Package: mopac
Type: Package
Title: Collection of Datasets Pertaining to Loop 1 "Mopac"
Version: 0.1.0
Authors@R: person("Scott", "McKenzie", email = "sccmckenzie@gmail.com",
  role = c("aut", "cre"))
Description: Provides real & simulated datasets containing time-series traffic observations
    and additional information pertaining to Loop 1 "Mopac" located in Austin, Texas.
Encoding: UTF-8
LazyData: true
Depends: R (>= 2.10)
Suggests: dplyr, lubridate, tibble, readr, hms
URL: https://github.com/sccmckenzie/mopac
BugReports: https://github.com/sccmckenzie/mopac/issues
RoxygenNote: 7.1.1
License: MIT + file LICENSE
NeedsCompilation: no
Packaged: 2021-04-27 15:35:00 UTC; Scott
Author: Scott McKenzie [aut, cre]
Maintainer: Scott McKenzie <sccmckenzie@gmail.com>
Repository: CRAN
Date/Publication: 2021-04-28 13:10:17 UTC
Built: R 4.6.0; ; 2026-04-26 22:29:51 UTC; unix

Package: mopac
Type: Package
Title: Collection of Datasets Pertaining to Loop 1 "Mopac"
Version: 0.1.0
Authors@R: person("Scott", "McKenzie", email = "sccmckenzie@gmail.com",
  role = c("aut", "cre"))
Description: Provides real & simulated datasets containing time-series traffic observations
    and additional information pertaining to Loop 1 "Mopac" located in Austin, Texas.
Encoding: UTF-8
LazyData: true
Depends: 
    R (>= 2.10)
Suggests: 
    dplyr,
    lubridate,
    tibble,
    readr,
    hms
URL: https://github.com/sccmckenzie/mopac
BugReports: https://github.com/sccmckenzie/mopac/issues
RoxygenNote: 7.1.1
License: MIT + file LICENSE

# Molecular Orbital PACkage (MOPAC)

[![License](https://img.shields.io/badge/License-Apache_2.0-blue.svg)](https://opensource.org/licenses/Apache-2.0)
[![DOI](https://zenodo.org/badge/177640376.svg)](https://zenodo.org/badge/latestdoi/177640376)
[![Anaconda-Server Badge](https://anaconda.org/conda-forge/mopac/badges/version.svg)](https://anaconda.org/conda-forge/mopac)
![build](https://github.com/openmopac/mopac/actions/workflows/CI.yaml/badge.svg)
[![codecov](https://codecov.io/gh/openmopac/mopac/branch/main/graph/badge.svg?token=qM2KeRvw06)](https://codecov.io/gh/openmopac/mopac)

This is the official repository of the modern open-source version of MOPAC, which is now released under an Apache license
(versions 22.0.0 through 23.0.3 are available under an LGPL license).
This is a direct continuation of the commercial development and distribution of MOPAC, which ended at MOPAC 2016.
Commercial versions of MOPAC are no longer supported, and all MOPAC users are encouraged to switch to the most recent open-source version.

[![mopac_at_molssi](.github/mopac_at_molssi.png)](https://molssi.org)

MOPAC is actively maintained and curated by the [Molecular Sciences Software Institute (MolSSI)](https://molssi.org).

## Installation

Open-source MOPAC is available through multiple distributon channels, and it can also be compiled from source using CMake.
In addition to continuing the distribution of self-contained installers on the
[old commercial website](http://openmopac.net/Download_MOPAC_Executable_Step2.html) and here on GitHub,
MOPAC can also be installed using multiple package managers and accessed through containers.

### Self-contained installers

Self-contained graphical installers for Linux, Mac, and Windows are available on GitHub for each release,
which are constructed using the [Qt Installer Framework](https://doc.qt.io/qtinstallerframework/).

While the installers are meant to be run from a desktop environment by default, they can also be run from a command line without user input.
On Linux, the basic command-line installation syntax is:

`./mopac-x.y.z-linux.run install --accept-licenses --confirm-command --root type_installation_directory_here`

For more information on command-line installation, see the [Qt Installer Framework Documentation](https://doc.qt.io/qtinstallerframework/ifw-cli.html).

Linux installations without a desktop environment may not have the shared libraries required for the graphical installers,
and there have also been isolated reports of problems with the Qt installer on other platforms. A minimal, compressed-archive installer
is available for each platform as an alternative for users that have problems with the Qt installer.

The minimum glibc version required for the precompiled version of MOPAC on Linux is currently 2.17.

#### Library path issues

The pre-built MOPAC executables use the RPATH system on Mac and Linux to connect with its shared libraries,
including the `libiomp5` Intel OpenMP redistributable library. The `libiomp5` library is not properly versioned, and the recent version used by
MOPAC is not compatible with older versions that might also exist on a user's machine. If a directory containing an old version of `libiomp5`
is in the shared library path (`LD_LIBRARY_PATH` on Linux, `DYLD_LIBRARY_PATH` on Mac), this will override the RPATH system, link MOPAC to the
wrong library, and cause an error in MOPAC execution. On Mac, this can be fixed by switching the offending directories to the failsafe shared library
path, `DYLD_FALLBACK_LIBRARY_PATH`. On Linux, the use of `LD_LIBRARY_PATH` is generally discouraged for widespread use, and there is no simple
workaround available. The newer version of `libiomp5` is backwards compatible, so replacing the offending version with the version used by MOPAC
should preserve the functionality of other software that depends on the library.

### Package managers

The officially supported package manager for MOPAC is the [conda-forge channel of Conda](https://anaconda.org/conda-forge/mopac).
MOPAC is also packaged by major Linux distributions including
[Fedora](https://packages.fedoraproject.org/pkgs/mopac/mopac/) and
[Debian](https://tracker.debian.org/pkg/mopac).
It is also available in the [Google Play store](https://play.google.com/store/apps/details?id=cz.m).

[![Packaging status](https://repology.org/badge/vertical-allrepos/mopac.svg?columns=2)](https://repology.org/project/mopac/versions)

### Docker/Apptainer Containers

The official [Docker](https://www.docker.com) and [Apptainer](https://apptainer.org) ([Singularity](https://sylabs.io)) containers for MOPAC 22.0.6 ([Conda version](https://anaconda.org/conda-forge/mopac)) are developed and
maintained by [MolSSI Container Hub](https://molssi.github.io/molssi-hub/index.html) and are distributed by the MolSSI Docker Hub [repository](https://hub.docker.com/r/molssi/mopac220-mamba141).

### CMake

MOPAC is now built using a CMake 3.x build system with tests orchestrated using CTest.
The minimum required CMake version is presently 3.14.

CMake performs out-of-source builds, with the canonical sequence of commands:

```
mkdir build
cd build
cmake ..
make
```

starting from the root directory of the MOPAC repository. MOPAC should build without any additional options
if CMake successfully detects a Fortran compiler and BLAS/LAPACK libraries. Otherwise, the `cmake ..` command
may require additional command-line options to specify a Fortran compiler (`-DCMAKE_Fortran_COMPILER=...`)
or the path (`-DMOPAC_LINK_PATH=...`) and linker options (`-DMOPAC_LINK=...`) to link BLAS and LAPACK libraries to the MOPAC executable.

The CTest-based testing requires an installation of Python 3.x and Numpy that can be detected by CMake.

## Documentation

The main source for MOPAC documentation is presently its old [online user manual](http://openmopac.net/manual/index.html).

There is a [new documentation website](https://openmopac.github.io) under development, but it is not yet ready for general use.

## Interfaces

While MOPAC is primarily a self-contained command-line program whose behavior is specified by an input file, it also has other modes of
operation, some of which only require the MOPAC shared library and not the executable. Note that API calls to the MOPAC library are not
thread safe. Each thread must load its own instance of the MOPAC library, such as by running independent calling programs.

### MDI Engine

MOPAC can be compiled to run as an MDI Engine through the [MolSSI Driver Interface Library](https://github.com/MolSSI-MDI/MDI_Library)
by setting `-DMDI=ON` when running CMake. See [MDI documentation](https://molssi-mdi.github.io/MDI_Library) for more information.

### Run from library

MOPAC calculations can be run as a C-like library call to `run_mopac_from_input(path_to_file)` where `path_to_file` is a C string
containing the system path to a MOPAC input file. Alternatively, a Fortran wrapper in the `include` directory allows this to be run as
the subroutine `run_mopac_from_input_f(path_to_file)` in the `mopac_api_f` module where `path_to_file` is a Fortran string.

### Diskless/stateless API

A subset of MOPAC calculations can be run through a C-like Application Programming Interface (API) defined by the `mopac.h` C header file
in the `include` directory, which also has a Fortran wrapper for convenience to Fortran software developers. Calculations run through this API
do not use any input or output files or any other form of disk access, and the data structures of the API contain all relevant information
regarding the input and output of the MOPAC calculation. The functionality and data exposed by this API is limited and has been designed to
align with the most common observed uses of MOPAC. Future expansion of this functionality and data will be considered upon request.

## Citation

To cite the use of open-source MOPAC in scientific publications, see the `CITATION.cff` file in this repository.

<!-- README.md is generated from README.Rmd. Please edit that file -->

# mopac <img src='man/figures/logo.png' align="right" height="250" />

<!-- badges: start -->

[![R-CMD-check](https://github.com/sccmckenzie/mopac/workflows/R-CMD-check/badge.svg)](https://github.com/sccmckenzie/mopac/actions)
[![CRAN
status](https://www.r-pkg.org/badges/version/mopac)](https://CRAN.R-project.org/package=mopac)
<!-- badges: end -->

mopac provides a collection of datasets pertaining to Loop 1 “Mopac” in
Austin, TX.

## Installation

Install the released version from CRAN with:

``` r
install.packages("mopac")
```

Or install the development version from Github:

``` r
devtools::install_github("sccmckenzie/mopac")
```

## Datasets

-   `rush_hour`: Time series of real traffic observations, collected for
    this package.

``` r
mopac::rush_hour
#> # A tibble: 962 x 7
#>    day   time                commercial color type  make    model    
#>    <ord> <dttm>              <lgl>      <chr> <chr> <chr>   <chr>    
#>  1 Sun   2020-05-17 17:27:00 FALSE      Blue  Truck Ford    F-150    
#>  2 Sun   2020-05-17 17:27:02 FALSE      Grey  Sedan Honda   Civic    
#>  3 Sun   2020-05-17 17:27:02 FALSE      White SUV   Lexus   LX       
#>  4 Sun   2020-05-17 17:27:02 FALSE      Red   Truck GMC     Sierra   
#>  5 Sun   2020-05-17 17:27:03 FALSE      Green SUV   Honda   CR-V     
#>  6 Sun   2020-05-17 17:27:04 FALSE      Black SUV   Nissan  Rogue    
#>  7 Sun   2020-05-17 17:27:05 FALSE      Black Sedan Hyundai Genesis  
#>  8 Sun   2020-05-17 17:27:06 FALSE      Blue  SUV   GMC     Acadia   
#>  9 Sun   2020-05-17 17:27:06 FALSE      White SUV   Honda   Pilot    
#> 10 Sun   2020-05-17 17:27:07 FALSE      Blue  Van   Ford    Econoline
#> # ... with 952 more rows
```

-   `express`: Simulated express lane records, shares a similar
    structure as rush\_hour.

``` r
mopac::express
#> # A tibble: 13,032 x 6
#>    direction time                plate    make       model    color 
#>    <chr>     <dttm>              <chr>    <chr>      <chr>    <chr> 
#>  1 North     2020-05-20 05:00:33 DZR-4059 Mercedes   S-Series Black 
#>  2 North     2020-05-20 05:01:13 GRG-4300 Nissan     Altima   Grey  
#>  3 North     2020-05-20 05:03:47 QZS-2886 Mazda      6        White 
#>  4 North     2020-05-20 05:04:54 OHK-3972 BMW        i1       White 
#>  5 North     2020-05-20 05:10:41 EAS-1671 Ford       F-250    Silver
#>  6 North     2020-05-20 05:13:53 OKP-7589 Dodge      Journey  White 
#>  7 North     2020-05-20 05:13:55 HNN-1298 Volkswagen Passat   Grey  
#>  8 North     2020-05-20 05:15:59 EWL-6179 Toyota     Venza    Grey  
#>  9 North     2020-05-20 05:16:01 YVH-4374 GMC        Safari   White 
#> 10 North     2020-05-20 05:18:16 DLU-6055 Nissan     Titan    Blue  
#> # ... with 13,022 more rows
```

-   `rates`: Express lane rates for a typical weekday.

``` r
mopac::rates
#> # A tibble: 25 x 3
#>    direction time    rate
#>    <chr>     <time> <dbl>
#>  1 North     05:00   0.3 
#>  2 North     15:00   0.6 
#>  3 North     15:30   1.75
#>  4 North     16:00   1.61
#>  5 North     16:30   2.59
#>  6 North     17:00   3.74
#>  7 North     17:30   4.65
#>  8 North     18:00   5.1 
#>  9 North     18:30   2.44
#> 10 North     19:00   0.3 
#> # ... with 15 more rows
```

-   `exits`: Information for all Mopac exits.

``` r
mopac::exits
#> # A tibble: 32 x 4
#>       mi    km destination                       notes                          
#>    <dbl> <dbl> <chr>                             <chr>                          
#>  1   0     0   SH 45 west                        <NA>                           
#>  2   0.7   1.1 South Bay Lane                    At-grade intersection; dead en~
#>  3   1.5   2.4 La Crosse Avenue                  <NA>                           
#>  4   2.3   3.7 Slaughter Lane                    Diverging Diamond Interchange  
#>  5   2.9   4.7 Davis Lane                        Southbound exit and northbound~
#>  6   4.7   7.6 William Cannon Drive              <NA>                           
#>  7   6     9.7 US 290 / SH 71 / Southwest Parkw~ Access to Baylor Scott & White~
#>  8   6.6  10.6 Frontage Road                     Southbound exit only           
#>  9   7.5  12.1 Loop 360 (Capital of Texas Highw~ Only one exit ramp travels fro~
#> 10   8.9  14.3 Barton Skyway                     <NA>                           
#> # ... with 22 more rows
```

# Molecular Orbital PACkage (MOPAC)

[![License: LGPL v3](https://img.shields.io/badge/License-LGPL_v3-blue.svg)](https://www.gnu.org/licenses/lgpl-3.0)
[![DOI](https://zenodo.org/badge/177640376.svg)](https://zenodo.org/badge/latestdoi/177640376)
[![Anaconda-Server Badge](https://anaconda.org/conda-forge/mopac/badges/version.svg)](https://anaconda.org/conda-forge/mopac)
![build](https://github.com/openmopac/mopac/actions/workflows/CI.yaml/badge.svg)
[![codecov](https://codecov.io/gh/openmopac/mopac/branch/main/graph/badge.svg?token=qM2KeRvw06)](https://codecov.io/gh/openmopac/mopac)

This is the official repository of the modern open-source version of MOPAC, which is now released under the LGPL license.
This is a direct continuation of the commercial development and distribution of MOPAC, ending at MOPAC 2016.
Commercial versions of MOPAC are no longer supported, and all MOPAC users are encouraged to switch to the most recent open-source version.

## Installation

Self-contained installers for Linux, Mac, and Windows are available on GitHub for each release,
which are constructed using the [Qt Installer Framework](https://doc.qt.io/qtinstallerframework/).

While the installers are meant to be run from a desktop environment by default, they can also be run from a command line without user input.
On Linux, the basic command-line installation syntax is:

`./mopac-x.y.z-linux.run install --accept-licenses --confirm-command --root type_installation_directory_here`

For more information on command-line installation, see the [Qt Installer Framework Documentation](https://doc.qt.io/qtinstallerframework/ifw-cli.html).

### Package managers

The officially supported package manager for MOPAC is the [conda-forge channel of Conda](https://anaconda.org/conda-forge/mopac).
MOPAC is also available on [Fedora](https://packages.fedoraproject.org/pkgs/mopac/mopac/)
and the [Google Play store](https://play.google.com/store/apps/details?id=cz.m).

We welcome the addition of MOPAC to other package managers and will add them to this list as they are made available and known.

### CMake

MOPAC is now built using a CMake 3.x build system with tests orchestrated using CTest.
The minimum required CMake version is presently 3.14.

CMake performs out-of-source builds, with the canonical sequence of commands:

```
mkdir build
cd build
cmake ..
make
```

starting from the root directory of the MOPAC repository. MOPAC should build without any additional options
if CMake successfully detects a Fortran compiler and BLAS/LAPACK libraries. Otherwise, the `cmake ..` command
may require additional command-line options to specify a Fortran compiler (`-DCMAKE_Fortran_COMPILER=...`)
or the path (`-DMOPAC_LINK_PATH=...`) and linker options (`-DMOPAC_LINK=...`) to link BLAS and LAPACK libraries to the MOPAC executable.

The CTest-based testing requires Python 3.x and Numpy.

## Documentation

The main source for MOPAC documentation is presently its old [online user manual](http://openmopac.net/manual/index.html).

There is a [new documentation website](https://openmopac.github.io) under development, but it is not yet ready for general use.

# Molecular Orbital PACkage (MOPAC)

[![License](https://img.shields.io/badge/License-Apache_2.0-blue.svg)](https://opensource.org/licenses/Apache-2.0)
[![DOI](https://joss.theoj.org/papers/10.21105/joss.08025/status.svg)](https://doi.org/10.21105/joss.08025)
[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.6511958.svg)](https://doi.org/10.5281/zenodo.6511958)
[![Anaconda-Server Badge](https://anaconda.org/conda-forge/mopac/badges/version.svg)](https://anaconda.org/conda-forge/mopac)
![build](https://github.com/openmopac/mopac/actions/workflows/CI.yaml/badge.svg)
[![codecov](https://codecov.io/gh/openmopac/mopac/branch/main/graph/badge.svg?token=qM2KeRvw06)](https://codecov.io/gh/openmopac/mopac)

This is the official repository of the modern open-source version of MOPAC, 
which is a direct continuation of the commercial development and distribution of MOPAC that ended at MOPAC 2016.

[![mopac_at_molssi](.github/mopac_at_molssi.png)](https://molssi.org)

MOPAC is actively maintained and curated by the [Molecular Sciences Software Institute (MolSSI)](https://molssi.org).

For detailed information about MOPAC, see its [website](https://openmopac.github.io). A brief summary for developers is provided below.

## About

MOPAC is a popular semiempirical quantum chemistry package that was first released in 1983.
MOPAC can perform quantum mechanical calculations of molecules and materials, much like *ab initio* quantum chemistry packages such as [Gaussian](https://www.gaussian.com).
Semiempirical calculations are around 1000x faster than *ab initio* calculations, but they are usually less accurate and less predictive because they rely on
simplified models fit to experimental data rather than more complicated and comprehensive theories.
The speed and ease-of-use of MOPAC make it a good teaching tool, either to teach physical chemistry concepts to students or to prepare for the use
of more expensive quantum chemistry software. It can also be useful for high-throughput calculations in screening and informatics applications.

## Building

Pre-built versions of MOPAC on Linux, Mac, and Windows are available with every [GitHub Release](https://github.com/openmopac/mopac/releases)
and also available on the Conda package manager using the command:
```
conda install -c conda-forge mopac
```

MOPAC can be built using its CMake build system. This repository has a [GitHub Actions workflow](https://github.com/openmopac/mopac/blob/main/.github/workflows/CI.yaml)
to build MOPAC, and you can build it locally using the standard CMake out-of-source invocation:
```
mkdir build
cd build
cmake ..
make
```
MOPAC will build without any other CMake options if a Fortran compiler, BLAS/LAPACK, Python 3, and NumPy are found in the software environment.
To build with optional [MolSSI Driver Interface(MDI)](https://molssi-mdi.github.io/MDI_Library/) engine support, use the CMake command-line option `-DMDI=ON`.

## Usage

While MOPAC is often used through its integration with other software such as [WebMO](https://www.webmo.net), it is primarily a command-line program
that operates through input and output files. Recent versions of MOPAC also has an application programming interface (API) for a subset of functionality.

Examples of command-line and API usage are provided in the [`/examples` folder](https://github.com/openmopac/mopac/tree/main/examples) of this repository.

## Citation

The following paper should be cited by scientific publications that use an open-source version of the MOPAC software package:

J. E. Moussa and J. J. P. Stewart, MOPAC: An open-source semiempirical molecular orbital program, *J. Open Source Softw.* **2026**, *11*(119), 8025.
DOI:[10.21105/joss.08025](https://doi.org/10.21105/joss.08025)

Alternatively, the open-source MOPAC software package can be cited directly through a software citation to its archival copy on Zenodo at
DOI:[10.5281/zenodo.6511958](https://doi.org/10.5281/zenodo.6511958).

This directory contains the training data and PARAM input files used to fit the PM6-ORG model. The main input file is
PM6-ORG.dat, which was used to fit H, C, N, O, F, Cl, Br, I and all intermolecular interactions that were updated. The
`metals optimization` directory contains input files for the optimization of specific metal elements: Zn, Fe, Co, Mg, Ca, Se, K, and Na. All optimizations were repeated until the process converged to a consistent set of model parameters.

This directory contains the reference data that has been used to train and test the semiempirical models contained within MOPAC.

Each piece of reference data is contained in a MOPAC input file with special syntax on the 3rd line of the input file to
denote what observables have reference data for the given molecule, what their values are, and what the source of the reference
data is. The bibliography for the reference data is contained in `references.txt`. PARAM parses this extra line of input
in addition to the standard first line of MOPAC keywords.

Because most of the reference data is heats of formation and most geometries are not fully constrained by experiment,
the reference geometries are relaxed to the local minimum of the semiempirical model being trained. The initial values
of the reference geometries serve to place the molecules in a particular basin of convergence in the potential energy
surface.

The PM6-ORG directory contains the specific training data used to fit the PM6-ORG model together with the PARAM input file
for the final stage of the fitting process. Much of this training data is new, but some of it is copied from the existing
reference data set.

This directory contains the reference data that has been used to train and test the semiempirical models contained within MOPAC.

Each piece of reference data is contained in a MOPAC input file with special syntax on the 3rd line of the input file to
denote what observables have reference data for the given molecule, what their values are, and what the source of the reference
data is. The bibliography for the reference data is contained in `references.txt`. PARAM parses this extra line of input
in addition to the standard first line of MOPAC keywords.

Because most of the reference data is heats of formation and most geometries are not fully constrained by experiment,
the reference geometries are relaxed to the local minimum of the semiempirical model being trained. The initial values
of the reference geometries serve to place the molecules in a particular basin of convergence in the potential energy
surface.

---
output: github_document
---

<!-- README.md is generated from README.Rmd. Please edit that file -->

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  fig.path = "man/figures/README-",
  out.width = "100%"
)

library(tibble)
library(readr)
```

# mopac <img src='man/figures/logo.png' align="right" height="250" />
<!-- badges: start -->
[![R-CMD-check](https://github.com/sccmckenzie/mopac/workflows/R-CMD-check/badge.svg)](https://github.com/sccmckenzie/mopac/actions)
[![CRAN status](https://www.r-pkg.org/badges/version/mopac)](https://CRAN.R-project.org/package=mopac)
<!-- badges: end -->

mopac provides a collection of datasets pertaining to Loop 1 "Mopac" in Austin, TX.

## Installation

Install the released version from CRAN with:

```r
install.packages("mopac")
```
Or install the development version from Github:

```r
devtools::install_github("sccmckenzie/mopac")
```
## Datasets

* `rush_hour`: Time series of real traffic observations, collected for this package.
```{r}
mopac::rush_hour
```

* `express`: Simulated express lane records, shares a similar structure as rush_hour.
```{r}
mopac::express
```

* `rates`: Express lane rates for a typical weekday.
```{r}
mopac::rates
```

* `exits`: Information for all Mopac exits.
```{r}
mopac::exits
```

# MOPAC source code

This directory contains all Fortran source code associated with MOPAC and accompanying programs
(PARAM, MAKPOL, & BZ). Historically, MOPAC was developed with all source code contained in a single,
unorganized source directory. The organization of source code into subdirectories here is an attempt
to identify and reverse-engineer the substructure of distinct features and contributions to MOPAC,
to make it easier for future open-source developers to understand the codebase.

Most source files are named after the first subroutine in the file, and all data modules are contained
in separate source files with the suffix `*_C.F90`.

This directory contains reference data that has been used to suppress erratic behavior observed in semiempirical models.

It includes pairs of data points combining physical reference data with erroneous geometries that are given an energetic
penalty to drive the model fitting towards destabilizing them.

It also includes a large and relatively crude set of energies for core-core collisions calculated from density functional theory.

# MOPAC include files

For OS-level ABI-compatibility, the MOPAC API is bound to C. The data structures and function prototypes of this C-like API
are provided in the `mopac.h` header file. It is possible but inconvenient to use the C-like API in other Fortran software,
so a Fortran convenience wrapper is also provided here.

# Semiempirical model parameters

This directory contains hard-coded tables for the core semiempirical parameters that define the
MNDO-form model Hamiltonian for the various model fits supported by MOPAC. It also contains
functionality for rerouting data to switch between models.

# INDO spectroscopy model

This directory contains an implementation of the INDO/S model and excited state calculations
using the INDO/S model Hamiltonian with electron correlation treated at various levels of theory.

The software in this directory was written by Rebecca Gieseking. It was derived and adapted from
the CNDO/INDO program written by Jeff Reimers [DOI:10.4231/D3R49G96G], which was in turn derived
and adapted from the CNDO/S program [QCPE 174] written by J. Del Bene, H. H. Jaffe, R. L. Ellis,
and G. Kuehnlenz.

# Molecular geometry calculations & transformations

This directory contains some basic subroutines for transforming molecular geometries
between coordinate systems and calculating some derived geometric quantities.

As noted in the source, `dihed.F90` was derived and adapted from software written by
Walter Thiel, and `gmetry.F90` was derived and adapted from software written by Michael Dewar.
The provenance of this software is not completely clear, but it is likely to have come from
either the MINDO/3 or MNDO programs.

# Matrix operations

This directory contains all of the files in MOPAC that have been identified as mostly containing
dense linear algebra operations. They have been centrally collected in preparation for their
consolidation into a more unified subsystem for dense linear algebra within MOPAC. In particular,
the prior support for GPUs in MOPAC, which is not presently functioning, needs to be re-introduced
in a more uniform and maintainable way. Some of the files in this directory may be relocated when
their matrix operations have been appropriately encapsulated.

`ddiag.F90` is from the EISPACK library of eigensolvers. `linpack.F90` is from LINPACK library of
linear solvers. `minv.F90` is from the IBM-SSP library of mathematical and statistical subroutines.
`esp_utilities.F90` contains subroutines from LINPACK and BLAS. `interp.F90` was derived and adapted
from software written by R. Nicholas Camp and Harry F. King.

There are also cases where dense matrix storage and operations are directly embedded in other files
that have not been relocated to this directory. The present list of such subroutines and files is:

- `densf @ polar.F90`
- `bmakuf @ polar.F90`
- `bdenup @ polar.F90`
- `bdenin @ polar.F90`
- `aval @ polar.F90`
- `trugud @ polar.F90`
- `trudgu @ polar.F90`
- `trugdu @ polar.F90`
- `trsub @ polar.F90`
- `transf @ polar.F90`
- `tf @ polar.F90`
- `coscl1 @ cosmo.F90`
- `coscl2 @ cosmo.F90`
- `determinant @ charst.F90`
- `polar @ polar.F90`

# Configuration Interaction

This directory contains the inter-determinant matrix elements and core computational routines for
performing truncated configuration interaction (CI) calculations. While not physically meaningful
according to the strictest interpretation of a thermochemitry model (that is only intended to model
heats of formation with Hartree-Fock calculations), these types of calculations are useful for
understanding the sufficiency of these models and the effects of strong correlation in certain
situations such as bond breaking and multi-radicals.

As annotated, several subroutines were derived and adapted from Daniel Liotard's contributions to
AMPAC version 2.1 (QCPE No. 506).

# MNDO Hamiltonian matrix elements

This directory contains an implementation of the Hamiltonian matrix elements for the
Modified Neglect of Differential Overlap (MNDO) model. The original MNDO model was developed
specifically for s and p orbitals, and was expanded to d orbitals in the 1990's.

The s/p-orbital components were derived and adapted from the original MNDO program, and the
d-orbital components were derived and adapted from the MNDO96 program written by Walter Thiel.

Several subroutines in this directory are attributed to E. R. Davidson, but their origin is unclear.

# PARAM

This directory contains subroutines and modules specific to the PARAM program for optimizing
parameters of MNDO-form models. The rest of its source code is shared with MOPAC.

*NOTE: psort.F90 contains some hard-coded paths that need to be updated in some way.*

# MOZYME

This directory contains the MOZYME feature of MOPAC, which performs reduced-scaling electronic
structure calculations based directly on localized molecular orbitals (LMOs) instead of canonical
orbitals, which allows for the use of sparse linear algebra rather than dense linear algebra. Many
of the core computational steps are then reduced from the cubic-scaling cost of dense linear algebra
to a linear-scaling cost in the number of atoms, but there are still steps and prefactors that cause
overall super-linear scaling, notably electrostatics are still performed with brute-force pair
summation rather than any fast hierarchical method and the SCF cycle and geometric relaxation cycle
inevitably retains some scaling with system size, depending on the degree of electronic and atomic
polarizability in a system.

This feature of MOPAC was formerly covered by a US patent owned by Fujitsu [5,604,686],
which has now expired.

# MOPAC API

This directory contains the application programming interface (API) to MOPAC, which presently has
very limited functionality. MOPAC's primary interface is disk-based rather than API-based, with
input passed in through input files and output read from output files (the AUX file being
machine-readable). The only functionality available right now is access to version information
and an ability to enable/disable expanded disk-based output for GUI support.

To allow MOPAC to function with Windows DLL's, the API subroutines must be marked by `dllexport` preprocessor statements that are used by the Intel Fortran compiler to build a DLL symbol table.

# Property calculations

This directory contains various property calculations based on the output of MNDO-form calculations.

`static_polarizability.F90` was written by Henry Kurtz, and `polar.F90` was written by Henry Kurtz and
Prakashan Korambath. `CPE_Energy.F90` was incorporated into MOPAC as part of its interface with the
Sybyl GUI and was presumably written by the developers of Sybyl.

# Electrostatic potentials

This directory contains two methods (ESP & PMEP) for mapping the density matrix produced by AM1
calculations to an electrostatic potential that attempts to match *ab initio* Hartree-Fock 
calculations. This methods are considered to be outdated and may be removed from future versions
of MOPAC.

`esp.F90` was written by Kenneth Merz, Jr. and `pmep.F90` was written by Bingze Wang.

# MAKPOL

This directory contains the MAKPOL program for generating supercells for use by MOPAC.
It is a useful tool for converging finite-size effects for  periodic calculations in MOPAC,
since there is no support in MOPAC for Brillouin zone sampling (all periodic calculations
are performed at the Gamma point). There is some overlap between the source code of MOPAC
and MAKPOL, but they are being kept separate for now (merge efforts are welcome).

# Classical molecular-mechanics corrections

This directory contains all of the classical interatomic potential terms that are used to
correct the quantum mechanical calculations performed by MOPAC. The oldest corrections were
introduced to fix very specific problems in certain covalent bonds (e.g. triple bonds), and
the more recent corrections have focused on weak intermolecular interactions, mainly
dispersion and hydrogen bonding.

The D3 dispersion model implementation was derived and adapted from the DFTD3 library
[https://github.com/dftbplus/dftd3-lib] with permission from Stephan Grimme. The files
derived from this source are `copyc6.F90`, `dftd3.F90`, `dftd3_bits.F90`, and `gdisp.F90`.

The H4 model implementation was derived and adapted from the h_bonds4 library written by
Jan Rezac, available either as a standalone C implementation [https://www.rezacovi.cz]
or in Ruby as part of the Cuby4 framework [http://cuby4.molecular.cz]. The file derived from
this source is `H_bonds4.F90`.

This directory contains reference data for excited atomic states.

Such data is important for constraining the orbital energies for atomic orbitals that have
very low orbital occupancies in typical ground-state calculations and thus very poor coverage
from the other reference data in this set.

# Input file processing

This directory contains functionality for the processing and parsing of input files. Note that
the input file is copied to a scratch file by `getdat.F90` before any other processing is performed.
The primary parsing of keywords occurs in `wrtkey.F90`, and any new keywords should be introduced
there before adding any other keyword-based control logic associated with that keyword.

# Transition states

This directory contains several different methods for calculating transition states and reaction
coordinates.

`ef.F90` was derived and adapted from software written by Frank Jensen.

# Output file processing

This directory contains functionality for the processing of output files. Much of the standard
`.out` file is printed by `writmo.F90`, and the machine-readable `.aux` file is printed by
`to_screen.F90`.

The energy decomposition in `enpart.F90` was a contribution to the original MNDO program written by
Santiago Olivella.

# Chemical detection & modification

This directory contains subroutines for determining and manipulating Lewis dot structures of
organic molecules (with some support for organometallic molecules). Its functionality includes
an ability to add hydrogen atoms, which are often missing from experimental structures determined
by x-ray crystallography. It also identifies standard functional groups and can label them according
to the PDB file format.

The optimizer of water molecule orientation in `orient_water.F90` is derived and adapted from the Constrained Optimization BY Linear Approximation (COBYLA) algorithm and software originally written
by M. J. D. Powell [https://www.zhangzk.net/software.html].

# BZ

This directory contains the Windows BZ program for visualizing band structures and Fermi
surfaces from periodic calculations performed by MOPAC. It generates a Brillouin zone by
downfolding the supercells created by MAKPOL to recover the original unit cell. This program
is presently available for Windows only as it uses the QuickWin library for visualization.
There is some overlap between the source code of MOPAC and BZ, but they are being kept
separate for now (merge efforts are welcome).

`blas.F90` is from the BLAS library of basic linear algebra subroutines. `minv.F90` is from
the IBM-SSP library of mathematical and statistical subroutines. `rsp.F90` is derived and
adapted from the EISPACK library of eigenvalue problem solvers.

# Geometry optimization

This directory contains various optimizers that are primarily used for geometry optimization. These
are all established optimization algorithms, and many of the implementations in MOPAC were derived
from standard, publicly-available implementations.

`powsq.F90` was originally integrated into the pre-MOPAC MINDO/3 codebase within the Dewar group by
one of its original authors, Andrew Komornicki. `flepo.F90` and `nllsq.F90` seem to have been from
the original MNDO program, but this provenance is unclear. `lbfgs.F90` was derived and adapted from
Algorithm 778 of the ACM Transactions on Mathematical Software [https://doi.org/10.1145/279232.279236].

# Analytical & numerical derivatives for forces & vibrations

This directory contains most of the functionality for calculating 1st and 2nd derivatives
of the Fock matrix and interatomic potential corrections with respect to atomic coordinates
for use in force and vibrational calculations.

A significant portion of the analytical derivatives were derived and adapted from
Daniel Liotard's contributions to AMPAC version 2.1 (QCPE No. 506).

# COSMO solvation model

This directory contains MOPAC's two implementations of the COSMO solvation model.
The original, refrence implementation was developed and written by Andreas Klamt.
The fast implementation, which includes an implementation of the fast multipole method, was written by Andrey Bliznyuk.

# Basic examples of MOPAC usage

This directory contains several examples of MOPAC calculations.

MOPAC is most commonly used as a command-line program with input and output files.
Here are several examples of input files for the most commonly used MOPAC features applied to water:

 - `example_scf.mop`: self-consistent field (SCF) calculation
 - `example_relax.mop`: molecular geometry relaxation
 - `example_vibe.mop`: vibrational calculation on a relaxed geometry
 - `example_cosmo.mop`: SCF calculation with COSMO implicit solvation model

These example input files are interoperable with the `.xyz` file format by adding or removing the MOPAC keyword line at the top.
Each of these examples can be run using the syntax:
```
 /path/to/mopac/executable example_name.mop
```
If the MOPAC executable is in your path, then `/path/to/mopac/executable` is simply `mopac`.
These examples generate a main output file named `example_name.out` and an archival output file named `example_name.arc`.
A reference copy of the main output files with the name `example_name.mop_output` is provided for comparison.

## C API example

These same example calculations are performed using the C API to MOPAC in the C program `example.c`.
This example includes the MOPAC API header file `mopac.h` located in `/include` and must be linked with the MOPAC shared library
(i.e. libmopac.so on Linux, libmopac.dylib on Mac, mopac.dll on Windows).
An example build statement with the `gcc` compiler and the MOPAC shared library located at `../lib` is:
```
gcc example.c -I../include -L../lib -lmopac -o c_executable
```
Additional linking options such as `-Wl,-rpath=../lib` may be necessary if the MOPAC shared library is not in your path.
`example.c_output` is a reference copy of the standard output generated by this example.

## Fortran API example

The Fortran API to MOPAC requires an extra wrapper that must be compiled alongside the calling program.
The Fortran program `example.F90` is the Fortran equivalent to `example.c`, which must be compiled and linked with
`mopac_wrapper.F90` and `mopac_wrapper_internal.F90` located in `/include` along with the MOPAC shared library.
An example build statement with the `gfortran` compiler and the MOPAC shared library located at `../lib` is:
```
gfortran example.F90 ../include/mopac_wrapper.F90 ../include/mopac_wrapper_internal.F90 -I../include -L../lib -lmopac -o fortran_executable
```
Additional linking options such as `-Wl,-rpath=../lib` may be necessary if the MOPAC shared library is not in your path.
`example.F90_output` is a reference copy of the standard output generated by this example.

## Further information

MOPAC's features and command-line functionality are primarily determined by keywords at the top of the input file.
Online [guides](https://openmopac.github.io/guides/) provide instructions on how to use the most
popular MOPAC keywords and features, and the online [manual](https://openmopac.github.io/Manual/) has a more detailed and
comprehensive description of MOPAC's keywords and features. Further information about the API is available in the
[API guide](https://openmopac.github.io/guides/api/).

library(dplyr)
library(purrr)
library(readr)
library(stringr)
library(lubridate)
library(readxl)

time_datum <- c("2020-05-17 17:27:00",
                "2020-05-18 18:24:00",
                "2020-05-19 18:00:00",
                "2020-05-20 18:00:00",
                "2020-05-21 18:00:00",
                "2020-05-22 18:00:00",
                "2020-05-23 15:00:00") %>%
  as_datetime(tz = "US/Central")

raw1 <- map_dfr(.x = 1:2, .f = ~ {
  read_excel("data-raw/mopac.xlsx", sheet = ..1) %>%
    mutate(day = wday(..1, label = TRUE),
           time = time_datum[[..1]] + dseconds(time))
})

raw2 <- map_dfr(.x = 3:7, .f = ~ {
  read_excel("data-raw/mopac.xlsx", sheet = ..1) %>%
    mutate(day = wday(..1, label = TRUE),
           time = sprintf("%.2f", time),
           time = time_datum[[..1]] + dminutes(as.integer(str_extract(time, "^\\d+"))) + dseconds(as.integer(str_extract(time, "\\d+$"))))
})

rush_hour <- bind_rows(raw1, raw2) %>%
  janitor::clean_names() %>%
  relocate(c(day, time), .before = everything())

usethis::use_data(rush_hour, overwrite = TRUE)

write_csv(rush_hour, here::here("inst", "extdata", "rush_hour.csv"))

library(readr)
library(dplyr)
library(tidyr)
library(stringr)
library(purrr)
library(lubridate)
library(jsonlite)

options(readr.default_locale = locale(tz = "US/Central"))

rush_hour <- read_csv("https://raw.githubusercontent.com/sccmckenzie/mopac/master/inst/extdata/rush_hour.csv")

express_counts <- read_csv("https://raw.githubusercontent.com/sccmckenzie/mopac/master/inst/extdata/express_counts.csv")

set.seed(10)
t_delta <- express_counts %>%
  mutate(t_delta = time_length(time - lag(time))) %>%
  drop_na(t_delta) %>%
  mutate(t_delta = t_delta + 2 * rbeta(n(), 2, 3)) %>%
  # ^ we add some jitter into timestamps
  # (observations were recorded with 1 sec resolution)
  pull(t_delta)

# set timeframe (5am - 8pm)
t1 <- 5
t2 <- 20
total_seconds <- (t2 - t1) * 3600

set.seed(20)
express <- tibble(direction = c("North", "South")) %>%
  rowwise(direction) %>%
  summarize(vehicle_spacing = sample(t_delta, size = total_seconds, replace = TRUE)) %>%
  # ^ generate temporal vehicle spacing
  transmute(time = make_datetime(2020, 5, 20, t1, tz = "US/Central") + cumsum(vehicle_spacing)) %>%
  # ^ add temporal vehicle spacing together
  filter(time < make_datetime(2020, 5, 20, t2, tz = "US/Central"))
# ^ cut off timestamps later than 8pm

steck <- jsonlite::fromJSON('https://data.austintexas.gov/resource/sh59-i6y9.json?atd_device_id=6409&year=2020&month=5&day=20&heavy_vehicle=false') %>%
  as_tibble() %>%
  janitor::clean_names() %>%
  filter(direction == "SOUTHBOUND") %>%
  transmute(read_date = as_datetime(read_date, tz = "US/Central"),
            direction,
            movement,
            volume = as.integer(volume)) %>%
  with_groups(read_date,
              summarize,
              volume = sum(volume)) %>%
  transmute(id = row_number(),
            read_date,
            volume = volume/max(volume))

# join Steck volume with express timestamps
set.seed(25)
express <- express %>%
  mutate(id = findInterval(time, steck$read_date)) %>%
  left_join(steck, by = "id") %>%
  rowwise() %>%
  mutate(keep = sample(c(FALSE, TRUE), prob = c(1 - volume, volume), size = 1)) %>%
  # ^ treat volume as probability of keeping row in express
  ungroup() %>%
  filter(keep) %>%
  select(direction, time) %>%
  arrange_all()

hourday <- function(t) {
  time_length(t - make_datetime(2020, 5, 20, tz = "US/Central"), unit = "hours")
}

set.seed(254)
scenario_1 <- express %>%
  sample_n(size = 5000) %>%
  mutate(v_id = row_number())

set.seed(400)
scenario_2A <- express %>%
  anti_join(scenario_1) %>%
  # ^ exclude observations already sampled into scenario_1
  group_by(direction) %>%
  # ^ need equal amounts of north & south samples
  sample_n(size = 1000, weight = dnorm(hourday(time), mean = 7, sd = 2)) %>%
  mutate(id = row_number()) %>%
  ungroup()

scenario_2B <- express %>%
  anti_join(scenario_1) %>%
  anti_join(scenario_2A) %>%
  group_by(direction) %>%
  sample_n(size = 1000, weight = dnorm(hourday(time), mean = 17, sd = 2)) %>%
  mutate(id = row_number()) %>%
  ungroup()

set.seed(451)
North <- sample(filter(scenario_2A, direction == "North")$time)
South <- sample(filter(scenario_2B, direction == "South")$time)

set.seed(90)

# I arbitrarily set the number of repetitions to 100,
# which is ultimately more than enough to achieve desired result
scenario_2_sim <- bind_rows(
  map_dfr(1:100, ~ {
    tibble(i = ..1,
           direction = "NS",
           North = filter(scenario_2A, direction == "North")$time %>% sample(),
           South = filter(scenario_2B, direction == "South")$time %>% sample())
  }),
  # now we flip the directions
  map_dfr(1:100, ~ {
    tibble(i = ..1,
           direction = "SN",
           South = filter(scenario_2A, direction == "South")$time %>% sample(),
           North = filter(scenario_2B, direction == "North")$time %>% sample())
  })
) %>%
  mutate(l = if_else(direction == "NS",
                     time_length(South - North, unit = "hours"),
                     time_length(North - South, unit = "hours"))) %>%
  with_groups(c(direction, i), filter, !any(l < 0.5))

library(broom)
scenario_2 <- scenario_2_sim %>%
  group_by(direction, i) %>%
  summarize(vec = list(l)) %>%
  rowwise() %>%
  mutate(shapiro.test(vec) %>% tidy()) %>%
  filter(p.value < 0.1) %>%
  group_by(direction) %>%
  slice_max(order_by = statistic) %>%
  semi_join(scenario_2_sim, .) %>%
  transmute(North, South, v_id = max(scenario_1$v_id) + row_number()) %>%
  pivot_longer(North:South, names_to = "direction", values_to = "time")

set.seed(100)
scenario_3 <- express %>%
  anti_join(scenario_1) %>%
  anti_join(scenario_2) %>%
  sample_n(size = n()) %>%
  mutate(v_id = (row_number() - 1) %% 3 == 0,
         v_id = cumsum(v_id) + max(scenario_2$v_id)) %>%
  arrange(v_id, time)

scenario_3 <- scenario_3 %>%
  group_by(v_id) %>%
  mutate(delta = time_length(time - lag(time), unit = "hours")) %>%
  filter(!any(delta < 1, na.rm = TRUE)) %>%
  ungroup() %>%
  slice_head(n = 300) %>%
  # ^ 3 rows / vehicle * 100 vehicles = 300 rows
  select(direction, time, v_id)

set.seed(99)
robbery_A <- express %>%
  anti_join(scenario_1) %>%
  anti_join(scenario_2) %>%
  anti_join(scenario_3) %>%
  sample_n(size = 2, weight = dnorm(hourday(time), mean = 12, sd = 0.1)) %>%
  mutate(v_id = max(scenario_3$v_id) + row_number())

robbery_B <- express %>%
  anti_join(scenario_1) %>%
  anti_join(scenario_2) %>%
  anti_join(scenario_3) %>%
  sample_n(size = 2, weight = dnorm(hourday(time), mean = 17, sd = 0.1)) %>%
  mutate(v_id = max(scenario_3$v_id) + row_number())

robbery <- bind_rows(robbery_A, robbery_B)

express <- express %>%
  anti_join(scenario_1) %>%
  anti_join(scenario_2) %>%
  anti_join(scenario_3) %>%
  anti_join(robbery) %>%
  mutate(v_id = max(robbery$v_id) + row_number()) %>%
  bind_rows(scenario_1, scenario_2, scenario_3, robbery) %>%
  arrange(direction, time)

vehicle_probs <- rush_hour %>%
  drop_na() %>%
  count(day, make, model) %>%
  group_by(day) %>%
  mutate(wt = n / sum(n)) %>%
  group_by(make, model) %>%
  summarize(wt_mean = mean(wt), .groups = "drop") %>%
  mutate(wt = wt_mean / sum(wt_mean), .keep = "unused")

color_probs <- rush_hour %>%
  drop_na() %>%
  count(make, model, color) %>%
  group_by(make, model) %>%
  mutate(wt = n / sum(n)) %>%
  ungroup()

set.seed(98)
express <- express %>%
  distinct(v_id) %>%
  # make/model
  bind_cols(sample_n(vehicle_probs,
                     size = nrow(.),
                     weight = wt,
                     replace = TRUE)) %>%
  select(!wt) %>%
  # color
  full_join(color_probs) %>%
  group_by(v_id) %>%
  sample_n(size = 1, weight = wt) %>%
  select(!(n:wt)) %>%
  inner_join(express, .) # join it all back with express

set.seed(97)
plate_letters <- crossing(L1 = LETTERS, L2 = LETTERS, L3 = LETTERS) %>%
  mutate(st = str_c(L1, L2, L3, sep = "")) %>%
  pull(st) %>%
  sample(., n_distinct(express$v_id), replace = TRUE)

plate_numbers <- 0:9999
plate_numbers <- str_pad(plate_numbers, side = "left", pad = "0", width = 4) %>%
  sample(., n_distinct(express$v_id), replace = TRUE)

plates <- str_c(plate_letters, plate_numbers, sep = "-")

express <- express %>%
  distinct(v_id) %>%
  mutate(plate = plates) %>%
  inner_join(express, .) %>%
  relocate(plate, .before = make) %>%
  select(!v_id)

use_data(express, overwrite = TRUE)
write_csv(express, here::here("inst", "extdata", "express.csv"))

library(dplyr)
library(rvest)

exits <- read_html("https://en.wikipedia.org/wiki/Texas_State_Highway_Loop_1") %>%
  html_nodes("table") %>%
  .[[5]] %>%
  html_table(fill = TRUE) %>%
  as_tibble() %>%
  janitor::clean_names() %>%
  select(mi:notes) %>%
  slice(-n()) %>%
  mutate(across(mi:km, as.double),
         notes = if_else(stringr::str_length(notes) == 0, NA_character_, notes)) %>%
  rename(destination = destinations) %>%
  filter(!is.na(mi))

usethis::use_data(exits, overwrite = TRUE)

library(readr)
library(dplyr)
library(tidyr)

rates <- read_csv("data-raw/rates.csv") %>%
  pivot_longer(South:North, names_to = "direction", values_to = "rate") %>%
  group_by(direction) %>%
  arrange(direction, time) %>%
  filter(rate != lag(rate, default = 0)) %>%
  ungroup() %>%
  relocate(direction)

use_data(rates, overwrite = TRUE)

#' Sample of vehicles collected from Loop 1 "Mopac" in Austin, Texas.
#'
#' Observations sampled in 2.5 minute intervals throughout week of 17 May 2020. Note that although intervals fall within normal "rush hour" timeframe, traffic density is lighter than normal due to COVID.
#'
#' @format A tibble with 962 rows and 7 variables:
#' \describe{
#'   \item{day}{day of the week when observations were recorded}
#'   \item{time}{observation timestamp}
#'   \item{commercial}{indicates whether vehicle is used for commercial purposes}
#'   \item{color}{vehicle color}
#'   \item{type}{vehicle type}
#'   \item{make}{vehicle make}
#'   \item{model}{vehicle model}
#' }
#'
#' @source Real observations collected from northbound Mopac at Far West Blvd.
"rush_hour"

#' Exit information for Mopac.
#'
#' Accurate as of 2021-03-26. Provides basic details for all exits along Loop 1 "Mopac" in Austin, Texas. Exits are unnumbered.
#'
#' @format A tibble with 32 rows and 4 variables:
#' \describe{
#'   \item{mi}{distance from Loop 1 southern terminus, in miles}
#'   \item{km}{distance from Loop 1 southern terminus, in kilometers}
#'   \item{exit}{main road accessed by exit}
#'   \item{notes}{additional information}
#' }
#' @source Scraped from \url{https://en.wikipedia.org/wiki/Texas_State_Highway_Loop_1}
"exits"

#' Mopac Express Lane Records
#'
#' Simulated observations of vehicles entering Mopac express lane at RM 2222 / Far West Blvd. Vehicle make/model/color frequencies are based on actual data from rush_hour. Traffic density inferred from ad hoc sampling and City of Austin Traffic Counts.
#'
#' @format A tibble with 13032 rows and 6 variables:
#' \describe{
#'   \item{direction}{\strong{north}: Far West entry point heading to Parmer, \strong{south}: RM 2222 heading to Cesar Chavez}
#'   \item{time}{time of day}
#'   \item{plate}{vehicle license plate}
#'   \item{make}{vehicle make}
#'   \item{model}{vehicle model}
#'   \item{color}{vehicle color}
#' }
#' @source To see how this dataset was generated, visit \url{https://sccm.io/post/mopac-dataset/}
#' @source For City of Austin Traffic Counts, visit \url{https://data.austintexas.gov/Transportation-and-Mobility/Camera-Traffic-Counts/sh59-i6y9}
"express"


#' Mopac Express Lane Rates
#'
#' Express Lane Rates for Loop 1 "Mopac" in Austin, Texas. Rates correspond to RM 2222 / Far West entry points with pre-COVID weekday traffic. Recommend loading \href{https://readr.tidyverse.org/}{readr} package so that \code{time} displays correctly as \strong{hms}.
#'
#' @format A tibble with 25 rows and 3 variables:
#' \describe{
#'   \item{direction}{\strong{north}: Far West entry point heading to Parmer, \strong{south}: RM 2222 heading to Cesar Chavez}
#'   \item{time}{time of day}
#'   \item{rate}{TxTag rate in USD}
#' }
#' @source {Rates obtained from Central Texas Regional Mobility Authority.} \url{https://www.mobilityauthority.com/pay-your-toll/rates}
"rates"

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  subroutine wrt_diffs
!
! Given two geometries, work out the differences in bond-lengths
! and print the resulting values, largest first
!
! The two geometries are in geo and geoa
!
   use chanel_C, only : iw, job_fn
   use molkst_C, only : numat, refkey, line, geo_dat_name, maxtxt
!
   use elemts_C, only : elemnt
!
   use common_arrays_C, only : geo, geoa, nat, nbonds, ibonds, txtatm, coord
!
   implicit none
   integer :: i, j, j1, k, l, m, n, npairs, ijbonds(15)
   integer, allocatable :: pairs(:,:)
   logical :: first = .TRUE.
   double precision :: sum, sum_a, sum_b, sum_aa, sum_bb
   double precision, allocatable :: dist(:,:)
   integer, allocatable :: jbonds(:,:), njbonds(:)
   integer, external :: quoted
     allocate(pairs(2,numat*10), dist(3,numat*10), jbonds(15,numat), njbonds(numat))
!
! Work out connectivity twice - the sequence of atoms on one set might be
! different to that in the other set.
!
     coord(:,:numat) = geoa(:,:numat)
     call set_up_dentate()
     jbonds(:,:numat) = ibonds(:,:numat)
     njbonds(:numat) = nbonds(:numat)
     coord(:,:numat) = geo(:,:numat)
     call set_up_dentate()
!
!  Decide on bonds to an atom by whichever system has the more bonds to that atom
!
     do i = 1, numat
       if (njbonds(i) > nbonds(i)) then
         nbonds(i) = njbonds(i)
         ibonds(:nbonds(i),i) = jbonds(:nbonds(i),i)
       end if
       if (nbonds(i) > njbonds(i)) then
         njbonds(i) = nbonds(i)
        jbonds(:nbonds(i),i) = ibonds(:nbonds(i),i)
       end if
     end do
     npairs = 0
     do i = 1, numat
       do j = 1, nbonds(i)
         k = ibonds(j,i)
!
! Decide which atom(s) in the first system matche(s) atom "k" in the second system
! If the choice is unambiguous, use that atom, otherwise use all atoms that are bonded to atom "i"
! and then pick the best match.
!
         m = 0
         n = 0
         do j1 = 1, nbonds(i)
           l = jbonds(j1,i)
           if (txtatm(l)(12:) == txtatm(k)(12:)) then
             m = l
             n = n + 1
           end if
         end do
         if (n == 1) then
!
!  The label on one and only one atom matches atom "i"
!
           ijbonds(1) = m
           m = 1
         else
           m = nbonds(i)
           ijbonds(:m) = jbonds(:m,i)
         end if
         sum = 10.d0
         sum_aa = 0.d0
         sum_bb = 0.d0
         do j1 = 1, m
           l = ijbonds(j1)
           if (l > i .or. k > i .or. k == 0 .or. l == 0) cycle
           if (nat(k) /= nat(l)) cycle
           if (maxtxt == 26) then
             if (txtatm(k)(13:16) /= txtatm(l)(13:16)) cycle
           end if
           sum_a = sqrt((geo(1,i) - geo(1,k))**2 + (geo(2,i) - geo(2,k))**2 + (geo(3,i) - geo(3,k))**2)
           sum_b = sqrt((geoa(1,i) - geoa(1,l))**2 + (geoa(2,i) - geoa(2,l))**2 + (geoa(3,i) - geoa(3,l))**2)
           if (sum > abs(sum_a - sum_b)) then
             sum = abs(sum_a - sum_b)
             sum_aa = sum_a
             sum_bb = sum_b
           end if
         end do
         if (sum < 9.d0) then
           npairs = npairs + 1
           pairs(1, npairs) = i
           pairs(2, npairs) = k
           dist(1,npairs) = sum
           dist(2,npairs) = sum_aa
           dist(3,npairs) = sum_bb
         end if
       end do
     end do
    !
    ! Write out differences,largest first
    !
    do i = 1, min(25, npairs)
      sum = 0.d0
      k = 0
      do j = 1, npairs
        if (sum < dist(1,j)) then
          sum = dist(1,j)
          k = j
        end if
      end do
      if (sum < 0.01d0) exit
      j = pairs(1,k)
      l = pairs(2,k)
      if (nat(l) == nat(j) .and. j > l .or. nat(l) > nat(j)) then
        j = pairs(2,k)
        l = pairs(1,k)
      end if
      if (first) then
        if (trim(job_fn) == trim(geo_dat_name)) then
          line = "dataset"
        else
          line = "GEO_DAT"
        end if
        write(iw,'(/28x,a)')" Differences between bond-lengths for the two geometries"
        write(iw,'(/,a)')"           Diff.                 Atom 1           "//&
          &"            Atom 2                  Bond length      Bond length"
        write(iw,'(85x,a)')" in "//trim(line)//"      in GEO_REF"
        first = .false.
      end if
      write(iw,'(i4, SP, f12.3, S, 4x, a, 3x, a, f11.3, 5x, f12.3)') &
        i, dist(2,k) - dist(3,k), elemnt(nat(j))//"("//trim(txtatm(j))//")", &
        elemnt(nat(l))//"("//trim(txtatm(l))//")", dist(2,k), dist(3,k)
      dist(1,k) = -10.d0
    end do
    if ( .not. first) then
      i = quoted(" GEO_DAT")
      if (i > 0) then
        do k = 1, 6
          line = " "//trim(refkey(k))
          call upcase(line, len_trim(line))
          i = index(line," GEO_DAT")
          if (i /= 0) exit
        end do
        j = index(refkey(k)(i + 10:),'"') + index(refkey(k)(i + 10:),"'") + i + 8
        line = refkey(k)(i + 9:j)
        write(iw,'(/3x,a)')" GEO_DAT:  '"//trim(line)//"'"
      else
        write(iw,'(/3x,a)')" Data set: '"//trim(job_fn)//"'"
      end if
      do k = 1, 6
        line = " "//trim(refkey(k))
        call upcase(line, len_trim(line))
        i = index(line," GEO_REF")
        if (i /= 0) exit
      end do
      j = index(refkey(k)(i + 10:),'"') + index(refkey(k)(i + 10:),"'") + i + 8
      line = refkey(k)(i + 9:j)
      write(iw,'(3x,a)')" GEO_REF:  '"//trim(line)//"'"
    end if
  end subroutine wrt_diffs
  subroutine analyze_h_bonds
!
!  Using two geometries, compare the hydrogen bonds to find:
!  (A) How many hydrogen bonds are the same.
!  (B) Which hydrogen bonds are in the first geometry and not in the second.
!  (C) Which hydrogen bonds are in the second geometry and not in the first.
    use molkst_C, only : numat,  P_Hbonds, numcal, geo_ref_name, geo_dat_name, &
    E_disp, E_hb, E_hh, line
!
    use common_arrays_C, only : coord, geoa, H_energy, H_txt
!
    use chanel_C, only : iw, job_fn
    implicit none
    double precision :: sum, E_1_disp, E_2_disp, E_1_hb, E_2_hb, E_1_hh, E_2_hh, sum_a
    integer :: set_1_P_Hbonds, set_2_P_Hbonds, i, j, k, l, n_common
    logical :: l_prt
    double precision, allocatable :: set_1_H_energy(:), set_2_H_energy(:)
    logical, allocatable :: l_used_1(:), l_used_2(:)
    character, allocatable :: set_1_H_txt(:)*62, set_2_H_txt(:)*62, set_1_H_dist(:)*5, set_2_H_dist(:)*5
      allocate(set_1_H_txt(numat), set_2_H_txt(numat), set_1_H_energy(numat), set_2_H_energy(numat), &
        l_used_1(numat), l_used_2(numat), set_1_H_dist(numat), set_2_H_dist(numat))
      call l_control("PRT DISP(1.0) SILENT", len("PRT DISP(1.0) SILENT"), 1)
      call get_H_bonds
      E_1_disp = E_disp
      E_1_hb = E_hb
      E_1_hh = E_hh
      set_1_P_Hbonds = P_Hbonds
      do i = 1, P_Hbonds
        set_1_H_txt(i) = H_txt(i)(:31)//trim(H_txt(i)(37:68))
        set_1_H_dist(i) = H_txt(i)(32:36)
      end do
      if (P_Hbonds > 0) set_1_H_energy(:P_Hbonds) = H_energy(:P_Hbonds)
      coord(:,:numat) = geoa(:,:numat)
      numcal = numcal + 1
      call get_H_bonds
      E_2_disp = E_disp
      E_2_hb = E_hb
      E_2_hh = E_hh
      set_2_P_Hbonds = P_Hbonds
      do i = 1, P_Hbonds
        set_2_H_txt(i) = H_txt(i)(:31)//trim(H_txt(i)(37:68))
        set_2_H_dist(i) = H_txt(i)(32:36)
      end do
      if (P_Hbonds > 0) set_2_H_energy(:P_Hbonds) = H_energy(:P_Hbonds)
      i = max(len_trim(geo_ref_name), len_trim(geo_dat_name))
      write(iw,'(//20x,a)')"Analysis of Non-Covalent Interactions"
!
!  How many hydrogen bonds are the same?
!
      l_used_1 = .false.
      l_used_2 = .false.
      n_common = 0
      do i = 1, set_1_P_Hbonds
        do j = 1, set_2_P_Hbonds
          if (set_1_H_txt(i) == set_2_H_txt(j)) then
            l_used_1(i) = .true.
            l_used_2(j) = .true.
            n_common = n_common + 1
          end if
        end do
      end do
      if (trim(job_fn) == trim(geo_dat_name)) then
        line = "dataset"
      else
        line = "GEO_DAT"
      end if
      write(iw,'(/10x,a, f9.2, a)')"Total non-covalent energy of "//trim(line)//" system: ", &
        E_1_disp + E_1_hb + E_1_hh, " Kcal/mol"
      write(iw,'(10x,a, f9.2, a)')"Total non-covalent energy of GEO_REF system: ", &
        E_2_disp + E_2_hb + E_2_hh, " Kcal/mol"
      sum = E_1_disp + E_1_hb + E_1_hh - E_2_disp - E_2_hb - E_2_hh
      write(iw,'(43x, a, f9.2, a)')"Difference: ", sum, " Kcal/mol"
      if (n_common > 0) write(iw,'(/10x,a, i5)')"Number of hydrogen bonds common to both systems:", n_common
!
!  Which hydrogen bonds are in the data set but not in the reference?
!
      j = 0
      l_prt = .true.
      do i = 1, set_1_P_Hbonds
        if (.not. l_used_1(i)) then
          j = j + 1
          set_1_H_txt(j) = set_1_H_txt(i)
          set_1_H_energy(j) = set_1_H_energy(i)
          set_1_H_dist(j) = set_1_H_dist(i)
        end if
      end do
      sum_a = 0.d0
      do l = 1, j
        k = 0
        sum = 10.d0
        do i = 1, j
          if (set_1_H_energy(i) < sum) then
            k = i
            sum = set_1_H_energy(i)
          end if
        end do
        if (sum > -0.8d0) exit
        if (set_1_H_dist(k) > "3.000") cycle
        if (l_prt) then
          if (trim(job_fn) == trim(geo_dat_name)) then
            line = "dataset"
          else
            line = "GEO_DAT"
          end if
          write(iw,'(//28x,a)')"Hydrogen bonds in "//trim(line)//" but not in GEO_REF"
          write(iw,'(/15x,a,21x,a,12x,a,5x,a,/)')"Donor atom","Hydrogen atom","H-bond length(A)","Energy    Sum"
          l_prt = .false.
        end if
        sum_a = sum_a + set_1_H_energy(k)
        write(iw,'(i4,3x,a, 7x, a, f17.3, f9.3)')l, set_1_H_txt(k), set_1_H_dist(k), set_1_H_energy(k), sum_a
        set_1_H_energy(k) = 5.d0
      end do
      j = 0
      l_prt = .true.
      do i = 1, set_2_P_Hbonds
        if (.not. l_used_2(i)) then
          j = j + 1
          set_2_H_txt(j) = set_2_H_txt(i)
          set_2_H_energy(j) = set_2_H_energy(i)
          set_2_H_dist(j) = set_2_H_dist(i)
        end if
      end do
      sum_a = 0.d0
      do l = 1, j
        k = 0
        sum = 10.d0
        do i = 1, j
          if (set_2_H_energy(i) < sum) then
            k = i
            sum = set_2_H_energy(i)
          end if
        end do
        if (sum > -0.8d0) exit
        if (set_2_H_dist(k) > "3.000") cycle
        if (l_prt) then
          if (trim(job_fn) == trim(geo_dat_name)) then
            line = "dataset"
          else
            line = "GEO_DAT"
          end if
          write(iw,'(//28x,a)')"Hydrogen bonds in GEO_REF but not in "//trim(line)
          write(iw,'(/15x,a,21x,a,12x,a,5x,a,/)')"Donor atom","Hydrogen atom","H-bond length(A)","Energy    Sum"
          l_prt = .false.
        end if
        sum_a = sum_a + set_2_H_energy(k)
        write(iw,'(i4, 3x, a, 7x, a, f17.3, f9.3)')l, set_2_H_txt(k), set_2_H_dist(k), set_2_H_energy(k), sum_a
        set_2_H_energy(k) = 5.d0
      end do
      return
  end subroutine analyze_h_bonds
  subroutine get_H_bonds
    logical :: L_grad = .false.
    double precision :: correction
    call post_scf_corrections(correction, l_grad)
    return
  end subroutine get_H_bonds

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine fock2z (f, q, qe, wj, wk, ptot2, mode, ione)
    use molkst_C, only: numat, mpack
    use MOZYME_C, only: lijbo, iorbs, kopt
    use common_arrays_C, only: coordinates => coord, p, nat, ifact
    implicit none
    integer, intent (in) :: ione, mode
    double precision :: f(mpack)
    double precision, dimension (numat), intent (out) :: q, qe
    double precision, dimension (*), intent (in) :: wj, wk
    double precision, dimension (numat, 81), intent (out) :: ptot2
      if (lijbo) then
      call fz2n (f, p, iorbs, nat, ifact, q, qe, wj, wk, ptot2, mode, &
           & kopt, ione, coordinates)
    else
      call fz2 (f, p, iorbs, nat, ifact, q, qe, wj, wk, ptot2, mode, &
           & kopt, ione, coordinates)
    end if
end subroutine fock2z
!
subroutine fz2 (f, ptot, iorbs, nat, ifact, q, qe, wj, wk, ptot2, mode, kopt, &
     & ione, coord)
    use molkst_C, only: numat, norbs, mpack, numcal, l_feather
    use cosmo_C, only : useps
    use parameters_C, only: am, dd, ad, tore
    use funcon_C, only: ev, a0
    use MOZYME_C, only : direct, semidr
    implicit none
   !***********************************************************************
   !
   ! FOCK2 FORMS THE TWO-ELECTRON TWO-CENTER REPULSION PART OF THE FOCK
   ! MATRIX
   ! ON INPUT  PTOT = TOTAL DENSITY MATRIX.
   !           W    = TWO-ELECTRON INTEGRAL MATRIX.
   !
   !  ON OUTPUT F   = PARTIAL FOCK MATRIX
   !***********************************************************************
    integer, intent (in) :: ione, mode
    integer, dimension (numat), intent (in) :: iorbs, kopt, nat
    integer, dimension (norbs), intent (in) :: ifact
    double precision, dimension (numat), intent (inout) :: q, qe
    double precision, dimension (mpack), intent (in) :: ptot
    double precision, dimension (mpack), intent (inout) :: f
    double precision, dimension (*), intent (in) :: wj, wk
    double precision, dimension (3, numat), intent (in) :: coord
    double precision, dimension (numat, 81), intent (inout) :: ptot2
   !
   !.. Local Scalars ..
    logical :: calci, calcj
    integer, save :: icalcn = 0, krinc = 0
    integer :: i, i1, iab, ii, iim1, ij, ilim, ired, j, j1, jba, ji, jj, jk, &
   & jred, k, kj, kl, kr, l, li, lii, lij, lj, ljj, lk, m, ni, nj
    double precision :: sum, sumdia, sumoff, ade, aee, da, dx, dy, dz, r, r2, &
   & ri2, ri5, rm, rp, w1, w2, w3, w4, w5, w6, w7, enuc, point, const
    integer, dimension (256), save :: jindex
    double precision, dimension (16) :: pja, pjb
    double precision, dimension (45) :: e1b, e2a
    double precision, dimension (171) :: fdummy = 0.d0
    double precision, dimension (2025) :: wjloc = 0.d0
    integer, external :: ijbo
   !
    dx = 0.d0
    dy = 0.d0
    dz = 0.d0
    r2 = 0.d0
    w2 = 0.d0
    w3 = 0.d0
    w4 = 0.d0
    w5 = 0.d0
    w6 = 0.d0
    w7 = 0.d0
    ni = 0
    nj = 0
   !
   !
    if (icalcn /= numcal) then
      icalcn = numcal
      !
      !   SET UP GATHER-SCATTER TYPE ARRAYS FOR USE WITH TWO-ELECTRON
      !   INTEGRALS.  JINDEX ARE THE INDICES OF THE J-INTEGRALS FOR ATOM I
      !               JJNDEX ARE THE INDICES OF THE J-INTEGRALS FOR ATOM J
      !
      m = 0
      do i = 1, 4
        do j = 1, 4
          ij = Min (i, j)
          ji = i + j - ij
          do k = 1, 4
            do l = 1, 4
              m = m + 1
              kl = Min (k, l)
              lk = k + l - kl
              jindex(m) = (ifact(ji)+ij) * 10 + ifact(lk) + kl - 10
            end do
          end do
        end do
      end do
    end if
   !
   !  Put P(A,A) density into array PTOT2
   !
    call chrge_for_MOZYME (ptot, qe)
   !
   !   MODE=1:   ADD TO EXISTING FOCK MATRIX
   !   MODE=0:   CALCULATE FOCK MATRIX STARTING WITH H MATRIX
   !   MODE=-1:  REMOVE TERMS FROM FULL FOCK MATRIX.
   !
    if (mode ==-1) then
      f(1:mpack) = -f(1:mpack)
    end if
    l = 0
    do ii = 1, numat
      q(ii) = tore(nat(ii)) - qe(ii)
      i = ijbo (ii, ii)
      iab = iorbs(ii)
      m = 0
      do j = 1, iab
        do k = 1, iab
          m = m + 1
          jk = Min (j, k)
          kj = k + j - jk
          ptot2(ii, m) = ptot(i+ (kj*(kj-1))/2+jk)
        end do
      end do
    end do

   !
    kr = 0
    ired = 1
    do ii = 1, numat
      calci = (kopt(ired) == ii)
      if (calci .and. ired < numat) then
        ired = ired + 1
      end if
      !
      !
        if (mode == 0) then
          calci = .true.
        end if
        iab = iorbs(ii)
        if (iab /= 0) then
          jred = 1
          iim1 = ii - ione
          do jj = 1, iim1
            calcj = (kopt(jred) == jj)
            if (calcj .and. jred < numat) then
              jred = jred + 1
            end if
            jba = iorbs(jj)
            if (ijbo(ii, jj) >= 0) then
              if (direct .and. (calci .or. calcj)) then
                call rotate(nat(ii), nat(jj), coord(1, ii), coord(1, jj), wjloc, kr, e1b, e2a, enuc)
              end if
               !
              if (iab > 5 .or. jba > 5) then
                if ( .not. (calci .or. calcj)) then
                  if ( .not. direct) then
                    kr = kr + (iab*(iab+1)) / 2 * (jba*(jba+1)) / 2
                  end if
                else
                  !
                  !   Use MNDOD specific code
                  !
                  i = ijbo (ii, ii) + 1
                  j = ijbo (jj, jj) + 1
                  ij = ijbo (ii, jj) + 1
                     !
                  if (direct) then
                    call focd2z (iab, jba, f(i), f(j), f(ij), ptot(i), &
                   & ptot(j), ptot(ij), wjloc, wjloc, i == j, krinc)
                  else
                    call focd2z (iab, jba, f(i), f(j), f(ij), ptot(i), &
                   & ptot(j), ptot(ij), wj(kr+1), wk(kr+1), i == j, kr)
                  end if
                end if
              else if (iab >= 3 .and. jba >= 3) then
                !
                !                         HEAVY-ATOM  - HEAVY-ATOM
                !
                !   EXTRACT COULOMB TERMS
                !
                if (calci .or. calcj) then
                  do i = 1, 16
                    pja(i) = ptot2(ii, i)
                    pjb(i) = ptot2(jj, i)
                  end do
                  !
                  !  COULOMB TERMS
                  !
                  if (ii == jj) then
                    if (direct) then
                      call jab_for_MOZYME (1, 1, pja, pjb, wjloc, f(ijbo(ii, ii)+1), &
                     & fdummy)
                    else
                       call jab_for_MOZYME (1, 1, pja, pjb, wj(kr+1), f(ijbo(ii, ii)+1), &
                     & fdummy)
                    end if
                  else if (direct) then
                    call jab_for_MOZYME (1, 1, pja, pjb, wjloc, f(ijbo(ii, ii)+1), &
                   & f(ijbo(jj, jj)+1))
                  else
                    call jab_for_MOZYME (1, 1, pja, pjb, wj(kr+1), f(ijbo(ii, ii)+1), &
                   & f(ijbo(jj, jj)+1))
                  end if
                  !
                  !  EXCHANGE TERMS
                  !
                  !  EXTRACT INTERSECTION OF ATOMS II AND JJ IN THE SPIN
                  !  DENSITY MATRIX
                  !
                  l = ijbo (ii, jj) + 1
                  if (ii /= jj) then

                    if (direct) then
                      call kab_for_MOZYME (0, 0, ptot(l), wjloc, f(l))
                    else
                      call kab_for_MOZYME (0, 0, ptot(l), wk(kr+1), f(l))
                    end if
                  end if
                end if

                if ( .not. direct) then
                  kr = kr + 100
                end if

              else if (iab >= 3 .and. jba == 1) then
                if (calci .or. calcj) then
                  !
                  !                         LIGHT-ATOM  - HEAVY-ATOM
                  !
                  !   COULOMB TERMS
                  !
                  sumdia = 0.d0
                  sumoff = 0.d0
                  l = ijbo (ii, jj)
                  lj = ijbo (jj, jj) + 1
                  li = ijbo (ii, ii)
                  k = 0


                  if (direct) then


                    do i = 1, 4
                      do j = 1, i - 1
                        li = li + 1
                        k = k + 1
                        f(li) = f(li) + ptot(lj) * wjloc(k)
                        sumoff = sumoff + ptot(li) * wjloc(k)
                      end do
                      li = li + 1
                      k = k + 1
                      f(li) = f(li) + ptot(lj) * wjloc(k)
                      sumdia = sumdia + ptot(li) * wjloc(k)
                    end do
                    f(lj) = f(lj) + sumoff * 2.d0 + sumdia
                    !
                    !  EXCHANGE TERMS
                    !
                    !  EXTRACT INTERSECTION OF ATOMS II AND JJ IN THE SPIN
                    !  DENSITY MATRIX
                    !
                    l = ijbo (ii, jj)
                    k = 0
                    do i = 1, 4
                      sum = 0.d0
                      do j = 1, 4
                        k = k + 1
                        sum = sum + ptot(l+j) * wjloc(jindex(k))
                      end do
                      f(l+i) = f(l+i) - sum * 0.5d0
                    end do
                  else
                        !
                    do i = 1, 4
                      do j = 1, i - 1
                        li = li + 1
                        k = k + 1
                        f(li) = f(li) + ptot(lj) * wj(kr+k)
                        sumoff = sumoff + ptot(li) * wj(kr+k)
                      end do
                      li = li + 1
                      k = k + 1
                      f(li) = f(li) + ptot(lj) * wj(kr+k)
                      sumdia = sumdia + ptot(li) * wj(kr+k)
                    end do
                    f(lj) = f(lj) + sumoff * 2.d0 + sumdia
                    !
                    !  EXCHANGE TERMS
                    !
                    !  EXTRACT INTERSECTION OF ATOMS II AND JJ IN THE SPIN
                    !  DENSITY MATRIX
                    !
                    l = ijbo (ii, jj)
                    k = 0
                    do i = 1, 4
                      sum = 0.d0
                      do j = 1, 4
                        k = k + 1
                        sum = sum + ptot(l+j) * wk(kr+jindex(k))
                      end do
                      f(l+i) = f(l+i) - sum * 0.5d0
                    end do
                  end if
                end if


                if ( .not. direct) then
                  kr = kr + 10
                end if


              else if (jba >= 3 .and. iab == 1) then
                if (calci .or. calcj) then
                  !
                  !                         HEAVY-ATOM - LIGHT-ATOM
                  !
                  !   COULOMB TERMS
                  !
                  sumdia = 0.d0
                  sumoff = 0.d0
                  l = ijbo (ii, jj)
                  lj = ijbo (jj, jj)
                  li = ijbo (ii, ii) + 1
                  k = 0

                  if (direct) then

                    do i = 1, 4
                      do j = 1, i - 1
                        k = k + 1
                        lj = lj + 1
                        f(lj) = f(lj) + ptot(li) * wjloc(k)
                        sumoff = sumoff + ptot(lj) * wjloc(k)
                      end do
                      lj = lj + 1
                      k = k + 1
                      f(lj) = f(lj) + ptot(li) * wjloc(k)
                      sumdia = sumdia + ptot(lj) * wjloc(k)
                    end do !
                    f(li) = f(li) + sumoff * 2.d0 + sumdia
                    !
                    !  EXCHANGE TERMS
                    !
                    !  EXTRACT INTERSECTION OF ATOMS II AND JJ IN THE SPIN
                    !  DENSITY MATRIX
                    !
                    l = ijbo (ii, jj)
                    k = 0
                    do i = 1, 4
                      sum = 0.d0
                      do j = 1, 4
                        k = k + 1
                        sum = sum + ptot(l+j) * wjloc(jindex(k))
                      end do
                      f(l+i) = f(l+i) - sum * 0.5d0
                    end do
                  else


                    do i = 1, 4
                      do j = 1, i - 1
                        k = k + 1
                        lj = lj + 1
                        f(lj) = f(lj) + ptot(li) * wj(kr+k)
                        sumoff = sumoff + ptot(lj) * wj(kr+k)
                      end do
                      lj = lj + 1
                      k = k + 1
                      f(lj) = f(lj) + ptot(li) * wj(kr+k)
                      sumdia = sumdia + ptot(lj) * wj(kr+k)
                    end do
                    f(li) = f(li) + sumoff * 2.d0 + sumdia
                    !
                    !  EXCHANGE TERMS
                    !
                    !  EXTRACT INTERSECTION OF ATOMS II AND JJ IN THE SPIN
                    !  DENSITY MATRIX
                    !
                    l = ijbo (ii, jj)
                    k = 0
                    do i = 1, 4
                      sum = 0.d0
                      do j = 1, 4
                        k = k + 1
                        sum = sum + ptot(l+j) * wk(kr+jindex(k))
                      end do
                      f(l+i) = f(l+i) - sum * 0.5d0
                    end do
                  end if
                end if

                if ( .not. direct) then
                  kr = kr + 10
                end if

              else if (iab == 1 .and. jba == 1) then
                if (calci .or. calcj) then
                  !
                  !                         LIGHT-ATOM - LIGHT-ATOM
                  !
                  lii = ijbo (ii, ii) + 1
                  lij = ijbo (ii, jj) + 1
                  ljj = ijbo (jj, jj) + 1
                     !
                  if (direct) then
                        !
                    f (lii) = f (lii) + ptot (ljj) * wjloc (1)
                    if (ii /= jj) then
                      f(ljj) = f(ljj) + ptot(lii) * wjloc(1)
                      f(lij) = f(lij) - ptot(lij) * wjloc(1) * 0.5d0
                    end if
                  else

                    f(lii) = f(lii) + ptot(ljj) * wj(kr+1)
                    if (ii /= jj) then
                      f(ljj) = f(ljj) + ptot(lii) * wj(kr+1)
                      f(lij) = f(lij) - ptot(lij) * wk(kr+1) * 0.5d0
                    end if
                  end if
                end if
                if ( .not. direct) then
                  kr = kr + 1
                end if
              end if
            else
              !
              !   Use point-charge approximation
              !
              i1 = ijbo (ii, ii)
              j1 = ijbo (jj, jj)

              if (iorbs(ii)*iorbs(jj) > 0) then

                if (calci .or. calcj) then

                  if (semidr) then
                    dx = coord(1, ii) - coord(1, jj)
                    dy = coord(2, ii) - coord(2, jj)
                    dz = coord(3, ii) - coord(3, jj)

                    r2 = dx * dx + dy * dy + dz * dz

                    ni = nat(ii)
                    nj = nat(jj)

                    aee = 0.5d0 / am(ni) + 0.5d0 / am(nj)
                    w1 = ev / Sqrt (r2/(a0**2)+aee**2)
                    if (l_feather) then
                      call to_point(sqrt(r2), point, const)
                      w1 = w1*const + (1.d0 - const)*point
                    end if
                  else
                    w1 = wj(kr+1)
                  end if
                  !
                  !   MONOPOLE
                  !

                  do i = 1, iorbs(ii)
                    i1 = i1 + i
                    f(i1) = f(i1) + qe(jj) * w1
                  end do
                  do j = 1, iorbs(jj)
                    j1 = j1 + j
                    f(j1) = f(j1) + qe(ii) * w1
                  end do
                  i1 = ijbo (ii, ii)
                  j1 = ijbo (jj, jj)
                end if

                if ( .not. semidr) then
                  kr = kr + 1
                end if
                  !
                if (ijbo(ii, jj) ==-2) then
                  !
                  !   DIPOLE, IF NEEDED
                  !
                  if ((calci .or. calcj) .and. semidr) then
                    r = Sqrt (r2)
                    dx = dx / r
                    dy = dy / r
                    dz = dz / r
                    if (Abs (dz) > 0.99999999d0) then
                      dz = Sign (1.d0, dz)
                    end if

                    if (iorbs(ii) > 1) then
                      da = dd(ni)
                      ade = 0.5d0 / ad(ni) + 0.5d0 / am(nj)
                      rp = Sqrt ((r/a0+da)**2+ade**2)
                      rm = Sqrt ((r/a0-da)**2+ade**2)
                      ri2 = ev * (0.5d0/rp-0.5d0/rm)
                      if (l_feather) then
                        call to_point(r, point, const)
                        ri2 = ri2*const
                      end if

                      w5 = ri2 * dx
                      w6 = ri2 * dy
                      w7 = ri2 * dz
                    end if

                    if (iorbs(jj) > 1) then

                      da = dd(nj)
                      ade = 0.5d0 / am(ni) + 0.5d0 / ad(nj)
                      rp = Sqrt ((r/a0+da)**2+ade**2)
                      rm = Sqrt ((r/a0-da)**2+ade**2)
                      ri5 = -ev * (0.5d0/rp-0.5d0/rm)
                      if (l_feather) then
                        call to_point(r, point, const)
                        ri5 = ri5*const
                      end if

                      w2 = ri5 * dx
                      w3 = ri5 * dy
                      w4 = ri5 * dz
                    end if
                  end if

                  if (iorbs(ii) > 1) then
                    if (iorbs(jj) > 1) then
                      if (calci .or. calcj) then
                        if ( .not. semidr) then
                          w2 = wj(kr+1)
                          w3 = wj(kr+2)
                          w4 = wj(kr+3)
                          w5 = wj(kr+4)
                          w6 = wj(kr+5)
                          w7 = wj(kr+6)
                        end if

                        f(j1+2) = f(j1+2) + qe(ii) * w2
                        f(j1+4) = f(j1+4) + qe(ii) * w3
                        f(j1+7) = f(j1+7) + qe(ii) * w4
                        f(i1+2) = f(i1+2) + qe(jj) * w5
                        f(i1+4) = f(i1+4) + qe(jj) * w6
                        f(i1+7) = f(i1+7) + qe(jj) * w7

                        f(j1 +1) = f(j1 +1) + ptot(i1+2) * w5 *2
                        f(j1 +3) = f(j1 +3) + ptot(i1+2) * w5 *2
                        f(j1 +6) = f(j1 +6) + ptot(i1+2) * w5 *2
                        f(j1+10) = f(j1+10) + ptot(i1+2) * w5 *2

                        f(j1 +1) = f(j1 +1) + ptot(i1+4) * w6 *2
                        f(j1 +3) = f(j1 +3) + ptot(i1+4) * w6 *2
                        f(j1 +6) = f(j1 +6) + ptot(i1+4) * w6 *2
                        f(j1+10) = f(j1+10) + ptot(i1+4) * w6 *2

                        f(j1 +1) = f(j1 +1) + ptot(i1+7) * w7 *2
                        f(j1 +3) = f(j1 +3) + ptot(i1+7) * w7 *2
                        f(j1 +6) = f(j1 +6) + ptot(i1+7) * w7 *2
                        f(j1+10) = f(j1+10) + ptot(i1+7) * w7 *2

                        f(i1 +1) = f(i1 +1) + ptot(j1+2) * w2 *2
                        f(i1 +3) = f(i1 +3) + ptot(j1+2) * w2 *2
                        f(i1 +6) = f(i1 +6) + ptot(j1+2) * w2 *2
                        f(i1+10) = f(i1+10) + ptot(j1+2) * w2 *2

                        f(i1 +1) = f(i1 +1) + ptot(j1+4) * w3 *2
                        f(i1 +3) = f(i1 +3) + ptot(j1+4) * w3 *2
                        f(i1 +6) = f(i1 +6) + ptot(j1+4) * w3 *2
                        f(i1+10) = f(i1+10) + ptot(j1+4) * w3 *2

                        f(i1 +1) = f(i1 +1) + ptot(j1+7) * w4 *2
                        f(i1 +3) = f(i1 +3) + ptot(j1+7) * w4 *2
                        f(i1 +6) = f(i1 +6) + ptot(j1+7) * w4 *2
                        f(i1+10) = f(i1+10) + ptot(j1+7) * w4 *2
                      end if

                      if ( .not. semidr) then
                        kr = kr + 6
                      end if
                    else
                      if (calci .or. calcj) then
                        if ( .not. semidr) then
                          w5 = wj(kr+1)
                          w6 = wj(kr+2)
                          w7 = wj(kr+3)
                        end if
                        f(i1+2) = f(i1+2) + qe(jj) * w5
                        f(i1+4) = f(i1+4) + qe(jj) * w6
                        f(i1+7) = f(i1+7) + qe(jj) * w7

                        f(j1 +1) = f(j1 +1) + ptot(i1+2) * w5 *2

                        f(j1 +1) = f(j1 +1) + ptot(i1+4) * w6 *2

                        f(j1 +1) = f(j1 +1) + ptot(i1+7) * w7 *2
                      end if
                      if ( .not. semidr) then
                        kr = kr + 3
                      end if
                    end if
                  else if (iorbs(jj) > 1) then
                    if (calci .or. calcj) then
                      if ( .not. semidr) then
                        w2 = wj(kr+1)
                        w3 = wj(kr+2)
                        w4 = wj(kr+3)
                      end if
                      f(j1+2) = f(j1+2) + qe(ii) * w2
                      f(j1+4) = f(j1+4) + qe(ii) * w3
                      f(j1+7) = f(j1+7) + qe(ii) * w4

                      f(i1 +1) = f(i1 +1) + ptot(j1+2) * w2 *2

                      f(i1 +1) = f(i1 +1) + ptot(j1+4) * w3 *2

                      f(i1 +1) = f(i1 +1) + ptot(j1+7) * w4 *2
                    end if
                    if ( .not. semidr) then
                      kr = kr + 3
                    end if
                  end if
                end if
              end if
            end if
          end do
          if (.not. direct) then
            i = ijbo (ii, ii) + 1
            ilim = (iab*(iab+1)) / 2
            call fock1_for_MOZYME (f(i), ptot(i), wj(kr+1), kr, iab, ilim)
          end if
        end if
    end do



    if (direct) then
      kr = 0
      ired = 1
      do ii = 1, numat
        iab = iorbs(ii)
          if (iab /= 0) then
            i = ijbo (ii, ii) + 1
            ilim = (iab*(iab+1)) / 2
            call fock1_for_MOZYME (f(i), ptot(i), wj(kr+1), kr, iab, ilim)
          end if
      end do
    end if

   !
    if (mode ==-1) then
      f(:) = -f(:)
    end if
    if (useps) then
  !    call addfck_for_MOZYME(f, ptot, iatsp, phinet, qscnet, qdenet, &
  !   & ipiden, gden, qscat)
    end if
end subroutine fz2
!
subroutine fz2n (f, ptot, iorbs, nat, ifact, q, qe, wj, wk, ptot2, mode, &
     & kopt, ione, coord)
    use molkst_C, only: numat, norbs, mpack, numcal, l_feather
    use MOZYME_C, only : nijbo, &
       & direct, semidr
    use parameters_C, only: am, dd, ad, tore
    use cosmo_C, only: useps
    use funcon_C, only: ev, a0
   ! use permanent_arrays, only: iatsp, ipiden, phinet, &
   !      & qdenet, qscnet, gden, qscat

     use linear_cosmo, only: addfckz

    implicit none
   !***********************************************************************
   !
   ! FOCK2 FORMS THE TWO-ELECTRON TWO-CENTER REPULSION PART OF THE FOCK
   ! MATRIX
   ! ON INPUT  PTOT = TOTAL DENSITY MATRIX.
   !           W    = TWO-ELECTRON INTEGRAL MATRIX.
   !
   !  ON OUTPUT F   = PARTIAL FOCK MATRIX
   !***********************************************************************
    integer, intent (in) :: ione, mode
    integer, dimension (numat), intent (in) :: iorbs, kopt, nat
    integer, dimension (norbs), intent (in) :: ifact
    double precision, dimension (numat), intent (inout) :: q, qe
    double precision, dimension (mpack), intent (in) :: ptot
    double precision, dimension (mpack), intent (inout) :: f
    double precision, dimension (*), intent (in) :: wj, wk
    double precision, dimension (3, numat), intent (in) :: coord
    double precision, dimension (numat, 81), intent (inout) :: ptot2
   !
   !.. Local Scalars ..
    logical :: calci, calcj
    integer, save :: icalcn = 0, krinc = 0
    integer :: i, i1, iab, ii, iim1, ij, ilim, ired, j, j1, jba, ji, jj, jk, &
   & jred, k, kj, kl, kr, l, li, lii, lij, lj, ljj, lk, m, ni, nj
    double precision :: sum, sumdia, sumoff, ade, aee, da, dx, dy, dz, r, r2, &
   & ri2, ri5, rm, rp, w1, w2, w3, w4, w5, w6, w7, enuc, rij, point, const
    integer, dimension (256), save :: jindex
    double precision, dimension (16) :: pja, pjb
    double precision, dimension (45) :: e1b, e2a
    double precision, dimension (171) :: fdummy = 0.d0
    double precision, dimension (2025) :: wjloc = 0.d0
   !
    dx = 0.d0
    dy = 0.d0
    dz = 0.d0
    r2 = 0.d0
    w2 = 0.d0
    w3 = 0.d0
    w4 = 0.d0
    w5 = 0.d0
    w6 = 0.d0
    w7 = 0.d0
    ni = 0
    nj = 0
   !
    if (icalcn /= numcal) then
      icalcn = numcal
      !
      !   SET UP GATHER-SCATTER TYPE ARRAYS FOR USE WITH TWO-ELECTRON
      !   INTEGRALS.  JINDEX ARE THE INDICES OF THE J-INTEGRALS FOR ATOM I
      !               JJNDEX ARE THE INDICES OF THE J-INTEGRALS FOR ATOM J
      !
      m = 0
      do i = 1, 4
        do j = 1, 4
          ij = Min (i, j)
          ji = i + j - ij
          do k = 1, 4
            do l = 1, 4
              m = m + 1
              kl = Min (k, l)
              lk = k + l - kl
              jindex(m) = (ifact(ji)+ij) * 10 + ifact(lk) + kl - 10
            end do
          end do
        end do
      end do
    end if
   !
   !  Put P(A,A) density into array PTOT2
   !
    call chrge_for_MOZYME (ptot, qe)
   !
   !   MODE=1:   ADD TO EXISTING FOCK MATRIX
   !   MODE=0:   CALCULATE FOCK MATRIX STARTING WITH H MATRIX
   !   MODE=-1:  REMOVE TERMS FROM FULL FOCK MATRIX.
   !
    if (mode ==-1) then
      f(1:mpack) = -f(1:mpack)
    end if
    l = 0
    do ii = 1, numat
      q(ii) = tore(nat(ii)) - qe(ii)
      i = nijbo (ii, ii)
      iab = iorbs(ii)
      m = 0
      do j = 1, iab
        do k = 1, iab
          m = m + 1
          jk = Min (j, k)
          kj = k + j - jk
          ptot2(ii, m) = ptot(i+ (kj*(kj-1))/2+jk)
        end do
      end do
    end do
    kr = 0
    ired = 1
    do ii = 1, numat
      calci = (kopt(ired) == ii)
      if (calci .and. ired < numat) then
        ired = ired + 1
      end if
        if (mode == 0) then
          calci = .true.
        end if
        iab = iorbs(ii)
        if (iab /= 0) then
          jred = 1
          iim1 = ii - ione
          do jj = 1, iim1
  !          if (ii == 13 .and. jj == 7) then
  !            continue
  !          end if
            calcj = (kopt(jred) == jj)
            if (calcj .and. jred < numat) then
              jred = jred + 1
            end if
            jba = iorbs(jj)
            if (nijbo(ii, jj) >= 0) then
              if (direct .and. (calci .or. calcj)) then
                call rotate(nat(ii), nat(jj), coord(1, ii), coord(1, jj), wjloc, kr, e1b, e2a, enuc)
              end if
               !
              if (iab > 5 .or. jba > 5) then
                if ( .not. (calci .or. calcj)) then
                  if ( .not. direct) then
                    kr = kr + (iab*(iab+1)) / 2 * (jba*(jba+1)) / 2
                  end if
                else
                  !
                  !   Use "d"-orbital specific code
                  !
                  i = nijbo (ii, ii) + 1
                  j = nijbo (jj, jj) + 1
                  ij = nijbo (ii, jj) + 1
                     !
                  if (direct) then
                    call focd2z (iab, jba, f(i), f(j), f(ij), ptot(i), &
                   & ptot(j), ptot(ij), wjloc, wjloc, i == j, krinc)
                  else
                    call focd2z (iab, jba, f(i), f(j), f(ij), ptot(i), &
                   & ptot(j), ptot(ij), wj(kr+1), wk(kr+1), i == j, kr)
                  end if
                end if
              else if (iab >= 3 .and. jba >= 3) then
                !
                !                         HEAVY-ATOM  - HEAVY-ATOM
                !
                !   EXTRACT COULOMB TERMS
                !
                if (calci .or. calcj) then
                  do i = 1, 16
                    pja(i) = ptot2(ii, i)
                    pjb(i) = ptot2(jj, i)
                  end do
                  !
                  !  COULOMB TERMS
                  !
                  if (ii == jj) then
                    if (direct) then
                      call jab_for_MOZYME (1, 1, pja, pjb, wjloc, f(nijbo(ii, ii)+1), &
                     & fdummy)
                    else
                       call jab_for_MOZYME (1, 1, pja, pjb, wj(kr+1), f(nijbo(ii, ii)+1), &
                     & fdummy)
                    end if
                  else if (direct) then
                    call jab_for_MOZYME (1, 1, pja, pjb, wjloc, f(nijbo(ii, ii)+1), &
                   & f(nijbo(jj, jj)+1))
                  else
                     call jab_for_MOZYME (1, 1, pja, pjb, wj(kr+1), f(nijbo(ii, ii)+1), &
                   & f(nijbo(jj, jj)+1))
                  end if
                  !
                  !  EXCHANGE TERMS
                  !
                  !  EXTRACT INTERSECTION OF ATOMS II AND JJ IN THE SPIN
                  !  DENSITY MATRIX
                  !
                  l = nijbo (ii, jj) + 1
                  if (ii /= jj) then

                    if (direct) then
                      call kab_for_MOZYME (0, 0, ptot(l), wjloc, f(l))
                    else
                      call kab_for_MOZYME (0, 0, ptot(l), wk(kr+1), f(l))
                    end if
                  end if
                end if

                if ( .not. direct) then
                  kr = kr + 100
                end if

              else if (iab >= 3 .and. jba == 1) then
                if (calci .or. calcj) then
                  !
                  !                         LIGHT-ATOM  - HEAVY-ATOM
                  !
                  !   COULOMB TERMS
                  !
                  sumdia = 0.d0
                  sumoff = 0.d0
                  l = nijbo (ii, jj)
                  lj = nijbo (jj, jj) + 1
                  li = nijbo (ii, ii)
                  k = 0


                  if (direct) then


                    do i = 1, 4
                      do j = 1, i - 1
                        li = li + 1
                        k = k + 1
                        f(li) = f(li) + ptot(lj) * wjloc(k)
                        sumoff = sumoff + ptot(li) * wjloc(k)
                      end do
                      li = li + 1
                      k = k + 1
                      f(li) = f(li) + ptot(lj) * wjloc(k)
                      sumdia = sumdia + ptot(li) * wjloc(k)
                    end do
                    f(lj) = f(lj) + sumoff * 2.d0 + sumdia
                    !
                    !  EXCHANGE TERMS
                    !
                    !  EXTRACT INTERSECTION OF ATOMS II AND JJ IN THE SPIN
                    !  DENSITY MATRIX
                    !
                    l = nijbo (ii, jj)
                    k = 0
                    do i = 1, 4
                      sum = 0.d0
                      do j = 1, 4
                        k = k + 1
                        sum = sum + ptot(l+j) * wjloc(jindex(k))
                      end do
                      f(l+i) = f(l+i) - sum * 0.5d0
                    end do
                  else
                        !
                    do i = 1, 4
                      do j = 1, i - 1
                        li = li + 1
                        k = k + 1
                        f(li) = f(li) + ptot(lj) * wj(kr+k)
                        sumoff = sumoff + ptot(li) * wj(kr+k)
                      end do
                      li = li + 1
                      k = k + 1
                      f(li) = f(li) + ptot(lj) * wj(kr+k)
                      sumdia = sumdia + ptot(li) * wj(kr+k)
                    end do
                    f(lj) = f(lj) + sumoff * 2.d0 + sumdia
                    !
                    !  EXCHANGE TERMS
                    !
                    !  EXTRACT INTERSECTION OF ATOMS II AND JJ IN THE SPIN
                    !  DENSITY MATRIX
                    !
                    l = nijbo (ii, jj)
                    k = 0
                    do i = 1, 4
                      sum = 0.d0
                      do j = 1, 4
                        k = k + 1
                        sum = sum + ptot(l+j) * wk(kr+jindex(k))
                      end do
                      f(l+i) = f(l+i) - sum * 0.5d0
                    end do
                  end if
                end if


                if ( .not. direct) then
                  kr = kr + 10
                end if


              else if (jba >= 3 .and. iab == 1) then
                if (calci .or. calcj) then
                  !
                  !                         HEAVY-ATOM - LIGHT-ATOM
                  !
                  !   COULOMB TERMS
                  !
                  sumdia = 0.d0
                  sumoff = 0.d0
                  l = nijbo (ii, jj)
                  lj = nijbo (jj, jj)
                  li = nijbo (ii, ii) + 1
                  k = 0

                  if (direct) then

                    do i = 1, 4
                      do j = 1, i - 1
                        k = k + 1
                        lj = lj + 1
                        f(lj) = f(lj) + ptot(li) * wjloc(k)
                        sumoff = sumoff + ptot(lj) * wjloc(k)
                      end do
                      lj = lj + 1
                      k = k + 1
                      f(lj) = f(lj) + ptot(li) * wjloc(k)
                      sumdia = sumdia + ptot(lj) * wjloc(k)
                    end do !
                    f(li) = f(li) + sumoff * 2.d0 + sumdia
                    !
                    !  EXCHANGE TERMS
                    !
                    !  EXTRACT INTERSECTION OF ATOMS II AND JJ IN THE SPIN
                    !  DENSITY MATRIX
                    !
                    l = nijbo (ii, jj)
                    k = 0
                    do i = 1, 4
                      sum = 0.d0
                      do j = 1, 4
                        k = k + 1
                        sum = sum + ptot(l+j) * wjloc(jindex(k))
                      end do
                      f(l+i) = f(l+i) - sum * 0.5d0
                    end do
                  else
                    do i = 1, 4
                      do j = 1, i - 1
                        k = k + 1
                        lj = lj + 1
                        f(lj) = f(lj) + ptot(li) * wj(kr+k)
                        sumoff = sumoff + ptot(lj) * wj(kr+k)
                      end do
                      lj = lj + 1
                      k = k + 1
                      f(lj) = f(lj) + ptot(li) * wj(kr+k)
                      sumdia = sumdia + ptot(lj) * wj(kr+k)
                    end do
                    f(li) = f(li) + sumoff * 2.d0 + sumdia
                    !
                    !  EXCHANGE TERMS
                    !
                    !  EXTRACT INTERSECTION OF ATOMS II AND JJ IN THE SPIN
                    !  DENSITY MATRIX
                    !
                    l = nijbo (ii, jj)
                    k = 0
                    do i = 1, 4
                      sum = 0.d0
                      do j = 1, 4
                        k = k + 1
                        sum = sum + ptot(l+j) * wk(kr+jindex(k))
                      end do
                      f(l+i) = f(l+i) - sum * 0.5d0
                    end do
                  end if
                end if

                if ( .not. direct) then
                  kr = kr + 10
                end if

              else if (iab == 1 .and. jba == 1) then
                if (calci .or. calcj) then
                  !
                  !                         LIGHT-ATOM - LIGHT-ATOM
                  !
                  lii = nijbo (ii, ii) + 1
                  lij = nijbo (ii, jj) + 1
                  ljj = nijbo (jj, jj) + 1
                     !
                  if (direct) then
                        !
                    f (lii) = f (lii) + ptot (ljj) * wjloc (1)!
                    if (ii /= jj) then
                      f(ljj) = f(ljj) + ptot(lii) * wjloc(1)
                      f(lij) = f(lij) - ptot(lij) * wjloc(1) * 0.5d0
                    end if
                  else

                    f(lii) = f(lii) + ptot(ljj) * wj(kr+1)
                    if (ii /= jj) then
                      f(ljj) = f(ljj) + ptot(lii) * wj(kr+1)
                      f(lij) = f(lij) - ptot(lij) * wk(kr+1) * 0.5d0
                    end if
                  end if
                end if
                if ( .not. direct) then
                  kr = kr + 1
                end if
              end if
            else
              !
              !   Use point-charge approximation
              !
              i1 = nijbo (ii, ii)
              j1 = nijbo (jj, jj)

              if (iorbs(ii)*iorbs(jj) > 0) then

                if (calci .or. calcj) then

                  if (semidr) then
                    dx = coord(1, ii) - coord(1, jj)
                    dy = coord(2, ii) - coord(2, jj)
                    dz = coord(3, ii) - coord(3, jj)

                    r2 = dx * dx + dy * dy + dz * dz
                    ni = nat(ii)
                    nj = nat(jj)
                    aee = 0.5d0 / am(ni) + 0.5d0 / am(nj)
                    if (l_feather) then
                      rij = sqrt(r2)
                      call to_point(rij, point, const)
                      w1 = ev / Sqrt (r2/(a0**2)+aee**2)
                      w1 = w1*const + (1.d0 - const)*point
                    else
                      w1 = ev / Sqrt (r2/(a0**2)+aee**2)
                    end if
                  else
                    w1 = wj(kr+1)
                  end if
                  !
                  !   MONOPOLE
                  !
                  do i = 1, iorbs(ii)
                    i1 = i1 + i
                    f(i1) = f(i1) + qe(jj) * w1
                  end do
                  do j = 1, iorbs(jj)
                    j1 = j1 + j
                    f(j1) = f(j1) + qe(ii) * w1
                  end do
                  i1 = nijbo (ii, ii)
                  j1 = nijbo (jj, jj)
                end if

                if ( .not. semidr) then
                  kr = kr + 1
                end if
                  !
                if (nijbo(ii, jj) ==-2) then
                  !
                  !   DIPOLE, IF NEEDED
                  !
                  if ((calci .or. calcj) .and. semidr) then
                    r = Sqrt (r2)
                    dx = dx / r
                    dy = dy / r
                    dz = dz / r
                    if (Abs (dz) > 0.99999999d0) then
                      dz = Sign (1.d0, dz)
                    end if

                    if (iorbs(ii) > 1) then

                      da = dd(ni)
                      ade = 0.5d0 / ad(ni) + 0.5d0 / am(nj)
                      rp = Sqrt ((r/a0+da)**2+ade**2)
                      rm = Sqrt ((r/a0-da)**2+ade**2)
                      ri2 = ev * (0.5d0/rp-0.5d0/rm)
                      if (l_feather) then
                        call to_point(r, point, const)
                        ri2 = ri2*const
                      end if

                      w5 = ri2 * dx
                      w6 = ri2 * dy
                      w7 = ri2 * dz
                    end if

                    if (iorbs(jj) > 1) then

                      da = dd(nj)
                      ade = 0.5d0 / am(ni) + 0.5d0 / ad(nj)
                      rp = Sqrt ((r/a0+da)**2+ade**2)
                      rm = Sqrt ((r/a0-da)**2+ade**2)
                      ri5 = -ev * (0.5d0/rp-0.5d0/rm)
                      if (l_feather) then
                        call to_point(r, point, const)
                        ri5 = ri5*const
                      end if
                      w2 = ri5 * dx
                      w3 = ri5 * dy
                      w4 = ri5 * dz
                    end if
                  end if

                  if (iorbs(ii) > 1) then
                    if (iorbs(jj) > 1) then
                      if (calci .or. calcj) then
                        if ( .not. semidr) then
                          w2 = wj(kr+1)
                          w3 = wj(kr+2)
                          w4 = wj(kr+3)
                          w5 = wj(kr+4)
                          w6 = wj(kr+5)
                          w7 = wj(kr+6)
                        end if
                        f(j1+2) = f(j1+2) + qe(ii) * w2
                        f(j1+4) = f(j1+4) + qe(ii) * w3
                        f(j1+7) = f(j1+7) + qe(ii) * w4
                        f(i1+2) = f(i1+2) + qe(jj) * w5
                        f(i1+4) = f(i1+4) + qe(jj) * w6
                        f(i1+7) = f(i1+7) + qe(jj) * w7

                        f(j1 +1) = f(j1 +1) + ptot(i1+2) * w5 *2
                        f(j1 +3) = f(j1 +3) + ptot(i1+2) * w5 *2
                        f(j1 +6) = f(j1 +6) + ptot(i1+2) * w5 *2
                        f(j1+10) = f(j1+10) + ptot(i1+2) * w5 *2

                        f(j1 +1) = f(j1 +1) + ptot(i1+4) * w6 *2
                        f(j1 +3) = f(j1 +3) + ptot(i1+4) * w6 *2
                        f(j1 +6) = f(j1 +6) + ptot(i1+4) * w6 *2
                        f(j1+10) = f(j1+10) + ptot(i1+4) * w6 *2

                        f(j1 +1) = f(j1 +1) + ptot(i1+7) * w7 *2
                        f(j1 +3) = f(j1 +3) + ptot(i1+7) * w7 *2
                        f(j1 +6) = f(j1 +6) + ptot(i1+7) * w7 *2
                        f(j1+10) = f(j1+10) + ptot(i1+7) * w7 *2

                        f(i1 +1) = f(i1 +1) + ptot(j1+2) * w2 *2
                        f(i1 +3) = f(i1 +3) + ptot(j1+2) * w2 *2
                        f(i1 +6) = f(i1 +6) + ptot(j1+2) * w2 *2
                        f(i1+10) = f(i1+10) + ptot(j1+2) * w2 *2

                        f(i1 +1) = f(i1 +1) + ptot(j1+4) * w3 *2
                        f(i1 +3) = f(i1 +3) + ptot(j1+4) * w3 *2
                        f(i1 +6) = f(i1 +6) + ptot(j1+4) * w3 *2
                        f(i1+10) = f(i1+10) + ptot(j1+4) * w3 *2

                        f(i1 +1) = f(i1 +1) + ptot(j1+7) * w4 *2
                        f(i1 +3) = f(i1 +3) + ptot(j1+7) * w4 *2
                        f(i1 +6) = f(i1 +6) + ptot(j1+7) * w4 *2
                        f(i1+10) = f(i1+10) + ptot(j1+7) * w4 *2
                      end if

                      if ( .not. semidr) then
                        kr = kr + 6
                      end if
                    else
                      if (calci .or. calcj) then
                        if ( .not. semidr) then
                          w5 = wj(kr+1)
                          w6 = wj(kr+2)
                          w7 = wj(kr+3)
                        end if
                        f(i1+2) = f(i1+2) + qe(jj) * w5
                        f(i1+4) = f(i1+4) + qe(jj) * w6
                        f(i1+7) = f(i1+7) + qe(jj) * w7

                        f(j1 +1) = f(j1 +1) + ptot(i1+2) * w5 *2

                        f(j1 +1) = f(j1 +1) + ptot(i1+4) * w6 *2

                        f(j1 +1) = f(j1 +1) + ptot(i1+7) * w7 *2
                      end if
                      if ( .not. semidr) then
                        kr = kr + 3
                      end if
                    end if
                  else if (iorbs(jj) > 1) then
                    if (calci .or. calcj) then
                      if ( .not. semidr) then
                        w2 = wj(kr+1)
                        w3 = wj(kr+2)
                        w4 = wj(kr+3)
                      end if
                      f(j1+2) = f(j1+2) + qe(ii) * w2
                      f(j1+4) = f(j1+4) + qe(ii) * w3
                      f(j1+7) = f(j1+7) + qe(ii) * w4

                      f(i1 +1) = f(i1 +1) + ptot(j1+2) * w2 *2

                      f(i1 +1) = f(i1 +1) + ptot(j1+4) * w3 *2

                      f(i1 +1) = f(i1 +1) + ptot(j1+7) * w4 *2
                    end if
                    if ( .not. semidr) then
                      kr = kr + 3
                    end if
                  end if
                end if
              end if
            end if
          end do
          if (.not. direct) then
            i = nijbo (ii, ii) + 1
            ilim = (iab*(iab+1)) / 2
            call fock1_for_MOZYME (f(i), ptot(i), wj(kr+1), kr, iab, ilim)
          end if
        end if
    end do
    if (direct) then
      kr = 0
      ired = 1
      do ii = 1, numat
          iab = iorbs(ii)
          if (iab /= 0) then
            i = nijbo (ii, ii) + 1
            ilim = (iab*(iab+1)) / 2
            call fock1_for_MOZYME (f(i), ptot(i), wj(kr+1), kr, iab, ilim)
          end if
      end do
    end if
   !
    if (mode == -1) f = -f
   ! The following routine adds the dielectric correction to F.
    if (useps .and. mode == 0) call addfckz()
end subroutine fz2n
subroutine focd2z (iab, jba, fii, fjj, fij, pii, pjj, pij, wj, wk, &
     & diagonal, kr)
   !
   !.. Implicit Declarations ..
    implicit none
   !
   !.. Formal Arguments ..
    logical, intent (in) :: diagonal
    integer, intent (in) :: iab, jba
    integer, intent (inout) :: kr
    double precision, dimension ((iab*(iab+1))/2*(jba*(jba+1))/2), &
         & intent (in) :: wj, wk
    double precision, dimension ((iab*(iab+1))/2), intent (in) :: pii
    double precision, dimension ((iab*(iab+1))/2), intent (inout) :: fii
    double precision, dimension ((jba*(jba+1))/2), intent (in) :: pjj
    double precision, dimension ((jba*(jba+1))/2), intent (inout) :: fjj
    double precision, dimension (iab*jba), intent (in) :: pij
    double precision, dimension (iab*jba), intent (inout) :: fij
!.
    integer :: i, ij, ik, il, j, jk, jl, k, ka, kc, kl, l, loop
    double precision :: a, aa, bb
   !***********************************************************************
   !
   ! FOCKD2 FORMS THE TWO-ELECTRON TWO-CENTER REPULSION PART OF THE FOCK
   ! MATRIX
   ! ON INPUT  PTOT = TOTAL DENSITY MATRIX.
   !           P    = ALPHA OR BETA DENSITY MATRIX.
   !           W    = TWO-ELECTRON INTEGRAL MATRIX.
   !
   !  ON OUTPUT F   = PARTIAL FOCK MATRIX
   !***********************************************************************
    loop = 0
    do i = 1, iab
      ka = (i*(i-1)) / 2
      aa = 2.0d00
      do j = 1, i
        if (i == j) then
          aa = 1.0d00
        end if
        ij = ka + j
        do k = 1, jba
          kc = (k*(k-1)) / 2
          bb = 2.0d00
          do l = 1, k
            if (k == l) then
              bb = 1.0d00
            end if
            kl = kc + l
            loop = loop + 1
            a = wj(loop)
            fii(ij) = fii(ij) + bb * a * pjj(kl)
            if ( .not. diagonal) then
              fjj(kl) = fjj(kl) + aa * a * pii(ij)
              a = wk(loop) * aa * bb * 0.125d0
              ik = (i-1) * jba + k
              il = (i-1) * jba + l
              jk = (j-1) * jba + k
              jl = (j-1) * jba + l
              fij(ik) = fij(ik) - a * pij(jl)
              fij(il) = fij(il) - a * pij(jk)
              fij(jk) = fij(jk) - a * pij(il)
              fij(jl) = fij(jl) - a * pij(ik)
            end if
          end do
        end do
      end do
    end do
    kr = kr + loop
end subroutine focd2z

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine Details_of_cursor_point(unit, mouseevent, keystate, MouseXpos,MouseYpos)
!
! Generate and print details of a point on a contour-map.  The point is selected by a mouse-click
! on the map
!
  use common_common, only : line, xscale, yscale, xoffset, yoffset, &
  top_l, top_r, bottom_l, grid, isurf, phonon, units
  USE IFQWIN
  INTEGER unit
  INTEGER mouseevent
  INTEGER keystate
  INTEGER MouseXpos
  INTEGER MouseYpos
  real :: xx, yy, xyz(3), sum
  integer :: status, npoint = -1
  character :: letter*1, num*3
  save :: npoint
  npoint = npoint + 1  
  xx = 0.5*(MouseXpos - xoffset)/xscale 
  yy = 0.5*(MouseYpos - yoffset)/yscale 
  if (xx > 1.0 .or. xx < 0.0 .or. yy > 1.0 .or. yy < 0.0 ) then
    line = "EXIT"
    npoint = -1
    return
  end if
  status = SETACTIVEQQ (10) ! unit = 10
  if (npoint > 25) then
    letter = char(ichar("A") + npoint - 26)
  else
    letter = char(ichar("a") + npoint)
  end if
  write(line,'(a)')letter
  call graphics(2.0*xx - 0.01, 2.0*yy - 0.02, 96)
  xyz = top_l - xx*(top_l - top_r) - yy*(top_l - bottom_l) 
  sum = grid(81 - nint(80.0*xx),81 - nint(80.0*yy), isurf)
  if (phonon) then
    num = "7.1"
  else
     num = "9.4"
  end if
  write(line,'(a,f6.2,",",f6.2,",",f6.2,a,f'//num//',a)') &
  "     Point "//letter//" = (", xyz, ")   Value:", sum, units
  status = SETACTIVEQQ (6)
  write(6,*)trim(line)
  return
end subroutine Details_of_cursor_point

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine cnvg(pnew, p, p1, niter, pl)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : norbs, numcal, keywrd, mpack, method_indo
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: niter
      double precision , intent(out) :: pl
      double precision , intent(inout) :: pnew(mpack)
      double precision , intent(inout) :: p(mpack)
      double precision , intent(inout) :: p1(norbs)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: icalcn, ii, k, i, ie, j
      double precision :: rhfuhf, faca, damp, facb, fac, sum1, a, sa, sum2, sum0, &
        sum
      logical :: extrap

      save rhfuhf, icalcn
!-----------------------------------------------
!***********************************************************************
!
!  CNVG IS A TWO-POINT INTERPOLATION ROUTINE FOR SPEEDING CONVERGENCE
!       OF THE DENSITY MATRIX.
!
! ON OUTPUT P      = NEW DENSITY MATRIX
!           P1     = DIAGONAL OF OLD DENSITY MATRIX
!           PL     = LARGEST DIFFERENCE BETWEEN OLD AND NEW DENSITY
!                    MATRIX DIAGONAL ELEMENTS
!***********************************************************************
      data icalcn/ 0/
      if (icalcn /= numcal) then
        icalcn = numcal
        if (index(keywrd,' UHF') /= 0) then
          rhfuhf = 1.d0
        else
          rhfuhf = 2.d0
        end if
      end if
      pl = 0.0d0
      faca = 0.0d0
      damp = 1.D10
      if (niter > 3) damp = 0.05d0
      if (method_indo) then
        if (niter > 40) damp = 0.01D0
        if (niter > 200) damp = 0.002D0
        if (niter > 350) damp = 0.001D0
      end if
      facb = 0.0d0
      fac = 0.0d0
      ii = mod(niter,3)
      extrap = ii /= 0
      sum1 = 0.d0
      k = 0
      do i = 1, norbs
        k = k + i
        a = pnew(k)
        sum1 = sum1 + a
        sa = Abs (a - p(k))
        if (sa > pl) then
          pl = sa
        end if
        if ( .not. extrap) then
          faca = faca + sa ** 2
          facb = facb + (a - 2.d0*p(k) + p1(i)) ** 2
        end if
        p1(i) = p(k)
        p(k) = a
      end do
      if (facb > 1.d-10 .and. faca < (100.d0*facb)) then
        fac = Sqrt (faca/facb)
      end if
      ie = 0
      sum2 = 0.d0
      do i = 1, norbs
        ii = i - 1
        do j = 1, ii
          ie = ie + 1
          a = pnew(ie)
          p(ie) = a + fac*(a-p(ie))
          pnew(ie) = p(ie)
        end do
        ie = ie + 1
        if (Abs (p(ie) - p1(i)) > damp) then
          p(ie) = p1(i) + Sign (damp, p(ie) - p1(i))
        else
          p(ie) = p(ie) + fac * (p(ie) - p1(i))
        end if
        p(ie) = Min (rhfuhf, Max (p(ie), 0.d0))
        sum2 = sum2 + p(ie)
        pnew(ie) = p(ie)
      end do
   !
   !   RE-NORMALIZE IF ANY DENSITY MATRIX ELEMENTS HAVE BEEN TRUNCATED
   !
      sum0 = sum1
      do
        if (sum2 > 1.d-3) then
          sum = sum1/sum2
        else
          sum = 0.d0
        end if
        sum1 = sum0
        if (sum2 < 1.d-3 .or. Abs (sum-1.d0) < 1.d-5) exit
        sum2 = 0.d0
        do i = 1, norbs
          j = (i*(i + 1))/2
           !
           !   ADD ON A SMALL NUMBER IN CASE AN OCCUPANCY IS EXACTLY ZERO
           !
          p(j) = p(j)*sum + 1.d-20
          p(j) = Max (p(j), 0.d0)
           !
           !  SET UP RENORMALIZATION OVER PARTLY OCCUPIED M.O.'S ONLY.  FULL M.O.'S
           !  CAN'T BE FILLED ANY MORE
           !
          if (p(j) > rhfuhf) then
            p(j) = rhfuhf
            sum1 = sum1 - rhfuhf
          else
            sum2 = sum2 + p(j)
          end if
          pnew(j) = p(j)
        end do
      end do
      end subroutine cnvg

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine vecprt_for_MOZYME(aa, numm)
    use molkst_C, only: mpack, numat, gui
    use chanel_C, only: iw
    use elemts_C, only: elemnt
    use common_arrays_C, only : nat, nfirst, nlast, l_atom
    implicit none
    double precision, dimension (mpack), intent (in) :: aa
    integer, intent (in) :: numm
    integer, parameter :: maxarr = 200
!
    integer :: i, ii, ij, j, jhi, jj, jlo, k, kk, l, limit, linear, ll, m, ma, &
   & n, na, numb
    double precision :: fact, sumax
    character (len=2), dimension (9), save :: atorbs
    character (len=2), dimension (maxarr) :: itext, jtext
    character (len=6), dimension (21) :: line
    integer, dimension (maxarr) :: natom
    double precision, dimension (:), allocatable :: a
    integer, external :: ijbo
    data atorbs / " S", "PX", "PY", "PZ", "X2", "XZ", "Z2", "YZ", "XY" /
!
    l = 0
    ll = 0
    numb = Abs (numm)
    if (numb > maxarr) then
      write (iw,'(/10x,a,i5)') "VECPRT CAN ONLY PRINT ARRAYS OF SIZE LESS THAN", maxarr
      write (iw,'(10x,a,i5)') "AN ATTEMPT WAS MADE TO PRINT AN ARRAY OF SIZE ", numb
      numb = maxarr
    end if
    linear = (numb*(numb+1)) / 2
    allocate (a(linear))
   !
   !    Decide what type of array to print.  Options are:
   !        (1)   Over atoms
   !        (2)   Over atomic orbitals
   !        (3)   All other types.
   !
    if (numat /= 0 .and. numat == numm) then
      !
      !    OPTION (1):  PRINT OVER ATOM COUNT
      !
      j = 0
      l = 0
      do i = 1, numb
        if (l_atom(i)) then
          j = j + 1
          itext(j) = "  "
          jtext(j) = elemnt(nat(i))
          if (gui) then
            natom(j) = j
          else
            natom(j) = i
          end if
          do k = 1, i
            if (l_atom(k)) then
              l = l + 1
              a(l) = aa((i*(i - 1))/2 + k)
            end if
          end do
        end if
      end do
      numb = j
      linear = l
    else if (numat /= 0 .and. nlast(numat) == numm) then
      !
      !   OPTION (2): PRINT OVER ATOMIC ORBITALS.  Before
      !   printing, the array has to be put into standard form.
      !
      do i = 1, linear
        a(i) = 0.d0
      end do
      ij = 0
      do i = 1, numat
        do j = 1, i - 1
          if (ijbo(i, j) >= 0) then
            ij = ij + 1
            l = ijbo (i, j)
            do ii = nfirst(i), nlast(i)
              do jj = nfirst(j), nlast(j)
                l = l + 1
                ll = (ii*(ii-1)) / 2 + jj
                if (ll <= linear) a(ll) = aa(l)
              end do
            end do
          end if
        end do
        ij = ij + 1
        l = ijbo (i, i)
        do ii = nfirst(i), nlast(i)
          do jj = nfirst(i), ii
            l = l + 1
            ll = (ii*(ii-1)) / 2 + jj
            if (ll <= linear)a(ll) = aa(l)
          end do
        end do
        if (ll == linear) exit
      end do
      outer_loop: do i = 1, numat
        jlo = nfirst(i)
        jhi = nlast(i)
        l = nat(i)
        k = 0
        do j = jlo, jhi
          k = k + 1
          itext(j) = atorbs(k)
          jtext(j) = elemnt(l)
          natom(j) = i
          if (j == numb) exit outer_loop
        end do
      end do outer_loop
    else
      !
      !    OPTION (3):  PRINT A GENERIC ARRAY.
      !
      do i = 1, numb
        itext (i) = "  "
        jtext (i) = "  "
        natom(i) = i
      end do
      do i = 1, linear
        a(i) = aa(i)
      end do
    end if
   !
   !   Scale diagonal terms so that they will always be printable.
   !
    sumax = 1.d0
    do i = 1, numb
      sumax = Max (Abs (a((i*(i+1))/2)), sumax)
    end do
    i = Int (Log10(sumax))
    if (i == 1 .or. i == 2) then
      i = 0
    end if
    fact = 10.d0 ** (-i)
    if (Abs (fact-1.d0) > 0.001d0) then
      write (iw, "(/10x,A,F16.6)") "Diagonal Terms should be Multiplied by", 1.d0 / &
     & fact
      do i = 1, numb
        a((i*(i+1))/2) = a((i*(i+1))/2) * fact
      end do
    end if
    do i = 1, 21
      line (i) = "------"
    end do
    limit = (numb*(numb+1)) / 2
    kk = 8
    na = 1
    do
      ll = 0
      m = Min ((numb+1-na), 6)
      ma = 2 * m + 1
      m = na + m - 1
      !
10000 format (/,/,13x,10(1x,a2,1x,a2,i3,2x))
      write (iw, 10000) (itext(i), jtext(i), natom(i), i=na, m)
10010 format (" ", 21 a6)
      write (iw, 10010) (line(k), k=1, ma)
      do i = na, numb
        ll = ll + 1
        k = (i*(i-1)) / 2
        l = Min ((k+m), (k+i))
        k = k + na
        if ((kk+ll) > 50) then
          write (iw, 10000) (itext(n), jtext(n), natom(n), n=na, m)
          write (iw, 10010) (line(n), n=1, ma)
          kk = 4
          ll = 0
        end if
10030   format (' ',a2,1x,a2,i5,10f11.6)
        write (iw, 10030) itext(i), jtext(i), natom(i), (a(n), n=k, l)
      end do
      if (l >= limit) exit
      kk = kk + ll + 4
      na = m + 1
      if ((kk+numb+1-na) > 50) then
        kk = 4
      end if
    end do
    deallocate (a)
    return
!
end subroutine vecprt_for_MOZYME

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine fock1_for_MOZYME (f, ptot, w, kr, iab, ilim)
    implicit none
    integer, intent (in) :: iab, ilim
    integer, intent (inout) :: kr
    double precision, dimension ((iab*(iab+1))/2), intent (in) :: ptot
    double precision, dimension ((iab*(iab+1))/2), intent (inout) :: f
    double precision, dimension (ilim, ilim), intent (in) :: w
!
    integer :: i, ij, ijp, ijw, ikw, im, ip, j, jlw, jm, jp, k, klw, l
    double precision :: sum
   ! *********************************************************************
   !
   ! *** COMPUTE THE REMAINING CONTRIBUTIONS TO THE ONE-CENTER ELEMENTS.
   !
   ! *********************************************************************
   !
   !   One-center coulomb and exchange terms for atom II.
   !
   !  F(i,j)=F(i,j)+sum(k,l)((PA(k,l)+PB(k,l))*<i,j|k,l>
   !                        -(PA(k,l)        )*<i,k|j,l>), k,l on atom II.
   !
    do i = 1, iab
      do j = 1, i
         !
         !    Address in 'F'
         !
        ij = (i*(i-1)) / 2 + j
         !
         !    'J' Address IJ in W
         !
        ijw = (i*(i-1)) / 2 + j
        sum = 0.d0
        do k = 1, iab
          do l = 1, iab
            ip = Max (k, l)
            jp = Min (k, l)
               !
               !    Address in 'P'
               !
            ijp = (ip*(ip-1)) / 2 + jp
               !
               !    'J' Address KL in W
               !
            im = Max (k, l)
            jm = Min (k, l)
            klw = (im*(im-1)) / 2 + jm
               !
               !    'K' Address IK in W
               !
            im = Max (k, j)
            jm = Min (k, j)
            ikw = (im*(im-1)) / 2 + jm
               !
               !    'K' Address JL in W
               !
            im = Max (l, i)
            jm = Min (l, i)
            jlw = (im*(im-1)) / 2 + jm
               !
               !   The term itself
               !
            sum = sum + ptot(ijp) * w(ijw, klw) - 0.5d0 * ptot(ijp) * w &
           & (ikw, jlw)
          end do
        end do
        f(ij) = f(ij) + sum
      end do
    end do
    kr = kr + ilim ** 2
end subroutine fock1_for_MOZYME

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine buildf (f, partf, mode)
    use molkst_C, only: numat, mpack, id
    use common_arrays_C, only : w, h, wk
    implicit none
    integer, intent (in) :: mode
    double precision, dimension (mpack), intent (in) :: partf
    double precision, dimension (mpack), intent (inout) :: f
    integer :: alloc_stat
    double precision, dimension(:), allocatable :: q, qe
    double precision, dimension(:,:), allocatable :: ptot2
   !
   !  MODE= 1:  Add on terms to a partial Fock matrix to make it complete.
   !  MODE= 0:  Build a Fock matrix, starting with the one-electron matrix.
   !  MODE=-1:  Remove terms from a complete Fock matrix to make a partial.
   !
    allocate (q(numat), qe(numat), ptot2(numat,81), stat=alloc_stat)
    if (alloc_stat /= 0) then
       call memory_error ("buildf")
       goto 100
    end if
    if (mode ==-1) f(:mpack) = partf(:mpack) - h(:mpack)
    if (mode == 0) f(:mpack) =                 h(:mpack)
    if (mode == 1) f(:mpack) = partf(:mpack) + h(:mpack)
    if (id == 0) then
      !
      !  Discrete system
      !
      call fock2z (f, q, qe, w, w, ptot2, mode, 1)
    else
      !
      !  A solid (polymer, layer, or 3-D solid)
      !
      call fock2z (f, q, qe, w, wk, ptot2, mode, 0)
    end if
100 continue
    deallocate (q, qe, ptot2)
end subroutine buildf

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      logical function myword (keywrd, testwd)
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      character , intent(inout) :: keywrd*(*)
      character , intent(in) :: testwd*(*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: j, k, len_key
      logical :: quote
      character :: key*3000
!-----------------------------------------------
      myword = .FALSE.
      len_key = len_trim(keywrd)
      key = keywrd(:len_key)
!
!      Remove all quoted text from "key" so that, when searching for a keyword, index will not
!      look at any text that is inside quotation marks.
!
      k = 0
      do
        k = k + 1
        if (k > len_key) exit
        if (key(k:k) == '"') then
          j = k
          do
            j = j + 1
            if (j > len_key) exit
            if (key(j:j) == '"') exit
          end do
          key(k:j) = " "
          k = j + 1
        end if
      end do
!
!
!  If the keyword containes quoted text, then ignore text between quotation marks.
!  quote starts off .FALSE.
!  quote is turned .TRUE. if a quotation mark, '"', is found
!  quote is turned .FALSE. when another quotation mark is found.
      quote = .false.
   10 continue
      j = index(key,testwd)
      if (j /= 0) then
!
!  Keyword found.  Now delete keyword in its entirety
!
        key(j:j+1) = " "
20      continue
        do while(keywrd(j:j) == ' ')
          j = j + 1
        end do
        myword = .TRUE.
        do k = j, len_key
          if (keywrd(k:k) == '"') quote = (.not. quote)
          if (.not. quote) then
            if (keywrd(k:k)=='=' .or. keywrd(k:k)==' ') then
!
!     CHECK FOR ATTACHED '=' SIGN
!
              j = k
              if (keywrd(j:j) == '=') go to 50
!
!     CHECK FOR SEPARATED '=' SIGN
!
              do j = k + 1, len_key
                if (keywrd(j:j) == '=') go to 50
                if (keywrd(j:j) /= ' ') go to 10
              end do
!
!    THERE IS NO '=' SIGN ASSOCIATED WITH THIS KEYWORD
!
              go to 10
     50       continue
              keywrd(j:j) = ' '
!
!   THERE MUST BE A NUMBER AFTER THE '=' SIGN, SOMEWHERE
!
              go to 20
            end if
          end if
          keywrd(k:k) = ' '
        end do
      end if
      return
      end function myword

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

    subroutine fock2(f, ptot, p, w, wj, wk, numat, nfirst, nlast, mode)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : numcal, norbs, mpack, n2elec, id, numat_ref => numat
      use cosmo_C, only : useps

!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: numat, mode
      integer  :: nfirst(numat_ref)
      integer  :: nlast(numat_ref)
      double precision  :: f(mpack)
      double precision , intent(in) :: ptot(mpack)
      double precision  :: p(mpack)
      double precision  :: w(n2elec)
      double precision , intent(in) :: wj(n2elec)
      double precision , intent(in) :: wk(n2elec)


!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(:), allocatable :: ifact, i1fact
      double precision, dimension(:,:), allocatable  :: ptot2
      integer :: ione, icalcn
      integer , dimension(256) :: jindex
      integer :: i, m, j, ij, ji, k, ik, l, kl, lk, jl, i1, ia, ib, jk, kj, kk&
        , ii, iminus, jj, ja, jb, ll, j1, ka, kb, kc, il
      double precision, dimension(81) :: pk
      double precision, dimension(16) :: pja, pjb
      double precision :: sumdia, sumoff, sum, aa, bb, aj, ak, a
      logical :: lid, deriv

      save ifact, i1fact, ione, lid, icalcn, jindex, ptot2
!-----------------------------------------------
!***********************************************************************
!
! FOCK2 FORMS THE TWO-ELECTRON TWO-CENTER REPULSION PART OF THE FOCK
! MATRIX
! ON INPUT  PTOT = TOTAL DENSITY MATRIX.
!           P    = ALPHA OR BETA DENSITY MATRIX.
!           W    = TWO-ELECTRON INTEGRAL MATRIX.
!
!  ON OUTPUT F   = PARTIAL FOCK MATRIX
!***********************************************************************
      data icalcn/ 0/
      deriv = (numat < 0)
      numat = abs(numat)
      if (numat == 0) then
        if (allocated(ptot2))  deallocate(ptot2)
        if (allocated(ifact))  deallocate(ifact)
        if (allocated(i1fact)) deallocate(i1fact)
         return
      end if
      if (icalcn /= numcal) then
        if (allocated(ptot2))  deallocate(ptot2)
        if (allocated(ifact))  deallocate(ifact)
        if (allocated(i1fact)) deallocate(i1fact)
        allocate(ptot2(numat,81), ifact(3 + norbs), i1fact(3 + norbs))
        icalcn = numcal
!
!   SET UP ARRAY OF LOWER HALF TRIANGLE INDICES (PASCAL'S TRIANGLE)
!
        do i = 1, norbs
          ifact(i) = (i*(i - 1))/2
          i1fact(i) = ifact(i) + i
        end do
!
!   SET UP GATHER-SCATTER TYPE ARRAYS FOR USE WITH TWO-ELECTRON
!   INTEGRALS.  JINDEX ARE THE INDICES OF THE J-INTEGRALS FOR ATOM I
!   INTEGRALS.  JJNDEX ARE THE INDICES OF THE J-INTEGRALS FOR ATOM J
!               KINDEX ARE THE INDICES OF THE K-INTEGRALS
!
        m = 0
        do i = 1, 4
          do j = 1, 4
            ij = min(i,j)
            ji = i + j - ij
            do k = 1, 4
              ik = min(i,k)
              do l = 1, 4
                m = m + 1
                kl = min(k,l)
                lk = k + l - kl
                jl = min(j,l)
                jindex(m) = (ifact(ji)+ij)*10 + ifact(lk) + kl - 10
              end do
            end do
          end do
        end do
        l = 0
        do i = 1, 4
          i1 = (i - 1)*4
          if (i > 0) then
            l = i + l
          end if
        end do
        lid = id == 0
        ione = 1
        if (id /= 0) ione = 0
!
!      END OF INITIALIZATION
!
      end if
!
!     START OF MNDO, AM1, OR PM3 OPTION
!
      l = 0
      do i = 1, numat
        ia = nfirst(i)
        ib = nlast(i)
        m = 0
        do j = ia, ib
          do k = ia, ib
            m = m + 1
            jk = min(j,k)
            kj = k + j - jk
            jk = jk + (kj*(kj - 1))/2
            ptot2(i,m) = ptot(jk)
          end do
        end do
      end do
      kk = 0
      do ii = 1, numat
        ia = nfirst(ii)
        ib = nlast(ii)
!
!  IF NUMAT=2 THEN WE ARE IN A DERIVATIVE IN A SOLID STATE OR IN A MOLECULE CALCULATION
!
        if (deriv) then
          iminus = ii - 1
        else
          iminus = ii - ione
        end if
        do jj = 1, iminus
          ja = nfirst(jj)
          jb = nlast(jj)
          if (lid) then    !  System does not use periodic boundary conditions
            if (ib - ia >= 6 .or. jb - ja >= 6) then
              call fockdorbs(ia, ib, ja, jb, f, p, ptot, w, kk, ifact)

            else if (ib - ia >= 3 .and. jb - ja >= 3) then
!
!                         HEAVY-ATOM  - HEAVY-ATOM
!
!   EXTRACT COULOMB TERMS
!
              pja = ptot2(ii,:16)
              pjb = ptot2(jj,:16)
!
!  COULOMB TERMS
!
              call jab (ia, ja, pja, pjb, w(kk+1), f)
!
!  EXCHANGE TERMS
!
!
!  EXTRACT INTERSECTION OF ATOMS II AND JJ IN THE SPIN DENSITY MATRIX
!
!  The following loop had been written in a more compact style, but
!  this had caused problems with the INTEL compiler in RELEASE mode when QuickWin was used
!
              l = 1
              do i = ia, ib
                i1 = ifact(i) + ja
                do j = l, l + 3
                  pk(j) = p(i1)
                  i1 = i1 + 1
                end do
                l = 4 + l
              end do
              call kab (ia, ja, pk, w(kk+1), f)
              kk = kk + 100
            else if (ib - ia >= 3 .and. ja == jb) then
!
!                         LIGHT-ATOM  - HEAVY-ATOM
!
!
!   COULOMB TERMS
!
              sumdia = 0.D0
              sumoff = 0.D0
              ll = i1fact(ja)
              k = 0
              do i = 0, 3
                j1 = ifact(ia+i) + ia - 1
                if (i > 0) then
                  do j = 1, i
                    f(j+j1) = f(j+j1) + ptot(ll)*w(j+kk+k)
                    sumoff = sumoff + ptot(j+j1)*w(j+kk+k)
                  end do
                  k = i + k
                  j1 = i + j1
                end if
                j1 = j1 + 1
                k = k + 1
                f(j1) = f(j1) + ptot(ll)*w(kk+k)
                sumdia = sumdia + ptot(j1)*w(kk+k)
              end do
              f(ll) = f(ll) + sumoff*2.D0 + sumdia
!
!  EXCHANGE TERMS
!
!
!  EXTRACT INTERSECTION OF ATOMS II AND JJ IN THE SPIN DENSITY MATRIX
!
              k = 0
              do i = ia, ib
                i1 = ifact(i) + ja
                sum = 0.D0
                do j = 1, ib - ia + 1
                  sum = sum + p(ifact(j-1+ia)+ja)*w(kk+jindex(j+k))
                end do
                k = ib - ia + 1 + k
                f(i1) = f(i1) - sum
              end do
              kk = kk + 10
            else if (jb - ja >= 3 .and. ia == ib) then
!
!                         HEAVY-ATOM - LIGHT-ATOM
!
!
!   COULOMB TERMS
!
              sumdia = 0.D0
              sumoff = 0.D0
              ll = i1fact(ia)
              k = 0
              do i = 0, 3
                j1 = ifact(ja+i) + ja - 1
                if (i > 0) then
                  do j = 1, i
                    f(j+j1) = f(j+j1) + ptot(ll)*w(j+kk+k)
                    sumoff = sumoff + ptot(j+j1)*w(j+kk+k)
                  end do
                  k = i + k
                  j1 = i + j1
                end if
                j1 = j1 + 1
                k = k + 1
                f(j1) = f(j1) + ptot(ll)*w(kk+k)
                sumdia = sumdia + ptot(j1)*w(kk+k)
              end do
              f(ll) = f(ll) + sumoff*2.D0 + sumdia
!
!  EXCHANGE TERMS
!
!
!  EXTRACT INTERSECTION OF ATOMS II AND JJ IN THE SPIN DENSITY MATRIX
!
              k = ifact(ia) + ja
              j = 0
              do i = k, k + 3
                sum = 0.D0
                do l = 1, 4
                  sum = sum + p(l-1+k)*w(kk+jindex(l+j))
                end do
                j = 4 + j
                f(i) = f(i) - sum
              end do
              kk = kk + 10
            else if (jb == ja .and. ia == ib) then
!
!                         LIGHT-ATOM - LIGHT-ATOM
!
              i1 = i1fact(ia)
              j1 = i1fact(ja)
              ij = i1 + ja - ia
              f(i1) = f(i1) + ptot(j1)*w(kk+1)
              f(j1) = f(j1) + ptot(i1)*w(kk+1)
              f(ij) = f(ij) - p(ij)*w(kk+1)
              kk = kk + 1
            end if
          else
            do i = ia, ib
              ka = ifact(i)
              do j = ia, i
                kb = ifact(j)
                ij = ka + j
                aa = 2.0D00
                if (i == j) aa = 1.0D00
                do k = ja, jb
                  kc = ifact(k)
                  if (i >= k) then
                    ik = ka + k
                  else
                    ik = 0
                  end if
                  if (j >= k) then
                    jk = kb + k
                  else
                    jk = 0
                  end if
                  do l = ja, k
                    if (i >= l) then
                      il = ka + l
                    else
                      il = 0
                    end if
                    if (j >= l) then
                      jl = kb + l
                    else
                      jl = 0
                    end if
                    kl = kc + l
                    bb = 2.0D00
                    if (k == l) bb = 1.0D00
                    kk = kk + 1
                    aj = wj(kk)
                    ak = wk(kk)
!
!     A  IS THE REPULSION INTEGRAL (I,J/K,L) WHERE ORBITALS I AND J ARE
!     ON ATOM II, AND ORBITALS K AND L ARE ON ATOM JJ.
!     AA AND BB ARE CORRECTION FACTORS SINCE
!     (I,J/K,L)=(J,I/K,L)=(I,J/L,K)=(J,I/L,K)
!     IJ IS THE LOCATION OF THE MATRIX ELEMENTS BETWEEN ATOMIB ORBITALS
!     I AND J.  SIMILARLY FOR IK ETC.
!
! THIS FORMS THE TWO-ELECTRON TWO-CENTER REPULSION PART OF THE FOCK
! MATRIX.  THE CODE HERE IS HARD TO FOLLOW, AND IMPOSSIBLE TO MODIFY!,
! BUT IT WORKS,
                    if (kl > ij) cycle
                    if (i == k .and. aa + bb < 2.1D0) then
                      f(ij) = f(ij) + aj*ptot(kl)
                    else
                      f(ij) = f(ij) + bb*aj*ptot(kl)
                      f(kl) = f(kl) + aa*aj*ptot(ij)
                      a = ak*aa*bb*0.25D0
                      if (jl > 0) f(ik) = f(ik) - a*p(jl)
                      if (jk > 0) f(il) = f(il) - a*p(jk)
                      if (jk > 0) f(jk) = f(jk) - a*p(il)
                      if (jl > 0) f(jl) = f(jl) - a*p(ik)
                    end if
                  end do
                end do
              end do
            end do
          end if
        end do
        if (mode == 2) then
          i = ((ib - ia + 1)*(ib - ia + 2))/2
          call fock1(f, ptot, p, mpack, w(kk+1), kk, ia, ib, i)
        end if
      end do
      if (useps) then
        call addfck (f,ptot)
      end if
      return
    end subroutine fock2



    subroutine fockdorbs (ia, ib, ja, jb, f, p, ptot, w, kr, ifact)
      use molkst_C, only: norbs, mpack
      implicit none
      integer, intent (in) :: ia, ib, ja, jb
      integer, intent (inout) :: kr
      integer, dimension (norbs), intent (in) :: ifact
      double precision, dimension (mpack), intent (in) :: p, ptot
      double precision, dimension (*), intent (inout) :: f
      double precision, dimension (*), intent (in) :: w
      integer :: i, ij, ik, il, j, jk, jl, k, ka, kb, kc, kl, l, n1, n2, nn, kref
      double precision :: a, aa, bb
      if (ia > ja) then
        do i = ia, ib
          ka = ifact(i)
          aa = 2.0d00
          do j = ia, i
            if (i == j) then
              aa = 1.0d00
            end if
            kb = ifact(j)
            ij = ka + j
            do k = ja, jb
              kc = ifact(k)
              ik = ka + k
              jk = kb + k
              bb = 2.0d00
              do l = ja, k
                if (k == l) then
                  bb = 1.0d00
                end if
                il = ka + l
                jl = kb + l
                kl = kc + l
                kr = kr + 1
                a = w(kr)
                f(ij) = f(ij) + bb * a * ptot(kl)
                f(kl) = f(kl) + aa * a * ptot(ij)
                a = a * aa * bb * 0.25d0
                f(ik) = f(ik) - a * p(jl)
                f(il) = f(il) - a * p(jk)
                f(jk) = f(jk) - a * p(il)
                f(jl) = f(jl) - a * p(ik)
              end do
            end do
          end do
        end do
      else
        kref = kr
        nn = jb - ja + 1
        nn = (nn*(nn+1)) / 2
        n1 = 0
        do i = ja, jb
          ka = ifact(i)
          aa = 2.0d00
          do j = ja, i
            n1 = n1 + 1
            if (i == j) then
              aa = 1.0d00
            end if
            kb = ifact(j)
            ij = ka + j
            n2 = 0
            do k = ia, ib
              kc = ifact(k)
              ik = ka + k
              jk = kb + k
              bb = 2.0d00
              do l = ia, k
                n2 = n2 + 1
                if (k == l) then
                  bb = 1.0d00
                end if
                il = ka + l
                jl = kb + l
                kl = kc + l
                kr = kr + 1
                a = w(kref+(n2-1)*nn+n1)
                f(ij) = f(ij) + bb * a * ptot(kl)
                f(kl) = f(kl) + aa * a * ptot(ij)
                a = a * aa * bb * 0.25d0
                f(ik) = f(ik) - a * p(jl)
                f(il) = f(il) - a * p(jk)
                f(jk) = f(jk) - a * p(il)
                f(jl) = f(jl) - a * p(ik)
              end do
            end do
          end do
        end do
      end if
    end subroutine fockdorbs

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine dcart(coord, dxyz)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!
      use common_arrays_C, only : nfirst, nlast, nat, p, pa, pb, tvec, &
      nbonds, ibonds, geoa, geo
!
      USE molkst_C, only : numat, numcal, keywrd, id, l1u, l2u, l3u, l123, use_ref_geo, &
      cutofp, method_pm6, method_PM7, mozyme, density, N_3_present, Si_O_H_present
!
      use MOZYME_C, only : iorbs, part_dxyz, mode, jopt
!
      use parameters_C, only : tore
!
      USE molmec_C, only : nnhco, nhco, htype
!
      USE funcon_C, only : fpc_9, a0, ev
!
      USE chanel_C, only : iw
!
      USE elemts_C, only : elemnt
!
      USE cosmo_C, only : useps
!
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision  :: coord(3,numat)
      double precision  :: dxyz(3,numat*l123)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: icalcn, icuc, numtot, i, j, ii, iii, im1, if, il, jj, &
        jjj, jf, jl, kkkk, ik, jk, kl, l, ij, k, loop, i2, j2, Si, O, H
      double precision, dimension(3,numat) :: work2
      double precision, dimension(171) :: pdi, padi, pbdi
      double precision, dimension(3,2) :: cdi
      double precision, dimension(numat) :: q
      integer :: ndi(2), ione
      double precision :: chnge, chnge2, const, aa, ee, deriv, del, angle, refh, &
        heat, sum, sumx, sumy, sumz, half, rij, der, dstat(3) = 0.d0
      double precision, external :: derp, nsp2_atom_correction, Si_O_H_bond_correction
      logical :: debug, force, large, refeps, point
      integer, external :: ijbo
      save debug, force, large, chnge, chnge2, icalcn, ione, const
!***********************************************************************
!
!    DCART CALCULATES THE DERIVATIVES OF THE ENERGY WITH RESPECT TO THE
!          CARTESIAN COORDINATES. THIS IS DONE BY FINITE DIFFERENCES.
!
!    THE MAIN ARRAYS IN DCART ARE:
!        DXYZ   ON EXIT CONTAINS THE CARTESIAN DERIVATIVES.
!
!***********************************************************************
      data icalcn/ 0/
      data chnge/ 1.D-4/
      chnge2 = chnge*0.5D0
      aa = 0.d0
!
! CHNGE IS A MACHINE-PRECISION DEPENDENT CONSTANT
! CHNGE2=CHNGE/2
!
      if (icalcn /= numcal) then
        icalcn = numcal
        const = fpc_9
        if (id == 0) then
          ione = 1
        else
          ione = 0
        end if
        large = index(keywrd,'LARGE') /= 0
        debug = index(keywrd,'DERIV') + index(keywrd,'DCART') /= 0
        force = index(keywrd,'PREC') + index(keywrd,'FORCE') /= 0
      end if
      icuc = (l123 + 1)/2
      numtot = numat*l123
      refeps = useps
      useps = .false.
      if (mozyme) then
   !
   !   MODE = 1:   ADD NEW DERIVATIVES ON TO OLD DERIVATIVES
   !          0:   CALCULATE ALL THE DERIVATIVES 'DE NOVO'
   !         -1:   CALCULATE 'OLD' DERIVATIVES, GIVEN ALL THE DERIVATIVES
        if (mode == 0) then
          dxyz(1:3, 1:numtot) = 0.d0
        else if (mode == 1) then
          dxyz(1:3, 1:numtot) = part_dxyz(1:3, 1:numtot)
        else if (mode ==-1) then
          dxyz(1:3, 1:numtot) = -dxyz(1:3, 1:numtot)
        end if
        call chrge_for_MOZYME(p, q)
      else
        dxyz(:,:numtot) = 0.D0
        call chrge(p, q)
        mode = 0
      end if
      q(:numat) = tore(nat(:numat)) - q(:numat)
      i2 = 1
      do ii = 1, numat
        if (mozyme) then
          if (mode == 0 .or. jopt(i2) == ii) then
            i2 = i2 + 1
          else
            cycle
          end if
        end if
        iii = l123*(ii - 1)
        im1 = ii - ione
        if = nfirst(ii)
        il = nlast(ii)
        ndi(2) = nat(ii)
        cdi(:,2) = coord(:,ii)
        j2 = 1
        do jj = 1, im1
          if (mozyme) then
            if (mode == 0 .or. jopt(j2) == jj) then
              j2 = j2 + 1
            else
              cycle
            end if
          end if
          if (ii == jj) then
            half = 0.5d0
          else
            half = 1.d0
          end if
          jjj = l123*(jj - 1)
!  FORM DIATOMIC MATRICES
          jf = nfirst(jj)
          jl = nlast(jj)
!   GET FIRST ATOM
          ndi(1) = nat(jj)
          if (mozyme) then
            if (ijbo(ii, jj) >= 0) then
                  ! GET FIRST ATOM
              k = ijbo (jj, jj)
              ij = 0
              do i = 1, iorbs(jj)
                do j = 1, i
                  ij = ij + 1
                  k = k + 1
                  padi(ij) = p(k) * 0.5d0
                  pdi(ij) = p(k)
                end do
              end do
                  ! GET SECOND ATOM FIRST ATOM INTERSECTION
              if (ii == jj) then
                 ij = iorbs(jj)
                 do i = 1, iorbs(ii)
                  ij = ij + 1
                  l = (ij*(ij-1)) / 2
                  do j = 1, iorbs(jj)
                    l = l + 1
                    padi(l) = 0.d0
                    pdi(l) = 0.d0
                  end do
                end do
              else
                ij = iorbs(jj)
                k = ijbo (ii, jj)
                do i = 1, iorbs(ii)
                  ij = ij + 1
                  l = (ij*(ij-1)) / 2
                  do j = 1, iorbs(jj)
                    l = l + 1
                    k = k + 1
                    padi(l) = p(k) * 0.5d0
                    pdi(l) = p(k)
                  end do
                end do
              end if
                  ! GET SECOND ATOM
              k = ijbo (ii, ii)
              ij = iorbs(jj)
              do i = 1, iorbs(ii)
                ij = ij + 1
                l = (ij*(ij-1)) / 2 + iorbs(jj)
                do j = 1, i
                  k = k + 1
                  l = l + 1
                  padi(l) = p(k) * 0.5d0
                  pdi(l) = p(k)
                end do
              end do
              pbdi = padi
              point = .false.
            else
              point = .true.
            end if
          else
          point = .false.
          ij = 0
            do i = jf, jl
              k = (i*(i - 1))/2 + jf - 1
              if (i - jf + 1 > 0) then
                padi(ij+1:i-jf+1+ij) = pa(k+1:i-jf+1+k)
                pbdi(ij+1:i-jf+1+ij) = pb(k+1:i-jf+1+k)
                pdi(ij+1:i-jf+1+ij) = p(k+1:i-jf+1+k)
                ij = i - jf + 1 + ij
              end if
            end do
! GET SECOND ATOM FIRST ATOM INTERSECTION
            do i = if, il
              l = (i*(i - 1))/2
              k = l + jf - 1
              if (jl - jf + 1 > 0) then
                padi(ij+1:jl-jf+1+ij) = pa(k+1:jl-jf+1+k)
                pbdi(ij+1:jl-jf+1+ij) = pb(k+1:jl-jf+1+k)
                pdi(ij+1:jl-jf+1+ij) = p(k+1:jl-jf+1+k)
                ij = jl - jf + 1 + ij
              end if
              k = l + if - 1
              if (i - if + 1 > 0) then
                padi(ij+1:i-if+1+ij) = pa(k+1:i-if+1+k)
                pbdi(ij+1:i-if+1+ij) = pb(k+1:i-if+1+k)
                pdi(ij+1:i-if+1+ij) = p(k+1:i-if+1+k)
                ij = i - if + 1 + ij
              end if
            end do
          end if
          kkkk = 0
          do ik = -l1u, l1u
            do jk = -l2u, l2u
              do kl = -l3u, l3u
                kkkk = kkkk + 1
                cdi(:,1) = coord(:,jj) + tvec(:,1)*ik + tvec(:,2)*jk + tvec(:,3)*kl
                if (id /= 0) then
                  rij = (cdi(1, 1)-cdi(1, 2)) ** 2 &
                       & + (cdi(2, 1)-cdi(2, 2)) ** 2 &
                       & + (cdi(3, 1)-cdi(3, 2)) ** 2
                  if (rij > (2.d0/3.d0*cutofp)**2) then
                        !
                        !   Use point-charge approximation
                        !
                    rij = Sqrt (rij)
                    der = derp (rij)
                    ee = q(ii) * q(jj) * fpc_9 * ev * a0 * der
                    do k = 1, 3
                      deriv = half * ee * (cdi(k, 1)-cdi(k, 2)) / rij
                      dxyz(k, iii+icuc) = dxyz(k, iii+icuc) - deriv
                      dxyz(k, jjj+kkkk) = dxyz(k, jjj+kkkk) + deriv
                    end do
                    cycle
                  end if
                end if
                if (point) then
                  do l = 1, 3
                    cdi(l, 1) = coord(l, jj) + tvec(l, 1) * ik &
                         & + tvec(l, 2) * jk + tvec(l, 3) * kl
                  end do
                  call delsta (nat, iorbs, p, cdi, dstat, ii, jj)
                  dxyz(1:3, iii+icuc) = dxyz(1:3, iii+icuc) - dstat(1:3)
                  dxyz(1:3, jjj+kkkk) = dxyz(1:3, jjj+kkkk) + dstat(1:3)
                else
                  if (.not. force) then
                   cdi(1,1) = cdi(1,1) + chnge2
                   cdi(2,1) = cdi(2,1) + chnge2
                   cdi(3,1) = cdi(3,1) + chnge2
                   call dhc (pdi, padi, pbdi, cdi, ndi, jf, jl, if, il, aa, 1)
                  end if
                  do k = 1, 3
                    if (force) then
                      cdi(k,2) = cdi(k,2) - chnge2
                      call dhc (pdi, padi, pbdi, cdi, ndi, jf, jl, if, il, aa, 1)
                    end if
                    cdi(k,2) = cdi(k,2) + chnge
                    call dhc (pdi, padi, pbdi, cdi, ndi, jf, jl, if, il, ee, 2)
                    cdi(k,2) = cdi(k,2) - chnge2
                    if (.not. force) cdi(k,2) = cdi(k,2) - chnge2
                    deriv = half*(aa - ee)*const/chnge
                    dxyz(k,iii+icuc) = dxyz(k,iii+icuc) - deriv
                    dxyz(k,jjj+kkkk) = dxyz(k,jjj+kkkk) + deriv
                  end do
                end if
              end do
            end do
          end do
        end do
      end do
      if (nnhco /= 0) then
!
!   NOW ADD IN MOLECULAR-MECHANICS CORRECTION TO THE H-N-C=O TORSION
!
        del = 1.D-8
        do i = 1, nnhco
          do j = 1, 4
            do k = 1, 3
              coord(k,nhco(j,i)) = coord(k,nhco(j,i)) - del
              call dihed (coord, nhco(1,i), nhco(2,i), nhco(3,i), nhco(4,i), &
                angle)
              refh = htype*sin(angle)**2
              coord(k,nhco(j,i)) = coord(k,nhco(j,i)) + del*2.D0
              call dihed (coord, nhco(1,i), nhco(2,i), nhco(3,i), nhco(4,i), &
                angle)
              coord(k,nhco(j,i)) = coord(k,nhco(j,i)) - del
              heat = htype*sin(angle)**2
              sum = (refh - heat)/(2.D0*del)
              dxyz(k,nhco(j,i)) = dxyz(k,nhco(j,i)) - sum
            end do
          end do
        end do
      end if
      if (method_pm6 .and. N_3_present) then
!
!   Add in the nitrogen sp2 correction
!
        del = 1.d-8
        do i = 1, numat
          if (nat(i) == 7 .and. nbonds(i) == 4) then
            jj = 0
            if (nat(ibonds(2,i)) == 1) jj = 1
            if (nat(ibonds(3,i)) == 1) jj = jj + 1
            if (nat(ibonds(4,i)) == 1) jj = jj + 1
            if ( jj < 2) then
              do j = 1,4
                do k = 1, 3
                  coord(k,ibonds(j,i)) = coord(k,ibonds(j,i)) - del
                  sum = nsp2_atom_correction(coord, i, ibonds(2,i), ibonds(3,i), ibonds(4,i))
                  coord(k,ibonds(j,i)) = coord(k,ibonds(j,i)) + 2.d0*del
                  sum = (sum - nsp2_atom_correction(coord, i ,ibonds(2,i), ibonds(3,i), ibonds(4,i)))/(2.d0*del)
                  coord(k,ibonds(j,i)) = coord(k,ibonds(j,i)) - del
                  dxyz(k,ibonds(j,i)) = dxyz(k,ibonds(j,i)) - sum
                end do
              end do
            end if
          end if
        end do
      end if
      if (method_pm7 .and. Si_O_H_present) then
!
!   Add in the Si-O-H correction
!
      del = 1.d-8
      do i = 1, numat
          if (nat(i) == 8) then
            O = i
            Si = 0
            H = 0
            do j = 1, nbonds(i)
              k = ibonds(j,i)
              if (nat(k) == 14) Si = k
              if (nat(k) == 1) H = k
            end do
            if (Si /= 0 .and. H /= 0) then
              do k = 1, 3
!
! Si
!
                coord(k,Si) = coord(k,Si) - del
                sum = Si_O_H_bond_correction(coord, Si, O, H)
                coord(k,Si) = coord(k,Si) + 2.d0*del
                sum = (sum - Si_O_H_bond_correction(coord, Si, O, H))/(2.d0*del)
                coord(k,Si) = coord(k,Si) - del
                dxyz(k,Si) = dxyz(k,Si) - sum
!
! O
!
                coord(k,O) = coord(k,O) - del
                sum = Si_O_H_bond_correction(coord, Si, O, H)
                coord(k,O) = coord(k,O) + 2.d0*del
                sum = (sum - Si_O_H_bond_correction(coord, Si, O, H))/(2.d0*del)
                coord(k,O) = coord(k,O) - del
                dxyz(k,O) = dxyz(k,O) - sum
!
! H
!
                coord(k,H) = coord(k,H) - del
                sum = Si_O_H_bond_correction(coord, Si, O, H)
                coord(k,H) = coord(k,H) + 2.d0*del
                sum = (sum - Si_O_H_bond_correction(coord, Si, O, H))/(2.d0*del)
                coord(k,H) = coord(k,H) - del
                dxyz(k,H) = dxyz(k,H) - sum
              end do
            end if
          end if
        end do
      end if
      if (mode ==-1) then
        part_dxyz(1:3, 1:numat*l123) = -dxyz(1:3, 1:numat*l123)
      end if
      useps = refeps
      if (useps) call diegrd (dxyz)
      if (use_ref_geo) then
        do i = 1, numat
          do j = 1,3
            dxyz(j,i) = dxyz(j,i) + (geo(j,i) - geoa(j,i))*density*2.d0
          end do
        end do
      end if
      if (.not.debug) return
      if (l123 == 1) then
        write (iw, '(I6,4x,a2,F13.6,2F13.6)') (i,elemnt(nat(i)),(dxyz(j,i),j=1,3),i=1,numtot)
      else if (large) then
      call print_dxyz("(Does NOT include post-SCF corrections)")
      end if
      if (id == 0) return
      write (iw, &
      '(2/10X,"CARTESIAN COORDINATE DERIVATIVES FOR THE CENTRAL UNIT CELL",/,"  NO. AT.     X            Y            Z",/)')
      if (l123 == 1) then
        write (iw, '(I6,A2,3F13.6)') (i,elemnt(nat(i)),(dxyz(j,i),j=1,3),i=1,numtot)
      else if (large) then
        loop = 0
        do i = 1, numat
          sumx = 0.D0
          sumy = 0.D0
          sumz = 0.D0
          do ik = -l1u, l1u
            do jk = -l2u, l2u
              do kl = -l3u, l3u
                loop = loop + 1
                sumx = sumx + dxyz(1,loop)
                sumy = sumy + dxyz(2,loop)
                sumz = sumz + dxyz(3,loop)
              end do
            end do
          end do
          work2(1,i) = sumx
          work2(2,i) = sumy
          work2(3,i) = sumz
        end do
        write (iw, '(I6,A2,F13.6,2F13.6)') (i,elemnt(nat(i)), &
        (work2(j,i),j=1,3), i = 1, numat)
        if (id == 3) call xyzcry (tvec, numat, work2, iw)
      else
        write (iw, '(I6,A2,F13.6,2F13.6)') (i,elemnt(nat((i-1)/l123+1)), &
        (dxyz(j,i) + dxyz(j,i+1) + dxyz(j,i+2),j=1,3),i = 1, numtot - 2, 3)
      end if
      return
      end subroutine dcart
!
      double precision function derp (r)
      use molkst_C, only: numcal, clower, cutofp, cupper
      implicit none
      double precision, intent (in) :: r
      integer, save :: icalcn = 0
      double precision, save :: bound1, bound2, c, cr, cr2, range
!
      if (icalcn /= numcal) then
      !
      ! Set constants for truncation function.
      !
      ! CLOWER = lower bound of truncation function, as a function of CUTOFP
        bound1 = clower / cutofp
      !
      ! CUPPER = upper bound of truncation function, as a function of CUTOFP
        bound2 = cupper / cutofp
        range = bound2 - bound1
      !
      ! Truncation function = C+CR*R+CR2*R**2
      !
        c = -0.5d0 * bound1 ** 2 * cutofp / range
        cr = 1.d0 + bound1 / range
        cr2 = -1 / (cutofp*2*range)
      !
      !   Above CUPPER function = constant
      !
        icalcn = numcal
      end if
   !
   !  Need a smooth function in the region of CUTOFP
   !
   !  Function has form:
   !    Up to CLOWER  R=R
   !    At CLOWER,  slope = 1.0
   !    Between CLOWER and CUPPER = Monotomic increase,
   !    with rate of increase dropping from 1.0 to 0.0
   !    At CUPPER, slope = 0
   !    Above CUTOFP   R=CUTOFP
      if (r > clower) then
        if (r > cupper) then
          derp = 0.d0
        else
          derp = -(cr+2*cr2*r) / (c+cr*r+cr2*r**2) ** 2
        end if
      else
        derp = -1 / r ** 2
      end if
  end function derp
  subroutine print_dxyz(header)
!
! Generic print of the array dxyz.  Use this wherever array dxyz needs to be printed
!
    use common_arrays_C, only : dxyz, nat
!
    USE molkst_C, only : numat, keywrd, l123, l11, l21, l31
    USE chanel_C, only : iw
    USE elemts_C, only : elemnt
!
    implicit none
    character :: header*(*)
    integer :: i1, j1, k1, i, k, j, l
    double precision :: sum
    logical :: large
    large = index(keywrd,'LARGE') /= 0
    write (iw, '(2/10X,''CARTESIAN COORDINATE DERIVATIVES'')')
    write (iw, '(7X,a)')trim(header)
    if (l123 == 1) then
      write (iw, '(/1X, a, /)')" NUMBER ATOM           X                Y                Z              Total"
      write (iw, '(I6,4x,a2,4F17.6)') (i, elemnt(nat(i)),(dxyz(i*3 - 3 + j), j = 1, 3), &
        sqrt(dxyz(i*3)**2 + dxyz(i*3 - 1)**2 + dxyz(i*3 - 2)**2), i = 1, numat)
    else if (large) then
      write (iw, '(/1X, a, /)')"       CELL           ATOM            X                Y                Z            Total"
      k = 0
      l = 0
      do i1 = -l11, l11
        do j1 = -l21, l21
          do k1 = -l31, l31
            l = l + 1
            do i = 1, numat
              k = k + 1
              sum = dxyz(k*3 - 2)**2 + dxyz(k*3 - 1)**2 + dxyz(k*3)**2
              if (sum > 0.1d0) &
              write (iw, '(I6, 2i4, i8, i4, 1x,a2,F13.6,3F17.6)')  i1, j1, k1, k, i, &
                elemnt(nat(i)), (dxyz(k*3 - 3 + j), j = 1, 3), sqrt(sum)
            end do
          end do
        end do
      end do
    end if
    end subroutine print_dxyz

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

module Common_arrays_C

!
!  This module contains all the arrays relating to the system being calculated.
!  Every entry is unique, and has the same meaning in every subroutine.
!
!
!  This module can also be regarded as a dictionary of the arrays relating to the system.
!  Quantities which have only a one-line descriptionis are of no interest outside MOPAC.
!  The data-type for each quantity is given at the start of the statement
!
  implicit none
  integer, dimension (:), allocatable :: &
  &  labels,     & !  Term          Atomic numbers (all atoms, real, dummy, Tv)
                   !  Units         None
                   !  Min inclusive 0
                   !  Max inclusive 107
                   !
  &  nat,        & !  Term          Atomic numbers (real atoms)
                   !  Definition    Atomic numbers of real atoms.
                   !  Min inclusive 0
                   !  Max inclusive 85
                   !
  &  na, nb, nc, & !  Term          Connectivities used in Z-matrix
                   !  Definition    Connectivity for bonds, angles, and dihedrals
  &  na_store,   & !  Store of "na" for cases where na must be temporarily zero
                   !
  &  nfirst,     & !  Term          Starting index of atomic orbitals for each atom
                   !
  &  nlast,      & !  Term          Ending index of atomic orbitals for each atom
                   !
  &  nw,         & !
  &  ifact,      & !
  &  i1fact,     & !
  &  nbonds,     & ! Number of atoms bonded to a given atom
  &  set_a,      & ! Set of atoms in first fragment, Used by PM6-DH2
  &  set_b,      & ! Set of atoms in second fragment, Used by PM6-DH2
  &  acceptor_a, & ! List of O and N atoms in first fragment. Used by PM6-DH2
  &  acceptor_b, & ! List of O and N atoms in second fragment. Used by PM6-DH2
  &  bonding_a_h,& ! List of Hydrogen atoms attached to O or N in first fragment. Used by PM6-DH2
  &  bonding_b_h,& ! List of Hydrogen atoms attached to O or N in second fragment. Used by PM6-DH2
  &  ipKa_sorted,& ! List of ionizable hydrogen atoms, sorted by pKa
  &ipKa_unsorted,& ! List of ionizable hydrogen atoms, not yet sorted by pKa
  &  dummy
  integer, dimension (:,:), allocatable :: &
  &  loc,        & !  Indices of atoms and coordinates marked for optimization
  &  ibonds,     & !  Atom numbers of atoms bonded to a given atom
  &  lopt,       & !  optimization flags
  &  lopt_store, & !  Optimization flags in GEO_REF
  &  pibonds,    & !  Pi bonds supplied by the user (requires keyword SETPI)
  &  hblist,     & !  List of hydrogen bonds X-H --- Y and types used by PM6-DH2
  &  ijpars,     & !
  &  dummy2
  double precision, dimension(3,3) :: tvec = 0.d0 !  Translation vectors (for solid-state)
  integer ::         &
   cell_ijk(3),      &   !  Dispacement translation indices (for solid-state)
   breaks(400),      &   !  Locations of breaks in PDB structure
   time_start(8),    &   !
   time_end(8)           !
  Double Precision :: Vab(3)           !  Distance vector between two atoms in a solid.(for solid-state)
  character ::chains(100)*1            !  Names of chains in proteins
  double precision :: break_coords(3,400) = 0.d0   !  Locations of breaks in a PDB structure
!
  double precision, dimension (:), allocatable :: &
  &  xparam,     & !  Values of geometric parameters marked for optimization
  &  xparef,     & !  Reference copy of xparam
  &  uspd,       & !  Initial values of one-electron diagonal (Uss, Upp, and Udd)
  &  pdiag,      & !  initial values of diagonal of density matrix
                   !
  &  h,          & !  Term          One electron Hamiltonian matrix
                   !  Definition    NDDO one-electron matrix, packed
                   !  Units         eV
                   !
  &  hb,         & !  Term          One electron beta Hamiltonian matrix
                   !  Definition    NDDO one-electron beta matrix, packed
                   !  Units         eV
                   !
  &  f,          & !  Term          Fock matrix, or alpha Fock matrix, if UHF
                   !  Definition    one-electron plus two-electron Hamiltonian matrix, packed
                   !  Units         eV
                   !
  &  fb,         & !  Term          Beta Fock matrix, if UHF
                   !  Definition    one-electron plus two-electron beta Hamiltonian matrix, packed
                   !  Units         eV
                   !
  &  w,          & !  Term          Two-electron integrals
                   !  Definition    One and two center, "J" two-electron integrals
                   !  Units         eV
                   !
  &  wk,         & !  Term          "K"-type two-electron integrals (used in solid state only)
                   !  Definition    One and two center, "J" two-electron integrals
                   !  Units         eV
                   !
  &  p,          & !  Term          Total density matrix
                   !  Definition    Coulson density matrix
                   !  Description   Calculated in SCF from M.O.s
                   !  Units         Electrons
                   !  Min inclusive -1.0 (off diagonal) 0.0 (on diagonal)
                   !  Max inclusive  1.0 (off diagonal) 2.0 (on diagonal)
                   !
  &  pa, pb,     & !  Term          Alpha and beta density matrix
                   !  Definition    Coulson alpha and beta on-electron density matrix
                   !  Description   Calculated in SCF from M.O.s
                   !  Units         Electrons
                   !  Min inclusive -1.0 (off diagonal) 0.0 (on diagonal)
                   !  Max inclusive  1.0 (off diagonal) 1.0 (on diagonal)
                   !  units:        alpha and beta electrons
                   !
  &  q,          & !  Term          Net charge on atoms
                   !  Definition    Core charge on an atom minus number of valence electrons
                   !  Units         Electrons
                   !
  &  eigs,       & !  Term          M.O. eigenvalues, or Alpha M.O. eigenvalues, if UHF
                   !  Definition    Energies of molecular orbitals or alpha M.O.s if UHF
                   !  Units         eV
                   !
  &  eigb,       & !  Term          Beta M.O. eigenvalues (if UHF)
                   !  Definition    Energies of beta molecular orbitals
                   !  Units         eV
                   !
  &  dxyz,       & !  Cartesian gradient vector in kcal/mol/Angstrom
  &  grad,       & !  Gradient vector (kcal/mol/A, or kcal/mol/radian)
  &  chrg,       & !  Mulliken charges (used by to_screen)
  &  bondab,     & !  Bond order matrix
                   !
  &  atmass,     & !  Term          Atomic masses
                   !  Definition    Masses of individual atoms
                   !  Units         Atomic mass units (Hydrogen = 1.00794 on this scale)
                   !  Default       Atomic weights given in Periodic Table
  &  ch,         & !
  &  hesinv,     & !  inverse hessian
  &  fmatrx,     & !  Hessian Force Matrix
  &  gnext1,     & !
  &  gmin1,      & !
  &  errfn,      & !
  &  profil,     & !
  &  pKa_sorted, & !  pKa of ionizable hydrogen atoms, sorted by pKa
  &  parsij,     &
  &  aicorr,     & !
  &  H_energy,   & !  Energies of hydrogen bonds found in system
  &  T_range,    & !  Term          Temperatures in thermochemistry (in thermo.F90)
                   !  Units         Kelvin
  &  HOF_tot,    & !  Term          Heats of formation at temperatures in T_range
                   !  Units         kilo-calories per mole
  &  H_tot,      & !  Term          Enthalpy at temperatures in T_range
                   !  Units         cal/mol
  &  Cp_tot,     & !  Term          Heat capacity at temperatures in T_range
                   !  Units         cal/(K.Mol)
  &  S_tot         !  Term          Entropy at temperatures in T_range
                   !  Units         cal/(K.Mol)
  double precision, dimension (:,:), allocatable :: &
  &  geo,        & !  Term          Geometry
                   !  Definition    Coordinates of all atoms in units defined by input
                   !  Units         Angstroms and radians
                   !
  &  geoa,       & !  Term          Alternative Geometry
                   !  Definition    Alternative geometry coordinates of all atoms in units defined by input
                   !  Units         Angstroms and radians
                   !
  &  coord,      & !  Term          Cartesian coordinates
                   !  Definition    Cartesian coordinates of all atoms
                   !  Units         Angstroms
                   !
  &  coorda,     & !  Term          Alternative Cartesian coordinates
                   !  Definition    Alternative Cartesian coordinates of all atoms
                   !  Units         Angstroms
                   !
  &  c,          & !  Term          Eigenvectors, or alpha eigenvectors, if UHF
                   !  Definition    Molecular orbital coefficients of alpha M.O.s.  c**2 = 1.0
                   !  Units         dimensionless
                   !  Min inclusive -1.0
                   !  Max inclusive  1.0
                   !
  &  cb,         & !  Term          Eigenvectors, or beta eigenvectors, if UHF
                   !  Definition    Molecular orbital coefficients of beta M.O.s.  c**2 = 1.0
                   !  Units         dimensionless
                   !  Min inclusive -1.0
                   !  Max inclusive  1.0
  &  workmat1,   & !  unpacked matrix workspace #1
  &  workmat2,   & !  unpacked matrix workspace #2
  &  workmat3,   & !  unpacked matrix workspace #3
  &  dxyz2,      & !  dxyz, but 2-D
  &  ptot2,      & !
     xmat,       &
  & rdummy2

  character, dimension (:), allocatable :: &
  &  simbol*10,      & !  Term          Symbol for geometric variable
                       !  Definition    Gaussian format symbolic
                       !  Unit          10 characters
  & all_comments*81, & !  Term          Comments
                       !  Definition    Comments in data set describing the data set. Not used in program working.
                       !                (Useful for holding PDB information)
  &  pibonds_txt*50, & !  pi bonds defined using SETPI, as text
  &  H_txt*120,      & !  Term          Description of hydrogen bonds
                       !  Definition    Atoms involved in H - bond, hydrogen bond-length and energy.
  &  txtatm*27,      & !  Term          Atom discriptor
                       !  Definition    A textual description of each atom.  Not used in program working.
  &  txtatm1*27        !  Term          Original atom discriptor

  logical, dimension (:), allocatable :: &
  &  l_atom            !  If true, then use atom in output, otherwise don't print

end module Common_arrays_C

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

module common_common
!
!  Scalars
!
  implicit none
  double precision ::   &
    tvec(3,3),          & !
    trans(3,3),         & !
    xop(11,149),        & !
    allt1(9,9,130),     & !
    r1,                 & !
    top_l(3),           & !
    top_r(3),           & !
    bottom_l(3),        & !
    bottom_r(3),        & !
    
    dummy_r
  real ::               & !
    xscale,             & !
    yscale,             & !
    xoffset,            & !
    yoffset,            & !
    size_x,             & !
    size_y
    
  double precision, allocatable :: &
    grid(:,:,:)
    
  integer ::            &
    id,                 & !   Dimensionality of the system.  id = 1 = polymer; id = 2 = layer; id = 3 = solid
    numat,              & !   Number of atoms in the unit cell
    nvecs,              & !   Number of vectors = number of atomic orbitals = number of M.O.s in the unit cell,
                        !   or three times the number of atoms (in phonon work)
    mr1,                & !
    mr2,                & !
    mr3,                & ! 
    iop,                & !   Number of symmetry operations
    ir,                 & !   Input channel number
    ir_new,             & !   
    iw,                 & !   Output channel number
    iw_new=19,          & !
    nijk(3,1000),       & !   Indices of all atoms in all unit cells
    nijk_cuc(3,500),    & !   Indices of all atoms in the Central Unit Cell
    ixyz,               & !   Index of a specific unit cell
    mop(4,300,130),     & !   
    ncell,              & !
    im,                 & !
    jm,                 & !
    isurf,              & !
    dummy_i             !   Not used: dummy_i is present to terminate this block
  integer*2 ::          &
    top_left_x,         &
    top_left_y
  character ::          &
    jobnam*2000,        & !  Name of the job = name of the brz file less ".brz"
    data_set_name*2000, & !  Name of input file containing the specific work BZ has to do
    keywrd*2000,        & !
    units*9,            & !  Name of units (eV or cm**(-1))
    title(149)*12,      & !   
    Sym_Oper*12,        & !  Name of Symmetry Operation
    line*2000           !  Temporary storage
  logical ::            &
    bcc,                & !
    lijk(600),          & !  for lijk(x) .true. if there exists an nijk(-i,-j,-k,x) for  nijk(i,j,k,x)
    l_read_dat,         & ! .true. if <file>.dat is NOT used, in which case create and save a new <file>.dat
    phonon
  integer, dimension(:), allocatable :: nfirst, nlast, per_atom
  double precision, allocatable, dimension(:, :) :: coord, ref_coord, sec_det
end module common_common

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

!**************************************************************************
!
!  Based on the work of:
!
!  Dr Andrey Bliznuk, Australian National University, Canberra, Australia.
!
!  See also:
!  Jana Khandogin, Anguang Hu, Darrin M. York, "Electronic structure properties
!  of solvated biomolecules: A quantum approach for macromolecular characterization
!  Volume 21, Issue 16 , Pages 1562 - 1571 (2000)
!
!**************************************************************************
  module cosmo_mini
!
!  This structure, the use of a module inside a module containing private data,
!  is necessary for debugging only.  The data here can be monitored by a debugger.
!  The other data in linear_cosmo cannot be monitored.
!
    logical :: new_surface, new_iteration
    double precision, dimension(:, :), allocatable :: a_block
    double precision, dimension(:), allocatable :: r_vec, p_vec, &
       & q_vec, z_vec, a_diag, m_vec, a_part
    double precision, dimension(:, :, :), allocatable :: tm
    integer, dimension(:), allocatable :: iblock_pos
  end module cosmo_mini
  module linear_cosmo
  use afmm_C
  use cosmo_mini, only : new_surface, new_iteration, a_block, tm, &
  r_vec, p_vec, q_vec, z_vec, a_diag, m_vec, a_part, iblock_pos
  implicit none

  public :: ini_linear_cosmo, coscavz, addnucz, addfckz, am1dft_solve
  double precision, public :: c_proc


  private

  integer, parameter :: na1max = 6000     ! when use O(n*log(n))
  integer, parameter :: na2max = 6000     ! when use O(n) algorithm
                                          ! for A*q vector

  integer, parameter :: nb1max = 8000     ! when use O(n*log(n))
  integer, parameter :: nb2max = 8000     ! when use O(n) algorithm
                                          ! for B*q vector

  logical, parameter :: compute_a_part = .true. ! precompute A matrix
  logical, parameter :: use_a_blocks = .true.   ! use block-diagonal
                                                ! preconditioner

  !!!!
  !!!! Note. use_a_blocks assumes that compute_a_part is .true.
  !!!!

  double precision, dimension(:, :), allocatable :: rsc

  integer, dimension(:), allocatable :: nipsrs
  integer, dimension(:), allocatable :: nset
  integer, dimension(:), allocatable :: npoints
  integer, dimension(:), allocatable :: iatom_pos

  integer, dimension(:), allocatable :: ijbo_diag



  integer :: max_block_size
  integer :: atom_handle, surface_handle
  integer, parameter :: dcmplx_kind = Kind ((1.d0, 1.d0))

contains

  subroutine ini_linear_cosmo

    use molkst_C, only: numat
    use cosmo_C, only : lenabc, solv_energy
    use common_arrays_C, only: nfirst, nlast
    implicit none
    integer :: maxrs, i, nnn
    intrinsic Allocated
    integer, external :: ijbo
    !
    !       Allocate Linear-Cosmo specific arrays
    !
    maxrs = 70 * numat
    if (Allocated (rsc)) then
      deallocate (rsc, tm, iatom_pos, nipsrs, nset, npoints, &
                & ijbo_diag, stat = i)

      if (i /= 0) then
        call mopend ("CosmoZ (1):  Deallocate error")
      end if
    end if

    allocate (rsc (4, maxrs), tm(3, 3, numat), iatom_pos(numat), &
         & nipsrs(lenabc), nset(1082*numat), npoints(numat+1), &
         ijbo_diag(numat), stat=i)

    if (i /= 0) then
      call mopend ("CosmoZ (2):  Allocate error ")
    end if

    iatom_pos(1) = 0
    ijbo_diag(1) = ijbo(1, 1)
    do i = 2, numat
      nnn = nlast(i-1) - nfirst(i-1) + 1
      nnn = ((nnn+1)*nnn)/2
      iatom_pos(i) = iatom_pos(i-1) + nnn
      ijbo_diag(i) = ijbo(i, i)
    end do

    solv_energy = 0.d0

    call afmm_ini

  end subroutine ini_linear_cosmo

  subroutine bpnew_vec (v)
    !
    ! Interaction of electronic densities with induced charges
    !

    use molkst_C, only : numat
    use cosmo_C, only : nps, cosurf
    use common_arrays_C, only: coord, nfirst, nlast, nat, p
    use parameters_C, only : dd, qq
    use funcon_C, only : a0
    implicit none
    double precision, dimension(nps), intent (out) :: v
    integer :: i, j, k, l, m, jj, nao, ni
    double precision :: dx, dy, dz, r, t, dip, quad
    double precision :: w(45)
    v(1:nps) = 0.d0
    dip = 0.d0
    quad = 0.d0

    do j=1, numat
      nao = nlast(j)-nfirst(j)
      jj = ijbo_diag(j )

      if (nao > 0) then
        ni = nat(j)
        dip = dd(ni) * a0
        quad = (a0 *qq(ni))** 2
      end if

      do i=1, nps

        dx= cosurf(1, i) - coord(1, j)
        dy= cosurf(2, i) - coord(2, j)
        dz= cosurf(3, i) - coord(3, j)

        r = 1.d0 / Sqrt (dx**2 + dy**2 + dz**2)

        if (nao == 0) then ! --- S-element
          v(i) = v(i) - p(jj+1) * r
          cycle

        else ! --- sp element

           w(1) = r

           dx = dx * r
           dy = dy * r
           dz = dz * r

           t = dip * r*r

           w(2) =  dx * t
           w(4) =  dy * t
           w(7) =  dz * t

           t = quad * r*r*r
           w(3)  = r + (3.d0*dx**2 - 1.d0) * t
           w(6)  = r + (3.d0*dy**2 - 1.d0) * t
           w(10) = r + (3.d0*dz**2 - 1.d0) * t

           w(5) = 3.d0*dx*dy * t
           w(8) = 3.d0*dx*dz * t
           w(9) = 3.d0*dy*dz * t

           if (nao > 3) then ! --- d - element
              w(11:45) = 0
              w(15) = r
              w(21) = r
              w(28) = r
              w(36) = r
              w(45) = r
           end if
        end if

        m = 0
        t = 0.d0
        do k = 1, nao+1
          do l = 1, k-1
            m = m + 1
            t = t - 2*p(jj+m) * w(m)
          end do
          m = m + 1
          t = t - p(jj+m) * w(m)
        end do

        !!write(26,*) ' Pair :', i, j
        !!write(26,*) ( w(k),k=1,((nao+1)*(nao+2))/2 )

        v(i) = v(i) + t
      end do
    end do

  end subroutine bpnew_vec

  subroutine bz_vec (v)
    !
    ! Interaction of atom cores with induced charges
    !

    use molkst_C, only : numat
    use common_arrays_C, only: coord, nat
    use cosmo_C, only : cosurf, nps
    use parameters_C, only: tore
    implicit none
    double precision, dimension(nps), intent (out) :: v
    integer :: i, j
    double precision :: t
    intrinsic Sqrt


    do i = 1, nps
      t = 0
      do j = 1, numat

        t = t + tore(nat(j)) / &
             & Sqrt ((coord(1, j) - cosurf(1, i))**2 + &
             & (coord(2, j) - cosurf(2, i))**2 + &
             & (coord(3, j) - cosurf(3, i))**2)
      end do

      v(i) = t

    end do
  end subroutine bz_vec

  subroutine get_bvec (x1, x2, nao, ni, w)
    use funcon_C, only : a0
    use parameters_C, only : dd, qq
    implicit none
    double precision, dimension(3), intent (in) :: x1, x2
    integer, intent (in) :: nao, ni
    double precision, dimension(*), intent (out) :: w
    double precision, dimension(3) :: dx
    double precision :: r, dip, quad
    integer :: i
    intrinsic Sqrt
    !
    dx(1) = x1(1) - x2(1)
    dx(2) = x1(2) - x2(2)
    dx(3) = x1(3) - x2(3)

    r = 1.d0 / Sqrt (dx(1)**2 + dx(2)**2 + dx(3)**2)

    w(1) = r

    if (nao == 0) then ! --- H
      return
    else ! --- sp - element
      dip = dd(ni) * a0 * r * r
      quad = (a0 *qq(ni))** 2 * r * r * r
      dx(1) = dx(1) * r
      dx(2) = dx(2) * r
      dx(3) = dx(3) * r

      w(2) =  dx(1) * dip
      w(4) =  dx(2) * dip
      w(7) =  dx(3) * dip

      w(3)  = r + (3.d0*dx(1)**2 - 1.d0) * quad
      w(6)  = r + (3.d0*dx(2)**2 - 1.d0) * quad
      w(10) = r + (3.d0*dx(3)**2 - 1.d0) * quad

      w(5) = 3.d0*dx(1)*dx(2) * quad
      w(8) = 3.d0*dx(1)*dx(3) * quad
      w(9) = 3.d0*dx(2)*dx(3) * quad

      if (nao < 4) then
        return
      else ! --- d - element
        do i = 11, 45
          w(i) = 0
        end do
        w(15) = r
        w(21) = r
        w(28) = r
        w(36) = r
        w(45) = r
      end if
    end if
  end subroutine get_bvec

  subroutine coscavz (coord, nat)
    !
    ! Prepares molecular surface & tesselations
    !

    use molkst_C, only: numat
    use overlaps_C, only : cutof2
    use cosmo_C, only : nps, disex2, ioldcv, lenabc, iatsp, nar_csm, nsetf, phinet, &
         & cosurf, srad, arat
    use chanel_C, only: iw
    implicit none
    double precision, dimension(3, numat), intent (inout) :: coord
    integer, dimension(numat), intent (in) :: nat
    integer :: i, j, ndim, maxrs
    integer, dimension(2) :: ind
    new_surface = .true.

    call coscanz (srad, coord, nat, cosurf, iatsp, nar_csm, nsetf, &
         & phinet, arat)

 !   write(26,*) ' Cosmo radii:'
 !   write(26,'(F12.5)') (srad(i), i=1, numat)

    call prepare_tesselations (numat, nps, ind, 2, i)

    if (i /= 0) then
      call mopend ("CosmoZ (3):  Tesselation ini error ")
      return
    end if

    atom_handle = ind(1)
    surface_handle = ind(2)

    if (numat > nb2max .or. numat > nb1max) then
 !     write (iw, *) " NUMAT Doing divide_box by", Sqrt(cutof2)
      call divide_box (coord, 3, numat, Sqrt(cutof2), 10, 0, atom_handle, i)
    end if

    if (i /= 0) then
      call mopend("Error in divide box by atoms ")
      return
    end if

 !   write (iw, *) " Number of surface elements = ", nps

    if (nps > na2max .or. nps > na1max) then
  !    write (iw, *) " NPS Doing divide_box by", Sqrt(disex2)
      call divide_box (cosurf, 4, nps, Sqrt(disex2), 20, 0, &
           & surface_handle, i)
    end if

    if (i /= 0) then
      call mopend("Error in divide box by surface ")
      return
    end if

    c_proc = 0

    if (compute_a_part) then

      if (allocated (a_part)) then
        deallocate (a_part)
      end if
      if (nps > na2max .or. nps > na1max) then

        call set_tesselation (surface_handle, i)
        if (i /= 0) then
          call mopend ("CosmoZ:  Tesselation ini error ")
          return
        end if
        ndim = count_short_ints  (cosurf, 4, simulate_aq_dir_int, .false.)

      else

        maxrs = 60*numat

        call simulate_aq_vec (coord, srad, numat, cosurf, nps, nar_csm, &
       & nsetf, nset, rsc, nipsrs, iatsp, tm, ioldcv, maxrs, lenabc, &
       & .false., ndim)

      end if

  !    write(iw,*) ' Number of close-range interactions: ', ndim

      allocate (a_part(ndim) , stat=i)
      if (i /= 0) then
         write(iw,*) ' Allocation failed for a_part'
         call mopend (' Allocation failed for a_part')
         return
      end if

    end if

    if (allocated (m_vec)) then
      deallocate (m_vec)
    end if

    if (use_a_blocks) then
      if (allocated (iblock_pos)) then
        deallocate (iblock_pos)
        deallocate (a_block)
      end if

      allocate (iblock_pos(numat) , stat=i)
      if (i /= 0) then
         write(iw, *) ' Allocation failed for iblock_pos'
         call mopend (' Allocation failed for iblock_pos')
         return
      end if

      ndim = 0
      max_block_size = 0
      do i=1, numat
        iblock_pos(i) = ndim +1
        j = npoints(i+1) - npoints(i)
        if (j > max_block_size) then
          max_block_size = j
        end if
        ndim = ndim + (j*(j+1)) / 2
      end do

  !    write(iw, *) ' Size of the preconditioner = ', ndim
  !    write(iw, *) ' Size of max_block = ', max_block_size

      allocate (m_vec(ndim) , stat=i)
      if (i /= 0) then
         write(iw, *) ' Allocation failed for m_vec'
         call mopend (' Allocation failed for m_vec')
         return
      end if
      allocate (a_block(max_block_size, max_block_size) , stat=i)
      if (i /= 0) then
         write(iw, *) ' Allocation failed for a_block'
         call mopend (' Allocation failed for a_block')
         return
      end if

      a_block = 0

    else

      write(iw, *) ' Size of the preconditioner = ', nps

      allocate (m_vec(nps) , stat=i)
      if (i /= 0) then
         write(iw, *) ' Allocation failed for m_vec'
         call mopend (' Allocation failed for m_vec')
         return
      end if

    end if

  end subroutine coscavz

  subroutine coscanz (srad, coord, nat, cosurf, iatsp, nar_loc, nsetf, &
       & phinet, arat)
    !***********************************************************************
    !
    ! THIS ROUTINE CONSTRUCTS OR UPDATES THE SOLVENT-ACCESSIBLE
    ! SURFACE (SAS)
    ! (Linear-scaling version of the coscan routine from Cosmo)
    !
    !***********************************************************************
    use molkst_C, only: numat
    use cosmo_C, only : lenabc, nps, area, cosvol, rsolv, ioldcv, dirvec, dirsm, &
    n0, isude, sude
    use chanel_C, only: iw
    implicit none
    integer, dimension(lenabc+1), intent (inout) :: iatsp, nar_loc, nsetf
    integer, dimension(numat), intent (in) :: nat
    double precision, dimension(numat), intent (in) :: srad
    double precision, dimension(numat), intent (out) :: arat
    double precision, dimension(lenabc+1, 3), intent (inout) :: phinet
    double precision, dimension(3, numat), intent (inout) :: coord
    double precision, dimension(4, lenabc), intent (inout) :: cosurf
    integer :: i, i0, ik, ilipa, inset, ipm, ips, j, jmax, jps, k, &
         & l, nara, narea, niter, nps0, maxrs, alloc_stat, indi
    double precision :: dist, dist1, dist2, dist3, r, ri, &
         & ri2, rr, sininv, sp, spm, x1, x2, x3, dists

    double precision :: xmax, ymax, zmax, xmin, ymin, zmin, r_max, o_2r
    integer :: nx, ny, nz, ix, iy, iz, i1, i2, l1, k1, ii, jj, &
         & ix1, iy1, iz1, ixfrom, ixto, iyfrom, iyto, izfrom, izto
    integer, dimension(:), allocatable :: atoms_in_box, s_box, box_number, &
         & temp
    logical, allocatable, dimension(:) :: din
    integer, dimension(1082) :: iseg
    double precision, dimension(3) :: xa, xx
    double precision, dimension(3, 1082) :: dirtm
    integer, dimension(:), allocatable :: isort, ipsrs, nipa, lipa
    integer, dimension(:, :), allocatable :: nn
    intrinsic Cos, Sqrt, Min, Max, Int, Allocated
    !
    ! MAKE COORDINATES A BIT ASYMMETRIC IN ORDER TO AVOID
    ! SYMMETRY PROBLEMS WITH CAVITY CONSTRUCTION

    do i = 1, numat
      do j = 1, 3
        coord(j, i) = coord(j, i) + Cos (i*j*.1d0) * 3.0d-9
      end do
    end do

    !
    !       Determing how many boxes are there
    !

    xmax = coord(1, 1)
    ymax = coord(2, 1)
    zmax = coord(3, 1)
    xmin = coord(1, 1)
    ymin = coord(2, 1)
    zmin = coord(3, 1)
    r_max = srad(1)

    do i = 2, numat
      if (coord(1, i) > xmax) then
        xmax = coord(1, i)
      elseif (coord(1, i) < xmin) then
        xmin = coord(1, i)
      end if

      if (coord(2, i) > ymax) then
        ymax = coord(2, i)
      elseif (coord(2, i) < ymin) then
        ymin = coord(2, i)
      end if

      if (coord(3, i) > zmax) then
        zmax = coord(3, i)
      elseif (coord(3, i) < zmin) then
        zmin = coord(3, i)
      end if

      if (srad(i) > r_max) then
        r_max = srad(i)
      end if
    end do

    r_max = r_max + rsolv
    r_max = r_max + r_max   ! cell size

    o_2r = 1 / r_max

    nx = Int ((xmax - xmin) * o_2r)
    if (nx < 1) nx = 1
    if (xmin + nx * r_max < xmax) nx = nx + 1

    ny = Int ((ymax - ymin) * o_2r)
    if (ny < 1) ny = 1
    if (ymin + ny * r_max < ymax) ny = ny + 1

    nz = Int ((zmax - zmin) * o_2r)
    if (nz < 1) nz = 1
    if (zmin + nz * r_max < zmax) nz = nz + 1

    maxrs = 100 * numat
    allocate (atoms_in_box(0:nx*ny*nz), s_box(0:numat-1), &
         & box_number(numat), nn(3, numat), isort(maxrs), &
         & ipsrs(maxrs), nipa(numat), din(Max (numat, 1082)), &
         & stat=alloc_stat)

    if (alloc_stat /= 0) then
      write (iw, *) " Can't allocate memory in COSCANZ"
      go to 100
    end if

    atoms_in_box = 0

    !
    !       Assign atoms to boxes. Boxes are numbered from 0 to n-1
    !

    do i = 1, numat
      ix = Int ((coord(1, i) - xmin) * o_2r)
      if (ix < 0) then
        ix = 0
      elseif (ix >= nx) then
        ix = nx - 1
      end if

      iy = Int ((coord(2, i) - ymin) * o_2r)
      if (iy < 0) then
        iy = 0
      elseif (iy >= ny) then
        iy = ny - 1
      end if

      iz = Int ((coord(3, i) - zmin) * o_2r)
      if (iz < 0) then
        iz = 0
      elseif (iz >= nz) then
        iz = nz - 1
      end if

      box_number(i) = ix + (iy + iz *ny) *nx
      atoms_in_box(box_number(i)) = atoms_in_box(box_number(i)) + 1
    end do

    !
    !       Now we need to collect atoms in the same box together.
    !       The easiest way to do it is by sorting ...
    !

    do i = 0, nx*ny*nz - 1
      atoms_in_box(i+1) = atoms_in_box(i+1) + atoms_in_box(i)
    end do

    do i = 1, numat
      atoms_in_box(box_number(i)) = atoms_in_box(box_number(i)) - 1
      s_box(atoms_in_box(box_number(i))) = i
    end do

    !
    !       It is time to intersect ...
    !
    ilipa = 0
    k = -ny
    do iz = 0, nz - 1
      k = k + ny
      do iy = 0, ny - 1
        l = (iy + k) *nx
        do ix = 0, nx - 1
          i1 = atoms_in_box(l)
          l = l + 1
          i2 = atoms_in_box(l)
          do ii = i1, i2 - 1
            i = s_box(ii)
            ri = srad(i)
            r = ri + rsolv
            rr = r + rsolv
            xa(1:3) = coord(1:3, i)
            izfrom = Max (iz-1, 0)
            izto   = Min (iz+2, nz) - 1
            k1 = (izfrom-1) * ny
            do iz1 = izfrom, izto
              iyfrom = Max (iy-1, 0)
              iyto   = Min (iy+2, ny) - 1
              k1 = k1 + ny
              do iy1 = iyfrom, iyto
                l1 = (iy1 + k1)*nx
                ixfrom = Max (ix-1, 0)
                ixto   = Min (ix+2, nx) - 1
                l1 = l1 + ixfrom - 1
                do ix1 = ixfrom, ixto
                  l1 = l1 + 1
                  do jj = atoms_in_box(l1), atoms_in_box(l1+1) - 1
                    j = s_box(jj)
                    if (j /= i) then
                      dist = (xa(1) - coord(1, j))**2 + &
                           & (xa(2) - coord(2, j))**2 + &
                           & (xa(3) - coord(3, j))**2
                      if (dist < (rr+srad(j))**2) then
                        ilipa = ilipa + 1
                      end if
                    end if
                  end do
                end do   ! ix1
              end do   ! iy1
            end do   ! iz1
          end do
        end do   ! ix
      end do   ! iy
    end do   ! iz
    allocate (temp(ilipa), lipa(ilipa), stat=alloc_stat)
    if (alloc_stat /= 0) then
      write (iw, *) " Can't allocate memory in COSCANZ"
      go to 100
    end if
   !
    ilipa = 0
    k = -ny
    do iz = 0, nz - 1
      k = k + ny
      do iy = 0, ny - 1
        l = (iy + k) *nx
        do ix = 0, nx - 1
          i1 = atoms_in_box(l)
          l = l + 1
          i2 = atoms_in_box(l)

          do ii = i1, i2 - 1
            i = s_box(ii)

            nipa(i) = 0
            ri = srad(i)
            r = ri + rsolv
            rr = r + rsolv
            xa(1:3) = coord(1:3, i)

            izfrom = Max (iz-1, 0)
            izto   = Min (iz+2, nz) - 1
            k1 = (izfrom-1) * ny
            do iz1 = izfrom, izto
              iyfrom = Max (iy-1, 0)
              iyto   = Min (iy+2, ny) - 1
              k1 = k1 + ny
              do iy1 = iyfrom, iyto
                l1 = (iy1 + k1)*nx
                ixfrom = Max (ix-1, 0)
                ixto   = Min (ix+2, nx) - 1
                l1 = l1 + ixfrom - 1
                do ix1 = ixfrom, ixto
                  l1 = l1 + 1

                  do jj = atoms_in_box(l1), atoms_in_box(l1+1) - 1
                    j = s_box(jj)

                    if (j /= i) then
                      dist = (xa(1) - coord(1, j))**2 + &
                           & (xa(2) - coord(2, j))**2 + &
                           & (xa(3) - coord(3, j))**2
                      if (dist < (rr+srad(j))**2) then
                        ! ---
                        ! For some stupid reasons, the code
                        ! below selecting nn atoms depends
                        ! on the order of atoms (and the
                        ! solvation energy of a molecule
                        ! depends on the order of atoms!)
                        ! so to make the code identical to
                        ! original Mopac Cosmo, instead of
                        ! the simple
                        !   nipa(i) = nipa(i) + 1
                        !   ilipa = ilipa + 1
                        !   lipa(ilipa) = j
                        ! we use the following:

                        i0 = ilipa + 1
                        do ik = ilipa, ilipa-nipa(i)+1, -1
                          if (lipa(ik) > j) then
                            lipa(i0) = lipa(ik)
                            i0 = i0 - 1
                          else
                            exit
                          end if
                        end do

                        nipa(i) = nipa(i) + 1
                        ilipa = ilipa + 1
                        lipa(i0) = j
                      end if
                    end if
                  end do
!                  if (ilipa >= 70*numat) then
!                    exit
!                  end if
                end do   ! ix1
!                if (ilipa >= 70*numat) then
!                  exit
!                end if
              end do   ! iy1
!              if (ilipa >= 70*numat) then
!                exit
!              end if
            end do   ! iz1
!            if (ilipa >= 70*numat) then
!              exit
!            end if
          end do
!          if (ilipa >= 70*numat) then
!            exit
!          end if
        end do   ! ix
!        if (ilipa >= 70*numat) then
!          exit
!        end if
      end do   ! iy
!      if (ilipa >= 70*numat) then
!        exit
!      end if
    end do   ! iz
    !
    !       At this stage, array lipa need to be reodered, so
    !       it correspond atoms in order 1...n, instead of
    !       s_box(0) ... s_box(n-1)
    !

    box_number(1) = 0
    do i = 2, numat
      box_number(i) = box_number(i-1) + nipa(i-1)     ! list starts
    end do

    indi = 0
    do ii = 0, numat - 1
      i = s_box(ii)
      do jj = 1, nipa(i)
        temp(box_number(i) + jj) = lipa(indi + jj)
      end do

      indi = indi + nipa(i)
    end do

    lipa(1:indi) = temp(1:indi)

    !
    !       Main loop
    !
    inset = 1
    ilipa = 0
    nps = 0
    area = 0.d0
    cosvol = 0.d0

    do i = 1, numat
      nps0 = nps + 1
      ri = srad(i)
      r = ri + rsolv
      rr = r + rsolv
      ri2 = ri * ri
      xa(1:3) = coord(1:3, i)

      !
      !       SEARCH FOR 3 NEAREST NEIGHBOR ATOMS
      !

      dist1 = 1.d20
      dist2 = 1.d20
      dist3 = 1.d20
      nn(1, i) = 0
      nn(2, i) = 0
      nn(3, i) = 0

      do jj = 1, nipa(i)
        j = lipa(ilipa + jj)
        dist = (xa(1) - coord(1, j))**2 + &
             & (xa(2) - coord(2, j))**2 + &
             & (xa(3) - coord(3, j))**2

        if (dist+0.05d0 < dist3) then
          dist3 = dist
          nn(3, i) = j
        end if

        if (dist3+0.05d0 < dist2) then
          dist = dist2
          dist2 = dist3
          dist3 = dist
          nn(3, i) = nn(2, i)
          nn(2, i) = j
        end if

        if (dist2+0.05d0 < dist1) then
          dist = dist1
          dist1 = dist2
          dist2 = dist
          nn(2, i) = nn(1, i)
          nn(1, i) = j
        end if
      end do

      ilipa = ilipa + nipa(i)

      !
      !       BUILD NEW TRANSFORMATION MATRIX
      !

      if (nn(1, i) == 0) then
        tm(1, 1, i) = 1.d0
        tm(1, 2, i) = 0.d0
        tm(1, 3, i) = 0.d0
      else
        dist1 = (xa(1) - coord(1, nn(1, i)))**2 + &
             & (xa(2) - coord(2, nn(1, i)))**2 + &
             & (xa(3) - coord(3, nn(1, i)))**2
        dist = 1.d0 / Sqrt (dist1)

        tm(1, 1, i) = (coord(1, nn(1, i))-xa(1)) * dist
        tm(1, 2, i) = (coord(2, nn(1, i))-xa(2)) * dist
        tm(1, 3, i) = (coord(3, nn(1, i))-xa(3)) * dist
      end if

      do
        if (nn(2, i) == 0) then
          tm(2, 1, i) = -tm(1, 2, i)
          tm(2, 2, i) = tm(1, 1, i)
          tm(2, 3, i) = 0.d0
          exit
        else
          dist2 = (xa(1) - coord(1, nn(2, i)))**2 + &
               & (xa(2) - coord(2, nn(2, i)))**2 + &
               & (xa(3) - coord(3, nn(2, i)))**2
          dist = 1 / Sqrt (dist2)

          xx(1) = (coord(1, nn(2, i))-xa(1)) * dist
          xx(2) = (coord(2, nn(2, i))-xa(2)) * dist
          xx(3) = (coord(3, nn(2, i))-xa(3)) * dist
          sp = xx(1)*tm(1, 1, i) + xx(2)*tm(1, 2, i) + xx(3)*tm(1, 3, i)

          if (sp*sp > 0.99d0) then
            nn(2, i) = nn(3, i)
            nn(3, i) = 0
            dist2 = dist3
          else
            sininv = 1 / Sqrt (1.d0-sp*sp)
            tm(2, 1, i) = (xx(1)-sp*tm(1, 1, i)) * sininv
            tm(2, 2, i) = (xx(2)-sp*tm(1, 2, i)) * sininv
            tm(2, 3, i) = (xx(3)-sp*tm(1, 3, i)) * sininv
            exit
          end if
        end if
      end do

      tm(3, 1, i) = tm(1, 2, i)*tm(2, 3, i) - tm(2, 2, i)*tm(1, 3, i)
      tm(3, 2, i) = tm(1, 3, i)*tm(2, 1, i) - tm(2, 3, i)*tm(1, 1, i)
      tm(3, 3, i) = tm(1, 1, i)*tm(2, 2, i) - tm(2, 1, i)*tm(1, 2, i)

      !
      !       TRANSFORM DIRVEC ACCORDING TO TM
      !
      do j = 1, 1082
        xx(1) = dirvec(1, j)
        xx(2) = dirvec(2, j)
        xx(3) = dirvec(3, j)
        dirtm(1, j) = xx(1)*tm(1, 1, i) + xx(2)*tm(2, 1, i) + &
             & xx(3)*tm(3, 1, i)
        dirtm(2, j) = xx(1)*tm(1, 2, i) + xx(2)*tm(2, 2, i) + &
             & xx(3)*tm(3, 2, i)
        dirtm(3, j) = xx(1)*tm(1, 3, i) + xx(2)*tm(2, 3, i) + &
             & xx(3)*tm(3, 3, i)
      end do

      !
      !       FIND THE POINTS OF THE BASIC GRID ON THE SAS
      !

      narea = 0
      loop: do j = 1, 1082
        din(j) = .false.
        xx(1) = xa(1) + dirtm(1, j) *r
        xx(2) = xa(2) + dirtm(2, j) *r
        xx(3) = xa(3) + dirtm(3, j) *r
        !
        !             --- WE NEED ONLY TRY THOSE ATOMS INTERSECTING ATOM I
        !
        do ik = ilipa - nipa(i) + 1, ilipa
          k = lipa(ik)
          dist = (xx(1) - coord(1, k))**2 + &
               & (xx(2) - coord(2, k))**2 + &
               & (xx(3) - coord(3, k))**2
          dist = Sqrt (dist) - rsolv - srad(k)
!
! jjps 8-22-2022:  An intermittent error caused the solvent-accessible surface to
! change size significantly, e.g., by 6 square Angstroms in a 1300 atom protein,
! on making a small change, 0.1 Angstroms total, in geometry.
! This error was traced to a special case when "dist" was almost zero.  The error
! was corrected by replacing the original test "if (dist < 0) cycle loop" with
! the text on the next line.  Surprisingly, this appears to have fixed the bug!
!
          if (dist < -0.001d0) cycle loop
        end do

        narea = narea + 1
        cosvol = cosvol + ri2 * dirvec(4, j) * &
             & (dirtm(1, j)*xa(1)+dirtm(2, j)*xa(2) + dirtm(3, j)*xa(3)+ri)
        area = area + ri2 * dirvec(4, j)
        din(j) = .true.
      end do loop

      if (narea /= 0) then
        !
        !  IF HYDROGEN, THEN USE THE SMALLER SET OF POINTS (NORMALLY 12 POINTS)
        !  OTHERWISE, USE THE LARGER SET (NORMALLY 42 POINTS)
        !
        i0 = 1
        if (nat(i) == 1) then
          i0 = 2
        end if

        jmax = n0(i0)
        i0 = (i0-1) * n0(1)
        do j = 1, jmax
          nps = nps + 1
          if (nps > lenabc) then
            call mopend ("NPS IS GREATER THAN &
                 &LENABC-USE SMALLER NSPA")
            return
          else
            iatsp(nps) = i
            xx(1) = dirsm(1, i0+j)
            xx(2) = dirsm(2, i0+j)
            xx(3) = dirsm(3, i0+j)
            cosurf(1, nps) = xx(1)*tm(1, 1, i) + &
                 & xx(2)*tm(2, 1, i) + &
                 & xx(3)*tm(3, 1, i)
            cosurf(2, nps) = xx(1)*tm(1, 2, i) + &
                 & xx(2)*tm(2, 2, i) + &
                 & xx(3)*tm(3, 2, i)
            cosurf(3, nps) = xx(1)*tm(1, 3, i) + &
                 & xx(2)*tm(2, 3, i) + &
                 & xx(3)*tm(3, 3, i)
          end if
        end do

        niter = 0
        do
          niter = niter + 1
          do ips = nps0, nps
            nar_loc(ips) = 0
            phinet(ips, 1) = 0.d0
            phinet(ips, 2) = 0.d0
            phinet(ips, 3) = 0.d0
          end do

          do j = 1, 1082
            if (din(j)) then
              ipm = nps0
              spm = -1.d0
              x1 = dirtm(1, j)
              x2 = dirtm(2, j)
              x3 = dirtm(3, j)
              do ips = nps0, nps
                sp = x1*cosurf(1, ips)+ x2*cosurf(2, ips)+ x3*cosurf(3, ips)
                if (sp >= spm) then
                  spm = sp*(1.d0+1.d-14)
                  ipm = ips
                end if
              end do

              iseg(j) = ipm
              nar_loc(ipm) = nar_loc(ipm) + 1
              phinet(ipm, 1)=phinet(ipm, 1) + dirtm(1, j) * dirvec(4, j)
              phinet(ipm, 2)=phinet(ipm, 2) + dirtm(2, j) * dirvec(4, j)
              phinet(ipm, 3)=phinet(ipm, 3) + dirtm(3, j) * dirvec(4, j)
            end if
          end do

          ips = nps0 - 1
          loop1: do
            ips = ips + 1
            do while (nar_loc(ips) == 0)
              niter = 1
              nps = nps - 1
              if (ips > nps) exit loop1
              do jps = ips, nps
                nar_loc(jps) = nar_loc(jps+1)
                phinet(jps, 1) = phinet(jps+1, 1)
                phinet(jps, 2) = phinet(jps+1, 2)
                phinet(jps, 3) = phinet(jps+1, 3)
              end do
            end do

            dists = phinet(ips, 1) ** 2 + &
                 & phinet(ips, 2) ** 2 + &
                 & phinet(ips, 3) ** 2

            dists = Max (dists, 1.d-20)
            dist = 1.d0 / Sqrt (dists)
            cosurf(1, ips) = phinet(ips, 1) * dist
            cosurf(2, ips) = phinet(ips, 2) * dist
            cosurf(3, ips) = phinet(ips, 3) * dist
            if (ips >= nps) exit
          end do loop1

          if (niter >= 2) exit
        end do
        !
        !        NOW ALL SEGMENTS ARE FINALLY DEFINED AND THE ASSOCIATED
        !        BASIC GRID POINTS ARE CLOSE-PACKED
        !
        do ips = nps0, nps
          nsetf(ips) = inset
          inset = inset + nar_loc(ips)
          nar_loc(ips) = 0
          cosurf(4, ips) = 0.d0
          cosurf(1, ips) = cosurf(1, ips) * ri + xa(1)
          cOsurf(2, ips) = cosurf(2, ips) * ri + xa(2)
          cosurf(3, ips) = cosurf(3, ips) * ri + xa(3)
        end do

        do j = 1, 1082
          if (din(j)) then
            ipm = iseg(j)
            nara = nar_loc(ipm)
            nset(nsetf(ipm)+nara) = j
            nar_loc(ipm) = nara + 1
            cosurf(4, ipm) = cosurf(4, ipm) + dirvec(4, j) * ri2
          end if
        end do
      end if
    end do

    !
    !       HERE THE CONSTRUCTION FOR A SINGLE ATOM ENDS
    !

    do i = 1, numat
      din(i) = .true.
    end do

    do j = 1, nps
      din(iatsp(j)) = .false.
    End do
    s_box(0:numat-1) = 0
    do i=1, nps
      j = iatsp(i) -1
      s_box(j) = s_box(j) + Int(cosurf(4, i))
    end do

    do i=1, numat
      s_box(i-1) = Int(s_box(i-1) / (srad(i))**2 * (srad(i) + rsolv)**2)
    end do

 !   write(iw, *) ' Cosmo atomic radii and accessible surface area '

 !   do i=1, numat
  !    write(iw, '(I10, F12.4, I10)') i, srad(i), s_box(i-1)
  !  end do
    !
    !     NOW THE SEGMENT FORMATION ON ALL ATOMS IS FINISHED
    !     NOW THE CLOSURE OF THE CONCAVE REGIONS OF THE SURFACE WILL BE DONE
    !

    if (ioldcv == 0) then
      i = max(numat, 1082)
      call surclo (coord, nipa, lipa, din, i, rsc, isort, &
           &      ipsrs, nipsrs, nat, srad, cosurf, iatsp, &
           &      nar_loc, nsetf, isude, sude, maxrs)
    end if

    cosvol = cosvol / 3

    npoints(1:numat) = 0
    do i=1, nps
      j = iatsp(i)
      npoints(j) = npoints(j) + 1
    end do
    !
    !       At this point, the npoints array has number of elements
    !       for each atom. Transform it to the list ...
    !
    j = npoints(1)
    npoints(1) = 1
    do i = 2, numat
      k = npoints(i)
      npoints(i) = npoints(i-1) + j
      j = k
    end do
    npoints(numat+1) = npoints(numat) + j

    arat(1:numat) = 0.d0
    do i = 1, nps
      j = iatsp(i)
      arat(j) = arat(j) + cosurf(4, i)
    end do


    deallocate (atoms_in_box, s_box, box_number, din, &
         & nn, isort, ipsrs, nipa, lipa, temp, stat=alloc_stat)

    if (alloc_stat /= 0) then
      write (iw, *) " Deallocation error in CoscanZ"
    end if

    if (allocated (r_vec)) then
      deallocate (r_vec, p_vec, q_vec, z_vec, &
           & a_diag, stat=alloc_stat)
      if  (alloc_stat /= 0) then
        write (iw, *) " Deallocation error in CoscanZ (2)"
        goto 100
      end if
    end if

    allocate (r_vec(nps), p_vec(nps), q_vec(Max (numat, nps)), &
         & z_vec(nps), a_diag(nps), stat=alloc_stat)

    if (alloc_stat /= 0) then
      write (iw, *) " Allocation error in CoscanZ"
    end if

100 continue

  end subroutine coscanz

  subroutine aq_vec (coord, srad, numat, cosurf, nps, nar_csm, nsetf, &
       & nset, rsc, nipsrs, iatsp, tm, ioldcv, maxrs, lenabc, a_diag, q, v)
    !
    ! Computes A*q product using N**2 algorithm
    !
    use cosmo_C, only : dirvec, disex2
    !
    !.. Implicit Declarations ..
    implicit none
    !
    !.. Formal Arguments ..
    integer, intent(in) :: numat, nps, ioldcv, maxrs, lenabc

    double precision, dimension(3, numat), intent(in) :: coord
    double precision, dimension(numat), intent(in) :: srad
    double precision, dimension(4, nps), intent(in) :: cosurf
    integer, dimension(lenabc+1), intent(in) :: nar_csm, nsetf, iatsp
    integer, dimension(*), intent(in) :: nset
    double precision, dimension(4, maxrs), intent(in) :: rsc
    integer, dimension(lenabc), intent(in) :: nipsrs
    double precision, dimension(3, 3, numat), intent(in) :: tm
    double precision, dimension(nps), intent(in) :: a_diag
    double precision, dimension(nps), intent(in) :: q

    double precision, dimension(nps), intent(out) :: v

    !
    ! .. Parameters
    !
    !.. Local Scalars ..
    integer :: i, j, ii, jj, k, l, nfl1, nfl2, ijpos
    double precision :: aa, d2, ri, rj, x1, x2, x3, x4
    !
    !.. Local Arrays ..
    double precision, dimension(4, 500, 2) :: finel
    double precision xi(3), xj(3), xa(3), xb(3)
    v = 0
    ijpos = 0

    do ii = 1, nps
      i = iatsp(ii)
      xa(1:3) = cosurf(1:3, ii)

      if (.not. compute_a_part) then
        ri = srad(i)
        xi(1:3) = coord(1:3, i)
        call mfinel (ii, 1, finel, nar_csm, nsetf, nset, rsc, &
           & nipsrs, dirvec, tm(1, 1, i), xi, ri, &
           & nfl1, ioldcv, maxrs, lenabc, numat)
      end if

      do jj = 1, ii-1
        j = iatsp(jj)
        xb(1:3) = cosurf(1:3, jj)

        d2 = (xb(1)-xa(1))**2 + (xb(2)-xa(2))**2 + &
             & (xb(3)-xa(3))**2

        if (d2 > disex2) then
          aa = 1.d0 / Sqrt (d2)
        else
          if (compute_a_part) then
            ijpos = ijpos +1
            aa = a_part(ijpos)
          else
            xj(1:3) = coord(1:3, j)
            rj = srad(j)
            call mfinel (jj, 2, finel, nar_csm, nsetf, &
               & nset, rsc, nipsrs, dirvec, &
               & tm(1, 1, j), xj, rj, nfl2, &
               & ioldcv, maxrs, lenabc, numat)

            aa = 0.d0
            do k = 1, nfl1
              x1 = finel(1, k, 1)
              x2 = finel(2, k, 1)
              x3 = finel(3, k, 1)
              x4 = finel(4, k, 1)

              do l = 1, nfl2
                aa = aa + x4 * finel(4, l, 2) / &
                   & Sqrt ((x1-finel(1, l, 2))**2 + &
                   &       (x2-finel(2, l, 2))**2 + &
                   &       (x3-finel(3, l, 2))**2)
              end do
            end do

            aa = aa / (cosurf(4, ii) * cosurf(4, jj))
          end if
        end if
        v(ii) = v(ii) + aa * q(jj)
        v(jj) = v(jj) + aa * q(ii)
      end do
    end do
    v = v + a_diag * q
  end subroutine aq_vec

  subroutine simulate_aq_vec (coord, srad, numat, cosurf, nps, nar_csm, nsetf, &
       & nset, rsc, nipsrs, iatsp, tm, ioldcv, maxrs, lenabc, compute, npos)
    !
    ! Computes number of short-range elements in A matrix and
    ! computes the short-range A matrix elements if requested
    ! using N**2 algorithm (off-diagonal elements only)
    !
    use cosmo_C, only : dirvec, disex2

    !
    !.. Implicit Declarations ..
    implicit none
    !
    !.. Formal Arguments ..
    integer, intent(in) :: numat, nps, ioldcv, maxrs, lenabc

    double precision, dimension(3, numat), intent(in) :: coord
    double precision, dimension(numat), intent(in) :: srad
    double precision, dimension(4, nps), intent(in) :: cosurf
    integer, dimension(lenabc+1), intent(in) :: nar_csm, nsetf, iatsp
    integer, dimension(*), intent(in) :: nset
    double precision, dimension(4, maxrs), intent(in) :: rsc
    integer, dimension(lenabc), intent(in) :: nipsrs
    double precision, dimension(3, 3, numat), intent(in) :: tm
    logical, intent(in) :: compute
    integer, intent(out) :: npos
    integer :: i, j, ii, jj, k, l, nfl1, nfl2
    double precision :: aa, d2, ri, rj, x1, x2, x3, x4
    double precision, dimension(4, 500, 2) :: finel
    double precision xi(3), xj(3), xa(3), xb(3)
    npos = 0

    do ii = 1, nps
      i = iatsp(ii)
      ri = srad(i)
      xi(1:3) = coord(1:3, i)
      xa(1:3) = cosurf(1:3, ii)

      if(compute) then
        call mfinel (ii, 1, finel, nar_csm, nsetf, nset, rsc, &
           & nipsrs, dirvec, tm(1, 1, i), xi, ri, &
           & nfl1, ioldcv, maxrs, lenabc, numat)
      end if

      do jj = 1, ii -1
        j = iatsp(jj)
        xj(1:3) = coord(1:3, j)
        xb(1:3) = cosurf(1:3, jj)

        d2 = (xb(1)-xa(1))**2 + (xb(2)-xa(2))**2 + &
             & (xb(3)-xa(3))**2

        if (d2 <= disex2) then
          npos = npos +1
          if(compute) then
            j = iatsp(jj)
            rj = srad(j)
            call mfinel (jj, 2, finel, nar_csm, nsetf, &
               & nset, rsc, nipsrs, dirvec, &
               & tm(1, 1, j), xj, rj, nfl2, &
               & ioldcv, maxrs, lenabc, numat)

            aa = 0.d0
            do k = 1, nfl1
              x1 = finel(1, k, 1)
              x2 = finel(2, k, 1)
              x3 = finel(3, k, 1)
              x4 = finel(4, k, 1)

              do l = 1, nfl2
                aa = aa + x4 * finel(4, l, 2) / &
                   & Sqrt ((x1-finel(1, l, 2))**2 + &
                   &       (x2-finel(2, l, 2))**2 + &
                   &       (x3-finel(3, l, 2))**2)
              end do
            end do

            aa = aa / (cosurf(4, ii) * cosurf(4, jj))

            a_part(npos) = aa
          end if
        end if
      end do
    end do
  end subroutine simulate_aq_vec

  subroutine aq_dir_int (ind1, n1, ind2, n2, c, nc, q, r, same)
    !
    ! Computes part of the A*q product for near surface elements
    !

    use common_arrays_C, only: coord
    use molkst_C, only : numat
    use cosmo_C, only: dirvec, lenabc, ioldcv, disex2, cosurf, srad, &
      nar_csm, iatsp, nsetf
    implicit none
    integer, intent(in) :: n1, n2, nc
    integer, intent(in), dimension(*) :: ind1, ind2
    double precision, intent(in), dimension(nc, *) :: c
    double precision, intent(in), dimension(*) :: q
    double precision, intent(inout), dimension(*) :: r
    logical, intent(in) :: same
    integer :: i, j, ii, jj, i3, j3, k, l, nfl1, nfl2, maxrs
    integer, save :: ijpos
    double precision :: aa, d2, ri, rj, x1, x2, x3, x4
    double precision, dimension(4, 500, 2) :: finel
    double precision xi(3), xj(3), xa(3), xb(3)
!
! Dummy statement to "use" c
!
    ri = c(1,1)
    if (new_iteration) then
      ijpos = 0
      new_iteration = .false.
    end if

    maxrs = 60*numat

    if (same) then
      do i3=1, n1
        ii = ind1(i3)
        i = iatsp(ii)
        ri = srad(i)
        xi(1:3) = coord(1:3, i)
        xa(1:3) = cosurf(1:3, ii)

        if (.not. compute_a_part) then
          call mfinel (ii, 1, finel, nar_csm, nsetf, nset, rsc, &
             & nipsrs, dirvec, tm(1, 1, i), xi, ri, &
             & nfl1, ioldcv, maxrs, lenabc, numat)
        end if

        do j3 = 1, i3 - 1
          jj = ind1(j3)
          j = iatsp(jj)
          xj(1:3) = coord(1:3, j)
          xb(1:3) = cosurf(1:3, jj)

          d2= (xb(1)-xa(1))**2 + (xb(2)-xa(2))**2 + (xb(3)-xa(3))**2

          if (d2 > disex2) then
            aa = 1.d0 / Sqrt (d2)
          else
            if (compute_a_part) then
              ijpos = ijpos +1
              aa = a_part(ijpos)
            else
              rj = srad(j)
              call mfinel (jj, 2, finel, nar_csm, nsetf, &
                 & nset, rsc, nipsrs, dirvec, &
                 & tm(1, 1, j), xj, rj, nfl2, &
                 & ioldcv, maxrs, lenabc, numat)

              aa = 0.d0
              do k = 1, nfl1
                x1 = finel(1, k, 1)
                x2 = finel(2, k, 1)
                x3 = finel(3, k, 1)
                x4 = finel(4, k, 1)

                do l = 1, nfl2
                  aa = aa + x4 * finel(4, l, 2) / &
                     & Sqrt ((x1-finel(1, l, 2))**2+ &
                     & (x2-finel(2, l, 2))**2+ &
                     & (x3-finel(3, l, 2))**2)
                end do
              end do

              aa = aa / (cosurf(4, ii) * cosurf(4, jj))
            end if
          end if

          r(ii) = r(ii) + aa * q(jj)
          r(jj) = r(jj) + aa * q(ii)
        end do
      end do
    else
      do i3 = 1, n1
        ii = ind1(i3)
        i = iatsp(ii)
        ri = srad(i)
        xi(1:3) = coord(1:3, i)
        xa(1:3) = cosurf(1:3, ii)

        if (.not. compute_a_part) then
          call mfinel (ii, 1, finel, nar_csm, nsetf, nset, rsc, &
             & nipsrs, dirvec, tm(1, 1, i), xi, ri, &
             & nfl1, ioldcv, maxrs, lenabc, numat)
        end if

        do j3 = 1, n2
          jj = ind2(j3)
          j = iatsp(jj)
          xj(1:3) = coord(1:3, j)
          xb(1:3) = cosurf(1:3, jj)

          d2 = (xb(1)-xa(1))**2 + (xb(2)-xa(2))**2 + (xb(3)-xa(3))**2

          if (d2 > disex2) then
            aa = 1.d0 / Sqrt (d2)
          else
            if (compute_a_part) then
              ijpos = ijpos +1
              aa = a_part(ijpos)
            else
              rj = srad(j)
              call mfinel (jj, 2, finel, nar_csm, nsetf, &
                 & nset, rsc, nipsrs, dirvec, &
                 & tm(1, 1, j), xj, rj, nfl2, &
                 & ioldcv, maxrs, lenabc, numat)

              aa = 0.d0
              do k = 1, nfl1
                x1 = finel(1, k, 1)
                x2 = finel(2, k, 1)
                x3 = finel(3, k, 1)
                x4 = finel(4, k, 1)

                do l = 1, nfl2
                  aa = aa + x4 * finel(4, l, 2) / &
                     & Sqrt ((x1-finel(1, l, 2))**2+ &
                     & (x2-finel(2, l, 2))**2+ &
                     & (x3-finel(3, l, 2))**2)
                end do
              end do

              aa = aa / (cosurf(4, ii) * cosurf(4, jj))
            end if
          end if

          r(ii) = r(ii) + aa * q(jj)
          r(jj) = r(jj) + aa * q(ii)
        end do
      end do
    end if
  end subroutine aq_dir_int

  subroutine simulate_aq_dir_int (ind1, n1, ind2, n2, c, nc, same, compute, &
                & npos)

    !
    ! Computes number of short-range elements in A matrix and
    ! computes the short-range A matrix elements if requested
    !

    use common_arrays_C, only: coord
    use molkst_C, only : numat
    use cosmo_C, only: dirvec, lenabc, ioldcv, disex2, cosurf, srad, &
      iatsp, nar_csm, nsetf
    implicit none
    integer, intent(in) :: n1, n2, nc
    integer, intent(in), dimension(*) :: ind1, ind2
    double precision, intent(in), dimension(nc, *) :: c
    logical, intent(in) :: same, compute
    integer, intent (inout) :: npos
    integer :: i, j, ii, jj, i3, j3, k, l, nfl1, nfl2, maxrs
    double precision :: aa, d2, ri, rj, x1, x2, x3, x4
    double precision, dimension(4, 500, 2) :: finel
    double precision xi(3), xj(3), xa(3), xb(3)
!
! Dummy statement to "use" c
!
    ri = c(1,1)
    maxrs = 60*numat

    if (same) then
      do i3=1, n1
        ii = ind1(i3)
        i = iatsp(ii)
        ri = srad(i)
        xi(1:3) = coord(1:3, i)
        xa(1:3) = cosurf(1:3, ii)

        if (compute) then
          call mfinel (ii, 1, finel, nar_csm, nsetf, nset, rsc, &
             & nipsrs, dirvec, tm(1, 1, i), xi, ri, &
             & nfl1, ioldcv, maxrs, lenabc, numat)
        end if

        do j3 = 1, i3 -1
          jj = ind1(j3)
          j = iatsp(jj)
          xj(1:3) = coord(1:3, j)
          xb(1:3) = cosurf(1:3, jj)

          d2= (xb(1)-xa(1))**2 + (xb(2)-xa(2))**2 + (xb(3)-xa(3))**2

          if (d2 <= disex2) then
            npos = npos +1
            if (compute) then
              rj = srad(j)
              call mfinel (jj, 2, finel, nar_csm, nsetf, &
                 & nset, rsc, nipsrs, dirvec, &
                 & tm(1, 1, j), xj, rj, nfl2, &
                 & ioldcv, maxrs, lenabc, numat)

              aa = 0.d0
              do k = 1, nfl1
                x1 = finel(1, k, 1)
                x2 = finel(2, k, 1)
                x3 = finel(3, k, 1)
                x4 = finel(4, k, 1)

                do l = 1, nfl2
                  aa = aa + x4 * finel(4, l, 2) / &
                       & Sqrt ((x1-finel(1, l, 2))**2+ &
                       & (x2-finel(2, l, 2))**2+ &
                       & (x3-finel(3, l, 2))**2)
                end do
              end do

              aa = aa / (cosurf(4, ii) * cosurf(4, jj))

              a_part(npos) = aa
            end if
          end if
        end do
      end do
    else
      do i3 = 1, n1
        ii = ind1(i3)
        i = iatsp(ii)
        ri = srad(i)
        xi(1:3) = coord(1:3, i)
        xa(1:3) = cosurf(1:3, ii)
        if (compute) then
          call mfinel (ii, 1, finel, nar_csm, nsetf, nset, rsc, &
             & nipsrs, dirvec, tm(1, 1, i), xi, ri, &
             & nfl1, ioldcv, maxrs, lenabc, numat)
        end if
        do j3 = 1, n2
          jj = ind2(j3)
          j = iatsp(jj)
          xj(1:3) = coord(1:3, j)
          xb(1:3) = cosurf(1:3, jj)

          d2 = (xb(1)-xa(1))**2 + (xb(2)-xa(2))**2 + (xb(3)-xa(3))**2

          if (d2 <= disex2) then
            npos = npos +1

            if (compute) then
              rj = srad(j)
              call mfinel (jj, 2, finel, nar_csm, nsetf, &
                 & nset, rsc, nipsrs, dirvec, &
                 & tm(1, 1, j), xj, rj, nfl2, &
                 & ioldcv, maxrs, lenabc, numat)

              aa = 0.d0
              do k = 1, nfl1
                x1 = finel(1, k, 1)
                x2 = finel(2, k, 1)
                x3 = finel(3, k, 1)
                x4 = finel(4, k, 1)

                do l = 1, nfl2
                  aa = aa + x4 * finel(4, l, 2) / &
                     & Sqrt ((x1-finel(1, l, 2))**2+ &
                     & (x2-finel(2, l, 2))**2+ &
                     & (x3-finel(3, l, 2))**2)
                end do
              end do

              aa = aa / (cosurf(4, ii) * cosurf(4, jj))

              a_part(npos) = aa
            end if
          end if
        end do
      end do
    end if
  end subroutine simulate_aq_dir_int

  subroutine precond_aq_dir_int (ind1, n1, ind2, n2, c, nc, same, compute, &
                & npos)
    !
    ! Computes block preconditioner
    !
    use cosmo_C, only : iatsp, cosurf, disex2
    implicit none
    integer, intent(in) :: n1, n2, nc
    integer, intent(in), dimension(*) :: ind1, ind2
    double precision, intent(in), dimension(nc, *) :: c
    logical, intent(in) :: same, compute
    integer, intent (inout) :: npos
    integer :: i, j, ii, jj, i3, j3, ips, jps
    double precision :: aa, d2
    double precision xa(3), xb(3)
!
! dummy statement to "use" compute and c
!
    if (compute) aa = c(1,1)
    m_vec = 0.d0
    if (same) then
      do i3=1, n1
        ii = ind1(i3)
        i = iatsp(ii)
        xa(1:3) = cosurf(1:3, ii)

        do j3 = 1, i3 -1
          jj = ind1(j3)
          j = iatsp(jj)
          xb(1:3) = cosurf(1:3, jj)

          d2 = (xb(1)-xa(1))**2 + (xb(2)-xa(2))**2 + &
              & (xb(3)-xa(3))**2

          if (d2 > disex2) then
            aa = 1.d0 / Sqrt (d2)
          else
            npos = npos +1
            aa = a_part(npos)
          end if
          if (i == j) then ! same atom
            ips = ii - npoints(i) +1
            jps = jj - npoints(i) +1

            if (ips >= jps) then
              m_vec(iblock_pos(i) -1 + (ips*(ips-1))/2 + jps) = aa
            else
              m_vec(iblock_pos(i) -1 + (jps*(jps-1))/2 + ips) = aa
            end if

          end if

        end do
      end do

    else

      do i3 = 1, n1
        ii = ind1(i3)
        i = iatsp(ii)
        xa(1:3) = cosurf(1:3, ii)

        do j3 = 1, n2
          jj = ind2(j3)
          j = iatsp(jj)
          xb(1:3) = cosurf(1:3, jj)

          d2 = (xb(1)-xa(1))**2 + (xb(2)-xa(2))**2 + &
              & (xb(3)-xa(3))**2

          if (d2 > disex2) then
            aa = 1.d0 / Sqrt (d2)
          else
            npos = npos +1
            aa = a_part(npos)
          end if

          if (i == j) then ! same atom

            ips = ii - npoints(i) +1
            jps = jj - npoints(i) +1
            if (ips >= jps) then
              m_vec(iblock_pos(i) -1 + (ips*(ips-1))/2 + jps) = aa
            else
              m_vec(iblock_pos(i) -1 + (jps*(jps-1))/2 + ips) = aa
            end if

          end if

        end do
      end do
    end if

  end subroutine precond_aq_dir_int

  subroutine aq_mult_int (ind, n, psi, p, x0, y0, z0, y_norm, pmn, c, n3, &
       & q, r)
    !
    ! Computes part of the A*q product for far surface elements,
    ! using local expansions
    !
    implicit none
    integer, intent(in) :: n, p, n3
    integer, intent(in), dimension(*) :: ind
    complex (kind=dcmplx_kind), dimension(-p:p, 0:p), intent(in) :: psi
    double precision, dimension(-p:p, 0:p), intent(in) :: y_norm
    double precision, dimension(-p:p, 0:p), intent(out) :: pmn
    double precision, intent(in), dimension(n3, *) :: c
    double precision, intent(in), dimension(*) :: q
    double precision, intent(inout), dimension(*) :: r
    double precision, intent(in) :: x0, y0, z0
    integer :: i, j, k
    double precision :: dx, dy, dz, d, phi, cos_t, t
    complex (kind=dcmplx_kind) :: tc
    intrinsic Real, Cmplx, Atan2, Sqrt, Exp
!
! Dummy statement to "use" q
!
    dx = q(1)
    do i = 1, n
      dx = c(1, ind(i)) - x0
      dy = c(2, ind(i)) - y0
      dz = c(3, ind(i)) - z0

      d = Sqrt (dx**2 + dy**2 + dz**2)
      cos_t = dz / d
      phi = Atan2 (dy, dx)

      call get_legendre (p, cos_t, pmn)

      t = 0.d0
      do j = 0, p
        tc = (0.d0, 0.d0)

        do k = 1, j
          tc = tc + y_norm(k, j) * pmn(k, j) * d**j &
               & * psi(k, j) * Exp (Cmplx (0.d0, k*phi, dcmplx_kind))
        end do

        t = t + 2.d0 * Real (tc) + pmn(0, j) * d**j * Real (psi(0, j))
      end do

      r(ind(i)) = r(ind(i)) + t

    end do

  end subroutine aq_mult_int

  subroutine aq_far_int (ind, n, psi, p, x0, y0, z0, y_norm, pmn, c, nc, &
       & q, r)
    !
    ! Computes part of the A*q product for far surface elements,
    ! using multipole expansions
    !
    implicit none
    integer, intent(in) :: n, p, nc
    integer, intent(in), dimension(*) :: ind
    complex (kind=dcmplx_kind), dimension(-p:p, 0:p), intent(in) :: psi
    double precision, dimension(-p:p, 0:p), intent(in) :: y_norm
    double precision, dimension(-p:p, 0:p), intent(out) :: pmn
    double precision, intent(in), dimension(nc, *) :: c
    double precision, intent(in), dimension(*) :: q
    double precision, intent(inout), dimension(*) :: r
    double precision, intent(in) :: x0, y0, z0
    integer :: i, j, k
    double precision :: dx, dy, dz, d, phi, cos_t, t
    complex (kind=dcmplx_kind) :: tc
    intrinsic Real, Cmplx, Atan2, Exp, Sqrt
!
! Dummy statement to "use" q
!
    dx = q(1)
    do i = 1, n
      dx =  c(1, ind(i)) - x0
      dy =  c(2, ind(i)) - y0
      dz =  c(3, ind(i)) - z0

      d = Sqrt (dx**2 + dy**2 + dz**2)
      cos_t = dz / d
      phi = Atan2 (dy, dx)

      call get_legendre (p, cos_t, pmn)

      t = 0
      do j = 0, p
        tc = (0.d0, 0.d0)
        do k =  1, j
          tc = tc + y_norm(k, j) * pmn(k, j) / d**(j+1) &
               *psi(k, j) * Exp (Cmplx (0, k*phi, dcmplx_kind))

        end do
        t = t + 2.d0 * Real (tc) + pmn(0, j) / d**(j+1) * Real (psi(0, j))
      end do

      r(ind(i)) = r(ind(i)) + t
    end do

  end subroutine aq_far_int

  subroutine bz_far_int (ind, n, psi, p, x0, y0, z0, y_norm, pmn, c, nc, q, r)
    !
    ! Computes part of the B*q product for far surface elements,
    ! using multipole expansions
    !


    use cosmo_C, only: cosurf
    implicit none
    integer, intent(in) :: n, p, nc
    integer, intent(in), dimension(*) :: ind
    complex (kind=dcmplx_kind), dimension(-p:p, 0:p), intent(in) :: psi
    double precision, dimension(-p:p, 0:p), intent(in) :: y_norm
    double precision, dimension(-p:p, 0:p), intent(out) :: pmn
    double precision, intent(in), dimension(nc, *) :: c
    double precision, intent(in), dimension(*) :: q
    double precision, intent(inout), dimension(*) :: r
    double precision, intent(in) :: x0, y0, z0
    integer :: i, ii, j, jj, k
    double precision :: dx, dy, dz, d, phi, cos_t, t
    complex (kind=dcmplx_kind) :: tc
    intrinsic Real, Cmplx, Atan2, Sqrt, Exp
!
! Dummy statement to "use" q and c
!
    dx = q(1) + c(1,1)
    do ii = 1, n
      i = ind(ii)  ! atom number
      do jj = npoints(i), npoints(i+1) - 1

        dx =  cosurf(1, jj) - x0
        dy =  cosurf(2, jj) - y0
        dz =  cosurf(3, jj) - z0

        d = Sqrt (dx**2 + dy**2 + dz**2)
        cos_t = dz / d
        phi = Atan2 (dy, dx)

        call get_legendre (p, cos_t, pmn)

        t = 0.d0
        do j = 0, p
          tc = (0.d0, 0.d0)
          do k = 1, j
            tc = tc + y_norm(k, j) * pmn(k, j) / d**(j+1) &
                 & * psi(k, j) * Exp (Cmplx (0.d0, k*phi, dcmplx_kind))

          end do
          t = t + 2.d0 * Real (tc) + pmn(0, j) / d**(j+1) * Real(psi(0, j))
        end do

        r(jj) = r(jj) + t
      end do
    end do

  end subroutine bz_far_int

  subroutine bz_mult_int (ind, n, psi, p, x0, y0, z0, y_norm, pmn, c, nc, &
       & q, r)
    !
    ! Computes part of the B*q product for far surface elements,
    ! using local expansions
    !

    use cosmo_C, only: cosurf

    !
    !.. Implicit Declarations ..
    implicit none
    !
    !.. Formal Arguments ..
    integer, intent(in) :: n, p, nc
    integer, intent(in), dimension(*) :: ind
    complex (kind=dcmplx_kind), dimension(-p:p, 0:p), intent(in) :: psi
    double precision, dimension(-p:p, 0:p), intent(in) :: y_norm
    double precision, dimension(-p:p, 0:p), intent(out) :: pmn
    double precision, intent(in), dimension(nc, *) :: c
    double precision, intent(in), dimension(*) :: q
    double precision, intent(inout), dimension(*) :: r
    double precision, intent(in) :: x0, y0, z0
    !
    !.. Local Scalars ..
    integer :: i, ii, j, jj, k
    double precision :: dx, dy, dz, d, phi, cos_t, t
    complex (kind=dcmplx_kind) :: tc
    !
    !.. Intrinsic Functions ..
    intrinsic Real, Atan2, Exp, Sqrt, Cmplx
!
! Dummy statement to "use" q and c
!
    dx = q(1) + c(1,1)
    do ii = 1, n
      i = ind(ii)  ! atom number
      do jj = npoints(i), npoints(i+1) - 1

        dx =  cosurf(1, jj) - x0
        dy =  cosurf(2, jj) - y0
        dz =  cosurf(3, jj) - z0

        d = Sqrt (dx**2 + dy**2 + dz**2)
        cos_t = dz / d
        phi = Atan2 (dy, dx)

        call get_legendre (p, cos_t, pmn)

        t = 0.d0
        do j = 0, p
          tc = (0.d0, 0.d0)
          do k = 1, j
            tc = tc + y_norm(k, j) * pmn(k, j) * d**j &
                 & * psi(k, j) * Exp (Cmplx (0.d0, k*phi, dcmplx_kind))

          end do
          t = t + 2.d0 * Real (tc) + pmn(0, j) * d**j * Real (psi(0, j))
        end do

        r(jj) = r(jj) + t
      end do
    end do

  end subroutine bz_mult_int

  subroutine bp_dir_int (ind1, n1, ind2, n2, c, nc, q, r, same)
    !
    ! Computes part of the B*q product for near surface elements
    !

    use common_arrays_C, only: nfirst, nlast, nat, p
    use cosmo_C, only : cosurf
    use parameters_C, only: tore

    !
    !.. Implicit Declarations ..
    implicit none
    !
    !.. Formal Arguments ..
    integer, intent(in) :: n1, n2, nc
    integer, intent(in), dimension(*) :: ind1, ind2
    double precision, intent(in), dimension(nc, *) :: c
    double precision, intent(in), dimension(*) :: q
    double precision, intent(inout), dimension(*) :: r
    logical, intent(in) :: same
    !
    !.. Local Scalars ..
    integer :: i3, j3, ii, i, j, jj, k, l, m, nao
    double precision :: t
    !
    !.. Local Arrays ..
    double precision :: w(45)
    !
    ! ... Executable Statements ...
!
! Dummy statement to "use" q
!
    t = q(1)
    if(same) then         ! --- points vs. atoms in the same box
      do i3 = 1, n1
        ii = ind1(i3)
        do i = npoints(ii), npoints(ii+1) - 1
          t = 0
          do j3 = 1, n1
            j = ind1(j3)
            nao = nlast(j)-nfirst(j)
            call get_bvec (cosurf(1, i), c(1, j), nao, nat(j), w)

            jj = ijbo_diag(j)

            m = 0
            do k = 1, nao+1
              do l = 1, k-1
                m = m + 1
                t = t - 2*p(jj+m) * w(m)
              end do
              m = m + 1
              t = t - p(jj+m) * w(m)
            end do

            t = t + tore(nat(j)) * w(1)
          end do

          r(i) = r(i) + t
        end do
      end do
    else

      ! --- (1) Points in the 1 box with atoms in 2 box

      do i3 = 1, n1
        ii = ind1(i3)
        do i = npoints(ii), npoints(ii+1) - 1
          t = 0
          do j3 = 1, n2
            j = ind2(j3)
            nao = nlast(j)-nfirst(j)
            call get_bvec (cosurf(1, i), c(1, j), nao, nat(j), w)

            jj = ijbo_diag(j)

            m = 0
            do k = 1, nao+1
              do l = 1, k-1
                m = m + 1
                t = t - 2*p(jj+m) * w(m)
              end do
              m = m + 1
              t = t - p(jj+m) * w(m)
            end do
            t = t + tore(nat(j)) * w(1)
          end do

          r(i) = r(i) + t
        end do
      end do

      ! --- (2) Points in the 2 box with atoms in 1 box

      do i3 = 1, n2
        ii = ind2(i3)
        do i = npoints(ii), npoints(ii+1) - 1
          t = 0
          do j3 = 1, n1
            j = ind1(j3)
            nao = nlast(j)-nfirst(j)
            call get_bvec (cosurf(1, i), c(1, j), nao, nat(j), w)

            jj = ijbo_diag(j)

            m = 0
            do k = 1, nao+1
              do l = 1, k-1
                m = m + 1
                t = t - 2*p(jj+m) * w(m)
              end do
              m = m + 1
              t = t - p(jj+m) * w(m)
            end do
            t = t + tore(nat(j)) * w(1)
          end do

          r(i) = r(i) + t
        end do
      end do
    end if

  end subroutine bp_dir_int

  subroutine cgm_solve (x, n, b, r, p, q, z, m, new_x, new_points)
    !
    !       Conjugated gradient with preconditioner solver
    !       for the system of linear equations
    !       From: "Templates for the solution of linear systems:
    !               Building blocks for iterative methods",
    !               SIAM, Philadelphia, 1994
    !

    use molkst_C, only : numat
    use common_arrays_C, only: coord
    use cosmo_C, only : iatsp, nar_csm, cosurf, srad, nsetf, lenabc, ioldcv

    implicit none
    integer, intent(in) :: n
    logical, intent(in) :: new_x, new_points
    double precision, dimension(n), intent(in) :: b
    double precision, dimension(n), intent(inout) :: x
    double precision, dimension(n), intent(out) :: r, p, q, z
    double precision, dimension(*), intent(out) :: m
    integer, parameter :: max_iters = 100
    double precision, parameter :: stop_tol = 1.d-6
    double precision, parameter :: start_tol = 1.d-2
    integer :: i, maxrs, ierr
    double precision :: t, tt, rho, rho_old, alpha, beta
    double precision, save :: current_tol
    double precision, external :: ddot
    rho_old = 0.d0
    new_iteration = .true.

    maxrs = 60*numat

    if (new_points) then
      current_tol = start_tol
!
      call amat_diag (coord, srad, numat, cosurf, n, nar_csm, nsetf, &
         & nset, rsc, nipsrs, iatsp, tm, ioldcv, maxrs, lenabc, a_diag)
    end if

    if (n > na1max .or. n > na2max) then
      call set_tesselation (surface_handle, ierr)
      if (ierr /= 0) then
        call mopend("Internal error in cgm_solve")
        return
      end if

      if (compute_a_part .and. new_points) then
        i = count_short_ints  (cosurf, 4, simulate_aq_dir_int, .true.)
      end if

    else

      if (compute_a_part .and. new_points) then
        call simulate_aq_vec (coord, srad, numat, cosurf, n, nar_csm, &
       & nsetf, nset, rsc, nipsrs, iatsp, tm, ioldcv, maxrs, lenabc, &
       & .true., i)
      end if


    end if
    if (new_points) then
      call precondition  (cosurf, n, iatsp, numat, a_diag, m)
    end if

    if(new_x) then        ! initial guess
      call precondition_solve (m, x, b, n)
    end if

    if (n > na2max) then

      call afmm (cosurf, 4, n, x, q, n, aq_dir_int, aq_mult_int)
      q = q + a_diag * x

    else if (n > na1max) then

      call simple_mm (cosurf, 4, n, x, q, aq_dir_int, aq_far_int)
      q = q + a_diag * x

    else

      call aq_vec (coord, srad, numat, cosurf, n, &
           & nar_csm, nsetf, nset, rsc, nipsrs, iatsp, &
           & tm, ioldcv, maxrs, lenabc, a_diag, x, q)
    end if

    r = b - q

    if (c_proc < 0.2d0) then
      t = start_tol
    else if (c_proc < 0.4d0) then
      t = start_tol * 0.1d0
    else if (c_proc < 0.6d0) then
      t = start_tol * 0.01d0
    else if (c_proc < 0.8d0) then
      t = start_tol * 0.001d0
    else
      t = stop_tol
    end if

    t = Min (t, current_tol)
    current_tol = t
!
!   write(26,*) ' Tol = ', t
!
    do i = 1, max_iters

      new_iteration = .true.

      call precondition_solve (m, z, r, n)

      rho = ddot (n, r, 1, z, 1)

      if (i == 1) then
        p = z
      else
        beta = rho / rho_old
        p = z + beta * p
      end if

      if (n > na2max) then
        call afmm (cosurf, 4, n, p, q, n, aq_dir_int, aq_mult_int)
        q = q + a_diag * p
      elseif (n > na1max) then
        call simple_mm (cosurf, 4, n, p, q, aq_dir_int, aq_far_int)
        q = q + a_diag * p
      else
        call aq_vec (coord, srad, numat, cosurf, n, &
             & nar_csm, nsetf, nset, rsc, nipsrs, &
             & iatsp, tm, ioldcv, maxrs, lenabc, a_diag, p, q)
      end if

      alpha = rho / ddot (n, p, 1, q, 1)
      x = x + alpha * p
      r = r - alpha * q

      tt = some_norm(r, n)
!
!     write(26,*) ' Micro It. ', i, tt
!
      if (tt < t) then
   !     write (iw, *) i, " microiterations, err = ", tt
        exit
      end if

      rho_old = rho
    end do

  ! if (tt > t) then
  !    write (iw, *) " Warning! cgm_solve finished with error = ", tt
  !  end if

  end subroutine cgm_solve

  double precision function some_norm (v, n)

    !
    !.. Implicit Declarations ..
    implicit none
    !
    !.. Formal Arguments ..
    integer, intent(in) :: n
    double precision, dimension(n), intent(in) :: v
    !
    !.. Local Scalars ..
    integer :: i
    double precision :: t
    !
    !.. Intrinsic Functions ..
    intrinsic Abs
    !
    ! ... Executable Statements ...

    t = Abs (v(1))
    do i = 2, n
      if (t < Abs (v(i))) then
        t = Abs (v(i))
      end if
    end do

    some_norm = t

  end function some_norm

  subroutine precondition (cosurf, nps, iatsp, numat, a_diag, m)

    use cosmo_C, only : disex2
    use chanel_C, only : iw

    !
    !.. Implicit Declarations ..
    implicit none
    !
    !.. Formal Arguments ..
    integer, intent(in) :: nps, numat
    double precision, dimension(4, nps), intent(in) :: cosurf
    integer, dimension(*), intent(in) :: iatsp
    double precision, dimension(nps), intent(in) :: a_diag

    double precision, dimension(*), intent(out) :: m
    !
    !.. Local Scalars ..
    integer :: i, j, ii, jj, ijpos, ips, jps, ierr
    double precision :: aa, d2
    !
    !.. Local Arrays ..
    double precision xa(3), xb(3)
  !  integer, external :: count_short_ints
    !
    ! ... Executable Statements ...


    if (.not. use_a_blocks) then
      m(1:nps) = 1.d0 / a_diag(1:nps)
      return
    end if

    !
    ! Build block-preconditioner
    !

    if (nps > na2max .or. nps > na1max) then
      i = count_short_ints  (cosurf, 4, precond_aq_dir_int, .false.)
      do i=1, nps
        j = iatsp(i)
        ii = iblock_pos(j) -1
        jj = i - npoints(j) +1
        m(ii + (jj*(jj+1))/2) = a_diag(i)
      end do

    else

      ijpos = 0

      do ii = 1, nps
        i = iatsp(ii)
        xa(1:3) = cosurf(1:3, ii)

        do jj = 1, ii
          j = iatsp(jj)
          xb(1:3) = cosurf(1:3, jj)

          d2 = (xb(1)-xa(1))**2 + (xb(2)-xa(2))**2 + &
              & (xb(3)-xa(3))**2

          if (d2 <= disex2 .and. ii /= jj) then
            ijpos = ijpos +1
          end if

          if (i == j) then ! same atom

            if (ii == jj) then ! same point
               aa = a_diag(jj)
            else if (d2 > disex2) then
               aa = 1.d0 / Sqrt (d2)
            else
               aa = a_part(ijpos)
            end if

            ips = ii - npoints(i) +1
            jps = jj - npoints(i) +1


            m(iblock_pos(i) -1 + (ips*(ips-1))/2 + jps) = aa

          end if

        end do
      end do

    end if

    !
    ! Invert blocks
    !

    do i=1, numat
       ii = npoints(i+1) - npoints(i)
       if (ii > 0) then
         ijpos = iblock_pos(i)
         do j=1,ii
           do jj=1,j
             a_block(jj, j) = m(ijpos)
             ijpos = ijpos +1
           end do
         end do

         call dpotrf ('U', ii, a_block, max_block_size, ierr)
      !   if (ierr /= 0) then
      !     write(iw,*) ' Error in decomposition of atom ', i, ' = ', ierr
      !     call mopend(' Internal error')
      !     return
      !  end if

         call dpotri ('U', ii, a_block, max_block_size, ierr)
         if (ierr /= 0) then
           write(iw,*) ' Error in Matrix invert ', i, ' = ', ierr
           call mopend(' Internal error')
           return
         end if

       ! !
       ! ! === Test ===
       ! !
       !
       ! do j=1,ii
       !   do jj=1,j
       !     a_block( j, jj ) = a_block( jj, j )
       !   end do
       ! end do
       !
       ! do j=1,ii
       !   call mult_triangle_vec( m( iblock_pos(i)), a_block(1,j), ii, &
       !        q_vec )
       !
       !   do jj=1,ii
       !     if( jj == j ) then
       !        if( abs( q_vec( jj ) -1.d0 ) > 1.d-6 ) then
       !           write(26,*) ' Error diag', i, j, jj
       !        end if
       !     else
       !        if( abs( q_vec( jj )) > 1.d-6 ) then
       !           write(26,*) ' Error off-diag', i, j, jj
       !        end if
       !     end if
       !   end do
       ! end do
       !
       ! !
       ! ! === end Test ===
       ! !

         ijpos = iblock_pos(i)
         do j=1,ii
           do jj=1,j
             m(ijpos) = a_block(jj, j)
             ijpos = ijpos +1
           end do
         end do

       end if
     end do

  end subroutine precondition

  subroutine amat_diag (coord, srad, numat, cosurf, nps, nar_csm, nsetf, &
       & nset, rsc, nipsrs, iatsp, tm, ioldcv, maxrs, lenabc, m)
    !
    ! Computes diagonal elements of the A matrix
    !

    use cosmo_C, only : dirvec
    use funcon_C, only: pi
    implicit none
    integer, intent(in) :: numat, nps, ioldcv, maxrs, lenabc

    double precision, dimension(3, numat), intent(in) :: coord
    double precision, dimension(numat), intent(in) :: srad
    double precision, dimension(4, nps), intent(in) :: cosurf
    integer, dimension(lenabc+1), intent(in) :: nar_csm, nsetf, iatsp
    integer, dimension(*), intent(in) :: nset
    double precision, dimension(4, maxrs), intent(in) :: rsc
    integer, dimension(lenabc), intent(in) :: nipsrs
    double precision, dimension(3, 3, numat), intent(in) :: tm

    double precision, dimension(nps), intent(out) :: m
    integer :: i, ii, k, l, nfl1
    double precision :: aa, fdiag, ri, x1, x2, x3, x4
    double precision, dimension(4, 500, 2) :: finel
    double precision xi(3)
    fdiag = 2.1d0 * Sqrt (Pi)

    do ii = 1, nps
      i = iatsp(ii)
      ri = srad(i)
      xi(1:3) = coord(1:3, i)

      call mfinel (ii, 1, finel, nar_csm, nsetf, nset, rsc, &
           & nipsrs, dirvec, tm(1, 1, i), xi, ri, &
           & nfl1, ioldcv, maxrs, lenabc, numat)
      !
      !       Diagonal element
      !
      aa = 0.d0
      do k = 1, nfl1
        aa = aa + fdiag * Sqrt (finel(4, k, 1)**3)
        x1 = finel(1, k, 1)
        x2 = finel(2, k, 1)
        x3 = finel(3, k, 1)
        x4 = finel(4, k, 1)

        do l = 1, k - 1
          aa = aa + 2 * x4 * finel(4, l, 1) / &
               &  Sqrt ((x1-finel(1, l, 1))**2 + &
               & (x2-finel(2, l, 1))**2 + &
               & (x3-finel(3, l, 1))**2)
        end do
      end do

      m(ii) = aa / (cosurf(4, ii) **2)
    end do

  end subroutine amat_diag

  subroutine precondition_solve (m, z, r, n)

    use molkst_C, only : numat

    !
    !.. Implicit Declarations ..
    implicit none
    integer, intent (in) :: n
    double precision, dimension(n), intent(in) :: r
    double precision, dimension(*), intent(in) :: m
    double precision, dimension(n), intent(out) :: z
    integer :: i, ndim, ipos
    if (use_a_blocks) then
      ipos = 1
      do i=1, numat
        ndim = npoints(i+1) - npoints(i)
        if (ndim > 0) then
          call mult_triangle_vec (m(iblock_pos(i)) , r(ipos) , ndim, &
            & z(ipos))
          ipos = ipos + ndim
        end if
      end do
    else
      z(1:n) = r(1:n) * m(1:n)
    end if

  end subroutine precondition_solve

  subroutine mult_triangle_vec (t, x, n, y)
    !
    !.. Implicit Declarations ..
    implicit none

    !
    !.. Formal Arguments ..
    integer, intent (in) :: n
    double precision, dimension(*), intent(in) :: t
    double precision, dimension(n), intent(in) :: x
    double precision, dimension(n), intent(out) :: y
    !
    !.. Local Scalars ..
    integer :: i, j, ii, ij
    double precision :: s
    !
    ! ... Executable Statements ...

        ii = 0   ! previous diagonal element
        do i=1, n
          s = 0.d0
          ij = ii
          do j=1, i
            ij = ij +1
            s = s + t(ij) * x(j)
          end do
          ii = ij
          do j=i+1, n
            ij = ij + j -1
            s = s + t(ij) * x(j)
          end do
          y(i) = s
        end do

  end subroutine mult_triangle_vec


  subroutine addnucz (phinet, qscnet, qdenet)
    use molkst_C, only: lm61, numat
    use cosmo_C, only : lenabc, nps, idenat
    use parameters_C, only: tore
    use common_arrays_C, only : nat
    !
    !.. Implicit Declarations ..
    implicit none
    !
    !.. Formal Arguments ..
    double precision, dimension(lenabc+1, 3), intent (inout) :: phinet, &
         & qscnet
    double precision, dimension(lm61, 3), intent (inout) :: qdenet
    !
    !.. Local Scalars ..
    integer :: i
    !
    ! ... Executable Statements ...

    phinet(1:nps, 1) = 0.d0
    qscnet(1:nps, 1) = 0.d0
    qdenet(1:lm61, 1) = 0.d0

    do i = 1, numat
       qdenet(idenat(i), 1) = tore(nat(i))
    end do

  end subroutine addnucz

  subroutine addfckz
    !
    ! Adds correction to the Fock matrix due to charges on surface
    ! Computes corrections to total energy
    !
    use molkst_C, only: lm61, numat
    use cosmo_C, only : nps, solv_energy, fepsi, cosurf, iatsp, phinet, &
      qscnet, qdenet, ipiden, gden, qscat, ediel
    use parameters_C, only: tore
    use funcon_C, only: a0, ev

    use common_arrays_C, only: coord, nfirst, nlast, nat, f, p
    !
    !.. Implicit Declarations ..
    implicit none
    !
    !.. Local Scalars ..
    integer :: i, iat, im, j, ii, nao, nnn, ierr
    double precision :: fcon, qsc3, s1, t
    !.. Local Arrays ..
    integer :: idiag(9) = (/ 1, 3, 6, 10, 15, 21, 28, 36, 45 /)
    double precision :: w(45), v(45)
    !
    !.. Intrinsic Functions ..
    intrinsic Sum
    !
    ! ... Executable Statements ...

    fcon = a0 * ev
    qscat(1:numat) = 0.d0
    phinet(1:nps, 2) = 0.d0
    if (numat > nb1max .or. numat > nb2max) then
      do i = 1, numat
        ii = ijbo_diag(i)
        j = nlast(i) - nfirst(i) + 1
        s1 = Sum(p(ii + idiag(1:j)))
        q_vec(i) = -s1 + tore(nat(i))
      end do

      call set_tesselation (atom_handle, ierr)
      if (ierr == -1000) return ! dummy use of ierr
    end if

    if (numat > nb2max) then
      call afmm (coord, 3, numat, q_vec, phinet(1, 2), nps, &
           & bp_dir_int, bz_mult_int)

    elseif (numat > nb1max) then
      call simple_mm (coord, 3, numat, q_vec, phinet(1, 2), &
           & bp_dir_int, bz_far_int)

    else
      call bz_vec (phinet(1, 1))
      call bpnew_vec (phinet(1, 2))
      phinet(1:nps, 2) = phinet(1:nps, 1) + phinet(1:nps, 2)
      phinet(1:nps, 1) = 0
      !!stop
    end if

    phinet(1:nps, 3) = phinet(1:nps, 2)

    if (new_surface) then
      call cgm_solve (qscnet(1, 2), nps, phinet(1, 2), &
           & r_vec, p_vec, q_vec, z_vec, m_vec, .true., .true.)
      new_surface = .false.
    else
      qscnet(1:nps, 2) = qscnet(1:nps, 2) / (-fepsi)
      call cgm_solve (qscnet(1, 2), nps, phinet(1, 2), &
           & r_vec, p_vec, q_vec, z_vec, m_vec, .false., .false.)
    end if

    ediel = 0.d0
    s1 = 0.0d0
    do i = 1, nps
      iat = iatsp(i)
      qscnet(i, 2) = -fepsi * qscnet(i, 2)
      qsc3 = qscnet(i, 1) + qscnet(i, 2)
      qscnet(i, 3) = qsc3
      ediel = ediel + qsc3 * phinet(i, 3)
      s1 = s1 + qscnet(i, 1)
      qscat(iat) = qscat(iat) + qsc3
    end do
    ediel = ediel * fcon / 2

    if (numat > nb1max .or. numat > nb2max) then
      call set_tesselation (atom_handle, ierr)
      qdenet(1:lm61, 2) = 0
    end if

    if (numat > nb2max) then
      call afmm (coord, 3, numat, qscnet(1, 2), qdenet(1, 2), lm61, &
           & fock_dir_int, fock_mult_int, sphere_f_multipoles)

      f(ipiden(1:lm61)) = f(ipiden(1:lm61)) - qdenet(1:lm61, 2) * fcon

      s1 = 0.d0
      do i = 1, lm61
        s1 = s1 + qdenet(i, 2) * p(ipiden(i)) * gden(i)
      end do
      s1 = -s1 *fcon

    elseif (numat > nb1max) then
      call simple_mm (coord, 3, numat, qscnet(1, 2), qdenet(1, 2), &
           & fock_dir_int, fock_far_int, sphere_f_multipoles)

      f(ipiden(1:lm61)) = f(ipiden(1:lm61)) - &
           & qdenet(1:lm61, 2) * fcon

      s1 = 0.d0
      do i = 1, lm61
        s1 = s1 + qdenet(i, 2) * p(ipiden(i)) * gden(i)
      end do
      s1 = -s1 * fcon

    else

      s1 = 0.d0

      im = 0
      do i = 1, numat
        nao = nlast(i)-nfirst(i)
        ii = ijbo_diag(i)

        if (nao == 0) then ! S - element

          v(1) = 0.d0
          do j=1, nps
            t = 1.d0 / Sqrt (( cosurf(1,j) - coord(1,i) )**2 &
                         &  +( cosurf(2,j) - coord(2,i) )**2 &
                         &  +( cosurf(3,j) - coord(3,i) )**2)
            v(1) = v(1) + qscnet(j, 2) * t
          end do

          v(1) = -v(1) * fcon

          f(ii+1) = f(ii+1) + v(1)

          im = im + 1
          s1 = s1 + v(1) * p(ii+1) * gden(im)

        else

          nnn = ((nao+2)*(nao+1)) / 2
          v(1:nnn) = 0

          do j = 1, nps
            call get_bvec (cosurf(1, j), coord(1, i), nao, nat(i), w)
            v(1:nnn) = v(1:nnn) + w(1:nnn) * qscnet(j, 2)
          end do

          v(1:nnn) = -v(1:nnn) * fcon

          do j = 1, nnn
            f(ii+j) = f(ii+j) + v(j)

            im = im + 1
            s1 = s1 + v(j) * p(ii+j) * gden(im)
          end do

        end if
      end do
    end if

    solv_energy = s1 * 0.5d0 + ediel

    ! CALCULATE QDENET FROM DENSITY MATRIX

    do i = 1, lm61
      qdenet(i, 2) = gden(i) * p(ipiden(i))
      qdenet(i, 3) = qdenet(i, 2) + qdenet(i, 1)
    end do

  end subroutine addfckz

  subroutine fock_dir_int (ind1, n1, ind2, n2, c, nc, q, r, same)
    !
    ! Adds correction to the Fock matrix due to near charges on surface
    !

    use common_arrays_C, only: nfirst, nlast, nat
    use cosmo_C, only : qscnet, cosurf

    !
    !.. Implicit Declarations ..
    implicit none
    !
    !.. Formal Arguments ..
    integer, intent(in) :: n1, n2, nc
    integer, intent(in), dimension(*) :: ind1, ind2
    double precision, intent(in), dimension(nc, *) :: c
    double precision, intent(in), dimension(*) :: q
    double precision, intent(inout), dimension(*) :: r
    logical, intent(in) :: same
    !
    !.. Local Scalars ..
    integer :: i3, j3, ii, i, j, jj, nao, nnn
    !
    !.. Local Arrays ..
    double precision :: v(45), w(45)

!
! Dummy statement to "use" q
!
    v(1) = q(1)
    if(same) then         ! --- Atoms vs. points in the same box
      do i3 = 1, n1
        i = ind1(i3)
        nao = nlast(i)-nfirst(i)
        nnn = ((nao+2)*(nao+1)) / 2
        v(1:nnn) = 0
        ii = iatom_pos(i)

        do j3 = 1, n1
          jj = ind1(j3)

          do j = npoints(jj), npoints(jj+1) - 1
            call get_bvec (cosurf(1, j), c(1, i), nao, nat(i), w)
            v(1:nnn) = v(1:nnn) + w(1:nnn) * qscnet(j, 2)
          end do
        end do

        do j = 1, nnn
          r(ii+j) = r(ii+j) + v(j)
        end do
      end do
    else
      ! --- (1) Atoms n the 1 box with points in 2 box

      do i3 = 1, n1
        i = ind1(i3)
        nao = nlast(i)-nfirst(i)
        nnn = ((nao+2)*(nao+1)) / 2
        v(1:nnn) = 0
        ii = iatom_pos(i)

        do j3 = 1, n2
          jj = ind2(j3)

          do j = npoints(jj), npoints(jj+1) - 1
            call get_bvec (cosurf(1, j), c(1, i), nao, nat(i), w)

            v(1:nnn) = v(1:nnn) + w(1:nnn) * qscnet(j, 2)
          end do
        end do

        do j = 1, nnn
          r(ii+j) = r(ii+j) + v(j)
        end do
      end do

      ! --- (2) Atoms in the 2 box with points in 1 box

      do i3 = 1, n2
        i = ind2(i3)
        nao = nlast(i)-nfirst(i)
        nnn = ((nao+2)*(nao+1)) / 2
        v(1:nnn) = 0
        ii = iatom_pos(i)

        do j3 = 1, n1
          jj = ind1(j3)

          do j = npoints(jj), npoints(jj+1) - 1
            call get_bvec (cosurf(1, j), c(1, i), nao, nat(i), w)

            v(1:nnn) = v(1:nnn) + w(1:nnn) * qscnet(j, 2)
          end do
        end do

        do j = 1, nnn
          r(ii+j) = r(ii+j) + v(j)
        end do
      end do
    end if

  end subroutine fock_dir_int

  subroutine fock_mult_int (ind, n, psi, p, x0, y0, z0, y_norm, pmn, c, &
       & nc, q, r)
    !
    ! Adds correction to the Fock matrix due to far charges on surface
    ! using local expansions
    !

    use common_arrays_C, only: nfirst, nlast
    !
    !.. Implicit Declarations ..
    implicit none
    !
    !.. Formal Arguments ..
    integer, intent(in) :: n, p, nc
    integer, intent(in), dimension(*) :: ind
    complex (kind=dcmplx_kind), dimension(-p:p, 0:p), intent(in) :: psi
    double precision, dimension(-p:p, 0:p), intent(in) :: y_norm
    double precision, dimension(-p:p, 0:p), intent(out) :: pmn
    double precision, intent(in), dimension(nc, *) :: c
    double precision, intent(in), dimension(*) :: q
    double precision, intent(inout), dimension(*) :: r
    double precision, intent(in) :: x0, y0, z0
    !
    !.. Local Scalars ..
    integer :: i, ii, i3, j, k, nnn
    double precision :: dx, dy, dz, d, phi, cos_t, t
    complex (kind=dcmplx_kind) :: tc
    !
    !.. Local Arrays ..
    integer :: idiag(9) = (/ 1, 3, 6, 10, 15, 21, 28, 36, 45 /)
    !
    !.. Intrinsic Functions ..
    intrinsic Real, Cmplx, Atan2, Exp, Sqrt
    !
    ! ... Executable Statements ...

!
! Dummy statement to "use" q
!
    dx = q(1)
    do i3 = 1, n
      i = ind(i3)  ! atom number
      ii = iatom_pos(i)
      nnn = nlast(i) - nfirst(i) + 1

      dx =  c(1, i) - x0
      dy =  c(2, i) - y0
      dz =  c(3, i) - z0

      d = Sqrt (dx**2 + dy**2 + dz**2)
      cos_t = dz / d
      phi = Atan2 (dy, dx)

      call get_legendre (p, cos_t, pmn)

      t = 0.d0
      do j = 0, p
        tc = Cmplx (0.d0, 0.d0, dcmplx_kind)
        do k = 1, j
          tc = tc + y_norm(k, j) * pmn(k, j) * d**j &
               & *psi(k, j) * Exp (Cmplx (0.d0, k*phi, dcmplx_kind))

        end do

        t = t + 2.d0 * Real (tc) + pmn(0, j) * d**j * Real (psi(0, j))
      end do

      r(ii + idiag(1:nnn)) = r(ii + idiag(1:nnn)) + t

    end do

  end subroutine fock_mult_int

  subroutine fock_far_int (ind, n, psi, p, x0, y0, z0, y_norm, pmn, c, &
       & nc, q, r)
    !
    ! Adds correction to the Fock matrix due to far charges on surface
    ! using multipole expansions
    !

    use common_arrays_C, only: nfirst, nlast

    !
    !.. Implicit Declarations ..
    implicit none
    !
    !.. Formal Arguments ..
    integer, intent(in) :: n, p, nc
    integer, intent(in), dimension(*) :: ind
    complex (kind=dcmplx_kind), dimension(-p:p, 0:p), intent(in) :: psi
    double precision, dimension(-p:p, 0:p), intent(in) :: y_norm
    double precision, dimension(-p:p, 0:p), intent(out) :: pmn
    double precision, intent(in), dimension(nc, *) :: c
    double precision, intent(in), dimension(*) :: q
    double precision, intent(inout), dimension(*) :: r
    double precision, intent(in) :: x0, y0, z0
    !
    !.. Local Scalars ..
    integer :: i, ii, i3, j, k, nnn
    double precision :: dx, dy, dz, d, phi, cos_t, t
    complex (kind=dcmplx_kind) :: tc
    !
    !.. Local Arrays ..
    integer :: idiag(9) = (/ 1, 3, 6, 10, 15, 21, 28, 36, 45 /)
    !
    !.. Intrinsic Functions ..
    intrinsic Real, Cmplx, Atan2, Sqrt, Exp
    !
    ! ... Executable Statements ...

!
! Dummy statement to "use" q
!
    t = q(1)
    do i3 = 1, n
      i = ind(i3)  ! atom number
      ii = iatom_pos(i)
      nnn = nlast(i) - nfirst(i) + 1

      dx =  c(1, i) - x0
      dy =  c(2, i) - y0
      dz =  c(3, i) - z0

      d = Sqrt (dx**2 + dy**2 + dz**2)
      cos_t = dz / d
      phi = Atan2 (dy, dx)

      call get_legendre (p, cos_t, pmn)

      t = 0.d0
      do j = 0, p
        tc = (0.d0, 0.d0)
        do k = 1, j
          tc = tc + y_norm(k, j) * pmn(k, j) / d**(j+1) &
               & * psi(k, j) * Exp (Cmplx (0.d0, k*phi, dcmplx_kind))

        end do

        t = t + 2.d0 * Real (tc) + pmn(0, j) / d**(j+1) * Real (psi(0, j))
      end do

      r(ii + idiag(1:nnn)) = r(ii + idiag(1:nnn)) + t

    end do

  end subroutine fock_far_int

  subroutine sphere_f_multipoles (x0, y0, z0, ind, n, pmn, y_norm, &
       & c, nc, q, psi, p)
    !
    ! Computes multipole expansions of surface charges
    !

    use cosmo_C, only: qscnet, cosurf

    !
    !.. Implicit Declarations ..
    implicit none
    !
    !.. Formal Arguments ..
    double precision, intent(in) :: x0, y0, z0
    integer, intent(in) :: n, nc, p
    integer, dimension(*), intent(in) :: ind
    double precision, dimension(nc, *), intent(in) :: c
    double precision, dimension(*), intent(in) :: q
    double precision, dimension(-p:p, 0:p), intent(in) :: y_norm
    double precision, dimension(-p:p, 0:p), intent(inout) :: pmn

    complex (kind=dcmplx_kind), dimension(-p:p, 0:p), intent(inout) :: psi
    !
    !.. Local Scalars ..
    double precision :: dx, dy, dz, t, tt, r, cos_t, phi, qq
    complex (kind=dcmplx_kind) :: tc, tc1
    integer :: j, j1, k, n1, m1
    !
    !.. Intrinsic Functions ..
    intrinsic Sqrt, Atan2, Cmplx, Exp, Conjg
    !
    ! ... Executable Statements ...

!
! Dummy statement to "use" q and c
!
    t = q(1) + c(1,1)
    do j = 1, n
      j1 = ind(j)   ! atom number
      do k = npoints(j1), npoints(j1+1) - 1
        dx = cosurf(1, k) - x0
        dy = cosurf(2, k) - y0
        dz = cosurf(3, k) - z0
        qq = qscnet(k, 2)
        r = Sqrt (dx**2 + dy**2 + dz**2)
        cos_t = dz / r
        phi = Atan2 (dy, dx)

        call get_legendre (p, cos_t, pmn)

        psi(0, 0) = psi(0, 0) + Cmplx(qq, 0.d0, dcmplx_kind)

        t = 1.d0
        do n1 = 1, p
          t = t * r
          do m1 = 0, n1
            tc = Exp (Cmplx (0.d0, -m1*phi, dcmplx_kind))
            tt = y_norm(-m1, n1) * pmn(-m1, n1) * t * qq
            tc1 = tc * tt
            psi(m1, n1) = psi(m1, n1) + tc1
          end do
        end do

        do n1 = 1, p
          do m1 = 1, n1
            psi(-m1, n1) = Conjg (psi(m1, n1))
          end do
        end do

      end do
    end do

  end subroutine sphere_f_multipoles



  subroutine am1dft_solve (qsct, phit, nps)
    ! Wrapper for cgm_solve to calculate AM1DFT correction in writmn.

    !.. Implicit Declarations ..
    implicit none

    !
    !.. Formal Arguments ..
    integer, intent(in) :: nps
    double precision, dimension(nps), intent(inout) :: qsct
    double precision, dimension(nps), intent(in) :: phit
    !
    !
    ! ... Executable Statements ...

    call cgm_solve (qsct, nps, phit, &
         & r_vec, p_vec, q_vec, z_vec, m_vec, .false., .false.)
  end subroutine am1dft_solve

end module linear_cosmo

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine chkion (ox_calc, n_lone_pairs, atom_charge)
   !***********************************************************************
   !
   !   CHKION works out which atoms are ionized.  By the time CHKION is
   !          called, all the obvious elements of the Lewis structure have
   !   been determined (bonds, groups such as -NH3(+), etc.).
   !
   !   An atom is ionized if it has unused atomic orbitals. Using tables of
   !   normal oxidation states (ox_ref_sp) and hypervalent oxidation states
   !   (ox_ref_spd1), the degree of ionization is worked out.  To do this,
   !   the starting oxidation state (ox_calc) is compared to that expected.
   !
   !   This should work for all elements in their common oxidation states.
   !
   !   A limitation is that the sum of atomic number and oxidation state
   !   must be even.  This means that Cr must be Cr(II) and not Cr(III).
   !
   !***********************************************************************
    use chanel_C, only: iw
    use parameters_C, only: tore
    use common_arrays_C, only : nat, nbonds, ibonds, txtatm
    use molkst_C, only : numat, nelecs, line, keywrd
    use elemts_C, only : elemnt
    use atomradii_C, only: is_metal
    use elemts_C, only : cap_elemnt
    use MOZYME_C, only: ions, Lewis_tot, Lewis_elem, &
      iz, ib
    implicit none
    character, intent (in) :: atom_charge(numat)
    integer, intent (inout) :: n_lone_pairs, ox_calc(numat)
    integer :: i, j, k, jj, loop, m, mm, outer_loop, ni, dummy, nocc_local
    integer :: ox_ref(107), ox_ref_sp(107), ox_ref_spd1(107), ox_ref_spd2(107)
    character :: num(10)*1
    double precision, external :: reada
!
!           H           Default formal oxidation states                     He
!           Li Be                                            B  C  N  O  F  Ne
!           Na Mg                                            Al Si P  S  Cl Ar
!           K  Ca Sc            Ti V  Cr Mn Fe Co Ni Cu Zn   Ga Ge As Se Br Kr
!           Rb Sr Y             Zr Nb Mo Tc Ru Rh Pd Ag Cd   In Sn Sb Te I  Xe
!           Cs Ba La Ce-Lu      Hf Ta W  Re Os Ir Pt Au Hg   Tl Pb Bi Po At Rn
!           Fr Ra Ac Th Pa U    Np Pu Am Cm Bk Cf            Cb ++ +  -- -  Tv
!                                      "s" shell
!                              Isolated atom (Most of these will never exist, e.g. C)
    data ox_ref &
        &/ 1,                                                                0, &!    2
        &  1, 2,                                              3, 4, 3,-2,-1, 0, &!   10
        &  1, 2,                                              3, 4, 3,-2,-1, 0, &!   18
        &  1, 2, 3,              4, 3, 2, 3, 2, 3, 2, 1, 2,   3, 4, 3,-2,-1, 0, &!   36
        &  1, 2, 3,              4, 3, 2, 3, 2, 3, 2, 1, 2,   3, 4, 3,-2,-1, 0, &!   54
        &  1, 2, 3, 14*3,        4, 3, 2, 3, 2, 3, 2, 1, 2,   3, 2, 3,-2,-1, 0, &!   86
        &  1, 2, 3, 4, 2, 2,     4, 3, 2, 3, 2, 3, 2, 0, 0,   0, 0, 0, 0, 0, 0 /
!
!                                Atom normal oxidation state.
!  Be very careful in changing these!  They are designed to suit the largest number
!  of common oxidation states.  Also, they affect the sign of the hypervalents.
!  Note in particular, the signs of Groups V, VI, and VII.
!
    data ox_ref_sp &
        &/ 1,                                                                0, &!    2
        &  1, 2,                                              3, 4, 3,-2,-1, 0, &!   10
        &  1, 2,                                              3, 4, 3,-2,-1, 0, &!   18
        &  1, 2, 3,              4, 3, 2, 3, 2, 3, 2, 1, 2,   3, 4, 3,-2, 1, 0, &!   36
        &  1, 2, 3,              4, 3, 2, 3, 2, 3, 2, 1, 2,   3, 4, 3,-2, 1, 0, &!   54
        &  1, 2, 3, 5*0,3*2,6*2, 4, 3, 2, 3, 2, 3, 2, 1, 2,   3, 2, 3,-2, 0, 0, &!   86
        &  1, 2, 3, 4, 2, 2,     4, 3, 2, 3, 2, 3, 2, 0, 0,   0, 0, 0, 0, 0, 0 /
!
!                                Atom lower hypervalent oxidation state
!
    data ox_ref_spd1 &
        &/ 1,                                                                0, &!    2
        &  1, 2,                                              3, 4, 3,-2,-1, 0, &!   10
        &  1, 2,                                              3, 4, 5, 6, 3, 0, &!   18
        &  1, 2, 3,              4, 5, 6, 7, 2, 3, 2, 1, 2,   3, 4, 5, 6, 3, 0, &!   36
        &  1, 2, 3,              4, 5, 6, 7, 2, 3, 2, 1, 2,   3, 4, 5, 6, 3, 0, &!   54
        &  1, 2, 3, 5*0,3*2,6*2, 4, 5, 6, 7, 2, 3, 2, 1, 2,   3, 2, 3, 4, 0, 0, &!   86
        &  1, 2, 3, 4, 2, 2,     4, 5, 6, 7, 2, 3, 2, 0, 0,   0, 0, 0, 0, 0, 0 /
!
!                                Atom higher hypervalent oxidation state
!
    data ox_ref_spd2 &
        &/ 1,                                                                0, &!    2
        &  1, 2,                                              3, 4,-3, 2,-1, 0, &!   10
        &  1, 2,                                              3, 4,-5, 6, 7, 0, &!   18
        &  1, 2, 2,              4, 3, 2, 3, 2, 3, 2, 1, 2,   3, 4,-5, 6, 5, 0, &!   36
        &  1, 2, 2,              4, 3, 2, 3, 2, 3, 2, 1, 2,   3, 4,-5, 6, 7, 0, &!   54
        &  1, 2, 2, 5*0,3*2,6*2, 4, 3, 2, 3, 2, 3, 2, 1, 2,   3, 4,-3, 2, 0, 0, &!   86
        &  1, 2, 2, 4, 2, 2,     4, 3, 2, 3, 2, 3, 2, 0, 0,   0, 0, 0, 0, 0, 0 /
!
!  If instructed to, change oxidation states
!
    i = index(keywrd," METAL")
    if (i /= 0) then
      j = index(keywrd(i:), ") ") + i
      if (i /= j) then
        line = keywrd(i + 7:j)
        do k = 1, 83
          if (is_metal(k)) then
            if (cap_elemnt(k)(2:2) == " ") then
              jj = 1
            else
              jj = 2
            end if
            m = index(line,cap_elemnt(k)(:jj))
            if (m /= 0) then
              jj = jj + m
              if (line(jj:jj) == "(") then
              m = nint(reada(line, m))
              if (mod(m - ox_ref(k), 2) == 1) then
                write(iw,'(10x, a, i3)')"Formal oxidation state of "//elemnt(k)//" is:   ", ox_ref(k)
                write(iw,'(10x,a, i3)')"Requested oxidation state of "//elemnt(k)//" is:", m
                if (mod(ox_ref(k), 2) == 1) then
                write(iw,'(10x,a, i3)')"Alternate oxidation states must be odd, e.g, -3, -1, +1, +3, +5, etc."
                else
                  write(iw,'(10x,a, i3)')"Alternate oxidation states must be even, e.g, -4, -2, +0, +2, +4, etc."
                end if
                call mopend("OXIDATION STATE REQUESTED IS NOT ALLOWED")
                return
              end if
              ox_ref(k) = m
              ox_ref_spd1(k) = ox_ref(k)
              end if
            end if
          end if
        end do
      end if
    end if
!
!  ALL ORBITALS SHOULD HAVE BEEN USED BY THIS TIME.  SOME ORBITALS
!  HAVE NOT BEEN USED: CHECK TO SEE IF THEY SHOULD BE FILLED OR
!  BE EMPTY.
!
!  First, work out the sign of the oxidation state of the atoms
!
    do i = 1, numat
      k = ions(i)
      if (nbonds(i) == 0) then
        jj = sign(1, ox_ref(nat(i)))    ! Isolated atom or ion
      else
        jj = sign(1, ox_ref_sp(nat(i))) ! Lowest valence state
      end if
      do j = 1, Lewis_tot
        if (Lewis_elem(1,j) /= 0 .and. Lewis_elem(2,j) /= 0) then
          if (Lewis_elem(1,j) == i) k = k + jj
          if (Lewis_elem(2,j) == i) k = k + jj
        end if
      end do
      ox_calc(i) = k
      if (ib(i) == 0) then
        ions(i) = iz(i)
        iz(i) = 0
      end if
    end do
!
!   Write in MOZYME(Cr(IV))
!

    do outer_loop = 1, 2
!
!  The first cycle of outer_loop assignes all obvious charges,
!  the second cycle assignes the more subtle charges
!  such as those on C2H5
!
      atom_loop: do i = 1, numat
        loop = 0
        do
          if (ib(i) <= 0) cycle atom_loop
          loop = loop + 1
          if (loop > 10) goto 1040
          if (nat(i) == 6) then
  !
  !  Carbon is particularly difficult: decide its charge based on its environment
  !
            if (outer_loop == 1) then
              if (iz(i) > 1) then
                call add_Lewis_element(i,0,0, n_lone_pairs)  !  Lone pair
                if (iz(i) == 0 .and. ib(i) == 1) then
                  call add_Lewis_element(0,i,0, dummy)  ! Virtual lone pair
                end if
              else
                do m = 1, nbonds(i)
                  if (ions(ibonds(m,i)) > 0) then ! Adjacent atom is a cation
                    call add_Lewis_element(i,0,-1, n_lone_pairs)    ! Lone pair
                    cycle atom_loop
                  else if (ions(ibonds(m,i)) < 0) then ! Adjacent atom is an anion
                    call add_Lewis_element(0,i,1, dummy)    ! Cation
                    cycle atom_loop
                  end if
                end do
  !
  !     If there is a nearby atom of Group V, make the atom a cation
  !
                do m = 1, nbonds(i)
                  mm = ibonds(m, i)
                     !
                     !   IS ANY ATOM ATTACHED TO THE ATOM OF GROUP 5?
                     !
                  if (Nint(tore(nat(mm))) == 5) go to 1010
                  if (Nint(tore(nat(mm))) == 6) go to 1012
                  do j = 1, nbonds(mm)
                    jj = ibonds(j, mm)
                        !
                        !   IS ANY ATOM ATTACHED TO ANY ATOM ATTACHED
                        !   TO THE ATOM OF GROUP 5?
                        !
                    if (Nint(tore(nat(jj))) == 5) go to 1010
                  end do
                end do
                goto 99
  1010        call add_Lewis_element(0,i,1, dummy)    ! Cation
                cycle atom_loop
  1012        call add_Lewis_element(i,0,-1, n_lone_pairs)    ! Lone pair
                cycle atom_loop
      !
      !     If there is a nearby atom of Group VI, make the atom an anion
      !
    99          do m = 1, nbonds(i)
                  mm = ibonds(m, i)
                     !
                     !   IS ANY ATOM ATTACHED TO THE ATOM OF GROUP 5?
                     !
                  if (Nint(tore(nat(mm))) == 6) go to 1011
                  do j = 1, nbonds(mm)
                    jj = ibonds(j, mm)
                        !
                        !   IS ANY ATOM ATTACHED TO ANY ATOM ATTACHED
                        !   TO THE ATOM OF GROUP 6?
                        !
                    if (Nint(tore(nat(jj))) == 6) go to 1011
                  end do
                end do
                cycle atom_loop
  1011          call add_Lewis_element(i,0, -1, n_lone_pairs)   ! Lone pair
                cycle atom_loop
              end if
            else
  !
  !  To get here, there are no obvious indications of the charge on
  !  carbon, so postpone assigning the charge until after all other
  !  charges are known.
  !
              call add_Lewis_element(-i,0, 0, dummy) ! Anion or cation - decide later
              cycle atom_loop
            end if
          else  !  Atom is not a carbon - use generic rules
            if (loop == 1) then
!
!  Adjust oxidation state to match that expected.
!
              ni = nat(i)
              do
                if (atom_charge(i) == " ") then
                  if (Abs(ox_calc(i)) > Abs(ox_ref_spd1(ni))) then
                    jj = ox_ref_spd2(ni) - ox_calc(i)
                  else if (Abs(ox_calc(i)) > Abs(ox_ref_sp(ni))) then
                    jj = ox_ref_spd1(ni) - ox_calc(i)
                  else if (nbonds(i) > 0) then
                    jj = ox_ref_sp(ni) - ox_calc(i)
                  else
                    jj = ox_ref(ni) - ox_calc(i)
                  end if
                else if (atom_charge(i) == "+") then
                  jj = 1
                else if (atom_charge(i) == "-") then
                  jj = -1
                else if (atom_charge(i) == "0") then
                  jj = 0
                end if
!
!  jj is the presumed charge on the atom.
!  "presumed" = difference between calculated oxidation state and default oxidation state,
!               or charge specified by the user.
!
                if (jj == 0) exit
                if (jj >= 2 .and. nat(i) == 7) then
                  jj = -2 ! Azide
                end if
                if (ib(i) == 0) exit
                  if (jj > 1) then
                  call add_Lewis_element(0,i,2, dummy)  ! di-cation
                  ox_calc(i) = ox_calc(i) + 2
                 else if (jj == 1) then
                  call add_Lewis_element(0,i,1, dummy)  ! Cation
                   ox_calc(i) = ox_calc(i) + 1
                 else if (jj == -1) then
                  call add_Lewis_element(i,0,-1, n_lone_pairs) ! Anion
                  ox_calc(i) = ox_calc(i) - 1
                 else if (jj < -1) then
                  call add_Lewis_element(i,0,-2, n_lone_pairs) ! di-Anion
                  ox_calc(i) = ox_calc(i) - 2
                end if
              end do
            else  if (iz(i) > 1) then
              call add_Lewis_element(i,0,0, n_lone_pairs)  ! Lone pair
            else
              call add_Lewis_element(0,i,0, dummy)  ! Virtual lone pair
            end if
          end if
        end do
      end do atom_loop
    end do
    nocc_local = 0
    do i = 1, Lewis_tot
      if (Lewis_elem(1,i) /= 0) nocc_local = nocc_local + 1
    end do
    mm = nocc_local - nelecs/2
!
!  mm is the number of undetermined Lewis elements that should be
!  virtual.  These elements are always charged carbon atoms.
!
    do i = 1, mm
      do j = 1, Lewis_tot
        jj = Lewis_elem(1,j)
        if (jj < 0) then
          jj = -jj              ! Convert undetermined charged carbon
          Lewis_elem(2,j) = jj   ! into a cation
          Lewis_elem(1,j) = 0
          iz(jj) = iz(jj) - 1
          if (ib(jj) == 1) then
            write (iw,'(/10x,a,i6,a)') " WARNING: Carbon atom ", jj, " has an unexpected valency!   PDB Label: """// &
            txtatm(jj)//""""
            if (nbonds(jj) > 0) then
              num = "1"
              do k = 1, nbonds(jj)
                num(k) = char(ichar("1") +int(log10(ibonds(k,jj) + 0.05)))
              end do
              line = '(10x,a,a,i'//num(1)//',3x,a,i'//num(2)//',3x,a,i'//num(3)
              line = trim(line)//',3x,a,i'//num(4)//',3x,a,i'//num(5)//',3x,a,i'//num(6)
              line = trim(line)//',3x,a,i'//num(7)//',3x,a,i'//num(8)//',3x,a,i'//num(9)//',3x,a,i'//num(10)//',a)'
              write (iw,trim(line))" It is connected to:  ",(elemnt(nat(ibonds(k,jj))),ibonds(k,jj), k = 1, nbonds(jj)), "only"
            else
              write (iw,'(a)')" It is not connected to any other atom."
            end if
            write(iw,"(/)")
          end if
!
! Convert all remaining unused atomic orbitals into virtual lone pairs
!
          do
            if (ib(jj) <= 0) exit
            call add_Lewis_element(0,jj,0, dummy)  ! Virtual lone pair
          end do
          exit
        end if
      end do
    end do
!
!   Convert all remaining undetermined charged carbon atoms into anions
!
    do j = 1, Lewis_tot
      jj = Lewis_elem(1,j)
      if (jj < 0) then
        jj = -jj
        Lewis_elem(1,j) = jj
        n_lone_pairs = n_lone_pairs + 1
        if (iz(jj) == 1) iz(jj) = 0
        if (ib(jj) == 1) then
!
! create a virtual lone pair
!
          write (iw,'(/10x,a,i6,a)') " WARNING: Carbon atom ", jj, " has an unexpected valency!   PDB Label: """// &
            txtatm(jj)//""""
          if (nbonds(jj) > 0) then
            num = "1"
            do k = 1, nbonds(jj)
              num(k) = char(ichar("1") +int(log10(ibonds(k,jj) + 0.05)))
            end do
            line = '(10x,a,a,i'//num(1)//',3x,a,i'//num(2)//',3x,a,i'//num(3)//',3x,a,i'//num(4)//',3x,a,i'
            line = trim(line)//num(5)//',3x,a,i'//num(6)//',3x,a,i'//num(7)//',3x,a,i'//num(8)
            line = trim(line)//',3x,a,i'//num(9)//',3x,a,i'//num(10)//',a)'
            write (iw,trim(line))" It is connected to:  ",(elemnt(nat(ibonds(k,jj))),ibonds(k,jj), k = 1, nbonds(jj)), "only"
          else
            write (iw,'(a)')" It is not connected to any other atom."
          end if
          write(iw,"(/)")
          call add_Lewis_element(0,jj,0, dummy)  ! Virtual lone pair
          ib(jj) = 0
        end if
      end if
    end do

    return
1040 write (iw,*) " CHARGE ON ATOM", i, " UNREASONABLE"
    call mopend ("Charge on an atom is unreasonable")
end subroutine chkion

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine hcore_for_MOZYME ()
  use molkst_C, only: numat, norbs, id, numcal, n2elec, moperr, &
     & enuclr, l1u, l2u, l3u, keywrd, efield, mpack, cutofp
  use cosmo_C, only : useps,  phinet, qscnet, qdenet
  use linear_cosmo, only : addnucz
  use chanel_C, only: iw
  use funcon_C, only: a0, ev
  use overlaps_C, only : cutof1, cutof2
  use parameters_C, only: tore, dd, natorb
  use common_arrays_C, only: h, coord, nat, w, wj => w, wk, uspd, tvec
  use MOZYME_C, only : semidr, direct, cutofs, parth, &
    iorbs, jopt, mode, numred, refnuc
  implicit none
!
  character (len=248) :: tmpkey
  logical :: calci, calcij, calcj, fldon
  logical, save :: debug
  integer :: i1, i2, ii, im1, io1, ione, ired, j, j1, jj, jo1, jred, k, &
 & krmax, kro, ks, mm, nj, kr, i, ni, itemp, imol=0
  double precision :: const, enuc, fldcon, fnuc, half, hterme, xf, yf, zf, xj(3)
  double precision, parameter :: eps = 1.d-10
  double precision, dimension (45) :: e1b, e2a
  double precision, dimension (2025) :: wjd, wkd
  double precision, dimension (9, 9) :: di, dibits
  double precision, external :: reada
  integer, external :: ijbo
  fldcon = 0.d0
  fnuc = 0.d0
  debug = (Index (keywrd, " HCORE") /= 0)
  call add_more_interactions()
  if (moperr) return
  if (imol /= numcal) then
    if (index(keywrd, " SILENT") == 0 .and. (debug .or. id /= 0)) then
      write (iw, "(A,31X,F12.6,A)") " Overlap Cutoff Distance:", Sqrt(cutofs), " CUTOFS"
      write (iw, "(A,F12.6,A)") &
       & " Cutoff for quadrupolar and higher 2-electron integrals:", Sqrt(cutof2), " CUTOF2"
      write (iw, "(A,26X,F12.6,A)") " Cutoff for dipolar integrals:", Sqrt(cutof1), " CUTOF1"
      if (id /= 0) &
          write (iw, "(A,39X,F12.6,A)") " Madelung cutoff:", cutofp, " CUTOFP"
    end if
    imol = numcal
    xf = 0.d0
    yf = 0.d0
    zf = 0.d0
    tmpkey = trim(keywrd)
    i = Index (tmpkey, " FIELD(") + Index (tmpkey, " FIELD=(")
    if (i /= 0) then
       !
       !   ERASE ALL TEXT FROM TMPKEY EXCEPT FIELD DATA
       !
      tmpkey (:i) = " "
      itemp = Index (tmpkey, ")")
      tmpkey (itemp:) = " "
       !
       !   READ IN THE EFFECTIVE FIELD IN X,Y,Z COORDINATES
       !
      xf = reada (tmpkey, i)
      i = Index (tmpkey, ",")
      if (i /= 0) then
        tmpkey (i:i) = " "
        yf = reada (tmpkey, i)
        i = Index (tmpkey, ",")
        if (i /= 0) then
          tmpkey (i:i) = " "
          zf = reada (tmpkey, i)
        end if
      end if
      write (iw, "(/10X,'THE ELECTRIC FIELD IS',3F10.5, ' VOLTS/ANGSTROM',&
       &/)") xf, yf, zf
    end if
    !
    !        CONST = Ao/(8h)  (h=Hartree = eV/atomic unit)
    !
    const = a0 / ev
    !
    efield(1) = xf * const
    efield(2) = yf * const
    efield(3) = zf * const
  end if
  ione = 1
  if (id /= 0) ione = 0
  if (mode == -1) then
    h(:mpack) = -h(:mpack)
    enuclr = -enuclr
  else if (mode == 0) then
    enuclr = 0.d0
  else
    h = parth
    enuclr = refnuc
  end if
  krmax = n2elec + 101
  fldon = .false.
  if (Abs (efield(1)) > eps .or. Abs (efield(2)) > eps .or. Abs (efield(3)) > eps) then
    fldcon = eV/a0 ! = 51.42
    fldon = .true.
  end if
 !
  kr = 1
 !
  mm = 0
  ired = 1
  if (mode == 0) then
    !
    !   ZERO OUT THE H MATRIX
    !
    h(1:mpack) = 0.d0
  end if
  do i = 1, numat

    calci = (jopt(ired) == i)
    if (calci .and. ired < numred) then
      ired = ired + 1
    end if
    ni = nat(i)
    if (mode == 0) then
        !
        ! FILL THE DIAGONALS, AND OFF-DIAGONALS ON THE SAME ATOM
        !
      i2 = ijbo (i, i)
      do i1 = 1, iorbs(i)
        do j1 = 1, i1
          i2 = i2 + 1
          h(i2) = 0.d0
          if (fldon) then
            io1 = i1 - 1
            jo1 = j1 - 1
            if ((jo1 == 0) .and. (io1 == 1)) then
              hterme = -a0 * dd(ni) * efield(1) * fldcon
              h(i2) = hterme
            end if
            if ((jo1 == 0) .and. (io1 == 2)) then
              hterme = -a0 * dd(ni) * efield(2) * fldcon
              h(i2) = hterme
            end if
            if ((jo1 == 0) .and. (io1 == 3)) then
              hterme = -a0 * dd(ni) * efield(3) * fldcon
              h(i2) = hterme
            end if
          end if
        end do
        mm = mm + 1
        h(i2) = uspd(mm)
        if (fldon) then
          fnuc = -(efield(1)*coord(1, i) + efield(2)*coord(2, i) + &
               & efield(3)*coord(3, i)) * fldcon
          h(i2) = h(i2) + fnuc
        end if
      end do
    end if
    if (fldon) then
      enuclr = enuclr - fnuc * tore(nat(i))
    end if
    !
    !   FILL THE ATOM-OTHER ATOM ONE-ELECTRON MATRIX<PSI(LAMBDA)|PSI(SIGMA)>
    !
    jred = 1
    im1 = i - ione
    do j = 1, im1
      half = 1.d0
      if (i == 46 .and. j < 888) then
    enuclr = enuclr
   end if
      if (i == j) half = 0.5d0
      calcj = (jopt(jred) == j)
      if (calcj .and. jred < numred) jred = jred + 1
      calcij = (calci .or. calcj .or. mode == 0)
      nj = nat(j)
      if (id == 0) then
        !
        !   Molecular system
        !
        if (ijbo(i, j) >= 0) then
          if (calcij) then
            call h1elec (ni, nj, coord(1, i), coord(1, j), di)
            ii = ijbo (i, j)
            if (i == j) then
              do i1 = 1, iorbs(i)
                do j1 = 1, i1
                  ii = ii + 1
                  h(ii) = h(ii) + di(i1, j1)
                end do
              end do
            else
              do i1 = 1, iorbs(i)
                do j1 = 1, iorbs(j)
                  ii = ii + 1
                  h(ii) = h(ii) + di(i1, j1)
                end do
              end do
            end if
            !
            ! CALCULATE THE TWO-ELECTRON INTEGRALS, W; THE ELECTRON
            ! NUCLEAR TERMS E1B AND E2A; AND THE NUCLEAR-NUCLEAR TERM ENUC.
            !
            call rotate (ni, nj, coord(1, i), coord(1, j), w(kr), i1, e1b, e2a, enuc)
            enuclr = enuclr + enuc
           !
          else if ( .not. direct) then
            kr = kr + (natorb(ni)*(natorb(ni)+1))/2 * (natorb(nj)*(natorb(nj)+1))/2
          end if
        else if (ijbo(i, j) ==-2) then
          if (calcij) then
            call outer2 (ni, nj, coord(1, i), coord(1, j), w(kr), kr, e1b, e2a, enuc, id, semidr)
            enuclr = enuclr + enuc
          else if ( .not. semidr) then
            if (natorb(ni)*natorb(nj) > 0) then
              if (natorb(ni) > 1) then
                if (natorb(nj) > 1) then
                  kr = kr + 7
                else
                  kr = kr + 4
                end if
              else if (natorb(nj) > 1) then
                kr = kr + 4
              else
                kr = kr + 1
              end if
            end if
          end if
        else if (calcij) then
          call outer1 (ni, nj, coord(1, i), coord(1, j), w(kr), kr, e1b, e2a, enuc, 0, semidr)
          enuclr = enuclr + enuc
        else if ( .not. semidr) then
          if (natorb(ni)*natorb(nj) > 0) kr = kr + 1
        end if
        if (calcij) then
          !
          !   ADD ON THE ELECTRON-NUCLEAR ATTRACTION TERM FOR ATOM I.
          !
          ii = ijbo (i, i)
          j1 = (iorbs(i)*(iorbs(i)+1)) / 2
          do i1 = 1, j1
            ii = ii + 1
            h(ii) = h(ii) + e1b(i1) * half
          end do
          !
          !   ADD ON THE ELECTRON-NUCLEAR ATTRACTION TERM FOR ATOM J.
          !
          ii = ijbo (j, j)
          j1 = (iorbs(j)*(iorbs(j)+1)) / 2
          do i1 = 1, j1
            ii = ii + 1
            h(ii) = h(ii) + e2a(i1) * half
          end do
        end if
        if (kr > krmax-100 .and. i /= numat) then
          write (iw,*) kr, krmax
          write (iw, "(' Running out of storage for W in HCORE ')")
          write (iw,*) " NUMBER OF ATOMS CALCULATED FOR 'W':", i
          write (iw,*) " NUMBER OF ATOMS IN SYSTEM:", numat
          call mopend ("Running out of storage for W in HCORE")
          return
        end if
      else
        !
        !   Solid-state system
        !
        if (ijbo(i, j) >= 0) then
          if (calcij) then
            di = 0.D0
            do ii = -l1u, l1u
              do jj = -l2u, l2u
                do k = -l3u, l3u
                  xj = coord(:,j) + tvec(:,1)*ii + tvec(:,2)*jj + tvec(:,3)*k
                  call h1elec (ni, nj, coord(1,i), xj, dibits)
                  di = di + dibits
                end do
              end do
            end do
            ii = ijbo (i, j)
            if (i == j) then
              do i1 = 1, iorbs(i)
                do j1 = 1, i1
                  ii = ii + 1
                  h(ii) = h(ii) + di(i1, j1)
                end do
              end do
            else
              do i1 = 1, iorbs(i)
                do j1 = 1, iorbs(j)
                  ii = ii + 1
                  h(ii) = h(ii) + di(i1, j1)
                end do
              end do
            end if
            !
            ! CALCULATE THE TWO-ELECTRON INTEGRALS, W;
            ! THE ELECTRON NUCLEAR TERMS E1B AND E2A;
            ! AND THE NUCLEAR-NUCLEAR TERM ENUC.
            !
            kro = kr
            call solrot (ni, nj, coord(1,i), coord(1,j), wjd, wkd, kr, e1b, e2a, enuc)
            w(kro:kr - 1) = wjd(:kr-kro)
            wk(kro:kr - 1) = wkd(:kr-kro)
            enuclr = enuclr + enuc
          else if (natorb(ni) == 1) then
            if (natorb(nj) == 1) then
              kr = kr + 1
            else
              kr = kr + 10
            end if
          else if (natorb(nj) == 1) then
            kr = kr + 10
          else
            kr = kr + 100
          end if
        else if (ijbo(i, j) ==-2) then
          if (calcij) then
            ks = kr
            call outer2 (ni, nj, coord(1, i), coord(1, j), wj(kr), kr, &
                 & e1b, e2a, enuc, id, semidr)
            do k = ks, kr - 1
              wk(k) = 0.d0
            end do
            enuclr = enuclr + enuc
          else if (natorb(ni)*natorb(nj) > 0) then
            if (natorb(ni) > 1) then
              if (natorb(nj) > 1) then
                kr = kr + 7
              else
                kr = kr + 4
              end if
            else if (natorb(nj) > 1) then
              kr = kr + 4
            else
              kr = kr + 1
            end if
          end if
        else if (calcij) then
          wk(kr) = 0.d0
          call outer1 (ni, nj, coord(1, i), coord(1, j), wj(kr), kr, &
               & e1b, e2a, enuc, id, semidr)
          enuclr = enuclr + enuc
        else if (natorb(ni)*natorb(nj) > 0) then
          kr = kr + 1
        end if
        if (calcij) then
           !
           !   ADD ON THE ELECTRON-NUCLEAR ATTRACTION TERM FOR ATOM I.
           !
          ii = ijbo (i, i)
          j1 = (iorbs(i)*(iorbs(i)+1)) / 2
          do i1 = 1, j1
            ii = ii + 1
            h(ii) = h(ii) + e1b(i1) * half
          end do
           !
           !   ADD ON THE ELECTRON-NUCLEAR ATTRACTION TERM FOR ATOM J.
           !
          ii = ijbo (j, j)
          j1 = (iorbs(j)*(iorbs(j)+1)) / 2
          do i1 = 1, j1
            ii = ii + 1
            h(ii) = h(ii) + e2a(i1) * half
          end do
        end if
        if (kr > krmax-100 .and. i /= numat) then
          write (iw,*) kr, krmax
          write (iw, "(' Running out of storage for W in HCORE ')")
          write (iw,*) " NUMBER OF ATOMS CALCULATED FOR 'W':", i
          write (iw,*) " NUMBER OF ATOMS IN SYSTEM:", numat
          call mopend ("Running out of storage for W in HCORE")
        end if
      end if
    end do
    ii = iorbs(i)
    ii = (ii*(ii+1)) / 2
    if (id /= 0) then
      do i1 = kr, kr + ii * ii - 1
        wk(i1) = 0.d0
      end do
    end if
    if (ii /= 0) then
      call wstore (w(kr), kr, ni, ii)
    end if
  end do
 !
 !
  if (mode == -1) then
    parth(:mpack) = -h(:mpack)
    refnuc = -enuclr
  end if
  if (useps) then
    ! In the following routine the dielectric correction to the core-core-
    ! interaction is added to ENUCLR (just set arrays to zero)

    call addnucz (phinet, qscnet, qdenet)

  end if
  kr = kr - 1
 !
 !
  if (debug) then
    write (iw, "(//10X,'ONE-ELECTRON MATRIX FROM HCORE')")
    if (mode ==-1) then
      write (iw, "(10X,A)") " AFTER REMOVAL OF TERMS FOR MOVING ATOMS"
    end if
    if (mode == 1) then
      write (iw, "(10X,A)") " AFTER ADDITION OF TERMS FOR MOVING ATOMS"
    end if
    call vecprt_for_MOZYME (h, norbs)
    if (kr > 2000) then
      write (iw,*) " THE TWO-ELECTRON MATRIX IS TOO LARGE TO PRINT"
    end if
    j = Min (kr, 2000)
    if (id == 0) then
      write (iw, "(//10X,'TWO-ELECTRON MATRIX IN HCORE'/)")
10000   format (10 f8.4)
      write (iw, 10000) (w(i), i=1, j)
    else
      write (iw, "(//10X,'TWO-ELECTRON J MATRIX IN HCORE'/)")
      write (iw, 10000) (wj(i), i=1, j)
      write (iw, "(//10X,'TWO-ELECTRON K MATRIX IN HCORE'/)")
      write (iw, 10000) (wk(i), i=1, j)
    end if
  end if
end subroutine hcore_for_MOZYME

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      module chanel_C
!dec$ attributes dllexport :: iend, end_fn
      integer :: &
     & iw0       = -1, & !    Abbrev. output, for GUI (By default, not used)
     & ifiles_1  =  1, &
     & input     =  2, & !    Input               <Filename>.dat         FORMATTED
     & iscr      =  3, & !    Scratch             <Filename>.scr         UNFORMATTED
     & irot      =  2, & !    Two-electron integrals used in analytical work
     & iend      =  4, & !    End                 <Filename>.end         FORMATTED
     & ires      =  9, & !    Restart             <Filename>.res         UNFORMATTED
     & iden      = 10, & !    Density             <Filename>.den         UNFORMATTED
     & ilog      = 31, & !    Log                 <Filename>.log         FORMATTED
     & iarc      = 12, & !    Archive             <Filename>.arc         FORMATTED
     & igpt      = 13, & !    Graphics            <Filename>.gpt         UNFORMATTED
     & iext      = 14, & !    EXTERNAL params      Defined by EXTERNAL    FORMATTED
     & iesr      = 15, & !    ESP restart         <Filename>.esr         UNFORMATTED
     & isyb      = 16, & !    SYBYL file          <Filename>.syb         FORMATTED
     & isol      = 17, & !    SOL map in MEP      <Filename>.sol         FORMATTED
     & ibrz      = 18, & !    Brillouin Zone      <Filename>.brz         FORMATTED
     & iump      = 20, & !    Grid map            <Filename>.ump         FORMATTED
     & iesp      = 21, & !    Electrostatic map   <Filename>.esp         FORMATTED
     & imep      = 22, & !    MEP map             <Filename>.mep         FORMATTED
     & ixyz      = 23, & !    XYZ output file     <Filename>.xyz         Formatted
     & param_out = 24, & !
     & ir        = 25, & !    Input (During run)  <Filename>.temp        FORMATTED
     & iw        = 26, & !    Output              <Filename>.out         FORMATTED
     & isetup    = 27, &
     & lbfgs_it  = 28, &
     & idaf      = 29, & !    DAF (polarization)  29   <Filename>.pol         FORMATTED
     & iwc       = 30    !    COSMO output (used by keyword COSWRT)

      logical :: log

      integer, parameter :: filename_len = 241

      character(len=filename_len) :: &
     & job_fn,       &
     & input_fn,     &
     & output_fn,    &
     & restart_fn,   &
     & density_fn,   &
     & log_fn,       &
     & end_fn,       &
     & ext_fn,       &
     & brillouin_fn, &
     & esp_fn,       &
     & esr_fn,       &
     & ump_fn,       &
     & mep_fn,       &
     & pol_fn,       &
     & gpt_fn,       &
     & xyz_fn,       &
     & syb_fn,       &
     & cosmo_fn,     &
     & archive_fn

      integer, dimension(145) :: ifilen, ioda
      integer :: irecln = 1023, irecst
      end module chanel_C

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine Locate_TS
!
! Multi-step procedure for locating a transition state involving two stationary points in a
! protein mechanism
!
! Steps involved:
! A: Using lbfgs_TS, and two stationary points, locate an approximation to the transition state
! B: Using the TS option in ef and only those atoms involved in the active site, locate the transition state.
!      (This uses gradient minimization)
! C: Using normal geometry optimization optimize the positions of all other atoms
! D: Repeat B and C until the geometry is stable
!
    use common_arrays_C, only : xparam, loc, geoa, lopt, geo, grad, lopt_store
    USE molkst_C, only : nvar, keywrd, numcal, numat, density, use_ref_geo, mpack, n2elec, &
     line, step_num, escf, moperr, prt_coords
    use MOZYME_C, only : geo_1, geo_2
    use chanel_C, only : iw, iarc, input_fn, iden
    implicit none
    integer :: i, j, k, l, big_nvar, shell, loop, nloop, nset, store_mpack, store_n2elec, ipdb = 14
    double precision :: stresses(100), gradients(100), gnorm_store
    double precision, allocatable :: big_xparam(:)
    integer :: ninsite(3)
    integer, allocatable :: active_site(:)
    logical :: extra_print, exists, l_refine = .true., opend
    character :: line1*200
    double precision, external :: reada
    character :: num
    allocate(active_site(200))
    if (.not. allocated(geoa)) allocate(geoa(3,numat))
    if (allocated(geo_1)) then
      geoa(:,:numat) = geo_1(:,:numat)
      call build_active_site(active_site, ninsite)
      if (moperr) return
    end if
    gnorm_store = 0.d0
!
!   Fill array "lopt"  When two systems are used, "lopt" is the difference in connectivity (topology) of them.
!
    if (.not. allocated(geo_1)) then
!
! If geo_1 does not exist, only one system was input, i.e. GEO_REF was not used.
! so set up conditions to go straight to "Refine_TS"
!
!  Set "lopt" to
!
      shell = 0
      if (.not. allocated(lopt_store)) then
        allocate(lopt_store(3,numat))
        lopt(:3,:numat) = 1 - lopt(:3,:numat)
      end if
      lopt_store = 1
      deallocate(grad)
      allocate(grad(3*numat))
      goto 99
    end if
!
! If geo_1 does exist, so two systems were input, i.e. GEO_REF was used.
! so run LOCATE-TS in the normal way
!
    i = index(keywrd, " GNORM=")
    if (i /= 0) gnorm_store = reada(keywrd, i)
    gradients = max(4.d0,min(20.d0,sqrt(numat*0.5d0)))
    i = index(keywrd,  " LOCATE-TS") + 11
    do j = i + 1, len_trim(keywrd)
      if (keywrd(j:j) == " ") exit
    end do
    k = index(keywrd(i:j), "C:")
    if (k > 0) then
      extra_print = .true.
      i = i + k + 1
      nloop = 0
      do
        k = ichar(keywrd(i:i)) - ichar("0")
        if (k >= 0 .and. k < 10) then
          nloop = nloop + 1
          stresses(nloop) = reada(keywrd,i)
          if (stresses(nloop) > 999.d0) then
            write(line,'(a, i3, a, f8.1, a)')"Stress for point", nloop, " is", stresses(nloop)," This is too large, max. = 999.0."
            call mopend(trim(line))
            return
          end if
          do
            i = i + 1
            if (ichar(keywrd(i:i)) /= ichar(".") .and. ichar(keywrd(i:i)) < ichar("0") .or. ichar(keywrd(i:i)) > ichar("9")) exit
          end do
          i = i + 1
        else
          exit
        end if
        if (i > j) exit
      end do
    else
      if (keywrd(i:i) > "0" .and. keywrd(i:i) <= "9") then
        call mopend("The first term in LOCATE-TS must be either ""C:"" or ""SET:""")
        return
      end if
      extra_print = .false.
      stresses(1) = 3.d0
      stresses(2) = 30.d0
      stresses(3) = 30.d0
      stresses(4) = 30.d0
      stresses(5) = 30.d0
      nloop = 5
    end if
    k = 0
    if (index(keywrd, " LOCATE-TS ") == 0) then
      i = index(keywrd,  " LOCATE-TS") + 11
      do j = i + 1, len_trim(keywrd)
        if (keywrd(j:j) == " ") exit
      end do
      k = index(keywrd(i:j), "SET:")
    end if
    if (k /= 0) then
      nset = nint(reada(keywrd, i + k + 3))
      write(iw,'(/10x, a, i2, a)')"Set", nset, " selected by keyword 'SET' within keyword 'LOCATE-TS'"
      if (nset > 2) then
        write(iw,'(/10x, a)')"(This is greater than 2, so re-set to 2)"
        nset = 2
      end if
      if (active_site(1) == 0) then
        if (index(keywrd, " LET") == 0) then
          write(line,'(a,i1,a)') """SET=""",nset,""" used in LOCATE-TS, but no atoms involved in bond-making or bond-breaking!"
          call mopend( trim(line))
          write(iw,'(/10x,a,i1,a)') "(Either remove "";SET=""",nset,""" from keyword ""LOCATE-TS"""// &
            "or add keyword ""LET"" to allow job to continue)"
          return
        end if
      end if
    else
      nset = 1
      if (index(keywrd(i:j), "C:") == 0) then
        write(iw,'(/10x, a)')"By default, set 1 will be used.  To change default, see keyword 'LOCATE-TS'"
      else
        l_refine = .false.
      end if
    end if
!
!   Use optimization flags from GEO_REF
!
    nvar = 0
    do i = 1, numat
      do j = 1,3
        if (lopt_store(j,i) == 1) then
          nvar = nvar + 1
          loc(1, nvar) = i
          loc(2, nvar) = j
        end if
      end do
    end do
    loc(:,nvar + 1:) = 0
    big_nvar = 2*nvar
    allocate(big_xparam(big_nvar))
    if (nset > 0) then
      shell = ninsite(nset)
      call select_opt(shell, active_site)
      big_nvar = 2*nvar
      do i = 1, nvar
        k = loc(1,i)
        l = loc(2,i)
        big_xparam(i) = geo_1(l,k)
        big_xparam(i + nvar) = geo_2(l,k)
        xparam(i) = geo(l,k)
      end do
    else
      shell = 0
      big_xparam = 0.d0
    end if
!
! Delete GEO_REF and LOCATE-TS from the new .mop, .arc, and other files
!
    call delete_ref_key("GEO_REF=", len_trim("GEO_REF="), '" ', 2)
    call delete_ref_key("LOCATE-TS", len_trim("LOCATE-TS"), ') ', 2)
    call delete_ref_key("XYZ", len_trim("XYZ"), " ", 1)
    call delete_ref_key("OPT", len_trim("OPT"), " ", 1)
    if (nloop == 0) then
!
!  Use average of the two geometries, i.e., the average of the input data-set and reference geometries.
!
      do i = 1, nvar
        xparam(i)=0.5d0*(big_xparam(i) + big_xparam(i + nvar))
        k = loc(1,i)
        l = loc(2,i)
        geo(l,k) = xparam(i)
      end do
      if (extra_print .and. prt_coords) then
        write(iw,'(/10x,a,/)')"Average of the input and reference geometries"
        call geout (iw)
      end if
    else
!
!            Locate the transition state by climbing the barrier. The strength of the pull from the
!            other geometry is in "density"  The pull is increased in steps, with the steps in "stresses"
!
!
! Run reference geometry
!
      density = 0.d0
      call big_swap(1,2)
      numcal = numcal + 1
      step_num = step_num + 1
      call set_up_rapid("ON")
      call set_up_rapid("OFF")
      call big_swap(0,2)
      geoa(:,:numat) = geo(:,:numat)
!
! Run data-set geometry
!
      call big_swap(1,1)
      nvar = 0
      do i = 1, numat
        do j = 1,3
          if (lopt_store(j,i) == 1) then
            nvar = nvar + 1
            xparam(nvar) = geo(j,i)
          end if
        end do
      end do
      numcal = numcal + 1
      step_num = step_num + 1
      call set_up_rapid("ON")
      call set_up_rapid("OFF")
      if (gnorm_store > 0.1d0) gradients(:nloop) = gnorm_store
      do loop = 1, nloop
        density = stresses(loop)
        if(density > 99.9499d0) then
          num = "6"
        else if(density > 9.9499d0) then   !  DELETE
          num = "5"
        else
          num = "4"
        end if
  !      write(iw,'(/10x,a,f0.2,a,/)')"Constraining constant: ",density, " Kcal/mol/Angstrom^2"
        write(line1,'(a,f'//num//'.2)')"C: ",density
        write(line,'(a,S,f0.5)')"GNORM=",gradients(loop)
        write(line1(len_trim(line1) + 4:),'(a)')trim(line)
        call l_control(trim(line), len_trim(line), 1)
        extra_print = (extra_print .or. loop == nloop)
        call lbfgs_TS(big_xparam, big_nvar, escf, extra_print)
      end do
    end if
!
!           The approximate location of the transition state has now been found.
!           Now switch off the two geometry option, and prepare to refine the transition state.
!
    if (shell == 0 .and. ninsite(1) == 0) return
99  continue
    if (.not. l_refine) goto 98
    use_ref_geo = .false.
!
! Switch off the use of a GEO_REF, from here on the geometry is self-referential
!
    density = 0.d0
!
!   Select set of atoms to be used in the active site.
!
    geoa(:,:numat) = geo(:,:numat)
    line = "LET DDMIN=0.D0 GEO-OK"
    if (gnorm_store > 0.1d0) write(line(len_trim(line) + 1:),'(a,f4.1)')" GNORM=",gnorm_store
    call l_control(line, len_trim(line), 1)
    numcal = numcal + 1
    store_mpack = mpack
    store_n2elec = n2elec
    call moldat(1)
    mpack = store_mpack
    n2elec = store_n2elec
    if (shell > 0) then
      lopt(:,:numat) = 1
      do i = 1, shell
        lopt(:,active_site(i)) = 0
      end do
    end if
    call Refine_TS
    close(iarc)
    if (index(keywrd, " PDBOUT") /= 0) then
      line = input_fn(:len_trim(input_fn) - 5)//".pdb"
      call add_path(line)
      inquire(unit=ipdb, opened=opend)
      if (opend) close(ipdb)
      open(unit=ipdb, file=trim(line), status='UNKNOWN', position='asis')
      call pdbout(ipdb)
      close (ipdb)
    end if
98  line = input_fn(:len_trim(input_fn) - 4)//"den"
    inquire (file=trim(line), exist = exists)
    if (exists) then
      open(unit=iden, file=trim(line))
      close(unit=iden, status='DELETE')
    end if
    return
  end subroutine Locate_TS

  subroutine lbfgs_TS (big_xparam, big_nvar, escf_tot, extra_print)
!
!  Use the limited-memory quasi-Newton Broyden-Fletcher-Goldfarb-Shanno method for unconstrained optimization
!
!    J. Nocedal. Updating Quasi-Newton Matrices with Limited Storage (1980),
!    Mathematics of Computation 35, pp. 773-782.
!    D.C. Liu and J. Nocedal. On the Limited Memory Method for Large Scale Optimization (1989),
!    Mathematical Programming B, 45, 3, pp. 503-528.
!
  use molkst_C, only: tleft, time0, iflepo, tdump, gnorm, keywrd, density, &
  moperr, nvar, id, line, numat, refkey, title
!
  use chanel_C, only: iw0, iw, log, ilog, input_fn, iarc
!
  use common_arrays_C, only : loc, geo, xparam, geoa
!
  use ef_C, only : nstep
!
  implicit none
  integer, intent (in) :: big_nvar
  logical :: extra_print
  double precision, intent (out) :: escf_tot
  double precision, dimension (big_nvar), intent (inout) ::  big_xparam
!
  character :: txt, csave*60, task*60, bias*7, fmt*3
  logical :: times, lsave(4), first = .true., opend
  integer :: i, k, l, itry1, jcyc, niwa, nwa, alloc_stat, m, isave(44), &
    nflush = 1
!
  double precision :: absmin, const, cycmx, stepmx, sum, tstep, tt0, rms, sum1, sum2, &
  & tlast, tolerg, tprt, tx1, tx2, oldstp(12), dsave(29), escf1, escf2, e_stress
!
  double precision, dimension(:), allocatable :: bot, gold, top, xold, wa, big_grad, store_big_grad
  integer, dimension (:), allocatable :: iwa, nbd
! For Mopac BLAS
  double precision, external :: ddot, dot, reada, seconds
!
  save :: tlast, first
!
  allocate (nbd(big_nvar), big_grad(big_nvar), store_big_grad(big_nvar), stat=alloc_stat)
  if (alloc_stat /= 0) then
    call memory_error ("mod_lbfgs")
    return
  end if
  m = 12
  nstep = 0
  niwa = 3 * big_nvar
  nwa = 2 * big_nvar * m + 4 * big_nvar + 11 * m ** 2 + 8 * m
  allocate (bot(big_nvar), gold(big_nvar), top(big_nvar), xold(big_nvar), wa(nwa), &
    iwa(niwa), stat=alloc_stat)
  wa = 0.d0
  iwa = 0
  task = " Unused"
  csave = " Unused"
  lsave = .false.
  isave = 0
  times = (Index (keywrd, " TIMES") /= 0)
  if (Index (keywrd, "GNORM=") /= 0) then
    tolerg = reada (keywrd, Index (keywrd, "GNORM="))
    if (Index (keywrd, " LET") == 0 .and. tolerg < 1.d-2) then
      write (iw, "(/,A)") "  GNORM HAS BEEN SET TOO LOW, RESET TO 0.01"
      tolerg = 1.d-2
    end if
  else
    tolerg = 1.d0
    if (id /= 0) tolerg = id*2.d0 - 1.d0
    if (Index (keywrd, " PREC") /= 0) then
      tolerg = tolerg*0.2d0
    end if
  end if
  do i = 1, 10
    oldstp(i) = 1.d0
  end do
  tlast = tleft
  tx2 = seconds (2)
  tx1 = tx2
!
!  Turn OFF all bounds checking.  This saves memory and speeds things up
!
  do i = 1, big_nvar
    nbd(i) = 0
  end do
  task = "START"
  jcyc = 0
  cycmx = 0.d0
  tlast = tleft
  itry1 = 0
  absmin = 1.d6
  do
    if (times) then
      call timer ("Before SETULB")
    end if
    call dcopy (big_nvar, big_xparam, 1, xold, 1)
!
!     THIS IS THE CALL TO THE L-BFGS-B CODE.
!
    call setulb (big_nvar, m, big_xparam, bot, top, nbd, escf_tot, big_grad, 0.d0, &
    & 0.d0, wa, iwa, task,-1, csave, lsave, isave, dsave)
    if (moperr) goto 99
    if (times) then
      call timer ("AFTER SETULB")
    end if
    dsave(2) = dsave(2) + 1.d4
    if (task(1:2) == "FG") then
      if (jcyc > 1) then
!
!  How big was the step in parameter space?
!
        sum = 0.d0
        do i = 1, big_nvar
          sum = sum + (big_xparam(i)-xold(i)) ** 2
        end do
        sum = Sqrt (sum)
        i = min(big_nvar,10)
        stepmx = Min (1.d0, dSqrt (ddot(i,oldstp, 1,oldstp, 1)/i))
        if (sum > stepmx*2.d0) then
!
! Step was too big - this was probably due to an error in SETULB.
! Reduce the step to two times STEPMX
!
          const = 2.d0 * stepmx / sum
          do i = 1, big_nvar
            big_xparam(i) = const * big_xparam(i) + (1.d0-const) * xold(i)
          end do
          sum = 2.d0 * stepmx
        end if
        oldstp(Mod(jcyc, 10)+1) = sum
      end if
!
!  Limit step to 0.2 Angstroms.  This should help damp wild swings
!
      sum = 0.2d0
      do i = 1, big_nvar
        if (abs(big_xparam(i) - xold(i)) > sum) then
          big_xparam(i) = xold(i) + max(-sum, min(sum, big_xparam(i) - xold(i)))
        end if
      end do
      if (first) then
        call  geo_diff(sum, rms, .false.)
        if (density < 0.01d0) then
          write(iw,'(/10x,a,f23.3,a)')"Current value of GEO_REF constraint:", density, " Kcal/mol/Angstrom^2"
        else
          write(iw,'(/10x,a,f22.2,a)')"Current value of GEO_REF constraint:", density, "  Kcal/mol/Angstrom^2"
        end if
        write(iw,'(10x,a,f26.2,a)') "Distance between the geometries:", sum,"  Angstroms"
      end if
      call compfg_TS (big_xparam, (mod(jcyc,222) == 0), escf1, escf2, .true., big_grad, .true.)
      if (first) then
        first = .false.
        store_big_grad(:big_nvar) = big_grad(:big_nvar)
        e_stress = 0.d0
!
!  Evaluate the cosine of the angle between the gradient-vectors for the two geometries
!  This should be need to -1.0, i.e., the angle should be about 180 degrees.
!
        do k = 1, nvar
          i = loc(1,k)
          l = loc(2,k)
          big_grad(k) = big_grad(k) + (geo(l,i) - geoa(l,i))*density*2.d0
          big_grad(k + nvar) = big_grad(k + nvar) + (geoa(l,i) - geo(l,i))*density*2.d0
          e_stress = e_stress + (geo(l,i) - geoa(l,i))**2*density
        end do
        write(iw,'(/10x,a,f19.3,a)') "Heat of formation of the first geometry:", escf1 - e_stress, " Kcal/mol"
        write(iw,'(10x,a,f18.3,a)') "Heat of formation of the second geometry:", escf2 - e_stress, " Kcal/mol"
        write(iw,'(10x,a,f11.3,a)') "Contribution to heat of formation due to stress:", 2.d0*e_stress, "  Kcal/mol"
        sum1 = sqrt(dot(big_grad, big_grad, nvar))
        sum2 = sqrt(dot(big_grad(nvar + 1), big_grad(nvar + 1), nvar))
        write(iw,'(10x,a,f22.3,a)') "Gradient arising from first geometry:", sum1, "  Kcal/mol/Angstrom"
        write(iw,'(10x,a,f21.3,a)') "Gradient arising from second geometry:", sum2,"  Kcal/mol/Angstrom"
        sum = dot(big_grad, big_grad(nvar + 1), nvar)/(sum1*sum2)
        if (sum < 0.d0) then
          write(iw,'(10x,a, f27.2, a, /)')"Angle between gradient vectors:", acos(sum)*57.2957795d0, "  degrees"
        else
          write(iw,'(10x,a, f15.2, a, /)')"WARNING! - Angle between gradient vectors: ", acos(sum)*57.2957795d0, "  degrees"
        end if
        big_grad(:big_nvar) = store_big_grad(:big_nvar)
      end if
      escf_tot = escf1 + escf2
      if (moperr) goto 99
      if (absmin-escf_tot < 1.d-7) then
        itry1 = itry1 + 1
        if (itry1 > 900 .or. (gnorm < 1.d0 .and. itry1 > 9)) then
          write (iw, "(//,' HEAT OF FORMATION IS ESSENTIALLY STATIONARY')")
          iflepo = 3
          exit
        end if
      else
        itry1 = 0
        absmin = escf_tot
      end if
      if (times) then
        call timer ("AFTER COMPFG_TS")
      end if
!
!  Write out this cycle
!
    jcyc = jcyc + 1
    tx2 = seconds (2)
    tstep = tx2 - tx1
    cycmx = Max (tstep, cycmx)
    tx1 = tx2
    tleft = tleft - tstep
    if (tlast-tleft > tdump) then
      tlast = tleft
      tt0 = seconds (1) - time0
      call lbfsav (tt0, 1, wa, nwa, iwa, niwa, task, csave, lsave, isave, &
            & dsave, jcyc, escf_tot)
      if (moperr) goto 99
    end if
    tleft = Max (0.d0, tleft)
    call prttim (tleft, tprt, txt)
    gnorm = dSqrt (ddot(big_nvar, big_grad, 1, big_grad, 1))
!
!   Write out current status
!
    if (id == 3) then
      call write_cell(iw)
      call write_cell(iw0)
    end if
    nstep = nstep + 1
    write (line, '(" CYCLE:", i6, " TIME:", f8.3, " TIME LEFT:", &
      & f6.2, a1, "  GRAD.:", f10.3, " HEAT:", g14.7)') &
      jcyc, Min (tstep, 9999.99d0), tprt, txt, &
      & Min (gnorm, 999999.999d0), escf_tot
    write(iw,"(a)")trim(line)
    endfile (iw)
    backspace (iw)
    if (log) write (ilog, "(a)")trim(line)
    call to_screen(line)
    if (mod(jcyc,30) == 0) then
      line = trim(input_fn)
      call add_path(line)
      i = len_trim(line) - 5
      call to_screen(line(:i))
    end if
    if (nflush /= 0) then
      if (Mod(jcyc, nflush) == 0) then
        endfile (iw)
        backspace (iw)
        if (log) then
          endfile (ilog)
          backspace (ilog)
        end if
      end if
    end if
    call to_screen("To_file: Geometry optimizing")
!
!  Write out the cosine of the angle that the new gradient makes
!  with the old gradient.  Ideally, this should be small.
!
      call dcopy (big_nvar, big_grad, 1, gold, 1)
      endfile (iw)
      backspace (iw)
!
!  EXIT CRITERIA.  (The criteria in SETULB are ignored.)
!
      if (gnorm < tolerg) then
        iflepo = 19
        exit
      end if
    else if (task(1:5) /= "NEW_X") then
      write (iw, "(2A)") " L-BFGS Message:", task
      iflepo = 9
      exit
    end if
  end do
   if (gnorm < tolerg) &
     write (iw, '(/, 5 x, "GRADIENT =", f9.5, " IS LESS THAN CUTOFF =", f9.5,//)') gnorm, tolerg
!
!  Prepare to exit: advise user of current status, in case anything goes wrong.
!
99 call  geo_diff(sum, rms, .false.)
  e_stress = 0.d0
!
!  Evaluate the cosine of the angle between the gradient-vectors for the two geometries
!  This should be need to -1.0, i.e., the angle should be about 180 degrees.
!
  do k = 1, nvar
    i = loc(1,k)
    l = loc(2,k)
    big_grad(k) = big_grad(k) + (geo(l,i) - geoa(l,i))*density*2.d0
    big_grad(k + nvar) = big_grad(k + nvar) + (geoa(l,i) - geo(l,i))*density*2.d0
    e_stress = e_stress + (geo(l,i) - geoa(l,i))**2*density
  end do
  if(density > 99.9499d0) then
    fmt = "5.1"
  else if(density > 9.9499d0) then
    fmt = "4.1"
  else if (density > 0.9499d0) then
    fmt = "3.1"
  else if (density > 0.09499d0) then
    fmt = "4.2"
  else
    fmt = "5.3"
  end if
  line = refkey(1)
  call upcase(line, len_trim(line))
!
! Remove SETUP
!
  k = index(line, " SETUP")
  if (k > 0) then
    l = k + 6
    do
      if (line(l:l) == " ") exit
      l = l + 1
    end do
    refkey(1) = refkey(1)(:k)//refkey(1)(l:)
  end if
  line = refkey(1)
  call upcase(line, len_trim(line))
  k = index(line, "GEO_DAT=") + 9
  if (k /= 9) then
    l = index(line(k:),'" ') + k
    refkey(1) = refkey(1)(:k - 10)//refkey(1)(l:)
    line = line(:k - 10)//line(l:)
  end if
  if (extra_print) then
    k = index(line, "GEO_REF=") + 9
    l = index(line(k:),'"') + k
    line = input_fn(:len_trim(input_fn) - 5)

    write(bias,'(f'//fmt//')') density
    title = "(Bias="//trim(bias)//" first) "//trim(title)
    write(line(len_trim(line) + 1:),'(a,f'//fmt//',a)')" bias=",density, " first.mop"
    call add_path(line)
    inquire(unit=iarc, opened=opend)
    if (opend) close(iarc)
    open(unit=iarc, file=trim(line), status='UNKNOWN', position='asis')
    write(iw,'(/10x,a,/10x,a,f'//fmt//',a,/10x,a,/)')"First geometry (derived from data-set) after optimization subject to ", &
    &"GEO_REF constraint of ", density, " Kcal/mol/Angstrom^2 towards the reference geometry written to file:", &
    &"'"//trim(line)//"'"
    call geout (iarc)
    close(iarc)
    k = index(title, ")") + 2
    title = trim(title(k:))
    geo(:,:numat) = geoa(:,:numat)
    line = refkey(1)
    call upcase(line, len_trim(line))
    k = index(line, "GEO_REF=") + 9
    l = index(line(k:),'"') + k
    line = input_fn(:len_trim(input_fn) - 5)
    title = "(Bias="//trim(bias)//" second) "//trim(title)
    write(line(len_trim(line) + 1:),'(a,f'//fmt//',a)')" bias=",density, " second.mop"
    call add_path(line)
    inquire(unit=iarc, opened=opend)
    if (opend) close(iarc)
    open(unit=iarc, file=trim(line), status='UNKNOWN', position='asis')
    write(iw,'(/10x,a,/10x,a,f'//fmt//',a,/10x,a,/)')"Second geometry (derived from reference geometry)"// &
    & "after optimization subject to ", "GEO_REF constraint of ", density, &
    " Kcal/mol/Angstrom^2 towards the data-set geometry written to file:", "'"//trim(line)//"'"
    call geout (iarc)
    close(iarc)
    k = index(title, ")") + 2
    title = trim(title(k:))
  end if
  write(iw,'(/10x,a,a)') "Job name: ","'"//input_fn(:len_trim(input_fn) - 5)//"'"
  if (density < 0.01d0) then
    write(iw,'(10x,a,f23.3,a)')"Current value of GEO_REF constraint:", density, " Kcal/mol/Angstrom^2"
  else
    write(iw,'(/10x,a,f22.2,a)')"Current value of GEO_REF constraint:", density, "  Kcal/mol/Angstrom^2"
  end if
  write(iw,'(10x,a,f24.2,a)') "Distance between the geometries:", sum,"  Angstroms"
  do i = 1, nvar
    k = loc(1,i)
    l = loc(2,i)
    geo(l,k) = big_xparam(i)
  end do
  call geo_diff(sum, rms, .true.)
  write(iw,'(/10x,a,f19.3,a)') "Heat of formation of the first geometry:", escf1 - e_stress, " Kcal/mol"
  write(iw,'(10x,a,f18.3,a)') "Heat of formation of the second geometry:", escf2 - e_stress, " Kcal/mol"
  write(iw,'(10x,a,f11.3,a)') "Contribution to heat of formation due to stress:", 2.d0*e_stress, "  Kcal/mol"
  sum1 = sqrt(dot(big_grad, big_grad, nvar))
  sum2 = sqrt(dot(big_grad(nvar + 1), big_grad(nvar + 1), nvar))
  write(iw,'(10x,a,f22.3,a)') "Gradient arising from first geometry:", sum1, "  Kcal/mol/Angstrom"
  write(iw,'(10x,a,f21.3,a)') "Gradient arising from second geometry:", sum2,"  Kcal/mol/Angstrom"
  sum = dot(big_grad, big_grad(nvar + 1), nvar)/(sum1*sum2)
  if (sum < 0.d0) then
    write(iw,'(10x,a, f27.2, a, /)')"Angle between gradient vectors:", acos(sum)*57.2957795d0, "  degrees"
  else
    write(iw,'(10x,a, f15.2, a, /)')"WARNING! - Angle between gradient vectors: ", acos(sum)*57.2957795d0, "  degrees"
  end if
  do i = 1, nvar
    xparam(i)=0.5d0*(big_xparam(i) + big_xparam(i + nvar))
    k = loc(1,i)
    l = loc(2,i)
    geo(l,k) = xparam(i)
  end do
  if (extra_print) then
    line = input_fn(:len_trim(input_fn) - 5)
    title = "(Bias="//trim(bias)//" average) "//trim(title)
    write(line(len_trim(line) + 1:),'(a,f'//fmt//',a)')" bias=",density, " average.mop"
    call add_path(line)
    inquire(unit=iarc, opened=opend)
    if (opend) close(iarc)
    open(unit=iarc, file=trim(line), status='UNKNOWN', position='asis')
     write(iw,'(/10x,a,/10x,a,f'//fmt//',a,/10x,a,/)')"Average of first and second geometries after optimization subject to ", &
    &"GEO_REF constraint of ", density, " Kcal/mol/Angstrom^2 towards the data-set geometry written to file:", &
    &"'"//trim(line)//"'"
    call geout (iarc)
    close(iarc)
    k = index(title, ")") + 2
    title = trim(title(k:))
  end if
  return
  end subroutine lbfgs_TS

  subroutine compfg_TS(big_xparam, int, escf1, escf2, fulscf, big_grad, lgrad)
!
! compfg_TS evaluates the heat of formation and, if lgrad, the gradients of the two systems,
! one in the data-set and one in the reference data-set.
!
    USE molkst_C, ONLY: nvar, numat
    use common_arrays_C, only : geo, geoa, grad
    use MOZYME_C, only : geo_1, geo_2
    implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
    double precision, intent(out) :: escf1, escf2
    logical , intent(in) :: int
    logical, intent(in)  :: fulscf
    logical , intent(in) :: lgrad
    double precision, intent(in) :: big_xparam(2*nvar)
    double precision, intent (out) :: big_grad(2*nvar)
    double precision, allocatable :: xparam(:)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
    integer :: i, nparam = -1
    save xparam, nparam
!  Reallocate xparam as needed
   if (nparam < nvar) then
     if(nparam >= 0) deallocate(xparam)
     nparam = nvar
     allocate(xparam(nparam))
   end if
!
!  Save the current point
!
    do i = 1, nvar
      xparam(i) = big_xparam(i)
    end do
!
!  Run data-set geometry, using reference geometry as geo_ref - this is in geoa
!
    call big_swap(1,1)
    call compfg(xparam, int, escf1, fulscf, grad, lgrad)
    call big_swap(0,1)
    big_grad(:nvar) = grad(:nvar)
    geoa(:,:numat) = geo(:,:numat)
!
! Run reference geometry using data-set as reference - this is now in geoa
!
    call big_swap(1,2)
    xparam = big_xparam(nvar + 1: 2*nvar)
    call compfg(xparam, int, escf2, fulscf, grad, lgrad)
    big_grad(nvar + 1: 2*nvar) = grad(:nvar)
    call big_swap(0,2)
!
!  Re-set geo and geoa to data-set and reference geometries
!
    geo(:,:numat) = geo_1(:,:numat)
    geoa(:,:numat) = geo_2(:,:numat)
    return
  end subroutine compfg_TS

  subroutine l_control(txt, nt, mode)
!
!   l_control has two modes:
!
! (A)  If mode =  1 the word(s) in txt is(are) added to keywrd.  If the word in txt already exists
!                   in keywrd, the word in txt would first be deleted from keywrd.
! (B)  If mode = -1 the word(s) in txt is(are) removed from keywrd
!
!  txt can consists of upper and lower case letters, "-" and "_"; the last two allow hyphenated words.
!
  use molkst_C, only : keywrd
  implicit none
  integer :: nt, mode
  character :: txt*(nt), store*2000, line*2000
  integer :: i, j, trim_len, mt
  character :: local_txt*(nt), ch*1
  local_txt = txt
  do
!
!  Parse each word, one at a time.
!
    do
      if (local_txt(1:1) /= " ") exit
      local_txt = local_txt(2:)
    end do
    ch = " "
    mt = 0
    do i = 1, nt
      mt = mt + 1
      if (local_txt(mt:mt) == '"') then ! Quickly run to the closing '"'
        do mt = mt + 1, nt
          if (local_txt(mt:mt) == '"') exit
        end do
      end if
      if (local_txt(mt:mt) == ' ') exit
      if (mt == nt) exit
    end do
    line = local_txt(:mt)
!
!  "line" holds a single keyword
!
    local_txt = local_txt(mt + 1:)
    if (line(1:1) >= "0" .and. line(1:1) <= "9") then
      i = mt + 1
      else
  !
  ! find the end of the defined keyword, e.g., in pi=3.1415, that would be "i"
  !
      do i = 1, mt
        if ((line(i:i) < "A" .or. line(i:i) > "Z") .and. (line(i:i) < "a" .or. line(i:i) > "z") .and. &
        line(i:i) /= "_" .and. line(i:i) /= "-") exit
      end do
    end if
    trim_len = i - 1
!
!  If keyword already exists, then delete the keyword
!  Keyword can have an "=" sign, or be followed by a "(" or a '"'
!  in which case, find the end of the keyword.
!
    do
      if (keywrd == " ") exit
      i = index(keywrd, " "//line(:trim_len))
      if (i > 0) then
        j = i + trim_len + 1
        if (keywrd(j:j) /= " ") then
          if (keywrd(j:j) == "=") j = j + 1
          ch = " "
          if (keywrd(j:j) == "(") then
            ch = ")"
          else if (keywrd(j:j) == '"') then
            ch = '"'
          end if
          do
            j = j + 1
            if (keywrd(j:j) == ch) exit
          end do
        end if
!
!  Clumsy fix to delete existing keywords that contain quotation marks.
!
        if (j > 1) then
          if (keywrd(j - 1:j - 1) == '"') then
            store = keywrd(:i)//'"'//trim(keywrd(j:))
          else
            do
              if (keywrd(j:j) == " ") exit
              j = j + 1
            end do
            store = keywrd(:i)//trim(keywrd(j + 1:))
          end if
        end if
        keywrd = trim(store)
      else
        exit
      end if
    end do
    store = " "
    if (mode == 1) then
      i = index(keywrd, store(:mt + 50))
      keywrd = keywrd(:i)//line(:mt)//trim(keywrd(i + mt + 1:))
    end if
    if (local_txt == " ") exit
  end do
  return
  end subroutine l_control

  subroutine get_pars(stresses, gradients, relscf, cutoff, nloop)
!
!  Used for calibrating quantities
!
  use molkst_C, only : line
  implicit none
  double precision :: stresses(20), gradients(20), relscf(20), cutoff(20)
  integer :: nloop, io_stat
!
!  Local
!
    read(33,'(a)')line
    nloop = 0
    do
      read(33,'(a)', iostat = io_stat) line
      nloop = nloop + 1
      if (io_stat /= 0) exit
      read(line,*, iostat = io_stat)stresses(nloop), gradients(nloop), relscf(nloop), cutoff(nloop)
      if (io_stat /= 0) exit
    end do
    nloop = nloop - 1
    close (33)
    return
  end subroutine get_pars

  Subroutine big_swap(mode, system)
!
!  Given two entire geometries, via 'GEO_REF="data-set.moip"', store or read
!  a geometry and all arrays specific to that geometry, e.g., occupied and virtual LMO's
!
! On input:
!           mode == 0:  Store data on the current system
!           mode == 1:  Extract data on the current system
!         system == 1:  System is based on the first data-set
!         system == 2:  System is based on the second data-set

    use molkst_C, only : numat, mpack
    use cosmo_C, only: solv_energy
!
    use common_arrays_C, only : coord, geo, nbonds, ibonds, xparam, f, p, dxyz, pa, pb
    use MOZYME_C, only : icocc, icvir, ncocc, ncvir, nncf, nnce, cocc, cvir, &
        cocc_dim, icocc_dim, icvir_dim, cvir_dim, ncf, nce,  iijj, &
        partf, partp, nijbo, iij, ijall, numij, iorbs, &
        nbonds_1, ibonds_1, icocc_1, icvir_1, ncocc_1, ncvir_1, &
        nncf_1, nnce_1, nce_1, ncf_1,  norred, nelred, &
        nijbo_1, iijj_1, iij_1, ijall_1, numij_1, iorbs_1, &
        nbonds_2, ibonds_2, icocc_2, icvir_2, ncocc_2, ncvir_2, &
        nncf_2, nnce_2, nce_2, ncf_2,  parth, parth_1, parth_2, &
        nijbo_2, iijj_2, iij_2, ijall_2, numij_2, iorbs_2, &
        geo_1, geo_2, dxyz_1, dxyz_2, &
        cocc_1, cvir_1, cocc_2, cvir_2, xparam_1, xparam_2, &
        partf_1, partp_1, f_1, p_1, refnuc, &
        partf_2, partp_2, f_2, p_2
    implicit none
    integer, intent (in) :: mode, system
    integer :: icocc_dim_1, icvir_dim_1, cvir_dim_1, cocc_dim_1, mpack_1, &
    icocc_dim_2, icvir_dim_2, cvir_dim_2, cocc_dim_2, mpack_2, norred_1, norred_2, &
      nelred_1, nelred_2
    double precision :: refnuc_1, refnuc_2, solv_energy_1 = 0.d0, solv_energy_2 = 0.d0
    save
    if (mode == 0) then
!
!  Store system
!
      if (system == 1) then
        if (allocated(nbonds)) then
          if (.not. allocated(nbonds_1)) allocate (nbonds_1(numat), ibonds_1(15,numat), &
          geo_1(3,numat), dxyz_1(3*numat))
          nbonds_1 = nbonds
          ibonds_1 = ibonds
        end if
        icocc_dim_1 = icocc_dim
        icvir_dim_1 = icvir_dim
        cvir_dim_1  = cvir_dim
        cocc_dim_1  = cocc_dim
        norred_1    = norred
        nelred_1    = nelred
        refnuc_1    = refnuc
        solv_energy_1 = solv_energy
        mpack_1 = mpack
        call copy_r_2(geo,             geo_1, 3)
        call copy_r_1(dxyz,           dxyz_1)
        call copy_i_1(icocc,         icocc_1)
        call copy_i_1(icvir,         icvir_1)
        call copy_i_1(ncocc,         ncocc_1)
        call copy_i_1(ncvir,         ncvir_1)
        call copy_i_1(nncf,           nncf_1)
        call copy_i_1(nnce,           nnce_1)
        call copy_i_1(ncf,             ncf_1)
        call copy_i_1(nce,             nce_1)
        call copy_i_1(iij,             iij_1)
        call copy_i_1(iijj,           iijj_1)
        call copy_i_1(ijall,         ijall_1)
        call copy_i_1(numij,         numij_1)
        call copy_i_1(iorbs,         iorbs_1)
        call copy_i_2(nijbo,         nijbo_1, numat)
        call copy_r_1(cocc,           cocc_1)
        call copy_r_1(cvir,           cvir_1)
        call copy_r_1(xparam,       xparam_1)
        call copy_r_1(partf,         partf_1)
        call copy_r_1(partp,         partp_1)
        call copy_r_1(parth,         parth_1)
        call copy_r_1(f,                 f_1)
        call copy_r_1(p,                 p_1)
      else
        if (allocated(nbonds)) then
          if (.not. allocated(nbonds_2)) allocate (nbonds_2(numat), ibonds_2(15,numat), &
          geo_2(3,numat), dxyz_2(3*numat))
          nbonds_2 = nbonds
          ibonds_2 = ibonds
        end if
        icocc_dim_2 = icocc_dim
        icvir_dim_2 = icvir_dim
        cvir_dim_2  = cvir_dim
        cocc_dim_2  = cocc_dim
        norred_2    = norred
        nelred_2    = nelred
        refnuc_2    = refnuc
        solv_energy_2 = solv_energy
        mpack_2 = mpack
        call copy_r_2(geo,             geo_2, 3)
        call copy_r_1(dxyz,           dxyz_2)
        call copy_i_1(icocc,         icocc_2)
        call copy_i_1(icvir,         icvir_2)
        call copy_i_1(ncocc,         ncocc_2)
        call copy_i_1(ncvir,         ncvir_2)
        call copy_i_1(nncf,           nncf_2)
        call copy_i_1(nnce,           nnce_2)
        call copy_i_1(ncf,             ncf_2)
        call copy_i_1(nce,             nce_2)
        call copy_i_1(iij,             iij_2)
        call copy_i_1(iijj,           iijj_2)
        call copy_i_1(ijall,         ijall_2)
        call copy_i_1(numij,         numij_2)
        call copy_i_1(iorbs,         iorbs_2)
        call copy_i_2(nijbo,         nijbo_2, numat)
        call copy_r_1(cocc,           cocc_2)
        call copy_r_1(cvir,           cvir_2)
        call copy_r_1(xparam,       xparam_2)
        call copy_r_1(partf,         partf_2)
        call copy_r_1(partp,         partp_2)
        call copy_r_1(parth,         parth_2)
        call copy_r_1(f,                 f_2)
        call copy_r_1(p,                 p_2)
      end if
    else
!
! Extract system
!
      if (system == 1) then
        nbonds(:numat) = nbonds_1(:numat)
        ibonds(:,:numat) = ibonds_1(:,:numat)
        if (icocc_dim_1 > 0) icocc_dim = icocc_dim_1
        if (icvir_dim_1 > 0) icvir_dim = icvir_dim_1
        if (cvir_dim_1 > 0)  cvir_dim  = cvir_dim_1
        if (cocc_dim_1 > 0)  cocc_dim  = cocc_dim_1
        if (norred_1 > 0)    norred    = norred_1
        if (nelred_1 > 0)    nelred    = nelred_1
        if (refnuc_1 > 0)    refnuc    = refnuc_1
        if (abs(solv_energy_1) > 0.1d0) solv_energy = solv_energy_1
        if (mpack_1 > 0) mpack = mpack_1
        call copy_r_2(geo_1,             geo, 3)
        call copy_r_1(dxyz_1,           dxyz)
        call copy_i_1(icocc_1,         icocc)
        call copy_i_1(icvir_1,         icvir)
        call copy_i_1(ncocc_1,         ncocc)
        call copy_i_1(ncvir_1,         ncvir)
        call copy_i_1(nncf_1,           nncf)
        call copy_i_1(nnce_1,           nnce)
        call copy_i_1(ncf_1,             ncf)
        call copy_i_1(nce_1,             nce)
        call copy_i_1(iij_1,             iij)
        call copy_i_1(iijj_1,           iijj)
        call copy_i_1(ijall_1,         ijall)
        call copy_i_1(numij_1,         numij)
        call copy_i_1(iorbs_1,         iorbs)
        call copy_i_2(nijbo_1,         nijbo, numat)
        call copy_r_1(cocc_1,           cocc)
        call copy_r_1(cvir_1,           cvir)
        call copy_r_1(xparam_1,       xparam)
        call copy_r_1(partf_1,         partf)
        call copy_r_1(partp_1,         partp)
        call copy_r_1(parth_1,         parth)
        call copy_r_1(f_1,                 f)
        call copy_r_1(p_1,                 p)
        if (allocated(pa)) pa = p*0.5d0
        if (allocated(pb)) pb = pa
      else
        nbonds(:numat) = nbonds_2(:numat)
        ibonds(:,:numat) = ibonds_2(:,:numat)
        if (icocc_dim_2 > 0) icocc_dim = icocc_dim_2
        if (icvir_dim_2 > 0) icvir_dim = icvir_dim_2
        if (cvir_dim_2 > 0)  cvir_dim  = cvir_dim_2
        if (cocc_dim_2 > 0)  cocc_dim  = cocc_dim_2
        if (norred_2 > 0)    norred    = norred_2
        if (nelred_2 > 0)    nelred    = nelred_2
        if (refnuc_2 > 0)    refnuc    = refnuc_2
        if (abs(solv_energy_2) > 0.1d0) solv_energy = solv_energy_2
        if (mpack_2 > 0) mpack = mpack_2
        call copy_r_2(geo_2,             geo, 3)
        call copy_r_1(dxyz_2,           dxyz)
        call copy_i_1(icocc_2,         icocc)
        call copy_i_1(icvir_2,         icvir)
        call copy_i_1(ncocc_2,         ncocc)
        call copy_i_1(ncvir_2,         ncvir)
        call copy_i_1(nncf_2,           nncf)
        call copy_i_1(nnce_2,           nnce)
        call copy_i_1(ncf_2,             ncf)
        call copy_i_1(nce_2,             nce)
        call copy_i_1(iij_2,             iij)
        call copy_i_1(iijj_2,           iijj)
        call copy_i_1(ijall_2,         ijall)
        call copy_i_1(numij_2,         numij)
        call copy_i_1(iorbs_2,         iorbs)
        call copy_i_2(nijbo_2,         nijbo, numat)
        call copy_r_1(cocc_2,           cocc)
        call copy_r_1(cvir_2,           cvir)
        call copy_r_1(xparam_2,       xparam)
        call copy_r_1(partf_2,         partf)
        call copy_r_1(partp_2,         partp)
        call copy_r_1(parth_2,         parth)
        call copy_r_1(f_2,                 f)
        call copy_r_1(p_2,                 p)
        if (allocated(pa)) pa = p*0.5d0
        if (allocated(pb)) pb = pa
      end if
      coord(:,:numat) = geo(:,:numat)
    end if
  contains
!
    subroutine copy_i_1(from, to)
      integer, allocatable :: from(:), to(:)
      if (allocated(from)) then
        if (allocated(to)) deallocate(to)
        allocate(to(size(from)))
        to = from
      end if
    end subroutine copy_i_1

    subroutine copy_i_2(from, to, dim_1)
      integer, allocatable :: from(:,:), to(:,:)
      integer :: dim_1
      if (allocated(from)) then
        if (allocated(to)) deallocate(to)
        allocate(to(dim_1,size(from)/dim_1))
        to = from
      end if
    end subroutine copy_i_2
!
    subroutine copy_r_1(from, to)
      double precision, allocatable :: from(:), to(:)
      if (allocated(from)) then
        if (allocated(to)) deallocate(to)
        allocate(to(size(from)))
        to = from
      end if
    end subroutine copy_r_1

    subroutine copy_r_2(from, to, dim_1)
      double precision, allocatable :: from(:,:), to(:,:)
      integer :: dim_1
      if (allocated(from)) then
        if (allocated(to)) deallocate(to)
        allocate(to(dim_1,size(from)/dim_1))
        to = from
      end if
    end subroutine copy_r_2
!
  end subroutine big_swap
  subroutine build_active_site(active_site, ninsite)
!
!  The set of atoms in the active site is constructed.
!  Given the topology of the reactants and products (in nbonds and ibonds),
!  the active site atoms are identified by the differences in topology.
!  This is typically 2 - 6 atoms.  By using the nearest neighbors and second nearest neighbors,
!  a good approximation to the active site can be constructed.
!
    use molkst_C, only : numat, line, pdb_label, maxtxt
!
    use common_arrays_C, only : nbonds, ibonds, txtatm, nat
!
    USE chanel_C, only : iw
!
    use elemts_C, only: elemnt
    implicit none
    integer, intent (out) :: active_site(200), ninsite(3)
    integer i, ii, j, jj, k, l, nsite
    integer, allocatable :: nbonds_b(:), ibonds_b(:,:)
    character :: ch*2
    active_site = 0
    ninsite = 0
    allocate (nbonds_b(numat), ibonds_b(15,numat))
    call big_swap(1,1)!  Extract system 1 - the input data set
    nbonds_b = nbonds
    ibonds_b = ibonds
    call big_swap(1,2)!  Extract system 2 - the reference geometry
    call set_up_dentate
    call big_swap(0,2)!  Store system 2 - this adds nbonds and ibonds to the store
!
!  Compare topologies
!
    nsite = 0
    do i = 1, numat
      if (nbonds(i) /= nbonds_b(i)) then
        do k = 1, nsite
          if (active_site(k) == i) exit
        end do
        if (k <= nsite) cycle
        nsite = nsite + 1
        active_site(nsite) = i
      else
        do j = 1, nbonds(i)
!
!  At this point, atoms are in exactly the same sequence, so no need to check every permutation
!
          if (ibonds(j,i) /= ibonds_b(j,i)) then
            do k = 1, nsite
              if (active_site(k) == i) exit
            end do
            if (k <= nsite) cycle
            nsite = nsite + 1
            active_site(nsite) = i
          end if
        end do
      end if
    end do
    if (nsite == 0) return
    k = 0
    do i = 1, nsite
      k = max(k,nbonds_b(active_site(i)))
    end do
    write(ch,'(i2)')max(1, k*6 - 6)

    if (pdb_label) then
      write(iw,'(/,a,'//ch//'x,a,/16x,a)') &
      " Set 1: Atoms involved in covalent bond-breaking and bond-making", "Connectivity of atoms"
      write(iw,'(77x,a,'//ch//'x,a)')"Data-set", "Reference"
      write(iw,'(37x,a)')"(PDB labels from GEO-REF)"
    else
      write(iw,'(/6x,a,'//ch//'x,a)')" Set 1: Atoms involved in covalent", "Connectivity of atoms"
      write(iw,'(7x, a,21x,a,/)')"bond-breaking and bond-making            Data-set", "Reference"
    end if
    write(ch,'(i2)')k*6
    do i = 1, nsite
      write(line,'(i12,10i6)')(ibonds_b(j, active_site(i)), j = 1, nbonds_b(active_site(i)))
      write(line(k*6 + 10:),'(i6,10i6)')(ibonds(j, active_site(i)), j = 1, nbonds(active_site(i)))
      if (pdb_label) then
        write(iw,'(i4, 3x, a, i6, a, a)')i, " Atom:  "//elemnt(nat(active_site(i))), active_site(i), &
    "  PDB Label: ("//txtatm(active_site(i))(:maxtxt)//")", trim(line)
      else
         write(iw,'(i12, 3x, a, i6, 6x, a)')i, " Atom:  "//elemnt(nat(active_site(i))), active_site(i), trim(line)
      end if
    end do
    ninsite(1) = nsite
!
! Select neighbors
!
    ii = nsite
    do jj = 1, ii
      i = active_site(jj)
      do j = 1, nbonds(i)
        k = ibonds(j,i)
        do l = 1, nsite
          if (active_site(l) == k) exit
        end do
        if (l <= nsite) cycle
        nsite = nsite + 1
        active_site(nsite) = k
      end do
    end do
    do jj = 1, ii
      i = active_site(jj)
      do j = 1, nbonds_b(i)
        k = ibonds_b(j,i)
        do l = 1, nsite
          if (active_site(l) == k) exit
        end do
        if (l <= nsite) cycle
        nsite = nsite + 1
        active_site(nsite) = k
      end do
    end do
    write(iw,'(/,a,/)')" Set 2 : Atoms involved in covalent bond-breaking "// &
      "and bond-making, plus nearest neighbors"
    if (pdb_label) then
      write(iw,'(i4, 3x, a, i6, a)')(i, " Atom:  "//elemnt(nat(active_site(i))), active_site(i), &
  "  PDB Label: ("//txtatm(active_site(i))(:maxtxt)//")", i = 1, nsite)
    else
      write(iw,'(i12, 3x, a, i6)')(i, " Atom:  "//elemnt(nat(active_site(i))), active_site(i), i = 1, nsite)
    end if
    ninsite(2) = nsite
    return
  end subroutine build_active_site
  subroutine select_opt(shell, active_site)
  use molkst_C, only: nvar
  use common_arrays_C, only: loc, xparam, geo, geoa
  implicit none
  integer, intent (in) :: shell, active_site(200)
  integer :: i, j, k, l, use(shell), tmp(shell)
  double precision :: x_1(3*shell), x_2(3*shell)
  tmp = active_site(:shell)
  do i = 1, shell
    k = 100000
    l = 0
    do j = 1, shell
      if (tmp(j) < k) then
        k = tmp(j)
        l = j
      end if

    end do
    tmp(l) = 200000
    use(i) = k
  end do
  if (.false.) then
  nvar = 0
  do i = 1, shell
    do j = 1, 3
      nvar = nvar + 1
      loc(1,nvar) = use(i)
      loc(2,nvar) = j
      x_1(nvar) = geoa(j,use(i))
      x_2(nvar) = geo(j,use(i))
    end do
  end do
  call big_swap(1,1)
  xparam(:nvar) = x_1(:nvar)
  call big_swap(0,1)
  call big_swap(1,2)
  xparam(:nvar) = x_2(:nvar)
  call big_swap(0,2)
  end if
  return
  end subroutine select_opt

  subroutine Refine_TS
!
!       Refine the transition state by minimizing the heat of formation of everything
!       except the reaction side, followed by gradient minimization of the active site.
!       This is an iterative process, so up to five cycles of
!       (HoF minimization followed by gradient minimization) are used
!
  use common_arrays_C, only : xparam, loc, lopt, geo, f, h, lopt_store
  USE molkst_C, only : nvar, numat, moperr, keywrd
  use ef_C, only: nstep
  use MOZYME_C, only : partf, parth, mode
  implicit none
  integer :: loop, i, j
  logical :: converged, extra_print, l_ts, l_nllsq, l_sigma
    i = index(keywrd,  " LOCATE-TS")
    do j = i + 12, min(240, i + 100)
      if (keywrd(j:j) == " ") exit
    end do
    extra_print = (index(keywrd(i:j), "C:") > 0)
    l_ts = (index(keywrd, " TS") /= 0)
    l_nllsq = (index(keywrd, " NLLSQ") /= 0)
    l_sigma = (index(keywrd, " SIGMA") /= 0)
!
!  Set default gradient minimization method.
!
    if (.not. (l_ts .or. l_nllsq .or. l_sigma)) l_ts = .true.
    if (.not. l_sigma) then
      call l_control("NLLSQ", len("NLLSQ"), -1)
      call l_control("TS", len("TS"), -1)
    end if
    do loop = 1,5
!
! Set up geometry optimization calculation for everything except the active site.
!
      if (loop > 1) then
        do i = 1, numat
          do j = 1, 3
            lopt(j,i) = 1 - lopt(j,i)
          end do
        end do
      end if
!
!  lopt = geometric variables to be optimized.  This consists of all atoms not involved in bond-making or bond-breaking.
!  lopt_store = all geometric variables to be optimized.
!
! At this point, the set to be optimized is (lopt .and. lopt_store)
!
      loc = 0
      nvar = 0
      do i = 1, numat
        do j = 1, 3
          if (lopt(j,i) == 1 .and. lopt_store(j,i) == 1) then
            nvar = nvar + 1
            loc(1,nvar) = i
            loc(2,nvar) = j
            xparam(nvar) = geo(j,i)
          end if
        end do
      end do
      h = 0.d0
      f = 0.d0
      parth = 0.d0
      partf = 0.d0
      mode = 0
      call minimize_energy(loop)
      converged = (nstep < 3)
!
! Set up gradient-minimum calculation for the active site, i.e., where the imaginary mode is.
!
      if (moperr) return
      do i = 1, numat
        do j = 1, 3
          lopt(j,i) = 1 - lopt(j,i)
        end do
      end do
!
!  lopt = geometric variables to be optimized.  This consists of all atoms involved in bond-making or bond-breaking.
!  lopt_store = all geometric variables to be optimized.
!
! At this point, the set to be optimized is (lopt .and. lopt_store)
!
      loc = 0
      nvar = 0
      do i = 1, numat
        do j = 1, 3
          if (lopt(j,i) == 1 .and. lopt_store(j,i) == 1) then
            nvar = nvar + 1
            loc(1,nvar) = i
            loc(2,nvar) = j
            xparam(nvar) = geo(j,i)
          end if
        end do
      end do
      call minimize_gradient(loop, converged, extra_print, l_ts, l_nllsq, l_sigma)
      converged = (converged .and. nstep < 3)
      if (converged) exit
    end do
  end subroutine Refine_TS
  subroutine minimize_energy(loop)
    USE molkst_C, only : numat, refkey, line, numcal, nvar, time0, escf, gnorm, keywrd
    use common_arrays_C, only : xparam, grad, geo, loc
    use chanel_C, only : iw
    implicit none
    integer, intent (in) :: loop
    double precision :: gnorm_lim
!
!
!
    integer :: i, k, l
    double precision, external :: seconds, reada


      call l_control("TS", len("TS"), -1)
      write(iw,'(a, i4 ,a,/)')"  Loop:", loop, &
      "  Energy minimization, excluding active site, using L-BFGS"
      gnorm_lim = nint(numat**0.25d0*2.d0 + 1.d0)
      line = refkey(1)
      call upcase(line, len_trim(line))
      i = index(line, " GNORM=")
      if (i /= 0) gnorm_lim = reada(line, i)
      write(line,'(a,f0.1)')"DDMIN=0 GNORM=",gnorm_lim
      call l_control(trim(line), len_trim(line), 1)
      numcal = numcal + 1
      time0 = seconds(1)
      if (nvar > 0) then
        call lbfgs(xparam,escf)
        if (gnorm < gnorm_lim) then
          i = index(keywrd, " GNORM")
          write (iw, '(/, 5 x, "GRADIENT =", f9.5, " IS LESS THAN CUTOFF =", f9.5,//)') gnorm, &
          gnorm_lim
        end if
        do i = 1, nvar
          k = loc(1,i)
          l = loc(2,i)
          geo(l,k) = xparam(i)
        end do
      else
        call compfg (xparam, .TRUE., escf, .TRUE., grad, .FALSE.)
        gnorm = 0.d0
      end if
      return
  end subroutine minimize_energy
  subroutine minimize_gradient(loop, converged, extra_print, l_ts, l_nllsq, l_sigma)
    USE molkst_C, only : numat, line, nvar, time0, escf, title, moperr, iflepo
    use common_arrays_C, only : xparam, geo, loc, geoa
    use chanel_C, only : iw, input_fn, iarc
    implicit none
    integer, intent (in) :: loop
    logical, intent (in) :: extra_print, l_ts, l_nllsq, l_sigma
    logical, intent (out) :: converged
!
!  Local
!
    integer :: i
    double precision, external :: seconds
    logical :: opend
    character :: num*1
    if (l_ts) then
      line = "TS"
    else if (l_nllsq) then
      line = "NLLSQ"
    else
      line = "SIGMA"
    end if
    write(iw,'(a, i4 ,a)')"  Loop:", loop, &
    "  Gradient minimization of atoms in the active site using "//trim(line)
    i = int(log10(loop + 0.05))
    num = char(ichar("1") + i)
    do
      if (title(1:5) /= "(Loop") exit
      line = trim(title(8:))
      title = trim(line)
    end do
    write(line,'("(Loop", i'//num//',")", a)')loop, trim(title)
    title = trim(line)
    line = input_fn(:len_trim(input_fn) - 5)
    write(line(len_trim(line) + 1:),'(a, i'//num//', a)')" Loop",loop, ".mop"
    if (extra_print) then
      call add_path(line)
      inquire(unit=iarc, opened=opend)
      if (opend) close(iarc)
      open(unit=iarc, file=trim(line), status='UNKNOWN', position='asis')
      write(iw,'(/10x,a,i2,a,/10x,a,/)')"Transition state on cycle",loop, " written to file:", &
      &"'"//trim(line)//"'"
      call geout (iarc)
      close(iarc)
      title = trim(title(8 + i:))
    end if
    call l_control("GNORM=3", len("GNORM=3"), 1)
    geoa(:,:numat) = geo(:,:numat)
    time0 = seconds(1)
    if (loop == 2) call l_control("OLD_HESS", len("OLD_HESS"), 1)
    if (l_ts) then
      call l_control("TS", len("TS"), 1)
      call l_control("OLD_SCF", len("OLD_SCF"), 1)
      call l_control("tighten", len_trim("tighten"), 1)
      call ef(xparam,escf)
    else if (l_sigma) then
      call powsq()
    else if (l_nllsq) then
      call nllsq()
    end if
    iflepo = 19
    if (moperr) then
      write(iw,'(//2x,a,//)')" Gradient minimization failed.  The best geometry at this point will be output to ARC file"
      converged = .true.
      iflepo = 8
      line = input_fn(:len_trim(input_fn) - 5)
      write(line(len_trim(line) + 1:),'(a)')".arc"
      call add_path(line)
      inquire(unit=iarc, opened=opend)
      if (opend) close(iarc)
      open(unit=iarc, file=trim(line), status='UNKNOWN', position='asis')
      do i = 1, nvar
        geo(loc(2,i),loc(1,i)) = xparam(i)
      end do
      call geout (iarc)
      close(iarc)
      return
    end if
    return
  end subroutine minimize_gradient

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine kpoint (sec_det, nvecs, xk, yk, zk, v, eigs)
!***********************************************************************
!                                                                      *
!  Calculates the eigenvalues and complex eigenvectors for the         *
!  k-point (XK,YK,ZK). On exit, the eigenvalues are in EIGS, and the   *
!  complex eigenvectors are in V.                                      *
!                                                                      *
!***********************************************************************
  use common_common, only : phonon, ncell, keywrd, iw_new
  implicit none
  integer, intent(in) :: nvecs
  double precision, intent(in) :: xk, yk, zk
  complex, dimension(nvecs, nvecs), intent(inout) :: v
  double precision, dimension(2*nvecs), intent(inout) :: eigs
  double precision, dimension(nvecs, nvecs*ncell), intent(in) :: sec_det
! 
  integer :: i, j, l, m, nprt, k
  complex :: sum
  double precision :: fact = 6.0221367d23, &
  & c2pi = 1/(2.99792458d10*2*3.14159265358979d0) 
  complex, dimension(ncell) :: phase
  complex, dimension(nvecs,nvecs) :: complex_fmat
  double precision, allocatable, dimension (:,:) :: real_fmat, real_vecs
  double precision, allocatable, dimension (:) :: real_1d_fmat
! 
!  Get the complex phase for each unit cell at the point (xk, yk, zk)
!
!
  call get_phase(phase, xk, yk, zk)
!
!  Build the complex secular determinant for the point (xk, yk, zk)
!
  do i = 1, nvecs
    do j = i, nvecs
      sum = 0.0
      if (i == 25 .and. j == 25) then
        sum = 0.d0
      end if
      do m = 1, ncell
        sum = sum + Real(sec_det(i, j + m*nvecs - nvecs))*phase(m)
   !     if (i == 1 .and. j == 10) then
   !       write(iw_new,'(i3, f12.3, f8.3,f13.3, f8.3, f12.3, f12.3,f8.3, i7,2i3)')m, sum, &
   !       real(sec_det(i, j + m*nvecs - nvecs))*phase(m), &
   !         sec_det(i, j + m*nvecs - nvecs), phase(m), nijk(:,m)
   !     end if
      end do
      complex_fmat(i,j) = sum
      complex_fmat(j,i) = Conjg(sum)
    end do
  end do
  if (Index (keywrd, "SECDET") /= 0) then
    nprt = Min (25, nvecs)
    write(iw_new, '(a)') " Complex Secular Determinant, Real Part"
    do i = 1, nvecs
      write(iw_new, "(25f8.4)") (dble(complex_fmat(j,i)), j = 1,nprt)
    end do
    write(iw_new, '(a)') " Complex Secular Determinant, Imaginary Part"
    do i = 1, nvecs
      write(iw_new, "(25f8.4)") (Aimag (complex_fmat(j,i)), j = 1,nprt)
    end do
  end if
  allocate (real_fmat(2*nvecs,2*nvecs), real_vecs(2*nvecs,2*nvecs))
  allocate (real_1d_fmat(4*nvecs*nvecs)) 
!
!  Store complex_fmat as a real matrix, for use with the real diagonalizer.
!
    do i = 1,nvecs
      do j = 1,i
        real_fmat(j,i) = dble(complex_fmat(j,i))
        real_fmat(j+nvecs,i+nvecs) = real_fmat(j,i)
        real_fmat(j,i+nvecs) = Aimag(complex_fmat(j,i))
        real_fmat(i,j+nvecs) = -real_fmat(j,i+nvecs)
      end do
    end do
    if (nvecs < 30) then
!
! Solve for real eigenvalues and complex eigenvectors using a subroutine that
! diagonalizes a complex Hermitian matrix.
!
! The lower half triangle of the input complex square matrix is set to zero, to make debugging easier.
!
      do i = 1, nvecs
        do j = i + 1, nvecs
          complex_fmat(j,i) = 0.0
        end do
      end do
      call HEigensystem(nvecs, complex_fmat, eigs, v, 1)
    else
!
!  Convert to lower-half triangular form
!
       l = 0
      do i = 1,2*nvecs
        do j = 1,i
        l = l + 1
        real_1d_fmat(l) = real_fmat(j,i)
        end do
      end do
!
! The complex diagonalizer has not generated good eigenvectors.  
! Get eigenvectors from real diagonalizer.
!
      call rsp(real_1d_fmat, 2*nvecs, 2*nvecs, eigs, real_vecs)
      
      do k = 1,nvecs
        eigs(k) = eigs(2*k)
        do j = 1,nvecs
          v(j,k) = Cmplx(real_vecs(j,2*k),real_vecs(j+nvecs,2*k))
        end do
      end do
    end if
!
! Lock phase so that the largest coefficient is positive real
!
    call phase_lock(v,nvecs)
    if ( phonon ) eigs(1:nvecs) = Sign(sqrt(fact*Abs(eigs(1:nvecs)*1.d5))*c2pi,eigs(1:nvecs))
  if (Index (keywrd, " VECTORS") /= 0) then
    m = Min (25, nvecs)
    write(iw_new, '(a,i5,24i10)') " Eigenvalues",(i, i = 2,m)    
    write(iw_new, "(25F10.4)") (eigs(i), i = 1, m)
    write(iw_new, '(a)') "Complex Eigenvectors, Before Operation, Real part"
    do i = 1, nvecs
      write(iw_new, "(25F10.4)") (real(v(i, j)), j = 1, m)
    end do
    write(iw_new, '(a)') "Complex Eigenvectors, ", "Before Operation, Imaginary part"
    do i = 1, nvecs
      write(iw_new, "(25F10.4)") (Aimag (v(i, j)), j = 1, m)
    end do
  end if
end subroutine kpoint
!
!
!
subroutine get_phase(phase, xk, yk, zk)
!
!   Put the complex phase factor for each unit cell into the array "phase"
!
  use common_common, only : ncell, nijk
  implicit none
  double precision :: xk, yk, zk
  complex :: phase(ncell)
  integer :: loop, i, j ,k
  double precision :: point, twopi = 6.28318530717959d0
   do loop = 1, ncell
    i = nijk(1, loop)
    j = nijk(2, loop)
    k = nijk(3, loop)
    point = (xk*i + yk*j + zk*k)*twopi
    phase(loop) = Cmplx (Cos(point), Sin(point))
  end do
end subroutine get_phase

subroutine phase_lock(vecs,n)
!
!  Rotate the complex eigenvectors vecs(:,i) so that the largest coefficient is
!  real and positive
!
  implicit none
!
  integer :: n
  complex, dimension (n,n) :: vecs
!  Local
  integer :: i, j
  real :: asum
  complex :: ssum
!
!  Work out the (complex) rotation phase ssum
!
  do i = 1, n
    asum = 0.0
    do j = 1, n
      if (Abs(vecs(j,i)) > asum) then
        asum = Abs(vecs(j,i))
        ssum = vecs(j,i)
      end if
    end do
    ssum = ssum/asum
!
!  Rotate the eigenvector 
!
    do j = 1, n
      vecs(j,i) = cmplx(real(ssum)*real(vecs(j,i)) + aimag(ssum)*aimag(vecs(j,i)), &
      real(ssum)*aimag(vecs(j,i)) - aimag(ssum)*real(vecs(j,i)))
    end do
  end do
  return
  end subroutine phase_lock

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

       subroutine ccrep(ni, nj, r, enuclr, gab)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use parameters_C, only : alp, tore, guess1, guess2, guess3, alpb, xfac, &
        par1, par2, par3, par4
      use funcon_C, only : a0
      use molkst_C, only : method_mndod, method_pm6, method_am1, &
        method_pm7, method_PM8, method_pm6_org
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: ni
      integer , intent(in) :: nj
      double precision , intent(inout) :: r
      double precision , intent(in) :: gab
      double precision , intent(out) :: enuclr
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: nt, ig, i, j
      double precision :: alpni, alpnj, enuc, abond, fff, scale, eni, enj, ax
!-----------------------------------------------
!     CONVERT TO ANGSTROM AND INITIALIZE VARIABLES.
      r = r*a0
      alpni = alp(ni)
      alpnj = alp(nj)
!
!     CALCULATE REPULSIVE TERM.
!
      enuc = tore(ni)*tore(nj)*gab

!
! Get bond parameters if defined.
!
      if (ni < 101 .and. nj < 101) then
        fff = xfac(ni,nj)
      else
        fff = 0.d0
      end if
      if (method_PM7) then
        if (abs(fff) < 1.d-5) then
          if (ni < 99 .and. nj < 99) then
!
!  This is a poor guess for the value of alpb(ni,nj) and xfac(ni,nj)
!
            xfac(ni,nj) = 0.5d0*(xfac(ni,ni) + xfac(nj,nj))
            alpb(ni,nj) = 0.5d0*(alpb(ni,ni) + alpb(nj,nj))
            fff = xfac(ni,nj)
          else
            fff = 0.d0  !  unreal atoms - set to an arbitary value
          end if
        end if
      end if
      if (abs(fff) > 1.d-5) then
     !
     ! Bond parameters defined
     !
        abond = alpb(ni,nj)
        if (abond < 1.d-6) abond = 1.2d0
        if (method_pm6_org) then
          call ccrep_PM6_ORG(ni, nj, r, fff, abond, scale)
        else if (.not. method_mndod) then
          if (method_pm6 .or. method_pm7 .or. method_pm8) then
            scale = 1.0d0 + 2.d0 * fff * Exp (-abond*(r + 0.0003*r**6))
  !
  !   Put all special handling codes here.  To date, these are:
  !
  !    If an O-H, C-H, or N-H interaction, use a different core-core term
  !
            i = max(ni, nj)
            j = min(ni, nj)
            select case (j)
            case (1)
              select case (i)
              case (1)
              case (6:7)
                scale = 1.0d0 + 2.d0 * fff * Exp (-abond*r**2)
              case (8)
!
! Slow O - H term
!
                scale = 1.0d0 + 2.d0 * fff * Exp (-abond*r**2) - par3*exp(-par4*r*2) ! par3*exp(-par4*r*2) used by PM7
              end select
            case (6)
              select case (i)
              case (6)
                scale = scale + par1*exp(-par2*r) ! To correct C-C triple bond HoF
              end select
            case (7)
              select case (i)
              case (7)
              end select
            case (8)
             select case (i)
             case (14)
!
!  The maximum gradient is, to a first approximation, given by: exp(-ax*(r - R0 + 1/(2.d0*ax))**2) where
!  R0 is the defined distance.
!  For R0 = 3.6 Angstroms, energy in kcal/mol per Si-O interaction is (11952/r = 3320) times premultiplier.
!
                ax = 1.0d0
                scale = scale  -0.7d-3*exp(-(r - 2.9d0)**2) ! To correct Si-O weak long-range interaction
              end select
            end select
          else  ! Not PM6
            if (method_am1 .and. (ni == 42 .and. nj == 1 .or. ni == 1 .and. nj == 42)) then
!
!  AM1-d Mo-H interaction
!
                scale = 1.0d0 + r * 2.d0 * fff * Exp (-abond*r)
            else
!
!  All other interactions
!
              scale = 1.0d0 + 2.d0 * fff * Exp (-abond*r)
            end if
          end if
        else
         !
         ! MNDO/d interactions
         !
         ! Alpb(ip) is used as alpha parameter for one element, and
         ! the standard alpha parameter is used for the other element.
          if (ni == nj) then
            scale = 1.0d0 + 2.d0 * Exp (-abond*r)
          else
            select case (nj)
            case(11, 12, 13)
              scale = 1.0d0 + Exp (-abond*r) + Exp (-alp(ni)*r)
            case default
              scale = 1.0d0 + Exp (-abond*r) + Exp (-alp(nj)*r)
            end select
          end if
        end if
       !
       ! Multiply monopole term by scaling factor
       !
        enuclr = enuc * scale
      else
        abond = 0.d0
        if (method_pm6 .or. method_pm7 .or. method_pm8 .or. method_pm6_org) then
          if (ni .gt. 56 .and. ni  .lt. 72 &
         .or. nj .gt. 56 .and. nj  .lt. 72 )then
            scale = 10.d0*exp((-3.d0*r))
          else
            scale = 10.d0*exp((-2.18d0*r)) ! This is a generic core-core term.
          end if
          eni = 0.d0
          enj = 0.d0
        else
          eni = exp((-alpni*r))
          enj = exp((-alpnj*r))
          scale = eni + enj
        end if
!
!  This is almost certainly dead code.
        nt = ni + nj
        if (nt == 8 .or. nt == 9) then
          if (ni == 7 .or. ni == 8) scale = scale + (r - 1.D0)*eni
          if (nj == 7 .or. nj == 8) scale = scale + (r - 1.D0)*enj
        end if
!
!  End of probable dead code
!
        enuclr = abs(scale*enuc) + enuc
      end if
      scale = 0.d0
      if (method_pm6 .or. method_pm7 .or. method_pm8 .or. method_pm6_org) then
  !
  !  VdW term
  !
        ax = guess2(ni,1)*(r - guess3(ni,1))**2
        if (ax < 25.D0) scale = scale + tore(ni)*tore(nj)/r*guess1(ni,1)*exp((-ax))
        ax = guess2(nj,1)*(r - guess3(nj,1))**2
        if (ax < 25.D0) scale = scale + tore(ni)*tore(nj)/r*guess1(nj,1)*exp((-ax))
        if (abond > 1.d-4) then
          i = 0
        else
          i = 4
        end if
      ! AM1 B-H, B-C, & B-halogen corrections
      else if (method_am1 .and. (ni == 5 .or. nj == 5) .and. &
          (ni == 1 .or. nj == 1 .or. ni == 6 .or. nj == 6 .or. ni == 9 .or. nj == 9 .or. &
           ni == 17 .or. nj == 17 .or. ni == 35 .or. nj == 35 .or. ni == 53 .or. nj == 53)) then
          if (ni == 1 .or. nj == 1) then
            ax = 10.0d0*(r - 0.832586d0)**2
            if (ax <= 25.D0) scale = scale + tore(ni)*tore(nj)/r*0.412253d0*exp(-ax)
            ax = 6.0d0*(r - 1.186220d0)**2
            if (ax <= 25.D0) scale = scale + tore(ni)*tore(nj)/r*(-0.149917d0)*exp(-ax)
          else if (ni == 6 .or. nj == 6) then
            ax = 8.0d0*(r - 1.063995d0)**2
            if (ax <= 25.D0) scale = scale + tore(ni)*tore(nj)/r*0.261751d0*exp(-ax)
            ax = 5.0d0*(r - 1.936492d0)**2
            if (ax <= 25.D0) scale = scale + tore(ni)*tore(nj)/r*0.050275d0*exp(-ax)
          else
            ax = 9.0d0*(r - 0.819351d0)**2
            if (ax <= 25.D0) scale = scale + tore(ni)*tore(nj)/r*0.359244d0*exp(-ax)
            ax = 9.0d0*(r - 1.574414d0)**2
            if (ax <= 25.D0) scale = scale + tore(ni)*tore(nj)/r*0.074729d0*exp(-ax)
          end if
          if (ni == 5) then
            do ig = 1, 4
              ax = guess2(nj,ig)*(r - guess3(nj,ig))**2
              if (ax <= 25.D0) scale = scale + tore(ni)*tore(nj)/r*guess1(nj,ig)*exp(-ax)
            end do
          else
            do ig = 1, 4
              ax = guess2(ni,ig)*(r - guess3(ni,ig))**2
              if (ax <= 25.D0) scale = scale + tore(ni)*tore(nj)/r*guess1(ni,ig)*exp(-ax)
            end do
          end if
          i = 0
      else
          i = 4
          if (fff > 1.d-4) i = 0
      end if
      do ig = 1, i
        if (abs(guess1(ni,ig)) > 0.D0) then
          ax = guess2(ni,ig)*(r - guess3(ni,ig))**2
          if (ax <= 25.D0) scale = scale + tore(ni)*tore(nj)/r*guess1(ni,ig)*&
            exp((-ax))
        end if
        if (abs(guess1(nj,ig)) <= 0.D0) cycle
        ax = guess2(nj,ig)*(r - guess3(nj,ig))**2
        if (ax > 25.D0) cycle
        scale = scale + tore(ni)*tore(nj)/r*guess1(nj,ig)*exp((-ax))
      end do
      enuclr = enuclr + scale
      if (method_pm6 .or. method_pm7 .or. method_pm8 .or. method_pm6_org) then
!
!  The next term is the unpolarizable core - unpolarizable core interaction
!  It should have no effect on heats of formation or other properties.
!  Its purpose is to allow systems where the atoms are forced together
!  to be realistic.  The form of the expression is the Lennard-Jones "12" part
!  in the "12 - 6" potential.
!
!  The multiplier "1.d-8" was chosen to make the function negligible at
!  normal bonding distances. "ax" is proportional to the interatomic distance
!  divided by the sum of the two covalent radii.
!
        ax = r/(ni**0.3333d0 + nj**0.3333d0)
        if (ax < 3.d0) then
          scale = 1.d-8/ax**12
          enuclr = enuclr + min(scale, 1.d5)
        end if
      end if
      return
  end subroutine ccrep
!
  subroutine ccrep_PM6_ORG(ni, nj, r, fff, abond, scale)
!
!  Core-core scaling factor for method PM6-ORG
!
  use parameters_C, only : par1, par2, par3, par4, par5, par10, par11, par12, par13, par14, par15, &
    par16, par17, par18, par19, par20, par21, par22, par23, par24, par25, par26, par27, par28, &
    par29, par30, par31
  implicit none
  integer, intent (in) :: ni, nj
  double precision, intent (in) :: r, fff, abond
  double precision, intent (out) :: scale
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
  integer :: i, j
  double precision :: sum = 0.01d0
  save :: sum
  scale = 1.0d0 + 2.d0 * fff * Exp (-abond*(r + 0.0003*r**6)) 
!
!   Put all special handling codes here.
!   
  i = max(ni, nj)
  j = min(ni, nj)
  select case (j) 
!
!  Hydrogen with everything
!
  case (1)
    select case (i)
    case (1)
!
! Steric repulsion term for H - H interaction. Uses: PAR16, PAR17, and PAR18
!
      if (r - par18 > 0.d0) then
        scale = scale + sum*par16*exp(-par17*(r-par18)**2) 
      else
        scale = scale + sum*par16
      end if
    case (6)
!
! Steric repulsion term for C - H interaction. Uses: PAR19, PAR11, and PAR12
!
      if (r - par12 > 0.d0) then
        scale = 1.0d0 + 2.d0 * fff * Exp (-abond*r**2) + sum*par19*exp(-par11*(r-par12)**2) 
      else
        scale = 1.0d0 + 2.d0 * fff * Exp (-abond*r**2) + sum*par19
      end if
    case (7)
      scale = 1.0d0 + 2.d0 * fff * Exp (-abond*r**2) 
    case (8)
!
! Steric repulsion term for O - H interaction. Uses: PAR3, PAR4, and PAR5
!
      if (r - par5 > 0.d0) then
        scale = 1.0d0 + 2.d0 * fff * Exp (-abond*r**2) + sum*par3*exp(-par4*(r-par5)**2) 
      else
        scale = 1.0d0 + 2.d0 * fff * Exp (-abond*r**2) + sum*par3
      end if
    end select
    case (9)
!
! Steric term for F - H interaction. Uses: PAR29, PAR30, and PAR31
!
     if (r - par31 > 0.d0) then
        scale = scale + sum*par29*exp(-par30*(r-par31)**2) 
      else
        scale = scale + sum*par29
      end if
!
!  Carbon 
!
  case (6)
    select case (i)
    case (6)
      scale = scale + par1*exp(-par2*r) ! To correct C-C triple bond HoF 
!
! Steric repulsion term for C - C interaction. Uses: PAR13, PAR14, and PAR15
!
      if (r - par15 > 0.d0) then
        scale = scale + sum*par13*exp(-par14*(r-par15)**2) 
      else
        scale = scale + sum*par13
      end if 
    case (8)
!
! Steric repulsion term for C - O interaction. Uses: PAR20, PAR21, and PAR22
!
      if (r - par22 > 0.d0) then
        scale = scale + sum*par20*exp(-par21*(r-par22)**2) 
      else
        scale = scale + sum*par20
      end if
    end select 
!
!  Nitrogen 
!
  case (7) 
    select case (i)
    case (8)
!
! Steric repulsion term for N - O interaction. Uses: PAR26, PAR27, and PAR28
!
      if (r - par28 > 0.d0) then
        scale = scale + sum*par26*exp(-par27*(r-par28)**2) 
      else
        scale = scale + sum*par26
      end if      
    end select 
!
!  Oxygen 
!
  case (8)
    select case (i)
    case (14)
!
!  For R0 = 3.6 Angstroms, energy in kcal/mol per Si-O interaction is (11952/r = 3320) times premultiplier.
!
      scale = scale  -0.7d-3*exp(-(r - 2.9d0)**2) ! To correct Si-O weak long-range interaction 
    case (16)
!
! Steric repulsion term for S - O interaction. Uses: PAR23, PAR24, and PAR25
!
      if (r - par25 > 0.d0) then
        scale = scale + sum*par23*exp(-par24*(r-par25)**2) 
      else
        scale = scale + sum*par23
      end if
    end select
  end select
  return
  end subroutine ccrep_PM6_ORG

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine upcase(keywrd, n)
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n
      character , intent(inout) :: keywrd*(*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: icapa, ilowa, ilowz, i, iline, j
      character :: keybuf*3000
!-----------------------------------------------
!
!  UPCASE WILL TAKE A CHARACTER STRING, IN KEYWRD, AND PUT IT INTO
!  UPPER CASE.  KEYWRD IS LIMITED TO 80 CHARACTERS
!
      icapa = ichar('A')
      ilowa = ichar('a')
      ilowz = ichar('z')
      keybuf = keywrd
      do i = 1, n
        iline = ichar(keywrd(i:i))
        if (iline>=ilowa .and. iline<=ilowz) &
        keywrd(i:i) = char(iline + icapa - ilowa)
        if (iline /= 9) cycle
!
!  Change tabs to spaces.  A tab is ASCII character 9.
!
        keywrd(i:i) = ' '
      end do
!
!   If the word EXTERNAL is present, do NOT change case of the following
!   character string.
!
      i = index(keywrd,'EXTERNAL=')
      if (i /= 0) then
        j = index(keywrd(i+1:),' ') + i
        keywrd(i+9:j) = keybuf(i+9:j)
      end if
      return
      end subroutine upcase

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

module to_screen_C
!
!  This module contains all the quantities relating to the system being calculated
!  that are likely to be used in the subroutine "to_screen".
!
  double precision :: &
  rot(3), &    ! Type          Rotational constants
               ! Definition    Frequencies of the three rotational constants
               ! Units         cm**(-1)
               ! Min inclusive 0.0
               ! Max inclusive no limit
               !
  xyzmom(3), & ! Type          Principal moments of inertia
               ! Definition    Moments of inertia for the system.
               ! Units         10**(-40)*gram-cm**2
               ! Min inclusive 0.0
               ! Max inclusive no limit
               !
  dip(4,3)     ! Type          Dipole moment array
               ! Definition    Point-charge and hybrid components of dipole in X, Y, and Z, and totals
               ! Units         Debye
               !
  double precision, dimension (:,:), allocatable :: &
  fcint,     & ! Type          Internal force constants
               ! Definition    Force constants for all coordinates of all atoms, using the coordinate system supplied
               ! Units         Millidynes/Angstrom and millidynes per radian
               !
  to_a,      & ! Type          Generic two-dimensional matrix
               ! Definition    Used for transferring matrix "a" in matou1 to here
               ! Units         Unknown
  redmas       ! Type          Reduced masses
               ! Definition    Effective mass of vibrational frequencies
               ! Units         Atomic mass units (amu)
               !
  double precision, dimension (:), allocatable :: &
  dipt,      & ! Type          Transition dipoles for vibrational frequencies
               ! Definition    <ground state|eR(x)|vibrational state>
               ! Units         electrons
force_const, & ! Type          Force constant
               ! Definition    Force constant for of vibrational frequencies
               ! Units         millidynes per Angstrom
               !
  travel,    & ! Type          Distance traveled during a vibration
               ! Definition
               ! Units         Angstroms
  freq,      & ! Type          Vibrational frequencies
               ! Definition    Normal mode frequencies
               ! Units         cm(-1)

  cnorml,    & ! Type          Normal modes of vibration
               ! Definition    Orthonormal coordinates of vibration
               ! Units         (None) Normalized to unity
  to_b         ! Type          Generic one-dimensional matrix

end module to_screen_C

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine pulay_for_gpu(f, p, n, fppf, fock, emat, &
                        & lfock, nfock, msize, start, pl) 
      use chanel_C, only : iw
      use molkst_C, only : numcal, keywrd, mpack
#ifdef GPU
      Use mult_symm_ab_I 
      Use mod_vars_cuda, only: real_cuda, prec, ngpus
#endif      
      Use mod_vars_cuda, only: lgpu 
      implicit none
      integer  :: n,iopc 
      integer , intent(inout) :: lfock 
      integer , intent(inout) :: nfock 
      integer , intent(in) :: msize 
      double precision , intent(out) :: pl 
      logical , intent(inout) :: start 
      double precision  :: f(mpack) 
      double precision  :: p(mpack) 
      double precision  :: fppf(6*mpack)
      double precision , intent(inout) :: fock(*) 
      double precision , intent(inout) :: emat(20,20) 
      integer :: icalcn, maxlim, linear, mfock, lbase, i, nfock1, j, l, il, ii, idim, kdim
      double precision, dimension(1000) :: evec 
      double precision, dimension(20) :: coeffs 
      double precision :: const, d, sum 
      logical :: debug  
#ifdef GPU
      integer :: igrid, iblock
#endif        
      double precision, external :: ddot       
      
      save icalcn, maxlim, debug, linear, mfock 
!-----------------------------------------------
!***********************************************************************
!
!   PULAY USES DR. PETER PULAY'S METHOD FOR CONVERGENCE.
!         A MATHEMATICAL DESCRIPTION CAN BE FOUND IN
!         "P. PULAY, J. COMP. CHEM. 3, 556 (1982).
!
! ARGUMENTS:-
!         ON INPUT F      = FOCK MATRIX, PACKED, LOWER HALF TRIANGLE.
!                  P      = DENSITY MATRIX, PACKED, LOWER HALF TRIANGLE.
!                  N      = NUMBER OF ORBITALS.
!                  FPPF   = WORKSTORE OF SIZE MSIZE, CONTENTS WILL BE
!                           OVERWRITTEN.
!                  FOCK   =      "       "              "         "
!                  EMAT   = WORKSTORE OF AT LEAST 20**2 ELEMENTS.
!                  START  = LOGICAL, = TRUE TO START PULAY.
!                  PL     = UNDEFINED ELEMENT.
!      ON OUTPUT   F      = "BEST" FOCK MATRIX, = LINEAR COMBINATION
!                           OF KNOWN FOCK MATRICES.
!                  START  = FALSE
!                  PL     = MEASURE OF NON-SELF-CONSISTENCY
!                         = [F*P] = F*P - P*F.
!
!***********************************************************************
      data icalcn/ 0/  
      if (icalcn /= numcal) then 
        icalcn = numcal 
        maxlim = 6
        debug = index(keywrd,'DEBUGPULAY') /= 0 
      end if 
      if (start) then 
        linear = (n*(n + 1))/2 
        mfock = msize/linear 
        mfock = min0(maxlim,mfock) 
        if (debug) write (iw, '('' MAXIMUM SIZE:'',I5)') mfock 
        nfock = 1 
        lfock = 1 
        start = .FALSE. 
      else 
        if (nfock < mfock) nfock = nfock + 1 
        if (lfock /= mfock) then 
          lfock = lfock + 1 
        else 
          lfock = 1 
        end if 
      end if 
      lbase = (lfock - 1)*linear 
!
!   FIRST, STORE FOCK MATRIX FOR FUTURE REFERENCE.
!
      ! TODO: use dcopy
      fock(lfock:(linear-1)*mfock+lfock:mfock) = f(:linear) 
!
!   NOW FORM /FOCK*DENSITY-DENSITY*FOCK/, AND STORE THIS IN FPPF
!      
      idim = linear + lbase
      
      if (lgpu) then
        iopc = 4
      else
        iopc = 3
      end if

      call mult_symm_AB(p, f, 1.d0, n, linear, fppf(lbase+1:idim), 0.d0, iopc)
      call mult_symm_AB(f, p, 1.d0, n, linear, fppf(lbase+1:idim), -1.d0, iopc)
      
!      call mamult (p, f, fppf(lbase+1), n, 0.D0) 
!      call mamult (f, p, fppf(lbase+1), n, -1.D0) 

!
!   FPPF NOW CONTAINS THE RESULT OF FP - PF.
!
      nfock1 = nfock + 1 
      do i = 1, nfock
        kdim = i*linear        
        emat(nfock1,i) = -1.D0 
        emat(i,nfock1) = -1.D0  
        emat(lfock,i) = ddot(linear,fppf((i-1)*linear+1:kdim),1,fppf(lbase+1:idim),1)
        
        emat(i,lfock) = emat(lfock,i) 
      end do 
      pl = emat(lfock,lfock)/linear 
      emat(nfock1,nfock1) = 0.D0 
      if (emat(lfock, lfock) < 1.d-20) return
      const = 1.D0/emat(lfock,lfock) 
      
      emat(:nfock,:nfock) = emat(:nfock,:nfock)*const 
      ! TODO:check call mkl_dimatcopy('c', 't', 20, 20, const, emat, nfock, nfock)
      
      if (debug) then 
        write (iw, '('' EMAT'')') 
        do i = 1, nfock1 
          write (iw, '(6E13.6)') (emat(j,i),j=1,nfock1) 
        end do 
      end if 
      l = 0 
      do i = 1, nfock1 
        evec(l+1:nfock1+l) = emat(i,:nfock1) 
        l = nfock1 + l 
      end do 
      const = 1.D0/const 
      emat(:nfock,:nfock) = emat(:nfock,:nfock)*const 
      ! TODO:check call mkl_dimatcopy('c', 't', 20, 20, const, emat, nfock, nfock)
      
!********************************************************************
!   THE MATRIX EMAT SHOULD HAVE FORM
!
!      |<E(1)*E(1)>  <E(1)*E(2)> ...   -1.0|
!      |<E(2)*E(1)>  <E(2)*E(2)> ...   -1.0|
!      |<E(3)*E(1)>  <E(3)*E(2)> ...   -1.0|
!      |<E(4)*E(1)>  <E(4)*E(2)> ...   -1.0|
!      |     .            .      ...     . |
!      |   -1.0         -1.0     ...    0. |
!
!   WHERE <E(I)*E(J)> IS THE SCALAR PRODUCT OF [F*P] FOR ITERATION I
!   TIMES [F*P] FOR ITERATION J.
!
!********************************************************************
      call osinv (evec, nfock1, d) 
      if (abs(d) < 1.D-6) then 
        start = .TRUE. 
        return  
      end if 
      if (nfock < 2) return  
      il = nfock*nfock1 
      coeffs(:nfock) = -evec(1+il:nfock+il) 
      if (debug) then 
        write (iw, '('' EVEC'')') 
        write (iw, '(6F12.6)') (coeffs(i),i=1,nfock) 
        write (iw, '("    LAGRANGIAN MULTIPLIER (ERROR) =", F13.6)') evec(nfock1*nfock1) 
      end if 
     
     ! TODO: make it parallel
      do i = 1, linear 
        sum = 0.D0 
        l = 0 
        ii = (i - 1)*mfock 
        do j = 1, nfock 
          sum = sum + coeffs(j)*fock(j+ii) 
        end do 
        f(i) = sum 
      end do 
      return  
      end subroutine pulay_for_gpu
      

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      double precision function helect (n, p, h, f)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n
      double precision , intent(in) :: p(*)
      double precision , intent(in) :: h(*)
      double precision , intent(in) :: f(*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: k, nn, i, jj
      double precision :: ed, ee
!-----------------------------------------------
!***********************************************************************
!
!    SUBROUTINE CALCULATES THE ELECTRONIC ENERGY OF THE SYSTEM IN EV.
!
!    ON ENTRY N = NUMBER OF ATOMIC ORBITALS.
!             P = DENSITY MATRIX, PACKED, LOWER TRIANGLE.
!             H = ONE-ELECTRON MATRIX, PACKED, LOWER TRIANGLE.
!             F = TWO-ELECTRON MATRIX, PACKED, LOWER TRIANGLE.
!    ON EXIT
!        HELECT = ELECTRONIC ENERGY.
!
!    NO ARGUMENTS ARE CHANGED.
!
!***********************************************************************
      ed = 0.0D00
      ee = 0.0D00
      k = 0
      nn = n + 1
      do i = 2, nn
        k = k + 1
        jj = i - 1
        ed = ed + p(k)*(h(k)+f(k))
        if (i == nn) cycle
        if (jj > 0) then
          ee = ee + sum(p(k+1:jj+k)*(h(k+1:jj+k)+f(k+1:jj+k)))
          k = jj + k
        end if
      end do
      ee = ee + .5D00*ed
      helect = ee
      return
!
      end function helect

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  subroutine update(iparam, ielmnt, param, c1)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!
    use parameters_C, only : natorb, guess1, guess2, guess3, zs, zp, zd, &
    betas, betap, betad, alp, zsn, zpn, zdn, uss, upp, udd, gss, gpp, &
    gsp, gp2, hsp, pocord, alpb, xfac, f0sd_store, g2sd_store, dorbs, v_par, &
    f0sd, g2sd, CPE_Zeta, CPE_Z0, CPE_B, CPE_Xlo, CPE_Xhi, &
    n_partyp_fn, n_partyp_alpb
      use chanel_C, only : iw
      use molkst_C, only : method_indo
      use reimers_C, only : isok, nbfa, zcorea, zeta, zetad, zetawt, betaa, fg
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: iparam
      integer , intent(in) :: ielmnt
      double precision , intent(in) :: c1, param
!-----------------------------------------------
!***********************************************************************
!
!  UPDATE UPDATES THE MODULES WHICH HOLD ALL THE PARAMETERS FOR
!         RUNNING MOPAC.
!         IPARAM REFERS TO THE TYPE OF PARAMETER,
!         IELMNT REFERS TO THE ELEMENT,
!         PARAM IS THE VALUE OF THE PARAMETER.
!         C1 is zero if the parameter is to be re-set to PARAM
!         C1 is one if the parameter is to be perturbed
!
!***********************************************************************
!------------------------------------------------------------
    integer :: i, kfn, ni, nj, jparam
    intrinsic Nint
!------------------------------------------------------------
    kfn = 0
    jparam = iparam
    if (jparam > n_partyp_fn - 1 .and. jparam < n_partyp_alpb) then
      kfn = (jparam - n_partyp_fn) / 3
      jparam = jparam - kfn * 3
      kfn = kfn + 1
    end if
    select case (jparam)
    case (2)
      upp(ielmnt) = upp(ielmnt) * c1 + param
    case (3)
      udd(ielmnt) = udd(ielmnt) * c1 + param
    case (4)
      zs(ielmnt) = zs(ielmnt) * c1 + param
    case (5)
      zp(ielmnt) = zp(ielmnt) * c1 + param
    case (6)
      zd(ielmnt) = zd(ielmnt) * c1 + param
    case (7)
!
!  Add INDO switch for beta parameters
!
      if (method_indo) then
        betaa(1, ielmnt) =  betaa(1, ielmnt) * c1 + param
      else
        betas(ielmnt) = betas(ielmnt) * c1 + param
      end if
    case (8)
      if (method_indo) then
        betaa(2, ielmnt) =  betaa(2, ielmnt) * c1 + param
      else
        betap(ielmnt) = betap(ielmnt) * c1 + param
      end if
    case (9)
      if (method_indo) then
        betaa(3, ielmnt) =  betaa(3, ielmnt) * c1 + param
      else
        betad(ielmnt) = betad(ielmnt) * c1 + param
      end if
    case (10)
      gss(ielmnt) = gss(ielmnt) * c1 + param
    case (11)
      gsp(ielmnt) = gsp(ielmnt) * c1 + param
    case (12)
      gpp(ielmnt) = gpp(ielmnt) * c1 + param
    case (13)
      gp2(ielmnt) = gp2(ielmnt) * c1 + param
    case (14)
      hsp(ielmnt) = hsp(ielmnt) * c1 + param
    case (15)
      f0sd_store(ielmnt) = f0sd_store(ielmnt) * c1 + param
      if (c1 < 1.d-20) f0sd(ielmnt) = param
    case (16)
      g2sd_store(ielmnt) = g2sd_store(ielmnt) * c1 + param
      if (c1 < 1.d-20) g2sd(ielmnt) = param
    case (17)
      pocord(ielmnt) = pocord(ielmnt) * c1 + param
    case (18)
      alp(ielmnt) = alp(ielmnt) * c1 + param
    case (19)
      zsn(ielmnt) = zsn(ielmnt) * c1 + param
    case (20)
      zpn(ielmnt) = zpn(ielmnt) * c1 + param
    case (21)
      zdn(ielmnt) = zdn(ielmnt) * c1 + param
    case (22)
      CPE_Zeta(ielmnt) = CPE_Zeta(ielmnt) * c1 + param
    case (23)
      CPE_Z0(ielmnt) = CPE_Z0(ielmnt) * c1 + param
    case (24)
      CPE_B(ielmnt) = CPE_B(ielmnt) * c1 + param
    case (25)
      CPE_Xlo(ielmnt) = CPE_Xlo(ielmnt) * c1 + param
    case (26)
      CPE_Xhi(ielmnt) = CPE_Xhi(ielmnt) * c1 + param
    case (27)
      guess1(ielmnt, kfn) = guess1(ielmnt, kfn) * c1 + param
    case (28)
      guess2(ielmnt, kfn) = guess2(ielmnt, kfn) * c1 + param
    case (29)
      guess3(ielmnt, kfn) = guess3(ielmnt, kfn) * c1 + param
    case (42)
      if (method_indo) then
        nbfa(ielmnt) = Nint (param)
      else
        natorb(ielmnt) = Nint (param)
      end if
      dorbs(ielmnt) = (natorb(ielmnt) == 9)
      i = Nint (param)
      if (i /= 9 .and. i /= 4 .and. i /= 1) then
        write (iw, "(///10x,' UNACCEPTABLE VALUE FOR NO. OF ORBITALS ON ATOM ')")
        stop
      end if
    case (n_partyp_alpb)
      nj = ielmnt/200
      ni = ielmnt - nj*200
      alpb(ni,nj) = alpb(ni,nj)*c1 + param
      alpb(nj,ni) = alpb(ni,nj)
    case (n_partyp_alpb + 1)
      nj = ielmnt/200
      ni = ielmnt - nj*200
      xfac(ni,nj) = xfac(ni,nj)*c1 + param
      xfac(nj,ni) = xfac(ni,nj)
    case (41)
      v_par(ielmnt) = v_par(ielmnt) * c1 + param
!
!  Add INDO parameters
!
    case (43)
      zcorea(ielmnt) = zcorea(ielmnt) * c1 + param
    case (44)
      zeta(ielmnt)  = zeta(ielmnt) * c1 + param
    case (45)
      zetad(1,ielmnt) = zetad(1,ielmnt) * c1 + param
    case (46)
      zetad(2,ielmnt) = zetad(2,ielmnt) * c1 + param
    case (47)
      zetawt(1,ielmnt) = zetawt(1,ielmnt) * c1 + param
    case (48)
      zetawt(2,ielmnt) = zetawt(2,ielmnt) * c1 + param
    case (49)
      fg( 1,ielmnt) = fg( 1,ielmnt) * c1 + param
    case (50)
      fg( 2,ielmnt) = fg( 2,ielmnt) * c1 + param
    case (51)
      fg( 3,ielmnt) = fg( 3,ielmnt) * c1 + param
    case (52)
      fg( 4,ielmnt) = fg( 4,ielmnt) * c1 + param
    case (53)
      fg( 5,ielmnt) = fg( 5,ielmnt) * c1 + param
    case (54)
      fg( 6,ielmnt) = fg( 6,ielmnt) * c1 + param
    case (55)
      fg( 7,ielmnt) = fg( 7,ielmnt) * c1 + param
    case (56)
      fg( 8,ielmnt) = fg( 8,ielmnt) * c1 + param
    case (57)
      fg( 9,ielmnt) = fg( 9,ielmnt) * c1 + param
    case (58)
      fg(10,ielmnt) = fg(10,ielmnt) * c1 + param
    case (59)
      fg(11,ielmnt) = fg(11,ielmnt) * c1 + param
    case (60)
      fg(12,ielmnt) = fg(12,ielmnt) * c1 + param
    case (61)
      fg(13,ielmnt) = fg(13,ielmnt) * c1 + param
    case (62)
      fg(14,ielmnt) = fg(14,ielmnt) * c1 + param
    case (63)
      fg(15,ielmnt) = fg(15,ielmnt) * c1 + param
    case (64)
      fg(16,ielmnt) = fg(16,ielmnt) * c1 + param
    case (65)
      fg(17,ielmnt) = fg(17,ielmnt) * c1 + param
    case (66)
      fg(18,ielmnt) = fg(18,ielmnt) * c1 + param
    case (67)
      fg(19,ielmnt) = fg(19,ielmnt) * c1 + param
    case (68)
      fg(20,ielmnt) = fg(20,ielmnt) * c1 + param
    case (69)
      fg(21,ielmnt) = fg(21,ielmnt) * c1 + param
    case (70)
      fg(22,ielmnt) = fg(22,ielmnt) * c1 + param
    case (71)
      fg(23,ielmnt) = fg(23,ielmnt) * c1 + param
    case (72)
      fg(24,ielmnt) = fg(24,ielmnt) * c1 + param
    case default
      uss(ielmnt) = uss(ielmnt) * c1 + param
    end select
!
! If parameters are read in for an element, assume element is OK to use.
!
    if (method_indo) isok(ielmnt) = 1
  return
  end subroutine update

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

    subroutine geo_ref
!
! geo_ref reads in the geometry reference file, and makes it as similar
! as possible to the current geometry.  It does this by:
!
! Requiring files to include PDB-type information
!
! The atoms of the reference geometry are put into the same sequence as in the current geometry.
!
! If any atoms cannot be mapped from reference to current geometry, then put those
! atoms at the end of the data sets.
!
! Rotate and translate the geometries to put them into maximum coincidence,
! i.e., minimize the RMS difference between the two geometries.
!
! During this process, swap pairs of atoms, if that will lower the RMS difference.
!
!
      use chanel_C, only : ir, iw, output_fn, job_fn, iarc, archive_fn
!
      use molkst_C, only : numat, keywrd, nvar, id, natoms, moperr, line, refkey, density, &
        maxtxt, numat_old, koment, title, geo_ref_name, geo_dat_name, arc_hof_2, arc_hof_1, &
        keywrd_txt, pdb_label, ncomments, refkey_ref, backslash, formula, keywrd_quoted
!
      use parameters_C, only : ams
!
      use common_arrays_C, only : geo, coord, xparam, na, nb, nc, nat, c, labels, txtatm, lopt, &
        txtatm1, geoa, atmass, loc, lopt_store
!
      use elemts_C, only: atom_names
      implicit none
!
      integer :: i, j, k, l, ii, jj, i4, j4, k4, iquit, numat_dat, numat_ref, ub
      integer, allocatable :: map_atoms_A(:), atom_no(:)
      integer, external :: quoted
      character, allocatable :: tmp_txt(:)*27, diffs(:)*80
      double precision, allocatable :: tmp_geoa(:,:)
      double precision :: dum1, dum2, sum, rms, rms_min, sum1, sum2, sum3, &
        toler, xmin, sum4
      double precision, external :: reada
      logical :: intern = .true., exists, bug, any_bug, swap, first, let, l_0SCF_HTML, opend
      logical, allocatable :: same(:), ok(:)
      character :: line_1*1000, line_2*1000, num*2, geo_dat*7
!
!   For Geo-Ref to work, some very specific conditions must be satisfied.
!   So before attempting a GEO_REF calculation, check that the data are okay
!
      do j = 2, natoms
        if (na(j) /= 0) exit
      end do
      l_0SCF_HTML = (index(keywrd," 0SCF") /= 0 .and. index(keywrd, " HTML ") /= 0)
!
! Force geometry to be Cartesian
!
      call gmetry (geo, coord)
      geo(:,:numat) = coord(:,:numat)
      na(:natoms) = 0
      j = 0
      do i = 1, natoms - id
        if (labels(i) /= 99) then
          j = j + 1
          labels(j) = labels(i)
          txtatm(j) = txtatm(i)
        end if
      end do
      txtatm1(:numat) = txtatm(:numat)
      id = 0
      if (moperr) return
      allocate(geoa(3,natoms + 300), c(3,natoms + 300)) ! Generous safety factor for second geometry
      i = quoted('GEO_REF=')
      if (i < -10) stop ! dummy use of "i" to prevent FORCHECK from flagging a possible error
      j = len_trim(line)
      if (line(j:j) == '"') line(j:j) = " "
      line_1 = trim(line)
      call upcase(line_1, len_trim(line_1))
      geo_ref_name = trim(line)
      i = index(keywrd_quoted," GEO_DAT")
      if (i > 0) then
        i = index(keywrd_quoted(i:), '"') + i
        j = index(keywrd_quoted(i + 2:),'" ') + i
        geo_dat_name = keywrd_quoted(i:j)
      else
        geo_dat_name = trim(job_fn)
      end if
      line = trim(geo_ref_name)
      inquire (file=trim(line), exist = exists)
      if (.not. exists) then
        call add_path(line)
        inquire (file=trim(line), exist = exists)
        if ( .not. exists) then
          inquire (file=trim(line)//".mop", exist = exists)
          if (exists) line = trim(line)//".mop"
        end if
        if ( .not. exists) then
          inquire (file=trim(line)//".txt", exist = exists)
          if (exists) line = trim(line)//".txt"
        end if
        if (.not. exists) then
          call mopend ("GEO_REF file '"//trim(line)//"' does not exist.")
          if (index(keywrd, " 0SCF") /= 0) then
            moperr = .false.
            call l_control("GEO_REF", len("GEO_REF"), -1)
            keywrd_txt = trim(keywrd)
          end if
          return
        end if
      end if
      open(unit = 99, file = trim(line), iostat = i)
      if (i /= 0) then
        call mopend ("Problem opening file "//trim(line))
        return
      end if
      if (l_0SCF_HTML) then
        if (index(geo_dat_name, "/") + index(geo_dat_name, backslash) == 0) then
          line = trim(geo_dat_name)
          call upcase(line, len_trim(line))
          line = line(len_trim(line) - 3:)
        else
          do i = len_trim(geo_dat_name), 1, -1
            if (geo_dat_name(i:i) == "/" .or. geo_dat_name(i:i) == backslash) exit
          end do
          geo_dat_name = geo_dat_name(i + 1:)
        end if
        line = geo_dat_name(:len_trim(geo_dat_name) - 3)//"pdb"
        call add_path(line)
        inquire (file=trim(line), exist = exists)
        if (exists .and. index(keywrd, " LET") == 0) then
           call mopend("A PDB FILE WITH THE SAME NAME AS THE GEO_DAT FILE ALREADY EXISTS")
           write(iw,'(10x,a)')"GEO_DAT FILE: """//trim(line)//""""
           write(iw,'(/10x,a)')"To continue, over-writing this file, add keyword ""LET"""
           return
        end if
        if (index(geo_ref_name, "/") + index(geo_ref_name, backslash) == 0) then
          line = trim(geo_ref_name)
          call upcase(line, len_trim(line))
          line = line(len_trim(line) - 3:)
        else
          do i = len_trim(geo_ref_name), 1, -1
            if (geo_ref_name(i:i) == "/" .or. geo_ref_name(i:i) == backslash) exit
          end do
          geo_ref_name = geo_ref_name(i + 1:)
        end if
        line = geo_ref_name(:len_trim(geo_ref_name) - 3)//"pdb"
        call add_path(line)
        inquire (file=trim(line), exist = exists)
        if (exists .and. index(keywrd, " LET") == 0) then
           call mopend("A PDB FILE WITH THE SAME NAME AS THE GEO_REF FILE ALREADY EXISTS")
           write(iw,'(10x,a)')"GEO_REF FILE: """//trim(line)//""""
           write(iw,'(/10x,a)')"To continue, over-writing this file, add keyword ""LET"""
        end if
        line = geo_dat_name
        i = len_trim(line) - 4
        call upcase(line, i)
        i = max(i, len_trim(line_1) - 4)
        if (line(:i) == line_1(:i)) then
          call mopend("The GEO_DAT and GEO_REF filenames are too similar.")
          write(iw,'(10x,a)')"(They would both write to the same PDB file.)"
        end if
        if (moperr) return
      end if
      nat(:natoms) = labels(:natoms)
      i = natoms
      rewind 99
      do i = 1, 100000
        read(99,"(a)", iostat = j) num
        if (j /= 0) exit
      end do
      rewind 99
      allocate(map_atoms_A(numat), tmp_txt(numat),  atom_no(numat))
      tmp_txt(:numat) = txtatm(:numat)
      if (i > numat) then
        deallocate (txtatm, txtatm1, labels, atmass)
        deallocate (geoa, c, coord, lopt, na, nb, nc)
        allocate(txtatm(i), txtatm1(i), labels(i), atmass(i))
        allocate(geoa(3,i), c(3,i), coord(3,i),lopt(3,i), na(i), nb(i), nc(i))
      end if
       line = trim(geo_ref_name)
      call upcase(line, len_trim(line))
      if (index(line, '.ARC') /= 0) then
        do
          read(99,"(a)", iostat=ii)line_1
          if (ii /= 0) exit
          if (index(line_1, "HEAT OF FORMATION") > 0) arc_hof_2 = reada(line_1,20)
          if (index(line_1," FINAL GEOMETRY OBTAINED") /= 0) exit
        end do
        if (ii /= 0) rewind(99)
      end if
      line_1 = trim(keywrd)
      if (index(keywrd_quoted,"GEO_DAT") /= 0) then
        if (geo_ref_name == job_fn) then
          i = index(keywrd_quoted," GEO_REF") + 11
          do
            if (keywrd_quoted(i:i) == '"' .or. keywrd_quoted(i:i) == "'") exit
            i = i + 1
          end do
          density = reada(keywrd_quoted, i + 1)
          write(iw,'(/10x,a,f8.3,a)')"A restraining force of",density," kcal/mol/A^2 will be used"
          geoa(:,:numat) = geo(:,:numat)
          ii = numat
          goto 96
        end if
      end if
      i = 0
      do
        i = i + 1
        read(99,"(a)", err = 99, iostat = ii)refkey_ref(i)  !  Dummy read over first three lines
        if (refkey_ref(i)(4:4) == "(" .and. refkey_ref(i)(31:31) == ")" .and. refkey_ref(i)(36:36) == ".") then
          rewind(99)
          exit
        end if
        if (ii /= 0) then
          write(iw,'(10x,a)')"Line 1 of data file defined by GEO_REF: """//trim(refkey_ref(1))//""""
          line = trim(refkey_ref(1))
          call upcase(line, len_trim(line))
          if (index(keywrd,"GEO_DAT") /= 0) then
            call mopend("A data file defined by GEO_REF cannot use GEO_DAT to point to another file.")
            return
          else
            write(line,'(a,i1,a)')"The data file defined by GEO_REF contains only ", i, " lines."
            call mopend(trim(line))
            return
          end if
        end if
        if (refkey_ref(i)(1:1) == "*") i = i - 1
        if (i == 1) then
          keywrd = refkey_ref(1)
          call upcase (keywrd, len_trim(keywrd))
          call l_control("GEO_DAT", len_trim("GEO_DAT"), -1)
          call l_control("GEO_REF", len_trim("GEO_REF"), -1)
          line = trim(keywrd)
          if (index(line, " +") + index(line, "++") /= 0) i = i - 1
        end if
        if (i == 3) exit
      end do
      keywrd = trim(line_1)
      refkey_ref(4:6) = "    NULL"
      goto 97
99    write(iw,*)" File' "//trim(line)//"' is faulty"
      return
97    i = quoted('GEO_REF=') + 11
      do
        if (keywrd_quoted(i:i) == '"' .or. keywrd_quoted(i:i) == "'") exit
        i = i + 1
      end do
      if (keywrd_quoted(i + 1: i + 1) == " ") then
        if (.not. l_0SCF_HTML .and. index(keywrd, "LOCATE-TS") + index(keywrd, "SADDLE") == 0) &
          write(iw,'(/10x,a)')"By default, no restraining force will be used"
        density = 0.d0
      else
        density = reada(keywrd_quoted, i + 1)
        write(iw,'(/10x,a,f8.3,a)')"A restraining force of",density," kcal/mol/A^2 will be used"
      end if
      if (id == 3 .and. abs(density) > 1.d-10 .and. index(keywrd, " 0SCF") == 0) then
        write(line,'(a)')"For solids, the restraining force in GEO_REF must be 0.0."
        call mopend(trim(line))
        return
      end if
      numat_dat = numat
      nat(numat + 1:) = 0
      atom_no(:numat) = nat(:numat)
!
!  Put atoms in the reference data set into the same order as those in the current data set
!
      ii = numat
      j = maxtxt
      call getgeo (99, labels, geoa, c, lopt, na, nb, nc, intern)
      if (natoms == 0) then
        call mopend("NO ATOMS DETECTED IN GEO_REF FILE")
        return
      end if
      if (numat > ii) then
!
! Increase the size of arrays
!
        deallocate (nat)
        allocate (nat(numat + 10))
        nat(:ii) = atom_no(:ii)
      end if
      if (index(keywrd, " OPT ") /= 0) lopt = 1
      deallocate(c)
      maxtxt = j
      if (moperr .and. natoms == 0) then
        call mopend("An error was detected in the reference data set.")
        return
      end if
      if (natoms == -2) then
        j = ir
        ir = 99
        rewind(99)
!
!  Do NOT remove CHAINS - no point in adding atoms that cannot be used
!
        call getpdb(geoa)
        ir = j
        numat_old = numat
      end if
!
! Force geometry to be Cartesian, so that both systems are "clean"
!
      call gmetry (geoa, coord)
      geoa(:,:numat) = coord(:,:numat)
      na(:natoms) = 0
      j = 0
      do i = 1, natoms - id
        if (labels(i) /= 99) then
          j = j + 1
          labels(j) = labels(i)
          txtatm(j) = txtatm(i)
        end if
      end do
      numat = numat - id
      numat_ref = numat
      id = 0
      if (index(keywrd, " 0SCF") == 0 .and. ii /= numat) then
        num = char(ichar("1") +int(log10(ii + 0.05)))
        write(iw,'(/10x,a,i'//num//')')"Number of atoms in """//trim(geo_dat_name)//""" = ", ii
        num = char(ichar("1") +int(log10(numat + 0.05)))
        write(iw,'(/10x,a,i'//num//')')"Number of atoms in """//trim(geo_ref_name)//""" = ", numat
        call mopend("Number of atoms in both systems must be the same, unless keyword ""0SCF"" is present")
        return
      end if
96    txtatm1(:ii) = tmp_txt(:ii)
      i = max(ii, numat, 26)
      allocate (tmp_geoa(3,i), same(i), ok(i), diffs(i))
      diffs = " "
      same = .false.
      ok = .false.
      call l_control("GEO_DAT", len_trim("GEO_DAT"), -1)
      call l_control("GEO_REF", len_trim("GEO_REF"), -1)
      if (index(keywrd," 0SCF") + index(keywrd, " LOCATE-TS") + index(keywrd, " SADDLE") /= 0) then
        if (maxtxt == 0 .or. txtatm(1) == " " .or. txtatm1(1) == " ") then
          if (index(keywrd, " GEO-OK") /= 0) then
            if (txtatm(1) == " " .and. txtatm1(1) == " ") call geochk()
            if (txtatm(1) == " ") then
              txtatm(:numat) = txtatm1(:numat)
            else
              txtatm1(:numat) = txtatm(:numat)
            end if
            maxtxt = 26
          else
            call mopend("In this job, atoms in both data-sets must have PDB-type labels")
            write(iw,'(a)')"Or add ""GEO-OK"" if one of the two data sets has PDB-type "// &
              "labels and the other does not have PDB information."
            return
          end if
        end if
!
!  Before starting, check that the chains are the same.  If they're not, then
!  delete chain information.
!
        do j = 1, ii
          k = ichar(txtatm1(j)(22:22)) - ichar("A") + 1
          if (k > 0) ok(k) = .true.
        end do
        do j = 1, numat
          k = ichar(txtatm(j)(22:22)) - ichar("A") + 1
          if (k > 0) same(k) = .true.
        end do
        do i = 1, 26
          if (same(i) .and. ok(i)) exit
        end do
        if (i == 27) then
          write(iw,'(/10x,a)')" The two systems have different chain letters, so all chain letters changed to ""X"""
          txtatm1(:ii)(22:22) = "X"
          txtatm(:numat)(22:22) = "X"
        end if
        ok = .false.
        same = .false.
!
! Put atoms in the GEO_REF file into the same order as those in the data-set
!
!    GEO_REF arrays:   geoa, txtatm, labels
!    dataset arrays:   geo, txtatm1, nat
!
!  Align atoms in three passes.  In the first pass, all atoms with the same label are aligned.
!  In the second pass, hydrogen atoms that might be mis-labeled within a residue are assigned.
!  In the third pass, any remaining hydrogen atoms are assigned.
!
! If deuterium atoms are used, the PDB name will have "D" instead of "H"
! so convert the "D"'s to "H"'s for the purpose of ordering the atoms.
!
        do i = 1, numat
          if (labels(i) == 1 .and. (index(txtatm(i)(:17), " D") /= 0)) then
            j = index(txtatm(i), " D")
            if (txtatm(i)(j + 1:j + 2) /= "DH") exit
          end if
        end do
        do j = 1, numat
          if (labels(j) == 1 .and. (index(txtatm1(j)(:17), " D") /= 0)) then
            k = index(txtatm1(j), " D")
            if (txtatm1(j)(k + 1:k + 2) /= "DH") exit
          end if
        end do
        if ((i > numat .and. j <= numat) .or. (i <= numat .and. j > numat)) then
          do i = 1, numat
            if (labels(i) == 1) then
              j = index(txtatm(i)(:17), " D")
              if (j /= 0) then
                txtatm(i)(j + 1:j + 1) = "H"
              end if
              j = index(txtatm1(i)(:17), " D")
              if (j /= 0) then
                txtatm1(i)(j + 1:j + 1) = "H"
              end if
            end if
          end do
        end if
        swap = (index(keywrd, " NOSWAP") == 0)
        k = 0
        l = 0
        do j = 1, ii
          j4 = 0
!
!  First pass
!
          do i = 1, numat
            if (same(i)) cycle
            if (txtatm1(j)(12:) == txtatm(i)(12:)) then
              k = k + 1
              tmp_txt(k) = trim(txtatm(i))
              coord(:,k) = geo(:,j)
              tmp_geoa(:,k) = geoa(:,i)
              labels(k) = nat(j)
              same(i) = .true.
              ok(j) = .true.
              j4 = 1
              exit
            end if
          end do
        end do
        let = (index(keywrd, " LOCATE-TS") + index(keywrd, " SADDLE")  /= 0 .or. &
          (index(keywrd," GEO-OK+") /= 0 .and. index(keywrd, " COMPARE") /= 0))
        do j = 1, ii
!
!  Second pass
!
          if(ok(j)) cycle
          do i4 = 1, numat
            if (same(i4) .or. ok(i4)) cycle
            if (txtatm1(j)(14:14) == "H" .and. txtatm(i4)(14:14) == "H" .and. &
              txtatm1(j)(18:) == txtatm(i4)(18:)) then
              if (txtatm1(j)(15:15) == txtatm(i4)(15:15)) then
              k = k + 1
              tmp_txt(k) = txtatm(i4)
              coord(:,k) = geo(:,j)
              tmp_geoa(:,k) = geoa(:,i4)
              labels(k) = nat(j)
              same(i4) = .true.
              ok(j) = .true.
              exit
              end if
            end if
          end do
          if (.not. ok(j) .and. .not. let) then
            l = l + 1
            write(diffs(l)(:40),'(3x,a)')txtatm1(j)
          end if
        end do
        if (let) then
          first = .true.
          do j = 1, ii
!
!  Third pass
!
            if(ok(j)) cycle
            do i4 = 1, numat
              if (same(i4)) cycle
              if (txtatm1(j)(14:14) == "H" .and. txtatm(i4)(14:14) == "H") then
                if (first) then
                  write(iw,'(/16x,a)')"Hydrogen atoms that are on different residues"
                  if (trim(job_fn) == trim(geo_dat_name)) then
                    line = "dataset"
                  else
                    line = "GEO_DAT"
                  end if
                  write(iw,'(/6x,a,14x,a,/)')"Atoms in "//trim(line)//" only","     Atoms in GEO_REF only"
                  first = .false.
                end if
                line = txtatm1(j)
                line(41:) = txtatm(i4)
                write(iw,'(4x,a)')trim(line)
                k = k + 1
                tmp_txt(k) = txtatm(i4)
                coord(:,k) = geo(:,j)
                tmp_geoa(:,k) = geoa(:,i4)
                labels(k) = nat(j)
                same(i4) = .true.
                ok(j) = .true.
                exit
              end if
            end do
            if (.not. ok(j)) then
              l = l + 1
              write(diffs(l)(:40),'(3x,a)')txtatm1(j)
            end if
          end do
          if (.not. first) write(iw,'(/18x,a)')"(Atom labels from GEO_REF will be used)"
        end if
        geo(:,:k) = coord(:,:k)
        ii = k
        jj = 0
        do i = 1, numat
          if (.not. same(i)) then
            jj = jj + 1
            write(diffs(jj)(41:),'(3x,a)')txtatm(i)
          end if
        end do
        nat(:k) = labels(:k)
        do i = 1, k
          atmass(i) = ams(nat(i))
        end do
        txtatm(:k) = tmp_txt(:k)
        if (index(keywrd, " GEO-OK") == 0) then
          geo_dat = "dataset"
        else
          geo_dat = "GEO_DAT"
        end if
        l = max(l, jj)
        if (l > 0) then
          write(iw,'(/28x,a)')"Differences in atoms sets"
          write(iw,'(/10x,a,19x,a,/)')"Atoms in "//geo_dat//" only",    "Atoms in GEO_REF only"
          do i = 1, l
            write(iw,'(i4,a)')i, trim(diffs(i))
          end do
          if (.not. let .and. index(keywrd, " COMPARE") == 0) &
            write(iw,'(/10x,a)')"If ""LET"" is used, then some or all of these differences will be ignored"
        end if
        geoa(:,:k) = tmp_geoa(:,:k)
        tmp_txt(:k) = txtatm(:k)
        if (numat_dat /= numat_ref) then
          if (index(keywrd, " GEO-OK") == 0 .and. .not. l_0SCF_HTML) then
            write(line,'(a, i5, a, i5)')"Number of atoms in data-set:",numat_dat, ", in GEO_REF:", numat_ref
            call mopend(trim(line))
            i = index(keywrd_txt," GEO_DAT") + 9
            if (i > 9) then
              write(iw,'(/10x, a,/10x,a, /)')"Docking can only be done when the number of atoms in ", &
              "the files defined by GEO_DAT and GEO_REF are the same."
            else
             write(iw,'(/5x, a, /)')"Docking can only be done when the number of atoms in the data-set and GEO_REF are the same."
            end if
            i = (k*100)/max(numat,ii)
            write(iw,'(10x,a,i3,a)')"(The two systems have",i, &
            "% of atoms in common. To continue, but using","only those atoms that are common to both systems, add ""GEO-OK"")"
            i = index(keywrd_txt," GEO_DAT") + 9
            if (i > 9) then
              write(iw,'(/10x,a)')"GEO_DAT name: """//trim(geo_dat_name)//""""
            else
              write(iw,'(/10x,a)')"Data-set name: "//trim(geo_dat_name)
            end if
            write(iw,'(/10x,a)')"GEO_REF name: """//trim(geo_ref_name)//""""
            return
          else
            write(iw,'(/10x, a)')"Empirical formulae of data-set and GEO_REF are different"
          end if
!
! First do GEO_REF
! Store the nat for GEO_DAT in nc
! Load the labels for geo_ref into nat
!
          nc(:numat_dat) = nat(:numat_dat)
          nat(:numat) = labels(:numat)
          call empiri()
          write(iw,'(/10x,a,i5)')   "Empirical formula of system in GEO_REF:"//trim(formula(30:))
!
! Now do GEO_DAT
! First store the data for GEO_REF
!
          i = numat
          numat = numat_dat
          nat(:numat) = atom_no(:numat)
          call empiri()
!
! Restore GEO_REF
!
          numat = i
          nat(:numat) = nc(:numat)
          write(iw,'(10x,a,i5)')"Empirical formula of system in "//geo_dat//":"//trim(formula(30:))
          write(iw,'(/10x,a,i5,/)') "Number of atoms common to both systems:",ii
        end if
        natoms = k
        numat = k
        if (pdb_label) txtatm1(:numat) = txtatm(:numat)
        txtatm(:numat) = tmp_txt(:numat)
        coord(:,:numat) = geoa(:,:numat)
      end if
      if (numat /= numat_dat .and. index(keywrd, " LOCATE-TS") /= 0) then
        if (maxtxt == 0 .or. txtatm(1) == " ") then
          if (index(keywrd, " GEO-OK") /= 0) then
            if (maxtxt == 0) then
              maxtxt = 26
              txtatm1(:numat) = txtatm(:numat)
            else
              txtatm(:numat) = txtatm1(:numat)
            end if
          else
            call mopend("In this job, atoms in both data-sets must have PDB-type labels")
            write(iw,'(a)')"Or add ""GEO-OK"" if one of the two data sets has "// &
              "PDB-type labels and the other does not have PDB information."
            return
          end if
        else
          call mopend("ERRORS DETECTED IN PDB LABELS DURING DOCKING MUST BE CORRECTED BEFORE LOCATE-TS CAN BE RUN.")
          write(iw,'(a)')"Or add ""GEO-OK"" if one of the two data sets has"// &
            " PDB-type labels and the other does not have PDB information."
          return
        end if
      end if
      if (moperr) then
        i = index(keywrd_txt," GEO_REF")
        j = index(keywrd(i + 10:),'"') + i + 8
        line = keywrd(i + 10:j)
        write(line,'(a)')"Fault detected in GEO_REF data set: '"//trim(line)//"'"
        write(iw,'(a)')trim(line)
        call mopend(trim(line))
        return
      end if
      call gmetry(geo, coord)
      if (natoms == 0) return
      geo(:,:natoms) = coord(:,:natoms)
      call gmetry(geoa, coord)
      geoa(:,:natoms) = coord(:,:natoms)
      na(:natoms) = 0
      if (index(keywrd, " NOREOR") /= 0) then
        call geo_diff(sum, rms, .true.)
        sum1 = sum/numat
        sum2 = sqrt(rms/numat)
        goto 98
      end if
      if (pdb_label .and. txtatm(1)(:4) == "ATOM" .and. txtatm1(1)(:4) == "ATOM") then
!
!  Put atoms in the reference data set into the same order as those in the current data set
!
        bug = .false.
        any_bug = .false.
!
!  Check for faults in the data-set labels
!
        call compare_txtatm(bug, any_bug)
        bug = .false.
!
!  Check for faults in the geo_ref labels
!
        do i = 1, numat
          if (labels(i) == 1) then
            l = 1
            do j = i + 1, numat
              if (labels(j) == 1) then
                if (txtatm(i)(12:) == txtatm(j)(12:)) then
                  do k = 13, 16
                    if (txtatm(j)(k:k) == " ") then
                      l = l + 1
                      txtatm(j)(k:k) = char(l + ichar("0"))
                      txtatm1(j)(k:k) = char(l + ichar("0"))
                      exit
                    end if
                  end do
                end if
              end if
              if (l == 9) exit
            end do
            if (l > 1) then
              do k = 13, 16
                if (txtatm(i)(k:k) == " ") then
                  txtatm(i)(k:k) = "1"
                  txtatm1(i)(k:k) = "1"
                  exit
                end if
              end do
            end if
          end if
        end do
!
!  At this point, txtatm1 holds the data from the input-dataset.
!                 txtatm holds the data from the geo_ref dataset
!
        k = 0
        do i = 1, numat
          do j = i + 1, numat
            if (txtatm(i)(12:) == txtatm(j)(12:)) exit
          end do
          if (j <= numat) then
            if ( .not. bug) then
              ii = index(keywrd_txt," GEO_REF")
              jj = index(keywrd(ii + 10:),'"') + ii + 8
              line = keywrd(ii + 10:jj)
              write(iw,'(/10x,a,/)')"Atoms in the GEO_REF file '"// &
              trim(geo_ref_name)//"' with the same labels"
            end if
            write(iw,'(10x,a,i6,a,i6,a)')"Atoms", i, " and", j, &
              ";  Labels: ("//txtatm(i)(:maxtxt)//") and ("//txtatm(j)(:maxtxt)//")"
              bug = .true.
              k = k + 1
          end if
        end do
        if (bug) then
          if (index(keywrd, " GEO-OK") == 0) &
            write(iw,'(/10x,a,/)')"Edit GEO_REF data set and re-run."
          any_bug = .true.
          bug = .false.
        end if
!
!  Check for labels in the data-set that are not in geo_ref
!
        do i = 1, numat
          do j = 1, numat
            if (txtatm1(i)(12:) == txtatm(j)(12:)) exit
          end do
          if (j > numat) then
            if ( .not. bug) then
              ii = index(keywrd_txt, "GEO_DAT=")
              if (ii > 0) then

                write(iw,'(/10x,a,/)')"Atoms in the GEO_DAT file '"// &
                trim(geo_dat_name)//"' with no equivalent in the geo_ref file"
              else
                write(iw,'(/10x,a,/)')"Atoms in the data-set file '"// &
                trim(geo_dat_name)//"' with no equivalent in the geo_ref file"
              end if
            end if
            write(iw,'(10x,a,i6,a,i6,a)')"Atom", i, ";  Label: ("//txtatm1(i)(:maxtxt)//")"
              bug = .true.
              any_bug = .true.
              k = k + 1
          end if
        end do
        bug = .false.
        do i = 1, numat
          do j = 1, numat
            if (txtatm(i)(12:) == txtatm1(j)(12:)) exit
          end do
          if (j > numat) then
            if ( .not. bug) then
              write(iw,'(/10x,a,/)')"Atoms in the GEO_REF file '"// &
                & trim(geo_ref_name)//"' with no equivalent in the data-set file"
            end if
            write(iw,'(10x,a,i6,a,i6,a)')"Atom", i, ";  Label: ("//txtatm(i)(:maxtxt)//")"
              bug = .true.
              any_bug = .true.
              k = k + 1
          end if
        end do
        if (any_bug) then
          if (index(keywrd, "GEO-OK") == 0) then
            any_bug = .false.
            if (k == 1) then
              call mopend("Fault detected in atom labels in a GEO_REF run.")
            else
              call mopend("Faults detected in atom labels in a GEO_REF run.")
            end if
            call mopend("(To continue with the current data set, use 'GEO-OK')")
            call web_message(iw,"geo_ref.html")
            return
          else
            if (k == 1) then
              write(iw,'(/10x,a)')"Fault detected in atom labels in a GEO_REF run,"
            else
              write(iw,'(/10x,a)')"Faults detected in atom labels in a GEO_REF run,"
            end if
            if (index(keywrd, " COMPARE") /= 0) then
              write(iw,'(10x,a)')"but because COMPARE was used, corrective action will be taken."
            else
              write(iw,'(10x,a)')"but because GEO-OK was used, corrective action will be taken."
            end if
          end if
        end if
!
!   Search all atoms in the geo_dat_name set to find which atom maps up with the
!   corresponding atom in GEO_REF file.
!
!   (Atoms in the GEO_REF file are never re-arranged or moved.)
!
!  First pass:  Map all atoms that are an exect match
!
        map_atoms_A = -1
        do i = 1, numat
          do j = 1, numat
            if (txtatm(j)(12:) == txtatm1(i)(12:)) exit
          end do
          if (j <= numat) then
            map_atoms_A(j) = i
          end if
        end do
        continue
!
! Second pass: If any atoms are not mapped, then
! find atoms that are NOT mapped, and put them into the map.
!
!   (This code should do nothing unless there is a bug higher up.)
!
        do i = 1, numat
          if (map_atoms_A(i) == -1) then
            do k = 1, numat
              do j = 1, numat
                if (map_atoms_A(j) == k) exit
              end do
              if (j > numat) then
                map_atoms_A(i) = k
                exit
              end if
            end do
            continue
          end if
        end do
        continue
!
!  At this point, the atom "map_atoms_A(i)" in GEO_DAT is replaced with atom i
!
        tmp_txt(:numat) = txtatm1(:numat)
        coord(:,:numat) = geo(:,:numat)
        do i = 1, numat
          j = map_atoms_A(i)
          geo(:,i) = coord(:,j)
          txtatm1(i) = tmp_txt(j)
          atom_no(i) = j
        end do
      else
        i = size(atom_no)
        do i = 1, numat
          atom_no(i) = i
        end do
      end if
      nat(:numat) = labels(:numat)
      coord(:,:numat) = geoa(:,:numat)
!                                                            Add atom numbers at this point
      do i = 1, numat
        write(txtatm1(i)(7:11),'(i5)')i
        write(txtatm (i)(7:11),'(i5)')i
      end do
      rms_min = 1.d6
      if (.not. allocated(same)) allocate(same(numat))
      call geo_diff(sum, rms, .false.)
      toler = 3.d0
      i4 = 1
      j4 = numat
      k4  = 1
      iquit = 0
      xmin = 1.d8
      exists = .true.
      if (index(keywrd, "NOREOR") /= 0) then
        ub = -1
        call geo_diff(sum, rms, .false.)
        sum1 = sum/numat
        sum2 = sqrt(rms/numat)
      else
        ub = 30
      end if
      do ii = 1, ub
        call dock (geo, geoa, sum)
        sum = 0.d0
        do i = 1, numat
          j = j + 1
          sum = sum + sqrt((geo(1,i) - geoa(1,i))**2 + &
                            (geo(2,i) - geoa(2,i))**2 + &
                            (geo(3,i) - geoa(3,i))**2)
        end do
        if (swap .and. ii > 1) then
!
!  Check that atoms are in maximum coincidence.
!  If they are not, then re-arrange geoa
!
          do i = 1, numat
            sum = (geo(1,i) - geoa(1,i))**2 + &
                  (geo(2,i) - geoa(2,i))**2 + &
                  (geo(3,i) - geoa(3,i))**2
            same(i) = (sum < toler)
          end do
          jj = 0
          do i = i4, j4, k4
            if (txtatm1(i)(18:20) == "TRP") cycle ! Add more of these tests, as needed
            sum = (geo(1,i) - geoa(1,i))**2 + &
                  (geo(2,i) - geoa(2,i))**2 + &
                  (geo(3,i) - geoa(3,i))**2
            if (sum > toler) then
              sum = 1.d8
              k = i
              do j = i4, j4, k4
                if (txtatm1(j)(18:20) == "TRP") cycle ! Add more of these tests, as needed
                if ((txtatm1(i)(:6) == txtatm1(j)(:6)    .and.  &
                  txtatm1(i)(22:)   == txtatm1(j)(22:)   .and.  &
                  txtatm1(i)(14:14) == txtatm1(j)(14:14) .or. &
!
!  Always allow water molecules to swap
!
                (txtatm1(i)(18:20) == "HOH" .and. txtatm1(j)(18:20) == "HOH")) .and.  &
                  labels(i) == labels(j) .and. .not. (same(i) .and. same(j))) then
                  num = txtatm1(i)(15:15)
                  if (num == " " .or. (num >= "0" .and. num <= "9")) then
                    num = txtatm1(j)(15:15)
                    if (num == " " .or. (num >= "0" .and. num <= "9")) num = "+"
                  end if
                  if (txtatm1(i)(15:15) /= txtatm1(j)(15:15) .and. num /= "+") cycle
                  sum2 = ((geo(1,j) - geoa(1,j))**2 + &
                          (geo(2,j) - geoa(2,j))**2 + &
                          (geo(3,j) - geoa(3,j))**2)
                  sum3 = ((geo(1,i) - geoa(1,i))**2 + &
                          (geo(2,i) - geoa(2,i))**2 + &
                          (geo(3,i) - geoa(3,i))**2)
                  dum1 = ((geo(1,i) - geoa(1,j))**2 + &
                          (geo(2,i) - geoa(2,j))**2 + &
                          (geo(3,i) - geoa(3,j))**2)
                  dum2 = ((geoa(1,i) - geo(1,j))**2 + &
                          (geoa(2,i) - geo(2,j))**2 + &
                          (geoa(3,i) - geo(3,j))**2)
!
!  If swapping the atoms around will improve the overlap, then do so.
!
!  dum1 = distance contribution from atom i if atom i and j were swapped around.
!  dum2 = distance contribution from atom j if atom i and j were swapped around.
!  sum2 = distance contribution from atom j if the atoms were not swapped around
!  sum3 = distance contribution from atom i if the atoms were not swapped around
!  sum  = smallest distance contribution, i.e., best choice for swapping
!
                  if (dum1 + dum2 < sum - 0.1d0 .and. dum1 + dum2 < sum2 + sum3 - 0.1d0) then
                    sum = dum1 + dum2
                    sum4 = sum2 + sum3
                    k = j
                  end if
                end if
              end do
              if (i /= k) then
                jj = jj + 1
                if (.false.) then
                if (exists) then
                  exists = .false.
                  write(iw,'(" ",20("----"))')
                  if (pdb_label) then
                    write(iw,'(/4x,a,//8x,a,/)')"  List of atoms in GEO_REF that were swapped in order to maximize overlap", &
                    "      Atom Label          and         Atom Label         Difference to GEO_REF"
                  else
                    write(iw,'(/4x,a,//8x,a,/)')"  List of atoms that were swapped in order to maximize overlap", &
                    "  Atom name   Atom No. and Atom No.  Difference to GEO_REF"
                  end if
                end if
                if (pdb_label) then
                  write(iw,'(i5, a, 2x, a, f12.2)')jj,  " ("//txtatm1(i)(:maxtxt)//")",  &
                  " ("//txtatm1(k)(:maxtxt)//")", sqrt(sum) - sqrt(sum4)
                else
                    write(iw,'(i5,1x, a, i9,  i13, 1x, f12.2)')jj, atom_names(nat(i)), atom_no(i),  atom_no(k), &
                  sqrt(sum) - sqrt(sum4)
                end if
                end if
                do j = 1,3
                  sum = geoa(j,i)
                  geoa(j,i) = geoa(j,k)
                  geoa(j,k) = sum
                end do
                line_1 = txtatm1(i)
                txtatm1(i) = txtatm1(k)
                txtatm1(k) = trim(line_1)
                j = atom_no(i)
                atom_no(i) = atom_no(k)
                atom_no(k) = j
              end if
              same(i) = .true.
            end if
          end do
        end if
        if (.not. exists) write(iw,*)" "
        k = 0
        do i = 1, numat
          do l = 1,3
            k = k + 1
            xparam(k) = geo(l,i)
          end do
        end do
          call geo_diff(sum, rms, .false.)
          sum1 = sum/numat
          sum2 = sqrt(rms/numat)
        if (abs(rms_min - rms) < 1.d-4 .and. ii > 2) exit
        if (xmin > rms) then
          xmin = rms
          iquit = 0
        else
          iquit = iquit + 1
          if (iquit > 3) exit
        end if
        rms_min = rms
        toler = max(1.d0, 0.7d0*toler)
        k4 = i4
        i4 = j4
        j4 = k4
        if (i4 == 1) then
          k4 = 1
        else
          k4 = -1
        end if
      end do
!
!  Docking complete. Now un-swap GEO_REF
!
      do i = 1, numat
        do k = i, numat
          if (txtatm1(i) == txtatm(k)) then
            if (i == k) exit
            do j = 1,3
              sum = geoa(j,i)
              geoa(j,i) = geoa(j,k)
              geoa(j,k) = sum
              sum = geo(j,i)
              geo(j,i) = geo(j,k)
              geo(j,k) = sum
            end do
            txtatm1(k) = txtatm1(i)
          end if
        end do
      end do
      txtatm1(:numat) = txtatm(:numat)
      if (sum1 < 1.d-10 .and. index(keywrd, " LOCATE-TS") /= 0) then
        write(line,'(a)')" The data-set and GEO_REF geometries are the same.  Correct the fault and re-run."
        call mopend (trim(line))
        return
      end if
      write(iw,'(/24x,a)')"After docking"
      call geo_diff(sum, rms, .true.)
98    if (trim(job_fn) == trim(geo_dat_name)) then
        line = "dataset"
      else
        line = "GEO_DAT"
      end if
      i = ichar("5") + max(0, int(log10(sum1*numat + 1.d-20)))
      if (i > 57) then
        num(1:1) = "1"
        num(2:2) = char(i - 10)
      else
        num(1:1) = char(i)
        num(2:2) = " "
      end if
      write(iw,'(/3x,a,f'//trim(num)//'.3,a,f8.4,a,f8.4,a)') &
        "Difference between "//trim(line)//" and GEO_REF: ", sum1*numat, &
        " = total,", sum1, " = Average,", sum2," = RMS, in Angstroms"
      if (index(keywrd," 0SCF") /= 0 .and. sum1 < 1.d-6) then
        call mopend("The two systems are identical, so the job will stop here.")
        return
      end if
      close(99)
      if (index(keywrd," NOCOM") /= 0) ncomments = 0
      if (index(keywrd, " COMPARE") /= 0) then
!
! Write out the reference geometry file needed for comparing the two geometries using JSmol.
!
        line_1 = geo_ref_name
        call upcase(line_1, len_trim(line_1))
        i = len_trim(line_1)
        j = max(1,i - 7)
        if (line_1(i - 3: i) == ".TXT" .and. line_1(j:j) == ".") &
        geo_ref_name = geo_ref_name(:len_trim(geo_ref_name) - 4)
        if (index(keywrd, " COMPARE") /= 0) then
          if (index(trim(geo_ref_name), "'") /= 0) then
            call mopend("When keyword ""COMPARE"" is used the GEO_REF filename"// &
             " must not contain a single quotation mark, i.e., a ""'"" mark")
            return
          end if
          if (index(trim(geo_dat_name), "'") /= 0) then
            if (index(keywrd, "GEO_DAT") /= 0) then
              call mopend("When keyword ""COMPARE"" is used the GEO_REF filename"// &
               " must not contain a single quotation mark, i.e., a ""'"" mark")
            else
              call mopend("When keyword ""COMPARE"" is used the data-set filename"// &
               " must not contain a single quotation mark, i.e., a ""'"" mark")
            end if
            return
          end if
          do i = len_trim(job_fn), 1, -1
            if (job_fn(i:i) == "/" .or. job_fn(i:i) == backslash) exit
          end do
          do j = len_trim(job_fn) - 4, 2, -1
            if (job_fn(j:j) /= " ") exit
          end do
          line_1 =  job_fn(i + 1:j)//"_"
        else
          line_1 = " "
        end if
        line = trim(line_1)//geo_ref_name(:len_trim(geo_ref_name) - 3)//"pdb"
        call add_path(line)
        line_2 = trim(line)
        open(unit = 99, file = trim(line), iostat = i)
        call l_control("HTML", len_trim("HTML"), -1)
        coord(:,:numat) = geo(:,:numat)
        geo(:,:numat) = geoa(:,:numat)
        call pdbout(99)
        geo(:,:numat) = coord(:,:numat)
        call l_control("HTML", len_trim("HTML"), 1)
        close (99)
      end if
      coord(:,:natoms) = geo(:,:natoms)   ! Store input geometry
      if (index(keywrd, " LOCATE-TS") == 0) then
        do i = 1, nvar
          xparam(i) = geoa(loc(2,i), loc(1,i))
        end do
      else
        if (.not. allocated(lopt_store)) then
!
! Store lopt for input data-set or GEO_DAT in case it will be needed in LOCATE_TS
!
          allocate(lopt_store(3,natoms))
          lopt_store = lopt(:3,:natoms)
        end if
        nvar = 0
        do i = 1, natoms
          do j = 1,3
            if (lopt_store(j,i) == 1) then
              nvar = nvar + 1
              xparam(nvar) = geoa(j,i)
            end if
          end do
        end do
      end if
      geo(:,:natoms) = geoa(:,:natoms)
!
! The following "big_swap" saves the geometry and xparam for the rotated input geometry
!
      call big_swap(0,2)
      geo(:,:natoms) = coord(:,:natoms)   ! Restore input geometry
      do i = 1, nvar
        xparam(i) = geo(loc(2,i), loc(1,i))
      end do
      if (index(keywrd, " COMPARE") /= 0) then
        call wrt_diffs()
        if (abs(arc_hof_1) + abs(arc_hof_2) > 1.d-4) write(iw,*)
        if (trim(job_fn) == trim(geo_dat_name)) then
          line = "dataset"
        else
          line = "GEO_DAT"
        end if
        if (abs(arc_hof_1) > 1.d-4) &
          write(iw,"(10x,a,f12.3,a)")  "Heat of formation of "//trim(line)//" system:",arc_hof_1," Kcal/mol"
        if (abs(arc_hof_2) > 1.d-4) &
          write(iw,"(10x,a,f12.3,a)")  "Heat of formation of GEO_REF system:",arc_hof_2," Kcal/mol"
        if (abs(arc_hof_1) > 1.d-4 .and. abs(arc_hof_2) > 1.d-4) &
          write(iw,"(40x,a,f12.3,a)")  "Diff.:", arc_hof_1 - arc_hof_2," Kcal/mol"
        call analyze_h_bonds()
      end if
      do ii = 1, 6
        line = " "//trim(refkey(ii))
        call upcase(line, len_trim(line))
        i = index(line," GEO_REF")
        if (i /= 0) exit
      end do
      inquire(unit = 99, opened = opend, name = line)
      if (index(keywrd, " TS ") /= 0 .and. index(keywrd, " LOCATE-TS") == 0) then
        write(iw,'(/,a)')"    The average of the supplied and reference geometry will be written to:"
        write(iw,'(a)')"'"//trim(line)//"'"
        geo(:,:natoms) = 0.5d0*(geoa(:,:natoms) + geo(:,:natoms))
        call geout(99)
      else
        if (index(keywrd, " COMPARE") /= 0) then
          do i = len_trim(output_fn), 1, -1
            if (output_fn(i:i) == "/" .or. output_fn(i:i) == backslash) exit
          end do
          if (i > 0) then
            write(iw,'(//,a)')"    The following files will be written to """//output_fn(:i)//""":"
          else
            write(iw,'(//,a)')"    The following files will be written:"
          end if
          line_1 = job_fn
          call upcase(line_1, len_trim(line_1))
          j = len_trim(line_1)
          if (j > 7) then
            if (line_1(j - 3: j) == ".TXT" .and. line_1(j - 7:j - 7) == ".") &
            job_fn = job_fn(:len_trim(job_fn) - 4)
          end if
          line = job_fn(i + 1:len_trim(job_fn) - 3)//"html"
          write(iw,'(14x, a)')"'"//trim(line)//"'"
!
          line_1 = geo_dat_name
          call upcase(line_1, len_trim(line_1))
          i = len_trim(line_1)
          j = max(1,i - 7)
          if (line_1(i - 3: i) == ".TXT" .and. line_1(j:j) == ".") &
          geo_dat_name = geo_dat_name(:len_trim(geo_dat_name) - 4)
          line = geo_dat_name(:len_trim(geo_dat_name) - 3)//"pdb"
          if (index(keywrd, " COMPARE") /= 0) then
            write(iw,'(a)')"From GEO_REF: '"//trim(line_2)//"'"
          else
            write(iw,'(a)')"'"//trim(line_2)//"'"
          end if
!
          line = geo_ref_name(:len_trim(geo_ref_name) - 3)//"pdb"
        end if
        line = refkey_ref(1)
        do i = 1,3
          line = refkey(i)
          refkey(i) = refkey_ref(i)
          refkey_ref(i) = trim(line)
        end do
        refkey_ref(4) = koment
        refkey_ref(5) = title
        if (l_0SCF_HTML) then
!
! Write out the input geometry file needed for comparing the two geometries using JSmol.
!
            close (99)
            if (sum2 > 9.9995d0) then
              num = "6"
            else
              num = "5"
            end if
            write(line,'(a,f'//num//'.3,a)')"RMS_DIFF=",sum2
            call l_control(trim(line), len_trim(line), 1)
            write(line,'(a,f12.3,a)')"DIFF=",sum1*numat
            call l_control(trim(line), len_trim(line), 1)
            if (index(keywrd, " COMPARE") /= 0) then
              do i = len_trim(job_fn), 1, -1
                if (job_fn(i:i) == "/" .or. job_fn(i:i) == backslash) exit
              end do
              do j = len_trim(job_fn) - 4, 2, -1
                if (job_fn(j:j) /= " ") exit
              end do
              line_1 =  job_fn(i + 1:j)//"_"
            else
              line_1 = " "
            end if
            if (index(keywrd, " COMPARE") /= 0 .and. &
              geo_dat_name(:len_trim(geo_dat_name) -3) == geo_ref_name(:len_trim(geo_ref_name) -3)) then
              line = trim(line_1)//geo_dat_name(:len_trim(geo_dat_name) - 4)//"_a.pdb"
            else
              line = trim(line_1)//geo_dat_name(:len_trim(geo_dat_name) - 4)//".pdb"
            end if
            coord(:,:numat) = geo(:,:numat)
            call add_path(line)
            open(unit = 99, file = trim(line), iostat = i)
            if (index(keywrd, " COMPARE") /= 0) then
              write(iw,'(a)')"From GEO_DAT: '"//trim(line)//"'"
            else
              write(iw,'(a)')"'"//trim(line)//"'"
            end if
            call pdbout(99)
        end if
        do i = 1,3
          line = refkey_ref(i)
          refkey_ref(i) = refkey(i)
          refkey(i) = trim(line)
        end do
        koment = trim(refkey_ref(4))
        title = trim(refkey_ref(5))
        close(99)
      end if
      deallocate(same)
      if (index(keywrd, " LOCATE-TS") == 0) then
        if (index(keywrd," 0SCF") + index(keywrd, " TS ") /= 0) then
!
! If a RESTART, generate an ARC file
!
          if (index(keywrd, " RESTART") /= 0) then
            inquire(unit=iarc, opened=opend)
            if (opend) close(iarc)
            archive_fn = archive_fn(:len_trim(archive_fn) - 3)//"arc"
            open(unit=iarc, file=archive_fn, status='UNKNOWN', position='asis')
            rewind iarc
            call geout (iarc)
          end if
          call mopend("GEO_REF with 0SCF: Job complete")
          return
        end if
      end if
      geo(:,:natoms) = coord(:,:natoms)
      coord(:,:natoms) = geoa(:,:natoms)
      return
  end subroutine geo_ref
  subroutine compare_txtatm(bug, any_bug)
    use molkst_C, only : numat, maxtxt, keywrd, line, keywrd_txt
    use common_arrays_C, only : txtatm, txtatm1, nat
    use chanel_C, only : iw, job_fn
    implicit none
    logical, intent (inout) :: bug, any_bug
    integer :: i, j, ii,jj
    if (index(keywrd, "GEO-OK") /= 0) return
    if (index(keywrd, "GEO_REF") == 0) return
    bug = .false.
    if (maxtxt /= 27) return
    do i = 1, numat
      do j = 1, 2
        if (txtatm(i)(20:20) /= " ") exit
        txtatm(i)(18:20) = " "//txtatm(i)(18:19)
      end do
      do j = 1, 2
        if (txtatm1(i)(20:20) /= " ") exit
        txtatm1(i)(18:20) = " "//txtatm1(i)(18:19)
      end do
    end do
    do i = 1, numat
      do j = i + 1, numat
        if (txtatm1(i)(12:) == txtatm1(j)(12:)) exit
      end do
      if (j <= numat .and. nat(i) /= 1) then
        if ( .not. bug) then
          ii = index(keywrd_txt, "GEO_DAT=")
         if (ii > 0) then
            jj = index(keywrd(ii + 9:),'"') + ii + 7
            line = keywrd(ii + 9:jj)
            write(iw,'(/10x,a,/)')"Atoms in the GEO_DAT file '"// &
            trim(line)//"' with the same labels"
          else
            write(iw,'(/10x,a,/)')"Atoms in the data-set file '"// &
            trim(job_fn)//"' with the same labels"
          end if
          write(iw,'(10x,a,i6,a,i6,a)')"Atoms", i, " and", j, &
          ";  Labels: ("//txtatm1(i)//") and ("//txtatm1(j)//")"
        end if
        bug = .true.
      end if
    end do
    if (bug) then
      call mopend("Error in data detected while using GEO_REF")
      write(iw,"(5x,a)")"(To continue with the current data set, use 'GEO-OK')"
      any_bug = .true.
    end if
    return
  end subroutine compare_txtatm

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine prtgra ()
    use molkst_C, only: natoms, nvar, maxtxt, na1, keywrd
    use chanel_C, only: iw
    use elemts_C, only: elemnt
    use common_arrays_C, only : grad, xparam, txtatm, labels, loc, na
    implicit none
    character (len=30) :: blank
    character (len=100) :: fmat
    logical :: lint, lxyz
    integer :: i, j, k, l, m, n
    double precision :: glim, gmax, sum
    double precision, dimension (3, 2) :: tmp
    j = 0
    do i = 2, natoms
      if (na(i) /= 0) j = j + 1
    end do
    lxyz = (j == 0)
    lint = (j == natoms - 1)
    glim = 0.1d0 ! Only print large gradients
    i = Index (keywrd, " GRAD=") + Index (keywrd,"DERIV") + Index (keywrd," GRAD")
    if (i /= 0) glim = -0.1d0
    blank = " "
    if (maxtxt == 0) then
      i = 1
    else
      i = maxtxt + 3
    end if
    if (lxyz) then   !  All coordinates are Cartesian
      write (iw, '("       ", a, "     Cartesian Gradients         Cartesian Coordinates          |Gradient|")') &
        blank(:i)
      write (iw, '("  Atom ", a, "     X        Y        Z        X          Y          Z")') blank(:i)
    else if (lint) then  !  All coordinates are internal
      write (iw, '("  Atom ", a, "         Gradients                      Geometry    ")') blank(:i)
      write (iw, '("  Atom ", a, "    Bond    Angle  Dihedral    Bond       Angle    Dihedral")') blank(:i)
    else !  Coordinates are mixed - Cartesian and internal
      write (iw, '("  Atom ", a, "         Gradients                      Geometry                  |Grad|")')  &
        blank(:i)
    end if
    write (iw,*)
    l = 1
    do i = 1, natoms
      !
      !                       1         2         3         4
      !              12345678901234567890123456789012345678901234567
      !
      fmat = "(I5,A,"
      j = 0
      gmax = 0.d0
      if (l <= nvar) then
        k = 7
        n = 38
        do m = 1, 3
          if (loc(1, l) == i .and. loc(2, l) == m) then
            j = j + 1
            tmp(j, 1) = grad(l)
            tmp(j, 2) = xparam(l)
            if (na1 /= 99 .and. m > 1 .and. na(i) /= 0) then
              tmp(j, 2) = tmp(j, 2) * 180.d0 / 3.14159265358979d0
            end if
            gmax = Max (gmax, Abs (grad(l)))
            fmat (k:k+4) = "F9.3,"
            fmat (n:n+5) = "F11.5,"
            l = l + 1
            k = k + 5
            n = n + 6
          else
            fmat (k:k+12) = "'     -   ',"
            fmat (n:n+14) = "'     -     ',"
            k = k + 13
            n = n + 15
          end if
        end do
        fmat (n:n+8) = "f12.3,1X)"
      end if
      if (j /= 0 .and. glim < gmax) then
        if (maxtxt == 0) then
          if (j == 3 .and. na(i) == 0) then
            sum = sqrt(tmp(1, 1)**2 + tmp(2, 1)**2 + tmp(3, 1)**2)
            write (iw, fmat) i, " " // elemnt (labels(i)), ((tmp(m, n), m=1, j), n=1, 2), sum
          else
            write (iw, fmat) i, " " // elemnt (labels(i)), ((tmp(m, n), m=1, j), n=1, 2)
          end if
        else
         if (j == 3 .and. na(i) == 0) then
            sum = sqrt(tmp(1, 1)**2 + tmp(2, 1)**2 + tmp(3, 1)**2)
            write (iw, fmat) i, " " // elemnt (labels(i)) // "(" // txtatm (i) &
         & (:maxtxt) // ")" // blank (maxtxt+3:17), ((tmp(m, n), m=1, j), n=1, 2), sum
          else
            write (iw, fmat) i, " " // elemnt (labels(i)) // "(" // txtatm (i) &
         & (:maxtxt) // ")" // blank (maxtxt+3:17), ((tmp(m, n), m=1, j), n=1, 2)
          end if
        end if
      end if
    end do
    write(iw,*)
  end subroutine prtgra
  subroutine prt_sorted_gradients
    use molkst_C, only: natoms, nvar, maxtxt, pdb_label
    use chanel_C, only: iw
    use elemts_C, only: elemnt
    use common_arrays_C, only : grad, txtatm, loc, labels, coord
    implicit none
    character (len=30) :: blank
    integer :: i, j, k, l, m
    double precision :: glim, gmax, sum
    double precision, dimension (3) :: tmp
    double precision, allocatable :: mod_grad(:), grads(:,:)
    if (nvar < 3) return
    allocate (mod_grad(natoms), grads(3,natoms))
    mod_grad = 0.d0
    l = 1
    do i = 1, natoms
      j = 0
      if (l <= nvar) then
        tmp = 0.d0
        do m = 1, 3
          if (loc(1, l) == i .and. loc(2, l) == m) then
            j = j + 1
            tmp(m) = grad(l)
            l = l + 1
          end if
        end do
        mod_grad(i) = sqrt(tmp(1)**2 + tmp(2)**2 + tmp(3)**2)
        grads(:,i) = tmp(:)
      end if
    end do
    if (pdb_label) then
      write(iw,'(/10x, a, //1x, a, 16x, a, 19x,a, 11x, a, 7x, a)')"LARGEST ATOMIC GRADIENTS","Atom","Label", &
      "Cartesian Gradients", "Cartesian Coordinates", " |Gradient|"
    else
      write(iw,'(/10x, a, //10x, a, 5x, a, 21x,a, 11x, a, 6x, a)')"LARGEST ATOMIC GRADIENTS","Atom","Label", &
      "Cartesian Gradients", "Cartesian Coordinates", " |Gradient|"
    end if
    write(iw,'(41x, a, 8x, a, /)')"  X          Y          Z", "X          Y          Z"
    gmax = 0.d0
    glim = 1.d6
    blank = " "
    do i = 1, min(20, natoms)
      sum = gmax
      do j = 1, natoms
        if (mod_grad(j) > sum .and. mod_grad(j) < glim) then
          sum = mod_grad(j)
          k = j
        end if
      end do
      if (sum < 1.d-3) exit
      if (pdb_label) then
      write (iw, '(i5, a, 3f11.3, 3f11.5, f11.3)') k, " " // elemnt (labels(k)) // "(" // txtatm (k) &
         & (:maxtxt) // ")" // blank (maxtxt+3:17), grads(:,k), coord(:,k), sum
      else
         write (iw, '(i14, 5x, a, 13x, 3f11.3, 3f11.5, f11.3)') k, " " // elemnt (labels(k)),grads(:,k), coord(:,k), sum
      end if
      glim = sum
      if (i > 9 .and. sum < 50) exit
    end do
    return
  end subroutine prt_sorted_gradients

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

program makpol
!***********************************************************************
!
!   Program MAKPOL- A utility for MOPAC.  MAKPOL can read in a PDB file
!                   with suffix ".ent" for example Urea.ent, or a MOPAC
!                   <Filename>.DAT file which contains the MERS keyword.
!                   It will produce a MOPAC data-file named <filename>.mop
!                   that is suitable for running solid-state systems.
!
!                   If keyword "TV" is not present, then a second file
!                   named Make_<filename>.dat will also be created.  
!                   This file is the same as <filename>.mop.  If its
!                   keyword MERS is edited, and MAKPOL run using
!                   Make_<filename>.dat, then a new <filename>.mop will
!                   be generated. 
!
!***********************************************************************
    use common_systm, only : iw, l_int, ir, ifiles_1, ndep, natoms, id, numat, line, l_use_tv
    use common_symult, only : depmul
    use common_keywrd, only : keywrd
    use common_jobnam, only : jobnam
    use common_geosym, only : locpar, idepfn, locdep
    use common_elemts, only : elemnt
    use common_titles, only : koment, title
    use common_ctvec, only : tvec
    use common_sizes, only : numatm
    implicit none
    integer :: i, j, k, l, ll, m, n, nmax, mers(3), store_mers(3), loc(3*numatm), &
      labels(numatm), na(numatm), nb(numatm), nc(numatm), N_Tv(3), M_Tv(3), Tv_atoms(3), &
      store_labels(numatm)
    double precision :: r, rmers(3), coord(3,numatm), geo(3,numatm), xtoc(3,3), &
      vec(3), Tv_n(3), sum, angle, zero(3) = 0.d0, store_tvec(3,3), store_coord(3,numatm)    
    character*1 :: n1, n2, n3
    logical :: exists, debug, pdb_file, l_cell, bug
    double precision, external :: dist, snapth, reada
    call getdat
!
!  Subroutines GETDAT, GETTXT, and GETGEO are from MOPAC. Only minor edits have been made
!  so that they will work in MAKPOL
!
    call gettxt
    if (index(keywrd, "HEADER") /= 0 .and. index(keywrd, " CSD") /= 0)  keywrd = " "
    line = "keywords for MAKPOL.txt"
    call add_path(line)
    inquire (file=trim(line), exist = exists)
    if (exists) then
      open(7, file = trim(line))
      read(7,'(a)', iostat = i) keywrd(len_trim(keywrd) + 2:)
      call upcase(keywrd, len_trim(keywrd))
      debug = (index(keywrd, "DEBUG") /= 0)
      if (debug) then
        write(iw,'(/10x,a)')"Keywords supplied by data-set and ""keywords for MAKPOL.txt"""
        write(iw,'(/10x,a)')trim(keywrd)
      end if
      line = trim(keywrd)
!
!  Delete duplicate keywords
!
      i = 0
      do 
        i = i + 1
        if (i >= len_trim(keywrd)) exit
        if (keywrd(i:i) /= " ") then
          j = i
          do 
            if (keywrd(j:j + 2) == "TV=" .or. keywrd(j:j + 3) == "CELL") then ! jump over these keywords
              do
                j = j + 1
                if (keywrd(j:j) == ")") exit
              end do
            end if
            j = j + 1
            if ((keywrd(j:j) < "A" .or. keywrd(j:j) > "Z") .and. &
                (keywrd(j:j) < "0" .or. keywrd(j:j) > "9") .and. &
                (keywrd(j:j) /= "-" .and. keywrd(j:j) /= "_") .and. keywrd(j:j) /= "." ) exit
          end do
          do
            k = index(keywrd(i + 2:), keywrd(i:j - 1))
            if (k == 0) exit
            do m = k + j + 1, 100
              if (keywrd(m:m) == " ") exit
            end do
            keywrd(k + i + 1: m) = " "
          end do
          do i = j, 100
            if (keywrd(i:i) == " ") exit            
          end do
        end if
      end do
  !  else
  !    write(iw,'("*",/,a,/,a,/,"*")')"* This message will not be printed if the file ""keywords for MAKPOL.txt""", &
  !    "* is present and is blank or contains keywords"
    end if
    if (keywrd(1:1) /= " ") keywrd = " "//trim(keywrd)
    if (koment == " ") then
      koment = jobnam
      do i = 1, len_trim(koment)
        if (koment(i:i) == "_") koment(i:i) = " "
      end do
    end if
!
    i = Index (" "//keywrd, " INT") 
    l_int = (i > 0)
    if (l_int) then
      keywrd (i:i + 3) = " "
    end if
    i = index(keywrd, " TV ")
    if (i > 0) then
      l_use_tv = .false.
      keywrd = keywrd(:i)//trim(keywrd(i + 4:))
    end if    
    call l_control("XYZ", len("XYZ"), -1)
    l_cell = (index(keywrd, " CELL") /= 0)
!
!  Read in the geometry in either MOPAC or PDB format
!
    call getgeo (ir, labels, geo, coord, loc, na, nb, nc)    
    if (natoms == -2) then
      rewind (ir)
      call getpdb(ir, geo, coord, na, nb, nc, labels, iw)
      rewind (ir)
      if (debug) then
       write(iw,'(/10x,a,/)')"Geometry read in from PDB file (atom number, label, coordinates)"      
        do i = 1, numat
          write (iw, "(2I6,3F18.12,3I4)") i, labels (i), (coord(k, i), k = 1, 3)
        end do
      end if
!
!  Assume geometry is in PDB format - look for translation vectors
!  and put them in keywrd as a keyword "TV=(a b c)"
!
      do
        read(ir,'(a)', iostat = i) line
        if (i /= 0) exit
        if (line(:5) == "CRYST") then
          i = 7
          do 
            if (line(i:i) /= " ") exit
            i = i + 1
          end do
          keywrd = trim(keywrd)//" CELL("//line(i:55)//")"
         if (l_cell) then
           call cell(coord, tvec)
           labels(numat + 1:numat + 3) = 99
           numat = natoms + 3
           id = 3
         end if
          l_cell = .true.
          exit
        end if
      end do
      koment = " "
      title = " "
      pdb_file = .true.
    else
!
! Geometry is in MOPAC format - look for atomic numbers 2, 93, or 107.  
! Use the coordinates of TV atoms as translation vectors, this is done in gmetrn,
! and the translation vectors are stored in the array tvec.
!
       if (index(keywrd, " XYZ") /= 0) natoms = natoms + 3
       numat = natoms
       call gmetrn (geo, coord, labels, na, nb, nc)
       j = 0
       do i = 1, numat   ! Delete all dummy atoms
!
!  Atoms that were translation vectors are given atomic number 98 by gmetrn,
!  at this point, these atoms are converted into atoms of the same type as atom 1
!  This is so that the atom types from a MOPAC data set and from PDB files are the same.
!
         if (labels(i) == 98) labels(i) = labels(1)
         if (labels(i) /= 99) then
           j = j + 1
           labels(j) = labels(i)
         end if
       end do
       if (l_cell) then
         call cell(coord, tvec)
         labels(numat + 1:numat + 3) = 99
         numat = natoms + 3
         id = 3
       end if
       geo(:,:numat) = coord(:,:numat)
!
!  The geometry is now in Cartesian coordinates, in geo and coord,
!  and the translation vectors are in tvec
!
       na = 0
       l = 0
       if (id > 0) then
         do i = 1, id
           sum = sqrt(tvec(1,i)**2 + tvec(2,i)**2 + tvec(3,i)**2)
           l = l + 1
           if (l == 1) write(keywrd(len_trim(keywrd) + 2:),'(a)')"TV=("
           write(keywrd(len_trim(keywrd) + 1:),'(f8.4)')sum
         end do
       else          
         do i = 2, natoms
          if (labels(i) == 93 .or. labels(i) == 2) labels(i) = 107
          if (labels(i) == 107) then
            sum = dist(coord, 1, i, tvec, xtoc, vec)
            l = l + 1
            if (l == 1) write(keywrd(len_trim(keywrd) + 2:),'(a)')"TV=("
            write(keywrd(len_trim(keywrd) + 1:),'(f8.4)')sum
          end if
         end do
       end if
       if (l /= 0) write(keywrd(len_trim(keywrd) + 1:),'(a)')")"
       pdb_file = .false.
    end if
!
!                                                                         All data now read in
!
! Geometry has been read in, and the translation vectors are known 
! and currently stored in the keyword.
!
!  Clean up keywrd (some keywords might have been added by subroutine "getgeo")
!
    call l_control("CHAINS", len("CHAINS"), -1)
    call l_control("START_RES", len("START_RES"), -1)
    if (labels(1) == 107) then
      write(iw,*)" Atom 1 must not be a translation vector"
      stop
    end if
    if (l_cell) then
         call cell(coord, tvec)
         do id = 1, 3
           Tv_n(id) = sqrt(tvec(1,id)**2 + tvec(2,id)**2 + tvec(3,id)**2)
           N_Tv(id) = 1 + int(11.d0/Tv_n(id))
           M_Tv(id) = 1
         end do
         numat = natoms + 3
         id = 3
         k = 3
    end if
    store_tvec = tvec
    store_coord(:,:numat) = coord(:,:numat)
    store_labels(:numat) = labels(:numat)
    i = index(keywrd, " TV=(")
    if (i /= 0 ) then
!
! Translation distances have been found in keywrd.
!
      Tv_n = 0.d0
      j = index(keywrd(i:), ")") + i
      l = 0
      do k = i, j
        if (keywrd(k:k) == ".") l = l + 1
      end do
      id = l
      k = index(keywrd(i:), ".") + i - 4
      do m = 1, id
        Tv_n(m) = reada(keywrd, k)
        if (m == id) exit
        k = index(keywrd(k + 5:), ".") + k + 1
      end do  
!
! Use Tv_n to work out tvec
!
      zero(:) = geo(:,1)
      do i = 1, natoms
        geo(:,i) = geo(:,i) - zero
      end do
      mers = 0
      do i = 1, id
        do j = 1, numat
          if (labels(j) /= labels(1)) cycle
          do k = 1, i - 1
            if (mers(k) == j) exit
          end do
          if (k < i) cycle
          sum = dist(geo, 1, j, tvec, xtoc, vec) 
          if (abs(sum - Tv_n(i)) < 0.01d0) then
            store_tvec(:,i) = geo(:,j)
            mers(i) = j
            exit
          end if
        end do
      end do
      tvec = store_tvec 
      if (natoms  == numat) then
        do i = 1, id
          geo(:,i + numat) = tvec(:,i)
        end do
        numat = numat + id
      end if

      if (debug) then
        write(iw,'(/5x,a)')"Data at the start of building the unit cell"
        write(iw,'(/5x,a, i4)')"Number of atoms:",numat
        write(iw,'(5x,a, i4)')"Number of Tv:   ",id
        write(iw,'(5x,a)')"KEYWORD: """//trim(keywrd)//""""
        write(iw,'(5x,a,3f9.4)')"Tv_n:           ",Tv_n(:id)
        write(iw,'(/15x,a,9F9.4)')"TVEC           "
        write(iw,'(2x,3f9.4)')tvec(:,:id)
        write(iw,'(/10x,a,/)')"Geometry (atom number, label, coordinates"      
        do l = 1, numat
          write (iw, "(2I6,3F18.12,3I4)") l, labels (l), (geo(k, l), k = 1, 3)
        end do
      end if
      call l_control("TV=", len("TV="), -1)
      if (l_cell) then
        do k = 1, 3
          N_Tv(k) = 1 + int(11.d0/Tv_n(k))
        end do
        k = 3
      else      
!
!  Now work out the size of the smallest translation vector lengths.
!  An earlier run might have made a multiple unit cell.
!  Store the new translation vectors in the array "tvec"
!
! Unconditionally set atom 1 at the origin
!
        zero(:) = geo(:,1)
        do i = 1, natoms
          geo(:,i) = geo(:,i) - zero
        end do
        k = 0
        loop: do i = 2, numat
          if (labels(i) /= labels(1) .and. (pdb_file .or. labels(i) /= 107)) cycle
          sum = dist(geo, 1, i, tvec, xtoc, vec) 
          do j = 1, id
!
! By default, the primitive unit cell is worked out, 
! if the Tv keyword is NOT supplied in the keywords in the data set 
!
            n = int(Tv_n(j)/sum) + 2
            if (.not. l_use_tv) n = 1
            do ll = n, 1, -1
              if (abs(sum - Tv_n(j)/ll) < 0.002d0) exit
            end do          
            if (ll > 1) then
!
!   Atom "i" is at a distance Tv_n(j)/ll from atom 1.
!
              if (ll > 1) then
!   Check that there is a second atom at the same fractional distance
!
                do l = 2, numat
                  if (l /= i .and. labels(l) /= 107) exit
                end do
                do m = 1, numat
                  if (labels(m) /= labels(l) .and. labels(m) /= 107) cycle              
                  sum = dist(geo, l, m, tvec, xtoc, vec)  
                  if (abs(sum - Tv_n(j)/ll) < 0.002d0) exit
                end do     
                if (m > numat) cycle
              end if
              do m = 2, numat
                if (m == i .or. (labels(m) /= labels(1) .and. labels(m) /= 107)) cycle
                sum = dist(geo, 1, m, tvec, xtoc, vec)  
                n = int(Tv_n(j)/sum) + 2
                if (.not. l_use_tv) n = 1
                do l = n, 1, -1
                  if (abs(sum - Tv_n(j)/l) < 0.002d0) then
                    call bangle (geo, i, 1, m, angle)
                    if (angle > 3.1d0) angle = angle - 3.1415926d0
                    if (angle > 0.001d0) then
                      continue
                      cycle
                    end if 
!
!   Atom "m" is at a distance Tv_n(j)/l from atom 1 and makes a straight line with atom "i".
!
                    if (ll > l) then
                      labels(i) = 107
                      labels(m) = 99
                      if (debug) write(iw,'(5x,a, i4, 5x, a, i4)')"Old Tv atom:", m, "New Tv atom:", i
                    else if (l > ll) then
                      labels(m) = 107
                      labels(i) = 99
                      if (debug) write(iw,'(5x,a, i4, 5x, a, i4)')"Old Tv atom:", i, "New Tv atom:", m
                    else
                      labels(m) = 107  
                      if (debug) write(iw,'(5x,a, i4, 5x, a, i4)')"Atom", m, "identified as a Tv"
                    end if
                    k = k + 1
!
! N_Tv holds the number of translation vectors that will be needed for a normal
! calculation.  If keyword MERS was provided, then information in N_Tv will be ignored.
!
                    N_Tv(k) = 1 + int(11.d0/Tv_n(j))
!
!  Tv_n(j) represents "l" or "ll" fundamental translation vector distances
!  Scale it back to exactly one fundamental translation vector distance.
!
                    Tv_n(j) = -Tv_n(j)/max(l, ll)
                    M_Tv(k) = max(l, ll)
                    cycle loop
                  end if
                end do
              end do
              if (Tv_n(j) > 0.1d0) then
!
! Atom "i" is at a distance of a Tv, but there is no other atom to verify that it is the
! correct atom, however the possibility of a mistake is low, so use it.
!
! If this possibility is a cause for concern, extend this test to check the angles or 
! check that there are no other atoms that are at a distance of Tv_n(j) from atom 1.
! Or, best option, use a larger PDB file, by selecting a 3 by 3 by 3 packing.
!
                labels(i) = 107
                k = k + 1
                N_Tv(k) = 1 + int(11.d0/Tv_n(j))
                M_Tv(k) = max(l, ll)
                Tv_atoms(k) = i
                if (debug) write(iw,'(5x,a, i4, 5x, a, i4)')"Atom", i, "identified as a Tv"
!
!  Tv_n(j) represents "l" fundamental translation vectors
!
                Tv_n(j) = -Tv_n(j)/max(l, ll)
                 cycle loop
              end if
            end if
          end do 
        end do loop
      end if
      i = 0
      if (id == 3) then
        i = 0
        do j = 1, 3
          if (Tv_n(j) < -0.001d0) i = i + 1
        end do
      end if
      if (.not. l_cell .and. id == 3 .and. i == 0) then
!
!  No Tv were found, so,
!  and reset the original Tv labels back to 107.
!
        do i = natoms + 1, natoms + 3
          labels(i) = 107
        end do
        natoms = natoms + 3
        do j = 1, id
          do k = 1, 3
            N_Tv(k) = 1 + int(11.d0/Tv_n(j))
            M_Tv(k) = 1
          end do
        end do
        k = 3
      end if      
      Tv_n = abs(Tv_n)
    else if (id /= 3) then
      write(iw,'(/10x,a)')"Translation vector distances not found"
      stop
    end if
    if (debug) then
        write(iw,'(/5x,a)')"Data after constructing Tv_n and N_Tv"
        write(iw,'(/5x,a,3f9.4)')"Tv_n:           ",Tv_n(:id)
        write(iw,'(/5x,a,3i9)')"N_Tv:           ",N_Tv(:id)
    end if  

!
!   Tv and the number of unit cells in each direction, N_Tv, are known.
!   tvec is still not known.
!
!  Write out the number of unit cells in each direction as a keyword MERS=(n,n,n)
!
    if (index(keywrd, " MERS") == 0) then
      if (k == 1) then
        write(keywrd(len_trim(keywrd) + 1:),'(a,i1,")")')" MERS=(", N_Tv(1)
      elseif (k == 2) then
        write(keywrd(len_trim(keywrd) + 1:),'(a,(i1,","),i1,")")')" MERS=(", N_Tv(1), N_Tv(2)
      elseif (k == 3) then
        write(keywrd(len_trim(keywrd) + 1:),'(a,2(i1,","),i1,")")')" MERS=(", N_Tv
      end if
    end if  
    if (Index (keywrd, " SYMM") + Index (keywrd, " SYM ") /= 0) then
      ifiles_1 = 0
      call getsym (locpar, idepfn, locdep, depmul, na)
      if (ndep /= 0) then
        call symtnn (geo, na)
      end if
    end if
    natoms = numat
    if (natoms == 0) then
      write (iw,*) " The system appears to have no atoms!"
      stop
    end if
    close (ir, status = "DELETE")
    numat = natoms
    if (Index (keywrd, " SNAP") /= 0) then
!
!   If any angles are near to important angles (such as 109.47...)
!   snap the angle to the exact angle
!
      do i = 1, numat
        if (na(i) /= 0) then
          geo(2, i) = snapth (geo(2, i))
          geo(3, i) = snapth (geo(3, i))
        end if
      end do
    end if
!
!  Protect any dummy atoms
!
    do i = 1, numat
      if (labels(i) == 99) then
        labels(i) = 98
      end if
    end do
!
!   Convert to Cartesian coordinates
!
    xtoc = tvec
    k = numat - id
    i = id
    call gmetrn (geo, coord, labels, na, nb, nc)
!
    if (l_cell) then
      call cell(coord, tvec)
      labels(numat - 2:numat) = 99
    end if
    id = i
!
!  xtoc: Translation vectors of the input data
!  tvec: Smallest valid translation vectors (primitive vectors)
!  Tv_n: Smallest valid translation distances
!  M_Tv: Number of primitive vectors needed to conver tvec into xtoc
!  n_tv: Number of primitive vectors requested.
!
    if (abs(Tv_n(1) - Tv_N(2)) + abs(Tv_n(1) - Tv_n(3)) < 0.004) then
!
!  All three primitive translation distances are equal, so
!  use the order of Tv found in the input data.
!
      do i = 1, 3
        tvec(:,i) = xtoc(:,i)/max(1,M_Tv(i))
      end do
      if (index(keywrd, " BCC") /= 0 .and. M_Tv(1)*M_Tv(2)*M_Tv(3) /= 1) tvec = tvec*0.5d0
    else
!
! Sort tvec into its original sequence.  The primitive Tv distances were worked out
! from the atoms of the input data.
!
      xtoc = tvec
      do j = 1, id
        do i = 1, id
          sum = sqrt(xtoc(1,i)**2 + xtoc(2,i)**2 + xtoc(3,i)**2)
          if (abs(sum - tv_n(j)) < 0.002d0) then
            tvec(:,j) = xtoc(:,i)
            coord(:,j + k) = tvec(:,j)
            xtoc(:,i) = -1.d3
            tv_n(j) = -tv_n(j)
          end if
        end do
      end do
      tv_n = -tv_n
    end if
!
!  Check to see if a severe error has been made
!
    bug = .false.
    if (id == 3) then
      bug = (bug .or. ((tvec(1,1) - tvec(1,2))**2 + (tvec(2,1) - tvec(2,2))**2 + (tvec(3,1) - tvec(3,2))**2 < 1.d0))
      bug = (bug .or. ((tvec(1,1) - tvec(1,3))**2 + (tvec(2,1) - tvec(2,3))**2 + (tvec(3,1) - tvec(3,3))**2 < 1.d0))
      bug = (bug .or. ((tvec(1,2) - tvec(1,3))**2 + (tvec(2,2) - tvec(2,3))**2 + (tvec(3,2) - tvec(3,3))**2 < 1.d0))
    end if
    if (bug) then
      if (l_cell) then
        write(iw,'(a)')" A severe fault is present in keyword ""CELL"" "// &
          "Two translation vectors are almost the same."
      else
        if (index(keywrd, " GEO-OK") /= 0) then
          tvec = store_tvec
          coord(:,:numat) = store_coord(:,:numat)
          labels(:numat) = store_labels(:numat)
        else
          write(iw,'(a)')" A severe fault was found in trying to calculate the translation vectors.", &
          " Try using keyword ""CELL"" or add the keyword ""GEO-OK"".", &
          " If ""GEO-OK"" is used, then the supplied translation vectors will be used,", &
          " and no attempt will be made to calculate them.", &
          " See http://openmopac.net/manual/makpol.html"
        end if
      end if
      i =index(keywrd, " GEO-OK")
      if (i /= 0) then
        line = trim(keywrd)
        keywrd = line(:i - 1)//trim(line(i + 7:))
      else
        stop
      end if
    end if
    if (debug) then
      write(iw,'(/10x,a,i4)')"Number of atoms in input data:", numat - id
    end if
    na(:numat) = 0
    if (id == 0) id = i
!
!   Safety check - make sure that no two atoms are at the same position
!
    do i = 1, numat
      if (labels(i) == 98) then
        labels(i) = 99
      end if
    end do
    k = 0
    do i = 1, numat
      l = 0
      do j = 1, i - 1
        r = (coord(1, i)-coord(1, j))**2 + (coord(2, i)-coord(2, j))**2 + &
       &  (coord(3, i)-coord(3, j))**2
        if (r < 0.1d0 .and. labels(i) < 99 .and. labels(j) < 99 .and. labels(i) /= labels(j)) then
          write (iw, "(A,I4,A,I4,A)") " In the data set supplied" // ", atoms",&
         &  i, " and", j, " are at the same position"
          write (iw, "(A)") " (These atoms are of type " // elemnt (labels(i)) &
         & // " and " // elemnt (labels(j)) // " respectively)"
           stop
         end if
         if (r < 0.1d0 .and. labels(i) < 99 .and. labels(j) < 99 ) l = 1
      end do
      if (l == 0) then
        k = k + 1
        coord(1,k) = coord(1,i)
        coord(2,k) = coord(2,i) 
        coord(3,k) = coord(3,i)
        labels(k) = labels(i)
      end if
    end do
    numat = k
    do i = 1, numat
      if (labels(i) == 99) then
        labels(i) = 98
      end if
    end do
!
!   Remove dummy atoms from LABELS
!
    do i = numat, 1, -1
      if (labels(i) < 98) exit
    end do
    numat = i
    natoms = numat
!
!   The translation vectors are in TVEC
!
!  If keyword MERS is NOT present, write in a default value of MERS
!
    j = Index (keywrd, "MERS=")
    if (j == 0) then
      j = index(keywrd, "              ") + 1
      if (id == 1) then
         keywrd(j:j + 13) = "MERS=(1) "
      else if (id == 2) then
         keywrd(j:j + 13) = "MERS=(1,1) "
      else
         keywrd(j:j + 13) = "MERS=(1,1,1) "
      end if
    end if
    i = Index (keywrd(j:), " ") + j
    k = 0
    do l = 1, 3
      j = j + k
      if (l > 1 .and. k == 0) exit
      rmers(l) = reada (keywrd(j:), 1)
      k = Index (keywrd(j:i), ",")
    end do
    if( l-1 /= id) then
      j = Index (keywrd, "MERS=")
      write(iw,"(10x,3a,i3)")  "Keyword MERS is: "&
    &,'"'//keywrd(j:i - 2)//'",', " number of Tv in system:",id
      write(iw,"(10x,a)")"Correct error and re-submit"
      stop
    end if
    do i = 1, id
      if (Abs(rmers(i) - Nint(rmers(i)))< 0.001d0) then
        mers(i) = nint(rmers(i))
      else 
!
!  Special case:  Number of mers is not integer
!
        do j = 1, 100
          if (Abs(rmers(i)*j - Nint(rmers(i)*j)) < 0.01d0) exit
        end do
!
!   Multiply by j to get integer
!
        mers(i) = Nint(rmers(i)*j)
        do k = 1,3
          tvec(k,i) = tvec(k,i)/j
        end do
!
!  Do a quick check: is there an atom at the first translation distance?
!
        l = 0
        do k = 2, natoms
          do j = -1,1,2
            if (Abs(coord(1,k) - tvec(1,i)) + Abs(coord(2,k) - tvec(2,i)) &
            & + Abs(coord(3,k) - tvec(3,i)) < 0.1d0)  l = 1
          end do
          if (l == 1) exit
        end do
        if (l == 0) then
          write(iw,"(a,i2,3a)") "For translation vector",i," there are no atoms at", &
          & " the correct distance - check MERS"
          write(iw,"(2a)")"Keyword = ",keywrd(1:len_trim(keywrd))
          stop
        end if
      end if
    end do
    if (index(keywrd, " BCC") /= 0) then
      if (mers(1)*mers(2)*mers(3) /= 1) then
        do i = 1, 3
          if (mod(mers(i),2) /= 0) then
            write(iw,'(//10x,a)')" When BCC is used, all MERS must be even"
            stop
          end if
        end do  
      end if
    end if
!
! Write out keyword MERS again
!
    j = Index (keywrd, "MERS=")
    i = Index (keywrd(j:), " ") + j - 1
    keywrd(j:i) = " "
    n1 = char(ichar("1") + int(log10(mers(1)*1.01)))
    if (id > 1) n2 = char(ichar("1") + int(log10(mers(2)*1.01)))
    if (id > 2) n3 = char(ichar("1") + int(log10(mers(3)*1.01)))
    if (id == 1) then
        write(keywrd(j:i),'("MERS=(",i'//n1//'")")')mers(1)     
    else if (id == 2) then
      write(keywrd(j:i),'("MERS=(",i'//n1//',",",i'//n2//',")")')mers(1),mers(2)
    else 
      write(keywrd(j:i),'("MERS=(",i'//n1//',",",i'//n2//',",",i'//n3//'")")')mers
    endif
    
    mers(2) = Max (1, mers(2))
    mers(3) = Max (1, mers(3))
    store_mers = mers
!
! First pass - check that all atoms are real, and that there are no duplicates.
!
    mers = 2
    if (id < 3) mers(3) = 1
    if (id < 2) mers(2) = 1
!
!   If "LET" or "SORT" is present, then do NOT put all atoms into the CUC.
!   Use LET or SORT if band-structure work is to be done. 
!   If setcuc is called here, then the positions of atoms might get changed -
!   assume the user knows what is wanted.
!
    if (Index (keywrd, " LET") + Index (keywrd, " SORT") == 0) then
!
! Put all atoms into the central unit cell.
!
      call setcuc (coord, natoms, tvec, id, xtoc)
!
! Detect redundancies (atoms within 0.5A of each other are considered to be the same atom)
!
      do i = 2, numat
        do j = 1, i - 1
          if (labels(j) == 200) cycle
          r = dist(coord, i, j, tvec, xtoc, vec)
          if (r < 0.5d0 .and. labels(i) < 99 .and. labels(j) < 99) then
            labels(i) = 200
            exit
          end if
        end do
      end do
!
! Remove redundancies 
!
      k = 0
      do i = 1, numat      
        if (labels(i) /= 200) then
          k = k + 1
          coord(1,k) = coord(1,i)
          coord(2,k) = coord(2,i) 
          coord(3,k) = coord(3,i)
          labels(k) = labels(i)
        end if
      end do
      numat = k
    end if 
!
!   If "LET" or "SORT" is present, then do NOT join fragments together.
!   Use LET or SORT if band-structure work is to be done.
!
    if (Index (keywrd, " LET") + Index (keywrd, " SORT") == 0)  &
!
!   Join together fragments, so that discrete molecules can be recognized.
!
    call join_bits_together(coord, labels, numat, tvec, xtoc)   
    mers = store_mers
    nmax = numat * mers(1) * mers(2) * mers(3) + 2 * id
    i = index(keywrd, " CELL")
    if (i /= 0) then
        j = index(keywrd(i:), ")") + i 
        keywrd(i:) = trim(keywrd(j:))
    end if
    i = Index (keywrd, " SORT")
    if (i /= 0) keywrd(i:i + 4) = " "
    i = 0
    call maklay (labels, coord, geo, na, nb, nc, mers, loc, nmax) 
end program makpol
double precision function snapth (theta)
!
!.. Implicit Declarations ..
    implicit none
!
!.. Formal Arguments ..
    double precision, intent (in) :: theta
!
!.. Local Scalars ..
    integer :: i, j, k
    double precision :: angle, const, phase, sum
!
!.. Intrinsic Functions ..
    intrinsic Abs, Acos, Asin, Cos, Int, Mod, Nint, Sign, Sqrt
!
! ... Executable Statements ...
!
    angle = Cos (theta)
    phase = Sign (1.d0, theta)
    if (Abs (angle) < 1.d-4) then
!
!   Cos(Theta) is zero - this is 90 or 270 degrees
!
      const = 2 * Asin (1.d0)
      if (Abs (theta) < const) then
        snapth = phase * Acos (0.d0)
      else
        snapth = phase * Acos (0.d0) + const
      end if
    else
      sum = Abs (1/angle)**2
      do i = 1, 7
        j = Nint (sum*i)
        if (Abs (j - sum*i) < 1.d-4) go to 1000
      end do
      snapth = theta
      return
1000  sum = Sqrt ((1.d0*i)/j)
      const = 2 * Asin (1.d0)
      k = Int (Abs (theta)/const)
      if (Mod(k, 2) == 0) then
!
!   Theta is in domain -180 - 0 - +180 degrees
!
        snapth = phase * Acos (sign(sum, angle))
      else
!
!   Theta is in domain -180 - 360 - +180 degrees
!
        snapth = phase * (2*const-Acos (sign(sum, angle)))
      end if
    end if
end function snapth
double precision function dist(coord, i, j, tvec, xtoc, vec)
  use common_systm, only :  id
  double precision :: coord(3,*), tvec(3,3), xtoc(3,3), vec(3)
  integer :: i, j
!
  double precision, dimension (3) :: xyz
  integer :: k, l, jj
  do k = 1,3
    vec(k) = coord(k,i) - coord(k,j)
  end do
      xyz = 0.d0
      do k = 1, 3        
        do l = 1, id
          xyz(l) = xyz(l) + vec(k) * xtoc(l, k)
        end do
      end do
!
!   XYZ holds the crystal fractional coordinates
!
      do jj = 1, id
        l = Int (xyz(jj)+2000.5d0) - 2000
        do k = 1, 3
          vec(k) = vec(k) - l * tvec(k, jj)
        end do
      end do
      dist = sqrt(vec(1)**2 + vec(2)**2 + vec(3)**2)
      return
end function dist
subroutine join_bits_together(coord, labels, numat, tvec, xtoc)  
  use common_systm, only : id
  use mod_atomradii, only: atom_radius_covalent, atom_radius_vdw
  implicit none
  integer :: numat, labels(numat)
  double precision, dimension (3,numat) :: coord
  double precision, dimension (3,3) :: tvec, xtoc
!
!  Local
!
  logical, allocatable, dimension (:,:) :: bonded
  logical, dimension (numat) :: used
  double precision :: coord_local(3,numat), xyz(3), vec(3)
  integer, dimension (numat) :: fragment, bonded_to
!
  double precision :: dist, Rij, sum, all_rij(107, 107)
  integer :: i, j, l, ii, jj, k, infrag
  external dist 
  allocate (bonded(numat,numat))
  atom_radius_covalent =  atom_radius_vdw*0.6d0
  do i = 1, 83
    do j = 1,83
      all_rij(i,j) = atom_radius_covalent(i) + atom_radius_covalent(j)
    end do
  end do
!
!  Add specific RIJ here
!
   all_rij(8,1)   = 1.4d0! Oxygen - hydrogen
   all_rij(1,8)   = 1.4d0! Oxygen - hydrogen
   all_rij(35,5)  = 2.3d0! Boron - bromine
   all_rij(5,35)  = 2.3d0! Boron - bromine
   all_rij(8,11)  = 2.38d0! Sodium - oxygen
   all_rij(11,8)  = 2.38d0! Sodium - oxygen
   all_rij(7,12)  = 2.3d0! Magnesium - nitrogen
   all_rij(12,7)  = 2.3d0! Magnesium - nitrogen
   all_rij(8,12)  = 2.2d0! Magnesium - oxygen
   all_rij(12,8)  = 2.2d0! Magnesium - oxygen
   all_rij(35,12) = 2.8d0! Magnesium - bromine
   all_rij(12,35) = 2.8d0! Magnesium - bromine
   all_rij(53,12) = 2.8d0! Magnesium - iodine
   all_rij(12,53) = 2.8d0! Magnesium - iodine
   all_rij(13,53) = 2.7d0! Aluminum - iodine
   all_rij(53,13) = 2.7d0! Aluminum - iodine
   all_rij(8,15)  = 1.7d0! Phosphorus - oxygen
   all_rij(15,8)  = 1.7d0! Phosphorus - oxygen
   all_rij(19,7)  = 2.85d0! Potassium - nitrogen
   all_rij(7,19)  = 2.85d0! Potassium - nitrogen
   all_rij(53,15) = 2.6d0! Phosphorus - iodine
   all_rij(15,53) = 2.6d0! Phosphorus - iodine 
   all_rij(19,8)  = 2.5d0! Potassium - oxygen
   all_rij(8,19)  = 2.5d0! Potassium - oxygen
   all_rij(8,20)  = 2.3d0! Calcium - oxygen
   all_rij(20,8)  = 2.3d0! Calcium - oxygen
   all_rij(53,20) = 3.3d0! Calcium - iodine
   all_rij(20,53) = 3.3d0! Calcium - iodine
   all_rij(21,8)  = 2.6d0! Scandium - oxygen
   all_rij(8,21)  = 2.6d0! Scandium - oxygen
   all_rij(22,7)  = 2.3d0! Titanium - nitrogen
   all_rij(7,22)  = 2.3d0! Titanium - nitrogen
   all_rij(22,8)  = 2.6d0! Titanium - oxygen
   all_rij(8,22)  = 2.6d0! Titanium - oxygen
   all_rij(22,17) = 2.6d0! Titanium - chlorine
   all_rij(17,22) = 2.6d0! Titanium - chlorine 
   all_rij(22,35) = 2.8d0! Titanium - bromine
   all_rij(35,22) = 2.8d0! Titanium - bromine 
   all_rij(22,53) = 2.9d0! Titanium - iodine
   all_rij(53,22) = 2.9d0! Titanium - iodine 
   all_rij(23,8)  = 2.4d0! Vanadium - oxygen  
   all_rij(8,23)  = 2.4d0! Vanadium - oxygen
   all_rij(23,35) = 2.5d0! Vanadium - bromine  
   all_rij(35,23) = 2.5d0! Vanadium - bromine
   all_rij(24,17) = 2.55d0! Chromium - chlorine
   all_rij(17,24) = 2.55d0! Chromium - chlorine
   all_rij(25,6)  = 1.9d0! Manganese - carbon  
   all_rij(6,25)  = 1.9d0! Manganese - carbon
   all_rij(25,8)  = 2.4d0! Manganese - oxygen  
   all_rij(8,25)  = 2.4d0! Manganese - oxygen
   all_rij(25,17) = 2.7d0! Manganese - chlorine  (MnCl6(4-))
   all_rij(17,25) = 2.7d0! Manganese - chlorine
   all_rij(25,35) = 2.8d0! Manganese - bromine  (MnBr6(4-))
   all_rij(35,25) = 2.8d0! Manganese - bromine
   all_rij(26,17) = 2.4d0! Iron - chlorine
   all_rij(17,26) = 2.4d0! Iron - chlorine
   all_rij(27,16) = 2.4d0! Cobalt - sulfur
   all_rij(16,27) = 2.4d0! Cobalt - sulfur
   all_rij(27,35) = 2.6d0! Cobalt - bromine
   all_rij(35,27) = 2.6d0! Cobalt - bromine
   all_rij(27,53) = 2.7d0! Cobalt - iodine
   all_rij(53,27) = 2.7d0! Cobalt - iodine 
   all_rij(28,6)  = 2.2d0! Nickel - carbon
   all_rij(6,28)  = 2.2d0! Nickel - carbon
   all_rij(28,7)  = 2.3d0! Nickel - nitrogen 
   all_rij(7,28)  = 2.3d0! Nickel - nitrogen
   all_rij(28,8)  = 2.6d0! Nickel - oxygen  (NiO6)
   all_rij(8,28)  = 2.6d0! Nickel - oxygen
   all_rij(28,16) = 2.4d0! Nickel - sulfur
   all_rij(16,28) = 2.4d0! Nickel - sulfur
   all_rij(28,17) = 2.4d0! Nickel - chlorine
   all_rij(17,28) = 2.4d0! Nickel - chlorine
   all_rij(29,7)  = 2.2d0! Copper - nitrogen 
   all_rij(7,29)  = 2.2d0! Copper - nitrogen
   all_rij(29,8)  = 2.6d0! Copper - oxygen (CuO6)
   all_rij(8,29)  = 2.6d0! Copper - oxygen
   all_rij(29,17) = 2.6d0! Copper - chlorine
   all_rij(17,29) = 2.6d0! Copper - chlorine
   all_rij(29,35) = 3.1d0! Copper - bromine
   all_rij(35,29) = 3.1d0! Copper - bromine
   all_rij(29,53) = 3.1d0! Copper - iodine
   all_rij(53,29) = 3.1d0! Copper - iodine
   all_rij(30,35) = 2.6d0! Zinc - bromine
   all_rij(35,30) = 2.6d0! Zinc - bromine 
   all_rij(31,8)  = 2.2d0! Gallium - oxygen
   all_rij(8,31)  = 2.2d0! Gallium - oxygen 
   all_rij(31,16) = 2.5d0! Gallium - sulfur
   all_rij(16,31) = 2.5d0! Gallium - sulfur 
   all_rij(31,17) = 2.5d0! Gallium - chlorine
   all_rij(17,31) = 2.5d0! Gallium - chlorine 
   all_rij(31,35) = 2.5d0! Gallium - bromine
   all_rij(35,31) = 2.5d0! Gallium - bromine 
   all_rij(31,53) = 2.6d0! Gallium - iodine
   all_rij(53,31) = 2.6d0! Gallium - iodine 
   all_rij(32,35) = 2.6d0! Germanium - bromine
   all_rij(35,32) = 2.6d0! Germanium - bromine 
   all_rij(32,53) = 2.6d0! Germanium - iodine
   all_rij(53,32) = 2.6d0! Germanium - iodine 
   all_rij(33,16) = 2.4d0! Arsenic - sulfur
   all_rij(16,33) = 2.4d0! Arsenic - sulfur 
   all_rij(33,35) = 2.5d0! Arsenic - bromine
   all_rij(35,33) = 2.5d0! Arsenic - bromine 
   all_rij(33,53) = 2.8d0! Arsenic - iodine
   all_rij(53,33) = 2.8d0! Arsenic - iodine 
   all_rij(47,6)  = 2.6d0! Silver - carbon
   all_rij(6,47)  = 2.6d0! Silver - carbon 
   all_rij(48,8)  = 2.9d0! Cadmium - oxygen
   all_rij(8,48)  = 2.9d0! Cadmium - oxygen 
   all_rij(34,17) = 2.4d0! Selenium - chlorine
   all_rij(17,34) = 2.4d0! Selenium - chlorine 
   all_rij(34,30) = 2.6d0! Selenium - zinc
   all_rij(30,34) = 2.6d0! Selenium - zinc 
   all_rij(34,34) = 2.5d0! Selenium - selenium
   all_rij(34,34) = 2.5d0! Selenium - selenium 
   all_rij(34,35) = 2.7d0! Selenium - bromine
   all_rij(35,34) = 2.7d0! Selenium - bromine 
   all_rij(34,48) = 2.8d0! Selenium - cadmium
   all_rij(48,34) = 2.8d0! Selenium - cadmium 
   all_rij(34,53) = 2.7d0! Selenium - iodine
   all_rij(53,34) = 2.7d0! Selenium - iodine 
   all_rij(34,80) = 2.8d0! Selenium - mercury
   all_rij(80,34) = 2.8d0! Selenium - mercury 
   all_rij(38,7)  = 3.0d0! Strontium - nitrogen
   all_rij(7,38)  = 3.0d0! Strontium - nitrogen 
   all_rij(38,53) = 3.6d0! Strontium - iodine
   all_rij(53,38) = 3.6d0! Strontium - iodine 
   all_rij(39,35) = 3.0d0! Yttrium - bromine  
   all_rij(35,39) = 3.0d0! Yttrium - bromine 
   all_rij(39,53) = 3.1d0! Yttrium - iodine  
   all_rij(53,39) = 3.1d0! Yttrium - iodine
   all_rij(42,8)  = 2.6d0! Molybdenum - oxygen
   all_rij(8,42)  = 2.6d0! Molybdenum - oxygen
   all_rij(42,17) = 2.7d0! Molybdenum - chlorine
   all_rij(17,42) = 2.7d0! Molybdenum - chlorine 
   all_rij(42,35) = 2.7d0! Molybdenum - bromine 
   all_rij(35,42) = 2.7d0! Molybdenum - bromine 
   all_rij(43,15) = 2.6d0! Technetium - phosphorus  
   all_rij(15,43) = 2.6d0! Technetium - phosphorus
   all_rij(43,16) = 2.6d0! Technetium - sulfur  
   all_rij(16,43) = 2.6d0! Technetium - sulfur
   all_rij(43,35) = 2.6d0! Technetium - bromine
   all_rij(35,43) = 2.6d0! Technetium - bromine
   all_rij(43,53) = 2.6d0! Technetium - iodine
   all_rij(53,43) = 2.6d0! Technetium - iodine
   all_rij(44,16) = 2.5d0! Ruthenium - sulfur  
   all_rij(16,44) = 2.5d0! Ruthenium - sulfur
   all_rij(44,17) = 2.5d0! Ruthenium - chlorine  
   all_rij(17,44) = 2.5d0! Ruthenium - chlorine
   all_rij(44,35) = 2.8d0! Ruthenium - bromine  
   all_rij(35,44) = 2.8d0! Ruthenium - bromine
   all_rij(44,53) = 2.9d0! Ruthenium - iodine  
   all_rij(53,44) = 2.9d0! Ruthenium - iodine
   all_rij(45,35) = 2.6d0! Rhodium - bromine  
   all_rij(35,45) = 2.6d0! Rhodium - bromine
   all_rij(45,53) = 2.8d0! Rhodium - iodine  
   all_rij(53,45) = 2.8d0! Rhodium - iodine
   all_rij(46,6)  = 2.3d0! Palladium - carbon
   all_rij(6,46)  = 2.3d0! Palladium - carbon 
   all_rij(46,7)  = 2.4d0! Palladium - nitrogen
   all_rij(7,46)  = 2.4d0! Palladium - nitrogen
   all_rij(46,16) = 2.5d0! Palladium - sulfur  
   all_rij(16,46) = 2.5d0! Palladium - sulfur
   all_rij(46,17) = 2.5d0! Palladium - chlorine  
   all_rij(17,46) = 2.5d0! Palladium - chlorine
   all_rij(46,35) = 2.5d0! Palladium - bromine  
   all_rij(35,46) = 2.5d0! Palladium - bromine
   all_rij(46,53) = 2.8d0! Palladium - iodine  
   all_rij(53,46) = 2.8d0! Palladium - iodine
   all_rij(49,6)  = 2.6d0! Indium - carbon  
   all_rij(6,49)  = 2.6d0! Indium - carbon
   all_rij(49,7)  = 2.5d0! Indium - nitrogen   
   all_rij(7,49)  = 2.5d0! Indium - nitrogen
   all_rij(49,15) = 2.6d0! Indium - phosphorus  
   all_rij(15,49) = 2.6d0! Indium - phosphorus
   all_rij(49,16) = 2.7d0! Indium - sulfur  
   all_rij(16,49) = 2.7d0! Indium - sulfur
   all_rij(49,17) = 2.7d0! Indium - chlorine  
   all_rij(17,49) = 2.7d0! Indium - chlorine
   all_rij(49,35) = 2.8d0! Indium - bromine  
   all_rij(35,49) = 2.8d0! Indium - bromine
   all_rij(49,52) = 2.9d0! Indium - tellurium  
   all_rij(52,49) = 2.9d0! Indium - tellurium
   all_rij(49,53) = 2.9d0! Indium - iodine  
   all_rij(53,49) = 2.9d0! Indium - iodine
   all_rij(50,6)  = 2.6d0! Tin - carbon  
   all_rij(6,50)  = 2.6d0! Tin - carbon
   all_rij(50,16) = 2.7d0! Tin - sulfur  
   all_rij(16,50) = 2.7d0! Tin - sulfur
   all_rij(50,17) = 2.5d0! Tin - chlorine  
   all_rij(17,50) = 2.5d0! Tin - chlorine
   all_rij(50,35) = 2.5d0! Tin - bromine  
   all_rij(35,50) = 2.5d0! Tin - bromine
   all_rij(51,6)  = 2.6d0! Antimony - carbon
   all_rij(6,51)  = 2.6d0! Antimony - carbon
   all_rij(51,8)  = 2.3d0! Antimony - oxygen
   all_rij(8,51)  = 2.3d0! Antimony - oxygen
   all_rij(51,16) = 2.9d0! Antimony - sulfur
   all_rij(16,51) = 2.9d0! Antimony - sulfur
   all_rij(51,17) = 3.0d0! Antimony - chlorine
   all_rij(17,51) = 3.0d0! Antimony - chlorine
   all_rij(51,35) = 3.0d0! Antimony - bromine
   all_rij(35,51) = 3.0d0! Antimony - bromine
   all_rij(51,51) = 2.9d0! Antimony - antimony
   all_rij(51,51) = 2.9d0! Antimony - antimony
   all_rij(51,53) = 3.5d0! Antimony - iodine
   all_rij(53,51) = 3.5d0! Antimony - iodine
   all_rij(52,8)  = 2.7d0! Tellurium - oxygen
   all_rij(8,52)  = 2.7d0! Tellurium - oxygen
   all_rij(52,16) = 2.9d0! Tellurium - sulfur
   all_rij(16,52) = 2.9d0! Tellurium - sulfur
   all_rij(52,17) = 2.7d0! Tellurium - chlorine
   all_rij(17,52) = 2.7d0! Tellurium - chlorine
   all_rij(52,35) = 2.8d0! Tellurium - bromine
   all_rij(35,52) = 2.8d0! Tellurium - bromine
   all_rij(52,52) = 3.4d0! Tellurium - tellurium
   all_rij(52,52) = 3.4d0! Tellurium - tellurium
   all_rij(52,53) = 3.1d0! Tellurium - iodine
   all_rij(53,52) = 3.1d0! Tellurium - iodine
   all_rij(55,7)  = 3.0d0! Cesium - nitrogen
   all_rij(7,55)  = 3.0d0! Cesium - nitrogen
   all_rij(56,8)  = 2.6d0! Barium - oxygen
   all_rij(8,56)  = 2.6d0! Barium - oxygen
   all_rij(56,35) = 3.4d0! Barium - bromine
   all_rij(35,56) = 3.4d0! Barium - bromine
! all_rij(56,56) = 2.4d0! Barium - barium
! all_rij(56,56) = 2.6d0! Barium - barium
   all_rij(57,7)  = 2.9d0! Lanthanum - nitrogen  
   all_rij(7,57)  = 2.9d0! Lanthanum - nitrogen
   all_rij(57,8)  = 2.7d0! Lanthanum - oxygen  
   all_rij(8,57)  = 2.7d0! Lanthanum - oxygen
   all_rij(57,17) = 3.0d0! Lanthanum - chlorine  
   all_rij(17,57) = 3.0d0! Lanthanum - chlorine
   all_rij(57,35) = 3.2d0! Lanthanum - bromine  
   all_rij(35,57) = 3.2d0! Lanthanum - bromine
   all_rij(57,53) = 3.4d0! Lanthanum - iodine  
   all_rij(53,57) = 3.4d0! Lanthanum - iodine
   all_rij(71,6)  = 2.9d0! Lutetium - carbon   
   all_rij(6,71)  = 2.9d0! Lutetium - carbon
   all_rij(71,7)  = 2.6d0! Lutetium - nitrogen   
   all_rij(7,71)  = 2.6d0! Lutetium - nitrogen
!   all_rij(62,8)  = 2.43d0! Samarium - oxygen   
!   all_rij(8,62)  = 2.43d0! Samarium - oxygen
   all_rij(71,8)  = 2.7d0! Lutetium - oxygen   
   all_rij(8,71)  = 2.7d0! Lutetium - oxygen
   all_rij(71,17) = 2.6d0! Lutetium - chlorine
   all_rij(17,71) = 2.6d0! Lutetium - chlorine
   all_rij(71,35) = 2.6d0! Lutetium - bromine
   all_rij(35,71) = 2.6d0! Lutetium - bromine
   all_rij(71,53) = 3.0d0! Lutetium - iodine
   all_rij(53,71) = 3.0d0! Lutetium - iodine
   all_rij(72,6)  = 2.7d0! Hafnium - carbon   
   all_rij(6,72)  = 2.7d0! Hafnium - carbon
   all_rij(72,17) = 2.6d0! Hafnium - chlorine   
   all_rij(17,72) = 2.6d0! Hafnium - chlorine
   all_rij(73,6)  = 2.6d0! Tantalum - carbon   
   all_rij(6,73)  = 2.6d0! Tantalum - carbon
   all_rij(73,16) = 2.6d0! Tantalum - sulfur   
   all_rij(16,73) = 2.6d0! Tantalum - sulfur
   all_rij(74,7)  = 2.4d0! Tungsten - nitrogen 
   all_rij(7,74)  = 2.4d0! Tungsten - nitrogen
   all_rij(74,8)  = 2.6d0! Tungsten - oxygen 
   all_rij(8,74)  = 2.6d0! Tungsten - oxygen
   all_rij(74,35) = 2.7d0! Tungsten - bromine
   all_rij(35,74) = 2.7d0! Tungsten - bromine
   all_rij(74,53) = 3.0d0! Tungsten - iodine
   all_rij(53,74) = 3.0d0! Tungsten - iodine
   all_rij(75,8)  = 2.4d0! Rhenium - oxygen
   all_rij(8,75)  = 2.4d0! Rhenium - oxygen
   all_rij(75,35) = 2.7d0! Rhenium - bromine
   all_rij(35,75) = 2.7d0! Rhenium - bromine
   all_rij(75,53) = 2.9d0! Rhenium - iodine
   all_rij(53,75) = 2.9d0! Rhenium - iodine
   all_rij(76,35) = 2.9d0! Osmium - bromine  
   all_rij(35,76) = 2.9d0! Osmium - bromine
   all_rij(76,53) = 3.0d0! Osmium - iodine  
   all_rij(53,76) = 3.0d0! Osmium - iodine
   all_rij(78,6)  = 2.3d0! Platinum - carbon
   all_rij(6,78)  = 2.3d0! Platinum - carbon
   all_rij(78,7)  = 2.4d0! Platinum - nitrogen
   all_rij(7,78)  = 2.4d0! Platinum - nitrogen 
   all_rij(78,17) = 2.5d0! Platinum - chlorine   
   all_rij(17,78) = 2.5d0! Platinum - chlorine
   all_rij(78,35) = 2.6d0! Platinum - bromine  
   all_rij(35,78) = 2.6d0! Platinum - bromine
   all_rij(78,53) = 2.9d0! Platinum - iodine  
   all_rij(53,78) = 2.9d0! Platinum - iodine
   all_rij(79,6)  = 2.3d0! Gold - carbon   
   all_rij(6,79)  = 2.3d0! Gold - carbon
   all_rij(79,15) = 2.6d0! Gold - phosphorus   
   all_rij(15,79) = 2.6d0! Gold - phosphorus
   all_rij(79,16) = 2.4d0! Gold - sulfur   
   all_rij(16,79) = 2.4d0! Gold - sulfur
   all_rij(79,17) = 2.5d0! Gold - chlorine   
   all_rij(17,79) = 2.5d0! Gold - chlorine
   all_rij(79,35) = 2.7d0! Gold - bromine   
   all_rij(35,79) = 2.7d0! Gold - bromine
   all_rij(79,53) = 2.8d0! Gold - iodine   
   all_rij(53,79) = 2.8d0! Gold - iodine
   all_rij(80,6)  = 2.4d0! Mercury - carbon 
   all_rij(6,80)  = 2.4d0! Mercury - carbon   
   all_rij(80,8)  = 3.0d0! Mercury - oxygen 
   all_rij(8,80)  = 3.0d0! Mercury - oxygen
   all_rij(80,17) = 2.5d0! Mercury - chlorine  
   all_rij(17,80) = 2.5d0! Mercury - chlorine
   all_rij(80,35) = 2.5d0! Mercury - bromine   
   all_rij(35,80) = 2.5d0! Mercury - bromine
   all_rij(80,53) = 2.5d0! Mercury - iodine 
   all_rij(53,80) = 2.5d0! Mercury - iodine
   all_rij(82,8)  = 2.5d0! Thallium - oxygen 
   all_rij(8,81)  = 2.5d0! Thallium - oxygen  
   all_rij(81,17) = 3.1d0! Thallium - chlorine
   all_rij(17,81) = 3.1d0! Thallium - chlorine
   all_rij(81,35) = 3.1d0! Thallium - bromine 
   all_rij(35,81) = 3.1d0! Thallium - bromine
   all_rij(81,53) = 3.1d0! Thallium - iodine
   all_rij(53,81) = 3.1d0! Thallium - iodine
   all_rij(82,6)  = 2.7d0! Lead - carbon
   all_rij(6,82)  = 2.7d0! Lead - carbon
   all_rij(82,8)  = 3.0d0! Lead - oxygen
   all_rij(8,82)  = 3.0d0! Lead - oxygen
   all_rij(82,17) = 3.1d0! Lead - chlorine
   all_rij(17,82) = 3.1d0! Lead - chlorine
   all_rij(82,35) = 3.1d0! Lead - bromine
   all_rij(35,82) = 3.1d0! Lead - bromine
   all_rij(82,35) = 3.3d0! Lead - iodine
   all_rij(53,82) = 3.3d0! Lead - iodine
   all_rij(83,8)  = 2.7d0! Bismuth - oxygen
   all_rij(8,83)  = 2.7d0! Bismuth - oxygen
   all_rij(83,17) = 3.0d0! Bismuth - chlorine
   all_rij(17,83) = 3.0d0! Bismuth - chlorine
   all_rij(83,35) = 3.2d0! Bismuth - bromine
   all_rij(35,83) = 3.2d0! Bismuth - bromine
   all_rij(83,53) = 3.2d0! Bismuth - iodine
   all_rij(53,83) = 3.2d0! Bismuth - iodine
!
!   Special functions
!
!  Cd_present = .false.
!  do i = 1, numat
!    if (labels(i) == 48) Cd_present = .true.
!  end do
!  if (Cd_present) then
!    all_rij(19,7)  = 2.5d0! Potassium - nitrogen
!    all_rij(7,19)  = 2.5d0! Potassium - nitrogen
!    all_rij(19,8)  = 2.5d0! Potassium - oxygen
!    all_rij(8,19)  = 2.5d0! Potassium - oxygen
!  end if
   


   do i = 1, numat
    do j = 1, i - 1
      Rij = all_rij(labels(i),labels(j))      
      sum = dist(coord, i, j, tvec, xtoc, vec)
      if ((labels(i) == 35)) then
        Rij = Rij
      end if
      bonded(i,j) = (sum < Rij .and. (labels(i) /= 1 .or. labels(j) /= 1))
      bonded(j,i) = bonded(i,j)     
    end do
    bonded(i,i) = .true.
  end do
!
! Avoid bridging hydrogens (short hydrogen bonds, etc.)
!
  do i = 1, numat
    if (labels(i) == 1) then
      sum = 1.d10
      do j = 1, numat
        if (.not. bonded(i,j)) cycle
        if (i == j) cycle
        Rij = dist(coord, i, j, tvec, xtoc, vec)
        if (Rij < sum) then
          sum = Rij
          k = j
        end if
      end do
      do j = 1, numat
        bonded(j,i) = (j == k .or. j == i)
      end do
    end if
  end do
!
!  Start making up fragments
!
  used = .false.  
  do i = 1, numat
    if ( .not. used(i)) then 
      fragment = 0
      infrag = 1
      fragment(infrag) = i
      do j = 1, numat
        jj = fragment(j)
        if (jj == 0) exit
        do k = 1, numat
          if (bonded(jj,k) .and. .not. used(k)) then
!
!  atom ii (in the fragment) is bonded to atom k.  Check if k has already been 
!  added to the fragment.
!
            do ii = 1, infrag
              if (fragment(ii) == k) exit
            end do
            if (ii > infrag) then
              infrag = infrag + 1
              fragment(infrag) = k
              bonded_to(infrag) = jj
            end if
          end if
        end do
      end do
!
!  At this point, a complete molecule exists in "fragment".
!  Mark all the atoms as used.
!
      do j = 1, infrag
        used(fragment(j)) = .true.
        do k = 1,3
          coord_local(k,j) = coord(k, fragment(j))
        end do  
      end do
!
!  Join all the atoms together.  Take each atom in turn and find where it's neighbor is.
!
      do ii = 2, infrag
        Rij = dist(coord, fragment(ii), bonded_to(ii), tvec, xtoc, vec)
        do j = 1, ii
          if (fragment(j) == bonded_to(ii)) exit
        end do
        do k = 1, 3
          coord_local(k, ii) = coord_local(k, j) + vec(k)
        end do      
      end do
!
!  Put center of fragment inside the unit cell (stops molecules from being mainly outside the cell)
!
      vec = 0.d0        
      do ii = 1, infrag
        do k = 1,3
          vec(k) = vec(k) + coord_local(k,ii)
        end do       
      end do
      vec = vec / infrag!  vec now holds the center of the molecule
      xyz = 0.d0
      do k = 1, 3        
        do j = 1, id
          xyz(j) = xyz(j) + vec(k) * xtoc(j, k)
        end do
      end do
!
!  If atom 1 is involved, and it's at the origin, do not move fragment
!
      do j = 1, infrag
        if (fragment(j) == 1) exit
      end do
      if (j < infrag + 1) then
        if (coord_local(1,j)**2 + coord_local(2,j)**2 + coord_local(2,j)**2  < 0.1d0) xyz = 0.d0
      end if
!
!   XYZ holds the crystal fractional coordinates of the center
!
      do ii = 1, infrag
        do j = 1, id
          l = Int (xyz(j) + 20.7d0) - 20! was 20.5d0, then 20.7
          do k = 1, 3
            coord_local(k, ii) = coord_local(k, ii) - l * tvec(k, j)
          end do
        end do
      end do
      do ii = 1, infrag
        do k = 1, 3
          coord(k,fragment(ii)) = coord_local(k,ii)
        end do
      end do
    end if
  end do
end subroutine join_bits_together

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine makvec ()
!
!   Construct the starting occupied and virtual localized molecular orbitals.
!   These are on one or two atoms.  The LMOs are stored in
!     Occupied   Virtual
!      cocc        cvir    Coefficients (this is a dilute array)
!      ncocc       ncvir   Starting addresses of LMO coefficients (dense)
!      icocc       icvir   Atoms numbers (this is a dilute array)
!      nncf        nnce    Starting addresses of atom numbers (dense)
!      ncf         nce     Number of atoms in LMOs (dense)
!
    use MOZYME_C, only: iorbs, icocc, icvir, nce, ncf, morb, Lewis_elem, &
         & ncocc, ncvir, nnce, nncf, Lewis_tot, &
         & cocc, cvir, partf, cocc_dim, cvir_dim
!
    use common_arrays_C, only : nfirst, nlast, pdiag, f, p
    use molkst_C, only: numat, norbs, keywrd, moperr, mpack
    implicit none
    logical :: lok, times
    integer :: i, ii, j, jj, k, locc, lvir, m, m1, ne, nf_loc, ni, nj, &
         & nocc, nvir, alloc_stat, nLewis
    double precision, dimension(:,:), allocatable :: catom
    integer, dimension(:), allocatable :: iz, ib
    logical, dimension (:), allocatable :: u
    integer, external :: ijbo
    times = (Index (keywrd, " TIMES") /= 0)
    !***************************************************************
    !
    !  Set up starting eigenvector matrix, based on the Fock matrix
    !  and the type of atom
    !
    !***************************************************************
    p = 0.d0
    m = 0
    do i = 1, numat
      j = ijbo (i, i)
      do k = 1, iorbs(i)
        m = m + 1
        j = j + k
        p(j) = pdiag(m)
      end do
    end do
    if (times) call timer (" After entry to Makvec")
    call buildf (f, partf, 0)
    if (times) call timer (" After BUILDF in MAKV")
   !
    allocate (iz(numat), ib(numat), catom(morb, norbs), u(norbs), stat=alloc_stat)
    if (alloc_stat /= 0) then
      call memory_error ("makvec")
      go to 1200
    end if
   !
    moperr = .false.
!
!   Construct hybrid atomic orbitals for each atom. Put these in catom
!
    call hybrid (catom)
    !
    !     Now to make the starting localized molecular orbitals
    !
    u(:norbs) = .false.
    nocc = 0
    nvir = 0
    nf_loc = 0
    ne = 0
    locc = 0
    lvir = 0
    do nLewis = 1, Lewis_tot
      ii = Lewis_elem(1, nLewis)
      jj = Lewis_elem(2, nLewis)
      if (ii > 0 .and. jj > 0) then
!
! Di-atomic Lewis element
!
        ni = nfirst(ii)
        nj = nfirst(jj)
        call mbonds (locc, lvir, f, catom, nfirst, ii, jj, u(ni), u(nj), &
               & lok, iorbs, cocc, cvir, cocc_dim, cvir_dim, numat, norbs, &
               & morb, mpack)
        if (lok) then
          nncf(nocc+1) = nf_loc
          nnce(nvir+1) = ne
          call mlmo (locc, lvir, ii, jj, nf_loc, ne, nocc, nvir, iz, ib, &
                 & nce, ncf, ncocc, ncvir, iorbs, icocc, icvir, cocc, cvir)
        else
         ii = 0 ! Use for error trap
        end if
      else if (ii > 0) then
!
! Lone pair
!
        do k = nlast(ii), nfirst(ii), -1
          if ( .not. u(k)) then
            u(k) = .true.
            m = locc
            do m1 = 1, iorbs(ii)
              m = m + 1
              cocc(m) = catom(m1, k)
            end do
            nncf(nocc+1) = nf_loc
            call mlmo (locc, lvir, ii, 0, nf_loc, ne, nocc, nvir, iz, ib, &
               & nce, ncf, ncocc, ncvir, iorbs, icocc, icvir, cocc, cvir)
            exit
          end if
        end do
      else
!
! Virtual Lone pair
!
        do k = nlast(jj), nfirst(jj), -1
          if ( .not. u(k)) then
            u(k) = .true.
            m = lvir
            do m1 = 1, iorbs(jj)
              m = m + 1
              cvir(m) = catom(m1, k)
            end do
            nnce(nvir+1) = ne
            call mlmo (locc, lvir, 0, jj, nf_loc, ne, nocc, nvir, iz, ib, &
                 & nce, ncf, ncocc, ncvir, iorbs, icocc, icvir, cocc, cvir)
            exit
          end if
        end do
      end if
    end do
 1200 continue
    if (Allocated (iz))   deallocate ( iz, ib, catom, u)
end subroutine makvec

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

submodule (mopac_api:mopac_api_operations) mopac_api_saveload
  use Common_arrays_C, only: p, pa, pb, nbonds, ibonds
  use molkst_C, only: keywrd, uhf, mpack, numat
  use MOZYME_C, only: iorbs, noccupied, ncf, nvirtual, nce, icocc_dim, &
    icocc, icvir_dim, icvir, cocc_dim, cocc, cvir_dim, cvir, nnce, nncf, ncocc, ncvir
  implicit none

contains

  ! save MOPAC density matrices
  module subroutine mopac_save(state)
    type(mopac_state), intent(inout) :: state

    if (state%mpack > 0) call destroy_mopac_state(state)

    state%mpack = mpack
    if (mpack > 0) then
      state%pa = create_copy(pa, [mpack])
      if (uhf) then
        state%uhf = 1
        state%pb = create_copy(pb, [mpack])
      else
        state%uhf = 0
        state%pb = c_null_ptr
      end if
    end if

  end subroutine mopac_save

  ! load MOPAC density matrices, or construct initial guesses
  module subroutine mopac_load(state)
    type(mopac_state), intent(in) :: state
    integer :: status
    real(c_double), pointer :: rptr(:)

    if(state%mpack > 0) then
      if (state%mpack /= mpack) then
        call mopend("Attempting to load incompatible MOPAC state")
        return
      end if
      keywrd = trim(keywrd) // " OLDENS"
      call c_f_pointer(state%pa, rptr, [mpack])
      pa = rptr
      if (uhf) then
        if (state%uhf == 1) then
          call c_f_pointer(state%pb, rptr, [mpack])
          pb = rptr
        else
          pb = pa
        end if
        p = pa + pb
      else
        p = pa*2.d0
      end if
    end if
  end subroutine mopac_load

  ! save MOZYME density matrix
  module subroutine mozyme_save(state)
    type(mozyme_state), intent(inout) :: state

    if (state%numat > 0) call destroy_mozyme_state(state)

    state%numat = numat
    if (numat > 0) then
      state%noccupied = noccupied
      state%nvirtual = nvirtual
      state%icocc_dim = icocc_dim
      state%icvir_dim = icvir_dim
      state%cocc_dim = cocc_dim
      state%cvir_dim = cvir_dim

      state%nbonds = create_copy(nbonds, [numat])
      state%ibonds = create_copy(ibonds, [9,numat])
      state%iorbs = create_copy(iorbs, [numat])
      state%ncf = create_copy(ncf, [noccupied])
      state%nce = create_copy(nce, [nvirtual])
      state%icocc = create_copy(icocc, [icocc_dim])
      state%icvir = create_copy(icvir, [icvir_dim])
      state%cocc = create_copy(cocc, [cocc_dim])
      state%cvir = create_copy(cvir, [cvir_dim])
    end if
  end subroutine mozyme_save

  ! load MOZYME density matrix, or construct initial guess
  module subroutine mozyme_load(state)
    type(mozyme_state), intent(in) :: state
    integer :: status, i, j, k, l
    integer(c_int), pointer :: iptr(:), iptr2(:,:)
    real(c_double), pointer :: rptr(:)

    if(state%numat > 0) then
      if (state%numat /= numat) then
        call mopend("Attempting to load incompatible MOZYME state")
        return
      end if
      keywrd = trim(keywrd) // " OLDENS"
      numat = state%numat
      noccupied = state%noccupied
      nvirtual = state%nvirtual
      icocc_dim = state%icocc_dim
      icvir_dim = state%icvir_dim
      cocc_dim = state%cocc_dim
      cvir_dim = state%cvir_dim
      if (allocated(nbonds)) deallocate(nbonds)
      if (allocated(ibonds)) deallocate(ibonds)
      if (allocated(iorbs)) deallocate(iorbs)
      if (allocated(ncf)) deallocate(ncf)
      if (allocated(nce)) deallocate(nce)
      if (allocated(icocc)) deallocate(icocc)
      if (allocated(icvir)) deallocate(icvir)
      if (allocated(cocc)) deallocate(cocc)
      if (allocated(cvir)) deallocate(cvir)
      if (allocated(nncf)) deallocate(nncf)
      if (allocated(nnce)) deallocate(nnce)
      if (allocated(ncocc)) deallocate(ncocc)
      if (allocated(ncvir)) deallocate(ncvir)
      allocate(nbonds(numat), stat=status)
      if (status /= 0) then
        call mopend("Failed to allocate memory in MOZYME_LOAD")
        return
      end if
      allocate(ibonds(9,numat), stat=status)
      if (status /= 0) then
        call mopend("Failed to allocate memory in MOZYME_LOAD")
        return
      end if
      allocate(iorbs(numat), stat=status)
      if (status /= 0) then
        call mopend("Failed to allocate memory in MOZYME_LOAD")
        return
      end if
      allocate(ncf(noccupied), stat=status)
      if (status /= 0) then
        call mopend("Failed to allocate memory in MOZYME_LOAD")
        return
      end if
      allocate(nce(nvirtual), stat=status)
      if (status /= 0) then
        call mopend("Failed to allocate memory in MOZYME_LOAD")
        return
      end if
      allocate(icocc(icocc_dim), stat=status)
      if (status /= 0) then
        call mopend("Failed to allocate memory in MOZYME_LOAD")
        return
      end if
      allocate(icvir(icvir_dim), stat=status)
      if (status /= 0) then
        call mopend("Failed to allocate memory in MOZYME_LOAD")
        return
      end if
      allocate(cocc(cocc_dim), stat=status)
      if (status /= 0) then
        call mopend("Failed to allocate memory in MOZYME_LOAD")
        return
      end if
      allocate(cvir(cvir_dim), stat=status)
      if (status /= 0) then
        call mopend("Failed to allocate memory in MOZYME_LOAD")
        return
      end if
      allocate(nncf(noccupied), stat=status)
      if (status /= 0) then
        call mopend("Failed to allocate memory in MOZYME_LOAD")
        return
      end if
      allocate(nnce(nvirtual), stat=status)
      if (status /= 0) then
        call mopend("Failed to allocate memory in MOZYME_LOAD")
        return
      end if
      allocate(ncocc(noccupied), stat=status)
      if (status /= 0) then
        call mopend("Failed to allocate memory in MOZYME_LOAD")
        return
      end if
      allocate(ncvir(nvirtual), stat=status)
      if (status /= 0) then
        call mopend("Failed to allocate memory in MOZYME_LOAD")
        return
      end if
      call c_f_pointer(state%nbonds, iptr, [numat])
      nbonds = iptr
      call c_f_pointer(state%ibonds, iptr2, [9,numat])
      ibonds = iptr2
      call c_f_pointer(state%iorbs, iptr, [numat])
      iorbs = iptr
      call c_f_pointer(state%ncf, iptr, [noccupied])
      ncf = iptr
      call c_f_pointer(state%nce, iptr, [nvirtual])
      nce = iptr
      call c_f_pointer(state%icocc, iptr, [icocc_dim])
      icocc = iptr
      call c_f_pointer(state%icvir, iptr, [icvir_dim])
      icvir = iptr
      call c_f_pointer(state%cocc, rptr, [cocc_dim])
      cocc = rptr
      call c_f_pointer(state%cvir, rptr, [cvir_dim])
      cvir = rptr
      ! reconstruct nncf, nnce, ncocc, & ncvir
      j = 0
      do i = 1, noccupied
        nncf(i) = j
        j = j + ncf(i)
      end do
      j = 0
      do i = 1, nvirtual
        nnce(i) = j
        j = j + nce(i)
      end do
      k = 0
      do i = 1, noccupied
        ncocc(i) = k
        l = 0
        do j = nncf(i) + 1, nncf(i) + ncf(i)
          l = l + iorbs(icocc(j))
        end do
        k = k + l
      end do
      k = 0
      do i = 1, nvirtual
        ncvir(i) = k
        l = 0
        do j = nnce(i) + 1, nnce(i) + nce(i)
          l = l + iorbs(icvir(j))
        end do
        k = k + l
      end do
    else
      call geochk()
    end if
  end subroutine mozyme_load

end submodule mopac_api_saveload

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      double precision function aabbcd (iocca1, ioccb1, iocca2, ioccb2, nmos, &
        xy)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE meci_C, only : ispqr, is, iiloop, jloop
!***********************************************************************
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: nmos
      integer , intent(in) :: iocca1(nmos)
      integer , intent(in) :: ioccb1(nmos)
      integer , intent(in) :: iocca2(nmos)
      integer , intent(in) :: ioccb2(nmos)
      double precision , intent(in) :: xy(nmos,nmos,nmos,nmos)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j, k, l, m, ij
      double precision :: xr
!-----------------------------------------------
!**********************************************************************
!
! AABBCD EVALUATES THE C.I. MATRIX ELEMENT FOR TWO MICROSTATES DIFFERING
!       BY TWO SETS OF M.O.S. ONE MICROSTATE HAS AN ALPHA ELECTRON
!       IN PSI(I) AND A BETA ELECTRON IN PSI(K) FOR WHICH THE OTHER
!       MICROSTATE HAS AN ALPHA ELECTRON IN PSI(J) AND A BETA ELECTRON
!       IN PSI(L)
!
!**********************************************************************
      do i = 1, nmos
        if (iocca1(i) == iocca2(i)) cycle
        exit
      end do
      do j = i + 1, nmos
        if (iocca1(j) == iocca2(j)) cycle
        exit
      end do
      do k = 1, nmos
        if (ioccb1(k) == ioccb2(k)) cycle
        exit
      end do
      do l = k + 1, nmos
        if (ioccb1(l) == ioccb2(l)) cycle
        exit
      end do
      if (i==k .and. j==l .and. iocca1(i)/=ioccb1(i)) then
        ispqr(iiloop,is) = jloop
        is = is + 1
      end if
      if (iocca1(i) < iocca2(i)) then
        m = i
        i = j
        j = m
      end if
      if (ioccb1(k) < ioccb2(k)) then
        m = k
        k = l
        l = m
      end if
      xr = xy(i,j,k,l)
!#      WRITE(IW,'(4I5,F12.6)')I,J,K,L,XR
!
!   NOW UNTANGLE THE MICROSTATES
!
      ij = 1
      if (i>k .and. j>l .or. i<=k .and. j<=l) ij = 0
      if (i > k) ij = ij + iocca1(k) + ioccb1(i)
      if (j > l) ij = ij + iocca2(l) + ioccb2(j)
      if (i > k) then
        m = i
        i = k
        k = m
      end if
      ij = ij + sum(ioccb1(i:k)+iocca1(i:k))
      if (j > l) then
        m = j
        j = l
        l = m
      end if
      ij = ij + sum(ioccb2(j:l)+iocca2(j:l))
!
!   IJ IN THE PERMUTATION NUMBER, .EQUIV. -1 IF IJ IS ODD.
!
      if (mod(ij,2) == 1) xr = -xr
      aabbcd = xr
      return
      end function aabbcd

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine eigen (write_gpt, write_out)
    use molkst_C, only: norbs, numat, nelecs, keywrd
    use chanel_C, only: igpt, iw
    use elemts_C, only: elemnt
    use common_arrays_C, only: eigs, nfirst, nlast, nat, c
    use MOZYME_C, only : icocc, icvir, ncocc, ncvir, nvirtual, noccupied, &
      & nnce, nncf, cocc, cvir, ncf, nce,  cocc_dim, &
      & cvir_dim, icocc_dim, icvir_dim
    implicit none
    logical, intent (in) :: write_gpt, write_out
    integer :: alloc_stat, vec_ao_size
    integer :: i, j, k, l, m
    integer :: print_set, print_first_orbital
    integer :: print_nocc, print_nvir, print_ntot, print_shift
    integer :: print_npanels, print_ncolumns, print_columns_left
    integer, parameter :: print_columns_per_panel = 8
    integer, parameter :: do_occ = 1, do_vir = 2
    integer, parameter :: default_print_nocc = 8
    integer, parameter :: default_print_nvir = 8
    character (len=248) :: tmpkey
    character (len=2), dimension (9), save :: print_orbital_name
    double precision, external :: reada
    data print_orbital_name / "S ", "Px", "Py", "Pz", "x2", "xz", "z2", "yz", "xy" /
    noccupied = nelecs/2
    nvirtual = norbs - noccupied
   !
   ! ==============================
   ! Write eigenvectors to gpt file
   ! ==============================
    if (write_gpt) then
      !
      ! Allocate local arrays
      allocate (c(norbs, norbs), stat=alloc_stat)
      if (alloc_stat /= 0) then
        call memory_error ("eigen")
        goto 1100
      end if
  !
  ! Convert LMOs to Eigenvectors
  !
      call lmo_to_eigenvectors(noccupied, ncf, nncf, ncocc, noccupied, &
           & icocc, icocc_dim, cocc, cocc_dim, eigs, c)
      call lmo_to_eigenvectors(nvirtual, nce, nnce, ncvir, nvirtual, icvir, &
           & icvir_dim, cvir, cvir_dim, eigs(noccupied + 1), c(1, noccupied + 1))
      !
      ! Write out results
      write (igpt) c
    end if
   !
   ! =================================================
   ! Write eigenvalues and eigenvectors to output file
   ! =================================================
    if (write_out) then
      !
      ! Determine how much needs to be written out
      if (Index (keywrd, " ALLVEC") /= 0) then
        !
        ! Everything requested
        print_nocc = noccupied
        print_nvir = nvirtual
      else if ((Index (keywrd, " VECTORS(") /= 0) .or. &
             & (Index (keywrd, " VECTORS=(") /= 0)) then
        !
        ! User has requested limits
        !
        ! Extract user limits from keyword string
        !
        ! Build temporary keyword string, and erase all text from it
        ! except VECTORS data
        tmpkey = trim(keywrd)
        i = Index (tmpkey, "VECTORS=(") + Index (tmpkey, "VECTORS(")
        tmpkey (:i) = " "
        j = Index (tmpkey, ")")
        tmpkey (j:) = " "
        ! Extract number of occupied orbitals to be written out
        print_nocc = Nint (reada (tmpkey, i))
        ! Extract number of virtual orbitals to be written out
        i = Index (tmpkey, ",") + Index (tmpkey, ":")
        if (i /= 0) then
          print_nvir = Nint (reada (tmpkey, i + 1))
        else
          print_nvir = default_print_nvir
        end if
      else
        !
        ! Use defaults
        print_nocc = default_print_nocc
        print_nvir = default_print_nvir
      end if
     !
     ! Make sure number of orbitals requested is no larger than
     ! the number available
      print_nocc = Max (0, Min (print_nocc, noccupied))
      print_nvir = Max (0, Min (print_nvir, nvirtual))
      print_ntot = print_nocc + print_nvir
      if (print_ntot > 0) then
        if (.not. write_gpt) then
          !
          ! Allocate local arrays
          vec_ao_size = Max (noccupied, nvirtual)
          allocate (c(norbs, vec_ao_size), stat=alloc_stat)
          if (alloc_stat /= 0) then
            call memory_error ("eigen")
            goto 1100
          end if
        end if
        c = 0.d0
        do print_set = do_occ, do_vir
          if (.not. write_gpt) then
            !
            ! Convert LMOs to Eigenvectors
            !
            if (print_set == do_occ) then
              call lmo_to_eigenvectors(noccupied, ncf, nncf, ncocc, noccupied, &
           & icocc, icocc_dim, cocc, cocc_dim, eigs, c)
              print_shift = noccupied - print_nocc
            else
              call lmo_to_eigenvectors(nvirtual, nce, nnce, ncvir, nvirtual, &
           & icvir, icvir_dim, cvir, cvir_dim, eigs, c)
              print_shift = 0
            end if
          else
            if (print_set == do_occ) then
              print_shift = noccupied - print_nocc
            else
              print_shift = noccupied
            end if
          end if
          !
          ! Write out results
          !
          ! Find number of print panels
          if (print_set == do_occ) then
            write (iw, "(/'  Occupied Orbitals'/)")
            print_first_orbital = noccupied - print_nocc
            print_npanels = 1 + (print_nocc - 1) / print_columns_per_panel
            print_columns_left = print_nocc
          else
            write (iw, "(/'  Virtual Orbitals'/)")
            print_first_orbital = noccupied
            print_npanels = 1 + (print_nvir - 1) / print_columns_per_panel
            print_columns_left = print_nvir
          end if
          !
          ! For each panel ...
          do i = 1, print_npanels
            !
            ! Evaluate how many columns to print in this panel
            if (print_columns_left >= print_columns_per_panel) then
              print_ncolumns = print_columns_per_panel
            else
              print_ncolumns = print_columns_left
            end if
            print_columns_left = print_columns_left - print_ncolumns
            !
            ! Print header for this panel
            write (iw, "(//'    Root No.')", advance="no")
            do j = 1, print_ncolumns
              write (iw, "(i6,'  ')", advance="no") print_first_orbital + &
                  & (i - 1) * print_columns_per_panel + j
            end do
            write (iw, "(/)")
            !
            ! Print eigenvalues
            write (iw, "('            ')", advance="no")
            do j = 1, print_ncolumns
              write (iw, "(f8.3)", advance="no") eigs(print_shift + &
                  & (i - 1) * print_columns_per_panel + j)
            end do
            write (iw, "(/)")
            !
            ! Print Eigenvectors
            k = 1
            do l = 1, numat
              do m = 1, 1 + nlast(l) - nfirst(l)
                write (iw, "(' ',a2,' ',a2,' ',i5)", advance="no") &
                    & print_orbital_name(m), elemnt(nat(l)), l
                do j = 1, print_ncolumns
                  write (iw, "(f8.4)", advance="no") c &
                 & (k, print_shift + (i - 1) * print_columns_per_panel + j)
                end do
                write (iw, "(' ')")
                k = k + 1
              end do
            end do
          end do
        end do
      end if
    end if
1100 continue
end subroutine eigen
subroutine FlmoFromFao (nlmo, ncx, nncx, ncxxx, n_dim, &
     & latoms, ws, icxxx, icxxx_dim, cxxx, cxxx_dim, &
     & ac, fmo_expanded)
  use molkst_C, only: numat, norbs
  use common_arrays_C, only : f, nfirst, nlast
  use MOZYME_C, only : lijbo, nijbo, iorbs
  !
  !.. Implicit Declarations ..
  implicit none
  !
  !.. Formal Arguments ..
  integer, intent (in) :: nlmo, icxxx_dim, cxxx_dim, n_dim
  logical, dimension (numat), intent (out) :: latoms
  integer, dimension (n_dim), intent (in) :: ncx, ncxxx, nncx
  integer, dimension (icxxx_dim), intent (in) :: icxxx
  double precision, dimension (nlmo * nlmo), intent (out) :: fmo_expanded
  double precision, dimension (norbs), intent (out) :: ws
  double precision, dimension (cxxx_dim), intent (in) :: cxxx
  double precision, dimension (numat), intent (out) :: ac
  integer :: i, i1, i2, i4, ii, j, j1, j2, &
       & jj, jx, k, k1, kk, kl, l, loopi, loopj, kj
  integer :: i1j1, i1j2, i2j1, i2j2
  integer :: k_fmo
  double precision :: flim, sum, cutoff
  integer, external :: ijbo

  ! Tolerance parameters
  flim = 1.0d-8
  cutoff = 1.0d-8
  !
  ! For each lmo do ...
  fmo_expanded = 0.0d0
  k_fmo = 1
  do i = 1, nlmo
    loopi = ncxxx(i)
    !
    ! Evaluate weight on each atom from lmo and build list of flags
    ! indicating if atoms exist in the lmo
    do j = 1, numat
      latoms(j) = .false.
    end do
    l = 0
    do j = nncx(i) + 1, nncx(i) + ncx(i)
      j1 = icxxx(j)
      sum = 0.d0
      do k = l + 1, l + iorbs(j1)
        sum = sum + cxxx(k+loopi) ** 2
      end do
      ac(j1) = sum
      latoms(j1) = .true.
      l = l + iorbs(j1)
    end do
    !
    ! Evaluate F * C
    !
    ! For each atom in the lmo do ...
    do jj = nncx(i) + 1, nncx(i) + ncx(i)
      j1 = icxxx(jj)
      do jx = 1, iorbs(j1)
        ws(nfirst(j1)+jx-1) = 0.0d00
      end do
      kl = loopi
      !
      ! For each neighboring atom in the lmo do ...
      do kk = nncx(i) + 1, nncx(i) + ncx(i)
        k1 = icxxx(kk)
        if (lijbo) then
          kj = nijbo (k1, j1)
        else
          kj = ijbo (k1, j1)
        end if
        !
        ! If the neighbor contributes to the lmo then evaluate
        ! contribution to F * C
        if (kj >= 0) then
          if (ac(k1) > cutoff) then
            if (iorbs(k1) .eq. 1 .and. iorbs(j1) .eq. 1) then
              ws(nfirst(j1)) = ws(nfirst(j1)) + f(kj+1) * cxxx(kl+1)
            else
              if (k1 > j1) then
                ii = kj
                do i4 = 1, iorbs(k1)
                  do jx = 1, iorbs(j1)
                    ii = ii + 1
                    ws(nfirst(j1)+jx-1) = ws(nfirst(j1)+jx-1) + f(ii) &
                         & * cxxx(kl+i4)
                  end do
                end do
              else if (k1 < j1) then
                ii = kj
                do jx = 1, iorbs(j1)
                  do i4 = 1, iorbs(k1)
                    ii = ii + 1
                    ws(nfirst(j1)+jx-1) = ws(nfirst(j1)+jx-1) + f(ii) &
                         & * cxxx(kl+i4)
                  end do
                end do
              else
                do jx = 1, iorbs(j1)
                  do i4 = 1, iorbs(j1)
                    ii = kj + (jx*(jx-1)) / 2 + i4
                    if (i4 .gt. jx) ii = kj + (i4*(i4-1)) / 2 + jx
                    ws(nfirst(j1)+jx-1) = ws(nfirst(j1)+jx-1) + f(ii) &
                         & * cxxx(kl+i4)
                  end do
                end do
              end if
            end if
          end if
        end if
        kl = kl + iorbs(k1)
      end do
    end do
    !
    ! Evaluate C * (F * C)
    i1 = icxxx(nncx(i)+1)
    if (ncx(i) > 1) then
      i2 = icxxx(nncx(i)+2)
    else
      i2 = i1
    end if
    !
    ! For each second orbital do ...
    do j = 1, i
        !
        ! FAST TEST TO SEE IF THE INTEGRAL IS WORTH EVALUATING
        j1 = icxxx(nncx(j)+1)
        if (ncx(j) > 1) then
          j2 = icxxx(nncx(j)+2)
        else
          j2 = j1
        end if
        if (lijbo) then
          i1j1 = nijbo (i1, j1)
          i1j2 = nijbo (i1, j2)
          i2j1 = nijbo (i2, j1)
          i2j2 = nijbo (i2, j2)
        else
          i1j1 = ijbo (i1, j1)
          i1j2 = ijbo (i1, j2)
          i2j1 = ijbo (i2, j1)
          i2j2 = ijbo (i2, j2)
        end if
        if (i1j1 >= 0 .or. i1j2 >= 0 .or. i2j1 >= 0 .or. i2j2 >= 0) &
             & then
          sum = 0.d0
          if (i1j1 >= 0) then
            sum = Abs (f(i1j1+1))
          end if
          if (i1j2 >= 0) then
            sum = sum + Abs (f(i1j2+1))
          end if
          if (i2j1 >= 0) then
            sum = sum + Abs (f(i2j1+1))
          end if
          if (i2j2 >= 0) then
            sum = sum + Abs (f(i2j2+1))
          end if
          !
          ! If test passed, build C * (F * C)
          if (sum >= flim) then
            loopj = ncxxx(j)
            sum = 0.d0
            kl = 0
            !
            ! For each atom in second lmo do ...
            do kk = nncx(j) + 1, nncx(j) + ncx(j)
              k1 = icxxx(kk)
              !
              ! If atom in first lmo, add contribution to C * (F * C)
              if (.not. latoms(k1)) then
                kl = kl + iorbs(k1)
              else
                do k = nfirst(k1), nlast(k1)
                  kl = kl + 1
                  sum = sum + ws(k) * cxxx(kl+loopj)
                end do
              end if
            end do
            !
            ! Store final integral
            fmo_expanded (k_fmo) = sum
          end if
        end if
        k_fmo = k_fmo + 1
    end do
  end do
end subroutine FlmoFromFao

!-------------------------------------------------------------------------------

subroutine eigen_limits (print_nocc, print_nvir)
   !
   ! This routine evaluates the number of occupied and virtual orbitals
   ! to be written out to the output file.
    use molkst_C, only: norbs, nelecs, keywrd
    implicit none
    integer, intent (inout) :: print_nocc, print_nvir
    integer :: i, j
    integer :: noccupied, nvirtual
    integer, parameter :: default_print_nocc = 8
    integer, parameter :: default_print_nvir = 8
    character (len=248) :: tmpkey
    double precision, external :: reada
    noccupied = nelecs/2
    nvirtual = norbs - noccupied
    if (Index (keywrd, " ALLVEC") /= 0) then
      !
      ! Everything requested
      print_nocc = noccupied
      print_nvir = nvirtual
    else if ((Index (keywrd, " VECTORS(") /= 0) .or. &
           & (Index (keywrd, " VECTORS=(") /= 0)) then
      !
      ! User has requested limits
      !
      ! Extract user limits from keyword string
      !
      ! Build temporary keyword string, and erase all text from it
      ! except VECTORS data
      tmpkey = trim(keywrd)
      i = Index (tmpkey, "VECTORS=(") + Index (tmpkey, "VECTORS(")
      tmpkey (:i) = " "
      j = Index (tmpkey, ")")
      tmpkey (j:) = " "
      ! Extract number of occupied orbitals to be written out
      print_nocc = Nint (reada (tmpkey, i))
      ! Extract number of virtual orbitals to be written out
      i = Index (tmpkey, ",") + Index (tmpkey, ":")
      if (i /= 0) then
        print_nvir = Nint (reada (tmpkey, i + 1))
      else
        print_nvir = default_print_nvir
      end if
    else
      !
      ! Use defaults
      print_nocc = default_print_nocc
      print_nvir = default_print_nvir
    end if
   !
   ! Make sure number of orbitals requested is no larger than
   ! the number available
    print_nocc = Max (0, Min (print_nocc, noccupied))
    print_nvir = Max (0, Min (print_nvir, nvirtual))
end subroutine eigen_limits
subroutine lmo_to_eigenvectors(nlmo, ncx, nncx, ncxxx, n_dim, &
     & icxxx, icxxx_dim, cxxx, cxxx_dim, eigs, c)
  use molkst_C, only : numat, norbs
  use common_arrays_C, only : nfirst, nlast
  implicit none
  integer, intent (in) :: nlmo, icxxx_dim, cxxx_dim, n_dim
  integer, dimension (n_dim), intent (in) :: ncx, ncxxx, nncx
  integer, dimension (icxxx_dim), intent (in) :: icxxx
  double precision, dimension (norbs), intent (out) :: eigs
  double precision, dimension (norbs, nlmo), intent (out) :: c
  double precision, dimension (cxxx_dim), intent (in) :: cxxx
!
  integer :: i, ka, jj, j, k, l
  double precision, dimension(:), allocatable :: fmo_expanded, &
  vec_lmo, c_lmo, ws, ac
  logical, allocatable, dimension (:) :: latoms
  allocate (fmo_expanded (nlmo*nlmo), vec_lmo(nlmo*nlmo), c_lmo(norbs), &
         & latoms(numat), ws(norbs), &
         & ac(numat), stat=i)

  if (i /= 0) then
    call memory_error ("DiagonaliseFockLMOScheme")
    return
  end if
  call FlmoFromFao (nlmo, ncx, nncx, ncxxx, nlmo, &
           & latoms, ws, icxxx, icxxx_dim, cxxx, cxxx_dim, &
           & ac, fmo_expanded)
!
! Diagonalise Fock matrix
   call rsp(fmo_expanded, nlmo, eigs, vec_lmo)
!
! Reconstruct eigenvectors in AO basis
!
   c(:norbs,:nlmo) = 0.d0
  do i = 1, nlmo
    !
    ! Expand i'th LMO into uncompressed format
    c_lmo = 0.d0
    ka = ncxxx(i)
    do jj = nncx(i) + 1, nncx(i) + ncx(i)
      j = icxxx(jj)
      do k = nfirst(j), nlast(j)
        ka = ka + 1
        c_lmo(k) = cxxx(ka)
      end do
    end do
    !
    ! Add contribution from i'th LMO to all eigenstates
    !
    do k = 1, norbs
      if (Abs (c_lmo(k)) > 1.0d-10) then
        l = i
        do j = 1, nlmo
          c(k,j) = c(k,j) + vec_lmo(l) * c_lmo(k)
          l = l + nlmo
        end do
      end if
    end do
  end do
  deallocate (fmo_expanded, vec_lmo, c_lmo, latoms, ws, ac)
  end subroutine lmo_to_eigenvectors

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine ionout (ions, m, num)
    use molkst_C, only: natoms, numat, maxtxt
    use chanel_C, only: iw
    use elemts_C, only: elemnt
    use common_arrays_C, only : na, nb, nc, txtatm, labels
    implicit none
    integer, intent (in) :: m, num
    integer, dimension (4, num), intent (in) :: ions
!
    integer, dimension (:), allocatable :: nlabels
    character (len=40) :: blank
    logical :: Int
    integer :: i, j, klim, nabc11, il, iu
    intrinsic Min
    allocate(nlabels(natoms))
    j = 0
    do i = 1, natoms
      if (labels(i) /= 99) j = j + 1
      nlabels(i) = j
    end do
    j = Min (3, numat)
    do i = 1, j
      if (na(i) /= 0) then
        Int = .true.
        klim = 3
        go to 1000
      end if
    end do
    Int = .false.
    klim = 0
1000 blank = " "
    i = maxtxt + 5
    if (i /= 5) then
      i = i + 5
    end if
    write (iw,*)
    if (Int) then
      write (iw, "('     ION   ATOM   WITH   TYPE',A,' CONNECTIVITY')") blank (:i)
      write (iw, "('            No.  DUMMYS')")
    else
      write (iw, "('     ION   ATOM   WITH   TYPE')") 
      write (iw, "('            No.  DUMMYS')")
    end if
   
    nabc11 = na(1)
    na(1) = 0
    if (m /= 3) then
      if (maxtxt /= 0) then
        do i = 1, num
          j = ions(m, i)
          if (txtatm(j)(1:1) == "(") then
          il = 2
          iu = maxtxt - 1
        else
          il = 1
          iu = maxtxt
        end if
          write (iw, "(3I7,3X,A2,'(',A,')',3I7)") i, nlabels(j), j, &
         & elemnt (labels(j)), txtatm(j) (il:iu), na(j), nb(j), nc(j)
        end do
      else
        do i = 1, num
          j = ions(m, i)
          write (iw, "(3I7,3X,A2,3I7)") i,  nlabels(j), j, &
         & elemnt (labels(j)), na(j), nb(j), nc(j)
        end do
      end if
    else if (maxtxt /= 0) then
      do i = 1, num
        j = ions(m, i)
        if (txtatm(j)(1:1) == "(") then
          il = 2
          iu = maxtxt - 1
        else
          il = 1
          iu = maxtxt
        end if
        if (klim == 0) then
          write (iw, "(3I7,3X,A2,'(',A,')',A,SP,I2)") i, nlabels(j), j, elemnt &
         & (labels(j)), txtatm (j) (il:iu), "  CHARGE: ", ions (4, i)
        else
          write (iw, "(3I7,3X,A2,'(',A,')',A,SP,I2,3I7)") i, nlabels(j), j, elemnt &
         & (labels(j)), txtatm (j) (il:iu), "  CHARGE: ", ions (4, i), &
         &  na(j), nb(j), nc(j)
        end if
      end do
    else
      do i = 1, num
        j = ions(m, i)
        if (klim == 0) then
          write (iw, "(3I7,3X,A2,A,SP,I2)") i, nlabels(j), j, elemnt (labels(j)), &
         & "  CHARGE: ", ions (4, i)
        else
          write (iw, "(3I7,3X,A2,3I7,A,SP,I2)") i, nlabels(j), j, elemnt (labels(j)), &
         &  na(j), nb(j), nc(j), "  CHARGE: ", ions (4, i)
        end if
      end do
    end if
    na(1) = nabc11
    deallocate(nlabels)
end subroutine ionout

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

double precision function parips (eigs, loop)
    use molkst_C, only : norbs, nopen, nclose, nalpha
    use param_global_C, only : lions
    implicit none
    integer, intent(in) :: loop
    double precision, dimension (norbs), intent (in) :: eigs
    if(nclose /= 0) then
!
!  Only allow for higher IPs for closed-shell systems
!
      parips = -eigs(lions(loop))
      if (nopen /= nclose) then
           parips = Min (parips,-eigs(nopen))
      end if
    elseif (nalpha > 0) then
      parips = -eigs(nalpha)
    else
      parips = 0.d0
    end if
end function parips

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

   subroutine rys(x, nroots, u, w)
    double precision :: x, u(4), w(4)
    integer nroots
    double precision :: &
    pie4 = 7.85398163397448d-01, &
    r12  = 2.75255128608411d-01, &
    w22  = 9.17517095361369d-02, &
    r22  = 2.72474487139158d+00, &
    Ex, f1, y
    u = 0.d0
    w = 0.d0
    if (x > 33.d0) then
      w(1) = sqrt(pie4/x)
      if (nroots == 1) then
        u(1) = 0.5d0/(x - 0.5d0)
        w(1) = sqrt(pie4/x)
      else
        if (x > 40.d0) then
          u(1) = r12/(x-r12);
          u(2) = r22/(x-r22);
          w(2) = w22*w(1);
          w(1) = w(1)-w(2);
        else
          Ex =  exp(-x);
          u(1)=(-8.78947307498880d-01*x + 1.09243702330261d+01)*Ex + r12/(x-r12)
          u(2)=(-9.28903924275977d+00*x + 8.10642367843811d+01)*Ex + r22/(x-r22)
          w(2)=( 4.46857389308400d+00*x - 7.79250653461045d+01)*Ex + w22*w(1)
          w(1)=w(1)-w(2)
        end if
      end if
    else if (x > 15.d0) then
      ex = exp(-x)
      w(1) = ((( 1.9623264149430d-01/x -4.9695241464490d-01)/x - &
      6.0156581186481d-05)*ex + sqrt(pie4/x))
      f1 =(w(1) - ex)/(2.d0*x)
      if (nroots == 1) then
        u(1) = f1/(w(1) - f1)
      else
        u(1) = ((((-1.14906395546354d-06*x + 1.76003409708332d-04)*x - &
            1.71984023644904d-02)*x -1.37292644149838d-01)*x + &
            (-4.75742064274859d+01/x + 9.21005186542857d+00)/x - &
            2.31080873898939d-02)*Ex + r12/(x-r12)
        u(2) = ((( 3.64921633404158d-04*x - 9.71850973831558d-02)*x - &
            4.02886174850252d+00)*x + &
            (-1.35831002139173d+02/x -8.66891724287962d+01)/x + &
            2.98011277766958d+00)*Ex + r22/(x-r22)
         w(2) = ((f1 - w(1)) * u(1) + f1)*(1.0d0 + u(2))/(u(2) - u(1))
         w(1) = w(1)-w(2)
      end if
    else if (x > 10.d0) then
      ex = exp(-x)
      w(1) =((((-1.8784686463512d-01/x + 2.2991849164985d-01)/x - &
      4.9893752514047d-01)/x  -2.1916512131607d-05)*ex + &
      sqrt(pie4/x))
      f1 =(w(1) - ex)/(2.d0*x)
      if (nroots == 1) then
        u(1) = f1/(w(1) - f1)
      else
        u(1) = ((((-1.01041157064226d-05*x &
              +1.19483054115173d-03)*x &
               -6.73760231824074d-02)*x &
               +1.25705571069895d+00)*x &
               +(((-8.57609422987199d+03/x &
               +5.91005939591842d+03)/x &
            -1.70807677109425d+03)/x &
            +2.64536689959503d+02)/x &
            -2.38570496490846d+01)*Ex  &
            + r12/(x-r12)
         u(2) = ((( 3.39024225137123d-04*x &
             -9.34976436343509d-02)*x &
            -4.22216483306320d+00)*x  &
            +(((-2.08457050986847d+03/x &
            -1.04999071905664d+03)/x &
            +3.39891508992661d+02)/x &
            -1.56184800325063d+02)/x &
            +8.00839033297501d+00)*Ex  &
            + r22/(x-r22)
         w(2) = ((f1 - w(1))*u(1) + f1)*(1.d0 + u(2))/(u(2) - u(1))
         w(1) = w(1) - w(2)
      end if
    else if (x > 5.d0) then
      ex = exp(-x)
      w(1)= ((((((( 4.6897511375022d-01/x-6.9955602298985d-01)/x + &
      5.3689283271887d-01)/x-3.2883030418398d-01)/x - &
      2.4645596956002d-01)/x-4.9984072848436d-01)/x - 3.1501078774085d-06)*ex + &
      sqrt(pie4/x))
      f1 =(w(1) - ex)/(2.d0*x)
      if (nroots == 1) then
        u(1) = f1/(w(1) - f1)
      else
        y=x-7.5d0
        u(1)= (((((((((((((-1.43632730148572d-16*y+2.38198922570405d-16)*y + &
        1.358319618800d-14)*y-7.064522786879d-14)*y &
      -7.719300212748d-13 &
          )*y+7.802544789997d-12)*y+6.628721099436d-11)*y &
      -1.775564159743d-09 &
          )*y+1.713828823990d-08)*y-1.497500187053d-07)*y &
      +2.283485114279d-06 &
          )*y-3.76953869614706d-05)*y+4.74791204651451d-04 &
          )*y-4.60448960876139d-03)*y+3.72458587837249d-02
         u(2)= (((((((((((( 2.48791622798900d-14*y-1.36113510175724d-13 &
          )*y-2.224334349799d-12)*y+4.190559455515d-11)*y &
      -2.222722579924d-10 &
          )*y-2.624183464275d-09)*y+6.128153450169d-08)*y &
      -4.383376014528d-07 &
          )*y-2.49952200232910d-06)*y+1.03236647888320d-04 &
          )*y-1.44614664924989d-03)*y+1.35094294917224d-02 &
          )*y-9.53478510453887d-02)*y+5.44765245686790d-01
         w(2)=((f1-w(1))*u(1)+f1)*(1.0d0+u(2))/(u(2)-u(1))
         w(1)=w(1)-w(2)
      end if
    else if (x > 3.d0) then
      y = x - 4.d0;
      f1= ((((((((((-2.62453564772299d-11*y + 3.24031041623823d-10)*y - &
      3.614965656163d-09)*y + 3.760256799971d-08)*y - 3.553558319675d-07)*y + &
      3.022556449731d-06)*y - 2.290098979647d-05)*y + 1.526537461148d-04)*y - &
      8.81947375894379d-04)*y + 4.33207949514611d-03)*y - &
      1.75257821619926d-02)*y + 5.28406320615584d-02
      w(1) = 2.d0*x*f1 + exp(-x)
      if (nroots == 1) then
        w(1) = 2.d0*x*f1 + exp(-x)
        u(1) = f1/(w(1)-f1)
      else
        u(1)= ((((((((-4.11560117487296d-12*y+7.10910223886747d-11)*y &
        -1.73508862390291d-09)*y+5.93066856324744d-08)*y &
        -9.76085576741771d-07)*y+1.08484384385679d-05)*y &
        -1.12608004981982d-04)*y+1.16210907653515d-03)*y &
        -9.89572595720351d-03)*y+6.12589701086408d-02
           u(2)= (((((((((-1.80555625241001d-10*y+5.44072475994123d-10)*y &
        +1.603498045240d-08)*y-1.497986283037d-07)*y-7.017002532106d-07)*y &
        +1.85882653064034d-05)*y-2.04685420150802d-05)*y &
        -2.49327728643089d-03)*y+3.56550690684281d-02)*y &
        -2.60417417692375d-01)*y+1.12155283108289d+00
        w(2)=((f1-w(1))*u(1)+f1)*(1.0d0+u(2))/(u(2)-u(1))
        w(1)=w(1) - w(2)
      end if
    else if (x > 1.d0) then
      y=x-2.0d0
      f1= ((((((((((-1.61702782425558d-10*y + 1.96215250865776d-09)*y - &
      2.14234468198419d-08)*y + 2.17216556336318d-07)*y - &
      1.98850171329371d-06)*y + 1.62429321438911d-05)*y - &
      1.16740298039895d-04)*y + 7.24888732052332d-04)*y - &
      3.79490003707156d-03)*y + 1.61723488664661d-02)*y - &
      5.29428148329736d-02)*y + 1.15702180856167d-01
      w(1) = 2.d0*x*f1 + exp(-x)
      if (nroots == 1) then
        u(1) = f1/(w(1)-f1)
      else
        u(1) = (((((((((-6.36859636616415d-12*y+8.47417064776270d-11) * y &
        -5.152207846962d-10)*y-3.846389873308d-10)*y+8.472253388380d-08) * y &
        -1.85306035634293d-06)*y+2.47191693238413d-05) * y &
        -2.49018321709815d-04)*y+2.19173220020161d-03) * y &
        -1.63329339286794d-02)*y+8.68085688285261d-02
          u(2) = (((((((((1.45331350488343d-10*y+2.07111465297976d-09) * y &
        -1.878920917404d-08)*y - 1.725838516261d-07)*y+2.247389642339d-06) * y &
        +9.76783813082564d-06)*y - 1.93160765581969d-04) * y &
        -1.58064140671893d-03)*y + 4.85928174507904d-02) * y &
        -4.30761584997596d-01)*y + 1.80400974537950d+00
          w(2) = ((f1-w(1))*u(1)+f1)*(1.0d0+u(2))/(u(2)-u(1))
          w(1) = w(1)-w(2)
      end if
    else if (x > 3.d-7) then
      f1= ((((((((-8.36313918003957d-08*x + 1.21222603512827d-06)*x - &
      1.15662609053481d-05)*x + 9.25197374512647d-05)*x - &
      6.40994113129432d-04)*x + 3.78787044215009d-03)*x - &
      1.85185172458485d-02)*x + 7.14285713298222d-02)*x - &
      1.99999999997023d-01)*x + 3.33333333333318d-01
      w(1) = 2.d0*x*f1 + exp(-x)
      if (nroots == 1) then
        u(1) = f1/(w(1)-f1)
      else
        u(1) = (((((((-2.35234358048491d-09*x + 2.49173650389842d-08) &
             *x - 4.558315364581d-08)*x - 2.447252174587d-06)*x + 4.743292959463d-05) &
             *x - 5.33184749432408d-04)*x + 4.44654947116579d-03) &
             *x - 2.90430236084697d-02)*x + 1.30693606237085d-01
            u(2) = (((((((-2.47404902329170d-08*x + 2.36809910635906d-07) &
             *x + 1.835367736310d-06)*x - 2.066168802076d-05)*x - 1.345693393936d-04) &
             *x - 5.88154362858038d-05)*x + 5.32735082098139d-02) &
             *x - 6.37623643056745d-01)*x + 2.86930639376289d+00
            w(2)=((f1-w(1))*u(1)+f1)*(1.0d0+u(2))/(u(2)-u(1))
            w(1)=w(1) - w(2)
      end if
    else
!
!  NOT verified!
!
      if (nroots == 1) then
        u(1) = 0.5d0 - x/5.0d0
        w(1) = 1.0d0 - x/3.0d0
      else
        u(1) = 1.30693606237085d-01 - 2.90430236082028d-02*x
        u(2) = 2.86930639376291d+00 - 6.37623643058102d-01*x
        w(1) = 6.52145154862545d-01 - 1.22713621927067d-01*x
        w(2) = 3.47854845137453d-01 - 2.10619711404725d-01*x
      end if
    end if
    return
  end subroutine rys

  subroutine vint(xint, yint, zint, ni, nj, x0, y0, z0, xi, yi, zi, xj, yj, zj, t)
!
!  Gauss-Hermite Quadrature
!
    double precision, intent (in) :: x0, y0, z0, xi, yi, zi, xj, yj, zj, t
    double precision, intent (out) :: xint, yint, zint
    integer, intent (in) :: ni, nj
!
!  Local variables
!
    double precision :: dum, ptx, pty, ptz, ax, ay, az, bx, by, bz, px, py, pz
    integer ::  i, j, min, max, npt
    double precision :: Hermite_roots(21) = (/ &
                   0.0d0,                                                      & ! 1
                  -0.7071067811865d0,  0.7071067811865d0,                      & ! 2
                  -1.224744871391d0,   0.0d0,              1.2247448713915d0,  & ! 3
                  -1.6506801238857d0, -0.52464762327529d0, 0.52464762327529d0, & ! 4
                     1.6506801238857d0,                                        &
                  -2.020182870456d0,  -0.9585724646138d0,  0.0d0,              & ! 5
                        0.9585724646138d0,  2.020182870456d0,                  &
                  -2.350604973674d0,  -1.335849074014d0,  -0.436077411928d0,   & ! 6
                        0.436077411928d0,   1.335849074014d0,   2.350604973674d0 /)

    double precision ::   Hermite_weights(21)  = (/ &
            1.772453850905d0,                                                  & ! 1
            0.886226925452d0,     0.886226925452d0,                            & ! 2
            0.295408975150d0,     1.18163590060d0,      0.295408975150d0,      & ! 3
            8.131283544725d-02, 0.8049140900055d0,    8.049140900055d-01,      & ! 4
              8.131283544725d-02,                                              &
            1.995324205905d-02, 3.936193231522d-01, 9.453087204829d-01,        & ! 5
              3.936193231522d-01, 1.995324205905d-02,                          &
            4.530009905509d-03, 1.570673203229d-01, 7.246295952244d-01,        & ! 6
            7.246295952244d-01, 1.570673203229d-01, 4.530009905509d-03 /)
    integer :: start_index(6) = (/ 0, 1, 3, 6, 10, 15/), &
                 end_index(6) = (/ 0, 2, 5, 9, 14, 20/)


    xint = 0.0d0
    yint = 0.0d0
    zint = 0.0d0

    npt  = (ni + nj)/2 + 1      ! form the index into the start_index array
    min  = start_index(npt) + 1 ! get the starting index in the roots,weights arrays.
    max  = end_index(npt) + 1   ! get the ending index in the roots,weights arrays.

    do i = min, max
      px   = 1.0d0
      py   = 1.0d0
      pz   = 1.0d0
      dum  = Hermite_roots(i) * t
      ptx  = dum + x0
      pty  = dum + y0
      ptz  = dum + z0
      ax   = ptx - xi
      ay   = pty - yi
      az   = ptz - zi
      bx   = ptx - xj
      by   = pty - yj
      bz   = ptz - zj

      do j = 2, ni
        px = px*ax
        py = py*ay
        pz = pz*az
      end do

      do j = 2, nj
        px = px*bx
        py = py*by
        pz = pz*bz
      end do
      dum    = Hermite_weights(i)
      xint = xint + dum * px
      yint = yint + dum * py
      zint = zint + dum * pz
    end do
  end subroutine vint

  subroutine get_minus_point_five_overlap(s)
  use molkst_C, only : numat, norbs
  use common_arrays_C, only: nfirst, nlast, nat, h, &
                           & i1fact
  use parameters_C, only : betas, betap, betad
  implicit none
  double precision, dimension(norbs**2) :: s
  !
  !.. Local Scalars ..
  integer :: i, if, ii, ij, il, im1, j, jf, jj, jl, k, &
       & alloc_stat
  double precision :: bi, bj, sum
  !.. Local Arrays ..
  double precision, dimension (:), allocatable :: eigs, vecs
!

  !
  !
  !.. Intrinsic Functions ..
  intrinsic Abs, Sqrt
  !
  ! ... Executable Statements ...
  !
  !     PATAS
  !*********************************************************************
  !
  !  FIRST, RE-CALCULATE THE OVERLAP MATRIX
  !
  !*********************************************************************
  !
  !     PATAS

  allocate (eigs(norbs), vecs(norbs**2), stat=alloc_stat)
  if (alloc_stat /= 0) return  !WARNING
  if (.not. allocated(i1fact)) then

    allocate(i1fact(3 + norbs))
!
!   SET UP ARRAY OF LOWER HALF TRIANGLE INDICES (PASCAL'S TRIANGLE)
!
    do i = 1, norbs
      i1fact(i) = (i*(i + 1))/2
    end do
  end if
  do i = 1, numat
      if = nfirst(i)
      il = nlast(i)
      if (il >= if) then
        eigs(if) = betas(nat(i))
        if (il > if) then
          eigs(if+1) = betap(nat(i))
          eigs(if+2) = eigs(if+1)
          eigs(if+3) = eigs(if+1)
          if (il > if+3) then
            eigs(if+4) = betad(nat(i))
            eigs(if+5) = eigs(if+4)
            eigs(if+6) = eigs(if+4)
            eigs(if+7) = eigs(if+4)
            eigs(if+8) = eigs(if+4)
          end if
        end if
    else
      if = nfirst(i)
      il = nlast(i)
      if (il >= if) then
        eigs(if) = betas(nat(i))
        if (il > if) then
          eigs(if+1) = betap(nat(i))
          eigs(if+2) = eigs(if+1)
          eigs(if+3) = eigs(if+1)
          if (il > if+3) then
            eigs(if+4) = betad(nat(i))
            eigs(if+5) = eigs(if+4)
            eigs(if+6) = eigs(if+4)
            eigs(if+7) = eigs(if+4)
            eigs(if+8) = eigs(if+4)
          end if
        end if
      end if
    end if
    im1 = i - 1
    bi = betas(nat(i))
    do k = if, il
      bi = eigs(k)
      ii = (k*(k-1)) / 2
      do j = 1, im1
        jf = nfirst(j)
        jl = nlast(j)
        do jj = jf, jl
          bj = eigs(jj)
          ij = ii + jj
          h(ij) = 2.d0 * h(ij) / (bi+bj) + 1.d-14
          !  THE  +1.D-14 IS TO PREVENT POSSIBLE ERRORS IN THE DIAGONALIZATION.
        end do
      end do
      do jj = if, k
        ij = ii + jj
        h(ij) = 0.d0
      end do
    end do
  end do
  do i = 1, norbs
    h(i1fact(i)) = 1.d0
  end do
  call rsp (h, norbs, eigs, vecs)
  do i = 1, norbs
    eigs(i) = 1.d0 / Sqrt (Abs (eigs(i)))
  end do
  ij = 0
  do i = 1, norbs
    do j = 1, i
      ij = ij + 1
      sum = 0.d0
      do k = 1, norbs
        sum = sum + vecs(i+ (k-1)*norbs) * eigs(k) * vecs &
             & (j+ (k-1)*norbs)
      end do
      s(i+ (j-1)*norbs) = sum
      s(j+ (i-1)*norbs) = sum
    end do
  end do
  !
  end subroutine get_minus_point_five_overlap


  subroutine evec(aVector, x, y, z, coord, numat)
    integer :: numat
    double precision :: coord(3,numat), x, y, z
    real :: aVector(7*numat)
!
!
    integer :: i, j
    real :: shellRi, shellR2, shellR2i, shellR3i, &
    u, v, w, uu, vv, ww
    j = 1
    do i = 1, numat
      u = sngl(x - coord(1,i))
      v = sngl(y - coord(2,i))
      w = sngl(z - coord(3,i))
      uu = u * u
      vv = v * v
      ww = w * w
      shellR2 = max(uu + vv + ww, 1.e-2)
      shellR2i = 1.e0/(shellR2 + 1.e-7)
      shellRi = sqrt(shellR2i)

      aVector(j + 0) =  shellRi
      shellR3i = shellRi * shellR2i
      aVector(j + 1) = u * shellR3i
      aVector(j + 2) = v * shellR3i
      aVector(j + 3) = w * shellR3i
      aVector(j + 4) = shellR2i
      aVector(j + 5) = shellR3i
      aVector(j + 6) = shellR2i * shellR2i
      j = j + 7
    end do
  end subroutine evec

  subroutine sqrdc(x, ldx, n, p, qraux, jpvt, work, job)
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: ldx
      integer  :: n
      integer , intent(in) :: p
      integer , intent(in) :: job
      integer , intent(inout) :: jpvt(ldx)
      real  :: x(ldx,ldx)
      real , intent(out) :: qraux(ldx)
      real , intent(inout) :: work(ldx)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: j, jp, l, lp1, lup, maxj, pl, pu, jj
      real :: maxnrm, tt, nrmxl, t
      logical :: negj, swapj
      real , external :: sdot, snrm2
!-----------------------------------------------
!
!     SQRDC USES HOUSEHOLDER TRANSFORMATIONS TO COMPUTE THE QR
!     FACTORIZATION OF AN N BY P MATRIX X.  COLUMN PIVOTING
!     BASED ON THE 2-NORMS OF THE REDUCED COLUMNS MAY BE
!     PERFORMED AT THE USERS OPTION.
!
!     ON ENTRY
!
!        X       REAL(LDX,P), WHERE LDX .GE. N.
!                X CONTAINS THE MATRIX WHOSE DECOMPOSITION IS TO BE
!                COMPUTED.
!
!        LDX     INTEGER.
!                LDX IS THE LEADING DIMENSION OF THE ARRAY X.
!
!        N       INTEGER.
!                N IS THE NUMBER OF ROWS OF THE MATRIX X.
!
!        P       INTEGER.
!                P IS THE NUMBER OF COLUMNS OF THE MATRIX X.
!
!        JPVT    INTEGER(P).
!                JPVT CONTAINS INTEGERS THAT CONTROL THE SELECTION
!                OF THE PIVOT COLUMNS.  THE K-TH COLUMN X(K) OF X
!                IS PLACED IN ONE OF THREE CLASSES ACCORDING TO THE
!                VALUE OF JPVT(K).
!
!                   IF JPVT(K) .GT. 0, THEN X(K) IS AN INITIAL
!                                      COLUMN.
!
!                   IF JPVT(K) .EQ. 0, THEN X(K) IS A FREE COLUMN.
!
!                   IF JPVT(K) .LT. 0, THEN X(K) IS A FINAL COLUMN.
!
!                BEFORE THE DECOMPOSITION IS COMPUTED, INITIAL COLUMNS
!                ARE MOVED TO THE BEGINNING OF THE ARRAY X AND FINAL
!                COLUMNS TO THE END.  BOTH INITIAL AND FINAL COLUMNS
!                ARE FROZEN IN PLACE DURING THE COMPUTATION AND ONLY
!                FREE COLUMNS ARE MOVED.  AT THE K-TH STAGE OF THE
!                REDUCTION, IF X(K) IS OCCUPIED BY A FREE COLUMN
!                IT IS INTERCHANGED WITH THE FREE COLUMN OF LARGEST
!                REDUCED NORM.  JPVT IS NOT REFERENCED IF
!                JOB .EQ. 0.
!
!        WORK    REAL(P).
!                WORK IS A WORK ARRAY.  WORK IS NOT REFERENCED IF
!                JOB .EQ. 0.
!
!        JOB     INTEGER.
!                JOB IS AN INTEGER THAT INITIATES COLUMN PIVOTING.
!                IF JOB .EQ. 0, NO PIVOTING IS DONE.
!                IF JOB .NE. 0, PIVOTING IS DONE.
!
!     ON RETURN
!
!        X       X CONTAINS IN ITS UPPER TRIANGLE THE UPPER
!                TRIANGULAR MATRIX R OF THE QR FACTORIZATION.
!                BELOW ITS DIAGONAL X CONTAINS INFORMATION FROM
!                WHICH THE ORTHOGONAL PART OF THE DECOMPOSITION
!                CAN BE RECOVERED.  NOTE THAT IF PIVOTING HAS
!                BEEN REQUESTED, THE DECOMPOSITION IS NOT THAT
!                OF THE ORIGINAL MATRIX X BUT THAT OF X
!                WITH ITS COLUMNS PERMUTED AS DESCRIBED BY JPVT.
!
!        QRAUX   REAL(P).
!                QRAUX CONTAINS FURTHER INFORMATION REQUIRED TO RECOVER
!                THE ORTHOGONAL PART OF THE DECOMPOSITION.
!
!        JPVT    JPVT(K) CONTAINS THE INDEX OF THE COLUMN OF THE
!                ORIGINAL MATRIX THAT HAS BEEN INTERCHANGED INTO
!                THE K-TH COLUMN, IF PIVOTING WAS REQUESTED.
!
!     LINPACK. THIS VERSION DATED 08/14/78 .
!     G.W. STEWART, UNIVERSITY OF MARYLAND, ARGONNE NATIONAL LAB.
!
!     SQRDC USES THE FOLLOWING FUNCTIONS AND SUBPROGRAMS.
!
!     BLAS SAXPY,SDOT,SSCAL,SSWAP,SNRM2
!     FORTRAN ABS,AMAX1,MIN0,SQRT
!
!     INTERNAL VARIABLES
!
!
!
      pl = 1
      pu = 0
      if (job /= 0) then
!
!        PIVOTING HAS BEEN REQUESTED.  REARRANGE THE COLUMNS
!        ACCORDING TO JPVT.
!
        do j = 1, p
          swapj = jpvt(j) > 0
          negj = jpvt(j) < 0
          jpvt(j) = j
          if (negj) jpvt(j) = -j
          if (.not.swapj) cycle
          if (j /= pl) call sswap (n, x(1,pl), 1, x(1,j), 1)
          jpvt(j) = jpvt(pl)
          jpvt(pl) = j
          pl = pl + 1
        end do
        pu = p
        do jj = 1, p
          j = p - jj + 1
          if (jpvt(j) >= 0) cycle
          jpvt(j) = -jpvt(j)
          if (j /= pu) then
            call sswap (n, x(1,pu), 1, x(1,j), 1)
            jp = jpvt(pu)
            jpvt(pu) = jpvt(j)
            jpvt(j) = jp
          end if
          pu = pu - 1
        end do
      end if
      if (pu >= pl) then
        do j = pl, pu
          qraux(j) = snrm2(n,x(1,j),1)
          work(j) = qraux(j)
        end do
      end if
      lup = min0(n,p)
      do l = 1, lup
        if (l>=pl .and. l<pu) then
!
!           LOCATE THE COLUMN OF LARGEST NORM AND BRING IT
!           INTO THE PIVOT POSITION.
!
          maxnrm = 0.0E0
          maxj = l
          do j = l, pu
            if (qraux(j) <= maxnrm) cycle
            maxnrm = qraux(j)
            maxj = j
          end do
          if (maxj /= l) then
            call sswap (n, x(1,l), 1, x(1,maxj), 1)
            qraux(maxj) = qraux(l)
            work(maxj) = work(l)
            jp = jpvt(maxj)
            jpvt(maxj) = jpvt(l)
            jpvt(l) = jp
          end if
        end if
        qraux(l) = 0.0E0
        if (l == n) cycle
!
!           COMPUTE THE HOUSEHOLDER TRANSFORMATION FOR COLUMN L.
!
        nrmxl = snrm2(n - l + 1,x(l,l),1)
        if (nrmxl == 0.0E0) cycle
        if (x(l,l) /= 0.0E0) nrmxl = sign(nrmxl,x(l,l))
        call sscal (n - l + 1, 1.0E0/nrmxl, x(l,l), 1)
        x(l,l) = 1.0E0 + x(l,l)
!
!              APPLY THE TRANSFORMATION TO THE REMAINING COLUMNS,
!              UPDATING THE NORMS.
!
        lp1 = l + 1
        if (p >= lp1) then
          do j = lp1, p
            t = -sdot(n - l + 1,x(l,l),1,x(l,j),1)/x(l,l)
            call saxpy (n - l + 1, t, x(l,l), 1, x(l,j), 1)
            if (j<pl .or. j>pu) cycle
            if (qraux(j) == 0.0E0) cycle
            tt = 1.0E0 - (abs(x(l,j))/qraux(j))**2
            tt = amax1(tt,0.0E0)
            t = tt
            tt = 1.0E0 + 0.05E0*tt*(qraux(j)/work(j))**2
            if (Abs(tt - 1.0E0) > 1.e-10 ) then
              qraux(j) = qraux(j)*sqrt(t)
            else
              qraux(j) = snrm2(n - l,x(l+1,j),1)
              work(j) = qraux(j)
            end if
          end do
        end if
!
!              SAVE THE TRANSFORMATION.
!
        qraux(l) = x(l,l)
        x(l,l) = -nrmxl
      end do
      return
      end subroutine sqrdc


      subroutine saxpy(n, sa, sx, incx, sy, incy)
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n
      integer , intent(in) :: incx
      integer , intent(in) :: incy
      real , intent(in) :: sa
      real , intent(in) :: sx(1)
      real , intent(inout) :: sy(1)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: ix, iy, m, mp1
!-----------------------------------------------
!
!     CONSTANT TIMES A VECTOR PLUS A VECTOR.
!     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.
!     JACK DONGARRA, LINPACK, 3/11/78.
!
!
      if (n <= 0) return
      if (sa == 0.0E0) return
      if (incx/=1 .or. incy/=1) then
!
!        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
!          NOT EQUAL TO 1
!
        ix = 1
        iy = 1
        if (incx < 0) ix = ((-n) + 1)*incx + 1
        if (incy < 0) iy = ((-n) + 1)*incy + 1
        sy(iy:(n-1)*incy+iy:incy) = sy(iy:(n-1)*incy+iy:incy) + sa*sx(ix:(n-1)*&
          incx+ix:incx)
        return
      end if
!
!        CODE FOR BOTH INCREMENTS EQUAL TO 1
!
!
!        CLEAN-UP LOOP
!
      m = mod(n,4)
      if (m /= 0) then
        sy(:m) = sy(:m) + sa*sx(:m)
        if (n < 4) return
      end if
      mp1 = m + 1
      sy(mp1:((n-mp1+4)/4)*4-1+mp1) = sy(mp1:((n-mp1+4)/4)*4-1+mp1) + sa*sx(mp1&
        :((n-mp1+4)/4)*4-1+mp1)
      return
      end subroutine saxpy


      real function sdot (n, sx, incx, sy, incy)
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n
      integer , intent(in) :: incx
      integer , intent(in) :: incy
      real , intent(in) :: sx(1)
      real , intent(in) :: sy(1)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: ix, iy, m, mp1
      real :: temp
!-----------------------------------------------
!
!     FORMS THE DOT PRODUCT OF TWO VECTORS.
!     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.
!     JACK DONGARRA, LINPACK, 3/11/78.
!
!
      sdot = 0.0E0
      temp = 0.0E0
      if (n <= 0) return
      if (incx/=1 .or. incy/=1) then
!
!        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
!          NOT EQUAL TO 1
!
        ix = 1
        iy = 1
        if (incx < 0) ix = ((-n) + 1)*incx + 1
        if (incy < 0) iy = ((-n) + 1)*incy + 1
        temp = dot_product(sx(ix:(n-1)*incx+ix:incx),sy(iy:(n-1)*incy+iy:incy))
        sdot = temp
        return
      end if
!
!        CODE FOR BOTH INCREMENTS EQUAL TO 1
!
!
!        CLEAN-UP LOOP
!
      m = mod(n,5)
      if (m == 0) go to 40
      temp = dot_product(sx(:m),sy(:m))
      if (n < 5) go to 60
   40 continue
      mp1 = m + 1
      temp = temp + dot_product(sx(mp1:((n-mp1+5)/5)*5-1+mp1),sy(mp1:((n-mp1+5)&
        /5)*5-1+mp1))
   60 continue
      sdot = temp
      return
      end function sdot


      subroutine sscal(n, da, dx, incx)
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n
      integer , intent(in) :: incx
      real , intent(in) :: da
      real , intent(inout) :: dx(1)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: m, mp1, nincx
!-----------------------------------------------
!
!     SCALES A VECTOR BY A CONSTANT.
!     USES UNROLLED LOOPS FOR INCREMENT EQUAL TO ONE.
!     JACK DONGARRA, LINPACK, 3/11/78.
!
!
      if (n <= 0) return
      if (incx /= 1) then
!
!        CODE FOR INCREMENT NOT EQUAL TO 1
!
        nincx = n*incx
        dx(:nincx:incx) = da*dx(:nincx:incx)
        return
      end if
!
!        CODE FOR INCREMENT EQUAL TO 1
!
!
!        CLEAN-UP LOOP
!
      m = mod(n,5)
      if (m /= 0) then
        dx(:m) = da*dx(:m)
        if (n < 5) return
      end if
      mp1 = m + 1
      dx(mp1:((n-mp1+5)/5)*5-1+mp1) = da*dx(mp1:((n-mp1+5)/5)*5-1+mp1)
      return
      end subroutine sscal


      real function snrm2 (n, sx, incx)
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n
      integer , intent(in) :: incx
      real , intent(in) :: sx(1)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: next, nn, i, j
      real :: cutlo, cuthi, hitest, sum, xmax, zero, one
!-----------------------------------------------
      data zero, one/ 0.0E0, 1.0E0/
!
!     EUCLIDEAN NORM OF THE N-VECTOR STORED IN SX() WITH STORAGE
!     INCREMENT INCX .
!     IF    N .LE. 0 RETURN WITH RESULT = 0.
!     IF N .GE. 1 THEN INCX MUST BE .GE. 1
!
!           C.L.LAWSON, 1978 JAN 08
!
!     FOUR PHASE METHOD     USING TWO BUILT-IN CONSTANTS THAT ARE
!     HOPEFULLY APPLICABLE TO ALL MACHINES.
!         CUTLO = MAXIMUM OF  SQRT(U/EPS)  OVER ALL KNOWN MACHINES.
!         CUTHI = MINIMUM OF  SQRT(V)      OVER ALL KNOWN MACHINES.
!     WHERE
!         EPS = SMALLEST NO. SUCH THAT EPS + 1. .GT. 1.
!         U   = SMALLEST POSITIVE NO.   (UNDERFLOW LIMIT)
!         V   = LARGEST  NO.            (OVERFLOW  LIMIT)
!
!     BRIEF OUTLINE OF ALGORITHM..
!
!     PHASE 1    SCANS ZERO COMPONENTS.
!     MOVE TO PHASE 2 WHEN A COMPONENT IS NONZERO AND .LE. CUTLO
!     MOVE TO PHASE 3 WHEN A COMPONENT IS .GT. CUTLO
!     MOVE TO PHASE 4 WHEN A COMPONENT IS .GE. CUTHI/M
!     WHERE M = N FOR X() REAL AND M = 2*N FOR COMPLEX.
!
!     VALUES FOR CUTLO AND CUTHI..
!     FROM THE ENVIRONMENTAL PARAMETERS LISTED IN THE IMSL CONVERTER
!     DOCUMENT THE LIMITING VALUES ARE AS FOLLOWS..
!     CUTLO, S.P.   U/EPS = 2**(-102) FOR  HONEYWELL.  CLOSE SECONDS ARE
!                   UNIVAC AND DEC AT 2**(-103)
!                   THUS CUTLO = 2**(-51) = 4.44089E-16
!     CUTHI, S.P.   V = 2**127 FOR UNIVAC, HONEYWELL, AND DEC.
!                   THUS CUTHI = 2**(63.5) = 1.30438E19
!     CUTLO, D.P.   U/EPS = 2**(-67) FOR HONEYWELL AND DEC.
!                   THUS CUTLO = 2**(-33.5) = 8.23181D-11
!     CUTHI, D.P.   SAME AS S.P.  CUTHI = 1.30438D19
!     DATA CUTLO, CUTHI / 8.232D-11,  1.304D19 /
!     DATA CUTLO, CUTHI / 4.441E-16,  1.304E19 /
      data cutlo, cuthi/ 4.441E-16, 1.304E19/
      xmax = 0.0
!
      if (n <= 0) then
        snrm2 = zero
      else
!
        next = 30
        sum = zero
        nn = n*incx
!                                                 BEGIN MAIN LOOP
        i = 1
   20   continue
        if (next == 30) go to 30
        if (next == 50) go to 50
        if (next == 70) go to 70
        if (next == 110) go to 110
   30   continue
        if (abs(sx(i)) > cutlo) go to 85
        next = 50
        xmax = zero
!
!                        PHASE 1.  SUM IS ZERO
!
   50   continue
        if (Abs(sx(i)) < 1.d-20) go to 200
        if (abs(sx(i)) > cutlo) go to 85
!
!                                PREPARE FOR PHASE 2.
        next = 70
        go to 105
!
!                                PREPARE FOR PHASE 4.
!
  100   continue
        i = j
        next = 110
        sum = (sum/sx(i))/sx(i)
  105   continue
        xmax = abs(sx(i))
        go to 115
!
!                   PHASE 2.  SUM IS SMALL.
!                             SCALE TO AVOID DESTRUCTIVE UNDERFLOW.
!
   70   continue
        if (abs(sx(i)) > cutlo) go to 75
!
!                     COMMON CODE FOR PHASES 2 AND 4.
!                     IN PHASE 4 SUM IS LARGE.  SCALE TO AVOID OVERFLOW.
!
  110   continue
        if (abs(sx(i)) <= xmax) go to 115
        sum = one + sum*(xmax/sx(i))**2
        xmax = abs(sx(i))
        go to 200
!
  115   continue
        sum = sum + (sx(i)/xmax)**2
        go to 200
!
!
!                  PREPARE FOR PHASE 3.
!
   75   continue
        sum = (sum*xmax)*xmax
!
!
!     FOR REAL OR D.P. SET HITEST = CUTHI/N
!     FOR COMPLEX      SET HITEST = CUTHI/(2*N)
!
   85   continue
        hitest = cuthi/float(n)
!
!                   PHASE 3.  SUM IS MID-RANGE.  NO SCALING.
!
        do j = i, nn, incx
          if (abs(sx(j)) >= hitest) go to 100
          sum = sum + sx(j)**2
        end do
        snrm2 = sqrt(sum)
        go to 300
!
  200   continue
        i = i + incx
        if (i <= nn) go to 20
!
!              END OF MAIN LOOP.
!
!              COMPUTE SQUARE ROOT AND ADJUST FOR SCALING.
!
        snrm2 = xmax*sqrt(sum)
      end if
  300 continue
      return
      end function snrm2


      subroutine sswap(n, sx, incx, sy, incy)
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n
      integer , intent(in) :: incx
      integer , intent(in) :: incy
      real , intent(inout) :: sx(1)
      real , intent(inout) :: sy(1)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, ix, iy, m, mp1
      real :: stemp
!-----------------------------------------------
!
!     INTERCHANGES TWO VECTORS.
!     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO 1.
!     JACK DONGARRA, LINPACK, 3/11/78.
!
!
      if (n <= 0) return
      if (incx/=1 .or. incy/=1) then
!
!       CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS NOT EQUAL
!         TO 1
!
        ix = 1
        iy = 1
        if (incx < 0) ix = ((-n) + 1)*incx + 1
        if (incy < 0) iy = ((-n) + 1)*incy + 1
        do i = 1, n
          stemp = sx(ix)
          sx(ix) = sy(iy)
          sy(iy) = stemp
          ix = ix + incx
          iy = iy + incy
        end do
        return
      end if
!
!       CODE FOR BOTH INCREMENTS EQUAL TO 1
!
!
!       CLEAN-UP LOOP
!
      m = mod(n,3)
      if (m /= 0) then
        do i = 1, m
          stemp = sx(i)
          sx(i) = sy(i)
          sy(i) = stemp
        end do
        if (n < 3) return
      end if
      mp1 = m + 1
      do i = mp1, n, 3
        stemp = sx(i)
        sx(i) = sy(i)
        sy(i) = stemp
        stemp = sx(i+1)
        sx(i+1) = sy(i+1)
        sy(i+1) = stemp
        stemp = sx(i+2)
        sx(i+2) = sy(i+2)
        sy(i+2) = stemp
      end do
      return
      end subroutine sswap
            MODULE scopy_I
      INTERFACE
      SUBROUTINE scopy (N, SX, INCX, SY, INCY)
      integer, INTENT(IN) :: N
      real, DIMENSION(1), INTENT(IN) :: SX
      integer, INTENT(IN) :: INCX
      real, DIMENSION(1), INTENT(OUT) :: SY
      integer, INTENT(IN) :: INCY
      END SUBROUTINE
      END INTERFACE
      END MODULE
      MODULE saxpy_I
      INTERFACE
      SUBROUTINE saxpy (N, SA, SX, INCX, SY, INCY)
      integer, INTENT(IN) :: N
      real, INTENT(IN) :: SA
      real, DIMENSION(1), INTENT(IN) :: SX
      integer, INTENT(IN) :: INCX
      real, DIMENSION(1), INTENT(INOUT) :: SY
      integer, INTENT(IN) :: INCY
      END SUBROUTINE
      END INTERFACE
      END MODULE

      subroutine sqrsl(x, ldx, n, k, qraux, y, qy, qty, b, rsd, xb, job, info)
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: ldx
      integer  :: n
      integer  :: k
      integer , intent(in) :: job
      integer , intent(out) :: info
      real  :: x(ldx,ldx)
      real , intent(in) :: qraux(ldx)
      real  :: y(ldx)
      real  :: qy(ldx)
      real  :: qty(ldx)
      real  :: b(ldx)
      real  :: rsd(ldx)
      real  :: xb(ldx)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: j, jj, ju, kp1
      real :: t, temp
      logical :: cb, cqy, cqty, cr, cxb
      real , external :: sdot
!-----------------------------------------------
!
!     SQRSL APPLIES THE OUTPUT OF SQRDC TO COMPUTE COORDINATE
!     TRANSFORMATIONS, PROJECTIONS, AND LEAST SQUARES SOLUTIONS.
!     FOR K .LE. MIN(N,P), LET XK BE THE MATRIX
!
!            XK = (X(JPVT(1)),X(JPVT(2)), ... ,X(JPVT(K)))
!
!     FORMED FROM COLUMNNS JPVT(1), ... ,JPVT(K) OF THE ORIGINAL
!     N X P MATRIX X THAT WAS INPUT TO SQRDC (IF NO PIVOTING WAS
!     DONE, XK CONSISTS OF THE FIRST K COLUMNS OF X IN THEIR
!     ORIGINAL ORDER).  SQRDC PRODUCES A FACTORED ORTHOGONAL MATRIX Q
!     AND AN UPPER TRIANGULAR MATRIX R SUCH THAT
!
!              XK = Q * (R)
!                       (0)
!
!     THIS INFORMATION IS CONTAINED IN CODED FORM IN THE ARRAYS
!     X AND QRAUX.
!
!     ON ENTRY
!
!        X      REAL(LDX,P).
!               X CONTAINS THE OUTPUT OF SQRDC.
!
!        LDX    INTEGER.
!               LDX IS THE LEADING DIMENSION OF THE ARRAY X.
!
!        N      INTEGER.
!               N IS THE NUMBER OF ROWS OF THE MATRIX XK.  IT MUST
!               HAVE THE SAME VALUE AS N IN SQRDC.
!
!        K      INTEGER.
!               K IS THE NUMBER OF COLUMNS OF THE MATRIX XK.  K
!               MUST NNOT BE GREATER THAN MIN(N,P), WHERE P IS THE
!               SAME AS IN THE CALLING SEQUENCE TO SQRDC.
!
!        QRAUX  REAL(P).
!               QRAUX CONTAINS THE AUXILIARY OUTPUT FROM SQRDC.
!
!        Y      REAL(N)
!               Y CONTAINS AN N-VECTOR THAT IS TO BE MANIPULATED
!               BY SQRSL.
!
!        JOB    INTEGER.
!               JOB SPECIFIES WHAT IS TO BE COMPUTED.  JOB HAS
!               THE DECIMAL EXPANSION ABCDE, WITH THE FOLLOWING
!               MEANING.
!
!                    IF A.NE.0, COMPUTE QY.
!                    IF B,C,D, OR E .NE. 0, COMPUTE QTY.
!                    IF C.NE.0, COMPUTE B.
!                    IF D.NE.0, COMPUTE RSD.
!                    IF E.NE.0, COMPUTE XB.
!
!               NOTE THAT A REQUEST TO COMPUTE B, RSD, OR XB
!               AUTOMATICALLY TRIGGERS THE COMPUTATION OF QTY, FOR
!               WHICH AN ARRAY MUST BE PROVIDED IN THE CALLING
!               SEQUENCE.
!
!     ON RETURN
!
!        QY     REAL(N).
!               QY CONNTAINS Q*Y, IF ITS COMPUTATION HAS BEEN
!               REQUESTED.
!
!        QTY    REAL(N).
!               QTY CONTAINS TRANS(Q)*Y, IF ITS COMPUTATION HAS
!               BEEN REQUESTED.  HERE TRANS(Q) IS THE
!               TRANSPOSE OF THE MATRIX Q.
!
!        B      REAL(K)
!               B CONTAINS THE SOLUTION OF THE LEAST SQUARES PROBLEM
!
!                    MINIMIZE NORM2(Y - XK*B),
!
!               IF ITS COMPUTATION HAS BEEN REQUESTED.  (NOTE THAT
!               IF PIVOTING WAS REQUESTED IN SQRDC, THE J-TH
!               COMPONENT OF B WILL BE ASSOCIATED WITH COLUMN JPVT(J)
!               OF THE ORIGINAL MATRIX X THAT WAS INPUT INTO SQRDC.)
!
!        RSD    REAL(N).
!               RSD CONTAINS THE LEAST SQUARES RESIDUAL Y - XK*B,
!               IF ITS COMPUTATION HAS BEEN REQUESTED.  RSD IS
!               ALSO THE ORTHOGONAL PROJECTION OF Y ONTO THE
!               ORTHOGONAL COMPLEMENT OF THE COLUMN SPACE OF XK.
!
!        XB     REAL(N).
!               XB CONTAINS THE LEAST SQUARES APPROXIMATION XK*B,
!               IF ITS COMPUTATION HAS BEEN REQUESTED.  XB IS ALSO
!               THE ORTHOGONAL PROJECTION OF Y ONTO THE COLUMN SPACE
!               OF X.
!
!        INFO   INTEGER.
!               INFO IS ZERO UNLESS THE COMPUTATION OF B HAS
!               BEEN REQUESTED AND R IS EXACTLY SINGULAR.  IN
!               THIS CASE, INFO IS THE INDEX OF THE FIRST ZERO
!               DIAGONAL ELEMENT OF R AND B IS LEFT UNALTERED.
!
!     THE PARAMETERS QY, QTY, B, RSD, AND XB ARE NOT REFERENCED
!     IF THEIR COMPUTATION IS NOT REQUESTED AND IN THIS CASE
!     CAN BE REPLACED BY DUMMY VARIABLES IN THE CALLING PROGRAM.
!     TO SAVE STORAGE, THE USER MAY IN SOME CASES USE THE SAME
!     ARRAY FOR DIFFERENT PARAMETERS IN THE CALLING SEQUENCE.  A
!     FREQUENTLY OCCURING EXAMPLE IS WHEN ONE WISHES TO COMPUTE
!     ANY OF B, RSD, OR XB AND DOES NOT NEED Y OR QTY.  IN THIS
!     CASE ONE MAY IDENTIFY Y, QTY, AND ONE OF B, RSD, OR XB, WHILE
!     PROVIDING SEPARATE ARRAYS FOR ANYTHING ELSE THAT IS TO BE
!     COMPUTED.  THUS THE CALLING SEQUENCE
!
!          CALL SQRSL(X,LDX,N,K,QRAUX,Y,DUM,Y,B,Y,DUM,110,INFO)
!
!     WILL RESULT IN THE COMPUTATION OF B AND RSD, WITH RSD
!     OVERWRITING Y.  MORE GENERALLY, EACH ITEM IN THE FOLLOWING
!     LIST CONTAINS GROUPS OF PERMISSIBLE IDENTIFICATIONS FOR
!     A SINGLE CALLINNG SEQUENCE.
!
!          1. (Y,QTY,B) (RSD) (XB) (QY)
!
!          2. (Y,QTY,RSD) (B) (XB) (QY)
!
!          3. (Y,QTY,XB) (B) (RSD) (QY)
!
!          4. (Y,QY) (QTY,B) (RSD) (XB)
!
!          5. (Y,QY) (QTY,RSD) (B) (XB)
!
!          6. (Y,QY) (QTY,XB) (B) (RSD)
!
!     IN ANY GROUP THE VALUE RETURNED IN THE ARRAY ALLOCATED TO
!     THE GROUP CORRESPONDS TO THE LAST MEMBER OF THE GROUP.
!
!     LINPACK. THIS VERSION DATED 08/14/78 .
!     G.W. STEWART, UNIVERSITY OF MARYLAND, ARGONNE NATIONAL LAB.
!
!     SQRSL USES THE FOLLOWING FUNCTIONS AND SUBPROGRAMS.
!
!     BLAS SAXPY,SCOPY,SDOT
!     FORTRAN ABS,MIN0,MOD
!
!     INTERNAL VARIABLES
!
!
!
!     SET INFO FLAG.
!
      info = 0
!
!     DETERMINE WHAT IS TO BE COMPUTED.
!
      cqy = job/10000 /= 0
      cqty = mod(job,10000) /= 0
      cb = mod(job,1000)/100 /= 0
      cr = mod(job,100)/10 /= 0
      cxb = mod(job,10) /= 0
      ju = min0(k,n - 1)
!
!     SPECIAL ACTION WHEN N=1.
!
      if (ju == 0) then
        if (cqy) qy(1) = y(1)
        if (cqty) qty(1) = y(1)
        if (cxb) xb(1) = y(1)
        if (cb) then
          if (x(1,1) == 0.0E0) then
            info = 1
          else
            b(1) = y(1)/x(1,1)
          end if
        end if
        if (cr) rsd(1) = 0.0E0
      else
        if (cqy) call scopy (n, y, 1, qy, 1)
        if (cqty) call scopy (n, y, 1, qty, 1)
        if (cqy) then
!
!           COMPUTE QY.
!
          do jj = 1, ju
            j = ju - jj + 1
            if (qraux(j) == 0.0E0) cycle
            temp = x(j,j)
            x(j,j) = qraux(j)
            t = -sdot(n - j + 1,x(j,j),1,qy(j),1)/x(j,j)
            call saxpy (n - j + 1, t, x(j,j), 1, qy(j), 1)
            x(j,j) = temp
          end do
        end if
        if (cqty) then
!
!           COMPUTE TRANS(Q)*Y.
!
          do j = 1, ju
            if (qraux(j) == 0.0E0) cycle
            temp = x(j,j)
            x(j,j) = qraux(j)
            t = -sdot(n - j + 1,x(j,j),1,qty(j),1)/x(j,j)
            call saxpy (n - j + 1, t, x(j,j), 1, qty(j), 1)
            x(j,j) = temp
          end do
        end if
        if (cb) call scopy (k, qty, 1, b, 1)
        kp1 = k + 1
        if (cxb) call scopy (k, qty, 1, xb, 1)
        if (cr .and. k<n) call scopy (n - k, qty(kp1), 1, rsd(kp1), 1)
        if (.not.(.not.cxb .or. kp1>n)) then
          xb(kp1:n) = 0.0E0
        end if
        if (cr) then
          rsd(:k) = 0.0E0
        end if
        if (cb) then
!
!           COMPUTE B.
!
          do jj = 1, k
            j = k - jj + 1
            if (x(j,j) == 0.0E0) then
              info = j
!           ......EXIT
              exit
            end if
            b(j) = b(j)/x(j,j)
            if (j == 1) cycle
            t = -b(j)
            call saxpy (j - 1, t, x(1,j), 1, b, 1)
          end do
        end if
        if (.not.(.not.cr .and. .not.cxb)) then
!
!           COMPUTE RSD OR XB AS REQUIRED.
!
          do jj = 1, ju
            j = ju - jj + 1
            if (qraux(j) == 0.0E0) cycle
            temp = x(j,j)
            x(j,j) = qraux(j)
            if (cr) then
              t = -sdot(n - j + 1,x(j,j),1,rsd(j),1)/x(j,j)
              call saxpy (n - j + 1, t, x(j,j), 1, rsd(j), 1)
            end if
            if (cxb) then
              t = -sdot(n - j + 1,x(j,j),1,xb(j),1)/x(j,j)
              call saxpy (n - j + 1, t, x(j,j), 1, xb(j), 1)
            end if
            x(j,j) = temp
          end do
        end if
      end if
      return
      end subroutine sqrsl


      subroutine scopy(n, sx, incx, sy, incy)
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n
      integer , intent(in) :: incx
      integer , intent(in) :: incy
      real , intent(in) :: sx(1)
      real , intent(out) :: sy(1)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: ix, iy, m, mp1
!-----------------------------------------------
!
!     COPIES A VECTOR, X, TO A VECTOR, Y.
!     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO 1.
!     JACK DONGARRA, LINPACK, 3/11/78.
!
!
      if (n <= 0) return
      if (incx/=1 .or. incy/=1) then
!
!        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
!          NOT EQUAL TO 1
!
        ix = 1
        iy = 1
        if (incx < 0) ix = ((-n) + 1)*incx + 1
        if (incy < 0) iy = ((-n) + 1)*incy + 1
        sy(iy:(n-1)*incy+iy:incy) = sx(ix:(n-1)*incx+ix:incx)
        return
      end if
!
!        CODE FOR BOTH INCREMENTS EQUAL TO 1
!
!
!        CLEAN-UP LOOP
!
      m = mod(n,7)
      if (m /= 0) then
        sy(:m) = sx(:m)
        if (n < 7) return
      end if
      mp1 = m + 1
      sy(mp1:((n-mp1+7)/7)*7-1+mp1) = sx(mp1:((n-mp1+7)/7)*7-1+mp1)
      return
      end subroutine scopy

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

subroutine epseta (eps, eta)
   !
   !.. Implicit Declarations ..
    implicit none
   !
   !.. Formal Arguments ..
    double precision, intent (out) :: eps, eta
   !
   !.. Intrinsic Functions ..
    intrinsic Max, Tiny, Epsilon

   ! ... Executable Statements ...
   !
   !     RETURN ETA, THE SMALLEST REPRESENTABLE NUMBER,
   !     AND EPS, THE SMALLEST NUMBER FOR WHICH 1+EPS.NE.1.
   !
    eps = Max (Tiny (1.d0), 1.d-39)
    eta = Max (Epsilon (1.d0), 1.d-17)
end subroutine epseta

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine rotsec (t1, transform, new_coord, loop)
!
!  Using the symmetry operation stored in xop(:,loop), operate on the coordinates
!  in new_coord to generate a new set of coordinates.
!
!  If transform is true:
!
!  Using the symmetry operation stored in xop(:,loop), rotate the unit matrix t1
!  to form a unitary matrix representing that operation.
!
!  For electronics, t1 represents atomic orbitals, 
!  for phonons, t1 represents the Cartesian directions, i.e., the vibrational coordinates
!
  use common_common, only : numat, id, tvec, xop, phonon, title, trans, keywrd, &
    iw_new, nijk, ixyz, nijk_CUC
  implicit none
  double precision, dimension(9, 9), intent(out) :: t1
  logical, intent(in) :: transform
  integer, intent(in) :: loop
  double precision, dimension(3, numat), intent(inout) :: new_coord
! 
  logical :: first = .true.
  logical :: prt
  integer :: i, j, k, l, phon
  double precision :: c1, c2, c3, ca, cb, one, r, sa, sb, six, sum, theta, &
       & tnpx, tnpy, tnpz, two, x, xnew, xx, xy, y, ynew, yx, z, znew, zx, &
       & a, b, c, d, e, f, g, h, o, x1, y1, z1, e1(9,9), e2(9,9), sum1
  double precision, dimension(3, 3) :: atrans, atxyz, bb, ctox, xtoc
  double precision, dimension(3, 3) :: at
  double precision, dimension(5, 5) :: aa, cc
  save
! 
!.. Equivalences .. 
  equivalence (at(1, 1), a)
  equivalence (at(2, 1), b)
  equivalence (at(3, 1), c)
  equivalence (at(1, 2), d)
  equivalence (at(2, 2), e)
  equivalence (at(3, 2), f)
  equivalence (at(1, 3), g)
  equivalence (at(2, 3), h)
  equivalence (at(3, 3), o)
  if (first) then
    prt = (Index (keywrd, " ROTFOK") /= 0)
    do j = 1, id
      if (tvec(j, j) < 0) then
        do k = 1, 3
          tvec(j, k) = -tvec(j, k)
        end do
      end if
    end do
    do j = id + 1, 3
      tvec(j, j) = 1.d0
    end do
    do j = 1, 3
      do k = 1, 3
        sum = 0.d0
        do l = 1, 3
          sum = sum + trans(l, j)*tvec(l, k)
        end do
        xtoc(k, j) = sum
        ctox(k, j) = sum
      end do
    end do
    if (prt) then
      write(iw_new, '(/,a)') " Transform CRYSTAL to XYZ Coordinates"
    end if
    if (prt) then
      write(iw_new, "(3f13.6)") ctox
    end if
    call minv (xtoc, 3, sum)
    if (prt) then
      write(iw_new, '(/,a)') " Transform XYZ to CRYSTAL Coordinates (The inverse of the previous transform)"
    end if
    if (prt) then
      write(iw_new, "(3f13.6)") xtoc
    end if
    if (prt) then
      write(iw_new, '(/,a)') " Unitary Transform: XYZ to CRYSTAL"
    end if
    if (prt) then
      write(iw_new, "(3f13.6)") trans
    end if
    first = .false.
  end if
  if (transform) then
    t1 = 0.d0
!
!     Specification of the symmetry operations
!
!  xop(1,  loop) = 1 if inversion, 0 otherwise
!  xop(2,  loop) = motion in fractional unit cell coordinates in direction "a"
!  xop(3,  loop) = motion in fractional unit cell coordinates in direction "b"
!  xop(4,  loop) = motion in fractional unit cell coordinates in direction "c"
!  xop(5,  loop) = Rotation angle 
!  xop(6,  loop) = "a" component of axis
!  xop(7,  loop) = "b" component of axis
!  xop(8,  loop) = "c" component of axis
!  xop(9,  loop) = "x" component of Cartesian location of the operation
!  xop(10, loop) = "y" component of Cartesian location of the operation
!  xop(11, loop) = "z" component of Cartesian location of the operation

    i = Nint (xop(1, loop))
    tnpx = xop(2, loop)
    tnpy = xop(3, loop)
    tnpz = xop(4, loop)
    theta = xop(5, loop)
    c1 = xop(7, loop)
    c2 = xop(6, loop)
    c3 = xop(8, loop)
    one = 1.d0
    if (i == 1) one = -1.d0
    theta = 2.d0 * 3.141592653589d0 * theta
    bb(1, 3) = 0.d0
    bb(2, 3) = 0.d0
    bb(3, 1) = 0.d0
    bb(3, 2) = 0.d0
    bb(1, 1) = Cos(theta) * one
    bb(2, 2) = bb(1, 1)
    bb(1, 2) = Sin(theta) * one
    bb(2, 1) = -bb(1, 2)
    bb(3, 3) = one
    if (i == 2) bb(3, 3) = -1.d0
!
!  bb now holds the symmetry operation, at this point the operation
!  is about the "Z" axis.
!
!  Now rotate the operation to be about the axis defined by xop(6:8,loop)
!  in crystallographic coordinates
!
    xy = c1*c1 + c2*c2
    if (xy == 0.d0) then
      ca = 1.d0
      cb = 1.d0
      sa = 0.d0
      sb = 0.d0
    else
      r = Sqrt (xy + c3*c3)
      xy = Sqrt (xy)
      ca = c1 / xy
      cb = c3 / r
      sa = c2 / xy
      sb = xy / r
    end if
    a = ca
    b = sa * cb
    c = sa * sb
    d = -sa
    e = ca * cb
    f = ca * sb
    g = 0.d0
    h = -sb
    o = cb
    do i = 1, 3
      do j = 1, 3
        x = 0.d0
        do k = 1, 3
          x = x + at(k, i)*bb(j, k)
        end do
        cc(i, j) = x
      end do
    end do
    do i = 1, 3
      do j = 1, 3
        x = 0.d0
        do k = 1, 3
          x = x + cc(j, k)*at(k, i)
        end do
        aa(i, j) = x
      end do
    end do
    do i = 1, 3
      do j = 1, 3
        at(i, j) = aa(i, j)
      end do
    end do
  else
    if(phonon) then
      phon = 0
    else
      phon = 1
    end if
    do i = 1, 3
      l = i + phon
      do j = 1, 3
        k = j + phon
        at(i, j) = t1(k, l)
      end do
    end do
  end if
!
!  Now to convert from crystal coordinates to Cartesian coordinates,
!  in order to operate on the position of the atoms.
!
!   The operation is TRANS*AT*TRANS
!
  do i = 1, 3
    do j = 1, 3
      sum = 0.d0
      do k = 1, 3
        sum = sum + at(k, i)*trans(k, j)
      end do
      atrans(j, i) = sum
    end do
  end do
  do i = 1, 3
    do j = 1, 3
      sum = 0.d0
      do k = 1, 3
        sum = sum + atrans(i, k)*trans(k, j)
      end do
      atxyz(i, j) = at(i, j)
      at(i, j) = sum
    end do
  end do
  if (prt .and. transform) then
    write(iw_new, '(/,a,i2,a)') " Unitary Transform representing Operation ", loop, ", "//trim(title(loop))
    write(iw_new, '(a)') "            Cartesian Coordinates"    
    if (abs(xop(2,loop)) + abs(xop(3,loop)) + abs(xop(4,loop)) > 0.1d0) then
      write(iw_new, '(a)')"     From:  x         y         z            Fractional crystal translation"
      write(iw_new, "(a,3f10.6, 10x, f13.4)") "     x ", at(1,:), xop(2,loop)
      write(iw_new, "(a,3f10.6, 10x, f13.4)") "To:  y ", at(2,:), xop(3,loop)
      write(iw_new, "(a,3f10.6, 10x, f13.4)") "     z ", at(3,:), xop(4,loop)
    else
      write(iw_new, '(a)')"     From:  x         y         z"
      write(iw_new, "(a,3f10.6)") "     x ", at(1,:)
      write(iw_new, "(a,3f10.6)") "To:  y ", at(2,:)
      write(iw_new, "(a,3f10.6)") "     z ", at(3,:)
    end if
  end if
  do i = 1, numat
!
!  GET CRYSTAL COORDINATES
!
    xx = new_coord(1, i)
    yx = new_coord(2, i)
    zx = new_coord(3, i)
!
!  CONVERT FROM CRYSTALLOGRAPHIC TO CARTESIAN COORDINATES
!
    x1 = xx*ctox(1, 1) + yx*ctox(2, 1) + zx*ctox(3, 1) - xop(9, loop)
    y1 = xx*ctox(1, 2) + yx*ctox(2, 2) + zx*ctox(3, 2) - xop(10, loop)
    z1 = xx*ctox(1, 3) + yx*ctox(2, 3) + zx*ctox(3, 3) - xop(11, loop)
!
!  PERFORM THE OPERATION IN CARTESIAN COORDINATES
!
    xnew = x1*a + y1*d + z1*g + xop(9, loop)
    ynew = x1*b + y1*e + z1*h + xop(10, loop)
    znew = x1*c + y1*f + z1*o + xop(11, loop)
!
!  CONVERT BACK TO CRYSTAL
!
    x = xnew*xtoc(1, 1) + ynew*xtoc(2, 1) + znew*xtoc(3, 1) + tnpx
    y = xnew*xtoc(1, 2) + ynew*xtoc(2, 2) + znew*xtoc(3, 2) + tnpy
    z = xnew*xtoc(1, 3) + ynew*xtoc(2, 3) + znew*xtoc(3, 3) + tnpz
!
!  Store the new coordinates in new_coord
!
    if (prt .and. .not. transform) then
      write(iw_new, "(i4, i8,2i3, i4,a,i4,4(f14.4, 2f10.4))") ixyz, nijk(1,ixyz) + nijk_CUC(1,i), &
      nijk(2,ixyz) + nijk_CUC(2,i), nijk(3,ixyz) + nijk_CUC(3,i),  i, "  =", &
      (ixyz - 1)*numat + i, xx, yx, zx, x1, y1, z1, xnew, ynew, znew, x,y,z
    end if
    new_coord(1, i) = x
    new_coord(2, i) = y
    new_coord(3, i) = z
  end do
  if (.not. transform) return
  if( phonon ) then
!
!  A phonon spectrum - use "p" orbital rotation matrix only
!
    do i = 1,3
      do j = 1,3
         t1(i,j) = atxyz(j,i)
      end do
    end do
    return
  end if
!
!  "d"-orbital transform
!
  two = Sqrt (0.5d0)
  six = Sqrt (1/6.d0)
  at = atxyz
!
!   d(x^2 - y^2)
!
    aa(1, 1) = (a*a - b*b - d*d + e*e)/2.d0
    aa(1, 2) = a*c - d*f  
    aa(1, 3) = (2.d0*c*c - b*b - a*a - 2.d0*f*f + e*e + d*d) * two * six  
    aa(1, 4) = b*c - e*f  
    aa(1, 5) = a*b - d*e 
!
!  d(xz)
! 
    aa(2, 1) = a*g - b*h  
    aa(2, 2) = a*o + c*g  
    aa(2, 3) = (2.d0*c*o - b*h - a*g) * six/two  
    aa(2, 4) = b*o + c*h  
    aa(2, 5) = a*h + b*g  
!
!  d(2z^2 - x^2 - y^2)
!
    aa(3, 1) = (2.d0*g*g - d*d - a*a - 2.d0*h*h + e*e + b*b) * two * six  
    aa(3, 2) = (2.d0*g*o - d*f - a*c) * six/two
    aa(3, 3) = (4.d0*o*o - 2.d0*(h*h + g*g + f*f + c*c) + e*e + d*d + b*b + a*a)/6.d0 
    aa(3, 4) = (2.d0*h*o - e*f - c*b) * six/two  
    aa(3, 5) = (2.d0*g*h - e*d - a*b) * six/two 
!
!  d(yz)
!
    aa(4, 1) = d*g - e*h  
    aa(4, 2) = d*o + f*g  
    aa(4, 3) = (2.d0*o*f - e*h - d*g) * six/two  
    aa(4, 4) = e*o + f*h  
    aa(4, 5) = d*h + e*g  
!
!  d(xy)
!
    aa(5, 1) = a*d - b*e  
    aa(5, 2) = a*f + c*d  
    aa(5, 3) = (2.d0*c*f - e*b - a*d) * six/two  
    aa(5, 4) = b*f + c*e  
    aa(5, 5) = a*e + d*b
! 
!  Use the following block for diagnostics only
!
    if (.false. .and. loop > 1) then
      write(*,*)"  atxyz"
      write(*,'(3f16.10)')((atxyz(i,j), i = 1,3),j = 1,3)
      write(*,*)
      do i = 1, 3
        do j = 1, 3
          sum = 0.d0
          sum1 = 0.d0
          do k = 1, 3
            sum = sum + atxyz(i,k)*atxyz(j,k)
            sum1 = sum1 + atxyz(k,i)*atxyz(k,j)
          end do
          e1(i,j) = sum
          e2(i,j) = sum1
        end do
      end do
      write(*,*) " atxyz squared"
      write(*,'(3f16.10)')((e1(i,j), i = 1,3),j = 1,3)
      write(*,*)
      write(*,'(3f16.10)')((e2(i,j), i = 1,3),j = 1,3)
      write(*,*)  
      do i = 1, 5
        do j = 1, 5
          sum = 0.d0
          sum1 = 0.d0
          do k = 1, 5
            sum = sum + aa(i,k)*aa(j,k)
            sum1 = sum1 + aa(k,i)*aa(k,j)
          end do
          e1(i,j) = sum
          e2(i,j) = sum1
        end do
      end do
      write(*,*) " d_rot "
      write(*,'(5f16.10)')((aa(i,j), i = 1, 5),j = 1, 5)
      write(*,*)
      write(*,*) " d_rot squared"
      write(*,'(5f16.10)')((e1(i,j), i = 1, 5),j = 1, 5)
      write(*,*)
      write(*,'(5f16.10)')((e2(i,j), i = 1, 5),j = 1, 5)
      i = i
    end if
!
! Put the "d" transform into t1
!
  l = 0
  do i = 5, 9
    l = l + 1
    k = 0
    do j = 5, 9
      k = k + 1
      t1(i, j) = aa(l,k)
    end do
  end do
!
! Put the "p" transform into t1
!
  do i = 1, 3
    l = i + 1
    do j = 1, 3
      k = j + 1
      t1(k, l) = atxyz(i, j)
    end do
  end do
  t1(1, 1) = 1.d0
end subroutine rotsec

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine mult(c, s, vecs, n)

!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
      integer , intent(in) :: n
      double precision , intent(in) :: c(n,n)
      double precision , intent(in) :: s(n,n)
      double precision , intent(out) :: vecs(n,n)
!
!  Local variables
!
      integer :: i, j, k
      double precision :: sum
!-----------------------------------------------
!**********************************************************************
!
!   MULT IS USED IN THE MULLIKEN ANALYSIS ONLY. IT PERFORMS THE
!        OPERATION:-
!                                   VECS=BACK-TRANSFORMED EIGENVECTORS
!        VECS  =  C*S               C   =UN-BACK-TRANSFORMED VECTORS
!                                   S   =1/SQRT(OVERLAP MATRIX)
!
!**********************************************************************
      do i = 1, n
        do j = 1, n
          sum = 0.D0
          do k = 1, n
            sum = sum + c(k,i)*s(j,k)
          end do
          vecs(j,i) = sum
        end do
      end do
      return
      end subroutine mult

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine nuchar(line, l_line, value, nvalue)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer, intent(in) :: l_line
      integer , intent(out) :: nvalue
      character  :: line*(*)
      double precision , intent(out) :: value(40)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(40) :: istart
      integer :: i
      logical :: leadsp
      character :: tab, comma, space
      double precision, external :: reada

      save comma, space
!-----------------------------------------------
!***********************************************************************
!
!   NUCHAR  DETERMINS AND RETURNS THE REAL VALUES OF ALL NUMBERS
!           FOUND IN 'LINE'. ALL CONNECTED SUBSTRINGS ARE ASSUMED
!           TO CONTAIN NUMBERS
!   ON ENTRY LINE    = CHARACTER STRING
!   ON EXIT  VALUE   = ARRAY OF NVALUE REAL VALUES
!
!***********************************************************************
      data comma, space/ ',', ' '/
      tab = char(9)
!
! CLEAN OUT TABS AND COMMAS
!
      do i = 1, l_line
        if (line(i:i)/=tab .and. line(i:i)/=comma) cycle
        line(i:i) = space
      end do
!
! FIND INITIAL DIGIT OF ALL NUMBERS, CHECK FOR LEADING SPACES FOLLOWED
!     BY A CHARACTER
!
      leadsp = .TRUE.
      nvalue = 0
      do i = 1, l_line
        if (leadsp .and. line(i:i)/=space) then
          nvalue = nvalue + 1
          istart(nvalue) = i
        end if
        leadsp = line(i:i) == space
      end do
!
! FILL NUMBER ARRAY
!
      do i = 1, nvalue
        value(i) = reada(line,istart(i))
      end do
      return
      end subroutine nuchar

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

module get_det
  implicit none
contains
  recursive function determinant(matrix, n) result(det)
!
! Evaluate the determinant of the matrix "matrix"
!
! On input,  matrix      = square matrix of size "n"
! On output, det         = value of the determinant of matrix "matrix"
!
    implicit none
    integer, intent (in) :: n
    double precision, intent (in) :: matrix(n,n)
!
! Local variables
!
    double precision :: det
    integer :: i
    double precision :: sum
    double precision, allocatable :: cf(:,:)
    if (n == 0) then
      sum = 1.d0
    else if (n == 1) then
      sum = matrix(1,1)
    else
      sum = 0
      do i = 1, n
        allocate(cf(n - 1, n - 1))
        cf = cofactor(matrix, n, i)
        sum = sum + ((-1)**(i + 1))*matrix(i, 1)*determinant(cf, n - 1)
        deallocate(cf)
      end do
    end if
    det = sum
  end function determinant
!
  function cofactor(matrix, n, mI)
    implicit none
    integer, intent (in) :: n, mI
    double precision, intent (in) :: matrix(n, n)
!
! Local variables
!
    integer ::  i, j, k, l
    double precision, dimension(:,:), allocatable :: cofactor
    allocate(cofactor(n - 1, n - 1))
    l = 0
    k = 1
    do i = 1, n
      if (i /= mI) then
        l = 1
        do j = 2, n
          cofactor(k, l) = matrix(i, j)
          l = l + 1
        end do
        k = k + 1
      end if
    end do
    return
  end function cofactor
end module

  double precision function charst (vects, ntype, istate, ioper, r,nvecs, first)
!-----------------------------------------------
!   M o d u l elem s
!-----------------------------------------------
      USE meci_C, only : nalmat, microa, microb, lab, conf, nmos
      use chanel_C, only : iw
      use symmetry_C, only : elem, jelem
      use molkst_C, only : keywrd, numat, norbs
      use get_det
      implicit none
      integer , intent(in) :: istate
      integer  :: ioper
      integer , intent(in) :: nvecs
      logical  :: first
      integer , intent(in) :: ntype(norbs)
      double precision , intent(in) :: vects(nvecs,nmos)
      double precision  :: r(3,3)
!-----------------------------------------------
!   L o c a l   P a r a m elem t elem r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l elem s
!-----------------------------------------------
      integer , dimension(2,3) :: ip
      integer , dimension(2,5) :: id
      integer , dimension(2,9) :: loc
      integer , dimension(:), allocatable :: iphase
      integer , dimension(:,:), allocatable :: iperma, ipermb
      integer :: nstate, j, i, iloop, iatom, jatom, ibase, kj, icheck, jcheck, &
        ii, jj, k, l, ne, nai, nbi
      double precision, dimension(:,:), allocatable :: vect1, vect2
      double precision :: h(5), p(3), d(5), matrix(36)
      double precision, dimension(:,:), allocatable :: t2, t4
      double precision, dimension(:), allocatable :: work
      double precision :: sum, det, suma, sumb
      logical :: posita, positb, debug
      double precision, external :: ddot
!***********************************************************************
!
!    CHARST evaluates the character of the State ISTATE under the
!           operation IOPER.
!
!   Info:   VECTS  = Molecular Orbitals
!           CONF   = State Eigenvectors
!           NVECS  = Number of atomic bases
!           NMOS   = Number of M.O.s in active space
!           NSTATE    = Number of Microstates in each State
!
!***********************************************************************
      data nstate/ 0/
      data posita, positb/ 2*.FALSE./
      save vect1, vect2, t2, t4, iphase, iperma, ipermb, work
      charst = 1.D0
      if (istate < 0) then
!
!   Reset MICROA and MICROB, if necessary.
!
        if (posita) then
          nalmat(:nstate) = nmos - nalmat(:nstate)
          microa(:nmos,:nstate) = 1 - microa(:nmos,:nstate)
        end if
        if (positb) then
          microb(:nmos,:nstate) = 1 - microb(:nmos,:nstate)
        end if
        charst = 0.D0
        if (allocated(vect1))  deallocate(vect1)
        if (allocated(vect2))  deallocate(vect2)
        if (allocated(t2))     deallocate(t2)
        if (allocated(t4))     deallocate(t4)
        if (allocated(iperma)) deallocate(iperma)
        if (allocated(ipermb)) deallocate(ipermb)
        if (allocated(work))   deallocate(work)
        if (allocated(iphase)) deallocate(iphase)
        return
      end if
      debug = index(keywrd,'CHARST')/=0 .and. index(keywrd,'DEBUG')/=0
!
!  Trivial case:  Operation is 'elem', the identity.
!
      charst = 1.D0
      if (ioper == 1) return
!
!   Non-trivial case
!
      if (istate == 1) then
        if (ioper == 2) then
         i = max(lab, nmos**2)
        allocate(vect1(nvecs,nmos), vect2(nvecs, nmos), t2(nmos, nmos), &
      & t4(lab,lab),iphase(lab), iperma(nmos + 3,lab), ipermb(nmos + 3,lab), &
      & work(i))
      end if
        nstate = lab
!
!    Set up the M.O. unitary matrix, <psi | IOPER | psi>
!
        do iloop = 1, nmos
          do iatom = 1, numat
            jatom = jelem(ioper,iatom)
            ibase = 0
            kj = 0
            do i = 1, nvecs
              icheck = ntype(i)/100
              if (icheck == iatom) then
                ibase = ibase + 1
                loc(1,ibase) = i
              end if
              if (icheck /= jatom) cycle
              kj = kj + 1
              loc(2,kj) = i
            end do
            if (ibase == 0) cycle
!
!   's'-type basis function
!
            icheck = loc(1,1)
            jcheck = loc(2,1)
            vect1(icheck,iloop) = vects(icheck,iloop)
            vect2(jcheck,iloop) = vects(icheck,iloop)
            if (ibase < 4) cycle
!
!    Atom I had a 'p' shell
!
            ip(1,:) = 0
            id(1,:3) = 0
            id(1,4) = 0
            id(1,5) = 0
            do i = 2, ibase
              icheck = loc(1,i)
              if (i <= 4) then
                p(i-1) = vects(icheck,iloop)
                ip(1,i-1) = loc(1,i)
                ip(2,i-1) = loc(2,i)
              else
                d(i-4) = vects(icheck,iloop)
                id(1,i-4) = loc(1,i)
                id(2,i-4) = loc(2,i)
              end if
            end do
            if (ibase /= 1) then
!
!    'p' transform
!
              h(1) = r(1,1)*p(1) + r(2,1)*p(2) + r(3,1)*p(3)
              h(2) = r(1,2)*p(1) + r(2,2)*p(2) + r(3,2)*p(3)
              h(3) = r(1,3)*p(1) + r(2,3)*p(2) + r(3,3)*p(3)
              p(1) = elem(1,1,ioper)*h(1) + elem(1,2,ioper)*h(2) + elem(1,3,ioper)*h(3)
              p(2) = elem(2,1,ioper)*h(1) + elem(2,2,ioper)*h(2) + elem(2,3,ioper)*h(3)
              p(3) = elem(3,1,ioper)*h(1) + elem(3,2,ioper)*h(2) + elem(3,3,ioper)*h(3)
              do i = 1, 3
                if (ip(1,i) < 1) return
                ii = ip(1,i)
                jj = ip(2,i)
                vect1(ii,iloop) = h(i)
                vect2(jj,iloop) = p(i)
              end do
            end if
            if (ibase /= 9) cycle
!
!   'd' transform
!
            h = d
            call dtrans (d, h, ioper, first, r)
            do i = 1, 5
              if (id(1,i) < 1) return
              ii = id(1,i)
              jj = id(2,i)
              vect1(ii,iloop) = h(i)
              vect2(jj,iloop) = d(i)
            end do
          end do
        end do
!
!    VECT1 holds the molecular orbitals in the coordinate system of
!          SYMTRZ.
!    VECT2 holds the same orbitals, after being operated on by the
!          symmetry operation IOPER.
!
!     T2 hold the unitary transform for the set of M.O.s
!        <Vect1|IOPER|VECT2>
!
        do i = 1, nmos
          do j = 1, nmos
            sum = 0.D0
            do k = 1, nvecs
              sum = sum + vect1(k,i)*vect2(k,j)
            end do
            t2(i,j) = sum
          end do
        end do
        if (debug) then
          write (iw, '(A)') ' Symmetry Operation in CHARST'
          write (iw, '(3F12.6)') ((elem(i,j,ioper),i=1,3),j=1,3)
          write (iw, '(A)') ' Transform of M.O.s'
          do i = 1, nmos
            write (iw, '(8F12.6)') (t2(j,i),j=1,nmos)
          end do
        end if
!***********************************************************************
!
!   For the microstates, take the positron equivalent if more than
!   half filled.
!
        if (ioper==2 .and. istate==1) then
          do i = 1, nstate
            l = 0
            do j = 1, nmos
              if (microa(j,i) == 0) cycle
              do k = j, nmos
                l = l + microb(k,i)
              end do
            end do
            iphase(i) = 1 - 2*mod(l,2)
          end do
          k = 0
          do i = 1, nmos
            k = k + microa(i,1)
          end do
!            NE=NE+K
          posita = k > nmos/2
          if (posita) then
            do j = 1, nstate
              nalmat(j) = nmos - nalmat(j)
              l = (2 - iphase(j))/2
              do i = 1, nmos
                if (microa(i,j) == 0) then
                  do k = i + 1, nmos
                    l = l + microa(k,j)
                  end do
                end if
                microa(i,j) = 1 - microa(i,j)
              end do
              iphase(j) = 1 - 2*mod(l,2)
            end do
          end if
          k = 0
          do i = 1, nmos
            k = k + microb(i,1)
          end do
          positb = k > nmos/2
          if (positb) then
            do j = 1, nstate
              l = (2 - iphase(j))/2
              do i = 1, nmos
                if (microb(i,j) == 0) then
                  do k = i + 1, nmos
                    l = l + microb(k,j)
                  end do
                end if
                microb(i,j) = 1 - microb(i,j)
              end do
              iphase(j) = 1 - 2*mod(l,2)
            end do
          end if
        end if
        ne = 0
        do i = 1, nmos
          ne = ne + microb(i,1) + microa(i,1)
        end do
!***********************************************************************
!
!   Now to work out the phase of the microstates.  The defined order
!   of M.O. occupancy is (alpha-1)(beta-1)(alpha-2)(beta-2) ...
!   If this order is permuted an odd number of times, the phase
!   will be negative.
!
        do i = 1, nstate
!
!    Load into IPERMA(1-2,I) and IPERMB(1-2,I) the locations of the
!    electrons.
!
          k = 0
          do j = 1, nmos
            if (microa(j,i) /= 1) cycle
            k = k + 1
            iperma(k,i) = j
          end do
          k = 0
          do j = 1, nmos
            if (microb(j,i) /= 1) cycle
            k = k + 1
            ipermb(k,i) = j
          end do
        end do
        if (posita .neqv. positb) then
!
!  Calculate determinant of M.O. transform in order to
!  define character of half-filled shell
!
          k = 0
          do i = 1, nmos
            work(k+1:nmos+k) = t2(i,:nmos)
            k = nmos + k
          end do
          call minv (work, nmos, det)
        else
          det = 1.D0
        end if
!
!   The big loop to fill T4
!
        do i = 1, nstate
          nai = nalmat(i)
          do j = 1, nstate
            if (nalmat(j) /= nai) cycle
             nbi = ne - nai
!
!    NAI = Number of alpha electrons
!    NBI = Number of beta electrons
!
! Fill the matrix for alpha electrons
!
            do ii = 1, nai
              do jj = 1,nai
                k = (ii - 1)*nai + jj
                matrix(k) = t2(iperma(jj,j),iperma(ii,i))
              end do
            end do
            suma = determinant(matrix, nai )
!
! Fill the matrix for beta electrons
!
            do ii = 1, nbi
              do jj = 1,nbi
                k = (ii - 1)*nbi + jj
                matrix(k) = t2(ipermb(jj,j),ipermb(ii,i))
              end do
            end do
            sumb = determinant(matrix, nbi )
            t4(i,j) = suma*sumb*iphase(i)*iphase(j)*det
          end do
        end do
        if (debug) then
          write (iw, *) ' State Transform for State', istate, &
            ' under Operation', ioper
          call matout (t4, t4, nstate, nstate, lab)
        end if
      end if
!
!    Now to perform <State(ISTATE) | Transform(IOPER) | State(ISTATE)>
!
      do j = 1, nstate
        sum = 0.D0
        do k = 1, nstate
          sum = sum + conf(k+(istate-1)*nstate)*t4(j,k)
        end do
        work(j) = sum
      end do
      sum = ddot(nstate,work(:nstate),1,conf(1+(istate-1)*nstate:istate*nstate),1)
      charst = sum
      return
      end function charst

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine deri1(number, grad, f, minear, fd, scalar, work)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE molkst_C, only : numat, nopen, numcal, keywrd, norbs, mpack, &
      & n2elec
      use chanel_C, only : iw
      use common_arrays_C, only : nfirst, nlast, eigb, p, pa, c, coord
      USE funcon_C, only : fpc_9
      use derivs_C, only : wmat, hmat, fmat
      use meci_C, only : nelec, nmos, lab, nbo, nstate, maxci, xy, vectci
      implicit none
      integer , intent(in) :: number
      integer , intent(in) :: minear
      double precision , intent(out) :: grad
      double precision  :: f(mpack)
      double precision  :: fd(mpack)
      double precision , intent(in) :: scalar(mpack)
      double precision, intent(out) :: work(norbs, norbs)
!
      integer ::  icalcn, nati, natx, i, l, j, nend, loop, ninit, n1&
        , n2, lcut, k, ll, ncol
      double precision :: const, step, enucl2, gse, sum
      logical :: debug
      double precision, external :: ddot, helect
      save debug, icalcn, const
!-----------------------------------------------
!********************************************************************
!
!     DERI1 COMPUTE THE NON-RELAXED DERIVATIVE OF THE NON-VARIATIONALLY
!     OPTIMIZED WAVEFUNCTION ENERGY WITH RESPECT TO ONE CARTESIAN
!     COORDINATE AT A TIME
!                             AND
!     COMPUTE THE NON-RELAXED FOCK MATRIX DERIVATIVE IN M.O BASIS AS
!     REQUIRED IN THE RELAXATION SECTION (ROUTINE 'DERI2').
!
!   INPUT
!     C(NORBS,NORBS) : M.O. COEFFICIENTS.
!     COORD  : CARTESIAN COORDINATES ARRAY.
!     NUMBER : LOCATION OF THE REQUIRED VARIABLE IN COORD.
!     WORK   : WORK ARRAY OF SIZE N*N.
!     WMAT     : WORK ARRAYS FOR d<PQ|RS> (2-CENTERS  A.O)
!   OUTPUT
!     C,COORD,NUMBER : NOT MODIFIED.
!     GRAD   : DERIVATIVE OF THE HEAT OF FORMATION WITH RESPECT TO
!              COORD(NUMBER), WITHOUT RELAXATION CORRECTION.
!     F(MINEAR) : NON-RELAXED FOCK MATRIX DERIVATIVE WITH RESPECT TO
!              COORD(NUMBER), EXPRESSED IN M.O BASIS, SCALED AND
!              PACKED, OFF-DIAGONAL BLOCKS ONLY.
!     FD     : IDEM BUT UNSCALED, DIAGONAL BLOCKS, C.I-ACTIVE ONLY.
!
!***********************************************************************
      data icalcn/ 0/
      n2 = 0
!
      if (icalcn /= numcal) then
        if(allocated(wmat)) deallocate(wmat)
        i = Max (n2elec + mpack, (lab*(lab+1))/2, 20*mpack, maxci*(maxci+1)/2)
        allocate(wmat(i))
        if(allocated(hmat)) deallocate(hmat)
        i = Max ((lab*(lab+1))/2, 20*minear, mpack)
        allocate(hmat(i))
        if(allocated(fmat)) deallocate(fmat)
        i = Max ((lab*(lab+1))/2, 20*minear, mpack)
        allocate(fmat(i))
        const = fpc_9
        debug = index(keywrd,'DERI1') /= 0
        icalcn = numcal
      end if
      if (debug) call timer ('BEFORE DERI1')
      step = 1.D-3
!
!     2 POINTS FINITE DIFFERENCE TO GET THE INTEGRAL DERIVATIVES
!     ----------------------------------------------------------
!     STORED IN HMAT AND WMAT, WITHOUT DIVIDING BY THE STEP SIZE.
!
      nati = (number - 1)/3 + 1
      natx = number - 3*(nati - 1)
      call dhcore (coord, hmat, wmat, enucl2, nati, natx, step)
!
! HMAT HOLDS THE ONE-ELECTRON DERIVATIVES OF ATOM NATI FOR DIRECTION
!      NATX W.R.T. ALL OTHER ATOMS
! WMAT HOLDS THE TWO-ELECTRON DERIVATIVES OF ATOM NATI FOR DIRECTION
!      NATX W.R.T. ALL OTHER ATOMS
      step = 0.5D0/step
!
!     NON-RELAXED FOCK MATRIX DERIVATIVE IN A.O BASIS.
!     ------------------------------------------------
!     STORED IN FMAT, DIVIDED BY STEP.
!
      call dcopy (mpack, hmat, 1, fmat, 1)
      call dfock2 (fmat, p, pa, wmat, numat, nfirst, nlast, nati)
!
!  FMAT HOLDS THE ONE PLUS TWO - ELECTRON DERIVATIVES OF ATOM NATI FOR
!       DIRECTION NATX W.R.T. ALL OTHER ATOMS
!
!       DERIVATIVE OF THE SCF-ONLY ENERGY (I.E BEFORE C.I CORRECTION)
!
      grad = (helect(norbs,p,hmat,fmat) + enucl2)*step
!     TAKE STEP INTO ACCOUNT IN FMAT
      fmat(:mpack) = fmat(:mpack)*step
!
!     RIGHT-HAND SIDE SUPER-VECTOR F = C' FMAT C USED IN RELAXATION
!     -----------------------------------------------------------
!     STORED IN NON-STANDARD PACKED FORM IN F(MINEAR) AND FD.
!     THE SUPERVECTOR IS THE NON-RELAXED FOCK MATRIX DERIVATIVE IN
!     M.O BASIS: F(IJ)= ( (C' * FOCK * C)(I,J) )   WITH I.GT.J .
!     F IS SCALED AND PACKED IN SUPERVECTOR FORM WITH
!                THE CONSECUTIVE FOLLOWING OFF-DIAGONAL BLOCKS:
!             1) OPEN-CLOSED  I.E. F(IJ)=F(I,J) WITH I OPEN & J CLOSED
!                                  AND I RUNNING FASTER THAN J,
!             2) VIRTUAL-CLOSED SAME RULE OF ORDERING,
!             3) VIRTUAL-OPEN   SAME RULE OF ORDERING.
!     FD IS PACKED OVER THE C.I-ACTIVE M.O WITH
!                THE CONSECUTIVE DIAGONAL BLOCKS:
!             1) CLOSED-CLOSED   IN CANONICAL ORDER, WITHOUT THE
!                                DIAGONAL ELEMENTS,
!             2) OPEN-OPEN       SAME RULE OF ORDERING,
!             3) VIRTUAL-VIRTUAL SAME RULE OF ORDERING.
!
!     PART 1 : WORK(N,N) = FMAT(N,N) * C(N,N)
      do i = 1, norbs
        call supdot (work(1,i), fmat, c(1,i), norbs)
      end do
!
!     PART 2 : F(IJ) =  (C' * WORK)(I,J) ... OFF-DIAGONAL BLOCKS.
      l = 1
      if (nbo(2)/=0 .and. nbo(1)/=0) then
!        OPEN-CLOSED
        ! TODO: GBR future modifications
        call mtxm (c(1,nbo(1)+1), nbo(2), work, norbs, f(l), nbo(1))
        l = l + nbo(2)*nbo(1)
      end if
      if (nbo(3)/=0 .and. nbo(1)/=0) then
!        VIRTUAL-CLOSED
        ! TODO: GBR future modifications
        call mtxm (c(1,nopen+1), nbo(3), work, norbs, f(l), nbo(1))
        l = l + nbo(3)*nbo(1)
      end if
!        VIRTUAL-OPEN
      ! TODO: GBR future modifications
      if (nbo(3)/=0 .and. nbo(2)/=0) &
      call mtxm (c(1,nopen+1), nbo(3), work(1,nbo(1)+1), norbs, f(l), nbo(2))
!     SCALE F ACCORDING TO THE DIAGONAL METRIC TENSOR 'SCALAR '.
      f(:minear) = f(:minear)*scalar(:minear)
      if (debug) then
        write (iw, *) ' F IN DERI1'
        j = min(20,minear)
        write (iw, '(5F12.6)') (f(i),i=1,j)
      end if
!
!     PART 3 : SUPER-VECTOR FD, C.I-ACTIVE DIAGONAL BLOCKS, UNSCALED.
      l = 1
      nend = 0
      do loop = 1, 3
        ninit = nend + 1
        nend = nend + nbo(loop)
        n1 = max(ninit,nelec + 1)
        n2 = min(nend,nelec + nmos)
        if (n2 < n1) cycle
        do i = n1, n2
          if (i <= ninit) cycle
          call mxm (c(1,i), 1, work(1,ninit), norbs, fd(l), i - ninit)
          l = l + i - ninit
        end do
      end do
      ncol = n2 - ninit + 1
      if (ncol > 0 .and. n2 < norbs) then
        ! TODO: GBR future modifications
        call mtxm (c(1, n2+1), norbs-n2, work(1,ninit), norbs, fd(l), ncol)
        l = l + ncol * (norbs-n2)
      end if
!
!     NON-RELAXED C.I CORRECTION TO THE ENERGY DERIVATIVE.
!     ----------------------------------------------------
!
!     C.I-ACTIVE FOCK EIGENVALUES DERIVATIVES, STORED IN FD(CONTINUED).
      lcut = l
      do i = nelec + 1, nelec + nmos
        fd(l) = ddot(norbs,c(1,i),1,work(1,i),1)
        l = l + 1
      end do
!
!     C.I-ACTIVE 2-ELECTRONS INTEGRALS DERIVATIVES. STORED IN XY.
!   FMAT IS USED HERE AS SCRATCH SPACE
!
      call dijkl1 (c(1,nelec+1), norbs, nati, wmat, fmat, hmat, fmat, xy)
      xy(:nmos,:nmos,:nmos,:nmos) = xy(:nmos,:nmos,:nmos,:nmos)*step
!
!     BUILD THE C.I MATRIX DERIVATIVE, STORED IN WMAT.
      call mecid (fd(lcut), gse, eigb, work, xy)
      if (debug) then
        write (iw, *) ' GSE:', gse
        write (iw, *) ' EIGB:', (eigb(i),i=1,10)
        write (iw, *) ' WORK:', (work(i,1),i=1,10)
      end if
      call mecih (work, wmat, nmos, lab, xy)
!
!     NON-RELAXED C.I CONTRIBUTION TO THE ENERGY DERIVATIVE.
      sum = 0.D0
      do i = 1, nstate
        j = (i - 1)*lab + 1
        call supdot (work, wmat, vectci(j), lab)
        sum = sum + ddot(lab,vectci(j),1,work,1)
      end do
      grad = (grad + sum/nstate)*const
      if (debug) then
        write (iw, '('' * * * GRADIENT COMPONENT NUMBER'',I4)') number
        write (iw, &
      '('' NON-RELAXED C.I-ACTIVE FOCK EIGENVALUES DERIVATIVES (E.V.)'')')
        write (iw, '(8F10.4)') (fd(lcut-1+i),i=1,nmos)
        write (iw, '('' NON-RELAXED 2-ELECTRONS DERIVATIVES (E.V.)''/  &
        &''    I    J    K    L       d<I(1)J(1)|K(2)L(2)>'')')
        do i = 1, nmos
          do j = 1, i
            do k = 1, i
              ll = k
              if (k == i) ll = j
              do l = 1, ll
                write (iw, '(4I5,F20.10)') nelec + i, nelec + j, nelec + k, nelec + l, xy(i,j,k,l)
              end do
            end do
          end do
        end do
        write (iw, '('' NON-RELAXED GRADIENT COMPONENT'',F10.4,'' KCAL/MOLE'')') grad
        call timer ('AFTER DERI1')
      end if
      return
      end subroutine deri1

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine mxmt(a, nar, b, nbr, c, ncc)
      implicit none
      integer  :: nar
      integer  :: nbr
      integer  :: ncc
      double precision  :: a(nar,nbr)
      double precision  :: b(ncc,nbr)
      double precision  :: c(nar,ncc)
!
!     MATRIX PRODUCT C(NAR,NCC) = A(NAR,NBR) * (B(NCC,NBR))'
!     ALL MATRICES RECTANGULAR , PACKED.
!
      call dgemm ('N', 'T', nar, ncc, nbr, 1.0D0, a, nar, b, ncc, 0.0D0, c, nar)
      return
      end subroutine mxmt

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine prtlmo ()
    use molkst_C, only: norbs, keywrd, numat
!
    use MOZYME_C, only: isort, nncf, icocc, ncocc, &
       & cocc, ncf, nnce, icvir, ncvir, cvir, nce, noccupied, nvirtual
!
    use common_arrays_C, only : eigs
!
    use chanel_C, only: iw
    implicit none
    integer :: i
    character :: num_1*1
    if (.not. Allocated (isort)) then
      allocate (isort(norbs), stat=i)
      if (i /= 0) then
        call memory_error ("prtlmo")
        return
      end if
      isort = 0
    end if
    num_1 = char(ichar("1") +int(log10(numat + 0.05)))
    write (iw,'(10x,a)') "LOCALIZED MOLECULAR ORBITALS"
   !
   !                Print the occupied set of LMOs
   !
    write (iw,'(/10x,a,/)') " Occupied Set"
    write (iw, "("//num_1//"x,'NUMBER OF CENTERS  LMO ENERGY     COMPOSITION OF ORBITALS ')")
    write (iw, "("//num_1//"x,34x,'(AS PERCENT OF THE LMO)',/)")
    call prtlmn (nncf, icocc, ncocc, cocc, ncf, isort, eigs, noccupied, 0)
    if (index(keywrd, " ALLVEC") /= 0) then
   !
   !                Print the virtual set of LMOs
   !
      write (iw,'(/10x,a,/)') " Virtual Set (NOT re-localized!)"
      write (iw, "("//num_1//"x,'NUMBER OF CENTERS  LMO ENERGY     COMPOSITION OF ORBITALS ')")
      write (iw, "("//num_1//"x,34x,'(AS PERCENT OF THE LMO)',/)")
      call prtlmn (nnce, icvir, ncvir, cvir, nce, isort(noccupied + 1:), &
           & eigs(noccupied + 1:), nvirtual, noccupied)
    else
      write (iw,'(/10x,a,/)') "To print Virtual Set as well, use keyword ""ALLVEC"""
    end if
    return
end subroutine prtlmo
subroutine prtlmn (nncx, icxxx, ncxxx, cxxx, ncx, isort, eigs, mmos, i_offset)
   !***********************************************************************
   !
   !  PRTLMN (PRTLMO) prints the Localized Molecular Orbitals as the
   !         scalar of the atomic contribution for the top few atoms.
   !  The value is multipled by 100, and printed as a percentage.
   !
   !***********************************************************************
    use MOZYME_C, only: iorbs, noccupied
!
    use molkst_C, only: norbs, numat
!
    use chanel_C, only: iw
!
    use elemts_C, only: elemnt
!
    use common_arrays_C, only : nat
!
    implicit none
    integer, intent (in) :: mmos, i_offset
    integer, dimension (norbs), intent (inout) :: isort
    integer, dimension (*), intent (in) :: ncx, nncx, ncxxx
    integer, dimension (*), intent (in) :: icxxx
    double precision, dimension (norbs), intent (in) :: eigs
    double precision, dimension (*), intent (in) :: cxxx
!
    integer :: i, ii, iunsrt, j, jl, ju, k, kk, l, lj, loop, m, n, nj, ibig(100), jbig(100)
    double precision :: const, sum, eig_min, xbig(100)
    double precision, dimension(:), allocatable :: w, eigs_temp
    integer, dimension(:), allocatable :: iscrch, jat
    character :: num_1*1, num_2*1

    allocate (w(Max(1,noccupied*20)), iscrch(Max(1,noccupied*20)), jat(norbs), &
            stat=i)
    if (i /= 0) then
      call memory_error ("prtlmo")
      return
    end if
!
! Construct map of LMO energy levels
!
    allocate (eigs_temp(mmos))
    eigs_temp(:mmos) = eigs(:mmos)
    do i = 1, mmos
      eig_min = 1.d7
      ii = 0
      do j = 1, mmos
        if (eigs_temp(j) < eig_min) then
          eig_min = eigs_temp(j)
          ii = j
        end if
      end do
      isort(i) = ii
      eigs_temp(ii) = 1.d8
    end do
   !
   !   Put LMO contributions per atom into an atom-based array
   !   Store number of atoms in each LMO in JAT
   !   Store number of times an atom is used in the LMOs in IAT
   !   Store the address of each atom in the square array IM
   !
    j = 0
    const = 2.d-4
    do iunsrt = 1, mmos
      i = isort(iunsrt)
      n = ncxxx(i)
      k = 0
      do ii = nncx(i) + 1, nncx(i) + ncx(i)
        l = icxxx(ii)
        nj = iorbs(l)
        sum = 0.d0
        do m = 1, nj
          sum = sum + cxxx(m+n) ** 2
        end do
        if (sum > const) then
          j = j + 1
          k = k + 1
          iscrch(j) = l
          w(j) = sum * 2.d0
        end if
        n = n + nj
      end do
      !
      !   JAT holds the number of atoms that are important in the LMO(I)
      !
      jat(i) = k
    end do
    ju = 0
    num_1 = char(ichar("3") +int(log10(numat + 0.05)))
    num_2 = char(ichar("2") +int(log10(norbs + 0.05)))
    do iunsrt = 1, mmos
      i = isort(iunsrt)
      jl = ju + 1
      ju = jl + jat(i) - 1
      k = 0
      do j = jl, ju
        k = k + 1
        xbig(k) = w(j)
        ibig(k) = iscrch(j)
      end do
      kk = Min (20, k)
      do loop = 1, kk
        sum = -1.d0
        l = 0
        lj = 0
        do j = loop, k
          if (xbig(j) > sum) then
            sum = xbig(j)
            l = ibig(j)
            lj = j
          end if
        end do
        if (sum < const*100.d0) exit
        xbig(lj) = xbig(loop)
        ibig(lj) = ibig(loop)
        jbig(loop) = Int (sum/const)
        ibig(loop) = l
      end do
      loop = loop - 1
      sum = 0.d0
      do j = 1, loop
        sum = sum + jbig(j)**2
      end do
      k = iunsrt + i_offset
      sum = 1.d8/sum
      if (loop == 1) then
        if (jbig(1)*0.01d0> 99.949d0) then
          write (iw, '(i'//num_1//',f10.4,f17.5, 3x,a2,i'//num_2//',f6.1)') &
                & k, sum,eigs(i), elemnt(nat(ibig(1))),ibig(1),jbig(1)*0.01d0
        else
          write (iw, '(i'//num_1//',f10.4,f17.5, 3x,a2,i'//num_2//',f6.2)') &
                & k, sum,eigs(i), elemnt(nat(ibig(1))),ibig(1),jbig(1)*0.01d0
        end if
      else
        if (loop < 6) then
          write (iw, '(i'//num_1//',f10.4,f17.5, 4(5(3x,a2,i'//num_2//',f6.2)))') &
          k, sum,eigs(i), (elemnt(nat(ibig(j))),ibig(j),jbig(j)*0.01d0, j=1, loop)
        else
          write (iw, '(i'//num_1//',f10.4,f17.5, 4(5(3x,a2,i'//num_2//',f6.2),/,'//num_1//'x,27x))') &
          k, sum,eigs(i), (elemnt(nat(ibig(j))),ibig(j),jbig(j)*0.01d0, j=1, loop)
        end if
      end if
    end do
    deallocate (w, iscrch, jat)
    return
  end subroutine prtlmn

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine densit(c, mdim, norbs, nocc, occ, nfract, fract, p, mode)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: mdim
      integer , intent(in) :: norbs
      integer , intent(in) :: nocc
      integer , intent(in) :: nfract
      integer , intent(in) :: mode
      double precision , intent(in) :: occ, fract
      double precision , intent(in) :: c(mdim,mdim)
      double precision , intent(inout) :: p((norbs*(norbs + 1))/2)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: norbs2, nl2, nu2, nl1, nu1, l, i, j
      double precision :: sign, frac, const, sum2, sum1
!-----------------------------------------------
!***********************************************************************
!
!   DENSIT COMPUTES THE DENSITY MATRIX GIVEN THE EIGENVECTOR MATRIX, AND
!          INFORMATION ABOUT THE M.O. OCCUPANCY.
!
!  INPUT:  C     = SQUARE EIGENVECTOR MATRIX, C IS OF SIZE MDIM BY MDIM
!                  AND THE EIGENVECTORS ARE STORED IN THE TOP LEFT-HAND
!                  CORNER.
!          NORBS = NUMBER OF ORBITALS
!          NOCC  = NUMBER OF FULLY-OCCUPIED M.O.S
!          occ   = NUMBER OF FRACTIONALLY OCCUPIED M.O.S.
!          MODE  = 2 IF POSITRON EQUIVALENT IS NOT TO BE USED
!
!   ON EXIT: P   = DENSITY MATRIX
!
!***********************************************************************
!
! SET UP LIMITS FOR SUMS
!  NL1 = BEGINING OF ONE ELECTRON SUM
!  NU1 = END OF SAME
!  NL2 = BEGINING OF TWO ELECTRON SUM
!  NU2 = END OF SAME
!
      norbs2 = norbs/2
      if (nocc /= 0 .and. nfract > norbs2 .and. mode /= 2) then
!
!    TAKE POSITRON EQUIVALENT
!
        sign = -1.d0
        frac = occ - fract
        const = occ
        nl2 = nfract + 1
        nu2 = norbs
        nl1 = nocc + 1
        nu1 = nfract
      else
!
!    TAKE ELECTRON EQUIVALENT
!
        sign = 1.d0
        frac = fract
        const = 0.d0
        nl2 = 1
        nu2 = nocc
        nl1 = nocc + 1
        nu1 = nfract
      end if
      l = 0
      do i = 1, norbs
        do j = 1, i
          l = l + 1
          sum1 = 0.D0
          sum2 = sum(c(i,nl2:nu2)*c(j,nl2:nu2))
          sum2 = sum2*occ
          sum1 = sum(c(i,nl1:nu1)*c(j,nl1:nu1))
          p(l) = (sum2 + sum1*frac)*sign
        end do
        p(l) = const + p(l)
      end do
      return
      end subroutine densit

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine repp(ni, nj, rij, ri, core, cutoff, a0, ev, ev1, ev2, ev3, ev4) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      use parameters_C, only : natorb, am, ad, aq, dd, qq, tore

!***********************************************************************
!
!..VECTOR VERSION WRITTEN BY ERNEST R. DAVIDSON, INDIANA UNIVERSITY
!
!
!  REPP CALCULATES THE TWO-ELECTRON REPULSION INTEGRALS AND THE
!       NUCLEAR ATTRACTION INTEGRALS.
!
!     ON INPUT RIJ     = INTERATOMIC DISTANCE
!              NI      = ATOM NUMBER OF FIRST ATOM
!              NJ      = ATOM NUMBER OF SECOND ATOM
!    (REF)     ADD     = ARRAY OF GAMMA, OR TWO-ELECTRON ONE-CENTER,
!                        INTEGRALS.
!    (REF)     TORE    = ARRAY OF NUCLEAR CHARGES OF THE ELEMENTS
!    (REF)     DD      = ARRAY OF DIPOLE CHARGE SEPARATIONS
!    (REF)     QQ      = ARRAY OF QUADRUPOLE CHARGE SEPARATIONS
!              CUTOFF  = MAXIMUM DISTANCE FOR 'NORMAL' INTERACTION.
!                        BEYOND CUTOFF ALL INTERACTIONS BECOME
!                        POINT-CHARGE, AND ARE BROUGHT IN TO
!                        CUTOFF.
!
!
!    ON OUTPUT RI      = ARRAY OF TWO-ELECTRON REPULSION INTEGRALS
!              CORE    = 4 X 2 ARRAY OF ELECTRON-CORE ATTRACTION
!                        INTEGRALS
!
!
! *** THIS ROUTINE COMPUTES THE TWO-CENTRE REPULSION INTEGRALS AND THE
! *** NUCLEAR ATTRACTION INTEGRALS.
! *** THE TWO-CENTRE REPULSION INTEGRALS (OVER LOCAL COORDINATES) ARE
! *** STORED AS FOLLOWS (WHERE P-SIGMA = O,  AND P-PI = P AND P* )
!     (SS/SS)=1,   (SO/SS)=2,   (OO/SS)=3,   (PP/SS)=4,   (SS/OS)=5,
!     (SO/SO)=6,   (SP/SP)=7,   (OO/SO)=8,   (PP/SO)=9,   (PO/SP)=10,
!     (SS/OO)=11,  (SS/PP)=12,  (SO/OO)=13,  (SO/PP)=14,  (SP/OP)=15,
!     (OO/OO)=16,  (PP/OO)=17,  (OO/PP)=18,  (PP/PP)=19,  (PO/PO)=20,
!     (PP/P*P*)=21,   (P*P/P*P)=22.
! *** THE STORAGE OF THE NUCLEAR ATTRACTION INTEGRALS  CORE(KL/IJ) IS
!     (SS/)=1,   (SO/)=2,   (OO/)=3,   (PP/)=4
!     WHERE IJ=1 IF THE ORBITALS CENTRED ON ATOM I,  =2 IF ON ATOM J.
! *** NI AND NJ ARE THE ATOMIC NUMBERS OF THE TWO ELEMENTS.
!
!***********************************************************************
!***********************************************************************
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: ni 
      integer , intent(in) :: nj 
      double precision , intent(in) :: rij 
      double precision , intent(in) :: cutoff 
      double precision , intent(in) :: a0 
      double precision , intent(in) :: ev 
      double precision , intent(in) :: ev1 
      double precision , intent(in) :: ev2 
      double precision , intent(in) :: ev3 
      double precision , intent(in) :: ev4 
      double precision , intent(out) :: ri(22) 
      double precision , intent(out) :: core(4,2) 

!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i 
      double precision, dimension(72) :: arg, sqr 
      double precision :: td, pp, r, aee, da, qa, ade, aqe, rsq, xxx, ee, db, qb, &
        aed, aeq, axx, adq, aqd, aqq, yyy, zzz, www, dze, qzze, qxxe, edz, eqzz&
        , eqxx, dxdx, dzdz, dzqxx, qxxdz, dzqzz, qzzdz, qxxqxx, qxxqyy, qxxqzz&
        , qzzqxx, qzzqzz, dxqxz, qxzdx, qxzqxz 
      logical :: si, sj 

      save td, pp 
!-----------------------------------------------
      data td/ 2.D00/  
      data pp/ 0.5D00/  
      ri = 0.D0 
      core(:,1) = 0.D0 
      core(:,2) = 0.D0 
      r = min(cutoff,rij)/a0 
        si = natorb(ni) >= 3 
        sj = natorb(nj) >= 3 
        aee = pp/am(ni) + pp/am(nj) 
        aee = aee*aee 
        if (.not.si .and. .not.sj) then 
!
!     HYDROGEN - HYDROGEN  (SS/SS)
!         
          ri(1) = ev/sqrt(r*r + aee) 
          core(1,1) = tore(nj)*ri(1) 
          core(1,2) = tore(ni)*ri(1) 
!
        else if (si .and. .not.sj) then 
!
!     HEAVY ATOM - HYDROGEN
!
          da = dd(ni) 
          qa = qq(ni)*td 
          ade = pp/ad(ni) + pp/am(nj) 
          ade = ade*ade 
          aqe = pp/aq(ni) + pp/am(nj) 
          aqe = aqe*aqe 
          rsq = r*r 
          arg(1) = rsq + aee 
          xxx = r + da 
          arg(2) = xxx*xxx + ade 
          xxx = r - da 
          arg(3) = xxx*xxx + ade 
          xxx = r + qa 
          arg(4) = xxx*xxx + aqe 
          xxx = r - qa 
          arg(5) = xxx*xxx + aqe 
          arg(6) = rsq + aqe 
          arg(7) = arg(6) + qa*qa 
          do i = 1, 7 
            sqr(i) = sqrt(arg(i)) 
          end do 
          ee = ev/sqr(1) 
          ri(1) = ee 
          ri(2) = ev1/sqr(2) - ev1/sqr(3) 
          ri(3) = ee + ev2/sqr(4) + ev2/sqr(5) - ev1/sqr(6) 
          ri(4) = ee + ev1/sqr(7) - ev1/sqr(6) 
          if (rij > cutoff) then 
!
!   Convert RI to point-charge system
!
            ri = 0.D0 
            ri(1) = ee 
            ri(3) = ee 
            ri(4) = ee 
          end if 
          core(1,1) = tore(nj)*ri(1) 
          core(1,2) = tore(ni)*ri(1) 
          core(2,1) = tore(nj)*ri(2) 
          core(3,1) = tore(nj)*ri(3) 
          core(4,1) = tore(nj)*ri(4) 
!
        else if (.not.si .and. sj) then 
!
!     HYDROGEN - HEAVY ATOM
!
          db = dd(nj) 
          qb = qq(nj)*td 
          aed = pp/am(ni) + pp/ad(nj) 
          aed = aed*aed 
          aeq = pp/am(ni) + pp/aq(nj) 
          aeq = aeq*aeq 
          rsq = r*r 
          arg(1) = rsq + aee 
          xxx = r - db 
          arg(2) = xxx*xxx + aed 
          xxx = r + db 
          arg(3) = xxx*xxx + aed 
          xxx = r - qb 
          arg(4) = xxx*xxx + aeq 
          xxx = r + qb 
          arg(5) = xxx*xxx + aeq 
          arg(6) = rsq + aeq 
          arg(7) = arg(6) + qb*qb 
          do i = 1, 7 
            sqr(i) = sqrt(arg(i)) 
          end do 
          ee = ev/sqr(1) 
          ri(1) = ee 
          ri(5) = ev1/sqr(2) - ev1/sqr(3) 
          ri(11) = ee + ev2/sqr(4) + ev2/sqr(5) - ev1/sqr(6) 
          ri(12) = ee + ev1/sqr(7) - ev1/sqr(6) 
          if (rij > cutoff) then 
!
!   Convert RI to point-charge system
!
            ri = 0.D0 
            ri(1) = ee 
            ri(11) = ee 
            ri(12) = ee 
          end if 
          core(1,1) = tore(nj)*ri(1) 
          core(1,2) = tore(ni)*ri(1) 
          core(2,2) = tore(ni)*ri(5) 
          core(3,2) = tore(ni)*ri(11) 
          core(4,2) = tore(ni)*ri(12) 
!
        else 
!
!     HEAVY ATOM - HEAVY ATOM
!
!     DEFINE CHARGE SEPARATIONS.
          da = dd(ni) 
          db = dd(nj) 
          qa = qq(ni)*td 
          qb = qq(nj)*td 
!
          ade = pp/ad(ni) + pp/am(nj) 
          ade = ade*ade 
          aqe = pp/aq(ni) + pp/am(nj) 
          aqe = aqe*aqe 
          aed = pp/am(ni) + pp/ad(nj) 
          aed = aed*aed 
          aeq = pp/am(ni) + pp/aq(nj) 
          aeq = aeq*aeq 
          axx = pp/ad(ni) + pp/ad(nj) 
          axx = axx*axx 
          adq = pp/ad(ni) + pp/aq(nj) 
          adq = adq*adq 
          aqd = pp/aq(ni) + pp/ad(nj) 
          aqd = aqd*aqd 
          aqq = pp/aq(ni) + pp/aq(nj) 
          aqq = aqq*aqq 
          rsq = r*r 
          arg(1) = rsq + aee 
          xxx = r + da 
          arg(2) = xxx*xxx + ade 
          xxx = r - da 
          arg(3) = xxx*xxx + ade 
          xxx = r - qa 
          arg(4) = xxx*xxx + aqe 
          xxx = r + qa 
          arg(5) = xxx*xxx + aqe 
          arg(6) = rsq + aqe 
          arg(7) = arg(6) + qa*qa 
          xxx = r - db 
          arg(8) = xxx*xxx + aed 
          xxx = r + db 
          arg(9) = xxx*xxx + aed 
          xxx = r - qb 
          arg(10) = xxx*xxx + aeq 
          xxx = r + qb 
          arg(11) = xxx*xxx + aeq 
          arg(12) = rsq + aeq 
          arg(13) = arg(12) + qb*qb 
          xxx = da - db 
          arg(14) = rsq + axx + xxx*xxx 
          xxx = da + db 
          arg(15) = rsq + axx + xxx*xxx 
          xxx = r + da - db 
          arg(16) = xxx*xxx + axx 
          xxx = r - da + db 
          arg(17) = xxx*xxx + axx 
          xxx = r - da - db 
          arg(18) = xxx*xxx + axx 
          xxx = r + da + db 
          arg(19) = xxx*xxx + axx 
          xxx = r + da 
          arg(20) = xxx*xxx + adq 
          arg(21) = arg(20) + qb*qb 
          xxx = r - da 
          arg(22) = xxx*xxx + adq 
          arg(23) = arg(22) + qb*qb 
          xxx = r - db 
          arg(24) = xxx*xxx + aqd 
          arg(25) = arg(24) + qa*qa 
          xxx = r + db 
          arg(26) = xxx*xxx + aqd 
          arg(27) = arg(26) + qa*qa 
          xxx = r + da - qb 
          arg(28) = xxx*xxx + adq 
          xxx = r - da - qb 
          arg(29) = xxx*xxx + adq 
          xxx = r + da + qb 
          arg(30) = xxx*xxx + adq 
          xxx = r - da + qb 
          arg(31) = xxx*xxx + adq 
          xxx = r + qa - db 
          arg(32) = xxx*xxx + aqd 
          xxx = r + qa + db 
          arg(33) = xxx*xxx + aqd 
          xxx = r - qa - db 
          arg(34) = xxx*xxx + aqd 
          xxx = r - qa + db 
          arg(35) = xxx*xxx + aqd 
          arg(36) = rsq + aqq 
          xxx = qa - qb 
          arg(37) = arg(36) + xxx*xxx 
          xxx = qa + qb 
          arg(38) = arg(36) + xxx*xxx 
          arg(39) = arg(36) + qa*qa 
          arg(40) = arg(36) + qb*qb 
          arg(41) = arg(39) + qb*qb 
          xxx = r - qb 
          arg(42) = xxx*xxx + aqq 
          arg(43) = arg(42) + qa*qa 
          xxx = r + qb 
          arg(44) = xxx*xxx + aqq 
          arg(45) = arg(44) + qa*qa 
          xxx = r + qa 
          arg(46) = xxx*xxx + aqq 
          arg(47) = arg(46) + qb*qb 
          xxx = r - qa 
          arg(48) = xxx*xxx + aqq 
          arg(49) = arg(48) + qb*qb 
          xxx = r + qa - qb 
          arg(50) = xxx*xxx + aqq 
          xxx = r + qa + qb 
          arg(51) = xxx*xxx + aqq 
          xxx = r - qa - qb 
          arg(52) = xxx*xxx + aqq 
          xxx = r - qa + qb 
          arg(53) = xxx*xxx + aqq 
          qa = qq(ni) 
          qb = qq(nj) 
          xxx = da - qb 
          xxx = xxx*xxx 
          yyy = r - qb 
          yyy = yyy*yyy 
          zzz = da + qb 
          zzz = zzz*zzz 
          www = r + qb 
          www = www*www 
          arg(54) = xxx + yyy + adq 
          arg(55) = xxx + www + adq 
          arg(56) = zzz + yyy + adq 
          arg(57) = zzz + www + adq 
          xxx = qa - db 
          xxx = xxx*xxx 
          yyy = qa + db 
          yyy = yyy*yyy 
          zzz = r + qa 
          zzz = zzz*zzz 
          www = r - qa 
          www = www*www 
          arg(58) = zzz + xxx + aqd 
          arg(59) = www + xxx + aqd 
          arg(60) = zzz + yyy + aqd 
          arg(61) = www + yyy + aqd 
          xxx = qa - qb 
          xxx = xxx*xxx 
          arg(62) = arg(36) + td*xxx 
          yyy = qa + qb 
          yyy = yyy*yyy 
          arg(63) = arg(36) + td*yyy 
          arg(64) = arg(36) + td*(qa*qa + qb*qb) 
          zzz = r + qa - qb 
          zzz = zzz*zzz 
          arg(65) = zzz + xxx + aqq 
          arg(66) = zzz + yyy + aqq 
          zzz = r + qa + qb 
          zzz = zzz*zzz 
          arg(67) = zzz + xxx + aqq 
          arg(68) = zzz + yyy + aqq 
          zzz = r - qa - qb 
          zzz = zzz*zzz 
          arg(69) = zzz + xxx + aqq 
          arg(70) = zzz + yyy + aqq 
          zzz = r - qa + qb 
          zzz = zzz*zzz 
          arg(71) = zzz + xxx + aqq 
          arg(72) = zzz + yyy + aqq 
          do i = 1, 72 
            sqr(i) = sqrt(arg(i)) 
          end do 
          ee = ev/sqr(1) 
          dze = (-ev1/sqr(2)) + ev1/sqr(3) 
          qzze = ev2/sqr(4) + ev2/sqr(5) - ev1/sqr(6) 
          qxxe = ev1/sqr(7) - ev1/sqr(6) 
          edz = (-ev1/sqr(8)) + ev1/sqr(9) 
          eqzz = ev2/sqr(10) + ev2/sqr(11) - ev1/sqr(12) 
          eqxx = ev1/sqr(13) - ev1/sqr(12) 
          dxdx = ev1/sqr(14) - ev1/sqr(15) 
          dzdz = ev2/sqr(16) + ev2/sqr(17) - ev2/sqr(18) - ev2/sqr(19) 
          dzqxx = ev2/sqr(20) - ev2/sqr(21) - ev2/sqr(22) + ev2/sqr(23) 
          qxxdz = ev2/sqr(24) - ev2/sqr(25) - ev2/sqr(26) + ev2/sqr(27) 
          dzqzz = (-ev3/sqr(28)) + ev3/sqr(29) - ev3/sqr(30) + ev3/sqr(31) - &
            ev2/sqr(22) + ev2/sqr(20) 
          qzzdz = (-ev3/sqr(32)) + ev3/sqr(33) - ev3/sqr(34) + ev3/sqr(35) + &
            ev2/sqr(24) - ev2/sqr(26) 
          qxxqxx = ev3/sqr(37) + ev3/sqr(38) - ev2/sqr(39) - ev2/sqr(40) + ev2/&
            sqr(36) 
          qxxqyy = ev2/sqr(41) - ev2/sqr(39) - ev2/sqr(40) + ev2/sqr(36) 
          qxxqzz = ev3/sqr(43) + ev3/sqr(45) - ev3/sqr(42) - ev3/sqr(44) - ev2/&
            sqr(39) + ev2/sqr(36) 
          qzzqxx = ev3/sqr(47) + ev3/sqr(49) - ev3/sqr(46) - ev3/sqr(48) - ev2/&
            sqr(40) + ev2/sqr(36) 
          qzzqzz = ev4/sqr(50) + ev4/sqr(51) + ev4/sqr(52) + ev4/sqr(53) - ev3/&
            sqr(48) - ev3/sqr(46) - ev3/sqr(42) - ev3/sqr(44) + ev2/sqr(36) 
          dxqxz = (-ev2/sqr(54)) + ev2/sqr(55) + ev2/sqr(56) - ev2/sqr(57) 
          qxzdx = (-ev2/sqr(58)) + ev2/sqr(59) + ev2/sqr(60) - ev2/sqr(61) 
          qxzqxz = ev3/sqr(65) - ev3/sqr(67) - ev3/sqr(69) + ev3/sqr(71) - ev3/&
            sqr(66) + ev3/sqr(68) + ev3/sqr(70) - ev3/sqr(72) 
          ri(1) = ee 
          ri(2) = -dze 
          ri(3) = ee + qzze 
          ri(4) = ee + qxxe 
          ri(5) = -edz 
          ri(6) = dzdz 
          ri(7) = dxdx 
          ri(8) = (-edz) - qzzdz 
          ri(9) = (-edz) - qxxdz 
          ri(10) = -qxzdx 
          ri(11) = ee + eqzz 
          ri(12) = ee + eqxx 
          ri(13) = (-dze) - dzqzz 
          ri(14) = (-dze) - dzqxx 
          ri(15) = -dxqxz 
          ri(16) = ee + eqzz + qzze + qzzqzz 
          ri(17) = ee + eqzz + qxxe + qxxqzz 
          ri(18) = ee + eqxx + qzze + qzzqxx 
          ri(19) = ee + eqxx + qxxe + qxxqxx 
          ri(20) = qxzqxz 
          ri(21) = ee + eqxx + qxxe + qxxqyy 
          ri(22) = pp*(qxxqxx - qxxqyy) 
          if (rij > cutoff) then 
!
!   Convert RI to point-charge system
!
            ri = 0.D0 
            ri(1) = ee 
            ri(3) = ee 
            ri(4) = ee 
            ri(11) = ee 
            ri(12) = ee 
            ri(16) = ee 
            ri(17) = ee 
            ri(18) = ee 
            ri(19) = ee 
            ri(21) = ee 
          end if 
!
!     CALCULATE CORE-ELECTRON ATTRACTIONS.
!
          core(1,1) = tore(nj)*ri(1) 
          core(2,1) = tore(nj)*ri(2) 
          core(3,1) = tore(nj)*ri(3) 
          core(4,1) = tore(nj)*ri(4) 
          core(1,2) = tore(ni)*ri(1) 
          core(2,2) = tore(ni)*ri(5) 
          core(3,2) = tore(ni)*ri(11) 
          core(4,2) = tore(ni)*ri(12) 
!
        end if 
!
        return  
      end subroutine repp 

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine static_polarizability
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : keywrd, numat, natoms, nvar, escf, ndep
      use chanel_C, only : iw
      use common_arrays_C, only : geo, coord, nat, labels, na
      use elemts_C, only : elemnt
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j, k, l
      double precision, dimension(1) :: grad
      double precision, dimension(3,3) :: rotvec
      double precision :: sum, sumx, sumy, sumz, summax
      logical :: let
!-----------------------------------------------
!**********************************************************************
!
!   POLAR SETS UP THE CALCULATION OF THE MOLECULAR ELECTRIC RESPONSE
!   PROPERTIES BY FFHPOL.
!
!**********************************************************************
      let = index(keywrd,' LET') /= 0
      write (iw, 10)
   10 format(' ',20('*'),' FINITE-FIELD POLARIZABILITIES ',20('*'),/,/,&
        '    THE F-F METHOD IS PERFORMED USING BOTH AN ENERGY',/,&
        '    AND DIPOLE MOMENT EXPANSION.  THESE RESULTS ARE',/,&
        '    LISTED BELOW AS "H.o.F." AND "Dipole", RESPECTIVELY.')
      call gmetry (geo, coord)
!
!  Orient the molecule with the moments of inertia.
!  This is done to ensure a unique, reproduceable set of directions.
!  If LET is specified, the input orientation will be used.
!
      if (.not.let) then
        call axis (sumx, sumy, sumz, rotvec)
        write (iw, 20)
   20   format(/,' ROTATION MATRIX FOR ORIENTATION OF MOLECULE:'/)
        do i = 1, 3
          write (iw, 30) (rotvec(i,j),j=1,3)
   30     format(5x,3f12.6)
        end do
!
!  ROTATE ATOMS
!
        do i = 1, numat
          do j = 1, 3
            sum = 0.0D00
            do k = 1, 3
              sum = sum + coord(k,i)*rotvec(k,j)
            end do
            geo(j,i) = sum
          end do
        end do
        coord(:,:numat) = geo(:,:numat)
        write (iw, '(2/10X,''CARTESIAN COORDINATES '',/)')
        write (iw, &
      '(4X,''NO.'',7X,''ATOM'',9X,''X'',                       9X,''Y'',9X,''Z'&
      &',/)')
        l = 0
        do i = 1, numat
          if (nat(i)==99 .or. nat(i)==107) cycle
          l = l + 1
          write (iw, '(I6,8X,A2,4X,3F10.4)') l, elemnt(nat(i)), (coord(j,l),j=1,&
            3)
        end do
      end if
!
!
!  SET UP THE VARIABLES IN XPARAM AND LOC, THESE ARE IN CARTESIAN
!  COORDINATES.
!
      numat = 0
      sumx = 0.D0
      sumy = 0.D0
      sumz = 0.D0
      do i = 1, natoms
        if (labels(i)==99 .or. labels(i)==107) cycle
        numat = numat + 1
        labels(numat) = labels(i)
        sumx = sumx + coord(1,numat)
        sumy = sumy + coord(2,numat)
        sumz = sumz + coord(3,numat)
        geo(:,numat) = coord(:,numat)
      end do
      sumx = sumx/numat
      sumy = sumy/numat
      sumz = sumz/numat
      summax = 0.D0
      do i = 1, numat
        geo(1,i) = geo(1,i) - sumx
        summax = dmax1(abs(geo(1,i)),summax)
        geo(2,i) = geo(2,i) - sumy
        summax = dmax1(abs(geo(2,i)),summax)
        geo(3,i) = geo(3,i) - sumz
        summax = dmax1(abs(geo(3,i)),summax)
      end do
!
      ndep = 0
      natoms = numat
      nvar = 0
      na = 0
      call compfg (geo, .TRUE., escf, .TRUE., grad, .FALSE.)
      write (iw,"(/,/,' ENERGY OF ""REORIENTED"" SYSTEM WITHOUT FIELD:',f15.5,a)") &
      escf, " Kcal/mol"
!
      call ffhpol ()
!
      return
      end subroutine static_polarizability
!
      subroutine ffhpol()
      use molkst_C, only : keywrd, numat, efield,escf
      use common_arrays_C, only : geo, nat
      use parameters_C, only : tore
      use funcon_C, only : fpc_9, eV,a0, fpc_1, fpc_8
      use chanel_C, only : iw
      implicit none
!
      integer :: nbdip, nbcnt, ngcnt, id, ivl, kd, kvl, &
        idm1, jd, i3, counter
      double precision, dimension(3) :: eigs
      double precision, dimension(9) :: vectrs
      double precision, dimension(3) :: dipe4
      double precision, dimension(6) :: apole4
      double precision, dimension(3) :: dipdp
      double precision, dimension(6) :: apoldp
      double precision, dimension(3) :: dip1p, dip1m, dip2p, dip2m
      double precision :: autokc, autodb, autovm, efval, sfe&
        , hnuc, heat1p, grad(1), heat1m, heat2p, heat2m, eterm, dmu, &
        ae, aki, hnucj, hpp, hpm, hmm, hmp, &
        h2pp, h2pm, h2mm, h2mp, aterm, aij, &
        dipe4t, dipe4d, dipdpt, dipdpd, avgpe4, avga3, avgesu, avgpdp, &
        avga3d, avgesd, heat0
      logical :: debug
      character, dimension(3) :: axis
      character :: ch_xyz(3)*1
      double precision, external :: pol_vol
      data ch_xyz/"X","Y","Z"/
!***********************************************************************
!  SUBROUTINE FOR THE FINITE FIELD CALCULATION OF ELECTRIC RESPONSE
!  PROPERTIES (DIPOLE MOMENT, POLARIZABILITY, AND 1ST AND 2ND
!  HYPERPOLARIZABILITY.
!
!  HENRY A. KURTZ, DEPARTMENT OF CHEMISTRY
!                  MEMPHIS STATE UNIVERSITY
!                  MEMPHIS, TN   38152
!
!***********************************************************************
!
!
!     DIPE4 AND DIPDP HOLD THE CALCULATED DIPOLE MOMENTS
!
!     APOLE4 AND APOLDP HOLD THE POLARIZABILITY TENSOR AS
!                                A PACKED ARRAY XX,XY,YY,XZ,YZ,ZZ
!
! Energy: a.u. to kcal/mole
      autokc = fpc_9*eV
! Dipole: a.u. to debye
      autodb = a0*fpc_8*fpc_1*1.d-10
! Electric Field: a.u. to volt/meter
      autovm = eV/a0 ! = 51.42
      nbdip = 1
      nbcnt = 4
      ngcnt = 4
      heat0 = escf
!
      data axis/ 'X', 'Y', 'Z'/
      debug = index(keywrd,'DEBUG') /= 0
!
!  FIELD STRENGTH IN A.U.
!
      efval = 0.002D0
      write (iw, "(/,/,' APPLIED ELECTRIC FIELD MAGNITUDE: ',f15.5,a)") efval*ev/a0, &
      " VOLTS PER ANGSTROM"
      sfe = 1.D00/efval
!.......................................................................
!  CALCULATE THE POLARIZABILITY AND HYPERPOLARIZABILITIES ALONG
!  THE THREE PRINCIPLE AXES.  (THESE AXES DEPEND ON YOUR ARBITRARY
!  ORIENTATION AND MAY NOT BE THE TRUE PRINCIPLE AXES.)
!.......................................................................
      counter = 0
      do id = 1, 3
        if (debug) then
          write (iw, 40) axis(id)
   40     format(/,/,' ****** ',a1,' DIRECTION *****',/)
        end if
!
! ZERO THE FIELD
!
        efield = 0.0D00
        hnuc = sum(efval*geo(id,:numat)*tore(nat(:numat))*autovm)
        hnuc = hnuc*fpc_9
! +E(ID)
        efield(id) = efval
        call compfg (geo, .TRUE., heat1p, .TRUE., grad, .FALSE.)
        counter = counter + 1
        write(iw,'(a,i3,a)')"    Step", counter, " of 36 done (+"//ch_xyz(id)//")"
        call dipind (dip1p)
! -E(ID)
        efield(id) = -efval
        call compfg (geo, .TRUE., heat1m, .TRUE., grad, .FALSE.)
        counter = counter + 1
        write(iw,'(a,i3,a)')"    Step", counter, " of 36 done (-"//ch_xyz(id)//")"
        call dipind (dip1m)
! +2E(ID)
        efield(id) = 2.0D00*efval
        call compfg (geo, .TRUE., heat2p, .TRUE., grad, .FALSE.)
        counter = counter + 1
        write(iw,'(a,i3,a)')"    Step", counter, " of 36 done (+2"//ch_xyz(id)//")"
        call dipind (dip2p)
! -2E(ID)
        efield(id) = -2.0D00*efval
        call compfg (geo, .TRUE., heat2m, .TRUE., grad, .FALSE.)
        counter = counter + 1
        write(iw,'(a,i3,a)')"    Step", counter, " of 36 done (-2"//ch_xyz(id)//")"
        call dipind (dip2m)
        if (debug) then
          write (iw, 70)
   70     format(' ENERGIES AT: ',5x,'F',21x,'2F',/)
          write (iw, 80) heat1p, heat2p, heat1m, heat2m
   80     format('   + ',2(f20.10,3x),/,'   - ',2(f20.10,3x))
        end if
!
! DIPOLE
!
        eterm = (1.0D00/12.D00)*(heat2p - heat2m) - &
          (2.0D00/3.0D00)*(heat1p - heat1m)
        dipe4(id) = eterm*sfe/autokc
!
! ALPHA
!
        ivl = (id*(id + 1))/2
        eterm = 2.5D00*heat0 - (4.D00/3.D00)*(heat1p + heat1m) + &
          (1.D00/12.0D00)*(heat2p + heat2m)
        apole4(ivl) = eterm*sfe*sfe/autokc
!
! DIPOLE CALCULATIONS
!
        dmu = (2.0D00/3.0D00)*(dip1p(id)+dip1m(id)) - &
          (1.D00/6.0D00)*(dip2p(id) + dip2m(id))
        dipdp(id) = dmu/autodb
        ae = (2.0D00/3.0D00)*(dip1p(id)-dip1m(id)) - &
          (1.0D00/12.D00)*(dip2p(id) - dip2m(id))
        apoldp(ivl) = ae*sfe/autodb
        do kd = 1, 3
          if (kd < id) then
            kvl = (id*(id - 1))/2 + kd
            aki = (2.0D00/3.0D00)*(dip1p(kd)-dip1m(kd)) - &
              (1.0D00/12.0D00)*(dip2p(kd)-dip2m(kd))
            apoldp(kvl) = aki*sfe/autodb
          end if
          if (kd == id) cycle
          nbdip = nbdip + 1
        end do
!.......................................................................
!
!  NOW CALCULATE THE OFF AXIS RESULTS.
!
!.......................................................................
        idm1 = id - 1
        do jd = 1, idm1
          hnucj = sum(efval*geo(jd,:numat)*tore(nat(:numat))*eV/a0)
          hnucj = hnucj*fpc_9
          efield = 0.0D00
!
! DIAGONAL FIELDS WITH COMPONENTS EQUAL TO EFVAL
!
          efield(id) = efval
          efield(jd) = efval
          call compfg (geo, .TRUE., hpp, .TRUE., grad, .FALSE.)
          counter = counter + 1
          write(iw,'(a,i3,a)')"    Step", counter, " of 36 done (+"//ch_xyz(id)//"+"//ch_xyz(jd)//")"
          call dipind (dip1p)
          efield(jd) = -efval
          call compfg (geo, .TRUE., hpm, .TRUE., grad, .FALSE.)
          counter = counter + 1
          write(iw,'(a,i3,a)')"    Step", counter, " of 36 done (+"//ch_xyz(id)//"-"//ch_xyz(jd)//")"
          call dipind (dip1p)
          efield(id) = -efval
          call compfg (geo, .TRUE., hmm, .TRUE., grad, .FALSE.)
          counter = counter + 1
          write(iw,'(a,i3,a)')"    Step", counter, " of 36 done (-"//ch_xyz(id)//"-"//ch_xyz(jd)//")"
          call dipind (dip1p)
          efield(jd) = efval
          call compfg (geo, .TRUE., hmp, .TRUE., grad, .FALSE.)
          counter = counter + 1
          write(iw,'(a,i3,a)')"    Step", counter, " of 36 done (-"//ch_xyz(id)//"+"//ch_xyz(jd)//")"
          call dipind (dip1p)
          hpp = hpp + hnuc + hnucj
          hpm = hpm + hnuc - hnucj
          hmm = hmm - hnuc - hnucj
          hmp = hmp - hnuc + hnucj
          if (debug) then
            write (iw, 120)
  120       format(/,'  ',12x,'+,+',15x,'+,-',15x,'-,+',15x,'-,-')
            write (iw, 130) hpp, hpm, hmp, hmm
  130       format('  E ',4f18.6)
          end if
!
!  DIAGONAL FIELDS WITH COMPONENTS EQUAL TO 2*EFVAL
!
          efield(id) = efval*2.D00
          efield(jd) = efval*2.D00
          call compfg (geo, .TRUE., h2pp, .TRUE., grad, .FALSE.)
          counter = counter + 1
          write(iw,'(a,i3,a)')"    Step", counter, " of 36 done (+2"//ch_xyz(id)//"+2"//ch_xyz(jd)//")"
          efield(jd) = -efval*2.D00
          call compfg (geo, .TRUE., h2pm, .TRUE., grad, .FALSE.)
          counter = counter + 1
          write(iw,'(a,i3,a)')"    Step", counter, " of 36 done (+2"//ch_xyz(id)//"-2"//ch_xyz(jd)//")"
          efield(id) = -efval*2.D00
          call compfg (geo, .TRUE., h2mm, .TRUE., grad, .FALSE.)
          counter = counter + 1
          write(iw,'(a,i3,a)')"    Step", counter, " of 36 done (-2"//ch_xyz(id)//"-2"//ch_xyz(jd)//")"
          efield(jd) = efval*2.D00
          call compfg (geo, .TRUE., h2mp, .TRUE., grad, .FALSE.)
          counter = counter + 1
          write(iw,'(a,i3,a)')"    Step", counter, " of 36 done (-2"//ch_xyz(id)//"+2"//ch_xyz(jd)//")"
          h2pp = h2pp + 2.0D00*(hnuc + hnucj)
          h2pm = h2pm + 2.0D00*(hnuc - hnucj)
          h2mm = h2mm - 2.0D00*(hnuc + hnucj)
          h2mp = h2mp - 2.0D00*(hnuc - hnucj)
          if (debug) then
            write (iw, 140) h2pp, h2pm, h2mp, h2mm
  140       format(' 2E ',4f18.6)
          end if
!
          aterm = (1.0D00/48.0D00)*(h2pp - h2pm - h2mp + h2mm) - &
            (1.0D00/3.0D00)*(hpp - hpm - hmp + hmm)
          aij = aterm*sfe*sfe/autokc
          ivl = (id*(id - 1))/2 + jd
          apole4(ivl) = aij
          nbcnt = nbcnt + 1
          nbcnt = nbcnt + 1
          ngcnt = ngcnt + 1
        end do
!
      end do
!-----------------------------------------------------------------------
!  SUMMARIZE THE RESULTS
!-----------------------------------------------------------------------
      write (iw, 170)
  170 format(/,/,' ',30('*'),' DIPOLE ',30('*'),/,/)
      dipe4t = sqrt(dipe4(1)*dipe4(1)+dipe4(2)*dipe4(2)+dipe4(3)*dipe4(3))
      dipe4d = dipe4t*autodb
      dipdpt = sqrt(dipdp(1)*dipdp(1)+dipdp(2)*dipdp(2)+dipdp(3)*dipdp(3))
      dipdpd = dipdpt*autodb
      write (iw, 180)
  180 format(21x,'H.o.F.         Dipole',/)
      write (iw, 190) 'X', dipe4(1), dipdp(1)
      write (iw, 190) 'Y', dipe4(2), dipdp(2)
      write (iw, 190) 'X', dipe4(3), dipdp(3)
  190 format(5x,a1,7x,2f15.6)
      write (iw, 200) dipe4t, dipdpt, dipe4d, dipdpd
  200 format(/,/,' MAGNITUDE:  ',2f15.6,'  (A.U.)',/,' ',12x,2f15.6,'  (DEBYE)')
!
! FIND EIGENVALUES AND EIGENVECTORS OF POLARIZATION MATRIX.
!
      write (iw, 210)
  210 format(/,/,' ',30('*'),' POLARIZABILITY ',20('*'),/,/)
      write (iw, 220)
  220 format(/,' Polarizability Tensor from Heat of Formation:')
      apole4(1) = pol_vol(apole4(1))
      apole4(3) = pol_vol(apole4(3))
      apole4(6) = pol_vol(apole4(6))
      i3 = 3
      call vecprt (apole4, (-i3))
      call rsp (apole4, i3, eigs, vectrs)
      call matout (vectrs, eigs, i3, i3, i3)
      avgpe4 = (eigs(1)+eigs(2)+eigs(3))/3.D0
      avga3 = avgpe4*0.14818D00
      avgesu = avgpe4*0.296352D-24
      write (iw, 230)
  230 format(/,' Polarizability Tensor from Dipole Moment:')
      apoldp(1) = pol_vol(apoldp(1))
      apoldp(3) = pol_vol(apoldp(3))
      apoldp(6) = pol_vol(apoldp(6))
      call vecprt (apoldp, (-i3))
      call rsp (apoldp, i3, eigs, vectrs)
      call matout (vectrs, eigs, i3, i3, i3)
      avgpdp = (eigs(1)+eigs(2)+eigs(3))/3.D0
      avga3d = avgpdp*0.14818D00
      avgesd = avgpdp*0.296352D-24
      write (iw, 240) avgpe4, avgpdp, avga3, avga3d, avgesu, avgesd
  240 format(/,/,' Average Polarizability from:     H.o.F         Dipole',/,' ',24x,2f15.6,&
        '  A.U.',/,' ',24x,2f15.6,'  ANG.**3',/,' ',24x,2(1p,d15.6),'  ESU')

!
      return
      end subroutine ffhpol
      subroutine dipind(dipvec)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use common_arrays_C, only : p, nfirst, nlast, nat, geo
      use molkst_C, only : numat, mozyme
      use funcon_C, only : a0, fpc_8, fpc_1
      use parameters_C, only : ams, tore, dd
!...............................................................
!  MODIFICATION OF DIPOLE SUBROUTINE FOR USE IN THE CALUCLATION
!  OF THE INDUCED DIPOLES FOR POLARIZABILITIES.
!...............................................................
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision , intent(out) :: dipvec(3)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, l, j, ni, ia, k
      double precision, dimension(numat) :: q, q2
      double precision, dimension(3) :: center
      double precision, dimension(3,numat) :: coord
      double precision, dimension(4,3) :: dip
      double precision :: sum, hyfsp
      double precision, save :: wtmol = 0.0d0
      logical, save :: first, chargd
      integer, external :: ijbo
!-----------------------------------------------
!
!***********************************************************************
!     DIPOLE CALCULATES DIPOLE MOMENTS
!
!  ON INPUT P     = DENSITY MATRIX
!           Q     = TOTAL ATOMIC CHARGES, (NUCLEAR + ELECTRONIC)
!           NUMAT = NUMBER OF ATOMS IN MOLECULE
!           NAT   = ATOMIC NUMBERS OF ATOMS
!           NFIRST= START OF ATOM ORBITAL COUNTERS
!           COORD = COORDINATES OF ATOMS
!
!  OUTPUT  DIPOLE = DIPOLE MOMENT
!***********************************************************************
!
!     IN THE ZDO APPROXIMATION, ONLY TWO TERMS ARE RETAINED IN THE
!     CALCULATION OF DIPOLE MOMENTS.
!     1. THE POINT CHARGE TERM (INDEPENDENT OF PARAMETERIZATION).
!     2. THE ONE-CENTER HYBRIDIZATION TERM, WHICH ARISES FROM MATRIX
!     ELEMENTS OF THE FORM <NS/R/NP>. THIS TERM IS A FUNCTION OF
!     THE SLATER EXPONENTS (ZS,ZP) AND IS THUS DEPENDENT ON PARAMETER-
!     IZATION. THE HYBRIDIZATION FACTORS (HYF(I)) USED IN THIS SUB-
!     ROUTINE ARE CALCULATED FROM THE FOLLOWING FORMULAE.
!     FOR SECOND ROW ELEMENTS <2S/R/2P>
!     HYF(I)= 469.56193322*(SQRT(((ZS(I)**5)*(ZP(I)**5)))/
!           ((ZS(I) + ZP(I))**6))
!     FOR THIRD ROW ELEMENTS <3S/R/3P>
!     HYF(I)=2629.107682607*(SQRT(((ZS(I)**7)*(ZP(I)**7)))/
!           ((ZS(I) + ZP(I))**8))
!     FOR FOURTH ROW ELEMENTS AND UP :
!     HYF(I)=2*(2.10716)*DD(I)
!     WHERE DD(I) IS THE CHARGE SEPARATION IN ATOMIC UNITS
!
!
!     REFERENCES:
!     J.A.POPLE & D.L.BEVERIDGE: APPROXIMATE M.O. THEORY
!     S.P.MCGLYNN, ET AL: APPLIED QUANTUM CHEMISTRY
!
      data first/ .TRUE./, chargd /.FALSE./

!
!  SETUP FOR DIPOLE CALCULATION
!
      call chrge (p, q2)
      q(:numat) = tore(nat(:numat)) - q2(:numat)
      call gmetry (geo, coord)
!
      if (first) then
        wtmol = 0.D0
        sum = 0.D0
        do i = 1, numat
          wtmol = wtmol + ams(nat(i))
          sum = sum + q(i)
        end do
        chargd = abs(sum) > 0.5D0
        first = .FALSE.
      end if
      if (chargd) then
!
!   NEED TO RESET ION'S POSITION SO THAT THE CENTER OF MASS IS AT THE
!   ORIGIN.
!
        center = 0.D0
        do i = 1, 3
          do j = 1, numat
            center(i) = center(i) + ams(nat(j))*coord(i,j)
          end do
        end do
        center = center/wtmol
        do i = 1, 3
          coord(i,:numat) = coord(i,:numat) - center(i)
        end do
      end if
      dip = 0.0D00
      do i = 1, numat
        ni = nat(i)
        ia = nfirst(i)
        l = Min(nlast(i) - ia, 3)
        hyfsp = 2.0D0*dd(ni)*a0*fpc_8*fpc_1*1.D-10
        if (mozyme) then
          do j = 1, l
            k = ijbo (i, i) + 1 + (j*(j+1)) / 2
            dip(j, 2) = dip(j, 2) - hyfsp * p(k)
          end do
        else
          do j = 1, l
            k = ((ia + j)*(ia + j - 1))/2 + ia
            dip(j,2) = dip(j,2) - hyfsp*p(k)
          end do
        end if
        dip(:3,1) = dip(:3,1) + 4.803D00*q(i)*coord(:,i)
      end do
      dip(:3,3) = dip(:3,2) + dip(:3,1)
      do j = 1, 3
        dip(4,j) = sqrt(dip(1,j)**2+dip(2,j)**2+dip(3,j)**2)
      end do
      dipvec(1) = -dip(1,3)
      dipvec(2) = -dip(2,3)
      dipvec(3) = -dip(3,3)
      return
!
      end subroutine dipind

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      double precision function charmo (vects, ntype, jorb, ioper, r, nvecs, first)
      use symmetry_C, only : elem, jelem
      use molkst_C, only : norbs, numat
      implicit none
      integer , intent(in) :: jorb
      integer  :: ioper
      integer , intent(in) :: nvecs
      logical, intent(inout)  :: first
      integer , intent(in) :: ntype(*)
      double precision , intent(in) :: vects(nvecs,nvecs)
      double precision  :: r(3,3)
      integer , dimension(2,3) :: ip
      integer , dimension(2,5) :: id
      integer , dimension(2,9) :: loc
      integer :: i, iatom, jatom, ibase, kj, icheck, jcheck, ii, jj
      double precision, dimension(norbs) :: vect1, vect2
      double precision, dimension(5) :: h = 0.d0
      double precision, dimension(3) :: p
      double precision, dimension(5) :: d
      double precision :: sum
      double precision, external :: ddot
!-----------------------------------------------
!
!  Trivial case:  Operation is 'E', the identity.
!
      charmo = 1.D0
      if (ioper == 1) return
!
!   Non-trivial case
!
      vect1(:nvecs) = 0.D0
      vect2(:nvecs) = 0.D0
      do iatom = 1, numat
        jatom = jelem(ioper,iatom)
        ibase = 0
        kj = 0
        do i = 1, nvecs
          icheck = ntype(i)/100
          if (icheck == iatom) then
            ibase = ibase + 1
            loc(1,ibase) = i
          end if
          if (icheck /= jatom) cycle
          kj = kj + 1
          loc(2,kj) = i
        end do
        if (ibase > 0) then
!
!   's'-type basis function
!
          icheck = loc(1,1)
          jcheck = loc(2,1)
          vect1(icheck) = vects(icheck,jorb)
          vect2(jcheck) = vects(icheck,jorb)
        end if
          if (ibase < 4) cycle
!
!    Atom I had a 'p' shell
!
        ip(1,:) = 0
        id(1,:3) = 0
        id(1,4) = 0
        id(1,5) = 0
        do i = 2, ibase
          icheck = loc(1,i)
          if (i <= 4) then
            p(i-1) = vects(icheck,jorb)
            ip(1,i-1) = loc(1,i)
            ip(2,i-1) = loc(2,i)
          else
            d(i-4) = vects(icheck,jorb)
            id(1,i-4) = loc(1,i)
            id(2,i-4) = loc(2,i)
          end if
        end do
        if (ibase /= 1) then
!
!    'p' transform
!
          h(1) = r(1,1)*p(1) + r(2,1)*p(2) + r(3,1)*p(3)
          h(2) = r(1,2)*p(1) + r(2,2)*p(2) + r(3,2)*p(3)
          h(3) = r(1,3)*p(1) + r(2,3)*p(2) + r(3,3)*p(3)
          p(1) = elem(1,1,ioper)*h(1) + elem(1,2,ioper)*h(2) + elem(1,3,ioper)*h(3)
          p(2) = elem(2,1,ioper)*h(1) + elem(2,2,ioper)*h(2) + elem(2,3,ioper)*h(3)
          p(3) = elem(3,1,ioper)*h(1) + elem(3,2,ioper)*h(2) + elem(3,3,ioper)*h(3)
          do i = 1, 3
            if (ip(1,i) < 1) return
            ii = ip(1,i)
            jj = ip(2,i)
            vect1(ii) = h(i)
            vect2(jj) = p(i)
          end do
        end if
        if (ibase /= 9) cycle
!
!   'd' transform
!
        call dtrans (d, h, ioper, first, r)
        do i = 1, 5
          if (id(1,i) < 1) return
          ii = id(1,i)
          jj = id(2,i)
          vect1(ii) = h(i)
          vect2(jj) = d(i)
        end do
      end do
!
!   Evaluate the term <psi(i)|R(theta)|psi(i)>
!
      sum = ddot(nvecs,vect1(:nvecs),1,vect2(:nvecs),1)
      charmo = sum
      return
      end function charmo

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

subroutine sort (val, vec, n)
  implicit none
  integer, intent(in) :: n
  real, dimension(*), intent(inout) :: val
  complex, dimension(n, *), intent(inout) :: vec
  integer :: i, j, k
  real :: x
  complex :: sum
  ! 
  ! ... Executable Statements ...
  ! 
  do i = 1, n
    x = 1.e9
    do j = i, n
      if (val(j) < x) then
        k = j
        x = val(j)
      end if
    end do
    do j = 1, n
      sum = vec(j, k)
      vec(j, k) = vec(j, i)
      vec(j, i) = sum
    end do
    val(k) = val(i)
    val(i) = x
  end do
end subroutine sort

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.
  subroutine add_hydrogen_atoms()
!
!   Adds hydrogen atoms.
!
!   Intended for use in converting PDB files into files suitable for running in MOPAC
!
  use molkst_C,  only : numat, natoms, keywrd, maxatoms, moperr, refkey, line, id
  use common_arrays_C,  only : nat,  coord,  nbonds,  ibonds, txtatm, labels, atmass, geo, &
    lopt, na, l_atom, loc, xparam, nfirst, nlast, txtatm1, coorda, tvec
  use parameters_C, only : ams
  use MOZYME_C, only : atomname, afn, n_add
  use atomradii_C, only: atom_radius_covalent, is_metal
  use funcon_C,  only : pi
  use elemts_C, only: elemnt
  implicit none
  integer :: i,  j,  k, l, ii, nH, icc, store_numat, nb_icc, nc_icc, nd_icc, nmetals,  i_add(20,14), b_add(20,14), &
    an, store_nmetals
  character*4 :: labl
  double precision :: const, bond_length, angle, dihedral, internal_dihedral, store_atom_radius_covalent(107), &
  tetrahedral
  logical :: ionized = .false., l_reseq
  integer, allocatable :: store_nat(:), store_labels(:), store_lopt(:,:), hybrid(:), metals(:)
  logical, allocatable :: store_l_atom(:)
  double precision, allocatable :: store_coord(:,:), store_atmass(:)
  character, allocatable :: store_txtatm(:)*27, store_txtatm1(:)*27
  double precision, external :: distance
  integer, external :: nheavy
!
!  Number of hydrogen atoms on each atom in a residue
!
  data (i_add(1,i),i=1,4)/1,2,0,0/                        !   GLY
  data (i_add(2,i),i=1,5)/1,1,0,0,3/                      !   ALA
  data (i_add(3,i),i=1,6)/1,1,0,0,2,1/                    !   SER
  data (i_add(4,i),i=1,6)/1,1,0,0,2,1/                    !   CYS
  data (i_add(5,i),i=1,7)/1,1,0,0,1,3,3/                  !   VAL
  data (i_add(6,i),i=1,7)/1,1,0,0,1,1,3/                  !   THR
  data (i_add(7,i),i=1,8)/1,1,0,0,1,2,3,3/                !   ILE
  data (i_add(8,i),i=1,7)/0,1,0,0,2,2,2/                  !   PRO
  data (i_add(9,i),i=1,8)/1,1,0,0,2,2,0,3/                !   MET
  data (i_add(10,i),i=1,8)/1,1,0,0,2,0,0,1/               !   ASP
  data (i_add(11,i),i=1,8)/1,1,0,0,2,0,0,2/               !   ASN
  data (i_add(12,i),i=1,8)/1,1,0,0,2,1,3,3/               !   LEU
  data (i_add(13,i),i=1,9)/1,1,0,0,2,2,2,2,2/             !   LYS
  data (i_add(14,i),i=1,9)/1,1,0,0,2,2,0,0,1/             !   GLU
  data (i_add(15,i),i=1,9)/1,1,0,0,2,2,0,0,2/             !   GLN
  data (i_add(16,i),i=1,11)/1,1,0,0,2,2,2,1,0,2,1/        !   ARG
  data (i_add(17,i),i=1,10)/1,1,0,0,2,0,1,1,1,0/          !   HIS
  data (i_add(18,i),i=1,11)/1,1,0,0,2,0,1,1,1,1,1/        !   PHE
  data (i_add(19,i),i=1,12)/1,1,0,0,2,0,1,1,1,1,0,1/      !   TYR
  data (i_add(20,i),i=1,14)/1,1,0,0,2,0,1,0,1,0,1,1,1,1/  !   TRP
!
! Number of bonds (if less than minimum, this is a non-standard residue)
!
!    First four atoms: N CA C O
!
  data (b_add(1,i),i=1,4)/2,2,3,1/                        !   GLY
  data (b_add(2,i),i=1,5)/2,3,3,1,1/                      !   ALA
  data (b_add(3,i),i=1,6)/2,3,3,1,2,1/                    !   SER
  data (b_add(4,i),i=1,6)/2,3,3,1,2,1/                    !   CYS
  data (b_add(5,i),i=1,7)/2,3,3,1,3,1,1/                  !   VAL
  data (b_add(6,i),i=1,7)/2,3,3,1,3,1,1/                  !   THR
  data (b_add(7,i),i=1,8)/2,3,3,1,3,2,1,1/                !   ILE
  data (b_add(8,i),i=1,7)/2,3,3,1,2,2,2/                  !   PRO
  data (b_add(9,i),i=1,8)/2,3,3,1,2,2,2,1/                !   MET
  data (b_add(10,i),i=1,8)/2,3,3,1,2,3,1,1/               !   ASP
  data (b_add(11,i),i=1,8)/2,3,3,1,2,3,1,1/               !   ASN
  data (b_add(12,i),i=1,8)/2,3,3,1,2,3,1,1/               !   LEU
  data (b_add(13,i),i=1,9)/2,3,3,1,2,2,2,2,1/             !   LYS
  data (b_add(14,i),i=1,9)/2,3,3,1,2,2,2,1,1/             !   GLU
  data (b_add(15,i),i=1,9)/2,3,3,1,2,2,3,1,1/             !   GLN
  data (b_add(16,i),i=1,11)/2,3,3,1,2,2,2,2,3,1,1/        !   ARG
  data (b_add(17,i),i=1,10)/2,3,3,1,2,3,2,2,2,2/          !   HIS
  data (b_add(18,i),i=1,11)/2,3,3,1,2,3,2,2,2,2,2/        !   PHE
  data (b_add(19,i),i=1,12)/2,3,3,1,2,3,2,2,2,2,3,1/      !   TYR
  data (b_add(20,i),i=1,14)/2,3,3,1,2,3,2,3,2,3,2,2,2,2/  !   TRP
!
  tetrahedral = 109.4712206d0
!
!  Check for type of hydrogenation:  neutral or ionized
!
    if (index(keywrd, " IONI") /= 0) then
!
!  Set residues for ionized form
!
      i_add(13,9)  = 3                        ! Lysine nitrogen (+)
      i_add(16,11) = 2                        ! Arginine nitrogen (+)
      i_add(17,10) = 1                        ! Histidine nitrogen (+)
      i_add(10,8)  = 0                        ! Aspartate oxygen (-)
      i_add(14,9)  = 0                        ! Glutamate oxygen (-)
      ionized = .true.
    end if
    allocate (store_nat(natoms), store_coord(3,natoms))
    allocate (store_labels(natoms), store_atmass(natoms), store_lopt(3,natoms))
    allocate (store_l_atom(natoms), metals(natoms), store_txtatm(natoms), store_txtatm1(natoms))
    an = 0
    store_nmetals = 0
!
! Remove any hydrogen atoms present
!
    j = 0
    do i = 1, natoms
      if (nat(i) /= 1) then
        j = j + 1
        store_nat(j) = nat(i)
        store_coord(:,j) = coord(:,i)
        store_atmass(j)  = atmass(i)
        store_lopt(:,j)  = lopt(:,i)
        store_l_atom(j)  = l_atom(i)
        store_txtatm(j)  = txtatm(i)
        store_txtatm1(j) = txtatm1(i)
        txtatm1(j) = txtatm1(i)
        txtatm(j) = txtatm(i)
        coorda(:,j) = coorda(:,i)
      end if
    end do
    if (i - 1 /= j) call reset_breaks()
    if (moperr) return
    k = 0
    do i = 1, natoms
      if (labels(i) /= 99 .and. labels(i) /= 1) then
        k = k + 1
        store_labels(k) = labels(i)
      end if
    end do
    numat = j - id
    natoms = j
    nmetals = 0
    store_atom_radius_covalent = atom_radius_covalent
    do i = 1, numat
      do j = 1, 102
        if (is_metal(store_nat(i))) exit
      end do
      if (j < 103) then
        nmetals = nmetals + 1
        metals(nmetals) = i
        atom_radius_covalent(store_nat(i)) = -1.d0
      end if
    end do
!
!  Make extra storage room for hydrogen atoms
!
    deallocate (nat, txtatm, txtatm1, coord, nbonds, ibonds, labels, atmass, geo, lopt, na, l_atom, loc, xparam)
    deallocate (nfirst, nlast)
    maxatoms = numat*5
    allocate (nat(maxatoms), txtatm(maxatoms), txtatm1(maxatoms), coord(3,maxatoms), atmass(maxatoms))
    allocate (nbonds(maxatoms), ibonds(15,maxatoms), labels(maxatoms), geo(3,maxatoms))
    allocate (lopt(3,maxatoms), na(maxatoms), l_atom(maxatoms), loc(2,3*maxatoms), xparam(3*maxatoms))
    allocate (nfirst(maxatoms), nlast(maxatoms))
    na = 0
    nat(:numat) = store_nat(:numat)
    txtatm(:numat) = store_txtatm(:numat)
    txtatm1 = " "
    txtatm1(:numat) = store_txtatm1(:numat)
    coord(:,:numat) = store_coord(:,:numat)
    labels(:natoms) = store_labels(:natoms)
    atmass(:numat) = store_atmass(:numat)
    lopt(:,:numat) = store_lopt(:,:numat)
    l_atom(:numat) = store_l_atom(:numat)
    deallocate (store_nat, store_coord, store_labels, store_atmass, store_l_atom, &
    store_txtatm, store_txtatm1)
    store_numat = numat
!
!  Re-calculate connectivity.  This is simpler than trying to remove hydrogen atoms from nbonds and ibonds.
!
     l_reseq = (index(keywrd, " RESEQ") /= 0)
     if (l_reseq) call l_control("RESEQ", len("RESEQ"), -1)
     call geochk()                               ! This needs to be called, to work out residue names
     if (l_reseq) call l_control("RESEQ", len("RESEQ"), 1)
     if (moperr) return
     line = trim(refkey(1))
     call upcase(line, len_trim(line))
     i = index(line, " CVB")
     if (i > 0) then
       j = index(line(i:), ") ") + i
       line = line(i + 1: j - 1)
       ii = len_trim(line)
!
!    If everything is in quotation marks, use the CVB keyword
!
       k = 0
       do
         k = k + 1
         if (k >= ii) exit
         if (line(k:k) == '"') then
           do
             k = k + 1
             if (line(k:k) == '"') exit
           end do
         end if
         if (line(k:k) >= "0" .and. line(k:k) <= "9") exit
       end do
       if (k > ii - 3) &
       call l_control(line, ii, 1)
     end if
     call lewis(.false.)                         ! Needed again, because geochk breaks S-S bonds
     call check_CVS(.false.)                     ! and changes to bonding might be made by CVB
!
!   "hybrid" is intended for a two-pass method for assigning hydrogen atoms.
!   In the first pass, all atoms are assigned a hybridization value
!   In the second pass, atoms are assigned a hybrid value, based on their environment and their neighbor hybrid values,
!   and any hydrogen atoms necessary are assigned.
!
!
    allocate (hybrid(numat))
    hybrid = 0
    dihedral = 0.d0
    internal_dihedral = 0.d0
    do icc = 1, numat
      call h_type(22, icc, ionized, nH, nb_icc, nc_icc, nd_icc, bond_length, angle, dihedral, internal_dihedral, &
        hybrid, metals, nmetals)
    end do
    do icc = 1, numat
      bond_length = 0.d0
      angle = 0.d0
      do j = 1, 20
        if (afn(j) == txtatm(icc)(18:20)) exit
      end do
      if (j < 21) then
        do an = 1, n_add(j)
          labl = elemnt(nat(icc))//txtatm(icc)(15:16)
          if (labl(3:4) == "XT") labl = labl(1:2)
          if (labl == atomname(j,an)) exit
        end do
!
!   Check that the number of bonds is correct.  For peptide "N" and "C" allow for terminal group.
!
        if (nbonds(icc) /= b_add(j,an) .or. &
        (an == 1 .and. nbonds(icc) == 1) .or. &
        (an == 3 .and. nbonds(icc) == 2)) then
          j = 21
        end if
      end if
      if (j == 17 .and. (txtatm(icc)(14:15) == "ND" .or. txtatm(icc)(14:15) == "NE")) j = 21  ! His' imidazole N are too hard - solve directly
      if (nat(icc) == 8 .and. nbonds(icc) == 1) then    ! Carboxylic acid
    cooh: do i = 1, nbonds(icc)
          k = ibonds(i,icc)
          if (nat(k) == 6) then
            if (nbonds(k) == 3) then
              l = 0
              do ii = 1, nbonds(k)
                if (nat(ibonds(ii,k)) == 8) l = l + 1
              end do
              if (l == 2) then
                j = 21
                exit cooh
              end if
            end if
          end if
        end do cooh
      end if
      if (nat(icc) == 7 .and. txtatm(icc)(14:20) /= "NE  ARG") then                   !  Arginine
       arg: do i = 1, nbonds(icc)
          k = ibonds(i,icc)
          if (nat(k) == 6) then
            if (nbonds(k) == 3) then
              l = 0
              do ii = 1, nbonds(k)
                if (nat(ibonds(ii,k)) == 7) l = l + 1
              end do
              if (l == 3) then
                j = 21
                exit arg
              end if
            end if
          end if
        end do arg
      end if
!
! Atom icc is a hetero-atom, icc.e., not one of the 20 common residues
!
       call h_type(j, icc, ionized, nH, nb_icc, nc_icc, nd_icc, bond_length, angle, dihedral, internal_dihedral, &
        hybrid, metals, nmetals)
       if (j < 21) then
         bond_length = 0.d0
!
!  For atom icc, residue name is afn(j)
!
!
!  Check if it is a special case, e.g., a terminus or a hetero group
!
        if ( an > n_add(j)) then
          if (labl == " OXT") then
            if (ionized) then
              nH = 0  !  Terminus: -COO(-)
            else
              nH = 1  !  Terminus: -COOH
            end if
          else
            nH = 0
          end if
        else
!
!  For atom icc, atom name is atomname(an)
!
!  Number of hydrogen atoms to add: i_add(j,an)
!
!
!   Get number of hydrogen atoms to be added from amino-acid residue
!
          nH = i_add(j,an)
!
! if "an" is 4, then this is a peptide oxygen atom.
! check to see if it is a terminal atom, i.e., it is ...-(CR)-C-O
!
          if (an == 4) then
            if (nheavy(ibonds(1,icc)) == 2) then
              if (distance(icc, ibonds(1,icc)) > 1.35d0) nH = 1
            end if
          end if
          if (nat(icc) == 8 .and. nbonds(icc) > 1) nH = 0
          if (an == 1 .and. nbonds(icc) == 1) then
            if (ionized) then
              nH = 3  !  Terminus: make -NH2 -NH3(+)
            else
              nH = 2  !  Terminus: make -NH -NH2
            end if
          end if
!
!  Special cases where the default number of hydrogen atoms needs to be changed
!
          if (              an == 3 .and. nbonds(icc) == 2) nH = 1  !  Terminus: make -CO -CHO
          if (j == 3  .and. an == 6 .and. nbonds(icc)  > 1) nH = 0
          if (j == 4  .and. an == 6 .and. nbonds(icc)  > 1) nH = 0
          if (j == 8  .and. an == 1 .and. nbonds(icc) == 2) nH = 1  ! Pro terminus, make it >NH
          if (j == 11 .and. an == 8 .and. nbonds(icc) == 2) nH = 1
          if (nat(icc) == 6 .and. an >  4 .and. nbonds(icc) == 1) nH = 3  ! Convert truncated atom into methyl
        end if
        select case (nh)
          case (1)
            if (nd_icc == 0) then
              angle = 120.d0
              dihedral = 180.d0
            else
              bond_length = 1.09d0
            end if
          case (2)
            angle = tetrahedral
            dihedral = 120.d0
            internal_dihedral = 120.d0
          case (3)
            angle = tetrahedral
            dihedral = 120.d0
            internal_dihedral = 120.d0
        end select
        if (nat(icc) == 6) then
          bond_length = 1.09d0
        else if (nat(icc) == 7) then
          bond_length = 1.01d0
        else if (nat(icc) == 16) then
          bond_length = 1.34d0
        else
          bond_length = 0.99d0
        end if
      end if
      if (abs(bond_length) < 0.1d0) cycle
      angle = angle*pi/180.d0
      dihedral = dihedral*pi/180.d0
      internal_dihedral = internal_dihedral*pi/180.d0
      if (j < 21 .and. nat(icc) /= 8 .and. nat(icc) /= 16) then
        store_nmetals = nmetals
        nmetals = 0
      end if
      select case (nH)
        case (1)
          if (nc_icc /= 0 .and. nd_icc /= 0) then
            call add_a_sp3_hydrogen_atom(icc, nb_icc, nc_icc, nd_icc, bond_length, metals, nmetals)
          else
            call add_a_generic_hydrogen_atom(icc, nb_icc, nc_icc, bond_length, angle, dihedral, metals, nmetals)
            if (moperr) return
!
!  Check to see if the system is water
!
            if (nat(icc) == 8 .and. nbonds(icc) == 2) then
              if (nat(ibonds(1,icc)) == 1 .and. nat(ibonds(2,icc)) == 1) then
!
! System is water.  Oxygen atom number is "icc", H1 is ibonds(1,icc), and H2 is ibonds(2,icc)
!
                i = ibonds(1,icc)
                j = ibonds(2,icc)
                call orient_water(icc, i, j, const)
                const = 1.d0 - 0.98d0/distance(icc, i)
                coord(:, i) = coord(:, i) - const*(coord(:, i) - coord(:, icc))
                const = 1.d0 - 0.98d0/distance(icc, j)
                coord(:, j) = coord(:, j) - const*(coord(:, j) - coord(:, icc))
              end if
            end if
          end if
        case (2)
          call add_a_generic_hydrogen_atom(icc, nb_icc, nc_icc, bond_length, angle, dihedral, metals, nmetals)
          internal_dihedral = internal_dihedral + dihedral
          call add_a_generic_hydrogen_atom(icc, nb_icc, nc_icc, bond_length, angle, internal_dihedral, metals, nmetals)
        case (3)
          call add_a_generic_hydrogen_atom(icc, nb_icc, nc_icc, bond_length, angle, pi, metals, nmetals)
          call add_a_generic_hydrogen_atom(icc, nb_icc, numat, bond_length, angle, internal_dihedral, metals, nmetals)
          call add_a_generic_hydrogen_atom(icc, nb_icc, numat, bond_length, angle, internal_dihedral, metals, nmetals)
      end select
      if (j < 21 .and. nat(icc) /= 8 .and. nat(icc) /= 16) then
        nmetals = store_nmetals
      end if
    end do
!
!  Set all new atoms to hydrogen
!
    do i = store_numat + 1, numat
      nat(i) = 1
      labels(i) = 1
      atmass(i) = ams(1)
      j = ibonds(1,i)
      write(txtatm(i),'(a,i5,a)') txtatm(j)(:6),i,"  H  "//txtatm(j)(17:)
    end do
!
!  and fill arrays that might be used by PDBOUT
!
    natoms = max(numat + id, natoms)
    labels(numat + 1: numat + id) = 107
    geo(:,:numat) = coord(:,:numat)
    lopt(:,store_numat + 1: numat) = 1
    do i = 1, id
      lopt(:, numat + id) = store_lopt(:,store_numat + id)
    end do
    deallocate (store_lopt)
    l_atom(store_numat + 1: numat + id) = .true.
    na(:numat) = 0
    atom_radius_covalent = store_atom_radius_covalent
!
! At this point it's necessary to re-calculate nbonds and ibonds
!
    call set_up_dentate()
    if (index(keywrd, "SITE") /= 0) call geochk()
    call l_control("NOSITE", len("NOSITE"), 1)
    call reset_breaks()
    do i = numat + 1, numat + id
      labels(i) = 107
      nat(i) = 107
      geo(:,i)  = tvec(:, i - numat)
      coord(:,i)  = tvec(:, i - numat)
    end do
    call delete_ref_key("ADD-H", len_trim("ADD-H"), ' ', 1)
    return
  end subroutine add_hydrogen_atoms
  subroutine h_type(jjj, icc, ionized, nH, nb_icc, nc_icc, nd_icc, bond_length, angle, dihedral, internal_dihedral, &
    hybrid, metals, nmetals)
!
!  Work out the type and number of hydrogen atom(s) attached to atom icc
!  Work out bond-lengths and angles.
!
! bond_length:       The distance, in Angstroms, from atom icc to the hydrogen atom
!
! angle:             The angle between the hydrogen atom to be added and atoms icc and nb_icc
!
! dihedral :         The torsion angle between the hydrogen atom to be added and atoms icc,
!                    nb_icc, and nc_icc
!
! internal_dihedral: The torsion angle between the hydrogen atom to be added and atoms
!                    icc, nb_icc, and the previous hydrogen atom added, when two or three hydrogen atoms are added
!
  use molkst_C,  only : numat
  use funcon_C,  only : pi
  use common_arrays_C,  only : nat,  coord,  nbonds,  ibonds, txtatm, labels
  implicit none
  integer, intent (in) :: jjj, icc, nmetals, metals(nmetals)
  integer, intent (out) :: nb_icc, nc_icc, nd_icc
  integer, intent (out) :: nH
  integer, intent (inout) :: hybrid(numat)
  logical, intent (in) :: ionized
  double precision, intent (out) :: bond_length, angle, dihedral, internal_dihedral
!
  integer :: i, j, k, l, kk, ll, ii, jj, search(3,6)
  double precision :: Rab, Rac, Rad, sum, bits, tetrahedral = 109.4712206d0
  double precision, external :: distance
!
!   CN: distance half way between C-N and C=N
!   CC: distance half way between C-C and C=C
!   CO: distance half way between C-O and C=O
  double precision, parameter :: cyanide = 1.3d0, CC = 1.46d0, CN = 1.405d0, CO = 1.33d0
  logical :: l_tmp
  logical, external :: aromatic, aromatic_5, near_a_metal, guanidine
  data search /1,0,0, -1,0,0, 0,1,0, 0,-1,0, 0,0,1, 0,0,-1/
  save :: tetrahedral
!
!   If hybrid(i) = 0, then hybridization unknown
!   If hybrid(i) = 1, then hybridization is sp
!   If hybrid(i) = 2, then hybridization is sp2
!   If hybrid(i) = 3, then hybridization is sp3
!
    bond_length = 0.d0
    angle = 0.d0       !  Not necessary, but useful when debugging
    nb_icc = 0
    nc_icc = 0
    nd_icc = 0
    nH = 0
    Rab = 0.d0
    Rac = 0.d0
    Rad = 0.d0
    if (nbonds(icc) == 0) then
!
!                                         Atom is isolated
!
      if (hybrid(icc) == 0) then
        hybrid(icc) = 3
        return
      end if
      select case (nat(icc))
        case (6)
          nH = 3                        ! Methane
          bond_length = 1.09d0
          angle = tetrahedral
          dihedral = 120.d0
          internal_dihedral = 120.d0
        case (7)
          nH = 2                        ! Ammonia
          bond_length = 1.0d0
          angle = 107.d0
          dihedral = 114.5d0
          internal_dihedral = dihedral
        case (8)
          nH = 1                        ! Water
          bond_length = 0.957d0
          angle = 104.4d0
        case (14)
          nH = 3                        ! Silane
          bond_length = 1.48d0
          angle = tetrahedral
          dihedral = 120.d0
          internal_dihedral = 120.d0
        case (15)
          nH = 2                        ! Phosphine
          bond_length = 1.42d0
          angle = 93.5d0
          dihedral = 93.8d0
          internal_dihedral = dihedral
        case (16)
          nH = 1                        ! H2S
          bond_length = 1.336d0
          angle = 92.1d0
        case (9, 17, 35, 53)
          return                        ! Halogen ions
        case (33)
          nH = 2                        ! Arsine
          bond_length = 1.519d0
          angle = 91.8d0
          dihedral = 92d0
          internal_dihedral = dihedral
        case (34)
          nH = 1                        ! H2Se
          bond_length = 1.46d0
          angle = 91.d0
        case (51)
          nH = 2                        ! Stibine
          bond_length = 1.707d0
          angle = 91.8d0
          dihedral = 92d0
          internal_dihedral = dihedral
        case (52)
          nH = 1                        ! H2Se
          bond_length = 1.69d0
          angle = 90.d0
        case default
          nH = 0                        ! If the atom is not specified, don't assign hydrogen atoms to it.
          return
      end select
!
!                                         Common to all isolated atoms that have hydrogen atoms
!
      numat = numat + 1
      nat(numat) = 1
      labels(numat) = 1
      do i = 1, 6
        coord(:, numat) = coord(:,icc) + bond_length*search(:,i)
        if ( .not. near_a_metal(icc, numat, metals, nmetals)) exit
      end do
      if (i > 6) then
        nH = 0
        if (nat(icc) == 8) then
          if (nbonds(icc) < -2) then
            numat = numat -1
            return
          end if
!
!  Water near to a metal atom.  Carefully add two hydrogen atoms
!
          coord(:, numat) = coord(:,icc) + bond_length*search(:,1)
          ibonds(1,icc) = numat
          ibonds(1,numat) = icc
          numat = numat + 1
          coord(:, numat) = coord(:,icc) + bond_length*search(:,2)
          ibonds(2,icc) = numat
          ibonds(1,numat) = icc
          i = ibonds(1,icc)
          j = ibonds(2,icc)
          call orient_water(icc, i, j, sum)
          sum = 1.d0 - 0.98d0/distance(icc, i)
          coord(:, i) = coord(:, i) - sum*(coord(:, i) - coord(:, icc))
          sum = 1.d0 - 0.98d0/distance(icc, j)
          coord(:, j) = coord(:, j) - sum*(coord(:, j) - coord(:, icc))
          return
        end if
        numat = numat - 1
        return
      end if
      nb_icc = numat
      nbonds(icc) = 1
      nbonds(numat) = 1
      ibonds(1,icc) = numat
      ibonds(1,numat) = icc
    else
      ii = ibonds(1,icc)
      if (nbonds(icc) == 3) then
        kk = ibonds(3,icc)
        jj = ibonds(2,icc)
!
!  Sort into ascending order
!
        if (nat(ii) > nat(jj)) then
          i = jj
          jj = ii
          ii = i
        end if
        if (nat(ii) > nat(kk)) then
          i = kk
          kk = ii
          ii = i
        end if
          if (nat(jj) > nat(kk)) then
            i = kk
            kk = jj
            jj = i
        end if
!
! Atomic numbers increase ii <= jj <= kk
!
        Rab = distance(icc, ii)
        Rac = distance(icc, jj)
        Rad = distance(icc, kk)
        if (nat(ii) == nat(jj)) then
          if (Rab > Rac) then
            i = ii
            ii = jj
            jj =i
            sum = Rab
            Rab = Rac
            Rac = sum
          end if
        end if
      else if (nbonds(icc) == 2) then
        jj = ibonds(2,icc)
        if (nat(jj) < nat(ii)) then
          i  = ii
          ii = jj
          jj = i
        end if
!
! Atomic numbers increase ii <= jj
!
        Rab = distance(icc, ii)
        Rac = distance(icc, jj)
        if (nat(ii) == 6 .and. nat(jj) == 6) then
          if (Rab > Rac) then   ! reverse order so Rab is smaller than Rac
            Rad = Rab
            Rab = Rac
            Rac = Rad
            i = ii
            ii = jj
            jj = i
          end if
        end if
      else
        Rab = distance(icc, ii)
      end if
!
!
!                   Now start to assign the number of hydrogen atoms to each non-hydrogen atom.
!                   The order of the assignment is as follows:
!                   First, select by atomic number of atoc "icc"
!                   Next, select by number of atoms attached to the atom "icc"
!                   Next, select by atomic number of atoms attached to atom attached to atom "icc",
!                     in the order: lowest atomic number first, then next, then highest.
!                   Then use bond-lengths to decide the bond order, and thus the number of hydrogen atoms
!
!                   Do high-reliability tests first, e.g, is an atom part of an aromatic ring, or attached to
!                   an aromatic ring?
!
!                   When editing this section, preserve the order of assignment, in particular
!                   the increasing order of atomic number.  If this order is lost, then debugging becomes hard.
!
!             "Typical" bond-lengths  ("T" means "triple bond")
!
!                     C-C 1.54     C=C 1.34  CTC 1.20
!                     C-N 1.43     C=N 1.38  CTN 1.16
!                     C-O 1.43     C=O 1.23  CTO 1.13
!                     C-S 1.83     C=S
!                     N-N 1.47     N=N 1.24  NTN 1.10
!                     N-O 1.36     N=O 1.22
!                     O-O 1.48     O=O 1.21
!                     S-S 2.08     S=S
!
!             ii = atom attached to icc
!             jj = atom attached to icc, and its atomic number is greater than or equal to that of ii
!             kk = atom attached to icc, and its atomic number is greater than or equal to that of jj
!             Rab = interatomic distance icc to ii
!             Rac = interatomic distance icc to jj
!             Rad = interatomic distance icc to kk
!
!
      bond_length = 1.09d0
      if (nbonds(icc) == 1) then
        nb_icc = ii
        do i = 1, nbonds(ii)
          kk = ibonds(i,ii)
          if (kk /= icc .and. nat(kk) > 1) nc_icc = kk
        end do
        if (nc_icc == 0) then
          do i = 1, nbonds(ii)
            kk = ibonds(i,ii)
            if (kk /= icc ) nc_icc = kk
          end do
        end if
      else if (nbonds(icc) == 2) then
        nb_icc = ii
        nc_icc = jj
      else
        nb_icc = ibonds(1,icc)
        nc_icc = ibonds(2,icc)
        nd_icc = ibonds(3,icc)
      end if
      if (jjj < 21) return
      select case (nat(icc))
        case (5)
          if (nbonds(icc) == 1) then
                nH = 3                !  sp3 boron
                bond_length = 1.07d0
                angle = tetrahedral
                internal_dihedral = 120.d0
                dihedral = 180.d0
                hybrid(icc) = 3
          else if (nbonds(icc) == 2) then
                nH = 1                !  sp3 boron
                bond_length = 1.07d0
                angle = 120
                dihedral = 180.d0
                hybrid(icc) = 1
          end if
                                        ! Carbon is very important
        case (6)                        ! so there are a lot of options for C-H bonds
                                        ! (Add more as necessary)
          select case (nbonds(icc))
          case (1)                      ! Carbon bonded to one other atom
            if (nat(ii) == 6) then
!
!  C-C bonds are common. So look at single, double, and triple bonds
!
              jj = 0
              do i = 1, nbonds(ii)
                if (nat(ibonds(i,ii)) == 6) jj = jj + 1
              end do
              if (jj == 3) then
!
! See if atom icc is attached to is already sp3
!
                 jj = 0
                 kk = 0
                 do i = 1, nbonds(ii)
                   ll = ibonds(i,ii)
                   if (nat(ll) == 6 .and. jj == 0 .and. ll /= icc .and. (kk /= ll .or. kk == 0)) jj = ibonds(i,ii)
                   if (nat(ll) == 6 .and. kk == 0 .and. ll /= icc .and. (jj /= ll .or. jj == 0)) kk = ibonds(i,ii)
                 end do
                call dihed(coord, icc, ii, jj, kk, sum)
                sum = abs(sum)
                if (hybrid(ii) == 3 .or. min(pi - sum, sum) > 0.4d0) then  ! 22.9 degrees
                  nH = 3
                  angle = tetrahedral                   !  If flat, nc
                  internal_dihedral = 120.d0
                  hybrid(icc) = 3
                  return
                end if
              end if
              jj = 0
              do i = 1, nbonds(ii)
                kk = ibonds(i,ii)
                if (kk /= icc) jj = kk
              end do
              if (Rab > CC .or. hybrid(ii) == 3) then
                nH = 3  ! Methyl
                angle = tetrahedral
                internal_dihedral = 120.d0
                dihedral = 180.d0
                hybrid(icc) = 3
                if (nc_icc == 0) then
                  do i = 1, nbonds(ii)
                    j = ibonds(i,ii)
                    if (j /= icc) then
                      nc_icc = j
                      return
                    end if
                  end do
                end if
              else if (Rab > 11.35d0) then
!
!  Why was this test here?  The original test was Rab > 1.35d0
!
                nH = 3                !  sp3 carbon
                angle = tetrahedral
                internal_dihedral = 120.d0
                dihedral = 180.d0
                hybrid(icc) = 3
              else if (Rab > 1.25d0) then
                nH = 2                 ! ethylene
                bond_length = 1.08d0
                angle = 123.d0
                dihedral = 180.d0
                internal_dihedral = 180.d0
                hybrid(icc) = 2
              else
                nH = 1                  ! acetylene
                bond_length = 1.07d0
                angle = 179.d0
                hybrid(icc) = 1
              end if
            else if (nat(ii) == 7) then
              if (hybrid(ii) == 3 .or. Rab > CN) then
                nH = 3                ! Methyl
                bond_length = 1.09d0
                angle = tetrahedral
                internal_dihedral = 120.d0
                return
              end if
              hybrid(icc) = 1
              if (ionized) then
                nH = 0                    ! Cyanide ion
              else
                nH = 1                    ! Hydrogen cyanide
                angle = 179.d0
              end if
            else if (nat(ii) == 8) then
              if (Rab > 1.37d0 .or. nbonds(ii) > 1) then
                nH = 3                ! Methanol
                bond_length = 1.09d0
                angle = tetrahedral
                internal_dihedral = 120.d0
                hybrid(icc) = 3
              else
                nH = 2                ! Formaldehyde
                angle = 120.d0
                internal_dihedral = 180.d0
                hybrid(icc) = 2
              end if
            else
                nH = 3                ! -CH3 (catch-all)
                angle = tetrahedral
                internal_dihedral = 120.d0
                dihedral = 180.d0
                hybrid(icc) = 3
            end if
!
          case (2)                      ! Carbon bonded to two other atoms
!
            if(nat(ii) == 6) then
              if (nat(jj) == 6) then
                if (aromatic_5(icc, ii, jj, hybrid)) then
                  if (Rab < 1.44d0) then
                    nH = 1                  ! C=C-C
                    angle = 120.d0
                    dihedral = 180.d0
                    hybrid(icc) = 2
                    return
                  else
                    nH = 2                  ! C-C-C
                    angle = tetrahedral
                    dihedral = 120.d0
                    internal_dihedral = 120.d0
                    hybrid(icc) = 3
                    return
                  end if
                end if
                if (aromatic(icc, ii, jj)) then
                  nH = 1                  ! Double bond
                  angle = 120.d0
                  dihedral = 180.d0
                  hybrid(icc) = 2
                  return
                end if
                if (Rab < 1.27d0) then
                  nH = 0
                  hybrid(icc) = 1
                  return
                end if
                nH = 2
                angle = tetrahedral
                internal_dihedral = 120.d0
                dihedral = 120.d0
                hybrid(icc) = 3
                if (hybrid(ii) == 3 .and. hybrid(jj) == 3) return
!
!   Carbon bonded to two other carbon atoms, e.g. C-C-C or C-C=C, etc.
!   Check for double bond
!
                call bangle (coord, ii, icc, jj, sum)    !
                if (sum > 3.d0 .and. Rac < 1.35d0) then ! Acetylenic
                 nH = 0 ! Acetylenic
                 hybrid(icc) = 2
                 return
                end if
                if ( Rab < 1.44d0) then
                  nH = 1                  ! Double bond
                  angle = 120.d0
                  dihedral = 180.d0
                  hybrid(icc) = 2
                  return
                end if
                i = 0
                if (sum > 2.03d0 .and. (Rab < 1.39d0) .or. sum > 2.2d0 .and. (Rab < 1.41d0)) then
                  if (nbonds(ii) /= 4) then
                    if (nbonds(ii) == 3) then
                      j = 0
                      do k = 1,3
                        if (nat(ibonds(k,ii)) == 8) j = j + 1
                      end do
                      if (j /= 2) i = 1
                    else if (nbonds(ii) == 2) then
                      call bangle (coord, ibonds(1,ii), ii, ibonds(2,ii), sum)
                      if (sum > 2.d0) i = 1
                    else
                      i = 1 ! over 116.3 degrees and short bond-lengths
                    end if
                  end if
                end if
                if (i == 1) then
                  nH = 1                               !  sp2 carbon
                  angle = 120.d0
                  internal_dihedral = 180.d0
                  dihedral = 180.d0
                  hybrid(icc) = 2
                end if
              else if (nat(jj) == 7) then
!
!   Carbon bonded to one carbon and one nitrogen atoms, e.g. C-C-N or C-C=N
                if (Rac < 1.2d0) then
                  hybrid(icc) = 1
                  return
!   Check for double bond
!
                 else if (hybrid(ii) == 3 .and. hybrid(jj) == 3) then
                  nH = 2                  ! C-C-N
                  bond_length = 1.09d0
                  angle = tetrahedral
                  internal_dihedral = 120.d0
                  dihedral = 120.d0
                  hybrid(icc) = 3
                else if (Rab < 1.43d0 .or. Rab + Rac < 2.9d0 .and. aromatic_5(icc, ii, jj, hybrid) .and. nbonds(jj) == 2) then
                  nH = 1                  ! Double bond
                  angle = 120.d0
                  dihedral = 180.d0
                  hybrid(icc) = 2
                else if (Rab + Rac < 2.8d0 .and. aromatic_5(icc, ii, jj, hybrid)) then
                  nH = 1                  ! Double bond
                  angle = 120.d0
                  dihedral = 180.d0
                  hybrid(icc) = 2
                else if (aromatic(icc,ii,jj) .or. Rac < CN) then
                  nH = 1                  ! Double bond
                  angle = 120.d0
                  dihedral = 180.d0
                  hybrid(icc) = 2
                  return
                else
                  nH = 2                  ! C-C-N
                  bond_length = 1.09d0
                  angle = tetrahedral
                  internal_dihedral = 120.d0
                  dihedral = 120.d0
                  hybrid(icc) = 3
                end if
              else if (nat(jj) == 8) then
!
!   Carbon bonded to one carbon and one oxygen atom, e.g. C-C-O or C-C=O
!   Check for double bond
!
                if (aromatic_5(icc,ii,jj, hybrid)) then
                  if (Rab < 1.44d0) then
                    nH = 1                  ! C=C-O
                    angle = 120.d0
                    dihedral = 180.d0
                    hybrid(icc) = 2
                    return
                  else
                    nH = 2                  ! C-C-O
                    angle = tetrahedral
                    dihedral = 120.d0
                    internal_dihedral = 120.d0
                    hybrid(icc) = 3
                    return
                  end if
                end if
                if (Rab < 1.4d0 .or. (Rac < 1.3d0 .and. nbonds(jj) == 1)) then
                  if (Rab < 1.4d0 .and. (Rac < 1.3d0 .and. nbonds(jj) == 1)) return ! ketene
                  nH = 1                  ! C=C-O or C-C=O
                  angle = 120.d0
                  dihedral = 180.d0
                  hybrid(icc) = 2
                  return
                end if
                sum = 0.d0
                j = 0
                do i = 1, nbonds(ii)
                  if (nat(ibonds(i,ii)) /= 1) j = j + 1
                end do
                if (nat(ii) == 6 .and. j == 2) then
                  jj = ibonds(1,ii)
                  if (jj == icc) jj = ibonds(2,ii)
                  call bangle (coord, icc, ii, jj, sum)
                end if
                if (Rac < 1.3d0 .and. sum > 2.03d0) then
                  nH = 1                  ! C-C=O
                  angle = 120.d0
                  dihedral = 180.d0
                  hybrid(icc) = 2
                  return
                else
                  nH = 2                  ! C-C-O
                  angle = tetrahedral
                  dihedral = 120.d0
                  internal_dihedral = 120.d0
                  hybrid(icc) = 3
                  return
                end if
              else if (nat(jj) == 9 .or. nat(jj) == 17 .or. nat(jj) == 35 .or. nat(jj) == 53) then
                if (Rab < 1.25d0) then
                  nH = 0                  ! CTC-X
                  hybrid(icc) = 1
                  return
                elseif (Rab < 1.44d0) then
                  nH = 1                  ! C=CH-X
                  angle = 120.d0
                  dihedral = 180.d0
                  hybrid(icc) = 2
                  return
                else
                  nH = 2                  ! C-CH2-X
                  angle = tetrahedral
                  dihedral = 120.d0
                  internal_dihedral = 120.d0
                  hybrid(icc) = 3
                  return
                end if
              else if (nat(jj) == 15) then
!
!   Carbon bonded to one carbon and one phosphorus atom, e.g. C-C-P
!   Check for double bond
!
                nH = 2                    ! C-C-P
                bond_length = 1.09d0
                angle = tetrahedral
                internal_dihedral = 120.d0
                dihedral = 120.d0
                hybrid(icc) = 3
              else if (nat(jj) == 16 .or. nat(jj) == 34) then
!
!   Carbon bonded to one carbon and one sulfur or selenium atom, e.g. C-C-S
!   Check for double bond
!
                if (Rab > 1.35d0) then
                  nH = 2
                  angle = tetrahedral
                  dihedral = 120.d0
                  internal_dihedral = 120.d0
                  hybrid(icc) = 3
                  hybrid(icc) = 2
                else if (Rab > 1.25d0) then
                  if (Rab < 1.4d0 .and. (Rac < 1.6d0 .and. nbonds(jj) == 1)) return ! thioketene
                  nH = 1                  ! C=CH-S
                  bond_length = 1.07d0
                  angle = 120.d0
                  dihedral = 180.d0
                  hybrid(icc) = 1
                else
                  nH = 0                    ! CTC-S
                  hybrid(icc) = 3
                end if
              end if
            else if (nat(ii) == 7) then
              if (nat(jj) == 8) then
                if (Rac < 1.3d0) then
                  nH = 1                    ! aromatic_5 - type
                  angle = 120.d0
                  dihedral = 180.d0
                  hybrid(icc) = 2
                  return
                else
                  nH = 2                    ! C-C-S
                  angle = tetrahedral
                  dihedral = 120.d0
                  internal_dihedral = 120.d0
                  hybrid(icc) = 3
                  return
                end if
              else if (nat(jj) == 7) then
                if ((hybrid(ii) == 3 .or. hybrid(jj) == 3) .and. (Rab > 1.4d0 .and. Rac > 1.4d0)) then
                  nH = 2                    ! N-C-N
                  angle = tetrahedral
                  dihedral = 120.d0
                  internal_dihedral = 120.d0
                  hybrid(icc) = 3
                  return
                else
                  nH = 1                    ! N=C-N
                  angle = 120.d0
                  dihedral = 180.d0
                  hybrid(icc) = 2
                  return
                end if
              else if (nat(jj) == 14) then  ! N-C-S
                if (Rab > 1.4d0 .and. Rac > 1.8d0) then
                  nH = 2                    ! C-C-S
                  angle = tetrahedral
                  dihedral = 120.d0
                  internal_dihedral = 120.d0
                  hybrid(icc) = 3
                else
                  nH = 1
                  angle = 120.d0
                  dihedral = 180.d0
                  hybrid(icc) = 2
                end if
                return
              end if
              if (nat(jj) == 16) then
!
!   Carbon bonded to one nitrogen and one sulfur atom, e.g. N-C-S
!
                nH = 2                    ! N-C-S
                angle = tetrahedral
                dihedral = 120.d0
                internal_dihedral = 120.d0
                hybrid(icc) = 3
                return
              end if
              if (nbonds(icc) == 2 .and. Rab < cyanide) then
                nH = 0                    ! Cyanide (nitrile)
              else
                nH = 1                    ! aromatic_5 - type
                angle = 120.d0
                dihedral = 180.d0
                hybrid(icc) = 2
              end if
            else if (nat(ii) == 8) then
              if (nat(jj) == 9 .or. nat(jj) == 17 .or. nat(jj) == 35 .or. nat(jj) == 53) then
                if (Rab > 1.3d0) then
                  nH = 2
                  angle = tetrahedral
                  dihedral = 120.d0
                  internal_dihedral = 120.d0
                  hybrid(icc) = 3
                else
                  nH = 1
                  angle = 120.d0
                  dihedral = 180.d0
                  hybrid(icc) = 2
                end if
                return
              end if
              if (nbonds(ii) == 2 .and. nbonds(jj) == 2) then
                nH = 2                    ! X-O-CH2-O-X
                angle = tetrahedral
                dihedral = 120.d0
                internal_dihedral = 120.d0
                hybrid(icc) = 3
                return
              end if
              call bangle (coord, ibonds(1,icc), icc, ibonds(2,icc), sum)
              if (nbonds(ii) /= 1 .or. nbonds(jj) /= 1 .or. &
                Rab > 1.28d0 .or. (nat(jj) == 8 .and. sum < 2.618d0) ) then
                nH = 1                    ! HCO2
                angle = 120.d0
                dihedral = 180.d0
                hybrid(icc) = 2
              else
                nH = 0
                hybrid(icc) = 2
              end if
              hybrid(icc) = 2
            else if (nat(ii) == 15) then
              nH = 0
              hybrid(icc) = 2
            else
              hybrid(icc) = 3
            end if
!
          case (3)                      ! Carbon bonded to three other atoms
!
            if (nat(jj) == 7 .and. Rac < CN .and. nat(kk) == 8) then
              nH = 0 ! C-(CO)=N already three ligands
              return
            end if
            if (nat(jj) == 6 .and. Rad < 1.31d0 .and. nat(kk) == 7) then
              nH = 0 ! C-(C)=N already three ligands
              return
            end if
            if (nat(ii) == 6 .and. Rab < CC .and. nat(jj) == 6 .and. nat(kk) == 16) then
              nH = 0 ! S-C=C and already three ligands
              return
            end if
            call dihed(coord, icc, ii, jj, kk, sum)
!
!  A dihedral angle involving the current atom and the three joined to it
!  can be used in deciding whether or not it should be sp2 or sp3
!
!  The tetrahedral dihedral angle, that is the torsion angle from an atom
!  to the first ligand, then to the second, then to the third, is ~35.26439 degrees.
!  The sine of this number is: 0.57735
!
            if (min(2*pi - sum, sum) < 0.05d0) then
              nH = 0    ! Very flat, so it must be sp2
              hybrid(icc) = 2
              return
            end if
            if (min(2*pi - sum, sum) < 0.15d0) then
              if (aromatic(icc,ii,jj) .or. aromatic(icc,ii,kk) .or. aromatic(icc,jj,kk)) then
                nH = 0                               ! aromatic ring
                hybrid(icc) = 2
                return
              end if
              if (aromatic_5(icc,ii,jj, hybrid) .or. aromatic_5(icc,ii,kk, hybrid) &
                .or. aromatic_5(icc,jj,kk, hybrid)) then
                nH = 0                               ! aromatic five membered ring
                hybrid(icc) = 2
                return
              end if
            end if
            if (min(2*pi - sum, sum) < 0.40d0) then
              bits = 0.d0
              if (nat(ii) == 7 .or. nat(ii) == 8) bits = bits + 0.1d0
              if (nat(jj) == 7 .or. nat(jj) == 8) bits = bits + 0.1d0
              if (nat(kk) == 7 .or. nat(kk) == 8) bits = bits + 0.1d0
              if (bits + Rab + Rac + Rad < 4.5d0) then
                nH = 0                      !  If flat, and short bond lengths, make sp2
                hybrid(icc) = 2
                return
              end if
            end if
            if (min(2*pi - sum, sum) > 0.25d0) then
              nH = 1                      !  If pyrimidal, make sp3, and don't check anything else
              hybrid(icc) = 3
              return
            end if
            nH = 1
            hybrid(icc) = 3
            if (nat(ii) == 6) then
              if (nat(jj) == 6) then
                if (nat(kk) == 6) then              !  carbon bonded to three carbon atoms
                  sum = min(Rab, Rac, Rad)
                  if (sum < 1.44d0) then
                    nH = 0                            ! Result is obvious
                    hybrid(icc) = 2
!
!  Consider using "call dihed (coord, icc, ii, jj, kk, bits)" if there is an ambiguity.
!
                  end if
                else if (nat(kk) == 7) then         !  carbon bonded to two carbon atoms and one nitrogen
                  if (hybrid(ii) == 3 .and. hybrid(jj) == 3 .and. hybrid(kk) == 3) return ! Obvious
                  j = 0
                  do i = 1, nbonds(kk)
                    if (nat(ibonds(i,kk)) /= 1) j = j + 1  ! Number of heavy atoms on nitrogen
                  end do
                  if (min(Rab, Rac) < 1.41d0 .or. Rad < 1.39d0 .and. j < 3) then
                    nH = 0
                    hybrid(icc) = 2
                  end if
                else if (nat(kk) == 8) then         !  carbon bonded to two carbon atoms and one oxygen
                  if (min(Rab, Rac) < 1.45d0 .or. Rad < 1.30d0) then
                    nH = 0
                    hybrid(icc) = 2
                  end if
                else if (nat(kk) == 9 .or. nat(kk) == 17 .or. nat(kk) == 35 .or. nat(kk) == 53) then
                  if (min(Rab, Rac) < 1.45d0) then     !  carbon bonded to two carbon atoms and one halogen
                    nH = 0
                    hybrid(icc) = 2
                  end if
                else if (nat(kk) == 16) then
                  sum = min(Rab, Rac)
                  if (aromatic(icc,ii,jj) .or. sum < 1.44d0) then
                    nH = 0                               ! aromatic ring
                    hybrid(icc) = 2
                    return
                  end if
                end if
              else if (nat(jj) == 7) then
                if (nat(kk) == 7) then
                  sum = min(Rab, Rac)
                  if (sum < 1.405d0 .or. hybrid(ii) == 2 .or. hybrid(jj) == 2 .or. hybrid(kk) == 2) then
                    nH = 0
                    hybrid(icc) = 2
                  end if
                else if (nat(kk) == 8) then
                  if (Rac > 1.45d0 .and. Rad > 1.28d0) then       !  Carbon bonded to carbon, sulfur and nitrogen
                    return
                  else
                    nH = 0                                        !  Most likely, a peptide
                    hybrid(icc) = 2
                  end if
                else if (nat(kk) == 16) then
                  call dihed(coord, icc, ii, jj, kk, sum)
                  if (min(2*pi - sum, sum) < 0.15d0) then
                    nH = 0                               ! aromatic ring
                    hybrid(icc) = 2
                    return
                  end if
                else
                  nH = 0                          !  Most likely, a peptide
                  hybrid(icc) = 2
                end if
              else if (nat(jj) == 8) then
                if (nat(kk) == 8 .or. Rac < 1.25d0) then
                  if (nbonds(jj) == 2 .and. nbonds(kk) == 2) then
                    if (Rab < 1.44d0) nH = 0
                    return
                  else
                    nH = 0
                    hybrid(icc) = 2
                  end if
                end if
              else if (nat(jj) == 9 .or. nat(jj) == 17 .or. nat(jj) == 35 .or. nat(jj) == 53) then
                if (Rab < 1.44d0) nH = 0  ! X-C=C
              end if
            else if (nat(ii) == 7) then
              if (nat(jj) == 7) then
                select case (nat(kk))
                case (7)
                  nH = 0
                  hybrid(icc) = 2
                case(8)
                  if (Rad < 1.33d0) then
                    nH = 0
                    hybrid(icc) = 2
                  end if
                case(16)
                  if (Rad < 1.7d0) then
                    nH = 0
                    hybrid(icc) = 2
                  end if
                end select
              end if
            else if (nat(ii) == 8 .or. nat(ii) == 16) then
              nH = 0                                ! Carbon bonded to three oxygen or sulfur atoms !
            end if
          case default
            hybrid(icc) = 3
          end select
                                        ! Nitrogen is very important
        case (7)                        ! so there are a lot of options for N-H bonds
                                        ! (Add more as necessary)
          if (nbonds(icc) == 1) then
            nH = 2                                ! -NH2
            bond_length = 1.02d0
            angle = tetrahedral
            dihedral = 120.d0
            internal_dihedral = 120.d0
            ii = ibonds(1,icc)
            if (nat(ii) == 6) then
              if (Rab < cyanide .and. nbonds(ii) < 3) then
                nH = 0
                hybrid(icc) = 1                          ! Cyanide
                return
              end if
              sum = 1.29d0
              if (nat(ii) == 6 .and. nbonds(ii) == 3) then
                do i = 1,3
                  if (nat(ibonds(i,ii)) == 8) sum = 1.1d0
                end do
              end if
              if (Rab < sum) then
                nH = 1                                   !  C=NH
                angle = 120.d0
                internal_dihedral = 180.d0
                dihedral = 0.d0
                hybrid(icc) = 1
                return
              end if
!
!  For Arg, make one -N -NH2, then decide on the other later on.
!
              if (guanidine(icc, ionized, nH, angle, internal_dihedral, dihedral, hybrid)) then
                continue
                return
                end if
               do i = 1, nbonds(ii)
                jj = ibonds(i,ii)
                if (nat(jj) /= 6 .and. nat(jj) /= 7) exit
                if (nat(jj) == 7 .and. jj /= icc) then  !  N-C-N structure
                  k = 0
                  l = 0
                  do j = 1, nbonds(jj)
                    if (nat(ibonds(j,jj)) == 6) k = k + 1
                    if (nat(ibonds(j,jj)) == 1) l = l + 1
                  end do
                  if (k == 2) cycle               !  Exclude C-N-C
                  if (l == 2) then
                    hybrid(icc) = 2
                    if (ionized) then
                      nH = 2                      !   ionized and an Arg
                      angle = 120.d0
                      internal_dihedral = 180.d0
                      dihedral = 0.d0
                    else
                      nH = 1
                      angle = 120.d0
                      internal_dihedral = 180.d0
                      dihedral = 0.d0
                    end if
                    return                         !  Unconditional
                  else
                    nH = 2
                    angle = 120.d0
                    internal_dihedral = 180.d0
                    dihedral = 0.d0
                    hybrid(icc) = 3
                    return
                  end if
                end if
               end do
            else if (nat(ii) == 7) then
              nH = 0  ! Azide
              return
            end if
            if (ionized) then
              nH = 3  !  Ionized  (what about cyanide?)
              if (nat(ii) == 6) then
                do i = 1, nbonds(ii)
                  if (nat(ibonds(i,ii)) == 8) exit
                end do
                if (i <= nbonds(ii)) nH = 2          !  Exclude -CO-NH3
              end if
            else
              nH = 2                                 ! Generic C-NH2
              angle = 120.d0
              internal_dihedral = 120.d0
              dihedral = 120.d0
              hybrid(icc) = 3
            end if
          else if (nbonds(icc) == 2) then
!
!  Nitrogen bonded to two atoms
!
            if (nat(ii) == 7) then
              if (nat(jj) == 7) then
                sum = min(Rab, Rac)
                if (sum < 1.35d0 .or. nbonds(ii) + nbonds(jj) > 4) then
                  nH = 0
                  hybrid(icc) = 2
                else
                  nH = 1
                  angle = 120.d0
                  dihedral = 180.d0
                  hybrid(icc) = 3
                end if
                return
              end if
            end if
            if (nat(ii) == 6) then
              if (nat(jj) == 6) then
                if (Rab < 1.3d0) then
                  nH = 0
                  continue
                  return
                end if
                if (Rab < CN) then
!
!  Test for double bond
!
                  do i = 1, nbonds(ii)
                    kk = ibonds(i,ii)
                    if (kk /= icc) then
                      if (nat(kk) == 6 .and. distance(kk, ii) < CC .or. &
                        nat(kk) == 7 .or. &
                        nat(kk) == 8 .and. distance(kk, ii) < CO) exit
                    end if
                  end do
                  if (i > nbonds(ii)) then
                    nH = 0
                    continue
                    return
                  end if
                end if
              end if
              if (guanidine(icc, ionized, nH, angle, internal_dihedral, dihedral, hybrid)) return
              if (nat(jj) == 7) then
                if (Rab < 1.39d0 .or. Rac < 1.40d0) then
                  nH = 0
                  return
                end if
              end if
            end if
            if (nat(ii) == 8) then
              if (nat(jj) == 8) then
                if (Rab < 1.30d0 .or. Rac < 1.30d0) then
                  nH = 0
                  return
                end if
              end if
            end if
            if (aromatic(icc,ii,jj)) then
              nH = 0                               ! aromatic ring
              hybrid(icc) = 2
              return
            end if
!
!
!  Locate the N-C-N structure, kk = distant N
!
            kk = 0
            do i = 1, nbonds(ii)
              j = ibonds(i,ii)
              if (nat(j) == 7 .and. j /= icc) then
                kk = j
                if (nbonds(j) == 2) then
                  k = ii   ! N-C-N structure found.
                  ii = jj  ! ii is the C in N-C-N
                  jj = k   ! C(jj) - N(icc) - C(ii) - N(kk)
                end if
              end if

            end do
            if (kk == 0) then
              do i = 1, nbonds(jj)
                j = ibonds(i,jj)
                if (nat(j) == 7 .and. j /= icc) then
                  if (nbonds(j) == 2) then
                    k = ii   ! N-C-N structure found.
                    ii = jj  ! ii is the C in N-C-N
                    jj = k   ! C(jj) - N(icc) - C(ii) - N(kk)
                  end if
                  kk = j   ! kk is the distant N
                end if
              end do
            end if
            if (nat(ii) == 6) then
              i = nbonds(ii)
              do j = 1,i
                k = ibonds(j,ii)
                if (nat(k) == 8) then
                  Rab = distance(ii,k)
                  if (Rab < 1.33d0) kk = 0  ! >C=O detected, therefore not conjugated
                end if
              end do
            end if
            if (kk /= 0) then
              l = 0
              if (nbonds(kk) >= 2) then
                ii = ibonds(1,kk)
                if (nat(ii) == 1 .or. nat(ii) == 6) l = 1
                ii = ibonds(2,kk)
                if (nat(ii) == 1 .or. nat(ii) == 6) l = l + 1
                if (nbonds(kk) == 3) then
                  ii = ibonds(3,kk)
                  if (nat(ii) == 1 .or. nat(ii) == 6) l = l + 1
                end if
                if (l == 3) then                     ! distant nitrogen in a histidine (imidazole) ring
                  hybrid(icc) = 3                    ! has a hydrogen or a carbon attached
                  if (ionized) then
                    nH = 1
                    angle = 125.5d0
                    dihedral = 180.d0
                    return
                  else
                    nH = 0
                    return
                  end if
                else
                  nH = 1
                  angle = 125.5d0
                  dihedral = 180.d0
                  hybrid(icc) = 3
                  return
                end if
              else
                if (distance(icc, ii) > 1.4d0 .or. distance(icc, jj) > 1.4d0) then
!
!  Not aromatic/conjugated
!
                  nH = 1
                  angle = 125.5d0
                  dihedral = 180.d0
                  hybrid(icc) = 3
                  return
                else
                  nH = 0
                  return
                end if
              end if
            end if
            hybrid(icc) = 3
            if (nat(ii) == 6 .and. nat(jj) == 6) then
              if (aromatic(icc,ii,jj)) then
                nH = 0                               ! aromatic ring
                hybrid(icc) = 2
                return
              end if
              if (aromatic_5(icc,ii,jj, hybrid)) then
                nH = 1                               ! five-membered aromatic ring
                angle = 125.5d0
                dihedral = 180.d0
                return
              end if
            end if
            if (nat(ii) == 6 .and. nat(jj) == 8) then
               if (nbonds(jj) == 1) then
                 nH = 0                              ! Nitroso
               else
                nH = 1                               ! -O-NH-C
                angle = 125.5d0
                dihedral = 180.d0
              end if
              return
            end if
            if (nat(jj) == 15) then
              if (Rac < 1.7d0) then
                nH = 0
              else
                nH = 1
                angle = 120.d0
                dihedral = 180.d0
              end if
              return
            end if
            nH = 1
            angle = 120.d0
            dihedral = 180.d0
          else
            hybrid(icc) = 3
          end if
          Rab = Rab
                                        ! Oxygen is very important
        case (8)                        ! so there are a lot of options for O-H bonds
                                        ! (Add more as necessary)
          if (nbonds(icc) == 1) then
            if (nat(ii) == 5) then
              nH = 1
              angle = 110.3d0
              return
            end if
            if (nat(ii) == 6) then
!
!  Check for single or double bond
!
              bond_length = 0.975d0                  ! Ethanol
              angle = 110.3d0                        ! Ethanol
              nH = 1                                 ! Default
              hybrid(icc) = 3
              if (nbonds(ii) == 4) then
                hybrid(icc) = 3
                return
              end if
!
!  See if oxygen is attached to an aromatic ring, if so, then it's a hydroxyl.
!
              if (nbonds(ii) == 3) then
                do i = 1,3
                  jj = ibonds(i,ii)
                  if (jj /= icc) exit
                end do
                do i = i + 1,3
                  kk = ibonds(i,ii)
                  if (kk /= icc .and. kk /= jj) exit
                end do

                if (aromatic(ii, jj, kk)) then
                  if (distance(ii,icc) > 1.3d0) then
                    nH = 1                             ! aromatic ring, therefore hydroxyl
                    hybrid(icc) = 3
                  else
                    nH = 0                           ! Looks like hydroxyl, but C-O bond is too short
                    hybrid(icc) = 2
                  end if
                  return
                end if
              end if
!
!  Check for -COOH
!
              jj = nbonds(ii)
              if (jj == 3) then
                k = 0
                i = 0
                do l = 1, jj
                  kk = ibonds(l,ii)
                  if (nat(kk) == 8) then             !  Found an oxygen atom
                    if (nbonds(kk) == 2) i = i + 1
                    k = k + 1
                    if (kk /= icc) j = kk
                  end if
                end do
                if (k == 2) then                     !  Two oxygen atoms attached to a carbon
                  if (txtatm(ii)(15:16) == " ") then
!
!  This carbon is unlabeled, therefore it is a terminal carbon
!
                    l_tmp = (icc > j)
                  else
                    call find_polar_atom(icc, ii, j, Rab)
                    Rac = distance(ii, j)              !  Pick the longer of the two C-O distances
                    if (Rab < 0.51d0) Rab = distance(ii,icc) ! No polar atom near to icc or j
                    l_tmp =  (Rab > Rac .and. i == 0)
                  end if
                  if (l_tmp) then   !  and neither of them has another atom attached
                    if (ionized) then
                      nH = 0
                    else
                      bond_length = 1.00d0
                      nH = 1
                      angle = 110.d0
                      dihedral = 0.d0
                      do l = 1, jj
                        kk = ibonds(l,ii)
                        if (nat(kk) == 8 .and. kk /= icc) nc_icc = kk
                      end do
                    end if
                    return
                  else
                    nH = 0
                    hybrid(icc) = 2
                    return
                  end if
                end if
              end if
              if (Rab > 1.37d0) then
                nH = 1                               ! Almost certainly hydroxyl
                bond_length = 0.97d0
                angle = 110.d0
                hybrid(icc) = 3
                return
              end if
              if (Rab < 1.3d0 .and. hybrid(ii) == 2) then
                nH = 0                               ! Almost certainly carbonyl
                hybrid(icc) = 2
                return
              end if
!
! start of low-reliability tests
!
              if (Rab < 1.23d0) then
                  nH = 0
                  return
                end if
                if (Rab > 1.17d0) then
                nH = 0
                j = 0
                do i = 1, nbonds(ii)
                  if (nat(ibonds(i,ii)) /= 1) j = j + 1
                end do
                if (nat(ii) == 6 .and. j == 2) then
                  jj = ibonds(1,ii)
                  if (jj == icc) jj = ibonds(2,ii)
                  call bangle (coord, icc, ii, jj, sum)
                  if (sum < 2.03d0) then
                    nH = 1
                    bond_length = 0.97d0
                    angle = 110.d0
                    hybrid(icc) = 3
                    return
                  end if
                end if
              end if
              if (Rab > 1.27d0) then
                if (nat(ii) == 6 .and. nbonds(ii) == 3) then  ! check for planarity
                  jj = ibonds(1,ii)
                  kk = ibonds(2,ii)
                  ll = ibonds(3,ii)
                  i = 0
                  if (nat(jj) == 6) i = 1
                  if (nat(kk) == 6) i = i + 1
                  if (nat(ll) == 6) i = i + 1
                  if (i == 2) then
                    call dihed(coord, ii, jj, kk, ll, sum)
                    if (min(2*pi - sum, sum) < 0.25d0) then
                      nH = 1                         !  If flat, make sp3, and don't check anything else
                      hybrid(icc) = 3
                      return
                    end if
                  end if                             !  Not sure
                end if
              else
                nH = 0                               ! >C=O
                hybrid(icc) = 2
              end if
            else if (nat(ii) == 7) then
!
! O-N  is it HNO3?
!
              if (.not. ionized) then
                if (nbonds(ii) == 3) then
                  j = 0
                  do i = 1, 3
                    if (nat(ibonds(i,ii)) == 8) j = j + 1
                  end do
                  if (j == 3) then  ! Yes, it's a NO3
  !
  ! First, break O-O bonds
  !
                    do i = 1, 3
                      k = ibonds(i,ii)
                      if (nbonds(k) /= 2) cycle
                      if (ibonds(1,k) /= ii) then
                        j = ibonds(1,k)
                        ibonds(1,k) = ibonds(2,k)
                        ibonds(2,k) = j
                      end if
                    end do
                    do ll = 1, 2
                      i = ibonds(ll,ii)
                      if (nbonds(i) == 2) then
                        jj = ibonds(2,i)
                        do k = ll + 1,3
                          j = ibonds(k,ii)
                          if (nbonds(j) == 2) then
                            kk = ibonds(2,j)
                            if (i == kk) then
                              nbonds(i) = 1
                              nbonds(j) = 1
                            end if
                          end if
                        end do
                      end if
                    end do
  !
  ! now check for oxygen bonded to other atoms
  !
                    j = 0
                    do i = 1,3
                      if (nbonds(ibonds(i,ii)) > 1) j = 1
                    end do
                    if (j == 0) then
                      nH = 1  ! NO3, therefore add a hydrogen
                      angle = 120.d0
                      dihedral = 180.d0
                      hybrid(icc) = 3
                      do i = 1,3
                        if (ibonds(i,ii) /= icc) exit
                      end do
                      jj = ibonds(i,ii)
                      do i = i + 1,3
                        if (ibonds(i,ii) /= icc) exit
                      end do
                      jj = ibonds(i,ii)
                    end if
                  else
                    if (Rab > 1.3d0) then
                      nH = 1  !  Long bond, therefore hydroxyl
                      angle = 120.d0
                      dihedral = 180.d0
                      hybrid(icc) = 3
                    else
                      nH = 0
                    end if
                  end if
                end if
              end if
            else if (nat(ii) == 8) then
              nH = 1
              angle = 104.d0
              dihedral = 90.d0
            else if (nat(ii) == 12 .or. nat(ii) == 20) then
              nH = 1                                 ! Mg or Ca
              angle = 150.d0
              hybrid(icc) = 3
            else if (nat(ii) == 15 .or. nat(ii) == 33) then
              hybrid(icc) = 3
               if (nbonds(ii) == 3) then
                 nH = 1
                 angle = 120.d0
                 dihedral = 180.d0
                 do i = 1, 3
                 nd_icc = ibonds(i,ii)
                   if (nd_icc /= nb_icc .and. nd_icc /= icc .and. nd_icc /= nc_icc) exit
                 end do
                 hybrid(icc) = 3
!
!  Test for phosphate and arsenate
!
              else if (nbonds(ii) == 4) then
                jj = 0
                j = 0
                do i = 1, nbonds(ii)
                  kk = ibonds(i,ii)
                  if (nbonds(kk) == 1 .and. nat(kk) == 8) jj = jj + 1
                  if (nat(kk) == 8) j = j + 1
                end do
!
!  jj is the number of oxygen atoms that are not bonded to another atom
!
                if (ionized .and. j == 4) then
                  nH =0
                  return
                end if
                if (jj > 1) then
                  nH = 1
                  angle = 150.d0
                  dihedral = 0.d0
                end if
              end if
            else if (nat(ii) == 16 .or. nat(ii) == 34) then
!
!  Test for sulfate, sulfite, selenate, and selenite
!
              hybrid(icc) = 3
              if (nbonds(ii) == 2) then
                if (nat(ibonds(1,ii)) == 6 .or. nat(ibonds(2,ii)) == 6) then
                  nH = 1
                  angle = 120.d0
                  dihedral = 90.d0
                end if
              else if (nbonds(ii) > 2) then
                jj = 0
                j = 0
                do i = 1, nbonds(ii)
                  kk = ibonds(i,ii)
                  if (nbonds(kk) == 1 .and. nat(kk) == 8) jj = jj + 1
                  if (nat(kk) == 8) j = j + 1
                end do
                if (ionized .and. j == 4) then
                  nH =0
                  return
                end if
!
!  jj is the number of oxygen atoms that are not bonded to another atom
!
                if (jj > nbonds(ii) - 2) then
                  nH = 1
                  angle = 150.d0
                  dihedral = 0.d0
                end if
              else
                hybrid(icc) = 3
              end if
            else
              hybrid(icc) = 3
            end if
          else
            hybrid(icc) = 2
          end if
!
!
!
           case (14, 32, 50)
             bond_length = 1.3d0
             select case (nbonds(icc))
             case (1)
               nH = 3
               angle = tetrahedral
               internal_dihedral = 120.d0
               dihedral = 180.d0
               hybrid(icc) = 3
             case (2)
               nH = 2
               angle = tetrahedral
               internal_dihedral = 180.d0
               dihedral = 90.d0
               hybrid(icc) = 3
             case (3)
               nH = 1
               angle = 125.5d0
               dihedral = 180.d0
               hybrid(icc) = 3
             case (4, 5, 6)
               nH = 0
             end select
             return
           case (15)
           hybrid(icc) = 3
          if (nbonds(icc) == 1) then
            nH = 2                                   ! -PH2
            bond_length = 1.42d0
            angle = 93.5d0
            internal_dihedral = 93.8d0
          else if (nbonds(icc) == 2) then
            nH = 1                                   ! >PH
            bond_length = 1.42d0
            angle = 122.d0
            dihedral = 180.d0
          end if
        case (16)
          hybrid(icc) = 3
          if (nbonds(icc) == 1) then
            if (Rab < 2.00d0 .and. nat(ii) == 16 .or. &
                Rab < 1.69d0 .and. nat(ii) ==  6) then
              nH = 0
            else
              if (Rab < 1.65d0) then
                nH = 0
              else
                nH = 1                                   ! -S-H
                bond_length = 1.3d0
                angle = 100.d0
                dihedral = 90.d0
              end if
            end if
          end if
        case (33)
          hybrid(icc) = 3
          if (nbonds(icc) == 1) then
            nH = 2                                   ! -AsH2
            bond_length = 1.52d0
            angle = 92.d0
            internal_dihedral = 92.d0
          else if (nbonds(icc) == 2) then
            nH = 1                                   ! >AsH
            bond_length = 1.52d0
            angle = 95.d0
            internal_dihedral = 95.d0
          end if
        case (34)
          hybrid(icc) = 3
          if (nbonds(icc) == 1) then
            nH = 1                                   ! -Se-H
            bond_length = 1.46d0
            angle = 91.d0
          end if
        case (51)
          hybrid(icc) = 3
          if (nbonds(icc) == 1) then
            nH = 2                                   ! -SbH2
            bond_length = 1.71d0
            angle = 92.d0
            internal_dihedral = 92.d0
          else if (nbonds(icc) == 2) then
            nH = 1                                   ! >SbH
            bond_length = 1.71d0
            angle = 95.d0
            internal_dihedral = 95.d0
            hybrid(icc) = 3
          end if
        case (52)
          hybrid(icc) = 3
          if (nbonds(icc) == 1) then
            nH = 1                                   ! -Te-H
            bond_length = 1.69d0
            angle = 90.d0
          end if
        case default
          hybrid(icc) = 3
        end select
    end if
  end subroutine h_type

  subroutine add_a_generic_hydrogen_atom(na, nb, nc, bond_length, angle, dihedral, metals, nmetals)
!
!  Add a single hydrogen atom to a heavy atom.
!  (This subroutine is generic, and is derived from subroutine geout)
!
    use common_arrays_C, only : coord, nbonds, ibonds, nat, txtatm
    use molkst_C, only : numat, id, temp_1, temp_2, temp_3, line
    use chanel_C, only: iw
    implicit none
    double precision, intent (in) :: bond_length, angle, dihedral
    integer, intent (in) :: na, nb, nc, nmetals, metals(nmetals)
!
    double precision :: xb, yb, zb, rbc, xa, ya, za, xpa, xpb, costh, sinth, &
      sinph, cosph, zqa, yza, xyb, ypa, coskh, sinkh, sina, cosd, &
      xd, yd, zd, xpd, ypd, zqd, xqd, yqd, xrd, cosa, sind, zpd
    integer :: k
    double precision, external :: distance
    logical, external :: near_a_metal
      cosa = cos(angle)
      if (id > 0) then
        xb = distance(nb, na)
        xb = temp_1
        yb = temp_2
        zb = temp_3
      else
        xb = coord(1,nb) - coord(1,na)
        yb = coord(2,nb) - coord(2,na)
        zb = coord(3,nb) - coord(3,na)
      end if
      rbc = xb*xb + yb*yb + zb*zb
      if (rbc < 1.d-4) then
        write(line,'(a, i6, a, i6, a)')"Atoms",na, " and", nb, " have the same coordinates."
        call mopend(trim(line))
        write(iw,'(/10x, a, i6, a, a, 3f10.3)') &
          "Atom No.:", na, "  Label: """//trim(txtatm(na))//"""", " Coordinates:", coord(:,na)
        write(iw,'(10x, a, i6, a, a, 3f10.3)') &
          "Atom No.:", nb, "  Label: """//trim(txtatm(nb))//"""", " Coordinates:", coord(:,nb)
        write(iw,'(/10x,a)')"Correct error before continuing."
        return
      end if
      rbc = 1.0D00/sqrt(rbc)
      if (nc /= 0) then
        if (id > 0) then
          xa = distance(nc, na)
          xa = temp_1
          ya = temp_2
          za = temp_3
        else
          xa = coord(1,nc) - coord(1,na)
          ya = coord(2,nc) - coord(2,na)
          za = coord(3,nc) - coord(3,na)
        end if
      else
        xa = 1.d0
        ya = 2.d0
        za = 3.d0
      end if
!
!     ROTATE ABOUT THE Z-AXIS TO MAKE YB=0, AND XB POSITIVE.  IF XYB IS
!     TOO SMALL, FIRST ROTATE THE Y-AXIS BY 90 DEGREES.
!
      xyb = sqrt(xb*xb + yb*yb)
      k = -1
      if (xyb <= 0.009d0) then
        xpa = za
        za = -xa
        xa = xpa
        xpb = zb
        zb = -xb
        xb = xpb
        xyb = sqrt(xb*xb + yb*yb)
        k = 1
      end if
!
!     ROTATE ABOUT THE Y-AXIS TO MAKE ZB VANISH
!
      costh = xb/xyb
      sinth = yb/xyb
      xpa = xa*costh + ya*sinth
      ypa = ya*costh - xa*sinth
      sinph = zb*rbc
      cosph = sqrt(abs(1.D00 - sinph*sinph))
      zqa = za*cosph - xpa*sinph
!
!     ROTATE ABOUT THE X-AXIS TO MAKE ZA=0, AND YA POSITIVE.
!
      yza = sqrt(ypa**2 + zqa**2)
      if (yza >= 1.D-4) then
        coskh = ypa/yza
        sinkh = zqa/yza
      else
!
!   ANGLE TOO SMALL TO BE IMPORTANT
!
        coskh = 1.D0
        sinkh = 0.D0
      end if
!
!     COORDINATES :-   A=(???,YZA,0),   B=(RBC,0,0),  C=(0,0,0)
!     NONE ARE NEGATIVE.
!     THE COORDINATES OF I ARE EVALUATED IN THE NEW FRAME.
!
      sina = sin(angle)
      sind = -sin(dihedral)
      cosd = cos(dihedral)
      xd = bond_length*cosa
      yd = bond_length*sina*cosd
      zd = bond_length*sina*sind
!
!     TRANSFORM THE COORDINATES BACK TO THE ORIGINAL SYSTEM.
!
      ypd = yd*coskh - zd*sinkh
      zpd = zd*coskh + yd*sinkh
      xpd = xd*cosph - zpd*sinph
      zqd = zpd*cosph + xd*sinph
      xqd = xpd*costh - ypd*sinth
      yqd = ypd*costh + xpd*sinth
      if (k >= 1) then
        xrd = -zqd
        zqd = xqd
        xqd = xrd
      end if
      numat = numat + 1
      coord(1,numat) = xqd + coord(1,na)
      coord(2,numat) = yqd + coord(2,na)
      coord(3,numat) = zqd + coord(3,na)
      nbonds(na) = nbonds(na) + 1
      nbonds(numat) = 1
      nat(numat) = 1
      ibonds(1,numat) = na
      ibonds(nbonds(na),na) = numat
      if (near_a_metal(na, numat, metals, nmetals)) numat = numat - 1
      return
  end subroutine add_a_generic_hydrogen_atom
!
!
  subroutine add_a_sp3_hydrogen_atom(icc, nb_icc, nc_icc, nd_icc, bond_length, metals, nmetals)
    use molkst_C,  only : numat
    use common_arrays_C,  only : coord, nbonds, ibonds, nat
    implicit none
    integer,  intent (in) :: icc, nmetals, metals(nmetals)
    integer ::  nb_icc, nc_icc, nd_icc
    double precision :: bond_length
    double precision :: x, y, z, ax, ay, az, r1, r2, sum, angle, dihedral
    logical, external :: near_a_metal
!
!  Adding a hydrogen atom to a heavy atom.  The heavy atom is atom number "icc"
!  In this subroutine, a hydrogen atom is added to a single heavy atom.
!  Four atoms are needed: atom icc, which will have the hydrogen atom attached,
!  and atoms nb_icc, nc_icc, and nd_icc which are attached to icc.
!  These atoms form a triangle, this triangle is used in determining the direction that the hydrogen
!  atom is pointed.
!
    ax = coord(1, icc)
    ay = coord(2, icc)
    az = coord(3, icc)
    x = (coord(1,nb_icc) + coord(1,nc_icc) + coord(1,nd_icc))/3.d0
    y = (coord(2,nb_icc) + coord(2,nc_icc) + coord(2,nd_icc))/3.d0
    z = (coord(3,nb_icc) + coord(3,nc_icc) + coord(3,nd_icc))/3.d0
    r1 = sqrt((x-ax)**2+(y-ay)**2+(z-az)**2)
    if (r1 < 0.4d0 .and. nat(icc) == 6 .or. r1 < 0.3d0) then
!
!  System is almost flat, so put hydrogen perpendicular to the plane
!
      angle = 1.570796d0
      dihedral = 1.57d0
      call add_a_generic_hydrogen_atom(icc, nb_icc, nc_icc, bond_length, angle, dihedral, metals, nmetals)
      r1 =         (coord(1,nb_icc) - coord(1,numat))**2 + &
        (coord(2,nb_icc) - coord(2,numat))**2 + (coord(3,nb_icc) - coord(3,numat))**2
      r1 = min(r1, (coord(1,nc_icc) - coord(1,numat))**2 + &
        (coord(2,nc_icc) - coord(2,numat))**2 + (coord(3,nc_icc) - coord(3,numat))**2)
      r1 = min(r1, (coord(1,nd_icc) - coord(1,numat))**2 + &
        (coord(2,nd_icc) - coord(2,numat))**2 + (coord(3,nd_icc) - coord(3,numat))**2)
      nbonds(icc) = nbonds(icc) - 1
      dihedral = -dihedral
      call add_a_generic_hydrogen_atom(icc, nb_icc, nc_icc, bond_length, angle, dihedral, metals, nmetals)
      r2 =         (coord(1,nb_icc) - coord(1,numat))**2 + &
        (coord(2,nb_icc) - coord(2,numat))**2 + (coord(3,nb_icc) - coord(3,numat))**2
      r2 = min(r2, (coord(1,nc_icc) - coord(1,numat))**2 + &
        (coord(2,nc_icc) - coord(2,numat))**2 + (coord(3,nc_icc) - coord(3,numat))**2)
      r2 = min(r2, (coord(1,nd_icc) - coord(1,numat))**2 + &
        (coord(2,nd_icc) - coord(2,numat))**2 + (coord(3,nd_icc) - coord(3,numat))**2)
      if (r2 > r1) coord(:,numat - 1) = coord(:,numat)
      numat = numat - 1
      return
    end if
    sum=bond_length/r1
    numat = numat + 1
    coord(1, numat) = ax + sum*(ax-x)
    coord(2, numat) = ay + sum*(ay-y)
    coord(3, numat) = az + sum*(az-z)
    nbonds(icc) = nbonds(icc) + 1
    nbonds(numat) = 1
    nat(numat) = 1
    ibonds(1,numat) = icc
    ibonds(nbonds(icc),icc) = numat
    if (near_a_metal(icc, numat, metals, nmetals)) numat = numat - 1
  end subroutine add_a_sp3_hydrogen_atom
!
!
  logical function aromatic(atom_1, atom_2, atom_6)
!
!  Given three adjacent atoms, atom_2 - atom_1 - atom_6, determine if they belong
!  to an aromatic ring.  If so, "aromatic" return .true.
!
    use common_arrays_C,  only : coord,  nbonds,  ibonds, nat
    use funcon_C,  only : pi
    implicit none
    integer, intent (in) :: atom_1, atom_2, atom_6
    integer :: atom_3, atom_5, i, j, k, l, m, nii, njj, kka, atom_4, ii
    double precision :: bent = 0.4d0, sum, Rcc
    double precision, external :: distance
      aromatic = .false.
      nii = nbonds(atom_2)
      njj = nbonds(atom_6)
      do i = 1, nii
        atom_3 = ibonds(i,atom_2)
        if (atom_3 == atom_1) cycle
        do j = 1, njj
          atom_5 = ibonds(j,atom_6)
          if (atom_5 == atom_1) cycle
          do k = 1, nbonds(atom_5)
            kka = ibonds(k,atom_5)
            if (kka == atom_6) cycle
            do l = 1, nbonds(atom_3)
              atom_4 = ibonds(l,atom_3)
              if (atom_4 == atom_2) cycle
              if (atom_4 == atom_5) then
!
!  Five-membered ring, check for N, O or S
!
                if (nat(atom_4) == 7 .or. nat(atom_4) == 8 .or. nat(atom_4) == 16 .or. &
                    nat(atom_3) == 7 .or. nat(atom_3) == 8 .or. nat(atom_3) == 16) then
                  call dihed(coord, atom_1, atom_2, atom_4, atom_6, sum)
                  if (min(2*pi - sum, sum) < bent) then
                    call dihed(coord, atom_1, atom_2, atom_3, atom_4, sum)
                    if (nat(atom_1) /= 6) then
                      Rcc = 2.d0 ! Definitely not aromatic
                    else
                      Rcc = min(distance(atom_1, atom_2), distance(atom_1, atom_6))
                    end if
                    aromatic = (min(2*pi - sum, sum) < bent .and. Rcc < 1.43d0 )
                  end if
                  return
                end if
              end if
              if (kka == atom_4) then
                if (atom_1 == atom_3 .or. atom_1 == atom_4 .or. atom_1 == atom_5) exit
                if (atom_2 == atom_3 .or. atom_2 == atom_4 .or. atom_2 == atom_5) exit
                if (atom_3 == atom_4 .or. atom_3 == atom_5 .or. atom_3 == atom_6) exit
                if (atom_4 == atom_5 .or. atom_4 == atom_6 .or. atom_5 == atom_6) exit
                m = max(nat(atom_1), nat(atom_2), nat(atom_3), nat(atom_4), nat(atom_5), nat(atom_6))
                if (m == 8 .or. m == 14 .or. m == 16) exit
                m = 0
                if (nat(atom_1) == 7 .and. nbonds(atom_1) > 2) m = m + 1
                if (nat(atom_2) == 7 .and. nbonds(atom_2) > 2) m = m + 1
                if (nat(atom_3) == 7 .and. nbonds(atom_3) > 2) m = m + 1
                if (nat(atom_4) == 7 .and. nbonds(atom_4) > 2) m = m + 1
                if (nat(atom_5) == 7 .and. nbonds(atom_5) > 2) m = m + 1
                if (nat(atom_6) == 7 .and. nbonds(atom_6) > 2) m = m + 1
!
!  Check for six-membered rings that have one or more >C=O (exclude >C-O)
!
                if (nat(atom_1) == 7) then
                  if (nat(atom_2) == 6 .and. nbonds(atom_2) == 3) then
                    do ii = 1, 3
                      if (nat(ibonds(ii, atom_2)) == 8) exit
                    end do
                    if (ii < 4) then
                      if (distance(atom_2, ibonds(ii, atom_2)) < 1.29d0) m = m + 2
                    end if
                  end if
                  if (nat(atom_6) == 6 .and. nbonds(atom_6) == 3) then
                    do ii = 1, 3
                      if (nat(ibonds(ii, atom_6)) == 8) exit
                    end do
                    if (ii < 4) then
                      if (distance(atom_6, ibonds(ii, atom_6)) < 1.29d0) m = m + 2
                    end if
                  end if
                end if
                if (m > 1) exit
!
!  Six-membered ring, with atoms numbered atom_1, atom_2, atom_3, atom_4 = kka, atom_5, atom_6
!
                call dihed(coord, atom_1, atom_2, atom_3, atom_4, sum)
                if (min(2*pi - sum, sum) < bent) then
                  call dihed(coord, atom_2, atom_3, atom_4, atom_5, sum)
                  if (min(2*pi - sum, sum) < bent) then
                    call dihed(coord, atom_3, atom_4, atom_5, atom_6, sum)
                    if (min(2*pi - sum, sum) < bent) then
                      call dihed(coord, atom_4, atom_5, atom_6, atom_1, sum)
                      if (min(2*pi - sum, sum) < bent) then
                        call dihed(coord, atom_5, atom_6, atom_1, atom_2, sum)
                        if (min(2*pi - sum, sum) < bent) then
                          call dihed(coord, atom_6, atom_1, atom_2, atom_3, sum)
                          if (min(2*pi - sum, sum) < bent) then
!
! Flat six-membered ring
!
                          aromatic = .true.
                          return
                          end if
                        end if
                      end if
                    end if
                  end if
                end if
              end if
            end do
          end do
        end do
      end do
      return
  end function aromatic
  logical function aromatic_5(atom_1, atom_2, atom_5, hybrid)
!
!  Given three adjacent atoms, atom_2 - atom_1 - atom_5, determine if they belong
!  to an five-membered aromatic ring.  If so, "aromatic_5" return .true.
!
    use common_arrays_C,  only : coord,  nbonds,  ibonds
    use molkst_C, only : numat
    use funcon_C,  only : pi
    implicit none
    integer, intent (in) :: atom_1, atom_2, atom_5, hybrid(numat)
    integer :: atom_3, i, j, k, nii, njj, kka, atom_4, l
    double precision :: bent = 0.4d0, sum
      if (numat < 5) then
        aromatic_5 = .false.
        return
      end if
      nii = nbonds(atom_2)
      njj = nbonds(atom_5)
      do i = 1, nii
        atom_3 = ibonds(i,atom_2)
        if (atom_3 == atom_1) cycle
        do j = 1, njj
          atom_4 = ibonds(j,atom_5)
          if (atom_4 == atom_1) cycle
          do k = 1, nbonds(atom_4)
            kka = ibonds(k,atom_4)
            if (kka == atom_3) then
              l = max(hybrid(2), hybrid(3), hybrid(4), hybrid(5))
              if (l == 3) cycle  ! if any atom in the ring is sp3, the ring cannot be aromatic
!
!  five-membered ring, with atoms numbered atom_1, atom_2, atom_3 = kka, atom_4, atom_5
!
              call dihed(coord, atom_1, atom_2, atom_3, atom_4, sum)
              if (min(2*pi - sum, sum) < bent) then
                call dihed(coord, atom_2, atom_3, atom_4, atom_5, sum)
                if (min(2*pi - sum, sum) < bent) then
                  call dihed(coord, atom_3, atom_4, atom_5, atom_1, sum)
                  if (min(2*pi - sum, sum) < bent) then
                    call dihed(coord, atom_4, atom_5, atom_1, atom_2, sum)
                    if (min(2*pi - sum, sum) < bent) then
                      call dihed(coord, atom_5, atom_1, atom_2, atom_3, sum)
                      if (min(2*pi - sum, sum) < bent) then
!
! Flat five-membered ring
!
                        aromatic_5 = .true.
                        return
                      end if
                    end if
                  end if
                end if
              end if
            end if
          end do
        end do
      end do
      aromatic_5 = .false.
      return
  end function aromatic_5
  logical function near_a_metal(icc, ii, metals, nmetals)
!
!  Work out whether the atom (icc) or the hydrogen atom (numat) is near
!  to a metal atom (metals(natoms)).  If so, set near_a_metal = .false.
!  and delete bonds formed.
!
  use common_arrays_C,  only : nbonds,  nat
  implicit none
  integer, intent (in) :: icc, ii, nmetals, metals(nmetals)
  integer :: i
  logical :: Sulfur, Oxygen, Nitrogen
  double precision :: Rab, Rac
  double precision, external :: distance
    do i = 1, nmetals
      Rab = distance(metals(i), icc)
      Rac = distance(metals(i), ii)
!
!  Check for Sulfur and Oxygen.  Maybe check for (not carbon)?
!
      Sulfur =   (nat(icc) == 16 .and. Rab < 2.6d0)
      Oxygen =   (nat(icc) == 8 .and. Rab < 2.1d0 .and. Rac <= Rab)
      Nitrogen = (nat(icc) == 7 .and. Rab < 2.5d0 .and. Rac <= Rab)
      if (Rac < 1.5d0) exit
      if ((Sulfur .or. Oxygen .or. Nitrogen)) exit
    end do
    near_a_metal = (i <= nmetals)
    if (.not. near_a_metal) return
    nbonds(icc) = nbonds(icc) - 1
    return
  end function near_a_metal



  subroutine bridge_H
!
!  Detect and print unusually short hydrogen bonds
!
  use molkst_C,  only : numat, line
  use common_arrays_C,  only : nat, nbonds,  ibonds, txtatm, &
    breaks
  use chanel_C, only : iw, log, ilog
  use elemts_C, only: elemnt
  implicit none
  integer :: i,ii, j, k, l, kk, jj, nchain2
  double precision :: bond_length, bond_length_2, sum
  integer, allocatable :: h1(:), h2(:)
  double precision, allocatable :: Rab1(:), Rab2(:)
  double precision, external :: distance
    allocate (h1(numat), h2(numat),Rab1(numat),Rab2(numat))
    Rab1 = 100.d0
    Rab2 = 100.d0
    k = 0
    ii = 0
    do i = 1, numat
      if (nat(i) /= 1) cycle
      bond_length = 10.d0
      bond_length_2 = 10.d0
      nchain2 = 1
      l = 0
      k = 0
      do j = 1, numat
        if (j == breaks(nchain2)) nchain2 = nchain2 + 1
        if (nat(j) == 1) cycle
        sum = distance(i,j)
!
!  Exclude water
!
        jj = 0
        if (nat(j) == 8) then
          jj = 0
          do kk = 1, nbonds(j)
            if (nat(ibonds(kk,j)) == 1) jj = jj + 1
          end do
        end if
        if (jj < 2) then
          if (sum < bond_length_2) then
            if (sum < bond_length) then
              bond_length_2 = bond_length
              l = k
              bond_length = sum
              k = j
            else
              bond_length_2 = sum
              l = j
            end if
          end if
        end if
      end do
      if (k > 0) then
!
! Rab1 = bond length from hydrogen to the nearer heavy atom
! Rab2 = bond length from hydrogen to the more distant heavy atom
! h1   = atom that hydrogen is nearer to.
! h2   = atom that hydrogen is more distant from
!
        Rab1(i) = bond_length
        h1(i) = k
        Rab2(i) = bond_length_2
        h2(i) = l
      end if
    end do
    do j = 1, 20
      bond_length_2 = 100.d0
      do i = 1, numat
        if (Rab2(i) < bond_length_2) then
          bond_length_2 = Rab2(i)
          k = i
        end if
      end do
      if (bond_length_2 > 1.5d0) exit
      if (ii == 0) then
        ii = 1
        write(line,"(16x,a)")"  UNUSUALLY SHORT HYDROGEN BOND DISTANCES"
        write(iw,"(/,a)")trim(line)
        if(log) write(ilog,"(/,a)")trim(line)
        write(iw,"(a)")
        if(log) write(ilog,"(a)")
        write(line,"(a)")"  Hydrogen   R(H-A)  Atom A    R(H-B)  Atom B     R(A-B)      Loc-A      Loc-B"
        write(iw,"(a)")trim(line)
        if(log) write(ilog,"(a)")trim(line)
      end if
      write(line,"(i8,f10.2,2x,a,i5,f9.2,2x,a,i5, f10.2,5x,a,2x,a)") k, Rab2(k), elemnt(nat(h2(k))), &
          h2(k), Rab1(k), elemnt(nat(h1(k))), h1(k), distance(h1(k), h2(k)), &
          txtatm(h2(k))(18:20)//txtatm(h2(k))(23:27)//" "//txtatm(h2(k))(22:22), &
          txtatm(h1(k))(18:20)//txtatm(h1(k))(23:27)//" "//txtatm(h1(k))(22:22)
      write(iw,"(a)")trim(line)
      if(log) write(ilog,"(a)")trim(line)
      Rab2(k) = 10.d0
    end do
    if (ii == 1) write(iw,*)
    if (ii == 1 .and. log) write(ilog,*)
    return
  end subroutine bridge_H
  subroutine reset_breaks
    use molkst_C,  only : numat, nbreaks, line, keywrd
    use common_arrays_C,  only : coord, txtatm, break_coords, breaks
    use chanel_C, only : iw
    implicit none
    integer :: i, j, k, l
    double precision :: sum
    logical :: first = .true.
    double precision, external :: reada
    save :: first
!
! Re-set "breaks" - they move when RESEQ or ADD_H is called
!
      do nbreaks = 1, 50
        numat_loop: do j = 1, numat
          sum = abs(coord(1,j) - break_coords(1,nbreaks)) + &
                abs(coord(2,j) - break_coords(2,nbreaks)) + &
                abs(coord(3,j) - break_coords(3,nbreaks))
          if (sum < 0.1d0) then
            exit numat_loop
          end if
        end do numat_loop
        if (j > numat) exit
  !
  !  Now move to the end of the residue
  !
        line = txtatm(j)(23:)
        k = nint(reada(line,1))
        do
          j = j + 1
          if (j > numat) exit
          line = txtatm(j)(23:)
          l = nint(reada(line,1))
          if (l /= k) exit
        end do
        breaks(nbreaks) = j - 1
      end do
!
!  Sequence breaks into increasing order
!
      j = 1
      nbreaks = nbreaks - 1
      do i = 1, nbreaks
        l = breaks(i)
        do k = i + 1, nbreaks
          if (breaks(k) < l) then
            breaks(i) = breaks(k)
            breaks(k) = l
            l = breaks(i)
          end if
        end do
        if (i > 1) then
          if (breaks(i) /= breaks(i - 1)) then
            j = j + 1
            breaks(j) = breaks(i)
          end if
        end if
      end do
      nbreaks = j
      breaks(nbreaks + 1) = 0
!
!  The following block is probably never used - delete it sometime (note date: 12/6/2015)
!
      if (index(keywrd, " NORES") == 0) then
        do i = 1, nbreaks
          do j = i + 1, nbreaks
            if (breaks(j) < breaks(i)) then
              if (first .and. index(keywrd, "GEO-OK") == 0) then
                first = .false.
!
!   An entire block has moved, so the breaks are no longer valid
!
!   Print a warning and quit
!
                call mopend("WARNING: After RESEQ, PDB ""TER"" locations are incorrect")
                write(iw,'(5x,a)')" To correct this error, edit the data set or PDB file"// &
                " or add keyword NORESEQ"
                write(iw,'(5x,a)')" To suppress this error, add ""GEO-OK"" to the keywords"
              end if
            end if
          end do
        end do
      end if
      j = 1
      do i = 2, nbreaks
        if (breaks(i) - breaks(i - 1) > 0) then
          j = j + 1
          breaks(j) = breaks(i)
        end if
      end do
      nbreaks = j
      breaks(nbreaks + 1) = 0
      j = 1
      do i = 1, numat
        write(line,'(a6,i5,a)')txtatm(i)(:6),i + j - 1,txtatm(i)(12:)
        txtatm(i) = trim(line)
        if (i == breaks(j)) j = j + 1
      end do
  end subroutine reset_breaks
  subroutine find_polar_atom(O1, C, O2, Rab)
!
! Given a -COO group, -(C)(O1)(O2), find the nearest polar oxygen.
! If it's O1, set Rab large
! If it's O2, set Rab small
! If there isn't one, set Rab very small
!
  use molkst_C,  only : numat
  use common_arrays_C,  only : nat,  coord,  nbonds,  ibonds
  implicit none
  integer, intent (in) :: O1, C, O2
  double precision, intent (inout) :: Rab
  integer :: i, j, k, n1, n2, n1_near(10), n2_near(10)
  double precision :: RO1, RO2, angle, RO1_near(10), RO2_near(10)
  double precision, external :: distance
    n1 = 0
    n2 = 0
    RO1 = 0.d0
    do i = 1, numat
      if (nat(i) == 8) then
        if (i /= O1) then
          do j = 1, nbonds(i)
            k = ibonds(j,i)
            if (nat(k) == 6) then
              RO1 = distance(O1, i)
              if (RO1 < 4.d0) then
                call bangle(coord, C, O1, i, angle)
                if (angle > 1.570796d0) then ! 90 degrees
                  call dihed (coord, i, O1, C, O2, angle)
                  if (angle < 1.570796d0 .or. angle > 4.71239d0) then
                    n1 = n1 + 1
                    n1_near(n1) = i
                    RO1_near(n1) = RO1
                  end if
                end if
              end if
            end if
          end do
        end if
        if (i /= O2) then
          do j = 1, nbonds(i)
            k = ibonds(j,i)
            if (nat(k) == 6) then
              RO2 = distance(O2, i)
              if (RO2 < 4.d0) then
                call bangle(coord, C, O2, i, angle)
                if (angle > 1.570796d0) then ! 90 degrees
                  call dihed (coord, i, O2, C, O1, angle)
                  if (angle < 1.570796d0 .or. angle > 4.71239d0) then
                    n2 = n2 + 1
                    n2_near(n2) = i
                    RO2_near(n2) = RO1
                  end if
                end if
              end if
            end if
          end do
        end if
      end if
    end do
    if (n1 == 0) then
      if (n2 == 0) return
!
!  There is an oxygen near to O2.  Set Rab small, so that the hydrogen is put on O2
!
      Rab = 0.52d0
    else
      if (n2 == 0) then
!
!  There is an oxygen near to O1.  Set Rab large, so that the hydrogen is put on O1
!
        Rab = 4.02d0
      else
!
!  There are no oxygen atoms near tp O1 or O2.  Set Rab large, so that the C-O1 and C-O2
!  distances will be used in deciding which oxygen atom has the hydrogen
!
        RO1 = 10.d0
        do i = 1, n1
          if (RO1 > RO1_near(i)) then
            RO1 = RO1_near(i)
            j = n1_near(i)
          end if
        end do
        RO2 = 10.d0
        do i = 1, n2
          if (RO2 > RO2_near(i)) then
            RO2 = RO2_near(i)
            k = n2_near(i)
          end if
        end do
        if (RO1 < RO2) then
!
!  There is an oxygen near to both O1 and O2.  Use the O1-O and O2-O distances
!  in deciding where to put the hydrogen atom.
!
           Rab = 4.1d0
        else
           Rab = 0.5d0
        end if
      end if
    end if
    return
  end subroutine find_polar_atom
  logical function guanidine (icc, ionized, nH, angle, internal_dihedral, dihedral, hybrid)
!
!   Test nitrogen atom "icc" to check that it's a "nu-1" or "nu-2" of a guanidine group in an Arg
!
  use common_arrays_C,  only : nat,  nbonds,  ibonds, txtatm
  use molkst_C,  only : numat
  implicit none
  integer :: nH, icc, hybrid(numat)
  double precision :: angle, internal_dihedral, dihedral
  logical :: ionized
!
!  Local
!
  integer :: i, j, k, ii, jj, loop
  guanidine = .false.
  if (.not. (txtatm(icc)(13:16) == " NH1" .or. txtatm(icc)(13:16) == " NH2")) return
  do loop = 1, nbonds(icc)
    ii = ibonds(loop,icc)
    do i = 1, nbonds(ii)
      jj = ibonds(i,ii)
      if (nat(jj) /= 6 .and. nat(jj) /= 7) exit
      if (nat(jj) == 7 .and. jj /= icc) then  !  N-C-N structure
        k = 0
        do j = 1, nbonds(jj)
          if (nat(ibonds(j,jj)) == 6) k = k + 1
        end do
        if (k == 2) cycle               !  Exclude C-N-C
        if (nbonds(jj) == 3) then
          hybrid(icc) = 2
          guanidine = .true.
          if (ionized) then
            nH = 2                      !   ionized and an Arg
            angle = 120.d0
            internal_dihedral = 180.d0
            dihedral = 0.d0
          else
            nH = 1
            angle = 120.d0
            internal_dihedral = 180.d0
            dihedral = 0.d0
          end if
          return                         !  Unconditional
        else
          nH = 2
          angle = 120.d0
          internal_dihedral = 180.d0
          dihedral = 0.d0
          hybrid(icc) = 3
          return
        end if
      end if
    end do
  end do
  return
  end function guanidine

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      double precision function dot (x, y, n)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n
      double precision , intent(in) :: x(n)
      double precision , intent(in) :: y(n)
!For MOPAC BLAS
      double precision, external :: ddot
!

!-----------------------------------------------
!***********************************************************************
!
!   DOT FORMS THE SCALAR PRODUCT OF TWO VECTORS.
!
!   ON INPUT     X   =    FIRST VECTOR, OF LENGTH N.
!                Y   =    SECOND VECTOR, OF LENGTH N.
!
!   ON RETURN    DOT =    DOT PRODUCT OF X AND Y.
!
!***********************************************************************
!For MOPAC BLAS
!     dot = dot_product(x(:n),y(:n))
      dot = ddot(n,x(1:n),1,y(1:n),1)
!
      return
      end function dot

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

double precision function PM6_DH_H_bond_corrections(l_grad, prt)
!
!    Add a dispersion E_disp, a coulombic, EC, and a repulsive correction, ER,
!    to improve intermolecular interaction energies.
!
  use molkst_C, only : numat, E_hb, N_Hbonds, method_pm7, l123, l1u, l2u, l3u, &
    method_pm6_dh_plus, method_pm6_dh2, method_pm6_dh2x, &
    line, id, numcal
  use parameters_C, only : tore
  use common_arrays_C, only: coord, nat, q, p, hblist, dxyz, cell_ijk
  implicit none
  logical, intent (in) :: l_grad, prt
!
! Local variables
!
  integer :: i, j, k, l, D, H, A, nd_list, d_list(9), d_l(9), i_cell, ii, iii, kkkk, &
    nrpairs, max_h_bonds, icalcn = -1
  logical :: n_h_bonds, first = .true.
  integer, allocatable :: nrbondsa(:), nrbondsb(:)
  double precision, allocatable :: vector(:)
  double precision :: EC, ER, sum, sum1, delta = 1.d-5, covrad(94)
  double precision, external :: EC_plus_ER, EH_plus
  logical, external :: connected

  save
   data covrad /&
  &0.32d0,  0.46d0,  1.20d0,  0.94d0,  0.77d0,  0.75d0,  0.71d0,  0.63d0,  0.64d0,  0.67d0, &
  &1.40d0,  1.25d0,  1.13d0,  1.04d0,  1.10d0,  1.02d0,  0.99d0,  0.96d0,  1.76d0,  1.54d0, &
  &1.33d0,  1.22d0,  1.21d0,  1.10d0,  1.07d0,  1.04d0,  1.00d0,  0.99d0,  1.01d0,  1.09d0, &
  &1.12d0,  1.09d0,  1.15d0,  1.10d0,  1.14d0,  1.17d0,  1.89d0,  1.67d0,  1.47d0,  1.39d0, &
  &1.32d0,  1.24d0,  1.15d0,  1.13d0,  1.13d0,  1.08d0,  1.15d0,  1.23d0,  1.28d0,  1.26d0, &
  &1.26d0,  1.23d0,  1.32d0,  1.31d0,  2.09d0,  1.76d0,  1.62d0,  1.47d0,  1.58d0,  1.57d0, &
  &1.56d0,  1.55d0,  1.51d0,  1.52d0,  1.51d0,  1.50d0,  1.49d0,  1.49d0,  1.48d0,  1.53d0, &
  &1.46d0,  1.37d0,  1.31d0,  1.23d0,  1.18d0,  1.16d0,  1.11d0,  1.12d0,  1.13d0,  1.32d0, &
  &1.30d0,  1.30d0,  1.36d0,  1.31d0,  1.38d0,  1.42d0,  2.01d0,  1.81d0,  1.67d0,  1.58d0, &
  &1.52d0,  1.53d0,  1.54d0,  1.55d0 /
!
  if (first) then
    covrad = 4.d0/3.d0*covrad !  This must be done once per entire run
    first = .false.
  end if
  if (icalcn /= numcal) then
    max_h_bonds = 0
    do j = 1, numat
      if (nat(j) == 8 .or. nat(j) == 7) max_h_bonds = max_h_bonds + 1
    end do
    if (id == 0) then
      max_h_bonds = max_h_bonds*125
    else
      max_h_bonds = max_h_bonds*250
    end if
  end if
  if (max_h_bonds == 0) then
    PM6_DH_H_bond_corrections = 0.d0
    return
  end if
  if (allocated(nrbondsa))   deallocate(nrbondsa)
  if (allocated(nrbondsb))   deallocate(nrbondsb)
  if (allocated(hblist))     deallocate(hblist)
  if (allocated(vector))     deallocate(vector)
  allocate (hblist(max_h_bonds,10), nrbondsa(max_h_bonds), nrbondsb(max_h_bonds), vector(numat), stat=i)
    if (i /= 0) then
    line = " Cannot allocate arrays for PM6-DH+"
    call to_screen(trim(line))
    call mopend(trim(line))
    PM6_DH_H_bond_corrections = 0.d0
    return
  end if
  hblist(:,:) = 0
  nrpairs = 0
  if (method_pm6_dh_plus .or. method_PM7) then
    call all_h_bonds(hblist(1,1), hblist(1,9), hblist(1,5), max_h_bonds, nrpairs)
    call setup_DH_Plus(nrpairs, nrbondsa, nrbondsb, n_h_bonds, covrad)
  else
    call all_h_bonds(hblist(1,1), hblist(1,2), hblist(1,3), max_h_bonds, nrpairs)
  end if
  if (method_pm6_dh2 .or. method_pm6_dh2x) then
    call chrge (p, vector)  ! PM6-DH2 needs partial charges
    do i = 1, numat
      j = nat(i)
      q(i) = tore(j) - vector(i)
    end do
  end if
!
!  Calculate Hydrogen bond energy correction
!
!    The hydrogen-bond acceptor types are as follows:
!
!    (1) nitrogen with no hydrogens bonded to it (mostly in aromatic rings) interacting with any hydrogen,
!    (2) nitrogen with one hydrogen (secondary amines) interacting with any hydrogen,
!    (3) nitrogen with two or more hydrogens (primary amines, ammonia) interacting with any hydrogen,
!    (4) oxygen except carbonyl interacting with HN,
!    (5) carbonyl oxygen interacting with HN,
!    (6) oxygen interacting with HO hydrogen different from 7 and 8,
!    (7) oxygen interacting with H in a water molecule, and
!    (8) oxygen interacting with H in a carboxyl group.
!

  N_Hbonds = 0
  E_hb = 0.d0
  do ii = 1, nrpairs
    if (method_pm6_dh_plus .or. method_pm7) then
      H = hblist(ii,9)
      A = hblist(ii,1)
      D = hblist(ii,5)
      sum = EH_plus(ii, hblist, max_h_bonds, nrbondsa, nrbondsb)
      E_hb = E_hb + sum
      nd_list=0
      do i = 1, 9
        if (hblist(ii,i) > 0) then
          j = hblist(ii,i)
          do l = 1, nd_list
            if (d_list(l) == j) exit
          end do
          if (l > nd_list) then
            nd_list = nd_list + 1
            d_list(nd_list) = hblist(ii,i)
          end if
        end if
      end do
    else
      H = hblist(ii,2)
      A = hblist(ii,3)
      D = hblist(ii,1)
      sum = EC_plus_ER(hblist(ii,1), hblist(ii,2), hblist(ii,3), q(hblist(ii,2)), q(hblist(ii,3)), EC, ER, d_list, nd_list)
      E_hb = E_hb + EC + ER
    end if
    if (sum < -1.d0) N_Hbonds = N_Hbonds + 1
    if (prt) call prt_hbonds(D, H, A, sum)
!
! Add in gradient contribution, if requested
!
    if (l_grad .and. sum < -0.01d0) then
      do j = 1, nd_list
        k = d_list(j)
        iii = l123*(k - 1)
        if (connected(H, k, 8.d0**2)) then
!
!   kkkk is the cell that atom k is in, relative to atom H
!
          kkkk = (l3u - cell_ijk(3)) + (2*l3u + 1)*(l2u - cell_ijk(2) + (2*l2u + 1)*(l1u - cell_ijk(1)))
          i_cell = iii + kkkk
!
!  Delta is 10^(-5).  During the evaluation of simple functions such as sqrt and acos, half of the precision is lost
!  This means that, instead of 16 digits of precision, there are only 8.  Tests with delta = 10^(-8) showed severe errors
!  in the derivatives.  The "ideal" value of delta should be 10^(-4), but 10^(-5) was selected by JJPS as the best compromise,
!  based on finding the middle of the plateau of constant derivatives.
!
          do i = 1, 3
            coord(i,k) = coord(i,k) + delta
            if (method_pm6_dh_plus .or. method_pm7) then
              sum1 = EH_plus(ii, hblist, max_h_bonds, nrbondsa, nrbondsb)
            else
              sum1 = EC_plus_ER(D, H, A, q(H), q(A), EC, ER, d_l, l)
            end if
            sum1 = (sum1 - sum)/delta
            if (Abs(sum1) < 50.d0) then
              dxyz(i_cell*3 + i) = dxyz(i_cell*3 + i) + sum1
            end if
            coord(i,k) = coord(i,k) - delta
          end do
        end if
      end do
    end if
  end do
  PM6_DH_H_bond_corrections = E_hb
  return
  end function PM6_DH_H_bond_corrections

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  subroutine alpb_and_xfac_mndo
    use parameters_C, only : xfac, alpb
    xfac = 0.d0
    alpb = 0.d0
    alpb( 3, 1) =   1.574938d0 !     Lithium -     Hydrogen
    xfac( 3, 1) =   1.267656d0 !     Lithium -     Hydrogen
    alpb( 3, 3) =   1.116981d0 !     Lithium -      Lithium
    xfac( 3, 3) =   1.867382d0 !     Lithium -      Lithium
    !
    alpb( 6, 3) =   1.331736d0 !      Carbon -      Lithium
    xfac( 6, 3) =   0.924766d0 !      Carbon -      Lithium
    !
    alpb( 7, 3) =   1.539010d0 !    Nitrogen -      Lithium
    xfac( 7, 3) =   0.917994d0 !    Nitrogen -      Lithium
    !
    alpb( 8, 3) =   1.246611d0 !      Oxygen -      Lithium
    xfac( 8, 3) =   0.532906d0 !      Oxygen -      Lithium
    !
    alpb( 9, 3) =   1.100244d0 !    Fluorine -      Lithium
    xfac( 9, 3) =   0.439938d0 !    Fluorine -      Lithium
    !
    alpb(11, 1) =   2.509533d0 !      Sodium -     Hydrogen
    xfac(11, 1) =  10.000001d0 !      Sodium -     Hydrogen
    alpb(11, 6) =   1.600907d0 !      Sodium -       Carbon
    xfac(11, 6) =   1.968197d0 !      Sodium -       Carbon
    alpb(11, 7) =   2.137374d0 !      Sodium -     Nitrogen
    xfac(11, 7) =   7.127566d0 !      Sodium -     Nitrogen
    alpb(11, 8) =   1.645246d0 !      Sodium -       Oxygen
    xfac(11, 8) =   1.815137d0 !      Sodium -       Oxygen
    alpb(11, 9) =   1.454308d0 !      Sodium -     Fluorine
    xfac(11, 9) =   1.176276d0 !      Sodium -     Fluorine
    alpb(11,11) =   1.237658d0 !      Sodium -       Sodium
    xfac(11,11) =   4.403848d0 !      Sodium -       Sodium
    !
    alpb(12, 1) =   2.225309d0 !   Magnesium -     Hydrogen
    xfac(12, 1) =   3.720059d0 !   Magnesium -     Hydrogen
    alpb(12, 6) =   2.261280d0 !   Magnesium -       Carbon
    xfac(12, 6) =   4.077811d0 !   Magnesium -       Carbon
    alpb(12, 7) =   2.235036d0 !   Magnesium -     Nitrogen
    xfac(12, 7) =   2.449707d0 !   Magnesium -     Nitrogen
    alpb(12, 8) =   1.861494d0 !   Magnesium -       Oxygen
    xfac(12, 8) =   1.028465d0 !   Magnesium -       Oxygen
    alpb(12, 9) =   2.020390d0 !   Magnesium -     Fluorine
    xfac(12, 9) =   1.351638d0 !   Magnesium -     Fluorine
    alpb(12,12) =   1.836049d0 !   Magnesium -    Magnesium
    xfac(12,12) =  10.000011d0 !   Magnesium -    Magnesium
    !
    alpb(16, 3) =   3.607514d0 !      Sulfur -      Lithium
    xfac(16, 3) =   1.246952d0 !      Sulfur -      Lithium
    alpb(16,11) =   3.292794d0 !      Sulfur -       Sodium
    xfac(16,11) =   2.813852d0 !      Sulfur -       Sodium
    alpb(16,12) =   2.042320d0 !      Sulfur -    Magnesium
    xfac(16,12) =   2.144097d0 !      Sulfur -    Magnesium
    !
    alpb(17, 3) =   1.697747d0 !    Chlorine -      Lithium
    xfac(17, 3) =   1.268099d0 !    Chlorine -      Lithium
    alpb(17,11) =   1.808032d0 !    Chlorine -       Sodium
    xfac(17,11) =   2.574233d0 !    Chlorine -       Sodium
    alpb(17,12) =   1.827473d0 !    Chlorine -    Magnesium
    xfac(17,12) =   1.305523d0 !    Chlorine -    Magnesium
    !
    alpb(19, 1) =   1.320313d0 !   Potassium -     Hydrogen
    xfac(19, 1) =   4.298548d0 !   Potassium -     Hydrogen
    alpb(19, 6) =   0.999445d0 !   Potassium -       Carbon
    xfac(19, 6) =   0.849075d0 !   Potassium -       Carbon
    alpb(19, 7) =   2.161504d0 !   Potassium -     Nitrogen
    xfac(19, 7) =   6.502600d0 !   Potassium -     Nitrogen
    alpb(19, 8) =   2.008450d0 !   Potassium -       Oxygen
    xfac(19, 8) =   2.658504d0 !   Potassium -       Oxygen
    alpb(19, 9) =   0.999684d0 !   Potassium -     Fluorine
    xfac(19, 9) =   0.489361d0 !   Potassium -     Fluorine
    alpb(19,16) =   3.669853d0 !   Potassium -       Sulfur
    xfac(19,16) =   8.085841d0 !   Potassium -       Sulfur
    alpb(19,17) =   1.873677d0 !   Potassium -     Chlorine
    xfac(19,17) =   5.877136d0 !   Potassium -     Chlorine
    alpb(19,19) =   1.428561d0 !   Potassium -    Potassium
    xfac(19,19) =   8.818535d0 !   Potassium -    Potassium
    !
    alpb(20, 1) =   1.232916d0 !     Calcium -     Hydrogen
    xfac(20, 1) =   2.523722d0 !     Calcium -     Hydrogen
    alpb(20, 6) =   0.999988d0 !     Calcium -       Carbon
    xfac(20, 6) =   0.719460d0 !     Calcium -       Carbon
    alpb(20, 7) =   0.999988d0 !     Calcium -     Nitrogen
    xfac(20, 7) =   0.478031d0 !     Calcium -     Nitrogen
    alpb(20, 8) =   1.971239d0 !     Calcium -       Oxygen
    xfac(20, 8) =   1.362643d0 !     Calcium -       Oxygen
    alpb(20, 9) =   1.519589d0 !     Calcium -     Fluorine
    xfac(20, 9) =   0.714119d0 !     Calcium -     Fluorine
    alpb(20,16) =   0.999943d0 !     Calcium -       Sulfur
    xfac(20,16) =   0.473306d0 !     Calcium -       Sulfur
    alpb(20,17) =   1.106581d0 !     Calcium -     Chlorine
    xfac(20,17) =   0.445562d0 !     Calcium -     Chlorine
    alpb(20,20) =   0.999160d0 !     Calcium -      Calcium
    xfac(20,20) =   9.359604d0 !     Calcium -      Calcium
    !
    alpb(21, 1) =   1.676255d0 !    Scandium -     Hydrogen
    xfac(21, 1) =   0.100038d0 !    Scandium -     Hydrogen
    alpb(21, 6) =   1.432818d0 !    Scandium -       Carbon
    xfac(21, 6) =   0.520317d0 !    Scandium -       Carbon
    alpb(21, 7) =   1.000663d0 !    Scandium -     Nitrogen
    xfac(21, 7) =   0.235793d0 !    Scandium -     Nitrogen
    alpb(21, 8) =   2.142980d0 !    Scandium -       Oxygen
    xfac(21, 8) =   0.958225d0 !    Scandium -       Oxygen
    alpb(21, 9) =   1.060263d0 !    Scandium -     Fluorine
    xfac(21, 9) =   0.209576d0 !    Scandium -     Fluorine
    alpb(21,13) =   1.000109d0 !    Scandium -    Aluminium
    xfac(21,13) =   0.100109d0 !    Scandium -    Aluminium
    alpb(21,15) =   1.000121d0 !    Scandium -   Phosphorus
    xfac(21,15) =   0.253782d0 !    Scandium -   Phosphorus
    alpb(21,16) =   1.000706d0 !    Scandium -       Sulfur
    xfac(21,16) =   0.234873d0 !    Scandium -       Sulfur
    alpb(21,17) =   1.849424d0 !    Scandium -     Chlorine
    xfac(21,17) =   0.778710d0 !    Scandium -     Chlorine
    alpb(21,21) =   1.000275d0 !    Scandium -     Scandium
    xfac(21,21) =   0.100274d0 !    Scandium -     Scandium
    !
    alpb(22, 1) =   1.021853d0 !    Titanium -     Hydrogen
    xfac(22, 1) =   0.246319d0 !    Titanium -     Hydrogen
    alpb(22, 6) =   1.346533d0 !    Titanium -       Carbon
    xfac(22, 6) =   0.552633d0 !    Titanium -       Carbon
    alpb(22, 7) =   1.637988d0 !    Titanium -     Nitrogen
    xfac(22, 7) =   0.663632d0 !    Titanium -     Nitrogen
    alpb(22, 8) =   2.121591d0 !    Titanium -       Oxygen
    xfac(22, 8) =   1.244152d0 !    Titanium -       Oxygen
    alpb(22, 9) =   1.691383d0 !    Titanium -     Fluorine
    xfac(22, 9) =   0.557018d0 !    Titanium -     Fluorine
    alpb(22,13) =   1.010468d0 !    Titanium -    Aluminium
    xfac(22,13) =   0.099946d0 !    Titanium -    Aluminium
    alpb(22,15) =   1.000705d0 !    Titanium -   Phosphorus
    xfac(22,15) =   0.332715d0 !    Titanium -   Phosphorus
    alpb(22,16) =   1.101330d0 !    Titanium -       Sulfur
    xfac(22,16) =   0.263489d0 !    Titanium -       Sulfur
    alpb(22,17) =   1.442739d0 !    Titanium -     Chlorine
    xfac(22,17) =   0.394445d0 !    Titanium -     Chlorine
    alpb(22,22) =   0.999929d0 !    Titanium -     Titanium
    xfac(22,22) =   0.465550d0 !    Titanium -     Titanium
    !
    alpb(23, 1) =   2.099912d0 !    Vanadium -     Hydrogen
    xfac(23, 1) =   0.539076d0 !    Vanadium -     Hydrogen
    alpb(23, 6) =   2.111663d0 !    Vanadium -       Carbon
    xfac(23, 6) =   0.928294d0 !    Vanadium -       Carbon
    alpb(23, 7) =   2.985690d0 !    Vanadium -     Nitrogen
    xfac(23, 7) =   2.492636d0 !    Vanadium -     Nitrogen
    alpb(23, 8) =   2.706614d0 !    Vanadium -       Oxygen
    xfac(23, 8) =   1.949912d0 !    Vanadium -       Oxygen
    alpb(23, 9) =   1.953405d0 !    Vanadium -     Fluorine
    xfac(23, 9) =   0.624110d0 !    Vanadium -     Fluorine
    alpb(23,15) =   2.220280d0 !    Vanadium -   Phosphorus
    xfac(23,15) =   1.568020d0 !    Vanadium -   Phosphorus
    alpb(23,16) =   2.349793d0 !    Vanadium -       Sulfur
    xfac(23,16) =   1.712026d0 !    Vanadium -       Sulfur
    alpb(23,17) =   3.099188d0 !    Vanadium -     Chlorine
    xfac(23,17) =   3.851130d0 !    Vanadium -     Chlorine
    alpb(23,23) =   3.339987d0 !    Vanadium -     Vanadium
    xfac(23,23) =   1.934781d0 !    Vanadium -     Vanadium
    !
    alpb(24, 1) =   3.693279d0 !    Chromium -     Hydrogen
    xfac(24, 1) =   9.412996d0 !    Chromium -     Hydrogen
    alpb(24, 6) =   2.545791d0 !    Chromium -       Carbon
    xfac(24, 6) =   2.590834d0 !    Chromium -       Carbon
    alpb(24, 7) =   1.856777d0 !    Chromium -     Nitrogen
    xfac(24, 7) =   0.445433d0 !    Chromium -     Nitrogen
    alpb(24, 8) =   2.761764d0 !    Chromium -       Oxygen
    xfac(24, 8) =   2.181701d0 !    Chromium -       Oxygen
    alpb(24, 9) =   2.018260d0 !    Chromium -     Fluorine
    xfac(24, 9) =   0.588431d0 !    Chromium -     Fluorine
    alpb(24,11) =   1.259973d0 !    Chromium -       Sodium
    xfac(24,11) =   0.489256d0 !    Chromium -       Sodium
    alpb(24,15) =   3.705498d0 !    Chromium -   Phosphorus
    xfac(24,15) =   5.795478d0 !    Chromium -   Phosphorus
    alpb(24,16) =   1.294459d0 !    Chromium -       Sulfur
    xfac(24,16) =   0.291800d0 !    Chromium -       Sulfur
    alpb(24,17) =   2.376352d0 !    Chromium -     Chlorine
    xfac(24,17) =   1.398679d0 !    Chromium -     Chlorine
    alpb(24,19) =   1.000000d0 !    Chromium -    Potassium
    xfac(24,19) =   1.033088d0 !    Chromium -    Potassium
    alpb(24,24) =   1.411352d0 !    Chromium -     Chromium
    xfac(24,24) =   0.555820d0 !    Chromium -     Chromium
    !
    alpb(26, 1) =   4.086290d0 !        Iron -     Hydrogen
    xfac(26, 1) =   9.514035d0 !        Iron -     Hydrogen
    alpb(26, 6) =   2.065348d0 !        Iron -       Carbon
    xfac(26, 6) =   0.462249d0 !        Iron -       Carbon
    alpb(26, 7) =   2.153388d0 !        Iron -     Nitrogen
    xfac(26, 7) =   0.512937d0 !        Iron -     Nitrogen
    alpb(26, 8) =   2.196403d0 !        Iron -       Oxygen
    xfac(26, 8) =   0.482389d0 !        Iron -       Oxygen
    alpb(26, 9) =   2.806610d0 !        Iron -     Fluorine
    xfac(26, 9) =   1.252944d0 !        Iron -     Fluorine
    alpb(26,16) =   2.644622d0 !        Iron -       Sulfur
    xfac(26,16) =   1.376080d0 !        Iron -       Sulfur
    alpb(26,17) =   2.950885d0 !        Iron -     Chlorine
    xfac(26,17) =   1.689985d0 !        Iron -     Chlorine
    alpb(26,26) =   2.941730d0 !        Iron -         Iron
    xfac(26,26) =   1.107774d0 !        Iron -         Iron
    !
    alpb(27, 1) =   4.091550d0 !      Cobalt -     Hydrogen
    xfac(27, 1) =   2.317736d0 !      Cobalt -     Hydrogen
    alpb(27, 6) =   2.028624d0 !      Cobalt -       Carbon
    xfac(27, 6) =   0.296687d0 !      Cobalt -       Carbon
    alpb(27, 7) =   2.864252d0 !      Cobalt -     Nitrogen
    xfac(27, 7) =   1.105497d0 !      Cobalt -     Nitrogen
    alpb(27, 8) =   3.401118d0 !      Cobalt -       Oxygen
    xfac(27, 8) =   1.954967d0 !      Cobalt -       Oxygen
    alpb(27, 9) =   1.806946d0 !      Cobalt -     Fluorine
    xfac(27, 9) =   0.149166d0 !      Cobalt -     Fluorine
    alpb(27,15) =   4.244101d0 !      Cobalt -   Phosphorus
    xfac(27,15) =   1.244784d0 !      Cobalt -   Phosphorus
    alpb(27,16) =   2.293154d0 !      Cobalt -       Sulfur
    xfac(27,16) =   0.224918d0 !      Cobalt -       Sulfur
    alpb(27,17) =   1.696901d0 !      Cobalt -     Chlorine
    xfac(27,17) =   0.098378d0 !      Cobalt -     Chlorine
    alpb(27,27) =   1.390891d0 !      Cobalt -       Cobalt
    xfac(27,27) =   0.611200d0 !      Cobalt -       Cobalt
    !
    alpb(28, 6) =   2.047692d0 !      Nickel -       Carbon
    xfac(28, 6) =   0.594612d0 !      Nickel -       Carbon
    alpb(28, 7) =   3.197290d0 !      Nickel -     Nitrogen
    xfac(28, 7) =   2.825048d0 !      Nickel -     Nitrogen
    alpb(28, 8) =   3.650551d0 !      Nickel -       Oxygen
    xfac(28, 8) =   2.220774d0 !      Nickel -       Oxygen
    alpb(28, 9) =   4.138390d0 !      Nickel -     Fluorine
    xfac(28, 9) =   3.183738d0 !      Nickel -     Fluorine
    alpb(28,15) =   5.804675d0 !      Nickel -   Phosphorus
    xfac(28,15) =   2.450729d0 !      Nickel -   Phosphorus
    alpb(28,16) =   3.109609d0 !      Nickel -       Sulfur
    xfac(28,16) =   2.512540d0 !      Nickel -       Sulfur
    alpb(28,17) =   3.420216d0 !      Nickel -     Chlorine
    xfac(28,17) =   2.431295d0 !      Nickel -     Chlorine
    !
    alpb(29, 1) =   2.679471d0 !      Copper -     Hydrogen
    xfac(29, 1) =   0.812933d0 !      Copper -     Hydrogen
    alpb(29, 6) =   2.428147d0 !      Copper -       Carbon
    xfac(29, 6) =   0.629043d0 !      Copper -       Carbon
    alpb(29, 7) =   1.513341d0 !      Copper -     Nitrogen
    xfac(29, 7) =   0.126664d0 !      Copper -     Nitrogen
    alpb(29, 8) =   2.615641d0 !      Copper -       Oxygen
    xfac(29, 8) =   0.574106d0 !      Copper -       Oxygen
    alpb(29, 9) =   2.439234d0 !      Copper -     Fluorine
    xfac(29, 9) =   0.431529d0 !      Copper -     Fluorine
    alpb(29,15) =   2.006445d0 !      Copper -   Phosphorus
    xfac(29,15) =   0.318485d0 !      Copper -   Phosphorus
    alpb(29,16) =   1.484117d0 !      Copper -       Sulfur
    xfac(29,16) =   0.122708d0 !      Copper -       Sulfur
    alpb(29,17) =   1.621943d0 !      Copper -     Chlorine
    xfac(29,17) =   0.147900d0 !      Copper -     Chlorine
    alpb(29,29) =   2.056349d0 !      Copper -       Copper
    xfac(29,29) =   0.129793d0 !      Copper -       Copper
    !
    alpb(33,27) =   3.368144d0 !     Arsenic -       Cobalt
    xfac(33,27) =   1.675239d0 !     Arsenic -       Cobalt
    !
    alpb(35, 3) =   2.267688d0 !     Bromine -      Lithium
    xfac(35, 3) =   4.129581d0 !     Bromine -      Lithium
    alpb(35,11) =   2.403632d0 !     Bromine -       Sodium
    xfac(35,11) =  10.000006d0 !     Bromine -       Sodium
    alpb(35,12) =   2.275335d0 !     Bromine -    Magnesium
    xfac(35,12) =   3.649579d0 !     Bromine -    Magnesium
    alpb(35,19) =   2.029580d0 !     Bromine -    Potassium
    xfac(35,19) =   8.686070d0 !     Bromine -    Potassium
    alpb(35,20) =   1.217321d0 !     Bromine -      Calcium
    xfac(35,20) =   0.622015d0 !     Bromine -      Calcium
    alpb(35,21) =   1.752557d0 !     Bromine -     Scandium
    xfac(35,21) =   0.692157d0 !     Bromine -     Scandium
    alpb(35,22) =   1.220144d0 !     Bromine -     Titanium
    xfac(35,22) =   0.256820d0 !     Bromine -     Titanium
    alpb(35,23) =   3.776685d0 !     Bromine -     Vanadium
    xfac(35,23) =   8.941343d0 !     Bromine -     Vanadium
    alpb(35,24) =   1.450054d0 !     Bromine -     Chromium
    xfac(35,24) =   0.336528d0 !     Bromine -     Chromium
    alpb(35,26) =   3.501908d0 !     Bromine -         Iron
    xfac(35,26) =   6.338691d0 !     Bromine -         Iron
    alpb(35,27) =   4.000589d0 !     Bromine -       Cobalt
    xfac(35,27) =   3.634965d0 !     Bromine -       Cobalt
    alpb(35,28) =   3.117064d0 !     Bromine -       Nickel
    xfac(35,28) =   1.904637d0 !     Bromine -       Nickel
    alpb(35,29) =   1.825733d0 !     Bromine -       Copper
    xfac(35,29) =   0.203501d0 !     Bromine -       Copper
    !
    alpb(37, 1) =   2.163911d0 !    Rubidium -     Hydrogen
    xfac(37, 1) =   7.659030d0 !    Rubidium -     Hydrogen
    alpb(37, 8) =   3.605597d0 !    Rubidium -       Oxygen
    xfac(37, 8) =   6.635511d0 !    Rubidium -       Oxygen
    alpb(37, 9) =   2.940757d0 !    Rubidium -     Fluorine
    xfac(37, 9) =   6.559839d0 !    Rubidium -     Fluorine
    alpb(37,17) =   2.006252d0 !    Rubidium -     Chlorine
    xfac(37,17) =   3.308870d0 !    Rubidium -     Chlorine
    alpb(37,35) =   2.135073d0 !    Rubidium -      Bromine
    xfac(37,35) =   5.523206d0 !    Rubidium -      Bromine
    alpb(37,37) =   2.329519d0 !    Rubidium -     Rubidium
    xfac(37,37) =   7.321125d0 !    Rubidium -     Rubidium
    !
    alpb(38, 1) =   0.999390d0 !   Strontium -     Hydrogen
    xfac(38, 1) =   3.279894d0 !   Strontium -     Hydrogen
    alpb(38, 6) =   1.006168d0 !   Strontium -       Carbon
    xfac(38, 6) =   0.104550d0 !   Strontium -       Carbon
    alpb(38, 7) =   1.003353d0 !   Strontium -     Nitrogen
    xfac(38, 7) =   0.104635d0 !   Strontium -     Nitrogen
    alpb(38, 8) =   2.523434d0 !   Strontium -       Oxygen
    xfac(38, 8) =   1.384826d0 !   Strontium -       Oxygen
    alpb(38, 9) =   1.779157d0 !   Strontium -     Fluorine
    xfac(38, 9) =   1.149661d0 !   Strontium -     Fluorine
    alpb(38,16) =   1.014322d0 !   Strontium -       Sulfur
    xfac(38,16) =   0.562327d0 !   Strontium -       Sulfur
    alpb(38,17) =   1.101161d0 !   Strontium -     Chlorine
    xfac(38,17) =   0.419825d0 !   Strontium -     Chlorine
    alpb(38,35) =   0.999859d0 !   Strontium -      Bromine
    xfac(38,35) =   0.394830d0 !   Strontium -      Bromine
    alpb(38,38) =   1.004898d0 !   Strontium -    Strontium
    xfac(38,38) =   0.103370d0 !   Strontium -    Strontium
    !
    alpb(40, 1) =   1.191679d0 !   Zirconium -     Hydrogen
    xfac(40, 1) =   0.611472d0 !   Zirconium -     Hydrogen
    alpb(40, 6) =   1.448378d0 !   Zirconium -       Carbon
    xfac(40, 6) =   0.908774d0 !   Zirconium -       Carbon
    alpb(40, 7) =   1.794086d0 !   Zirconium -     Nitrogen
    xfac(40, 7) =   1.218702d0 !   Zirconium -     Nitrogen
    alpb(40, 8) =   2.520699d0 !   Zirconium -       Oxygen
    xfac(40, 8) =   3.776252d0 !   Zirconium -       Oxygen
    alpb(40, 9) =   2.023366d0 !   Zirconium -     Fluorine
    xfac(40, 9) =   1.545337d0 !   Zirconium -     Fluorine
    alpb(40,13) =   1.270618d0 !   Zirconium -    Aluminium
    xfac(40,13) =   0.874059d0 !   Zirconium -    Aluminium
    alpb(40,15) =   1.168915d0 !   Zirconium -   Phosphorus
    xfac(40,15) =   0.841496d0 !   Zirconium -   Phosphorus
    alpb(40,16) =   1.187588d0 !   Zirconium -       Sulfur
    xfac(40,16) =   0.890952d0 !   Zirconium -       Sulfur
    alpb(40,17) =   1.477001d0 !   Zirconium -     Chlorine
    xfac(40,17) =   0.727384d0 !   Zirconium -     Chlorine
    alpb(40,35) =   1.431258d0 !   Zirconium -      Bromine
    xfac(40,35) =   0.725137d0 !   Zirconium -      Bromine
    alpb(40,40) =   1.237025d0 !   Zirconium -    Zirconium
    xfac(40,40) =   0.864360d0 !   Zirconium -    Zirconium
    !
    alpb(42, 1) =   2.378986d0 !  Molybdenum -     Hydrogen
    xfac(42, 1) =   1.706974d0 !  Molybdenum -     Hydrogen
    alpb(42, 6) =   2.455593d0 !  Molybdenum -       Carbon
    xfac(42, 6) =   2.899166d0 !  Molybdenum -       Carbon
    alpb(42, 7) =   2.150309d0 !  Molybdenum -     Nitrogen
    xfac(42, 7) =   1.420214d0 !  Molybdenum -     Nitrogen
    alpb(42, 8) =   2.318219d0 !  Molybdenum -       Oxygen
    xfac(42, 8) =   1.424165d0 !  Molybdenum -       Oxygen
    alpb(42, 9) =   2.069297d0 !  Molybdenum -     Fluorine
    xfac(42, 9) =   0.884100d0 !  Molybdenum -     Fluorine
    alpb(42,15) =   1.927339d0 !  Molybdenum -   Phosphorus
    xfac(42,15) =   1.466154d0 !  Molybdenum -   Phosphorus
    alpb(42,16) =   2.629697d0 !  Molybdenum -       Sulfur
    xfac(42,16) =   4.103434d0 !  Molybdenum -       Sulfur
    alpb(42,17) =   2.088120d0 !  Molybdenum -     Chlorine
    xfac(42,17) =   1.135150d0 !  Molybdenum -     Chlorine
    alpb(42,24) =   1.678626d0 !  Molybdenum -     Chromium
    xfac(42,24) =   1.595571d0 !  Molybdenum -     Chromium
    alpb(42,35) =   2.097119d0 !  Molybdenum -      Bromine
    xfac(42,35) =   1.186756d0 !  Molybdenum -      Bromine
    alpb(42,42) =   2.281182d0 !  Molybdenum -   Molybdenum
    xfac(42,42) =   4.583438d0 !  Molybdenum -   Molybdenum
    !
    alpb(46, 1) =   2.041243d0 !   Palladium -     Hydrogen
    xfac(46, 1) =   0.430625d0 !   Palladium -     Hydrogen
    alpb(46, 6) =   3.442816d0 !   Palladium -       Carbon
    xfac(46, 6) =   3.400458d0 !   Palladium -       Carbon
    alpb(46, 7) =   3.867100d0 !   Palladium -     Nitrogen
    xfac(46, 7) =   5.510125d0 !   Palladium -     Nitrogen
    alpb(46, 8) =   2.826616d0 !   Palladium -       Oxygen
    xfac(46, 8) =   0.932468d0 !   Palladium -       Oxygen
    alpb(46, 9) =   3.785998d0 !   Palladium -     Fluorine
    xfac(46, 9) =   5.469458d0 !   Palladium -     Fluorine
    alpb(46,14) =   3.248566d0 !   Palladium -      Silicon
    xfac(46,14) =   5.267683d0 !   Palladium -      Silicon
    alpb(46,15) =   3.995342d0 !   Palladium -   Phosphorus
    xfac(46,15) =   4.829767d0 !   Palladium -   Phosphorus
    alpb(46,16) =   5.657215d0 !   Palladium -       Sulfur
    xfac(46,16) =   5.280869d0 !   Palladium -       Sulfur
    alpb(46,17) =   3.340418d0 !   Palladium -     Chlorine
    xfac(46,17) =   3.257806d0 !   Palladium -     Chlorine
    alpb(46,35) =   3.824737d0 !   Palladium -      Bromine
    xfac(46,35) =   5.152525d0 !   Palladium -      Bromine
    alpb(46,46) =   3.749207d0 !   Palladium -    Palladium
    xfac(46,46) =   5.524179d0 !   Palladium -    Palladium
    !
    alpb(47, 1) =   1.906028d0 !      Silver -     Hydrogen
    xfac(47, 1) =   0.598879d0 !      Silver -     Hydrogen
    alpb(47, 6) =   2.383592d0 !      Silver -       Carbon
    xfac(47, 6) =   1.351594d0 !      Silver -       Carbon
    alpb(47, 7) =   2.523534d0 !      Silver -     Nitrogen
    xfac(47, 7) =   1.217347d0 !      Silver -     Nitrogen
    alpb(47, 8) =   2.461500d0 !      Silver -       Oxygen
    xfac(47, 8) =   0.941833d0 !      Silver -       Oxygen
    alpb(47, 9) =   2.390898d0 !      Silver -     Fluorine
    xfac(47, 9) =   0.701901d0 !      Silver -     Fluorine
    alpb(47,15) =   1.083516d0 !      Silver -   Phosphorus
    xfac(47,15) =   0.120610d0 !      Silver -   Phosphorus
    alpb(47,16) =   2.508196d0 !      Silver -       Sulfur
    xfac(47,16) =   2.395844d0 !      Silver -       Sulfur
    alpb(47,17) =   1.916406d0 !      Silver -     Chlorine
    xfac(47,17) =   0.396164d0 !      Silver -     Chlorine
    alpb(47,35) =   2.436224d0 !      Silver -      Bromine
    xfac(47,35) =   1.260972d0 !      Silver -      Bromine
    alpb(47,47) =   3.137432d0 !      Silver -       Silver
    xfac(47,47) =   1.873430d0 !      Silver -       Silver
    !
    alpb(53, 3) =   2.430052d0 !      Iodine -      Lithium
    xfac(53, 3) =   9.738383d0 !      Iodine -      Lithium
    alpb(53,11) =   2.138290d0 !      Iodine -       Sodium
    xfac(53,11) =  10.000025d0 !      Iodine -       Sodium
    alpb(53,12) =   2.563705d0 !      Iodine -    Magnesium
    xfac(53,12) =  10.000011d0 !      Iodine -    Magnesium
    alpb(53,19) =   1.848045d0 !      Iodine -    Potassium
    xfac(53,19) =   8.419048d0 !      Iodine -    Potassium
    alpb(53,20) =   1.233027d0 !      Iodine -      Calcium
    xfac(53,20) =   1.073378d0 !      Iodine -      Calcium
    alpb(53,21) =   1.107792d0 !      Iodine -     Scandium
    xfac(53,21) =   0.145416d0 !      Iodine -     Scandium
    alpb(53,22) =   1.085513d0 !      Iodine -     Titanium
    xfac(53,22) =   0.335123d0 !      Iodine -     Titanium
    alpb(53,23) =   3.779472d0 !      Iodine -     Vanadium
    xfac(53,23) =   9.205430d0 !      Iodine -     Vanadium
    alpb(53,24) =   1.309520d0 !      Iodine -     Chromium
    xfac(53,24) =   0.309901d0 !      Iodine -     Chromium
    alpb(53,26) =   3.254087d0 !      Iodine -         Iron
    xfac(53,26) =   2.239898d0 !      Iodine -         Iron
    alpb(53,27) =   4.356713d0 !      Iodine -       Cobalt
    xfac(53,27) =   1.104424d0 !      Iodine -       Cobalt
    alpb(53,28) =   4.686287d0 !      Iodine -       Nickel
    xfac(53,28) =   1.274164d0 !      Iodine -       Nickel
    alpb(53,29) =   1.647705d0 !      Iodine -       Copper
    xfac(53,29) =   0.157448d0 !      Iodine -       Copper
    alpb(53,38) =   0.999837d0 !      Iodine -    Strontium
    xfac(53,38) =   0.819781d0 !      Iodine -    Strontium
    alpb(53,40) =   1.027422d0 !      Iodine -    Zirconium
    xfac(53,40) =   0.428563d0 !      Iodine -    Zirconium
    alpb(53,42) =   2.248014d0 !      Iodine -   Molybdenum
    xfac(53,42) =   2.117515d0 !      Iodine -   Molybdenum
    alpb(53,46) =   5.705495d0 !      Iodine -    Palladium
    xfac(53,46) =   5.229526d0 !      Iodine -    Palladium
    alpb(53,47) =   2.078961d0 !      Iodine -       Silver
    xfac(53,47) =   0.900167d0 !      Iodine -       Silver
    !
    alpb(55, 1) =   1.332561d0 !      Cesium -     Hydrogen
    xfac(55, 1) =   8.705312d0 !      Cesium -     Hydrogen
    alpb(55, 6) =   1.090683d0 !      Cesium -       Carbon
    xfac(55, 6) =   4.897821d0 !      Cesium -       Carbon
    alpb(55, 7) =   0.999646d0 !      Cesium -     Nitrogen
    xfac(55, 7) =   0.099792d0 !      Cesium -     Nitrogen
    alpb(55, 8) =   3.528675d0 !      Cesium -       Oxygen
    xfac(55, 8) =   4.390620d0 !      Cesium -       Oxygen
    alpb(55, 9) =   2.999365d0 !      Cesium -     Fluorine
    xfac(55, 9) =   4.453994d0 !      Cesium -     Fluorine
    alpb(55,15) =   2.593617d0 !      Cesium -   Phosphorus
    xfac(55,15) =   0.190509d0 !      Cesium -   Phosphorus
    alpb(55,16) =   4.000021d0 !      Cesium -       Sulfur
    xfac(55,16) =   4.423858d0 !      Cesium -       Sulfur
    alpb(55,17) =   1.969222d0 !      Cesium -     Chlorine
    xfac(55,17) =   3.000681d0 !      Cesium -     Chlorine
    alpb(55,35) =   2.046451d0 !      Cesium -      Bromine
    xfac(55,35) =   4.694115d0 !      Cesium -      Bromine
    alpb(55,53) =   1.847641d0 !      Cesium -       Iodine
    xfac(55,53) =   3.998888d0 !      Cesium -       Iodine
    alpb(55,55) =   0.996356d0 !      Cesium -       Cesium
    xfac(55,55) =   4.999747d0 !      Cesium -       Cesium
    !
    alpb(56, 1) =   1.171257d0 !      Barium -     Hydrogen
    xfac(56, 1) =   0.099982d0 !      Barium -     Hydrogen
    alpb(56, 6) =   1.047588d0 !      Barium -       Carbon
    xfac(56, 6) =   0.099981d0 !      Barium -       Carbon
    alpb(56, 7) =   1.000237d0 !      Barium -     Nitrogen
    xfac(56, 7) =   0.099981d0 !      Barium -     Nitrogen
    alpb(56, 8) =   1.422688d0 !      Barium -       Oxygen
    xfac(56, 8) =   0.383114d0 !      Barium -       Oxygen
    alpb(56, 9) =   1.730509d0 !      Barium -     Fluorine
    xfac(56, 9) =   1.127771d0 !      Barium -     Fluorine
    alpb(56,16) =   1.505311d0 !      Barium -       Sulfur
    xfac(56,16) =   1.957151d0 !      Barium -       Sulfur
    alpb(56,17) =   1.129944d0 !      Barium -     Chlorine
    xfac(56,17) =   0.557748d0 !      Barium -     Chlorine
    alpb(56,35) =   1.585564d0 !      Barium -      Bromine
    xfac(56,35) =   2.326451d0 !      Barium -      Bromine
    alpb(56,53) =   1.271836d0 !      Barium -       Iodine
    xfac(56,53) =   1.714690d0 !      Barium -       Iodine
    alpb(56,56) =   1.000402d0 !      Barium -       Barium
    xfac(56,56) =   0.136939d0 !      Barium -       Barium
    !
    alpb(78, 1) =   2.287480d0 !    Platinum -     Hydrogen
    xfac(78, 1) =   0.419211d0 !    Platinum -     Hydrogen
    alpb(78, 6) =   2.401063d0 !    Platinum -       Carbon
    xfac(78, 6) =   0.773872d0 !    Platinum -       Carbon
    alpb(78, 7) =   2.277268d0 !    Platinum -     Nitrogen
    xfac(78, 7) =   0.476560d0 !    Platinum -     Nitrogen
    alpb(78, 8) =   2.298204d0 !    Platinum -       Oxygen
    xfac(78, 8) =   0.587388d0 !    Platinum -       Oxygen
    alpb(78, 9) =   1.114424d0 !    Platinum -     Fluorine
    xfac(78, 9) =   0.119676d0 !    Platinum -     Fluorine
    alpb(78,14) =   0.999989d0 !    Platinum -      Silicon
    xfac(78,14) =   0.099989d0 !    Platinum -      Silicon
    alpb(78,15) =   2.131889d0 !    Platinum -   Phosphorus
    xfac(78,15) =   0.099936d0 !    Platinum -   Phosphorus
    alpb(78,16) =   1.671855d0 !    Platinum -       Sulfur
    xfac(78,16) =   0.125941d0 !    Platinum -       Sulfur
    alpb(78,17) =   1.569223d0 !    Platinum -     Chlorine
    xfac(78,17) =   0.099612d0 !    Platinum -     Chlorine
    alpb(78,35) =   1.571111d0 !    Platinum -      Bromine
    xfac(78,35) =   0.099993d0 !    Platinum -      Bromine
    alpb(78,53) =   2.085603d0 !    Platinum -       Iodine
    xfac(78,53) =   0.290991d0 !    Platinum -       Iodine
    alpb(78,78) =   0.999988d0 !    Platinum -     Platinum
    xfac(78,78) =   0.099990d0 !    Platinum -     Platinum
    !
  end subroutine alpb_and_xfac_mndo

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

subroutine setupk (nocc1)
    use MOZYME_C, only : icocc, ncf, nncf, kopt
    use molkst_C, only : numat
    implicit none
    integer, intent (in) :: nocc1
    integer :: i, j, k, l
   !********************************************************************
   !
   !   SETUPK DETERMINES WHICH ATOMS NEED TO BE CONSIDERED IN
   !   RE-CONSTRUCTING THE FOCK MATRIX.
   !
   !   THE SET OF ATOMS TO BE USED IS PUT INTO KOPT.  ALL ATOMS USED IN
   !   THE LMOs IN THE SCF CALCULATION ARE PUT INTO KOPT.
   !
   !   (Note:  Perhaps a better test would be 'All atoms that make a
   !   significant contribution to the LMOs in the SCF calculation?'
   !
   !********************************************************************
    kopt = 0
    do i = 1, nocc1
      j = nncf(i)
      do k = 1, ncf(i)
        kopt(icocc(k+j)) = 1
      end do
    end do
!
!   If atom i is to be used in constructing the Fock matrix, then kopt(i) = 1
!   otherwise kopt(i) = 0
!
!   Now compress kopt, so that all the atoms used for the Fock matrix are in
!   order.
!
    l = 0
    do i = 1, numat
      if (kopt(i) == 1) then
        l = l + 1
        kopt(l) = i
      end if
    end do
!
!  Force a zero in after the last atom.  This can be used in finding the end of the atom list.
!
    if (l /= numat) kopt(l+1) = 0
end subroutine setupk

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine mullik()
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!
      use molkst_C, only : numat, nelecs, nclose, nopen, fract,  &
        keywrd, norbs, id, verson, method_pm6, uhf, nalpha, nbeta, &
        numcal, escf, line
!
      use symmetry_C, only : jndex, namo
!
      use maps_C, only : rxn_coord
!
      use common_arrays_C, only : nfirst, nlast, nat, coord, &
      & c, h, pb, tvec, eigs, q, eigb, p, ifact, cb
!
      use parameters_C, only : zs, zp, zd, betas, betap, tore
!
      use chanel_C, only : igpt, gpt_fn, iw
!
      implicit none
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, if, il, im1, k, ii, j, jf, jl, ij, icalcn=0, mo_l, mo_u
      character, dimension(:), allocatable :: namo_tmp*4
      character :: paras*1
      double precision, dimension(norbs) :: eig
      double precision, dimension(:), allocatable :: store, vecs, store_h
      double precision, dimension(:, :), allocatable :: work
      double precision :: bi, bj, sum, summ, q2(numat)
      logical :: graph, graph_formatted, namo_ok
! GBR_new_addition
      integer :: nlower
!
      save :: graph, graph_formatted, icalcn, mo_l, mo_u
!

!-----------------------------------------------
!*********************************************************************
!
!  MULLIK DOES A MULLIKEN POPULATION ANALYSIS
! ON INPUT     C      =  SQUARE ARRAY OF EIGENVECTORS.
!              H      =  PACKED ARRAY OF ONE-ELECTRON MATRIX
!              VECS   =  WORKSTORE OF SIZE AT LEAST NORBS*NORBS
!              STORE  =  WORKSTORE OF SIZE AT LEAST (NORBS*(NORBS+1))/2
!
!*********************************************************************


     allocate(store((norbs*(norbs + 1))/2), store_h((norbs*(norbs + 1))/2), &
       vecs(norbs**2), stat = i)
     if (i /= 0) then
        write(iw,*)" Unable to allocate memory for eigenvector matrices in MULLIK"
        call mopend("Unable to allocate memory for eigenvector matrices in MULLIK")
        return
      end if
!*********************************************************************
!
!  FIRST, RE-CALCULATE THE OVERLAP MATRIX
!
!*********************************************************************
      if (icalcn /= numcal) then
        icalcn = numcal
        graph = index(keywrd,'GRAPH') /= 0
        graph_formatted = index(keywrd,'GRAPHF') /= 0
        if (allocated(ifact)) deallocate(ifact)
        allocate (ifact(norbs + 1))
        do i = 1, norbs
          ifact(i) = (i*(i - 1))/2
        end do
        ifact(norbs+1) = (norbs*(norbs + 1))/2
        if (graph) then
          close (unit=igpt, iostat=i)
          if (graph_formatted) then
            open(unit=igpt, file=gpt_fn(:len_trim(gpt_fn) - 3)//"mgf", form='FORMATTED', &
              status="UNKNOWN", iostat = i)
          else
            open(unit=igpt, file=gpt_fn, form='UNFORMATTED', status="UNKNOWN", iostat = i)
          end if
          if (i /= 0) then
            write(iw,*)" File '"//gpt_fn(:len_trim(gpt_fn))//"' is unavailable for use"
            call mopend("File '"//gpt_fn(:len_trim(gpt_fn))//"' is unavailable for use")
            return
          end if
          rewind igpt
        end if
        mo_l = 1
        mo_u = norbs
      end if
      call chrge (p, q2)
      do i = 1, numat
        q(i) = tore(nat(i) ) - q2(i)
      end do
      store_h = h
      do i = 1, numat
        if = nfirst(i)
        il = nlast(i)
        im1 = i - 1
        bi = betas(nat(i))
        do k = if, il
          ii = (k*(k - 1))/2
          do j = 1, im1
            jf = nfirst(j)
            jl = nlast(j)
            bj = betas(nat(j))
!  THE  +1.D-14 IS TO PREVENT POSSIBLE ERRORS IN THE DIAGONALIZATION.
            ij = ii + jf
            h(ij) = 2.D0*h(ij)/(bi + bj) + 1.D-14
            store(ij) = h(ij)
            bj = betap(nat(j))
            bj = betap(nat(j))
            h(ii+jf+1:jl+ii) = 2.D0*h(ii+jf+1:jl+ii)/(bi + bj) + 1.D-14
!  THE  +1.D-14 IS TO PREVENT POSSIBLE ERRORS IN THE DIAGONALIZATION.
            store(ii+jf+1:jl+ii) = h(ii+jf+1:jl+ii)
          end do
          store(ii+if:k+ii) = 0.D0
          h(ii+if:k+ii) = 0.D0
          bi = betap(nat(i))
        end do
      end do
      store(ifact(2:norbs+1)) = 1.D0
      h(ifact(2:norbs+1)) = 1.D0
      call rsp (h, norbs, eig, vecs)
      do i = 1, norbs
        eig(i) = 1.D0/sqrt(abs(eig(i)))
      end do
      if (.not. allocated(work)) allocate(work(norbs,norbs))
      ij = 0
      do i = 1, norbs
        do j = 1, i
          ij = ij + 1
          sum = 0.D0
          do k = 1, norbs
            sum = sum + vecs(i+(k-1)*norbs)*eig(k)*vecs(j+(k-1)*norbs)
          end do
          work(i,j) = sum
          work(j,i) = sum
        end do
      end do
      if (graph) then
        if (graph_formatted) then
          write(igpt,"(i5, a)") numat," MOPAC-Graphical data Version "//verson
          do i = 1, numat
            write(igpt,"(i4,f13.7,2f12.7,f9.4)")nat(i),(coord(j,i),j=1,3), q(i)
          end do
          do i = 1, numat
            write(igpt,"(3f11.7)")zs(nat(i)), zp(nat(i)), zd(nat(i))
          end do
          if (index(keywrd," ALLV") == 0) then
            mo_l = max(1, max(nalpha,nclose) - 8)
            mo_u = min(norbs, max(nalpha,nclose) + 7)
          end if
          paras = char(ichar("1") +int(log10(norbs + 0.05)))
          namo_ok =allocated(namo)
          do i = mo_l, mo_u
            j = 0
            if (uhf .and. i <= nalpha) j = 1
            if ( .not. uhf) then
              if (i <= nclose) then
                j = 2
              else if ( i <= nopen .and. abs(fract - 1.d0) < 1.d-4) then
                j = 1
              end if
            end if
            if (namo_ok) then
              write(igpt,"(a,i2,1x,i"//paras//",a,f10.4)")' ORBITAL', j, jndex(i),namo(i), eigs(i)
            else
              write(igpt,"(a,i2,1x,'NONE',f10.4)")' ORBITAL', j, eigs(i)
            end if
            write(igpt,"(5d15.8)")(c(j,i), j=1, norbs)  !   Write out the spin-free M.O.s, or alpha M.O.s, if UHF
          end do
          write(igpt,"(a,i"//paras//",a,i"//paras//",a)")' INVERSE_MATRIX[',norbs,'x',norbs,']='
          do i = 1, norbs
            write(igpt,"(5d15.8)")(work(j,i), j=1, i) !   This is the inverse-square-root of the overlap matrix, lower half triangle.
          end do
          if (rxn_coord < 1.d8) then
            write(igpt,'(a,f12.4)')" Reaction coordinate:", rxn_coord
            write(igpt,'(a,f12.4)')" Heat_of_formation:  ", escf
          end if
          line = trim(keywrd)
          if (method_pm6 .and. index(keywrd," PM6") == 0) line = " PM6"//trim(line)
          if (uhf .and. index(keywrd," UHF") == 0) line = " UHF"//trim(line)
          write(igpt,"(a)")" Keywords:"//trim(line)
          if (uhf) then
            if (index(keywrd," ALLV") == 0) then
              mo_l = max(1, max(nbeta,nclose) - 8)
              mo_u = min(norbs, max(nbeta,nclose) + 7)
            end if
            if (namo_ok) then
              allocate(namo_tmp(norbs))
              namo_tmp(:norbs) = namo(:norbs)
              call symtrz (cb, eigb, 1, .TRUE.)
            end if
            do i = mo_l, mo_u
              j = 0
              if (uhf .and. i <= nbeta) j = 1
              if (namo_ok) then
                write(igpt,"(a,i2,1x,i"//paras//",a,f10.4)")' ORBITAL', j, jndex(i),namo(i), eigb(i)
              else
                write(igpt,"(a,i2,1x,'NONE',f10.4)")' ORBITAL', j, eigb(i)
              end if
              write(igpt,"(5d15.8)")(cb(j,i), j=1, norbs)  !   Write out the beta M.O.s, if UHF
            end do
            if (namo_ok) then
              namo(:norbs) = namo_tmp(:norbs)
              deallocate(namo_tmp)
            end if
          end if
        else
!
! WRITE TO DISK THE FOLLOWING DATA FOR GRAPHICS CALCULATION, IN ORDER:
!
!      NUMBER OF ATOMS, ORBITAL, ELECTRONS
!      ALL ATOMIC COORDINATES
!      ORBITAL COUNTERS
!      ORBITAL EXPONENTS, S, P, AND D, AND ATOMIC NUMBERS
!      EIGENVECTORS (M.O.S NOT RE-NORMALIZED)
!      INVERSE-SQUARE ROOT OF THE OVERLAP MATRIX.
!

          write (igpt) numat, norbs, nelecs, ((coord(i,j),j=1,numat),i=1,3)
          write (igpt) (nlast(i),nfirst(i),i=1,numat)
          write (igpt) (zs(nat(i)),i=1,numat), (zp(nat(i)),i=1,numat), &
          (zd(nat(i)),i=1,numat), (nat(i),i=1,numat)
          write (igpt) c
          write (igpt) work
          write (igpt) id, tvec
        end if
        h = store_h
        if (index(keywrd,'MULLIK') == 0) return
      end if
      call mult (c, work, vecs, norbs)
      i = -1
      nlower = (norbs*(norbs + 1))/2
      call density_for_GPU (vecs, fract, nclose, nopen, 2.d0, nlower, norbs, 2, pb, 3)
!
      pb = pb*store
      summ = 0.D0
      do i = 1, norbs
        sum = 0
        do j = 1, i
          sum = sum + pb(ifact(i)+j)
        end do
        do j = i + 1, norbs
          sum = sum + pb(ifact(j)+i)
        end do
        summ = summ + sum
        pb(ifact(i+1)) = sum
      end do
      h = store_h
      return
      end subroutine mullik

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

!     ******************************************************************
      double precision function digit (string, istart)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: istart
      character , intent(in) :: string*(*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i0, i9, ineg, ipos, idot, ispc, l, idig, i, n, j
      double precision :: c1, c2, deciml
      logical :: sign
!-----------------------------------------------
!     FORTRAN FUNCTION TO CONVERT NUMERIC FIELD TO DOUBLE PRECISION
!     NUMBER.  THE STRING IS ASSUMED TO BE CLEAN (NO INVALID DIGIT
!     OR CHARACTER COMBINATIONS FROM ISTART TO THE FIRST NONSPACE,
!     NONDIGIT, NONSIGN, AND NONDECIMAL POINT CHARACTER).
!
!
!     DEFINE ASCII VALUES OF NUMERIC FIELD CHARACTERS
      i0 = ichar('0')
      i9 = ichar('9')
      ineg = ichar('-')
      ipos = ichar('+')
      idot = ichar('.')
      ispc = ichar(' ')
!
      c1 = 0.D0
      c2 = 0.D0
      sign = .TRUE.
      l = len(string)
!
!     DETERMINE THE CONTRIBUTION TO THE NUMBER GREATER THAN ONE
      idig = 0
      do i = istart, l
        n = ichar(string(i:i))
        if (n>=i0 .and. n<=i9) then
          idig = idig + 1
          c1 = c1*1.D1 + n - i0
        else if (n==ineg .or. n==ipos .or. n==ispc) then
          if (n == ineg) sign = .FALSE.
        else if (n == idot) then
          exit
        else
          go to 40
        end if
      end do
!
!     DETERMINE THE CONTRIBUTION TO THE NUMBER LESS THAN THAN ONE
      deciml = 1.D0
      do j = i + 1, l
        n = ichar(string(j:j))
        if (n>=i0 .and. n<=i9) then
          deciml = deciml/1.D1
          c2 = c2 + (n - i0)*deciml
        else if (n /= ispc) then
          exit
        end if
      end do
!
!     PUT THE PIECES TOGETHER
   40 continue
      digit = c1 + c2
      if (.not.sign) digit = -digit
      return
      end function digit

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

! Fortran wrapper for diskless/stateless Application Programming Interface (API) to core MOPAC operations
module mopac_api_f
  implicit none

  private
  ! public derived types of the MOPAC API
  public :: mopac_system_f, mopac_properties_f, mopac_state_f, mozyme_state_f
  ! public subroutines of the MOPAC API
  public :: mopac_scf_f, mopac_relax_f, mopac_vibe_f, mozyme_scf_f, mozyme_relax_f, mozyme_vibe_f
  ! public subroutine of the simple, disk-based MOPAC API
  public :: run_mopac_from_input_f, get_mopac_version_f

  ! data that defines the atomistic system and MOPAC job options (Fortran wrapper)
  type :: mopac_system_f
    ! number of atoms
    integer :: natom = 0
    ! number of atoms that are allowed to move (first natom_move atoms in array)
    integer :: natom_move = 0
    ! net charge
    integer :: charge = 0
    ! number of spin excitations, floor[(number of alpha electrons)/2 - (number of beta electrons)/2]
    integer :: spin = 0
    ! semiempirical model: PM7 = 0, PM6-D3H4 = 1, PM6-ORG = 2, PM6 = 3, AM1 = 4, RM1 = 5
    integer :: model = 0
    ! dielectric constant for COSMO implicit solvent, must be 1 (no solvent) for nlattice > 0
    double precision :: epsilon = 1.d0
    ! atomic number of each atom [natom]
    integer, dimension (:), allocatable :: atom
    ! (x,y,z) coordinates of each atom (Angstroms) [3*natom]
    double precision, dimension (:), allocatable :: coord
    ! number of lattice vectors / translation vectors / periodic dimensions
    integer :: nlattice = 0
    ! number of lattice vectors that are allowed to move (first nlattice_move vectors in array)
    integer :: nlattice_move = 0
    ! external hydrostatic pressure (Gigapascals)
    double precision :: pressure = 0.d0
    ! (x,y,z) coordinates of each lattice vectors (Angstroms) [3*nlattice]
    double precision, dimension (:), allocatable :: lattice
    ! relative numerical tolerances (equivalent to GNORM and RELSCF keyword values)
    double precision :: tolerance = 1.d0
    ! time limit for a MOPAC calculation (seconds)
    integer :: max_time = 3600
  end type

  ! calculated ground-state properties of an atomistic system and MOPAC job info (Fortran wrapper)
  type :: mopac_properties_f
    ! heat of formation (kcal/mol)
    double precision :: heat
    ! dipole moment vector (Debye)
    double precision, dimension (3) :: dipole
    ! atomic partial charges [natom]
    double precision, dimension (:), allocatable :: charge
    ! (x,y,z) coordinates of each moveable atom (Angstroms) [3*natom_move]
    double precision, dimension (:), allocatable :: coord_update
    ! (x,y,z) heat gradients for each moveable atom (kcal/mol/Angstrom) [3*natom_move]
    double precision, dimension (:), allocatable :: coord_deriv
    ! vibrational frequencies of normal modes (1/cm) [3*natom_move], if available
    double precision, dimension (:), allocatable :: freq
    ! (x,y,z) displacement vectors of normal modes [3*natom_move,3*natom_move], if available
    double precision, dimension (:,:), allocatable :: disp
    ! bond-order matrix in compressed sparse column (CSC) matrix format (1-based indexing)
    ! with insignificant bond orders (<0.01) truncated
    ! diagonal matrix entries are atomic valencies
    ! > first index of each atom in CSC bond-order matrix [natom+1]
    integer, dimension (:), allocatable :: bond_index
    ! > list of atoms bonded to each atom in CSC format [bond_index(natom+1)-1]
    integer, dimension (:), allocatable :: bond_atom
    ! > bond order of atoms bonded to each atom in CSC format [bond_index(natom+1)-1]
    double precision, dimension (:), allocatable :: bond_order
    ! (x,y,z) coordinates of each moveable lattice vectors (Angstroms) [3*nlattice_move]
    double precision, dimension (:), allocatable :: lattice_update
    ! (x,y,z) heat gradients for each moveable lattice vector (kcal/mol/Angstrom) [3*nlattice_move]
    double precision, dimension (:), allocatable :: lattice_deriv
    ! stress tensor (Gigapascals) in Voigt form (xx, yy, zz, yz, xz, xy), 0 if available
    double precision, dimension (6) :: stress
    ! number of MOPAC error messages (negative value indicates that allocation of error_msg failed)
    integer :: nerror
    ! text of MOPAC error messages [nerror,120]
    character(len=120), dimension (:), allocatable :: error_msg
  end type

  ! data that describes the electronic state using standard molecular orbitals (Fortran wrapper)
  type :: mopac_state_f
    ! MOPAC data format is adapted from molkst_C and Common_arrays_C modules
    ! > number of matrix elements in packed lower triangle matrix format
    integer :: mpack = 0 ! 0 if state is unavailable
    ! > flag for unrestricted Hartree-Fock ground state (0 == restricted, 1 == unrestricted)
    logical :: uhf
    ! > alpha density matrix [mpack]
    double precision, dimension (:), allocatable :: pa
    ! > beta density matrix [mpack], empty if uhf == 0
    double precision, dimension (:), allocatable :: pb
  end type

  ! data that describes the electronic state using localized molecular orbitals (Fortran wrapper)
  type :: mozyme_state_f
    ! MOZYME data format is adapted from molkst_C, Common_arrays_C, and MOZYME_C modules
    ! > number of real atoms
    integer :: numat = 0 ! 0 if state is unavailable
    ! > number of Lewis bonds per real atom [numat]
    integer, dimension (:), allocatable :: nbonds
    ! > list of Lewis-bonded real atoms for each real atom [9,numat]
    integer, dimension (:,:), allocatable :: ibonds
    ! > number of orbitals per real atom [numat]
    integer, dimension (:), allocatable :: iorbs
    ! > number of occupied molecular orbitals
    integer :: noccupied
    ! > number of atoms in each occupied LMO [noccupied]
    integer, dimension (:), allocatable :: ncf
    ! > number of virtual molecular orbitals
    integer :: nvirtual
    ! > number of atoms in each virtual LMO [nvirtual]
    integer, dimension (:), allocatable :: nce
    ! > size of array icocc
    integer :: icocc_dim
    ! > index of each real atom in the occupied LMOs [iccoc_dim]
    integer, dimension (:), allocatable :: icocc
    ! > size of array icvir
    integer :: icvir_dim
    ! > index of each real atom in the virtual LMOs [icvir_dim]
    integer, dimension (:), allocatable :: icvir
    ! > size of array cocc
    integer :: cocc_dim
    ! > atomic orbital coefficients of the occupied LMOs [cocc_dim]
    double precision, dimension (:), allocatable :: cocc
    ! > size of array cvir
    integer :: cvir_dim
    ! > atomic orbital coefficients of the virtual LMOs [cvir_dim]
    double precision, dimension (:), allocatable :: cvir
  end type

  ! library subroutines
  interface

    ! MOPAC electronic ground state calculation
    module subroutine mopac_scf_f(system, state, properties)
      type(mopac_system_f), intent(in) :: system
      type(mopac_state_f), intent(inout) :: state
      type(mopac_properties_f), intent(out) :: properties
    end subroutine mopac_scf_f

    ! MOPAC geometry relaxation
    module subroutine mopac_relax_f(system, state, properties)
      type(mopac_system_f), intent(in) :: system
      type(mopac_state_f), intent(inout) :: state
      type(mopac_properties_f), intent(out) :: properties
    end subroutine mopac_relax_f

    ! MOPAC vibrational calculation
    module subroutine mopac_vibe_f(system, state, properties)
      type(mopac_system_f), intent(in) :: system
      type(mopac_state_f), intent(inout) :: state
      type(mopac_properties_f), intent(out) :: properties
    end subroutine mopac_vibe_f

    ! MOZYME electronic ground state calculation
    module subroutine mozyme_scf_f(system, state, properties)
      type(mopac_system_f), intent(in) :: system
      type(mozyme_state_f), intent(inout) :: state
      type(mopac_properties_f), intent(out) :: properties
    end subroutine mozyme_scf_f

    ! MOZYME geometry relaxation
    module subroutine mozyme_relax_f(system, state, properties)
      type(mopac_system_f), intent(in) :: system
      type(mozyme_state_f), intent(inout) :: state
      type(mopac_properties_f), intent(out) :: properties
    end subroutine mozyme_relax_f

    ! MOZYME vibrational calculation
    module subroutine mozyme_vibe_f(system, state, properties)
      type(mopac_system_f), intent(in) :: system
      type(mozyme_state_f), intent(inout) :: state
      type(mopac_properties_f), intent(out) :: properties
    end subroutine mozyme_vibe_f

    ! run MOPAC conventionally from an input file
    module function run_mopac_from_input_f(path_to_file)
      logical :: run_mopac_from_input_f
      character(len=240), intent(in) :: path_to_file
    end function run_mopac_from_input_f

    ! get MOPAC version string
    module subroutine get_mopac_version_f(version)
      character(len=20), intent(out) :: version
    end subroutine get_mopac_version_f

  end interface

end module mopac_api_f

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine ciosci(vects, lroot, oscil, conf)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only: numat,  norbs, keywrd
      use common_arrays_C, only : coord, nfirst, nlast, nat
      USE parameters_C, only : dd, zp, zd
      use funcon_C, only : a0
      use meci_C, only : nstate, lab, nmos, microa, microb
      use chanel_C, only: iw
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   C o m m o n   B l o c k s
!-----------------------------------------------

!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision , intent(in) :: vects(norbs,norbs)
      double precision , intent(inout) :: oscil(3,*)
      double precision, dimension(:,:), allocatable :: t4
      double precision , intent(in) :: conf(lab*lab)
      integer :: lroot
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(14) :: ll
      integer :: loop, iloop, iatom, i, j, k, l, m, ii, ij, jj, istate, &
      nd, npp, ns
      double precision, dimension(norbs,nmos) :: vect1, vect2
      double precision, dimension(nmos,nmos) :: t2
      double precision, dimension(lab) :: work
      integer, dimension (107), save :: nspqn
      double precision, dimension (numat) :: sppol
      double precision, dimension (:), allocatable :: pdpol
      character (len=1) :: type (3)
      double precision :: sum
      logical :: debug
!***********************************************************************
!
!    CIOSCI evaluates the expectation value <STATE|x or y or z|STATE>
!
!   Info:   VECTS  = Molecular Orbitals
!           CONF   = State Eigenvectors
!           NSTATE = State to be excited from
!
!
!***********************************************************************
      data nspqn / 2 * 1, 8 * 2, 8 * 3, 18 * 4, 18 * 5, 32 * 6, 21 * 0 /
      data type / "x", "y", "z" /
      debug = (Index (keywrd, "CIOSCI") /= 0)
      allocate(t4(lab, lab))
   !
   !   a0 = 0.529
   !
   ! dd(i) = (2*n+1)*2**(2n+1)*(exp(s)*exp(p))**(n+1/2)
   !           ----------------------------------------  See calpar
   !          (sqrt(3)*(exp(s)+exp(p))**(2*n+2))
   !
   ! dd is the transition length <ns|r|np> in bohr
   !
      sppol(:numat) = a0 * dd(nat(:numat))
      ll(1) = 1
      do i = 2, 14
        ll(i) = ll(i-1) * i
      end do
  !
  !  For p-d transitions,
  !  pdpop(i) = (np+nd+1)!*2**(np+nd+1)*exp(p)**(np+1/2)*exp(d)**(nd+1/2)
  !              --------------------------------------------------------
  !             sqrt(5)*(exp(p)+exp(d)**(np+nd+2)*sqrt( (2*np)! * (2*nd)! )
  !
      allocate (pdpol(numat))
      do i = 1, numat
        if (nlast(i)-nfirst(i) > 5) then
          j = nat(i)
          nd = nspqn(j)
          npp = nd
          if (j > 20) npp = npp - 1
          pdpol(i) = a0 * ll(npp+nd+1) * 2 ** (npp+nd+1) * &
               & zp(j) ** (npp+ 0.5d0) * zd(j) ** (nd+0.5d0) / &
               & (Sqrt(5.d0)*(zp(j)+zd(j))**(npp+nd+2) * &
               & Sqrt(Dble(ll((2*npp))*ll(2*nd))))
        end if
      end do
      oscil(:3, :lab) = 0.d0
      do loop = 1, 3
        !
        !    SET UP THE M.O. UNITARY MATRIX, <PSI | IOPER | PSI>
        !
        do iloop = 1, nmos
          do iatom = 1, numat
            do i = nfirst(iatom), nlast(iatom)
              vect1(i, iloop) = vects(i, iloop)
              vect2(i, iloop) = vects(i, iloop) * coord(loop, iatom)
              if (nat(iatom) /= 1) then
  !
  !   Include the s-p transition on the same atom
  !
                if (i == nfirst(iatom)) then
                  vect2(i, iloop) = vect2(i, iloop) + sppol(iatom) * &
                       & vects(i+loop, iloop)
                else if (i-nfirst(iatom) == loop) then
                  vect2(i, iloop) = vect2(i, iloop) + sppol(iatom) * &
                       & vects(i-loop, iloop)
                end if
                if (i == nfirst(iatom)+8) then
  !
  !  k = start of "p" shell - 1;  l = start of "d" shell - 1.
  !
                  k = nfirst(iatom)
                  l = k + 3
  !
  ! Add in p - d transition.  Do all three (x, y, z) at one time
  !
                  if (loop == 1) then
                    vect2(k+1, iloop) = vect2(k+1, iloop) + pdpol(iatom) * &
                         & (vects(l+1, iloop)-1/Sqrt(3.d0)*vects(l+3, iloop))
                 !
                    vect2(k+2, iloop) = vect2(k+2, iloop) + pdpol(iatom) * &
                         & vects(l+5, iloop)
                 !
                    vect2(k+3, iloop) = vect2(k+3, iloop) + pdpol(iatom) * &
                         & vects(l+2, iloop)
  !
  !  "d" set
  !
                    vect2(l+1, iloop) = vect2(l+1, iloop) + pdpol(iatom) * &
                         & vects(k+1, iloop)
                    vect2(l+2, iloop) = vect2(l+2, iloop) + pdpol(iatom) * &
                         & vects(k+3, iloop)
                    vect2(l+3, iloop) = vect2(l+3, iloop) - 1 / Sqrt (3.d0) * &
                         & pdpol(iatom) * vects(k+1, iloop)
                    vect2(l+5, iloop) = vect2(l+5, iloop) + pdpol(iatom) * &
                         & vects(k+2, iloop)
                  else if (loop == 2) then
                    vect2(k+1, iloop) = vect2(k+1, iloop) + pdpol(iatom) * &
                         & vects(l+5, iloop)
                    vect2(k+2, iloop) = vect2(k+2, iloop) + pdpol(iatom) * &
                         & (-vects(l+1, iloop)-1/Sqrt(3.d0)*vects(l+3, iloop))
                    vect2(k+3, iloop) = vect2(k+3, iloop) + pdpol(iatom) * &
                         & vects(l+4, iloop)
                    vect2(l+1, iloop) = vect2(l+1, iloop) - pdpol(iatom) * &
                         & vects(k+2, iloop)
                    vect2(l+3, iloop) = vect2(l+3, iloop) - 1 / Sqrt (3.d0) * &
                   & pdpol(iatom) * vects(k+2, iloop)
                    vect2(l+4, iloop) = vect2(l+4, iloop) + pdpol(iatom) * &
                         & vects(k+3, iloop)
                    vect2(l+5, iloop) = vect2(l+5, iloop) + pdpol(iatom) * &
                         & vects(k+1, iloop)
                  else
                    vect2(k+1, iloop) = vect2(k+1, iloop) + pdpol(iatom) * &
                         & vects(l+2, iloop)
                    vect2(k+2, iloop) = vect2(k+2, iloop) + pdpol(iatom) * &
                         & vects(l+4, iloop)
                    vect2(k+3, iloop) = vect2(k+3, iloop) + pdpol(iatom) * &
                         & 2.d0 / Sqrt (3.d0) * vects(l+3, iloop)
                 !
                    vect2(l+2, iloop) = vect2(l+2, iloop) + pdpol(iatom) * &
                         & vects(k+1, iloop)
                    vect2(l+3, iloop) = vect2(l+3, iloop) + 2 / Sqrt (3.d0) * &
                         & pdpol(iatom) * vects(k+3, iloop)
                    vect2(l+4, iloop) = vect2(l+4, iloop) + pdpol(iatom) * &
                         & vects(k+2, iloop)
                  end if
                end if
              end if
            end do
          end do
        end do
        !
        !    VECT1 HOLDS THE MOLECULAR ORBITALS IN THE COORDINATE SYSTEM OF
        !          SYMTRZ.
        !    VECT2 HOLDS THE SAME ORBITALS, AFTER BEING OPERATED ON BY THE
        !          DIPOLE OPERATORS 'X', 'Y', AND 'Z'.
        !
        !     T2 HOLD THE UNITARY TRANSFORM FOR THE SET OF M.O.S
        !        <VECT1|IOPER|VECT2>
        !
        do i = 1, nmos
          t2(i, i) = 0.d0
          do j = 1, i - 1
            if (i /= j) then
              sum = 0.d0
              do k = 1, norbs
                sum = sum + vect1(k, i) * vect2(k, j)
              end do
              t2(i, j) = sum
              t2(j, i) = -sum
            end if
          end do
        end do
        if (debug) then
          write (iw, "(/,A)") "              EFFECT OF DIPOLE OPERATOR ON M.O.S"
          do j = 1, nmos, 2
            jj = Min (j+1, nmos)
            if (jj /= j) then
              write (iw, "(4(a,i1,a,i1),a)") "    A.O.           |M.O.", j, &
                   & ">         " // type (loop) // "|M.O.", j, &
                   & ">          |M.O.", j + 1, ">         " // type (loop) // &
                   & "|M.O.", j + 1, ">"
            else
              write (iw, "(2(a,i1,a,i1),a)") "    A.O.           |M.O.", j, &
                   & ">        " // type (loop) // "|M.O.", j, ">"
            end if
            do i = 1, norbs
              write (iw, "(i6,6x,4f17.12)") i, (vect1(i, k), vect2(i, k), &
                   & k=j, jj)
            end do
          end do
          write (iw, "(/6x,a)") "         Integrals <M.O.|" // type (loop) // &
               & "|M.O.>"
          write (iw, "(i12,8i17)") (i, i=1, nmos)
          do i = 1, nmos
            write (iw, "(I6,10(10F17.12,/6x))") i, (t2(j, i), j=1, nmos)
          end do
        end if
        !
        !   THE BIG LOOP TO FILL T4
        !
        do i = 1, lab
          do j = 1, i
            l = 0
            m = 0
            do k = 1, nmos
              if (microa(k, i) /= microa(k, j)) then
                l = l + 1
                ll(l) = k
              end if
              if (microb(k, i) /= microb(k, j)) then
                m = m + 1
                ll(m) = k
              end if
            end do
            if (l == 2 .and. m == 0 .or. m == 2 .and. l == 0) then
              t4(i, j) = t2(ll(1), ll(2))
              if (l == 2) then
                !
                !   Two microstates differing in two ALPHA electrons
                !
                ii = ll(1)
                !
                !   Add in MICROA(II,I) to allow for the fact that M.O. LL(1)
                !   is ALWAYS less than M.O. LL(2).
                !
                !   Step over MICROB(II,I)
                !
                ij = microb(ii, i) + microa(ii, i)
                do jj = ii + 1, ll(2) - 1
                  ij = ij + microa(jj, i) + microb(jj, i)
                end do
              else
                !
                !   Two microstates differing in two BETA electrons
                !
                ii = ll(1)
                !
                !   Add in MICROB(II,I) to allow for the fact that M.O. LL(1)
                !   is ALWAYS less than M.O. LL(2).
                !
                ij = microb(ii, i)
                do jj = ii + 1, ll(2) - 1
                  ij = ij + microa(jj, i) + microb(jj, i)
                end do
                    !
                    !  Must jump over MICROA(LL(2),I) to get to the beta M.O.
                    !
                ij = ij + microa(ll(2), i)
              end if
              if (Mod(ij, 2) == 1) then
                t4(i, j) = -t4(i, j)
              end if
                 !
                 !  Matrix is antisymmetric, therefore:
                 !
              t4(j, i) = -t4(i, j)
            else
              t4(i, j) = 0.d0
              t4(j, i) = 0.d0
            end if
          end do
        end do
        if (debug) then
          write (iw, "(//10x, ' EFFECT OF DIPOLE OPERATOR ON MICROSTATES')")
          if (lab < 6) then
            write (iw, "(i12,5i17)") (i, i=1, lab)
            do i = 1, lab
              write (iw, "(I6,3(5F17.12,2x))") i, (t4(j, i), j=1, lab)
            end do
          else
            i = -lab
            call matout (t4, t4, lab,i, lab)
          end if
        end if
        !
        !    NOW TO PERFORM <STATE(LROOT)| X OR Y OR Z  | STATE(ISTATE)>
        !
        do ns = 1, nstate
          ii = (lroot+ns-2) * lab
          do istate = 1, lab
            do j = 1, lab
              sum = 0.d0
              do k = 1, lab
                sum = sum + conf(k+ii) * t4(j, k)
              end do
              work(j) = sum
            end do
            sum = 0.d0
            do k = 1, lab
              sum = sum + work(k) * conf(k+ (istate-1)*lab)
            end do
            oscil(loop, istate) = oscil(loop, istate) + sum ** 2
          end do
        end do
      end do
      if (Index (keywrd, " LARGE") /= 0 .or. debug) then
        write (iw, "(//,A)") "           EFFECT OF DIPOLE OPERATOR ON STATES"
        write (iw, "(' STATE         X                Y                Z')")
        do i = 1, lab
          write (iw, "(I4,3F17.8)") i, (oscil(j, i), j=1, 3)
        end do
      end if
      deallocate (pdpol)
end subroutine ciosci

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine output_rama
!
! Write out Ramachandran angles, if keyword "RAMA" is present.
!
! These angles are calculated in get_angles each time they are printed.
!
  use common_arrays_C, only : txtatm
  use molkst_C, only : keywrd
  use MOZYME_C, only : angles, res_start, uni_res
  use chanel_C, only: iw
  implicit none
  integer :: i, j
  if (index(keywrd, " RAMA") == 0) return
  call get_angles()
  if (uni_res == 0) return
  write(iw,"(/22x,a)")"Ramachandran Angles"
  write(iw,"(/15x, a, 8x, a/)")"Residue","Phi    Psi  Omega"
  do i = 1, uni_res
    if (Abs(angles(1,i)) + Abs(angles(3,i))> 1.d-20 .and. res_start(i) > 0 .and. &
      txtatm(res_start(i))(1:4) == "ATOM") then
      if (Abs(angles(1,i)) > 1.d-20 .and. Abs(angles(2,i)) > 1.d-20 ) then
        write(iw,"(14x,a, 3x, 3f7.1, a)")txtatm(res_start(i))(18:26), (angles(j,i),j = 1,3)
        else if  (Abs(angles(1,i)) > 1.d-20) then
        write(iw,"(14x,a, 3x,f7.1, 2a)")txtatm(res_start(i))(18:26), angles(1,i), &
        "    -  ","    -  "
        else
        write(iw,"(14x,a, 3x,a, 3f7.1)")txtatm(res_start(i))(18:26), &
        "    -  ", (angles(j,i),j = 2,3)
      end if
    end if
  end do
  write(iw,*)" "
  return
end subroutine output_rama


subroutine get_angles ()
!
! Calculate the Ramachandran angles and the number of unique residues.
!
! Nothing else should be altered.
!
! Array "ions" is needed by subroutine "names"
!
  use common_arrays_C, only : nat, txtatm
  use MOZYME_C, only : ions, angles, allres, ib, allr, iopt, &
    start_res, lstart_res, uni_res
  use molkst_C, only: natoms, numat, moperr, maxatoms
  use atomradii_C, only: atom_radius_covalent
  implicit none
!
  double precision, dimension(:), allocatable :: radius
  logical, save :: l_protein
  logical, dimension (:), allocatable :: ioptl
  integer :: i, ires, nfrag, io, j, n1, alloc_stat, mres, &
    nn1,  delta_res, max_frag
!
  if (allocated(ions))    deallocate (ions)
  if (allocated(iopt))    deallocate(iopt)
  if (Allocated (ib))     deallocate (ib)
  allocate (ions(maxatoms),  ib(maxatoms),  &
          & ioptl(maxatoms), iopt(maxatoms), radius(maxatoms), &
          stat=alloc_stat)
  if (alloc_stat /= 0) return
  l_protein = .false.
  ib(:) = 0
  mres = 0
  ions = 0
  call extvdw_for_MOZYME (radius, atom_radius_covalent)
!
!   WORK OUT WHAT ATOMS ARE BONDED TO EACH OTHER.
!
  call lewis (.true.)
  if (moperr) return
!
!  FIND THE NITROGEN ATOM OF THE N END OF THE PROTEIN.
!
  ioptl(:numat) = .false.
  call findn1 (n1, ioptl, io, delta_res)
  txtatm(:numat) = " "
  angles = 0.d0
  allres = " "
  l_protein = (n1 /= 0)
  ib(:numat) = -100000
  ires = 0
  uni_res = 0
!
!  Break all intra-chain bonds, so that the residues can easily be
!  identified.
!
  call lyse !
  allr = " "
  do max_frag = 1, 10000
    if (start_res(max_frag) == -200) exit
  end do
  max_frag = max_frag - 1
  lstart_res = .false.
  nfrag = 0
  do
    if (max_frag > 0) then
      do nfrag = 1, max_frag
        if (.not. lstart_res(start_res(nfrag) + 1)) exit
      end do
    else
      nfrag = nfrag + 1
    end if
    if (max_frag > 0) then
      if (nfrag > max_frag) exit
      ires = start_res(nfrag) - delta_res
    end if
!
    call names (ioptl, ib, n1, ires, nfrag, io, uni_res, mres)
    if (moperr) return
!
    nn1 = n1
    call findn1 (n1, ioptl, io, delta_res)
!
! n1 is the start of the next fragment
! delta_res is the distance back along the chain to the start of the next fragment.
!
    if (.not. l_protein) nfrag = 0
    if (n1 == 0) exit
    if (n1 == nn1) ioptl(n1) = .true.
  end do
!
!  Re-evaluate all residues
!
  j = 1
  allres(j) = txtatm(1)(18:20)
  do i = 2, natoms
    if (txtatm(i) == " ")exit
    if (nat(i) /= 1 .and. txtatm(i)(23:27) /= txtatm(i - 1)(23:27)) then
      j = j + 1
      allres(j) = txtatm(i)(18:20)
    end if
  end do
  ires = j
  iopt(:natoms) = ib(:natoms)
!
!   LABEL THE ATOMS IN ANY NON-PROTEIN MOLECULES IN THE SYSTEM
!
  nfrag = nfrag + 1
  if (start_res(max(1,nfrag)) == -200) then
    if (.not. l_protein) ires = 0
  else
    ires = start_res(nfrag)
  end if
  call ligand (ires, start_res, nfrag)
!
!  Add chain letters
!
  call update_txtatm(.true., .true.)
  return
end subroutine get_angles

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine deri22(c, b, work, foc2, ab, minear, fci, w, diag, &
        scalar, ninear)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE molkst_C, only : nopen, numat, norbs, n2elec
      use common_arrays_C, only : nfirst, nlast
      use meci_C, only : nmos, nbo, nelec
      implicit none
      integer , intent(in) :: minear
      integer , intent(in) :: ninear
      double precision :: c(norbs,norbs), work(norbs,norbs), foc2(norbs**2)
      double precision, allocatable  :: dp(:), dpa(:)
      double precision  :: b(minear)
      double precision  :: ab(minear)
      double precision  :: fci(ninear)
      double precision  :: w(n2elec)
      double precision , intent(in) :: diag(*)
      double precision , intent(in) :: scalar(*)
!
      integer :: i, l, j, nend, loop, ninit, n1, n2, icount, ncol
      double precision :: wj(1) = 0.d0, wk(1) = 0.d0  ! Dummys - wj and wk are used by solids only.
      double precision, external :: ddot, dot
!***********************************************************************
!  1) BUILD THE 2-ELECTRON FOCK MATRIX DEPENDING ON B AS FOLLOWS :
!     DP = C * SCALE*B * C' ...  DP DENSITY MATRIX 'DERIVATIVE',
!     FOC2 = 0.5 * TRACE ( DP * (2<J>-<K>) ) DONE IN FOCK2 & FOCK1.
!  2) HALF-TRANSFORM ONTO M.O. BASIS : DPT =  FOC2 * C
!     AND COMPUTE DIAGONAL BLOCKS ELEMENTS OF C' * FOC2, EXTRACTING
!     IN FCI ELEMENTS OVER C.I-ACTIVE M.O ONLY.
!  3) COMPUTE SUPERVECTOR AB = (DIAG + A) * B DEFINED BY THE MATRIX :
!     AB(I,J)= ( DIAG(I,J)*B(I,J)+DPT(I,J) )*SCALAR(I,J)  WITH I.GT.J,
!     DIAG(I,J)=(EIGS(I)-EIGS(J))/(O(J)-O(I)) >0, O OCCUPANCY NUMBERS,
!     EIGS EIGENVALUES OF FOCK OPERATOR WITH EIGENVECTORS C IN A.O.
!
!   INPUT
! C(NORBS,NORBS)   : M.O. EIGENVECTORS (COLUMNWISE).
! B(*)             : B SUPERVECTOR PACKED BY OFF-DIAGONAL BLOCKS, SCALED
! WORK(*)          : WORK AREA OF SIZE N*N.
! NORBS            : NUMBER OF M.O.S
! NELEC,NMOS       : LAST FROZEN CORE M.O. , C.I-ACTIVE BAND LENGTH.
!           IN COMMON
! DIAG,SCALAR AS DEFINED IN 'DERI0'.
!   OUTPUT
! FOC2(*)       : 2-ELECTRON FOCK MATRIX, PACKED CANONICAL.
! AB(*)         : ANTISYMMETRIC MATRIX PACKED IN SUPERVECTOR FORM WITH
!                 THE CONSECUTIVE FOLLOWING BLOCKS:
!              1) OPEN-CLOSED  I.E. B(IJ)=B(I,J) WITH I OPEN & J CLOSED
!                 AND I RUNNING FASTER THAN J,
!              2) VIRTUAL-CLOSED SAME RULE OF ORDERING,
!              3) VIRTUAL-OPEN   SAME RULE OF ORDERING.
! FCI(*)        : FOCK DIAGONAL BLOCKS ELEMENTS OVER C.I-ACTIVE M.O.
!            FOC2 CAN BE EQUIVALENCED WITH WORK IN THE CALLING SEQUENCE.
!***********************************************************************
!
!  NOTE: NORBS AND NORD ARE THE SAME ADDRESS.  THE NAME NORBD IS NOT
!        USED HERE.
!
!
!     DERIVATIVE OF THE DENSITY MATRIX IN DP (PACKED,CANONICAL).
!     ----------------------------------------------------------
!     DP = C * B * C' .
!
!     STEP 0 : UNSCALE VECTOR B.
      n2 = 0
      allocate (dp(norbs**2), dpa(norbs**2), stat=i)
      if (i /= 0) then
        call memory_error ("deri22")
        return
      end if
      b = b*scalar(:minear)
!
!     STEP 1 : WORK = C * B    .  DP TEMPORARY ARRAY.
      l = 1
      if (nbo(2)/=0 .and. nbo(1)/=0) then
!        OPEN-CLOSED
        call mxm (c(1,nbo(1)+1), norbs, b(l), nbo(2), work, nbo(1))
!       CLOSED-OPEN
        call mxmt (c, norbs, b(l), nbo(1), work(1,nbo(1)+1), nbo(2))
        l = l + nbo(2)*nbo(1)
      end if
      if (nbo(3)/=0 .and. nbo(1)/=0) then
!       VIRTUAL-CLOSED
        if (l > 1) then
          call mxm (c(1,nopen+1), norbs, b(l), nbo(3), dp, nbo(1))
          icount = 0
        do j = 1, nbo(1)
          do i = 1, norbs
            icount = icount + 1
            work(i, j) = work(i, j) + dp(icount)
          end do
        end do
        else
          call mxm (c(1,nopen+1), norbs, b(l), nbo(3), work, nbo(1))
        end if
!       CLOSED-VIRTUAL
        call mxmt (c, norbs, b(l), nbo(1), work(1,nopen+1), nbo(3))
        l = l + nbo(3)*nbo(1)
      end if
      if (nbo(3)/=0 .and. nbo(2)/=0) then
!       VIRTUAL-OPEN
        call mxm (c(1,nopen+1), norbs, b(l), nbo(3), dp, nbo(2))
         icount = 0
      do j = nbo(1) + 1, nbo(1) + nbo(2)
        do i = 1, norbs
          icount = icount + 1
          work(i, j) = work(i, j) + dp(icount)
        end do
      end do
!       OPEN-VIRTUAL
        call mxmt (c(1,nbo(1)+1), norbs, b(l), nbo(2), dp, nbo(3))
     icount = 0
      do j = nopen + 1, nopen + nbo(3)
        do i = 1, norbs
          icount = icount + 1
          work(i, j) = work(i, j) + dp(icount)
        end do
      end do
      end if
!
!     STEP 2 : DP= WORK * C'   WITH DP PACKED,CANONICAL.
      l = 0
      do i = 1, norbs
        do j = 1, i
          l = l + 1
          dp(l) = ddot(norbs,work(i,1),norbs,c(j,1),norbs)
        end do
      end do
!
!     2-ELECTRON FOCK MATRIX BUILD WITH THE DENSITY MATRIX DERIVATIVE.
!     ----------------------------------------------------------------
!     RETURNED IN FOC2 (PACKED CANONICAL).
      foc2 = 0.D0
      dpa(:l) = 0.5D0*dp(:l)
        call fock2 (foc2, dp, dpa, w, wj, wk, numat, nfirst, nlast, 2)
!
!     BUILD DP AND EXTRACT FCI.
!     --------------------------
!
!     DP(NORBS,NEND) = FOC2(NORBS,NORBS) * C(NORBS,NEND).
      nend = max(nopen,nelec + nmos)
      l = 1
      do i = 1, nend
        call supdot (dp(l), foc2, c(1,i), norbs)
        l = l + norbs
      end do
!     EXTRACT FCI
      l = 1
      nend = 0
      do loop = 1, 3
        ninit = nend + 1
        nend = nend + nbo(loop)
        n1 = max(ninit,nelec + 1)
        n2 = min(nend,nelec + nmos)
        if (n2 < n1) cycle
        do i = n1, n2
          if (i <= ninit) cycle
          ! TODO: GBR future modifications
          call mxm (c(1,i), 1, dp(norbs*(ninit-1)+1), norbs, fci(l), i - ninit)
          l = l + i - ninit
        end do
      end do
      ncol = n2 - ninit + 1
      if (ncol > 0 .and. n2 < norbs) then
        ! TODO: GBR future modifications
        call mtxm (c(1, n2+1), norbs-n2, dp(norbs*(ninit-1)+1), norbs, fci(l), ncol)
        l = l + ncol * (norbs-n2)
      end if
      do i = nelec + 1, nelec + nmos
        fci(l) = -dot(c(1,i),dp(norbs*(i-1)+1),norbs)
        l = l + 1
      end do
!
!     NEW SUPERVECTOR AB = (DIAG + C'* FOC2 * C) * B , SCALED.
!     --------------------------------------------------------
!
!     PART 1 : AB(I,J) = (C' * DP)(I,J) DONE BY BLOCKS.
      l = 1
      if (nbo(2)/=0 .and. nbo(1)/=0) then
        ! TODO: GBR future modifications
        call mtxm (c(1,nbo(1)+1), nbo(2), dp, norbs, ab(l), nbo(1))
        l = l + nbo(2)*nbo(1)
      end if
      if (nbo(3)/=0 .and. nbo(1)/=0) then
        call mtxm (c(1,nopen+1), nbo(3), dp, norbs, ab(l), nbo(1))
        l = l + nbo(3)*nbo(1)
      end if
      if (nbo(3)/=0 .and. nbo(2)/=0) call mtxm (c(1,nopen+1), nbo(3), &
        dp(norbs*nbo(1)+1), norbs, ab(l), nbo(2))
!
!     PART 2 : AB = SCALE * (D * B + AB) AND RESCALE BASIS VECTOR B.
!
      ab = (diag(:minear)*b+ab)*scalar(:minear)
      b = b/scalar(:minear)
      return
      end subroutine deri22

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

  subroutine Details_of_cursor_point(unit, mouseevent, keystate, MouseXpos,MouseYpos)
    use common_common, only : line, xscale, yscale, xoffset, yoffset, &
      top_l, top_r, bottom_l
   USE IFQWIN
    INTEGER unit
    INTEGER mouseevent
    INTEGER keystate
    INTEGER MouseXpos
    INTEGER MouseYpos
    double precision :: xx, yy
    integer :: status
    xx = (MouseXpos - xoffset)/xscale 
    yy = (MouseYpos - yoffset)/yscale 
    write(line,'(a,f6.2,",",f6.2,",",f6.2,a,f6.2)') &
    "Point (", xx, yy, yy, ") Value:", xx*yy
    status = SETACTIVEQQ (6)
    write(6,*)trim(line)
   return
  end subroutine Details_of_cursor_point

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine timout(nout)
      use molkst_C, only : wall_clock_0, wall_clock_1, CPU_1, CPU_0
!
!     CONVERT THE TIME FROM SECONDS TO DAYS, HOURS, MINUTES, AND SECONDS
!
      implicit none
      integer , intent(in) :: nout
      integer :: CPU_days, CPU_hours, CPU_mins, &
        wall_clock_days, wall_clock_hours, wall_clock_mins
      double precision :: mins, days, hours, CPU_secs, wall_clock_secs, tim
      character :: day*5, hour*6, minute*8, h*1, m*1, s*1
      tim = CPU_1 - CPU_0
      days = (wall_clock_1 - wall_clock_0)/86400.0
      wall_clock_days = idint(days)
      day = " DAY "
      if (wall_clock_days > 1) day = " DAYS"
      hours = (days - dble(wall_clock_days))*24.0D0
      wall_clock_hours = idint(hours)
      hour = " HOUR "
      if (wall_clock_hours > 1) hour = " HOURS"
      mins = (hours - dble(wall_clock_hours))*60.0D0
      wall_clock_mins = idint(mins)
      minute = " MINUTE "
      if (wall_clock_mins > 1) minute = " MINUTES"
      wall_clock_secs = (mins - dble(wall_clock_mins))*60.0D0
      h = "2"
      m = "2"
      s = "6"
      if (wall_clock_hours > 9) h = "3"
      if (wall_clock_mins > 9) m = "3"
      if (wall_clock_secs > 9) s = "7"
      if (wall_clock_days > 0) then
        write (nout, "(10x, 'WALL-CLOCK TIME', 9x, '=', 9x, i2, a, i"//h//", a, i"//m//", a, ' AND',f"//s//".3, ' SECONDS')") &
        wall_clock_days, trim(day), wall_clock_hours, trim(hour), wall_clock_mins, trim(minute), wall_clock_secs
      else if (wall_clock_hours > 0) then
        write (nout, "(10x, 'WALL-CLOCK TIME', 9x, '=', 9x,  i2, a, i"//m//", a, ' AND',f"//s//".3, ' SECONDS')") &
        wall_clock_hours, trim(hour), wall_clock_mins, trim(minute), wall_clock_secs
      else if (wall_clock_mins > 0) then
         write (nout, "(10x, 'WALL-CLOCK TIME', 9x, '=', 9x, i2, a, ' AND',f"//s//".3, ' SECONDS')") &
         wall_clock_mins, trim(minute), wall_clock_secs
      else
        write (nout, "(10x, 'WALL-CLOCK TIME', 9x, '=', 5x, f6.3, ' SECONDS')") wall_clock_secs
      end if

      days = tim/86400.0
      CPU_days = idint(days)
      day = " DAY "
      if (CPU_days > 1) day = " DAYS"
      hours = (days - dble(CPU_days))*24.0D0
      CPU_hours = idint(hours)
      hour = " HOUR "
      if (CPU_hours > 1) hour = " HOURS"
      mins = (hours - dble(CPU_hours))*60.0D0
      CPU_mins = idint(mins)
      minute = " MINUTE "
      if (CPU_mins > 1) minute = " MINUTES"
      CPU_secs = (mins - dble(CPU_mins))*60.0D0
      h = "2"
      m = "2"
      s = "6"
      if (CPU_hours > 9) h = "3"
      if (CPU_mins > 9) m = "3"
      if (CPU_secs > 9) s = "7"
      if (CPU_days > 0) then
        write (nout, "(10x, 'COMPUTATION TIME', 8x, '=', 9x, i2, a, i"//h//", a, i"//m//", a, ' AND',f"//s//".3, ' SECONDS')") &
        CPU_days, trim(day), CPU_hours, trim(hour), CPU_mins, trim(minute), CPU_secs
      else if (CPU_hours > 0) then
        write (nout, "(10x, 'COMPUTATION TIME', 8x, '=', 9x,  i2, a, i"//m//", a, ' AND',f"//s//".3, ' SECONDS')") &
        CPU_hours, trim(hour), CPU_mins, trim(minute), CPU_secs
      else if (CPU_mins > 0) then
         write (nout, "(10x, 'COMPUTATION TIME', 8x, '=', 9x, i2, a, ' AND',f"//s//".3, ' SECONDS')") &
         CPU_mins, trim(minute), CPU_secs
      else
        write (nout, "(10x, 'COMPUTATION TIME', 8x, '=', 5x, f6.3, ' SECONDS')") CPU_secs
      end if
      return
      end subroutine timout

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine rapid1 (loop, xparam, numvar_loc, funct1)
!
!
    use param_global_C, only : ifiles_8, parab, contrl, nfns, error, &
    factor, maxpms
    integer, intent (inout) :: numvar_loc
    integer, intent (in) :: loop
    double precision, dimension (numvar_loc), intent (inout) :: xparam
    double precision, intent (out) :: funct1
    double precision, external :: reada
 !-------------------------------------------------------------------------
    logical :: first = .true., fix_parab
    logical :: okc, okf, reset, first_print
    integer :: i, ihdim, ii, ik, iloop, j, jnrst, k, lnstop
    double precision :: alpha, bsmvf, cncadd, Cos, cosine_loc, del, dell, &
   & dott, funct, funct2, ggd, ggggg, gnorm_loc, pmstep, pnlast, pnorm, &
   & renorm, rootv, rst, s, smval, startf, startg, sy, y, yhy
    double precision, dimension (:), allocatable :: hesinv
    double precision, dimension (maxpms) :: gg
    double precision, dimension (maxpms) :: glast
    double precision, dimension (maxpms) :: gd, grad, pvect, xd
    double precision, dimension (maxpms) :: xlast
    double precision, dimension (maxpms) :: xold
    external finish
    double precision, external :: dot
    intrinsic Abs, Max, Min, Sign, Sqrt
    save :: first, fix_parab, del, dell, rootv, rst
    data xlast / maxpms * 0.d0 /
    data glast / maxpms * 0.d0 /
!--------------------------------------------------------------------------
    ggd = 0.d0
    if (first) then
      do i = 1, numvar_loc
        xold(i) = 1.d0
      end do
      first = .false.
      parab = 10000.d0
      i = Index(contrl," PARAB=")
      if(i /= 0)then
      parab = Reada(contrl,i)
      fix_parab = .true.
      else
      fix_parab = .false.
      end if
    !
    !   THE FOLLOWING CONSTANTS SHOULD BE SET BY THE USER.
    !
      rst = 0.05d0
      dell = 0.0000001d0
      del = dell
    !
    !    THESE CONSTANTS SHOULD BE SET BY THE PROGRAM.
    !
      rootv = Sqrt (numvar_loc+1.d-5)
    end if
  !
  !     AND FINALLY, THE FOLLOWING CONSTANTS ARE CALCULATED.
  !
    ihdim = (numvar_loc*(numvar_loc+1)) / 2
    allocate (hesinv(ihdim))
    cncadd = Min (1.0d00/rootv, 0.15d0)
  !
  !     FIRST, WE INITIALISE THE VARIABLES.
  !
    lnstop = 1
    alpha = 0.01d00
    pnorm = .10d00
    jnrst = 0
    Cos = 0.0d00
    iloop = 0
    first_print = .true.
  !
  ! CALCULATE THE VALUE OF THE FUNCTION -> FUNCT1, AND GRADIENTS -> GRAD.
  ! NORMAL SET-UP OF FUNCT1 AND GRAD, DONE ONCE ONLY.
  !
    call rapid2 (xparam, funct1, grad, .true.)
    startg = Sqrt (dot(grad, grad, numvar_loc))
    if (startg >= 1.0d-4) then
      startf = funct1
      do i = 1, numvar_loc
        gd(i) = grad(i)
      end do
    !     *
    !     START OF EACH ITERATION CYCLE ...
    !     *
    !
      reset = .false.
      do
        gnorm_loc = Sqrt (dot(grad, grad, numvar_loc))
        jnrst = jnrst + 1
        if (lnstop /= 1 .and. Cos > rst .and. jnrst < 30) then
        !
        !     *
        !     UPDATE VARIABLE-METRIC MATRIX
        !     *
        !
          sy = 0.0d00
          yhy = 0.0d00
          do i = 1, numvar_loc
            s = 0.0d00
            do k = 1, numvar_loc
              ik = i + numvar_loc * (k-1) - ((k*(k-1))/2)
              if (k > i) then
                ik = k + numvar_loc * (i-1) - ((i*(i-1))/2)
              end if
              s = s + hesinv(ik) * (grad(k)-glast(k))
            end do
            gg(i) = s
            y = grad(i) - glast(i)
            yhy = yhy + gg(i) * y
            sy = sy + (xparam(i)-xlast(i)) * y
          end do
          if (abs(sy) > 1.d-10 .and. abs(yhy) > 1.d-10) then
          do i = 1, numvar_loc
            y = xparam(i) - xlast(i)
            do k = i, numvar_loc
              ik = k + numvar_loc * (i-1) - ((i*(i-1))/2)
              hesinv(ik) = hesinv(ik) + y * (xparam(k)-xlast(k)) / sy - gg &
             & (i) * gg(k) / yhy
            end do
          end do
          end if
        else
          reset = .true.
          do i = 1, numvar_loc
            xd(i) = xparam(i) - Sign (del, grad(i))
          end do
        !
        ! THIS CALL OF COMPFG IS USED TO CALCULATE THE SECOND-ORDER MATRIX IN H
        ! IF THE NEW POINT HAPPENS TO IMPROVE THE RESULT, THEN IT IS KEPT.
        ! OTHERWISE IT IS SCRAPPED, BUT STILL THE SECOND-ORDER MATRIX IS O.K.
        !
          call rapid2 (xd, funct2, gd, .true.)
          do i = 1, ihdim
            hesinv(i) = 0.0d00
          end do
          do i = 1, numvar_loc
            ii = i + numvar_loc * (i-1) - ((i*(i-1))/2)
            ggggg = grad(i) - gd(i)
            if (Abs (ggggg) >= 1.d-12) then
              ggd = Abs (grad(i))
              if (funct2 < funct1) then
                ggd = Abs (gd(i))
              end if
              hesinv(ii) = Sign (del, grad(i)) / ggggg
              if (hesinv(ii) >= 0.0d00 .or. ggd >= 1.d-12) then
                if (hesinv(ii) < 0.0d00) then
                  hesinv(ii) = 6.d0 * del / ggd
                end if
                go to 1000
              end if
            end if
            hesinv(ii) = 0.01d00
1000        if (ggd < 1.d-12) then
              ggd = 1.d-12
            end if
            pmstep = Abs (0.1d0/ggd)
            if (hesinv(ii) > pmstep) then
              hesinv(ii) = pmstep
            end if
          end do
          jnrst = 0
          if (funct2 < funct1) then
            funct1 = funct2
            gnorm_loc = 0.0d00
            do i = 1, numvar_loc
              xparam(i) = xd(i)
              grad(i) = gd(i)
              gnorm_loc = gnorm_loc + grad(i) ** 2
            end do
            gnorm_loc = Sqrt (gnorm_loc)
          end if
        end if
        do
        !
        !     *
        !     ESTABLISH NEW SEARCH DIRECTION
        !     *
          pnlast = pnorm
          pnorm = 0.0d00
          dott = 0.0d00
          do k = 1, numvar_loc
            s = 0.0d00
            do i = 1, numvar_loc
              ik = i + numvar_loc * (k-1) - ((k*(k-1))/2)
              if (k > i) then
                ik = k + numvar_loc * (i-1) - ((i*(i-1))/2)
              end if
              s = s - hesinv(ik) * grad(i)
            end do
            pvect(k) = s
            pnorm = pnorm + pvect(k) ** 2
            dott = dott + pvect(k) * grad(k)
          end do
          pnorm = Sqrt (pnorm)
          Cos = -dott / (pnorm*gnorm_loc)
          if (jnrst == 0) exit
          if (Cos > cncadd) then
            if (Cos > rst) then
              i = 0
              exit
            end if
          end if
          pnorm = pnlast
          reset = .true.
          do i = 1, numvar_loc
            xd(i) = xparam(i) - Sign (del, grad(i))
          end do
        !
        ! THIS CALL OF COMPFG IS USED TO CALCULATE THE SECOND-ORDER MATRIX IN H
        ! IF THE NEW POINT HAPPENS TO IMPROVE THE RESULT, THEN IT IS KEPT.
        ! OTHERWISE IT IS SCRAPPED, BUT STILL THE SECOND-ORDER MATRIX IS O.K.
        !
          call rapid2 (xd, funct2, gd, .true.)
          do i = 1, ihdim
            hesinv(i) = 0.0d00
          end do
          do i = 1, numvar_loc
            ii = i + numvar_loc * (i-1) - ((i*(i-1))/2)
            ggggg = grad(i) - gd(i)
            if (Abs (ggggg) >= 1.d-12) then
              ggd = Abs (grad(i))
              if (funct2 < funct1) then
                ggd = Abs (gd(i))
              end if
              hesinv(ii) = Sign (del, grad(i)) / ggggg
              if (hesinv(ii) >= 0.0d00 .or. ggd >= 1.d-12) then
                if (hesinv(ii) < 0.0d00) then
                  hesinv(ii) = 6.d0 * del / ggd
                end if
                go to 1100
              end if
            end if
            hesinv(ii) = 0.01d00
1100        if (ggd < 1.d-12) then
              ggd = 1.d-12
            end if
            pmstep = Abs (0.1d0/ggd)
            if (hesinv(ii) > pmstep) then
              hesinv(ii) = pmstep
            end if
          end do
          jnrst = 0
          if (funct2 < funct1) then
            funct1 = funct2
            gnorm_loc = 0.0d00
            do i = 1, numvar_loc
              xparam(i) = xd(i)
              grad(i) = gd(i)
              gnorm_loc = gnorm_loc + grad(i) ** 2
            end do
            gnorm_loc = Sqrt (gnorm_loc)
          end if
        end do
        lnstop = 0
        alpha = alpha * pnlast / pnorm
        do i = 1, numvar_loc
          glast(i) = grad(i)
          xlast(i) = xparam(i)
        end do
        if (jnrst == 0) then
          alpha = 0.1d00
        end if
        iloop = iloop + 1
     !   if (Abs (smval-funct1) < 1.d-5) exit
        if (Mod(iloop,200) == 0) then
          if (first_print) then
            write(ifiles_8,*)" Mini-cycle  Error Function  Gradient"
            write(ifiles_8,'(i7,f16.2, f14.2)')0,startf,startg
             first_print = .false.
          end if
          write(ifiles_8,'(i7,f16.2, f14.2)')iloop,funct1,gnorm_loc
          endfile (ifiles_8)
          backspace (ifiles_8)
        end if
        if (jnrst /= 0 .and. gnorm_loc < 0.01d0*startg .or. iloop > 2000) then
          i = 0
          exit
        end if
        smval = funct1
        call rapid3 (xparam, alpha, pvect, numvar_loc, funct1, okf, okc)
      !   WE WANT ACCURATE DERIVATIVES AT THIS POINT
      !
      !   RAPID3 DOES NOT GENERATE ANY DERIVATIVES, THEREFORE RAPID2 MUST BE
      !   CALLED TO END THE SEARCH
      !
        if (reset) then
          do j = 1, numvar_loc
            grad(j) = 0.d0
          end do
          reset = .false.
        end if
        call rapid2 (xparam, funct1, grad, .true.)
        if (numvar_loc == 1) then
          gnorm_loc = Abs(grad(1))
          i = 0
          exit
        end if
        bsmvf = Abs (smval-funct1)
        if (bsmvf > 10.d00) then
          Cos = 0.0d00
        end if
        del = 0.0000002d00
        if (bsmvf > 1.0d00) then
          del = dell / 2.0d00
        end if
      !
      ! END OF ITERATION LOOP, EVERYTHING IS STILL O.K. SO GO TO
      ! NEXT CYCLE OF OPTIMIZATION.
      !
        if (bsmvf > 5.0d00) then
          del = dell
        end if
        if (Cos < rst) then
          do i = 1, numvar_loc
            gd(i) = 0.5d0
          end do
        end if
      end do
    !
    !   RAPID1 IS ENDING PROPERLY. THIS IS IMMEDIATELY BEFORE THE RETURN.
    !
      call rapid2 (xparam, funct, grad, .false.)
      do i = 1, numvar_loc
        funct = funct - xparam(i) ** 2 * parab
      end do
    !
    !  Alter damping factor using the cosine of the step with the old step
    !
      renorm = Sqrt (dot(xparam, xparam, numvar_loc)*dot(xold, xold, numvar_loc))
      cosine_loc = dot (xparam, xold, numvar_loc) / renorm
      do i = 1, numvar_loc
        xold(i) = xparam(i)
      end do
!
!  Set factor to 1.d0 in order to calculate "raw" ssq and grad.
!
      error(1:nfns) = factor(1:nfns)
      factor(1:nfns) = 1.d0
      pvect = 0.d0
      call rapid2(pvect, startf, grad,.true.)
  !    startg = Sqrt(dot(grad,grad,numvar_loc))
      call rapid2(xparam, funct, grad, .false.)
  !    write(ifiles_8,'(5f12.6)')xparam(1:5),grad(1:5)
      factor(1:nfns) = error(1:nfns)
   !   gnorm_loc = Sqrt(dot(grad,grad,numvar_loc))
      if(.not. fix_parab) then
      if (cosine_loc > 0.6d0) then
        parab = Max (parab/1.3d0, -10.d0)
      else
        parab = Min (Max(10.d0,parab*1.3d0), 5000000.d0)
      end if
      end if
      write (ifiles_8, "(i4,A,F12.5,A,F17.5,a,i4)") loop, " COSINE ", cosine_loc, " PARAB", &
     & parab, " CYCLES:", iloop
      write (ifiles_8, "(I4,A,2F14.2,A,2F15.1)") loop, " START SSQ:", &
     & startf, funct, "   GRAD:", startg, gnorm_loc
     if(startg < 5.d-1) then
       write(ifiles_8,*) "Optimization Successful"
       call finish
     end if
      if (startf-funct >=1.d-1) return
    else
    write(ifiles_8,*) "Optimization Successful"
    call finish
    end if
end subroutine rapid1

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine atomrs (lused, ioptl, ires, n1, io, uni_res, first_res)
    use molkst_C, only: natoms, numat, line, keywrd, ncomments, numat_old
    use chanel_C, only: iw, log, ilog
    use MOZYME_C, only: nbackb, jatom, iatom, k, loop, mxeno, txeno, &
       & nxeno,  allres, maxres,  ions, res_start, &
       tyres, size_mres, odd_h, atomname, afn, n_add
    use common_arrays_C, only : txtatm, nat, ibonds, nbonds, coord, all_comments, coorda, &
      txtatm1
    use elemts_C, only: elemnt, atom_names, cap_elemnt
    use funcon_C, only : pi
    implicit none
    integer, intent (in) :: io, n1, uni_res
    integer, intent (inout) :: ires
    logical, dimension (numat), intent (inout) :: ioptl
    integer, dimension (natoms), intent (inout) :: lused
    logical, intent (in) :: first_res
    integer, parameter :: natomr = 10000
!
    integer :: i2
    integer :: i, i3, ico, ihcr, j, j2, j3, j4, j5, j6, j7, OXT, live(500), &
      j8, j9, j10, jofco, l, ninres, nlive, nh, jj3, extra_atoms(2), once(5), n_once = 0
      double precision :: sum
    character (len=3) :: loc_tyres, tmp
    integer, dimension (natomr) :: inres
    integer, dimension (natomr) :: npack
    integer, dimension (5, size_mres) :: mres
    logical :: okay, found(14), UNK
    intrinsic Abs, Max
    logical, external :: peptide_n
    save :: once, n_once
    data inres / natomr * 0 /
! No. of        C  N  O  S  H    C  N  O  S  H     C  N  O  S  H
    data mres / 2, 1, 1, 0, 3,   3, 1, 1, 0, 5,    5, 1, 1, 0, 9, & !  GLY ALA VAL
                6, 1, 1, 0,11,   6, 1, 1, 0,11,    3, 1, 2, 0, 5, & !  LEU ILE SER
                4, 1, 2, 0, 7,   4, 1, 3, 0, 5,    4, 2, 2, 0, 6, & !  THR ASP ASN
                6, 2, 1, 0,13,   5, 1, 3, 0, 7,    5, 2, 2, 0, 8, & !  LYS GLU GLN
                6, 4, 1, 0,13,   6, 3, 1, 0, 7,    9, 1, 1, 0, 9, & !  ARG HIS PHE
                3, 1, 1, 1, 5,  11, 2, 1, 0,10,    9, 1, 2, 0, 9, & !  CYS TRP TYR
                5, 1, 1, 1, 9,   6, 2, 1, 0, 7,    5, 1, 2, 0, 9, & !  MET PRO PRO
                5, 1, 2, 0, 9,   0, 0, 0, 0, 0/                     !  PRO
    ninres = 0
   !             NBACKB(1) =  Carbon CHR  of N-CHR-CO-N'
   !             NBACKB(2) =  Carbon CO   of N-CHR-CO-N'
   !             NBACKB(3) =  Oxygen CO   of N-CHR-CO-N'
   !             NBACKB(4) =  Nitrogen N' of N-CHR-CO-N'
    ihcr = nbackb(1)
    ico = nbackb(2)
    jofco = nbackb(3)
    jatom = nbackb(4)
   !
   !   Starting with the nitrogen, work out the atoms in the residue.
   !
    nlive = nbonds(iatom)
    j3 = 0
    j4 = 0
    extra_atoms = 0
    do i2 = 1, nlive
      j2 = ibonds(i2, iatom)
      if (nat(j2) == 1 .or. j2 == ihcr) then
 !
 ! Select atoms that are definitely in the residue
 !
        j3 = j3 + 1
        live(j3) = j2
      else
 !
 ! Store list of atoms that are probably not in the residue. (Think of proline)
 !
        sum = 0.d0
        do i = 1, nlive
          if (nat(ibonds(i,iatom)) == 1) then
            do j = 1, nbonds(j2)
              if (nat(ibonds(j,j2)) == 8) then
!
!  Found a H-N-C-O sequence.  Check torsion angle
!
                call dihed (coord, ibonds(i,iatom), iatom, j2, ibonds(j,j2), sum)
              end if
            end do
          end if
        end do
        if (sum < pi*0.5d0 .and. sum > -pi*0.5d0) then
          j4 = min(2, j4 + 1)
          extra_atoms(j4) = j2
        end if
      end if
    end do
    nlive = j3
    outer_loop: do
      l = live(1)
      if (l == 0) go to 1100
      if (l == jatom .or. ioptl(l) .or. l == iatom .or. peptide_n(l)) then
         !
         !   Atom L is either already known to be in the residue, or is known
         !   to not be in the residue.
         !
        if (nlive == 0) go to 1100
        live(1) = live(nlive)
        nlive = nlive - 1
      else
        ioptl(l) = .true.
        ninres = ninres + 1
        if (ninres > natomr) then
          write (iw, "(A,I4,A,I4)") " There are more than", natomr, &
         & " atoms in residue", ires
          write (iw,*) " Atoms in residue", ires
          write (iw, "(10(1X,A2,I5))") (elemnt(nat(inres(l))), &
               & inres(l), l=1, natomr)
          if (Index (keywrd, " ADD-H") /= 0)  &
            write(iw,'(/10x,a)')"(To avoid this error, add keyword ""NORESEQ"" and re-run.)"
          call mopend ("Too many atoms in residue")
          go to 1000
        else
            !
            !  Assign atom L to the residue.
            !
          inres(ninres) = l
          if (nbonds(l) /= 0) then
               !
               !  THERE IS AT LEAST ONE ATOM ATTACHED TO THE 'LIVE' ATOM
               !
            loop1: do i2 = 2, nbonds(l)
              j = ibonds(i2, l)
              do i3 = 1, nlive
                if (live(i3) == j) cycle loop1
              end do
              nlive = nlive + 1
                  !
                  !   Panic if number of live atoms is greater than 500
                  !
              if (nlive > 500) exit outer_loop
              live(nlive) = j
            end do loop1
            live(1) = ibonds(1, l)
          else
            if (nlive == 0) go to 1100
            live(1) = live(nlive)
            nlive = nlive - 1
          end if
        end if
      end if
    end do outer_loop
    write (iw, "(10x,A,I4,A)") " Number of live atoms in residue", ires, &
                         & " greater than 500"
    do i = 1, numat
      if (index(txtatm(i), "UNK") > 0) exit
    end do
    if (i > 1 .and. i <= numat) &
      write(iw,'(/10x,a)')"The fault is probably after atom:  """//trim(txtatm(i - 1))//""""
    if (txtatm1(jatom) /= " ") then
      write(iw,'(/10x,a,a)')"The fault is probably before atom: """//trim(txtatm1(jatom))//""""
    else
      write(iw,'(/10x,a, i5)')"The fault is probably before atom: "//elemnt(nat(jatom)), jatom
    end if
    call mopend ("More than 500 atoms in residue")
1000 if (nat(io) == 8) then
      write (iw, "(10X,A,I5,A,3(/10X,A))") "Oxygen atom", io, &
     & " was incorrectly assumed to be in the backbone ", &
     & "of a residue.  To correct the fault, please move this atom", &
     & "to the end of the data set."
     end if
     if (Index (keywrd, " ADD-H") /= 0)  &
       write(iw,'(/10x,a)')"(To avoid this error, add keyword ""NORESEQ"" and re-run.)"
    return
   !
   !   Check that atoms are not counted twice
   !
1100 do j = 1, ninres
      do k = j + 1, ninres
        if (inres(j) == inres(k)) then
          inres(j) = 0
        end if
      end do
    end do
    npack(:) = 0
!
!  If the starting atom of the residue was a nitrogen, then count it
!
    if (nat(iatom) == 7) npack(7) = 1
    jj3 = 0
    do i2 = 1, ninres
      if (inres(i2) /= 0) then
        j2 = inres(i2)
!
!  Test for strange atoms
!
        do j4 = 1, nbonds(j2)
          j5 = nat(ibonds(j4,j2))
          select case (j5)
          case (1,6:8,16)
          case default
            jj3 = j5
          end select
        end do
        npack(nat(j2)) = npack(nat(j2)) + 1
      end if
      lused(inres(i2)) = ires
    end do
    lused(iatom) = -ires
    lused(ihcr) = -ires
    if (ico >0) lused(ico) = -ires
    if (jofco /= 0) then
      lused(jofco) = -ires
    end if
   !
   !   Determine the residue name (it must be one of the 21 amino acids,
   !   or an amino acid plus something attached.
   !
   OXT = 0
   if (ico > 0) then
!
!  Check for terminal -COOH  If present, delete one oxygen from formula count.
!
      k = 0
      i2 = 0
      j3 = 0
      j4 = 0
      do j = 1, nbonds(ico)
        j2 = ibonds(j,ico)
        if (nat(j2) == 8) then
          k = k + 1
          if (nbonds(j2) == 2) i2 = j2
          if (nbonds(j2) == 1) j3 = j3 + 1
          j4 = j2
        end if
      end do
      if (j3 == 2) i2 = j4
    end if
    if (k == 2) then
      OXT = i2
      npack(8) = npack(8) - 1
    else
      OXT = 0
    end if
    nh = npack(1)  !  Store number of hydrogen atoms in the residue
    k = 0
    loc_tyres = " "
    if (jj3 == 34) then
!
!  Convert Se into selenomethionine
!
      npack(16) = npack(16) + 1
    end if
    if (jj3 == 0 .or. jj3 == 34) then
      do loop = 1, mxeno
        npack(1) = npack(6) - nxeno(1, loop)
        npack(2) = npack(7) - nxeno(2, loop)
        npack(3) = npack(8) - nxeno(3, loop)
        npack(4) = npack(16) - nxeno(4, loop)
        if (iatom == jatom .and. ico > 0) then
!
!  Terminal group.  Check for -COOH
!
          j = 0
          do i = 1, nbonds(ico)
            if (nat(ibonds(i,ico)) == 8) j = j + 1
          end do
          if (j == 2) npack(3) = Max (0, npack(3)-1)
        end if
        loop2: do j = 1, size_mres - 1
          do k = 1, 4
            if (npack(k) /= mres(k, j)) cycle loop2
          end do
          if (j == 21 .or. j == 22) then
!
!  Check for hydroxyproline
!
            j2 = 0
            do j3 = 1, nbonds(ico)
              if (nat(ibonds(j3,ico)) == 8) j2 = j2 + 1
            end do
            if (j2 /= 2) cycle loop2
          end if
          if (j == 3) then
  !
  !  Check that the side chain involves isopropyl.  If so, it's valine
  !
  !
            j4 = 0
            do k = 1, nbonds(ihcr)
              l = 0
              j2 = ibonds(k,ihcr)
              if (nat(j2) == 6) then
                do j3 = 1, nbonds(j2)
                  if (nat(ibonds(j3,j2)) == 6) l = l + 1
                end do
              end if
              j4 = max(j4,l)
            end do
            if (j4 == 2) then
  !
  ! No, it's not valine.  Check for terminal proline
  !
              okay = .false.
              proline_check: do k = 1, nbonds(ihcr)
                if (nat(ibonds(k,ihcr)) == 7) then
  !
  ! Found the nitrogen
  !
                  j2 = ibonds(k,ihcr)
                  do j3 = 1, nbonds(j2)
                    if (nat(ibonds(j3,j2)) == 6 .and. ibonds(j3,j2) /= ihcr ) then
  !
  ! Found a C attached to N, and the C is not the C of -CHR-
  !
                      j4 = ibonds(j3,j2)
                      do j5 = 1,nbonds(j4)
                        if (nat(ibonds(j5,j4)) == 6) then
                          j6 = ibonds(j5,j4)
                          do j7 = 1, nbonds(j6)
                            if (nat(ibonds(j7,j6)) == 6) then
  !
  ! Found the C of N-C-C
  !
                              j8 = ibonds(j7,j6)
                              do j9 = 1, nbonds(j8)
                                do j10 = 1, nbonds(ihcr)
                                  if (ibonds(j9,j8) == ibonds(j10,ihcr)) then
                                    okay = .true.
                                    exit proline_check
                                  end if
                                end do
                              end do
                            end if
                          end do
                        end if
                      end do
                    end if
                  end do
                end if
              end do proline_check
              if (okay) then
                k = 20
              else
                cycle loop2
              end if
            end if
          end if
          k = j
          go to 1200
        end do loop2
        j = 0
        if (iatom == jatom) then
           !
           !   SPECIAL CASE:  THE -COOH END OF THE PROTEIN IS ONLY -C=O
           !
          if (npack(3) /= 0) then
            k = 1
            npack(3) = npack(3) + 1
          end if
        else if (jatom == 0) then
           !
           !   SPECIAL CASE:  SINGLE AMINO ACID, THEREFORE MAKE END -COO
           !
          k = 1
          npack(3) = npack(3) - 1
        end if
        if (k /= 0) then
           !
           !   CHECK ALL SPECIAL CASES
           !
          loop3: do k = 1, size_mres - 1
            do j = 1, 4
              if (npack(j) /= mres(j, k)) cycle loop3
            end do
            if (k == 21 .or. k == 22) then
!
!  Check for hydroxyproline
!
              j2 = 0
              do j3 = 1, nbonds(ico)
                if (nat(ibonds(j3,ico)) == 8) j2 = j2 + 1
              end do
              if (j2 /= 2) then
                loc_tyres = "HYP"
                cycle loop3
              end if
            end if
            if (k == 3) then
              j4 = 0
              do j = 1, nbonds(ihcr)
                l = 0
                j2 = ibonds(j,ihcr)
                do j3 = 1, nbonds(j2)
                  if (nat(ibonds(j3,j2)) == 6) l = l + 1
                end do
                j4 = max(j4,l)
              end do
              if (j4 /= 3) cycle loop3
            end if
            go to 1200
          end do loop3
        end if
      end do
    else
      do j = 1, 10
        if (atom_names(jj3)(j:j) /= " ") exit
      end do
      do j6 = 1, numat
        if (abs(coord(1,ihcr) - coorda(1,j6)) < 0.0005d0) then
          if (abs(coord(2,ihcr) - coorda(2,j6)) < 0.0005d0) then
            if (abs(coord(3,ihcr) - coorda(3,j6)) < 0.0005d0) exit
          end if
        end if
      end do
      do j7 = 1, n_once
        if (once(j7) == j6) exit
      end do
      if (j7 > n_once) then
        n_once = j7
        once(n_once) = j6
        write(iw,"(a,a,a)")"         Residue: '",txtatm1(j6)(18:), &
          "' contains "//atom_names(jj3)(j:)//" so identification not done"
      end if
      loop = 1
      goto 1200
    end if
    if (npack (6) == 0 .and. npack (7) == 1 .and. npack (8) == 0 .and. npack (16) == 0) then
      ioptl(jatom) = .true.
      ires = ires - 1
      return
    end if
1200 if (k == 0) then
       k = size_mres
     end if
     if (k == 4) then
      !
      !   RESIDUE IS EITHER LEU OR ILE.  TO DISTINGUISH BETWEEN THEM,
      !   CHECK THE NUMBER OF CARBON ATOMS ATTACHED TO THE CARBON
      !   OF THE SIDE-CHAIN.  IF IT IS 3 THEN ILE, ELSE LEU.
      !
      do i2 = 1, nbonds(iatom)
        j = ibonds(i2, iatom)
         !
         !  IS ATOM ATTACHED TO NITROGEN A CARBON?
         !
        if (nat(j) == 6) then
          loop4: do j2 = 1, nbonds(j)
            j3 = ibonds(j2, j)
               !
               !  IS THE ATOM ATTACHED TO THE CARBON THAT IS ATTACHED
               ! TO THE NITROGEN A CARBON?
               !
            if (nat(j3) == 6) then
              l = 0
              do j4 = 1, nbonds(j3)
                j5 = ibonds(j4, j3)
                     !
                     !  ARE ALL THE ATTACHED ATOMS, CARBON ATOMS?
                     !
                if (nat(j5) == 6) then
                  l = l + 1
                end if
                if (nat(j5) /= 1 .and. nat(j5) /= 6) cycle loop4
              end do
              if (l == 3) then
                k = 5
              end if
            end if
          end do loop4
        end if
      end do
    else if (k == 3) then
      !
      !    RESIDUE IS EITHER VAL OR PRO
      !
      !
      !  Check for both start of chain and (middle or end) of chain
      !
      l = 0
      do j = 1, nbonds(iatom)
        if (nat(ibonds(j, iatom)) /= 1) then
          l = l + 1
        end if
      end do
      if (l == 3 .and. iatom /= n1 .or. l == 2 .and. iatom == n1) then
        k = 20
      end if
    end if
    if (nat(n1) == 1) then  !  If the starting nitrogen atom is in fact a hydrogen,
      ninres = ninres + 1   !  then add it to the atoms in the residue.
      inres(ninres) = n1
    end if
    if (loc_tyres == " ") loc_tyres = tyres(k)
    if (k == 19 .and. jj3 == 34) then
      loc_tyres = "MSE"
    end if
    if (k == 23) then
      okay = .false.
      if (npack(6) == 2 .and. npack(7) == 0 .and. npack(8) == 1 .and. npack(16) == 0) then
        loc_tyres = "ACE"
        line = "Acetyl group"
        okay = .true.
      end if
      if (npack(6) == 1 .and. npack(7) == 1 .and. npack(8) == 0 .and. npack(16) == 0) then
        loc_tyres = "CH3"
        line = "Methyl group"
        okay = .true.
      end if
      if (okay .and. index(keywrd," RESID") /= 0) then
        ncomments = ncomments + 1
        write(all_comments(ncomments),'(a,i5)') &
               "*REMARK   2   "//loc_tyres//" = "//line(:47)//"res: ", ires
      end if
    end if
    if (len_trim(txeno(loop)) == 3) loc_tyres = txeno(loop)(:3)
    do j = 1, ninres
      l = inres(j)
      if (l /= 0) then
        write (txtatm(l), "(a,i6,1x,a3,a5,i6)")"ATOM ", l, cap_elemnt(nat(l)), loc_tyres, ires
      end if
    end do
    res_start(uni_res) = iatom
    call greek (jatom)
    if (k == 20) then            !  Check that N of proline is present
      do i = 1, ninres            !  If it is, and the nitrogen is in the
        if (inres(i) == jatom) exit    !  residue, remove the label
      end do
      if (i == ninres + 1 .and. jatom > 0) then
        txtatm(jatom) = " "
      end if
    end if
    if (txtatm(iatom)(:15) /= " ") then
      allres (ires) = loc_tyres // " "
      return
    end if
    if (ires == 1 .and.  txtatm(ihcr)(18:20) == "PRO") then
      write(txtatm(n1), "(I6,1X,A3, i4)") n1, "PRO", 1  ! Label N of proline in
    end if
    if (OXT /= 0) txtatm(OXT)(15:16) = "XT"
!
!  Run a check to make sure that all atoms are properly labeled.
!  If they are not properly labeled, re-label them as "unknown"
!
    do j2 = 1, 20
      if (afn(j2) == txtatm(inres(1))(18:20)) exit
    end do
    found = .false.
    UNK = .false.
    if (j2 < 21) then
      do i = 1, ninres
        l = inres(i)
        line = elemnt(nat(l))//txtatm(l)(15:15)//txtatm(l)(16:16)
        do j = 1, n_add(j2)
          if (line(:4) == atomname(j2,j)) found(j) = .true.
        end do
      end do
      do i = 5, n_add(j2)
        if (.not. found(i)) exit
      end do
!
!  Check iatom to make sure it's a backbone nitrogen
!
      if (j2 /= 8) then
        l = 0
        do j = 1, nbonds(iatom)
          if (nat(ibonds(j, iatom)) > 1) l = l + 1
        end do
        if (l > 2) i = 0
      end if
      if (i .le. n_add(j2)) then
        loc_tyres = "UNK"
        do i = 1, ninres
          txtatm(inres(i))(18:20) = loc_tyres
        end do
        UNK = .true.
      end if
    end if
    if (extra_atoms(1) > 0) then
!
! Assign labels to atoms that are associated with this residue, but call them "UNK"
!
      live(:2) = extra_atoms(:2)
      nlive = 1
      if (live(2) /= 0) nlive = 2
      ninres = 0
      outer_loop_extra: do
        l = live(1)
        if (l == jatom .or. ioptl(l) .or. l == iatom) then
           !
           !   Atom L is either already known to be in the residue, or is known
           !   to not be in the residue.
           !
          if (nlive == 0) go to 1101
          live(1) = live(nlive)
          nlive = nlive - 1
        else
          ioptl(l) = .true.
          ninres = ninres + 1
          if (ninres > natomr) then
            write (iw, "(A,I4,A,I4)") " There are more than", natomr, &
           & " atoms in residue", ires
            write (iw,*) " Atoms in residue", ires
            write (iw, "(10(1X,A2,I5))") (elemnt(nat(inres(l))), &
                 & inres(l), l=1, natomr)
            write(iw,'(/10x,a,/)')" Atoms recognized"
            do i = 1, numat
              if (txtatm(i) /= " ") write(iw,'(a)')txtatm(i)
            end do
            write(iw,'(/10x,a)')"(The fault is probably near the end of the list of recognized atoms)"
            call mopend ("Too many atoms in residue")
            go to 1000
          else
              !
              !  Assign atom L to the residue.
              !
            inres(ninres) = l
            if (nbonds(l) /= 0) then
                 !
                 !  THERE IS AT LEAST ONE ATOM ATTACHED TO THE 'LIVE' ATOM
                 !
              loop1_extra: do i2 = 2, nbonds(l)
                j = ibonds(i2, l)
                do i3 = 1, nlive
                  if (live(i3) == j) cycle loop1_extra
                end do
                nlive = nlive + 1
                    !
                    !   Panic if number of live atoms is greater than 500
                    !
                if (nlive > 500) exit outer_loop_extra
                live(nlive) = j
              end do loop1_extra
              live(1) = ibonds(1, l)
            else
              if (nlive == 0) go to 1101
              live(1) = live(nlive)
              nlive = nlive - 1
            end if
          end if
        end if
      end do outer_loop_extra
1101  continue
      tmp = "UNK"
      npack = 0
      do j = 1, ninres
        npack(nat(inres(j))) = npack(nat(inres(j))) + 1
      end do
      okay = .false.
      select case (npack(6))
      case(1)
        if (npack(7) == 1 .and. npack(8) == 0 .and. npack(16) == 0) then
          tmp = "CH3"
          line = "Methyl group"
          okay = .true.
        end if
      case(2)
        if (npack(7) == 0 .and. npack(8) == 1 .and. npack(16) == 0) then
          tmp = "ACE"
          line = "Acetyl group"
          okay = .true.
        end if
      case(4)
        if (npack(7) == 0 .and. npack(8) == 0 .and. npack(16) == 0) then
          tmp = "TBU"
          line = "Tertiary butyl group"
          okay = .true.
        end if
      end select
      if (okay .and. index(keywrd," RESID") /= 0) then
        ncomments = ncomments + 1
        write(all_comments(ncomments),'(a,i5)')  &
               "*REMARK   2   "//tmp//" = "//line(:47)//"res: ", ires
        do j = 1, ninres
          l = inres(j)
          if (l /= 0) then
            write (txtatm(l), "(a,i6,1x,a3,a5,i6)")"ATOM ", l, cap_elemnt(nat(l)), tmp, ires
          end if
        end do
      else
        do j = 1, ninres
          l = inres(j)
          if (l /= 0) then
            write (txtatm(l), "(a,i6,1x,a3,a5,i6)")"ATOM ", l, cap_elemnt(nat(l)), tmp, ires
          end if
        end do
      end if
    end if
    write (txtatm(iatom), "(a,i6,1x,a3,a5,i6)")"ATOM ", iatom, cap_elemnt(nat(iatom)), loc_tyres, ires
    if (index(keywrd, " ADD-H") /= 0) return
!
! residue 1 "by hand"
!
    i = Abs(mres(5,k) - nh)
    if (ico /= 0 .and. .not. UNK .and. i > 1 .and. .not. first_res .and. loop == 1) then
      if (nbonds(ico) /= 4 .or. nbonds(jofco) /= 2 .or. i /= 3) then  ! Exclude end group being -CH2OH instead of -COOH
        if(odd_h .and. k /= size_mres) then
          odd_h = .false.
          write(line,"(a, a)")"         Residues where the number of hydrogen", &
                       " atoms is not equal to that expected"
          write(iw,'(/,a,/)')trim(line)
          if (log) write(ilog,'(/,a,/)')trim(line)
          write(line,"(15x, a)")"Atom label              Coordinates of atom ""N""   No. of extra hydrogen atoms"
          write(iw,'(a,/)')trim(line)
          if (log) write(ilog,'(a)')trim(line)
        end if
        if (k /= size_mres) then
          do j = 1, numat_old
            if (abs(coord(1,iatom) - coorda(1,j)) > 0.1d0) cycle
            if (abs(coord(2,iatom) - coorda(2,j)) > 0.1d0) cycle
            if (abs(coord(3,iatom) - coorda(3,j)) > 0.1d0) cycle
            exit
          end do
          line = "          "//loc_tyres
          if (txtatm1(j) /= " ") line = txtatm1(j)
          write(line,"(6x, a, 4x, 3F8.3, i16)")'"'//line(:27)//'"', coord(:,iatom), nh - mres(5,k)
          write(iw,'(a)')trim(line)
          if (log) write(ilog,'(a)')trim(line)
        end if
      end if
    end if
    if (ires > maxres) then
      write (iw,*) " MODIFY SUBROUTINE NAMES"
      write (iw,*) " MAXIMUM NUMBER OF RESIDUES ALLOWED:", maxres
      call mopend ("Too many residues")
    end if
    allres (ires) = loc_tyres // " "
    do i = 1, numat
      if (ions(i) == 1 .and. Abs (lused(i)) == ires) then
        allres (ires) (4:4) = "+"
      end if
    end do
    j = 0
    l = 0
    do i = 1, numat
      if (ions(i) > 0 .and. Abs (lused(i)) == ires) j = j + ions(i)
      if (ions(i) < 0 .and. Abs (lused(i)) == ires) l = l + ions(i)
    end do
    if (j /= 0 .or. l /= 0) then
      if (j + l == 0) then
        if (j == 1) write (iw, "(8X,2A,I4,A)") " Residue:  '", allres(ires)(1:3), &
               & ires, "' is Zwitterionic"
      else if (j > 0) then
        allres (ires) (4:4) = "+"
      else
        allres (ires) (4:4) = "-"
      end if
    end if
    return
  end subroutine atomrs
  logical function peptide_n(l)
    use common_arrays_C, only : nat, ibonds, nbonds
    implicit none
    integer :: l
    integer :: i, j, k, nc, nh, nco
    if (nat(l) /= 7) then
      peptide_n = .false.
      return
    else
!
!  "l" is a nitrogen.  Check that it has three bonds, two to carbon and one to hydrogen,
!  and that one carbon is attached to an oxygen
!
      if (nbonds(l) /= 3) then
        peptide_n = .false.
        return
      end if
      nc = 0
      nh = 0
      nco = 0
      do i = 1, 3
        if (nat(ibonds(i,l)) == 6)then
          nc = nc + 1
          k = ibonds(i,l)
          if (nbonds(k) == 3) then
            do j = 1, 3
              if (nat(ibonds(j,k)) == 8) then
                if (nbonds(ibonds(j,k)) == 1) then
                  nco = nco + 1
                else
                  peptide_n = .false.         ! Structure N-C-O-R detected
                  return
                end if
              end if
            end do
          else if (nbonds(k) == 4) then
            do j = 1, 4
              if (nat(ibonds(j,k)) == 8) then ! Structure N-C-O-R detected
                peptide_n = .false.
                return
              end if
            end do
          end if
        end if
        if (nat(ibonds(i,l)) == 1) nh = nh + 1
      end do
      if (nc /= 2 .or. nh /= 1 .or. nco /= 1) then
        peptide_n = .false.   ! Structure C-NH-C=O not detected
        return
      end if
!
!  "l" is a nitrogen.  Check that it has three bonds, two to carbon and one to hydrogen
!
      peptide_n = .true.
      return
    end if
  end function peptide_n

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine scfcri (selcon)
    use molkst_C, only: numcal, keywrd, efield
    use chanel_C, only: iw
 !   use common_convrg, only: scfref
   !
   !.. Implicit Declarations ..
    implicit none
   !
   !.. Formal Arguments ..
    double precision, intent (inout) :: selcon
   !
   !.. Local Scalars ..
    logical :: precis
    integer :: i
    integer :: icalcn = 0
    double precision, save  :: scfcrt, scfref
    double precision, external :: reada
    if (icalcn /= numcal) then
      icalcn = numcal
      !
      !   DETERMINE THE SELF-CONSISTENCY CRITERION
      !
      ! SCFCRT IS MACHINE-PRECISION DEPENDENT
      !
      !   IF SCFCRT IS CHANGED, THEN ALSO CHANGE DEFAULT IN WRTKEY
      !
      scfcrt = 1.d-2
      !
      !  THE USER CAN STATE THE SCF CRITERION, IF DESIRED.
      !
      i = Index (keywrd, " TS") + Index (keywrd, " FORCETS") + Index (keywrd, " IRC=")
      if (i /= 0) scfcrt = 2.0d-3
      precis = (Index (keywrd, " PRECIS") /= 0)
      i = Index (keywrd, " RELSCF")
      if (i /= 0) then
        scfcrt = reada (keywrd, i) * scfcrt
        write (iw, "('  SCF CRITERION =',G14.4)") scfcrt
        if (scfcrt < 1.d-5) then
10000     format (//2 x, " THERE IS A RISK OF INFINITE LOOPING WITH", &
         & " THE SCFCRT LESS THAN 1.D-5")
          write (iw, 10000)
        end if
      end if
      i = Index (keywrd, " SCFCRT")
      if (i /= 0) then
        scfcrt = reada (keywrd, i)
        write (iw, "('  SCF CRITERION =',G14.4)") scfcrt
        if (scfcrt < 1.d-5) then
          write (iw, "(//2x,' THERE IS A RISK OF INFINITE LOOPING WITH', &
         & ' THE SCFCRT LESS THAN 1.D-5')")
        end if
      end if
      !
      !   SELF-CONSISTENCY CRITERIA: SELCON IS IN KCAL/MOL
      !   IF GNORM IS LARGE, MAKE SELCON BIGGER
      !
      if (precis) then
        scfcrt = scfcrt * 0.01d0
      end if
      !
      ! For polarizability calculations, the default convergence should be
      ! tightened
      !
      if (Index (keywrd, " POLAR") /= 0 .and. scfref == 0.0d0) then
        scfcrt = 1.d-4
      end if
      selcon = scfcrt
      scfref = scfcrt
    else
      !
      !  IF POLARIZATION IS BEING CALCULATED, TIGHTEN SCF CRITERION
      !
      if (Abs (efield(1))+Abs(efield(2))+Abs(efield(3)) > 1.d-6) then
        selcon = 1.d-4
      end if
      if (scfref /= 0.d0) then
        selcon = scfref
      end if
    end if
    return
end subroutine scfcri

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine schmib(u, n, ndim)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!***********************************************************************
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n
      integer , intent(in) :: ndim
      double precision , intent(inout) :: u(ndim,ndim)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: n1, ii, k, k1, npass, j
      double precision :: zero, small, one, dot, scale

      save zero, small, one
!-----------------------------------------------
!
!     SAME AS SCHMIDT BUT WORKS FROM RIGHT TO LEFT.
!
      data zero, small, one/ 0.0D0, 0.01D0, 1.0D0/
      n1 = n + 1
      ii = 0
      do k = 1, n
        k1 = k - 1
!
!     NORMALIZE KTH COLUMN VECTOR
!
        dot = zero
        dot = dot + sum(u(:n,n1-k)*u(:n,n1-k))
        if (Abs(dot) < 1.d-20) go to 100
        scale = one/sqrt(dot)
        u(:n,n1-k) = scale*u(:n,n1-k)
   30   continue
        if (k1 == 0) cycle
        npass = 0
!
!     PROJECT OUT K-1 PREVIOUS ORTHONORMAL VECTORS FROM KTH VECTOR
!
   40   continue
        npass = npass + 1
        do j = 1, k1
          dot = zero
          dot = dot + sum(u(:n,n1-j)*u(:n,n1-k))
          u(:n,n1-k) = u(:n,n1-k) - dot*u(:n,n1-j)
        end do
!
!     SECOND NORMALIZATION (AFTER PROJECTION)
!     IF KTH VECTOR IS SMALL BUT NOT ZERO THEN NORMALIZE
!     AND PROJECT AGAIN TO CONTROL ROUND-OFF ERRORS.
!
        dot = zero
        dot = dot + sum(u(:n,n1-k)*u(:n,n1-k))
        if (Abs(dot) < 1.d-20) go to 100
        if (dot<small .and. npass>2) go to 100
        scale = one/sqrt(dot)
        u(:n,n1-k) = scale*u(:n,n1-k)
        if (dot < small) go to 40
        cycle
!
!     REPLACE LINEARLY DEPENDENT KTH VECTOR BY A UNIT VECTOR.
!
  100   continue
        ii = ii + 1
!     IF(II.GT.N) CALL MOPEND
        u(ii,n1-k) = one
        go to 30
      end do
      return
      end subroutine schmib

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.


      subroutine formxy(w, kr, wca, wcb, ca, na, cb, nb)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE molkst_C, only : numcal
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(inout) :: kr
      integer , intent(in) :: na
      integer , intent(in) :: nb
      double precision , intent(in) :: w(*)
      double precision , intent(inout) :: wca(45)
      double precision , intent(inout) :: wcb(45)
      double precision , intent(in) :: ca(45)
      double precision , intent(in) :: cb(45)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: icalcn, ij, i, j, kl, k, l, nna, nnb, n1, n2
      double precision :: aa, sum, bb
      integer, dimension (45) :: in

      save icalcn
!-----------------------------------------------
!***********************************************************************
!
!    EACH OF THE NA ELEMENTS OF WCA WILL ADD ON THE NB ELECTROSTATIC
!    TERMS FROM ATOM B IN CB
!
!    EACH OF THE NB ELEMENTS OF WCB WILL ADD ON THE NA ELECTROSTATIC
!    TERMS FROM ATOM A IN CA
!
!    BOTH SUMS WILL INVOLVE THE NA*NB TERMS IN ARRAY W.  ONCE USED,
!    W WILL BE INCREMENTED BY NA*NB.
!
! NA=NUMBER OF ATOMIC ORBITALS ON ATOM 'A'.
! NB=NUMBER OF ATOMIC ORBITALS ON ATOM 'B'.
!
!***********************************************************************
      data icalcn/ 0/
      in(1)  = 1
      in(10) = 4
      in(45) = 9
      if (icalcn /= numcal) icalcn = numcal
      ij = 0
      n1 = 0
      nna = in(na)
      nnb = in(nb)
      do i = 1, nna
        aa = 1.d0
        do j = 1, i
          n1 = n1 + 1
          if (i == j) then
            aa = 0.5d0
          end if
          ij = ij + 1
          sum = 0.d0
          kl = 0
          n2 = 0
          do k = 1, nnb
            bb = 1.d0
            do l = 1, k
              n2 = n2 + 1
              if (k == l) then
                bb = 0.5d0
              end if
              kl = kl + 1
              sum = sum + cb(kl) * w((n1-1)*nb+n2) * bb
            end do
          end do
          wca(ij) = wca(ij) + sum * aa
        end do
      end do
      ij = 0
      n1 = 0
      do i = 1, nnb
        aa = 1.d0
        do j = 1, i
          n1 = n1 + 1
          if (i == j) then
            aa = 0.5d0
          end if
          ij = ij + 1
          sum = 0.d0
          kl = 0
          n2 = 0
          do k = 1, nna
            bb = 1.d0
            do l = 1, k
              n2 = n2 + 1
              if (k == l) then
                bb = 0.5d0
              end if
              kl = kl + 1
              sum = sum + ca(kl) * w((n2-1)*nb+n1) * bb
            end do
          end do
          wcb(ij) = wcb(ij) + sum * aa
        end do
      end do
      kr = kr + na * nb
      return
      end subroutine formxy

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine getsym (locpar, idepfn, locdep, depmul, na)
    use common_systm, only : line, natoms, ifiles_1,iw, ir, ndep
    implicit none
    integer, dimension (3*natoms), intent (inout) :: idepfn, locpar
    integer, dimension (3*natoms), intent (out) :: locdep
    double precision, dimension (natoms), intent (out) :: depmul
    integer, dimension (natoms + 3), intent (in) :: na
    integer :: i, j, k, l, ll, loop, n, nerror, nvalue
    double precision :: sum
    character (len=60), dimension (19, 2), save :: text
    integer, dimension (40) :: ivalue
    double precision, dimension (40) :: value
    data text (1:19, 1) &
         &/ " BOND LENGTH    IS SET EQUAL TO THE REFERENCE BOND LENGTH   ", &
         &" BOND ANGLE     IS SET EQUAL TO THE REFERENCE BOND ANGLE    " , &
         &" DIHEDRAL ANGLE IS SET EQUAL TO THE REFERENCE DIHEDRAL ANGLE", &
         &" DIHEDRAL ANGLE VARIES AS  90 DEGREES - REFERENCE DIHEDRAL  ", &
         &" DIHEDRAL ANGLE VARIES AS  90 DEGREES + REFERENCE DIHEDRAL  ", &
         &" DIHEDRAL ANGLE VARIES AS 120 DEGREES - REFERENCE DIHEDRAL  ", &
         &" DIHEDRAL ANGLE VARIES AS 120 DEGREES + REFERENCE DIHEDRAL  ", &
         &" DIHEDRAL ANGLE VARIES AS 180 DEGREES - REFERENCE DIHEDRAL  ", &
         &" DIHEDRAL ANGLE VARIES AS 180 DEGREES + REFERENCE DIHEDRAL  ", &
         &" DIHEDRAL ANGLE VARIES AS 240 DEGREES - REFERENCE DIHEDRAL  ", &
         &" DIHEDRAL ANGLE VARIES AS 240 DEGREES + REFERENCE DIHEDRAL  ", &
         &" DIHEDRAL ANGLE VARIES AS 270 DEGREES - REFERENCE DIHEDRAL  ", &
         &" DIHEDRAL ANGLE VARIES AS 270 DEGREES + REFERENCE DIHEDRAL  ", &
         &" DIHEDRAL ANGLE VARIES AS - REFERENCE DIHEDRAL              ", &
         &" BOND LENGTH VARIES AS HALF THE REFERENCE BOND LENGTH       ", &
         &" BOND ANGLE VARIES AS HALF THE REFERENCE BOND ANGLE         ", &
         &" BOND ANGLE VARIES AS 180 DEGREES - REFERENCE BOND ANGLE    ", &
         &" NOT USED - USE SYMMETRY FUNCTION 19 INSTEAD                ", &
         &" BOND LENGTH IS A MULTIPLE OF THE REFERENCE BOND LENGTH     " /
    data text (1:19, 2) &
         &/ " X COORDINATE IS SET EQUAL TO   THE REFERENCE X COORDINATE  ", &
         &" Y COORDINATE IS SET EQUAL TO   THE REFERENCE Y COORDINATE  " , &
         &" Z COORDINATE IS SET EQUAL TO   THE REFERENCE Z COORDINATE  ", &
         &" X COORDINATE IS SET EQUAL TO - THE REFERENCE X COORDINATE  ", &
         &" Y COORDINATE IS SET EQUAL TO - THE REFERENCE Y COORDINATE  ", &
         &" Z COORDINATE IS SET EQUAL TO - THE REFERENCE Z COORDINATE  ", &
         &" X COORDINATE IS SET EQUAL TO   THE REFERENCE Y COORDINATE  ", &
         &" Y COORDINATE IS SET EQUAL TO   THE REFERENCE Z COORDINATE  ", &
         &" Z COORDINATE IS SET EQUAL TO   THE REFERENCE X COORDINATE  ", &
         &" X COORDINATE IS SET EQUAL TO - THE REFERENCE Y COORDINATE  ", &
         &" Y COORDINATE IS SET EQUAL TO - THE REFERENCE Z COORDINATE  ", &
         &" Z COORDINATE IS SET EQUAL TO - THE REFERENCE X COORDINATE  ", &
         &" X COORDINATE IS SET EQUAL TO   THE REFERENCE Z COORDINATE  ", &
         &" Y COORDINATE IS SET EQUAL TO   THE REFERENCE X COORDINATE  ", &
         &" Z COORDINATE IS SET EQUAL TO   THE REFERENCE Y COORDINATE  ", &
         &" X COORDINATE IS SET EQUAL TO - THE REFERENCE Z COORDINATE  ", &
         &" Y COORDINATE IS SET EQUAL TO - THE REFERENCE X COORDINATE  ", &
         &" Z COORDINATE IS SET EQUAL TO - THE REFERENCE Y COORDINATE  ", &
         &" NOT USED                                                   " /
!
! TITLE OUTPUT
!
    if (ifiles_1 == 1) then
10000 format (///5 x, "PARAMETER DEPENDENCE DATA"//&
           &"        REFERENCE ATOM      FUNCTION NO.    DEPENDENT ATOM(S)")
      write (iw, 10000)
    end if
!
! INPUT SYMMETRY : FUNCTION, REFERANCE PARAMETER, AND DEPENDENT ATOMS
!
    n = 0
    ndep = 0
    nerror = 0
    depmul(1) = 0.d0
    do
      read (ir, "(A)", end=1000) line
      call nuchar (line, value, nvalue)
!   INTEGER VALUES
      do i = 1, nvalue
        ivalue(i) = Nint (value(i))
      end do
!   FILL THE LOCDEP ARRAY
      if (nvalue == 0 .or. ivalue(3) == 0) exit
      if (ivalue(2) == 19) then
        if (na(ivalue(1)) == 0) then
!
!  Not allowed: a Cartesian coordinate cannot use function 19
!
          write (iw,*) "Atom ", ivalue (1), " is Cartesian.  " // &
               &"Function 19 cannot be used here."
          return
        end if
        do i = 4, nvalue
          if (ivalue(i) == 0) exit
          ndep = ndep + 1
          locdep(ndep) = ivalue(i)
          locpar(ndep) = ivalue(1)
          idepfn(ndep) = 19
          n = n + 1
          sum = value(3)**2
          do l = 1, 16
            j = Nint (sum*l)
            if (Abs (j-sum*l) < l*1.d-3) then
              value(3) = Sqrt ((1.d0*j)/l)
            end if
          end do
          depmul(n) = value(3)
        end do
      else
        if (na(ivalue(1)) /= 0 .and. ivalue(2) == 18) then
!
!  Not allowed: an internal coordinate cannot use function 18
!
          write (iw,*) "Atom ", ivalue (1), " is internal.  " // &
               &"Function 18 cannot be used here."
          return
        end if
        do i = 3, nvalue
          if (ivalue(i) == 0) exit
          ndep = ndep + 1
          locdep(ndep) = ivalue(i)
          locpar(ndep) = ivalue(1)
          idepfn(ndep) = ivalue(2)
          if (ivalue(i) > natoms) then
            nerror = 1
          end if
        end do
      end if
      ll = i - 1
      if (ivalue(2) == 19) then
        if (ifiles_1 == 1) then
10010     format (i13, i13, f13.8, i9, 6 i5, 10(/, 43 x, 7 i5))
          write (iw, 10010) ivalue(1), ivalue(2), value(3), &
               &(ivalue(j), j=4, ll)
        end if
      else if (ifiles_1 == 1) then
10020   format (i13, i19, i16, 6 i5, 10(/, 43 x, 7 i5))
        write (iw, 10020) ivalue(1), ivalue(2), (ivalue(j), j=3, ll)
      end if
 !     if (nerror == 1) then
 !       write (iw,*) " A SYMMETRY FUNCTION IS USED TO ", &
 !            &"DEFINE A NON-EXISTENT ATOM"
 !       return
 !     end if
    end do
!
! CLEAN UP
1000 if (ifiles_1 == 1) then
10030 format (/ 10 x, "   DESCRIPTIONS OF THE FUNCTIONS USED", /)
      write (iw, 10030)
    end if
    do loop = 1, 2
      do j = 1, 19
        do i = 1, ndep
          if (idepfn(i) == j) go to 1100
        end do
        cycle
1100    do k = 1, natoms
          if (locpar(i) == k) then
            if (loop == 1 .and. na(k) /= 0) then
              go to 1200
            else if (loop == 2 .and. na(k) == 0) then
              go to 1200
            end if
          end if
        end do
        cycle
1200    if (ifiles_1 == 1) then
10040     format (i4, 5 x, a)
          write (iw, 10040) j, text(j, loop)
        end if
      end do
    end do
end subroutine getsym

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module common_systm
    implicit none
    save
    integer :: numat, natoms, maxtxt, iw, na1, ndep, ir,  &
    & ifiles_1, id, nvar, nalpha, maxsym=60000
    character (len=240) :: jobnam_c, line, path
    logical :: l_int, l_use_tv = .true.
!
end module common_systm
!
!
!

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine deriv(geo, gradnt)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE molkst_C, ONLY: numat, norbs, nclose, nopen, fract, natoms, numcal, &
      & ndep, nvar, keywrd, cosine, moperr, mpack, isok, id, l123, line, nscf, &
      pressure, l1u, l2u, l3u, method_PM7, method_pm8, method_pm6_org
      use common_arrays_C, only : dxyz, loc, errfn, aicorr, tvec
      USE symmetry_C, ONLY: locpar, idepfn
      USE chanel_C, only : iw, ir, job_fn
      use funcon_C, only : pi
      use derivs_C, only : aidref, work2
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
!
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision, intent(in)  :: geo(3,natoms)
      double precision, intent(inout)  :: gradnt(nvar)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: idelta, icalcn, i, j, nstep, nw2, ncol
      double precision, dimension(3) :: change
      double precision :: coord(3*natoms), gold(3*natoms), xparam(3*natoms)


      double precision :: grlim, sum, gnorm, step, press, summ, press1, &
      press2, press3
      double precision, external :: dot, volume
      logical :: scf1, halfe, slow, aifrst, debug, precis, intn, geochk, ci, &
        aic, noanci, field, saddle, DH_correction, l_redo_bonds

      save change, scf1, halfe, idelta, slow, icalcn, aifrst, debug, l_redo_bonds, &
        precis, intn, geochk, ci, aic, grlim, nw2, field, DH_correction
!-----------------------------------------------
!***********************************************************************
!
!    DERIV CALCULATES THE DERIVATIVES OF THE ENERGY WITH RESPECT TO THE
!          INTERNAL COORDINATES. THIS IS DONE BY FINITE DIFFERENCES.
!
!    THE MAIN ARRAYS IN DERIV ARE:
!        LOC    INTEGER ARRAY, LOC(1,I) CONTAINS THE ADDRESS OF THE ATOM
!               INTERNAL COORDINATE LOC(2,I) IS TO BE USED IN THE
!               DERIVATIVE CALCULATION.
!        GEO    ARRAY \GEO\ HOLDS THE INTERNAL COORDINATES.
!        gradnt   ON EXIT, CONTAINS THE DERIVATIVES
!
!***********************************************************************
      data icalcn/ 0/
      if (icalcn /= numcal) then
        aifrst = index(keywrd,' RESTART') == 0
        saddle = index(keywrd, " SADDLE") /= 0
        debug = index(keywrd,' DERIV') /= 0
        field = index(keywrd,' FIELD') /= 0
        precis = index(keywrd,' PREC') /= 0
        DH_correction = (index(keywrd,' PM6-D') + index(keywrd,' PM6-H') /= 0 .or. &
          method_PM7 .or. method_pm6_org .or. method_pm8 )
        intn = index(keywrd,'  XYZ') == 0
        if (saddle) then
          nw2 = max(mpack, 9*natoms**2)
        else
          nw2 = max(mpack, 6*natoms*l123)
        end if
        errfn = 0.d0
        if (allocated(aidref)) deallocate(aidref)
        if (allocated(work2))  deallocate(work2)
        allocate(aidref(nvar), work2(nw2))
        aidref = 0.d0
!
!   GEOCHK is true if the system is a transition state in internal
!          coordinates with all coordinates marked for optimization.
!          It can be over-ridden by GEO-OK
!
        geochk = index(keywrd,' TS') + index(keywrd,' NLLSQ') + index(keywrd,&
          ' SIGMA') /= 0
        geochk = geochk .and. intn .and. nvar>=numat*3-6 .and. id==0 .and. &
          index(keywrd,'GEO-OK')==0
        geochk = geochk .and. index(keywrd,' XYZ')==0
        ci = index(keywrd,' C.I.') /= 0
        scf1 = index(keywrd,' 1SCF') /= 0
        aic = index(keywrd,'AIDER') /= 0
        if (aic .and. aifrst) then
          open(unit=ir, file=job_fn, status='OLD', blank='ZERO',position='asis')
          rewind ir
!
!  ISOK IS SET FALSE: ONLY ONE SYSTEM ALLOWED
!
          isok = .FALSE.
          do i = 1, 1000
            read (ir, '(A)') line
            call upcase (line, 80)
            if (index(line,'AIDER') == 0) cycle
            exit
          end do
          do j = 1, 1000
            read (ir, '(A)', end=40, err=40) line
            call upcase (line, 80)
            if (index(line,'AIDER') /= 0) go to 60
          end do
   40     continue
          write (iw, '(2/,A)') ' KEYWORD "AIDER" SPECIFIED, BUT NOT'
          write (iw, '(A)') ' PRESENT AFTER Z-MATRIX.  JOB STOPPED'
          call mopend (&
         'KEYWORD "AIDER" SPECIFIED, BUT NOT PRESENT AFTER Z-MATRIX.  JOB STOPPED')
          return
   50     continue
          write (iw, '(2/,A)') '  FAULT IN READ OF AB INITIO DERIVATIVES'
          write (iw, '(A)') '  DERIVATIVES READ IN ARE AS FOLLOWS'
          write (iw, '(6F12.6)') (aidref(j),j=1,i)
          call mopend ('FAULT IN READ OF AB INITIO DERIVATIVES')
          return
   60     continue
          if (natoms > 2) then
            j = 3*natoms - 6
          else
            j = 1
          end if
          read (ir, *, end=50, err=50) (aidref(i),i=1,j)
          write (iw, '(/,A,/)') &
            ' AB-INITIO DERIVATIVES IN KCAL/MOL/(ANGSTROM OR RADIAN)'
          write (iw, '(5F12.6)') (aidref(i),i=1,j)
          do i = 1, nvar
            if (loc(1,i) > 3) then
              j = 3*loc(1,i) + loc(2,i) - 9
            else if (loc(1,i) == 3) then
              j = loc(2,i) + 1
            else
              j = 1
            end if
            aidref(i) = aidref(j)
          end do
          write (iw, '(/,A,/)') ' AB-INITIO DERIVATIVES FOR VARIABLES'
          write (iw, '(5F12.6)') (aidref(i),i=1,nvar)
          if (ndep /= 0) then
            do i = 1, nvar
              sum = aidref(i)
              aidref(i) = aidref(i) + count(loc(1,i)==locpar(:ndep) .and. &
              (loc(2,i)==idepfn(:ndep) .or. loc(2,i)==3 .and. &
              idepfn(:ndep)==14))*sum
            end do
            write (iw, '(/,A,/)') &
              ' AB-INITIO DERIVATIVES AFTER SYMMETRY WEIGHTING'
            write (iw, '(5F12.6)') (aidref(j),j=1,nvar)
          end if
          close(ir, status='KEEP')
        end if
        l_redo_bonds = (index(keywrd,' FORCE') + index(keywrd,' IRC=') + &
          index(keywrd,' THERM') + index(keywrd,' DFORCE') == 0)
        grlim = 0.01D0
        if (precis) grlim = 0.0001D0
        halfe = nopen>nclose .and. Abs(fract - 2.d0) > 1.d-20 .and. Abs(fract) > 1.d-20 .or. ci
        idelta = -7
!
!   IDELTA IS A MACHINE-PRECISION DEPENDANT INTEGER
!
        change(1) = 10.D0**idelta
        change(2) = 10.D0**idelta
        change(3) = 10.D0**idelta
!
!    CHANGE(I) IS THE STEP SIZE USED IN CALCULATING THE DERIVATIVES.
!    FOR "CARTESIAN" DERIVATIVES, CALCULATED USING DCART,AN
!    INFINITESIMAL STEP, HERE 0.000001, IS ACCEPTABLE. IN THE
!    HALF-ELECTRON METHOD A QUITE LARGE STEP IS NEEDED AS FULL SCF
!    CALCULATIONS ARE NEEDED, AND THE DIFFERENCE BETWEEN THE TOTAL
!    ENERGIES IS USED. THE STEP CANNOT BE VERY LARGE, AS THE SECOND
!    DERIVITIVE IN FLEPO IS CALCULATED FROM THE DIFFERENCES OF TWO
!    FIRST DERIVATIVES. CHANGE(1) IS FOR CHANGE IN BOND LENGTH,
!    (2) FOR ANGLE, AND (3) FOR DIHEDRAL.
!
      end if
      if (nvar == 0) return
      if (debug) then
        write (iw, '(10X, "GEOMETRY AT THE START OF DERIV")')
        call geout(-iw)
      end if
      gnorm = 0.D0
      do i = 1, nvar
        gold(i) = gradnt(i)
        xparam(i) = geo(loc(2,i),loc(1,i))
        gnorm = gnorm + gradnt(i)**2
      end do
      gnorm = sqrt(gnorm)
      slow = .FALSE.
      noanci = .FALSE.
      if (halfe) then
        noanci = (index(keywrd,'NOANCI') /= 0 .or. nopen == norbs)
        slow = (noanci .and. (gnorm<grlim .or. scf1))
      else
        slow = (index(keywrd,'NOANCI') /= 0)
      end if
      if (ndep /= 0) call symtry
      call gmetry (geo, coord)
!
!  COORD NOW HOLDS THE CARTESIAN COORDINATES
!
      if (halfe .and. .not.noanci .and. numat > 1) then
        if (debug) write (iw, '(10x,a)') 'DOING ANALYTICAL C.I. DERIVATIVES'
        if (debug) write (iw, '(" NUMBER  ATOM  ",5X,"X",12X,"Y",12X,"Z",/)')
        call dernvo ()
        if (moperr) return
      else
        if (debug) write (iw, '(10x,a)') 'DOING VARIATIONALLY OPTIMIZED DERIVATIVES'
        call dcart (coord, dxyz)
      end if
      if (l_redo_bonds .and. mod(nscf,10) == 4 .and. nscf /= 0 .and. id == 0) then
!
!  There is a possibility that a bond might be made or broken during a geometry optimization
!  or a gradient minimization.  To allow for this, the bonds array should be updated every
!  few SCF calculations. The values in the mod test are "intelligent guesses"
!
        call lewis (.true.)
        if (moperr) then
           write (iw, '(/10x,A,/)') ' Geometry at the point this error was detected'
          call geout(iw)
        end if
      end if
      if (DH_correction) call post_scf_corrections(sum, .true.)
!
!   THE CARTESIAN DERIVATIVES ARE IN DXYZ
!
      if (field) call dfield ()
      if (Abs (pressure) > 1.d-4) then
        if (id == 1) then
      !
      !  Add in gradient tension contribution
      !
          i = 3 * l123 / 2 - 1
        !
        !  For polymers, pressure is pull in Newtons for 1 mole
        !  1N = J/M = 10**(-3)/4.184 kcal/M = 4.184*10**(-3)*10**(-10) kcal/Angstrom
          press = pressure / Sqrt (dot(tvec(1, 1), tvec(1, 1), 3))
          do j = 1, 3
            dxyz(j + i) = dxyz(j + i) + tvec(j, 1) * press
            dxyz(j + i + 3) = dxyz(j + i + 3) - tvec(j, 1) * press
          end do
        else if (id == 3) then
          summ = volume (tvec, 3)
          press1 = summ / dot (tvec(1, 1), tvec(1, 1), 3) * pressure
          press2 = summ / dot (tvec(1, 2), tvec(1, 2), 3) * pressure
          press3 = summ / dot (tvec(1, 3), tvec(1, 3), 3) * pressure
  !
  ! Add in gradient pressure term
  !
  !  First, the central unit cell
  !
          i = 3*(l1u * (2*l2u+1) * (2*l3u+1) + l2u * (2*l3u+1) + l3u - 1)
          do j = 1, 3
            dxyz(j + i) = dxyz(j + i) + tvec(j, 1) * press1
            dxyz(j + i) = dxyz(j + i) + tvec(j, 2) * press2
            dxyz(j + i) = dxyz(j + i) + tvec(j, 3) * press3
          end do
  !
  !  Cell in 0,0,1 position
  !
          i = 3*(l1u * (2*l2u+1) * (2*l3u+1) + l2u * (2*l3u+1) + l3u)
          do j = 1, 3
            dxyz(j + i) = dxyz(j + i) - tvec(j, 3) * press3
          end do
  !
  !  Cell in 0,1,0 position
  !
          i = 3*(l1u * (2*l2u+1) * (2*l3u+1) + (l2u+1) * (2*l3u+1) + l3u - 1)
          do j = 1, 3
            dxyz(j + i) = dxyz(j + i) - tvec(j, 2) * press2
          end do
  !
  !  Cell in 1,0,0 position
  !
          i = 3*((l1u+1) * (2*l2u+1) * (2*l3u+1) + l2u * (2*l3u+1) + l3u - 1)
          do j = 1, 3
            dxyz(j + i) = dxyz(j + i) - tvec(j, 1) * press1
          end do
        end if
      end if
      if ((DH_correction .or. Abs (pressure) > 1.d-4) .and. debug) then
         call print_dxyz("  (Includes post-SCF corrections)")
      end if

      step = change(1)
      nstep = nw2/(3*numat*l123)
      do i = 1, nvar, nstep
        j = min(i + nstep - 1,nvar)
        call jcarin (xparam, step, precis, work2, ncol, i, j)
        call mxm (work2, j - i + 1, dxyz, ncol, gradnt(i), 1)
!
      end do
      if (precis) then
        step = 0.5D0/step
      else
        step = 1.0D0/step
      end if
      gradnt(:nvar) = gradnt(:nvar)*step
!
!  NOW TO ENSURE THAT INTERNAL DERIVATIVES ACCURATELY REFLECT CARTESIAN
!  DERIVATIVES
!
      if (geochk) then
        sum = dot(gradnt,gradnt,nvar)
        if (sum<2.D0 .and. dot(dxyz,dxyz,3*numat)>max(4.D0,sum*4.D0)) then
!
! OOPS, LOOKS LIKE AN ERROR.
!
          do i = 1, nvar
            j = int(xparam(i)/3.141D0)
            if (.not.(loc(2,i)==2 .and. loc(1,i)>3 .and. abs(xparam(i)-j*pi)<0.005D0)) cycle
!
!  ERROR LOCATED, BUT CANNOT CORRECT IN THIS RUN
!
            write (iw, '(2/,3(A,/),I3,A)') &
              ' INTERNAL COORDINATE DERIVATIVES DO NOT REFLECT', &
              ' CARTESIAN COORDINATE DERIVATIVES', &
              ' TO CORRECT ERROR, INCREASE DIHEDRAL OF ATOM', loc(1,i), &
              ' BY 90 DEGREES'
            write (iw, '(2/,A)') '     CURRENT GEOMETRY'
            call geout (iw)
            call mopend (&
       ' INTERNAL COORDINATE DERIVATIVES DO NOT REFLECT CARTESIAN COORDINATE DERIVATIVES')
            return
          end do
        end if
      end if
!
!  THIS CODE IS ONLY USED IF THE KEYWORD NOANCI IS SPECIFIED
      if (slow) then
        if (debug) write (iw, *) 'DOING FULL SCF DERIVATIVES'
        call deritr ()
        icalcn = numcal
!
! THE ARRAY ERRFN HOLDS THE EXACT DERIVATIVES MINUS THE APPROXIMATE
! DERIVATIVES
        errfn(:nvar) = errfn(:nvar) - gradnt(:nvar)
      end if
!
!  AT THIS POINT, THE INTERNAL DERIVATIVES ARE KNOWN, AND ARE IN GRADNT.
!
      cosine = dot(gradnt,gold,nvar)/sqrt(dot(gradnt,gradnt,nvar)*dot(gold,gold,nvar)&
         + 1.D-20)
      if (slow) gradnt(:nvar) = gradnt(:nvar) + errfn(:nvar)
      if (aic) then
        if (aifrst) then
          aifrst = .FALSE.
          aicorr(:nvar) = (-aidref(:nvar)) - gradnt(:nvar)
        end if
        gradnt(:nvar) = gradnt(:nvar) + aicorr(:nvar)
      end if
      if (debug) then
        write (iw, '('' GRADIENTS'')')
        write (iw, '(8F10.3)') (gradnt(i),i=1,nvar)
        write (iw, '('' XPARAM'')')
        write (iw, '(8F10.3)') (xparam(i),i=1,nvar)
        if (slow) then
          write (iw, '('' ERROR FUNCTION'')')
          write (iw, '(8F10.3)') (errfn(i),i=1,nvar)
        end if
      end if
      if (debug) write (iw, '('' COSINE OF SEARCH DIRECTION ='',F30.6)') cosine
      return
      end subroutine deriv

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine pdbout (mode1)
    use molkst_C, only: numat, natoms, ncomments, verson, line, nbreaks, id, &
      maxtxt, keywrd, nelecs, escf, stress, backslash, l_normal_html
    use chanel_C, only: iw, input_fn
    use elemts_C, only: elemnt
    use common_arrays_C, only: txtatm, nat, all_comments, p, labels, &
      breaks, txtatm1, geo, l_atom
    USE parameters_C, only : tore
    implicit none
    integer, intent (in) :: mode1
!
    character :: ele_pdb*2, idate*24, num*1, x*1
    integer :: i, i1, i2, iprt, k, nline
    logical :: ter, html, ter_ok, l_irc_drc
    double precision :: sum
    intrinsic Abs, Char, Ichar
    double precision, allocatable :: q2(:), coord(:,:)
!
    html = (index(keywrd, " HTML") /= 0)
    ter_ok = (index(keywrd, " NOTER") == 0)
    l_irc_drc = (index(keywrd, " IRC") + index(keywrd, " DRC") /= 0)
    ter = .false.
    allocate (q2(numat), coord(3, natoms))
    if (allocated(p)) then
      if (index(keywrd, " 0SCF") /= 0) then
        sum = 0.d0
        i2 = 0
        do i = 1, numat
          sum = sum + p(i)
          if (txtatm(i) /= " ") then
            i2 = i2 + 1
            txtatm(i2) = txtatm(i)
          end if
        end do
        if (sum > 0.d0) then
          nelecs = nelecs - nint(sum)
          q2(:numat) = p(:numat)
        else
          q2(:numat) = 0.d0
        end if
      else
        call chrge (p, q2)
        q2(:numat) = tore(nat(:numat)) - q2(:numat)
      end if
    else
      q2 = 0.d0
    end if
!
! Convert geometry into Cartesian coordinates, preserving dummy atoms
!
    do i = 1, numat
      if (labels(i) == 99) labels(i) = 199
    end do
    call gmetry(geo, coord)
    do i = 1, numat
      if (labels(i) == 199) labels(i) = 99
    end do
    nline = 0
    if (mode1 == 1) then
      iprt = iw
    else
      iprt = Abs (mode1)
    end if
    call fdate (idate)
    i = len_trim(input_fn)
    if (ncomments > 0) then
      if (index(all_comments(1),"HEADER") == 0) then
        line = "HEADER  data-set: "//input_fn(:i - 5)
        if(len_trim(line) > 80) then
          do
            k = index(line, backslash)
            if (k == 0) exit
            i2 = index(line,"data-set:") + 9
            line = line(:i2)//line(k + 1:)
          end do
        end if
        line(81:) = " "
        write (iprt, "(A)") trim(line)
        line = "REMARK  MOPAC, Version: "//verson//" Date: "//idate(5:11)//idate(21:)//idate(11:16)
        write (iprt, "(A)") trim(line)
      end if
      do i = 1, ncomments
        line = all_comments(i)(:7)
        if (index(line,"ATOM  ") + index(line,"HETATM") + index(line,"TITLE ") + index(line,"HEADER") + &
            index(line,"ANISOU") + index(line,"COMPND") + index(line,"SOURCE") + index(line,"KEYWDS") + &
            index(line,"HELIX ") + index(line,"SHEET ") + index(line,"REMARK") + index(line,"USER  ") + &
            index(line,"EXPDTA") + index(line,"AUTHOR") + index(line,"REVDAT") + index(line,"JRNL  ") + &
            index(line,"DBREF ") + index(line,"SEQRES") + index(line,"HET   ") + index(line,"HETNAM") + &
            index(line,"LINK  ") + index(line,"CRYST1") + index(line,"SCALE" ) + index(line,"ORIGX" ) + &
            index(line,"FORMUL") + index(line,"SEQRES") == 0) cycle
        write(iprt,"(a)")all_comments(i)(2:len_trim(all_comments(i)))
      end do
    else
      line = "HEADER  data-set: "//input_fn(:i - 5)
      if(len_trim(line) > 80) then
        do
          k = index(line, backslash)
          if (k == 0) exit
          i2 = index(line,"data-set:") + 9
          line = line(:i2)//line(k + 1:)
        end do
      end if
      line(81:) = " "
      write (iprt, "(A)") trim(line)
      if (ncomments == 0) then
        line = "REMARK  MOPAC, Version: "//verson
        write (iprt, "(A)") trim(line)
        line = "REMARK  Date: "//idate(5:11)//idate(21:)//idate(11:16)
        write (iprt, "(A)") trim(line)
        if (.not. l_irc_drc) line = "REMARK  Heat of Formation ="
        sum = escf - stress
        if (abs(sum) > 4.99999d-4) then
          i = max(int(log10(abs(sum))), 0)
          if ( sum < 0.d0) i = i + 1
          if (i < 4) then
            num = char(ichar("6") + i)
            write (iprt, "(A, f"//num//".3, a)") trim(line), sum, " Kcal/mol"
          else
            num = char(ichar("6") + i - 10)
            write (iprt, "(A, f1"//num//".3, a)") trim(line), sum, " Kcal/mol"
          end if
        end if
      end if
    end if
    if (maxtxt == 0 .and. txtatm(1) /= " ") then
      txtatm1(:natoms) = txtatm(:natoms)
    end if
    i1 = 0
    i2 = 0
    nbreaks = 1
    do i = 1, natoms - id
      if (labels(i) /= 99) i1 = i1 + 1
      i2 = i2 + 1
!
!   i:  all atoms, real and dummy
!   i1: real atom only
!   i2: all atoms, real and dummy, plus TER.  I.e., PDB record entry number
!

      nline = nline + 1
      if (ter_ok) ter = (i == breaks(nbreaks))
      if (ter) nbreaks = nbreaks + 1
      if (i1 == 0) cycle
      if ( .not. l_atom(i1)) cycle
      if (elemnt(labels(i)) (1:1) == " " .or. labels(i) == 99) then
        ele_pdb(1:1) = " "
        ele_pdb(2:2) = elemnt(labels(i)) (2:2)
      else
        ele_pdb(1:1) = elemnt(labels(i)) (1:1)
        ele_pdb (2:2) = Char (Ichar ("A")-Ichar ("a")+Ichar (elemnt(labels(i)) (2:2)))
      end if
      if (maxtxt == 27) then
        num = "1"
      else
        num = "2"
      end if
      if (txtatm(i)(15:16) == "**") txtatm(i)(15:16) = "99"
      if (txtatm(i)(23:26) == "****") txtatm(i)(23:26) = "9999"
      x = txtatm(i)(13:13)
      if (x == "X") txtatm(i)(13:13) = " "
      if (txtatm(i)(14:14) /= "X") then
      write (iprt, "(a,i5,a,f1"//num//".3,f8.3,f8.3,a,f7.2,a, a2,a)") txtatm(i)(1:6),i2,txtatm(i)(12:maxtxt), &
        & (coord(k, i), k=1, 3), "  1.0",q2(i1)*10.d0,"      PROT", ele_pdb, " "
      else
        write (iprt, "(a,i5,a,f1"//num//".3,f8.3,f8.3,a,f7.2,a, a2,a)") txtatm(i)(1:6),i2,txtatm(i)(12:maxtxt), &
        & (coord(k, i), k=1, 3), "  1.0 ",0.d0,"      PROT", ele_pdb, " "
      end if
      txtatm(i)(13:13) = x
      if (ter) then
        i2 = i2 + 1
        write(iprt, "(a,i8,a)")"TER",i2,"      "//txtatm(i)(18:26)  !  Write out the TERMINAL marker
      end if
    end do
    write(iprt, "(a)")"END"
    if (html) then
      if (l_normal_html) then
        l_normal_html = .false.
        call write_html
      end if
    end if
  end subroutine pdbout
  subroutine write_html
    use chanel_C, only: input_fn
    use molkst_C, only : line, koment, title, keywrd, numcal, geo_ref_name, geo_dat_name, &
      maxtxt, backslash, natoms, id
    use common_arrays_C, only : txtatm, p
    use mozyme_C, only : tyres, tyr
    implicit none
    integer :: nres, i, j, k, nprt, ncol, biggest_res, iprt, icalcn = -1, it
    character :: res_txt(4000)*10, l_res*14, n_res*14, wrt_res*14, num*1, line_1*400
    integer, parameter :: limres = 260
    logical :: exists, l_prt_res, l_geo_ref, l_compare, l_het_only
    double precision, external :: reada
    save :: icalcn
    it = 0
    iprt = 27
    if (icalcn == numcal .and. index(keywrd, " Write_Escf") == 0) return
    icalcn = numcal
    l_compare = (index(keywrd, " COMPARE") /= 0)
    l_prt_res = (index(keywrd," NORJSMOL") == 0)
    line = input_fn(:len_trim(input_fn) - 4)//"html"
    open(unit=iprt, file=trim(line))
    nres = 0
    if (l_prt_res) then
!
!   Identify all residues
!

      l_het_only = .true.
      do i = 1, natoms - id
        if (txtatm(i)(1:4) == "ATOM") l_het_only = .false.
        if (txtatm(i)(18:20) == "HOH") cycle
        if (txtatm(i)(18:20) == "SO4") cycle
        j = nint(reada(txtatm(i), 23))
        if (j < 0) then
           write(l_res,"(a3,i4.3,a)")txtatm(i)(18:20),j,":"//txtatm(i)(22:22)
        else
           write(l_res,"(a3,i4.4,a)")txtatm(i)(18:20),j,":"//txtatm(i)(22:22)
        end if
        if (maxtxt == 27) then
          l_res(10:10) = txtatm(i)(27:27)
        else
          l_res(10:10) = " "
        end if
!
! If the first character is a number, change it to "Q"
!
        do k = 1, 6
          if (l_res(k:k) /= " ") exit
        end do
        if (l_res(k:k) >= "0" .and. l_res(k:k) <= "9") l_res(k:k) = "Q"
!
! Change any spaces to "J"
!
        do k = k + 1, 9
          if (l_res(k:k) == " ") then
            if (txtatm(i)(:6) /= "HETATM") l_res(k:k) = "J"
          end if
        end do
          do k = 1, nres
          if (res_txt(k) == l_res .or. l_res(1:7) == "   Q000") exit
        end do
        if (k > nres) then
          nres = nres + 1
          res_txt(nres) = trim(l_res)
          do k = 1, len_trim(l_res)
            if (res_txt(nres)(k:k) == " ") res_txt(nres)(k:k) ="Q"
          end do
        end if
      end do
!
! Remove redundancies
!
      j = 0
      do i = 1, nres
        do k = 1, j
          if (res_txt(k) == res_txt(i)) exit
        end do
        if (k > j) then
          j = j + 1
          res_txt(j) = res_txt(i)
        end if
      end do
      nres = j
    end if
!
!  Heading
!
    if (len_trim(koment) == 0 .or. (index(koment(:8), " NULL") /= 0)) then
      write(iprt,"(a)") "<HTML><HEAD><TITLE>"//input_fn(:len_trim(input_fn) - 5)//"</TITLE></HEAD>"
    else
      do it = 1, len_trim(koment)
        if (koment(it:it) /= " ") exit
      end do
      write(iprt,"(a)") "<HTML><HEAD><TITLE>"//trim(koment(it:))//"</TITLE></HEAD>"
    end if
    write(iprt,"(a)")"<style type=""text/css"">"
    write(iprt,"(a)")".auto-style4 {"
    write(iprt,"(a)")"margin-top: 0px;"
    write(iprt,"(a)")"text-align: center;"
    write(iprt,"(a)")"line-height: 85%;"
    write(iprt,"(a)")"}"
    write(iprt,"(a)")".auto-style5 {"
    write(iprt,"(a)")"text-decoration: none;"
    write(iprt,"(a)")"}"
    write(iprt,"(a)")"</style>"
    write(iprt,"(a)") "<!--"," ","   Start of JSmol script"," ", "-->"
    write(iprt,"(a)") "<meta charset=""utf-8""> <script type=""text/javascript"" src=""../jsmol/JSmol.min.js""></script>  "
    write(iprt,"(a)") "<script type=""text/javascript"">"
    write(iprt,"(/a)") "$(document).ready(function() {Info = {"
    write(iprt,"(10x,a)") "width: 1500,", "height: 1000,", "color: ""0xB0B0B0"",", &
    "disableInitialConsole: true, ", "addSelectionOptions: false,", "j2sPath: ""../jsmol/j2s"",", &
    "jarPath: ""../jsmol/java"",", "use: ""HTML5"", script: ", " "
    write(iprt,"(a)")"// Data set to be loaded", " "
    if (index(keywrd, " GRAPHF") /= 0) then
      line = input_fn(:len_trim(input_fn) - 4)//"mgf"
    else
      line = input_fn(:len_trim(input_fn) - 4)//"pdb"
    end if
    do i = len_trim(line), 1, -1
      if (line(i:i) == "/" .or. line(i:i) == backslash) exit
    end do
    write(iprt,"(a)") """load "//backslash
    l_geo_ref = (index(keywrd, " COMPARE") /= 0)
    if (l_geo_ref) then
      if (l_compare) then
        line_1 = line(i + 1:len_trim(line)-4)//"_"
      else
        line_1 = " "
      end if
      if (geo_dat_name(:len_trim(geo_dat_name) -3) == geo_ref_name(:len_trim(geo_ref_name) -3)) then
        line = trim(line_1)//geo_dat_name(:len_trim(geo_dat_name) - 4)//"_a.pdb"//"' '"// &
        trim(line_1)//geo_ref_name(:len_trim(geo_ref_name) - 3)//"pdb"//"'; "//backslash
      else
        line = trim(line_1)//geo_dat_name(:len_trim(geo_dat_name) -3)//"pdb"//"' '"// &
        trim(line_1)//geo_ref_name(:len_trim(geo_ref_name) - 3)//"pdb"//"'; "//backslash
      end if
      write(iprt,"(10x,a)")"FILES '"//trim(line)
    else
      write(iprt,"(10x,a)")"'"//trim(line(i + 1:))//"'; "//backslash
    end if
    write(iprt,"(10x,a)")"set measurementUnits ANGSTROMS; "//backslash
    if (l_geo_ref) then
      write(iprt,"(10x,a)")"set bondRadiusMilliAngstroms (25); "//backslash, "spacefill 10%; "//backslash
    else
      write(iprt,"(10x,a)")"set bondRadiusMilliAngstroms (50); "//backslash, "spacefill 15%; "//backslash
    end if
    write(iprt,"(10x,a)")"set display selected; "//backslash, "hBonds calculate; "//backslash
    write(iprt,"(10x,a)")"set defaultDistanceLabel '%0.3VALUE %UNITS'; "//backslash
    if (index(keywrd, " COMPARE") /= 0) then
      write(iprt,"(10x,a)")"select */2.1; color bonds green;  select none;"//backslash
    else
      write(iprt,"(10x,a)")"select none; "//backslash
    end if
    write(iprt,"(10x,a)")"set perspectivedepth off; "//backslash, &
    "connect 0.8  1.5 (hydrogen) (phosphorus) create; "//backslash
    if (l_geo_ref) then
      write(iprt,"(10x,a)")"set zoomLarge false; frame 0;"" "
    else
      write(iprt,"(10x,a)")"set zoomLarge false;"" "
    end if
    write(iprt,"(a)") "} "
    write(iprt,"(a)") "$(""#mydiv"").html(Jmol.getAppletHtml(""jmolApplet0"",Info))}); "
    write(iprt,"(a)") "</script>"
    write(iprt,"(a)") "<!--"," ","   End of JSmol script"," ", "-->"
    if (len_trim(koment) == 0 .or. (index(koment(:8), " NULL") /= 0) ) then
      write(iprt,"(a)") "<h1 align=""center"">"//input_fn(:len_trim(input_fn) - 5)//"</h1>"
    else
      line_1 = trim(koment(it:))
      line = " "
      do i = 1, len_trim(line_1)
        j = len_trim(line) + 1
        if (line_1(i:i) == " ") then
          line(j:) = "&nbsp;"
        else
          line(j:j) = line_1(i:i)
        end if
      end do
    write(iprt,"(a)") "<h1 align=""center"">"//trim(line)//"</h1>"
    end if
    if (len_trim(title) /= 0 .and. (index(title(:8), " NULL") == 0) ) &
      write(iprt,"(a)") '<h2 align="center">'//trim(title)//'</h2>'
    if (index(keywrd, " COMPARE") /= 0) then
      write(iprt,"(a)")"<h2 align=""center"">Compare """//trim(geo_dat_name)// &
      & """ and ""<span style=""color:green"">"//trim(geo_ref_name)//"</span>""</h2>"
    end if
    write(iprt,"(a)") "<BODY  BGCOLOR=""#ffffff"">"
!
!  Start of table.  The table consists of two side-by-side cells
!  The first entry in the first cell is a table of size three rows, two columns
!
    write(iprt,"(a)")"<TABLE>", "<TD>", "<TABLE>", "<TR>"
    if (nres < limres) then
!
!   Element(1,1) and (2,1)
!
      write(iprt,"(a)") "<TD colspan=""2"">"
      call write_data_to_html(iprt)
      write(iprt,"(a)") "</TD></TR><TR>"
    end if
!
!   Element(1,2)
!
    if (index(keywrd, " COMPARE") /= 0) then
      write(iprt,"(a)") "<TD>Toggle display<br><a href=""javascript:Jmol.script(jmolApplet0,'"
    else
      write(iprt,"(a)") "<TD><a href=""javascript:Jmol.script(jmolApplet0,'"
    end if
    write(iprt,"(a)") "if (isOK1);  Display *; zoom 0; isOK1 = FALSE; else hide *; "
    line = " "
    biggest_res = 0
    do i = 1, nres
      n_res = "["//res_txt(i)(:3)//"]"
      j = nint(reada(res_txt(i),4))
      biggest_res = max(biggest_res, j)
      if (j < 0) then
        num = char(Int(log10(-j + 1.0)) + ichar("1"))
        write(n_res(6:),'(a1,i'//num//',a)')"_", -j, res_txt(i)(8:9)
      else
        num = char(Int(log10(j + 1.0)) + ichar("2"))
        write(n_res(6:),'(i'//num//',a)')j, res_txt(i)(8:9)
      end if
      wrt_res = n_res(2:4)//n_res(6:)
      wrt_res(2:2) = char(ichar(wrt_res(2:2)) + ichar("a") - ichar("A"))
      wrt_res(3:3) = char(ichar(wrt_res(3:3)) + ichar("a") - ichar("A"))
      j = len_trim(line)
      if (j > 120) then
        j = 0
        write(iprt,"(a)")trim(line)
        line = " "
      end if
      l_res = res_txt(i)(:7)//res_txt(i)(9:9)
      if (l_res(1:1) >= "0" .and. l_res(1:1) <= "9") &
        l_res(1:1) = char(ichar("A") + ichar(l_res(1:1)) - ichar("0"))
      k = index(l_res, "-")
      if (k > 0) l_res(k:k) = "_"
      write(line(j + 2:),"(a)") l_res//" = FALSE;"
    end do
    write(iprt,"(a)")trim(line)
    write(iprt,"(a)") "isOK1 = TRUE; isOK2 = FALSE; lzoom = TRUE; lcenter = TRUE;"
    if (index(keywrd, " COMPARE") /= 0) then
      write(iprt,"(a)") "endif;')""> 1&<span style=""color:green"">2</span></a>"
      write(iprt,"(a)")"<a href=""javascript:Jmol.script(jmolApplet0,'if (isOKone);  Display add */1.1; zoom 0; isOKone = FALSE;", &
        "else hide add */1.1; zoom 0; isOKone = TRUE;  lzoom = TRUE; lcenter = TRUE; endif;')""> 1</a>"
      write(iprt,"(a)")"<a href=""javascript:Jmol.script(jmolApplet0,'if (isOKtwo);  Display add */2.1; zoom 0; isOKtwo = FALSE;", &
        "else hide add */2.1; zoom 0; isOKtwo = TRUE;  lzoom = TRUE; "// &
      & "lcenter = TRUE; endif;')""><span style=""color:green"">2</span></a>"
    else
      write(iprt,"(a)") "endif;')"">Toggle display all</a>"
    end if
    write(iprt,"(a)")"</TD>"
!
!   Element(2,2)
!
    write(iprt,"(a)")"<TD><a href=""javascript:Jmol.script(jmolApplet0,'"
    write(iprt,"(a)")"if (lcenter);  lcenter = FALSE; else lcenter = TRUE; center {visible}; endif;"
    write(iprt,"(a)")"')"">Toggle center picture</a> </TD>","</TR> <TR>"
!
!   Element(1,3)
!
    write(iprt,"(a)")"<TD><a href=""javascript:Jmol.script(jmolApplet0,'console;')"">Console</a> </TD> "
    write(iprt,"(a)") ""
!
!   Element(2,3)
!
!
!   Element(1,4)
!
    write(iprt,"(a)")"<TD> <a href=""javascript:Jmol.script(jmolApplet0,'if (lzoom); zoom 0; "// &
      "select */2.1; color bonds green; select none; lzoom = FALSE; else lzoom = TRUE; "// &
    "end if ')"">Fit to screen</a> </TD></TR><TR>"
!
!   Element(2,4)
!
    write(iprt,"(a)")"<TD><a href=""javascript:Jmol.script(jmolApplet0,'display within(3,visible);"// &
      "select */2.1; color bonds green; select none; if (lzoom); zoom 0; end if ')"">Near Neighbors</a> </TD> "
     write(iprt,"(a)")"<TD><a href=""javascript:Jmol.script(jmolApplet0,'"// &
     "connect (all) (all) delete; connect; display add connected(visible); select *; hbonds calculate; select "// &
      " */2.1; color bonds green; select none; if (lzoom); delay 0.001; zoom 0; end if ')"">Connected Neighbors</a> </TD> "
    if (allocated(p)) then
      if (p(1) > -900.d0) then
        write(iprt,"(a)")"<TR><TD>"
        write(iprt,"(a)")"<a href=""javascript:Jmol.script(jmolApplet0,'if (!lcharge_x); "
        write(iprt,"(a)")"frame 0; var use = {visible}; frame 1; select off; var sel = use;"
        write(iprt,"(a)")"var z = 0; for (var i IN @sel){z = 3}"
        write(iprt,"(a)")"if (z = 3); use = sel; endif;"
        write(iprt,"(a)")"for (var x IN @use){select @x; var txt =  (x.temperature > 0 ? "//backslash// &
          "'+"//backslash//"':"//backslash//"'"//backslash//"')"// &
          "+format("//backslash//"'%1.3f"//backslash//"',x.temperature*0.1 ); label @txt; color label black;"
        write(iprt,"(a)")"set labelOffset 0 0;}  select @sel; lcharge_x= TRUE;"
        write(iprt,"(a)")"else lcharge_x= FALSE; var use = {visible}; var sel = {selected};"
        write(iprt,"(a)")"var z = 0; for (var i IN @sel){z = 3}"
        write(iprt,"(a)")"if (z = 3); use = sel; endif;"
        write(iprt,"(a)")"select @use; label OFF; select @sel; end if ')"">Charges as Nos.</a>"

        write(iprt,"(a)")"</TD><TD>"
        write(iprt,"(a)")"<a href=""javascript:Jmol.script(jmolApplet0,'if (!lcharge_s); "
        write(iprt,"(a)")"frame 0; var use = {visible}; frame 1; select off; var sel = use;"
        write(iprt,"(a)")"var z = 0; for (var i IN @sel){z = 3}"
        write(iprt,"(a)")"if (z = 3); use = sel; endif;"
        write(iprt,"(a)")"for (var x IN @use)"
        write(iprt,"(a)")"{select @x; var txt =  @x.temperature*0.05;"
        write(iprt,"(a)")"if (@txt > 0){spacefill @txt; color atom deepskyblue;}"
        write(iprt,"(a)")"if (!@txt > 0){txt = -txt; spacefill @txt; color atom deeppink;}}"
        write(iprt,"(a)")"select @sel; lcharge_s= TRUE;"
        write(iprt,"(a)")"else lcharge_s= FALSE; var use = {visible}; var sel = {selected};"
        write(iprt,"(a)")"var z = 0; for (var i IN @sel){z = 3}"
        write(iprt,"(a)")"if (z = 3); use = sel; endif;"
        write(iprt,"(a)")"select @use; spacefill 15%; color cpk; select @sel; end if ')"">Charges as Sizes</a>"
        write(iprt,"(a)")"</TD></TR>"
      end if
    end if
    if (index(keywrd,  " IRC") + index(keywrd,  " STEP=") /= 0) then
!
!  Animation instructions
!
      write(iprt,"(a)")"<TR><TD> <a href=""javascript:Jmol.script(jmolApplet0,'model first;')"">first</a> </TD>"
      write(iprt,"(a)")"<TD> <a href=""javascript:Jmol.script(jmolApplet0,'model last;')"">last</a> </TD></TR>"
      write(iprt,"(a)")"<TR><TD> <a href=""javascript:Jmol.script(jmolApplet0,'model prev;')"">previous</a></TD> "
      write(iprt,"(a)")"<TD> <a href=""javascript:Jmol.script(jmolApplet0,'model next;')"">next</a> </TD></TR>"
      write(iprt,"(a)")"<TR><TD> <a href=""javascript:Jmol.script(jmolApplet0,'animation mode loop 0 0;animation play;')"">"// &
      "loop</a>&nbsp;&nbsp;"
      write(iprt,"(a)")"<a href=""javascript:Jmol.script(jmolApplet0,'animation off;')"">off</a> </TD> "
      write(iprt,"(a)")"<TD> <a href=""javascript:Jmol.script(jmolApplet0,'animation mode palindrome 0 0;animation play;')"">"// &
      "palindrome</a> </TD></TR>"
!
! End of animation instructions
!
    end if
    write(iprt,"(a)") "<TR>"
!
!   Element(1,5)
!
    line = input_fn(:len_trim(input_fn) - 4)//"txt"
    line_1 = trim(line)
    call upcase(line_1, len_trim(line_1))
    i = 0
    do j = 1, len_trim(line) - 4
      if (line(j:j) == "/" .or. line(j:j) == backslash) then
        i = j
      end if
    end do
    if (i /= 0) line = line(i + 1:)
    write(iprt,"(a)")"<TD colspan=""2""><a href=""javascript:Jmol.script(jmolApplet0,'script common.txt;')"">"// &
    "<strong style=""font-size:20px"">Common Script</strong>"
    write(iprt,"(a)")"</a>&nbsp; (Read file from:<br> ""<a href=""common.txt""  target=""_blank"">common.txt</a>"")</TD>"
    write(iprt,"(a)")"</TR> <TR>"
    write(iprt,"(a)")"<TD colspan=""2""><a href=""javascript:Jmol.script(jmolApplet0,'script "//backslash// &
    "'"//trim(line)//backslash//"';')"">"//"<strong style=""font-size:20px"">Specific Script</strong>"
    write(iprt,"(a)")"</a>&nbsp; (Read file from:<br> ""<a href="""//trim(line)// &
    """  target=""_blank"">"//trim(line)//"</a>"")</TD>"
    write(iprt,"(a)")"</TR></TABLE>"
!
!  The second entry in the first cell is a table of size (nres/5) rows, ncol columns.
!  Write all residues in table form
!
    if (nres > 0) then
      write(iprt,"(a)")"<p align=""center"">Toggle Individual Residues</p>"
      write(iprt,"(a)") "<TABLE>"
      write(iprt,"(a)") "<TR>"
!
! Number of rows is a maximum of 36.
! If the number of residues is small, put 8 residues on a line
!
      ncol = max(7, nres/16) + 1
      nprt = 1
      do i = 1, nres
        n_res = "["//res_txt(i)(:3)//"]"
        j = nint(reada(res_txt(i),4))
        if (j < 0) then
          num = char(Int(log10(-j + 1.0)) + ichar("2"))
          write(n_res(6:),'(i'//num//',a)')j, res_txt(i)(8:9)
        else
          num = char(Int(log10(j + 1.0)) + ichar("1"))
          write(n_res(6:),'(i'//num//',a)')j, res_txt(i)(8:9)
        end if
        if (maxtxt == 27 .and. res_txt(i)(10:10) /= " ") then
          j = index(n_res,":")
          n_res = n_res(:j - 1)//"^"//res_txt(i)(10:10)//trim(n_res(j:))
        end if
        wrt_res = n_res(2:4)//n_res(6:)
        l_res = res_txt(i)(:7)//res_txt(i)(9:10)
  !
  !  Residue names must not start with a number.  If they do, convert them into a letter
  !  0 => A, 1 => B, etc.
  !
        if (l_res(1:1) >= "0" .and. l_res(1:1) <= "9") &
          l_res(1:1) = char(ichar("A") + ichar(l_res(1:1)) - ichar("0"))
        do j = 1, 23
          if (n_res(2:4) == tyres(j)) exit
        end do
        if (j > 23) then
          n_res(:5) = " "
          wrt_res(1:1) = "X"
        else
          wrt_res(1:1) = tyr(j)
          if (wrt_res(1:1) == "?") wrt_res(1:1) = "X"
        end if
        j = index(l_res, "-")
        if (j > 0) l_res(j:j) = "_"
        if (n_res(2:4) == "UNK") then
          if (res_txt(i)(1:3) == "UNK") then
            if (l_het_only) then
              n_res = res_txt(i)(4:7)
            else
              n_res = "[UNK]"//res_txt(i)(4:7)
            end if
          else
            n_res = res_txt(i)(4:7)
          end if
        end if
        write(iprt,"(2a)") "<TD> <a href=""javascript:Jmol.script(jmolApplet0,'if (!"//l_res, &
        ");   display ADD "//trim(n_res)//";  "//l_res//" = TRUE; else "
        write(iprt,"(2a)") " hide ADD "//trim(n_res)//";  "//l_res//" = FALSE; end if; ", &
        "if (lcenter); center {visible}; endif; if (lzoom); zoom 0; endif;')"" class=""auto-style5"">  "
        j = index(wrt_res, "^")
        if (j > 0) wrt_res = wrt_res(:j - 1)//wrt_res(j + 1:)
        if (index(wrt_res,":") /= 0) then
          j = index(wrt_res,":") + 1
          write(iprt,"(2a)")"<p class=""auto-style4"">"//wrt_res(1:1)//"<br>"//wrt_res(4:j - 2)//"</p> </a></TD>"
        else
          write(iprt,"(2a)")"<p class=""auto-style4"">"//wrt_res(1:1)//"<br>"//wrt_res(4:)//"</p> </a></TD>"
        end if
        if (nprt == ncol) then
          nprt = 1
          write(iprt,'(a)')"</TR> <TR>"
        else
          nprt = nprt + 1
        end if
      end do
      write(iprt,"(a)") "</TR>"
      write(iprt,"(a)") "</TABLE><br> "
    end if
!
!  End of table of residues, and end of the first cell, now to write the JSmol picture (in the cell (1,2))
!
    write(iprt,"(a)") " </TD><TD>"
    if (nres >= limres) then
!
!   Element(1,1) and (2,1)
!
   !   write(iprt,"(a)") "<TD colspan=""2"">"
      call write_data_to_html(iprt)
   !   write(iprt,"(a)") "</TD></TR><TR>"
    end if
    write(iprt,"(a)") "<span id=mydiv></span><a href=""javascript:Jmol.script(jmolApplet0)""></a></TD></TABLE>"
    write(iprt,"(a)") "</BODY>"
    write(iprt,"(a)") "</HTML>"
!
!  Write out a simple script file
!
    close (iprt)
    line = line(:len_trim(line) - 3)
    call add_path(line)
    inquire (file=trim(line)//"txt", exist = exists)
    if (.not. exists) then
      open(unit=iprt, file=trim(line)//"txt")
      i = 0
      do j = 1, len_trim(line)
        if (line(j:j) == "/" .or. line(j:j) == backslash) i = j
      end do
      if (i /= 0) line = line(i + 1:)
      write(iprt,"(a)")"#","# Script for use with the HTML file """//trim(line)//"html""","#"
    end if
    close (iprt)
  end subroutine write_html
  subroutine write_data_to_html(iprt)
    use molkst_C, only : numat, formula, escf, nelecs, keywrd, arc_hof_1, arc_hof_2, &
      density, id, mol_weight, stress
    USE parameters_C, only : tore
    use common_arrays_C, only: nat, tvec
    use chanel_C, only: log
    use funcon_C, only : fpc_10
    implicit none
    integer :: iprt
    integer :: i, j, k, l, eqls, colon
    character :: idate*24, line*120
    logical :: store_log
    double precision :: sum
    integer, external :: quoted
    double precision, external :: volume
!
!  Print out information on the system: formula, number of atoms, heat of formation, date, etc.
!
    write(iprt,"(a)")"<TABLE>"
    call fdate (idate)
    write(iprt,"(a)")  "<TR><TD> Date:</TD><TD> &nbsp;&nbsp; &nbsp;</TD><TD>"// &
      idate(5:11)//idate(21:)//idate(11:16)//"</TD></TR>"
    write(iprt,"(a,i5,a)")  "<TR><TD> No. atoms:</TD><TD> &nbsp;&nbsp; &nbsp;</TD><TD>", &
      numat,  "</TD></TR>"
    store_log = log
    log = .false.
    call empiri()
    log = store_log
    colon = index(formula, ":") + 1
    eqls = index(formula, "=") - 1
    line = " "
    do i = colon, eqls
      j = i + 1
      if ((formula(i:i) < "0" .or. formula(i:i) > "9") .and. formula(j:j) >= "0" .and. formula(j:j) <= "9") then
        line = trim(line)//formula(i:i)
        line = trim(line)//"<sub>"
      else if ((formula(j:j) < "0" .or. formula(j:j) > "9") .and. formula(i:i) >= "0" .and. formula(i:i) <= "9") then
        line = trim(line)//formula(i:i)
        line = trim(line)//"</sub>"
      else
        line = trim(line)//formula(i:i)
      end if
    end do
    write(iprt,"(a)")  "<TR><TD> Formula:</TD><TD> &nbsp;&nbsp; &nbsp;</TD><TD>"//trim(line)//"</TD></TR>"
    if (index(keywrd, " 0SCF") == 0 .or. quoted('GEO_REF="') == 0) then
       if (id == 3) then
        sum = volume(tvec,3)
        density = mol_weight*1.D24/fpc_10/sum
        if (density > 1.d-1) write(iprt,"(a,f7.3,a)")  &
        "<TR><TD> Density:</TD><TD> &nbsp;&nbsp; &nbsp;</TD><TD>",density,"</TD></TR>"
      end if
    else
      if (abs(arc_hof_1) > 1.d-4) then
        if ( quoted('GEO_DAT="') /= 0) then
          write(iprt,"(a,f12.3,a)")  "<TR><TD> GEO_DAT:</TD><TD> &nbsp;&nbsp; &nbsp;</TD><TD>", &
          arc_hof_1," kcal/mol</TD></TR>"
        else
          write(iprt,"(a,f12.3,a)")  "<TR><TD> Dataset:</TD><TD> &nbsp;&nbsp; &nbsp;</TD><TD>", &
          arc_hof_1," kcal/mol</TD></TR>"
        end if
      end if
      if (abs(arc_hof_2) > 1.d-4) &
      write(iprt,"(a,f12.3,a)")  "<TR><TD> <span style=""color:green""> GEO_REF:</span></TD><TD> &nbsp;&nbsp; &nbsp;</TD><TD>", &
        arc_hof_2," kcal/mol</TD></TR>"
      i = index(keywrd, " RMS_DIFF")
      if (i > 0) then
        i = index(keywrd(i:), "F=") + i + 1
        j = index(keywrd(i:), " ") + i - 2
        k = index(keywrd, " DIFF=") + 6
        l = k
        do l = l, len_trim(keywrd)
          if (keywrd(l:l) >= "0" .and. keywrd(l:l) <= "9") exit
        end do
        l = index(keywrd(l:)," ") + l - 2
        write(iprt,"(a)")  "<TR><TD> RMSD: "//keywrd(i:j)//"&Aring;</TD><TD> </TD><TD>Diff: "//keywrd(k:l)//"&Aring;</TD></TR>"
      end if
    end if
    if (index(line, "H") /= 0 .and. nelecs > 0) then
!
!  Net charge has to be worked out the hard way
!
      sum = -nelecs
      do i = 1, numat
        sum = sum + tore(nat(i))
      end do
      i = nint(sum)
      if (i /= 0) then
        write(iprt,"(a,SP,i6,SS,a)")"<TR><TD> Net charge:</TD><TD> &nbsp;&nbsp; &nbsp;</TD><TD>",i,"</TD></TR>"
      else
          write(iprt,"(a)")"<TR><TD> Net charge:</TD><TD> &nbsp;&nbsp; &nbsp;</TD><TD>Zero</TD></TR>"
      end if
    end if
    if (abs(escf) > 1.d-10) then
      if (abs(escf) > 1.d-10) &
        write(iprt,"(a, f12.3)")"<TR><TD> Heat of Formation:</TD><TD> &nbsp;&nbsp; &nbsp;</TD><TD>", &
        escf - stress," Kcal/mol</TD></TR>"
    end if
    write(iprt,"(a)")  "</TABLE>"
  end subroutine write_data_to_html

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine paths()
!-----------------------------------------------
!   Follow a reaction path in which the values of the coordinate are supplied by the user
!-----------------------------------------------
    use molkst_C, only : iflepo, numat, keywrd, nvar, tleft, &
          & time0, escf, norbs, moperr, line, nl_atoms
    use maps_C, only : lparam, react, latom, rxn_coord
    use common_arrays_C, only : geo, xparam, na, hesinv, l_atom, nat, coord
    use ef_C, only : alparm, x0, x1, x2, iloop
    use chanel_C, only : iw0, iw, ires, restart_fn, ixyz, xyz_fn
    use elemts_C, only : elemnt
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
    implicit none
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
    integer :: maxcyc, i, j, ii, lpr, npts, iw00, percent = 0, ipdb = 14, imodel = 0
    double precision :: x3, c3, cc1, cc2, cb1, cb2, delf0, delf1, aconst, bconst, cconst, c1
    logical :: lef, debug
    double precision, external :: reada, seconds
!-----------------------------------------------

!***********************************************************************
!
!   PATH FOLLOWS A REACTION COORDINATE.   THE REACTION COORDINATE IS ON
!        ATOM LATOM, AND IS A DISTANCE IF LPARAM=1,
!                           AN ANGLE   IF LPARAM=2,
!                           AN DIHEDRALIF LPARAM=3.
!
!***********************************************************************
    iloop = 1! Counter for reaction coordinate steps
    iw00 = iw0
    debug = (index(keywrd, " DEBUG") /= 0)
    if (index(keywrd, " PDBOUT") /= 0) &
      open(unit = ipdb, file = xyz_fn(:len_trim(xyz_fn) - 3)//"pdb")
    open(unit=ixyz, file=xyz_fn)
    if (.not. debug) iw0 = -1
    if (allocated(hesinv)) deallocate(hesinv)
    allocate (hesinv(nvar*nvar))
    hesinv = 0.0D00

! Set a maximum of reaction coordinate steps (BIGCYCLES)
    maxcyc = 100000
    if (index(keywrd,' BIGCYCLES') /= 0) &
          maxcyc = nint(reada(keywrd,index(keywrd,' BIGCYCLES')))

! Use LBFGS optimizer as default, EF on demand
    lef = (index(keywrd,' LBFGS') == 0 .and. nvar <101)

    if (allocated(alparm)) deallocate(alparm)
    allocate(alparm(3, nvar))
    alparm = 0.d0

! Initialize if RESTART
    CheckRestart: if (lef) then
        write (iw, '(''  ABOUT TO ENTER EF FROM PATH'')')
        if (index(keywrd,'RESTAR') /= 0) then
            open(unit=ires, file=restart_fn, status='UNKNOWN', &
                  & form='UNFORMATTED', position='asis')
            rewind ires
            read (ires, end=120, err=120) i, j
            if (norbs /= j .or. numat /= i) then
                call mopend("Restart file read in does not match current data set")
                goto 99
            end if
            read (ires, end=120, err=120) ((alparm(j,i),j=1,3),i=1,nvar)
            read (ires, end=120, err=120) iloop, x0, x1, x2
            close (ires)
        end if

    else
        write (iw, '(''  ABOUT TO ENTER LBFGS FROM PATH'')')
        if (index(keywrd,'RESTAR') /= 0) then
          call mopend(" RESTART is not supported in a path calculation unless EF is used")
          write(iw,'(10x, "(Edit the previous PATH output to make a new job that"'// &
          '"starts the path where the previous path stopped)")')
          return
        end if

    end if CheckRestart

! Conversion factor for angles
    if (lparam /= 1 .and. na(latom) /= 0) then
        c1 = 57.29577951308232D0
    else
        c1 = 1.D0
    end if

    FirstReactionStep: if (iloop <= 1) then
        time0 = seconds(1)
        if (maxcyc == 0) tleft = -100.D0
        if (lef) then
            call ef (xparam, escf)
        else
            call lbfgs (xparam, escf)
        end if
        i = index(keywrd,'RESTAR')
        if (i /= 0) keywrd(i:i+6) = " "
        if (iw00 > -1) then
            write (line, '('' :'',F16.5,F16.6)') geo(lparam,latom)*c1, escf
            call to_screen(line)
        end if
        if (moperr) goto 99
        if (iflepo == (-1)) goto 99
        write (iw, '(''  OPTIMIZED VALUES OF PARAMETERS, INITIAL POINT'')')
        if (index(keywrd, " PDBOUT") /= 0) then
          imodel = imodel + 1
          write(ipdb,'(a,i7)')"MODEL",imodel
          call pdbout(ipdb)
          write(ipdb,'(a)')"ENDMDL"
        end if
        call writmo
        time0 = seconds(1)
    end if FirstReactionStep

    NextReactionStep: if (iloop <= 2) then
        geo(lparam,latom) = react(2)

        SecondReactionStep: if (iloop == 1) then
            x0 = react(1)
            x1 = x0
            x2 = react(2)
            if (x2 < (-100.D0)) call mopend ('Error in PATHS')
            if (x2 < (-100.D0)) goto 99
            alparm(2,:nvar) = xparam(:nvar)
            alparm(1,:nvar) = xparam(:nvar)
            iloop = 2
        end if SecondReactionStep

        if (maxcyc == 1) tleft = -100.D0
        if (lef) then
            call ef (xparam, escf)
        else
            call lbfgs (xparam, escf)
        end if
        if (iw00 > -1) then
            write (line, '('' :'',F16.5,F16.6)') geo(lparam,latom)*c1, escf
            call to_screen(line)
        end if
        if (iflepo == (-1)) goto 99
        rxn_coord = react(2)
        if (lparam > 1 .and. na(latom) > 0) then
            rxn_coord = rxn_coord*57.29577951308232D0
            write (iw, &
                  '(1X,16(''*****''),2/17X,''REACTION COORDINATE = ''       ,F12.4,2X,A10,1&
                  &9X,2/1X,16(''*****''))') rxn_coord, 'DEGREES   '
        else
            write (iw, &
                  '(1X,16(''*****''),2/17X,''REACTION COORDINATE = ''       ,F12.4,2X,A10,1&
                  &9X,2/1X,16(''*****''))') rxn_coord, 'ANGSTROMS   '
        end if

        call writmo
!
!  Write out "xyz" file
!
        write(ixyz,"(i6,a)") nl_atoms," "
        write(ixyz,*)"PATH "
        do i = 1, numat
          if (l_atom(i)) write(ixyz,"(3x,a2,3f15.5)")elemnt(nat(i)), (coord(j,i),j=1,3)
        end do
        if (index(keywrd, " PDBOUT") /= 0) then
          imodel = imodel + 1
          write(ipdb,'(a,i7)')"MODEL",imodel
          call pdbout(ipdb)
          write(ipdb,'(a)')"ENDMDL"
        end if
        time0 = seconds(1)
        alparm(3,:nvar) = xparam(:nvar)
        if (iloop == 2) iloop = 3
    end if NextReactionStep

! Find number of reaction path steps
    lpr = iloop
    do npts = 1,10000
        if (react(npts) < -100.D0) exit
    end do

    MainLoop: do ii = lpr, npts - 1
        iloop = ii
        if (iloop - lpr > maxcyc - 3) then
            tleft = -100.D0
        end if
        rxn_coord = react(iloop)
        if (lparam > 1 .and. na(latom) > 0) then
            rxn_coord = rxn_coord*57.29577951308232D0
            write (iw, &
                  '(1X,16(''*****''),2/17X,''REACTION COORDINATE = '',F12.4,2X,A10,19X,2/1X,16(''*****''))') &
                  rxn_coord, 'DEGREES   '
        else
            write (iw, &
                  '(1X,16(''*****''),2/17X,''REACTION COORDINATE = '',F12.4,2X,A10,19X,2/1X,16(''*****''))') &
                  rxn_coord, 'ANGSTROMS   '
        end if

! Determine type of interpolation
        x3 = react(iloop)
        c3 = (x0*x0 - x1*x1)*(x1 - x2) - (x1*x1 - x2*x2)*(x0 - x1)
        if (abs(c3) < 1.D-8) then
 ! Linear interpolation
            cc1 = 0.D0
            cc2 = 0.D0
        else
 ! Quadratic interpolation
            cc1 = (x1 - x2)/c3
            cc2 = (x0 - x1)/c3
        end if
        cb1 = 1.D0/(x1 - x2)
        cb2 = (x1*x1 - x2*x2)*cb1

! Calculate the interpolated coordinates
        do i = 1, nvar
            delf0 = alparm(1,i) - alparm(2,i)
            delf1 = alparm(2,i) - alparm(3,i)
            aconst = cc1*delf0 - cc2*delf1
            bconst = cb1*delf1 - aconst*cb2
            cconst = alparm(3,i) - bconst*x2 - aconst*x2**2
            xparam(i) = cconst + bconst*x3 + aconst*x3**2
            alparm(1,i) = alparm(2,i)
            alparm(2,i) = alparm(3,i)
        end do

! Check that the guessed geometry is not too absurd
        CheckGeo: do i = 1, nvar
            if (abs(xparam(i)-alparm(3,i)) > 0.2D0) then
     ! Too large deviation, resort to old geometry
                write (iw, &
                      '('' GEOMETRY TOO UNSTABLE FOR EXTRAPOLATION TO BE USED'',/,  &
                      & " - THE LAST GEOMETRY IS BEING USED TO START THE NEXT",'' CALCULATION'')')
                xparam(:nvar) = alparm(3,:nvar)
                exit CheckGeo
            end if
        end do CheckGeo

        x0 = x1
        x1 = x2
        x2 = x3
        geo(lparam,latom) = react(iloop)
       if (lef) then
            call ef (xparam, escf)
        else
            call lbfgs (xparam, escf)
        end if
        if (iw00 > -1) then
            i = nint((100.0*iloop)/npts)
            if (i /= percent) then
                percent = i
                write(line,"(i4,a)")percent, "% of Reaction Coordinate done"
                call to_screen(line)
            end if
            write (line, '('' :'',F16.5,F16.6)') geo(lparam,latom)*c1, escf
            call to_screen(line)
        end if
        if (iflepo == (-1)) goto 99
        if (index(keywrd, " PDBOUT") /= 0) then
          imodel = imodel + 1
          write(ipdb,'(a,i7)')"MODEL",imodel
          call pdbout(ipdb)
          write(ipdb,'(a)')"ENDMDL"
        end if
        call writmo
        time0 = seconds(1)
        alparm(3,:nvar) = xparam(:nvar)
    end do MainLoop

    iw0 = iw00
    goto 99
120 continue
    write (iw, '(2/10X,''Restart file is corrupt!'')')
    call mopend ('Restart file is corrupt!')
99  continue
    if (allocated(alparm)) deallocate(alparm)
    return
end subroutine paths

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine solrot(ni, nj, xi, xj, wj, wk, kr, e1b, e2a, enuc)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use common_arrays_C, only : tvec
      use molkst_C, only : numcal, l1u, l2u, l3u, clower
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: ni
      integer  :: nj
      integer , intent(inout) :: kr
      double precision , intent(out) :: enuc
      double precision , intent(in) :: xi(3)
      double precision , intent(in) :: xj(3)
      double precision , intent(out) :: wj(2025)
      double precision , intent(out) :: wk(2025)
      double precision , intent(inout) :: e1b(45)
      double precision , intent(inout) :: e2a(45)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: icalcn, i, j, k, kb
      double precision, dimension(:), allocatable :: wsum, wmax, wbits
      double precision, dimension(3) :: xjuc
      double precision, dimension(45) :: e1bits = 0.d0, e2bits = 0.d0
      double precision, dimension(3) :: xdumy
      double precision :: one, cutof2, r, enubit

      save xdumy, icalcn, cutof2
!-----------------------------------------------
!***********************************************************************
!
!   SOLROT FORMS THE TWO-ELECTRON TWO-ATOM J AND K INTEGRAL STRINGS.
!          ON EXIT WJ = "J"-TYPE INTEGRALS
!                  WK = "K"-TYPE INTEGRALS
!
!      FOR MOLECULES, WJ = WK.
!***********************************************************************
      data icalcn/ 0/
      data xdumy/ 3*0.D0/
      if (icalcn /= numcal) then
        icalcn = numcal
        cutof2 = clower**2
      end if
      one = 1.D0
      if (Abs(xi(1) - xj(1)) <1.d-20 .and. Abs(xi(2) - xj(2)) <1.d-20 .and. &
      Abs(xi(3) - xj(3)) <1.d-20) one = 0.5D0
      allocate (wsum(2025), wmax(2025), wbits(2025))
      wmax = 0.D0
      wsum = 0.D0
      wbits = 0.D0
      e1b = 0.D0
      e2a = 0.D0
      enuc = 0.D0
      do i = -l1u, l1u
        do j = -l2u, l2u
          do k = -l3u, l3u
            xjuc = xj + tvec(:,1)*i + tvec(:,2)*j + tvec(:,3)*k - xi
            r = xjuc(1)**2 + xjuc(2)**2 + xjuc(3)**2
            if (r > cutof2) then
!
!  Interaction distance is greater than cutoff, so use point-charge
!
              r = sqrt(r)
              call point(r, ni, nj, wbits, kb, e1bits, e2bits, enubit)
            else
!
!  Interaction distance is less than cutoff
!
              kb = 0
              call rotate (ni, nj, xdumy, xjuc, wbits, kb, e1bits, e2bits, enubit)
            end if
            wsum(:kb) = wsum(:kb) + wbits(:kb)
            if (wmax(1) < wbits(1)) wmax(:kb) = wbits(:kb) ! "K" integrals apply only to nearest pair
            e1b = e1b + e1bits
            e2a = e2a + e2bits
            enuc = enuc + enubit*one
          end do
        end do
      end do
      if (one < 0.9D0) wmax(:kb) = 0.D0
      wk(:kb) = wmax(:kb)
      wj(:kb) = wsum(:kb)
      kr = kb + kr
      deallocate(wmax, wbits, wsum)
      return
      end subroutine solrot
      subroutine nddo_to_point(wbits, e1bits, e2bits, enubit, r, ni, nj)
!
! NDDO_to_point smoothly transitions the two center integrals from NDDO to point-charge
! as the distance increases.  This is done by steadily mixing more and more point-charge
! contribution as the distance increases.
!
!  Up to 3 Angstroms, use "exact" NDDO, beyond 3 Angstroms, use a Gauusian mixture.
!
      use molkst_C, only : l_feather
        implicit none
        double precision, dimension(45) :: e1bits, e2bits, e1bits_p = 0.d0, e2bits_p = 0.d0
        double precision, dimension(2025) :: wbits
        double precision, intent (inout):: r
        double precision, intent (inout):: enubit
        integer, intent (in) :: ni, nj
        integer :: kb
        double precision :: const, enubit_p, dummy
        double precision, dimension(2025) :: wbits_p

        if (l_feather) then
          call to_point(r, dummy, const)
        else
          if (r < 3.0d0) return
          const = Exp (-0.025d0*(r - 3.d0)**2)
        end if
        call point (r, ni, nj, wbits_p, kb, e1bits_p, e2bits_p, enubit_p)
        wbits(1:kb) = const*wbits(1:kb) +(1.d0-const)*wbits_p(1:kb)
        e1bits = const*e1bits + (1.d0 - const)*e1bits_p
        e2bits = const*e2bits + (1.d0 - const)*e2bits_p
        enubit = const*enubit + (1.d0 - const)*enubit_p
      end subroutine nddo_to_point

  subroutine point (r, ni, nj, w, kr, e1b, e2a, enuc)
  use funcon_C, only : a0, ev
  use parameters_C, only : tore, natorb
  implicit none
  integer, intent (in) :: ni, nj
  integer, intent (out) :: kr
  double precision, intent (inout) :: r
  double precision, intent (out) :: enuc
  double precision, dimension (45), intent (out) :: e1b, e2a
  double precision, dimension (*), intent (out) :: w
  integer :: i, j, ii, jj, nii, njj
  double precision :: ee, ee1, ee2
  double precision, external :: trunk
!
!   In solid-state work, if an interatomic distance is larger than
!   clower, then the NDDO approximation is replaced by a point-charge
!   approximation, in which the point-charge is located at a distance
!   that depends on the interatomic distance (see trunk)
!
    r = trunk (r)
    ee = ev * a0 / r
    ee1 = -ee * tore(nj)
    ee2 = -ee * tore(ni)
    i = natorb(ni)
    j = natorb(nj)
    nii = (i*(i+1)) / 2
    njj = (j*(j+1)) / 2
    kr = nii * njj
    !
    !  Fill "w" array
    !
    w(1:kr) = 0.d0
    i_loop: do ii = 1, i
      j_loop: do jj = 1, j
        w(((ii*(ii+1))/2-1)*njj+ (jj*(jj+1))/2) = ee
      end do j_loop
    end do i_loop
    !
    ! Fill e1b and e2a
    !
    e1b(1:nii) = 0
    e2a(1:njj) = 0
    do ii = 1, i
      e1b((ii*(ii+1))/2) = ee1
    end do
    do jj = 1, j
      e2a((jj*(jj+1))/2) = ee2
    end do
    !
    !  Compute nuclear contribution
    !
    enuc = -ee1 * tore(ni)
end subroutine point
double precision function trunk (r)
!
!  In solids, change the apparent distance so that the Madelung sum can be
!  solved.
!
!   r: Distance in Angstroms
!
    use molkst_C, only: numcal, clower, cutofp, cupper
    implicit none
    double precision, intent (in) :: r
    integer, save :: icalcn = 0
    double precision, save :: bound1, bound2, c, clim, cr, cr2, range
    if (icalcn /= numcal) then
      bound1 = clower / cutofp
      !
      !   CUPPER = upper bound of truncation function, as a function of CUTOFP
      !
      cupper = cutofp + 0
      bound2 = cupper / cutofp
      range = bound2 - bound1
      !
      !   Truncation function = C+CR*R+CR2*R**2
      !
      c = -0.5d0 * bound1 ** 2 * cutofp / range
      cr = 1.0d0 + bound1 / range
      cr2 = -1 / (cutofp*2*range)
      !
      !   Above CUPPER function = constant
      !
      clim = c + cr * cupper + cr2 * cupper ** 2
      icalcn = numcal
    end if
   !
   !  Need a smooth function in the region of CUTOFP
   !
   !  Function has form:
   !    Up to CLOWER  R=R
   !    At CLOWER,  slope = 1.0
   !    Between CLOWER and CUPPER = Monotomic increase,
   !    with rate of increase dropping from 1.0 to 0.0
   !    At CUPPER, slope = 0
   !    Above CUTOFP   R=CUTOFP
    if (r > clower) then
      if (r > cupper) then
        trunk = clim
      else
        trunk = c + cr * r + cr2 * r ** 2
      end if
    else
      trunk = r
    end if
end function trunk

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  double precision function EC_plus_ER(D, H, A, q1, q2, EC, ER, d_list, nd_list)
!
! Based on "A Transferable H-bonding Correction For Semiempirical Quantum-Chemical Methods",
! by Martin Korth, Michal Pitonak, Jan Rezac and Pavel Hobza, J. Chem. Theory Comput., 2010, 6 (1), pp 344:352
!
  use common_arrays_C, only: coord, nat, nbonds, ibonds
  use molkst_C, only : Rab
  use parameters_C, only : dh2_a_parameters
  use funcon_C, only : pi, a0, eV, fpc_9
  implicit none
  integer :: D, H, A, R1, R2, R3, C_of_CO, i, nH, nC, nO, nN, N_of_HNCO, ii, nd_list, d_list(8)
  double precision :: q1, q2, EC, ER
  double precision :: angle_cos, r, torsion_check, angle, angle2_shift, &
    angle2_shift_2, torsion_shift, angle2_cos, angle2, angle2_cos_2, &
    torsion, torsion_cos, torsion2, torsion_2, torsion_ref, &
    torsion_cos_2, unit_part, attraction, torsion_correct, &
    expo, repulsion, rep_pre, rep_exp, c, sum, multiplier_a, sum_max
  logical :: torsion_check_set, peptide, torsion_check_set2, first = .true.
  double precision, external :: truncation
  logical, external :: connected
  save :: first
  if (first) then
    first = .false.
    dh2_a_parameters(1) = 1.48d0    ! Nitrogen
    dh2_a_parameters(2) = 1.56d0    ! Oxygen, generic
    dh2_a_parameters(3) = 1.55d0    ! Oxygen, acid
    dh2_a_parameters(4) = 0.96d0    ! Oxygen, peptide
    dh2_a_parameters(5) = 0.76d0    ! Oxygen, water
    dh2_a_parameters(6) = 0.85d0    ! Sulfur
  end if
  EC_plus_ER = 0.d0
  EC = 0.d0
  ER = 0.d0
  torsion_shift = 0.d0
  multiplier_a = 0.d0
  angle2_shift = 0.d0
  angle2_shift_2 = 0.d0
!
!  D is the atom that hydrogen atom H is attached to, and A is the distant acceptor
!
!
!  First angle
!
    call bangle (coord, D, H, A, angle)
    d_list(1) = D
    d_list(2) = H
    d_list(3) = A
    nd_list = 3
    angle_cos = -cos(angle)
    if (angle_cos < 0.d0) return
!
! get target angles
!
    torsion_check = 0.0
    torsion_check_set = .false.
    torsion_check_set2 = .false.
    if (nat(A) == 8 .or. nat(A) == 16) then
      if (nbonds(A) == 1) then
        angle2_shift = pi
        angle2_shift_2 = pi/(180.d0/120.d0)
        torsion_shift = 0.0
        torsion_check_set2 = .true.
      else
        angle2_shift = pi/(180.d0/109.48d0)
        angle2_shift_2 = angle2_shift
        torsion_shift = pi/(180.d0/54.74d0)
      end if
      if (nat(A) == 8) then
        multiplier_a = 0.d0
        if (nbonds(A) == 2) then
          if (nat(ibonds(1,A)) == 1 .and. nat(ibonds(2,A)) == 1) multiplier_a = dh2_a_parameters(5)   ! Water
        else if (nat(ibonds(1,A)) == 6) then
          C_of_CO =  ibonds(1,A)
          if (nbonds(C_of_CO) == 3) then
            nH = 0
            nC = 0
            nO = 0
            nN = 0
            do i = 1, 3
              if (nat(ibonds(i,C_of_CO)) == 1) nH = nH +1
              if (nat(ibonds(i,C_of_CO)) == 6) nC = nC +1
              if (nat(ibonds(i,C_of_CO)) == 7) then
                nN = nN +1
                N_of_HNCO = ibonds(i,C_of_CO)
              end if
              if (nat(ibonds(i,C_of_CO)) == 8) nO = nO +1
            end do
            if (nC + nH == 1 .and. nN == 1 .and. nO == 1) then
              peptide = .false.
!
!  Check that H-N-C-O exists and is trans
!
              nH = 0
              do i = 1, nbonds(N_of_HNCO)
                if (nat(ibonds(i,N_of_HNCO)) == 1) then
                  nH = nH + 1
                  call dihed (coord, A, C_of_CO, N_of_HNCO, ibonds(i,N_of_HNCO), sum)
                  sum = min(sum, 2*pi - sum)
                  if (sum > 0.5d0*pi) peptide = .true.
                end if
              end do
              if (peptide .and. nH > 0) multiplier_a = dh2_a_parameters(4)   ! peptide oxygen
            else if (nO == 2) then
              multiplier_a = dh2_a_parameters(3)   ! acid (carboxylate) oxygen
            end if
          end if
        end if
        if (multiplier_a < 1.d-20) multiplier_a  = dh2_a_parameters(2)   ! generic oxygen
      else
        multiplier_a = dh2_a_parameters(6)   ! sulfur
      end if
    else if (nat(A) == 7) then
      multiplier_a = dh2_a_parameters(1)   ! nitrogen
      if (nbonds(A) == 2) then
        angle2_shift = pi/(180.d0/120.d0)
        angle2_shift_2 = angle2_shift
        torsion_shift = 0.d0
      else
        angle2_shift = pi/(180.d0/109.48d0)
        angle2_shift_2 = angle2_shift
        torsion_shift = pi/(180.d0/54.74d0)
        torsion_check_set = .true.! NR3 group
      end if
    end if
!
!  extrapolation between tetrahedral and planar NR3 group
!
    R1 = 0
    if (nbonds(A) == 1) then
      R1 = ibonds(1,A)
      sum_max = 0.d0
      do ii = 1, nbonds(R1)
        i = ibonds(ii,R1)
!  if (i == A) cycle
       if ( .not. connected(i, H, 1000.d0**2)) return
        if (sum_max < Rab) then
          R2 = i
          sum_max = Rab
        end if
      end do
      R3 = H
    else if (nbonds(A) == 2) then
      sum_max = 0.d0
      do ii = 1, nbonds(A)
        i = ibonds(ii,A)
        if ( .not. connected(i, H, 1000.d0**2)) return
        if (sum_max < Rab) then
          sum_max = Rab
          R1 = i
        end if
      end do
      do ii = 1, nbonds(A)
        i = ibonds(ii,A)
        if (i == R1) cycle
        R2 = i
      end do
      R3 = H
    else if (nbonds(A) == 3) then
      sum_max = 0.d0
      do ii = 1, nbonds(A)
        i = ibonds(ii,A)
        if ( .not. connected(i, H, 1000.d0**2)) return
        if (sum_max < Rab) then
          sum_max = Rab
          R1 = i
        end if
      end do
      sum_max = 0.d0
      do ii = 1, nbonds(A)
        i = ibonds(ii,A)
        if (i == R1) cycle
        if ( .not. connected(i, H, 1000.d0**2)) return
        if (sum_max < Rab) then
          sum_max = Rab
          R2 = i
        end if
      end do
      do ii = 1, nbonds(A)
        i = ibonds(ii,A)
        if (i == R1 .or. i == R2) cycle
        R3 = i
      end do
      if (torsion_check_set) call dihed (coord, R2, R1, A, R3, torsion2)
      torsion_check = torsion2
      if (torsion_check <   -pi) torsion_check = torsion_check + 2.d0*pi
      if (torsion_check >    pi) torsion_check = torsion_check - 2.d0*pi
      if (torsion_check < 0.d0) then
        torsion_check = -pi - torsion_check
      else
        torsion_check =  pi - torsion_check
      end if
      sum = torsion_check
      if (sum <  0.d0) sum = -sum
      sum = 180.d0/pi*sum
      torsion_shift = torsion_shift + pi/(180.d0/((54.74d0 - sum)/54.74d0*35.26d0))
      angle2_shift=angle2_shift - pi/(180.d00/((54.74d0 - sum)/54.74d0*19.48d0))
      angle2_shift_2 = angle2_shift
    end if
    if (R1 == 0) return
!
! second angle
!
    call bangle (coord, R1, A, H, angle2)
    nd_list = nd_list + 1
    d_list(nd_list) = R1
    angle2_cos = cos(angle2_shift - angle2)
    angle2_cos_2 = cos(angle2_shift_2 - angle2)
    if (angle2_cos_2 > angle2_cos) angle2_cos = angle2_cos_2
    if (angle2_cos <= 0.d0) return
!
! torsion angle
! correction of NR3 torsion angle for through-bond case
!
      call dihed (coord, R2, R1, A, H, torsion_ref)
      nd_list = nd_list + 1
      d_list(nd_list) = R2
      torsion_correct = torsion_ref
      if (torsion_correct < -pi) torsion_correct = torsion_correct + 2.d0*pi
      if (torsion_correct >  pi) torsion_correct = torsion_correct - 2.d0*pi
      if (.not. torsion_check_set2 .or. Abs(torsion_correct) > 0.5d0*pi) then
        if (torsion_correct < 0.d0) then
          torsion_correct = -pi - torsion_correct
        else
          torsion_correct =  pi - torsion_correct
        end if
      end if


      if (torsion_check < 0.0) then ! negative torsion angle occupied by -NR3 r3
        torsion = torsion_shift - torsion_correct
        if (torsion <  -pi) torsion = torsion + 2.d0*pi
        if (torsion >   pi) torsion = torsion - 2.d0*pi
        torsion_cos = cos(torsion)
      else if (torsion_check > 0.0) then ! positive torsion angle occupied by -NR3 r3
        torsion = -torsion_shift - torsion_correct
        if (torsion <  -pi) torsion = torsion + 2.d0*pi
        if (torsion >   pi) torsion = torsion - 2.d0*pi
        torsion_cos = cos(torsion)
      else ! planar -NR3 or general case
        torsion = torsion_shift - torsion_correct
        torsion_2 = -torsion_shift - torsion_correct
        if (torsion <  -pi) torsion = torsion + 2.d0*pi
        if (torsion >   pi) torsion = torsion - 2.d0*pi
        if (torsion_2 <  -pi) torsion_2 = torsion_2 + 2.d0*pi
        if (torsion_2 >   pi) torsion_2 = torsion_2 - 2.d0*pi
        torsion_cos = cos(torsion)
        torsion_cos_2 = cos(torsion_2)
        if (torsion_cos_2 > torsion_cos) torsion_cos = torsion_cos_2
      end if
      if ( .not. connected(A, H, 1000.d0**2)) return
      r = Rab
      if ( .not. connected(R1, H, 1000.d0**2)) return
      if (torsion_check_set2 .and. r > Rab) torsion_cos = -1.d0
      if (torsion_cos <= 0.0) return
!
! distance cutoff as ad-hoc solution ...
!
!  To prevent a discontinuity in the gradients, make r a function of distance:
!
!  Above 1.85 Angstroms, r = r
!  Below 1.75 Angstroms r is increased to 1.80 Angstroms
!
    r = truncation(r, 1.80d0, 0.05d0)
    r = r/a0
    expo    = 3.d0    ! "b" in equation 2
    rep_pre = 0.65d0    ! "c" in equation 2
    rep_exp = 5.d0    ! "d" in equation 2
    unit_part = fpc_9*eV
    attraction = multiplier_a*q1*q2/r**expo*unit_part
    repulsion = rep_pre*rep_exp**(-r)*unit_part
    c = (attraction + repulsion)*angle_cos*angle2_cos*torsion_cos
    EC =       attraction*angle_cos*angle2_cos*torsion_cos
    ER =       repulsion*angle_cos*angle2_cos*torsion_cos
    EC_plus_ER = c
  end function EC_plus_ER

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine getgeg(iread, labels, geo, lopt, na, nb, nc)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : natoms, nvar, ndep, ltxt, line, keywrd, refkey
      use parameters_C, only : ams
      USE symmetry_C, ONLY: locpar, idepfn, locdep
      use common_arrays_C, only : atmass, loc, xparam, simbol, txtatm
      use chanel_C, only : iw
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: iread
      integer , intent(out) :: labels(*)
      integer , intent(out) :: lopt(3,*)
      integer , intent(out) :: na(*)
      integer , intent(out) :: nb(*)
      integer , intent(out) :: nc(*)
      double precision  :: geo(3,*)

!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(20) :: istart
      integer , dimension(:,:), allocatable :: lgeo
      integer :: i, nerr, numat, maxtxt, k, iline, nvalue, j, ivar, kerr, merr&
        , l, n, lerr
      double precision :: sum, degree
      logical :: leadsp
      character , dimension(:,:), allocatable :: tgeo*12
      character :: string*80
      character, dimension(107) :: elemnt*2
      double precision, external :: reada

      save elemnt
!-----------------------------------------------
      data (elemnt(i),i=1,107)/ ' H', 'HE', 'LI', 'BE', ' B', ' C', ' N', ' O'&
        , ' F', 'NE', 'NA', 'MG', 'AL', 'SI', ' P', ' S', 'CL', 'AR', 'K ', &
        'CA', 'SC', 'TI', ' V', 'CR', 'MN', 'FE', 'CO', 'NI', 'CU', 'ZN', 'GA'&
        , 'GE', 'AS', 'SE', 'BR', 'KR', 'RB', 'SR', ' Y', 'ZR', 'NB', 'MO', &
        'TC', 'RU', 'RH', 'PD', 'AG', 'CD', 'IN', 'SN', 'SB', 'TE', ' I', 'XE'&
        , 'CS', 'BA', 'LA', 'CE', 'PR', 'ND', 'PM', 'SM', 'EU', 'GD', 'TB', &
        'DY', 'HO', 'ER', 'TM', 'YB', 'LU', 'HF', 'TA', ' W', 'RE', 'OS', 'IR'&
        , 'PT', 'AU', 'HG', 'TL', 'PB', 'BI', 'PO', 'AT', 'RN', 'FR', 'RA', &
        'AC', 'TH', 'PA', 'U', 'NP', 'PU', 'AM', 'CM', 'BK', 'CF', 'XX', 'FM', &
        'MD', 'CB', '++', ' +', '--', ' -', 'TV'/
      allocate(tgeo(3,10000), lgeo(3,10000))
      k = 0
      nerr = 0
      numat = 0
      na(1) = 0
      nb(1) = 0
      nc(1) = 0
      nb(2) = 0
      nc(2) = 0
      nc(3) = 0
      maxtxt = 0
      do natoms = 1, 900
      geo(:,natoms) = 0.d0
        read (iread, '(A)', end=70, err=70) line
        if (line == ' ') exit
!
!   SEE IF TEXT IS ASSOCIATED WITH THIS ELEMENT
!
        i = index(line,'(')
        if (i /= 0) then
!
!  YES, ELEMENT IS LABELLED.
!
          k = index(line,')')
          txtatm(natoms) = line(i:k)
          maxtxt = max(maxtxt,k - i + 1)
          string = line(1:i-1)//line(k+1:)
          line = string
        else
          txtatm(natoms) = ' '
        end if
!***********************************************************************
        do i = 1, 80
          iline = ichar(line(i:i))
          if (iline<ichar('a') .or. iline>ichar('z')) cycle
          line(i:i) = char(iline + ichar('A') - ichar('a'))
        end do
!***********************************************************************
        nvalue = 0
        leadsp = .TRUE.
        do i = 1, 80
          if (leadsp .and. line(i:i)/=' ') then
            nvalue = nvalue + 1
            istart(nvalue) = i
          end if
          leadsp = line(i:i) == ' '
        end do
        do j = 1, 107
          if (index(' '//line(istart(1):istart(1)+2),elemnt(j)//' ') /= 0) &
            go to 40
        end do
        if (index(' '//line(istart(1):istart(1)+2),' X') /= 0) then
          j = 99
          go to 40
        end if
        write (iw, '(2A)') ' ELEMENT NOT RECOGNIZED: ', line(istart(1):istart(1)+2)
        nerr = nerr + 1
   40   continue
        labels(natoms) = j
        if (j /= 99 .and. j < 107) then
          numat = numat + 1
          atmass(numat) = ams(j)
        end if
        tgeo(1,natoms) = ' '
        tgeo(2,natoms) = ' '
        tgeo(3,natoms) = ' '
        if (natoms == 1) cycle
        na(natoms) = nint(reada(line,istart(2)))
        call getval (line(istart(3):), geo(1,natoms), tgeo(1,natoms))
        if (natoms == 2) cycle
        if (istart(4) == 0) cycle
        nb(natoms) = nint(reada(line,istart(4)))
        call getval (line(istart(5):), geo(2,natoms), tgeo(2,natoms))
        if (natoms == 3) cycle
        nc(natoms) = nint(reada(line,istart(6)))
        call getval (line(istart(7):), geo(3,natoms), tgeo(3,natoms))
      end do
   70 continue
      natoms = natoms - 1
      lgeo(:,:natoms) = -1
      ivar = -1
      nvar = 0
      ndep = 0
      kerr = 0
   90 continue
      read (iread, '(A)', end=180, err=180) line
      if (line == ' ') then
        if (ivar == (-1)) then
          merr = 0
          do i = 1, natoms
            merr = merr + count(geo(:,i)<(-998))
          end do
!
!  IF ALL SYMBOLS ARE DEFINED, THEN DO NOT READ 'FIXED' SYMBOLS
!
          if (merr == 0) go to 180
          ivar = nvar
          go to 90
        else
          go to 180
        end if
      end if
!***********************************************************************
      do i = 1, 80
        iline = ichar(line(i:i))
        if (iline<ichar('a') .or. iline>ichar('z')) cycle
        line(i:i) = char(iline + ichar('A') - ichar('a'))
      end do
!***********************************************************************
      do i = 1, 80
        if (line(i:i) == ' ') cycle
        exit
      end do
      do l = i, i + 12
        if (line(l:l) /= ' ') cycle
        exit
      end do
      sum = reada(line,l)
      n = 0
      lerr = 0
      do j = 1, natoms
        do k = 1, 3
          if (.not.(tgeo(k,j)==line(i:l) .or. tgeo(k,j)(2:)==line(i:l) .and. &
            tgeo(k,j)(1:1)=='-')) cycle
          if (lgeo(k,j) /= (-1)) lerr = 1
          lgeo(k,j) = lgeo(k,j) + 1
          n = n + 1
          geo(k,j) = sum
          if (n == 1) then
            nvar = nvar + 1
            loc(1,nvar) = j
            loc(2,nvar) = k
            xparam(nvar) = sum
            simbol(nvar)(:10) = tgeo(k,j)(:10)
            if (simbol(nvar)(1:1) == '-') then
              write (iw, '(A)') &
      ' NEGATIVE SYMBOLICS MUST BE PRECEEDED BY  THE POSITIVE EQUIVALENT'
              write (iw, '(A)') ' FAULTY SYMBOLIC:  '//simbol(nvar)
              call mopend (&
      'NEGATIVE SYMBOLICS MUST BE PRECEEDED BY THE POSITIVE EQUIVALENT')
              return
            end if
          end if
          if (n <= 1) cycle
          ndep = ndep + 1
          locpar(ndep) = loc(1,nvar)
          idepfn(ndep) = loc(2,nvar)
          if (tgeo(k,j)(1:1) == '-') then
            idepfn(ndep) = 14
            if (loc(2,nvar) /= 3) then
              kerr = kerr + 1
              write (iw, '(2A)') ' ONLY DIHEDRAL SYMBOLICS ', &
                ' CAN BE PRECEEDED BY A "-" SIGN'
            end if
          end if
          locdep(ndep) = j
        end do
      end do
      kerr = kerr + lerr
      if (lerr == 1) then
        write (iw, '(2A)') &
          ' THE FOLLOWING SYMBOL HAS BEEN DEFINED MORE THAN ONCE:', line(i:l)
        nerr = nerr + 1
      end if
      if (n == 0) then
        write (iw, '(2A)') ' THE FOLLOWING SYMBOLIC WAS NOT USED:', line(i:l)
        nerr = nerr + 1
      end if
      go to 90
  180 continue
      merr = 0
      do i = 1, natoms
        merr = merr + count(geo(:,i)<(-998))
      end do
      if (merr /= 0) write (iw, '(I4,A)') merr, &
        ' GEOMETRY VARIABLES WERE NOT DEFINED'
      if (merr + kerr + nerr /= 0) then
        write (iw, '(A,I3,A)') ' THE GEOMETRY DATA-SET CONTAINED', merr + kerr&
           + nerr, ' ERRORS'
        call mopend ('THE GEOMETRY DATA-SET CONTAINED ERRORS')
        return
      end if
!
!  SORT PARAMETERS TO BE OPTIMIZED INTO INCREASING ORDER OF ATOMS
!
      if (ivar /= (-1)) nvar = ivar
      do i = 1, nvar
        j = 100000
        do l = i, nvar
          if (j <= loc(1,l)*4 + loc(2,l)) cycle
          k = l
          j = loc(1,l)*4 + loc(2,l)
        end do
        string(1:10) = simbol(i)
        simbol(i) = simbol(k)
        simbol(k) = string(:10)
        sum = xparam(i)
        xparam(i) = xparam(k)
        xparam(k) = sum
        do j = 1, 2
          l = loc(j,i)
          loc(j,i) = loc(j,k)
          loc(j,k) = l
        end do
      end do
      loc(:,nvar+1:) = 0
!
! Convert to radians
!
      degree = 1.7453292519943D-02
      where (loc(2,:nvar) /= 1)
        xparam(:nvar) = xparam(:nvar)*degree
      end where
      geo(2:3,:natoms) = geo(2:3,:natoms)*degree
      ltxt = char(maxtxt)
!
!  Put optimization flage into LOPT in case this will be followed by
!  an OLDGEO calculation
!
      lopt(:,:natoms) = 0
      do i = 1, nvar
        lopt(loc(2,i),loc(1,i)) = 1
      end do
      if (nvar > 0 .and. index(keywrd, " SYMM") == 0) then
        i = index(refkey(1), "          ")
        refkey(1)(i:i + 9) = " SYMMETRY "
      end if
      return
      end subroutine getgeg

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine denrot()
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : norbs, numat, mpack, id, l1u, l2u, l3u, &
      mozyme
!
      use chanel_C, only : iw
      use elemts_C, only : elemnt
      use common_arrays_C, only : nat, geo, nfirst, nlast, coord, p, tvec
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(norbs) :: natom
      integer , dimension(5,35) :: irot
      integer , dimension(9) :: isp
      integer :: iprt, i, if, il, ipq, ii, i1, j1, j, mm, nn, kk, jf, jl, jpq, &
        jj, k, ll, l, l1, l2, ij, limit, na, m, ma, n
      double precision, dimension(9,9) :: arot
      double precision, dimension(3,5,5) :: c
      double precision, dimension(9,9) :: pab, vect
      double precision, dimension(:), allocatable :: b
      double precision :: delx, dely, delz, rmin, r, delxm, delym, delzm, sum
      character , dimension(21) :: line*6
      character , dimension(9) :: atorbs*7
      character, dimension(norbs) :: itext*7, jtext*2

      save irot, isp, atorbs
!-----------------------------------------------
!***********************************************************************
!
! DENROT PRINTS THE DENSITY MATRIX AS (S-SIGMA, P-SIGMA, P-PI) RATHER
!        THAN (S, PX, PY, PZ).
!
!***********************************************************************
      data atorbs/ 'S-SIGMA', 'P-SIGMA', '  P-PI ', '  P-PI ', 'D-SIGMA', &
        '  D-PI ', '  D-PI ', ' D-DELL', ' D-DELL'/
!**********************************************************************
! IROT IS A MAPPING LIST. FOR EACH ELEMENT OF AROT 5 NUMBERS ARE
! NEEDED. THESE ARE, IN ORDER, FIRST AND SECOND SUBSCRIPTS OF AROT,
! AND FIRST,SECOND, AND THIRD SUBSCRIPTS OF C, THUS THE FIRST
! LINE OF IROT DEFINES AROT(1,1)=C(1,3,3)
!
!**********************************************************************
      data irot/ 1, 1, 1, 3, 3, 2, 2, 2, 4, 3, 3, 2, 2, 2, 3, 4, 2, 2, 3, 3, 2&
        , 3, 2, 4, 2, 3, 3, 2, 2, 2, 4, 3, 2, 3, 2, 2, 4, 2, 4, 4, 3, 4, 2, 2, &
        4, 4, 4, 2, 3, 4, 5, 5, 3, 1, 5, 6, 5, 3, 4, 3, 7, 5, 3, 3, 3, 8, 5, 3&
        , 2, 3, 9, 5, 3, 5, 3, 5, 6, 3, 1, 2, 6, 6, 3, 4, 2, 7, 7, 3, 3, 2, 8, &
        6, 3, 2, 2, 9, 6, 3, 5, 2, 5, 7, 3, 1, 4, 6, 7, 3, 4, 4, 7, 7, 3, 3, 4&
        , 8, 7, 3, 2, 4, 9, 7, 3, 5, 4, 5, 8, 3, 1, 1, 6, 8, 3, 4, 1, 7, 8, 3, &
        3, 1, 8, 8, 3, 2, 1, 9, 8, 3, 5, 1, 5, 9, 3, 1, 5, 6, 9, 3, 4, 5, 7, 9&
        , 3, 3, 5, 8, 9, 3, 2, 5, 9, 9, 3, 5, 5/
      data isp/ 1, 2, 3, 3, 4, 5, 5, 6, 6/
      if (mozyme) then
        call denrot_for_MOZYME()
        return
      end if
      allocate(b(mpack))
      call gmetry (geo, coord)
      iprt = 0
      j1 = 0
      do i = 1, numat
        if = nfirst(i)
        il = nlast(i)
        ipq = il - if - 1
        ii = ipq + 2
        if (ii == 0) cycle
        do i1 = 1, ii
          j1 = iprt + isp(i1)
          itext(j1) = atorbs(i1)
          jtext(j1) = elemnt(nat(i))
          natom(j1) = i
        end do
        iprt = j1
        if (ipq /= 2) ipq = min(max(ipq,1),3)
        do j = 1, i
          delx = coord(1,j) - coord(1,i)
          dely = coord(2,j) - coord(2,i)
          delz = coord(3,j) - coord(3,i)
          if (id /= 0) then
            rmin = 100.D0
            delxm = 0.d0
            delym = 0.d0
            delzm = 0.d0
            do mm = -l1u, l1u
              do nn = -l2u, l2u
                do kk = -l3u, l3u
                  r = (tvec(1,1)*mm+tvec(1,2)*nn+tvec(1,3)*kk+delx)**2 + (tvec(&
                    2,1)*mm+tvec(2,2)*nn+tvec(2,3)*kk+dely)**2 + (tvec(3,1)*mm+&
                    tvec(3,2)*nn+tvec(3,3)*kk+delz)**2
                  if (r >= rmin) cycle
                  rmin = r
                  delxm = tvec(1,1)*mm + tvec(1,2)*nn + tvec(1,3)*kk + delx
                  delym = tvec(2,1)*mm + tvec(2,2)*nn + tvec(2,3)*kk + dely
                  delzm = tvec(3,1)*mm + tvec(3,2)*nn + tvec(3,3)*kk + delz
                end do
              end do
            end do
            delx = delxm
            dely = delym
            delz = delzm
          end if
          jf = nfirst(j)
          jl = nlast(j)
          jpq = jl - jf - 1
          jj = jpq + 2
          if (jj == 0) cycle
          if (jpq /= 2) jpq = min(max(jpq,1),3)
          pab = 0.D0
          kk = 0
          do k = if, il
            kk = kk + 1
            ll = 0
            pab(kk,:jl-jf+1) = p(jf + (k*(k-1))/2:jl + (k*(k-1))/2)
          end do
          call coe (delx, dely, delz, ipq, jpq, c, r)
          arot = 0.D0
          do i1 = 1, 35
            arot(irot(1,i1),irot(2,i1)) = c(irot(3,i1),irot(4,i1),irot(5,i1))
          end do
          l1 = isp(ii)
          l2 = isp(jj)
          vect = -1.D0
          j1 = 10
          j1 = 1
          if (l2 > 0) then
            vect(:l1,:l2) = 0.D0
            j1 = l2 + 1
          end if
          if (i /= j) then
            ij = max(ii,jj)
            do i1 = 1, ii
              do j1 = 1, jj
                sum = 0.D0
                do l1 = 1, ij
                  do l2 = 1, ij
                    sum = sum + arot(l1,i1)*pab(l1,l2)*arot(l2,j1)
                  end do
                end do
                vect(isp(i1),isp(j1)) = vect(isp(i1),isp(j1)) + sum**2
              end do
            end do
          end if
          k = 0
          do i1 = if, il
            k = k + 1
            l = 0
            do j1 = jf, jl
              l = l + 1
              if (j1 > i1) cycle
              b(j1+(i1*(i1-1))/2) = vect(k,l)
            end do
          end do
        end do
      end do
!
! NOW TO REMOVE ALL THE DEAD SPACE IN P, CHARACTERIZED BY -1.0
!
      l = 0
      do i = 1, mpack
        if (b(i) <= (-0.1D0)) cycle
        l = l + 1
        b(l) = b(i)
      end do
!
!   PUT ATOMIC ORBITAL VALENCIES ONTO THE DIAGONAL
!
      do i = 1, iprt
        sum = 0.D0
        ii = (i*(i - 1))/2
        do j = 1, i
          sum = sum + b(j+ii)
        end do
        do j = i + 1, iprt
          sum = sum + b((j*(j-1))/2+i)
        end do
        b((i*(i+1))/2) = sum
      end do
      line = '------'
      limit = (iprt*(iprt + 1))/2
      kk = 8
      na = 1
  190 continue
      ll = 0
      m = min0(iprt + 1 - na,6)
      ma = 2*m + 1
      m = na + m - 1
      write (iw, '(/16X,10(1X,A7,3X))') (itext(i),i=na,m)
      write (iw, '(15X,10(2X,A2,I3,4X))') (jtext(i),natom(i),i=na,m)
      write (iw, '(20A6)') (line(k),k=1,ma)
      do i = na, iprt
        ll = ll + 1
        k = (i*(i - 1))/2
        l = min0(k + m,k + i)
        k = k + na
        if (kk + ll > 50) then
          write (iw, '(/17X,10(1X,A7,3X))') (itext(n),n=na,m)
          write (iw, '( 17X,10(2X,A2,I3,4X))') (jtext(n),natom(n),n=na,m)
          write (iw, '(20A6)') (line(n),n=1,ma)
          kk = 4
          ll = 0
        end if
        write (iw, '(1X,A7,1X,A2,I3,10F11.6)') itext(i), jtext(i), natom(i), (b&
          (n),n=k,l)
      end do
      if (l >= limit) go to 220
      kk = kk + ll + 4
      na = m + 1
      if (kk + iprt + 1 - na <= 50) go to 190
      kk = 4
      go to 190
  220 continue
      deallocate (b)
      return
      end subroutine denrot

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine dfield()
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE parameters_C, only : tore
      USE molkst_C, only :numat, efield
      USE funcon_C, only : ev, a0, fpc_9
      use common_arrays_C, only : nat, p, dxyz
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i
      double precision, dimension(numat) :: q2
      double precision :: fldcon
!-----------------------------------------------
      call chrge (p, q2)
      q2(:numat) = tore(nat(:numat)) - q2(:numat)
!
!   FLDCON=(h/Ao)*(eV to Kcal/mol)
!
      fldcon = ev/a0*fpc_9
      do i = 1, numat
        dxyz(3*(i-1) + 1) = dxyz(3*(i-1) + 1) + efield(1)*q2(i)*fldcon
        dxyz(3*(i-1) + 2) = dxyz(3*(i-1) + 2) + efield(2)*q2(i)*fldcon
        dxyz(3*(i-1) + 3) = dxyz(3*(i-1) + 3) + efield(3)*q2(i)*fldcon
      end do
      return
      end subroutine dfield

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

! ____________________________________________________________________________
! _____________________ ARBITRARY - EXCITATION DET GENERATOR ___________________
! ____________________________________________________________________________

      subroutine excite (istsym, e, ci)

!     **** This generates spin - adapted determinates as SCF excitations	****
!     **** Uses fast code for single excitations from SCF reference det	****
!     **** or uses completely general code for Complete Active Space, 	****
!     **** single or double excitations from any number of reference	****
!     **** determinates.						****
!     **** The routine makes two passes: first, do determine the CI	****
!     **** state identity, second to generate the MP2 perturbation	****
!     **** corrections to all of the CI matrix elements.		****
      use reimers_C, only:  n, nb2, matind, nbt, nel, nshell, norb, &
          norbl, norbh, vnn, ixprd, nmrep, stwt, nptg, nr, ns, nslwr, &
          nsupr, istr, nsym, mofrag, icifrag, nconf, multci, nci, &
          ncore, nol, noh, nvl, nvh, nov, fastci, emaxci, nese, nciout, &
          icisym, nmp2, edef, ecore, eec, ee2, &
          ifst, afst, aor1, bor1, isc, tr1, nfact, vv, ifbinc, krefd, &
          aor, bor, aod, bod, ao1, bo1, aos, bos, cc0, gamma, beta, tot, &
          nbtmo, aocc, bocc, spintr, evalmo, nspn, nex, dbls, mspn, nold, &
          nvhd, nolc, nvhc, mrci

      USE molkst_C, only : norbs, nopen, nclose
      USE chanel_C, only : iw
      use cosmo_C, only  : useps

      implicit none
!     **** MP2 storage in excite and spcls ****
      double precision  e(nconf), ci(matind(nconf) + nconf + 1), &
                        ener, tel, xj12, xk12
      integer           vvs(4), vvd(4), a1, a, b, b1, maxunp, &
                        istsym(nconf), &
                        i1, icifrag1, iirefd, irefd, ismin, ispn, &
                        isynca, isyncb, &
                        j1, jconf, jconfm, &
                        jmin, maxoc, &
                        nalpha, nbeta, ndif, nelopn, nend, norbopn, nov2, nov4, &
                        nperm,  nv, nvs, nvd
      double precision, allocatable :: aii(:)
      logical           exok, maxmp2
      logical*1, allocatable :: aoc(:), boc(:)
      character*8       param
      integer           i, j, k
      double precision  ediel
      logical*1, external :: permca
      param = " "
      if (param == "xxxxxxxx") return
      ecore = 0.d0

!     **** determine n! ****
      n = norbs
      nb2 = n*(n + 1)/2
      icisym(1) = nconf
      emaxci = 1.d6

      nfact(0) = 1
      do i = 1, 10
        nfact(i) = nfact(i - 1) * i
      end do

      maxunp = multci
      if (dbls) maxunp = maxunp + 1
      if (mrci) maxunp = maxunp + min(noh - nolc + 1, nvhc - nvl + 1)
      mspn = nfact(maxunp*2) / nfact(maxunp)**2

!     **** determine basis - vector type of each MO ****
!     **** if type j = s, px, py, etc is present, then nbtmo bit j is set to 1 ****
      if(allocated(nbtmo)) deallocate(nbtmo)
      allocate(nbtmo(n))
      do i = 1, n
        do j = 0, 8
          ifbinc(j) = 0
        end do
        do k = 1, n
          if (abs(cc0(i, k)) > 1.d-5) ifbinc(nbt(k)) = 1
        end do
        nbtmo(i) = 0
        do j = 8, 0, - 1
          nbtmo(i) = nbtmo(i)*2 + ifbinc(j)
        end do
      end do
!     **** apply symmetry weights to MO coeffs ****

      if (allocated(stwt))  deallocate(stwt)
      if (allocated(isc))   deallocate(isc)
      if (allocated(istr))  deallocate(istr)
      if (allocated(nsym))  deallocate(nsym)
      allocate(stwt(n))
      allocate(isc(n))
      allocate(istr(8, n))
      allocate(nsym(n))

!     ************** debug: use this to turn off symmetry info ***********
      nptg = 1
      nr = 1
      ns(1) = 1
      nslwr(1) = 1
      nsupr(1) = n
      do i = 1, n
        stwt(i) = 1.D0
        nsym(i) = 1
        istr(1, i) = i
      end do

      do i1 = 1, n
!	**** stwt is set to nstr**(1/4) ****
        stwt(i1) = sqrt (1.D0/stwt(i1))
        isc(i1) = 0
      end do
      do i1 = 1, n
        i = istr(1, i1)
        if (isc(i).eq.0) then
          isc(i) = 1
          do j = 1, n
            cc0(j, i) = cc0(j, i) * stwt(i1)
          end do
        end if
      end do

!     ********** determine if it's a default or a specified CI **********

      fastci = .not. dbls .and. .not. mrci .and. (nopen.eq.nclose)

!     ************ initial setup of integral storage ***********
      nov = nvh - nol + 1
      nov2 = nov*(nov + 1)/2
      nov4 = nov2*(nov2 + 1)/2

      if(allocated(eec)) deallocate(eec)
      if(allocated(ee2)) deallocate(ee2)
      allocate(eec(nov2))
      allocate(ee2(nov4))

      if (fastci) then
        ifst = 0
      else

!       ********** calc energy of core of electrons (with nucleii) ************
!       **** code replaced in SCF routine by evaluating Fock matrix given *****
!       **** the density from the CI core only ... much much faster! **********

        tot = tot + vnn
        ecore = vnn
        do i = 1, ncore
          call inttr (i, i, i, i, cc0, gamma, nbtmo, xj12, xk12, 0)
          ecore = ecore + 2.D0*beta(matind(i) + i) + xj12
          do j = 1, i - 1
            call inttr (i, i, j, j, cc0, gamma, nbtmo, xj12, xk12, 0)
            ecore = ecore + 4.D0*xj12 - 2.D0*xk12
          end do
        end do
        ecore = ecore - tot

!       ******* set to default value storage for all possible integrals ******
!       **** eec(i, a) = sum_j - 2(i, a|j, j) + (i, j|a, j) with j in core and	****
!       **** i, a in x - space; matrix stored in symmetric mode.		****
!       **** eec(i, j, a, b) = (i, j|a, b) with i, j, a, b in x - space.		****

        edef = 1.D20
        j = nov*(nov + 1)/2
        do i = 1, j
          eec(i) = sngl(edef)
        end do
        j = j*(j + 1)/2
        do i = 1, j
          ee2(i) = sngl(edef)
        end do

      end if

      jconf = 0
      nmp2 = 0
      jconfm = 0
      do k = 1, nr
        nci(k) = 0
      end do
!     ******************** form determinants ***************************
!     **** loop over reference determinates; first read alpha occupancy ****z
      if(allocated(vv))  deallocate(vv)
      if(allocated(aor)) deallocate(aor)
      if(allocated(bor)) deallocate(bor)
      if(allocated(aor1)) deallocate(aor1)
      if(allocated(bor1)) deallocate(bor1)
      if(allocated(aos)) deallocate(aos)
      if(allocated(bos)) deallocate(bos)
      if(allocated(aod)) deallocate(aod)
      if(allocated(bod)) deallocate(bod)
      if(allocated(ao1)) deallocate(ao1)
      if(allocated(bo1)) deallocate(bo1)
      allocate(vv(n))
      allocate(aor(nov))
      allocate(bor(nov))
      allocate(aor1(nov))
      allocate(bor1(nov))
      allocate(aoc(nov))
      allocate(boc(nov))
      allocate(aos(nov))
      allocate(bos(nov))
      allocate(aod(nov))
      allocate(bod(nov))
      allocate(ao1(nov, mspn))
      allocate(bo1(nov, mspn))

      irefd = 0

      do while (irefd.eq.0)
        irefd = irefd + 1
        maxmp2=.false.

!       **** open shell contributions ****
        tel = 0.D0
        do i = 2, nshell
          tel = tel + nel(i)
        end do
        nelopn = nint(tel)
        nalpha = (nelopn + multci - 1) / 2
        nbeta = nelopn - nalpha

        if (nbeta < 0) then
          nbeta = 0
          nalpha = nelopn
        end if

        nv = 1
        vv(1) = norb(1) + nalpha

        maxoc = vv(nv)

!	**** alpha set occupied/vacant flags ****
        do i = nol, vv(1)
          aor(i - ncore) = .true.
        end do
        do i = vv(1) + 1, nvh
          aor(i - ncore) = .false.
        end do
        do j = 2, nv
          aor(vv(j) - ncore) = .true.
        end do
        write (iw, "(//, ' Reference determinate nber', i4, ' is ', a5, ' 1 -', 25i4)") &
          irefd, 'ALPHA', (vv(i), i=1, nv)

!	**** determine beta occupancy ****
!	**** auto include ground state reference det ****
        vv(1) = norb(1) + nbeta
        maxoc = max (maxoc, vv(nv))

!	**** beta set occupied/vacant flags ****
        do i = nol, vv(1)
          bor(i - ncore) = .true.
        end do
        do i = vv(1) + 1, nvh
          bor(i - ncore) = .false.
        end do
        do j = 2, nv
          bor(vv(j) - ncore) = .true.
        end do
! Subtract dielectric energy off of ecore
        if (useps) then
          call staticsolv(aor, bor, ediel)
          ecore = ecore - ediel
        end if

        if (irefd.eq.1) then
!	  **** save first reference determinate for excitation naming ****
          do i = 1, nov
            aor1(i) = aor(i)
            bor1(i) = bor(i)
          end do
        end if

        if(allocated(ao1))    deallocate(ao1)
        if(allocated(bo1))    deallocate(bo1)
        if(allocated(aocc))   deallocate(aocc)
        if(allocated(bocc))   deallocate(bocc)
        if(allocated(nspn))   deallocate(nspn)
        if(allocated(krefd))  deallocate(krefd)
        if(allocated(spintr)) deallocate(spintr)
        if(allocated(aii))    deallocate(aii)
        if(allocated(tr1))    deallocate(tr1)
        allocate(ao1(nov, mspn))
        allocate(bo1(nov, mspn))
        allocate(aocc(nov, mspn, nex))
        allocate(bocc(nov, mspn, nex))
        allocate(nspn(nconf))
        allocate(krefd(nconf))
        allocate(spintr(mspn, nconf))
        allocate(aii(n))
        allocate(tr1(mspn))

        do i=1, n
          aii(i) = evalmo(i)
        end do

        do i=1, nov
          do j=1, mspn
            do k=1, nex
              aocc(i, j, k) = .False.
              bocc(i, j, k) = .False.
            end do
          end do
        end do

!	**** spin adapt and include in config list ****

        call spclas(istsym, jconf, aor, bor, ao1, bo1, e, &
     &        aocc, bocc, nspn, spintr, beta, cc0, gamma, nbtmo, aii, nfact, &
     &        irefd, krefd, .true.)
!        write (6, *) '1   ', jconf, e(jconf), aor, '   ', bor

!	********* read in excitation control parameters ********
        nvs = 4
        vvs(1) = nol
        vvs(2) = noh
        vvs(3) = nvl
        vvs(4) = nvh

!	**** set up values for double excitations if no DOUBLE card read ****
        nvd = 4
        if (dbls) then
          vvd(1) = nold
          vvd(2) = noh
          vvd(3) = nvl
          vvd(4) = nvhd
        else
          vvd(1) = 1
          vvd(2) = 0
          vvd(3) = 1
          vvd(4) = 0
        end if
!	**** set up values for CAS if no CAS card read ****
!	**** CAS amongst all open shell orbitals ****
        norbopn = norbh(nshell) - norbh(1)
        if (norbopn.eq.0) then
!         **** RHF, turn CAS off ****
          nv = 1
          vv(1) = maxoc + 1
        else
          nv = norbopn
          j = 0
          do i = norbl(2), norbh(nshell)
            j = j + 1
            vv(j) = i
          end do
        end if

        if (mrci) then
          fastci = .false.
          nv = 0
          do i = nolc, nvhc
            nv = nv + 1
            vv(nv) = i
          end do

!         **** ensure CAS orbitals are in ascending order for sort speed ***
          do i = 1, nv - 1
            a = n
            jmin = 0
            do j = i, nv
              if (vv(j) < a) then
                a = vv(j)
                jmin = j
              end if
            end do
            vv(jmin) = vv(i)
            vv(i) = a
          end do
          if (vv(1).le.ncore .or. vv(nv) > nvh) &
              stop 'in EXCITE: CAS RANGE'
        end if

!       **** check and print excitation generators ****

        if (nv > 1) write (iw, " (' CAS excitations amongst orbitals:', 25i4)") (vv(i), i=1, nv)
        if (vvs(2) > 0) then
          write (iw, "(1x, a6, ' excitations FROM orbs', i4, ' to', i4, ' INTO orbs', i4, ' to', i4)") &
            'SINGLE', (vvs(i), i=1, nvs)
          call chkdeg (vvs, nvs, aii)
        end if
        if (vvd(2) > 0) then
          write (iw, "(1x, a6, ' excitations FROM orbs', i4, ' to', i4, ' INTO orbs', i4, ' to', i4)") &
            'DOUBLE', (vvd(i), i=1, nvd)
          call chkdeg (vvd, nvd, aii)
        end if
        write (iw, *)

!       **** first, CAS excitations amongst a finite nber of orbitals ****

!       **** determine nber of alpha and beta els in space of nv orbs	****
!       **** and hence the nber of permutations possible		****
        nalpha = 0
        nbeta = 0
        do i = 1, nv
          if (aor(vv(i) - ncore)) nalpha = nalpha + 1
          if (bor(vv(i) - ncore)) nbeta = nbeta + 1
        end do
        nend = nint (2.D0**nv)
        isynca = nend

        do while (permca (aor, aoc, nalpha, vv, nv, isynca))
          isyncb = nend
          do while (permca (bor, boc, nbeta, vv, nv, isyncb))

!         **** spin adapt and include in config list ****
            call spclas(istsym, jconf, aoc, boc, ao1, bo1, e, &
     &          aocc, bocc, nspn, spintr, beta, cc0, gamma, nbtmo, aii, nfact, &
     &          irefd, krefd, .false.)
!            write (6, *) 'CAS ', jconf, e(jconf), aoc, '   ', boc

!	    ***** generate single excitations from all CAS dets *****

            do i1 = vvs(2), vvs(1), - 1
              ifst = i1
              i = i1 - ncore
              do a1 = vvs(3), vvs(4)
                afst = a1
                a = a1 - ncore
!               **** this is the i - >a excitation ****

                if (aoc(i) .and. .not. aoc(a) .or.&
     &              boc(i) .and. .not. boc(a) .or. i.eq.a) then
!                 **** fill in occupancy from CAS det ****
                  do k = 1, nov
                    aos(k) = aoc(k)
                    bos(k) = boc(k)
                  end do
!                 **** select alpha spin if available, else beta spin ****
                  if (aos(i) .and. .not. aos(a)) then
                    aos(i) = .false.
                    aos(a) = .true.
                  else if (i.ne.a) then
                    bos(i) = .false.
                    bos(a) = .true.
                  end if
!	          **** spin adapt and include in config list ****
                  call spclas(istsym, jconf, aos, bos, ao1, bo1, e, &
     &              aocc, bocc, nspn, spintr, beta, cc0, gamma, nbtmo, aii, nfact, &
     &              irefd, krefd, .false.)
!                  write (6, *) 'CAS2', jconf, e(jconf), aos, '   ', bos

!	          ******** double excitations *********

                  do j1 = vvd(2), vvd(1), - 1
                    j = j1 - ncore
                    do b1 = vvd(3), vvd(4)
                      b = b1 - ncore
!                     **** this is the i - >a & j - >b double excitation ****

!                     **** eliminate double counting so that J>=I and B>=A ****
                      exok = .true.
                      if (vvs(1).le.j .and. j.le.vvs(2) .and.&
     &                    vvs(3).le.b .and. b.le.vvs(4) )&
     &                    exok = j.ge.i .and. a.ge.b
                      if (exok .and. j.eq.a) then
!                       **** eliminate possible double counting ****
!                       **** proceed only if no single excitation i - >b ***
                        exok = (.not. aoc(i) .or. aoc(b)) .and.&
     &                        (.not. boc(i) .or. boc(b) .or.&
     &                        i < vvs(1) .or. i > vvs(2)  .or.&
     &                        b < vvs(3) .or. b > vvs(4) )
                      end if
                      if (exok .and. i.eq.b)&
!		        **** proceed only if no single excitation j - >a ***
     &                  exok = (.not. aoc(j) .or. aoc(a)) .and.&
     &                        (.not. boc(j) .or. boc(a) .or.&
     &                        j < vvs(1) .or. j > vvs(2) .or.&
     &                        a < vvs(3) .or. a > vvs(4) )

                      if (exok .and. ( aos(j) .and. .not. aos(b) .or.&
     &                                 bos(j) .and. .not. bos(b) ) ) then
!		        **** fill in occupancy from single excited det ****
                        do k = 1, nov
                          aod(k) = aos(k)
                          bod(k) = bos(k)
                        end do

!                       **** do only one of alpha or beta promotion ****
                        if (aod(j) .and. .not.aod(b)) then
                          aod(j) = .false.
                          aod(b) = .true.
                        else
                          bod(j) = .false.
                          bod(b) = .true.
                        end if

!                       **** spin adapt and include in config list ****
                        call spclas(istsym, jconf, aod, bod, ao1, bo1, &
     &                      e, aocc, bocc, nspn, spintr, beta, &
     &                      cc0, gamma, nbtmo, aii, nfact, irefd, krefd, .false.)
!                        write (6, *) 'CAS3', jconf, e(jconf), aod, '   ', bod

!                       **** end of double excitation ****
                      end if
                    end do
                  end do

!                 **** end of single excitation ****
                end if
              end do
            end do

!	    **** end of CAS excitation ****
          end do
        end do
!       **** end of processing of excitation cards ****
!	**** end of reference det, position for next ALPHA read ****
!        if (param.eq.'   ALPHA') backspace ix
        if (maxmp2) then
          jconfm = jconfm + 1
          do while (jconfm.le.jconf .and. krefd(jconfm).ne. - 1)
            jconfm = jconfm + 1
          end do
        end if
      end do

!     **************** reorganize basis set order **********************

      nconf =  min (nconf, jconf)
      nciout = min (nciout, nconf)
      nese =   min (nese,  nciout)
      jconf =  nconf
      write (iw, "(/' CI excitations=', i5, ':', 8(5x, a3, '=', i3))") nconf, (nmrep(k, nptg), nci(k), k=1, nr)

      if (allocated(icifrag))  deallocate(icifrag)
      if (allocated(mofrag))   deallocate(mofrag)
      allocate(icifrag(nconf))
      allocate(mofrag(n))
      do i = 1, n
        mofrag(i) = 1
      end do

!     **** determine symmetry of states ****
!     **** determine if state is in a diagonal fragment block ****

      do i = 1, nconf
        istsym(i) = 1
        icifrag(i) = 0
        do j = 1, nov
          if (aocc(j, 1, i) .neqv. bocc(j, 1, i)) then
            istsym(i) = ixprd (istsym(i), nsym(j + ncore))
            if (icifrag(i).eq.0) then
              icifrag(i) = mofrag(j + ncore)
            else
              if (icifrag(i).ne.mofrag(j + ncore)) icifrag(i) = -1
            end if
          end if
        end do
        ndif = 0
        do j = 1, nov
          if (aocc(j, 1, i) .neqv. bocc(j, 1, i)) then
            ndif = ndif + 1
          end if
        end do
      end do

!     **** sort states by symmetry ****

      do k = 1, nconf
        jmin = 0
        ismin = 10000
        do j = k, nconf
          if (istsym(j) < ismin) then
            jmin = j
            ismin = istsym(j)
          end if
        end do
!	**** swap states, maintaining energy ordering ****
        ismin = istsym(jmin)
        ener = e(jmin)
        nperm = nspn(jmin)
        icifrag1 = icifrag(jmin)
        iirefd = krefd(jmin)
        do ispn = 1, nperm
          tr1(ispn) = spintr(ispn, jmin)
          do i = 1, nov
            ao1(i, ispn) = aocc(i, ispn, jmin)
            bo1(i, ispn) = bocc(i, ispn, jmin)
          end do
        end do

        do j = jmin, k + 1, - 1
          j1 = j - 1
          istsym(j) = istsym(j1)
          e(j) = e(j1)
          nspn(j) = nspn(j1)
          icifrag(j) = icifrag(j1)
          krefd(j) = krefd(j1)
          do ispn = 1, nspn(j1)
            spintr(ispn, j) = spintr(ispn, j1)
            do i = 1, nov
              aocc(i, ispn, j) = aocc(i, ispn, j1)
              bocc(i, ispn, j) = bocc(i, ispn, j1)
            end do
          end do
        end do

        istsym(k) = ismin
        e(k) = ener
        nspn(k) = nperm
        icifrag(k) = icifrag1
        krefd(k) = iirefd
        do ispn = 1, nperm
          spintr(ispn, k) = tr1(ispn)
          do i = 1, nov
            aocc(i, ispn, k) = ao1(i, ispn)
            bocc(i, ispn, k) = bo1(i, ispn)
          end do
        end do
      end do

!     **** count the number of CI states of each symmetry ****

      do k = 1, nr
        nci(k) = 0
      end do
      do i = 1, nconf
        k = istsym(i)
        nci(k) = nci(k) + 1
      end do

!     **** zero the CI matrix ****
      do i = 1, matind(nconf) + nconf
        ci(i) = 0.D0
      end do

      return

      end subroutine excite

!     **********************************************************************

      subroutine chkdeg (vv, nv, evalmo)

!     **** this checks an exc list for degenerate boundary MO eigenvalues ****
      use reimers_C, only: n
      USE chanel_C, only : iw

      implicit none
      integer :: nv, vv(nv)
      double precision   evalmo(n), diff, tol
      integer            i, j, k, idir, ifn

      data tol  /1.d-1/
      do j = 1, 4
        i = vv(j)
        idir = 0
        if ( (j.eq.1 .or. j.eq.3) .and. i > 1) then
          diff = abs (evalmo(i) - evalmo(i - 1))
          if (diff  <  tol) then
            idir = 1
            ifn = n
          end if
        else if ( (j.eq.2 .or. j.eq.4) .and. i < n .and. i.ge.1) then
          diff = abs (evalmo(i) - evalmo(i + 1))
          if (diff  <  tol) then
            idir = -1
            ifn = 1
          end if
        end if

        if (idir.ne.0) then
          if (diff > tol/5.) then
            write (iw, "(/' CI WARNING: MO', i4, ' EVAL DIFF <', f7.4)") i, tol
          else
            write (iw, "(/' CI WARNING: MO', i4, ' EVAL DIFF <', f7.4)") i, tol/5.
            do k = i, ifn, idir
              if (abs(evalmo(k) - evalmo(i)) < tol) vv(j) = vv(j) + idir
            end do
          end if
        end if
      end do

      return
      end subroutine chkdeg

!     **********************************************************************

      subroutine spclas (istsym, jconf, ao, bo, ao1, bo1, e, &
     &        aocc, bocc, nspn, spintr, beta, c, gamma, nbtmo, aii, nfact, &
     &        irefd, krefd, isrefd)

!     **** this takes a determinate AO, BO and finds all other DETs	****
!     **** belonging to its CLASS (ie, dets coupled by S**2).  It calcs	****
!     **** their interaction energies, diagonalizes S**2 to deduce the	****
!     **** linear combinations which are eigenvalues of spin, and hence	****
!     **** transforms the energy matrix to deduce the spin - adapted	****
!     **** CONFiguration energies E.  Those of spin MULTCI are selected	****
!     **** and the lowest NCONF stored if their energy is < EMAXCI.	****
!     **** AOCC and BOCC store the dets if at least one energy included	****
!     **** ISNG stores locn of all singly occ orbs in det		****
      use reimers_C, only: n, nb2, matind, nconf, multci, ncore, nol, &
          nvh, nov, fastci, icisym, ecore, ifst, afst, ixprd, ndiff, nex, &
          mspn, nsym
      USE chanel_C, only : iw
      use cosmo_C, only : useps

      implicit none
!     **** MP2 storage in excite and spcls ****
      integer            isng(mspn), nbtmo(n), nel(nov), nspn(nconf), &
                         istsym(nconf), krefd(nconf), nfact(0:mspn)
      double precision   s2(mspn, mspn), eval(mspn), wk(mspn), &
                         h(mspn, mspn), s2eig(mspn, mspn), s2eval(mspn), &
                         gamma(n, n), c(n, n), e(nconf), beta(nb2), &
                         aii(n), spintr(mspn, nov)
      integer            i, j, k, i0, i1, idet, ier, iisym, ih, il, ip, &
                         irefd, isync, j1, jconf, jdet, &
                         k1, k2, nalpha, nbeta, ndeg, &
                         nelj, nend, nperm, nsng
      double precision   ciener, e1, eec1, j12, k12, s1, tol

      logical*1          ao(nov), bo(nov), ao1(nov, mspn), bo1(nov, mspn), &
                         aocc(nov, mspn, nex), bocc(nov, mspn, nex)
      logical            isrefd
      double precision       ediel

!     *********** check that its of the correct symmetry ************
      iisym = 1
      do j = 1, nov
        if (ao(j) .neqv. bo(j)) iisym = ixprd (iisym, nsym(j + ncore))
      end do
      if (.not. isrefd .and. icisym(iisym).eq.0) then
        return
      end if

!     *********** check that this det isnt already included in CI list ********

!     **** calculate the total number of electrons in each orb ****
      do i = 1, nov
        nel(i) = 0
        if (ao(i)) nel(i) = 1
        if (bo(i)) nel(i) = nel(i) + 1
      end do

      do 200 i = 1, jconf
        do j = 1, nov
          nelj = 0
          if (aocc(j, 1, i)) nelj = 1
          if (bocc(j, 1, i)) nelj = nelj + 1
          if (nelj.ne.nel(j)) goto 200
        end do

!	**** can only get here if two dets are in the same spin class ****
        return
200   continue

!     ***** if its closed shell with singles excitation; fast code ****

      if (fastci) then
        if (ifst > 0) then
         call inttr (ifst, ifst, afst, afst, c, gamma, nbtmo, j12, k12, 0)

          eval(1) = aii(afst) - aii(ifst) - j12
          if (multci.eq.1) eval(1) = eval(1) + 2.D0*k12
        else
!	  **** ground state energy ****
          eval(1) = 0.D0
        end if

        nperm = 1
        h(1, 1) = 1.D0
        wk(1) = multci
        do i = 1, nov
          ao1(i, 1) = ao(i)
          bo1(i, 1) = bo(i)
        end do

        goto 500
      end if

!     **** determine nber of sngl occ alpha and beta orbitals ****

      nsng = 0
      nalpha = 0
      nbeta = 0
      do i = 1, nov
        if (nel(i).eq.1) then
          nsng = nsng + 1
          if (nsng > mspn) stop 'NSNG in SPCLAS'
          isng(nsng) = i + ncore
          if (ao(i)) then
            nalpha = nalpha + 1
          else
            nbeta = nbeta + 1
          end if
        end if
      end do
      i = abs (nalpha - nbeta) + 1

!     **** generate all possible perturbations ****

      nperm = nfact(nsng) / nfact(nalpha) / nfact(nbeta)
      if (nperm > mspn) then
        write (iw, *) 'ERROR: max nber of spin components=', mspn, &
     &     ' found=', nperm, ' for det:'
        write (iw, '(1x, 131l1)') (ao(i), i=1, nov)
        write (iw, '(1x, 131l1)') (bo(i), i=1, nov)
        stop 'in SPCLAS'
      end if

      isync = 0
      nend = nint (2.D0**nsng)
      idet = 1

!     **** PERTS generates next perturbation, is false if all done ****

      do idet = 1, nperm
        call perms (ao, bo, ao1(1, idet), &
     &              bo1(1, idet), isng, nalpha, nbeta, isync, nend)
      end do

!     **** calculate the energy matrix for all dets in this class ****

      do idet = 1, nperm
        e1 = 0.D0

        do i1 = nol, nvh
          i = i1 - ncore
          if (nel(i) > 0) then
            e1 = e1 + beta(matind(i1) + i1) * nel(i)

!	    **** matrix element <i, i_bar || i, i_bar> ****
            if (nel(i).eq.2) then
              call inttr (i1, i1, i1, i1, c, gamma, nbtmo, j12, k12, 0)
              e1 = e1 + j12
            end if

!	    **** add core terms sum_j (i, i|j, j) ****
            e1 = e1 + eec1 (i1, i1, c, gamma, nbtmo) * nel(i)

!	    **** inner loop over all non - core electrons up to current one ****
            do j1 = nol, i1 - 1
              j = j1 - ncore
              if (nel(j) > 0) then
!		**** matrix elements <ij||ij> via J = [ii||jj], K = [ij|ij] ****
                call inttr (i1, i1, j1, j1, c, gamma, nbtmo, j12, k12, 0)

                if (nel(i).eq.1) then
                  if (nel(j).eq.1) then
!		    **** only one electron in each orbital ****
                    e1 = e1 + j12
                    if (ao1(i, idet) .eqv. ao1(j, idet))&
     &                e1 = e1 - k12
                  else
!		    **** one double occ, one single ****
                    e1 = e1 + 2.D0*j12 - k12
                  end if
                else
                  if (nel(j).eq.1) then
!		    **** one double occ, one single ****
                    e1 = e1 + 2.D0*j12 - k12
                  else
!		    **** both double occ ****
                    e1 = e1 + 4.D0*j12 - 2.D0*k12
                  end if
                end if
              end if
            end do

          end if
        end do
! RMG - add solvent correction
        ediel = 0.D0
        if (useps) then
          call staticsolv(ao, bo, ediel)
        end if
        h(idet, idet) = e1 + ecore + ediel
      end do

!     ***** determine interaction energies between all dets in class ****

      do idet = 2, nperm
        do jdet = 1, idet - 1
          h(idet, jdet) = ciener (ao1(1, idet), bo1(1, idet), &
     &      ao1(1, jdet), bo1(1, jdet), c, gamma, nbtmo, beta)
          h(jdet, idet) = h(idet, jdet)
        end do
      end do

!     **** diagonalize energy block ****
      call tred2e (mspn, nperm, h, eval, wk, h)
      call tql2e  (mspn, nperm,  eval, wk, h, ier)

!     **** form S**2 matrix in det basis ****

      do i = 1, nperm
        s2(i, i) = (nalpha + nbeta)*0.5D0 + (nalpha - nbeta)**2*0.25D0
        do j = 1, i - 1
!	  **** sign of off diag elem is given by det ordering convention ****
!	  **** alpha beta alpha beta .... as used also in ALIGN function ****
!	  **** first, ensure that only 2 alpha orbs are different ****
          ndiff = 0
          do k = 1, nov
            if (ao1(k, i) .neqv. ao1(k, j)) ndiff = ndiff + 1
          end do
          s2(i, j) = 0.D0
          if (ndiff.eq.2) s2(i, j) = 1.D0
          s2(j, i) = s2(i, j)
        end do
      end do

!     **** if degenerate energy eigenvalues, then form S**2 in eigvec basis ****

      tol = 1.d-5
      il = 1
      do while (il < nperm)
        ih = il + 1
        do while (ih.le.nperm .and. abs(eval(il) - eval(ih))  <  tol)
          ih = ih + 1
        end do
        if (ih > nperm .or. abs(eval(il) - eval(ih))  >  tol) ih = ih - 1
        ndeg = ih - il + 1
        if (ndeg > 1) then
!	  **** found NDEG degenerate eigenvalues, form S**2 in evec basis ****
          i0 = il - 1
          do i = 1, ndeg
            do j = 1, i
              s2eig(i, j) = 0.D0
              do k1 = 1, nperm
                s1 = 0.D0
                do k2 = 1, nperm
                  s1 = s1 + s2(k1, k2) * h(k2, i0 + j)
                end do
                s2eig(i, j) = s2eig(i, j) + h(k1, i0 + i) * s1
              end do
            end do
          end do
!	  **** diagonalize S**2 in eigvec basis ****
          call tred2e (mspn, ndeg, s2eig, s2eval, wk, s2eig)
          call tql2e  (mspn, ndeg,      s2eval, wk, s2eig, ier)
!	  **** transform energy eigvecs to be eigvecs of S**2 also ****
          do j = 1, nperm
            do i = 1, ndeg
              wk(i) = 0.D0
              do k = 1, ndeg
                wk(i) = wk(i) + s2eig(k, i) * h(j, i0 + k)
              end do
            end do
            do i = 1, ndeg
              h(j, i0 + i) = wk(i)
            end do
          end do
        end if

        il = il + ndeg
      end do

!     **** determine diag element of transformed S**2 matrix ****

      tol = 1.d-5
      do i = 1, nperm
        wk(i) = 0.D0
        do j = 1, nperm
          s1 = 0.D0
          do k = 1, nperm
            s1 = s1 + s2(k, j) * h(k, i)
          end do
          wk(i) = wk(i) + h(j, i) * s1
        end do
!	**** use S**2 = s(s + 1) and spin mult = 2s + 1 to get multiplicity ****
        wk(i) = sqrt (1.D0 + 4.D0*wk(i))
      end do

!     **** check for non - integral multiplicity ****

      do i = 1, nperm
        if (abs(mod(wk(i) + tol, 1.D0))  >  2*tol) then
          write (iw, *) 'ERROR in S^2 eigenvalue', (sngl(wk(j)), j=1, nperm)
          do k = 1, nperm
            write (iw, *) k, (ao1(j, k), j=1, nov), '  ', (bo1(j, k), j=1, nov)
          end do
          stop 'spin in SPCLAS'
        end if
      end do

500   continue

!     **** select only eigvecs of the correct multiplicity		****
!     **** CI: store in mastor store, truncating by max nber and energy	****
!     **** PM2: evaluate interactions with chosen states		****
      do ip = 1, nperm
        if (nint(wk(ip)) .eq. multci) then

!	    *********** store the state in CI master index ***********

            call sortst (jconf, eval(ip), e, ao1, bo1, aocc, bocc, nperm, &
     &        nspn, h(1, ip), spintr, irefd, krefd, iisym, istsym, isrefd)

        end if
      end do
      return
      end subroutine spclas

!     **********************************************************************

      subroutine perms (aoi, boi, ao, bo, isng, nalpha, nbeta, isync, imax)

!     **** this forms all possible permutations of NALPHA and NBETA ****
!     **** electrons, one per orbital, in orbs ISNG		    ****
!     **** ISYNC is increased one per call; IMAX is terminating value **
      use reimers_C, only: ncore, nov

      implicit none
      integer           isng(nov), i, j, &
                        ialpha, ibeta, imax, io, isync, &
                        jsync, kk, nalpha, nbeta, ntot
      logical*1         aoi(nov), boi(nov), ao(nov), bo(nov)

!     **** copy accross initial determinate ****
      do i = 1, nov
        ao(i) = aoi(i)
        bo(i) = boi(i)
      end do

!     **** loop increasing isync looking for allowed pattern ****

100   continue

      if (isync.ge.imax) stop 'PERMS: could not find permutation'
      isync = isync + 1

      ntot = nalpha + nbeta
      ialpha = 0
      ibeta = 0
      jsync = isync
      do i = 1, ntot
        io = isng(i) - ncore
        j = jsync / 2
        kk = jsync - 2*j
        jsync = j
        ao(io) = kk.eq.0
        if (ao(io)) then
          ialpha = ialpha + 1
          if (ialpha > nalpha) goto 100
        else
          ibeta = ibeta + 1
          if (ibeta > nbeta) goto 100
        end if
      end do

!     **** it can only get here if pattern is allowed ****
      do i = 1, ntot
        io = isng(i) - ncore
        bo(io) = .not. ao(io)
      end do

      return
      end subroutine perms

!     **********************************************************************

      logical*1 function permca (aoi, ao, nalpha, icas, ntot, isync)

!     **** this forms all possible permutations of NALPHA electrons in	***
!     **** in the NTOT orbitals specified by ISNG			***
!     **** ISYNC is decreased one per call; 0 is terminating value	***
      use reimers_C, only: ncore, nov

      implicit none
      integer :: nalpha, icas, ntot, isync
      logical*1         aoi(nov), ao(nov)
      dimension         icas(nov)
      integer :: i, j, kk, io, jsync, ialpha

!     **** copy accross initial determinate ****
      do i = 1, nov
        ao(i) = aoi(i)
      end do

      permca = .false.

!     **** loop increasing isync looking for allowed pattern ****

100   continue

      isync = isync - 1
      if (isync < 0) return

      ialpha = 0
      jsync = isync
      do i = 1, ntot
        io = icas(i) - ncore
        j = jsync / 2
        kk = jsync - 2*j
        jsync = j
        ao(io) = kk.eq.0
        if (ao(io)) then
          ialpha = ialpha + 1
          if (ialpha > nalpha) goto 100
        end if
      end do
      if (ialpha.ne.nalpha) goto 100

!     **** it can only get here if pattern is allowed ****
      permca = .true.

      return
      end function permca

!     **********************************************************************

      subroutine sortst (k, ener, e, ao1, bo1, aocc, bocc, nperm, nspn, &
     &                tr, spintr, irefd, krefd, iisym, istsym, isrefd)

!     **** this keeps track of the lowest - energy NCONF determinates	****
!     **** a new state is inserted into the list in energy order	****
!     **** a new state is inserted into the list in energy order	****
      use reimers_C, only: nconf, nci, icisym, emaxci, nov, fastci, &
          nex, mspn

      implicit none
      double precision  e(nconf), tr(mspn), spintr(mspn, nconf), &
                        ener
      integer           nspn(nconf), krefd(nconf), istsym(nconf), &
                        k, nperm, irefd, iisym, &
                        i, j, iii, ispn, j1, jo
      logical           isrefd
      logical*1         aocc(nov, mspn, nex), bocc(nov, mspn, nex), &
     &                  ao1(nov, mspn), bo1(nov, mspn)

!     **** first, check the energy max cuttoff criterion ****
      if (ener > emaxci) then
        return
      end if

!     **** first check to see if max states of this symmetry exceeded ****
      if (.not. isrefd .and. nci(iisym).eq.icisym(iisym)) then
!	**** find locn of state ****
        i = k
        do while (istsym(i).ne.iisym)
          i = i - 1
        end do
        if (ener > e(i)) then
          return
        end if
!	**** remove this state ****
        k = k - 1
        nci(iisym) = nci(iisym) - 1
        do j1 = i, k
          j = j1 + 1
          e(j1) = e(j)
          istsym(j1) = istsym(j)
          nspn(j1) = nspn(j)
          krefd(j1) = krefd(j)
          do ispn = 1, nspn(j)
            spintr(ispn, j1) = spintr(ispn, j)
            do jo = 1, nov
              aocc(jo, ispn, j1) = aocc(jo, ispn, j)
              bocc(jo, ispn, j1) = bocc(jo, ispn, j)
            end do
          end do
        end do
      end if

!     **** if full, spot check to see if its energy is too large ****
      if (k.eq.nconf) then
        if (abs(ener - e(k))  <  1.d-5) then
!	  **** degenerate with last state, remove them both ****
          nci(istsym(k)) = nci(istsym(k)) - 1
          k = k - 1
          return
        else
          if (ener > e(k)) then
            return
          end if
        end if
!	**** insert new into filled list, pop top one off ****
        nci(istsym(k)) = nci(istsym(k)) - 1
        k = k - 1
      end if

!     **** see where new state fits in energy order (crap code to fool Intel debugger) ****
      i = k
      iii = 1
      do while (i.ge.1 .and. iii.eq.1)
        if (ener < e(i)) then
          i = i - 1
        else
          iii = 0
        end if
      end do
      i = i + 1

! RMG - add to avoid moving 1st config to solve triplet fastci issues
      if (fastci .and. i.eq.1 .and. k.ge.1) i = i + 1

!     **** move those above it up one spot ****
      do j = k, i, - 1
        j1 = j + 1
        e(j1) = e(j)
        istsym(j1) = istsym(j)
        nspn(j1) = nspn(j)
        krefd(j1) = krefd(j)
        do ispn = 1, nspn(j)
          spintr(ispn, j1) = spintr(ispn, j)
          do jo = 1, nov
            aocc(jo, ispn, j1) = aocc(jo, ispn, j)
            bocc(jo, ispn, j1) = bocc(jo, ispn, j)
          end do
        end do
      end do

!     **** insert new state ****
      e(i) = ener
      istsym(i) = iisym
      nspn(i) = nperm
      krefd(i) = irefd

      do ispn = 1, nperm
        spintr(ispn, i) = tr(ispn)
        do jo = 1, nov
          aocc(jo, ispn, i) = ao1(jo, ispn)
          bocc(jo, ispn, i) = bo1(jo, ispn)
        end do
      end do

      nci(iisym) = nci(iisym) + 1
      k = k + 1

      return
      end subroutine sortst

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  subroutine diagg2 (nocc, nvir,  eigv, iused, latoms, &
     & nij, idiagg, storei, storej)
   !***********************************************************************
   !
   !   DIAGG2  PERFORMS A SIMPLE JACOBIAN ANNIHILATION OF THE ENERGY TERMS
   !   CONNECTING THE OCCUPIED LMOS AND THE VIRTUAL LMOS.  THE ENERGY TERMS
   !   ARE IN THE ARRAY FMO, AND THE INDICES OF THE LMOS ARE IN IFMO.
   !
   !***********************************************************************
    use molkst_C, only: numat, norbs, numcal, keywrd, id
    use MOZYME_C, only : nvirtual, icocc_dim, shift, &
       & icvir_dim, cocc_dim, cvir_dim, ipad2, thresh, tiny, sumb, &
       ncf, nce, nncf, nnce, ncocc, ncvir, iorbs, cocc, cvir, icocc, icvir, &
       ifmo, fmo
!
    use common_arrays_C, only : eigs, nat
    use parameters_C, only: main_group
    use chanel_C, only: iw
    implicit none
    integer, intent (in) :: idiagg, nij, nocc, nvir
    logical, dimension (numat), intent (out) :: latoms
    integer, dimension (numat), intent (out) :: iused
    double precision, dimension (norbs), intent (out) :: storei, storej
    double precision, dimension (nvirtual), intent (in) :: eigv
    logical :: bug = .false.
    logical :: retry
    logical, save :: debug, times
    integer :: i, ii, jur, l
    integer, save :: icalcn = 0
    integer :: ij, ilr, incv, iur, j, jlr, jncf, k, le, lf, lij, loopi, loopj, &
   & mie, mle, mlee, mlf, mlff, ncei, ncfj, nrej
    double precision :: a, alpha, b, beta, biglim, c, d, e, sum
    double precision, save :: const, eps, eta, bigeps
    double precision, external :: reada
    integer, dimension (2) :: nrejct
    data nrejct / 2 * 0 /
    if (numcal /= icalcn) then
      icalcn = numcal
      times = (Index (keywrd, " TIMES") /= 0)
      debug = (Index (keywrd, " DIAGG2") /= 0)
      !
      !   IF THE SYSTEM IS A SOLID, THEN DAMP ROTATION OF VECTORS,
      !   IN AN ATTEMPT TO PREVENT AUTOREGENERATIVE CHARGE OSCILLATION.
      !
      i = Index (keywrd, " DAMP")
      if (i /= 0) then
        const = reada (keywrd, i+5)
      else if (id == 3) then
        const = 0.5d0
      else
        a = 1.d0               !  If a transition metal, set DAMP to 0.5d0
        do i = 1, numat        !
          if (.not. main_group(nat(i)))  a = 0.5d0
        end do
        const = a
      end if
      !
      !   EPS IS THE SMALLEST NUMBER WHICH, WHEN ADDED TO 1.D0, IS NOT
      !   EQUAL TO 1.D0
      call epseta (eps, eta)
      !
      !   INCREASE EPS TO ALLOW FOR A LOT OF ROUND-OFF
      !
      bigeps = 50.d0 * Sqrt (eps)
    end if
   !
   !  RETRY IS .TRUE. IF THE NUMBER OF REJECTED ANNIHILATIONS IS IN THE
   !         RANGE 1 TO 20  AND THE SAME ON TWO ITERATIONS.  THIS WILL
   !         OCCUR NEAR THE END OF A SCF CALCULATION, WHEN ONLY A FEW
   !         LMOS ARE BADLY BEHAVED.
   !
    retry = (nrejct(1) == nrejct(2) .and. nrejct(1) /= 0 .and. nrejct(1) < 20)
    if (Mod(idiagg, 5) == 0 .or. idiagg <= 5) then
      tiny = -1.d0
      biglim = -1.d0
    else
      tiny = 0.01d0 * tiny
      biglim = bigeps
    end if
   !***********************************************************************
   !
   !   DO A CRUDE 2 BY 2 ROTATION TO "ELIMINATE" SIGNIFICANT ELEMENTS
   !
   !***********************************************************************
    iused(:) = -1
    latoms(:) = .false.
    if (debug) then
      write (iw,*)
      write (iw,*) "            SIZE OF OCCUPIED ARRAYS IN DIAGG2"
      write (iw,*)
      write (iw,*) "    LMO    NNCF     NCF   SPACE  ", " NCOCC    SIZE   SPACE"
      do i = 1, nocc - 1
        l = ncocc(i)
        do j = nncf(i) + 1, nncf(i) + ncf(i)
          l = l + iorbs(icocc(j))
        end do
        write (iw, "(7I8)") i, nncf (i), ncf (i), nncf (i+1) - &
       & nncf(i) - ncf(i), ncocc(i), l - ncocc(i), ncocc(i+1) - l
      end do
      i = nocc
      l = ncocc(i)
      do j = nncf(i) + 1, nncf(i) + ncf(i)
        l = l + iorbs(icocc(j))
      end do
      write (iw, "(7I8)") i, nncf (i), ncf (i), icocc_dim - nncf (i) - ncf &
     & (i), ncocc(i), l - ncocc(i), cocc_dim - l
      write (iw,*)
      write (iw,*) "            SIZE OF VIRTUAL ARRAYS IN DIAGG2"
      write (iw,*)
      write (iw,*) "    LMO    NNCE     NCE   SPACE  ", " NCVIR    SIZE   SPACE"
      do i = 1, nvir - 1
        l = ncvir(i)
        do j = nnce(i) + 1, nnce(i) + nce(i)
          l = l + iorbs(icvir(j))
        end do
        write (iw, "(7I8)") i, nnce (i), nce (i), nnce (i+1) - nnce (i) - nce &
       & (i), ncvir(i), l - ncvir(i), ncvir(i+1) - l
      end do
      i = nvir
      l = ncvir(i)
      do j = nnce(i) + 1, nnce(i) + nce(i)
        l = l + iorbs(icvir(j))
      end do
      write (iw, "(7I8)") i, nnce (i), nce (i), icvir_dim - nnce (i) - nce (i), &
     & ncvir(i), l - ncvir(i), cvir_dim - l
      if (bug) then
        write (iw,*)
        write (iw, "(A,I3,A)") " THIS FAULT CAN PROBABLY BE " // &
                             & "CORRECTED BY USE OF KEYWORD 'NLMO=", &
                             & ipad2 + 50, "'"
        write (iw,*)
        call mopend ("VALUE OF NLMO IS TOO SMALL")
      end if
    end if
    sumb = 0.d0
    nrej = 0
    lij = 0
    outer_loop: do ij = 1, nij
      i = ifmo(1, ij)
      j = ifmo(2, ij)
      if (Abs (fmo(ij)) >= tiny) then
        c = fmo(ij) * const
        d = eigs(j) - eigv(i) - shift
        if (Abs (c/d) >= biglim) then
          ncfj = ncf(j)
          ncei = nce(i)
      !
      !  STORE LMOS FOR POSSIBLE REJECTION, IF LMOS EXPAND TOO MUCH.
      !
          jlr = ncocc(j) + 1
          if (j /= nocc) then
            jur = ncocc(j+1)
            jncf = nncf(j+1)
          else
            jur = cocc_dim
            jncf = icocc_dim
          end if
          jur = Min (jlr+norbs-1, jur)
          ilr = ncvir(i) + 1
          if (i /= nvir) then
            iur = ncvir(i+1)
            incv = nnce(i+1)
          else
            iur = cvir_dim
            incv = icvir_dim
          end if
          iur = Min (ilr+norbs-1, iur)
          l = 0
          do k = jlr, jur
            l = l + 1
            storej(l) = cocc(k)
          end do
          l = 0
          do k = ilr, iur
            l = l + 1
            storei(l) = cvir(k)
          end do
          !
          !   STORAGE DONE.
          !
          lij = lij + 1
          e = Sign (Sqrt(4.d0*c*c+d*d), d)
          alpha = Sqrt (0.5d0*(1.d0+d/e))
          do
            beta = -Sign (Sqrt(1.d0-alpha*alpha), c)
            sumb = sumb + Abs (beta)
            !
            ! IDENTIFY THE ATOMS IN THE OCCUPIED LMO.  ATOMS NOT USED ARE
            ! FLAGGED BY '-1' IN IUSED.
            !
            mlf = 0
            !
            do lf = nncf(j) + 1, nncf(j) + ncf(j)
              ii = icocc(lf)
              iused(ii) = mlf
              mlf = mlf + iorbs(ii)
            end do
            loopi = ncvir(i)
            loopj = ncocc(j)
            mle = 0
         !
         !      ROTATION OF PSEUDO-EIGENVECTORS
         !
            do le = nnce(i) + 1, nnce(i) + nce(i)
              mie = icvir(le)

              latoms(mie) = .true.
              mlff = iused(mie) + loopj
              if (iused(mie) >= 0) then
                !
                !  TWO BY TWO ROTATION OF ATOMS WHICH ARE COMMON
                !  TO OCCUPIED LMO J AND VIRTUAL LMO I
                !
                do mlee = mle + 1 + loopi, mle + iorbs(mie) + loopi
                  mlff = mlff + 1
                  a = cocc(mlff)
                  b = cvir(mlee)
                  cocc(mlff) = alpha * a + beta * b
                  cvir(mlee) = alpha * b - beta * a
                end do
              else
                !
                !   FILLED  LMO ATOM 'MIE' DOES NOT EXIST.
                !   CHECK IF IT SHOULD EXIST
                !
                sum = 0.d0
                do mlee = mle + 1 + loopi, mle + iorbs(mie) + loopi
                  sum = sum + (beta*cvir(mlee)) ** 2
                end do
                if (sum > thresh) then
                  !
                  if (nncf(j)+ncf(j) >= jncf) go to 1000
                  if (mlf+iorbs(mie)+loopj > jur) go to 1000
                  !
                  !  YES, OCCUPIED LMO ATOM 'MIE' SHOULD EXIST
                  !
                  ncf(j) = ncf(j) + 1
                  icocc(nncf(j)+ncf(j)) = mie
                  !
                  iused(mie) = mlf
                  mlf = mlf + iorbs(mie)
                  !
                  !   PUT INTENSITY INTO OCCUPIED LMO ATOM 'MIE'
                  !
                  mlff = iused(mie) + loopj
                  do mlee = mle + 1 + loopi, mle + iorbs(mie) + loopi
                    mlff = mlff + 1
                    cocc(mlff) = beta * cvir(mlee)
                    cvir(mlee) = alpha * cvir(mlee)
                  end do
                end if
              end if
              mle = mle + iorbs(mie)
            end do
            !
            !  NOW CHECK ALL ATOMS WHICH WERE IN THE OCCUPIED LMO
            !  WHICH ARE NOT IN THE VIRTUAL LMO, TO SEE IF THEY
            !  SHOULD BE IN THE VIRTUAL LMO.
            !
            do lf = nncf(j) + 1, nncf(j) + ncf(j)
              ii = icocc(lf)

              if ( .not. latoms(ii)) then
                sum = 0.d0
                do mlff = iused(ii) + loopj + 1, iused(ii) + loopj + &
                     & iorbs(ii)
                  sum = sum + (beta*cocc(mlff)) ** 2
                end do
                if (sum > thresh) then
                  if (nnce(i)+nce(i) >= incv) go to 1000
                  if (mle+iorbs(ii)+loopi > iur) go to 1000
                  !
                  !  YES, VIRTUAL  LMO ATOM 'II' SHOULD EXIST
                  !
                  nce(i) = nce(i) + 1
                  icvir(nnce(i)+nce(i)) = ii
                  latoms(ii) = .true.
                  !
                  !   PUT INTENSITY INTO VIRTUAL  LMO ATOM 'II'
                  !
                  mlff = iused(ii) + loopj
                  do mlee = mle + 1 + loopi, mle + iorbs(ii) + loopi
                    mlff = mlff + 1
                     !
                    cvir(mlee) = -beta * cocc(mlff)
                    cocc(mlff) = alpha * cocc(mlff)
                  end do
                  mle = mle + iorbs(ii)
                end if
              end if
            end do
          exit
      1000  continue
            nrej = nrej + 1
              !
              !   THE ARRAY BOUNDS WERE GOING TO BE EXCEEDED.
              !   TO PREVENT THIS, RESET THE LMOS.
              !
            l = 0
            do k = jlr, jur
              l = l + 1
              cocc(k) = storej(l)
            end do
            l = 0
            do k = ilr, iur
              l = l + 1
              cvir(k) = storei(l)
            end do
            ncf(j) = ncfj
            nce(i) = ncei
            do k = 1, numat
              iused(k) = -1
              latoms(k) = .false.
            end do
            if (retry) then
                !
                !   HALF THE ROTATION ANGLE.  WILL THIS PREVENT THE
                !   ARRAY BOUND FROM BEING EXCEEDED?
                !
              alpha = 0.5d0 * (alpha+1.d0)
            else
              cycle outer_loop
            end if
          end do
        !
        !  RESET COUNTERS WHICH HAVE BEEN SET.
        !
          do le = nnce(i) + 1, nnce(i) + nce(i)
            mie = icvir(le)
            latoms(mie) = .false.
          end do
        !
          do lf = nncf(j) + 1, nncf(j) + ncf(j)
            iused(icocc(lf)) = -1
          end do
        end if
      end if
    end do outer_loop
    nrejct(2) = nrejct(1)
    nrejct(1) = nrej
    if (times) then
      call timer (" AFTER DIAGG2 IN ITER")
    end if
  end subroutine diagg2

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine rapid2 (xparam, functn, grad, lgrad)
!
!
    use param_global_C, only : valvar, botlim, toplim, numvar, &
    power, nfns, diffns, fns, parab, factor, penalty
!
!
    implicit none
    double precision, dimension (numvar), intent (in) :: xparam
    double precision, intent (out) :: functn
    logical, intent (in) :: lgrad
    double precision, dimension (numvar) :: grad
!----------------------------------------------------------------

    integer :: i, j
    double precision :: curpar, error, sum
    intrinsic Max, Min
!----------------------------------------------------------------
!
!  Power is the power "n" in error = sum_i x_i**n
!  Default is 2, do NOT go less than about 1.05
!
    if (lgrad) then
      do i = 1, numvar
        grad(i) = 0.d0
      end do
    end if
  !
  !    CALCULATE THE ERROR
  !
    functn = 0.d0
    do i = 1, nfns
      sum = 0.d0
      do j = 1, numvar
        sum = sum + xparam(j) * diffns(j, i)
      end do
      error = (fns(i)-sum)*factor(i)
      if (lgrad) then
      !
      !   CALCULATE DERIVATIVES OF SSQ W.R.T. PARAMETERS
      !
        do j = 1, numvar
          grad(j) = grad(j) - &
          & factor(i)*Sign(1.d0,error)*Abs(error)**(power - 1.d0) * diffns(j, i) * power
        end do
      end if
    !
    !   CALCULATE FUNCTION = SSQ
    !
       functn = functn + abs(error)**power
    end do
  !
  !  Add a damping function - to avoid the effects of a very low
  !  eigenvalue in the parameter Hessian.
  !
    sum = 0.d0
    do i = 1, numvar
      functn = functn + xparam(i) ** 2 * parab
      if (lgrad) then
        grad(i) = grad(i) + 2 * xparam(i) * parab
 !       if (j == 1) then
 !       write(ifiles_8,'(5f12.6)')grad(j),factor(i),error,diffns(j,i)
 !       end if
      end if
    end do
  !
  ! Add a limiting function - to set "soft" upper and lower limits
  ! to the value of the functions
  !
    do i = 1, numvar
      curpar = valvar(i) - xparam(i)
      sum = (Max(0.d0, curpar-toplim(i))+Min(0.d0, curpar-botlim(i)))
      functn = functn + penalty * sum ** 2
      if (lgrad) then
        grad(i) = grad(i) - 2.d0 * penalty * sum
!        if (i == 1) then
!        write(ifiles_8,'(5f12.6)')grad(i)
!        end if
      end if
    end do
end subroutine rapid2

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine mtxmc(a, nar, b, nbr, c)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: nar
      integer  :: nbr
      double precision  :: a(nbr,nar)
      double precision  :: b(nbr,nar)
      double precision  :: c(*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: l, i
!-----------------------------------------------
!     MATRIX PRODUCT C(NAR,NAR) = (A(NBR,NAR))' * B(NBR,NAR)
!     A AND B RECTANGULAR , PACKED,
!     C LOWER LEFT TRIANGLE ONLY, PACKED IN CANONICAL ORDER.
!  NOTE ... THIS IS THE BEST VERSION ON CRAY 1.
      l = 1
      do i = 1, nar
        call mxm (a(1,i), 1, b, nbr, c(l), i)
        l = l + i
      end do
      return
      end subroutine mtxmc

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

program mopac
  use chanel_C, only : iw0
  use molkst_C, only : program_name, gui, line, verson !, site_no, academic
  implicit none
  program_name = "Standalone MOPAC "
  call getdatestamp(line, verson)  
  gui = .false.
  iw0 = -1
!  iw0 = 0
!
! The call to "password" checks that the password is valid.  If it's not valid, the run will be stopped.
! if it is valid, ijulian will be incremented to, e.g. ijulian = 365.
! To by-pass "password" replace the following line with: "site_no = 999".
  call password  
  call run_mopac 
end program mopac
  

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine bangle(xyz, i, j, k, angle)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use common_arrays_C, only: tvec
      use molkst_C, only : numat, id, l11, l21, l31
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: i
      integer , intent(in) :: j
      integer , intent(in) :: k
      double precision , intent(out) :: angle
      double precision , intent(in) :: xyz(3,numat + 3)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      double precision :: d2ij, d2jk, d2ik, xy, temp, Vab(3), Rab
      integer :: ii, jj, kk
!-----------------------------------------------
!********************************************************************
!
! BANGLE CALCULATES THE ANGLE BETWEEN ATOMS I,J, AND K. THE
!        CARTESIAN COORDINATES ARE IN XYZ.
!
!********************************************************************
      if (id == 0) then
        d2ij = (xyz(1,i)-xyz(1,j))**2 + (xyz(2,i)-xyz(2,j))**2 + (xyz(3,i)-xyz(3,j))**2
        d2jk = (xyz(1,j)-xyz(1,k))**2 + (xyz(2,j)-xyz(2,k))**2 + (xyz(3,j)-xyz(3,k))**2
        d2ik = (xyz(1,i)-xyz(1,k))**2 + (xyz(2,i)-xyz(2,k))**2 + (xyz(3,i)-xyz(3,k))**2
      else
        d2ij = 1.d8
        d2jk = 1.d8
        d2ik = 1.d8
        do ii = -l11, l11
          do jj = -l21, l21
            do kk = -l31, l31
              Vab = xyz(:,i) - xyz(:,j) + tvec(:,1)*ii + tvec(:,2)*jj + tvec(:,3)*kk
              Rab = Vab(1)**2 + Vab(2)**2 + Vab(3)**2
              if (Rab < d2ij) then
                d2ij = Rab
              end if
              Vab = xyz(:,k) - xyz(:,j) + tvec(:,1)*ii + tvec(:,2)*jj + tvec(:,3)*kk
              Rab = Vab(1)**2 + Vab(2)**2 + Vab(3)**2
              if (Rab < d2jk) then
                d2jk = Rab
              end if
              Vab = xyz(:,i) - xyz(:,k) + tvec(:,1)*ii + tvec(:,2)*jj + tvec(:,3)*kk
              Rab = Vab(1)**2 + Vab(2)**2 + Vab(3)**2
              if (Rab < d2ik) then
                d2ik = Rab
              end if
            end do
          end do
        end do
      end if
      xy = sqrt(d2ij*d2jk)
      if (xy < 1.d-20) then
        angle = 0.d0
        return
      end if
      temp = 0.5D0*(d2ij + d2jk - d2ik)/xy
      temp = min(1.0D0,temp)
      temp = dmax1(-1.0D0,temp)
      angle = acos(temp)
      return
      end subroutine bangle

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

  subroutine set_up_MOZYME_arrays()
    use MOZYME_C, only : jopt, ncocc, ncvir, nncf, nnce, icocc, icvir, kopt, &
    noccupied, nvirtual, icocc_dim, icvir_dim, ncf, nce, cocc, cvir, &
    ipad2,  ipad4, cocc_dim, cvir_dim, numred, norred, nelred, &
    fmo_dim, part_dxyz, p1, p2, p3, ws, partf, parth, &
    partp, idiag, nfmo, fmo, ifmo, iorbs, mode, rapid
!
    use molkst_C, only : n2elec, mpack, numat, nelecs, norbs, l123, &
    keywrd, id
!
    use common_arrays_C, only : h, w, wk, p, f, ifact, q, &
    dxyz, eigs, nfirst, nlast, errfn
!
    use iter_C, only : pold, pold2, pold3, pbold, pbold2
!
    implicit none
    integer :: i, j
!
! Deallocate arrays before use (not essential, but prevents possible errors if a complicated
! job involving several calculations is run)
!
  call delete_MOZYME_arrays()
  allocate (iorbs(numat), stat = i)
    if (i /= 0) then

    end if
    iorbs = nlast - nfirst + 1
!
! The sizes of the arrays used by MOZYME must be evaluated by a call to fillij.
! Once the sizes are known, the arrays can be created.
!



  call fillij(.true.)
  noccupied = nelecs/2
  nvirtual = norbs - noccupied
  ipad2 = min(numat + 10, nint((real(numat))**0.25*50))
  ipad4 = nint(real(ipad2*norbs)/numat)
  icocc_dim = ipad2*noccupied + 1000
  icvir_dim = ipad2*nvirtual + 1000
  cocc_dim = ipad4*noccupied + 1000 !  100 is a safety factor, in case no Lewis structure is possible
  cvir_dim = ipad4*nvirtual + 1000
!
!  The two main sizes are:
!     mpack:  the number of elements in the density - one electron - Fock matrices,
!     n2elec: the number of two-electron integrals that are stored
!


!
!  Allocate the arrays.  If there is not enough memory, it's better to find out before
!  any real work is done.
!
  allocate(h(mpack), w(n2elec + 2025), stat = i)
  j = i
  if (id > 0) then
    allocate( wk(n2elec + 2025), stat = i)
    j = j + i
  end if
  allocate (pold(mpack), pold2(1), pold3(1), pbold(1), pbold2(1), stat = i)
  j = j + i
  allocate (ncocc(noccupied+1), ncvir(nvirtual+1), nncf(noccupied+1), nnce(nvirtual+1), &
               & icocc(icocc_dim), icvir(icvir_dim), jopt(numat), &
               & kopt(numat), ncf(noccupied + 1), nce(nvirtual + 1), p(mpack), &
               f(mpack), q(numat), stat = i)
  j = j + i
  allocate(ifact(norbs), stat = i)
  j = j + i
  allocate(cocc(cocc_dim), cvir(cvir_dim), stat = i)
  j = j + i
  if ( index(keywrd, " RESTART") /= 0 .or. &
       index(keywrd," 1SCF") == 0     .or. &
       index(keywrd, " GRAD") /= 0) then
    if (rapid) then
      allocate(part_dxyz(3,numat*l123), stat = i)
      j = j + i
    end if
    allocate(dxyz(3*numat*l123), errfn(3*numat*l123), stat = i)
    j = j + i
    dxyz = 0.d0
  end if
  allocate(p1(norbs), p2(norbs), p3(norbs), nfmo(norbs), idiag(norbs), stat = i)
  j = j + i
  allocate( ws(norbs), eigs(norbs), stat = i)
  j = j + i
  if (rapid) then
    allocate(  partf(mpack), partp(mpack), parth(mpack), stat = i)
    j = j + i
  else
    allocate(  partf(1), partp(1), parth(1), stat = i)
    mode = 0
  end if
  fmo_dim = Min(300, norbs)*norbs
  allocate (fmo(fmo_dim), ifmo(2,fmo_dim), stat = i)
  if (j /= 0) then
    call mopend("Failed to assign memory in MOZYME")
    return
  end if
  icocc = 0
  icvir = 0
  jopt = 0
  kopt = 0
! Initialize LMOs to zero size
  ncf = 0
  nce = 0
  nncf = 0
  nnce = 0
  ncocc = 0
  ncvir = 0
!
!   Create the ijbo array, if it exists?
!

  call fillij(.false.)

  ifact(1) = 0
  do i = 1, norbs - 1
    ifact(i + 1) = i + ifact(i)
  end do


  numred = numat
  norred = norbs
  nelred = nelecs

  end subroutine set_up_MOZYME_arrays
  subroutine delete_MOZYME_arrays()
    use molkst_C, only : numat
    use MOZYME_C, only : jopt, ncocc, ncvir, nncf, nnce, icocc, icvir, kopt, &
    ncf, nce, cocc, cvir, ions, iopt, nijbo, &
    part_dxyz, p1, p2, p3, ws, partf, parth, &
    partp, idiag, nfmo, fmo, ifmo, iorbs
!
    use common_arrays_C, only : h, w, wk, p, f, ifact, fb, q, c, dxyz, eigs, errfn
!
    use iter_C, only : pold, pold2, pold3, pbold, pbold2
    implicit none
    if (numat == 0) then
      if (allocated(ions))     deallocate(ions)
      if (allocated(iopt))     deallocate(iopt)
    end if

    if (allocated(c))          deallocate(c)
    if (allocated(h))          deallocate(h)
    if (allocated(jopt))       deallocate(jopt)
    if (allocated(wk))         deallocate(wk)
    if (allocated(w))          deallocate(w)
    if (allocated(f))          deallocate(f)
    if (allocated(fb))         deallocate(fb)
    if (allocated(p))          deallocate(p)
    if (allocated(pold))       deallocate(pold)
    if (allocated(pold2))      deallocate(pold2)
    if (allocated(pold3))      deallocate(pold3)
    if (allocated(pbold))      deallocate(pbold)
    if (allocated(pbold2))     deallocate(pbold2)
    if (allocated(ncocc))      deallocate(ncocc)
    if (allocated(ncvir))      deallocate(ncvir)
    if (allocated(nncf))       deallocate(nncf)
    if (allocated(nnce))       deallocate(nnce)
    if (allocated(icocc))      deallocate(icocc)
    if (allocated(icvir))      deallocate(icvir)
    if (allocated(kopt))       deallocate(kopt)
    if (allocated(ncf))        deallocate(ncf)
    if (allocated(nce))        deallocate(nce)
    if (allocated(pbold2))     deallocate(pbold2)
    if (allocated(ifact))      deallocate(ifact)
    if (allocated(cocc))       deallocate(cocc)
    if (allocated(cvir))       deallocate(cvir)
    if (allocated(q))          deallocate(q)
    if (allocated(dxyz))       deallocate(dxyz)
    if (allocated(errfn))      deallocate(errfn)
    if (allocated(pold))       deallocate(pold)
    if (allocated(p1))         deallocate(p1)
    if (allocated(p2))         deallocate(p2)
    if (allocated(p3))         deallocate(p3)
    if (allocated(ws))         deallocate(ws)
    if (allocated(fmo))        deallocate(fmo)
    if (allocated(ifmo))       deallocate(ifmo)
    if (allocated(partf))      deallocate(partf)
    if (allocated(partp))      deallocate(partp)
    if (allocated(parth))      deallocate(parth)
    if (allocated(part_dxyz))  deallocate(part_dxyz)
    if (allocated(nfmo))       deallocate(nfmo)
    if (allocated(eigs))       deallocate(eigs)
    if (allocated(idiag))      deallocate(idiag)
    if (allocated(iorbs))      deallocate(iorbs)
    if (allocated(nijbo))      deallocate(nijbo)
    return
  end subroutine delete_MOZYME_arrays

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine anavib(eigs, dipt, n3, vibs, rij, nv, hess, f)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE molkst_C, only : numat, line
      use common_arrays_C, only : nat, coord
      USE elemts_C, only : elemnt
      USE funcon_C, only : fpc_10, fpc_8, pi
      use to_screen_C, only : travel, redmas, force_const
      USE chanel_C, only : iw
      USE symmetry_C, only :  jndex, namo
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n3
      integer , intent(in) :: nv
      double precision , intent(in) :: eigs(n3)
      double precision , intent(in) :: dipt(n3)
      double precision , intent(in) :: vibs(n3,n3)
      double precision , intent(inout) :: rij((numat*(numat + 1))/2)
      double precision , intent(in) :: hess((3*numat*(3*numat + 1))/2)
      double precision , intent(inout) :: f((numat*(numat + 1))/2)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(10) :: ijf
      integer :: l, i, j, iline, k, j3, linear, j1, i1, jj, ii, ij, j2, i3, i2, npad
      double precision, dimension(107) :: vanrad
      double precision, dimension(10) :: fij
      double precision :: tot, vdw, eab, eb, ea, sum, xj, yj, zj, xi, yi, zi, x, y, z, e, shift, radial, ans
      character :: pad*20, num*1, num1*1
      logical :: vib1, vib2, vib3, vib4, vib5, vib6

      save vanrad
!-----------------------------------------------
      data vanrad/ 0.32D0, 0.93D0, 1.23D0, 0.90D0, 0.82D0, 0.77D0, 0.75D0, &
        0.73D0, 0.72D0, 0.71D0, 1.54D0, 1.36D0, 1.18D0, 1.11D0, 1.06D0, 1.02D0&
        , 0.99D0, 0.98D0, 2.03D0, 1.74D0, 1.44D0, 1.32D0, 1.22D0, 1.18D0, &
        1.17D0, 1.17D0, 1.16D0, 1.15D0, 1.17D0, 1.25D0, 1.26D0, 1.22D0, 1.20D0&
        , 1.16D0, 1.14D0, 1.12D0, 2.16D0, 1.91D0, 1.62D0, 1.45D0, 1.34D0, &
        1.30D0, 1.27D0, 1.25D0, 1.25D0, 1.28D0, 1.34D0, 1.48D0, 1.44D0, 1.41D0&
        , 1.40D0, 1.36D0, 1.33D0, 1.31D0, 2.35D0, 1.98D0, 1.69D0, 1.65D0, &
        1.65D0, 1.64D0, 1.63D0, 1.62D0, 1.85D0, 1.61D0, 1.59D0, 1.59D0, 1.58D0&
        , 1.57D0, 1.56D0, 1.56D0, 1.56D0, 1.44D0, 1.34D0, 1.30D0, 1.28D0, &
        1.26D0, 1.27D0, 1.30D0, 1.34D0, 1.49D0, 1.48D0, 1.47D0, 1.46D0, 1.46D0&
        , 1.45D0, 1.45D0, 21*1.45D0/
!
!    COMPUTE INTERATOMIC DISTANCES.
!
      l = 0
      do i = 1, numat
        do j = 1, i - 1
          l = l + 1
          rij(l) = sqrt((coord(1,j)-coord(1,i))**2+(coord(2,j)-coord(2,i))**2+(&
            coord(3,j)-coord(3,i))**2) + 1.D-10
        end do
      end do
!
!     ANALYSE VIBRATIONS
!
      write (iw, '(2/10X,''DESCRIPTION OF VIBRATIONS'',/)')
      iline = 0
      pad = " "
      i2 = int(log10(numat + 0.05))
      num = char(ichar("1") + i2)
      num1 = char(ichar("5") + (i2 + 1)/2)
      npad = 9 - i2/2
      do k = 1, nv
        vib1 = .TRUE.
        vib2 = .TRUE.
        vib3 = .TRUE.
        vib4 = .TRUE.
        vib5 = .TRUE.
        vib6 = .TRUE.
        j3 = 0
        l = 0
        tot = 0.D0
        linear = 0
        j1 = -2
        do j = 1, numat
          j1 = j1 + 3
          i1 = -2
          do i = 1, j - 1
            i1 = i1 + 3
            vdw = (vanrad(nat(i))+vanrad(nat(j)))*1.5D0
            l = l + 1
            f(l) = 0.D0
            if (rij(l) >= vdw) cycle
!
! CALCULATE ENERGY TERM BETWEEN THE TWO ATOMS
!
            eab = 0.D0
            do jj = j1, j1 + 2
              do ii = i1, i1 + 2
                eab = eab + vibs(jj,k)*hess((jj*(jj-1))/2+ii)*vibs(ii,k)
              end do
            end do
            eb = 0.D0
            do jj = j1, j1 + 2
              do ii = j1, jj
                eb = eb + vibs(jj,k)*hess((jj*(jj-1))/2+ii)*vibs(ii,k)*2.D0
              end do
              eb = eb - vibs(jj,k)*hess((jj*(jj+1))/2)*vibs(jj,k)
            end do
            ea = 0.D0
            do jj = i1, i1 + 2
              do ii = i1, jj
                ea = ea + vibs(jj,k)*hess((jj*(jj-1))/2+ii)*vibs(ii,k)*2.D0
              end do
              ea = ea - vibs(jj,k)*hess((jj*(jj+1))/2)*vibs(jj,k)
            end do
            linear = linear + 1
            f(l) = ea + eab*2.D0 + eb
            tot = tot + f(l)
          end do
        end do
        if (k == nv .or. jndex (k) .ne. jndex(k+1) .or. namo (k) .ne. namo(k+1)) then
        if (abs(tot) >= 1.D-5) then
!
!  NOW TO SORT F INTO DECENDING ORDER
!
          do i = 1, 10
            jj = 0
            sum = -100.D0
            do j = 1, l
              if (abs(f(j)) <= sum) cycle
              jj = j
              sum = abs(f(j))
            end do
            if (sum < 0.D0) go to 100
            fij(i) = sum
            f(jj) = -1.D-9
            ijf(i) = jj
          end do
          i = 10
  100     continue
          linear = i
          sum = 1.D0/tot
          do ij = 1, linear
            j = int(0.5D0*(0.9999D0 + sqrt(1.D0 + 8.D0*ijf(ij))))
            i = ijf(ij) - (j*(j - 1))/2
            j = j + 1
            xj = coord(1,j)
            yj = coord(2,j)
            zj = coord(3,j)
            j1 = 3*j - 2
            j2 = j1 + 1
            j3 = j2 + 1
            i3 = 0
            xi = coord(1,i)
            yi = coord(2,i)
            zi = coord(3,i)
            i1 = 3*i - 2
            i2 = i1 + 1
            i3 = i2 + 1
            x = vibs(j1,k) - vibs(i1,k)
            y = vibs(j2,k) - vibs(i2,k)
            z = vibs(j3,k) - vibs(i3,k)
            e = fij(ij)*sum*100.D0
            shift = x*x + y*y + z*z + 1.D-30
            if (.not.(abs(e)>10.D0 .or. ij<5 .and. abs(e)>0.1D0)) cycle
            shift = sqrt(shift)
            radial = ((x*(xi - xj) + y*(yi - yj) + z*(zi - zj))/(shift*rij(ijf(ij))))**2*100.D0
            ans = min(999.d0, max(-99.9d0, 100.D0*sqrt(fij(ij)*1.D5*fpc_10)/(fpc_8*pi*2.D0)/eigs(k)))
            j1 = 1
            if (elemnt(nat(j))(1:1) == " ") j1 = 2
            i1 = 1
            if (elemnt(nat(i))(1:1) == " ") i1 = 2
            write(line,'(a, i'//num//', a, i'//num//',a, sp,F9.1,ss,''% ('',F5.1,''%)'',F9.1,''%'')') &
             pad(:npad)//elemnt(nat(i))(i1:2)//pad(: i1 - 1), i, " -- "//elemnt(nat(j))(j1:2)//pad(: j1 - 1), &
              j, pad(:npad - 4), e, ans, radial
            if (vib1) then
              write (iw, &
      '(/," VIBRATION",I11,I5,A4, '//num1//'x, "  ATOM PAIR", '//num1//'x, "ENERGY CONTRIBUTION    RADIAL")') &
       k, jndex(k), namo(k)
              write (iw, '('' FREQUENCY        '',F9.2,a)') eigs(k), trim(line)
              vib1 = .FALSE.
            else if (vib2) then
              vib2 = .FALSE.
              write (iw, '('' TRANSITION DIPOLE'',F9.4,a)') dipt(k), trim(line)
            else if (vib3) then
              vib3 = .FALSE.
              write (iw, '('' TRAVEL (Ang.)    '',F9.4,a)') travel(k), trim(line)
            else if (vib4) then
              vib4 = .FALSE.
              write (iw, '('' REDUCED MASS     '',F9.4,a)') redmas(k,1), trim(line)
            else if (vib5) then
              vib5 = .false.
              write (iw, '('' EFFECTIVE MASS   '',F9.4,a)') redmas(k,2), trim(line)
            else if (vib6) then
              vib6 = .false.
              write (iw, '('' FORCE CONSTANT   '',F9.4,a)') force_const(k), trim(line)
            else
              iline = iline + 1
              write (iw, &
              & '(''                   '',a)') &
               trim(line)
            end if
          end do
        end if
        if (vib1) then
          write (iw, '(/,'' VIBRATION'',I4)') k
          write (iw, '(  '' FREQ.    '',F8.2)') eigs(k)
        end if
        if (vib2) write (iw, '(  '' TRANSITION DIPOLE'',F9.4)') dipt(k)
        if (vib3) write (iw, '(  '' TRAVEL (Ang.)    '',F9.4)') travel(k)
        if (vib4) write (iw, '(  '' REDUCED MASS     '',F9.4)') redmas(k, 1)
        if (vib5) write (iw, '(  '' EFFECTIVE MASS   '',F9.4)') min(9999.9999d0,max(-999.9999d0,redmas(k, 2)))
        if (vib6) write (iw, '(  '' FORCE CONSTANT   '',F9.4)') force_const(k)
        end if
      end do
      return
      end subroutine anavib

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine tred2e(nm, n, a, d, e, z)

      implicit none
      integer :: i, j, k, l, n, ii, nm, jp1
      double precision :: a(nm, n), d(n), e(n), z(nm, n)
      double precision :: f, g, h, hh, scale

!
!     this subroutine is a translation of the algol procedure tred2,
!     num. math. 11, 181 - 195(1968) by martin, reinsch, and wilkinson.
!     handbook for auto. comp., vol.ii - linear algebra, 212 - 226(1971).
!
!     this subroutine reduces a real symmetric matrix to a
!     symmetric tridiagonal matrix using and accumulating
!     orthogonal similarity transformations.
!
!     on input -
!
!        nm must be set to the row dimension of two - dimensional
!          array parameters as declared in the calling program
!          dimension statement,
!
!        n is the order of the matrix,
!
!        a contains the real symmetric input matrix.  only the
!          lower triangle of the matrix need be supplied.
!
!     on output -
!
!        d contains the diagonal elements of the tridiagonal matrix,
!
!        e contains the subdiagonal elements of the tridiagonal
!          matrix in its last n - 1 positions.  e(1) is set to zero,
!
!        z contains the orthogonal transformation matrix
!          produced in the reduction,
!
!        a and z may coincide.  if distinct, a is unaltered.
!
!     questions and comments should be directed to b. s. garbow,
!     applied mathematics division, argonne national laboratory
!
!    - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!
      do i = 1, n
         do j = 1, i
            z(i, j) = a(i, j)
         end do
      end do
!
      if (n  ==  1) go to 320
!     ********** for i = n step - 1 until 2 do - - **********
      do ii = 2, n
         i = n + 2 - ii
         l = i - 1
         h = 0.0
         scale = 0.0
         if (l  <  2) go to 130
!     ********** scale row (algol tol then not needed) **********
         do k = 1, l
            scale = scale + abs(z(i, k))
         end do
!
         if (scale /= 0.0) go to 140
  130    e(i) = z(i, l)
         go to 290
!
  140    do k = 1, l
            z(i, k) = z(i, k) / scale
            h = h + z(i, k) * z(i, k)
         end do
!
         f = z(i, l)
         g = -sign(sqrt(h), f)
         e(i) = scale * g
         h = h - f * g
         z(i, l) = f - g
         f = 0.0
!
         do j = 1, l
            z(j, i) = z(i, j) / (scale * h)
            g = 0.0
!     ********** form element of a*u **********
            do k = 1, j
               g = g + z(j, k) * z(i, k)
            end do
!
            jp1 = j + 1
            if (l  <  jp1) go to 220
!
            do k = jp1, l
               g = g + z(k, j) * z(i, k)
            end do
!     ********** form element of p **********
  220       e(j) = g / h
            f = f + e(j) * z(i, j)
         end do
!
         hh = f / (h + h)
!     ********** form reduced a **********
         do j = 1, l
            f = z(i, j)
            g = e(j) - hh * f
            e(j) = g
            do k = 1, j
               z(j, k) = z(j, k) - f * e(k) - g * z(i, k)
            end do
         end do
!
         do k = 1, l
            z(i, k) = scale * z(i, k)
         end do
!
  290    d(i) = h
      end do
!
  320 d(1) = 0.0
      e(1) = 0.0
!     ********** accumulation of transformation matrices **********
      do i = 1, n
         l = i - 1
         if (d(i)  ==  0.0) go to 380
!
         do j = 1, l
            g = 0.0
!
            do k = 1, l
               g = g + z(i, k) * z(k, j)
            end do
!
            do k = 1, l
               z(k, j) = z(k, j) - g * z(k, i)
            end do
         end do
!
  380    d(i) = z(i, i)
         z(i, i) = 1.d0
         if (l  >=  1) then
            do j = 1, l
               z(i, j) = 0.0
               z(j, i) = 0.0
            end do
         endif
!
      end do
!
      return
!     ********** last card of tred2 **********
      end subroutine tred2e
!
!    - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!
      subroutine tql2e(nm, n, d, e, z, ierr)

      implicit none
      integer :: i, j, k, l, m, n, ii, nm, mml, ierr
      double precision :: d(n), e(n), z(nm, n)
      double precision :: b, c, f, g, h, p, r, s, machep
!
!     this subroutine is a translation of the algol procedure tql2,
!     num. math. 11, 293 - 306(1968) by bowdler, martin, reinsch, and
!     wilkinson.
!     handbook for auto. comp., vol.ii - linear algebra, 227 - 240(1971).
!
!     this subroutine finds the eigenvalues and eigenvectors
!     of a symmetric tridiagonal matrix by the ql method.
!     the eigenvectors of a full symmetric matrix can also
!     be found if  tred2  has been used to reduce this
!     full matrix to tridiagonal form.
!
!     on input -
!
!        nm must be set to the row dimension of two - dimensional
!          array parameters as declared in the calling program
!          dimension statement,
!
!        n is the order of the matrix,
!
!        d contains the diagonal elements of the input matrix,
!
!        e contains the subdiagonal elements of the input matrix
!          in its last n - 1 positions.  e(1) is arbitrary,
!
!        z contains the transformation matrix produced in the
!          reduction by  tred2, if performed.  if the eigenvectors
!          of the tridiagonal matrix are desired, z must contain
!          the identity matrix.
!
!      on output -
!
!        d contains the eigenvalues in ascending order.  if an
!          error exit is made, the eigenvalues are correct but
!          unordered for indices 1, 2, ..., ierr - 1,
!
!        e has been destroyed,
!
!        z contains orthonormal eigenvectors of the symmetric
!          tridiagonal (or full) matrix.  if an error exit is made,
!          z contains the eigenvectors associated with the stored
!          eigenvalues,
!
!        ierr is set to
!          zero       for normal return,
!          j          if the j - th eigenvalue has not been
!                     determined after 30 iterations.
!
!     questions and comments should be directed to b. s. garbow,
!     applied mathematics division, argonne national laboratory
!
!    - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!
!     ********** machep is a machine dependent parameter specifying
!                the relative precision of floating point arithmetic.
!
!                **********
      machep = 2.d0**(- 52)

      ierr = 0
      if (n  ==  1) go to 1001

      do i = 2, n
         e(i - 1) = e(i)
      end do

      f = 0.0
      b = 0.0
      e(n) = 0.0

      do 240 l = 1, n
         j = 0
         h = machep * (abs(d(l)) + abs(e(l)))
         if (b  <  h) b = h
!     ********** look for small sub - diagonal element **********
         do 110 m = l, n
            if (abs(e(m))  <=  b) go to 120
!     ********** e(n) is always zero, so there is no exit
!                through the bottom of the loop **********
  110    continue

  120    if (m  ==  l) go to 220
  130    if (j  ==  30) go to 1000
         j = j + 1
!     ********** form shift **********
         p = (d(l + 1) - d(l)) / (2.0 * e(l))
         r = sqrt(p*p + 1.d0)
         h = d(l) - e(l) / (p + sign(r, p))

         do i = l, n
            d(i) = d(i) - h
         end do

         f = f + h
!     ********** ql transformation **********
         p = d(m)
         c = 1.d0
         s = 0.0
         mml = m - l
!     ********** for i = m - 1 step - 1 until l do - - **********
         do 200 ii = 1, mml
            i = m - ii
            g = c * e(i)
            h = c * p
            if (abs(p)  <  abs(e(i))) go to 150
            c = e(i) / p
            r = sqrt(c*c + 1.d0)
            e(i + 1) = s * p * r
            s = c / r
            c = 1.0 / r
            go to 160
  150       c = p / e(i)
            r = sqrt(c*c + 1.d0)
            e(i + 1) = s * e(i) * r
            s = 1.0 / r
            c = c * s
  160       p = c * d(i) - s * g
            d(i + 1) = h + s * (c * g + s * d(i))
!     ********** form vector **********
            do 180 k = 1, n
               h = z(k, i + 1)
               z(k, i + 1) = s * z(k, i) + c * h
               z(k, i) = c * z(k, i) - s * h
  180       continue

  200    continue

         e(l) = s * p
         d(l) = c * p
         if (abs(e(l))  >  b) go to 130
  220    d(l) = d(l) + f
  240 continue
!     ********** order eigenvalues and eigenvectors **********
      do 300 ii = 2, n
         i = ii - 1
         k = i
         p = d(i)

         do 260 j = ii, n
            if (d(j)  >=  p) go to 260
            k = j
            p = d(j)
  260    continue

         if (k  ==  i) go to 300
         d(k) = d(i)
         d(i) = p

         do 280 j = 1, n
            p = z(j, i)
            z(j, i) = z(j, k)
            z(j, k) = p
  280    continue

  300 continue

      go to 1001
!     ********** set error - - no convergence to an
!                eigenvalue after 30 iterations **********
 1000 ierr = l
 1001 return
!     ********** last card of tql2 **********
      end subroutine tql2e

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine quadr(f0, f1, f2, x1, x2, a, b, c)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision , intent(in) :: f0
      double precision , intent(in) :: f1
      double precision , intent(in) :: f2
      double precision , intent(in) :: x1
      double precision , intent(in) :: x2
      double precision , intent(out) :: a
      double precision , intent(out) :: b
      double precision , intent(out) :: c
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
!-----------------------------------------------
!***************************************************
!                                                  *
!    QUADR CALCULATES THE A, B AND C IN THE EQUNS. *
!                                                  *
!     A                   =   F0                   *
!     A + B.X0 + C.X0**2  =   F1                   *
!     A + B.X2 + C.X2**2  =   F2                   *
!                                                  *
!***************************************************
      c = (x2*(f1 - f0) - x1*(f2 - f0))/(x2*x1*(x1 - x2))
      b = (f1 - f0 - c*x1**2)/x1
      a = f0
      return
      end subroutine quadr

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

MODULE MDI_IMPLEMENTATION

  USE, INTRINSIC :: ISO_C_binding

  ! MDI library dependencies
  use MDI_wrapper, only : MDI_Init, MDI_Accept_communicator, MDI_Send, &
    MDI_Recv_command, MDI_Recv, MDI_COMMAND_LENGTH, MDI_LABEL_LENGTH, &
    MDI_DOUBLE, MDI_CHAR, MDI_INT, MDI_Register_command, MDI_Register_node, &
    MDI_Conversion_factor, MDI_Get_role, MDI_ENGINE, MDI_Plugin_get_argc, &
    MDI_Plugin_get_arg, MDI_Set_plugin_state, MDI_Set_execute_command_func

  ! MOPAC data exposed to the MDI interface:
  USE chanel_C, only : iw

  use molkst_C, only : numat, & ! number of real atoms
    id, & ! number of translation/lattice vectors
    nvar, & ! number of coordinates to be optimized
    msdel, & ! magnetic component of spin
    escf, & ! heat of formation
    nelecs, & ! number of electrons
    voigt, & ! Voigt stress tensor (xx, yy, zz, yz, xz, xy)
    jobnam, & ! path to input file
    run ! run mode

  use Common_arrays_C, only : geo, & ! raw coordinates of atoms (highest priority for unrelaxed coordinates)
    xparam, & ! values of coordinates undergoing optimization (highest priority for relaxed coordinates)
    loc, & ! indices of atoms and coordinates marked for optimization
    p, & ! total density matrix
    q, & ! partial charges
    nat, & ! atomic numbers of real atoms
    atmass, & ! atomic masses
    grad, & ! gradients of heat
    txtatm1 ! original atom discriptor

  use parameters_C, only : tore ! number of valence electrons per element

  implicit none

  ! MDI Communicator to the driver
  INTEGER :: comm

  ! Status flags for MDI
  LOGICAL :: use_mdi = .false.
  LOGICAL :: open_mdi = .false.
  LOGICAL :: close_mdi = .false.
  LOGICAL :: terminate_flag
  LOGICAL :: recompute_flag

CONTAINS

  FUNCTION MDI_Plugin_open_mopac(plugin_state) bind ( C, name="MDI_Plugin_open_mopac" )
    TYPE(C_PTR), VALUE :: plugin_state
    INTEGER :: MDI_Plugin_open_mopac
    INTEGER :: ierr, argc
    CHARACTER(len=240) :: input_file
    PROCEDURE(execute_command), POINTER :: generic_command => null()
    TYPE(C_PTR)                         :: class_obj
    interface
      subroutine run_mopac() bind(c)
      end subroutine run_mopac
    end interface
    MDI_Plugin_open_mopac = 0
    CALL MDI_Set_plugin_state(plugin_state, ierr)
    generic_command => execute_command
    CALL MDI_Set_execute_command_func(c_funloc(generic_command), class_obj, ierr)
    CALL MDI_Plugin_get_argc(argc, ierr)
    IF (argc > 0) THEN
      CALL MDI_Plugin_get_arg(0, input_file, ierr)
    ELSE
      MDI_Plugin_open_mopac = 1
      WRITE(*,*) "MDI ERROR: No input file provided for MOPAC engine"
      RETURN
    END IF
    run = 2
    jobnam = trim(input_file)
    use_mdi = .true.
    open_mdi = .true.
    CALL run_mopac
    open_mdi = .false.
  END FUNCTION MDI_Plugin_open_mopac

  FUNCTION MDI_Plugin_close_mopac() bind ( C, name="MDI_Plugin_close_mopac" )
    INTEGER :: MDI_Plugin_close_mopac
    interface
      subroutine run_mopac() bind(c)
      end subroutine run_mopac
    end interface
    MDI_Plugin_close_mopac = 0
    close_mdi = .true.
    CALL run_mopac
    close_mdi = .false.
    use_mdi = .false.
    jobnam = ' '
    run = 1
  END FUNCTION MDI_Plugin_close_mopac

  FUNCTION MDI_Plugin_launch_mopac(plugin_state) bind ( C, name="MDI_Plugin_launch_mopac" )
    TYPE(C_PTR), VALUE :: plugin_state
    INTEGER :: MDI_Plugin_launch_mopac
    INTEGER :: ierr, argc
    CHARACTER(len=240) :: input_file
    PROCEDURE(execute_command), POINTER :: generic_command => null()
    TYPE(C_PTR)                         :: class_obj
    interface
      subroutine run_mopac() bind(c)
      end subroutine run_mopac
    end interface
    MDI_Plugin_launch_mopac = 0
    CALL MDI_Set_plugin_state(plugin_state, ierr)
    generic_command => execute_command
    CALL MDI_Set_execute_command_func(c_funloc(generic_command), class_obj, ierr)
    CALL MDI_Plugin_get_argc(argc, ierr)
    IF (argc > 0) THEN
      CALL MDI_Plugin_get_arg(0, input_file, ierr)
    ELSE
      MDI_Plugin_launch_mopac = 1
      WRITE(*,*) "MDI ERROR: No input file provided for MOPAC engine"
      RETURN
    END IF
    run = 2
    jobnam = trim(input_file)
    use_mdi = .true. 
    CALL run_mopac
    use_mdi = .false.
    jobnam = ' '
    run = 1
  END FUNCTION MDI_Plugin_launch_mopac

  SUBROUTINE initialize_mdi()
    INTEGER :: i, ierr, role
    CHARACTER(len=1024) :: mdi_options

    ! Check for CLI mode (-mdi command-line option)
    do i = 1, iargc()
      call getarg (i, mdi_options)
      if (mdi_options == '-mdi' .OR. mdi_options == '--mdi') then
        if ( i .eq. iargc() ) then
          WRITE(iw,*) "MDI ERROR: No argument was provided for the -mdi command-line option"
          stop
        else
          call getarg (i+1, mdi_options)
          write(iw,*) " Received MDI command-line options: ",TRIM(mdi_options)
          call MDI_Init( mdi_options, ierr)
          use_mdi = .true.
        endif
      endif
    end do

    IF ( use_mdi ) THEN
      ! Confirm that the code is being run as an ENGINE
      call MDI_Get_role(role, ierr)
      IF ( role /= MDI_ENGINE ) THEN
        WRITE(iw,*) "MDI ERROR: Must run MOPAC as an ENGINE"
      END IF

      ! Set control flags
      recompute_flag = .true.
      terminate_flag = .false.

      ! Register supported MDI commands
      CALL MDI_Register_node("@DEFAULT", ierr)
      CALL MDI_Register_command("@DEFAULT", "EXIT", ierr)
      CALL MDI_Register_command("@DEFAULT", "<@", ierr)
      CALL MDI_Register_command("@DEFAULT", ">CELL", ierr)
      CALL MDI_Register_command("@DEFAULT", "<CELL", ierr)
      CALL MDI_Register_command("@DEFAULT", "<CELL_DISPL", ierr)
      CALL MDI_Register_command("@DEFAULT", "<CHARGES", ierr)
      CALL MDI_Register_command("@DEFAULT", ">COORDS", ierr)
      CALL MDI_Register_command("@DEFAULT", "<COORDS", ierr)
      CALL MDI_Register_command("@DEFAULT", "<DIMENSIONS", ierr)
      CALL MDI_Register_command("@DEFAULT", "<ELEC_MULT", ierr)
      CALL MDI_Register_command("@DEFAULT", "<ELEMENTS", ierr)
      CALL MDI_Register_command("@DEFAULT", "<ENERGY", ierr)
      CALL MDI_Register_command("@DEFAULT", "<FORCES", ierr)
      CALL MDI_Register_command("@DEFAULT", "<LABELS", ierr)
      CALL MDI_Register_command("@DEFAULT", "<MASSES", ierr)
      CALL MDI_Register_command("@DEFAULT", "<NATOMS", ierr)
      CALL MDI_Register_command("@DEFAULT", "<STRESS", ierr)
      CALL MDI_Register_command("@DEFAULT", "<TOTCHARGE", ierr)

      ! Connect to the driver
      call MDI_Accept_communicator(comm, ierr)
      write(iw,*) " Received MDI communicator: ", comm
    END IF

  END SUBROUTINE initialize_mdi

  SUBROUTINE respond_to_commands()
    CHARACTER(len=:), ALLOCATABLE :: command
    INTEGER                       :: ierr

    TYPE(C_PTR)                   :: class_obj

    ALLOCATE( character(MDI_COMMAND_LENGTH) :: command )

    ! Respond to the driver's commands
    response_loop: DO

      ! Receive a command from the driver and broadcast it to all ranks
      CALL MDI_Recv_command(command, comm, ierr)
      write(iw,*) " Received MDI command: ",TRIM(command)

      ierr = execute_command(command, comm, class_obj)
      IF ( ierr /= 0 ) STOP 1

      IF ( terminate_flag ) EXIT

    END DO response_loop

    DEALLOCATE( command )

  END SUBROUTINE respond_to_commands

  FUNCTION execute_command(command, comm, class_obj)

    CHARACTER(LEN=*), INTENT(IN)  :: command
    INTEGER, INTENT(IN)           :: comm
    TYPE(C_PTR), VALUE            :: class_obj
    INTEGER(KIND=C_INT)           :: execute_command

    INTEGER                       :: i, j, ierr
    INTEGER                       :: natoms
    DOUBLE PRECISION              :: conv
    DOUBLE PRECISION              :: charge
    CHARACTER(len=:), ALLOCATABLE :: char_array
    INTEGER, ALLOCATABLE          :: int_array(:)
    DOUBLE PRECISION, ALLOCATABLE :: real_array(:)

    execute_command = 0
 
    SELECT CASE( TRIM(command) )
    CASE( "EXIT" )
      terminate_flag = .true.

    CASE( "<@" )
      ! Send the name of the current node
      ! For MOPAC, this is always "@DEFAULT"
      CALL MDI_Send("@DEFAULT", MDI_COMMAND_LENGTH, MDI_CHAR, comm, ierr)
      if (ierr /= 0) execute_command = 1

    CASE( "<CELL_DISPL" )
      ! Send the current displacement of the cell origin
      ! This is always zero for MOPAC
      ALLOCATE( real_array(3) )
      real_array = 0.0d0
      CALL MDI_Send(real_array, 3, MDI_DOUBLE, comm, ierr)
      if (ierr /= 0) execute_command = 1
      DEALLOCATE( real_array )

    CASE( "<CELL" )
      ! Send the cell dimensions
      ! This should be in the form of three vectors
      CALL MDI_Conversion_factor("angstrom", "atomic_unit_of_length", conv, ierr)
      if (ierr /= 0) execute_command = 1
      ALLOCATE( real_array(9) )
      real_array = 0.0d0
      do i=1, id
        do j=1, 3
          real_array(3*(i-1)+j) = geo(j,numat+i) * conv
        end do
      end do
      CALL MDI_Send(real_array, 9, MDI_DOUBLE, comm, ierr)
      if (ierr /= 0) execute_command = 1
      DEALLOCATE( real_array )

    CASE( ">CELL" )
      ! Receive new cell dimensions
      ! NOTE: This is not reliable if the cell changes are too large,
      !   in which case the summation bounds over unit cells need to be recomputed
      CALL MDI_Conversion_factor("atomic_unit_of_length", "angstrom", conv, ierr)
      if (ierr /= 0) execute_command = 1
      ALLOCATE( real_array(9) )
      CALL MDI_Recv(real_array, 9, MDI_DOUBLE, comm, ierr)
      if (ierr /= 0) execute_command = 1
      do i=1, id
        do j=1, 3
          geo(j, numat+i) = real_array(3*(i-1)+j) * conv
        end do
      end do
      DEALLOCATE( real_array )
      ! make sure that optimized coordinates in xparam are synchronized with geo
      do i=MAX(nvar-3*id+1,1), nvar
        if (loc(1,i) > numat) then
          xparam(i) = geo(loc(2,i), loc(1,i))
        end if
      end do
      recompute_flag = .true.

    CASE( "<CHARGES" )
      ! Send the partial charges of each atom
      CALL recompute_as_needed()
      ! extra code for partial charge post-processing
      call chrge (p, q)
      q(:numat) = tore(nat(:numat)) - q(:numat)
      CALL MDI_Send(q, numat, MDI_DOUBLE, comm, ierr)
      if (ierr /= 0) execute_command = 1

    CASE( "<COORDS" )
      ! Send the current nuclear coordinates
      CALL MDI_Conversion_factor("angstrom", "atomic_unit_of_length", conv, ierr)
      if (ierr /= 0) execute_command = 1
      ALLOCATE( real_array(3*numat) )  
      do i=1, numat
        do j=1, 3
          real_array(3*(i-1)+j) = geo(j,i) * conv
        end do
      end do
      CALL MDI_Send(real_array, 3 * numat, MDI_DOUBLE, comm, ierr)
      if (ierr /= 0) execute_command = 1
      DEALLOCATE( real_array )

    CASE( ">COORDS" )
      ! Receive a new set of nuclear coordinates
      CALL MDI_Conversion_factor("atomic_unit_of_length", "angstrom", conv, ierr)
      if (ierr /= 0) execute_command = 1
      ALLOCATE( real_array(3*numat) )
      CALL MDI_Recv(real_array, 3 * numat, MDI_DOUBLE, comm, ierr)
      if (ierr /= 0) execute_command = 1
      do i=1, numat
        do j=1, 3
          geo(j, i) = real_array(3*(i-1)+j) * conv
        end do
      end do
      DEALLOCATE( real_array )
      ! make sure that optimized coordinates in xparam are synchronized with geo
      do i=1, nvar
        if (loc(1,i) <= numat) then
          xparam(i) = geo(loc(2,i), loc(1,i))
        end if
      end do
      recompute_flag = .true.

    CASE( "<DIMENSIONS" )
      ! Send the status of translation vectors
      ALLOCATE( int_array(3) )
      int_array = 1
      if (id > 0) int_array(1:id) = 2
      CALL MDI_Send(int_array, 3, MDI_INT, comm, ierr)
      if (ierr /= 0) execute_command = 1
      DEALLOCATE( int_array )

    CASE( "<ELEC_MULT" )
      ! Send the current electronic multiplicity
      CALL MDI_Send(msdel+1, 1, MDI_INT, comm, ierr)
      if (ierr /= 0) execute_command = 1

    CASE( "<ELEMENTS" )
      ! Send the element of each atom
      CALL MDI_Send(nat, numat, MDI_INT, comm, ierr)
      if (ierr /= 0) execute_command = 1

    CASE( "<ENERGY" )
      ! Calculate and send the energy
      CALL recompute_as_needed()
      CALL MDI_Conversion_factor("kilocalorie_per_mol", "atomic_unit_of_energy", conv, ierr)
      if (ierr /= 0) execute_command = 1
      CALL MDI_Send(escf*conv, 1, MDI_DOUBLE, comm, ierr)
      if (ierr /= 0) execute_command = 1

    CASE( "<FORCES" )
      ! Calculate and send the nuclear forces
      CALL recompute_as_needed()
      ALLOCATE( real_array(3*numat) )
      real_array = 0.0d0
      do i=1, nvar
        if (loc(1,i) <= numat) then
          real_array(3*(loc(1,i)-1)+loc(2,i)) = grad(i)
        end if
      end do
      CALL MDI_Conversion_factor("kilocalorie_per_mol", "atomic_unit_of_energy", conv, ierr)
      if (ierr /= 0) execute_command = 1
      real_array = real_array * conv
      CALL MDI_Conversion_factor("angstrom", "atomic_unit_of_length", conv, ierr)
      if (ierr /= 0) execute_command = 1
      real_array = real_array / conv
      CALL MDI_Send(real_array, 3 * numat, MDI_DOUBLE, comm, ierr)
      if (ierr /= 0) execute_command = 1
      DEALLOCATE( real_array )

    CASE( "<LABELS" )
      ! Send the atom labels
      ALLOCATE( CHARACTER(len=(MDI_LABEL_LENGTH * natoms)) :: char_array )
      char_array = ""
      do i=1, numat
        char_array(1+(i-1)*MDI_LABEL_LENGTH:i*MDI_LABEL_LENGTH) = trim(txtatm1(i))
      end do
      CALL MDI_Send(char_array, MDI_LABEL_LENGTH * natoms, MDI_CHAR, comm, ierr)
      if (ierr /= 0) execute_command = 1
      DEALLOCATE( char_array )

    CASE( "<MASSES" )
      ! Send the atomic masses
      CALL MDI_Send(atmass, numat, MDI_DOUBLE, comm, ierr)
      if (ierr /= 0) execute_command = 1

    CASE( "<NATOMS" )
      ! Send the current number of atoms in the system
      CALL MDI_Send(numat, 1, MDI_INT, comm, ierr)
      if (ierr /= 0) execute_command = 1

    CASE( "<STRESS" )
      ! Calculate and send the virial stress tensor
      CALL recompute_as_needed()
      ALLOCATE( real_array(9) )
      ! (xx, yy, zz, yz, xz, xy) -> (xx, xy, xz, yx, yy, yz, zx, zy, zz)
      real_array(1) = voigt(1)
      real_array(2) = voigt(6)
      real_array(3) = voigt(5)
      real_array(4) = voigt(6)
      real_array(5) = voigt(2)
      real_array(6) = voigt(4)
      real_array(7) = voigt(5)
      real_array(8) = voigt(4)
      real_array(9) = voigt(3)
      CALL MDI_Conversion_factor("newton", "atomic_unit_of_force", conv, ierr)
      if (ierr /= 0) execute_command = 1
      real_array = real_array * conv * 1e-9
      CALL MDI_Conversion_factor("meter", "atomic_unit_of_length", conv, ierr)
      if (ierr /= 0) execute_command = 1
      real_array = real_array / (conv*conv)
      CALL MDI_Send(real_array, 9, MDI_DOUBLE, comm, ierr)
      if (ierr /= 0) execute_command = 1
      DEALLOCATE( real_array )

    CASE( "<TOTCHARGE" )
      ! Send the total charge of the system
      charge = -nelecs
        do i=1, numat
          charge = charge + tore(nat(i))
        end do
      CALL MDI_Send(charge, 1, MDI_DOUBLE, comm, ierr)
      if (ierr /= 0) execute_command = 1

    CASE DEFAULT
      write(iw,*) "Unknown command ", trim(command)," received through MDI"
      execute_command = 1
    END SELECT

  END FUNCTION execute_command

  SUBROUTINE recompute_as_needed()
  if ( recompute_flag ) then
    call compfg (xparam, .true., escf, .true., grad, .true.)
    recompute_flag = .false.
  end if
  END SUBROUTINE recompute_as_needed

END MODULE MDI_IMPLEMENTATION

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      double precision function dipole (p, coord, dipvec, mode)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE molkst_C, only : numat, keywrd, numcal, ux, uy, uz, mpack, &
      mol_weight
      USE parameters_C, only : ddp, dd
      use to_screen_C, only : dip
      USE funcon_C, only : fpc_8, fpc_1, a0
      USE chanel_C, only : iw
      use common_arrays_C, only : nfirst, nlast, nat, atmass, q
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: mode
      double precision , intent(in) :: p(mpack)
      double precision , intent(inout) :: coord(3,*)
      double precision , intent(out) :: dipvec(3)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: icalcn, i, j, ni, ia, ib, l, k, ll
      double precision, dimension(3) :: center
      double precision :: sum, hyfsp, xt, hyfpd, dx, dy, dz, factdm
      logical :: first, chargd, force

      save first, chargd, force, icalcn
!-----------------------------------------------
!***********************************************************************
!     DIPOLE CALCULATES DIPOLE MOMENTS
!
!  ON INPUT P     = DENSITY MATRIX
!           Q     = TOTAL ATOMIC CHARGES, (NUCLEAR + ELECTRONIC)
!           NUMAT = NUMBER OF ATOMS IN MOLECULE
!           NAT   = ATOMIC NUMBERS OF ATOMS
!           NFIRST= START OF ATOM ORBITAL COUNTERS
!           COORD = COORDINATES OF ATOMS
!
!  OUTPUT  DIPOLE = DIPOLE MOMENT
!***********************************************************************
!
!     IN THE ZDO APPROXIMATION, ONLY TWO TERMS ARE RETAINED IN THE
!     CALCULATION OF DIPOLE MOMENTS.
!     1. THE POINT CHARGE TERM (INDEPENDENT OF PARAMETERIZATION).
!     2. THE ONE-CENTER HYBRIDIZATION TERM, WHICH ARISES FROM MATRIX
!     ELEMENTS OF THE FORM <NS/R/NP>. THIS TERM IS A FUNCTION OF
!     THE SLATER EXPONENTS (ZS,ZP) AND IS THUS DEPENDENT ON PARAMETER-
!     IZATION.
!
!
!     REFERENCES:
!     J.A.POPLE & D.L.BEVERIDGE: APPROXIMATE M.O. THEORY
!     S.P.MCGLYNN, ET AL: APPLIED QUANTUM CHEMISTRY
!
      data icalcn/ 0/
      first = icalcn /= numcal
      icalcn = numcal
!
!   CONST = c.C.a0.2
!
      if (first) then
        sum = 0.D0
        do i = 1, numat
          sum = sum + q(i)
        end do
        chargd = abs(sum) > 0.5D0
        force = index(keywrd,'FORCE') + index(keywrd," THERMO") + index(keywrd,'IRC') /= 0
      end if
      if (.not.force .and. chargd) then
!
!   NEED TO RESET ION'S POSITION SO THAT THE CENTER OF MASS IS AT THE
!   ORIGIN.
!
        center = 0.D0
        do i = 1, 3
          do j = 1, numat
            center(i) = center(i) + atmass(j)*coord(i,j)
          end do
        end do
        center = center/mol_weight
        do i = 1, 3
          coord(i,:numat) = coord(i,:numat) - center(i)
        end do
      end if
      dip = 0.0D00
      do i = 1, numat
        ni = nat(i)
        ia = nfirst(i)
        ib = nlast(i)
        l = ib - ia
        if (l > 0) then
            hyfsp = 2.0D0*dd(ni)*a0*fpc_8*fpc_1*1.D-10
          do j = 1, 3
            k = ((ia + j)*(ia + j - 1))/2 + ia
            dip(j,2) = dip(j,2) - hyfsp*p(k)
          end do
!
!   PD ONE-CENTER TERM
          if (ib - ia == 8) then
            xt = 1.D0/sqrt(3.D00)
            hyfpd = 2.0D0*ddp(5,ni)*a0*fpc_8*fpc_1*1.D-10
            ll = (ia + 5)*(ia + 4)/2 + ia + 3
            dx = p(ll)
            ll = (ia + 4)*(ia + 3)/2 + ia + 1
            dx = dx + p(ll)
            ll = (ia + 8)*(ia + 7)/2 + ia + 2
            dx = dx + p(ll)
            ll = (ia + 6)*(ia + 5)/2 + ia + 1
            dx = dx - xt*p(ll)
!
            ll = (ia + 7)*(ia + 6)/2 + ia + 3
            dy = p(ll)
            ll = (ia + 4)*(ia + 3)/2 + ia + 2
            dy = dy - p(ll)
            ll = (ia + 8)*(ia + 7)/2 + ia + 1
            dy = dy + p(ll)
            ll = (ia + 6)*(ia + 5)/2 + ia + 2
            dy = dy - xt*p(ll)
!
            ll = (ia + 5)*(ia + 4)/2 + ia + 1
            dz = p(ll)
            ll = (ia + 7)*(ia + 6)/2 + ia + 2
            dz = dz + p(ll)
            ll = (ia + 6)*(ia + 5)/2 + ia + 3
            dz = dz + 2.D0*xt*p(ll)
            dip(1,2) = dip(1,2) - dx*hyfpd
            dip(2,2) = dip(2,2) - dy*hyfpd
            dip(3,2) = dip(3,2) - dz*hyfpd
          end if
        end if
!
!  FPC(8)=SPEED OF LIGHT,  FPC(1)=CHARGE ON ELECTRON.
!
        factdm = fpc_8*fpc_1*1.D-10
        dip(:3,1) = dip(:3,1) + q(i)*coord(:,i)*factdm
      end do
      dip(:3,3) = dip(:3,2) + dip(:3,1)
      do j = 1, 3
        dip(4,j) = sqrt(dip(1,j)**2+dip(2,j)**2+dip(3,j)**2)
      end do
      if (force) then
        dipvec(1) = dip(1,3)
        dipvec(2) = dip(2,3)
        dipvec(3) = dip(3,3)
      end if
      if (mode == 1) write (iw, 140) ((dip(i,j),i=1,4),j=1,3)
!     STORE DIPOLE MOMENT COMPONENTS IN UX,UY,UZ FOR USE IN
!     ASSIGNING CHARGES DETERMINED FROM THE ESP. BHB
      ux = dip(1,3)
      uy = dip(2,3)
      uz = dip(3,3)
      dipole = dip(4,3)
      if (.not.force .and. chargd) then
!
!   NEED TO RESET ION'S POSITION AGAIN, SO THAT IT IS BACK WHERE IT STARTED
!
        do i = 1, 3
          coord(i,:numat) = coord(i,:numat) + center(i)
        end do
      end if
      return
!
  140 format(' DIPOLE',11x,'X         Y         Z       TOTAL',/,' POINT-CHG.',&
        4f10.3,/,' HYBRID',4x,4f10.3,/,' SUM',7x,4f10.3)
!
      end function dipole

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

function jdate() result (line)
    !
    !   Simulate the function jdate
    !   On return, contains the year and Julian date in the character*8 form: yyddd
    !   with the last 3 characters unused
    !
    implicit none

    ! Result value
    character (len=8) :: line

    ! External routines
    intrinsic Date_and_Time

    ! Local variables
    integer :: iday, imonth, iyear, ijulian, i
    integer :: dim(12) = (/ 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30/)
    character(len=8) :: date

    line = ' '

    ! This intrinsic routine returns a date-string containing
    !  CCYYMMDD
    call Date_and_Time(date)

    ! Assign the year (in current century, and with leading zeros)
    read (date(3:4), '(i2)')   iyear     
    write(line(1:2), '(i2.2)') iyear

    ! Setup the absolute day in the year (ddd)
    read(date(5:6),'(i2)') imonth 
    read(date(7:8),'(i2)') iday 
    ijulian = iday 
    do i = 1,imonth
        ijulian = ijulian + dim(i)
    end do
    write(line(3:5),'(i3.3)') ijulian

end function jdate

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine tidy (nmos_loc, nc, ic, n01, c, n02, nnc_loc, ncmo, ln, mn, mode)
    use MOZYME_C, only: iorbs, jopt, thresh, numred
    use molkst_C, only: numat, step_num, norbs, moperr, keywrd, numcal
    use chanel_C, only: iw
    implicit none
    integer, intent (in) :: mode,  n02, nmos_loc
    integer, intent (inout) :: n01
    integer, intent (out) :: ln, mn
    integer, dimension (n01), intent (inout) :: ic
    integer, dimension (nmos_loc), intent (inout) :: nc, ncmo, nnc_loc
    double precision, dimension (n02), intent (inout) :: c
!
    integer :: alloc_stat
    logical, save :: debug, large
    integer :: icalcn = 0
    integer, save :: ireset
    integer :: i, in, isnew, ispace, j, j1, jdash, jsav, jspace, jtop, &
         & k, l, li, ll, mdash, mm, momax, momin, msav, mtop, n
    integer :: nmol = 0
    double precision :: sum
    integer, dimension(:), allocatable :: iused, jused, kused, lused
    integer, dimension (2) :: imode
    data imode / 2 * 0 /
    allocate (iused(norbs), jused(norbs), kused(norbs), lused(norbs), &
         & stat=alloc_stat)
    if (alloc_stat /= 0) then
      call memory_error ("tidy")
      goto 100
    end if
   !
    if (numcal /= icalcn) then
      icalcn = numcal
      debug = (Index (keywrd, " TIDY") /= 0)
      large = (Index (keywrd, " LARGE") /= 0)
    end if
    if (nmos_loc == 0) return
    isnew = 0
    if (nmol /= numcal) then
      !
      !  A new molecule.  Therefore, set IMODE to step_num to prevent
      !  SELMOS from being called.
      !
      imode(1) = step_num
      imode(2) = step_num
      ireset = 0
    end if
    do
      !
      !  COMPRESS  IC AND C
      !
      momax = 0
      ireset = ireset - 1
      if (ireset == 0) then
        thresh = thresh * 100.d0
      end if
      momin = 10000
      ln = 0
      mn = 0
      in = 0
      li = 0
      do i = 1, nmos_loc
        ll = nnc_loc(i)
        li = li - ll
        mm = ncmo(i)
        ncmo(i) = mn
        nnc_loc(i) = 0
        if (i /= 1) then
          nnc_loc(i) = nnc_loc(i-1) + in
        end if
        in = 0
        momax = Max (momax, nc(i))
        if (nc(i) < momin) then
          momin = nc(i)
        end if
        do j1 = 1, nc(i)
          ll = ll + 1
          sum = 0.d0
          j = ic(ll)
          do k = 1, iorbs(j)
            mm = mm + 1
            sum = sum + c(mm) ** 2
          end do
          if (sum > thresh) then
            mm = mm - iorbs(j)
            do k = 1, iorbs(j)
              mn = mn + 1
              mm = mm + 1
              c(mn) = c(mm)
            end do
            in = in + 1
            ln = ln + 1
            ic(ln) = j
          end if
        end do
        nc(i) = in
        iused(i) = mn
        li = li + ll
      end do
      !
      !   Do the LMOs of the SCF need to be put at the start of the storage?
      !
      if (isnew /= 0 .or. step_num <= 1 .or. step_num == imode(mode)) exit
      isnew = 2
      if (numred >= numat-1) then
        isnew = 1
      end if
      imode(mode) = step_num
      if (isnew == 2) then
         !
         !   Move LMO's for atoms in JOPT to start of storage space
         !
        call selmos (nmos_loc, nc, ic, n01, c, n02, nnc_loc, ncmo, ln, mn, &
       & iused, jopt, jused, kused, lused, mode)
      else
        exit
      end if
    end do
   !
   !   DIVIDE AVAILABLE SPACE EQUALLY AMONG THE LMO'S
   !
    ispace = (n01-ln) / nmos_loc
    jspace = (n02-mn) / nmos_loc
   !
   !   LN     = Highest address in IC used
   !            (the end of the compressed LMOs)
   !   LN/NMOS= Average number of atoms in a LMO.
   !   ISPACE = Average amount of free space that LMOs can expand into.
   !
   !   Is there enough space for LMOs to expand?  If not, stop the run
   !
   !  In order to ensure that the next annihilation step can be run,
   !  the amount of storage for each LMO, (LN/NMOS+ISPACE), should be
   !  more than NUMAT, or ISPACE must be greater than the larger of
   !  20% of the available space and 20. That is, there must be at least
   !  20% unused space for a LMO to expand into.
   !
    i = n01 / nmos_loc
    if (i + ispace < numat .and. ispace < Max (i/5, 20)) then
      call pinout (1, .false.)
  !    write (iw, "(/,A,/,A,I8)") &
  !   & " There is not enough unused space left to ensure ", &
  !   & " that the next iteration can be done.  New memory being allocated:", &
  !   & Nint (n01*0.2)
      moperr = .true.
      return
    end if
    if (ispace > numat .and. jspace > nmos_loc) then
      !
      !   There is more than enough space to guarantee that every LMO can
      !   be filled completely, therefore:
      ispace = 0
      jspace = 0
      if (debug) then
        write (iw, "(6(A,I5))") " MAX.:", momax, " MIN.:", momin, " AVE. IC:", &
       & ln / nmos_loc, " AVE. C:", mn / nmos_loc
      end if
    else if (debug) then
      write (iw, "(6(A,I5))") " MAX.:", momax, " MIN.:", momin, " AVE. IC:", &
           & ln / nmos_loc, " AVE. C:", mn / nmos_loc, " FREE IC:", &
           & ispace, " FREE C:", jspace
    end if
    jtop = n01
    mtop = n02
    jsav = n01 - ln - ispace * nmos_loc
    msav = n02 - mn - jspace * nmos_loc
    do i = nmos_loc, 2, -1
      j = Min (nc(i)+ispace, numat)
      if (j < nc(i)+ispace) then
         !
         !   Some space is unused - save it for later
         !
        jsav = jsav + nc(i) + ispace - j
        jtop = jtop - j
      else
         !
         !  USE UP SOME OF THE SAVED SPACE
         !
        jdash = Min (numat, Max (jsav, 0)+j)
        jtop = jtop - jdash
        jsav = jsav - jdash + j
      end if
      l = nnc_loc(i)
      nnc_loc(i) = jtop
      do k = nc(i), 1, -1
        ic(jtop+k) = ic(l+k)
      end do
      n = iused(i) - iused(i-1)
      j = Min (n+jspace, norbs)
      if (j < n+jspace) then
         !
         !   Some space is unused - save it for later
         !
        msav = msav + n + jspace - j
        mtop = mtop - j
      else
         !
         !  USE UP SOME OF THE SAVED SPACE
         !
        mdash = Min (norbs, Max (msav, 0)+j)
        mtop = mtop - mdash
        msav = msav - mdash + j
      end if
      ncmo(i) = mtop
      do k = n, 1, -1
        c(k+mtop) = c(k+iused(i-1))
      end do
    end do
    if (debug .and. large) then
      !
      !   PRINT ADDRESSES SET UP BY TIDY
      !
      write (iw,*) " ADDRESSES IN TIDY"
      write (iw, "(A)") "               NNC       NC     NCMO "
      do i = 1, nmos_loc
        write (iw, "(7I9)") i, nnc_loc (i), nc (i), ncmo (i)
      end do
      write (iw,*) " Contents of IC"
      do i = 1, nmos_loc
        write (iw, "(I4,I7,18I4,10(/,I11,18I4))") i, (ic(j), j=nnc_loc(i)+1, &
       & nnc_loc(i)+nc(i))
      end do
    end if
    if (mode == 2) then
      nmol = numcal
    end if
   !
    deallocate (iused, jused, kused, lused)
100 continue
end subroutine tidy

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

  subroutine add_missing_cells()
    use common_common, only : ncell, nijk
!
!  For every cell (i,j,k) there must exist a cell (-i,j,k) and a cell (i,-j,k) etc.
!
!  If any cells are missing, add them now.
!
    implicit none
    integer :: iloop, jloop, new_cells(4,500), ia, ib, ic, ja, jb, jc, &
      to_add
    logical :: cell_ok(500)
!
!  Make sure that for every cell (i,j,k) there exists a partner cell (-i,-j,-k)
!
    cell_ok = .false.
    to_add = 0
    do iloop = 1, ncell
      if (cell_ok(iloop)) cycle
      ia = nijk(1,iloop)
      ib = nijk(2,iloop)
      ic = nijk(3,iloop)
      j_loop: do jloop = iloop + 1, ncell
        if (cell_ok(jloop)) cycle
        ja = nijk(1,jloop)
        jb = nijk(2,jloop)
        jc = nijk(3,jloop)
!
!  Check cell
!
        if ((ia == 0 .or. ia == -ja) .and. (ib == 0 .or. ib == -jb) .and. (ic == 0 .or. ic == -jc)) then
!
!   The cell (ja, jb, jc) already exists.  Mark it as existing and move on.
!
            if (ia /= 0 .or. ib /= 0 .or. ic /= 0) cell_ok(jloop) = .true.
            exit j_loop
        end if
      end do j_loop
!
!    Cells needed are in need_cell
!
      if (jloop > ncell) then
        to_add = to_add + 1
        new_cells(1,to_add) = -ia
        new_cells(2,to_add) = -ib
        new_cells(3,to_add) = -ic
        new_cells(4,to_add) = iloop
      end if
    end do
  !  write(iw_new,'(a)')"  Existing cells"
  !  write(iw_new,'(3i3)')nijk(:,:ncell)
  !  write(iw_new,'(a)')"  Missing cells"
  !  write(iw_new,'(4i3)')new_cells(:,:to_add)
    call expand(new_cells, to_add)
  end subroutine add_missing_cells
  subroutine expand(new_cells, to_add)
    use common_common, only : ncell, nijk, nvecs, sec_det
    implicit none
    integer :: to_add, new_cells(4, to_add)
!
    integer :: iloop, jloop, kloop
!
!  Expand the set of cells
!
    do kloop =  1, to_add
      nijk(:,kloop + ncell) = new_cells(:3,kloop)
    end do
!
!  Expand the secular determinant
!
    do kloop = 1, to_add
      do iloop = 1, nvecs
        do jloop = 1, nvecs
          sec_det(iloop, jloop + (kloop + ncell - 1)*nvecs) = sec_det(jloop, iloop + (new_cells(4, kloop) - 1)*nvecs)
        end do
      end do
    end do
    ncell = ncell + to_add
  end subroutine expand

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine add_more_interactions()
!
!   In a MOZYME calculation, during a geometry optimization, the distance between a
!  pair of atoms might become less, so that instead of an interaction being considered as a
!  point charge it might need to be considered as a point charge plus dipole, or instead of being a
!  point charge plus dipole, it might need to be considered using the full NDDO approximation.
!
!  Here, the matrix of interactions is re-evaluated and if an iteraction needs to be promoted,
!  it would be promoted.
!
!  The array nijbo is the only array whose contents are changed.
!  other arrays might need to be increased in size.  If so, then they would be increased by
!  20% more than needed, to leave room for future expansion.
!
  use molkst_C, only: mpack, numcal
!
  use common_arrays_C, only: p, f, h
!
  use MOZYME_C, only : lijbo, direct, semidr, partp, parth, partf, &
    rapid
!
  use iter_C, only : pold
!
  implicit none
  double precision, dimension (:), allocatable :: temp_store
!
!  Write out the contents of ijbo at the entry to add_more_interactions
!
  integer :: i, j, alloc_stat, imol = 0
  save imol
!
!  Method is limited to direct SCF
!
  if (.not. direct .or. .not. semidr .or. .not. lijbo) return
  if (imol /= numcal) then
    imol = numcal
    return  !  First time add_more_interactions is called, do nothing
  end if
  i = mpack
  call fillij (.false.)
  if (mpack > i) then
!
! Some arrays are now too small - increase their size, but also preserve their contents
!
    allocate (temp_store(i), stat=alloc_stat)
    if (alloc_stat /= 0) then
        call memory_error ("add_more_interactions")
        return
    end if
    j = Nint(mpack*1.2)
!
    temp_store = pold
    deallocate(pold)
    allocate(pold(j), stat=alloc_stat)
    if (alloc_stat /= 0) then
        call memory_error ("add_more_interactions")
        return
    end if
    pold(1:i) = temp_store(1:i)
    pold(i+1:) = 0.d0
!
    temp_store = p
    deallocate(p)
    allocate(p(j), stat=alloc_stat)
    if (alloc_stat /= 0) then
        call memory_error ("add_more_interactions")
        return
    end if
    p(1:i) = temp_store(1:i)
    p(i+1:) = 0.d0
!
    temp_store = h
    deallocate(h)
    allocate(h(j), stat=alloc_stat)
    if (alloc_stat /= 0) then
        call memory_error ("add_more_interactions")
        return
    end if
    h(1:i) = temp_store(1:i)
    h(i+1:) = 0.d0
!
    temp_store = f
    deallocate(f)
    allocate(f(j), stat=alloc_stat)
    if (alloc_stat /= 0) then
        call memory_error ("add_more_interactions")
        return
    end if
    f(1:i) = temp_store(1:i)
    f(i+1:) = 0.d0
!
!
!
    if (rapid) then
      temp_store = partp
      deallocate(partp)
      allocate(partp(j), stat=alloc_stat)
      if (alloc_stat /= 0) then
          call memory_error ("add_more_interactions")
          return
      end if
      partp(1:i) = temp_store(1:i)
      partp(i+1:) = 0.d0
  !
  !
      temp_store = parth
      deallocate(parth)
      allocate(parth(j), stat=alloc_stat)
      if (alloc_stat /= 0) then
          call memory_error ("add_more_interactions")
          return
      end if
      parth(1:i) = temp_store(1:i)
      parth(i+1:) = 0.d0
  !
      temp_store = partf
      deallocate(partf)
      allocate(partf(j), stat=alloc_stat)
      if (alloc_stat /= 0) then
          call memory_error ("add_more_interactions")
          return
      end if
      partf(1:i) = temp_store(1:i)
      partf(i+1:) = 0.d0
    end if
  end if
  return
end subroutine add_more_interactions

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine switch
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE parameters_C, only : alp, guess1, guess2, guess3, &
      betas, betap, betad, uss, upp, udd, zs, zp, zd, zsn, zpn, zdn, &
      gss, gsp, gpp, gp2, hsp, f0sd, g2sd, f0sd_store, g2sd_store, v_par, &
      polvol, pocord, xfac, alpb, CPE_Zeta, CPE_Z0, CPE_B, CPE_Xlo, CPE_Xhi, &
      ams, npq, natorb
!
!
      USE molkst_C, only : keywrd, keywrd_quoted, method_mndo, method_pm3, method_indo, &
      & method_mndod, method_pm6, method_rm1, method_pm7, method_PM7_ts, method_pm6_org, method_pm8
!
!
      USE parameters_for_INDO_C, only: isoki, nbfai, zetai, zetadi, &
        zetawti, zcoreai, betaai, fgi

      USE reimers_C, only: isok, nprin, nbfa, zcorea, weight,&
        zeta, zetad, zetawt, betaa, fg, mg1sp, ifgfac
!
!
      USE parameters_for_mndod_C, only : zsnd, zpnd, zdnd, ussd, uppd, uddd, &
      & zsd, zpd, zdd, betasd, betapd, betadd, alpd, gssd, gspd, &
      & gp2d, hspd, gppd, poc_d
!
!
      USE parameters_for_mndo_C, only :  ussm, uppm, uddm, zsm, zpm, zdm, betasm, &
        betapm, betadm, alpm, gssm, gspm, gppm, gp2m, hspm, polvolm, guesm1, &
        guesm2, guesm3, f0sdm, g2sdm, pocm, zsnm, zpnm, zdnm
!
!
      USE parameters_for_PM6_C, only :  uss6, upp6, udd6, zs6, zp6, zd6, betas6, &
        betap6, betad6, gss6, gsp6, gpp6, gp26, hsp6, polvo6, gues61, f0sd6, g2sd6, &
        gues62, gues63, poc_6, zsn6, zpn6, zdn6, alpb_and_xfac_pm6, alp6, v_par6, &
        CPE_Zet6, CPE_Z06, CPE_B6, CPE_Xlo6, CPE_Xhi6
!
!
      USE parameters_for_PM7_C, only :  uss7, upp7, udd7, zs7, zp7, zd7, betas7, &
        betap7, betad7, gss7, gsp7, gpp7, gp27, hsp7, polvo7, gues71, f0sd7, g2sd7, &
        gues72, gues73, poc_7, zsn7, zpn7, zdn7, alpb_and_xfac_pm7, alp7, v_par7
!
!
        USE parameters_for_PM6_ORG_C, only :  uss_org, upp_org, udd_org, zs_org, zp_org, zd_org, betas_org, &
        betap_org, betad_org, gss_org, gsp_org, gpp_org, gp2_org, hsp_org, polvo_org, gues_org1, f0sd_org, g2sd_org, &
        gues_org2, gues_org3, poc__org, zsn_org, zpn_org, zdn_org, alpb_and_xfac_pm6_org, alp_org, v_par_org
!
!
      USE parameters_for_PM8_C, only :  uss8, upp8, udd8, zs8, zp8, zd8, betas8, &
        betap8, betad8, gss8, gsp8, gpp8, gp28, hsp8, polvo8, gues81, f0sd8, g2sd8, &
        gues82, gues83, poc_8, zsn8, zpn8, zdn8, alpb_and_xfac_pm8, alp8, v_par8
!
!
       USE parameters_for_PM7_TS_C, only : uss7_TS, upp7_TS, udd7_TS, zs7_TS, zp7_TS, zd7_TS, betas7_TS, &
         betap7_TS, betad7_TS, gss7_TS, gsp7_TS, gpp7_TS, gp27_TS, hsp7_TS, polvo7_TS, poc_7_TS, &
         zsn7_TS, zpn7_TS, zdn7_TS, f0sd7_TS, g2sd7_TS, alp7_TS, v_par7_TS, alpb_and_xfac_pm7_ts, &
         gues7_ts1, gues7_ts2, gues7_ts3
!
!
      USE parameters_for_PM3_C, only : usspm3, upppm3, zspm3, zppm3, &
        betasp, betapp, alppm3, gsspm3, gsppm3, gpppm3, polvolpm3, &
        gp2pm3, hsppm3, guesp1, guesp2, guesp3
!
!
      use parameters_for_PM3_Sparkles_C, only : gssPM3sp, alpPM3sp, guesPM3sp1, guesPM3sp2, guesPM3sp3
!
!
      USE parameters_for_AM1_C, only : zsam1, zpam1, zdam1, ussam1, uppam1, uddam1, alpam1, &
      & gssam1, gppam1, gspam1, gp2am1, betasa, betapa, hspam1, guesa1, &
      & guesa2, guesa3, betada, zsnam1, zpnam1, zdnam1, f0sdam1, g2sdam1, polvolam1
!
!
      use parameters_for_AM1_Sparkles_C, only : gssam1sp, alpam1sp, guesam1sp1, guesam1sp2, guesam1sp3
!
!
      use parameters_for_PM6_Sparkles_C, only : gss6sp, alp6sp, gues6sp1, gues6sp2, gues6sp3
!
!
      Use Parameters_for_PM7_Sparkles_C, only : gss7sp, alp7sp, gues7sp1, gues7sp2, gues7sp3
!
!
      Use Parameters_for_RM1_Sparkles_C, only : gssrm1sp, alprm1sp, guesrm1sp1, guesrm1sp2, guesrm1sp3
!
!
      use parameters_for_RM1_C, only : ussRM1, uppRM1, uddRM1, zsRM1, zpRM1, zdRM1, betasRM1, &
      & betapRM1, betadRM1, gssRM1, gspRM1, gppRM1, gp2RM1, hspRM1, alpRM1, zsnRM1, zpnRM1, zdnRM1, &
      & poc_RM1, f0sdRM1, g2sdRM1, guess1RM1, guess2RM1, guess3RM1
!
!
!***********************************************************************
!
!   SWITCH copies data from the reference modules into the
!          arrays used by MOPAC.  The choice of reference data used
!          is given by the keywords MNDO, AM1, PM3, or MNDOD
!
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j
        pocord = 0.d0
        if (method_mndo) then
!
!    SWITCH IN MNDO PARAMETERS
!
          guess1 = guesm1
          guess2 = guesm2
          guess3 = guesm3
          polvol = polvolm
          zs = zsm
          zp = zpm
          zd = zdm
          zsn = zsnm
          zpn = zpnm
          zdn = zdnm
          uss = ussm
          upp = uppm
          udd = uddm
          betas = betasm
          betap = betapm
          betad = betadm
          alp = alpm
          gss = gssm
          gpp = gppm
          gsp = gspm
          gp2 = gp2m
          hsp = hspm
          f0sd = f0sdm
          g2sd = g2sdm
          pocord = pocm
          call alpb_and_xfac_mndo
        else if (method_indo) then
!
!    SWITCH IN INDO PARAMETERS
!
          isok   = isoki
          nbfa   = nbfai
          zeta   = zetai
          zetad  = zetadi
          zetawt = zetawti
          zcorea = zcoreai
          betaa  = betaai
          fg     = fgi
          do i= 1,80
            natorb(i) = nbfa(i)
            nprin(i)  = npq(i,1)
            weight(i) = ams(i)
            do j= 1,11
              fg(mg1sp-1+j,i)= fg(mg1sp-1+j,i) / ifgfac(j)
            end do
            zs(i) = zeta(i)
            zp(i) = zeta(i)
          end do
        else if (method_pm3) then
!
!    SWITCH IN MNDO-PM3 PARAMETERS
!
          guess1 = guesp1
          guess2 = guesp2
          guess3 = guesp3
          polvol = polvolpm3
          zs = zspm3
          zp = zppm3
          zd = 0.d0
          uss = usspm3
          upp = upppm3
          betas = betasp
          betap = betapp
          alp = alppm3
          gss = gsspm3
          gpp = gpppm3
          gsp = gsppm3
          gp2 = gp2pm3
          hsp = hsppm3
          call alpb_and_xfac_pm3
          if (index(keywrd, " SPARK") /= 0) then
            do i = 1, 102
              if (alpPM3sp(i) > 0.1d0) then
                zd(i) = 0.d0
                zp(i) = 0.d0
                zs(i) = 0.d0
                zsn(i) = 0.d0
                zpn(i) = 0.d0
                zdn(i) = 0.d0
                uss(i) = 0.d0
                upp(i) = 0.d0
                udd(i) = 0.d0
                betas(i) = 0.d0
                betap(i) = 0.d0
                betad(i) = 0.d0
                alp(i) = alpPM3sp(i)
                gss(i) = gssPM3sp(i)
                gpp(i) = 0.d0
                gp2(i) = 0.d0
                hsp(i) = 0.d0
                gsp(i) = 0.d0
                f0sd(i) = 0.d0
                g2sd(i) = 0.d0
                pocord(i) = 0.d0
                guess1(i,1) = guesPM3sp1(i,1)
                guess2(i,1) = guesPM3sp2(i,1)
                guess3(i,1) = guesPM3sp3(i,1)
                guess1(i,2) = guesPM3sp1(i,2)
                guess2(i,2) = guesPM3sp2(i,2)
                guess3(i,2) = guesPM3sp3(i,2)
                guess1(i,3:4) = 0.d0
                guess2(i,3:4) = 0.d0
                guess3(i,3:4) = 0.d0
              end if
            end do
            alpb(:100,57:71) = 0.d0
            alpb(57:71,:100) = 0.d0
            xfac(:100,57:71) = 0.d0
            xfac(57:71,:100) = 0.d0
          end if
        else if (method_pm6_org) then
!
!    SWITCH IN PM6-ORG PARAMETERS
!
          guess1 = gues_org1
          guess2 = gues_org2
          guess3 = gues_org3
          zs = zs_org
          zp = zp_org
          zd = zd_org
          zsn = zsn_org
          zpn = zpn_org
          zdn = zdn_org
          uss = uss_org
          upp = upp_org
          udd = udd_org
          betas = betas_org
          betap = betap_org
          betad = betad_org
          gss = gss_org
          gpp = gpp_org
          gsp = gsp_org
          gp2 = gp2_org
          hsp = hsp_org
          f0sd = f0sd_org
          g2sd = g2sd_org
          alp = alp_org
          pocord = poc__org
          polvol = polvo_org
          v_par = v_par_org
          call alpb_and_xfac_pm6_org
        else if (method_pm8) then
!
!    SWITCH IN PM8 PARAMETERS
!
          guess1 = gues81
          guess2 = gues82
          guess3 = gues83
          zs = zs8
          zp = zp8
          zd = zd8
          zsn = zsn8
          zpn = zpn8
          zdn = zdn8
          uss = uss8
          upp = upp8
          udd = udd8
          betas = betas8
          betap = betap8
          betad = betad8
          gss = gss8
          gpp = gpp8
          gsp = gsp8
          gp2 = gp28
          hsp = hsp8
          f0sd = f0sd8
          g2sd = g2sd8
          alp = alp8
          pocord = poc_8
          polvol = polvo8
          v_par = v_par8
          call alpb_and_xfac_pm8
        else if (method_pm6) then
!
!    SWITCH IN PM6 PARAMETERS
!
          guess1 = gues61
          guess2 = gues62
          guess3 = gues63
          zs = zs6
          zp = zp6
          zd = zd6
          zsn = zsn6
          zpn = zpn6
          zdn = zdn6
          uss = uss6
          upp = upp6
          udd = udd6
          betas = betas6
          betap = betap6
          betad = betad6
          gss = gss6
          gpp = gpp6
          gsp = gsp6
          gp2 = gp26
          hsp = hsp6
          f0sd = f0sd6
          g2sd = g2sd6
          alp = alp6
          pocord = poc_6
          polvol = polvo6
          CPE_Zeta = CPE_Zet6
          CPE_Z0   = CPE_Z06
          CPE_B    = CPE_B6
          CPE_Xlo  = CPE_Xlo6
          CPE_Xhi  = CPE_Xhi6
          v_par = v_par6
          call alpb_and_xfac_pm6
          if (index(keywrd, " SPARK") /= 0) then
            do i = 1, 107
              if (alp6sp(i) > 0.1d0) then
                zd(i) = 0.d0
                zp(i) = 0.d0
                zs(i) = 0.d0
                zsn(i) = 0.d0
                zpn(i) = 0.d0
                zdn(i) = 0.d0
                uss(i) = 0.d0
                upp(i) = 0.d0
                udd(i) = 0.d0
                betas(i) = 0.d0
                betap(i) = 0.d0
                betad(i) = 0.d0
                alp(i) = alp6sp(i)
                gss(i) = gss6sp(i)
                gpp(i) = 0.d0
                gp2(i) = 0.d0
                hsp(i) = 0.d0
                gsp(i) = 0.d0
                f0sd(i) = 0.d0
                g2sd(i) = 0.d0
                pocord(i) = 0.d0
                guess1(i,1) = gues6sp1(i,1)
                guess2(i,1) = gues6sp2(i,1)
                guess3(i,1) = gues6sp3(i,1)
                guess1(i,2) = gues6sp1(i,2)
                guess2(i,2) = gues6sp2(i,2)
                guess3(i,2) = gues6sp3(i,2)
                guess1(i,3:4) = 0.d0
                guess2(i,3:4) = 0.d0
                guess3(i,3:4) = 0.d0
              end if
            end do
            alpb(:100,57:71) = 0.d0
            alpb(57:71,:100) = 0.d0
            xfac(:100,57:71) = 0.d0
            xfac(57:71,:100) = 0.d0
          end if
        else if (method_pm7_ts) then
!
!    SWITCH IN PM7_TS PARAMETERS
!
          guess1 = gues7_TS1
          guess2 = gues7_TS2
          guess3 = gues7_TS3
          zs = zs7_TS
          zp = zp7_TS
          zd = zd7_TS
          zsn = zsn7_TS
          zpn = zpn7_TS
          zdn = zdn7_TS
          uss = uss7_TS
          upp = upp7_TS
          udd = udd7_TS
          betas = betas7_TS
          betap = betap7_TS
          betad = betad7_TS
          gss = gss7_TS
          gpp = gpp7_TS
          gsp = gsp7_TS
          gp2 = gp27_TS
          hsp = hsp7_TS
          f0sd = f0sd7_TS
          g2sd = g2sd7_TS
          alp = alp7_TS
          pocord = poc_7_TS
          polvol = polvo7_TS
          v_par = v_par7_TS
          call alpb_and_xfac_pm7_TS
        else if (method_pm7) then
!
!    SWITCH IN PM7 PARAMETERS
!
          guess1 = gues71
          guess2 = gues72
          guess3 = gues73
          zs = zs7
          zp = zp7
          zd = zd7
          zsn = zsn7
          zpn = zpn7
          zdn = zdn7
          uss = uss7
          upp = upp7
          udd = udd7
          betas = betas7
          betap = betap7
          betad = betad7
          gss = gss7
          gpp = gpp7
          gsp = gsp7
          gp2 = gp27
          hsp = hsp7
          f0sd = f0sd7
          g2sd = g2sd7
          alp = alp7
          pocord = poc_7
          polvol = polvo7
          v_par = v_par7
          call alpb_and_xfac_pm7
          if (index(keywrd, " SPARK") /= 0) then
            do i = 1, 102
              if (alp7sp(i) > 0.1d0) then
                zd(i) = 0.d0
                zp(i) = 0.d0
                zs(i) = 0.d0
                zsn(i) = 0.d0
                zpn(i) = 0.d0
                zdn(i) = 0.d0
                uss(i) = 0.d0
                upp(i) = 0.d0
                udd(i) = 0.d0
                betas(i) = 0.d0
                betap(i) = 0.d0
                betad(i) = 0.d0
                alp(i) = alp7sp(i)
                gss(i) = gss7sp(i)
                gpp(i) = 0.d0
                gp2(i) = 0.d0
                hsp(i) = 0.d0
                gsp(i) = 0.d0
                f0sd(i) = 0.d0
                g2sd(i) = 0.d0
                pocord(i) = 0.d0
                guess1(i,1) = gues7sp1(i,1)
                guess2(i,1) = gues7sp2(i,1)
                guess3(i,1) = gues7sp3(i,1)
                guess1(i,2) = gues7sp1(i,2)
                guess2(i,2) = gues7sp2(i,2)
                guess3(i,2) = gues7sp3(i,2)
                guess1(i,3:4) = 0.d0
                guess2(i,3:4) = 0.d0
                guess3(i,3:4) = 0.d0
              end if
            end do
            alpb(:100,57:71) = 0.d0
            alpb(57:71,:100) = 0.d0
            xfac(:100,57:71) = 0.d0
            xfac(57:71,:100) = 0.d0
          end if
        else if (method_mndod) then
!
!    SWITCH IN MNDOD PARAMETERS
!
          uss = ussd
          upp = uppd
          udd = uddd
          zs  = zsd
          zp  = zpd
          zd  = zdd
          zsn = zsnd
          zpn = zpnd
          zdn = zdnd
          betas = betasd
          betap = betapd
          betad = betadd
          gss = gssd
          gsp = gspd
          gpp = gppd
          gp2 = gp2d
          hsp = hspd
          alp = alpd
          pocord = poc_d
          guess1 = 0.d0
          guess2 = 0.d0
          guess3 = 0.d0
          f0sd = 0.d0
          g2sd = 0.d0
          call alpb_and_xfac_mndod
        else if (method_rm1) then
!
!    SWITCH IN RM1 PARAMETERS
!
          guess1 = guess1RM1
          guess2 = guess2RM1
          guess3 = guess3RM1
          uss = ussRM1
          upp = uppRM1
          udd = uddRM1
          zs  = zsRM1
          zp  = zpRM1
          zd  = zdRM1
          zsn = zsnRM1
          zpn = zpnRM1
          zdn = zdnRM1
          betas = betasRM1
          betap = betapRM1
          betad = betadRM1
          gss = gssRM1
          gsp = gspRM1
          gpp = gppRM1
          gp2 = gp2RM1
          hsp = hspRM1
          alp = alpRM1
          f0sd = f0sdRM1
          g2sd = g2sdRM1
          alp = alpRM1
          pocord = poc_RM1
          if (index(keywrd, " SPARK") /= 0) then
            do i = 1, 102
              if (alp7sp(i) > 0.1d0) then
                zd(i) = 0.d0
                zp(i) = 0.d0
                zs(i) = 0.d0
                zsn(i) = 0.d0
                zpn(i) = 0.d0
                zdn(i) = 0.d0
                uss(i) = 0.d0
                upp(i) = 0.d0
                udd(i) = 0.d0
                betas(i) = 0.d0
                betap(i) = 0.d0
                betad(i) = 0.d0
                alp(i) = alprm1sp(i)
                gss(i) = gssrm1sp(i)
                gpp(i) = 0.d0
                gp2(i) = 0.d0
                hsp(i) = 0.d0
                gsp(i) = 0.d0
                f0sd(i) = 0.d0
                g2sd(i) = 0.d0
                pocord(i) = 0.d0
                guess1(i,1) = guesrm1sp1(i,1)
                guess2(i,1) = guesrm1sp2(i,1)
                guess3(i,1) = guesrm1sp3(i,1)
                guess1(i,2) = guesrm1sp1(i,2)
                guess2(i,2) = guesrm1sp2(i,2)
                guess3(i,2) = guesrm1sp3(i,2)
                guess1(i,3:4) = 0.d0
                guess2(i,3:4) = 0.d0
                guess3(i,3:4) = 0.d0
              end if
            end do
          end if
        else
!
!    SWITCH IN AM1 PARAMETERS
!
          guess1 = guesa1
          guess2 = guesa2
          guess3 = guesa3
          polvol = polvolam1
          zs = zsam1
          zp = zpam1
          zd = zdam1
          zsn = zsnam1
          zpn = zpnam1
          zdn = zdnam1
          f0sd = f0sdam1
          g2sd = g2sdam1
          uss = ussam1
          upp = uppam1
          udd = uddam1
          betas = betasa
          betap = betapa
          betad = betada
          alp = alpam1
          gss = gssam1
          gpp = gppam1
          gsp = gspam1
          gp2 = gp2am1
          hsp = hspam1
          call alpb_and_xfac_am1
!
!   Unique parameter for Voityuk's Molybdenum
!
          pocord(42) = 1.334d0
          if (index(keywrd, " SPARK") /= 0) then
            do i = 1, 102
              if (alpam1sp(i) > 0.1d0) then
                zd(i) = 0.d0
                zp(i) = 0.d0
                zs(i) = 0.d0
                zsn(i) = 0.d0
                zpn(i) = 0.d0
                zdn(i) = 0.d0
                uss(i) = 0.d0
                upp(i) = 0.d0
                udd(i) = 0.d0
                betas(i) = 0.d0
                betap(i) = 0.d0
                betad(i) = 0.d0
                alp(i) = alpam1sp(i)
                gss(i) = gssam1sp(i)
                gpp(i) = 0.d0
                gp2(i) = 0.d0
                hsp(i) = 0.d0
                gsp(i) = 0.d0
                f0sd(i) = 0.d0
                g2sd(i) = 0.d0
                pocord(i) = 0.d0
                guess1(i,1) = guesam1sp1(i,1)
                guess2(i,1) = guesam1sp2(i,1)
                guess3(i,1) = guesam1sp3(i,1)
                guess1(i,2) = guesam1sp1(i,2)
                guess2(i,2) = guesam1sp2(i,2)
                guess3(i,2) = guesam1sp3(i,2)
                guess1(i,3:4) = 0.d0
                guess2(i,3:4) = 0.d0
                guess3(i,3:4) = 0.d0
              end if
            end do
            alpb(:100,57:71) = 0.d0
            alpb(57:71,:100) = 0.d0
            xfac(:100,57:71) = 0.d0
            xfac(57:71,:100) = 0.d0
          end if
        end if
!
!
        f0sd_store = f0sd
        g2sd_store = g2sd

!
!  Symmetrize the alpb and xfac arrays
!
      do i = 1, 100
        alpb(:i,i) = alpb(i,:i)
        xfac(:i,i) = xfac(i,:i)
      end do
      call fractional_metal_ion
      if (index(keywrd_quoted,'EXTERNAL') /= 0) return
      if (.not. method_indo .and. uss(1) > (-1.D0)) then
        call mopend (&
          'THE HAMILTONIAN REQUESTED IS NOT AVAILABLE IN THIS PROGRAM')
        return
      end if
      return
      end subroutine switch
      subroutine fractional_metal_ion
      use parameters_C, only : tore, zs, zp, gss, gpp, gp2, gsp, hsp, &
      betas, betap, upp, alp
      integer :: i
!
!  Pseudo - halide metal ion with core charge of -1/2 - for use with
!  transition metal ions only
    tore(85) = -0.5d0
!
!  Pseudo - alkali metal ion with core charge of 1/2 - for use with
!  transition metal ions only
      tore(87) = 0.5d0
      do i = 85, 87, 2
        upp(i) = 0.d0
        alp(i) = 3.0d0
        zs(i) = 0.d0
        zp(i) = 0.d0
        betas(i) = 0.d0
        betap(i) = 0.d0
        gss(i) = 10.d0
        gsp(i) =0.d0
        gpp(i) = 0.d0
        gp2(i) = 0.d0
        hsp(i) = 0.d0
      end do
      end subroutine fractional_metal_ion

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

        subroutine nllsq()
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use chanel_C, only : iw, ilog, igpt, log
      use molkst_C, only : iflepo, keywrd, last, moperr, escf, nvar, &
      & tleft, nscf, tdump, time0, line
      use common_arrays_C, only : xparam, grad
      implicit none
      double precision, dimension (:,:), allocatable  :: q, r
      integer :: icyc, irst, jrst, maxcyc, m, nrst, ifrtl, nsst, ixso, &
        np1, np2, jcyc, i, j, jj, ii, i1, j1, k, jend, ncount
      integer, dimension(6) :: iiium
      double precision, dimension(nvar) :: y, efs, p, xlast
      double precision :: alf, ssq, pn, tol2, tols1, tols2, tols5, tols6, tlast,  &
        eps, t, time1, temp, prt, efsss, sin, cos, work, pnlast, pn2, ttmp, &
        ssqlst, time2, tcycle, yn, const, ytail, bet, tmp, tolx, tprt
      logical :: middle, resfil
      character :: txt
      double precision, external :: ddot, reada, seconds
!***********************************************************************
!
!  NLLSQ IS A NON-DERIVATIVE, NONLINEAR LEAST-SQUARES MINIMIZER. IT USES
!        BARTEL'S PROCEDURE TO MINIMIZE A FUNCTION WHICH IS A SUM OF
!        SQUARES.
!
!    ON INPUT nvar    = NUMBER OF UNKNOWNS
!             xparam    = PARAMETERS OF FUNCTION TO BE MINIMIZED.
!
!    ON EXIT  xparam    = OPTIMIZED PARAMETERS.
!
!    THE FUNCTION TO BE MINIMIZED IS "COMPFG". COMPFG MUST HAVE THE
!    CALLING SEQUENCE
!                  CALL COMPFG(XPARAM,.TRUE.,ESCF,.TRUE.,EFS,.TRUE.)
!                  SSQ=DOT(EFS,EFS,nvar)
!    WHERE   EFS  IS A VECTOR WHICH  COMPFG  FILLS WITH THE nvar INDIVIDUAL
!                 COMPONENTS OF THE ERROR FUNCTION AT THE POINT xparam
!            SSQ IS THE VALUE OF THE SUM OF THE  EFS  SQUARED.
!    IN THIS FORMULATION OF NLLSQ M AND nvar ARE THE SAME.
!    THE PRECISE DEFINITIONS OF THESE TWO QUANTITIES IS:
!
!     nvar = NUMBER OF PARAMETERS TO BE OPTIMIZED.
!     M = NUMBER OF REFERENCE FUNCTIONS. M MUST BE GREATER THEN, OR
!         EQUAL TO, nvar
!***********************************************************************
!     Q = ORTHOGONAL MATRIX   (M BY M)
!     R = RIGHT-TRIANGULAR MATRIX   (M BY nvar)
!     MXCNT(1) = MAX ALLOW OVERALL FUN EVALS
!     MXCNT(2) = MAX ALLOW NO OF FNC EVALS PER LIN SEARCH
!     TOLS1 = RELATIVE TOLERANCE ON xparam OVERALL
!     TOLS2 = ABSOLUTE TOLERANCE ON xparam OVERALL
!     TOLS5 = RELATIVE TOLERANCE ON xparam FOR LINEAR SEARCHES
!     TOLS6 = ABSOLUTE TOLERANCE ON xparam FOR LINEAR SEARCHES
!     NRST = NUMBER OF CYCLES BETWEEN SIDESTEPS
!     **********
      allocate(q(nvar,nvar), r(nvar + 2, nvar + 2), stat = i)
      if (i /= 0) then
        write(iw,*)" Unable to allocate memory for Hessian matrices in NLLSQ"
        call mopend("Unable to allocate memory for Hessian matrices in NLLSQ")
        goto 99
      end if
      middle = index(keywrd,' RESTART') /= 0
      maxcyc = 100000
      if (index(keywrd,' CYCLES') /= 0) maxcyc = nint(reada(keywrd,index(keywrd,' CYCLES')))
      iflepo = 10
      pn = 0.d0
      ssq = 0.d0
      alf = 0.d0
!*
      m = nvar
!*
      tol2 = 4.D-1
      if (index(keywrd,' GNORM') /= 0) then
        tol2 = reada(keywrd,index(keywrd,' GNORM'))
        if (tol2<0.01D0 .and. index(keywrd,' LET')==0) then
          write (iw, '(/,A)') '  GNORM HAS BEEN SET TOO LOW, RESET TO 0.01'
          tol2 = 0.01D0
        end if
      end if
      last = 0
      tols1 = 1.D-12
      tols2 = 1.D-10
      tols5 = 1.D-6
      tols6 = 1.D-3
      nrst = 4
      tlast = tleft
      resfil = .FALSE.
      tleft = tleft - seconds(2) + time0
!     **********
!     SET UP COUNTERS AND SWITCHES
!     **********
      ifrtl = 0
      nsst = 0
      ixso = nvar
      np1 = nvar + 1
      np2 = nvar + 2
      icyc = 0
      jcyc = icyc
      irst = 0
      jrst = 1
      eps = tols5
      t = tols6
      grad = 0.d0
!     **********
!     GET STARTING-POINT FUNCTION VALUE
!     SET UP ESTIMATE OF INITIAL LINE STEP
!     **********
      if (middle) then
        q = 0.d0
        r = 0.d0
        call parsav (0, nvar, m, q, r, grad, xlast, iiium)
        if (moperr) goto 99
        nscf = iiium(1)
        close(igpt)
        ncount = iiium(5)
        xparam(:nvar) = xlast(:nvar)
        time1 = seconds(2)
        if (index(keywrd,' 1SCF') /= 0) then
          iflepo = 13
          last = 1
          goto 99
        end if
        jcyc = icyc
        go to 60
      end if
      call compfg (xparam, .TRUE., escf, .TRUE., grad, .TRUE.)
      ssq = ddot(nvar,grad,1,grad,1)
      ncount = 1
      do i = 1, m
        do j = 1, nvar
          r(i,j) = 0.0D0
          if (i /= j) cycle
          r(i,j) = 1.0D0
        end do
        do j = i, m
          q(i,j) = 0.0D0
          q(j,i) = 0.0D0
          if (i /= j) cycle
          q(i,i) = 1.0D0
        end do
      end do
      temp = 0.0D0
      temp = sum(xparam(:nvar)**2)
      alf = 100.0D0*(eps*sqrt(temp) + t)
!     **********
!     MAIN LOOP
!     **********
      time1 = seconds(2)
   60 continue
      ifrtl = ifrtl + 1
      icyc = icyc + 1
      irst = irst + 1
!     **********
!     SET  PRT,  THE LEVENBERG-MARQUARDT PARAMETER.
!     **********
      prt = sqrt(ssq)
!     **********
!     IF A SIDESTEP IS TO BE TAKEN, GO TO 31
!     **********
      if (irst < nrst) then
!     **********
!     SOLVE THE SYSTEM    Q*R*P = -grad    IN THE LEAST-SQUARES SENSE
!     **********
        nsst = 0
        do i = 1, m
          temp = 0.0D0
          temp = -sum(q(:m,i)*grad(:m))
          efs(i) = temp
        end do
        do j = 1, nvar
          jj = np1 - j
          do i = 1, j
            ii = np2 - i
            r(ii,jj) = r(i,j)
          end do
        end do
        l160: do i = 1, nvar
          i1 = i + 1
          y(i) = prt
          efsss = 0.0D0
          if (i < nvar) then
            y(i1:nvar) = 0.0D0
          end if
          do j = i, nvar
            ii = np2 - j
            jj = np1 - j
            if (abs(y(j)) >= abs(r(ii,jj))) then
              temp = y(j)*sqrt(1.0D0 + (r(ii,jj)/y(j))**2)
            else
              temp = r(ii,jj)*sqrt(1.0D0 + (y(j)/r(ii,jj))**2)
            end if
            sin = r(ii,jj)/temp
            cos = y(j)/temp
            r(ii,jj) = temp
            temp = efs(j)
            efs(j) = sin*temp + cos*efsss
            efsss = sin*efsss - cos*temp
            if (j >= nvar) cycle  l160
            j1 = j + 1
            do k = j1, nvar
              jj = np1 - k
              temp = r(ii,jj)
              r(ii,jj) = sin*temp + cos*y(k)
              y(k) = sin*y(k) - cos*temp
            end do
          end do
        end do l160
        p(nvar) = efs(nvar)/r(2,1)
        i = nvar
  170   continue
        i = i - 1
        if (i <= 0) go to 200
        temp = efs(i)
        k = i + 1
        ii = np2 - i
        temp = temp - dot_product(r(ii,np1-k:np1-nvar:(-1)),p(k:nvar))
        jj = np1 - i
        p(i) = temp/r(ii,jj)
        go to 170
  200   continue
      else
!     **********
!     SIDESTEP SECTION
!     **********
        jrst = jrst + 1
        nsst = nsst + 1
        if (nsst >= ixso) go to 670
        if (jrst > nvar) jrst = 2
        irst = 0
!     **********
!     PRODUCTION OF A VECTOR ORTHOGONAL TO THE LAST P-VECTOR
!     **********
        work = pn*(abs(p(1))+pn)
        temp = p(jrst)
        p(1) = temp*(p(1)+sign(pn,p(1)))
        p(2:nvar) = temp*p(2:nvar)
        p(jrst) = p(jrst) - work
      end if
!     **********
!     COMPUTE NORM AND NORM-SQUARE OF THE P-VECTOR
!     **********
      pnlast = pn
      pn = 0.D0
      pn2 = 0.0D0
      do i = 1, nvar
        pn = pn + abs(p(i))
        pn2 = pn2 + p(i)**2
      end do
      if (pn < 1.D-20) then
        write (iw, &
      '('' SYSTEM DOES NOT APPEAR TO BE OPTIMIZABLE.'',/    ,'' THIS CAN HAPPEN&
      & IF (A) IT WAS OPTIMIZED TO BEGIN WITH'',/     ,'' OR                 (B)&
      & IT IS NEITHER A GROUND NOR A'',        '' TRANSITION STATE'')')
        call geout (1)
        call mopend ('SYSTEM DOES NOT APPEAR TO BE OPTIMIZABLE.')
        goto 99
      end if
      pn2 = dmax1(1.D-20,pn2)
      pn = sqrt(pn2)
      alf = min(1.D20,alf)
      if (icyc > 1) then
        alf = alf*1.D-20*pnlast/pn
        alf = min(1.D10,alf)
        alf = alf*1.D20
      end if
      ttmp = alf*pn
      if (ttmp < 0.0001D0) alf = 0.001D0/pn
!     **********
!     PRINTING SECTION
!     **********
!#      WRITE(IW,501)TLEFT,ICYC,SSQ
      efs(:nvar) = xparam(:nvar)
!     **********
!     PERFORM LINE-MINIMIZATION FROM POINT xparam IN DIRECTION P OR -P
!     **********
      ssqlst = ssq
      efs(:nvar) = 0.D0
      xlast(:nvar) = xparam(:nvar)
      call locmin (m, xparam, nvar, p, ssq, alf, efs, ncount)
      if (ssqlst < ssq) then
     !   if (ierr == 0) ssq = ssqlst
        xparam(:nvar) = xlast(:nvar)
        irst = nrst
        pn = pnlast
        go to 590
      end if
!     **********
!     PRODUCE THE VECTOR   R*P
!     **********
      do i = 1, nvar
        temp = 0.0D0
        temp = sum(r(i,i:nvar)*p(i:nvar))
        y(i) = temp
      end do
!     **********
!     PRODUCE THE VECTOR ...
!                  Y  =    (EFS-grad-ALF*Q*R*P)/(ALF*(NORMSQUARE(P))
!     COMPUTE NORM OF THIS VECTOR AS WELL
!     **********
      work = alf*pn2
      yn = 0.0D0
      do i = 1, m
        temp = sum(q(i,:nvar)*y(:nvar))
        temp = efs(i) - grad(i) - alf*temp
        grad(i) = efs(i)
        yn = yn + temp**2
        efs(i) = temp/work
      end do
      yn = sqrt(yn)/work
!     **********
!     THE BROYDEN UPDATE   NEW MATRIX = OLD MATRIX + Y*(P-TRANS)
!     HAS BEEN FORMED.  IT IS NOW NECESSARY TO UPDATE THE  QR DECOMP.
!     FIRST LET    Y = (Q-TRANS)*Y.
!     **********
      do i = 1, m
        temp = 0.0D0
        temp = sum(q(:m,i)*efs(:m))
        y(i) = temp
      end do
!     **********
!     REDUCE THE VECTOR Y TO A MULTIPLE OF THE FIRST UNIT VECTOR USING
!     A HOUSEHOLDER TRANSFORMATION FOR COMPONENTS nvar+1 THROUGH M AND
!     ELEMENTARY ROTATIONS FOR THE FIRST nvar+1 COMPONENTS.  APPLY ALL
!     TRANSFORMATIONS TRANSPOSED ON THE RIGHT TO THE MATRIX Q, AND
!     APPLY THE ROTATIONS ON THE LEFT TO THE MATRIX R.
!     THIS GIVES    (Q*(V-TRANS))*((V*R) + (V*Y)*(P-TRANS)),    WHERE
!     V IS THE COMPOSITE OF THE TRANSFORMATIONS.  THE MATRIX
!     ((V*R) + (V*Y)*(P-TRANS))    IS UPPER HESSENBERG.
!     **********
      if (m > np1) then
!
! THE NEXT THREE LINES WERE INSERTED TO TRY TO GET ROUND OVERFLOW BUGS.
!
        const = 1.D-12
        do i = np1, m
          const = max(abs(y(np1)),const)
        end do
        ytail = sum((y(np1:m)/const)**2)
        ytail = sqrt(ytail)*const
        bet = (1.0D25/ytail)/(ytail + abs(y(np1)))
        y(np1) = sign(ytail + abs(y(np1)),y(np1))
        do i = 1, m
          tmp = sum(q(i,np1:m)*y(np1:m)*1.D-25)
          tmp = bet*tmp
          q(i,np1:m) = q(i,np1:m) - tmp*y(np1:m)
        end do
        y(np1) = ytail
        i = np1
      else
        i = m
      end if
  410 continue
      j = i
      i = i - 1
      if (i <= 0) go to 480
      do while(y(j) == 0.D0)
        j = i
        i = i - 1
        if (i <= 0) go to 480
      end do
      if (abs(y(i)) >= abs(y(j))) then
        temp = abs(y(i))*sqrt(1.0D0 + (y(j)/y(i))**2)
      else
        temp = abs(y(j))*sqrt(1.0D0 + (y(i)/y(j))**2)
      end if
      cos = y(i)/temp
      sin = y(j)/temp
      y(i) = temp
      do k = 1, m
        temp = cos*q(k,i) + sin*q(k,j)
        work = (-sin*q(k,i)) + cos*q(k,j)
        q(k,i) = temp
        q(k,j) = work
      end do
      if (i > nvar) go to 410
      r(j,i) = -sin*r(i,i)
      r(i,i) = cos*r(i,i)
      if (j > nvar) go to 410
      do k = j, nvar
        temp = cos*r(i,k) + sin*r(j,k)
        work = (-sin*r(i,k)) + cos*r(j,k)
        r(i,k) = temp
        r(j,k) = work
      end do
      go to 410
  480 continue
      r(1,:nvar) = r(1,:nvar) + yn*p(:nvar)
      jend = np1
      if (m == nvar) jend = nvar
      do j = 2, jend
        i = j - 1
        if (r(j,i) == 0.D0) cycle
        if (abs(r(i,i)) >= abs(r(j,i))) then
          temp = abs(r(i,i))*sqrt(1.0D0 + (r(j,i)/r(i,i))**2)
        else
          temp = abs(r(j,i))*sqrt(1.0D0 + (r(i,i)/r(j,i))**2)
        end if
        cos = r(i,i)/temp
        sin = r(j,i)/temp
        r(i,i) = temp
        if (j <= nvar) then
          do k = j, nvar
            temp = cos*r(i,k) + sin*r(j,k)
            work = (-sin*r(i,k)) + cos*r(j,k)
            r(i,k) = temp
            r(j,k) = work
          end do
        end if
        do k = 1, m
          temp = cos*q(k,i) + sin*q(k,j)
          work = (-sin*q(k,i)) + cos*q(k,j)
          q(k,i) = temp
          q(k,j) = work
        end do
      end do
!     **********
!     CHECK THE STOPPING CRITERIA
!     **********
      temp = 0.0D0
      temp = sum(xparam(:nvar)**2)
      tolx = tols1*sqrt(temp) + tols2
      if (sqrt(alf*pn2) <= tolx) go to 650
      if (ssq >= 2.D0*nvar) go to 590
      do i = 1, nvar
!*****
!     The stopping criterion is that no individual gradient be
!         greater than TOL2
!*****
        if (abs(grad(i)) >= tol2) go to 590
      end do
!#      WRITE(IW,730) SSQ
      go to 660
  590 continue
      time2 = time1
      time1 = seconds(2)
      tcycle = time1 - time2
      tleft = tleft - tcycle
      if (tleft < 0.0D0) tleft = -0.1D0
      call prttim (tleft, tprt, txt)
      if (resfil) then
        write (iw, 600) tprt, txt, sqrt(ssq), escf
  600   format('  RESTART FILE WRITTEN,     TIME LEFT:',f6.2,a1,'  GRAD.:',f10.3,&
          ' HEAT:',g14.7)
        resfil = .FALSE.
      else
        write (line, '(" CYCLE:", i6, " TIME:", f8.3, " TIME LEFT:", &
                 & f6.2, a1, "  GRAD.:", f10.3, " HEAT:", g14.7)') &
                 icyc, min(tcycle,9999.99D0), tprt, txt, &
                 & min(sqrt(ssq),999999.999D0), escf
        write(iw,"(a)")line(:len_trim(line))
        endfile (iw)
        backspace (iw)
        if (log) write (ilog, "(a)")line(:len_trim(line))
        call to_screen(line)
        endfile (iw)
        backspace (iw)
        if (log) then
          endfile (ilog)
          backspace (ilog)
        end if
      end if
      endfile (iw)
      backspace (iw)
      if (log) then
        endfile (ilog)
        backspace (ilog)
      end if
      if (tlast - tleft > tdump) then
        tlast = tleft
        resfil = .TRUE.
        xlast(:nvar) = xparam(:nvar)
        iiium(1) = nscf
        call parsav (2, nvar, m, q, r, grad, xlast, iiium)
        if (moperr) goto 99
      end if
      if (tleft>tcycle*2 .and. icyc-jcyc<maxcyc) go to 60
      iiium(5) = ncount
      xlast(:nvar) = xparam(:nvar)
      iiium(1) = nscf
      call parsav (1, nvar, m, q, r, grad, xlast, iiium)
      if (moperr) goto 99
      iflepo = -1
      goto 99
  650 continue
      write (iw, 760) ncount
      go to 870
  660 continue
      write (iw, 770) ncount
      go to 870
  670 continue
      write (iw, 680) ixso
  680 format(' ',5x,'ATTEMPT TO GO DOWNHILL IS UNSUCCESSFUL AFTER',i5,5x,&
        'ORTHOGONAL SEARCHES')
      go to 870
  760 format(' TEST ON xparam SATISFIED, NUMBER OF FUNCTION CALLS = ',i5)
  770 format(' TEST ON SSQ SATISFIED, NUMBER OF FUNCTION CALLS = ',i5)
  870 continue
      last = 1
      call compfg (xparam, .TRUE., escf, .TRUE., grad, .TRUE.)
  99  if (allocated(q)) deallocate(q, stat = i)
      if (i /= 0) return
      if (allocated(r)) deallocate(r, stat = i)
      if (i /= 0) return
      return
      end subroutine nllsq

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine density_for_MOZYME (p, mode, nclose_loc, partp)
   !***********************************************************************
   !
   !   DENSIT COMPUTES THE DENSITY MATRIX GIVEN THE EIGENVECTOR MATRIX, AND
   !          INFORMATION ABOUT THE M.O. OCCUPANCY.
   !
   !  INPUT:  COCC  = COMPRESSED OCCUPIED EIGENVECTOR MATRIX
   !
   !   ON EXIT: P   = DENSITY MATRIX
   !
   !***********************************************************************
    use molkst_C, only: numat, mpack, keywrd
    use MOZYME_C, only : lijbo, nijbo, ncf, ncocc, &
      nncf, iorbs, cocc, icocc
    use chanel_C, only: iw
    implicit none
    integer, intent (in) :: mode, nclose_loc
    double precision, dimension (mpack), intent (in) :: partp
    double precision, dimension (mpack), intent (inout) :: p
    logical :: first = .true.
    logical, save :: prnt
    integer :: i, j, j1, ja, jj, k, k1, k2, ka, kk, l, loop, nj
    double precision :: spinfa, sum
    integer, external :: ijbo
    if (first) then
      first = .false.
      prnt = Index (keywrd, " DIAG ") /= 0
    end if
    if (mode == 0) then
      !
      !  INITIALIZE P:  FULL DENSITY CALCULATION
      !
      p(:) = 0.d0
    else if (mode ==-1) then
      !
      !   FULL DENSITY MATRIX IS IN PARTP, REMOVE DENSITY DUE TO
      !   OLD LMO's USED IN SCF
      !
      p(:) = -0.5d0 * partp(:)
    else
      !
      !   PARTIAL DENSITY MATRIX IS IN PARTP, BUILD THE REST OF P
      !
      p(:) = 0.5d0 * partp(:)
    end if

    do i = 1, nclose_loc
      loop = ncocc(i)
      ja = 0
      if (lijbo) then
        do jj = nncf(i) + 1, nncf(i) + ncf(i)
          j = icocc(jj)
          nj = iorbs(j)
          ka = loop
          do kk = nncf(i) + 1, nncf(i) + ncf(i)
            k = icocc(kk)
            if (j == k) then
              l = nijbo (j, k)
              do j1 = 1, nj
                sum = cocc(ja+j1+loop)
                do k1 = 1, j1
                  k2 = ka + k1
                  l = l + 1
                  p(l) = p(l) + cocc(k2) * sum
                end do
              end do
            else if (j > k .and. nijbo (j, k) >= 0) then
              l = nijbo (j, k)
              do j1 = 1, nj
                sum = cocc(ja+j1+loop)
                do k1 = 1, iorbs(k)
                  k2 = ka + k1
                  l = l + 1
                  p(l) = p(l) + cocc(k2) * sum
                end do
              end do
            end if
            ka = ka + iorbs(k)
          end do
          ja = ja + nj
        end do
      else
        do jj = nncf(i) + 1, nncf(i) + ncf(i)
          j = icocc(jj)
          nj = iorbs(j)
          ka = loop
          do kk = nncf(i) + 1, nncf(i) + ncf(i)
            k = icocc(kk)
            l = ijbo (j, k)
            if (j == k) then
              do j1 = 1, nj
                sum = cocc(ja+j1+loop)
                do k1 = 1, j1
                  k2 = ka + k1
                  l = l + 1
                  p(l) = p(l) + cocc(k2) * sum
                end do
              end do
            else if (j > k .and. l >= 0) then
              do j1 = 1, nj
                sum = cocc(ja+j1+loop)
                do k1 = 1, iorbs(k)
                  k2 = ka + k1
                  l = l + 1
                  p(l) = p(l) + cocc(k2) * sum
                end do
              end do
            end if
            ka = ka + iorbs(k)
          end do
          ja = ja + nj
        end do
      end if
    end do
    if (mode == 0 .or. mode == 1) then
      !
      !    FULL DENSITY CALCULATION.  MULTIPLY BY 2 FOR SPIN
      !
      spinfa = 2.d0
    else if (mode ==-1) then
      !
      !   MAKING PARTIAL DENSITY MATRIX. REVERSE SIGN ONCE MORE
      !
      spinfa = -2.d0
    else
      spinfa = 1.d0
    end if
   !
    if (Abs(spinfa - 1.d0) > 1.d-10) then
      p(:) = spinfa * p(:)
    end if
    if (prnt) then
      sum = 0.d0
      if (lijbo) then
        do i = 1, numat
          j = nijbo(i, i) + 1
          if (iorbs(i) > 0) then
            sum = sum + p(j)
          end if
          if (iorbs(i) == 4) then
            sum = sum + p(j+2) + p(j+5) + p(j+9)
          end if
        end do
      else
        do i = 1, numat
          j = ijbo (i, i) + 1
          if (iorbs(i) > 0) then
            sum = sum + p(j)
          end if
          if (iorbs(i) == 4) then
            sum = sum + p(j+2) + p(j+5) + p(j+9)
          end if
        end do
      end if
      write (iw,*) " COMPUTED NUMBER OF ELECTRONS:", sum
    end if
end subroutine density_for_MOZYME

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

    subroutine lbfgs (xparam, escf)
!
!  Use the limited-memory quasi-Newton Broyden-Fletcher-Goldfarb-Shanno method for unconstrained optimization
!
!    J. Nocedal. Updating Quasi-Newton Matrices with Limited Storage (1980),
!    Mathematics of Computation 35, pp. 773-782.
!    D.C. Liu and J. Nocedal. On the Limited Memory Method for Large Scale Optimization (1989),
!    Mathematical Programming B, 45, 3, pp. 503-528.
!
      use molkst_C, only: tleft, time0, iflepo, tdump, gnorm, natoms, keywrd, stress, &
      moperr, nvar, id, line, last, mozyme, numat, prt_gradients, keywrd_txt,  prt_coords
!
      use chanel_C, only: iw0, iw, log, ilog, input_fn
!
      use common_arrays_C, only : nc, grad, loc, geo
!
      use ef_C, only : nstep
!
      implicit none
      double precision, intent (inout) :: escf
      double precision, dimension (nvar), intent (inout) ::  xparam
!
      character :: txt, csave*60, task*60, line1*30
      logical :: resfil, times, lsave(4), geo_ref, restrt
      integer :: i, icyc, niwa, nwa, maxcyc, alloc_stat, m, isave(44), nflush = 1, &
        n_bad = 0, max_bad
!
      double precision :: const, cycmx, stepmx, sum, tstep, tt0, rms, slog, &
     & tlast, tolerg, tprt, tx1, tx2, best_funct, best_gnorm, oldstp(12), dsave(29)
!
      double precision, dimension(:), allocatable :: best_xparam, best_gradients, &
      bot, gold, top, xold, wa
      integer, dimension (:), allocatable :: best_nc, iwa, nbd
! For Mopac BLAS
      double precision, external :: ddot, reada, seconds
!

      save :: resfil, tlast
!
      allocate (best_xparam(nvar), best_gradients(nvar), best_nc(natoms), &
         & nbd(nvar), stat=alloc_stat)
      if (alloc_stat /= 0) then
        call memory_error ("mod_lbfgs")
        return
      end if
      m = 12
      grad = 0.d0
      best_xparam(:) = 0.d0
      best_gradients(:) = 0.d0
      best_nc(:) = 0
      best_funct = 1.d10
      best_gnorm = 1.d10
      niwa = 3 * nvar
      nwa = 2 * nvar * m + 4 * nvar + 11 * m ** 2 + 8 * m
      allocate (bot(nvar), gold(nvar), top(nvar), xold(nvar), wa(nwa), &
        iwa(niwa), stat=alloc_stat)
      wa = 0.d0
      iwa = 0
      task = " Unused"
      csave = " Unused"
      lsave = .false.
      isave = 0
      geo_ref = ((Index (keywrd_txt, " GEO_REF") /= 0) .and. (Index(keywrd, "LOCATE-TS") == 0))
      times = (Index (keywrd, " TIMES") /= 0)
      maxcyc = 100000
      slog = 0.2d0
      if (index(keywrd," SLOG=") /= 0) then
        slog = reada(keywrd, index(keywrd," SLOG="))
      else if (index(keywrd," SLOG") /= 0) then
        slog = 0.05d0
      end if
      if (Index (keywrd, " CYCLES") /= 0) then
        maxcyc = Nint (reada (keywrd, Index (keywrd, " CYCLES")))
      end if
      if (index(keywrd, " LET") + index(keywrd, " PREC") /= 0) then
        if (index(keywrd, " LET(") /= 0) then
          max_bad = Nint (reada (keywrd, Index (keywrd, " LET(")))
          write(iw,'(/10x,a,i4)') &
            "Keyword ""LET"" re-set the number of cycles used in identifying the lowest-energy geometry to",max_bad
        else
          max_bad = 60
        end if
      else
        max_bad = 30
      end if
      if (Index (keywrd, "GNORM=") /= 0) then
        tolerg = reada (keywrd, Index (keywrd, "GNORM="))
        if (Index (keywrd, " LET") == 0 .and. tolerg < 1.d-2) then
          write (iw, "(/,A)") "  GNORM HAS BEEN SET TOO LOW, RESET TO 0.01"
          tolerg = 1.d-2
        end if
      else
        tolerg = 1.d0
        if (id /= 0) tolerg = id*2.d0 - 1.d0
        if (Index (keywrd, " PREC") /= 0) then
          tolerg = tolerg*0.2d0
        end if
      end if
      do i = 1, 10
        oldstp(i) = 1.d0
      end do
      tlast = tleft
      tx2 = seconds (2)
      tx1 = tx2
      tleft = tleft - tx2 + time0
    !
    !  Turn OFF all bounds checking.  This saves memory and speeds things up
    !
      do i = 1, nvar
        nbd(i) = 0
      end do
      restrt = (Index (keywrd, " RESTART") /= 0)
      if (restrt) then
        isave = 0
        dsave = 0.d0
        nstep = 0
        tt0 = 0.d0
        call lbfsav (tt0, 0, wa, nwa, iwa, niwa, task, csave, lsave, isave, dsave, &
             & nstep, escf)
        time0 = time0 - tt0
        if (Index (keywrd, " 1SCF") /= 0) then
          i = Index (keywrd, " GRAD") + Index (keywrd,"DERIV")
          call compfg (xparam, .true., escf, .true., grad, i/=0)
          iflepo = 1
          return
        end if
        if (moperr) return
       !
       !  Don't save GOLD - it's only used for advice to the user.
       !
        call dcopy (nvar, grad, 1, gold, 1)
        icyc = nstep
      else
        task = "START"
        nstep = 0
        icyc = 0
      end if
      cycmx = 0.d0
      tlast = tleft
      resfil = .false.
      do
       !
       !  Check: Is there enough time for another cycle?
       !
       !     ------- THE BEGINNING OF THE LOOP ----------
        if (tleft < 1.5d0*cycmx .or. nstep-icyc+1 > maxcyc) then
          if (nstep-icyc+1 > maxcyc) then
            write (iw, "(/20x,a,/)") &
                 & "NUMBER OF CYCLES EXCEEDED.  NOW GOING TO FINAL"
          else
            write (iw, "(20x,a,/30x,a)") &
                 & "THERE IS NOT ENOUGH TIME FOR ANOTHER CYCLE", &
                 & "NOW GOING TO FINAL"
          end if
          write (iw, "(//10x,' - THE CALCULATION IS BEING DUMPED TO DISK')")
          write (iw, "(10x,'   RESTART IT USING THE KEYWORD ""RESTART""')")
          tt0 = seconds (1) - time0
          call lbfsav (tt0, 1, wa, nwa, iwa, niwa, task, csave, lsave, isave, &
               & dsave, nstep, escf)
          iflepo = -1
          goto 99
        end if
        if (times) then
          call timer (" Before SETULB")
        end if
       !
       !  Yes, there is time for another cycle.
       !
        call dcopy (nvar, xparam, 1, xold, 1)
       !     THIS IS THE CALL TO THE L-BFGS-B CODE.
       !
        call setulb (nvar, m, xparam, bot, top, nbd, escf, grad, 0.d0, &
       & 0.d0, wa, iwa, task,-1, csave, lsave, isave, dsave)
        if (moperr) goto 99
        if (times) then
          call timer (" AFTER SETULB")
        end if
        dsave(2) = dsave(2) + 1.d4
        if (task(1:2) == "FG") then
          if (nstep > 1) then
            !
            !  How big was the step in parameter space?
            !
            sum = 0.d0
            do i = 1, nvar
              sum = sum + (xparam(i)-xold(i)) ** 2
            end do
            sum = Sqrt (sum)
            i = min(nvar,10)
            stepmx = Min (1.d0, dSqrt (ddot(i,oldstp, 1,oldstp, 1)/i))
            if (sum > stepmx*2.d0) then
              !
              ! Step was too big - this was probably due to an error in SETULB.
              ! Reduce the step to two times STEPMX
              !
              const = 2.d0 * stepmx / sum
              do i = 1, nvar
                xparam(i) = const * xparam(i) + (1.d0-const) * xold(i)
              end do
              sum = 2.d0 * stepmx
            end if
            oldstp(Mod(nstep, 10)+1) = sum
          end if
!
!  Limit step to "slog" Angstroms, default: 0.2A.  This should help damp wild swings
!
          do i = 1, nvar
            if (abs(xparam(i) - xold(i)) > slog) then
              xparam(i) = xold(i) + max(-slog, min(slog, xparam(i) - xold(i)))
            end if
          end do
          call compfg (xparam, .true., escf, .true., grad, .true.)
          if (moperr) goto 99
          if (best_funct < escf) then
            n_bad = n_bad + 1
          else
            n_bad = 0
          end if
!
! Allow for quite large regions of instability in the optimization.
!
          if (n_bad > max_bad .or. (gnorm < 1.d0 .and. n_bad > (max_bad*2)/3)) then
            write (iw, "(//10x,' HEAT OF FORMATION IS ESSENTIALLY STATIONARY')")
            iflepo = 3
            exit
          end if
          if (times) then
            call timer ("AFTER COMPFG")
          end if
            !
            !  Write out this cycle
            !
          nstep = nstep + 1
          tx2 = seconds (2)
          tstep = tx2 - tx1
          cycmx = Max (tstep, cycmx)
          tx1 = tx2
          tleft = tleft - tstep
          if (tlast-tleft > tdump) then
            tlast = tleft
            resfil = .true.
            tt0 = seconds (1) - time0
            call lbfsav (tt0, 1, wa, nwa, iwa, niwa, task, csave, lsave, isave, &
                 & dsave, nstep, escf)
            if (moperr) goto 99
          end if
          tleft = Max (0.d0, tleft)
          call prttim (tleft, tprt, txt)
          gnorm = dSqrt (ddot(nvar,grad, 1, grad, 1))
          if (best_funct > escf) then
  !
  !  Store best result up to the present
  !
            best_gnorm = gnorm
            best_funct = escf
            best_xparam = xparam
            best_gradients = grad
            best_nc(:natoms) = nc(:natoms)
          end if
  !
  !   Write out current status
  !
          if (id == 3 .and. nstep > 0) then
            nstep = nstep - 1
            call write_cell(iw)
            call write_cell(iw0)
            nstep = nstep + 1
          end if
          if (geo_ref) then
            call  geo_diff(sum, rms, .false.)
            write(iw,'(/1x, a, f8.2, a, f8.4, a, f8.4, a, f11.2, a)') "Difference to Geo-Ref:", sum, &
            " = total,", sum/numat, " = Average,", sqrt(rms/numat)," = RMS movement.    STRESS:", &
            stress
          end if
          if (geo_ref) then
            write(line1,'(a,g15.7)')"  - STRESS:", escf - stress
          else
            line1 = " "
          end if
          if (resfil) then
            write (line, '(" RESTART FILE WRITTEN,      TIME LEFT:", f6.2, &
             & a1, "  GRAD.:", f10.3, " HEAT:", g14.7, a)') &
             tprt, txt, Min (gnorm, 999999.999d0), escf, trim(line1)
            write(iw,"(a)")trim(line)
            call to_screen(trim(line))
            endfile (iw)
            backspace (iw)
            if (log) write (ilog, '(a)', err = 1000)trim(line)
            resfil = .false.
          else
            write (line, '(" CYCLE:", i6, " TIME:", f8.3, " TIME LEFT:", &
                   & f6.2, a1, "  GRAD.:", f10.3, " HEAT:", g14.7, a)') &
                   nstep, Min (tstep, 9999.99d0), tprt, txt, &
                   & Min (gnorm, 999999.999d0), escf, trim(line1)
            write(iw,"(a)")trim(line)
            endfile (iw)
            backspace (iw)
            if (log) write (ilog, "(a)")trim(line)
            call to_screen(trim(line))
          end if
          if (mod(nstep,30) == 0) then
            line = trim(input_fn)
            call add_path(line)
            i = len_trim(line) - 5
            call to_screen(line(:i))
          end if
          if (nflush /= 0) then
            if (Mod(nstep, nflush) == 0) then
              endfile (iw)
              backspace (iw)
              if (log) then
                endfile (ilog)
                backspace (ilog)
              end if
            end if
          end if
          call to_screen("To_file: Geometry optimizing")
          !
          !  Write out the cosine of the angle that the new gradient makes
          !  with the old gradient.  Ideally, this should be small.
          !
  1000    call dcopy (nvar, grad, 1, gold, 1)
          endfile (iw)
          backspace (iw)
          !
          !  EXIT CRITERIA.  (The criteria in SETULB are ignored.)
          if (gnorm < tolerg) then
            iflepo = 3
            exit
          end if
        else if (task(1:5) /= "NEW_X") then
          write (iw, "(2A)") " L-BFGS Message:", task
          iflepo = 9
          exit
        end if
      end do
!
!  If current point is not the best, then load in the best point
!
99    if (best_funct + 5.d-4 < escf) then
        m = 1
        escf   = best_funct
        gnorm  = best_gnorm
        xparam = best_xparam
        grad   = best_gradients
        nc(:natoms)     = best_nc(:natoms)
        if (iflepo == -1) then
!
! Job ran out of time or out of cycles - most likely shut down using the SHUT command.
! so update the geometry before printing it.
!       Update array geo
          do i = 1, nvar
            geo(loc(2,i) ,loc(1,i)) = xparam(i)
          end do
          call symtry
        else
!
!  Call compfg to re-set all calculated quantities
!
          last = 1
          call compfg (xparam, .true., escf, .true., grad, .false.)
          write (iw, "(//10X,'CURRENT BEST VALUE OF HEAT OF FORMATION ='   ,F14.6)") escf - stress
          if ( prt_coords) then
            write(iw,*)
            call geout (iw)
            write(iw,*)
          end if
        end if
      else
        m = 0
        if (iflepo /= -1 .and. .not. mozyme ) then
!
! Job did not run out of time.  The energy levels are incorrect - the SHIFT is still working
! so do a single SCF calculation to re-set the energy levels.
!
          last = 1
          call compfg (xparam, .true., escf, .true., grad, .false.)
        end if
      end if
      if (iflepo == -1) then
        if (m == 1) then
          write (iw, "(//10X,'CURRENT BEST VALUE OF HEAT OF FORMATION ='   ,F14.6)") escf - stress
        else
          write (iw, "(//10X,'CURRENT VALUE OF HEAT OF FORMATION ='   ,F14.6)") escf - stress
        end if
        if (prt_gradients .and. index(keywrd," GRADI") /= 0 .and. mozyme) then
          write (iw, '(3/7X,''CURRENT  POINT  AND  DERIVATIVES'',/)')
          call prtgra ()
        end if
        call geout (iw)
        write(iw,*)
      end if
      deallocate (best_xparam, best_gradients, best_nc, stat=alloc_stat)
      return
    end subroutine lbfgs
    subroutine lbfsav (tt0, mode, wa, nwa, iwa, niwa, task, csave, lsave, isave, &
   & dsave, nstep, escf)
      use molkst_C, only: nscf, numat, norbs, nvar
      use chanel_C, only: ires, iw, restart_fn
      use common_arrays_C, only: xparam, grad
      implicit none
      character (len=60), intent (inout) :: csave, task
      integer, intent (in) :: mode, niwa, nwa
      integer, intent (inout) :: nstep
      double precision, intent (inout) :: escf, tt0
      logical, dimension (4), intent (inout) :: lsave
      integer, dimension (44), intent (inout) :: isave
      integer, dimension (niwa), intent (inout) :: iwa
      double precision, dimension (29), intent (inout) :: dsave
      double precision, dimension (nwa), intent (inout) :: wa
      logical :: opend
      integer :: old_numat, old_norbs, i, j
      inquire (unit=ires, opened=opend)
      if (opend) then
        close (unit=ires, status="KEEP")
      end if
      open (unit=ires, file=restart_fn, status="UNKNOWN", form="UNFORMATTED")
      rewind (ires)
      if (mode == 1) then
        call den_in_out (1)
       !
       !  Write out XPARAM and GRAD
       !
        write (ires) numat, norbs, (xparam(i),i=1,nvar)
        write (ires) grad
       !
       !  Write out restart file
       !
        write (ires) wa, iwa, task, csave, lsave, isave, dsave, nstep, &
       & escf, nscf, tt0
        close (ires)
      else
        write (iw, "(//10X,'RESTORING DATA FROM DISK'/)")
       !
       !  Read in XPARAM and GRAD
       !
        read (ires, iostat = j)old_numat, old_norbs
        if (norbs /= old_norbs .or. numat /= old_numat .or. j /= 0) then
        call mopend("Restart file read in does not match current data set")
        return
    end if
        read (ires, err=1100, END=1100) grad
       !
       !  Read in restart file
       !
        read (ires, err=1000, END=1000) wa, iwa, task, csave, lsave, isave, &
       & dsave, nstep, escf, nscf, tt0
        i = int(tt0/10000000)
    tt0 = tt0 - i*10000000
    write (iw, '(10X,''TOTAL TIME USED SO FAR:'',F13.2,'' SECONDS'',/)') tt0
        return
1000    call mopend ("RESTART FILE EXISTS, BUT IS CORRUPT")
        return
1100    call mopend ("NO RESTART FILE EXISTS!")
      end if
    end subroutine lbfsav
    subroutine setulb (n, m, x, l, u, nbd, f, g, factr, pgtol, wa, iwa, task, &
   & iprint, csave, lsave, isave, dsave)
      implicit none
      character (len=60), intent (inout) :: csave, task
      integer, intent (in) :: iprint, m, n
      double precision, intent (in) :: factr, pgtol
      double precision, intent (inout) :: f
      logical, dimension (4), intent (inout) :: lsave
      integer, dimension (44), intent (inout) :: isave
      integer, dimension (3*n), intent (inout) :: iwa
      integer, dimension (n), intent (in) :: nbd
      double precision, dimension (2*m*n+4*n+11*m*m+8*m), intent (inout) :: wa
      double precision, dimension (29), intent (inout) :: dsave
      double precision, dimension (n), intent (in) :: l, u
      double precision, dimension (n), intent (inout) :: g, x
      integer :: ld, lr, lsnd, lss, lsy, lt, lwa, lwn, lws, lwt, &
     & lwy, lz
      if (task == "START") then
        isave(1) = m * n
        isave(2) = m ** 2
        isave(3) = 4 * m ** 2
        isave(4) = 1
        isave(5) = isave(4) + isave(1)
        isave(6) = isave(5) + isave(1)
        isave(7) = isave(6) + isave(2)
        isave(8) = isave(7) + isave(2)
        isave(9) = isave(8)
        isave(10) = isave(9) + isave(2)
        isave(11) = isave(10) + isave(3)
        isave(12) = isave(11) + isave(3)
        isave(13) = isave(12) + n
        isave(14) = isave(13) + n
        isave(15) = isave(14) + n
        isave(16) = isave(15) + n
      end if
      lws = isave(4)
      lwy = isave(5)
      lsy = isave(6)
      lss = isave(7)
      lwt = isave(9)
      lwn = isave(10)
      lsnd = isave(11)
      lz = isave(12)
      lr = isave(13)
      ld = isave(14)
      lt = isave(15)
      lwa = isave(16)
    !
    !
      call mainlb (n, m, x, l, u, nbd, f, g, factr, pgtol, wa(lws), wa(lwy), &
     & wa(lsy), wa(lss), wa(lwt), wa(lwn), wa(lsnd), wa(lz), wa(lr), wa(ld), &
     & wa(lt), wa(lwa), iwa(1), iwa(n+1), iwa(2*n+1), task, iprint, csave, &
     & lsave, isave(22), dsave)
    !
    end subroutine setulb
  !
  !======================= The end of setulb =============================
    subroutine mainlb (n, m, x, l, u, nbd, f, g, factr, pgtol, ws, wy, sy, ss, &
   & wt, wn, snd, z, r, d, t, wa, Index, iwhere, indx2, task, iprint, csave, &
   & lsave, isave, dsave)
    !
    use chanel_C, only: lbfgs_it, iw
      implicit none
      double precision, parameter :: one = 1.0d0
      double precision, parameter :: zero = 0.0d0
      character (len=60), intent (inout) :: csave, task
      integer, intent (in) :: iprint, m, n
      double precision, intent (in) :: factr, pgtol
      double precision, intent (inout) :: f
      logical, dimension (4), intent (inout) :: lsave
      integer, dimension (23), intent (inout) :: isave
      integer, dimension (n), intent (in) :: nbd
      integer, dimension (n), intent (inout) :: index, indx2, iwhere
      double precision, dimension (29), intent (inout) :: dsave
      double precision, dimension (8*m), intent (inout) :: wa
      double precision, dimension (n), intent (in) :: l, u
      double precision, dimension (n), intent (inout) :: d, g, r, t, x, z
      double precision, dimension (2*m, 2*m), intent (inout) :: snd, wn
      double precision, dimension (m, m), intent (inout) :: ss, sy, wt
      double precision, dimension (n, m), intent (inout) :: ws, wy
      character (len=3) :: word
      logical :: boxed, cnstnd, prjctd, updatd, wrk
      integer :: col, head, i, iback, ifun, ileave, info, itail, iter, itfile, &
     & iupdat, iword, k, nact, nenter, nfgv, nfree, nint, nintol, nskip
      double precision :: cachyt, cpu1, cpu2, ddum, dnorm, dr, dtd, epsmch, &
     & fold, gd, gdold, lnscht, rr, sbgnrm, sbtime, stp, stpmx, theta, time, &
     & time1, time2, tol, xstep
      double precision, external :: dpmeps
! For Parallel MOPAC
      double precision, external :: ddot

      if (task == "START") then
       !
       !         call timer(time1)
       !
       !        Generate the current machine precision.
       !
        epsmch = dpmeps ()!
       !        The end of the initialization.
       !
        fold = 0.0d0
        dnorm = 0.0d0
        time1 = 0.0d0
        time2 = 0.0d0
        cpu1 = 0.0d0
        cpu2 = 0.0d0
        gd = 0.0d0
        sbgnrm = 0.0d0
        stp = 0.0d0
        stpmx = 0.0d0
        gdold = 0.0d0
        dtd = 0.0d0
       !
       !
       !        Initialize counters and scalars when task='START'.
       !
       !           for the limited memory BFGS matrices:
        col = 0
        head = 1
        theta = one
        iupdat = 0
        updatd = .false.
        iback = 0
        itail = 0
        ifun = 0
        iword = 0
        nact = 0
        ileave = 0
        nenter = 0
       !           for operation counts:
        iter = 0
        nfgv = 0
        nint = 0
        nintol = 0
        nskip = 0
        nfree = n
       !
       !           for stopping tolerance:
        tol = factr * epsmch
       !
       !           for measuring running time:
        cachyt = 0
        sbtime = 0
        lnscht = 0
       !           'word' records the status of subspace solutions.
        word = "---"
       !
       !           'info' records the termination information.
        info = 0
        itfile = 0
       !
        if (iprint >= 1) then
          !                                open a summary file
     !     open (lbfgs_it, file=lbfgs_it_fn, status="unknown")
          itfile = lbfgs_it
        end if
       !
       !        Check the input arguments for errors.
       !
        call errclb (n, m, factr, l, u, nbd, task, info, k)
        if (task(1:5) == "ERROR") then
          xstep = 0.0d0
          k = 0
          call prn3lb (n, x, f, task, iprint, info, itfile, iter, nfgv, &
         & nintol, nskip, nact, sbgnrm, zero, nint, word, iback, stp, xstep, &
         & k, cachyt, sbtime, lnscht)
          return
        else
          !
          call prn1lb (n, m, l, u, x, iprint, itfile, epsmch)
          !        Initialize iwhere & project x onto the feasible set.
          call active (n, l, u, nbd, x, iwhere, iprint, prjctd, cnstnd, boxed)
        end if
      else
       !          restore local variables.
       !
        prjctd = lsave(1)
        cnstnd = lsave(2)
        boxed = lsave(3)
        updatd = lsave(4)
       !
        nintol = isave(1)
        itfile = isave(3)
        iback = isave(4)
        nskip = isave(5)
        head = isave(6)
        col = isave(7)
        itail = isave(8)
        iter = isave(9)
        iupdat = isave(10)
        nint = isave(12)
        nfgv = isave(13)
        info = isave(14)
        ifun = isave(15)
        iword = isave(16)
        nfree = isave(17)
        nact = isave(18)
        ileave = isave(19)
        nenter = isave(20)
       !
        theta = dsave(1)
        fold = dsave(2)
        tol = dsave(3)
        dnorm = dsave(4)
        epsmch = dsave(5)
        cpu1 = dsave(6)
        cachyt = dsave(7)
        sbtime = dsave(8)
        lnscht = dsave(9)
        time1 = dsave(10)
        gd = dsave(11)
        stpmx = dsave(12)
        sbgnrm = dsave(13)
        stp = dsave(14)
        gdold = dsave(15)
        dtd = dsave(16)
        cpu2 = 0.d0
       !        After returning from the driver go to the point where execution
       !        is to resume.
       !
        if (task(1:5) /= "FG_LN") then
          if (task(1:5) == "NEW_X") then
            !
            !     Test for termination.
            !
            if (sbgnrm <= pgtol) then
              !             terminate the algorithm.
              task = "CONVERGENCE: NORM OF PROJECTED GRADIENT <= PGTOL"
              go to 1100
            else

              ddum = Max (Abs (fold), Abs (f), one)
              if ((fold-f) <= tol*ddum) then
                !           terminate the algorithm.
                task = "CONVERGENCE: REL_REDUCTION_OF_F <= FACTR*EPSMCH"
                ! i.e., to issue a warning if iback>10 in the line search.
                if (iback >= 10) then
                  info = -5
                end if
                go to 1100
              else
                !
                !     Compute d=newx-oldx, r=newg-oldg, rr=y'y and dr=y's.
                do i = 1, n
                  r(i) = g(i) - r(i)
                end do
                rr = ddot (n, r, 1, r, 1)
                if (Abs(stp - one) < 1.d-20) then
                  dr = gd - gdold
                  ddum = -gdold
                else
                  dr = (gd-gdold) * stp
                  call dscal (n, stp, d, 1)
                  ddum = -gdold * stp
                end if
                if (dr <= epsmch*ddum) then
                      !                            skip the L-BFGS update.
                  nskip = nskip + 1
                  updatd = .false.
                  if (iprint >= 1) then
10000               format ("  ys=", 1 p, e10.3, "  -gs=", 1 p, e10.3, &
                   & " BFGS update SKIPPED")
                    write (iw, 10000) dr, ddum
                  end if
                else
                  !cccccccccccccccccccccccccccccccccccccccccccccccc
                  !
                  !     Update the L-BFGS matrix.
                  !
                  !cccccccccccccccccccccccccccccccccccccccccccccccc
                  updatd = .true.
                  iupdat = iupdat + 1
                  !
                  !     Update matrices WS and WY and form the middle
                  !     matrix in B.
                  !
                  call matupd (n, m, ws, wy, sy, ss, d, r, itail, iupdat, &
                       & col, head, theta, rr, dr, stp, dtd)
                  !
                  ! Form the upper half of the pds T = theta*SS + L*D^(-1)*L';
                  !    Store T in the upper triangular of the array wt;
                  !    Cholesky factorize T to J*J' with
                  !    J' stored in the upper triangular of wt.
                  !
                  call formt (m, wt, sy, ss, col, theta, info)
                  if (info /= 0) then
                    ! nonpositive definiteness in Cholesky factorization;
                    ! refresh the lbfgs memory and restart the iteration.
                    if (iprint >= 1) then
10010                 format (/, &
                     & " Nonpositive definiteness in Cholesky factorization", &
                     & " in formt;"/ &
                     & "   refresh the lbfgs memory and restart the iteration.")
                      write (iw, 10010)
                    end if
                    info = 0
                    col = 0
                    head = 1
                    theta = one
                    iupdat = 0
                    updatd = .false.
                  end if
                end if
              end if
            end if
          else if (task(1:5) == "FG_ST") then
            nfgv = 1
             !     Compute the infinity norm of the (-) projected gradient.
            call projgr (n, l, u, nbd, x, g, sbgnrm)
            if (iprint >= 1) then
10020         format (/, "At iterate", i5, 4 x, "f= ", 1 p, d12.5, 4 x, &
             & "|proj g|= ", 1 p, d12.5)
              write (iw, 10020) iter, f, sbgnrm
10030         format (2(1 x, i4), 5 x, "-", 5 x, "-", 3 x, "-", 5 x, "-", 5 x, &
             & "-", 8 x, "-", 3 x, 1 p, 2(1 x, d10.3))
              write (itfile, 10030) iter, nfgv, sbgnrm, f
            end if
            if (sbgnrm <= pgtol) then
              !            terminate the algorithm.
              task = "CONVERGENCE: NORM OF PROJECTED GRADIENT <= PGTOL"
              go to 1100
            end if
          else if (task(1:4) == "STOP") then
            if (task(7:9) == "CPU") then
                !           restore the previous iterate.
              call dcopy (n, t, 1, x, 1)
              call dcopy (n, r, 1, g, 1)
              f = fold
            end if
            go to 1100
          else
            go to 1000
          end if
          do
            if (iprint >= 99) then
                !
10040         format (/ /, "ITERATION ", i5)
              write (iw, 10040) iter + 1
            end if
            iword = -1
             !
            if ( .not. cnstnd .and. col > 0) then
                !              skip the search for GCP.
              call dcopy (n, x, 1, z, 1)
              wrk = updatd
              nint = 0
            else
              !
              !cccccccccccccccccccccccccccccccccccccccccccccccccccc
              !
              !     Compute the Generalized Cauchy Point (GCP).
              !
              !cccccccccccccccccccccccccccccccccccccccccccccccccccc
              !
              !      call timer(cpu1)
              call cauchy (n, x, l, u, nbd, g, indx2, iwhere, t, d, z, m, wy, &
             & ws, sy, wt, theta, col, head, wa(1), wa(2*m+1), wa(4*m+1), &
             & wa(6*m+1), nint, iprint, sbgnrm, info, epsmch)
              if (info /= 0) then
                !singular triangular system detected; refresh the lbfgs memory.
                if (iprint >= 1) then
10050             format (/, " Singular triangular system detected;",/, &
                 & "   refresh the lbfgs memory and restart the iteration.")
                  write (iw, 10050)
                end if
                info = 0
                col = 0
                head = 1
                theta = one
                iupdat = 0
                updatd = .false.
                   !         call timer(cpu2)
                cachyt = cachyt + cpu2 - cpu1
                cycle
              else
                   !      call timer(cpu2)
                cachyt = cachyt + cpu2 - cpu1
                nintol = nintol + nint
                !
                !     Count the entering and leaving variables for iter > 0;
                !     find the index set of free and active variables at
                !     the GCP.
                !
                call freev (n, nfree, index, nenter, ileave, indx2, iwhere, &
               & wrk, updatd, cnstnd, iprint, iter)
                   !
                nact = n - nfree
              end if
            end if
            !     If there are no free variables or B=theta*I, then
            !          skip the subspace minimization.
            if (nfree == 0 .or. col == 0) exit
            !cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
            !
            !     Subspace minimization.
            !
            !cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
             !
             !      call timer(cpu1)
             !
             !     Form  the LEL^T factorization of the indefinite
             !       matrix    K = [-D -Y'ZZ'Y/theta     L_a'-R_z'  ]
             !                     [L_a -R_z           theta*S'AA'S ]
             !       where     E = [-I  0]
             !                     [ 0  I]
             !
            if (wrk) then
              call formk (n, nfree, index, nenter, ileave, indx2, iupdat, &
             & updatd, wn, snd, m, ws, wy, sy, theta, col, head, info)
            end if
            if (info /= 0) then
                !          nonpositive definiteness in Cholesky factorization;
                !          refresh the lbfgs memory and restart the iteration.
              if (iprint >= 1) then
10060           format (/, &
               & " Nonpositive definiteness in Cholesky factorization in formk;" / &
               & "   refresh the lbfgs memory and restart the iteration.")
                write (iw, 10060)
              end if
              info = 0
              col = 0
              head = 1
              theta = one
              iupdat = 0
              updatd = .false.
                !         call timer(cpu2)
              sbtime = sbtime + cpu2 - cpu1
            else
              !
              !        compute r=-Z'B(xcp-xk)-Z'g (using wa(2m+1)=W'(xcp-x)
              !                                from 'cauchy').
              call cmprlb (n, m, x, g, ws, wy, sy, wt, z, r, wa, index, theta, &
                   & col, head, nfree, cnstnd, info)
              if (info == 0) then
                   !       call the direct method.
                call subsm (n, m, nfree, index, l, u, nbd, z, r, ws, wy, &
               & theta, col, head, iword, wa, wn, iprint, info)
              end if
              if (info /= 0) then
                   !    singular triangular system detected;
                   !    refresh the lbfgs memory and restart the iteration.
                if (iprint >= 1) then
                  write (iw, 10050)
                end if
                info = 0
                col = 0
                head = 1
                theta = one
                iupdat = 0
                updatd = .false.
                   !         call timer(cpu2)
                sbtime = sbtime + cpu2 - cpu1
              else
                   !      call timer(cpu2)
                sbtime = sbtime + cpu2 - cpu1
                exit
              end if
            end if
          end do
          !ccccccccccccccccccccccccccccccccccccccccccccccccccccc
          !
          !     Line search and optimality tests.
          !
          !ccccccccccccccccccccccccccccccccccccccccccccccccccccc
          !     Generate the search direction d:=z-x.
          !
          do i = 1, n
            d(i) = z(i) - x(i)
          end do
        end if
        do
          !      call timer(cpu1)
          call lnsrlb (n, l, u, nbd, x, f, fold, gd, gdold, g, d, r, t, z, &
         & stp, dnorm, dtd, xstep, stpmx, iter, ifun, iback, nfgv, info, task, &
         & boxed, cnstnd, csave, isave(22), dsave(17))
          if (info == 0 .and. iback < 20) go to 1200
          !          restore the previous iterate.
          call dcopy (n, t, 1, x, 1)
          call dcopy (n, r, 1, g, 1)
          f = fold
          if (col == 0) exit
          !             refresh the lbfgs memory and restart the iteration.
          if (iprint >= 1) then
10070       format (/, " Bad direction in the line search;",/, &
           & "   refresh the lbfgs memory and restart the iteration.")
            write (iw, 10070)
          end if
          if (info == 0) then
            nfgv = nfgv - 1
          end if
          info = 0
          col = 0
          head = 1
          theta = one
          iupdat = 0
          updatd = .false.
          task = "RESTART_FROM_LNSRCH"
          !            call timer(cpu2)
          lnscht = lnscht + cpu2 - cpu1
          do
            ! ----------------- the beginning of the loop ---------------
            if (iprint >= 99) then
              write (iw, 10040) iter + 1
            end if
            iword = -1
             !
            if ( .not. cnstnd .and. col > 0) then
                !                             skip the search for GCP.
              call dcopy (n, x, 1, z, 1)
              wrk = updatd
              nint = 0
            else
              !
              !cccccccccccccccccccccccccccccccccccccccccccccccccccccc
              !
              !     Compute the Generalized Cauchy Point (GCP).
              !
              !cccccccccccccccccccccccccccccccccccccccccccccccccccccc
              !
              !      call timer(cpu1)
              call cauchy (n, x, l, u, nbd, g, indx2, iwhere, t, d, z, m, wy, &
             & ws, sy, wt, theta, col, head, wa(1), wa(2*m+1), wa(4*m+1), &
             & wa(6*m+1), nint, iprint, sbgnrm, info, epsmch)
              if (info /= 0) then
                !singular triangular system detected; refresh the lbfgs memory.
                if (iprint >= 1) then
                  write (iw, 10050)
                end if
                info = 0
                col = 0
                head = 1
                theta = one
                iupdat = 0
                updatd = .false.
                   !         call timer(cpu2)
                cachyt = cachyt + cpu2 - cpu1
                cycle
              else
                   !      call timer(cpu2)
                cachyt = cachyt + cpu2 - cpu1
                nintol = nintol + nint
                !
                !     Count the entering and leaving variables for iter > 0;
                !     find the index set of free and active variables at the GCP.
                !
                call freev (n, nfree, index, nenter, ileave, indx2, iwhere, &
               & wrk, updatd, cnstnd, iprint, iter)
                   !
                nact = n - nfree
              end if
            end if
             !     If there are no free variables or B=theta*I, then
             !                skip the subspace minimization.
            if (nfree == 0 .or. col == 0) exit
            !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
            !
            !     Subspace minimization.
            !
            !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
             !
             !      call timer(cpu1)
             !
             !     Form  the LEL^T factorization of the indefinite
             !       matrix    K = [-D -Y'ZZ'Y/theta     L_a'-R_z'  ]
             !                     [L_a -R_z           theta*S'AA'S ]
             !       where     E = [-I  0]
             !                     [ 0  I]
             !
            if (wrk) then
              call formk (n, nfree, index, nenter, ileave, indx2, iupdat, &
             & updatd, wn, snd, m, ws, wy, sy, theta, col, head, info)
            end if
            if (info /= 0) then
                !          nonpositive definiteness in Cholesky factorization;
                !          refresh the lbfgs memory and restart the iteration.
              if (iprint >= 1) then
                write (iw, 10060)
              end if
              info = 0
              col = 0
              head = 1
              theta = one
              iupdat = 0
              updatd = .false.
                !         call timer(cpu2)
              sbtime = sbtime + cpu2 - cpu1
            else
              !
              !     compute r=-Z'B(xcp-xk)-Z'g (using wa(2m+1)=W'(xcp-x)
              !                       from 'cauchy').
              call cmprlb (n, m, x, g, ws, wy, sy, wt, z, r, wa, index, theta, &
             & col, head, nfree, cnstnd, info)
              if (info == 0) then
                   !       call the direct method.
                call subsm (n, m, nfree, index, l, u, nbd, z, r, ws, wy, &
               & theta, col, head, iword, wa, wn, iprint, info)
              end if
              if (info /= 0) then
                !          singular triangular system detected;
                !          refresh the lbfgs memory and restart the iteration.
                if (iprint >= 1) then
                  write (iw, 10050)
                end if
                info = 0
                col = 0
                head = 1
                theta = one
                iupdat = 0
                updatd = .false.
                   !         call timer(cpu2)
                sbtime = sbtime + cpu2 - cpu1
              else
                   !      call timer(cpu2)
                sbtime = sbtime + cpu2 - cpu1
                exit
              end if
            end if
          end do
          !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
          !
          !     Line search and optimality tests.
          !
          !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
          !     Generate the search direction d:=z-x.
          !
          do i = 1, n
            d(i) = z(i) - x(i)
          end do
        end do
       !             abnormal termination.
        if (info == 0) then
          info = -9
          !        restore the actual number of f and g evaluations etc.
          nfgv = nfgv - 1
          ifun = ifun - 1
          iback = iback - 1
        end if
        task = "ABNORMAL_TERMINATION_IN_LNSRCH"
        iter = iter + 1
        go to 1100
1200    if (task(1:5) /= "FG_LN") then
          !    calculate and print out the quantities related to the new X.
          !         call timer(cpu2)
          lnscht = lnscht + cpu2 - cpu1
          iter = iter + 1
          !        Compute the infinity norm of the projected (-)gradient.
          call projgr (n, l, u, nbd, x, g, sbgnrm)
          !        Print iteration information.
          !
          call prn2lb (n, x, f, g, iprint, itfile, iter, nfgv, nact, sbgnrm, &
         & nint, word, iword, iback, stp, xstep)
        end if
        go to 1300
1100    time2 = 0
       !      call timer(time2)
        time = time2 - time1
        k = 0
        call prn3lb (n, x, f, task, iprint, info, itfile, iter, nfgv, nintol, &
       & nskip, nact, sbgnrm, time, nint, word, iback, stp, xstep, k, cachyt, &
       & sbtime, lnscht)
        go to 1300
      end if
    !
    !     Compute f0 and g0.
    !
    !          return to the driver to calculate f and g; reenter at 111.
1000  task = "FG_START"
    !
    !     Save local variables.
    !
1300  lsave(1) = prjctd
      lsave(2) = cnstnd
      lsave(3) = boxed
      lsave(4) = updatd
    !
      isave(1) = nintol
      isave(3) = itfile
      isave(4) = iback
      isave(5) = nskip
      isave(6) = head
      isave(7) = col
      isave(8) = itail
      isave(9) = iter
      isave(10) = iupdat
      isave(12) = nint
      isave(13) = nfgv
      isave(14) = info
      isave(15) = ifun
      isave(16) = iword
      isave(17) = nfree
      isave(18) = nact
      isave(19) = ileave
      isave(20) = nenter
    !
      dsave(1) = theta
      dsave(2) = fold
      dsave(3) = tol
      dsave(4) = dnorm
      dsave(5) = epsmch
      dsave(6) = cpu1
      dsave(7) = cachyt
      dsave(8) = sbtime
      dsave(9) = lnscht
      dsave(10) = time1
      dsave(11) = gd
      dsave(12) = stpmx
      dsave(13) = sbgnrm
      dsave(14) = stp
      dsave(15) = gdold
      dsave(16) = dtd
    !
    end subroutine mainlb
  !======================= The end of mainlb =============================
  !
    subroutine active (n, l, u, nbd, x, iwhere, iprint, prjctd, cnstnd, boxed)
      use chanel_C, only: iw
      implicit none
      double precision, parameter :: zero = 0.0d0
      logical, intent (out) :: boxed, cnstnd, prjctd
      integer, intent (in) :: iprint, n
      integer, dimension (n), intent (in) :: nbd
      integer, dimension (n), intent (out) :: iwhere
      double precision, dimension (n), intent (in) :: l, u
      double precision, dimension (n), intent (inout) :: x
      integer :: i, nbdd
    !
    !     Initialize nbdd, prjctd, cnstnd and boxed.
    !
      nbdd = 0
      prjctd = .false.
      cnstnd = .false.
      boxed = .true.
    !
    !     Project the initial x to the easible set if necessary.
    !
      do i = 1, n
        if (nbd(i) > 0) then
          if (nbd(i) <= 2 .and. x(i) <= l(i)) then
            if (x(i) < l(i)) then
              prjctd = .true.
              x(i) = l(i)
            end if
            nbdd = nbdd + 1
          else if (nbd(i) >= 2 .and. x(i) >= u(i)) then
            if (x(i) > u(i)) then
              prjctd = .true.
              x(i) = u(i)
            end if
            nbdd = nbdd + 1
          end if
        end if
      end do
    !
    !     Initialize iwhere and assign values to cnstnd and boxed.
    !
      do i = 1, n
        if (nbd(i) /= 2) then
          boxed = .false.
        end if
        if (nbd(i) == 0) then
          !                                this variable is always free
          iwhere (i) = -1 !
          !           otherwise set x(i)=mid(x(i), u(i), l(i)).
        else
          cnstnd = .true.
          if (nbd(i) == 2 .and. u(i)-l(i) <= zero) then
             !                   this variable is always fixed
            iwhere(i) = 3
          else
            iwhere(i) = 0
          end if
        end if
      end do
    !
      if (iprint >= 0) then
        if (prjctd) then
          write (iw,*) "The initial X is infeasible.  Restart with its projection."
        end if
        if ( .not. cnstnd) then
          write (iw,*) "This problem is unconstrained."
        end if
      end if
    !
      if (iprint > 0) then
       !
10000   format (/, "At X0 ", i9, " variables are exactly at the bounds")
        write (iw, 10000) nbdd
      end if
    !
    end subroutine active
  !
  !======================= The end of active =============================
    subroutine bmv (m, sy, wt, col, v, p, info)
      implicit none
      integer, intent (in) :: col, m
      integer, intent (inout) :: info
      double precision, dimension (2*col), intent (in) :: v
      double precision, dimension (2*col), intent (inout) :: p
      double precision, dimension (m, m), intent (in) :: sy
      double precision, dimension (m, m), intent (inout) :: wt
      integer :: i, i2, k
      double precision :: sum
      if (col == 0) return
    !     PART I: solve [  D^(1/2)      O ] [ p1 ] = [ v1 ]
    !                   [ -L*D^(-1/2)   J ] [ p2 ]   [ v2 ].
    !
    !       solve Jp2=v2+LD^(-1)v1.
      p(col+1) = v(col+1)
      do i = 2, col
        i2 = col + i
        sum = 0.0d0
        do k = 1, i - 1
          sum = sum + sy(i, k) * v(k) / sy(k, k)
        end do
        p(i2) = v(i2) + sum
      end do
    !     Solve the triangular system
      call dtrsl (wt, m, col, p(col+1), 11, info)
      if (info /= 0) return
    !       solve D^(1/2)p1=v1.
      do i = 1, col
        p(i) = v(i) / Sqrt (sy(i, i))
      end do
    !     PART II: solve [ -D^(1/2)   D^(-1/2)*L'  ] [ p1 ] = [ p1 ]
    !                    [  0         J'           ] [ p2 ]   [ p2 ].
    !       solve J^Tp2=p2.
      call dtrsl (wt, m, col, p(col+1), 1, info)
      if (info /= 0) return
    !       compute p1=-D^(-1/2)(p1-D^(-1/2)L'p2)
    !                 =-D^(-1/2)p1+D^(-1)L'p2.
      do i = 1, col
        p(i) = -p(i) / Sqrt (sy(i, i))
      end do
      do i = 1, col
        sum = 0.d0
        do k = i + 1, col
          sum = sum + sy(k, i) * p(col+k) / sy(i, i)
        end do
        p(i) = p(i) + sum
      end do
    !
    end subroutine bmv
  !
  !======================== The end of bmv ===============================
  !
    subroutine cauchy (n, x, l, u, nbd, g, iorder, iwhere, t, d, xcp, m, wy, &
   & ws, sy, wt, theta, col, head, p, c, wbp, v, nint, iprint, sbgnrm, info, &
   & epsmch)
      use chanel_C, only: iw
      implicit none
      double precision, parameter :: one = 1.0d0
      double precision, parameter :: zero = 0.0d0
      integer, intent (in) :: head, iprint, m, n
      integer, intent (inout) :: col, info
      integer, intent (out) :: nint
      double precision, intent (in) :: epsmch, sbgnrm
      double precision, intent (inout) :: theta
      integer, dimension (n), intent (in) :: nbd
      integer, dimension (n), intent (inout) :: iorder, iwhere
      double precision, dimension (2*m), intent (inout) :: c, p, v, wbp
      double precision, dimension (n), intent (in) :: g, l, u
      double precision, dimension (n), intent (inout) :: d, t, x, xcp
      double precision, dimension (m, m), intent (in) :: sy
      double precision, dimension (m, m), intent (inout) :: wt
      double precision, dimension (n, col), intent (in) :: ws, wy
      logical :: bnded, xlower, xupper
      integer :: col2, i, ibkmin, ibp, iter, j, nbreak, nfree, nleft, pointr
      double precision :: bkmin, dibp, dibp2, dt, dtm, f1, f2, f2_org, neggi, &
     & tj, tj0, tl, tsum, tu, wmc, wmp, wmw, zibp
      external daxpy, dcopy, dscal
      double precision, external :: ddot
      tl = 0.d0
      tu = 0.d0
    !
    !     Check the status of the variables, reset iwhere(i) if necessary;
    !       compute the Cauchy direction d and the breakpoints t; initialize
    !       the derivative f1 and the vector p = W'd (for theta = 1).
      if (sbgnrm <= zero) then
        if (iprint >= 0) then
          write (iw,*) "Subgnorm = 0.  GCP = X."
        end if
        call dcopy (n, x, 1, xcp, 1)
      else
        bnded = .true.
        nfree = n + 1
        nbreak = 0
        ibkmin = 0
        bkmin = zero
        col2 = 2 * col
        f1 = zero
        if (iprint >= 99) then
10000     format (/, "---------------- CAUCHY entered-------------------")
          write (iw, 10000)
        end if
       !
       !     We set p to zero and build it up as we determine d.
       !
        do i = 1, col2
          p(i) = zero
        end do
       !
       !     In the following loop we determine for each variable its bound
       !        status and its breakpoint, and update p accordingly.
       !        Smallest breakpoint is identified.
       !
        do i = 1, n
          neggi = -g(i)
          if (iwhere(i) /= 3 .and. iwhere(i) /=-1) then
             !             if x(i) is not a constant and has bounds,
             !             compute the difference between x(i) and its bounds.
            if (nbd(i) <= 2) then
              tl = x(i) - l(i)
            end if
            if (nbd(i) >= 2) then
              tu = u(i) - x(i)
            end if
             !
             !           If a variable is close enough to a bound
             !             we treat it as at bound.
            xlower = nbd(i) <= 2 .and. tl <= zero
            xupper = nbd(i) >= 2 .and. tu <= zero
             !
             !              reset iwhere(i).
            iwhere(i) = 0
            if (xlower) then
              if (neggi <= zero) then
                iwhere(i) = 1
              end if
            else if (xupper) then
              if (neggi >= zero) then
                iwhere(i) = 2
              end if
            else if (Abs (neggi) <= zero) then
              iwhere(i) = -3
            end if
          end if
          pointr = head
          if (iwhere(i) /= 0 .and. iwhere(i) /=-1) then
            d(i) = zero
          else
            d(i) = neggi
            f1 = f1 - neggi * neggi
             !             calculate p := p - W'e_i* (g_i).
            do j = 1, col
              p(j) = p(j) + wy(i, pointr) * neggi
              p(col+j) = p(col+j) + ws(i, pointr) * neggi
              pointr = Mod (pointr, m) + 1
            end do
            if (nbd(i) <= 2 .and. nbd(i) /= 0 .and. neggi < zero) then
                !            x(i) + d(i) is bounded; compute t(i).
              nbreak = nbreak + 1
              iorder(nbreak) = i
              t(nbreak) = tl / (-neggi)
              if (nbreak == 1 .or. t(nbreak) < bkmin) then
                bkmin = t(nbreak)
                ibkmin = nbreak
              end if
            else if (nbd(i) >= 2 .and. neggi > zero) then
                !             x(i) + d(i) is bounded; compute t(i).
              nbreak = nbreak + 1
              iorder(nbreak) = i
              t(nbreak) = tu / neggi
              if (nbreak == 1 .or. t(nbreak) < bkmin) then
                bkmin = t(nbreak)
                ibkmin = nbreak
              end if
            else
                !                x(i) + d(i) is not bounded.
              nfree = nfree - 1
              iorder(nfree) = i
              if (Abs (neggi) > zero) then
                bnded = .false.
              end if
            end if
          end if
        end do
       !     The indices of the nonzero components of d are now stored
       !       in iorder(1),...,iorder(nbreak) and iorder(nfree),...,iorder(n).
       !       The smallest of the nbreak breakpoints is in t(ibkmin)=bkmin.
        if (abs(theta - one) > 1.d-20) then
          !    complete the initialization of p for theta not= one.
          call dscal (col, theta, p(col+1), 1)
        end if
       !     Initialize GCP xcp = x.
       !
        call dcopy (n, x, 1, xcp, 1)
       !
        if (nbreak == 0 .and. nfree == n+1) then
          !      is a zero vector, return with the initial xcp as GCP.
          if (iprint > 100) then
             !
10010       format ("Cauchy X =  ",/, (4 x, 1 p, 6(1 x, d11.4)))
            write (iw, 10010) (xcp(i), i=1, n)
          end if
        else
          !     Initialize c = W'(xcp - x) = 0.
          do j = 1, col2
            c(j) = zero
          end do
          !     Initialize derivative f2.
          f2 = -theta * f1
          f2_org = f2
          if (col > 0) then
            call bmv (m, sy, wt, col, p, v, info)
            if (info /= 0) return
            f2 = f2 - ddot (col2, v, 1, p, 1)
          end if
          dtm = -f1 / f2
          tsum = zero
          nint = 1
          if (iprint >= 99) then
            write (iw,*) "There are ", nbreak, "  breakpoints "
          end if
          !     If there are no breakpoints, locate the GCP and return.
          if (nbreak /= 0) then
            nleft = nbreak
            iter = 1
            tj = zero
            do
              !     Find the next smallest breakpoint;
              !       compute dt = t(nleft) - t(nleft + 1).
              !------------------- the beginning of the loop ------------
              tj0 = tj
              if (iter == 1) then
                ! Since we already have the smallest breakpoint we need not do
                ! heapsort yet. Often only one breakpoint is used and the
                ! cost of heapsort is avoided.
                tj = bkmin
                ibp = iorder(ibkmin)
              else
                if (iter == 2) then
                  ! Replace the already used smallest breakpoint with the
                  ! breakpoint numbered nbreak > nlast, before heapsort call.
                  if (ibkmin /= nbreak) then
                    t(ibkmin) = t(nbreak)
                    iorder(ibkmin) = iorder(nbreak)
                  end if
                end if
                call hpsolb (nleft, t, iorder, iter-2)
                tj = t(nleft)
                ibp = iorder(nleft)
              end if
              dt = tj - tj0
              if (dt /= zero .and. iprint >= 100) then
10020           format (/, "Piece    ", i3, " --f1, f2 at start point ", 1 p, &
               & 2(1 x, d11.4))
                write (iw, 10020) nint, f1, f2
10030           format ("Distance to the next break point =  ", 1 p, d11.4)
                write (iw, 10030) dt
10040           format ("Distance to the stationary point =  ", 1 p, d11.4)
                write (iw, 10040) dtm
              end if
                !     If a minimizer is within this interval,
                !       locate the GCP and return.
              if (dtm < dt) go to 1100
                !     Otherwise fix one variable and
                !       reset the corresponding component of d to zero.
              tsum = tsum + dt
              nleft = nleft - 1
              iter = iter + 1
              dibp = d(ibp)
              d(ibp) = zero
              if (dibp > zero) then
                zibp = u(ibp) - x(ibp)
                xcp(ibp) = u(ibp)
                iwhere(ibp) = 2
              else
                zibp = l(ibp) - x(ibp)
                xcp(ibp) = l(ibp)
                iwhere(ibp) = 1
              end if
              if (iprint >= 100) then
                write (iw,*) "Variable  ", ibp, "  is fixed."
              end if
              if (nleft == 0 .and. nbreak == n) exit
                !     Update the derivative information.
              nint = nint + 1
              dibp2 = dibp ** 2
                !     Update f1 and f2.
                !        temporarily set f1 and f2 for col=0.
              f1 = f1 + dt * f2 + dibp2 - theta * dibp * zibp
              f2 = f2 - theta * dibp2
                !
              if (col > 0) then
                   !                          update c = c + dt*p.
                call daxpy (col2, dt, p, 1, c, 1)
                ! choose wbp,
                ! the row of W corresponding to the breakpoint encountered.
                pointr = head
                do j = 1, col
                  wbp(j) = wy(ibp, pointr)
                  wbp(col+j) = theta * ws(ibp, pointr)
                  pointr = Mod (pointr, m) + 1
                end do
                   !           compute (wbp)Mc, (wbp)Mp, and (wbp)M(wbp)'.
                call bmv (m, sy, wt, col, wbp, v, info)
                if (info /= 0) return
                wmc = ddot (col2, c, 1, v, 1)
                wmp = ddot (col2, p, 1, v, 1)
                wmw = ddot (col2, wbp, 1, v, 1)
                   !           update p = p - dibp*wbp.
                call daxpy (col2,-dibp, wbp, 1, p, 1)
                   !           complete updating f1 and f2 while col > 0.
                f1 = f1 + dibp * wmc
                f2 = f2 + 2.0d0 * dibp * wmp - dibp2 * wmw
              end if
                !
              f2 = Max (epsmch*f2_org, f2)
              if (nleft > 0) then
                dtm = -f1 / f2
              else
                go to 1000
              end if
            end do
            !        all n variables are fixed,
            !        return with xcp as GCP.
            dtm = dt
            go to 1200
             !                 to repeat the loop for unsearched intervals.
1000        if (bnded) then
              f1 = zero
              f2 = zero
              dtm = zero
            else
              dtm = -f1 / f2
            end if
          end if
          !
          !------------------- the end of the loop -------------------
1100      if (iprint >= 99) then
            write (iw,*)
            write (iw,*) "GCP found in this segment"
10050       format ("Piece    ", i3, " --f1, f2 at start point ", 1 p, 2(1 x, &
           & d11.4))
            write (iw, 10050) nint, f1, f2
            write (iw, 10040) dtm
          end if
          if (dtm <= zero) then
            dtm = zero
          end if
          tsum = tsum + dtm
          !     Move free variables (i.e., the ones w/o breakpoints) and
          !       the variables whose breakpoints haven't been reached.
          call daxpy (n, tsum, d, 1, xcp, 1)
          !     Update c = c + dtm*p = W'(x^c - x)
          !       which will be used in computing r = Z'(B(x^c - x) + g).
1200      if (col > 0) then
            call daxpy (col2, dtm, p, 1, c, 1)
          end if
          if (iprint > 100) then
            write (iw, 10010) (xcp(i), i=1, n)
          end if
          if (iprint >= 99) then
10060       format (/, "---------------- exit CAUCHY----------------------", &
           & /)
            write (iw, 10060)
          end if
        end if
      end if
    end subroutine cauchy
  !
  !====================== The end of cauchy ==============================
  !
    subroutine cmprlb (n, m, x, g, ws, wy, sy, wt, z, r, wa, index, theta, &
   & col, head, nfree, cnstnd, info)
      implicit none
      logical, intent (in) :: cnstnd
      integer, intent (in) :: col, head, m, n, nfree
      integer, intent (inout) :: info
      double precision, intent (in) :: theta
      integer, dimension (n), intent (in) :: index
      double precision, dimension (4*m), intent (inout) :: wa
      double precision, dimension (n), intent (in) :: g, x, z
      double precision, dimension (n), intent (inout) :: r
      double precision, dimension (m, m), intent (in) :: sy
      double precision, dimension (m, m), intent (inout) :: wt
      double precision, dimension (n, m), intent (in) :: ws, wy
      integer :: i, j, k, pointr
      double precision :: a1, a2
      intrinsic Mod
      if ( .not. cnstnd .and. col > 0) then
        do i = 1, n
          r(i) = -g(i)
        end do
      else
        do i = 1, nfree
          k = Index(i)
          r(i) = -theta * (z(k)-x(k)) - g(k)
        end do
        call bmv (m, sy, wt, col, wa(2*m+1), wa(1), info)
        if (info /= 0) then
          info = -8
          return
        end if
        pointr = head
        do j = 1, col
          a1 = wa(j)
          a2 = theta * wa(col+j)
          do i = 1, nfree
            k = Index(i)
            r(i) = r(i) + wy(k, pointr) * a1 + ws(k, pointr) * a2
          end do
          pointr = Mod (pointr, m) + 1
        end do
      end if
    !
    end subroutine cmprlb
  !
  !======================= The end of cmprlb =============================
  !
    subroutine errclb (n, m, factr, l, u, nbd, task, info, k)
      implicit none
      double precision, parameter :: zero = 0.0d0
      character (len=60), intent (inout) :: task
      integer, intent (in) :: m, n
      integer, intent (inout) :: info
      integer, intent (out) :: k
      double precision, intent (in) :: factr
      integer, dimension (n), intent (in) :: nbd
      double precision, dimension (n), intent (in) :: l, u
      integer :: i
    !
    !     Check the input arguments for errors.
    !
      if (n <= 0) then
        task = "ERROR: N .LE. 0"
      end if
      if (m <= 0) then
        task = "ERROR: M .LE. 0"
      end if
      if (factr < zero) then
        task = "ERROR: FACTR .LT. 0"
      end if
    !
    !     Check the validity of the arrays nbd(i), u(i), and l(i).
    !
      do i = 1, n
        if (nbd(i) < 0 .or. nbd(i) > 3) then
          !                                                   return
          task = "ERROR: INVALID NBD"
          info = -6
          k = i
        end if
        if (nbd(i) == 2) then
          if (l(i) > u(i)) then
             !                                    return
            task = "ERROR: NO FEASIBLE SOLUTION"
            info = -7
            k = i
          end if
        end if
      end do
    !
    end subroutine errclb
  !
  !======================= The end of errclb =============================
    subroutine formk (n, nsub, ind, nenter, ileave, indx2, iupdat, updatd, wn, &
   & wn1, m, ws, wy, sy, theta, col, head, info)
    !
      implicit none
      double precision, parameter :: zero = 0.0d0
      logical, intent (in) :: updatd
      integer, intent (in) :: head, ileave, iupdat, m, n, nenter, nsub
      integer, intent (inout) :: col
      integer, intent (inout) :: info
      double precision, intent (in) :: theta
      integer, dimension (n), intent (in) :: ind, indx2
      double precision, dimension (2*m, 2*m), intent (inout) :: wn, wn1
      double precision, dimension (m, m), intent (in) :: sy
      double precision, dimension (n, m), intent (in) :: ws, wy
      integer :: col2, dbegin, dend, i, ipntr, is, is1, iy, jpntr, js, js1, &
     & jy, k, k1, m2, pbegin, pend, upcl
      double precision :: temp1, temp2, temp3, temp4
      external dcopy
      double precision, external :: ddot
    !
    !     Form the lower triangular part of
    !               WN1 = [Y' ZZ'Y   L_a'+R_z']
    !                     [L_a+R_z   S'AA'S   ]
    !        where L_a is the strictly lower triangular part of S'AA'Y
    !              R_z is the upper triangular part of S'ZZ'Y.
      if (updatd) then
        if (iupdat > m) then
          !                                 shift old part of WN1.
          do jy = 1, m - 1
            js = m + jy
            call dcopy (m-jy, wn1(jy+1, jy+1), 1, wn1(jy, jy), 1)
            call dcopy (m-jy, wn1(js+1, js+1), 1, wn1(js, js), 1)
            call dcopy (m-1, wn1(m+2, jy+1), 1, wn1(m+1, jy), 1)
          end do
        end if
       !          put new rows in blocks (1,1), (2,1) and (2,2).
        pbegin = 1
        pend = nsub
        dbegin = nsub + 1
        dend = n
        iy = col
        is = m + col
        ipntr = head + col - 1
        if (ipntr > m) then
          ipntr = ipntr - m
        end if
        jpntr = head
        do jy = 1, col
          js = m + jy
          temp1 = zero
          temp2 = zero
          temp3 = zero
          !             compute element jy of row 'col' of Y'ZZ'Y
          do k = pbegin, pend
            k1 = ind(k)
            temp1 = temp1 + wy(k1, ipntr) * wy(k1, jpntr)
          end do
          !             compute elements jy of row 'col' of L_a and S'AA'S
          do k = dbegin, dend
            k1 = ind(k)
            temp2 = temp2 + ws(k1, ipntr) * ws(k1, jpntr)
            temp3 = temp3 + ws(k1, ipntr) * wy(k1, jpntr)
          end do
          wn1(iy, jy) = temp1
          wn1(is, js) = temp2
          wn1(is, jy) = temp3
          jpntr = Mod (jpntr, m) + 1
        end do
       !          put new column in block (2,1).
        jy = col
        jpntr = head + col - 1
        if (jpntr > m) then
          jpntr = jpntr - m
        end if
        ipntr = head
        do i = 1, col
          is = m + i
          temp3 = zero
          !             compute element i of column 'col' of R_z
          do k = pbegin, pend
            k1 = ind(k)
            temp3 = temp3 + ws(k1, ipntr) * wy(k1, jpntr)
          end do
          ipntr = Mod (ipntr, m) + 1
          wn1(is, jy) = temp3
        end do
        upcl = col - 1
      else
        upcl = col
      end if
    !       modify the old parts in blocks (1,1) and (2,2) due to changes
    !       in the set of free variables.
      ipntr = head
      do iy = 1, upcl
        is = m + iy
        jpntr = head
        do jy = 1, iy
          js = m + jy
          temp1 = zero
          temp2 = zero
          temp3 = zero
          temp4 = zero
          do k = 1, nenter
            k1 = indx2(k)
            temp1 = temp1 + wy(k1, ipntr) * wy(k1, jpntr)
            temp2 = temp2 + ws(k1, ipntr) * ws(k1, jpntr)
          end do
          do k = ileave, n
            k1 = indx2(k)
            temp3 = temp3 + wy(k1, ipntr) * wy(k1, jpntr)
            temp4 = temp4 + ws(k1, ipntr) * ws(k1, jpntr)
          end do
          wn1(iy, jy) = wn1(iy, jy) + temp1 - temp3
          wn1(is, js) = wn1(is, js) - temp2 + temp4
          jpntr = Mod (jpntr, m) + 1
        end do
        ipntr = Mod (ipntr, m) + 1
      end do
    !       modify the old parts in block (2,1).
      ipntr = head
      do is = m + 1, m + upcl
        jpntr = head
        do jy = 1, upcl
          temp1 = zero
          temp3 = zero
          do k = 1, nenter
            k1 = indx2(k)
            temp1 = temp1 + ws(k1, ipntr) * wy(k1, jpntr)
          end do
          do k = ileave, n
            k1 = indx2(k)
            temp3 = temp3 + ws(k1, ipntr) * wy(k1, jpntr)
          end do
          if (is <= jy+m) then
            wn1(is, jy) = wn1(is, jy) + temp1 - temp3
          else
            wn1(is, jy) = wn1(is, jy) - temp1 + temp3
          end if
          jpntr = Mod (jpntr, m) + 1
        end do
        ipntr = Mod (ipntr, m) + 1
      end do
    !     Form the upper triangle of WN = [D+Y' ZZ'Y/theta   -L_a'+R_z' ]
    !                                     [-L_a +R_z        S'AA'S*theta]
    !
      m2 = 2 * m
      do iy = 1, col
        is = col + iy
        is1 = m + iy
        do jy = 1, iy
          js = col + jy
          js1 = m + jy
          wn(jy, iy) = wn1(iy, jy) / theta
          wn(js, is) = wn1(is1, js1) * theta
        end do
        do jy = 1, iy - 1
          wn(jy, is) = -wn1(is1, jy)
        end do
        do jy = iy, col
          wn(jy, is) = wn1(is1, jy)
        end do
        wn(iy, iy) = wn(iy, iy) + sy(iy, iy)
      end do
    !
    !     Form the upper triangle of
    !          WN= [  LL'            L^-1(-L_a'+R_z')]
    !              [(-L_a +R_z)L'^-1   S'AA'S*theta  ]
    !
    !        first Cholesky factor (1,1) block of wn to get LL'
    !                          with L' stored in the upper triangle of wn.
      call dpofa (wn, m2, col, info)
      if (info /= 0) then
        info = -1
        return
      end if
    !        then form L^-1(-L_a'+R_z') in the (1,2) block.
      col2 = 2 * col
      do js = col + 1, col2
        call dtrsl (wn, m2, col, wn(1, js), 11, info)
      end do
    !
    !     Form S'AA'S*theta + (L^-1(-L_a'+R_z'))'L^-1(-L_a'+R_z') in the
    !        upper triangle of (2,2) block of wn.
    !
      do is = col + 1, col2
        do js = is, col2
          wn(is, js) = wn(is, js) + ddot (col, wn(1, is), 1, wn(1, js), 1)
        end do
      end do
    !
    !     Cholesky factorization of (2,2) block of wn.
    !
      call dpofa (wn(col+1, col+1), m2, col, info)
    !
      if (info /= 0) then
        info = -2
      end if
    !
    end subroutine formk
  !
  !======================= The end of formk ==============================
  !
    subroutine formt (m, wt, sy, ss, col, theta, info)
      implicit none
      double precision, parameter :: zero = 0.0d0
      integer, intent (in) :: col, m
      integer, intent (inout) :: info
      double precision, intent (in) :: theta
      double precision, dimension (m, m), intent (in) :: ss, sy
      double precision, dimension (m, m), intent (inout) :: wt
      integer :: i, j, k, k1
      double precision :: ddum
      intrinsic Min
    !
    !
    !     Form the upper half of  T = theta*SS + L*D^(-1)*L',
    !        store T in the upper triangle of the array wt.
      do j = 1, col
        wt(1, j) = theta * ss (1, j)
      end do
      do i = 2, col
        do j = i, col
          k1 = Min (i, j) - 1
          ddum = zero
          do k = 1, k1
            ddum = ddum + sy(i, k) * sy(j, k) / sy(k, k)
          end do
          wt(i, j) = ddum + theta * ss (i, j)
        end do
      end do
    !     Cholesky factorize T to J*J' with
    !        J' stored in the upper triangle of wt.
      call dpofa (wt, m, col, info)
    !
      if (info /= 0) then
        info = -3
      end if
    !
    end subroutine formt
  !
  !======================= The end of formt ==============================
    subroutine freev (n, nfree, index, nenter, ileave, indx2, iwhere, wrk, &
   & updatd, cnstnd, iprint, iter)
      use chanel_C, only: iw
    !
      implicit none
      logical, intent (in) :: cnstnd, updatd
      logical, intent (out) :: wrk
      integer, intent (in) :: iprint, iter, n
      integer, intent (inout) :: nfree
      integer, intent (out) :: ileave, nenter
      integer, dimension (n), intent (in) :: iwhere
      integer, dimension (n), intent (inout) :: index
      integer, dimension (n), intent (out) :: indx2
      integer :: i, iact, k
    !
    !
      nenter = 0
      ileave = n + 1
      if (iter > 0 .and. cnstnd) then
       !                           count the entering and leaving variables.
        do i = 1, nfree
          k = Index(i)
          if (iwhere(k) > 0) then
            ileave = ileave - 1
            indx2(ileave) = k
            if (iprint >= 100) then
              write (iw,*) "Variable ", k, " leaves the set of free variables"
            end if
          end if
        end do
        do i = 1 + nfree, n
          k = Index(i)
          if (iwhere(k) <= 0) then
            nenter = nenter + 1
            indx2(nenter) = k
            if (iprint >= 100) then
              write (iw,*) "Variable ", k, " enters the set of free variables"
            end if
          end if
        end do
        if (iprint >= 99) then
          write (iw,*) n + 1 - ileave, " variables leave; ", nenter, &
         & " variables enter"
        end if
      end if
      wrk = (ileave < n+1) .or. (nenter > 0) .or. updatd
    !     Find the index set of free and active variables at the GCP.
      nfree = 0
      iact = n + 1
      do i = 1, n
        if (iwhere(i) <= 0) then
          nfree = nfree + 1
          Index(nfree) = i
        else
          iact = iact - 1
          Index(iact) = i
        end if
      end do
    !
      if (iprint >= 99) then
        write (iw,*) nfree, " variables are free at GCP ", iter + 1
      end if
    !
    end subroutine freev
  !
  !======================= The end of freev ==============================
  !
    subroutine hpsolb (n, t, iorder, iheap)
      implicit none
      integer, intent (in) :: n
      double precision, dimension (n), intent (inout) :: t
      integer, dimension (n), intent (inout) :: iorder
      integer, intent (in) :: iheap
      integer :: i, indxin, indxou, j, k
      double precision :: ddum, out
    !
      if (iheap == 0) then
       !
       !        Rearrange the elements t(1) to t(n) to form a heap.
       !
        do k = 2, n
          ddum = t(k)
          indxin = iorder(k)
          !
          !           Add ddum to the heap.
          i = k
          do while (i >  1)
            j = i / 2
            if (ddum < t(j)) then
              t(i) = t(j)
              iorder(i) = iorder(j)
              i = j
            else
              exit
            end if
          end do
          t(i) = ddum
          iorder(i) = indxin
        end do
      end if
    !     Assign to 'out' the value of t(1), the least member of the heap,
    !        and rearrange the remaining members to form a heap as
    !        elements 1 to n-1 of t.
      if (n <= 1) return
    !
      i = 1
      out = t(1)
      indxou = iorder(1)
      ddum = t(n)
      indxin = iorder(n)
      do
       !
       !        Restore the heap
        j = i + i
        if (j > n-1) exit
        if (t(j+1) < t(j)) then
          j = j + 1
        end if
        if (t(j) < ddum) then
          t(i) = t(j)
          iorder(i) = iorder(j)
          i = j
        else
          exit
        end if
      end do
      t(i) = ddum
      iorder(i) = indxin
    !     Put the least member in t(n).
    !
      t(n) = out
      iorder(n) = indxou
    !
    end subroutine hpsolb
  !
  !====================== The end of hpsolb ==============================
  !
    subroutine lnsrlb (n, l, u, nbd, x, f, fold, gd, gdold, g, d, r, t, z, &
   & stp, dnorm, dtd, xstep, stpmx, iter, ifun, iback, nfgv, info, task, &
   & boxed, cnstnd, csave, isave, dsave)
    !
      implicit none
      double precision, parameter :: one = 1.0d0
      double precision, parameter :: zero = 0.0d0
      double precision, parameter :: big = 1.d-5
      double precision, parameter :: ftol = 1.0d-3
      double precision, parameter :: gtol = 0.9d0
      double precision, parameter :: xtol = 0.1d0
      character (len=60), intent (inout) :: csave, task
      logical, intent (in) :: boxed, cnstnd
      integer, intent (in) :: iter, n
      integer, intent (inout) :: ifun, nfgv
      integer, intent (inout) :: info, iback
      double precision, intent (in) :: f
      double precision, intent (inout) :: dnorm, stp, stpmx
      double precision, intent (inout) :: dtd, fold, gd, gdold, xstep
      integer, dimension (2), intent (inout) :: isave
      integer, dimension (n), intent (in) :: nbd
      double precision, dimension (13), intent (inout) :: dsave
      double precision, dimension (n), intent (in) :: l, u
      double precision, dimension (n), intent (inout) :: d, g, r, t, x, z
      integer :: i
      double precision :: a1, a2
      external dcopy
      double precision, external :: ddot
    !
    !
      if (task(1:5) /= "FG_LN") then
       !
        dtd = ddot (n, d, 1, d, 1)
        dnorm = Sqrt (dtd)
       !
       !     Determine the maximum step length.
       !
        stpmx = big
        if (cnstnd) then
          if (iter == 0) then
            stpmx = one
          else
            do i = 1, n
              a1 = d(i)
              if (nbd(i) /= 0) then
                if (a1 < zero .and. nbd(i) <= 2) then
                  a2 = l(i) - x(i)
                  if (a2 >= zero) then
                    stpmx = zero
                  else if (a1*stpmx < a2) then
                    stpmx = a2 / a1
                  end if
                else if (a1 > zero .and. nbd(i) >= 2) then
                  a2 = u(i) - x(i)
                  if (a2 <= zero) then
                    stpmx = zero
                  else if (a1*stpmx > a2) then
                    stpmx = a2 / a1
                  end if
                end if
              end if
            end do
          end if
        end if
        if (iter == 0 .and. .not. boxed) then
          stp = Min (one/dnorm, stpmx)
        else
          stp = one
        end if
       !
        call dcopy (n, x, 1, t, 1)
        call dcopy (n, g, 1, r, 1)
        fold = f
        ifun = 0
        iback = 0
        csave = "START"
      end if
      gd = ddot (n, g, 1, d, 1)
      if (ifun == 0) then
        gdold = gd
        if (gd >= zero) then
          !                               the directional derivative >=0.
          !                               Line search is impossible.
          info = -4
          return
        end if
      end if
    !
      call dcsrch (f, gd, stp, ftol, gtol, xtol, zero, stpmx, csave, isave, &
     & dsave)
    !
      xstep = stp * dnorm
    !
      if (csave(1:4) == "CONV" .or. csave(1:4) == "WARN") then
        task = "NEW_X"
        return
      end if
      task = "FG_LNSRCH"
      ifun = ifun + 1
      nfgv = nfgv + 1
      iback = ifun - 1
      if (Abs(stp - one) < 1.d-20) then
        call dcopy (n, z, 1, x, 1)
      else
        do i = 1, n
          x(i) = stp * d(i) + t(i)
        end do
      end if
    !
    end subroutine lnsrlb
  !
  !======================= The end of lnsrlb =============================
  !
    subroutine matupd (n, m, ws, wy, sy, ss, d, r, itail, iupdat, col, head, &
   & theta, rr, dr, stp, dtd)
      implicit none
      double precision, parameter :: one = 1.0d0
      integer, intent (in) :: iupdat, m, n
      integer, intent (inout) :: col, head, itail
      double precision, intent (in) :: dr, dtd, rr, stp
      double precision, intent (out) :: theta
      double precision, dimension (n), intent (inout) :: d, r
      double precision, dimension (m, m), intent (inout) :: ss, sy
      double precision, dimension (n, m), intent (inout) :: ws, wy
      integer :: j, pointr
      external dcopy
      double precision, external :: ddot
      intrinsic Mod
    !
    !
    !     Set pointers for matrices WS and WY.
      if (iupdat <= m) then
        col = iupdat
        itail = Mod (head+iupdat-2, m) + 1
      else
        itail = Mod (itail, m) + 1
        head = Mod (head, m) + 1
      end if
    !     Update matrices WS and WY.
    !
      call dcopy (n, d, 1, ws(1, itail), 1)
      call dcopy (n, r, 1, wy(1, itail), 1)
    !     Set theta=yy/ys.
      theta = rr / dr
    !     Form the middle matrix in B.
    !        update the upper triangle of SS,
    !                                         and the lower triangle of SY:
      if (iupdat > m) then
       !                              move old information
        do j = 1, col - 1
          call dcopy (j, ss(2, j+1), 1, ss(1, j), 1)
          call dcopy (col-j, sy(j+1, j+1), 1, sy(j, j), 1)
        end do
      end if
    !        add new information: the last row of SY
    !                                             and the last column of SS:
      pointr = head
      do j = 1, col - 1
        sy(col, j) = ddot (n, d, 1, wy(1, pointr), 1)
        ss (j, col) = ddot (n, ws(1, pointr), 1, d, 1)
        pointr = Mod (pointr, m) + 1
      end do
      if (Abs(stp - one) < 1.d-20) then
        ss (col, col) = dtd
      else
        ss (col, col) = stp * stp * dtd
      end if
      sy(col, col) = dr
    !
    end subroutine matupd
  !
  !======================= The end of matupd =============================
  !
    subroutine prn1lb (n, m, l, u, x, iprint, itfile, epsmch)

      use chanel_C, only: iw
      implicit none
      integer, intent (in) :: iprint, itfile, m, n
      double precision, intent (in) :: epsmch
      double precision, dimension (n), intent (in) :: l, u, x
      integer :: i
    !
    !
      if (iprint < 0) return
10000 format ("RUNNING THE L-BFGS-B CODE",/,/, "           * * *",/,/, &
     & "Machine precision =", 1 p, d10.3)
      write (iw, 10000) epsmch
      write (iw,*) "N = ", n, "    M = ", m
      if (iprint >= 1) then
10010   format ("RUNNING THE L-BFGS-B CODE",/,/, &
       & "it    = iteration number"/ &
       & "nf    = number of function evaluations",/, &
       & "nint  = number of segments explored during the Cauchy search",/, &
       & "nact  = number of active bounds at the generalized Cauchy point",/, &
       & "sub   = manner in which the subspace minimization terminated:",/, &
       & "        con = converged, bnd = a bound was reached",/, &
       & "itls  = number of iterations performed in the line search",/, &
       & "stepl = step length used",/, &
       & "tstep = norm of the displacement (total step)",/, &
       & "projg = norm of the projected gradient",/, &
       & "f     = function value",/,/, "           * * *",/,/, &
       & "Machine precision =", 1 p, d10.3)
        write (itfile, 10010) epsmch
        write (itfile,*) "N = ", n, "    M = ", m
10020   format (/, 3 x, "it", 3 x, "nf", 2 x, "nint", 2 x, "nact", 2 x, "sub", &
       & 2 x, "itls", 2 x, "stepl", 4 x, "tstep", 5 x, "projg", 8 x, "f")
        write (itfile, 10020)
        if (iprint > 100) then
          !
10030     format (/, a4, 1 p, 6(1 x, d11.4), /, (4 x, 1 p, 6(1 x, d11.4)))
          write (iw, 10030) "L =", (l(i), i=1, n)
          write (iw, 10030) "X0 =", (x(i), i=1, n)
          write (iw, 10030) "U =", (u(i), i=1, n)
        end if
      end if
    !
    end subroutine prn1lb
  !
  !======================= The end of prn1lb =============================
  !
    subroutine prn2lb (n, x, f, g, iprint, itfile, iter, nfgv, nact, sbgnrm, &
   & nint, word, iword, iback, stp, xstep)

      use chanel_C, only: iw
      implicit none

      character (len=3), intent (out) :: word
      integer, intent (in) :: iback, iprint, iter, itfile, iword, n, nact, &
     & nfgv, nint
      double precision, intent (in) :: f, sbgnrm, stp, xstep
      double precision, dimension (n), intent (in) :: g, x
      integer :: i, imod
    !
    !           'word' records the status of subspace solutions.
      if (iword == 0) then
       !                            the subspace minimization converged.
        word = "con"
      else if (iword == 1) then
       !                          the subspace minimization stopped at a bound.
        word = "bnd"
      else if (iword == 5) then
       !                             the truncated Newton step has been used.
        word = "TNT"
      else
        word = "---"
      end if
      if (iprint >= 99) then
        write (iw,*) "LINE SEARCH", iback, " times; norm of step = ", xstep
10000   format (/, "At iterate", i5, 4 x, "f= ", 1 p, d12.5, 4 x, "|proj g|= ",&
       &  1 p, d12.5)
        write (iw, 10000) iter, f, sbgnrm
        if (iprint > 100) then
          !
10010     format (/, a4, 1 p, 6(1 x, d11.4), /, (4 x, 1 p, 6(1 x, d11.4)))
          write (iw, 10010) "X =", (x(i), i=1, n)
          write (iw, 10010) "G =", (g(i), i=1, n)
        end if
      else if (iprint > 0) then
        imod = Mod (iter, iprint)
        if (imod == 0) then
          write (iw, 10000) iter, f, sbgnrm
        end if
      end if
      if (iprint >= 1) then
10020   format (2(1 x, i4), 2(1 x, i5), 2 x, a3, 1 x, i4, 1 p, 2(2 x, d8.1), &
       & 1 p, 2(1 x, d10.3))
        write (itfile, 10020) iter, nfgv, nint, nact, word, iback, stp, xstep, &
       & sbgnrm, f
      end if
    !
    end subroutine prn2lb
  !
  !======================= The end of prn2lb =============================
  !
    subroutine prn3lb (n, x, f, task, iprint, info, itfile, iter, nfgv, &
   & nintol, nskip, nact, sbgnrm, time, nint, word, iback, stp, xstep, k, &
   & cachyt, sbtime, lnscht)

      use chanel_C, only: iw
      implicit none

      character (len=3), intent (in) :: word
      character (len=60), intent (in) :: task
      integer, intent (in) :: iback, info, iprint, iter, itfile, k, n, nact, &
     & nfgv, nint, nintol, nskip
      double precision, intent (in) :: cachyt, f, lnscht, sbgnrm, sbtime, stp, &
     & time, xstep
      double precision, dimension (n), intent (in) :: x
      integer :: i
    !
    !
      if (task(1:5) /= "ERROR") then
       !
        if (iprint >= 0) then
10000     format (/, "           * * *",/,/, &
         & "Tit   = total number of iterations",/, &
         & "Tnf   = total number of function evaluations",/, &
         & "Tnint = total number of segments explored during Cauchy searches",/, &
         & "Skip  = number of BFGS updates skipped",/, &
         & "Nact  = number of active bounds at final generalized Cauchy point",/, &
         & "Projg = norm of the final projected gradient",/, &
         & "F     = final function value",/,/, &
         & "           * * *")
          write (iw, 10000)
10010     format (/, 3 x, "N", 3 x, "Tit", 2 x, "Tnf", 2 x, "Tnint", 2 x, "Skip", &
         & 2 x, "Nact", 5 x, "Projg", 8 x, "F")
          write (iw, 10010)
10020     format (i5, 2(1 x, i4), (1 x, i6), (2 x, i4), (1 x, i5), 1 p, 2(2 x, &
         & d10.3))
          write (iw, 10020) n, iter, nfgv, nintol, nskip, nact, sbgnrm, f
          if (iprint >= 100) then
             !
10030       format (/, a4, 1 p, 6(1 x, d11.4), /, (4 x, 1 p, 6(1 x, d11.4)))
            write (iw, 10030) "X =", (x(i), i=1, n)
          end if
          if (iprint >= 1) then
            write (iw,*) " F =", f
          end if
        end if
      end if
      if (iprint < 0) return
10040 format (/, a60)
      write (iw, 10040) task
      if (info /= 0) then
        if (info ==-1) then
10050     format (/, " Matrix in 1st Cholesky factorization in formk is not Pos. Def.")
          write (iw, 10050)
        end if
        if (info ==-2) then
10060     format (/, " Matrix in 2st Cholesky factorization in formk is not Pos. Def.")
          write (iw, 10060)
        end if
        if (info ==-3) then
10070     format (/, " Matrix in the Cholesky factorization in formt is not Pos. Def.")
          write (iw, 10070)
        end if
        if (info ==-4) then
10080     format (/, " Derivative >= 0, backtracking line search impossible.",/, &
         & "   Previous x, f and g restored.",/, &
         & " Possible causes: 1 error in function or gradient evaluation;",/, &
         & "                  2 rounding errors dominate computation.")
          write (iw, 10080)
        end if
        if (info ==-5) then
10090     format (/, " Warning:  more than 10 function and gradient",/, &
         & "   evaluations in the last line search.  Termination",/, &
         & "   may possibly be caused by a bad search direction.")
          write (iw, 10090)
        end if
        if (info ==-6) then
          write (iw,*) " Input nbd(", k, ") is invalid."
        end if
        if (info ==-7) then
          write (iw,*) " l(", k, ") > u(", k, ").  No feasible solution."
        end if
        if (info ==-8) then
10100     format (/, " The triangular system is singular.")
          write (iw, 10100)
        end if
        if (info ==-9) then
10110     format (/, " Line search cannot locate an adequate point after 20 function",/, &
         & "  and gradient evaluations.  Previous x, f and g restored.",/, &
         & " Possible causes: 1 error in function or gradient evaluation;",/, &
         & "                  2 rounding error dominate computation.")
          write (iw, 10110)
        end if
      end if
      if (iprint >= 1) then
10120   format (/, " Cauchy                time", 1 p, e10.3, " seconds.",/ &
       & " Subspace minimization time", 1 p, e10.3, " seconds.",/ &
       & " Line search           time", 1 p, e10.3, " seconds.")
        write (iw, 10120) cachyt, sbtime, lnscht
      end if
10130 format (/, " Total User time", 1 p, e10.3, " seconds.", /)
      write (iw, 10130) time
      if (iprint < 1) return
      if (info ==-4 .or. info ==-9) then
10140   format (2(1 x, i4), 2(1 x, i5), 2 x, a3, 1 x, i4, 1 p, 2(2 x, d8.1), &
       & 6 x, "-", 10 x, "-")
        write (itfile, 10140) iter, nfgv, nint, nact, word, iback, stp, xstep
      end if
      write (itfile, 10040) task
      if (info /= 0) then
        if (info ==-1) then
          write (itfile, 10050)
        end if
        if (info ==-2) then
          write (itfile, 10060)
        end if
        if (info ==-3) then
          write (itfile, 10070)
        end if
        if (info ==-4) then
          write (itfile, 10080)
        end if
        if (info ==-5) then
          write (itfile, 10090)
        end if
        if (info ==-8) then
          write (itfile, 10100)
        end if
        if (info ==-9) then
          write (itfile, 10110)
        end if
      end if
      write (itfile, 10130) time
    !
    end subroutine prn3lb
  !
  !======================= The end of prn3lb =============================
  !
    subroutine projgr (n, l, u, nbd, x, g, sbgnrm)
    !
      implicit none
      double precision, parameter :: zero = 0.0d0
      integer, intent (in) :: n
      double precision, intent (out) :: sbgnrm
      integer, dimension (n), intent (in) :: nbd
      double precision, dimension (n), intent (in) :: g, l, u, x
      integer :: i
      double precision :: gi
      intrinsic Abs, Max, Min
    !
    !
      sbgnrm = zero
      do i = 1, n
        gi = g(i)
        if (nbd(i) /= 0) then
          if (gi < zero) then
            if (nbd(i) >= 2) then
              gi = Max ((x(i)-u(i)), gi)
            end if
          else if (nbd(i) <= 2) then
            gi = Min ((x(i)-l(i)), gi)
          end if
        end if
        sbgnrm = Max (sbgnrm, Abs (gi))
      end do
    !
    end subroutine projgr
  !
  !======================= The end of projgr =============================
  !
    subroutine subsm (n, m, nsub, ind, l, u, nbd, x, d, ws, wy, theta, col, &
   & head, iword, wv, wn, iprint, info)

      use chanel_C, only: iw
      implicit none
      double precision, parameter :: one = 1.0d0
      double precision, parameter :: zero = 0.0d0
      integer, intent (in) :: col, head, iprint, m, n, nsub
      integer, intent (inout) :: info
      integer, intent (out) :: iword
      double precision, intent (in) :: theta
      integer, dimension (n), intent (in) :: nbd
      integer, dimension (nsub), intent (in) :: ind
      double precision, dimension (2*m), intent (inout) :: wv
      double precision, dimension (n), intent (in) :: l, u
      double precision, dimension (n), intent (inout) :: d, x
      double precision, dimension (2*m, 2*m), intent (inout) :: wn
      double precision, dimension (n, m), intent (in) :: ws, wy
      integer :: col2, i, ibd, j, js, jy, k, m2, pointr
      double precision :: alpha, dk, temp1, temp2
    !
      ibd = 0
      if (nsub <= 0) return
      if (iprint >= 99) then
       !
10000   format (/, "----------------SUBSM entered-----------------", /)
        write (iw, 10000)
      end if
    !
    !     Compute wv = W'Zd.
    !
      pointr = head
      do i = 1, col
        temp1 = zero
        temp2 = zero
        do j = 1, nsub
          k = ind(j)
          temp1 = temp1 + wy(k, pointr) * d(j)
          temp2 = temp2 + ws(k, pointr) * d(j)
        end do
        wv(i) = temp1
        wv(col+i) = theta * temp2
        pointr = Mod (pointr, m) + 1
      end do
    !     Compute wv:=K^(-1)wv.
    !
      m2 = 2 * m
      col2 = 2 * col
      call dtrsl (wn, m2, col2, wv, 11, info)
      if (info /= 0) return
      do i = 1, col
        wv(i) = -wv(i)
      end do
      call dtrsl (wn, m2, col2, wv, 1, info)
      if (info /= 0) return
    !     Compute d = (1/theta)d + (1/theta**2)Z'W wv.
      pointr = head
      do jy = 1, col
        js = col + jy
        do i = 1, nsub
          k = ind(i)
          d(i) = d(i) + wy(k, pointr) * wv(jy) / theta + ws(k, pointr) * &
         & wv(js)
        end do
        pointr = Mod (pointr, m) + 1
      end do
      do i = 1, nsub
        d(i) = d(i) / theta
      end do
    !     Backtrack to the feasible region.
      alpha = one
      temp1 = alpha
      do i = 1, nsub
        k = ind(i)
        dk = d(i)
        if (nbd(k) /= 0) then
          if (dk < zero .and. nbd(k) <= 2) then
            temp2 = l(k) - x(k)
            if (temp2 >= zero) then
              temp1 = zero
            else if (dk*alpha < temp2) then
              temp1 = temp2 / dk
            end if
          else if (dk > zero .and. nbd(k) >= 2) then
            temp2 = u(k) - x(k)
            if (temp2 <= zero) then
              temp1 = zero
            else if (dk*alpha > temp2) then
              temp1 = temp2 / dk
            end if
          end if
          if (temp1 < alpha) then
            alpha = temp1
            ibd = i
          end if
        end if
      end do
      if (alpha < one) then
        dk = d(ibd)
        k = ind(ibd)
        if (dk > zero) then
          x(k) = u(k)
          d(ibd) = zero
        else if (dk < zero) then
          x(k) = l(k)
          d(ibd) = zero
        end if
      end if
      do i = 1, nsub
        k = ind(i)
        x(k) = x(k) + alpha * d(i)
      end do
      if (iprint >= 99) then
        if (alpha < one) then
10010     format ("ALPHA = ", f8.5, " backtrack to the BOX")
          write (iw, 10010) alpha
        else
          write (iw,*) "SM solution inside the box"
        end if
        if (iprint > 100) then
10020     format ("Subspace solution X =  ",/, (4 x, 1 p, 6(1 x, d11.4)))
          write (iw, 10020) (x(i), i=1, n)
        end if
      end if
      if (alpha < one) then
        iword = 1
      else
        iword = 0
      end if
      if (iprint >= 99) then
10030   format (/, "----------------exit SUBSM --------------------", /)
        write (iw, 10030)
      end if
    !
    end subroutine subsm
  !====================== The end of subsm ===============================
  !
    subroutine dcsrch (f, g, stp, ftol, gtol, xtol, stpmin, stpmax, task, &
   & isave, dsave)
      implicit none
      double precision, parameter :: zero = 0.0d0
      double precision, parameter :: p5 = 0.5d0
      double precision, parameter :: p66 = 0.66d0
      double precision, parameter :: xtrapl = 1.1d0
      double precision, parameter :: xtrapu = 4.0d0
      character (len=*), intent (inout) :: task
      double precision, intent (in) :: f, ftol, g, gtol, stpmax, stpmin, xtol
      double precision, intent (inout) :: stp
      integer, dimension (2), intent (inout) :: isave
      double precision, dimension (13), intent (inout) :: dsave
      logical :: brackt
      integer :: stage
      double precision :: finit, fm, ftest, fx, fxm, fy, fym, ginit, gm, &
     & gtest, gx, gxm, gy, gym, stmax, stmin, stx, sty, width, width1
      intrinsic Abs, Max, Min
    !
    !     Initialization block.
    !
      if (task(1:5) == "START") then
       !
       !        Check the input arguments for errors.
       !
        if (stp < stpmin) then
          task = "ERROR: STP .LT. STPMIN"
        end if !
        if (stp > stpmax) then
          task = "ERROR: STP .GT. STPMAX"
        end if
        if (g >= zero) then
          task = "ERROR: INITIAL G .GE. ZERO"
        end if
        if (ftol < zero) then
          task = "ERROR: FTOL .LT. ZERO"
        end if
        if (gtol < zero) then
          task = "ERROR: GTOL .LT. ZERO"
        end if
        if (xtol < zero) then
          task = "ERROR: XTOL .LT. ZERO"
        end if
        if (stpmin < zero) then
          task = "ERROR: STPMIN .LT. ZERO"
        end if
        if (stpmax < stpmin) then
          task = "ERROR: STPMAX .LT. STPMIN"
        end if
       !
       !        Exit if there are errors on input.
       !
        if (task(1:5) == "ERROR") return
       !
       !        Initialize local variables.
       !
        brackt = .false.
        stage = 1
        finit = f
        ginit = g
        gtest = ftol * ginit
        width = stpmax - stpmin
        width1 = width / p5
       !
       !        The variables stx, fx, gx contain the values of the step,
       !        function, and derivative at the best step.
       !        The variables sty, fy, gy contain the value of the step,
       !        function, and derivative at sty.
       !        The variables stp, f, g contain the values of the step,
       !        function, and derivative at stp.
       !
        stx = 1.d-5
        fx = finit
        gx = ginit
        sty = 1.d-4
        fy = finit
        gy = ginit
        stmin = zero
        stmax = stp + xtrapu * stp
       !
        task = "FG"
      else
       !
       !        Restore local variables.
       !
        if (isave(1) == 1) then
          brackt = .true.
        else
          brackt = .false.
        end if
        stage = isave(2)
        ginit = dsave(1)
        gtest = dsave(2)
        gx = dsave(3)
        gy = dsave(4)
        finit = dsave(5)
        fx = dsave(6)
        fy = dsave(7)
        stx = dsave(8)
        sty = dsave(9)
        stmin = dsave(10)
        stmax = dsave(11)
        width = dsave(12)
        width1 = dsave(13)
       !
       !     If psi(stp) <= 0 and f'(stp) >= 0 for some step, then the
       !     algorithm enters the second stage.
       !
        ftest = finit + stp * gtest
        if (stage == 1 .and. f <= ftest .and. g >= zero) then
          stage = 2
        end if
       !
       !     Test for warnings.
       !
        if (brackt .and. (stp <= stmin .or. stp >= stmax)) then
          task = "WARNING: ROUNDING ERRORS PREVENT PROGRESS"
        end if
        if (brackt .and. stmax-stmin <= xtol*stmax) then
          task = "WARNING: XTOL TEST SATISFIED"
        end if
        if (abs(stp - stpmax) < 1.d-20 .and. f <= ftest .and. g <= gtest) then
          task = "WARNING: STP = STPMAX"
        end if
        if (Abs(stp - stpmin) < 1.d-20 .and. (f > ftest .or. g >= gtest)) then
          task = "WARNING: STP = STPMIN"
        end if
       !
       !     Test for convergence.
       !
        if (f <= ftest .and. Abs (g) <= gtol*(-ginit)) then
          task = "CONVERGENCE"
        end if
       !
       !     Test for termination.
       !
        if (task(1:4) /= "WARN" .and. task(1:4) /= "CONV") then
          !
          !     A modified function is used to predict the step during the
          !     first stage if a lower function value has been obtained but
          !     the decrease is not sufficient.
          !
          if (stage == 1 .and. f <= fx .and. f > ftest) then
             !
             !        Define the modified function and derivative values.
             !
            fm = f - stp * gtest !
            fxm = fx - stx * gtest
            fym = fy - sty * gtest
            gm = g - gtest
            gxm = gx - gtest
            gym = gy - gtest
             !
             !        Call dcstep to update stx, sty, and to compute the new step.
             !
            call dcstep (stx, fxm, gxm, sty, fym, gym, stp, fm, gm, brackt, &
           & stmin, stmax)
             !
             !        Reset the function and derivative values for f.
             !
            fx = fxm + stx * gtest
            fy = fym + sty * gtest
            gx = gxm + gtest
            gy = gym + gtest
          else
            !
            !  Call dcstep to update stx, sty, and to compute the new step.
            !
            call dcstep (stx, fx, gx, sty, fy, gy, stp, f, g, brackt, stmin, &
           & stmax)
          end if
          !
          !     Decide if a bisection step is needed.
          !
          if (brackt) then
            if (Abs (sty-stx) >= p66*width1) then
              stp = stx + p5 * (sty-stx)
            end if
            width1 = width
            width = Abs (sty-stx)
          end if
          !
          !     Set the minimum and maximum steps allowed for stp.
          !
          if (brackt) then
            stmin = Min (stx, sty)
            stmax = Max (stx, sty)
          else
            stmin = stp + xtrapl * (stp-stx)
            stmax = stp + xtrapu * (stp-stx)
          end if
          !     Force the step to be within the bounds stpmax and stpmin.
          stp = Max (stp, stpmin)
          stp = Min (stp, stpmax)
          !
          !     If further progress is not possible, let stp be the best
          !     point obtained during the search.
          !
          if (brackt .and. (stp <= stmin .or. stp >= stmax) .or. (brackt .and. &
         & stmax-stmin <= xtol*stmax)) then
            stp = stx
          end if
          !
          !     Obtain another function and derivative.
          !
          task = "FG"
        end if
      end if
    !
    !     Save local variables.
    !
    !
      if (brackt) then
        isave(1) = 1
      else
        isave(1) = 0
      end if
      isave(2) = stage
      dsave(1) = ginit
      dsave(2) = gtest
      dsave(3) = gx
      dsave(4) = gy
      dsave(5) = finit
      dsave(6) = fx
      dsave(7) = fy
      dsave(8) = stx
      dsave(9) = sty
      dsave(10) = stmin
      dsave(11) = stmax
      dsave(12) = width
      dsave(13) = width1
    !
    end subroutine dcsrch
  !====================== The end of dcsrch ==============================
  !
    subroutine dcstep (stx, fx, dx, sty, fy, dy, stp, fp, dp, brackt, stpmin, &
   & stpmax)
      implicit none
      double precision, parameter :: zero = 0.0d0
      double precision, parameter :: p66 = 0.66d0
      double precision, parameter :: two = 2.0d0
      double precision, parameter :: three = 3.0d0
      logical, intent (inout) :: brackt
      double precision, intent (in) :: dp, fp, stpmax, stpmin
      double precision, intent (inout) :: dx, dy, fx, fy, stp, stx, sty
      double precision :: gamma, p, q, r, s, sgnd, stpc, stpf, stpq, theta
    !
      sgnd = dp * (dx/Abs(dx))
!
!  Consider pathologic condition: stp = stx
!
      if (Abs (stp - stx) < 1.d-5) stp = stp + 1.d-5
    !
    !     First case: A higher function value. The minimum is bracketed.
    !     If the cubic step is closer to stx than the quadratic step, the
    !     cubic step is taken, otherwise the average of the cubic and
    !     quadratic steps is taken.
    !
      if (fp > fx) then
        theta = three * (fx-fp) / (stp-stx) + dx + dp
        s = Max (Abs (theta), Abs (dx), Abs (dp))
        gamma = s * Sqrt ((theta/s)**2-(dx/s)*(dp/s))
        if (stp < stx) then
          gamma = -gamma
        end if
        p = (gamma-dx) + theta
        q = ((gamma-dx)+gamma) + dp
        r = p / q
        stpc = stx + r * (stp-stx)
        stpq = stx + ((dx/((fx-fp)/(stp-stx)+dx))/two) * (stp-stx)
        if (Abs (stpc-stx) < Abs (stpq-stx)) then
          stpf = stpc
        else
          stpf = stpc + (stpq-stpc) / two
        end if
        brackt = .true.
       !
       !     Second case: A lower function value and derivatives of opposite
       !     sign. The minimum is bracketed. If the cubic step is farther from
       !     stp than the secant step, the cubic step is taken, otherwise the
       !     secant step is taken.
       !
      else if (sgnd < zero) then
        theta = three * (fx-fp) / (stp-stx) + dx + dp
        s = Max (Abs (theta), Abs (dx), Abs (dp))
        gamma = s * Sqrt ((theta/s)**2-(dx/s)*(dp/s))
        if (stp > stx) then
          gamma = -gamma
        end if
        p = (gamma-dp) + theta
        q = ((gamma-dp)+gamma) + dx
        r = p / q
        stpc = stp + r * (stx-stp)
        stpq = stp + (dp/(dp-dx)) * (stx-stp)
        if (Abs (stpc-stp) > Abs (stpq-stp)) then
          stpf = stpc
        else
          stpf = stpq
        end if
        brackt = .true.
       !
       !     Third case: A lower function value, derivatives of the same sign,
       !     and the magnitude of the derivative decreases.
       !
      else if (Abs (dp) < Abs (dx)) then
       !
       !        The cubic step is computed only if the cubic tends to infinity
       !        in the direction of the step or if the minimum of the cubic
       !        is beyond stp. Otherwise the cubic step is defined to be the
       !        secant step.
       !
        theta = three * (fx-fp) / (stp-stx) + dx + dp !
       !     Fourth case: A lower function value, derivatives of the
       !     same sign, and the magnitude of the derivative does not
       !     decrease. If the minimum is not bracketed, the step is either
       !     stpmin or stpmax, otherwise the cubic step is taken.
       !
        s = Max (Abs (theta), Abs (dx), Abs (dp))
       !
       !        The case gamma = 0 only arises if the cubic does not tend
       !        to infinity in the direction of the step.
       !
        gamma = s * Sqrt (Max(zero, (theta/s)**2-(dx/s)*(dp/s)))
        if (stp > stx) then
          gamma = -gamma
        end if
        p = (gamma-dp) + theta
        q = (gamma+ (dx-dp)) + gamma
        r = p / q
        if (r < zero .and. gamma /= zero) then
          stpc = stp + r * (stx-stp)
        else if (stp > stx) then
          stpc = stpmax
        else
          stpc = stpmin
        end if
        stpq = stp + (dp/(dp-dx)) * (stx-stp)
       !
        if (brackt) then
          !
          !           A minimizer has been bracketed. If the cubic step is
          !           closer to stp than the secant step, the cubic step is
          !           taken, otherwise the secant step is taken.
          !
          if (Abs (stpc-stp) < Abs (stpq-stp)) then
            stpf = stpc
          else
            stpf = stpq
          end if
          if (stp > stx) then
            stpf = Min (stp+p66*(sty-stp), stpf)
          else
            stpf = Max (stp+p66*(sty-stp), stpf)
          end if
        else
          !
          !           A minimizer has not been bracketed. If the cubic step is
          !           farther from stp than the secant step, the cubic step is
          !           taken, otherwise the secant step is taken.
          !
          if (Abs (stpc-stp) > Abs (stpq-stp)) then
            stpf = stpc
          else
            stpf = stpq
          end if
          stpf = Min (stpmax, stpf)
          stpf = Max (stpmin, stpf)
        end if
      else if (brackt) then
        theta = three * (fp-fy) / (sty-stp) + dy + dp
        s = Max (Abs (theta), Abs (dy), Abs (dp))
        gamma = s * Sqrt ((theta/s)**2-(dy/s)*(dp/s))
        if (stp > sty) then
          gamma = -gamma
        end if
        p = (gamma-dp) + theta
        q = ((gamma-dp)+gamma) + dy
        r = p / q
        stpc = stp + r * (sty-stp)
        stpf = stpc
      else if (stp > stx) then
        stpf = stpmax
      else
        stpf = stpmin
      end if
    !
    !     Update the interval which contains a minimizer.
    !
      if (fp > fx) then
        sty = stp
        fy = fp
        dy = dp
      else
        if (sgnd < zero) then
          sty = stx
          fy = fx
          dy = dx
        end if
        stx = stp
        fx = fp
        dx = dp
      end if
    !
    !     Compute the new step.
    !
      stp = stpf
    !
    end subroutine dcstep
  !====================== The end of dcstep ==============================
    double precision function dpmeps ()
    !     **********
    !
    !     Function dpeps
    !
    !     This function computes the machine precision parameter
    !     dpmeps as the smallest floating point number such that
    !     1 + dpmeps differs from 1.
    !
    !     Replaced with F90 function Epsilon
    !     Original fails on COMPAQ Alpha
    !
    !.. Implicit Declarations ..
      implicit none
    !
      dpmeps = Epsilon (1.d0)
    !
    end function dpmeps
  !====================== The end of dpmeps ==============================
    subroutine dpofa (a, lda, n, info)
      implicit none
      integer, intent (in) :: lda
      double precision, dimension (lda,*), intent (inout) :: a
      integer, intent (in) :: n
      integer, intent (inout) :: info
       integer :: j, jm1, k
      double precision :: s, t
      double precision, external :: ddot
    !     begin block with ...exits to 40
    !
    !
      do j = 1, n
        info = j
        s = 0.0d0
        jm1 = j - 1
        if (jm1 >= 1) then
          do k = 1, jm1
            t = a(k, j) - ddot (k-1, a(1, k), 1, a(1, j), 1)
            t = t / a(k, k)
            a(k, j) = t
            s = s + t * t
          end do
        end if
        s = a(j, j) - s
       !     ......exit
        if (s <= 0.0d0) return
        a(j, j) = Sqrt (s)
      end do
      info = 0
    end subroutine dpofa
  !====================== The end of dpofa ===============================
    subroutine dtrsl (t, ldt, n, b, job, info)
      implicit none
      integer, intent (in) :: ldt
      double precision, dimension (ldt,*), intent (inout) :: t
      integer, intent (in) :: n
      double precision, dimension (*), intent (inout) :: b
      integer, intent (in) :: job
      integer, intent (inout) :: info
      integer :: case, j, jj
      double precision :: temp
      external daxpy
      double precision, external :: ddot
    !
    !
    !     begin block permitting ...exits to 150
    !
    !        check for zero diagonal elements.
    !
      do info = 1, n
       !     ......exit
        if (t(info, info) == 0.0d0) return
      end do
      info = 0
    !
    !        determine the task and go to it.
    !
    case = 1
      if (Mod(job, 10) /= 0) then
      case = 2
      end if
      if (Mod(job, 100)/10 /= 0) then
      case = case + 2
      end if
      select case (case)
      case (2)
       !
       !        solve t*x=b for t upper triangular.
       !
        b(n) = b(n) / t(n, n)
        if (n >= 2) then
          do jj = 2, n
            j = n - jj + 1
            temp = -b(j+1)
            call daxpy (j, temp, t(1, j+1), 1, b(1), 1)
            b(j) = b(j) / t(j, j)
          end do
        end if
      case (3)
       !
       !        solve trans(t)*x=b for t lower triangular.
       !
        b(n) = b(n) / t(n, n)
        if (n >= 2) then
          do jj = 2, n
            j = n - jj + 1
            b(j) = b(j) - ddot (jj-1, t(j+1, j), 1, b(j+1), 1)
            b(j) = b(j) / t(j, j)
          end do
        end if
      case (4)
       !
       !        solve trans(t)*x=b for t upper triangular.
       !
        b(1) = b(1) / t(1, 1)
        if (n >= 2) then
          do j = 2, n
            b(j) = b(j) - ddot (j-1, t(1, j), 1, b(1), 1)
            b(j) = b(j) / t(j, j)
          end do
        end if
      case default
       !
       !        solve t*x=b for t lower triangular
       !
        b(1) = b(1) / t(1, 1)
        if (n >= 2) then
          do j = 2, n
            temp = -b(j-1)
            call daxpy (n-j+1, temp, t(j, j-1), 1, b(j), 1)
            b(j) = b(j) / t(j, j)
          end do
        end if
      end select
    end subroutine dtrsl
  !====================== The end of dtrsl ===============================

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine gettxt
      use chanel_C, only: ir, iw, isetup, input_fn
      use molkst_C, only: keywrd, keywrd_quoted, koment, title, refkey, gui, numcal, line, &
        moperr, allkey, backslash
      implicit none
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j, k, l, m, ipath
      character :: filen*300, oldkey*3000, line1*3000, path*240, ch*1
      logical :: aux, exists, setup_present, zero_scf
      character (len = 300), external :: get_text
      integer, external :: quoted
!-----------------------------------------------
      koment = " "
      title = " "
      refkey = '    NULL  '
      keywrd_quoted = " "
      oldkey = " "
      aux = (index(keywrd, "AUX") /= 0)
      read (ir, '(A2000)', end=100, err=100) refkey(1)
      keywrd = refkey(1)
      do
        j = index(keywrd, "++")
        if (j /= 0) then
          do
            j = index(keywrd, "++")
            if (j== 0) exit
            i = j
            if (keywrd(i - 1:i - 1) == " ")then
              line = keywrd(:i - 1)//" "//trim(keywrd(i + 2:))
            else
              line = keywrd(:i - 1)//" "//trim(keywrd(i + 2:))
            end if
            keywrd = trim(line)
          end do
          read (ir, '(A2000)', end=100, err=100) line
          if (keywrd(i - 1:i - 1) == " ")then
              keywrd = trim(keywrd)//" "//trim(line)
            else
              keywrd = trim(keywrd)//trim(line)
            end if
        else
          refkey(1) = trim(keywrd)
          exit
        end if
      end do
      oldkey = trim(keywrd)
      call upcase (keywrd, len_trim(keywrd))
      zero_scf = (index(keywrd, "0SCF") /= 0)
      do i = len_trim(input_fn), 2, -1
        if (input_fn(i:i) == backslash .or. input_fn(i:i) == "/") exit
      end do
      ipath = i
      if  (ipath > 2) then
        path = input_fn(:ipath)
        filen = trim(path)//'SETUP'
      else
        filen = 'SETUP'
      end if
      inquire (file=filen, exist = exists)
      i = len_trim(keywrd)
      allkey = keywrd(:i)
      setup_present = (index(keywrd,'SETUP') /= 0)
      if (setup_present) then
        if (index(allkey, " + ") /= 0) then
          call mopend(" Keywords ""SETUP"" and ""+""cannot be used together")
!
!  Dummy read to go to the end of the data set
!
          do
            read(ir,*,err=98, iostat = i)filen
            if (i /= 0) exit
          end do
  98      return
        end if
        i = index(keywrd,'SETUP=')
        if (i /= 0) then
          filen = trim(get_text(oldkey, i + 6, 1))
        else
          i = index(keywrd,'SETUP')
          j = index(keywrd(i:), " ") + i - 1
          filen = keywrd(i:j)
        end if
        call add_path(filen)
        inquire (file=filen, exist = exists)
        if (.not. exists) then
          inquire (file=trim(filen)//".txt", exist = exists)
          if (exists) filen = trim(filen)//".txt"
        end if
        if (.not. exists) then
          if (setup_present .and. .not. zero_scf) then
            write (line, '(A)') "SETUP FILE """//trim(filen)//""" MISSING."
            numcal = 2
            if (.not. gui )write(0,'(//30x,a)')' SETUP FILE "'//trim(filen)//'" MISSING'
            call mopend (trim(line))
            return
          end if
        else
          open(unit=isetup, file=filen, status='UNKNOWN', form='FORMATTED',position='REWIND', iostat=i)
          if (i /= 0) then
            if (.not. zero_scf) then
              call mopend ('COULD NOT OPEN SETUP FILE: '//trim(filen))
              if (zero_scf) moperr = .false.
              return
            end if
          end if
          rewind isetup
          refkey(2) = " "
          i = -1
          do
            read (isetup, '(A)', end=61, err=50) line1
61          if (line1(1:1) == "*") cycle
            j = len_trim(line1)
            if (j == 3000) line1 = " "
            if (i == -1) then
              refkey(2) = trim(refkey(2))//trim(line1)
            else
              if (refkey(2)(i - 1:i - 1) == " ")then
                refkey(2) = trim(refkey(2))//" "//trim(line1)
              else
                refkey(2) = trim(refkey(2))//trim(line1)
              end if
            end if
            j = index(refkey(2), "++")
            if (j /= 0) then
              do
                j = index(refkey(2), "++")
                if (j == 0) exit
                i = j
                if (refkey(2)(i - 1:i - 1) == " ")then
                  line = refkey(2)(:i - 1)//" "//trim(refkey(2)(i + 2:))
                else
                  line = refkey(2)(:i - 1)//" "//trim(refkey(2)(i + 2:))
                end if
                refkey(2) = trim(line)
                line = refkey(2)(:i - 1)//trim(refkey(2)(i + 2:))
              end do
            else
              oldkey = trim(oldkey)//" "//trim(refkey(2))
              exit
            end if
          end do
          close (isetup)
          call upcase (refkey(2), len(refkey(2)) )
!
!  Check for " -" signs in setup file
!
          i = ichar(refkey(2)(1:1))
          if (i == 0) then
            refkey(2) = " "
          else if (refkey(2)(1:1) /= " ") then
            refkey(2) = " "//refkey(2)(:len_trim(refkey(2)))
          end if
          do
            i = index(refkey(2), " -")
            if (i == 0) exit
!
! Is the minus sign inside a quoted text
!
            j = 0
            do k = i, len_trim(refkey(2))
              if (refkey(2)(k:k) == '"') j = j + 1
            end do
            if (mod(j,2) == 1) then
!
!  Yes, it's inside a quoted string, so protect it and carry on
!
              refkey(2)(i:i) = "*"
              cycle
            end if
            j = index(refkey(2)(i + 2:), " ") + i + 1
            do
              k = index(" "//keywrd, " "//refkey(2)(i + 2: j - 1))
              if (k == 0) exit
              l = index(keywrd(k + 1:)," ") + k + 1
              keywrd(k:) = keywrd(l:)
              if (keywrd == " ") exit
            end do
            refkey(2)(i:) = refkey(2)(j:)
          end do
!
!   Check for keywords in SETUP that are present in the keyword line, and delete them
!   ( Keywords on keyword line take precedence.)
!
!  First, move keywords that contain quoted text into keywrd_quoted so that they
!  will not affect keyword analyses
!
          i = 1
          do
            i = i + 1
            if (i > len_trim(refkey(2))) exit
            if (refkey(2)(i - 1:i - 1) == " " .and. refkey(2)(i:i) /= " ") then
!
!  Found a keyword. Now look for the end of the keyword
!
              do j = i + 1, len_trim(refkey(2))
                if (refkey(2)(j:j) == " ") exit
              end do
              line = refkey(2)(i:j)
              do k = 1,100
                if ((line(k:k) < "A" .or. line(k:k) > "Z") .and. &
                    (line(k:k) < "0" .or. line(k:k) > "9") .and. &
                    (line(k:k) /= "_")) exit
              end do
              k = k - 1
              if (index(allkey, " "//line(:k)) > 0 .and. line(:5) /= "SETUP") then
                k = index(keywrd, " "//line(:k)) + k + 1
                if (keywrd(k:k) < "A" .or. keywrd(k:k) > "Z") then
                  refkey(2) = refkey(2)(:i - 1)//refkey(2)(j + 1:)
                  i = i - 1
                end if
              end if
            end if
          end do
!
!  Check for " -" signs in keywrd line
!
          m = 0
          do
            i = index(keywrd(m + 1:), " -") + m
            if (i == m) exit
!
! Is the minus sign inside a quoted text
!
            j = 0
            do k = i, len_trim(keywrd)
              if (keywrd(k:k) == '"') j = j + 1
            end do
            if (mod(j,2) == 1) then
!
!  Yes, it's inside a quoted string, so protect it and carry on
!
              keywrd(i:i) = char(0)
              m = i
              cycle
            end if
            j = index(keywrd(i + 2:), " ") + i + 1
            do
              k = index(" "//refkey(2), " "//keywrd(i + 2: j - 1))
              if (k == 0) exit
              l = index(refkey(2)(k + 1:)," ") + k + 1
              refkey(2)(k:) = refkey(2)(l:)
            end do
            i = index(keywrd, " -")
            j = index(keywrd(i + 2:), " ") + i + 1
            keywrd(i:) = keywrd(j:)
            m = i
          end do
          do
            i = index(keywrd, char(0))
            if (i == 0) exit
            keywrd(i:i) = " "
          end do
          i = len_trim(keywrd)
          keywrd(i + 1:) = refkey(2)(:3000 - 1 - i)
          refkey(1) = trim(keywrd)
          refkey(2) = refkey(3)
!
! Delete SETUP keyword
!
          i = index(refkey(1)," SETUP")
          ch = " "
          do j = i + 6, len_trim(refkey(1))
            if (refkey(1)(j:j) == ch) exit
            if (refkey(1)(j:j) == '"') then
              if (ch == '"') then
                ch = " "
              else
                ch = '"'
              end if
            end if
          end do
          refkey(1) = refkey(1)(:i)//trim(refkey(1)(j + 1:))
        end if
        read (ir, '(A)', end=100, err=100) koment, title
      else if (index(allkey(1:i),' +') /= 0) then
!
!  READ SECOND KEYWORD LINE
!
        read (ir, '(A)', end=100, err=100) refkey(2)
        oldkey(len_trim(oldkey) + 2:) = trim(refkey(2))
        i = index(allkey(1:i),' +')
        keywrd(i:i + 1) = " "
        i = len_trim(keywrd)
        keywrd(i + 2:) = trim(refkey(2))
        call upcase (keywrd(i + 1:), len(keywrd) - i)
        k = len_trim(keywrd)
        allkey = keywrd(:k)
        if (index(keywrd,'SETUP') /= 0) then
          i = index(keywrd,'SETUP=')
          if (i /= 0) then
            j = index(keywrd(i:),' ')
            filen = oldkey(i+6:i+j-2)
            keywrd(i: i + j - 1) = " "
          else
            filen = 'SETUP'
            i = index(keywrd,'SETUP')
            keywrd(i: i + 5) = " "
          end if
          keywrd(i:i+6) = " "
          call add_path(filen)
          open(unit=isetup, file=filen, status='UNKNOWN', form='FORMATTED', &
            position='REWIND')
          rewind isetup
          read (isetup, '(A)', end=30, err=30) refkey(2)
          close(isetup)
          i = len_trim(keywrd) + 1
          keywrd(i:) = refkey(2)(:1001 - i)
          call upcase (keywrd, len_trim(keywrd))
   30     continue
        else if (index(allkey(i + 1:),' +') /= 0) then
!
!  READ THIRD KEYWORD LINE
!
          read (ir, '(A)', end=100, err=100) refkey(3)
          allkey = refkey(3)
          i = index(allkey, " + ")
          if (i /= 0) then
            write(iw,"(a)")" A maximum of three lines of keywords are allowed."
            write(iw,"(a)")" On the third line of keywords is a '+' sign, implying more lines of keywords."
            write(iw,"(a)")" Remove the '+' sign from the third line of keywords, and re-run."
            call web_message(iw,"plus.html")
            call mopend("A maximum of three lines of keywords are allowed.")
            return
          end if
          i = index(keywrd(1:len_trim(keywrd)),' +')
          keywrd(i:i + 1) = " "
          i = len_trim(keywrd)
          keywrd(i + 2:) = refkey(3)(:1001 - i)
          i = len_trim(oldkey)
          oldkey(i:) = trim(refkey(3))
          call upcase (keywrd, len_trim(keywrd))
        end if
!
!  READ TITLE LINE
!
        read (ir, '(A)', end=100, err=100) koment, title
      else if (index(keywrd,'&') /= 0) then
        i = index(keywrd,'&')
        keywrd(i:i) = ' '
        oldkey(i:i) = ' '
        i = len_trim(keywrd)
        read (ir, '(A)', end=100, err=100) refkey(2)
        keywrd(i + 1:) = " "//refkey(2)(:1001 - i)
        oldkey(len_trim(oldkey) + 2:) = refkey(2)(:1001 - i)
        call upcase (keywrd, len_trim(keywrd))
        i = len_trim(keywrd)
        if (index(keywrd,'SETUP') /= 0) then
          i = index(keywrd,'SETUP=')
          if (i /= 0) then
            j = index(keywrd(i:),' ')
            filen = keywrd(i + 6:i + j)
            keywrd(i: i + j) = " "
          else
            filen = 'SETUP'
            i = index(keywrd,'SETUP')
            keywrd(i:i + 6) = " "
          end if
          call add_path(filen)
          open(unit=isetup, file=filen, status='UNKNOWN', form='FORMATTED', &
            position='REWIND')
          rewind isetup
          read (isetup, '(A)', end=39, err=40) keywrd(len_trim(keywrd) + 2:)
39        close (isetup)
          call upcase (keywrd, len_trim(keywrd))
          read (ir, '(A)', end=100, err=100) title
   40     continue
        else if (index(keywrd(i:),'&') /= 0) then
          j = index(keywrd,'&')
          keywrd(j:j) = ' '
          oldkey(j:j) = ' '
          read (ir, '(A)', end=100, err=100) refkey(3)
          read(refkey(3), '(a)') keywrd(i + 1:)
          read(refkey(3), '(a)') oldkey(i + 1:)
          call upcase (keywrd, len_trim(keywrd))
        else
          read (ir, '(A)', end=100, err=100) title
        end if
      else
        read (ir, '(A)', end=100, err=100) koment, title
      end if
      call split_keywords(oldkey)
      go to 60
50    continue
      if (zero_scf) go to 60
      numcal = 2
      call mopend ('SETUP FILE "'//trim(filen)//'" MISSING')
      write(iw,'(a)') " (Setup file name: '"//trim(filen)//"')"
      return
60    continue
      line = " "
      goto 99
100   continue
      call split_keywords(oldkey)
      
      if (numcal > 1) then
        if (index(keywrd,"OLDGEO") /= 0) return ! User forgot to add extra lines for title and comment
        if (aux) keywrd = " AUX"
        line = "JOB ENDED NORMALLY"       
        if (quoted('GEO_DAT"') == 0) then
          line = ' ERROR IN READ OF FIRST THREE LINES' 
        else
          line = " "
        end if
      end if
99    continue
!
!  Look for non-standard characters.  If Apple's "text editor" is used,
!  convert the fancy '"' (four characters) into a normal '"'.
!
      exists = .false.
      j = len_trim(keywrd)
      do i = j, 3, -1
        if (ichar(keywrd(i:i)) /= 157) cycle
        if (ichar(keywrd(i - 1:i - 1)) == 128 .and. &
            ichar(keywrd(i - 2:i - 2)) == 226 .and. &
            ichar(keywrd(i - 3:i - 3)) == 156) then
          if (ichar(keywrd(i - 4:i - 4)) /= 128) then
            keywrd = keywrd(:i - 3)//'"'//trim(keywrd(i + 1:))
          else
            keywrd = keywrd(:i - 6)//'"'//trim(keywrd(i + 1:))
          end if
          exists = .true.
        end if
      end do
      do k = 1, 6
        if (index(refkey(k), " NULL") /= 0) exit
        j = len_trim(refkey(k))
        do
          i = index(refkey(k), char(160))
          if (i > 0) then
            refkey(k)(i:i) = " "
          else
            exit
          end if
        end do
      end do
      if (exists) then
        do k = 1, 6
          if (index(refkey(k), " NULL") /= 0) exit
          j = len_trim(refkey(k))
          do i = j, 3, -1
            if (ichar(refkey(k)(i:i)) /= 157) cycle
            if (ichar(refkey(k)(i - 1:i - 1)) == 128 .and. &
                ichar(refkey(k)(i - 2:i - 2)) == 226 .and. &
                ichar(refkey(k)(i - 3:i - 3)) == 156) then
              if (ichar(refkey(k)(i - 4:i - 4)) /= 128) then
                refkey(k) = refkey(k)(:i - 3)//'"'//trim(refkey(k)(i + 1:))
              else
                refkey(k) = refkey(k)(:i - 6)//'"'//trim(refkey(k)(i + 1:))
              end if
            end if
          end do
        end do
      end if
!
! Convert all bad slashes into good slashes
!
      do
        i = index(keywrd, backslash)
        if (i == 0) exit
        keywrd(i:i) = "/"
      end do
!
! Convert all fancy quotation marks into normal ASCII quotation marks
!
      do
        i = index(keywrd, char(148))
        if (i == 0) exit
        keywrd(i:i) = '"'
      end do
      return
  end subroutine gettxt
  character (len = 300) function get_text(line, i_start, zero)
    implicit none
    character :: line*(*)
    integer :: i_start, zero
!
!  Return text between character i_start and the next space.
!  If character i_start is '"' or ''', return text between character i_start + 1 and the closing character.
!
    integer, parameter :: num_lim = 2
    character :: limit(num_lim)*1, ch*1
    integer :: i, j
    data limit /"""","'"/
    do i = 1, num_lim
      if (line(i_start:i_start) == limit(i)) exit
    end do
    j = i_start
    if (i > num_lim) then
      ch = " "
      i = i_start
    else
      j = j + 1
      ch = limit(i)
      i = i_start + 1
    end if
    do
      if (line(i + 1:i + 1) == ch) exit
      i = i + 1
    end do
    get_text = line(j:i)
    if (zero == 0) line(i_start:i + 1) = " "
    return
  end function get_text
!
!
!
  subroutine split_keywords(oldkey)
  use molkst_C, only: keywrd, keywrd_quoted, line
  implicit none
  character, intent (in) :: oldkey*3000
  integer :: i, j, k, loop
  integer, parameter :: n_quoted = 4
  character :: quoted_keywords(n_quoted)*20, old*3000, quotation*1
  logical :: first
!
!  Split the keyword string "keywrd" into two strings: "keywrd" and "keywrd_quoted".
!  On exit:
!  First string:  keywrd        - holds all the keywords that must not contain quotation marks.
!  Second string: keywrd_quoted - holds all the keywords that can contain quotation marks.
!
!  If a keyword that can contain quotation marks does not have quotation marks, 
!  then quotation marks will be added.
!
!  If a keyword occurs more than once, only the first occurance will be kept in "keywrd_quoted", 
!  all others will be deleted.
!
  quoted_keywords(1) = ' GEO_DAT='
  quoted_keywords(2) = ' GEO_REF='
  quoted_keywords(3) = ' EXTERNAL='
  quoted_keywords(4) = ' SETUP='
  old = trim(oldkey)
  keywrd_quoted = " "
  do
    i = index(old, " + ")
    if (i /= 0) then
      line = trim(old)
      old = line(:i)//trim(line(i + 3:))
    else
      exit
    end if
  end do
  keywrd = trim(old)
  call upcase (keywrd, len_trim(keywrd))
  if (keywrd(1:1) /= " ") then
    line = trim(keywrd)
    keywrd = " "//trim(line)
    line = trim(old)
    old = " "//trim(line)
  end if
  do loop = 1, n_quoted
    first = .true.
    do
      i = index(keywrd, trim(quoted_keywords(loop)))
      if (i /= 0) then
!
! Found a keyword that should be quoted.  Make sure that it has a quotation mark
!
        k = len_trim(quoted_keywords(loop))
        j = i + k
        if (keywrd(j:j) /= '"') then
          quotation = '"'
          j = index(keywrd(j:), ' ') + j - 1     
        else
          quotation = ' '
          j = index(keywrd(j + 1:), '"') + j + 1
          j = index(keywrd(j:), ' ') + j - 1     
        end if                
!
! Copy the keyword that contains quotation marks to keywrd_quoted
!    
        if (first) then
          line = trim(keywrd_quoted)        
          keywrd_quoted = trim(line)//keywrd(i:i + k -1)//trim(quotation)//old(i + k:j - 1)//trim(quotation)  
          first = .false.
        end if
!
! Delete the keyword from keywrd that contains the quotation marks
!  
        line = trim(keywrd)
        keywrd = line(1:i - 1)//trim(line(j:))
        line = trim(old)
        old = line(1:i - 1)//trim(line(j:))
      else
        exit
      end if
    end do
  end do
  do
    i = index(keywrd_quoted, "\")
    if (i == 0) exit
    keywrd_quoted(i:i) = "/"
  end do
  return
  end subroutine split_keywords
  
  
  integer function quoted(key)
!
! If the test keyword "key" is present in "keywrd_quoted", then the function is set to
! the location in the string, and the string variable "line" is set to the text.
! If the test keyword is not present, the function is set to zero and "line" is empty.  
!
  use molkst_C, only: keywrd_quoted, line
  implicit none
  character, intent (in) :: key*(*)
  integer :: i, j, k
  integer, external :: end_of_keyword
!
! Search for a keyword that contains a string that contains text that could be mistaken
! for keywords.
!
    line = " "
      i = index(keywrd_quoted, trim(key))
      if (i /= 0) then
 !
  ! Keyword contains quotation marks, so:
  !
      k = Index (keywrd_quoted(i:), "=") + i
      j = end_of_keyword(keywrd_quoted, len_trim(keywrd_quoted), k) - 2
      i = i + 1 + len_trim(key) 
      line = keywrd_quoted(i:j)
      end if
    quoted = i
    return
  end function quoted

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

subroutine upcase (keywrd)
  implicit none
  character(len=*), intent(inout) :: keywrd
!
  integer :: i, icapa, iline, ilowa, ilowz
  icapa = Ichar ("A")
  ilowa = Ichar ("a")
  ilowz = Ichar ("z")
  do i = 1, Len (keywrd)
    iline = Ichar (keywrd(i:i))
    if (iline>=ilowa .and. iline<=ilowz) then
      keywrd(i:i) = Char(iline+icapa-ilowa)
    end if
  end do
end subroutine upcase

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module common_titles
    character (len=241) :: koment, title
    save
end module common_titles

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine maksym(loc, xparam, xstore)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : nvar, ndep, natoms
      use symmetry_C, only : locpar, idepfn, locdep
      use funcon_C, only : pi
      use common_arrays_C, only : na
      use chanel_C, only : iw
!***********************************************************************
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
    integer, dimension (2, nvar), intent (inout) :: loc
    double precision, dimension (nvar), intent (inout) :: xparam, xstore
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j, loop, locl
      double precision :: twopi, xref
!-----------------------------------------------
!*********************************************************************
!
! MAKSYM CONSTRUCTS THE SYMMETRY DEFINITIONS FOR THE SYSTEM
!        AUTOMATICALLY.  IT RELIES ON IDENTICAL BOND-LENGTHS BEING
!        SYMMETRY RELATED, SIMILARLY FOR ANGLES AND DIHEDRALS.
!
!*********************************************************************
      do i = 2, natoms
        if (na(i) == 0) exit
      end do
      if (i < natoms) then
        write(iw,'(a)')" For AUTOSYM to work, geometry must be in internal coordinates."
        call mopend("For AUTOSYM to work, geometry must be in internal coordinates")
      end if
      twopi = 2.D0*pi
      ndep = 0
      do i = 1, nvar
        if (loc(2,i) == 3) then
!
!  FORCE DIHEDRALS INTO SAME HALF-CIRCLE
!
          j = int(sign(0.5D0,xparam(i))+xparam(i)/twopi)
          xparam(i) = xparam(i) - j*twopi
        end if
        xstore(i) = xparam(i)
      end do
      do loop = 1, nvar
        if (xstore(loop) < (-1.D4)) cycle
        xref = xstore(loop)
        locl = loc(2,loop)
        do i = loop + 1, nvar
          if (abs(xref - xstore(i))>=1.D-3 .or. loc(2,i)/=locl) cycle
          ndep = ndep + 1
          locpar(ndep) = loc(1,loop)
          idepfn(ndep) = locl
          locdep(ndep) = loc(1,i)
          xstore(i) = -1.D5
        end do
!
!   Special, common, dihedral symmetry function
!
        do i = loop + 1, nvar
          if (abs(xref + xstore(i))>=1.D-3 .or. loc(2,i)/=locl) cycle
          ndep = ndep + 1
          locpar(ndep) = loc(1,loop)
          idepfn(ndep) = 14
          locdep(ndep) = loc(1,i)
          xstore(i) = -1.D5
        end do
      end do
      j = 0
      do i = 1, nvar
        if (xstore(i) <= (-1.D4)) cycle
        j = j + 1
        loc(1,j) = loc(1,i)
        loc(2,j) = loc(2,i)
        xparam(j) = xparam(i)
      end do
      nvar = j
      return
      end subroutine maksym

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  subroutine to_screen(text0)
  use chanel_C, only : iw0
  use molkst_C, only : keywrd
  implicit none
  character (len=*) :: text0
  character (len=200) :: text
  integer :: i
  i = len_trim(text0)
  if (i == 0) then
!
! Length not passed, so work it out
!
    do i = 1, 200
      if (ichar(text0(i:i)) == 0) exit
    end do
    i = i - 1
  end if
  text = text0(:i)
  if (text(:min(len_trim(text), 8)) /= "To_file:") then
    if (iw0 > -1) then
      write(iw0,"(a)") trim(text)
      call flush (iw0)
    end if
  else
    if (index(keywrd, " AUX") == 0) return
    call current_version(text)
  end if
  end subroutine to_screen

  subroutine current_version (text)
  use chanel_C, only : output_fn
!
  use to_screen_C, only : rot, xyzmom, dip, dipt, travel, freq, &
  redmas, fcint, cnorml
!
  use common_arrays_C, only : nat, tvec, coord, nfirst, nlast, c, grad, &
  h, eigs, q, geo, na, nb, nc, p, pa, pb, eigb, cb, fmatrx, atmass, &
  txtatm, chrg, ipKa_sorted, pKa_sorted, f, fb, bondab, T_range, HOF_tot, H_tot, Cp_tot, S_tot
!
  use parameters_C, only : zs, zp, zd, npq, betas, betap, betad, tore, natorb
!
  use symmetry_C, only : name, jndex, namo, state_spin, state_Irred_Rep, state_QN
!
  use polar_C, only : omega, alpavg
!
  use molkst_C, only : numat, norbs, escf, nelecs, nclose, nopen, verson, &
  method_am1, method_mndo, method_pm3, method_rm1, method_mndod, method_pm6, &
  method_pm7, nvar, koment, keywrd, zpe, id, density, natoms, formula, press, &
  uhf, nalpha, nbeta,  gnorm, mozyme, mol_weight, ilim, &
  line, nscf, time0, sz, ss2, no_pKa, title, jobnam, job_no, fract
!
  use MOZYME_C, only : ncf, ncocc, noccupied, icocc_dim, cocc_dim, nvirtual, icvir_dim, &
  nncf, iorbs, cocc, icocc, ncvir, nnce, nce, icvir, cvir, tyres, size_mres, &
  cvir_dim, idiag
!
  use elemts_C, only : elemnt
!
  use chanel_c, only : iw
!
  use funcon_C, only : a0
!
  use cosmo_C, only : area, solv_energy, cosvol
!
  use meci_C, only : deltap, nmos, occa, microa, microb, lab, nstate, vectci, &
    root_requested, eig, nelec, rjkab
!
  use maps_C, only : rxn_coord, rc_escf, ekin, lparam, latom
!
  use drc_C, only: time
!
#if MOPAC_F2003
  USE, INTRINSIC :: IEEE_ARITHMETIC
#endif
!
  implicit none
  character (len=*) :: text

  integer :: i, j, k, l, hook = 50, if, im1, jj, ii, jf, ij, opt_hook, ni, nj, &
  norbi, norbj, kl, ku, i1, j1, ic, mos, moa_lower, moa_upper, jloop = -1, &
  mob_lower, mob_upper, i_map
  logical :: normal, force, geom_opt, int_force_const, error, finished, &
  first = .true., LMO, LMO_alpha = .true., end_of_job, opend, compressed, &
  eigen, mullik, esp, irc_drc, irc, lnmoas, lnmobs, loc_mos, new_calcn = .true., &
  polar, reaction_path, l_RC, L_overlap, L_MO_s, L_Density
  character :: atorbs(9)*2, idate*24, atoms*3, paras*3, orbs*3, orbs2*5, fmt*3, &
  fmt1*5
  double precision, dimension(3) :: convert = (/1.d0,57.29577951d0,57.29577951d0/)
  double precision :: work(norbs),  bi(9), bj(9), sum, limit, bk, eig_min
  double precision, allocatable :: overlap(:), c_lmo(:), comp(:), store_eigs(:)
  double precision, allocatable :: overlap2(:,:)
  double precision, external :: seconds, reada
  character, dimension(:), allocatable :: namo_tmp*4, letters*1
  character :: fmt8p4*5, fmt9p3*5, fmt10p1*5, fmt10p2*5, fmt10p3*5, fmt9p4*5, fmt10p4*5, fmtnnp4*5, fmt9p5*5, &
  fmt13p5*5, fmt13p6*5, fmt7p4*5, irc_or_drc*1, num*1
  integer :: iwork(norbs), ifact(norbs + 1)
  integer, allocatable :: icomp(:), eigs_map(:)
  integer, external :: ijbo
  character, dimension (23) :: tyr
  save :: first, opt_hook, atoms, paras, orbs, compressed, fmt8p4, fmt9p3, fmt10p1, fmt10p2, fmt10p3, fmt9p4, fmt10p4, &
  fmt9p5, fmt13p5, fmt13p6, fmt7p4, mos, irc, irc_or_drc, moa_lower, moa_upper, jloop, L_overlap, L_MO_s, L_Density, &
  mob_lower, mob_upper, lnmoas, lnmobs, loc_mos, new_calcn, orbs2, l_RC
  data atorbs/ ' S', 'PX', 'PY', 'PZ', 'X2', 'XZ', 'Z2', 'YZ', 'XY'/
  data tyr / "G", "A", "V", "L", "I", "S", "T", "D", "N", "K", "E", "Q", &
     & "R", "H", "F", "C", "W", "Y", "M", "P", "P", "P", "?" /

!
!   Take special action to output essential data in a compact ASCII form
!
  inquire(unit=hook, opened=opend)
  if (.not. opend .or. new_calcn) then
    new_calcn = .false.
    first = .true.
    if (index(text, "Leaving MOPAC") + index(text, "END_OF_JOB") /= 0) then
      new_calcn = .true.
      return
    end if
    l_RC = (index(keywrd, " IRC") + index(keywrd," DRC") > 0)
    open(unit=hook,file=output_fn(:len_trim(output_fn) - 4)//".aux")
    if (.not. opend) then
      write(hook,"(a)")" START OF MOPAC PROGRAM"
    end if
    write(hook,"(a)")" START OF MOPAC FILE"
    write(hook,"(a)")" ####################################"
    write(hook,"(a)")" #                                  #"
    write(hook,"(a)")" #       Start of Input data        #"
    write(hook,"(a)")" #                                  #"
    write(hook,"(a)")" ####################################"
    write(hook,"(a,a)")" MOPAC_VERSION=",verson
    call fdate (idate)
    write(hook,"(3a)")" DATE=""",idate,""""
    if (method_mndo) then
      write(hook,"(a)")" METHOD=MNDO"
    else if (method_am1) then
      write(hook,"(a)")" METHOD=AM1"
    else if (method_pm3) then
      write(hook,"(a)")" METHOD=PM3"
    else if (method_pm6) then
      i = index(keywrd, " PM6") + 1
      j = index(keywrd(i:), " ") + i - 2
      write(hook,"(a)")" METHOD="//keywrd(i:j)
    else if (method_pm7) then
      write(hook,"(a)")" METHOD=PM7"
    else if (method_rm1) then
      write(hook,"(a)")" METHOD=RM1"
    else if (method_mndod) then
      write(hook,"(a)")" METHOD=MNDOD"
    end if
    line = koment
    if (len_trim(line) > 1) then
      do
        if (line(1:1) /= " ") exit
        line = line(2:)
      end do
    end if
    write(hook,"(a,a)")" TITLE=""",trim(line)//'"'
    line = trim(keywrd)
    do i = 1, len_trim(line)
      do
        if (line(i:i + 1) /= "  ") exit
        if (line(i:) == " ") exit
        line(i:) = line(i + 1:)
      end do
    end do
    write(hook,"(a,a)")" KEYWORDS=""",trim(line)//'"'
    line = title
    if (len_trim(line) > 0) then
      do
        if (line(1:1) /= " ") exit
        line = line(2:)
      end do
    end if
    write(hook,"(a,a)")" COMMENTS=""",trim(line)//'"'
    j = int(log10(numat*1.0001)) + 2
    write(atoms,'(i1,a,i1)')j, ".", j
    j = int(log10(numat*3.0001)) + 2
    write(paras,'(i1,a,i1)')j, ".", j
    j = int(log10(norbs*1.0001)) + 2
    write(orbs,'(i1,a,i1)')j, ".", j
    j = int(log10(norbs**2*1.0001)) + 2
    if (j > 9) then
      write(orbs2,'(i2,a,i2)')j, ".", j
    else
      write(orbs2,'(i1,a,i1)')j, ".", j
    end if
    mos = 10
    i = index(keywrd, " AUX(")
    if (i /= 0) then
      j = index(keywrd(i:),") ") + i
      k = i + 5
      if (ichar(keywrd(k:k)) >= ichar("0") .and. ichar(keywrd(k:k)) <= ichar("9")) then
        opt_hook = nint(reada(keywrd(i:j),1))
        opt_hook = max(0, min(opt_hook,100))
      else
        opt_hook = hook
      end if
      compressed = (index(keywrd(i:j), "COMP") /= 0)
      L_overlap = (index(keywrd(i:j), "XS") == 0)
      L_MO_s    = (index(keywrd(i:j), "XW") == 0)
      L_Density = (index(keywrd(i:j), "XP") == 0)
      k = index(keywrd(i:j), "MOS")
      if (k > 0) mos = nint(reada(keywrd(i:), k))
    else
      compressed = .false.
      opt_hook = hook
      L_overlap = .true.
      L_MO_s    = .true.
      L_Density = .true.
    end if
    if(index(keywrd," LARGE") == 0) then
        moa_lower = max(1, nclose - mos + 1, nalpha - mos + 1)
        moa_upper = min(norbs, max(nclose + mos, nalpha + mos))
        lnmoas = (moa_upper - moa_lower > -1)
        mob_lower = max(1, nclose - mos + 1, nalpha - mos + 1)
        mob_upper = min(norbs, max(nclose + mos, nalpha + mos))
        lnmobs = (mob_upper - mob_lower > -1)
      else
        moa_lower = 1
        moa_upper = norbs
        mob_lower = 1
        mob_upper = norbs
        lnmobs = .true.
        lnmoas = .true.
      end if
    k = 0
    if (i > 0) k = index(keywrd(i:j), "PRECISION")
    if (k > 0) k = nint(reada(keywrd(i:), k))
    write(fmt7p4,"(i2.2,'.',i2.2)")7 + k, 4 + k
    write(fmt8p4,"(i2.2,'.',i2.2)")8 + k, 4 + k
    write(fmt9p3,"(i2.2,'.',i2.2)")9 + k, 3 + k
    write(fmt9p4,"(i2.2,'.',i2.2)")9 + k, 4 + k
    write(fmt9p5,"(i2.2,'.',i2.2)")9 + k, 5 + k
    write(fmt10p1,"(i2.2,'.',i2.2)")10 + k, 1 + k
    write(fmt10p2,"(i2.2,'.',i2.2)")10 + k, 2 + k
    write(fmt10p3,"(i2.2,'.',i2.2)")10 + k, 3 + k
    write(fmt10p4,"(i2.2,'.',i2.2)")10 + k, 4 + k
    write(fmt13p5,"(i2.2,'.',i2.2)")13 + k, 5 + k
    write(fmt13p6,"(i2.2,'.',i2.2)")13 + k, 6 + k
!
!  All the data used in defining the starting system
!
    write(hook,"(a,i"//atoms//",a)")" ATOM_EL[",numat,"]="
    write(hook,"(40(' ',a2))")(elemnt(nat(i)), i=1,numat)
    write(hook,"(a,i"//atoms//",a)")" ATOM_CORE[",numat,"]="
    write(hook,"(40(' ',i2))")(nint(tore(nat(i))), i=1,numat)
    write(hook,"(a,i"//paras//",a)")" ATOM_X:ANGSTROMS[",3*numat, "]="
    write(hook,"(3f"//fmt10p4//")") ((coord(j,i),j=1,3), i=1,numat)
    if (norbs > 0) then
      write(hook,"(a,i"//orbs//",a)")" AO_ATOMINDEX[",norbs,"]="
      j = int(log10(norbs*1.0001)) + 2
      write(fmt1,'(i2,a,i2)')120/j, "i", j
      write(hook,"("//fmt1//")")((i,j = nfirst(i),nlast(i)), i = 1, numat)
      write(hook,"(a,i"//orbs//",a)")" ATOM_SYMTYPE[", norbs,"]="
      write(hook,"(40(' ',a2))")&
       ((atorbs(j - nfirst(i) + 1),j = nfirst(i),nlast(i)), i = 1, numat)
      write(hook,"(a,i"//orbs//",a)")" AO_ZETA[",norbs,"]="
!
!   Set up an array to hold all the atomic orbital exponents and principal quantum numbers
!
      j = 1
      do i = 1, numat
        if (nlast(i) - nfirst(i) > -1) then
          work(j) = zs(nat(i))
          iwork(j) = npq(nat(i),1)
          j = j + 1
        end if
        if (nlast(i) - nfirst(i) > 2) then
          work(j:j + 2) = zp(nat(i))
          iwork(j:j + 2) = npq(nat(i),2)
          j = j + 3
        end if
        if (nlast(i) - nfirst(i) > 7) then
          work(j:j + 4) = zd(nat(i))
          iwork(j:j + 4) = npq(nat(i),3)
          j = j + 5
        end if
      end do
      write(hook,"(10f"//fmt8p4//")") (work(i), i=1,norbs)
      write(hook,"(a,i"//orbs//",a)")" ATOM_PQN[",norbs,"]="
      write(hook,"(40i2)")(iwork(i), i=1,norbs)
    end if
    if (norbs > 0) write(hook,"(a,i"//orbs//")")" NUM_ELECTRONS=",nelecs
    if (id > 0) then
      write(hook,"(a,i1,a)")" INITIAL_TRANS_VECTS:ANGSTROMS[",id*3,"]="
      write(hook,"(3f"//fmt9p4//")")((tvec(j,i),j=1,3),i=1,id)
      if (density > 1.d-1) write(hook,"(a,d"//fmt13p6//",a)")" DENSITY:G/CM^3=",density
    end if
    write(hook,"(a)")" EMPIRICAL_FORMULA="""//formula(31:len_trim(formula))//""""
!
!  End of definition of starting system
!
  end if
  if (L_MO_s) L_MO_s = (moa_upper - moa_lower > -1)
  if (nelecs == 0) then
    L_MO_s = .false.
    L_overlap = .false.
    L_Density = .false.
    eigen = .false.
    lnmobs = .false.
    lnmoas = .false.
  end if
!
!  Set up options for various types of calculation
!
  geom_opt         = (index(text,"Geometry optimizing") /= 0)
  normal           = (index(text,"Normal output") /= 0)
  force            = (index(text,"Force output") /= 0)
  LMO              = (index(text,"LMO") /= 0)
  int_force_const  = (index(text,"Internal Force Constants") /= 0)
  error            = (index(text,": ERROR:") /= 0)
  finished         = (index(text,"Leaving MOPAC") /= 0)
  end_of_job       = (index(text,"END_OF_JOB") /= 0)
  mullik           = (index(text,"Mullik") /= 0)
  esp              = (index(text,"Esp") /= 0)
  irc_drc          = (index(text,"IRC-DRC") /= 0)
  loc_mos          = (index(text,"Localized") /= 0)
  polar            = (index(text,"POLAR") /= 0)
  reaction_path    = (index(text,"Reaction path") /= 0)
  if (geom_opt) geom_opt = (lparam == 0 .and. latom == 0)
  if (.not. l_RC .and. (geom_opt .or. first)) then
    if (first) then
      write(opt_hook,"(a)",iostat=i)" ####################################"
      if (i /= 0) then
        write(iw,'(/5x,a,i3,a)') "WARNING: Channel", opt_hook, " cannot be opened"
        open(unit=opt_hook, file=trim(jobnam)//'_opt.aux')
        write(iw,'(3x,a)') "- intermediate results will be sent to '"//trim(jobnam)//"_opt.aux'"
        if (opt_hook /= 0) then
          write(iw,'(5x,a,/)') "(Try using chanel 0 if you want to avoid having intermediate results written out.)"
        else
          write(iw,'(5x,a)') " "
        end if
        write(opt_hook,"(a)")" ####################################"
      end if
      write(opt_hook,"(a)")" #                                  #"
      if (lparam /= 0 .and. latom /= 0 .or. l_RC) then
        write(opt_hook,"(a)")" #          Reaction path           #"
      else
        write(opt_hook,"(a)")" #      Geometry optimization       #"
      end if
      write(opt_hook,"(a)")" #                                  #"
      write(opt_hook,"(a)")" ####################################"
      first = .false.
    end if
!
!  Geometry updated.
!
    if (abs(escf) > 1.d-30) then
      write(opt_hook,"(a,sp, d"//fmt13p6//",a)")" HEAT_OF_FORM_UPDATED:KCAL/MOL=",escf
      write(opt_hook,"(a,sp, d"//fmt13p6//",a)")" GRADIENT_UPDATED:KCAL/MOL/ANG=",gnorm

      write(opt_hook,"(a,i"//paras//",a)")" ATOM_X_UPDATED:ANGSTROMS[",3*numat, "]="
      write(opt_hook,"(3f"//fmt10p4//")") ((coord(j,i),j=1,3), i=1,numat)
      if (id > 0) then
        write(opt_hook,"(a,i1,a)")" TRANS_VECTS_UPDATED:ANGSTROMS[",id*3,"]="
        write(opt_hook,"(3f"//fmt9p4//")")((tvec(j,i),j=1,3),i=1,id)
        if (density > 1.d-1) write(opt_hook,"(a,d"//fmt13p6//",a)")" DENSITY:G/CM^3=",density
      end if
    end if
    if (opt_hook == 0) call flush (0)
    return
  else if (irc_drc) then
    if (first) then
      if (index(keywrd, " DRC") == 0) then
        irc_or_drc = "I"
        irc = .true.
      else
        irc_or_drc = "D"
        irc = .false.
      end if
      write(opt_hook,"(a)")" ####################################"
      write(opt_hook,"(a)")" #                                  #"
      write(opt_hook,"(a)")" #               "//irc_or_drc//"RC                #"
      write(opt_hook,"(a)")" #                                  #"
      write(opt_hook,"(a)")" ####################################"
      first = .false.
    end if
!
!  Geometry updated.
!
    jloop = jloop + 1
    write(opt_hook,"(a,i5.5)")" REF_POINT=",jloop
    write(opt_hook,"(a,sp, d"//fmt13p6//",a)")" MOVEMENT:ANGSTROMS=",rxn_coord
    write(opt_hook,"(a,sp, d"//fmt13p6//",a)")" POTENTIAL:KCAL/MOL=",rc_escf
    if (irc) then
      write(opt_hook,"(a,sp, d"//fmt13p6//",a)")" ENERGY_LOST:KCAL/MOL=",ekin
    else
      write(opt_hook,"(a,sp, d"//fmt13p6//",a)")" KINETIC_ENERGY:KCAL/MOL=",ekin
      write(opt_hook,"(a,sp, d"//fmt13p6//",a)")" ELAPSED_TIME:FS=",time
    end if
    write(opt_hook,"(a,i"//paras//",a)")" ATOM_X_UPDATED:ANGSTROMS[",3*numat, "]="
    write(opt_hook,"(3f"//fmt10p4//")") ((coord(j,i),j=1,3), i=1,numat)
    if (L_MO_s) &
    call print_conventional_M_O_s(opt_hook, compressed, moa_lower, moa_upper, mob_lower, mob_upper, fmt9p4, orbs2)
    if (L_MO_s) &
    call print_M_O_data(hook, moa_lower, moa_upper, lnmoas, mob_lower, mob_upper, lnmobs, orbs, fmt9p3)
    call chrge (p, q)
    q(:numat) = tore(nat(:numat)) - q(:numat)
    write(opt_hook,"(a,i"//atoms//",a)")" ATOM_CHARGES[",numat,"]="
    write(opt_hook,"(sp,10f"//fmt9p5//")") (q(i), i=1,numat)
    if (index(keywrd, " BOND") /= 0)  then
      if (allocated(bondab)) deallocate(bondab)
      call write_screen_bonds(compressed, orbs2, hook, fmt9p4)
    end if
    if (opt_hook == 0) call flush (0)
    return
  else if (normal) then!  Calculated results common to most types of calculation
    write(hook,"(a)")" ####################################"
    write(hook,"(a)")" #                                  #"
    write(hook,"(a)")" #        Final SCF results         #"
    write(hook,"(a)")" #                                  #"
    write(hook,"(a)")" ####################################"

    write(hook,"(a,sp, d"//fmt13p6//",a)")" HEAT_OF_FORMATION:KCAL/MOL=",escf
    write(hook,"(a,sp, d"//fmt13p6//",a)")" GRADIENT_NORM:KCAL/MOL/ANGSTROM=",gnorm
    write(hook,"(a,a)")" POINT_GROUP=",name
    if (id > 0) then
      write(hook,"(a,i1,a)")" TRANS_VECTS:ANGSTROMS[",id*3,"]="
      write(hook,"(3f"//fmt9p4//")")((tvec(j,i),j=1,3),i=1,id)
      if (density > 1.d-1) write(hook,"(a,d"//fmt13p6//",a)")" DENSITY:G/CM^3=",density
      if (Abs(press(1)) > 1.d-20) then
        write(hook,"(a,i1,a)")" RESTRAINING_PRESSURE:GIGAPASCALS[3]="
        write(hook,"(3f"//fmt13p5//")")(press(i),i=1,3)
      end if
    end if
#ifdef MOPAC_F2003
    if (.not. ieee_is_nan(dip(4,3))) then
#else
    if (.not. isnan(dip(4,3))) then
#endif
      if (Abs(dip(4,3)) > 1.d-20) then
        write(hook,"(a,sp, d"//fmt13p6//", a)")" DIPOLE:DEBYE=",dip(4,3)
        write(hook,"(a,sp, 3d"//fmt13p5//", a)")" DIP_VEC:DEBYE[3]=",(dip(i,3), i = 1, 3)
      end if
    end if
    if (no_pKa > 0) then
      num = char(ichar("1") +int(log10(ipKa_sorted(1) + 0.05)))
      write(hook,"(a,i"//num//")")" HYDROGEN_ATOM_NO_FOR_PKA=",ipKa_sorted(1)
      write(hook,"(a,sp, d"//fmt13p6//",a)")" PKA_OF_MOST_IONIZABLE_HYDROGEN=",pKa_sorted(1)
    end if
    if (area > 1.d-6) then
      write(hook,"(a,sp, d"//fmt13p6//",a)")" AREA:SQUARE ANGSTROMS=",area
      write(hook,"(a,sp, d"//fmt13p6//",a)")" VOLUME:CUBIC ANGSTROMS=",cosvol
      if (Abs(solv_energy) > 1.d-6) write(hook,"(a,sp, d"//fmt13p6//",a)")" DIEL_ENER:EV=",solv_energy
    end if
    if (.not. mozyme) then
      if (nalpha > 0) then
        eig_min = -eigs(nalpha)
        if (nbeta > 0) eig_min = min(eig_min,-eigb(nbeta))
      else if (nelecs == 1) then
        eig_min = -eigs(1)
      else if (nelecs > 1) then
        if (nopen > 0) eig_min = -eigs(nopen)
        if (nclose > 0) eig_min = min(eig_min,-eigs(nclose))
!   CORRECTION TO I.P. OF DOUBLETS
        if (nopen - nclose == 1 .and. fract <= 1.99D0) eig_min = eig_min + 0.5D0*rjkab(1,1)
      end if
      if (nelecs > 0) write(hook,"(a,sp, d"//fmt13p6//",a)")" IONIZATION_POTENTIAL:EV=",eig_min
    end if
    write(hook,"(a,sp, d"//fmt13p6//",a)")" SPIN_COMPONENT=",sz
    write(hook,"(a,sp, d"//fmt13p6//",a)")" TOTAL_SPIN=",ss2
    num = char(ichar("1") +int(log10(nscf + 0.05)))
    write(hook,"(a,i"//num//")")" NUMBER_SCF_CYCLES=",nscf
    if (uhf) then
      num = char(ichar("1") +int(log10(nalpha + 0.05)))
      write(hook,"(a,i"//num//")")" NUM_ALPHA_ELECTRONS=",nalpha
      num = char(ichar("1") +int(log10(nbeta + 0.05)))
      write(hook,"(a,i"//num//")")" NUM_BETA_ELECTRONS=",nbeta
    end if
      sum = seconds(1) - time0
      i = int(sum*0.000001D0)
      sum = sum - i*1000000
    write(hook,"(a,sp, d"//fmt13p6//",a)")" CPU_TIME:SEC=",sum
    write(hook,"(a,sp, d"//fmt13p6//",a)")" MOLECULAR_WEIGHT:AMU=",mol_weight
    write(hook,"(a,i"//paras//",a)")" ATOM_X_OPT:ANGSTROMS[",3*numat, "]="
    write(hook,"(3f"//fmt10p4//")") ((coord(j,i),j=1,3), i=1,numat)
    if(nelecs == 0)then
      call chrge (p, q)
      q(:numat) = tore(nat(:numat)) - q(:numat)
    end if
    write(hook,"(a,i"//atoms//",a)")" ATOM_CHARGES[",numat,"]="
    write(hook,"(sp,10f"//fmt9p5//")") (q(i), i=1,numat)
    write(hook,"(a,i"//orbs//",a)")" AO_CHARGES[",norbs,"]="
    if (mozyme) then
      write(hook,"(10f"//fmt9p5//")") (p(idiag(i)), i=1,norbs)
    else
      write(hook,"(10f"//fmt9p5//")") (p((i*(i+1))/2), i=1,norbs)
      if (uhf) then
        write(hook,"(a,i"//orbs//",a)")" AO_SPINS[",norbs,"]="
        write(hook,"(sp,10f"//fmt9p5//")") (pa((i*(i+1))/2)-pb((i*(i+1))/2), i=1,norbs)
      end if
    end if
    if (nvar > 0) then
      sum = 0.d0
      do i = 1, nvar
        if (abs(grad(i)) > sum) sum = abs(grad(i))
      end do
      if (sum > 1.d-4) then
        write(hook,"(a,i"//paras//",a)")" GRADIENTS:KCAL/MOL/ANGSTROM[",nvar, "]="
        read(fmt9p4,'(3x,i2)')i
        j = max(int(log10(sum)),1)
        write(fmtnnp4,"(i2.2,'.',i2.2)")4 + j + i, i
        write(hook,"(10f"//fmtnnp4//")") (grad(i), i=1,nvar)
      end if
    end if
!
! Write out the residue letter, if it exists.
!
    do i = 1, numat
      do j = 1, size_mres
        if (index(txtatm(i)(8:11), tyres(j)) > 0) exit
      end do
      if (j <= size_mres) exit
    end do
    if (i <= numat) then
      allocate(letters(numat))
      do i = 1, numat
        do j = 1, size_mres
           if (index(txtatm(i)(8:11), tyres(j)) > 0) exit
        end do
        if (j <= size_mres) then
          letters(i) = tyr(j)
        else
          letters(i) = "?"
        end if
      end do
      write(hook,"(a,i"//atoms//",a)")" RESIDUE_LETTER[",numat,"]="
      write(hook,"(100a1)")(letters(i), i = 1, numat)
      deallocate(letters)
    end if
    if (mozyme) then
!
!   Start of MOZYME
!
!
!  Set up an array to hold the overlap matrix
!
      if (L_overlap) then
        if (compressed) then
          write(hook,"(a)")" ####################################"
          write(hook,"(a)")" #                                  #"
          write(hook,"(a)")" #    Compressed Overlap Matrix     #"
          write(hook,"(a)")" #                                  #"
          write(hook,"(a)")" ####################################"
          write(hook,"(a)")" #  Lower half triangle only"
          limit = 0.05d0
          i = min(1000000, max(10000, 50*norbs))
          allocate(comp(i), icomp(i))
          ic = 0
        else
          write(hook,"(a,i"//orbs2//",a)")" OVERLAP_MATRIX[",(norbs*(norbs + 1))/2,"]="
          write(hook,"(a)")" #  Lower half triangle only"
          allocate(overlap2(norbs,9))
        end if
        do i = 1, numat
          if (.not. compressed) overlap2 = 0.d0
          ii = iorbs(i)
          ni = nat(i)
          bi = betas(ni)
          bi(1) = betas(ni)*0.5D0
          bi(2) = betap(ni)*0.5D0
          bi(3) = bi(2)
          bi(4) = bi(2)
          bi(5) = betad(ni)*0.5D0
          bi(6) = bi(5)
          bi(7) = bi(5)
          bi(8) = bi(5)
          bi(9) = bi(5)
          do j = 1, i - 1
            jj = iorbs(j)
            if (i /= j .and. ijbo (i, j) >= 0) then
              nj = nat(j)
              bj(1) = betas(nj)*0.5D0
              bj(2) = betap(nj)*0.5D0
              bj(3) = bj(2)
              bj(4) = bj(2)
              bj(5) = betad(nj)*0.5D0
              bj(6) = bj(5)
              bj(7) = bj(5)
              bj(8) = bj(5)
              bj(9) = bj(5)
              kl = ijbo (i, j)! starting address in H matrix  minus 1
              do i1 = 1, ii
                do j1 = 1, jj
                  sum =h(kl + (i1 - 1)* jj + j1)/(bi(i1) + bj(j1))
                  if (compressed) then
                    if (abs(sum) > limit) then
                      ic = ic + 1
                      k = nfirst(i) + i1 - 1
                      l = nfirst(j) + j1 - 1
                      icomp(ic) = (k*(k - 1))/2 + l
                      comp(ic) = sum
                    end if
                  else
                    overlap2(j1 + nfirst(j) - 1, i1) = sum
                  end if
                end do
              end do
            end if
          end do
!
! Diagonal term
!
          if (compressed) then
            do i1 = 1, ii
              k = nfirst(i) + i1 - 1
              ic = ic + 1
              icomp(ic) = (k*(k + 1))/2
              comp(ic) = 1.d0
            end do
          else
            do i1 = 1, ii
              overlap2(i1 + nfirst(j) - 1, i1) = 1.d0
            end do
          end if
!
! At this point, overlap2 contains the entire overlap matrix for atom i up to atom i
!
          if (.not. compressed) then
            do i1 = 1,ii
              write(hook,"(10f"//fmt9p4//")") (overlap2(j1,i1), j1 = 1, nfirst(i) + i1 -1)
            end do
          end if
        end do
        if (compressed) then
          if (ic < 999) then
            fmt = "3.3"
          else
            fmt = "6.6"
          end if
          j = int(log10((norbs*(norbs + 1))/2*1.0001)) + 2
          write(fmt1,'(i2,a,i2)')120/j, "i", j
          write(hook,"(1x,a,i"//fmt//",a)")" COMPRESSED_OVERLAP_INDICES[",ic,"]="
          write(hook,"("//fmt1//")") (icomp(ii),ii=1,ic)
          write(hook,"(1x,a,i"//fmt//",a)")" COMPRESSED_OVERLAP_VALUES[",ic,"]="
          write(hook,"(10f"//fmt9p4//")") (comp(ii),ii=1,ic)
        end if
      end if
      if (index(keywrd, " BOND") /= 0) then
        if (compressed) then
          write(hook,"(a)")" ####################################"
          write(hook,"(a)")" #                                  #"
          write(hook,"(a)")" #     Compressed Bond Orders       #"
          write(hook,"(a)")" #                                  #"
          write(hook,"(a)")" ####################################"
          write(hook,"(a)")" #  Lower half triangle only"
          limit = 0.05d0
          if (allocated(comp)) deallocate (comp,icomp)
          i =  50*numat
          allocate(comp(i), icomp(i))
        else
          write(hook,"(a,i"//orbs2//",a)")" BOND_ORDERS[",(numat*(numat + 1))/2,"]="
          write(hook,"(a)")" #  Lower half triangle only"
        end if
        ic = 0
        do i = 1, numat
          ii = iorbs(i)
          do j = 1, i
            jj = iorbs(j)
            if (i /= j .and. ijbo (i, j) >= 0) then
              kl = ijbo (i, j) + 1
              ku = kl + ii * jj - 1
              sum = 0.d0
              do k = kl, ku
                sum = sum + p(k) ** 2
              end do
              if (compressed) then
                if (sum > limit) then
                  ic = ic + 1
                  comp(ic) = sum
                  icomp(ic) = (i*(i - 1))/2 + j
                end if
              else
                work(j) = sum
              end if
            end if
          end do
          if (.not. compressed) then
            work(i) = 0.d0
            write(hook,"(10f"//fmt9p4//")") (work(j), j=1, i)
          end if
        end do
        if (compressed) then
          if (ic < 999) then
            fmt = "3.3"
          else
            fmt = "6.6"
          end if
          j = int(log10((numat*(numat + 1))/2*1.0001)) + 2
          write(fmt1,'(i2,a,i2)')120/j, "i", j
          write(hook,"(1x,a,i"//fmt//",a)")" COMPRESSED_BOND_ORDERS_INDICES[",ic,"]="
          write(hook,"("//fmt1//")") (icomp(ii),ii=1,ic)
          write(hook,"(1x,a,i"//fmt//",a)")" COMPRESSED_BOND_ORDERS_VALUES[",ic,"]="
          write(hook,"(10f"//fmt9p4//")") (comp(ii),ii=1,ic)
        end if
      end if! Bond orders
!
! Construct map of LMO energy levels
!
      allocate (store_eigs(norbs), eigs_map(norbs))
      store_eigs(:norbs) = eigs(:norbs)
      ii = 1
      do i = 1, noccupied
        eig_min = 1.d7
        do j = 1, noccupied
          if (eigs(j) < eig_min) then
            eig_min = eigs(j)
            ii = j
          end if
        end do
        eigs_map(i) = ii
        eigs(ii) = 1.d8
      end do
      do i = noccupied + 1, norbs
        eig_min = 1.d7
        do j = noccupied + 1, norbs
          if (eigs(j) < eig_min) then
            eig_min = eigs(j)
            ii = j
          end if
        end do
        eigs_map(i) = ii
        eigs(ii) = 1.d8
      end do
      eigs(:norbs) = store_eigs(:norbs)
      if (L_MO_s) then
        write(hook,"(a,2i8)")" SET_OF_MOS=",moa_lower, moa_upper
        if (moa_lower > 1 .or. moa_upper < norbs) write(hook,"(a)") &
        " # To print all the molecular orbitals, add keyword LARGE or use MOS=99999 in AUX  #"
        i = max(noccupied, nvirtual)
        allocate (c_lmo(norbs*i))
        eigen = (index(keywrd, " EIGEN") /= 0)
        if (eigen) then
          call lmo_to_eigenvectors(noccupied, ncf, nncf, ncocc, noccupied, &
           & icocc, icocc_dim, cocc, cocc_dim, eigs, c_lmo)
          if (compressed) then
            do i = moa_lower, noccupied
              call write_comp_vect(hook, c_lmo((i - 1)*norbs + 1), norbs, 0.002d0, .true., &
              "EIGENVECTOR_INDICES","EIGENVECTOR_COEFFICIENTS", fmt9p4)
            end do
          else
            write(hook,"(a,i"//orbs2//",a)")" EIGENVECTORS[",norbs*(moa_upper - moa_lower + 1),"]="
            write(hook,"(10f"//fmt9p4//")") ((c_lmo(j + (i - 1)*norbs), j=1,norbs), i=moa_lower,noccupied)
          end if
          call lmo_to_eigenvectors(nvirtual, nce, nnce, ncvir, nvirtual, icvir, &
           & icvir_dim, cvir, cvir_dim, eigs(noccupied + 1), c_lmo)
          if (compressed) then
            do i = 1, moa_upper - noccupied
              call write_comp_vect(hook, c_lmo((i - 1)*norbs + 1), norbs, 0.002d0, .true., &
              "EIGENVECTOR_INDICES","EIGENVECTOR_COEFFICIENTS", fmt9p4)
            end do
          else
            write(hook,"(10f"//fmt9p4//")") ((c_lmo(j + (i - 1)*norbs), j=1,norbs), i= 1, moa_upper - noccupied)
          end if
        else
          if (compressed) then
            write(hook,"(a)")" ####################################"
            write(hook,"(a)")" #                                  #"
            write(hook,"(a)")" #     Compressed LMO vectors       #"
            write(hook,"(a)")" #                                  #"
            write(hook,"(a)")" ####################################"
          else
            write(hook,"(a,i"//orbs2//",a)")" LMO_VECTORS[",norbs*(moa_upper - moa_lower +1),"]="
          end if
!
          do i_map = moa_lower, noccupied
            i = eigs_map(i_map)
!
! Expand i'th occupied LMO into uncompressed format
!
            c_lmo = 0.d0
            ii = ncocc(i)
            do j = nncf(i) + 1, nncf(i) + ncf(i)
              jj = icocc(j)
              do k = nfirst(jj), nlast(jj)
                ii = ii + 1
                c_lmo(k) = cocc(ii)
              end do
            end do
            if (compressed) then
              call write_comp_vect(hook, c_lmo, norbs, 0.002d0, .true., &
                "LMO_INDICES","LMO_COEFFICIENTS", fmt9p4)
            else
              write(hook,"(10f"//fmt9p4//")") (c_lmo(j), j=1,norbs)
            end if
          end do
          do i_map = 1, moa_upper - noccupied
             i = eigs_map(i_map + nclose) - nclose
!
! Expand i'th virtual LMO into uncompressed format
!
            c_lmo = 0.d0
            ii = ncvir(i)
            do j = nnce(i) + 1, nnce(i) + nce(i)
              jj = icvir(j)
              do k = nfirst(jj), nlast(jj)
                ii = ii + 1
                c_lmo(k) = cvir(ii)
              end do
            end do
            if (compressed) then
              call write_comp_vect(hook, c_lmo, norbs, 0.002d0, .true., &
              "LMO_INDICES","LMO_COEFFICIENTS", fmt9p4)
            else
              write(hook,"(10f"//fmt9p4//")") (c_lmo(j), j=1,norbs)
            end if
          end do
        end if
      end if

      if (L_Density) then
        if (compressed) then
          write(hook,"(a)")" ####################################"
          write(hook,"(a)")" #                                  #"
          write(hook,"(a)")" #    Compressed Density Matrix     #"
          write(hook,"(a)")" #                                  #"
          write(hook,"(a)")" ####################################"
          write(hook,"(a)")" #  Lower half triangle only"
          limit = 0.05d0
          ic = 0
        else
          write(hook,"(a,i"//orbs2//",a)")" DENSITY_MATRIX[",(norbs*(norbs + 1))/2,"]="
          write(hook,"(a)")" #  Lower half triangle only."
        end if
        if (.not. allocated(overlap2)) allocate(overlap2(norbs,9))
        if (allocated(comp)) deallocate(comp, icomp)
        i = min(1000000, max(10000, 50*norbs))
        allocate(comp(i), icomp(i))
        do i = 1, numat
          if(.not. compressed) overlap2 = 0.d0
          ii = iorbs(i)
          do j = 1, i - 1
            jj = iorbs(j)
            if (i /= j .and. ijbo (i, j) >= 0) then
              ij = ijbo (i, j)! starting address in P matrix  minus 1
              do i1 = 1, ii
                do j1 = 1, jj
                  sum = p(ij + ((i1 - 1)*i1)/2 + j1)
                  if (compressed) then
                    if (abs(sum) > limit) then
                      ic = ic + 1
                      k = nfirst(i) + i1 - 1
                      l = nfirst(j) + j1 - 1
                      icomp(ic) = (k*(k - 1))/2 + l
                      comp(ic) = sum
                    end if
                  else
                    overlap2(j1 + nfirst(j) - 1, i1) = sum
                  end if
                end do
              end do
            end if
          end do
!
! Diagonal term
!
          ij = ijbo (i, i)
          do i1 = 1, ii
            do j1 = 1, i1
              sum = p(ij + ((i1 - 1)*i1)/2 + j1)
              if (compressed) then
                if (abs(sum) > limit) then
                  ic = ic + 1
                  k = nfirst(i) + i1 - 1
                  l = nfirst(j) + j1 - 1
                  icomp(ic) = (k*(k - 1))/2 + l
                  comp(ic) = sum
                end if
              else
                overlap2(j1 + nfirst(j) - 1, i1) = sum
              end if
            end do
          end do
!
! At this point, overlap2 contains the entire density matrix for atom i up to atom i
!
          if ( .not. compressed) then
            do i1 = 1,ii
              write(hook,"(10f"//fmt9p4//")") (overlap2(j1,i1), j1 = 1, nfirst(i) + i1 -1)
            end do
          end if
        end do
        if (compressed) then
          if (ic < 999) then
            fmt = "3.3"
          else
            fmt = "6.6"
          end if
          j = int(log10((norbs*(norbs + 1))/2*1.0001)) + 2
          write(fmt1,'(i2,a,i2)')120/j, "i", j
          write(hook,"(1x,a,i"//fmt//",a)")" COMPRESSED_DENSITY_INDICES[",ic,"]="
          write(hook,"("//fmt1//")") (icomp(ii),ii=1,ic)
          write(hook,"(1x,a,i"//fmt//",a)")" COMPRESSED_DENSITY_VALUES[",ic,"]="
          write(hook,"(10f"//fmt9p4//")") (comp(ii),ii=1,ic)
        end if
      end if
      if (eigen) then
        write(hook,"(a,i"//orbs//",a)")" EIGENVALUES[",moa_upper - moa_lower + 1,"]="
      else
        if (lnmoas) &
        write(hook,"(a,i"//orbs//",a)")" LMO_ENERGY_LEVELS[",moa_upper - moa_lower + 1,"]="
      end if
      write(hook,"(10f"//fmt9p3//")") (eigs(eigs_map(i)), i=moa_lower, moa_upper)
      if (compressed) then
        if (allocated(icomp)) deallocate (icomp)
        if (allocated(comp)) deallocate (comp)
      else
        if (allocated(overlap2)) deallocate (overlap2)
      end if
      if (allocated(c_lmo)) deallocate (c_lmo)
      if (allocated(eigs_map)) deallocate (eigs_map)
      if (allocated(store_eigs)) deallocate (store_eigs)
!
!   End of MOZYME part
!
    else
!
!   Conventional matrix-algebra method
!
!
!  Set up an array to hold the overlap matrix
!
      do i = 1, norbs
        ifact(i) = (i*(i - 1))/2
      end do
      ifact(norbs+1) = (norbs*(norbs + 1))/2
      allocate(overlap((norbs*(norbs + 1))/2))
      overlap = 0.d0
      do i = 1, numat
        if = nfirst(i)
        im1 = i - 1
        ni = nat(i)
        bi = betas(ni)
        bi(1) = betas(ni)*0.5D0
        bi(2) = betap(ni)*0.5D0
        bi(3) = bi(2)
        bi(4) = bi(2)
        bi(5) = betad(ni)*0.5D0
        bi(6) = bi(5)
        bi(7) = bi(5)
        bi(8) = bi(5)
        bi(9) = bi(5)
        norbi = natorb(ni)
        do j = 1, im1
          nj = nat(j)
          bj(1) = betas(nj)*0.5D0
          bj(2) = betap(nj)*0.5D0
          bj(3) = bj(2)
          bj(4) = bj(2)
          bj(5) = betad(nj)*0.5D0
          bj(6) = bj(5)
          bj(7) = bj(5)
          bj(8) = bj(5)
          bj(9) = bj(5)
          norbj = natorb(nj)
          jf = nfirst(j)
          do ii = 1, norbi
            do jj = 1, norbj
              ij = ((if + ii - 1)*(if + ii - 2))/2 + jf + jj - 1
              overlap(ij) = h(ij)/(bi(ii) + bj(jj))
            end do
          end do
        end do
      end do
      overlap(ifact(2:norbs+1)) = 1.D0
      if (compressed .and. L_Overlap) then
        call write_comp_vect(hook, overlap, ((norbs*(norbs + 1))/2), 0.0001d0, .false., &
        "OVERLAP_INDICES","OVERLAP_COEFFICIENTS", fmt9p4)
      else if (L_Overlap) then
        write(hook,"(a,i"//orbs2//",a)")" OVERLAP_MATRIX[",(norbs*(norbs + 1))/2,"]="
        write(hook,"(a)")" #  Lower half triangle only"
        write(hook,"(10f"//fmt9p4//")") (overlap(i), i=1,(norbs*(norbs + 1))/2)
      end if
      deallocate (overlap)

      if (L_MO_s) &
      call print_conventional_M_O_s(hook, compressed, moa_lower, moa_upper, mob_lower, mob_upper, fmt9p4, orbs2)

      if (L_Density) then
        if (uhf) then
          if (compressed) then
            call write_comp_vect(hook, pa, ((norbs*(norbs + 1))/2), 0.0005d0, .false., &
              "ALPHA_DENSITY_MATRIX_INDICES","ALPHA_DENSITY_MATRIX_COEFFICIENTS", fmt9p4)
            call write_comp_vect(hook, pb, ((norbs*(norbs + 1))/2), 0.0005d0, .false., &
              "BETA_DENSITY_MATRIX_INDICES","BETA_DENSITY_MATRIX_COEFFICIENTS", fmt9p4)
          else
            write(hook,"(a,i"//orbs2//",a)")" ALPHA_DENSITY_MATRIX[",(norbs*(norbs + 1))/2,"]="
            write(hook,"(a)")" #  Lower half triangle only"
            write(hook,"(10f"//fmt9p4//")") (pa(i), i=1,(norbs*(norbs + 1))/2)
            write(hook,"(a,i"//orbs2//",a)")" BETA_DENSITY_MATRIX[",(norbs*(norbs + 1))/2,"]="
            write(hook,"(a)")" #  Lower half triangle only"
            write(hook,"(10f"//fmt9p4//")") (pb(i), i=1,(norbs*(norbs + 1))/2)
          end if
        else
          if (compressed) then
            call write_comp_vect(hook, p, ((norbs*(norbs + 1))/2), 0.0005d0, .false., &
              "DENSITY_MATRIX_INDICES","DENSITY_MATRIX_COEFFICIENTS", fmt9p4)
          else if (L_Density) then
            write(hook,"(a,i"//orbs2//",a)")" TOTAL_DENSITY_MATRIX[",(norbs*(norbs + 1))/2,"]="
            write(hook,"(a)")" #  Lower half triangle only"
            write(hook,"(10f"//fmt9p4//")") (p(i), i=1,(norbs*(norbs + 1))/2)
          end if
        end if
      end if
      if (index(keywrd, " FOCK") /= 0) then
        if (uhf) then
          write(hook,"(a,i"//orbs2//",a)")" ALPHA_FOCK_MATRIX[",(norbs*(norbs + 1))/2,"]="
        else
          write(hook,"(a,i"//orbs2//",a)")" FOCK_MATRIX[",(norbs*(norbs + 1))/2,"]="
        end if
        write(hook,"(a)")" #  Lower half triangle only"
        write(hook,"(10f"//fmt9p4//")") (f(i), i=1,(norbs*(norbs + 1))/2)
        if (uhf) then
          write(hook,"(a,i"//orbs2//",a)")" BETA_FOCK_MATRIX[",(norbs*(norbs + 1))/2,"]="
          write(hook,"(a)")" #  Lower half triangle only"
          write(hook,"(10f"//fmt9p4//")") (fb(i), i=1,(norbs*(norbs + 1))/2)
        end if
      end if
      if (index(keywrd, " BOND") /= 0)  &
        call write_screen_bonds(compressed, orbs2, hook, fmt9p4)
      if (L_MO_s) &
      call print_M_O_data(hook, moa_lower, moa_upper, lnmoas, mob_lower, mob_upper, lnmobs, orbs, fmt9p3)
    end if
!
!   Molecular orbital occupancies
!
    if (uhf) then
      if (lnmoas) then
        write(hook,"(a,i5.5,a)")" ALPHA_MOLECULAR_ORBITAL_OCCUPANCIES[",moa_upper - moa_lower + 1,"]="
        write(hook,"(40i2)")(1, i = moa_lower, nalpha),(0, i = nalpha + 1, moa_upper)
      end if
      if (lnmobs) then
        write(hook,"(a,i5.5,a)")" BETA_MOLECULAR_ORBITAL_OCCUPANCIES[",mob_upper - mob_lower + 1,"]="
        write(hook,"(40i2)")(1, i = mob_lower, nbeta),(0, i = nbeta + 1, mob_upper)
      end if
    else
      if (nmos == 0) then
        if (lnmoas) then
!
!   Simple closed shell RHF
!
          write(hook,"(a,i5.5,a)")" MOLECULAR_ORBITAL_OCCUPANCIES[",moa_upper - moa_lower + 1,"]="
          write(hook,"(10f"//fmt7p4//")")(2.d0, i = moa_lower, nclose),(0.d0, i = nclose + 1, moa_upper)
        end if
      else
        if (lnmoas) then
!
!   RHF-C.I.: Recalculate M.O. occupancies of the active space
!
          write(hook,"(a,i5.5,a)")" MOLECULAR_ORBITAL_OCCUPANCIES[",moa_upper - moa_lower + 1,"]="
          if (nelec > 0) then
            write(hook,"(a)")" #  Below active space"
            write(hook,"(10f"//fmt7p4//")")(2.d0, i = moa_lower, nelec)
            write(hook,"(a)")" #  Active space"
            write(hook,"(10f"//fmt7p4//")")(2.d0*occa(i) + deltap(i,i), i = 1, nmos)
            if (nelec + nmos + 1 <= moa_upper) then
              write(hook,"(a)")" #  Above active space"
              write(hook,"(10f"//fmt7p4//")")(0.d0, i = nelec + nmos + 1, moa_upper)
            end if
          end if
!
!  Microstates
!
          write(hook,"(a,i"//orbs//")")" SIZE_OF_ACTIVE_SPACE=",nmos
          write(hook,"(a,i"//orbs//")")" NUMBER_MICROSTATES=",lab
          write(hook,"(a)")" #  microstate configurations are alpha first, then beta. One configuration per line"
          write(hook,"(a,i5.5,a)")" MICROSTATE_CONFIGURATIONS[",2*lab*nmos,"]="
          do i = 1, lab
            write(hook,"(25i5)")(microa(j,i),j = 1, nmos), (microb(j,i),j = 1, nmos)
          end do
          write(hook,"(a,i5)")" STATE_REQUESTED=", root_requested
          write(hook,"(a,i"//orbs//")")" STATE_DEGENERACY=",nstate
          write(hook,"(a,i5.5,a)")" STATE_VECTOR[",lab*nstate,"]="
          do i = 1, nstate
            write(hook,"(10f"//fmt9p4//")") (vectci(j + (i - 1)*lab), j=1,lab)
          end do
          write(hook,'('' STATE="'',i2,1x,3A)') state_QN, state_spin, trim(state_Irred_Rep)//'"'
          write(hook,"(a,sp, d"//fmt13p6//",a)")" STATE_ENERGY_ABSOLUTE:EV=",eig(root_requested)
          write(hook,"(a,sp, d"//fmt13p6//",a)")" STATE_ENERGY_RELATIVE:EV=",eig(root_requested) - eig(1)
        end if
      end if
    end if

    if (LMO) then
      if (uhf) then
        if (LMO_alpha) then
          LMO_alpha = .false.
          write(hook,"(a,i"//orbs2//",a)")" ALPHA_LMO_MO[",norbs*nalpha,"]="
          write(hook,"(10f"//fmt9p4//")") ((c(j,i), j=1,norbs), i=1,nalpha)
          write(hook,"(a,i"//orbs//",a)")" ALPHA_LMO_E[",nalpha,"]="
        write(hook,"(10f"//fmt9p3//")") (eigs(i), i=1,nalpha)
        else
          write(hook,"(a,i"//orbs2//",a)")" BETA_LMO_MO[",norbs*nbeta,"]="
          write(hook,"(10f"//fmt9p4//")") ((cb(j,i), j=1,norbs), i=1,nbeta)
          write(hook,"(a,i"//orbs//",a)")" BETA_LMO_E[",nbeta,"]="
        write(hook,"(10f"//fmt9p3//")") (eigb(i), i=1,nbeta)
        end if
      else
        write(hook,"(a,i"//orbs2//",a)")" LMO_MO[",norbs*nclose,"]="
        write(hook,"(10f"//fmt9p4//")") ((c(j,i), j=1,norbs), i=1,nclose)
        write(hook,"(a,i"//orbs//",a)")" LMO_E[",nclose,"]="
        write(hook,"(10f"//fmt9p3//")") (eigs(i), i=1,nclose)
      end if
    end if
  else if (reaction_path) then
    write(hook,"(a,sp, d"//fmt13p6//",a)")" HEAT_OF_FORMATION:KCAL/MOL=",escf
    write(hook,"(a,i"//paras//",a)")" ATOM_X_OPT:ANGSTROMS[",3*numat, "]="
    write(hook,"(3f"//fmt10p4//")") ((coord(j,i),j=1,3), i=1,numat)
    if (index(keywrd, " BOND") /= 0)  &
      call write_screen_bonds(compressed, orbs2, hook, fmt9p4)
  else if (mullik) then
    write(hook,"(a,i"//atoms//",a)")" MULLIKEN_ATOM_CHARGES[",numat,"]="
    write(hook,"(sp,10f9.5)") (chrg(i), i=1,numat)
  else if (esp) then
    write(hook,"(a,i"//atoms//",a)")" ELECTROSTATIC_POTENTIAL_CHARGES[",numat,"]="
    write(hook,"(sp,10f9.5)") (q(i), i=1,numat)
  else if (loc_mos) then
    if (uhf) then
      if ((index(text,"alpha") /= 0)) then
        write(hook,"(a,i"//orbs2//",a)")" ALPHA_LMO_MO[",norbs*nalpha,"]="
        write(hook,"(10f"//fmt9p4//")") ((c(j,i), j=1,norbs), i=1,nalpha)
        write(hook,"(a,i"//orbs//",a)")" ALPHA_LMO_E[",nalpha,"]="
      write(hook,"(10f"//fmt9p3//")") (eigs(i), i=1,nalpha)
      else
        write(hook,"(a,i"//orbs2//",a)")" BETA_LMO_MO[",norbs*nbeta,"]="
        write(hook,"(10f"//fmt9p4//")") ((cb(j,i), j=1,norbs), i=1,nbeta)
        write(hook,"(a,i"//orbs//",a)")" BETA_LMO_E[",nbeta,"]="
      write(hook,"(10f"//fmt9p3//")") (eigb(i), i=1,nbeta)
      end if
    else
      write(hook,"(a,i"//orbs2//",a)")" LMO_MO[",norbs*nclose,"]="
      write(hook,"(10f"//fmt9p4//")") ((c(j,i), j=1,norbs), i=1,nclose)
      write(hook,"(a,i"//orbs//",a)")" LMO_E[",nclose,"]="
      write(hook,"(10f"//fmt9p3//")") (eigs(i), i=1,nclose)
    end if
  else if(force) then
    write(hook,"(a)")" ####################################"
    write(hook,"(a)")" #                                  #"
    write(hook,"(a)")" #      Normal mode analysis        #"
    write(hook,"(a)")" #                                  #"
    write(hook,"(a)")" ####################################"
    write(hook,"(a,i"//paras//",a)")" ORIENTATION_ATOM_X:ANGSTROMS[",3*numat, "]="
    write(hook,"(3f"//fmt10p4//")") ((coord(j,i),j=1,3), i=1,numat)
    write(hook,"(a,i"//paras//",a)")" ISOTOPIC_MASSES[",numat, "]="
    write(hook,"(10f9.4)") (atmass(i), i=1,numat)
    write(hook,"(a,3f"//fmt13p6//",a)")" ROTAT_CONSTS:CM(-1)[3]=",rot
    write(hook,"(a,3f"//fmt13p6//",a)")" PRI_MOM_OF_I:10**(-40)*GRAM-CM**2[3]=",xyzmom
    write(hook,"(a,f"//fmt13p6//",a)")" ZERO_POINT_ENERGY:KCAL/MOL=",zpe
    write(hook,"(a,i"//paras//",a)")" VIB._FREQ:CM(-1)[", nvar, "]="
    write(hook,"(10f9.2)") (freq(i), i=1,nvar)
    if (compressed) then
      do i = 1, nvar
         call write_comp_vect(hook, cnorml((i - 1)*3*numat + 1), 3*numat, 0.0005d0, .false., &
            "NORMAL_MODE_INDICES","NORMAL_MODE_COEFFICIENTS", fmt9p4)
      end do
    else
      write(hook,"(a,i"//orbs2//",a)")" NORMAL_MODES[",3*nvar*numat,"]="
      write(hook,"(10f"//fmt9p4//")") (cnorml(i),i = 1,3*nvar*numat)
    end if
    write(hook,"(a)")" #Warning: Hessian matrix is mass-weighted."
    j = (3*numat*(3*numat + 1))/2
    if (compressed) then
      write(hook,"(a)")" #COMPRESSED_HESSIAN_MATRIX:MILLIDYNES/ANGSTROM"
      call write_comp_vect(hook, fmatrx, j, 0.0001d0, .false., &
        "HESSIAN_INDICES","HESSIAN_COEFFICIENTS", fmt9p4)
    else
      write(hook,"(a,i"//orbs2//",a)")" HESSIAN_MATRIX:MILLIDYNES/ANGSTROM/SQRT(MASS(I)*MASS(J))[",j,"]="
      write(hook,"(a)")" #  Lower half triangle only"
      write(hook,"(10f"//fmt9p4//")") (fmatrx(i), i=1,j)
    end if
    if (jndex(1) == 1) then
      allocate(namo_tmp(nvar))
      namo_tmp = namo
      do i = 1,nvar
        j = index(namo_tmp(i),'"')
        if (j /= 0) namo_tmp(i) = namo(i)(:j - 1)//"''"
      end do
      write(hook,"(a,i"//paras//",a)")" NORMAL_MODE_SYMMETRY_LABELS[",nvar,"]="
      write(hook,'(10(i4,a4))') (jndex(i),namo_tmp(i), i=1,nvar)
      deallocate(namo_tmp)
    end if
    write(hook,"(a,i"//paras//",a)")" VIB._T_DIP:ELECTRONS[", nvar, "]="
    write(hook,"(10f"//fmt9p3//")") (dipt(i), i=1,nvar)
    write(hook,"(a,i"//paras//",a)")" VIB._TRAVEL:ANGSTROMS[", nvar, "]= "
    write(hook,"(10f"//fmt9p3//")") (travel(i), i=1,nvar)
    write(hook,"(a,i"//paras//",a)")" VIB._RED_MASS:AMU[", nvar, "]= "
    write(hook,"(10f"//fmt9p3//")") (redmas(i, 1), i=1,nvar)
    write(hook,"(a,i"//paras//",a)")" VIB._EFF_MASS:AMU[", nvar, "]= "
    write(hook,"(10f"//fmt9p3//")") (min(9999.999d0, max(-999.999d0, redmas(i, 2))), i=1,nvar)
    if (ilim > 0) then
      write(hook,"(a,i"//paras//",a)")" THERMODYNAMIC_PROPERTIES_TEMPS:K[", ilim, "]= "
      write(hook,"(10f"//fmt9p3//")") (T_range(i), i=1,ilim)
      write(hook,"(a,i"//paras//",a)")" ENTHALPY_TOT:CAL/MOL[", ilim, "]= "
      write(hook,"(10f"//fmt10p1//")") (H_tot(i), i=1,ilim)
      write(hook,"(a,i"//paras//",a)")" HEAT_CAPACITY_TOT:CAL/K/MOL[", ilim, "]= "
      write(hook,"(10f"//fmt10p3//")") (Cp_tot(i), i=1,ilim)
      write(hook,"(a,i"//paras//",a)")" ENTROPY_TOT:CAL/K/MOL[", ilim, "]= "
      write(hook,"(10f"//fmt10p3//")") (S_tot(i), i=1,ilim)
      write(hook,"(a,i"//paras//",a)")" H_O_F(T):KCAL/MOL[", ilim, "]= "
      write(hook,"(10f"//fmt10p2//")")   (HOF_tot(i), i=1,ilim)
    end if
    write(hook,"(a,i"//paras//",a)")" ATOM_X_FORCE:ANGSTROMS[",3*numat, "]="
    write(hook,"(3f"//fmt10p4//")") ((coord(j,i),j=1,3), i=1,numat)
  else if (int_force_const) then
    write(hook,"(a,i"//paras//",a)")" INT_FORCE_CONSTS:MILLIDYNES/ANGSTROM[",3*numat, "]= "
    write(hook,"(3f"//fmt10p4//")") ((fcint(j,i),j=1,3), i=1,numat)
    j = 0
    do i = 2, natoms
      if (na(i) /= 0) j = j + 1
    end do
    if (j /= 0) then
      write(hook,"(a,i"//paras//",a)")" INT_COORDS:ANGSTROMS AND DEGREES[",3*numat, "]="
      do i = 1, natoms
        if (na(i) == 0) then
          write(hook,"(3f"//fmt10p4//")") (geo(j,i),j=1,3)
        else
          write(hook,"(3f"//fmt10p4//")") (geo(j,i)*convert(j),j=1,3)
        end if
      end do
      write(hook,"(a,i"//paras//",a)")" CONNECTIVITY[",3*numat, "]="
      write(hook,"(3i5)")(na(i), nb(i), nc(i), i = 1, natoms)
    end if
  else if (error) then
    write(hook,"(a,a)")" ERROR=""",text(17:len_trim(text))//""""
  else if (polar) then
    write(hook,"(a,sp, d"//fmt13p6//", a)")" POLAR_FREQUENCY:EV=",omega
    write(hook,"(a,sp, d"//fmt13p6//", a)")" POLAR_AVE_ALPHA:CUBIC ANGSTROMS=", alpavg*a0**3

  else if (end_of_job) then
    if (index(text,"JOB ENDED NORM") /= 0) then
      write(hook,"(a,a)")" TERMINATION_MESSAGE=""",text(19:len_trim(text))//'"'
    else
      write(hook,"(a,a)")" ERROR_MESSAGE=""",text(19:len_trim(text))//'"'
    end if
  else if (finished) then
    write(hook,"(a,f12.2)")" CPU_TIME:SECONDS[1]=",time0
!
!  Don't print processor-independent CPU times for quick jobs - that would waste too much time.
!
    if (time0 > 1.d0 .and. job_no < 4) then
!
!  Deliberately run a time-consuming calculation to work out CPU speed
!  The "j" index is set to use up 1.0 seconds on the development computer.
!  Do NOT change this quantity!
!
      bk = seconds(2)
      bi = 0.d0
      do j = 1,142083
        do i = 1,1000
          bi = bi + 1.d0/i
        end do
      end do
      bk = seconds(2) - bk
      if(natoms == 0) write(hook,"(a,f12.2)") " DUMMY[1]=",bi ! dummy code to force bi evaluation
      write(hook,"(a,f12.2)")" CPU_TIME:ARBITRARY_UNITS[1]=",time0/bk
    end if
    write(hook,"(a)")" END OF MOPAC FILE"
    new_calcn = .true.
  end if
  return
end subroutine current_version
subroutine write_comp_vect(output, c, size_c, cutoff, norm, text1, text2, fmt9p4)
!
!  Write out the vector "c" in compressed form
!
  implicit none
  integer, intent(in) :: output, size_c
  logical, intent (in) :: norm
  double precision, intent(in) :: c(size_c), cutoff
  character (len=*), intent (in) :: text1, text2
  character, intent (in) :: fmt9p4*5
!
!  Local
!
  integer :: n, ii, j, k
  double precision :: sum, phase
  double precision, allocatable :: c_loc(:), c1(:)
  integer, allocatable :: ivec(:), ic(:)
  character :: fmt*3, fmt1*5
  allocate(c_loc(size_c), c1(size_c), ivec(size_c), ic(size_c))
  n = 0
  do j = 1, size_c
  if (Abs(c(j)) > cutoff) then
    n = n + 1
    ivec(n) = j
    c_loc(n) = c(j)
  end if
  end do
!
!  Re-sequence the coefficients so that the largest is first
!
  do ii = 1, n
  sum = 0.d0
  k = 1
  do j = 1, n
    if (sum < Abs(c_loc(j))) then
      sum = Abs(c_loc(j))
      k = j
    end if
  end do
  ic(ii) = ivec(k)
  c1(ii) = c_loc(k)
  c_loc(k) = 0.d0
  end do
  if (norm) then
    sum = 0.d0
    do j = 1, n
      sum = sum + c1(j)**2
    end do
    phase = 1.d0/sqrt(sum)
    if (c1(1) < 0.d0) phase = -phase
  else
    phase = 1.d0
  end if
!
!  Write out all finite indices.
!
  if (n < 999) then
  fmt = "3.3"
  else
  fmt = "6.6"
  end if
  j = int(log10(size_c*1.0001)) + 2
  write(fmt1,'(i2,a,i1)')120/j, "i", j
  write(output,"(1x,a,i"//fmt//",a)")trim(text1)//"[",n,"]="
  write(output,"("//fmt1//")") (ic(ii),ii=1,n)
  write(output,"(1x,a,i"//fmt//",a)")trim(text2)//"[",n,"]="
  write(output,"(10f"//fmt9p4//")") (phase*c1(ii),ii=1,n)
  return
end subroutine write_comp_vect
!
subroutine print_conventional_M_O_s(iwrite, compressed, moa_lower, moa_upper, mob_lower, mob_upper, fmt9p4, orbs2)
  use common_arrays_C, only : c, cb
  use molkst_C, only : norbs, uhf
  implicit none
  logical :: compressed
  integer :: iwrite, moa_lower, moa_upper, mob_lower, mob_upper
  character :: fmt9p4*5, orbs2*3
!
!
  integer :: i, j
  logical :: lnmos, first = .true.
  save :: first
  if (uhf) then
    if (compressed) then
      lnmos = (moa_upper - moa_lower > -1)
      if (lnmos) then
        write(iwrite,"(a,2i8)")" SET_OF_ALPHA_MOS=",moa_lower, moa_upper
        if (first .and. (moa_lower > 1 .or. moa_upper < norbs)) write(iwrite,"(a)") &
        " # To print all the molecular orbitals, add keyword LARGE or use MOS=99999 in AUX  #"
        do i = moa_lower, moa_upper
          call write_comp_vect(iwrite, c(1,i), norbs, 0.002d0, .false., &
          "ALPHA_MO_INDICES","ALPHA_MO_COEFFICIENTS", fmt9p4)
        end do
      end if
      lnmos = (mob_upper - mob_lower > -1)
      if (lnmos) then
        write(iwrite,"(a,2i8)")" SET_OF_BETA_MOS=",mob_lower, mob_upper
        if (first .and. (mob_lower > 1 .or. mob_upper < norbs)) write(iwrite,"(a)") &
        " # To print all the molecular orbitals, add keyword LARGE or use MOS=99999 in AUX  #"
        do i = mob_lower, mob_upper
          call write_comp_vect(iwrite, cb(1,i), norbs, 0.002d0, .false., &
          "BETA_MO_INDICES","BETA_MO_COEFFICIENTS", fmt9p4)
        end do
      end if
    else
      lnmos = (moa_upper - moa_lower > -1)
      if (lnmos) then
        write(iwrite,"(a,2i8)")" SET_OF_ALPHA_MOS=",moa_lower, moa_upper
        if (first .and. (moa_lower > 1 .or. moa_upper < norbs)) write(iwrite,"(a)") &
        " # To print all the molecular orbitals, add keyword LARGE or use MOS=99999 in AUX  #"
        write(iwrite,"(a,i"//orbs2//",a)")" ALPHA_EIGENVECTORS[",norbs*(moa_upper - moa_lower + 1),"]="
        write(iwrite,"(10f"//fmt9p4//")") ((c(j,i), j=1,norbs), i=moa_lower, moa_upper)
      end if
      lnmos = (mob_upper - mob_lower > -1)
      if (lnmos) then
        write(iwrite,"(a,2i8)")" SET_OF_BETA_MOS=",mob_lower, mob_upper
        if (first .and. (mob_lower > 1 .or. mob_upper < norbs)) write(iwrite,"(a)") &
        " # To print all the molecular orbitals, add keyword LARGE or use MOS=99999 in AUX  #"
        write(iwrite,"(a,i"//orbs2//",a)")" BETA_EIGENVECTORS[",norbs*(mob_upper - mob_lower + 1),"]="
        write(iwrite,"(10f"//fmt9p4//")") ((cb(j,i), j=1,norbs), i=mob_lower, mob_upper)
      end if
    end if
  else
    lnmos = (moa_upper - moa_lower > -1)
    if (.not. lnmos) return
    write(iwrite,"(a,2i8)")" SET_OF_MOS=",moa_lower, moa_upper
    if (first .and. (moa_lower > 1 .or. moa_upper < norbs)) write(iwrite,"(a)") &
    " # To print all the molecular orbitals, add keyword LARGE or use MOS=99999 in AUX  #"
    if (compressed) then
      do i = moa_lower, moa_upper
        call write_comp_vect(iwrite, c(1,i), norbs, 0.002d0, .true., &
        "MO_INDICES","MO_COEFFICIENTS", fmt9p4)
      end do
    else
      write(iwrite,"(a,i"//orbs2//",a)")" EIGENVECTORS[",norbs*(moa_upper - moa_lower + 1),"]="
      write(iwrite,"(10f"//fmt9p4//")") ((c(j,i), j=1,norbs), i=moa_lower, moa_upper)
    end if
  end if
  first = ( .not. (moa_lower > 1 .or. moa_upper < norbs .or. mob_lower > 1 .or. mob_upper < norbs))
end subroutine print_conventional_M_O_s

Subroutine print_M_O_data(hook, moa_lower, moa_upper, lnmoas, mob_lower, mob_upper, lnmobs, orbs, fmt9p3)
!
! Write out symmetry labels and eigenvalues
!
  use molkst_C, only : norbs, uhf
!
  use symmetry_C, only : jndex, namo
!
  use common_arrays_C, only : c, eigs, eigb
!
  implicit none
  integer, intent (in) :: hook, moa_lower, moa_upper, mob_lower, mob_upper
  logical, intent (in) :: lnmoas, lnmobs

  character, intent (in) :: fmt9p3*5, orbs*3
!
!  Local quantities
!
  integer :: i, j
  character, dimension(:), allocatable :: namo_tmp*4
  logical :: lnmos
  if (allocated(jndex)) then
    if (jndex(1) == 1) then
      allocate(namo_tmp(norbs))
      namo_tmp = namo
      do i = 1,norbs
        j = index(namo_tmp(i),'"')
        if (j /= 0) namo_tmp(i) = namo(i)(:j - 1)//"''"
      end do
      if (uhf) then
        lnmos = (mob_upper - mob_lower > -1)
        if (lnmos) then
          write(hook,"(a,i"//orbs//",a)")" BETA_M.O.SYMMETRY_LABELS[",mob_upper - mob_lower + 1,"]="
          write(hook,'(10(i4,a4))') (jndex(i),namo_tmp(i), i = mob_lower, mob_upper)
        end if
        lnmos = (moa_upper - moa_lower > -1)
        if (lnmos) then
        call symtrz (c, eigs, 1, .TRUE.)
        end if
        namo_tmp = namo
        do i = 1,norbs
          j = index(namo_tmp(i),'"')
          if (j /= 0) namo_tmp(i) = namo(i)(:j - 1)//"''"
        end do
        write(hook,"(a,i"//orbs//",a)")" ALPHA_M.O.SYMMETRY_LABELS[",moa_upper - moa_lower + 1,"]="
        write(hook,'(10(i4,a4))') (jndex(i),namo_tmp(i), i = moa_lower, moa_upper)
      else
        if (lnmoas) then
          write(hook,"(a,i"//orbs//",a)")" M.O.SYMMETRY_LABELS[",moa_upper - moa_lower + 1,"]="
          write(hook,'(10(i4,a4))') (jndex(i),namo_tmp(i), i = moa_lower, moa_upper)
        end if
      end if
      deallocate(namo_tmp)
    end if
  end if
  if (uhf) then
    if (lnmoas) then
      write(hook,"(a,i"//orbs//",a)")" ALPHA_EIGENVALUES[",moa_upper - moa_lower + 1,"]="
      write(hook,"(10f"//fmt9p3//")") (eigs(i), i = moa_lower, moa_upper)
    end if
    if (lnmobs) then
      write(hook,"(a,i"//orbs//",a)")" BETA_EIGENVALUES[",mob_upper - mob_lower + 1,"]="
      write(hook,"(10f"//fmt9p3//")") (eigb(i), i = mob_lower, mob_upper)
    end if
  else
    if (lnmoas) then
      write(hook,"(a,i"//orbs//",a)")" EIGENVALUES[",moa_upper - moa_lower + 1,"]="
      write(hook,"(10f"//fmt9p3//")") (eigs(i), i = moa_lower, moa_upper)
    end if
  end if
end subroutine print_M_O_data
subroutine fill_overlap_matrix(overlap)
!
!  Set up an array to hold the overlap matrix
!
  use parameters_C, only : betas, betap, betad, natorb
  use molkst_C, only : norbs, numat
  use common_arrays_C, only : nat, nfirst, h
  implicit none
  double precision, intent (out) :: overlap((norbs*(norbs + 1))/2)
  integer :: i, im1, j, ii, jj, ij, if, jf, ni, nj, norbi, norbj, ifact(norbs + 1)
  double precision :: bi(9), bj(9)
    do i = 1, norbs
      ifact(i) = (i*(i - 1))/2
    end do
    ifact(norbs+1) = (norbs*(norbs + 1))/2
    overlap = 0.d0
    do i = 1, numat
      if = nfirst(i)
      im1 = i - 1
      bi = betas(nat(i))
      ni = nat(i)
      bi(1) = betas(ni)*0.5D0
      bi(2) = betap(ni)*0.5D0
      bi(3) = bi(2)
      bi(4) = bi(2)
      bi(5) = betad(ni)*0.5D0
      bi(6) = bi(5)
      bi(7) = bi(5)
      bi(8) = bi(5)
      bi(9) = bi(5)
      norbi = natorb(ni)
      do j = 1, im1
        nj = nat(j)
        bj(1) = betas(nj)*0.5D0
        bj(2) = betap(nj)*0.5D0
        bj(3) = bj(2)
        bj(4) = bj(2)
        bj(5) = betad(nj)*0.5D0
        bj(6) = bj(5)
        bj(7) = bj(5)
        bj(8) = bj(5)
        bj(9) = bj(5)
        norbj = natorb(nj)
        jf = nfirst(j)
        do ii = 1, norbi
          do jj = 1, norbj
            ij = ((if + ii - 1)*(if + ii - 2))/2 + jf + jj - 1
            overlap(ij) = h(ij)/(bi(ii) + bj(jj))
          end do
        end do
      end do
    end do
    overlap(ifact(2:norbs+1)) = 1.D0
  end subroutine fill_overlap_matrix

  subroutine write_screen_bonds(compressed, orbs2, hook, fmt9p4)
  use common_arrays_C, only : bondab
  use molkst_C, only : numat
  use chanel_C, only : iw
  implicit none
  integer, intent (in) :: hook
  logical, intent (in) :: compressed
  character, intent (in) :: orbs2*3, fmt9p4*5
  character :: fmt*3, fmt1*5
  integer :: i, j, ic
  double precision :: sum
  double precision, allocatable :: comp(:)
  integer, allocatable :: icomp(:)
    if (.not. allocated(bondab))  then
      i = iw
      iw = 88
      open(unit=iw, status='SCRATCH')
      call bonds ()
      close(iw)
      iw = i
    end if
    if (compressed) then
      i = (numat*(numat + 1))/2
      allocate(comp(i), icomp(i))
      ic = 0
      do i = 1, numat
!
!  Work out all bond orders involving atom i
!
        do j = 1, i - 1
          sum = bondab((i*(i - 1))/2 + j)
          if (sum > 0.05d0) then
            ic = ic + 1
            comp(ic) = sum
            icomp(ic) = (i*(i - 1))/2 + j
          end if
        end do
      end do
      if (ic < 999) then
        fmt = "3.3"
      else
        fmt = "6.6"
      end if
      j = int(log10((numat*(numat + 1))/2*1.0001)) + 2
      write(fmt1,'(i2,a,i1)')120/j, "i", j
      write(hook,"(1x,a,i"//fmt//",a)")" COMPRESSED_BOND_ORDERS_INDICES[",ic,"]="
      write(hook,"("//fmt1//")") (icomp(i),i=1,ic)
      write(hook,"(1x,a,i"//fmt//",a)")" COMPRESSED_BOND_ORDERS_VALUES[",ic,"]="
      write(hook,"(10f"//fmt9p4//")") (comp(i),i=1,ic)
    else
      write(hook,"(a,i"//orbs2//",a)")" BOND_ORDERS[",(numat*(numat + 1))/2,"]="
      write(hook,"(a)")" #  Lower half triangle only"
      write(hook,"(10f"//fmt9p4//")") (bondab(i), i=1,(numat*(numat + 1))/2)
    end if
  end subroutine write_screen_bonds

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine adjvec (cvecb, ncvb, icvecb, nib, nncb, ncb_loc, nnb, ncvecb, lmob, &
& iorbs, cveca, ncva, icveca, nia, nnca, nca_loc, nna_loc, ncveca, lmoa, beta, &
& iused, sumtot)
    use molkst_C, only: numat, norbs
    use MOZYME_C, only : thresh
    implicit none
    integer, intent (in) :: lmoa, lmob, ncva, ncvb, nia, nib, nna_loc, nnb
    double precision, intent (in) :: beta
    double precision, intent (inout) :: sumtot
    integer, dimension (nia), intent (in) :: icveca
    integer, dimension (nib), intent (inout) :: icvecb
    integer, dimension (nna_loc), intent (in) :: nca_loc, ncveca, nnca
    integer, dimension (nnb), intent (in) :: ncvecb, nncb
    integer, dimension (nnb), intent (inout) :: ncb_loc
    integer, dimension (numat), intent (inout) :: iused
    integer, dimension (norbs), intent (in) :: iorbs
    double precision, dimension (ncva), intent (in) :: cveca
    double precision, dimension (ncvb), intent (inout) :: cvecb
!
    integer :: ii, la, lb, llim, mia, mla, mlb, mlim, mlla, mllb
    double precision :: cutoff, sum
    mlla = 0
    cutoff = thresh * 1.d1
    if (Abs (beta) < cutoff) return
    sumtot = sumtot + Abs (beta)
   !
   !   IDENTIFY THE ATOMS IN THE SECOND SET OF LMOs.  ATOMS NOT USED ARE
   !   FLAGGED BY '-1' IN IUSED.
   !
    do la = nnca(lmoa) + 1, nnca(lmoa) + nca_loc(lmoa)
      iused(icveca(la)) = -1
    end do
    mlb = ncvecb(lmob)
    if (lmob == nnb) then
      llim = nib
    else
      llim = nncb(lmob+1)
    end if
    if (lmob == nnb) then
      mlim = ncvb - 4
    else
      mlim = ncvecb(lmob+1) - 4
    end if
    do lb = nncb(lmob) + 1, nncb(lmob) + ncb_loc(lmob)
      ii = icvecb(lb)
      iused(ii) = mlb
      mlb = mlb + iorbs(ii)
    end do
    mla = ncveca(lmoa)
   !
   !      ROTATION OF SECOND VECTOR TO MAKE IT ORTHOGONAL TO THE FIRST.
   !
    do la = nnca(lmoa) + 1, nnca(lmoa) + nca_loc(lmoa)
      mia = icveca(la)
      if (iused(mia) >= 0) then
        mllb = iused(mia)
         !
         !   ROTATION INVOLVING ATOMS WHICH ARE COMMON TO BOTH LMOs
         !
        do mlla = mla + 1, mla + iorbs(mia)
          mllb = mllb + 1
          cvecb(mllb) = cvecb(mllb) - beta * cveca(mlla)
        end do
      else
         !
         !   ATOM 'MIA' DOES NOT EXIST IN LMOB.  CHECK IF IT SHOULD EXIST.
         !   IF IT SHOULD EXIST, MAKE IT EXIST.
         !
        sum = 0.d0
        do mlla = mla + 1, mla + iorbs(mia)
          sum = sum + cveca(mlla) ** 2
        end do
        if (beta**2*sum > cutoff) then
          if (ncb_loc(lmob) < llim .and. mlb < mlim) then
            ncb_loc(lmob) = ncb_loc(lmob) + 1
            icvecb(nncb(lmob)+ncb_loc(lmob)) = mia
            iused(mia) = mlb
            do mlla = mla + 1, mla + iorbs(mia)
              mlb = mlb + 1
              cvecb(mlb) = -beta * cveca(mlla)
            end do
          end if
        end if
      end if
      mla = mla + iorbs(mia)
    end do
    if (mlla /= -1) return
!
!   Use in debugging - sum is the value of the overlap after orthogonalization
!
    sum = 0
    mla = ncveca(lmoa)
    do la = nnca(lmoa) + 1, nnca(lmoa) + nca_loc(lmoa)
      mia = icveca(la)
      if (iused(mia) >= 0) then
        mllb = iused(mia)
        do mlla = mla + 1, mla + iorbs(mia)
          mllb = mllb + 1
          sum = sum + cvecb(mllb)*cveca(mlla)
        end do
      end if
      mla = mla + iorbs(mia)
    end do
end subroutine adjvec

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine getdat(input, output)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : natoms, jobnam, run, backslash, &
      line, ncomments, is_PARAM, keywrd, arc_hof_1, arc_hof_2, gui
      use chanel_C, only : job_fn, input_fn, iw0, iw
      use common_arrays_C, only : all_comments
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
      integer, intent (in) :: input, output
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer, parameter :: from_data_set = 7
      integer :: i, j, io_stat, l, nlines
      logical :: exists, arc_file, comments = .true.
      character :: line1*3000, num1*1, num2*1
      character, allocatable :: tmp_comments(:)*120
      double precision, external :: reada
      save i
!-----------------------------------------------
!
!***********************************************************************
!
!   GETDAT READS IN ALL THE DATA USING CHANEL "from_data_set", AND WRITES IT
!   TO SCRATCH CHANNEL "input".  THIS WAY THE ORIGINAL DATA-SET IS
!   FREED UP AS SOON AS THE JOB STARTS.
!********************************************************************
      natoms = 0
      call to_screen("To_file: getdat")
      if (gui) then
        jobnam = "MOPAC input"
        natoms = 1
      else
        if (run /= 2 .or.jobnam ==" ") then
#ifdef MOPAC_F2003
          i = command_argument_count()
#else
          i = iargc()
#endif
          if (i >= run) then
#ifdef MOPAC_F2003
            call get_command_argument (run, jobnam)
#else
            call getarg (run, jobnam)
#endif
            natoms = 1
            do i = len_trim(jobnam), 1, -1   !  Remove any unprintable characters from the end of the file-name
              if (ichar(jobnam(i:i)) > 39 .and. ichar(jobnam(i:i)) < 126 .or. jobnam(i:i) =="'") exit
            end do
            jobnam(i + 1:) = " "
!
!  Replace backslash with forward-slash
!
            do i = 1, len_trim(jobnam)
              if (jobnam(i:i) == backslash) jobnam(i:i) = "/"
            end do
          else if (i == 0) then
            if (is_PARAM) then
              write(line,'(2a)')" PARAM is the parameter optimization program for use with MOPAC"
              write(0,'(/10x,a,/)')trim(line)
              write(0,'(10x,a)')" It uses a single argument, the PARAM data-set"
              write(0,'(10x,a)')" The command to run PARAM is 'mopac-param <data-set>.dat'"
             ! call web_message(0,"running_MOPAC.html")
              write(0,'(10x,a)')" Press (return) to continue"
              read(5,*, iostat=i)
              return
            else
              write(0,'(/10x,a,/)')" MOPAC is a semiempirical quantum chemistry program"
              write(0,'(10x,a)')" It uses a single argument, the MOPAC data-set"
              write(0,'(10x,a)')" The command to run MOPAC is 'mopac <data-set>.mop'"
              call web_message(0,"running_MOPAC.html")
              write(0,'(10x,a)')" Press (return) to continue"
              read(5,*, iostat=i)
              return
            end if
          end if
        else
          natoms = 1
        end if
      end if
      if (natoms == 0) return
!
! Check for the data set in the order: <file>.mop, <file>.dat, <file>
!
      line = jobnam
      exists = .false.
      call upcase(line, len_trim(line))
      i = Index(line,".MOP") + Index(line,".DAT") + Index(line, ".ARC")
      arc_file = (Index(line, ".ARC") > 0)
      if (i > 0) then  ! User has supplied a suffix - use it
        line1 = trim(line)
        line = trim(jobnam)
        inquire(file=line, exist=exists)
        j = len_trim(line1)
        if (line1(j - 3:j) == ".TXT") then
          jobnam(j - 3:j) = " "
          if (j - i > 7) then
          line1 = "There must not be any text between """//line1(i:i+3)// &
          """ and "".TXT"" in the file-name"
           open(unit=iw, file=trim(jobnam)//'.out')
           call mopend(trim(line1))
           write(iw,'(/10x,a)')"(End of file name: """//trim(line(i:))//""")"
           return
          end if
        end if
        jobnam(i:i+3) = " "
      else  ! No suffix supplied, try the file, then .mop, then .dat
        line = trim(jobnam)
        inquire(file=line, exist=exists)
        if (exists) then ! Check that it is not a folder
          open(unit=from_data_set, file=line, status='OLD', position=&
          'asis', iostat=io_stat)
          if (io_stat == 9) then
            exists = .false.
          else
            close (from_data_set)
          end if
        end if
        if ( .not. exists) then
          line = trim(jobnam)//'.mop'
          inquire(file=line, exist=exists)
        end if
        if ( .not. exists) then
          line = trim(jobnam)//'.dat'
          inquire(file=line, exist=exists)
        end if
      end if
  98  if (exists) then
         if (iw0 > -1) then
           call to_screen("Preparing to read the following MOPAC file: ")
           i = min(len_trim(line), 240)
                         call to_screen(line(:min(i,120)))
           if (i > 120)  call to_screen(line(121:min(i,240)))
         end if
         job_fn = line(:len(job_fn))
        open(unit=from_data_set, file=job_fn, status='OLD', position='asis', iostat=io_stat)
        if (io_stat /= 0) then
          write(line,'(2a)')" Data file: '"//trim(job_fn)//"' exists, but it cannot be opened."
          write(0,'(//10x,a,//)')trim(line)
          call to_screen(" File '"//job_fn(:len_trim(job_fn))//"' cannot be opened")
          call mopend("File '"//job_fn(:len_trim(job_fn))//"' cannot be opened")
          return
        end if
!
!  Now that the name of the data-set is known, set up all the other file-names
!
        call init_filenames
      else
        if (is_PARAM) then
          line = "PARAM input data-set file: """//trim(jobnam)//""" does not exist."
          open(unit=iw, file='PARAM Error message.txt')
        else
          line = "MOPAC input data-set file: """//trim(jobnam)//""" does not exist."
          open(unit=iw, file='MOPAC Error message.txt')
        end if
        write(0,'(//10x,a,//)')trim(line)
        call to_screen(trim(line))
        call mopend(trim(line))
        return
      end if
!
!  CLOSE UNIT IFILES(5) IN CASE IT WAS ALREADY PRE-ASSIGNED.
!INPUT FILE MISSING
      close(input)
      open(unit=input, status='SCRATCH', iostat = io_stat)
      if (io_stat /= 0) then
        if (io_stat == 30) then
          call to_screen(" The file'"//input_fn(:len_trim(input_fn))//"' is busy")
          call to_screen(" Correct this problem, and re-submit job")
          call mopend("Temporary file '"//input_fn(:len_trim(input_fn))//"' is unavailable for use")
          return
        end if
      end if
      rewind input
      rewind from_data_set
      arc_hof_1 = 0.d0
      arc_hof_2 = 0.d0
      if (arc_file) then
        do
          read (from_data_set, '(A1000)', iostat = i) line
          if (i /= 0) then
            i = 0
            ncomments = 0
            rewind(from_data_set)
            exit
          end if
          if (index(line, "HEAT OF FORMATION") > 0) arc_hof_1 = reada(line,20)
          if (index(line, "FINAL GEOMETRY OBTAINED") > 0) exit
          if (index(line, "GEOMETRY IN CARTESIAN COORDINATE") > 0) exit
          if (index(line, "GEOMETRY IN MOPAC Z-MATRIX") > 0) exit
        end do
      end if
      nlines = 0
      ncomments = 0
      if (.not. allocated(tmp_comments)) allocate(tmp_comments(10000))
      keywrd = " "
!
!  The size of the comments is not known, so set up a temporary array of size 10000 lines
!
      do
        read (from_data_set, '(A2000)', end=30, err=30) line
        nlines = nlines + 1
        if (nlines == 1) then
          line1 = trim(line)
          call upcase(line1, len_trim(line1))
          j = Index(line1,"DATA=")
          if (j > 0) exit
        end if
        if (line(1:1) /= '*') then
            line1 = trim(line)
            i = 0
            do j = 1, len_trim(line1)
              if (ichar(line1(j:j)) == 9) then
      !
      ! convert tab to space(s).  Align with 8 character boundary
      !
                i = i + 1
                l = mod(i,8)
                line(i:) = " "
                if (l /= 0) i = i + 8 - l
              else
                i = i + 1
                line(i:i) = line1(j:j)
              end if
            end do
          write (input, '(A)', iostat=io_stat) trim(line)
          if (io_stat /= 0) then
            write (line, '(a)') ' The run-time temporary file "'//trim(jobnam)//'.temp" cannot be written to.'
            open(unit=iw, file=trim(jobnam)//'.out')
            if( .not. gui) write(0,"(///10x,a)")line
            call to_screen(line)
            call mopend (trim(line))
            return
          end if
          comments = .false.
          if (keywrd == " ") keywrd = line
        else if (comments) then
          ncomments = ncomments + 1
          tmp_comments(ncomments) = trim(line)
          i = len_trim(line)
          if (i > 81) then
            line = trim(line(2:))
            if (index(line(:4),"ATOM") + index(line(:6),"HETATM") + index(line,"TITLE") + &
            index(line,"HEADER") + index(line,"ANISOU") + index(line,"COMPND") + &
            index(line,"SOURCE") + index(line,"KEYWDS") + index(line,"USER ") + &
            index(line,"HELIX") + index(line,"SHEET") + index(line,"REMARK") + &
            index(line, "SEQRES") /= 0) then
              open(unit=iw, file=trim(jobnam)//'.out')
              num1 = char(ichar("2") + int(log10(ncomments*1.01)))
              num2 = char(ichar("2") + int(log10(i*1.01)))
              write(iw,'(/10x, a, i'//num1//', a,i'//num2//', a)') "Comment number", ncomments, &
                " is", i -1, " characters long. "
              write(iw,'(10x,a)')"This comment is recognized as being in Protein Data Bank format.", &
                "PDB lines are limited to 80 characters."
              write(iw,'(84x,a)')"Limit => |"
              write(iw,'(a)')"(Comment is:'*"//line(:i - 1)//"')"
              call mopend("Either make the line non-PDB format or shorten it. ")
              return
            end if
          end if
        end if
      end do
30    continue
      call upcase(keywrd, len_trim(keywrd))
      if (keywrd(1:1) /= " ") keywrd = " "//trim(keywrd)
      i = index(keywrd, "GEO-DAT")
      if (i /= 0) keywrd(i:i+6) = "GEO_DAT"
      i = index(keywrd, "GEO-REF")
      if (i /= 0) keywrd(i:i+6) = "GEO_REF"
      if (index(keywrd, " GEO_DAT") + index(keywrd, " SETUP")/= 0) then
        nlines = nlines + 3
      else if (.not. is_PARAM .and. nlines < 4) then
        inquire(unit=iw, opened=exists)
        if (.not. exists) open(unit=iw, file=trim(jobnam)//'.out')
        if (keywrd /= " ") then
          if (index(keywrd, "++") == 0) &
          write(iw,'(3/10x,a,/)') &
            " Data set does not contain any atoms and neither GEO_DAT or SETUP is present on the keyword line"
        end if
      end if
      keywrd = "  "
      if (nlines == 1 .and. Len_trim(line1) > 0 .and. .not. is_PARAM) then
!
!  Data set points to a MOPAC data set.
!
        i = Len_trim(line1)
        job_fn = line(j+5:i)
        if(line1(i:i) == "+") then
!
!  File name runs onto two lines
!
           read (input, "(A120)", end=1000, err=1000) line
           i = i - j - 6
           job_fn(i:) = line
        end if
        i = Len_trim(line)
        if(line(i:i) == "+") then
!
!  File name runs onto three lines
!
           read (input, "(A120)", end=1000, err=1000) line
           i = Len_trim(job_fn) - 1
           job_fn(i:) = line
        end if
!
!  Make sure that the file ends in ".mop", ".dat", or "arc"
!
        i = Len_trim(job_fn) - 1
        line = job_fn
        call upcase(line,i)
        i = index(line,".MOP") + index(line,".DAT") + index(line,".ARC")
        if (i /= 0) job_fn(i + 4:) = " "
        if (job_fn(1:1) == '"') job_fn = trim(job_fn(2:))
        do j = 1,Len_trim(job_fn)
          if (job_fn(j:j) == char(92)) job_fn(j:j) = "/"
        end do
!
!  Clean up path before continuing
!
        do j = 1, Len_trim(jobnam)
          if (jobnam(j:j) == char(92)) jobnam(j:j) = "/"
        end do
        l = Index(job_fn,"/")
        if (l == 0) then
          open(unit=iw, file=trim(jobnam)//'.out')
          call mopend ('INPUT FILE PATH MUST BE DEFINED IN ''DATA="<file plus path>"''')
          call web_message(iw,"DATA.html")
          return
        end if
        call to_screen ("Preparing to read the following MOPAC file: ")
        j = Len_trim (job_fn)
        if (j > 160) then
          call to_screen ("'"//job_fn(1:80))
          call to_screen (job_fn(81:160))
          call to_screen (job_fn(161:j)//"'")
        else if (j> 80) then
          call to_screen ("'"//job_fn(1:80))
          call to_screen (job_fn(81:j)//"'")
        else
          call to_screen ("'"//job_fn(1:j)//"'")
        end if
        line = job_fn
        exists = .true.
        goto 98
    end if   ! Line was one of first 5 lines
!
! Now the size of the comments list is known.  Allocate all_comments
!
      if ( .not. allocated(all_comments)) allocate(all_comments(ncomments + 100))
      do i = 1, ncomments
        all_comments(i) = trim(tmp_comments(i))
      end do
      deallocate(tmp_comments)
      line = ' '
      write (input, '(A241)') line
      rewind input
1000  if (nlines < 3 .and. .not. is_PARAM) then
        inquire(unit=output, opened=exists)
        if (.not. exists) open(unit=output, file=trim(jobnam)//'.out')
#ifdef MOPAC_F2003
        call get_command_argument (run, jobnam)
#else
        call getarg (run, jobnam)
#endif
        write (0, '(A)') ' INPUT FILE "'//trim(jobnam)//'" MISSING OR EMPTY'
        call mopend ( ' INPUT FILE "'//trim(jobnam)//'" MISSING OR EMPTY')
        return
      end if
      natoms = nlines
      close(from_data_set)
      return
      end subroutine getdat

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine h1elec(ni, nj, xi, xj, smat)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      use parameters_C, only : natorb, betas, betap, betad
      use MOZYME_C, only : cutofs
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: ni
      integer  :: nj
      double precision , intent(in) :: xi(3)
      double precision , intent(in) :: xj(3)
      double precision  :: smat(9,9)

!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: j, norbi, norbj
      double precision :: bi(9), bj(9), xjuc(3), rab
!-----------------------------------------------
!***********************************************************************
!
!  H1ELEC FORMS THE ONE-ELECTRON MATRIX BETWEEN TWO ATOMS.
!
!   ON INPUT    NI   = ATOMIC NO. OF FIRST ATOM.
!               NJ   = ATOMIC NO. OF SECOND ATOM.
!               XI   = COORDINATES OF FIRST ATOM.
!               XJ   = COORDINATES OF SECOND ATOM.
!
!   ON OUTPUT   SMAT = MATRIX OF ONE-ELECTRON INTERACTIONS.
!
!***********************************************************************
      rab = (xi(1)-xj(1))**2+(xi(2)-xj(2))**2+(xi(3)-xj(3))**2
      if (rab > cutofs .or. (rab > 3.24D0 .and. (ni==102 .or. nj==102))) then
        smat = 0.D0
        return
      end if
      xjuc = xj - xi
      call diat (ni, nj, xjuc, smat)
      bi(1) = betas(ni)*0.5D0
      bi(2) = betap(ni)*0.5D0
      bi(3) = bi(2)
      bi(4) = bi(2)
      bi(5) = betad(ni)*0.5D0
      bi(6) = bi(5)
      bi(7) = bi(5)
      bi(8) = bi(5)
      bi(9) = bi(5)
      bj(1) = betas(nj)*0.5D0
      bj(2) = betap(nj)*0.5D0
      bj(3) = bj(2)
      bj(4) = bj(2)
      bj(5) = betad(nj)*0.5D0
      bj(6) = bj(5)
      bj(7) = bj(5)
      bj(8) = bj(5)
      bj(9) = bj(5)
      norbi = natorb(ni)
      norbj = natorb(nj)
      do j = 1, norbj
        smat(:norbi,j) = smat(:norbi,j)*(bi(:norbi)+bj(j))
      end do
      return
      end subroutine h1elec

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine bonds()
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE molkst_C, only : norbs, numat, nopen, fract, nclose, nelecs, nalpha, &
      nbeta, keywrd, mozyme, maxtxt
      use common_arrays_C, only : nfirst, nlast, nat, p, c, pa, pb, cb, bondab
      USE parameters_C, only : tore
      USE chanel_C, only : iw
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision, allocatable  :: b(:,:),  sdm(:), aux(:,:), &
      pspin(:), spinab(:)

!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: nopn, k, i, j, n, m, mu, l, ij, ll, kk, il, ih, &
        ilih, ibab(100)
      double precision, dimension(numat) :: spna, v, fv, sq, aq, tq, pm, sp, sd, &
        spsa, spsq
      double precision :: zkappa, sum, a, x, da, aa, valenc, bab(100), sumlim
      logical :: ci, nci, kci, lall
!-----------------------------------------------
!
!*********************************************************************
!   CALCULATES AND PRINTS THE BOND INDICES AND VALENCIES OF ATOMS
!   FOR REFERENCE, SEE "BOND INDICES AND VALENCY", J.C.S.DALTON,
!   ARMSTRONG,D.R., PERKINS,P.G. AND STEWART,J.J.P., 838 (1973)
!
!  ON INPUT
!           P = DENSITY MATRIX, LOWER HALF TRIANGLE, PACKED.
!               P IS NOT ALTERED BY BONDS
!
!*********************************************************************
      if (mozyme) then
        call bonds_for_MOZYME()
        return
      end if
!
      i = (numat*(numat + 1))/2
      j = (norbs*(norbs + 1))/2
      if (allocated(bondab)) deallocate(bondab)
      allocate (b(norbs,norbs), bondab(i), sdm(j), aux(numat,numat), &
      pspin(j), spinab(i))
      ci = index(keywrd,'C.I.') + index(keywrd,'MECI') /= 0
      kci = index(keywrd,'MICROS') == 0
      nci = index(keywrd,'ROOT') + index(keywrd,'OPEN') == 0
      nopn = nopen - nclose
      nelecs = nclose + nclose + nopn + nalpha + nbeta
      lall = (Index (keywrd, " ALLBOND") /= 0)
      sumlim = 0.01d0                  !  Report all bonds greater than 0.01 not involving hydrogen
      if (lall) sumlim = sumlim*0.1d0  !  Report all bonds greater than 0.001
!*****   CALCULATE THE DEGREE OF BONDING   ************
!
      k = 0
      do i = 1, norbs
        do j = 1, i
          k = k + 1
          b(i,j) = p(k)
          b(j,i) = p(k)
        end do
      end do
!
! *******  CALCULATE KAPPA FACTOR FOR UHF OR ROHF  ******************
!
      if (index(keywrd,' UHF') /= 0) then
!****** UHF CASE
        zkappa = 0.D0
        do n = 1, nalpha
          do m = 1, nbeta
            sum = 0.D0
            do mu = 1, norbs
              sum = sum + c(mu,n)*cb(mu,m)
            end do
            zkappa = zkappa + sum**2
          end do
        end do
        zkappa = 1.D0/(zkappa/dble(nalpha + nbeta) + 0.5D0)
      else
        if (.not.ci .and. nopn==0 .and. nci .and. kci) then
          zkappa = 1.D0
        else
!****** ROHF CASE
          zkappa = 1.D0/(1.D0 - (dble(nopn)/dble(nelecs))/2.D0)
        end if
      end if
      ij = 0
      do i = 1, numat
        a = 0.0D00
        l = nfirst(i)
        ll = nlast(i)
        do j = 1, i
          ij = ij + 1
          k = nfirst(j)
          kk = nlast(j)
          x = 0.0D0
          do il = l, ll
            do ih = k, kk
              x = x + b(il,ih)*b(il,ih)
            end do
          end do
          bondab(ij) = x
        end do
        x = -bondab(ij)
        do j = l, ll
          a = a + b(j,j)
          x = x + 2.D0*b(j,j)
        end do
        v(i) = x
        sd(i) = a
      end do
!
!
! ***** CALCULATE ACTIVE CHARGE (AQ), SELF CHARGE (SQ), FREE VALENCE(FV)
!        TOTAL CHARGE (TQ), MULLIKEN TYPE PROMOTION (PM) AND STATISTICAL
!          PROMOTION (SP)  ********************************************
!
      k = 0
      do i = 1, numat
        do j = 1, i
          k = k + 1
          bondab(k) = bondab(k)*zkappa
          aux(i,j) = bondab(k)
          aux(j,i) = bondab(k)
        end do
        bondab(k) = v(i)
      end do
      do i = 1, numat
        da = 0.0D0
        do j = 1, numat
          if (j == i) cycle
          da = da + aux(i,j)
        end do
        aq(i) = da
        sq(i) = (aux(i,i)-da)/2.D00
        fv(i) = v(i) - aq(i)
        tq(i) = aq(i) + sq(i)
        pm(i) = sd(i) - tore(nat(i))
        sp(i) = tq(i) - tore(nat(i))
      end do
!
!
!  ********   OUTPUT    *****************
!
!
      write (iw, '(2/)')
      if (maxtxt > 25) then
        write (iw, '(1X,2/37X,"(VALENCIES)",1x,"BOND ORDER       TO",/)')
      else
        write (iw, '(1X,2/12X,"(VALENCIES)   BOND ORDERS",/)')
      end if
      do i = 1, numat
        l = 0
        valenc = aux(i,i)
        aux(i,i) = 0.d0
        do j = 1, numat
          if (aux(i,j) > sumlim) then
            l = l + 1
            ibab(l) = j
            bab(l) = aux(i,j)
          end if
        end do
        aux(i,i) = valenc
        call print_bonds_compact(i,l, v(i), bab, ibab)
      end do
  !    call vecprt (bondab, numat)

  call to_screen("To_file: Bonds")
      if (index(keywrd,' LARGE') == 0) return
      write (iw, '(3/)')
      write (iw, '(A)') ' SELF-Q:    SELF OR INACTIVE CHARGE'
      write (iw, '(A)') ' ACTIV-Q:   CHARGE WHICH IS USED TO FORM BONDS'
      write (iw, '(A)') ' TOTAL-Q:   SELF-Q + ACTIV-Q'
      write (iw, '(A)') ' FREE-VA:   TOTAL-Q - VALENCE'
      write (iw, '(A)') ' STAT.PROM: TOTAL-Q - CORE CHARGE'
      write (iw, '(A)') ' MULL.PROM: -CHARGE (SEE ABOVE)'
      write (iw, &
      '(/,7X,''SELF-Q'',4X,''ACTIV-Q'',3X,''TOTAL-Q'',3X,   ''VALENCE'',3X,'&
      &'FREE-VA'',1X,''STAT.PROM'',1X,''MULL.PROM'',2/)')
      write (iw, '(I4,7F10.5/)') (i,sq(i),aq(i),tq(i),v(i),fv(i),sp(i),pm(i)&
        ,i=1,numat)
!****** PERFORM SPIN POPULATION STATISTICAL ANALYSIS
      if (index(keywrd,' UHF') == 0) then
        if (.not.ci .and. nopn==0 .and. nci .and. kci) then
          write (iw, '(1X,''CLOSED SHELL'',2/)')
          return
        else
          call dopen (c, norbs, norbs, nclose, nopen, fract, sdm)
          pspin = sdm
!       WRITE(IW,'(1X,''SDM'',10E12.3)')(SDM(J),J=1,LINEAR)
          write (iw, '(1X,''ROHF'',2/)')
          go to 160
        end if
      end if
      write (iw, '(1X,''UHF '',2/)')
      pspin = pa - pb
      sum = 0.D0
      l = 0
      do i = 1, norbs
        do j = 1, i
          aa = 2.D0
          if (i == j) aa = 1.D0
          l = l + 1
          sum = sum + aa*(pspin(l)*p(l))
        end do
      end do
      write (iw, '(2/)')
      write (iw, '(10X,''NALPHA-NBETA= '',F10.5,2/)') sum
  160 continue
      write (iw, '(1X,''OPEN SHELL & UHF CASE'',2/)')
!#      WRITE(IW,'(1X,10X,51(''* '')//1X,10X,''* '',9X,''STATISTICAL SPI
!#     + POPULATION ANALYSIS'',9X,''* '',//1X,10X,51(''* ''))')
! EVALUATE  THE CORRESPONDING INACTIVE ATOMIC AND BOND SPIN POPULATIONS
      ij = 0
      do i = 1, numat
        l = nfirst(i)
        ll = nlast(i)
        do j = 1, i
          ij = ij + 1
          k = nfirst(j)
          kk = nlast(j)
          x = 0.D0
          do il = l, ll
            do ih = k, kk
              if (il >= ih) then
                ilih = (il*(il - 1))/2 + ih
              else
                ilih = (ih*(ih - 1))/2 + il
              end if
              x = x + b(il,ih)*pspin(ilih)
            end do
          end do
          spinab(ij) = x
        end do
      end do
! EVALUATE THE TOTAL ATOMIC SPIN POPULATIONS
      k = 0
      do i = 1, numat
        do j = 1, i
          k = k + 1
          aux(i,j) = spinab(k)
          aux(j,i) = spinab(k)
        end do
      end do
      do i = 1, numat
        da = 0.D0
        do j = 1, numat
          if (j == i) cycle
          da = da + aux(i,j)
        end do
        spsa(i) = da
        spsq(i) = aux(i,i)
        spna(i) = da + aux(i,i)
      end do
      write (iw, '(2/20X,''SELF UNPAIRED AND BOND SPIN POPULATIONS ''/)')
      call vecprt (spinab, numat)
      write (iw, '(2/)')
      write (iw, '(10X,'' TOTAL ATOMIC SPIN POPULATIONS''/)')
      write (iw, &
      '(1X,''ATOM    SELF UNCPLD SPIN    SHARED UNCPLD SPIN     TOTAL UNCPLD SP&
      &IN '',3/(1X,I3,3F20.5))') (i,spsq(i),spsa(i),spna(i),i=1,numat)
      return
      end subroutine bonds


      subroutine dopen(c, mdim, norbs, ndubl, nsingl, fract, sdm)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: mdim
      integer , intent(in) :: norbs
      integer , intent(in) :: ndubl
      integer , intent(in) :: nsingl
      double precision , intent(in) :: fract
      double precision , intent(in) :: c(mdim,mdim)
      double precision , intent(out) :: sdm((mdim*(mdim + 1))/2)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: nl1, nu1, l, i, j
      double precision :: frac, sum1
!-----------------------------------------------
!**********************************************************************
!
!  DOPEN COMPUTES THE DENSITY MATRIX OF OPEN SHELL ROHF STATE FUNCTIONS
!  FROM THE EIGENVECTOR MATRIX AND THE M.O'S OCCUPANCIES
!
!  INPUT:   C      = SQUARE EIGENVECTOR MATRIX C
!           NORBS  = NUMBER OF ORBITALS
!           NDUBL  = NUMBER OF DOUBLY OCCUPIED M.O'S (=0 IF UHF)
!           NSINGL = NUMBER OF SINGLY OR FRACTIONALLY OCCUPIED M.O'S
!
!  EXIT:    SDM    = ROHF OPEN SHELL DENSITY MATRIX
!
!**********************************************************************
!
!  SET UP LIMITS FOR SUMS
!    NL1 = BEGINNING OF ONE ELECTRON SUM
!    NU1 = END OF THE SAME
!
      frac = fract
      nl1 = ndubl + 1
      nu1 = nsingl
      l = 0
      do i = 1, norbs
        do j = 1, i
          l = l + 1
          sum1 = 0.D0
          sum1 = sum(c(i,nl1:nu1)*c(j,nl1:nu1))
          sdm(l) = sum1*frac
        end do
      end do
      return
      end subroutine dopen

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      module parameters_C
!
! This module holds all the parameters for the elements.  It is filled
! from the reference parameter sets
!
    logical, dimension(107) :: dorbs
    double precision, dimension(107) :: alp
    double precision, dimension(107,4) :: guess1, guess2, guess3
    double precision, dimension(60) :: v_par = 0.d0
    double precision, dimension(6,107) :: ddp
    double precision, dimension(9,107) :: po = 0.d0
    double precision, dimension(107) :: betas = 0.d0, betap = 0.d0, betad = 0.d0
    double precision, dimension(107) :: uss = 0.d0, upp = 0.d0, udd = 0.d0
    double precision, dimension(107) :: gpp = 0.d0, gp2 = 0.d0, hsp = 0.d0, gss = 0.d0, gsp = 0.d0
    double precision, dimension(107) :: am, ad, aq, dd, qq
    double precision, dimension(107) :: dsd = 0.d0, dpd = 0.d0, ddd = 0.d0
    double precision, dimension(107) :: zs, zp, zd, zsn = 0.d0, zpn = 0.d0, zdn = 0.d0
    double precision, dimension(107) :: eisol, eheat
    double precision, dimension(57:71) ::  eheat_sparkles
    double precision, dimension(107) :: ams
    double precision, dimension (107) :: tore, polvol, pocord, f0dd = 0.d0, f2dd = 0.d0, f4dd = 0.d0, &
    f0sd = 0.d0, g2sd = 0.d0, f0pd = 0.d0, f2pd = 0.d0, g1pd = 0.d0, g3pd = 0.d0, CPE_Zeta = 0.d0, &
      CPE_Z0 = 0.d0, CPE_B = 0.d0, CPE_Xlo = 0.d0, CPE_Xhi = 0.d0
    double precision, dimension (107) :: f0sd_store(107) ! Used by PARAM, not used in MOPAC
    double precision, dimension (107) :: g2sd_store(107) ! Used by PARAM, not used in MOPAC
    double precision, dimension (107) :: atom_radius_vdw, atom_radius_cosmo, &
    &  atom_radius_cosmo_oldcav
    double precision, dimension(100,100) :: xfac, alpb
    double precision :: dh2_a_parameters(6)
    integer, dimension (107,3) :: npq
    integer, dimension (107) :: iod, iop, ios, natorb, ndelec
    integer, parameter :: n_partyp = 72, n_partyp_alpb = 39, n_partyp_fn = 27
    logical, dimension (107) :: main_group
    double precision :: par1,  par2,  par3,  par4,  par5,  par6,  par7,  par8,  par9,  par10, &
                        par11, par12, par13, par14, par15, par16, par17, par18, par19, par20, &
                        par21, par22, par23, par24, par25, par26, par27, par28, par29, par30, &
                        par31, par32, par33, par34, par35, par36, par37, par38, par39, par40, &
                        par41, par42, par43, par44, par45, par46, par47, par48, par49, par50, &
                        par51, par52, par53, par54, par55, par56, par57, par58, par59, par60

    character :: partyp(n_partyp)*5
    character (len = 70) :: t_par(60), &
                        tpar1,  tpar2,  tpar3,  tpar4,  tpar5,  tpar6,  tpar7,  tpar8,  tpar9,  tpar10, &
                        tpar11, tpar12, tpar13, tpar14, tpar15, tpar16, tpar17, tpar18, tpar19, tpar20, &
                        tpar21, tpar22, tpar23, tpar24, tpar25, tpar26, tpar27, tpar28, tpar29, tpar30, &
                        tpar31, tpar32, tpar33, tpar34, tpar35, tpar36, tpar37, tpar38, tpar39, tpar40, &
                        tpar41, tpar42, tpar43, tpar44, tpar45, tpar46, tpar47, tpar48, tpar49, tpar50, &
                        tpar51, tpar52, tpar53, tpar54, tpar55, tpar56, tpar57, tpar58, tpar59, tpar60

    equivalence &
      (v_par(1),  par1),  (v_par(2), par2),   (v_par(3), par3),   (v_par(4), par4),   (v_par(5), par5),   &
      (v_par(6),  par6),  (v_par(7), par7),   (v_par(8), par8),   (v_par(9), par9),   (v_par(10), par10), &
      (v_par(11), par11), (v_par(12), par12), (v_par(13), par13), (v_par(14), par14), (v_par(15), par15), &
      (v_par(16), par16), (v_par(17), par17), (v_par(18), par18), (v_par(19), par19), (v_par(20), par20), &
      (v_par(21), par21), (v_par(22), par22), (v_par(23), par23), (v_par(24), par24), (v_par(25), par25), &
      (v_par(26), par26), (v_par(27), par27), (v_par(28), par28), (v_par(29), par29), (v_par(30), par30), &
      (v_par(31), par31), (v_par(32), par32), (v_par(33), par33), (v_par(34), par34), (v_par(35), par35), &
      (v_par(36), par36), (v_par(37), par37), (v_par(38), par38), (v_par(39), par39), (v_par(40), par40), &
      (v_par(41), par41), (v_par(42), par42), (v_par(43), par43), (v_par(44), par44), (v_par(45), par45), &
      (v_par(46), par46), (v_par(47), par47), (v_par(48), par48), (v_par(49), par49), (v_par(50), par50), &
      (v_par(51), par51), (v_par(52), par52), (v_par(53), par53), (v_par(54), par54), (v_par(55), par55), &
      (v_par(56), par56), (v_par(57), par57), (v_par(58), par58), (v_par(59), par59), (v_par(60), par60)
     equivalence &
      (t_par(1), tpar1),  (t_par(2),tpar2),   (t_par(3),tpar3),   (t_par(4),tpar4),   (t_par(5),tpar5),   &
      (t_par(6), tpar6),  (t_par(7),tpar7),   (t_par(8),tpar8),   (t_par(9),tpar9),   (t_par(10),tpar10), &
      (t_par(11),tpar11), (t_par(12),tpar12), (t_par(13),tpar13), (t_par(14),tpar14), (t_par(15),tpar15), &
      (t_par(16),tpar16), (t_par(17),tpar17), (t_par(18),tpar18), (t_par(19),tpar19), (t_par(20),tpar20), &
      (t_par(21),tpar21), (t_par(22),tpar22), (t_par(23),tpar23), (t_par(24),tpar24), (t_par(25),tpar25), &
      (t_par(26),tpar26), (t_par(27),tpar27), (t_par(28),tpar28), (t_par(29),tpar29), (t_par(30),tpar30), &
      (t_par(31),tpar31), (t_par(32),tpar32), (t_par(33),tpar33), (t_par(34),tpar34), (t_par(35),tpar35), &
      (t_par(36),tpar36), (t_par(37),tpar37), (t_par(38),tpar38), (t_par(39),tpar39), (t_par(40),tpar40), &
      (t_par(41),tpar41), (t_par(42),tpar42), (t_par(43),tpar43), (t_par(44),tpar44), (t_par(45),tpar45), &
      (t_par(46),tpar46), (t_par(47),tpar47), (t_par(48),tpar48), (t_par(49),tpar49), (t_par(50),tpar50), &
      (t_par(51),tpar51), (t_par(52),tpar52), (t_par(53),tpar53), (t_par(54),tpar54), (t_par(55),tpar55), &
      (t_par(56),tpar56), (t_par(57),tpar57), (t_par(58),tpar58), (t_par(59),tpar59), (t_par(60),tpar60)

    data ndelec / 20 * 0, &
!       Sc Ti V  Cr Mn Fe Co Ni Cu  Zn
      & 0, 0, 2, 2, 4, 4, 6, 8, 10, 10, 8 * 0, &   !  First transition series
      & 0, 0, 2, 2, 4, 4, 6, 8, 10, 10, 22* 0, &   !  Second transition series
      & 0, 0, 2, 2, 4, 4, 6, 8, 10, 10, 27 * 0 /   !  Third transition series
    double precision, dimension (n_partyp) :: defmax, defmin  ! Used by PARAM, not used in MOPAC

    save
!              H           Initial "s" Orbital Occupancies                     He
!              Li Be                                            B  C  N  O  F  Ne
!              Na Mg                                            Al Si P  S  Cl Ar
!              K  Ca Sc            Ti V  Cr Mn Fe Co Ni Cu Zn   Ga Ge As Se Br Kr
!              Rb Sr Y             Zr Nb Mo Tc Ru Rh Pd Ag Cd   In Sn Sb Te I  Xe
!              Cs Ba La Ce-Lu      Hf Ta W  Re Os Ir Pt Au Hg   Tl Pb Bi Po At Rn
!              Fr Ra Ac Th Pa U    Np Pu Am Cm Bk Cf            Cb ++ +  -- -  Tv
!                                      "s" shell
    data ios &
        &/ 1,                                                                2, &!    2
        &  1, 2,                                              2, 2, 2, 2, 2, 0, &!   10
        &  1, 2,                                              2, 2, 2, 2, 2, 0, &!   18
        &  1, 2, 2,              2, 2, 1, 2, 2, 2, 2, 1, 2,   2, 2, 2, 2, 2, 0, &!   36
        &  1, 2, 2,              2, 1, 1, 2, 1, 1, 0, 1, 2,   2, 2, 2, 2, 2, 0, &!   54
        &  1, 2, 2, 5*2,3*2,6*2, 2, 2, 1, 2, 2, 2, 1, 1, 2,   2, 2, 2, 2, 2, 0, &!   86
        &  1, 1, 2, 4, 2, 2,     2, 2, 2, 2, 2, 1, 0, 3,-3,   1, 2, 1,-2,-1, 0 /
!                                  /
!
!              H           Initial "p" Orbital Occupancies                   He
!              Li Be                                          B  C  N  O  F  Ne
!              Na Mg                                          Al Si P  S  Cl Ar
!              K  Ca Sc          Ti V  Cr Mn Fe Co Ni Cu Zn   Ga Ge As Se Br Kr
!              Rb Sr Y           Zr Nb Mo Tc Ru Rh Pd Ag Cd   In Sn Sb Te I  Xe
!              Cs Ba La Ce-Lu    Hf Ta W  Re Os Ir Pt Au Hg   Tl Pb Bi Po At Rn
!              Fr Ra Ac Th Pa U  Np Pu Am Cm Bk Cf (The rest are reserved for MOPAC)
!                                      "p" shell
    data iop / 0 ,                                                           0, &!    2
            &  0, 0,                                          1, 2, 3, 4, 5, 6, &!   10
            &  0, 0,                                          1, 2, 3, 4, 5, 6, &!   18
            &  0, 0, 0,          0, 0, 0, 0, 0, 0, 0, 0, 0,   1, 2, 3, 4, 5, 6, &!   36
            &  0, 0, 0,          0, 0, 0, 0, 0, 0, 0, 0, 0,   1, 2, 3, 4, 5, 6, &!   54
            &  0, 0, 0,  14*0,   0, 0, 0, 0, 0, 0, 0, 0, 0,   1, 2, 3, 4, 5, 6, &!   86
            &  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9*0                        /
!
!              H           Initial "d" Orbital Occupancies                   He
!              Li Be                                          B  C  N  O  F  Ne
!              Na Mg                                          Al Si P  S  Cl Ar
!              K  Ca Sc          Ti V  Cr Mn Fe Co Ni Cu Zn   Ga Ge As Se Br Kr
!              Rb Sr Y           Zr Nb Mo Tc Ru Rh Pd Ag Cd   In Sn Sb Te I  Xe
!              Cs Ba La Ce-Lu    Hf Ta W  Re Os Ir Pt Au Hg   Tl Pb Bi Po At Rn
!              Fr Ra Ac Th Pa U  Np Pu Am Cm Bk Cf (The rest are reserved for MOPAC)
!                                      "d" shell
    data iod / 0,                                                           0, &!    2
             & 0, 0,                                         0, 0, 0, 0, 0, 0, &!   10
             & 0, 0,                                         0, 0, 0, 0, 0, 0, &!   18
             & 0, 0, 1,          2, 3, 5, 5, 6, 7, 8, 10, 0, 0, 0, 0, 0, 0, 0, &!   36
             & 0, 0, 1,          2, 4, 5, 5, 7, 8,10, 10, 0, 0, 0, 0, 0, 0, 0, &!   54
             & 0, 0, 1,13*1,  1, 2, 3, 5, 5, 6, 7, 9, 10, 0, 0, 0, 0, 0, 0, 0, &!   86
             & 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9*0                     /
!
!                     Principal Quantum Numbers for all shells.
!
!              H                 "s"  shell                                  He
!              Li Be                                          B  C  N  O  F  Ne
!              Na Mg                                          Al Si P  S  Cl Ar
!              K  Ca Sc          Ti V  Cr Mn Fe Co Ni Cu Zn   Ga Ge As Se Br Kr
!              Rb Sr Y           Zr Nb Mo Tc Ru Rh Pd Ag Cd   In Sn Sb Te I  Xe
!              Cs Ba La Ce-Lu    Hf Ta W  Re Os Ir Pt Au Hg   Tl Pb Bi Po At Rn
!              Fr Ra Ac Th-Lr    ?? ?? ?? ??
!
data npq(1:107,1) / &
             & 1,                                                             1, &!  2
             & 2, 2,                                           2, 2, 2, 2, 2, 3, &! 10
             & 3, 3,                                           3, 3, 3, 3, 3, 4, &! 18
             & 4, 4,             4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, &! 36
             & 5, 5,             5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, &! 54
             & 6, 6, 14 * 6,     6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 7, &! 86
             & 11 * 0, 1, 0, 0, 0,3, 5 * 0 /
!
!              H                "p"  shell                                   He
!              Li Be                                          B  C  N  O  F  Ne
!              Na Mg                                          Al Si P  S  Cl Ar
!              K  Ca Sc          Ti V  Cr Mn Fe Co Ni Cu Zn   Ga Ge As Se Br Kr
!              Rb Sr Y           Zr Nb Mo Tc Ru Rh Pd Ag Cd   In Sn Sb Te I  Xe
!              Cs Ba La Ce-Lu    Hf Ta W  Re Os Ir Pt Au Hg   Tl Pb Bi Po At Rn
!              Fr Ra Ac Th-Lr    ?? ?? ?? ??
!
data npq(1:107,2) / &
             & 1,                                                             2, &!  2
             & 2, 2,                                           2, 2, 2, 2, 2, 2, &! 10
             & 3, 3,                                           3, 3, 3, 3, 3, 3, &! 18
             & 4, 4,             4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, &! 36
             & 5, 5,             5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, &! 54
             & 6, 6, 14 * 6,     6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, &! 86
             & 21 * 0 /
!
!              H                 "d"  shell                                  He
!              Li Be                                          B  C  N  O  F  Ne
!              Na Mg                                          Al Si P  S  Cl Ar
!              K  Ca Sc          Ti V  Cr Mn Fe Co Ni Cu Zn   Ga Ge As Se Br Kr
!              Rb Sr Y           Zr Nb Mo Tc Ru Rh Pd Ag Cd   In Sn Sb Te I  Xe
!              Cs Ba La Ce-Lu    Hf Ta W  Re Os Ir Pt Au Hg   Tl Pb Bi Po At Rn
!              Fr Ra Ac Th-Lr    ?? ?? ?? ??
!
data npq(1:107,3) / &
             & 0,                                                             0, &!  2
             & 0, 0,                                           0, 0, 0, 0, 0, 0, &! 10
             & 3, 3,                                           3, 3, 3, 3, 3, 4, &! 18
             & 3, 3,             3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 5, &! 36
             & 4, 4,             4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 6, &! 54
             & 5, 5, 14 * 5,     5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 7, &! 86
             & 21 * 0 /
!  Main_group is .true. if the Gss, Gpp, etc., are independent of zsn, zpn, and zdn,
!  .false. otherwise.
!
!  For main-group elements, the Gss value is important, for the transition metals,
!  Gss is less important.
!
    data main_group /&
   &  2*.true.,                              & ! H  - He
   &  8*.true.,                              & ! Li - Ne
   &  8*.true.,                              & ! Na - Ar
   &  2*.true., 9*.false., 7*.true.,         & ! K  - Kr
   &  2*.true., 9*.false., 7*.true.,         & ! Rb - Xe
   &  2*.true.,23*.false., 7*.true.,         & ! Cs - Rn
   & 21*.true.                               / ! Fr - Tv
!
!     ENTHALPIES OF FORMATION OF GASEOUS ATOMS ARE TAKEN FROM \ANNUAL
!     REPORTS,1974,71B,P 117\  THERE ARE SOME SIGNIFICANT DIFFERENCES
!     BETWEEN THE VALUES REPORTED THERE AND THE VALUES PREVIOUSLY IN
!     THE BLOCK DATA OF THIS PROGRAM.  ONLY THE THIRD  ROW ELEMENTS
!     HAVE BEEN UPDATED.
!
! ALL THE OTHER ELEMENTS ARE TAKEN FROM CRC HANDBOOK 1981-1982
    data eheat(1) / 52.102d0 /
    data eheat(2) / 0.000d0 /
    data eheat(3) / 38.410d0 /
    data eheat(4) / 76.960d0 /
    data eheat(5) / 135.700d0 /
    data eheat(6) / 170.890d0 /
    data eheat(7) / 113.000d0 /
    data eheat(8) / 59.559d0 /
    data eheat(9) / 18.890d0 /
    data eheat(10) / 0.000d0 /
    data eheat(11) / 25.650d0 /
    data eheat(12) / 35.000d0 /
    data eheat(13) / 79.490d0 /
    data eheat(14) / 108.390d0 /
    data eheat(15) / 75.570d0 /
    data eheat(16) / 66.400d0 /
    data eheat(17) / 28.990d0 /
    data eheat(18) / 0.000d0 /
    data eheat(19) / 21.420d0 /
    data eheat(20) / 42.600d0 /
    data eheat(21) / 90.300d0 /
    data eheat(22) / 112.300d0 /
    data eheat(23) / 122.900d0 /
    data eheat(24) / 95.000d0 /
    data eheat(25) / 67.700d0 /
    data eheat(26) / 99.300d0 /
    data eheat(27) / 102.400d0 /
    data eheat(28) / 102.800d0 /
    data eheat(29) / 80.700d0 /
    data eheat(30) / 31.170d0 /
    data eheat(31) / 65.400d0 /
    data eheat(32) / 89.500d0 /
    data eheat(33) / 72.300d0 /
    data eheat(34) / 54.300d0 /
    data eheat(35) / 26.740d0 /
    data eheat(36) / 0.000d0 /
    data eheat(37) / 19.600d0 /
    data eheat(38) / 39.100d0 /
    data eheat(39) / 101.500d0 /
    data eheat(40) / 145.500d0 /
    data eheat(41) / 172.400d0 /
    data eheat(42) / 157.300d0 /
    data eheat(43) / 162.000d0 /
    data eheat(44) / 155.500d0 /
    data eheat(45) / 133.000d0 /
    data eheat(46) / 90.000d0 /
    data eheat(47) / 68.100d0 /
    data eheat(48) / 26.720d0 /
    data eheat(49) / 58.000d0 /
    data eheat(50) / 72.200d0 /
    data eheat(51) / 63.200d0 /
    data eheat(52) / 47.000d0 /
    data eheat(53) / 25.517d0 /
    data eheat(54) / 0.000d0 /
    data eheat(55) / 18.700d0 /
    data eheat(56) / 42.500d0 /
    data eheat(57) /103.011d0/
    data eheat(58) /101.004d0/
    data eheat(59) /84.990d0/
    data eheat(60) /78.298d0/
    data eheat(61) /83.174d0/
    data eheat(62) /49.402d0/
    data eheat(63) /41.898d0/
    data eheat(64) /95.007d0/
    data eheat(65) /92.902d0/
    data eheat(66) /69.407d0/
    data eheat(67) /71.893d0/
    data eheat(68) /75.791d0/
    data eheat(69) /55.500d0/
    data eheat(70) /36.358d0/
    data eheat(71) /102.199d0/
    data eheat(72) / 148.000d0 /
    data eheat(73) / 186.900d0 /
    data eheat(74) / 203.100d0 /
    data eheat(75) / 185.000d0 /
    data eheat(76) / 188.000d0 /
    data eheat(77) / 160.000d0 /
    data eheat(78) / 135.200d0 /
    data eheat(79) / 88.000d0 /
    data eheat(80) / 14.690d0 /
    data eheat(81) / 43.550d0 /
    data eheat(82) / 46.620d0 /
    data eheat(83) / 50.100d0 /
    data eheat(86) / 0.000d0 /
    data eheat(90) / 1674.64d0/
    data eheat(102) / 207.0d0 /
    data eheat(103) / 0.0d0 /
    data eheat(104) / 0.0d0 /
    data eheat(105) / 0.0d0 /
    data eheat(106) / 0.0d0 /
    data eheat(107) / 0.0d0 /
    data eheat_sparkles(57) / 928.9D0/   !  Represents La(+++)
    data eheat_sparkles(58) / 944.7D0 /  !  Represents Ce(+++)
    data eheat_sparkles(59) / 952.9D0 /  !  Represents Pr(+++)
    data eheat_sparkles(60) / 962.8D0 /  !  Represents Nd(+++)
    data eheat_sparkles(61) / 976.9D0 /  !  Represents Pm(+++)
    data eheat_sparkles(62) / 974.4d0 /  !  Represents Sm(+++)
    data eheat_sparkles(63) / 1006.6d0/  !  Represents Eu(+++)
    data eheat_sparkles(64) / 991.37d0/  !  Represents Gd(+++)
    data eheat_sparkles(65) / 999.0d0/   !  Represents Tb(+++)
    data eheat_sparkles(66) / 1001.3d0 / !  Represents Dy(+++)
    data eheat_sparkles(67) / 1009.6d0 / !  Represents Ho(+++)
    data eheat_sparkles(68) / 1016.15d0 /!  Represents Er(+++)
    data eheat_sparkles(69) / 1022.06d0/ !  Represents Tm(+++)
    data eheat_sparkles(70) / 1039.03d0/ !  Represents Ho(+++)
    data eheat_sparkles(71) / 1031.2d0 / !  Represents Lu(+++)
    data eisol / 107 * 0.0d0 /
    data ams / 1.00790d0, 4.00260d0, 6.94000d0, 9.01218d0, 10.81000d0, &
   & 12.01100d0, 14.00670d0, 15.99940d0, 18.99840d0, 20.17900d0, 22.98977d0, &
   & 24.30500d0, 26.98154d0, 28.08550d0, 30.97376d0, 32.06000d0, 35.45300d0, &
   & 39.94800d0, 39.09830d0, 40.08000d0, 44.95590d0, 47.90000d0, 50.94150d0, &
   & 51.99600d0, 54.93800d0, 55.84700d0, 58.93320d0, 58.71000d0, 63.54600d0, &
   & 65.38000d0, 69.73500d0, 72.59000d0, 74.92160d0, 78.96000d0, 79.90400d0, &
   & 83.80000d0, 85.46780d0, 87.62000d0, 88.90590d0, 91.22000d0, 92.90640d0, &
   & 95.94000d0, 98.90620d0, 101.0700d0, 102.9055d0, 106.4000d0, 107.8680d0, &
   & 112.4100d0, 114.8200d0, 118.6900d0, 121.7500d0, 127.6000d0, 126.9045d0, &
   & 131.3000d0, 132.9054d0, 137.3300d0, 138.9060d0, 140.1160d0, 140.9077d0, &
   & 144.2400d0, 145.0000d0, 150.3600d0, 151.9640d0, 157.2500d0, 158.9253d0, &
   & 162.5000d0, 164.9303d0, 167.2600d0, 168.9342d0, 173.0400d0, 174.9670d0, &
   & 178.4900d0, 180.9479d0, &
   & 183.8500d0, 186.2070d0, 190.2000d0, 192.2200d0, 195.0900d0, 196.9665d0, &
   & 200.5900d0, 204.3700d0, 207.2000d0, 208.9804d0, 209.0000d0, 210.0000d0, &
   & 222.0000d0, 223.0000d0, 226.0000d0, 227.0000d0, 232.0381d0, 231.0359d0, &
   & 238.0289d0, 5 * 0.000d0, 0.00005d0, 3*0.d0, 1.0079d0, &
   & 5 * 0.000d0 /
    data partyp (1),  defmin (1),  defmax (1) / "USS  ", - 200.d0, 60.d0 /
    data partyp (2),  defmin (2),  defmax (2) / "UPP  ", - 200.d0, 60.d0 /
    data partyp (3),  defmin (3),  defmax (3) / "UDD  ", - 200.d0, 60.d0 /
    data partyp (4),  defmin (4),  defmax (4) / "ZS   ", 0.6d0, 6.d0 /
    data partyp (5),  defmin (5),  defmax (5) / "ZP   ", 0.6d0, 6.d0 /
    data partyp (6),  defmin (6),  defmax (6) / "ZD   ", 0.6d0, 6.d0 /
    data partyp (7),  defmin (7),  defmax (7) / "BETAS", - 70.d0, 10.d0 /
    data partyp (8),  defmin (8),  defmax (8) / "BETAP", - 70.d0, 10.d0 /
    data partyp (9),  defmin (9),  defmax (9) / "BETAD", - 70.d0, 10.d0 /
    data partyp (10), defmin (10), defmax (10) / "GSS  ", 1.d0, 20.d0 /
    data partyp (11), defmin (11), defmax (11) / "GSP  ", 1.d0, 20.d0 /
    data partyp (12), defmin (12), defmax (12) / "GPP  ", 1.d0, 20.d0 /
    data partyp (13), defmin (13), defmax (13) / "GP2  ", 1.0d0, 19.d0 /
    data partyp (14), defmin (14), defmax (14) / "HSP  ", 1.d0, 5.d0 /
    data partyp (15), defmin (15), defmax (15) / "F0SD ", 1.d0,10.d0 /
    data partyp (16), defmin (16), defmax (16) / "G2SD ", 1.d0,10.d0 /
    data partyp (17), defmin (17), defmax (17) / "POC  ", 1.d0,10.d0 /
    data partyp (18), defmin (18), defmax (18) / "ALP  ", 0.5d0, 6.d0 /
    data partyp (19), defmin (19), defmax (19) / "ZSN  ", 0.5d0,25.d0 /
    data partyp (20), defmin (20), defmax (20) / "ZPN  ", 0.5d0,25.d0 /
    data partyp (21), defmin (21), defmax (21) / "ZDN  ", 0.5d0,25.d0 /
    data partyp (22), defmin (22), defmax (22) / "C_ZET", -0.5d0,25.d0 /
    data partyp (23), defmin (23), defmax (23) / "C_Z0 ", -0.5d0,25.d0 /
    data partyp (24), defmin (24), defmax (24) / "C_B  ", -0.5d0,25.d0 /
    data partyp (25), defmin (25), defmax (25) / "C_XLO", -0.5d0,25.d0 /
    data partyp (26), defmin (26), defmax (26) / "C_XHI", -0.5d0,25.d0 /
    data partyp (27), defmin (27), defmax (27) / "FN11 ", -1.d0, 1.d0 /
    data partyp (28), defmin (28), defmax (28) / "FN21 ", 0.5d0, 3.d0 /
    data partyp (29), defmin (29), defmax (29) / "FN31 ", 0.5d0, 3.d0 /
    data partyp (30), defmin (30), defmax (30) / "FN12 ", - 1.d0, 1.d0 /
    data partyp (31), defmin (31), defmax (31) / "FN22 ", 0.15d0, 3.d0 /
    data partyp (32), defmin (32), defmax (32) / "FN32 ", 0.5d0, 3.5d0 /
    data partyp (33), defmin (33), defmax (33) / "FN13 ", - 1.d0, 1.d0 /
    data partyp (34), defmin (34), defmax (34) / "FN23 ", 1.d0, 3.d0 /
    data partyp (35), defmin (35), defmax (35) / "FN33 ", 0.5d0, 4.d0 /
    data partyp (36), defmin (36), defmax (36) / "FN14 ", - 1.d0, 1.d0 /
    data partyp (37), defmin (37), defmax (37) / "FN24 ", 1.d0, 3.d0 /
    data partyp (38), defmin (38), defmax (38) / "FN34 ", 0.5d0, 3.d0 /
    data partyp (39), defmin (39), defmax (39) / "ALPB_", 0.9d0, 3.0d0 /
    data partyp (40), defmin (40), defmax (40) / "XFAC_", 0.5d0, 30.d0 /
    data partyp (41), defmin (41), defmax (41) / "PAR  ", 0.5d0, 6.d0 /
    data partyp (42), defmin (42), defmax (42) / "NORBS", 0.9d0, 9.1d0/
    data partyp (43)                           / "ZCORE"/
    data partyp (44)                           / "ZSP  "/
    data partyp (45)                           / "ZD1  "/
    data partyp (46)                           / "ZD2  "/
    data partyp (47)                           / "ZWT1 "/
    data partyp (48)                           / "ZWT2 "/
    data partyp (49)                           / "FG1  "/
    data partyp (50)                           / "FG2  "/
    data partyp (51)                           / "FG3  "/
    data partyp (52)                           / "FG4  "/
    data partyp (53)                           / "FG5  "/
    data partyp (54)                           / "FG6  "/
    data partyp (55)                           / "FG7  "/
    data partyp (56)                           / "FG8  "/
    data partyp (57)                           / "FG9  "/
    data partyp (58)                           / "FG10 "/
    data partyp (59)                           / "FG11 "/
    data partyp (60)                           / "FG12 "/
    data partyp (61)                           / "FG13 "/
    data partyp (62)                           / "FG14 "/
    data partyp (63)                           / "FG15 "/
    data partyp (64)                           / "FG16 "/
    data partyp (65)                           / "FG17 "/
    data partyp (66)                           / "FG18 "/
    data partyp (67)                           / "FG19 "/
    data partyp (68)                           / "FG20 "/
    data partyp (69)                           / "FG21 "/
    data partyp (70)                           / "FG22 "/
    data partyp (71)                           / "FG23 "/
    data partyp (72)                           / "FG24 "/
      end module parameters_C

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine rotmol(numat, coord, sina, cosa, i, j, r)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: numat
      integer , intent(in) :: i
      integer , intent(in) :: j
      double precision , intent(in) :: sina
      double precision , intent(in) :: cosa
      double precision  :: coord(3,numat)
      double precision  :: r(3,3)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: k
      double precision :: buff
!-----------------------------------------------
      call symopr (numat, coord, -1, r)
      do k = 1, 3
        buff = (-sina*r(k,i)) + cosa*r(k,j)
        r(k,i) = cosa*r(k,i) + sina*r(k,j)
        r(k,j) = buff
      end do
      call symopr (numat, coord, 1, r)
      return
      end subroutine rotmol

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine dang(a1, a2, b1, b2, rcos)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision , intent(inout) :: a1
      double precision , intent(inout) :: a2
      double precision , intent(inout) :: b1
      double precision , intent(inout) :: b2
      double precision , intent(out) :: rcos
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      double precision :: zero, anorm, bnorm, sinth, costh
!-----------------------------------------------
!*********************************************************************
!
!    DANG  DETERMINES THE ANGLE BETWEEN THE POINTS (A1,A2), (0,0),
!          AND (B1,B2).  THE RESULT IS PUT IN RCOS.
!
!*********************************************************************
      zero = 1.0D-6
      if (abs(a1) >= zero .or. abs(a2) >= zero) then
        if (abs(b1) >= zero .or. abs(b2) >= zero) then
          anorm = 1.0D0/sqrt(a1**2 + a2**2)
          bnorm = 1.0D0/sqrt(b1**2 + b2**2)
          a1 = a1*anorm
          a2 = a2*anorm
          b1 = b1*bnorm
          b2 = b2*bnorm
          sinth = a1*b2 - a2*b1
          costh = a1*b1 + a2*b2
          costh = min(1.0D0,costh)
          costh = dmax1(-1.0D0,costh)
          rcos = acos(costh)
          if (abs(rcos) >= 4.0D-5) then
            if (sinth > 0.D0) rcos = 6.28318530717959D0 - rcos
            rcos = -rcos
            return
          end if
        end if
      end if
      rcos = 0.0D0
      return
      end subroutine dang

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      module vast_kind_param                                        
         integer, parameter :: byte_log = selected_int_kind(2)      
         integer, parameter :: short_log = selected_int_kind(4)     
         integer, parameter :: long_log = selected_int_kind(18)     
         integer, parameter :: byte = selected_int_kind(2)          
         integer, parameter :: short = selected_int_kind(4)         
         integer, parameter :: long = selected_int_kind(18)         
         integer, parameter :: double = selected_real_kind(8)      
         integer, parameter :: extended = selected_real_kind(30)    
         integer, parameter :: double_ext = selected_real_kind(50)  
         integer, parameter :: dble_complex = selected_real_kind(14)
         integer, parameter :: ext_complex = selected_real_kind(30) 
      end module vast_kind_param                                    

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  subroutine fillij (count)
      use molkst_C, only: numat, natoms, cutofp, id, n2elec, l1u, l2u, l3u, keywrd, mpack, &
        ispd, line
      use common_arrays_C, only : tvec, coord
      use chanel_C, only: iw
      use MOZYME_C, only : cutofs, direct, semidr, &
        nijbo, lijbo, iijj, iij, ij_dim, ijall, numij, morb, iorbs
      use overlaps_C, only : cutof1, cutof2
!
      implicit none
      !
      !***********************************************************************
      !
      ! fillij creates either the array ijbo, if there is enough memory, or
      ! the arrays iijj, ijall, and iij, if there is not enough memory.
      !
      !***********************************************************************
      logical :: count
!
      integer :: i, ii, iloop, io, ip, j, jloop, jo, jp, &
           & kp, lp, ix
      double precision :: r, rmin, rr, x1, x2, x3
      save :: ix
      logical :: first
      double precision, dimension (3) :: xj
      double precision, external :: reada
!
      if (.not. allocated(nijbo)) then
        ix = 0
        n2elec = 0
        mpack = 0
        first = .true.
        morb = 4
        if (ispd > 0) morb = 9
      else
!
!   Array nijbo was already allocated, therefore it was filled.  Do not reset mpack1, instead add any new interactions
!   to array nijbo
!
        first = .false.
      end if
!
      if (.not. count) then
        ! Allocate either nijbo or iijj and ijall
        if ( .not. allocated(nijbo)) then
          i = 1
          if (lijbo) then
!
!  Try to allocate memory for a simple square array
!
            allocate (nijbo(numat, numat), stat = i)
            if (i == 0) nijbo(:, :) = 0
          end if
          if (i /= 0) then

!
!  Array nijbo could not be created.  Therefore set lijbo false and
!  create smaller, but more CPU intensive, arrays
!
            lijbo = .false.
            allocate (iijj(ij_dim), ijall(ij_dim), iij(natoms), numij(natoms), &
               & stat = i)
            if (i /= 0) then
              call mopend("There is not enough memory to create the ijbo-type arrays")
              return
            end if
            iijj(:) = 0
            ijall(:) = 0
            iij(:) = 0
            numij(:) = 0
          end if
        end if
      else
        lijbo = .true.
      end if
      !
      !   Set CUTOF values  CUTOF2 = First cutoff (NDDO-dipolar)
      !                     CUTOF1 = Second cutoff (dipolar-point charge)
      !

      cutof1 = 10.d0 ** 2
      if (cutofp < 100.d0) cutof1 = cutofp ** 2 + 1.d-4
      if (numat < 30)      cutof1 = 1.d6 + 10
      cutof2 = 9.9d0 ** 2
      if (cutofp < 100.d0) cutof2 = cutofp ** 2
      if (numat < 30)      cutof2 = 1.d6
      line = trim(keywrd)
      if (index(line," GEO_DAT") /= 0) then
        i = index(line," GEO_DAT") + 9
        j = index(line(i + 10:),'" ') + i + 9
        line(i:j) = " "
      end if

      i = Index (line, " CUTOFF=")
      if (i /= 0) then
        cutof1 = reada (line, i+8)
        cutof2 = (cutof1 - 1.d-1)**2
        cutof1 = cutof1**2
      else
        i = Index (line, " CUTOF1=")
        if (i /= 0) cutof1 = reada (keywrd, i+8) ** 2
        i = Index (line, " CUTOF2=")
        if (i /= 0) cutof2 = reada (keywrd, i+8) ** 2
      end if
      !
      i = Index (line, " CUTOFS=")
      if (i /= 0) then
        cutofs = reada (line, i+8) ** 2
      else
        cutofs = 7.d0 ** 2
      end if
      !
      !   Check that CUTOF1 is greater than CUTOF2
      !
      if (cutof1 < cutof2) then
        cutof1 = cutof2 + 1.d-4
        write (iw, "(/,A,F12.4,/)") " CUTOF1 WAS SET SMALLER THAN CUTOF2," // &
             & " RESET TO", Sqrt (cutof1)
      end if
      !#aab
      if ((Index (keywrd, " NODIRECT") /= 0) .or. (id /= 0) ) then
        direct = .false.
        semidr = .false.
      else if (Index (keywrd, " SEMIDIRECT") /= 0) then
        direct = .false.
        semidr = .true.
      else
        direct = .true.
        semidr = .true.
      end if
      !#aab - end
      !
      rmin = 100.d0
      !
      !     Identify atom pairs involved in calculation.  This is done based
      !     on interatomic distance.
      !
      i = 0
      do iloop = 1, numat
          io = iorbs(iloop)
          i = i + 1
          x1 = coord(1, i)
          x2 = coord(2, i)
          x3 = coord(3, i)
          ii = (io*(io+1)) / 2
          if (first) n2elec = n2elec + ii * ii ! for one-centre two-electron integrals
          if (.not. lijbo .and. .not. count) then
            iij(i) = ix + 1
          end if
          j = 0
          do jloop = 1, iloop - 1
              jo = iorbs(jloop)
              j = j + 1
              if (id == 0) then
                r = (x1-coord(1, j)) ** 2 + (x2-coord(2, j)) ** 2 &
                     & + (x3-coord(3, j)) ** 2
              else
                r = 1.d10
                do ip = -l1u, l1u
                  do jp = -l2u, l2u
                    do kp = -l3u, l3u
                      do lp = 1, 3
                        xj(lp) = coord(lp, j) + tvec(lp, 1) * ip &
                             & + tvec(lp, 2) * jp + tvec(lp, 3) * kp
                      end do
                      rr = (x1-xj(1)) ** 2 + (x2-xj(2)) ** 2 + (x3-xj(3)) ** 2
                      r = Min (r, rr)
                    end do
                  end do
                end do
              end if

              if (r < cutof2) then
                ix = ix + 1
                if (.not. count) then
                  if (lijbo) then
                    if (first .or. nijbo(i,j) < 0) then
                      nijbo(i, j) = mpack
                      nijbo(j, i) = mpack
                    else
                      mpack = mpack - io * jo  !  prevent mpack from being incremented - the element of
                                                 !  nijbo was already set.
                    end if
                  else
                    iijj(ix) = mpack
                    ijall(ix) = j
                  end if
                end if
                mpack = mpack + io * jo
                !
                if ( .not. direct) then
                  n2elec = n2elec + (jo*(jo+1)) / 2 * ii
                end if
                if (r < rmin) then
                  rmin = r
                end if
              else if (r < cutof1) then
                !
                !   USE CHARGES AND DIPOLES
                !
                if ( .not. semidr) then
                  !
                  if (io > 1) then
                    if (jo > 1) then
                      n2elec = n2elec + 7
                    else
                      n2elec = n2elec + 4
                    end if
                  else if (jo > 1) then
                    n2elec = n2elec + 4
                  else
                    n2elec = n2elec + 1
                  end if
                end if !#aab - end
                !
                if (lijbo .and. (.not. count)) then
                  if (first .or. nijbo(i,j) == -1) then
                    nijbo(i, j) = -2
                    nijbo(j, i) = -2
                  end if
                end if
                !#aab
              else
                !
                !  USE POINT CHARGE APPROXIMATION
                !
                if ( .not. semidr) then
                  n2elec = n2elec + 1
                end if
                !
                if (lijbo .and. (.not. count)) then
                  if (first) then
                    nijbo(i, j) = -1
                    nijbo(j, i) = -1
                  end if
                end if
                !#aab
            end if
          end do
          !
          ix = ix + 1
          if (.not. count) then
            if (lijbo) then
              if (first) then
                nijbo(i, i) = mpack
              else
                mpack = mpack - (io*(io+1)) / 2  !  prevent mpack from being incremented - the element of
                                                   !  nijbo was already set.
              end if
            else
              iijj(ix) = mpack
              ijall(ix) = i
              numij(i) = ix
            end if
          end if
          if (id /= 0) then
            n2elec = n2elec + ((io*(io+1))/2) ** 2
          end if
          mpack = mpack + (io*(io+1)) / 2
      end do
      !
      if (count) then
        ij_dim = ix
      end if
      !
      !  Leave room for dummy atom integrals and for gradients
      !
      if (n2elec < 2025) then
        n2elec = 2025
      end if
      if (first) then
        n2elec = n2elec + 10
        if (direct .and. ispd == 0) n2elec = n2elec + 100
        if (direct .and. ispd /= 0) n2elec = n2elec + 2025
      end if
      if (id /= 0) then
        n2elec = n2elec * 2
      end if
    end subroutine fillij

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine names (ioptl, lused, n1, ires, nfrag, io, uni_res, mres)
    use molkst_C, only: natoms, numat, keywrd, id
    use MOZYME_C, only : nres, allres, maxres, nbackb, nxeno, mxeno, k, iatom, jatom, &
       & loop, bbone, angles, txeno, afn, allr, lstart_res
    use common_arrays_C, only : nat, labels, txtatm, txtatm1, ibonds, coord, breaks, nbonds
    use funcon_C, only : pi
    use chanel_C, only: iw
    implicit none
    integer, intent (in) :: n1, nfrag, io
    integer, intent (inout) :: ires, uni_res, mres
    logical, dimension (numat), intent (inout) :: ioptl
    integer, dimension (natoms), intent (inout) :: lused
!
    logical :: lreseq, first_res, iatoms(numat)
    integer :: i, iold, irold, j, l, ires_start, ires_loop, &
      nbreaks
    intrinsic Index, Max
!
    lreseq = (Index (keywrd, " RESEQ") /= 0)
    do i = 1, 4
      nbackb(i) = 0
      nxeno(i, 1) = 0
    end do
    mxeno = 1
!
!   WORK OUT THE BACKBONE
!
    iatom = n1
    iold = -999
    if (nfrag == 1) txtatm(:numat) = " "
    irold = ires + 1
    bbone(1,ires + 1) = n1
    ires = ires + 1
    ires_start = ires
    first_res = .true.
    iatoms = .false.
    jatom = 0
    do ires_loop = ires_start, maxres
      if (iatom == 0) goto 999
      if (iatoms(iatom)) goto 1000
      iatoms(iatom) = .true.
!
!  NXTMER identifies the backbone atoms to the next residue.
!  The nitrogen of the next residue is in NBACKB(4)
!
      ioptl(iatom) = .true.
      call nxtmer (iatom, nbackb)
      jatom = nbackb(4)
!
!  The residue is attached to IATOM and does not involve JATOM
!
!  NOW TO WORK OUT THE ATOMS IN THE RESIDUE
!
      uni_res = uni_res + 1
      i = io
      if (.not. first_res) then
        do i = 1, numat
          if (nat(i) /= 8) exit
        end do
      end if
      call atomrs (lused, ioptl, ires, n1, i, uni_res, first_res)
      lstart_res(ires) = .true.
      first_res = .false.
      bbone(1,ires + 1) = jatom!  N of residue
      bbone(2,ires) = nbackb(1)!  C(alpha) of residue
      bbone(3,ires) = nbackb(2)!  C1 of residue (Carboxylic)
      if (loop /= 1 .and. k > 0 .and. k /= 23 .and. i /= 1) then
        i = Max (Index (txeno(loop), " "), 2) - 1
        if (i /= 1 .and. index(keywrd, " ADD-H") == 0) &
          write (iw,"(a,i5, 4a,i5,a)") "         Residue:", ires, &
            " ("//allres(ires)(:3)//") contains a xeno group."
        if (allres(ires) (4:4) == "+") then
          write (iw, "(A,I5,A)") "         Residue:", ires, &
               & " plus xeno group has a positive charge"
        else if (allres(ires) (4:4) == "-") then
          write (iw, "(A,I5,A)") "         Residue:", ires, &
               & " plus xeno group has a negative charge"
        end if
        allres (ires) = allres (ires) (1:3) // "*"
      end if
      if (iatom == jatom) go to 1000
      if (iold == jatom) then
        write (iw,*) " STRUCTURE UNRECOGNIZABLE"
        call mopend("Structure Unrecognizable")
        exit
      end if
      iold = iatom
      iatom = jatom
      if (iatom == 0 .and. ires_loop == ires_start) go to 1010
      ires = ires + 1
      if (ires == 0) then
        if (txtatm1(1) == " " .or. index(keywrd, " CHECKZERO") /= 0) then
          call l_control("CHECKZERO", len("CHECKZERO"), 1)
            if (index(keywrd, " NOZERO") /= 0) then
              ires = 1
            else if (index(keywrd, " ZERO") /= 0) then
              ires = 0
            else
              write(iw,'(/10x, a)') "A residue that can have either the number 1 or 0 has been detected"
              write(iw,'(10x, a)') "Add keyword ""NOZERO"" if the number 1 is to be used for this residue"
              write(iw,'(10x, a)') "Add keyword ""ZERO"" if the number 0 is to be used for this residue"
              call mopend("DURING ASSIGNMENT OF RESIDUES AN AMBIGUITY IN RESIDUE NUMBER 0 WAS FOUND.")
              return
            end if
          end if
        end if
    end do
    return
 999 ires = ires - 1
1000 continue
!
!  Check to see if there is a stray N attached to the end of the chain
!
    if (jatom > 0) then
      if (nat(jatom) == 7 .and. txtatm(jatom) == " ") then
        l = 0
        do i = 1, nbonds(jatom)
          k = ibonds(i,jatom)
          if ( .not. ioptl(k) .and. nat(k) > 1) l = l + 1
        end do
        if (l == 0) then
          write(txtatm(jatom),'(a,i5,a,i5)')  "ATOM  ", jatom, "  N   UNK ", ires + 1
        end if
      end if
    end if
    if (index(keywrd, " ADD-H") /= 0) return
    if (ires > 0) then
      first_res = .true.
      do i = irold, ires
        mres = mres + 1
       if (.not. first_res) then
!
! Work out phi
!
          if (bbone(3,i - 1)*bbone(1,i) /= 0 .and. bbone(2,i)*bbone(3,i) /= 0) then
            call dihed(coord, bbone(3,i - 1), bbone(1,i), bbone(2,i), bbone(3,i), angles(1,mres))
          else
            angles(1,mres) = 0.d0
          end if
        end if
        if (i /= ires) then
!
! Work out psi
!
          if (bbone(1,i)*bbone(2,i) /= 0 .and. bbone(3,i)*bbone(1,i + 1) /= 0) then
            call dihed(coord, bbone(1,i), bbone(2,i), bbone(3,i), bbone(1,i + 1), angles(2,mres))
          else
            angles(2,mres) = 0.d0
          end if
!
! Work out omega
!
          if (bbone(2,i)*bbone(3,i) /= 0 .and. bbone(2,i + 1)*bbone(1,i + 1) /= 0) then
            call dihed(coord, bbone(2,i), bbone(3,i), bbone(1,i + 1), bbone(2,i + 1), angles(3,mres))
          else
            angles(3,mres) = 0.d0
          end if
        end if
        do j = 1,3
          if (angles(j,mres) >  pi) angles(j,mres) = angles(j,mres) - 2.d0*pi
          if (angles(j,mres) < -pi) angles(j,mres) =0.d0
          angles(j,mres) = angles(j,mres)*180.d0/pi
        end do
        first_res = .false.
      end do
      do i = 1, ires
        do j = 1, 20
          if(allres(i)(:3) == afn(j)(:3)) exit
        end do
        if ( j > 20) allr(i) = "X"
      end do
    end if
!
!  LABEL THE HYDROGEN ATOMS
!
    nbreaks = 1  !  In this subroutine, "nbreaks" is local
    do j = 1, numat
      if (nat(j) == 1) then
        if (j /= breaks(nbreaks)) then
          if (ibonds(1, j) > 0) lused(j) = lused(ibonds(1, j))
        else
          nbreaks = nbreaks + 1
        end if
      end if
    end do
    if (numat /= natoms + id.and. .not. lreseq) then
      j = natoms - numat
!
!  MODIFY TXTATM TO ALLOW FOR DUMMY ATOMS
!
      l = numat
      do i = natoms - id, 1, -1
        if (labels(i) /= 99) then
          txtatm(i) = txtatm(l)
          lused(i) = lused(l)
          l = l - 1
        else
          write (txtatm(i), "(I6)") j
          j = j - 1
        end if
      end do
    end if
    nres = ires
    goto 1020
1010 nres = 1
    if (allres (ires) (:3) /= "   ") then
      if (index(keywrd, " RESIDUE") /= 0) &
        write (iw,'(10x,a,i4,a,a)') " AMINO ACID (residue:",ires,") = ", allres (ires) (:3)
    end if
!
!   LABEL EVERY NON-BACKBONE ATOM AS A SIDE-CHAIN ATOM
!
    do i = 1, natoms
      if (lused(i) /=-1) then
        lused(i) = 1
      end if
    end do
    do j = 1, numat
      if (nat(j) == 1) then
        lused(j) = lused(ibonds(1, j))
      end if
    end do
    if (numat == natoms) return
    j = natoms - numat
!
!  MODIFY TXTATM TO ALLOW FOR DUMMY ATOMS
!
    l = numat
    do i = natoms - id, 1, -1
      if (labels(i) /= 99) then
        txtatm(i) = txtatm(l)
        lused(i) = lused(l)
        l = l - 1
      else
        write (txtatm(i), "(I6)") j
        j = j - 1
      end if
    end do
1020 continue
     return
end subroutine names

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine values (type)
    use molkst_C, only: norbs, mpack
    use MOZYME_C, only : icocc_dim, cocc_dim, icvir_dim, cvir_dim, &
    isort, nncf, ncf, icocc, ncocc, iorbs, cocc, nnce, nce, icvir, ncvir, &
    cvir, noccupied, nvirtual
    use chanel_C, only: iw
    use common_arrays_C, only: f, eigs
    implicit none
    character (len=*), intent (in) :: type
    integer :: alloc_stat
    double precision, dimension(:), allocatable :: fdiat
    if (.not. Allocated (isort)) then
      allocate (isort(norbs), stat=alloc_stat)
      if (alloc_stat /= 0) then
        call memory_error ("values")
        go to 1100
      end if
    end if
    allocate (fdiat(norbs), stat=alloc_stat)
    if (alloc_stat /= 0) then
      call memory_error ("values")
      go to 1100
    end if
!
!
!
    if (type == "OCCUPIED") then
      call valuen (f, mpack, noccupied, nncf, ncf, norbs, icocc, icocc_dim, &
        ncocc, iorbs, cocc, cocc_dim, fdiat, eigs, isort)
!
!
!
    else if (type == "VIRTUAL") then
      !
      call valuen (f, mpack, nvirtual, nnce, nce, norbs, icvir, icvir_dim, ncvir, &
        iorbs, cvir, cvir_dim, fdiat, eigs(noccupied+1:), isort(noccupied+1:))
    else
      write (iw,*) " Error"
      call mopend ("Error")
    end if
    deallocate (fdiat)
1100 continue
end subroutine values
subroutine valuen (fao, nfao, nocc, nncf, ncf, nnn, icocc, nico, ncocc, iorbs, &
   cocc, nco, fdiat, eigf, isort)
    implicit none
    integer, intent (in) :: nco, nfao, nico, nnn, nocc
    integer, dimension (nico), intent (in) :: icocc
    integer, dimension (*), intent (in) :: ncf, ncocc, nncf
    integer, dimension (nocc), intent (out) :: isort
    integer, dimension (*), intent (in) :: iorbs
    double precision, dimension (nco), intent (in) :: cocc
    double precision, dimension (nfao), intent (in) :: fao
    double precision, dimension (nnn), intent (out) :: fdiat
    double precision, dimension (nocc), intent (inout) :: eigf
    integer :: i, i4, ii, j, j1, j4, jl, jx, k, k1, kl, l, loopi
    double precision :: sum, sum1
    integer, external :: ijbo
   !**********************************************************************
   !
   !   Calculates the energy levels of the LMOs, and sorts the LMOs into
   !   increasing energy order.
   !
   !**********************************************************************
    do i = 1, nocc
      loopi = ncocc(i)
      l = 0
      do j = nncf(i) + 1, nncf(i) + ncf(i)
        j1 = icocc(j)
        sum = 0.d0
        do k = l + 1, l + iorbs(j1)
          sum = sum + cocc(k+loopi) ** 2
        end do
        l = l + iorbs(j1)
      end do
      sum = 0.d0
      jl = loopi
      do j = nncf(i) + 1, nncf(i) + ncf(i)
        j1 = icocc(j)
        do jx = 1, iorbs(j1)
          jl = jl + 1
          kl = loopi
          do k = nncf(i) + 1, nncf(i) + ncf(i)
            k1 = icocc(k)
            if (ijbo(k1, j1) >= 0) then
                  !
                  !  Extract the atom-atom intersection of FAO
                  !
              if (k1 > j1) then
                     !
                     !   LOWER TRIANGLE
                     !
                ii = ijbo (k1, j1) + jx - iorbs(j1)
                do i4 = 1, iorbs(k1)
                  ii = ii + iorbs(j1)
                  fdiat(i4) = fao(ii)
                end do
              else if (k1 < j1) then
                     !
                     !   UPPER TRIANGLE
                     !
                ii = ijbo (k1, j1) + iorbs(k1) * (jx-1)
                do i4 = 1, iorbs(k1)
                  ii = ii + 1
                  fdiat(i4) = fao(ii)
                end do
              else
                     !
                     !   DIAGONAL TERM
                     !
                ii = ijbo (k1, j1) + (jx*(jx+1)) / 2
                do i4 = jx + 1, iorbs(k1)
                  ii = ii + jx
                  fdiat(i4) = fao(ii)
                  ii = ii + i4 - jx
                end do
                ii = ijbo (k1, j1) + (jx*(jx-1)) / 2
                do j4 = 1, jx
                  ii = ii + 1
                  fdiat(j4) = fao(ii)
                end do
              end if
              sum1 = 0.d0
              do i4 = 1, iorbs(k1)
                kl = kl + 1
                sum1 = sum1 + fdiat(i4) * cocc(kl)
              end do
              sum = sum + cocc(jl) * sum1
            end if
          end do
        end do
      end do
      eigf(i) = sum
    end do
   !
   !  Now sort eigenvalues.
   !
    do i = 1, nocc
      fdiat(i) = eigf(i)
    end do
    do i = 1, nocc
      k = 0
      sum = 1.d9
      do j = 1, nocc
        if (fdiat(j) < sum) then
          k = j
          sum = fdiat(j)
        end if
      end do
      fdiat(k) = 1.d10
      isort(i) = k
    end do
end subroutine valuen

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine hcore()
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE molkst_C, only : numcal, numat, norbs, id, l1u, l2u, l3u, &
      & keywrd, enuclr, n2elec, efield, mpack, line
      use common_arrays_C, only : nfirst, nlast, nat, uspd, &
      & coord, h, w, wk, tvec
      use cosmo_C, only : useps
      USE funcon_C, only : a0, ev, fpc_9
      USE parameters_C, only : tore, dd
      use MOZYME_C, only : cutofs
      use overlaps_C, only : cutof1, cutof2
      USE chanel_C, only : iw

!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: icalcn, ione
      integer :: i, j, k, kr, ia, ib, ni, i1, i2, j1, io1, jo1, im1, &
        ja, jb, nj, ii, jj, kro, q_at, link_at, mol_at
      double precision, dimension(45) :: e1b(45), e2a(45), di(9,9), wjd(2025), wkd(2025), xj(3), dibits(9,9)
      double precision, allocatable:: vqc(:)
      double precision ::  xf, yf, zf, const, fldcon, hterme, fnuc, half, enuc
      logical :: fldon, first, debug, lmolaris_qmmm, exists
      character :: tmpkey*241
      double precision, external :: reada
      save first, debug, icalcn, ione, vqc, lmolaris_qmmm
!***********************************************************************
!
!   HCORE GENERATES THE ONE-ELECTRON MATRIX AND TWO ELECTRON INTEGRALS
!         FOR A GIVEN MOLECULE WHOSE GEOMETRY IS DEFINED IN CARTESIAN
!         COORDINATES.
!
!  ON INPUT  COORD   = COORDINATES OF THE MOLECULE.
!
!  ON OUTPUT  H      = ONE-ELECTRON MATRIX.
!             W      = TWO-ELECTRON INTEGRALS.
!             ENUCLR = NUCLEAR ENERGY
!***********************************************************************
      data icalcn/ 0/
      fnuc = 0.d0
      fldcon = 0.d0
      first = icalcn /= numcal
      icalcn = numcal
      if (first) then
        ione = 1
        cutofs = 1.d4
        cutof2 = 1.D10
        cutof1 = 225.d0 ! (Cutoff distance)**2 for overlap integrals
        if (id /= 0) then
          if (allocated(wk)) deallocate (wk)
          allocate(wk(n2elec))
        end if
        if (id /= 0) ione = 0
        debug = (index(keywrd,'HCORE') /= 0)
        lmolaris_qmmm = (index(keywrd,'QMMM') /= 0)
        if (lmolaris_qmmm) then
!
!  Read in the energy in kcal/mol that an electron on each atom would have, arising from
!  the partial charges on all atoms.
!
          line="mol.in"
          call add_path(line)
          inquire (file=trim(line), exist = exists)
          if (.not. exists) then
             call mopend("A file named '"//trim(line)//"' was expected, but was not found.")
             return
          end if
          open(85, file=line, status='unknown', form='formatted')
          read(85, *, iostat = i)
          if (i /= 0) then
             call mopend("A file named '"//trim(line)//"' exists, but is empty.")
             return
          end if
          read(85, *, iostat = i)q_at, link_at
          if (i /= 0) then
             call mopend("A file named '"//trim(line)//"' exists, but is corrupt.")
             return
          end if
          mol_at = q_at + link_at
          if(mol_at /= numat) then
            write(line,'(a,i5,a,i5,a)') &
              " The number of atoms in 'mol.in':",mol_at," and in the MOPAC data set:",numat," are different."
            call mopend(trim(line))
            write(iw,'(10x,a)')" Correct fault and resubmit."
            return
          end if
          if (allocated(vqc)) deallocate(vqc)
          allocate(vqc(numat))
          do i = 1, numat
            read(85,*)line,line,line,line,vqc(i)
            if (debug) write(iw,'(a, i4, a, f9.3)')"ATOM No.",i," VQC(I)",vqc(i)
          end do
          close(85)
        end if
        xf = 0.D0
        yf = 0.D0
        zf = 0.D0
        tmpkey = trim(keywrd)
        i = index(tmpkey,' FIELD(') + index(tmpkey,' FIELD=(')
        if (i /= 0) then
!
!   ERASE ALL TEXT FROM TMPKEY EXCEPT FIELD DATA
!
          tmpkey(:i) = ' '
          tmpkey(index(tmpkey,')'):) = ' '
!
!   READ IN THE EFFECTIVE FIELD IN X,Y,Z COORDINATES
!
          xf = reada(tmpkey,i)
          i = index(tmpkey,',')
          if (i /= 0) then
            tmpkey(i:i) = ' '
            yf = reada(tmpkey,i)
            i = index(tmpkey,',')
            if (i /= 0) then
              tmpkey(i:i) = ' '
              zf = reada(tmpkey,i)
            end if
          end if
          write (iw, '(/10X,''THE ELECTRIC FIELD IS'',3F10.5,'' VOLTS/ANGSTROM'',/)') xf, yf, zf
        end if
        const = a0/ev
!
        efield(1) = xf*const
        efield(2) = yf*const
        efield(3) = zf*const
      end if
      fldon = .FALSE.
      if (efield(1) /= 0.0D00 .or. efield(2) /= 0.0D00 .or. efield(3) /= 0.0D00) then
!
!   FLDCON = h/Ao
!
        fldcon = ev/a0
        fldon = .TRUE.
      end if
      enuclr = 0.d0
      h(:mpack) = 0.d0
      kr = 1
      do i = 1, numat
        ia = nfirst(i)
        ib = nlast(i)
        ni = nat(i)
!
! FIRST WE FILL THE DIAGONALS, AND OFF-DIAGONALS ON THE SAME ATOM
!
        if (.not.fldon) then
          do i1 = ia, ib
            i2 = i1*(i1 - 1)/2 + ia - 1
            if (i1 - ia + 1 > 0) then
              h(i2+1:i1-ia+1+i2) = 0.D0
              i2 = i1 - ia + 1 + i2
            end if
            h(i2) = uspd(i1)
            if(lmolaris_qmmm) then
              if (debug) write(iw,'(''OLD 1e MATRIX ELEMENT '',i5,f12.5,'' i'',i5,&
            & '' vqc(i)'',f12.5)')i2,h(i2),i,-vqc(i)/fpc_9
              h(i2) = h(i2) - vqc(i)/fpc_9
              if (debug) write(iw,'(''UPD 1e MATRIX ELEMENT '',i5,f12.5)')i2,h(i2)
            end if
            cycle
          end do
        else
          do i1 = ia, ib
            i2 = i1*(i1 - 1)/2 + ia - 1
            do j1 = ia, i1
              i2 = i2 + 1
              h(i2) = 0.D0
              io1 = i1 - ia
              jo1 = j1 - ia
              if (jo1==0 .and. io1==1) then
                hterme = -a0*dd(ni)*efield(1)*fldcon
                h(i2) = hterme
              end if
              if (jo1==0 .and. io1==2) then
                hterme = -a0*dd(ni)*efield(2)*fldcon
                h(i2) = hterme
              end if
              if (jo1/=0 .or. io1/=3) cycle
              hterme = -a0*dd(ni)*efield(3)*fldcon
              h(i2) = hterme
            end do
            h(i2) = uspd(i1)
            fnuc = -(efield(1)*coord(1,i) + efield(2)*coord(2,i) + efield(3)*coord(3,i))*fldcon
            h(i2) = h(i2) + fnuc
          end do
        end if
        if (fldon) enuclr = enuclr - fnuc*tore(nat(i))
        if (lmolaris_qmmm) enuclr = enuclr + vqc(i)/fpc_9*tore(nat(i))
!
!   FILL THE ATOM-OTHER ATOM ONE-ELECTRON MATRIX<PSI(LAMBDA)|PSI(SIGMA)>
!
        im1 = i - ione
        do j = 1, im1
          half = 1.D0
          if (i == j) half = 0.5D0
          ja = nfirst(j)
          jb = nlast(j)
          nj = nat(j)
          if (id == 0) then
            call h1elec (ni, nj, coord(1,i), coord(1,j), di)
          else
            di = 0.D0
            do ii = -l1u, l1u
              do jj = -l2u, l2u
                do k = -l3u, l3u
                  xj = coord(:,j) + tvec(:,1)*ii + tvec(:,2)*jj + tvec(:,3)*k
                  call h1elec (ni, nj, coord(1,i), xj, dibits)
                  di = di + dibits
                end do
              end do
            end do
          end if
          i2 = 0
          do i1 = ia, ib
            ii = i1*(i1 - 1)/2 + ja - 1
            i2 = i2 + 1
            jj = min(i1,jb)
            h(ii+1:jj-ja+1+ii) = h(ii+1:jj-ja+1+ii) + di(i2,:jj-ja+1)
          end do
!
!   CALCULATE THE TWO-ELECTRON INTEGRALS, W; THE ELECTRON NUCLEAR TERMS
!   E1B AND E2A; AND THE NUCLEAR-NUCLEAR TERM ENUC.
!
          if (id == 0) then
            call rotate (ni, nj, coord(1,i), coord(1,j), w(kr), kr, e1b, e2a, enuc)
          else
            kro = kr
            call solrot (ni, nj, coord(1,i), coord(1,j), wjd, wkd, kr, e1b, e2a, enuc)
            jj = 0
            w(kro:kr - 1) = wjd(:kr-kro)
            wk(kro:kr - 1) = wkd(:kr-kro)
          end if
          enuclr = enuclr + enuc
!
!   ADD ON THE ELECTRON-NUCLEAR ATTRACTION TERM FOR ATOM I.
!
          i2 = 0
          do i1 = ia, ib
            ii = i1*(i1 - 1)/2 + ia - 1
            if (i1 - ia + 1 > 0) then
              h(ii+1:i1-ia+1+ii) = h(ii+1:i1-ia+1+ii) + e1b(i2+1:i1-ia+1+i2)*half
              i2 = i1 - ia + 1 + i2
            end if
          end do
!
!   ADD ON THE ELECTRON-NUCLEAR ATTRACTION TERM FOR ATOM J.
!
          i2 = 0
          do i1 = ja, jb
            ii = i1*(i1 - 1)/2 + ja - 1
            if (i1 - ja + 1 > 0) then
              h(ii+1:i1-ja+1+ii) = h(ii+1:i1-ja+1+ii) + e2a(i2+1:i1-ja+1+i2)*half
              i2 = i1 - ja + 1 + i2
            end if
          end do
        end do
        ii = ib - ia + 1
        ii = (ii*(ii+1)) / 2
        if (id /= 0) then
          do i1 = kr, kr + ii * ii - 1
            wk(i1) = 0.d0
          end do
        end if
        if (ii /= 0) then
          call wstore (w(kr), kr, ni, ii)
        end if
      end do
      if (useps) then
! In the following routine the dielectric correction to the core-core-
! interaction is added to ENUCLR
        call addnuc ()
! The following routine adds the dielectric correction for the electron-
! interaction to the diagonal elements of H
        call addhcr ()
      end if
! end of COSMO change
      if (debug) then
        write (iw, '(2/10X,''ONE-ELECTRON MATRIX FROM HCORE'')')
        call vecprt (h, norbs)
        j = min(400,kr - 1)
        j = kr - 1
        if (id == 0) then
          write (iw, '(2/10X,''TWO-ELECTRON MATRIX IN HCORE''/)')
          write (iw, 200) (w(i),i=1,j)
        else
          write (iw, '(2/10X,''TWO-ELECTRON J MATRIX IN HCORE''/)')
          write (iw, 200) (w(i),i=1,j)
          write (iw, '(2/10X,''TWO-ELECTRON K MATRIX IN HCORE''/)')
          write (iw, 200) (wk(i),i=1,j)
        end if
  200   format(10f8.4)
      end if
      return
      end subroutine hcore

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      module reimers_C
! Full module added by RMG
      integer :: n, na, nb2, nham, ix, iy, &
                 nlocl, nstrt, ndump, ion, nstop, &
                 nshell, nconf, multci, n2phot, nese, &
                 nciout, nciouv, nwch, ntrmet, nirreg, nte, &
                 nrep, ifroti = 0, nptg, nr, ndtype, &
                 ncore, nol, noh, nvl, nvh, nov, neltot, nunp, &
                 mfg(24), isok(80), nprin(80), nbfa(80), ndconf, &
                 ixprd(8,8), ig1(74,8), ig2(74,8), ig3(74,8), &
                 ig4(74,8), matind(50000), ifgfac(11), &
                 kflag(3), jflag(3), mb, ic, id, lenf, nfrag, &
                 ncoupb1, ncoupv1, ncoupb2, ncoupv2, &
                 ncisym, icisym(8), nmp2, nmp2t, &
                 ifst, afst, nrange(8), ifbinc(0:8), &
                 ndiff, io(2), iv(2), irrtyp, ns(8), nslwr(8), &
                 nsupr(8), nfact(0:10), nci(8), &
                 norb(4), norbl(4), norbh(4), nex, mspn, moass, &
                 kass(8,4), nold, nvhd, nolc, nvhc

      character*2   ::  iatsym(80)
      character*3   ::  kind(9)
      character*80  ::  line
      double precision  ::  alpha(9,9)
      character*3   ::  nmptg(8), nmrep(8,8), cisym(8)
      character*80  ::  ident
      character*8   ::  ldcomp(3)
      character*40  ::  filenm
      character*8, allocatable :: lab(:)
      logical*1     ::  fastci, ixeof, sing, dbls, mrci

      double precision :: emaxci, vnn, dipsym, value, &
                 zeta(80), zetad(2,80), zetawt(2,80), &
                 weight(80), zcorea(80), betaa(3,80), fg(24,80), &
                 f0(2,2) = 0.d0, tomk,g(74,8), &
                 fssig, fpsig, fppi, fdsig, fdpi, fddel, fall, pp, &
                 bincoe(465), fact(30), a(35), b(35), d(8), e(8), &
                 fspdf(4,4), ss(4), fintfa(6), &
                 avec1(0:4), bvec1(0:4), avec2(0:4), bvec2(0:4), &
                 dia(0:4), tot, edef = 0.d0, ecore, rr, &
                 dq(3), dda(3), dtot(3), pol(6), nel(4), ef(3) = 0.d0


      integer, allocatable :: natm(:), nbf(:), ibf(:), iat(:), &
                 nbt(:), nprn(:), itrmet(:), natt(:), nstr(:), &
                 istr(:,:), nsym(:), ivv(:), npsn(:), mofrag(:), &
                 nfocc(:), nfvir(:), icifrag(:), imp2d(:), imp2s(:), &
                 isc(:), krefd(:), vv(:), iwk(:,:), &
                 istate(:), nseig(:), icif(:), jcif(:), ncif(:), &
                 nbtmo(:), iconf(:), nspn(:)

      double precision, allocatable :: vca(:,:), vcb(:,:), occfr(:), &
                 x(:), y(:), z(:), zcore(:), gamma(:,:), beta(:), &
                 betao(:), s(:), r(:,:), ppg(:,:), pg(:,:), dd(:,:), &
                 ff(:,:), aa(:), cc0(:,:), dm(:,:), xz(:,:), ci(:,:), &
                 evalmo(:), evalci(:), spintr(:,:), cimatr(:), &
                 dmci(:,:), stwt(:), e0(:), wk1(:), wk2(:), tr1(:), &
                 wk0(:,:), wk3(:), occ(:), qgs(:), dipgs(:,:), &
                 qbfcore(:,:), qbf(:,:), qcore(:), q0(:), dip(:,:), &
                 dtmp(:,:)

      double precision, allocatable :: eec(:), ee2(:)

      logical*1, allocatable :: aocc(:,:,:), bocc(:,:,:), aor1(:), &
                 bor1(:), aor(:), bor(:), aos(:), bos(:), aod(:), &
                 bod(:), ao1(:,:), bo1(:,:)

      integer :: ind(0:8), nintg, nbeta

      integer       ::  mis2, mis1, mip2, mip1, mid2, mid1, mid0, &
     &                  mic2, mic1, mic0, &
     &                  mf0ss, mf0sd, mf0dd, mg1sp, mf2pp, &
     &                  mg2sd, mg1pd, mf2pd, mg3pd, mf2dd, mf4dd, &
     &                  mr1sppd, mr2sddd, mr2sdpp

      double precision :: au2ev,au2ang,au2cm,debye

      data au2ev,au2ang,au2cm,debye / &
       27.2114D0, 0.529177D0, 219475.3D0, 4.80294D0 /
      data nmptg /' C1',' CS',' C2','C2V','D2H',' CI','C2H',' D2'/
      data nmrep / 8*'   ',              ' A''',' A"',6*'   ',&
     &             '  A','  B',6*' ',    ' A1',' A2',' B1',' B2',4*' ',&
     &             ' Ag',' Au','B1g','B1u','B2g','B2u','B3g','B3u',&
     &             '  g','  u',6*' ',    ' Ag',' Au',' Bg',' Bu',4*' ',&
     &             '  A',' B1',' B2',    ' B3',4*' ' /
      data ixprd /1,2,3,4,5,6,7,8,2,1,4,3,6,5,8,7,3,4,1,2,7,8,5,6,4,3,2,&
     &1,8,7,6,5,5,6,7,8,1,2,3,4,6,5,8,7,2,1,4,3,7,8,5,6,3,4,1,2,8,7,6,5,&
     &4,3,2,1/
      data (iatsym(i),i=1,80) &
     &            /" H", "He", "Li", "Be", " B", " C", " N", " O", " F", "Ne", &
     & "Na", "Mg", "Al", "Si", "P ", "S ", "Cl", "Ar", "K ", "Ca", "Sc", "Ti", &
     & " V", "Cr", "Mn", "Fe", "Co", "Ni", "Cu", "Zn", "Ga", "Ge", "As", "Se", "Br", &
     & "Kr", "Rb", "Sr", "Y ", "Zr", "Nb", "Mo", "Tc", "Ru", "Rh", "Pd", "Ag", &
     & "Cd", "In", "Sn", "Sb", "Te", " I", "Xe", "Cs", "Ba", "La", "Ce", "Pr", &
     & "Nd", "Pm", "Sm", "Eu", "Gd", "Tb", "Dy", "Ho", "Er", "Tm", "Yb", "Lu", &
     & "Hf", "Ta", "W ", "Re", "Os", "Ir", "Pt", "Au", "Hg" /
      data kind    /' S ', ' Px',' Py',' Pz', 'Dz2','xy2','Dxy',&
     &              'Dxz','Dyz'/

      data mfg / 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,&
     &           21,22,23,24/
      data ind  /1,1,1,1,2,2,2,2,2/
      data tomk / 1.2D0 /
      data ifgfac / 3,25,5,15,35,245,49,441,1,1,1 /
      data fintfa / 1.D0,1.267D0,0.585D0,3*1.D0/
      data              ic,id/1,2/
      data ldcomp       /'X Dipole','Y Dipole','Z Dipole'/

      equivalence (mfg(1),mis2), (mfg(2),mis1), (mfg(3),mip2), &
     & (mfg(4),mip1),     (mfg(5),mid2),     (mfg(6),mid1), &
     & (mfg(7),mid0),     (mfg(8),mic2),     (mfg(9),mic1), &
     & (mfg(10),mic0),    (mfg(11),mf0ss),   (mfg(12),mf0sd), &
     & (mfg(13),mf0dd),   (mfg(14),mg1sp),   (mfg(15),mf2pp), &
     & (mfg(16),mg2sd),   (mfg(17),mg1pd),   (mfg(18),mf2pd), &
     & (mfg(19),mg3pd),   (mfg(20),mf2dd),   (mfg(21),mf4dd), &
     & (mfg(22),mr1sppd), (mfg(23),mr2sddd), (mfg(24),mr2sdpp)

      equivalence (fintfa(1),fssig),(fintfa(2),fpsig), &
     &            (fintfa(3),fppi), (fintfa(4),fdsig), &
     &            (fintfa(5),fdpi), (fintfa(6),fddel)

      end module reimers_C

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

! C-bound types for diskless/stateless Application Programming Interface (API) to core MOPAC operations
module mopac_api_c
  use, intrinsic :: iso_c_binding
  implicit none

  ! data that defines the atomistic system and MOPAC job options
  type, bind(c) :: mopac_system
    ! number of atoms
    integer(c_int) :: natom
    ! number of atoms that are allowed to move (first natom_move atoms in array)
    integer(c_int) :: natom_move
    ! net charge
    integer(c_int) :: charge
    ! number of spin excitations, floor[(number of alpha electrons)/2 - (number of beta electrons)/2]
    integer(c_int) :: spin
    ! semiempirical model: PM7 = 0, PM6-D3H4 = 1, PM6-ORG = 2, PM6 = 3, AM1 = 4, RM1 = 5
    integer(c_int) :: model
    ! dielectric constant for COSMO implicit solvent, must be 1 (no solvent) for nlattice > 0
    real(c_double) :: epsilon
    ! atomic number of each atom
    type(c_ptr) :: atom ! integer(c_int)[natom]
    ! (x,y,z) coordinates of each atom (Angstroms)
    type(c_ptr) :: coord ! real(c_double)[3*natom]
    ! number of lattice vectors / translation vectors / periodic dimensions
    integer(c_int) :: nlattice
    ! number of lattice vectors that are allowed to move (first nlattice_move vectors in array)
    integer(c_int) :: nlattice_move
    ! external hydrostatic pressure (Gigapascals)
    real(c_double) :: pressure
    ! (x,y,z) coordinates of each lattice vectors (Angstroms)
    type(c_ptr) :: lattice ! real(c_double)[3*nlattice]
    ! relative numerical tolerances (equivalent to GNORM and RELSCF keyword values)
    real(c_double) :: tolerance
    ! time limit for a MOPAC calculation (seconds)
    integer(c_int) :: max_time
  end type

  ! calculated ground-state properties of an atomistic system and MOPAC job info
  type, bind(c) :: mopac_properties
    ! heat of formation (kcal/mol)
    real(c_double) :: heat
    ! dipole moment vector (Debye)
    real(c_double), dimension (3) :: dipole
    ! atomic partial charges
    type(c_ptr) :: charge ! real(c_double)[natom]
    ! (x,y,z) coordinates of each moveable atom (Angstroms)
    type(c_ptr) :: coord_update ! real(c_double)[3*natom_move]
    ! (x,y,z) heat gradients for each moveable atom (kcal/mol/Angstrom)
    type(c_ptr) :: coord_deriv ! real(c_double)[3*natom_move]
    ! vibrational frequencies of normal modes (1/cm)
    type(c_ptr) :: freq ! real(c_double)[3*natom_move], NULL if unavailable
    ! (x,y,z) displacement vectors of normal modes
    type(c_ptr) :: disp ! real(c_double)[3*natom_move,3*natom_move], NULL if unavailable
    ! bond-order matrix in compressed sparse column (CSC) matrix format (0-based indexing)
    ! with insignificant bond orders (<0.01) truncated
    ! diagonal matrix entries are atomic valencies
    ! > first index of each atom in CSC bond-order matrix
    type(c_ptr) :: bond_index ! integer(c_int)[natom+1]
    ! > list of atoms bonded to each atom in CSC format
    type(c_ptr) :: bond_atom ! integer(c_int)[bond_index(natom+1)]
    ! > bond order of atoms bonded to each atom in CSC format
    type(c_ptr) :: bond_order ! real(c_double)[bond_index(natom+1)]
    ! (x,y,z) coordinates of each moveable lattice vectors (Angstroms)
    type(c_ptr) :: lattice_update ! real(c_double)[3*nlattice_move]
    ! (x,y,z) heat gradients for each moveable lattice vector (kcal/mol/Angstrom)
    type(c_ptr) :: lattice_deriv ! real(c_double)[3*nlattice_move]
    ! stress tensor (Gigapascals) in Voigt form (xx, yy, zz, yz, xz, xy)
    real(c_double), dimension (6) :: stress ! 0 if unavailable
    ! number of MOPAC error messages (negative value indicates that allocation of error_msg failed)
    integer(c_int) :: nerror
    ! text of MOPAC error messages
    type(c_ptr) :: error_msg ! type(c_ptr)[nerror] -> character(kind=c_char)[*]
  end type

  ! data that describes the electronic state using standard molecular orbitals
  type, bind(c) :: mopac_state
    ! MOPAC data format is adapted from molkst_C and Common_arrays_C modules
    ! > number of matrix elements in packed lower triangle matrix format
    integer(c_int) :: mpack ! 0 if state is unavailable
    ! > flag for unrestricted Hartree-Fock ground state (0 == restricted, 1 == unrestricted)
    integer(c_int) :: uhf
    ! > alpha density matrix
    type(c_ptr) :: pa ! real(c_double)[mpack]
    ! > beta density matrix
    type(c_ptr) :: pb ! real(c_double)[mpack], NULL if uhf == 0
  end type

  ! data that describes the electronic state using localized molecular orbitals
  type, bind(c) :: mozyme_state
    ! MOZYME data format is adapted from molkst_C, Common_arrays_C, and MOZYME_C modules
    ! > number of real atoms
    integer(c_int) :: numat ! 0 if state is unavailable
    ! > number of Lewis bonds per real atom
    type(c_ptr) :: nbonds ! integer(c_int)[numat]
    ! > list of Lewis-bonded real atoms for each real atom
    type(c_ptr) :: ibonds ! integer(c_int)[9,numat]
    ! > number of orbitals per real atom
    type(c_ptr) :: iorbs ! integer(c_int)[numat]
    ! > number of occupied molecular orbitals
    integer(c_int) :: noccupied
    ! > number of atoms in each occupied LMO
    type(c_ptr) :: ncf ! integer(c_int)[noccupied]
    ! > number of virtual molecular orbitals
    integer(c_int) :: nvirtual
    ! > number of atoms in each virtual LMO
    type(c_ptr) :: nce ! integer(c_int)[nvirtual]
    ! > size of array icocc
    integer(c_int) :: icocc_dim
    ! > index of each real atom in the occupied LMOs
    type(c_ptr) :: icocc ! integer(c_int)[iccoc_dim]
    ! > size of array icvir
    integer(c_int) :: icvir_dim
    ! > index of each real atom in the virtual LMOs
    type(c_ptr) :: icvir ! integer(c_int)[icvir_dim]
    ! > size of array cocc
    integer(c_int) :: cocc_dim
    ! > atomic orbital coefficients of the occupied LMOs
    type(c_ptr) :: cocc ! real(c_double)[cocc_dim]
    ! > size of array cvir
    integer(c_int) :: cvir_dim
    ! > atomic orbital coefficients of the virtual LMOs
    type(c_ptr) :: cvir ! real(c_double)[cvir_dim]
  end type

end module mopac_api_c

! Implementation of Fortran API wrapper
submodule (mopac_api_f) mopac_api_f_internal
  use, intrinsic :: iso_c_binding
  use mopac_api_c
  implicit none

  ! C-bound library subroutines
  interface

    ! MOPAC electronic ground state calculation
    subroutine mopac_scf(system, state, properties) bind(c)
      use mopac_api_c
      type(mopac_system), intent(in) :: system
      type(mopac_state), intent(inout) :: state
      type(mopac_properties), intent(out) :: properties
    end subroutine mopac_scf

    ! MOPAC geometry relaxation
    subroutine mopac_relax(system, state, properties) bind(c)
      use mopac_api_c
      type(mopac_system), intent(in) :: system
      type(mopac_state), intent(inout) :: state
      type(mopac_properties), intent(out) :: properties
    end subroutine mopac_relax

    ! MOPAC vibrational calculation
    subroutine mopac_vibe(system, state, properties) bind(c)
      use mopac_api_c
      type(mopac_system), intent(in) :: system
      type(mopac_state), intent(inout) :: state
      type(mopac_properties), intent(out) :: properties
    end subroutine mopac_vibe

    ! MOZYME electronic ground state calculation
    subroutine mozyme_scf(system, state, properties) bind(c)
      use mopac_api_c
      type(mopac_system), intent(in) :: system
      type(mozyme_state), intent(inout) :: state
      type(mopac_properties), intent(out) :: properties
    end subroutine mozyme_scf

    ! MOZYME geometry relaxation
    subroutine mozyme_relax(system, state, properties) bind(c)
      use mopac_api_c
      type(mopac_system), intent(in) :: system
      type(mozyme_state), intent(inout) :: state
      type(mopac_properties), intent(out) :: properties
    end subroutine mozyme_relax

    ! MOZYME vibrational calculation
    subroutine mozyme_vibe(system, state, properties) bind(c)
      use mopac_api_c
      type(mopac_system), intent(in) :: system
      type(mozyme_state), intent(inout) :: state
      type(mopac_properties), intent(out) :: properties
    end subroutine mozyme_vibe

    ! allocate memory for mopac_state
    subroutine create_mopac_state(state) bind(c)
      use mopac_api_c
      type(mopac_state), intent(inout) :: state
    end subroutine create_mopac_state

    ! allocate memory for mozyme_state
    subroutine create_mozyme_state(state) bind(c)
      use mopac_api_c
      type(mozyme_state), intent(inout) :: state
    end subroutine create_mozyme_state

    ! deallocate memory in mopac_properties (associated system is needed for size info)
    subroutine destroy_mopac_properties(properties) bind(c)
      use mopac_api_c
      type(mopac_properties), intent(in) :: properties
    end subroutine destroy_mopac_properties

    ! deallocate memory in mopac_state
    subroutine destroy_mopac_state(state) bind(c)
      use mopac_api_c
      type(mopac_state), intent(in) :: state
    end subroutine destroy_mopac_state

    ! deallocate memory in mozyme_state
    subroutine destroy_mozyme_state(state) bind(c)
      use mopac_api_c
      type(mozyme_state), intent(in) :: state
    end subroutine destroy_mozyme_state

    ! run MOPAC conventionally from an input file
    function run_mopac_from_input(path_to_file) bind(c)
      use iso_c_binding
      integer(c_int) :: run_mopac_from_input
      character(kind=c_char), dimension(*), intent(in) :: path_to_file
    end function run_mopac_from_input

    ! get MOPAC version string
    subroutine get_mopac_version(version) bind(c)
      use iso_c_binding
      character(kind=c_char), dimension(*), intent(out) :: version
    end subroutine get_mopac_version

  end interface

contains

  module subroutine mopac_scf_f(system, state, properties)
    type(mopac_system_f), intent(in) :: system
    type(mopac_state_f), intent(inout) :: state
    type(mopac_properties_f), intent(out) :: properties
    type(mopac_system) :: system_c
    type(mopac_state) :: state_c
    type(mopac_properties) :: properties_c
    integer(c_int), pointer :: iwork(:)
    real(c_double), pointer :: rwork(:)
    call mopac_system_f2c(system, system_c, iwork, rwork)
    call mopac_state_f2c(state, state_c)
    call mopac_scf(system_c, state_c, properties_c)
    call mopac_state_c2f(state_c, state)
    call mopac_properties_c2f(system_c, properties_c, properties)
    deallocate(iwork)
    deallocate(rwork)
  end subroutine mopac_scf_f

  module subroutine mopac_relax_f(system, state, properties)
    type(mopac_system_f), intent(in) :: system
    type(mopac_state_f), intent(inout) :: state
    type(mopac_properties_f), intent(out) :: properties
    type(mopac_system) :: system_c
    type(mopac_state) :: state_c
    type(mopac_properties) :: properties_c
    integer(c_int), pointer :: iwork(:)
    real(c_double), pointer :: rwork(:)
    call mopac_system_f2c(system, system_c, iwork, rwork)
    call mopac_state_f2c(state, state_c)
    call mopac_relax(system_c, state_c, properties_c)
    call mopac_state_c2f(state_c, state)
    call mopac_properties_c2f(system_c, properties_c, properties)
    deallocate(iwork)
    deallocate(rwork)
  end subroutine mopac_relax_f

  module subroutine mopac_vibe_f(system, state, properties)
    type(mopac_system_f), intent(in) :: system
    type(mopac_state_f), intent(inout) :: state
    type(mopac_properties_f), intent(out) :: properties
    type(mopac_system) :: system_c
    type(mopac_state) :: state_c
    type(mopac_properties) :: properties_c
    integer(c_int), pointer :: iwork(:)
    real(c_double), pointer :: rwork(:)
    call mopac_system_f2c(system, system_c, iwork, rwork)
    call mopac_state_f2c(state, state_c)
    call mopac_vibe(system_c, state_c, properties_c)
    call mopac_state_c2f(state_c, state)
    call mopac_properties_c2f(system_c, properties_c, properties)
    deallocate(iwork)
    deallocate(rwork)
  end subroutine mopac_vibe_f

  module subroutine mozyme_scf_f(system, state, properties)
    type(mopac_system_f), intent(in) :: system
    type(mozyme_state_f), intent(inout) :: state
    type(mopac_properties_f), intent(out) :: properties
    type(mopac_system) :: system_c
    type(mozyme_state) :: state_c
    type(mopac_properties) :: properties_c
    integer(c_int), pointer :: iwork(:)
    real(c_double), pointer :: rwork(:)
    call mopac_system_f2c(system, system_c, iwork, rwork)
    call mozyme_state_f2c(state, state_c)
    call mozyme_scf(system_c, state_c, properties_c)
    call mozyme_state_c2f(state_c, state)
    call mopac_properties_c2f(system_c, properties_c, properties)
    deallocate(iwork)
    deallocate(rwork)
  end subroutine mozyme_scf_f

  module subroutine mozyme_relax_f(system, state, properties)
    type(mopac_system_f), intent(in) :: system
    type(mozyme_state_f), intent(inout) :: state
    type(mopac_properties_f), intent(out) :: properties
    type(mopac_system) :: system_c
    type(mozyme_state) :: state_c
    type(mopac_properties) :: properties_c
    integer(c_int), pointer :: iwork(:)
    real(c_double), pointer :: rwork(:)
    call mopac_system_f2c(system, system_c, iwork, rwork)
    call mozyme_state_f2c(state, state_c)
    call mozyme_relax(system_c, state_c, properties_c)
    call mozyme_state_c2f(state_c, state)
    call mopac_properties_c2f(system_c, properties_c, properties)
    deallocate(iwork)
    deallocate(rwork)
  end subroutine mozyme_relax_f

  module subroutine mozyme_vibe_f(system, state, properties)
    type(mopac_system_f), intent(in) :: system
    type(mozyme_state_f), intent(inout) :: state
    type(mopac_properties_f), intent(out) :: properties
    type(mopac_system) :: system_c
    type(mozyme_state) :: state_c
    type(mopac_properties) :: properties_c
    integer(c_int), pointer :: iwork(:)
    real(c_double), pointer :: rwork(:)
    call mopac_system_f2c(system, system_c, iwork, rwork)
    call mozyme_state_f2c(state, state_c)
    call mozyme_vibe(system_c, state_c, properties_c)
    call mozyme_state_c2f(state_c, state)
    call mopac_properties_c2f(system_c, properties_c, properties)
    deallocate(iwork)
    deallocate(rwork)
  end subroutine mozyme_vibe_f

  module function run_mopac_from_input_f(path_to_file)
    logical :: run_mopac_from_input_f
    character(len=240), intent(in) :: path_to_file
    character(kind=c_char), allocatable :: path_to_file_c(:)
    integer :: i, size, status
    size = len_trim(path_to_file)
    allocate(path_to_file_c(size+1), stat=status)
    if (status /= 0) then
      write(*,*) "ERROR: Failed to allocate memory in MOPAC API wrapper"
      stop 1
    end if
    do i=1, size
      path_to_file_c(i) = path_to_file(i:i)
    end do
    path_to_file_c(size+1) = c_null_char
    status = run_mopac_from_input(path_to_file_c)
    if (status == 0) then
      run_mopac_from_input_f = .true.
    else
      run_mopac_from_input_f = .false.
    end if
  end function run_mopac_from_input_f

  module subroutine get_mopac_version_f(version)
    character(len=20), intent(out) :: version
    character(kind=c_char) :: version_c(21)
    integer :: i
    i = 1
    call get_mopac_version(version_c)
    do
      if(version_c(i) == c_null_char) exit
      version(i:i) = version_c(i)
      i = i + 1
    end do
    version(i:) = ' '
  end subroutine get_mopac_version_f

  subroutine mopac_system_f2c(system_f, system_c, iwork, rwork)
    type(mopac_system_f), intent(in) :: system_f
    type(mopac_system), intent(out) :: system_c
    integer(c_int), pointer :: iwork(:)
    real(c_double), pointer :: rwork(:)
    integer :: status
    system_c%natom = system_f%natom
    system_c%natom_move = system_f%natom_move
    system_c%charge = system_f%charge
    system_c%spin = system_f%spin
    system_c%model = system_f%model
    system_c%epsilon = system_f%epsilon
    system_c%nlattice = system_f%nlattice
    system_c%nlattice_move = system_f%nlattice_move
    system_c%pressure = system_f%pressure
    system_c%tolerance = system_f%tolerance
    system_c%max_time = system_f%max_time
    system_c%coord = c_null_ptr
    system_c%lattice = c_null_ptr
    allocate(iwork(system_f%natom), stat=status)
    if (status /= 0) then
      write(*,*) "ERROR: Failed to allocate memory in MOPAC API wrapper"
      stop 1
    end if
    iwork = system_f%atom
    system_c%atom = c_loc(iwork)
    allocate(rwork(3*system_f%natom+3*system_f%nlattice), stat=status)
    if (status /= 0) then
      write(*,*) "ERROR: Failed to allocate memory in MOPAC API wrapper"
      stop 1
    end if
    if (system_f%natom > 0) then
      rwork(:3*system_f%natom) = system_f%coord
      system_c%coord = c_loc(rwork)
      if (system_f%nlattice > 0) then
        rwork(3*system_f%natom+1:) = system_f%lattice
        system_c%lattice = c_loc(rwork(3*system_f%natom+1))
      end if
    end if
  end subroutine mopac_system_f2c

  subroutine mopac_properties_c2f(system_c, properties_c, properties_f)
    type(mopac_system), intent(in) :: system_c
    type(mopac_properties), intent(in) :: properties_c
    type(mopac_properties_f), intent(out) :: properties_f
    character(kind=c_char), pointer :: cptr(:)
    type(c_ptr), pointer :: pptr(:)
    integer :: i, j, size, status
    properties_f%nerror = properties_c%nerror
    if (properties_c%nerror == 0) then
      properties_f%heat = properties_c%heat
      properties_f%dipole = properties_c%dipole
      properties_f%stress = properties_c%stress
      call copy_real(properties_f%charge, properties_c%charge, [system_c%natom])
      call copy_real(properties_f%coord_update, properties_c%coord_update, [3*system_c%natom_move])
      call copy_real(properties_f%coord_deriv, properties_c%coord_deriv, [3*system_c%natom_move])
      if (c_associated(properties_c%freq)) then
        call copy_real(properties_f%freq, properties_c%freq, [3*system_c%natom_move])
        call copy_real2(properties_f%disp, properties_c%disp, [3*system_c%natom_move,3*system_c%natom_move])
      end if
      call copy_int(properties_f%bond_index, properties_c%bond_index, [system_c%natom+1])
      do i=1, system_c%natom+1
        properties_f%bond_index(i) = properties_f%bond_index(i) + 1
      end do
      call copy_int(properties_f%bond_atom, properties_c%bond_atom, &
                    [properties_f%bond_index(system_c%natom+1)-1])
      do i=1, properties_f%bond_index(system_c%natom+1)-1
        properties_f%bond_atom(i) = properties_f%bond_atom(i) + 1
      end do
      call copy_real(properties_f%bond_order, properties_c%bond_order, &
                    [properties_f%bond_index(system_c%natom+1)-1])
      call copy_real(properties_f%lattice_update, properties_c%lattice_update, [3*system_c%nlattice_move])
      call copy_real(properties_f%lattice_deriv, properties_c%lattice_deriv, [3*system_c%nlattice_move])
    else if (properties_c%nerror > 0) then
      allocate(properties_f%error_msg(properties_c%nerror), stat=status)
      if (status /= 0) then
        write(*,*) "ERROR: Failed to allocate memory in MOPAC API wrapper"
        stop 1
      end if
      call c_f_pointer(properties_c%error_msg, pptr, [properties_c%nerror])
      do i=1, properties_c%nerror
        properties_f%error_msg(i) = ' '
        call c_f_pointer(pptr(i), cptr, [120])
        do size=1, 120
          if (cptr(size) == c_null_char) exit
        end do
        size = size - 1
        do j=1, size
          properties_f%error_msg(i)(j:j) = cptr(j)
        end do
      end do
    end if
    call destroy_mopac_properties(properties_c)
  end subroutine mopac_properties_c2f

  subroutine mopac_state_f2c(state_f, state_c)
    type(mopac_state_f), intent(in) :: state_f
    type(mopac_state), intent(out) :: state_c
    real(c_double), pointer :: rptr(:)
    state_c%mpack = state_f%mpack
    if (state_f%uhf) then
      state_c%uhf = 1
    else
      state_c%uhf = 0
    end if
    call create_mopac_state(state_c)
    if (state_f%mpack /= 0) then
      call c_f_pointer(state_c%pa, rptr, [state_c%mpack])
      rptr = state_f%pa
      if (state_f%uhf) then
        call c_f_pointer(state_c%pb, rptr, [state_c%mpack])
        rptr = state_f%pb
      end if
    end if
  end subroutine mopac_state_f2c

  subroutine mopac_state_c2f(state_c, state_f)
    type(mopac_state), intent(in) :: state_c
    type(mopac_state_f), intent(out) :: state_f
    state_f%mpack = state_c%mpack
    state_f%uhf = (state_c%uhf /= 0)
    if (allocated(state_f%pa)) deallocate(state_f%pa)
    if (allocated(state_f%pb)) deallocate(state_f%pb)
    if (state_f%mpack /= 0) then
      call copy_real(state_f%pa, state_c%pa, [state_c%mpack])
      if (state_f%uhf) call copy_real(state_f%pb, state_c%pb, [state_c%mpack])
    end if
    call destroy_mopac_state(state_c)
  end subroutine mopac_state_c2f

  subroutine mozyme_state_f2c(state_f, state_c)
    type(mozyme_state_f), intent(in) :: state_f
    type(mozyme_state), intent(out) :: state_c
    integer(c_int), pointer :: iptr(:), iptr2(:,:)
    real(c_double), pointer :: rptr(:)
    state_c%numat = state_f%numat
    state_c%noccupied = state_f%noccupied
    state_c%nvirtual = state_f%nvirtual
    state_c%icocc_dim = state_f%icocc_dim
    state_c%icvir_dim = state_f%icvir_dim
    state_c%cocc_dim = state_f%cocc_dim
    state_c%cvir_dim = state_f%cvir_dim
    call create_mozyme_state(state_c)
    if (state_f%numat /= 0) then
      call c_f_pointer(state_c%nbonds, iptr, [state_c%numat])
      iptr = state_f%nbonds
      call c_f_pointer(state_c%ibonds, iptr2, [9,state_c%numat])
      iptr2 = state_f%ibonds
      call c_f_pointer(state_c%iorbs, iptr, [state_c%numat])
      iptr = state_f%iorbs
      call c_f_pointer(state_c%ncf, iptr, [state_c%noccupied])
      iptr = state_f%ncf
      call c_f_pointer(state_c%nce, iptr, [state_c%nvirtual])
      iptr = state_f%nce
      call c_f_pointer(state_c%icocc, iptr, [state_c%icocc_dim])
      iptr = state_f%icocc
      call c_f_pointer(state_c%icvir, iptr, [state_c%icvir_dim])
      iptr = state_f%icvir
      call c_f_pointer(state_c%cocc, rptr, [state_c%cocc_dim])
      rptr = state_f%cocc
      call c_f_pointer(state_c%cvir, rptr, [state_c%cvir_dim])
      rptr = state_f%cvir
    end if
  end subroutine mozyme_state_f2c

  subroutine mozyme_state_c2f(state_c, state_f)
    type(mozyme_state), intent(in) :: state_c
    type(mozyme_state_f), intent(out) :: state_f
    state_f%numat = state_c%numat
    state_f%noccupied = state_c%noccupied
    state_f%nvirtual = state_c%nvirtual
    state_f%icocc_dim = state_c%icocc_dim
    state_f%icvir_dim = state_c%icvir_dim
    state_f%cocc_dim = state_c%cocc_dim
    state_f%cvir_dim = state_c%cvir_dim
    if (allocated(state_f%nbonds)) deallocate(state_f%nbonds)
    if (allocated(state_f%ibonds)) deallocate(state_f%ibonds)
    if (allocated(state_f%iorbs)) deallocate(state_f%iorbs)
    if (allocated(state_f%ncf)) deallocate(state_f%ncf)
    if (allocated(state_f%nce)) deallocate(state_f%nce)
    if (allocated(state_f%icocc)) deallocate(state_f%icocc)
    if (allocated(state_f%icvir)) deallocate(state_f%icvir)
    if (allocated(state_f%cocc)) deallocate(state_f%cocc)
    if (allocated(state_f%cvir)) deallocate(state_f%cvir)
    if (state_f%numat /= 0) then
      call copy_int(state_f%nbonds, state_c%nbonds, [state_c%numat])
      call copy_int2(state_f%ibonds, state_c%ibonds, [9,state_c%numat])
      call copy_int(state_f%iorbs, state_c%iorbs, [state_c%numat])
      call copy_int(state_f%ncf, state_c%ncf, [state_c%noccupied])
      call copy_int(state_f%nce, state_c%nce, [state_c%nvirtual])
      call copy_int(state_f%icocc, state_c%icocc, [state_c%icocc_dim])
      call copy_int(state_f%icvir, state_c%icvir, [state_c%icvir_dim])
      call copy_real(state_f%cocc, state_c%cocc, [state_c%cocc_dim])
      call copy_real(state_f%cvir, state_c%cvir, [state_c%cvir_dim])
    end if
    call destroy_mozyme_state(state_c)
  end subroutine mozyme_state_c2f

  subroutine copy_int(data, ptr, size)
    integer, allocatable, intent(out) :: data(:)
    type(c_ptr), intent(in) :: ptr
    integer, intent(in) :: size(1)
    integer(c_int), pointer :: data_c(:)
    integer :: status
    call c_f_pointer(ptr, data_c, size)
    allocate(data(size(1)), stat=status)
    if (status /= 0) then
      write(*,*) "ERROR: Failed to allocate memory in MOPAC API wrapper"
      stop 1
    end if
    data = data_c
  end subroutine copy_int

  subroutine copy_int2(data, ptr, size)
    integer, allocatable, intent(out) :: data(:,:)
    type(c_ptr), intent(in) :: ptr
    integer, intent(in) :: size(2)
    integer(c_int), pointer :: data_c(:,:)
    integer :: status
    call c_f_pointer(ptr, data_c, size)
    allocate(data(size(1),size(2)), stat=status)
    if (status /= 0) then
      write(*,*) "ERROR: Failed to allocate memory in MOPAC API wrapper"
      stop 1
    end if
    data = data_c
  end subroutine copy_int2

  subroutine copy_real(data, ptr, size)
    double precision, allocatable, intent(out) :: data(:)
    type(c_ptr), intent(in) :: ptr
    integer, intent(in) :: size(1)
    real(c_double), pointer :: data_c(:)
    integer :: status
    call c_f_pointer(ptr, data_c, size)
    allocate(data(size(1)), stat=status)
    if (status /= 0) then
      write(*,*) "ERROR: Failed to allocate memory in MOPAC API wrapper"
      stop 1
    end if
    data = data_c
  end subroutine copy_real

  subroutine copy_real2(data, ptr, size)
    double precision, allocatable, intent(out) :: data(:,:)
    type(c_ptr), intent(in) :: ptr
    integer, intent(in) :: size(2)
    real(c_double), pointer :: data_c(:,:)
    integer :: status
    call c_f_pointer(ptr, data_c, size)
    allocate(data(size(1),size(2)), stat=status)
    if (status /= 0) then
      write(*,*) "ERROR: Failed to allocate memory in MOPAC API wrapper"
      stop 1
    end if
    data = data_c
  end subroutine copy_real2

end submodule mopac_api_f_internal

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module mod_vars_cuda

  integer, parameter :: nthreads_gpu = 256, nblocks_gpu = 256
  logical :: lgpu = .false.
  real, parameter :: real_cuda = selected_real_kind(8)
  integer, parameter :: prec = 8
  integer :: ngpus,gpu_id
  logical, parameter :: exe_gpu_kepler = .true.
end module mod_vars_cuda

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine check (nvec, nnc, nc, icvec, ic_dim, iorbs, ncvec, cvec, c_dim)
   !***********************************************************************
   !   CHECK corrects very small normalization errors in the LMOs.
   !   If the errors are large, greater than 0.1, then a diagnostic
   !   message is printed, and the run stopped.  In practice, the errors
   !   are either (a) very small, in which case correcting them is
   !   appropriate, or (b) very large, in which case there is a bug in the
   !   program.
   !
   !***********************************************************************
    use molkst_C, only: numat
    use chanel_C, only: iw
    use MOZYME_C, only : ws
   !
   !.. Implicit Declarations ..
    implicit none
   !
   !.. Formal Arguments ..
    integer, intent (in) :: ic_dim, c_dim, nvec
    integer, dimension (ic_dim), intent (in) :: icvec
    integer, dimension (nvec+1), intent (in) :: nc, ncvec, nnc
    integer, dimension (numat), intent (in) :: iorbs
    double precision, dimension (c_dim), intent (inout) :: cvec
   !
   !.. Local Scalars ..
    integer :: i, j, k, l, m, mm, n
    double precision :: error, sum
   !
   !.. Intrinsic Functions ..
    intrinsic Abs, Sqrt
   !
   ! ... Executable Statements ...
   !
    error = 0.d0
   !
   !   RENORMALIZE L.M.O.s
   !
    do i = 1, nvec
      m = nnc(i)
      sum = 0.d0
      n = 0
      do j = 1, nc(i)
        m = m + 1
        k = icvec(m)
        do mm = 1, iorbs(k)
          n = n + 1
          sum = sum + cvec(ncvec(i)+n) ** 2
        end do
      end do
      error = error + Abs (1.d0-sum)
      ws(i) = sum
    end do
    do i = 1, nvec
      m = nnc(i)
      sum = 1.d0 / Sqrt (ws(i))
      n = 0
      do j = 1, nc(i)
        m = m + 1
        k = icvec(m)
        do mm = 1, iorbs(k)
          n = n + 1
          cvec(ncvec(i)+n) = cvec(ncvec(i)+n) * sum
        end do
      end do
    end do
    if (error <= 0.1d0) return
   !
   !   SEVERE ERROR IN LMO's.  QUIT THE JOB
   !
    call mopend(" ERROR DETECTED IN SUBROUTINE CHECK")
    write (iw, "(/,A,F12.6,/)") " MAGNITUDE OF ERROR:", error
    write (iw,*) " NUMBER OF VECTORS:", nvec
    write (iw, "(/,A,/)") " L.M.O.s WERE NORMALIZED TO"
    write (iw, "(5F16.12)") (ws(i), i=1, nvec)
    write (iw,*)
    do i = 1, nvec
      if (Abs (ws(i)-1.d0) > 0.1d0) then
        write (iw, "(/,A,I6,A,F12.6/)") "  DETAILS OF LMO", i, " N:", ws (i)
        write (iw,*) " NUMBER OF ATOMS IN LMO:         ", nc (i)
        write (iw,*) " STARTING ADDRESS OF LMO ATOMS:  ", nnc (i)
        write (iw,*) " STARTING ADDRESS OF LMO COEFFS.:", ncvec (i)
        write (iw,*) " ATOM NUMBERS OF ATOMS IN LMO"
        write (iw, "(10I7)") (icvec(j), j=nnc(i)+1, nnc(i)+nc(i))
        write (iw,*) " NNC(I+1):", nnc (i+1)
        write (iw,*) " NCVEC(I+1):", ncvec (i+1)
        l = 0
        write (iw,*) " ORBITAL COEFFICIENTS"
        sum = Sqrt (ws(i))
        do j = 1, nc(i)
          k = icvec(nnc(i)+j)
          write (iw, "(2I6,9F12.6)") j, k, (cvec(m)*sum, m=ncvec(i)+l+1, &
         & ncvec(i)+l+iorbs(k))
          l = l + iorbs(k)
        end do
        write (iw,*) " NUMBER OF ORBITALS IN LMO:", l
      end if
    end do
end subroutine check

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine superd(c, eigs, norbs, nelecs, numat, nat)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use chanel_C, only : iw
      use elemts_C, only : elemnt
      use parameters_C, only: natorb
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: norbs
      integer , intent(in) :: nelecs
      integer , intent(in) :: numat
      integer , intent(in) :: nat(numat)
      double precision , intent(in) :: c(norbs,norbs)
      double precision , intent(in) :: eigs(norbs)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: ihomo, isize, i, ii, k, j, l, ll
      double precision, dimension(4) :: orb
      double precision :: alpha, totloc, totnuc, cdens, deloc, denuc, seltot, &
        selpol, sum
!-----------------------------------------------
      ihomo = nelecs/2
      isize = norbs
      alpha = (eigs(ihomo)+eigs(ihomo+1))/2.D0
      write (iw, '(A,F12.6)') ' Mulliken electronegativity:    ', (-alpha)
      write (iw, '(A,F12.6)') ' Parr & Pople absolute hardness:', (eigs(ihomo+1&
        )-eigs(ihomo))/2.D0
      write (iw, '(A,F12.6)') ' Schuurmann MO shift alpha:     ', alpha
      write (iw, *)
      write (iw, '(A,F12.6)') ' Ehomo:                         ', eigs(ihomo)
      write (iw, '(A,F12.6)') ' Elumo:                         ', eigs(ihomo+1)
      write (iw, '(2/,A,/)') '  a   n        Dn(r)        De(r)   q(r) - Z(r)'
      totloc = 0.D0
      totnuc = 0.D0
      i = 1
      do ii = 1, numat
        if (nat(ii) == 1) then
          i = i + 1
        else
!
!   CALCULATE DELOCALIZABILITY
!
          cdens = 0.D0
          deloc = 0.D0
          denuc = 0.D0
          do k = i, i + natorb(nat(ii)) - 1
            do j = 1, ihomo
              cdens = cdens + c(k,j)*c(k,j)
              deloc = deloc + c(k,j)*c(k,j)/(eigs(j)-alpha)
            end do
            do j = ihomo + 1, isize
              denuc = denuc - c(k,j)*c(k,j)/(eigs(j)-alpha)
            end do
          end do
          write (iw, '(1X,A2,1X,I3,3F13.6)') elemnt(nat(ii)), ii, 2.D0*denuc, &
            2.D0*deloc, (-2.D0*cdens)
          i = i + 4
          totnuc = totnuc + 2.D0*denuc
          totloc = totloc + 2.D0*deloc
        end if
      end do
      write (iw, '(/,A,2F13.6)') ' Total:', totnuc, totloc
      write (iw, '(/,A,/)') '  a   n        piS(r)'
      seltot = 0.D0
      i = 1
      do ii = 1, numat
        if (nat(ii) == 1) then
          i = i + 1
        else
          selpol = 0.D0
          do l = i, i + natorb(nat(ii)) - 1
            do j = 1, ihomo
              do k = ihomo + 1, isize
                selpol = selpol + c(l,j)*c(l,j)*c(l,k)*c(l,k)/(eigs(k)-eigs(j))
              end do
            end do
          end do
          selpol = -4.D0*selpol
          write (iw, '(1X,A2,1X,I3,F13.6)') elemnt(nat(ii)), ii, selpol
          seltot = seltot + selpol
          i = i + natorb(nat(ii))
        end if
      end do
      write (iw, '(/,A,F13.6,/)') ' Total:', seltot
      write (iw, '(A,/)') &
        '  a   n       homo-1         homo         lumo       lumo+1'
      i = 1
      do ii = 1, numat
        if (nat(ii) == 1) then
          i = i + 1
        else
          ll = 0
          do j = ihomo - 1, ihomo + 2
            ll = ll + 1
            sum = 0.D0
            do l = i, i + natorb(nat(ii)) - 1
              sum = sum + c(l,j)*c(l,j)
            end do
            orb(ll) = sum*100.D0
          end do
          write (iw, '(1X,A2,1X,I3,4F13.6)') elemnt(nat(ii)), ii, orb
          i = i + 4
        end if
      end do
      return
      end subroutine superd

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine dtrans(d, h, ioper, first, r)
!
!  Perform symmetry operation ioper on the "d" orbital set d
!
!  "r" holds the orientation matrix that rotates the system so that it is orientated
!  along the principal axes
!
      USE symmetry_C, only : nclass, elem
      implicit none
      integer , intent(in) :: ioper
      logical , intent(inout) :: first
      double precision , intent(inout) :: d(5)
      double precision , intent(inout) :: h(5)
      double precision , intent(in) :: r(3,3)
      integer :: i, k
      double precision, dimension(5,5,12), save :: t1
      double precision, dimension(3,3) :: s
!-----------------------------------------------
      if (first) then
        first = .FALSE.
!
!  Copy r into s because dtrans modifies the first argument
!
        s = r
        t1 = 0.d0
        call dtran2 (s, t1, 1)
        do k = 2, nclass
          s = elem(:,:,k)
          call dtran2 (s, t1, k)
        end do
      end if
!
!  Matrix multiply d*t1*d(trans)
!
      do i = 1, 5
        h(i) = 0.D0
        h(i) = h(i) + sum(t1(i,:,1)*d)
      end do
      do i = 1, 5
        d(i) = 0.D0
        d(i) = d(i) + sum(t1(:,i,ioper)*h)
      end do
      return
      end subroutine dtrans

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine diag(fao, vector, nocc, eig, mdim, n)
      use molkst_C, only : norbs, mpack
      implicit none
      integer , intent(in) :: nocc
      integer , intent(in) :: mdim
      integer , intent(in) :: n
      double precision , intent(in) :: fao(mpack)
      double precision , intent(inout) :: vector(mdim,mdim)
      double precision , intent(in) :: eig(mdim)
!
      integer :: lumo, ij, i, kk, j, k, j1, k2, m
      double precision, dimension(norbs) :: ws
      double precision ::  bigeps = 1.5d-007, tiny, sum, a, b, c, d, e, alpha, beta
      double precision, allocatable :: fmo(:)
!***********************************************************************
!
!   "FAST" DIAGONALISATION PROCEDURE.
!
!    ON INPUT FAO CONTAINS THE LOWER HALF TRIANGLE OF THE MATRIX TO BE
!                         DIAGONALISED, PACKED.
!             VECTOR  CONTAINS THE OLD EIGENVECTORS ON INPUT, THE NEW
!             VECTORS ON EXITING.
!             NOCC = NUMBER OF OCCUPIED MOLECULAR ORBITALS.
!             EIG  = EIGENVALUES FROM AN EXACT DIAGONALISATION
!             MDIM = DECLARED SIZE OF MATRIX "C".
!             N = NUMBER OF ATOMIC ORBITALS IN BASIS SET
!
!  DIAG IS A PSEUDO-DIAGONALISATION PROCEDURE, IN THAT THE VECTORS THAT
!       ARE GENERATED BY IT ARE MORE NEARLY ABLE TO BLOCK-DIAGONALISE
!       THE FOCK MATRIX OVER MOLECULAR ORBITALS THAN THE STARTING
!       VECTORS. IT MUST BE CONSIDERED PSEUDO FOR SEVERAL REASONS:
!       (A) IT DOES NOT GENERATE EIGENVECTORS - THE SECULAR DETERMINANT
!           IS NOT DIAGONALISED, ONLY THE OCCUPIED-VIRTUAL INTERSECTION.
!       (B) MANY SMALL ELEMENTS IN THE SEC.DET. ARE IGNORED AS BEING TOO
!           SMALL COMPARED WITH THE LARGEST ELEMENT.
!       (C) WHEN ELEMENTS ARE ELIMINATED BY ROTATION, THE REST OF THE
!           SEC. DET. IS ASSUMED NOT TO CHANGE, I.E. ELEMENTS CREATED
!           ARE IGNORED.
!       (D) THE ROTATION REQUIRED TO ELIMINATE THOSE ELEMENTS CONSIDERED
!           SIGNIFICANT IS APPROXIMATED TO USING THE EIGENVALUES OF THE
!           EXACT DIAGONALISATION THROUGHOUT THE REST OF THE ITERATIVE
!           PROCEDURE.
!
!  (NOTE:- IN AN ITERATIVE PROCEDURE ALL THE APPROXIMATIONS PRESENT IN
!          DIAG BECOME VALID AT SELF-CONSISTENCY, SELF-CONSISTENCY IS
!          NOT SLOWED DOWN BY USE OF THESE APPROXIMATIONS)
!
!    REFERENCE:
!             "FAST SEMIEMPIRICAL CALCULATIONS",
!             STEWART. J.J.P., CSASZAR, P., PULAY, P., J. COMP. CHEM.,
!             3, 227, (1982)
!
!***********************************************************************
!
!  FIRST, CONSTRUCT THAT PART OF A SECULAR DETERMINANT OVER MOLECULAR
!  ORBITALS WHICH CONNECTS THE OCCUPIED AND VIRTUAL SETS.
!
!***********************************************************************
!


      allocate(fmo(mpack))
      tiny = 0.D0
      lumo = nocc + 1
      ij = 0
      do i = lumo, n
        kk = 0
        do j = 1, n
          sum = 0.D0
          do k = 1, j
            kk = kk + 1
            sum = sum + fao(kk)*vector(k,i)
          end do
          if (j /= n) then
            j1 = j + 1
            k2 = kk
            do k = j1, n
              k2 = k2 + k - 1
              sum = sum + fao(k2)*vector(k,i)
            end do
          end if
          ws(j) = sum
        end do
        do j = 1, nocc
          ij = ij + 1
          sum = 0.D0
          do k = 1, n
            sum = sum + ws(k)*vector(k,j)
          end do
          tiny = dmax1(abs(sum),tiny)
          fmo(ij) = sum
        end do
      end do
      tiny = 0.05D0*tiny



!***********************************************************************
!
!   NOW DO A CRUDE 2 BY 2 ROTATION TO "ELIMINATE" SIGNIFICANT ELEMENTS
!
!***********************************************************************
      ij = 0
!      k = 0

!
      do i = lumo, n
        do j = 1, nocc
          ij = ij + 1
          if (abs(fmo(ij)) < tiny) cycle
!
!      BEGIN 2 X 2 ROTATIONS
!
          a = eig(j)
          b = eig(i)
          c = fmo(ij)
          d = a - b
!
!    USE BIGEPS TO DETERMINE WHETHER TO DO A 2 BY 2 ROTATION
!
          if (abs(c/d) < bigeps) cycle
!
!  AT THIS POINT WE KNOW THAT
          e = sign(sqrt(4.D0*c*c + d*d),d)
          alpha = sqrt(0.5D0*(1.D0 + d/e))
          beta = -sign(sqrt(1.D0 - alpha*alpha),c)
!
!      ROTATION OF PSEUDO-EIGENVECTORS
!
! GBR test
!          k = k + 1
!
          do m = 1, n
            a = vector(m,j)
            b = vector(m,i)
            vector(m,j) = alpha*a + beta*b
            vector(m,i) = alpha*b - beta*a
          end do
          continue
        end do
      end do

! GBR test
!      write(iw,*) ' Number of Jacobi rotations in diag = ',k
!

      return
      end subroutine diag

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  subroutine prtpka(ipKa_sorted, pKa_sorted, ipKa_unsorted, pKa_unsorted,  no)
    use common_arrays_C, only : grad, xparam, p, nat, coord
    use molkst_C, only : numat, escf, mozyme, emin, mpack, moperr
    use linear_cosmo, only : ini_linear_cosmo, coscavz
    use parameters_C, only : tore
    use cosmo_C, only : iseps, useps, lpka
    use chanel_C, only : iw
    implicit none
    integer, intent (out) :: ipKa_sorted(numat), ipKa_unsorted(numat), no
    double precision, intent (out) :: pKa_sorted(numat), pKa_unsorted(numat)
!
! Calculates and prints the pKa_sorted for an organic molecule with an ionizable hydrogen
! attached to an oxygen atom.
!
   double precision :: sum, c1, c2, c3, dist(numat), sum_min, sum_H_min
   integer :: i, j, k, nh, loop, i_min
   double precision, dimension(numat) :: q
   logical :: store_iseps, store_useps
!
!  First, switch in parameters specific to the pKa_sorted calculation.
!
    call Parameters_for_PKA(c1, c2, c3)
!
!  Re-calculate the charges
!
    store_iseps = iseps
    store_useps = useps
    iseps = .true.
    useps = .true.
    emin = 0.d0
    call cosini(.true.)
    if (mozyme) call ini_linear_cosmo
    if (mozyme) then
      call coscavz(coord, nat)
      lpka = .true.
    else
       call coscav
       call mkbmat
    end if
    i = mpack
    call moldat(1)
    mpack = i
    moperr = .false. ! An error in moldat is not important here. only the electronics are affected.
    call calpar
    call compfg (xparam, .TRUE., escf, .TRUE., grad, .FALSE.)
    nh = 0
    if (moperr) return
    lpka = .false.
    call chrge (p, q)
    q(:numat) = tore(nat(:numat)) - q(:numat)
!
!  Find the ionizable hydrogens
!
    pKa_unsorted = 0.d0
    do i = 1, numat
      if (nat(i) /= 1) cycle
      sum_min = 2.d0
      i_min = 0
      do j = 1, numat
        if (nat(j) /= 8) cycle
        sum = (coord(1,i) - coord(1,j))**2 + &
            & (coord(2,i) - coord(2,j))**2 + &
            & (coord(3,i) - coord(3,j))**2
        if (sum < sum_min) then      ! Assume that a hydrogen within 1.4 Angstroms of an oxygen is
          sum_min = sum              ! attached to that atom
          i_min = j
        end if
      end do
      if (sum_min < 1.9999d0) then
!
! Exclude water
!
        sum_H_min = 2.d0
        do k = 1, numat
          if (nat(k) /= 1 .or. k == i) cycle
          sum = (coord(1,k) - coord(1,i_min))**2 + &
              & (coord(2,k) - coord(2,i_min))**2 + &
              & (coord(3,k) - coord(3,i_min))**2
! Assume that a hydrogen within 1.4 Angstroms of an oxygen is attached to that atom
          if (sum < sum_H_min) then
            sum_H_min = sum
          end if
        end do
        if (sum_H_min < 1.9999d0 .and. numat > 3) cycle
        nh = nh + 1
        ipKa_unsorted(nh) = i
        pKa_unsorted(nh)=q(i)
        dist(nh) = sqrt(sum_min)
      end if
    end do
!
! Now sort into decending order
!
    ipKa_sorted = 0
    pKa_sorted = 0.d0
    if (nh == 0) then
      write(iw,"(/,3(10x,a,/))")"A request was made to print the pKa_sorted values for this system,", &
      "but there are no hydrogen atoms attached to an oxygen atom,", &
      "so the pKa_sorted calculation cannot be completed."
      return
    end if
    do i = 1, nh !  Convert charges and bond-lengths into pKa_sorted values
     pKa_unsorted(i) = pKa_unsorted(i)*c1 + dist(i)*c2 + c3
    end do
    loop = 0
    do i = 1, nh  ! Sort pKa_sorted into order, select lowest four
      sum = 100.d0
      k = 0
      do j = 1, nh
        if (pKa_unsorted(j) < sum) then
          k = j
          sum = pKa_unsorted(j)
        end if
      end do
      if (k == 0) exit
      j = 1
      if (loop > 0) then
        do j = 1, loop
          if (ipKa_sorted(j) == ipKa_unsorted(k) .and. Abs(pKa_sorted(j) - pKa_unsorted(k)) < 0.2d0) exit
        end do
      end if
      if (j <= loop) cycle
      loop = loop + 1
      ipKa_sorted(loop) = ipKa_unsorted(k)
      pKa_sorted(loop) =  pKa_unsorted(k)
      pKa_unsorted(k) = 200.d0 + pKa_unsorted(k)
    end do
    pKa_unsorted(:loop) = pKa_unsorted(:loop) - 200.d0
    no = loop
    call switch
    iseps = store_iseps
    useps = store_useps
    i = mpack
    call moldat(1)
    mpack = i
    moperr = .false. ! An error in moldat is not important here. only the electronics are affected.
    call calpar
    emin = 0.d0
    call compfg (xparam, .TRUE., escf, .TRUE., grad, .FALSE.)
    return
  end subroutine prtpka
  subroutine Parameters_for_PKA(c1, c2, c3)
    use parameters_C, only : uss, upp, udd, zs, zp, zd, betas, &
    betap, betad, gss, gsp, gpp, gp2, hsp, zsn, zpn, zdn
    double precision, intent (out) :: c1, c2, c3
    c1   =    -288.0530769d0
    c2   =      28.6888717d0
    c3   =      89.1172382d0
!
!                    Data for pKa_sorted for Element  1         Hydrogen
!
    uss  ( 1)   =      -9.3555403d0
    betas( 1)   =      -2.6789813d0
    zs   ( 1)   =       1.2458568d0
    gss  ( 1)   =      14.5964443d0
!
!                    Data for pKa_sorted for Element  6           Carbon
!
    uss  ( 6)   =     -49.9390029d0
    upp  ( 6)   =     -43.8233347d0
    betas( 6)   =     -12.6446141d0
    betap( 6)   =      -9.4614222d0
    zs   ( 6)   =       1.6412075d0
    zp   ( 6)   =       1.5810984d0
    gss  ( 6)   =      16.7616538d0
    gsp  ( 6)   =      12.3925395d0
    gpp  ( 6)   =      11.2679258d0
    gp2  ( 6)   =      11.0158335d0
    hsp  ( 6)   =       0.4200022d0
!
!                    Data for pKa_sorted for Element  7         Nitrogen
!
    uss  ( 7)   =     -55.4307466d0
    upp  ( 7)   =     -49.8247298d0
    betas( 7)   =     -21.7612447d0
    betap( 7)   =     -16.9335869d0
    zs   ( 7)   =       1.4860676d0
    zp   ( 7)   =       2.0420069d0
    gss  ( 7)   =       7.1149144d0
    gsp  ( 7)   =       7.2242656d0
    gpp  ( 7)   =      14.8103679d0
    gp2  ( 7)   =      11.4500819d0
    hsp  ( 7)   =       4.5873409d0
!
!                    Data for pKa_sorted for Element  8           Oxygen
!
    uss  ( 8)   =     -89.9472647d0
    upp  ( 8)   =     -70.7249961d0
    betas( 8)   =     -66.7497177d0
    betap( 8)   =     -21.7795050d0
    zs   ( 8)   =       4.3991035d0
    zp   ( 8)   =       2.1614926d0
    gss  ( 8)   =      16.3875625d0
    gsp  ( 8)   =      16.0293626d0
    gpp  ( 8)   =      16.6098992d0
    gp2  ( 8)   =      11.0339705d0
    hsp  ( 8)   =       4.7920603d0
!
!                    Data for pKa_sorted for Element  9         Fluorine
!
    uss  ( 9)   =    -141.5218991d0
    upp  ( 9)   =     -98.4596662d0
    betas( 9)   =     -69.7628706d0
    betap( 9)   =     -30.1591819d0
    zs   ( 9)   =       5.9393528d0
    zp   ( 9)   =       4.7675390d0
    gss  ( 9)   =      12.5528331d0
    gsp  ( 9)   =      19.8940208d0
    gpp  ( 9)   =       8.8875462d0
    gp2  ( 9)   =      12.5543486d0
    hsp  ( 9)   =       3.5419742d0
!
!                    Data for pKa_sorted for Element 17         Chlorine
!
    uss  (17)   =     -61.5736619d0
    upp  (17)   =     -54.5254717d0
    udd  (17)   =     -38.2581550d0
    betas(17)   =      -0.5351767d0
    betap(17)   =     -11.7700638d0
    betad(17)   =      -4.0377510d0
    zs   (17)   =       4.2327248d0
    zp   (17)   =       1.2135427d0
    zd   (17)   =       1.3240330d0
    zsn  (17)   =       0.9562970d0
    zpn  (17)   =       2.4640670d0
    zdn  (17)   =       6.4103250d0
    gss  (17)   =       9.4258401d0
    gsp  (17)   =       5.3649222d0
    gpp  (17)   =      10.2118976d0
    gp2  (17)   =       9.1156399d0
    hsp  (17)   =       4.9183864d0
!
!                    Data for pKa_sorted for Element 35          Bromine
!
    uss  (35)   =     -46.3749516d0
    upp  (35)   =     -50.1929356d0
    udd  (35)   =       7.0867380d0
    betas(35)   =     -31.5606655d0
    betap(35)   =      -9.1283278d0
    betad(35)   =      -9.8391240d0
    zs   (35)   =       5.0204513d0
    zp   (35)   =       2.2579169d0
    zd   (35)   =       1.5210310d0
    zsn  (35)   =       3.0947770d0
    zpn  (35)   =       3.0657640d0
    zdn  (35)   =       2.8200030d0
    gss  (35)   =       8.1108378d0
    gsp  (35)   =       5.2179143d0
    gpp  (35)   =      10.3707055d0
    gp2  (35)   =       8.5089799d0
    hsp  (35)   =       4.8307027d0
!
!                    Data for pKa_sorted for Element 53           Iodine
!
    uss  (53)   =     -59.6492236d0
    upp  (53)   =     -56.2042321d0
    udd  (53)   =     -28.8226030d0
    betas(53)   =     -30.0143361d0
    betap(53)   =      -5.5364107d0
    betad(53)   =      -7.6761070d0
    zs   (53)   =       4.9453882d0
    zp   (53)   =       2.4202135d0
    zd   (53)   =       1.8751750d0
    zsn  (53)   =       9.1352440d0
    zpn  (53)   =       6.8881910d0
    zdn  (53)   =       3.7915230d0
    gss  (53)   =       7.7877000d0
    gsp  (53)   =       9.4756338d0
    gpp  (53)   =      10.5149673d0
    gp2  (53)   =       8.1832762d0
    hsp  (53)   =       4.7971922d0
    return
  end subroutine Parameters_for_PKA

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine selmos (nmos_loc, nc, ic, n01, c, n02, nnc_loc, ncmo, ln, mn, iws, &
& jopt, ncnew, ncmnew, nncnew, mode)
    use molkst_C, only: numat
    use MOZYME_C, only : numred, nelred, norred
    use chanel_C, only: iw
    implicit none
    integer, intent (in) :: ln, mn, mode, n01, n02, nmos_loc
    integer, dimension (n01), intent (inout) :: ic
    integer, dimension (nmos_loc), intent (inout) :: iws, nc, ncmnew, ncmo, &
   & ncnew, nnc_loc, nncnew
    integer, dimension (numat), intent (in) :: jopt
    double precision, dimension (n02), intent (inout) :: c
    integer :: i, ibot, itop, j, jbot, jtop, l, l1, l2, m, n, nbot, ncoefs, &
   & nreal, ntop
   !
   !   Move LMOs for atoms in JOPT to start of storage space
   !
   !    MN, LN   = END OF STORAGE ALREADY USED
   !    N02, N01 = END OF STORAGE
   !
   !   FIRST, MOVE ALL VECTORS TO END OF STORAGE
   !
    l = n02 - mn
    do i = mn, 1, -1
      c(i+l) = c(i)
    end do
   !
   !  Modify pointers
   !
    do i = 1, nmos_loc
      ncmo(i) = ncmo(i) + l
    end do
   !
   !  Move atom addresses
   !
    l = n01 - ln
    do i = ln, 1, -1
      ic(i+l) = ic(i)
    end do
   !
   !  Modify atom address pointers
   !
    do i = 1, nmos_loc
      nnc_loc(i) = nnc_loc(i) + l
    end do
   !
   !        NBOT       refers to IC                -> IC
   !        JBOT, JTOP refer to C                  -> C
   !        IBOT, ITOP refer to NC, NNC, and NCMO -> NCNEW, NNCNEW, NCMNEW
   !
   !   Select those LMOs that are to be used in the SCF.  Move these to the
   !   start of the storage
   !
    jbot = 0
    nbot = 0
    jtop = n02 - mn - 1
    ntop = n01 - ln - 1
    ibot = 0
    itop = nmos_loc + 1
    nreal = 0
   !
   !   Put number of coefficients into IWS.
   !
    do i = nmos_loc, 2, -1
      iws(i) = iws(i) - iws(i-1)
    end do
    do i = 1, nmos_loc
      l = nnc_loc(i)
      l1 = ic(1+l)
      l2 = ic(2+l)
      do m = 1, numred
        if (l1 == jopt(m) .or. l2 == jopt(m)) go to 1000
      end do
      !
      ! PUT VECTOR AT END OF IC AND C.  This is the default: the LMO is
      ! NOT selected.
      !
      itop = itop - 1
      nncnew(itop) = nnc_loc(i)
      ncnew(itop) = nc(i)
      ncmnew(itop) = ncmo(i)
      cycle
1000  if (nbot+nc(i) > ntop .or. jbot+iws(i) > jtop) then
        !
        !   There is no space for the remaining vectors.  Remove unused space
        !   from between the vectors that will not be used in the SCF.
        !
        call compct (nncnew, ncnew, ncmnew, itop, nc, ic, iws, n01, c, n02, &
       & nmos_loc, i, ntop, jtop, l, ncmo(i))
      end if
      !
      ! PUT VECTOR AT START OF IC AND C
      !
      ibot = ibot + 1
      nncnew(ibot) = nbot
      ncnew(ibot) = nc(i)
      ncmnew(ibot) = jbot
      do n = 1, nc(i)
        ic(nbot+n) = ic(l+n)
      end do
      nbot = nbot + nc(i)
      nc(i) = 0
      j = ncmo(i)
      ncoefs = iws(i)
      do n = 1, ncoefs
        c(jbot+n) = c(j+n)
      end do
      jbot = jbot + ncoefs
      nreal = nreal + 1
    end do
    do i = 1, ibot
      nc(i) = ncnew(i)
      nnc_loc(i) = nncnew(i)
      ncmo(i) = ncmnew(i)
    end do
    j = nmos_loc + 1
    do i = itop, nmos_loc
      j = j - 1
      nc(i) = ncnew(j)
      nnc_loc(i) = nncnew(j)
      ncmo(i) = ncmnew(j)
    end do
   !
   !  HAVE ARRAY BOUNDS BEEN DAMAGED?
   !
    if (jbot > jtop) then
      if (mode == 1) then
        write (iw,*) " OCCUPIED C VECTOR DAMAGED IN SELMOS"
        write (iw,*) " (THIS IS A BUG IN THE PROGRAM)"
      else
        write (iw,*) " VIRTUAL C VECTOR DAMAGED IN SELMOS"
        write (iw,*) "  (THIS IS A BUG IN THE PROGRAM)"
      end if
      call mopend ("BUG IN SELMOS")
    end if
    if (nbot > ntop) then
      if (mode == 1) then
        write (iw,*) " OCCUPIED IC VECTOR DAMAGED IN SELMOS"
        write (iw,*) "  (THIS IS A BUG IN THE PROGRAM)"
      else
        write (iw,*) " VIRTUAL IC VECTOR DAMAGED IN SELMOS"
        write (iw,*) "  (THIS IS A BUG IN THE PROGRAM)"
      end if
      call mopend ("BUG IN SELMOS")
    end if
    if (mode == 1) then
      !
      !   Number of electrons to be used in the SCF is NELRED.
      !
      nelred = 2 * nreal
    else
      !
      !   Number of LMOs to be used in the SCF is NORRED.
      !
      norred = nreal + nelred / 2
    end if
    norred = norred
    nelred = nelred
end subroutine selmos

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine cntour (a, mdim, imax, jmax, pz, value, i1, i2, i3, r11)
  use common_common, only : im, r1, jm
  implicit none
  integer, intent(in) :: i1, i2, i3, imax, jmax, mdim
  double precision, intent(in) :: pz, value
  double precision, intent(out) :: r11
  double precision, dimension(mdim, *), intent(inout) :: a
  ! 
  !.. Local Scalars .. 
  integer :: i, imax1, j, jmax1, k
  double precision :: aa, ab
  logical, dimension(40000) :: b
  logical, dimension(20000, 2) :: c
  ! 
  !***********************************************************************
  !
  ! GENERAL CONTOUR-DRAWING ROUTINE.
  !
  !  ON INPUT:
  !      A      = 2-D ARRAY OF POINTS DEFINING HEIGHT IN MAP-SPACE.
  !      MDIM   = SIZE OF FIRST DIMENSION OF A.
  !      IMAX   = LENGTH OF ONE SIDE OF ARRAY WITHIN A.
  !      JMAX   = LENGTH OF THE OTHER SIDE OF THE ARRAY WITHIN A.
  !      PZ     = VALUE OF Z DIRECTION IF 3-D PLOTS ARE BEING DRAWN.
  !      VALUE  = VALUE OF CONTOUR.
  !      I1,I2,I3 = 1,2,3 IF AN ORTHOSCOPIC PLOT IS WANTED, I.E. IF THE
  !               VIEW IS ALONG Z, AND THE PLOT IS IN X AND Y, THIS IS THE
  !               'NORMAL' PLOT. THIS OPTION HAS NEVER BEEN EXCERCISED
  !               FULLY.
  !  ON EXIT R11= LENGTH OF CONTOUR. THIS IS THE TOTAL LENGTH OF ALL LINES
  !               MAKING UP THE CONTOUR, OPEN AND CLOSED.
  !***********************************************************************
  im = imax
  r1 = 0.d0
  jm = jmax
  !
  !  SET UP STRING FOR LATER ANNOTATION OF CONTOURS.
  !
  !
  !  THE FOLLOWING CODE SUBTRACTS THE VALUE OF THE VALUE BEING SOUGHT
  !  FROM ALL ELEMENTS OF A, SO THAT THE ZERO VALUE WILL BE SOUGHT
  !  HEREAFTER.
  !
  do i = 1, imax
    do j = 1, jmax
      a(i, j) = a(i, j) - value
    end do
  end do
  r11 = r1
  jmax1 = jmax - 1
  imax1 = imax - 1
  do i = 1, imax
    do j = 1, jmax1
      aa = a(i, j)
      ab = a(i, j+1)
      !
      !  IF A CONTOUR  PASSES CLOSE TO AN ELEMENT OF A, THE CORRESPONDING
      !  ELEMENT OF LOGICAL ARRAY B IS SET.
      !
      b(imax*(j-1)+i) = ((aa>=0..and.ab<0.).or. (aa<0..and.ab>=0.))
    end do
  end do
  k = 1
  do j = 1, jmax, jmax1
    ab = a(1, j)
    do i = 1, imax1
      aa = ab
      ab = a(i+1, j)
      !
      !  THE ARRAY C HAS THE SAME FUNCTION AS B, BUT ON THE BOUNDARY OF THE
      !  AREA.
      !
      c(i, k) = ((aa>=0..and.ab<0.).or. (aa<0..and.ab>=0.))
    !
    !  THE ARRAY C HAS THE SAME FUNCTION AS B, BUT ON THE BOUNDARY OF THE
    !  AREA.
    !
    end do
    k = 2
  end do
  !
  !   DRAW UNCLOSED CONTOURS (IE STARTING ON A BOUNDARY).
  !
  do i = 1, imax1
    if (c(i, 1)) then
      call draw (i, 1, 1, a, b, c, pz, i1, i2, i3, mdim)
    end if
    if (c(i, 2)) then
      call draw (i+1, jmax, 3, a, b, c, pz, i1, i2, i3, mdim)
    end if
  end do
  !
  !  DRAW INTERIOR CONTOURS PASSING CLOSE TO BOUNDARY POINTS.
  !
  do j = 1, jmax1
    if (b((j-1)*imax+1)) then
      call draw (1, j+1, 4, a, b, c, pz, i1, i2, i3, mdim)
    end if
    if (b(j*imax)) then
      call draw (imax, j, 2, a, b, c, pz, i1, i2, i3, mdim)
    end if
  end do
  !
  !  DRAW OTHER INTERIOR CONTOURS.
  !
  do i = 2, imax1
    do j = 1, jmax1
      if (b((j-1)*imax+i)) then
        call draw (i, j, 2, a, b, c, pz, i1, i2, i3, mdim)
      end if
    end do
  end do
  !
  !  RESTORE "A" MATRIX TO ITS ORIGINAL VALUE.
  !
  do i = 1, imax
    do j = 1, jmax
      a(i, j) = a(i, j) + value
    end do
  end do
end subroutine cntour

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine prttim(tleft, tprt, txt)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision , intent(in) :: tleft
      double precision , intent(out) :: tprt
      character , intent(out) :: txt
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
!-----------------------------------------------
      tprt = tleft
      txt = 'S'
      if (tprt >= 604800D0) then
        tprt = tprt/604800.D0
        txt = 'W'
      else if (tprt >= 86400.D0) then
        tprt = tprt/86400.D0
        txt = 'D'
      else if (tprt >= 3600.D0) then
        tprt = tprt/3600.D0
        txt = 'H'
      else if (tprt >= 60.D0) then
        tprt = tprt/60.D0
        txt = 'M'
      end if
      return
      end subroutine prttim

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine ligand (ires, start_res, nfrag)
    use elemts_C, only: cap_elemnt
    use common_arrays_C, only : txtatm, txtatm1, nat, labels, nbonds, ibonds, &
      all_comments
    use MOZYME_C, only : allres
    use molkst_C, only : natoms, id, ncomments, line, keywrd, numat
    use chanel_C, only: log, ilog, iw
    implicit none
    integer, intent (inout) :: ires, nfrag
    integer, intent (in) :: start_res(*)
!
    integer, parameter :: maxlive = 15000
    integer :: i, j, k, l, m, n, ii, jj, kk, mm, nn, res, change_no, max_comments, &
      nlive, n_C, n_O, n_N, n_S, n_P, n_ele(107), ninres, i_panic, ele_order(107)
    logical, allocatable :: l_used(:)
    integer, allocatable :: inres(:)
    integer, allocatable :: live(:)
    logical :: attached, l_chain, first, l_write = .true.
    integer, external :: nheavy
    double precision, external :: distance, reada
    character :: het*3, het_group*120, num, num1, el*2, het2*3, line1*120
    save :: l_write
    allocate (l_used(natoms), inres(natoms), live(maxlive))
    ele_order(1) = 6
    ele_order(2) = 1
    ele_order(3) = 7
    ele_order(4) = 8
    k = 4
    do i = 2, 107
       select case (i)
       case (6, 7, 8)
       case default
         k = k + 1
         ele_order(k) = i
       end select
    end do
    j = 0
    do i = 1, ncomments
      if (index(all_comments(i), "REMARK   3") == 0) then
        j = j + 1
        all_comments(j) = all_comments(i)
      end if
    end do
    ncomments = j
    max_comments = size(all_comments)
    first = .true.
    change_no = 0
!
    i_loop: do i = 1, natoms - id
      if (txtatm(i) (26:26) == " ") then
!
!  Residue number is missing, therefore not a residue.
!
!
!    Test for specific molecules
!
        if (labels(i) == 15) then
          if (nbonds(i) == 4) then
            k = 0
            do j = 1, 4
              if (labels(ibonds(j, i)) /= 8) go to 1000
              if (nbonds(ibonds(j,i)) > 1) k = k + 1
            end do
            if (k > 1) go to 1000
!
!                                 Phosphate
!
            call inc_res(ires, start_res, nfrag)
            write (txtatm(i), "(a6,i5,1x,a3,a5,i6)")"HETATM", i, " P ", "PO4", ires
            do j = 1, 4
              write (txtatm(ibonds(j, i)), "(a6,i5,1x,a3,a5,i6)")"HETATM", ibonds(j, i), " O ", "PO4", ires
            end do
          end if
        else if (labels(i) == 16) then
          if (nbonds(i) == 4) then
            do j = 1, 4
              if (labels(ibonds(j, i)) /= 8) go to 1000
            end do
!
!                                 Sulfate
!
            call inc_res(ires, start_res, nfrag)
            write (txtatm(i), "(a6,i5,1x,a3,a5,i6)")"HETATM", i, " S ", "SO4", ires
            do j = 1, 4
              write (txtatm(ibonds(j, i)), "(a6,i5,1x,a3,a5,i6)")"HETATM", ibonds(j, i), " O ", "SO4", ires
            end do
          end if
        else if (labels(i) == 8 .and. nheavy(i) == 0) then
!
!                                 Water
!
          call inc_res(ires, start_res, nfrag)
          write (txtatm(i), "(a6,i5,1x,a3,a5,i6)")"HETATM", i, " O ", "HOH", ires
            do j = 1, nbonds(i)
              write (txtatm(ibonds(j, i)), "(a6,i5,1x,a3,a5,i6)")"HETATM", ibonds(j, i), " H ", "HOH", ires
            end do
        else if (labels(i) == 8) then
!
!                                     Ethylene glycol and glycerol
!                                     H-O-CH2-CH2-O-H and HOCH2-HCOH-H2COH
!
          if (nheavy(i) == 1) then
            do ii = 1, nbonds(i)
              j = ibonds(ii,i)
              if (nat(j) /= 6) cycle
              if (nheavy(j) /= 2) cycle! Oxygen joined to carbon(1)
                do jj = 1, nbonds(j)
                k = ibonds(jj,j)
                if (nat(k) /= 6) cycle
                if (nheavy(k) == 1) then
!
!  Found methanol
!
                else if (nheavy(k) == 2) then! Carbon(1) joined to oxygen and carbon(2)

                  do kk = 1,nbonds(k)
                    l = ibonds(kk,k)
                    if (nat(l) == 8 .and. l /= j) then
                      l = l
                    end if
                    if (nat(l) /= 8) cycle
                    if (nheavy(l) == 1) then! Oxygen joined to carbon(2)
!
! Found O-C-C-O
!
                      call inc_res(ires, start_res, nfrag)
                      write (txtatm(i), "(a6,i5,1x,a3,a5,i6)")"HETATM", i, " O ", "EDO", ires
                      write (txtatm(j), "(a6,i5,1x,a3,a5,i6)")"HETATM", i, " C ", "EDO", ires
                      write (txtatm(k), "(a6,i5,1x,a3,a5,i6)")"HETATM", i, " C ", "EDO", ires
                      write (txtatm(l), "(a6,i5,1x,a3,a5,i6)")"HETATM", i, " O ", "EDO", ires
                    end if
                  end do
                else if (nheavy(k) == 3) then

                  do kk = 1,nbonds(k)
                    l = ibonds(kk,k)
                    if (nat(l) /= 8) cycle
                    if (nheavy(l) /= 1) cycle! Oxygen joined to carbon(2)
                    do mm = 1,nbonds(k)
                      m = ibonds(mm,k)
                      if (nat(m) /= 6) cycle
                      if (m == j) cycle
                      if (nheavy(m) /= 2) cycle! Carbon(3) joined to carbon(2)
                      do nn = 1, nbonds(m)
                        n = ibonds(nn,m)
                        if (nat(n) /= 8) cycle
!
! Found O-C-CO-C-O
!
                        call inc_res(ires, start_res, nfrag)
                        write (txtatm(i), "(a6,i5,1x,a3,a5,i6)")"HETATM", i, " O ", "GOL", ires
                        write (txtatm(j), "(a6,i5,1x,a3,a5,i6)")"HETATM", i, " C ", "GOL", ires
                        write (txtatm(k), "(a6,i5,1x,a3,a5,i6)")"HETATM", i, " C ", "GOL", ires
                        write (txtatm(l), "(a6,i5,1x,a3,a5,i6)")"HETATM", i, " O ", "GOL", ires
                        write (txtatm(m), "(a6,i5,1x,a3,a5,i6)")"HETATM", i, " C ", "GOL", ires
                        write (txtatm(n), "(a6,i5,1x,a3,a5,i6)")"HETATM", i, " O ", "GOL", ires
                      end do
                    end do
                  end do
                end if
              end do
            end do
          end if
        end if
1000    continue
      end if
      n_ele = 0
      ninres = 0
      i_panic = 0
      l_used = .false.
      if (txtatm(i) (26:26) == " " .and. nat(i) /= 1) then
        ninres = 1
        inres(1) = i
        l_used(i) = .true.
        nlive = nbonds(i)
        live(:nlive) = ibonds(:nlive,i)
        select case (nat(i))
        case (6:9, 15:17, 34:35, 53)
        case default
          nlive = 0
        end select
        call inc_res(ires, start_res, nfrag)
        outer_loop: do
          l = live(1)
          if (nlive == 0) exit
          if (l == 0) exit
          if (l_used(l) .or. txtatm(l)(11:14) /= " ") then
!
!   Atom L is already labeled
!
            live(1) = live(nlive)
            nlive = nlive - 1
          else
!
!  Assign atom L to the hetero group.
!
            l_used(l) = .true.
            do ii = 1, nbonds(l)
              jj = ibonds(ii,l)
              if (txtatm(jj)(11:14) /= " ") then
                select case (nat(i))
                case (6:9, 15:17, 34:35, 53)
                  i_panic = jj
                end select
              end if
            end do
            select case (nat(i))
            case (6:9, 15:17, 34:35, 53)
              ninres = ninres + 1
              inres(ninres) = l
            end select
            if (nbonds(l) /= 0) then
!
!  THERE IS AT LEAST ONE ATOM ATTACHED TO THE 'LIVE' ATOM
!
              loop1: do ii = 2, nbonds(l)
                j = ibonds(ii, l)
                do jj = 1, nlive
                  if (live(jj) == j) cycle loop1
                end do
                if (.not. l_used(j) .and. txtatm(j)(11:14) == " ") then
                  nlive = nlive + 1
                  if (nlive > maxlive) return
                  live(nlive) = j
                end if
              end do loop1
              live(1) = ibonds(1, l)
            else
              if (nlive == 0) exit
              live(1) = live(nlive)
              nlive = nlive - 1
            end if
          end if
        end do outer_loop
        if (i_panic == 0) then
          n_ele = 0
          l = 0
          do j = 1, ninres
            k = inres(j)
            if (k <= numat) then
              if (nat(k) < 99 .or. (nat(k) > 99 .and. nat(k) < 107)) then
                l = l + 1
                n_ele(nat(k)) = n_ele(nat(k)) + 1
              end if
            end if
          end do
          if (l == 0) return
          ninres = l
          n_C = n_ele(6)
          n_N = n_ele(7)
          n_O = n_ele(8)
          n_S = n_ele(16)
          n_P = n_ele(15)
          attached = .false.
          res = -10000
          n = 0
          loop_k: do k = 1, ninres
            m = inres(k)
            do l = 1, nbonds(m)
              n = ibonds(l,m)
              if (txtatm(n)(26:26) /= " ") then
                attached = .true.
                res = nint(reada(txtatm(n), 23))
                exit loop_k
              end if
            end do
          end do loop_k
          if (n > 0 .and. res /= -10000) then
            if (txtatm(n)(13:16) == " N  " .and. nat(m) == 6) then
!
!  Inserting a fragment at the start of a chain -
!  so move all residue numbers in the rest of the chain up by 1
!
              k = res
              do
                j = nint(reada(txtatm(n), 23))
                if (j == k) then
                  write(txtatm(n)(23:26),'(i4)') k + 1
                else if (j == k + 1) then
                  k = k + 1
                  write(txtatm(n)(23:26),'(i4)') k + 1
                else
                  exit
                end if
                n = n + 1
              end do
              k = res
              het  = allres(k)(:3)
              allres(k) = "UNK"
              do
                het2 = allres(k + 1)(:3)
                if (het2 == " ") exit
                allres(k + 1) = het
                het = het2
                k = k + 1
              end do
            end if
          end if
!
!  Formula of hetero group is C(n_C) N(n_N) O(n_O)
!  and atoms are in inres(:ninres)
!
!  Now assign "obvious" hetero groups
!
          het = "HET"
          line = "Not identified;"
          do m = 1, 84
            k = ele_order(m)
            if (n_ele(k) > 0) then
              l = n_ele(k)
              num = char(ichar("1") +int(log10(l + 0.05)))
              if (cap_elemnt(k)(1:1) == " ") then
                num1 = "2"
              else
                num1 = "3"
              end if
              if (l == 1) then
                write(line(len_trim(line) + 1:),'(a'//num1//')')cap_elemnt(k)
              else
                write(line(len_trim(line) + 1:),'(a'//num1//',i'//num//')')cap_elemnt(k), l
              end if
            end if
          end do
          write(line(35:),'(a, i6, a)')" =", ninres, " atoms"
          het_group = trim(line)
!
!  Make sure all oxygen atoms are counted
!
          kk = ninres
          do ii = 1, kk
            k = inres(ii)
            if (nat(k) /= 6) cycle
            jj = ibonds(nbonds(k) + 1,k)
            if (jj > 0) then
              if (nat(jj) == 8) then
                if (distance(k,jj) < 1.9d0) then
                  do k = 1, ninres
                    if (inres(k) == jj) exit
                  end do
                  if (k > ninres) then
                    n_O = n_O + 1
                    ninres = ninres + 1
                    inres(ninres) = jj
                  end if
                end if
              end if
            end if
          end do
          select case (n_C)
            case (0)
              j = 0
              do k = 1, ninres
                if (nat(inres(k)) /= 1) then
                  j = j + 1
                  l = inres(k)
                end if
              end do
              if (ninres == 1) then
                j = 0
                select case (nat(i))
                  case(3:4, 11:12, 19:30, 37:48, 55:80)
                    j = 1
                end select
                if (j == 1 .or. nbonds(i) == 0) then
                  het = " "//cap_elemnt(nat(inres(1)))
                  if (het(3:3) >= "a" .and. het(3:3) <= "z") het(3:3) = char(ichar(het(3:3)) + ichar("A") - ichar("a"))
                  het_group = "Isolated element"
                else if (nbonds(i) > 0) then
                  het = " "//cap_elemnt(nat(inres(1)))
                  if (het(3:3) >= "a" .and. het(3:3) <= "z") het(3:3) = char(ichar(het(3:3)) + ichar("A") - ichar("a"))
                  het_group = "Covalently bound element"
                end if
                k = ibonds(1,i)
                if (nbonds(i) == 1) then
                  if (txtatm(k) /= " ") then
                    el = cap_elemnt(nat(i))
                    if (el(2:2) == " ") el = " "//el(1:1)
                    if (nat(i) == 1) then
                      txtatm(i) = txtatm(k)(:12)//" H"//txtatm(k)(15:)
                    else
!
!  A single element is bonded to something.
!  If possible, use the original label (in txtatm1), if not, then use the label of the atom it's attached to.
!
                      if (txtatm1(i) == " ") then
                        j = nint(reada(txtatm(k), 21)) + 1
                        write(line,'(8x,i4)')j
                      else
                        line =txtatm1(i)(15:)
                      end if
                      if(cap_elemnt(nat(i))(2:2) == " ") then
                        txtatm(i) = txtatm(k)(:12)//" "//cap_elemnt(nat(i))(1:1)//trim(line)
                      else
                        txtatm(i) = txtatm(k)(:12)//cap_elemnt(nat(i))//txtatm(k)(15:)
                      endif
                    end if
                    cycle
                  end if
                end if
              end if
              if (ninres == 2 .and. n_O == 1 .and. n_ele(1) == 1) then
                het = " OH"
                het_group = "Hydroxide ion"
              end if
              if (ninres == 3 .and. n_O == 1 .and. n_ele(1) == 2) then
                het = "H2O"
                het_group = "Complexed water"
              end if
              if (nat(l) == 7) then
                if (nheavy(l) > 1) then
                  do k = 1, nbonds(l)
                    j = ibonds(k,l)
                    if (nat(j) /= 6) cycle
!
!  Found carbon attached to nitrogen
!
                      do m = 1, nbonds(j)
                        if (nat(ibonds(m,j)) == 8) exit
                      end do
                      if (m <= nbonds(j)) then
                        write(txtatm(l),"(a6,i5,a3,a12)")txtatm(j)(:6), l, "  N", txtatm(j)(15:)
                        cycle i_loop
                      end if
                  end do
                else
                  het = "NH3"
                  het_group = "Ammonia"
                end if
              end if
              if  (n_N == 0 .and. n_O == 2 .and. n_S == 0 .and. n_P == 0) then
                het = "O-O"
                het_group = "Hydrogen peroxide?"
              end if
             if  (n_N == 1 .and. n_O == 3 .and. n_S == 0 .and. n_P == 0) then
                het = "NO3"
                het_group = "Nitrate"
              end if
             if  (n_P == 1 .and. n_O == 4 .and. n_S == 0) then
                het = "PO4"
                het_group = "Phosphate"
              end if
            case (1)
              if  (n_N == 0 .and. n_O == 1 .and. n_S == 0 .and. n_P == 0) then
                het = "MOH"
                het_group = "Methanol"
              end if
              if  (n_N == 0 .and. n_O == 2 .and. n_S == 0 .and. n_P == 0) then
                het = "FMT"
                het_group = "Formic acid"
              end if
              if  (n_N == 0 .and. n_O == 3 .and. n_S == 0 .and. n_P == 0) then
                het = "CO3"
                het_group = "Carbonate ion"
              end if
              if  (n_N == 1 .and. n_O == 0 .and. n_S == 0 .and. n_P == 0) then
                het = "CYN"
                het_group = "Cyanide ion"
              end if
              if  (n_N == 0 .and. n_O == 0 .and. n_ele(1) == 3 .and. n_S == 0 .and. n_P == 0) then
                het = "CH3"
                het_group = "Methyl group"
              end if
              if  (n_N == 2 .and. n_O == 1 .and. n_ele(1) == 4 .and. n_S == 0 .and. n_P == 0) then
                het = "URE"
                het_group = "UREA"
              end if
            case (2)
              if  (n_N == 0 .and. n_O == 1 .and. n_S == 0 .and. n_P == 0) then
                het = "EOH"
                het_group = "Ethanol"
              else if (n_N == 0 .and. n_O == 2 .and. n_S == 0 .and. n_P == 0) then
                do ii = 1, ninres
                  if (nat(inres(ii)) == 6) exit
                end do
                if (nheavy(inres(ii)) == 2) then
                  het = "EDO"
                  het_group = "1,2-Ethanediol "
                else
                  het = "ACY"
                  het_group = "Acetic acid "
                end if
              end if
            case (3)
              if  (n_N == 0 .and. n_O == 2 .and. n_S == 0 .and. n_P == 0) then
                het = "PGO"
                het_group = "S-1,2-Propanediol"
              end if
              if  (n_N == 0 .and. n_O == 3 .and. n_S == 0 .and. n_P == 0) then
                het = "GOL"
                het_group = "Glycerol"
              end if
              if  (n_N == 0 .and. n_O == 4 .and. n_S == 0 .and. n_P == 0) then
                het = "MLI"
                het_group = "Malonate ion (-)"
              end if
              if  (n_N == 2 .and. n_O == 0 .and. n_S == 0 .and. n_P == 0) then
                het = "IMD"
                het_group = "Imidazole"
              end if
            case (4)
              if  (n_N == 0 .and. n_O == 3 .and. n_S == 0 .and. n_P == 0) then
                het = "PEG"
                het_group = "Di(hydroxyethyl) ether"
              end if
              if  (n_N == 0 .and. n_O == 6 .and. n_S == 0 .and. n_P == 0) then
                het = "TLA"
                het_group = "L(+)-Tartaric acid"
              end if
              if  (n_N == 1 .and. n_O == 0 .and. n_S == 0 .and. n_P == 0) then
                het = "NTB"
                het_group = "N-Tertiary butyl"
              end if
              if  (n_N == 1 .and. n_O == 3 .and. n_S == 0 .and. n_P == 0) then
                het = "TRS"
                het_group = "2-Amino-2-hydroxymethyl-propane-1,3-diol"
              end if
            case (5)
              if  (n_N == 1 .and. n_O == 3 .and. n_S == 0 .and. n_P == 0) then
                het = "PCA"
                het_group = "Pyroglutamic acid"
              end if
              if  (n_N == 1 .and. n_O == 7 .and. n_S == 0 .and. n_P == 0) then
                het = "10E"
                het_group = "4-Amino-3-methylbut-2-en-1-yl diphosphate"
              end if
            case (6)
               if  (n_N == 0 .and. n_O == 1 .and. n_P == 0) then
                het = "IPH"
                het_group = "Phenol"
              end if
               if  (n_N == 0 .and. n_O == 1 .and. n_P == 1) then
                het = "HXP"
                het_group = "Hexyl bonded to phosphorus"
              end if
              if  (n_N == 0 .and. n_O == 2 .and. n_S == 0 .and. n_P == 0) then
                het = "RCO"
                het_group = "Resorcinol"
              end if
              if  (n_N == 0 .and. n_O == 9 .and. n_P == 0) then
                het = "SGA"
                het_group = "O3-Sulfonylgalactose"
              end if
              if  (n_N == 0 .and. n_O == 5 .and. n_S == 0 .and. n_P == 0) then
                het = "FUC"
                het_group = "Alpha-L-fucose"
              end if
              if  (n_N == 0 .and. n_O == 6 .and. n_S == 0 .and. n_P == 0) then
                het = "HEX"
                het_group = "A hexose, e.g. glucose or mannose"
                call identify_hexose(ninres, inres, het, het_group)
              end if
              if  (n_N == 0 .and. n_O == 2 .and. n_S == 0 .and. n_P == 0) then
                het = "MPD"
                het_group = "(4S)-2-Methyl-2,4-pentanediol"
              end if
              if  (n_N == 0 .and. n_O == 4 .and. n_S == 0 .and. n_P == 0) then
                het = "PGE"
                het_group = "Triethylene glycol"
              end if
              if  (n_N == 1 .and. n_O == 4 .and. n_P == 0) then
                het = "MES"
                het_group = "2-(N-Morpholino)-ethanesulfonic acid"
              end if
            case (7)
              if  (n_N == 1 .and. n_O == 1 .and. n_S == 0 .and. n_P == 0) then
                het = "DBZ"
                het_group = "Benzoylamino (H6C7NO)"
              end if
              if  (n_N == 1 .and. n_O == 3 .and. n_S == 0 .and. n_P == 0) then
                het = "TAM"
                het_group = "Tris(hydroxyethyl) aminomethane"
              end if
            case (8)
              if  (n_N == 0 .and. n_O == 0 .and. n_S == 0 .and. n_P == 0) then
                het = "OCT"
                het_group = "N-Octane"
              end if
              if  (n_N == 0 .and. n_O == 5 .and. n_S == 0 .and. n_P == 0) then
                het = "PG4"
                het_group = "Tetraethylene glycol"
              end if
              if  (n_N == 0 .and. n_O == 1 .and. n_S == 0 .and. n_P == 0) then
                het = "0VT"
                het_group = "6-Methyl-5-hepten-2-one"
              end if
              if  (n_N == 1 .and. (n_O > 3 .and. n_O < 7) .and. n_S == 0 .and. n_P == 0) then
                het = "NAG"
                het_group = "N-Acetyl-D-glucosamine"
              end if
              if  (n_N == 1 .and. n_O == 0 .and. n_S == 0 .and. n_P == 0) then
                het = "TBA"
                het_group = "Tetrabutylammonium ion"
              end if
              if  (n_N == 1 .and. n_O == 2 .and. n_P == 0) then
                het = "AES"
                het_group = "4-(2-Aminoethyl)benzenesulfonyl fluoride"
              end if
              if  (n_N == 2 .and. n_O == 4 .and. n_P == 0) then
                het = "EPE"
                het_group = "Hepes (C8 H18 N2 O4 S)"
              end if
            case (9)
              if  (n_N == 1 .and. n_O == 2 .and. n_ele(17) == 1.and. n_S == 0 .and. n_P == 0) then
                het = "GM5"
                het_group = "4-Chlorocinnamylhydroxamate"
              end if
              if  (n_N == 3 .and. n_O == 13 .and. n_S == 0 .and. n_P == 3) then
                het = "DCP"
                het_group = "2'-deoxycytidine-5'-triphosphate"
              end if
              if (n_N == 3 .and. n_O == 14 .and. n_S == 0 .and. n_P == 3) then
                het = "CTP"
                het_group = "Cytidine-5'-triphosphate"
              end if
              if (n_N == 2 .and. n_O == 15 .and. n_S == 0 .and. n_P == 3) then
                het = "UTP"
                het_group = "Uridine-5'-triphosphate"
              end if
            case (10)
              if  (n_N == 0 .and. n_O == 6 .and. n_S == 0 .and. n_P == 0) then
                het = "TSA"
                het_group = "Endo-oxabicyclic transition state analogue"
              end if
              if  (n_N == 1 .and. n_O == 1 .and. n_S == 0 .and. n_P == 0) then
                het = "T55"
                het_group = "8-Methylnonanoic acid"
              end if
              if (n_N == 1 .and. n_O == 3 .and. n_S == 0) then
                het = "VPF"
                het_group = "C22 H32 N3 O8 P (incomplete)"
              end if
              if (n_N == 2 .and. n_O == 14 .and. n_S == 0 .and. n_P == 3) then
                het = "TTP"
                het_group = "Thymidine-5'-triphosphate"
              end if
              if (n_N == 5 .and. n_O == 10 .and. n_S == 0 .and. n_P == 2) then
                het = "ADP"
                het_group = "Adenosine-5'-diphosphate"
              end if
              if (n_N == 5 .and. n_O == 13 .and. n_S == 0 .and. n_P == 3) then
                het = "ATP"
                het_group = "Adenosine-5'-triphosphate"
              end if
              if (n_N == 5 .and. n_O == 14 .and. n_S == 0 .and. n_P == 3) then
                het = "GTP"
                het_group = "Guanosine-5'-triphosphate"
              end if
              if  (n_N == 6 .and. n_O == 12 .and. n_S == 0) then
                het = "ANP"
                het_group = "Phosphoaminophosphonic acid-adenylate ester"
              end if
            case (13)
              if  (n_N == 2 .and. n_O == 0 .and. n_S == 0 .and. n_P == 0) then
                het = "THA"
                het_group = "Tacrine"
              end if
            case (14)
              if  (n_N == 0 .and. n_O == 4 .and. n_S == 0 .and. n_P == 0) then
                het = "HKA"
                het_group = "3-Methoxy-4-phenoxybenzoic acid"
              end if
            case (15)
              if  (n_N == 1 .and. n_O == 5 .and. n_S == 0) then
                het = "1CT"
                het_group = "Oxo-trifluoro methyl phenyl ethoxy "// &
                  &"phenyl phosphonic acid"
              end if
              if  (n_N == 2 .and. n_O == 12 .and. n_S == 0 .and. n_P == 2) then
                het = "5GW"
                het_group = "5-Phenyluridine 5'-(trihydrogen diphosphate)"
              end if
            case (16)
              if  (n_N == 2 .and. n_O == 11 .and. n_S == 0 .and. n_P == 0) then
                het = "NA2"
                het_group = "N-Acetyl-D-glucosamine, dimer"
              end if
              if  (n_N == 0 .and. n_O == 1 .and. n_S == 0 .and. n_P == 0) then
                het = "BOM"
                het_group = "Hexadecyl-10,12-dien-1-ol"
              end if
            case (17)
              if (n_N == 4 .and. n_O == 9 .and. n_S == 0 .and. n_P == 1) then
                het = "FMN"
                het_group = "Riboflavin monophosphate "
              end if
              if (n_N == 2 .and. n_O == 2) then
                het = "641"
                het_group = "Oxopyrrolidine-3-carboxamide"
              end if
            case (18)
              if (n_N == 2 .and. n_O == 0) then
                het = "HUX"
                het_group = "(-)-Huprine X (C18 H19 N2 Cl)"
              end if
            case (19)
              if (n_N == 0 .and. n_O == 2) then
                het = "ASD"
                het_group = "4-Androstene-3-17-dione"
              end if
              if (n_N == 4 .and. n_O == 2) then
                het = "PNT"
                het_group = "1,5-Bis(4-amidinophenoxy)pentane"
              end if
            case (20)
              if (n_N == 0 .and. n_O == 1) then
                het = "ARC"
                het_group = "3,7,11,15-Tetramethyl-hexadecan-1-ol"
              end if
              if (n_N == 0 .and. n_O == 10) then
                het = "BHE"
                het_group = "Galactopyranoside"
              end if
              if (n_N == 4 .and. n_O == 2) then
                het = "DID"
                het_group = "4,4'[1,6-Hexanediylbis(oxy)]"// &
                &"bisbenzenecarboximidamide"
              end if
              if (n_N == 7 .and. n_O == 9) then
                het = "BT5"
                het_group = "Biotinyl-5-amp"
              end if
            case (21)
              if (n_N == 2 .and. n_O == 17 .and. n_P == 2) then
                het = "2GW"
                het_group = "5-Phenyl-uridine-5'-alpha-D-galactosyl-diphosphate"
              end if
              if (n_N == 7 .and. n_O == 14) then
                het = "NAD"
                het_group = "Nicotinamide-adenine-dinucleotide"
              end if
              if (n_N == 7 .and. n_O == 17 .and. n_P > 0) then
                het = "NAP"
                het_group = "Nicotinamide-adenine-dinucleotide phosphate"
              end if
              if (n_N == 10 .and. n_O == 1) then
                het = "32G"
                het_group = "C21 H30 N10 O S"
              end if
            case (22)
              if (n_N == 2 .and. n_O == 2) then
                het = "CZM"
                het_group = "3,3'-Me2-salophen"
              end if
              if (n_N == 3 .and. n_O == 8) then
                het = "VPF"
                het_group = "C22 H32 N3 O8 P"
              end if
            case (23)
              if (n_N == 0 .and. n_O == 11) then
                het = "CM5"
                het_group = "5-Cyclohexyy-1-pentyl-beta-d-maltoside"
              end if
              if (n_N == 3 .and. n_O == 3) then
                het = "4A2"
                het_group = "C23 H17 F4 N3 O3"
              end if
            case (26)
              if (n_N == 0 .and. n_O == 8) then
                het = "0DV"
                het_group = "Fusicoccin H"
              end if
            case (34)
              if (n_N == 4 .and. n_O == 4) then
                het = "HEM"
                het_group = "Heme ring"
              end if
          end select
          if (n_ele(15) > 3) then
            het = "NUC"
            het_group = "Nucleic acid (DNA or RNA type)"
          end if
          l = index(keywrd, " XENO")
          if (l /= 0) then
            l_chain = (index(keywrd, " CHAINS=(") == 0)
            j = index(keywrd(l:), ") ")
            if (j /= 0) then
              line = " "//keywrd(l + 5:j + l - 1)
              do
                do l = 1, 10
                  line = trim(line(2:))
                  if (line(1:1) == "(" .or. line(1:1) == "," .or. line(1:1) == ";" .or. line(1:1) == ")") exit
                end do
                if (line == " ") exit
                num = line(2:2)
                k = 0
                if (l_chain) then
                  if (num >= "A" .and. num <= "Z") then
                    if (txtatm1(i)(22:22) >= "A" .and. txtatm1(i)(22:22) <= "Z") then
                      if (num /= txtatm1(i)(22:22)) k = -1000
                    end if
                  end if
                end if
                k = nint(reada(line,1)) + k
                if (k == ires) then
                  do l = 1, 10
                    if (line(1:1) == "=") exit
                    line = trim(line(2:))
                  end do
                  if (het_group(1:3) /= "Not") then
                    line1 = "Defined using keyword XENO as "//trim(het_group)
                    het_group = trim(line1)
                  end if
                  if (l_write) then
                    if (first) then
                      first = .false.
                      write(iw,'(/,a)') "      Ligand names that have been changed by XENO keyword"
                      write(iw,'(/,a)') "      Residue No.  Calculated name   XENO name"
                    end if
                      change_no = change_no + 1
                      write(iw,'(i3,i9,3x,a1,8x,a3,13x,a3)')change_no, ires, num, het, line(2:4)
                      het = line(2:4)
                      exit
                    end if
                  end if
              end do
            end if
          end if
          if (nat(i) /= 1 .or. nbonds(i) /= 1) then
            if (ncomments < max_comments .and. index(keywrd, " RESID") /= 0) then
              ncomments = ncomments + 1
              if (index(het_group, "XENO") == 0 ) then
                write(line,'(a,i4)') "*REMARK   3 "//het//" = "//trim(het_group)//" res: ", ires
              else
                write(line,'(a,i4)') "*REMARK   3 "//het//" = "//trim(het_group)//"   res: ", ires
              end if
              j = len_trim(line)
              if (j > 80) then
                j = index(line, "XENO")
                write(all_comments(ncomments),'(a)') line(1:j +7)
                ncomments = ncomments + 1
                write(all_comments(ncomments),'(a)') "*REMARK   3"//trim(line(j + 7:))
              else
                write(all_comments(ncomments),'(a)') trim(line)
              end if
              if (log) then
                 write(ilog,'(a)')  trim(line)
                 if (het == "HET")  write(ilog,'(20x,a,i5,a)')" (Includes atom number:", inres(1),")"
              end if
            end if
            do j = 1, ninres
              k = inres(j)
              el = cap_elemnt(nat(k))
              if (el(2:2) == " ") el = " "//el(1:1)
              if (attached) then
                write (txtatm(k), "(a6,i5,a3,a6,i6)")"ATOM  ", k, " "//el, het, res
              else
                write (txtatm(k), "(a6,i5,a3,a6,i6)")"HETATM", k, " "//el, het, ires
              end if
            end do
          end if
        else
          do j = 1, ninres
            k = inres(j)
            el = cap_elemnt(nat(k))
            if (el(2:2) == " ") el = " "//el(1:1)
            write(txtatm(k),"(a6,i5,a3,a6,i6)")"HETATM", k, " "//el, "UNK", ires
          end do
          call inc_res(ires, start_res, nfrag)
        end if
      end if
    end do i_loop
!
!  Label any remaining atoms
!
    do i = 1, natoms - id
      if (txtatm(i) (26:26) == " ") then
        el = cap_elemnt(nat(i))
        if (el(2:2) == " ") el = " "//el(1:1)
        if (el == " H" .and. i > 1 .and. nbonds(i) == 1) then
          j = ibonds(1,i)
          write(txtatm(i),"(a6,i5,a3,a6)")txtatm(j)(:6), j, " "//el, txtatm(j)(18:20)
        else
         write(txtatm(i),"(a6,i5,a3,a6)")"HETATM", i, " "//el, "UNK"
        end if
      end if
    end do
    l_write = .false.
    return
end subroutine ligand
subroutine moiety (iopt, lused, istart, new)
    use molkst_C, only: numat, natoms
    use common_arrays_C, only : nat, nbonds, ibonds
    use chanel_C, only: iw
    use elemts_C, only: elemnt
!
!.. Implicit Declarations ..
    implicit none
!
!.. Formal Arguments ..
    integer, intent (in) :: istart
    integer, intent (inout) :: new
    logical, dimension (numat), intent (inout) :: iopt
    integer, dimension (natoms), intent (inout) :: lused
!
!.. Local Scalars ..
    integer :: i2, i3, iatom, j, j2, k, l, ninbit, nlive
!
!.. Local Arrays ..
    integer, allocatable :: live(:), inres(:)
!
! ... Executable Statements ...
!
   i2 = max(2000, natoms*2)
    allocate (live(i2), inres(i2))
    inres = 0
    iatom = istart
!
!   The first atom identified in the moiety is atom IATOM.
!
    iopt(iatom) = .true.
!
!  NOW TO WORK OUT THE ATOMS IN THE MOIETY
!
    nlive = nbonds(iatom)
    if (nlive == 0) then
      ninbit = 1
      inres(1) = iatom
    else
      ninbit = 0
      do i2 = 1, nlive
        live(i2) = ibonds(i2, iatom)
      end do
      do
        l = live(1)
        if (iopt(l) .or. l == iatom) then
          if (nlive < 1) exit
          live(1) = live(nlive)
          nlive = nlive - 1
        else
          iopt(l) = .true.
          ninbit = ninbit + 1
          if (ninbit > natoms) then
            write (iw, "(A,I4,A)") " There are more than", natoms, &
                 & " atoms in moiety "
            write (iw,*) " Atoms in moiety"
            write (iw, "(10(1X,A2,I5))") (elemnt(nat(inres(l))), inres(l), &
                 & l=1, natoms)
            call mopend ("Too many atoms in moiety")
            return
          end if
          inres(ninbit) = l
          if (nbonds(l) /= 0) then
!
!  THERE IS AT LEAST ONE ATOM ATTACHED TO THE 'LIVE' ATOM
!
            loop: do i2 = 2, nbonds(l)
              j = ibonds(i2, l)
              do i3 = 1, nlive
                if (live(i3) == j) cycle loop
              end do
              nlive = nlive + 1
              live(nlive) = j
            end do loop
            live(1) = ibonds(1, l)
          else
            if (nlive == 0) exit
            live(1) = live(nlive)
            nlive = nlive - 1
          end if
        end if
      end do
    end if
!
!   Check that atoms are not counted twice
!
    do j = 1, ninbit
      do k = j + 1, ninbit
        if (inres(j) == inres(k)) then
          inres(j) = 0
        end if
      end do
    end do
!
!  Put hydrogen atoms at the end of the list
!
    k = ninbit
    do j = 1, ninbit
      l = inres(j)
      if (l /= 0) then
        if (nat(l) == 1) then
          k = k + 1
          inres(k) = l
          inres(j) = 0
        end if
      end if
    end do
    ninbit = k
    if (iatom /= 0) then
      new = new + 1
      lused(new) = iatom
      iopt(iatom) = .true.
    end if
    do i2 = 1, ninbit
      j2 = inres(i2)
      if (j2 /= 0 .and. j2 /= iatom) then
        new = new + 1
        lused(new) = j2
      end if
    end do
!
!  If more than one hydrogen is attached to an atom, then the order of the hydrogen atoms is incorrect.
!  To correct this, the sequence of hydrogen atoms is reversed.  This is necessary in order to prevent
!  hydrogen atoms being swapped around by repeated calls to RESEQ.
!
    do j = 1, new
      if (nat(lused(j)) == 1) exit
    end do
    if (j > -new) return
!
! Start of hydrogen atoms = j
!
    k = j
    do
      do
        k = k + 1
        if (k == new) exit
        if (ibonds(1,lused(k)) /= ibonds(1,lused(j))) then
          k = k - 1
          exit
        end if
      end do
      if (k - j > 0) then
!
!  Two or three hydrogen atoms attached to the same atom
!  Swapping the atoms around is unusually simple!
!
        i2 = lused(j)
        lused(j) = lused(k)
        lused(k) = i2
      else
        k = k + 1
      end if
      if (k == new) exit
      j = k
    end do
    return
end subroutine moiety
integer function nheavy(icc)
  use common_arrays_C, only : nat, nbonds, ibonds
  implicit none
  integer, intent (in) :: icc
  integer :: i, n
  n = 0
  do i = 1, nbonds(icc)
    if (nat(ibonds(i,icc)) > 1) n = n + 1
  end do
  nheavy = n
  return
end function nheavy
subroutine identify_hexose(ninres, inres, nam, name)
  use common_arrays_C, only : nat, nbonds, ibonds, coord
  use funcon_C, only : pi
  implicit none
  integer, intent (in) :: ninres, inres(ninres)
  character, intent (inout) :: nam*3, name*60
!
!  Identify hexose by looking at the five chiral sites, C1 - C5
!  Assume that hexose exists as hemi-acetal
!
  double precision :: torsion
  integer :: i, j, k, l, m, backbone(6), C1, Cn, Cm, Cp, On, Hn, chiral(6)
  integer, external :: nheavy
  character :: hexose_aldose(8)*9, hexose_ketose(4)*9
  logical :: aldose
  data hexose_aldose /"Allose   ", "Altrose  ", "Glucose  ", "Mannose  ", &
    "Gulose   ", "Idose    ", "Galactose", "Talose   "/
   data hexose_ketose /"Psicose  ", "Fructose ", "Sorbose ", "Tagatose "/
   C1 = 0
   l = 0
   m = 0
!
! First, check that all carbon atoms have four ligands
!
    do i = 1, ninres
      if (nat(inres(i)) == 6) then
        if (nbonds(inres(i)) /= 4) then
          if (nbonds(inres(i)) < 3) return
          j = inres(i)
          k = ibonds(4,j)
          if (k == 0) return
          if (nat(k) /= 8) return
        end if
      end if
    end do
    aldose = .true.
!
!  Locate C1
!
    do i = 1, ninres
      if (nat(inres(i)) == 6) then
        C1 = inres(i)
        k = 0
        do j = 1, 4
          if (nat(ibonds(j,C1)) == 8) k = k + 1
        end do
        if (k == 2) exit
      end if
    end do
    do i = 1, nbonds(C1)
      if (nat(ibonds(i,C1)) == 6) then
        j = ibonds(i,C1)
        if (nheavy(j) == 2) then
          l = 0
          do k = 1, nbonds(j)
            if (nat(ibonds(k,j)) == 8) l = l + 1
          end do
          if (l == 1) then
            C1 = j
            aldose = .false.
            exit
          end if
        end if
      end if
    end do
    backbone(1) = C1
    Cn = C1
    Cm = Cn
!
!  Now locate C2 - C6
!
    do i = 2, 6
      do j = 1, 4
        l = ibonds(j,Cn)
        if (l == 0) return
        if (nat(l) == 6 .and. l /= Cm) exit
      end do
      backbone(i) = l
      Cm = backbone(i - 1)
      Cn = l
    end do
    chiral = 0
!
!  Work out chirality of C1
!
    On = 0
    do i = 1, 4
      j = ibonds(i,C1)
       if (j == 0) return
      if (nat(j) == 8 .and. nheavy(j) == 2) then
!
!   Make sure that the atom the oxygen is attached to is not in the ring
!
        do l = 1, nbonds(j)
          m = ibonds(l,j)
           if (m == 0) return
           if (nat(m) > 1 .and. m /= C1) exit
        end do
        do l = 1, ninres
          if (inres(l) == m) exit
        end do
        if (l > ninres) On = j
      end if
      if (nat(j) == 8 .and. nheavy(j) == 1) On = j
      if (nat(j) == 1                     ) Hn = j
    end do
    if (On == 0) return!  Failed to find oxygen
    Cp = backbone(2)
    call dihed (coord, Hn, Cp, C1, On, torsion)
    if (torsion > pi) torsion = torsion - 2*pi
    if (torsion < 0) chiral(1) = 1
!
!  Work out chirality of C2 - C5
!
    do k = 2, 5
      Cn = backbone(k)
      Cp = backbone(k + 1)
      l = 0
      do i = 1, 4
        if (nat(ibonds(i,Cn)) == 8) l = l + 1
      end do
      do i = 1, 4
        j = ibonds(i,Cn)
        if (l == 1) then
          if (nat(j) == 8) On = j
          if (nat(j) == 1) Hn = j
        else
          if (nat(j) == 8 .and. nheavy(j) == 2) Hn = j
          if (nat(j) == 8 .and. nheavy(j) == 1) On = j
        end if
      end do
      call dihed (coord, Hn, Cn, Cp, On, torsion)
      if (torsion > pi) torsion = torsion - 2*pi
      if (torsion > 0) chiral(k) = 1
    end do
!
!  Determine the hexose
!
    if (aldose) then
      i = chiral(2) + 2*chiral(3) + 4*chiral(4) + 1
      name = hexose_aldose(i)
    else
      i = chiral(3) + 2*chiral(4) + 1
      name = hexose_ketose(i)
    end if
    if (chiral(5) == 0) then
      name = "D-"//trim(name)
    else
      name = "L-"//trim(name)
    end if
    if (aldose) then
      if (chiral(1) == 0) then
        name = "alpha-"//trim(name)
      else
        name = "beta-"//trim(name)
      end if
    else
      if (chiral(2) == 0) then
        name = "alpha-"//trim(name)
      else
        name = "beta-"//trim(name)
      end if
    end if
    select case(name)
      case("alpha-D-Allose")
        nam = "ALO"
      case("alpha-D-Altrose")
        nam = "ALT"!
      case("alpha-D-Glucose")
        nam = "GLC"
      case("alpha-D-Mannose")
        nam = "MAN"!
      case("alpha-D-Gulose")
        nam = "GUL"!
      case("alpha-D-Idose")
        nam = "IDO"!
      case("alpha-D-Galactose")
        nam = "GAL"!
      case("alpha-D-Talose")
        nam = "TAL"!
      case("beta-D-Allose")
        nam = "BAL"
      case("beta-D-Altrose")
        nam = "BAT"!
      case("beta-D-Glucose")
        nam = "BGC"
      case("beta-D-Mannose")
        nam = "BMA"!
      case("beta-D-Gulose")
        nam = "BGU"!
      case("beta-D-Idose")
        nam = "BID"!
      case("beta-D-Galactose")
        nam = "BGA"!
      case("beta-D-Talose")
        nam = "BTA"!
      case("alpha-D-Psicose")
        nam = "ADP"!
      case("alpha-D-Fructose")
        nam = "ADF"!
      case("alpha-D-Sorbose")
        nam = "ADS"!
      case("alpha-D-Tagatose")
        nam = "ADT"!
    end select
  end subroutine identify_hexose
  subroutine inc_res(ires, start_res, nfrag)
    implicit none
    integer, intent (inout) :: ires, nfrag
    integer, intent (in) :: start_res(*)
!
    if (start_res(max(1,nfrag)) /= -200) then
      ires = start_res(nfrag)
      nfrag = nfrag + 1
    end if
    ires = ires + 1
    return
  end subroutine inc_res

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine frame(fmat, numat, mode)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use common_arrays_C, only : coord, atmass
      use molkst_C, only : id, n_trivial => itemp_2
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: numat
      integer  :: mode
      double precision , intent(inout) :: fmat(*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j, k, n3, l
      double precision, dimension(6,3*numat) :: vib
      double precision, dimension(3,3) :: rot
      double precision :: shift(6)
      double precision, dimension(3,numat) :: coord1
      double precision :: sum, wtmass, x, y, z, sums(6)
!-----------------------------------------------
!**********************************************************************
!
!   FRAME APPLIES AN RIGID ORIENTATION TO THE MOLECULE IN A FORCE
!         CALCULATION. THE TRANSLATIONS ARE GIVEN A 'FORCE CONSTANT'
!         OF T(X)=500 MILLIDYNES/ANGSTROM
!            T(Y)=600 MILLIDYNES/ANGSTROM
!            T(Z)=700 MILLIDYNES/ANGSTROM
!         AND THE ROTATIONS ARE GIVEN A 'FORCE CONSTANT' OF
!            R(X)=800 MILLIDYNES/ANGSTROM
!            R(Y)=900 MILLIDYNES/ANGSTROM
!            R(Z)=1000 MILLIDYNES/ANGSTROM,
!    THE ROTATIONS ARE MADE ABOUT AXES DETERMINED BY THE MOMENTS
!    OF INERTIA, WHICH IN TURN DEPEND ON THE ISOTOPIC MASSES. FOR
!    THE NORMAL FREQUENCY CALCULATION THESE ARE THE REAL MASSES,
!    FOR THE FORCE CALCULATION THEY ARE ALL UNITY.
!**********************************************************************
      call axis (x, y, z, rot)
      do i = 1, numat
        do j = 1, 3
          sum = 0.D0
          do k = 1, 3
            sum = sum + coord(k,i)*rot(k,j)
          end do
          coord1(j,i) = sum
        end do
      end do
      n3 = numat*3
      j = 0
      wtmass = 1.D0
      if (mode == 1) then
        do i = 1, numat
          wtmass = sqrt(atmass(i))
          j = j + 1
          vib(1,j) = wtmass
          vib(2,j) = 0.D0
          vib(3,j) = 0.D0
          vib(4,j) = 0.D0
          vib(5,j) = coord1(3,i)*wtmass
          vib(6,j) = coord1(2,i)*wtmass
          j = j + 1
          vib(1,j) = 0.D0
          vib(2,j) = wtmass
          vib(3,j) = 0.D0
          vib(4,j) = coord1(3,i)*wtmass
          vib(5,j) = 0.D0
          vib(6,j) = -coord1(1,i)*wtmass
          j = j + 1
          vib(1,j) = 0.D0
          vib(2,j) = 0.D0
          vib(3,j) = wtmass
          vib(4,j) = -coord1(2,i)*wtmass
          vib(5,j) = -coord1(1,i)*wtmass
          vib(6,j) = 0.D0
        end do
      else
! Translation along "x"
        vib(1,j+1:numat*3-2+j:3) = wtmass
        vib(1,j+2:numat*3-1+j:3) = 0.D0
        vib(1,j+3:numat*3+j:3) = 0.D0
! Translation along "y"
        vib(2,j+1:numat*3-2+j:3) = 0.D0
        vib(2,j+2:numat*3-1+j:3) = wtmass
        vib(2,j+3:numat*3+j:3) = 0.D0
! Translation along "z"
        vib(3,j+1:numat*3-2+j:3) = 0.D0
        vib(3,j+2:numat*3-1+j:3) = 0.D0
        vib(3,j+3:numat*3+j:3) = wtmass
! Rotation about "x"
        vib(4,j+1:numat*3-2+j:3) = 0.D0
        vib(4,j+2:numat*3-1+j:3) =  coord1(3,:numat)*wtmass
        vib(4,j+3:numat*3+j:3)   = -coord1(2,:numat)*wtmass
! Rotation about "y"
        vib(5,j+1:numat*3-2+j:3) =  coord1(3,:numat)*wtmass
        vib(5,j+2:numat*3-1+j:3) =  0.D0
        vib(5,j+3:numat*3+j:3)   = -coord1(1,:numat)*wtmass
! Rotation about "z"
        vib(6,j+1:numat*3-2+j:3) =  coord1(2,:numat)*wtmass
        vib(6,j+2:numat*3-1+j:3) = -coord1(1,:numat)*wtmass
        vib(6,j+3:numat*3+j:3)   =  0.D0
      end if
!
! Unitary transform to rotate vibrations into frame of moments of inertia.
!
      j = 1
      do i = 1, numat
        do k = 4, 6
          x = vib(k,j)
          y = vib(k,j+1)
          z = vib(k,j+2)
          vib(k,j)   = x*rot(1,1) + y*rot(1,2) + z*rot(1,3)
          vib(k,j+1) = x*rot(2,1) + y*rot(2,2) + z*rot(2,3)
          vib(k,j+2) = x*rot(3,1) + y*rot(3,2) + z*rot(3,3)
        end do
        j = j + 3
      end do
      sums = 0.D0
      do i = 1,n3
        sums(:) = sums(:) + vib(:,i)**2
      end do
      if (n_trivial == 5) then
        sum = 0.01d0 + Min(sums(1), sums(2), sums(3), sums(4), sums(5), sums(6))  ! System is linear, so don't use one mode
        do i = 1,6
          if (sums(i) > sum) sums(i) = sqrt(1.D0/sums(i))
        end do
      else
        sums = sqrt(1.d0/sums)
      end if

      if (id /= 0) sums(4:6) = 0.D0

      do i = 1, 6
        vib(i,:n3) = vib(i,:n3)*sums(i)
        shift(i) = 40000.D0 + i*100.D0
      end do
      l = 0
      do i = 1, n3
        do j = 1, i
          l = l + 1
          sum = 0.D0
          do k = 1, 6
            sum = sum + vib(k,i)*shift(k)*vib(k,j)
          end do
          fmat(l) = fmat(l) + sum
        end do
      end do
      return
      end subroutine frame

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine datin(ir, iw)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE parameters_C, only : partyp, n_partyp, n_partyp_alpb, v_par, t_par
      use Common_arrays_C, only : ijpars, parsij
      use molkst_C, only : keywrd, keywrd_quoted, lpars, line, backslash
      use chanel_C, only : iext
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
      integer, intent(in) :: iw, ir
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------

      integer :: i, j, l, iparam, k, ielmnt, jelmnt, nref, &
      loop, mpar

      double precision :: param
      logical :: exists, lv_par(60) = .false.
      character (len=500), dimension (10) :: file
      character :: text*80,  ch*1
      character, dimension(107) :: elemnt*2
      character, external :: get_a_name*300
      integer, external :: end_of_keyword
      double precision, external :: reada

      character :: infile * 100
      logical :: first = .true., found = .false.

      save elemnt
!-----------------------------------------------
      data (elemnt(i),i=1,107)/ 'H ', 'HE', 'LI', 'BE', 'B ', 'C ', 'N ', 'O '&
        , 'F ', 'NE', 'NA', 'MG', 'AL', 'SI', 'P ', 'S ', 'CL', 'AR', 'K ', &
        'CA', 'SC', 'TI', 'V ', 'CR', 'MN', 'FE', 'CO', 'NI', 'CU', 'ZN', 'GA'&
        , 'GE', 'AS', 'SE', 'BR', 'KR', 'RB', 'SR', 'Y ', 'ZR', 'NB', 'MO', &
        'TC', 'RU', 'RH', 'PD', 'AG', 'CD', 'IN', 'SN', 'SB', 'TE', 'I ', 'XE'&
        , 'CS', 'BA', 'LA', 'CE', 'PR', 'ND', 'PM', 'SM', 'EU', 'GD', 'TB', &
        'DY', 'HO', 'ER', 'TM', 'YB', 'LU', 'HF', 'TA', 'W ', 'RE', 'OS', 'IR'&
        , 'PT', 'AU', 'HG', 'TL', 'PB', 'BI', 'PO', 'AT', 'RN', 'FR', 'RA', &
        'AC', 'TH', 'PA', 'U ', 'NP', 'PU', 'AM', 'CM', 'BK', 'MI', 'XX', 'FM'&
        , 'MD', 'CB', '++', '+', '--', '-', 'TV'/
    if (.not. allocated(ijpars))  allocate(ijpars(5,5000), parsij(5000))
    i = Index(keywrd_quoted, "EXTERNAL")
    t_par     = "Add a description of this parameter near line 50 in datin.F90  "
    t_par(1)  = "Used in ccrep for scalar correction of C-C triple bonds."
    t_par(2)  = "Used in ccrep for exponent correction of C-C triple bonds."
    t_par(3)  = "Used in ccrep for scalar correction of O-H term."
    t_par(4)  = "Used in ccrep for exponent correction of O-H term."
    t_par(5)  = "Used in ccrep for offset correction of O-H term."
    t_par(7)  = "Used in dftd3 to set ""s6""  in D3H4"
    t_par(8)  = "Used in dftd3 to set ""alp"" in D3H4"
    t_par(9)  = "Used in dftd3 to set ""rs6"" in D3H4"
    t_par(10) = "Used in dftd3 to set ""s18"" in D3H4."
    t_par(11) = "Used in ccrep for exponent correction of C-H term."
    t_par(12) = "Used in ccrep for offset correction of C-H term."
    t_par(13) = "Used in ccrep for scalar correction of C-C term."
    t_par(14) = "Used in ccrep for exponent correction of C-C term."
    t_par(15) = "Used in ccrep for offset correction of C-C term."
    t_par(16) = "Used in ccrep for scalar correction of H-H term."
    t_par(17) = "Used in ccrep for exponent correction of H-H term."
    t_par(18) = "Used in ccrep for offset correction of H-H term."
    t_par(19) = "Used in ccrep for scalar correction of C-H term."
    t_par(20) = "Used in ccrep for scalar correction of C-O term."
    t_par(21) = "Used in ccrep for exponent correction of C-O term."
    t_par(22) = "Used in ccrep for offset correction of C-O term."
    t_par(23) = "Used in ccrep for scalar correction of S-O term."
    t_par(24) = "Used in ccrep for exponent correction of S-O term."
    t_par(25) = "Used in ccrep for offset correction of S-O term."
    t_par(26) = "Used in ccrep for scalar correction of O-N term."
    t_par(27) = "Used in ccrep for exponent correction of O-N term."
    t_par(28) = "Used in ccrep for offset correction of O-N term."
    t_par(29) = "Used in ccrep for scalar correction of F-H term."
    t_par(30) = "Used in ccrep for exponent correction of F-H term."
    t_par(31) = "Used in ccrep for offset correction of F-H term."
    nref = 0
    k = Index (keywrd_quoted(i:), "=") + i
    j = end_of_keyword(keywrd_quoted, len_trim(keywrd_quoted), k)
!
! k = start of reference data directory list
! j = end of list.
! in between are the names of the reference directories, separated by ";"
!
    do l = 1, 20
      i = Index(keywrd_quoted(k:j),";")
      if (i /= 0) then
        nref = nref + 1
        file(nref) = trim(get_a_name(keywrd_quoted(k:j), len_trim(keywrd_quoted(k:j))))
        k = k + i
      end if
      if (i == 0) then
!
!  Last entry
!
        nref = nref + 1
        file(nref) = keywrd_quoted(k:j)
        exit
      end if
    end do
    if (file(nref)(1:1) == '"') file(nref) = file(nref)(2:)
    i = len_trim(file(nref))
    if (file(nref)(i:i) == '"') file(nref) = file(nref)(:i - 1)

  !
  !   Read in parameters from a previous run - these will overwrite
  !   the default values of the parameters.
  !
    lpars = 0
    do 10 loop = 1, nref
      mpar = 0
      call add_path(file(loop))
      inquire (file=trim(file(loop)), exist = exists)
      if (.not. exists) then
        ! first look for BEGIN EXTERNAL block farther down in the file
        rewind(ir)
        do 2
          read(ir, '(A)', end=3) infile
          if (first) then
            first = .false.
            goto 2
          end if
          call upcase(infile, 80)
          i = Index(infile, "BEGIN EXTERNAL")
          if (i /= 0) then
            ! found the parameters, move on
            found = .true.
            goto 3
          end if
2       continue
3       continue
        if (.not. found) then
          if (index(keywrd,' 0SCF') == 0) call mopend("EXTERNAL file: '"//trim(file(loop))//"' does not exist!")
          exit
        end if
      end if
! Read from beginning of external block in input file
      if (found) then
        iext = ir
! Read from external file
      else
        open (unit=iext, form="FORMATTED", status="OLD", file=trim(file(loop)), action="READ", iostat = i)
        if (i /= 0) then
          if (lpars > 0) exit
          if (loop == 1) then
            write(line,'(a)')" EXTERNAL file """//trim(file(loop))//""" could not be opened"
            write(iw,'(/,a)')trim(line)
            if (index(keywrd,' 0SCF') + index(keywrd, " RESEQ") == 0 ) then
              call mopend(trim(line))
              inquire (file=trim(file(loop)), exist = exists)
              if (exists) then
                write(line,'(a)')" (The EXTERNAL file exists, but could not be read)"
                write(iw,'(a)')trim(line)
                call mopend(trim(line))
              else
                write(line,'(a)')" (The EXTERNAL file does not exist)"
                write(iw,'(a)')trim(line)
                call mopend(trim(line))
              end if
            end if
          end if
        end if
        rewind (iext,err = 10)
      end if
      do
        read (iext, "(A60)", err=11, end=11) text
        call upcase (text, 80)
        if (Index (text, "END") /= 0 .or. text == " ")  exit
        if (text(1:1) == "*") cycle
        if (index(text, "PAR") /= 0) then
          i = index(text, "PAR") + 3
          j = ichar(text(i:i)) - ichar("0")
          i = i + 1
          line = text (1:80)
          if (text(i:i) /= " ")then
            j = j*10 + ichar(text(i:i)) - ichar("0")
            i = i + 1
          end if
          v_par(j) = reada(text, i)
          lv_par(j) = .true.
          lpars = lpars + 1
          ijpars(1, lpars) = j
          ijpars(2, lpars) = 41
          parsij(lpars) =  reada(text, i)
          mpar = 1
          cycle
        end if
        line = text (1:80)
        do
          if (line(1:1) /= " ") exit
          line = line(2:)
        end do
        j = len_trim(line)
        do i = j, 1, -1
          ch = line(i:i)
          if (ichar(ch) > 126) exit
          if (ichar(ch) < 32) exit
        end do
        if (i /= 0) then
          call mopend(" Non-standard characters detected in the EXTERNAL file")
          l = 0
          write(iw,'(/, "Faulty line")')
          do
            l = l + 20
            k = min(l,len_trim(line))
            if (k < l - 19) exit
            write(iw,'(a,i3,30i4)')"Position:", (j, j = l - 19, k)
            write(iw,'(a,i3,30i4)')"   ASCII:", (ichar(line(j:j)), j = l - 19, k)
            write(iw,'(a,a3,29a4)')"    Char:", (line(j:j), j = l - 19, k)
            write(iw,*)
            if (k == i) exit
          end do
          write(iw,'(//,a,//)')" (Edit the EXTERNAL to remove non-standard characters using a primitive editor such as vi)"
          return
        end if
!
! Clean up line - delete anything after the third set of spaces
!
        do
          j = 0
          do i = 1, len_trim(line)
            if (line(i:i + 1) == "  ") then
              j = 1
              line(i:) = line(i + 1:)
            end if
          end do
          if (j == 0) exit
        end do
        i = Index (line, " ")
        i = index(line(i + 1:)," ") + i + 1
        i = index(line(i + 1:)," ") + i
        text = line(1:i)
!
!  Force in spaces needed for parsing
!
        i = index(text," ")
        text(i:) = "  "//text(i:)
        i = index(text(i + 3:)," ") + i + 3
        text(i:) = "  "//text(i:)
        line = text
        do j = 1, n_partyp
          if (Index(" "//text, " "//partyp(j)) /= 0) go to 1000
        end do
        write(iw,"(3a)")" EXTERNAL parameter type: '",trim(text),"' unrecognized"
        if (.not. found) close(iext)
        goto 99
1000    iparam = j
        jelmnt=0
        if (iparam == n_partyp_alpb .or. iparam == n_partyp_alpb + 1) then
!
!  This is a di-atomic parameter - read in the other element number
!
          i = Index(text, partyp(j))+5
          do j = 1, 99
            if (Index (" "//text(i:i+2), " "//elemnt(j)) /= 0) exit
          end do
          jelmnt = j
          end if
        i = Index (line, " ")
        text = line(i:)
        line = text
        do i = 1, 88
          if (line(1:1) /= " ") exit
          text = line(2:60)
          line = text
        end do
        text = " " // line (1:79)
        do j = 1, 100
          if (Index (text, " "//elemnt(j)) /= 0) go to 1100
        end do
        write(iw,"(3a)")" EXTERNAL element type: '",trim(text),"' unrecognized"
        if (.not. found) close(iext)
        goto 99
1100    param = reada (text, Index (text, " "//elemnt(j)))
        if (j > jelmnt) then
          ielmnt = j+200*jelmnt
        else
          ielmnt = jelmnt+200*j
        end if
        do i = 1, lpars
          if (ijpars(1, i) == ielmnt .and. ijpars(2, i) == iparam) go to 1200
        end do
        lpars = lpars + 1
        i = lpars
1200    ijpars(1, i) = ielmnt
        ijpars(2, i) = iparam
        if (Abs(param) < 1.d-7) param = 1.d-7  ! Don't allow new parameters to be exactly zero
        parsij(i) = param
        text = " "
        mpar = 1
      end do
11  continue
    if(mpar == 1) then
      if(.not. found) write(iw,'(/,3a)')" Parameters read in from file: """, file(loop)(:len_trim(file(loop))),""""
    else
      if (index(keywrd,' 0SCF') + index(keywrd, " RESEQ") == 0 ) then
        call mopend("No parameters read in from '"//file(loop)(:len_trim(file(loop)))//"'")
      end if
    end if
10  continue
    if (.not. found) close (iext, status="KEEP")
    call write_params(iw, lv_par)
    do i = 1, lpars
      call update(ijpars(2, i), ijpars(1, i), parsij(i), 0.d0)
    end do
    if (.not. found) close(iext)
 99   return
    end subroutine datin
    !
    !
    !
    subroutine write_params(iw, lv_par)
      USE parameters_C, only : partyp, n_partyp_alpb, n_partyp, v_par, t_par
      use Common_arrays_C, only : ijpars, parsij
      use molkst_C, only : lpars, line
      implicit none
      integer, intent(in) :: iw
      logical, intent (in) :: lv_par(60)
      logical :: lold = .true.
!
!  Local
!
      integer :: i, j, k, l, il, iu, ii, jj, iparam, ielmnt, jelmnt
      character :: elemnt(107)*2, elemnt2*2
      save elemnt, lold
!-----------------------------------------------
      data (elemnt(i),i=1,107)/ 'H ', 'HE', 'LI', 'BE', 'B ', 'C ', 'N ', 'O '&
        , 'F ', 'NE', 'NA', 'MG', 'AL', 'SI', 'P ', 'S ', 'CL', 'AR', 'K ', &
        'CA', 'SC', 'TI', 'V ', 'CR', 'MN', 'FE', 'CO', 'NI', 'CU', 'ZN', 'GA'&
        , 'GE', 'AS', 'SE', 'BR', 'KR', 'RB', 'SR', 'Y ', 'ZR', 'NB', 'MO', &
        'TC', 'RU', 'RH', 'PD', 'AG', 'CD', 'IN', 'SN', 'SB', 'TE', 'I ', 'XE'&
        , 'CS', 'BA', 'LA', 'CE', 'PR', 'ND', 'PM', 'SM', 'EU', 'GD', 'TB', &
        'DY', 'HO', 'ER', 'TM', 'YB', 'LU', 'HF', 'TA', 'W ', 'RE', 'OS', 'IR'&
        , 'PT', 'AU', 'HG', 'TL', 'PB', 'BI', 'PO', 'AT', 'RN', 'FR', 'RA', &
        'AC', 'TH', 'PA', 'U ', 'NP', 'PU', 'AM', 'CM', 'BK', 'MI', 'XX', 'FM'&
        , 'MD', 'CB', '++', '+', '--', '-', 'TV'/
      do j = 1, 107
        do k = 1, n_partyp
          if (k == n_partyp_alpb + 1) cycle
          if (k == n_partyp_alpb) then
           il = 1
           iu = 98
          else
           il = 0
           iu = 0
          end if
          do ii = il, iu
            do jj = 0, il
              do i = 1, lpars
                iparam = ijpars(2, i)
                ielmnt = ijpars(1, i)
                jelmnt = mod(ielmnt,200)
                l = ielmnt/200
                if (iparam == k + jj .and. jelmnt == j .and. l == ii) then
                  if (lold) then
                    write (iw, "(//,8X,A)") " Parameters read in"
                    write (iw, "(/5X, ' Parameter Type  Element    Parameter')")
                    lold = .false.
                  end if
                  if(l /= 0) then
                    elemnt2 = elemnt(l)
                    if(elemnt2(2:2) == " ")elemnt2 = elemnt2(1:1)
                  else
                    elemnt2 = " "
                  end if
                  write (line, "(12X,A7,7X,A2,F16.8)") partyp (iparam)//elemnt2, elemnt(jelmnt), parsij(i)
                  if (iparam /= 41 .and. iparam < n_partyp) then
                    write (iw, "(a)") trim(line)
                  else
                   continue
                  end if
                end if
              end do
            end do
          end do
        end do
      end do
!
! Write out the global parameters that have been read in
!
      do i = 1, 9
        if (lv_par(i)) write(iw,"(12x,'PAR', i1, f28.8, a)") i, v_par(i), "    "//trim(t_par(i))
      end do
       do i = 10, 60
        if (lv_par(i)) write(iw,"(12x,'PAR', i2, f27.8, a)") i, v_par(i), "    "// trim(t_par(i))
      end do
      return
  end subroutine write_params
    integer function end_of_keyword(input, len, start)
!
! Given a keyword, input(start:), find the end of the keyword
!
  integer, intent (in) :: len, start
  character, intent (in) :: input*(len)
!
! Local
!
  integer :: j, k
  logical :: quotation_mark
    quotation_mark = .false.
    k = start
    do
      if (input(k:k) /= " ") exit
      k = k + 1
    end do
    j = k - 1
    do
      j = j + 1
      if (j > len) exit
      if (input(j:j) == ' ') exit
      if (input(j:j) == '"')  quotation_mark = (.not.  quotation_mark)
      if (quotation_mark) then
        do
          j = j + 1
          if (j > len) exit
          if (input(j:j) == '"')  quotation_mark = (.not.  quotation_mark)
          if (.not. quotation_mark) exit
        end do
      end if
    end do
    end_of_keyword = j
    return
  end function end_of_keyword
  character(LEN=300) function get_a_name(input, len)
!
! Given a string of the type "aaa;bbb;ccc" separate
! off the first string, here "aaa"
!
! Note: In input, the first character MUST be the first character of the name or
!       a quotation mark
!
  integer, intent (in) :: len
  character, intent (in) :: input*(len)
!
! Local variables
!
  integer :: istart, istop
  logical :: quotation_marks
  istart = 1
  do 
    if (input(istart:istart) /= " ") exit
    istart = istart + 1
  end do
  quotation_marks = (input(istart:istart) == '"')
  if (quotation_marks) then
!
!    name starts and ends with quotation marks
!
    istart = istart + 1
    istop = index(input(istart:), '"') + istart - 2
  else
    do istop = istart + 1, len
      if (input(istop:istop)== " " .or. input(istop:istop) == ";") exit
    end do
    istop = istop - 1
  end if
  get_a_name = input(istart:istop)
  return
  end function get_a_name

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

program mopac_api_test
    use mopac_api_f
    implicit none
    integer :: nfail
    character(50) :: version
    nfail = 0

    version = ' '
    call get_mopac_version_f(version)

    call test_mopac_scf1(nfail)
    call test_mopac_scf2(nfail)
    call test_mopac_relax1(nfail)
    call test_mopac_vibe1(nfail)
    call test_mozyme_scf1(nfail)
    call test_mozyme_relax1(nfail)
    call test_mozyme_vibe1(nfail)
    call test_mopac_restart1(nfail)
    call test_mopac_restart2(nfail)
    call test_mozyme_restart1(nfail)
    call test_cosmo1(nfail)
    call test_crystal1(nfail)
    call test_moperr(nfail)
    call exit(nfail)
end program mopac_api_test

subroutine test_mopac_scf1(nfail)
    use mopac_api_f
    implicit none
    integer, intent(inout) :: nfail
    type(mopac_system_f) :: test_in
    type(mopac_state_f) :: test_restore
    type(mopac_properties_f) :: test_target
    type(mopac_properties_f) :: test_out
    character(50) :: test_name
    integer :: i
    test_name = 'H2O SCF'

    ! SCF calculation of H2O
    test_in%natom = 3
    test_in%natom_move = 3
    allocate(test_in%atom(3))
    test_in%atom(1) = 1
    test_in%atom(2) = 1
    test_in%atom(3) = 8
    allocate(test_in%coord(3*3))
    test_in%coord(1) = 0.76d0
    test_in%coord(2) = 0.59d0
    test_in%coord(3) = 0.0d0
    test_in%coord(4) = -0.76d0
    test_in%coord(5) = 0.59d0
    test_in%coord(6) = 0.0d0
    test_in%coord(7) = 0.0d0
    test_in%coord(8) = 0.0d0
    test_in%coord(9) = 0.0d0
    test_target%heat = -57.76975d0
    allocate(test_target%coord_update(3*3))
    test_target%coord_update = test_in%coord
    allocate(test_target%coord_deriv(3*3))
    test_target%coord_deriv(1) = 2.307865d0
    test_target%coord_deriv(2) = 2.742432d0
    test_target%coord_deriv(3) = 0.0d0
    test_target%coord_deriv(4) = -2.307865d0
    test_target%coord_deriv(5) = 2.711610d0
    test_target%coord_deriv(6) = 0.0d0
    test_target%coord_deriv(7) = 0.0d0
    test_target%coord_deriv(8) = -5.454042d0
    test_target%coord_deriv(9) = 0.0d0
    allocate(test_target%charge(3))
    test_target%charge(1) = 0.322260d0
    test_target%charge(2) = 0.322260d0
    test_target%charge(3) = -0.644520d0
    test_target%dipole(1) = 0.0d0
    test_target%dipole(2) = 2.147d0
    test_target%dipole(3) = 0.0d0
    test_target%stress(:) = 0.0d0
    allocate(test_target%bond_index(4))
    test_target%bond_index(1) = 1
    test_target%bond_index(2) = 3
    test_target%bond_index(3) = 5
    test_target%bond_index(4) = 8
    allocate(test_target%bond_atom(7))
    test_target%bond_atom(1) = 1
    test_target%bond_atom(2) = 3
    test_target%bond_atom(3) = 2
    test_target%bond_atom(4) = 3
    test_target%bond_atom(5) = 1
    test_target%bond_atom(6) = 2
    test_target%bond_atom(7) = 3
    allocate(test_target%bond_order(7))
    test_target%bond_order(1) = 0.896d0
    test_target%bond_order(2) = 0.895d0
    test_target%bond_order(3) = 0.896d0
    test_target%bond_order(4) = 0.895d0
    test_target%bond_order(5) = 0.895d0
    test_target%bond_order(6) = 0.895d0
    test_target%bond_order(7) = 1.791d0
    test_target%nerror = 0

    call mopac_scf_f(test_in, test_restore, test_out)
    call test_output(test_name, test_in, test_target, test_out, nfail)
end subroutine test_mopac_scf1

subroutine test_mopac_scf2(nfail)
    use mopac_api_f
    implicit none
    integer, intent(inout) :: nfail
    type(mopac_system_f) :: test_in
    type(mopac_state_f) :: test_restore
    type(mopac_properties_f) :: test_target
    type(mopac_properties_f) :: test_out
    character(50) :: test_name
    integer :: i
    test_name = 'OH- SCF'

    ! SCF calculation of OH-
    test_in%natom = 2
    test_in%natom_move = 0
    test_in%charge = -1
    test_in%model = 1
    allocate(test_in%atom(2))
    test_in%atom(1) = 1
    test_in%atom(2) = 8
    allocate(test_in%coord(2*3))
    test_in%coord(1) = 0.94d0
    test_in%coord(2) = 0.0d0
    test_in%coord(3) = 0.0d0
    test_in%coord(4) = 0.0d0
    test_in%coord(5) = 0.0d0
    test_in%coord(6) = 0.0d0
    test_target%heat = -31.91817d0
    allocate(test_target%coord_update(2*3))
    test_target%coord_update = test_in%coord
    allocate(test_target%coord_deriv(0))
    allocate(test_target%charge(2))
    test_target%charge(1) = 0.246921d0
    test_target%charge(2) = -1.246921d0
    test_target%dipole(1) = 1.723d0
    test_target%dipole(2) = 0.0d0
    test_target%dipole(3) = 0.0d0
    test_target%stress(:) = 0.0d0
    allocate(test_target%bond_index(3))
    test_target%bond_index(1) = 1
    test_target%bond_index(2) = 3
    test_target%bond_index(3) = 5
    allocate(test_target%bond_atom(4))
    test_target%bond_atom(1) = 1
    test_target%bond_atom(2) = 2
    test_target%bond_atom(3) = 1
    test_target%bond_atom(4) = 2
    allocate(test_target%bond_order(4))
    test_target%bond_order(1) = 0.939d0
    test_target%bond_order(2) = 0.939d0
    test_target%bond_order(3) = 0.939d0
    test_target%bond_order(4) = 0.939d0
    test_target%nerror = 0

    call mopac_scf_f(test_in, test_restore, test_out)
    call test_output(test_name, test_in, test_target, test_out, nfail)
end subroutine test_mopac_scf2

subroutine test_mopac_relax1(nfail)
    use mopac_api_f
    implicit none
    integer, intent(inout) :: nfail
    type(mopac_system_f) :: test_in
    type(mopac_state_f) :: test_restore
    type(mopac_properties_f) :: test_target
    type(mopac_properties_f) :: test_out
    character(50) :: test_name
    integer :: i
    test_name = 'H2O relax'

    ! 1 - geometry relaxation of H2O
    test_in%natom = 3
    test_in%natom_move = 3
    allocate(test_in%atom(3))
    test_in%atom(1) = 1
    test_in%atom(2) = 1
    test_in%atom(3) = 8
    allocate(test_in%coord(3*3))
    test_in%coord(1) = 0.8d0
    test_in%coord(2) = 0.4d0
    test_in%coord(3) = 0.0d0
    test_in%coord(4) = -0.8d0
    test_in%coord(5) = 0.4d0
    test_in%coord(6) = 0.0d0
    test_in%coord(7) = 0.0d0
    test_in%coord(8) = 0.0d0
    test_in%coord(9) = 0.0d0
    test_target%heat = -57.79952d0
    allocate(test_target%coord_update(3*3))
    test_target%coord_update(1) = 0.758862835d0
    test_target%coord_update(2) = 0.486805290d0
    test_target%coord_update(3) = 0.0d0
    test_target%coord_update(4) = -0.759709263d0
    test_target%coord_update(5) = 0.485142519d0
    test_target%coord_update(6) = 0.0d0
    test_target%coord_update(7) = 0.000846434d0
    test_target%coord_update(8) = -0.093004709d0
    test_target%coord_update(9) = 0.0d0
    allocate(test_target%coord_deriv(3*3))
    test_target%coord_deriv(1) = -0.565914d0
    test_target%coord_deriv(2) = -0.294814d0
    test_target%coord_deriv(3) = 0.0d0
    test_target%coord_deriv(4) = 0.063505d0
    test_target%coord_deriv(5) = 0.058243d0
    test_target%coord_deriv(6) = 0.0d0
    test_target%coord_deriv(7) = 0.502409d0
    test_target%coord_deriv(8) = 0.236571d0
    test_target%coord_deriv(9) = 0.0d0
    allocate(test_target%charge(3))
    test_target%charge(1) = 0.324544d0
    test_target%charge(2) = 0.324720d0
    test_target%charge(3) = -0.649264d0
    test_target%dipole(1) = -0.005d0
    test_target%dipole(2) = 2.129d0
    test_target%dipole(3) = 0.0d0
    test_target%stress(:) = 0.0d0
    allocate(test_target%bond_index(4))
    test_target%bond_index(1) = 1
    test_target%bond_index(2) = 3
    test_target%bond_index(3) = 5
    test_target%bond_index(4) = 8
    allocate(test_target%bond_atom(7))
    test_target%bond_atom(1) = 1
    test_target%bond_atom(2) = 3
    test_target%bond_atom(3) = 2
    test_target%bond_atom(4) = 3
    test_target%bond_atom(5) = 1
    test_target%bond_atom(6) = 2
    test_target%bond_atom(7) = 3
    allocate(test_target%bond_order(7))
    test_target%bond_order(1) = 0.895d0
    test_target%bond_order(2) = 0.894d0
    test_target%bond_order(3) = 0.895d0
    test_target%bond_order(4) = 0.894d0
    test_target%bond_order(5) = 0.894d0
    test_target%bond_order(6) = 0.894d0
    test_target%bond_order(7) = 1.788d0
    test_target%nerror = 0

    call mopac_relax_f(test_in, test_restore, test_out)
    call test_output(test_name, test_in, test_target, test_out, nfail)
end subroutine test_mopac_relax1

subroutine test_mopac_vibe1(nfail)
    use mopac_api_f
    implicit none
    integer, intent(inout) :: nfail
    type(mopac_system_f) :: test_in
    type(mopac_state_f) :: test_restore
    type(mopac_properties_f) :: test_target
    type(mopac_properties_f) :: test_out
    character(50) :: test_name
    test_name = 'H2O vibe'

    ! 1 - geometry relaxation of H2O
    test_in%natom = 3
    test_in%natom_move = 3
    allocate(test_in%atom(3))
    test_in%atom(1) = 1
    test_in%atom(2) = 1
    test_in%atom(3) = 8
    allocate(test_in%coord(3*3))
    test_in%coord(1) = 0.759568602d0
    test_in%coord(2) = 0.486889564d0
    test_in%coord(3) = 0.0d0
    test_in%coord(4) = -0.760025949d0
    test_in%coord(5) = 0.485109057d0
    test_in%coord(6) = 0.0d0
    test_in%coord(7) = 0.000457356d0
    test_in%coord(8) = -0.093055521d0
    test_in%coord(9) = 0.0d0
    test_target%heat = -57.79986d0
    allocate(test_target%coord_update(3*3))
    test_target%coord_update = test_in%coord
    allocate(test_target%coord_deriv(3*3))
    test_target%coord_deriv(1) = 0.000042d0
    test_target%coord_deriv(2) = 0.013515d0
    test_target%coord_deriv(3) = 0.0d0
    test_target%coord_deriv(4) = -0.006056d0
    test_target%coord_deriv(5) = -0.013157d0
    test_target%coord_deriv(6) = 0.0d0
    test_target%coord_deriv(7) = 0.006014d0
    test_target%coord_deriv(8) = -0.000359d0
    test_target%coord_deriv(9) = 0.0d0
    allocate(test_target%charge(3))
    test_target%charge(1) = 0.324672d0
    test_target%charge(2) = 0.324697d0
    test_target%charge(3) = -0.649369d0
    test_target%dipole(1) = -0.003d0
    test_target%dipole(2) = 2.129d0
    test_target%dipole(3) = 0.0d0
    test_target%stress(:) = 0.0d0
    allocate(test_target%bond_index(4))
    test_target%bond_index(1) = 1
    test_target%bond_index(2) = 3
    test_target%bond_index(3) = 5
    test_target%bond_index(4) = 8
    allocate(test_target%bond_atom(7))
    test_target%bond_atom(1) = 1
    test_target%bond_atom(2) = 3
    test_target%bond_atom(3) = 2
    test_target%bond_atom(4) = 3
    test_target%bond_atom(5) = 1
    test_target%bond_atom(6) = 2
    test_target%bond_atom(7) = 3
    allocate(test_target%bond_order(7))
    test_target%bond_order(1) = 0.895d0
    test_target%bond_order(2) = 0.894d0
    test_target%bond_order(3) = 0.895d0
    test_target%bond_order(4) = 0.894d0
    test_target%bond_order(5) = 0.894d0
    test_target%bond_order(6) = 0.894d0
    test_target%bond_order(7) = 1.788d0
    test_target%nerror = 0
    allocate(test_target%freq(9))
    test_target%freq(1) = -18.0d0
    test_target%freq(2) = -14.6d0
    test_target%freq(3) = -4.0d0
    test_target%freq(4) = 0.0d0
    test_target%freq(5) = 2.3d0
    test_target%freq(6) = 4.7d0
    test_target%freq(7) = 1395.0d0
    test_target%freq(8) = 2810.2d0
    test_target%freq(9) = 2856.4d0
    allocate(test_target%disp(9,9))
    test_target%disp(1,1) = 0.1312d0
    test_target%disp(2,1) = -0.1922d0
    test_target%disp(3,1) = 0.8602d0
    test_target%disp(4,1) = 0.1308d0
    test_target%disp(5,1) = 0.1926d0
    test_target%disp(6,1) = 0.3710d0
    test_target%disp(7,1) = -0.0624d0
    test_target%disp(8,1) = 0.0000d0
    test_target%disp(9,1) = -0.1011d0
    test_target%disp(1,2) = -0.2659d0
    test_target%disp(2,2) = 0.4129d0
    test_target%disp(3,2) = -0.0185d0
    test_target%disp(4,2) = -0.2649d0
    test_target%disp(5,2) = -0.4137d0
    test_target%disp(6,2) = 0.6915d0
    test_target%disp(7,2) = 0.1976d0
    test_target%disp(8,2) = -0.0001d0
    test_target%disp(9,2) = -0.0029d0
    test_target%disp(1,3) = 0.3319d0
    test_target%disp(2,3) = -0.3100d0
    test_target%disp(3,3) = -0.4197d0
    test_target%disp(4,3) = 0.3312d0
    test_target%disp(5,3) = 0.3120d0
    test_target%disp(6,3) = 0.5078d0
    test_target%disp(7,3) = 0.3768d0
    test_target%disp(8,3) = 0.0028d0
    test_target%disp(9,3) = 0.1034d0
    test_target%disp(1,4) = -0.0016d0
    test_target%disp(2,4) = 0.2370d0
    test_target%disp(3,4) = 0.0003d0
    test_target%disp(4,4) = -0.0016d0
    test_target%disp(5,4) = 0.2361d0
    test_target%disp(6,4) = 0.0001d0
    test_target%disp(7,4) = -0.0048d0
    test_target%disp(8,4) = 0.9424d0
    test_target%disp(9,4) = 0.0007d0
    test_target%disp(1,5) = 0.0966d0
    test_target%disp(2,5) = 0.1446d0
    test_target%disp(3,5) = 0.1956d0
    test_target%disp(4,5) = 0.0970d0
    test_target%disp(5,5) = -0.1428d0
    test_target%disp(6,5) = -0.3284d0
    test_target%disp(7,5) = 0.8218d0
    test_target%disp(8,5) = 0.0041d0
    test_target%disp(9,5) = -0.3442d0
    test_target%disp(1,6) = 0.0123d0
    test_target%disp(2,6) = 0.0684d0
    test_target%disp(3,6) = 0.2130d0
    test_target%disp(4,6) = 0.0125d0
    test_target%disp(5,6) = -0.0682d0
    test_target%disp(6,6) = -0.1359d0
    test_target%disp(7,6) = 0.2567d0
    test_target%disp(8,6) = 0.0005d0
    test_target%disp(9,6) = 0.9277d0
    test_target%disp(1,7) = -0.3143d0
    test_target%disp(2,7) = 0.5969d0
    test_target%disp(3,7) = -0.0000d0
    test_target%disp(4,7) = 0.3129d0
    test_target%disp(5,7) = 0.5976d0
    test_target%disp(6,7) = -0.0000d0
    test_target%disp(7,7) = 0.0003d0
    test_target%disp(8,7) = -0.2998d0
    test_target%disp(9,7) = -0.0000d0
    test_target%disp(1,8) = 0.5406d0
    test_target%disp(2,8) = 0.4131d0
    test_target%disp(3,8) = -0.0000d0
    test_target%disp(4,8) = 0.5419d0
    test_target%disp(5,8) = -0.4119d0
    test_target%disp(6,8) = -0.0000d0
    test_target%disp(7,8) = -0.2717d0
    test_target%disp(8,8) = -0.0003d0
    test_target%disp(9,8) = 0.0000d0
    test_target%disp(1,9) = -0.6335d0
    test_target%disp(2,9) = -0.2964d0
    test_target%disp(3,9) = -0.0000d0
    test_target%disp(4,9) = 0.6340d0
    test_target%disp(5,9) = -0.2947d0
    test_target%disp(6,9) = -0.0000d0
    test_target%disp(7,9) = -0.0001d0
    test_target%disp(8,9) = 0.1483d0
    test_target%disp(9,9) = 0.0000d0

    call mopac_vibe_f(test_in, test_restore, test_out)
    call test_output(test_name, test_in, test_target, test_out, nfail)
end subroutine test_mopac_vibe1

subroutine test_mozyme_scf1(nfail)
    use mopac_api_f
    implicit none
    integer, intent(inout) :: nfail
    type(mopac_system_f) :: test_in
    type(mozyme_state_f) :: test_restore
    type(mopac_properties_f) :: test_target
    type(mopac_properties_f) :: test_out
    character(50) :: test_name
    integer :: i
    test_name = 'H2O SCF MOZYME'

    ! SCF calculation of H2O
    test_in%natom = 3
    test_in%natom_move = 3
    allocate(test_in%atom(3))
    test_in%atom(1) = 1
    test_in%atom(2) = 1
    test_in%atom(3) = 8
    allocate(test_in%coord(3*3))
    test_in%coord(1) = 0.76d0
    test_in%coord(2) = 0.59d0
    test_in%coord(3) = 0.0d0
    test_in%coord(4) = -0.76d0
    test_in%coord(5) = 0.59d0
    test_in%coord(6) = 0.0d0
    test_in%coord(7) = 0.0d0
    test_in%coord(8) = 0.0d0
    test_in%coord(9) = 0.0d0
    test_target%heat = -57.76837d0
    allocate(test_target%coord_update(3*3))
    test_target%coord_update = test_in%coord
    allocate(test_target%coord_deriv(3*3))
    test_target%coord_deriv(1) = 2.237d0
    test_target%coord_deriv(2) = 2.318d0
    test_target%coord_deriv(3) = 0.0d0
    test_target%coord_deriv(4) = -2.222d0
    test_target%coord_deriv(5) = 2.295d0
    test_target%coord_deriv(6) = 0.001d0
    test_target%coord_deriv(7) = -0.014d0
    test_target%coord_deriv(8) = -4.614d0
    test_target%coord_deriv(9) = -0.001d0
    allocate(test_target%charge(3))
    test_target%charge(1) = 0.320470d0
    test_target%charge(2) = 0.320480d0
    test_target%charge(3) = -0.640950d0
    test_target%dipole(1) = 0.0d0
    test_target%dipole(2) = 2.137d0
    test_target%dipole(3) = 0.0d0
    test_target%stress(:) = 0.0d0
    allocate(test_target%bond_index(4))
    test_target%bond_index(1) = 1
    test_target%bond_index(2) = 3
    test_target%bond_index(3) = 5
    test_target%bond_index(4) = 8
    allocate(test_target%bond_atom(7))
    test_target%bond_atom(1) = 1
    test_target%bond_atom(2) = 3
    test_target%bond_atom(3) = 2
    test_target%bond_atom(4) = 3
    test_target%bond_atom(5) = 1
    test_target%bond_atom(6) = 2
    test_target%bond_atom(7) = 3
    allocate(test_target%bond_order(7))
    test_target%bond_order(1) = 0.897d0
    test_target%bond_order(2) = 0.896d0
    test_target%bond_order(3) = 0.897d0
    test_target%bond_order(4) = 0.896d0
    test_target%bond_order(5) = 0.896d0
    test_target%bond_order(6) = 0.896d0
    test_target%bond_order(7) = 1.793d0
    test_target%nerror = 0

    call mozyme_scf_f(test_in, test_restore, test_out)
    call test_output(test_name, test_in, test_target, test_out, nfail)
end subroutine test_mozyme_scf1

subroutine test_mozyme_relax1(nfail)
    use mopac_api_f
    implicit none
    integer, intent(inout) :: nfail
    type(mopac_system_f) :: test_in
    type(mozyme_state_f) :: test_restore
    type(mopac_properties_f) :: test_target
    type(mopac_properties_f) :: test_out
    character(50) :: test_name
    integer :: i
    test_name = 'H2O relax MOZYME'

    ! 1 - geometry relaxation of H2O
    test_in%natom = 3
    test_in%natom_move = 3
    allocate(test_in%atom(3))
    test_in%atom(1) = 1
    test_in%atom(2) = 1
    test_in%atom(3) = 8
    allocate(test_in%coord(3*3))
    test_in%coord(1) = 0.8d0
    test_in%coord(2) = 0.4d0
    test_in%coord(3) = 0.0d0
    test_in%coord(4) = -0.8d0
    test_in%coord(5) = 0.4d0
    test_in%coord(6) = 0.0d0
    test_in%coord(7) = 0.0d0
    test_in%coord(8) = 0.0d0
    test_in%coord(9) = 0.0d0
    test_target%heat = -57.79952d0
    allocate(test_target%coord_update(3*3))
    test_target%coord_update(1) = 0.760052823d0
    test_target%coord_update(2) = 0.459205345d0
    test_target%coord_update(3) = 0.000297581d0
    test_target%coord_update(4) = -0.760101400d0
    test_target%coord_update(5) = 0.459419431d0
    test_target%coord_update(6) = 0.000222660d0
    test_target%coord_update(7) = 0.000048582d0
    test_target%coord_update(8) = -0.118624776d0
    test_target%coord_update(9) = -0.000520243d0
    allocate(test_target%coord_deriv(3*3))
    test_target%coord_deriv(1) = -0.103d0
    test_target%coord_deriv(2) = -0.132d0
    test_target%coord_deriv(3) = 0.0d0
    test_target%coord_deriv(4) = -0.027d0
    test_target%coord_deriv(5) = -0.08d0
    test_target%coord_deriv(6) = 0.0d0
    test_target%coord_deriv(7) = 0.13d0
    test_target%coord_deriv(8) = 0.212d0
    test_target%coord_deriv(9) = 0.001d0
    allocate(test_target%charge(3))
    test_target%charge(1) = 0.325153d0
    test_target%charge(2) = 0.325224d0
    test_target%charge(3) = -0.650376d0
    test_target%dipole(1) = 0.0d0
    test_target%dipole(2) = 2.129d0
    test_target%dipole(3) = 0.003d0
    test_target%stress(:) = 0.0d0
    allocate(test_target%bond_index(4))
    test_target%bond_index(1) = 1
    test_target%bond_index(2) = 3
    test_target%bond_index(3) = 5
    test_target%bond_index(4) = 8
    allocate(test_target%bond_atom(7))
    test_target%bond_atom(1) = 1
    test_target%bond_atom(2) = 3
    test_target%bond_atom(3) = 2
    test_target%bond_atom(4) = 3
    test_target%bond_atom(5) = 1
    test_target%bond_atom(6) = 2
    test_target%bond_atom(7) = 3
    allocate(test_target%bond_order(7))
    test_target%bond_order(1) = 0.895d0
    test_target%bond_order(2) = 0.894d0
    test_target%bond_order(3) = 0.895d0
    test_target%bond_order(4) = 0.894d0
    test_target%bond_order(5) = 0.894d0
    test_target%bond_order(6) = 0.894d0
    test_target%bond_order(7) = 1.788d0
    test_target%nerror = 0

    call mozyme_relax_f(test_in, test_restore, test_out)
    call test_output(test_name, test_in, test_target, test_out, nfail)
end subroutine test_mozyme_relax1


subroutine test_mozyme_vibe1(nfail)
    use mopac_api_f
    implicit none
    integer, intent(inout) :: nfail
    type(mopac_system_f) :: test_in
    type(mozyme_state_f) :: test_restore
    type(mopac_properties_f) :: test_target
    type(mopac_properties_f) :: test_out
    character(50) :: test_name
    test_name = 'H2O vibe MOZYME'

    ! 1 - geometry relaxation of H2O
    test_in%natom = 3
    test_in%natom_move = 3
    allocate(test_in%atom(3))
    test_in%atom(1) = 1
    test_in%atom(2) = 1
    test_in%atom(3) = 8
    allocate(test_in%coord(3*3))
    test_in%coord(1) = 0.759568602d0
    test_in%coord(2) = 0.486889564d0
    test_in%coord(3) = 0.0d0
    test_in%coord(4) = -0.760025949d0
    test_in%coord(5) = 0.485109057d0
    test_in%coord(6) = 0.0d0
    test_in%coord(7) = 0.000457356d0
    test_in%coord(8) = -0.093055521d0
    test_in%coord(9) = 0.0d0
    test_in%tolerance = 0.001d0
    test_target%heat = -57.79986d0
    allocate(test_target%coord_update(3*3))
    test_target%coord_update = test_in%coord
    allocate(test_target%coord_deriv(3*3))
    test_target%coord_deriv(1) = 0.000042d0
    test_target%coord_deriv(2) = 0.013515d0
    test_target%coord_deriv(3) = 0.0d0
    test_target%coord_deriv(4) = -0.006056d0
    test_target%coord_deriv(5) = -0.013157d0
    test_target%coord_deriv(6) = 0.0d0
    test_target%coord_deriv(7) = 0.006014d0
    test_target%coord_deriv(8) = -0.000359d0
    test_target%coord_deriv(9) = 0.0d0
    allocate(test_target%charge(3))
    test_target%charge(1) = 0.324672d0
    test_target%charge(2) = 0.324697d0
    test_target%charge(3) = -0.649369d0
    test_target%dipole(1) = -0.003d0
    test_target%dipole(2) = 2.129d0
    test_target%dipole(3) = 0.0d0
    test_target%stress(:) = 0.0d0
    allocate(test_target%bond_index(4))
    test_target%bond_index(1) = 1
    test_target%bond_index(2) = 3
    test_target%bond_index(3) = 5
    test_target%bond_index(4) = 8
    allocate(test_target%bond_atom(7))
    test_target%bond_atom(1) = 1
    test_target%bond_atom(2) = 3
    test_target%bond_atom(3) = 2
    test_target%bond_atom(4) = 3
    test_target%bond_atom(5) = 1
    test_target%bond_atom(6) = 2
    test_target%bond_atom(7) = 3
    allocate(test_target%bond_order(7))
    test_target%bond_order(1) = 0.895d0
    test_target%bond_order(2) = 0.894d0
    test_target%bond_order(3) = 0.895d0
    test_target%bond_order(4) = 0.894d0
    test_target%bond_order(5) = 0.894d0
    test_target%bond_order(6) = 0.894d0
    test_target%bond_order(7) = 1.788d0
    test_target%nerror = 0
    allocate(test_target%freq(9))
    test_target%freq(1) = -18.0d0
    test_target%freq(2) = -14.6d0
    test_target%freq(3) = -4.0d0
    test_target%freq(4) = 0.0d0
    test_target%freq(5) = 2.3d0
    test_target%freq(6) = 4.7d0
    test_target%freq(7) = 1395.0d0
    test_target%freq(8) = 2810.2d0
    test_target%freq(9) = 2856.4d0
    allocate(test_target%disp(9,9))
    test_target%disp(1,1) = 0.1312d0
    test_target%disp(2,1) = -0.1922d0
    test_target%disp(3,1) = 0.8602d0
    test_target%disp(4,1) = 0.1308d0
    test_target%disp(5,1) = 0.1926d0
    test_target%disp(6,1) = 0.3710d0
    test_target%disp(7,1) = -0.0624d0
    test_target%disp(8,1) = 0.0000d0
    test_target%disp(9,1) = -0.1011d0
    test_target%disp(1,2) = -0.2659d0
    test_target%disp(2,2) = 0.4129d0
    test_target%disp(3,2) = -0.0185d0
    test_target%disp(4,2) = -0.2649d0
    test_target%disp(5,2) = -0.4137d0
    test_target%disp(6,2) = 0.6915d0
    test_target%disp(7,2) = 0.1976d0
    test_target%disp(8,2) = -0.0001d0
    test_target%disp(9,2) = -0.0029d0
    test_target%disp(1,3) = 0.3319d0
    test_target%disp(2,3) = -0.3100d0
    test_target%disp(3,3) = -0.4197d0
    test_target%disp(4,3) = 0.3312d0
    test_target%disp(5,3) = 0.3120d0
    test_target%disp(6,3) = 0.5078d0
    test_target%disp(7,3) = 0.3768d0
    test_target%disp(8,3) = 0.0028d0
    test_target%disp(9,3) = 0.1034d0
    test_target%disp(1,4) = -0.0016d0
    test_target%disp(2,4) = 0.2370d0
    test_target%disp(3,4) = 0.0003d0
    test_target%disp(4,4) = -0.0016d0
    test_target%disp(5,4) = 0.2361d0
    test_target%disp(6,4) = 0.0001d0
    test_target%disp(7,4) = -0.0048d0
    test_target%disp(8,4) = 0.9424d0
    test_target%disp(9,4) = 0.0007d0
    test_target%disp(1,5) = 0.0966d0
    test_target%disp(2,5) = 0.1446d0
    test_target%disp(3,5) = 0.1956d0
    test_target%disp(4,5) = 0.0970d0
    test_target%disp(5,5) = -0.1428d0
    test_target%disp(6,5) = -0.3284d0
    test_target%disp(7,5) = 0.8218d0
    test_target%disp(8,5) = 0.0041d0
    test_target%disp(9,5) = -0.3442d0
    test_target%disp(1,6) = 0.0123d0
    test_target%disp(2,6) = 0.0684d0
    test_target%disp(3,6) = 0.2130d0
    test_target%disp(4,6) = 0.0125d0
    test_target%disp(5,6) = -0.0682d0
    test_target%disp(6,6) = -0.1359d0
    test_target%disp(7,6) = 0.2567d0
    test_target%disp(8,6) = 0.0005d0
    test_target%disp(9,6) = 0.9277d0
    test_target%disp(1,7) = -0.3143d0
    test_target%disp(2,7) = 0.5969d0
    test_target%disp(3,7) = -0.0000d0
    test_target%disp(4,7) = 0.3129d0
    test_target%disp(5,7) = 0.5976d0
    test_target%disp(6,7) = -0.0000d0
    test_target%disp(7,7) = 0.0003d0
    test_target%disp(8,7) = -0.2998d0
    test_target%disp(9,7) = -0.0000d0
    test_target%disp(1,8) = 0.5406d0
    test_target%disp(2,8) = 0.4131d0
    test_target%disp(3,8) = -0.0000d0
    test_target%disp(4,8) = 0.5419d0
    test_target%disp(5,8) = -0.4119d0
    test_target%disp(6,8) = -0.0000d0
    test_target%disp(7,8) = -0.2717d0
    test_target%disp(8,8) = -0.0003d0
    test_target%disp(9,8) = 0.0000d0
    test_target%disp(1,9) = -0.6335d0
    test_target%disp(2,9) = -0.2964d0
    test_target%disp(3,9) = -0.0000d0
    test_target%disp(4,9) = 0.6340d0
    test_target%disp(5,9) = -0.2947d0
    test_target%disp(6,9) = -0.0000d0
    test_target%disp(7,9) = -0.0001d0
    test_target%disp(8,9) = 0.1483d0
    test_target%disp(9,9) = 0.0000d0

    call mozyme_vibe_f(test_in, test_restore, test_out)
    call test_output(test_name, test_in, test_target, test_out, nfail)
end subroutine test_mozyme_vibe1

subroutine test_mopac_restart1(nfail)
    use mopac_api_f
    implicit none
    integer, intent(inout) :: nfail
    type(mopac_system_f) :: test_in
    type(mopac_state_f) :: test_restore
    type(mopac_properties_f) :: test_target
    type(mopac_properties_f) :: test_out
    character(50) :: test_name
    integer :: i
    test_name = 'H2O SCF restart'

    ! SCF calculation of H2O
    test_in%natom = 3
    test_in%natom_move = 3
    allocate(test_in%atom(3))
    test_in%atom(1) = 1
    test_in%atom(2) = 1
    test_in%atom(3) = 8
    allocate(test_in%coord(3*3))
    test_in%coord(1) = 0.76d0
    test_in%coord(2) = 0.59d0
    test_in%coord(3) = 0.0d0
    test_in%coord(4) = -0.76d0
    test_in%coord(5) = 0.59d0
    test_in%coord(6) = 0.0d0
    test_in%coord(7) = 0.0d0
    test_in%coord(8) = 0.0d0
    test_in%coord(9) = 0.0d0
    test_target%heat = -57.76975d0
    allocate(test_target%coord_update(3*3))
    test_target%coord_update = test_in%coord
    allocate(test_target%coord_deriv(3*3))
    test_target%coord_deriv(1) = 2.307865d0
    test_target%coord_deriv(2) = 2.742432d0
    test_target%coord_deriv(3) = 0.0d0
    test_target%coord_deriv(4) = -2.307865d0
    test_target%coord_deriv(5) = 2.711610d0
    test_target%coord_deriv(6) = 0.0d0
    test_target%coord_deriv(7) = 0.0d0
    test_target%coord_deriv(8) = -5.454042d0
    test_target%coord_deriv(9) = 0.0d0
    allocate(test_target%charge(3))
    test_target%charge(1) = 0.322260d0
    test_target%charge(2) = 0.322260d0
    test_target%charge(3) = -0.644520d0
    test_target%dipole(1) = 0.0d0
    test_target%dipole(2) = 2.147d0
    test_target%dipole(3) = 0.0d0
    test_target%stress(:) = 0.0d0
    allocate(test_target%bond_index(4))
    test_target%bond_index(1) = 1
    test_target%bond_index(2) = 3
    test_target%bond_index(3) = 5
    test_target%bond_index(4) = 8
    allocate(test_target%bond_atom(7))
    test_target%bond_atom(1) = 1
    test_target%bond_atom(2) = 3
    test_target%bond_atom(3) = 2
    test_target%bond_atom(4) = 3
    test_target%bond_atom(5) = 1
    test_target%bond_atom(6) = 2
    test_target%bond_atom(7) = 3
    allocate(test_target%bond_order(7))
    test_target%bond_order(1) = 0.896d0
    test_target%bond_order(2) = 0.895d0
    test_target%bond_order(3) = 0.896d0
    test_target%bond_order(4) = 0.895d0
    test_target%bond_order(5) = 0.895d0
    test_target%bond_order(6) = 0.895d0
    test_target%bond_order(7) = 1.791d0
    test_target%nerror = 0

    call mopac_scf_f(test_in, test_restore, test_out)
    call mopac_scf_f(test_in, test_restore, test_out)
    call test_output(test_name, test_in, test_target, test_out, nfail)
end subroutine test_mopac_restart1

subroutine test_mopac_restart2(nfail)
    use mopac_api_f
    implicit none
    integer, intent(inout) :: nfail
    type(mopac_system_f) :: test_in
    type(mopac_state_f) :: test_restore
    type(mopac_properties_f) :: test_target_minus, test_target_zero
    type(mopac_properties_f) :: test_out
    character(50) :: test_name
    integer :: i

    ! SCF calculations of OH
    test_in%natom = 2
    test_in%natom_move = 0
    allocate(test_in%atom(2))
    test_in%atom(1) = 1
    test_in%atom(2) = 8
    allocate(test_in%coord(2*3))
    test_in%coord(1) = 0.94d0
    test_in%coord(2) = 0.0d0
    test_in%coord(3) = 0.0d0
    test_in%coord(4) = 0.0d0
    test_in%coord(5) = 0.0d0
    test_in%coord(6) = 0.0d0
    test_target_minus%heat = -32.84804d0
    allocate(test_target_minus%coord_update(2*3))
    test_target_minus%coord_update = test_in%coord
    allocate(test_target_minus%coord_deriv(0))
    allocate(test_target_minus%charge(2))
    test_target_minus%charge(1) = 0.258863d0
    test_target_minus%charge(2) = -1.258863d0
    test_target_minus%dipole(1) = 1.704d0
    test_target_minus%dipole(2) = 0.0d0
    test_target_minus%dipole(3) = 0.0d0
    test_target_minus%stress(:) = 0.0d0
    allocate(test_target_minus%bond_index(3))
    test_target_minus%bond_index(1) = 1
    test_target_minus%bond_index(2) = 3
    test_target_minus%bond_index(3) = 5
    allocate(test_target_minus%bond_atom(4))
    test_target_minus%bond_atom(1) = 1
    test_target_minus%bond_atom(2) = 2
    test_target_minus%bond_atom(3) = 1
    test_target_minus%bond_atom(4) = 2
    allocate(test_target_minus%bond_order(4))
    test_target_minus%bond_order(1) = 0.933d0
    test_target_minus%bond_order(2) = 0.933d0
    test_target_minus%bond_order(3) = 0.933d0
    test_target_minus%bond_order(4) = 0.933d0
    test_target_minus%nerror = 0

    test_target_zero%heat = 7.49350d0
    allocate(test_target_zero%coord_update(2*3))
    test_target_zero%coord_update = test_in%coord
    allocate(test_target_zero%coord_deriv(0))
    allocate(test_target_zero%charge(2))
    test_target_zero%charge(1) = 0.249457d0
    test_target_zero%charge(2) = -0.249457d0
    test_target_zero%dipole(1) = 1.361d0
    test_target_zero%dipole(2) = 0.0d0
    test_target_zero%dipole(3) = 0.0d0
    test_target_zero%stress(:) = 0.0d0
    allocate(test_target_zero%bond_index(3))
    test_target_zero%bond_index(1) = 1
    test_target_zero%bond_index(2) = 3
    test_target_zero%bond_index(3) = 5
    allocate(test_target_zero%bond_atom(4))
    test_target_zero%bond_atom(1) = 1
    test_target_zero%bond_atom(2) = 2
    test_target_zero%bond_atom(3) = 1
    test_target_zero%bond_atom(4) = 2
    allocate(test_target_zero%bond_order(4))
    test_target_zero%bond_order(1) = 0.938d0
    test_target_zero%bond_order(2) = 0.935d0
    test_target_zero%bond_order(3) = 0.935d0
    test_target_zero%bond_order(4) = 1.939d0
    test_target_zero%nerror = 0

    test_in%charge = -1
    test_name = 'OH SCF restart (-1)'
    call mopac_scf_f(test_in, test_restore, test_out)
    call test_output(test_name, test_in, test_target_minus, test_out, nfail)
    test_in%charge = 0
    test_name = 'OH SCF restart (-1 -> 0)'
    call mopac_scf_f(test_in, test_restore, test_out)
    call test_output(test_name, test_in, test_target_zero, test_out, nfail)

    test_restore%mpack = 0

    test_in%charge = 0
    test_name = 'OH SCF restart (0)'
    call mopac_scf_f(test_in, test_restore, test_out)
    call test_output(test_name, test_in, test_target_zero, test_out, nfail)
    test_in%charge = -1
    test_name = 'OH SCF restart (0 -> -1)'
    call mopac_scf_f(test_in, test_restore, test_out)
    call test_output(test_name, test_in, test_target_minus, test_out, nfail)

    call mopac_scf_f(test_in, test_restore, test_out)
end subroutine test_mopac_restart2

subroutine test_mozyme_restart1(nfail)
    use mopac_api_f
    implicit none
    integer, intent(inout) :: nfail
    type(mopac_system_f) :: test_in
    type(mozyme_state_f) :: test_restore
    type(mopac_properties_f) :: test_target
    type(mopac_properties_f) :: test_out
    character(50) :: test_name
    integer :: i
    test_name = 'H2O SCF MOZYME restart'

    ! SCF calculation of H2O
    test_in%natom = 3
    test_in%natom_move = 3
    ! API-based save/load is captured at slightly different point in SCF cycle,
    ! needs tigher tolerance for consistent results
    test_in%tolerance = 0.1d0
    allocate(test_in%atom(3))
    test_in%atom(1) = 1
    test_in%atom(2) = 1
    test_in%atom(3) = 8
    allocate(test_in%coord(3*3))
    test_in%coord(1) = 0.76d0
    test_in%coord(2) = 0.59d0
    test_in%coord(3) = 0.0d0
    test_in%coord(4) = -0.76d0
    test_in%coord(5) = 0.59d0
    test_in%coord(6) = 0.0d0
    test_in%coord(7) = 0.0d0
    test_in%coord(8) = 0.0d0
    test_in%coord(9) = 0.0d0
    test_target%heat = -57.76970d0
    allocate(test_target%coord_update(3*3))
    test_target%coord_update = test_in%coord
    allocate(test_target%coord_deriv(3*3))
    test_target%coord_deriv(1) = 2.296d0
    test_target%coord_deriv(2) = 2.662d0
    test_target%coord_deriv(3) = 0.001d0
    test_target%coord_deriv(4) = -2.295d0
    test_target%coord_deriv(5) = 2.631d0
    test_target%coord_deriv(6) = 0.001d0
    test_target%coord_deriv(7) = -0.001d0
    test_target%coord_deriv(8) = -5.293d0
    test_target%coord_deriv(9) = -0.001d0
    allocate(test_target%charge(3))
    test_target%charge(1) = 0.321963d0
    test_target%charge(2) = 0.321963d0
    test_target%charge(3) = -0.643926d0
    test_target%dipole(1) = 0.0d0
    test_target%dipole(2) = 2.146d0
    test_target%dipole(3) = 0.0d0
    test_target%stress(:) = 0.0d0
    allocate(test_target%bond_index(4))
    test_target%bond_index(1) = 1
    test_target%bond_index(2) = 3
    test_target%bond_index(3) = 5
    test_target%bond_index(4) = 8
    allocate(test_target%bond_atom(7))
    test_target%bond_atom(1) = 1
    test_target%bond_atom(2) = 3
    test_target%bond_atom(3) = 2
    test_target%bond_atom(4) = 3
    test_target%bond_atom(5) = 1
    test_target%bond_atom(6) = 2
    test_target%bond_atom(7) = 3
    allocate(test_target%bond_order(7))
    test_target%bond_order(1) = 0.896d0
    test_target%bond_order(2) = 0.895d0
    test_target%bond_order(3) = 0.896d0
    test_target%bond_order(4) = 0.895d0
    test_target%bond_order(5) = 0.895d0
    test_target%bond_order(6) = 0.895d0
    test_target%bond_order(7) = 1.791d0
    test_target%nerror = 0

    call mozyme_scf_f(test_in, test_restore, test_out)
    call mozyme_scf_f(test_in, test_restore, test_out)
    call test_output(test_name, test_in, test_target, test_out, nfail)
end subroutine test_mozyme_restart1

subroutine test_cosmo1(nfail)
    use mopac_api_f
    implicit none
    integer, intent(inout) :: nfail
    type(mopac_system_f) :: test_in
    type(mopac_state_f) :: test_restore
    type(mopac_properties_f) :: test_target
    type(mopac_properties_f) :: test_out
    character(50) :: test_name
    integer :: i
    test_name = 'H2O SCF COSMO'

    ! SCF calculation of H2O
    test_in%natom = 3
    test_in%natom_move = 3
    test_in%epsilon = 78.4d0
    allocate(test_in%atom(3))
    test_in%atom(1) = 1
    test_in%atom(2) = 1
    test_in%atom(3) = 8
    allocate(test_in%coord(3*3))
    test_in%coord(1) = 0.76d0
    test_in%coord(2) = 0.59d0
    test_in%coord(3) = 0.0d0
    test_in%coord(4) = -0.76d0
    test_in%coord(5) = 0.59d0
    test_in%coord(6) = 0.0d0
    test_in%coord(7) = 0.0d0
    test_in%coord(8) = 0.0d0
    test_in%coord(9) = 0.0d0
    test_target%heat = -65.21458d0
    allocate(test_target%coord_update(3*3))
    test_target%coord_update = test_in%coord
    allocate(test_target%coord_deriv(3*3))
    test_target%coord_deriv(1) = -0.773696d0
    test_target%coord_deriv(2) = -1.302274d0
    test_target%coord_deriv(3) = 0.045812d0
    test_target%coord_deriv(4) = 0.734278d0
    test_target%coord_deriv(5) = -1.261587d0
    test_target%coord_deriv(6) = -0.029041d0
    test_target%coord_deriv(7) = 0.039417d0
    test_target%coord_deriv(8) = 2.563860d0
    test_target%coord_deriv(9) = -0.016772d0
    allocate(test_target%charge(3))
    test_target%charge(1) = 0.374234d0
    test_target%charge(2) = 0.374006d0
    test_target%charge(3) = -0.748240d0
    test_target%dipole(1) = 0.0d0
    test_target%dipole(2) = 2.43d0
    test_target%dipole(3) = 0.0d0
    test_target%stress(:) = 0.0d0
    allocate(test_target%bond_index(4))
    test_target%bond_index(1) = 1
    test_target%bond_index(2) = 3
    test_target%bond_index(3) = 5
    test_target%bond_index(4) = 8
    allocate(test_target%bond_atom(7))
    test_target%bond_atom(1) = 1
    test_target%bond_atom(2) = 3
    test_target%bond_atom(3) = 2
    test_target%bond_atom(4) = 3
    test_target%bond_atom(5) = 1
    test_target%bond_atom(6) = 2
    test_target%bond_atom(7) = 3
    allocate(test_target%bond_order(7))
    test_target%bond_order(1) = 0.860d0
    test_target%bond_order(2) = 0.859d0
    test_target%bond_order(3) = 0.860d0
    test_target%bond_order(4) = 0.859d0
    test_target%bond_order(5) = 0.859d0
    test_target%bond_order(6) = 0.859d0
    test_target%bond_order(7) = 1.718d0
    test_target%nerror = 0

    call mopac_scf_f(test_in, test_restore, test_out)
    call test_output(test_name, test_in, test_target, test_out, nfail)
end subroutine test_cosmo1

subroutine test_crystal1(nfail)
    use mopac_api_f
    implicit none
    integer, intent(inout) :: nfail
    type(mopac_system_f) :: test_in
    type(mopac_state_f) :: test_restore
    type(mopac_properties_f) :: test_target
    type(mopac_properties_f) :: test_out
    character(50) :: test_name
    integer :: i
    test_name = 'LiF SCF'

    ! SCF calculation of LiF
    test_in%natom = 54
    test_in%natom_move = 54
    test_in%nlattice = 3
    test_in%nlattice_move = 3
    allocate(test_in%atom(54))
    test_in%atom(1) = 3
    test_in%atom(2) = 9
    test_in%atom(3) = 3
    test_in%atom(4) = 9
    test_in%atom(5) = 3
    test_in%atom(6) = 9
    test_in%atom(7) = 3
    test_in%atom(8) = 9
    test_in%atom(9) = 3
    test_in%atom(10) = 9
    test_in%atom(11) = 3
    test_in%atom(12) = 9
    test_in%atom(13) = 3
    test_in%atom(14) = 9
    test_in%atom(15) = 3
    test_in%atom(16) = 9
    test_in%atom(17) = 3
    test_in%atom(18) = 9
    test_in%atom(19) = 3
    test_in%atom(20) = 9
    test_in%atom(21) = 3
    test_in%atom(22) = 9
    test_in%atom(23) = 3
    test_in%atom(24) = 9
    test_in%atom(25) = 3
    test_in%atom(26) = 9
    test_in%atom(27) = 3
    test_in%atom(28) = 9
    test_in%atom(29) = 3
    test_in%atom(30) = 9
    test_in%atom(31) = 3
    test_in%atom(32) = 9
    test_in%atom(33) = 3
    test_in%atom(34) = 9
    test_in%atom(35) = 3
    test_in%atom(36) = 9
    test_in%atom(37) = 3
    test_in%atom(38) = 9
    test_in%atom(39) = 3
    test_in%atom(40) = 9
    test_in%atom(41) = 3
    test_in%atom(42) = 9
    test_in%atom(43) = 3
    test_in%atom(44) = 9
    test_in%atom(45) = 3
    test_in%atom(46) = 9
    test_in%atom(47) = 3
    test_in%atom(48) = 9
    test_in%atom(49) = 3
    test_in%atom(50) = 9
    test_in%atom(51) = 3
    test_in%atom(52) = 9
    test_in%atom(53) = 3
    test_in%atom(54) = 9
    allocate(test_in%coord(3*54))
    test_in%coord(1) = 0.0d0
    test_in%coord(2) = 0.0d0
    test_in%coord(3) = 0.0d0
    test_in%coord(4) = 1.795d0
    test_in%coord(5) = 1.795d0
    test_in%coord(6) = 1.795d0
    test_in%coord(7) = 0.0d0
    test_in%coord(8) = 1.795d0
    test_in%coord(9) = 1.795d0
    test_in%coord(10) = 1.795d0
    test_in%coord(11) = 3.59d0
    test_in%coord(12) = 3.59d0
    test_in%coord(13) = 0.0d0
    test_in%coord(14) = 3.59d0
    test_in%coord(15) = 3.59d0
    test_in%coord(16) = 1.795d0
    test_in%coord(17) = 5.385d0
    test_in%coord(18) = 5.385d0
    test_in%coord(19) = 1.795d0
    test_in%coord(20) = 0.0d0
    test_in%coord(21) = 1.795d0
    test_in%coord(22) = 3.59d0
    test_in%coord(23) = 1.795d0
    test_in%coord(24) = 3.59d0
    test_in%coord(25) = 1.795d0
    test_in%coord(26) = 1.795d0
    test_in%coord(27) = 3.59d0
    test_in%coord(28) = 3.59d0
    test_in%coord(29) = 3.59d0
    test_in%coord(30) = 5.385d0
    test_in%coord(31) = 1.795d0
    test_in%coord(32) = 3.59d0
    test_in%coord(33) = 5.385d0
    test_in%coord(34) = 3.59d0
    test_in%coord(35) = 5.385d0
    test_in%coord(36) = 7.18d0
    test_in%coord(37) = 3.59d0
    test_in%coord(38) = 0.0d0
    test_in%coord(39) = 3.59d0
    test_in%coord(40) = 5.385d0
    test_in%coord(41) = 1.795d0
    test_in%coord(42) = 5.385d0
    test_in%coord(43) = 3.59d0
    test_in%coord(44) = 1.795d0
    test_in%coord(45) = 5.385d0
    test_in%coord(46) = 5.385d0
    test_in%coord(47) = 3.59d0
    test_in%coord(48) = 7.18d0
    test_in%coord(49) = 3.59d0
    test_in%coord(50) = 3.59d0
    test_in%coord(51) = 7.18d0
    test_in%coord(52) = 5.385d0
    test_in%coord(53) = 5.385d0
    test_in%coord(54) = 8.975d0
    test_in%coord(55) = 1.795d0
    test_in%coord(56) = 1.795d0
    test_in%coord(57) = 0.0d0
    test_in%coord(58) = 3.59d0
    test_in%coord(59) = 3.59d0
    test_in%coord(60) = 1.795d0
    test_in%coord(61) = 1.795d0
    test_in%coord(62) = 3.59d0
    test_in%coord(63) = 1.795d0
    test_in%coord(64) = 3.59d0
    test_in%coord(65) = 5.385d0
    test_in%coord(66) = 3.59d0
    test_in%coord(67) = 1.795d0
    test_in%coord(68) = 5.385d0
    test_in%coord(69) = 3.59d0
    test_in%coord(70) = 3.59d0
    test_in%coord(71) = 7.18d0
    test_in%coord(72) = 5.385d0
    test_in%coord(73) = 3.59d0
    test_in%coord(74) = 1.795d0
    test_in%coord(75) = 1.795d0
    test_in%coord(76) = 5.385d0
    test_in%coord(77) = 3.59d0
    test_in%coord(78) = 3.59d0
    test_in%coord(79) = 3.59d0
    test_in%coord(80) = 3.59d0
    test_in%coord(81) = 3.59d0
    test_in%coord(82) = 5.385d0
    test_in%coord(83) = 5.385d0
    test_in%coord(84) = 5.385d0
    test_in%coord(85) = 3.59d0
    test_in%coord(86) = 5.385d0
    test_in%coord(87) = 5.385d0
    test_in%coord(88) = 5.385d0
    test_in%coord(89) = 7.18d0
    test_in%coord(90) = 7.18d0
    test_in%coord(91) = 5.385d0
    test_in%coord(92) = 1.795d0
    test_in%coord(93) = 3.59d0
    test_in%coord(94) = 7.18d0
    test_in%coord(95) = 3.59d0
    test_in%coord(96) = 5.385d0
    test_in%coord(97) = 5.385d0
    test_in%coord(98) = 3.59d0
    test_in%coord(99) = 5.385d0
    test_in%coord(100) = 7.18d0
    test_in%coord(101) = 5.385d0
    test_in%coord(102) = 7.18d0
    test_in%coord(103) = 5.385d0
    test_in%coord(104) = 5.385d0
    test_in%coord(105) = 7.18d0
    test_in%coord(106) = 7.18d0
    test_in%coord(107) = 7.18d0
    test_in%coord(108) = 8.975d0
    test_in%coord(109) = 3.59d0
    test_in%coord(110) = 3.59d0
    test_in%coord(111) = 0.0d0
    test_in%coord(112) = 5.385d0
    test_in%coord(113) = 5.385d0
    test_in%coord(114) = 1.795d0
    test_in%coord(115) = 3.59d0
    test_in%coord(116) = 5.385d0
    test_in%coord(117) = 1.795d0
    test_in%coord(118) = 5.385d0
    test_in%coord(119) = 7.18d0
    test_in%coord(120) = 3.59d0
    test_in%coord(121) = 3.59d0
    test_in%coord(122) = 7.18d0
    test_in%coord(123) = 3.59d0
    test_in%coord(124) = 5.385d0
    test_in%coord(125) = 8.975d0
    test_in%coord(126) = 5.385d0
    test_in%coord(127) = 5.385d0
    test_in%coord(128) = 3.59d0
    test_in%coord(129) = 1.795d0
    test_in%coord(130) = 7.18d0
    test_in%coord(131) = 5.385d0
    test_in%coord(132) = 3.59d0
    test_in%coord(133) = 5.385d0
    test_in%coord(134) = 5.385d0
    test_in%coord(135) = 3.59d0
    test_in%coord(136) = 7.18d0
    test_in%coord(137) = 7.18d0
    test_in%coord(138) = 5.385d0
    test_in%coord(139) = 5.385d0
    test_in%coord(140) = 7.18d0
    test_in%coord(141) = 5.385d0
    test_in%coord(142) = 7.18d0
    test_in%coord(143) = 8.975d0
    test_in%coord(144) = 7.18d0
    test_in%coord(145) = 7.18d0
    test_in%coord(146) = 3.59d0
    test_in%coord(147) = 3.59d0
    test_in%coord(148) = 8.975d0
    test_in%coord(149) = 5.385d0
    test_in%coord(150) = 5.385d0
    test_in%coord(151) = 7.18d0
    test_in%coord(152) = 5.385d0
    test_in%coord(153) = 5.385d0
    test_in%coord(154) = 8.975d0
    test_in%coord(155) = 7.18d0
    test_in%coord(156) = 7.18d0
    test_in%coord(157) = 7.18d0
    test_in%coord(158) = 7.18d0
    test_in%coord(159) = 7.18d0
    test_in%coord(160) = 8.975d0
    test_in%coord(161) = 8.975d0
    test_in%coord(162) = 8.975d0
    allocate(test_in%lattice(3*3))
    test_in%lattice(1) = 5.385d0
    test_in%lattice(2) = 5.385d0
    test_in%lattice(3) = 0.0d0
    test_in%lattice(4) = 5.385d0
    test_in%lattice(5) = 0.0d0
    test_in%lattice(6) = 5.385d0
    test_in%lattice(7) = 0.0d0
    test_in%lattice(8) = 5.385d0
    test_in%lattice(9) = 5.385d0
    test_target%heat = -4588.63517d0
    allocate(test_target%coord_update(3*54))
    test_target%coord_update = test_in%coord
    allocate(test_target%coord_deriv(3*54))
    test_target%coord_deriv(1) = -0.003072d0
    test_target%coord_deriv(2) = -0.001544d0
    test_target%coord_deriv(3) = -0.000184d0
    test_target%coord_deriv(4) = -0.002616d0
    test_target%coord_deriv(5) = -0.000781d0
    test_target%coord_deriv(6) = -0.000527d0
    test_target%coord_deriv(7) = -0.003046d0
    test_target%coord_deriv(8) = -0.003246d0
    test_target%coord_deriv(9) = -0.001886d0
    test_target%coord_deriv(10) = -0.003656d0
    test_target%coord_deriv(11) = -0.002632d0
    test_target%coord_deriv(12) = -0.002377d0
    test_target%coord_deriv(13) = -0.004086d0
    test_target%coord_deriv(14) = -0.004968d0
    test_target%coord_deriv(15) = -0.003608d0
    test_target%coord_deriv(16) = -0.003656d0
    test_target%coord_deriv(17) = -0.004478d0
    test_target%coord_deriv(18) = -0.004224d0
    test_target%coord_deriv(19) = -0.003531d0
    test_target%coord_deriv(20) = 0.002452d0
    test_target%coord_deriv(21) = -0.001774d0
    test_target%coord_deriv(22) = -0.000814d0
    test_target%coord_deriv(23) = -0.000424d0
    test_target%coord_deriv(24) = -0.001538d0
    test_target%coord_deriv(25) = -0.003531d0
    test_target%coord_deriv(26) = 0.000725d0
    test_target%coord_deriv(27) = -0.003496d0
    test_target%coord_deriv(28) = -0.001854d0
    test_target%coord_deriv(29) = -0.002273d0
    test_target%coord_deriv(30) = -0.003385d0
    test_target%coord_deriv(31) = -0.004570d0
    test_target%coord_deriv(32) = -0.000998d0
    test_target%coord_deriv(33) = -0.005222d0
    test_target%coord_deriv(34) = -0.001854d0
    test_target%coord_deriv(35) = -0.004120d0
    test_target%coord_deriv(36) = -0.005232d0
    test_target%coord_deriv(37) = -0.000966d0
    test_target%coord_deriv(38) = 0.000375d0
    test_target%coord_deriv(39) = -0.001107d0
    test_target%coord_deriv(40) = -0.000700d0
    test_target%coord_deriv(41) = 0.003466d0
    test_target%coord_deriv(42) = -0.002285d0
    test_target%coord_deriv(43) = -0.000966d0
    test_target%coord_deriv(44) = -0.001352d0
    test_target%coord_deriv(45) = -0.002832d0
    test_target%coord_deriv(46) = -0.001741d0
    test_target%coord_deriv(47) = 0.001616d0
    test_target%coord_deriv(48) = -0.004131d0
    test_target%coord_deriv(49) = -0.002006d0
    test_target%coord_deriv(50) = -0.003074d0
    test_target%coord_deriv(51) = -0.004558d0
    test_target%coord_deriv(52) = -0.001740d0
    test_target%coord_deriv(53) = -0.000230d0
    test_target%coord_deriv(54) = -0.005979d0
    test_target%coord_deriv(55) = -0.003615d0
    test_target%coord_deriv(56) = -0.003741d0
    test_target%coord_deriv(57) = 0.009705d0
    test_target%coord_deriv(58) = 0.000734d0
    test_target%coord_deriv(59) = 0.001680d0
    test_target%coord_deriv(60) = -0.002221d0
    test_target%coord_deriv(61) = -0.003615d0
    test_target%coord_deriv(62) = -0.005463d0
    test_target%coord_deriv(63) = 0.007978d0
    test_target%coord_deriv(64) = -0.000306d0
    test_target%coord_deriv(65) = -0.000167d0
    test_target%coord_deriv(66) = -0.004070d0
    test_target%coord_deriv(67) = -0.004655d0
    test_target%coord_deriv(68) = -0.007189d0
    test_target%coord_deriv(69) = 0.006255d0
    test_target%coord_deriv(70) = -0.000306d0
    test_target%coord_deriv(71) = -0.002013d0
    test_target%coord_deriv(72) = -0.005917d0
    test_target%coord_deriv(73) = -0.004098d0
    test_target%coord_deriv(74) = 0.000230d0
    test_target%coord_deriv(75) = 0.008089d0
    test_target%coord_deriv(76) = 0.002535d0
    test_target%coord_deriv(77) = 0.002039d0
    test_target%coord_deriv(78) = -0.003233d0
    test_target%coord_deriv(79) = -0.004098d0
    test_target%coord_deriv(80) = -0.001493d0
    test_target%coord_deriv(81) = 0.006365d0
    test_target%coord_deriv(82) = 0.001495d0
    test_target%coord_deriv(83) = 0.000193d0
    test_target%coord_deriv(84) = -0.005079d0
    test_target%coord_deriv(85) = -0.005138d0
    test_target%coord_deriv(86) = -0.003218d0
    test_target%coord_deriv(87) = 0.004640d0
    test_target%coord_deriv(88) = 0.001495d0
    test_target%coord_deriv(89) = -0.001654d0
    test_target%coord_deriv(90) = -0.006926d0
    test_target%coord_deriv(91) = -0.001534d0
    test_target%coord_deriv(92) = -0.001845d0
    test_target%coord_deriv(93) = 0.008754d0
    test_target%coord_deriv(94) = 0.002650d0
    test_target%coord_deriv(95) = 0.005927d0
    test_target%coord_deriv(96) = -0.003979d0
    test_target%coord_deriv(97) = -0.001534d0
    test_target%coord_deriv(98) = -0.003569d0
    test_target%coord_deriv(99) = 0.007028d0
    test_target%coord_deriv(100) = 0.001610d0
    test_target%coord_deriv(101) = 0.004081d0
    test_target%coord_deriv(102) = -0.005826d0
    test_target%coord_deriv(103) = -0.002574d0
    test_target%coord_deriv(104) = -0.005294d0
    test_target%coord_deriv(105) = 0.005303d0
    test_target%coord_deriv(106) = 0.001610d0
    test_target%coord_deriv(107) = 0.002233d0
    test_target%coord_deriv(108) = -0.007674d0
    test_target%coord_deriv(109) = 0.003433d0
    test_target%coord_deriv(110) = 0.003270d0
    test_target%coord_deriv(111) = 0.002281d0
    test_target%coord_deriv(112) = 0.002916d0
    test_target%coord_deriv(113) = 0.001338d0
    test_target%coord_deriv(114) = 0.006969d0
    test_target%coord_deriv(115) = 0.003433d0
    test_target%coord_deriv(116) = 0.001544d0
    test_target%coord_deriv(117) = 0.000555d0
    test_target%coord_deriv(118) = 0.001876d0
    test_target%coord_deriv(119) = -0.000509d0
    test_target%coord_deriv(120) = 0.005122d0
    test_target%coord_deriv(121) = 0.002393d0
    test_target%coord_deriv(122) = -0.000181d0
    test_target%coord_deriv(123) = -0.001169d0
    test_target%coord_deriv(124) = 0.001876d0
    test_target%coord_deriv(125) = -0.002357d0
    test_target%coord_deriv(126) = 0.003275d0
    test_target%coord_deriv(127) = 0.002947d0
    test_target%coord_deriv(128) = 0.007238d0
    test_target%coord_deriv(129) = 0.000669d0
    test_target%coord_deriv(130) = 0.004719d0
    test_target%coord_deriv(131) = 0.001697d0
    test_target%coord_deriv(132) = 0.005959d0
    test_target%coord_deriv(133) = 0.002947d0
    test_target%coord_deriv(134) = 0.005512d0
    test_target%coord_deriv(135) = -0.001055d0
    test_target%coord_deriv(136) = 0.003679d0
    test_target%coord_deriv(137) = -0.000149d0
    test_target%coord_deriv(138) = 0.004112d0
    test_target%coord_deriv(139) = 0.001907d0
    test_target%coord_deriv(140) = 0.003787d0
    test_target%coord_deriv(141) = -0.002780d0
    test_target%coord_deriv(142) = 0.003679d0
    test_target%coord_deriv(143) = -0.001997d0
    test_target%coord_deriv(144) = 0.002265d0
    test_target%coord_deriv(145) = 0.005513d0
    test_target%coord_deriv(146) = 0.005162d0
    test_target%coord_deriv(147) = 0.001333d0
    test_target%coord_deriv(148) = 0.004834d0
    test_target%coord_deriv(149) = 0.005587d0
    test_target%coord_deriv(150) = 0.005213d0
    test_target%coord_deriv(151) = 0.005513d0
    test_target%coord_deriv(152) = 0.003437d0
    test_target%coord_deriv(153) = -0.000392d0
    test_target%coord_deriv(154) = 0.003794d0
    test_target%coord_deriv(155) = 0.003740d0
    test_target%coord_deriv(156) = 0.003366d0
    test_target%coord_deriv(157) = 0.004473d0
    test_target%coord_deriv(158) = 0.001712d0
    test_target%coord_deriv(159) = -0.002117d0
    test_target%coord_deriv(160) = 0.003794d0
    test_target%coord_deriv(161) = 0.001892d0
    test_target%coord_deriv(162) = 0.001519d0
    allocate(test_target%lattice_update(3*3))
    test_target%lattice_update = test_in%lattice
    allocate(test_target%lattice_deriv(3*3))
    test_target%lattice_deriv(1) = -2.329702d0
    test_target%lattice_deriv(2) = -2.324697d0
    test_target%lattice_deriv(3) = 2.296600d0
    test_target%lattice_deriv(4) = -2.314736d0
    test_target%lattice_deriv(5) = 2.301304d0
    test_target%lattice_deriv(6) = -2.299118d0
    test_target%lattice_deriv(7) = 2.302052d0
    test_target%lattice_deriv(8) = -2.296322d0
    test_target%lattice_deriv(9) = -2.281867d0
    allocate(test_target%charge(54))
    test_target%charge(1) = 0.855660d0
    test_target%charge(2) = -0.855642d0
    test_target%charge(3) = 0.855660d0
    test_target%charge(4) = -0.855642d0
    test_target%charge(5) = 0.855660d0
    test_target%charge(6) = -0.855642d0
    test_target%charge(7) = 0.855654d0
    test_target%charge(8) = -0.855644d0
    test_target%charge(9) = 0.855654d0
    test_target%charge(10) = -0.855644d0
    test_target%charge(11) = 0.855654d0
    test_target%charge(12) = -0.855644d0
    test_target%charge(13) = 0.855654d0
    test_target%charge(14) = -0.855642d0
    test_target%charge(15) = 0.855654d0
    test_target%charge(16) = -0.855642d0
    test_target%charge(17) = 0.855654d0
    test_target%charge(18) = -0.855642d0
    test_target%charge(19) = 0.855642d0
    test_target%charge(20) = -0.855647d0
    test_target%charge(21) = 0.855642d0
    test_target%charge(22) = -0.855647d0
    test_target%charge(23) = 0.855642d0
    test_target%charge(24) = -0.855647d0
    test_target%charge(25) = 0.855637d0
    test_target%charge(26) = -0.855649d0
    test_target%charge(27) = 0.855637d0
    test_target%charge(28) = -0.855649d0
    test_target%charge(29) = 0.855637d0
    test_target%charge(30) = -0.855649d0
    test_target%charge(31) = 0.855636d0
    test_target%charge(32) = -0.855647d0
    test_target%charge(33) = 0.855636d0
    test_target%charge(34) = -0.855647d0
    test_target%charge(35) = 0.855636d0
    test_target%charge(36) = -0.855647d0
    test_target%charge(37) = 0.855642d0
    test_target%charge(38) = -0.855641d0
    test_target%charge(39) = 0.855642d0
    test_target%charge(40) = -0.855641d0
    test_target%charge(41) = 0.855642d0
    test_target%charge(42) = -0.855641d0
    test_target%charge(43) = 0.855636d0
    test_target%charge(44) = -0.855643d0
    test_target%charge(45) = 0.855636d0
    test_target%charge(46) = -0.855643d0
    test_target%charge(47) = 0.855636d0
    test_target%charge(48) = -0.855643d0
    test_target%charge(49) = 0.855636d0
    test_target%charge(50) = -0.855641d0
    test_target%charge(51) = 0.855636d0
    test_target%charge(52) = -0.855641d0
    test_target%charge(53) = 0.855636d0
    test_target%charge(54) = -0.855641d0
    test_target%dipole(:) = 0.0d0
    test_target%stress(1) = -0.550d0
    test_target%stress(2) = -0.553d0
    test_target%stress(3) = -0.554d0
    test_target%stress(4) = 0.001d0
    test_target%stress(5) = 0.000d0
    test_target%stress(6) = 0.002d0
    allocate(test_target%bond_index(55))
    do i = 1, 55
        test_target%bond_index(i) = 1 + 7*(i-1)
    end do
    allocate(test_target%bond_atom(54*7))
    test_target%bond_atom(1) = 1
    test_target%bond_atom(2) = 6
    test_target%bond_atom(3) = 14
    test_target%bond_atom(4) = 18
    test_target%bond_atom(5) = 38
    test_target%bond_atom(6) = 42
    test_target%bond_atom(7) = 50
    test_target%bond_atom(8) = 2
    test_target%bond_atom(9) = 3
    test_target%bond_atom(10) = 7
    test_target%bond_atom(11) = 9
    test_target%bond_atom(12) = 19
    test_target%bond_atom(13) = 21
    test_target%bond_atom(14) = 25
    test_target%bond_atom(15) = 2
    test_target%bond_atom(16) = 3
    test_target%bond_atom(17) = 14
    test_target%bond_atom(18) = 16
    test_target%bond_atom(19) = 38
    test_target%bond_atom(20) = 40
    test_target%bond_atom(21) = 52
    test_target%bond_atom(22) = 4
    test_target%bond_atom(23) = 5
    test_target%bond_atom(24) = 9
    test_target%bond_atom(25) = 11
    test_target%bond_atom(26) = 21
    test_target%bond_atom(27) = 23
    test_target%bond_atom(28) = 27
    test_target%bond_atom(29) = 4
    test_target%bond_atom(30) = 5
    test_target%bond_atom(31) = 16
    test_target%bond_atom(32) = 18
    test_target%bond_atom(33) = 40
    test_target%bond_atom(34) = 42
    test_target%bond_atom(35) = 54
    test_target%bond_atom(36) = 1
    test_target%bond_atom(37) = 6
    test_target%bond_atom(38) = 7
    test_target%bond_atom(39) = 11
    test_target%bond_atom(40) = 19
    test_target%bond_atom(41) = 23
    test_target%bond_atom(42) = 29
    test_target%bond_atom(43) = 2
    test_target%bond_atom(44) = 6
    test_target%bond_atom(45) = 7
    test_target%bond_atom(46) = 12
    test_target%bond_atom(47) = 38
    test_target%bond_atom(48) = 44
    test_target%bond_atom(49) = 48
    test_target%bond_atom(50) = 8
    test_target%bond_atom(51) = 9
    test_target%bond_atom(52) = 13
    test_target%bond_atom(53) = 15
    test_target%bond_atom(54) = 25
    test_target%bond_atom(55) = 27
    test_target%bond_atom(56) = 31
    test_target%bond_atom(57) = 2
    test_target%bond_atom(58) = 4
    test_target%bond_atom(59) = 8
    test_target%bond_atom(60) = 9
    test_target%bond_atom(61) = 40
    test_target%bond_atom(62) = 44
    test_target%bond_atom(63) = 46
    test_target%bond_atom(64) = 10
    test_target%bond_atom(65) = 11
    test_target%bond_atom(66) = 15
    test_target%bond_atom(67) = 17
    test_target%bond_atom(68) = 27
    test_target%bond_atom(69) = 29
    test_target%bond_atom(70) = 33
    test_target%bond_atom(71) = 4
    test_target%bond_atom(72) = 6
    test_target%bond_atom(73) = 10
    test_target%bond_atom(74) = 11
    test_target%bond_atom(75) = 42
    test_target%bond_atom(76) = 46
    test_target%bond_atom(77) = 48
    test_target%bond_atom(78) = 7
    test_target%bond_atom(79) = 12
    test_target%bond_atom(80) = 13
    test_target%bond_atom(81) = 17
    test_target%bond_atom(82) = 25
    test_target%bond_atom(83) = 29
    test_target%bond_atom(84) = 35
    test_target%bond_atom(85) = 8
    test_target%bond_atom(86) = 12
    test_target%bond_atom(87) = 13
    test_target%bond_atom(88) = 18
    test_target%bond_atom(89) = 44
    test_target%bond_atom(90) = 50
    test_target%bond_atom(91) = 54
    test_target%bond_atom(92) = 1
    test_target%bond_atom(93) = 3
    test_target%bond_atom(94) = 14
    test_target%bond_atom(95) = 15
    test_target%bond_atom(96) = 19
    test_target%bond_atom(97) = 31
    test_target%bond_atom(98) = 33
    test_target%bond_atom(99) = 8
    test_target%bond_atom(100) = 10
    test_target%bond_atom(101) = 14
    test_target%bond_atom(102) = 15
    test_target%bond_atom(103) = 46
    test_target%bond_atom(104) = 50
    test_target%bond_atom(105) = 52
    test_target%bond_atom(106) = 3
    test_target%bond_atom(107) = 5
    test_target%bond_atom(108) = 16
    test_target%bond_atom(109) = 17
    test_target%bond_atom(110) = 21
    test_target%bond_atom(111) = 33
    test_target%bond_atom(112) = 35
    test_target%bond_atom(113) = 10
    test_target%bond_atom(114) = 12
    test_target%bond_atom(115) = 16
    test_target%bond_atom(116) = 17
    test_target%bond_atom(117) = 48
    test_target%bond_atom(118) = 52
    test_target%bond_atom(119) = 54
    test_target%bond_atom(120) = 1
    test_target%bond_atom(121) = 5
    test_target%bond_atom(122) = 13
    test_target%bond_atom(123) = 18
    test_target%bond_atom(124) = 23
    test_target%bond_atom(125) = 31
    test_target%bond_atom(126) = 35
    test_target%bond_atom(127) = 2
    test_target%bond_atom(128) = 6
    test_target%bond_atom(129) = 14
    test_target%bond_atom(130) = 19
    test_target%bond_atom(131) = 24
    test_target%bond_atom(132) = 32
    test_target%bond_atom(133) = 36
    test_target%bond_atom(134) = 20
    test_target%bond_atom(135) = 21
    test_target%bond_atom(136) = 25
    test_target%bond_atom(137) = 27
    test_target%bond_atom(138) = 37
    test_target%bond_atom(139) = 39
    test_target%bond_atom(140) = 43
    test_target%bond_atom(141) = 2
    test_target%bond_atom(142) = 4
    test_target%bond_atom(143) = 16
    test_target%bond_atom(144) = 20
    test_target%bond_atom(145) = 21
    test_target%bond_atom(146) = 32
    test_target%bond_atom(147) = 34
    test_target%bond_atom(148) = 22
    test_target%bond_atom(149) = 23
    test_target%bond_atom(150) = 27
    test_target%bond_atom(151) = 29
    test_target%bond_atom(152) = 39
    test_target%bond_atom(153) = 41
    test_target%bond_atom(154) = 45
    test_target%bond_atom(155) = 4
    test_target%bond_atom(156) = 6
    test_target%bond_atom(157) = 18
    test_target%bond_atom(158) = 22
    test_target%bond_atom(159) = 23
    test_target%bond_atom(160) = 34
    test_target%bond_atom(161) = 36
    test_target%bond_atom(162) = 19
    test_target%bond_atom(163) = 24
    test_target%bond_atom(164) = 25
    test_target%bond_atom(165) = 29
    test_target%bond_atom(166) = 37
    test_target%bond_atom(167) = 41
    test_target%bond_atom(168) = 47
    test_target%bond_atom(169) = 2
    test_target%bond_atom(170) = 8
    test_target%bond_atom(171) = 12
    test_target%bond_atom(172) = 20
    test_target%bond_atom(173) = 24
    test_target%bond_atom(174) = 25
    test_target%bond_atom(175) = 30
    test_target%bond_atom(176) = 26
    test_target%bond_atom(177) = 27
    test_target%bond_atom(178) = 31
    test_target%bond_atom(179) = 33
    test_target%bond_atom(180) = 43
    test_target%bond_atom(181) = 45
    test_target%bond_atom(182) = 49
    test_target%bond_atom(183) = 4
    test_target%bond_atom(184) = 8
    test_target%bond_atom(185) = 10
    test_target%bond_atom(186) = 20
    test_target%bond_atom(187) = 22
    test_target%bond_atom(188) = 26
    test_target%bond_atom(189) = 27
    test_target%bond_atom(190) = 28
    test_target%bond_atom(191) = 29
    test_target%bond_atom(192) = 33
    test_target%bond_atom(193) = 35
    test_target%bond_atom(194) = 45
    test_target%bond_atom(195) = 47
    test_target%bond_atom(196) = 51
    test_target%bond_atom(197) = 6
    test_target%bond_atom(198) = 10
    test_target%bond_atom(199) = 12
    test_target%bond_atom(200) = 22
    test_target%bond_atom(201) = 24
    test_target%bond_atom(202) = 28
    test_target%bond_atom(203) = 29
    test_target%bond_atom(204) = 25
    test_target%bond_atom(205) = 30
    test_target%bond_atom(206) = 31
    test_target%bond_atom(207) = 35
    test_target%bond_atom(208) = 43
    test_target%bond_atom(209) = 47
    test_target%bond_atom(210) = 53
    test_target%bond_atom(211) = 8
    test_target%bond_atom(212) = 14
    test_target%bond_atom(213) = 18
    test_target%bond_atom(214) = 26
    test_target%bond_atom(215) = 30
    test_target%bond_atom(216) = 31
    test_target%bond_atom(217) = 36
    test_target%bond_atom(218) = 19
    test_target%bond_atom(219) = 21
    test_target%bond_atom(220) = 32
    test_target%bond_atom(221) = 33
    test_target%bond_atom(222) = 37
    test_target%bond_atom(223) = 49
    test_target%bond_atom(224) = 51
    test_target%bond_atom(225) = 10
    test_target%bond_atom(226) = 14
    test_target%bond_atom(227) = 16
    test_target%bond_atom(228) = 26
    test_target%bond_atom(229) = 28
    test_target%bond_atom(230) = 32
    test_target%bond_atom(231) = 33
    test_target%bond_atom(232) = 21
    test_target%bond_atom(233) = 23
    test_target%bond_atom(234) = 34
    test_target%bond_atom(235) = 35
    test_target%bond_atom(236) = 39
    test_target%bond_atom(237) = 51
    test_target%bond_atom(238) = 53
    test_target%bond_atom(239) = 12
    test_target%bond_atom(240) = 16
    test_target%bond_atom(241) = 18
    test_target%bond_atom(242) = 28
    test_target%bond_atom(243) = 30
    test_target%bond_atom(244) = 34
    test_target%bond_atom(245) = 35
    test_target%bond_atom(246) = 19
    test_target%bond_atom(247) = 23
    test_target%bond_atom(248) = 31
    test_target%bond_atom(249) = 36
    test_target%bond_atom(250) = 41
    test_target%bond_atom(251) = 49
    test_target%bond_atom(252) = 53
    test_target%bond_atom(253) = 20
    test_target%bond_atom(254) = 24
    test_target%bond_atom(255) = 32
    test_target%bond_atom(256) = 37
    test_target%bond_atom(257) = 42
    test_target%bond_atom(258) = 50
    test_target%bond_atom(259) = 54
    test_target%bond_atom(260) = 1
    test_target%bond_atom(261) = 3
    test_target%bond_atom(262) = 7
    test_target%bond_atom(263) = 38
    test_target%bond_atom(264) = 39
    test_target%bond_atom(265) = 43
    test_target%bond_atom(266) = 45
    test_target%bond_atom(267) = 20
    test_target%bond_atom(268) = 22
    test_target%bond_atom(269) = 34
    test_target%bond_atom(270) = 38
    test_target%bond_atom(271) = 39
    test_target%bond_atom(272) = 50
    test_target%bond_atom(273) = 52
    test_target%bond_atom(274) = 3
    test_target%bond_atom(275) = 5
    test_target%bond_atom(276) = 9
    test_target%bond_atom(277) = 40
    test_target%bond_atom(278) = 41
    test_target%bond_atom(279) = 45
    test_target%bond_atom(280) = 47
    test_target%bond_atom(281) = 22
    test_target%bond_atom(282) = 24
    test_target%bond_atom(283) = 36
    test_target%bond_atom(284) = 40
    test_target%bond_atom(285) = 41
    test_target%bond_atom(286) = 52
    test_target%bond_atom(287) = 54
    test_target%bond_atom(288) = 1
    test_target%bond_atom(289) = 5
    test_target%bond_atom(290) = 11
    test_target%bond_atom(291) = 37
    test_target%bond_atom(292) = 42
    test_target%bond_atom(293) = 43
    test_target%bond_atom(294) = 47
    test_target%bond_atom(295) = 20
    test_target%bond_atom(296) = 26
    test_target%bond_atom(297) = 30
    test_target%bond_atom(298) = 38
    test_target%bond_atom(299) = 42
    test_target%bond_atom(300) = 43
    test_target%bond_atom(301) = 48
    test_target%bond_atom(302) = 7
    test_target%bond_atom(303) = 9
    test_target%bond_atom(304) = 13
    test_target%bond_atom(305) = 44
    test_target%bond_atom(306) = 45
    test_target%bond_atom(307) = 49
    test_target%bond_atom(308) = 51
    test_target%bond_atom(309) = 22
    test_target%bond_atom(310) = 26
    test_target%bond_atom(311) = 28
    test_target%bond_atom(312) = 38
    test_target%bond_atom(313) = 40
    test_target%bond_atom(314) = 44
    test_target%bond_atom(315) = 45
    test_target%bond_atom(316) = 9
    test_target%bond_atom(317) = 11
    test_target%bond_atom(318) = 15
    test_target%bond_atom(319) = 46
    test_target%bond_atom(320) = 47
    test_target%bond_atom(321) = 51
    test_target%bond_atom(322) = 53
    test_target%bond_atom(323) = 24
    test_target%bond_atom(324) = 28
    test_target%bond_atom(325) = 30
    test_target%bond_atom(326) = 40
    test_target%bond_atom(327) = 42
    test_target%bond_atom(328) = 46
    test_target%bond_atom(329) = 47
    test_target%bond_atom(330) = 7
    test_target%bond_atom(331) = 11
    test_target%bond_atom(332) = 17
    test_target%bond_atom(333) = 43
    test_target%bond_atom(334) = 48
    test_target%bond_atom(335) = 49
    test_target%bond_atom(336) = 53
    test_target%bond_atom(337) = 26
    test_target%bond_atom(338) = 32
    test_target%bond_atom(339) = 36
    test_target%bond_atom(340) = 44
    test_target%bond_atom(341) = 48
    test_target%bond_atom(342) = 49
    test_target%bond_atom(343) = 54
    test_target%bond_atom(344) = 1
    test_target%bond_atom(345) = 13
    test_target%bond_atom(346) = 15
    test_target%bond_atom(347) = 37
    test_target%bond_atom(348) = 39
    test_target%bond_atom(349) = 50
    test_target%bond_atom(350) = 51
    test_target%bond_atom(351) = 28
    test_target%bond_atom(352) = 32
    test_target%bond_atom(353) = 34
    test_target%bond_atom(354) = 44
    test_target%bond_atom(355) = 46
    test_target%bond_atom(356) = 50
    test_target%bond_atom(357) = 51
    test_target%bond_atom(358) = 3
    test_target%bond_atom(359) = 15
    test_target%bond_atom(360) = 17
    test_target%bond_atom(361) = 39
    test_target%bond_atom(362) = 41
    test_target%bond_atom(363) = 52
    test_target%bond_atom(364) = 53
    test_target%bond_atom(365) = 30
    test_target%bond_atom(366) = 34
    test_target%bond_atom(367) = 36
    test_target%bond_atom(368) = 46
    test_target%bond_atom(369) = 48
    test_target%bond_atom(370) = 52
    test_target%bond_atom(371) = 53
    test_target%bond_atom(372) = 5
    test_target%bond_atom(373) = 13
    test_target%bond_atom(374) = 17
    test_target%bond_atom(375) = 37
    test_target%bond_atom(376) = 41
    test_target%bond_atom(377) = 49
    test_target%bond_atom(378) = 54
    allocate(test_target%bond_order(54*7))
    test_target%bond_order(1) = 0.268d0
    test_target%bond_order(2) = 0.037d0
    test_target%bond_order(3) = 0.037d0
    test_target%bond_order(4) = 0.037d0
    test_target%bond_order(5) = 0.037d0
    test_target%bond_order(6) = 0.037d0
    test_target%bond_order(7) = 0.037d0
    test_target%bond_order(8) = 0.283d0
    test_target%bond_order(9) = 0.037d0
    test_target%bond_order(10) = 0.037d0
    test_target%bond_order(11) = 0.037d0
    test_target%bond_order(12) = 0.037d0
    test_target%bond_order(13) = 0.037d0
    test_target%bond_order(14) = 0.037d0
    test_target%bond_order(15) = 0.037d0
    test_target%bond_order(16) = 0.268d0
    test_target%bond_order(17) = 0.037d0
    test_target%bond_order(18) = 0.037d0
    test_target%bond_order(19) = 0.037d0
    test_target%bond_order(20) = 0.037d0
    test_target%bond_order(21) = 0.037d0
    test_target%bond_order(22) = 0.283d0
    test_target%bond_order(23) = 0.037d0
    test_target%bond_order(24) = 0.037d0
    test_target%bond_order(25) = 0.037d0
    test_target%bond_order(26) = 0.037d0
    test_target%bond_order(27) = 0.037d0
    test_target%bond_order(28) = 0.037d0
    test_target%bond_order(29) = 0.037d0
    test_target%bond_order(30) = 0.268d0
    test_target%bond_order(31) = 0.037d0
    test_target%bond_order(32) = 0.037d0
    test_target%bond_order(33) = 0.037d0
    test_target%bond_order(34) = 0.037d0
    test_target%bond_order(35) = 0.037d0
    test_target%bond_order(36) = 0.037d0
    test_target%bond_order(37) = 0.283d0
    test_target%bond_order(38) = 0.037d0
    test_target%bond_order(39) = 0.037d0
    test_target%bond_order(40) = 0.037d0
    test_target%bond_order(41) = 0.037d0
    test_target%bond_order(42) = 0.037d0
    test_target%bond_order(43) = 0.037d0
    test_target%bond_order(44) = 0.037d0
    test_target%bond_order(45) = 0.268d0
    test_target%bond_order(46) = 0.037d0
    test_target%bond_order(47) = 0.037d0
    test_target%bond_order(48) = 0.037d0
    test_target%bond_order(49) = 0.037d0
    test_target%bond_order(50) = 0.283d0
    test_target%bond_order(51) = 0.037d0
    test_target%bond_order(52) = 0.037d0
    test_target%bond_order(53) = 0.037d0
    test_target%bond_order(54) = 0.037d0
    test_target%bond_order(55) = 0.037d0
    test_target%bond_order(56) = 0.037d0
    test_target%bond_order(57) = 0.037d0
    test_target%bond_order(58) = 0.037d0
    test_target%bond_order(59) = 0.037d0
    test_target%bond_order(60) = 0.268d0
    test_target%bond_order(61) = 0.037d0
    test_target%bond_order(62) = 0.037d0
    test_target%bond_order(63) = 0.037d0
    test_target%bond_order(64) = 0.283d0
    test_target%bond_order(65) = 0.037d0
    test_target%bond_order(66) = 0.037d0
    test_target%bond_order(67) = 0.037d0
    test_target%bond_order(68) = 0.037d0
    test_target%bond_order(69) = 0.037d0
    test_target%bond_order(70) = 0.037d0
    test_target%bond_order(71) = 0.037d0
    test_target%bond_order(72) = 0.037d0
    test_target%bond_order(73) = 0.037d0
    test_target%bond_order(74) = 0.268d0
    test_target%bond_order(75) = 0.037d0
    test_target%bond_order(76) = 0.037d0
    test_target%bond_order(77) = 0.037d0
    test_target%bond_order(78) = 0.037d0
    test_target%bond_order(79) = 0.283d0
    test_target%bond_order(80) = 0.037d0
    test_target%bond_order(81) = 0.037d0
    test_target%bond_order(82) = 0.037d0
    test_target%bond_order(83) = 0.037d0
    test_target%bond_order(84) = 0.037d0
    test_target%bond_order(85) = 0.037d0
    test_target%bond_order(86) = 0.037d0
    test_target%bond_order(87) = 0.268d0
    test_target%bond_order(88) = 0.037d0
    test_target%bond_order(89) = 0.037d0
    test_target%bond_order(90) = 0.037d0
    test_target%bond_order(91) = 0.037d0
    test_target%bond_order(92) = 0.037d0
    test_target%bond_order(93) = 0.037d0
    test_target%bond_order(94) = 0.283d0
    test_target%bond_order(95) = 0.037d0
    test_target%bond_order(96) = 0.037d0
    test_target%bond_order(97) = 0.037d0
    test_target%bond_order(98) = 0.037d0
    test_target%bond_order(99) = 0.037d0
    test_target%bond_order(100) = 0.037d0
    test_target%bond_order(101) = 0.037d0
    test_target%bond_order(102) = 0.268d0
    test_target%bond_order(103) = 0.037d0
    test_target%bond_order(104) = 0.037d0
    test_target%bond_order(105) = 0.037d0
    test_target%bond_order(106) = 0.037d0
    test_target%bond_order(107) = 0.037d0
    test_target%bond_order(108) = 0.283d0
    test_target%bond_order(109) = 0.037d0
    test_target%bond_order(110) = 0.037d0
    test_target%bond_order(111) = 0.037d0
    test_target%bond_order(112) = 0.037d0
    test_target%bond_order(113) = 0.037d0
    test_target%bond_order(114) = 0.037d0
    test_target%bond_order(115) = 0.037d0
    test_target%bond_order(116) = 0.268d0
    test_target%bond_order(117) = 0.037d0
    test_target%bond_order(118) = 0.037d0
    test_target%bond_order(119) = 0.037d0
    test_target%bond_order(120) = 0.037d0
    test_target%bond_order(121) = 0.037d0
    test_target%bond_order(122) = 0.037d0
    test_target%bond_order(123) = 0.283d0
    test_target%bond_order(124) = 0.037d0
    test_target%bond_order(125) = 0.037d0
    test_target%bond_order(126) = 0.037d0
    test_target%bond_order(127) = 0.037d0
    test_target%bond_order(128) = 0.037d0
    test_target%bond_order(129) = 0.037d0
    test_target%bond_order(130) = 0.268d0
    test_target%bond_order(131) = 0.037d0
    test_target%bond_order(132) = 0.037d0
    test_target%bond_order(133) = 0.037d0
    test_target%bond_order(134) = 0.283d0
    test_target%bond_order(135) = 0.037d0
    test_target%bond_order(136) = 0.037d0
    test_target%bond_order(137) = 0.037d0
    test_target%bond_order(138) = 0.037d0
    test_target%bond_order(139) = 0.037d0
    test_target%bond_order(140) = 0.037d0
    test_target%bond_order(141) = 0.037d0
    test_target%bond_order(142) = 0.037d0
    test_target%bond_order(143) = 0.037d0
    test_target%bond_order(144) = 0.037d0
    test_target%bond_order(145) = 0.268d0
    test_target%bond_order(146) = 0.037d0
    test_target%bond_order(147) = 0.037d0
    test_target%bond_order(148) = 0.283d0
    test_target%bond_order(149) = 0.037d0
    test_target%bond_order(150) = 0.037d0
    test_target%bond_order(151) = 0.037d0
    test_target%bond_order(152) = 0.037d0
    test_target%bond_order(153) = 0.037d0
    test_target%bond_order(154) = 0.037d0
    test_target%bond_order(155) = 0.037d0
    test_target%bond_order(156) = 0.037d0
    test_target%bond_order(157) = 0.037d0
    test_target%bond_order(158) = 0.037d0
    test_target%bond_order(159) = 0.268d0
    test_target%bond_order(160) = 0.037d0
    test_target%bond_order(161) = 0.037d0
    test_target%bond_order(162) = 0.037d0
    test_target%bond_order(163) = 0.283d0
    test_target%bond_order(164) = 0.037d0
    test_target%bond_order(165) = 0.037d0
    test_target%bond_order(166) = 0.037d0
    test_target%bond_order(167) = 0.037d0
    test_target%bond_order(168) = 0.037d0
    test_target%bond_order(169) = 0.037d0
    test_target%bond_order(170) = 0.037d0
    test_target%bond_order(171) = 0.037d0
    test_target%bond_order(172) = 0.037d0
    test_target%bond_order(173) = 0.037d0
    test_target%bond_order(174) = 0.268d0
    test_target%bond_order(175) = 0.037d0
    test_target%bond_order(176) = 0.283d0
    test_target%bond_order(177) = 0.037d0
    test_target%bond_order(178) = 0.037d0
    test_target%bond_order(179) = 0.037d0
    test_target%bond_order(180) = 0.037d0
    test_target%bond_order(181) = 0.037d0
    test_target%bond_order(182) = 0.037d0
    test_target%bond_order(183) = 0.037d0
    test_target%bond_order(184) = 0.037d0
    test_target%bond_order(185) = 0.037d0
    test_target%bond_order(186) = 0.037d0
    test_target%bond_order(187) = 0.037d0
    test_target%bond_order(188) = 0.037d0
    test_target%bond_order(189) = 0.268d0
    test_target%bond_order(190) = 0.283d0
    test_target%bond_order(191) = 0.037d0
    test_target%bond_order(192) = 0.037d0
    test_target%bond_order(193) = 0.037d0
    test_target%bond_order(194) = 0.037d0
    test_target%bond_order(195) = 0.037d0
    test_target%bond_order(196) = 0.037d0
    test_target%bond_order(197) = 0.037d0
    test_target%bond_order(198) = 0.037d0
    test_target%bond_order(199) = 0.037d0
    test_target%bond_order(200) = 0.037d0
    test_target%bond_order(201) = 0.037d0
    test_target%bond_order(202) = 0.037d0
    test_target%bond_order(203) = 0.268d0
    test_target%bond_order(204) = 0.037d0
    test_target%bond_order(205) = 0.283d0
    test_target%bond_order(206) = 0.037d0
    test_target%bond_order(207) = 0.037d0
    test_target%bond_order(208) = 0.037d0
    test_target%bond_order(209) = 0.037d0
    test_target%bond_order(210) = 0.037d0
    test_target%bond_order(211) = 0.037d0
    test_target%bond_order(212) = 0.037d0
    test_target%bond_order(213) = 0.037d0
    test_target%bond_order(214) = 0.037d0
    test_target%bond_order(215) = 0.037d0
    test_target%bond_order(216) = 0.268d0
    test_target%bond_order(217) = 0.037d0
    test_target%bond_order(218) = 0.037d0
    test_target%bond_order(219) = 0.037d0
    test_target%bond_order(220) = 0.283d0
    test_target%bond_order(221) = 0.037d0
    test_target%bond_order(222) = 0.037d0
    test_target%bond_order(223) = 0.037d0
    test_target%bond_order(224) = 0.037d0
    test_target%bond_order(225) = 0.037d0
    test_target%bond_order(226) = 0.037d0
    test_target%bond_order(227) = 0.037d0
    test_target%bond_order(228) = 0.037d0
    test_target%bond_order(229) = 0.037d0
    test_target%bond_order(230) = 0.037d0
    test_target%bond_order(231) = 0.268d0
    test_target%bond_order(232) = 0.037d0
    test_target%bond_order(233) = 0.037d0
    test_target%bond_order(234) = 0.283d0
    test_target%bond_order(235) = 0.037d0
    test_target%bond_order(236) = 0.037d0
    test_target%bond_order(237) = 0.037d0
    test_target%bond_order(238) = 0.037d0
    test_target%bond_order(239) = 0.037d0
    test_target%bond_order(240) = 0.037d0
    test_target%bond_order(241) = 0.037d0
    test_target%bond_order(242) = 0.037d0
    test_target%bond_order(243) = 0.037d0
    test_target%bond_order(244) = 0.037d0
    test_target%bond_order(245) = 0.268d0
    test_target%bond_order(246) = 0.037d0
    test_target%bond_order(247) = 0.037d0
    test_target%bond_order(248) = 0.037d0
    test_target%bond_order(249) = 0.283d0
    test_target%bond_order(250) = 0.037d0
    test_target%bond_order(251) = 0.037d0
    test_target%bond_order(252) = 0.037d0
    test_target%bond_order(253) = 0.037d0
    test_target%bond_order(254) = 0.037d0
    test_target%bond_order(255) = 0.037d0
    test_target%bond_order(256) = 0.268d0
    test_target%bond_order(257) = 0.037d0
    test_target%bond_order(258) = 0.037d0
    test_target%bond_order(259) = 0.037d0
    test_target%bond_order(260) = 0.037d0
    test_target%bond_order(261) = 0.037d0
    test_target%bond_order(262) = 0.037d0
    test_target%bond_order(263) = 0.283d0
    test_target%bond_order(264) = 0.037d0
    test_target%bond_order(265) = 0.037d0
    test_target%bond_order(266) = 0.037d0
    test_target%bond_order(267) = 0.037d0
    test_target%bond_order(268) = 0.037d0
    test_target%bond_order(269) = 0.037d0
    test_target%bond_order(270) = 0.037d0
    test_target%bond_order(271) = 0.268d0
    test_target%bond_order(272) = 0.037d0
    test_target%bond_order(273) = 0.037d0
    test_target%bond_order(274) = 0.037d0
    test_target%bond_order(275) = 0.037d0
    test_target%bond_order(276) = 0.037d0
    test_target%bond_order(277) = 0.283d0
    test_target%bond_order(278) = 0.037d0
    test_target%bond_order(279) = 0.037d0
    test_target%bond_order(280) = 0.037d0
    test_target%bond_order(281) = 0.037d0
    test_target%bond_order(282) = 0.037d0
    test_target%bond_order(283) = 0.037d0
    test_target%bond_order(284) = 0.037d0
    test_target%bond_order(285) = 0.268d0
    test_target%bond_order(286) = 0.037d0
    test_target%bond_order(287) = 0.037d0
    test_target%bond_order(288) = 0.037d0
    test_target%bond_order(289) = 0.037d0
    test_target%bond_order(290) = 0.037d0
    test_target%bond_order(291) = 0.037d0
    test_target%bond_order(292) = 0.283d0
    test_target%bond_order(293) = 0.037d0
    test_target%bond_order(294) = 0.037d0
    test_target%bond_order(295) = 0.037d0
    test_target%bond_order(296) = 0.037d0
    test_target%bond_order(297) = 0.037d0
    test_target%bond_order(298) = 0.037d0
    test_target%bond_order(299) = 0.037d0
    test_target%bond_order(300) = 0.268d0
    test_target%bond_order(301) = 0.037d0
    test_target%bond_order(302) = 0.037d0
    test_target%bond_order(303) = 0.037d0
    test_target%bond_order(304) = 0.037d0
    test_target%bond_order(305) = 0.283d0
    test_target%bond_order(306) = 0.037d0
    test_target%bond_order(307) = 0.037d0
    test_target%bond_order(308) = 0.037d0
    test_target%bond_order(309) = 0.037d0
    test_target%bond_order(310) = 0.037d0
    test_target%bond_order(311) = 0.037d0
    test_target%bond_order(312) = 0.037d0
    test_target%bond_order(313) = 0.037d0
    test_target%bond_order(314) = 0.037d0
    test_target%bond_order(315) = 0.268d0
    test_target%bond_order(316) = 0.037d0
    test_target%bond_order(317) = 0.037d0
    test_target%bond_order(318) = 0.037d0
    test_target%bond_order(319) = 0.283d0
    test_target%bond_order(320) = 0.037d0
    test_target%bond_order(321) = 0.037d0
    test_target%bond_order(322) = 0.037d0
    test_target%bond_order(323) = 0.037d0
    test_target%bond_order(324) = 0.037d0
    test_target%bond_order(325) = 0.037d0
    test_target%bond_order(326) = 0.037d0
    test_target%bond_order(327) = 0.037d0
    test_target%bond_order(328) = 0.037d0
    test_target%bond_order(329) = 0.268d0
    test_target%bond_order(330) = 0.037d0
    test_target%bond_order(331) = 0.037d0
    test_target%bond_order(332) = 0.037d0
    test_target%bond_order(333) = 0.037d0
    test_target%bond_order(334) = 0.283d0
    test_target%bond_order(335) = 0.037d0
    test_target%bond_order(336) = 0.037d0
    test_target%bond_order(337) = 0.037d0
    test_target%bond_order(338) = 0.037d0
    test_target%bond_order(339) = 0.037d0
    test_target%bond_order(340) = 0.037d0
    test_target%bond_order(341) = 0.037d0
    test_target%bond_order(342) = 0.268d0
    test_target%bond_order(343) = 0.037d0
    test_target%bond_order(344) = 0.037d0
    test_target%bond_order(345) = 0.037d0
    test_target%bond_order(346) = 0.037d0
    test_target%bond_order(347) = 0.037d0
    test_target%bond_order(348) = 0.037d0
    test_target%bond_order(349) = 0.283d0
    test_target%bond_order(350) = 0.037d0
    test_target%bond_order(351) = 0.037d0
    test_target%bond_order(352) = 0.037d0
    test_target%bond_order(353) = 0.037d0
    test_target%bond_order(354) = 0.037d0
    test_target%bond_order(355) = 0.037d0
    test_target%bond_order(356) = 0.037d0
    test_target%bond_order(357) = 0.268d0
    test_target%bond_order(358) = 0.037d0
    test_target%bond_order(359) = 0.037d0
    test_target%bond_order(360) = 0.037d0
    test_target%bond_order(361) = 0.037d0
    test_target%bond_order(362) = 0.037d0
    test_target%bond_order(363) = 0.283d0
    test_target%bond_order(364) = 0.037d0
    test_target%bond_order(365) = 0.037d0
    test_target%bond_order(366) = 0.037d0
    test_target%bond_order(367) = 0.037d0
    test_target%bond_order(368) = 0.037d0
    test_target%bond_order(369) = 0.037d0
    test_target%bond_order(370) = 0.037d0
    test_target%bond_order(371) = 0.268d0
    test_target%bond_order(372) = 0.037d0
    test_target%bond_order(373) = 0.037d0
    test_target%bond_order(374) = 0.037d0
    test_target%bond_order(375) = 0.037d0
    test_target%bond_order(376) = 0.037d0
    test_target%bond_order(377) = 0.037d0
    test_target%bond_order(378) = 0.283d0
    test_target%nerror = 0

    call mopac_scf_f(test_in, test_restore, test_out)
    call test_output(test_name, test_in, test_target, test_out, nfail)
end subroutine test_crystal1

subroutine test_moperr(nfail)
    use mopac_api_f
    implicit none
    integer, intent(inout) :: nfail
    type(mopac_system_f) :: test_in
    type(mopac_state_f) :: test_restore
    type(mopac_properties_f) :: test_target
    type(mopac_properties_f) :: test_out
    character(50) :: test_name
    integer :: i
    test_name = 'error handler recovery'

    ! SCF calculation of H2O
    test_in%natom = 3
    test_in%natom_move = 3
    allocate(test_in%atom(3))
    test_in%atom(1) = 1
    test_in%atom(2) = 1
    test_in%atom(3) = 8
    allocate(test_in%coord(3*3))
    test_in%coord(1) = 0.76d0
    test_in%coord(2) = 0.59d0
    test_in%coord(3) = 0.0d0
    test_in%coord(4) = -0.76d0
    test_in%coord(5) = 0.59d0
    test_in%coord(6) = 0.0d0
    test_in%coord(7) = 0.0d0
    test_in%coord(8) = 0.0d0
    test_in%coord(9) = 0.0d0
    test_target%heat = -57.76975d0
    allocate(test_target%coord_update(3*3))
    test_target%coord_update = test_in%coord
    allocate(test_target%coord_deriv(3*3))
    test_target%coord_deriv(1) = 2.307865d0
    test_target%coord_deriv(2) = 2.742432d0
    test_target%coord_deriv(3) = 0.0d0
    test_target%coord_deriv(4) = -2.307865d0
    test_target%coord_deriv(5) = 2.711610d0
    test_target%coord_deriv(6) = 0.0d0
    test_target%coord_deriv(7) = 0.0d0
    test_target%coord_deriv(8) = -5.454042d0
    test_target%coord_deriv(9) = 0.0d0
    allocate(test_target%charge(3))
    test_target%charge(1) = 0.322260d0
    test_target%charge(2) = 0.322260d0
    test_target%charge(3) = -0.644520d0
    test_target%dipole(1) = 0.0d0
    test_target%dipole(2) = 2.147d0
    test_target%dipole(3) = 0.0d0
    test_target%stress(:) = 0.0d0
    allocate(test_target%bond_index(4))
    test_target%bond_index(1) = 1
    test_target%bond_index(2) = 3
    test_target%bond_index(3) = 5
    test_target%bond_index(4) = 8
    allocate(test_target%bond_atom(7))
    test_target%bond_atom(1) = 1
    test_target%bond_atom(2) = 3
    test_target%bond_atom(3) = 2
    test_target%bond_atom(4) = 3
    test_target%bond_atom(5) = 1
    test_target%bond_atom(6) = 2
    test_target%bond_atom(7) = 3
    allocate(test_target%bond_order(7))
    test_target%bond_order(1) = 0.896d0
    test_target%bond_order(2) = 0.895d0
    test_target%bond_order(3) = 0.896d0
    test_target%bond_order(4) = 0.895d0
    test_target%bond_order(5) = 0.895d0
    test_target%bond_order(6) = 0.895d0
    test_target%bond_order(7) = 1.791d0
    test_target%nerror = 0

    ! trigger an API error
    test_in%natom = -1
    call mopac_scf_f(test_in, test_restore, test_out)
    test_in%natom = 3

    call mopac_scf_f(test_in, test_restore, test_out)
    call test_output(test_name, test_in, test_target, test_out, nfail)
end subroutine test_moperr

subroutine test_output(name, input, target, output, nfail)
    use mopac_api_f
    implicit none
    character(50), intent(in) :: name
    type(mopac_system_f), intent(in) :: input
    type(mopac_properties_f), intent(in) :: target, output
    integer, intent(inout) :: nfail
    integer :: i, j
    double precision :: heat_tol, coord_tol, deriv_tol, freq_tol, charge_tol, stress_tol
    double precision, dimension (:,:), allocatable :: fmat1, fmat2, fmat3
    heat_tol = 1d-3
    coord_tol = 1d-3
    deriv_tol = 1d-1
    freq_tol = 3d1
    charge_tol = 1d-3
    stress_tol = 1d-3
    ! compare heat
    if(abs(target%heat - output%heat) > heat_tol) then
        nfail = nfail + 1
        write(*,*) "heat mismatch in test '", trim(name), "':", target%heat, "vs", output%heat
    end if
    ! compare dipole
    do i = 1, 3
        if(abs(target%dipole(i) - output%dipole(i)) > charge_tol) then
            nfail = nfail + 1
            write(*,*) "dipole(", i, ") mismatch in test '", trim(name), "':", target%dipole(i), &
            "vs", output%dipole(i)
        end if
    end do
    ! compare charge
    do i = 1, input%natom
        if(abs(target%charge(i) - output%charge(i)) > charge_tol) then
            nfail = nfail + 1
            write(*,*) "charge(", i, ") mismatch in test '", trim(name), "':", target%charge(i), &
            "vs", output%charge(i)
        end if
    end do
    ! compare updated coordinates
    do i = 1, 3*input%natom_move
        if(abs(target%coord_update(i) - output%coord_update(i)) > coord_tol) then
            nfail = nfail + 1
            write(*,*) "coord_update(", i, ") mismatch in test '", trim(name), "':", &
            target%coord_update(i), "vs", output%coord_update(i)
        end if
    end do
    ! compare coordinate gradients
    do i = 1, 3*input%natom_move
        if(abs(target%coord_deriv(i) - output%coord_deriv(i)) > deriv_tol) then
            nfail = nfail + 1
            write(*,*) "coord_deriv(", i, ") mismatch in test '", trim(name), "':", &
            target%coord_deriv(i), "vs", output%coord_deriv(i)
        end if
    end do
    ! compare vibrational properties
    if(allocated(target%freq) .neqv. allocated(output%freq)) then
        nfail = nfail + 1
        write(*,*) "freq allocation mistmatch in test '", trim(name), "':", allocated(target%freq), &
        "vs", allocated(output%freq)
    else if(allocated(target%freq) .eqv. .true.) then
        do i = 1, 3*input%natom_move
            if(abs(target%freq(i) - output%freq(i)) > freq_tol) then
                nfail = nfail + 1
                write(*,*) "freq(", i, ") mismatch in test '", trim(name), "':", target%freq(i), &
                "vs", output%freq(i)
            end if
        end do
        allocate(fmat1(3*input%natom_move,3*input%natom_move))
        allocate(fmat2(3*input%natom_move,3*input%natom_move))
        allocate(fmat3(3*input%natom_move,3*input%natom_move))
        do i=1, 3*input%natom_move
            fmat3(:,i) = target%disp(:,i)*target%freq(i)
        end do
        fmat1 = matmul(fmat3,transpose(fmat3))
        do i=1, 3*input%natom_move
            fmat3(:,i) = output%disp(:,i)*output%freq(i)
        end do
        fmat2 = matmul(fmat3,transpose(fmat3))
        do i=1, 3*input%natom_move
            do j=1, 3*input%natom_move
                if(abs(fmat1(i,j) - fmat2(i,j)) > freq_tol*freq_tol) then
                    nfail = nfail + 1
                    write(*,*) "fmat(", i, ",", j, ") mismatch in test '", trim(name), "':", fmat1(i,j), &
                    "vs", fmat2(i,j)
                end if
            end do
        end do
        deallocate(fmat1, fmat2, fmat3)
    end if
    ! compare bond-order matrices
    do i = 1, input%natom+1
        if(target%bond_index(i) /= output%bond_index(i)) then
            nfail = nfail + 1
            write(*,*) "bond_index(", i, ") mismatch in test '", trim(name), "':", target%bond_index(i), "vs", output%bond_index(i)
        end if
    end do
    do i = 1, target%bond_index(input%natom+1)-1
        if(target%bond_atom(i) /= output%bond_atom(i)) then
            nfail = nfail + 1
            write(*,*) "bond_atom(", i, ") mismatch in test '", trim(name), "':", target%bond_atom(i), "vs", output%bond_atom(i)
        end if
        if(abs(target%bond_order(i) - output%bond_order(i)) > charge_tol) then
            nfail = nfail + 1
            write(*,*) "bond_order(", i, ") mismatch in test '", trim(name), "':", target%bond_order(i), "vs", output%bond_order(i)
        end if
    end do
    ! compare updated coordinates
    do i = 1, 3*input%nlattice_move
        if(abs(target%lattice_update(i) - output%lattice_update(i)) > coord_tol) then
            nfail = nfail + 1
            write(*,*) "lattice_update(", i, ") mismatch in test '", trim(name), "':", &
            target%lattice_update(i), "vs", output%lattice_update(i)
        end if
    end do
    ! compare coordinate gradients
    do i = 1, 3*input%nlattice_move
        if(abs(target%lattice_deriv(i) - output%lattice_deriv(i)) > deriv_tol) then
            nfail = nfail + 1
            write(*,*) "lattice_deriv(", i, ") mismatch in test '", trim(name), "':", &
            target%lattice_deriv(i), "vs", output%lattice_deriv(i)
        end if
    end do
    ! compare stress
    do i = 1, 6
        if(abs(target%stress(i) - output%stress(i)) > stress_tol) then
            nfail = nfail + 1
            write(*,*) "stress(", i, ") mismatch in test '", trim(name), "':", target%stress(i), &
            "vs", output%stress(i)
        end if
    end do
    ! compare error status
    if(target%nerror /= output%nerror) then
        nfail = nfail + 1
        write(*,*) "nerror mismatch in test '", trim(name), "':", target%nerror, "vs", output%nerror
    end if
end subroutine test_output

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

    subroutine grid
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use chanel_C, only : iw0, iw, iarc, ires, iump, archive_fn, ump_fn, &
      restart_fn
!
      use common_arrays_C, only : geo, xparam, geoa, labels, coord, &
      na, nb, nc, pa, pb, p
!      
      use elemts_C, only : elemnt
!
      use molkst_C, only : nvar, keywrd, tleft, line, norbs, &
      natoms, moperr, uhf, numat, mpack, gui
!
      use maps_C, only : rxn_coord1, rxn_coord2, ione, ijlp, ilp, jlp, jlp1, surf, &
      lpara1, latom1, lpara2, latom2
!
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: npts1, npts2, maxcyc, i, iloop, jloop, j, k, ij, l, &
      iw00, percent = 0, max_count, big_loop, loop, io_stat
      double precision :: step1, step2, degree, c1, c2, cputot, &
        escf, cpu1, cpu2, cpu3, geo11, geo22, sum
      character :: formt*4, num*1
      logical :: restrt, useef, opend, minimize_energy_in_grid = .false., use_p
      double precision, dimension (:), allocatable :: all_points1, all_points2
      double precision, dimension (:,:), allocatable ::  xy, surfac, all_pa, all_pb
      double precision, dimension (:,:,:), allocatable :: all_geo
      integer, dimension (:,:,:), allocatable :: all_nabc
      character :: txt*1
      double precision, external :: reada, seconds
!-----------------------------------------------
      if (allocated(geoa)) deallocate (geoa)
      allocate(geoa(3, natoms))
      geoa = geo
      iw00 = iw0
      iw0 = -1  !  While in "grid", do not print working in other subroutines
      useef = (Index (keywrd, " BFGS") == 0 .or. nvar < 2)
      i = Index (keywrd, "STEP1") + 6
      step1 = reada (keywrd, i)
      i = Index (keywrd, "STEP2") + 6
      step2 = reada (keywrd, i)
      npts1 = 11
      npts2 = 11
      maxcyc = 100000
      minimize_energy_in_grid = (index(keywrd," SMOOTH") /= 0)
      if (Index (keywrd, " BIGCYCLES") /= 0) then
        maxcyc = Nint (reada (keywrd, Index (keywrd, " BIGCYCLES")))
      end if
      if (Index (keywrd, "POINT1") /= 0) then
        npts1 = Nint (Abs(reada (keywrd, Index (keywrd, "POINT1")+7)))
      end if
      if (Index (keywrd, "POINT2") /= 0) then
        npts2 = Nint (Abs(reada (keywrd, Index (keywrd, "POINT2")+7)))
      end if
      restrt = (Index (keywrd, " RESTART") /= 0)
      if (allocated(surf))   deallocate(surf)
      allocate (surf(npts1*npts2), surfac(npts2, npts1), xy(2,npts1*npts2*4))
  !
  !  Basic "SMOOTH" grid - a four-fold ploughed field.
  !
  !   Left to right, down one, right to left, down one, repeat to end of grid.
  !   Reverse this plot
  !   Top to bottom, left one, bottom to top, left one, repeat to end of grid.
  !   Reverse this plot
  !
  !  Set up grid of points for the first pass
  !
      k = 0
      do i = 1,npts1
        do j = 1,npts2
          k = k + 1
          xy(1,k) = i - 1
          if (mod(i,2) == 1) then
            xy(2,k) = j - 1
          else
            xy(2,k) = npts2 - j
          end if
        end do
      end do
      ij = npts1*npts2
  !
  !  Set up grid of points for the second pass
  !
      do i = 1, ij
        k = k + 1
        xy(1,k) = xy(1,ij - i + 1)
        xy(2,k) = xy(2,ij - i + 1)
      end do
  !
  !  Set up grid of points for the third pass
  !
      do j = 1,npts2
        do i = 1,npts1
          k = k + 1
          xy(2,k) = j - 1
          if (mod(j,2) == 1) then
            xy(1,k) = i - 1
          else
            xy(1,k) = npts1 - i
          end if
        end do
      end do
  !
  !  Set up grid of points for the fourth and final pass
  !
      ij = npts1*npts2
      l = 3*ij + 1
      do i = 1, ij
        k = k + 1
        xy(1,k) = xy(1,l - i)
        xy(2,k) = xy(2,l - i)
      end do
     !
     !  THE TOP-LEFT VALUE OF THE FIRST AND SECOND DIMENSIONS ARE
     !      GEO(LPARA1,LATOM1) AND GEO(LPARA2,LATOM2)
     !
      degree = 57.29577951308232d0
      if (lpara1 /= 1) then
        step1 = step1 / degree
      end if
      if (lpara2 /= 1) then
        step2 = step2 / degree
      end if
      geo11 = geo(lpara1, latom1)
      geo22 = geo(lpara2, latom2)
      max_count = 0
      i = npts1*npts2
      if (uhf) then
        j = mpack
      else
        j = 1
      end if
      allocate (all_nabc(i,3,natoms), all_points1(i), all_points2(i), &
              & all_geo(i,3,natoms))
      allocate (all_pa(i,mpack), all_pb(i,j), stat = k)
      use_p = (i == 0)
      surf = 1.d9
      if (lpara1 /= 1 .and. na(latom1) > 0) then
        c1 = degree
      else
        c1 = 1.d0
      end if
      if (lpara2 /= 1 .and. na(latom2) > 0) then
        c2 = degree
      else
        c2 = 1.d0
      end if
      cputot = 0.d0
      if (restrt) then
          open(unit=ires, file=restart_fn, status='UNKNOWN', form='UNFORMATTED', &
          position='asis', iostat = io_stat)
          if (io_stat /= 0) then
            call mopend ("Restart file either does not exist or is not available for reading")
            return
          end if
          rewind ires
          if (nvar > 0) then
            read (ires, iostat = io_stat)i,j
            if ((norbs /= j .or. numat /= i) .and. (norbs /= i .or. numat /= j) ) then
              call mopend("Restart file read in does not match current data set")
              return
            end if
          end if
        if (useef .and. nvar > 1) then
!
!  Dummy read over the EF restart file
!
          do i = 1, 7
            read(ires, iostat = io_stat)txt
            if (txt == "x") j = 1
          end do
        else
          if (nvar > 0) then
            do i = 1, 3
              read(ires, iostat = io_stat)txt
            end do
          end if
        end if
        read(ires, iostat = io_stat) max_count, ijlp, ilp, jlp, jlp1, ione
        read(ires, iostat = io_stat) rxn_coord1, rxn_coord2
        read(ires, iostat = io_stat)all_geo(:max_count,:,:natoms)
        read(ires, iostat = io_stat)all_nabc(:max_count,:,:natoms)
        read(ires, iostat = io_stat)surf(:max_count), all_points1(:max_count), all_points2(:max_count)
      else
        ijlp = 1
      end if
      if ( minimize_energy_in_grid )  then
        big_loop = 4*npts1*npts2
      else
        big_loop = npts1*npts2
      end if
      if (iw00 > -1) &
      call to_screen('       FIRST VARIABLE   SECOND VARIABLE        FUNCTION      DONE LEFT')
 Main_Loop:  do loop = ijlp, big_loop
        if (loop >= maxcyc) then
          tleft = -100.d0
        end if
        geo (lpara1, latom1) = geo11 + xy(1,loop)*step1
        geo (lpara2, latom2) = geo22 + xy(2,loop)*step2
        cpu1 = seconds (2)
        if (useef .and. nvar > 1) then
          call ef (xparam, escf)
        else
          call flepo (xparam, nvar, escf)
        end if
        cpu2 = seconds (2)
        cpu3 = cpu2 - cpu1
        cputot = cputot + cpu3
        jlp = jlp + 1
        ijlp = ijlp + 1
 !
 !  Find the point in all_points1(1:max_count) and all_points2(1:max_count)
 !  defined by geo(lpara1, latom1) and geo(lpara2, latom2).
 !  If it does not exist, then create it.
 !
        k = 0
        do i = 1, max_count
          if( Abs(all_points1(i) - geo (lpara1, latom1)) < 1.d-6) then
            if( Abs(all_points2(i) - geo (lpara2, latom2)) < 1.d-6) then
 !
 !  Point located in "all" arrays
 !
              k = i
              exit
            end if
          end if
          if (k /= 0) exit
        end do
        if (k == 0) then
          max_count = max_count + 1
          k = max_count
          all_points1(k) = geo (lpara1, latom1)
          all_points2(k) = geo (lpara2, latom2)
        end if
 !
 !  If the current escf is lower than the stored value (surf(k)) then store
 !  the current value.
 !
        if (escf + 1.d-10 < surf(k)) then

 !
 !  Store all data for this point
 !
          surf(k) = escf
          do i = 1,natoms
            do j = 1,3
              all_geo(k,j,i) = geo(j,i)
            end do
            all_nabc(k,1,i) = na(i)
            all_nabc(k,2,i) = nb(i)
            all_nabc(k,3,i) = nc(i)
          end do
          if (gui) then
            if (use_p) then
              all_pa(k,:mpack) = pa(:mpack)
              if (uhf) then
                all_pb(k,:mpack) = pb(:mpack)
              end if
            end if
          end if
          write (line, '('' :'',F16.5,F16.5,F21.6, i10,i5)') &
            geo(lpara1,latom1)*c1, geo(lpara2,latom2)*c2, escf, &
            loop , big_loop - loop

          if (iw00 > -1) then
            i = nint((100.0*loop)/big_loop)
            if (i /= percent) then
              percent = i
              write(line,"(i4,a)")percent, "% of Grid Surface done"
              call to_screen(line)
            end if
            call to_screen(line)
          end if
          write(iw,'(a)')trim(line)
          if (index(keywrd, " DEBUG") /= 0) then
            if (index(keywrd, " PDBOUT") /= 0) then
              call pdbout(iw)
            else
              call geout(iw)
            end if
          end if
        end if
        if (tleft < 0.d0 .or. moperr) then
          if (tleft < 0.d0) then
            inquire(unit=ires, opened=opend)
            if (.not. opend) &
              open(unit=ires, file=restart_fn, status='UNKNOWN', form='UNFORMATTED', &
              position='asis', iostat = io_stat)
!
!  Save everything that would be needed by GRID when the job is restarted.
!
            write(ires, iostat = io_stat) max_count, ijlp, ilp, jlp, jlp1, ione
            write(ires, iostat = io_stat) rxn_coord1, rxn_coord2
            write(ires, iostat = io_stat)all_geo(:max_count,:,:natoms)
            write(ires, iostat = io_stat)all_nabc(:max_count,:,:natoms)
            write(ires, iostat = io_stat)surf(:max_count), all_points1(:max_count), all_points2(:max_count)
          end if
          deallocate (surf, surfac)
          return
        end if
      end do   Main_Loop

      if (minimize_energy_in_grid) write(iw,*)" Survey complete.  About to print points"
      do iloop = 1,npts1
        do jloop = 1, npts2
          geo (lpara1, latom1) = geo11 + (iloop - 1)*step1
          geo (lpara2, latom2) = geo22 + (jloop - 1)*step2
!
!  Find the correct point to print
!
          k = 0
          do i = 1, max_count
            if( Abs(all_points1(i) - geo (lpara1, latom1)) < 1.d-6) then
              if( Abs(all_points2(i) - geo (lpara2, latom2)) < 1.d-6) then
!
!  Point has been located in "all" arrays
!
                k = i
                exit
              end if
            end if
          if (k /= 0) exit
          end do
!
!  Restore all data for this point
!
          escf = surf(k)
          do i = 1,natoms
            do j = 1,3
              geo(j,i) = all_geo(k,j,i)
            end do
            na(i) = all_nabc(k,1,i)
            nb(i) = all_nabc(k,2,i)
            nc(i) = all_nabc(k,3,i)
          end do
          surfac(jloop, iloop) = escf
          write (iw, "(/'       FIRST VARIABLE   ',  'SECOND VARIABLE FUNCTION')")
          write (iw, "(' :',F16.5,F16.5,F16.6)") geo(lpara1, latom1)*c1, geo(lpara2, latom2)*c2, escf
          call geout (iw)
          if (index(keywrd, " PRTXYZ") /= 0) then
            write (iw, '(29X,''CARTESIAN COORDINATES '',/)')
            call gmetry(geo, coord)
            l = 0 
            do i = 1, natoms 
              if (labels(i) == 99 .or. labels(i) == 107) cycle
              l = l + 1
              write (iw, '(I4,3X,A2,3x, 3F16.9)') l, elemnt(labels(i)), (coord(k,l),k=1,3) 
            end do
          end if
          if (gui) then
            if (use_p) then
              ij = 0
              do i = 1, norbs
                do j = 1, i
                ij = ij + 1
                pa(ij) = all_pa(k,ij)
                end do
              end do
              if (uhf) then
                ij = 0
                do i = 1, norbs
                  do j = 1, i
                  ij = ij + 1
                  pb(ij) = all_pb(k,ij)
                  end do
                end do
              else
                pa = 0.d0
                pb = 0.d0
              end if
              p = pa + pb
            else
              p = 2*pa
            end if
            call bonds()
          end if
        end do
      end do
      write (iw, "(/10x,'HORIZONTAL: VARYING SECOND PARAMETER,',/10x, &
   & 'VERTICAL:   VARYING FIRST PARAMETER')")
    write (iw, "(/10X,'WHOLE OF GRID, SUITABLE FOR PLOTTING',//)")
   !
   !  ARCHIVE
      inquire (unit=iarc, opened=opend)
      if (opend) then
        close (unit=iarc, status="KEEP")
      end if
      open (unit=iarc, file=archive_fn, status="UNKNOWN")
10000 format (" ARCHIVE FILE FOR GRID CALCULATION"/"GRID OF HEATS" /)
      write (iarc, 10000)
      call wrttxt (iarc)
      write (iarc, "(/' TOTAL JOB TIME IN FLEPO : ',F10.3/)") cputot
   !
   !  WRITE OUT THE GRIDS
   !
      sum = 0.d0
      do i = 1, npts1
        do j = 1, npts2
          if (abs(surfac(j,i)) > sum) sum = abs(surfac(j,i))
        end do
      end do
      if (sum > 0.9999999d3) then
        num = char(ichar("5") + int(log10(sum)))
        formt = " "//num//".1"
      else
        num = char(ichar("7") + int(log10(sum)))
        formt = " "//num//".3"
      end if
      write(iw  ,'('//num//'x,1000f'//formt//')') ((geo22 + (j - 1)*step2)*c2,j=1,npts2)
      write(iarc,'('//num//'x,1000f'//formt//')') ((geo22 + (j - 1)*step2)*c2,j=1,npts2)
      open(unit=iump, file=ump_fn, status='UNKNOWN', position='asis')
      do i = 1, npts1
        write (iw,   '(1000f'//formt//')') (geo11 + (i - 1)*step1)*c1, (surfac(j,i),j=1,npts2)
        write (iarc, '(1000f'//formt//')') (geo11 + (i - 1)*step1)*c1, (surfac(j,i),j=1,npts2)
        do j = 1, npts2
          write (iump, '(2f9.3,F'//formt//')')(rxn_coord1 + step1*(i - 1))*c1, &
          (rxn_coord2 + step2*(j - 1))*c2, surfac(j,i)
        end do
      end do
      close(iump)
    if (allocated(surf)) then
      deallocate (surf, surfac)
    end if
    if (allocated(all_nabc)) &
    deallocate (all_nabc, all_points1, all_points2, all_geo)
    iw0 = iw00
end subroutine grid

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine psort (refers, mode, nmols, reftxt, allref, ifile, l, lp)
    use param_global_C, only : source, maxrfs, contrl
    implicit none
    logical, intent (in) :: lp
    integer, intent (in) :: ifile, mode, nmols
    integer, intent (out) :: l
    character (len=5), dimension (nmols), intent (out) :: reftxt
    character (len=8), dimension (nmols), intent (in) :: refers
    character (len=13), dimension (maxrfs), intent (inout) :: allref
    integer, parameter :: nrefs = 2
    character :: line*120, iw*300, location_of_references(nrefs)*22
    integer :: i, ii, j, m
    logical :: first = .true., exists
    intrinsic :: Index
    data location_of_references / &
    "./REFERENCES.txt     ", &
    "M:/utility/REFERENCES" /
!----------------------------------------------------------------------
    if (mode /= 1) then
      l = 0
      do i = 1, nmols
        if (refers(i) == " ") then
          reftxt (i) = "  "
        else
          do j = 1, l
            if (allref(j) (6:13) == refers(i)) go to 1000
          end do
          l = l + 1
          j = l
          allref(j) (6:13) = refers(i)
1000      reftxt(i) = " "
          write(reftxt(i),'(i5)')j
          allref(j) (1:5) = reftxt(i)
        end if
      end do
      if ( .not. lp) return
    end if
    i = index(contrl, 'REFERENCES="') + 12
    if (i /= 12) then
      j = index(contrl(i:), '"') + i - 2
      iw = trim(contrl(i:j))
      call add_path(iw)
      inquire (file=trim(iw), exist = exists)
    else
      do i = 1, nrefs
        inquire (file=trim(location_of_references(i)), exist = exists)
        if (exists) then
          iw = trim(location_of_references(i))
          exit
        end if
      end do
    end if
    if (exists) then
      open (14, status="UNKNOWN", file=trim(iw), blank="ZERO")
      rewind (14)
    end if
    m = l
    do i = 1, l
      source (3, i) = "      *+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+* +&
     &* "
      source (2, i) = "      *+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+* +&
     &* "
      source (1, i) = " " // allref (i) (5:12) // " NO REFERENCE *+*+*+*+" // &
     & "*+*+*+*+*+*+*+*+*+*"
    end do
    do ii = 1, 10000
      read (14, "(A)", end=1200, err=1200) line
!
! Having read in one reference, is that reference used by this run?
! Check mnemonics only
!
      do j = 1, l
        i = Index(line, " "//allref(j) (6:13))
        if (i /= 0) go to 1100
      end do
!
! Have references become messed up?  References mnemonics should have less than 10 characters
!
      if (line(11:) /= " ") then
        if(first) then
          first = .false.
          write(ifile,*)" Some mnemonics apear to be out-of sequence.  These include:"
        end if
        write(ifile,"(a)")line
      end if
!
! Reference is NOT used, therefore skip over next three lines
!
      read (14, "(A)", end=1200, err=1200) line, line, line
      cycle
1100  read (14, "(A)", end=1200, err=1200) source (1, j), source (2, j), &
     & source(3, j)
      m = m - 1
    end do
1200 close (14)
    do i = 1, l
      write (ifile,*)
      iw = source(1, i)
      if (source(2, i) /= " ") then
        iw(len_trim(iw) + 2:) = source(2, i)
        if (source(3, i) /= " ") then
          iw(len_trim(iw) + 2:) = source(3, i)
        end if
      end if
      if (index(iw, " NO REFERENCE") == 0) then
        write (ifile, "(A)")  allref (i) (1:5) // ":" // trim(iw)
      else
        write (ifile, "(A)")  allref (i) (1:5) // ": " // trim(iw(3:))
      end if
    end do
end subroutine psort

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine matou1(a, b, ncx, nr, ndim, iflag)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : numat, norbs, nalpha, nclose, keywrd
      use common_arrays_C, only : nfirst, nlast, nat
      use chanel_C, only : iw
      use elemts_C, only : elemnt
      use to_screen_C, only : to_a, to_b
      USE symmetry_C, only :  jndex, namo
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: ncx
      integer , intent(inout) :: nr
      integer , intent(in) :: ndim
      integer , intent(in) :: iflag
      double precision , intent(in) :: a(nr,nr)
      double precision , intent(in) :: b(ndim)

!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(nr) :: natom
      integer :: nc, nsave, nfix, i, jlo, jhi, l, j, ka, kc, kb, la, lc, lb, &
        nup, ndown
      logical :: allprt
      character , dimension(9) :: atorbs*2
      character , dimension(nr) :: itext*2, jtext*2
      character, dimension(3) :: xyz*2

      save atorbs, xyz
!-----------------------------------------------
!**********************************************************************
!
!      MATOUT PRINTS A SQUARE MATRIX OF EIGENVECTORS AND EIGENVALUES
!
!    ON INPUT A CONTAINS THE MATRIX TO BE PRINTED.
!             B CONTAINS THE EIGENVALUES.
!             NC NUMBER OF MOLECULAR ORBITALS TO BE PRINTED.
!             NR IS THE SIZE OF THE SQUARE ARRAY TO BE PRINTED.
!             NDIM IS THE ACTUAL SIZE OF THE SQUARE ARRAY "A".
!             NFIRST AND NLAST CONTAIN ATOM ORBITAL COUNTERS.
!             NAT = ARRAY OF ATOMIC NUMBERS OF ATOMS.
!
!
!     OUTPUT TYPE (ROW LABELING)
!       IFLAG=1 : ORBITALS
!       IFLAG=2 : ORBITALS + SYMMETRY-DESIGNATORS
!       IFLAG=3 : ATOMS
!       IFLAG=4 : NUMBERS ONLY
!       IFLAG=5 : VIBRATIONS + SYMMETRY-DESIGNATIONS
!
!
!***********************************************************************
      data xyz/ ' x', ' y', ' z'/
      data atorbs/ 'S ', 'Px', 'Py', 'Pz', 'x2', 'xz', 'z2', 'yz', 'xy'/
!      -------------------------------------------------
      nfix = 0
      allprt = index(keywrd,'ALLVEC') /= 0
      i = index(keywrd," VECTORS")
      nup = 7
      ndown = 9
      if (i > 0) then
        do j = i + 1, i + 20
          if (keywrd(j:j) == " ") exit
        end do
        if (index(keywrd(i:j), ")") > 0) then
!
!  User has specified number of occupied and virtual M.O.s to be printed
!  Format:  VECTORS=(12,34)
!
        do i = i + 1, j
            if (keywrd(i:i) >= "0" .and. keywrd(i:i) <= "9") exit
          end do
          ndown = ichar(keywrd(i:i)) - ichar("0")
          do i = i + 1, j
            if (keywrd(i:i) < "0" .or. keywrd(i:i) > "9") exit
            ndown = ndown*10 + ichar(keywrd(i:i)) - ichar("0")
          end do
          do i = i, j
            if (keywrd(i:i) >= "0" .and. keywrd(i:i) <= "9") exit
          end do
          nup = ichar(keywrd(i:i)) - ichar("0")
          do i = i + 1, j
            if (keywrd(i:i) < "0" .or. keywrd(i:i) > "9") exit
            nup = nup*10 + ichar(keywrd(i:i)) - ichar("0")
          end do
        end if
        ndown = ndown - 1
        if (nup == -16) then
          nup = (ndown + 1)/2
          ndown = ndown - nup
        end if
      end if
      nc = ncx
      if (iflag > 2 .and. iflag /= 5) go to 50
      if ( .not. allprt) then
        nsave = ncx
        nfix = max(nalpha,nclose)
        if (iflag == 2 .and. nc > 16) nc = nfix + nup
        nc = min0(nsave,nc)
      end if
      if (numat == 0) go to 50
      if (nlast(numat) /= nr) go to 50
      do i = 1, numat
        jlo = nfirst(i)
        jhi = nlast(i)
        l = nat(i)
        if (iflag <= 2) then
          itext(jlo:jhi) = atorbs(:jhi-jlo+1)
          jtext(jlo:jhi) = elemnt(l)
          natom(jlo:jhi) = i
        else
          jhi = 3*(i - 1)
          itext(1+jhi:3+jhi) = xyz
          jtext(1+jhi:3+jhi) = elemnt(l)
          natom(1+jhi:3+jhi) = i
        end if
      end do
      go to 70
   50 continue
      nr = abs(nr)
      if (iflag == 3) then
        do i = 1, nr
          itext(i) = '  '
          jtext(i) = elemnt(nat(i))
          natom(i) = i
        end do
      else
        do i = 1, nr
          itext(i) = '  '
          jtext(i) = '  '
          natom(i) = i
        end do
      end if
   70 continue
      ka = 1
      kc = 8
      if (.not.allprt) then
        if (iflag == 2 .and. norbs > 16) ka = nfix - ndown
        ka = max0(1,ka)
        if (iflag == 2 .and. norbs > 16) kc = ka + 7
      end if
   90 continue
      kb = min0(kc,nc)
      write (iw, 130) (i,i=ka,kb)
      if (iflag == 2 .or. iflag == 5) write (iw, 180) (jndex(i),namo(i),i=ka,kb)
      if (b(1) /= 0.D0) then
        if (iflag == 5) then
          write (iw, 150) (b(i),i=ka,kb)
        else
          write (iw, 140) (b(i),i=ka,kb)
        end if
      end if
      write (iw, 160)
      la = 1
      lc = 40
  100 continue
      lb = min0(lc,nr)
      do i = la, lb
        if (itext(i) == ' S') write (iw, 160)
        write (iw, 170) itext(i), jtext(i), natom(i), (a(i,j),j=ka,kb)
      end do
      if (lb == nr) go to 120
      la = lc + 1
      lc = lc + 40
      go to 100
  120 continue
      if (kb == nc) then
        if (allocated (to_a)) deallocate(to_a)
        if (allocated (to_b)) deallocate(to_b)
        allocate(to_a(nr,nr), to_b(ndim))
        to_a = a
        to_b = b
        deallocate(to_a, to_b)
        return
      end if
      ka = kc + 1
      kc = kc + 8
      go to 90

  130 format(/,/,2x,' Root No.',i8,11i10)
  140 format(/,12x,10f10.3)
  150 format(/,12x,10f10.1)
  160 format('  ')
  170 format(' ',2(1x,a2),i5,f10.4,10f10.4)
  180 format(/,13x,10(i5,1x,a4))
      end subroutine matou1

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine supdot(s, h, g, n)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n
      double precision , intent(inout) :: s(*)
      double precision , intent(in) :: h(*)
      double precision , intent(in) :: g(*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: k, i, j
      double precision :: sum, gi
!-----------------------------------------------
!     (S)=(H)*(G) WITH  H  IN PACKED FORM (CANONICAL ORDER).
      k = 0
      do i = 1, n
        sum = 0.D0
        do j = 1, i
          sum = sum + g(j)*h(k+j)
        end do
        s(i) = sum
        k = k + i
      end do
      if (n == 1) return
      k = 1
      do i = 2, n
        gi = g(i)
        s(:i-1) = s(:i-1) + h(k+1:i-1+k)*gi
        k = k + i
      end do
      return
      end subroutine supdot

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine haddon (w, l, m, loc, a, na, fact)
!**********************************************************************
!
!   HADDON CALCULATES THE VALUE OF A SYMMETRY-DEPENDENT VARIABLE
!
!  ON INPUT: M   = NUMBER SPECIFYING THE SYMMETRY OPERATION
!            LOC = ADDRESS OF REFERENCE ATOM
!            A   = ARRAY OF INTERNAL COORDINATES
!  ON OUTPUT W   = VALUE OF DEPENDENT FUNCTION
!            L   = 1 (FOR BOND LENGTH), 2 (ANGLE), OR 3 (DIHEDRAL)
!**********************************************************************
    use common_systm
    implicit none
    integer, intent (in) :: loc, m, na(natoms + 3)
    integer, intent (out) :: l
    double precision, intent (in) :: fact, a(3,natoms + 3)
    double precision, intent (out) :: w
    integer :: i
    double precision :: pi
    pi = 2.d0 * Asin (1.d0)
    if (m > 19 .or. m < 1) then
      write (iw, "(///10X,'UNDEFINED SYMMETRY FUNCTION',I3, ' USED')") m
    end if
    i = loc
    if (na(i) == 0) then
      select case (m)
      case (1)
!
!   Start of Cartesian relationships.
!
!                          X = X
        l = 1
        w = a(1, i)
        return
      case (2)
!                          Y = Y
        l = 2
        w = a(2, i)
        return
      case (3)
!                          Z = Z
        l = 3
        w = a(3, i)
        return
      case (4)
!                          X = -X
        l = 1
        w = -a(1, i)
        return
      case (5)
!                          Y = -Y
        l = 2
        w = -a(2, i)
        return
      case (6)
!                          Z = -Z
        l = 3
        w = -a(3, i)
        return
      case (7)
!                          X = Y
        l = 1
        w = a(2, i)
        return
      case (8)
!                          Y = Z
        l = 2
        w = a(3, i)
        return
      case (9)
!                          Z = X
        l = 3
        w = a(1, i)
        return
      case (10)
!                          X = -Y
        l = 1
        w = -a(2, i)
        return
      case (11)
!                          Y = -Z
        l = 2
        w = -a(3, i)
        return
      case (12)
!                          Z = -X
        l = 3
        w = -a(1, i)
        return
      case (13)
!                          X = Z
        l = 1
        w = a(3, i)
        return
      case (14)
!                          Y = X
        l = 2
        w = a(1, i)
        return
      case (15)
!                          Z = Y
        l = 3
        w = a(2, i)
        return
      case (16)
!                          X = -Z
        l = 1
        w = -a(3, i)
        return
      case (17)
!                          Y = -X
        l = 2
        w = -a(1, i)
        return
      case (18, 19)
!                          Z = -Y
        l = 3
        w = -a(2, i)
        return
      case default
      end select
    else
      select case (m)
      case (2)
!
!  Set bond-angles equal
!
        l = 2
        w = a(2, i)
        return
      case (3)
!
!  Set dihedrals equal
!
        w = a(3, i)
      case (4)
        w = (pi/2.0d00) - a(3, i)
      case (5)
        w = (pi/2.0d00) + a(3, i)
      case (6)
        w = (2.0d00*pi/3.0d00) - a(3, i)
      case (7)
        w = (2.0d00*pi/3.0d00) + a(3, i)
      case (8)
        w = pi - a(3, i)
      case (9)
        w = pi + a(3, i)
      case (10)
        w = (4.0d00*pi/3.0d00) - a(3, i)
      case (11)
        w = (4.0d00*pi/3.0d00) + a(3, i)
      case (12)
        w = (3.0d00*pi/2.0d00) - a(3, i)
      case (13)
        w = (3.0d00*pi/2.0d00) + a(3, i)
      case (14)
        w = -a(3, i)
      case (15)
        l = 1
        w = a(1, i) / 2.0d00
        return
      case (16)
        l = 2
        w = a(2, i) / 2.0d00
        return
      case (17)
        l = 2
        w = pi - a(2, i)
        return
      case (18, 19)
        l = 1
        w = a(1, i) * fact
        return
      case default
        go to 1000
      end select
      l = 3
      return
    end if
!
!  Set bond-lengths equal
!
1000 l = 1
    w = a(1, i)
end subroutine haddon

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  subroutine alpb_and_xfac_pm3
    use parameters_C, only : xfac, alpb
    alpb = 0.d0
    xfac = 0.d0
    !
    alpb(11, 1) =   1.800472d0 !      Sodium -     Hydrogen
    xfac(11, 1) =   3.171946d0 !      Sodium -     Hydrogen
    alpb(11, 6) =   1.321600d0 !      Sodium -       Carbon
    xfac(11, 6) =   0.876072d0 !      Sodium -       Carbon
    alpb(11, 7) =   0.999895d0 !      Sodium -     Nitrogen
    xfac(11, 7) =   0.295812d0 !      Sodium -     Nitrogen
    alpb(11, 8) =   2.116028d0 !      Sodium -       Oxygen
    xfac(11, 8) =   3.392634d0 !      Sodium -       Oxygen
    alpb(11, 9) =   1.860719d0 !      Sodium -     Fluorine
    xfac(11, 9) =   1.605474d0 !      Sodium -     Fluorine
    alpb(11,11) =   1.024150d0 !      Sodium -       Sodium
    xfac(11,11) =   1.126080d0 !      Sodium -       Sodium
    !
    alpb(16,11) =   0.999990d0 !      Sulfur -       Sodium
    xfac(16,11) =   0.241710d0 !      Sulfur -       Sodium
    !
    alpb(17,11) =   1.420756d0 !    Chlorine -       Sodium
    xfac(17,11) =   1.168589d0 !    Chlorine -       Sodium
    !
    alpb(19, 1) =   1.027701d0 !   Potassium -     Hydrogen
    xfac(19, 1) =   0.893642d0 !   Potassium -     Hydrogen
    alpb(19, 6) =   1.453975d0 !   Potassium -       Carbon
    xfac(19, 6) =   2.009100d0 !   Potassium -       Carbon
    alpb(19, 7) =   0.999984d0 !   Potassium -     Nitrogen
    xfac(19, 7) =   0.425244d0 !   Potassium -     Nitrogen
    alpb(19, 8) =   1.470651d0 !   Potassium -       Oxygen
    xfac(19, 8) =   0.999945d0 !   Potassium -       Oxygen
    alpb(19, 9) =   0.999898d0 !   Potassium -     Fluorine
    xfac(19, 9) =   0.342063d0 !   Potassium -     Fluorine
    alpb(19,16) =   1.000576d0 !   Potassium -       Sulfur
    xfac(19,16) =   0.584513d0 !   Potassium -       Sulfur
    alpb(19,17) =   0.999989d0 !   Potassium -     Chlorine
    xfac(19,17) =   0.584823d0 !   Potassium -     Chlorine
    alpb(19,19) =   1.532875d0 !   Potassium -    Potassium
    xfac(19,19) =   8.250024d0 !   Potassium -    Potassium
    !
    alpb(20, 1) =   1.427846d0 !     Calcium -     Hydrogen
    xfac(20, 1) =   1.805489d0 !     Calcium -     Hydrogen
    alpb(20, 6) =   0.999993d0 !     Calcium -       Carbon
    xfac(20, 6) =   0.320183d0 !     Calcium -       Carbon
    alpb(20, 7) =   0.999993d0 !     Calcium -     Nitrogen
    xfac(20, 7) =   0.275261d0 !     Calcium -     Nitrogen
    alpb(20, 8) =   1.934512d0 !     Calcium -       Oxygen
    xfac(20, 8) =   0.480203d0 !     Calcium -       Oxygen
    alpb(20, 9) =   1.964914d0 !     Calcium -     Fluorine
    xfac(20, 9) =   0.594612d0 !     Calcium -     Fluorine
    alpb(20,16) =   0.999960d0 !     Calcium -       Sulfur
    xfac(20,16) =   0.212682d0 !     Calcium -       Sulfur
    alpb(20,17) =   1.669363d0 !     Calcium -     Chlorine
    xfac(20,17) =   0.928683d0 !     Calcium -     Chlorine
    alpb(20,20) =   0.999174d0 !     Calcium -      Calcium
    xfac(20,20) =   3.160373d0 !     Calcium -      Calcium
    !
    !
    alpb(35,11) =   1.517965d0 !     Bromine -       Sodium
    xfac(35,11) =   1.741658d0 !     Bromine -       Sodium
    alpb(35,19) =   1.401604d0 !     Bromine -    Potassium
    xfac(35,19) =   2.440790d0 !     Bromine -    Potassium
    alpb(35,20) =   1.509690d0 !     Bromine -      Calcium
    xfac(35,20) =   0.874420d0 !     Bromine -      Calcium
    !
    alpb(37, 1) =   2.066936d0 !    Rubidium -     Hydrogen
    xfac(37, 1) =   9.999919d0 !    Rubidium -     Hydrogen
    alpb(37, 5) =   1.996668d0 !    Rubidium -        Boron
    xfac(37, 5) =  10.000119d0 !    Rubidium -        Boron
    alpb(37, 8) =   1.999948d0 !    Rubidium -       Oxygen
    xfac(37, 8) =   1.817233d0 !    Rubidium -       Oxygen
    alpb(37, 9) =   3.083855d0 !    Rubidium -     Fluorine
    xfac(37, 9) =  10.000006d0 !    Rubidium -     Fluorine
    alpb(37,17) =   2.371423d0 !    Rubidium -     Chlorine
    xfac(37,17) =   9.970607d0 !    Rubidium -     Chlorine
    alpb(37,35) =   2.071332d0 !    Rubidium -      Bromine
    xfac(37,35) =   7.407687d0 !    Rubidium -      Bromine
    alpb(37,37) =   0.539344d0 !    Rubidium -     Rubidium
    xfac(37,37) =   2.654922d0 !    Rubidium -     Rubidium
    !
    alpb(38, 1) =   1.385332d0 !   Strontium -     Hydrogen
    xfac(38, 1) =   7.195639d0 !   Strontium -     Hydrogen
    alpb(38, 6) =   1.392807d0 !   Strontium -       Carbon
    xfac(38, 6) =   5.455084d0 !   Strontium -       Carbon
    alpb(38, 7) =   1.392514d0 !   Strontium -     Nitrogen
    xfac(38, 7) =   5.293460d0 !   Strontium -     Nitrogen
    alpb(38, 8) =   2.471371d0 !   Strontium -       Oxygen
    xfac(38, 8) =   2.147711d0 !   Strontium -       Oxygen
    alpb(38, 9) =   2.525416d0 !   Strontium -     Fluorine
    xfac(38, 9) =   5.359983d0 !   Strontium -     Fluorine
    alpb(38,16) =   1.045944d0 !   Strontium -       Sulfur
    xfac(38,16) =   0.594774d0 !   Strontium -       Sulfur
    alpb(38,17) =   1.473507d0 !   Strontium -     Chlorine
    xfac(38,17) =   1.176805d0 !   Strontium -     Chlorine
    alpb(38,35) =   1.338861d0 !   Strontium -      Bromine
    xfac(38,35) =   1.082828d0 !   Strontium -      Bromine
    alpb(38,38) =   1.393785d0 !   Strontium -    Strontium
    xfac(38,38) =   5.138251d0 !   Strontium -    Strontium
    !
    alpb(53,11) =   1.148784d0 !      Iodine -       Sodium
    xfac(53,11) =   0.747959d0 !      Iodine -       Sodium
    alpb(53,19) =   1.402113d0 !      Iodine -    Potassium
    xfac(53,19) =   2.568324d0 !      Iodine -    Potassium
    alpb(53,20) =   1.513600d0 !      Iodine -      Calcium
    xfac(53,20) =   0.856865d0 !      Iodine -      Calcium
    alpb(53,38) =   1.730393d0 !      Iodine -    Strontium
    xfac(53,38) =   3.855491d0 !      Iodine -    Strontium
    !
    alpb(55, 1) =   1.448617d0 !      Cesium -     Hydrogen
    xfac(55, 1) =   6.721688d0 !      Cesium -     Hydrogen
    alpb(55, 6) =   0.999871d0 !      Cesium -       Carbon
    xfac(55, 6) =   5.579858d0 !      Cesium -       Carbon
    alpb(55, 7) =   0.999559d0 !      Cesium -     Nitrogen
    xfac(55, 7) =   0.242498d0 !      Cesium -     Nitrogen
    alpb(55, 8) =   3.222538d0 !      Cesium -       Oxygen
    xfac(55, 8) =   7.547802d0 !      Cesium -       Oxygen
    alpb(55, 9) =   2.748652d0 !      Cesium -     Fluorine
    xfac(55, 9) =   3.360596d0 !      Cesium -     Fluorine
    alpb(55,15) =   0.999863d0 !      Cesium -   Phosphorus
    xfac(55,15) =   0.099894d0 !      Cesium -   Phosphorus
    alpb(55,16) =   0.999607d0 !      Cesium -       Sulfur
    xfac(55,16) =   0.869429d0 !      Cesium -       Sulfur
    alpb(55,17) =   0.999578d0 !      Cesium -     Chlorine
    xfac(55,17) =   0.288955d0 !      Cesium -     Chlorine
    alpb(55,35) =   0.999651d0 !      Cesium -      Bromine
    xfac(55,35) =   0.350614d0 !      Cesium -      Bromine
    alpb(55,53) =   0.998419d0 !      Cesium -       Iodine
    xfac(55,53) =   0.377054d0 !      Cesium -       Iodine
    alpb(55,55) =   0.997434d0 !      Cesium -       Cesium
    xfac(55,55) =   8.549732d0 !      Cesium -       Cesium
    !
    alpb(56, 1) =   0.999997d0 !      Barium -     Hydrogen
    xfac(56, 1) =   0.099997d0 !      Barium -     Hydrogen
    alpb(56, 6) =   0.999997d0 !      Barium -       Carbon
    xfac(56, 6) =   0.099997d0 !      Barium -       Carbon
    alpb(56, 7) =   0.999997d0 !      Barium -     Nitrogen
    xfac(56, 7) =   0.099997d0 !      Barium -     Nitrogen
    alpb(56, 8) =   1.249857d0 !      Barium -       Oxygen
    xfac(56, 8) =   0.352542d0 !      Barium -       Oxygen
    alpb(56, 9) =   1.886689d0 !      Barium -     Fluorine
    xfac(56, 9) =   1.528347d0 !      Barium -     Fluorine
    alpb(56,16) =   0.999862d0 !      Barium -       Sulfur
    xfac(56,16) =   0.904098d0 !      Barium -       Sulfur
    alpb(56,17) =   1.490059d0 !      Barium -     Chlorine
    xfac(56,17) =   1.846584d0 !      Barium -     Chlorine
    alpb(56,35) =   1.628325d0 !      Barium -      Bromine
    xfac(56,35) =   3.652542d0 !      Barium -      Bromine
    alpb(56,53) =   1.461169d0 !      Barium -       Iodine
    xfac(56,53) =   2.514512d0 !      Barium -       Iodine
    alpb(56,56) =   0.999997d0 !      Barium -       Barium
    xfac(56,56) =   0.099997d0 !      Barium -       Barium
    !
  end subroutine alpb_and_xfac_pm3

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      double precision  function aababc (iocca1, ioccb1, iocca2, nmos, xy)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE meci_C, only : occa
!***********************************************************************
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: nmos
      integer , intent(in) :: iocca1(nmos)
      integer , intent(in) :: ioccb1(nmos)
      integer , intent(in) :: iocca2(nmos)
      double precision , intent(in) :: xy(nmos,nmos,nmos,nmos)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, ij, j, k
      double precision :: sum
!-----------------------------------------------
!**********************************************************************
!
! AABABC EVALUATES THE C.I. MATRIX ELEMENT FOR TWO MICROSTATES DIFFERING
!       BY ONE ALPHA ELECTRON. THAT IS, ONE MICROSTATE HAS AN ALPHA
!       ELECTRON IN PSI(I) WHICH, IN THE OTHER MICROSTATE, IS IN PSI(J)
!
!**********************************************************************
      do i = 1, nmos
        if (iocca1(i) == iocca2(i)) cycle
        exit
      end do
      ij = ioccb1(i)
      do j = i + 1, nmos
        if (iocca1(j) /= iocca2(j)) exit
        ij = ij + iocca1(j) + ioccb1(j)
      end do
      sum = 0.D0
      do k = 1, nmos
        sum = sum + (xy(i,j,k,k)-xy(i,k,j,k))*(iocca1(k)-occa(k)) + &
        xy(i,j,k,k)*(ioccb1(k)-occa(k))
      end do
      if (mod(ij,2) == 1) sum = -sum
      aababc = sum
      return
      end function aababc

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      module ef_C
      integer :: ef_mode, nstep, negreq, iprnt, iloop
      double precision :: ddx, rmin, rmax, omin = 0.d0, xlamd, xlamd0, skal, x0, x1, x2
      double precision, dimension(:), allocatable :: oldf, d, vmode, pmat, uc, hessc
      double precision, dimension(:,:), allocatable :: hess, bmat, u, oldhss, oldu, alparm
      end module ef_C
      module drc_C
        double precision, dimension(:), allocatable :: vref, vref0, now
        double precision, dimension(:,:), allocatable :: allxyz, allvel, xyz3, vel3, allgeo, geo3, georef
        double precision, dimension(:), allocatable :: parref
        double precision :: time
      end module drc_C
      module derivs_C
        double precision, dimension(:), allocatable :: wmat, hmat, fmat
        double precision, dimension(:,:), allocatable  :: b, ab, fb
          double precision, dimension(:), allocatable :: aidref, work2
      end module derivs_C

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine mxm(a, nar, b, nbr, c, ncc)
      implicit none
      integer  :: nar
      integer  :: nbr
      integer  :: ncc
      double precision  :: a(nar,nbr)
      double precision  :: b(nbr,ncc)
      double precision  :: c(nar,ncc)
!
!     RECTANGULAR MATRIX PRODUCT C=A*B.
!     EACH MATRIX IS ENTIRELY FULLFILLED AND PACKED.
!
      call dgemm ('N', 'N', nar, ncc, nbr, 1.0D0, a, nar, b, nbr, 0.0D0, c, nar)
      return
      end subroutine mxm

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine parfg (errors, ttype, nerr, loop, do_scf)
  !**********************************************************************
  !
  ! PARFG computes the values of the errors for molecule number LOOP
  !       using the current set of parameters.
  !
  !  On exit  ERRORS = Array of errors for reference functions
  !           NERR   = Number of errors in ERRORS
  !           TTYPE  = (text): name of the type of reference function.
  !
  !**********************************************************************
    use molkst_C, only : last, emin, escf, nclose, nopen, fract, &
    & nscf,  nvar, numat, rjkab1
    use param_global_C, only : ifiles_8, ihrefs, hofcal, refgeo, refher, &
     refder, refcer, refger, reftot, wtgeo, wthof, refhof, wtips, refips, &
    & wtdip, refdip, wtz, refpKa, wtpKa, atom_pKa, atom_pKa_O, &
    spin_state, i_r, qn
    use parameters_C, only : uss, upp, udd, zs, tore
    use meci_C, only : eig, lab, ispin, nelec, labsiz
    use funcon_C, only : fpc_9
    use symmetry_C, only : namo, jndex
    use cosmo_C, only: useps, area
    use common_arrays_C, only :  nat, coord, nfirst, nlast,  uspd, &
    & xparam, grad, eigs, loc, p, c
    implicit none
    double precision, dimension (300), intent (out) :: errors
    character (len=20), dimension (300), intent (out) :: ttype
    integer, intent (out) :: nerr
    integer, intent (in) :: loop
    logical :: do_scf
    integer :: i, ndif, nopn, loop_ref, j, qn_temp(20,20), irep(20), m, l, k, &
      iloop = -10
    double precision :: caldip, calhof, calips, cerr, derr, gerr, herr, toterr, &
    & sum
    double precision, dimension (300) :: q
    character , dimension(10) :: tspin*8
    double precision, external :: meci, parips, pardip, pargeo
    character :: srep(1000)*4
    save :: ndif, nopn, loop_ref, iloop
    data tspin/ 'SINGLET ', 'DOUBLET ', 'TRIPLET ', 'QUARTET ', 'QUINTET ', &
      'SEXTET  ', 'SEPTET  ', 'OCTET   ', 'NONET   ', '??????? '/
!-----------------------------------------------------------------------
  !
  !  Need to fill USPD - this would normally be filled in MOLDAT...
  !
     call filusp (nat, nfirst, nlast, uspd)
  !***********************************************************************
  !
  !  Compute the Function
  !
  !  set last to 3 to force MECI to calculate all roots. (Dataset must have
  !  keyword MECI in order for this to work)
  !
    last = 3
    emin = escf
    nscf=0
    if (do_scf) then
      grad(1:nvar) = 0.d0
      call compfg (xparam, .true., calhof, .true., grad, wtgeo > 1.d-4)
    else
      calhof = escf
    end if
    toterr = 0.d0
    nerr = 0
    gerr = 0.d0
!
!  wtz = 1.0 if not a solid.
!  wtz = 1.0/N where N = number of stoichiometric units in cluster, if a solid.
!
!
    calhof = calhof*wtz
    if(loop /= 0) loop_ref = loop
  !***********************************************************************
  !
  !                     Heat of Formation Error
  !
  !***********************************************************************
    if (wthof > 1.d-8) then
      if(qn(loop_ref) /= 0)then
      if (labsiz == 11) sum = meci()
        call symtrz (c(1, nelec + 1), eig, 3, .TRUE.)
        qn_temp = 0
        j = 0
        l = 0
        do i = 1, lab
          if (i > 1) then
    !
    !  If part of a degenerate manifold, use previous quantum number
    !
            if (ispin(i) == ispin(i-1) .and. namo(i) == namo(i-1) .and. abs(eig(i) - eig(i - 1)) < 0.01d0) then
              jndex(i) = jndex(i-1)
              cycle
            end if
          end if
    !
    !  Find Irreducible Representation
    !
          do k = 1, j
            if (srep(k) == namo(i)) exit
          end do
          if (k > j) then
            j = j + 1
            srep(j) = namo(i)
          end if
  !
          do m = 1, l
            if (irep(m) == ispin(i)) exit
          end do
          if (m > l) then
            l = l + 1
            irep(l) = ispin(i)
          end if
          qn_temp(k, m) = qn_temp(k, m) + 1
          jndex(i) = qn_temp(k, m)
        end do
!
!  Use excited state relative energy.  First, identify desired state.
!
        do i = 1,lab
          if( qn(loop_ref) /= jndex(i) ) cycle
          if( spin_state(loop_ref) /= ispin(i) ) cycle
          if( i_r(loop_ref) /= namo(i) ) cycle
!
!  State "i" is the one needed.
!
           calhof = (eig(i) - eig(1))*fpc_9 + 1.d-15
!
!  Extra "1.d-15" to ensure that calhof is not zero
!
          exit
        end do
        if(i > lab) then
          if (iloop /= loop .and. loop > 0) then
            write(ifiles_8,"(a,i1,a,i1,2a)") &
      & " Root requested not found: ", &
      & qn(loop_ref),",",spin_state(loop_ref),",",i_r(loop_ref)
            write(ifiles_8,"(/,a,/)")" Possible roots"
            write(ifiles_8,"(i5,2x,a,2x,a,f12.4)")(jndex(i), tspin(ispin(i)), namo(i), eig(i), i = 1, lab)
            iloop = loop
          end if
!
!  Instead of stopping the run, set the calculated state energy to the observed
!  state energy.  That will give rise to a zero error.  On the next cycle,
!  the failure should correct itself, or the user might see the error
!  message and fix the problem.
!
          calhof = refhof
        end if
      end if
      herr = calhof - refhof + 1.d-15 !(Ensure that the H.o.F. error is not exactly zero)
      nerr = nerr + 1
      errors(nerr) = herr * wthof
      ttype (nerr) = "HOF "
    else
      herr = 0.d0
    end if
    if (wtpKa > 1.d-8) then
!
!
!   Use dummy atom parameters for parameters used in unconventional ways.
!
!  Here, pKa = (Charge on ionizable hydrogen)*(constant_1) + (constant_2)
      call chrge (p, q)
      if (useps) then
        if (atom_pKa_O == 0) then
          herr = 1.d6
          do i = 1, numat
            if (atom_pKa == i) cycle
            sum = (coord(1,i) - coord(1,atom_pKa))**2 + &
         & (coord(2,i) - coord(2,atom_pKa))**2 + &
         & (coord(3,i) - coord(3,atom_pKa))**2
            if (sum < herr) then
              herr = sum
              atom_pKa_O = i
            end if
          end do
        end if
        sum = Sqrt((coord(1,atom_pKa_O) - coord(1,atom_pKa))**2 + &
          &      (coord(2,atom_pKa_O) - coord(2,atom_pKa))**2 + &
          &      (coord(3,atom_pKa_O) - coord(3,atom_pKa))**2 )
    !    herr = (tore(nat(atom_pKa)) - q(atom_pKa))*uss(99) +  sum*upp(99) + zs(99) - refpKa
        herr = (tore(nat(atom_pKa)) - q(atom_pKa))*uss(99) + area*udd(99) + sum*upp(99) + zs(99) - refpKa
    !  if (loop /= 0) write(ifiles_8,'(a,f8.4)')" Charge:", (tore(nat(atom_pKa)) - q(atom_pKa))
      else
        herr = (tore(nat(atom_pKa)) - q(atom_pKa))*uss(99) + upp(99)  - refpKa
      end if
      nerr = nerr + 1
      errors(nerr) = herr * wtpKa
      ttype (nerr) = "pKa "
    end if
  !***********************************************************************
  !
  !                     Ionization Potential Error
  !
  !***********************************************************************
    if (wtips > 1.d-8) then
      i = nclose
      if (fract > 1.99d0) then
        i = nopen
      end if
      nopn = nopen - i
    !   CORRECTION TO I.P. OF DOUBLETS
      calips = parips(eigs, loop_ref)
      if (nopn == 1) then
        calips = calips + 0.5d0 * rjkab1
      end if
      if (Abs(calips) > 1.d-5) then
        cerr = calips - refips
        nerr = nerr + 1
        errors(nerr) = cerr * wtips
        ttype (nerr) = "I.P."
      else
        cerr = 0.d0
      end if
    else
      cerr = 0.d0
    end if
  !***********************************************************************
  !
  !                       Dipole Moment Error
  !
  !***********************************************************************
    if (wtdip > 1.d-8) then
      caldip = pardip(coord, nat)
      derr = caldip - refdip
      nerr = nerr + 1
      errors(nerr) = derr * wtdip
      ttype (nerr) = "DIPO"
    else
      derr = 0.d0
    end if
  !***********************************************************************
  !
  !                 Geometry errors (grad)
  !
  !***********************************************************************
    if (wtgeo > 1.d-8) then
      gerr = pargeo(grad, wtgeo / wtz**0.666d0, refgeo, loc, errors, ndif)
      nerr = nerr + ndif
      j = 0
      do i = 1, Min(nvar,30)
        if (refgeo(i) /= " ") then
          j = j + 1
          ttype (j) = "GEOM "//refgeo(i)
        end if
      end do
    else
      gerr = 0.d0
    end if
  !***********************************************************************
      if (loop > 0) then
      hofcal(loop) = calhof
      refher = herr
      do i = 1, ihrefs(1, loop)
        refher = refher - hofcal(ihrefs(i+1, loop))
      end do
      refder = derr
      refcer = cerr
      refger = gerr
      reftot = toterr
    end if
end subroutine parfg

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

subroutine resetp (mode, loop)
    use molkst_C, only : mpack, keywrd
    use param_global_C, only : pas, pbs
    use common_arrays_C, only : p, pa, pb
!--------------------------------------------------------------------
    implicit none
    integer, intent (in) :: loop, mode
!--------------------------------------------------------------------
    integer :: i
    integer, save :: ilin
    if (loop == 1) then
      ilin = 0
    end if
    if (mode == 0) then
    !
    !  Restore density matrix from store (PAS and PBS) to current array (P)
    !
      do i = 1, mpack
        pa(i) = pas(i+ilin)
        pb(i) = pbs(i+ilin)
        p(i) = pa(i) + pb(i)
      end do
    else
    !
    !  Store density matrix
    !
      if(index(keywrd," UHF") /=0)then
        do i = 1, mpack
          pas(i+ilin) = pa(i)
          pbs(i+ilin) = pb(i)
        end do
      else
       do i = 1, mpack
          pas(i+ilin) = pa(i)
          pbs(i+ilin) = pa(i)
        end do
      end if
    end if
    ilin = ilin + mpack
end subroutine resetp

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine hbonds (fao, nocc, nvir, iused, nij_loc, cutoff)
   !**********************************************************************
   !                                                                     *
   !   HBONDS IDENTIFIES HYDROGEN BONDS WHICH HAVE NOT BEEN CREATED IN   *
   !          EARLIER STEPS                                              *
   !                                                                     *
   !**********************************************************************
   !                                                                     *
   !  FAO:      Fock matrix over atomic orbitals                         *
   !  FMO:      Fock matrix over molecular orbitals                      *
   !  VECTOR:   Eigenvectors of M.O.s                                    *
   !  FILLED:   Occupied M.O.s                                           *
   !  EMPTY:    Virtual M.O.s                                            *
   !  NOCC:     Number of occupied M.O.s                                 *
   !  EIG:      All the eigenvalues                                      *
   !  N:        Number of M.O.s = number of A.O.s*                       *
   !                                                                     *
   !  On exit:  NIJ = NUMBER OF HYDROGEN BONDS WHICH NEED TO BE CREATED  *
   !                                                                     *
   !**********************************************************************
    use molkst_C, only: numat, norbs, mpack
    use MOZYME_C, only : nncf, ncf, nnce, nce, iorbs, icocc, icvir, &
    fmo, ifmo
    use common_arrays_C, only:  p
    implicit none
    integer, intent (out) :: nij_loc
    integer, intent (in) :: nocc, nvir
    double precision, intent (in) :: cutoff
    integer, dimension (norbs), intent (out) :: iused
    double precision, dimension (mpack), intent (in) :: fao
    integer :: i
    integer :: j, k, kk, l, ll, m
    double precision :: sumf, sump
    integer, external :: ijbo
    intrinsic Min
   !
   !   CHECK FOCK MATRIX AND DENSITY MATRIX TO ENSURE THAT ALL
   !   FOCK MATRIX ELEMENTS ARE BEING CORRECTLY HANDLED BY THE
   !   DIAGONALISER.
   !
    nij_loc = 0
    do i = 1, numat
      do j = 1, i - 1
        if (ijbo(i, j) >= 0) then
          ll = ijbo (i, j)
          sumf = 0.d0
          sump = 0.d0
          do k = 1, iorbs(i)
            do l = 1, iorbs(j)
              ll = ll + 1
              sumf = sumf + fao(ll) ** 2
              sump = sump + p(ll) ** 2
            end do
          end do
          if (sump < 1.d-10 .and. sumf > cutoff) then
            m = 0
            do k = 1, nocc
              !
              !  If the LMO only contains one atom, do NOT check the
              !  second atom.
              !
              kk = Min (ncf(k)-1, 1)
              l = nncf(k) + 1
              if (icocc(l) == i .or. icocc(l+kk) == i .or. icocc(l) == j .or. &
             & icocc(l+kk) == j) then
                m = m + 1
                iused(m) = k
              end if
            end do
            do k = 1, nvir
              !
              !  If the LMO only contains one atom, do NOT check the
              !  second atom.
              !
              kk = Min (nce(k)-1, 1)
              l = nnce(k) + 1
              if (icvir(l) == i .or. icvir(l+kk) == i .or. icvir(l) == j .or. &
             & icvir(l+kk) == j) then
                do l = 1, m
                  nij_loc = nij_loc + 1
                  fmo(nij_loc) = 0.1d0
                  ifmo(2, nij_loc) = iused(l)
                  ifmo(1, nij_loc) = k
                end do
              end if
            end do
          end if
        end if
      end do
    end do
end subroutine hbonds

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      module iter_C
      double precision, dimension(:), allocatable :: pold, pold2, pold3, pbold, &
      pbold2, pbold3,  pgasa, pgasb, psona, psonb
!
! Arrays used in interp.F90
!
      double precision, dimension(:), allocatable :: h_ai, vecl_ai, h_bi, vecl_bi
      double precision, dimension(:,:), allocatable :: vec_ai, fock_ai, &
       & p_ai, vec_bi, fock_bi, p_bi, pulay_work1, pulay_work2, pulay_work3

      end module iter_C

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      module journal_references_C
      character, dimension(107,10) :: allref*100
! 2nd index denotes the model:
! 1 = MNDO
! 2 = PM6
! 3 = AM1
! 4 = PM3
! 5 = MNDO/d
! 6 = RM1
! 7 = PM7
! 8 = RM1 sparkles
! 9 = PM6-ORG
! 10 = PM8

 data  allref( 1,6)/ '  H: (RM1): G.B. ROCHA, R.O. FREIRE, A.M.SIMAS, J.J.P. STEWART, J. COMP. CHEM. 27, 1101 (2006)'/
 data  allref( 6,6)/ '  C: (RM1): G.B. ROCHA, R.O. FREIRE, A.M.SIMAS, J.J.P. STEWART, J. COMP. CHEM. 27, 1101 (2006)'/
 data  allref( 7,6)/ '  N: (RM1): G.B. ROCHA, R.O. FREIRE, A.M.SIMAS, J.J.P. STEWART, J. COMP. CHEM. 27, 1101 (2006)'/
 data  allref( 8,6)/ '  O: (RM1): G.B. ROCHA, R.O. FREIRE, A.M.SIMAS, J.J.P. STEWART, J. COMP. CHEM. 27, 1101 (2006)'/
 data  allref( 9,6)/ '  F: (RM1): G.B. ROCHA, R.O. FREIRE, A.M.SIMAS, J.J.P. STEWART, J. COMP. CHEM. 27, 1101 (2006)'/
 data  allref(15,6)/ '  P: (RM1): G.B. ROCHA, R.O. FREIRE, A.M.SIMAS, J.J.P. STEWART, J. COMP. CHEM. 27, 1101 (2006)'/
 data  allref(16,6)/ '  S: (RM1): G.B. ROCHA, R.O. FREIRE, A.M.SIMAS, J.J.P. STEWART, J. COMP. CHEM. 27, 1101 (2006)'/
 data  allref(17,6)/ ' Cl: (RM1): G.B. ROCHA, R.O. FREIRE, A.M.SIMAS, J.J.P. STEWART, J. COMP. CHEM. 27, 1101 (2006)'/
 data  allref(35,6)/ ' Br: (RM1): G.B. ROCHA, R.O. FREIRE, A.M.SIMAS, J.J.P. STEWART, J. COMP. CHEM. 27, 1101 (2006)'/
 data  allref(53,6)/ '  I: (RM1): G.B. ROCHA, R.O. FREIRE, A.M.SIMAS, J.J.P. STEWART, J. COMP. CHEM. 27, 1101 (2006)'/

 data  allref(11,5)/ " Na: (MNDO/d): W.THIEL AND A.A.VOITYUK, J. PHYS. CHEM., 100, 616 (1996)                      "/
 data  allref(12,5)/ " Mg: (MNDO/d): W.THIEL AND A.A.VOITYUK, J. PHYS. CHEM., 100, 616 (1996)                      "/
 data  allref(13,5)/ " Al: (MNDO/d): W.THIEL AND A.A.VOITYUK, J. PHYS. CHEM., 100, 616 (1996)                      "/
 data  allref(14,5)/ " Si: (MNDO/d): W.THIEL AND A.A.VOITYUK, J. PHYS. CHEM., 100, 616 (1996)                      "/
 data  allref(15,5)/ "  P: (MNDO/d): W.THIEL AND A.A.VOITYUK, J. PHYS. CHEM., 100, 616 (1996)                      "/
 data  allref(16,5)/ "  S: (MNDO/d): W.THIEL AND A.A.VOITYUK, J. PHYS. CHEM., 100, 616 (1996)                      "/
 data  allref(17,5)/ " Cl: (MNDO/d): W.THIEL AND A.A.VOITYUK, J. PHYS. CHEM., 100, 616 (1996)                      "/
 data  allref(30,5)/ " Zn: (MNDO/d): W.THIEL AND A.A.VOITYUK, J. PHYS. CHEM., 100, 616 (1996)                      "/
 data  allref(35,5)/ " Br: (MNDO/d): W.THIEL AND A.A.VOITYUK, J. PHYS. CHEM., 100, 616 (1996)                      "/
 data  allref(48,5)/ " Cd: (MNDO/d): W.THIEL AND A.A.VOITYUK, J. PHYS. CHEM., 100, 616 (1996)                      "/
 data  allref(53,5)/ "  I: (MNDO/d): W.THIEL AND A.A.VOITYUK, J. PHYS. CHEM., 100, 616 (1996)                      "/
 data  allref(80,5)/ " Hg: (MNDO/d): W.THIEL AND A.A.VOITYUK, J. PHYS. CHEM., 100, 616 (1996)                      "/
!
!  References for the RM1 Lanthanides
!
 data  allref(57,6)/ " La: (RM1): Dutra, J.D.L., Filho, M.A.M., et al., PLOS ONE, 2015, DOI: 10.1371/journal.pone.0124372 "/
 data  allref(58,6)/ " Ce: (RM1): Dutra, J.D.L., Filho, M.A.M., et al., PLOS ONE, 2015, DOI: 10.1371/journal.pone.0124372 "/
 data  allref(59,6)/ " Pr: (RM1): Dutra, J.D.L., Filho, M.A.M., et al., PLOS ONE, 2015, DOI: 10.1371/journal.pone.0124372 "/
 data  allref(60,6)/ " Nd: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., RSC Adv., 2015, DOI: 10.1039/C4RA12682C "/
 data  allref(61,6)/ " Pm: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., RSC Adv., 2015, DOI: 10.1039/C4RA12682C "/
 data  allref(62,6)/ " Sm: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., RSC Adv., 2015, DOI: 10.1039/C4RA12682C "/
 data  allref(63,6)/ " Eu: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., JCTC, 2014, DOI: 10.1021/ct400909w "/
 data  allref(64,6)/ " Gd: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., JCTC, 2014, DOI: 10.1021/ct400909w "/
 data  allref(65,6)/ " Tb: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., JCTC, 2014, DOI: 10.1021/ct400909w "/
 data  allref(66,6)/ " Dy: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., PLOS ONE, 2014, DOI: 10.1371/journal.pone.0086376 "/
 data  allref(67,6)/ " Ho: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., PLOS ONE, 2014, DOI: 10.1371/journal.pone.0086376 "/
 data  allref(68,6)/ " Er: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., PLOS ONE, 2014, DOI: 10.1371/journal.pone.0086376 "/
 data  allref(69,6)/ " Tm: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., PLOS ONE, 2016, DOI: 10.1371/journal.pone.0154500 "/
 data  allref(70,6)/ " Yb: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., PLOS ONE, 2016, DOI: 10.1371/journal.pone.0154500 "/
 data  allref(71,6)/ " Lu: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., PLOS ONE, 2016, DOI: 10.1371/journal.pone.0154500 "/
!
!  References for the RM1 Lanthanides as sparkles
!
 data  allref(57,8)/ " La: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., RSC Adv., 2013, DOI: 10.1039/C3RA41406J "/
 data  allref(58,8)/ " Ce: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., RSC Adv., 2013, DOI: 10.1039/C3RA41406J "/
 data  allref(59,8)/ " Pr: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., RSC Adv., 2013, DOI: 10.1039/C3RA41406J "/
 data  allref(60,8)/ " Nd: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., RSC Adv., 2013, DOI: 10.1039/C3RA41406J "/
 data  allref(61,8)/ " Pm: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., RSC Adv., 2013, DOI: 10.1039/C3RA41406J "/
 data  allref(62,8)/ " Sm: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., RSC Adv., 2013, DOI: 10.1039/C3RA41406J "/
 data  allref(63,8)/ " Eu: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., RSC Adv., 2013, DOI: 10.1039/C3RA41406J "/
 data  allref(64,8)/ " Gd: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., RSC Adv., 2013, DOI: 10.1039/C3RA41406J "/
 data  allref(65,8)/ " Tb: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., RSC Adv., 2013, DOI: 10.1039/C3RA41406J "/
 data  allref(66,8)/ " Dy: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., RSC Adv., 2013, DOI: 10.1039/C3RA41406J "/
 data  allref(67,8)/ " Ho: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., RSC Adv., 2013, DOI: 10.1039/C3RA41406J "/
 data  allref(68,8)/ " Er: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., RSC Adv., 2013, DOI: 10.1039/C3RA41406J "/
 data  allref(69,8)/ " Tm: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., RSC Adv., 2013, DOI: 10.1039/C3RA41406J "/
 data  allref(70,8)/ " Yb: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., RSC Adv., 2013, DOI: 10.1039/C3RA41406J "/
 data  allref(71,8)/ " Lu: (RM1): Filho, M.A.M., Dutra, J.D.L., et al., RSC Adv., 2013, DOI: 10.1039/C3RA41406J "/
!
!  References for the PM6 Lanthanides
!
 data  allref(57,2)/ " La: (PM6): Freire R.O. and Simas, A.M.  J. Chem. Theory and Comput., 2010, 6, 2019-2023     "/
 data  allref(58,2)/ " Ce: (PM6): Freire R.O. and Simas, A.M.  J. Chem. Theory and Comput., 2010, 6, 2019-2023     "/
 data  allref(59,2)/ " Pr: (PM6): Freire R.O. and Simas, A.M.  J. Chem. Theory and Comput., 2010, 6, 2019-2023     "/
 data  allref(60,2)/ " Nd: (PM6): Freire R.O. and Simas, A.M.  J. Chem. Theory and Comput., 2010, 6, 2019-2023     "/
 data  allref(61,2)/ " Pm: (PM6): Freire R.O. and Simas, A.M.  J. Chem. Theory and Comput., 2010, 6, 2019-2023     "/
 data  allref(62,2)/ " Sm: (PM6): Freire R.O. and Simas, A.M.  J. Chem. Theory and Comput., 2010, 6, 2019-2023     "/
 data  allref(63,2)/ " Eu: (PM6): Freire R.O. and Simas, A.M.  J. Chem. Theory and Comput., 2010, 6, 2019-2023     "/
 data  allref(64,2)/ " Gd: (PM6): Freire R.O. and Simas, A.M.  J. Chem. Theory and Comput., 2010, 6, 2019-2023     "/
 data  allref(65,2)/ " Tb: (PM6): Freire R.O. and Simas, A.M.  J. Chem. Theory and Comput., 2010, 6, 2019-2023     "/
 data  allref(66,2)/ " Dy: (PM6): Freire R.O. and Simas, A.M.  J. Chem. Theory and Comput., 2010, 6, 2019-2023     "/
 data  allref(67,2)/ " Ho: (PM6): Freire R.O. and Simas, A.M.  J. Chem. Theory and Comput., 2010, 6, 2019-2023     "/
 data  allref(68,2)/ " Er: (PM6): Freire R.O. and Simas, A.M.  J. Chem. Theory and Comput., 2010, 6, 2019-2023     "/
 data  allref(69,2)/ " Tm: (PM6): Freire R.O. and Simas, A.M.  J. Chem. Theory and Comput., 2010, 6, 2019-2023     "/
 data  allref(70,2)/ " Yb: (PM6): Freire R.O. and Simas, A.M.  J. Chem. Theory and Comput., 2010, 6, 2019-2023     "/
 data  allref(71,2)/ " Lu: (PM6): Freire R.O. and Simas, A.M.  J. Chem. Theory and Comput., 2010, 6, 2019-2023     "/
!
!
!  References for the PM7 Lanthanides
!
!
 data  allref(57,7)/ " La: (PM7): Dutra, J.D.L., Filho, M.A.M., et al J. Chem. Theory and Comput., 2013, 9, 3333-3341 "/
 data  allref(58,7)/ " Ce: (PM7): Dutra, J.D.L., Filho, M.A.M., et al J. Chem. Theory and Comput., 2013, 9, 3333-3341 "/
 data  allref(59,7)/ " Pr: (PM7): Dutra, J.D.L., Filho, M.A.M., et al J. Chem. Theory and Comput., 2013, 9, 3333-3341 "/
 data  allref(60,7)/ " Nd: (PM7): Dutra, J.D.L., Filho, M.A.M., et al J. Chem. Theory and Comput., 2013, 9, 3333-3341 "/
 data  allref(61,7)/ " Pm: (PM7): Dutra, J.D.L., Filho, M.A.M., et al J. Chem. Theory and Comput., 2013, 9, 3333-3341 "/
 data  allref(62,7)/ " Sm: (PM7): Dutra, J.D.L., Filho, M.A.M., et al J. Chem. Theory and Comput., 2013, 9, 3333-3341 "/
 data  allref(63,7)/ " Eu: (PM7): Dutra, J.D.L., Filho, M.A.M., et al J. Chem. Theory and Comput., 2013, 9, 3333-3341 "/
 data  allref(64,7)/ " Gd: (PM7): Dutra, J.D.L., Filho, M.A.M., et al J. Chem. Theory and Comput., 2013, 9, 3333-3341 "/
 data  allref(65,7)/ " Tb: (PM7): Dutra, J.D.L., Filho, M.A.M., et al J. Chem. Theory and Comput., 2013, 9, 3333-3341 "/
 data  allref(66,7)/ " Dy: (PM7): Dutra, J.D.L., Filho, M.A.M., et al J. Chem. Theory and Comput., 2013, 9, 3333-3341 "/
 data  allref(67,7)/ " Ho: (PM7): Dutra, J.D.L., Filho, M.A.M., et al J. Chem. Theory and Comput., 2013, 9, 3333-3341 "/
 data  allref(68,7)/ " Er: (PM7): Dutra, J.D.L., Filho, M.A.M., et al J. Chem. Theory and Comput., 2013, 9, 3333-3341 "/
 data  allref(69,7)/ " Tm: (PM7): Dutra, J.D.L., Filho, M.A.M., et al J. Chem. Theory and Comput., 2013, 9, 3333-3341 "/
 data  allref(70,7)/ " Yb: (PM7): Dutra, J.D.L., Filho, M.A.M., et al J. Chem. Theory and Comput., 2013, 9, 3333-3341 "/
 data  allref(71,7)/ " Lu: (PM7): Dutra, J.D.L., Filho, M.A.M., et al J. Chem. Theory and Comput., 2013, 9, 3333-3341 "/
!
! MNDO
!
 data  allref(  1,1)/ '  H: (MNDO): M.J.S. DEWAR, W. THIEL, J. AM. CHEM. SOC., 99, 4899, (1977)        '/
 data  allref(  2,1)/ ' He: (MNDO):                                                                    '/
 data  allref(  3,1)/ ' Li: (MNDO): TAKEN FROM MNDOC BY W.THIEL (QCPE NO.438, V. 2, P.63, (1982))      '/
 data  allref(  4,1)/ ' Be: (MNDO): M.J.S. DEWAR, H.S. RZEPA, J. AM. CHEM. SOC., 100, 777, (1978)      '/
 data  allref(  5,1)/ '  B: (MNDO): M.J.S. DEWAR, M.L. MCKEE, J. AM. CHEM. SOC., 99, 5231, (1977)      '/
 data  allref(  6,1)/ '  C: (MNDO): M.J.S. DEWAR, W. THIEL, J. AM. CHEM. SOC., 99, 4899, (1977)        '/
 data  allref(  7,1)/ '  N: (MNDO): M.J.S. DEWAR, W. THIEL, J. AM. CHEM. SOC., 99, 4899, (1977)        '/
 data  allref(  8,1)/ '  O: (MNDO): M.J.S. DEWAR, W. THIEL, J. AM. CHEM. SOC., 99, 4899, (1977)        '/
 data  allref(  9,1)/ '  F: (MNDO): M.J.S. DEWAR, H.S. RZEPA, J. AM. CHEM. SOC., 100, 777, (1978)      '/
 data  allref( 10,1)/ ' Ne: (MNDO):                                                                    '/
 data  allref( 11,1)/ ' Na: (MNDO): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                 '/
 data  allref( 12,1)/ ' Mg: (MNDO): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                 '/
 data  allref( 13,1)/ ' Al: (MNDO): L.P. DAVIS, ET.AL.  J. COMP. CHEM., 2, 433, (1981)                 '/
 data  allref( 14,1)/ ' Si: (MNDO): M.J.S.DEWAR, ET. AL. ORGANOMETALLICS  5, 375 (1986)                '/
 data  allref( 15,1)/ '  P: (MNDO): M.J.S.DEWAR, M.L.MCKEE, H.S. RZEPA,J. AM. CHEM. SOC., 100 3607 1978'/
 data  allref( 16,1)/ '  S: (MNDO): M.J.S.DEWAR, C.H. REYNOLDS, J. COMP. CHEM. 7, 140-143 (1986)       '/
 data  allref( 17,1)/ ' Cl: (MNDO): M.J.S.DEWAR, H.S.RZEPA, J. COMP. CHEM., 4, 158, (1983)             '/
 data  allref( 18,1)/ ' Ar: (MNDO):                                                                    '/
 data  allref( 19,1)/ '  K: (MNDO): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                 '/
 data  allref( 20,1)/ ' Ca: (MNDO): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                 '/
 data  allref( 30,1)/ ' Zn: (MNDO): M.J.S. DEWAR, K.M. MERZ, ORGANOMETALLICS, 5, 1494-1496 (1986)      '/
 data  allref( 31,1)/ ' Ga: (MNDO): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                 '/
 data  allref( 32,1)/ ' Ge: (MNDO): M.J.S.DEWAR, G.L.GRADY, E.F.HEALY,ORGANOMETALLICS 6 186-189 (1987) '/
 data  allref( 33,1)/ ' As: (MNDO): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                 '/
 data  allref( 34,1)/ ' Se: (MNDO): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                 '/
 data  allref( 35,1)/ ' Br: (MNDO): M.J.S.DEWAR, E.F. HEALY, J. COMP. CHEM., 4, 542, (1983)            '/
 data  allref( 36,1)/ ' Kr: (MNDO):                                                                    '/
 data  allref( 37,1)/ ' Rb: (MNDO): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                 '/
 data  allref( 38,1)/ ' Sr: (MNDO): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                 '/
 data  allref( 49,1)/ ' In: (MNDO): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                 '/
 data  allref( 50,1)/ ' Sn: (MNDO): M.J.S.DEWAR,G.L.GRADY,J.J.P.STEWART, J.AM.CHEM.SOC.,106 6771 (1984)'/
 data  allref( 51,1)/ ' Sb: (MNDO): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                 '/
 data  allref( 52,1)/ ' Te: (MNDO): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                 '/
 data  allref( 53,1)/ '  I: (MNDO): M.J.S.DEWAR, E.F. HEALY, J.J.P. STEWART, J.COMP.CHEM., 5,358,(1984)'/
 data  allref( 54,1)/ ' Xe: (MNDO):                                                                    '/
 data  allref( 55,1)/ ' Cs: (MNDO): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                 '/
 data  allref( 56,1)/ ' Ba: (MNDO): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                 '/
 data  allref( 80,1)/ ' Hg: (MNDO): M.J.S.DEWAR,  ET. AL. ORGANOMETALLICS 4, 1964, (1985)              '/
 data  allref( 81,1)/ ' Tl: (MNDO): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                 '/
 data  allref( 82,1)/ ' Pb: (MNDO): M.J.S.DEWAR, ET.AL ORGANOMETALLICS 4, 1973-1980 (1985)             '/
 data  allref( 83,1)/ ' Bi: (MNDO): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                 '/
 data  allref(102,1)/ ' Cb: (MNDO): Capped Bond  (Hydrogen-like, takes on a  zero charge.)             '/
 data  allref(104,1)/ '  +: (MNDO): Sparkle with charge of +1                                          '/
 data  allref(106,1)/ '  -: (MNDO): Sparkle with charge of -1                                          '/
!
!                                          AM1
!
 data  allref(  1,3)/ '  H: (AM1): M.J.S. DEWAR ET AL, J. AM. CHEM. SOC. 107 3902-3909 (1985)          '/
 data  allref(  2,3)/ ' He: (AM1):                                                                     '/
 data  allref(  3,3)/ ' Li: (AM1): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref(  4,3)/ ' Be: (AM1): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref(  5,3)/ '  B: (AM1): M.J.S. DEWAR ET AL, ORGANOMETALLICS, 7, 513-521 (1988)              '/
 data  allref(  6,3)/ '  C: (AM1): M.J.S. DEWAR ET AL, J. AM. CHEM. SOC. 107 3902-3909 (1985)          '/
 data  allref(  7,3)/ '  N: (AM1): M.J.S. DEWAR ET AL, J. AM. CHEM. SOC. 107 3902-3909 (1985)          '/
 data  allref(  8,3)/ '  O: (AM1): M.J.S. DEWAR ET AL, J. AM. CHEM. SOC. 107 3902-3909 (1985)          '/
 data  allref(  9,3)/ '  F: (AM1): M.J.S. DEWAR AND E. G. ZOEBISCH, THEOCHEM, 180, 1 (1988).           '/
 data  allref( 10,3)/ ' Ne: (AM1):                                                                     '/
 data  allref( 11,3)/ ' Na: (AM1): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 12,3)/ ' Mg: (AM1): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 13,3)/ ' Al: (AM1): M. J. S. Dewar, A. J. Holder, Organometallics, 9, 508-511 (1990).   '/
 data  allref( 14,3)/ ' Si: (AM1): M.J.S.DEWAR, C. JIE, ORGANOMETALLICS, 6, 1486-1490 (1987).          '/
 data  allref( 15,3)/ '  P: (AM1): M.J.S.DEWAR, JIE, C, THEOCHEM, 187, 1 (1989)                        '/
 data  allref( 16,3)/ '  S: (AM1): M.J.S. DEWAR, Y-C YUAN, INORGANIC CHEMISTRY, 29, 3881:3890,  (1990) '/
 data  allref( 17,3)/ ' Cl: (AM1): M.J.S. DEWAR AND E. G. ZOEBISCH, THEOCHEM, 180, 1 (1988).           '/
 data  allref( 18,3)/ ' Ar: (AM1):                                                                     '/
 data  allref( 19,3)/ '  K: (AM1): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 20,3)/ ' Ca: (AM1): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 30,3)/ ' Zn: (AM1): M.J.S. DEWAR, K.M. MERZ, ORGANOMETALLICS, 7, 522-524 (1988).        '/
 data  allref( 31,3)/ ' Ga: (AM1): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 32,3)/ ' Ge: (AM1): M.J.S.Dewar and C.Jie, Organometallics, 8, 1544, (1989)             '/
 data  allref( 33,3)/ ' As: (AM1): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 34,3)/ ' Se: (AM1): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 35,3)/ ' Br: (AM1): M.J.S. DEWAR AND E. G. ZOEBISCH, THEOCHEM, 180, 1 (1988).           '/
 data  allref( 36,3)/ ' Kr: (AM1):                                                                     '/
 data  allref( 37,3)/ ' Rb: (AM1): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 38,3)/ ' Sr: (AM1): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 42,3)/ ' Mo: (AM1): A.A. Voityuk, N. Roesch J. Phys. Chem. A 104, 4089 (2000).          '/
 data  allref( 49,3)/ ' In: (AM1): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 50,3)/ ' Sn: (AM1): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 51,3)/ ' Sb: (AM1): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 52,3)/ ' Te: (AM1): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 53,3)/ '  I: (AM1): M.J.S. DEWAR AND E. G. ZOEBISCH, THEOCHEM, 180, 1 (1988).           '/
 data  allref( 54,3)/ ' Xe: (AM1):                                                                     '/
 data  allref( 55,3)/ ' Cs: (AM1): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 56,3)/ ' Ba: (AM1): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 57,3)/ ' La: (AM1): R.O. FREIRE, ET AL, J. PHYS. CHEM. A 110 (17) (2006) 5897.          '/
 data  allref( 58,3)/ ' Ce: (AM1): R.O. FREIRE, ET AL, J. ORGANOMETALLIC CHEMISTRY 691 (2006) 2584.    '/
 data  allref( 59,3)/ ' Pr: (AM1): R.O. FREIRE, ET AL, J. ORGANOMETALLIC CHEMISTRY 690 (2005) 4099.    '/
 data  allref( 60,3)/ ' Nd: (AM1): C.C. BASTOS, ET AL, J. PHOTOCHEM. PHOTOBIOL. A 177 (2006) 225.      '/
 data  allref( 61,3)/ ' Pm: (AM1): R.O. FREIRE, ET AL, J. CHEM. THEORY COMPUT. 2 (2006) 64.            '/
 data  allref( 62,3)/ ' Sm: (AM1): R.O. FREIRE, ET AL, J. CHEM. THEORY COMPUT. 2 (2006) 64.            '/
 data  allref( 63,3)/ ' Eu: (AM1): R.O. FREIRE, G.B. ROCHA, A.M. SIMAS, INORG. CHEM.44 (2005) 3299.    '/
 data  allref( 64,3)/ ' Gd: (AM1): R.O. FREIRE, G.B. ROCHA, A.M. SIMAS, INORG. CHEM.44 (2005) 3299.    '/
 data  allref( 65,3)/ ' Tb: (AM1): R.O. FREIRE, G.B. ROCHA, A.M. SIMAS, INORG. CHEM.44 (2005) 3299.    '/
 data  allref( 66,3)/ ' Dy: (AM1): N.B. DA COSTA JR, ET AL, INORG. CHEM. COMM. 8 (2005) 831.           '/
 data  allref( 67,3)/ ' Ho: (AM1): N.B. DA COSTA JR, ET AL, POLYHEDRON 24 (2005) 3046.                 '/
 data  allref( 68,3)/ ' Er: (AM1): R.O. FREIRE, ET AL, J. ORGANOMETALLIC CHEMISTRY 691 (2006) 2584.    '/
 data  allref( 69,3)/ ' Tm: (AM1): R.O. FREIRE, ET AL, CHEM. PHYS. LETT., 411 (2005) 61.               '/
 data  allref( 70,3)/ ' Yb: (AM1): R.O. FREIRE, G.B. ROCHA, A.M. SIMAS, J. COMP. CHEM., 26 (2005) 1524.'/
 data  allref( 71,3)/ ' Lu: (AM1): R.O. FREIRE, ET AL, J. PHYS. CHEM. A 110 (17) (2006) 5897.          '/
 data  allref( 80,3)/ ' Hg: (AM1): M.J.S.Dewar and C.Jie, Organometallics 8, 1547, (1989)              '/
 data  allref( 81,3)/ ' Tl: (AM1): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 82,3)/ ' Pb: (AM1): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 83,3)/ ' Bi: (AM1): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 90,3)/ ' Th: (AM1): Rocha, G.B., D.Sc. Thesis, Dept. Quim. U. Pernambuco, Brazil  (2002)'/
 data  allref(102,3)/ ' Cb: (AM1): Capped Bond  (Hydrogen-like, takes on a zero charge.)               '/
 data  allref(104,3)/ '  +: (AM1): Sparkle with charge of +1                                           '/
 data  allref(106,3)/ '  -: (AM1): Sparkle with charge of -1                                           '/
!
!                                          PM3
!
 data  allref(  1,4)/ '  H: (PM3): J. J. P. STEWART, J. COMP. CHEM. 10, 209 (1989).                    '/
 data  allref(  2,4)/ ' He: (PM3):                                                                     '/
 data  allref(  3,4)/ ' Li: (PM3): E. ANDERS, R. KOCH, P. FREUNSCHT, J. COMP. CHEM 14 1301-1312  1993  '/
 data  allref(  4,4)/ ' Be: (PM3): J. J. P. STEWART, J. COMP. CHEM. 10, 209 (1989).                    '/
 data  allref(  5,4)/ '  B: (PM3): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref(  6,4)/ '  C: (PM3): J. J. P. STEWART, J. COMP. CHEM. 10, 209 (1989).                    '/
 data  allref(  7,4)/ '  N: (PM3): J. J. P. STEWART, J. COMP. CHEM. 10, 209 (1989).                    '/
 data  allref(  8,4)/ '  O: (PM3): J. J. P. STEWART, J. COMP. CHEM. 10, 209 (1989).                    '/
 data  allref(  9,4)/ '  F: (PM3): J. J. P. STEWART, J. COMP. CHEM. 10, 209 (1989).                    '/
 data  allref( 10,4)/ ' Ne: (PM3):                                                                     '/
 data  allref( 11,4)/ ' Na: (PM3): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 12,4)/ ' Mg: (PM3): J. J. P. STEWART, J. COMP. CHEM. 12, 320-341 (1991).                '/
 data  allref( 13,4)/ ' Al: (PM3): J. J. P. STEWART, J. COMP. CHEM. 10, 209 (1989).                    '/
 data  allref( 14,4)/ ' Si: (PM3): J. J. P. STEWART, J. COMP. CHEM. 10, 209 (1989).                    '/
 data  allref( 15,4)/ '  P: (PM3): J. J. P. STEWART, J. COMP. CHEM. 10, 209 (1989).                    '/
 data  allref( 16,4)/ '  S: (PM3): J. J. P. STEWART, J. COMP. CHEM. 10, 209 (1989).                    '/
 data  allref( 17,4)/ ' Cl: (PM3): J. J. P. STEWART, J. COMP. CHEM. 10, 209 (1989).                    '/
 data  allref( 18,4)/ ' Ar: (PM3):                                                                     '/
 data  allref( 19,4)/ '  K: (PM3): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 20,4)/ ' Ca: (PM3): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 30,4)/ ' Zn: (PM3): J. J. P. STEWART, J. COMP. CHEM. 12, 320-341 (1991).                '/
 data  allref( 31,4)/ ' Ga: (PM3): J. J. P. STEWART, J. COMP. CHEM. 12, 320-341 (1991).                '/
 data  allref( 32,4)/ ' Ge: (PM3): J. J. P. STEWART, J. COMP. CHEM. 12, 320-341 (1991).                '/
 data  allref( 33,4)/ ' As: (PM3): J. J. P. STEWART, J. COMP. CHEM. 12, 320-341 (1991).                '/
 data  allref( 34,4)/ ' Se: (PM3): J. J. P. STEWART, J. COMP. CHEM. 12, 320-341 (1991).                '/
 data  allref( 35,4)/ ' Br: (PM3): J. J. P. STEWART, J. COMP. CHEM. 10, 209 (1989).                    '/
 data  allref( 36,4)/ ' Kr: (PM3):                                                                     '/
 data  allref( 37,4)/ ' Rb: (PM3): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 38,4)/ ' Sr: (PM3): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 48,4)/ ' Cd: (PM3): J. J. P. STEWART, J. COMP. CHEM. 12, 320-341 (1991).                '/
 data  allref( 49,4)/ ' In: (PM3): J. J. P. STEWART, J. COMP. CHEM. 12, 320-341 (1991).                '/
 data  allref( 50,4)/ ' Sn: (PM3): J. J. P. STEWART, J. COMP. CHEM. 12, 320-341 (1991).                '/
 data  allref( 51,4)/ ' Sb: (PM3): J. J. P. STEWART, J. COMP. CHEM. 12, 320-341 (1991).                '/
 data  allref( 52,4)/ ' Te: (PM3): J. J. P. STEWART, J. COMP. CHEM. 12, 320-341 (1991).                '/
 data  allref( 53,4)/ '  I: (PM3): J. J. P. STEWART, J. COMP. CHEM. 10, 209 (1989).                    '/
 data  allref( 54,4)/ ' Xe: (PM3):                                                                     '/
 data  allref( 55,4)/ ' Cs: (PM3): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 56,4)/ ' Ba: (PM3): J. J. P. STEWART, J. MOL. MOD., 10, 155-164 (2004)                  '/
 data  allref( 57,4)/ ' La: (PM3): R.O. FREIRE, ET AL, J. PHYS. CHEM. A 110 (17) (2006) 5897.          '/
 data  allref( 58,4)/ ' Ce: (PM3): R.O. FREIRE, ET AL, J. ORGANOMETALLIC CHEMISTRY 691 (2006) 2584.    '/
 data  allref( 59,4)/ ' Pr: (PM3): R.O. FREIRE, ET AL, J. ORGANOMETALLIC CHEMISTRY 690 (2005) 4099.    '/
 data  allref( 60,4)/ ' Nd: (PM3): C.C. BASTOS, ET AL, J. PHOTOCHEM. PHOTOBIOL. A 177 (2006) 225.      '/
 data  allref( 61,4)/ ' Pm: (PM3): R.O. FREIRE, ET AL, J. CHEM. THEORY COMPUT. 2 (2006) 64.            '/
 data  allref( 62,4)/ ' Sm: (PM3): R.O. FREIRE, ET AL, J. CHEM. THEORY COMPUT. 2 (2006) 64.            '/
 data  allref( 63,4)/ ' Eu: (PM3): R.O. FREIRE, G.B. ROCHA, A.M. SIMAS, INORG. CHEM.44 (2005) 3299.    '/
 data  allref( 64,4)/ ' Gd: (PM3): R.O. FREIRE, G.B. ROCHA, A.M. SIMAS, INORG. CHEM.44 (2005) 3299.    '/
 data  allref( 65,4)/ ' Tb: (PM3): R.O. FREIRE, G.B. ROCHA, A.M. SIMAS, INORG. CHEM.44 (2005) 3299.    '/
 data  allref( 66,4)/ ' Dy: (PM3): N.B. DA COSTA JR, ET AL, INORG. CHEM. COMM. 8 (2005) 831.           '/
 data  allref( 67,4)/ ' Ho: (PM3): N.B. DA COSTA JR, ET AL, POLYHEDRON 24 (2005) 3046.                 '/
 data  allref( 68,4)/ ' Er: (PM3): R.O. FREIRE, ET AL, J. ORGANOMETALLIC CHEMISTRY 691 (2006) 2584.    '/
 data  allref( 69,4)/ ' Tm: (PM3): R.O. FREIRE, ET AL, CHEM. PHYS. LETT., 425 (2006) 138.              '/
 data  allref( 70,4)/ ' Yb: (PM3): R.O. FREIRE, G.B. ROCHA, A.M. SIMAS, J. COMP. CHEM., 26 (2005) 1524.'/
 data  allref( 71,4)/ ' Lu: (PM3): R.O. FREIRE, ET AL, J. PHYS. CHEM. A 110 (17) (2006) 5897.          '/
 data  allref( 80,4)/ ' Hg: (PM3): J. J. P. STEWART, J. COMP. CHEM. 12, 320-341 (1991).                '/
 data  allref( 81,4)/ ' Tl: (PM3): J. J. P. STEWART, J. COMP. CHEM. 12, 320-341 (1991).                '/
 data  allref( 82,4)/ ' Pb: (PM3): J. J. P. STEWART, J. COMP. CHEM. 12, 320-341 (1991).                '/
 data  allref( 83,4)/ ' Bi: (PM3): J. J. P. STEWART, J. COMP. CHEM. 12, 320-341 (1991).                '/
 data  allref(102,4)/ ' Cb: (PM3): Capped Bond  (Hydrogen-like, takes on a  zero charge.)              '/
 data  allref(104,4)/ '  +: (PM3): Sparkle with charge of +1                                           '/
 data  allref(106,4)/ '  -: (PM3): Sparkle with charge of -1                                           '/
!
! PM8
!
 data  allref(1:107,9)/ 107*" PM8 from PARAM (Development version)                                     "/
      end module journal_references_C

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine diagg1 (fao, nocc, nvir, eigv, ws, latoms, ifmo, fmo, fmo_dim, nij, idiagg,  avir, aocc, aov)
   !**********************************************************************
   !
   !  FAO:      FOCK MATRIX OVER ATOMIC ORBITALS
   !  FMO:      FOCK MATRIX OVER MOLECULAR ORBITALS
   !  VECTOR:   EIGENVECTORS OF M.O.S
   !  FILLED:   OCCUPIED M.O.S
   !  eigs:     EIGENVALUES OF OCCUPIED M.O.S
   !  EMPTY:    VIRTUAL M.O.S
   !  EIGV:     EIGENVALUES OF VIRTUAL M.O.S
   !  NOCC:     NUMBER OF OCCUPIED M.O.S
   !  EIG:      ALL THE EIGENVALUES
   !  N:        NUMBER OF M.O.S = NUMBER OF A.O.S*
   !
   !**********************************************************************
   !
   !  ALL OCCUPIED AND UNOCCUPIED LMO ENERGY LEVELS ARE CALCULATED, AS WELL
   !  AS ALL MATRIX ELEMENTS WHICH CAN BE NON ZERO CONNECTING THE OCCUPIED
   !  AND VIRTUAL SETS OF LMO'S.
   !
   !**********************************************************************
   !
    use molkst_C, only: numat, norbs, mpack, numcal, keywrd
    use MOZYME_C, only : nvirtual, icocc_dim, &
       & nfmo, lijbo, nijbo, &
       tiny, sumt, ijc, ovmax, ncf, nce, nncf, nnce, ncocc, ncvir, &
     & iorbs, icocc, icvir, cocc, cvir
    use common_arrays_C, only : eigs, nfirst, nlast, p
    implicit none
    integer, intent (in) :: idiagg, nocc, nvir, fmo_dim
    integer, intent (inout) :: nij
    logical, dimension (numat), intent (out) :: latoms
    integer, dimension (2, fmo_dim), intent (inout) :: ifmo
    double precision, dimension (fmo_dim), intent (out) :: fmo
    double precision, dimension (numat), intent (out) :: aov
    double precision, dimension (norbs), intent (out) :: avir, ws
    double precision, dimension (mpack), intent (in) :: fao
    double precision, dimension (nvirtual), intent (inout) :: eigv
    double precision, dimension (icocc_dim), intent (out) :: aocc
    integer, save :: nf, icalcn = 0, mydisp = 0, ij0
    integer :: i, i1, i2, i4, ii, j, j1, j2, j4, &
         & jj, jl, jx, k, k1, kk, kl, l, loopi, loopj, kj, i1j1, &
         & i1j2, i2j1, i2j2, k1j1
    logical :: lij
    logical, save :: times
    double precision :: cutlim, flim
    double precision, save :: fref, oldlim, safety
    double precision :: cutoff, sum, sum1
    integer, external :: ijbo
    if (numcal /= icalcn) then
      icalcn = numcal
      fref = 10.0d0
      safety = 1.0d0
      oldlim = 0.0d0
      nf = 0
      times = (Index (keywrd, " TIMES") /= 0)
      if (Index (keywrd, " OLDENS") /= 0) then
        fref = 0.d0
      end if
    end if
    !
    !
    aocc(:) = 0.d0
    !
    !   IF THE CONTRIBUTION OF AN ATOM IN AN OCCUPIED LMO IS VERY SMALL
    !   THEN DO NOT USE THAT ATOM IN CALCULATING THE OCCUPIED-VIRTUAL
    !   INTERACTION.  PUT THE CONTRIBUTIONS INTO AN ARRAY 'AOCC'.
    !
    do j = 1, nocc
        loopj = ncocc(j)
        kl = 0
        do kk = nncf(j) + 1, nncf(j) + ncf(j)
          k1 = icocc(kk)
          sum = 0.d0
          do k = nfirst(k1), nlast(k1)
            kl = kl + 1
            sum = sum + cocc(kl+loopj) ** 2
          end do
          !
          !   AOCC(KK) HOLDS THE SQUARE OF THE CONTRIBUTION OF THE KK'TH ATOM
          !   IN THE OCCUPIED SET.  NOTE:  THIS IS NOT ATOM KK.
          !
          aocc(kk) = sum
          !
        end do
      !
    end do
    !
    !
    !    CUTLIM    PRECISION OF PL
    !
    !    1.D-6      0.004
    !    1.D-7      0.00004
    !
    cutlim = 1.d-8
    cutoff = Max (cutlim, tiny*10.d0*cutlim)
    flim = Min (3.d0, fref*0.5d0)
    fref = 0.d0
    if (idiagg <= 5) then
      cutoff = cutlim
    end if
    sumt = 0.d0
    ijc = 0
    tiny = 0.d0
    !
    !
    do i = 1, nvir
      !
      loopi = ncvir(i)
      latoms(:) = .false.
      l = 0
      do j = nnce(i) + 1, nnce(i) + nce(i)
        j1 = icvir(j)
        sum = 0.d0
        do k = l + 1, l + iorbs(j1)
          sum = sum + cvir(k+loopi) ** 2
        end do
        l = l + iorbs(j1)
        !
        !   AVIR(J1) HOLDS THE SQUARE OF THE CONTRIBUTION OF THE ATOM J1
        !   IN THE VIRTUAL LMO 'I'.
        !
        avir(j1) = sum
        latoms(icvir(j)) = .true.
      end do
      !
      if (lijbo) then
        do jj = nnce(i) + 1, nnce(i) + nce(i)
          j1 = icvir(jj)
          do jx = 1, iorbs(j1)
            ws(nfirst(j1)+jx-1) = 0.0d00
          end do
          !
          kl = loopi
          do kk = nnce(i) + 1, nnce(i) + nce(i)
            k1 = icvir(kk)
            kj = nijbo(k1, j1)
            if (kj >= 0) then
              if (avir(k1)*p(kj+1) > cutoff) then
                !
                !  EXTRACT THE ATOM-ATOM INTERSECTION OF FAO
                !
                if (iorbs(k1) .eq. 1 .and. iorbs(j1) .eq. 1) then
                  ws(nfirst(j1)) = ws(nfirst(j1)) + fao(kj+1) * cvir(kl+1)
                else
                  if (k1 > j1) then
                    ii = kj
                    do i4 = 1, iorbs(k1)
                      do jx = 1, iorbs(j1)
                        ii = ii + 1
                        ws(nfirst(j1)+jx-1) = ws(nfirst(j1)+jx-1) + fao(ii) &
                             & * cvir(kl+i4)
                      end do
                    end do
                  else if (k1 < j1) then
                    ii = kj
                    do jx = 1, iorbs(j1)
                      do i4 = 1, iorbs(k1)
                        ii = ii + 1
                        ws(nfirst(j1)+jx-1) = ws(nfirst(j1)+jx-1) + fao(ii) &
                             & * cvir(kl+i4)
                      end do
                    end do
                  else
                    do jx = 1, iorbs(j1)
                      do i4 = 1, iorbs(j1)
                        if (i4 > jx) then
                          ii = kj + (i4*(i4-1)) / 2 + jx
                        else
                          ii = kj + (jx*(jx-1)) / 2 + i4
                        end if
                        ws(nfirst(j1)+jx-1) = ws(nfirst(j1)+jx-1) + fao(ii) &
                             & * cvir(kl+i4)
                      end do
                    end do
                  end if
                end if
              end if
            end if
            kl = kl + iorbs(k1)
          end do
        end do
      else
        do jj = nnce(i) + 1, nnce(i) + nce(i)
          j1 = icvir(jj)
          do jx = 1, iorbs(j1)
            ws(nfirst(j1)+jx-1) = 0.0d00
          end do
          !
          kl = loopi
          do kk = nnce(i) + 1, nnce(i) + nce(i)
            k1 = icvir(kk)
            kj = ijbo (k1, j1)
            if (kj >= 0) then
              if (avir(k1)*p(kj+1) > cutoff) then
                !
                !  EXTRACT THE ATOM-ATOM INTERSECTION OF FAO
                !
                if (iorbs(k1) == 1 .and. iorbs(j1) == 1) then
                  ws(nfirst(j1)) = ws(nfirst(j1)) + fao(kj+1) * cvir(kl+1)
                else
                  if (k1 > j1) then
                    ii = kj
                    do i4 = 1, iorbs(k1)
                      do jx = 1, iorbs(j1)
                        ii = ii + 1
                        ws(nfirst(j1)+jx-1) = ws(nfirst(j1)+jx-1) + fao(ii) &
                             & * cvir(kl+i4)
                      end do
                    end do
                  else if (k1 < j1) then
                    ii = kj
                    do jx = 1, iorbs(j1)
                      do i4 = 1, iorbs(k1)
                        ii = ii + 1
                        ws(nfirst(j1)+jx-1) = ws(nfirst(j1)+jx-1) + fao(ii) &
                             & * cvir(kl+i4)
                      end do
                    end do
                  else
                    do jx = 1, iorbs(j1)
                      do i4 = 1, iorbs(j1)
                        if (i4 > jx) then
                          ii = kj + (i4*(i4-1)) / 2 + jx
                        else
                          ii = kj + (jx*(jx-1)) / 2 + i4
                        end if
                        ws(nfirst(j1)+jx-1) = ws(nfirst(j1)+jx-1) + fao(ii) &
                             & * cvir(kl+i4)
                      end do
                    end do
                  end if
                end if
              end if
            end if
            kl = kl + iorbs(k1)
          end do
        end do
      end if
      !
      do j = 1, numat
        if (latoms(j)) then
          sum = 0.d0
          do k = nfirst(j), nlast(j)
            sum = sum + ws(k) ** 2
          end do
          !
          !   AOV(J) HOLDS THE SQUARE OF THE ENERGY CONTRIBUTION OF THE
          !   ATOM J IN THE VIRTUAL LMO 'I'.
          !
          aov(j) = sum
        else
          aov(j) = 0.d0
        end if
      end do
      !
      !   EVALUATE THE VIRTUAL ENERGY LEVELS
      !
      sum = 0.d0
      kl = loopi
      do kk = nnce(i) + 1, nnce(i) + nce(i)
        k1 = icvir(kk)
        if (aov(k1)*avir(k1) > cutoff) then
          do k = nfirst(k1), nlast(k1)
            kl = kl + 1
            sum = sum + ws(k) * cvir(kl)
          end do
        else
          kl = kl + iorbs(k1)
        end if
      end do
      !
      eigv(i) = sum
      !
      !  EVALUATE THE OCCUPIED-VIRTUAL LMO INTERACTION ENERGIES
      !
      if (idiagg <= 5 .or. Mod (idiagg, 2) == 0) then
        nf = 0
        i1 = icvir(nnce(i)+1)
        if (nce(i) > 1) then
          i2 = icvir(nnce(i)+2)
        else
          i2 = i1
        end if
        if (lijbo) then
          do j = 1, nocc
            if (ijc /= nij) then
              !
              !  FAST TEST TO SEE IF THE INTEGRAL IS WORTH EVALUATING
              !
              j1 = icocc(nncf(j)+1)
              if (ncf(j) > 1) then
                j2 = icocc(nncf(j)+2)
              else
                j2 = j1
              end if
              !
              i1j1 = nijbo(i1, j1)
              i1j2 = nijbo(i1, j2)
              i2j1 = nijbo(i2, j1)
              i2j2 = nijbo(i2, j2)
              !
              if (i1j1 >= 0 .or. i1j2 >= 0 .or. i2j1 >= 0 .or. i2j2 >= 0) then
                sum = 0.d0
                if (i1j1 >= 0) then
                  sum = Abs (fao(i1j1+1))
                end if
                if (i1j2 >= 0) then
                  sum = sum + Abs (fao(i1j2+1))
                end if
                if (i2j1 >= 0) then
                  sum = sum + Abs (fao(i2j1+1))
                end if
                if (i2j2 >= 0) then
                  sum = sum + Abs (fao(i2j2+1))
                end if
                if (sum >= flim) then
                  loopj = ncocc(j)
                  lij = .false.
                  sum = 0.d0
                  kl = 0
                  do kk = nncf(j) + 1, nncf(j) + ncf(j)
                    k1 = icocc(kk)
                    if (aocc(kk)*aov(k1) < cutoff .or. .not. latoms(k1)) then
                      kl = kl + iorbs(k1)
                    else
                      lij = .true.
                      do k = nfirst(k1), nlast(k1)
                        kl = kl + 1
                        sum = sum + ws(k) * cocc(kl+loopj)
                      end do
                    end if
                  end do
                  sumt = sumt + Abs (sum)
                  tiny = Max (tiny, Abs (sum))
                  if (lij) then
                    if (Abs (sum) > oldlim) then
                      nf = nf + 1
                      ijc = ijc + 1
                      ifmo(1, ijc) = i
                      ifmo(2, ijc) = j
                      fmo(ijc) = sum
                    end if
                  end if
                end if
              end if
            end if
          end do
        else
          do j = 1, nocc
            if (ijc /= nij) then
              !
              !  FAST TEST TO SEE IF THE INTEGRAL IS WORTH EVALUATING
              !
              j1 = icocc(nncf(j)+1)
              if (ncf(j) > 1) then
                j2 = icocc(nncf(j)+2)
              else
                j2 = j1
              end if
              !
              i1j1 = ijbo (i1, j1)
              i1j2 = ijbo (i1, j2)
              i2j1 = ijbo (i2, j1)
              i2j2 = ijbo (i2, j2)
              !
              if (i1j1 >= 0 .or. i1j2 >= 0 .or. i2j1 >= 0 .or. i2j2 >= 0) &
                   & then
                sum = 0.d0
                if (i1j1 >= 0) then
                  sum = Abs (fao(i1j1+1))
                end if
                if (i1j2 >= 0) then
                  sum = sum + Abs (fao(i1j2+1))
                end if
                if (i2j1 >= 0) then
                  sum = sum + Abs (fao(i2j1+1))
                end if
                if (i2j2 >= 0) then
                  sum = sum + Abs (fao(i2j2+1))
                end if
                if (sum >= flim) then
                  loopj = ncocc(j)
                  lij = .false.
                  sum = 0.d0
                  kl = 0
                  do kk = nncf(j) + 1, nncf(j) + ncf(j)
                    k1 = icocc(kk)
                    if (aocc(kk)*aov(k1) < cutoff .or. .not. latoms(k1)) then
                      kl = kl + iorbs(k1)
                    else
                      lij = .true.
                      do k = nfirst(k1), nlast(k1)
                        kl = kl + 1
                        sum = sum + ws(k) * cocc(kl+loopj)
                      end do
                    end if
                  end do
                  sumt = sumt + Abs (sum)
                  tiny = Max (tiny, Abs (sum))
                  if (lij) then
                    if (Abs (sum) > oldlim) then
                      nf = nf + 1
                      ijc = ijc + 1
                      ifmo(1, ijc) = i
                      ifmo(2, ijc) = j
                      fmo(ijc) = sum
                    end if
                  end if
                end if
              end if
            end if
          end do
        end if
        nfmo(i) = nf
      else
        ij0 = ijc + mydisp
        do jj = 1, nfmo(i)
          if (ijc+mydisp == nij) exit
          j = ifmo(2, ij0+jj)
          loopj = ncocc(j)
          sum = 0.d0
          kl = 0
          do kk = nncf(j) + 1, nncf(j) + ncf(j)
            k1 = icocc(kk)
            if (aov(k1)*aocc(kk) < cutoff .or. .not. latoms(k1)) then
              kl = kl + iorbs(k1)
            else
              do k = nfirst(k1), nlast(k1)
                kl = kl + 1
                sum = sum + ws(k) * cocc(kl+loopj)
              end do
            end if
          end do
          sumt = sumt + Abs (sum)
          tiny = Max (tiny, Abs (sum))
          ijc = ijc + 1
          fmo(ijc) = sum
        end do
      end if
    end do
    !
    if (ijc == nij) then
      !
      !   THERE WAS NOT ENOUGH STORAGE TO HOLD ALL THE INTEGRALS.
      !   THEREFORE, ON THE NEXT ITERATION, CALCULATE FEWER INTEGRALS.
      !
      safety = safety * 2.d0
    else
      !
      !  THERE IS ENOUGH STORAGE FOR ALL THE INTEGRALS.  IF NECESSARY,
      !  CALCULATE MORE INTEGRALS.
      !
      safety = Max (safety*0.5d0, 1.d0)
    end if

    nij = ijc
    if (idiagg > 2 .and. Mod (idiagg, 4) /= 0) then
      fref = tiny ** 4
      if (times) then
        call timer (" AFTER DIAGG1 IN ITER")
      end if
        !
    else
      !
      !  EVALUATE THE OCCUPIED ENERGY LEVELS
      !
        !
      do i = 1, nocc
        !
          loopi = ncocc(i)
          l = 0
          do j = nncf(i) + 1, nncf(i) + ncf(i)
            j1 = icocc(j)
            sum = 0.d0
            do k = l + 1, l + iorbs(j1)
              sum = sum + cocc(k+loopi) ** 2
            end do
            l = l + iorbs(j1)
            !
            !   AOCC(KK) HOLDS THE SQUARE OF THE CONTRIBUTION OF THE KK'TH ATOM
            !   IN THE OCCUPIED SET.  NOTE:  THIS IS NOT ATOM KK.
            !
            !   AVIR(J1) HOLDS THE SQUARE OF THE CONTRIBUTION OF ATOM J1
            !   IN THE OCCUPIED SET.  NOTE:  THIS IS NOT THE J1'th ATOM.
            !
            avir(j1) = sum
            !
            !   AOCC(KK) HOLDS THE SQUARE OF THE CONTRIBUTION OF THE KK'TH ATOM
            !   IN THE OCCUPIED SET.  NOTE:  THIS IS NOT ATOM KK.
            !
            !   AVIR(J1) HOLDS THE SQUARE OF THE CONTRIBUTION OF ATOM J1
            !   IN THE OCCUPIED SET.  NOTE:  THIS IS NOT THE J1'th ATOM.
            !
          end do
          sum = 0.d0
          jl = loopi
          !
          if (lijbo) then
            do j = nncf(i) + 1, nncf(i) + ncf(i)
              j1 = icocc(j)
              kl = loopi
              do k = nncf(i) + 1, nncf(i) + ncf(i)
                k1 = icocc(k)
                k1j1 = nijbo(k1, j1)
                if (k1j1 >= 0) then
                  if (avir(k1)*p(k1j1+1)*aocc(k) >= cutoff) then
                    !
                    !  EXTRACT THE ATOM-ATOM INTERSECTION OF FAO
                    !
                    if (k1 > j1) then
                      !
                      !   LOWER TRIANGLE
                      !
                      do jx = 1, iorbs(j1)
                        sum1 = 0.d0
                        do i4 = 1, iorbs(k1)
                          ii = k1j1 + (i4-1) * iorbs(j1) + jx
                          sum1 = sum1 + fao(ii) * cocc(kl+i4)
                        end do
                        sum = sum + cocc(jl+jx) * sum1
                      end do
                    else if (k1 < j1) then
                      !
                      !   UPPER TRIANGLE
                      !
                      do jx = 1, iorbs(j1)
                        sum1 = 0.d0
                        do i4 = 1, iorbs(k1)
                          ii = k1j1 + (jx-1) * iorbs(k1) + i4
                          sum1 = sum1 + fao(ii) * cocc(kl+i4)
                        end do
                        sum = sum + cocc(jl+jx) * sum1
                      end do
                    else
                      !
                      !   DIAGONAL TERM
                      !
                      do jx = 1, iorbs(j1)
                        sum1 = 0.d0
                        do j4 = 1, jx
                          ii = k1j1 + (jx*(jx-1)) / 2 + j4
                          sum1 = sum1 + fao(ii) * cocc(kl+j4)
                        end do
                        ii = k1j1 + (jx*(jx+1)) / 2
                        do i4 = jx + 1, iorbs(k1)
                          ii = k1j1 + (i4*(i4-1)) / 2 + jx
                          sum1 = sum1 + fao(ii) * cocc(kl+i4)
                        end do
                        sum = sum + cocc(jl+jx) * sum1
                      end do
                    end if
                  end if
                end if
                kl = kl + iorbs(k1)
              end do
              !
              jl = jl + iorbs(j1)
            end do
          else
            do j = nncf(i) + 1, nncf(i) + ncf(i)
              j1 = icocc(j)
              kl = loopi
              do k = nncf(i) + 1, nncf(i) + ncf(i)
                k1 = icocc(k)
                k1j1 = ijbo (k1, j1)
                if (k1j1 >= 0) then
                  if (avir(k1)*p(k1j1+1)*aocc(k) >= cutoff) then
                    !
                    !  EXTRACT THE ATOM-ATOM INTERSECTION OF FAO
                    !
                    if (k1 > j1) then
                      !
                      !   LOWER TRIANGLE
                      !
                      do jx = 1, iorbs(j1)
                        sum1 = 0.d0
                        do i4 = 1, iorbs(k1)
                          ii = k1j1 + (i4-1) * iorbs(j1) + jx
                          sum1 = sum1 + fao(ii) * cocc(kl+i4)
                        end do
                        sum = sum + cocc(jl+jx) * sum1
                      end do
                    else if (k1 < j1) then
                      !
                      !   UPPER TRIANGLE
                      !
                      do jx = 1, iorbs(j1)
                        sum1 = 0.d0
                        do i4 = 1, iorbs(k1)
                          ii = k1j1 + (jx-1) * iorbs(k1) + i4
                          sum1 = sum1 + fao(ii) * cocc(kl+i4)
                        end do
                        sum = sum + cocc(jl+jx) * sum1
                      end do
                    else
                      !
                      !   DIAGONAL TERM
                      !
                      do jx = 1, iorbs(j1)
                        sum1 = 0.d0
                        do j4 = 1, jx
                          ii = k1j1 + (jx*(jx-1)) / 2 + j4
                          sum1 = sum1 + fao(ii) * cocc(kl+j4)
                        end do
                        ii = k1j1 + (jx*(jx+1)) / 2
                        do i4 = jx + 1, iorbs(k1)
                          ii = k1j1 + (i4*(i4-1)) / 2 + jx
                          sum1 = sum1 + fao(ii) * cocc(kl+i4)
                        end do
                        sum = sum + cocc(jl+jx) * sum1
                      end do
                    end if
                  end if
                end if
                kl = kl + iorbs(k1)
              end do
              !
              jl = jl + iorbs(j1)
            end do
          end if
          !
          eigs(i) = sum
          !
      end do
            oldlim = tiny * safety * 1.d-3
      fref = tiny ** 4
      if (times) then
        call timer (" AFTER DIAGG1 IN ITER")
      end if
    end if

    ovmax = tiny
end subroutine diagg1

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      module ef_C
      integer :: ef_mode, nstep, negreq, iprnt, iloop
      double precision :: ddx, rmin, rmax, omin = 0.d0, xlamd, xlamd0, skal, x0, x1, x2
      double precision, dimension(:), allocatable :: oldf, d, vmode, pmat, uc, hessc
      double precision, dimension(:,:), allocatable :: hess, bmat, u, oldhss, oldu, alparm
      end module ef_C
      module drc_C
        double precision, dimension(:), allocatable :: vref, vref0, now
        double precision, dimension(:,:), allocatable :: allxyz, allvel, xyz3, vel3, allgeo, geo3, georef
        double precision, dimension(:), allocatable :: parref
        double precision :: time
      end module drc_C
      module derivs_C
        double precision, dimension(:), allocatable :: wmat, hmat, fmat
        double precision, dimension(:,:), allocatable  :: b, ab, fb
          double precision, dimension(:), allocatable :: aidref, work2
      end module derivs_C

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine mopac_gui_activate
!dec$ attributes dllexport :: mopac_gui_activate
  use molkst_C, only : gui
  implicit none
  gui = .true.
  return
end subroutine mopac_gui_activate

subroutine mopac_gui_deactivate
!dec$ attributes dllexport :: mopac_gui_deactivate
  use molkst_C, only : gui
  implicit none
  gui = .false.
  return
end subroutine mopac_gui_deactivate

subroutine mopac_gui_set_channel(channel)
!dec$ attributes dllexport :: mopac_gui_set_channel
  use chanel_C, only : iw0
  implicit none
  integer :: channel
  iw0 = channel
  return
end subroutine mopac_gui_set_channel

subroutine mopac_gui_get_channel(channel)
!dec$ attributes dllexport :: mopac_gui_get_channel
  use chanel_C, only : iw0
  implicit none
  integer :: channel
  channel = iw0
  return
end subroutine mopac_gui_get_channel

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  subroutine new_esp()
    use common_arrays_C, only : coord, c, p, nat, &
    nfirst, nlast
    use parameters_C, only : tore
    use molkst_C, only : numat, norbs, fract, nclose, nopen, &
      keywrd, jobnam
    use funcon_C, only : a0, pi
    use chanel_C, only : iesp
    use esp_C, only : ixn, iyn, izn, jxn, jyn, jzn
    USE overlaps_C, only : ccc, zzz
!

    implicit none
    logical dubl, sames, cube, espgrid
    integer :: i, j, ij, nx, ny, nz, iiz, iiy, iix, &
    mini, minj, maxi, maxj, lit, ljt, nshells, k, l, ig, jg, &
    isize, isizes, jsize, jsizes, jgmax, idx, nroots, n, mm, in, jn, &
    pij, kl, lmax, nxyz, nFit, m, el, nUse, nnx, nny, nnz

    real :: rtemp, dx, dy, dz, ep(81)

    double precision :: x, y, z, delx, dely, delz,  &
    iatomx, iatomy, iatomz, jatomx, jatomy, jatomz, px, py, pz, &
    icoeff, jcoeff, dtemp1, dtemp2, dtemp3, rr, iexp, jexp, &
    gamma, gammainverse, kfac, contractionDensity(100), tosp, yz, xyz, &
    rx, u(4), w(4), uu, ww, ttinverse, t, x0, y0, z0, &
    tt, xint, yint, zint, xin(64), yin(64), zin(64), &
     EUpperRange, &
    inorm, jnorm, &
    xmax = -1.d8, &
    xmin =  1.d8, &
    ymax = -1.d8, &
    ymin =  1.d8, &
    zmax = -1.d8, &
    zmin =  1.d8

    integer, dimension(:), allocatable :: jpvt, itypes, istart, istop, &
      & icoord
    real, dimension (:), allocatable :: aMatrix, qraux, bVector, aVector, &
                                      & rsd, qy, qty, xb, esp_array
    double precision, allocatable, dimension(:,:) :: norm


    integer ::  ijx(100), ijy(100), ijz(100), &
    itype, jtype
    real, dimension (:), allocatable :: planexy,  Scr2
    double precision, dimension (:,:), allocatable :: s, vecs
    double precision, external :: reada
    mini = 0
    minj = 0
    allocate (s(norbs, norbs), vecs(norbs, norbs), istart(norbs), istop(norbs))
    nFit = 0
    call get_minus_point_five_overlap(s)
    call mult (c, s, vecs, norbs)

! For GPU MOPAC
! GBR_new_addition

! ORG      call densit (vecs, norbs, norbs, nclose, 2.d0, nopen, fract, p, 2)
    ij = (norbs*(norbs+1)/2)
        call density_for_GPU (vecs,fract,nclose,nopen, &
                             & 2.d0,ij,norbs,2,p,5)
! this procedure was replaced with MKL/DSCAL calling
!    ij = 0
!    do i = 1, norbs
!      do j = 1, i - 1
!        ij = ij + 1
!        p(ij) = p(ij)*2.d0
!      end do
!      ij = ij + 1
!    end do

    call dscal(ij, 2.d0, p, 1)
    j = 0
    do i = 1,norbs
       j = i*(i+1)/2
       p(j) = p(j)/2.d0
    end do
!!!

    tosp = 2.d0/sqrt(pi)
!
!  Convert to AU and work out the upper and lower bounds of the box
!
    coord = coord/a0

    do i = 1, numat
      if (coord(1,i) > xmax) xmax = coord(1,i)
      if (coord(2,i) > ymax) ymax = coord(2,i)
      if (coord(3,i) > zmax) zmax = coord(3,i)
      if (coord(1,i) < xmin) xmin = coord(1,i)
      if (coord(2,i) < ymin) ymin = coord(2,i)
      if (coord(3,i) < zmin) zmin = coord(3,i)
    end do
    xmax = xmax + 4.d0
    ymax = ymax + 4.d0
    zmax = zmax + 4.d0
    xmin = xmin - 4.d0
    ymin = ymin - 4.d0
    zmin = zmin - 4.d0
  !  nnx = max(15, min(25, nint((xmax - xmin))))
  !  nnx = max(15, min(25, nint((ymax - ymin))), nnx)
  !  nnx = max(15, min(25, nint((zmax - zmin))), nnx)
  !  nny = nnx ! max(15, nint((ymax - ymin)*1.5d0))
  !  nnz = nnx ! max(15, nint((zmax - zmin)*1.5d0))


    nnx = max(15, min(25, nint((xmax - xmin))))
    nny = max(15, min(25, nint((ymax - ymin))))
    nnz = max(15, min(25, nint((zmax - zmin))))
    allocate (planexy(nnx*nny*nnz), scr2(nnx*nny*nnz))
    delx = (xmax - xmin)/(nnx - 1)
    dely = (ymax - ymin)/(nny - 1)
    delz = (zmax - zmin)/(nnz - 1)
!
!  Set up arrays for handling the STO6G orbitals
!
    call setupg
    allocate (itypes(norbs), icoord(norbs), norm(norbs,6))
    nshells = 0
    do i = 1, numat
      nshells = nshells + 1
      itypes(nshells) = 0   !  "s"-type
      icoord(nshells) = i
      istart(nshells) = nfirst(i)
      istop(nshells) = nfirst(i)
      norm(nshells,:) = (2.d0*zzz(nshells,:)/pi)**0.75
      if (nlast(i) == nfirst(i)) cycle
      nshells = nshells + 1
      itypes(nshells) = 1   !  "p"-type
      icoord(nshells) = i
      istart(nshells) = nfirst(i) + 1
      istop(nshells) = nfirst(i) + 3
      norm(nshells,:) = (128.d0/pi**3)**0.25*zzz(nshells,:)**1.25d0
    end do
!
!  Contribution to the ESP arising from the nuclii
!
    planexy = 0.e0
    pij = 0
    do iiz = 1, nnz
      z = zmin + delz*(iiz - 1)
      do iiy = 1, nny
        y = ymin + dely*(iiy - 1)
        do iix = 1, nnx
          x = xmin + delx*(iix - 1)
          pij = pij + 1
          do i = 1, numat
            dx = sngl(x - coord(1,i))
            dy = sngl(y - coord(2,i))
            dz = sngl(z - coord(3,i))
            planexy(pij) = planexy(pij) + sngl(tore(nat(i)))/sqrt(max(dx**2 + dy**2 + dz**2, 1.e-12))
          end do
        end do
      end do
    end do
!
!  Contribution to the ESP arising from the electrons
!
    do i = 1, nshells
      itype = itypes(i)
      iatomx = coord(1, icoord(i))
      iatomy = coord(2, icoord(i))
      iatomz = coord(3, icoord(i))
      select case (itype)
      case (0) !  "s"-type
        isize  = 1
        isizes = 1
        mini   = 1
        maxi   = 1
        lit    = 1
      case (1) !  "p"-type
        isize  = 3
        isizes = 3
        mini   = 2
        maxi   = 4
        lit    = 2
      end select

      do j = 1, i
        sames = (i == j)
        jtype = itypes(j)
        jatomx = coord(1, icoord(j))
        jatomy = coord(2, icoord(j))
        jatomz = coord(3, icoord(j))
        select case (jtype)
        case (0) !  "s"-type
          jsize  = 1
          jsizes = 1
          minj   = 1
          maxj   = 1
          ljt    = 1
        case (1) !  "p"-type
          jsize  = 3
          jsizes = 3
          minj   = 2
          maxj   = 4
          ljt    = 2
        end select
        dtemp1 = iatomx - jatomx
        dtemp2 = iatomy - jatomy
        dtemp3 = iatomz - jatomz
        rr = dtemp1**2 + dtemp2**2 + dtemp3**2
        if (sames) then
          ij = 0
          do k = mini, maxi
            do l = minj, k
              ij = ij + 1
              ijx(ij) = ixn(k) + jxn(l) + 1
              ijy(ij) = iyn(k) + jyn(l) + 1
              ijz(ij) = izn(k) + jzn(l) + 1
            end do
          end do
        else
          ij = 0
          do k = mini, maxi
            do l = minj, maxj
              ij = ij + 1
              ijx(ij) = ixn(k) + jxn(l) + 1
              ijy(ij) = iyn(k) + jyn(l) + 1
              ijz(ij) = izn(k) + jzn(l) + 1
            end do
          end do
        end if
        do ig = 1,6
          iexp = zzz(i,ig)
          icoeff = ccc(i,ig)
          inorm = norm(i,ig)
          if (sames) then
            jgmax = ig
          else
            jgmax = 6
          end if
          do jg = 1, jgmax
            dubl = (sames .and. ig /= jg)
            jexp = zzz(j,jg)
            jnorm = norm(j,jg)
            jcoeff = ccc(j,jg)
            gamma = iexp + jexp
            gammainverse = 1.d0/gamma
            dtemp1 = iexp*jexp*rr*gammainverse
            if (dtemp1 < 46.d0) then
              kfac = exp(-dtemp1)
              px = (iexp*iatomx + jexp*jatomx)*gammainverse
              py = (iexp*iatomy + jexp*jatomy)*gammainverse
              pz = (iexp*iatomz + jexp*jatomz)*gammainverse
              dtemp1 = icoeff*jcoeff*inorm*jnorm*kfac
              idx = 0
              if (sames) then
                if (dubl) then
                  do k = 1, isize
                    do l = 1, k
                      idx = idx + 1
                      contractionDensity(idx) = 2.d0*dtemp1
                    end do
                  end do
                else
                   do k = 1, isize
                    do l = 1, k
                      idx = idx + 1
                      contractionDensity(idx) = dtemp1
                    end do
                  end do
                end if
              else
                do k = 1, isize
                  do l = 1, jsize
                      idx = idx + 1
                      contractionDensity(idx) = dtemp1
                  end do
                end do
              end if
              contractionDensity(:ij) = contractionDensity(:ij)*tosp*gammainverse
              pij = 1
              do iiz = 1, nnz
                z = zmin + delz*(iiz - 1)
                dz = sngl(pz -  z)
                do iiy = 1, nny
                  y = ymin + dely*(iiy - 1)
                  dy = sngl(py - y)
                  yz = dy**2 + dz**2
                  do iix = 1, nnx
                    x = xmin + delx*(iix - 1)
                    isize = isizes
                    jsize = jsizes
                    dx = sngl(px - x)
                    xyz = max(dx**2 + yz, 1.d-2)
                    rx = gamma*xyz
                    nroots = (itype + jtype)/2 + 1
!
!  Solve the Rys polynomials.  See: J. Rys, M. Dupuis,
!  and H. F. King, J. Comput. Chem. 4,154 (1983).
!
                    call rys(rx, nroots, u, w)
                    mm = 0
                    do n = 1, nroots
                      uu = gamma*u(n)
                      ww = -w(n)
                      tt = gamma + uu
                      ttinverse = 1.d0/tt
                      t = sqrt(tt)
                      t = 1.d0/t
                      x0 = (px*gamma + uu*x)*ttinverse
                      y0 = (py*gamma + uu*y)*ttinverse
                      z0 = (pz*gamma + uu*z)*ttinverse
                      in = mm
                      do k = 1, lit
                        do l = 1, ljt
                          jn = in + l
!
!  Solve for the one-dimensional integrals using Gauss-Hermite Quadrature
!
                          call vint(xint, yint, zint, k,l, x0, y0, z0, &
                          iatomx, iatomy, iatomz, jatomx, jatomy, jatomz, t)
                          xin(jn) = xint
                          yin(jn) = yint
                          zin(jn) = zint * ww
                        end do
                        in = in + 4
                      end do
                      mm = mm + 16
                    end do
                    do k = 1, ij
                      nx = ijx(k)
                      ny = ijy(k)
                      nz = ijz(k)
                      dtemp1 = 0.d0
                      mm = 0
                      do l = 1,nroots
                        dtemp1 = dtemp1 + xin(nx + mm)*yin(ny + mm)*zin(nz + mm)
                        mm = mm + 16
                      end do
                      ep(k) = sngl(contractiondensity(k)*dtemp1)
                    end do
                    kl = 0
                    do k = istart(i), istop(i)
                      if (sames) then
                        lmax = k
                      else
                        lmax = istop(j)
                      end if
                      do l = istart(j), lmax
                        kl = kl + 1
                        planexy(pij) = planexy(pij) + ep(kl)*sngl(p((k*(k - 1))/2 + l))
                        if (pij == 231) then
                          pij = pij
                        end if
                      end do          !  "l" shell loop
                    end do            !  "k" shell loop
                  pij = pij + 1
                  end do              !  "x" loop
                end do                !  "y" loop
              end do                  !  "z" loop
            end if
          end do                      ! Outermost "jg" loop
        end do                        ! Outermost "ig" loop
      end do                          ! Outermost "j" loop
    end do
    nxyz = pij - 1                 ! Outermost "i" loop
    scr2 = planexy
    EUpperRange = 0.9d0
    do
      do i = 1, nxyz
        if (abs(scr2(i)) < EUpperrange .and. abs(scr2(i)) > 1.d-4) nFit = nFit + 1
      end do
      if (nFit > nxyz - 10) exit
      EUpperRange = EUpperRange*2.d0
    end do
    EUpperRange = EUpperRange*0.5d0
    pij = 1
    el = 7*numat
    allocate(amatrix(el*el), qraux(el), bVector(el), aVector(el), &
    rsd(el), qy(el), qty(el), xb(el), jpvt(el))
    jpvt = 0
    aMatrix = 0.e0
    bVector = 0.e0
    i = 0
    l = 0
    do iiz = 1, nnz
      z = zmin + delz*(iiz - 1)
      do iiy = 1, nny
        y = ymin + dely*(iiy - 1)
        do iix = 1, nnx
          x = xmin + delx*(iix - 1)
          l = l + 1
          if (abs(scr2(l)) <  EUpperrange .and. abs(scr2(l)) > 1.d-4) then
            call evec(aVector, x, y, z, coord, numat)
            do m = 1, el
              do n = 1, el
                aMatrix((m - 1)*el + n) =  aMatrix((m - 1)*el + n) + aVector(m)*aVector(n)
              end do
              bVector(m) =  bVector(m) + aVector(m)*Scr2(l)
            end do
            i = i + 1
          end if
          pij = pij + 1
        end do
      end do
    end do
!
!  Use the Householder transformation to compute the QR factorization of the aMatrix of size el.
!
    i = 1
    call sqrdc(aMatrix, el, el, el, qraux, jpvt, aVector, i)
    dtemp2 = Abs(aMatrix(1))*1.d-5
    do k = 1, el
      dtemp1 = Abs(aMatrix((k - 1)*el + k))
      if (dtemp1 < dtemp2) exit
    end do
    nUse = k - 1
!
!  SQRSL applies the output of SQRDC to compute coordinate
!     transformations, projections, and least squares solutions.
!
    i = 111
    call sqrsl(aMatrix, el, el, nUse, qraux, bVector, qy, qty, aVector, rsd, xb, i, j)
    do j = 1, el
      jpvt(j) = -jpvt(j)
      if (j > nUse) aVector(j) = 0.e0
    end do
!
! Untangle the vectors
!
    do j = 1, el
      if (jpvt(j) <= 0) then
        k = -jpvt(j)
        do while (k /= j)
          rtemp = aVector(j)
          aVector(j) = aVector(k)
          aVector(k) = rtemp
          jpvt(k) = -jpvt(k)
          k = jpvt(k)
        end do
      end if
    end do
    xmax = xmax + 4.d0
    xmin = xmin - 4.d0
    ymax = ymax + 4.d0
    ymin = ymin - 4.d0
    zmax = zmax + 4.d0
    zmin = zmin - 4.d0
    i = index(keywrd," ESPGR")
    if (i /= 0) then
      nnx = max( nint(reada(keywrd, i + 8)), 60)
      nny = nnx
      nnz = nnx
    else
      nnx = 60
      nny = 60
      nnz = 60
    end if
    allocate(esp_array(nny*nnz))
    delx = (xmax - xmin)/(nnx - 1)
    dely = (ymax - ymin)/(nny - 1)
    delz = (zmax - zmin)/(nnz - 1)

    cube = (index(keywrd, " CUBE") /= 0)
    espgrid = (index(keywrd, " ESPGRID") /= 0)
    if (cube) then
!
!  Write out ESP data in format for Jmol
!
      open (iesp, file=trim(jobnam)//".grd"  , status="UNKNOWN")
      write (iesp,"(a)") " 4 Density"
      write (iesp,"(a)") " Electron density from Total SCF Density"
      write (iesp, "(i5,3f12.6)")numat, xmin, ymin, zmin
      write (iesp, "(i5, 3f12.6)") nnx, delx, 0.d0, 0.d0
      write (iesp, "(i5, 3f12.6)") nny, 0.d0, dely, 0.d0
      write (iesp, "(i5, 3f12.6)") nnz, 0.d0, 0.d0, delz
      do i = 1, numat
        write(iesp,"(i5,4f12.6)") nat(i), nat(i)*1.d0, coord(1,i), coord(2,i), coord(3,i)
      end do
!
!   Write out electrostatic values
!
      do iix = 1, nnx
      x = xmin + delx*(iix - 1)
      pij = 0
      do iiy = 1, nny
        y = ymin + dely*(iiy - 1)
        do iiz = 1, nnz
          z = zmin + delz*(iiz - 1)
          pij = pij + 1
          call evec(bVector, x, y, z, coord, numat)
          rtemp = 0.e0
          do k = 1, el
            rtemp = rtemp + aVector(k)*bVector(k)
          end do
          esp_array(pij) = rtemp
        end do
      end do
      write(iesp, "(5e13.5)") esp_array(:pij)
    end do
    else if (espgrid) then
      open (iesp, file=trim(jobnam)//'.grd', status="UNKNOWN")
      write (iesp, "(3f12.6)") xmin*a0, ymin*a0, zmin*a0
      write (iesp, "(i5, 3f12.6)") nnx, delx*a0, delx*a0, delx*a0
      write (iesp, "(i5, 3f12.6)") nny, dely*a0, dely*a0, dely*a0
      write (iesp, "(i5, 3f12.6)") nnz, delz*a0, delz*a0, delz*a0
!
!   Write out electrostatic values
!
      do iiz = 1, nnz
      z = zmin + delz*(iiz - 1)
      pij = 0
      do iiy = 1, nny
        y = ymin + dely*(iiy - 1)
        do iix = 1, nnx
          x = xmin + delx*(iix - 1)
          pij = pij + 1
          call evec(bVector, x, y, z, coord, numat)
          rtemp = 0.e0
          do k = 1, el
            rtemp = rtemp + aVector(k)*bVector(k)
          end do
          esp_array(pij) = rtemp
        end do
      end do
      write(iesp, "(e13.5)") esp_array(:pij)
      end do
    end if
  end subroutine new_esp

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine depfn (fns, diffns, loop, loch, ndep, ihref, nfns, numvar)
    use param_global_C, only : weight, hofcal
    implicit none
    integer, intent (in) :: loop, ndep, nfns, numvar
    integer, dimension (loop), intent (in) :: loch
    integer, dimension (ndep), intent (in) :: ihref
    double precision, dimension (nfns), intent (inout) :: fns
    double precision, dimension (numvar, nfns), intent (inout) :: diffns
    integer :: i, iref, j, k, l
  !
  ! ... Executable Statements ...
  !
  !
  !   Modify FNS and DIFFNS to allow for dependent molecules
  !
  !
  !    LOOP = Current molecule number (The H.o.F. of this molecule
  !           depends on the H.o.F. os the molecules in IHREF)
  !
  !    IREF = Address of current molecule in FNS and in DIFFNS
  !
  !    J    = Index of the dependent molecule.
  !
  !    K    = Address of dependent molecule in FNS and in DIFFNS.
    iref = loch(loop)
    do i = 1, ndep
      j = ihref(i)
      k = loch(j)
    !
    !  Calculate the new error in the H.o.F in one step.
    !
      fns(iref) = fns(iref) - hofcal(j) * weight(1, loop)
    !
    !  Calculate the new derivatives:
    !
      do l = 1, numvar
        diffns(l, iref) = diffns(l, iref) - diffns(l, k) / weight(1, j) * &
       & weight(1, loop)
      end do
    end do
end subroutine depfn

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

 subroutine getpar
!**********************************************************************
!
!   GETPAR 1: Reads in any reference parameters from a previous run.
!          2: Reads in the list of parameters to be optimized.
!
!**********************************************************************
    use param_global_C, only : valvar, valold, toplim, botlim,  &
    numvar, ifiles_8, locked, contrl, &
    maxpms, locvar
    use chanel_C, only: iw, ir
    use parameters_C, only : udd, zd, f0sd, g2sd, main_group, f0sd_store, g2sd_store, &
    dorbs, partyp, defmin, defmax, n_partyp_fn, n_partyp_alpb, n_partyp
    implicit none
    character :: text*240, text2*240,koment*120, elemnt2*2
    logical :: buggy = .false., use_list
    integer :: i, j, k, l, jelmnt, io_stat, &
    & npar, mpar, nele, ipar, iele, n_ele, nlines
    character (len=2), dimension (107) :: elemnt
    character (len=7), dimension (2,1000) :: parlist
    external upcase
    double precision, external :: reada
    intrinsic Index
    data (elemnt(i), i=1, 107) / "H ", "HE", "LI", "BE", "B ", "C ", "N ", "O ", &
   & "F ", "NE", "NA", "MG", "AL", "SI", "P ", "S ", "CL", "AR", "K ", "CA", &
   & "SC", "TI", "V ", "CR", "MN", "FE", "CO", "NI", "CU", "ZN", "GA", "GE", &
   & "AS", "SE", "BR", "KR", "RB", "SR", "Y ", "ZR", "NB", "MO", "TC", "RU", "RH", &
   & "PD", "AG", "CD", "IN", "SN", "SB", "TE", "I ", "XE", "CS", "BA", "LA", &
   & "CE", "PR", "ND", "PM", "SM", "EU", "GD", "TB", "DY", "HO", "ER", "TM", &
   & "YB", "LU", "HF", "TA", "W ", "RE", "OS", "IR", "PT", "AU", "HG", "TL", "PB", &
   & "BI", "PO", "AT", "RN", "FR", "RA", "AC", "TH", "PA", "U ", "NP", "PU", &
   & "AM", "CM", "BK", "MI", "XX", "+3", "-3", "CB", "++", "+", "--", "-", "TV" /
    do i = 1,90
    if (main_group(i)) f0sd(i) = 0.d0
    if (main_group(i)) g2sd(i) = 0.d0
    if (f0sd_store(i) < 1.d-5) f0sd_store(i) = f0sd(i)
    if (g2sd_store(i) < 1.d-5) g2sd_store(i) = g2sd(i)
    dorbs(i) = (Abs(udd(i)) > 1.d-8 .and. zd(i) > 1.d-1)
    end do
!
!  Read in parameters to be optimized
!
    numvar = 0
    locked = .false.
    nlines = 0
    if (index(contrl, " NOLIM") /= 0) then
      defmax = 400.d0
      defmin = -400.d0
    end if
!
!  Read in each parameter to be optimized, one parameter per line
!
    do
      read (ir, "(A240)", iostat=io_stat) text
      if(io_stat /= 0 .or. text == " ") goto 97
      call upcase (text, len_trim(text))
      nlines = nlines + 1

      if (Index (text, "END") /= 0) then
        close(unit=iw,status="DELETE")
        if (buggy) then
          write(ifiles_8,"(a)")" One or more parameters have an exactly zero value"
          write(ifiles_8,"(a)")" Either set value to non-zero or remove parameter"
          call finish
        end if
        if (numvar == 0 .and. nlines > 1) then
          write(ifiles_8,"(a)")" None of the parameters read in have non-zero values"
          write(ifiles_8,"(a)")" Either set one or more values to non-zero or remove parameters"
          call finish
        end if
        i = numvar
        do numvar = 1, i
           call print_par
        end do
        numvar = i
        return
      end if
!
!   Check for par symbols
!
      i = index(text, "PAR")
      if (i /= 0) then
        numvar = numvar + 1
        if (numvar > maxpms) then
          write (ifiles_8, "(A,I5)") " Too many parameters to be optimized. Max:", maxpms
          stop
        end if
        locvar(1, numvar) = 41 ! Parameter type is "PAR"
        locvar(2, numvar) = nint(reada(text, i))
        if (mpar == 1) locked(numvar) = .true.
        botlim(numvar) = -1.d3
        toplim(numvar) =  1.d3
        i = index(text(i:)," ") + i
        do i = i, 67
!
!  Check for bottom limit
!
          if (text(i:i) /= " ") then
            botlim(numvar) = reada (text, i)
            exit
          end if
        end do
!
!  Check for top limit
!
        i = Index (text(i:), " ") + i
        do i = i, 67
          if (text(i:i) /= " ") then
            toplim(numvar) = reada (text, i)
            exit
          end if
        end do
        call extract_parameter(locvar(1, numvar), locvar(2, numvar), valvar(numvar))
        valold(numvar) = valvar(numvar)
        goto 96
      end if
      if (index(text, "PAR") /= 0) then
        i = index(text,"PAR") + 4
        text2 = text
        j = ichar(text(i-1:i-1)) - ichar("0")
        if (text(i:i) /= " ") j = j*10 + ichar(text(i:i)) - ichar("0")
        if (j < 13) then
          k = mod(j - 1,3) + 1
          j = (j - 1)/3 + 1
          write(text,"('FN',2i1,' XX ',a)") k, j, trim(text2(i + 1:))
        else
          j = j - 12
          k = mod(j - 1,3) + 1
          j = (j - 1)/3 + 1
           write(text,"('FN',2i1,' MI ',a)") k, j, trim(text2(i + 1:))
         end if
      end if
      use_list = .false.
!
!  If "text" involves parentheses, parse the line to extract the different
!  parameters to be optimized
!
      k = Index(text,"(") + 1
      if (k /= 1) then
        use_list = .true.
        do
          i = index(text," )")
          if (i /= 0) then
            text(i:) = text(i + 1:)
          else
            exit
          end if
        end do
        l = Index(text,")")
        do n_ele = 1,84
          nele = n_ele
          do
            if (text(k:k) /= " ") exit
            k = k + 1
          end do
          j = Min(Index(text(k:)," ") + k - 1 , l-1)
          if (j == k - 1) j = l - 1
!
! "k" marks the start of the element symbol
! "j" marks the end of the element symbol
!
          if(j - k > 2 .or. j - k > 1 .and. text(j:j) /= " ")then
            if (text(k:j) == "ALL") then
              nele = 0
              do i = 1,57
                nele = nele + 1
                parlist(1,nele) = elemnt(i)
              end do
              do i = 71, 83
                nele = nele + 1
                parlist(1,nele) = elemnt(i)
              end do
              goto 23
            else
!
!   Trap instances where chemical symbols are not separated by spaces
!
              write(ifiles_8,"(3a)")" Element symbol more than two characters, symbol: '",text(k:j),"'"
              call finish
            end if
          end if
          parlist(1,n_ele) = text(k:j)
          k = j + 1
          if (k >=l) exit
        end do
  23    text = text(l+1:)
        k = Index(text,"(") + 1
        l = Index(text,")")
        do npar = 1,50
          do
            if (text(k:k) /= " ") exit
            k = k + 1
          end do
          j = Min(Index(text(k:)," ") + k - 1 , l-1)
          if (j == k - 1) j = l - 1
!
! "k" marks the start of the parameter symbol
! "j" marks the end of the parameter symbol
!
          parlist(2,npar) = text(k:j)
          k = j + 1
          if (k >=l) exit
        end do
      else
        npar = 1
        nele = 1
      end if
      text2 = text
      do iele = 1, nele ! iele loop
        if (Index(text2,"ALL") /= 0) then
            do j = 1, 99
            k = Index (" "//parlist(1,iele), " "//elemnt(j))
            if (k /= 0) then
              call what_parameters(j,parlist,mpar)
              exit
            end if
          end do
        else
          mpar = npar
        end if
        mpar_loop: do ipar = 1,mpar
          if (use_list) text = parlist(2,ipar)//" "//parlist(1,iele)
          koment = "    " // text (1:76)
          do i = 1, 80
            if (koment(1:1) /= " ") exit
            text = koment(2:80)
            koment = text(:120)
          end do
          i = Index (koment, " ")
          text = koment(1:i)
          i = len_trim(text)
          if (text(i:i) == ")") text(i:i) = " "
          numvar = numvar + 1
          if (numvar > maxpms) then
            write (ifiles_8, "(A,I5)") " Too many parameters to be optimized. Max:", maxpms
            stop
          end if
          do j = 1, n_partyp
            if (text(:5) == partyp(j)) go to 1500
          end do
          if (text == " ") then
            numvar = numvar - 1
            cycle
          end if
          go to 2000
    1500  locvar(1, numvar) = j
          if (mpar == 1) locked(numvar) = .true.
          jelmnt=0
          if (j == n_partyp_alpb .or. j == n_partyp_alpb + 1) then
!
!  This is a di-atomic parameter - read in the other element number
!
            i = Index(text, partyp(j))+5
            do j = 1, 99
              if (Index (" "//text(i:i+2), " "//elemnt(j)) /= 0) exit
            end do
            jelmnt = j
          end if
          i = Index (koment, " ")
          text = koment(i:)
          koment = text(:120)
          do i = 1, 50
            if (koment(1:1) /= " ") exit
            text = koment(2:50)
            koment = text(:120)
          end do
          text = " " // koment (1:49)
          botlim(numvar) = defmin(locvar(1, numvar))
          toplim(numvar) = defmax(locvar(1, numvar))
!Gallo
! Instead of setting the general upper and lower bounds to -1000 and 1000,
! respectively, they are defined in parameters_C.F90 also for par == T
!          if (par) then
!            botlim(numvar) = -1000.d0
!            toplim(numvar) =  1000.d0
!          end if
!Gallo
!
!  Read in lower and upper limits
!
          do i = 4, 67
!
!  Check for bottom limit
!
            if (text(i:i) /= " ") then
              botlim(numvar) = reada (text, i)
              exit
            end if
          end do
!
!  Check for top limit
!
          i = Index (text(i:), " ") + i
          do i = i, 67
            if (text(i:i) /= " ") then
              toplim(numvar) = reada (text, i)
              exit
            end if
          end do
          do j = 1, 100
            k = Index (text, " "//elemnt(j))
            if (k /= 0) go to 1900
          end do
          if (J == 101 .or. text /= " ") then
            write (ifiles_8, "(A)") " Element not recognized:"//text(1:len_trim(text)+1)
            stop
          end if
    1900  locvar(2, numvar) = j + jelmnt*200
!
!  Check: Is this parameter already marked for optimization?
!
          do i = 1, numvar - 1
              if (locvar(1,i) == locvar(1,numvar)) then
                k = locvar(2, i)/200
                if(k /= 0) then
                  l = locvar(2,i) - k*200
                  if ((k == j .and. l == jelmnt) .or. (k == jelmnt .and. l == j)) then
                    numvar = numvar -1
                    cycle mpar_loop
                  end if
                else
                  if (locvar(2,i) == j) then
                    numvar = numvar -1
                    cycle mpar_loop
                  end if
                end if
              end if
            end do
          call extract_parameter(locvar(1, numvar), locvar(2, numvar), valvar(numvar))
!
!  Is the parameter one that cannot be optimized, i.e. a transition metal with Gss - Hsp?
!
          if (locvar(2,numvar) < 200) then
            if (.not. main_group(locvar(2,numvar))) then
              if (locvar(1,numvar) > 9 .and. locvar(1,numvar) < 15) then
                numvar = numvar -1
                cycle
              end if
            end if
          end if
          if (Abs(valvar(numvar)) < 1.d-20) then
            numvar = numvar - 1
            cycle
          end if
          if (.not. buggy) buggy = (Abs(valvar(numvar)) < 1.d-6)
          i = locvar(2,numvar)
          if(i > 200) then
            j = i/200
            i = i - j*200
            elemnt2 = elemnt(j)
            if(elemnt2(2:2) == " ")elemnt2 = elemnt2(1:1)
          else
            elemnt2 = " "
          end if
!    call lockit(valvar(numvar), numvar)
!
!   Crude way to lock various parameters
!
          if (locvar(1,numvar) == 19 .and. locvar(2,numvar) == 17) then
            if (Abs(botlim(numvar) -0.5d0) < 1.d-3) botlim(numvar) = 2.d0! Lock Cl ZSN
          end if
          j = locvar(1,numvar) - n_partyp_fn + 1
          text(2:2) = " "
          if (i == 98) j = j + 12
          if (j < 10) then
            text(1:1) = char(j + ichar("0"))
          else if (j < 20) then
            text(2:2) = char(j - 10 + ichar("0"))
            text(1:1) = "1"
          else
            text(2:2) = char(j - 20 + ichar("0"))
            text(1:1) = "2"
          end if
          valold(numvar) = valvar(numvar)
        end do mpar_loop
      end do ! iele loop
!
!  Check on atomic and diatomic parameters complete.
!
96 continue
    end do ! End of loop over lines read in
2000 write (ifiles_8, "(A)") text
    write (ifiles_8, "('   NAME NOT FOUND')")
    write (ifiles_8,*)" PARAM data set:"
    rewind (ir)
    do
     read (ir, "(A80)", end=199, err=199) text
     write (ifiles_8,'(a)')text(1:len_trim(text))
    end do!  All parameters loop
199 stop
97  return
end subroutine getpar
subroutine what_parameters(z,parlist,mpar)
  use parameters_C, only : alpb
  implicit none
  integer :: z, mpar
  double precision alp
  character (len=7), dimension (2,1000) :: parlist
  integer :: i
  character (len=2), dimension (99) :: elemnt
  data elemnt /  "H ", "HE", "LI", "BE", "B ", "C ", "N ", "O ", "F ", "NE", &
   & "NA", "MG", "AL", "SI", "P ", "S ", "CL", "AR", "K ", "CA", "SC", "TI", &
   & "V ", "CR", "MN", "FE", "CO", "NI", "CU", "ZN", "GA", "GE", "AS", "SE", "BR&
   &",     "KR", "RB", "SR", "Y ", "ZR", "NB", "MO", "TC", "RU", "RH", "PD", "AG", &
   & "CD", "IN", "SN", "SB", "TE", "I ", "XE", "CS", "BA", "LA", "CE", "PD", &
   & "ND", "PM", "SM", "EU", "GD", "TB", "DY", "HO", "ER", "TM", "YB", "LU", "HF&
   &",     "TA", "W ", "RE", "OS", "IR", "PT", "AU", "HG", "TL", "PB", "BI"&
   & , "PO", "AT", "RN", "FR", "RA", "AC", "TH", "PA", "U ", "NP", "PU", "AM", &
   & "CM", "BK", "CF", "XX" /
  parlist(2,1) = "USS"
  parlist(2,2) = "UPP"
  parlist(2,3) = "UDD"
  parlist(2,4) = "ZSN"
  parlist(2,5) = "ZPN"
  parlist(2,6) = "ZDN"
  parlist(2,7) = "ZS"
  parlist(2,8) = "ZP"
  parlist(2,9) = "ZD"
  parlist(2,10) = "BETAS"
  parlist(2,11) = "BETAP"
  parlist(2,12) = "BETAD"
  parlist(2,13) = "GSS"
  parlist(2,14) = "GSP"
  parlist(2,15) = "GPP"
  parlist(2,16) = "GP2"
  parlist(2,17) = "HSP"
  parlist(2,18) = "F0SD"
  parlist(2,19) = "G2SD"
  parlist(2,20) = "ALP"
    parlist(2,21) = "FN11"
    parlist(2,22) = "FN21"
    parlist(2,23) = "FN31"
    parlist(2,24) = "FN12"
    parlist(2,25) = "FN22"
    parlist(2,26) = "FN32"
    parlist(2,27) = "FN13"
    parlist(2,28) = "FN23"
    parlist(2,29) = "FN33"
    parlist(2,30) = "FN14"
    parlist(2,31) = "FN24"
    parlist(2,32) = "FN34"
    mpar=33
  parlist(2,mpar) = "POC"
  do i =1,83
    alp = alpb(i,z)
    if (alp > 0.001d0) then
      mpar = mpar + 1
      parlist(2,mpar) = "ALPB_"//elemnt(i)
      mpar = mpar + 1
      parlist(2,mpar) = "XFAC_"//elemnt(i)
    end if
  end do

end subroutine what_parameters
subroutine lockit(value, numvar)
  implicit none
  double precision :: value
  integer :: numvar
! double precision :: multiplier = 1.d7
    value = value
    numvar = numvar
       return
!
!  Truncate value so that the last digits are all zero's
!
!     i = int(value)
!     value = i + nint((value - i)*multiplier)/multiplier
!    if (.not. locked(numvar)) then
!
!  Modify value of parameter so that the last digit printed is not zero
!
!    value =  value + 0.2d0/multiplier
!  end if
  end subroutine lockit
  subroutine print_par
    use param_global_C, only : valvar, toplim, botlim, numvar, ifiles_8, locvar, &
      penalty, contrl
    use parameters_C, only : partyp
!
!  Local
!
    double precision :: penalty_fn
    integer :: i, j
    logical :: lfirst = .true., l_prt
    character :: typtxt, text*5, elemnt2*2, num*1
       character (len=2), dimension (107) :: elemnt
    data (elemnt(i), i=1, 107) / "H ", "HE", "LI", "BE", "B ", "C ", "N ", "O ", &
   & "F ", "NE", "NA", "MG", "AL", "SI", "P ", "S ", "CL", "AR", "K ", "CA", &
   & "SC", "TI", "V ", "CR", "MN", "FE", "CO", "NI", "CU", "ZN", "GA", "GE", &
   & "AS", "SE", "BR", "KR", "RB", "SR", "Y ", "ZR", "NB", "MO", "TC", "RU", "RH", &
   & "PD", "AG", "CD", "IN", "SN", "SB", "TE", "I ", "XE", "CS", "BA", "LA", &
   & "CE", "PR", "ND", "PM", "SM", "EU", "GD", "TB", "DY", "HO", "ER", "TM", &
   & "YB", "LU", "HF", "TA", "W ", "RE", "OS", "IR", "PT", "AU", "HG", "TL", "PB", &
   & "BI", "PO", "AT", "RN", "FR", "RA", "AC", "TH", "PA", "U ", "NP", "PU", &
   & "AM", "CM", "BK", "MI", "XX", "+3", "-3", "CB", "++", "+", "--", "-", "TV" /
    save
    l_prt = (index(contrl, " SURVEY") == 0)
    if (lfirst) then
      if (l_prt) then
        write (ifiles_8, "(//,10X,A)") "    PARAMETERS TO BE OPTIMIZED"
        write (ifiles_8, "(//5X, ' PARAMETER TYPE  ELEMENT    PARAMETER      LOWER LIMIT',&
            &'   UPPER LIMIT')")
      end if
      lfirst = .false.
    end if
    i = locvar(2,numvar)
    if (i > 200) then
      j = i/200
      i = i - j*200
      elemnt2 = elemnt(j)
      if(elemnt2(2:2) == " ")elemnt2 = elemnt2(1:1)
    else
      elemnt2 = " "
    end if
    typtxt = " "
    penalty_fn = penalty*((Max(0.d0, valvar(numvar)-toplim(numvar))+ &
    & Min(0.d0, valvar(numvar)-botlim(numvar))))**2
    if (penalty_fn > 1.d-6) typtxt = "*"
    if (l_prt) then
      if (penalty_fn > 1.d-6) then
        if (locvar(1, numvar) == 41) then
           write (ifiles_8, "(12X,A,11X,F16.8,A1,2F16.2)") &
          & text(:5),  valvar(numvar), "*", &
          & botlim(numvar), toplim(numvar)
        else
          write (ifiles_8, "(12X,A,7X,A,F16.8,A1,3F16.2)") &
          & partyp(locvar(1, numvar))//elemnt2, elemnt(i), valvar(numvar), typtxt, &
          & botlim(numvar), toplim(numvar), penalty_fn
        end if
      else
        if (locvar(1, numvar) == 41) then
          text = "PAR"
          if (i < 10) then
            num = "1"
          else
            num = "2"
          end if
          write(text(4:),'(i'//num//')')i
          write (ifiles_8, "(12X,A,11X,F16.8,A1,2F16.2)") &
          & text(:5),  valvar(numvar)
        else
          write (ifiles_8, "(12X,A,7X,A,F16.8,A1,2F16.2)") &
          & partyp (locvar(1,numvar))//elemnt2, elemnt(i), valvar(numvar), typtxt, &
          & botlim(numvar), toplim(numvar)
        end if
      end if
    end if
    return
    end subroutine print_par

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  subroutine run_mopac
  !dec$ attributes dllexport :: run_mopac
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!
      use common_arrays_C, only : nfirst, nlast, nat, xparam, grad, nw, &
      p, pa, pb, labels, loc, time_start, l_atom, coord, txtatm, coorda, &
      txtatm1, cell_ijk, eigs, c, breaks
!
      USE molkst_C, only : gnorm, natoms, numat, nvar, numcal, job_no, nscf, id, &
        escf, iflepo, iscf, keywrd, last, moperr, maxatoms, ncomments, &
        time0, atheat, errtxt, isok, mpack, line, na1, refkey, keywrd_txt, &
        press, mozyme, step_num, jobnam, nelecs, stress, E_disp, E_hb, E_hh, no_pKa, &
        MM_corrections, lxfac, trunc_1, trunc_2, l_normal_html, &
        sparkle, itemp_1, maxtxt, koment, sz, ss2, keywrd_quoted, &
        nl_atoms, use_ref_geo, prt_coords, pdb_label, step, &
        density, norbs, method_indo, nclose, nopen, backslash, gui, os, git_hash, verson
!
      USE parameters_C, only : tore, ios, iop, iod, eisol, eheat, zs, eheat_sparkles, gss
!
!
      use cosmo_C, only : iseps, useps, lpka, solv_energy, area, fepsi, ediel
!
      USE funcon_C, only : fpc_9
!
      USE maps_C, only : latom, react, rxn_coord
!
      use symmetry_C, only : state_Irred_Rep, name
!
      USE chanel_C, only : ir, iw, iarc, output_fn, end_fn, iend, &
        archive_fn, log, ilog, xyz_fn, job_fn, log_fn
!
      use MOZYME_C, only : rapid, nres, refnuc, uni_res
!
      use meci_C, only : nmos, lab
!
      use elemts_C, only : elemnt, atom_names
!
      USE reimers_C, only: noh, nvl, cc0, nel, norb, norbl, norbh,&
          nshell, filenm, lenf, evalmo, nbt, multci, occfr, vca, vcb
#ifdef GPU
      Use iso_c_binding
      Use mod_vars_cuda, only: lgpu, ngpus, gpu_id
      Use gpu_info
      Use settingGPUcard
#endif
      implicit none
      integer ::  i, j, k, l
      double precision :: eat,  tim, store_fepsi
      logical :: exists, opend, sparkles_available, l_OLDDEN
      double precision, external :: C_triple_bond_C, reada, seconds
      character :: nokey(20)*10
#ifdef _OPENMP
      integer :: num_threads, default_num_threads
      integer, external :: omp_get_max_threads
#endif
#ifdef MKL
      integer :: num_threads
      integer, external :: mkl_get_max_threads
#endif
#ifdef GPU
      logical :: lgpu_ref
      logical(c_bool)    :: hasGpu = .false.
      logical(c_bool)    :: lstat = .false.
      logical(c_bool)    :: hasDouble(6)
      integer(c_int)     :: nDevices
      character*256	     :: gpuName(6)
      integer(c_size_t)  :: totalMem(6)
      logical            :: gpu_ok(6)
      character*3        :: on_off(6)
      integer(c_int), dimension(6)	 :: clockRate, major, minor, name_size
#endif
! set versioning information
#ifdef MOPAC_VERSION_FULL
      verson = MOPAC_VERSION_FULL
#endif
#ifdef MOPAC_OS
      os = MOPAC_OS
#endif
#ifdef MOPAC_GIT_HASH
      git_hash = MOPAC_GIT_HASH
#endif
! parse command-line flags
#ifdef MOPAC_F2003
      do i = 1, command_argument_count()
        call get_command_argument (i, jobnam)
#else
      do i = 1, iargc()
        call getarg (i, jobnam)
#endif
        if (jobnam == '-V' .OR. jobnam == '--version') then
          write(*,"(a)") "MOPAC version "//trim(verson)//" commit "//trim(git_hash)
          stop
        endif
      end do
!------------------------------------------------------------------------
      tore = ios + iop + iod
      call fbx                            ! Factorials and Pascal's triangle (pure constants)
      call fordd                          ! More constants, for use by MNDO-d
      trunc_1 = 7.0d0    ! Beyond 7.0 Angstroms, use exact point-charge
      trunc_2 = 0.22d0   ! Multiplier in Gaussian: exp(-trunc_2*(trunc_1 - Rab)^2)
!
! Read in all data; put it into a scratch file, "ir"
!
      moperr = .false.
      call getdat(ir,iw)
      call to_screen("To_file: Start of reading in data")
      if (natoms == 0 .or. moperr) return
!
!   CLOSE UNIT IW IN CASE IT WAS ALREADY PRE-ASSIGNED
!
      close(iw)
!
! WARNING - Replace with standard name, sometime.
!
      i = index(jobnam,' ') - 1
      filenm = trim(jobnam)
      lenf = i+1
      l = 0
 11   open(unit=iw, file=output_fn, status='UNKNOWN', position='asis', iostat = i)
      if (i /= 0) then
        l = l + 1
        write(0,"(i3,3a)")21 - l," File """,output_fn(:len_trim(output_fn)),""" is unavailable for use"
        write(0,"(a)")"    Correct fault (probably the output file is in use elsewhere)"
        call sleep(5)
        if (l < 20) goto 11
        write(0,"(a)") "Job abandoned due to output file being unavailable"
        call mopend("Job abandoned due to output file being unavailable")
        call sleep(5)
        goto 101
      end if
      if (l > 0) then
       write(0,"(a)")" Fault successfully corrected.  Job continuing"
      end if
      rewind iw
      isok = .TRUE.
      errtxt = 'Job stopped by operator'
      tim = seconds(1)
      call date_and_time(VALUES=time_start)
      if (moperr) goto 101
!
! Set up essential arrays, these are the arrays that are needed for reading in the data
!
      natoms = natoms + 200
      call setup_mopac_arrays(natoms, 1)
      maxatoms = natoms
   10 continue
      numcal = numcal + 1      ! A new calculation
      job_no = job_no + 1      ! A new job
      if (job_no > 1) then
        backspace(ir)
        read(ir,'(a)', iostat = i) line
        if (i == 0) then
          if (line /= " ") then
            call upcase(line, len_trim(line))
            if (index(line, "NEXT") /= 0) backspace(ir)
          end if
        end if
      end if
      step_num = step_num + 1  ! New electronic structure, therefore increment step_num
      moperr = .FALSE.
      name = " "
      escf   = 0.d0
      ediel  = 0.d0
      gnorm  = 0.D0
      press  = 0.d0
      E_disp = 0.d0
      E_hb   = 0.d0
      E_hh   = 0.d0
      solv_energy = 0.d0
      sz = 0.d0
      ss2 = 0.d0
      step = 0.d0
      density = 0.d0
      area = 0.d0
      store_fepsi = fepsi
      fepsi = 0.d0
      refnuc = 0.d0
      nres = 0
      nscf = 0
      nmos = 0
      na1 = 0
      norbs = 0
      lab = 0
      lpka = .false.
      stress = 0.d0
      no_pKa = 0
      cell_ijk = 0
      uni_res = 0
      id = 0
      iflepo = 0
      time0 = seconds(1)
      MM_corrections = .false.
      nelecs = 0
      pdb_label = .false.
      l_normal_html = .true.
      state_Irred_Rep = " "
      if (job_no > 1) then
        i = index(keywrd, " BIGCYCL")
        if (i /= 0 .and. index(keywrd,' DRC') == 0) then
          i = nint(reada(keywrd, i)) + 1
          if (job_no < i) then
            fepsi = store_fepsi
            goto 90
          end if
        end if
      end if
      if (numcal > 1 .and. numcal < 4 .and. index(keywrd_txt," GEO_DAT") /= 0) then
!
!  Quickly jump over first three lines
!
        close (ir)
        i = natoms
        call getdat(ir,iw)
        natoms = i
        call gettxt
      end if
      if (numcal > 1) call to_screen("To_file: Leaving MOPAC")
!
!    Read in all the data for the current job
!
      i = numcal
      call readmo
!
! Check to see if an old density matrix exists
!
      line = trim(job_fn)
      i = len_trim(line)
      if (i > 4) then
        j = index(line(i - 4:), ".")
        if (j /= 0) i = i - 6 + j
      end if
      inquire(file=line(:i)//".den", exist=l_OLDDEN)
90      if (moperr .and. numcal == 1 .and. natoms > 1) goto 101
      if (moperr .and. numcal == 1 .and. index(keywrd_txt," GEO_DAT") == 0) goto 100
      if (moperr) goto 101
! Adjust maximum number of threads using the OpenMP API
#ifdef _OPENMP
      if (numcal == 1) default_num_threads = omp_get_max_threads()
      i = index(keywrd, " THREADS")
      if (i > 0) then
        num_threads = nint(reada(keywrd, i))
      else
        num_threads = default_num_threads
      end if
      call omp_set_num_threads(num_threads)
#endif
      if (numcal == 1) then
#ifdef MKL
        num_threads = min(mkl_get_max_threads(), 20)
        i = index(keywrd, " THREADS")
        if (i > 0) then
          i = nint(reada(keywrd, i))
          num_threads = min(max(1,i), num_threads)
        end if
        call mkl_set_num_threads(num_threads)
#endif
#ifdef GPU
        gpuName(1:6) = '' ; name_size(1:6) = 0 ; totalMem(1:6) = 0 ; clockRate(1:6) = 0
        hasDouble(1:6) = .false. ; gpu_ok(1:6) = .false.
        clockRate(1:6) = 0 ; major(1:6) = 0 ; minor(1:6) = 0; on_off(1:6) = 'OFF'
        call gpuInfo(hasGpu, hasDouble, nDevices, gpuName,name_size, totalMem, &
                  & clockRate, major, minor)
        lgpu = .false.
        lgpu_ref = hasGPU
        if (lgpu_ref) lgpu_ref = (index(keywrd, " NOGPU") == 0)
        if (lgpu_ref) then
          lgpu_ref = .false.
! Counting how many GPUs are suitable to perform the calculations or with compute capability 2 (Fermi or Kepler).
          j = 0
          do i = 1, nDevices
            if (major(i) >= 2  .and. hasDouble(i)) then
              gpu_ok(i) = .true.
              j = j + 1
            end if
          end do
          lgpu_ref = (j >= 1)
        end if
        ngpus = 1  ! in this version only single-GPU calculation are performed. This variable control it.
!       ngpus = j ! in future versions of MOPAC Multi-GPUs calculations should be allowed

        l = 0; k = 0
        if (lgpu_ref) then
          l = index(keywrd,' SETGPU=')
          if (l /= 0) then  ! The user has inserted SETGPU keyword to Select one specific GPU
            gpu_id = nint(reada(keywrd,l))
            if (gpu_id > nDevices .or. gpu_id < 1 .or. (.not. gpu_ok(gpu_id))) then
              ! the user made a wrong choice !!!
              Write(iw,'(/,5x,a)') ' Problem with the definition of SETGPU keyword ! '
              Write(iw,'(5x,a,/)') ' MOPAC will automatically set a valid GPU card for the calculation '
              l = 0
            else
              on_off(gpu_id) = 'ON '
              call setGPU(gpu_id - 1, lstat)
              if (.not. lstat) then
                write (6,*) 'Problem to set GPU card ID = ', gpu_id
                stop
              end if
            end if
          end if
          if (l == 0) then   ! Select GPU automatically
            do i = 1, nDevices
             if (gpu_ok(i)) then
                on_off(i) = 'ON '
                gpu_id = i - 1
                call setGPU(gpu_id, lstat)
                if (.not. lstat) then
                  write (6,*) 'Problem to set GPU card ID = ', gpu_id
                  stop
                end if
                exit
              end if
            end do
          end if
        else
          nDevices = 0
          ngpus = 0
        end if
!
!  For small systems, using a GPU takes longer than not using a GPU,
!  so do not use a GPU for small systems.  The lower limit, 100, is just a guess.
!
        lgpu = (lgpu_ref .and. natoms > 100) ! Warning - there are problems with UHF calculations on small systems
#endif
      end if
      if (.not. gui .and. numcal == 1 .and. natoms == 0) then
        write(line,'(2a)')" Data set exists, but does not contain any atoms."
        write(0,'(//10x,a,//)')trim(line)
        call mopend(trim(line))
        write(0,'(5x,a)')" (Check the first few lines of the data-set for an extra blank line."
        write(0,'(5x,a)')"  If there is an extra line, delete it and re-submit.)"
        inquire(unit=ir, opened=opend)
        if (opend) close(ir, status = 'delete', err = 999)
        stop
      end if
      if (numat > 46000) then
        write(line,'(a,i5,a)')"Data set '"//trim(jobnam)//"' exists, but at ",numat," atoms is too large to run."
        write(0,'(//10x,a,//)')trim(line)
        call mopend(trim(line))
        write(iw,'(10x,a)')"(Absolute maximum size: 46,000 atoms.)"
        numat = 0
        natoms = 0
        goto 100
      end if
      if (numcal == 1 .and. moperr .or. natoms == 0) then
!
!   Check for spurious "extra" data
!
        do i = 1,15
          read(ir,*, iostat=l)line
          if (l /= 0) exit
        end do
        if (i > 14) then
          write(iw,"(//10x,a)") " WARNING: There are extra data at the end of the input data set."
          write(iw,"(10x,a,/)")"          There might be an error in the data set."
        end if
        goto 101
      end if
      if (moperr) then
        if (keywrd(:7) == " MODEL") goto 101
        go to 10
      end if
      lxfac = (index(keywrd," XFAC") /= 0)
!
! Load in parameters for the method to be used
!
      call switch
    !  if (method_PM8) method_PM7 = .true.
      if (index(keywrd_quoted,' EXTERNAL=') + index(keywrd,' EXTERNAL') /= 0) call datin (ir, iw)
      if (moperr) go to 100
      sparkle = (index(keywrd, " SPARKL") /= 0)
!
!  Check to see if SPARKLES are needed and, if need, can they be used.
!
      sparkles_available = .true.
!
! Are SPARKLES needed?
!
      do i = 1, natoms
        if (labels(i) > 83) cycle
        if  (zs(labels(i)) < 0.1d0) then
!
! Can SPARKLES be used?
!
          sparkles_available = (sparkles_available .and. (gss(labels(i)) > 0.1d0))
          if (.not. sparkle) then
            line = " "
            do j = 1, 10
              if (atom_names(labels(i))(j:j) /= " ") exit
            end do
            write (line, '(A,a)') ' Data are not available for ', atom_names(labels(i))(j:)//"."
            if (index(keywrd, " 0SCF") == 0) then
              if (sparkles_available) write(iw,*)" (Parameters are available if SPARKLE is used)"
              call mopend(trim(line))
              goto 100
            end if
          end if
        end if
      end do
      do i = 57,71
        if (zs(i) < 0.1d0) tore(i) = 3.d0
      end do
!
! Set up all the data for the molecule
!
      call moldat (0)  ! data dependent on the system
      if (index(keywrd, " 0SCF") /= 0) moperr = .FALSE.
      call calpar      ! Calculate derived parameters
      if (moperr) goto 100
      call to_screen("To_file: Data read in")
!
!  If no SCF calculations are needed, output geometry and quit
!
      if (.false.) then
        inquire(unit=iarc, opened=opend)
        if (opend) close (iarc)
        open(unit=iarc, file=archive_fn(:len_trim(archive_fn) - 3)//"mop", status='UNKNOWN', position='asis')
        rewind iarc
!
!   Remove unwanted keywords
!
        call upcase(refkey(1), len_trim(refkey(1)))
        nokey = " "
        nokey(1) = "NOOPT"
        nokey(2) = "OPT"
        nokey(3) = "LET"
        nokey(4) = "GEO_R"
        nokey(5) = "GNOR"
        nokey(6) = "PL"
        nokey(7) = "MOZY"
        nokey(8) = "PDBO"
        nokey(9) = "SETU"
        nokey(10) = "PM7"
        do j = 1, 20
          if (nokey(j) == " ") exit
          do
            i = index(refkey(1), " "//trim(nokey(j)))
            if (i == 0) exit
            l = index(refkey(1)(i + 1:)," ") + i + 1
            refkey(1) = refkey(1)(:i)//refkey(1)(l:)
          end do
        end do
        refkey(1) = trim(refkey(1))//' SETUP'
        call geout (iarc)
        stop
      end if
      if (index(keywrd,' 0SCF') + index(keywrd, " RESEQ") /= 0 ) then
        inquire(unit=iarc, opened=opend)
        if (opend) close (iarc)
        if (index(keywrd, " PDBOUT") /= 0) then
          line = archive_fn(:len_trim(archive_fn) - 3)//"pdb"
        else
          line = trim(archive_fn)
        end if
        if (index(keywrd, " HTML") /= 0) then
          do i = len_trim(line), 1, -1
            if (line(i:i) == "/" .or. line(i:i) == backslash) exit
          end do
        end if
        open(unit=iarc, file=trim(line), status='UNKNOWN', position='asis')
        rewind iarc
        if (index(keywrd,' 0SCF') /= 0 .and. index(keywrd, " MINI") /= 0 .and. nl_atoms > 0) then
          open(unit=l, file=xyz_fn)
          write(l,"(i6,a)") nl_atoms," "
          write(l,*)"POINT "
          do i = 1, natoms
            if (l_atom(i)) write(l,"(3x,a2,3f15.5)")elemnt(labels(i)), (coord(j,i),j=1,3)
          end do
        end if
      end if
      call delete_ref_key("RESIDUES", len_trim("RESIDUES"), ' ', 1)
      call delete_ref_key("XENO", len_trim("XENO"), ' ', 1)
      call output_rama()
      if (maxtxt == 0 .and. index(keywrd, " RESIDUES") /= 0) then
        call geochk()
        if (moperr) goto 100
      end if
      if ( index(keywrd," PDBOUT") /= 0 .and. maxtxt < 26 .and. index(keywrd," RESID") == 0) then
        if (maxtxt == 0) then
          maxtxt = 26
          do i = 1, natoms
            write(txtatm(i),'(a,i5,1x,a,a)')"HETATM",i, elemnt(labels(i)),"   HET A   1"
          end do
          txtatm1(:natoms) = txtatm(:natoms)
        else
          write(line,'(a)')"PDBOUT only works when the atom labels are in PDB format or keyword RESIDUES is also present"
          call mopend(trim(line))
          write(iw,'(/10x,a)') &
          "(Before using PDBOUT, either add keyword RESIDUES or run a job using keyword RESIDUES to add PDB atom labels.)"
          write(iw,'(10x,a)') &
          "(Keyword RESIDUES can only be used when one of MOZYME, LEWIS, CHARGES, or RESEQ is also present)"
          return
        end if
      end if
      if (mozyme) then
        if (index(keywrd, " PREC") /= 0) then
          call l_control("PREC", len_trim("PREC"), -1)
          if (index(keywrd, " LET") == 0) call l_control("LET", len_trim("LET"), 1)
        end if
      end if
      if (index(keywrd, " ADD-H") + index(keywrd, " SITE=") /= 0 ) nelecs = 0
      if (index(keywrd,' 0SCF') + index(keywrd, " RESEQ") + index(keywrd, " NEWPDB") + &
        index(keywrd, " ADD-H") + index(keywrd, " SITE=") /= 0 ) then
        if (index(keywrd, " DISP") /= 0) then
          call l_control("0SCF", len_trim("0SCF"), 1)
          call l_control("PRT", len_trim("PRT"), 1)
          call post_scf_corrections(eat, .false.)
        end if
        if (index(keywrd,' XYZ') /= 0) then
          line = ' GEOMETRY IN CARTESIAN COORDINATES'
        else if (index(keywrd,' INT') /= 0) then
          line = ' GEOMETRY IN MOPAC Z-MATRIX FORMAT'
        else
          line = ' GEOMETRY OF SYSTEM SUPPLIED'
        end if
        if (prt_coords) write (iw, '(A)') trim(line)
!        xparam(1) = -1.D0
        if (index(keywrd," OLDEN") /= 0 .and. index(keywrd, " 0SCF") == 0) then
!
! read in density so that charges can be calculated
!
          if (mozyme) then
            call set_up_MOZYME_arrays()
          else
            if (allocated(p))      deallocate (p)
            if (allocated(pa))     deallocate (pa)
            if (allocated(pb))     deallocate (pb)
            allocate(p(mpack), pa(mpack), pb(mpack))
          end if
          call den_in_out(0)
          if (moperr) return
          if (mozyme) call density_for_MOZYME (p, 0, nelecs/2, pa)
        end if
        if (prt_coords) call geout (iw)
        if (index(keywrd,' AIGOUT') /= 0) then
          write (iw, '(2/,A)') '  GEOMETRY IN GAUSSIAN Z-MATRIX FORMAT'
          call wrttxt (iw)
          call geoutg (iw)
          write (iarc, '(2/,A)') '  GEOMETRY IN GAUSSIAN Z-MATRIX FORMAT'
          call wrttxt (iarc)
          call geoutg (iarc)
        else if (mozyme .or. index(keywrd, " SITE=") + index(keywrd, " ADD-H") /= 0  .or. &
          (index(keywrd," PDBOUT") + index(keywrd," RESEQ") + index(keywrd," NEWPDB") + &
          index(keywrd," RESID") /= 0)) then
          i = size(coorda)
          j = size(coord)
          if (i /= j) then
            deallocate (coorda)
            allocate(coorda(3,natoms))
            coorda = coord
          end if
!
!  Check the format of hydrogen atoms if SITE is used.  If it is the new formatmake sure that NEWPDB is present
!
          if (index(keywrd, " SITE=") /= 0 .and. index(keywrd," NEWPDB") == 0) then
            j = 0
            k = 0
            do i = 1, min(numat,100)
              if (index(txtatm(i), " 1H") /= 0) j = j + 1
              if (index(txtatm(i), " HG13") /= 0) k = k + 1
              line=txtatm(i)(12:15)
            end do
            if (k > 0 .and. j == 0) call l_control("NEWPDB", len("NEWPDB"), 1)
          end if
          if (index(keywrd, " ADD-H") + index(keywrd, " SITE=") == 0) call geochk()
          if (index(keywrd, " ADD-H") == 0 .and. index(keywrd, " SITE=") == 0 .and. index(keywrd," RESEQ") /= 0) then
            moperr = .false.
            goto 10
          end if
          if (index(keywrd, " SITE=") + index(keywrd, " ADD-H") /= 0) then
            if (index(keywrd, " RESEQ") == 0 ) call l_control("Move", len("Move"), 1)
            moperr = .false.
            if (index(keywrd, " ADD-H") /= 0) then
              call store_and_restore_Tv("STORE")
              call add_hydrogen_atoms()
              if (moperr) then
                inquire(unit=iarc, opened=opend) 
                if (opend) close (iarc, status="DELETE") 
                go to 101
              end if
              call move_hydrogen_atoms
              call store_and_restore_Tv("RESTORE")
              call lewis(.false.)
              if (moperr) then
                inquire(unit=iarc, opened=opend)
                if (opend) close (iarc, status="DELETE")
                go to 101
              end if
              if (index(keywrd, " NORESEQ") /= 0) call update_txtatm(.true., .false.)
              call l_control("ADD-H", len("ADD-H"), -1)
              numat = natoms - id
              numcal = numcal + 1
              call mopend("ADD-H: SYSTEM HAS BEEN HYDROGENATED")
              moperr = .false.
            end if
            call l_control("0SCF", len("0SCF"), 1)
!
! Force the TER's to be re-calculated
!
            breaks(1) = -300
            call geochk()
            if (moperr) goto 101
            if (size(coorda) >= size(coord)) then
              coorda(:,:numat) = coord(:,:numat)
              txtatm1(:numat) = txtatm(:numat)
            end if
            moperr = .false.
            i = index(refkey(1), "ADD-H")
            if (i /= 0) refkey(1) = refkey(1)(:i - 1)//refkey(1)(i + 5:)
          else
            if (index(keywrd, " NEWPDB") /= 0) call update_txtatm(.true., .false.)
          end if
          if (index(keywrd, " SITE=") + index(keywrd, " ADD-H") /= 0 .and. &
            index(keywrd," RESEQ") + index(keywrd," RESID") + index(keywrd, " NEWPDB") /= 0) &
            call update_txtatm(.true., .false.)         !  Now that geometry checks are done, switch to input labels
          if (index(keywrd, " NEWPDB") /= 0) call PDB3()
          call write_sequence
          if (log) call bridge_H()
          if (moperr) goto 101
          inquire(unit=iarc, opened=opend)
          if (opend) close(iarc)
          archive_fn = archive_fn(:len_trim(archive_fn) - 3)//"arc"
          open(unit=iarc, file=archive_fn, status='UNKNOWN', position='asis')
          rewind iarc
          if (index(keywrd, " NOOPT") + index(keywrd," OPT") == 0)   then
            if (index(keywrd, " RESEQ") + index(keywrd, " ADD-H") + index(keywrd, " SITE=") /= 0 ) then
!
!  Atoms added, deleted, or re-arranged, so set all optimization parameters to "opt"
!
              l = 0
              do i = 1, numat
                do j = 1,3
                  l = l + 1
                  loc(1,l) = i
                  loc(2,l) = j
                end do
              end do
            end if
          end if
          call geout (iarc)
          if ( index(keywrd," PDBOUT") /= 0) then
            inquire(unit=iarc, opened=opend)
            if (opend) close(iarc)
              line = archive_fn(:len_trim(archive_fn) - 3)//"pdb"
              if (index(keywrd, " HTML") /= 0) then
                do i = len_trim(line), 1, -1
                  if (line(i:i) == "/" .or. line(i:i) == backslash) exit
                end do
              end if
            open(unit=iarc, file=trim(line), status='UNKNOWN', position='asis')
            rewind iarc
            call pdbout(iarc)
          end if
        else
          if (index(keywrd, " ADD-H") /= 0) then
            call store_and_restore_Tv("STORE")
            call add_hydrogen_atoms()
            call store_and_restore_Tv("RESTORE")
          end if
          inquire(unit=iarc, opened=opend)
          if (opend) close (iarc)
          open(unit=iarc, file=archive_fn, status='UNKNOWN', position='asis')
          rewind iarc
          if (pdb_label) then
!
!   PDB format, so renumber atoms in atom label
!
            j = 1
            do i = 1, numat
              write(line,'(a6,i5,a15)')txtatm(i)(:6),i + j - 1,txtatm(i)(12:)
              txtatm(i) = trim(line)
            end do
          end if
          call geout (iarc)
        end if
        if (index(keywrd, " SITE=") + index(keywrd, " ADD-H") + index(keywrd, " 0SCF") + &
          index(keywrd," RESEQ") + index(keywrd," RESID") /= 0) go to 100
        if (nelecs == 0 .or. index(keywrd, " NEWPDB") == 0) goto 100
        close (iarc)
      end if
      if (pdb_label) call compare_txtatm(moperr, moperr)
      if (moperr) then
        if (index(keywrd," GEO-OK") /= 0) then
          moperr = .false.
        else
          goto 100
        end if
      end if
!
!  If any special work is done, do it here
!
  !    call special
   !   go to 10
!
! Everything is ready - now set up the arrays used by the SCF, etc.
!
      useps = .FALSE.
      iseps = (index(keywrd,' EPS=') + index(keywrd," PKA") /= 0)
      call setup_mopac_arrays(1,2)
      iseps = (index(keywrd,' EPS=') /= 0)
      if (moperr) goto 100
      if (allocated(nw)) deallocate(nw)
      allocate(nw(numat))
      l = 1
      do i = 1, numat
        nw(i) = l
        l = l + ((nlast(i)-nfirst(i)+1)*(nlast(i)-nfirst(i)+2))/2
      end do
      if (method_indo) then
        if(.not. allocated(occfr)) allocate(occfr(2))
        noh = nopen
        nvl = nclose + 1
        nel(1) = nclose * 2

        norb(1) = nclose
        norbl(1) = 1
        norbh(1) = nclose
        occfr(1) = 2.D0

        if (nopen == nclose) then
          nshell = 1

        else
          nshell = 2

          nel(2) = nopen - nclose
          norb(2) = nopen - nclose
          norbl(2) = norbh(1) + 1
          norbh(2) = nopen
          occfr(2) = 1.D0
          allocate(vca(2,2))
          allocate(vcb(2,2))
! One alpha electron per orbital
          vca(2,2)= 1.D0
          vcb(2,2)= 2.D0
        end if
! Set up CI data
        if (index(keywrd,' CIS') /= 0 .or. index(keywrd,' MRCI') /= 0 .or. &
            index(keywrd,' C.I.') /= 0 .or. index(keywrd,' C.A.S.') /= 0) then
          multci = nopen - nclose + 1
          if (index(keywrd,' SING') /= 0) multci = 1
          if (index(keywrd,' DOUB') /= 0) multci = 2
          if (index(keywrd,' TRIP') /= 0) multci = 3
          if (index(keywrd,' QUAR') /= 0) multci = 4
          if (allocated(evalmo)) deallocate(evalmo)
          if (allocated(nbt))    deallocate(nbt)
          allocate(evalmo(norbs))
          allocate(nbt(norbs))
        end if
      end if
!
!  CALCULATE THE ATOMIC ENERGY
!
      if (sparkle) then
        atheat = 0.d0
        do i = 1, numat
          if  (nat(i) > 56 .and. nat(i) < 72 .and. zs(nat(i)) < 0.1d0) then
            atheat = atheat + eheat_sparkles(nat(i))
          else
            atheat = atheat + eheat(nat(i))
          end if
        end do
      else
        atheat = sum(eheat(nat(:numat)))
      end if
      eat = sum(eisol(nat(:numat)))
      atheat = atheat - eat*fpc_9
      atheat = atheat + C_triple_bond_C()
      rxn_coord = 1.d9
!
!  All data for the current job are now read in, and all parameters are
!  available in the arrays.
!  Now decide what type of calculation is to be done.
!
      call l_control("GEO_DAT", len_trim("GEO_DAT"), -1)
      call l_control("GEO_REF", len_trim("GEO_REF"), -1)
      if (mozyme) then
        call geochk()
        if (moperr) then
          if ( index(keywrd," PDBOUT") /= 0) then
            archive_fn = archive_fn(:len_trim(archive_fn) - 3)//"pdb"
            inquire(unit=iarc, opened=opend)
            if (opend) close(iarc)
            open(unit=iarc, file=archive_fn, status='UNKNOWN', position='asis')
            rewind iarc
            call pdbout(iarc)
          end if
!
! If the current calculation cannot continue, increment numcal to indicate that a partial calculation has already been done.
!
          numcal = numcal + 1
          goto 10
        end if
        if (index(keywrd, " RESID") + index(keywrd, " RESEQ") + index(keywrd, " ADD-H") + index(keywrd, " SITE=") /= 0 ) &
          call update_txtatm(.true., .false.)         !  Now that geometry checks are done, switch to input labels
        if (moperr) then
!
! If the current calculation cannot continue, increment numcal to indicate that a partial calculation has already been done.
!
          numcal = numcal + 1
          goto 10
        end if
        rapid = (index(keywrd, " RAPID") + index(keywrd, " LOCATE-TS") /= 0)
        call set_up_MOZYME_arrays()
        if (moperr) goto 101
        if (index(keywrd, " RAPID") /= 0) call set_up_rapid("ON")
      end if
      if (index(keywrd,' 1SCF') /= 0 .or. method_indo) then
        if (method_indo .and. index(keywrd,' 1SCF') == 0) then
          write (iw,*) "WARNING: INDO only performs single-point calculations"
        end if
        iflepo = 1
        iscf = 1
        last = 1
        i = index(keywrd,' GRAD')
        grad(:nvar) = 0.D0
        numcal = numcal + 1
        tim = seconds(1)
        call to_screen(" Single point calculation")
        call compfg (xparam, .TRUE., escf, .TRUE., grad, i /= 0)
      else if (index(keywrd,' SADDLE') /= 0) then
        call to_screen(" Transition state geometry calculated using SADDLE")
        call react1 ()
      else if (index(keywrd,' STEP1') /= 0) then
        call to_screen(" Grid calculation")
        call grid ()
        iflepo = -1  !  Prevent printing of results
      else if (latom /= 0) then
        call to_screen(" Path calculation")
        if (index(keywrd,' STEP')==0 .or. index(keywrd,' POINT')==0) then
          call paths ()
        else
          call pathk ()
        end if
        iflepo = -1
      else if (index(keywrd,' FORCE') + index(keywrd,' IRC=') + &
        index(keywrd,' THERM') + index(keywrd,' DFORCE') /= 0) then
        call to_screen(" Force constant calculation")
        last = 1
        call force ()
        keywrd = " "
        iflepo = -1
      else if (index(keywrd,' DRC') + index(keywrd,' IRC') /= 0) then
        call to_screen(" Reaction coordinate calculation")
        if (.not. allocated(react)) then
          allocate(react(3*numat))
          react = 0.d0
        end if
        if (index(keywrd, " HTML") /= 0) then
          call write_path_html(1)
        end if
        call drc (react, react)
        iflepo = -1
      else if (index(keywrd, " LOCATE-TS") /= 0) then
        if (.not. use_ref_geo) then
          if (index(keywrd, " LOCATE-TS(SET") == 0) then
            write(line,'(a)')" LOCATE-TS requires GEO_REF to be used"
            call mopend(trim(line))
            return
          end if
        end if
        call Locate_TS
        if (iflepo == 0) iflepo = -1
      else if (index(keywrd,' NLLSQ') /= 0) then
        write(iw,'(5x,a)')" Transition state refinement using NLLSQ"
        call to_screen(" Transition state refinement using NLLSQ")
        call nllsq ()
      else if (index(keywrd,' SIGMA') /= 0) then
        write(iw,'(5x,a)')" Transition state refinement using SIGMA"
        call to_screen(" Transition state refinement using SIGMA")
        call powsq ()
      else if (nvar == 0) then
        iflepo = 1
        iscf = 1
        last = 1
        i = index(keywrd,' GRAD')
        grad(:nvar) = 0.D0
        numcal = numcal + 1
        tim = seconds(1)
        call to_screen(" Single point calculation")
        call compfg (xparam, .TRUE., escf, .TRUE., grad, i /= 0)
      else if (index(keywrd,' DFP') + index(keywrd,' FLEPO') + &
        index(keywrd,' BFGS') /= 0 .or. nvar == 1) then
        write(iw,'(/10x,a)')"Geometry optimization using BFGS"
        call to_screen(" Geometry optimization using BFGS")
        call flepo (xparam, nvar, escf)
      else if (index(keywrd,' TS')/=0) then
        write(iw,'(/10x,a)')"Transition state refinement using EF"
        call to_screen(" Transition state refinement using EF")
        call ef (xparam, escf)
      else if (index(keywrd,' LBFGS') /= 0 .or. &
        id == 0 .and. index(keywrd_txt, " GEO_REF") /= 0 .or. &
        nvar > 100 .and. index(keywrd,' EF') == 0) then
        write(iw,'(/10x,a)')"Geometry optimization using L-BFGS"
        call to_screen(" Geometry optimization using L-BFGS")
        call lbfgs (xparam, escf)
      else
        write(iw,'(/10x,a)')"Geometry optimization using EF"
        call to_screen(" Geometry optimization using EF")
        call ef (xparam, escf)
      end if
      if (method_indo .and. (index(keywrd,' CIS') /= 0 .or. index(keywrd,' MRCI') /= 0 .or.&
            index(keywrd,' C.I.') /= 0 .or. index(keywrd,' C.A.S.') /= 0)) then
        do i=1,norbs
          evalmo(i) = eigs(i)
          do j = 1,norbs
            cc0(j,i) = c(i,j)
          end do
        end do
        do i=1,natoms
          k = 0
          do j=nfirst(i),nlast(i)
            nbt(j) = k
            k = k+1
          end do
        end do
        call rci()
        go to 100
      end if
!
!  Calculation done, now print results
!
      if (moperr) go to 100
      last = 1
      if (iflepo >= 0) then
        call writmo
        if (moperr) go to 100
        if (index(keywrd,' POLAR') /= 0) then
          call polar ()
          if (moperr) go to 100
        end if
        if (index(keywrd,' STATIC') /= 0) then
          numcal = numcal + 1 !  In case POLAR was also used
          call static_polarizability
          if (moperr) go to 100
        end if
        if (index(keywrd,'PMEP') /= 0) call pmep ()
        if (moperr) go to 100
        if (index(keywrd,' ESP') /= 0) then
          call esp ()
          if (moperr) go to 100
        end if
      end if
  100 continue
      tim = tim + seconds(2)
      if (tim > 1.d7) tim = tim - 1.d7
      inquire(unit = ilog, opened = opend, name = line)
      if (opend) opend = (index(line, log_fn) /= 0)
      if (opend .and. index(keywrd, "LOG") == 0) then
        write(ilog, '(/,'' == MOPAC DONE =='')', iostat = j)
        if (j /= 0) goto 98
        rewind (ilog)
        i = 0
        do
          read(ilog, "(a)", iostat=j) line
          if (j /= 0) exit
          if (index(line, " COVALENT") /= 0)        i = 1
          if (index(line, " charged") /= 0)         i = 1
          if (index(line, " Type    Charge") /= 0)  i = 1
          if (index(line, "TIVE CHARGES") /= 0)     i = 1
          if (index(line, "COMPUTED CHARGE") /= 0)  i = 1
          if (index(line, "UNUSUALLY SHORT") /= 0)  i = 1
          if (index(line, "Original residue") /= 0) i = 1
        end do
        if (i == 0) then
          close(ilog, status = "delete", iostat = j, err = 98)
        else
          close(ilog, status = "keep", iostat = j, err = 98)
        end if
98      continue
      end if
      if ( .not. gui) then
        if (allocated(p)) deallocate(p)
        if (allocated(react)) deallocate(react)
        inquire (file = end_fn, exist = exists)
        if (exists) then
          open(unit=iend, file=end_fn, status='UNKNOWN', position='asis', iostat=i)
          close(iend, status = 'delete', iostat=i)
        end if
         itemp_1 = ncomments
        if (index(keywrd, " ADD-H PDBOUT") == 0 .or. &
           index(koment, " From PDB file") == 0) ncomments = 0
        if (index(keywrd_txt," GEO_DAT") /= 0) then
          i = index(keywrd_txt," GEO_DAT") + 9
          j = index(keywrd_txt(i + 10:),'" ') + i + 9
          write(line,'(a)')"GEO_DAT="//keywrd_txt(i:j)
          call l_control(trim(line), len_trim(line), 1)
        end if
        call delete_MOZYME_arrays()
!
! Delete density matrix if it was made by MOZYME
!
        if (.not. l_OLDDEN .and. index(keywrd, " NEWDEN") == 0) then
          j = len_trim(end_fn)
          inquire (file = end_fn(:j - 3)//"den", exist = exists)
          if (exists) then
            open(unit = iend, file = end_fn(:j - 3)//"den", status='OLD', iostat=i)
            if (i == 0) close(iend, status = 'delete', iostat=i)
          end if
        end if
        go to 10
      end if
!
! Carefully delete all arrays created using "allocate"
!
  101 if ( .not. gui) then
        call setup_mopac_arrays(0,0)
        call delete_MOZYME_arrays()
      end if
      call summary(" ",1)
      if (tim > 1.d7) tim = tim - 1.d7
      write (iw, '(3/,'' TOTAL JOB TIME: '',F16.2,'' SECONDS'')') tim
      write (iw, '(/,'' == MOPAC DONE =='')')
      call fdate (line)
      write(*,'(//10x,a,/)')"MOPAC Job: """//trim(job_fn)//""" ended normally on "// &
      line(5:10)//", "//trim(line(21:))//", at"//line(11:16)//"."
!
!  Delete files that are definitely not wanted
!
      inquire (file = end_fn, exist = exists)
      if (exists) then
        open(unit=iend, file=end_fn, status='UNKNOWN', position='asis', iostat=i)
        close(iend, status = 'delete', iostat=i)
      end if
      inquire(unit=ir, opened=opend)
      if (opend) close(ir, status = 'delete', err = 999)
999   jobnam = " "
      inquire(unit = ilog, opened = opend, name = line)
      if (opend) then
        rewind (ilog)
        read(ilog,'(a)', iostat=i)line
        if (i == -1) close(ilog, status = 'delete', iostat=i)
      end if
      return
end subroutine run_mopac
subroutine special
!
!  Use this subroutine for any special work.
!  for example, to print a MOPAC data-set.
!
  use molkst_C, only : jobnam, refkey, line
  implicit none
  integer :: iprt = 33, i, j, k, len_key
  open(unit=iprt, file=jobnam(:len_trim(jobnam) - 0)//"_(PM6).arc", status='UNKNOWN', position='asis', iostat = i)
  do i = 1, 6
    if (index(refkey(i), " NULL") /= 0) exit
    line = refkey(i)
    len_key = len_trim(refkey(i))
    call upcase(line, len_key)
!
!  Put all changes in keywords here
!
    j = index(line, " 1SCF")
    if (j /= 0) refkey(i)(j:j + 4) = " "
    j = index(line, " PM6")
    if (j /= 0) refkey(i)(j:j + 3) = " "
    j = index(line, " DENOUT")
    if (j /= 0) refkey(i)(j:j + 7) = " "
    j = index(line, " GRADIENTS")
    if (j /= 0) refkey(i)(j:j + 9) = " "
    j = index(line, " GNORM=")
    if (j == 0) then
      j = index(line, "        ")
      refkey(i)(j:j+8) = " GNORM=4"
    end if
!
!  Remove all extra blank spaces
!
    len_key = len_trim(refkey(i))
    refkey(i)(len_key + 1:len_key + 1) = "@"
    do j = 1, len_key
      do k = 1,10
        if (refkey(i)(j:j + 1) == "  ") refkey(i)(j:) = refkey(i)(j + 1:)
      end do
    end do
    j = index(refkey(i), "@")
    refkey(i)(j:) = " "
    j = index(refkey(i),"     ")
    refkey(i)(j:) = " PM6"
  end do
  write(iprt,"(a)")"  MOPAC"
  write(iprt,"(a)")" FINAL GEOMETRY OBTAINED"
  call geout (iprt)
end subroutine special

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  subroutine lyse
!
!  Before a residue sequence can be worked out, all inter-protein bonds
!  must first be broken.  These bonds are of type N-S, O-S, and S-S
!
    use common_arrays_C, only : nat, nbonds, ibonds
    use molkst_C, only : numat
    implicit none
    integer :: i, j, k, l, ll, m, n
    logical :: special
    double precision :: r_min, r
    double precision, external :: distance
 !
 !   FIRST, GET RID OF H ATOMS AND ATOMS ALREADY DEFINED
 !
    do i = 1, numat
      if (nat(i) /= 1) then
        if (nat(i) == 6) then
          l = 0
          do k = 1, nbonds(i)
            l = l + 1
            ibonds(l, i) = ibonds(k, i)
          end do
        else
          special = .false.
          if (nat(i) == 8) then
!
!  Atom is oxygen - check to see if it's attached to a sulfate or phosphate.
!  If so, do NOT lyse the bond.
!
            do k = 1, nbonds(i)
              if (nat(ibonds(k, i)) == 16 .or. nat(ibonds(k, i)) == 15) then
                if (nbonds(ibonds(k,i)) == 4) special = .true.
              end if
            end do
          end if
          if (special) then
            l = nbonds(i)
            cycle
          end if
!
! EXCLUDE ALL N-S, O-S, and S-S BONDS
!
          l = 0
          do k = 1, nbonds(i)
            if (nat(ibonds(k, i)) /= 16) then
              l = l + 1
              ibonds(l, i) = ibonds(k, i)
            end if
          end do
          ll = 0
          do k = 1, l
            j = ibonds(k,i)
            if(nat(j) == 7 .or. nat(j) == 6) ll = 1
          end do
          if (ll == 0) cycle
!
! EXCLUDE ALL BONDS TO NON-PROTEIN ATOMS
!
          ll = l
          l = 0
          do k = 1, ll
            j = ibonds(k, i)
            if (nat(j) == 1 .or. nat(j) == 6 .or. nat(j) == 7 .or. nat(j) == 8 &
           & .or. nat(j) == 16) then
              l = l + 1
              ibonds(l, i) = ibonds(k, i)
            else
!
!  Also remove bond from non-protein atom
!
              m = 0
              do n = 1, nbonds(j)
                if (ibonds(n,j) /= i) then
                  m = m + 1
                  ibonds(m,j) = ibonds(n,j)
                end if
              end do
              nbonds(j) = nbonds(j) - 1
            end if
          end do
        end if
        nbonds(i) = l
      else
        if (nbonds(i) > 1) then
!
! Break all bonds except the shortest
!
          r_min = 1000.d0
          k = 0
          do j = 1, nbonds(i)
            r = distance(ibonds(j,i), i)
!
!  Chose the shortest bond, but not shorter than a normal X-H
!
            if (r < r_min .and. r > 0.95d0) then
              r_min = r
              k = ibonds(j,i)
            end if
          end do
          if ( k > 0) then
!
! Shortest bond is i to k
! Break all bonds to atom i
!
            do j = 1, nbonds(i)
              l = ibonds(j,i)
              do m = 1, nbonds(l)
                if (ibonds(m,l) == i) exit
              end do
              nbonds(l) = nbonds(l) - 1
              do n = m, nbonds(l)
                ibonds(n,l) = ibonds(n + 1,l)
              end do
            end do
!
!  Create bond between atoms i and k
!
            nbonds(i) = 1
            ibonds(1,i) = k
            nbonds(k) = nbonds(k) + 1
            ibonds(nbonds(k),k) = i
          end if
        end if
      end if
    end do
  end subroutine lyse

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

! HEigensystem.F
! diagonalization of a Hermitian n-by-n matrix using the Jacobi algorithm
! code adapted from the "Handbook" routines for complex A
! (Wilkinson, Reinsch: Handbook for Automatic Computation, p. 202)
! this file is part of the Diag library
! last modified 9 Aug 11 th
!************************************************************************
! HEigensystem diagonalizes a Hermitian n-by-n matrix.
!* Input: n, A = n-by-n matrix, Hermitian
!* (only the upper triangle of A needs to be filled).
!* Output: d = vector of eigenvalues, U = transformation matrix
!* these fulfill diag(d) = U A U^+ = U A U^-1 with U unitary.

	subroutine HEigensystem(n, A, d, U, sort)
	implicit none
	integer n, sort
	Complex A(n,n), U(n,n)
	double precision d(n)

	integer p, q, j
	double precision sym_eps
	Real red, off, thresh
	Real t, delta, invc, s
	Complex x, y, Apq
	Real ev(2,n)

	integer sweep
	common /nsweeps/ sweep

	Real Sq
	Complex c
	Sq(c) = real(c*conjg(c))
	SYM_EPS = 2D0**(-103)

	do p = 1, n
	  ev(1,p) = 0
	  ev(2,p) = real(A(p,p))
	  d(p) = ev(2,p)
	enddo

	do p = 1, n
	  do q = 1, n
	    U(q,p) = (0.0, 0.0)
	  enddo
	  U(p,p) = (1.0, 0.0)
	enddo

	red = 0.04/n**4

	do sweep = 1, 50
	  off = 0
	  do q = 2, n
	    do p = 1, q - 1
	      off = off + Sq(A(p,q))
	    enddo
	  enddo
	  if( .not. off .gt. SYM_EPS ) goto 1

	  thresh = 0
	  if( sweep .lt. 4 ) thresh = off*red

	  do q = 2, n
	    do p = 1, q - 1
	      Apq = A(p,q)
	      off = Sq(Apq)
        if(sweep > 4 .and. off < SYM_EPS*(ev(2,p)**2+ev(2,q)**2) ) then
	        A(p,q) = (0.0, 0.0)
	      else if( off .gt. thresh ) then
	        t = 0.5*(ev(2,p) - ev(2,q))
	        t = 1/(t + sign(sqrt(t**2 + off), t))

	        delta = t*off
	        ev(1,p) = ev(1,p) + delta
	        ev(2,p) = real(d(p)) + ev(1,p)
	        ev(1,q) = ev(1,q) - delta
	        ev(2,q) = real(d(q)) + ev(1,q)

	        invc = sqrt(delta*t + 1)
	        s = t/invc
	        t = delta/(invc + 1)

	        do j = 1, p - 1
	          x = A(j,p)
	          y = A(j,q)
	          A(j,p) = x + s*(conjg(Apq)*y - t*x)
	          A(j,q) = y - s*(Apq*x + t*y)
	        enddo

	        do j = p + 1, q - 1
	          x = A(p,j)
	          y = A(j,q)
	          A(p,j) = x + s*(Apq*conjg(y) - t*x)
	          A(j,q) = y - s*(Apq*conjg(x) + t*y)
	        enddo

	        do j = q + 1, n
	          x = A(p,j)
	          y = A(q,j)
	          A(p,j) = x + s*(Apq*y - t*x)
	          A(q,j) = y - s*(conjg(Apq)*x + t*y)
	        enddo

	        A(p,q) = (0.0, 0.0)

	        do j = 1, n
	          x = U(p,j)
	          y = U(q,j)
	          U(p,j) = x + s*(Apq*y - t*x)
	          U(q,j) = y - s*(conjg(Apq)*x + t*y)
	        enddo
	      endif
	    enddo
	  enddo

	  do p = 1, n
	    ev(1,p) = 0
	    d(p) = ev(2,p)
	  enddo
	enddo

	print *, "Bad convergence in HEigensystem"

1	if( sort .eq. 0 ) return

! sort the eigenvalues

	do p = 1, n - 1
	  j = p
	  t = real(d(p))
	  do q = p + 1, n
	    if( sort*(t - d(q)) .gt. 0 ) then
	      j = q
	      t = real(d(q))
	    endif
	  enddo

	  if( j .ne. p ) then
	    d(j) = d(p)
	    d(p) = t
	    do q = 1, n
	      x = U(p,q)
	      U(p,q) = U(j,q)
	      U(j,q) = x
	    enddo
	  endif
	enddo
	do p = 1, n
	  do q = 1, p
	    x = U(p,q)
	    U(p,q) = U(q,p)
	    U(q,p) = x
	  end do
	end do
	end

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine solir (eigs, cr, nvecs, xyzk, itriv, xyzxyz)
  use common_common, only : numat, iop, xop, id, phonon, iw, iw_new, &
    line, nfirst, per_atom, title, allt1, mop, keywrd, data_set_name, jobnam
  implicit none
  integer, intent(in) :: itriv, nvecs
  complex, dimension(nvecs, nvecs), intent(in) :: cr
  double precision, dimension(nvecs+1), intent(inout) :: eigs
  double precision, dimension(3), intent(in) :: xyzk, xyzxyz
  ! 
  !.. Local Scalars .. 
  !
  logical :: first = .true., prtvec = .false., opend
  integer :: i, i1, iatom, il, iloop, iold, ir, j, jop, k, kk, klim, &
       & l, m, nnnew, nvecs1, nreps, alloc_stat
  complex :: angle, xc
  double precision :: deltak, eig1, eig2, elim, optlim, phalim, rdotk, repp, &
       & twopi, eigs2(120), t1(9,9)
  character :: little(149)*12, num*1, num2*1
  integer :: nclass(iop), itype(nvecs)
  complex :: rotc(iop), vecc(nvecs), phaser(iop, nvecs), refchi(iop, nvecs)
  real :: sum
  complex, dimension(:,:), allocatable :: wfnr
  double precision, external :: reada
  save
  allocate (wfnr(nvecs, nvecs), stat=alloc_stat)
  if (alloc_stat /= 0) then
    write(6,*)"Failed to allocate array wfnr in solir"
    stop
  end if
  inquire(unit=iw_new, opened=opend) 
  if (.not. opend) open (unit = iw_new, file = trim(data_set_name)//".txt", form = "FORMATTED", status = "UNKNOWN", iostat = i)
  phaser = (0.0, 0.0)
  if (first) then
    first = .false.
    twopi = 2.d0 * Acos (-1.d0)
    elim = 0.1d0
    if ( phonon ) elim = 1.0d0
    prtvec = (index(keywrd," PRTVEC") /= 0)
    if (Index (keywrd, "DEGEN") /= 0) then
      elim = reada (keywrd, Index (keywrd, "DEGEN"))
    end if
    if (Index (keywrd, " LET") /= 0) then
      optlim = 10.d0
      phalim = 1.d0
      klim = -1
    else
      if (phonon) then
        optlim = 0.01d0
        phalim = 0.3d0
        klim = -1
      else
        optlim = 0.01d0
        phalim = 0.3d0
        klim = 0
      end if      
    end if
    write(iw_new,'(/10x,a,/)')"BZ Data-set: """//trim(jobnam)//""""
  end if
  !
  !  Evaluate the characters for each operation.
  !
  do jop = 1, iop
    do i = 1, 9
      do j = 1, 9
        t1(i, j) = allt1(i, j, jop)
      end do
    end do
    !
    !  T1 now holds the transform of the atomic orbitals under
    !     operation JOP
    !
    do iatom = 1, numat
      k = iatom
      ir = per_atom(iatom)
      rdotk = mop(2, k, jop)*xyzk(1) + mop(3, k, jop)*xyzk(2) + mop(4, k, jop)*xyzk(3)
      deltak = xyzk(1)*xop(2, jop) + xyzk(2)*xop(3, jop) + xyzk(3)*xop(4, jop)
      k = mop(1, k, jop)
      !
      !  ROTC is the complex phase which arises due to non-trivial
      !       translations in an operation.
      !
      rotc(jop) = Cmplx (Cos(deltak*twopi), -Sin(deltak*twopi))
      il = nfirst(k) - 1
      l = nfirst(iatom) - 1
      !
      !  ANGLE is the complex phase resulting from an atom being moved
      !        into a different unit cell
      !
      angle = Cmplx (Cos(rdotk*twopi), Sin(rdotk*twopi))
      do iloop = 1, nvecs
        do i = 1, nvecs
          vecc(i) = cr(i, iloop)
        end do
        do i = 1, ir
          k = i + il
          xc = 0.0
          do j = 1, ir
            i1 = j + l
            xc = xc + vecc(i1)*real(t1(j, i))
          end do
          wfnr(k, iloop) = xc * angle
        end do
      end do
    end do
    if (prtvec) then
      m = Min (40, nvecs)
      write(iw, "(//,A)")"Complex Eigenvectors, before Operation "//title(jop)// "  Real part"
      write(iw_new, "(//,A)")"Complex Eigenvectors, before Operation "//title(jop)// "  Real part"
      do i = 1, nvecs
        write(iw, "(40f10.4)") (Real (cr(i, j)), j = 1, m)
        write(iw_new, "(40f10.4)") (Real (cr(i, j)), j = 1, m)
      end do
      write(iw, "(/,A)") "Complex Eigenvectors, before Operation "//title(jop)//"  Imaginary part"
      write(iw_new, "(/,A)") "Complex Eigenvectors, before Operation "//title(jop)//"  Imaginary part"
      do i = 1, nvecs
        write(iw, "(40f10.4)") (Aimag (cr(i, j)), j = 1, m)
        write(iw_new, "(40f10.4)") (Aimag (cr(i, j)), j = 1, m)
      end do
      write(iw, "(//,A)")"Complex Eigenvectors, After Operation "//title(jop)//"  Real part"
      write(iw_new, "(//,A)")"Complex Eigenvectors, After Operation "//title(jop)//"  Real part"
      do i = 1, nvecs
        write(iw, "(40f10.4)") (Real (wfnr(i, j)), j = 1, m)
        write(iw_new, "(40f10.4)") (Real (wfnr(i, j)), j = 1, m)
      end do
      write(iw, "(/,A)")"Complex Eigenvectors, After Operation "//title(jop)//"  Imaginary part"
      write(iw_new, "(/,A)")"Complex Eigenvectors, After Operation "//title(jop)//"  Imaginary part"
      do i = 1, nvecs
        write(iw, "(40f10.4)") (Aimag (wfnr(i, j)), j = 1, m)
        write(iw_new, "(40f10.4)") (Aimag (wfnr(i, j)), j = 1, m)
      end do
    end if
    do iloop = 1, nvecs
      xc = 0.0
      do i = 1, nvecs
        xc = xc + cr(i, iloop) * Conjg (wfnr(i, iloop))
      end do
      phaser(jop, iloop) = xc
    end do
  end do

  deallocate (wfnr, stat=alloc_stat)
  if (alloc_stat /= 0) then
    write(6,*)"Array wfnr in solir corrupted"
    stop
  end if

  if (itriv == 3) then
    do j = 1, iop
      if (Abs (xop(2, j)) + Abs (xop(3, j)) + Abs (xop(4, j)) > 0.1d0) then
        xc = phaser(j, 1)
        do i = 1, nvecs
          phaser(j, i) = phaser(j, i) * Conjg (rotc(j))
        end do
      end if
    end do
  elseif (itriv == 2) then
    do j = 1, iop
      if (Abs (xop(2, j))+Abs (xop(3, j))+Abs (xop(4, j)) > 0.1d0) then
        xc = phaser(j, 1)
        do i = 1, nvecs
          phaser(j, i) = phaser(j, i) * Conjg (xc)
        end do
      end if
    end do
  end if
  !***********************************************************************
  !
  !    Start of Tidy-Up
  !
  !   Compress levels so that degenerate levels are printed once only.
  !
  eig1 = eigs(1)
  nvecs1 = nvecs + 1
  eigs(nvecs1) = 1.d10
  do i = 1, nvecs
    do j = 1, iop
      refchi(j, i) = 0.0
    end do
  end do
  j = 0
  iold = 1
  do i = 2, nvecs1
    eig2 = eigs(i)
    if (eig2-eig1 >= elim) then
      j = j + 1
      eigs2(j) = eigs(iold)
      do l = iold, i-1
        do k = 1, iop
          refchi(k, j) = refchi(k, j) + phaser(k, l)
        end do
      end do
      iold = i
    end if
    eig1 = eig2
  end do
  nnnew = j
  do i = 1, nnnew
    do j = 1, iop
      phaser(j, i) = refchi(j, i)
    end do
  end do
  !
  !    Eliminate all operations which are not operations of the group
  !
  l = 0
  do i = 1, iop
    repp = 0
    xc = 0.0
    k = 0
    do j = 1, nnnew
      xc = phaser(i, j) * Conjg (phaser(i, j))
      kk = Nint (Real (xc))
      k = k + kk
      if (Abs (kk - xc) < optlim .and. kk /= 0 .or. Abs (kk - xc) < 0.1d0*optlim) then
        repp = repp + 1
      end if
    end do
    if (repp/nnnew > 0.6d0 .and. k /= klim) then
      l = l + 1
      little(l) = title(i)
      rotc(l) = rotc(i)
      do j = 1, nnnew
        phaser(l, j) = phaser(i, j)
      end do
    end if
  end do
  !
  !  Eliminate Duplicate Operations
  !
  do i = 1, l
    nclass(i) = 1
  end do
  jop = 0
  do i = 1, l
    if (i /= 1) then
      loop1: do j = 1, jop
        do k = 1, nnnew
          if (Abs (phaser(i, k) - phaser(j, k)) > phalim) cycle loop1
        end do
        if (little(j) == little(i)) goto 1000
      end do loop1
      goto 1100
1000  continue
      nclass(j) = nclass(j) + 1
      cycle
    end if
    !
    !   Characters for I are different to those of all known operations.
    !
1100 continue
    jop = jop + 1
    little(jop) = little(i)
    rotc(jop) = rotc(i)
    do k = 1, nnnew
      phaser(jop, k) = phaser(i, k)
    end do
  end do
  !
  !   Label Irreducible Representations
  !
  nreps = 0
  do i = 1, nnnew
    loop2: do j = 1, nreps
      do k = 1, jop
        if (Abs (phaser(k, i) - refchi(k, j)) > 1.d-1) cycle loop2
      end do
      goto 1200
    end do loop2
    nreps = nreps + 1
    l = nreps
    do k = 1, jop
      refchi(k, nreps) = phaser(k, i)
    end do
    goto 1300
    !
    !   Level I has same I.R. as known representation J
    !
1200 continue
    l = j
1300 continue
    itype(i) = l
  end do
  if (line /= " ") then
    line = " "//trim(line)//" = (" 
  else
    line = " = ("
  end if
  num = char(id + ichar("0"))
  sum = 0.0
  do i = 1, id
    sum = max(sum, real(abs(xyzxyz(i))))
  end do
  if (id == 1) then
    num2 =char(int(log10(sum)) + ichar("7"))
    write(iw, '(///10x, "EXPECTATION VALUE OF OPERATORS FOR POINT", a, '//num//'f'//num2//'.4,a)') &
    trim(line), xyzxyz(1),")"
  else
    num2 =char(int(log10(sum)) + ichar("8"))
    write(iw, '(///10x, "EXPECTATION VALUE OF OPERATORS FOR POINT", a, '//num//'f'//num2//'.4,a)') &
    trim(line), (xyzxyz(i), i = 1, id),")"
  end if
  write(iw_new, '(///10x, "EXPECTATION VALUE OF OPERATORS FOR POINT",a, '//num//'f'//num2//'.4,a)') &
  trim(line), (xyzxyz(i), i = 1, id),")"
  write(iw, *)
  write(iw, "(18X,50(I4,1X,A12))") (nclass(i), little(i), i = 1, jop)
  write(iw_new, '(a)')
  write(iw_new, "(18X,50(I4,1X,A12))") (nclass(i), little(i), i = 1, jop)
  k = 1
  do i = 1, nnnew
    do j = 1, jop
      if (real(phaser(j, i)) < 0.0000 .and. real(phaser(j, i)) > -0.0005) phaser(j,i) = phaser(j,i) + (0.0005, 0.0)
      if (imag(phaser(j, i)) < 0.0000 .and. imag(phaser(j, i)) > -0.0005) phaser(j,i) = phaser(j,i) + (0.0, 0.00049)
    end do
    write(iw, "(i3,f10.4,i3,50(a2,f6.3,f7.3,a2))") &
            & k, eigs2(i), itype(i), (" (", phaser(j, i), ") ", j = 1, jop)
    write(iw_new, "(I3,F10.4,I3,50(A2,F6.3,F7.3,A2))") &
            & k, eigs2(i), itype(i), (" (", phaser(j, i), ") ", j = 1, jop)
            k = k + nint(real(phaser(1, i)))
  end do
end subroutine solir

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  subroutine rotate(ni, nj, xi, xj, w, kr, e1b, e2a, enuc)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
  use molkst_C, only : id, method_pm7
  use parameters_C, only: natorb
!***********************************************************************
!
  implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
  integer  :: ni
  integer  :: nj
  integer , intent(inout) :: kr
  double precision , intent(out) :: enuc
  double precision , intent(in) :: xi(3)
  double precision , intent(in) :: xj(3)
  double precision , intent(out) :: w(2025)
  double precision , intent(out) :: e1b(45)
  double precision , intent(out) :: e2a(45)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
  integer :: i, li, lj, ik, k
  double precision ::  rijx, rij
  double precision, dimension(3) :: x
  double precision, dimension(171) :: en
!-----------------------------------------------
!***********************************************************************
!
!..IMPROVED SCALAR VERSION
!..WRITTEN BY ERNEST R. DAVIDSON, INDIANA UNIVERSITY.
!
!
!   ROTATE CALCULATES THE TWO-PARTICLE INTERACTIONS.
!
!   ON INPUT  NI     = ATOMIC NUMBER OF FIRST ATOM.
!             NJ     = ATOMIC NUMBER OF SECOND ATOM.
!             XI     = COORDINATE OF FIRST ATOM.
!             XJ     = COORDINATE OF SECOND ATOM.
!
! ON OUTPUT W      = ARRAY OF TWO-ELECTRON REPULSION INTEGRALS.
!           E1B,E2A= ARRAY OF ELECTRON-NUCLEAR ATTRACTION INTEGRALS,
!                    E1B = ELECTRON ON ATOM NI ATTRACTING NUCLEUS OF NJ.
!           ENUC   = NUCLEAR-NUCLEAR REPULSION TERM.
!
!
! *** THIS ROUTINE COMPUTES THE REPULSION AND NUCLEAR ATTRACTION
!     INTEGRALS OVER MOLECULAR-FRAME COORDINATES.  THE INTEGRALS OVER
!     LOCAL FRAME COORDINATES ARE EVALUATED BY SUBROUTINE REPP AND
!     STORED AS FOLLOWS (WHERE P-SIGMA = O,   AND P-PI = P AND P* )
!     IN RI
!     (SS/SS)=1,   (SO/SS)=2,   (OO/SS)=3,   (PP/SS)=4,   (SS/OS)=5,
!     (SO/SO)=6,   (SP/SP)=7,   (OO/SO)=8,   (PP/SO)=9,   (PO/SP)=10,
!     (SS/OO)=11,  (SS/PP)=12,  (SO/OO)=13,  (SO/PP)=14,  (SP/OP)=15,
!     (OO/OO)=16,  (PP/OO)=17,  (OO/PP)=18,  (PP/PP)=19,  (PO/PO)=20,
!     (PP/P*P*)=21,   (P*P/P*P)=22.
!
!***********************************************************************
  x(1) = xi(1) - xj(1)
  x(2) = xi(2) - xj(2)
  x(3) = xi(3) - xj(3)
  rij = x(1)*x(1) + x(2)*x(2) + x(3)*x(3)
  if (rij < 0.00002D0) then
!
!     SMALL RIJ CASE
!
    e1b = 0.D0
    e2a = 0.D0
    w = 0.D0
    enuc = 0.D0
    return
  end if
!
!
! *** THE REPULSION INTEGRALS OVER MOLECULAR FRAME (W) ARE STORED IN THE
!     ORDER IN WHICH THEY WILL LATER BE USED.  IE.  (I,J/K,L) WHERE
!     J.LE.I  AND  L.LE.K     AND L VARIES MOST RAPIDLY AND I LEAST
!     RAPIDLY.  (ANTI-NORMAL COMPUTER STORAGE)
!
!
  rijx = sqrt(rij)
  rij = rijx
!
! *** COMPUTE INTEGRALS IN DIATOMIC FRAME
!
  li = natorb(ni)
  lj = natorb(nj)
  call rotatd(ni, nj, xi, xj, w, kr, enuc)
  en(:) = 0.d0
  call elenuc (1, li, li + 1, li + lj, en)
  ik = 0
  do i = 1, li
    do k = 1, i
      ik = ik + 1
      e1b(ik) = en((i*(i - 1))/2 + k)
    end do
  end do
  ik = 0
  do i = li + 1, li + lj
    do k = li + 1, i
      ik = ik + 1
      e2a(ik) = en((i*(i - 1))/2 + k)
    end do
  end do
  if (id == 3 .and. .not. method_PM7) call nddo_to_point(w, e1b, e2a, enuc, rij, ni, nj) ! In solids, transition to point-charge as Rij increases
  return
  end subroutine rotate

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

subroutine filusp (nat, nfirst, nlast, uspd)
    use molkst_C, only :  norbs, numat
    use parameters_C, only : uss, upp, udd
  !
  !.. Implicit Declarations ..
    implicit none
  !
  !.. Formal Arguments ..
    integer, dimension (numat), intent (in) :: nat, nfirst, nlast
    double precision, dimension (norbs), intent (out) :: uspd
  !
  !.. Local Scalars ..
    integer :: i, ia, ib, j, ni_loc
  !
  ! ... Executable Statements ...
  !
    do i = 1, numat
      ni_loc = nat(i)
      ia = nfirst(i)
      ib = nlast(i)
      if (ia <= ib) then
      !
      !  Atom has an "s" orbital.
      !
        uspd(ia) = uss(ni_loc)
        if (ia /= ib) then
        !
        !  Atom has a "p" shell.
        !
          do j = ia + 1, ia + 3
            uspd(j) = upp(ni_loc)
          end do
        !
        !  Set the "d" shell, if present.
        !
          do j = ia + 4, ib
            uspd(j) = udd(ni_loc)
          end do
        end if
      end if
    end do
end subroutine filusp

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      double precision function charvi (vects, jorb, ioper, r, nvecs)
!-----------------------------------------------
!   M o d u l elem s
!-----------------------------------------------
      use symmetry_C, only : elem, jelem
      use molkst_C, only : numat
!***********************************************************************
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m elem t elem r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m elem n t s
!-----------------------------------------------
      integer , intent(in) :: jorb
      integer , intent(in) :: ioper
      integer , intent(in) :: nvecs
      double precision , intent(in) :: vects(nvecs,nvecs)
      double precision , intent(in) :: r(3,3)
!-----------------------------------------------
!   L o c a l   V a r i a b l elem s
!-----------------------------------------------
      integer :: iatom, jatom
      double precision, dimension(:), allocatable :: vect1, vect2
      double precision, dimension(5) :: h
      double precision, dimension(3) :: p
      double precision :: sum
! For Mopac BLAS
      double precision, external :: ddot
!

!-----------------------------------------------
      charvi = 1.D0
      if (ioper == 1) return
!
!   Non-trivial case
!
      allocate(vect1(nvecs), vect2(nvecs))
      vect1(:nvecs) = 0.D0
      vect2(:nvecs) = 0.D0
!#      WRITE(IW,*)' Vibration, raw'
!#      WRITE(IW,'(3f12.6)')(VECTS(i,jorb),i=1,3*NUMAT)
      do iatom = 1, numat
        jatom = jelem(ioper,iatom)
        p(1) = vects(iatom*3-2,jorb)
        p(2) = vects(iatom*3-1,jorb)
        p(3) = vects(iatom*3-0,jorb)
        h(1) = r(1,1)*p(1) + r(2,1)*p(2) + r(3,1)*p(3)
        h(2) = r(1,2)*p(1) + r(2,2)*p(2) + r(3,2)*p(3)
        h(3) = r(1,3)*p(1) + r(2,3)*p(2) + r(3,3)*p(3)
        p(1) = elem(1,1,ioper)*h(1) + elem(1,2,ioper)*h(2) + elem(1,3,ioper)*h(3)
        p(2) = elem(2,1,ioper)*h(1) + elem(2,2,ioper)*h(2) + elem(2,3,ioper)*h(3)
        p(3) = elem(3,1,ioper)*h(1) + elem(3,2,ioper)*h(2) + elem(3,3,ioper)*h(3)
        vect1(iatom*3-2:iatom*3) = h(:3)
        vect2(jatom*3-2:jatom*3) = p
      end do
!#      WRITE(IW,*)' Vibration, coordinate independent '
!#      WRITE(IW,'(3f12.6)')(VECT2(i),i=1,3*NUMAT)
!#      WRITE(IW,*)' Vibration, transformed            '
!#      WRITE(IW,'(3f12.6)')(VECT1(i),i=1,3*NUMAT)
!
!   Evaluate the term <psi(i)|R(theta)|psi(i)>
!
      sum = ddot(nvecs,vect1(:nvecs),1,vect2(:nvecs),1)
      charvi = sum
      return
      end function charvi

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine lewis (use_cvs)
   !***********************************************************************
   !
   !
   !  LEWIS works out what atom is bonded to what atom for the purpose of
   !  generating a Lewis structure.  It starts with the topography generated
   !  by "set_up_dentate" (this is the raw topography), then tidies up the
   !  topography using a series of filters - keywords such as CVB, and criteria
   !  such as a hydrogen atom must bond to exactly one other atom, and that must
   !  be a non-hydrogen atom.
   !
   ! On exit, NBONDS holds the number of bonds to each atom, and
   !          IBONDS contains the atom numbers, in order of increasing
   !                 atomic number.
   !
   ! The maximum number of bonded atoms per atom is 4.  More are allowed
   ! for checking purposes, but for a SCF calculation, 4 is the maximum.
   !
   !***********************************************************************
    use molkst_C, only: natoms, numat, maxtxt, keywrd, line, moperr, prt_topo
    use chanel_C, only: iw
    use elemts_C, only: elemnt
    use common_arrays_C, only: txtatm, nat, nbonds, ibonds
    implicit none
    logical, intent (in) :: use_cvs
!
    logical :: debug, let
    integer :: i, ibad, j, jbad, k, l, m, n
    integer, dimension (:), allocatable :: iz
    l = 0
!
! Most of the time, LET should be false, the commonest exceptions being 0SCF and RESEQ
!
    allocate (iz(natoms))
    let = (Index (keywrd, " 0SCF") + Index (keywrd, " RESEQ") + Index (keywrd, " SITE=") +  &
      Index (keywrd, " GEO-OK") + Index (keywrd, " ADD-H") + Index (keywrd, " LET") /= 0)
    debug = (Index (keywrd, " LEWIS") /= 0)
!
!  Work out raw connectivity.  This depends only on the topology.
!  Arrays nbonds and ibonds are filled here.
!
    call set_up_dentate()
    if (use_cvs) call check_cvs(.true.)
!
! Sanity check - Are all TXTATM filled
!
     do i = 1, numat
       do j = 1, nbonds(i)
         if (ibonds(j,i) == 0) then
            call mopend("A SEVERE ERROR OCCURRED WHILE ATTEMPTING TO RESEQUENCE THE ATOMS.")
            if (index(keywrd," RESEQ") == 0) &
              write(iw,'(10x, a)')"(Try adding keyword ""NORESEQ"" and re-submit.)"
            write(iw,'(10x, a)')"(Ignore any error messages after this line.)"
            return
         end if
       end do
     end do
!
!  Put limit on maximum number of bonds to an atom.
!
!  This is a practical issue.  In theory, it should be possible to make Lewis structures
!  for all systems, but in practice some are just too difficult.  For example, [Fe(ii)(NH3)6](2+)
!  and [Ni(ii)(NH3)6](2+).  In these systems, consider the metal as bonding to a nitrogen atom.
!  The metal obviously has a formal charge of -4 and the nitrogen atoms have a formal charge of +1,
!  to give a net charge on the complex of +2.  However, writing software for this has been too difficult,
!  so it is easier to re-word such complexes as [Fe(ii)(NH3)5](2+).(NH3)  This does not affect the results,
!  but is a useful expedient.
!
    do i = 1, numat
      select case (nat(i))
      case (26, 28, 46, 78)  ! Fe, Ni, Pd, Pt
        do
          if (nbonds(i) > 5) then
            call remove_bond(i)
          else
            exit
          end if
        end do
      case default
      end select
    end do
!
!  Check bonding of hydrogen atoms - check for bridges
!
    call check_H(ibad)
    if (ibad == 1) then
      write (iw,*)
    end if
    if (ibad /= 0 .and. .not. let) then
      write(iw,'(//10x,a)') "Add keyword ""LET"" to allow job to continue"
      call mopend ("A hydrogen atom is badly positioned")
    end if
    jbad = ibad
    ibad = 0
!
!  Special check for nitro groups
!
    do i = 1, numat
      if (nat(i) == 7) then
        k = 0
        l = 0
        do j = 1, nbonds(i)
          if (nat(ibonds(j,i)) == 8 .and. nbonds(ibonds(j,i)) == 1) then
            k = ibonds(j,i)
            exit
          end if
        end do
        do j = j + 1, nbonds(i)
          if (nat(ibonds(j,i)) == 8 .and. nbonds(ibonds(j,i)) == 1) then
            l = ibonds(j,i)
            exit
          end if
        end do
!
!  Found a system with N bonded to two oxygen atoms (k and l),
!  which are not bonded to anything else.
!
        if (k /= 0 .and. l /= 0) then
!
!  Put a bond between the two oxygen atoms
!
          nbonds(k) = 2
          nbonds(l) = 2
          ibonds(2,k) = l
          ibonds(2,l) = k
        end if
      end if
    end do
!
!  End of special check for nitro groups
!
!
!  Put atoms into order of atomic number
!
    do i = 1, numat
      if (nbonds(i) > 1) then
        n = nbonds(i)
        iz(:n) = ibonds(:n,i)
        do j = 1, n
          k = 0
          do m = 1, n
            if (iz(m) /= 0) then
              if (nat(iz(m)) > k) then
                l = m
                 k = nat(iz(m))
              end if
            end if
          end do
          ibonds(j,i) = iz(l)
          iz(l) = 0
        end do
      end if
    end do
    if (prt_topo .and. debug .and. jbad /= 0 .and. .not. let) then
      if (maxtxt == 0) then
        j = 1
      else
        j = maxtxt/2 + 2
      end if
      write (iw, "(/,A,/)") "   TOPOGRAPHY OF SYSTEM"
      line = " "
      write (iw,*) "  ATOM No. "//line(:j)//"  LABEL  "//line(:j)//"Atoms connected to this atom"
      if (j == 0) then
        do i = 1, numat
          write (iw, "(I7,9X,A,9I7)") i, elemnt (nat(i)) // "  ", (ibonds(j, i), j=1, nbonds(i))
        end do
      else
        if (maxtxt > 2) then
          do i = 1, numat
            write (iw, "(I7,9X,A,9I7)") i, elemnt (nat(i)) // " (" // txtatm(i) (:maxtxt) // ") ", (ibonds(j, i), j=1, nbonds(i))
          end do
        else
          do i = 1, numat
            write (iw, "(I7,9X,A,9I7)") i, elemnt (nat(i)), (ibonds(j, i), j=1, nbonds(i))
          end do
        end if
      end if
    end if
    if (jbad /= 0 .and. .not. let) call mopend ("Geometry is faulty")
    if (let) moperr = .false.
end subroutine lewis
!
!
!
subroutine remove_bond(i)
  use common_arrays_C, only: coord, nbonds, ibonds
!
!  Remove the longest bond from atom i
!
  implicit none
  integer, intent (in) :: i
  double precision :: rmax, sum
  integer :: j, k, l
  rmax = 0.d0
  l = 0
  do j = 1, nbonds(i)
    k = ibonds(j,i)
    sum = (coord(1, i)-coord(1, k)) ** 2 + &
          (coord(2, i)-coord(2, k)) ** 2 + &
          (coord(3, i)-coord(3, k)) ** 2
    if (sum > rmax) then
      rmax = sum
      l = k
    end if
  end do
  k = 0
  do j = 1, nbonds(i)
    if (ibonds(j,i) /= l) then
      k = k + 1
      ibonds(k,i) = ibonds(j,i)
    end if
  end do
  nbonds(i) = nbonds(i) - 1
  k = 0
  do j = 1, nbonds(l)
    if (ibonds(j,l) /= i) then
    k = k + 1
      ibonds(k,l) = ibonds(j,l)
    end if
  end do
  nbonds(l) = nbonds(l) - 1
  end subroutine remove_bond
  subroutine check_h(ibad)
    use molkst_C, only: natoms, numat, line, mozyme, keywrd, numcal, maxtxt, pdb_label
    use chanel_C, only: iw, ilog, log, log_fn
    use elemts_C, only: elemnt
    use atomradii_C, only: radius
    use common_arrays_C, only: nat, labels, nbonds, ibonds, txtatm
    implicit none
    integer, intent (out) :: ibad
    integer :: i, j, m, n, k, l, ii, heavy(10), icalcn = -1
    integer, allocatable :: im(:)
    double precision :: rmin, r
    logical :: opend, prt
    double precision, external :: distance
    character :: num1*1, num2*1, num3*1
    save :: icalcn
    if ( .not. mozyme) then
      ibad = 0
      return
    end if
    prt = (icalcn /= numcal)
    if (prt) icalcn = numcal
    allocate (im(natoms))
    inquire(unit=ilog, opened=opend)
    if (.not. opend) open(unit=ilog, form='FORMATTED', status='UNKNOWN', file=log_fn, position='asis')
    j = 0
    k = 0
    do i = 1, natoms
      if (labels(i) /= 99) then
        j = j + 1
        im(j) = i
      end if
    end do
!
!  Check bonding of hydrogen atoms - check for bridges
!
    ibad = 0
    do i = 1, numat
      if (nat(i) == 1) then
        if (nbonds(i) == 0) then
!
!  Find nearest heavy atom to hydrogen atom i
!
          rmin = 1.d12
          do j = 1, numat
            if (j == i .or. nat(j) == 1) cycle
            r = distance(i, j)
            if (r < rmin) then
              rmin = r
              k = j
            end if
          end do
          nbonds(i) = 1
          ibonds(1,i) = k
          nbonds(k) = nbonds(k) + 1
          ibonds(nbonds(k),k) = i
          if (rmin < max(1.3d0, 2.d0*radius(k))) cycle
          if (ibad < 20 .and. &
            index(keywrd, " 0SCF") + index(keywrd, " LET") + index(keywrd, " ADD-H") + index(keywrd, " RESEQ") == 0) then
            num1 = char(Int(log10(i     + 1.0)) + ichar("1"))
            num2 = char(Int(log10(rmin  + 0.05d0)) + ichar("5"))
            num3 = char(Int(log10(im(k) + 1.0)) + ichar("1"))
            j = 1
            if (elemnt (nat(k))(1:1) == " ") j = 2
            write (line, "(a,i"//num1//",a,f"//num2//".2,a, a,i"//num3//",a)") &
              "Hydrogen atom ", i, " is", rmin, " Angstroms from the nearest non-hydrogen atom (", &
              elemnt (nat(k))(j:2), im(k),")"
            call mopend(trim(line))
            write(iw,"(10x,a,i"//num1//",a,/)")"(Label for atom ", i, ": """//trim(txtatm(i))//""")"
            inquire(unit=ilog, opened=opend)
            if (log) write (ilog, "(a)")trim(line)
            ibad = ibad + 1
          end if
          cycle
        else if (nbonds(i) == 1) then
!
!  The normal case
!
          r = distance(i, ibonds(1,i))
        else
!
!  Find the heavy atom, k, nearest to hydrogen atom i
!
          rmin = 1.d12
          m = 0
          k = 0
          do j = 1, nbonds(i)
            if (nat(ibonds(j,i)) == 1) cycle
            m = m + 1
            heavy(m) = ibonds(j,i)
            r = distance(i, ibonds(j,i))
            if (r < rmin .and. r > 0.95d0) then
              rmin = r
              k = ibonds(j,i)
            end if
          end do
          if (k == 0) then
            do j = 1, nbonds(i)
              if (nat(ibonds(j,i)) == 1) cycle
              m = m + 1
              heavy(m) = ibonds(j,i)
              r = distance(i, ibonds(j,i))
              if (r < rmin) then
                rmin = r
                k = ibonds(j,i)
              end if
            end do
          end if
!
! Write out error message
!
          if (m == 2 .and. prt) then
            j = 1
            m = heavy(1)
            n = heavy(2)
            num1 = char(Int(log10(m     + 1.0)) + ichar("1"))
            num2 = char(Int(log10(n     + 1.0)) + ichar("1"))
            num3 = char(Int(log10(im(i) + 1.0)) + ichar("1"))
            if (pdb_label) then
              write (iw, "(/,a,i"//num3//",6a)") " Hydrogen atom ", im(i), &
              & " bonds to """, txtatm(m), """ and """, txtatm(n),""""
            if (log) write (ilog, "(a,i"//num3//",6a)") " Hydrogen atom ", im(i), &
              & " bonds to """, txtatm(m), """ and """, txtatm(n),""""
            else
              write (iw, "(/,a,i"//num3//",a,a2,i"//num1//",a,a2,i"//num2//")") " Hydrogen atom ", im(i), &
                & " has covalent bonds to ", elemnt (nat(m)), im(m), " and ", elemnt (nat(n)), im(n)
              if (log) write (ilog, "(a,i"//num3//",a,a2,i"//num1//",a,a2,i"//num2//")") " Hydrogen atom ", im(i), &
                & " has covalent bonds to ", elemnt (nat(m)), im(m), " and ", elemnt (nat(n)), im(n)
            end if
          else if (m > 2 .and. prt) then
            if (ibad < 20) then
              num3 = char(Int(log10(im(i) + 1.0)) + ichar("1"))
              write (iw, "(/,a,i"//num3//",a,a2,I5,a,a2,i5)") " Hydrogen atom ", im(i), " has more than two covalent bonds"
              if (txtatm(im(i)) /= " ") then
                j = im(i)
                write(iw, '(5x, a)')"Atom label: """//txtatm(j)(:maxtxt)//""""
                do n = 1, nbonds(j)
                  l = ibonds(n,j)
                  write(iw,'(5x, a, f8.3, a)')"The bond-length to """//txtatm(l)(:maxtxt)//""" is ",distance(l, im(i)), " Angstroms"
                end do
              end if
              if (log) write (ilog, "(a,i"//num3//",a,a2,I5,a,a2,i5)") &
                 " Hydrogen atom ", im(i), " has more than two covalent bonds"
            end if
          end if
          if (m > 1) then
!
!  Remove all bonds to hydrogen atom i except the shortest bond, to atom "k"
!
            do j = 1, nbonds(i)
              ii = ibonds(j,i)
              if (ii == k .or. nat(ii) == 1) cycle
              m = 0
              do l = 1, nbonds(ii)
                if (ibonds(l,ii) /= i) then
                  m = m + 1
                  ibonds(m,ii) = ibonds(l,ii)
                end if
              end do
              nbonds(ii) = m
            end do
            nbonds(i) = 1
            ibonds(1,i) = k
            num1 = char(Int(log10(k     + 1.0)) + ichar("1"))
            if (prt) then
              if (pdb_label) then
                write (iw, "(12x,3a)") "(Keeping bond to """, txtatm(k), """)"
              else
                write (iw, "(25x,a,a2,i"//num1//",a)") "(Keeping bond to ", elemnt (nat(k)), im(k), ")"
              end if
            end if
          end if
        end if
      end if
      if (ibad == 21) write (iw,*) " Remaining errors suppressed"
    end do
    return
  end subroutine check_h


  subroutine check_CVS(let)
  use molkst_C, only: numat, keywrd, line, numcal, moperr, nscf, maxtxt, natoms
  use common_arrays_C, only: txtatm, nat, coord, &
      nbonds, ibonds
  use elemts_C, only: elemnt
  use atomradii_C, only: radius, is_metal
  use chanel_C, only: iw
  implicit none
  logical, intent (in) :: let
  integer :: i, j, k, l, n, m, ii, ncvb, icalcn = -1, ik, cvb_atoms(60)
  logical :: lbond, error, PDB_input, OO_first = .true., made, first = .true.
  double precision :: r
  double precision, external :: reada
  double precision, allocatable :: store_coord(:,:)
  double precision, external :: distance
  character :: num*1, num_1*1, store*2000
  save :: store_coord, OO_first, first
  error = .false.
  PDB_input = .false.
!
! Most of the time, LET should be false, the commonest exceptions being 0SCF and RESEQ
!
    if (allocated (store_coord) .and. icalcn /= numcal) then
      deallocate (store_coord)
      icalcn = numcal
    end if
    if (.not. allocated (store_coord)) then
      i = size(coord)/3
      allocate (store_coord(3,i))
      store_coord = coord
    end if
!
!  Parse CVB(2:3,45:65)
!
     store = trim(keywrd)
     i = index(keywrd, " CVB")
     if (i > 0) then
       j = index(keywrd(i:), ") ") + i
       line = keywrd(i + 1: j - 1)
       ii = len_trim(line)
!
!    If everything is in quotation marks, use the CVB keyword
!
       k = 0
       do
         k = k + 1
         if (k >= ii) exit
         if (line(k:k) == '"') then
           do
             k = k + 1
             if (line(k:k) == '"') exit
           end do
         end if
         if (line(k:k) >= "0" .and. line(k:k) <= "9") exit
       end do
       PDB_input = (k > ii - 3)
    end if
    i = Index (keywrd, " CVB")
    k = 0
    if (i /= 0) then
      k = Index (keywrd(i:), ")") + i
      if (keywrd(k:k) /= " ") then
        write(iw,"(//10x,a)")" There must be a space after the closing parenthesis of the CVB keyword"
        do
          k = k + 1
          if (keywrd(k:k) == " ") exit
        end do
        write(iw,'(/10x,a)')" CVB keyword: """//keywrd(i + 1:k-1)//'"'
        if (index(keywrd, " 0SCF") /= 0) return
        call mopend ("ERROR IN CVB KEYWORD")
        return
      end if
    end if
    if (k == i .and. i /= 0) then
      k = Index (keywrd(i + 3:), " ") + i + 3
      write(iw,"(//10x,a)")" No closing parenthesis for CVB keyword"
      write(iw,'(10x,a)')" CVB keyword ="//'"'//keywrd(i:k)//'"'
      if (index(keywrd, " 0SCF") /= 0) return
      call mopend ("ERROR IN CVB KEYWORD")
      return
    end if
    if (i /= 0) then
      do n = 1, 50
        k = Index (keywrd(i:), ") ") + i
        j = index(keywrd(i:k),"""") + i
        if (j == i) exit
        if (keywrd(j: j + 3) == 'O:-O') then
!
!  Run O-O check: If two oxygen atoms are bonded together, and both oxygen atoms are
!  bonded to other atoms, then delete the O-O bond.
!
!
! Jump over the text "O:-O"
!
          i = j + 5
          lbond = .false.
          do j = 1, numat
            if (nat(j) == 8) then
              do k = 1, nbonds(j)
                l = ibonds(k,j)
                if (nat(l) == 8 .and. nbonds(l) + nbonds(j) > 3) then
!
!  Delete O-O bond j-l
!
                  do m = k + 1, nbonds(j)
                    ibonds(m - 1,j) = ibonds(m,j)
                  end do
                  nbonds(j) = nbonds(j) - 1
                  do m = 1, nbonds(l)
                    if (ibonds(m,l) == j) then
                      do ik = m + 1, nbonds(l)
                        ibonds(ik - 1,l) = ibonds(ik,l)
                      end do
                      nbonds(l) = nbonds(l) - 1
                    end if
                  end do
                  lbond = .true.
                  if (OO_first) &
                    write(iw,'(10x,a)')"O - O Bond between """//txtatm(j)//""" and """//txtatm(l)//""" deleted"
                end if
              end do
            end if
          end do
          if (.not. lbond) then
             if (OO_first .and. index(keywrd, " 0SCF") == 0) &
               write(iw,'(/10x,"Option ""O:-O"" present in CVB, but no O-O bonds found.  This option ignored, job continuing")')
          end if
          OO_first = .false.
          cycle
        end if
        call txt_to_atom_no(keywrd, j - 1, let)
        if (moperr) return
      end do
      k = Index (keywrd(i:), ")") + i
      ncvb = 0
      if (first) then
        write(iw,'(20x,a,/)')" Bonds made and broken by keyword CVB"
        write(iw,'(9x,a)')"Atom #          Label                  Atom #          Label"
      end if
      do
        made = .true.
        j = Nint (reada (keywrd(i:k), 1))
        ii = Index (keywrd(i:k), ":") + i
        if (ii == i) then
          if (index(keywrd, '("O:-O")') /= 0) exit
          write (iw,*)
          write (iw,*) " ERROR IN CVB KEYWORD - ':' EXPECTED BUT NOT FOUND"
          j = Index (keywrd, " CVB")
          write(iw,'(10x,a)')" CVB keyword ="//'"'//keywrd(j:k)//'"'
          call mopend ("ERROR IN CVB KEYWORD")
          return
        end if
        i = ii
        if (j > natoms .or. j == 0 .or. j < -natoms) then
          write (iw,*) " AT LEAST ONE ATOM DEFINED BY CVB IS FAULTY"
          write (iw,*) " THE FAULTY ATOM NUMBER IS", j
          j = Index (keywrd, " CVB")
          write(iw,'(10x,a)')" CVB keyword ="//'"'//keywrd(j:k)//'"'
          error = .true.
        end if
        l = Nint (reada (keywrd(i:k), 1))
        if (l > natoms .or. l == 0 .or. l < -natoms) then
          write (iw,*) " AT LEAST ONE ATOM DEFINED BY CVB IS FAULTY"
          write (iw,*) " THE FAULTY ATOM NUMBER IS", l
          m = Index (keywrd, " CVB")
          write(iw,'(10x,a)')" CVB keyword ="//'"'//keywrd(m:k)//'"'
          error = .true.
        end if
        if (error) goto 99
        n = abs(l)
        m = abs(j)
        if (allocated(store_coord) .and. .not. PDB_input) then
!
!   If an atom has moved, find its new location
!
          do ii = 1, numat
            if (abs(coord(1,ii) - store_coord(1,n)) < 1.d-1) then
               if (abs(coord(2,ii) - store_coord(2,n)) < 1.d-1) then
                 if (abs(coord(3,ii) - store_coord(3,n)) < 1.d-1) exit
               end if
            end if
          end do
          l = sign(ii,l)
          do ii = 1, numat
            if (abs(coord(1,ii) - store_coord(1,m)) < 1.d-1) then
               if (abs(coord(2,ii) - store_coord(2,m)) < 1.d-1) then
                 if (abs(coord(3,ii) - store_coord(3,m)) < 1.d-1) exit
               end if
            end if
          end do
          j = sign(ii,j)
        else
          j = sign(m,j)
          l = sign(n,l)
        end if
        do ii = 1, ncvb
          if (cvb_atoms(ii) == m) exit
        end do
        if (ii > ncvb) then
          ncvb = ncvb + 1
          cvb_atoms(ncvb) = m
        end if
        m = abs(l)
        do ii = 1, ncvb
          if (cvb_atoms(ii) == m) exit
        end do
        if (ii > ncvb) then
          ncvb = ncvb + 1
          cvb_atoms(ncvb) = m
        end if
        if (j > 0 .and. l > 0) then
          do ii = 1, nbonds(j)
            if (ibonds(ii, j) == l .and. .not. let .and. index(keywrd, " GEO-OK") == 0 .and. &
              index(keywrd, " 0SCF") == 0) then
              r = distance(j,l)
              write(iw,"(/,a,i5,a,i5,a, f6.3, a)")" The bond to be made by CVB between atoms",j," and", &
              l, " already exists, bond length =", r," Angstrom."
              write(iw,'(/30x,a,/)')"PDB label              Coordinates of the two atoms"
              write(iw,"(a,i5,a,3x,a, 3f12.6)")" Atom:", j, ": "//elemnt(nat(j)), "("//txtatm(j)//")", coord(:,j)
              write(iw,"(a,i5,a,3x,a, 3f12.6)")" Atom:", l, ": "//elemnt(nat(l)), "("//txtatm(l)//")", coord(:,l)
              write(iw,"(/10x,a,/)") "(If an extra bond needs to be added, use keyword 'SETPI')"
              error = .true.
            end if
          end do
          r = distance(j,l)
          if (r > 3.d0*(radius(j) + radius(l)) .and. .not. let .and. index(keywrd, " GEO-OK") == 0 .and. &
              index(keywrd, " 0SCF") == 0) then
            if (.not. is_metal(nat(j)) .and. .not. is_metal(nat(l))) then
              num = char(ichar("5") + int(log10(r)))
              write(iw,'(/,a,i5,a,i5,a,f'//num//'.2,a)')" The bond to be made by CVB between atoms", j, &
              " and", l, " would be", r, " Angstroms long.  This is unrealistic."
              write(iw,'(/30x,a,/)')"PDB label              Coordinates of the two atoms"
              write(iw,"(a,i5,a,3x,a, 3f12.6)")" Atom:", j, ": "//elemnt(nat(j)), "("//txtatm(j)//")", coord(:,j)
              write(iw,"(a,i5,a,3x,a, 3f12.6)")" Atom:", l, ": "//elemnt(nat(l)), "("//txtatm(l)//")", coord(:,l)
              error = .true.
            end if
          end if
!
!  Do NOT add a bond if that bond already exists
!
          do ii = 1, nbonds(j)
            if (ibonds(ii,j) == l) exit
          end do
          if (ii > nbonds(j)) then
            nbonds(j) = nbonds(j) + 1
            nbonds(l) = nbonds(l) + 1
            ibonds(nbonds(j), j) = l
            ibonds(nbonds(l), l) = j
          end if
        else
!
!  make sure that the faulty bond actually exists.
!
          j = Abs(j)
          l = Abs(l)
          if (j == 0 .or. l == 0) then
            write(iw,"(10x,a)")" Error detected while reading CVB"
            j = Index (keywrd, " CVB")
            write(iw,'(10x,a)')" CVB keyword ="//'"'//keywrd(j:k)//'"'
            error = .true.
          end if
          lbond = .false.
          do n = 1, nbonds(j)
            if (ibonds(n,j) == l) then
!
!  Faulty bond exists, therefore delete it.
!
              ik = l
              do m = n + 1,nbonds(j)
                ibonds(m - 1,j) = ibonds(m,j)
              end do
              ibonds(nbonds(j),j) = ik
              nbonds(j) = nbonds(j) - 1
              lbond = .true.
              exit
            end if
          end do
          do n = 1, nbonds(l)
            if (ibonds(n,l) == j) then
!
!  Faulty bond exists, therefore delete it.
!
              ik = j
              do m = n + 1,nbonds(l)
                ibonds(m - 1,l) = ibonds(m,l)
              end do
              ibonds(nbonds(l),l) = ik
              nbonds(l) = nbonds(l) - 1
              lbond = .true.
              exit
            end if
          end do
          made = .false.
          if (.not. lbond .and. .not. let) then
            if (radius(l) > 0.1d0 .and. radius(j) > 0.1d0) then
            if (index(keywrd, " GEO-OK") == 0 .and. index(keywrd, " 0SCF") == 0) then
              num = char(ichar("2") + int(log10(j*1.0001)))
              num_1 = char(ichar("2") + int(log10(l*1.0001)))

              write(iw,"(/,a,i"//num//",a,i"//num_1//",a)")" The bond to be deleted by CVB between atoms",j," and", &
                l, " did not exist.  Correct error and re-submit"
              write(iw,'(/30x,a,/)')"PDB label              Coordinates of the two atoms"
              write(iw,"(a,i5,a,3x,a, 3f12.6)")" Atom:", j, ": "//elemnt(nat(j)), "("//txtatm(j)//")", coord(:,j)
              write(iw,"(a,i5,a,3x,a, 3f12.6)")" Atom:", l, ": "//elemnt(nat(l)), "("//txtatm(l)//")", coord(:,l)
            else
              if (index(keywrd, " LOCATE-TS") == 0 .and. index(keywrd, " 0SCF") == 0) then
                write(iw,"(/,a,i5,a,i5,a,/,a)")" The bond to be deleted by CVB between atoms",j," and", &
                l, " did not exist,", " but, because GEO-OK is present, the job will continue."
              end if
            end if
            error = .true.
            end if
          end if
        end if
99      continue
        if (.not. error .and. first) then
          if (made) then
            write(iw,'(a8, i6,a,i8,a)')" Made",   j, " "//elemnt(nat(j))//"("//txtatm(j)(:maxtxt)//")", &
              l, " "//elemnt(nat(l))//"("//txtatm(l)(:maxtxt)//")"
          else
            write(iw,'(a8, i6,a,i8,a)')" Broken", j, " "//elemnt(nat(j))//"("//txtatm(j)(:maxtxt)//")", &
              l, " "//elemnt(nat(l))//"("//txtatm(l)(:maxtxt)//")"
          end if
        end if
        do j = i, k
          if (keywrd(j:j) == "," .or. keywrd(j:j) == ";") exit
        end do
        if (j <= k) then
          i = j
        else
          exit
        end if
      end do
      do i = 1, ncvb
        j = cvb_atoms(i)
        if (nbonds(j) == 0 .and. radius(j) > 0.1d0) then
          if (nat(j) == 1) then
!
!  A bond to hydrogen has been broken, so see if there is a different atom within range.
!
            do_k: do k = 1, numat
              do l = 1, ncvb
                if (cvb_atoms(l) == k) cycle do_k
              end do
              if (distance(j,k) < 1.2d0) then
                nbonds(j) = 1
                ibonds(1,j) = k
                nbonds(k) = nbonds(k) + 1
                ibonds(nbonds(k),k) = j
                exit
              end if
            end do do_k
            if (nbonds(j) == 1) cycle
          end if
          if (nscf < 3) then
            if (txtatm(j) /= " ") then
            num = char(ichar("1") + int(log10(j*1.01)))
            write(line,"(a, i"//num//",a)")"All bonds to atom ", j, ", label: """ &
            //txtatm(j)//""" have been deleted"
            else
              write(line,"(a,i5,a,3f10.5)") &
              " All bonds to atom "//elemnt(nat(j)), j, " have been deleted. Coords:",coord(:,j)
            end if
            call mopend(trim(line))
            error = .true.
          end if
        end if
      end do
    end if
    if (error .and. .not. let) then
      if (index(keywrd, " GEO-OK") + index(keywrd, " 0SCF") == 0  ) then
        write(iw,"(/10x,a)")"To continue add ""GEO-OK"" or correct reported faults"
        call mopend("Fault in CVB keyword")
        return
      end if
    end if
    if (let) moperr = .false.
    keywrd = store
    first = .false.
    return
  end subroutine check_CVS
  subroutine txt_to_atom_no(text, j_in, let)
!
!  Convert atom number from text to a number.  Text can be PDB or Jmol
!
!  On input, "text": Line of text containing PDB or Jmol
!            j_in: Start of text (location of the character after the leading '"')
!            let:  TRUE if the job is to continue even if a fault is found.
!
! On exit, "text": PDB or Jmol text has been replaced by numbers
!
  use molkst_C, only: natoms, pdb_label
  use common_arrays_C, only: txtatm
  use chanel_C, only: iw
  implicit none
  character :: text*(*)
  integer, intent (in) :: j_in
  logical, intent (in) :: let
  integer :: i, j, l, n, k, m, p, q
  character :: line*80, txt*30, num*1, txt2*30
  if (.not. pdb_label) then
    call mopend("Labeled atoms can only be used when atoms have labels")
    m = 0
    return
  end if
  j = j_in + 1
  l = index(text(j:),"""") + j
  call upcase(text, len_trim(text))
  line = text(j:l - 2)
  txt2 = trim(line)
  if (line(1:1) == "[") then
    k = len_trim(line)
    if (k > 16) then
      write(line,'(a)')"Atom defined by '"//trim(line)//"' is not in JSmol format"
      call mopend(trim(line))
      return
    end if
!
! Atom defined using Jmol format
!
    n = index(text(j:l - 2),".") + j
    k = index(text(j:l - 2),":") + j
    m = index(text(j:l - 2),"]") + j
    if (n == j .or. m == j) then
      write(line,'(a)')"Atom defined by '"//trim(line)//"' is not in JSmol format"
      call mopend(trim(line))
      if (n == j) call mopend("(The dot separator, ""."", is missing.)")
      if (m == j) call mopend("(The close square bracket, ""]"", is missing.)")
      return
    end if
    if (k == j) then
      line = text(n:l - 2)//text(j + 1:m - 2)//text(m:n - 2)
    else
      line = text(n:l - 2)//text(j + 1:m - 2)//text(k:k)//text(m:k - 2)
    end if
  end if
  m = 0
  do k = 1, len_trim(line)
    if (line(k:k) /= " ") then
      m = m + 1
      line(m:m) = line(k:k)
    end if
  end do
  line(m + 1:) = " "
  if (m > 12) then
     write(line,'(a)')"Atom defined by '"//trim(line)//"' is not in PDB format"
     call mopend(trim(line))
     return
  end if
  line(m + 1:m + 5) = " "
  q = 0
  do i = 1, natoms
    txt = txtatm(i)
    call upcase(txt, len_trim(txt))
    n = 0
    do k = 13, 27
      if (txt(k:k) /= " ") then
        n = n + 1
        txt(n:n) = txt(k:k)
      end if
    end do
    txt(n + 1:m ) = "?"
    n = max(n, m)
    do k = 1, n
      if (txt(k:k) /= line(k:k) .and. line(k:k) /= "*") exit
    end do
    if (k > n) then
      q = q + 1
      if (q == 2) then
          write(iw,'(/1x,a)')"An atom has been defined using a PDB label, "// &
            "but more than one atom in the data-set has this label:"
          write(iw,'(/10x,a)')"Atom number      PDB label"
          write(iw,'(10x, i5, 4x, a)')p, '"'//txtatm(p)//'"'
          write(iw,'(10x, i5, 4x, a)')i, '"'//txtatm(i)//'"'        
          call mopend("TWO ATOMS HAVE THE SAME PDB LABEL")
          return
      end if
      p = i
    end if
  end do
  if (q == 1) then
    i = p
    num = char(ichar("1") + int(log10(i*1.0001)))
    write(line,'(i'//num//')')i
    text(j - 1:) = trim(line)//text(l:)          
  end if
  if (q == 0) then
    k = len_trim(line)
    if (index(txt2,"[") /= 0) then
      write(line,'(a)')"Atom defined by JSmol label '"//trim(txt2)//"' was not found in the data set"
    else
      write(line,'(a)')"Atom defined by PDB label '"//trim(txt2)//"' was not found in the data set"
    end if
    if(.not. let) then
      call mopend(trim(line))
      write(iw,'(10x,a)') &
      "(Hint: Check that the atom-label in the data set matches the atom-label in the PDB file.)"
      write(iw,'(10x,a)')"(Hint: Atom-labels used in connectivity can only use atoms that have already been defined.)"
      return
    end if
  end if
  return
  end subroutine txt_to_atom_no
  subroutine atom_no_to_txt(atom_no, text)
!
! Convert an atom number to its PDB label
!
    use common_arrays_C, only: txtatm
    implicit none
    integer, intent (in) :: atom_no
    character, intent (out) :: text*(*)
!
!  Local
!
    character :: txt*18
    if (atom_no == 0) then
      text = " 0 "
      return
    end if
    txt = txtatm(atom_no)(12:)
    do
      if (txt(1:1) /= " ") exit
      txt = trim(txt(2:))
    end do
    text = '"'//trim(txt)//'"'
    return
  end subroutine atom_no_to_txt

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

subroutine bangle (xyz, i, j, k, angle)
!
!.. Implicit Declarations ..
    implicit none
!
!.. Formal Arguments ..
    double precision, dimension (3,*), intent (in) :: xyz
    integer, intent (in) :: i, j, k
    double precision, intent (out) :: angle
!
!.. Local Scalars ..
    double precision :: d2ij, d2ik, d2jk, temp, xy
!
!.. Intrinsic Functions ..
    intrinsic Acos, Sqrt
!
! ... Executable Statements ...
!
!********************************************************************
!
! BANGLE CALCULATES THE ANGLE BETWEEN ATOMS I,J, AND K. THE
!        CARTESIAN COORDINATES ARE IN XYZ.
!
!********************************************************************
    d2ij = (xyz(1, i)-xyz(1, j))**2 + (xyz(2, i)-xyz(2, j))**2 &
         &+ (xyz(3, i)-xyz(3, j))**2
    d2jk = (xyz(1, j)-xyz(1, k))**2 + (xyz(2, j)-xyz(2, k))**2 &
         &+ (xyz(3, j)-xyz(3, k))**2
    d2ik = (xyz(1, i)-xyz(1, k))**2 + (xyz(2, i)-xyz(2, k))**2 &
         &+ (xyz(3, i)-xyz(3, k))**2
    xy = Sqrt (d2ij*d2jk)
    temp = 0.5d0 * (d2ij+d2jk-d2ik) / xy
    if (temp <-1.d0+1.d-12) then
      temp = -1.0d0
    end if
    if (temp > 1.d0-1.d-12) then
      temp = 1.d0
    end if
    angle = Acos (temp)
end subroutine bangle
subroutine dang (a1, a2, b1, b2, rcos)
!
!.. Implicit Declarations ..
    implicit none
!
!.. Formal Arguments ..
    double precision, intent (inout) :: a1, a2, b1, b2
    double precision, intent (out) :: rcos
!
!.. Local Scalars ..
    double precision :: anorm, bnorm, costh, sinth, zero
!
!.. Intrinsic Functions ..
    intrinsic Abs, Acos, Asin, Sqrt
!
! ... Executable Statements ...
!
!*********************************************************************
!
!    DANG  DETERMINES THE ANGLE BETWEEN THE POINTS (A1,A2), (0,0),
!          AND (B1,B2).  THE RESULT IS PUT IN RCOS.
!
!*********************************************************************
    zero = 1.0d-6
    if (Abs (a1) >= zero .or. Abs (a2) >= zero) then
      if (Abs (b1) >= zero .or. Abs (b2) >= zero) then
        anorm = 1.0d0 / Sqrt (a1**2+a2**2)
        bnorm = 1.0d0 / Sqrt (b1**2+b2**2)
        a1 = a1 * anorm
        a2 = a2 * anorm
        b1 = b1 * bnorm
        b2 = b2 * bnorm
        sinth = (a1*b2) - (a2*b1)
        costh = a1 * b1 + a2 * b2
        if (costh > 1.0d0) then
          costh = 1.0d0
        end if
        if (costh <-1.0d0) then
          costh = -1.0d0
        end if
        rcos = Acos (costh)
        if (Abs (rcos) >= 4.0d-4) then
          if (sinth > 0.d0) then
            rcos = 4.0d0 * Asin (1.0d00) - rcos
          end if
          rcos = -rcos
          return
        end if
      end if
    end if
    rcos = 0.0d0
end subroutine dang
!    ******************************************************************
double precision function digit (string, istart)
!     FORTRAN FUNCTION TO CONVERT NUMERIC FIELD TO DOUBLE PRECISION
!     NUMBER.  THE STRING IS ASSUMED TO BE CLEAN (NO INVALID DIGIT
!     OR CHARACTER COMBINATIONS FROM ISTART TO THE FIRST NONSPACE,
!     NONDIGIT, NONSIGN, AND NONDECIMAL POINT CHARACTER).
!
!
!.. Implicit Declarations ..
    implicit none
!
!.. Formal Arguments ..
    character (len=*), intent (in) :: string
    integer, intent (in) :: istart
!
!.. Local Scalars ..
    logical :: sign
    integer :: i, i0, i9, idig, idot, ineg, ipos, ispc, j, l, n
    double precision :: c1, c2, deciml
!
!.. Intrinsic Functions ..
    intrinsic Ichar, Len
!
! ... Executable Statements ...
!
!
!     DEFINE ASCII VALUES OF NUMERIC FIELD CHARACTERS
    i0 = Ichar ("0")
    i9 = Ichar ("9")
    ineg = Ichar ("-")
    ipos = Ichar ("+")
    idot = Ichar (".")
    ispc = Ichar (" ")
!
    c1 = 0.d0
    c2 = 0.d0
    sign = .true.
    l = Len(string)
!
!     DETERMINE THE CONTRIBUTION TO THE NUMBER GREATER THAN ONE
    idig = 0
    do i = istart, l
      n = Ichar (string(i:i))
      if (n >= i0 .and. n <= i9) then
        idig = idig + 1
        c1 = c1 * 1.d1 + n - i0
      else if (n == ineg .or. n == ipos .or. n == ispc) then
        if (n == ineg) then
          sign = .false.
        end if
      else
        go to 1000
      end if
    end do
!
!     DETERMINE THE CONTRIBUTION TO THE NUMBER LESS THAN THAN ONE
1100 deciml = 1.d0
    do j = i + 1, l
      n = Ichar (string(j:j))
      if (n >= i0 .and. n <= i9) then
        deciml = deciml / 1.d1
        c2 = c2 + (n-i0) * deciml
      else if (n /= ispc) then
        exit
      end if
    end do
    go to 1200
1000 if (n == idot) go to 1100
!
!     PUT THE PIECES TOGETHER
1200 digit = c1 + c2
    if ( .not. sign) then
      digit = -digit
    end if
end function digit
subroutine dihed (xyz, i, j, k, l, angle)
    implicit none
    double precision, dimension (3,*), intent (in) :: xyz
    integer, intent (in) :: i, j, k, l
    double precision, intent (out) :: angle
    double precision :: cosa, cosph, costh, ddd, dist, sinph, sinth, xi1, xi2, &
   & xj1, xl1, xl2, yi1, yi2, yi3, yj1, yj2, yl1, yl2, yl3, yxdist, zi1, zj1, &
   & zl1
!********************************************************************
!
!      DIHED CALCULATES THE DIHEDRAL ANGLE BETWEEN ATOMS I, J, K,
!            AND L.  THE CARTESIAN COORDINATES OF THESE ATOMS
!            ARE IN ARRAY XYZ.
!
!     DIHED IS A MODIFIED VERSION OF A SUBROUTINE OF THE SAME NAME
!           WHICH WAS WRITTEN BY DR. W. THEIL IN 1973.
!
!********************************************************************
    xi1 = xyz(1, i) - xyz(1, k)
    xj1 = xyz(1, j) - xyz(1, k)
    xl1 = xyz(1, l) - xyz(1, k)
    yi1 = xyz(2, i) - xyz(2, k)
    yj1 = xyz(2, j) - xyz(2, k)
    yl1 = xyz(2, l) - xyz(2, k)
    zi1 = xyz(3, i) - xyz(3, k)
    zj1 = xyz(3, j) - xyz(3, k)
    zl1 = xyz(3, l) - xyz(3, k)
!      ROTATE AROUND Z AXIS TO PUT KJ ALONG Y AXIS
    dist = Sqrt (xj1**2+yj1**2+zj1**2)
    cosa = zj1 / dist
    if (cosa > 1.0d0) then
      cosa = 1.0d0
    end if
    if (cosa <-1.0d0) then
      cosa = -1.0d0
    end if
    ddd = 1.0d0 - cosa**2
    if (ddd > 0.0) then
      yxdist = dist * Sqrt (ddd)
      if (yxdist > 1.0d-6) then
        cosph = yj1 / yxdist
        sinph = xj1 / yxdist
        xi2 = xi1 * cosph - yi1 * sinph
        xl2 = xl1 * cosph - yl1 * sinph
        yi2 = xi1 * sinph + yi1 * cosph
        yj2 = xj1 * sinph + yj1 * cosph
        yl2 = xl1 * sinph + yl1 * cosph
!      ROTATE KJ AROUND THE X AXIS SO KJ LIES ALONG THE Z AXIS
        costh = cosa
        sinth = yj2 / dist
        go to 1000
      end if
    end if
    xi2 = xi1
    xl2 = xl1
    yi2 = yi1
    yl2 = yl1
    costh = cosa
    sinth = 0.d0
1000 yi3 = yi2 * costh - zi1 * sinth
    yl3 = yl2 * costh - zl1 * sinth
    call dang (xl2, yl3, xi2, yi3, angle)
    if (angle < 0.) then
      angle = 4.0d0 * Asin (1.0d00) + angle
    end if
    if (angle >= 6.2831853d0) then
      angle = 0.d0
    end if
end subroutine dihed
subroutine getdat
!
!
!
!
    use common_systm, only : jobnam_c, ifiles_1, ir, iw, path
    use common_jobnam, only : jobnam
!
!.. Implicit Declarations ..
    implicit none
!
!.. Local Scalars ..
    character (len=240) :: line
    logical :: exists
    integer, save :: i = 0, j
!
!
! ... Executable Statements ...
!
!
!   IFILES(1)=1 IS USED AS A FLAG TO INDICATE NORMAL PRINTING
!   IFILES(1)=0 WILL REDUCE THE AMOUNT OF OUTPUT
!
    ifiles_1 = 1



    ir = 25
    iw = 26
#ifdef MOPAC_F2003
    i = command_argument_count()
#else
    i = iargc()
#endif
    if (i == 0) then
      write(*,"(a)")"                        Program MAKPOL"
      write(*,"(a)")" "
      write(*,"(a)")"  MAKPOL constructs a MOPAC data set for a polymer, layer system, or solid."
      write(*,"(a)")"  It uses either a MOPAC-type data set that contains information about "
      write(*,"(a)")"  the size of the cluster to be built or a raw "".pdb"" or "".ent"" file.  "
      write(*,"(a)")"  For a description of MAKPOL, see:"
      write(*,"(a)")" "
      write(*,"(a)")" http://www.OpenMOPAC.net/Manual/makpol.html"
      write(*,"(a)")"  "
      write(0,'(10x,a)')" Press (return) to continue"
      read(5,*, iostat=i)
      stop
    end if
    if (i > 1) then
      write(*,'(//10x,a,/)') "Makpol only uses one argument, more than one was supplied"
      stop
    end if
#ifdef MOPAC_F2003
    call get_command_argument (1, jobnam)
#else
    call getarg (1, jobnam)
#endif
    write(*,*)trim(jobnam)
!
! allow for up to 3 commas in data set file name
!
    if (i >= 2) then
#ifdef MOPAC_F2003
      call get_command_argument (2, jobnam_c)
#else
      call getarg (2, jobnam_c)
#endif
      j = len_trim(jobnam)
      if (jobnam(j:j) == ",") jobnam(j:j) = " "
      jobnam=trim(jobnam)//","//jobnam_c
    end if
    if (i >= 3) then
#ifdef MOPAC_F2003
      call get_command_argument (3, jobnam_c)
#else
      call getarg (3, jobnam_c)
#endif
      jobnam=trim(jobnam)//","//jobnam_c
    end if
    if (i == 4) then
#ifdef MOPAC_F2003
      call get_command_argument (4, jobnam_c)
#else
      call getarg (4, jobnam_c)
#endif
      jobnam=trim(jobnam)//","//jobnam_c
    end if
!
! Split jobnam into the path and the job-name
!
    do j = len_trim(jobnam), 1, -1
      if (jobnam(j:j) == "/" .or. jobnam(j:j) == "\") exit
    end do
    if (j > 0) then
      path = jobnam(:j)
      jobnam = jobnam(j + 1:)
    else
      path = " "
    end if
    
    
    jobnam_c = jobnam
    call upcase(jobnam_c,len_trim(jobnam_c))
!
! See if the explicit file already exists  The explicit file must be of form
!   name.nnn
!
    line = jobnam_c
    if (jobnam_c(:5) == "MAKE_") jobnam = jobnam(6:)
    i = len_trim(jobnam) - 3
    if (i > 1) then
      if (jobnam(i:i) == ".") jobnam = jobnam(:i - 1)
    end if
!
!  At this point,
!  the complete name, in upper case, is in jobnam_c, and
!  the file-name, in the original case is in jobnam
!
!  First, check to see if the file, as defined in the filename, actually exists.
!
    exists = .false.
    i = len_trim(jobnam_c) - 3
    if (i > 1) then
      if (jobnam_c(i:i) == ".") then
         jobnam_c = trim(path)//trim(jobnam_c)
         inquire (file = trim(jobnam_c), exist = exists)       
      end if
    end if
    if (.not. exists) then
      line = jobnam
      call upcase(line, len_trim(line))
!
! Hunt for an appropriate file
!
!  Possible file names are:
!
!     MAKE_filename.dat
!          filename.mop
!     MAKE_fimename.mop
!          filename.ent
!

      jobnam_c = trim(path)//trim(line)//".dat"
      inquire (file = trim(jobnam_c), exist = exists)
      if (.not. exists) then
        jobnam_c = trim(path)//"MAKE_"//trim(line)//".dat"
        inquire (file = trim(jobnam_c), exist = exists)
      end if
      if (.not. exists) then
        jobnam_c = trim(path)//trim(line)//".mop"
        inquire (file = trim(jobnam_c), exist = exists)
      end if
      if (.not. exists) then
        jobnam_c = trim(path)//trim(line)//".mop"
        inquire (file = trim(jobnam_c), exist = exists)
      end if
      if (.not. exists) then
        jobnam_c = trim(path)//"MAKE_"//trim(line)//".mop"
        inquire (file = trim(jobnam_c), exist = exists)
      end if
      if (.not. exists) then
        jobnam_c = trim(path)//trim(line)//".ENT"
        inquire (file = trim(jobnam_c), exist = exists)
      end if
    end if
!
    open (unit=5, file=jobnam_c, status="OLD",iostat=i)
    if (i /= 0) then
      write(*,*)
      if ( .not. exists) then
        write(*,'(a)')"    No files of the type: '"//trim(jobnam)//"' were found."
      else
        write(*,'(a)')"    File: '"//trim(jobnam_c)//"' exists, but cannot be opened!"
      end if
      write(*,'(/3x,a)')" Press return to exit"
      read(5,'(a)') jobnam_c
      stop
    end if
    close (ir)
    rewind (5)
    line = trim(jobnam)
    call add_path(line)
    open (unit=ir, file=trim(line)//".temp_makpol")
    rewind (ir)
    i = 0
    do
      read (5, "(A)", end=1000, err=1000) line
      i = i + 1
      if (line(1:1) /= "*") then
        write (ir, "(A)") trim(line)
      end if
    end do
1000  write (ir, "(A)") " "
    rewind (ir)
    line = jobnam
!    do i = 1, len_trim(line)
!        if (line(i:i) == "_") line(i:i) = " "
!    end do
    if (i == 1) then
      write (iw, "(A)") " INPUT FILE MISSING OR EMPTY"
    else
      close (5)
      open (5, status="SCRATCH", form="UNFORMATTED")
    end if
    open (unit=iw, file=trim(path)//trim(line)//".mop", iostat = i)
    rewind (ir)
end subroutine getdat
subroutine getgeo (iread, labels, geo, xyz, lopt, na, nb, nc)
    use common_systm
    use common_keywrd
    use common_atomtx
    use common_sizes
    implicit none
!***********************************************************************
!
!   GETGEO READS IN THE GEOMETRY. THE ELEMENT IS SPECIFIED BY IT'S
!          CHEMICAL SYMBOL, OR, OPTIONALLY, BY IT'S ATOMIC NUMBER.
!
!  ON INPUT   IREAD  = CHANNEL NUMBER FOR READ, NORMALLY 5
!             AMS    = DEFAULT ATOMIC MASSES.
!
!  WORKING    LINT = Coordinates should be INTERNAL
!             LXYZ = Coordinates should be CARTESIAN
!             (If .NOT.LINT and .NOT.LXYZ, use coordinates supplied)
!
! ON OUTPUT LABELS = ATOMIC NUMBERS OF ALL ATOMS, INCLUDING DUMMIES.
!           GEO    = INTERNAL COORDINATES, IN ANGSTROMS, AND DEGREES.
!                    OR CARTESIAN COORDINATES, DEPENDING ON WHETHER
!                    KEYWORD ' XYZ' IS PRESENT
!           LOPT   = INTEGER ARRAY, A '1' MEANS OPTIMIZE THIS PARAMETER,
!                    '0' MEANS DO NOT OPTIMIZE, AND A '-1' LABELS THE
!                    REACTION COORDINATE.
!           NA     = INTEGER ARRAY OF ATOMS (SEE DATA INPUT)
!           NB     = INTEGER ARRAY OF ATOMS (SEE DATA INPUT)
!           NC     = INTEGER ARRAY OF ATOMS (SEE DATA INPUT)
!           ATMASS = ATOMIC MASSES OF ATOMS.
!***********************************************************************
    integer, intent (in) :: iread
    integer, dimension (numatm), intent (out) :: labels, na, nb, nc
    integer, dimension (3, numatm), intent (out) :: lopt
    double precision, dimension (3, numatm), intent (out) :: geo, xyz
    character, save :: nine = "9", space = " "
    character, save :: comma = ",", zero = "0"
    character :: turn
    character (len=2) :: ele
    character (len=120) :: string
    logical :: ircdrc, leadsp, lint, lmop, lxyz, velo
    integer :: i, icapa, icapz, icomma, iserr, j, k, khar, l, &
   & label, ndmy, nvalue, nvar_loc
    double precision :: const, degree,  real, sum, x1, x2, x3
    character (len=2), dimension (107), save :: elemnt
    integer, dimension (40) :: istart
    double precision, external :: reada
    data (elemnt(i), i=1, 107) / "H", "HE", "LI", "BE", "B", "C", "N", "O", &
         &"F", "NE", "NA", "MG", "AL", "SI", "P", "S", "CL", "AR", "K", &
         &"CA", "SC", "TI", "V", "CR", "MN", "FE", "CO", "NI", "CU", "ZN", &
         &"GA", "GE", "AS", "SE", "BR", "KR", "RB", "SR", "Y", "ZR", "NB", &
         &"MO", "TC", "RU", "RH", "PD", "AG", "CD", "IN", "SN", "SB", "TE", &
         &"I", "XE", "CS", "BA", "LA", "CE", "PR", "ND", "PM", "SM", "EU", &
         &"GD", "TB", "DY", "HO", "ER", "TM", "YB", "LU", "HF", "TA", "W", &
         &"RE", "OS", "IR", "PT", "AU", "HG", "TL", "PB", "BI", "PO", "AT", &
         &"RN", "FR", "RA", "AC", "TH", "PA", "U", "NP", "PU", "AM", "CM", "&
         &BK", "CF", "XX", "FM", "MD", "CB", "++", "+", "--", "-", "TV" /
    ircdrc = (Index (keywrd, "IRC")+Index (keywrd, "DRC") /= 0)
    lmop = (Index (keywrd, " MOPAC") /= 0)
    icapa = Ichar ("A")
    icapz = Ichar ("Z")
    maxtxt = 0
    natoms = 0
    numat = 0
    iserr = 0
    do
!
      line = " "
        read (ir, "(A)", end=1000, err=1000) line
        go to 1100
1000    line = " "
1100  continue
!
!
      if (line == " ") go to 1400
      string = line(:6)
      if (index(string,"ATOM  ") + index(string,"HETATM") + index(string,"TITLE ") + index(string,"HEADER") + &
                                  index(string,"COMPND") + index(string,"SOURCE") + index(string,"KEYWDS") + &
          index(string,"HELIX ") + index(string,"SHEET ") + index(string,"REMARK") + index(string,"USER  ") + &
          index(string,"EXPDTA") + index(string,"AUTHOR") + index(string,"REVDAT") + index(string,"JRNL  ") + &
          index(string,"DBREF ") + index(string,"SEQRES") + index(string,"HET   ") + index(string,"HETNAM") + &
          index(string,"LINK  ") + index(string,"CRYST1") + index(string,"SCALE" ) + index(string,"ORIGX" ) + &
          index(string,"FORMUL") + index(string,"SEQRES") + index(string,"CONECT") /= 0) then
        natoms = -2
        return
      end if
      natoms = natoms + 1
!
!   SEE IF TEXT IS ASSOCIATED WITH THIS ELEMENT
!
      i = Index (line, "(")
      if (i /= 0) then
!
!  YES, ELEMENT IS LABELLED.
!
        k = Index (line, ")")
        txtatm(natoms) = line(i+1:k-1)
        maxtxt = Min (13, Max (maxtxt, k-i-1))
        string = line(1:i-1) // line(k+1:)
        line = string
      else
        txtatm (natoms) = " "
      end if
!   CLEAN THE INPUT DATA
      call upcase (line, 80)
      icomma = Ichar (comma)
      do i = 1, 80
        khar = Ichar (line(i:i))
        if (khar == icomma) then
          line(i:i) = space
        end if
      end do
!
!   INITIALIZE ISTART TO INTERPRET BLANKS AS ZERO'S
      do i = 1, 10
        istart(i) = 80
      end do
!
! FIND INITIAL DIGIT OF ALL NUMBERS, CHECK FOR LEADING SPACES FOLLOWED
!     BY A CHARACTER AND STORE IN ISTART
      leadsp = .true.
      nvalue = 0
      do i = 1, 80
        if (leadsp .and. line(i:i) /= space) then
          nvalue = nvalue + 1
          istart(nvalue) = i
        end if
        leadsp = (line(i:i) == space)
      end do
!
!  If optimization flags not present, adjust istart to suit
!
      if (nvalue == 4) then
        istart(6) = istart(4)
        istart(4) = istart(3)
        istart(3) = 1        
      end if
!
! ESTABLISH THE ELEMENT'S NAME AND ISOTOPE, CHECK FOR ERRORS OR E.O.DATA
!
      string = line(istart(1) :istart(2)-1)
      if (string(1:1) >= zero .and. string(1:1) <= nine) then
!  ATOMIC NUMBER USED: NO ISOTOPE ALLOWED
        label = Nint (reada (string, 1))
        if (label == 0) then
!***********************************************************************
! ALL DATA READ IN, CLEAN UP AND RETURN
!***********************************************************************
          natoms = natoms - 1
          go to 1400
        else if (label < 0 .or. label > 107) then
          write (iw, "('  ILLEGAL ATOMIC NUMBER')")
          go to 1600
        end if
      else
!  ATOMIC SYMBOL USED
        real = Abs (reada (string, 1))
        if (real < 1.d-15) then
!   NO ISOTOPE
          ele = string(1:2)
        else
          if (string(2:2) >= zero .and. string(2:2) <= nine) then
            ele = string(1:1)
          else
            ele = string(1:2)
          end if
        end if
!   CHECK FOR ERROR IN ATOMIC SYMBOL
        if (ele(1:1) == "-" .and. ele(2:2) /= "-") then
          ele (2:2) = " "
        end if
        do i = 1, 107
          if (ele == elemnt(i)) go to 1200
        end do
        if (ele(1:1) == "X") then
          label = 99
          go to 1300
        else
          write (iw, "('  UNRECOGNIZED ELEMENT NAME: (',A,')')") ele
          go to 1600
        end if
1200    label = i
      end if
!
! ALL O.K.
!
1300  if (label /= 99) then
        numat = numat + 1
      end if
      if (natoms > numatm) then
        write (iw, "(//10X,'**** MAX. NUMBER OF ATOMS ALLOWED:' ,I4)") numatm
        return
      end if
      labels(natoms) = label
      geo(1, natoms) = reada (line, istart(2))
      geo(2, natoms) = reada (line, istart(4))
      geo(3, natoms) = reada (line, istart(6))
      if (ircdrc) then
        turn = line(istart(3) :istart(3))
        if (turn == "T") then
          lopt(1, natoms) = 1
          if (natoms == 1) then
            write (iw, "(A)") " IN DRC MONITOR" &
                 &// " POTENTIAL ENERGY TURNING POINTS"
          end if
        else
          lopt(1, natoms) = 0
        end if
        turn = line(istart(5) :istart(5))
        if (turn == "T") then
          lopt(2, natoms) = 1
        else
          lopt(2, natoms) = 0
        end if
        turn = line(istart(7) :istart(7))
        if (turn == "T") then
          lopt(3, natoms) = 1
        else
          lopt(3, natoms) = 0
        end if
      else
       if(istart(3) /= 1) then
          lopt(1, natoms) = Nint (reada (line, istart(3)))
          lopt(2, natoms) = Nint (reada (line, istart(5)))
          lopt(3, natoms) = Nint (reada (line, istart(7)))
          do i = 3, 7, 2
            if (Ichar (line(istart(i) :istart(i))) >= icapa .and. &
         & Ichar (line(istart(i) :istart(i))) <= icapz .and. natoms > 1) then
              iserr = 1
            end if
          end do
        else
          lopt(1, natoms) = 1
          lopt(2, natoms) = 1
          lopt(3, natoms) = 1        
        end if
      end if
      sum = reada (line, istart(8))
      if (sum > 1.d7) then
        write (iw, "(A,I5,A)") " THE CONNECTIVITY OF ATOM", natoms, " IS FAULTY"
        return
      end if
!
!  If number is not an integer, then zero it out.  This
!  prevents an atomic charge being confused for a connectivity
!
      if (Abs (sum-Nint (sum)) > 1.d-5) then
        sum = 0.d0
      end if
      na(natoms) = Nint (sum)
      sum = reada (line, istart(9))
      if (Abs (sum-Nint (sum)) > 1.d-5) then
        sum = 0.d0
      end if
      nb(natoms) = Nint (sum)
      sum = reada (line, istart(10))
      if (Abs (sum-Nint (sum)) > 1.d-5) then
        sum = 0.d0
      end if
      nc(natoms) = Nint (sum)
      
!
!  SPECIAL CASE OF USERS FORGETTING TO ADD DIHEDRAL DATA FOR ATOM 3
!
      if (lmop .and. natoms == 3) then
        if (lopt(3, 3) == 2) then
          na(3) = 1
          nb(3) = 2
          geo(3, 3) = 0.d0
          lopt(3, 3) = 0
        else if (lopt(3, 3) == 1 .and. Abs (geo(3, 3)-2.d0) < 1.d-4) then
          na(3) = 2
          nb(3) = 1
          geo(3, 3) = 0.d0
          lopt(3, 3) = 0
        end if
      end if
      if ((lopt(1, natoms) > 1 .or. lopt(2, natoms) > 1 &
           &.or. lopt(3, natoms) > 1) .and. natoms > 1) then
        iserr = 1
      end if
      if (iserr == 1) exit
    end do
!  CHECK TO SEE IF GEOMETRY IS IN PDB FORMAT
!
    if (Index (line, "ATOM")+Index (line, "HETATM") /= 0) then
      natoms = -2
      return
    end if
!
!  MUST BE GAUSSIAN GEOMETRY INPUT
!
    do i = 2, natoms
      do k = 1, 3
        j = Nint (geo(k, i))
        if (Abs (geo(k, i)-j) > 1.d-5) then
!
!   GEOMETRY CANNOT BE GAUSSIAN
!
          return
        end if
      end do
    end do
    natoms = -1
    return
1400 lint = .false.
    lxyz = (index(keywrd, " XYZ") > 0 )
!
!   If MOPAC, set connectivity of atoms 2 and 3
!
1600 if (lmop) then
      na(2) = 1
      if (na(3) == 0) then
        na(3) = 2
        nb(3) = 1
      end if
    end if
!
!  Convert to radians, if in internal coordinates
!
    const = 1.7453292519943d-02
    do l = 1, natoms
      if (na(l) /= 0) then
        geo(2, l) = geo(2, l) * const
        geo(3, l) = geo(3, l) * const
      end if
    end do
!
!   Check that connectivity is O.K.
!
    do i = 4, natoms
      if (na(i) /= 0) then
        j = 0
        if (nb(i) < 1 .or. nc(i) < 1) then
          j = 1
        end if
        if (na(i) >= i .or. nb(i) >= i .or. nc(i) >= i) then
          j = 1
        end if
        if (na(i) == nb(i) .or. nb(i) == nc(i) .or. na(i) == nc(i)) then
          j = 1
        end if
        if (j /= 0) then
!       write (iw, "(A,I5,A,3I5,A)") " Connectivity of atom", i, " (", &
!          &na(i), nb(i), nc(i), ") is faulty"
        end if
      end if
    end do
    na1 = 0
    if (lxyz) then
!
!    COORDINATES SHOULD BE CARTESIAN
!
!
!  Coordinates are internal,  therefore switch.
!
      if (natoms == 0) then
        return
      end if
      call gmetrn (geo, xyz, labels, na, nb, nc)
!
!  Get rid of dummy atoms
!
      numat = 0
      do i = 1, natoms
        if (labels(i) /= 99) then
          numat = numat + 1
          labels(numat) = labels(i)        
          do j = 1, 3
            geo(j, numat) = xyz(j, i)
          end do
        end if
      end do
      natoms = numat
      na(1:numat) = 0
      na1 = 99
    else if (lint) then
      call gmetrn (geo, xyz, labels, na, nb, nc)
!
!   Check that no two atoms have the same coordinates
!
      do i = 2, numat
        x1 = xyz(1, i)
        x2 = xyz(2, i)
        x3 = xyz(3, i)
        do j = 1, i - 1
          if (Abs (x1-xyz(1, j)) <= 1.d-5) then
            if (Abs (x2-xyz(2, j)) <= 1.d-5) then
              if (Abs (x3-xyz(3, j)) <= 1.d-5) then
!
!   ATOMS I AND J ARE COINCIDENT.  THIS IS A BUG.
!
                write (iw,*)
                write (iw, "(A,I5,A,I5,A,/,A,3F9.4)") "  Atoms", i, " and", j, &
               & " have the same ", "  Cartesian coordinates:", x1, x2, x3
              end if
            end if
          end if
        end do
      end do
!
!   Remove dummy atoms, if any
!
      k = 0
      l = 0
      numat = 0
      nvar_loc = 0
      do i = 1, natoms
        na(i) = 0
        do j = 1, 3
          if (lopt(j, i) == 1) then
            nvar_loc = nvar_loc + 1
          end if
        end do
        if (labels(i) /= 99 .and. labels(i) /= 107) then
          k = k + 1
        end if
        if (labels(i) /= 99) then
          l = l + 1
          labels(l) = labels(i)
          txtatm(l) = txtatm(i)
        end if
      end do
      natoms = l
      numat = k
      do i = 1, natoms
        if (labels(i) == 107) then
!
!  ONLY NEED ONE WARNING.  TV CANNOT OCCUR WITH PDB FILES
!
          write (iw,*)
          write (iw,*) " SYSTEMS WITH TV CANNOT BE RUN WITH 'INT."
        end if
      end do
!
!    COORDINATES SHOULD BE INTERNAL.
!
      degree = 1.d0
      call xyzint (xyz, na, nb, nc, degree, geo)
!
!  UNCONDITIONALLY SET FLAGS FOR INTERNAL COORDINATES
!
      do i = 1, 3
        do j = i, 3
          lopt(j, i) = 0
        end do
      end do
      if (Abs (geo(2, 3)-180.d0) < 1.d-4 .or. Abs (geo(2, 3)) < 1.d-4) then
        write (iw, "(A)") " DUE TO PROGRAM BUG, THE FIRST THREE " &
             &// "ATOMS MUST NOT LIE IN A STRAIGHT LINE."
      end if
    end if
    lint = (lint .or. lxyz)
end subroutine getgeo
subroutine gmetrn (geo, coord, labels, na, nb, nc)
    use common_systm, only : natoms, na1, iw, id
    use common_ctvec, only : tvec
    implicit none
    integer, dimension (natoms), intent (inout) :: labels, na, nb
    integer, dimension (natoms), intent (inout) :: nc
    double precision, dimension (3, natoms), intent (inout) :: coord
    double precision, dimension (3, natoms), intent (in) :: geo
    integer :: i, j, k, l, ma, mb, mc
    double precision :: ccos, cosa, cosd, coskh, cosph, costh, rbc, &
   & sina, sind, sinkh, sinph, sinth, xa, xb, xd, xpa, xpb, xpd, xqd, &
   & xrd, xyb, ya, yb, yd, ypa, ypd, yqd, yza, za, zb, zd, zpd, zqa, zqd
!***********************************************************************
!
!    GMETRY  COMPUTES COORDINATES FROM BOND-ANGLES AND LENGTHS.
!***IT IS ADAPTED FROM THE PROGRAM WRITTEN BY M.J.S. DEWAR.
!
!     THREE SEPARATE OPTIONS EXIST WITHIN GMETRY. THESE ARE:
!    (A) IF NA1 IS EQUAL TO 99 (IMPOSSIBLE UNDER NORMAL CIRCUMSTANCES)
!        THEN GEO IS ASSUMED TO BE IN CARTESIAN RATHER THAN INTERNAL
!        COORDINATES, AND COORD IS THEN SET EQUAL TO GEO.
!    (B) IF STEP IS NON-ZERO (THIS IS THE CASE WHEN "SADDLE" IS USED)
!        THEN GEO IS FIRST MODIFIED BY SHIFTING THE INTERNAL COORDINATES
!        ALONG A RADIUS FROM GEOA TO PLACE GEO AT A DISTANCE STEP FROM
!        GEOA.
!    (C) NORMAL CONVERSION FROM INTERNAL TO CARTESIAN COORDINATES
!        IS DONE.
!
!  ON INPUT:
!         GEO    = ARRAY OF INTERNAL COORDINATES.
!         NATOMS = NUMBER OF ATOMS, INCLUDING DUMMIES.
!         NA     = ARRAY OF ATOM LABELS FOR BOND LENGTHS.
!
!  ON OUTPUT:
!         COORD  = ARRAY OF CARTESIAN COORDINATES
!
!***********************************************************************
!                                     OPTION (B)
    
  
!                                     OPTION (A)
    if (na1 == 99) then
      do i = 1, 3
!    USE NATOMS INSTEAD OF NUMAT BECAUSE OF TV
!$DOIT VBEST
        do j = 1, natoms
          coord(i, j) = geo(i, j)
        end do
!    USE NATOMS INSTEAD OF NUMAT BECAUSE OF TV
!$DOIT VBEST
      end do
    else
!                                     OPTION (C)
      do i = 1, Min (3, natoms)
        do j = 1, 3
          coord(j, i) = geo(j, i)
        end do
      end do
      if (natoms > 1) then
        if (na(2) == 1) then
          coord(1, 2) = coord(1, 1) + geo(1, 2)
          coord(2, 2) = coord(2, 1)
          coord(3, 2) = coord(3, 1)
        end if
        if (natoms /= 2) then
          ccos = Cos (geo(2, 3))
          if (na(3) == 1) then
            coord(1, 3) = coord(1, 1) + geo(1, 3) * ccos
            coord(2, 3) = coord(2, 1) + geo(1, 3) * Sin (geo(2, 3))
            coord(3, 3) = coord(3, 1)
          else if (na(3) == 2) then
            coord(1, 3) = coord(1, 2) - geo(1, 3) * ccos
            coord(2, 3) = coord(2, 2) + geo(1, 3) * Sin (geo(2, 3))
            coord(3, 3) = coord(3, 2)
          else
            coord(1, 3) = geo(1, 3)
            coord(2, 3) = geo(2, 3)
            coord(3, 3) = geo(3, 3)
          end if
          do i = 4, natoms
            mc = na(i)
            if (mc /= 0) then
              cosa = Cos (geo(2, i))
              mb = nb(i)
              xb = coord(1, mb) - coord(1, mc)
              yb = coord(2, mb) - coord(2, mc)
              zb = coord(3, mb) - coord(3, mc)
              rbc = xb * xb + yb * yb + zb * zb
              if (rbc < 1.d-16) then
!
!     TWO ATOMS ARE COINCIDENT.  A FATAL ERROR.
!
                write (iw, "(A,I4,A,I4,A)") " ATOMS", mb, " AND", mc, &
                     &" ARE COINCIDENT"
                write (iw, "(A)") " THIS IS A FATAL ERROR, RUN " &
                     &// "STOPPED IN GMETRY"
              else
                rbc = 1.0d00 / Sqrt (rbc)
              end if
              do
                ma = nc(i)
                xa = coord(1, ma) - coord(1, mc)
                ya = coord(2, ma) - coord(2, mc)
                za = coord(3, ma) - coord(3, mc)
!
!     ROTATE ABOUT THE Z-AXIS TO MAKE YB=0, AND XB POSITIVE.  IF XYB IS
!     TOO SMALL, FIRST ROTATE THE Y-AXIS BY 90 DEGREES.
!
                xyb = Sqrt (xb*xb+yb*yb)
                k = -1
                if (xyb <= 0.1d00) then
                  xpa = za
                  za = -xa
                  xa = xpa
                  xpb = zb
                  zb = -xb
                  xb = xpb
                  xyb = Sqrt (xb*xb+yb*yb)
                  k = + 1
                end if
!
!     ROTATE ABOUT THE Y-AXIS TO MAKE ZB VANISH
!
                costh = xb / xyb
                sinth = yb / xyb
                xpa = xa * costh + ya * sinth
                ypa = ya * costh - xa * sinth
                sinph = zb * rbc
                cosph = Sqrt (Abs (1.d00-sinph*sinph))
                zqa = za * cosph - xpa * sinph
!
!     ROTATE ABOUT THE X-AXIS TO MAKE ZA=0, AND YA POSITIVE.
!
                yza = Sqrt (ypa**2+zqa**2)
                if (yza < 1.d-4) then
!
!   ANGLE TOO SMALL TO BE IMPORTANT
!
                  coskh = 1.d0
                  sinkh = 0.d0
                  go to 1000
                else
                  if (Abs (cosa) >= 0.9998d0) exit
                  if (yza >= 2.d-3) exit
!
!   Faulty atom: I; Bond lendth to I: NA(I); Angle to I: NB(I)
!
!   Set a new NC(I) and re-try
!
                  j = nc(i)
                  call renum (coord, na, nb, nc, i, natoms)
                  if (nc(i) == 0 .or. nc(i) == j) then
                    go to 1100
                  end if
                end if
              end do
              coskh = ypa / yza
              sinkh = zqa / yza
!
!     COORDINATES :-   A=(???,YZA,0),   B=(RBC,0,0),  C=(0,0,0)
!     NONE ARE NEGATIVE.
!     THE COORDINATES OF I ARE EVALUATED IN THE NEW FRAME.
!
1000          sina = Sin (geo(2, i))
              sind = -Sin (geo(3, i))
              cosd = Cos (geo(3, i))
              xd = geo(1, i) * cosa
              yd = geo(1, i) * sina * cosd
              zd = geo(1, i) * sina * sind
!
!     TRANSFORM THE COORDINATES BACK TO THE ORIGINAL SYSTEM.
!
              ypd = yd * coskh - zd * sinkh
              zpd = zd * coskh + yd * sinkh
              xpd = xd * cosph - zpd * sinph
              zqd = zpd * cosph + xd * sinph
              xqd = xpd * costh - ypd * sinth
              yqd = ypd * costh + xpd * sinth
              if (k >= 1) then
                xrd = -zqd
                zqd = xqd
                xqd = xrd
              end if
              coord(1, i) = xqd + coord(1, mc)
              coord(2, i) = yqd + coord(2, mc)
              coord(3, i) = zqd + coord(3, mc)
            else
              coord(1, i) = geo(1, i)
              coord(2, i) = geo(2, i)
              coord(3, i) = geo(3, i)
            end if
          end do
          go to 1200
1100      write (iw, "(//20x,' CALCULATION ABANDONED AT THIS POINT')")
          if (nc(i) == 0) then
            write (iw, "(//10x,' THREE ATOMS BEING USED TO ','DEFINE THE',&
                 &/10x,' COORDINATES OF A FOURTH ATOM, WHOSE BOND-ANGLE IS')")
            write (iw, "(10X,' NOT ZERO OR 180 DEGREES, ARE ,'&
                 &'IN AN ALMOST STRAIGHT')")
            write (iw, "(10x,' LINE.  THERE IS A HIGH PROBABILITY THAT THE',&
                 &/10x,' COORDINATES OF THE ATOM WILL BE INCORRECT.')")
            write (iw, "(//20x,'THE FAULTY ATOM IS ATOM NUMBER',i6)") i
          else
            write (iw,*) " The Cartesian geometry has become unreasonable"
          end if
            if (nc(i) == 0) then
            write (iw, "(//20X, 'CARTESIAN COORDINATES UP TO FAULTY ATOM')")
            write (iw, "(//5X,'I',12X,'X',12X,'Y',12X,' Z')")
            do j = 1, i
              write (iw, "(I6,F16.5,2F13.5)") j, (coord(k, j), k=1, 3)
            end do
            write (iw, "(//6x,' ATOMS',i3,',',i3,', AND',i3,' ARE WITHIN',&
                 &f7.4,' ANGSTROMS OF A STRAIGHT LINE')") mc, mb, ma, yza
          end if
          return
        end if
      end if
    end if
!
!***NOW REMOVE THE TRANSLATION VECTORS, IF ANY, FROM THE ARRAY COOR
!
1200 Continue
!    if (labels(natoms) == 98) then
!      write(iw,*) " The last atom must NOT be a dummy atom"
!      stop
!    end if
    l = 0
    do k = 1, natoms
      if (labels(k) == 107) then
        l = l + 1
        tvec(1, l) = coord(1, k)
        tvec(2, l) = coord(2, k)
        tvec(3, l) = coord(3, k)
        labels(k) = 98
      end if
    end do
    id = l
    j = 0
    do i = 1, natoms
      if (labels(i) /= 98) then
        j = j + 1
!$DOIT ASIS
        do k = 1, 3
          coord(k, j) = coord(k, i)
        end do
        labels(j) = labels(i)
      end if
    end do
    natoms = j
end subroutine gmetrn
    subroutine renum (coord, na, nb, nc, ii, natoms)
        implicit none
        integer, intent (in) :: ii, natoms
        integer, dimension (natoms), intent (in) :: na, nb
        integer, dimension (natoms), intent (out) :: nc
        double precision, dimension (3, natoms), intent (in) :: coord
        integer :: i, jj, nai, nbi
        double precision :: angle, rab, rmin, theta
!***********************************************************************
!
!  Renumber the NC of atom II.  On input, the angle NA(II)-NB(II)-NC(II)
!  is too near to 0 or 180 degrees.  Find a new atom for NC(II), so that
!  the angle will be acceptable (as large as possible)
!***********************************************************************
        nai = na(ii)
        nbi = nb(ii)
!
!   Theta = 45 degrees
!
        theta = 0.7853d0
        jj = 0
        rmin = 1.d10
        do
          do i = 1, ii - 1
            if (i /= nai .and. i /= nbi) then
              call bangle (coord, nai, nbi, i, angle)
              if (angle > 1.5707963d0) then
                angle = 2.d0 * Asin (1.d0) - angle
              end if
              if (angle >= theta) then
!
!   Angle is OK.  Now find atom of lowest distance
!
                rab = (coord(1, nbi)-coord(1, i))**2 &
                     &+ (coord(2, nbi)-coord(2, i))**2 &
                     &+ (coord(3, nbi)-coord(3, i))**2
                if (rab < rmin) then
                  jj = i
                  rmin = rab
                end if
              end if
            end if
          end do
          if (jj /= 0) then
!
!  Best NC is JJ; best angle is THMIN
!
            nc(ii) = jj
            exit
          end if
!
!   No atom inside the allowed angle - reduce the angle
!
          theta = theta * 0.5d0
          if (theta < 0.0174533d0) then
            nc(ii) = 0
            exit
          end if
        end do
    end subroutine renum
    subroutine minv (a, n, d)
!
!.. Implicit Declarations ..
        implicit none
!
!.. Formal Arguments ..
        integer, intent (in) :: n
        double precision, dimension (n*n), intent (inout) :: a
        double precision, intent (out) :: d
!
!.. Local Scalars ..
        integer :: i, ij, ik, iz, j, ji, jk, jp, jq, jr, k, ki, kj, kk, nk
        double precision :: biga, hold
!
!.. Local Arrays ..
        integer, dimension (1000) :: l, m
!
!.. Intrinsic Functions ..
        intrinsic Abs, Max, Min
!
! ... Executable Statements ...
!
!
!     SEARCH FOR LARGEST ELEMENT
!
        d = 1.0d0
        nk = -n
        do k = 1, n
          nk = nk + n
          l(k) = k
          m(k) = k
          kk = nk + k
          biga = a(kk)
          do j = k, n
            iz = n * (j-1)
            do i = k, n
              ij = iz + i
              if (Abs (biga) < Abs (a(ij))) then
                biga = a(ij)
                l(k) = i
                m(k) = j
              end if
            end do
          end do
!
!     INTERCHANGE ROWS
!
          j = l(k)
          if (j > k) then
            ki = k - n
            do i = 1, n
              ki = ki + n
              hold = -a(ki)
              ji = ki - k + j
              a(ki) = a(ji)
              a(ji) = hold
            end do
          end if
!
!     INTERCHANGE COLUMNS
!
          i = m(k)
          if (i > k) then
            jp = n * (i-1)
            do j = 1, n
              jk = nk + j
              ji = jp + j
              hold = -a(jk)
              a(jk) = a(ji)
              a(ji) = hold
            end do
          end if
!
!     DIVIDE COLUMN BY MINUS PIVOT (VALUE OF PIVOT ELEMENT IS
!     CONTAINED IN BIGA)
!
          if (biga == 0.0d0) then
            d = 0.d0
            return
          end if
          do i = 1, n
            if (i /= k) then
              ik = nk + i
              a(ik) = a(ik) / (-biga)
            end if
          end do
!  REDUCE MATRIX
          do i = 1, n
            ik = nk + i
            hold = a(ik)
            ij = i - n
            do j = 1, n
              ij = ij + n
              if (i /= k .and. j /= k) then
                kj = ij - i + k
                a(ij) = hold * a(kj) + a(ij)
              end if
            end do
          end do
!
!     DIVIDE ROW BY PIVOT
!
          kj = k - n
          do j = 1, n
            kj = kj + n
            if (j /= k) then
              a(kj) = a(kj) / biga
            end if
          end do
!
!     PRODUCT OF PIVOTS
!
          d = Max (-1.d25, Min (1.d25, d))
          d = d * biga
!
!     REPLACE PIVOT BY RECIPROCAL
!
          a(kk) = 1.d0 / biga
        end do
!
!     FINAL ROW AND COLUMN INTERCHANGE
!
        k = n
        do
          k = (k-1)
          if (k <= 0) exit
          i = l(k)
          if (i > k) then
            jq = n * (k-1)
            jr = n * (i-1)
            do j = 1, n
              jk = jq + j
              hold = a(jk)
              ji = jr + j
              a(jk) = -a(ji)
              a(ji) = hold
            end do
          end if
          j = m(k)
          if (j > k) then
            ki = k - n
            do i = 1, n
              ki = ki + n
              hold = a(ki)
              ji = ki - k + j
              a(ki) = -a(ji)
              a(ji) = hold
            end do
          end if
        end do
    end subroutine minv
    subroutine nuChar (line, value, nvalue)
        implicit none
        character (len=80), intent (inout) :: line
        double precision, dimension (40), intent (out) :: value
        integer, intent (out) :: nvalue
        character, save :: comma = ",", space = " "
        character :: tab
        logical :: leadsp
        integer :: i
        integer, dimension (40) :: istart
        double precision, external :: reada
        tab = Char(9)
!
! CLEAN OUT TABS AND COMMAS
!
        do i = 1, 80
          if (line(i:i) == tab .or. line(i:i) == comma) then
            line(i:i) = space
          end if
        end do
!
! FIND INITIAL DIGIT OF ALL NUMBERS, CHECK FOR LEADING SPACES FOLLOWED
!     BY A CHARACTER
!
        leadsp = .true.
        nvalue = 0
        do i = 1, 80
          if (leadsp .and. line(i:i) /= space) then
            nvalue = nvalue + 1
            istart(nvalue) = i
          end if
          leadsp = (line(i:i) == space)
        end do
!
! FILL NUMBER ARRAY
!
        do i = 1, nvalue
          value(i) = reada (line, istart(i))
        end do
    end subroutine nuchar
    double precision function reada (string, istart)
!     FORTRAN FUNCTION TO EXTRACT NUMBER FROM STRING
!
        implicit none

        character (len=*), intent (in) :: string
        integer, intent (in) :: istart
        logical :: expnnt
        integer :: i, i0, i9, iadd, icapd, icape, idot, ineg, ipos, ismld, &
       & ismle, j, l, n
        double precision, external :: digit
!
!     DEFINE ASCII VALUES OF NUMERIC FIELD CHARACTERS
        i0 = Ichar ("0")
        i9 = Ichar ("9")
        idot = Ichar (".")
        ineg = Ichar ("-")
        ipos = Ichar ("+")
        icapd = Ichar ("D")
        icape = Ichar ("E")
        ismld = Ichar ("d")
        ismle = Ichar ("e")
!
        l = Len(string)
!
!     FIND THE START OF THE NUMERIC FIELD
        do i = istart, l
          iadd = 0
          n = Ichar (string(i:i))
!
!       SIGNAL START OF NUMERIC FIELD IF DIGIT FOUND
          if (n >= i0 .and. n <= i9) go to 1000
!
!       ACCOUNT FOR CONSECUTIVE SIGNS [- AND(OR) +]
          if (n == ineg .or. n == ipos) then
            iadd = iadd + 1
            if (i+iadd > l) exit
            n = Ichar (string(i+iadd:i+iadd))
            if (n >= i0 .and. n <= i9) go to 1000
          end if
!
!       ACCOUNT FOR CONSECUTIVE DECIMAL POINTS (.)
          if (n == idot) then
            iadd = iadd + 1
            if (i+iadd > l) exit
            n = Ichar (string(i+iadd:i+iadd))
            if (n >= i0 .and. n <= i9) go to 1000
          end if
        end do
!
!     DEFAULT VALUE RETURNED BECAUSE NO NUMERIC FIELD FOUND
        reada = 0.d0
        return
!
!     FIND THE END OF THE NUMERIC FIELD
1000    expnnt = .false.
        do j = i + 1, l
          iadd = 0
          n = Ichar (string(j:j))
!
!       CONTINUE SEARCH FOR END IF DIGIT FOUND
          if (n < i0 .or. n > i9) then
!
!       CONTINUE SEARCH FOR END IF SIGN FOUND AND EXPNNT TRUE
            if (n == ineg .or. n == ipos) then
              if ( .not. expnnt) go to 1100
              iadd = iadd + 1
              if (j+iadd > l) go to 1100
              n = Ichar (string(j+iadd:j+iadd))
              if (n >= i0 .and. n <= i9) cycle
            end if
            if (n == idot) then
              iadd = iadd + 1
              if (j+iadd > l) go to 1100
              n = Ichar (string(j+iadd:j+iadd))
              if (n >= i0 .and. n <= i9) then
                cycle
              else if (n == icape .or. n == ismle .or. n == icapd .or. n == &
             & ismld) then
                cycle
              end if
            end if
            if (n /= icape .and. n /= ismle .and. n /= icapd .and. n /= ismld) &
           & go to 1100
            if (expnnt) go to 1100
            expnnt = .true.
          end if
        end do
        j = l + 1
1100    n = Ichar (string(j-1:j-1))
        if (n == icape .or. n == ismle .or. n == icapd .or. n == ismld) then
          j = j - 1
        end if
!
!     FOUND THE END OF THE NUMERIC FIELD (IT RUNS 'I' THRU 'J-1')
        n = 0
        n = n + Index (string(i:j-1), "e")
        n = n + Index (string(i:j-1), "E")
        n = n + Index (string(i:j-1), "d")
        n = n + Index (string(i:j-1), "D")
        if (n == 0) then
          reada = digit (string(i:j-1), 1)
        else
          reada = digit (string(:i+n-2), i) * 1.d1**&
               &digit (string(:j-1), i+n)
        end if
    end function reada
    subroutine upcase (keywrd, n)
!
!.. Implicit Declarations ..
        implicit none
!
!.. Formal Arguments ..
        character (len=*), intent (inout) :: keywrd
        integer, intent (in) :: n
!
!.. Local Scalars ..
        character (len=241) :: keybuf
        integer :: i, icapa, iline, ilowa, ilowz, j
!
!.. Intrinsic Functions ..
        intrinsic Char, Ichar, Index
!
! ... Executable Statements ...
!
!
!  UPCASE WILL TAKE A CHARACTER STRING, IN KEYWRD, AND PUT IT INTO
!  UPPER CASE.  KEYWRD IS LIMITED TO 80 CHARACTERS
!
        icapa = Ichar ("A")
        ilowa = Ichar ("a")
        ilowz = Ichar ("z")
        keybuf = keywrd
        do i = 1, n
          iline = Ichar (keywrd(i:i))
          if (iline >= ilowa .and. iline <= ilowz) then
            keywrd(i:i) = Char(iline+icapa-ilowa)
          end if
!
!  Change tabs to spaces.  A tab is ASCII character 9.
!
          if (iline == 9) then
            keywrd (i:i) = " "
          end if
        end do
!
!   If the word EXTERNAL is present, do NOT change case of the following
!   character string.
!
        i = Index (keywrd, "EXTERNAL")
        if (i /= 0) then
          j = Index (keywrd(i+1:), " ") + i
          keywrd(i+9:j) = keybuf(i+9:j)
        end if
    end subroutine upcase
    subroutine wrttxt (iprt)
        use common_titles
        use common_keywrd
        use common_jobnam, only : jobnam
!.. Implicit Declarations ..
        implicit none
!
!.. Formal Arguments ..
        integer, intent (in) :: iprt
!
!.. Intrinsic Functions ..
        intrinsic Index
!
! ... Executable Statements ...
!
        write (iprt, "(A)") trim(keywrd)
        if (Index (koment, " NULL ") == 0 .and. koment /= " ") then
          write (iprt, "(A)") trim(koment)
        else
          write (iprt, "(A)") trim(jobnam)
        end if
        if (Index (title, " NULL ") == 0) &
        &  write (iprt, "(A)") trim(title)

       
    end subroutine wrttxt
    subroutine xyzgeo (xyza, numat, na, nb, nc, degree, geo)
        implicit none
        integer, intent (in) :: numat
        double precision, intent (in) :: degree
        integer, dimension (numat), intent (in) :: na, nb
        integer, dimension (numat), intent (inout) :: nc
        double precision, dimension (3, numat), intent (in) :: xyza
        double precision, dimension (3, numat), intent (inout) :: geo
        integer :: i, i1, ii, j, k, l
        double precision :: angl, r, sum, tol
!**********************************************************************
!
!   XYZGEO CONVERTS COORDINATES FROM CARTESIAN TO INTERNAL.
!
!     ON INPUT XYZ  = ARRAY OF CARTESIAN COORDINATES
!              NUMAT= NUMBER OF ATOMS
!              NA   = NUMBERS OF ATOM TO WHICH ATOMS ARE RELATED
!                     BY DISTANCE
!              NB   = NUMBERS OF ATOM TO WHICH ATOMS ARE RELATED
!                     BY ANGLE
!              NC   = NUMBERS OF ATOM TO WHICH ATOMS ARE RELATED
!                     BY DIHEDRAL
!
!    ON OUTPUT GEO  = INTERNAL COORDINATES IN ANGSTROMS, RADIANS,
!                     AND RADIANS
!
!**********************************************************************
        do i = 2, numat
          j = na(i)
          k = nb(i)
          l = nc(i)
          if (i == 493) then
            l = nc(i)
          end if
          if (i >= 3) then
            ii = i
            call bangle (xyza, ii, j, k, geo(2, i))
            geo(2, i) = geo(2, i) * degree
            if (i >= 4) then
!
!   MAKE SURE DIHEDRAL IS MEANINGLFUL
!
              call bangle (xyza, j, k, l, angl)
              tol = 0.2617994d0
!
!  If angle is within 0.015 degrees of a straight line, assume
!  the user intended this, and carry on
!
              if ((angl < 3.1415926d0-tol*1.d-3 .or. angl > tol*1.d-3) .and. &
             & (angl > 3.1415926d0-tol .or. angl < tol)) then
                do
!
!  ANGLE IS UNSATISFACTORY, LET'S SEARCH FOR ANOTHER ATOM FOR
!  DEFINING THE DIHEDRAL.
                  sum = 100.d0
                  do i1 = 1, ii - 1
                    r = (xyza(1, i1)-xyza(1, k))**2 &
                         &+ (xyza(2, i1)-xyza(2, k))**2 &
                         &+ (xyza(3, i1)-xyza(3, k))**2
                    if (r < sum .and. i1 /= j .and. i1 /= k) then
                      call bangle (xyza, j, k, i1, angl)
                      if (angl < 3.1415926d0-tol .and. angl > tol) then
                        sum = r
                        l = i1
                        nc(ii) = l
                      end if
                    end if
                  end do
                  if (sum > 99.d0 .and. tol > 0.1d0) then
!
! ANYTHING WITHIN 5 DEGREES?
!
                    tol = 0.087266d0
                  else
                    exit
                  end if
                end do
              end if
              call dihed (xyza, ii, j, k, l, geo(3, i))
              geo(3, i) = geo(3, i) * degree
            end if
          end if
          geo(1, i) = Sqrt ((xyza(1, i)-xyza(1, j))**2&
               &+ (xyza(2, i)-xyza(2, j))**2&
               &+ (xyza(3, i)-xyza(3, j))**2)
        end do
        geo(1, 1) = 0.d0
        geo(2, 1) = 0.d0
        geo(3, 1) = 0.d0
        geo(2, 2) = 0.d0
        geo(3, 2) = 0.d0
        geo(3, 3) = 0.d0
    end subroutine xyzgeo
    subroutine xyzint (xyz, na, nb, nc, degree, geo)
        use common_systm, only : numat
        implicit none
        double precision, dimension (3, numat), intent (in) :: xyz
        integer, dimension (numat), intent (inout) :: na, nb, nc
        double precision, intent (in) :: degree
        double precision, dimension (3, numat), intent (inout) :: geo
        integer :: i, l
        integer :: im1, j, k
        double precision :: r, sum, pi = 3.141592653589d0
        geo = 0.d0
        do i = 1, numat 
          im1 = i - 1 
          j = na(i) 
          if (j == 0) then
            na(i) = 2 
            nb(i) = 3 
            nc(i) = 4   
            if (i == 1) cycle           
            sum = 1.d30 
            do j = 1, im1 
              r = (xyz(1,i) - xyz(1,j))**2 + (xyz(2,i) - xyz(2,j))**2 + (xyz(3,i) - xyz(3,j))**2 
              if (.not.(r < sum .and. na(j) /= j .and. nb(j) /=j )) cycle  
              sum = r 
              k = j 
            end do 
  !
  !   ATOM I IS NEAREST TO ATOM K
  !
            na(i) = k 
            j = k
            if (i > 2) nb(i) = na(k)  
            nc(i) = nb(k) 
!
!   FIND ANY ATOM TO RELATE TO NA(I)
!
          end if         
          if (i > 3) then
!
!  Check that the angle na(i) - nb(i) - nc(i) is meaningful
!
            call bangle (xyz, na(i), nb(i), nc(i), sum) 
            if (sum < 1.d-2 .or. Abs(pi - sum) < 1.d-2) then
!
!  Angle is zero or 180 degrees.  Search for an atom nearest to 90 degrees
!
              r = 2.d0
              do k = 1, im1
                if (k == i .or. k == j) cycle
                call bangle (xyz, na(i), nb(i), k, sum) 
                if (Abs(pi*0.5d0 - sum)  < r) then
                  r =  Abs(pi*0.5d0 - sum)
                  l = k
                  end if
                  if (r < 0.5d0) exit ! angle is acceptable
              end do
              nc(i) = l
            end if
            call dihed (xyz, i, j, nb(i), nc(i), geo(3,i)) 
          end if
          geo(3,i) = geo(3,i)*degree
          if (i > 2) call bangle (xyz, i, j, nb(i), geo(2,i)) 
          geo(2,i) = geo(2,i)*degree
          geo(1,i) = sqrt((xyz(1,i)-xyz(1,j))**2 + &
                          (xyz(2,i)-xyz(2,j))**2 + &
                          (xyz(3,i)-xyz(3,j))**2) 
        end do    
        na(1) = 0 
        nb(1) = 0 
        nc(1) = 0 
        if (numat > 1) then 
          nb(2) = 0 
          nc(2) = 0 
          if (numat > 2) nc(3) = 0 
          na(2) = 1 
        end if 
  end subroutine xyzint
  subroutine add_path(file)
    use common_systm, only : path
    implicit none
    character, intent (inout) :: file*(*)
    integer :: n
    logical :: need_path
!
!  Test to see if the file "file" already has an absolute path.
! 
      need_path =  ((file(2:2) /= ":") .and. &
      ((file(1:1) /= "/") .and. (file(1:1) /= "\")) .and. ((file(2:2) /= "/") .and. (file(2:2) /= "\"))) 
    if (.not. need_path) return
!
!  Test to see if the job has an absolte path.
!    
      need_path = (path(2:2) == ":")
    if (.not. need_path) return      
!
!  file "file" does not include the path and the path is present in "path"
!  therefore add path to the file "file"
!
!  First check if a relative path is used
!
    n = 1
    do 
      if (file(1:3) /= "../" .and. file(1:3) /= "..\") exit
      n = n + 1
      file = trim(file(4:))
    end do
!
!  Is the file defined relative to the current folder?
!  If so, delete the definition.
!
    if (file(1:2) == "./" .or. file(1:2) == ".\") file = trim(file(3:))
!
!  Join the path to the start of the file
!
    file = trim(path)//trim(file)   
    return
  end subroutine add_path
  subroutine l_control(txt, nt, mode)
!
!   l_control has two modes:
!
! (A)  If mode =  1 the word(s) in txt is(are) added to keywrd.  If the word in txt already exists
!                   in keywrd, the word in txt would first be deleted from keywrd.
! (B)  If mode = -1 the word(s) in txt is(are) removed from keywrd
!
!  txt can consists of upper and lower case letters, "-" and "_"; the last two allow hyphenated words.
!
  use common_systm, only :  line
  use common_keywrd, only : keywrd
  implicit none
  integer :: nt, mode
  character :: txt*(nt), store*2000
  integer :: i, j, trim_len, mt
  character :: local_txt*(nt), ch*1
  local_txt = txt
  do
!
!  Parse each word, one at a time.
!
    do
      if (local_txt(1:1) /= " ") exit
      local_txt = local_txt(2:)
    end do
    ch = " "
    mt = 0
    do i = 1, nt
      mt = mt + 1
      if (local_txt(mt:mt) == '"') then ! Quickly run to the closing '"'
        do mt = mt + 1, nt
          if (local_txt(mt:mt) == '"') exit
        end do
      end if
      if (local_txt(mt:mt) == ' ') exit 
      if (mt == nt) exit
    end do
    line = local_txt(:mt)  
!
!  "line" holds a single keyword
!
    local_txt = local_txt(mt + 1:)
    if (line(1:1) >= "0" .and. line(1:1) <= "9") then
      i = mt + 1
      else
  !
  ! find the end of the defined keyword, e.g., in pi=3.1415, that would be "i"
  !
      do i = 1, mt
        if ((line(i:i) < "A" .or. line(i:i) > "Z") .and. (line(i:i) < "a" .or. line(i:i) > "z") .and. &
        line(i:i) /= "_" .and. line(i:i) /= "-") exit
      end do
    end if
    trim_len = i - 1  
!
!  If keyword already exists, then delete the keyword
!  Keyword can have an "=" sign, or be followed by a "(" or a '"'
!  in which case, find the end of the keyword.
!
    do
      if (keywrd == " ") exit
      i = index(keywrd, " "//line(:trim_len))
      if (i > 0) then
        j = i + trim_len + 1
        if (keywrd(j:j) /= " ") then
          if (keywrd(j:j) == "=") j = j + 1
          ch = " "
          if (keywrd(j:j) == "(") then
            ch = ")"
          else if (keywrd(j:j) == '"') then
            ch = '"'
          end if
          do
            j = j + 1
            if (keywrd(j:j) == ch) exit
          end do 
        end if
        keywrd = keywrd(:i)//keywrd(j + 1:)
      else
        exit
      end if
    end do
    store = " "
    if (mode == 1) then
      i = index(keywrd, store(:mt + 2))
      keywrd = keywrd(:i)//line(:mt)//trim(keywrd(i + mt + 1:))
    end if  
    if (local_txt == " ") exit
  end do
  return
  end subroutine l_control

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  module YGXX_SimpleGaussianInts
  implicit none
  public :: GGJPP_IntQ, GPJPS_Int, GPJPS_IntQ, SSJPS_IntQ, SSJPP_Int, SPJPS_Int, GSJPS_IntQ

  private

  integer, parameter :: XSN = 3
  double precision, parameter :: XSZ(3) = (/ 0.4068833884920483d0, 0.09179674341953627d0, 3.515225231758639d0 /)
  double precision, parameter :: XSC(3) = (/ 0.3620527755096057d0, 0.6262050528632612d0, 0.01174217162750757d0 /)
  double precision, parameter :: sqrt_pi = 1.772453850905516027298167483341d0

  contains

  subroutine GSJPS_IntQ(Rab, na, Ca, Za, dZadQa, Zb, dZbdQb, X, Xa, Xb)
    implicit none
    double precision, intent(in) :: Rab(3)
    integer, intent(in) :: na
    double precision, intent(in) :: Za(na), Ca(na), dZadQa(na), Zb, dZbdQb
    double precision, intent(OUT) :: X(3, 1), Xa(3, 1), Xb(3, 1)
!
!  Local variables
!
    double precision :: Gb(XSN)
    double precision :: dGb(XSN)
    Gb = XSZ * Zb**2
    dGb = XSZ * 2*Zb * dZbdQb
    call GGJPS_IntQ(Rab, na, Ca, Za, dZadQa, XSN, XSC, Gb, dGb, X, Xa, Xb)
  end subroutine GSJPS_IntQ

  subroutine SSJPS_IntQ(Rab, Za, dZadQa, Zb, dZbdQb, X, Xa, Xb)
    implicit none
    double precision, intent(in) :: Rab(3), Za, Zb, dZadQa, dZbdQb
    double precision, intent(OUT) :: X(3, 1), Xa(3, 1), Xb(3, 1)
!
!  Local variables
!
    double precision :: Ga(XSN), Gb(XSN)
    double precision :: dGa(XSN), dGb(XSN)
    Ga = XSZ * Za**2
    Gb = XSZ * Zb**2
    dGa = XSZ * 2*Za * dZadQa
    dGb = XSZ * 2*Zb * dZbdQb
    call GGJPS_IntQ(Rab, XSN, XSC, Ga, dGa, XSN, XSC, Gb, dGb, X, Xa, Xb)
  end subroutine SSJPS_IntQ

  subroutine GGJPS_IntQ(Rab, na, Ca, Za, dZadQa, nb, Cb, Zb, dZbdQb, X, Xa, Xb)
    implicit none
    double precision, intent(in) :: Rab(3)
    integer, intent(in) :: na, nb
    double precision, intent(in) :: Ca(na), Za(na), dZadQa(na), Cb(nb), Zb(nb), dZbdQb(nb)
    double precision, intent(OUT) :: X( 3, 1 ), Xa( 3, 1 ), Xb( 3, 1 )
!
!  Local variables
!
    integer :: i, j
    double precision :: r2, r, b, br, cc, j00, d00dr, j10, e, U(3), dbdQa, dbdQb, d00db, &
      dedb, d00drdb, d10db, d10dQa, d10dQb
    X = 0.d0
    Xa = 0.d0
    Xb = 0.d0
    r2 = Rab(1)*Rab(1) + Rab(2)*Rab(2) + Rab(3)*Rab(3)
    if ( r2 < 1.d-25 ) then
       X = 0.d0
       Xa = 0.d0
       Xb = 0.d0
    else
       r = sqrt(r2)
       U = Rab/r
       j10 = 0.d0
       d10dQa = 0.d0
       d10dQb = 0.d0
       do i=1, na
          do j=1, nb
             b  = sqrt( Za(i) * Zb(j) / ( Za(i) + Zb(j) ) )
             dbdQa = dZadQa(i) * ( Zb(j)/( Za(i)+Zb(j) ) )**2  / (2.d0*b)
             dbdQb = dZbdQb(j) * ( Za(i)/( Za(i)+Zb(j) ) )**2  / (2.d0*b)
             br = b * r
             cc = Ca(i) * Cb(j)
             e = (2.d0 / sqrt_PI) * b * EXP(-br*br)
             j00    = erf(br)/r
             d00dr  = e/r - j00/r
             d00db = (2.d0 / sqrt_PI) * EXP(-br*br)
             dedb  = (2.d0 / sqrt_PI) * (1.d0-2.d0*br*br) * EXP(-br*br)
             d00drdb = dedb/r - d00db/r
             j10    = j10 + cc * d00dr
             d10db  = cc * d00drdb
             d10dQa = d10dQa + d10db * dbdQa
             d10dQb = d10dQb + d10db * dbdQb
          end do
       end do
       X(1, 1) = X(1, 1) + j10 * U(3)
       X(2, 1) = X(2, 1) + j10 * U(1)
       X(3, 1) = X(3, 1) + j10 * U(2)
       Xa(1, 1) = Xa(1, 1) + d10dQa * U(3)
       Xa(2, 1) = Xa(2, 1) + d10dQa * U(1)
       Xa(3, 1) = Xa(3, 1) + d10dQa * U(2)
       Xb(1, 1) = Xb(1, 1) + d10dQb * U(3)
       Xb(2, 1) = Xb(2, 1) + d10dQb * U(1)
       Xb(3, 1) = Xb(3, 1) + d10dQb * U(2)
    end if
  end subroutine GGJPS_IntQ

  subroutine SSJPP_Int(Rab, Za, Zb, X)
    implicit none
    double precision, intent(in) :: Rab(3)
    double precision, intent(in) :: Za, Zb
    double precision, intent(OUT) :: X(3, 3)
!
!  Local variables
!
    double precision :: Ga(XSN), Gb(XSN)
    Ga = XSZ * Za**2
    Gb = XSZ * Zb**2
    call GGJPP_Int(Rab, XSN, XSC, Ga, XSN, XSC, Gb, X)
  end subroutine SSJPP_Int




  subroutine GGJPP_Int(Rab, na, Ca, Za, nb, Cb, Zb, X)
    implicit none
    double precision, intent(in) :: Rab(3)
    integer, intent(in) :: na, nb
    double precision, intent(in) :: Ca(na), Za(na)
    double precision, intent(in) :: Cb(nb), Zb(nb)
    double precision, intent(OUT) :: X( 3, 3 )
!
!  Local variables
!

    integer :: i, j
    double precision :: r2, r
    double precision :: b, br, cc
    double precision :: j00, d00dr, d00dr2
    double precision :: j10
    double precision :: j11
    double precision :: e, dedr
    double precision :: U(3)
    double precision :: dUda(3, 3)
    integer :: ix, iy, jx, jy
    X = 0.d0
    r2 = Rab(1)*Rab(1) + Rab(2)*Rab(2) + Rab(3)*Rab(3)
    if ( r2 < 1.d-25 ) then
       e = 0.d0
       do i=1, na
          do j=1, nb
             b  = sqrt( Za(i) * Zb(j) / ( Za(i) + Zb(j) ) )
             cc = Ca(i) * Cb(j)
             e = e + cc * 4.d0 * b**3 / ( 3.d0 * sqrt_PI )
          end do
       end do
       do i=1, 3
          X(i, i) = e
       end do
    else
       r = sqrt(r2)
       U = Rab/r
       do i=1, 3
          do j=1, 3
             dUda(i, j) = -U(i)*U(j)/r
          end do
          dUda(i, i) = dUda(i, i) + 1.d0/r
       end do
       j10 = 0.d0
       j11 = 0.d0
       do i=1, na
          do j=1, nb
             b  = sqrt( Za(i) * Zb(j) / ( Za(i) + Zb(j) ) )
             br = b * r
             cc = Ca(i) * Cb(j)
             e     =  (2.d0 / sqrt_PI) * b * EXP(-br*br)
             dedr  = -2*b*br * e
             j00    = erf(br)/r
             d00dr  = e/r - j00/r
             d00dr2 = dedr/r - e/r2 - d00dr/r + j00/r2
             j10    = j10 + cc * d00dr
             j11    = j11 + cc * d00dr2
          end do
       end do
       do iy=1, 3
          jy = MOD(iy+1, 3)+1
          do ix=1, 3
             jx = MOD(ix+1, 3)+1
             X(ix, iy) =   j11 * U(jx) * (-U(jy)) &
                  &     - j10 * dUda(jx, jy)
          end do
       end do
    end if
  end subroutine GGJPP_Int

  subroutine GGJPP_IntQ(Rab, na, Ca, Za, dZadQa, nb, Cb, Zb, dZbdQb, X, Xa, Xb)
    implicit none
    double precision, intent(in) :: Rab(3)
    integer, intent(in) :: na, nb
    double precision, intent(in) :: Ca(na), Za(na), dZadQa(na)
    double precision, intent(in) :: Cb(nb), Zb(nb), dZbdQb(nb)
    double precision, intent(OUT) :: X( 3, 3 )
    double precision, intent(OUT) :: Xa( 3, 3 )
    double precision, intent(OUT) :: Xb( 3, 3 )
!
!  Local variables
!
    integer :: i, j
    double precision :: r2, r
    double precision :: b, br, cc
    double precision :: j00, d00dr, d00dr2
    double precision :: j10
    double precision :: j11
    double precision :: e, dedr
    double precision :: U(3)
    double precision :: dUda(3, 3)
    integer :: ix, iy, jx, jy
    double precision :: dbdQa, dbdQb
    double precision :: dedb, dedrdb, d00db, d00drdb, d00dr2db
    double precision :: dedQa, dedQb
    double precision :: d10dQa, d10dQb
    double precision :: d11dQa, d11dQb
    X  = 0.d0
    Xa = 0.d0
    Xb = 0.d0
    r2 = Rab(1)*Rab(1) + Rab(2)*Rab(2) + Rab(3)*Rab(3)
    if ( r2 < 1.d-25 ) then
       e = 0.d0
       dedQa = 0.d0
       dedQb = 0.d0
       do i=1, na
          do j=1, nb
             b  = sqrt( Za(i) * Zb(j) / ( Za(i) + Zb(j) ) )
             dbdQa = dZadQa(i) * ( Zb(j)/( Za(i)+Zb(j) ) )**2  / (2.d0*b)
             dbdQb = dZbdQb(j) * ( Za(i)/( Za(i)+Zb(j) ) )**2  / (2.d0*b)
             cc = Ca(i) * Cb(j)
             e = e + cc * 4.d0 * b**3 / ( 3.d0 * sqrt_PI )
             dedb =  cc * 12.d0 * b**2 / ( 3.d0 * sqrt_PI )
             dedQa = dedQa + dedb * dbdQa
             dedQb = dedQb + dedb * dbdQb
          end do
       end do
       do i=1, 3
          X(i, i) = e
          Xa(i, i) = dedQa
          Xb(i, i) = dedQb
       end do
    else
       r = sqrt(r2)
       U = Rab/r
       do i=1, 3
          do j=1, 3
             dUda(i, j) = -U(i)*U(j)/r
          end do
          dUda(i, i) = dUda(i, i) + 1.d0/r
       end do
       j10 = 0.d0
       j11 = 0.d0
       d10dQa = 0.d0
       d10dQb = 0.d0
       d11dQa = 0.d0
       d11dQb = 0.d0
       do i=1, na
          do j=1, nb
             b  = sqrt( Za(i) * Zb(j) / ( Za(i) + Zb(j) ) )
             dbdQa = dZadQa(i) * ( Zb(j)/( Za(i)+Zb(j) ) )**2  / (2.d0*b)
             dbdQb = dZbdQb(j) * ( Za(i)/( Za(i)+Zb(j) ) )**2  / (2.d0*b)
             br = b * r
             cc = Ca(i) * Cb(j)
             e     =  (2.d0 / sqrt_PI) * b * EXP(-br*br)
             dedr  = -2*b*br * e
             dedb = (2.d0 / sqrt_PI) * (1.d0-2.d0*br*br) * EXP(-br*br)
             dedrdb = -4*br*e - 2*b*br*dedb
             j00    = erf(br)/r
             d00dr  = e/r - j00/r
             d00dr2 = dedr/r - e/r2 - d00dr/r + j00/r2
             d00db    = (2.d0 / sqrt_PI) * EXP(-br*br)
             d00drdb  = dedb/r - d00db/r
             d00dr2db = dedrdb/r - dedb/r2 - d00drdb/r + d00db/r2
             j10    = j10 + cc * d00dr
             j11    = j11 + cc * d00dr2
             d10dQa = d10dQa + cc * d00drdb * dbdQa
             d10dQb = d10dQb + cc * d00drdb * dbdQb
             d11dQa = d11dQa + cc * d00dr2db * dbdQa
             d11dQb = d11dQb + cc * d00dr2db * dbdQb
          end do
       end do
       do iy=1, 3
          jy = MOD(iy+1, 3)+1
          do ix=1, 3
             jx = MOD(ix+1, 3)+1
             X(ix, iy) =   j11 * U(jx) * (-U(jy))  - j10 * dUda(jx, jy)
             Xa(ix, iy) =   d11dQa * U(jx) * (-U(jy))  - d10dQa * dUda(jx, jy)
             Xb(ix, iy) =   d11dQb * U(jx) * (-U(jy))  - d10dQb * dUda(jx, jy)
          end do
       end do
    end if
  end subroutine GGJPP_IntQ

  subroutine SPJPS_Int(Rab, Za, X)
    implicit none
    double precision, intent(in) :: Rab(3), Za
    double precision, intent(OUT) :: X(3, 1)
!
!  Local variables
!
    double precision :: Ga(XSN)
    Ga = XSZ * Za**2
    call GPJPS_Int(Rab, XSN, XSC, Ga, X)
  end subroutine SPJPS_Int




  subroutine GPJPS_Int(Rab, na, Ca, Za, X)
    implicit none
    double precision, intent(in) :: Rab(3)
    integer, intent(in) :: na
    double precision, intent(in) :: Ca(na), Za(na)
    double precision, intent(OUT) :: X( 3, 1 )
!
!  Local variables
!
    integer :: i
    double precision :: r2, r, b, br, cc, j00, d00dr, j10, e, U(3)
    X = 0.d0
    r2 = Rab(1)*Rab(1) + Rab(2)*Rab(2) + Rab(3)*Rab(3)
    if ( r2 < 1.d-25 ) then
       X = 0.d0
    else
       r = sqrt(r2)
       U = Rab/r
       j10 = 0.d0
       do i=1, na
          b  = sqrt( Za(i)  )
          br = b * r
          cc = Ca(i)
          e = (2.d0 / sqrt_PI) * b * EXP(-br*br)
          j00    = erf(br)/r
          d00dr  = e/r - j00/r
          j10    = j10 + cc * d00dr
       end do
       X(1, 1) = X(1, 1) + j10 * U(3)
       X(2, 1) = X(2, 1) + j10 * U(1)
       X(3, 1) = X(3, 1) + j10 * U(2)
    end if
  end subroutine GPJPS_Int



  subroutine GPJPS_IntQ(Rab, na, Ca, Za, dZadQa, X, Xa)
    implicit none
    double precision, intent(in) :: Rab(3)
    integer, intent(in) :: na
    double precision, intent(in) :: Ca(na), Za(na), dZadQa(na)
    double precision, intent(OUT) :: X( 3, 1 ), Xa( 3, 1 )
!
!  Local variables
!
    integer :: i
    double precision :: r2, r, b, br, cc, j00, d00dr, j10, e, U(3), d10dQa, dbdQa, &
      dedb, d00db, d00drdb
    X = 0.d0
    Xa = 0.d0
    r2 = Rab(1)*Rab(1) + Rab(2)*Rab(2) + Rab(3)*Rab(3)
    if ( r2 < 1.d-25 ) then
       X = 0.d0
       Xa = 0.d0
    else
       r = sqrt(r2)
       U = Rab/r
       j10 = 0.d0
       d10dQa = 0.d0
       do i=1, na
          b  = sqrt( Za(i) )
          dbdQa = dZadQa(i) / ( 2.d0*b )
          br = b * r
          cc = Ca(i)
          e = (2.d0 / sqrt_PI) * b * EXP(-br*br)
          dedb = (2.d0 / sqrt_PI) * (1.d0-2.d0*br*br) * EXP(-br*br)
          j00    = erf(br)/r
          d00dr  = e/r - j00/r
          d00db = (2.d0 / sqrt_PI) * EXP(-br*br)
          d00drdb = dedb/r - d00db/r
          j10    = j10 + cc * d00dr
          d10dQa = d10dQa + cc * d00drdb * dbdQa
       end do
       X(1, 1) = X(1, 1) + j10 * U(3)
       X(2, 1) = X(2, 1) + j10 * U(1)
       X(3, 1) = X(3, 1) + j10 * U(2)
       Xa(1, 1) = Xa(1, 1) + d10dQa * U(3)
       Xa(2, 1) = Xa(2, 1) + d10dQa * U(1)
       Xa(3, 1) = Xa(3, 1) + d10dQa * U(2)
    end if
  end subroutine GPJPS_IntQ
  end module YGXX_SimpleGaussianInts

  subroutine Invert_Symmetric_Matrix( N, A, AI )
    implicit none
    integer, intent(in) :: N
    double precision, intent(in) :: A(N, N)
    double precision, intent(OUT) :: AI(N, N)
!
!  Local variables
!
    integer :: INFO, i, j
    AI = A
    call dpotrf( "U", N, AI(1, 1), N, INFO )
    call dpotri( "U", N, AI(1, 1), N, INFO )
    do j=2, N
      do i=1, j-1
          AI(j, i) = AI(i, j)
      end do
    end do
  end subroutine Invert_Symmetric_Matrix

 subroutine CPE_QdepDipole_Contribution(N_qm, Id_qm, Crd_qm, Q_qm, Zeta_qm, E, Pot, C )
    implicit none
    integer, intent(in) :: N_qm          ! Number of qm atoms
    integer, intent(in) :: Id_qm( N_qm ) ! Parameter indices
    double precision, intent(in) :: Crd_qm( 3, N_qm ) ! qm coordinates (xyz)
    double precision, intent(in) :: Q_qm( N_qm )      ! qm electric partial charges
    double precision, intent(in) :: Zeta_qm( N_qm )   ! qm aux slater exponent
    double precision, intent(OUT) :: E                ! response energy contribution
    double precision, intent(OUT) :: Pot( N_qm )      ! effective monopolar potential correction to be mapped into the fock matrix
    double precision, intent(OUT) :: C( 3 * N_qm )    ! Response dipole coefs (zxy)
!
!  Local variables
!
    integer :: N
    double precision, ALLOCATABLE :: Eta(:, :), dEtadQa(:, :), dEtadQb(:, :), EtaInv(:, :), &
      M(:), Mmat(:, :), dMdQa(:), Q0(:)
    integer :: i, i1, i2, j, j1, j2
    Pot = 0.d0
    N = 3 * N_qm
    allocate( Eta(N, N), dEtadQa(N, N), dEtadQb(N, N), EtaInv(N, N), M(N), Mmat( N, N_qm ) )
    allocate( dMdQa(N), Q0( N_qm) )
    Q0( 1:N_qm ) = Q_qm( 1:N_qm )
    call Cpt_SecondOrderMatrix( N_qm, Id_qm, Crd_qm, Q_qm, Eta, dEtadQa, dEtadQb )
    call Cpt_FirstOrderMatrix( N_qm, Id_qm, Crd_qm, Q_qm, Zeta_qm, Mmat, dMdQa )
    call Invert_Symmetric_Matrix( N, Eta, EtaInv )
    M = matmul( Mmat, Q0 )
    C = -matmul(EtaInv, M )
    E =  dot_product( C, M ) + 0.5d0 * dot_product( C, matmul( Eta, C ) )
    do i=1, N_qm
       i1 = (i-1)*3 + 1
       i2 = i1 + 2
       Pot(i) = Pot(i) + dot_product( C, Mmat(:, i) )
       Pot(i) = Pot(i) + dot_product( C(i1:i2), dMdQa(i1:i2) )
    end do
    do i=1, N_qm
       i1 = (i-1)*3 + 1
       i2 = i1 + 2
       do j=1, N_qm
          j1 = (j-1)*3 + 1
          j2 = j1 + 2
          Pot(i) = Pot(i) + 0.5d0 * dot_product(C(i1:i2), matmul(dEtadQa(i1:i2, j1:j2), C(j1:j2)))
          Pot(j) = Pot(j) + 0.5d0 * dot_product(C(i1:i2), matmul(dEtadQb(i1:i2, j1:j2), C(j1:j2)))
       end do
    end do
  end subroutine CPE_QdepDipole_Contribution

  subroutine Cpt_FirstOrderMatrix( N_qm, Id_qm, Crd_qm, Q_qm, Zeta_qm, Mmat, dMdQa )
    use YGXX_SimpleGaussianInts, only : GSJPS_IntQ
    USE parameters_C, only : CPE_Z0, CPE_B, CPE_Xlo, CPE_Xhi
    implicit none
    integer, intent(in) :: N_qm          ! Number of qm atoms
    integer, intent(in) :: Id_qm( N_qm ) ! Parameter indices
    double precision, intent(in) :: Crd_qm( 3, N_qm ) ! qm coordinates (xyz)
    double precision, intent(in) :: Q_qm( N_qm )      ! qm electric partial charges
    double precision, intent(in) :: Zeta_qm( N_qm )   ! qm aux slater exponent
    double precision, intent(OUT) :: Mmat( 3*N_qm, N_qm), dMdQa( 3*N_qm )
!
!  Local variables
!
    double precision :: Rab(3), X(3, 1), Xa(3, 1), Xb(3, 1), Za, dZadQa, Zb, dZbdQb
    integer :: i, i1, i2, ia, j, ib
    double precision :: rlo, rhi, r, s
    Mmat  = 0.d0
    dMdQa = 0.d0
    do i=1, N_qm
       i1 = (i-1)*3 + 1
       i2 = i1 + 2
       ia = Id_qm(i)
       Za = CPE_Z0(ia) * EXP( CPE_B(ia) * Q_qm(i) )
       dZadQa = CPE_B(ia) * Za
       do j=1, N_qm
          ib = Id_qm(j)
          Rab = Crd_qm(1:3, i) - Crd_qm(1:3, j)
          r   = sqrt( Rab(1)*Rab(1) + Rab(2)*Rab(2) + Rab(3)*Rab(3) )
          Zb = Zeta_qm(j)
          dZbdQb = 0.d0
          call GSJPS_IntQ(Rab, 1, (/1.d0/), (/Za/), (/dZadQa/), Zb, dZbdQb, X, Xa, Xb)
          rlo = CPE_Xlo(ia) + CPE_Xlo(ib)
          rhi = CPE_Xhi(ia) + CPE_Xhi(ib)
          call SwitchOn(r, rlo, rhi, s)
          X  = s * X
          Xa = s * Xa
          Mmat( i1:i2, j ) = Mmat( i1:i2, j ) + X(1:3, 1)
          dMdQa( i1:i2 ) = dMdQa( i1:i2 ) + Xa(1:3, 1) * Q_qm(j)
       end do
    end do
    if (xb(1, 1) > 1.d9) return
  end subroutine Cpt_FirstOrderMatrix

  subroutine Cpt_SecondOrderMatrix( N_qm, Id_qm, Crd_qm, Q_qm, Eta, dEtadQa, dEtadQb )
    use YGXX_SimpleGaussianInts, only : GGJPP_IntQ
    USE parameters_C, only : CPE_Z0, CPE_B
    implicit none
    integer, intent(in) :: N_qm          ! Number of qm atoms
    integer, intent(in) :: Id_qm( N_qm ) ! Parameter indices
    double precision, intent(in) :: Crd_qm( 3, N_qm ) ! qm coordinates (xyz)
    double precision, intent(in) :: Q_qm( N_qm )      ! qm electric partial charges

    double precision, intent(OUT) :: Eta( 3*N_qm, 3*N_qm ), dEtadQa( 3*N_qm, 3*N_qm ), &
      dEtadQb( 3*N_qm, 3*N_qm )
!
!  Local variables
!
    double precision :: X(3, 3), Xa(3, 3), Xb(3, 3), Za, dZadQa, Zb, dZbdQb, Rab(3)
    integer :: i, i1, i2, j, j1, j2, ia, ib
    Eta     = 0.d0
    dEtadQa = 0.d0
    dEtadQb = 0.d0
    do i=1, N_qm
       i1 = (i-1)*3 + 1
       i2 = i1 + 2
       ia = Id_qm(i)
       Za = CPE_Z0(ia) * EXP( CPE_B(ia) * Q_qm(i) )
       dZadQa = CPE_B(ia) * Za
       do j=1, N_qm
          j1 = (j-1)*3 + 1
          j2 = j1 + 2
          ib = Id_qm(j)
          Zb = CPE_Z0(ib) * EXP( CPE_B(ib) * Q_qm(j) )
          dZbdQb = CPE_B(ib) * Zb
          Rab = Crd_qm(1:3, i) - Crd_qm(1:3, j)
          call GGJPP_IntQ(Rab, 1, (/1.d0/), (/Za/), (/dZadQa/), 1, (/1.d0/), (/Zb/), (/dZbdQb/), X, Xa, Xb)
          Eta( i1:i2, j1:j2 ) = X
          dEtadQa( i1:i2, j1:j2 ) = Xa
          dEtadQb( i1:i2, j1:j2 ) = Xb
       end do
    end do
  end subroutine Cpt_SecondOrderMatrix

  subroutine SwitchOn(x, xlo, xhi, f)
    implicit none
    double precision, intent(in) :: x, xlo, xhi
    double precision, intent(OUT) :: f
!
!  Local variables
!
    double precision :: s, sf
!
! switch off
!
    if ( x >= xhi ) then
       f = 0.d0
    else if ( x <= xlo ) then
       f = 1.d0
    else
       s  = (xhi-x)/(xhi-xlo)
       sf =    10.d0 * s**3 &
            & -15.d0 * s**4 &
            & + 6.d0 * s**5
       f = sf
    end if
!
! switch on
!
    f = 1.d0 - f
  end subroutine SwitchOn

  Subroutine CPE_energy(Ene, Pot, C)
!
! Evaluates the total energy due to CPE (chemical-potential equalization)
!
    use molkst_C, only : numat
    use Common_arrays_C, only : nat, coord, chrg
    use funcon_C, only : a0, eV, fpc_9
    USE parameters_C, only : CPE_Zeta
    implicit none
    double precision :: Pot(numat)! Effective monopolar potential correction to be mapped into the Fock matrix
    double precision :: C(3*numat)! Response dipole coefs (zxy)
    double precision :: Ene       ! Response energy contribution
!
!  Local variables
!
    double precision, allocatable :: Crd_qm(:,:), Zeta_qm(:)
!=============================================================================
!  Initialization
!=============================================================================
    allocate(Zeta_qm(numat), Crd_qm(3, numat))
    Crd_qm(:,:numat) = coord(:,:numat)/a0 !  Convert geometry from Angstroms to Bohrs
    Zeta_qm(:numat) = CPE_Zeta(nat(:numat))
!=============================================================================
! Initialization complete.  Now do the calculation.
!=============================================================================
    call CPE_QdepDipole_Contribution( numat, nat, Crd_qm, chrg, Zeta_qm, Ene, Pot, C)
!
!  Convert energy into kcal.mol^(-1), Pot and C into eV. (This works in MOPAC, but does not work "stand-alone")
!
    Ene = Ene * eV*fpc_9
    Pot(:numat) = Pot(:numat)*eV
    C(:3*numat) = C(:3*numat)
    return
  end subroutine CPE_energy

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine pathk()
!-----------------------------------------------
!   Follow a reaction path in which the step-size is a constant,
!   Keywords STEP and POINTS are used
!-----------------------------------------------
      use molkst_C, only : iflepo, numat, keywrd, nvar, tleft, escf, &
      line, norbs, numcal, id, natoms, nl_atoms, time0, ncomments
      use maps_C, only : rxn_coord, lparam, react, latom, kloop
      use common_arrays_C, only : geo, xparam, profil, na, l_atom, coord, nat, &
        loc, grad, all_comments, p, q, labels
      use chanel_C, only : iw0, iw, ires, iarc, restart_fn, archive_fn, &
        ixyz, xyz_fn
      use elemts_C, only : elemnt
      USE parameters_C, only : tore
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(20) :: mdfp
      integer :: npts, maxcyc, i, lloop, iloop, l, m, k, iw00, percent, ipdb, &
        imodel, ixyz1
      double precision :: step, degree, c1, cputot, cpu1, cpu2, cpu3, stepc1, factor, dip, &
        dipvec(3), xdfp(20),  gd(3*numat), xlast(3*numat)
      logical :: use_lbfgs, opend, scale, debug, l_dipole
      character :: num1*1, num2*1
      double precision, external :: dipole, reada, seconds
!-----------------------------------------------
      imodel = 0
      ipdb = 14
      ixyz1 = 0
      percent = 0
      use_lbfgs = (index(keywrd,' LBFGS') /=0 .or. nvar > 100 .and. index(keywrd,' EF') == 0)
      step = reada(keywrd,index(keywrd,'STEP') + 5)
      debug = (index(keywrd, " DEBUG") /= 0)
      l_dipole = (index(keywrd, " DIPOLE") /= 0)
      npts = nint(reada(keywrd,index(keywrd,'POINT') + 6))
!
!  THE SMALLEST VALUE IN THE PATH IS
!      REACT(1) DEGREE OR GEO(LPARAM,LATOM) RADIANS
!
      degree = 57.29577951308232D0
      if (lparam /= 1 .and. na(latom) /= 0) then
        step = step/degree
        c1 = degree
      else
        c1 = 1.D0
      end if
      if (index(keywrd, " PDBOUT") /= 0) &
      open(unit = ipdb, file = xyz_fn(:len_trim(xyz_fn) - 3)//"pdb")
      if (index(keywrd, " MINI") /= 0) then
        loc = 0
        nvar = 0
        do i = 1, natoms
          do l = 1, 3
            if (lparam /= l .or. latom /= i) then
              nvar = nvar + 1
              loc(1,nvar) = i
              loc(2,nvar) = l
              xparam(nvar) = geo(l,i)
            end if
          end do
        end do
        if (allocated(grad)) deallocate(grad)
        allocate(grad(nvar))
      end if
      open(unit=ixyz, file=xyz_fn)
      if (l_dipole) then
      ixyz1 = ixyz + 1
      open(unit=ixyz1, file=xyz_fn(:len_trim(xyz_fn) - 4)//" for dipole.xyz")
    end if
!
      kloop = 1
      maxcyc = 100000
      if (index(keywrd,' BIGCYCLES') /= 0) maxcyc = nint(reada(keywrd,index(&
        keywrd,' BIGCYCLES')))
      cputot = 0.0D0
      rxn_coord = geo(lparam,latom)
      if (allocated(profil)) deallocate(profil)
      if (allocated(react)) deallocate(react)
      allocate(profil(npts + 1), react(npts + 1))
      profil = 0.D0
      react(1) = geo(lparam,latom)
      if (use_lbfgs) then
        write (iw, '(/10x,''ABOUT TO ENTER L-BFGS FROM PATHK'')')
        if (index(keywrd,'RESTAR') /= 0) then
          mdfp(9) = 0 !   This section is almost certainly faulty!
          gd = 0.d0
          xlast = 0.d0
          xdfp = 0.d0
          call dfpsav (cputot, xparam, gd, xlast, escf, mdfp, xdfp)
          write (iw, '(2/10X,'' RESTARTING AT POINT'',I3)') kloop
        end if
      else
        write (iw, '(''  ABOUT TO ENTER EF FROM PATHK'')')
        if (index(keywrd,'RESTAR') /= 0) then
          open(unit=ires, file=restart_fn, status='UNKNOWN', form=&
            'UNFORMATTED', position='asis')
          rewind ires
          read (ires, end=60, err=60) i, l
          if (norbs /= l .or. numat /= i) then
              call mopend("Restart file read in does not match current data set")
              goto 99
          end if
          read (ires, err=60) kloop
          read (ires, err=60) rxn_coord
          read (ires, err=60) (profil(i),i=1,kloop)
          close (ires)
          write (iw, '(2/10X,'' RESTARTING AT POINT'',I3)') kloop
        end if
      end if
!
      geo(lparam,latom) = rxn_coord
      lloop = kloop
      scale = .false.
      if (id == 1) then
        do i = 1, natoms
          if (na(i) /= 0) exit
        end do
        scale = (i > natoms .and.latom == natoms)
      end if
      iw00 = iw0
      if (.not. debug) iw0 = -1
      if (index(keywrd, " HTML") /= 0) then
        if (index(keywrd,' DIPOLE') /= 0) call write_path_html(2)
        call write_path_html(1)
      end if
      do iloop = kloop, npts
        if (iloop - lloop >= maxcyc) tleft = -100.D0
        time0 = seconds(1)
        cpu1 = seconds(2)
        if (iloop > 1 .and. scale) then
          factor = geo(lparam,latom)/rxn_coord
          do i = 1, latom - 1
            xparam((i - 1)*3 +lparam) = xparam((i - 1)*3 +lparam)*factor
          end do
        end if
        rxn_coord = geo(lparam,latom)
        numcal = numcal + 1
        if (use_lbfgs) then
          write(iw,'(/10x,a)')"Geometry optimization using L-BFGS"
          if (iloop == 1 .and.iw00 > -1) then
            if (.not. debug) iw0 = 0 ! Temporarily allow writing to screen
            call to_screen(" Geometry optimization using L-BFGS")
            if (.not. debug) iw0 = -1
          end if
          call lbfgs (xparam, escf)
        else
          write(iw,'(/10x,a)')"Geometry optimization using EF"
          if (iloop == 1 .and.iw00 > -1) then
            if (.not. debug) iw0 = 0 ! Temporarily allow writing to screen
            call to_screen(" Geometry optimization using EF")
            if (.not. debug) iw0 = -1
          end if
          call ef (xparam, escf)
        end if
        i = index(keywrd,'RESTAR')
        if (i /= 0) keywrd(i:i+6) = " "
        i = index(keywrd,'OLDENS')
        if (i /= 0) keywrd(i:i+5) = " "
        if (iflepo == (-1) .or. tleft < 0.d0 ) goto 99
        kloop = kloop + 1
        cpu2 = seconds(2)
        cpu3 = cpu2 - cpu1
        cputot = cputot + cpu3
        profil(iloop) = escf
        write (iw, '(/''          VARIABLE        FUNCTION'')')
        write (iw, '('' :'',F16.5,F16.6)') geo(lparam,latom)*c1, escf
        if (iw00 > -1) then
          if (.not. debug) iw0 = 0 ! Temporarily allow writing to screen
          i = nint((100.0*iloop)/npts)
          if (i /= percent) then
            percent = i
            write(line,"('' :'',F16.4,F16.4,i9,a)")geo(lparam,latom)*c1, escf, &
              percent, "% of Reaction Coordinate done"
          else
            write(line,"('' :'',F16.4,F16.4,i9,a)")geo(lparam,latom)*c1, escf
          end if
          call to_screen(line)
        end if
        call to_screen("To_file: Reaction path")
        call geout (iw)
        if (index(keywrd, " PRTXYZ") /= 0) then
          write (iw, '(29X,''CARTESIAN COORDINATES '',/)')
          l = 0 
          do i = 1, natoms
            if (labels(i) == 99 .or. labels(i) == 107) cycle
            l = l + 1
            write (iw, '(I4,3X,A2,3x, 3F16.9)') l, elemnt(labels(i)), (coord(k,l),k=1,3)
          end do
        end if
        if (index(keywrd, " PDBOUT") /= 0) then
          imodel = imodel + 1
          write(line,'(F13.5)') escf
          do i = 1, 12
            if (line(i:i) /= " ") exit
          end do
          write(ipdb,'(a, i9, 2x, a)')"MODEL",imodel, trim(line(i:))
          if (ncomments == 0) ncomments = 1
          write(all_comments(1),'(a,f12.3,a)')" HEADER Heat of Formation =", escf, " Kcal/mol"
          call pdbout(ipdb)
          write(ipdb,'(a)')"ENDMDL"
        end if
        geo(lparam,latom) = geo(lparam,latom) + step
!
!  Write out "xyz" file
!
        write(ixyz,"(i6,a)") nl_atoms," "
        num1 = char(ichar("1") + int(log10(iloop*1.01)))
        factor = abs(escf)
        num2 = char(max(ichar("0"), ichar("0") + min(9, int(log10(factor)))))
        write(ixyz,'(a, i'//num1//', a, f1'//num2//'.5, a)')"Profile.", iloop, &
        " HEAT OF FORMATION =", escf, " KCAL "
        do i = 1, numat
          if (l_atom(i)) write(ixyz,"(3x,a2,3f15.5)")elemnt(nat(i)), (coord(l,i),l=1,3)
        end do
        if (l_dipole) then
          call chrge (p, q)
          q(:numat) = tore(labels(:numat)) - q(:numat)
          dip = dipole(p, coord, dipvec,0)
          write(ixyz1,"(i6,a)") nl_atoms," "
          write(ixyz1,'(a, i'//num1//', a, f1'//num2//'.5, a)')"Profile.", iloop, &
          " DIPOLE =", dip, " DEBYE"
          do i = 1, numat
            if (l_atom(i)) write(ixyz1,"(3x,a2,3f15.5)")elemnt(nat(i)), (coord(l,i),l=1,3)
          end do
        end if
        if (.not. debug) iw0 = -1
      end do
      if (cputot > 1.d7) cputot = cputot - 1.d7
      react(1) = react(1)*c1
      stepc1 = step*c1
      do i = 2, npts
        react(i) = react(i-1) + stepc1
      end do
      write (iw, &
      '(/16X,''POINTS ON REACTION PATH '',/16X,''AND CORRESPONDING HEATS'',2/)')
      inquire(unit=iarc, opened=opend)
      if (opend) close(unit=iarc, status='KEEP')
      open(unit=iarc, file=archive_fn, status='UNKNOWN', position=&
        'asis')
      write (iarc, 30)
      call wrttxt (iarc)
   30 format(' ARCHIVE FILE FOR PATH CALCULATION'/,&
        'A PROFILE OF COORDINATES - HEATS'/)
      write (iarc, '(/'' TOTAL JOB TIME : '',F10.3/)') cputot
!
      l = npts/8
      m = npts - l*8
      if (l >= 1) then
        do k = 0, l - 1
          write (iw, '(9F17.8)') (react(i),i=k*8 + 1,k*8 + 8)
          write (iw, '(9F17.8,/)') (profil(i),i=k*8 + 1,k*8 + 8)
        end do
      end if
      if (m > 0) then
        write (iw, '(9F17.8)') (react(i),i=l*8 + 1,l*8 + m)
        write (iw, '(9F17.8,/)') (profil(i),i=l*8 + 1,l*8 + m)
      end if
      do i = 1, npts
        write(iarc,'(2f17.8)')react(i), profil(i)
      end do
      if (.not. debug) iw0 = iw00
      goto 99
   60 continue
      write (iw, '(A,I3,A)') ' ERROR DETECTED DURING READ FROM CHANNEL', ires, &
        ' IN SUBROUTINE PATHK'
      call mopend ('ERROR DETECTED DURING READ IN SUBROUTINE PATHK')
  99  if (allocated(profil)) deallocate(profil)
      if (allocated(react)) deallocate(react)
      return
  end subroutine pathk
  subroutine write_path_html(mode)
    use chanel_C, only: input_fn
    use molkst_C, only : line, koment, escf, title, backslash, keywrd, l_normal_html
    implicit none
    integer, intent (in) :: mode
    logical :: exists, l_pdb
    integer :: iprt=27, i, j
    double precision :: store_escf
    character :: suffix*3
    l_normal_html = .false.
    if (mode == 1) then
      line = input_fn(:len_trim(input_fn) - 4)//"html"
    else
      line = input_fn(:len_trim(input_fn) - 5)//" for dipole.html"
    end if
    open(unit=iprt, file=trim(line))
    write(iprt,"(a)")"<!DOCTYPE html> "
    write(iprt,"(a)")"<html>"
    write(iprt,"(a)")"<head>"
    write(iprt,"(a)")"<!--"
    write(iprt,"(a)")""
    write(iprt,"(a)")"Template for JSmol reaction path: JSmol window plus HoF energy plot."
    write(iprt,"(a)")""
    write(iprt,"(a)")"-->"
    write(iprt,"(a)")""
    write(iprt,"(a)")"<style>"
    write(iprt,"(a)")"@media print { .noprint {display:none} .printonly {display:block}}"
    write(iprt,"(a)")"@media screen {.noprint {display:block} .printonly {display:none}}"
    write(iprt,"(a)")"</style>"
    write(iprt,"(a)")"<script type=""text/javascript"" src=""../jsmol/JSmol.min.js""></script>"
    write(iprt,"(a)")"<script type=""text/javascript"" src=""../jsmol/js/Jmol2.js""></script>"
    write(iprt,"(a)")"<script type=""text/javascript"" src=""../jsmol/flot/jquery.flot2.js""></script>"
    write(iprt,"(a)")""
    write(iprt,"(a)")"<script type=""text/javascript"">"
    write(iprt,"(a)")"function roundoff(x,ndec){"
    write(iprt,"(a)")"//round x to ndec decimal places"
    write(iprt,"(a)")"if(x==0)return 0"
    write(iprt,"(a)")"if(ndec==0)return Math.round(x)"
    write(iprt,"(a)")"var neg=(x<0?""-"":"""")"
    write(iprt,"(a)")"var xs=Math.abs(x)+"""""
    write(iprt,"(a)")"var i=(xs.indexOf(""E"") & xs.indexOf(""e""))"
    write(iprt,"(a)")"i=xs.indexOf(""."")"
    write(iprt,"(a)")"if (i<0) {xs=xs+""."";i=xs.indexOf(""."");}"
    write(iprt,"(a)")"xs=xs+""000000000"""
    write(iprt,"(a)")"var s="".""+xs.substring(i+1+ndec,xs.length)"
    write(iprt,"(a)")"xs=xs.substring(0,i)+xs.substring(i+1,i+1+ndec)"
    write(iprt,"(a)")"var add1=(xs.charAt(0)==""0"")"
    write(iprt,"(a)")"if(add1)xs=""1""+xs"
    write(iprt,"(a)")"xs=eval(xs)+Math.round(eval(s))+"""""
    write(iprt,"(a)")"if(add1)xs=xs.substring(1,xs.length)"
    write(iprt,"(a)")"xs=xs.substring(0,xs.length-ndec)+"".""+xs.substring(xs.length-ndec,xs.length)"
    write(iprt,"(a)")"if(xs.substring(0,1)==""."")xs=""0""+xs"
    write(iprt,"(a)")"return neg+xs"
    write(iprt,"(a)")"}"
    write(iprt,"(a)")""
    suffix = "xyz"
    l_pdb = (index(keywrd, " PDBOUT") /= 0)
    if (l_pdb) suffix = "pdb"
    if (mode == 1) then
      line = input_fn(:len_trim(input_fn) - 4)//suffix
    else
      line = input_fn(:len_trim(input_fn) - 5)//" for dipole."//suffix
    end if
    do i = len_trim(line), 1, -1
      if (line(i:i) == "/" .or. line(i:i) == backslash) exit
    end do
    line = line(i+1:)
    write(iprt,"(a)")"modelFile = """//backslash//"'"//trim(line)//backslash//"'; center {visible}; zoom 0;"""
    write(iprt,"(a)")"var appletPrintable = (navigator.appName != ""Netscape"")"
    write(iprt,"(a)")""
    write(iprt,"(a)")"// The following code is black magic - don't mess with it!"
    write(iprt,"(a)")""
    write(iprt,"(a)")"function setImage() {if (appletPrintable)return; var image = jmolGetPropertyAsString(""image"")"
    write(iprt,"(a)")"var html = '<img src=""data:image/jpeg;base64,'+image+'"" />'; "
    write(iprt,"(a)")"document.getElementById(""imagediv"").innerHTML = html }"
    write(iprt,"(a)")""
    write(iprt,"(a)")"function doPrintAll() { setImage(); window.print()}"
    write(iprt,"(a)")""
    write(iprt,"(a)")"$(function () { if (!appletPrintable)$(""#appletdiv"").addClass(""noprint"")})"
    write(iprt,"(a)")""
    write(iprt,"(a)")"var theplot = null   "
    write(iprt,"(a)")""
    write(iprt,"(a)")"var data = []"
    write(iprt,"(a)")""
    write(iprt,"(a)")"function plotEnergies(a,b,c,d,e) {"
    write(iprt,"(a)")"if (c == ""zapped"")return"
    write(iprt,"(a)")""
    write(iprt,"(a)")"setImage()"
    write(iprt,"(a)")""
    write(iprt,"(a)")"data = []"
    write(iprt,"(a)")"var A = []"
    write(iprt,"(a)")"var nplots = 1"
    write(iprt,"(a)")"Info = jmolGetPropertyAsArray(""auxiliaryInfo.models"");  "
    write(iprt,"(a)")"var modelCount = Info.length"
    write(iprt,"(a)")" "
    write(iprt,"(a)")"// Gather the data we want for each model."
    write(iprt,"(a)")"//   Note that Flot allows additional element data other than just x and y -- we use this in the callback."
    write(iprt,"(a)")"//   We build an array: [x,y,modelnumber,label]."
    write(iprt,"(a)")""
    if (l_pdb) then
      write(iprt,"(a)")"var x = Jmol.evaluateVar(jmolApplet0, ""show('file').lines.find('MODEL')"");"
      write(iprt,"(a)")"var e = []; for (var i = 0;i < x.length; i++){e.push(+x[i].substring(16))};"
    end if
    write(iprt,"(a)")"for (var i = 0; i < modelCount; i++) {"
    write(iprt,"(a)")"  var modelnumber = 0 + Info[i].modelNumber"
    write(iprt,"(a)")"  var name = Info[i].name"
    write(iprt,"(a)")"  var Properties = Info[i].modelProperties"
    if (l_pdb) then
      write(iprt,"(a)")"  var energy =  e[i]"
    else
      write(iprt,"(a)")"  var energy =  parseFloat(name.substring((name.toLowerCase() + "" kc"")."// &
       "split(""kc"")[0].lastIndexOf(""="") + 1)); //parse the name to pull out the energy"
    end if
    if (mode == 2) then
      write(iprt,"(a)")"  var label =  'Model = ' + modelnumber + ', Dipole = ' + roundoff(energy,3) + ' Debye'"
    else
      write(iprt,"(a)")"  var label =  'Model = ' + modelnumber + ', Energy = ' + roundoff(energy,3) + ' Kcal/mol'"
    end if
    write(iprt,"(a)")"  A.push([i+1,0 + energy,modelnumber,label])"
    write(iprt,"(a)")"  }"
    write(iprt,"(a)")""
    write(iprt,"(a)")"// add that data to the array"
    write(iprt,"(a)")""
    write(iprt,"(a)")"data.push(A)"
    write(iprt,"(a)")""
    write(iprt,"(a)")"// select flot options:"
    write(iprt,"(a)")""
    write(iprt,"(a)")"var options = {"
    write(iprt,"(a)")"  lines: { show: true },"
    write(iprt,"(a)")"  points: { show: true, color:""#FF0000"" },"
    write(iprt,"(a)")"  selection: { mode: (nplots == 1 ? ""x"" : ""xy""), hoverMode: (nplots == 1 ? ""x"" : ""xy"") },"
    write(iprt,"(a)")"  grid: { hoverable: true, clickable: true, hoverDelay: 10, hoverDelayDefault: 10 }"
    write(iprt,"(a)")"  }"
    write(iprt,"(a)")""
    write(iprt,"(a)")"// draw the plot"
    write(iprt,"(a)")""
    write(iprt,"(a)")"theplot = $.plot($(""#plotarea""), data, options)"
    write(iprt,"(a)")""
    write(iprt,"(a)")""
    write(iprt,"(a)")""
    write(iprt,"(a)")"// globals for callback"
    write(iprt,"(a)")""
    write(iprt,"(a)")" previousPoint = null"
    write(iprt,"(a)")" item0 = {datapoint:A[0]}"
    write(iprt,"(a)")""
    write(iprt,"(a)")" $(""#plotarea"").unbind(""plothover plotclick"", null)"
    write(iprt,"(a)")" $(""#plotarea"").bind(""plothover"", plotHoverCallback)"
    write(iprt,"(a)")" $(""#plotarea"").bind(""plotclick"", plotClickCallback)"
    write(iprt,"(a)")""
    write(iprt,"(a)")" // execute an initial plotClickCallback:"
    write(iprt,"(a)")""
    write(iprt,"(a)")""
    write(iprt,"(a)")" setTimeout('plotClickCallback(null,null,item0);"// &
      "iamready=true;jmolScript(""animation mode loop 0 0;animation on"")',100)"
    write(iprt,"(a)")""
    write(iprt,"(a)")""
    write(iprt,"(a)")" "
    write(iprt,"(a)")"}"
    write(iprt,"(a)")""
    write(iprt,"(a)")"var iamready = false"
    write(iprt,"(a)")""
    write(iprt,"(a)")"function doHighlight(app, modelIndex) {"
    write(iprt,"(a)")" if (!iamready)return"
    write(iprt,"(a)")" theplot.unhighlight(0,-1)"
    write(iprt,"(a)")""
    write(iprt,"(a)")"  modelIndex = 0 + modelIndex // required for JavaScript"
    write(iprt,"(a)")""
    write(iprt,"(a)")" theplot.highlight(0, modelIndex)"
    write(iprt,"(a)")" var label = data[0][modelIndex][3]"
    write(iprt,"(a)")"        setTimeout('jmolScript(""set echo top left;echo ' + label+'"")',100)"
    write(iprt,"(a)")"}"
    write(iprt,"(a)")""
    write(iprt,"(a)")"var item0"
    write(iprt,"(a)")"var previousPoint = null"
    write(iprt,"(a)")""
    write(iprt,"(a)")"function plotClickCallback(event, pos, item) {"
    write(iprt,"(a)")" // We're getting back  Flot ""event"" that returns the [x,y,modelIndex,label] point clicked."
    write(iprt,"(a)")""
    write(iprt,"(a)")" if (!item)return"
    write(iprt,"(a)")" var model = item.datapoint[2]"
    write(iprt,"(a)")" var label = item.datapoint[3]"
    write(iprt,"(a)")" var script = ' model 1.'+model+';font echo 16; set echo top left;echo ' + label"
    write(iprt,"(a)")""
    write(iprt,"(a)")" // It's important to use jmolScriptWait here, otherwise Jmol "
    write(iprt,"(a)")" // will impose a 100 ms wait of its own in processing the script queue."
    write(iprt,"(a)")""
    write(iprt,"(a)")" jmolScriptWait(script)"
    write(iprt,"(a)")"}"
    write(iprt,"(a)")""
    write(iprt,"(a)")"function plotHoverCallback(event, pos, item) {"
    write(iprt,"(a)")""
    write(iprt,"(a)")" // for hover, we set the ""tooltip"" div -- "
    write(iprt,"(a)")""
    write(iprt,"(a)")" // $(""#xxxx"") is a jQuery wrapper for a div. $(""#xxxx"")[0] is the div itself"
    write(iprt,"(a)")""
    write(iprt,"(a)")" if (item) {"
    write(iprt,"(a)")"  if (previousPoint != item.datapoint) {"
    write(iprt,"(a)")"   $(""#tooltip"").remove()"
    write(iprt,"(a)")"   previousPoint = item.datapoint "
    write(iprt,"(a)")"   var y = item.datapoint[1]"
    write(iprt,"(a)")"   var model = item.datapoint[2]"
    if (mode == 2) then
      write(iprt,"(a)")"   var label = ""&nbsp;&nbsp;Model ""+ model + "", Dipole = "" + y +"" Debye"""
    else
      write(iprt,"(a)")"   var label = ""&nbsp;&nbsp;Model ""+ model + "", Energy = "" + y +"" Kcal/mol)"""
    end if
    write(iprt,"(a)")"   showTooltip(item.pageX, item.pageY + 10, label, pos)"
    write(iprt,"(a)")"  }"
    write(iprt,"(a)")""
    write(iprt,"(a)")"  if (pos.canvasY > 350)plotClickCallback(event, pos, item)"
    write(iprt,"(a)")" } else {"
    write(iprt,"(a)")"  $(""#tooltip"").remove()"
    write(iprt,"(a)")"  previousPoint = null"
    write(iprt,"(a)")" }"
    write(iprt,"(a)")"}"
    write(iprt,"(a)")""
    write(iprt,"(a)")"function showTooltip(x, y, contents, pos) {"
    write(iprt,"(a)")""
    write(iprt,"(a)")" // from the plot hover callback -- create the tooltip div and set its content and style"
    write(iprt,"(a)")""
    write(iprt,"(a)")" if (pos.canvasY > 340) y += (340 - pos.canvasY)"
    write(iprt,"(a)")" $('<div id=""tooltip"">' + contents + '</div>').css( {"
    write(iprt,"(a)")"  position: 'absolute',"
    write(iprt,"(a)")"  display: 'none',"
    write(iprt,"(a)")"  top: y + 5,"
    write(iprt,"(a)")"  left: x + 5,"
    write(iprt,"(a)")"  border: '1px solid #fdd',"
    write(iprt,"(a)")"  padding: '2px',"
    write(iprt,"(a)")"  'background-color': '#fee',"
    write(iprt,"(a)")"  opacity: 0.80"
    write(iprt,"(a)")"  }).appendTo(""body"").fadeIn(200);"
    write(iprt,"(a)")"}"
    write(iprt,"(a)")""
    write(iprt,"(a)")""
    write(iprt,"(a)")"</script>"
    write(iprt,"(a)")"</head>"
    write(iprt,"(a)")"<body>"
    write(iprt,"(a)")""
    write(iprt,"(a)")""
    if (len_trim(koment) == 0 .or. (index(koment(:8), " NULL") /= 0)) then
      write(iprt,"(a)") "<HTML><HEAD><TITLE>"//input_fn(:len_trim(input_fn) - 5)//"</TITLE></HEAD>"
      write(iprt,"(a)") "<h1 align=""center"">"//input_fn(:len_trim(input_fn) - 5)//"</h1>"
    else
      write(iprt,"(a)") "<HTML><HEAD><TITLE>"//trim(koment)//"</TITLE></HEAD>"
      write(iprt,"(a)") "<h1 align=""center"">"//trim(koment)//"</h1>"
    end if
     if (len_trim(title) /= 0 .and. (index(title(:8), " NULL") == 0) ) &
      write(iprt,"(a)") '<h2 align="center">'//trim(title)//'</h2>'
    store_escf = escf
    escf = 0.d0
    call write_data_to_html(iprt)
    escf = store_escf
    write(iprt,"(a)")"<table><tr><td bgcolor=lightblue align=center>"
    write(iprt,"(a)")"<div id=""imagediv"" class=""printonly""></div>"
    write(iprt,"(a)")"<div id=""appletdiv"" style=""width:450;height:470;text-align:center"">"
    write(iprt,"(a)")"<script type=""text/javascript"">"
    write(iprt,"(a)")""
    write(iprt,"(a)")"  Jmol.Info.j2sPath = ""../jsmol/j2s"""
    write(iprt,"(a)")"  "
    write(iprt,"(a)")" jmolInitialize(""java"",""JmolAppletSigned0.jar"")"
    write(iprt,"(a)")" jmolSetAppletColor(""lightblue"");"
    write(iprt,"(a)")" jmolApplet(600, ""set antialiasDisplay;set loadStructCallback 'plotEnergies';"// &
      "set animFrameCallback 'doHighlight'; load "" + modelFile);"
    write(iprt,"(a)")"jmolScript(""set measurementUnits ANGSTROMS; set "// &
      "bondRadiusMilliAngstroms (50); spacefill 15%; "")</script>"
    write(iprt,"(a)")"</script>"
    write(iprt,"(a)")"</div>"
    write(iprt,"(a)")"animation"
    write(iprt,"(a)")" <a href='javascript:jmolScript(""model first"")'>first</a> "
    write(iprt,"(a)")" <a href='javascript:jmolScript(""model last"")'>last</a> "
    write(iprt,"(a)")" <a href='javascript:jmolScript(""model prev"")'>previous</a> "
    write(iprt,"(a)")" <a href='javascript:jmolScript(""model next"")'>next</a> "
    write(iprt,"(a)")" <a href='javascript:jmolScript(""animation mode loop 0 0;animation play"")'>loop</a> "
    write(iprt,"(a)")" <a href='javascript:jmolScript(""animation mode palindrome 0 0;animation play"")'>palindrome</a> "
    write(iprt,"(a)")" <a href='javascript:jmolScript(""animation off"")'>off</a> &nbsp;&nbsp; "
    line = input_fn(:len_trim(input_fn) - 4)//"txt"
    do i = len_trim(line), 1, -1
      if (line(i:i) == "/" .or. line(i:i) == backslash) exit
    end do
    line = line(i+1:)
    write(iprt,"(a)")" <a href='javascript:jmolScript(""script "//backslash//"""common.txt" &
      //backslash//""";"")'>Common</a>&nbsp;&nbsp;"
    write(iprt,"(a)")" <a href='javascript:jmolScript(""script "//backslash//""""//trim(line) &
      //backslash//""";"")'> Script</a>"
    write(iprt,"(a)")"<br>"
    write(iprt,"(a)")"</td>"
    write(iprt,"(a)")"<td bgcolor=lightblue align=center>"
    write(iprt,"(a)")"<table><tr><td width=40></td><td>"
    write(iprt,"(a)")"<div id=""graphdiv"" style=""background-color:lightblue"">"
    write(iprt,"(a)")" <div id=""plottitle""></div>"
    write(iprt,"(a)")" <br>"
    write(iprt,"(a)")" <div id=""plotarea"" style=""width:600px;height:600px;background-color:lightblue""></div>"
    write(iprt,"(a)")"</div>"
    write(iprt,"(a)")"</td></tr></table>"
    write(iprt,"(a)")"</td>"
    write(iprt,"(a)")"</tr>"
    write(iprt,"(a)")"<tr>"
    write(iprt,"(a)")"<td valign=top>"
    write(iprt,"(a)")"<span class=""noprint"">"
    write(iprt,"(a)")"Click on a point, or scan along the baseline to move rapidly among the models."
    write(iprt,"(a)")"<br><br>"
    write(iprt,"(a)")""
    write(iprt,"(a)")"</span>"
    write(iprt,"(a)")"</td>"
    write(iprt,"(a)")"</tr>"
    write(iprt,"(a)")"<tr><td colspan=2>"
    write(iprt,"(a)")""
    write(iprt,"(a)")""
    write(iprt,"(a)")"</td></tr></table>"
    write(iprt,"(a)")""
    write(iprt,"(a)")"</body>"
    write(iprt,"(a)")"</html>"
!
!  Write out a simple script file
!
    close (iprt)
    line = line(:len_trim(line) - 3)
    call add_path(line)
    inquire (file=trim(line)//"txt", exist = exists)
    if (.not. exists) then
      open(unit=iprt, file=trim(line)//"txt")
      i = 0
      do j = 1, len_trim(line)
        if (line(j:j) == "/" .or. line(j:j) == backslash) i = j
      end do
      if (i /= 0) line = line(i + 1:)
      write(iprt,"(a)")"#","# Script for use with the HTML file """//trim(line)//"html""","#"
    end if
    close (iprt)
  end subroutine write_path_html

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

 subroutine parkey (keywrd)
    use param_global_C, only : ifiles_8
    use molkst_C, only : method_PM7, method_PM8, keywrd_quoted
    implicit none
    character (len=*), intent (in) :: keywrd
    integer :: i, j, k
    character :: num*1, line*300
    character(len=300), external :: get_a_name
    integer, external :: end_of_keyword
    double precision, external :: reada
     if (Index (keywrd, " MNDO ") /= 0) &
       write (ifiles_8, "(' *  MNDO        -  Default parameter set: MNDO')")
     if (Index (keywrd, " AM1") /= 0) &
       write (ifiles_8, "(' *  AM1         -  Default parameter set: AM1')")
     if (Index (keywrd, " PM3") /= 0) &
       write (ifiles_8, "(' *  PM3         -  Default parameter set: PM3')")
     if (Index (keywrd, " RM1") /= 0) &
       write (ifiles_8, "(' *  RM1         -  Default parameter set: RM1')")
     if (Index (keywrd, " PM6-DH") /= 0)  then
       write (ifiles_8, "(' *  PM6-DH2     -  Default parameter set: PM6-DH2')")
! Gallo
! These lines only print in the output file the chosen method. That way,
! filename.out will also acknowledge the use of PM6-D3H4 and PM6-D3(H4)
     else if (Index (keywrd, " PM6-D3H4") /= 0)  then
       write (ifiles_8, "(' *  PM6-D3H4    -  Default parameter set: PM6-D3H4')")
     else if (Index (keywrd, " PM6-D3(H4)") /= 0)  then
       write (ifiles_8, "(' *  PM6-D3(H4)  -  Default parameter set: PM6-D3(H4)')")
! Gallo
     else  if (Index (keywrd, " PM6") /= 0)  then
       write (ifiles_8, "(' *  PM6         -  Default parameter set: PM6')")
     end if
     if (Index (keywrd, " MNDOD") /= 0) &
       write (ifiles_8, "(' *  MNDOD       -  Default parameter set: MNDOD')")
     if (method_PM7) write (ifiles_8, "(' *  PM7         -  Default parameter set: PM7')")
     if (method_PM8) write (ifiles_8, "(' *  PM8         -  Default parameter set: PM8')")
     if (Index (keywrd, " PM5D ") /= 0) &
       write (ifiles_8, "(' *  PM5D        -  Default parameter set: PM5D')")
      if (Index (keywrd, "LARGE") /= 0) then
10000 format (" *  LARGE       -  GENERATE STANDARD MOPAC OUTPUT")
      write (ifiles_8, 10000)
    end if
    if (Index (keywrd, "SAVEG") /= 0) then
10010 format (" *  SAVEG      -  SAVE OPTIMIZED GEOMETRIES")
      write (ifiles_8, 10010)
    end if
    if (Index (keywrd, " NOSAVEP") /= 0) then
10011 format (" *  NOSAVEP    -  DO NOT SAVE OPTIMIZED PARAMETERS")
      write (ifiles_8, 10011)
    end if
    if (Index (keywrd, "FULL") /= 0) then
10021 format (" *  FULL       -  PRINT ALL DERIVATIVES")
      write (ifiles_8, 10021)
    end if
    if (Index (keywrd, "PARALLEL") /= 0) then
10022 format (" *  PARALLEL   -  COMBINE PARAMETERS FROM OTHER RUNNING PARAM JOBS")
      write (ifiles_8, 10022)
    end if
     if (Index (keywrd, "EXPORT") /= 0) &
     & write (ifiles_8, '(" *  EXPORT     -  REMOVE REFERENCE INFO FROM NEW DATA FILE")')
    if (Index (keywrd, "LET") /= 0) then
10040 format (" *  LET        -  CARRY OUT CALCULATION EVEN IF ", "SOME SYSTEMS &
     &ARE FAULTY")
      write (ifiles_8, 10040)
    end if
    if (Index(keywrd, " GNORM") /= 0) then
10041 format (" *  GNORM=     -  EXIT WHEN GRADIENT NORM DROPS BELOW ", g10.3)
      write (ifiles_8, 10041) reada (keywrd, Index (keywrd, " GNORM"))
    end if
    if (Index (keywrd, "CLEAN") /= 0) write(ifiles_8,'(a)') &
    & " * CLEAN       -  REMOVE DIAGNOSTIC KEYWORDS FROM REFERENCE DATA SETS"
    if (Index (keywrd, "ALL") /= 0) then
10042 format (" *  ALL        -  USE ALL REFERENCE DATA, INCLUDING SYSTEMS &
     &NOT BEING OPTIMIZED")
      write (ifiles_8, 10042)
    end if
    if (Index (keywrd, "ONLY") /= 0) then
10043 format (" *  ONLY        -  Use only compounds that contain elements being parameterized.")
      write (ifiles_8, 10043)
    end if
    if (Index (keywrd, "1SCF") /= 0) then
10050 format (" *  1SCF       -  GEOMETRIES ARE NOT TO BE OPTIMIZED ")
      write (ifiles_8, 10050)
    end if
    if (Index (keywrd, " PRECISE") /= 0) then
10055 format (" *  PRECISE    -  USE ""PRECISE"" IN MOPAC")
      write (ifiles_8, 10055)
    end if
    i = Index (keywrd, " PARAB=")
    if (i /= 0) then
10061 format (" *  PARAB=n    -  DAMPENING FACTOR OF",f13.2," USED")
      write (ifiles_8, 10061) Reada(keywrd,i)
    end if
     i = Index (keywrd, " POWER=")
    if (i /= 0) then
10063 format (" *  POWER=n    -  Power to be minimized",f5.2," USED")
      write (ifiles_8, 10063) Reada(keywrd,i)
    end if
    i = Index (keywrd, " RELH=")
    if (i /= 0) then
10051 format (" *  RELH=n     -  Relative weight for Heats of Formation:",f4.1)
      write (ifiles_8, 10051) Reada(keywrd,i)
    end if
    i = Index (keywrd, " RELD=")
    if (i /= 0) then
10052 format (" *  RELD=n     -  Relative weight for Dipole Moments:",f4.1)
      write (ifiles_8, 10052) Reada(keywrd,i)
    end if
     i = Index (keywrd, " RELI=")
    if (i /= 0) then
10053 format (" *  RELI=n     -  Relative weight for Ionization Potentials:",f4.1)
      write (ifiles_8, 10053) Reada(keywrd,i)
    end if
     i = Index (keywrd, " RELG=")
    if (i /= 0) then
10054 format (" *  RELG=n     -  Relative weight for Geometries:",f4.1)
      write (ifiles_8, 10054) Reada(keywrd,i)
    end if
    i = Index (keywrd, " CYCLES=")
    if (i /= 0) then
      j = Nint(Reada(keywrd,i))
      num = char(ichar("2") +int(log10(j + 0.05)))
      write (ifiles_8, '(" *  CYCLES=n    -  RUN A MAXIMUM OF",I'//num//'," CYCLES")') j
    end if
    i = Index (keywrd, " OUT=")
    if (i /= 0) then
      j = Index (keywrd(i+1:), " ") + i
10060 format (" *  OUT=n       -  WRITE OUTPUT TO DIRECTORY ",/19x, a)
      write (ifiles_8, 10060) keywrd(i+5:j)
    end if
    i = Index (keywrd, " PARAMS=")
    if (i /= 0) then
      j = Index (keywrd(i+1:), " ") + i
10071 format (" *  PARAMS=n    -  REFERENCE PARAMETERS TO BE READ FROM DIRECTORY ",/16 x, a)
      write (ifiles_8, 10071) keywrd(i+8:j)
    end if
    i = Index (keywrd, " NEW_REF=")
    if (i /= 0) then
      line = get_a_name(keywrd(i + 9:), len_trim(keywrd(i + 9:)))
      write (ifiles_8, '(" *  NEW_REF=n   -  OPTIMIZED REFERENCE DATA ARE WRITTEN TO DIRECTORY: ",/16 x, a)') trim(line)
      call l_control("CYCLES=0", len("CYCLES=0"), 1)
    end if
    i = Index (keywrd, " NEW_REFP")
    if (i /= 0) then
      j = Index (keywrd(i+1:), " ") + i
10081 format (" *  NEW_RP=n    -  OPTIMIZED PARAMETERS ARE WRITTEN TO DIRECTORY ",/16 x, a)
      write (ifiles_8, 10081) keywrd(i+14:j)
    end if
    if (Index (keywrd, "CHKPAR") /= 0) then
10090 format (" *  CHKPAR      -  CHECK THAT PARAMETER SET IS VALID")
      write (ifiles_8, 10090)
    end if
    if (Index (keywrd, " SURVEY") /= 0) then
10091 format (" *  SURVEY      -  GENERATE TABLES FOR STATISTICS, ETC")
      write (ifiles_8, 10091)
    end if
    if (index(keywrd, " SET") + index(keywrd, " REF") /= 0) &
      write (ifiles_8, "(' *',/1X,15('*****'))")
    i = Index (keywrd, " SET")
    if (i /= 0) then
      i = i + 5
      line = get_a_name(keywrd(i:), len_trim(keywrd(i:)))
      j = i + len_trim(line)
      if (keywrd(j + 1: j + 1) == '"') j = j + 2
      if (keywrd(j:j) == ";") then
        write (ifiles_8, '(" *",/," *  SET=n       -  THE LISTS OF COMPOUNDS TO BE USED ARE IN FILES: ")')
      else
        write (ifiles_8, '(" *",/," *  SET=n       -  THE LIST OF COMPOUNDS TO BE USED IS IN FILE: ")')
      end if
      write (ifiles_8, '(" *",17x,a)')'"'//trim(line)//'"'
      if (keywrd(i + 1: i + 1) == '"') i = i + 2
      do
        i = i + len_trim(line)
        if (keywrd(i + 1: i + 1) == '"') i = i + 2
        if (keywrd(i:i) == ";") then
          i = i + 1
          line = get_a_name(keywrd(i:), len_trim(keywrd(i:)))
          write (ifiles_8, '(" *", 10x, a)')'   and "'//trim(line)//'"'
        else
          exit
        end if
      end do
    end if
    i = Index (keywrd, " REF=")
    if (i /= 0) then
      i = i + 5
      k = end_of_keyword(keywrd, len_trim(keywrd), i)
      line = get_a_name(keywrd(i:k), len_trim(keywrd(i:k)))
      write (ifiles_8, '(" *",/," *  REF=n       -  REFERENCE DATA ARE IN DIRECTORY: ",/," *",17x, a)') '"'//trim(line)//'"'
      do
        j = index(keywrd(i:k), ";")
        if (j /= 0) then
          i = i + j
          line = get_a_name(keywrd(i:), len_trim(keywrd(i:)))
          write (ifiles_8, '(" *", 10x, a)')'   and "'//trim(line)//'"'
        else
          exit
        end if
      end do
    end if
    i = Index(keywrd_quoted, "EXTERNAL=")
    if (i /= 0) then
      i = index(keywrd_quoted(i:), "=") + i
      k = end_of_keyword(keywrd_quoted, len_trim(keywrd_quoted), i)
      line = get_a_name(keywrd_quoted(i:k), len_trim(keywrd_quoted(i:k)))
      write (ifiles_8, '(" *",/," *  EXTERNAL=n  -  DEFAULT PARAMETERS RESET USING&
                        & DATA IN FILES: ",/," *",17x, a)') '"'//trim(line)//'"'
      do
        j = index(keywrd_quoted(i:k), ";")
        if (j /= 0) then
          i = i + j
          line = get_a_name(keywrd_quoted(i:), len_trim(keywrd_quoted(i:)))
          write (ifiles_8, '(" *", 10x, a)')'   and "'//trim(line)//'"'
        else
          exit
        end if
      end do
    else if (Index(keywrd, "EXTERNAL") /= 0) then
      write (ifiles_8, '(" *  EXTERNAL   - DEFAULT PARAMETERS RESET USING DATA IN INPUT FILE")')
    end if
    return
  end subroutine parkey

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  SUBROUTINE graphics(xx, yy, Action ) 
!
! Subroutine "graphics" looks after all graphical operations
!
! On input xx = x-coordinate of the point from the non-graphics side of the program 
!          yy = y-coordinate of the point from the non-graphics side of the program
!
! Action: An integer with value 1, 2, 3, 6, 99, 100, idicating which graphics task is to be done.
!
  USE IFQWIN   
  use common_common, only : line, xscale, yscale, xoffset, yoffset, top_left_x, top_left_y
  implicit none
  interface
  subroutine Details_of_cursor_point(unit, mouseevent, keystate, MouseXpos,MouseYpos)
      INTEGER unit
      INTEGER mouseevent
      INTEGER keystate
      INTEGER MouseXpos
      INTEGER MouseYpos
    end subroutine 
  end interface
  integer, intent (in) :: Action
  real, intent (in) :: xx, yy
  !
  ! Local
  !
 ! real :: xoffset,          &  ! Define the relative position on the monitor
 !         yoffset,          &  ! Define the relative position on the monitor
 !         xscale  =  450.0, &  ! Convert from non-graphics coordinates to graphics coordinates
 !         yscale  =  450.0, &  ! Convert from non-graphics coordinates to graphics coordinates
  real ::        x, y
  integer(4) ::   i, j, k, l, col(3), all_colors(50)
  INTEGER(2) :: color, pick_color
  TYPE (windowconfig) :: myscreen
  TYPE (qwinfo)      :: FrameSize
  TYPE (xycoord) :: xy
  character :: type_font*30, num1*1, num2*1
  logical :: status, l_font = .false.
!
! All colors used for lines, expressed as three fractions per color, blue,green,red
!
  real, dimension (3,50) :: colors = (/& 
& 0.0,0.0,1.0,  0.0,0.1,0.9,  0.0,0.2,0.8, 0.0,0.3,0.7, 0.0,0.4,0.6, &
& 0.0,0.5,0.5,  0.0,0.6,0.4,  0.0,0.7,0.3, 0.0,0.8,0.2, 0.0,0.9,0.1, &
& 0.0,1.0,0.0,  0.0,1.0,0.1,  0.0,1.0,0.2, 0.0,1.0,0.3, 0.0,1.0,0.4, &
& 0.0,1.0,0.5,  0.0,1.0,0.6,  0.0,1.0,0.7, 0.0,1.0,0.8, 0.0,1.0,0.9, &
& 1.0,0.0,1.0,  1.0,0.1,0.9,  1.0,0.2,0.8, 1.0,0.3,0.7, 1.0,0.4,0.6, &
& 1.0,0.5,0.5,  1.0,0.6,0.4,  1.0,0.7,0.3, 1.0,0.8,0.2, 1.0,0.9,0.1, &
& 1.0,1.0,0.0,  1.0,1.0,0.1,  1.0,1.0,0.2, 1.0,1.0,0.3, 1.0,1.0,0.4, &
& 1.0,1.0,0.5,  1.0,1.0,0.6,  1.0,1.0,0.7, 1.0,1.0,0.8, 1.0,1.0,0.9, &
& 1.0,0.0,1.0,  1.0,0.1,1.0,  1.0,0.2,1.0, 1.0,0.3,1.0, 1.0,0.4,1.0, &
& 1.0,0.5,1.0,  1.0,0.6,1.0,  1.0,0.7,1.0, 1.0,0.8,1.0, 1.0,0.9,1.0  &
 /)
save
  select case (Action)
!
!
  case (1) !  Run one time only, to set up graphics initialization
!
!  Create graphics window frame to fill the whole screen
!
    Status=GETWSIZEQQ(QWIN$FRAMEWINDOW,QWIN$SIZEMAX,FrameSize)
    Status=SETWSIZEQQ(QWIN$FRAMEWINDOW,FrameSize)
!
!  Create  child window to hold text
!

    OPEN (UNIT = 6, FILE = 'USER', IOFOCUS = .TRUE.)
    myscreen.numxpixels = int2(0.40*FrameSize.W)  ! Width of the text window
    myscreen.numypixels = int2(0.75*FrameSize.H)  ! Height of the text window
    myscreen.numtextcols=-1
    myscreen.numtextrows=-1
    myscreen.numcolors=-1
    myscreen.fontsize=-1
    myscreen.title = "Text "C ! Title of the graphics screen
    status = SETWINDOWCONFIG(myscreen) ! Set configuration of the graphics window
    Framesize.X = 0
    Status=SETWSIZEQQ(6,FrameSize)
!
!  Background colors are set in six bytes: BBGGRR. White is FFFFFF and black is 000000.
!  Colow child window white
!
    i=setbkcolorrgb(#FFFFFF)   !! white background
    i=settextcolorrgb(#000000) !! black text
    call clearscreen($GCLEARSCREEN)
!
!  Create child window to hold graphics
!
    OPEN (UNIT = 10, FILE = 'USER', IOFOCUS = .TRUE.)

    myscreen.numxpixels = int2(0.60*FrameSize.W)   ! Width of the graphics window
    myscreen.numypixels = int2(0.90*FrameSize.H)  ! Height of the graphics window
    myscreen.numtextcols=-1
    myscreen.numtextrows=-1
    myscreen.numcolors=-1
    myscreen.fontsize=-1
    myscreen.title = "Program BZ "C ! Title of the graphics screen
    status = SETWINDOWCONFIG(myscreen) ! Set configuration of the graphics window
!
!  Position child window for graphics
!
    Framesize.TYPE = QWIN$SET
    Framesize.X = 0.053*Framesize.W     ! Position graphics window to the right of the screen
    top_left_x  = Framesize.X
    top_left_y  = Framesize.Y
    Status=SETWSIZEQQ(10,FrameSize)
    i = SETBKCOLORRGB(Z'FFFFFF')
    call clearscreen($GCLEARSCREEN)
    Status = REGISTERMOUSEEVENT (10, MOUSE$LBUTTONDOWN, Details_of_cursor_point)
    xoffset = 70.0
    yoffset = 40.0
    xscale  =  450.0*framesize.W/1920.0 ! Convert from non-graphics coordinates to graphics coordinates
    yscale  =  450.0*framesize.H/1133.0 ! Convert from non-graphics coordinates to graphics coordinates

    pick_color = 0
!
!  Set colors used in lines as four-byte integers. 
!
!  Byte 1: Red
!  Byte 2: Green
!  Byte 3: Blue
!  Byte 4: not used
!
    do i = 1,50
      do l = 1,3
      j = nint(colors(l,i)*255)
      col(l) = j
      end do
      all_colors(i) = col(1) + 256*(col(2) + 256*col(3))
    end do      
!
! Construct part of format for text
!
    i = nint((18*framesize.H)/1133.0)
    num1 = char(ichar("1") + i/10)
    j = nint((10*framesize.W)/1920.0)
    num2 = char(ichar("1") + j/10)
!
! Set up fonts
!
    i = INITIALIZEFONTS()
    return
!
!
  case (2) ! Move to new point, don't draw a line
    i = SETACTIVEQQ(10)
    i = FOCUSQQ(10)
    x = xx*xscale + xoffset
    y = yy*yscale + yoffset
    CALL MOVETO(int2(x), int2(y), xy ) 
    return
!
!
  case (3) ! Move to new point drawing a line from the old point
    x = xx*xscale + xoffset
    y = yy*yscale + yoffset
    i = LINETO(int2(x), int2(y)) 
    return
!
!
  case (6)  ! Run each time a new picture is drawn, initialize a picture.  
    i = SETACTIVEQQ(10)
    i = FOCUSQQ(10)
    CALL SETVIEWORG( INT2(0),  INT2( 0 ), xy )
    call clearscreen($GCLEARSCREEN)
    i = SETCOLORRGB(Z'000000')
    pick_color = 0
    return
!
!
  case (96)  ! Write text to graph in Arial and Symbol
    i = SETCOLORRGB(Z'000000')
    write(type_font,'(a,i'//num1//',a,i'//num2//',a)')"t'Arial'h" ,i, "w", j, "vb'"
    if (len_trim(line) == 3) then
      if (line(3:3) == "G") write(type_font,'(a,i'//num1//',a,i'//num2//',a)')"t'Symbol'h" ,i, "w", j, "vb'"
      if (line(3:3) == "G" .or. line(3:3) == "R")line(3:3) = " "
    end if
    i = SETFONT(trim(type_font))
    x = xx*xscale + xoffset
    y = yy*yscale + yoffset
    CALL MOVETO(int2(x), int2(y), xy )
    call OUTGTEXT(trim(line))
    return
!
!
  case (97)  ! Set focus to channel 6

    i = FOCUSQQ(6)
    return
!
!
  case (98)  ! Select black

    i = SETACTIVEQQ(10)
    i = FOCUSQQ(10)
    i = SETCOLORRGB(Z'000000')
    return
!
!
    case (99)  ! Select color
    pick_color = pick_color + 1
    if (pick_color == 50) pick_color = 1 
    i = SETCOLORRGB(all_colors(pick_color))
    return
!
!
  case (100)  ! Run one time only, to gracefully terminate the job
    i = SETEXITQQ(QWIN$EXITNOPERSIST)
    return
  end select
END SUBROUTINE graphics

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine picopt (loop)
    use molkst_C, only: natoms, numat, nvar, ndep, numcal
    use common_arrays_C, only: loc, nbonds, ibonds, labels
    use symmetry_C, only : locdep
    use MOZYME_C, only : jopt, numred
    implicit none
    integer, intent (in) :: loop
    integer, allocatable :: iopt_loc(:)
!
    integer :: i, j, imol = 0
   !***********************************************************************
   !                                                                      *
   !   PICOPT DETERMINES WHICH ATOMS ARE TO BE USED IN THE SCF.           *
   !                                                                      *
   !   THIS DETERMINATION IS BASED ON THE FOLLOWING:                      *
   !                                                                      *
   !     LOOP=-1:     USE ALL ATOMS                                       *
   !                  ELSE USE ATOMS MARKED FOR OPTIMIZATION IN LOC.      *
   !                  PLUS ANY ATOMS DEFINED BY SYMMETRY                  *
   !                                                                      *
   !    ON EXIT, JOPT   = ATOM NUMBERS OF ATOMS TO BE USED IN SCF         *
   !             NUMRED = NUMBER OF ATOMS IN JOPT                         *
   !                                                                      *
   !   iopt is scratch,                                                   *
   !   LOC, NBONDS, IBONDS, LABELS, and LOCDEP are reference arrays       *
   !                                                                      *
   !***********************************************************************
    allocate (iopt_loc(natoms))
    if (loop ==-1) then
      iopt_loc = 1
    else
      iopt_loc = 0
      !
      !   USE THE GEOMETRY SUPPLIED
      !
      iopt_loc = 0
      do i = 1, nvar
        iopt_loc(loc(1, i)) = 2
      end do
      do i = 1, ndep
        iopt_loc(locdep(i)) = 2
      end do
      !
      !   AT THIS POINT, iopt_loc REFERS TO ALL ATOMS, INCLUDING DUMMIES.
      !   IN THE FOLLOWING SECTION, WE NEED TO WORK WITH REAL ATOMS
      !   ONLY
      !
      j = 0
      do i = 1, natoms
        if (labels(i) /= 99) then
          j = j + 1
          iopt_loc(j) = iopt_loc(i)
        end if
      end do
      !
      !   IOPT IS NOW OVER REAL ATOMS ONLY
      !
      if (imol == numcal) then
        do i = 1, numat
          if (iopt_loc(i) == 2) then
            do j = 1, nbonds(i)
              if (iopt_loc(ibonds(j, i)) == 0) then
                iopt_loc(ibonds(j, i)) = 1
              end if
            end do
          end if
        end do
      end if
    end if
    imol = numcal
    numred = 0
    jopt = 0
    do i = 1, numat
      if (iopt_loc(i) /= 0) then
        numred = numred + 1
        jopt(numred) = i
      end if
    end do
    return
end subroutine picopt

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine coe(x2, y2, z2, norbi, norbj, c, r)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: norbi
      integer , intent(in) :: norbj
      double precision , intent(in) :: x2
      double precision , intent(in) :: y2
      double precision , intent(in) :: z2
      double precision , intent(out) :: r
      double precision , intent(out) :: c(75)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: nij
      double precision :: rt34, rt13, xy, ca, cb, sa, sb, c2a, c2b, s2a, s2b
!-----------------------------------------------
      data rt34/ 0.86602540378444D0/
      data rt13/ 0.57735026918963D0/
      xy = x2**2 + y2**2
      r = sqrt(xy + z2**2)
      xy = sqrt(xy)
      if (xy >= 1.D-10) then
        ca = x2/xy
        cb = z2/r
        sa = y2/xy
        sb = xy/r
      else
        if (z2 <= 0.D0) then
          if (z2 /= 0.D0) then
            ca = -1.D0
            cb = -1.D0
            sa = 0.D0
            sb = 0.D0
            go to 50
          end if
          ca = 0.D0
          cb = 0.D0
          sa = 0.D0
          sb = 0.D0
          go to 50
        end if
        ca = 1.D0
        cb = 1.D0
        sa = 0.D0
        sb = 0.D0
      end if
   50 continue
      c = 0.D0
      nij = max(norbi,norbj)
      c(37) = 1.D0
      if (nij >= 2) then
        c(56) = ca*cb
        c(41) = ca*sb
        c(26) = -sa
        c(53) = -sb
        c(38) = cb
        c(23) = 0.D0
        c(50) = sa*cb
        c(35) = sa*sb
        c(20) = ca
        if (nij >= 5) then
          c2a = 2*ca*ca - 1.D0
          c2b = 2*cb*cb - 1.D0
          s2a = 2*sa*ca
          s2b = 2*sb*cb
          c(75) = c2a*cb*cb + 0.5D0*c2a*sb*sb
          c(60) = 0.5D0*c2a*s2b
          c(45) = rt34*c2a*sb*sb
          c(30) = -s2a*sb
          c(15) = -s2a*cb
          c(72) = -0.5D0*ca*s2b
          c(57) = ca*c2b
          c(42) = rt34*ca*s2b
          c(27) = -sa*cb
          c(12) = sa*sb
          c(69) = rt13*sb*sb*1.5D0
          c(54) = -rt34*s2b
          c(39) = cb*cb - 0.5D0*sb*sb
          c(66) = -0.5D0*sa*s2b
          c(51) = sa*c2b
          c(36) = rt34*sa*s2b
          c(21) = ca*cb
          c(6) = -ca*sb
          c(63) = s2a*cb*cb + 0.5D0*s2a*sb*sb
          c(48) = 0.5D0*s2a*s2b
          c(33) = rt34*s2a*sb*sb
          c(18) = c2a*sb
          c(3) = c2a*cb
        end if
      end if
      return
      end subroutine coe

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

double precision function pargeo (grad, wtgeo, refgeo, loc, diffs, ndif)
  !***********************************************************************
  !
  !   PARGEO  1:  Computes the gradient error.
  !
  !***********************************************************************
    use molkst_C, only : nvar
    use param_global_C, only : power, wtz
    implicit none
    double precision, dimension (300), intent (in) :: grad
    double precision, intent (in) :: wtgeo
    character (len=12), dimension (300), intent (in) :: refgeo
    integer, dimension (2, 300), intent (in) :: loc
    double precision, dimension (300), intent (inout) :: diffs
    integer, intent (out) :: ndif
    integer :: i, lim
    double precision :: relative_weight, sum
    intrinsic Min
!------------------------------------------------------------------------
    lim = Min (100, nvar)
    ndif = 0
    sum = 0.d0
    do i = 1, lim
      if (refgeo(i) /= " ") then
        ndif = ndif + 1
        if (loc(2, i) == 1) then
                                      !
          relative_weight = 1.d0      !  Relative weight of bond-length
                                      !
        else if (loc(2, i) == 2) then !
                                      !
          relative_weight = 1.d0      !  Relative weight of bond-angle
                                      !
        else if (loc(2,i) == 3) then  !
                                      !
          relative_weight = 1.d0      !  Relative weight of dihedral
                                      !
        end if
        diffs(ndif) = grad(i) * wtgeo * relative_weight * wtz
        sum = sum + Abs(diffs(ndif)) ** power
      end if
    end do
    pargeo = sum
end function pargeo

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

logical function connected(atom_i, atom_j, criterion)
!
!   "connected" is true if atom_i and atom_j are within sqrt(criterion) Angstroms
!   of each other, false otherwise.
!
!   if "connected" then:
!
!   If the system is infinite (polymer, layer or solid),
!   then cell_ijk will hold the unit cell translation indices that move atom_j near to
!   atom_i, zero therwise.
!
!   Vab is the position of atom_i relative to atom_j
!
!   Rab is distance from atom_i to atom_j
!
!   if not "connected" then Rab, Vab, and cell_ijk are meaningless.
!
  use molkst_C, only : id, Rab
  use common_arrays_C, only: coord, Vab
  implicit none
  double precision ::  criterion
  integer :: atom_i, atom_j
  double precision, external :: distance
!
  if (id == 0) then
    Vab = coord(:,atom_i) - coord(:,atom_j)
    Rab = Vab(1)**2 + Vab(2)**2 + Vab(3)**2
  else
    Rab = distance(atom_i, atom_j)**2
  end if
  connected = (Rab < criterion)
  if (connected) Rab = sqrt(Rab)
  return
end function connected
subroutine find_XH_bonds(acc, nacc, h_b, nhb)
!
!  Locate all hydrogen atoms involved in O-H and N-H bonds
!  On exit:
!  nhb:   Number of hydrogen atoms involved in O-H or N-H bonds
!  h_b:   Atom numbers of the hydrogen atoms
!
  use molkst_C, only : numat, method_PM7, method_pm6_dh_plus, method_pm6_d3h4, method_pm6_d3h4x
  use common_arrays_C, only: nat
  implicit none
  integer :: nacc, nhb

  integer :: acc(numat), h_b(numat)
  integer :: i, j, is
  double precision :: RAH
  logical :: used(numat)
  logical, external :: connected
    if (method_pm6_dh_plus) then
      RAH = 1.4d0
      is = 8
    else if (method_PM7) then
      RAH = 1.4d0
      is = 8  ! Change to 16 ASAP
    else if (method_pm6_d3h4 .or. method_pm6_d3h4x) then
      RAH = 1.15d0
      is = 8
    else
      RAH = 1.15d0
      is = 16
    end if
    used = .false.
    nacc = 0
    nhb  = 0
    do i = 1, numat
      if (nat(i) ==  7 .or. nat(i) ==  8 .or. nat(i) ==  is) then
        nacc = nacc + 1
        acc(nacc) = i
        do j = 1, numat
          if (nat(j) ==  1 .and. .not. used(j)) then
            if (connected(i, j, RAH**2)) then
              nhb = nhb + 1
              h_b(nhb) = j
              used(j) = .true.
            end if
          end if
        end do
      end if
    end do
end subroutine find_XH_bonds
subroutine find_H__Y_bonds(acc_a, nacc_a, acc_b, nacc_b, bonding_a_h, nb_a_h, hblist1, hblist2, hblist3, max_h_bonds, nrpairs)
!
!  Find all sets of three atoms that form a hydrogen bond
!
!   acc_a:       All O and N atoms
!   bonding_a_h: Hydrogen atoms bonded to acc_a, not in any particular order
!
  use chanel_C, only : iw
  use funcon_C, only : pi
  use molkst_C, only : keywrd, method_pm7
  implicit none
  integer :: nacc_a, nacc_b, nb_a_h, nrpairs, max_h_bonds
  integer :: acc_a(nacc_a), acc_b(nacc_b), bonding_a_h(nb_a_h), hblist1(max_h_bonds), hblist2(max_h_bonds), hblist3(max_h_bonds)
  integer:: ii, i, jj, j, kk, k, i1
  double precision :: RAH, cutoff
  logical, external :: connected
  double precision, external :: angle
  if (index(keywrd, "PM6-DH+") /= 0 ) then
      RAH = 1.4d0
      cutoff = 10.d0
    else if (method_PM7) then
      RAH = 1.4d0
      cutoff = 7.d0
    else
!
!  "cutoff" had been set to 7.0, but that had caused problems with the radial term "e_radial"
!  in H_bonds4.F90.  "e_radial" increases sharply beyond 5.5 Angstroms.
!
      RAH = 1.15d0
      cutoff = 5.5d0
    end if
    do ii = 1, nacc_a
      i = acc_a(ii)   !  i = Acceptor atom bonded to H
      do jj = 1, nb_a_h
        j = bonding_a_h(jj)   !  j = Hydrogen bond to acceptor atom
        if (connected(i, j, RAH**2)) then
          do kk = 1, nacc_b
            k = acc_b(kk)
            if (k /= i) then
              if (connected(k, i, cutoff**2)) then
                if (angle(k,j,i) > pi*0.5d0) then
!
!  Eliminate bonds of type O(n) - H - O(m) if O(m) - H - O(n) exists
!
                  do i1 = 1, nrpairs
                    if (hblist2(i1) /= j) cycle
                    if (hblist1(i1) /= k) cycle
                    if (hblist3(i1) /= i) cycle
                    exit
                  end do
                  if (i1 /= nrpairs + 1) cycle
                  do i1 = 1, nrpairs
                    if (hblist2(i1) /= j) cycle
                    if (hblist1(i1) /= i) cycle
                    if (hblist3(i1) /= k) cycle
                    exit
                  end do
                  if (i1 /= nrpairs + 1) cycle
                  nrpairs = nrpairs + 1 !  k = Distant acceptor atom
                  if (nrpairs > max_h_bonds) then
                    call mopend("The default array size for hydrogen bonds is too small")
                    write(iw,'(9x,a,i6,a,i6)')" Array size:", max_h_bonds,", estimated size needed:", &
                      nint(float(max_h_bonds)*float(nacc_a)/float(ii))
                    nrpairs = nrpairs - 1
                    return
                  end if
                  hblist3(nrpairs) = k ! O or N hydrogen-bonded to hydrogen j
                  hblist2(nrpairs) = j ! H singly bonded to i
                  hblist1(nrpairs) = i ! O or N of single bond to H
                end if
              end if
            end if
          end do
        end if
      end do
    end do
    return
  end subroutine find_H__Y_bonds

  function truncation(R, limit, spread)
!
!  Truncation has the values:
!
!  limit, when R < limit - spread
!  greater than R when R is in the range: limit - spread < R < limit + spread
!  R, when R > limit + spread
!
!  At limit + spread, the slope of truncation is 1, i.e., equal to the slope for R > limit + spread
!  At limit - spread, the slope is zero, i.e., equal to the slope of the constant "limit"
!
  implicit none
  double precision, intent(in) :: R, limit, spread
  double precision :: truncation, a, b
    a = limit - spread
    b = limit + spread
    if (R < b) then
      if (R < a) then
        truncation = limit
      else
        truncation = limit + (limit - a)/(a - b)**2*(R - a)**2
      end if
    else
      truncation = R
    end if
    return
  end function truncation



  subroutine all_h_bonds(hblist1, hblist2, hblist3, max_h_bonds, nrpairs)
!
!  all_h_bonds detects all potential hydrogen bonds.  A hydrogen bond is a set of three atoms,
!  an oxygen or nitrogen, a hydrogen, and an oxygen or nitrogen atom.  The hydrogen atom must
! be within RAH Angstroms of either an oxygen or a nitrogen atom.
!
!  On exit:
!
!    nrpairs: number of pairs of atoms
!    hblist1: Atom number of oxygen or nitrogen attached to hydrogen
!    hblist2: Atom number of hydrogen atom involved in hydrogen bonding
!    hblist3: Atom number ofoxygen or nitrogen hydrogen bonded to the hydrogen atom
!
!
  use common_arrays_C, only: bonding_a_h, bonding_b_h, acceptor_a, acceptor_b
  use molkst_C, only : numat, line, moperr
  use chanel_C, only : iw
  implicit none
    integer, intent (in) :: max_h_bonds
    integer, intent (out) :: hblist1(max_h_bonds), hblist2(max_h_bonds), hblist3(max_h_bonds), nrpairs
!
!  Local variables
!
    integer :: i, nacceptor_a, nbonding_a_h
!
!  Work out list of of potential hydrogen bonds
!
!   First, find all N-H and O-H groups
!
    if (allocated(acceptor_a))   deallocate(acceptor_a)
    if (allocated(acceptor_b))   deallocate(acceptor_b)
    if (allocated(bonding_a_h))  deallocate(bonding_a_h)
    if (allocated(bonding_b_h))  deallocate(bonding_b_h)
    allocate (acceptor_a(numat*2), acceptor_b(numat*2), bonding_a_h(numat*2), &
      bonding_b_h(numat*2), stat=i)
    if (i /= 0) then
      line = " Cannot allocate arrays for hydrogen bonds"
      write(iw,*)" Cannot allocate arrays for hydrogen bonds"
      call to_screen(trim(line))
      call mopend(trim(line))
      return
    end if
    call find_XH_bonds(acceptor_a, nacceptor_a, bonding_a_h, nbonding_a_h)
!
!  acceptor_a now holds the list of acceptor O and N atoms (for the first fragment)
!  acceptor_b now holds the list of acceptor O and N atoms (for the second fragment, if it exists)
!  bonding_a_h now holds the list of H atoms attached to an O or N (for the first fragment)
!  bonding_b_h now holds the list of H atoms attached to an O or N (for the second fragment, if it exists)
!
!
!  Find if there is a hydrogen bond
!
    nrpairs = 0
    call find_H__Y_bonds(acceptor_a, nacceptor_a, acceptor_a, nacceptor_a, &
      bonding_a_h, nbonding_a_h, hblist1, hblist2, hblist3, max_h_bonds, nrpairs)
    if (moperr) return
  end subroutine all_h_bonds

  double precision function distance(a, b)
    use common_arrays_C, only: coord, tvec, cell_ijk, Vab
    use molkst_C, only : id, l1u, l2u, l3u, temp_1, temp_2, temp_3
    implicit none
      integer :: a,  b
      integer :: ik, jk, kl
      double precision :: coord1(3), sum
      if (id == 0) then
        temp_1 = coord(1, a)-coord(1, b)
        temp_2 = coord(2, a)-coord(2, b)
        temp_3 = coord(3, a)-coord(3, b)
        distance = sqrt(temp_1**2 + temp_2**2 + temp_3**2)
        Vab(:) = coord(:, a) - coord(:, b)
      else
        distance = 1.d6
        do ik = -l1u, l1u
          do jk = -l2u, l2u
            do kl = -l3u, l3u
              coord1(:) = coord(:, a) + tvec(:, 1)*ik + tvec(:, 2)*jk + tvec(:, 3)*kl
              sum =  (coord1(1)-coord(1, b))**2 &
                   + (coord1(2)-coord(2, b))**2 &
                   + (coord1(3)-coord(3, b))**2
              if (sum < distance) then
                distance = sum
                temp_1 = coord1(1)-coord(1, b)
                temp_2 = coord1(2)-coord(2, b)
                temp_3 = coord1(3)-coord(3, b)
                Vab(:) = coord1(:)-coord(:, b)
                cell_ijk(1) = ik
                cell_ijk(2) = jk
                cell_ijk(3) = kl
              end if
            end do
          end do
        end do
        distance = sqrt(distance)
      end if
  end function distance
  double precision function angle(a, b, c)
    use common_arrays_C, only: coord
      integer :: a,  b,  c
      call bangle(coord, a, b, c, angle)
  end
  double precision function torsion(i, j, k, l)
      use common_arrays_C, only: coord
      integer :: i,  j,  k,  l
      call dihed (coord, i, j, k, l, torsion)
  end

  double precision function bonding(x, y, covrad)
    use common_arrays_C, only: nat
    implicit none
    integer,  INTENT(IN) :: x, y
    double precision :: covrad(94)
      bonding = covrad(nat(x)) + covrad(nat(y))
    return
  end function bonding

  subroutine prt_hbonds(D, H, A, energy)
  use common_arrays_C, only: nat, txtatm, H_txt, H_energy
  use molkst_C, only : numat, keywrd, numcal, P_hbonds, maxtxt
  use elemts_C, only: elemnt
  implicit none
  integer, intent (in) :: D, H, A
  double precision, intent (in) :: energy
!
!  Local
!
  integer :: icalcn = -1
  double precision :: cutoff, sum1
  double precision, external :: distance, reada
  logical :: prt_first
  save :: prt_first, cutoff, icalcn
    if (icalcn /= numcal) then
      icalcn = numcal
      if (allocated(H_txt)) deallocate (H_txt, H_energy)
      prt_first = .true.
      allocate(H_txt(numat), H_energy(numat))
      P_hbonds = 0
    end if
    if (prt_first) then
      prt_first = .false.
      cutoff = reada(keywrd, index(keywrd," DISP("))
      cutoff = -abs(cutoff)
      P_Hbonds = 0
    end if
    if (energy > -0.5d0) return
    sum1 = distance(D,H)
    P_Hbonds = min(numat, P_Hbonds + 1)
    if (txtatm(D) == " ") write(txtatm(D),'(a,i5,3x,a)')"Atom No.:", D, elemnt(nat(D))
    if (txtatm(H) == " ") write(txtatm(H),'(a,i5,3x,a)')"Atom No.:", H, elemnt(nat(H))
    if (txtatm(A) == " ") write(txtatm(A),'(a,i5,3x,a)')"Atom No.:", A, elemnt(nat(A))
    if (maxtxt == 0) then
      write(H_txt(P_Hbonds),'(2x,a,f15.3,6x,a,12x,a,10x, f7.2,a)')trim(txtatm(D)), sum1,  &
      trim(txtatm(H)), trim(txtatm(A)), energy, " Kcal/mol"
    else
      write(H_txt(P_Hbonds),'(a,2x,f6.3,3x,a,3x,a,3x, f7.2,a)')""""//txtatm(D)(:maxtxt)//"""", sum1,  &
      """"//txtatm(H)(:maxtxt)//"""", """"//txtatm(A)(:maxtxt)//"""", energy, " Kcal/mol"
    end if
    H_energy(P_Hbonds) = energy
    return
  end subroutine prt_hbonds

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  subroutine alpb_and_xfac_am1
    use parameters_C, only : xfac, alpb
    xfac = 0.d0
    alpb = 0.d0
    alpb( 3, 1) =   2.975116d0 !     Lithium -     Hydrogen
    xfac( 3, 1) =  10.000006d0 !     Lithium -     Hydrogen
    alpb( 3, 3) =   2.074231d0 !     Lithium -      Lithium
    xfac( 3, 3) =  10.000005d0 !     Lithium -      Lithium
    !
    alpb( 4, 1) =   1.521999d0 !   Beryllium -     Hydrogen
    xfac( 4, 1) =   0.535972d0 !   Beryllium -     Hydrogen
    alpb( 4, 4) =   0.999154d0 !   Beryllium -    Beryllium
    xfac( 4, 4) =   0.441202d0 !   Beryllium -    Beryllium
    !
    alpb( 6, 3) =   1.709195d0 !      Carbon -      Lithium
    xfac( 6, 3) =   1.679411d0 !      Carbon -      Lithium
    alpb( 6, 4) =   0.999473d0 !      Carbon -    Beryllium
    xfac( 6, 4) =   0.132557d0 !      Carbon -    Beryllium
    !
    alpb( 7, 3) =   1.924790d0 !    Nitrogen -      Lithium
    xfac( 7, 3) =   1.762718d0 !    Nitrogen -      Lithium
    alpb( 7, 4) =   0.999523d0 !    Nitrogen -    Beryllium
    xfac( 7, 4) =   0.099561d0 !    Nitrogen -    Beryllium
    !
    alpb( 8, 3) =   1.873415d0 !      Oxygen -      Lithium
    xfac( 8, 3) =   1.294666d0 !      Oxygen -      Lithium
    alpb( 8, 4) =   2.816061d0 !      Oxygen -    Beryllium
    xfac( 8, 4) =   1.104010d0 !      Oxygen -    Beryllium
    !
    alpb( 9, 3) =   1.890271d0 !    Fluorine -      Lithium
    xfac( 9, 3) =   1.542043d0 !    Fluorine -      Lithium
    alpb( 9, 4) =   1.866431d0 !    Fluorine -    Beryllium
    xfac( 9, 4) =   0.411014d0 !    Fluorine -    Beryllium
    !
    alpb(11, 1) =   2.430601d0 !      Sodium -     Hydrogen
    xfac(11, 1) =   9.994724d0 !      Sodium -     Hydrogen
    alpb(11, 6) =   1.711276d0 !      Sodium -       Carbon
    xfac(11, 6) =   2.226935d0 !      Sodium -       Carbon
    alpb(11, 7) =   2.323882d0 !      Sodium -     Nitrogen
    xfac(11, 7) =  10.000002d0 !      Sodium -     Nitrogen
    alpb(11, 8) =   2.161260d0 !      Sodium -       Oxygen
    xfac(11, 8) =   4.057658d0 !      Sodium -       Oxygen
    alpb(11, 9) =   2.056819d0 !      Sodium -     Fluorine
    xfac(11, 9) =   3.274203d0 !      Sodium -     Fluorine
    alpb(11,11) =   1.612164d0 !      Sodium -       Sodium
    xfac(11,11) =   9.944446d0 !      Sodium -       Sodium
    !
    alpb(12, 1) =   2.174856d0 !   Magnesium -     Hydrogen
    xfac(12, 1) =   2.832813d0 !   Magnesium -     Hydrogen
    alpb(12, 6) =   2.216434d0 !   Magnesium -       Carbon
    xfac(12, 6) =   2.837201d0 !   Magnesium -       Carbon
    alpb(12, 7) =   2.091799d0 !   Magnesium -     Nitrogen
    xfac(12, 7) =   1.504138d0 !   Magnesium -     Nitrogen
    alpb(12, 8) =   1.666897d0 !   Magnesium -       Oxygen
    xfac(12, 8) =   0.472916d0 !   Magnesium -       Oxygen
    alpb(12, 9) =   2.142571d0 !   Magnesium -     Fluorine
    xfac(12, 9) =   1.227425d0 !   Magnesium -     Fluorine
    alpb(12,12) =   1.794083d0 !   Magnesium -    Magnesium
    xfac(12,12) =  10.000008d0 !   Magnesium -    Magnesium
    !
    alpb(14,12) =   1.900000d0 !     Silicon -    Magnesium
    xfac(14,12) =   2.000000d0 !     Silicon -    Magnesium
    !
    alpb(15,11) =   1.850000d0 !  Phosphorus -       Sodium
    xfac(15,11) =   2.000000d0 !  Phosphorus -       Sodium
    !
    alpb(16, 3) =   2.693882d0 !      Sulfur -      Lithium
    xfac(16, 3) =  10.000007d0 !      Sulfur -      Lithium
    alpb(16, 4) =   0.999448d0 !      Sulfur -    Beryllium
    xfac(16, 4) =   0.200086d0 !      Sulfur -    Beryllium
    alpb(16,11) =   1.903681d0 !      Sulfur -       Sodium
    xfac(16,11) =   1.053743d0 !      Sulfur -       Sodium
    alpb(16,12) =   1.572524d0 !      Sulfur -    Magnesium
    xfac(16,12) =   0.571504d0 !      Sulfur -    Magnesium
    !
    alpb(17, 3) =   1.779447d0 !    Chlorine -      Lithium
    xfac(17, 3) =   1.436235d0 !    Chlorine -      Lithium
    alpb(17, 4) =   1.382661d0 !    Chlorine -    Beryllium
    xfac(17, 4) =   0.211418d0 !    Chlorine -    Beryllium
    alpb(17,11) =   1.968902d0 !    Chlorine -       Sodium
    xfac(17,11) =   4.053650d0 !    Chlorine -       Sodium
    alpb(17,12) =   1.875713d0 !    Chlorine -    Magnesium
    xfac(17,12) =   1.195314d0 !    Chlorine -    Magnesium
    !
    alpb(19, 1) =   2.224557d0 !   Potassium -     Hydrogen
    xfac(19, 1) =   9.800241d0 !   Potassium -     Hydrogen
    alpb(19, 6) =   1.687938d0 !   Potassium -       Carbon
    xfac(19, 6) =   3.166630d0 !   Potassium -       Carbon
    alpb(19, 7) =   1.938615d0 !   Potassium -     Nitrogen
    xfac(19, 7) =   7.651496d0 !   Potassium -     Nitrogen
    alpb(19, 8) =   1.461751d0 !   Potassium -       Oxygen
    xfac(19, 8) =   1.046264d0 !   Potassium -       Oxygen
    alpb(19, 9) =   1.402823d0 !   Potassium -     Fluorine
    xfac(19, 9) =   0.811417d0 !   Potassium -     Fluorine
    alpb(19,16) =   3.439238d0 !   Potassium -       Sulfur
    xfac(19,16) =   9.817827d0 !   Potassium -       Sulfur
    alpb(19,17) =   2.072076d0 !   Potassium -     Chlorine
    xfac(19,17) =   8.149694d0 !   Potassium -     Chlorine
    alpb(19,19) =   1.267822d0 !   Potassium -    Potassium
    xfac(19,19) =   9.852489d0 !   Potassium -    Potassium
    !
    alpb(20, 1) =   1.593033d0 !     Calcium -     Hydrogen
    xfac(20, 1) =   3.654870d0 !     Calcium -     Hydrogen
    alpb(20, 6) =   1.005258d0 !     Calcium -       Carbon
    xfac(20, 6) =   0.567133d0 !     Calcium -       Carbon
    alpb(20, 7) =   1.003892d0 !     Calcium -     Nitrogen
    xfac(20, 7) =   0.453895d0 !     Calcium -     Nitrogen
    alpb(20, 8) =   2.574888d0 !     Calcium -       Oxygen
    xfac(20, 8) =   2.892181d0 !     Calcium -       Oxygen
    alpb(20, 9) =   2.268048d0 !     Calcium -     Fluorine
    xfac(20, 9) =   1.986328d0 !     Calcium -     Fluorine
    alpb(20,16) =   0.999897d0 !     Calcium -       Sulfur
    xfac(20,16) =   0.335089d0 !     Calcium -       Sulfur
    alpb(20,17) =   1.694685d0 !     Calcium -     Chlorine
    xfac(20,17) =   1.371206d0 !     Calcium -     Chlorine
    alpb(20,20) =   0.999786d0 !     Calcium -      Calcium
    xfac(20,20) =   4.524140d0 !     Calcium -      Calcium
    !
    alpb(35, 3) =   1.886037d0 !     Bromine -      Lithium
    xfac(35, 3) =   2.214447d0 !     Bromine -      Lithium
    alpb(35, 4) =   1.166450d0 !     Bromine -    Beryllium
    xfac(35, 4) =   0.193603d0 !     Bromine -    Beryllium
    alpb(35,11) =   2.189596d0 !     Bromine -       Sodium
    xfac(35,11) =   9.992652d0 !     Bromine -       Sodium
    alpb(35,12) =   1.939738d0 !     Bromine -    Magnesium
    xfac(35,12) =   1.898893d0 !     Bromine -    Magnesium
    alpb(35,19) =   1.997576d0 !     Bromine -    Potassium
    xfac(35,19) =   9.709128d0 !     Bromine -    Potassium
    alpb(35,20) =   1.635628d0 !     Bromine -      Calcium
    xfac(35,20) =   1.769827d0 !     Bromine -      Calcium
    !
    alpb(37, 1) =   1.999930d0 !    Rubidium -     Hydrogen
    xfac(37, 1) =   7.589965d0 !    Rubidium -     Hydrogen
    alpb(37, 5) =   1.999970d0 !    Rubidium -        Boron
    xfac(37, 5) =   6.012783d0 !    Rubidium -        Boron
    alpb(37, 8) =   1.999662d0 !    Rubidium -       Oxygen
    xfac(37, 8) =   2.914922d0 !    Rubidium -       Oxygen
    alpb(37, 9) =   2.914271d0 !    Rubidium -     Fluorine
    xfac(37, 9) =   8.743147d0 !    Rubidium -     Fluorine
    alpb(37,17) =   1.999948d0 !    Rubidium -     Chlorine
    xfac(37,17) =   3.708034d0 !    Rubidium -     Chlorine
    alpb(37,35) =   1.999755d0 !    Rubidium -      Bromine
    xfac(37,35) =   6.443546d0 !    Rubidium -      Bromine
    alpb(37,37) =   1.999854d0 !    Rubidium -     Rubidium
    xfac(37,37) =  10.000003d0 !    Rubidium -     Rubidium
    !
    alpb(38, 1) =   1.491059d0 !   Strontium -     Hydrogen
    xfac(38, 1) =   8.262735d0 !   Strontium -     Hydrogen
    alpb(38, 6) =   3.009340d0 !   Strontium -       Carbon
    xfac(38, 6) =   5.935637d0 !   Strontium -       Carbon
    alpb(38, 7) =   3.004535d0 !   Strontium -     Nitrogen
    xfac(38, 7) =   6.408169d0 !   Strontium -     Nitrogen
    alpb(38, 8) =   2.987339d0 !   Strontium -       Oxygen
    xfac(38, 8) =   5.727702d0 !   Strontium -       Oxygen
    alpb(38, 9) =   1.849351d0 !   Strontium -     Fluorine
    xfac(38, 9) =   1.086554d0 !   Strontium -     Fluorine
    alpb(38,16) =   2.051857d0 !   Strontium -       Sulfur
    xfac(38,16) =   4.276806d0 !   Strontium -       Sulfur
    alpb(38,17) =   2.072171d0 !   Strontium -     Chlorine
    xfac(38,17) =   4.093194d0 !   Strontium -     Chlorine
    alpb(38,35) =   2.168786d0 !   Strontium -      Bromine
    xfac(38,35) =   8.440324d0 !   Strontium -      Bromine
    alpb(38,38) =   2.982057d0 !   Strontium -    Strontium
    xfac(38,38) =   6.335178d0 !   Strontium -    Strontium
!
    alpb(42, 1) =   2.240000d0 !  Molybdenum -     Hydrogen
    xfac(42, 1) =   1.000000d0 !  Molybdenum -     Hydrogen
    alpb(42, 6) =   2.465000d0 !  Molybdenum -       Carbon
    xfac(42, 6) =   2.500000d0 !  Molybdenum -       Carbon
    alpb(42, 7) =   2.324000d0 !  Molybdenum -     Nitrogen
    xfac(42, 7) =   1.500000d0 !  Molybdenum -     Nitrogen
    alpb(42, 8) =   2.492000d0 !  Molybdenum -       Oxygen
    xfac(42, 8) =   1.500000d0 !  Molybdenum -       Oxygen
    alpb(42, 9) =   2.485000d0 !  Molybdenum -     Fluorine
    xfac(42, 9) =   1.500000d0 !  Molybdenum -     Fluorine
    alpb(42,15) =   3.000000d0 !  Molybdenum -   Phosphorus
    xfac(42,15) =   6.000000d0 !  Molybdenum -   Phosphorus
    alpb(42,16) =   2.290000d0 !  Molybdenum -       Sulfur
    xfac(42,16) =   1.500000d0 !  Molybdenum -       Sulfur
    alpb(42,17) =   2.500000d0 !  Molybdenum -     Chlorine
    xfac(42,17) =   2.500000d0 !  Molybdenum -     Chlorine
    alpb(42,24) =   1.955826d0 !  Molybdenum -     Chromium
    xfac(42,24) =   1.677542d0 !  Molybdenum -     Chromium
    alpb(42,35) =   2.130000d0 !  Molybdenum -      Bromine
    xfac(42,35) =   1.500000d0 !  Molybdenum -      Bromine
    alpb(42,42) =   2.550000d0 !  Molybdenum -   Molybdenum
    xfac(42,42) =   6.000000d0 !  Molybdenum -   Molybdenum

    !
    alpb(53, 3) =   2.648765d0 !      Iodine -      Lithium
    xfac(53, 3) =   9.992209d0 !      Iodine -      Lithium
    alpb(53, 4) =   0.999470d0 !      Iodine -    Beryllium
    xfac(53, 4) =   0.101571d0 !      Iodine -    Beryllium
    alpb(53,11) =   2.130872d0 !      Iodine -       Sodium
    xfac(53,11) =  10.000013d0 !      Iodine -       Sodium
    alpb(53,12) =   2.685633d0 !      Iodine -    Magnesium
    xfac(53,12) =   9.956335d0 !      Iodine -    Magnesium
    alpb(53,19) =   2.062884d0 !      Iodine -    Potassium
    xfac(53,19) =   9.900715d0 !      Iodine -    Potassium
    alpb(53,20) =   2.164489d0 !      Iodine -      Calcium
    xfac(53,20) =   7.940431d0 !      Iodine -      Calcium
    alpb(53,38) =   2.011009d0 !      Iodine -    Strontium
    xfac(53,38) =   6.634610d0 !      Iodine -    Strontium
    alpb(53,42) =   2.150000d0 !      Iodine -   Molybdenum
    xfac(53,42) =   1.500000d0 !      Iodine -   Molybdenum
    !
    !
    alpb(55, 1) =   0.997604d0 !      Cesium -     Hydrogen
    xfac(55, 1) =   1.985832d0 !      Cesium -     Hydrogen
    alpb(55, 6) =   0.999375d0 !      Cesium -       Carbon
    xfac(55, 6) =   0.099375d0 !      Cesium -       Carbon
    alpb(55, 7) =   0.998759d0 !      Cesium -     Nitrogen
    xfac(55, 7) =   0.205926d0 !      Cesium -     Nitrogen
    alpb(55, 8) =   2.249702d0 !      Cesium -       Oxygen
    xfac(55, 8) =   1.307467d0 !      Cesium -       Oxygen
    alpb(55, 9) =   0.999854d0 !      Cesium -     Fluorine
    xfac(55, 9) =   0.119889d0 !      Cesium -     Fluorine
    alpb(55,15) =   0.999228d0 !      Cesium -   Phosphorus
    xfac(55,15) =   0.099806d0 !      Cesium -   Phosphorus
    alpb(55,16) =   0.997626d0 !      Cesium -       Sulfur
    xfac(55,16) =   0.766755d0 !      Cesium -       Sulfur
    alpb(55,17) =   1.061905d0 !      Cesium -     Chlorine
    xfac(55,17) =   0.324568d0 !      Cesium -     Chlorine
    alpb(55,35) =   0.999274d0 !      Cesium -      Bromine
    xfac(55,35) =   0.416656d0 !      Cesium -      Bromine
    alpb(55,53) =   1.135145d0 !      Cesium -       Iodine
    xfac(55,53) =   0.642690d0 !      Cesium -       Iodine
    alpb(55,55) =   0.994764d0 !      Cesium -       Cesium
    xfac(55,55) =   3.263516d0 !      Cesium -       Cesium
    !
    alpb(56, 1) =   1.081595d0 !      Barium -     Hydrogen
    xfac(56, 1) =   0.108779d0 !      Barium -     Hydrogen
    alpb(56, 6) =   1.005494d0 !      Barium -       Carbon
    xfac(56, 6) =   0.109472d0 !      Barium -       Carbon
    alpb(56, 7) =   1.004182d0 !      Barium -     Nitrogen
    xfac(56, 7) =   0.109951d0 !      Barium -     Nitrogen
    alpb(56, 8) =   1.630584d0 !      Barium -       Oxygen
    xfac(56, 8) =   0.465945d0 !      Barium -       Oxygen
    alpb(56, 9) =   2.230982d0 !      Barium -     Fluorine
    xfac(56, 9) =   2.476341d0 !      Barium -     Fluorine
    alpb(56,16) =   1.000116d0 !      Barium -       Sulfur
    xfac(56,16) =   0.714303d0 !      Barium -       Sulfur
    alpb(56,17) =   1.341436d0 !      Barium -     Chlorine
    xfac(56,17) =   1.041642d0 !      Barium -     Chlorine
    alpb(56,35) =   1.427436d0 !      Barium -      Bromine
    xfac(56,35) =   2.384411d0 !      Barium -      Bromine
    alpb(56,53) =   1.303416d0 !      Barium -       Iodine
    xfac(56,53) =   2.097065d0 !      Barium -       Iodine
    alpb(56,56) =   1.110416d0 !      Barium -       Barium
    xfac(56,56) =   0.101890d0 !      Barium -       Barium
    !
  end subroutine alpb_and_xfac_am1

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine pulay(f, p, n, fppf, fock, emat, lfock, nfock, msize, start, pl)
      use chanel_C, only : iw
      use molkst_C, only : numcal, keywrd, mpack, npulay
      use Common_arrays_C, only : workmat1, workmat2, workmat3
      implicit none
      integer  :: n
      integer , intent(inout) :: lfock
      integer , intent(inout) :: nfock
      integer , intent(in) :: msize
      double precision , intent(out) :: pl
      logical , intent(inout) :: start
      double precision  :: f(mpack)
      double precision  :: p(mpack)
      double precision  :: fppf(*)
      double precision , intent(inout) :: fock(*)
      double precision , intent(inout) :: emat(npulay+1,npulay+1)
!
      integer :: icalcn, maxlim, linear, mfock, lbase, i, nfock1, j, l, il, ii
      double precision, dimension((npulay+1)**2) :: evec
      double precision, dimension(npulay) :: coeffs
      double precision :: const, d, sum
      logical :: debug
      double precision, external :: ddot
!
      save icalcn, maxlim, debug, linear, mfock
!-----------------------------------------------
!***********************************************************************
!
!   PULAY USES DR. PETER PULAY'S METHOD FOR CONVERGENCE.
!         A MATHEMATICAL DESCRIPTION CAN BE FOUND IN
!         "P. PULAY, J. COMP. CHEM. 3, 556 (1982).
!
! ARGUMENTS:-
!         ON INPUT F      = FOCK MATRIX, PACKED, LOWER HALF TRIANGLE.
!                  P      = DENSITY MATRIX, PACKED, LOWER HALF TRIANGLE.
!                  N      = NUMBER OF ORBITALS.
!                  FPPF   = WORKSTORE OF SIZE MSIZE, CONTENTS WILL BE
!                           OVERWRITTEN.
!                  FOCK   =      "       "              "         "
!                  EMAT   = WORKSTORE OF AT LEAST NPULAY**2 ELEMENTS.
!                  START  = LOGICAL, = TRUE TO START PULAY.
!                  PL     = UNDEFINED ELEMENT.
!      ON OUTPUT   F      = "BEST" FOCK MATRIX, = LINEAR COMBINATION
!                           OF KNOWN FOCK MATRICES.
!                  START  = FALSE
!                  PL     = MEASURE OF NON-SELF-CONSISTENCY
!                         = [F*P] = F*P - P*F.
!
!***********************************************************************
      data icalcn/ 0/
      if (icalcn /= numcal) then
        icalcn = numcal
        maxlim = npulay
        debug = index(keywrd,'DEBUGPULAY') /= 0
      end if
      if (start) then
        linear = (n*(n + 1))/2
        mfock = msize/linear
        mfock = min0(maxlim,mfock)
        if (debug) write (iw, '('' MAXIMUM SIZE:'',I5)') mfock
        nfock = 1
        lfock = 1
        start = .FALSE.
      else
        if (nfock < mfock) nfock = nfock + 1
        if (lfock /= mfock) then
          lfock = lfock + 1
        else
          lfock = 1
        end if
      end if
      lbase = (lfock - 1)*linear
!
!   FIRST, STORE FOCK MATRIX FOR FUTURE REFERENCE.
!
      fock(lfock:(linear-1)*mfock+lfock:mfock) = f(:linear)
!
!   NOW FORM /FOCK*DENSITY-DENSITY*FOCK/, AND STORE THIS IN FPPF
!
!      call mamult (p, f, fppf(lbase+1), n, 0.D0)
!      call mamult (f, p, fppf(lbase+1), n, -1.D0)
      call unpack_matrix(p, workmat1, n)
      call unpack_matrix(f, workmat2, n)
      call sym_commute(workmat1, workmat2, workmat3, n)
      call pack_matrix(workmat3, fppf(lbase+1), n)
!
!   FPPF NOW CONTAINS THE RESULT OF FP - PF.
!
      nfock1 = nfock + 1
      do i = 1, nfock
        emat(nfock1,i) = -1.D0
        emat(i,nfock1) = -1.D0
        emat(lfock,i) = ddot(linear,fppf((i-1)*linear+1),1,fppf(lbase+1),1)
        emat(i,lfock) = emat(lfock,i)
      end do
      pl = emat(lfock,lfock)/linear
      emat(nfock1,nfock1) = 0.D0
      if (emat(lfock, lfock) < 1.d-20) return
      const = 1.D0/emat(lfock,lfock)
      emat(:nfock,:nfock) = emat(:nfock,:nfock)*const
      if (debug) then
        write (iw, '('' EMAT'')')
        do i = 1, nfock1
          write (iw, '(6E13.6)') (emat(j,i),j=1,nfock1)
        end do
      end if
      l = 0
      do i = 1, nfock1
        evec(l+1:nfock1+l) = emat(i,:nfock1)
        l = nfock1 + l
      end do
      const = 1.D0/const
      emat(:nfock,:nfock) = emat(:nfock,:nfock)*const
!********************************************************************
!   THE MATRIX EMAT SHOULD HAVE FORM
!
!      |<E(1)*E(1)>  <E(1)*E(2)> ...   -1.0|
!      |<E(2)*E(1)>  <E(2)*E(2)> ...   -1.0|
!      |<E(3)*E(1)>  <E(3)*E(2)> ...   -1.0|
!      |<E(4)*E(1)>  <E(4)*E(2)> ...   -1.0|
!      |     .            .      ...     . |
!      |   -1.0         -1.0     ...    0. |
!
!   WHERE <E(I)*E(J)> IS THE SCALAR PRODUCT OF [F*P] FOR ITERATION I
!   TIMES [F*P] FOR ITERATION J.
!
!********************************************************************
      call osinv (evec, nfock1, d)
      if (abs(d) < 1.D-6) then
        start = .TRUE.
        return
      end if
      if (nfock < 2) return
      il = nfock*nfock1
      coeffs(:nfock) = -evec(1+il:nfock+il)
      if (debug) then
        write (iw, '('' EVEC'')')
        write (iw, '(6F12.6)') (coeffs(i),i=1,nfock)
        write (iw, '(''    LAGRANGIAN MULTIPLIER (ERROR) =''                          ,F13.6)') evec(nfock1*nfock1)
      end if
      do i = 1, linear
        sum = 0.D0
        l = 0
        ii = (i - 1)*mfock
        do j = 1, nfock
          sum = sum + coeffs(j)*fock(j+ii)
        end do
        f(i) = sum
      end do
      return
      end subroutine pulay

      subroutine pack_matrix(unpacked, packed, size)
        implicit none
        integer :: info
        integer , intent(in) :: size
        double precision , intent(in) :: unpacked(size, size)
        double precision , intent(out) :: packed(*)
  !-----------------------------------------------
  !***********************************************************************
  !
  !   CONVERT UNPACKED SYMMETRIC MATRIX INTO A PACKED UPPER TRIANGLE
  !   (LAPACK DTRTTP CALL)
  !
  ! ARGUMENTS:-
  !         ON INPUT UNPACKED = UNPACKED SYMMETRIC MATRIX
  !                  SIZE     = DIMENSION OF MATRIX
  !      ON OUTPUT   PACKED   = PACKED UPPER TRIANGLE MATRIX
  !
  !***********************************************************************
        call dtrttp( 'U', size, unpacked, size, packed, info )
        if (info /= 0) stop 'error in dtrttp'
        return
        end subroutine pack_matrix

        subroutine unpack_matrix(packed, unpacked, size)
          implicit none
          integer :: info, i, j
          integer , intent(in) :: size
          double precision , intent(in) :: packed(*)
          double precision , intent(out) :: unpacked(size, size)
    !-----------------------------------------------
    !***********************************************************************
    !
    !   CONVERT PACKED UPPER TRIANGLE INTO AN UNPACKED SYMMETRIC MATRIX
    !   (LAPACK DTPTTR CALLS & FILLING IN THE REST BY HAND)
    !
    ! ARGUMENTS:-
    !         ON INPUT PACKED   = PACKED UPPER TRIANGLE MATRIX
    !                  SIZE     = DIMENSION OF MATRIX
    !      ON OUTPUT   UNPACKED = UNPACKED SYMMETRIC MATRIX
    !
    !***********************************************************************
          call dtpttr( 'U', size, packed, unpacked, size, info )
          if (info /= 0) stop 'error in dtpttr'
          do i = 1, size
            do j = i+1, size
              unpacked(j,i) = unpacked(i,j)
            end do
          end do
          return
          end subroutine unpack_matrix

          subroutine sym_commute(mat1, mat2, mat3, size)
            implicit none
            integer :: i, j
            integer , intent(in) :: size
            double precision , intent(in) :: mat1(size, size)
            double precision , intent(in) :: mat2(size, size)
            double precision , intent(out) :: mat3(size, size)
    !-----------------------------------------------
    !***********************************************************************
    !
    !   COMPUTE THE COMMUTATOR BETWEEN TWO SYMMETRIC MATRICES
    !   (DGEMM & AN IN-PLACE EVALUATION OF THE SECOND TERM)
    !
    ! ARGUMENTS:-
    !         ON INPUT MAT1   = FIRST SYMMETRIC MATRIX IN COMMUTATOR
    !                  MAT2   = SECOND SYMMETRIC MATRIX IN COMMUTATOR
    !                  SIZE   = DIMENSION OF MATRIX
    !      ON OUTPUT   MAT3   = MAT1*MAT2 - MAT2*MAT1
    !
    !***********************************************************************
            call dsymm('L', 'U', size, size, 1.D0, mat1, size, mat2, size, 0.D0, mat3, size)
            do i = 1, size
              do j = i, size
                mat3(i,j) = mat3(i,j) - mat3(j,i)
                mat3(j,i) = -mat3(i,j)
              end do
            end do
            return
            end subroutine sym_commute

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

double precision function helecz ()
!
!   Return the total electronic energy,
!   from e = 0.5P(H + F)
!
    use molkst_C, only: numat
    use MOZYME_C, only : iorbs
    use common_arrays_C, only : p, h, f
    implicit none
    integer :: i, j, k, l, l1, l2, m
    double precision :: ed, ee
    integer, external :: ijbo
    ed = 0.0d00
    ee = 0.0d00
    do i = 1, numat
      do j = 1, i - 1
          k = ijbo (i, j)
          if (k >= 0) then
            l = k + iorbs(i) * iorbs(j)
            do m = k + 1, l
              ee = ee + p(m) * (h(m)+f(m))
            end do
          end if
      end do
        k = ijbo (i, i)
        do l1 = 1, iorbs(i)
          do l2 = 1, l1 - 1
            k = k + 1
            ee = ee + p(k) * (h(k)+f(k))
          end do
          k = k + 1
          ed = ed + p(k) * (h(k)+f(k))
        end do
    end do
    ee = ee + .5d00 * ed
    helecz = ee
end function helecz

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      double precision function meci ()
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use meci_C, only : rjkaa, rjkab, microa, microb, nmeci, nelec, nstate, &
      & lab, labsiz, cdiagi, cdiag, occa, maxci, nalmat, conf, nmos, &
      & vectci, xy, dijkl, ispin, eig, ispqr,  k, deltap, root_requested
      use symmetry_C, only : jndex, namo, state_spin, state_Irred_Rep, &
      state_QN
      USE common_arrays_C, only : nfirst, nlast, eigs, c
      USE molkst_C, only : nopen, nclose, fract, nelecs, norbs, numcal, &
      & numat, keywrd, last, lm61, rjkab1, msdel, line
      USE chanel_C, only : ir, iw
      use cosmo_C, only : iseps
      USE mndod_C, only : fx
      implicit none
!
      integer , dimension(:), allocatable :: nfa
      integer :: icalcn, ndoubl, j, l, mdim, lroot, ne, lima, &
        limb, i1, j1, ntot, izero, limci, nupp, &
        ndown, loc, i2, j2, iroot, i, ii, ji, m, maxvec, &
        iuj, iofset, il, iu, irep(maxci), smult, jroot
      integer, dimension (20, 20) :: qn_temp
      integer, dimension(:,:), allocatable :: nperma, npermb
      double precision, dimension(:), allocatable :: eiga, cimat, spin, cij, ckl, wcij, &
        delta
      double precision, dimension(:), allocatable :: diag
      double precision, dimension(nmeci, nmeci) :: deltapp
      double precision, dimension(:,:), allocatable :: oscil
      double precision, dimension(3) :: work
      double precision :: xx, x, gse, y, sum, summ
!      double precision, allocatable :: overlap(:)
      double precision, external :: diagi, reada
      logical :: debug, large, prnt, lspin, lspin1, peci, first1, bigprt, sing, &
        doub, trip, quar, quin, sext, prnt2, geook, getmic, sept, octe, none, &
        cis, cisd, cisdt
      character, dimension(11) :: tspin*8
      character :: srep(maxci)*15, root_ir*4, tex_root*1, num1*1, num2*1

      save spin, debug, large, lspin1, first1, sing, doub, trip, quar, quin, &
        sext, prnt2, geook, getmic, sept, tspin, icalcn, ndoubl, j, l, delta, &
        mdim, lroot, smult, ne, xx, lima, limb, eiga, octe, none, peci, cis, cisd, cisdt, &
        oscil, nperma, npermb, nfa, limci, nupp, ndown, root_ir
!-----------------------------------------------
!**********************************************************************
!
!                 PROGRAM MECI
!
!   A MULTI-ELECTRON CONFIGURATION INTERACTION CALCULATION
!
!   WRITTEN BY JAMES J. P. STEWART, AT THE
!              FRANK J. SEILER RESEARCH LABORATORY
!              USAFA, COLORADO SPRINGS, CO 80840
!
!              1985
!
!**********************************************************************
!
!
!   MATRICES FOR PERMUTATION WORK
!
!
!   MATRICES FOR ONE AND TWO ELECTRON INTEGRALS
!
!
!   SPIN MATRICES
!
!
!   MATRICES FOR SEC.DET., VECTORS, AND EIGENVALUES.
!
      data icalcn/ 0/
      data tspin/ 'SINGLET ', 'DOUBLET ', 'TRIPLET ', 'QUARTET ', 'QUINTET ', &
      'SEXTET  ', 'SEPTET  ', 'OCTET   ', 'NONET   ', 'DECET   ', '??????? '/
      meci = 0.d0
      if (numat == 0) then
        if (allocated(spin))   deallocate(spin)
        if (allocated(nalmat)) deallocate(nalmat)
        if (allocated(eig))    deallocate(eig)
        if (allocated(conf))   deallocate(conf)
        if (allocated(vectci)) deallocate(vectci)
        if (allocated(ispin))  deallocate(ispin)
        if (allocated(oscil))  deallocate(oscil)
        if (allocated(ispqr))  deallocate(ispqr)
        if (allocated(occa))   deallocate(occa)
        if (allocated(deltap)) deallocate(deltap)
        if (allocated(nperma)) deallocate(nperma)
        if (allocated(npermb)) deallocate(npermb)
        if (allocated(nfa))    deallocate(nfa)
        if (allocated(delta))  deallocate(delta)
        if (allocated(eiga))   deallocate(eiga, rjkaa, xy, rjkab, dijkl)
        meci = 0.d0
        return
      end if
      if (icalcn /= numcal) then
        icalcn = numcal
        first1 = .TRUE.
        limci = 0
        mdim = maxci
        geook = index(keywrd,'GEO-OK') /= 0
        lspin1 = index(keywrd,'ESR') /= 0
        debug = index(keywrd,'DEBUG') /= 0
        prnt2 = index(keywrd,'MECI') /= 0
        debug = debug .and. prnt2
        large = index(keywrd,'LARGE') /= 0
        peci  = index(keywrd,' PECI') /= 0
        cis   = index(keywrd,' CIS ') /= 0
        cisd  = index(keywrd,' CISD ') /= 0
        cisdt = index(keywrd,' CISDT ') /= 0
        root_ir = "XXXX"
        ndoubl = 99
        i = index(keywrd,'C.I.=(')
        if (i /= 0) then
          j = index(keywrd(i:i+10),',') + i - 1
          ndoubl = nint(reada(keywrd,j))
          nmos = nint(reada(keywrd,index(keywrd,'C.I.=(') + 5))
          ndoubl = min(ndoubl,nclose)
        else if (index(keywrd,'C.I.=') /= 0) then
          nmos = nint(reada(keywrd,index(keywrd,'C.I.=') + 5))
        else
          nmos = nopen - nclose
        end if
        nmos = min(nmos,norbs)
        if (allocated(occa))    deallocate(occa)
        if (allocated(deltap))  deallocate(deltap)
        allocate(occa(nmos), deltap(nmos, nmos))
        lroot = 1
        if (index(keywrd,'EXCI') /= 0) lroot = 2
        i = index(keywrd," ROOT")
        if (i /= 0) then
          do j = i + 6, i + 9
            if (keywrd(j:j) > "9" .or. keywrd(j:j) < "0") exit
          end do
          lroot = Nint (reada (keywrd(:j), i + 6))
          do j = i + 7, i + 14
            if (keywrd(j:j) == " ") exit
            if (keywrd(j:j) >= "A" .and. keywrd(j:j) <= "Z") then
              root_ir = keywrd(j:)
              i = Index(root_ir," ")
              if (i /= 0) root_ir(i:) = " "
              do k = 2,4
                if (root_ir(k:k) >="A" .and. root_ir <= "Z") &
                & root_ir(k:k) = Char(Ichar(root_ir(k:k)) + Ichar('a') - Ichar('A'))
              end do
            end if
            if (root_ir /= " ") exit
          end do
        end if
        if (ndoubl == 99) then
          j = max(min((nclose + nopen + 1)/2 - (nmos - 1)/2,norbs - nmos + 1),1)
        else
          j = nclose - ndoubl + 1
          if (fract > 1.99D0) j = j + 1
        end if
        l = 0
        if (nclose - j + 1 > 0) then
          occa(:nclose-j+1) = 1
          l = nclose - j + 1
        end if
        j = max(j,nclose + 1)
        if (nopen - j + 1 > 0) then
          occa(l+1:nopen-j+1+l) = fract*0.5D0
          l = nopen - j + 1 + l
        end if
        do i = 1, nmeci
          l = l + 1
          if (l > nmos) exit
          occa(l) = 0.D0
        end do
        sing = index(keywrd,' SING') + index(keywrd,' EXCI') + index(keywrd,&
          ' BIRAD') /= 0
        doub = index(keywrd,' DOUB') /= 0
        trip = index(keywrd,' TRIP') /= 0
        quar = index(keywrd,' QUAR') /= 0
        quin = index(keywrd,' QUIN') /= 0
        sext = index(keywrd,' SEXT') /= 0
        sept = index(keywrd,' SEPT') /= 0
        octe = index(keywrd,' OCTE') /= 0
        none = index(keywrd,' NONE') /= 0
        smult = -1
        if (sing) smult = 1
        if (doub) smult = 2
        if (trip) smult = 3
        if (quar) smult = 4
        if (quin) smult = 5
        if (sext) smult = 6
        if (sept) smult = 7
        x = 0.D0
        do j = 1, nmos
          x = x + occa(j)
        end do
        xx = x + x
        ne = nint(xx)
        i = (nelecs - ne + 1)/2
        nelec = (nelecs - ne + 1)/2
      end if
      root_requested = 0
      prnt = debug .or. last==3 .and. prnt2
      bigprt = prnt .and. large
!
!    TEST TO SEE IF THE SET OF ENERGY LEVELS USED IN MECI IS COMPLETE,
!    I.E., ALL COMPONENTS OF DEGENERATE IRREDUCIBLE REPRESENTATIONS
!    ARE USED.  IF NOT, THEN RESULTS WILL BE NONSENSE.  GIVE USERS A
!    CHANCE TO REALLY FOUL THINGS UP BY ALLOWING JOB TO CONTINUE IF
!    'GEO-OK' IS SPECIFIED.
!
      if (nelec < 0) then
        meci = 0.D0
        call mopend (&
           ' NUMBER OF ELECTRONS IN M.O.S BELOW ACTIVE SPACE IS LESS THAN ZERO')
        return
      end if
      if (nelec + nmos > norbs) then
        meci = 0.D0
        call mopend (&
       ' UPPER BOUND OF ACTIVE SPACE IS GREATER THAN THE NUMBER OF ORBITALS!')
        return
      end if
      if (allocated(eiga)) then
        deallocate(eiga, rjkaa, xy, rjkab, dijkl, delta)
      end if
      allocate(eiga(nmos), rjkaa(nmos,nmos), xy(nmos, nmos, nmos, nmos), &
      & rjkab(nmos, nmos), dijkl(norbs, nmos,(nmos*(nmos + 1))/2))
      allocate(cij(lm61), ckl(lm61), wcij(lm61), delta(nmeci*norbs))
      eiga(:nmos) = eigs(1+nelec:nmos+nelec)
      lspin = lspin1 .and. last==3
      if (bigprt) then
        write (iw, '(''  INITIAL EIGENVALUES'')')
        write (iw, '(5F12.6)') (eiga(i),i=1,nmos)
        write (iw, '(2/10X,''NUMBER OF ELECTRONS IN C.I. ='',F5.1)') xx
      end if
      i = nmos + nelec + 1
      if (.not.geook .and. nelec>0) then
        if (abs(eigs(nelec+1)-eigs(nelec))<2.D-2 .or. nelec+1+nmos .lt. norbs &
        .and. abs(eigs(nelec+1+nmos)-eigs(nelec+nmos))<2.D-2) then
          write (iw, '(3/10X,A)') 'DEGENERATE ENERGY LEVELS DETECTED IN MECI'
          write (iw, '(10X,A)') &
            'SOME OF THESE LEVELS WOULD BE TREATED BY MECI,'
          write (iw, '(10X,A)') 'WHILE OTHERS WOULD NOT.  THIS WOULD RESULT IN'
          write (iw, '(10X,A)') 'NON-REPRODUCIBLE ELECTRONIC ENERGIES.'
          write (iw, '(/2X,A)') 'EIGENVALUES OF ACTIVE SPACE'
          write (iw, '(8F10.4)') (eigs(i),i=nelec + 1,nelec + nmos)
          write (iw, '(/2X,A)') 'EIGENVALUES BELOW ACTIVE SPACE'
          write (iw, '(8F10.4)') (eigs(i),i=max(1,nelec - 5),nelec)
          write (iw, '(/2X,A)') 'EIGENVALUES ABOVE ACTIVE SPACE'
          write (iw, '(8F10.4)') (eigs(i),i=nelec + nmos + 1,min(norbs,nelec + &
            nmos + 5))
          write (iw, *)
          meci = 0.D0
          call mopend ('JOB STOPPED. TO CONTINUE, SPECIFY "GEO-OK".')
          return
        end if
      end if
!      allocate(overlap((norbs*(norbs + 1))/2))
!      call fill_overlap_matrix(overlap)
      if (bigprt) then
        write (iw, '(2/10X,''EIGENVECTORS'',/)')
        do i = 1, norbs
          write (iw, '(6F12.6)') (c(i,j+nelec),j=1,nmos)
        end do
      end if
      call ijkl (c(1,nelec+1), c, nelec, nmos, dijkl, cij, ckl, wcij, xy)
      do i = 1, nmos
        do j = 1, nmos
          rjkaa(i,j) = xy(i,i,j,j) - xy(i,j,i,j)
          rjkab(i,j) = xy(i,i,j,j)
        end do
      end do
      rjkab1 = rjkab(1,1)
!
!  Divide M.O. eigenvalue by the overlap integral of the M.O.
!
!     if (allocated(overlap)) deallocate(overlap)
!      write (iw, '(/,5x,a,/)') 'EIGENVALUES BEFORE DIVISION BY M.O. OVERLAP'
!      write (iw, '(8F10.5)') (eiga(i),i=1,nmos)
!      allocate(overlap((norbs*(norbs + 1))/2))
!      call fill_overlap_matrix(overlap)
!      write(iw,*)" M.O.  overlap"
!      do j = 1, nmos
!        sum = 0.d0
!        l = 0
!        do i = 1,norbs
!          do k = 1, i - 1
!            l = l + 1
!            sum = sum + c(i, j + nelec)*overlap(l)*c(k, j + nelec)
!          end do
!            l = l + 1
!            sum = sum + c(i, j + nelec)*0.5d0*c(k, j + nelec)
!        end do
!        sum = sum*2.d0
!        write(iw,'(i4, f10.4)')j + nelec, sum
!        eiga(j) = eiga(j)/sum
!      end do
!      write (iw, '(/,5x,a,/)') 'EIGENVALUES AFTER DIVISION BY M.O. OVERLAP'
!      write (iw, '(8F10.5)') (eiga(i),i=1,nmos)
      do i = 1, nmos
        x = 0.D0
        do j = 1, nmos
          x = x + (rjkaa(i,j)+rjkab(i,j))*occa(j)
        end do
        eiga(i) = eiga(i) - x
      end do
      if (bigprt) then
        write (iw, 120)
  120   format(/,5x,'EIGENVALUES AFTER REMOVAL OF INTER-ELECTRONIC',&
          ' INTERACTIONS',/)
        write (iw, '(8F10.5)') (eiga(i),i=1,nmos)
        write (iw, '(3/10X,''TWO-ELECTRON J-INTEGRALS'',/)')
        do i1 = 1, nmos
          write (iw, '(10F8.4)') (rjkab(i1,j1),j1=1,min(10,nmos))
        end do
        write (iw, '(3/10X,''TWO-ELECTRON K-INTEGRALS'',/)')
        do i1 = 1, nmos
          write (iw, '(10F8.4)') (rjkab(i1,j1) - rjkaa(i1,j1),j1=1,min(nmos,10)&
            )
        end do
      end if
      i = 1
      if (nmos > 0) then
        j = 1
        rjkaa(:nmos,:nmos) = rjkaa(:nmos,:nmos)*0.5D0
        j = nmos + 1
        i = nmos + 1
      end if
      if (first1) then
        getmic = index(keywrd,'MICROS') /= 0
        if (getmic) then
          k = nint(reada(keywrd,index(keywrd,'MICROS')))
          lab = k
          if (prnt) write (iw, '(''    MICROSTATES READ IN'')')
          ntot = nint(xx)
          rewind ir
          do i = 1, 10000
            read (ir, '(A)') line
            call upcase (line, 80)
            if (index(line,'MICRO') == 0) cycle
            exit
          end do
          do i = 1, 1000
            read (ir, '(A)', end=190, err=190) line
            call upcase (line, 80)
            if (index(line,'MICRO') /= 0) go to 200
          end do
  190     continue
          meci = 0.D0
          call mopend (&
             'MICROSTATES SPECIFIED BY KEYWORDS BUT MISSING FROM DATA')
          return
  200     continue
          if (allocated(microa)) deallocate(microa)
          if (allocated(microb)) deallocate(microb)
          allocate(microa(nmos, lab), microb(nmos,lab))
          do i = 1, lab
            read (ir, '(A)') line
            izero = max(0,min(index(line,'0'),index(line,'1')) - 1)
            do j = 1, nmos
              if (line(j+izero:j+izero) /= '1') line(j+izero:j+izero) = '0'
              if (line(j + nmos + izero:j + nmos + izero) /= '1') &
              line(j + nmos + izero:j + nmos + izero) = '0'
              microa(j,i) = ichar(line(j+izero:j+izero)) - ichar('0')
              microb(j,i) = ichar(line(j+nmos+izero:j+nmos+izero)) - ichar('0')
            end do
            if (prnt) write (iw, '(20I3)') (microa(j,i),j=1,nmos), (microb(j,i),j=1,nmos)
            k = 0
            do j = 1, nmos
              k = k + microa(j,i) + microb(j,i)
            end do
            if (k == ntot) cycle
            ntot = k
            xx = k
            write (iw, &
      '(/10X,''NUMBER OF ELECTRONS IN C.I. REDEFINED TO:'',I4,/)') k
          end do
          if (getmic) go to 240
          limci = 0
        end if
        if (msdel == 0 .and. mod(ne,2) == 1) msdel = 1
        nupp = (ne + msdel)/2
        ndown = ne - nupp
        if (nupp*ndown < 0) then
          write (iw, '(/10X,''IMPOSSIBLE VALUE OF DELTA S'')')
          meci = 0.D0
          call mopend ('IMPOSSIBLE VALUE OF DELTA S')
          return
        end if
        if (limci == 0) then
          lima = nint(fx(nmos + 1)/(fx(nupp + 1)*fx(nmos - nupp + 1)))
          limb = nint(fx(nmos + 1)/(fx(ndown + 1)*fx(nmos - ndown + 1)))
          if (allocated(nperma)) deallocate(nperma)
          if (allocated(npermb)) deallocate(npermb)
          allocate(nperma(nmos, lima), npermb(nmos, limb), stat = i)
          if (i /= 0) then
            meci = 0.d0
            call mopend("A problem occurred during memory assignment. The number of configurations is too large. ")
            return
          end if
        end if
        lab = lima*limb

        if (peci) limci = 4
        if (cis .or. cisd .or. cisdt) then
          if (cis)   limci = 2
          if (cisd)  limci = 4
          if (cisdt) limci = 6
        end if
        call perm (nperma, nupp, nmos, lima, limci)
        call perm (npermb, ndown, nmos, limb, limci)
        lab = lima*limb
        if (allocated(microa)) deallocate(microa)
        if (allocated(microb)) deallocate(microb)
        allocate(microa(nmos, lab), microb(nmos,lab), stat = i)
        if (i /= 0) then
          meci = 0.d0
          call mopend("A problem occurred during memory assignment. The number of configurations is too large. ")
          return
        end if
      else
        if (.not.getmic) lab = lima*limb
      end if
  240 continue
      if (allocated(spin))   deallocate(spin)
      if (allocated(nalmat)) deallocate(nalmat)
      if (allocated(eig))    deallocate(eig)
      if (allocated(conf))   deallocate(conf)
      if (allocated(vectci)) deallocate(vectci)
      if (allocated(ispin))  deallocate(ispin)
      if (allocated(oscil))  deallocate(oscil)
      if (allocated(ispqr))  deallocate(ispqr)
      allocate(spin(lab), nalmat(lab), eig(lab + 1), vectci(30*lab), &
      & ispin(lab), oscil(3,lab + 4), ispqr(lab,nmeci + 1), stat = i)
      if (i /= 0) then
          meci = 0.d0
          call mopend("A problem occurred during memory assignment. The number of configurations is too large. ")
          return
        end if
      ispqr = -99999
      if (prnt) write (iw, 250) (nupp - ndown)*0.5D0
  250 format(10x,'COMPONENT OF SPIN  = ',f4.1)
      gse = 0.0D0
      do i = 1, nmos
        gse = gse + eiga(i)*occa(i)*2.D0
        gse = gse + xy(i,i,i,i)*occa(i)*occa(i)
        do j = i + 1, nmos
          gse = gse + 2.D0*(2.D0*xy(i,i,j,j)-xy(i,j,i,j))*occa(i)*occa(j)
        end do
      end do
      if (limci /= 0) then
!
! REMOVE ALL UNWANTED EXCITATIONS
!
        loc = 0
        do i = 1, lima
          do j = 1, limb
!
!        DETERMINE THE TYPE OF EXCITATION
!
            k = 0
            do l = 1, nmos
              k = k + abs(nperma(l,i)-nperma(l,1)) + abs(npermb(l,j)-npermb(l,1))
            end do
            if (peci) then
              l = 1
              if (nmos > 0) then
                do l = 1, nmos
                  if (.not.k<=2 .and. .not.nperma(l,i)==npermb(l,j)) k = 1000
                end do
                l = nmos + 1
              end if
            end if
!
!        COPY DET AND INCREMENT LOC
!
            if (k > limci) cycle
            loc = loc + 1
            if (loc <= 0) cycle
            l = 1
            if (nmos > 0) then
              microa(:nmos,loc) = nperma(:nmos,i)
              microb(:nmos,loc) = npermb(:nmos,j)
              l = nmos + 1
            end if
          end do
        end do
        lab = loc
      end if
      num1 = char(ichar("2") + int(log10(lab*1.0001)))
      if (prnt) write (iw, "(/,/,10x,' NO OF CONFIGURATIONS CONSIDERED =',i"//num1//")") lab
      if (allocated(cdiag))  deallocate(cdiag)
      if (lab > maxci) then
        meci = 0.d0
        call mopend("Too many configurations requested")
        write(iw,"(a,i7)")"  Number requested:", lab
        return
      end if
      allocate(conf(lab**2), cimat((lab*(lab + 1))/2 + 9), diag(lab), cdiag(lab), stat = i)
      if (i /= 0) then
        meci = 0.d0
        call mopend("A problem occurred during memory assignment. The number of configurations is too large. ")
        return
      end if
      if (getmic .or. limci/=0) then
        do i = 1, lab
          diag(i) = diagi(microa(1,i),microb(1,i),eiga,xy,nmos) - gse
          cdiag(i) = cdiagi
        end do
        go to 400
      end if
      j = 0
      i = 0
      do i1 = 1, lima
        do i2 = 1, limb
          i = i + 1
          cimat(i) = diagi(nperma(1,i1),npermb(1,i2),eiga,xy,nmos) - gse
        end do
      end do
      if (lab <= mdim) then
        k = 0
        do i = 1, lima
          do j = 1, limb
            k = k + 1
            diag(k) = cimat(k)
            l = 1
            if (nmos > 0) then
              microa(:nmos,k) = nperma(:nmos,i)
              microb(:nmos,k) = npermb(:nmos,j)
              l = nmos + 1
            end if
          end do
        end do
      else
!
!   SELECT THE MDIM LOWEST MICROSTATES
!
        do lab = 1, mdim
          x = 1000.D0
          i = 0
          j1 = 0
          j2 = 0
          do i1 = 1, lima
            do i2 = 1, limb
              i = i + 1
              if (cimat(i) >= x) cycle
              x = cimat(i)
              j = i
              j1 = i1
              j2 = i2
            end do
          end do
!
!   MICROSTATE J IS THE LOWEST IN THE REMAINING SET
!
          k = 1
          if (nmos > 0) then
            microa(:nmos,lab) = nperma(:nmos,j1)
            microb(:nmos,lab) = npermb(:nmos,j2)
            k = nmos + 1
          end if
          diag(lab) = cimat(j)
          cimat(j) = 1.D8
        end do
        lab = mdim
      end if
  400 continue
      if (lab > maxci) then
        meci = 0.d0
        call mopend("Too many configurations requested")
        write(iw,"(a,i7)")"  Number requested:", lab
        write(iw,"(a,i7)")"  Max. no. allowed:", maxci
        return
      end if
      do i = 1, lab
        k = 0
        x = 0.D0
        do j = 1, nmos
          x = x + microa(j,i)*microb(j,i)
          k = k + microa(j,i)
        end do
        nalmat(i) = k
        spin(i) = 4.D0*x - (xx - 2*nalmat(i))**2
      end do
!
!   BEFORE STARTING, CHECK THAT THE ROOT WANTED CAN EXIST
!
      if (lab < lroot) then
        call mopend (&
       'C.I. IS OF SIZE LESS THAN ROOT SPECIFIED. MODIFY SIZE OF C.I. OR ROOT NUMBER.')
        write (iw, '(10X,''MODIFY SIZE OF C.I. OR ROOT NUMBER'')')
        meci = 0.D0
        return
      end if
      if (prnt) then
        write (iw, &
      '(/,'' CONFIGURATIONS CONSIDERED IN C.I.      '',/,'' M.O. NUMBER :      '',20I4)') &
       (i, i = nelec + 1, nelec + min(20, nmos))
       if (nmos > 20) write (iw, '(20X,20I4)') (i,i=nelec + 21, nelec + min(40,nmos))
        write (iw, '(''          ENERGY'')')
        num1 = char(ichar("2") + int(log10(lab*1.0001)))
        num2 = char(ichar("6") - int(log10(lab*1.0001)))
        do i = 1, lab
          write (iw, '(/7x,'//num2//'x,I'//num1//',5X,20I4)') i, (microa(k,i),k=1,min(20,nmos))
          if (nmos > 20) write (iw, '(20X,20I4)') (microa(k,i),k=21,min(40,nmos))
          write (iw, '(6X,F10.4,4X,20I4)') diag(i), (microb(k,i),k=1,min(20,nmos))
          if (nmos > 20) write (iw, '(20X,20I4)') (microb(k,i),k=21,min(40,nmos))
        end do
      end if
      call mecih (diag, cimat, nmos, lab, xy)
      if (bigprt) then
        write (iw, '(2/,'' C.I. MATRIX'')')
        call vecprt (cimat, (-lab))
      end if
!
!  Sometimes exact degeneracies cause problems with RSP, so perturb the C.I. matrix
!  to destroy exact degeneracy.
!
      do i = 1, lab
        cimat((i*(i + 1))/2) = cimat((i*(i + 1))/2) + 1.d-10*i*(-1)**i
      end do
      labsiz = min(lab,lroot + 10)
      if (last == 3 .and. prnt2 .or. root_requested /= 1 .and. first1 .or. root_ir /= "XXXX") then
        labsiz = lab
      end if
      call rsp (cimat, lab, eig, conf)
      if (bigprt .or. last > 0 .or. root_ir /= "XXXX") call symtrz (c(1,nelec+1), eig, 3, .TRUE.)
      if (bigprt) then
        write (iw, '(2/20X,''STATE VECTORS'',2/)')
        if (last == 3) then
          call matou1 (conf, eig, lab, lab, lab, 4)
        else
          call matout (conf, eig, lab, lab, lab)
        end if
      end if
      if (prnt) then
        write (iw, &
      '(/,''  STATE       ENERGY (EV)        Q.N.  SPIN   SYMMETRY              POLARIZATION'')')
        write (iw, &
      '(''         ABSOLUTE     RELATIVE'',28X,''    X           Y           Z'',/)')
      end if
      iroot = 0
      jroot = 1
      cimat = 0.1D0
      ispin(:lab) = 0
      do i = 1, labsiz
        if (last == 0 .and. root_ir == "XXXX") then
          namo(i) = ' '
          jndex(i) = i
        end if
        x = 0.5D0*xx
        ii = (i - 1)*lab
        do j = 1, lab
          ji = j + ii
          x = x - conf(ji)*conf(ji)*spin(j)*0.25D0
          k = ispqr(j,1)
          if (k == 1) cycle
          l = 2
          if (k - 1 > 0) then
            do l = 1, k - 1
              x = x + conf(ji)*conf(ispqr(j,l+1)+ii)*2.D0
            end do
            l = k + 1
          end if
        end do
        y = (-1.D0 + sqrt(1.D0 + 4.D0*x))*0.5D0
        ispin(i) = nint(y*2.D0 + 1)
        if (Abs(ispin(i) - y*2.d0 - 1.d0) > 0.2d0) then
          ispin(i) = 11
        else
          ispin(i) = Min(ispin(i), 11)
        end if
        cimat(j) = cimat(j) + 1
      end do
!
!   Reset jndex to allow for spin.
!
    qn_temp = 0
    srep = " "
    irep = 0
    if (allocated(nfa))     deallocate(nfa)
    i = Max(maxci, nmos + 3, lab)
    allocate(nfa(i))
    nfa(1:lab) = jndex(1:lab)
    j = 0
    l = 0
    do i = 1, lab
      if (i > 1) then
!
!  If part of a degenerate manifold, use previous quantum number
!
        if (nfa(i) == nfa(i-1) .and. namo(i) == namo(i-1)) then
          jndex(i) = jndex(i-1)
          if (smult < 0 .or. ispin(i) == smult) iroot = iroot + 1
          cycle
        end if
      end if
!
!  Find Irreducible Representation
!
      do k = 1, j
        if (srep(k) == namo(i)) exit
      end do
      if (k > j) then
        j = j + 1
        srep(j) = namo(i)
      end if
      do m = 1, l
        if (irep(m) == ispin(i)) exit
      end do
      if (m > l) then
        l = l + 1
        irep(l) = ispin(i)
      end if
      if (k>20 .or. m > 20) then
        write(iw,*)" An error has ocurred in MECI, here are some diagnostics"
        write(iw,"(a,i5)")"Number of states (lab):              ", lab
        write(iw,"(a,i5)")"Number of states calculated (labsiz):", labsiz
        write(iw,"(a,i5)")"Error ocurred on state number:       ", i
        write(iw,"(a,2i5)")"Value of 'k' and 'm':", k,m
        if (m > 20) then
          write(iw,*)" Values of ispin"
          write(iw,"(10i5)")ispin(:lab)
          write(iw,*)" Values of irep"
          write(iw,"(10i5)")irep(:m)
        end if
        stop 'Dimension error in MECI.F90'
      end if
      qn_temp(k, m) = qn_temp(k, m) + 1
      jndex(i) = qn_temp(k, m)
      if (root_requested < 1 .and. (smult < 0 .or. ispin(i) == smult)) then
        iroot = iroot + 1
        if (iroot >= lroot .and. jroot <= lroot .and. root_ir == "XXXX" .or. &
          &   lroot == jndex(i) .and. root_ir == namo(i))  then
!
!    Select spin root "smult" if spin is defined, otherwise use all spins
!    Select state with lroot if no I.R. is given, otherwise select the "lroot"'th
!    state of names I.R.
!
!   The root requested has been found
!
          root_requested = i
          meci = eig(i)
          m = 0
          do k = i, min(lab,i + 22)
            if (abs(eig(k)-eig(i)) > 1.D-2) go to 510
            if (lab > 0) then
              vectci(m+1:lab+m) = conf(1+lab*(k-1):lab*k)
              m = lab + m
            end if
          end do
          k = min(lab,i + 4) + 1
  510     continue
          nstate = k - i
        end if
        jroot = iroot
      end if
    end do
      if (root_requested < 1) then
        call mopend ("ROOT REQUESTED DOES NOT EXIST IN C.I.")
        write (iw,'(a,i5,a)')"  Root requested:",lroot,root_ir
        if (sing) write(iw,'(a)')"  State requested must be a Singlet."
        if (doub) write(iw,'(a)')"  State requested must be a Doublet."
        if (trip) write(iw,'(a)')"  State requested must be a Triplet."
        if (quar) write(iw,'(a)')"  State requested must be a Quartet."
        if (quin) write(iw,'(a)')"  State requested must be a Quintet."
        if (sext) write(iw,'(a)')"  State requested must be a Sextet."
        if (octe) write(iw,'(a)')"  State requested must be a Octet."
        if (none) write(iw,'(a)')"  State requested must be a Nonet."
        if (smult < -0.1d0) write(iw,'(a)')"  State requested can have any spin."
        write (iw,'(/,a,/)')"      Roots available:"
        do i = 1, labsiz
          k = min(labsiz, i + 14)
          do j = i + 1, k
            if (.not.(eig(j)-eig(j-1)>1.D-4 .or. jndex(j)/=jndex(j-1) &
             .or. namo(j)/=namo(j-1))) cycle
            exit
          end do
          if (i > 1) then
            if (eig(i) - eig(i-1)>1.D-4 .or. jndex(i)/=jndex(i-1) .or. &
            namo(i) /= namo(i-1)) &
            write (iw, "(i6,2x,a8,1x,a4)")jndex(i), tspin(ispin(i)), namo(i)
          else
            write (iw, "(i6,2x,a8,1x,a4)") jndex(i), tspin(ispin(i)), namo(i)
          end if
        end do
        meci = 0.d0
        return
      end if
      state_Irred_Rep = namo(root_requested)
      state_spin = tspin(ispin(root_requested))
      state_QN = jndex(root_requested)

      if (prnt) then
        call ciosci (c(1,nelec+1), root_requested, oscil, conf)
        deltapp = 0.d0
        delta = 0.d0
        if (iseps) call dmecip (c, deltapp, delta, eig, vectci, conf)
        do i = 1, labsiz
          tex_root = " "
          k = min(labsiz, i + 14)
          do j = i + 1, k
            if (.not.(eig(j)-eig(j-1)>1.D-4 .or. jndex(j)/=jndex(j-1) &
             .or. namo(j)/=namo(j-1))) cycle
            exit
          end do
          work = 0.D0
          do k = i, j - 1
            work = work + oscil(:,k)**2
            l = 4
          end do
          do k = i, j - 1
            if(root_requested == k) tex_root = "+"
          end do
          if (work(1) + work(2) + work(3) > 1.D-9) then
            k = 3
          else
            k = 0
          end if
          if (i > 1) then
            if (eig(i) - eig(i-1)>1.D-4 .or. jndex(i)/=jndex(i-1) .or. namo(i)&
              /=namo(i-1)) write (iw, 580) i, tex_root, eig(i), eig(i) - eig(1), &
              jndex(i), tex_root, tspin(ispin(i)), namo(i), (sqrt(work(j)),j=1,k)
          else
            write (iw, 580) i, tex_root, eig(i), eig(i) - eig(1), jndex(i), &
            tex_root, tspin(ispin(i)), namo(i), (sqrt(work(j)),j=1,k)
          end if
        end do
      end if
      if (prnt .and. msdel /= 0) write (iw, '(/10x, A, /10x, a)') &
        ' ''RELATIVE ENERGY'' Is relative to the lowest state calculated.', &
        ' This may or may not be the ground state.'
      if (prnt) write (iw, '(10x, A)')  ' The "+" symbol indicates the root used.'
  580 format(i5,a,2f12.6,i6,a1,2x,a8,4x,a4,3f12.4)
      if (root_requested == 0) then
        call mopend (&
       'THE STATE REQUIRED IS NOT PRESENT IN THE SET OF CONFIGURATIONS AVAILABLE')
        write (iw, &
      '(/ 4X,''NUMBER OF STATES ACCESSIBLE USING CURRENT KEY-WORDS'',/)')
        do i = 1, 7
          if (cimat(i) <= 0.5D0) cycle
          write (iw, '((24X,A8,I4))') tspin(i), nint(cimat(i))
        end do
        meci = 0.D0
        return
      end if
      maxvec = 0
      if (lspin) maxvec = root_requested + min(3,lab - root_requested)
      if (lspin .and. (ne/2)*2==ne) write (iw, &
        '(''   ESR SPECIFIED FOR AN EVEN-ELECTRON SYSTEM'')')
      do iuj = root_requested, maxvec
        iofset = (iuj - 1)*lab
        write (iw, &
      '(2/,''      MICROSTATE CONTRIBUTIONS TO STATE EIGENFUNCTION'',I3)') iuj
        write (iw, '(5F13.6)') (conf(i+iofset),i=1,lab)
        do i = 1, lab
          conf(i) = conf(i+iofset)**2
        end do
!                                             SECOND VECTOR!
        do i = 1, nmos
          sum = 0.D0
          do j = 1, lab
            sum = sum + (microa(i,j)-microb(i,j))*conf(j)
          end do
          eiga(i) = sum
        end do
        write (iw, &
          '(/,''    SPIN DENSITIES FROM EACH M.O., ENERGY:''    ,F7.3)') eig(&
          iuj)
        write (iw, '(5F12.6)') (eiga(i),i=1,nmos)
        write (iw, *)
        j = 0
        do i = 1, numat
          if (nlast(i) - nfirst(i) > 5) j = 1
        end do
        write (iw, *) '     SPIN DENSITIES FROM EACH ATOMIC ORBITAL'
        if (j == 1) then
          write (iw, '(a,/)') ' Atom   s        p(x)      p(y)      p(z)     d(x2-y2)   '//&
          &'d(xz)     d(z2)     d(yz)     d(xy)     TOTAL'
        else
          write (iw, '(a,/)') ' Atom   s        p(x)      p(y)      p(z)      TOTAL'
        end if
        do i = 1, numat
          il = nfirst(i)
          iu = nlast(i)
          l = 0
          summ = 0.D0
          do k = il, iu
            l = l + 1
            sum = 0.D0
            do j = 1, nmos
              sum = sum + c(k,j+nelec)**2*eiga(j)
            end do
            summ = summ + sum
            eigs(l) = sum
          end do
          if (l == 9) then
            write (iw, '(i4,10f10.6)') i, (eigs(k),k=1,9), summ
          else if (l == 4) then
            write (iw, '(i4,4f10.6,50x,f10.6)') i, (eigs(k),k=1,4), summ
          else if (l == 1) then
            write (iw,'(i4,f10.6,80X,f10.6)') i, eigs(1), summ
          end if
        end do
      end do
      first1 = .FALSE.
      return
      end function meci

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      module funcon_C
      double precision :: &
      &  fpc_1,     & !
      &  fpc_2,     & !
      &  a0,        & !
      &  ev,        & !
      &  fpc_5,     & !
      &  fpc_6,     & !
      &  fpc_7,     & !
      &  fpc_8,     & !
      &  fpc_9,     & !
      &  fpc_10
      double precision, dimension (10) :: fpc = 0.d0
      double precision, parameter :: pi = 3.14159265358979323846d0
      double precision, parameter :: twopi = 2.0d0 * pi
      equivalence (fpc(1), fpc_1), (fpc(2), fpc_2), (fpc(3), a0), (fpc(4), ev), &
      & (fpc(5), fpc_5), (fpc(6), fpc_6), (fpc(7), fpc_7), (fpc(8), fpc_8), &
      & (fpc(9), fpc_9), (fpc(10), fpc_10)
      end module funcon_C

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine dofs(eref, mono3, n, dd, m, bottom, top) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      use chanel_C, only : iw
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: mono3 
      integer , intent(in) :: n 
      integer , intent(in) :: m 
      double precision , intent(in) :: bottom 
      double precision , intent(in) :: top 
      double precision , intent(inout) :: eref(mono3,n) 
      double precision , intent(inout) :: dd(m) 

!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j, ii, k
      double precision :: range, x, b, a, spread, partj, partk 
!-----------------------------------------------
      dd(:500) = 0.D0 
!
!   SPREAD OUT THE ENERGIES OVER THE ENERGY SPECTRUM, TOP TO BOTTOM
!
      range = m/(top - bottom) 
      do j = 1, mono3 
        do i = 1, n 
          x = eref(j,i) 
          if (x<bottom .or. x>top) x = -1.D7 
          eref(j,i) = (x - bottom)*range 
        end do 
      end do 
      do ii = 1, mono3 
        do i = 2, n 
          b = eref(ii,i-1) 
          if (b < 1) cycle  
          a = eref(ii,i) 
          if (a < 1) cycle  
          if (b > a) then 
            x = b 
            b = a 
            a = x 
          end if 
          j = int(b) 
          k = int(a) 
!
! IF J EQUALS K THE INTERVAL FALLS WITHIN ONE BIN
!
          if (j == k) then 
            dd(k) = dd(k) + 1.D0 
          else 
            spread = 1.D0/(a - b + 1.D-12) 
            partj = (j + 1 - b)*spread 
            partk = (a - k)*spread 
            dd(j) = dd(j) + partj 
            dd(k) = dd(k) + partk 
!
! IF K EQUALS J+1 THE INTERVAL STRADDLES TWO BINS
!
            if (k /= j + 1) then 
!
! IF K IS GREATER THAN J+1 THE INTERVAL COVERS MORE THAN TWO BINS
!
              j = j + 1 
              k = k - 1 
              dd(j:k) = dd(j:k) + spread 
            end if 
          end if 
        end do 
      end do 
      x = m/((n - 1)*(top - bottom)) 
      dd = dd*x 
      write (iw, '(A)') ' NORMALIZED DENSITY OF STATES' 
!
!  THE FIRST 'BIN' HAS LOWER BOUND AT BOTTOM AND UPPER BOUND
!  AT BOTTOM+RANGE, THEREFORE THE FIRST 'BIN' IS FOR BOTTOM+0.5*RANGE
!  THE LAST 'BIN' HAS BOUNDS TOP-RANGE AND TOP,
!  THEREFOR THE LAST 'BIN' IS FOR TOP-0.5*RANGE
      range = m/(top - bottom) 
      do i = 1, m 
        write (iw, '(F9.2,F12.6)') bottom + (i - 0.5D0)/range, dd(i) 
      end do 
      return  
      end subroutine dofs 

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine perm(iperm, nels, nmos, nperms, limci)
      use meci_C, only : maxci
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: nels
      integer , intent(in) :: nmos
      integer , intent(inout) :: nperms
      integer , intent(in) :: limci
      integer , intent(inout) :: iperm(nmos,maxci*4)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: Upper, Lower, Prm, El, i
      integer, dimension (:), allocatable :: Occ
!-----------------------------------------------
!***********************************************************************
!
!  PERM PERMUTES NELS ENTITIES AMONG NMOS LOCATIONS. THE ENTITIES AND
!       LOCATIONS ARE EACH INDISTINGUISHABLE. THE PAULI EXCLUSION
!       PRINCIPLE IS FOLLOWED. THE NUMBER OF STATES PRODUCED IS GIVEN
!       BY NMOS!/(NELS!*(NMOS-NELS)!).
! ON INPUT: NELS  = NUMBER OF INDISTINGUISHABLE ENTITIES
!           NMOS  = NUMBER OF INDISTINGUISHABLE LOCATIONS
!
! ON OUTPUT IPERM = ARRAY OF PERMUTATIONS, A 0 INDICATES NO ENTITY,
!                   A 1 INDICATES AN ENTITY.
!           NPERM = NUMBER OF PERMUTATIONS.
!
!***********************************************************************
    Upper = nmos - nels
    Lower = 1
    Prm = 1
    El = nels
    allocate (Occ(-1:nels))
!
!  Occ initially contains the upper bounds that the various electrons
!  can go to.  Thus electron 1 can end up in M.O. "nmos",
!  and electron "nels-1" will end up in M.O. "nmos-nels".
!
    Occ(-1:nels-1) = (/(nmos+1-i, i=-1, nels-1) /)
!
!  For electron "El", the starting position is "1".
!
    call rperm (iperm, nperms, nels, Occ, Lower, Upper, El, limci)
    nperms = Prm-1
    deallocate (Occ)
  contains
    recursive subroutine rperm (iperm, nperms, nels, Occ, Lower, Upper, &
         & El, limci)
      use meci_C, only: nmos
    implicit none
      integer, intent (in) :: nperms, nels, limci
      integer, intent (in) :: Lower, Upper
      integer  :: El
      integer, dimension (-1:nels), intent(inout) :: Occ
      integer, dimension (nmos, nperms), intent(inout) :: iperm
      integer :: i, j, k
      if (El /= 0) then
        do j = Lower, Upper
          Occ(El) = j
          call rperm (iperm, nperms, nels, Occ, Occ(El)+1, Occ(El-2)-2, &
               & El-1, limci)
        end do
!
!  "do" loop is complete.  Now add in the final permutation.
!  (This is the reason for the second "-2" in "Occ(El-2)-2" in the call above.)
!
        Occ(El) = Upper + 1
!
!  Simplest test for exit - is the electron in an unacceptable M.O.,
!  or have all the permutations been calculated.
!
        if (Upper+1 > nmos .or. Prm > nperms) return
      end if
!
!  Generate the permutation.
!
      iperm(1:nmos, Prm) = 0
      do i = 1, nels
        iperm(Occ(i), Prm) = 1
      end do
      ! This statement only has an effect during the first call to rperm
      El = nels + 1
!
!   Eliminate microstates which are not allowed by "limci".
!
      if (limci /= 0 .and. Prm > 1) then
        k = 0
        do j = 1, nmos
          k = k + Abs (iperm(j, Prm)-iperm(j, 1))
        end do
        if (k > limci) then
          Prm = Prm - 1
        end if
      end if
      Prm = Prm + 1
      return
    end subroutine rperm
end subroutine perm

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine getmol (iloop)
!
    use param_global_C, only : weight,nvars, locs, titls, comnts, keys, &
    ndeps, locpas, idepfs, locdes, depmuls, pas, pbs, nats, nfirss, nlasts, &
    numats, norbss, nlecss, nopens, nlm61, ncloss, fracts, &
    natmss, nas, nbs, ncs, lablss, heats, hions, dipls, Atom_pKas, pkas, &
    geos, names, molnam, refgeo, refhof, refips,  msdels, &
    refdip, wthof, wtips, wtgeo, wtdip, wtz, n2elecs, &
    refpka, wtpka, atom_pKa, atom_pKa_O, geotxt, l123s, nnalpha_open, &
    nnbeta_open


    use molkst_C, only : title, koment, natoms, norbs, mpack, numcal, &
    & ndep, nelecs, nvar, nclose, nopen, nalpha, nbeta, fract, lm61, &
    & keywrd, numat, n2elec,  atheat , uhf, id, msdel, refkey, l1u, &
    & l2u, l3u, l123, mol_weight, rhf, lxfac, nalpha_open, nbeta_open

    use common_arrays_C, only : nfirst, nlast, p, pa, pb, nat, labels, na, &
     nb, nc, geo, uspd, xparam, loc, nw, pdiag, atmass

    use parameters_C, only : ams

    use symmetry_C, only : locpar, idepfn, locdep, depmul
    implicit none
!----------------------------------------------------------------------
    integer, intent (in) :: iloop
    integer :: i, iatm, igeo, iloc, ips, isym, j
    save :: iatm, igeo, iloc, ips, isym
    if (iloop == 1) then
      igeo = 0
      isym = 0
      iloc = 0
      iatm = 0
      ips = 0
    end if
    molnam = names(iloop)(:40)
  !
  !     RESTORE ALL DATA RELATING TO THE MOLECULE.
  !
    numcal = iloop
  !#      MOLNUM=ILOOP
    natoms = natmss(iloop)
    numat = numats(iloop)
    ndep = ndeps(iloop)
    norbs = norbss(iloop)
    n2elec = n2elecs(iloop)
    mpack = (norbs*(norbs+1)) / 2
    nelecs = nlecss(iloop)
    nvar = nvars(iloop)
    keywrd = keys(iloop)
    refkey(1) = trim(keywrd)
    nclose = ncloss(iloop)
    nopen = nopens(iloop)
    nalpha_open = nnalpha_open(iloop)
    nbeta_open = nnbeta_open(iloop)
    msdel = msdels(iloop)
    l1u = l123s(1,iloop)
    l2u = l123s(2,iloop)
    l3u = l123s(3,iloop)
    l123 = (2*l1u + 1)*(2*l2u + 1)*(2*l3u + 1)
    rhf   = (Index (keywrd, " RHF") + Index(keywrd, " OPEN") + &
    index(keywrd, " MECI") /= 0 .or. Index (keywrd, " C.I.") /= 0)
    lxfac = (Index (keywrd, " XFAC") /= 0)
    if(index(keywrd," UHF") /=0)then
    nalpha = nclose
    nbeta  = nopen
    nclose = 0
    nopen  = 0
    uhf = .true.
    else
    nalpha = 0
    nbeta  = 0
    uhf = .false.
    end if
    if (.not. rhf .and. .not. uhf) then
      if (mod(nelecs,2) == 0) then
        rhf = .true.
      else
        nalpha = nclose
        nbeta  = nopen
        nclose = 0
        nopen  = 0
        uhf = .true.
      end if
    end if
    title = trim(titls(iloop))
    koment = comnts(iloop)
 !   nmos = nnmos(iloop)
    lm61 = nlm61(iloop)
    fract = fracts(iloop)
  !
  ! RESTORE GEOMETRIC DATA
  !
    do i = 1, natoms
      igeo = igeo + 1
      do j = 1, 3
        geo(j, i) = geos(j, igeo)
      end do
    end do
    do i = 1, ndep
      isym = isym + 1
      locpar(i) = locpas(isym)
      idepfn(i) = idepfs(isym)
      locdep(i) = locdes(isym)
      depmul(i) = depmuls(isym)
    end do
  !
  ! XPARAM is defined by the geo - it does NOT exist separately
  !
    do i = 1, nvar
      iloc = iloc + 1
      xparam(i) = geo(locs(2, iloc), locs(1, iloc))
      loc(1, i) = locs(1, iloc)
      loc(2, i) = locs(2, iloc)
    end do
    loc(1, nvar+1) = 0
  !
  !  RESTORE ATOMIC DATA.
  !
  mol_weight = 0.d0
    do i = 1, natoms
      iatm = iatm + 1
      na(i) = nas(iatm)
      nb(i) = nbs(iatm)
      nc(i) = ncs(iatm)
      nat(i) = nats(iatm)
      if ( i <= numat) then
        atmass(i) = ams(nat(i))
        mol_weight = mol_weight + atmass(i)
      end if
      nfirst(i) = nfirss(iatm)
      nlast(i) = nlasts(iatm)
      labels(i) = lablss(iatm)
    end do
    j = 1
    do i = 1, numat
      nw(i) = j
      j = j + ((nlast(i)-nfirst(i)+1)*(nlast(i)-nfirst(i)+2))/2
    end do
    id = 0
  !
  !  RESTORE ORBITAL DATA
  !
    call getusp (nat, nfirst, nlast, uspd, atheat)
    do i = 1, mpack
      pa(i) = pas(i+ips)
      pb(i) = pbs(i+ips)
      p(i) = pa(i) + pb(i)
    end do
    do i = 1, norbs
      pdiag(i) = p((i*(i+1))/2)
    end do
    ips = ips + mpack
  !
  !  RESTORE REFERENCE DATA
  !
    refhof = heats(iloop)
    refips = hions(iloop)
    refdip = dipls(iloop)
    refpka = pkas(iloop)
    atom_pKa = Atom_pKas(iloop,1)
    atom_pKa_O = Atom_pKas(iloop,2)
    do i = 1, 300
      refgeo(i) = geotxt(i, iloop)
    end do
    wthof = weight(1, iloop)
    wtdip = weight(2, iloop)
    wtips = weight(3, iloop)
    wtgeo = weight(4, iloop)
    wtz   = weight(5, iloop)
    wtpka = weight(6, iloop)
    if (atom_pKa /= 0) then  !  it's a pKa, so set pKa weight and set HoF weight to zero.
      wtpKa = wthof
      wthof = 0.d0
    else
      wtpKa = 0.d0
    end if
end subroutine getmol
subroutine getusp (nat, nfirst, nlast, uspd, atheat)
    use molkst_C, only : numat, norbs, keywrd, cutofp, id
    USE parameters_C, only : eisol, eheat, uss, upp, udd, eheat_sparkles, zs
    use funcon_C, only : fpc_9
    use common_arrays_C, only : geo, coord
    implicit none
    integer, dimension (numat), intent (in) :: nat, nfirst, nlast
    double precision, dimension (norbs), intent (out) :: uspd
    double precision, intent (out) :: atheat
    integer :: ia, ib, ii, j, k, k1, ni, i
    double precision :: eat
    double precision, external :: C_triple_bond_C
!----------------------------------------------------------------
    atheat = 0.d0
    if (index(keywrd, " SPARKL") /= 0) then
      atheat = 0.d0
      do i = 1, numat
        if  (nat(i) > 56 .and. nat(i) < 72 .and. zs(nat(i)) < 0.1d0) then
          atheat = atheat + eheat_sparkles(nat(i))
        else
          atheat = atheat + eheat(nat(i))
        end if
      end do
    else
      atheat = sum(eheat(nat(:numat)))
    end if
    eat = sum(eisol(nat(:numat)))
    do ii = 1, numat
      ia = nfirst(ii)
      ib = nlast(ii)
      ni = nat(ii)
      if (ia <= ib) then
        uspd(ia) = uss(ni)
        if (ia /= ib) then
          k = ia + 1
          k1 = ia + 3
          do j = k, k1
            uspd(j) = upp(ni)
          end do
          if (k1 /= ib) then
            k = k1 + 1
            do j = k, ib
              uspd(j) = udd(ni)
            end do
          end if
        end if
      end if
    end do
    atheat = atheat - eat * fpc_9
    call gmetry (geo, coord)
    if (id == 0) then
      cutofp = 1.d10
    else
      cutofp = 30.d0
    end if
    call set_up_dentate
    atheat = atheat + C_triple_bond_C()
!
end subroutine getusp

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine mopend(txt)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE molkst_C, only : moperr, errtxt
      use chanel_C, only : iw
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      character , intent(in) :: txt*(*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
!-----------------------------------------------
      moperr = .TRUE.
      errtxt = txt
      call summary(txt, len_trim(txt))
      if (trim(txt) /= "JOB ENDED NORMALLY" ) write(iw,'(/10x,a)')trim(txt)
      call to_screen("To_file:END_OF_JOB"//trim(txt))
      return
      end subroutine mopend
      subroutine summary(txt, ntxt)
!
!  Collect error messages and print them at the end of each calculation
!
!
        use chanel_C, only : iw, ir
        use molkst_C, only : line, job_no, natoms
        implicit none
        integer, intent (in) :: ntxt
        character, intent (in) :: txt*(*)
!
!  Local quantities
!
        integer, parameter :: lim = 120, hook = 50
        character :: messages(20)*(lim), blank*(lim)
        integer :: nmessages = 0, i, j, max_txt
        logical :: first = .true., opend
        save
        if (first) then
           messages(1)(:18) = "JOB ENDED NORMALLY"
           first = .false.
!
!   Add closing message to AUX file
!
           inquire(unit=hook, opened=opend)
           if (opend) then
             write(hook,"(a)")" END OF MOPAC PROGRAM"
           end if
        end if
        if (ntxt == 1) then
          if (natoms == 0 .and. job_no == 1) then
            write(iw,'(/10x, a)')"Job failed to run because no atoms were detected in the system"
            write(iw,'(10x, a, /)')"The start of the data-set is as follows:"
            rewind (ir)
            max_txt = 0
            do i = 1, 9
              read(ir, '(a)', iostat = j)line
              if (j /= 0) exit
              max_txt = max(max_txt, len_trim(line))
            end do
            rewind (ir)
            do i = 1, 9
              read(ir, '(a)', iostat = j)line
              if (j /= 0) exit
              write(iw,'(a, i1, a)')" Line ", i, ": """//line(:max_txt)//""""
            end do
            if (i < 10) write(iw,'(/,a)')"          Then the end of the data-set was detected"
          end if
!
!   Write out messages
!
          blank = " "
          blank(1:1) = "*"
          max_txt = 1
          do i = 1, nmessages
            max_txt = max(max_txt, len_trim(messages(i)))
          end do
          max_txt = min(lim, max(max_txt + 4, 22))
          if (messages(1)(1:18) /= "JOB ENDED NORMALLY" ) max_txt = max(max_txt, 78)
          write(iw,'(/1x,120a)')("*", i = 1, max_txt)
          blank(max_txt:max_txt) = "*"
          write(iw,'(1x,a)')trim(blank)
          if (messages(1)(1:18) /= "JOB ENDED NORMALLY" ) then
            write(line,'(a)') "*     Error and normal termination messages reported in this calculation"
            line(max_txt:max_txt) = "*"
            write(iw,'(1x,a)')trim(line)
            write(iw,'(1x,a)')trim(blank)
            do i = 1, nmessages
              if (index(messages(i),"JOB ENDED NORMALLY") > 0) cycle
              write(line,'(a)')"* "//trim(messages(i))
              line(max_txt:max_txt) = "*"
              write(iw,'(1x,a)')trim(line)
            end do
          end if
          write(line,'(a)') "* JOB ENDED NORMALLY "
          line(max_txt:max_txt) = "*"
          write(iw,'(1x,a)')trim(line)
          write(iw,'(1x,a)')trim(blank)
          write(iw,'(1x,120a)')("*", i = 1, max_txt)
          nmessages = 0
          messages(1) = "JOB ENDED NORMALLY"
        else
!
!   Store current message
!
          if (nmessages == 20) return
          nmessages = nmessages + 1
          i = min(ntxt, lim - 3)
          messages(nmessages) = txt(:i)
        end if
        return
      end subroutine summary

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

double precision function reada (string, istart)
  !     FORTRAN FUNCTION TO EXTRACT NUMBER FROM STRING
  !
  ! 
  !.. Implicit Declarations .. 
  implicit none
  ! 
  !.. Formal Arguments .. 
  character(len=*), intent(in) :: string
  integer, intent(in) :: istart
  ! 
  !.. Local Scalars .. 
  logical :: expnnt
  integer :: i, i0, i9, iadd, icapd, icape, idot, ineg, ipos, ismld, ismle, &
       & j, l, n
  double precision, external :: digit
  ! 
  ! ... Executable Statements ...
  ! 
  !
  !     DEFINE ASCII VALUES OF NUMERIC FIELD CHARACTERS
  i0 = Ichar ("0")
  i9 = Ichar ("9")
  idot = Ichar (".")
  ineg = Ichar ("-")
  ipos = Ichar ("+")
  icapd = Ichar ("D")
  icape = Ichar ("E")
  ismld = Ichar ("d")
  ismle = Ichar ("e")
  !
  l = Len (string)
  !
  !     FIND THE START OF THE NUMERIC FIELD
  do i = istart, l
    iadd = 0
    n = Ichar (string(i:i))
    !
    !       SIGNAL START OF NUMERIC FIELD IF DIGIT FOUND
    if (n>=i0 .and. n<=i9) goto 1000
    !
    !       ACCOUNT FOR CONSECUTIVE SIGNS [- AND(OR) +]
    if (n==ineg .or. n==ipos) then
      iadd = iadd + 1
      if (i+iadd > l) exit
      n = Ichar (string(i+iadd:i+iadd))
      if (n>=i0 .and. n<=i9) goto 1000
    end if
    !
    !       ACCOUNT FOR CONSECUTIVE DECIMAL POINTS (.)
    if (n == idot) then
      iadd = iadd + 1
      if (i+iadd > l) exit
      n = Ichar (string(i+iadd:i+iadd))
      if (n>=i0 .and. n<=i9) goto 1000
    end if
  end do
  !
  !     DEFAULT VALUE RETURNED BECAUSE NO NUMERIC FIELD FOUND
  reada = 0.d0
  return
  !
  !     FIND THE END OF THE NUMERIC FIELD
  1000 expnnt = .false.
  do j = i+1, l
    iadd = 0
    n = Ichar (string(j:j))
    !
    !       CONTINUE SEARCH FOR END IF DIGIT FOUND
    if (n<i0 .or. n>i9) then
      !
      !       CONTINUE SEARCH FOR END IF SIGN FOUND AND EXPNNT TRUE
      if (n==ineg .or. n==ipos) then
        if (.not. expnnt) goto 1100
        iadd = iadd + 1
        if (j+iadd > l) goto 1100
        n = Ichar (string(j+iadd:j+iadd))
        if (n>=i0 .and. n<=i9) cycle
      end if
      if (n == idot) then
        iadd = iadd + 1
        if (j+iadd > l) goto 1100
        n = Ichar (string(j+iadd:j+iadd))
        if (n>=i0 .and. n<=i9) then
          cycle
        elseif (n==icape .or. n==ismle .or. n==icapd .or. n==ismld) then
          cycle
        end if
      end if
      if (n/=icape .and. n/=ismle .and. n/=icapd .and. n/=ismld) goto 1100
      if (expnnt) goto 1100
      expnnt = .true.
    end if
  end do
  j = l + 1
  1100 n = Ichar (string(j-1:j-1))
  if (n==icape .or. n==ismle .or. n==icapd .or. n==ismld) then
    j = j - 1
  end if
  !
  !     FOUND THE END OF THE NUMERIC FIELD (IT RUNS 'I' THRU 'J-1')
  n = 0
  n = n + Index (string(i:j-1), "e")
  n = n + Index (string(i:j-1), "E")
  n = n + Index (string(i:j-1), "d")
  n = n + Index (string(i:j-1), "D")
  if (n == 0) then
    reada = digit (string(i:j-1), 1)
  else
    reada = digit (string(:i+n-2), i) * 1.d1**digit (string(:j-1), i+n)
  end if
end function reada

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine minv (a, n, d)
  implicit none
  double precision, dimension(*), intent(inout) :: a
  integer, intent(in) :: n
  double precision, intent(out) :: d
!
  integer :: i, ij, ik, iz, j, ji, jk, jp, jq, jr, k, ki, kj, kk, nk
  double precision :: biga, hold
  integer, dimension(n) :: l, m
  !
  !     SEARCH FOR LARGEST ELEMENT
  !
  d = 1.0d0
  nk = -n
  do k = 1, n
    nk = nk + n
    l(k) = k
    m(k) = k
    kk = nk + k
    biga = a(kk)
    do j = k, n
      iz = n * (j-1)
      do i = k, n
        ij = iz + i
        if (Abs (biga) < Abs (a(ij))) then
          biga = a(ij)
          l(k) = i
          m(k) = j
        end if
      end do
    end do
    !
    !     INTERCHANGE ROWS
    !
    j = l(k)
    if (j > k) then
      ki = k - n
      do i = 1, n
        ki = ki + n
        hold = -a(ki)
        ji = ki - k + j
        a(ki) = a(ji)
        a(ji) = hold
      end do
    end if
    !
    !     INTERCHANGE COLUMNS
    !
    i = m(k)
    if (i > k) then
      jp = n * (i-1)
      do j = 1, n
        jk = nk + j
        ji = jp + j
        hold = -a(jk)
        a(jk) = a(ji)
        a(ji) = hold
      end do
    end if
    !
    !     DIVIDE COLUMN BY MINUS PIVOT (VALUE OF PIVOT ELEMENT IS
    !     CONTAINED IN BIGA)
    !
    if (biga == 0.0d0) then
      d = 0.d0
      return
    end if
    do i = 1, n
      if (i /= k) then
        ik = nk + i
        a(ik) = a(ik) / (-biga)
      end if
    end do
    !  REDUCE MATRIX
    do i = 1, n
      ik = nk + i
      hold = a(ik)
      ij = i - n
      do j = 1, n
        ij = ij + n
        if (i/=k .and. j/=k) then
          kj = ij - i + k
          a(ij) = hold*a(kj) + a(ij)
        end if
      end do
    end do
    !
    !     DIVIDE ROW BY PIVOT
    !
    kj = k - n
    do j = 1, n
      kj = kj + n
      if (j /= k) then
        a(kj) = a(kj) / biga
      end if
    end do
    !
    !     PRODUCT OF PIVOTS
    !
    d = Max (-1.d25, Min (1.d25, d))
    d = d * biga
    !
    !     REPLACE PIVOT BY RECIPROCAL
    !
    a(kk) = 1.d0 / biga
  end do
  !
  !     FINAL ROW AND COLUMN INTERCHANGE
  !
  k = n
  do
    k = (k-1)
    if (k <= 0) exit
    i = l(k)
    if (i > k) then
      jq = n * (k-1)
      jr = n * (i-1)
      do j = 1, n
        jk = jq + j
        hold = a(jk)
        ji = jr + j
        a(jk) = -a(ji)
        a(ji) = hold
      end do
    end if
    j = m(k)
    if (j > k) then
      ki = k - n
      do i = 1, n
        ki = ki + n
        hold = a(ki)
        ji = ki - k + j
        a(ki) = -a(ji)
        a(ji) = hold
      end do
    end if
  end do
end subroutine minv

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.


            real(kind(0.0d0)) function ddot (n, dx, incx, dy, incy) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  22:48:56  03/08/06  
!...Switches: -rl INDDO=2 INDIF=2 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n 
      integer , intent(in) :: incx 
      integer , intent(in) :: incy 
      real(double) , intent(in) :: dx(*) 
      real(double) , intent(in) :: dy(*) 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: ix, iy, m, mp1 
      real(double) :: dtemp 
!-----------------------------------------------
!
!     FORMS THE DOT PRODUCT OF TWO VECTORS.
!           DOT = DX(I) * DY(I)
!     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.
!     JACK DONGARRA, LINPACK, 3/11/78.
!
      ddot = 0.0D+00 
      dtemp = 0.0D+00 
      if (n <= 0) return  
      if (incx/=1 .or. incy/=1) then 
!
!        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
!          NOT EQUAL TO 1
!
        ix = 1 
        iy = 1 
        if (incx < 0) ix = ((-n) + 1)*incx + 1 
        if (incy < 0) iy = ((-n) + 1)*incy + 1 
        dtemp = dot_product(dx(ix:(n-1)*incx+ix:incx),dy(iy:(n-1)*incy+iy:incy)) 
        ddot = dtemp 
        return  
      endif 
!
!        CODE FOR BOTH INCREMENTS EQUAL TO 1
!
!
!        CLEAN-UP LOOP
!
      m = mod(n,5) 
      if (m == 0) go to 40 
      dtemp = dot_product(dx(:m),dy(:m)) 
      if (n < 5) go to 60 
   40 continue 
      mp1 = m + 1 
      dtemp = dtemp + dot_product(dx(mp1:((n-mp1+5)/5)*5-1+mp1),dy(mp1:((n-mp1+5)/5)*5-1+mp1)) 
   60 continue 
      ddot = dtemp 
      return  
      end function ddot 

          subroutine dcopy(n, dx, incx, dy, incy) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  22:48:56  03/08/06  
!...Switches: -rl INDDO=2 INDIF=2 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n 
      integer , intent(in) :: incx 
      integer , intent(in) :: incy 
      real(double) , intent(in) :: dx(*) 
      real(double) , intent(out) :: dy(*) 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: ix, iy, m, mp1 
!-----------------------------------------------
!
!     COPIES A VECTOR, X, TO A VECTOR, Y.
!     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.
!     JACK DONGARRA, LINPACK, 3/11/78.
!
!
      if (n <= 0) return  
      if (incx/=1 .or. incy/=1) then 
!
!        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
!          NOT EQUAL TO 1
!
        ix = 1 
        iy = 1 
        if (incx < 0) ix = ((-n) + 1)*incx + 1 
        if (incy < 0) iy = ((-n) + 1)*incy + 1 
        dy(iy:(n-1)*incy+iy:incy) = dx(ix:(n-1)*incx+ix:incx) 
        return  
      endif 
!
!        CODE FOR BOTH INCREMENTS EQUAL TO 1
!
!
!        CLEAN-UP LOOP
!
      m = mod(n,7) 
      if (m /= 0) then 
        dy(:m) = dx(:m) 
        if (n < 7) return  
      endif 
      mp1 = m + 1 
      dy(mp1:((n-mp1+7)/7)*7-1+mp1) = dx(mp1:((n-mp1+7)/7)*7-1+mp1) 
      return  
      end subroutine dcopy 

           subroutine dgemm(transa, transb, m, n, k, alpha, a, lda, b, ldb, beta, c, ldc) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  22:48:56  03/08/06  
!...Switches: -rl INDDO=2 INDIF=2 
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: m 
      integer , intent(in) :: n 
      integer , intent(in) :: k 
      integer , intent(in) :: lda 
      integer , intent(in) :: ldb 
      integer , intent(in) :: ldc 
      real(double) , intent(in) :: alpha 
      real(double) , intent(in) :: beta 
      character  :: transa*(*) 
      character  :: transb*(*) 
      real(double) , intent(in) :: a(lda,*) 
      real(double) , intent(in) :: b(ldb,*) 
      real(double) , intent(out) :: c(ldc,*) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      real(double), parameter :: zero = 0.0D+0 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, info, j, l, nrowa, nrowb 
      real(double) :: temp 
      logical :: nota, notb 
!-----------------------------------------------
!   I n t r i n s i c  F u n c t i o n s
!-----------------------------------------------
      INTRINSIC max 
!-----------------------------------------------
!     .. SCALAR ARGUMENTS ..
!     .. ARRAY ARGUMENTS ..
!     ..
!
!  PURPOSE
!  =======
!
!  DGEMM  PERFORMS ONE OF THE MATRIX-MATRIX OPERATIONS
!
!     C := ALPHA*OP( A )*OP( B ) + BETA*C,
!
!  WHERE  OP( X ) IS ONE OF
!
!     OP( X ) = X   OR   OP( X ) = X',
!
!  ALPHA AND BETA ARE SCALARS, AND A, B AND C ARE MATRICES, WITH OP( A )
!  AN M BY K MATRIX,  OP( B )  A  K BY N MATRIX AND  C AN M BY N MATRIX.
!
!  PARAMETERS
!  ==========
!
!  TRANSA - CHARACTER*1.
!           ON ENTRY, TRANSA SPECIFIES THE FORM OF OP( A ) TO BE USED IN
!           THE MATRIX MULTIPLICATION AS FOLLOWS:
!
!              TRANSA = 'N' OR 'N',  OP( A ) = A.
!
!              TRANSA = 'T' OR 'T',  OP( A ) = A'.
!
!              TRANSA = 'C' OR 'C',  OP( A ) = A'.
!
!           UNCHANGED ON EXIT.
!
!  TRANSB - CHARACTER*1.
!           ON ENTRY, TRANSB SPECIFIES THE FORM OF OP( B ) TO BE USED IN
!           THE MATRIX MULTIPLICATION AS FOLLOWS:
!
!              TRANSB = 'N' OR 'N',  OP( B ) = B.
!
!              TRANSB = 'T' OR 'T',  OP( B ) = B'.
!
!              TRANSB = 'C' OR 'C',  OP( B ) = B'.
!
!           UNCHANGED ON EXIT.
!
!  M      - INTEGER.
!           ON ENTRY,  M  SPECIFIES  THE NUMBER  OF ROWS  OF THE  MATRIX
!           OP( A )  AND OF THE  MATRIX  C.  M  MUST  BE AT LEAST  ZERO.
!           UNCHANGED ON EXIT.
!
!  N      - INTEGER.
!           ON ENTRY,  N  SPECIFIES THE NUMBER  OF COLUMNS OF THE MATRIX
!           OP( B ) AND THE NUMBER OF COLUMNS OF THE MATRIX C. N MUST BE
!           AT LEAST ZERO.
!           UNCHANGED ON EXIT.
!
!  K      - INTEGER.
!           ON ENTRY,  K  SPECIFIES  THE NUMBER OF COLUMNS OF THE MATRIX
!           OP( A ) AND THE NUMBER OF ROWS OF THE MATRIX OP( B ). K MUST
!           BE AT LEAST  ZERO.
!           UNCHANGED ON EXIT.
!
!  ALPHA  - DOUBLE PRECISION.
!           ON ENTRY, ALPHA SPECIFIES THE SCALAR ALPHA.
!           UNCHANGED ON EXIT.
!
!  A      - DOUBLE PRECISION ARRAY OF DIMENSION ( LDA, KA ), WHERE KA IS
!           K  WHEN  TRANSA = 'N' OR 'N',  AND IS  M  OTHERWISE.
!           BEFORE ENTRY WITH  TRANSA = 'N' OR 'N',  THE LEADING  M BY K
!           PART OF THE ARRAY  A  MUST CONTAIN THE MATRIX  A,  OTHERWISE
!           THE LEADING  K BY M  PART OF THE ARRAY  A  MUST CONTAIN  THE
!           MATRIX A.
!           UNCHANGED ON EXIT.
!
!  LDA    - INTEGER.
!           ON ENTRY, LDA SPECIFIES THE FIRST DIMENSION OF A AS DECLARED
!           IN THE CALLING (SUB) PROGRAM. WHEN  TRANSA = 'N' OR 'N' THEN
!           LDA MUST BE AT LEAST  MAX( 1, M ), OTHERWISE  LDA MUST BE AT
!           LEAST  MAX( 1, K ).
!           UNCHANGED ON EXIT.
!
!  B      - DOUBLE PRECISION ARRAY OF DIMENSION ( LDB, KB ), WHERE KB IS
!           N  WHEN  TRANSB = 'N' OR 'N',  AND IS  K  OTHERWISE.
!           BEFORE ENTRY WITH  TRANSB = 'N' OR 'N',  THE LEADING  K BY N
!           PART OF THE ARRAY  B  MUST CONTAIN THE MATRIX  B,  OTHERWISE
!           THE LEADING  N BY K  PART OF THE ARRAY  B  MUST CONTAIN  THE
!           MATRIX B.
!           UNCHANGED ON EXIT.
!
!  LDB    - INTEGER.
!           ON ENTRY, LDB SPECIFIES THE FIRST DIMENSION OF B AS DECLARED
!           IN THE CALLING (SUB) PROGRAM. WHEN  TRANSB = 'N' OR 'N' THEN
!           LDB MUST BE AT LEAST  MAX( 1, K ), OTHERWISE  LDB MUST BE AT
!           LEAST  MAX( 1, N ).
!           UNCHANGED ON EXIT.
!
!  BETA   - DOUBLE PRECISION.
!           ON ENTRY,  BETA  SPECIFIES THE SCALAR  BETA.  WHEN  BETA  IS
!           SUPPLIED AS ZERO THEN C NEED NOT BE SET ON INPUT.
!           UNCHANGED ON EXIT.
!
!  C      - DOUBLE PRECISION ARRAY OF DIMENSION ( LDC, N ).
!           BEFORE ENTRY, THE LEADING  M BY N  PART OF THE ARRAY  C MUST
!           CONTAIN THE MATRIX  C,  EXCEPT WHEN  BETA  IS ZERO, IN WHICH
!           CASE C NEED NOT BE SET ON ENTRY.
!           ON EXIT, THE ARRAY  C  IS OVERWRITTEN BY THE  M BY N  MATRIX
!           ( ALPHA*OP( A )*OP( B ) + BETA*C ).
!
!  LDC    - INTEGER.
!           ON ENTRY, LDC SPECIFIES THE FIRST DIMENSION OF C AS DECLARED
!           IN  THE  CALLING  (SUB)  PROGRAM.   LDC  MUST  BE  AT  LEAST
!           MAX( 1, M ).
!           UNCHANGED ON EXIT.
!
!
!  LEVEL 3 BLAS ROUTINE.
!
!  -- WRITTEN ON 8-FEBRUARY-1989.
!     JACK DONGARRA, ARGONNE NATIONAL LABORATORY.
!     IAIN DUFF, AERE HARWELL.
!     JEREMY DU CROZ, NUMERICAL ALGORITHMS GROUP LTD.
!     SVEN HAMMARLING, NUMERICAL ALGORITHMS GROUP LTD.
!
!
!     .. EXTERNAL FUNCTIONS ..
!     .. EXTERNAL SUBROUTINES ..
!     .. INTRINSIC FUNCTIONS ..
!     .. LOCAL SCALARS ..
!     .. PARAMETERS ..
!     ..
!     .. EXECUTABLE STATEMENTS ..
!
!     SET  NOTA  AND  NOTB  AS  TRUE IF  A  AND  B  RESPECTIVELY ARE NOT
!     TRANSPOSED AND SET  NROWA, NCOLA AND  NROWB  AS THE NUMBER OF ROWS
!     AND  COLUMNS OF  A  AND THE  NUMBER OF  ROWS  OF  B  RESPECTIVELY.
!
      nota = lsame(transa,'N') 
      notb = lsame(transb,'N') 
      if (nota) then 
        nrowa = m 
      else 
        nrowa = k 
      endif 
      if (notb) then 
        nrowb = k 
      else 
        nrowb = n 
      endif 
!
!     TEST THE INPUT PARAMETERS.
!
      info = 0 
      if (.not.nota .and. .not.lsame(transa,'C') .and. .not.lsame(transa,'T')) &
        then 
        info = 1 
      else if (.not.notb .and. .not.lsame(transb,'C') .and. .not.lsame(transb,&
          'T')) then 
        info = 2 
      else if (m < 0) then 
        info = 3 
      else if (n < 0) then 
        info = 4 
      else if (k < 0) then 
        info = 5 
      else if (lda < max(1,nrowa)) then 
        info = 8 
      else if (ldb < max(1,nrowb)) then 
        info = 10 
      else if (ldc < max(1,m)) then 
        info = 13 
      endif 
      if (info /= 0) then 
        call xerbla ('DGEMM ', info) 
        return  
      endif 
!
!     QUICK RETURN IF POSSIBLE.
!
      if (m==0 .or. n==0 .or. (Abs(alpha) < 1.d-20 .or. k==0) .and. Abs(beta - 1.d0) < 1.d-20) return  
!
!     AND IF  ALPHA.EQ.ZERO.
!
      if (Abs(alpha) < 1.d-20) then 
        if (Abs(beta - 1.d0) < 1.d-20) then 
          c(:m,:n) = zero 
        else 
          c(:m,:n) = beta*c(:m,:n) 
        endif 
        return  
      endif 
!
!     START THE OPERATIONS.
!
      if (notb) then 
        if (nota) then 
!
!           FORM  C := ALPHA*A*B + BETA*C.
!
          do j = 1, n 
            if (beta == zero) then 
              c(:m,j) = zero 
            else if (Abs(beta - 1.d0) > 1.d-20) then 
              c(:m,j) = beta*c(:m,j) 
            endif 
            do l = 1, k 
              if (b(l,j) == zero) cycle  
              temp = alpha*b(l,j) 
              c(:m,j) = c(:m,j) + temp*a(:m,l) 
            end do 
          end do 
        else 
!
!           FORM  C := ALPHA*A'*B + BETA*C
!
          do j = 1, n 
            do i = 1, m 
              temp = zero 
              temp = temp + sum(a(:k,i)*b(:k,j)) 
              if (beta == zero) then 
                c(i,j) = alpha*temp 
              else 
                c(i,j) = alpha*temp + beta*c(i,j) 
              endif 
            end do 
          end do 
        endif 
      else 
        if (nota) then 
!
!           FORM  C := ALPHA*A*B' + BETA*C
!
          do j = 1, n 
            if (beta == zero) then 
              c(:m,j) = zero 
            else if (Abs(beta-1.d0) > 1.d-20) then 
              c(:m,j) = beta*c(:m,j) 
            endif 
            do l = 1, k 
              if (b(j,l) == zero) cycle  
              temp = alpha*b(j,l) 
              c(:m,j) = c(:m,j) + temp*a(:m,l) 
            end do 
          end do 
        else 
!
!           FORM  C := ALPHA*A'*B' + BETA*C
!
          do j = 1, n 
            do i = 1, m 
              temp = zero 
              temp = temp + sum(a(:k,i)*b(j,:k)) 
              if (beta == zero) then 
                c(i,j) = alpha*temp 
              else 
                c(i,j) = alpha*temp + beta*c(i,j) 
              endif 
            end do 
          end do 
        endif 
      endif 
!
      return  
!
!     END OF DGEMM .
!
      end subroutine dgemm 

   subroutine dscal(n, da, dx, incx) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  22:48:56  03/08/06  
!...Switches: -rl INDDO=2 INDIF=2 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n 
      integer , intent(in) :: incx 
      real(double) , intent(in) :: da 
      real(double) , intent(inout) :: dx(*) 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: m, mp1, nincx 
!-----------------------------------------------
!
!     SCALES A VECTOR BY A CONSTANT.
!     USES UNROLLED LOOPS FOR INCREMENT EQUAL TO ONE.
!     JACK DONGARRA, LINPACK, 3/11/78.
!
!
      if (n <= 0) return  
      if (incx /= 1) then 
!
!        CODE FOR INCREMENT NOT EQUAL TO 1
!
        nincx = n*incx 
        dx(:nincx:incx) = da*dx(:nincx:incx) 
        return  
      endif 
!
!        CODE FOR INCREMENT EQUAL TO 1
!
!
!        CLEAN-UP LOOP
!
      m = mod(n,5) 
      if (m /= 0) then 
        dx(:m) = da*dx(:m) 
        if (n < 5) return  
      endif 
      mp1 = m + 1 
      dx(mp1:((n-mp1+5)/5)*5-1+mp1) = da*dx(mp1:((n-mp1+5)/5)*5-1+mp1) 
      return  
      end subroutine dscal 

           subroutine daxpy(n, da, dx, incx, dy, incy) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  22:48:56  03/08/06  
!...Switches: -rl INDDO=2 INDIF=2 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n 
      integer , intent(in) :: incx 
      integer , intent(in) :: incy 
      real(double) , intent(in) :: da 
      real(double) , intent(in) :: dx(*) 
      real(double) , intent(inout) :: dy(*) 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: ix, iy, m, mp1 
!-----------------------------------------------
!
!     CONSTANT TIMES A VECTOR PLUS A VECTOR.
!           DY(I) = DY(I) + DA * DX(I)
!     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.
!     JACK DONGARRA, LINPACK, 3/11/78.
!
      if (n <= 0) return  
      if (da == 0.0D+00) return  
      if (incx/=1 .or. incy/=1) then 
!
!        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
!          NOT EQUAL TO 1
!
        ix = 1 
        iy = 1 
        if (incx < 0) ix = ((-n) + 1)*incx + 1 
        if (incy < 0) iy = ((-n) + 1)*incy + 1 
        dy(iy:(n-1)*incy+iy:incy) = dy(iy:(n-1)*incy+iy:incy) + da*dx(ix:(n-1)*incx+ix:incx) 
        return  
      endif 
!
!        CODE FOR BOTH INCREMENTS EQUAL TO 1
!
!
!        CLEAN-UP LOOP
!
      m = mod(n,4) 
      if (m /= 0) then 
        dy(:m) = dy(:m) + da*dx(:m) 
        if (n < 4) return  
      endif 
      mp1 = m + 1 
      dy(mp1:((n-mp1+4)/4)*4-1+mp1) = dy(mp1:((n-mp1+4)/4)*4-1+mp1) + da*dx(mp1:((n-mp1+4)/4)*4-1+mp1) 
      return  
      end subroutine daxpy 

                subroutine dgesv(n, nrhs, a, lda, ipiv, b, ldb, info) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  11:54:31  01/16/06  
!...Switches: -rl INDDO=2 INDIF=2 
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: n 
      integer  :: nrhs 
      integer  :: lda 
      integer  :: ldb 
      integer  :: info 
      integer  :: ipiv(*) 
      real(double)  :: a(lda,*) 
      real(double)  :: b(ldb,*) 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
!-----------------------------------------------
!   I n t r i n s i c  F u n c t i o n s
!-----------------------------------------------
      INTRINSIC max 
!-----------------------------------------------
!
!  -- LAPACK driver routine (version 3.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     March 31, 1993
!
!     .. Scalar Arguments ..
!     ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DGESV computes the solution to a real system of linear equations
!     A * X = B,
!  where A is an N-by-N matrix and X and B are N-by-NRHS matrices.
!
!  The LU decomposition with partial pivoting and row interchanges is
!  used to factor A as
!     A = P * L * U,
!  where P is a permutation matrix, L is unit lower triangular, and U is
!  upper triangular.  The factored form of A is then used to solve the
!  system of equations A * X = B.
!
!  Arguments
!  =========
!
!  N       (input) INTEGER
!          The number of linear equations, i.e., the order of the
!          matrix A.  N >= 0.
!
!  NRHS    (input) INTEGER
!          The number of right hand sides, i.e., the number of columns
!          of the matrix B.  NRHS >= 0.
!
!  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
!          On entry, the N-by-N coefficient matrix A.
!          On exit, the factors L and U from the factorization
!          A = P*L*U; the unit diagonal elements of L are not stored.
!
!  LDA     (input) INTEGER
!          The leading dimension of the array A.  LDA >= max(1,N).
!
!  IPIV    (output) INTEGER array, dimension (N)
!          The pivot indices that define the permutation matrix P;
!          row i of the matrix was interchanged with row IPIV(i).
!
!  B       (input/output) DOUBLE PRECISION array, dimension (LDB,NRHS)
!          On entry, the N-by-NRHS matrix of right hand side matrix B.
!          On exit, if INFO = 0, the N-by-NRHS solution matrix X.
!
!  LDB     (input) INTEGER
!          The leading dimension of the array B.  LDB >= max(1,N).
!
!  INFO    (output) INTEGER
!          = 0:  successful exit
!          < 0:  if INFO = -i, the i-th argument had an illegal value
!          > 0:  if INFO = i, U(i,i) is exactly zero.  The factorization
!                has been completed, but the factor U is exactly
!                singular, so the solution could not be computed.
!
!  =====================================================================
!
!     .. External Subroutines ..
!     ..
!     .. Intrinsic Functions ..
!     ..
!     .. Executable Statements ..
!
!     Test the input parameters.
!
      info = 0 
      if (n < 0) then 
        info = -1 
      else if (nrhs < 0) then 
        info = -2 
      else if (lda < max(1,n)) then 
        info = -4 
      else if (ldb < max(1,n)) then 
        info = -7 
      endif 
      if (info /= 0) then 
        call xerbla ('DGESV ', (-info)) 
        return  
      endif 
!
!     Compute the LU factorization of A.
!
      call dgetrf (n, n, a, lda, ipiv, info) 
!
!        Solve the system A*X = B, overwriting B with X.
!
      if (info == 0) call dgetrs ('No transpose', n, nrhs, a, lda, ipiv, b, ldb&
        , info) 
      return  
!
!     End of DGESV
!
      end subroutine dgesv


      subroutine dswap(n, dx, incx, dy, incy) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  22:48:56  03/08/06  
!...Switches: -rl INDDO=2 INDIF=2 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n 
      integer , intent(in) :: incx 
      integer , intent(in) :: incy 
      real(double) , intent(inout) :: dx(*) 
      real(double) , intent(inout) :: dy(*) 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, ix, iy, m, mp1 
      real(double) :: dtemp 
!-----------------------------------------------
!
!     INTERCHANGES TWO VECTORS.
!     USES UNROLLED LOOPS FOR INCREMENTS EQUAL ONE.
!     JACK DONGARRA, LINPACK, 3/11/78.
!
!
      if (n <= 0) return  
      if (incx/=1 .or. incy/=1) then 
!
!       CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS NOT EQUAL
!         TO 1
!
        ix = 1 
        iy = 1 
        if (incx < 0) ix = ((-n) + 1)*incx + 1 
        if (incy < 0) iy = ((-n) + 1)*incy + 1 
        do i = 1, n 
          dtemp = dx(ix) 
          dx(ix) = dy(iy) 
          dy(iy) = dtemp 
          ix = ix + incx 
          iy = iy + incy 
        end do 
        return  
      endif 
!
!       CODE FOR BOTH INCREMENTS EQUAL TO 1
!
!
!       CLEAN-UP LOOP
!
      m = mod(n,3) 
      if (m /= 0) then 
        do i = 1, m 
          dtemp = dx(i) 
          dx(i) = dy(i) 
          dy(i) = dtemp 
        end do 
        if (n < 3) return  
      endif 
      mp1 = m + 1 
      do i = mp1, n, 3 
        dtemp = dx(i) 
        dx(i) = dy(i) 
        dy(i) = dtemp 
        dtemp = dx(i+1) 
        dx(i+1) = dy(i+1) 
        dy(i+1) = dtemp 
        dtemp = dx(i+2) 
        dx(i+2) = dy(i+2) 
        dy(i+2) = dtemp 
      end do 
      return  
      end subroutine dswap 


          subroutine dgetrf(m, n, a, lda, ipiv, info) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  11:54:31  01/16/06  
!...Switches: -rl INDDO=2 INDIF=2 
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: m 
      integer  :: n 
      integer  :: lda 
      integer  :: info 
      integer  :: ipiv(*) 
      real(double)  :: a(lda,*) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      real(double), parameter :: one = 1.0D+0 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: j, jb, nb 
      integer, external :: ilaenv
!-----------------------------------------------
!   I n t r i n s i c  F u n c t i o n s
!-----------------------------------------------
      INTRINSIC max, min 
!-----------------------------------------------
!
!  -- LAPACK routine (version 3.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     March 31, 1993
!
!     .. Scalar Arguments ..
!     ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DGETRF computes an LU factorization of a general M-by-N matrix A
!  using partial pivoting with row interchanges.
!
!  The factorization has the form
!     A = P * L * U
!  where P is a permutation matrix, L is lower triangular with unit
!  diagonal elements (lower trapezoidal if m > n), and U is upper
!  triangular (upper trapezoidal if m < n).
!
!  This is the right-looking Level 3 BLAS version of the algorithm.
!
!  Arguments
!  =========
!
!  M       (input) INTEGER
!          The number of rows of the matrix A.  M >= 0.
!
!  N       (input) INTEGER
!          The number of columns of the matrix A.  N >= 0.
!
!  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
!          On entry, the M-by-N matrix to be factored.
!          On exit, the factors L and U from the factorization
!          A = P*L*U; the unit diagonal elements of L are not stored.
!
!  LDA     (input) INTEGER
!          The leading dimension of the array A.  LDA >= max(1,M).
!
!  IPIV    (output) INTEGER array, dimension (min(M,N))
!          The pivot indices; for 1 <= i <= min(M,N), row i of the
!          matrix was interchanged with row IPIV(i).
!
!  INFO    (output) INTEGER
!          = 0:  successful exit
!          < 0:  if INFO = -i, the i-th argument had an illegal value
!          > 0:  if INFO = i, U(i,i) is exactly zero. The factorization
!                has been completed, but the factor U is exactly
!                singular, and division by zero will occur if it is used
!                to solve a system of equations.
!
!  =====================================================================
!
!     .. Parameters ..
!     ..
!     .. Local Scalars ..
!     ..
!     .. External Subroutines ..
!     ..
!     .. External Functions ..
!     ..
!     .. Intrinsic Functions ..
!     ..
!     .. Executable Statements ..
!
!     Test the input parameters.
!
      info = 0 
      if (m < 0) then 
        info = -1 
      else if (n < 0) then 
        info = -2 
      else if (lda < max(1,m)) then 
        info = -4 
      endif 
      if (info /= 0) then 
        call xerbla ('DGETRF', (-info)) 
        return  
      endif 
!
!     Quick return if possible
!
      if (m==0 .or. n==0) return  
!
!     Determine the block size for this environment.
!
      nb = ilaenv(1,'DGETRF'," ",m,n,-1, -1) 
      if (nb<=1 .or. nb>=min(m,n)) then 
!
!        Use unblocked code.
!
        call dgetf2 (m, n, a, lda, ipiv) 
      else 
!
!        Use blocked code.
!
        do j = 1, min(m,n), nb 
          jb = min(min(m,n) - j + 1,nb) 
!
!           Factor diagonal and subdiagonal blocks and test for exact
!           singularity.
!
          call dgetf2 (m - j + 1, jb, a(j,j), lda, ipiv(j)) 
!
!           Adjust INFO and the pivot indices.
!
      !    if (info==0 .and. iinfo>0) info = iinfo + j - 1 
          ipiv(j:min(m,j+jb-1)) = j - 1 + ipiv(j:min(m,j+jb-1)) 
!
!           Apply interchanges to columns 1:J-1.
!
          call dlaswp (j - 1, a, lda, j, j + jb - 1, ipiv, 1) 
!
          if (j + jb > n) cycle  
!
!              Apply interchanges to columns J+JB:N.
!
          call dlaswp (n - j - jb + 1, a(1,j+jb), lda, j, j + jb - 1, ipiv, 1) 
!
!              Compute block row of U.
!
          call dtrsm ('Left', 'Lower', 'No transpose', 'Unit', jb, n - j - jb&
             + 1, one, a(j,j), lda, a(j,j+jb), lda) 
          if (j + jb > m) cycle  
!
!                 Update trailing submatrix.
!
          call dgemm ('No transpose', 'No transpose', m - j - jb + 1, n - j - &
            jb + 1, jb, (-one), a(j+jb,j), lda, a(j,j+jb), lda, one, a(j+jb,j+&
            jb), lda) 
        end do 
      endif 
      return  
!
!     End of DGETRF
!
      end subroutine dgetrf 


      subroutine dgetrs(trans, n, nrhs, a, lda, ipiv, b, ldb, info) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  11:54:31  01/16/06  
!...Switches: -rl INDDO=2 INDIF=2 
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: n 
      integer  :: nrhs 
      integer  :: lda 
      integer  :: ldb 
      integer , intent(out) :: info 
      character  :: trans 
      integer  :: ipiv(*) 
      real(double)  :: a(lda,*) 
      real(double)  :: b(ldb,*) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      real(double), parameter :: one = 1.0D+0 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      logical :: notran 
!-----------------------------------------------
!   I n t r i n s i c  F u n c t i o n s
!-----------------------------------------------
      INTRINSIC max 
!-----------------------------------------------
!
!  -- LAPACK routine (version 3.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     March 31, 1993
!
!     .. Scalar Arguments ..
!     ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DGETRS solves a system of linear equations
!     A * X = B  or  A' * X = B
!  with a general N-by-N matrix A using the LU factorization computed
!  by DGETRF.
!
!  Arguments
!  =========
!
!  TRANS   (input) CHARACTER*1
!          Specifies the form of the system of equations:
!          = 'N':  A * X = B  (No transpose)
!          = 'T':  A'* X = B  (Transpose)
!          = 'C':  A'* X = B  (Conjugate transpose = Transpose)
!
!  N       (input) INTEGER
!          The order of the matrix A.  N >= 0.
!
!  NRHS    (input) INTEGER
!          The number of right hand sides, i.e., the number of columns
!          of the matrix B.  NRHS >= 0.
!
!  A       (input) DOUBLE PRECISION array, dimension (LDA,N)
!          The factors L and U from the factorization A = P*L*U
!          as computed by DGETRF.
!
!  LDA     (input) INTEGER
!          The leading dimension of the array A.  LDA >= max(1,N).
!
!  IPIV    (input) INTEGER array, dimension (N)
!          The pivot indices from DGETRF; for 1<=i<=N, row i of the
!          matrix was interchanged with row IPIV(i).
!
!  B       (input/output) DOUBLE PRECISION array, dimension (LDB,NRHS)
!          On entry, the right hand side matrix B.
!          On exit, the solution matrix X.
!
!  LDB     (input) INTEGER
!          The leading dimension of the array B.  LDB >= max(1,N).
!
!  INFO    (output) INTEGER
!          = 0:  successful exit
!          < 0:  if INFO = -i, the i-th argument had an illegal value
!
!  =====================================================================
!
!     .. Parameters ..
!     ..
!     .. Local Scalars ..
!     ..
!     .. External Functions ..
!     ..
!     .. External Subroutines ..
!     ..
!     .. Intrinsic Functions ..
!     ..
!     .. Executable Statements ..
!
!     Test the input parameters.
!
      info = 0 
      notran = lsame(trans,'N') 
      if (.not.notran .and. .not.lsame(trans,'T') .and. .not.lsame(trans,'C')) &
        then 
        info = -1 
      else if (n < 0) then 
        info = -2 
      else if (nrhs < 0) then 
        info = -3 
      else if (lda < max(1,n)) then 
        info = -5 
      else if (ldb < max(1,n)) then 
        info = -8 
      endif 
      if (info /= 0) then 
        call xerbla ('DGETRS', (-info)) 
        return  
      endif 
!
!     Quick return if possible
!
      if (n==0 .or. nrhs==0) return  
!
      if (notran) then 
!
!        Solve A * X = B.
!
!        Apply row interchanges to the right hand sides.
!
        call dlaswp (nrhs, b, ldb, 1, n, ipiv, 1) 
!
!        Solve L*X = B, overwriting B with X.
!
        call dtrsm ('Left', 'Lower', 'No transpose', 'Unit', n, nrhs, one, a, &
          lda, b, ldb) 
!
!        Solve U*X = B, overwriting B with X.
!
        call dtrsm ('Left', 'Upper', 'No transpose', 'Non-unit', n, nrhs, one, &
          a, lda, b, ldb) 
      else 
!
!        Solve A' * X = B.
!
!        Solve U'*X = B, overwriting B with X.
!
        call dtrsm ('Left', 'Upper', 'Transpose', 'Non-unit', n, nrhs, one, a, &
          lda, b, ldb) 
!
!        Solve L'*X = B, overwriting B with X.
!
        call dtrsm ('Left', 'Lower', 'Transpose', 'Unit', n, nrhs, one, a, lda&
          , b, ldb) 
!
!        Apply row interchanges to the solution vectors.
!
        call dlaswp (nrhs, b, ldb, 1, n, ipiv, -1) 
      endif 
!
      return  
!
!     End of DGETRS
!
      end subroutine dgetrs 

         real(kind(0.0d0)) function dasum (n, dx, incx) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  22:48:56  03/08/06  
!...Switches: -rl INDDO=2 INDIF=2 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n 
      integer , intent(in) :: incx 
      real(double) , intent(in) :: dx(incx*n) 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, m, mp1, nincx 
      real(double) :: dtemp 
!-----------------------------------------------
!
!     TAKES THE SUM OF THE ABSOLUTE VALUES.
!     JACK DONGARRA, LINPACK, 3/11/78.
!
!
      dasum = 0.0D+00 
      dtemp = 0.0D+00 
      if (n <= 0) return  
      if (incx /= 1) then 
!
!        CODE FOR INCREMENT NOT EQUAL TO 1
!
        nincx = n*incx 
        do i = 1, nincx, incx 
          dtemp = dtemp + abs(dx(i)) 
        end do 
        dasum = dtemp 
        return  
      endif 
!
!        CODE FOR INCREMENT EQUAL TO 1
!
!
!        CLEAN-UP LOOP
!
      m = mod(n,6) 
      if (m == 0) go to 40 
      do i = 1, m 
        dtemp = dtemp + abs(dx(i)) 
      end do 
      if (n < 6) go to 60 
   40 continue 
      mp1 = m + 1 
      do i = mp1, n, 6 
        dtemp = dtemp + abs(dx(i)) + abs(dx(i+1)) + abs(dx(i+2)) + abs(dx(i+3)) &
           + abs(dx(i+4)) + abs(dx(i+5)) 
      end do 
   60 continue 
      dasum = dtemp 
      return  
      end function dasum 

    real(kind(0.0d0)) function dnrm2 (n, dx) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n 
      real(double) , intent(in) :: dx(n) 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      double precision :: norm
      norm = dot(dx,dx,n)
      if (norm > 0.d0) then
        norm = sqrt(norm)
      else
        norm=1.d-30
      end if
      dnrm2 = norm
      return  
      end function dnrm2 

   subroutine dpotri(uplo, n, a, lda, info) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  20:49:17  01/01/08  
!...Switches: -rl INDDO=2 INDIF=2 
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: n 
      integer  :: lda 
      integer  :: info 
      character  :: uplo 
      real(double)  :: a(lda,*) 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
!-----------------------------------------------
!   I n t r i n s i c  F u n c t i o n s
!-----------------------------------------------
      INTRINSIC max 
      logical, external :: lsame
!-----------------------------------------------
!
!  -- LAPACK routine (version 3.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     March 31, 1993
!
!     .. Scalar Arguments ..
!     ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DPOTRI computes the inverse of a real symmetric positive definite
!  matrix A using the Cholesky factorization A = U**T*U or A = L*L**T
!  computed by DPOTRF.
!
!  Arguments
!  =========
!
!  UPLO    (input) CHARACTER*1
!          = 'U':  Upper triangle of A is stored;
!          = 'L':  Lower triangle of A is stored.
!
!  N       (input) INTEGER
!          The order of the matrix A.  N >= 0.
!
!  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
!          On entry, the triangular factor U or L from the Cholesky
!          factorization A = U**T*U or A = L*L**T, as computed by
!          DPOTRF.
!          On exit, the upper or lower triangle of the (symmetric)
!          inverse of A, overwriting the input factor U or L.
!
!  LDA     (input) INTEGER
!          The leading dimension of the array A.  LDA >= max(1,N).
!
!  INFO    (output) INTEGER
!          = 0:  successful exit
!          < 0:  if INFO = -i, the i-th argument had an illegal value
!          > 0:  if INFO = i, the (i,i) element of the factor U or L is
!                zero, and the inverse could not be computed.
!
!  =====================================================================
!
!     .. External Functions ..
!     ..
!     .. External Subroutines ..
!     ..
!     .. Intrinsic Functions ..
!     ..
!     .. Executable Statements ..
!
!     Test the input parameters.
!
      info = 0 
      if (.not.lsame(uplo,'U') .and. .not.lsame(uplo,'L')) then 
        info = -1 
      else if (n < 0) then 
        info = -2 
      else if (lda < max(1,n)) then 
        info = -4 
      endif 
      if (info /= 0) then 
        call xerbla ('DPOTRI', (-info)) 
        return  
      endif 
!
!     Quick return if possible
!
      if (n == 0) return  
!
!     Invert the triangular Cholesky factor U or L.
!
      call dtrtri (uplo, 'Non-unit', n, a, lda, info) 
      if (info > 0) return  
!
!     Form inv(U)*inv(U)' or inv(L)'*inv(L).
!
      call dlauum (uplo, n, a, lda, info) 
!
      return  
!
!     End of DPOTRI
!
      end subroutine dpotri 

   integer function ilaenv (ispec, name, opts, n1, n2, n3, n4) 
!...Translated by Pacific-Sierra Research 77to90  4.4G  20:49:17  01/01/08  
!...Switches: -rl INDDO=2 INDIF=2 
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: ispec 
      integer , intent(in) :: n1 
      integer , intent(in) :: n2 
      integer  :: n3 
      integer , intent(in) :: n4 
      character , intent(in) :: name*(*) 
      character  :: opts*(*) 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, ic, iz, nb, nbmin, nx 
      logical :: cname, sname 
      character :: c1, c2*2, c4*2, c3*3, subnam*6 
!-----------------------------------------------
!   I n t r i n s i c  F u n c t i o n s
!-----------------------------------------------
      INTRINSIC char, ichar, int, min, real 
!-----------------------------------------------
!
!  -- LAPACK auxiliary routine (version 3.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     June 30, 1999
!
!     .. Scalar Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  ILAENV is called from the LAPACK routines to choose problem-dependent
!  parameters for the local environment.  See ISPEC for a description of
!  the parameters.
!
!  This version provides a set of parameters which should give good,
!  but not optimal, performance on many of the currently available
!  computers.  Users are encouraged to modify this subroutine to set
!  the tuning parameters for their particular machine using the option
!  and problem size information in the arguments.
!
!  This routine will not function correctly if it is converted to all
!  lower case.  Converting it to all upper case is allowed.
!
!  Arguments
!  =========
!
!  ISPEC   (input) INTEGER
!          Specifies the parameter to be returned as the value of
!          ILAENV.
!          = 1: the optimal blocksize; if this value is 1, an unblocked
!               algorithm will give the best performance.
!          = 2: the minimum block size for which the block routine
!               should be used; if the usable block size is less than
!               this value, an unblocked routine should be used.
!          = 3: the crossover point (in a block routine, for N less
!               than this value, an unblocked routine should be used)
!          = 4: the number of shifts, used in the nonsymmetric
!               eigenvalue routines
!          = 5: the minimum column dimension for blocking to be used;
!               rectangular blocks must have dimension at least k by m,
!               where k is given by ILAENV(2,...) and m by ILAENV(5,...)
!          = 6: the crossover point for the SVD (when reducing an m by n
!               matrix to bidiagonal form, if max(m,n)/min(m,n) exceeds
!               this value, a QR factorization is used first to reduce
!               the matrix to a triangular form.)
!          = 7: the number of processors
!          = 8: the crossover point for the multishift QR and QZ methods
!               for nonsymmetric eigenvalue problems.
!          = 9: maximum size of the subproblems at the bottom of the
!               computation tree in the divide-and-conquer algorithm
!               (used by xGELSD and xGESDD)
!          =10: ieee NaN arithmetic can be trusted not to trap
!          =11: infinity arithmetic can be trusted not to trap
!
!  NAME    (input) CHARACTER*(*)
!          The name of the calling subroutine, in either upper case or
!          lower case.
!
!  OPTS    (input) CHARACTER*(*)
!          The character options to the subroutine NAME, concatenated
!          into a single character string.  For example, UPLO = 'U',
!          TRANS = 'T', and DIAG = 'N' for a triangular routine would
!          be specified as OPTS = 'UTN'.
!
!  N1      (input) INTEGER
!  N2      (input) INTEGER
!  N3      (input) INTEGER
!  N4      (input) INTEGER
!          Problem dimensions for the subroutine NAME; these may not all
!          be required.
!
! (ILAENV) (output) INTEGER
!          >= 0: the value of the parameter specified by ISPEC
!          < 0:  if ILAENV = -k, the k-th argument had an illegal value.
!
!  Further Details
!  ===============
!
!  The following conventions have been used when calling ILAENV from the
!  LAPACK routines:
!  1)  OPTS is a concatenation of all of the character options to
!      subroutine NAME, in the same order that they appear in the
!      argument list for NAME, even if they are not used in determining
!      the value of the parameter specified by ISPEC.
!  2)  The problem dimensions N1, N2, N3, N4 are specified in the order
!      that they appear in the argument list for NAME.  N1 is used
!      first, N2 second, and so on, and unused problem dimensions are
!      passed a value of -1.
!  3)  The parameter value returned by ILAENV is checked for validity in
!      the calling subroutine.  For example, ILAENV is used to retrieve
!      the optimal blocksize for STRTRI as follows:
!
!      NB = ILAENV( 1, 'STRTRI', UPLO // DIAG, N, -1, -1, -1 )
!      IF( NB.LE.1 ) NB = MAX( 1, N )
!
!  =====================================================================
!
!     .. Local Scalars ..
!     ..
!     .. Intrinsic Functions ..
!     ..
!     .. External Functions ..
!     ..
!     .. Executable Statements ..
!
      select case (ispec)  
!
!     Invalid value for ISPEC
!
      case default 
        ilaenv = -1 
        return  
!
      case (1:3)  
        ilaenv = 1 
        subnam = name 
        ic = ichar(subnam(1:1)) 
        iz = ichar('Z') 
        if (iz==90 .or. iz==122) then 
!
!        ASCII character set
!
          if (ic>=97 .and. ic<=122) then 
            subnam(1:1) = char(ic - 32) 
            do i = 2, 6 
              ic = ichar(subnam(i:i)) 
              if (ic<97 .or. ic>122) cycle  
              subnam(i:i) = char(ic - 32) 
            end do 
          endif 
!
        else if (iz==233 .or. iz==169) then 
!
!        EBCDIC character set
!
          if (ic>=129 .and. ic<=137 .or. ic>=145 .and. ic<=153 .or. ic>=162&
             .and. ic<=169) then 
            subnam(1:1) = char(ic + 64) 
            do i = 2, 6 
              ic = ichar(subnam(i:i)) 
              if (.not.(ic>=129 .and. ic<=137 .or. ic>=145 .and. ic<=153 .or. &
                ic>=162 .and. ic<=169)) cycle  
              subnam(i:i) = char(ic + 64) 
            end do 
          endif 
!
        else if (iz==218 .or. iz==250) then 
!
!        Prime machines:  ASCII+128
!
          if (ic>=225 .and. ic<=250) then 
            subnam(1:1) = char(ic - 32) 
            do i = 2, 6 
              ic = ichar(subnam(i:i)) 
              if (ic<225 .or. ic>250) cycle  
              subnam(i:i) = char(ic - 32) 
            end do 
          endif 
        endif 
!
        c1 = subnam(1:1) 
        sname = c1=='S' .or. c1=='D' 
        cname = c1=='C' .or. c1=='Z' 
        if (.not.(cname .or. sname)) return  
        c2 = subnam(2:3) 
        c3 = subnam(4:6) 
        c4 = c3(2:3) 
!
        select case (ispec)  
!
        case default 
          nb = 1 
!
          if (c2 == 'GE') then 
            if (c3 == 'TRF') then 
              if (sname) then 
                nb = 64 
              else 
                nb = 64 
              endif 
            else if (c3=='QRF' .or. c3=='RQF' .or. c3=='LQF' .or. c3=='QLF') &
                then 
              if (sname) then 
                nb = 32 
              else 
                nb = 32 
              endif 
            else if (c3 == 'HRD') then 
              if (sname) then 
                nb = 32 
              else 
                nb = 32 
              endif 
            else if (c3 == 'BRD') then 
              if (sname) then 
                nb = 32 
              else 
                nb = 32 
              endif 
            else if (c3 == 'TRI') then 
              if (sname) then 
                nb = 64 
              else 
                nb = 64 
              endif 
            endif 
          else if (c2 == 'PO') then 
            if (c3 == 'TRF') then 
              if (sname) then 
                nb = 64 
              else 
                nb = 64 
              endif 
            endif 
          else if (c2 == 'SY') then 
            if (c3 == 'TRF') then 
              if (sname) then 
                nb = 64 
              else 
                nb = 64 
              endif 
            else if (sname .and. c3=='TRD') then 
              nb = 32 
            else if (sname .and. c3=='GST') then 
              nb = 64 
            endif 
          else if (cname .and. c2=='HE') then 
            select case (c3)  
            case ('TRF')  
              nb = 64 
            case ('TRD')  
              nb = 32 
            case ('GST')  
              nb = 64 
            end select 
          else if (sname .and. c2=='OR') then 
            if (c3(1:1) == 'G') then 
              if (c4=='QR' .or. c4=='RQ' .or. c4=='LQ' .or. c4=='QL' .or. c4==&
                'HR' .or. c4=='TR' .or. c4=='BR') nb = 32 
            else if (c3(1:1) == 'M') then 
              if (c4=='QR' .or. c4=='RQ' .or. c4=='LQ' .or. c4=='QL' .or. c4==&
                'HR' .or. c4=='TR' .or. c4=='BR') nb = 32 
            endif 
          else if (cname .and. c2=='UN') then 
            if (c3(1:1) == 'G') then 
              if (c4=='QR' .or. c4=='RQ' .or. c4=='LQ' .or. c4=='QL' .or. c4==&
                'HR' .or. c4=='TR' .or. c4=='BR') nb = 32 
            else if (c3(1:1) == 'M') then 
              if (c4=='QR' .or. c4=='RQ' .or. c4=='LQ' .or. c4=='QL' .or. c4==&
                'HR' .or. c4=='TR' .or. c4=='BR') nb = 32 
            endif 
          else if (c2 == 'GB') then 
            if (c3 == 'TRF') then 
              if (sname) then 
                if (n4 <= 64) then 
                  nb = 1 
                else 
                  nb = 32 
                endif 
              else 
                if (n4 <= 64) then 
                  nb = 1 
                else 
                  nb = 32 
                endif 
              endif 
            endif 
          else if (c2 == 'PB') then 
            if (c3 == 'TRF') then 
              if (sname) then 
                if (n2 <= 64) then 
                  nb = 1 
                else 
                  nb = 32 
                endif 
              else 
                if (n2 <= 64) then 
                  nb = 1 
                else 
                  nb = 32 
                endif 
              endif 
            endif 
          else if (c2 == 'TR') then 
            if (c3 == 'TRI') then 
              if (sname) then 
                nb = 64 
              else 
                nb = 64 
              endif 
            endif 
          else if (c2 == 'LA') then 
            if (c3 == 'UUM') then 
              if (sname) then 
                nb = 64 
              else 
                nb = 64 
              endif 
            endif 
          else if (sname .and. c2=='ST') then 
            if (c3 == 'EBZ') nb = 1 
          endif 
          ilaenv = nb 
          return  
!
        case (2)  
          nbmin = 2 
          if (c2 == 'GE') then 
            if (c3=='QRF' .or. c3=='RQF' .or. c3=='LQF' .or. c3=='QLF') then 
              if (sname) then 
                nbmin = 2 
              else 
                nbmin = 2 
              endif 
            else if (c3 == 'HRD') then 
              if (sname) then 
                nbmin = 2 
              else 
                nbmin = 2 
              endif 
            else if (c3 == 'BRD') then 
              if (sname) then 
                nbmin = 2 
              else 
                nbmin = 2 
              endif 
            else if (c3 == 'TRI') then 
              if (sname) then 
                nbmin = 2 
              else 
                nbmin = 2 
              endif 
            endif 
          else if (c2 == 'SY') then 
            if (c3 == 'TRF') then 
              if (sname) then 
                nbmin = 8 
              else 
                nbmin = 8 
              endif 
            else if (sname .and. c3=='TRD') then 
              nbmin = 2 
            endif 
          else if (cname .and. c2=='HE') then 
            if (c3 == 'TRD') nbmin = 2 
          else if (sname .and. c2=='OR') then 
            if (c3(1:1) == 'G') then 
              if (c4=='QR' .or. c4=='RQ' .or. c4=='LQ' .or. c4=='QL' .or. c4==&
                'HR' .or. c4=='TR' .or. c4=='BR') nbmin = 2 
            else if (c3(1:1) == 'M') then 
              if (c4=='QR' .or. c4=='RQ' .or. c4=='LQ' .or. c4=='QL' .or. c4==&
                'HR' .or. c4=='TR' .or. c4=='BR') nbmin = 2 
            endif 
          else if (cname .and. c2=='UN') then 
            if (c3(1:1) == 'G') then 
              if (c4=='QR' .or. c4=='RQ' .or. c4=='LQ' .or. c4=='QL' .or. c4==&
                'HR' .or. c4=='TR' .or. c4=='BR') nbmin = 2 
            else if (c3(1:1) == 'M') then 
              if (c4=='QR' .or. c4=='RQ' .or. c4=='LQ' .or. c4=='QL' .or. c4==&
                'HR' .or. c4=='TR' .or. c4=='BR') nbmin = 2 
            endif 
          endif 
          ilaenv = nbmin 
          return  
!
        case (3)  
          nx = 0 
          if (c2 == 'GE') then 
            if (c3=='QRF' .or. c3=='RQF' .or. c3=='LQF' .or. c3=='QLF') then 
              if (sname) then 
                nx = 128 
              else 
                nx = 128 
              endif 
            else if (c3 == 'HRD') then 
              if (sname) then 
                nx = 128 
              else 
                nx = 128 
              endif 
            else if (c3 == 'BRD') then 
              if (sname) then 
                nx = 128 
              else 
                nx = 128 
              endif 
            endif 
          else if (c2 == 'SY') then 
            if (sname .and. c3=='TRD') nx = 32 
          else if (cname .and. c2=='HE') then 
            if (c3 == 'TRD') nx = 32 
          else if (sname .and. c2=='OR') then 
            if (c3(1:1) == 'G') then 
              if (c4=='QR' .or. c4=='RQ' .or. c4=='LQ' .or. c4=='QL' .or. c4==&
                'HR' .or. c4=='TR' .or. c4=='BR') nx = 128 
            endif 
          else if (cname .and. c2=='UN') then 
            if (c3(1:1) == 'G') then 
              if (c4=='QR' .or. c4=='RQ' .or. c4=='LQ' .or. c4=='QL' .or. c4==&
                'HR' .or. c4=='TR' .or. c4=='BR') nx = 128 
            endif 
          endif 
          ilaenv = nx 
          return  
!
        case (4)  
          ilaenv = 6 
          return  
!
        case (5)  
          ilaenv = 2 
          return  
!
        case (6)  
          ilaenv = int(real(min(n1,n2))*1.6E0) 
          return  
!
        case (7)  
          ilaenv = 1 
          return  
!
        case (8)  
          ilaenv = 50 
          return  
!
        case (9)  
          ilaenv = 25 
          return  
!
        case (10)  
          ilaenv = 1 
          if (ilaenv == 1) ilaenv = ieeeck(0,0.0,1.0) 
          return  
!
        case (11)  
          ilaenv = 1 
          if (ilaenv == 1) ilaenv = ieeeck(1,0.0,1.0) 
          return  
        end select 
      end select 
      if (n3 == -10000 .and. opts == " ") ilaenv = ilaenv + 0 ! dummy use of n3 and opts
!
!     End of ILAENV
!
      end function ilaenv 


 
      subroutine dpotrf(uplo, n, a, lda, info) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  20:49:17  01/01/08  
!...Switches: -rl INDDO=2 INDIF=2 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: n 
      integer  :: lda 
      integer  :: info 
      character  :: uplo 
      real(double)  :: a(lda,*) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      real(double), parameter :: one = 1.0D+0 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: j, jb, nb 
      logical :: upper 
!-----------------------------------------------
!   I n t r i n s i c  F u n c t i o n s
!-----------------------------------------------
      INTRINSIC max, min 
      integer, external :: ilaenv
!-----------------------------------------------
!
!  -- LAPACK routine (version 3.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     March 31, 1993
!
!     .. Scalar Arguments ..
!     ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DPOTRF computes the Cholesky factorization of a real symmetric
!  positive definite matrix A.
!
!  The factorization has the form
!     A = U**T * U,  if UPLO = 'U', or
!     A = L  * L**T,  if UPLO = 'L',
!  where U is an upper triangular matrix and L is lower triangular.
!
!  This is the block version of the algorithm, calling Level 3 BLAS.
!
!  Arguments
!  =========
!
!  UPLO    (input) CHARACTER*1
!          = 'U':  Upper triangle of A is stored;
!          = 'L':  Lower triangle of A is stored.
!
!  N       (input) INTEGER
!          The order of the matrix A.  N >= 0.
!
!  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
!          On entry, the symmetric matrix A.  If UPLO = 'U', the leading
!          N-by-N upper triangular part of A contains the upper
!          triangular part of the matrix A, and the strictly lower
!          triangular part of A is not referenced.  If UPLO = 'L', the
!          leading N-by-N lower triangular part of A contains the lower
!          triangular part of the matrix A, and the strictly upper
!          triangular part of A is not referenced.
!
!          On exit, if INFO = 0, the factor U or L from the Cholesky
!          factorization A = U**T*U or A = L*L**T.
!
!  LDA     (input) INTEGER
!          The leading dimension of the array A.  LDA >= max(1,N).
!
!  INFO    (output) INTEGER
!          = 0:  successful exit
!          < 0:  if INFO = -i, the i-th argument had an illegal value
!          > 0:  if INFO = i, the leading minor of order i is not
!                positive definite, and the factorization could not be
!                completed.
!
!  =====================================================================
!
!     .. Parameters ..
!     ..
!     .. Local Scalars ..
!     ..
!     .. External Functions ..
!     ..
!     .. External Subroutines ..
!     ..
!     .. Intrinsic Functions ..
!     ..
!     .. Executable Statements ..
!
!     Test the input parameters.
!
      info = 0 
      upper = lsame(uplo,'U') 
      if (.not.upper .and. .not.lsame(uplo,'L')) then 
        info = -1 
      else if (n < 0) then 
        info = -2 
      else if (lda < max(1,n)) then 
        info = -4 
      endif 
      if (info /= 0) then 
        call xerbla ('DPOTRF', (-info)) 
        return  
      endif 
!
!     Quick return if possible
!
      if (n == 0) return  
!
!     Determine the block size for this environment.
!
      nb = ilaenv(1,'DPOTRF',uplo,n,-1,-1,-1) 
      if (nb<=1 .or. nb>=n) then 
!
!        Use unblocked code.
!
        call dpotf2 (uplo, n, a, lda, info) 
      else 
!
!        Use blocked code.
!
        if (upper) then 
!
!           Compute the Cholesky factorization A = U'*U.
!
          do j = 1, n, nb 
!
!              Update and factorize the current diagonal block and test
!              for non-positive-definiteness.
!
            jb = min(nb,n - j + 1) 
            call dsyrk ('Upper', 'Transpose', jb, j - 1, (-one), a(1,j), lda, &
              one, a(j,j), lda) 
            call dpotf2 ('Upper', jb, a(j,j), lda, info) 
            if (info /= 0) go to 30 
            if (j + jb > n) cycle  
!
!                 Compute the current block row.
!
            call dgemm ('Transpose', 'No transpose', jb, n - j - jb + 1, j - 1&
              , (-one), a(1,j), lda, a(1,j+jb), lda, one, a(j,j+jb), lda) 
            call dtrsm ('Left', 'Upper', 'Transpose', 'Non-unit', jb, n - j - &
              jb + 1, one, a(j,j), lda, a(j,j+jb), lda) 
          end do 
!
        else 
!
!           Compute the Cholesky factorization A = L*L'.
!
          do j = 1, n, nb 
!
!              Update and factorize the current diagonal block and test
!              for non-positive-definiteness.
!
            jb = min(nb,n - j + 1) 
            call dsyrk ('Lower', 'No transpose', jb, j - 1, (-one), a(j,1), lda&
              , one, a(j,j), lda) 
            call dpotf2 ('Lower', jb, a(j,j), lda, info) 
            if (info /= 0) go to 30 
            if (j + jb > n) cycle  
!
!                 Compute the current block column.
!
            call dgemm ('No transpose', 'Transpose', n - j - jb + 1, jb, j - 1&
              , (-one), a(j+jb,1), lda, a(j,1), lda, one, a(j+jb,j), lda) 
            call dtrsm ('Right', 'Lower', 'Transpose', 'Non-unit', n - j - jb&
               + 1, jb, one, a(j,j), lda, a(j+jb,j), lda) 
          end do 
        endif 
      endif 
      go to 40 
!
   30 continue 
      info = info + j - 1 
!
   40 continue 
      return  
!
!     End of DPOTRF
!
      end subroutine dpotrf 


 
      subroutine xerbla(srname, info) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
     USE chanel_C, only : iw
!...Translated by Pacific-Sierra Research 77to90  4.4G  22:48:56  03/08/06  
!...Switches: -rl INDDO=2 INDIF=2 
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: info 
      character , intent(in) :: srname*6 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
!-----------------------------------------------
!
!  -- LAPACK AUXILIARY ROUTINE (VERSION 1.0B) --
!     UNIV. OF TENNESSEE, UNIV. OF CALIFORNIA BERKELEY, NAG LTD.,
!     COURANT INSTITUTE, ARGONNE NATIONAL LAB, AND RICE UNIVERSITY
!     FEBRUARY 29, 1992
!
!     .. SCALAR ARGUMENTS ..
! MOPAC CHANGE
      write (iw, fmt=10) srname, info 
! END OF MOPAC CHANGE
!
      call mopend ('Error in BLAS') 
      return  
!
   10 format(' ** ON ENTRY TO ',a6,' PARAMETER NUMBER ',i2,' HAD ',&
        'AN ILLEGAL VALUE') 
!
!     END OF XERBLA
!
      end subroutine xerbla 

      
      subroutine dgetf2(m, n, a, lda, ipiv) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  11:54:31  01/16/06  
!...Switches: -rl INDDO=2 INDIF=2 
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: m 
      integer  :: n 
      integer  :: lda 
      integer  :: info   ! WARNING
      integer , intent(out) :: ipiv(*) 
      real(double)  :: a(lda,*) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      real(double), parameter :: one = 1.0D+0 
      real(double), parameter :: zero = 0.0D+0 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: j, jp 
!-----------------------------------------------
!   I n t r i n s i c  F u n c t i o n s
!-----------------------------------------------
      INTRINSIC max, min 
!-----------------------------------------------
!
!  -- LAPACK routine (version 3.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     June 30, 1992
!
!     .. Scalar Arguments ..
!     ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DGETF2 computes an LU factorization of a general m-by-n matrix A
!  using partial pivoting with row interchanges.
!
!  The factorization has the form
!     A = P * L * U
!  where P is a permutation matrix, L is lower triangular with unit
!  diagonal elements (lower trapezoidal if m > n), and U is upper
!  triangular (upper trapezoidal if m < n).
!
!  This is the right-looking Level 2 BLAS version of the algorithm.
!
!  Arguments
!  =========
!
!  M       (input) INTEGER
!          The number of rows of the matrix A.  M >= 0.
!
!  N       (input) INTEGER
!          The number of columns of the matrix A.  N >= 0.
!
!  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
!          On entry, the m by n matrix to be factored.
!          On exit, the factors L and U from the factorization
!          A = P*L*U; the unit diagonal elements of L are not stored.
!
!  LDA     (input) INTEGER
!          The leading dimension of the array A.  LDA >= max(1,M).
!
!  IPIV    (output) INTEGER array, dimension (min(M,N))
!          The pivot indices; for 1 <= i <= min(M,N), row i of the
!          matrix was interchanged with row IPIV(i).
!
!  INFO    (output) INTEGER
!          = 0: successful exit
!          < 0: if INFO = -k, the k-th argument had an illegal value
!          > 0: if INFO = k, U(k,k) is exactly zero. The factorization
!               has been completed, but the factor U is exactly
!               singular, and division by zero will occur if it is used
!               to solve a system of equations.
!
!  =====================================================================
!
!     .. Parameters ..
!     ..
!     .. Local Scalars ..
!     ..
!     .. External Functions ..
!     ..
!     .. External Subroutines ..
!     ..
!     .. Intrinsic Functions ..
!     ..
!     .. Executable Statements ..
!
!     Test the input parameters.
!
      info = 0 
      if (m < 0) then 
        info = -1 
      else if (n < 0) then 
        info = -2 
      else if (lda < max(1,m)) then 
        info = -4 
      endif 
      if (info /= 0) then 
        call xerbla ('DGETF2', (-info)) 
        return  
      endif 
!
!     Quick return if possible
!
      if (m==0 .or. n==0) return  
!
      do j = 1, min(m,n) 
!
!        Find pivot and test for singularity.
!
        jp = j - 1 + idamax(m - j + 1,a(j,j),1) 
        ipiv(j) = jp 
        if (a(jp,j) /= zero) then 
!
!           Apply the interchange to columns 1:N.
!
          if (jp /= j) call dswap (n, a(j,1), lda, a(jp,1), lda) 
!
!           Compute elements J+1:M of J-th column.
!
          if (j < m) call dscal (m - j, one/a(j,j), a(j+1,j), 1) 
!
        else if (info == 0) then 
!
          info = j 
        endif 
!
        if (j >= min(m,n)) cycle  
!
!           Update trailing submatrix.
!
        call dger (m - j, n - j, (-one), a(j+1,j), 1, a(j,j+1), lda, a(j+1,j+1)&
          , lda) 
      end do 
      return  
!
!     End of DGETF2
!
      end subroutine dgetf2 


      subroutine dlaswp(n, a, lda, k1, k2, ipiv, incx) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  11:54:31  01/16/06  
!...Switches: -rl INDDO=2 INDIF=2 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n 
      integer , intent(in) :: lda 
      integer , intent(in) :: k1 
      integer , intent(in) :: k2 
      integer , intent(in) :: incx 
      integer , intent(in) :: ipiv(*) 
      real(double) , intent(inout) :: a(lda,*) 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, i1, i2, inc, ip, ix, ix0, j, k, n32 
      real(double) :: temp 
!-----------------------------------------------
!
!  -- LAPACK auxiliary routine (version 3.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     June 30, 1999
!
!     .. Scalar Arguments ..
!     ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DLASWP performs a series of row interchanges on the matrix A.
!  One row interchange is initiated for each of rows K1 through K2 of A.
!
!  Arguments
!  =========
!
!  N       (input) INTEGER
!          The number of columns of the matrix A.
!
!  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
!          On entry, the matrix of column dimension N to which the row
!          interchanges will be applied.
!          On exit, the permuted matrix.
!
!  LDA     (input) INTEGER
!          The leading dimension of the array A.
!
!  K1      (input) INTEGER
!          The first element of IPIV for which a row interchange will
!          be done.
!
!  K2      (input) INTEGER
!          The last element of IPIV for which a row interchange will
!          be done.
!
!  IPIV    (input) INTEGER array, dimension (M*abs(INCX))
!          The vector of pivot indices.  Only the elements in positions
!          K1 through K2 of IPIV are accessed.
!          IPIV(K) = L implies rows K and L are to be interchanged.
!
!  INCX    (input) INTEGER
!          The increment between successive values of IPIV.  If IPIV
!          is negative, the pivots are applied in reverse order.
!
!  Further Details
!  ===============
!
!  Modified by
!   R. C. Whaley, Computer Science Dept., Univ. of Tenn., Knoxville, USA
!
! =====================================================================
!
!     .. Local Scalars ..
!     ..
!     .. Executable Statements ..
!
!     Interchange row I with row IPIV(I) for each of rows K1 through K2.
!
      if (incx > 0) then 
        ix0 = k1 
        i1 = k1 
        i2 = k2 
        inc = 1 
      else if (incx < 0) then 
        ix0 = 1 + (1 - k2)*incx 
        i1 = k2 
        i2 = k1 
        inc = -1 
      else 
        return  
      endif 
!
      n32 = (n/32)*32 
      if (n32 /= 0) then 
        do j = 1, n32, 32 
          ix = ix0 
          do i = i1, i2, inc 
            ip = ipiv(ix) 
            if (ip /= i) then 
              do k = j, j + 31 
                temp = a(i,k) 
                a(i,k) = a(ip,k) 
                a(ip,k) = temp 
              end do 
            endif 
            ix = ix + incx 
          end do 
        end do 
      endif 
      if (n32 /= n) then 
        n32 = n32 + 1 
        ix = ix0 
        do i = i1, i2, inc 
          ip = ipiv(ix) 
          if (ip /= i) then 
            do k = n32, n 
              temp = a(i,k) 
              a(i,k) = a(ip,k) 
              a(ip,k) = temp 
            end do 
          endif 
          ix = ix + incx 
        end do 
      endif 
!
      return  
!
!     End of DLASWP
!
      end subroutine dlaswp 



      integer function ieeeck (ispec, zero, one) 
!...Translated by Pacific-Sierra Research 77to90  4.4G  11:54:31  01/16/06  
!...Switches: -rl INDDO=2 INDIF=2 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: ispec 
      real , intent(in) :: zero 
      real , intent(in) :: one 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      real ::  neginf, negzro, newzro, &
        posinf 
!-----------------------------------------------
!
!  -- LAPACK auxiliary routine (version 3.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     June 30, 1998
!
!     .. Scalar Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  IEEECK is called from the ILAENV to verify that Infinity and
!  possibly NaN arithmetic is safe (i.e. will not trap).
!
!  Arguments
!  =========
!
!  ISPEC   (input) INTEGER
!          Specifies whether to test just for inifinity arithmetic
!          or whether to test for infinity and NaN arithmetic.
!          = 0: Verify infinity arithmetic only.
!          = 1: Verify infinity and NaN arithmetic.
!
!  ZERO    (input) REAL
!          Must contain the value 0.0
!          This is passed to prevent the compiler from optimizing
!          away this code.
!
!  ONE     (input) REAL
!          Must contain the value 1.0
!          This is passed to prevent the compiler from optimizing
!          away this code.
!
!  RETURN VALUE:  INTEGER
!          = 0:  Arithmetic failed to produce the correct answers
!          = 1:  Arithmetic produced the correct answers
!
!     .. Local Scalars ..
!     ..
!     .. Executable Statements ..
      ieeeck = 1 
!
      posinf = one/zero 
      if (posinf <= one) then 
        ieeeck = 0 
        return  
      endif 
!
      neginf = -one/zero 
      if (neginf >= zero) then 
        ieeeck = 0 
        return  
      endif 
!
      negzro = one/(neginf + one) 
      if (Abs(negzro) > 1.d-20) then 
        ieeeck = 0 
        return  
      endif 
!
      neginf = one/negzro 
      if (neginf > -1.d-20) then 
        ieeeck = 0 
        return  
      endif 
!
      newzro = negzro + zero 
      if (Abs(newzro) > 1.d-20) then 
        ieeeck = 0 
        return  
      endif 
!
      posinf = one/newzro 
      if (posinf <= one) then 
        ieeeck = 0 
        return  
      endif 
!
      neginf = neginf*posinf 
      if (neginf >= zero) then 
        ieeeck = 0 
        return  
      endif 
!
      posinf = posinf*posinf 
      if (posinf <= one) then 
        ieeeck = 0 
        return  
      endif 
!
!
!
!
!     Return if we were only asked to check infinity arithmetic
!
      if (ispec == 0) return  
!
        ieeeck = 0  ! Bypass all the nan tests
!
      return  
      end function ieeeck 



      subroutine dtrsm(side, uplo, transa, diag, m, n, alpha, a, lda, b, ldb) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  22:48:56  03/08/06  
!...Switches: -rl INDDO=2 INDIF=2 
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: m 
      integer , intent(in) :: n 
      integer , intent(in) :: lda 
      integer , intent(in) :: ldb 
      real(double) , intent(in) :: alpha 
      character  :: side*(*) 
      character  :: uplo*(*) 
      character  :: transa*(*) 
      character  :: diag*(*) 
      real(double) , intent(in) :: a(lda,*) 
      real(double) , intent(inout) :: b(ldb,*) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      real(double), parameter :: one = 1.0D+0 
      real(double), parameter :: zero = 0.0D+0 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, info, j, k, nrowa 
      real(double) :: temp 
      logical :: lside, nounit, upper 
!-----------------------------------------------
!   I n t r i n s i c  F u n c t i o n s
!-----------------------------------------------
      INTRINSIC max 
!-----------------------------------------------
!     .. SCALAR ARGUMENTS ..
!     .. ARRAY ARGUMENTS ..
!     ..
!
!  PURPOSE
!  =======
!
!  DTRSM  SOLVES ONE OF THE MATRIX EQUATIONS
!
!     OP( A )*X = ALPHA*B,   OR   X*OP( A ) = ALPHA*B,
!
!  WHERE ALPHA IS A SCALAR, X AND B ARE M BY N MATRICES, A IS A UNIT, OR
!  NON-UNIT,  UPPER OR LOWER TRIANGULAR MATRIX  AND  OP( A )  IS ONE  OF
!
!     OP( A ) = A   OR   OP( A ) = A'.
!
!  THE MATRIX X IS OVERWRITTEN ON B.
!
!  PARAMETERS
!  ==========
!
!  SIDE   - CHARACTER*1.
!           ON ENTRY, SIDE SPECIFIES WHETHER OP( A ) APPEARS ON THE LEFT
!           OR RIGHT OF X AS FOLLOWS:
!
!              SIDE = 'L' OR 'L'   OP( A )*X = ALPHA*B.
!
!              SIDE = 'R' OR 'R'   X*OP( A ) = ALPHA*B.
!
!           UNCHANGED ON EXIT.
!
!  UPLO   - CHARACTER*1.
!           ON ENTRY, UPLO SPECIFIES WHETHER THE MATRIX A IS AN UPPER OR
!           LOWER TRIANGULAR MATRIX AS FOLLOWS:
!
!              UPLO = 'U' OR 'U'   A IS AN UPPER TRIANGULAR MATRIX.
!
!              UPLO = 'L' OR 'L'   A IS A LOWER TRIANGULAR MATRIX.
!
!           UNCHANGED ON EXIT.
!
!  TRANSA - CHARACTER*1.
!           ON ENTRY, TRANSA SPECIFIES THE FORM OF OP( A ) TO BE USED IN
!           THE MATRIX MULTIPLICATION AS FOLLOWS:
!
!              TRANSA = 'N' OR 'N'   OP( A ) = A.
!
!              TRANSA = 'T' OR 'T'   OP( A ) = A'.
!
!              TRANSA = 'C' OR 'C'   OP( A ) = A'.
!
!           UNCHANGED ON EXIT.
!
!  DIAG   - CHARACTER*1.
!           ON ENTRY, DIAG SPECIFIES WHETHER OR NOT A IS UNIT TRIANGULAR
!           AS FOLLOWS:
!
!              DIAG = 'U' OR 'U'   A IS ASSUMED TO BE UNIT TRIANGULAR.
!
!              DIAG = 'N' OR 'N'   A IS NOT ASSUMED TO BE UNIT
!                                  TRIANGULAR.
!
!           UNCHANGED ON EXIT.
!
!  M      - INTEGER.
!           ON ENTRY, M SPECIFIES THE NUMBER OF ROWS OF B. M MUST BE AT
!           LEAST ZERO.
!           UNCHANGED ON EXIT.
!
!  N      - INTEGER.
!           ON ENTRY, N SPECIFIES THE NUMBER OF COLUMNS OF B.  N MUST BE
!           AT LEAST ZERO.
!           UNCHANGED ON EXIT.
!
!  ALPHA  - DOUBLE PRECISION.
!           ON ENTRY,  ALPHA SPECIFIES THE SCALAR  ALPHA. WHEN  ALPHA IS
!           ZERO THEN  A IS NOT REFERENCED AND  B NEED NOT BE SET BEFORE
!           ENTRY.
!           UNCHANGED ON EXIT.
!
!  A      - DOUBLE PRECISION ARRAY OF DIMENSION ( LDA, K ), WHERE K IS M
!           WHEN  SIDE = 'L' OR 'L'  AND IS  N  WHEN  SIDE = 'R' OR 'R'.
!           BEFORE ENTRY  WITH  UPLO = 'U' OR 'U',  THE  LEADING  K BY K
!           UPPER TRIANGULAR PART OF THE ARRAY  A MUST CONTAIN THE UPPER
!           TRIANGULAR MATRIX  AND THE STRICTLY LOWER TRIANGULAR PART OF
!           A IS NOT REFERENCED.
!           BEFORE ENTRY  WITH  UPLO = 'L' OR 'L',  THE  LEADING  K BY K
!           LOWER TRIANGULAR PART OF THE ARRAY  A MUST CONTAIN THE LOWER
!           TRIANGULAR MATRIX  AND THE STRICTLY UPPER TRIANGULAR PART OF
!           A IS NOT REFERENCED.
!           NOTE THAT WHEN  DIAG = 'U' OR 'U',  THE DIAGONAL ELEMENTS OF
!           A  ARE NOT REFERENCED EITHER,  BUT ARE ASSUMED TO BE  UNITY.
!           UNCHANGED ON EXIT.
!
!  LDA    - INTEGER.
!           ON ENTRY, LDA SPECIFIES THE FIRST DIMENSION OF A AS DECLARED
!           IN THE CALLING (SUB) PROGRAM.  WHEN  SIDE = 'L' OR 'L'  THEN
!           LDA  MUST BE AT LEAST  MAX( 1, M ),  WHEN  SIDE = 'R' OR 'R'
!           THEN LDA MUST BE AT LEAST MAX( 1, N ).
!           UNCHANGED ON EXIT.
!
!  B      - DOUBLE PRECISION ARRAY OF DIMENSION ( LDB, N ).
!           BEFORE ENTRY,  THE LEADING  M BY N PART OF THE ARRAY  B MUST
!           CONTAIN  THE  RIGHT-HAND  SIDE  MATRIX  B,  AND  ON EXIT  IS
!           OVERWRITTEN BY THE SOLUTION MATRIX  X.
!
!  LDB    - INTEGER.
!           ON ENTRY, LDB SPECIFIES THE FIRST DIMENSION OF B AS DECLARED
!           IN  THE  CALLING  (SUB)  PROGRAM.   LDB  MUST  BE  AT  LEAST
!           MAX( 1, M ).
!           UNCHANGED ON EXIT.
!
!
!  LEVEL 3 BLAS ROUTINE.
!
!
!  -- WRITTEN ON 8-FEBRUARY-1989.
!     JACK DONGARRA, ARGONNE NATIONAL LABORATORY.
!     IAIN DUFF, AERE HARWELL.
!     JEREMY DU CROZ, NUMERICAL ALGORITHMS GROUP LTD.
!     SVEN HAMMARLING, NUMERICAL ALGORITHMS GROUP LTD.
!
!
!     .. EXTERNAL FUNCTIONS ..
!     .. EXTERNAL SUBROUTINES ..
!     .. INTRINSIC FUNCTIONS ..
!     .. LOCAL SCALARS ..
!     .. PARAMETERS ..
!     ..
!     .. EXECUTABLE STATEMENTS ..
!
!     TEST THE INPUT PARAMETERS.
!
      lside = lsame(side,'L') 
      if (lside) then 
        nrowa = m 
      else 
        nrowa = n 
      endif 
      nounit = lsame(diag,'N') 
      upper = lsame(uplo,'U') 
!
      info = 0 
      if (.not.lside .and. .not.lsame(side,'R')) then 
        info = 1 
      else if (.not.upper .and. .not.lsame(uplo,'L')) then 
        info = 2 
      else if (.not.lsame(transa,'N') .and. .not.lsame(transa,'T') .and. .not.&
          lsame(transa,'C')) then 
        info = 3 
      else if (.not.lsame(diag,'U') .and. .not.lsame(diag,'N')) then 
        info = 4 
      else if (m < 0) then 
        info = 5 
      else if (n < 0) then 
        info = 6 
      else if (lda < max(1,nrowa)) then 
        info = 9 
      else if (ldb < max(1,m)) then 
        info = 11 
      endif 
      if (info /= 0) then 
        call xerbla ('DTRSM ', info) 
        return  
      endif 
!
!     QUICK RETURN IF POSSIBLE.
!
      if (n == 0) return  
!
!     AND WHEN  ALPHA.EQ.ZERO.
!
      if (alpha == zero) then 
        b(:m,:n) = zero 
        return  
      endif 
!
!     START THE OPERATIONS.
!
      if (lside) then 
        if (lsame(transa,'N')) then 
!
!           FORM  B := ALPHA*INV( A )*B.
!
          if (upper) then 
            do j = 1, n 
              if (Abs(alpha-1.d0) > 1.d-20) then 
                b(:m,j) = alpha*b(:m,j) 
              endif 
              do k = m, 1, -1 
                if (b(k,j) == zero) cycle  
                if (nounit) b(k,j) = b(k,j)/a(k,k) 
                b(:k-1,j) = b(:k-1,j) - b(k,j)*a(:k-1,k) 
              end do 
            end do 
          else 
            do j = 1, n 
              if (Abs(alpha-1.d0) > 1.d-20) then 
                b(:m,j) = alpha*b(:m,j) 
              endif 
              do k = 1, m 
                if (b(k,j) == zero) cycle  
                if (nounit) b(k,j) = b(k,j)/a(k,k) 
                b(k+1:m,j) = b(k+1:m,j) - b(k,j)*a(k+1:m,k) 
              end do 
            end do 
          endif 
        else 
!
!           FORM  B := ALPHA*INV( A' )*B.
!
          if (upper) then 
            do j = 1, n 
              do i = 1, m 
                temp = alpha*b(i,j) 
                temp = temp - sum(a(:i-1,i)*b(:i-1,j)) 
                if (nounit) temp = temp/a(i,i) 
                b(i,j) = temp 
              end do 
            end do 
          else 
            do j = 1, n 
              do i = m, 1, -1 
                temp = alpha*b(i,j) 
                temp = temp - sum(a(i+1:m,i)*b(i+1:m,j)) 
                if (nounit) temp = temp/a(i,i) 
                b(i,j) = temp 
              end do 
            end do 
          endif 
        endif 
      else 
        if (lsame(transa,'N')) then 
!
!           FORM  B := ALPHA*B*INV( A ).
!
          if (upper) then 
            do j = 1, n 
              if (Abs(alpha-1.d0) > 1.d-20) then 
                b(:m,j) = alpha*b(:m,j) 
              endif 
              do k = 1, j - 1 
                if (a(k,j) == zero) cycle  
                b(:m,j) = b(:m,j) - a(k,j)*b(:m,k) 
              end do 
              if (.not.nounit) cycle  
              temp = one/a(j,j) 
              b(:m,j) = temp*b(:m,j) 
            end do 
          else 
            do j = n, 1, -1 
              if (Abs(alpha-1.d0) > 1.d-20) then 
                b(:m,j) = alpha*b(:m,j) 
              endif 
              do k = j + 1, n 
                if (a(k,j) == zero) cycle  
                b(:m,j) = b(:m,j) - a(k,j)*b(:m,k) 
              end do 
              if (.not.nounit) cycle  
              temp = one/a(j,j) 
              b(:m,j) = temp*b(:m,j) 
            end do 
          endif 
        else 
!
!           FORM  B := ALPHA*B*INV( A' ).
!
          if (upper) then 
            do k = n, 1, -1 
              if (nounit) then 
                temp = one/a(k,k) 
                b(:m,k) = temp*b(:m,k) 
              endif 
              do j = 1, k - 1 
                if (a(j,k) == zero) cycle  
                temp = a(j,k) 
                b(:m,j) = b(:m,j) - temp*b(:m,k) 
              end do 
              if (Abs(alpha-1.d0) < 1.d-20) cycle  
              b(:m,k) = alpha*b(:m,k) 
            end do 
          else 
            do k = 1, n 
              if (nounit) then 
                temp = one/a(k,k) 
                b(:m,k) = temp*b(:m,k) 
              endif 
              do j = k + 1, n 
                if (a(j,k) == zero) cycle  
                temp = a(j,k) 
                b(:m,j) = b(:m,j) - temp*b(:m,k) 
              end do 
              if (Abs(alpha-1.d0) < 1.d-20) cycle  
              b(:m,k) = alpha*b(:m,k) 
            end do 
          endif 
        endif 
      endif 
!
      return  
!
!     END OF DTRSM .
!
      end subroutine dtrsm 


      integer function idamax (n, dx, incx) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  22:48:56  03/08/06  
!...Switches: -rl INDDO=2 INDIF=2 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n 
      integer , intent(in) :: incx 
      real(double) , intent(in) :: dx(*) 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, ix 
      real(double) :: dmax 
!-----------------------------------------------
!
!     FINDS THE INDEX OF ELEMENT HAVING MAX. ABSOLUTE VALUE.
!     JACK DONGARRA, LINPACK, 3/11/78.
!     MODIFIED TO CORRECT PROBLEM WITH NEGATIVE INCREMENT, 8/21/90.
!
!
      idamax = 0 
      if (n < 1) return  
      idamax = 1 
      if (n == 1) return  
      if (incx /= 1) then 
!
!        CODE FOR INCREMENT NOT EQUAL TO 1
!
        ix = 1 
        if (incx < 0) ix = ((-n) + 1)*incx + 1 
        dmax = dabs(dx(ix)) 
        ix = ix + incx 
        do i = 2, n 
          if (dabs(dx(ix)) > dmax) then 
            idamax = i 
            dmax = dabs(dx(ix)) 
          endif 
          ix = ix + incx 
        end do 
        return  
      endif 
!
!        CODE FOR INCREMENT EQUAL TO 1
!
      dmax = dabs(dx(1)) 
      do i = 2, n 
        if (dabs(dx(i)) <= dmax) cycle  
        idamax = i 
        dmax = dabs(dx(i)) 
      end do 
      return  
      end function idamax 


      logical function lsame (ca, cb) 
!...Translated by Pacific-Sierra Research 77to90  4.4G  22:48:56  03/08/06  
!...Switches: -rl INDDO=2 INDIF=2 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      character , intent(in) :: ca 
      character , intent(in) :: cb 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: inta, intb, zcode 
!-----------------------------------------------
!   I n t r i n s i c  F u n c t i o n s
!-----------------------------------------------
      INTRINSIC ichar 
!-----------------------------------------------
!
!  -- LAPACK AUXILIARY ROUTINE (VERSION 1.0) --
!     UNIV. OF TENNESSEE, UNIV. OF CALIFORNIA BERKELEY, NAG LTD.,
!     COURANT INSTITUTE, ARGONNE NATIONAL LAB, AND RICE UNIVERSITY
!     FEBRUARY 29, 1992
!
!     .. SCALAR ARGUMENTS ..
!     ..
!
!  PURPOSE
!  =======
!
!  LSAME RETURNS .TRUE. IF CA IS THE SAME LETTER AS CB REGARDLESS OF
!  CASE.
!
!  ARGUMENTS
!  =========
!
!  CA      (INPUT) CHARACTER*1
!  CB      (INPUT) CHARACTER*1
!          CA AND CB SPECIFY THE SINGLE CHARACTERS TO BE COMPARED.
!
!     .. INTRINSIC FUNCTIONS ..
!     ..
!     .. LOCAL SCALARS ..
!     ..
!     .. EXECUTABLE STATEMENTS ..
!
!     TEST IF THE CHARACTERS ARE EQUAL
!
      lsame = ca == cb 
      if (lsame) return  
!
!     NOW TEST FOR EQUIVALENCE IF BOTH CHARACTERS ARE ALPHABETIC.
!
      zcode = ichar('Z') 
!
!     USE 'Z' RATHER THAN 'A' SO THAT ASCII CAN BE DETECTED ON PRIME
!     MACHINES, ON WHICH ICHAR RETURNS A VALUE WITH BIT 8 SET.
!     ICHAR('A') ON PRIME MACHINES RETURNS 193 WHICH IS THE SAME AS
!     ICHAR('A') ON AN EBCDIC MACHINE.
!
      inta = ichar(ca) 
      intb = ichar(cb) 
!
      if (zcode==90 .or. zcode==122) then 
!
!        ASCII IS ASSUMED - ZCODE IS THE ASCII CODE OF EITHER LOWER OR
!        UPPER CASE 'Z'.
!
        if (inta>=97 .and. inta<=122) inta = inta - 32 
        if (intb>=97 .and. intb<=122) intb = intb - 32 
!
      else if (zcode==233 .or. zcode==169) then 
!
!        EBCDIC IS ASSUMED - ZCODE IS THE EBCDIC CODE OF EITHER LOWER OR
!        UPPER CASE 'Z'.
!
        if (inta>=129 .and. inta<=137 .or. inta>=145 .and. inta<=153 .or. inta&
          >=162 .and. inta<=169) inta = inta + 64 
        if (intb>=129 .and. intb<=137 .or. intb>=145 .and. intb<=153 .or. intb&
          >=162 .and. intb<=169) intb = intb + 64 
!
      else if (zcode==218 .or. zcode==250) then 
!
!        ASCII IS ASSUMED, ON PRIME MACHINES - ZCODE IS THE ASCII CODE
!        PLUS 128 OF EITHER LOWER OR UPPER CASE 'Z'.
!
        if (inta>=225 .and. inta<=250) inta = inta - 32 
        if (intb>=225 .and. intb<=250) intb = intb - 32 
      endif 
      lsame = inta == intb 
      return  
!
!     RETURN
!
!     END OF LSAME
!
      end function lsame 




      subroutine dtrtri(uplo, diag, n, a, lda, info) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  20:49:17  01/01/08  
!...Switches: -rl INDDO=2 INDIF=2 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: n 
      integer  :: lda 
      integer  :: info 
      character  :: uplo 
      character  :: diag 
      real(double)  :: a(lda,*) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      real(double), parameter :: one = 1.0D+0 
      real(double), parameter :: zero = 0.0D+0 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: j, jb, nb, nn 
      logical :: nounit, upper 
!-----------------------------------------------
!   I n t r i n s i c  F u n c t i o n s
!-----------------------------------------------
      INTRINSIC max, min 
      integer, external :: ilaenv
!-----------------------------------------------
!
!  -- LAPACK routine (version 3.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     March 31, 1993
!
!     .. Scalar Arguments ..
!     ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DTRTRI computes the inverse of a real upper or lower triangular
!  matrix A.
!
!  This is the Level 3 BLAS version of the algorithm.
!
!  Arguments
!  =========
!
!  UPLO    (input) CHARACTER*1
!          = 'U':  A is upper triangular;
!          = 'L':  A is lower triangular.
!
!  DIAG    (input) CHARACTER*1
!          = 'N':  A is non-unit triangular;
!          = 'U':  A is unit triangular.
!
!  N       (input) INTEGER
!          The order of the matrix A.  N >= 0.
!
!  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
!          On entry, the triangular matrix A.  If UPLO = 'U', the
!          leading N-by-N upper triangular part of the array A contains
!          the upper triangular matrix, and the strictly lower
!          triangular part of A is not referenced.  If UPLO = 'L', the
!          leading N-by-N lower triangular part of the array A contains
!          the lower triangular matrix, and the strictly upper
!          triangular part of A is not referenced.  If DIAG = 'U', the
!          diagonal elements of A are also not referenced and are
!          assumed to be 1.
!          On exit, the (triangular) inverse of the original matrix, in
!          the same storage format.
!
!  LDA     (input) INTEGER
!          The leading dimension of the array A.  LDA >= max(1,N).
!
!  INFO    (output) INTEGER
!          = 0: successful exit
!          < 0: if INFO = -i, the i-th argument had an illegal value
!          > 0: if INFO = i, A(i,i) is exactly zero.  The triangular
!               matrix is singular and its inverse can not be computed.
!
!  =====================================================================
!
!     .. Parameters ..
!     ..
!     .. Local Scalars ..
!     ..
!     .. External Functions ..
!     ..
!     .. External Subroutines ..
!     ..
!     .. Intrinsic Functions ..
!     ..
!     .. Executable Statements ..
!
!     Test the input parameters.
!
      info = 0 
      upper = lsame(uplo,'U') 
      nounit = lsame(diag,'N') 
      if (.not.upper .and. .not.lsame(uplo,'L')) then 
        info = -1 
      else if (.not.nounit .and. .not.lsame(diag,'U')) then 
        info = -2 
      else if (n < 0) then 
        info = -3 
      else if (lda < max(1,n)) then 
        info = -5 
      endif 
      if (info /= 0) then 
        call xerbla ('DTRTRI', (-info)) 
        return  
      endif 
!
!     Quick return if possible
!
      if (n == 0) return  
!
!     Check for singularity if non-unit.
!
      if (nounit) then 
        do info = 1, n 
          if (a(info,info) /= zero) cycle  
          return  
        end do 
        info = 0 
      endif 
!
!     Determine the block size for this environment.
!
      nb = ilaenv(1,'DTRTRI',uplo//diag,n,-1,-1,-1) 
      if (nb<=1 .or. nb>=n) then 
!
!        Use unblocked code
!
        call dtrti2 (uplo, diag, n, a, lda, info) 
      else 
!
!        Use blocked code
!
        if (upper) then 
!
!           Compute inverse of upper triangular matrix
!
          do j = 1, n, nb 
            jb = min(nb,n - j + 1) 
!
!              Compute rows 1:j-1 of current block column
!
            call dtrmm ('Left', 'Upper', 'No transpose', diag, j - 1, jb, one, &
              a, lda, a(1,j), lda) 
            call dtrsm ('Right', 'Upper', 'No transpose', diag, j - 1, jb, (-&
              one), a(j,j), lda, a(1,j), lda) 
!
!              Compute inverse of current diagonal block
!
            call dtrti2 ('Upper', diag, jb, a(j,j), lda, info) 
          end do 
        else 
!
!           Compute inverse of lower triangular matrix
!
          nn = ((n - 1)/nb)*nb + 1 
          do j = nn, 1, -nb 
            jb = min(nb,n - j + 1) 
            if (j + jb <= n) then 
!
!                 Compute rows j+jb:n of current block column
!
              call dtrmm ('Left', 'Lower', 'No transpose', diag, n - j - jb + 1&
                , jb, one, a(j+jb,j+jb), lda, a(j+jb,j), lda) 
              call dtrsm ('Right', 'Lower', 'No transpose', diag, n - j - jb + &
                1, jb, (-one), a(j,j), lda, a(j+jb,j), lda) 
            endif 
!
!              Compute inverse of current diagonal block
!
            call dtrti2 ('Lower', diag, jb, a(j,j), lda, info) 
          end do 
        endif 
      endif 
!
      return  
!
!     End of DTRTRI
!
      end subroutine dtrtri 


 
      subroutine dlauum(uplo, n, a, lda, info) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  20:49:17  01/01/08  
!...Switches: -rl INDDO=2 INDIF=2 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: n 
      integer  :: lda 
      integer  :: info 
      character  :: uplo 
      real(double)  :: a(lda,*) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      real(double), parameter :: one = 1.0D+0 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, ib, nb 
      logical :: upper 
      integer, external :: ilaenv
!-----------------------------------------------
!   I n t r i n s i c  F u n c t i o n s
!-----------------------------------------------
      INTRINSIC max, min 
!-----------------------------------------------
!
!  -- LAPACK auxiliary routine (version 3.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     February 29, 1992
!
!     .. Scalar Arguments ..
!     ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DLAUUM computes the product U * U' or L' * L, where the triangular
!  factor U or L is stored in the upper or lower triangular part of
!  the array A.
!
!  If UPLO = 'U' or 'u' then the upper triangle of the result is stored,
!  overwriting the factor U in A.
!  If UPLO = 'L' or 'l' then the lower triangle of the result is stored,
!  overwriting the factor L in A.
!
!  This is the blocked form of the algorithm, calling Level 3 BLAS.
!
!  Arguments
!  =========
!
!  UPLO    (input) CHARACTER*1
!          Specifies whether the triangular factor stored in the array A
!          is upper or lower triangular:
!          = 'U':  Upper triangular
!          = 'L':  Lower triangular
!
!  N       (input) INTEGER
!          The order of the triangular factor U or L.  N >= 0.
!
!  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
!          On entry, the triangular factor U or L.
!          On exit, if UPLO = 'U', the upper triangle of A is
!          overwritten with the upper triangle of the product U * U';
!          if UPLO = 'L', the lower triangle of A is overwritten with
!          the lower triangle of the product L' * L.
!
!  LDA     (input) INTEGER
!          The leading dimension of the array A.  LDA >= max(1,N).
!
!  INFO    (output) INTEGER
!          = 0: successful exit
!          < 0: if INFO = -k, the k-th argument had an illegal value
!
!  =====================================================================
!
!     .. Parameters ..
!     ..
!     .. Local Scalars ..
!     ..
!     .. External Functions ..
!     ..
!     .. External Subroutines ..
!     ..
!     .. Intrinsic Functions ..
!     ..
!     .. Executable Statements ..
!
!     Test the input parameters.
!
      info = 0 
      upper = lsame(uplo,'U') 
      if (.not.upper .and. .not.lsame(uplo,'L')) then 
        info = -1 
      else if (n < 0) then 
        info = -2 
      else if (lda < max(1,n)) then 
        info = -4 
      endif 
      if (info /= 0) then 
        call xerbla ('DLAUUM', (-info)) 
        return  
      endif 
!
!     Quick return if possible
!
      if (n == 0) return  
!
!     Determine the block size for this environment.
!
      nb = ilaenv(1,'DLAUUM',uplo,n,-1,-1,-1) 
!
      if (nb<=1 .or. nb>=n) then 
!
!        Use unblocked code
!
        call dlauu2 (uplo, n, a, lda, info) 
      else 
!
!        Use blocked code
!
        if (upper) then 
!
!           Compute the product U * U'.
!
          do i = 1, n, nb 
            ib = min(nb,n - i + 1) 
            call dtrmm ('Right', 'Upper', 'Transpose', 'Non-unit', i - 1, ib, &
              one, a(i,i), lda, a(1,i), lda) 
            call dlauu2 ('Upper', ib, a(i,i), lda, info) 
            if (i + ib > n) cycle  
            call dgemm ('No transpose', 'Transpose', i - 1, ib, n - i - ib + 1&
              , one, a(1,i+ib), lda, a(i,i+ib), lda, one, a(1,i), lda) 
            call dsyrk ('Upper', 'No transpose', ib, n - i - ib + 1, one, a(i,i&
              +ib), lda, one, a(i,i), lda) 
          end do 
        else 
!
!           Compute the product L' * L.
!
          do i = 1, n, nb 
            ib = min(nb,n - i + 1) 
            call dtrmm ('Left', 'Lower', 'Transpose', 'Non-unit', ib, i - 1, &
              one, a(i,i), lda, a(i,1), lda) 
            call dlauu2 ('Lower', ib, a(i,i), lda, info) 
            if (i + ib > n) cycle  
            call dgemm ('Transpose', 'No transpose', ib, i - 1, n - i - ib + 1&
              , one, a(i+ib,i), lda, a(i+ib,1), lda, one, a(i,1), lda) 
            call dsyrk ('Lower', 'Transpose', ib, n - i - ib + 1, one, a(i+ib,i&
              ), lda, one, a(i,i), lda) 
          end do 
        endif 
      endif 
!
      return  
!
!     End of DLAUUM
!
      end subroutine dlauum 


 
 
      subroutine dlauu2(uplo, n, a, lda, info) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  20:49:17  01/01/08  
!...Switches: -rl INDDO=2 INDIF=2 
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n 
      integer  :: lda 
      integer , intent(out) :: info 
      character  :: uplo 
      real(double)  :: a(lda,*) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      real(double), parameter :: one = 1.0D+0 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i 
      real(double) :: aii 
      logical :: upper 
!-----------------------------------------------
!   I n t r i n s i c  F u n c t i o n s
!-----------------------------------------------
      INTRINSIC max 
!-----------------------------------------------
!
!  -- LAPACK auxiliary routine (version 3.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     February 29, 1992
!
!     .. Scalar Arguments ..
!     ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DLAUU2 computes the product U * U' or L' * L, where the triangular
!  factor U or L is stored in the upper or lower triangular part of
!  the array A.
!
!  If UPLO = 'U' or 'u' then the upper triangle of the result is stored,
!  overwriting the factor U in A.
!  If UPLO = 'L' or 'l' then the lower triangle of the result is stored,
!  overwriting the factor L in A.
!
!  This is the unblocked form of the algorithm, calling Level 2 BLAS.
!
!  Arguments
!  =========
!
!  UPLO    (input) CHARACTER*1
!          Specifies whether the triangular factor stored in the array A
!          is upper or lower triangular:
!          = 'U':  Upper triangular
!          = 'L':  Lower triangular
!
!  N       (input) INTEGER
!          The order of the triangular factor U or L.  N >= 0.
!
!  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
!          On entry, the triangular factor U or L.
!          On exit, if UPLO = 'U', the upper triangle of A is
!          overwritten with the upper triangle of the product U * U';
!          if UPLO = 'L', the lower triangle of A is overwritten with
!          the lower triangle of the product L' * L.
!
!  LDA     (input) INTEGER
!          The leading dimension of the array A.  LDA >= max(1,N).
!
!  INFO    (output) INTEGER
!          = 0: successful exit
!          < 0: if INFO = -k, the k-th argument had an illegal value
!
!  =====================================================================
!
!     .. Parameters ..
!     ..
!     .. Local Scalars ..
!     ..
!     .. External Functions ..
!     ..
!     .. External Subroutines ..
!     ..
!     .. Intrinsic Functions ..
!     ..
!     .. Executable Statements ..
!
!     Test the input parameters.
!
      info = 0 
      upper = lsame(uplo,'U') 
      if (.not.upper .and. .not.lsame(uplo,'L')) then 
        info = -1 
      else if (n < 0) then 
        info = -2 
      else if (lda < max(1,n)) then 
        info = -4 
      endif 
      if (info /= 0) then 
        call xerbla ('DLAUU2', (-info)) 
        return  
      endif 
!
!     Quick return if possible
!
      if (n == 0) return  
!
      if (upper) then 
!
!        Compute the product U * U'.
!
        do i = 1, n 
          aii = a(i,i) 
          if (i < n) then 
            a(i,i) = ddot(n - i + 1,a(i,i),lda,a(i,i),lda) 
            call dgemv ('No transpose', i - 1, n - i, one, a(1,i+1), lda, a(i,i&
              +1), lda, aii, a(1,i), 1) 
          else 
            call dscal (i, aii, a(1,i), 1) 
          endif 
        end do 
!
      else 
!
!        Compute the product L' * L.
!
        do i = 1, n 
          aii = a(i,i) 
          if (i < n) then 
            a(i,i) = ddot(n - i + 1,a(i,i),1,a(i,i),1) 
            call dgemv ('Transpose', n - i, i - 1, one, a(i+1,1), lda, a(i+1,i)&
              , 1, aii, a(i,1), lda) 
          else 
            call dscal (i, aii, a(i,1), lda) 
          endif 
        end do 
      endif 
!
      return  
!
!     End of DLAUU2
!
      end subroutine dlauu2 


 
      subroutine dsyrk(uplo, trans, n, k, alpha, a, lda, beta, c, ldc) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  20:49:17  01/01/08  
!...Switches: -rl INDDO=2 INDIF=2 
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n 
      integer , intent(in) :: k 
      integer , intent(in) :: lda 
      integer , intent(in) :: ldc 
      real(double) , intent(in) :: alpha 
      real(double) , intent(in) :: beta 
      character  :: uplo 
      character  :: trans 
      real(double) , intent(in) :: a(lda,*) 
      real(double) , intent(out)  :: c(ldc,*) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      real(double), parameter :: one = 1.0D+0 
      real(double), parameter :: zero = 0.0D+0 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, info, j, l, nrowa 
      real(double) :: temp 
      logical :: upper 
!-----------------------------------------------
!   I n t r i n s i c  F u n c t i o n s
!-----------------------------------------------
      INTRINSIC max 
!-----------------------------------------------
!     .. Scalar Arguments ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DSYRK  performs one of the symmetric rank k operations
!
!     C := alpha*A*A' + beta*C,
!
!  or
!
!     C := alpha*A'*A + beta*C,
!
!  where  alpha and beta  are scalars, C is an  n by n  symmetric matrix
!  and  A  is an  n by k  matrix in the first case and a  k by n  matrix
!  in the second case.
!
!  Parameters
!  ==========
!
!  UPLO   - CHARACTER*1.
!           On  entry,   UPLO  specifies  whether  the  upper  or  lower
!           triangular  part  of the  array  C  is to be  referenced  as
!           follows:
!
!              UPLO = 'U' or 'u'   Only the  upper triangular part of  C
!                                  is to be referenced.
!
!              UPLO = 'L' or 'l'   Only the  lower triangular part of  C
!                                  is to be referenced.
!
!           Unchanged on exit.
!
!  TRANS  - CHARACTER*1.
!           On entry,  TRANS  specifies the operation to be performed as
!           follows:
!
!              TRANS = 'N' or 'n'   C := alpha*A*A' + beta*C.
!
!              TRANS = 'T' or 't'   C := alpha*A'*A + beta*C.
!
!              TRANS = 'C' or 'c'   C := alpha*A'*A + beta*C.
!
!           Unchanged on exit.
!
!  N      - INTEGER.
!           On entry,  N specifies the order of the matrix C.  N must be
!           at least zero.
!           Unchanged on exit.
!
!  K      - INTEGER.
!           On entry with  TRANS = 'N' or 'n',  K  specifies  the number
!           of  columns   of  the   matrix   A,   and  on   entry   with
!           TRANS = 'T' or 't' or 'C' or 'c',  K  specifies  the  number
!           of rows of the matrix  A.  K must be at least zero.
!           Unchanged on exit.
!
!  ALPHA  - DOUBLE PRECISION.
!           On entry, ALPHA specifies the scalar alpha.
!           Unchanged on exit.
!
!  A      - DOUBLE PRECISION array of DIMENSION ( LDA, ka ), where ka is
!           k  when  TRANS = 'N' or 'n',  and is  n  otherwise.
!           Before entry with  TRANS = 'N' or 'n',  the  leading  n by k
!           part of the array  A  must contain the matrix  A,  otherwise
!           the leading  k by n  part of the array  A  must contain  the
!           matrix A.
!           Unchanged on exit.
!
!  LDA    - INTEGER.
!           On entry, LDA specifies the first dimension of A as declared
!           in  the  calling  (sub)  program.   When  TRANS = 'N' or 'n'
!           then  LDA must be at least  max( 1, n ), otherwise  LDA must
!           be at least  max( 1, k ).
!           Unchanged on exit.
!
!  BETA   - DOUBLE PRECISION.
!           On entry, BETA specifies the scalar beta.
!           Unchanged on exit.
!
!  C      - DOUBLE PRECISION array of DIMENSION ( LDC, n ).
!           Before entry  with  UPLO = 'U' or 'u',  the leading  n by n
!           upper triangular part of the array C must contain the upper
!           triangular part  of the  symmetric matrix  and the strictly
!           lower triangular part of C is not referenced.  On exit, the
!           upper triangular part of the array  C is overwritten by the
!           upper triangular part of the updated matrix.
!           Before entry  with  UPLO = 'L' or 'l',  the leading  n by n
!           lower triangular part of the array C must contain the lower
!           triangular part  of the  symmetric matrix  and the strictly
!           upper triangular part of C is not referenced.  On exit, the
!           lower triangular part of the array  C is overwritten by the
!           lower triangular part of the updated matrix.
!
!  LDC    - INTEGER.
!           On entry, LDC specifies the first dimension of C as declared
!           in  the  calling  (sub)  program.   LDC  must  be  at  least
!           max( 1, n ).
!           Unchanged on exit.
!
!
!  Level 3 Blas routine.
!
!  -- Written on 8-February-1989.
!     Jack Dongarra, Argonne National Laboratory.
!     Iain Duff, AERE Harwell.
!     Jeremy Du Croz, Numerical Algorithms Group Ltd.
!     Sven Hammarling, Numerical Algorithms Group Ltd.
!
!
!     .. External Functions ..
!     .. External Subroutines ..
!     .. Intrinsic Functions ..
!     .. Local Scalars ..
!     .. Parameters ..
!     ..
!     .. Executable Statements ..
!
!     Test the input parameters.
!
      if (lsame(trans,'N')) then 
        nrowa = n 
      else 
        nrowa = k 
      endif 
      upper = lsame(uplo,'U') 
!
      info = 0 
      if (.not.upper .and. .not.lsame(uplo,'L')) then 
        info = 1 
      else if (.not.lsame(trans,'N') .and. .not.lsame(trans,'T') .and. .not.&
          lsame(trans,'C')) then 
        info = 2 
      else if (n < 0) then 
        info = 3 
      else if (k < 0) then 
        info = 4 
      else if (lda < max(1,nrowa)) then 
        info = 7 
      else if (ldc < max(1,n)) then 
        info = 10 
      endif 
      if (info /= 0) then 
        call xerbla ('DSYRK ', info) 
        return  
      endif 
!
!     Quick return if possible.
!
      if (n==0 .or. (Abs(alpha) < 1.d-20 .or. k==0) .and. Abs(beta - one) < 1.d-20) return  
!
!     And when  alpha.eq.zero.
!
      if (alpha == zero) then 
        if (upper) then 
          if (beta == zero) then 
            do j = 1, n 
              c(:j,j) = zero 
            end do 
          else 
            do j = 1, n 
              c(:j,j) = beta*c(:j,j) 
            end do 
          endif 
        else 
          if (beta == zero) then 
            do j = 1, n 
              c(j:n,j) = zero 
            end do 
          else 
            do j = 1, n 
              c(j:n,j) = beta*c(j:n,j) 
            end do 
          endif 
        endif 
        return  
      endif 
!
!     Start the operations.
!
      if (lsame(trans,'N')) then 
!
!        Form  C := alpha*A*A' + beta*C.
!
        if (upper) then 
          do j = 1, n 
            if (beta == zero) then 
              c(:j,j) = zero 
            else if (Abs(beta - one) > 1.d-20) then 
              c(:j,j) = beta*c(:j,j) 
            endif 
            do l = 1, k 
              if (a(j,l) == zero) cycle  
              temp = alpha*a(j,l) 
              c(:j,j) = c(:j,j) + temp*a(:j,l) 
            end do 
          end do 
        else 
          do j = 1, n 
            if (beta == zero) then 
              c(j:n,j) = zero 
            else if (Abs(beta - one) > 1.d-20) then 
              c(j:n,j) = beta*c(j:n,j) 
            endif 
            do l = 1, k 
              if (a(j,l) == zero) cycle  
              temp = alpha*a(j,l) 
              c(j:n,j) = c(j:n,j) + temp*a(j:n,l) 
            end do 
          end do 
        endif 
      else 
!
!        Form  C := alpha*A'*A + beta*C.
!
        if (upper) then 
          do j = 1, n 
            do i = 1, j 
              temp = zero 
              temp = temp + sum(a(:k,i)*a(:k,j)) 
              if (beta == zero) then 
                c(i,j) = alpha*temp 
              else 
                c(i,j) = alpha*temp + beta*c(i,j) 
              endif 
            end do 
          end do 
        else 
          do j = 1, n 
            do i = j, n 
              temp = zero 
              temp = temp + sum(a(:k,i)*a(:k,j)) 
              if (beta == zero) then 
                c(i,j) = alpha*temp 
              else 
                c(i,j) = alpha*temp + beta*c(i,j) 
              endif 
            end do 
          end do 
        endif 
      endif 
!
      return  
!
!     End of DSYRK .
!
      end subroutine dsyrk 

      
 
 
      subroutine dpotf2(uplo, n, a, lda, info) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  20:49:17  01/01/08  
!...Switches: -rl INDDO=2 INDIF=2 
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n 
      integer  :: lda 
      integer , intent(out) :: info 
      character  :: uplo 
      real(double)  :: a(lda,*) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      real(double), parameter :: one = 1.0D+0 
      real(double), parameter :: zero = 0.0D+0 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: j 
      real(double) :: ajj 
      logical :: upper 
!-----------------------------------------------
!   I n t r i n s i c  F u n c t i o n s
!-----------------------------------------------
      INTRINSIC max, sqrt 
!-----------------------------------------------
!
!  -- LAPACK routine (version 3.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     February 29, 1992
!
!     .. Scalar Arguments ..
!     ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DPOTF2 computes the Cholesky factorization of a real symmetric
!  positive definite matrix A.
!
!  The factorization has the form
!     A = U' * U ,  if UPLO = 'U', or
!     A = L  * L',  if UPLO = 'L',
!  where U is an upper triangular matrix and L is lower triangular.
!
!  This is the unblocked version of the algorithm, calling Level 2 BLAS.
!
!  Arguments
!  =========
!
!  UPLO    (input) CHARACTER*1
!          Specifies whether the upper or lower triangular part of the
!          symmetric matrix A is stored.
!          = 'U':  Upper triangular
!          = 'L':  Lower triangular
!
!  N       (input) INTEGER
!          The order of the matrix A.  N >= 0.
!
!  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
!          On entry, the symmetric matrix A.  If UPLO = 'U', the leading
!          n by n upper triangular part of A contains the upper
!          triangular part of the matrix A, and the strictly lower
!          triangular part of A is not referenced.  If UPLO = 'L', the
!          leading n by n lower triangular part of A contains the lower
!          triangular part of the matrix A, and the strictly upper
!          triangular part of A is not referenced.
!
!          On exit, if INFO = 0, the factor U or L from the Cholesky
!          factorization A = U'*U  or A = L*L'.
!
!  LDA     (input) INTEGER
!          The leading dimension of the array A.  LDA >= max(1,N).
!
!  INFO    (output) INTEGER
!          = 0: successful exit
!          < 0: if INFO = -k, the k-th argument had an illegal value
!          > 0: if INFO = k, the leading minor of order k is not
!               positive definite, and the factorization could not be
!               completed.
!
!  =====================================================================
!
!     .. Parameters ..
!     ..
!     .. Local Scalars ..
!     ..
!     .. External Functions ..
!     ..
!     .. External Subroutines ..
!     ..
!     .. Intrinsic Functions ..
!     ..
!     .. Executable Statements ..
!
!     Test the input parameters.
!
      info = 0 
      upper = lsame(uplo,'U') 
      if (.not.upper .and. .not.lsame(uplo,'L')) then 
        info = -1 
      else if (n < 0) then 
        info = -2 
      else if (lda < max(1,n)) then 
        info = -4 
      endif 
      if (info /= 0) then 
        call xerbla ('DPOTF2', (-info)) 
        return  
      endif 
!
!     Quick return if possible
!
      if (n == 0) return  
!
      if (upper) then 
!
!        Compute the Cholesky factorization A = U'*U.
!
        do j = 1, n 
!
!           Compute U(J,J) and test for non-positive-definiteness.
!
          ajj = a(j,j) - ddot(j - 1,a(1,j),1,a(1,j),1) 
          if (ajj <= zero) then 
            a(j,j) = ajj 
            go to 30 
          endif 
          ajj = sqrt(ajj) 
          a(j,j) = ajj 
!
!           Compute elements J+1:N of row J.
!
          if (j >= n) cycle  
          call dgemv ('Transpose', j - 1, n - j, (-one), a(1,j+1), lda, a(1,j)&
            , 1, one, a(j,j+1), lda) 
          call dscal (n - j, one/ajj, a(j,j+1), lda) 
        end do 
      else 
!
!        Compute the Cholesky factorization A = L*L'.
!
        do j = 1, n 
!
!           Compute L(J,J) and test for non-positive-definiteness.
!
          ajj = a(j,j) - ddot(j - 1,a(j,1),lda,a(j,1),lda) 
          if (ajj <= zero) then 
            a(j,j) = ajj 
            go to 30 
          endif 
          ajj = sqrt(ajj) 
          a(j,j) = ajj 
!
!           Compute elements J+1:N of column J.
!
          if (j >= n) cycle  
          call dgemv ('No transpose', n - j, j - 1, (-one), a(j+1,1), lda, a(j,&
            1), lda, one, a(j+1,j), 1) 
          call dscal (n - j, one/ajj, a(j+1,j), 1) 
        end do 
      endif 
      go to 40 
!
   30 continue 
      info = j 
!
   40 continue 
      return  
!
!     End of DPOTF2
!
      end subroutine dpotf2 
 
 


      subroutine dgemv(trans, m, n, alpha, a, lda, x, incx, beta, y, incy) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  22:48:56  03/08/06  
!...Switches: -rl INDDO=2 INDIF=2 
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: m 
      integer , intent(in) :: n 
      integer , intent(in) :: lda 
      integer , intent(in) :: incx 
      integer , intent(in) :: incy 
      real(double) , intent(in) :: alpha 
      real(double) , intent(in) :: beta 
      character  :: trans*(*) 
      real(double) , intent(in) :: a(lda,*) 
      real(double) , intent(in) :: x(*) 
      real(double) , intent(inout) :: y(*) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      real(double), parameter :: zero = 0.0D+0 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: info, ix, iy, j, jx, jy, kx, ky, lenx, leny 
      real(double) :: temp 
!-----------------------------------------------
!   I n t r i n s i c  F u n c t i o n s
!-----------------------------------------------
      INTRINSIC max 
!-----------------------------------------------
!     .. SCALAR ARGUMENTS ..
!     .. ARRAY ARGUMENTS ..
!     ..
!
!  PURPOSE
!  =======
!
!  DGEMV  PERFORMS ONE OF THE MATRIX-VECTOR OPERATIONS
!
!     Y := ALPHA*A*X + BETA*Y,   OR   Y := ALPHA*A'*X + BETA*Y,
!
!  WHERE ALPHA AND BETA ARE SCALARS, X AND Y ARE VECTORS AND A IS AN
!  M BY N MATRIX.
!
!  PARAMETERS
!  ==========
!
!  TRANS  - CHARACTER*1.
!           ON ENTRY, TRANS SPECIFIES THE OPERATION TO BE PERFORMED AS
!           FOLLOWS:
!
!              TRANS = 'N' OR 'N'   Y := ALPHA*A*X + BETA*Y.
!
!              TRANS = 'T' OR 'T'   Y := ALPHA*A'*X + BETA*Y.
!
!              TRANS = 'C' OR 'C'   Y := ALPHA*A'*X + BETA*Y.
!
!           UNCHANGED ON EXIT.
!
!  M      - INTEGER.
!           ON ENTRY, M SPECIFIES THE NUMBER OF ROWS OF THE MATRIX A.
!           M MUST BE AT LEAST ZERO.
!           UNCHANGED ON EXIT.
!
!  N      - INTEGER.
!           ON ENTRY, N SPECIFIES THE NUMBER OF COLUMNS OF THE MATRIX A.
!           N MUST BE AT LEAST ZERO.
!           UNCHANGED ON EXIT.
!
!  ALPHA  - DOUBLE PRECISION.
!           ON ENTRY, ALPHA SPECIFIES THE SCALAR ALPHA.
!           UNCHANGED ON EXIT.
!
!  A      - DOUBLE PRECISION ARRAY OF DIMENSION ( LDA, N ).
!           BEFORE ENTRY, THE LEADING M BY N PART OF THE ARRAY A MUST
!           CONTAIN THE MATRIX OF COEFFICIENTS.
!           UNCHANGED ON EXIT.
!
!  LDA    - INTEGER.
!           ON ENTRY, LDA SPECIFIES THE FIRST DIMENSION OF A AS DECLARED
!           IN THE CALLING (SUB) PROGRAM. LDA MUST BE AT LEAST
!           MAX( 1, M ).
!           UNCHANGED ON EXIT.
!
!  X      - DOUBLE PRECISION ARRAY OF DIMENSION AT LEAST
!           ( 1 + ( N - 1 )*ABS( INCX ) ) WHEN TRANS = 'N' OR 'N'
!           AND AT LEAST
!           ( 1 + ( M - 1 )*ABS( INCX ) ) OTHERWISE.
!           BEFORE ENTRY, THE INCREMENTED ARRAY X MUST CONTAIN THE
!           VECTOR X.
!           UNCHANGED ON EXIT.
!
!  INCX   - INTEGER.
!           ON ENTRY, INCX SPECIFIES THE INCREMENT FOR THE ELEMENTS OF
!           X. INCX MUST NOT BE ZERO.
!           UNCHANGED ON EXIT.
!
!  BETA   - DOUBLE PRECISION.
!           ON ENTRY, BETA SPECIFIES THE SCALAR BETA. WHEN BETA IS
!           SUPPLIED AS ZERO THEN Y NEED NOT BE SET ON INPUT.
!           UNCHANGED ON EXIT.
!
!  Y      - DOUBLE PRECISION ARRAY OF DIMENSION AT LEAST
!           ( 1 + ( M - 1 )*ABS( INCY ) ) WHEN TRANS = 'N' OR 'N'
!           AND AT LEAST
!           ( 1 + ( N - 1 )*ABS( INCY ) ) OTHERWISE.
!           BEFORE ENTRY WITH BETA NON-ZERO, THE INCREMENTED ARRAY Y
!           MUST CONTAIN THE VECTOR Y. ON EXIT, Y IS OVERWRITTEN BY THE
!           UPDATED VECTOR Y.
!
!  INCY   - INTEGER.
!           ON ENTRY, INCY SPECIFIES THE INCREMENT FOR THE ELEMENTS OF
!           Y. INCY MUST NOT BE ZERO.
!           UNCHANGED ON EXIT.
!
!
!  LEVEL 2 BLAS ROUTINE.
!
!  -- WRITTEN ON 22-OCTOBER-1986.
!     JACK DONGARRA, ARGONNE NATIONAL LAB.
!     JEREMY DU CROZ, NAG CENTRAL OFFICE.
!     SVEN HAMMARLING, NAG CENTRAL OFFICE.
!     RICHARD HANSON, SANDIA NATIONAL LABS.
!
!
!     .. PARAMETERS ..
!     .. LOCAL SCALARS ..
!     .. EXTERNAL FUNCTIONS ..
!     .. EXTERNAL SUBROUTINES ..
!     .. INTRINSIC FUNCTIONS ..
!     ..
!     .. EXECUTABLE STATEMENTS ..
!
!     TEST THE INPUT PARAMETERS.
!
      info = 0 
      if (.not.lsame(trans,'N') .and. .not.lsame(trans,'T') .and. .not.lsame(&
        trans,'C')) then 
        info = 1 
      else if (m < 0) then 
        info = 2 
      else if (n < 0) then 
        info = 3 
      else if (lda < max(1,m)) then 
        info = 6 
      else if (incx == 0) then 
        info = 8 
      else if (incy == 0) then 
        info = 11 
      endif 
      if (info /= 0) then 
        call xerbla ('DGEMV ', info) 
        return  
      endif 
!
!     QUICK RETURN IF POSSIBLE.
!
      if (m==0 .or. n==0 .or. Abs(alpha) < 1.d-20 .and. Abs(beta - 1.d0) < 1.d-20) return  
!
!     SET  LENX  AND  LENY, THE LENGTHS OF THE VECTORS X AND Y, AND SET
!     UP THE START POINTS IN  X  AND  Y.
!
      if (lsame(trans,'N')) then 
        lenx = n 
        leny = m 
      else 
        lenx = m 
        leny = n 
      endif 
      if (incx > 0) then 
        kx = 1 
      else 
        kx = 1 - (lenx - 1)*incx 
      endif 
      if (incy > 0) then 
        ky = 1 
      else 
        ky = 1 - (leny - 1)*incy 
      endif 
!
!     START THE OPERATIONS. IN THIS VERSION THE ELEMENTS OF A ARE
!     ACCESSED SEQUENTIALLY WITH ONE PASS THROUGH A.
!
!     FIRST FORM  Y := BETA*Y.
!
      if (Abs(beta - 1.d0) > 1.d-20) then 
        if (incy == 1) then 
          if (beta == zero) then 
            y(:leny) = zero 
          else 
            y(:leny) = beta*y(:leny) 
          endif 
        else 
          iy = ky 
          if (Abs(beta) < 1.d-20) then 
            y(iy:(leny-1)*incy+iy:incy) = zero 
          else 
            y(iy:(leny-1)*incy+iy:incy) = beta*y(iy:(leny-1)*incy+iy:incy) 
          endif 
        endif 
      endif 
      if (Abs(alpha) < 1.d-20) return  
      if (lsame(trans,'N')) then 
!
!        FORM  Y := ALPHA*A*X + Y.
!
        jx = kx 
        if (incy == 1) then 
          do j = 1, n 
            if (x(jx) /= zero) then 
              temp = alpha*x(jx) 
              y(:m) = y(:m) + temp*a(:m,j) 
            endif 
            jx = jx + incx 
          end do 
        else 
          do j = 1, n 
            if (x(jx) /= zero) then 
              temp = alpha*x(jx) 
              iy = ky 
              y(iy:(m-1)*incy+iy:incy) = y(iy:(m-1)*incy+iy:incy) + temp*a(:m,j&
                ) 
            endif 
            jx = jx + incx 
          end do 
        endif 
      else 
!
!        FORM  Y := ALPHA*A'*X + Y.
!
        jy = ky 
        if (incx == 1) then 
          do j = 1, n 
            temp = zero 
            temp = temp + sum(a(:m,j)*x(:m)) 
            y(jy) = y(jy) + alpha*temp 
            jy = jy + incy 
          end do 
        else 
          do j = 1, n 
            temp = zero 
            ix = kx 
            temp = temp + sum(a(:m,j)*x(ix:(m-1)*incx+ix:incx)) 
            y(jy) = y(jy) + alpha*temp 
            jy = jy + incy 
          end do 
        endif 
      endif 
!
      return  
!
!     END OF DGEMV .
!
      end subroutine dgemv 


      subroutine dger(m, n, alpha, x, incx, y, incy, a, lda) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  22:48:56  03/08/06  
!...Switches: -rl INDDO=2 INDIF=2 
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: m 
      integer , intent(in) :: n 
      integer , intent(in) :: incx 
      integer , intent(in) :: incy 
      integer , intent(in) :: lda 
      real(double) , intent(in) :: alpha 
      real(double) , intent(in) :: x(*) 
      real(double) , intent(in) :: y(*) 
      real(double) , intent(inout) :: a(lda,*) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      real(double), parameter :: zero = 0.0D+0 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: info, ix, j, jy, kx 
      real(double) :: temp 
!-----------------------------------------------
!   I n t r i n s i c  F u n c t i o n s
!-----------------------------------------------
      INTRINSIC max 
!-----------------------------------------------
!     .. SCALAR ARGUMENTS ..
!     .. ARRAY ARGUMENTS ..
!     ..
!
!  PURPOSE
!  =======
!
!  DGER   PERFORMS THE RANK 1 OPERATION
!
!     A := ALPHA*X*Y' + A,
!
!  WHERE ALPHA IS A SCALAR, X IS AN M ELEMENT VECTOR, Y IS AN N ELEMENT
!  VECTOR AND A IS AN M BY N MATRIX.
!
!  PARAMETERS
!  ==========
!
!  M      - INTEGER.
!           ON ENTRY, M SPECIFIES THE NUMBER OF ROWS OF THE MATRIX A.
!           M MUST BE AT LEAST ZERO.
!           UNCHANGED ON EXIT.
!
!  N      - INTEGER.
!           ON ENTRY, N SPECIFIES THE NUMBER OF COLUMNS OF THE MATRIX A.
!           N MUST BE AT LEAST ZERO.
!           UNCHANGED ON EXIT.
!
!  ALPHA  - DOUBLE PRECISION.
!           ON ENTRY, ALPHA SPECIFIES THE SCALAR ALPHA.
!           UNCHANGED ON EXIT.
!
!  X      - DOUBLE PRECISION ARRAY OF DIMENSION AT LEAST
!           ( 1 + ( M - 1 )*ABS( INCX ) ).
!           BEFORE ENTRY, THE INCREMENTED ARRAY X MUST CONTAIN THE M
!           ELEMENT VECTOR X.
!           UNCHANGED ON EXIT.
!
!  INCX   - INTEGER.
!           ON ENTRY, INCX SPECIFIES THE INCREMENT FOR THE ELEMENTS OF
!           X. INCX MUST NOT BE ZERO.
!           UNCHANGED ON EXIT.
!
!  Y      - DOUBLE PRECISION ARRAY OF DIMENSION AT LEAST
!           ( 1 + ( N - 1 )*ABS( INCY ) ).
!           BEFORE ENTRY, THE INCREMENTED ARRAY Y MUST CONTAIN THE N
!           ELEMENT VECTOR Y.
!           UNCHANGED ON EXIT.
!
!  INCY   - INTEGER.
!           ON ENTRY, INCY SPECIFIES THE INCREMENT FOR THE ELEMENTS OF
!           Y. INCY MUST NOT BE ZERO.
!           UNCHANGED ON EXIT.
!
!  A      - DOUBLE PRECISION ARRAY OF DIMENSION ( LDA, N ).
!           BEFORE ENTRY, THE LEADING M BY N PART OF THE ARRAY A MUST
!           CONTAIN THE MATRIX OF COEFFICIENTS. ON EXIT, A IS
!           OVERWRITTEN BY THE UPDATED MATRIX.
!
!  LDA    - INTEGER.
!           ON ENTRY, LDA SPECIFIES THE FIRST DIMENSION OF A AS DECLARED
!           IN THE CALLING (SUB) PROGRAM. LDA MUST BE AT LEAST
!           MAX( 1, M ).
!           UNCHANGED ON EXIT.
!
!
!  LEVEL 2 BLAS ROUTINE.
!
!  -- WRITTEN ON 22-OCTOBER-1986.
!     JACK DONGARRA, ARGONNE NATIONAL LAB.
!     JEREMY DU CROZ, NAG CENTRAL OFFICE.
!     SVEN HAMMARLING, NAG CENTRAL OFFICE.
!     RICHARD HANSON, SANDIA NATIONAL LABS.
!
!
!     .. PARAMETERS ..
!     .. LOCAL SCALARS ..
!     .. EXTERNAL SUBROUTINES ..
!     .. INTRINSIC FUNCTIONS ..
!     ..
!     .. EXECUTABLE STATEMENTS ..
!
!     TEST THE INPUT PARAMETERS.
!
      info = 0 
      if (m < 0) then 
        info = 1 
      else if (n < 0) then 
        info = 2 
      else if (incx == 0) then 
        info = 5 
      else if (incy == 0) then 
        info = 7 
      else if (lda < max(1,m)) then 
        info = 9 
      endif 
      if (info /= 0) then 
        call xerbla ('DGER  ', info) 
        return  
      endif 
!
!     QUICK RETURN IF POSSIBLE.
!
      if (m==0 .or. n==0 .or. alpha==zero) return  
!
!     START THE OPERATIONS. IN THIS VERSION THE ELEMENTS OF A ARE
!     ACCESSED SEQUENTIALLY WITH ONE PASS THROUGH A.
!
      if (incy > 0) then 
        jy = 1 
      else 
        jy = 1 - (n - 1)*incy 
      endif 
      if (incx == 1) then 
        do j = 1, n 
          if (y(jy) /= zero) then 
            temp = alpha*y(jy) 
            a(:m,j) = a(:m,j) + x(:m)*temp 
          endif 
          jy = jy + incy 
        end do 
      else 
        if (incx > 0) then 
          kx = 1 
        else 
          kx = 1 - (m - 1)*incx 
        endif 
        do j = 1, n 
          if (y(jy) /= zero) then 
            temp = alpha*y(jy) 
            ix = kx 
            a(:m,j) = a(:m,j) + x(ix:(m-1)*incx+ix:incx)*temp 
          endif 
          jy = jy + incy 
        end do 
      endif 
!
      return  
!
!     END OF DGER  .
!
      end subroutine dger 



      subroutine dtrmm(side, uplo, transa, diag, m, n, alpha, a, lda, b, ldb) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  22:48:56  03/08/06  
!...Switches: -rl INDDO=2 INDIF=2 
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: m 
      integer , intent(in) :: n 
      integer , intent(in) :: lda 
      integer , intent(in) :: ldb 
      real(double) , intent(in) :: alpha 
      character  :: side*(*) 
      character  :: uplo*(*) 
      character  :: transa*(*) 
      character  :: diag*(*) 
      real(double) , intent(in) :: a(lda,*) 
      real(double) , intent(inout) :: b(ldb,*) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      real(double), parameter :: zero = 0.0D+0 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, info, j, k, nrowa 
      real(double) :: temp 
      logical :: lside, nounit, upper 
!-----------------------------------------------
!   I n t r i n s i c  F u n c t i o n s
!-----------------------------------------------
      INTRINSIC max 
!-----------------------------------------------
!     .. SCALAR ARGUMENTS ..
!     .. ARRAY ARGUMENTS ..
!     ..
!
!  PURPOSE
!  =======
!
!  DTRMM  PERFORMS ONE OF THE MATRIX-MATRIX OPERATIONS
!
!     B := ALPHA*OP( A )*B,   OR   B := ALPHA*B*OP( A ),
!
!  WHERE  ALPHA  IS A SCALAR,  B  IS AN M BY N MATRIX,  A  IS A UNIT, OR
!  NON-UNIT,  UPPER OR LOWER TRIANGULAR MATRIX  AND  OP( A )  IS ONE  OF
!
!     OP( A ) = A   OR   OP( A ) = A'.
!
!  PARAMETERS
!  ==========
!
!  SIDE   - CHARACTER*1.
!           ON ENTRY,  SIDE SPECIFIES WHETHER  OP( A ) MULTIPLIES B FROM
!           THE LEFT OR RIGHT AS FOLLOWS:
!
!              SIDE = 'L' OR 'L'   B := ALPHA*OP( A )*B.
!
!              SIDE = 'R' OR 'R'   B := ALPHA*B*OP( A ).
!
!           UNCHANGED ON EXIT.
!
!  UPLO   - CHARACTER*1.
!           ON ENTRY, UPLO SPECIFIES WHETHER THE MATRIX A IS AN UPPER OR
!           LOWER TRIANGULAR MATRIX AS FOLLOWS:
!
!              UPLO = 'U' OR 'U'   A IS AN UPPER TRIANGULAR MATRIX.
!
!              UPLO = 'L' OR 'L'   A IS A LOWER TRIANGULAR MATRIX.
!
!           UNCHANGED ON EXIT.
!
!  TRANSA - CHARACTER*1.
!           ON ENTRY, TRANSA SPECIFIES THE FORM OF OP( A ) TO BE USED IN
!           THE MATRIX MULTIPLICATION AS FOLLOWS:
!
!              TRANSA = 'N' OR 'N'   OP( A ) = A.
!
!              TRANSA = 'T' OR 'T'   OP( A ) = A'.
!
!              TRANSA = 'C' OR 'C'   OP( A ) = A'.
!
!           UNCHANGED ON EXIT.
!
!  DIAG   - CHARACTER*1.
!           ON ENTRY, DIAG SPECIFIES WHETHER OR NOT A IS UNIT TRIANGULAR
!           AS FOLLOWS:
!
!              DIAG = 'U' OR 'U'   A IS ASSUMED TO BE UNIT TRIANGULAR.
!
!              DIAG = 'N' OR 'N'   A IS NOT ASSUMED TO BE UNIT
!                                  TRIANGULAR.
!
!           UNCHANGED ON EXIT.
!
!  M      - INTEGER.
!           ON ENTRY, M SPECIFIES THE NUMBER OF ROWS OF B. M MUST BE AT
!           LEAST ZERO.
!           UNCHANGED ON EXIT.
!
!  N      - INTEGER.
!           ON ENTRY, N SPECIFIES THE NUMBER OF COLUMNS OF B.  N MUST BE
!           AT LEAST ZERO.
!           UNCHANGED ON EXIT.
!
!  ALPHA  - DOUBLE PRECISION.
!           ON ENTRY,  ALPHA SPECIFIES THE SCALAR  ALPHA. WHEN  ALPHA IS
!           ZERO THEN  A IS NOT REFERENCED AND  B NEED NOT BE SET BEFORE
!           ENTRY.
!           UNCHANGED ON EXIT.
!
!  A      - DOUBLE PRECISION ARRAY OF DIMENSION ( LDA, K ), WHERE K IS M
!           WHEN  SIDE = 'L' OR 'L'  AND IS  N  WHEN  SIDE = 'R' OR 'R'.
!           BEFORE ENTRY  WITH  UPLO = 'U' OR 'U',  THE  LEADING  K BY K
!           UPPER TRIANGULAR PART OF THE ARRAY  A MUST CONTAIN THE UPPER
!           TRIANGULAR MATRIX  AND THE STRICTLY LOWER TRIANGULAR PART OF
!           A IS NOT REFERENCED.
!           BEFORE ENTRY  WITH  UPLO = 'L' OR 'L',  THE  LEADING  K BY K
!           LOWER TRIANGULAR PART OF THE ARRAY  A MUST CONTAIN THE LOWER
!           TRIANGULAR MATRIX  AND THE STRICTLY UPPER TRIANGULAR PART OF
!           A IS NOT REFERENCED.
!           NOTE THAT WHEN  DIAG = 'U' OR 'U',  THE DIAGONAL ELEMENTS OF
!           A  ARE NOT REFERENCED EITHER,  BUT ARE ASSUMED TO BE  UNITY.
!           UNCHANGED ON EXIT.
!
!  LDA    - INTEGER.
!           ON ENTRY, LDA SPECIFIES THE FIRST DIMENSION OF A AS DECLARED
!           IN THE CALLING (SUB) PROGRAM.  WHEN  SIDE = 'L' OR 'L'  THEN
!           LDA  MUST BE AT LEAST  MAX( 1, M ),  WHEN  SIDE = 'R' OR 'R'
!           THEN LDA MUST BE AT LEAST MAX( 1, N ).
!           UNCHANGED ON EXIT.
!
!  B      - DOUBLE PRECISION ARRAY OF DIMENSION ( LDB, N ).
!           BEFORE ENTRY,  THE LEADING  M BY N PART OF THE ARRAY  B MUST
!           CONTAIN THE MATRIX  B,  AND  ON EXIT  IS OVERWRITTEN  BY THE
!           TRANSFORMED MATRIX.
!
!  LDB    - INTEGER.
!           ON ENTRY, LDB SPECIFIES THE FIRST DIMENSION OF B AS DECLARED
!           IN  THE  CALLING  (SUB)  PROGRAM.   LDB  MUST  BE  AT  LEAST
!           MAX( 1, M ).
!           UNCHANGED ON EXIT.
!
!
!  LEVEL 3 BLAS ROUTINE.
!
!  -- WRITTEN ON 8-FEBRUARY-1989.
!     JACK DONGARRA, ARGONNE NATIONAL LABORATORY.
!     IAIN DUFF, AERE HARWELL.
!     JEREMY DU CROZ, NUMERICAL ALGORITHMS GROUP LTD.
!     SVEN HAMMARLING, NUMERICAL ALGORITHMS GROUP LTD.
!
!
!     .. EXTERNAL FUNCTIONS ..
!     .. EXTERNAL SUBROUTINES ..
!        EXTERNAL           XRBLA
!     .. INTRINSIC FUNCTIONS ..
!     .. LOCAL SCALARS ..
!     .. PARAMETERS ..
!     ..
!     .. EXECUTABLE STATEMENTS ..
!
!     TEST THE INPUT PARAMETERS.
!
      lside = lsame(side,'L') 
      if (lside) then 
        nrowa = m 
      else 
        nrowa = n 
      endif 
      nounit = lsame(diag,'N') 
      upper = lsame(uplo,'U') 
!
      info = 0 
      if (.not.lside .and. .not.lsame(side,'R')) then 
        info = 1 
      else if (.not.upper .and. .not.lsame(uplo,'L')) then 
        info = 2 
      else if (.not.lsame(transa,'N') .and. .not.lsame(transa,'T') .and. .not.&
          lsame(transa,'C')) then 
        info = 3 
      else if (.not.lsame(diag,'U') .and. .not.lsame(diag,'N')) then 
        info = 4 
      else if (m < 0) then 
        info = 5 
      else if (n < 0) then 
        info = 6 
      else if (lda < max(1,nrowa)) then 
        info = 9 
      else if (ldb < max(1,m)) then 
        info = 11 
      endif 
      if (info /= 0) then 
        call xerbla ('DTRMM ', info) 
        return  
      endif 
!
!     QUICK RETURN IF POSSIBLE.
!
      if (n == 0) return  
!
!     AND WHEN  ALPHA.EQ.ZERO.
!
      if (alpha == zero) then 
        b(:m,:n) = zero 
        return  
      endif 
!
!     START THE OPERATIONS.
!
      if (lside) then 
        if (lsame(transa,'N')) then 
!
!           FORM  B := ALPHA*A*B.
!
          if (upper) then 
            do j = 1, n 
              do k = 1, m 
                if (b(k,j) == zero) cycle  
                temp = alpha*b(k,j) 
                b(:k-1,j) = b(:k-1,j) + temp*a(:k-1,k) 
                if (nounit) temp = temp*a(k,k) 
                b(k,j) = temp 
              end do 
            end do 
          else 
            do j = 1, n 
              do k = m, 1, -1 
                if (b(k,j) == zero) cycle  
                temp = alpha*b(k,j) 
                b(k,j) = temp 
                if (nounit) b(k,j) = b(k,j)*a(k,k) 
                b(k+1:m,j) = b(k+1:m,j) + temp*a(k+1:m,k) 
              end do 
            end do 
          endif 
        else 
!
!           FORM  B := ALPHA*B*A'.
!
          if (upper) then 
            do j = 1, n 
              do i = m, 1, -1 
                temp = b(i,j) 
                if (nounit) temp = temp*a(i,i) 
                temp = temp + sum(a(:i-1,i)*b(:i-1,j)) 
                b(i,j) = alpha*temp 
              end do 
            end do 
          else 
            do j = 1, n 
              do i = 1, m 
                temp = b(i,j) 
                if (nounit) temp = temp*a(i,i) 
                temp = temp + sum(a(i+1:m,i)*b(i+1:m,j)) 
                b(i,j) = alpha*temp 
              end do 
            end do 
          endif 
        endif 
      else 
        if (lsame(transa,'N')) then 
!
!           FORM  B := ALPHA*B*A.
!
          if (upper) then 
            do j = n, 1, -1 
              temp = alpha 
              if (nounit) temp = temp*a(j,j) 
              b(:m,j) = temp*b(:m,j) 
              do k = 1, j - 1 
                if (a(k,j) == zero) cycle  
                temp = alpha*a(k,j) 
                b(:m,j) = b(:m,j) + temp*b(:m,k) 
              end do 
            end do 
          else 
            do j = 1, n 
              temp = alpha 
              if (nounit) temp = temp*a(j,j) 
              b(:m,j) = temp*b(:m,j) 
              do k = j + 1, n 
                if (a(k,j) == zero) cycle  
                temp = alpha*a(k,j) 
                b(:m,j) = b(:m,j) + temp*b(:m,k) 
              end do 
            end do 
          endif 
        else 
!
!           FORM  B := ALPHA*B*A'.
!
          if (upper) then 
            do k = 1, n 
              do j = 1, k - 1 
                if (a(j,k) == zero) cycle  
                temp = alpha*a(j,k) 
                b(:m,j) = b(:m,j) + temp*b(:m,k) 
              end do 
              temp = alpha 
              if (nounit) temp = temp*a(k,k) 
              if (Abs(temp - 1.d0) < 1.d-20) cycle  
              b(:m,k) = temp*b(:m,k) 
            end do 
          else 
            do k = n, 1, -1 
              do j = k + 1, n 
                if (a(j,k) == zero) cycle  
                temp = alpha*a(j,k) 
                b(:m,j) = b(:m,j) + temp*b(:m,k) 
              end do 
              temp = alpha 
              if (nounit) temp = temp*a(k,k) 
              if (Abs(temp - 1.d0) < 1.d-20) cycle  
              b(:m,k) = temp*b(:m,k) 
            end do 
          endif 
        endif 
      endif 
!
      return  
!
!     END OF DTRMM .
!
      end subroutine dtrmm 

      

      subroutine dtrti2(uplo, diag, n, a, lda, info) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  20:49:17  01/01/08  
!...Switches: -rl INDDO=2 INDIF=2 
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n 
      integer  :: lda 
      integer , intent(out) :: info 
      character  :: uplo 
      character  :: diag 
      real(double)  :: a(lda,*) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      real(double), parameter :: one = 1.0D+0 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: j 
      real(double) :: ajj 
      logical :: nounit, upper 
!-----------------------------------------------
!   I n t r i n s i c  F u n c t i o n s
!-----------------------------------------------
      INTRINSIC max 
!-----------------------------------------------
!
!  -- LAPACK routine (version 3.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     February 29, 1992
!
!     .. Scalar Arguments ..
!     ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DTRTI2 computes the inverse of a real upper or lower triangular
!  matrix.
!
!  This is the Level 2 BLAS version of the algorithm.
!
!  Arguments
!  =========
!
!  UPLO    (input) CHARACTER*1
!          Specifies whether the matrix A is upper or lower triangular.
!          = 'U':  Upper triangular
!          = 'L':  Lower triangular
!
!  DIAG    (input) CHARACTER*1
!          Specifies whether or not the matrix A is unit triangular.
!          = 'N':  Non-unit triangular
!          = 'U':  Unit triangular
!
!  N       (input) INTEGER
!          The order of the matrix A.  N >= 0.
!
!  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
!          On entry, the triangular matrix A.  If UPLO = 'U', the
!          leading n by n upper triangular part of the array A contains
!          the upper triangular matrix, and the strictly lower
!          triangular part of A is not referenced.  If UPLO = 'L', the
!          leading n by n lower triangular part of the array A contains
!          the lower triangular matrix, and the strictly upper
!          triangular part of A is not referenced.  If DIAG = 'U', the
!          diagonal elements of A are also not referenced and are
!          assumed to be 1.
!
!          On exit, the (triangular) inverse of the original matrix, in
!          the same storage format.
!
!  LDA     (input) INTEGER
!          The leading dimension of the array A.  LDA >= max(1,N).
!
!  INFO    (output) INTEGER
!          = 0: successful exit
!          < 0: if INFO = -k, the k-th argument had an illegal value
!
!  =====================================================================
!
!     .. Parameters ..
!     ..
!     .. Local Scalars ..
!     ..
!     .. External Functions ..
!     ..
!     .. External Subroutines ..
!     ..
!     .. Intrinsic Functions ..
!     ..
!     .. Executable Statements ..
!
!     Test the input parameters.
!
      info = 0 
      upper = lsame(uplo,'U') 
      nounit = lsame(diag,'N') 
      if (.not.upper .and. .not.lsame(uplo,'L')) then 
        info = -1 
      else if (.not.nounit .and. .not.lsame(diag,'U')) then 
        info = -2 
      else if (n < 0) then 
        info = -3 
      else if (lda < max(1,n)) then 
        info = -5 
      endif 
      if (info /= 0) then 
        call xerbla ('DTRTI2', (-info)) 
        return  
      endif 
!
      if (upper) then 
!
!        Compute inverse of upper triangular matrix.
!
        do j = 1, n 
          if (nounit) then 
            a(j,j) = one/a(j,j) 
            ajj = -a(j,j) 
          else 
            ajj = -one 
          endif 
!
!           Compute elements 1:j-1 of j-th column.
!
          call dtrmv ('Upper', 'No transpose', diag, j - 1, a, lda, a(1,j), 1) 
          call dscal (j - 1, ajj, a(1,j), 1) 
        end do 
      else 
!
!        Compute inverse of lower triangular matrix.
!
        do j = n, 1, -1 
          if (nounit) then 
            a(j,j) = one/a(j,j) 
            ajj = -a(j,j) 
          else 
            ajj = -one 
          endif 
          if (j >= n) cycle  
!
!              Compute elements j+1:n of j-th column.
!
          call dtrmv ('Lower', 'No transpose', diag, n - j, a(j+1,j+1), lda, a(&
            j+1,j), 1) 
          call dscal (n - j, ajj, a(j+1,j), 1) 
        end do 
      endif 
!
      return  
!
!     End of DTRTI2
!
      end subroutine dtrti2 



      subroutine dtrmv(uplo, trans, diag, n, a, lda, x, incx) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  22:48:56  03/08/06  
!...Switches: -rl INDDO=2 INDIF=2 
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n 
      integer , intent(in) :: lda 
      integer , intent(in) :: incx 
      character  :: uplo*(*) 
      character  :: trans*(*) 
      character  :: diag*(*) 
      real(double) , intent(in) :: a(lda,*) 
      real(double) , intent(inout) :: x(*) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      real(double), parameter :: zero = 0.0D+0 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: info, ix, j, jx, kx 
      real(double) :: temp 
      logical :: nounit 
!-----------------------------------------------
!   I n t r i n s i c  F u n c t i o n s
!-----------------------------------------------
      INTRINSIC max 
!-----------------------------------------------
!     .. SCALAR ARGUMENTS ..
!     .. ARRAY ARGUMENTS ..
!     ..
!
!  PURPOSE
!  =======
!
!  DTRMV  PERFORMS ONE OF THE MATRIX-VECTOR OPERATIONS
!
!     X := A*X,   OR   X := A'*X,
!
!  WHERE X IS AN N ELEMENT VECTOR AND  A IS AN N BY N UNIT, OR NON-UNIT,
!  UPPER OR LOWER TRIANGULAR MATRIX.
!
!  PARAMETERS
!  ==========
!
!  UPLO   - CHARACTER*1.
!           ON ENTRY, UPLO SPECIFIES WHETHER THE MATRIX IS AN UPPER OR
!           LOWER TRIANGULAR MATRIX AS FOLLOWS:
!
!              UPLO = 'U' OR 'U'   A IS AN UPPER TRIANGULAR MATRIX.
!
!              UPLO = 'L' OR 'L'   A IS A LOWER TRIANGULAR MATRIX.
!
!           UNCHANGED ON EXIT.
!
!  TRANS  - CHARACTER*1.
!           ON ENTRY, TRANS SPECIFIES THE OPERATION TO BE PERFORMED AS
!           FOLLOWS:
!
!              TRANS = 'N' OR 'N'   X := A*X.
!
!              TRANS = 'T' OR 'T'   X := A'*X.
!
!              TRANS = 'C' OR 'C'   X := A'*X.
!
!           UNCHANGED ON EXIT.
!
!  DIAG   - CHARACTER*1.
!           ON ENTRY, DIAG SPECIFIES WHETHER OR NOT A IS UNIT
!           TRIANGULAR AS FOLLOWS:
!
!              DIAG = 'U' OR 'U'   A IS ASSUMED TO BE UNIT TRIANGULAR.
!
!              DIAG = 'N' OR 'N'   A IS NOT ASSUMED TO BE UNIT
!                                  TRIANGULAR.
!
!           UNCHANGED ON EXIT.
!
!  N      - INTEGER.
!           ON ENTRY, N SPECIFIES THE ORDER OF THE MATRIX A.
!           N MUST BE AT LEAST ZERO.
!           UNCHANGED ON EXIT.
!
!  A      - DOUBLE PRECISION ARRAY OF DIMENSION ( LDA, N ).
!           BEFORE ENTRY WITH  UPLO = 'U' OR 'U', THE LEADING N BY N
!           UPPER TRIANGULAR PART OF THE ARRAY A MUST CONTAIN THE UPPER
!           TRIANGULAR MATRIX AND THE STRICTLY LOWER TRIANGULAR PART OF
!           A IS NOT REFERENCED.
!           BEFORE ENTRY WITH UPLO = 'L' OR 'L', THE LEADING N BY N
!           LOWER TRIANGULAR PART OF THE ARRAY A MUST CONTAIN THE LOWER
!           TRIANGULAR MATRIX AND THE STRICTLY UPPER TRIANGULAR PART OF
!           A IS NOT REFERENCED.
!           NOTE THAT WHEN  DIAG = 'U' OR 'U', THE DIAGONAL ELEMENTS OF
!           A ARE NOT REFERENCED EITHER, BUT ARE ASSUMED TO BE UNITY.
!           UNCHANGED ON EXIT.
!
!  LDA    - INTEGER.
!           ON ENTRY, LDA SPECIFIES THE FIRST DIMENSION OF A AS DECLARED
!           IN THE CALLING (SUB) PROGRAM. LDA MUST BE AT LEAST
!           MAX( 1, N ).
!           UNCHANGED ON EXIT.
!
!  X      - DOUBLE PRECISION ARRAY OF DIMENSION AT LEAST
!           ( 1 + ( N - 1 )*ABS( INCX ) ).
!           BEFORE ENTRY, THE INCREMENTED ARRAY X MUST CONTAIN THE N
!           ELEMENT VECTOR X. ON EXIT, X IS OVERWRITTEN WITH THE
!           TRANFORMED VECTOR X.
!
!  INCX   - INTEGER.
!           ON ENTRY, INCX SPECIFIES THE INCREMENT FOR THE ELEMENTS OF
!           X. INCX MUST NOT BE ZERO.
!           UNCHANGED ON EXIT.
!
!
!  LEVEL 2 BLAS ROUTINE.
!
!  -- WRITTEN ON 22-OCTOBER-1986.
!     JACK DONGARRA, ARGONNE NATIONAL LAB.
!     JEREMY DU CROZ, NAG CENTRAL OFFICE.
!     SVEN HAMMARLING, NAG CENTRAL OFFICE.
!     RICHARD HANSON, SANDIA NATIONAL LABS.
!
!
!     .. PARAMETERS ..
!     .. LOCAL SCALARS ..
!     .. EXTERNAL FUNCTIONS ..
!     .. EXTERNAL SUBROUTINES ..
!     .. INTRINSIC FUNCTIONS ..
!     ..
!     .. EXECUTABLE STATEMENTS ..
!
!     TEST THE INPUT PARAMETERS.
!
      info = 0 
      if (.not.lsame(uplo,'U') .and. .not.lsame(uplo,'L')) then 
        info = 1 
      else if (.not.lsame(trans,'N') .and. .not.lsame(trans,'T') .and. .not.&
          lsame(trans,'C')) then 
        info = 2 
      else if (.not.lsame(diag,'U') .and. .not.lsame(diag,'N')) then 
        info = 3 
      else if (n < 0) then 
        info = 4 
      else if (lda < max(1,n)) then 
        info = 6 
      else if (incx == 0) then 
        info = 8 
      endif 
      if (info /= 0) then 
        call xerbla ('DTRMV ', info) 
        return  
      endif 
!
!     QUICK RETURN IF POSSIBLE.
!
      if (n == 0) return  
!
      nounit = lsame(diag,'N') 
!
!     SET UP THE START POINT IN X IF THE INCREMENT IS NOT UNITY. THIS
!     WILL BE  ( N - 1 )*INCX  TOO SMALL FOR DESCENDING LOOPS.
!
      if (incx <= 0) then 
        kx = 1 - (n - 1)*incx 
      else if (incx /= 1) then 
        kx = 1 
      endif 
!
!     START THE OPERATIONS. IN THIS VERSION THE ELEMENTS OF A ARE
!     ACCESSED SEQUENTIALLY WITH ONE PASS THROUGH A.
!
      if (lsame(trans,'N')) then 
!
!        FORM  X := A*X.
!
        if (lsame(uplo,'U')) then 
          if (incx == 1) then 
            do j = 1, n 
              if (x(j) == zero) cycle  
              temp = x(j) 
              x(:j-1) = x(:j-1) + temp*a(:j-1,j) 
              if (.not.nounit) cycle  
              x(j) = x(j)*a(j,j) 
            end do 
          else 
            jx = kx 
            do j = 1, n 
              if (x(jx) /= zero) then 
                temp = x(jx) 
                ix = kx 
                x(ix:(j-2)*incx+ix:incx) = x(ix:(j-2)*incx+ix:incx) + temp*a(:j&
                  -1,j) 
                if (nounit) x(jx) = x(jx)*a(j,j) 
              endif 
              jx = jx + incx 
            end do 
          endif 
        else 
          if (incx == 1) then 
            do j = n, 1, -1 
              if (x(j) == zero) cycle  
              temp = x(j) 
              x(n:1+j:(-1)) = x(n:1+j:(-1)) + temp*a(n:1+j:(-1),j) 
              if (.not.nounit) cycle  
              x(j) = x(j)*a(j,j) 
            end do 
          else 
            kx = kx + (n - 1)*incx 
            jx = kx 
            do j = n, 1, -1 
              if (x(jx) /= zero) then 
                temp = x(jx) 
                ix = kx 
                x(ix:incx*(j-n+1)+ix:(-incx)) = x(ix:incx*(j-n+1)+ix:(-incx))&
                   + temp*a(n:1+j:(-1),j) 
                if (nounit) x(jx) = x(jx)*a(j,j) 
              endif 
              jx = jx - incx 
            end do 
          endif 
        endif 
      else 
!
!        FORM  X := A'*X.
!
        if (lsame(uplo,'U')) then 
          if (incx == 1) then 
            do j = n, 1, -1 
              temp = x(j) 
              if (nounit) temp = temp*a(j,j) 
              temp = temp + sum(a(j-1:1:(-1),j)*x(j-1:1:(-1))) 
              x(j) = temp 
            end do 
          else 
            jx = kx + (n - 1)*incx 
            do j = n, 1, -1 
              temp = x(jx) 
              ix = jx 
              if (nounit) temp = temp*a(j,j) 
              temp = temp + sum(a(j-1:1:(-1),j)*x(ix-incx:incx*(1-j)+ix:(-incx)&
                )) 
              x(jx) = temp 
              jx = jx - incx 
            end do 
          endif 
        else 
          if (incx == 1) then 
            do j = 1, n 
              temp = x(j) 
              if (nounit) temp = temp*a(j,j) 
              temp = temp + sum(a(j+1:n,j)*x(j+1:n)) 
              x(j) = temp 
            end do 
          else 
            jx = kx 
            do j = 1, n 
              temp = x(jx) 
              ix = jx 
              if (nounit) temp = temp*a(j,j) 
              temp = temp + sum(a(j+1:n,j)*x(ix+incx:(n-j)*incx+ix:incx)) 
              x(jx) = temp 
              jx = jx + incx 
            end do 
          endif 
        endif 
      endif 
!
      return  
!
!     END OF DTRMV .
!
      end subroutine dtrmv 

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine mult33(fmat, iplace)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE symmetry_C, only : elem
!***********************************************************************
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: iplace
      double precision , intent(in) :: fmat(3,3)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j, k
      double precision, dimension(3,3) :: help
!-----------------------------------------------
!***********************************************************************
!
!   MULT33 performs a eulerian rotation on a symmetry operation.
!
!    The symmetry operation IPLACE, stored in ELEM is subjected
!    to the operation stored in FMAT.
!
!***********************************************************************
      do i = 1, 3
        do j = 1, 3
          help(i,j) = 0.D0
          do k = 1, 3
            help(i,j) = help(i,j) + sum(fmat(i,:)*fmat(j,k)*elem(:,k,iplace))
          end do
        end do
      end do
      elem(:,:,iplace) = help
      return
      end subroutine mult33

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine rapid3 (xparam, step, pvect, numvar, funct, okf, okc)
    use param_global_C, only : maxpms
    implicit none
    logical, intent (out) :: okc, okf
    integer, intent (inout) :: numvar
    double precision, intent (inout) :: funct, step
    double precision, dimension (numvar), intent (inout) :: pvect, xparam
!---------------------------------------------------------------------------
    logical :: first = .true.
    integer :: center, i, ictr, iquit, left, maxlin, right
    double precision :: aabs, alfs, alpha, beta, drop, energy, eps, estor, &
   & fin, fmax, fmin, funold, gamma, pabs, s, sqstor, ssqlst, stlast, tee, &
   & tiny, xcrit, xmaxm, xminm, xxm, ymaxst
    double precision, dimension (3) :: phi, vt, grad
    double precision, dimension (maxpms) :: xstor
    external exchng
    intrinsic Abs, Max, Min, Sign
    save :: first, drop, xmaxm, i, maxlin, xcrit, ymaxst, eps, tee, energy
!---------------------------------------------------------------------------
    if (first) then
      first = .false.
      drop = 0.002d0
      xmaxm = 0.4d0
      i = 2
      step = 1.d0
      maxlin = 15
      if (numvar == 1) maxlin = 30
      xcrit = 0.0001d0
      ymaxst = 0.4d0
      eps = 10 ** (-i)
      tee = eps
      energy = 0.d0
    end if
    xmaxm = 0.d0
    step = Max (0.d0, Min (100.d0, step))
    do i = 1, numvar
      pabs = Abs (pvect(i))
      xmaxm = Max (xmaxm, pabs)
    end do
    xminm = xmaxm
    xmaxm = ymaxst / xmaxm
    fin = funct
    ssqlst = funct
    iquit = 0
    phi(1) = funct
    vt(1) = 0.0d00
    vt(2) = step / 4.0d00
    if (vt(2) > xmaxm) then
      vt(2) = xmaxm
    end if
    fmax = funct
    fmin = funct
    step = vt(2)
    do i = 1, numvar
      xparam(i) = xparam(i) + step * pvect(i)
    end do
    call rapid2 (xparam, funct, grad, .false.)
    phi(2) = funct
    if (phi(2) > fmax) then
      fmax = phi(2)
    end if
    if (phi(2) < fmin) then
      fmin = phi(2)
    end if
    call exchng (phi(2), sqstor, energy, estor, xparam, xstor, step, alfs, &
   & numvar)
    if (phi(1) <= phi(2)) then
      vt(3) = -vt(2)
      left = 3
      center = 1
      right = 2
    else
      vt(3) = 2.0d00 * vt(2)
      left = 1
      center = 2
      right = 3
    end if
    stlast = vt(3)
    step = stlast - step
    do i = 1, numvar
      xparam(i) = xparam(i) + step * pvect(i)
    end do
    call rapid2 (xparam, funct, grad, .false.)
    if (funct > fmax) then
      fmax = funct
    end if
    if (funct < fmin) then
      fmin = funct
    end if
    if (funct < sqstor) then
      call exchng (funct, sqstor, energy, estor, xparam, xstor, step, alfs, &
     & numvar)
    end if
    if (funct < fin) then
      iquit = 1
    end if
    phi(3) = funct
    okc = .true.
    do ictr = 3, maxlin
      alpha = vt(2) - vt(3)
      beta = vt(3) - vt(1)
      gamma = vt(1) - vt(2)
      if (Abs (alpha*beta*gamma) <= 1.d-20) go to 1000
      alpha = - (phi(1)*alpha+phi(2)*beta+phi(3)*gamma) / (alpha*beta*gamma)
      beta = ((phi(1)-phi(2))/gamma) - alpha * (vt(1)+vt(2))
      if (alpha > 0.0d0) then
        step = -beta / (2.0d00*alpha)
        s = step - stlast
        xxm = 2.0d00 * xmaxm
        if (Abs (s) > xxm) then
          s = Sign (xxm, s) * (1.d0+0.01d0*(xxm/s))
        end if
        step = s + stlast
      else
        if (phi(right) > phi(left)) then
          step = 3.0d00 * vt(left) - 2.0d00 * vt(center)
        else
          step = 3.0d00 * vt(right) - 2.0d00 * vt(center)
        end if
        s = step - stlast
        if (Abs (s) > xmaxm) then
          s = Sign (xmaxm, s) * (1.d0+0.01d0*(xmaxm/s))
        end if
        step = s + stlast
      end if
      if (ictr > 3) then
        aabs = Abs (s*xminm)
        if (aabs < xcrit .and. ictr > 4) go to 1000
      end if
      do i = 1, numvar
        xparam(i) = xparam(i) + s * pvect(i)
      end do
      funold = funct
      call rapid2 (xparam, funct, grad, .false.)
      if (funct > fmax) then
        fmax = funct
      end if
      if (funct < fmin) then
        fmin = funct
      end if
      if (funct < sqstor) then
        call exchng (funct, sqstor, energy, estor, xparam, xstor, step, alfs, &
       & numvar)
      end if
      if (funct < fin) then
        iquit = 1
      end if
    !
    ! TEST TO EXIT FROM RAPID3 IF NOT DROPPING IN VALUE OF FUNCTION FAST.
    !
      tiny = Max ((ssqlst-fmin)*0.2d0, drop)
      tiny = Min (tiny, 0.5d0)
      if (numvar == 1) tiny = 0.01d0*tiny
      if (Abs (funold-funct) < tiny .and. iquit == 1 .and. ictr > 4) go to 1000
      if ((Abs(step-stlast) <= eps*Abs(step+stlast)+tee) .and. (iquit == 1) .and. ictr > 4) &
     & go to 1000
      stlast = step
      if ((step > vt(right)) .or. (step > vt(center) .and. funct < &
     & phi(center)) .or. (step > vt(left) .and. step < vt(center) .and. funct &
     & > phi(center))) then
        vt(left) = step
        phi(left) = funct
      else
        vt(right) = step
        phi(right) = funct
      end if
      if (vt(center) >= vt(right)) then
        i = center
        center = right
        right = i
      end if
      if (vt(left) >= vt(center)) then
        i = left
        left = center
        center = i
      end if
      if (vt(center) >= vt(right)) then
        i = center
        center = right
        right = i
      end if
    end do
    okc = .false.
1000 call exchng (sqstor, funct, estor, energy, xstor, xparam, alfs, step, &
   & numvar)
    okf = (funct < ssqlst)
    if (funct >= ssqlst) return
    if (step < 0.0d0) then
      step = -step
      do i = 1, numvar
        pvect(i) = -pvect(i)
      end do
    end if
end subroutine rapid3

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

program MOPAC_win
  USE IFQWIN
  use dfport
  implicit none
  INTEGER :: i4
  integer i, j, k, loop
  character :: ch
    call mopac_gui_deactivate
    call mopac_gui_set_channel(0)
    OPEN(0, file='user', title='MOPAC')
    i4 = setbkcolor(15)
    i4 = settextcolor(0)
    call clearscreen($GCLEARSCREEN)
#ifdef MOPAC_F2003
    i = command_argument_count()
#else
    i = iargc()
#endif
    if (i == 0) then
      write(0,*)
      write(0,*)"  MOPAC in WINDOWS: To run MOPAC within WINDOWS, see:"
      write(0,*)
      write(0,*)"  http://OpenMOPAC.net/manual/Running_MOPAC.html"
      write(0,*)
      write(0,*)
      write(0,*)
      i = 0
      stop
    end if
    call run_mopac()  ! the user has supplied data sets as arguments
    i = SETEXITQQ(QWIN$EXITNOPERSIST)
  end program MOPAC_win


!+++++++++++++++++++++++++++++++++++++++++++++++++
!  InitialSettings Do not edit, unless necessary
!
LOGICAL FUNCTION InitialSettings()

USE DFLIB
USE DFNLS
implicit none
LOGICAL :: l4, result
integer(4) cp, i
  type (qwinfo) :: qwi
external :: instructions, about, shutdown

call NLSGetLocale(CODEPAGE = cp)
! This routine is called automatically when the program begins.  It sets
! up the menu structure for the program, and connects "callback" routines
! with each menu item.
  qwi.x = 0
  qwi.y = 0
  qwi.w = 1000
  qwi.h = 1000
  qwi.type = QWIN$SET
  i = setWSizeQQ(QWIN$FRAMEWINDOW, qwi)
   l4 = appendmenuqq(1, $MENUENABLED,   'File'C,           NUL)
   l4 = appendmenuqq(1, $MENUENABLED,   'Exit'C,           WINEXIT)

   l4 = appendmenuqq(2, $MENUENABLED,   'Edit'C,	   NUL)
   l4 = appendmenuqq(2, $MENUENABLED,   'Select Text'C,	   WINSELECTTEXT)
   l4 = appendmenuqq(2, $MENUENABLED,   'Select All'C,	   WINSELECTALL)
   l4 = appendmenuqq(2, $MENUENABLED,   'Copy'C,	   WINCOPY)
   l4 = appendmenuqq(2, $MENUENABLED,   'Paste'C,	   WINPASTE)

   l4 = appendmenuqq(3, $MENUENABLED,   'View'C,           NUL)
   l4 = appendmenuqq(3, $MENUENABLED,   'Size to Fit'C,    WINSIZETOFIT)
   l4 = appendmenuqq(3, $MENUENABLED,   'Full Screen'C,    WINFULLSCREEN)

   l4 = appendmenuqq(4, $MENUENABLED,   'State'C,          NUL)
   l4 = appendmenuqq(4, $MENUENABLED,   'Pause'C,          WINSTATE)

   l4 = appendmenuqq(5, $MENUENABLED,   'Window'C,         NUL)
   l4 = appendmenuqq(5, $MENUENABLED,   'Status Bar'C,     WINSTATUS)

   l4 = appendmenuqq(6, $MENUENABLED,   'Help'C,           NUL)
   l4 = appendmenuqq(6, $MENUENABLED,   'Instructions'C, Instructions)
   l4 = appendmenuqq(6, $MENUENABLED,   'About'C,               About)

   l4 = appendmenuqq(7, $MENUENABLED,   'Shutdown'C,         NUL)
   l4 = appendmenuqq(7, $MENUENABLED,   'Shutdown'C,         Shutdown)


InitialSettings = l4

return
  end

  subroutine Instructions(checked)
      USE DFLIB
      USE DFNLS
      logical :: checked, lstatus
      integer :: i4
      lstatus = checked
      i4 = messageboxqq('                    Instructions for running MOPAC for WINDOWS in screen modes\r\r &
      & MOPAC for WINDOWS runs MOPAC in screen and command-prompt modes.\r &
      & These instructions apply to the screen mode only.\r\r &
      & "Drag and Drop" mode:\r &
      & Locate the data set to be run, and drag it to the MOPAC for WINDOWS icon.\r\r &
      & The data set will be run, and the results placed in the folder &
      & where the data set came from.\r\r &
      & "Open with" mode:\r &
      & Within Windows Explorer, locate the file to be run\r &
      & Right-click the file, and use "Open with" -> "mopac.exe"\r\r &
      & If, at that point,  you can''t see "mopac.exe" then:\r &
      & Use "Choose program" -> "Browse" then navigate to the file "mopac.exe".\r &
      & Highlight it, then click on "Open".\r &
      & 'C,'MOPAC Instructions'C, MB$OK)
      return
end
subroutine About(checked)
      USE DFLIB
      USE DFNLS
      logical :: checked, lstatus
      integer :: i4
      character(len = 20) :: verson
      call mopac_version(verson)
      lstatus = checked
      i4 = messageboxqq('   MOPAC for WINDOWS\r\r &
      & Copyright: Virginia Polytechnic Institute and State University\r\r &
      & Version '//trim(verson)//' &
      &  'C,'MOPAC Instructions'C, MB$OK)
      return
end
subroutine Shutdown(checked)
      USE DFLIB
      USE DFNLS
      use chanel_C, only: iend, end_fn
      logical :: checked
      open (unit=iend, file=end_fn, status="UNKNOWN", err=1000)
      write(iend,*)"Shut"
      close(iend)
1000  return
end

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

subroutine eimp ()
!
!   Store in the s-s location of array p the value of the Fock terms relating
!   atom A and atom B, for all pairs of atoms.  This quantity will be used by
!   the diagonalizer
!
  use molkst_C, only: numat
  use common_arrays_C, only : p, f
  use MOZYME_C, only : iorbs
  implicit none
  integer :: i, j, k, l, m
  double precision :: sum
  integer, external :: ijbo
  do i = 1, numat
    do j = 1, i - 1
      k = ijbo (i, j)
      if (k >= 0) then
        l = iorbs(i) * iorbs(j)
        if (l /= 0) then
          l = k + l
          sum = 0.d0
          do m = k + 1, l
            sum = sum + f(m) ** 2
          end do
          p(k+1) = sum
        end if
      end if
    end do
  end do
end subroutine eimp

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

program BZ 
  !***************************************************************
  !
  !   General Brillouin Zone plotting program.
  !   The main functions within BZ are:
  !
  !  1. To calculate the eigenvalue spectrum at specified points in the
  !     electronic or phonon BZ, and to determine the space-group 
  !     irreducible representations.
  !
  !  2. To plot the eigenvalue spectrum along lines within the BZ.
  !
  !  3. To plot eigenvalue surfaces within a BZ.
  !
  !***************************************************************
  use ifqwin
  use common_common, only : tvec, id, numat, phonon, ir, iw, jobnam, &
    data_set_name, units, iw_new, nfirst, nlast, per_atom, mr1, mr2, mr3, bcc, &
    keywrd, coord, ref_coord, line, sec_det, nvecs, size_x, size_y, l_read_dat
  implicit none
  integer :: i, i99, itype, j, mvecs, natot, alloc_stat, io_stat
 
  double precision, allocatable, dimension(:) :: MOPAC_sec_det
  logical :: exists, suffix = .false., is_brz = .false., is_dat = .false.
  double precision, external :: reada 
  character      :: num
  ! 
  iw = 6
#ifdef MOPAC_F2003
  i = command_argument_count()
#else
  i = iargc()
#endif
  l_read_dat = (i < 2)
  if (i == 0) then
    call graphics(0.0, 0.0, 1)
    write(iw,*)
    write(iw,*)" Program BZ generates Brillouin zones for systems with translation vectors"
    write(iw,*)
    write(iw,*)" It requires one or two arguments:"
    write(iw,*)" First argument: The name of the file containing information on the system,"
    write(iw,*)"                 this file is generated by MOPAC and its name ends in '.brz'"
    write(iw,*)
    write(iw,*)" Second argument (optional): The name of the file that contains the 'walk' in"
    write(iw,*)" 'k'-space.  This file will be generated if the 'walk' is supplied at run-time."
    write(iw,'(/5x,a)')"Press ""RETURN"" to quit"
    read (iw, "(Q,A)", end = 1100, err = 1100)i, line 
    call graphics(0.0, 0.0, 100)
    stop
  else
#ifdef MOPAC_F2003
    call get_command_argument(1, jobnam)
#else
    call getarg(1, jobnam)
#endif
    j = len_trim(jobnam) 
    if (jobnam(j - 3:j - 3) == ".") then
      suffix = .true.
      keywrd = jobnam(j - 2:)
      call upcase(keywrd(:3))
      is_brz = (keywrd(:3) == "BRZ")     
      jobnam = jobnam(:j - 4)
    end if
    if (i > 1) then
      ir = 25
#ifdef MOPAC_F2003
      call get_command_argument(2, data_set_name)
#else
      call getarg(2, data_set_name)
#endif
      i = len_trim(data_set_name) 
      if (i > 4) then
        if (data_set_name(i - 3:i - 3) == ".") then
          suffix = .true.
          keywrd = data_set_name(i - 2:)
          call upcase(keywrd(:3))
          is_dat = (keywrd(:3) == "DAT")     
          data_set_name = data_set_name(:i - 4)
        end if
      end if
      if (suffix) then
        if (is_brz .and. is_dat) then
          i99 = 0; io_stat = 0  ! Everything is okay
        else if (.not. is_brz .and. .not. is_dat) then
          i99 = 1; io_stat = 1  ! Swap names around
        else
          suffix = .false.
        end if
      end if    
      if (.not. suffix) then
!
!  Check that the data_set_name applies to the stored instruction set
!
        inquire (file=trim(jobnam)//".brz", exist = exists)
        i99 = 1
        io_stat = 1
        if (exists) then
          open (unit = 18, file = trim(jobnam)//".brz", status = "OLD", iostat = i99)
          if (i99 == 0) then
            read (18, *, iostat=io_stat)mvecs, mr1, mr2, mr3, bcc
          end if
          close (unit = 18)
        end if
      end if
      if (i99 /= 0 .or. io_stat /= 0) then
        keywrd = trim(jobnam)
        jobnam = trim(data_set_name)
        data_set_name = trim(keywrd)
      end if
    else
      ir = 6
      data_set_name = jobnam
    end if
  end if
!
! Read in (unformatted) information on the system from the <file>.brz file.
!
  inquire (file=trim(jobnam)//".brz", exist = exists)
  if (.not. exists) then
    call graphics(0.0, 0.0, 1)
    write (iw, '(/10x,a,/)') " File '"//trim(jobnam)//".brz' does not exist."
    write(iw,'(/5x,a)')"Press ""RETURN"" to quit"
    read (iw, "(Q,A)", end = 1100, err = 1100)i, line 
    call graphics(0.0, 0.0, 100)
    stop    
  end if  
  open (unit = 18, file = trim(jobnam)//".brz", status = "OLD", iostat = i99)
  if (i99 /= 0) then
    open (unit = iw_new, file = trim(data_set_name)//".txt", form = "FORMATTED", status = "UNKNOWN", iostat = i99)
    write (iw, '(/10x,a,/)') " Failed to open '"//trim(jobnam)//".brz'"
    write (iw_new, '(/10x,a,/)') " Failed to open '"//trim(jobnam)//".brz'"
    stop
  end if
!  write (iw, "(//,3A)") " Data for ", trim(jobnam), " is being read off disk"
  read (18, *, iostat=io_stat) mvecs, mr1, mr2, mr3, bcc
  mr1 = max(1, mr1)
  mr2 = max(1, mr2)
  mr3 = max(1, mr3)
  if (io_stat /= 0) then
   write (6,'(/,a)') " File exists, but the first five data could not be read."
   call sleep (60)
  end if
!
!  Create array to hold the secular determinant from MOPAC
!
  allocate (MOPAC_sec_det((mvecs*(mvecs+1))/2), stat = alloc_stat)
  if( alloc_stat /= 0 ) then
    write(iw,*)" Unable to allocate 'MOPAC_sec_det'"
    stop
  endif
  read (18, *, iostat=io_stat) MOPAC_sec_det 
  if (io_stat /= 0) then
   write (6,'(/,a)') " File exists, but the second set of data"
   write (6,'(a,i7,a)') " (the secular determinant) could not be read."
   call sleep (60)
  end if
  allocate (coord(3,2000), ref_coord(3,2000))
  read (18,*) tvec, id, numat, ((coord(j, i), j = 1, 3), i = 1, numat)
  ref_coord(:,:numat) = coord(:,:numat)
!
!  Create arrays to hold the starting and stopping addresses (from MOPAC)
!
  allocate (nfirst(numat), nlast(numat), per_atom(numat), stat = alloc_stat)
  if( alloc_stat /= 0 ) then
    write(iw,*)" Unable to allocate 'nfirst' and 'nlast'"
    stop
  endif
  read (18, *, end = 1000, err = 1000) (nfirst(i), nlast(i), i = 1, numat)
  per_atom = nlast - nfirst + 1
  phonon = (per_atom(1) == 3)
  if (phonon) then
    units = " cm^(-1)."
  else
    units = " eV."
  end if
  !
  !   Convert from MOPAC's giant unit cell to fundamental unit cell
  !
  !  mvecs = total number of vectors in the system.
  !  nvecs = number of vectors in a primitive unit cell
  !
  nvecs = (2*mvecs)/(mr1*mr2*mr3)
  if (.not. bcc) nvecs = nvecs/2
  natot = numat
  numat = numat * nvecs / mvecs
  do i = 1, 3
    tvec(i, 1) = tvec(i, 1) / mr1
    tvec(i, 2) = tvec(i, 2) / mr2
    tvec(i, 3) = tvec(i, 3) / mr3
  end do
!
!  Convert from secular determinant into small matrices representing
!  the interaction of the CUC with all cells.
!
  allocate (sec_det(nvecs,nvecs*mr1*mr2*mr3*8))
!
! All <file>.brz now read in. Read in data on what BZ has to do.
!
  call graphics(0.0, 0.0, 1)
  if (l_read_dat) then 
    call graphics(0.0, 0.0, 97)
    write (iw, "(A)") &
       & "     Do you want to calculate a point [0], ", &
       & "              or draw band-structures [1], "
    if (id /= 1) write (iw, "(A,\)") "              or draw energy surfaces [2], "
 !   write (iw, "(A)") " or do you want advice on diagnostics [3]?"
  else
    open(unit = ir, file = trim(data_set_name)//".dat", status = "OLD", iostat = i99)
    if (i99 /= 0) then
      inquire (file = trim(data_set_name)//".dat", exist = exists)
      if (exists) then
        write(iw,'(/10x,a)') " File: '"//trim(data_set_name)//".dat' exists, but cannot be opened"
      else
        write(iw,'(/10x,a)') " File: '"//trim(data_set_name)//".dat' does not exist"
      end if
      write(iw,'(/5x,a)')"Press ""RETURN"" to quit"
      read(iw,'(a)') num 
      if (num /= "{") call graphics(0.0, 0.0, 100)
      stop
    end if
!
!  Copy everything from the input file, and put it in a scratch file
!
     open(unit=99, status='SCRATCH', iostat = io_stat) 
     do
       do
         read(ir,'(a)', iostat = io_stat)line
         if (line(1:1) /= "*") exit
       end do       
       if (io_stat /= 0) exit
       write(99,'(a)')trim(line)
     end do
     close (ir)
     rewind(99)
     ir = 99
  end if  
!
! if  data-set <file>.dat supplied, then ir = 99, otherwise ir = 6
!
  read (ir, "(Q,A)", end = 1100, err = 1100)i, line 
!
! Keywords being read in, so allow room for extra data
!
  i = max(len_trim(line), 30)
  if (id /= 1) then
    line(i:) = ": Do you want to calculate a point [0], or draw band-structures [1], or draw energy surfaces [2] "
  else
    line(i:) = ": Do you want to calculate a point [0], or draw band-structures [1]"
  end if
  call write_keystrokes(line, len_trim(line))
  read(line, '(a80)') keywrd 
  call upcase(keywrd)
  if (index(keywrd," OPS")   + index(keywrd," SEC")    + index(keywrd," FRACT")  + index(keywrd," ROTSEC") + &
      index(keywrd," TRANS") + index(keywrd," SYMSEC") + index(keywrd," PRTVEC") + index(keywrd," ROTFOK") + &
      index(keywrd," VECT") + index(keywrd," SYMTRZ") /= 0) &
    open (unit = iw_new, file = trim(data_set_name)//".txt", form = "FORMATTED", status = "UNKNOWN", iostat = i99)
   call setup(MOPAC_sec_det, nvecs, sec_det)  
!
!  Rotate so that the first translation vector is along the "x" axis,
!  and, if it exists, the second translation vector is in the "x-y" plane.
!
!  Symmetrize the small matrices using information supplied by <filename>.ops
!
  size_x = 1.0
  size_y = 1.0
  i = index(keywrd, " SIZE=")
  if (i > 0) then
    size_x = real(reada(keywrd, i))
    size_y = size_x
  end if
  call orient(nvecs, sec_det, natot, coord) 
  itype = Nint (reada (keywrd, 1))
!
! Setup is now complete.  Use graphics for lines and surfaces
! data is either read in from channel 99 if a data-set <file>.dat has been supplied, of channel 6 otherwise.
!
  if (itype == 0) then
!
!  Calculate a point in "k" space, then do symmetry analysis, if symmetry data set exists
!
     call point(nvecs, sec_det)
  else if (itype == 1) then
!
!  Generate a picture of the band-structure.
!
    call make_line(nvecs, sec_det)
  else if (itype == 2) then
!
!  Generate pictures of energy surfaces.
!
    call surfac(nvecs, sec_det)
  else
    write (iw, "(A)") &
       & " Diagnostic Key-Words.  These are added after the numeric option ", &
       & " OPS:     Print the space-group symmetry operations", &
       & " SEC:     Print the Secular Determinant from MOPAC", &
       & " FRACT:   Print the Fractional Unit Cell Coordinates", &
       & " ROTSEC:  Print the Secular Determinant in crystal coordinate frame", &
       & " TRANS:   Print the transform to convert Cartesian into crystal coordinates", &
       & " SYMSEC:  Print the symmetrized Secular Determinant", " ", &
       & " For SEC, ROTSEC, and SYMSEC, an optional '=n' "// &
           & "can be added to print only the first 'n' unit cell interactions"
    write(iw,*)" Press return to exit"
    read(*,*)
    call graphics(0.0, 0.0, 100)
  end if
  stop
  1000 write (6, *) " Binary file missing or corrupt"
  1100 stop
  end program BZ
  subroutine write_keystrokes(text, len_text)
  use common_common, only : jobnam, l_read_dat
  implicit none
  integer, intent (in) :: len_text
  character, intent (in) :: text*(len_text)
!
  logical :: first = .true.
  integer :: status
  save
    if (.not. l_read_dat) return
    if (first) then
      first = .false.
      open (unit = 16, file = trim(jobnam)//".dat")
      rewind (16)
    end if
    write(16,'(a)', iostat = status) text
    return
  end subroutine write_keystrokes
  

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine diat(ni, nj, xj, di)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      use molkst_C, only : numcal
      use funcon_C, only : a0
      use overlaps_C, only : cutof1
      use parameters_C, only : natorb, zs, zp, zd, npq
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer, intent(in)  :: ni
      integer, intent(in)  :: nj
      double precision, intent(in)  :: xj(3)
      double precision, intent(out)  :: di(9,9)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: a, pq2, b, pq1
      integer , dimension(3,5) :: ival
      integer :: icalcn
      integer :: i, j, ia, ib, newk, nk1, iss, jss, k, kss, kmin, kmax, lmin, &
        lmax, l, ii, jj, pi, pj
      double precision, dimension(3,3,3) :: s
      double precision, dimension(3) :: ul1, ul2
      double precision, dimension(3,5,5) :: c
      double precision, dimension(27) :: slin
      double precision, dimension(3,5) :: c1, c2, c3, c4, c5
      double precision, dimension(3,3) :: s1, s2, s3
      double precision :: x2, y2, z2, r, aa, bb
      double precision, external :: ss
      logical :: use_diat2(107)

      save ival, icalcn, use_diat2
!-----------------------------------------------
!***********************************************************************
!
!   DIAT CALCULATES THE DI-ATOMIC OVERLAP INTEGRALS BETWEEN ATOMS
!        OF ATOMIC NUMBER NI AND NJ, WHERE NJ IS AT POSITION
!        XJ RELATIVE TO NI.
!
!   ON INPUT NI  = ATOMIC NUMBER OF THE FIRST ATOM.
!            NJ  = ATOMIC NUMBER OF THE SECOND ATOM.
!            XJ  = CARTESIAN COORDINATES OF THE SECOND ATOM,
!                  RELATIVE TO THE FIRST ATOM.
!
!  ON OUTPUT DI  = DIATOMIC OVERLAP, IN A 9 * 9 MATRIX. LAYOUT OF
!                  ATOMIC ORBITALS IN DI IS
!                  1   2   3   4   5            6     7       8     9
!                  S   PX  PY  PZ  D(X**2-Y**2) D(XZ) D(Z**2) D(YZ)D(XY)
!
!   LIMITATIONS:  IN THIS FORMULATION, NI AND NJ MUST BE LESS THAN 107
!         EXPONENTS ARE ASSUMED TO BE PRESENT IN COMMON BLOCK EXPONT.
!
!***********************************************************************
      equivalence (slin(1), s(1,1,1))
      equivalence (c1(1,1), c(1,1,1)), (c2(1,1), c(1,1,2)), (c3(1,1), c(1,1,3)), &
        (c4(1,1), c(1,1,4)), (c5(1,1), c(1,1,5)), (s1(1,1), s(1,1,1)), (s2(1,1), &
        s(1,1,2)), (s3(1,1), s(1,1,3))
      data ival/ 1, 0, 9, 1, 3, 8, 1, 4, 7, 1, 2, 6, 0, 0, 5/
      data icalcn/ 0/
      if (icalcn /= numcal) then
        icalcn = numcal
        use_diat2 = .false.
        do i = 1, 17
          use_diat2(i) = (natorb(i) < 5)
        end do
        use_diat2(2)  = .false.
        use_diat2(10) = .false.
      end if
      x2 = xj(1)
      y2 = xj(2)
      z2 = xj(3)
      pq1 = npq(ni,1)
      pq2 = npq(nj,1)
      di = 0.0D0
      r = x2**2 + y2**2 + z2**2
      if (pq1==0 .or. pq2==0 .or. r>=cutof1) return
      if (natorb(ni)==0 .or. natorb(nj)==0) return
      call coe (x2, y2, z2, natorb(ni), natorb(nj), c, r)
      if (r < 0.001D0) return
      ia = min(pq1 + 1,3)
      ib = min(pq2 + 1,3)
      a = ia - 1
      b = ib - 1
      if (use_diat2(ni) .and. use_diat2(nj)) then
        call diat2 (ni, zs(ni), zp(ni), r, nj, zs(nj), zp(nj), s, a0)
      else
        ul1(1) = zs(ni)
        ul2(1) = zs(nj)
        ul1(2) = zp(ni)
        ul2(2) = zp(nj)
        ul1(3) = max(zd(ni),0.3D0)
        ul2(3) = max(zd(nj),0.3D0)
        slin = 0.0D0
        newk = min(a,b)
        nk1 = newk + 1
        do i = 1, ia
          iss = i
          ib = b + 1
          pq1 = npq(ni,i)
          do j = 1, ib
            jss = j
            pq2 = npq(nj,j)
            do k = 1, nk1
              if (k>i .or. k>j) cycle
              kss = k
              pi = max(pq1,iss)
              pj = max(pq2,jss)
              s(i,j,k) = ss(pi,pj,iss,jss,kss,ul1(i),ul2(j),r,a0)
            end do
          end do
        end do
      end if
      do i = 1, ia ! i goes over  L = s, p, d for atom a
        kmin = 4 - i
        kmax = 2 + i
        do j = 1, ib ! j goes over  L = s, p, d for atom b
          if (j == 2) then
            aa = -1.D0
            bb = 1.D0
          else
            aa = 1.D0
            if (j == 3) then
              bb = -1.D0
            else
              bb = 1.D0
            end if
          end if
          lmin = 4 - j
          lmax = 2 + j
          do k = kmin, kmax   ! k goes over M_L = -del, -pi, sigma, pi, del for atom a
            do l = lmin, lmax ! l goes over M_L = -del, -pi, sigma, pi, del for atom b
              ii = ival(i,k)  !                     1    2     3     4   5
              jj = ival(j,l)
              di(ii,jj) = s1(i,j)*(c3(i,k)*c3(j,l))*aa + &
                          s2(i,j)*(c4(i,k)*c4(j,l)+c2(i,k)*c2(j,l))*bb + &
                          s3(i,j)*(c5(i,k)*c5(j,l)+c1(i,k)*c1(j,l))
            end do
          end do
        end do
      end do
      return
      end subroutine diat
      subroutine diat2(na, esa, epa, r12, nb, esb, epb, s, a0)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE overlaps_C, only : sa, sb, a, b, isp, ips
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: na
      integer  :: nb
      double precision  :: esa
      double precision  :: epa
      double precision , intent(in) :: r12
      double precision  :: esb
      double precision  :: epb
      double precision , intent(in) :: a0
      double precision , intent(inout) :: s(3,3,3)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(17) :: inmb
      integer , dimension(78) :: iii
      integer :: jmax, jmin, nbond, ii
      double precision :: rab, rab4, w, rt3, d, e, rab6

      save inmb, iii
!-----------------------------------------------
!***********************************************************************
!
! OVERLP CALCULATES OVERLAPS BETWEEN ATOMIC ORBITALS FOR PAIRS OF ATOMS
!        IT CAN HANDLE THE ORBITALS 1S, 2S, 3S, 2P, AND 3P.
!
!***********************************************************************
      data inmb/ 1, 0, 2, 2, 3, 4, 5, 6, 7, 0, 8, 8, 8, 9, 10, 11, 12/
!     NUMBERING CORRESPONDS TO BOND TYPE MATRIX GIVEN ABOVE
!      THE CODE IS
!
!     III=1      FIRST - FIRST  ROW ELEMENTS
!        =2      FIRST - SECOND
!        =3      FIRST - THIRD
!        =4      SECOND - SECOND
!        =5      SECOND - THIRD
!        =6      THIRD - THIRD
      data iii/  1, 2, 4, 2, 4, 4, 2, 4, 4, 4, 2, 4, 4, 4, 4, 2, 4, 4, 4, 4, 4, &
        2, 4, 4, 4, 4, 4, 4, 3, 5, 5, 5, 5, 5, 5, 6, 3, 5, 5, 5, 5, 5, 5, 6, 6, &
        3, 5, 5, 5, 5, 5, 5, 6, 6, 6, 3, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 3, 5, &
        5, 5, 5, 5, 5, 6, 6, 6, 6, 6/
!
!      ASSIGNS BOND NUMBER
!
      jmax = max0(inmb(na),inmb(nb))
      jmin = min0(inmb(na),inmb(nb))
      nbond = (jmax*(jmax - 1))/2 + jmin
      ii = iii(nbond)
      s = 0.D0
      rab = r12/a0
      select case (ii)
!
!     ------------------------------------------------------------------
! *** THE ORDERING OF THE ELEMENTS WITHIN S IS
! *** S(1,1,1)=(S(B)/S(A))
! *** S(1,2,1)=(P-SIGMA(B)/S(A))
! *** S(2,1,1)=(S(B)/P-SIGMA(A))
! *** S(2,2,1)=(P-SIGMA(B)/P-SIGMA(A))
! *** S(2,2,2)=(P-PI(B)/P-PI(A))
!     ------------------------------------------------------------------
! *** FIRST ROW - FIRST ROW OVERLAPS
!
      case default
        call set (esa, esb, na, nb, rab, ii)
        s(1,1,1) = .25D0*sqrt((sa*sb*rab*rab)**3)*(a(3)*b(1)-b(3)*a(1))
        return
!
! *** FIRST ROW - SECOND ROW OVERLAPS
!
      case (2)
        call set (esa, esb, na, nb, rab, ii)
        rab4 = rab**4*0.125D00
        w = sqrt(sa**3*sb**5)*rab4
        s(1,1,1) = sqrt(1.D00/3.D00)
        s(1,1,1) = w*s(1,1,1)*(a(4)*b(1)-b(4)*a(1)+a(3)*b(2)-b(3)*a(2))
        if (na > 1) call set (epa, esb, na, nb, rab, ii)
        if (nb > 1) call set (esa, epb, na, nb, rab, ii)
        w = sqrt(sa**3*sb**5)*rab4
        s(isp,ips,1) = w*(a(3)*b(1)-b(3)*a(1)+a(4)*b(2)-b(4)*a(2))
        return
!
! *** FIRST ROW - THIRD ROW OVERLAPS
!
      case (3)
        call set (esa, esb, na, nb, rab, ii)
        rab4 = rab**5*0.0625D00
        w = sqrt(sa**3*sb**7/22.5D00)*rab4
        s(1,1,1) = w*(a(5)*b(1)-b(5)*a(1)+(a(4)*b(2)-b(4)*a(2))*2.D0)
        if (na > 1) call set (epa, esb, na, nb, rab, ii)
        if (nb > 1) call set (esa, epb, na, nb, rab, ii)
        w = sqrt(sa**3*sb**7/7.5D00)*rab4
        s(isp,ips,1) = w*(a(4)*(b(1)+b(3))-b(4)*(a(1)+a(3))+b(2)*(a(3)+a(5))-a(2)*(b(3)+b(5)))
        return
!
! *** SECOND ROW - SECOND ROW OVERLAPS
!
      case (4)
        call set (esa, esb, na, nb, rab, ii)
        rab4 = rab**5*0.0625D00
        w = sqrt((sa*sb)**5)*rab4
        s(1,1,1) = w*(a(5)*b(1)+b(5)*a(1)-2.0D00*a(3)*b(3))/3.0D00
        call set (esa, epb, na, nb, rab, ii)
        if (na > nb) call set (epa, esb, na, nb, rab, ii)
        w = sqrt((sa*sb)**5)*rab4
        rt3 = 1.D00/sqrt(3.D00)
        d = a(4)*(b(1)-b(3)) - a(2)*(b(3)-b(5))
        e = b(4)*(a(1)-a(3)) - b(2)*(a(3)-a(5))
        s(isp,ips,1) = w*rt3*(d + e)
        call set (epa, esb, na, nb, rab, ii)
        if (na > nb) call set (esa, epb, na, nb, rab, ii)
        w = sqrt((sa*sb)**5)*rab4
        d = a(4)*(b(1)-b(3)) - a(2)*(b(3)-b(5))
        e = b(4)*(a(1)-a(3)) - b(2)*(a(3)-a(5))
        s(ips,isp,1) = w*rt3*(d - e)
        call set (epa, epb, na, nb, rab, ii)
        w = sqrt((sa*sb)**5)*rab4
        s(2,2,1) = -w*(b(3)*(a(5)+a(1))-a(3)*(b(5)+b(1)))
        s(2,2,2) = 0.5D0*w*(a(5)*(b(1)-b(3))-b(5)*(a(1)-a(3))-a(3)*b(1)+b(3)*a(1))
        return
!
! *** SECOND ROW - THIRD ROW OVERLAPS
!
      case (5)
        call set (esa, esb, na, nb, rab, ii)
        rab6 = rab**6*0.03125D0/sqrt(7.5D0)
        w = sqrt(sa**5*sb**7)*rab6
        rt3 = 1.D00/sqrt(3.D00)
        s(1,1,1) = w*(a(6)*b(1)+a(5)*b(2)-2.D0*(a(4)*b(3)+a(3)*b(4))+a(2)*b(5)+a(1)*b(6))/3.D00
!
        call set (esa, epb, na, nb, rab, ii)
        if (na > nb) call set (epa, esb, na, nb, rab, ii)
        w = sqrt(sa**5*sb**7)*rab6
        s(isp,ips,1) = w*rt3*(a(6)*b(2)+a(5)*b(1)-2.D0*(a(4)*b(4)+a(3)*b(3))+a(2)*b(6)+a(1)*b(5))
!
        call set (epa, esb, na, nb, rab, ii)
        if (na > nb) call set (esa, epb, na, nb, rab, ii)
        w = sqrt(sa**5*sb**7)*rab6
        s(ips,isp,1) = -w*rt3*(a(5)*(2.D0*b(3)-b(1))-b(5)*(2.D0*a(3)-a(1))-a(2) &
          *(b(6)-2.D0*b(4))+b(2)*(a(6)-2.D0*a(4)))
!
        call set (epa, epb, na, nb, rab, ii)
        w = sqrt(sa**5*sb**7)*rab6
        s(2,2,1) = -w*(b(4)*(a(1)+a(5))-a(4)*(b(1)+b(5))+b(3)*(a(2)+a(6))-a(3)* &
          (b(2)+b(6)))
        s(2,2,2) = 0.5D0*w*(a(6)*(b(1)-b(3))-b(6)*(a(1)-a(3))+a(5)*(b(2)-b(4)) - &
          b(5)*(a(2)-a(4))-a(4)*b(1)+b(4)*a(1)-a(3)*b(2)+b(3)*a(2))
        return
!
! *** THIRD ROW - THIRD ROW OVERLAPS
!
      case (6)
        call set (esa, esb, na, nb, rab, ii)
        rab4 = rab**7/480.D00
        w = sqrt((sa*sb)**7)*rab4
        rt3 = 1.D00/sqrt(3.D00)
        s(1,1,1) = w*(a(7)*b(1)-3.D00*(a(5)*b(3)-a(3)*b(5))-a(1)*b(7))/3.D00
        call set (esa, epb, na, nb, rab, ii)
        if (na > nb) call set (epa, esb, na, nb, rab, ii)
        w = sqrt((sa*sb)**7)*rab4
        d = a(6)*(b(1)-b(3)) - 2.D00*a(4)*(b(3)-b(5)) + a(2)*(b(5)-b(7))
        e = b(6)*(a(1)-a(3)) - 2.D00*b(4)*(a(3)-a(5)) + b(2)*(a(5)-a(7))
        s(isp,ips,1) = w*rt3*(d - e)
        call set (epa, esb, na, nb, rab, ii)
        if (na > nb) call set (esa, epb, na, nb, rab, ii)
        w = sqrt((sa*sb)**7)*rab4
        d = a(6)*(b(1)-b(3)) - 2.D00*a(4)*(b(3)-b(5)) + a(2)*(b(5)-b(7))
        e = b(6)*(a(1)-a(3)) - 2.D00*b(4)*(a(3)-a(5)) + b(2)*(a(5)-a(7))
        s(ips,isp,1) = -w*rt3*((-d) - e)
        call set (epa, epb, na, nb, rab, ii)
        w = sqrt((sa*sb)**7)*rab4
        d = a(3)*(b(7)+b(3)+b(3)) - a(5)*(b(1)+b(5)+b(5)) - b(5)*a(1) + a(7)*b(3)
        s(2,2,1) = -w*d
        d = a(7)*(b(1)-b(3)) + b(7)*(a(1)-a(3))
        e = a(5)*(b(5)-b(3)-b(1)) + b(5)*(a(5)-a(3)-a(1)) + 2.D0*a(3)*b(3)
        s(2,2,2) = 0.5D0*w*(d + e)
        return
      end select
!
      end subroutine diat2
      double precision function ss (na, nb, la1, lb1, m1, ua, ub, r1, a0)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use overlaps_C, only : fact
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: na
      integer , intent(in) :: nb
      integer , intent(in) :: la1
      integer , intent(in) :: lb1
      integer , intent(in) :: m1
      double precision , intent(in) :: ua
      double precision , intent(in) :: ub
      double precision , intent(in) :: r1
      double precision , intent(in) :: a0
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: m, lb, la, i, i1, j, n, lam1, lbm1, ia, ic, ib, id, iab, k1, &
        k2, k3, k4, k5, iaf, k6, ibf
      double precision, dimension(0:2,0:2,0:2) :: aff
      double precision, dimension(0:19) :: af, bf
      double precision, dimension(0:12,0:12) :: bi
      double precision :: r, p, b, quo, sum, sum1
      logical :: first

      save first, aff, bi
!-----------------------------------------------
      data first/ .TRUE./
      data aff/ 27*0.D0/
      m = m1 - 1
      lb = lb1 - 1
      la = la1 - 1
      r = r1/a0
      if (first) then
        first = .FALSE.
!
!           INITIALISE SOME CONSTANTS
!
!                  BINOMIALS
!
        do i = 0, 12
          bi(i,0) = 1.D0
          bi(i,i) = 1.D0
        end do
        do i = 0, 11
          i1 = i - 1
          bi(i+1,1:i1+1) = bi(i,1:i1+1) + bi(i,:i1)
        end do
        aff(0,0,0) = 1.D0
        aff(1,0,0) = 1.D0
        aff(1,1,0) = sqrt(0.5D0)
        aff(2,0,0) = 1.5D0
        aff(2,1,0) = sqrt(1.5D0)
        aff(2,2,0) = sqrt(0.375D0)
!
!   AFF(2,0,2) CORRESPONDS TO C(2,0,1) IN THE MANUAL
!
        aff(2,0,2) = -0.5D0
      end if
      p = (ua + ub)*r*0.5D0
      b = (ua - ub)*r*0.5D0
      quo = 1/p
      af(0) = quo*exp((-p))
      do n = 1, 19
        af(n) = n*quo*af(n-1) + af(0)
      end do
      call bfn (b, bf)
      sum = 0.D0
      lam1 = la - m
      lbm1 = lb - m
!
!          START OF OVERLAP CALCULATION PROPER
!
      do i = 0, lam1, 2
        ia = na + i - la
        ic = la - i - m
        do j = 0, lbm1, 2
          ib = nb + j - lb
          id = lb - j - m
          sum1 = 0.D0
          iab = ia + ib
!
!   In the Manual ka = K6
!                 kb = K5
!                 Pa = K1
!                 Pb = K2
!                 qa = K3
!                 qb = K4
!
          do k1 = 0, ia
            do k2 = 0, ib
              do k3 = 0, ic
                do k4 = 0, id
                  do k5 = 0, m
                    iaf = iab - k1 - k2 + k3 + k4 + 2*k5
                    do k6 = 0, m
                      ibf = k1 + k2 + k3 + k4 + 2*k6
                      sum1 = sum1 + bi(id,k4)*bi(ic,k3)*bi(ib,k2)*bi(ia,k1)*bi(m,k5)*bi(m,k6)* &
                      (1 - 2*mod(m + k2 + k4 + k5 + k6,2))*af(iaf)*bf(ibf)
                    end do
                  end do
                end do
              end do
            end do
          end do
          sum = sum + sum1*aff(la,m,i)*aff(lb,m,j)
        end do
      end do
      ss = sum*r**(na + nb + 1)*ua**na*ub**nb/2.D0* &
      sqrt(ua*ub/(fact(na+na)*fact(nb+ nb))*((la+la+1)*(lb+lb+1)))
      return
      end function ss

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine chkpar
    use param_global_C, only : ifiles_8, numvar, nfns, diffns, locvar
    use elemts_C, only : elemnt
    use parameters_C, only : partyp
    implicit none
    integer :: i, il, iu, j, j2, k, l, lim, ll, lu
    double precision :: sum
    double precision, dimension (:), allocatable :: par
    double precision, dimension (5) :: eiglim
    double precision, dimension (:), allocatable :: parmod
    double precision, dimension (:), allocatable :: vects
    intrinsic Min, Sqrt
  !
  !.. Data Declarations ..
    data eiglim / 1.d-5, 1.d-0, 1.d1, 1.d2, 1.d3 /
  !
  ! ... Executable Statements ...
  !
    write (ifiles_8, "(//20X,A)") " CHECK OF PARAMETER INDEPENDENCE"
    write (ifiles_8, "(//15X,A,I5)") " Number of reference data:", nfns
    write (ifiles_8, "(  15X,A,I5)") " Number of parameters:    ", numvar
     i = (numvar*(numvar+1))/2
     allocate (par(i), parmod(numvar), vects(numvar**2))
    if (nfns < 30 .and. numvar < 9) then
      write (ifiles_8, "(/3X,2A,/)") "Matrix of Differentials ", "(Rows: Refer&
     &ence data, Columns: Parameters)"
      do i = 1, nfns
        write (ifiles_8, "(8F10.4)") (diffns(j, i), j=1, numvar)
      end do
    end if
    l = 0
    do i = 1, numvar
      sum = 1.d-20
      do k = 1, nfns
        sum = sum + diffns(i, k) * diffns(i, k)
      end do
      parmod(i) = 1.d0 / Sqrt (sum)
      parmod(i) = 1.d0
      do j = 1, i
        sum = 0.d0
        do k = 1, nfns
          sum = sum + diffns(i, k) * diffns(j, k)
        end do
        l = l + 1
        par(l) = sum * parmod(i) * parmod(j)
      end do
    end do
    if (numvar < 9) then
      write (ifiles_8, "(/15X,A,/)") "Parameter Hessian"
      l = 1
      do i = 1, numvar
        ll = l
        l = l + i
        lu = l - 1
        write (ifiles_8, "(8F10.1)") (par(j), j=ll, lu)
      end do
    end if
    call rsp (par, numvar, parmod, vects)
    write (ifiles_8, "(//20X,A,/)") " Eigenvalues of Parameter Hessian"
    do j = 1, numvar
      if (parmod(j) > 1.d7) then
        j2 = j - 1
        go to 1000
      end if
    end do
    j2 = numvar
1000 write (ifiles_8, "(8F10.1)") (parmod(i), i=1, j2)
    if (j2 /= numvar) then
      write (ifiles_8, "(/20X,A)") "(Eigenvalues over 10,000,000 omitted)"
    end if
    write (ifiles_8, "(/)")
    if (parmod(1) < eiglim(1)) then
      lim = 1
      write (ifiles_8, "(20X,A)") " Parameters are ill-defined"
    else if (parmod(1) < eiglim(2)) then
      lim = 2
      write (ifiles_8, "(20X,A)") " Parameters are very poorly defined"
    else if (parmod(1) < eiglim(3)) then
      lim = 3
      write (ifiles_8, "(20X,A)") " Parameters are poorly defined"
    else
      lim = 4
      write (ifiles_8, "(20X,A)") " Parameters are defined by reference data"
    end if
    if (lim == 4) return
    do i = 1, numvar
      if (parmod(i) > eiglim(lim)) go to 1100
    end do
    i = numvar
1100 write (ifiles_8, "(/15X,A,/)") " Parameter Eigenvectors of Low Eigenvalue&
   &s"
    i = Min (i, 8)
    write (ifiles_8, "(12X,8F8.1)") (parmod(j), j=1, i)
    locvar(1,numvar+1) = 0
    locvar(2,numvar+1) = 0
    do j = 1, numvar
      il = (j-1) * numvar + 1
      iu = il + i - 1
      write (ifiles_8, "(3X,A,2X,A,2X,8F8.3)") partyp (locvar(1, j)), elemnt &
     & (locvar(2, j)), (vects(k), k=il, iu)
    end do
end subroutine chkpar

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine addfck (f, p)
    use molkst_C, only : lm61, numat, mpack
    use funcon_C, only : a0, ev
    use cosmo_C, only : ediel, fepsi, nps, &
     amat, bmat, iatsp, nsetf, phinet, qscnet, qdenet, ipiden, gden, qscat
    implicit none
    double precision, dimension(mpack), intent(in) :: p
    double precision, dimension(mpack), intent(inout) :: f
    integer :: i, iat, im, j
    double precision :: fcon, fim, phi, qsc3, s1, s3
    fcon = a0 * ev
    do i = 1, numat
      qscat(i) = 0.d0
    end do
   ! FIRST CALCULATE QDENEL FROM DENSITY MATRIX
    do i = 1, lm61
      qdenet(i, 2) = gden(i) * p(ipiden(i))
      qdenet(i, 3) = qdenet(i, 2) + qdenet(i, 1)
    end do
   !  NOW CALCULATE PHIEL FROM BMAT*QDENEL
    do i = 1, nps
      phi = 0.d0
      do j = 1, lm61
        phi = phi + bmat(j, i) * qdenet(j, 2)
      end do
      phinet(i, 2) = phi
      phinet(i, 3) = phinet(i, 1) + phi
    end do
   !  NOW CALCULATE QSCEL FROM A*QSCEL = -PHIEL
    call coscl2 (amat, nsetf, qscnet(1, 2), phinet(1, 2), nps)
    ediel = 0.d0
    s1 = 0.0d0
    s3 = 0.0d0
    do i = 1, nps
      iat = iatsp(i)
      qscnet(i, 2) = -fepsi * qscnet(i, 2)
      qsc3 = qscnet(i, 1) + qscnet(i, 2)
      qscnet(i, 3) = qsc3
      ediel = ediel + qsc3 * phinet(i, 3)
      s1 = s1 + qscnet(i, 1)
      s3 = s3 + qsc3
      qscat(iat) = qscat(iat) + qsc3
    end do
    ediel = ediel * fcon / 2
   ! NOW ADD BMAT*QSCEL TO FOCK MATRIX
    do i = 1, lm61
      im = ipiden(i)
      fim = 0.d0
      do j = 1, nps
        fim = fim + bmat(i, j) * qscnet(j, 2)
      end do
      f(im) = f(im) - fcon * fim
    end do
end subroutine addfck
subroutine addhcr
    use molkst_C, only : lm61
    use funcon_C, only : a0, ev
    use cosmo_C, only : nps, bmat, qscnet, ipiden
    use common_arrays_C, only : h
    implicit none
    integer :: i, im, j
    double precision :: fcon, him
    fcon = a0 * ev
    do i = 1, lm61
      im = ipiden(i)
      him = 0.d0
      do j = 1, nps
        him = him + bmat(i, j) * qscnet(j, 1)
      end do
      h(im) = h(im) - fcon * him
    end do
end subroutine addhcr
subroutine addnuc
    use molkst_C, only : numat, lm61, enuclr
    use funcon_C, only : a0, ev
    use common_arrays_c, only : nat
    use cosmo_C, only : nps, fepsi, &
    amat, bmat, nsetf, phinet, qscnet, qdenet, idenat
    use parameters_C, only : tore
    implicit none
    integer :: i, j
    double precision :: enclr, fcon, phi
   !
   ! FIRST CALCULATE QDENNUC
    fcon = a0 * ev
    do i = 1, lm61
      qdenet(i, 1) = 0
    end do
    do i = 1, numat
      qdenet(idenat(i), 1) = tore(nat(i))
    end do
   !  NOW CALCULATE PHINUC AS BMAT*QDENUC
    do i = 1, nps
      phi = 0.d0
      do j = 1, lm61
        phi = phi + bmat(j, i) * qdenet(j, 1)
      end do
      phinet(i, 1) = phi
    end do
   !  NOW CALCULATE QSCNUC FROM  AMAT*QSCNUC = PHINUC
    call coscl2 (amat, nsetf, qscnet(1, 1), phinet(1, 1), nps)
   ! SCALE QSCNUC AND CALCULATE INTERATION ENERGY
    enclr = 0.d0
    do i = 1, nps
      qscnet(i, 1) = -fepsi * qscnet(i, 1)
      enclr = enclr + qscnet(i, 1) * phinet(i, 1)
    end do
    enuclr = enuclr + fcon * enclr / 2
end subroutine addnuc
subroutine ansude (ra, rb, d, rs, ara, arb, aar, abr, arad, arbd, rinc)
    use funcon_C, only : pi
   !   THIS PROGROM CALCULATES THE AREA OF TWO INTERSECTING SPHERES
   !   WITH RADII RA AND RB AT A DISTANCE D AND A SOLVENT PROBE
   !   RADIUS RS. THE TWO AREAS ARE CALCULATED SEPARATELY (ARA, ARB).
   !   THE PART OF THE AREA ON THE CLOSURE PART IS AAR AND ABR.
   !   FOR BOTH AREAS ANALYTIC DERIVATIVES WITH RESPECT TO THE DISTANCE
   !   D ARE CALCULATED (ARAD, ARBD).    (WRITTEN BY ANDREAS KLAMT, 9/9/96)
    implicit none
    double precision, intent (in) :: d, ra, rb, rs
    double precision, intent (out) :: aar, abr, ara, arad, arb, arbd, rinc
    double precision :: ca, cad, cb, cbd, fza, fzad, fzb, fzbd, qa, qb, &
   & sa, sad, sb, sbd, ta, tad, tb, tbd, xa, xad, xb, xbd, ya, yad, yb, ybd, &
   & za, zad, zb, zbd
    qa = ra + rs
    qb = rb + rs
    ca = (qa**2 + d**2 - qb**2) / (2.d0*qa*d)
    cb = (qb**2 + d**2 - qa**2) / (2.d0*qb*d)
    sa = Sqrt (1.d0 - ca*ca)
    sb = Sqrt (1.d0 - cb*cb)
    ta = pi * sa
    tb = pi * sb
    fza = (1.d0 - Cos (ta)) / 2
    fzb = (1.d0 - Cos (tb)) / 2
    if (sa < 0 .or. sb < 0) then
      fza = 1.d0
    end if
    if (sa < 0 .or. sb < 0) then
      fzb = 1.d0
    end if
    xa = fzb ** 1 * rs * (ca + cb)
    xb = fza ** 1 * rs * (ca + cb)
    ya = ra * sa - fzb * rb * sb
    yb = rb * sb - fza * ra * sa
    za = Sqrt (xa*xa + ya*ya)
    zb = Sqrt (xb*xb + yb*yb)
    rinc = 0.5d0*(za + zb)/sqrt(rs*rs*(ca + cb)**2 + (ra*sa - rb*sb)**2)
    ara = pi * ra * (2.d0*(1.d0 + ca)*ra + sa*za)
    arb = pi * rb * (2.d0*(1.d0 + cb)*rb + sb*zb)
    aar = pi * ra * (sa*za)
    abr = pi * rb * (sb*zb)
   ! NOW DERIVATIVES
    cad = (qb**2 + d**2 - qa**2) / (2.d0*qa*d*d)
    cbd = (qa**2 + d**2 - qb**2) / (2.d0*qb*d*d)
    sad = -ca * cad / sa
    sbd = -cb * cbd / sb
    tad = pi * sad
    tbd = pi * sbd
    fzad = Sin (ta) * .5d0
    fzbd = Sin (tb) * .5d0
    if (sa < 0 .or. sb < 0) then
      fzad = 0.d0
    end if
    if (sa < 0 .or. sb < 0) then
      fzbd = 0.d0
    end if
    xad = rs * ((ca + cb)*fzbd*tbd + fzb*(cad + cbd))
    xbd = rs * ((ca + cb)*fzad*tad + fza*(cad + cbd))
    yad = ra * sad-fzbd * tbd * rb * sb - fzb * rb * sbd
    ybd = rb * sbd-fzad * tad * ra * sa - fza * ra * sad
    zad = (xa*xad + ya*yad) / za
    zbd = (xb*xbd + yb*ybd) / zb
    arad = pi * ra * (sad*za + sa*zad + 2.d0*ra*cad)
    arbd = pi * rb * (sbd*zb + sb*zbd + 2.d0*rb*cbd)
end subroutine ansude
subroutine ciint (c34, pq34)
    use molkst_C, only : lm61
    use cosmo_C, only : nps, cmat
    implicit none
    double precision, dimension (lm61), intent (in) :: c34
    double precision, dimension (lm61), intent (inout) :: pq34
    integer :: i, i0, j
    i0 = 0
    do i = 1, lm61
      pq34(i) = 0.d0
    end do
    if (nps < 0) return
    do i = 1, lm61
      do j = 1, i - 1
        i0 = i0 + 1
        pq34(j) = pq34(j) + cmat(i0) * c34(i)
        pq34(i) = pq34(i) + cmat(i0) * c34(j)
      end do
      i0 = i0 + 1
      pq34(i) = pq34(i) + cmat(i0) * c34(i)
    end do
end subroutine ciint
subroutine coscav
   !***********************************************************************
   !
   ! THIS ROUTINE CONSTRUCTS OR UPDATES THE SOLVENT - ACCESSIBLE
   ! SURFACE (SAS)
   !
   !***********************************************************************
    use molkst_C, only : numat
    use cosmo_C, only : lenabc, nps, area, isude, sude, &
       cosvol, rsolv, ioldcv, disex2, n0, dirvec, dirsm, srad, &
       cosurf, amat, iatsp, nar_csm, nsetf, phinet, arat
    use common_arrays_c, only : coord, nat
    use funcon_C, only : pi
    use chanel_C, only : iw
    implicit none
    integer :: i, i0, ik, ilipa, inset, ipm, ips, ix, j, jmax, jps, k, &
   & l, nara, narea, nfl1, nfl2, niter, nps0, maxrs
    double precision :: aa, d2, dist, dist1, dist2, dist3, fdiagr, r, ri, &
   & ri2, rj, rr, sininv, sp, spm, x1, x2, x3, x4, dists
    logical, dimension (10000) :: din ! Was 1082, but some calc'ns used more than 1082
    integer, dimension (1082) :: iseg
    double precision, dimension (3) :: xa, xb, xi, xj, xx
    double precision, dimension (:, :), allocatable :: dirtm
    double precision, dimension (:, :, :), allocatable :: finel
    double precision, dimension(:), allocatable :: rdat
    double precision, dimension(:, :), allocatable :: rsc
    double precision, dimension(:, :, :), allocatable :: tm
    integer, dimension(:), allocatable :: isort, ipsrs, nipsrs, nset, nipa, &
         & lipa
    integer, dimension(:, :), allocatable :: nn
    maxrs = 70 * numat
    allocate (rdat(numat), rsc(4, maxrs), tm(3, 3, numat), nn(3, numat), &
         & isort(maxrs), ipsrs(maxrs), nipsrs(lenabc), nset(1082*numat), &
         & nipa(numat), dirtm(3, 1082), finel(4, 500, 2))
    if (.not. allocated(srad)) allocate(srad(numat))
    if (.not. allocated(nar_csm))  allocate(nar_csm(lenabc + 1))
   ! MAKE COORDINATES A BIT ASYMMETRIC IN ORDER TO AVOID
   ! SYMMETRY PROBLEMS WITH CAVITY CONSTRUCTION
    do i = 1, numat
      do j = 1, 3
        coord(j, i) = coord(j, i) + Cos (i*j*.1d0) * 3.0d-9
      end do
    end do
   !
    ilipa = 0
    do i = 1, numat
      ri = srad(i)
      r = ri + rsolv
      rr = r + rsolv
      ri2 = ri * ri
      do ix = 1, 3
        xa(ix) = coord(ix, i)
      end do
      do j = 1, numat
        if (j /= i) then
          dist = 0.d0
          do ix = 1, 3
            dist = dist + (xa(ix) - coord(ix, j)) ** 2
          end do
          if (dist < (rr + srad(j))**2) then
            ilipa = ilipa + 1
          end if
        end if
      end do
    end do
    allocate (lipa(Max(1, ilipa)))
    fdiagr = 2.1d0 * Sqrt (pi)
    inset = 1
    ilipa = 0
    nps = 0
    area = 0.d0
    cosvol = 0.d0
   ! NOW A LARGE LOOP OVER ALL ATOMS STARTS, WHICH MAKES THE SEGMENTATION
   ! ON THE CONVEX (SPHERICAL) PART OF THE CORRESPONDING PART OF THE CAVITY
    do i = 1, numat
      nipa(i) = 0
      ri = srad(i)
      r = ri + rsolv
      rr = r + rsolv
      ri2 = ri * ri
      do ix = 1, 3
        xa(ix) = coord(ix, i)
      end do
      nps0 = nps + 1
      do j = 1, numat
        if (j /= i) then
          dist = 0.d0
          do ix = 1, 3
            dist = dist + (xa(ix) - coord(ix, j)) ** 2
          end do
          if (dist < (rr + srad(j))**2) then
            ilipa = ilipa + 1
            if (ilipa > maxrs) then
              write(iw, '(/10x, a)')"Solvent radius too large - reduce RSOLV"
              write(iw, '(/10x, a, f6.2, a, /)')"(Current value of RSOLV:", rsolv, " Angstroms)"
              call mopend ("Solvent radius too large - reduce RSOLV")
              return
            end if
            nipa(i) = nipa(i) + 1
            lipa(ilipa) = j
          end if
        end if
      end do
      ! SEARCH FOR 3 NEAREST NEIGHBOR ATOMS
      dist1 = 1.d20
      dist2 = 1.d20
      dist3 = 1.d20
      nn(1, i) = 0
      nn(2, i) = 0
      nn(3, i) = 0
      do j = 1, numat
        if (j /= i) then
          dist = 0.d0
          do ix = 1, 3
            dist = dist + (xa(ix) - coord(ix, j)) ** 2
          end do
          if (dist + 0.05d0 < dist3) then
            dist3 = dist
            nn(3, i) = j
          end if
          if (dist3 + 0.05d0 < dist2) then
            dist = dist2
            dist2 = dist3
            dist3 = dist
            nn(3, i) = nn(2, i)
            nn(2, i) = j
          end if
          if (dist2 + 0.05d0 < dist1) then
            dist = dist1
            dist1 = dist2
            dist2 = dist
            nn(2, i) = nn(1, i)
            nn(1, i) = j
          end if
        end if
      end do
      ! BUILD NEW TRANSFORMATION MATRIX
      if (nn(1, i) == 0) then
        tm(1, 1, i) = 1.d0
        tm(1, 2, i) = 0.d0
        tm(1, 3, i) = 0.d0
      else
        dist1 = 0.d0
        do ix = 1, 3
          dist1 = dist1 + (xa(ix) - coord(ix, nn(1, i))) ** 2
        end do
        dist = 1.d0 / Sqrt (dist1)
        tm(1, 1, i) = (coord(1, nn(1, i)) - xa(1)) * dist
        tm(1, 2, i) = (coord(2, nn(1, i)) - xa(2)) * dist
        tm(1, 3, i) = (coord(3, nn(1, i)) - xa(3)) * dist
      end if
      rr = -1.d0
      i_loop: do
        if (nn(2, i) == 0) then
          rr = rr + 1.d0
          dist = sqrt(9.d0*(tm(1, 2, I) + rr)**2 + 4.d0*(tm(1, 1, i) + rr**2)**2 + tm(1, 3, i)**2)
          xx(1) = 3.d0*(tm(1, 2, I) + rr)/dist
          xx(2) = tm(1, 3, I)/dist
          xx(3) = 2.d0*(tm(1, 1, I) + rr**2)/dist
        else
          dist2 = 0.d0
          do ix = 1, 3
              dist2 = dist2 + (xa(ix) - coord(ix, nn(2, i)))**2
          end do
          dist = 1.0d0/sqrt(dist2)
          xx(1) = (coord(1, nn(2, i)) - xa(1))*dist
          xx(2) = (coord(2, nn(2, i)) - xa(2))*dist
          xx(3) = (coord(3, nn(2, i)) - xa(3))*dist
        end if
        sp = xx(1)*tm(1, 1, i) + xx(2)*tm(1, 2, i) + xx(3)*tm(1, 3, i)
        if (sp*sp > 0.99d0) then
          nn(2, i) = nn(3, i)
          nn(3, i) = 0
          dist2 = dist3
          cycle i_loop
        else
          exit i_loop
        end if
      end do i_loop
      sininv = 1.d0 / Sqrt (1.d0 - sp*sp)
      tm(2, 1, i) = (xx(1) - sp*tm(1, 1, i)) * sininv
      tm(2, 2, i) = (xx(2) - sp*tm(1, 2, i)) * sininv
      tm(2, 3, i) = (xx(3) - sp*tm(1, 3, i)) * sininv
      tm(3, 1, i) = tm(1, 2, i) * tm(2, 3, i) - tm(2, 2, i) * tm(1, 3, i)
      tm(3, 2, i) = tm(1, 3, i) * tm(2, 1, i) - tm(2, 3, i) * tm(1, 1, i)
      tm(3, 3, i) = tm(1, 1, i) * tm(2, 2, i) - tm(2, 1, i) * tm(1, 2, i)
      ! TRANSFORM DIRVEC ACCORDING TO TM
      do j = 1, 1082
        xx(1) = dirvec(1, j)
        xx(2) = dirvec(2, j)
        xx(3) = dirvec(3, j)
        do ix = 1, 3
          dirtm(ix, j) = xx(1) * tm(1, ix, i) + xx(2) * tm(2, ix, i) + xx &
         & (3) * tm(3, ix, i)
        end do
      end do
      ! FIND THE POINTS OF THE BASIC GRID ON THE SAS
      narea = 0
      loop: do j = 1, 1082
        din(j) = .false.
        do ix = 1, 3
          xx(ix) = xa(ix) + dirtm(ix, j) * r
        end do
         !          - - - WE NEED ONLY TRY THOSE ATOMS INTERSECTING ATOM I
        do ik = ilipa - nipa(i) + 1, ilipa
          k = lipa(ik)
          dist = 0.d0
          do ix = 1, 3
            dist = dist + (xx(ix) - coord(ix, k)) ** 2
          end do
          dist = Sqrt (dist) - rsolv - srad(k)
          if (dist < 0) cycle loop
        end do
        narea = narea + 1
        cosvol = cosvol + ri2 * dirvec(4, j) * (dirtm(1, j)*xa(1) + dirtm(2, &
       & j)*xa(2) + dirtm(3, j)*xa(3) + ri)
        area = area + ri2 * dirvec(4, j)
        din(j) = .true.
      end do loop
      if (narea /= 0) then
         !
         !  IF HYDROGEN, THEN USE THE SMALLER SET OF POINTS (NORMALLY
         !  12 POINTS), OTHERWISE, USE THE LARGER SET (NORMALLY 42 POINTS)
         !
        i0 = 1
        if (nat(i) == 1) then
          i0 = 2
        end if
        jmax = n0(i0)
        i0 = (i0 - 1) * n0(1)
        do j = 1, jmax
          nps = nps + 1
          if (nps > lenabc) then
            call mopend ("NPS IS GREATER THAN LENABC - USE SMALLER NSPA")
            go to 100
          else
            iatsp(nps) = i
            do ix = 1, 3
              xx(ix) = dirsm(ix, i0 + j)
            end do
            do ix = 1, 3
              cosurf(ix, nps) = xx(1) * tm(1, ix, i) + xx(2) * tm(2, ix, &
             & i) + xx(3) * tm(3, ix, i)
            end do
          end if
        end do
        niter = 0
        do
          niter = niter + 1
          do ips = nps0, nps
            nar_csm(ips) = 0
            phinet(ips, 1) = 0.d0
            phinet(ips, 2) = 0.d0
            phinet(ips, 3) = 0.d0
          end do
          do j = 1, 1082
            if (din(j)) then
              spm = -1.d0
              ipm = 0
              x1 = dirtm(1, j)
              x2 = dirtm(2, j)
              x3 = dirtm(3, j)
              do ips = nps0, nps
                sp = x1 * cosurf(1, ips) + x2 * cosurf(2, ips) + x3 * cosurf &
               & (3, ips)
                if (sp >= spm) then
                  spm = sp * (1.d0 + 1.d-14)
                  ipm = ips
                end if
              end do
              iseg(j) = ipm
              nar_csm(ipm) = nar_csm(ipm) + 1
              do ix = 1, 3
                phinet(ipm, ix) = phinet(ipm, ix) + dirtm(ix, j) * dirvec &
               & (4, j)
              end do
            end if
          end do
          ips = nps0 - 1
          loop1: do
            ips = ips + 1
            do while (nar_csm(ips) == 0)
              niter = 1
              nps = nps - 1
              if (ips > nps) exit loop1
              do jps = ips, nps
                nar_csm(jps) = nar_csm(jps + 1)
                phinet(jps, 1) = phinet(jps + 1, 1)
                if (Abs(phinet(1, 1)) > 1.d-20) then
                  ips = ips
               end if
                phinet(jps, 2) = phinet(jps + 1, 2)
                phinet(jps, 3) = phinet(jps + 1, 3)
              end do
            end do
            dists = 0.d0
            do ix = 1, 3
              dists = dists + phinet(ips, ix) ** 2
            end do
            dists = Max (dists, 1.d-20)
            dist = 1.d0 / Sqrt (dists)
            do ix = 1, 3
              cosurf(ix, ips) = phinet(ips, ix) * dist
            end do
            if (ips >= nps) exit
          end do loop1
          if (niter >= 2) exit
        end do
         ! NOW ALL SEGMENTS ARE FINALLY DEFINED AND THE ASSOCIATED
         ! BASIC GRID POINTS ARE CLOSE - PACKED
        do ips = nps0, nps
          nsetf(ips) = inset
          inset = inset + nar_csm(ips)
          nar_csm(ips) = 0
          cosurf(4, ips) = 0.d0
          do ix = 1, 3
            cosurf(ix, ips) = cosurf(ix, ips) * ri + xa(ix)
          end do
        end do
        do j = 1, 1082
          if (din(j)) then
            ipm = iseg(j)
            nara = nar_csm(ipm)
            nset(nsetf(ipm) + nara) = j
            nar_csm(ipm) = nara + 1
            cosurf(4, ipm) = cosurf(4, ipm) + dirvec(4, j) * ri2
          end if
        end do
      end if
  !  Check lipa size
      if (ilipa >= 70*numat) then
        exit
      end if
    end do
     !
   ! HERE THE CONSTRUCTION FOR A SINGLE ATOM ENDS
    do i = 1, numat
      din(i) = .true.
    end do
    do j = 1, nps
      din(iatsp(j)) = .false.
    end do
   ! NOW THE SEGMENT FORMATION ON ALL ATOMS IS FINISHED
   ! NOW THE CLOSURE OF THE CONCAVE REGIONS OF THE SURFACE WILL BE DONE
    if (ioldcv == 0) then
      i = max(numat, 1082)
      call surclo (coord, nipa, lipa, din, i, rsc, isort, ipsrs, nipsrs, nat, &
     & srad, cosurf, iatsp, nar_csm, nsetf, isude, sude, maxrs)
    end if
    cosvol = cosvol / 3
    do i = 1, numat
      arat(i) = 0.d0
      rdat(i) = 0.d0
    end do
   ! FILLING AMAT
    do ips = 1, nps
      i = iatsp(ips)
      ri = srad(i)
      do ix = 1, 3
        xi(ix) = coord(ix, i)
        xa(ix) = cosurf(ix, ips)
      end do
      arat(i) = arat(i) + cosurf(4, ips)
      call mfinel (ips, 1, finel, nar_csm, nsetf, nset, rsc, nipsrs, dirvec, &
     & tm(1, 1, i), xi, ri, nfl1, ioldcv, maxrs, lenabc, numat)
      aa = 0.d0
      do k = 1, nfl1
        aa = aa + fdiagr * Sqrt (finel(4, k, 1)**3)
        x1 = finel(1, k, 1)
        x2 = finel(2, k, 1)
        x3 = finel(3, k, 1)
        x4 = finel(4, k, 1)
        do l = 1, k - 1
          aa = aa + 2 * x4 * finel(4, l, 1) / Sqrt ((x1 - finel(1, l, &
         & 1))**2 + (x2 - finel(2, l, 1))**2 + (x3 - finel(3, l, 1))**2)
        end do
      end do
      amat(((ips + 1)*ips)/2) = aa / cosurf(4, ips) ** 2
      rdat(i) = rdat(i) + aa
      do jps = 1, ips - 1
        j = iatsp(jps)
        d2 = 0.d0
        do ix = 1, 3
          xj(ix) = coord(ix, j)
          xb(ix) = cosurf(ix, jps)
          d2 = d2 + (xb(ix) - xa(ix)) ** 2
        end do
        if (d2 > disex2) then
          aa = 1.d0 / Sqrt (d2)
        else
          j = iatsp(jps)
          rj = srad(j)
          call mfinel (jps, 2, finel, nar_csm, nsetf, nset, rsc, nipsrs, &
         & dirvec, tm(1, 1, j), xj, rj, nfl2, ioldcv, maxrs, lenabc, numat)
          aa = 0.d0
          do k = 1, nfl1
            x1 = finel(1, k, 1)
            x2 = finel(2, k, 1)
            x3 = finel(3, k, 1)
            x4 = finel(4, k, 1)
            do l = 1, nfl2
              aa = aa + x4 * finel(4, l, 2) / Sqrt ((x1 - finel(1, l, &
             & 2))**2 + (x2 - finel(2, l, 2))**2 + (x3 - finel(3, l, 2))**2)
            end do
          end do
          aa = aa / cosurf(4, ips) / cosurf(4, jps)
        end if
        amat(((ips - 1)*ips)/2 + jps) = aa
        if (i == j) then
          rdat(i) = rdat(i) + 2 * aa * cosurf(4, ips) * cosurf(4, jps)
        end if
      end do
    end do
   !
   ! PERFORM CHOLESKY FACTORIZATION
   !
    call coscl1 (amat, nsetf, nps)
    deallocate (rdat, rsc, tm, nn, isort, ipsrs, nipsrs, nset, nipa, lipa, dirtm, finel)
    100 continue
end subroutine coscav
subroutine coscl1 (a, id, n)
   ! THIS ROUTINE PERFORMS A CHOLESKY FACTORIZATION
   ! INPUT:   A = PACKED LOWER TRIANGLE OF A
   !               SYMMETRIC POSITIVE DEFINITE N*N MATRIX
   ! OUTPUT:  A = LOWER TRIANGLE OF CHOLESKY MATRIX (INVERSE PIVOT ELEMEN
   !         ID = INTEGER VECTOR OF LENGTH N CONTAINING THE INDICES I(I - 1)
   !
    implicit none
    integer, intent (in) :: n
    double precision, dimension (*), intent (inout) :: a
    integer, dimension (n), intent (inout) :: id
    integer :: i, indi, info
    indi = 0
    do i = 1, n
      id(i) = indi
      indi = indi + i
    end do
    call dpptrf('U', n, a, info)
    do i = 1, n
      a(i+id(i)) = 1.0d0/a(i+id(i))
    end do
end subroutine coscl1
subroutine coscl2 (a, id, x, y, n)
   ! THIS ROUTINE SOLVES THE LINEAR SYSTEM CX = Y BASED ON
   ! CHOLESKY FACTORIZATION
   ! INPUT:   A = UPPER TRIANGLE OF CHOLESKY MATRIX
   ! INPUT:   Y = VECTOR OF LENGTH N
   !         ID = INTEGER VECTOR OF LENGTH N CONTAINING THE INDICES I(I - 1)
   ! OUTPUT:  X = VECTOR OF LENGTH N
    implicit none
    integer, intent (in) :: n
    double precision, dimension (*), intent (in) :: a
    integer, dimension (n), intent (in) :: id
    double precision, dimension (n), intent (out) :: x
    double precision, dimension (n), intent (in) :: y
    integer :: i, k, kk
    double precision :: summe
    x = 0.d0
    do k = 1, n
      summe = y(k)
      kk = id(k)
      do i = k - 1, 1, - 1
        summe = summe - a(i + kk) * x(i)
      end do
      x(k) = summe * a(k + kk)
    end do
    do k = n, 1, - 1
      summe = x(k)
      do i = k + 1, n
        summe = summe - a(k + id(i)) * x(i)
      end do
      x(k) = summe * a(k + id(k))
    end do
end subroutine coscl2
subroutine diegrd (dxyz)
    use molkst_C, only : numat
    use cosmo_C, only : nps, fepsi, nipc, &
     cosurf, iatsp, isude, sude, qscnet, qdenet, qscat, arat
    use parameters_C, only : dd, qq
    use common_arrays_c, only : coord, nfirst, nlast, nat
    use funcon_C, only : ev, a0, fpc_9
    implicit none
    integer :: i, ia, iak, ial, ib, idel, iden, ix, j, k, l, nati, iii
    double precision :: bsurf, ddi, deab, dist2, dx, fact, ff, ff0, &
   & qqi2, qsk, rm2, rm4, xxx
    double precision, dimension (3) :: xk, xl, xx
    double precision, dimension (0:3, 10) :: db
    double precision, dimension (3, numat), intent (inout) :: dxyz
    intrinsic Min, Sqrt
    do i = 1, 10
      do ix = 1, 3
        db(ix, i) = 0.d0
      end do
    end do
    db(0, 1) = 1.d0
    fact = -ev * a0 * fpc_9
    do k = 1, nps
      iak = iatsp(k)
      do ix = 1, 3
        xk(ix) = cosurf(ix, k)
      end do
      qsk = qscnet(k, 3)
      do l = 1, k - 1
        ial = iatsp(l)
        if (ial /= iak) then
          dist2 = 0.d0
          do ix = 1, 3
            xxx = cosurf(ix, l) - xk(ix)
            xl(ix) = xxx
            dist2 = dist2 + xxx * xxx
          end do
          ff = qsk * qscnet(l, 3) * fact * dist2 ** (- 1.5d0) / fepsi
          do ix = 1, 3
            dxyz(ix, iak) = dxyz(ix, iak) - xl(ix) * ff
            dxyz(ix, ial) = dxyz(ix, ial) + xl(ix) * ff
          end do
        end if
      end do
    end do
   ! NOW THE CONTRIBUTIONS FROM ANALYTIC SURFACE DERIVATIVES
   ! FOR THE SURFACE CLOSURE
    bsurf = 0.d0
    do i = 1, nipc
      ia = isude(1, i)
      ib = isude(2, i)
      deab = -0.25d0 * (qscat(ia)**2*sude(1, i)/arat(ia) + qscat(ib)**2*sude(2, &
     & i)/arat(ib) + bsurf*(sude(1, i) + sude(2, i)))
      xk(1) = coord(1, ib) - coord(1, ia)
      xk(2) = coord(2, ib) - coord(2, ia)
      xk(3) = coord(3, ib) - coord(3, ia)
      deab = deab / Sqrt (xk(1)**2 + xk(2)**2 + xk(3)**2)
      do ix = 1, 3
        dxyz(ix, ia) = dxyz(ix, ia) - xk(ix) * deab
        dxyz(ix, ib) = dxyz(ix, ib) + xk(ix) * deab
      end do
    end do
    do k = 1, nps
      iak = iatsp(k)
      do ix = 1, 3
        xk(ix) = cosurf(ix, k)
      end do
      qsk = qscnet(k, 3)
      iden = 0
      do i = 1, numat
        idel = nlast(i) + 1 - nfirst(i)
        if (i /= iak) then
          nati = nat(i)
          dist2 = 0.d0
          do ix = 1, 3
            xxx = xk(ix) - coord(ix, i)
            xx(ix) = xxx
            dist2 = dist2 + xxx * xxx
          end do
          ddi = dd(nati) * a0
          qqi2 = (a0*qq(nati)) ** 2
          ff0 = -qsk * fact * dist2 ** (- 1.5d0)
          if (idel  >  1) then
            rm2 = 1.d0 / dist2
            rm4 = rm2 ** 2
            db(0, 2) = ddi * 3 * xx(1) * rm2
            db(0, 4) = ddi * 3 * xx(2) * rm2
            db(0, 7) = ddi * 3 * xx(3) * rm2
            db(0, 3) = 1.d0 + qqi2 * (15*xx(1)**2*rm2 - 3.d0) * rm2
            db(0, 6) = 1.d0 + qqi2 * (15*xx(2)**2*rm2 - 3.d0) * rm2
            db(0, 10) = 1.d0 + qqi2 * (15*xx(3)**2*rm2 - 3.d0) * rm2
            db(0, 5) = qqi2 * 15 * xx(1) * xx(2) * rm4
            db(0, 8) = qqi2 * 15 * xx(1) * xx(3) * rm4
            db(0, 9) = qqi2 * 15 * xx(3) * xx(2) * rm4
            db(1, 2) = ddi
            db(2, 4) = db(1, 2)
            db(3, 7) = db(1, 2)
            db(1, 3) = 6 * qqi2 * xx(1) * rm2
            db(2, 6) = 6 * qqi2 * xx(2) * rm2
            db(3, 10) = 6 * qqi2 * xx(3) * rm2
            db(1, 5) = db(2, 6)
            db(2, 5) = db(1, 3)
            db(1, 8) = db(3, 10)
            db(3, 8) = db(1, 3)
            db(2, 9) = db(3, 10)
            db(3, 9) = db(2, 6)
          end if
          do j = 1, min(10, (idel*(idel + 1))/2)
            ff = -ff0 * qdenet(iden + j, 3)
            if(j == 1 .and. idel == 9) then
              do iii = 5, 9
                ff = ff - ff0 * qdenet(iden + (iii*(iii + 1))/2, 3)
              end do
            end if
            do ix = 1, 3
              dx = (xx(ix)*db(0, j) - db(ix, j)) * ff
              dxyz(ix, iak) = dxyz(ix, iak) + dx
              dxyz(ix, i) = dxyz(ix, i) - dx
            end do
          end do
        end if
        iden = iden + (idel*(idel + 1))/2
      end do
    end do
end subroutine diegrd
subroutine dmecip (coeffs, deltap, delta, eig, vectci, conf)
    use molkst_C, only : numat, norbs, lm61
    use meci_C, only : lab, nmos, nstate, nelec, microa, microb, occa, nalmat
    use cosmo_C, only : nps, fnsq, amat, bmat, nsetf, &
    phinet, qscnet, qdenet
    use common_arrays_C, only : nfirst, nlast
    use funcon_C, only : ev, a0
    implicit none
    double precision, dimension (lab), intent (inout) :: eig, vectci
    double precision, dimension (lab**2), intent (in) :: conf
    double precision, dimension (norbs, norbs), intent (in) :: coeffs
    double precision, dimension (norbs, nmos), intent (inout) :: delta
    double precision, dimension (nmos, nmos), intent (inout) :: deltap
    integer :: i, iat, id, iden, ii, ij, ist, ix, iy, j, jd, k
    double precision :: edie, fact, sum

    fact = -ev * a0 * fnsq / 2
    do ist = 1, lab
      ii = lab * (ist - 1)
      do j = 1, lab
        vectci(j) = conf(ii + j)
      end do
      !     INITIALIZE WITH THE OPPOSITE OF THE 'SCF' DENSITY.
      do i = 1, nmos
        deltap(i, i) = -occa(i) * 2.d0
        do j = 1, i - 1
          deltap(i, j) = 0.d0
        end do
      end do
      !
      !     ADD THE C.I. CORRECTION
      do id = 1, lab
        do jd = 1, id
            !     CHECK SPIN AGREEMENT
          if (nalmat(id) == nalmat(jd)) then
            ix = 0
            iy = 0
            do j = 1, nmos
              ix = ix + Abs (microa(j, id) - microa(j, jd))
              iy = iy + Abs (microb(j, id) - microb(j, jd))
            end do
               !     CHECK NUMBER OF DIFFERING M.O.
            if (ix + iy  <= 2) then
              if (ix == 2) then
                ! DETERMINANTS ID AND JD DIFFER BY M.O I IN ID AND M.O J IN JD:
                do i = 1, nmos
                  if (microa(i, id) /= microa(i, jd)) exit
                end do
                ij = microb(i, id)
                do j = i + 1, nmos
                  if (microa(j, id) /= microa(j, jd)) exit
                  ij = ij + microa(j, id) + microb(j, id)
                end do
                !        IJ GIVES THE SIGN OF THE PERMUTATION
                sum = 0.d0
                do k = 1, nstate
                  sum = sum + vectci(id + (k - 1)*lab) * vectci(jd + (k - 1)*lab)
                end do
                deltap(j, i) = deltap(j, i) + sum * Dble (1 - 2*Mod(ij, 2)) / &
               & nstate
              else if (iy == 2) then
                ! DETERMINANTS ID AND JD DIFFER BY M.O J IN ID AND M.O I IN JD:
                do i = 1, nmos
                  if (microb(i, id) /= microb(i, jd)) exit
                end do
                ij = 0
                do j = i + 1, nmos
                  if (microb(j, id) /= microb(j, jd)) exit
                  ij = ij + microa(j, id) + microb(j, id)
                end do
                ij = ij + microa(j, id)
                sum = 0.d0
                do k = 1, nstate
                  sum = sum + vectci(id + (k - 1)*lab) * vectci(jd + (k - 1)*lab)
                end do
                deltap(j, i) = deltap(j, i) + sum * Dble (1 - 2*Mod(ij, 2)) / &
                     & nstate
              else
                     !        DETERMINANTS ID AND JD ARE IDENTICAL:
                sum = 0.d0
                do k = 1, nstate
                  sum = sum + vectci(id + (k - 1)*lab) ** 2
                end do
                do i = 1, nmos
                  deltap(i, i) = deltap(i, i) &
                       & + (microa(i, id) + microb(i, id)) * sum / nstate
                end do
              end if
            end if
          end if
        end do
      end do
      !
      !     BACK TRANSFORM INTO A.O. BASIS.
      !    - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      !     P(C.I.) = P(SCF) + C * DELTAP * C'
      do i = 1, nmos
        do j = 1, i - 1
          deltap(j, i) = deltap(i, j)
        end do
      end do
      !     STEP 1: DELTAP = C * DELTAP
      call mxm (coeffs(1, nelec + 1), norbs, deltap, nmos, delta, nmos)
      !     STEP 2: P = P + DELTAP * C'
      iden = 0
      do iat = 1, numat
        do i = nfirst(iat), nlast(iat)
          do j = nfirst(iat), i
            sum = 0.d0
            do k = 1, nmos
              sum = sum + delta (i, k) * coeffs(j, nelec + k)
            end do
            iden = iden + 1
            qdenet(iden, 1) = sum
          end do
        end do
      end do
      ! FIRST CALCULATE THE CORRESPONDING POTENTIAL AS BMAT*QDENET
      do i = 1, nps
        sum = 0.d0
        do j = 1, lm61
          sum = sum + bmat(j, i) * qdenet(j, 1)
        end do
        phinet(i, 1) = sum
      end do
      ! NOW CALCULATE THE CORRESPONDING SCREENING CHARGES FROM A*QSCNET = -QDENE
      call coscl2 (amat, nsetf, qscnet, phinet, nps)
      edie = 0.d0
      ! NOW CALCULATE THE DIELECTRIC ENERGY AS QSCNET*PHINET
      do i = 1, nps
        edie = edie + qscnet(i, 1) * phinet(i, 1)
      end do
      edie = fact * edie
      eig(ist) = eig(ist) + edie
    end do
    do j = 1, lab
      vectci(j) = conf(j)
    end do
end subroutine dmecip
subroutine dvfill (nppa, dirvec)
   !***********************************************************************
   !
   !   DVFILL CALCULATES THE DIRECTION VECTORS.  THESE ARE PUT IN DIRVEC.
   !
   !  (THE VARIOUS SETS FORM ALMOST REGULAR POLYHEDRA WITH IH
   !   SYMMETRY.  A GOOD EXERCISE IS TO SKETCH THE POINTS USING,
   !   E.G. CHEM3D)
   !
   !***********************************************************************
    use chanel_C, only : iw
    use funcon_C, only : pi
    implicit none
    integer, intent (in) :: nppa
    double precision, dimension (4, nppa), intent (inout) :: dirvec
    integer :: i, ix, j, j1, j2, k, m, m2, na, nb, nc, nd
    double precision :: ar, beta, cphi, dist, dist2, h, r, sphi, sumar, t, &
   & xx, yy
    integer, dimension (2, 30) :: kset
    integer, dimension (3, 20) :: fset
    data kset / 1, 2, 1, 3, 1, 4, 1, 5, 1, 6, 12, 11, 12, 10, 12, 9, 12, 8, &
   & 12, 7, 2, 3, 3, 4, 4, 5, 5, 6, 6, 2, 7, 8, 8, 9, 9, 10, 10, 11, 11, 7, 2, &
   & 7, 7, 3, 3, 8, 8, 4, 4, 9, 9, 5, 5, 10, 10, 6, 6, 11, 11, 2 /
    data fset / 1, 2, 3, 1, 3, 4, 1, 4, 5, 1, 5, 6, 1, 6, 2, 12, 11, 10, 12, &
   & 10, 9, 12, 9, 8, 12, 8, 7, 12, 7, 11, 2, 3, 7, 3, 4, 8, 4, 5, 9, 5, 6, &
   & 10, 6, 2, 11, 7, 8, 3, 8, 9, 4, 9, 10, 5, 10, 11, 6, 11, 7, 2 /
    dirvec(1, 1) = -1.d0
    dirvec(2, 1) = 0.d0
    dirvec(3, 1) = 0.d0
    nd = 1
    r = Sqrt (0.8d0)
    h = Sqrt (0.2d0)
    do i = -1, 1, 2
      do j = 1, 5
        nd = nd + 1
        beta = 1.d0 + j * 0.4d0 * pi + (i + 1) * 0.1d0 * pi
        dirvec(2, nd) = r * Cos (beta)
        dirvec(3, nd) = r * Sin (beta)
        dirvec(1, nd) = i * h
      end do
    end do
    dirvec(1, 12) = 1.d0
    dirvec(2, 12) = 0.d0
    dirvec(3, 12) = 0.d0
    nd = 12
    cphi = Cos (1.d0)
    sphi = Sin (1.d0)
    do i = 1, 12
      xx = dirvec(1, i)
      yy = dirvec(2, i)
      dirvec(1, i) = cphi * xx + sphi * yy
      dirvec(2, i) = -sphi * xx + cphi * yy
    end do
   !   NPPA = 10*3**K*M**2 + 2
    m2 = (nppa - 2) / 10
    m = Nint (Sqrt(m2 + 0.d0))
    k = 0
    if (m2 /= m*m) then
      k = 1
      m2 = m2 / 3
      m = Nint (Sqrt(m2 + 0.d0))
    end if
    if (10*3**k*m**2 + 2 /= nppa) then
      write (iw, *) "VALUE OF NPPA NOT ALLOWED: IT MUST BE 10*3**K*M**2 + 2"
      return
    end if
   ! CREATE ON EACH EDGE M - 1 NEW POINTS
    do i = 1, 30
      na = kset(1, i)
      nb = kset(2, i)
      do j = 1, m - 1
        nd = nd + 1
        do ix = 1, 3
          dirvec(ix, nd) = dirvec(ix, na) * (m - j) + dirvec(ix, nb) * j
        end do
      end do
    end do
   ! CREATE POINTS WITHIN EACH TRIANGLE
    do i = 1, 20
      na = fset(1, i)
      nb = fset(2, i)
      nc = fset(3, i)
      do j1 = 1, m - 1
        do j2 = 1, m - j1 - 1
          nd = nd + 1
          do ix = 1, 3
            dirvec(ix, nd) = dirvec(ix, na) * (m - j1 - j2) + dirvec(ix, nb) * &
           & j1 + dirvec(ix, nc) * j2
          end do
        end do
      end do
      if (k /= 0) then
         ! CREATE TWO ADDITIONAL SUBGRIDS
        t = 1.d0 / 3
        do j1 = 0, m - 1
          do j2 = 0, m - j1 - 1
            nd = nd + 1
            do ix = 1, 3
              dirvec(ix, nd) = dirvec(ix, na) * (m - j1 - j2 - 2*t) + dirvec(ix, &
             & nb) * (j1 + t) + dirvec(ix, nc) * (j2 + t)
            end do
          end do
        end do
        t = 2.d0 / 3
        do j1 = 0, m - 2
          do j2 = 0, m - j1 - 2
            nd = nd + 1
            do ix = 1, 3
              dirvec(ix, nd) = dirvec(ix, na) * (m - j1 - j2 - 2*t) + dirvec(ix, &
             & nb) * (j1 + t) + dirvec(ix, nc) * (j2 + t)
            end do
          end do
        end do
      end if
    end do
   ! NORMALIZE ALL VECTORS
    sumar = 0.d0
    do i = 1, nppa
      dist = 0.d0
      do ix = 1, 3
        dist = dist + dirvec(ix, i) ** 2
      end do
      dist = 1.d0 / Sqrt (dist)
      dist2 = (m*dist) ** 2
      do ix = 1, 3
        dirvec(ix, i) = dirvec(ix, i) * dist
      end do
      if (i  <= 12) then
        ar = 5.d0
      else
        ar = 6.d0 * dist2
      end if
      dirvec(4, i) = ar
      sumar = sumar + ar
    end do
    sumar = 4 * pi / sumar
    do i = 1, nppa
      dirvec(4, i) = dirvec(4, i) * sumar
    end do
end subroutine dvfill
subroutine mfinel (ips, k, finel, nar_csm, nsetf, nset, rsc, nipsrs, dirvec, tm, &
& x, r, nfl, ioldcv, maxrs, lenabc, numat)
   !  THIS ROUTINE GENERATES THE LIST OF ALL BASIC GRID POINTS AND
   !  RING - SEGMENTS BELONGING TO SEGMENT IPS
    implicit none
    integer, intent (in) :: ioldcv, ips, k, lenabc, maxrs, numat
    integer, intent (out) :: nfl
    double precision, intent (in) :: r
    integer, dimension (1082*numat), intent (in) :: nset
    integer, dimension (lenabc), intent (in) :: nar_csm, nipsrs, nsetf
    double precision, dimension (3), intent (in) :: x
    double precision, dimension (3, 3), intent (in) :: tm
    double precision, dimension (4, 1082), intent (in) :: dirvec
    double precision, dimension (4, maxrs), intent (in) :: rsc
    double precision, dimension (4, 500, 2), intent (out) :: finel
    integer :: idir, irs, irs0, irs1, ix, l, nari
    double precision, dimension (3) :: y
   !
   ! FIRST THE TRANSFORMED BASIC GRID POINTS
    nfl = 0
    nari = nar_csm(ips)
    do l = nsetf(ips), nsetf(ips) + nari - 1
      idir = nset(l)
      nfl = nfl + 1
      do ix = 1, 3
        y(ix) = dirvec(ix, idir) * r
      end do
      finel(1, nfl, k) = y(1) * tm(1, 1) + y(2) * tm(2, 1) + y(3) * tm &
     & (3, 1) + x(1)
      finel(2, nfl, k) = y(1) * tm(1, 2) + y(2) * tm(2, 2) + y(3) * tm &
     & (3, 2) + x(2)
      finel(3, nfl, k) = y(1) * tm(1, 3) + y(2) * tm(2, 3) + y(3) * tm &
     & (3, 3) + x(3)
      finel(4, nfl, k) = dirvec(4, idir) * r * r
    end do
    if (ioldcv == 1) return
   ! NOW THE ASSOCIATED RINGSEGMENTS
    irs0 = 1
    if (ips > 1) then
      irs0 = nipsrs(ips - 1) + 1
    end if
    irs1 = nipsrs(ips)
    do irs = irs0, irs1
      nfl = nfl + 1
      do ix = 1, 4
        finel(ix, nfl, k) = rsc (ix, irs)
      end do
    end do
end subroutine mfinel
subroutine mkbmat
    use molkst_C, only : numat, method_indo
    use cosmo_C, only : nps, bmat, cosurf
    use parameters_C, only : dd, qq, dsd, dpd, ddd
    use funcon_C, only : a0
    use common_arrays_C, only : coord, nfirst, nlast, nat
    implicit none
    integer :: i, ia, idel, iden, ips, ix, nati, iii
    double precision :: ddi, dist, qqi2, rm1, rm3, rm5, dsdi, dpdi, dddi, atmp
    double precision, dimension (3) :: xa
   ! FILLING B - MATRIX
    iden = 0
    do i = 1, numat
      ia = nfirst(i)
      idel = nlast(i) - ia + 1
      nati = nat(i)
      ddi = dd(nati) * a0
      qqi2 = (a0*qq(nati)) ** 2
!
! replace dd and qq with terms that work for d orbitals
!
      dsdi = (dsd(nati)*a0)**2
      dpdi = dpd(nati)*a0
      dddi = (ddd(nati)*a0)**2
      do ips = 1, nps
        dist = 0.d0
        do ix = 1, 3
          xa(ix) = cosurf(ix, ips) - coord(ix, i)
          dist = dist + xa(ix) ** 2
        end do
        rm1 = 1.d0 / Sqrt (dist)
        bmat(iden + 1, ips) = rm1
        if (idel > 1) then
          rm3 = rm1 ** 3
          rm5 = rm1 ** 5
!
!   INDO off - diagonal terms are zero - preset here
!
          do iii = iden + 2, iden + 9
            bmat(iii, ips) = 0.d0
          end do
          bmat(iden + 3, ips) = rm1 + 3 * xa(1) ** 2 * qqi2 * rm5 - qqi2 * &
         & rm3
          bmat(iden + 6, ips) = rm1 + 3 * xa(2) ** 2 * qqi2 * rm5 - qqi2 * &
         & rm3
          bmat(iden + 10, ips) = rm1 + 3 * xa(3) ** 2 * qqi2 * rm5 - qqi2 &
         & * rm3
!
!  s - p terms (2, 4, 7) and p - p terms (5, 8, 9) for non - INDO methods
!
          if (.not. method_indo) then
            bmat(iden + 2, ips) = xa(1) * ddi * rm3
            bmat(iden + 4, ips) = xa(2) * ddi * rm3
            bmat(iden + 7, ips) = xa(3) * ddi * rm3
            bmat(iden + 5, ips) = 3 * xa(1) * xa(2) * qqi2 * rm5
            bmat(iden + 8, ips) = 3 * xa(1) * xa(3) * qqi2 * rm5
            bmat(iden + 9, ips) = 3 * xa(3) * xa(2) * qqi2 * rm5
          end if
! c now the d-orbitals in spherical symmetry
          if(idel > 4) then
            do iii = iden + 11, iden + 44
              bmat(iii, ips) = 0.d0
            end do
            do iii = 5, 9
              bmat(iden + (iii*(iii + 1))/2, ips) = rm1
            end do
! Replace spherically symmetric d orbitals with terms from
! J. Phys. Chem. B 2005, 109, 9799
            if (method_indo) then
              do iii = iden + 11, iden + 44
                bmat(iii, ips) = 0.d0
              end do
! Order of INDO d orbitals:  z^2, x^2 - y^2, xy, xz, yz
! d-d self interactions
              bmat(iden + 15, ips) = rm1 - dddi*rm3 + 3*dddi*xa(3)**2*rm5   ! z^2
              bmat(iden + 21, ips) = rm1 + dddi*rm3 - 3*dddi*xa(3)**2*rm5   ! x^2 - y^2
              bmat(iden + 28, ips) = rm1 + dddi*rm3 - 3*dddi*xa(3)**2*rm5   ! xy
              bmat(iden + 36, ips) = rm1 + dddi*rm3 - 3*dddi*xa(2)**2*rm5   ! xz
              bmat(iden + 45, ips) = rm1 + dddi*rm3 - 3*dddi*xa(1)**2*rm5   ! yz
            else
! Order of MOPAC d orbitals: x^2 - y^2, xz, z^2, yz, xy
              bmat(iden + 15, ips) = rm1 + dddi*rm3 - 3*dddi*xa(3)**2*rm5   ! x^2 - y^2
              bmat(iden + 21, ips) = rm1 + dddi*rm3 - 3*dddi*xa(2)**2*rm5   ! xz
              bmat(iden + 28, ips) = rm1 - dddi*rm3 + 3*dddi*xa(3)**2*rm5   ! z^2
              bmat(iden + 36, ips) = rm1 + dddi*rm3 - 3*dddi*xa(1)**2*rm5   ! yz
              bmat(iden + 45, ips) = rm1 + dddi*rm3 - 3*dddi*xa(3)**2*rm5   ! xy

!     s - d terms
              atmp = 2*xa(3)**2 - xa(1)**2 - xa(2)**2
              bmat(iden + 11, ips) = 3*dsdi*(xa(1)**2 - xa(2)**2)*rm5/2.d0    ! x^2 - y^2
              bmat(iden + 16, ips) = 3*dsdi*xa(1)*xa(3)*rm5                 ! xz
              bmat(iden + 22, ips) = sqrt(3.d0)*atmp*rm5/2.d0               ! z^2
              bmat(iden + 29, ips) = 3*dsdi*xa(2)*xa(3)*rm5                 ! yz
              bmat(iden + 37, ips) = 3*dsdi*xa(1)*xa(2)*rm5                 ! xy

!     p - d terms
!             dx^2 - y^2
              bmat(iden + 12, ips) = dpdi*xa(1)*rm3
              bmat(iden + 13, ips) = dpdi*xa(2)*rm3
              bmat(iden + 14, ips) = 0.d0
!             dxz
              bmat(iden + 17, ips) = dpdi*xa(3)*rm3
              bmat(iden + 18, ips) = 0.d0
              bmat(iden + 19, ips) = dpdi*xa(1)*rm3
!             dz^2
              bmat(iden + 23, ips) = -dpdi*xa(1)*rm3/sqrt(3.d0)
              bmat(iden + 24, ips) = -dpdi*xa(2)*rm3/sqrt(3.d0)
              bmat(iden + 25, ips) = 2*dpdi*xa(3)*rm3/sqrt(3.d0)
!             dyz
              bmat(iden + 30, ips) = 0.d0
              bmat(iden + 31, ips) = dpdi*xa(3)*rm3
              bmat(iden + 32, ips) = dpdi*xa(2)*rm3
!             dxy
              bmat(iden + 38, ips) = dpdi*xa(2)*rm3
              bmat(iden + 39, ips) = dpdi*xa(1)*rm3
              bmat(iden + 40, ips) = 0.d0

!     d-d non - self terms
              bmat(iden + 20, ips) = 3*dddi*xa(1)*xa(3)*rm5             ! dxz - dx^2 - y^2
              bmat(iden + 26, ips) = 3*dddi*rm5*(xa(1)**2 - xa(2)**2)   ! dz^2 - dx^2 - y^2
              bmat(iden + 27, ips) = sqrt(3.d0)*dddi*rm5*xa(1)*xa(3)    ! dz^2 - dxz
              bmat(iden + 33, ips) = 3*dddi*xa(2)*xa(3)*rm5             ! dyz - dx^2 - y^2
              bmat(iden + 34, ips) = 3*dddi*xa(1)*xa(2)*rm5             ! dyz - dxz
              bmat(iden + 35, ips) = sqrt(3.d0)*dddi*rm5*xa(2)*xa(3)    ! dyz - dz^2
              bmat(iden + 41, ips) = 0                                  ! dxy - dx^2 - y^2
              bmat(iden + 42, ips) = 3*dddi*xa(2)*xa(3)*rm5             ! dxy - dxz
              bmat(iden + 43, ips) = -2*sqrt(3.d0)*dddi*rm5*xa(1)*xa(2) ! dxy - dz^2
              bmat(iden + 44, ips) = 3*dddi*xa(1)*xa(3)*rm5             ! dxy - dyz
            end if
          end if
! c end d-orbitals
        end if
      end do
      iden = iden + (idel*(idel + 1))/2
    end do
end subroutine mkbmat
subroutine surclo (coord, nipa, lipa, din, dim_din, rsc, isort, ipsrs, nipsrs, nat, &
& srad, cosurf, iatsp, nar_csm, nsetf, isude, sude, maxrs)
   ! CREATES SEGMENTS WHICH CLOSE THE CONCAVE REGIONS OF THE CAVITY
    use cosmo_C, only : n0, lenabc, nipc, rsolv, area, &
       & cosvol, nps
    use molkst_C, only : numat
    use funcon_C, only : pi, twopi
    implicit none
    integer, intent (in) :: maxrs, dim_din
    logical, dimension (dim_din), intent (in) :: din
    integer, dimension (lenabc + 1), intent (inout) :: iatsp, nar_csm, nsetf
    integer, dimension (maxrs), intent (in) :: lipa
    integer, dimension (maxrs), intent (out) :: ipsrs, isort
    integer, dimension (numat), intent (in) :: nat, nipa
    integer, dimension (lenabc), intent (out) :: nipsrs
    integer, dimension (2, 30*numat), intent (out) :: isude
    double precision, dimension (numat), intent (in) :: srad
    double precision, dimension (2, 30*numat), intent (out) :: sude
    double precision, dimension (3, numat), intent (in) :: coord
    double precision, dimension (4, lenabc + 1), intent (inout) :: cosurf
    double precision, dimension (4, maxrs), intent (out) :: rsc
    integer :: i, i2, i3, ia, iat, iat0, ib, ic, ich, iib, iic, iii, &
         & ik, il, ilipa, ip1, ips, ips0, ips1, ipsmin, is, isum, &
         & isum2, ix, ja, jb, jc, k, l, nrs, nsa, nsab, ntrp, ntrp2
    double precision :: aa, aad, aar, ab, abd, abr, arseg, arsegn, ca, cj, &
         & cnrs, cosa, cosb, cphi, d2, d2max, d2min, da, dab, dabc, &
         & dabck, ddd, dist, dp, hh, htr, phi, phio, phiu, ra, rb, rc, &
         & sina, sj, sp
    double precision :: sphi, spn, spn2, spx, spy, sss, sumphi, &
         & xxx, dac, dbc, rinc, tar
    integer, dimension (50) :: iset
    double precision, dimension (2) :: fz, yx
    double precision, dimension (3) :: rvx, rvy, trp, tvx, tvy, xd, xja, &
         & xjb, xjc, xx
    double precision, dimension (50) :: phiset
    double precision, dimension (3, 3) :: ee, xta
    double precision, dimension (50) :: tarset
    htr = 0.d0
    tarset = 0.d0
    nipc = 0
    nrs = 0
    iset = 0
   ! GENERATION OF SEGMENTS ALONG THE INTERSECTION RINGS
    ilipa = 0
    do i = 1, numat
      nipsrs(i) = 0
    end do
    do ia = 1, numat - 1
      if (.not. din(ia)) then
        ra = srad(ia) + rsolv
        do ix = 1, 3
          xta(ix, 1) = coord(ix, ia)
        end do
        do iib = ilipa + 1, ilipa + nipa(ia)
          ib = lipa(iib)
          if (ib > ia) then
            if (.not. din(ib)) then
              rb = srad(ib) + rsolv
              dab = 0.d0
              nsab = 0
              do ix = 1, 3
                xta(ix, 2) = coord(ix, ib)
                xx(ix) = xta(ix, 2) - xta(ix, 1)
                dab = dab + xx(ix) ** 2
              end do
              dab = Sqrt (dab)
              call ansude (ra - rsolv, rb - rsolv, dab, rsolv, aa, ab, aar, abr, &
             & aad, abd, rinc)
              cosa = (ra**2 + dab**2 - rb**2) / (2*dab*ra)
              cosb = (rb**2 + dab**2 - ra**2) / (2*dab*rb)
              sina = Sqrt (1.d0 - cosa**2)
              da = ra * cosa
              hh = ra * sina
              ddd = rsolv * (cosa + cosb) / dab
              fz(1) = (1.d0 - Cos (hh*pi/ra)) / 2
              fz(2) = (1.d0 - Cos (hh*pi/rb)) / 2
              if (cosa*cosb < 0d0) then
                fz(1) = 1.d0
              end if
              if (cosa*cosb < 0d0) then
                fz(2) = 1.d0
              end if
              yx(1) = rsolv / ra
              yx(2) = rsolv / rb
              do ix = 1, 3
                xd(ix) = xta(ix, 1) + da * xx(ix) / dab
              end do
                  !  CREATE RING VECTORS
              rvx(1) = xx(2) * 3.d0 - xx(3) * 2.d0
              rvx(2) = xx(3) * 1.d0 - xx(1) * 3.d0
              rvx(3) = xx(1) * 2.d0 - xx(2) * 1.d0
              dist = Sqrt (rvx(1)**2 + rvx(2)**2 + rvx(3)**2)
              if(dist < 1d-9) then
                rvx(1) = xx(2)*4.d0 - xx(3)*2.d0
                rvx(2) = xx(3)*1.d0 - xx(1)*4.d0
                rvx(3) = xx(1)*2.d0 - xx(2)*1.d0
                dist = sqrt(rvx(1)**2 + rvx(2)**2 + rvx(3)**2)
              end if
              do ix = 1, 3
                rvx(ix) = hh * rvx(ix) / dist
              end do
              rvy(1) = (xx(2)*rvx(3) - xx(3)*rvx(2)) / dab
              rvy(2) = (xx(3)*rvx(1) - xx(1)*rvx(3)) / dab
              rvy(3) = (xx(1)*rvx(2) - xx(2)*rvx(1)) / dab
                  ! NOW ALL TRIPLE POINTS ON THE RING ARE SEARCHED
              ntrp = 0
              ntrp2 = 0
              do iic = ilipa + 1, ilipa + nipa(ia)
                ic = lipa(iic)
                if (ic /= ib) then
                  rc = srad(ic) + rsolv
                  dabc = 0.d0
                  sp = 0.d0
                  do ix = 1, 3
                    xxx = coord(ix, ic) - xd(ix)
                    xta(ix, 3) = coord(ix, ic)
                    sp = sp + xxx * xx(ix)
                    dabc = dabc + xxx ** 2
                  end do
                  dabc = Sqrt (dabc)
                  cosa = sp / dab / dabc
                           ! AVOID PROBLEMS WITH NUMERICAL ACCURACY
                  sina = Sqrt (Max(1.d-28, 1.d0 - cosa*cosa))
                  cj = (dabc*dabc + hh*hh - rc*rc) / (2*dabc*hh*sina)
                  if (cj < 1.d0) then
                    ntrp2 = ntrp2 + 2
                  end if
                  if (cj  <= 1.d0 .and. cj >= -1.d0) then
                    sj = Sqrt (1.d0 - cj*cj)
                              !
                    do ix = 1, 3
                      tvx(ix) = (xta(ix, 3) - xd(ix)) - cosa * dabc * xx(ix) / &
                     & dab
                    end do
                    dist = Sqrt (tvx(1)**2 + tvx(2)**2 + tvx(3)**2)
                    do ix = 1, 3
                      tvx(ix) = hh * tvx(ix) / dist
                    end do
                    tvy(1) = (xx(2)*tvx(3) - xx(3)*tvx(2)) / dab
                    tvy(2) = (xx(3)*tvx(1) - xx(1)*tvx(3)) / dab
                    tvy(3) = (xx(1)*tvx(2) - xx(2)*tvx(1)) / dab
                    loop: do l = -1, 1, 2
                      il = ntrp + 1
                      do ix = 1, 3
                        trp(ix) = xd(ix) + cj * tvx(ix) + sj * tvy(ix) * l
                      end do
                      do ik = ilipa + 1, ilipa + nipa(ia)
                        k = lipa(ik)
                        if (k /= ib .and. k /= ic) then
                          dabck = 0.d0
                          do ix = 1, 3
                            dabck = dabck + (trp(ix) - coord(ix, k)) ** 2
                          end do
                          dabck = Sqrt (dabck)
                          if (dabck < srad(k) + rsolv) cycle loop
                        end if
                      end do
                      ntrp = ntrp + 1
                      spx = 0.d0
                      spy = 0.d0
                      do ix = 1, 3
                        spx = spx + rvx(ix) * (trp(ix) - xd(ix))
                        spy = spy + rvy(ix) * (trp(ix) - xd(ix))
                      end do
                      phi = Acos (spx/(hh**2 + 1.d-10))
                      if (spy < 0.d0) then
                        phi = -phi
                      end if
                      phiset(il) = phi
                      sp = 0.d0
                      do ix = 1, 3
                        sp = sp + (- spy*rvx(ix) + spx*rvy(ix)) * &
                       & (trp(ix) - xta(ix, 3))
                      end do
                      iset(ntrp) = 1
                      if (sp < 0.d0) then
                        iset(ntrp) = -1
                      end if
! first calculate the edges of the triangle
                      sp = 0.d0
                      dac = 0.d0
                      dbc = 0.d0
                      do ix = 1, 3
                        ee(ix, 1) = trp(ix) + rsolv / srad(ia) &
                             & * (xta(ix, 1) - trp(ix))
                        ee(ix, 2) = trp(ix) + rsolv / srad(ib) &
                             & * (xta(ix, 2) - trp(ix))
                        ee(ix, 3) = trp(ix) + rsolv / srad(ic) &
                             & * (xta(ix, 3) - trp(ix))
                        sp = sp + (ee(ix, 1) - ee(ix, 3)) * (ee(ix, 2) - ee(ix, 3))
                        dac = dac + (ee(ix, 1) - ee(ix, 3)) &
                             & * (ee(ix, 1) - ee(ix, 3))
                        dbc = dbc + (ee(ix, 2) - ee(ix, 3)) &
                             & * (ee(ix, 2) - ee(ix, 3))
                      end do
                      tarset(il) = 0.8d0 * Sqrt (dac*dbc - sp*sp) / 12
                    end do loop
                  end if
                end if
              end do
                  ! SORT THE SET OF TRIPLE POINTS ON THE RING
              if (Mod(ntrp, 2) /= 0) then
                call mopend ("ODD NTRP")
              end if
              if (ntrp > 18) then
                call mopend ("NTRP TOO LARGE")
              end if
              if (ntrp + ntrp2 == 0) then
                phiset(1) = 0
                phiset(2) = twopi
                tarset(2) = 0.d0
                iset(1) = 1
                iset(2) = -1
                ntrp = 2
              end if
              do
                ic = 0
                do l = 2, ntrp
                  if (phiset(l) < phiset(l - 1)) then
                    phi = phiset(l)
                    iii = iset(l)
                    tar = tarset(l)
                    phiset(l) = phiset(l - 1)
                    iset(l) = iset(l - 1)
                    tarset(l) = tarset(l - 1)
                    phiset(l - 1) = phi
                    iset(l - 1) = iii
                    tarset(l - 1) = tar
                    ic = ic + 1
                  end if
                end do
                if (ic  <= 0) then
                  if (iset(1) == -1) then
                    phiset(1) = phiset(1) + twopi
                  else
                    exit
                  end if
                end if
              end do
                  ! NOW FOR EACH CONTINUOUS SECTION OF THE RING TRIANGLES ARE CREATED
              sumphi = 0.d0
              ips0 = nrs
              do l = 2, ntrp, 2
                k = l - 1
                phiu = phiset(k)
                phio = phiset(l)
                nsa = Int ((phio - phiu)/2/pi*20)
                nsa = Max (nsa + 1, 2)
                sumphi = sumphi + phio - phiu
                dp = (phio - phiu) / (nsa - 1)
                do ich = 1, 2
                  iat = ib
                  if (ich == 2) then
                    iat = ia
                  end if
                  if (iat == ia) then
                    htr = aar / twopi
                  end if
                  if (iat == ib) then
                    htr = abr / twopi
                  end if
                  do ja = ich, nsa, 2
                    jb = Max (ja - 1, 1)
                    jc = Min (ja + 1, nsa)
                    phi = phiu + (ja - 1) * dp
                    cphi = Cos (phi)
                    sphi = Sin (phi)
                    do ix = 1, 3
                      ca = xd(ix) + (cphi*rvx(ix) + sphi*rvy(ix)) * fz(ich)
                      ca = ca + (xta(ix, ich) - ca) * yx(ich)
                      xja(ix) = ca + (xta(ix, 3 - ich) - xta(ix, ich)) * ddd * &
                     & (1.d0 - fz(ich))
                    end do
                    phi = phiu + (jb - 1) * dp
                    cphi = Cos (phi)
                    sphi = Sin (phi)
                    do ix = 1, 3
                      ca = xd(ix) + cphi * rvx(ix) + sphi * rvy(ix)
                      xjb(ix) = ca + (xta(ix, 3 - ich) - ca) * yx(3 - ich)
                    end do
                    phi = phiu + (jc - 1) * dp
                    cphi = Cos (phi)
                    sphi = Sin (phi)
                    do ix = 1, 3
                      ca = xd(ix) + cphi * rvx(ix) + sphi * rvy(ix)
                      xjc(ix) = ca + (xta(ix, 3 - ich) - ca) * yx(3 - ich)
                    end do
                    nrs = nrs + 1
                    nsab = nsab + 1
                    sp = 0.d0
                    d2 = 0.d0
                    spn = 0.d0
                    spn2 = 0.d0
                    dist = 0.d0
                    ipsrs(nrs) = ib
                    if (ich == 2) then
                      ipsrs(nrs) = ia
                    end if
                    iat = ipsrs(nrs)
                    nipsrs(iat) = nipsrs(iat) + 1
                    do ix = 1, 3
                      rsc (ix, nrs) = (xja(ix)*.5d0 + xjb(ix) + xjc(ix)) / 2.5d0
                      i2 = Mod (ix, 3) + 1
                      i3 = Mod (i2, 3) + 1
                      cnrs = (xjc(i2) - xjb(i2)) * (xja(i3) - xjb(i3)) - &
                     & (xja(i2) - xjb(i2)) * (xjc(i3) - xjb(i3))
                      dist = dist + cnrs ** 2
                      spn = spn + cnrs * (rsc (ix, nrs) - coord(ix, iat))
                      spn2 = spn2 + cnrs * rsc (ix, nrs)
                    end do
                    dist = 1.d0 / Sqrt (dist)
                    if (spn < 0.d0) then
                      dist = -dist
                    end if
                    rsc(4, nrs) = (jc - jb)*dp*htr
                    if (ja  ==  1)   rsc (4, nrs) = rsc (4, nrs) + tarset(k) * rinc
                    if (ja  ==  nsa) rsc (4, nrs) = rsc (4, nrs) + tarset(l) * rinc
                    cosvol = cosvol + rsc (4, nrs) * spn2 * dist
                    do ik = ilipa + 1, ilipa + nipa(ia)
                      k = lipa(ik)
                      if (k  ==  ib) cycle
                      dabck = 0.d0
                      do ix = 1, 3
                        dabck = dabck + (rsc(ix, nrs) - coord(ix, k))**2
                      end do
                      dabck = sqrt(dabck)
                    end do
                    area = area + rsc (4, nrs)
                  end do
                end do
              end do
              if (sumphi > 1.d-10) then
                nipc = nipc + 1
                isude(1, nipc) = ia
                isude(2, nipc) = ib
                sumphi = sumphi / twopi
                sude(1, nipc) = aad * sumphi
                sude(2, nipc) = abd * sumphi
              end if
            end if
          end if
        end do
      end if
      ilipa = ilipa + nipa(ia)
    end do
    if (nrs > maxrs) then
      call mopend ("NRS .GT. MAXRS IN SURCLO")
    end if
   ! NOW SORT THE SEGMENTS WITH RESPECT TO ATOMS
    isum = 0
    do iat = 1, numat
      isum2 = isum + nipsrs(iat)
      nipsrs(iat) = isum
      isum = isum2
    end do
    do i = 1, nrs
      iat = ipsrs(i)
      isum2 = nipsrs(iat) + 1
      nipsrs(iat) = isum2
      isort(i) = isum2
    end do
    do i = 1, nrs
      do while (isort(i) /= i)
        is = isort(i)
        do ix = 1, 4
          sss = rsc (ix, i)
          rsc (ix, i) = rsc (ix, is)
          rsc (ix, is) = sss
        end do
        iii = ipsrs(i)
        ipsrs(i) = ipsrs(is)
        ipsrs(is) = iii
        isort(i) = isort(is)
        isort(is) = is
      end do
    end do
   ! NOW FIND FOR EACH RINGSEGMENT THE NEAREST SEGMENT OUT OF THE SAME ATOM
    do i = 1, nps
      nipsrs(i) = 0
    end do
    iat0 = 0
    ips0 = 0
    ips1 = 0
    d2max = 0.d0
    do i = 1, nrs
      iat = ipsrs(i)
      if (iat > iat0) then
        iat0 = iat
        d2max = 16 * srad(iat) ** 2 / n0(1)
        if (nat(iat) == 1) then
          d2max = d2max * n0(1) / n0(2)
        end if
        do ips = ips1 + 1, nps
          if (iatsp(ips) == iat) exit
        end do
        ips0 = ips
        do ips = ips0, nps - 1
          if (iatsp(ips + 1) > iat) exit
        end do
        ips1 = ips
      end if
      ipsmin = 0
      d2min = 1d6
      do ips = ips0, ips1
        d2 = 0.d0
        do ix = 1, 3
          d2 = d2 + (cosurf(ix, ips) - rsc (ix, i)) ** 2
        end do
        if (d2 < d2min) then
          ipsmin = ips
          d2min = d2
        end if
      end do
      if (d2min > d2max) then
         ! IF NO CLOSE ENOUGH SEGMENT IS PRESENT ADD A NEW ONE
        ips1 = ips1 + 1
        do ips = nps, ips1, - 1
          ip1 = ips + 1
          do ix = 1, 4
            cosurf(ix, ip1) = cosurf(ix, ips)
          end do
          iatsp(ip1) = iatsp(ips)
          nsetf(ip1) = nsetf(ips)
          nar_csm(ip1) = nar_csm(ips)
          nipsrs(ip1) = nipsrs(ips)
        end do
        ipsrs(i) = ips1
        nps = nps + 1
        do ix = 1, 4
          cosurf(ix, ips1) = rsc (ix, i)
        end do
        iatsp(ips1) = iatsp(ips1 - 1)
        nar_csm(ips1) = 0
        nipsrs(ips1) = 1
        nsetf(ips1) = nsetf(ips1 + 1)
      else
        ipsrs(i) = ipsmin
        nipsrs(ipsmin) = nipsrs(ipsmin) + 1
         ! UPDATE THE SEGMENT WITH RESPECT TO ADDED RING - SEGMENT
        arseg = cosurf(4, ipsmin)
        arsegn = arseg + rsc (4, i)
        do ix = 1, 3
          cosurf(ix, ipsmin) = (arseg*cosurf(ix, ipsmin) + rsc (4, i)*rsc (ix, &
         & i)) / arsegn
        end do
        cosurf(4, ipsmin) = arsegn
      end if
    end do
   ! NOW SORT THE RING - SEGMENTS WITH RESPECT TO PRIMARY SEGMENTS
    isum = 0
    do ips = 1, nps
      isum2 = isum + nipsrs(ips)
      nipsrs(ips) = isum
      isum = isum2
    end do
    do i = 1, nrs
      ips = ipsrs(i)
      isum2 = nipsrs(ips) + 1
      nipsrs(ips) = isum2
      isort(i) = isum2
    end do
    do i = 1, nrs
      do while (isort(i) /= i)
        is = isort(i)
        do ix = 1, 4
          sss = rsc (ix, i)
          rsc (ix, i) = rsc (ix, is)
          rsc (ix, is) = sss
        end do
        isort(i) = isort(is)
        isort(is) = is
      end do
    end do
end subroutine surclo
subroutine cosini(l_print)
    use cosmo_C, only : n0, ioldcv, fnsq, nps, rsolv, nspa, disex2, &
    dirsm, dirvec, srad, ipiden, gden, idenat, qdenet, amat, &
    cmat, lenabc, arat, sude, isude, bh, qden, nar_csm, nsetf, phinet, &
    qscnet, bmat, nset, xsp, abcmat, iatsp, nn, qscat, cosurf, nppa, &
    ffact, fepsi, nden
    use common_arrays_C, only : nat, nfirst, nlast
    use molkst_C, only : numat, keywrd, moperr, lm61, mozyme, line, jobnam
    use chanel_C, only : iw
    implicit none
    logical, intent (in) :: l_print
    integer :: i, i0, iat, idel, iden, incif, indise, inrsol, j, k, n1, &
   & n2, nfi, nfj, ns, nsp, nspd
    double precision :: disex, ri1, x
    double precision, dimension (107) :: rvdw, usevdw
    integer, external :: ijbo
    double precision, external :: reada
    data rvdw / &
   1.30d0,  1.64d0,  2.13d0,  2.19d0,  2.05d0,  2.00d0,  1.83d0,  1.72d0, &
   1.72d0,  1.80d0,  2.66d0,  2.02d0,  2.41d0,  2.46d0,  2.11d0,  2.16d0, &
   2.05d0,  2.20d0,  3.22d0,  2.54d0,  2.64d0,  2.64d0,  2.52d0,  2.40d0, &
   2.46d0,  2.41d0,  2.40d0,  1.91d0,  1.64d0,  1.63d0,  2.19d0,  2.46d0, &
   2.22d0,  2.22d0,  2.16d0,  2.36d0,  3.78d0,  3.44d0,  3.39d0,  3.33d0, &
   3.28d0,  2.57d0,  2.57d0,  2.57d0,  2.57d0,  1.91d0,  2.01d0,  1.85d0, &
   2.26d0,  2.54d0,  2.53d0,  2.41d0,  2.32d0,  2.53d0,  4.00d0,  3.47d0, &
   2.81d0,  2.81d0,  2.81d0,  2.81d0,  2.81d0,  2.81d0,  2.81d0,  2.81d0, &
   2.81d0,  2.81d0,  2.81d0,  2.81d0,  2.81d0,  2.81d0,  2.81d0,  2.57d0, &
   2.57d0,  2.57d0,  2.57d0,  2.57d0,  2.57d0,  2.05d0,  1.94d0,  1.81d0, &
   2.29d0,  2.36d0,  2.64d0,  2.64d0,  2.63d0,  2.69d0,  2.57d0,  2.57d0, &
   2.57d0,  2.57d0,  2.57d0,  2.18d0,  2.57d0,  2.57d0,  2.57d0,  2.57d0, &
   2.57d0,  2.57d0,  2.57d0,  2.57d0,  2.57d0,  2.57d0,  5*2.d0/
    lenabc = max(100, nspa*numat)
    ns = 0
    nsp = 0
    nspd = 0
    do i = 1, numat
      if (nlast(i) - nfirst(i) == 0) then
        ns = ns + 1
      else if (nlast(i) - nfirst(i) == 3) then
        nsp = nsp + 1
      else
        nspd = nspd + 1
      end if
    end do
    nden = 1*ns + 10*nsp + 45*nspd
    if (allocated(ipiden)) deallocate (ipiden)
    if (allocated(idenat)) deallocate (idenat)
    if (allocated(gden))   deallocate (gden)
    if (allocated(qdenet)) deallocate (qdenet)
    if (allocated(phinet)) deallocate (phinet)
    if (allocated(qscnet)) deallocate (qscnet)
    if (allocated(abcmat)) deallocate (abcmat)
    if (allocated(bmat))   deallocate (bmat)
    if (allocated(cmat))   deallocate (cmat)
    if (allocated(qscat))  deallocate (qscat)
    if (allocated(srad))   deallocate (srad)
    if (allocated(iatsp))  deallocate (iatsp)
    if (allocated(nar_csm))deallocate (nar_csm)
    if (allocated(nn))     deallocate (nn)
    if (allocated(cosurf)) deallocate (cosurf)
    if (allocated(xsp))    deallocate (xsp)
    if (allocated(nset))   deallocate (nset)
    if (allocated(bh))     deallocate (bh)
    if (allocated(qden))   deallocate (qden)
    if (allocated(nar_csm))    deallocate (nar_csm)
    if (allocated(nsetf))  deallocate (nsetf)
    if (allocated(isude))  deallocate (isude)
    if (allocated(sude))   deallocate (sude)
    if (allocated(arat))   deallocate (arat)
    if (allocated(amat))   deallocate (amat)
    allocate(ipiden(lm61), idenat(numat), gden(lm61), &
          qdenet(lm61, 3), phinet(lenabc + 1, 3), qscnet(lenabc + 1, 3), &
          qscat(numat), stat = i)
          qscat = 0.d0
    if (i /= 0) then
      call memory_error("COSINI (0) in Cosmo")
      return
    end if
    allocate(srad(numat), nn(3, numat), qden(lm61), &
          iatsp(lenabc + 1), isude(2, 30*numat), nar_csm(lenabc + 1), &
          arat(numat), sude(2, 30*numat), nsetf(lenabc + 1), cosurf(4, lenabc), stat = i)
    nsetf = 0 ! Added to fix gaps in nsetf's initialization, which might indicate a deeper flaw
    if (i /= 0) then
      call memory_error("COSINI (1) in Cosmo")
      return
    end if
    if (.not. mozyme) then
      allocate(abcmat(lenabc), xsp(3, lenabc), nset(nppa*numat), bh(lenabc), stat = j)
      allocate(bmat(lm61, lenabc), stat = i)
      j = j + i
      allocate(amat((lenabc*(lenabc + 1))/2), stat = i)
      j = j + i
      allocate(cmat((lm61*(lm61 + 1))/2), stat = i)
      j = j + i
      if (j /= 0) then
        if (l_print) then
          write(line, '(a, i5, a)')"Data set '"//trim(jobnam)//"' exists, "
          write(0, '(//10x, a)')trim(line)
          call mopend(trim(line))
          write(line, '(a)')"but is too large to run using COSMO."
          write(0, '(//10x, a)')trim(line)
          call mopend(trim(line))
          write(line, '(a, i5, a)')"(This job might run if MOZYME is used.)"
          write(0, '(/10x, a, //)')trim(line)
          write(iw, '(/10x, a, //)')trim(line)
        end if
        call memory_error("COSINI (2) in Cosmo")
        return
      end if
      cmat = 0.d0
    end if
    call extvdw (usevdw, rvdw)
    if (moperr) return
    rsolv = 1.30005d0
    ioldcv = 0
    inrsol = Index (keywrd, " RSOLV=")
    if (inrsol /= 0) then
      rsolv = reada (keywrd, inrsol)
    end if
    if (rsolv < 0.5d0) then
      write (iw, *) "RSOLV IS SET TO 0.5"
      return
    end if
    if (moperr) return
    ri1 = 2.d0
    incif = Index (keywrd, "N**2")
    if (incif /= 0) then
      ri1 = reada (keywrd, incif + 4)
      if (ri1 < 0.d0) then
        write (iw, *) "     N**2 CANNOT BE NEGATIVE"
        call mopend ("N**2 CANNOT BE NEGATIVE")
        return
      else if (0.d0 < ri1 .and. ri1 < 1.d0) then
        write (iw, *) "     N**2 IS SMALLER THAN 1.d0, OK?"
      end if
    end if
    fnsq = (ri1 - 1.d0) / (ri1 + .5d0)
!
!  Set ffact for later use
!
    if (fepsi > 0.d0) then
      ffact = fnsq/fepsi
    else
      ffact = 0.d0
    end if
    nps = 0
   ! NO KEYWORD DELSC ANYMORE. PEOPLE MAY USE EXPLICIT
   ! DEFINITION OF RADII TO CHANGE FROM DEFAULTS! RDS IS REPLACED BY RSOLV
    rsolv = Max (rsolv, 0.5d0)
    disex = 4.d0
    indise = Index (keywrd, " DISEX=")
    if (indise /= 0) then
      disex = reada (keywrd, indise)
    end if
   ! FILL THE COSMO - RADII (SRAD) AND INDEX - VECTORS IDENAT AND IPIDEN
    iden = 0
    do i = 1, numat
      nfi = nfirst(i)
      idenat(i) = iden + 1
      idel = nlast(i) + 1 - nfi
      if (mozyme) then
        i0 = ijbo (i, i)
        do j = 1, idel
          nfj = nfi - 1 + j
          do k = 1, j
            iden = iden + 1
            i0 = i0 + 1
            ipiden(iden) = i0
            gden(iden) = -2.0d0
          end do
          gden(iden) = -1.0d0
        end do
      else
        do j = 1, idel
          nfj = nfi - 1 + j
          i0 = (nfj*(nfj - 1)) / 2 + nfi - 1
          do k = 1, j
            iden = iden + 1
            ipiden(iden) = i0 + k
            gden(iden) = -2.0d0
          end do
          gden(iden) = -1.0d0
        end do
      end if
      iat = nat(i)
      srad(i) = usevdw(iat)
    end do

   !
   !  NUMBER OF SECTIONS PER ATOM
   !
    n0(1) = nspa
    if (nspa /= 42) then
      x = (nspa - 2) / 10.d0 + 1d-8
      n1 = 10 * Int (Sqrt(x)) ** 2 + 2
      n2 = 30 * Int (Sqrt(x/3)) ** 2 + 2
      n0(1) = Max (n1, n2)
      n0(1) = Max (12, n0(1))
      if (nspa /= n0(1)) then
        write (iw, "(A, I6)") "NSPA IS SET TO", n0 (1)
      end if
    end if
    nspa = n0(1)
    n1 = (n0(1) - 2) / 10
   !
   !   FOR HYDROGEN, USE ABOUT 1/3 THE NUMBER OF ATOMS.
   !
    n0(2) = 10 * n1 / 3 + 2
    if (Mod(n1, 3) /= 0) then
      n0(2) = 10 * Int (Sqrt(n1/3.d0)) ** 2 + 2
    end if
   !
   !   RESET N0(2) TO 12.  N0 = 42, 12
   !
    n0(2) = Max (n0(2), 12)
    if (n0(1) + n0(2) > 1082) then
      call mopend ("CHOSE NSPA < 0.75*1082")
    end if
    call dvfill (n0(1), dirsm)
    call dvfill (n0(2), dirsm(1, n0(1) + 1))
    disex2 = 4 * (1.7d0*disex) ** 2 / nspa
    call dvfill (1082, dirvec)
end subroutine cosini
subroutine extvdw (vdw, refvdw)
    use molkst_C, only : numat, keywrd, line
    use chanel_C, only : iw
    use common_arrays_C, only : nat
    use elemts_C, only : cap_elemnt, elemnt
    implicit none
    double precision, dimension (107), intent (out) :: vdw
    double precision, dimension (107), intent (in) :: refvdw
    integer :: i, j, k
    double precision, external :: reada
   !
   ! ... Executable Statements ...
   !
   !  Modify Van der Waal's radii of various atoms.  The format of
   ! the keyword is: VDW(chemical symbol = n.nn:chemical symbol = n.nn ...)
   ! e.g. VDW(:H = 1.0:Cl = 1.7)
   !
   i = index(keywrd, " VDW(")
    if (i == 0) then
      line = " "
    else
      if (keywrd(i + 5:i + 5) /= ";") keywrd(i + 5:) = ";"//keywrd(i + 5:)
      j = index(keywrd(i + 5:), ")") + i + 5
      do k = i + 5, j
         if (keywrd(k:k) == ":") keywrd(k:k) = ";"
         if (keywrd(k:k) == ", ") keywrd(k:k) = ";"
      end do
      line = keywrd(i + 5:j - 1)
    end if
    vdw(:107) = refvdw(:107)
    if (line /= " ") then
      do i = 1, 107
        j = 2
        if (cap_elemnt(i) (2:2) == " ") j = 1
        j = index(line, ";"//cap_elemnt(i)(:j)//"=")
        if (j > 0) vdw(i) = reada(line, j)
      end do
    end if
    !
    !  Verify that all radii that will be used are, in fact, set correctly
    !
    do i = 1, numat
      if (nat(i) > 102) cycle
      if (vdw(nat(i)) > 900.d0) then
        write (line, *) "MISSING VAN DER WAALS RADIUS " // elemnt (nat(i))
        call mopend (trim(line))
        j = 2
        if (elemnt(nat(i)) (2:2) == " ") j = 1
        write (iw, "(2x, 3a)") "To correct this, add keyword 'VDW(", &
       & elemnt (nat(i)) (1:j), " = n.nn)'"
        return
      end if
    end do
end subroutine extvdw

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine axis(a, b, c, evec)
      use molkst_C, only : numcal, keywrd, mol_weight, numat
      use common_arrays_C, only : atmass, coord
      USE chanel_C, only : iw
      use to_screen_C, only : rot, xyzmom
      USE funcon_C, only : fpc_6, fpc_8, fpc_10, pi
      implicit none
      double precision , intent(out) :: a
      double precision , intent(out) :: b
      double precision , intent(out) :: c
      double precision  :: evec(3,3)
      integer :: icalcn, i, j
      double precision, dimension(6) :: t
      double precision, dimension(numat) :: x, y, z
      double precision, dimension(3) ::  eig
      double precision :: const1, const2, sumwx, sumwy, sumwz, sum
      logical :: first
      double precision, external :: ddot
      save t, eig, first, icalcn
!***********************************************************************
!
!  AXIS CALCULATES THE THREE MOMENTS OF INERTIA AND THE MOLECULAR
!       WEIGHT.  THE MOMENTS OF INERTIA ARE RETURNED IN A, B, AND C.
!       THE MOLECULAR WEIGHT IN mol_weight.
!       THE UNITS OF INERTIA ARE 10**(-40)GRAM-CM**2,
!       AND MOL.WEIGHT IN ATOMIC-MASS-UNITS. (AMU'S)
!***********************************************************************
      data t/ 6*0.D0/
      data icalcn/ 0/
      if (icalcn /= numcal) then
        icalcn = numcal
        first = .TRUE.
      end if
!***********************************************************************
!     CONST1 =  10**40/(N*A*A)
!               N = AVERGADRO'S NUMBER
!               A = CM IN AN ANGSTROM
!               10**40 IS TO ALLOW UNITS TO BE 10**(-40)GRAM-CM**2
!
!***********************************************************************
      const1 = 10.d0**24/fpc_10
!***********************************************************************
!
!     CONST2 = CONVERSION FACTOR FROM ANGSTROM-AMU TO CM**(-1)
!
!            = (PLANCK'S CONSTANT*N*10**16)/(8*PI*PI*C)
!            = H[ERG-SEC]*N*10**16/
!              (8*PI**2*C[CM/SEC])
!
!***********************************************************************
      const2 = fpc_6*fpc_10*1.D16/(8.D0*pi**2*fpc_8)
!    FIRST WE CENTRE THE MOLECULE ABOUT THE CENTRE OF GRAVITY,
!    THIS DEPENDS ON THE ISOTOPIC MASSES, AND THE CARTESIAN GEOMETRY.
!
      sumwx = 0.D0
      sumwy = 0.D0
      sumwz = 0.D0
!
      if (mol_weight > 0) then
        do i = 1, numat
          sumwx = sumwx + atmass(i)*coord(1,i)
          sumwy = sumwy + atmass(i)*coord(2,i)
          sumwz = sumwz + atmass(i)*coord(3,i)
        end do
      else
        mol_weight = mol_weight + dble(numat)
        do i = 1, numat
          sumwx = sumwx + coord(1,i)
          sumwy = sumwy + coord(2,i)
          sumwz = sumwz + coord(3,i)
        end do
      end if
!
      if (mol_weight>0 .and. first) &
      write (iw, '(/10X,''MOLECULAR WEIGHT ='',F8.2,/)') min(99999.99D0,mol_weight)
      sumwx = sumwx/mol_weight
      sumwy = sumwy/mol_weight
      sumwz = sumwz/mol_weight
      x(:numat) = coord(1,:numat) - sumwx
      y(:numat) = coord(2,:numat) - sumwy
      z(:numat) = coord(3,:numat) - sumwz
!***********************************************************************
!
!    MATRIX FOR MOMENTS OF INERTIA IS OF FORM
!
!           |   Y**2+Z**2                         |
!           |    -Y*X       Z**2+X**2             | -I =0
!           |    -Z*X        -Z*Y       X**2+Y**2 |
!
!***********************************************************************
      do i = 1, 6
        t(i) = dble(i)*1.0D-10
      end do
!
      if (mol_weight > 0) then
        do i = 1, numat
          t(1) = t(1) + atmass(i)*(y(i)**2+z(i)**2)
          t(2) = t(2) - atmass(i)*x(i)*y(i)
          t(3) = t(3) + atmass(i)*(z(i)**2+x(i)**2)
          t(4) = t(4) - atmass(i)*z(i)*x(i)
          t(5) = t(5) - atmass(i)*y(i)*z(i)
          t(6) = t(6) + atmass(i)*(x(i)**2+y(i)**2)
        end do
      else
        do i = 1, numat
          t(1) = t(1) + (y(i)**2+z(i)**2)
          t(2) = t(2) - x(i)*y(i)
          t(3) = t(3) + (z(i)**2+x(i)**2)
          t(4) = t(4) - z(i)*x(i)
          t(5) = t(5) - y(i)*z(i)
          t(6) = t(6) + (x(i)**2+y(i)**2)
        end do
      end if
!
      call rsp (t, 3, eig, evec)
      if (mol_weight>0 .and. first .and. index(keywrd,'RC=')==0) then
        write (iw,'(2/9X,'' ROTATIONAL CONSTANTS IN CM(-1)'',/)')
        where (eig < 3.D-4)
          eig = 0.D0
          rot = 0.D0
        elsewhere
          rot = const2/eig
        end where
        xyzmom = eig*const1
        write (iw, &
      '(10X,''A ='',F14.8,''   B ='',F14.8,''   C ='',F14.8,/)') (rot(i),i=1,3)
        if (index(keywrd,'RC=') == 0) write (iw, &
      '(2/10X,'' PRINCIPAL MOMENTS OF INERTIA IN UNITS OF 10**(-40)*GRAM-CM**2'',/)')
        write (iw, &
      '(10X,''A ='',F14.4,''   B ='',F14.4,''   C ='',F14.4,/)') (xyzmom(i),i=1,3)
        c = rot(1)
        b = rot(2)
        a = rot(3)
      end if
!
!     MAKE DIAGONAL TERMS OBLIGATE POSITIVE
!
      do i = 1, 3
        if (evec(i,i) >= 0.D0) cycle
        evec(:,i) = -evec(:,i)
      end do
!
!   NOW TO ORIENT THE MOLECULE SO THE CHIRALITY IS PRESERVED
!   CHIRALITY CAN ONLY BE LOST IF ONE OR MORE EVEC(I,I) ARE ZERO
!
      sum = evec(1,1)*(evec(2,2)*evec(3,3)-evec(3,2)*evec(2,3)) + &
            evec(1,2)*(evec(2,3)*evec(3,1)-evec(2,1)*evec(3,3)) + &
            evec(1,3)*(evec(2,1)*evec(3,2)-evec(2,2)*evec(3,1))
      if (sum < 0) then
        sum = 1.D0
        do j = 1, 3
          if (evec(j,j) >= sum) cycle
          sum = evec(j,j)
          i = j
        end do
        evec(:,i) = -evec(:,i)
      end if
      if (index(keywrd,' NOREOR') + index(keywrd,' FORCETS') == 0) then
        coord(1,:numat) = x(:numat)
        coord(2,:numat) = y(:numat)
        coord(3,:numat) = z(:numat)
      end if
      if (mol_weight > 0) first = .FALSE.
      return
      end subroutine axis

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine prtdrc(deltt, xparam, ref, escf, ekin, gtot, etot, velo0, mcoprt, ncoprt, parmax, &
          l_dipole, dip)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE molkst_C, only : numat, keywrd, numcal, nvar, jloop => itemp_1, line
      use common_arrays_C, only : nat, na, nb, nc, p, na_store, geoa, loc
      USE parameters_C, only : tore
      use chanel_C, only : iw, ires
      use drc_C, only: vref, vref0, allxyz, allvel, xyz3, vel3, allgeo, geo3, parref, &
        time, now
      implicit none
      double precision , intent(in) :: deltt, escf, ekin, dip
      double precision , intent(inout) :: gtot
      logical, intent (in) :: l_dipole
      double precision  :: etot
      double precision, dimension(3*numat) :: xparam, ref, velo0
      integer, dimension (2, 3*numat) :: mcoprt
      integer, intent(in) ::  ncoprt
      logical, intent(in) :: parmax
      integer ::  iloop, icalcn, ione, i, l, j, nfract, ii, n, k, ij
      double precision, dimension(3) :: escf3, ekin3
      double precision, dimension(numat) :: charge
      double precision, dimension(3) :: xold3
      double precision, dimension(3*numat) :: geo
      double precision, dimension(200) :: tsteps
      double precision, dimension(3) :: etot3, xtot3, dip3
      double precision :: gtot0, gtot1, escf0, escf1, ekin0, ekin1, etot0, etot1, &
        xold0, xold1, xold2, refscf, totime, told2, told1, refx, tlast, old_sum, &
        stept, steph, stepx, tref = 0.d0, xtot0, xtot1, xtot2, etot2, escf2, ekin2, &
        sum, deltat, t1, t2, sum1, dh, cc, bb, aa, c1, fract, dip2 = 0.d0, dip1 = 0.d0, dip0 = 0.d0, &
        suma, sumb, total = 0.d0
      logical :: goturn, ldrc, exists, l_pdbout
      character , dimension(3) :: cotype*2
      character :: text1*3, text2*2
      double precision, external :: dot, reada
      save  gtot0, gtot1, escf0, escf1, ekin0, ekin1, etot0, etot1&
        , xold0, xold1, xold2, refscf, cotype, iloop, totime, told2, told1, &
        icalcn, refx, tlast, goturn, ione, ldrc, stept, steph, stepx, &
        tref, xtot0, xtot1, xtot2, dip1, dip0, old_sum, l_pdbout
!-----------------------------------------------
!********************************************************************
!
!    PRTDRC PREPARES TO PRINT THE GEOMETRY ETC. FOR POINTS IN A DRC
!    OR IRC
!    CALCULATION.
!    ON INPUT  ESCF   = HEAT OF FORMATION FOR THE CURRENT POINT
!              DELTT  = CHANGE IN TIME, PREVIOUS TO CURRENT POINT
!              XPARAM = CURRENT CARTESIAN GEOMETRY
!              EKIN   = CURRENT KINETIC ENERGY
!              GTOT   = TOTAL GRADIENT NORM IN IRC CALC'N.
!              VELO0  = CURRENT VELOCITY
!              NVAR   = NUMBER OF VARIABLES = 3 * NUMBER OF ATOMS.
!
!*******************************************************************
      data icalcn/ 0/
      data refscf/ 0.D0/
      data cotype/ 'BL', 'BA', 'DI'/
      geo = 0.d0
      if (icalcn /= numcal) then
        if (allocated(vref)) deallocate(vref)
        if (allocated(vref0)) deallocate(vref0)
        if (allocated(allxyz)) deallocate(allxyz)
        if (allocated(allvel)) deallocate(allvel)
        if (allocated(xyz3)) deallocate(xyz3)
        if (allocated(vel3)) deallocate(vel3)
        if (allocated(allgeo)) deallocate(allgeo)
        if (allocated(geo3)) deallocate(geo3)
        if (allocated(parref)) deallocate(parref)
        if (allocated(now)) deallocate(now)
        i = 3*numat
        allocate(vref(i), vref0(i), allxyz(3,i), allvel(3,i), xyz3(3,i), vel3(3,i), &
        allgeo(3,i), geo3(3,i), parref(i), now(i))
        allgeo = 0.d0
        now = ref
        old_sum = 0.d0
        icalcn = numcal
        totime = 0.D0
        etot0 = 0.0D0
        etot1 = 0.0D0
        etot2 = 0.0D0
        escf0 = 0.0D0
        escf1 = 0.0D0
        escf2 = 0.0D0
        ekin0 = 0.0D0
        ekin1 = 0.0D0
        ekin2 = 0.0D0
        gtot = 0.D0
        gtot0 = 0.0D0
        gtot1 = 0.0D0
        refx = 0.D0
        fract = 0.D0
        told2 = 0.D0
        xold0 = 0.D0
        xold1 = 0.D0
        xold2 = 0.D0
        xtot0 = 0.D0
        xtot1 = 0.D0
        xtot2 = 0.D0
        if (.false.) then
          line = "Debug.txt"
          call add_path(line)
          inquire (file=trim(line), exist = exists)
          if (exists) then
            open(unit=44, file=trim(line))
            close(unit=44, status='DELETE')
          end if
        end if
        l_pdbout = (index(keywrd, " PDBOUT") /= 0)
        parref(:nvar) = xparam(:nvar)
        etot = escf + ekin
        tlast = 0.D0
        goturn = .FALSE.
        sum = 0.D0
        do i = 1, nvar
          sum = sum + velo0(i)**2
          vref0(i) = velo0(i)
          vref(i) = velo0(i)
        end do
        ione = 1
        ldrc = sum > 1.D0
        iloop = 1
        told1 = 0.0D0
!
!       DETERMINE TYPE OF PRINT: TIME, ENERGY OR GEOMETRY PRIORITY
!       OR PRINT ALL POINTS
!
        stept = 0.D0
        steph = 0.D0
        stepx = 0.D0
        i = index(keywrd,' T-PRI')
        if (i /= 0) then
!
!  Check for "=" sign
!
          j = index(keywrd(i + 6:)," ") + i + 6
          do i = i + 6, j
            if (keywrd(i:i) == "=") then
              j = -1
            end if
          end do
          if (j < 0 ) then
            stept = reada(keywrd,index(keywrd,'T-PRIO') + 5)
          else
            stept = 0.1D0
          end if
          tref = -1.D-6
          write (iw, &
      '(/,'' TIME PRIORITY, INTERVAL ='',F5.2,'' FEMTOSECONDS'',/)')stept
        else if (index(keywrd,' H-PRI') /= 0) then
          i = index(keywrd,' H-PRI')
!
!  Check for "=" sign
!
          j = index(keywrd(i + 6:)," ") + i + 6
          do i = i + 6, j
            if (keywrd(i:i) == "=") then
              j = -1
            end if
          end do
          if (j < 0 ) then
            steph = reada(keywrd,index(keywrd,'H-PRI') + 5)
          else
            steph = 0.1D0
          end if
          write (iw, &
      '(/,'' KINETIC ENERGY PRIORITY, STEP ='',F5.2,'' KCAL/MOLE'',/)') steph
        else if (index(keywrd,' X-PRI') /= 0) then
          i = index(keywrd,' X-PRI')
!
!  Check for "=" sign
!
          j = index(keywrd(i + 6:)," ") + i + 6
          do i = i + 6, j
            if (keywrd(i:i) == "=") then
              j = -1
            end if
          end do
          if (j < 0 ) then
            stepx = reada(keywrd,index(keywrd,'X-PRIO') + 5)
          else
            stepx = 0.05D0
          end if
          write (iw, &
      '(/,'' GEOMETRY PRIORITY, STEP ='',F7.4,'' ANGSTROMS'',/)') stepx
        end if
        if (stepx < 1.d-6 .and. steph < 1.d-6 .and. stept < 1.d-6) then
       !
       !  Set default: if a DRC, then time-slice,
       !  if an IRC then a movement slice.
       !
          if (Index (keywrd, " DRC") == 0) then
            stepx = 0.00d0
          else
            stept = 0.1d0
          end if
        end if
        if (index(keywrd,' RESTART')/=0 .and. index(keywrd,'IRC=')==0) then
            read (ires) (parref(i),i=1,nvar)
            read (ires) (ref(i),i=1,nvar)
            read (ires) (vref0(i),i=1,nvar)
            read (ires) (vref(i),i=1,nvar)
            read (ires) (allgeo(3,i),i=1,nvar)
            read (ires) (allgeo(2,i),i=1,nvar)
            read (ires) (allgeo(1,i),i=1,nvar)
            read (ires) (allvel(3,i),i=1,nvar)
            read (ires) (allvel(2,i),i=1,nvar)
            read (ires) (allvel(1,i),i=1,nvar)
            read (ires) (allxyz(3,i),i=1,nvar)
            read (ires) (allxyz(2,i),i=1,nvar)
            read (ires) (allxyz(1,i),i=1,nvar)
            read (ires) iloop, ldrc, ione, etot1, etot0, escf1, escf0, ekin1, &
              ekin0, told2, told1, gtot1, gtot0, xold2, xold1, xold0, totime, &
              jloop, etot, refx, xtot1, xtot0
        end if
      end if
      if (iloop > 1000 .and. jloop < 3) then
        call mopend("Step size is too large for a path to be generated")
        return
      end if
      c1 = 0.d0
      if (escf < (-1.D8)) then
          write (ires) (parref(i),i=1,nvar)
          write (ires) (ref(i),i=1,nvar)
          write (ires) (vref0(i),i=1,nvar)
          write (ires) (vref(i),i=1,nvar)
          write (ires) (allgeo(3,i),i=1,nvar)
          write (ires) (allgeo(2,i),i=1,nvar)
          write (ires) (allgeo(1,i),i=1,nvar)
          write (ires) (allvel(3,i),i=1,nvar)
          write (ires) (allvel(2,i),i=1,nvar)
          write (ires) (allvel(1,i),i=1,nvar)
          write (ires) (allxyz(3,i),i=1,nvar)
          write (ires) (allxyz(2,i),i=1,nvar)
          write (ires) (allxyz(1,i),i=1,nvar)
          write (ires) iloop, ldrc, ione, etot1, etot0, escf1, escf0, ekin1, &
            ekin0, told2, told1, gtot1, gtot0, xold2, xold1, xold0, totime, &
            jloop, etot, refx, xtot1, xtot0
        close(ires, status='KEEP')
        return
      end if
      call chrge (p, charge)
      charge(:numat) = tore(nat(:numat)) - charge(:numat)
      deltat = deltt*1.D15
      if ( .not. l_pdbout) then
        na(:numat) =  na_store(:numat)
!
!  Load geometry into geoa
!
        do i = 1, nvar
          geoa(loc(2,i), loc(1,i)) = xparam(i)
        end do
        call xyzint (geoa, numat, na, nb, nc, 57.29577951308232D0, geo)
      end if
      if (iloop == 1) then
        etot1 = etot0
        etot0 = etot
        escf1 = escf
        escf0 = escf
        ekin1 = ekin
        ekin0 = ekin
        dip1 = dip
        dip0 = dip
        do j = 1, 3
          allgeo(j,:nvar) = geo(:nvar)
          allxyz(j,:nvar) = xparam(:nvar)
          allvel(j,:nvar) = velo0(:nvar)
        end do
      else
        allgeo(3,:nvar) = allgeo(2,:nvar)
        allgeo(2,:nvar) = allgeo(1,:nvar)
        allgeo(1,:nvar) = geo(:nvar)
        allxyz(3,:nvar) = allxyz(2,:nvar)
        allxyz(2,:nvar) = allxyz(1,:nvar)
        allxyz(1,:nvar) = xparam(:nvar)
        allvel(3,:nvar) = allvel(2,:nvar)
        allvel(2,:nvar) = allvel(1,:nvar)
        allvel(1,:nvar) = velo0(:nvar)
      end if
!
!  FORM QUADRATIC EXPRESSION FOR POSITION AND VELOCITY W.R.T. TIME.
!
      t1 = max(told2,0.02D0)
      t2 = max(told1,0.02D0) + t1
      do i = 1, nvar
        call quadr (allgeo(3,i), allgeo(2,i), allgeo(1,i), t1, t2, geo3(1,i), &
          geo3(2,i), geo3(3,i))
!
!***************************************************
!                                                  *
!    QUADR CALCULATES THE A, B AND C IN THE EQUNS. *
!                                                  *
!     A                   =   F0                   *
!     A + B.X0 + C.X0**2  =   F1                   *
!     A + B.X2 + C.X2**2  =   F2                   *
! GIVEN THE ARGUMENT LIST (F0,F1,F2, X1,X2, A,B,C) *
!                                                  *
!***************************************************
        call quadr (allxyz(3,i), allxyz(2,i), allxyz(1,i), t1, t2, xyz3(1,i), &
          xyz3(2,i), xyz3(3,i))
        call quadr (allvel(3,i), allvel(2,i), allvel(1,i), t1, t2, vel3(1,i), &
          vel3(2,i), vel3(3,i))
      end do
      etot2 = etot1
      etot1 = etot0
      etot0 = etot
      call quadr (etot2, etot1, etot0, t1, t2, etot3(1), etot3(2), etot3(3))
      dip2 = dip1
      dip1 = dip0
      dip0 = dip
      call quadr (dip2, dip1, dip0, t1, t2, dip3(1), dip3(2), dip3(3))
      ekin2 = ekin1
      ekin1 = ekin0
      ekin0 = ekin
      call quadr (ekin2, ekin1, ekin0, t1, t2, ekin3(1), ekin3(2), ekin3(3))
      escf2 = escf1
      escf1 = escf0
      escf0 = escf
      call quadr (escf2, escf1, escf0, t1, t2, escf3(1), escf3(2), escf3(3))
      gtot1 = gtot0
      gtot0 = gtot
      xtot2 = xtot1
      xtot1 = xtot0
      xold2 = xold2 + xold1
      xold1 = xold0
!
!   CALCULATE CHANGE IN GEOMETRY
!
        l = 0
        xtot0 = 0.D0
        sum = 0.D0
        sum1 = 0.D0
        do ij = 1, nvar, 3
          suma = 0.d0
          sumb = 0.d0
          i = loc(1, ij)
          do j = 1, 3
            l = (i - 1) *3 + j
            suma = suma + (allxyz(1,ij + j - 1) - ref(l))**2
            sumb = sumb + (allxyz(1,ij + j - 1) - now(ij + j - 1))**2
            continue
          end do
          sum = sum + sqrt(sumb)
          sum1 = sum1 + sqrt(suma)
        end do
!
!  xtot0 is the change in geometry from the start of the run
!  xold0 is the change in geometry from the last step
!
      xold0 =  sum - old_sum
      xtot0 = xtot0 + sum1
      old_sum = sum
      call quadr (xtot2, xtot1, xtot0, t1, t2, xtot3(1), xtot3(2), xtot3(3))
      call quadr (xold2, xold2 + xold1, xold2 + xold1 + xold0, t1, t2, xold3(1), xold3(2), xold3(3))
!**********************************************************************
!   GO THROUGH THE CRITERIA FOR DECIDING WHETHER OR NOT TO PRINT THIS *
!   POINT.  IF YES, THEN ALSO CALCULATE THE EXACT POINT AS A FRACTION *
!   BETWEEN THE LAST POINT AND THE CURRENT POINT                      *
!**********************************************************************
!   NFRACT IS THE NUMBER OF POINTS TO BE PRINTED IN THE CURRENT DOMAIN
!**********************************************************************
      if (iloop >= 3) then
        fract = -10.D0
        nfract = 1
        if (Abs(steph) > 1.d-20) then
!
!   CRITERION FOR PRINTING RESULTS  IS A CHANGE IN HEAT OF FORMATION =
!   -CHANGE IN KINETIC ENERGY
!
          if (refscf == 0.D0) then
            i = int(escf2/steph)
            refscf = i*steph
          end if
          if (iloop == 3) refscf = escf1
          dh = abs(escf1 - refscf)
          if (dh > steph) then
            steph = sign(steph,escf1 - refscf)
            nfract = int(abs(dh/steph))
            cc = escf3(1)
            bb = escf3(2)
            aa = escf3(3)
!***********************************************
! PROGRAMMERS! - BE VERY CAREFUL IF YOU CHANGE *
! THIS FOLLOWING SECTION.  THERE IS NUMERICAL  *
! INSTABILITY IF ABS(BB/AA) IS VERY LARGE. NEAR*
! INFLECTION POINTS AA CHANGES SIGN.       JJPS*
!***********************************************
            if (abs(bb/aa) > 30) then
!
!   USE LINEAR INTERPOLATION
!
              do i = 1, nfract
                tsteps(i) = -(cc - (refscf + i*steph))/bb
              end do
            else
!
!  USE QUADRATIC INTERPOLATION
!
              do i = 1, nfract
                c1 = cc - (refscf + i*steph)
                tsteps(i) = ((-bb) + sign(sqrt(bb*bb - 4.D0*(aa*c1)),bb))/(2.D0&
                  *aa)
              end do
            end if
            fract = -.1D0
            refscf = refscf + nfract*steph
          end if
        else if (stept /= 0.D0) then
!
!   CRITERION FOR PRINTING RESULTS IS A CHANGE IN TIME.
!
          if (abs(totime + told2 - tref) > stept) then
            i = int(totime/stept)
            fract = i*stept - totime
            i = int((told2 + totime)/stept)
            j = int(totime/stept)
            nfract = i - j + ione
            ione = 0
            do i = 1, nfract
              tsteps(i) = fract + i*stept
            end do
            tref = tref + nfract*stept
          end if
        else if (stepx /= 0.D0) then
!
!   CRITERION FOR PRINTING RESULTS IS A CHANGE IN GEOMETRY.
!
! refx = integral of change in geometry from the start, quantized by stepx
!
          if (xold2 + xold1 - refx > stepx) then
            nfract = Min(200, int((xold2 + xold1 - refx)/stepx))
            cc = xold3(1)
            bb = xold3(2)
            aa = xold3(3)
            sum = bb*bb - 4.D0*(aa*c1)
            if (abs(bb/aa) > 30 .or. sum < 1.d-20) then
!
!   USE LINEAR INTERPOLATION
!
              do i = 1, nfract
                tsteps(i) = -(cc - (refx + i*stepx))/bb
              end do
            else
!
!  USE QUADRATIC INTERPOLATION
!
              do i = 1, nfract
                c1 = cc - (refx + i*stepx)
                tsteps(i) = ((-bb) + sign(sqrt(sum),bb))/(2.D0*aa)
              end do
            end if
            refx = refx + nfract*stepx
            fract = -0.1D0
          end if
        else
!
!   PRINT EVERY POINT.
!
          fract = 0.0D0
        end if
        if (fract >= -9.D0 ) then
!
!  LOOP OVER ALL POINTS IN CURRENT DOMAIN
!
          if (fract == 0.D0 .and. nfract == 1) then
            text1 = ' '
            text2 = ' '
            ii = 0
            call drcout (xyz3, geo3, vel3, nvar, totime, escf3, ekin3, etot3, dip3, &
              xtot3, iloop, charge, fract, text1, text2, ii, jloop, l_dipole)
            n = 0
            do i = 1, ncoprt
              k = mcoprt(1,i)
              j = mcoprt(2,i)
              l = k*3 - 3 + j
              if (abs(geo3(3,l)) > 1.D-20) fract = -geo3(2,l)/(geo3(3,l)*2.D0)
              if (fract <= 0.D0 .or. fract >= told2) cycle
              if (geo3(3,l) > 0.D0) text1 = 'MIN'
              if (geo3(3,l) < 0.D0) text1 = 'MAX'
              text2 = cotype(j)
              if (n == 0) then
                n = n + 1
                write (iw, '(/,20(''****''))')
              end if
              time = totime + fract
              call drcout (xyz3, geo3, vel3, nvar, time, escf3, ekin3, etot3, dip3, &
                xtot3, iloop, charge, fract, text1, text2, k, jloop, l_dipole)
            end do
            if (n /= 0) write (iw, '(/,20(''****''))')
            if (abs(escf3(3)) > 1.D-20) fract = -escf3(2)/(escf3(3)*2.D0)
            if (.not. goturn .and. fract > 0.D0 .and. fract < told2*1.04D0 .and. parmax) then
              goturn = .TRUE.
              time = fract + totime
              if (escf3(3) > 0.D0) then
                text1 = 'MIN'
                if (ldrc) then
                  sum = dot(velo0,vref,nvar)**2/(dot(velo0,velo0,nvar)*dot(vref&
                    ,vref,nvar) + 1.D-10)
                  sum1 = dot(velo0,vref0,nvar)**2/(dot(velo0,velo0,nvar)*dot(&
                    vref0,vref0,nvar) + 1.D-10)
                  if (sum1>0.1D0 .and. abs(sum1-1.D0)>1.D-6) write (iw, &
                    '(/,A,F8.5,A,F8.5,A,G12.3,A)') &
                    ' COEF. OF V(0)            =', sum1, '   LAST V(0)', sum, &
                    '   HALF-LIFE =', (-0.6931472D0*time/log(sum1)), &
                    ' FEMTOSECS'
                end if
                write (iw, '(2/,A,F11.3,A)') ' HALF-CYCLE TIME =', time - tlast&
                  , ' FEMTOSECONDS'
                tlast = time
                vref(:nvar) = velo0(:nvar)
              end if
              if (escf3(3) < 0.D0) text1 = 'MAX'
              text2 = ' '
              call drcout (xyz3, geo3, vel3, nvar, time, escf3, ekin3, etot3, dip3, &
                xtot3, iloop, charge, fract, text1, text2, 0, jloop, l_dipole)
            else
              goturn = .FALSE.
            end if
          else
            do i = 1, nfract
              time = totime + tsteps(i)
              text1 = ' '
              text2 = ' '
              call drcout (xyz3, geo3, vel3, nvar, time, escf3, ekin3, etot3, dip3, &
                xtot3, iloop, charge, tsteps(i), text1, text2, 0, jloop, l_dipole)
            end do
            if (.false.) then
              line = "Debug.txt"
              call add_path(line)
              inquire (file=trim(line), exist = exists)
              if (.not. exists) then
                open(unit=44, file=trim(line))
              end if
              l = 0
              sum = 0.D0
              do i = 1, numat
                suma = 0.d0
                do j = 1, 3
                  l = l + 1
                  suma = suma + (allxyz(1,l) - now(l))**2
                end do
                sum = sum + sqrt(suma)
              end do
              total = total + sum
              write(44,'(i5, 3f12.4)')jloop, escf3(1), sum, total
            end if
            old_sum = 0.d0
            now(:) = allxyz(1,:)
          end if
          n = 0
          do i = 1, ncoprt
            k = mcoprt(1,i)
            j = mcoprt(2,i)
            l = k*3 - 3 + j
            if (abs(geo3(3,l)) > 1.D-20) fract = -geo3(2,l)/(geo3(3,l)*2.D0)
            if (fract <= 0.D0 .or. fract >= told2) cycle
            if (geo3(3,l) > 0.D0) text1 = 'MIN'
            if (geo3(3,l) < 0.D0) text1 = 'MAX'
            text2 = cotype(j)
            if (n == 0) then
              n = n + 1
              write (iw, '(/,20(''****''))')
            end if
            time = totime + fract
            call drcout (xyz3, geo3, vel3, nvar, time, escf3, ekin3, etot3, dip3, &
              xtot3, iloop, charge, fract, text1, text2, k, jloop, l_dipole)
          end do
          if (n /= 0) write (iw, '(/,20(''****''))')
        end if
      else if (iloop == 1) then
        text1 = " "
        text2 = " "
        time = 0.d0
        call drcout (xyz3, geo3, vel3, nvar, time, escf3, ekin3, etot3, dip3, &
                xtot3, iloop, charge, fract, text1, text2, 0, jloop, l_dipole)
      end if
      totime = totime + told2
      told2 = told1
      told1 = deltat
      iloop = iloop + 1
      endfile (iw)
      backspace (iw)
      na = 0
      return
      end subroutine prtdrc

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.


subroutine post_scf_corrections(correction, l_grad)
!
!    Add dispersion, hydrogen bonding, extra H-H repulsion, and other energies to
!    improve intermolecular interaction geometries and energies.
!
  use molkst_C, only : keywrd, E_disp, E_hb, E_hh, method_pm7, P_Hbonds, &
    method_pm6_dh_plus, method_pm6_dh2, method_pm6_d3h4, method_pm6_dh2x, method_pm6_d3h4x, &
    method_pm6_d3, method_pm6_d3_not_h4, method_pm7_hh, method_pm7_minus, method_pm6_org, method_PM8
  use common_arrays_C, only: dxyz
  implicit none
  double precision, intent(out) ::  correction
  logical, intent (in) :: l_grad
!
! Local variables
!
  logical ::  prt
  double precision, external :: & !                  Original references
                          !
  energy_corr_hh_rep,   & ! Rezac J., Hobza P., "Advanced Corrections of Hydrogen Bonding and
                          ! Dispersion for Semiempirical Quantum Mechanical Methods", J. Chem.
                          ! Theory and Comp 8, 141-151 (2012).
                          !
                          !
  PM6_DH_Dispersion,    & ! S. Grimme, "Accurate description of van der Waals complexes by
                          ! density functional theory including empirical corrections."
                          ! J Comput Chem. 2004 Sep;25(12):1463-73.
                          !
  dftd3,                & ! Grimme S., Antony J., Ehrlich S., Krieg H., "A consistent and accurate
                          ! ab initio parametrization of density functional dispersion correction
                          ! (DFT-D) for the 94 elements H-Pu", J. Chem. Phys. 132, 154104:154104
                          ! (2010).
                          !
  disp_DnX,             & ! (DH2X) Rezac and Hobza's correction: "A halogen-bonding correction
                          ! for the semiempirical PM6 method" Chem. Phys. Lett. 506 286-289 (2011)
                          !
                          ! (D3H4X) Rezac J., Hobza P., "Advanced Corrections of Hydrogen Bonding
                          ! and Dispersion for Semiempirical Quantum Mechanical Methods", J. Chem.
                          ! Theory and Comp 8, 141-151 (2012)
                          !
  Hydrogen_bond_corrections !(DH2) Korth M., Pitonak M., Rezac J., Hobza P., "A Transferable
                          ! H-bonding Correction for Semiempirical Quantum-Chemical Methods",
                          ! J. Chem. Theory and Computation 6, 344-352 (2010).
                          !
                          ! (DH+) Korth M., "Third-Generation Hydrogen-Bonding Corrections for
                          ! Semiempirical QM Methods and Force Fields", J. Chem. Theory Comput.
                          ! 6, 3808-3816 (2010).
!
! PM6-D3H4X: Brahmkshatriya, P. S.; Dobes, P.; Fanfrlik, J.; Rezac, J.; Paruch, K.; Bronowska,
! A.; Lepsik, M.; Hobza, P. "Quantum Mechanical Scoring: Structural and Energetic Insights into
! Cyclin-Dependent Kinase 2 Inhibition by Pyrazolo[1,5-a]pyrimidines" Curr. Comput.-Aid. Drug.
! 2013 , 9 (1), 118�129.
!
  prt = (index(keywrd," 0SCF ") + index(keywrd," PRT ") /= 0 .and. index(keywrd," DISP") /= 0)
  correction = 0.d0
  E_hb       = 0.d0
  E_hh       = 0.d0
  E_disp     = 0.d0
  P_Hbonds   = 0
  if (.not. allocated(dxyz)) allocate (dxyz(1))
!
! All the hydrogen-bond corrections are in Hydrogen_bond_corrections
!
  if (method_pm6_d3h4x) then
    correction = correction + dftd3(l_grad, dxyz)
    correction = correction + Hydrogen_bond_corrections(l_grad, prt)
    correction = correction + energy_corr_hh_rep(l_grad, dxyz)
    correction = correction + disp_DnX(l_grad)
  else if (method_pm6_d3h4) then
    correction = correction + dftd3(l_grad, dxyz)
    correction = correction + Hydrogen_bond_corrections(l_grad, prt)
    correction = correction + energy_corr_hh_rep(l_grad, dxyz)
  else if (method_pm6_d3_not_h4) then
    correction = correction + dftd3(l_grad, dxyz)
    correction = correction + energy_corr_hh_rep(l_grad, dxyz)
  else if (method_pm6_d3) then
    correction = correction + dftd3(l_grad, dxyz)
  else if (method_pm6_dh_plus) then
    correction = correction + PM6_DH_Dispersion(l_grad)
    correction = correction + Hydrogen_bond_corrections(l_grad, prt)
  else if (method_pm6_dh2) then
!
! Hydrogen_bond_corrections uses partial atomic charges if method_pm6_dh2 .or. method_pm6_dh2x
!
    correction = correction + PM6_DH_Dispersion(l_grad)
    correction = correction + Hydrogen_bond_corrections(l_grad, prt)
  else if (method_pm6_dh2x) then
    correction = correction + PM6_DH_Dispersion(l_grad)
    correction = correction + Hydrogen_bond_corrections(l_grad, prt)
    correction = correction + disp_DnX(l_grad)
  else if (method_pm7_hh) then
    correction = correction + energy_corr_hh_rep(l_grad, dxyz)
    correction = correction + PM6_DH_Dispersion(l_grad)
    correction = correction + Hydrogen_bond_corrections(l_grad, prt)
  else if (method_pm7_minus) then
    return
  else if (method_pm6_org) then
    correction = correction + dftd3(l_grad, dxyz)
    correction = correction + Hydrogen_bond_corrections(l_grad, prt)
    correction = correction + energy_corr_hh_rep(l_grad, dxyz)
  else if (method_pm8) then
    correction = correction + dftd3(l_grad, dxyz)
    correction = correction + Hydrogen_bond_corrections(l_grad, prt)
    correction = correction + energy_corr_hh_rep(l_grad, dxyz)
  else if (method_pm7) then
    correction = correction + PM6_DH_Dispersion(l_grad)
    correction = correction + Hydrogen_bond_corrections(l_grad, prt)
  end if
  if (index(keywrd, " SILENT") == 0) then
    if (prt .and. P_Hbonds > 0) call print_post_scf_corrections
  end if
  return
end subroutine post_scf_corrections

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine inttr (i, j, a, b, c, gamma, nbtmo, j12, k12, ifstor)

!     **** generates J and K integrals in MO basis for CI routines   ****
!     **** by index transformation on the AO - basis integrals	     ****
!     **** is set up for notation (ij||ab) = <ia||jb> of Georges notes****

!     **** J = [ij|ab] = <phi_i(1) phi_j(1) | 1/r | phi_a(2) phi_b(2)> ****
!     **** K = [ia|jb] = <phi_i(1) phi_a(1) | 1/r | phi_j(2) phi_b(2)> ****

!     **** integrals in the AO basis set are:				   ****
!     **** (mu, mu|nu, nu) = gamma(mu, nu) = CNDO Coulomb integrals		   ****
!     **** (mu, nu|mu, nu) = gamma(nu, mu) = INDO one - centre Exchange integrals ****
!     **** (mu, nu|nu, mu) = gamma(nu, mu) = INDO one - centre Exchange integrals ****
!     **** (ig1, ig2|ig3, ig4) INDO trans metal irregular integrals	   ****

!     **** nb, in an alternate notation used in Georges notes, we have *
!     **** J = <ib|ja> = <phi_i(1) phi_b(2) | 1/r | phi_j(1) phi_a(2)> ****
!     **** K = <ib|aj> = <phi_i(1) phi_b(2) | 1/r | phi_a(1) phi_j(2)> ****
!     **** ie, <ib||ja> = (ij||ab), and parameter definition reverses ****

!     **** J = <ij|ab> = <phi_i(1) phi_j(2) | 1/r | phi_a(1) phi_b(2)> ****
!     **** K = <ij|ba> = <phi_i(1) phi_j(2) | 1/r | phi_b(1) phi_a(2)> ****
!     **** ie, <ia||jb> = (ia||jb), and parameter definition reverses ****
      use reimers_C, only : n, matind, nham, ibf, iat, nslwr, nsupr, &
          istr, nsym, ixprd, ig1, ig2, ig3, ig4, g, ntrmet, itrmet, &
          nirreg, natt, ncore, edef, ee2, wk1, wk2, isc
!      USE chanel_C, only : iw

      implicit none
      double precision ::  c(n, n), gamma(n, n), aa, gk
      integer ::           nbtmo(n), a, b, i, j, k, &
                        ifstor, imu, imu0, ir, irreg, &
                        k1, k2, k3, k4, ka, kt, mu, mu1, &
                        nm1, nm2, nmc, nme, nu, nu1, nu1l
      logical*1 ::         diagon
      double precision ::  j12, k12, jk12
      double precision ::            edefs
      nu1l = 0
      nmc = 0
      nme = 0

      if (allocated(wk1)) deallocate(wk1)
      if (allocated(wk2)) deallocate(wk2)
      allocate(wk1(n))
      allocate(wk2(n))
      if (ifstor == 1) then
!	**** see if element already evaluated and stored ****
        nm1 = matind(max(i, j) - ncore) + min(i, j) - ncore
        nm2 = matind(max(a, b) - ncore) + min(a, b) - ncore
        nmc = matind(max(nm1, nm2)) + min(nm1, nm2)

        nm1 = matind(max(i, a) - ncore) + min(i, a) - ncore
        nm2 = matind(max(j, b) - ncore) + min(j, b) - ncore
        nme = matind(max(nm1, nm2)) + min(nm1, nm2)

        edefs = edef / 2.
        if (ee2(nme) < edefs .and. ee2(nmc) < edefs) then
!	  **** retriev from store ****
          j12 = ee2(nmc)
          k12 = ee2(nme)
          return
        end if
      end if

!     ********** evaluate integrals **************

      diagon = i == j .and. a == b
      j12 = 0.d0
      k12 = 0.d0

!     **** elements of symmetry i x j ****

      if (iand (nbtmo(i), nbtmo(j)) /= 0) then
        ir = ixprd(nsym(i), nsym(j))
        imu0 = 0
        do mu1 = nslwr(ir), nsupr(ir)
          mu = istr(1, mu1)
          wk1(mu) = c(i, mu)*c(j, mu)
          wk2(mu) = c(a, mu)*c(b, mu)
          j12 = j12 + wk1(mu)*wk2(mu) * gamma(mu1, mu1)
          do nu1 = nslwr(ir), mu1 - 1
!	     **** CNDO coulomb integrals (mu, mu|nu, nu) ****
             nu = istr(1, nu1)
             j12 = j12 + (wk1(mu)*wk2(nu) + wk1(nu)*wk2(mu)) *&
     &                                gamma(mu1, nu1)
          end do
          if (nham == 2) then
!	    **** INDO exchange terms (mu, nu|mu, nu) ****
            imu = iat(mu)
            if (imu /= imu0) then
              nu1l = mu1
              imu0 = imu
            else
              do nu1 = nu1l, mu1 - 1
                nu = istr(1, nu1)
                k12 = k12 + (wk1(mu)*wk2(nu) + wk1(nu)*wk2(mu))&
     &                        * gamma(nu1, mu1)
              end do
            end if
          end if
        end do
      end if

!     **** integrals of symmetry i x a ****

      if (iand (nbtmo(i), nbtmo(a)) /= 0) then
        ir = ixprd(nsym(i), nsym(a))
        jk12 = 0.d0
        imu0 = 0
        do mu1 = nslwr(ir), nsupr(ir)
          mu = istr(1, mu1)
          wk1(mu) = c(i, mu)*c(a, mu)
          wk2(mu) = c(j, mu)*c(b, mu)
          k12 = k12 + wk1(mu)*wk2(mu) * gamma(mu1, mu1)
          do nu1 = nslwr(ir), mu1 - 1
!	    **** CNDO coulomb integrals (mu, mu|nu, nu) ****
            nu = istr(1, nu1)
            k12 = k12 + (wk2(mu)*wk1(nu) + wk2(nu)*wk1(mu)) * &
     &                                gamma(mu1, nu1)
          end do
          if (nham == 2) then
!	    **** INDO exchange terms (mu, nu|mu, nu) ****
            imu = iat(mu)
            if (imu /= imu0) then
              nu1l = mu1
              imu0 = imu
            else
              do nu1 = nu1l, mu1 - 1
                nu = istr(1, nu1)
                jk12 = jk12 + (wk1(mu)*wk2(nu) + wk1(nu)*wk2(mu))&
     &                                * gamma(nu1, mu1)
              end do
            end if
          end if
        end do
        if (diagon) then
!	  **** this trick adds also the i x b terms for determinate energy ****
          j12 = j12 + jk12 * 2.d0
          k12 = k12 + jk12
        else
!	  **** this is the i x a term only ****
          j12 = j12 + jk12
        end if
      end if

!     **** integrals (mu, nu|nu, mu) from INDO, symmetry = i x b ****

      if (.not.diagon .and. nham == 2 .and.&
     &                iand (nbtmo(i), nbtmo(b)) /= 0) then
        jk12 = 0.d0
        imu0 = 0
        ir = ixprd(nsym(i), nsym(b))
        do mu1 = nslwr(ir), nsupr(ir)
          mu = istr(1, mu1)
          imu = iat(mu)
          wk1(mu) = c(i, mu)*c(b, mu)
          wk2(mu) = c(j, mu)*c(a, mu)
          if (imu /= imu0) then
            nu1l = mu1
            imu0 = imu
          else
            do nu1 = nu1l, mu1 - 1
              nu = istr(1, nu1)
              jk12 = jk12 + (wk2(mu)*wk1(nu) + wk2(nu)*wk1(mu))&
     &                                * gamma(nu1, mu1)
            end do
          end if
        end do
        j12 = j12 + jk12
        k12 = k12 + jk12
      end if

!      **** Zerners irregular integrals for transition metals ****

      do kt = 1, ntrmet
        ka = itrmet(kt)
        k = natt(ka)
!	**** select unique transition metal atom ****
        if (isc(ka) == 1) then
          mu = ibf(ka)
          do irreg = 1, nirreg
            k1 = ig1(irreg, k)
            k2 = ig2(irreg, k)
            k3 = ig3(irreg, k)
            k4 = ig4(irreg, k)
            gk = g(irreg, k)

!	    **** terms (k1, k2|k3, k4) ****
            aa = c(i, mu + k1) * c(b, mu + k4) * gk
            k12 = k12 + c(a, mu + k2) * c(j, mu + k3) * aa
            j12 = j12 + c(a, mu + k3) * c(j, mu + k2) * aa

!	    **** terms (k1, k2|k4, k3) ****
            aa = c(i, mu + k1) * c(b, mu + k3) * gk
            k12 = k12 + c(a, mu + k2) * c(j, mu + k4) * aa
            j12 = j12 + c(a, mu + k4) * c(j, mu + k2) * aa

!	    **** terms (k3, k4|k1, k2) ****
            aa = c(i, mu + k3) * c(b, mu + k2) * gk
            k12 = k12 + c(a, mu + k4) * c(j, mu + k1) * aa
            j12 = j12 + c(a, mu + k1) * c(j, mu + k4) * aa

!	    **** terms (k4, k3|k1, k2) ****
            aa = c(i, mu + k4) * c(b, mu + k2) * gk
            k12 = k12 + c(a, mu + k3) * c(j, mu + k1) * aa
            j12 = j12 + c(a, mu + k1) * c(j, mu + k3) * aa

            if (k1 /= k2) then
!	      **** terms (k2, k1|k3, k4) ****
              aa = c(i, mu + k2) * c(b, mu + k4) * gk
              k12 = k12 + c(a, mu + k1) * c(j, mu + k3) * aa
              j12 = j12 + c(a, mu + k3) * c(j, mu + k1) * aa

!	      **** terms (k2, k1|k4, k3) ****
              aa = c(i, mu + k2) * c(b, mu + k3) * gk
              k12 = k12 + c(a, mu + k1) * c(j, mu + k4) * aa
              j12 = j12 + c(a, mu + k4) * c(j, mu + k1) * aa

!	      **** terms (k3, k4|k2, k1) ****
              aa = c(i, mu + k3) * c(b, mu + k1) * gk
              k12 = k12 + c(a, mu + k4) * c(j, mu + k2) * aa
              j12 = j12 + c(a, mu + k2) * c(j, mu + k4) * aa

!	      **** terms (k4, k3|k2, k1) ****
              aa = c(i, mu + k4) * c(b, mu + k1) * gk
              k12 = k12 + c(a, mu + k3) * c(j, mu + k2) * aa
              j12 = j12 + c(a, mu + k2) * c(j, mu + k3) * aa
            end if

          end do
        end if
      end do

!     **** store matrix elements ****

      if (ifstor == 1) then
        ee2(nmc) = sngl (j12)
        ee2(nme) = sngl (k12)
        j12 = ee2(nmc)
        k12 = ee2(nme)
      end if

      return
      end

!     *************************************************************************

      function eec1 (i1, a1, c, gamma, nbtmo)

!     **** evaluates sum over core j of (i, a|j, j) with i, a in x space ****
      use reimers_C, only : n, matind, ncore, edef, eec
!      USE chanel_C, only : iw

      implicit none
      double precision ::  c(n, n), gamma(n, n), eec1
      integer ::           nbtmo(n)
      integer ::           a, a1, i, i1, j, nm
      double precision ::  j12, k12
      double precision ::            edefs

      i = i1 - ncore
      a = a1 - ncore
      nm = matind(max(i, a)) + min(i, a)
      edefs = edef / 2.
      if (eec(nm) > edefs) then
!	**** value not previously determined, calculate it ****
        eec(nm) = 0.0
        do j = 1, ncore
          call inttr (i1, a1, j, j, c, gamma, nbtmo, j12, k12, 0)
          eec(nm) = eec(nm) + 2.d0*j12 - k12
        end do
      end if

      eec1 = eec(nm)
      return

      end function eec1

!     *************************************************************************

      function align (i, j, spn, aocc, bocc)

!     **** calculates the number of column interchanges necessary to give ****
!     **** optimum alignment of two determinates.			  ****
!     **** returns 1.d0 if even nber, - 1.d0 if odd number		  ****
!     **** I, J are orbs that are different in spin type SPN		  ****
!
!     **** ELECTRON ORDERING IS: alpha(1) beta(1) alpha(2) beta(2) ...	  ****
!     **** ie, any electron for orbital i appears before any for orb i + 1  ****
!     **** which is different to Georges book which has all alpha els	  ****
!     **** followed by all beta els.  The consequence is that signs of    ****
!     **** linear combinations change, eg, closed shell i - >a singlet state ***
!     **** is |i, a_bar> - |i_bar, a> wheras in Goerges book its written as ****
!     ****    |i, a_bar> + |a, i_bar>					  ****
!     **** This choice has consequences only here and in S2 matrix gen	  ****
      use reimers_C, only : nov

      implicit none
      double precision ::  align
      integer ::           i, j, k, i1, j1, ninter
      logical*1 ::         aocc(nov), bocc(nov), spn

      i1 = min(i, j)
      j1 = max(i, j)
      ninter = 0
      do k = i1 + 1, j1 - 1
        if (aocc(k)) ninter = ninter + 1
        if (bocc(k)) ninter = ninter + 1
      end do
      if (spn) then
!	**** electron is alpha spin, move past a beta spin in orb i1 ****
        if (bocc(i1)) ninter = ninter + 1
      else
!	**** electron is beta spin, move past an alpha spin in orb j1 ****
        if (aocc(j1)) ninter = ninter + 1
      end if

      align = 1.d0
      if (mod(ninter, 2) == 1) align = -1.d0
      return

      end function align

!     **********************************************************************

      subroutine cimat (c, gamma, beta, nbtmo, istsym, e, aocc, bocc, &
     &                spintr, nspn, ci, ndump)
      use reimers_C, only : n, nb2, matind, nconf, multci, ncore, nol, nvl, &
           nvh, nov, fastci, edef, eec, ee2, iwk, wk0, nex, cc0, mspn
      use cosmo_C, only : ffact, diagsl

      implicit none
      double precision ::  e(nconf), beta(nb2), ci(nconf*(nconf + 1)/2), &
                        c(n, n), gamma(n, n), spintr(mspn, nconf), &
                        ciener, e1, e2, xxx, edefs
      integer ::      istsym(nconf), nspn(nconf), io(nconf), b, &
                        iv(nconf), i, j, k, iout, ioutt, iw = 0, &
                        k1, k2, ndump, nm, nxs, nxss
      double precision ::  j12, k12
      logical*1 ::         aocc(nov, mspn, nex), bocc(nov, mspn, nex), same
      integer ::           a, nbtmo(n)

!     ****  RHF: generates singlet or triplet CI matrix h ****
!     **** ROHF: generates CI matrix in (S) with spin Sz = MULTCI   ****
!     ****	 and hence S**2 components > = Sz.  The S**2 matrix ****
!     ****	 is written into matrix (T).			   ****

!     **** zero entire matrix ****
      do i = 1, matind(nconf) + nconf
        ci(i) = 0.d0
      end do

      if (fastci) then
!	************ RHF calc, singles excitations only ****************

!	**** CI matrix element of excitn i - >a with excitn j - >b ****
        do k2 = 2, nconf
!	  **** first, determine occ and vir levels in excitation ****
          io(k2) = 1
          do while (aocc(io(k2), 1, k2))
            io(k2) = io(k2) + 1
          end do
          iv(k2) = nvl - ncore
          do while (.not.aocc(iv(k2), 1, k2))
            iv(k2) = iv(k2) + 1
          end do

          nm = matind(k2) + k2
          ci(nm) = ci(nm) + e(k2)
          do k1 = 2, k2 - 1
            if (istsym(k2) == istsym(k1)) then
!	      **** matrix elements, J = [ij|ab], K = [ia|jb] ****
              call inttr (ncore + io(k2), ncore + io(k1), ncore + iv(k2), &
     &                    ncore + iv(k1), c, gamma, nbtmo, j12, k12, 0)
              nm = matind(k2) + k1
              ci(nm) = ci(nm) - j12
              if (multci == 1) ci(nm) = ci(nm) + 2.d0 * k12
            end if
          end do

        end do
      else

!	**************** General open shell matrix elements *************

        do k2 = 1, nconf
          nm = matind(k2) + k2
          ci(nm) = ci(nm) + e(k2)
          do k1 = 1, k2 - 1
            e1 = 0.d0
            if (istsym(k2) == istsym(k1)) then


!	      **** each config is a spin-adapted linear combs of dets	****
!	      **** if both sets of dets are the same, then E = 0 as these ****
!	      **** are both eigenvectors of the same orb class in SPCLAS ***
              same = nspn(k1)  ==  nspn(k2)
              i = 0
              do while (same .and. i < nov)
                i = i + 1
                same = (aocc(i, 1, k1) .eqv. aocc(i, 1, k2)) .and.&
     &                (bocc(i, 1, k1) .eqv. bocc(i, 1, k2))
              end do
              if (.not. same) then
                do i = 1, nspn(k1)
                  e2 = 0.d0
                  do j = 1, nspn(k2)
                    xxx = ciener (aocc(1, i, k1), &
     &                 bocc(1, i, k1), aocc(1, j, k2), bocc(1, j, k2), &
     &                 c, gamma, nbtmo, beta)
                    e2 = e2 + spintr(j, k2) * xxx
                  end do
                  e1 = e1 + spintr(i, k1) * e2
                end do
              end if
              nm = matind(k2) + k1
              ci(nm) = ci(nm) + e1

            end if
          end do
        end do

      end if

! RMG - add COSMO correction to CI diagonal matrix elements
      if (ffact > 0.d0) then
        do i = 1, n
          do j = 1, n
            cc0(i, j) = c(i, j)
          end do
        end do
        if (allocated(diagsl)) deallocate(diagsl)
        allocate(diagsl(nconf))
        call diagci(ci, aocc, bocc, diagsl)
      end if

!     ********************** dump output ******************

      i = 4
      if (ndump > 0) i = 3
      nxs = nov*(nov + 1)/2
      nxss = nxs*(nxs + 1)/2
      edefs = edef / 2.d0

      if (ndump >= 2) then
!       **** dump matrix elements differing by 1 electron ****
        write (iw, "(/' Contributions to integrals differing by 1 electron:', &
     &         ' from BETA, from sum over CI core, and total'/)")
        iout = 0
        ioutt = 0
        nm = 0
        do i = nol, nvh
          do a = nol, i
            nm = nm + 1
            if (eec(nm) < edefs) then
              ioutt = ioutt + 1
              iout = iout + 1
              iwk(1, iout) = i
              iwk(2, iout) = a
              wk0(1, iout) = beta(matind(i) + a)
              wk0(2, iout) = eec(nm)
            end if
            if (iout == 5 .or. iout > 0 .and. nm == nxs) then
              write (iw, '(5(2i4, 2f6.0, f6.1))') (iwk(1, k), iwk(2, k), wk0(1, k), wk0(2, k), &
     &            wk0(1, k) + wk0(2, k), k = 1, iout)
              iout = 0
            end if
          end do
        end do
        write (iw, "(1x, a3, ' used = ', i6, ' maximum = ', i6, ' fraction = ', f6.2)") &
          'eec', ioutt, nxs, ioutt/float(nxs)

!       **** dump matrix elements differing by 2 electrons ****
        write (iw, "(/' Non - Zero Contributions to integrals differing by 2', &
     &         ' electrons'/)")
        iout = 0
        ioutt = 0
        nm = 0
        do i = nol, nvh
         do j = nol, i
          do a = nol, j
           do b = nol, a
            nm = nm + 1
            if (ee2(nm) < edefs) then
              ioutt = ioutt + 1
              if (ee2(nm) /= 0.E0) then
                iout = iout + 1
                iwk(1, iout) = i
                iwk(2, iout) = j
                iwk(3, iout) = a
                iwk(4, iout) = b
                wk0(1, iout) = ee2(nm)
              end if
            end if
            if (iout == 6 .or. iout > 0 .and. nm == nxss) then
              write (iw, '(6(4i4, f6.2))') (iwk(1, k), iwk(2, k), iwk(3, k), iwk(4, k), &
     &            wk0(1, k), k = 1, iout)
              iout = 0
            end if
           end do
          end do
         end do
        end do
        write (iw, "(1x, a3, ' used = ', i6, ' maximum = ', i6, ' fraction = ', f6.2)") &
          'ee2', ioutt, nxss, ioutt/float(nxss)
      end if

      return
      end subroutine cimat

!     ***********************************************************************

      function ciener (aoi, boi, aoj, boj, c, gamma, nbtmo, beta)

!     **** determines the interaction energy between two necessarily	****
!     **** different dets. first is aoi, boi; second is aoj, boj		****
      use cosmo_C, only : bmat, nden, gden, ipiden, nps, qscnet, useps
      use funcon_C, only : a0, ev
      use reimers_C, only : n, nb2, matind, ncore, nol, nvh, nov, &
          ndiff, io, iv, cc0
      use molkst_c, only : mpack

      implicit none
      integer ::  nbtmo(n)
      double precision ::  beta(nb2), c(n, n), gamma(n, n), &
                        j12, k12, ciener, e, eec1, align
      integer ::           i, j, ivo, j1, ndiffo, ndiffv, a
      logical*1 ::         aoi(nov), boi(nov), aoj(nov), boj(nov), &
     &                  ao, bo, spno(2), spnv(2), ao1(nov), bo1(nov)
      double precision  ::  ediel, fcon, phi(nps), qden(nden), p(mpack)

      e = 0.d0

!      ************ determine nber of different electrons ************
!      **** ndiff = total, o = occ in k1 not k2; v = occ in k2 not k1****
!      **** spn = true if alpha ****
      ndiff = 0
      ndiffo = 0
      ndiffv = 0
      do j1 = nol, nvh
        j = j1 - ncore

!        **** check alpha occupancy ****
        if (aoi(j) .neqv. aoj(j)) then
          if (ndiff == 4) goto 120
          ndiff = ndiff + 1
          if (aoi(j)) then
            ndiffo = ndiffo + 1
            if (ndiffo > 2) goto 120
            io(ndiffo) = j1
            spno(ndiffo) = .true.
          else
            ndiffv = ndiffv + 1
            if (ndiffv > 2) goto 120
            iv(ndiffv) = j1
            spnv(ndiffv) = .true.
          end if
        end if

!       **** check beta occupancy ****
        if (boi(j) .neqv. boj(j)) then
          if (ndiff == 4) goto 120
          ndiff = ndiff + 1
          if (boi(j)) then
            ndiffo = ndiffo + 1
            if (ndiffo > 2) goto 120
            io(ndiffo) = j1
            spno(ndiffo) = .false.
          else
            ndiffv = ndiffv + 1
            if (ndiffv > 2) goto 120
            iv(ndiffv) = j1
            spnv(ndiffv) = .false.
          end if
        end if

      end do

      if (ndiff == 2) then
!	******* differ in one electron, excitn io(1) - >iv(1) ********

!	**** core term sum_j in core (io, iv|j, j) ****
        e = e + eec1 (io(1), iv(1), c, gamma, nbtmo)

!	**** (io, iv|j, j) terms with j in xcitn space ****
        do j1 = nol, nvh
          j = j1 - ncore
          ao = aoi(j)
          bo = boi(j)
          if (j1 == io(1) .or. j1 == iv(1)) then
!	    **** remove the electon thats changing from sum ****
            if (spno(1)) then
              ao = .false.
            else
              bo = .false.
            end if
          end if

          if (ao .or. bo) then
!	    **** calc <i, j||a, j> via J = [i, a|j, j] and K = [i, j|a, j] ****
            call inttr (io(1), iv(1), j1, j1, &
     &          c, gamma, nbtmo, j12, k12, 0)
            if (ao .and. bo) then
!		      **** orb k has both electrons occupied ****
              e = e + 2.d0*j12 - k12
            else if (ao .eqv. spno(1)) then
!              **** one electron, same spin as moving one ****
              e = e + j12 - k12
            else
!              **** one electron, opp spin to moving one ****
              e = e + j12
            end if
          end if
         end do

!        **** add one - electron term ****
         ivo = matind (max(io(1), iv(1))) + min(io(1), iv(1))
         e = e + beta(ivo)

!        **** determine sign due to reorg of det to line it all up ****
! Add solvent correction for electron - induced surface charges to beta(ivo)
         if (useps) then
           ediel = 0.d0
           fcon = a0 * ev
           a = 0
! Construct electron density for the product of orbitals
           do i = 1, n
             do j = 1, i
               a = a + 1
               p(a) = cc0(iv(1), i)*cc0(io(1), j)
             end do
           end do
! Set up charge density for solvation
           do i = 1, nden
             qden(i) = gden(i) * p(ipiden(i))
           end do
! Compute electrostatic potential at each surface point
           do i = 1, nps
             phi(i) = 0.d0
             do j = 1, nden
               phi(i) = phi(i) + bmat(j, i) * qden(j)
             end do
           end do
           do i = 1, nps
             ediel = ediel + qscnet(i, 2) * phi(i)
           end do
           e = e + ediel * fcon
          end if

!        **** determine sign due to reorg of det to line it all up ****
         e = e * align (iv(1) - ncore, io(1) - ncore, spno(1), aoi, boi)


       else
!        ********* dets differ by two electrons ***********

         if (spno(1) .neqv. spnv(1) ) then
!          **** ensure io(1) and iv(1) are same spin ****
           j = iv(1)
           iv(1) = iv(2)
           iv(2) = j
         end if
!	 *** calc <ij||ab> = <ib||aj> via J = [i, a|b, j] and K = [ib|aj] ****
        call inttr (io(1), iv(1), iv(2), io(2), c, gamma, nbtmo, &
      &              j12, k12, 0)
        e = j12
        if (spno(1) .eqv. spno(2)) e = e - k12

!       **** determine sign due to reorg of det, electron 1 ****
        e = e * align (iv(1) - ncore, io(1) - ncore, spno(1), aoi, boi)

!       **** determine change to det k1 after this rearrangement ****
        do i = 1, nov
          ao1(i) = aoi(i)
          bo1(i) = boi(i)
        end do
        if (spno(1)) then
          ao1(io(1) - ncore) = .false.
          ao1(iv(1) - ncore) = .true.
        else
          bo1(io(1) - ncore) = .false.
          bo1(iv(1) - ncore) = .true.
        end if

!       **** determine sign due to reorg of det, electron 2 ****
        e = e * align (iv(2) - ncore, io(2) - ncore, spno(2), ao1, bo1)

      end if

120   continue
      ciener = e
      return
      end function ciener

!     *************************************************************************

      subroutine cidiag (ciin, ci, aii, aocc, bocc)
      use reimers_C, only : matind, nconf, nci, nr, nov, nex, mspn
      use cosmo_C, only : ffact, diagsl

      implicit none
      double precision ::  ciin(nconf*(nconf + 1)/2), ci(nconf, nconf), &
                        aii(nconf), wk0(nconf), emin, xx
      integer ::           i, j, k, i0, ier, nm, nconf1
      logical*1 ::         aocc(nov, mspn, nex), bocc(nov, mspn, nex)


!     **** expand symmetric matrix into full storage mode ****
      nm = matind(nconf) + nconf
      do i = nconf, 1, - 1
        do j = i, 1, - 1
          ci(j, i) = ciin(nm)
          nm = nm - 1
        end do
      end do
      do i = nconf, 1, - 1
        do j = i, 1, - 1
          ci(i, j) = ci(j, i)
        end do
      end do

!     **** block - wise diagonalization ****
      i0 = 1
      do i = 1, nr
        if (nci(i) > 0) then

          call tred2e (nconf, nci(i), ci(i0, i0), aii(i0), wk0, ci(i0, i0))
          call tql2e  (nconf, nci(i),         aii(i0), wk0, ci(i0, i0), ier)
          i0 = i0 + nci(i)
        end if
      end do

! RMG - correct eigenvalues if using solvent
      if (ffact > 0.d0) then
        call corrci(ciin, ci, aocc, bocc, diagsl, aii)
      end if

!     **** order in terms of increasing eigenvalue ****
      do nconf1 = 1, nconf
        k = 0
        emin = 1.d30
        do i = nconf1, nconf
          if (emin > aii(i)) then
            k = i
            emin = aii(i)
          end if
        end do
        xx = aii(nconf1)
        aii(nconf1) = aii(k)
        aii(k) = xx
        do i = 1, nconf
          xx = ci(i, nconf1)
          ci(i, nconf1) = ci(i, k)
          ci(i, k) = xx
        end do
      end do
!     **** transpose eigenvectors ****
      do i = 2, nconf
        do j = 1, min(i - 1, nconf)
          xx = ci(i, j)
          ci(i, j) = ci(j, i)
          ci(j, i) = xx
        end do
      end do

      return
      end subroutine cidiag

!     *************************************************************************

      subroutine ciout (ci, evalci, istsym, dmci, aocc, bocc, tot)
      use reimers_C, only : n, matind, au2ev, au2ang, au2cm, debye, &
          nconf, ndtype, nmrep, nptg, nr, ixprd, nov, &
          n2phot, nese, nciout, nciouv, filenm, lenf, irrtyp, occ, &
          istate, nex, mspn
      USE chanel_C, only : iw
      use molkst_C, only : keywrd

      implicit none
      double precision :: mom, evalci(nconf), ci(nconf, nconf), &
                        dmci(nconf*(nconf + 1)/2, 3), &
                        beta, deldip, dipch, dlo, dmtot, eng, feps = 0.d0, &
                        fosc, foscf, foscm, fref = 0.d0, freq, &
                        rmom, solva, solve, tot, &
                        wl, cisum
      integer ::           istsym(nconf), &
                        i, j, k, i0, il, kk, &
                        nm, nm0, nmd, nst, nsx, nsy
      logical*1 ::       solv = .false.
      logical*1 ::         aocc(nov, mspn, nex), bocc(nov, mspn, nex)
      double precision ::  wrtconf
      double precision, external :: reada
      integer, allocatable :: nelc(:, :)
      allocate (nelc(n, nconf))
 1005 format (a5, 1x, i4, 1x, f7.4, '     CI coeff  CI percent')
 1006 format (4x, a7, 2x, i5, 1x, f12.8, f12.8)
 1007 format (a24, 7x, f12.8)
 1150 format (/' Depression of ground-state after CI=', &
     &         f12.0, ' cm**-1', ' Energy=', f14.7, ' eV' /&
     &         ' Dipole moment=', 3f10.6, ' tot=', f10.6, ' Debyes'/)
 1170 format (i4, i2, 1x, a3, f8.1, f10.6, f8.3)
      nr = 1
      nciouv = nciout
      nese = 1
      ndtype = 1
      if(allocated(occ)) deallocate(occ)
      allocate(occ(nov))

!     **** determine CI state symmetry ****
      if(allocated(istate)) deallocate(istate)
      allocate(istate(nconf))
      do il = 1, nconf
        j = 1
        do while (abs(ci(il, j)) < 1.d-2)
          j = j + 1
        end do
        nsy = istsym(j)
        istate(il) = nsy
      end do

!     **** determine MO occupancy CI states ****
      do j = 1, nconf
!	**** determine nber of electrons in MO i in all configs j ****
        do i = 1, nov
          nelc(i, j) = 0
          if (aocc(i, 1, j)) nelc(i, j) = 1
          if (bocc(i, 1, j)) nelc(i, j) = nelc(i, j) + 1
        end do
      end do
      do j = 1, nciout
!	**** weight these by CI coeffs ****
        do i = 1, nov
          occ(i) = 0.d0
          do k = 1, nconf
            occ(i) = occ(i) + nelc(i, k) * ci(j, k)**2
          end do
        end do
      end do

!     **** ground state properties ****
      dmtot = sqrt (dmci(1, 1)**2 + dmci(1, 2)**2 + dmci(1, 3)**2) * debye
      dlo = evalci(1)/au2ev*au2cm
      write (iw, 1150) dlo, evalci(1) + tot, (debye*dmci(1, kk), kk = 1, 3), dmtot

!     **** read solvent shift parameters ****

      solva = 0.d0
      solve = 0.d0
      foscf = 2.d0/3.d0/au2ang**2/au2cm
      foscm = 2.d0/3.d0*au2ang**2*au2cm

!     *************** output excitations from CI states ****************
! RMG - add option to write transition dipoles between excited states
      if (index(keywrd, ' TDIP') /= 0) then
        filenm(lenf:lenf + 4) = '.tdip'
        open (14, file = filenm, status = 'unknown')
        write(14, *) nciout
      end if
! End RMG
      do i0 = 1, nese

        nsx = istate(i0)
        write (iw, "(/'  CI trans.  energy frequency wavelength oscillator', &
     & '--------- polarization---------  dipole  ', &
     & '------ components-----')")
        write (iw, "(' st.  symm.    eV      cm - 1       nm      strength ', &
     & '      x          y         z       moment     x       y  ', &
     & '     z ' /)")
        call polzro
        nm0 = matind(i0) + i0

        do il = 1, nciout
         if (il /= i0) then
          eng = evalci(il) - evalci(i0)
          freq = eng / au2ev * au2cm
! RMG - add option to write transition dipoles between excited states
          if (index(keywrd, ' TDIP') /= 0) then
            write(14, *) eng
          end if
! End RMG

          wl = 0.d0
          if (abs(freq) > 1.d0) wl = 1.D7/abs(freq)
          nsy = istate(il)
          nst = ixprd(nsx, nsy)

!         **** dipole moments and solvent shifts ****
          nmd = matind(il) + il
          dmtot = sqrt (dmci(nmd, 1)**2 + dmci(nmd, 2)**2 + dmci(nmd, 3)**2)&
     &                * debye
          if (i0 == 1 .and. solv) then
            beta = 0.d0
            solva = 0.d0
            solve = 0.d0
            do kk = 1, 3
              deldip = dmci(nmd, kk) - dmci(nm0, kk)
              beta = beta + deldip**2
              solva = solva + dmci(nm0, kk)*deldip
              solve = solve + dmci(nmd, kk)*deldip
            end do
            beta =  fref * beta * 0.5
            solva = -feps * solva - beta
            solve = -feps * solve + beta

!	    **** Jeffs special code to evaluate polarizability after shift ****
            evalci(il) = evalci(il) + solva * au2ev / au2cm
            eng = evalci(il) - evalci(i0)
            freq = eng / au2ev * au2cm
            wl = 0.d0
            if (abs(freq) > 1.d0) wl = 1.D7/abs(freq)
          end if

!	  **** transition moments and oscillator strengths ****
          nm = matind(max(i0, il)) + min(i0, il)
          mom = dmci(nm, 1)**2 + dmci(nm, 2)**2 + dmci(nm, 3)**2
!	  write (iy, '(3i4, 4f10.5)') i0, il, nm, sqrt(mom)*debye,
!     $				   (dmci(nm, k)*debye, k = 1, 3)
          if (ndtype /= 2) then
!	    **** f = 2/3*m**2*e with m, e in au; with m in Ang and e in cm** - 1
            fosc = foscf * freq * mom
            if (ndtype == 3) fosc = fosc * 1000.d0
          else
!	    **** f = 2/3*m**2/e with m, e in au; with m in Ang** - 1 and e in cm** - 1
            fosc = foscm / freq * mom
          end if
          call polizn (dmci(nm, 1), dmci(nm, 2), dmci(nm, 3), freq)

          dipch = sqrt ((dmci(nmd, 1) - dmci(1, 1))**2 + &
     &      (dmci(nmd, 2) - dmci(1, 2))**2 + (dmci(nmd, 3) - dmci(1, 3))**2)
          if (irrtyp > 0 .and. freq < 4.D5) write (40, 1170)&
     &      il - 1, nst, nmrep(nst, nptg), freq, fosc, dipch

          if (il > i0 .and. fosc > 0.00000001d0) then

!	    **** main output to log file ****
            rmom = 1.d0 / sqrt(mom)
            if (ndtype <= 1) then
              write (iw, "(i4, 1x, a3, f11.7, f10.0, f10.2, f10.6, 3f11.6, f10.6, 3f8.3)") &
                il, nmrep(nst, nptg), eng, freq, wl, fosc, &
     &                (dmci(nm, kk)*rmom, kk = 1, 3), &
     &                dmtot, (debye*dmci(nmd, kk), kk = 1, 3)
            else
              write (iw, "(i4, 1x, a3, f11.7, f10.0, f10.2, f10.6, 3f11.6, f10.6, 3f8.3)") &
                il, nmrep(nst, nptg), eng, freq, wl, fosc, &
     &                (dmci(nm, kk)*rmom, kk = 1, 3)
            end if

          else if (il > i0) then
!	    **** main output to log file, no osc strength ****
            if (ndtype <= 1) then
              write (iw, '(i4, 1x, a3, f11.7, f10.0, f10.2, f10.6, 33x,  f10.6, 3f8.3)') &
                il, nmrep(nst, nptg), eng, freq, wl, fosc, &
     &                dmtot, (debye*dmci(nmd, kk), kk = 1, 3)
            else
              write (iw, '(i4, 1x, a3, f11.7, f10.0, f10.2, f10.6, 33x,  f10.6, 3f8.3)') &
                il, nmrep(nst, nptg), eng, freq, wl, fosc
            end if
          end if

         end if
         end do

        if (ndtype <= 1) call polout
        if (n2phot > 0) call twopho (i0, evalci, dmci, istate)
      end do

!     ************************ write out ci matrix **********************
!     RMG add-print major state contributions for all states

      wrtconf = 0.04d0
      if (index(keywrd, ' WRTCONF=') /= 0) then
        wrtconf = reada(keywrd, index(keywrd, ' WRTCONF='))
      end if

      write (iw, *)
      write (iw, *)
      write (iw, *) 'Major CI contributions to CI states'
      write (iw, *)

      do il = 1, nciout
        eng = evalci(il) - evalci(1)
        write (iw, 1005) 'State ', il, eng

!       Find configurations with large contributions
!
        cisum = 0
        do i = 1, nconf
          if (abs(ci(il, i)) > wrtconf) then
            write(iw, 1006) 'Config ', i, ci(il, i), ci(il, i)**2
            cisum = cisum + ci(il, i)**2
          end if
        end do
        write (iw, 1007) 'Total coeff printed    ', cisum
        write (iw, *) ' '
      end do
!     End RMG

! RMG - add option to write transition dipoles between excited states
      if (index(keywrd, ' TDIP') /= 0) then
        do i = 1, nciout
          do j = 1, i
            nm = matind(max(i, j)) + min(i, j)
            write(14, '(i5, i5, 3f12.6)') i, j, dmci(nm, 1)*debye, dmci(nm, 2)*debye, dmci(nm, 3)*debye
          end do
         end do
        close(14)
      end if

! End RMG

      return

      end subroutine ciout

!     *************************************************************************

      subroutine foscil (dmci, dm, istsym, e, aocc, bocc, spintr, nspn, xz, zcore)

!     **** uses dipole moment in MO basis to construct dipole integrals ****
!     **** between CI configurations					****
      use reimers_C, only : na, nb2, matind, au2ev, au2ang, au2cm, debye, &
          icifrag, nconf, multci, ncore, nov, fastci, n2phot, nciouv, &
          nmrep, nptg, aor1, bor1, dipsym, ndtype, nex, mspn
      USE chanel_C, only : iw

      implicit none
      double precision ::  dmci(nconf*(nconf + 1)/2, 3), dm(nb2, 3), &
                        e(nconf), spintr(mspn, nconf), xz(na, 3), &
                        zcore(na), dcore(3), sqrt2, foscf, foscm, &
                        xx, align, emin, freq, diplen, tmsq, f
      integer ::           istsym(nconf), nspn(nconf), &
                        i, j, k, i1, ilow, iov, ivo, j1, k1, k2, kk, &
                        maxx, ndiff, nel, nio, niv, nm, nspni
      logical*1 ::         aocc(nov, mspn, nex), bocc(nov, mspn, nex), &
     &                  same, adiff, bdiff, abdiff
      character*4       lo(9), lv(9), ll
      character*3       rep

      write (iw, "(' The lowest ', i4, ' spin-adapted configurations of ', &
     &        'multiplicity=', i3 /&
     &        5x, 'sym   eV   cm**-1 -dets- dipole oscilator X FRAG ....', &
     &        'Excitations named from first reference determinate' /&
     &        23x, 'tot  #  Debye  strength')") nconf, multci
      nciouv = nconf

      if (ndtype == 3) write (iw, "(45x, ' x 1000')")
      write (iw, *)
      call polzro
      sqrt2 = sqrt (2.d0)
      foscf = 2.d0/3.d0/au2ang**2/au2cm
      foscm = 2.d0/3.d0*au2ang**2*au2cm

      if (ndtype == 4) then
!	**** dont do any dipole or transition moment calcs ****
        do i = 1, 3
          do j = 1, nconf*(nconf + 1)/2
            dmci(j, i) = 0.d0
          end do
        end do
        goto 500
      end if

!     **** determine dipole moment of (nucleas + inner shells) + valence core ****

      do kk = 1, 3
        dcore(kk) = 0.d0
         if (abs(dipsym - 1.d0) < 1.d-10) then
          do i = 1, na
            dcore(kk) = dcore(kk) + xz(i, kk) * zcore(i)
          end do
          do i = 1, ncore
            dcore(kk) = dcore(kk) + dm(matind(i) + i, kk)*2.d0
          end do
        end if
      end do

!     ***** calc dipole and transition moments ****

      nm = 0
      do i = 1, nconf
!	**** transition moments ****
        do j = 1, i - 1
          nm = nm + 1
          dmci(nm, 1) = 0.d0
          dmci(nm, 2) = 0.d0
          dmci(nm, 3) = 0.d0

!	  **** loop over each det in each config ****
          do i1 = 1, nspn(i)
            do j1 = 1, nspn(j)

!	      **** count the nber of electrons differing, proceed if 1 only ****
              ndiff = 0
              k = 0
              do while (ndiff <= 3 .and. k < nov)
                k = k + 1
                adiff = aocc(k, i1, i) .neqv. aocc(k, j1, j)
                bdiff = bocc(k, i1, i) .neqv. bocc(k, j1, j)
                if (adiff .and. bdiff) then
                  ndiff = 100
                else if (adiff .or. bdiff) then
                  ndiff = ndiff + 1
                  k2 = k
                  if (ndiff == 1) k1 = k
                  abdiff = adiff
                end if
              end do

              if (ndiff == 2) then
!		**** determine sign due to reorg of det to line it all up ****
                xx = align (k1, k2, abdiff, aocc(1, i1, i), bocc(1, j1, j)) *&
     &                spintr(i1, i) * spintr(j1, j)
!		**** check if dip ints real or imag; get symm of matrix ****
                ivo = matind(ncore + k2) + ncore + k1
                do kk = 1, 3
                  dmci(nm, kk) = dmci(nm, kk) + xx * dm(ivo, kk)
                end do
              end if

            end do
          end do

          if (fastci .and. j == 1) then
!	    **** GS interaction; apply directly + / - linear combs of det pair ****
            do kk = 1, 3
              dmci(nm, kk) = sqrt2 * dmci(nm, kk)
              if (multci == 3) dmci(nm, kk) = 0.d0
            end do
          end if
        end do

!	**** dipole moment of CI state i ****
        nm = nm + 1
        dmci(nm, 1) = dcore(1)
        dmci(nm, 2) = dcore(2)
        dmci(nm, 3) = dcore(3)
        if (abs(dipsym - 1.d0) < 1.d-10) then
          do k = 1, nov
            nel = 0
            if (aocc(k, 1, i)) nel = 1
            if (bocc(k, 1, i)) nel = nel + 1
            if (nel > 0) then
              iov = matind(ncore + k) + ncore + k
              do kk = 1, 3
                dmci(nm, kk) = dmci(nm, kk) + nel * dm(iov, kk)
              end do
            end if
          end do
        end if
      end do
500   continue

!     *************** generate names and output single - dets **************

!     **** first, calc max nber of excitations for format spec ****

      maxx = 0
      do i = 1, nconf
        nio = 0
        niv = 0
         do j = 1, nov
           if (aor1(j) .neqv. aocc(j, 1, i)) then
            if (aor1(j)) then
              nio = nio + 1
            else
              niv = niv + 1
            end if
          end if
          if (bor1(j) .neqv. bocc(j, 1, i)) then
            if (bor1(j)) then
              nio = nio + 1
            else
              niv = niv + 1
            end if
          end if
        end do
        if (nio /= niv) then
          write (iw, *) 'Cant interpret excitation', i
          write (iw, *) 'ref = ', (aor1(j), j = 1, nov), '  ', (bor1(j), j = 1, nov)
          write (iw, *) 'det = ', (aocc(j, 1, i), j = 1, nov), '  ', &
     &                      (bocc(j, 1, i), j = 1, nov)
          stop 'DET FUNNY in FOSCIL'
        end if
        maxx = max (maxx, nio)
      end do
      if (maxx > 9) stop 'EXCITE - OUTPUT IS FOR MAX OF 9 EXCITNS !'

!     *** determine state of lowest energy; calc transition moments from it ****

      emin = 1.D30
      do i = 1, nconf
        if (emin > e(i)) then
          emin = e(i)
          ilow = i
        end if
      end do

!     ***** actually do output *****

      do i = 1, nconf
!	**** first reset flags for Occ and Vir orbs ****
        nio = 0
        niv = 0
        do j = 1, maxx
          lo(j) = '    '
          lv(j) = '    '
        end do

!	**** loop over orbitals, check diffs from first ref det ****
        do j = 1, nov

          if (aor1(j) .neqv. aocc(j, 1, i)) then
!	    **** alpha differs from first ref det ****
            if (aor1(j)) then
              nio = nio + 1
              write (ll, '(i4)') j + ncore
              lo(nio) = ll
            else
              niv = niv + 1
              write (ll, '(i4)') j + ncore
              lv(niv) = ll
            end if
          end if

          if (bor1(j) .neqv. bocc(j, 1, i)) then
!	    **** beta differs from first ref det ****
            if (bor1(j)) then
              nio = nio + 1
              write (ll, '(i4)') j + ncore
              lo(nio) = ll
            else
              niv = niv + 1
              write (ll, '(i4)') j + ncore
              lv(niv) = ll
            end if
          end if
        end do

!	**** check if det list is same as any previous config ****
        nspni = 1
        do k = 1, i - 1
          same = nspn(k)  ==  nspn(i)
          j = 0
          do while (j < nov .and. same)
            j = j + 1
            same = (aocc(j, 1, i) .eqv. aocc(j, 1, k)) .and.&
     &          (bocc(j, 1, i) .eqv. bocc(j, 1, k))
          end do
          if (same) nspni = nspni + 1
        end do

!	**** symmetry, wavenumber, dip length, tr mom to ref state ****
        rep = nmrep(istsym(i), nptg)
        freq = (e(i) - e(ilow))/au2ev*au2cm
        nm = matind(i) + i
        diplen = sqrt (dmci(nm, 1)**2 + dmci(nm, 2)**2 + dmci(nm, 3)**2)

!	**** calculate ground-state polarizability ****
        nm = matind(max(i, ilow)) + min(i, ilow)
        if (ndtype <= 1)&
     &        call polizn (dmci(nm, 1), dmci(nm, 2), dmci(nm, 3), freq)
!	**** calculate oscillator strength ****
        tmsq = dmci(nm, 1)**2 + dmci(nm, 2)**2 + dmci(nm, 3)**2
        if (ndtype /= 2) then
!	  **** f = 2/3*m**2*e with m, e in au; with m in Ang and e in cm** - 1
          f = foscf * tmsq * freq
          if (ndtype == 3) f = f * 1000.d0
        else
!	  **** velocity formalism ****
!	  **** f = 2/3*m**2/e with m, e in au; with m in Ang** - 1 and e in cm** - 1
          f = foscm * tmsq / freq
        end if

        write (iw, "(i4, 1x, a3, f7.3, f8.0, 2i3, f8.4, f9.6, i2, i3, &
     &        ' (', 20a4)") i, rep, e(i), freq, nspn(i), nspni, diplen*debye, &
     &   f, nio, icifrag(i), (lo(j), j = 1, maxx), ')->(', (lv(j), j = 1, maxx), ')'

      end do

!     **** output of estimated GS polarizability ****

!     **** two - photon intensities ****
      if (n2phot > 0) call twopho (ilow, e, dmci, istsym)

      return
      end subroutine foscil

!     *************************************************************************

      subroutine twopho (i0, ener, dm, istsym)

!     **** this calculates 2 - photon relative einstein - B coefficients	****
!     **** for absorption from state i0 which must be non - degenerate	****
!     **** D.P. Craig and T. Thirunamachandran Molecular Quantum	****
!     **** Electrodynamics (Academic, London, 1984) P109		****
      use reimers_C, only : matind, nconf, nptg, nmrep, ixprd, nciout
      USE chanel_C, only : iw

      implicit none
      double precision ::   ener(nconf), dm(nconf*(nconf + 1)/2, 3), &
                         alp11, alp21, alp22, alp31, alp32, alp33, &
                         d, trace, od, planar, circ
      integer ::            istsym(nconf), j, k, i0, isym, nj, nk
      write (iw, "('1Single - Beam 2 - photon relative Einstein B coefficients', &
     &        ' exciting from state', i4 /&
     &        ' transition  energy  lin    cir!       xx        xy', &
     &        '        yy        xz        yz        zz' / )") i0

!     **** loop over all outputted states j ****

      do j = 1, nciout
        if (j /= i0) then
          alp11 = 0.d0
          alp21 = 0.d0
          alp22 = 0.d0
          alp31 = 0.d0
          alp32 = 0.d0
          alp33 = 0.d0

!	  **** loop over all intermediate states k ****
          do k = 1, nconf
            if (k /= i0 .and. k /= j) then
              nj = matind (max(i0, k)) + min(i0, j)
              nk = matind (max(k, j)) + min(k, j)
              d = 1.d0 / (ener(k) - ener(j))
              alp11 = alp11 + dm(nj, 1)*dm(nk, 1) * d
              alp22 = alp22 + dm(nj, 2)*dm(nk, 2) * d
              alp33 = alp33 + dm(nj, 3)*dm(nk, 3) * d
              alp21 = alp21 + (dm(nj, 2)*dm(nk, 1) + dm(nj, 1)*dm(nk, 2)) * d
              alp31 = alp31 + (dm(nj, 3)*dm(nk, 1) + dm(nj, 1)*dm(nk, 3)) * d
              alp32 = alp32 + (dm(nj, 3)*dm(nk, 2) + dm(nj, 2)*dm(nk, 3)) * d
            end if
          end do

!	  **** double count diag terms, calc single - beam intensities ****
          alp11 = alp11 * 2.d0
          alp22 = alp22 * 2.d0
          alp33 = alp33 * 2.d0
          trace = alp11 + alp22 + alp33
          od = alp11**2 + alp22**2 + alp33**2 + 2.d0 * &
     &       (alp21**2 + alp31**2 + alp32**2)
          planar = trace**2 + 2.d0 * od
          circ = -trace**2 + 3.d0 * od
          isym = ixprd (istsym(i0), istsym(j))
          write (iw, '(i4, 1x, a3, f8.3, 2f8.3, 6f10.7)') j, nmrep(isym, nptg), &
            ener(j) - ener(i0), planar, circ, alp11, alp21, alp22, alp31, alp32, alp33
        end if
      end do

      return
      end subroutine twopho

!     *************************************************************************

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine geoutg(iprt)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use common_arrays_C, only : na, coord, geo, loc, labels, &
      & simbol, nb, nc, txtatm
      use molkst_C, only : natoms, nvar, ndep, maxtxt
      USE symmetry_C, ONLY: locpar, idepfn, locdep
      use chanel_C, only : iscr
      use elemts_C, only : elemnt
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: iprt
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(3,natoms) :: igeo
      integer :: i, j, nopt, nbi, nci, l, nchars
      double precision :: degree, w, x
      character , dimension(3,natoms) :: line*14
      character , dimension(3) :: type
      character , dimension(3*natoms) :: optdat*14
      character :: blank*80
      save type
!-----------------------------------------------
!***********************************************************************
!
!   GEOUTG WRITES OUT THE GEOMETRY IN GAUSSIAN-8X STYLE
!
!***********************************************************************
      data type/ 'r', 'a', 'd'/
      degree = 57.29577951308232D0
      do i = 2, natoms
        if (na(i) == 0) exit
      end do
      if (i <= natoms) then
!
!  At least one atom is not in Cartesian coordinates
!  Convert everything to Cartesian coordinates
!
        coord(:,:natoms) = geo(:,:natoms)
        call xyzint (coord, natoms, na, nb, nc, 1.D0, geo)
        nvar = 0
        do i = 1, natoms
          do j = 1, min(3,i - 1)
            nvar = nvar + 1
            loc(1,nvar) = i
            loc(2,nvar) = j
          end do
        end do
      else
!
!   CONSTRAIN ANGLES TO THE RANGE 0 to 180 DEGREES
!
        do i = 4, natoms
          w = geo(2,i)*degree
          x = geo(3,i)*degree
          w = w - aint(w/360.D0)*360.D0
          if (w < 0) w = w + 360.D0
          if (w > 180.D0) then
            x = x + 180.D0
            w = 360.D0 - w
          end if
!
!  CONSTRAIN DIHEDRAL TO DOMAIN -180 - 180 DEGREES
!
          x = x - aint(x/360.D0 + sign(0.5D0 - 1.D-9,x) - 1.D-9)*360.D0
          geo(2,i) = w/degree
          geo(3,i) = x/degree
        end do
      end if
      igeo(:,:natoms) = -1
      do i = 1, nvar
        igeo(loc(2,i),loc(1,i)) = -2
      end do
      do i = 1, ndep
        if (idepfn(i) == 14) then
          igeo(3,locdep(i)) = -locpar(i)
        else
          if (idepfn(i) > 3) cycle
          igeo(idepfn(i),locdep(i)) = locpar(i)
        end if
      end do
      open(unit=iscr, status='SCRATCH', position='asis')
      nopt = 0
      do i = 1, natoms
        do j = 1, 3
          line(j,i) = ' '
          if (igeo(j,i) == (-1)) then
            rewind iscr
            if (j /= 1) then
              write (iscr, '(F12.6)') geo(j,i)*degree
            else
              write (iscr, '(F12.6)') geo(j,i)
            end if
            rewind iscr
            read (iscr, '(A)') line(j,i)
          else if (igeo(j,i) == (-2)) then
            nopt = nopt + 1
            if (simbol(nopt) /= '---------') then
              if (simbol(nopt)(1:1) == '-') then
                line(j,i)(4:) = simbol(nopt)(2:)
              else
                line(j,i)(4:) = simbol(nopt)
              end if
            else
              nbi = nb(i)
              nci = nc(i)
              if (j /= 3) nci = 0
              if (j == 1) nbi = 0
              call xxx (type(j), i, na(i), nbi, nci, line(j,i)(4:))
            end if
            optdat(nopt) = line(j,i)
          else if (igeo(j,i) < 0) then
            line(3,i) = line(3,(-igeo(j,i)))
            line(3,i)(3:3) = '-'
          else
            line(j,i) = line(j,igeo(j,i))
          end if
        end do
        if (maxtxt /= 0 .and. maxtxt /= 27) then
          blank = elemnt(labels(i))//txtatm(i)//'  '
          nchars = max(4,maxtxt + 2)
        else
          blank = elemnt(labels(i))
          nchars = 3
        end if
        if (labels(i) == 99) blank(1:1) = ' '
        select case (i)
        case (1)
          write (iprt, '(1X,A,I4,A,I4,A,I4,A,I4)') blank(:nchars)
        case (2)
          write (iprt, '(1X,A,I4,A,I4,A,I4,A,I4)') blank(:nchars), na(i), line(1,i)
        case (3)
          write (iprt, '(1X,A,I4,A,I4,A,I4,A,I4)') &
          blank(:nchars), na(i), line(1,i), nb(i), line(2,i)
        case default
          write (iprt, '(1X,A,I4,A,I4,A,I4,A,I4)') &
          blank(:nchars), na(i), line(1,i), nb(i), line(2,i), nc(i), line(3,i), 0
        end select
      end do
      write (iprt, *)
      do l = 1, 3
        do i = 1, nopt
          if (loc(2,i) /= l) cycle
          if (loc(2,i) /= 1) then
            write (iprt, '(A,F12.6)') optdat(i), geo(loc(2,i),loc(1,i))*degree
          else
            write (iprt, '(A,F12.6)') optdat(i), geo(loc(2,i),loc(1,i))
          end if
        end do
      end do
      return
      end subroutine geoutg

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine cell(coord, tvec)
!*********************************************************************
!
!   GEOUT PRINTS THE CURRENT GEOMETRY.  IT CAN BE CALLED ANY TIME,
!         FROM ANY POINT IN THE PROGRAM AND DOES NOT AFFECT ANYTHING.
!         IF MODE1 .EQ.1 THEN GEOMETRY IS PRINTED IN USUAL .OUT FORMAT
!                  .GT.1 THEN GEOMETRY IS PRINTED IN .DAT FORMAT to
!                  CHANNEL MODE1
!
!*********************************************************************
    use common_systm, only : natoms, iw, maxtxt, ndep, numat, line
    use common_symult, only : depmul
    use common_keywrd, only : keywrd
    use common_geosym, only : locpar, idepfn, locdep
    use common_elemts, only : elemnt
    implicit none
    integer, parameter :: n_spacer = 4
    double precision :: coord(3,natoms + 3), tvec(3,3)
    integer :: i, j, k, l, m, ic, iend
    double precision :: cell_paras(6), a, b, c, alpha, beta, gamma
    character :: spacer(n_spacer)*1
    double precision, external :: reada
    equivalence (cell_paras(1), a), (cell_paras(2), b), (cell_paras(3), c), (cell_paras(4), alpha), &
      (cell_paras(5), beta), (cell_paras(6), gamma)
    data spacer /" ", "=", ";", ","/
      i = index(keywrd, " CELL") + 4
      keywrd(i + 1:i + 1) = " "
      iend = index(keywrd(i:), ")")
      if (iend == 0) then
        write(iw,'(/10x, a)')" Closing parethesis for keyword ""CELL"" not found"
        stop
      else
        iend = iend + i
      end if
      do j = 1, 6
!
!  Find a spacer
!
        m = iend
        do k = 1, n_spacer
          l = index(keywrd(i:iend), spacer(k))
          if (l /= 0) m = min(m, l)
        end do
        i = i + m
        if (i > iend) exit
        cell_paras(j) = reada(keywrd, i)
!
!  Find the end of the spacer
!
        do l = 1, 60
          i = i + 1
          if (i > iend) exit
          do k = 1, n_spacer
            if (keywrd(i:i) == spacer(k)) exit
          end do
          if (k > n_spacer) exit
        end do
      end do
      if (j < 7) then
        write(iw,'(/10x, a, i1, a)')"Only ", j, " cell parameters found, 6 were expected"
        i = index(keywrd, " CELL") + 6
        write(iw,'(/10x, a)')"Keyword: ""CELL("//keywrd(i:iend-1)//""""
        stop
      end if
      alpha = alpha*0.01745329252d0
      beta  = beta*0.01745329252d0
      gamma = gamma*0.01745329252d0
      tvec = 0.d0
      tvec(1,1) = a
      tvec(1,2) = b*cos(gamma)
      tvec(2,2) = b*sin(gamma)
      tvec(1,3) = c*cos(beta)
      tvec(2,3) = c*(cos(alpha) - cos(beta)*cos(gamma))/sin(gamma)
      tvec(3,3) = sqrt(c**2 - tvec(1,3)**2 - tvec(2,3)**2)
      return
    end subroutine cell

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine geochk ()
!***********************************************************************
!                                                                      *
!  GEOCHK DOES SEVERAL VERY DIFFERENT THINGS:
!
!   (A) IT CHECKS THE GEOMETRY TO MAKE SURE IT CONFORMS TO THE LEWIS
!       STRUCTURE CONVENTIONS.
!
!   (B) IT IDENTIFIES ALL IONIZED ATOMS. LATER ON, MAKVEC WILL NEED TO
!       KNOW WHICH ATOMS ARE IONIZED.
!
!   (C) IT CALCULATES THE CHARGE ON THE SYSTEM.
!
!   (D) (OPTIONAL) IT RESEQUENCES THE ATOMS SO THAT ALL ATOMS OF EACH
!       RESIDUE ARE CONTIGUOUS.  IF THIS IS DONE, THE JOB CANNOT BE
!       CONTINUED, SO THE NEW GEOMETRY IS PRINTED OUT AND THE RUN
!       STOPPED.
!
!                                                                      *
!***********************************************************************
    use common_arrays_C, only : geo, coord, nfirst, nlast, breaks, &
       & labels, nat, na, nb, nc, nbonds, ibonds, txtatm, atmass, pdiag, &
         txtatm1, chains, all_comments, coorda, loc, lopt, l_atom, break_coords
    use MOZYME_C, only : ions, icharges, angles, allres, iz, ib, tyr, allr, &
    iopt, nres, at_res, Lewis_tot, Lewis_elem, noccupied, nvirtual, &
    odd_h, tyres, start_res, lstart_res, uni_res
!
    use molkst_C, only: natoms, numat, nelecs, keywrd, moperr, maxtxt, mozyme, &
      maxatoms, line, nalpha, nbeta, uhf, nclose, nopen, norbs, numcal, id, &
      ncomments, numat_old, nvar, prt_coords, prt_topo, allkey, txtmax, pdb_label
    use chanel_C, only: iw, iarc, archive_fn, log, ilog
    use atomradii_C, only: atom_radius_covalent
    use parameters_C, only : ams, natorb, tore, main_group
    use elemts_C, only : elemnt
    implicit none
!
    integer, parameter :: max_sites = 400
    character :: padding*40, txtatm_1*27, txtatm_2*27, tmp*130
    character, allocatable :: Lewis_formatted(:,:)*20, temp_txtatm(:)*27
    character (len=1), dimension (:), allocatable :: atom_charge
    character :: ion_names(-6:6)*12, charge(max_sites,3)*1, num
    double precision, dimension(:), allocatable :: radius
    logical, save :: debug, let, lres, lreseq, times, opend, charges, l_protein, &
      done, neutral(100), lsite, ter, residues, lbreaks, l_use_old_labels, &
    l_names(max_sites), first, first_prt, header, l_rama, l_salt
    logical, dimension (:), allocatable :: ioptl
    integer :: i, ibad, ichrge, irefq, ires, ii, jj, m, nfrag, io, kk, kkk, near_ions_store(2), &
   & j, jbad, k, l, large, n1, new, alloc_stat, mres, near_ions(2, 100), atomic_charges(8), n_neutral, &
     maxtxt_store, nn1, n_new, new_res(max_sites), j2, mbreaks, icalcn = -10, nnumat, delta_res, max_frag
    integer, dimension(:), allocatable ::  mb
    integer, save :: numbon(3), num_ions(-6:6)
    integer, dimension(:), allocatable :: nnbonds
    integer, dimension(:,:), allocatable :: iibonds
    double precision :: sum, r_ions(100)
    character :: new_name(max_sites)*3, old_name(max_sites)*3, new_chain(max_sites)*1, &
      new_alt(max_sites)*1
    double precision, external :: reada
    data numbon / 3 * 0 /
    data atomic_charges /1, 4, 3, 2, -1, -2, -3, -4/
    data ion_names / &
      "Less than -5", &
      "Penta-anion ", &
      "Tetra-anion ", &
      "Tri-anion   ", &
      "Di-anion    ", &
      "Anion       ", &
      "(not used)  ", &
      "Cation      ", &
      "Di-cation   ", &
      "Tri-cation  ", &
      "Tetra-cation", &
      "Penta-cation", &
      "More than +5" /
!
    intrinsic Abs, Index, Min, Nint, Allocated
    if (icalcn /= numcal) then
      first_prt = .true.
      icalcn = numcal
    end if
    l_rama = (index(keywrd, " writemo_rama") /= 0)
!
    if (allocated(ions))    deallocate (ions)
    if (allocated(iopt))    deallocate(iopt)
    if (allocated(at_res))  deallocate(at_res)
    if (Allocated (iz))     deallocate (iz)
    if (Allocated (ib))     deallocate (ib)
    allocate (ions(maxatoms), iz(maxatoms), ib(maxatoms), mb(maxatoms), at_res(maxatoms), &
            & atom_charge(maxatoms), ioptl(maxatoms), iopt(maxatoms), radius(maxatoms), &
            stat=alloc_stat)
    if (alloc_stat /= 0) then
      call mopend("Failed to allocate arrays in GEOCHK")
      go to 1100
    end if
    l_protein = .false.
    ib(:) = 0
    at_res = 0
    mres = 0
    ions = 0
    j = 0
    lbreaks = (breaks(1) /= -300)
    if (.not. lbreaks) mbreaks = 0
    do i = 1, ncomments
      if (index(all_comments(i), "REMARK   2") == 0) then
        j = j + 1
        all_comments(j) = all_comments(i)
      end if
    end do
    ncomments = j
!
    done = .false.
    n_new = 0
    line = trim(keywrd)
    i = Index (line, " XENO")
    if (i /= 0) then
      do
        if (line(i:i) == "(") exit
        line = line(2:)
      end do
      j = index(line(i:), ") ")
      if (j == 0) then
        call mopend("Closing parenthesis for XENO not found")
        return
      end if
      line = ","//line(i + 1: j + i)
      do
        if (line == " ") exit
        do j = 1, 100
          if (line(1:1) == "," .or. line(1:1) == ";" .or. line(1:1) == ")") exit
          line = line(2:)
        end do
        if (line(1:1) == ")") exit
        line = line(2:)
        k = index(line, "=")
        if (k == 0) then
          call mopend("Equals sign (""="") expected in XENO but not found")
          return
        end if
        l = k + 2
        j = k + 4
        n_new = n_new + 1
        new_chain(n_new) = line(1:1)
        if (new_chain(n_new) >= "0" .and. new_chain(n_new) <= "9") new_chain(n_new) = "A"
        new_res(n_new) = nint(reada(line, 1))
        if (line(l:l) == "," .or. line(l:l) == ";" .or. line(l:l) == ")") then
!
!   A one-letter residue name has been detected.
!
          new_name(n_new) = line(k + 1:k + 1)
        else if (line(j:j) == "," .or. line(j:j) == ";" .or. line(j:j) == ")") then
!
!   A three-letter residue name has been detected.
!
          new_name(n_new) = line(k + 1:k + 3)
        else
          write(iw,'(/10x,a)')"XENO keyword used: ("//trim(line)
          call mopend("RESIDUE NAMES IN KEYWORD XENO MUST BE ONE OR THREE CHARACTERS LONG")
          return
        end if
      end do
    end if
    do
      i = Index (keywrd, " xeno")
      if (i == 0) exit
      keywrd(i:i+6) = " XENO=("
    end do
    do i = 1, n_new
      do j = i + 1, n_new
        if (new_chain(i) == new_chain(j) .and. new_res(i) == new_res(j) .and. &
          new_name(i) /= new_name(j)) then
          write(line,'(a,a,i4,a)')" XENO residue ",new_chain(i), new_res(i),&
          " occurs more than once.  Remove extra definition."
          call mopend(trim(line))
          return
        end if
      end do
      if (new_name(i)(2:3) == "  ") then
        do j = 1, 20
          if (tyr(j) == new_name(i)(1:1)) then
            new_name(i) = tyres(j)
            exit
          end if
        end do
      end if
    end do
!
!   Add or remove hydrogen atoms, as necessary.
!
    i =  index(keywrd," SITE=(IONIZE)")
    if (i > 0) then
      line = "SITE=(COO,NH3,ARG(+),SO4,PO4)"
      keywrd = keywrd(:i)//trim(line)//keywrd(i + 14:)
    end if
    i = index(keywrd," SITE=")
    lsite = .false.
!
!   Identify sites that either should be ionized or should not be ionized.
!
!   In array "neutral", these are:
!
!   1:   -COOH
!   2:   -COO(-)
!   3:   -NH3(+)
!   4:   -NH2
!   5:   -Arg(+)-
!   6:   -Arg-
!   7:   -His(+)-
!   8:   -His-
!   9:    SO4(=)
!  10:    PO4(=)
!  11:   -Lys(+)-
!  12:   -Lys-
!
    n_neutral = 12
    i = index(keywrd," SITE=(")
    if (i /= 0 .and. index (keywrd, " ADD-H") == 0) then
!
!  Quick check that obvious structures are present
!
      j = index(keywrd(i:), ") ") + i
      line = keywrd(i + 7:j)
      do
        i = index(line,'"')
        if (i == 0) exit
        j = index(line(i + 1:), '"') + i + 1
        if (line(j:j) /= "(") then
         call mopend("ERROR IN SITE KEYWORD AT THE END OF '"//line(i:j)//"'")
          write(iw,'(10x,a)')"The last three characters must be one of '(+)', '(0)', or '(-)', e.g,"//line(i:j-1)//"(+)"
          return
        end if
        j = j + 1
        if (line(j:j) /= "+" .and. line(j:j) /= "0" .and. line(j:j) /= "-") then
          call mopend("ERROR IN SITE KEYWORD AT THE END OF '"//line(i:j)//"'")
          write(iw,'(10x,a)')"The last character must be a '+', a '0', or a '-'"
          return
        end if
        j = j + 1
        if (line(j:j) == "+" .or. line(j:j) == "0" .or. line(j:j) == "-") j = j + 1
        if (line(j:j) /= ")" .and. line(j:j) /= "2" .and. line(j:j) /= "3" ) then
          call mopend("ERROR IN SITE KEYWORD AT THE END OF '"//line(i:j)//"'")
          write(iw,'(10x,a)')"The last character must be a '2', a '3', or a ')'"
          return
        end if
        j = j + 1
        if (line(j:j) /= "," .and. line(j:j) /= ")") then
          call mopend("ERROR IN SITE KEYWORD AT THE END OF '"//line(i:j)//"'")
          write(iw,'(10x,a)')"The last character must be a comma ',' or a close parenthesis ')'"
          return
        end if
        line = line(j:)
      end do
      call lewis(.true.)
      do
        i = index(keywrd," SITE=")
        if (keywrd(i + 7:i + 7) == ")") exit
        if (i /= 0 .and. index (keywrd, " ADD-H") == 0) then
          if (moperr) return
          j = index(keywrd(i:), ") ") + i
          call upcase(keywrd(i:j), j - i + 1)
          allkey = keywrd(i:j)
          neutral = .false.
          if (index(keywrd(i:j),"""") == 0) then
            if (index(keywrd(i:j),"COOH") /= 0) then
              neutral(1) = .true.
            else if (index(keywrd(i:j),"COO") /= 0) then
              neutral(2) = .true.
            end if
            if (index(keywrd(i:j),"NH3") /= 0) then
              neutral(3) = .true.
            else if (index(keywrd(i:j),"NH2") /= 0) then
              neutral(4) = .true.
            end if
            if (index(keywrd(i:j),"ARG(+)") /= 0) then
              neutral(5) = .true.
            else if (index(keywrd(i:j),"ARG") /= 0) then
              neutral(6) = .true.
            end if
            if (index(keywrd(i:j),"HIS(+)") /= 0) then
              neutral(7) = .true.
            else if (index(keywrd(i:j),"HIS") /= 0) then
              neutral(8) = .true.
            end if
            if (index(keywrd(i:j),"SO4") /= 0) then
               neutral(9) = .true.
            end if
            if (index(keywrd(i:j),"PO4") /= 0) then
               neutral(10) = .true.
            end if
            if (index(keywrd(i:j),"LYS(+)") /= 0) then
              neutral(11) = .true.
            else if (index(keywrd(i:j),"LYS") /= 0) then
              neutral(12) = .true.
            end if
          end if
          do k = 1, n_neutral
            if (neutral(k)) exit
          end do
          if (k > n_neutral) then
            if (index(keywrd(i:j), "SALT") /= 0) then
              call find_salt_bridges(numbon, numbon, 0, 0)
              if (moperr) return
              if (index(keywrd(i:j), "SALT") /= 0) then
                i = index(keywrd(i:j), "SALT") + i - 2
                do j = i + 1, len_trim(keywrd)
                  if (keywrd(j:j + 1) == ") " .or. keywrd(j:j + 1) == ",") exit
                end do
                keywrd = keywrd(:i)//trim(keywrd(j:))
                cycle
              end if
            end if
    !
    !  Now check for specific residues
    !
            i = index(keywrd," SITE=")
            j = index(keywrd(i:), ") ") + i
            do i = i, len_trim(keywrd)
              if (keywrd(i:i) == "(") exit
            end do
            j = j - 1
            m = 0
            charge = "*"
            do
              i = i + 1
              do
                if (keywrd(i:i) /= """") exit
                do i = i + 1, len_trim(keywrd)
                  if (keywrd(i:i) == ")") exit
                end do
                i = i + 2
              end do
              if (i >= j) exit
              m = m + 1
              new_chain(m) = keywrd(i:i)
              num = char(Int(log10(m*1.0)) + ichar("1") + 1)
              if (new_chain(m) < "A" .or. new_chain(m) > "Z") then
                write(iw,'(//10x,a,/10x,a,i'//num//',a)')" There is a fault in the SITE keyword", &
                " Chain letter for residue", m, " is not in the range 'A' to 'Z'"
              end if
              i = i + 1
              k = ichar(keywrd(i:i)) - ichar("0")
              if ((k < 0 .or. k > 9) .and. keywrd(i:i) /= "-") then
                write(iw,'(//10x,a,/10x,a,i'//num//',a)')" There is a fault in the SITE keyword", &
                " The entry for site", m, " is faulty"
              end if
              if (keywrd(i:i) == "-") then
                ii = -1
                k = 0
              else
                ii = 1
              end if
              do
              i = i + 1
              if (keywrd(i:i) < "0" .or. keywrd(i:i) > "9") exit
                k = k*10 + ichar(keywrd(i:i)) - ichar("0")
              end do
              new_res(m) = k*ii
              if (txtmax == 27 .and. keywrd(i:i) /= "(") then
                new_alt(m) = keywrd(i:i)
                if ((new_alt(m) < "A" .or. new_alt(m) > "Z") .and. new_alt(m) /= " ") &
                  write(iw,'(//10x,a,/10x,a,i'//num//',a)')" There is a fault in the SITE keyword", &
                  " Alternate residue for residue", m, " is not in the range 'A' to 'Z'"
                i = i + 1
              else
                new_alt(m) = " "
              end if
              i = i + 1
              charge(m,1) = keywrd(i:i)
              if (charge(m,1) /= "+" .and. charge(m,1) /= "-" .and. charge(m,1) /= "0") then
                write(iw,'(//10x,a,/10x,a,i4,a)')" There is a fault in the SITE keyword", &
                " Charge on site", m, " is not '+', '0', or '-'"
              end if
              i = i + 1
              charge(m,2) = keywrd(i:i)
              if (charge(m,2) == "+" .or. charge(m,2) == "-" .or. charge(m,2) == "0") then
                i = i + 1
              else
                charge(m,2) = "*"
              end if
              i = i + 1
              continue
              if (keywrd(i:i) == ")") i = i + 1
            end do
          else
            m = 0
          end if
          lsite = .true.
          call update_txtatm(.true., .true.)
          do j = 1, id
            nat(numat + j) = 107
          end do
          i = numat
          if (index(keywrd, " NOSITE") == 0 .or. index(keywrd, " CVB") == 0) then
            call store_and_restore_Tv("STORE")
            call site(neutral, new_chain, new_res, new_alt, charge, m, max_sites, allkey)
            call store_and_restore_Tv("RESTORE")
          end if
          if (moperr) return
          l_atom(i:natoms) = .true.
          call update_txtatm(.true., .true.)
          if (index(keywrd, " LET") /= 0) moperr = .false.
          if (moperr) return
        end if
        i = index(keywrd," SITE=")
        if (i == 0) exit
        do j = i + 1, len_trim(keywrd)
          if (keywrd(j:j + 1) == ") ") exit
        end do
        keywrd = keywrd(:i)//trim(keywrd(j + 1:))
      end do
    end if
!
!  Store charge, if present
!
    do i = 1, natoms
      atom_charge(i) = txtatm(i)(2:2)
!
!  Prevent atom number being mis-read as a charge.
!
      if (txtatm(i)(2:2) /= "+" .and. txtatm(i)(2:2) /= "-" .and. txtatm(i)(2:2) /= "0") &
      & atom_charge(i) = " "
    end do
!
!    ASSIGN LOGICALS USING KEYWRD
!
!  Force the TER's to be re-calculated
!
    lres = (Index (keywrd, " RESI") + Index (keywrd, " RESEQ") + index(keywrd, " NOSITE") /= 0)
    if (.not. lres) lres = (Index (keywrd, " PDBOUT") /= 0 .and. maxtxt /= txtmax)
    if (.not. lres) lres = (Index (keywrd, " ADD-H") /= 0 .and. Index (keywrd, " NORESEQ") == 0)
    lreseq = (Index (keywrd, " NORESEQ") == 0 .and. Index (keywrd, " RESEQ") /= 0)
    let = (Index (keywrd, " 0SCF")+Index (keywrd, " LET")+ &
   & Index (keywrd, " RESEQ")+Index (keywrd, " GEO-OK") /= 0)
    times = (Index (keywrd, " TIMES") /= 0)
    if (times) then
      call timer (" START OF GEOCHK")
    end if
    debug = (Index (keywrd, " GEOCHK") /= 0)
    if (Index (keywrd, " CHARGE=") /= 0) then
      irefq = Nint (reada (keywrd, Index (keywrd, " CHARGE=")))
    else
      irefq = 0
    end if
    call extvdw_for_MOZYME (radius, atom_radius_covalent)
    if (moperr) return
!
    if (Index (keywrd, " LARGE") /= 0) then
      large = 1000000
    else
      large = 20
    end if
    nnumat = numat
!
!   WORK OUT WHAT ATOMS ARE BONDED TO EACH OTHER.
!
    call lewis (.true.)
    if (moperr) return
    allocate (nnbonds(numat), iibonds(15,numat), stat=alloc_stat)
    if (alloc_stat /= 0) then
      call memory_error ("geochn")
      go to 1100
    end if
!
!  Store nbonds and ibonds in case they are modified within this subroutine
!
    nnbonds = nbonds
    iibonds = ibonds
    if (moperr) then
      if (Index (keywrd, " GEO-OK") == 0) then
        write (iw,*) " GEOMETRY CONTAINS FAULTS. TO CONTINUE CALCULATION SPECIFY ""GEO-OK"""
        go to 1100
      else
        moperr = .false.
      end if
    end if
!
!   ZERO OUT IONS
!
!
!  FIND THE NITROGEN ATOM OF THE N END OF THE PROTEIN.
!
    do i = 1, numat
      ioptl(i) = .false.
    end do
    call findn1 (n1, ioptl, io, delta_res)
    if (lreseq) then
!
!   RESEQUENCE THE ATOMS.  WHEN RESEQ IS CALLED, THE SEQUENCE OF
!   ATOMS IS CHANGED.  A CONSEQUENCE OF THIS IS THAT THE SCF CANNOT
!   BE RUN.
!
! First, delete all bonds between ATOMs and HETATMs
!
      do i = 1, numat
        if (txtatm(i)(:4) /= "ATOM") cycle
        do j = 1, nbonds(i)
          k = ibonds(j,i)
          if (txtatm(k)(:4) /= "ATOM") ibonds(j,i) = 0
        end do
        l = 0
        do j = 1, nbonds(i)
          k = ibonds(j,i)
          if (k > 0) then
            l = l + 1
            ibonds(l,i) = k
          end if
        end do
        nbonds(i) = l
      end do
      if (index(keywrd, "RESID") /= 0) txtatm1(:numat) = " "
      new = 0
      iz = -1000
      do
        if (n1 /= 0) call reseq (ioptl, iz, n1, new, io)
          if (n1 == -100) goto 90
        if (moperr) go to 1100
        call findn1 (n1, ioptl, io, delta_res)
        if (n1 == 0) exit
      end do
      if (new /= numat) then
        do i = 1, numat
          if (nat(i) /= 1 .and. .not. ioptl(i)) then
!
!   IDENTIFY ALL NON-PROTEIN MOLECULES IN THE SYSTEM
!
            call moiety (ioptl, iz, i, new)
          end if
        end do
        do i = 1, numat
          if (nat(i) == 1 .and. .not. ioptl(i)) then
!
!   IDENTIFY ALL HYDROGENS ATTACHED TO RESIDUE-LIKE SPECIES
!
            new = new + 1
            iz(new) = i
          end if
        end do
        if (new /= numat) then
          write (iw,*) " THERE IS A FAULT IN RESEQ"
          write (iw,'(a,i5)') "  Number of atoms found in data-set:  ", numat
          write (iw,'(a,i5)') "  Number of atoms after re-sequencing:", new
          if (new < numat) then
            write(iw,'(a)') "Atoms missing (Use original numbering system)"
            ioptl(:numat) = .true.
            do i = 1, new
              ioptl(iz(i)) = .false.
            end do
            do i = 1, numat
              if (ioptl(i)) write(iw,'(i5)')i
            end do
          else
          end if
          call mopend("THERE IS A FAULT IN RESEQ")
          go to 1100
        end if
!
!  Unconditionally, convert geometry into Cartesian coordinates
!
        geo(:,:numat) = coord(:,:numat)
        do i = 1, numat
          if (na(i) /= 0) exit
        end do
        if (i <= numat) then
          call mopend("SOME COORDINATES WERE IN INTERNAL. THESE HAVE BEEN CHANGED TO CARTESIAN")
          moperr = .false.
        end if
        na = 0
      end if
      l = 1
      do i = 1, numat
        nfirst(i) = l
        j = iz(i)
        mb(j) = i
        do k = 1, 3
          geo(k, i) = coord(k, j)
        end do
        labels(i) = nat(j)
        nlast(i) = nfirst(i) + natorb(labels(i)) - 1
        l = nlast(i) + 1
      end do
      nat(:numat) = labels(:numat)
      coord(:,:numat) = geo(:,:numat)
      done = .true.
!
!   DUMMY ATOMS ARE EXCLUDED, THEREFORE
!
      natoms = numat
!
!
!   REARRANGE ATOMS TO SUIT THE NEW NUMBERING SYSTEM
!
      do i = 1, numat
        j = iz(i)
        ib(i) = Min (nbonds(j), 4)
        l = Min (nbonds(i), 4)
        do k = 1, l
          ibonds(k+4, i) = mb(ibonds(k, i))
        end do
      end do
      do i = 1, numat
        nbonds(i) = ib(i)
        do k = 1, nbonds(i)
          ibonds(k, i) = ibonds(k+4, iz(i))
        end do
      end do
    end if
    noccupied = 0
    if (Index (keywrd, " RESEQ") + Index (keywrd, " SITE=") + index(keywrd, " ADD-H") &
      + index(keywrd, " 0SCF") == 0 .and. nelecs /= 0) then
!
!  EXAMINE THE GEOMETRY - IDENTIFY THE LEWIS ELEMENTS (SIGMA BONDS,
!  LONE PAIRS, CATIONS, PI BONDS, ANIONS, OTHER CHARGES)
!
      numbon = 0
      call chklew (mb, numbon, l, large, debug)
      if (moperr) return
      l = 0
      do i = 1, numat
        l = l + Abs (iz(i))
      end do
      if (l /= 0) then
!
!  THERE ARE IONS.  IDENTIFY THEM.
!
        call chkion (mb, numbon(2), atom_charge)
        if (lreseq) moperr = .false.
        if (moperr) return
      end if
      do i = 1, numat
        ions(i) = nint(tore(nat(i)))
      end do
      do i = 1, Lewis_tot
        if (Lewis_elem(1,i) > 0) then
          noccupied = noccupied + 1
          j = Lewis_elem(1,i)
          if (Lewis_elem(2,i) > 0) then
            k = Lewis_elem(2,i)
            ions(k) = ions(k) - 1! one electron from a bond
            ions(j) = ions(j) - 1! one electron from a bond
          else
            ions(j) = ions(j) - 2! two electrons from a lone pair
          end if
        end if
      end do
      nvirtual = 0
      do i = 1, Lewis_tot
        if (Lewis_elem(2,i) > 0) nvirtual = nvirtual + 1
      end do
    else
      nvar = 0
      do i = 1, numat
        do j = 1, numat_old
          if (abs(coord(1,i) - coorda(1,j)) > 0.1d0) cycle
          if (abs(coord(2,i) - coorda(2,j)) > 0.1d0) cycle
          if (abs(coord(3,i) - coorda(3,j)) > 0.1d0) cycle
          exit
        end do
        if (j <= numat_old) then
!
!  Atom "i" in coord has the same coordinates as atom "j" in coorda
!
          do k = 1, 3
            if (lopt(k,j) == 1) then
              nvar = nvar + 1
              loc(1,nvar) = i
              loc(2,nvar) = k
            end if
          end do
        else
          do k = 1, 3
            nvar = nvar + 1
            loc(1,nvar) = i
            loc(2,nvar) = k
          end do
        end if
      end do
      do j = numat + 1, numat + id
        do k = 1,3
          if (lopt(k,j) == 1) then
            nvar = nvar + 1
            loc(1,nvar) = j
            loc(2,nvar) = k
          end if
        end do
      end do
    end if
!
!   Use the following block to debug the construction of the Lewis structure
!
    if ( .false.) then
!
!  Sanity check - are all atomic orbitals accounted for?
!
      k = abs(norbs - noccupied - nvirtual)
      do i = 1, numat
        if (iz(i) /= 0) then
          k = k + 1
        end if
        if (ib(i) /= 0) then
          k = k + 1
        end if
      end do
      iz = 0
      do i = 1, Lewis_tot
        j = Lewis_elem(1,i)
        if (j > 0) iz(j) = iz(j) + 1
        j = Lewis_elem(2,i)
        if (j > 0) iz(j) = iz(j) + 1
      end do
      do i = 1, numat
        if (iz(i) - natorb(nat(i)) /= 0) then
          k = k + 1
        end if
      end do
      if (k /= 0) then
        write(iw,*)" An error has been detected."
      end if
    end if
!
!
    if (lres) then
      txtatm(:) = " "
      if (maxtxt == 0) then
        maxtxt = 26
        txtmax = 26
      end if
      angles = 0.d0
      allres = " "
      if (done) then
!
!   THE EARLIER CALL TO RESEQ MEANS THAT N1 MIGHT HAVE MOVED.
!   SO FIND N1 AGAIN.
!
        ioptl(:numat) = .false.
        call findn1 (n1, ioptl, io, delta_res)
      end if
      l_protein = (n1 /= 0)
      ib(:numat) = -100000
      nfrag = 0
      ires = 0
      uni_res = 0
      odd_h = .true.
!
!  Break all intra-chain bonds, so that the residues can easily be
!  identified.
!
      call lyse !
      allr = " "
      do max_frag = 1, 10000
        if (start_res(max_frag) == -200) exit
      end do
      max_frag = max_frag - 1
      lstart_res = .false.
      nfrag = 0
      do
        if (max_frag > 0) then
          do nfrag = 1, max_frag
            if (.not. lstart_res(start_res(nfrag) + 1)) exit
          end do
        else
          nfrag = nfrag + 1
        end if
        if (max_frag > 0) then
          if (nfrag > max_frag) exit
          ires = start_res(nfrag) - delta_res
        end if
!
! General bug-trap: if the number of fragments is unreasonably large,
! assume the system is unrecognizable and exit
!
        if (nfrag > 999) then
          call mopend("STRUCTURE UNRECOGNIZABLE")
          inquire(unit=iarc, opened=opend)
          if (opend) close(iarc, status = "DELETE")
          go to 1100
        endif
!
        call names (ioptl, ib, n1, ires, nfrag, io, uni_res, mres)
        if (moperr) return
!
        nn1 = n1
        call findn1 (n1, ioptl, io, delta_res)
!
! n1 is the start of the next fragment
! delta_res is the distance back along the chain to the start of the next fragment.
!
        if (.not. l_protein) nfrag = 0
        if (n1 == 0) exit
        if (n1 == nn1) ioptl(n1) = .true.
        if (.not. lbreaks) then
          mbreaks = mbreaks + 1
          breaks(mbreaks) = n1
!
! Find the last atom that has been defined.  Use this for defining the break
!
          do i = 1, numat
            if (.not. ioptl(i)) exit
          end do
          if (i - 1 > 0) break_coords(:,mbreaks) = coord(:,i - 1)
        end if
      end do
!
!  Re-evaluate all residues
!
      j = 1
      allres(j) = txtatm(1)(18:20)
      do i = 2, natoms
        if (txtatm(i) == " ")exit
        if (nat(i) /= 1 .and. txtatm(i)(23:27) /= txtatm(i - 1)(23:27)) then
        j = j + 1
        allres(j) = txtatm(i)(18:20)
        end if
      end do
      ires = j
      iopt(:natoms) = ib(:natoms)
!
!   LABEL THE ATOMS IN ANY NON-PROTEIN MOLECULES IN THE SYSTEM
!
      nfrag = nfrag + 1
      if (start_res(max(1,nfrag)) == -200) then
        if (.not. l_protein) ires = 0
      else
        ires = start_res(nfrag)
      end if
      call lewis(.true.)
      call ligand (ires, start_res, nfrag)
!
!  If ligands are present, set a break at the end of the protein, to separate protein from ligands
!
      if (.not. lbreaks) then
        mbreaks = mbreaks + 1
        breaks(mbreaks) = n1
!
! Find the last atom that has been defined.  Use this for defining the break
!
        do i = 1, numat
          if (.not. ioptl(i)) exit
        end do
        if (i - 1 > 0) break_coords(:,mbreaks) = coord(:,i - 1)
      end if
      nres = uni_res
      maxtxt = txtmax
      if (.not. pdb_label) pdb_label = (maxtxt > 25)
!
!  Add chain letters
!
      call reset_breaks()
      i = index(keywrd, " RESI")
      if (i > 0) then
        j = index(keywrd(i + 1:), " ") + i
        j = index(keywrd(i + 1: j), "0")
      end if
      if (i > 0 .and. j > 0) then
        do i = 1, numat
          txtatm(i)(13:16) = txtatm1(i)(13:16)
        end do
      end if
      if (moperr) return
      mbreaks = 1
      line = txtatm(1)(23:txtmax)
      do i = 1, numat
        txtatm(i) = txtatm(i)(:21)//chains(mbreaks)//txtatm(i)(23:)
        if (i == breaks(mbreaks)) then
          mbreaks = mbreaks + 1
        else
          if (txtatm(i)(23:txtmax) == "    ") cycle
          if (mbreaks > 1) then
!
!  This is a workaround to avoid having a break that already has been used.
!  (This can occur when a heterogroup that contains a peptide bond is positioned
!   after other heterogroups that do not contain a peptide bond.)
!
            if (i - 1 == breaks(mbreaks - 1)) then
              line = txtatm(i)(23:txtmax)
              cycle
            end if
          end if
          if (txtatm(i)(:6) == "HETATM") then
            if (txtatm(i)(23:26) /= line(1:4)) then
              if (txtatm(i - 1)(:4) /= "ATOM") then
                if (txtatm(i - 1)(18:20) /= "HOH" .or. txtatm(i)(18:20) /= "HOH") then
                  mbreaks = min(26, mbreaks + 1)
                end if
              end if
            end if
            txtatm(i) = txtatm(i)(:21)//chains(mbreaks)//txtatm(i)(23:)
          end if
        end if
        line = txtatm(i)(23:txtmax)
      end do
!
!   Check for unknowns
!
      do i = 1, numat
        do j = 1, 20
          if (txtatm(i)(18:20) == tyres(j)) exit
        end do
        if (j == 21) then
          if (txtatm(i)(15:16) /= "  ") cycle
          j = 1
          do k = i + 1, numat
            if (txtatm(k)(14:txtmax) == txtatm(i)(14:txtmax)) then
              j = j + 1
              if (j < 10) then
                write(txtatm(k)(15:15),'(i1)')j
              else
                 write(txtatm(k)(15:16),'(i2)')min(j, 99)
              end if
            end if
          end do
          if (j > 1) write(txtatm(i)(15:15),'(i1)')1
        end if
      end do
      do i = 1, natoms
        if (txtatm(i)(1:6) /= "HETATM" .and. txtatm(i)(1:6) /= "ATOM  ") then
!
!  Catch all atoms that have still not been identified
!
          write(line, '(a,i5, a, a)')"HETATM", i, " "//elemnt(labels(i)), "   HET"
          txtatm(i) = trim(line)
        end if
      end do
      if (n_new /= 0) then
!
!  Re-name residues to use the XENO name
!
        call update_txtatm(.true., .true.)
        mbreaks = 1
        old_name(:n_new) = "---"
        l_names = .false.
        do i = 1, natoms
          j = nint(reada(txtatm(i)(23:),1))
          do k = 1, n_new
            if (new_chain(k) == chains(mbreaks) .and. new_res(k) == j) then
              if (old_name(k) == "---") old_name(k) = txtatm(i)(18:20)
              txtatm(i) = txtatm(i)(:17)//new_name(k)//txtatm(i)(21:)
              if (txtatm(i)(:6) /= "HETATM") l_names(k) = .true.
              exit
            end if
          end do
          ter = (i == breaks(mbreaks))
          if (ter) mbreaks = mbreaks + 1
        end do
        first = .true.
        do i = 1, n_new
          if (l_names(i)) then
            if (first) then
              write(iw,'(/,a)') "      Residue names that have been changed"
              write(iw,'(/,a)') "      Residue No.  Calculated name   XENO name"
              first = .false.
            end if
            if (old_name(i) ==  new_name(i)) then
              write(iw,'(i3,i9,3x,a1,8x,a3,13x,a3, a)')i, new_res(i), new_chain(i), old_name(i), new_name(i), &
                "  Name not changed!"
            else
              write(iw,'(i3,i9,3x,a1,8x,a3,13x,a3)')i, new_res(i), new_chain(i), old_name(i), new_name(i)
            end if
          end if
        end do
        if (log) then
          write(ilog,'(/,a)') "      Residue names that have been changed"
          write(ilog,'(/,a)') "      Residue No.  Calculated name   XENO name"
          do i = 1, n_new
            if (old_name(i) ==  new_name(i)) then
              write(ilog,'(i3,i9,3x,a1,8x,a3,13x,a3, a)')i, new_res(i), new_chain(i), old_name(i), new_name(i), &
              "  Name not changed!"
            else
              write(ilog,'(i3,i9,3x,a1,8x,a3,13x,a3)')i, new_res(i), new_chain(i), old_name(i), new_name(i)
            end if
          end do
        end if
      end if
      l_use_old_labels = (index(keywrd," SITE=") /= 0 .and. index(keywrd, " ADD-H") == 0)
      l_use_old_labels = .true.
      call update_txtatm(l_use_old_labels, .true.)
!
! Insert dummy atoms, if present
!
      allocate(temp_txtatm(natoms))
      j = 0
      do i = 1, natoms
        if (labels(i) == 99) then
          temp_txtatm(i) = "HETATM    4  XX  HET A   1"
        else
          j = j + 1
          temp_txtatm(i) =  txtatm(j)
        end if
      end do
      txtatm(:natoms) = temp_txtatm(:natoms)
      deallocate(temp_txtatm)
      call write_sequence
    end if
90  if (index(keywrd, " PDBOUT") /= 0) then
      allocate(temp_txtatm(natoms))
!
! Assign atom numbers
!
      temp_txtatm = txtatm
      do i = 1, natoms
        write (txtatm(i), "(a,i5,a)")temp_txtatm(i)(1:6),i,temp_txtatm(i)(12:maxtxt)
      end do
      deallocate(temp_txtatm)

!
!  Identify atoms where chain breaks occur
!
      if (Index (keywrd, " RESEQ") + index(keywrd, " ADD-H") /= 0) call reset_breaks()
      if (index(keywrd, " RESEQ") + index(keywrd, " ADD-H") == 0) then
        if (allocated(txtatm1) .and. index(keywrd, " RESID") /= 0) then
          if (txtatm1(1) /= " ") call compare_sequence(n_new)
        end if
      end if
    end if
!
!  Edit keywords to remove text that would not be used in the next calculation.
!
    call delete_ref_key("SITE", len_trim("SITE"), ') ', 2)
    i = index(keywrd, "SITE=()")
    if (i /= 0) keywrd(i:i + 6) = " "
    if (index(keywrd, " RESEQ") /= 0) call delete_ref_key("RESEQ", len_trim("RESEQ"), ' ', 1)
    numat = nnumat
    natoms = max(natoms, numat)
    if (index(keywrd, " ADD-H") /= 0) return
    if (index(keywrd, "CHARGES") == 0 .and. index(keywrd, "CONTROL_no_MOZYME") /= 0 .or. index(keywrd, " RESEQ") /= 0) then
      if ( index(keywrd," PDBOUT") /= 0 .and. index(keywrd, " RESEQ") /= 0) then
        line = archive_fn(:len_trim(archive_fn) - 3)//"pdb"
        i = iarc
        inquire(unit=i, opened=opend)
        if (opend) close(i, status = 'keep', iostat=j)
        open(unit=i, file=line, status='UNKNOWN', position='asis')
        rewind i
        call pdbout(i)
        close (i)
      end if
      if (index(keywrd, " RESEQ") /= 0) then
        line = archive_fn(:len_trim(archive_fn) - 3)//"arc"
        inquire(unit=iarc, opened=opend)
        if (opend) close(iarc, status = 'keep', iostat=i)
        open(unit=iarc, file=line, status='UNKNOWN', position='asis')
        rewind iarc
        call geout (iarc)
      end if
      if (index(keywrd, " RESEQ") == 0) return
    end if
    ibad = 0
    if (.not. mozyme) goto 99
!
!  MODIFY IONS SO THAT IT REFERS TO ALL ATOMS (REAL AND DUMMY)
!
    j = 0
    iz = ions
    ions = 0
    do i = 1, natoms
      if (labels(i) == 99) then
        ions(i) = 0
      else
         j = j + 1
        ions(i) = iz(j)
      end if
    end do
    if (lres .and. .not. lreseq) then
!
!   CHECK ALL IONS TO SEE IF ANY RESIDUE IS A DI-ION
!
      outer_loop: do i = 1, numat
        if(ions(i) /= 1 .and. ions(i) /= -1) cycle! WARNING
      end do outer_loop
      if (ibad /= 0) then
        write (iw,*)
      end if
      jbad = ibad
      ibad = 0
      ibad = ibad + jbad
    end if
!
!
    charges = (lsite .or. index(keywrd, "CHARGES") /= 0)
    ichrge = -noccupied*2
    do i = 1, numat
      ichrge = ichrge + nint(tore(nat(i)))
    end do
    line = " "
    if (noccupied /= 0 .and. (index(keywrd," LEWIS") > 0 .or. noccupied*2 /= nelecs)) then
      maxtxt = 0
      do i = 1, numat
        maxtxt = max(maxtxt, len_trim(txtatm(i)))
      end do
      if (maxtxt == 0) then
        j = 1
      else
        j = maxtxt/2 + 2
      end if
      if (lreseq) call update_txtatm(.true., .false.)
      if (prt_topo) then
          line = " "
        write (iw, "(/,A,/)") "   TOPOGRAPHY OF SYSTEM"
        write (iw,*) "  ATOM No. "//line(:j)//"  LABEL  "//line(:j)//"Atoms connected to this atom"
        if (j == 0) then
          do i = 1, numat
            write (iw, "(I7,9X,A,9I7)") i, elemnt (nat(i)) // "  ", (ibonds(j, i), j=1, nbonds(i))
          end do
        else
          if (maxtxt > 2) then
            do i = 1, numat
              write (iw, "(I7,9X,A,9I7)") i, elemnt (nat(i)) // " (" // txtatm(i) (:maxtxt) // ") ", &
                (ibonds(j, i), j=1, nbonds(i))
            end do
          else
            do i = 1, numat
              write (iw, "(I7,9X,A,9I7)") i, elemnt (nat(i)), (ibonds(j, i), j=1, nbonds(i))
            end do
          end if
        end if
      end if
    end if
    if (noccupied /= 0 .and. index(keywrd," LEWIS") > 0) then
      write (iw, "(/37x,A,/)") "   Lewis Structure"
      if (index(keywrd, " LARGE") /= 0)  &
        write (iw,"(23x,a,/)") "  ATOMS IN OCCUPIED LOCALIZED MOLECULAR ORBITALS"
      l = 4
      allocate(Lewis_formatted(Lewis_tot/l + 5, l))
      Lewis_formatted = " "
      k = 0
      j = 0
      do i = 1, Lewis_tot
        if (Lewis_elem(1,i) > 0) j = j + 1
      end do
      m = j/l + 1
      write(iw,"(4('     LMO  Atom  Atom    '))")
      ii = 0
      jj = 1
      do i = 1, Lewis_tot
        if (Lewis_elem(1,i) > 0) then
          k = k + 1
          ii = ii + 1
          if (ii > m) then
            ii = 1
            jj = jj + 1
          end if
          if (Lewis_elem(2,i) > 0) then
            write (Lewis_formatted(ii,jj), "(I8,I6,I6)") k, (Lewis_elem(j,i),j=1,2)
          else
            write (Lewis_formatted(ii,jj), "(I8,I6)") k, Lewis_elem(1,i)
          end if
        end if
      end do
      do i = 1, Lewis_tot
        if (Lewis_formatted(i,1) == " ") exit
        write(iw,"(10a)")(Lewis_formatted(i,j)//"    ", j = 1, l)," "
      end do
      if (index(keywrd, " LARGE") /= 0) then
        write (iw,"(/23x,a,/)") "  ATOMS IN UNOCCUPIED LOCALIZED MOLECULAR ORBITALS"
        Lewis_formatted = " "
        j = 0
        do i = 1, Lewis_tot
          if (Lewis_elem(2,i) > 0) j = j + 1
        end do
        m = j/l + 1
        k = 0
        ii = 0
        jj = 1
        do i = 1, Lewis_tot
          if (Lewis_elem(2,i) > 0) then
            k = k + 1
            ii = ii + 1
            if (ii > m) then
              ii = 1
              jj = jj + 1
            end if
            if (Lewis_elem(1,i) > 0) then
              write (Lewis_formatted(ii,jj), "(I8,I6,I6)") k, (Lewis_elem(j,i),j=1,2)
            else
              write (Lewis_formatted(ii,jj), "(I8,I6)") k, Lewis_elem(2,i)
            end if
          end if
        end do
        do i = 1, Lewis_tot
          if (Lewis_formatted(i,1) == " ") exit
          write(iw,"(10a)")(Lewis_formatted(i,j)//"    ", j = 1, l)," "
        end do
      end if
      deallocate(Lewis_formatted)
      write (iw,*)
      if (noccupied > 0) then
        write (iw,"(a,/)") "          Type          Number of Lewis structural elements identified"
        if (log) write (ilog,"(/,a,/)") "          Type          Number of Lewis structural elements identified"
      end if
      if (numbon(1) /= 0) then
        write (iw, "(A,I6)") "         SIGMA BONDS   ", numbon (1)
        if (log) write (ilog, "(A,I6)") "         SIGMA BONDS   ", numbon (1)
      end if
      if (numbon(2) /= 0) then
        write (iw, "(A,I6)") "         LONE PAIRS    ", numbon (2)
        if (log) write (ilog, "(A,I6)") "         LONE PAIRS    ", numbon (2)
      end if
      if (numbon(3) /= 0) then
        write (iw, "(A,I6)") "         PI BONDS      ", numbon (3)
        if (log) write (ilog, "(A,I6)") "         PI BONDS      ", numbon (3)
      end if
      if (index(keywrd," LEWIS") > 0 .or. (noccupied*2 /= nelecs .and. noccupied /= 0)) then
        write(iw,"(/,a,i6)")" Number of filled levels from atoms and charge:", nelecs/2
        write(iw,"(a,i6)")" Number of filled levels from Lewis structure: ", noccupied
        if (log) write (ilog,"(/,a,i6)")" Number of filled levels from atoms and charge:", nelecs/2
        if (log) write (ilog,"(a,i6)")" Number of filled levels from Lewis structure: ", noccupied
      end if
      l = 0
      m = 0
      num = char(Int(log10(numat + 1.0)) + ichar("1") + 1)
      do i = 1, numat
        if (.not. main_group(nat(i))) then
!
!  Element is a transition metal.  Work out its formal oxidation state
!
          k = ions(i)
          do j = 1, Lewis_tot
            if (Lewis_elem(1,j) /= 0 .and. Lewis_elem(2,j) /= 0) then
              if (Lewis_elem(1,j) == i) k = k + 1
              if (Lewis_elem(2,j) == i) k = k + 1
            end if
          end do
          if (m == 0) write(iw,*)
          m = 1
          write(iw,"(10x,a,i"//num//",a,sp,i3)")" Formal oxidation state of atom",i,", a "//trim(elemnt(nat(i)))//", is", k
          if (k < 0) l = 1
          if (k > 3) l = 1
        end if
      end do
      if (l == 1) call web_message(iw,"Lewis_structures.html")
    end if
!
! Check for sulfate and phosphate
!
      do i = 1, numat
        if (nat(i) == 16 .and. txtatm(i)(18:20) == "SO4") then
          k = 2
          ions(i) = 0
          do j = 1, nbonds(i)
            l = ibonds(j,i)
            if (ions(l) == -1) then
              ions(l) = 0
              k = k - 1
              if (k == 0) exit
            end if
          end do
        end if
        if (nat(i) == 15 .and. txtatm(i)(18:20) == "PO4") then
          k = 1
          ions(i) = 0
          do j = 1, nbonds(i)
            l = ibonds(j,i)
            if (ions(l) == -1) then
              ions(l) = 0
              k = k - 1
              if (k == 0) exit
            end if
          end do
        end if
      end do
    num_ions = 0
    do i = 1, numat
      j = (Min(6, Max(-6, ions(i))))
      num_ions(j) = num_ions(j) + 1
    end do
    i = 0
    do j = 1,6
      i = i + num_ions(j) + num_ions(-j)
    end do
    if (i == 0) then
      if (nelecs /= 0) write(iw,'(/10x, a)')"NO CHARGES FOUND."
    else
      if (index(keywrd," LEWIS") > 0) then
        write (iw,*)
        write (iw,"(a,/)") "          Type           Number of charged sites identified"
        if (log) write(ilog,"(/,a,/)") "          Type           Number of charged sites identified"
        do i = 1,6
        if (num_ions(i)  > 0) then
          write (iw, "(9x,a,2x,i6)") ion_names(i) , num_ions(i)
          if (log) write(ilog, "(9x,a,2x,i6)") ion_names(i) , num_ions(i)
        end if
        if (num_ions(-i) > 0) then
          write (iw, "(9x,a,2x,i6)") ion_names(-i), num_ions(-i)
          if (log) write(ilog, "(9x,a,2x,i6)") ion_names(-i), num_ions(-i)
        end if
        end do
        i = 0
        do j = 1,6
          i = i + num_ions(j) * j
        end do
        write(iw,"(SP/,a,i5)")" SUM OF POSITIVE CHARGES", i
        if (log) write(ilog,"(SP/,a,i5)")" SUM OF POSITIVE CHARGES", i
        i = 0
        do j = 1,6
          i = i + num_ions(-j) * j
        end do
        write(iw,"(a,i5)")" SUM OF NEGATIVE CHARGES", -i
        if (log) write(ilog,"(a,i5)")" SUM OF NEGATIVE CHARGES", -i
      end if
      padding = " "
      do i = 1, numat
        if (ions(i) /= 0) then
          if (nat(i) == 15 .or. nat(i) == 16) then
            kk = 0
            do jj = 1, nbonds(i)
              ii = ibonds(jj,i)
              if (nat(ii) == 8) then
                if (ions(ii) == -1) then
!
!  Found a PO4 or SO4.  Neutralize the P-O or S-O Zwitterion.
!
                  ions(i) = ions(i) - 1
                  ions(ii) = ions(ii) + 1
                  kk = 1
                  if (ions(i) == 0) exit
                end if
              end if
            end do
            if (kk == 1) cycle
          end if
        end if
      end do
      do i = 1, numat
        if (ions(i) /= 0) exit
      end do
      maxtxt_store = maxtxt
      if (maxtxt < 0) maxtxt = 14
      l_salt = .false.
      if (first_prt .and. .not. l_rama) then
        if (i <= numat) then
          if (maxtxt > 1) then
             l = max(1,(17 - maxtxt/2))
             residues = (index(keywrd, " RESID") /= 0)
          end if
        else
          write(iw,'(/18x,a)') "NO CHARGED ATOMS FOUND."
        end if
        ioptl = .true.
        m = 0
        header = .true.
        do n1 = 1, 8
          j = atomic_charges(n1)
          first = .true.
          k = 0
          kkk = 0
          do i = 1, numat
            if (ions(i) == j) then
              if (first) then
                write(iw,*)
                first = .false.
                end if
              line = " "
              jj = 0
              if (j == 1) then
                line = " "
                do ii = 1, numat
                  if (ions(ii) < 0 .and. ioptl(ii)) then
                    call identify_nearby_counterions(i, ii, jj, near_ions, r_ions, line)
                    if (line == "Salt bridge!") then
                      ioptl(i) = .false.
                      ioptl(ii) = .false.
                      exit
                    end if
                  end if
                end do
              else if (j == -1) then
                if (.not. ioptl(i)) cycle
                line = " "
                do ii = 1, numat
                  if (ions(ii) > 0 .and. ioptl(ii)) then
                    call identify_nearby_counterions(i, ii, jj, near_ions, r_ions, line)
                    if (line == "Salt bridge!") exit
                  end if
                end do
              end if
              if (jj > 1) then
  !
  !  Sort near ions into increasing distance
  !
                jj = min(jj,100)
                do ii = 1, jj
                  do kk = ii + 1, jj
                    if (r_ions(kk) < r_ions(ii)) then
                      sum = r_ions(kk)
                      r_ions(kk) = r_ions(ii)
                      r_ions(ii) = sum
                      near_ions_store = near_ions(:,kk)
                      near_ions(:,kk) = near_ions(:,ii)
                      near_ions(:,ii) = near_ions_store
                    end if
                  end do
                end do
                do ii = 2, jj
                  if (r_ions(ii) > 5.d0) then
                    jj = ii - 1
                    exit
                  end if
                end do
              end if
              if (maxtxt > 1) then
                if (line == "Salt bridge!") then
                  if (j == 1) then
!
! There is a counterion, therefore this is a salt-bridge
!
                    if (residues) then
                      txtatm_1 = txtatm(near_ions(1,1))
                      txtatm_2 = txtatm(near_ions(2,1))
                    else
                      txtatm_1 = txtatm1(near_ions(1,1))
                      txtatm_2 = txtatm1(near_ions(2,1))
                    end if
                    num = "5"
                    if (elemnt(nat(near_ions(2,1)))(1:1) /= " ") num = "5"
                      if (txtatm_2(maxtxt:maxtxt) == ")") then
                        ii = maxtxt + 1
                        txtatm_2 = "("//trim(txtatm_2)
                        kk = maxtxt - 1
                      else
                        ii = maxtxt
                        kk = maxtxt
                      end if
                      if ( .not. l_salt) then
                        if (maxtxt > 1) then
                           write(line,"(a)")"   Ion     <--------PDB Label------->   Charge     "// &
                             &"Distance        PDB label for Salt Bridge   Charge"
                           write(iw,'(/,a,/)') trim(line)
                           if (log) write(ilog,"(/,a)") trim(line)
                        else
                           write(iw,"(/,a)")"     Ion Atom No.  Type    Charge"
                           if (log) write(ilog,"(/,a,/)")"    Ion Atom No.  Type    Charge"
                        end if
                      end if
                      k = k + 1
                      write(tmp,"(i5, 2x, 3x, a, SP,i5,S, f13.2, 9x, a, a, a)") &
                      & k, padding(:l-5)//"("//txtatm_1(1:kk)//")"//padding(:l-15), ions(i), &
                      & r_ions(1), "("//txtatm_2(:ii)//")", "   -1"
                      write(iw,'(a)') trim(tmp)
                      l_salt = .true.
                      if (log) write(ilog,"(a)") trim(line)
                  end if
                else
!
! No nearby counterions, therefore this is not a salt-bridge
!
                   if (residues) then
                    txtatm_1 = txtatm(i)
                  else
                    txtatm_1 = txtatm1(i)
                  end if
                  kk = len_trim(txtatm_1)
                  if (txtatm_1(kk:kk) == ")") then
                    kk = maxtxt - 1
                    ii = l - 6
                    j2 = l - 1
                  else
                    kk = maxtxt
                    ii = l - 5
                    j2 = l - 5
                  end if
                  kkk = kkk + 1
                  write(line,"(i5, 2x, 3x, a,SP,i5,S,a)") &
                    kkk, padding(:ii)//"("//txtatm_1(1:kk)//")"//padding(:j2), ions(i)
                  if (m == 0) then
!
! Find the first free unit, and use that number for the scratch file
!
                    do m = 10, 100
                      inquire(unit=m, opened = opend)
                      if (.not. opend) then
                      open(unit=m, status='SCRATCH')
                      exit
                      end if
                    end do
                  end if
                  if (j /= 1) then
                    if (header) then
                      if (maxtxt < 2) then
                        write(iw,'(10x, a, /)') "All other ions"
                        if (maxtxt < 2)write(iw,"(a)")"   Ion Atom No.  Type    Charge"
                      else
                        write(iw,'(/17x, a)') "All other ions"
                      end if
                      header = .false.
                    end if
                    write(iw,'(a)')trim(line)
                    else
!
! Store text of ions with a charge of +1
!
                  write(m,'(a)')trim(line)
                  end if
                  if (log) write(ilog,'(a)')trim(line)
                end if
              else
                k = k + 1
                write(line,"(i5,3x,i5,5x,a2,SP,i9,S)")k, i, elemnt(nat(i)),ions(i)
                if (header) then
                  if (maxtxt < 2) then
                    write(iw,'(10x, a, /)') "All other ions"
                    if (maxtxt < 2)write(iw,"(a)")"   Ion Atom No.  Type    Charge"
                  else
                    write(iw,'(/17x, a)') "All other ions"
                  end if
                  header = .false.
                end if
                write(iw,'(a)') trim(line)
                if (log) write(ilog,"(a)")trim(line)
              end if
            end if
          end do
          if (j == 2 .and. m /= 0) then
!
!  Write out ions that have a charge of -1
!
            rewind (m)
            if (header) then
              if (maxtxt < 2) then
                    write(iw,'(10x, a, /)') "All other ions"
                    if (maxtxt < 2)write(iw,"(a)")"   Ion Atom No.  Type    Charge"
                  else
                    write(iw,'(/17x, a)') "All other ions"
                  end if
              header = .false.
            end if
            do k = 1, 10000
              read(m,'(a)', iostat = ii)line
              if (ii /= 0) exit
              if (k == 1) write(iw,*)
              write(iw, '(a)')trim(line)
            end do
            close (m)
          end if
        end do
      end if
      maxtxt = maxtxt_store
    end if
    if (first_prt .and. noccupied /= 0 .and. .not. l_rama) then
      num = char(ichar("3") + max(int(log10(abs(ichrge) + 0.05)),0))
      if (index(keywrd," CHARGE=") /= 0) then
        if (ichrge == irefq) then
          write (iw, "(SP/10x,A,I"//num//", a)") "COMPUTED CHARGE ON SYSTEM:", ichrge, &
         ", THIS IS THE SAME AS THE CHARGE DEFINED IN THE DATA-SET."
        else
          i = index(keywrd," CHARGE=") + 1
          j = i -2 + index(keywrd(i:), " ")
          write (iw, "(SP/2x,A,I"//num//", a)") "COMPUTED CHARGE ON SYSTEM:", ichrge, &
         ", THIS IS NOT THE SAME AS THE CHARGE DEFINED IN THE DATA-SET: """//keywrd(i:j)//"""."
        end if
      else
        if (.not. charges) write (iw, "(SP/10x,A,I"//num//")") "COMPUTED CHARGE ON SYSTEM:", ichrge
      end if
      if (log) write (ilog, "(SP/10x,A,I"//num//")") "COMPUTED CHARGE ON SYSTEM:", ichrge
      end if
      first_prt = .false.
    if (index(keywrd, " LEWIS") /= 0 .and. index(keywrd," 0SCF") == 0) &
      call mopend ("RUN STOPPED BECAUSE KEYWORD LEWIS WAS USED.")
!
99  continue
    atmass(1:numat) = ams(nat(1:numat))
    if (done .and. .not. lreseq) then
      call xyzint (coord, numat, na, nb, nc, 1.d0, geo)
    end if
    if (lreseq) then
      geo(:,:numat) = coord(:,:numat)
      na = 0
    end if
    if (lreseq .or. lsite) then
      archive_fn = archive_fn(:len_trim(archive_fn) - 3)//"arc"
      inquire(unit=iarc, opened=opend)
      if (opend) close(iarc, status = 'keep', iostat=i)
      open(unit=iarc, file=archive_fn, status='UNKNOWN', position='asis')
      rewind iarc
      if (index(keywrd, " PDBOUT") /= 0) call delete_ref_key("PDBOUT", len_trim("PDBOUT"), ' ', 1)
      call geout (iarc)
      if (index(keywrd, " PDBOUT") + index(keywrd, " HTML") /= 0 .and. &
        index(keywrd, " RESEQ") == 0) then
        line = archive_fn(:len_trim(archive_fn) - 3)//"pdb"
        i = iarc
        inquire(unit=i, opened=opend)
        if (opend) close(i)
        open(unit=i, file=line, status='UNKNOWN', position='asis')
        rewind i
        coord(:,:numat) = geo(:,:numat)
        call update_txtatm(.true., .true.)
        if (index(keywrd, " NORES") == 0) call rectify_sequence()
        call reset_breaks()
        call pdbout(i)
        if (allocated(coorda)) deallocate (coorda)
        allocate(coorda(3,numat))
        txtatm1(:numat) = txtatm(:numat)
        coorda(:,:numat) = coord(:,:numat)
        close (i)
      end if
    end if
    if (.not. mozyme) goto 98
    if (irefq /= ichrge .and. .not. lreseq .or. charges .or. index(keywrd, " Move") /= 0) then
!
!  THE CALCULATED CHARGE DOES NOT MATCH THAT DEFINED BY CHARGE=N.
!  THEREFORE, THE USER HAS MADE A MISTAKE.  WRITE OUT CHARGES
!  FOUND HERE.
!
!
      if (icharges /= 0) write (iw,*)
      line = " "
      if (index(keywrd, " 0SCF") == 0) line = "JOB STOPPED BECAUSE"
      i = len_trim(line)
      if (i > 0) i = i + 1
      j = max(abs(ichrge), abs(irefq))
      k = min(ichrge, irefq)
      num = char(ichar("2") + max(int(log10(j + 0.05)),0))
      if (k < 0) num = char(ichar(num) + 1)
      if (charges) then
        if (index(keywrd," CHARGES") +index(keywrd," CHARGE=") == 0) then
          call mopend (line(:i)//"CHARGES MODIFIED BY SITE COMMAND")
        else if (noccupied > 0) then
          call write_sequence
          if (irefq /= ichrge) then
            if (index(keywrd," CHARGE=") /= 0) then
              write (iw, "(10x,A,SP,I"//num//",A)") "CHARGE SPECIFIED IN DATA SET: ", irefq," IS INCORRECT."
            else
              write (iw, "(/10x,A,SP,I"//num//",a)") "COMPUTED CHARGE ON SYSTEM: ", ichrge, &
                "  (THIS DOES NOT AGREE WITH THE DEFAULT CHARGE OF ZERO)"
            end if
          else
            if (.not. charges) write (iw, "(SP/3x,A,I"//num//", a)") "COMPUTED CHARGE ON SYSTEM = ", ichrge, &
            ". THIS AGREES WITH THE CHARGE IN THE DATA-SET."
          end if
          archive_fn = archive_fn(:len_trim(archive_fn) - 3)//"arc"
          inquire(unit=iarc, opened=opend)
          if (opend) close(iarc, status = 'keep', iostat=i)
          open(unit=iarc, file=archive_fn, status='UNKNOWN', position='asis')
          rewind iarc
          if (index(keywrd, " PDBOUT") /= 0) call delete_ref_key("PDBOUT", len_trim("PDBOUT"), ' ', 1)
          call geout (iarc)
          call mopend ("JOB STOPPED HERE BECAUSE KEYWORD ""CHARGES"" WAS USED")
        end if
        call delete_ref_key("SITE", len_trim("SITE"), ') ', 2)
      end if
      if (lreseq .or. index(keywrd, " Move") /= 0) then
!
!  Check to see if any atoms are in internal coordinates
!
        j = 0
        do i = 1, numat
          if (na(i) /= 0) j = j + 1
        end do
        if (j /= 0) then
          if (index(keywrd, " Move") /= 0) then
            call mopend("WHEN HYDROGEN ATOMS ARE ADDED OR DELETED, ALL ATOMS MUST BE IN CARTESIAN COORDINATES")
            return
          else if (index(keywrd, "GEO-OK") == 0) then
            call mopend("WHEN SYSTEM IS RESEQENCED, EITHER ADD ""GEO-OK"" OR ALL ATOMS MUST BE IN CARTESIAN COORDINATES")
          end if
        end if
        call store_and_restore_Tv("STORE")
        call move_hydrogen_atoms
        call store_and_restore_Tv("RESTORE")
        call lewis(.false.)
        if (index(keywrd, " ADD-H") > 0) then
          call mopend("ADD-H: SYSTEM HAS BEEN HYDROGENATED")
        else if (index(keywrd, " Move") > 0) then
          call mopend("HYDROGEN ATOMS ADDED OR DELETED")
        else
          call mopend("GEOMETRY RESEQUENCED")
        end if
        moperr = .false.
        if (prt_coords) call geout (iw)
      end if
      if (charges .or. lreseq) return
      if (index(keywrd, " LEWIS") /= 0) then
        if (index(keywrd, " 0SCF") == 0) then
          if (.not. moperr) call mopend (line(:i)//"KEYWORD LEWIS USED")
          return
        end if
      end if
!
!
      if (Index (keywrd, " 0SCF") + Index (keywrd, " RESEQ") + Index (keywrd, " LEWIS") == 0) then
        write(iw,*)" "
        if (index(keywrd," CHARGE=") /= 0) then
          if (index(keywrd," GEO-OK") /= 0) then
            write (iw, "(10x,A)") "KEYWORD 'GEO-OK' WAS PRESENT, SO THE CHARGE HAS BEEN RESET."
            write (iw, "(10x,A)") "IF THE NEW CHARGE IS INCORRECT, EITHER MODIFY THE STRUCTURE OR "//&
            "USE KEYWORD 'SETPI' TO CORRECT THE LEWIS STRUCTURE."
          else
            write (iw, "(10x,A,SP,I"//num//",A)") "In the data-set supplied, the charge specified (", irefq,") is incorrect."
          end if
        else
          num = char(ichar("3") + max(int(log10(abs(ichrge) + 0.05)),0))
          write (iw, "(10x,A,SP,I"//num//",a)") "BECAUSE KEYWORD ""CHARGE"" WAS NOT USED, THE COMPUTED CHARGE OF", &
          ichrge, " WILL BE USED IN THIS RUN."
          sum = -dfloat(ichrge)/norbs
          pdiag(:norbs) = pdiag(:norbs) + sum
        end if
        nelecs = nelecs + irefq - ichrge
        nclose = nelecs/2
        nopen = nclose
        nalpha = 0
        nbeta = 0
        uhf = .false.
        if (irefq /= ichrge) then
          if (mod(irefq - ichrge, 2) == 0) then
            write(iw,"(/10x,a)")"If the Lewis structure used by MOZYME is incorrect, "// &
            &"use keywords such as CVB or SETPI to correct it"
            call web_message(iw,"setpi.html")
          else
            if (index(keywrd," CHARGE=") /= 0) &
              write(iw,"(/10x,a)")"The charge keyword, Lewis structure, or the chemical formula is faulty"
          end if
          if (Index(keywrd," GEO-OK") == 0 .and. index(keywrd," CHARGE=") /= 0 ) then
            call mopend("CHARGE SPECIFIED IS INCORRECT. CORRECT THE ERROR BEFORE CONTINUING")
            write(iw,"(/10x,a)")"If that is done, then the correct charge will be used."
            return
          else if (id > 0) then
            write(iw,"(/10x,a)")"INFINITE SYSTEMS MUST HAVE A ZERO CHARGE ON THE UNIT CELL"
            call mopend("Unit cell has a charge. Correct fault and re-submit ")
            return
          else
            call fix_charges(ichrge)
          end if
        end if
      end if
    end if
98  if (done) then
      if (prt_coords) write (iw, "(//10X,A,//)") " GEOMETRY AFTER RE-SEQUENCING"
      call update_txtatm(.true., .true.)
      if (prt_coords) call geout (iw)
      if (index(keywrd, "0SCF") + index(keywrd, " RESEQ") == 0 .or. &
         index(keywrd, " PDBOUT") == 0) then
        inquire(unit=iarc, opened=opend)
        if ( .not. opend) open(unit=iarc, file=archive_fn, status='UNKNOWN', position='asis')
        rewind(iarc)
        call geout (iarc)
      end if
      if ( index(keywrd," PDBOUT") /= 0) then
        if (prt_coords) call pdbout(1)
      end if
      line = "GEOMETRY RESEQUENCED"
      call mopend(trim(line))
      go to 1100
    end if
    if (ibad /= 0 .and. .not. let) then
      call mopend("ERROR")
      go to 1100
    end if
    if (times) then
      call timer (" END OF GEOCHK")
    end if
    if (lreseq .or. lsite) then
      if (lsite) then
        call mopend ("RUN STOPPED BECAUSE KEYWORD ""SITE"" USED")
        call delete_ref_key("SITE", len_trim("SITE"), ') ', len_trim(') '))
      else if (lreseq) then
        if (index(keywrd, " ADD-H") > 0) then
          call mopend("ADD-H: SYSTEM HAS BEEN HYDROGENATED")
        else if (index(keywrd, " Move") > 0) then
          call mopend("HYDROGEN ATOMS ADDED OR DELETED")
        else
          call mopend("GEOMETRY RESEQUENCED")
        end if
      end if
      moperr = .false.
      if (prt_coords) call geout (iw)
      return
    end if
!
!  MODIFY IONS SO THAT IT REFERS TO REAL ATOMS ONLY
!
    j = 0
    do i = 1, natoms
      if (labels(i) /= 99) then
        j = j + 1
        iz(i) = j
      end if
    end do
!
!  Restore charges, if present
!
    if (maxtxt /= 27) then
      do i = 1, natoms
        if(atom_charge(i) /= " ") txtatm(i)(2:2) = atom_charge(i)
      end do
    end if
!
!  Restore nbonds and ibonds in case they are modified within this subroutine
!
    nbonds(:numat) = nnbonds(:numat)
    ibonds(:,:numat) = iibonds(:,:numat)
1100 continue
    if (Allocated (nnbonds))      deallocate (nnbonds, iibonds)
    if (Allocated (iz))           deallocate (iz)
    if (Allocated (ib))           deallocate (ib)
    if (Allocated (mb))           deallocate (mb)
    if (Allocated (atom_charge))  deallocate (atom_charge)
    if (Allocated (ioptl))        deallocate (ioptl)
    return
  end subroutine geochk
  subroutine identify_nearby_counterions(i_in, j_in, n_jj, near_ions, r_ions, line)
!
! Identify charged atoms
! If the charge is +1 or -1, then test for salt bridge
!
  use MOZYME_C, only : ions
  use common_arrays_C, only : txtatm, nbonds, ibonds, nat
  implicit none
  integer, intent(in) :: i_in, j_in
  integer, intent (inout) :: n_jj, near_ions(2, 100)
  double precision, intent (inout) :: r_ions(100)
  character, intent (out) :: line*100
!
  double precision :: sum, sum_min
  integer :: i, j, k, l, m, atom_i, atom_j, i_set(3), ni, j_set(3), nj
  character :: atm*3
  logical :: l_salt_i, l_salt_j
  double precision, external :: distance
  if (ions(i_in) == 1) then
    atom_i = i_in
    atom_j = j_in
  else
    atom_j = i_in
    atom_i = j_in
  end if
  ni = 1
  i_set(1) = atom_i
  nj = 1
  j_set(1) = atom_j
  if (ions(atom_i)*ions(atom_j) == -1) then
!
!  This might be a salt-bridge.  Search for the shortest contact distance
!
! Look for cations
!
    if (txtatm(atom_i)(18:20) == "HIS") then
!
! Search for ND1 and NE2 in the imidazolium ring
!
      if (txtatm(atom_i)(14:16) == "CE1" .or. txtatm(atom_i)(14:16) == "ND1" .or. txtatm(atom_i)(14:16) == "NE2") then
        if (txtatm(atom_i)(14:16) == "CE1") then
!
!  Use the nitrogen atoms on each side of the current atom
!
          ni = 0
          do i = 1, nbonds(atom_i)
            j = ibonds(i,atom_i)
            if (nat(j) == 7) then
              ni = ni + 1
              i_set(ni) = j
            end if
          end do
        else                                                  ! The following block has not been tested.
          if (txtatm(i_in)(14:16) == "ND1") then
            atm = "NE2"
          else
            atm = "ND1"
          end if
!
!  Use the current nitrogen atom and the nitrogen atom on the other side of "CE1"
!
          do i = 1, nbonds(atom_i)
            j = ibonds(i,atom_i)
            if (txtatm(j)(14:16) == "CE1") then
              do k = 1, nbonds(j)
                l = ibonds(k,j)
                if (txtatm(l)(14:16) == atm) then
                  ni = ni + 1
                  i_set(ni) = l
                end if
              end do
            end if
          end do
        end if
      end if
    else if (txtatm(atom_i)(18:20) == "ARG") then
      if (txtatm(atom_i)(14:15) == "CZ" .or. txtatm(atom_i)(14:16) == "NH1" .or. txtatm(atom_i)(14:16) == "NH2") then
        if (txtatm(atom_i)(14:15) == "CZ") then
!
!  Use the terminal nitrogen atoms on each side of the current atom
!
          ni = 0
          do i = 1, nbonds(atom_i)
            j = ibonds(i,atom_i)
            ni = ni + 1
            i_set(ni) = j
          end do
        end if
      end if
    end if
!
! Look for anionic oxygen atoms
!
   if (txtatm(atom_i)(24:26) == "107" .and. txtatm(atom_j)(24:26) == "245") then
    continue
   end if
    if (txtatm(atom_j)(14:14) == "O") then
      do i = 1, nbonds(atom_j)
        j = ibonds(i, atom_j)
        if (txtatm(j)(14:14) == "C" .and. nbonds(j) == 3) then
!
! Search for both oxygen atoms of a -COO
!
          nj = 0
          do l = 1, nbonds(j)
            m = ibonds(l,j)
            if (txtatm(m)(14:14) == "O") then
              nj = nj + 1
              j_set(nj) = m
            end if
          end do
        end if
      end do
    end if
  end if

!
! Now find the shortest distance between the two ions
!
  sum_min = 1.d10
  k = 0
  l = 0
  do i = 1, ni
    atom_i = i_set(i)
    do j = 1, nj
      atom_j = j_set(j)
      sum = distance(atom_i, atom_j)
      if (sum < sum_min) then
        sum_min = sum
        k = atom_i
        l = atom_j
      end if
    end do
  end do
  atom_i = k
  atom_j = l
  if (sum_min < 99.d0) then
    n_jj = n_jj + 1
    if (n_jj > 100) return
    if(ions(i_in) == 1) then
      near_ions(1,n_jj) = atom_i
      near_ions(2,n_jj) = atom_j
    else
      near_ions(1,n_jj) = atom_j
      near_ions(2,n_jj) = atom_i
    end if
    r_ions(n_jj) = sum_min
    l_salt_i = .false.
    l_salt_j = .false.
    if (txtatm(atom_i)(18:20) == "HIS") then
      if (txtatm(atom_i)(14:16) == "ND1" .or. txtatm(atom_i)(14:16) == "NE2") l_salt_i = .true.
    else if (txtatm(atom_i)(18:20) == "ARG") then
       if (txtatm(atom_i)(14:16) == "NH1" .or. txtatm(atom_i)(14:16) == "NH2" &
         .or. txtatm(atom_i)(14:15) == "NE") l_salt_i = .true.
    else if (txtatm(atom_i)(14:14) == "N") then
       if (nbonds(atom_i) == 4) l_salt_i = .true.
    end if
    if (txtatm(atom_j)(14:14) == "O") l_salt_j = .true.
    if (l_salt_i .and. l_salt_j .and. sum_min < 4.d0) line = "Salt bridge!"
  end if
  return
  end subroutine identify_nearby_counterions

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine polar()
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use common_arrays_C, only : nat, na, labels, &
      & geo, coord, w, c, tvec
      USE parameters_C, only : polvol
      USE funcon_C, only : ev
      USE elemts_C, only : elemnt
      USE molkst_C, ONLY: numat, norbs, natoms, ndep, nvar, keywrd, last, &
      limscf, id, moperr
      USE polar_C, only : omega
      USE chanel_C, only : iw
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
      double precision, allocatable, dimension (:,:) :: x1, x2, x3, x4, x5, x6, x7, x8, &
        x19, x10, x11, x12, x13
      integer :: i, j, k, l, iwflb, ibet, igam, maxitu, maxita, &
        nfreq, iwfla, ref_na(natoms)
      double precision, dimension(nvar) :: grad
      double precision, dimension(3,3) :: rotvec, tempv
      double precision, dimension(10) :: dataev
      double precision, dimension(3,natoms) :: refgeo
      double precision :: a, b, sum, sumx, sumy, sumz, summax, atpol, heat0, &
        atol, btol, hartr, omegau, cc
      double precision, external :: reada, wrdkey
      logical :: let
      character :: polkey*241
!-----------------------------------------------
!
!   THIS COMPUTER PROGRAM HAS BEEN PLACED IN THE PUBLIC DOMAIN
!   BY THE AUTHORS PROF HENRY KURTZ AND PRAKASHAN KORAMBATH
!   DEPARTMENT OF CHEMISTRY, MEMPHIS STATE UNIVERSITY, MEMPHIS TN
!   1992
!.. 6/13/91
!**********************************************************************
!
!   POLAR SETS UP THE CALCULATION OF THE MOLECULAR ELECTRIC RESPONSE
!   PROPERTIES BY FFHPOL.
!
!**********************************************************************
!..
    allocate(x1(norbs,norbs), x2(norbs,norbs), x3(norbs,norbs), x4(norbs,norbs), &
      x5(norbs,norbs), x6(norbs,norbs), x7(norbs,norbs), x8(norbs,norbs), &
      x19(norbs,norbs), x10(norbs,norbs), x11(norbs,norbs), x12(norbs,norbs), x13(norbs,norbs), &
      stat=i)
    if (i /= 0) then
      call memory_error ("polar")
      return
    end if
    x1 = 0.d0
    x2 = 0.d0
    x3 = 0.d0
    x4 = 0.d0
    x5 = 0.d0
    x6 = 0.d0
    x7 = 0.d0
    x8 = 0.d0
    x19 = 0.d0
    x10 = 0.d0
    x11 = 0.d0
      limscf = .FALSE.
      let = index(keywrd,'LET') /= 0
      write (iw, 10)
   10 format(' ',20('*'),' TDHF POLARIZABILITIES ',20('*'),/,/)
   refgeo(:,:natoms) = geo(:,:natoms)
   ref_na(:natoms) = na(:natoms)
      call gmetry (geo, coord)
!
!  ORIENT THE MOLECULE WITH THE MOMENTS OF INERTIA.
!  THIS IS DONE TO ENSURE A UNIQUE, REPRODUCEABLE SET OF DIRECTIONS.
!  IF LET IS SPECIFIED, THE INPUT ORIENTATION WILL BE USED.
!
      if (.not.let) then
        call axis (a, b, cc, rotvec)
        if (Int(a + b + cc) == -1000) return ! dummy use of arguments of axis
        write (iw, 20)
   20   format(/,' ROTATION MATRIX FOR ORIENTATION OF MOLECULE:'/)
        do i = 1, 3
          write (iw, 30) (rotvec(i,j),j=1,3)
   30     format(5x,3f12.6)
        end do
!
!  ROTATE ATOMS
!
        do i = 1, numat
          do j = 1, 3
            sum = 0.0D00
            do k = 1, 3
              sum = sum + coord(k,i)*rotvec(k,j)
            end do
            geo(j,i) = sum
          end do
        end do
        coord(:,:numat) = geo(:,:numat)
        write (iw, '(2/10X,''CARTESIAN COORDINATES '',/)')
        write (iw, &
      '(4X,''NO.'',7X,''ATOM'',9X,''X'',                      9X,''Y'',9X,''Z''&
      &,/)')
        l = 0
        do i = 1, numat
          if (nat(i)==99 .or. nat(i)==107) cycle
          l = l + 1
          write (iw, '(I6,8X,A2,4X,3F10.4)') l, elemnt(nat(i)), (coord(j,l),j=1&
            ,3)
        end do
!
!  IF POLYMER, ROTATE TVEC
!  (BEWARE:  THE POLYMER SECTIONS MAY NOT WORK YET)
!
        if (id > 0) then
          do i = 1, id
            do j = 1, 3
              sum = 0.0D00
              do k = 1, 3
                sum = sum + tvec(k,i)*rotvec(k,j)
              end do
              tempv(j,i) = sum
            end do
          end do
          tvec(:,:id) = tempv(:,:id)
          write (iw, 160) ((tvec(j,i),j=1,3),i=1,id)
  160     format(/,' NEW TRANSLATION VECTOR:'/,' ',3(3f15.5))
        end if
      end if
!
      last = 1
      na = 0
!
!  SET UP THE VARIABLES IN XPARAM AND LOC, THESE ARE IN CARTESIAN
!  COORDINATES.
!
      ndep = 0
      numat = 0
      sumx = 0.D0
      sumy = 0.D0
      sumz = 0.D0
      do i = 1, natoms
        if (labels(i)==99 .or. labels(i)==107) cycle
        numat = numat + 1
        labels(numat) = labels(i)
        sumx = sumx + coord(1,numat)
        sumy = sumy + coord(2,numat)
        sumz = sumz + coord(3,numat)
        geo(:,numat) = coord(:,numat)
      end do
      sumx = sumx/numat
      sumy = sumy/numat
      sumz = sumz/numat
      summax = 0.D0
      atpol = 0.D0
      do i = 1, numat
        if (labels(i) /= 107) atpol = atpol + polvol(labels(i))
        geo(1,i) = geo(1,i) - sumx
        summax = dmax1(abs(geo(1,i)),summax)
        geo(2,i) = geo(2,i) - sumy
        summax = dmax1(abs(geo(2,i)),summax)
        geo(3,i) = geo(3,i) - sumz
        summax = dmax1(abs(geo(3,i)),summax)
      end do
!
      nvar = 0
      natoms = numat
      call compfg (geo, .TRUE., heat0, .TRUE., grad, .FALSE.)
      write (iw, 200) heat0
  200 format(/,/,' ENERGY OF "REORIENTED" SYSTEM WITHOUT FIELD:',f20.10)
!...............................................................
!
!  VARIABLES USED FOR TIME-DEPENDENT CALCULATIONS
!
!    OMEGA .........  FREQUENCY OF LIGHT (ACTUALLY INPUT AS ENERGY
!                     IN EV'S.
!    IWFLA .........  TYPE OF ALPHA CALCULATION FOR STORING MATRICES
!                     0 = STATIC
!                     1 = OMEGA
!                     2 = 2*OMEGA
!                     3 = 3*OMEGA
!    IWFLB .........  TYPE OF BETA CALCULATION FOR STORING MATRICES
!                     0 = (0,0)
!                     1 = (W,W) (SHG)
!                     2 = (0,W) (EOPE)
!                     3 = (W,-W) (OR)
!
!  INPUT NUMBER OF FREQENCIES TO RUN
!
!     IBET = 0  NO BETA CALC
!            1  ITERATIVE BETA
!           -1  NONITER BETA (SHG)
!           -2  NONITER EOPE
!           -3  NONITER OR
!
!     IGAM = 0  NO GAMMA CALC
!            1 THIRD HARMONIC GENERATION INPUT N,0,1,1
!            2 DC-EFISHG INPUT N,0,1,2
!            3 IDRI N,0,1,3
!            4 OKE N,0,1,4
!            5 DC EFIOR (NOT AVAILABLE)
!
      iwflb = nint(wrdkey(keywrd,'POLAR(',6,'IWFLB',5,0.D0))
      ibet = nint(wrdkey(keywrd,'POLAR(',6,'BETA',4,1.D0))
      igam = nint(wrdkey(keywrd,'POLAR(',6,'GAMMA',5,1.D0))
      atol = wrdkey(keywrd,'POLAR(',6,'TOL',3,0.001D0)
      maxitu = nint(wrdkey(keywrd,'POLAR(',6,'MAXITU',6,500.D0))
      maxita = nint(wrdkey(keywrd,'POLAR(',6,'MAXITA',6,150.D0))
      btol = wrdkey(keywrd,'POLAR(',6,'BTOL',4,0.001D0)
      i = index(keywrd,'POLAR(')
      if (i /= 0) then
        polkey = keywrd(i:)
        i = index(polkey,') ')
        polkey(i:) = ' '
      else
        polkey = ' '
      end if
      i = index(polkey,'E=(')
      if (i /= 0) then
        j = index(polkey(i:),')')
        polkey(:i) = ' '
        polkey(i+j:) = ' '
        do i = 1, 10
          dataev(i) = reada(polkey,1)
          j = index(polkey,',')
          if (j /= 0) then
            polkey(:j) = ' '
          else
            nfreq = i
            go to 230
          end if
        end do
      else
        do i = 1, 3
          dataev(i) = (i - 1)*0.25D0
        end do
        nfreq = 3
      end if
  230 continue
      if (igam /= 0) ibet = 1
      write (iw, 240) nfreq, iwflb, ibet, igam
  240 format(/,/,'  NFREQ=',i3,'  IWFLB=',i3,'  IBET=',i3,'  IGAM=',i3)
!
! ATOL IS THE MAXIMUM TOLERANCE IN MAKEUF AND BTOL IS THAT IN BMAKUF
! MAXITU IS THE MAXIMUM ITERATION IN BETAF AND MAXITA IS THE MAXIMUM
! ITERATION IN ALPHAF
!
      write (iw, 250) atol, btol, maxitu, maxita
  250 format('  ATOL=',d12.5,'  BTOL=',d12.5,'    MAXITU=',i5,'    MAXITA=',i5)
!
! SET UP DIRECT ACCESS FILE FOR T-D MATRICES
      call openda (0)
!
! CALCULATE ALPHA AT STATIC VALUES
!
      if (iwflb==2 .or. igam==2 .or. igam==4 .or. ibet<=(-2)) then
        iwfla = 0
        omega = 0.0D00
        call alphaf (iwfla, atol, maxita, x1, x2, x3, x4, x5, x6, x7, x8, c, w)
        if (moperr) return
!
      end if
      if (igam == 4) then
        iwflb = 0
        call betaf (iwflb, maxitu, btol, x1, x2, x3, x4, x5, x6, x7, x8, x19, &
          x10, x11, x12, x13, c, w)
      end if
!
! CALCULATE FREQUENCY DEPENDENT VALUES
!
      hartr = ev
      do i = 1, nfreq
!
!  READ IN FREQ:  ACTUALLY READ IN AS ENERGY IN EV.
!
        omega = dataev(i)
        omegau = omega/hartr
        if (omega < 1.0D-8) then
!#           WRITE(IW,401) OMEGA
          write (iw, 260)
  260     format(/,/,' ',65('*'),/,' CALCULATION OF STATIC FIELD QUANTITIES',/,&
            ' ',65('*'))
        else
          write (iw, 270) omega, omegau, 1239.8424D0/omega, 8065.541D0*omega
  270     format(/,/,' ',70('*'),/,' CALCULATION FOR A FREQUENCY OF ',f10.5,&
            ' EV  =',f14.5,' A.U. '/,18x,'WAVELENGTH OF ',f10.2,' NM  =',f14.5,&
            ' CM(-1)',/,' ',70('*'))
        end if
!
!  CALCULATE ALPHA(W)
!
        iwfla = 1
        call alphaf (iwfla, atol, maxita, x1, x2, x3, x4, x5, x6, x7, x8, c, w)
        if (moperr) return
!
!  PERFORM NONITERATIVE BETA CALCULATIONS
!
!   OPTICAL RECTIFICATION
        if (ibet == (-3)) call nonor (x1, x2, x3, x4, x5, x6, x7, x8, x19, x10&
          , x11, x12)
!   ELECTROPTIC POCKELS EFFECT
        if (ibet == (-2)) call nonope (x1, x2, x3, x4, x5, x6, x7, x8, x19, x10&
          , x11, x12)
!   SECOND HARMONIC GENERATION
        if (ibet == (-1)) then
          iwfla = 2
          omega = omega*2.0D00
          call alphaf (iwfla, atol, maxita, x1, x2, x3, x4, x5, x6, x7, x8, c, w)
          if (moperr) return
!
          omega = omega/2.0D00
          call nonbet (x1, x2, x3, x4, x5, x6, x7, x8, x19, x10, x11, x12)
        end if
!
!  PERFORM ITERATIVE BETA (SHG AND STATIC)CALCULATIONS
!
!         IF ((IBET.GT.0) .AND.(IGAM .EQ. 0)) THEN
        if (ibet==1 .and. iwflb<=1 .and. igam==0) then
          call betaf (iwflb, maxitu, btol, x1, x2, x3, x4, x5, x6, x7, x8, x19&
            , x10, x11, x12, x13, c, w)
!
! PERFORM ITERATIVE BETA (EOPE AND OR) CALCULATIONS
!
        else if (ibet==1 .and. iwflb>1 .and. igam==0) then
          call beopor (iwflb, maxitu, btol, x1, x2, x3, x4, x5, x6, x7, x8, x19&
            , x10, x11, x12, x13, c, w)
        end if
!.......................................................................
! CALCULATE GAMMA VALUES
!.......................................................................
        if (ibet>0 .and. igam<=3 .and. igam/=0) then
          iwflb = 1
          call betaf (iwflb, maxitu, btol, x1, x2, x3, x4, x5, x6, x7, x8, x19&
            , x10, x11, x12, x13, c, w)
        end if
! THIRD HARMONIC GENERATION
        if (igam == 1) then
          iwfla = 3
          omega = omega*3.0D00
          call alphaf (iwfla, atol, maxita, x1, x2, x3, x4, x5, x6, x7, x8, c, w)
          if (moperr) return
!
          omega = omega/3.0D00
          call ngamtg (x1, x2, x3, x4, x5, x6, x7, x8, x19)
        end if
! DC-EFISHG
        if (igam == 2) then
          iwfla = 2
          omega = 2.0D00*omega
          call alphaf (iwfla, atol, maxita, x1, x2, x3, x4, x5, x6, x7, x8, c, w)
          if (moperr) return
!
          omega = omega/2.0D00
          iwflb = 2
          call beopor (iwflb, maxitu, btol, x1, x2, x3, x4, x5, x6, x7, x8, x19&
            , x10, x11, x12, x13, c, w)
          call ngefis (x1, x2, x3, x4, x5, x6, x7, x8, x19)
        end if
! IDRI
        if (igam == 3) then
          iwflb = 3
          call beopor (iwflb, maxitu, btol, x1, x2, x3, x4, x5, x6, x7, x8, x19&
            , x10, x11, x12, x13, c, w)
          call ngidri (x1, x2, x3, x4, x5, x6, x7, x8, x19)
        end if
! OKE
        if (igam /= 4) cycle
        iwflb = 2
        call beopor (iwflb, maxitu, btol, x1, x2, x3, x4, x5, x6, x7, x8, x19, &
          x10, x11, x12, x13, c, w)
        call ngoke (igam, x1, x2, x3, x4, x5, x6, x7, x8, x19)
      end do
!
      geo(:,:natoms) = refgeo(:,:natoms)
      na(:natoms) = ref_na(:natoms)
      return
      end subroutine polar



      subroutine tf(ua, ga, ub, gb, t, norbs)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: norbs
      double precision , intent(in) :: ua(norbs,norbs)
      double precision , intent(in) :: ga(norbs,norbs)
      double precision , intent(in) :: ub(norbs,norbs)
      double precision , intent(in) :: gb(norbs,norbs)
      double precision  :: t(norbs,norbs)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j
      double precision :: sum1, sum2
!-----------------------------------------------
!
!  THIS SUBROUTINE CREATES THE NEW T MATRIX
!
!
!  ZERO MATRIX INITIALLY
!
      call zerom (t, norbs)
!
! CALCULATE T (IJ)(W,W)= SUM(GA(IK)(W)*UB(KJ)(W)+
! GB(IK)(W)*UA(KJ)(W)-UA(IK)(W)GB(KJ)(W)-UB(IK)(W)GA(KJ)(W)
!
      do i = 1, norbs
        do j = 1, norbs
          sum1 = 0.0D0
          sum2 = 0.0D0
! CALCULATE FOR (W,W), (0,W) VALUES
!
          sum1 = sum(ga(i,:norbs)*ub(:norbs,j)+gb(i,:norbs)*ua(:norbs,j)-ua(i,:&
            norbs)*gb(:norbs,j)-ub(i,:norbs)*ga(:norbs,j))
          sum2 = sum(ga(j,:norbs)*ub(:norbs,i)+gb(j,:norbs)*ua(:norbs,i)-ua(j,:&
            norbs)*gb(:norbs,i)-ub(j,:norbs)*ga(:norbs,i))
          t(i,j) = sum1
          t(j,i) = sum2
        end do
      end do
!
      return
      end subroutine tf


      subroutine transf(f, g, c, norb)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : norbs
!***********************************************************************
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: norb
      double precision , intent(in) :: f(norb,norb)
      double precision , intent(out) :: g(norb,norb)
      double precision , intent(in) :: c(norb,norb)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j
      double precision, dimension(norbs) :: work
      double precision :: term, term2
!-----------------------------------------------
!
!  THIS SUBROUTINE FORMS THE G MATRIX BY TRANSFORMING F WITH C
!
!
      do i = 1, norb
        do j = 1, norb
          term = 0.0D00
          term = sum(f(j,:)*c(:,i))
          work(j) = term
        end do
        do j = 1, norb
          term2 = 0.0D00
          term2 = sum(work(:norb)*c(:,j))
          g(j,i) = term2
        end do
      end do
      return
      end subroutine transf


      double precision function trsub (ul, x, ur, l1, lm, ndim)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
! THIS PROGRAM CALCULATES TRACES OF MATRICES
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: l1
      integer , intent(in) :: lm
      integer , intent(in) :: ndim
      double precision , intent(in) :: ul(ndim,ndim)
      double precision , intent(in) :: x(ndim,ndim)
      double precision , intent(in) :: ur(ndim,ndim)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, k, l
      double precision :: sum, suml
!-----------------------------------------------
!
      sum = 0.0D00
      do i = 1, l1
        do k = 1, lm
          suml = 0.0D00
          do l = 1, lm
            suml = suml + x(k,l)*ur(l,i)
          end do
          sum = sum + suml*ul(i,k)
        end do
      end do
      trsub = 2.0D00*sum
      return
      end function trsub


      double precision function trudgu (ul, x, ur, l1, lm, ndim)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: l1
      integer , intent(in) :: lm
      integer , intent(in) :: ndim
      double precision , intent(in) :: ul(ndim,ndim)
      double precision , intent(in) :: x(ndim,ndim)
      double precision , intent(in) :: ur(ndim,ndim)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, k, l
      double precision :: sum, suml
!-----------------------------------------------
!
      sum = 0.0D00
      do i = 1, l1
        do k = 1, lm
          suml = 0.0D00
          do l = 1, lm
            suml = suml + x(k,l)*ur(l,i)
          end do
          sum = sum + suml*ul(k,i)
        end do
      end do
      trudgu = 2.0D00*sum
      return
      end function trudgu


      double precision function trugdu (ul, x, ur, l1, lm, ndim)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: l1
      integer , intent(in) :: lm
      integer , intent(in) :: ndim
      double precision , intent(in) :: ul(ndim,ndim)
      double precision , intent(in) :: x(ndim,ndim)
      double precision , intent(in) :: ur(ndim,ndim)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, k, l
      double precision :: sum, suml
!-----------------------------------------------
!
      sum = 0.0D00
      do i = 1, l1
        do k = 1, lm
          suml = 0.0D00
          do l = 1, lm
            suml = suml + x(l,k)*ur(l,i)
          end do
          sum = sum + suml*ul(i,k)
        end do
      end do
      trugdu = 2.0D00*sum
      return
      end function trugdu


      double precision function trugud (ul, x, ur, l1, lm, ndim)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: l1
      integer , intent(in) :: lm
      integer , intent(in) :: ndim
      double precision , intent(in) :: ul(ndim,ndim)
      double precision , intent(in) :: x(ndim,ndim)
      double precision , intent(in) :: ur(ndim,ndim)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, k, l
      double precision :: sum, suml
!-----------------------------------------------
!
      sum = 0.0D00
      do i = 1, l1
        do k = 1, lm
          suml = 0.0D00
          do l = 1, lm
            suml = suml + x(k,l)*ur(i,l)
          end do
          sum = sum + suml*ul(i,k)
        end do
      end do
      trugud = 2.0D00*sum
      return
      end function trugud


      double precision function wrdkey (keywrd, key, nk, refkey, nr, def)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: nk
      integer , intent(in) :: nr
      double precision , intent(in) :: def
      character  :: keywrd*241
      character , intent(in) :: key*(*)
      character , intent(in) :: refkey*(*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j, k
      double precision, external :: reada
!-----------------------------------------------
!***********************************************************************
!
!   WRDKEY is a way to assign values using keywords.  If the keyword is
!          present, it is used, otherwise the default is used.
!
!   Format:
!          KEY    =  Start of keyword
!          NK     =  Number of characters in (start of keyword)
!          REFKEY =  Variable in keyword
!          NR     =  Number of characters in (variable in keyword)
!
!   For example, if call is WRDKEY(KEYWRD,'VDW(',4,':ZN',3,1.5D0)
!   then if VWD(:ZN=1.4) exists, WRDKEY will be 1.4, otherwise 1.5
!   Note: the "=" and ")" are not necessary, but make the line easier
!   to read.
!***********************************************************************
      i = index(keywrd,key(:nk))
      if (i /= 0) then
        j = index(keywrd(i:),') ')
        k = index(keywrd(i:i+j),refkey(:nr))
        if (k /= 0) then
          wrdkey = reada(keywrd,i + k)
        else
          wrdkey = def
        end if
      else
        wrdkey = def
      end if
      return
      end function wrdkey


      subroutine zerom(x, m)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------

      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: m
      double precision , intent(out) :: x(m,m)
!-----------------------------------------------
!
!  ZEROM ZEROS THE MATRIX X
!
      x = 0.0D00
      return
      end subroutine zerom


      subroutine alphaf(iwfla, atol, maxita, u, f, g, uold, h1, d, da, w2, c, w)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : norbs, keywrd, nclose, numat
      use chanel_C, only : iw
      use funcon_C, only: a0, ev
      use common_arrays_C, only : eigs, nat, nfirst, nlast, coord
      USE polar_C, only : omega, alpavg
!
!  SUBROUTINE FOR THE CALCULATION OF THE FREQUENCY DEPENDENT FIRST-ORDER
!  RESPONCE MATRICIES UA AND DENSITIES DA.
!  USED TO COMPUTE THE FREQUENCY DEPENDENT POLARIZABILITY AND FOR
!  SOLVING THE SECOND-ORDER PROBLEM.
!
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: iwfla
      integer , intent(in) :: maxita
      double precision  :: atol
      double precision  :: u(norbs,norbs)
      double precision  :: f(norbs,norbs)
      double precision  :: g(norbs,norbs)
      double precision  :: uold(norbs,norbs)
      double precision  :: h1(norbs,norbs)
      double precision  :: d(norbs,norbs)
      double precision  :: da(norbs,norbs)
      double precision  :: w2(*)
      double precision  :: c(*)
      double precision  :: w(*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: nsqr, iposu, iposg, id, icount, ic, j, iexp
      double precision, dimension(3,3) :: allalp
      double precision :: cmptim, alpold, diff, alphaw, dela, &
      const
      logical :: last, debug
      character, dimension(3) :: alab
      double precision, external :: aval, pol_vol, seconds

      save alab
!-----------------------------------------------
!
      data alab/ 'X', 'Y', 'Z'/
!
      iexp = 0
      debug = index(keywrd,' DEBUG') /= 0
      nsqr = norbs*norbs
      alpavg = 0.0D00
! COMPUTE OFFSETS FOR U AND G MATRICES
      iposu = 1 + 6*iwfla
      iposg = 4 + 6*iwfla
      write (iw, 10) omega
   10 format(/,' +++++ ALPHA AT ',1f13.5,' EV.')
!
!  CHOOSE A  COMPONENT
!  X: ID=1   Y: ID=2   Z: ID=3
!
      do id = 1, 3
        cmptim = seconds(1)
        last = .FALSE.
!
!  CALCULATE THE DIPOLE MATRIX.
!
        call hmuf (h1, id, coord, nfirst, nlast, nat, norbs, numat)
        call copym (h1, f, norbs)

!
!
!  INITIALIZE UOLD TO ZERO
!
        call zerom (uold, norbs)
!.................................................................
!  LOOP STARTS HERE
!.................................................................
        icount = 0
        alpold = 0.0D00
        icount = icount + 1
        if (icount > maxita) last = .TRUE.
!
!  CREATE G MATRIX.
!
        call transf (f, g, c, norbs)
!
!  FORM U MATRIX
!
        call makeuf (u, uold, g, eigs, last, norbs, nclose, diff, atol)
!
!  FORM NEW DENSITY MATRIX
!
        call densf (u, c, d, da, norbs, nclose, w2)
!
! COMPUTE TEST ALPHA TO BE USED FOR A CONVERGENCE TEST
!
        alphaw = aval(h1,d,norbs)
        dela = dabs(alpold - alphaw)
        alpold = alphaw
!
!  CREATE NEW FOCK MATRIX
!
        f = 0.d0
        call ffreq2 (f, d, w)
        call ffreq1 (f, d, da, da, norbs)
        f = h1 + f/ev
        do while(.not.last)
          icount = icount + 1
          if (icount > maxita) last = .TRUE.
!
!  CREATE G MATRIX.
!
          call transf (f, g, c, norbs)
!
!  FORM U MATRIX
!
          call makeuf (u, uold, g, eigs, last, norbs, nclose, diff, atol)
!
!  FORM NEW DENSITY MATRIX
!
          call densf (u, c, d, da, norbs, nclose, w2)
!
! COMPUTE TEST ALPHA TO BE USED FOR A CONVERGENCE TEST
!
          alphaw = aval(h1,d,norbs)
          dela = dabs(alpold - alphaw)
          alpold = alphaw
!
!  CREATE NEW FOCK MATRIX
!
          call zerom (f, norbs)
          call ffreq2 (f, d, w)
          call ffreq1 (f, d, da, da, norbs)
          if (Abs(f(1,1)) > 1.d6) then
            call mopend("Calculation of polarizability failed (This part of MOPAC is fragile)")
            return
          end if
          call hplusf (f, h1, norbs)
!..............................................................
        end do
        cmptim = seconds(1) - cmptim
        if (debug) write (iw, 30) icount, cmptim, diff, dela
   30   format(/,' CONVERGED IN',i4,' ITERATIONS IN',f10.2,' SECONDS',/,&
          '           DENSITY CONVERG. TO ',1p,d12.5,/,&
          '             ALPHA CONVERG. TO ',1p,d12.5,/)
!
! COMPUTE ALPHA
!
        alphaw = aval(h1,d,norbs)
        allalp(id,id) = alphaw
        if (debug) write (iw, 40) alab(id), alab(id), alphaw
   40   format('      ALPHA(',a1,',',a1,') = ',1p,d14.7)
        alpavg = alpavg + alphaw
!
!  WRITE OUT U AND G FOR FUTURE USE
!
        call dawrit (u, nsqr, iposu + id)
        call dawrit (g, nsqr, iposg + id)
!
!  COMPUTE OTHER COMPONENTS
!
        do ic = 1, 3
          if (ic == id) cycle
          call hmuf (h1, ic, coord, nfirst, nlast, nat, norbs, numat)
          alphaw = aval(h1,d,norbs)
          allalp(ic,id) = alphaw
          if (debug) write (iw, 50) alab(ic), alab(id), alphaw
   50     format('      ALPHA(',a1,',',a1,') = ',1p,d14.7)
        end do
      end do

      allalp(1,1) = pol_vol(allalp(1,1))
      allalp(2,2) = pol_vol(allalp(2,2))
      allalp(3,3) = pol_vol(allalp(3,3))
      alpavg = (allalp(1,1) + allalp(2,2) + allalp(3,3))/3.d0
      if (alpavg > 1.d6) then
        iexp = Nint (Log10(alpavg)) - 5
        const = 10.d0 ** (-iexp)
        write (iw, "(/27X, 'COMPONENTS OF ALPHA*10**(',I3,')',/)") - iexp
      else
        const = 1.d0
        write (iw, "(/27X, 'COMPONENTS OF ALPHA',/)")
      end if
    write (iw, "(21X,'*X',11X,'*Y',11X,'*Z')")
    write (iw, "(10X,' *=X:',3F13.4)") (allalp(1, j)*const, j=1, 3)
    write (iw, "(10X,' *=Y:',3F13.4)") (allalp(2, j)*const, j=1, 3)
    write (iw, "(10X,' *=Z:',3F13.4)") (allalp(3, j)*const, j=1, 3)
     if (const < 0.9d0) then
      write (iw, 10035) - iexp, alpavg * const,alpavg * const*a0**3
10035 format (/, "  ISOTROPIC AVERAGE ALPHA*10**(", I3, ") = ", f13.5, " A.U. =",&
  & f13.5, " ANG.**3")
    else
      write (iw, 10040) alpavg, alpavg*a0**3
10040 format (/, "  ISOTROPIC AVERAGE ALPHA = ", 1 f13.5, " A.U. =", &
           & f13.5, " ANG.**3")
    end if
    call to_screen("To_file: POLAR")
!
      return
      end subroutine alphaf


      double precision function aval (h, d, norbs)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: norbs
      double precision , intent(in) :: h(norbs,norbs)
      double precision , intent(in) :: d(norbs,norbs)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j
      double precision :: sum
!-----------------------------------------------
!.................................................................
!  COMPUTE POLARIZABILITY AS TRACE OF H*D
!.................................................................
      sum = 0.0D00
      do i = 1, norbs
        do j = 1, norbs
          sum = sum + h(i,j)*d(j,i)
        end do
      end do
      aval = -sum
      return
      end function aval


      subroutine bdenin(bdcon, ua, ub, c, norbs, nclose)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!
!***********************************************************************
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: norbs
      integer , intent(in) :: nclose
      double precision , intent(out) :: bdcon(norbs,norbs)
      double precision , intent(in) :: ua(norbs,norbs)
      double precision , intent(in) :: ub(norbs,norbs)
      double precision , intent(in) :: c(norbs,norbs)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j, l, k
      double precision, dimension(norbs) :: w1, w2, w3, w4
      double precision :: sum1, sum2, sum3, sum4, s3, s4
!-----------------------------------------------
!
!  THIS SUBROUTINE IS USED TO COMPUTE THE FIRST-ORDER DENSITY
!
!
! CALCULATE
!
      do i = 1, norbs
        do j = 1, norbs
!
          do l = nclose + 1, norbs
            sum1 = 0.D0
            sum2 = 0.D0
            sum1 = sum(ub(l,:nclose)*c(j,:nclose))
            sum2 = sum(ua(l,:nclose)*c(j,:nclose))
            w1(l) = sum1
            w2(l) = sum2
          end do
          do k = 1, nclose
            sum3 = 0.D0
            sum3 = sum((ua(k,nclose+1:norbs)*w1(nclose+1:norbs)+ub(k,nclose+1:&
              norbs)*w2(nclose+1:norbs)))
            w3(k) = sum3
          end do
!
          do l = 1, nclose
            sum1 = 0.D0
            sum2 = 0.D0
            sum1 = sum(ub(l,nclose+1:norbs)*c(j,nclose+1:norbs))
            sum2 = sum(ua(l,nclose+1:norbs)*c(j,nclose+1:norbs))
            w1(l) = sum1
            w2(l) = sum2
          end do
          do k = nclose + 1, norbs
            sum4 = 0.D0
            sum4 = sum((ua(k,:nclose)*w1(:nclose)+ub(k,:nclose)*w2(:nclose)))
            w4(k) = sum4
          end do
          s3 = 0.D0
          s3 = sum(w3(:nclose)*c(i,:nclose))
          s4 = 0.D0
          s4 = sum(w4(nclose+1:norbs)*c(i,nclose+1:norbs))
          bdcon(i,j) = s3 - s4
        end do
      end do
!
      return
      end subroutine bdenin


      subroutine bdenup(bdcon, uab, c, d, da, norbs, nclose)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: norbs
      integer , intent(in) :: nclose
      double precision , intent(in) :: bdcon(norbs,norbs)
      double precision , intent(in) :: uab(norbs,norbs)
      double precision , intent(in) :: c(norbs,norbs)
      double precision  :: d(norbs,norbs)
      double precision , intent(inout) :: da(norbs,norbs)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: j, k, l, i
      double precision, dimension(norbs) :: w1
      double precision :: sum, s1, s2
!-----------------------------------------------
!
!  THIS SUBROUTINE IS USED TO COMPUTE THE FIRST-ORDER DENSITY
!
!
! FORM DENSITY MATRIX
!
!
      call zerom (d, norbs)
!
! CALCULATE
!
      do j = 1, norbs
        do k = 1, norbs
          sum = 0.D0
          do l = 1, nclose
            sum = sum + uab(k,l)*c(j,l)
          end do
          da(k,j) = sum
        end do
      end do
      do i = 1, norbs
        do k = 1, norbs
          sum = 0.D0
          do l = 1, nclose
            sum = sum + c(i,l)*uab(l,k)
          end do
          w1(k) = sum
        end do
        do j = 1, norbs
          s1 = 0.0D00
          s2 = 0.0D00
          do k = 1, norbs
            s1 = s1 + c(i,k)*da(k,j)
            s2 = s2 + w1(k)*c(j,k)
          end do
          d(i,j) = 2.0D00*(s1 - s2 + bdcon(i,j))
        end do
      end do
      da(:norbs,:norbs) = d(:norbs,:norbs)*0.5D0
!
      return
      end subroutine bdenup


      subroutine beopor(iwflb, maxitu, btol, ua, ub, f, ga, gb, t, h1, d, da, &
        uab, uold1, g, x, c, w)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : norbs, numat, nclose, line
      use common_arrays_C, only : eigs, nat, nfirst, nlast, coord
      use chanel_C, only : iw
      USE polar_C, only : omega
!
! THIS SUBROUTINE CALCULATES ITERATIVE BETA VALUES FOR
! THE ELECTROOPTIC POCKELS EFFECT AND OPTICAL RECTIFICATION
!
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: iwflb
      integer , intent(in) :: maxitu
      double precision  :: btol
      double precision  :: ua(norbs,norbs)
      double precision  :: ub(norbs,norbs)
      double precision  :: f(norbs,norbs)
      double precision  :: ga(norbs,norbs)
      double precision  :: gb(norbs,norbs)
      double precision  :: t(norbs,norbs)
      double precision  :: h1(norbs,norbs)
      double precision  :: d(norbs,norbs)
      double precision  :: da(norbs,norbs)
      double precision  :: uab(norbs,norbs)
      double precision  :: uold1(norbs,norbs)
      double precision  :: g(norbs,norbs)
      double precision  :: x(norbs,norbs)
      double precision  :: c(*)
      double precision  :: w(*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(9) :: ida, idb
      integer :: maxsq, iposu, iposg, ipose, iposum, id, ia, ib, jpu, jpg, &
        icount, ic
      double precision :: maxu, one, bavx, bavy, bavz, cmptim, betaw, diff, bvec
      logical :: last
      character, dimension(3) :: alab
      double precision, external :: aval, seconds

      save alab, ida, idb
!-----------------------------------------------
      data alab/ 'X', 'Y', 'Z'/
      data ida/ 1, 1, 1, 2, 2, 2, 3, 3, 3/
      data idb/ 1, 2, 3, 1, 2, 3, 1, 2, 3/
      one = 1.0D00
      maxsq = norbs*norbs
      if (iwflb == 2) then
        iposu = 73
      else
        iposu = 109
      end if
      iposg = iposu + 9
      ipose = iposg + 9
      iposum = ipose + 9
      if (iwflb == 0) then
        write (iw, 10) omega
   10   format(/,' +++++ BETA (STATIC) AT ',1f15.5,' EV.'/)
      else if (iwflb == 2) then
        write (iw, 20) omega
   20   format(/,' +++++ BETA',' (ELECTROOPTIC POCKELS EFFECT) AT ',1f15.5,&
          ' EV.'/)
      else
        write (iw, 30) omega
   30   format(/,' +++++ BETA',' (OPTICAL RECTIFICATION) AT ',1f15.5,' EV.'/)
      end if
!
!  LOOP OVER COMPONENTS
!
      bavx = 0.0D+00
      bavy = 0.0D+00
      bavz = 0.0D+00
      do id = 1, 9
        cmptim = seconds(1)
        ia = ida(id)
        ib = idb(id)
        last = .FALSE.
!
!  CALCULATE THE DIPOLE MATRIX.
!
        call hmuf (h1, ia, coord, nfirst, nlast, nat, norbs, numat)
!
!  INITIALIZE ZERO ARRAYS
!
        call zerom (uold1, norbs)
        call zerom (uab, norbs)
        call zerom (f, norbs)
!
!  INPUT U AND GA FROM ALPHA CALCULATIONS
!
        if (iwflb==2 .or. iwflb==0) then
!  UA CONTAINS UA(0)
          jpu = 1 + ia
          call daread (ua, maxsq, jpu)
!  GA CONTAINS GA(0)
          jpg = 4 + ia
          call daread (ga, maxsq, jpg)
        else
!  UA CONTAINS UA(W)
          jpu = 7 + ia
          call daread (ua, maxsq, jpu)
!  GA CONTAINS GA(W)
          jpg = 10 + ia
          call daread (ga, maxsq, jpg)
        end if
!
! READ VALUES FOR (W,-W) CALCULATION  :  OR
!
        if (iwflb == 3) then
!  UB CONTAINS UB(-W) = -UB+(W)
          jpu = 7 + ib
          call daread (x, maxsq, jpu)
          call fhpatn (ub, x, norbs, 2, (-one))
!  GB CONTAINS GB(-W) = GB+(W)
          jpg = 10 + ib
          call daread (x, maxsq, jpg)
          call fhpatn (gb, x, norbs, 2, one)
!
! READ VALUES FOR (0,W) CALCULATION  :  OKE
!
        else if (iwflb == 0) then
!  UB CONTAINS UB(0)
          jpu = 1 + ib
          call daread (ub, maxsq, jpu)
!  GB CONTAINS GB(0)
          jpg = 4 + ib
          call daread (gb, maxsq, jpg)
        else
!  UB CONTAINS UB(W)
          jpu = 7 + ib
          call daread (ub, maxsq, jpu)
!  GB CONTAINS GB(W)
          jpg = 10 + ib
          call daread (gb, maxsq, jpg)
        end if
!
!  CONSTRUCT T-MATRIX ONE TIME
!
        call tf (ua, ga, ub, gb, t, norbs)
!
!  CALCULATE INITIAL DENSITY AND BETA VALUE
!
        call bdenin (x, ua, ub, c, norbs, nclose)
        call bdenup (x, uab, c, d, da, norbs, nclose)
        betaw = aval(h1,d,norbs)
!
! INITIALIZE FOCK MATRIX
!
        call ffreq2 (f, d, w)
        call ffreq1 (f, d, da, da, norbs)
        call zerom (da, norbs)
        call hplusf (f, da, norbs)
!.................................................................
!  LOOP STARTS HERE
!.................................................................
        icount = 0
        icount = icount + 1
        if (icount >= maxitu) last = .TRUE.
!
!  CREATE G MATRIX.
!
        call transf (f, g, c, norbs)
!
!  FORM U MATRIX
!
        call bmakuf (ua, ub, uab, t, uold1, g, eigs, last, norbs, nclose, diff&
          , iwflb, maxu, btol)
!
!  FORM NEW DENSITY MATRIX
!
        call bdenin (x, ua, ub, c, norbs, nclose)
        call bdenup (x, uab, c, d, da, norbs, nclose)
!...
! COMPUTE TEST BETA
!
        betaw = aval(h1,d,norbs)
!         IF (LAST.OR.(ICOUNT.GT.(MAXITU-5))) THEN
!             WRITE(IW,1500) ICOUNT,DELA,MAXU,DIFF
! 1500        FORMAT(' ',I4,'  DELTA BETA = ', D12.5,
!     X       ' MAXU = ', D12.5, '  UDIFF = ', D12.5)
!         ENDIF
!
!  CREATE NEW FOCK MATRIX
!
        call zerom (f, norbs)
        call ffreq2 (f, d, w)
        call ffreq1 (f, d, da, da, norbs)
        call zerom (da, norbs)
        call hplusf (f, da, norbs)
        do while(.not.last)
          icount = icount + 1
          if (icount >= maxitu) last = .TRUE.
!
!  CREATE G MATRIX.
!
          call transf (f, g, c, norbs)
!
!  FORM U MATRIX
!
          call bmakuf (ua, ub, uab, t, uold1, g, eigs, last, norbs, nclose, &
            diff, iwflb, maxu, btol)
!
!  FORM NEW DENSITY MATRIX
!
          call bdenin (x, ua, ub, c, norbs, nclose)
          call bdenup (x, uab, c, d, da, norbs, nclose)
!...
! COMPUTE TEST BETA
!
          betaw = aval(h1,d,norbs)
!         IF (LAST.OR.(ICOUNT.GT.(MAXITU-5))) THEN
!             WRITE(IW,1500) ICOUNT,DELA,MAXU,DIFF
! 1500        FORMAT(' ',I4,'  DELTA BETA = ', D12.5,
!     X       ' MAXU = ', D12.5, '  UDIFF = ', D12.5)
!         ENDIF
!
!  CREATE NEW FOCK MATRIX
!
          call zerom (f, norbs)
          call ffreq2 (f, d, w)
          call ffreq1 (f, d, da, da, norbs)
          call zerom (da, norbs)
          call hplusf (f, da, norbs)
!..............................................................
        end do
        cmptim = seconds(1) - cmptim
        write (iw, 50) icount, cmptim
   50   format(/,' CONVERGED IN',i4,' ITERATIONS IN',f10.2,' SECONDS')
        write (iw, 60) maxu, diff
   60   format(' MAXIMUM UAB ELEMENT =',1f15.5,',  MAXIMUM DIFFERENCE =',1f15.5&
          ,/)
!
!  COMPUTE OTHER COMPONENTS
!
        do ic = 1, 3
          call hmuf (h1, ic, coord, nfirst, nlast, nat, norbs, numat)
          betaw = aval(h1,d,norbs)
          write (iw, 70) alab(ic), alab(ia), alab(ib), betaw
   70     format('      BETA(',a1,',',a1,',',a1,') = ',1f15.5)
! CALCULATES THE AVERAGE VALUE OF BETA
!
          if (id==1 .and. ic==1) then
            bavx = bavx + 3.0D0*betaw
          else if ((id==5 .or. id==9) .and. ic==1) then
            bavx = bavx + betaw
          else if ((id==2 .or. id==4) .and. ic==2) then
            bavx = bavx + betaw
          else if ((id==3 .or. id==7) .and. ic==3) then
            bavx = bavx + betaw
          end if
! CALCULATES AVERAGE BETA IN Y-DIRECTION
!
          if (id==5 .and. ic==2) then
            bavy = bavy + 3.0D0*betaw
          else if ((id==2 .or. id==4) .and. ic==1) then
            bavy = bavy + betaw
          else if ((id==1 .or. id==9) .and. ic==2) then
            bavy = bavy + betaw
          else if ((id==6 .or. id==8) .and. ic==3) then
            bavy = bavy + betaw
          end if
! CALCULATES AVERAGE BETA IN THE Z-DIRECTION
!
          if (id==9 .and. ic==3) then
            bavz = bavz + 3.0D0*betaw
          else if ((id==3 .or. id==7) .and. ic==1) then
            bavz = bavz + betaw
          else if ((id==6 .or. id==8) .and. ic==2) then
            bavz = bavz + betaw
          else if ((id==1 .or. id==5) .and. ic==3) then
            bavz = bavz + betaw
          end if
        end do
!
! CALL SUBROUTINE TO CALCULATE EPSILON AND UMINUS OMEGA,OMEGA
!  EPSILON IN H1 AND UMINUS IN DA
        call epsab (h1, eigs, g, ga, gb, ua, ub, uab, da, norbs, nclose, iwflb)
        call dawrit (uab, maxsq, iposu + id)
        call dawrit (g, maxsq, iposg + id)
        call dawrit (h1, maxsq, ipose + id)
        call dawrit (da, maxsq, iposum + id)
      end do
      bavx = bavx/5.0D+00
      bavy = bavy/5.0D+00
      bavz = bavz/5.0D+00
      bvec = (bavx*bavx + bavy*bavy + bavz*bavz)**0.5D+00
!
      if (bvec < 1.d10) then
        line = "(' AVERAGE BETA',a,' VALUE AT',f10.5,' EV = ',f11.4)"
      else if (bvec < 1.d15) then
        line = "(' AVERAGE BETA',a,' VALUE AT',f10.5,' EV = ',f16.4)"
      else
        line = "(' AVERAGE BETA',a,' VALUE AT',f10.5,' EV = ',f21.4)"
      end if
      write (iw,"(/)")
      write (iw, trim(line)) "X", omega, bavx
      write (iw, trim(line)) "Y", omega, bavy
      write (iw, trim(line)) "Z", omega, bavz
      write (iw,"(2/)")
      write (iw, trim(line)) " ", omega, bvec
      write (iw,"(/)")
      return
      end subroutine beopor


      subroutine betaf(iwflb, maxitu, btol, ua, ub, f, ga, gb, t, h1, d, da, &
        uab, uold1, g, x, c, w)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use common_arrays_C, only : eigs, nat, nfirst, nlast, coord
      use chanel_C, only : iw
      use molkst_C, only : norbs, nclose, numat, keywrd, line
      USE polar_C, only : omega
!
! THIS SUBROUTINE CALCULATES ITERATIVE BETA VALUES FOR SECOND HARMONIC
! GENERATION.
!
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: iwflb
      integer , intent(in) :: maxitu
      double precision  :: btol
      double precision  :: ua(norbs,norbs)
      double precision  :: ub(norbs,norbs)
      double precision  :: f(norbs,norbs)
      double precision  :: ga(norbs,norbs)
      double precision  :: gb(norbs,norbs)
      double precision  :: t(norbs,norbs)
      double precision  :: h1(norbs,norbs)
      double precision  :: d(norbs,norbs)
      double precision  :: da(norbs,norbs)
      double precision  :: uab(norbs,norbs)
      double precision  :: uold1(norbs,norbs)
      double precision  :: g(norbs,norbs)
      double precision  :: x(norbs,norbs)
      double precision  :: c(*)
      double precision  :: w(*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(6) :: ida, idb
      integer :: maxsq, iposu, iposg, ipose, iposum, id, ia, ib, jpu, jpg, &
        icount, ic, i, j
      double precision :: maxu
      double precision, dimension(3,3,3) :: allbet
      double precision :: one, bavx, bavy, bavz, cmptim, betaw, diff, bvec, &
        au_to_esu = 8.639418d-33
      logical :: last, debug
      character, dimension(3) :: alab
      double precision, external :: aval, seconds

      save alab, ida, idb
!-----------------------------------------------
!
!
      data alab/ 'X', 'Y', 'Z'/
      data ida/ 1, 1, 1, 2, 2, 3/
      data idb/ 1, 2, 3, 2, 3, 3/
!
      debug = index(keywrd,' BETAF ') /= 0
      one = 1.0D00
      maxsq = norbs*norbs
      iposu = 25 + 24*iwflb
      iposg = iposu + 6
      ipose = iposg + 6
      iposum = ipose + 6
!
      if (iwflb == 0) then
        write (iw, 10) omega
   10   format(/,' +++++ BETA (STATIC) AT ',1f15.5,' EV.'/)
      else
        write (iw, 20) omega
   20   format(/,' +++++ BETA',' (SECOND HARMONIC GENERATION) AT ',1f13.5,&
          ' EV.'/)
      end if
!
!  CHOOSE A  COMPONENT
!  X: ID=1   Y: ID=2   Z: ID=3
!
      bavx = 0.0D+00
      bavy = 0.0D+00
      bavz = 0.0D+00
      do id = 1, 6
        cmptim = seconds(1)
        ia = ida(id)
        ib = idb(id)
        last = .FALSE.
!
!  CALCULATE THE DIPOLE MATRIX.
!
        call hmuf (h1, ia, coord, nfirst, nlast, nat, norbs, numat)
!
!  INITIALIZE ZERO ARRAYS
!
        call zerom (uold1, norbs)
        call zerom (uab, norbs)
        call zerom (f, norbs)
!
!  INPUT U AND GA FROM ALPHA CALCULATIONS
!
        if (iwflb==2 .or. iwflb==0) then
          jpu = 1 + ia
          call daread (ua, maxsq, jpu)
          jpg = 4 + ia
          call daread (ga, maxsq, jpg)
        else
          jpu = 7 + ia
          call daread (ua, maxsq, jpu)
          jpg = 10 + ia
          call daread (ga, maxsq, jpg)
        end if
! READ VALUES FOR (W,-W)
        if (iwflb == 3) then
          jpu = 7 + ib
          call daread (x, maxsq, jpu)
          call fhpatn (ub, x, norbs, 2, (-one))
          jpg = 10 + ib
          call daread (x, maxsq, jpg)
          call fhpatn (gb, x, norbs, 2, one)
! READ VALUES FOR OKE
!
        else if (iwflb == 0) then
          jpu = 1 + ib
          call daread (ub, maxsq, jpu)
          jpg = 4 + ib
          call daread (gb, maxsq, jpg)
        else
          jpu = 7 + ib
          call daread (ub, maxsq, jpu)
          jpg = 10 + ib
          call daread (gb, maxsq, jpg)
        end if
!
!  CONSTRUCT T-MATRIX ONE TIME
!
        call tf (ua, ga, ub, gb, t, norbs)
!
!  CALCULATE INITIAL DENSITY AND BETA VALUE
!
        call bdenin (x, ua, ub, c, norbs, nclose)
        call bdenup (x, uab, c, d, da, norbs, nclose)
        betaw = aval(h1,d,norbs)
!
! INITIALIZE FOCK MATRIX
!
        call ffreq2 (f, d, w)
        call ffreq1 (f, d, da, da, norbs)
        call zerom (da, norbs)
        call hplusf (f, da, norbs)
!.................................................................
!  LOOP STARTS HERE
!.................................................................
        icount = 0
        icount = icount + 1
        if (icount >= maxitu) last = .TRUE.
!
!  CREATE G MATRIX.
!
        call transf (f, g, c, norbs)
!
!  FORM U MATRIX
!
        call bmakuf (ua, ub, uab, t, uold1, g, eigs, last, norbs, nclose, diff&
          , iwflb, maxu, btol)
!
!  FORM NEW DENSITY MATRIX
!
        call bdenup (x, uab, c, d, da, norbs, nclose)
!...
! COMPUTE TEST BETA
!
        betaw = aval(h1,d,norbs)
!         IF (LAST.OR.(ICOUNT.GT.(MAXITU-5))) THEN
!             WRITE(IW,1500) ICOUNT,DELA,MAXU,DIFF
! 1500        FORMAT(' ',I4,'  DELTA BETA = ', D12.5,
!     X       ' MAXU = ', D12.5, '  UDIFF = ', D12.5)
!         ENDIF
!
!  CREATE NEW FOCK MATRIX
!
        call zerom (f, norbs)
        call ffreq2 (f, d, w)
        call ffreq1 (f, d, da, da, norbs)
        call zerom (da, norbs)
        call hplusf (f, da, norbs)
        do while(.not.last)
          icount = icount + 1
          if (icount >= maxitu) last = .TRUE.
!
!  CREATE G MATRIX.
!
          call transf (f, g, c, norbs)
!
!  FORM U MATRIX
!
          call bmakuf (ua, ub, uab, t, uold1, g, eigs, last, norbs, nclose, &
            diff, iwflb, maxu, btol)
!
!  FORM NEW DENSITY MATRIX
!
          call bdenup (x, uab, c, d, da, norbs, nclose)
!...
! COMPUTE TEST BETA
!
          betaw = aval(h1,d,norbs)
!         IF (LAST.OR.(ICOUNT.GT.(MAXITU-5))) THEN
!             WRITE(IW,1500) ICOUNT,DELA,MAXU,DIFF
! 1500        FORMAT(' ',I4,'  DELTA BETA = ', D12.5,
!     X       ' MAXU = ', D12.5, '  UDIFF = ', D12.5)
!         ENDIF
!
!  CREATE NEW FOCK MATRIX
!
          call zerom (f, norbs)
          call ffreq2 (f, d, w)
          call ffreq1 (f, d, da, da, norbs)
          call zerom (da, norbs)
          call hplusf (f, da, norbs)
!..............................................................
        end do
        cmptim = seconds(1) - cmptim
        if (debug) write (iw, 40) icount, cmptim
   40   format(/,' CONVERGED IN',i4,' ITERATIONS IN',f10.2,' SECONDS')
        if (debug) write (iw, 50) maxu, diff
   50   format(' MAXIMUM UAB ELEMENT =',1f15.5,',  MAXIMUM DIFFERENCE =',1f15.5&
          ,/)
!
! COMPUTE BETA
!
!        CALL HMUF(H1,ID,COORD,NFIRST,NLAST,NAT,NORBS,NUMAT)
!        BETAW = AVAL(H1,D,NORBS)
!        WRITE(IW,2000) ALAB(ID),ALAB(ID),ALAB(ID),BETAW
!2000    FORMAT('BETA(',A1,',',A1,','A1,') = ',D12.5)
!
!  COMPUTE OTHER COMPONENTS
!
        do ic = 1, 3
          call hmuf (h1, ic, coord, nfirst, nlast, nat, norbs, numat)
          betaw = aval(h1,d,norbs)
          allbet(ic,ia,ib) = betaw
          if (debug) write (iw, 60) alab(ic), alab(ia), alab(ib), betaw
   60     format('      BETA(',a1,',',a1,',',a1,') = ',1f15.5)
!
! CALCULATE AVERAGE BETA IN THE X-DIRECTION
!
          if (id==1 .and. ic==1) then
            bavx = bavx + 3.0D0*betaw
          else if (id==2 .and. ic==2) then
            bavx = bavx + 2.0D0*betaw
          else if (id==3 .and. ic==3) then
            bavx = bavx + 2.0D0*betaw
          else if ((id==4 .or. id==6) .and. ic==1) then
            bavx = bavx + betaw
          end if
! CALCULATES AVERAGE BETA IN THE Y-DIRECTION
          if (id==4 .and. ic==2) then
            bavy = bavy + 3.0D0*betaw
          else if (id==2 .and. ic==1) then
            bavy = bavy + 2.0D0*betaw
          else if (id==5 .and. ic==3) then
            bavy = bavy + 2.0D0*betaw
          else if ((id==1 .or. id==6) .and. ic==2) then
            bavy = bavy + betaw
          end if
! CALCULATES AVERAGE BETA IN THE Z-DIRECTION
          if (id==6 .and. ic==3) then
            bavz = bavz + 3.0D0*betaw
          else if (id==3 .and. ic==1) then
            bavz = bavz + 2.0D0*betaw
          else if (id==5 .and. ic==2) then
            bavz = bavz + 2.0D0*betaw
          else if ((id==4 .or. id==1) .and. ic==3) then
            bavz = bavz + betaw
          end if
        end do
!
!
! CALL SUBROUTINE TO CALCULATE EPSILON AND UMINUS OMEGA,OMEGA
!  EPSILON IN H1 AND UMINUS IN DA
        call epsab (h1, eigs, g, ga, gb, ua, ub, uab, da, norbs, nclose, iwflb)
        call dawrit (uab, maxsq, iposu + id)
        call dawrit (g, maxsq, iposg + id)
        call dawrit (h1, maxsq, ipose + id)
        call dawrit (da, maxsq, iposum + id)
      end do
      write (iw, '(30X,''COMPONENTS OF BETA'')')
      bavx = bavx/5.0D+00
      bavy = bavy/5.0D+00
      bavz = bavz/5.0D+00
! CALCULATES AVERAGE BETA
      bvec = (bavx*bavx + bavy*bavy + bavz*bavz)**0.5D+00
      if (bvec < 0.999d5) then
        line = "(3X,a,6F12.5)"
      else
        line = "(3X,a,6g12.4)"
      end if
      write (iw, &
      '(12X,''*XX'', 9X,''*XY'', 9X,''*YY'', 9X,               ''*XZ'', 9X,''*Y&
      &Z'', 9X,''*ZZ'')')
      write (iw, trim(line)) "*=X", ((allbet(1,i,j),i=1,j),j=1,3)
      write (iw, trim(line)) "*=Y", ((allbet(2,i,j),i=1,j),j=1,3)
      write (iw, trim(line)) "*=Z", ((allbet(3,i,j),i=1,j),j=1,3)
!
!
      if (bvec < 1.d10) then
        line = "(' AVERAGE BETA',a,'(SHG) VALUE AT',f10.5,' EV = ',f15.4,a,g14.6,a)"
      else
        line = "(' AVERAGE BETA',a,'(SHG) VALUE AT',f10.5,' EV = ',g13.6,a,g14.6,a)"
      end if
      write (iw,"(/)")
      write (iw, trim(line)) "X", omega, bavx, " a.u. =", bavx*au_to_esu, " ESU"
      write (iw, trim(line)) "Y", omega, bavy, " a.u. =", bavy*au_to_esu, " ESU"
      write (iw, trim(line)) "Z", omega, bavz, " a.u. =", bavz*au_to_esu, " ESU"
      write (iw,"(2/)")
      write (iw, trim(line)) " ", omega, bvec, " a.u. =", bvec*au_to_esu, " ESU"
      write (iw, "(a)") "   (1 a.u. = 8.639418X10-33 esu)"
      write (iw,"(/)")
      return
      end subroutine betaf


      subroutine betal1(u0a, g0a, u1b, g1b, u1c, g1c, nclose, norbs, term)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!
! THIS SUBROUTINE CALCULATES THE TRACE OF UGU MATRICES
!
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: nclose
      integer  :: norbs
      double precision , intent(out) :: term
      double precision  :: u0a(norbs,norbs)
      double precision  :: g0a(norbs,norbs)
      double precision  :: u1b(norbs,norbs)
      double precision  :: g1b(norbs,norbs)
      double precision  :: u1c(norbs,norbs)
      double precision  :: g1c(norbs,norbs)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      double precision :: t1a, t2a, t3a, t4a, t5a, t6a, t1b, t2b, t3b, t4b, t5b, &
        t6b
        double precision, external :: trugud, trudgu, trugdu
!-----------------------------------------------
      t1a = trugud(u0a,g1b,u1c,nclose,norbs,norbs)
      t2a = trudgu(u1c,g1b,u0a,nclose,norbs,norbs)
      t3a = trugdu(u1b,g1c,u0a,nclose,norbs,norbs)
      t4a = trugdu(u0a,g1c,u1b,nclose,norbs,norbs)
      t5a = trudgu(u1c,g0a,u1b,nclose,norbs,norbs)
      t6a = trugud(u1b,g0a,u1c,nclose,norbs,norbs)
      t1b = trugud(u0a,g1b,u1c,norbs,nclose,norbs)
      t2b = trudgu(u1c,g1b,u0a,norbs,nclose,norbs)
      t3b = trugdu(u1b,g1c,u0a,norbs,nclose,norbs)
      t4b = trugdu(u0a,g1c,u1b,norbs,nclose,norbs)
      t5b = trudgu(u1c,g0a,u1b,norbs,nclose,norbs)
      t6b = trugud(u1b,g0a,u1c,norbs,nclose,norbs)
      term = t1b - t1a + t2b - t2a + t3a - t3b + t4a - t4b + t5b - t5a + t6b - &
        t6a
      return
      end subroutine betal1


      subroutine betall(u2a, g2a, u1b, g1b, u1c, g1c, nclose, norbs, term)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!
! THIS SUBROUTINE CALCULATES TRACE OF UGU MATRICES
! WHEN A,B,C DIRECTIONS ARE DIFFERENT
!
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: nclose
      integer  :: norbs
      double precision , intent(out) :: term
      double precision  :: u2a(norbs,norbs)
      double precision  :: g2a(norbs,norbs)
      double precision  :: u1b(norbs,norbs)
      double precision  :: g1b(norbs,norbs)
      double precision  :: u1c(norbs,norbs)
      double precision  :: g1c(norbs,norbs)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      double precision :: t1a, t2a, t3a, t4a, t5a, t6a, t1b, t2b, t3b, t4b, t5b, &
        t6b
      double precision, external :: trugud, trudgu, trugdu
!-----------------------------------------------
      t1a = trudgu(u2a,g1b,u1c,nclose,norbs,norbs)
      t2a = trugud(u1c,g1b,u2a,nclose,norbs,norbs)
      t3a = trugud(u1b,g1c,u2a,nclose,norbs,norbs)
      t4a = trudgu(u2a,g1c,u1b,nclose,norbs,norbs)
      t5a = trugdu(u1c,g2a,u1b,nclose,norbs,norbs)
      t6a = trugdu(u1b,g2a,u1c,nclose,norbs,norbs)
      t1b = trudgu(u2a,g1b,u1c,norbs,nclose,norbs)
      t2b = trugud(u1c,g1b,u2a,norbs,nclose,norbs)
      t3b = trugud(u1b,g1c,u2a,norbs,nclose,norbs)
      t4b = trudgu(u2a,g1c,u1b,norbs,nclose,norbs)
      t5b = trugdu(u1c,g2a,u1b,norbs,nclose,norbs)
      t6b = trugdu(u1b,g2a,u1c,norbs,nclose,norbs)
      term = t1b - t1a + t2b - t2a + t3b - t3a + t4b - t4a + t5a - t5b + t6a - &
        t6b
      return
      end subroutine betall


      subroutine betcom(u1, g1, u2, g2, nclose, norbs, term)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!
! THIS SUBROUTINE CALCULATES TRACE OF UGU MATRICES
!
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: nclose
      integer  :: norbs
      double precision , intent(out) :: term
      double precision  :: u1(norbs,norbs)
      double precision  :: g1(norbs,norbs)
      double precision  :: u2(norbs,norbs)
      double precision  :: g2(norbs,norbs)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      double precision :: t1a, t2a, t3a, t1b, t2b, t3b
      double precision, external :: trugud, trudgu, trugdu
!-----------------------------------------------
      t1a = trudgu(u2,g1,u1,nclose,norbs,norbs)
      t2a = trugud(u1,g1,u2,nclose,norbs,norbs)
      t3a = trugdu(u1,g2,u1,nclose,norbs,norbs)
      t1b = trudgu(u2,g1,u1,norbs,nclose,norbs)
      t2b = trugud(u1,g1,u2,norbs,nclose,norbs)
      t3b = trugdu(u1,g2,u1,norbs,nclose,norbs)
      term = 2.0D0*(t1b - t1a + t2b - t2a + t3a - t3b)
      return
      end subroutine betcom


      subroutine bmakuf(ua, ub, uab, t, uold1, gab, eigs, last, norbs, nclose, &
        diff, iwflb, maxu, btol)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use funcon_C, only : ev
      USE polar_C, only : omega
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: norbs
      integer , intent(in) :: nclose
      integer , intent(in) :: iwflb
      double precision , intent(out) :: diff
      double precision , intent(out) :: maxu
      double precision , intent(in) :: btol
      logical , intent(out) :: last
      double precision , intent(in) :: ua(norbs,norbs)
      double precision , intent(in) :: ub(norbs,norbs)
      double precision , intent(inout) :: uab(norbs,norbs)
      double precision , intent(in) :: t(norbs,norbs)
      double precision , intent(inout) :: uold1(norbs,norbs)
      double precision , intent(in) :: gab(norbs,norbs)
      double precision , intent(in) :: eigs(norbs)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j, kll, kul, k, l
      double precision :: hartr, sum, udif
!-----------------------------------------------
!
!  THIS SUBROUTINE CREATES THE NEW TRANSFORMATION MATRIX U
!  AND THEN CHECKS FOR CONVERGENCE
!
      hartr = ev
!
!  ZERO MATRIX INITIALLY
!      CALL ZEROM(UAB,NORBS)
!
!  CREATE DIAGONAL BLOCKS (OCC,OCC) AND (UNOCC,UNOCC)
!
      kll = 0
      kul = 0
      do i = 1, norbs
        do j = 1, i
          sum = 0.0D00
          if (i <= nclose) then
            kll = nclose + 1
            kul = norbs
          else if (i>nclose .and. j>nclose) then
            kll = 1
            kul = nclose
          end if
          do k = kll, kul
            sum = sum + ua(i,k)*ub(k,j) + ub(i,k)*ua(k,j)
          end do
          uab(i,j) = sum*0.5D00
          uab(j,i) = sum*0.5D00
        end do
      end do
!
!  CREATE OFF-DIAGONAL BLOCKS
!
      do k = nclose + 1, norbs
        do l = 1, nclose
          select case (iwflb)
! CALCULATE FOR (W,W) VALUES
!
          case default
            uab(k,l) = hartr*((gab(k,l)+t(k,l))/((eigs(l)-eigs(k))-2.0D00*omega&
              ))
            uab(l,k) = hartr*((gab(l,k)+t(l,k))/((eigs(k)-eigs(l))-2.0D00*omega&
              ))
! CALCULATE FOR (0,W) VALUES
!
          case (2)
            uab(k,l) = hartr*((gab(k,l)+t(k,l))/((eigs(l)-eigs(k))-omega))
            uab(l,k) = hartr*((gab(l,k)+t(l,k))/((eigs(k)-eigs(l))-omega))
! CALCULATE FOR (W,-W) VALUES
!
          case (3)
            uab(k,l) = hartr*((gab(k,l)+t(k,l))/(eigs(l)-eigs(k)))
            uab(l,k) = hartr*((gab(l,k)+t(l,k))/(eigs(k)-eigs(l)))
          end select
        end do
      end do
!
!  CHECK FOR CONVERGENCE
!
      diff = 0.0D00
      maxu = -1000
      do i = 1, norbs
        do j = 1, norbs
          udif = uab(i,j) - uold1(i,j)
          diff = dmax1(abs(udif),diff)
          maxu = dmax1(uab(i,j),maxu)
        end do
      end do
      if (diff < btol) last = .TRUE.
!
      uold1 = uab
!
      return
      end subroutine bmakuf


      subroutine copym(h, f, m)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: m
      double precision , intent(in) :: h(m,m)
      double precision , intent(out) :: f(m,m)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
!-----------------------------------------------
!
!  COPYM COPIES MATRIX H INTO F
!

! GBR_new_addition
! ORG      f = h
      call dlacpy('u', m, m, h, m, f, m )
!
      return
      end subroutine copym


      subroutine darea1(v, len, idaf, ns)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: len
      integer , intent(in) :: idaf
      integer , intent(in) :: ns
      double precision  :: v(len)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
!-----------------------------------------------
!
!       READ A PHYSICAL RECORD FROM THE DAF
!
      read (unit=idaf, rec=ns) v
      return
      end subroutine darea1


      subroutine daread(v, len, nrec)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use chanel_C, only : iw, idaf, ioda, irecln
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: len
      integer , intent(in) :: nrec
      double precision  :: v(len)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: n, is, ns, lent, if, nsp, lenw
!-----------------------------------------------
!
      n = ioda(nrec)
      if (n /= (-1)) then
        is = (-irecln) + 1
        ns = n
        lent = len
        is = is + irecln
        if = is + lent - 1
        if (if - is + 1 > irecln) if = is + irecln - 1
        nsp = ns
        lenw = if - is + 1
        call darea1 (v(is), lenw, idaf, nsp)
        lent = lent - irecln
        ns = ns + 1
        n = ns
        do while(lent >= 1)
          is = is + irecln
          if = is + lent - 1
          if (if - is + 1 > irecln) if = is + irecln - 1
          nsp = ns
          lenw = if - is + 1
          call darea1 (v(is), lenw, idaf, nsp)
          lent = lent - irecln
          ns = ns + 1
          n = ns
        end do
        return
      end if
!
      write (iw, 30) nrec, len
      call mopend (&
        '*** ERROR ***, ATTEMPT TO READ A DAF RECORD THAT WAS NEVER WRITTEN')
!
   30 format(1x,'*** ERROR ***, ATTEMPT TO READ A DAF RECORD',&
        ' THAT WAS NEVER WRITTEN. NREC,LEN=',i5,i10)
      return
      end subroutine daread


      subroutine dawrit(v, len, nrec)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use chanel_C, only : ioda, ifilen, irecst, idaf, irecln, iw
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: len
      integer , intent(in) :: nrec
      double precision  :: v(len)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: n, ist, ns, lent, if, nsp, lenw
      logical :: newrec
!-----------------------------------------------
      n = ioda(nrec)
      if (n<=0 .or. len==ifilen(nrec)) then
        newrec = .FALSE.
        if (n <= 0) then
          ioda(nrec) = irecst
          ifilen(nrec) = len
          newrec = .TRUE.
          irecst = irecst + (len - 1)/irecln + 1
          n = ioda(nrec)
        end if
        ist = (-irecln) + 1
        ns = n
        lent = len
        ist = ist + irecln
        if = ist + lent - 1
        if (if - ist + 1 > irecln) if = ist + irecln - 1
        nsp = ns
        lenw = if - ist + 1
        call dawrt1 (v(ist), lenw, idaf, nsp)
        lent = lent - irecln
        ns = ns + 1
        n = ns
        do while(lent >= 1)
          ist = ist + irecln
          if = ist + lent - 1
          if (if - ist + 1 > irecln) if = ist + irecln - 1
          nsp = ns
          lenw = if - ist + 1
          call dawrt1 (v(ist), lenw, idaf, nsp)
          lent = lent - irecln
          ns = ns + 1
          n = ns
        end do
        if (newrec) write (unit=idaf, rec=1) irecst, ioda, ifilen
        return
      end if
!
      write (iw, 40) nrec, len, ifilen(nrec)
      call mopend (&
      'DAWRIT HAS REQUESTED A RECORD WITH LENGTH DIFFERENT THAN BEFORE - ABORT &
      &FORCED.')
!
   40 format(1x,'DAWRIT HAS REQUESTED A RECORD WITH LENGTH',1x,&
        'DIFFERENT THAN BEFORE - ABORT FORCED.'/,1x,'DAF RECORD ',i5,&
        ' NEW LENGTH =',i5,' OLD LENGTH =',i5)
      return
      end subroutine dawrit


!*MODULE IOLIB   *DECK DAWRT1
      subroutine dawrt1(v, len, idaf, ns)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: len
      integer , intent(in) :: idaf
      integer , intent(in) :: ns
      double precision , intent(in) :: v(len)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
!-----------------------------------------------
!
!     ----- WRITE A PHYSICAL RECORD ON THE DAF -----
!
      write (unit=idaf, rec=ns) v
      return
      end subroutine dawrt1


      subroutine densf(u, c, d, da, norbs, nclose, w2)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!
!***********************************************************************
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: norbs
      integer , intent(in) :: nclose
      double precision , intent(in) :: u(norbs,norbs)
      double precision , intent(in) :: c(norbs,norbs)
      double precision , intent(out) :: d(norbs,norbs)
      double precision , intent(out) :: da(norbs,norbs)
      double precision , intent(inout) :: w2(norbs,norbs)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: j, k, l, i
      double precision, dimension(norbs) :: w1
      double precision :: sum
!-----------------------------------------------
!
!  THIS SUBROUTINE IS USED TO COMPUTE THE FIRST-ORDER DENSITY
!  FROM CA = C*U
!
!
!  FORM DENSITY MATRIX      CA*N*C+ + C*N*CA+
!
      do j = 1, norbs
        do k = 1, norbs
          sum = 0.D0
          do l = 1, nclose
            sum = sum + u(k,l)*c(j,l)
          end do
          w2(k,j) = sum
        end do
      end do
      do i = 1, norbs
        do k = 1, norbs
          sum = 0.D0
          do l = 1, nclose
            sum = sum + c(i,l)*u(l,k)
          end do
          w1(k) = sum
        end do
        do j = 1, norbs
          sum = 0.0D00
          do k = 1, norbs
            sum = sum + c(i,k)*w2(k,j) - w1(k)*c(j,k)
          end do
          d(i,j) = 2.0D00*sum
          da(i,j) = sum
        end do
      end do
!
      return
      end subroutine densf


      subroutine epsab(eigsab, eigs, gab, ga, gb, ua, ub, uab, udms, norbs, &
        nclose, iwflb)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use funcon_C, only : ev
      USE polar_C, only : omega
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: norbs
      integer , intent(in) :: nclose
      integer , intent(in) :: iwflb
      double precision  :: eigsab(norbs,norbs)
      double precision , intent(in) :: eigs(norbs)
      double precision , intent(in) :: gab(norbs,norbs)
      double precision , intent(in) :: ga(norbs,norbs)
      double precision , intent(in) :: gb(norbs,norbs)
      double precision , intent(in) :: ua(norbs,norbs)
      double precision , intent(in) :: ub(norbs,norbs)
      double precision , intent(in) :: uab(norbs,norbs)
      double precision  :: udms(norbs,norbs)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j
      double precision :: hartr, omval, s1, s2
!-----------------------------------------------
!
!  THIS SUBROUTINE CREATES THE NEW EPSILON MATRIX AND UDMS MATRIX
!
      hartr = ev
      omval = 0.d0
!
!  ZERO EPSILON OMEGA OMEGA MATRIX INITIALLY
!
      call zerom (eigsab, norbs)
!
!  ZERO UAB MINUS OMEGA,OMEGA MATRIX INITIALLY
!
      call zerom (udms, norbs)
!
      if (iwflb==0 .or. iwflb==1) then
        omval = 2.0D00*omega
      else if (iwflb == 3) then
        omval = 0.0D00
      else if (iwflb == 2) then
        omval = omega
      end if
      do i = 1, nclose
        do j = 1, nclose
          s1 = 0.0D00
!
! CALCULATION FOR EPSAB
!
          s1 = sum(ga(i,nclose+1:norbs)*ub(nclose+1:norbs,j)+gb(i,nclose+1:&
            norbs)*ua(nclose+1:norbs,j))
!
          eigsab(i,j) = gab(i,j) + s1 + uab(i,j)*(eigs(i)-eigs(j)+omval)/hartr
        end do
      end do
!
! CALCULATION FOR UMS
!
      do i = 1, norbs
        do j = 1, norbs
          s2 = 0.0D00
          s2 = sum(ua(i,:norbs)*ub(:norbs,j)+ub(i,:norbs)*ua(:norbs,j))
!
          udms(i,j) = s2 - uab(i,j)
        end do
      end do
!
      return
      end subroutine epsab


      subroutine ffreq1(f, ptot, pa, pb, ndim)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE parameters_C, only : gss, gsp, gpp, gp2, hsp
      use common_arrays_C, only : nat, nfirst, nlast
      use molkst_C, only : numat
!***********************************************************************
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: ndim
      double precision , intent(inout) :: f(ndim,ndim)
      double precision , intent(in) :: ptot(ndim,ndim)
      double precision , intent(in) :: pa(ndim,ndim)
      double precision , intent(in) :: pb(ndim,ndim)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: ii, ia, ib, ni, iplus, j, iminus, icc
      double precision :: ptpop, papop
      logical :: first

      save first
!-----------------------------------------------
! *********************************************************************
!
! *** COMPUTE THE REMAINING CONTRIBUTIONS TO THE ONE-CENTRE ELEMENTS.
!
! *********************************************************************
      data first/ .TRUE./
      if (first) first = .FALSE.
      do ii = 1, numat
        ia = nfirst(ii)
        ib = min(nlast(ii), ia + 3)
        ni = nat(ii)
        ptpop = 0.D0
        papop = 0.D0
        go to (1002,20,10,10,10,10,10,10,10,10) ib - ia + 2
   10   continue
        ptpop = ptot(ib,ib) + ptot(ib-1,ib-1) + ptot(ib-2,ib-2)
        papop = pa(ib,ib) + pa(ib-1,ib-1) + pa(ib-2,ib-2)
   20   continue
!
!     F(S,S)
!
        f(ia,ia) = f(ia,ia) + pb(ia,ia)*gss(ni) + ptpop*gsp(ni) - papop*hsp(ni)
        if (ni >= 3) then
          iplus = ia + 1
          do j = iplus, ib
!
!     F(P,P)
!
            f(j,j) = f(j,j) + ptot(ia,ia)*gsp(ni) - pa(ia,ia)*hsp(ni) + pb(j,j)&
              *gpp(ni) + (ptpop - ptot(j,j))*gp2(ni) - 0.5D0*(papop - pa(j,j))*&
              (gpp(ni)-gp2(ni))
!
!     F(S,P)
!
            f(ia,j) = f(ia,j) + 2.D0*ptot(ia,j)*hsp(ni) - pa(ia,j)*(hsp(ni)+gsp&
              (ni))
            f(j,ia) = f(j,ia) + 2.D0*ptot(j,ia)*hsp(ni) - pa(j,ia)*(hsp(ni)+gsp&
              (ni))
          end do
!
!     F(P,P*)
!
          iminus = ib - 1
          do j = iplus, iminus
            icc = j + 1
            f(j,icc:ib) = f(j,icc:ib) + ptot(j,icc:ib)*(gpp(ni)-gp2(ni)) - &
              0.5D0*pa(j,icc:ib)*(gpp(ni)+gp2(ni))
            f(icc:ib,j) = f(icc:ib,j) + ptot(icc:ib,j)*(gpp(ni)-gp2(ni)) - &
              0.5D0*pa(icc:ib,j)*(gpp(ni)+gp2(ni))
          end do
        end if
 1002   continue
      end do
      return
      end subroutine ffreq1


      subroutine ffreq2(f, ptot, w)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE molkst_C, only : numat, norbs
      use common_arrays_C, only : nfirst, nlast
!***********************************************************************
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision , intent(inout) :: f(norbs,norbs)
      double precision , intent(in) :: ptot(norbs,norbs)
      double precision , intent(in) :: w(*)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: ii, iim1, ia, ib, jj, ja, jb, i, j, k, l, kk
      double precision :: fij, fkl, a, aint
!-----------------------------------------------
!*******************************************************************
!
!  TDHF FORMS TWO ELECTRON TWO CENTER REPULSION PART OF THE FOCK
!  MATRIX
! ON INPUT PTOT = TOTAL DENSITY MATRIX
!          P    = ALPHA OR BETA DENSITY MATRIX
!          W    = TWO ELECTRON INTEGRAL MATRIX
!
!  ON OUTPUT F = PARTIAL FOCK MATRIX
!
!********************************************************************

        kk = 0
!
        do ii = 1, numat
          iim1 = ii - 1
          ia = nfirst(ii)
          ib = nlast(ii)
          do jj = 1, iim1
            ja = nfirst(jj)
            jb = nlast(jj)
            do i = ia, ib
              do j = ia, i
                fij = 1.0D00
                if (i == j) fij = 0.5D00
                do k = ja, jb
                  do l = ja, k
                    fkl = 1.0D00
                    if (k == l) fkl = 0.5D00
                    kk = kk + 1
                    a = w(kk)
                    aint = a*fkl*fij
                    f(i,j) = f(i,j) + aint*(ptot(k,l)+ptot(l,k))
                    f(j,i) = f(j,i) + aint*(ptot(k,l)+ptot(l,k))
                    f(k,l) = f(k,l) + aint*(ptot(i,j)+ptot(j,i))
                    f(l,k) = f(l,k) + aint*(ptot(i,j)+ptot(j,i))
                    aint = aint*0.5D00
                    f(i,l) = f(i,l) - aint*ptot(j,k)
                    f(l,i) = f(l,i) - aint*ptot(k,j)
                    f(k,j) = f(k,j) - aint*ptot(l,i)
                    f(j,k) = f(j,k) - aint*ptot(i,l)
                    f(i,k) = f(i,k) - aint*ptot(j,l)
                    f(k,i) = f(k,i) - aint*ptot(l,j)
                    f(j,l) = f(j,l) - aint*ptot(i,k)
                    f(l,j) = f(l,j) - aint*ptot(k,i)
                  end do
                end do
              end do
            end do
          end do
          kk = kk + (((ib - ia +1 )*(ib - ia + 2))/2) **2
        end do
      return
      end subroutine ffreq2


      subroutine fhpatn(a, b, norbs, itw, sign)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: norbs
      integer , intent(in) :: itw
      double precision , intent(in) :: sign
      double precision , intent(out) :: a(norbs,norbs)
      double precision , intent(in) :: b(norbs,norbs)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
!-----------------------------------------------
!
! THIS SUBROUTINE CONVERTS THE MATRICES INTO ITS ADJOINTS
!
      go to (10,40,40,10) itw
   10 continue
      a = b
      go to 70
   40 continue
      a = transpose(sign*b)
   70 continue
      return
      end subroutine fhpatn


      subroutine hmuf(h1, id, coord, nfirst, nlast, nat, norbs, numat)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE parameters_C, only : dd
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: id
      integer  :: norbs
      integer , intent(in) :: numat
      integer , intent(in) :: nfirst(numat)
      integer , intent(in) :: nlast(numat)
      integer , intent(in) :: nat(numat)
      double precision  :: h1(norbs,norbs)
      double precision , intent(in) :: coord(3,*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, ia, ib, ni, i1, j1, io1, jo1
!-----------------------------------------------
!
!  FORM THE DIPOLE MOMENT MATRIX FOR COMPONENT ID
!
!
!  ZERO H1 MATRIX
!
      call zerom (h1, norbs)
!
!  FORM DIPOLE MATRIX
!
      do i = 1, numat
        ia = nfirst(i)
        ib = min(nlast(i), ia + 3)
        ni = nat(i)
        do i1 = ia, ib
          do j1 = ia, i1
            h1(i1,j1) = 0.0D00
            io1 = i1 - ia
            jo1 = j1 - ia
            if (id==1 .and. jo1==0 .and. io1==1) then
              h1(i1,j1) = dd(ni)
              h1(j1,i1) = dd(ni)
            end if
            if (id==2 .and. jo1==0 .and. io1==2) then
              h1(i1,j1) = dd(ni)
              h1(j1,i1) = dd(ni)
            end if
            if (.not.(id==3 .and. jo1==0 .and. io1==3)) cycle
            h1(i1,j1) = dd(ni)
            h1(j1,i1) = dd(ni)
          end do
          h1(i1,i1) = 0.0D00
!.. ADDED FOR TRANSLATION OF CENTER FROM ORIGIN
          h1(i1,i1) = h1(i1,i1) + 1.8897262D0*coord(id,i)
        end do
      end do
!
      return
      end subroutine hmuf


      subroutine hplusf(f, h, norbs)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use funcon_C, only : ev
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: norbs
      double precision , intent(inout) :: f(norbs,norbs)
      double precision , intent(in) :: h(norbs,norbs)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      double precision :: hartr
!-----------------------------------------------
!
! HPLUSF ADDS THE 1 AND 2-ELECTRON PARTS OF THE FOCK MATRIX
!
      hartr = ev
      f = h + f/hartr
      return
      end subroutine hplusf


      subroutine makeuf(u, uold, g, eigs, last, norbs, nclose, diff, atol)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use funcon_C, only : ev
       USE polar_C, only : omega
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: norbs
      integer , intent(in) :: nclose
      double precision , intent(out) :: diff
      double precision , intent(in) :: atol
      logical , intent(out) :: last
      double precision  :: u(norbs,norbs)
      double precision , intent(inout) :: uold(norbs,norbs)
      double precision , intent(in) :: g(norbs,norbs)
      double precision , intent(in) :: eigs(norbs)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: k, i, j
      double precision :: hartr, udif
!-----------------------------------------------
!
!  THIS SUBROUTINE CREATES THE NEW TRANSFORMATION MATRIX U
!  AND THEN CHECKS FOR CONVERGENCE
!
      hartr = ev
!
!  ZERO MATRIX INITIALLY
!
      call zerom (u, norbs)
!
!  CREATE OFF-DIAGONAL BLOCKS
!
     do k = nclose + 1, norbs
      do i = 1, nclose
        u(i, k) = hartr * g(i, k) / (eigs(k)-eigs(i)-omega)
        u(k, i) = hartr * g(k, i) / (eigs(i)-eigs(k)-omega)
      end do
    end do
!
!  CHECK FOR CONVERGENCE
!
      diff = 0.0D00
      do i = 1, norbs
        do j = 1, norbs
          udif = abs(u(i,j)-uold(i,j))
          diff = dmax1(udif,diff)
        end do
      end do
      if (diff < atol) last = .TRUE.
!
      uold(:norbs,:norbs) = u(:norbs,:norbs)
!
      return
      end subroutine makeuf


      subroutine ngamtg(x, gd3, ud3, g1, u1, gs, usmd, eps, us)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : norbs, nclose
      use chanel_C, only : iw
       USE polar_C, only : omega
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision  :: x(norbs,norbs)
      double precision  :: gd3(norbs,norbs)
      double precision  :: ud3(norbs,norbs)
      double precision  :: g1(norbs,norbs)
      double precision  :: u1(norbs,norbs)
      double precision  :: gs(norbs,norbs)
      double precision  :: usmd(norbs,norbs)
      double precision  :: eps(norbs,norbs)
      double precision  :: us(norbs,norbs)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(9) :: ida, idb, idc, idd
      integer , dimension(3,3) :: ipair
      integer :: msq, jgarc, juarc, jurec, jgrec, jg2rec, ju2rec, ju2mrc, &
        jeprec, ie, ia, ib, ic, id, icd, ibd, ibc, imove, j2, j34
      double precision, dimension(9) :: gamma
      double precision :: one, gav, yy, gave
      character, dimension(3) :: alab
      double precision, external :: trsub

      save alab, ida, idb, idc, idd, ipair
!-----------------------------------------------
!.....................................................................
!  CALCULATE GAMMA(THG) IN A NONITERATIVE FASHION
!.....................................................................
      data alab/ 'X', 'Y', 'Z'/
      data ida/ 1, 2, 3, 1, 1, 2, 2, 3, 3/
      data idb/ 1, 2, 3, 1, 1, 2, 2, 3, 3/
      data idc/ 1, 2, 3, 2, 3, 1, 3, 1, 2/
      data idd/ 1, 2, 3, 2, 3, 1, 3, 1, 2/
      data ipair/ 1, 2, 3, 2, 4, 5, 3, 5, 6/
      one = 1.D0
      msq = norbs*norbs
      write (iw, 20) omega
   20 format(/,/,' GAMMA (THIRD HARMONIC GENERATION) AT ',f10.5,' EV.'/,/)
!
! IGAM=1 (THIRD HARMONIC GENERATION)
!
      jgarc = 22
      juarc = 19
      jurec = 7
      jgrec = 10
      jg2rec = 55
      ju2rec = 49
      ju2mrc = 67
      jeprec = 61
!
! LOOP BEGINS FOR THE CALCULATION OF GAMMA(ABCD)
!
      gav = 0.0D+00
      do ie = 1, 9
!
        ia = ida(ie)
        ib = idb(ie)
        ic = idc(ie)
        id = idd(ie)
        icd = ipair(ic,id)
        ibd = ipair(ib,id)
        ibc = ipair(ib,ic)
!
!  READ IN THE FIRST ORDER U3 OMEGA AND G3 OMEGA IN THE DIRECTION A
!
! MAKE GD3 OMEGA MATRIX FROM G3 MATRIX
!
        call daread (x, msq, jgarc + ia)
        call fhpatn (gd3, x, norbs, 2, one)
!
! MAKE UD3 OMEGA MATRIX FROM U3 OMEGA MATRIX
!
        call daread (x, msq, juarc + ia)
        call fhpatn (ud3, x, norbs, 2, (-one))
!
        yy = 0.0D00
        imove = 1
   30   continue
!
        select case (imove)
!
        case default
          j2 = ib
          j34 = icd
        case (2)
          j2 = ic
          j34 = ibd
        case (3)
          j2 = id
          j34 = ibc
        end select
!
!  READ IN G1,U1,GS,US,UMS,EPS
!
!  GET  UB
        call daread (u1, msq, jurec + j2)
!  GET  GB
        call daread (g1, msq, jgrec + j2)
!  GET  GCD
        call daread (gs, msq, jg2rec + j34)
!  GET  UCD
        call daread (us, msq, ju2rec + j34)
!  GET  USMD
        call daread (usmd, msq, ju2mrc + j34)
!  GET  EPCD
        call daread (eps, msq, jeprec + j34)
!
!
! FIRST KIND
!
        yy = yy + trsub(ud3,g1,us,nclose,norbs,norbs)
        yy = yy - trsub(usmd,g1,ud3,nclose,norbs,norbs)
        yy = yy - trsub(ud3,g1,us,norbs,nclose,norbs)
        yy = yy + trsub(usmd,g1,ud3,norbs,nclose,norbs)
!
! SECOND KIND
!
        yy = yy + trsub(ud3,gs,u1,nclose,norbs,norbs)
        yy = yy + trsub(u1,gs,ud3,nclose,norbs,norbs)
        yy = yy - trsub(ud3,eps,u1,norbs,nclose,norbs)
        yy = yy - trsub(u1,eps,ud3,norbs,nclose,norbs)
!
! THIRD KIND
!
        yy = yy + trsub(u1,gd3,us,nclose,norbs,norbs)
        yy = yy - trsub(usmd,gd3,u1,nclose,norbs,norbs)
        yy = yy - trsub(u1,gd3,us,norbs,nclose,norbs)
        yy = yy + trsub(usmd,gd3,u1,norbs,nclose,norbs)
!
        imove = imove + 1
        if (imove <= 3) go to 30
!
        gamma(ie) = yy
!
! CALCULATE THE AVERAGE GAMMA VALUE
!
        gav = gav + yy
!
! WRITE GAMMA(ABCD)
!
        write (iw,"(' GAMMA(',a1,',',a1,',',a1,',',a1,') = ',f19.5)") &
        alab(ia), alab(ib), alab(ic), alab(id), gamma(ie)
      end do
      gave = gav/5.0D+00
      write (iw, "(/,/,' AVERAGE GAMMA VALUE AT ',f10.5,' = ',f19.5,a,f19.5,a,/,/)") &
      omega, gave, " a.u. =", gave/1.985425939776565, " ESU (X10-39)"
      return
      end subroutine ngamtg


      subroutine ngefis(x, gd3, ud3, g1, u1, gs, usmd, eps, us)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : norbs, nclose
      use chanel_C, only : iw
       USE polar_C, only : omega
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision  :: x(norbs,norbs)
      double precision  :: gd3(norbs,norbs)
      double precision  :: ud3(norbs,norbs)
      double precision  :: g1(norbs,norbs)
      double precision  :: u1(norbs,norbs)
      double precision  :: gs(norbs,norbs)
      double precision  :: usmd(norbs,norbs)
      double precision  :: eps(norbs,norbs)
      double precision  :: us(norbs,norbs)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(15) :: ida, idb, idc, idd
      integer , dimension(3,3) :: ip, ipair
      integer :: msq, jgarc, juarc, jurec, jgrec, jg2rec, ju2rec, ju2mrc, &
        jeprec, ie, ia, ib, ic, id, icd, ibd, ibc, imove, j2, j34, j3u, j3g, &
        j3e, j3um
      double precision, dimension(15) :: gamma
      double precision :: one, gav, yy, gave
      character, dimension(3) :: alab
      double precision, external :: trsub

      save alab, ida, idb, idc, idd, ip, ipair
!-----------------------------------------------
!.....................................................................
!  CALCULATE GAMMA(DC-EFISHG) IN A NONITERATIVE FASHION
!.....................................................................
      data alab/ 'X', 'Y', 'Z'/
!
      data ida/ 1, 2, 3, 1, 1, 2, 2, 3, 3, 1, 1, 2, 2, 3, 3/
      data idb/ 1, 2, 3, 2, 3, 1, 3, 1, 2, 1, 1, 2, 2, 3, 3/
      data idc/ 1, 2, 3, 1, 1, 2, 2, 3, 3, 2, 3, 1, 3, 1, 2/
      data idd/ 1, 2, 3, 2, 3, 1, 3, 1, 2, 2, 3, 1, 3, 1, 2/
      data ip/ 1, 2, 3, 2, 4, 5, 3, 5, 6/
      data ipair/ 1, 4, 7, 2, 5, 8, 3, 6, 9/
      j3e = 0
      j3g = 0
      j3u = 0
      j3um = 0
      one = 1.D0
      msq = norbs*norbs
      write (iw, 10) omega
   10 format(/,/,' GAMMA (DC-EFISHG) AT ',f10.5,' EV.'/,/)
!
! GET DATA FROM ALPHA  AND ITERATIVE BETA CALCULATIONS
!
!   REQUIRED RECORDS FROM POLARIZABILITY CALCULATIONS
!   -------------------------------------------------------
!        0    W    2W    3W
!
!       -02- -08-  -14-  -20-  -U- MATRIX FOR -X- DIRECTION
!       -03- -09-  -15-  -21-  -U- MATRIX FOR -Y- DIRECTION
!       -04- -10-  -16-  -22-  -U- MATRIX FOR -Z- DIRECTION
!       -05- -11-  -17-  -23-  -G- MATRIX FOR -X- DIRECTION
!       -06- -12-  -18-  -24-  -G- MATRIX FOR -Y- DIRECTION
!       -07- -13-  -19-  -25-  -G- MATRIX FOR -Z- DIRECTION
!   -------------------------------------------------------
!      (0,0)    (W,W)    (0,W)    (W,-W)
!
!      -26-     -50-     -74-     -110-   -U- MATRIX FOR -XX- DIRECTION
!      -27-     -51-     -75-     -111-   -U- MATRIX FOR -XY- DIRECTION
!      -28-     -52-     -76-     -112-   -U- MATRIX FOR -XZ- DIRECTION
!                        -77-     -113-   -U- MATRIX DOE -YX- DIRECTION
!      -29-     -53-     -78-     -114-   -U- MATRIX FOR -YY- DIRECTION
!      -30-     -54-     -79-     -115-   -U- MATRIX FOR -YZ- DIRECTION
!                        -80-     -116-   -U- MATRIX FOR -ZX- DIRECTION
!                        -81-     -117-   -U- MATRIX FOR -ZY- DIRECTION
!      -31-     -55-     -82-     -118-   -U- MATRIX FOR -ZZ- DIRECTION
!   ------------------------------------------------------------------
!
!      -32-     -56-     -83-     -119-   -G- MATRIX FOR -XX- DIRECTION
!      -33-     -57-     -84-     -120-   -G- MATRIX FOR -XY- DIRECTION
!      -34-     -58-     -85-     -121-   -G- MATRIX FOR -XZ- DIRECTION
!                        -86-     -122-   -G- MATRIX FOR -YX- DIRECTION
!      -35-     -59-     -87-     -123-   -G- MATRIX FOR -YY- DIRECTION
!      -36-     -60-     -88-     -124-   -G- MATRIX FOR -YZ- DIRECTION
!                        -89-     -125-   -G- MATRIX FOR -ZX- DIRECTION
!                        -90-     -126-   -G- MATRIX FOR -ZY- DIRECTION
!      -37-     -61-     -91-     -127-   -G- MATRIX FOR -ZZ- DIRECTION
!   ------------------------------------------------------------------
!
!      -38-     -62-     -92-     -128-   -E- MATRIX FOR -XX- DIRECTION
!      -39-     -63-     -93-     -129-   -E- MATRIX FOR -XY- DIRECTION
!      -40-     -64-     -94-     -130-   -E- MATRIX FOR -XZ- DIRECTION
!                        -95-     -131-   -E- MATRIX FOR -YX- DIRECTION
!      -41-     -65-     -96-     -132-   -E- MATRIX FOR -YY- DIRECTION
!      -42-     -66-     -97-     -133-   -E- MATRIX FOR -YZ- DIRECTION
!                        -98-     -134-   -E- MATRIX FOR -ZX- DIRECTION
!                        -99-     -135-   -E- MATRIX FOR -ZY- DIRECTION
!      -43-     -67-     -100-    -136-   -E- MATRIX FOR -ZZ- DIRECTION
!   ------------------------------------------------------------------
!
!      -44-     -68-     -101-    -137-   -UM- MATRIX FOR -XX- DIRECTION
!      -45-     -69-     -102-    -138-   -UM- MATRIX FOR -XY- DIRECTION
!      -46-     -70-     -103-    -139-   -UM- MATRIX FOR -XZ- DIRECTION
!                        -104-    -140-   -UM- MATRIX FOR -YX- DIRECTION
!      -47-     -71-     -105-    -141-   -UM- MATRIX FOR -YY- DIRECTION
!      -48-     -72-     -106-    -142-   -UM- MATRIX FOR -YZ- DIRECTION
!                        -107-    -143-   -UM- MATRIX FOR -ZX- DIRECTION
!                        -108-    -144-   -UM- MATRIX FOR -ZY- DIRECTION
!      -49-     -73-     -109-    -145-   -UM- MATRIX FOR -ZZ- DIRECTION
!   ------------------------------------------------------------------
!
! CALCULATION OF DIFFERENT GAMMA VALUES IN A NONITERATIVE METHOD.
!
! IGAM=2 (DC-ELECTIC FIELD INDUCED SECOND HARMONIC GENERATION)
!
      jgarc = 16
      juarc = 13
      jurec = 1
      jgrec = 4
      jg2rec = 55
      ju2rec = 49
      ju2mrc = 67
      jeprec = 61
! LOOP BEGINS FOR THE CALCULATION OF GAMMA(ABCD)
!
      gav = 0.0D00
      do ie = 1, 15
        ia = ida(ie)
        ib = idb(ie)
        ic = idc(ie)
        id = idd(ie)
        icd = ip(ic,id)
        ibd = ipair(ib,id)
        ibc = ipair(ib,ic)
!
!  READ IN THE FIRST ORDER U3 OMEGA AND G3 OMEGA IN THE DIRECTION A
!  MAKE GD3 OMEGA MATRIX FROM G3 MATRIX
!
        call daread (x, msq, jgarc + ia)
        call fhpatn (gd3, x, norbs, 2, one)
!
! MAKE UD3 OMEGA MATRIX FROM U3 OMEGA MATRIX
!
        call daread (x, msq, juarc + ia)
        call fhpatn (ud3, x, norbs, 2, (-one))
        yy = 0.0D00
        imove = 1
   20   continue
!
! DC EFISHG
!
        select case (imove)
        case default
          j2 = ib
          j34 = icd
        case (2)
          j2 = ic + 6
!                 J34=IBD+24
          j3u = ibd + 24
          j3g = ibd + 27
          j3e = ibd + 30
          j3um = ibd + 33
        case (3)
          j2 = id + 6
          j3u = ibc + 24
          j3g = ibc + 27
          j3e = ibc + 30
          j3um = ibc + 33
        end select
!
!  READ IN G1,U1,GS,US,UMS,EPS
!
!  CALL UB
!
        call daread (u1, msq, jurec + j2)
!  CALL GB
        call daread (g1, msq, jgrec + j2)
        if (imove == 1) then
!  CALL GCD
          call daread (gs, msq, jg2rec + j34)
!  CALL UCD
          call daread (us, msq, ju2rec + j34)
!  CALL USMD
          call daread (usmd, msq, ju2mrc + j34)
!  CALL EPCD
          call daread (eps, msq, jeprec + j34)
!
        else
!  CALL GCD
          call daread (gs, msq, jg2rec + j3g)
!  CALL UCD
          call daread (us, msq, ju2rec + j3u)
!  CALL USMD
          call daread (usmd, msq, ju2mrc + j3um)
!  CALL EPCD
          call daread (eps, msq, jeprec + j3e)
        end if
!
! FIRST KIND
!
        yy = yy + trsub(ud3,g1,us,nclose,norbs,norbs)
        yy = yy - trsub(usmd,g1,ud3,nclose,norbs,norbs)
        yy = yy - trsub(ud3,g1,us,norbs,nclose,norbs)
        yy = yy + trsub(usmd,g1,ud3,norbs,nclose,norbs)
!
! SECOND KIND
!
        yy = yy + trsub(ud3,gs,u1,nclose,norbs,norbs)
        yy = yy + trsub(u1,gs,ud3,nclose,norbs,norbs)
        yy = yy - trsub(ud3,eps,u1,norbs,nclose,norbs)
        yy = yy - trsub(u1,eps,ud3,norbs,nclose,norbs)
!
! THIRD KIND
!
        yy = yy + trsub(u1,gd3,us,nclose,norbs,norbs)
        yy = yy - trsub(usmd,gd3,u1,nclose,norbs,norbs)
        yy = yy - trsub(u1,gd3,us,norbs,nclose,norbs)
        yy = yy + trsub(usmd,gd3,u1,norbs,nclose,norbs)
!
        imove = imove + 1
        if (imove <= 3) go to 20
!
        gamma(ie) = yy
! CALCULATE THE AVERAGE GAMMA VALUE
        if (ie <= 3) then
          gav = gav + 3*yy
        else if (ie > 9) then
          gav = gav + yy
        else
          gav = gav + 2*yy
        end if
!
! WRITE GAMMA(ABCD)
!
        write (iw, 80) alab(ia), alab(ib), alab(ic), alab(id), gamma(ie)
   80   format(' GAMMA(',a1,',',a1,',',a1,',',a1,') = ',1p,d14.7)
!
      end do
      gave = gav/15.0D+00
      write (iw, 100) omega, gave, " a.u. =", gave/1.985425939776565, " ESU (X10-39)"
  100 format(/,/,' AVERAGE GAMMA VALUE AT ',f10.5,' EV = ',1p,d14.7,a,d14.7,a,/,/)
      return
      end subroutine ngefis


      subroutine ngidri(x, gd3, ud3, g1, u1, gs, usmd, eps, us)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : norbs, nclose
       USE polar_C, only : omega
      use chanel_C, only : iw
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision  :: x(norbs,norbs)
      double precision  :: gd3(norbs,norbs)
      double precision  :: ud3(norbs,norbs)
      double precision  :: g1(norbs,norbs)
      double precision  :: u1(norbs,norbs)
      double precision  :: gs(norbs,norbs)
      double precision  :: usmd(norbs,norbs)
      double precision  :: eps(norbs,norbs)
      double precision  :: us(norbs,norbs)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(15) :: ida, idb, idc, idd
      integer , dimension(3,3) :: ip, ipair
      integer :: msq, jgarc, juarc, jurec, jgrec, ie, ia, ib, ic, id, icd, ibd&
        , ibc, imove, j2, j34, jg2rec, ju2rec, ju2mrc, jeprec
      double precision, dimension(15) :: gamma
      double precision :: one, gav, yy, gave
      character, dimension(3) :: alab
      double precision, external :: trsub

      save alab, ida, idb, idc, idd, ip, ipair
!-----------------------------------------------
!.....................................................................
!  CALCULATE GAMMA(IDRI) IN A NONITERATIVE FASHION
!.....................................................................
      data alab/ 'X', 'Y', 'Z'/
!
      data ida/ 1, 2, 3, 1, 1, 2, 2, 3, 3, 1, 1, 2, 2, 3, 3/
      data idb/ 1, 2, 3, 1, 1, 2, 2, 3, 3, 2, 3, 1, 3, 1, 2/
      data idc/ 1, 2, 3, 2, 3, 1, 3, 1, 2, 2, 3, 1, 3, 1, 2/
      data idd/ 1, 2, 3, 2, 3, 1, 3, 1, 2, 1, 1, 2, 2, 3, 3/
      data ip/ 1, 2, 3, 2, 4, 5, 3, 5, 6/
      data ipair/ 1, 4, 7, 2, 5, 8, 3, 6, 9/
      one = 1.0D00
      msq = norbs*norbs
!
      write (iw, 10) omega
   10 format(/,/,' GAMMA (IDRI) AT ',f10.5,' EV.'/,/)
!
! GET DATA FROM ALPHA  AND ITERATIVE BETA CALCULATIONS
!
!
! IGAM=3 (INTENSITY DEPENDENT REFRACTIVE INDEX OR DEGENERATED FOUR
! WAVE MIXING)
!
      jgarc = 10
      juarc = 7
      jurec = 7
      jgrec = 10
! LOOP BEGINS FOR THE CALCULATION OF GAMMA(ABCD)
!
      gav = 0.0D+00
      do ie = 1, 15
        ia = ida(ie)
        ib = idb(ie)
        ic = idc(ie)
        id = idd(ie)
        icd = ipair(ic,id)
        ibd = ipair(ib,id)
        ibc = ip(ib,ic)
!
!  READ IN THE FIRST ORDER U3 OMEGA AND G3 OMEGA IN THE DIRECTION A
!
! MAKE GD3 OMEGA MATRIX FROM G3 MATRIX
!
        call daread (x, msq, jgarc + ia)
        call fhpatn (gd3, x, norbs, 2, one)
!
! MAKE UD3 OMEGA MATRIX FROM U3 OMEGA MATRIX
!
        call daread (x, msq, juarc + ia)
        call fhpatn (ud3, x, norbs, 2, (-one))
!
        yy = 0.0D00
        imove = 1
   20   continue
!
!
! IDRI
!
        select case (imove)
        case default
          j2 = ib
          j34 = icd
          jg2rec = 118
          ju2rec = 109
          ju2mrc = 136
          jeprec = 127
        case (2)
          j2 = ic
          j34 = ibd
          jg2rec = 118
          ju2rec = 109
          ju2mrc = 136
          jeprec = 127
        case (3)
          j2 = id
          j34 = ibc
          jg2rec = 55
          ju2rec = 49
          ju2mrc = 67
          jeprec = 61
        end select
!  READ IN G1,U1,GS,US,UMS,EPS
!
!  CALL UB
        if (imove == 3) then
          call daread (x, msq, jurec + j2)
          call fhpatn (u1, x, norbs, 2, (-one))
        else
          call daread (u1, msq, jurec + j2)
        end if
!  CALL GB
        if (imove == 3) then
          call daread (x, msq, jgrec + j2)
          call fhpatn (g1, x, norbs, 2, one)
        else
          call daread (g1, msq, jgrec + j2)
        end if
!  CALL GCD
        call daread (gs, msq, jg2rec + j34)
!  CALL UCD
        call daread (us, msq, ju2rec + j34)
!  CALL USMD
        call daread (usmd, msq, ju2mrc + j34)
!  CALL EPCD
        call daread (eps, msq, jeprec + j34)
!
! FIRST KIND
!
        yy = yy + trsub(ud3,g1,us,nclose,norbs,norbs)
        yy = yy - trsub(usmd,g1,ud3,nclose,norbs,norbs)
        yy = yy - trsub(ud3,g1,us,norbs,nclose,norbs)
        yy = yy + trsub(usmd,g1,ud3,norbs,nclose,norbs)
!
! SECOND KIND
!
        yy = yy + trsub(ud3,gs,u1,nclose,norbs,norbs)
        yy = yy + trsub(u1,gs,ud3,nclose,norbs,norbs)
        yy = yy - trsub(ud3,eps,u1,norbs,nclose,norbs)
        yy = yy - trsub(u1,eps,ud3,norbs,nclose,norbs)
!
! THIRD KIND
!
        yy = yy + trsub(u1,gd3,us,nclose,norbs,norbs)
        yy = yy - trsub(usmd,gd3,u1,nclose,norbs,norbs)
        yy = yy - trsub(u1,gd3,us,norbs,nclose,norbs)
        yy = yy + trsub(usmd,gd3,u1,norbs,nclose,norbs)
!
        imove = imove + 1
        if (imove <= 3) go to 20
!
        gamma(ie) = yy
!
! CALCULATE THE AVERAGE GAMMA VALUE
!
        if (ie <= 3) then
          gav = gav + 3.0D0*yy
        else if (ie > 9) then
          gav = gav + yy
        else
          gav = gav + 2.0D0*yy
        end if
!
! WRITE GAMMA(ABCD)
!
        write (iw, 70) alab(ia), alab(ib), alab(ic), alab(id), gamma(ie)
   70   format(' GAMMA(',a1,',',a1,',',a1,',',a1,') = ',1p,d14.7)
!
      end do
      gave = gav/15.0D+00
      write (iw, 90) omega, gave, " a.u. =", gave/1.985425939776565, " ESU (X10-39)"
   90 format(/,/,'  AVERAGE GAMMA VALUE AT ',f10.5,' = ',1p,d14.7,a,d14.7,a,/,/)
      return
      end subroutine ngidri


      subroutine ngoke(igam, x, gd3, ud3, g1, u1, gs, usmd, eps, us)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : norbs, nclose
      use chanel_C, only : iw
       USE polar_C, only : omega
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: igam
      double precision  :: x(norbs,norbs)
      double precision  :: gd3(norbs,norbs)
      double precision  :: ud3(norbs,norbs)
      double precision  :: g1(norbs,norbs)
      double precision  :: u1(norbs,norbs)
      double precision  :: gs(norbs,norbs)
      double precision  :: usmd(norbs,norbs)
      double precision  :: eps(norbs,norbs)
      double precision  :: us(norbs,norbs)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(15) :: ida, idb, idc, idd
      integer , dimension(3,3) :: ip, ipair
      integer :: msq, jgarc, juarc, jurec, jgrec, ie, ia, ib, ic, id, icd, ibd&
        , ibc, imove, j2, j34, jg2rec, ju2rec, ju2mrc, jeprec
      double precision, dimension(15) :: gamma
      double precision :: one, gav, yy, gave
      character, dimension(3) :: alab
      double precision, external :: trsub

      save alab, ida, idb, idc, idd, ip, ipair
!-----------------------------------------------
!.....................................................................
!  CALCULATE GAMMA(OKE) IN A NONITERATIVE FASHION
!.....................................................................
      data alab/ 'X', 'Y', 'Z'/
!
      data ida/ 1, 2, 3, 1, 1, 2, 2, 3, 3, 1, 1, 2, 2, 3, 3/
      data idb/ 1, 2, 3, 1, 1, 2, 2, 3, 3, 2, 3, 1, 3, 1, 2/
      data idc/ 1, 2, 3, 2, 3, 1, 3, 1, 2, 2, 3, 1, 3, 1, 2/
      data idd/ 1, 2, 3, 2, 3, 1, 3, 1, 2, 1, 1, 2, 2, 3, 3/
      data ip/ 1, 2, 3, 2, 4, 5, 3, 5, 6/
      data ipair/ 1, 4, 7, 2, 5, 8, 3, 6, 9/
      one = 1.0D00
      msq = norbs*norbs
!
      if (igam == 3) then
        write (iw, 10) omega
   10   format(/,/,' GAMMA (IDRI) AT ',f10.5,' EV.'/,/)
      else
        write (iw, 20) omega
   20   format(/,/,' GAMMA (OKE) AT ',f10.5,' EV.'/,/)
      end if
!
! DATA INCLUDING YX, ZY, ZX DIRECTIONS
! GET DATA FROM ALPHA  AND ITERATIVE BETA CALCULATIONS
!
!   REQUIRED RECORDS FROM POLARIZABILITY CALCULATIONS
!
!   -------------------------------------------------------
!        0    W    2W    3W
!
!       -02- -08-  -14-  -20-  -U- MATRIX FOR -X- DIRECTION
!       -03- -09-  -15-  -21-  -U- MATRIX FOR -Y- DIRECTION
!       -04- -10-  -16-  -22-  -U- MATRIX FOR -Z- DIRECTION
!       -05- -11-  -17-  -23-  -G- MATRIX FOR -X- DIRECTION
!       -06- -12-  -18-  -24-  -G- MATRIX FOR -Y- DIRECTION
!       -07- -13-  -19-  -25-  -G- MATRIX FOR -Z- DIRECTION
!   -------------------------------------------------------
!      (0,0)    (W,W)    (0,W)    (W,-W)
!
!      -26-     -50-     -74-     -110-   -U- MATRIX FOR -XX- DIRECTION
!      -27-     -51-     -75-     -111-   -U- MATRIX FOR -XY- DIRECTION
!      -28-     -52-     -76-     -112-   -U- MATRIX FOR -XZ- DIRECTION
!                        -77-     -113-   -U- MATRIX DOE -YX- DIRECTION
!      -29-     -53-     -78-     -114-   -U- MATRIX FOR -YY- DIRECTION
!      -30-     -54-     -79-     -115-   -U- MATRIX FOR -YZ- DIRECTION
!                        -80-     -116-   -U- MATRIX FOR -ZX- DIRECTION
!                        -81-     -117-   -U- MATRIX FOR -ZY- DIRECTION
!      -31-     -55-     -82-     -118-   -U- MATRIX FOR -ZZ- DIRECTION
!   ------------------------------------------------------------------
!
!      -32-     -56-     -83-     -119-   -G- MATRIX FOR -XX- DIRECTION
!      -33-     -57-     -84-     -120-   -G- MATRIX FOR -XY- DIRECTION
!      -34-     -58-     -85-     -121-   -G- MATRIX FOR -XZ- DIRECTION
!                        -86-     -122-   -G- MATRIX FOR -YX- DIRECTION
!      -35-     -59-     -87-     -123-   -G- MATRIX FOR -YY- DIRECTION
!      -36-     -60-     -88-     -124-   -G- MATRIX FOR -YZ- DIRECTION
!                        -89-     -125-   -G- MATRIX FOR -ZX- DIRECTION
!                        -90-     -126-   -G- MATRIX FOR -ZY- DIRECTION
!      -37-     -61-     -91-     -127-   -G- MATRIX FOR -ZZ- DIRECTION
!   ------------------------------------------------------------------
!
!      -38-     -62-     -92-     -128-   -E- MATRIX FOR -XX- DIRECTION
!      -39-     -63-     -93-     -129-   -E- MATRIX FOR -XY- DIRECTION
!      -40-     -64-     -94-     -130-   -E- MATRIX FOR -XZ- DIRECTION
!                        -95-     -131-   -E- MATRIX FOR -YX- DIRECTION
!      -41-     -65-     -96-     -132-   -E- MATRIX FOR -YY- DIRECTION
!      -42-     -66-     -97-     -133-   -E- MATRIX FOR -YZ- DIRECTION
!                        -98-     -134-   -E- MATRIX FOR -ZX- DIRECTION
!                        -99-     -135-   -E- MATRIX FOR -ZY- DIRECTION
!      -43-     -67-     -100-    -136-   -E- MATRIX FOR -ZZ- DIRECTION
!   ------------------------------------------------------------------
!
!      -44-     -68-     -101-    -137-   -UM- MATRIX FOR -XX- DIRECTION
!      -45-     -69-     -102-    -138-   -UM- MATRIX FOR -XY- DIRECTION
!      -46-     -70-     -103-    -139-   -UM- MATRIX FOR -XZ- DIRECTION
!                        -104-    -140-   -UM- MATRIX FOR -YX- DIRECTION
!      -47-     -71-     -105-    -141-   -UM- MATRIX FOR -YY- DIRECTION
!      -48-     -72-     -106-    -142-   -UM- MATRIX FOR -YZ- DIRECTION
!                        -107-    -143-   -UM- MATRIX FOR -ZX- DIRECTION
!                        -108-    -144-   -UM- MATRIX FOR -ZY- DIRECTION
!      -49-     -73-     -109-    -145-   -UM- MATRIX FOR -ZZ- DIRECTION
!   ------------------------------------------------------------------
!
! GET DATA FROM ALPHA  AND ITERATIVE BETA CALCULATIONS
!
!
! IGAM=4 (OPTICAL KERR EFFECT)
!
      jgarc = 10
      juarc = 7
      jurec = 1
      jgrec = 4
! LOOP BEGINS FOR THE CALCULATION OF GAMMA(ABCD)
!
      gav = 0.0D+00
      do ie = 1, 15
        ia = ida(ie)
        ib = idb(ie)
        ic = idc(ie)
        id = idd(ie)
        icd = ipair(ic,id)
        ibd = ipair(ib,id)
        ibc = ip(ib,ic)
!
!  READ IN THE FIRST ORDER U3 OMEGA AND G3 OMEGA IN THE DIRECTION A
!
! MAKE GD3 OMEGA MATRIX FROM G3 MATRIX
!
        call daread (x, msq, jgarc + ia)
        call fhpatn (gd3, x, norbs, 2, one)
!
! MAKE UD3 OMEGA MATRIX FROM U3 OMEGA MATRIX
!
        call daread (x, msq, juarc + ia)
        call fhpatn (ud3, x, norbs, 2, (-one))
!
        yy = 0.0D00
        imove = 1
   30   continue
!
! OKE
        select case (imove)
        case default
          j2 = ib
          j34 = icd
          jg2rec = 82
          ju2rec = 73
          ju2mrc = 100
          jeprec = 91
        case (2)
          j2 = ic
          j34 = ibd
          jg2rec = 82
          ju2rec = 73
          ju2mrc = 100
          jeprec = 91
        case (3)
          j2 = id
          j34 = ibc
          jg2rec = 31
          ju2rec = 25
          ju2mrc = 43
          jeprec = 37
        end select
!  READ IN G1,U1,GS,US,UMS,EPS
!
!  CALL UB
        if (imove == 3) then
          call daread (u1, msq, juarc + j2)
        else
          call daread (u1, msq, jurec + j2)
        end if
!  CALL GB
        if (imove == 3) then
          call daread (g1, msq, jgarc + j2)
        else
          call daread (g1, msq, jgrec + j2)
        end if
!  CALL GCD
        call daread (gs, msq, jg2rec + j34)
!  CALL UCD
        call daread (us, msq, ju2rec + j34)
!  CALL USMD
        call daread (usmd, msq, ju2mrc + j34)
!  CALL EPCD
        call daread (eps, msq, jeprec + j34)
!
! FIRST KIND
!
        yy = yy + trsub(ud3,g1,us,nclose,norbs,norbs)
        yy = yy - trsub(usmd,g1,ud3,nclose,norbs,norbs)
        yy = yy - trsub(ud3,g1,us,norbs,nclose,norbs)
        yy = yy + trsub(usmd,g1,ud3,norbs,nclose,norbs)
!
! SECOND KIND
!
        yy = yy + trsub(ud3,gs,u1,nclose,norbs,norbs)
        yy = yy + trsub(u1,gs,ud3,nclose,norbs,norbs)
        yy = yy - trsub(ud3,eps,u1,norbs,nclose,norbs)
        yy = yy - trsub(u1,eps,ud3,norbs,nclose,norbs)
!
! THIRD KIND
!
        yy = yy + trsub(u1,gd3,us,nclose,norbs,norbs)
        yy = yy - trsub(usmd,gd3,u1,nclose,norbs,norbs)
        yy = yy - trsub(u1,gd3,us,norbs,nclose,norbs)
        yy = yy + trsub(usmd,gd3,u1,norbs,nclose,norbs)
!
        imove = imove + 1
        if (imove <= 3) go to 30
!
        gamma(ie) = yy
!
! CALCULATE THE AVERAGE GAMMA VALUE
!
        if (ie <= 3) then
          gav = gav + 3.0D0*yy
        else if (ie > 9) then
          gav = gav + yy
        else
          gav = gav + 2.0D0*yy
        end if
!
! WRITE GAMMA(ABCD)
!
        write (iw, 80) alab(ia), alab(ib), alab(ic), alab(id), gamma(ie)
   80   format(' GAMMA(',a1,',',a1,',',a1,',',a1,') = ',1p,d14.7)
!
      end do
      gave = gav/15.0D+00
      write (iw, 100) omega, gave, " a.u. =", gave/1.985425939776565, " ESU (X10-39)"
  100 format(/,/,'  AVERAGE GAMMA VALUE AT ',f10.5,' = ',1p,d14.7,a,d14.7,a,/,/)
      return
      end subroutine ngoke


      subroutine nonbet(u1x, u1y, u1z, u2x, u2y, u2z, g1x, g1y, g1z, g2x, g2y, g2z)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : norbs, nclose, line
      use chanel_C, only : iw
       USE polar_C, only : omega
!
! THIS SUBROUTINE CALCULATES SECOND HARMONIC GENERATION IN A
! NONITERATIVE WAY.
!
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision  :: u1x(norbs,norbs)
      double precision  :: u1y(norbs,norbs)
      double precision  :: u1z(norbs,norbs)
      double precision  :: u2x(norbs,norbs)
      double precision  :: u2y(norbs,norbs)
      double precision  :: u2z(norbs,norbs)
      double precision  :: g1x(norbs,norbs)
      double precision  :: g1y(norbs,norbs)
      double precision  :: g1z(norbs,norbs)
      double precision  :: g2x(norbs,norbs)
      double precision  :: g2y(norbs,norbs)
      double precision  :: g2z(norbs,norbs)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: maxsq
      double precision :: bavx, bavy, bavz, bxxx, byxx, bzxx, bxxy, byxy, bzxy, &
        bxxz, byxz, bzxz, bxyx, byyx, bzyx, bxyy, byyy, bzyy, bxyz, byyz, bzyz&
        , bxzx, byzx, bzzx, bxzy, byzy, bzzy, bxzz, byzz, bzzz, bvec
!-----------------------------------------------
!.....................................................................
!  CALCULATE BETA IN A NONITERATIVE FASHION
!.....................................................................
!
! GET DATA FROM ALPHA CALCULATIONS
!
      maxsq = norbs*norbs
      bavx = 0.0D+00
      bavy = 0.0D+00
      bavz = 0.0D+00
      call daread (u1x, maxsq, 8)
      call daread (u1y, maxsq, 9)
      call daread (u1z, maxsq, 10)
      call daread (g1x, maxsq, 11)
      call daread (g1y, maxsq, 12)
      call daread (g1z, maxsq, 13)
      call daread (u2x, maxsq, 14)
      call daread (u2y, maxsq, 15)
      call daread (u2z, maxsq, 16)
      call daread (g2x, maxsq, 17)
      call daread (g2y, maxsq, 18)
      call daread (g2z, maxsq, 19)
! XXX
      call betcom (u1x, g1x, u2x, g2x, nclose, norbs, bxxx)
      bavx = bavx + 3.0D0*bxxx
! YXX
      call betcom (u1x, g1x, u2y, g2y, nclose, norbs, byxx)
      bavy = bavy + byxx
! ZXX
      call betcom (u1x, g1x, u2z, g2z, nclose, norbs, bzxx)
      bavz = bavz + bzxx
! XXY
      call betall (u2x, g2x, u1x, g1x, u1y, g1y, nclose, norbs, bxxy)
      bavy = bavy + bxxy
! YXY
      call betall (u2y, g2y, u1x, g1x, u1y, g1y, nclose, norbs, byxy)
      bavx = bavx + byxy
! ZXY
      call betall (u2z, g2z, u1x, g1x, u1y, g1y, nclose, norbs, bzxy)
! XXZ
      call betall (u2x, g2x, u1x, g1x, u1z, g1z, nclose, norbs, bxxz)
      bavz = bavz + bxxz
! YXZ
      call betall (u2y, g2y, u1x, g1x, u1z, g1z, nclose, norbs, byxz)
! ZXZ
      call betall (u2z, g2z, u1x, g1x, u1z, g1z, nclose, norbs, bzxz)
      bavx = bavx + bzxz
! XYX
      call betall (u2x, g2x, u1y, g1y, u1x, g1x, nclose, norbs, bxyx)
      bavy = bavy + bxyx
! YYX
      call betall (u2y, g2y, u1y, g1y, u1x, g1x, nclose, norbs, byyx)
      bavx = bavx + byyx
! ZYX
      call betall (u2z, g2z, u1y, g1y, u1x, g1x, nclose, norbs, bzyx)
! XYY
      call betcom (u1y, g1y, u2x, g2x, nclose, norbs, bxyy)
      bavx = bavx + bxyy
! YYY
      call betcom (u1y, g1y, u2y, g2y, nclose, norbs, byyy)
      bavy = bavy + 3.0D0*byyy
! ZYY
      call betcom (u1y, g1y, u2z, g2z, nclose, norbs, bzyy)
      bavz = bavz + bzyy
! XYZ
      call betall (u2x, g2x, u1y, g1y, u1z, g1z, nclose, norbs, bxyz)
! YYZ
      call betall (u2y, g2y, u1y, g1y, u1z, g1z, nclose, norbs, byyz)
      bavz = bavz + byyz
! ZYZ
      call betall (u2z, g2z, u1y, g1y, u1z, g1z, nclose, norbs, bzyz)
      bavy = bavy + bzyz
! XZX
      call betall (u2x, g2x, u1z, g1z, u1x, g1x, nclose, norbs, bxzx)
      bavz = bavz + bxzx
! YZX
      call betall (u2y, g2y, u1z, g1z, u1x, g1x, nclose, norbs, byzx)
! ZZX
      call betall (u2z, g2z, u1z, g1z, u1x, g1x, nclose, norbs, bzzx)
      bavx = bavx + bzzx
! XZY
      call betall (u2x, g2x, u1z, g1z, u1y, g1y, nclose, norbs, bxzy)
! YZY
      call betall (u2y, g2y, u1z, g1z, u1y, g1y, nclose, norbs, byzy)
      bavz = bavz + byzy
! ZZY
      call betall (u2z, g2z, u1z, g1z, u1y, g1y, nclose, norbs, bzzy)
      bavy = bavy + bzzy
! XZZ
      call betcom (u1z, g1z, u2x, g2x, nclose, norbs, bxzz)
      bavx = bavx + bxzz
! YZZ
      call betcom (u1z, g1z, u2y, g2y, nclose, norbs, byzz)
      bavy = bavy + byzz
! ZZZ
      call betcom (u1z, g1z, u2z, g2z, nclose, norbs, bzzz)
      bavz = bavz + 3.0D0*bzzz
!
      bavx = bavx/5.0D+00
      bavy = bavy/5.0D+00
      bavz = bavz/5.0D+00
!
      bvec = (bavx*bavx + bavy*bavy + bavz*bavz)**0.5D+00
      write (iw, 10)
   10 format(/,/,' BETA (SECOND HARMONIC GENERATION)'/,/)
      write (iw, 20) bxxx, byxx, bzxx, bxxy, byxy, bzxy, bxxz, byxz, bzxz, bxyx&
        , byyx, bzyx, bxyy, byyy, bzyy, bxyz, byyz, bzyz, bxzx, byzx, bzzx, &
        bxzy, byzy, bzzy, bxzz, byzz, bzzz
   20 format(/,/,'  BXXX  ',d15.8,'  BYXX ',d15.8,'  BZXX ',d15.8,/,'  BXXY  ',&
        d15.8,'  BYXY ',d15.8,'  BZXY ',d15.8,/,'  BXXZ  ',d15.8,'  BYXZ ',&
        d15.8,'  BZXZ ',d15.8,/,'  BXYX  ',d15.8,'  BYYX ',d15.8,'  BZYX ',&
        d15.8,/,'  BXYY  ',d15.8,'  BYYY ',d15.8,'  BZYY ',d15.8,/,'  BXYZ  ',&
        d15.8,'  BYYZ ',d15.8,'  BZYZ ',d15.8,/,'  BXZX  ',d15.8,'  BYZX ',&
        d15.8,'  BZZX ',d15.8,/,'  BXZY  ',d15.8,'  BYZY ',d15.8,'  BZZY ',&
        d15.8,/,'  BXZZ  ',d15.8,'  BYZZ ',d15.8,'  BZZZ ',d15.8)
!
      if (bvec < 1.d10) then
        line = "(' AVERAGE BETA',a,'(SHG) VALUE AT',f10.5,' EV = ',f11.4, a)"
      else if (bvec < 1.d15) then
        line = "(' AVERAGE BETA',a,'(SHG) VALUE AT',f10.5,' EV = ',f16.4, a)"
      else
        line = "(' AVERAGE BETA',a,'(SHG) VALUE AT',f10.5,' EV = ',f21.4, a)"
      end if
      write (iw,"(/)")
      write (iw, trim(line)) "X", omega, bavx, " a.u."
      write (iw, trim(line)) "Y", omega, bavy, " a.u."
      write (iw, trim(line)) "Z", omega, bavz, " a.u."
      write (iw,"(2/)")
      write (iw, trim(line)) " ", omega, bvec, " a.u."
      write (iw,"(/)")
      return
      end subroutine nonbet


      subroutine nonope(u0x, u1y, u1z, u1x, u0y, u0z, g0x, g1y, g1z, g1x, g0y, &
        g0z)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : norbs, nclose, line
      use chanel_C, only : iw
      USE polar_C, only : omega
!
! THIS SUBROUTINE CALCULATES ELECTROOPTIC POCKEL'S EFFECT
! IN A NONITERATIVE WAY.
!
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision  :: u0x(norbs,norbs)
      double precision  :: u1y(norbs,norbs)
      double precision  :: u1z(norbs,norbs)
      double precision  :: u1x(norbs,norbs)
      double precision  :: u0y(norbs,norbs)
      double precision  :: u0z(norbs,norbs)
      double precision  :: g0x(norbs,norbs)
      double precision  :: g1y(norbs,norbs)
      double precision  :: g1z(norbs,norbs)
      double precision  :: g1x(norbs,norbs)
      double precision  :: g0y(norbs,norbs)
      double precision  :: g0z(norbs,norbs)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: maxsq
      double precision :: bavx, bavy, bavz, bxxx, byxx, bzxx, bxxy, byxy, bzxy, &
        bxxz, byxz, bzxz, bxyx, byyx, bzyx, bxyy, byyy, bzyy, bxyz, byyz, bzyz, &
        bxzx, byzx, bzzx, bxzy, byzy, bzzy, bxzz, byzz, bzzz, bvec, &
        au_to_esu = 8.639418d-33
!-----------------------------------------------
!.....................................................................
!  CALCULATE BETA IN A NONITERATIVE FASHION
!.....................................................................
!
      maxsq = norbs*norbs
!
! READ DATA FROM ALPHA CALCULATION
!
      bavx = 0.0D+00
      bavy = 0.0D+00
      bavz = 0.0D+00
!
      call daread (u0x, maxsq, 2)
      call daread (u0y, maxsq, 3)
      call daread (u0z, maxsq, 4)
      call daread (g0x, maxsq, 5)
      call daread (g0y, maxsq, 6)
      call daread (g0z, maxsq, 7)
      call daread (u1x, maxsq, 8)
      call daread (u1y, maxsq, 9)
      call daread (u1z, maxsq, 10)
      call daread (g1x, maxsq, 11)
      call daread (g1y, maxsq, 12)
      call daread (g1z, maxsq, 13)
! XXX
      call betall (u1x, g1x, u0x, g0x, u1x, g1x, nclose, norbs, bxxx)
      bavx = bavx + 3.0D0*bxxx
! YXX
      call betall (u1y, g1y, u0x, g0x, u1x, g1x, nclose, norbs, byxx)
      bavy = bavy + byxx
! ZXX
      call betall (u1z, g1z, u0x, g0x, u1x, g1x, nclose, norbs, bzxx)
      bavz = bavz + bzxx
! XXY
      call betall (u1x, g1x, u0x, g0x, u1y, g1y, nclose, norbs, bxxy)
      bavy = bavy + bxxy
! YXY
      call betall (u1y, g1y, u0x, g0x, u1y, g1y, nclose, norbs, byxy)
      bavx = bavx + byxy
! ZXY
      call betall (u1z, g1z, u0x, g0x, u1y, g1y, nclose, norbs, bzxy)
! XXZ
      call betall (u1x, g1x, u0x, g0x, u1z, g1z, nclose, norbs, bxxz)
      bavz = bavz + bxxz
! YXZ
      call betall (u1y, g1y, u0x, g0x, u1z, g1z, nclose, norbs, byxz)
! ZXZ
      call betall (u1z, g1z, u0x, g0x, u1z, g1z, nclose, norbs, bzxz)
      bavx = bavx + bzxz
! XYX
      call betall (u1x, g1x, u0y, g0y, u1x, g1x, nclose, norbs, bxyx)
      bavy = bavy + bxyx
! YYX
      call betall (u1y, g1y, u0y, g0y, u1x, g1x, nclose, norbs, byyx)
      bavx = bavx + byyx
! ZYX
      call betall (u1z, g1z, u0y, g0y, u1x, g1x, nclose, norbs, bzyx)
! XYY
      call betall (u1x, g1x, u0y, g0y, u1y, g1y, nclose, norbs, bxyy)
      bavx = bavx + bxyy
! YYY
      call betall (u1y, g1y, u0y, g0y, u1y, g1y, nclose, norbs, byyy)
      bavy = bavy + 3.0D0*byyy
! ZYY
      call betall (u1z, g1z, u0y, g0y, u1y, g1y, nclose, norbs, bzyy)
      bavz = bavz + bzyy
! XYZ
      call betall (u1x, g1x, u0y, g0y, u1z, g1z, nclose, norbs, bxyz)
! YYZ
      call betall (u1y, g1y, u0y, g0y, u1z, g1z, nclose, norbs, byyz)
      bavz = bavz + byyz
! ZYZ
      call betall (u1z, g1z, u0y, g0y, u1z, g1z, nclose, norbs, bzyz)
      bavy = bavy + bzyz
! XZX
      call betall (u1x, g1x, u0z, g0z, u1x, g1x, nclose, norbs, bxzx)
      bavz = bavz + bxzx
! YZX
      call betall (u1y, g1y, u0z, g0z, u1x, g1x, nclose, norbs, byzx)
! ZZX
      call betall (u1z, g1z, u0z, g0z, u1x, g1x, nclose, norbs, bzzx)
      bavx = bavx + bzzx
! XZY
      call betall (u1x, g1x, u0z, g0z, u1y, g1y, nclose, norbs, bxzy)
! YZY
      call betall (u1y, g1y, u0z, g0z, u1y, g1y, nclose, norbs, byzy)
      bavz = bavz + byzy
! ZZY
      call betall (u1z, g1z, u0z, g0z, u1y, g1y, nclose, norbs, bzzy)
      bavy = bavy + bzzy
! XZZ
      call betall (u1x, g1x, u0z, g0z, u1z, g1z, nclose, norbs, bxzz)
      bavx = bavx + bxzz
! YZZ
      call betall (u1y, g1y, u0z, g0z, u1z, g1z, nclose, norbs, byzz)
      bavy = bavy + byzz
! ZZZ
      call betall (u1z, g1z, u0z, g0z, u1z, g1z, nclose, norbs, bzzz)
      bavz = bavz + 3.0D0*bzzz
!
      bavx = bavx/5.0D+00
      bavy = bavy/5.0D+00
      bavz = bavz/5.0D+00
!
      bvec = (bavx*bavx + bavy*bavy + bavz*bavz)**0.5D+00
      write (iw, *) '  BETA (ELECTOPTIC POCKELS EFFECT) '
      write (iw, 10) bxxx, byxx, bzxx, bxxy, byxy, bzxy, bxxz, byxz, bzxz, bxyx&
        , byyx, bzyx, bxyy, byyy, bzyy, bxyz, byyz, bzyz, bxzx, byzx, bzzx, &
        bxzy, byzy, bzzy, bxzz, byzz, bzzz
   10 format(/,/,'  BXXX  ',d15.8,'  BYXX ',d15.8,'  BZXX ',d15.8,/,'  BXXY  ',&
        d15.8,'  BYXY ',d15.8,'  BZXY ',d15.8,/,'  BXXZ  ',d15.8,'  BYXZ ',&
        d15.8,'  BZXZ ',d15.8,/,'  BXYX  ',d15.8,'  BYYX ',d15.8,'  BZYX ',&
        d15.8,/,'  BXYY  ',d15.8,'  BYYY ',d15.8,'  BZYY ',d15.8,/,'  BXYZ  ',&
        d15.8,'  BYYZ ',d15.8,'  BZYZ ',d15.8,/,'  BXZX  ',d15.8,'  BYZX ',&
        d15.8,'  BZZX ',d15.8,/,'  BXZY  ',d15.8,'  BYZY ',d15.8,'  BZZY ',&
        d15.8,/,'  BXZZ  ',d15.8,'  BYZZ ',d15.8,'  BZZZ ',d15.8)
!
      if (bvec < 1.d10) then
        line = "(' AVERAGE BETA',a,'VALUE AT',f10.5,' EV = ',f15.4,a,g14.6,a)"
      else
        line = "(' AVERAGE BETA',a,'VALUE AT',f10.5,' EV = ',g13.6,a,g14.6,a)"
      end if
      write (iw,"(/)")
      write (iw, trim(line)) "X      ", omega, bavx, " a.u. =", bavx*au_to_esu, " ESU"
      write (iw, trim(line)) "Y      ", omega, bavy, " a.u. =", bavy*au_to_esu, " ESU"
      write (iw, trim(line)) "Z      ", omega, bavz, " a.u. =", bavz*au_to_esu, " ESU"
      write (iw,"(2/)")
      write (iw,"(/)")


      return
      end subroutine nonope


      subroutine nonor(u0x, u1y, u1z, u1x, u0y, u0z, g0x, g1y, g1z, g1x, g0y, &
        g0z)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : norbs, nclose
      use chanel_C, only : iw
       USE polar_C, only : omega
!
! THIS SUBROUTINE CALCULATES OPTICAL RECTIFICATION IN A
! NONITERATIVE WAY
!
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision  :: u0x(norbs,norbs)
      double precision  :: u1y(norbs,norbs)
      double precision  :: u1z(norbs,norbs)
      double precision  :: u1x(norbs,norbs)
      double precision  :: u0y(norbs,norbs)
      double precision  :: u0z(norbs,norbs)
      double precision  :: g0x(norbs,norbs)
      double precision  :: g1y(norbs,norbs)
      double precision  :: g1z(norbs,norbs)
      double precision  :: g1x(norbs,norbs)
      double precision  :: g0y(norbs,norbs)
      double precision  :: g0z(norbs,norbs)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: maxsq
      double precision :: bavx, bavy, bavz, bxxx, byxx, bzxx, bxxy, byxy, bzxy, &
        bxxz, byxz, bzxz, bxyx, byyx, bzyx, bxyy, byyy, bzyy, bxyz, byyz, bzyz&
        , bxzx, byzx, bzzx, bxzy, byzy, bzzy, bxzz, byzz, bzzz, bvec
!-----------------------------------------------
!.....................................................................
!  CALCULATE BETA IN A NONITERATIVE FASHION
!.....................................................................
      maxsq = norbs*norbs
!
! READ DATA FROM ALPHA CALCULATION
!
      bavx = 0.0D+00
      bavy = 0.0D+00
      bavz = 0.0D+00
!
      call daread (u0x, maxsq, 2)
      call daread (u0y, maxsq, 3)
      call daread (u0z, maxsq, 4)
      call daread (g0x, maxsq, 5)
      call daread (g0y, maxsq, 6)
      call daread (g0z, maxsq, 7)
      call daread (u1x, maxsq, 8)
      call daread (u1y, maxsq, 9)
      call daread (u1z, maxsq, 10)
      call daread (g1x, maxsq, 11)
      call daread (g1y, maxsq, 12)
      call daread (g1z, maxsq, 13)
!
! NONITERATIVE BETA CALCULATION
!
! XXX
      call betal1 (u0x, g0x, u1x, g1x, u1x, g1x, nclose, norbs, bxxx)
      bavx = bavx + 3.0D0*bxxx
! YXX
      call betal1 (u0y, g0y, u1x, g1x, u1x, g1x, nclose, norbs, byxx)
      bavy = bavy + byxx
! ZXX
      call betal1 (u0z, g0z, u1x, g1x, u1x, g1x, nclose, norbs, bzxx)
      bavz = bavz + bzxx
! XXY
      call betal1 (u0x, g0x, u1x, g1x, u1y, g1y, nclose, norbs, bxxy)
      bavy = bavy + bxxy
! YXY
      call betal1 (u0y, g0y, u1x, g1x, u1y, g1y, nclose, norbs, byxy)
      bavx = bavx + byxy
! ZXY
      call betal1 (u0z, g0z, u1x, g1x, u1y, g1y, nclose, norbs, bzxy)
! XXZ
      call betal1 (u0x, g0x, u1x, g1x, u1z, g1z, nclose, norbs, bxxz)
      bavz = bavz + bxxz
! YXZ
      call betal1 (u0y, g0y, u1x, g1x, u1z, g1z, nclose, norbs, byxz)
! ZXZ
      call betal1 (u0z, g0z, u1x, g1x, u1z, g1z, nclose, norbs, bzxz)
      bavx = bavx + bzxz
! XYX
      call betal1 (u0x, g0x, u1y, g1y, u1x, g1x, nclose, norbs, bxyx)
      bavy = bavy + bxyx
! YYX
      call betal1 (u0y, g0y, u1y, g1y, u1x, g1x, nclose, norbs, byyx)
      bavx = bavx + byyx
! ZYX
      call betal1 (u0z, g0z, u1y, g1y, u1x, g1x, nclose, norbs, bzyx)
! XYY
      call betal1 (u0x, g0x, u1y, g1y, u1y, g1y, nclose, norbs, bxyy)
      bavx = bavx + bxyy
! YYY
      call betal1 (u0y, g0y, u1y, g1y, u1y, g1y, nclose, norbs, byyy)
      bavy = bavy + 3.0D0*byyy
! ZYY
      call betal1 (u0z, g0z, u1y, g1y, u1y, g1y, nclose, norbs, bzyy)
      bavz = bavz + bzyy
! XYZ
      call betal1 (u0x, g0x, u1y, g1y, u1z, g1z, nclose, norbs, bxyz)
! YYZ
      call betal1 (u0y, g0y, u1y, g1y, u1z, g1z, nclose, norbs, byyz)
      bavz = bavz + byyz
! ZYZ
      call betal1 (u0z, g0z, u1y, g1y, u1z, g1z, nclose, norbs, bzyz)
      bavy = bavy + bzyz
! XZX
      call betal1 (u0x, g0x, u1z, g1z, u1x, g1x, nclose, norbs, bxzx)
      bavz = bavz + bxzx
! YZX
      call betal1 (u0y, g0y, u1z, g1z, u1x, g1x, nclose, norbs, byzx)
! ZZX
      call betal1 (u0z, g0z, u1z, g1z, u1x, g1x, nclose, norbs, bzzx)
      bavx = bavx + bzzx
! XZY
      call betal1 (u0x, g0x, u1z, g1z, u1y, g1y, nclose, norbs, bxzy)
! YZY
      call betal1 (u0y, g0y, u1z, g1z, u1y, g1y, nclose, norbs, byzy)
      bavz = bavz + byzy
! ZZY
      call betal1 (u0z, g0z, u1z, g1z, u1y, g1y, nclose, norbs, bzzy)
      bavy = bavy + bzzy
! XZZ
      call betal1 (u0x, g0x, u1z, g1z, u1z, g1z, nclose, norbs, bxzz)
      bavx = bavx + bxzz
! YZZ
      call betal1 (u0y, g0y, u1z, g1z, u1z, g1z, nclose, norbs, byzz)
      bavy = bavy + byzz
! ZZZ
      call betal1 (u0z, g0z, u1z, g1z, u1z, g1z, nclose, norbs, bzzz)
      bavz = bavz + 3.0D0*bzzz
!
      bavx = bavx/5.0D+00
      bavy = bavy/5.0D+00
      bavz = bavz/5.0D+00
!
      bvec = (bavx*bavx + bavy*bavy + bavz*bavz)**0.5D+00
      write (iw, 10)
   10 format(/,/,' BETA (OPTICAL RECTIFICATION) ')
      write (iw, 20) bxxx, byxx, bzxx, bxxy, byxy, bzxy, bxxz, byxz, bzxz, bxyx&
        , byyx, bzyx, bxyy, byyy, bzyy, bxyz, byyz, bzyz, bxzx, byzx, bzzx, &
        bxzy, byzy, bzzy, bxzz, byzz, bzzz
   20 format(/,/,'  BXXX  ',d15.8,'  BYXX ',d15.8,'  BZXX ',d15.8,/,'  BXXY  ',&
        d15.8,'  BYXY ',d15.8,'  BZXY ',d15.8,/,'  BXXZ  ',d15.8,'  BYXZ ',&
        d15.8,'  BZXZ ',d15.8,/,'  BXYX  ',d15.8,'  BYYX ',d15.8,'  BZYX ',&
        d15.8,/,'  BXYY  ',d15.8,'  BYYY ',d15.8,'  BZYY ',d15.8,/,'  BXYZ  ',&
        d15.8,'  BYYZ ',d15.8,'  BZYZ ',d15.8,/,'  BXZX  ',d15.8,'  BYZX ',&
        d15.8,'  BZZX ',d15.8,/,'  BXZY  ',d15.8,'  BYZY ',d15.8,'  BZZY ',&
        d15.8,/,'  BXZZ  ',d15.8,'  BYZZ ',d15.8,'  BZZZ ',d15.8)
!
      write (iw, 30) omega, bavx, " a.u."
   30 format(/,/,' AVERAGE BETAX VALUE AT ',f10.5,'EV = ',1f15.5, a)
!
      write (iw, 40) omega, bavy, " a.u."
   40 format(' AVERAGE BETAY VALUE AT ',f10.5,'EV = ',1f15.5, a)
!
      write (iw, 50) omega, bavz, " a.u."
   50 format(' AVERAGE BETAZ VALUE AT ',f10.5,'EV = ',1f15.5,a,/,/)
!
      write (iw, 60) omega, bvec, " a.u."
   60 format(/,/,' AVERAGE BETA(OR) VALUE AT ',f10.5,'EV = ',1f15.5,a,/,/)
!
      return
      end subroutine nonor


      subroutine openda(irest)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use chanel_C, only : idaf, irecln, irecst, ioda, ifilen, &
      pol_fn
!
!     - - - - OPEN MASTER DICTIONARY FILE 10 - - - -
!
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: irest
!-----------------------------------------------
!
!
      idaf = 17
      irecln = 1023
      open(unit=idaf, file=pol_fn, status='UNKNOWN', access=&
        'DIRECT', form='UNFORMATTED', recl=8*irecln)
!
!     ----- IS THIS A NEW OR OLD DAF FILE -----
!
      if (irest == 0) then
!
!        ----- MARK THE NEW DAF RECORDS AS EMPTY -----
!
        irecst = 1
        ioda = -1
        irecst = irecst + 1
        write (unit=idaf, rec=1) irecst, ioda, ifilen
        return
      end if
!
!     ----- LOAD THE OLD DAF DIRECTORY -----
!
      read (unit=idaf, rec=1) irecst, ioda, ifilen
      return
      end subroutine openda
  double precision function pol_vol(average)
  use molkst_C, only: numat, method_MNDO, method_AM1, method_PM3, method_PM6, method_PM7
  use parameters_C, only: polvol
  use common_arrays_C, only: labels
  use funcon_C, only: a0
  implicit none
  !
  !.. Formal Arguments ..
  double precision, intent (in) :: average
  double precision :: polarizability
  integer :: i
  double precision :: C_1, C_2
!
!  The corrected polarizability (alpha) is given by:
!
!          P = Sum_i C_i  +  P'*C_1 + C_2
!
!   where C_i are constants per atom, C_1 and C_2 are constants.
!
!  If these constants need to be altered, use v_par in PARAM to get new values.
!
     if (method_MNDO) then
      C_1 = 0.5651170d0
      C_2 = 0.2859620d0
    else if (method_AM1) then
      C_1 = 0.54687d0
      C_2 = 0.321973d0
    else if (method_PM3) then
      C_1 = 0.2465020d0
      C_2 = 0.0d0
     else if (method_PM6) then
      C_1 = 0.791396d0
      C_2 = 0.373638d0
    else if (method_PM7) then
      C_1 =  0.445109d0
      C_2 =  0.351109d0
    else
      C_1 = 0.d0
      C_2 = 0.d0
    end if
    polarizability = average*a0**3
    if (C_1 > 1.d-4) then
      polarizability = polarizability * C_1 + C_2
      do i = 1, numat
        polarizability = polarizability + polvol(labels(i))
      end do
    end if
    pol_vol = polarizability/a0**3
    return
  end function pol_vol

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine sort(val, vec, n)
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n
      real , intent(inout) :: val(*)
      complex , intent(inout) :: vec(n,*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j, k
      real :: x
      complex :: sum
!-----------------------------------------------
      do i = 1, n
        k = 0
        x = 1.E9
        do j = i, n
          if (val(j) >= x) cycle
          k = j
          x = val(j)
        end do
        do j = 1, n
          sum = vec(j,k)
          vec(j,k) = vec(j,i)
          vec(j,i) = sum
        end do
        val(k) = val(i)
        val(i) = x
      end do
      return
      end subroutine sort

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine local2 (c, mdim, nmos, nfirst, nlast, numat)
   !
   !.. Implicit Declarations ..
    implicit none
   !
   !.. Formal Arguments ..
    integer, intent (in) :: mdim, nmos, numat
    integer, dimension (*), intent (in) :: nfirst, nlast
    double precision, dimension (mdim, mdim), intent (inout) :: c
   !
   !.. Local Scalars ..
    integer :: i, j, k, k1, loop, n, niter
    double precision :: aij, bij, ca, dii, dij, djj, sa, sum, xiiii, xiijj, &
   & xijij, xijjj, xjiii, xjjjj
   !
   !.. Local Arrays ..
    double precision, dimension (20) :: psi1, psi2
   !
   !.. Intrinsic Functions ..
    intrinsic Abs, Sqrt
   !
   ! ... Executable Statements ...
   !
    n = nlast(numat)
    niter = 1
    if (nmos == 4) then
      niter = 19
    end if
    do loop = 1, niter
      sum = 0.d0
      do i = 1, nmos
        do j = 1, nmos
          if (j /= i) then
            xijjj = 0.0d0
            xjiii = 0.0d0
            xiiii = 0.0d0
            xjjjj = 0.0d0
            xijij = 0.0d0
            xiijj = 0.0d0
            do k = 1, n
              psi1(k) = c(k, i)
              psi2(k) = c(k, j)
            end do
            do k1 = 1, numat
              dij = 0.d0
              dii = 0.d0
              djj = 0.d0
              do k = nfirst(k1), nlast(k1)
                dij = dij + psi1(k) * psi2(k)
                dii = dii + psi1(k) * psi1(k)
                djj = djj + psi2(k) * psi2(k)
              end do
              xijjj = xijjj + dij * djj
              xjiii = xjiii + dij * dii
              xiiii = xiiii + dii * dii
              xjjjj = xjjjj + djj * djj
              xijij = xijij + dij * dij
              xiijj = xiijj + dii * djj
            end do
            aij = xijij - (xiiii+xjjjj-2.0d0*xiijj) / 4.0d0
            bij = xjiii - xijjj
            ca = Sqrt (aij*aij+bij*bij)
            sa = aij + ca
            if (sa > 1.0d-14) then
              ca = (1.0d0+Sqrt((1.0d0-aij/ca)/2.0d0)) / 2.0d0
              sa = Sqrt (1.0d0-ca)
              sum = sum + Abs (sa)
              ca = Sqrt (ca)
              do k = 1, n
                c(k, i) = ca * psi1(k) + sa * psi2(k)
                c(k, j) = -sa * psi1(k) + ca * psi2(k)
              end do
            end if
          end if
        end do
      end do
      if (sum < 1.d-5) exit
    end do
end subroutine local2

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine genun(u, n)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!****************************************************************
!
!     GENERATE UNIT VECTORS OVER SPHERE. USED BY SURFAC ONLY.
!
!****************************************************************
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(inout) :: n
      double precision , intent(out) :: u(3,n)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: nequat, nvert, nu, i, nhor, j
      double precision :: pi, fi, z, xy, fj, x, y
!-----------------------------------------------
      pi = 4.D0*atan(1.D0)
      nequat = int(sqrt(n*pi))
      nvert = nequat/2
      nu = 0
      l20: do i = 1, nvert + 1
        fi = (pi*(i - 1))/nvert
        z = cos(fi)
        xy = sin(fi)
        nhor = int(nequat*xy)
        nhor = max0(1,nhor)
        do j = 1, nhor
          fj = (2.D0*pi*(j - 1))/nhor
          x = dcos(fj)*xy
          y = dsin(fj)*xy
          if (nu >= n) exit  l20
          nu = nu + 1
          u(1,nu) = x
          u(2,nu) = y
          u(3,nu) = z
        end do
      end do l20
      n = nu
      return
      end subroutine genun


      logical function collid (cw, rw, cnbr, rnbr, nnbr, ishape)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!****************************************************************
!
!     COLLISION CHECK OF PROBE WITH NEIGHBORING ATOMS
!     USED BY SURFAC ONLY.
!
!****************************************************************
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: nnbr
      integer , intent(in) :: ishape
      double precision , intent(in) :: rw
      double precision , intent(in) :: cw(3)
      double precision , intent(in) :: cnbr(3,200)
      double precision , intent(in) :: rnbr(200)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i
      double precision :: sumrad, vect1, vect2, vect3, sr2, dd2
!-----------------------------------------------
      if (nnbr > 0) then
!
!     CHECK WHETHER PROBE IS TOO CLOSE TO ANY NEIGHBOR
!
        if (ishape == 3) then
        else
          do i = 1, nnbr
            sumrad = rw + rnbr(i)
            vect1 = dabs(cw(1)-cnbr(1,i))
            if (vect1 >= sumrad) cycle
            vect2 = dabs(cw(2)-cnbr(2,i))
            if (vect2 >= sumrad) cycle
            vect3 = dabs(cw(3)-cnbr(3,i))
            if (vect3 >= sumrad) cycle
            sr2 = sumrad**2
            dd2 = vect1**2 + vect2**2 + vect3**2
            if (dd2 < sr2) go to 30
          end do
        end if
      end if
      collid = .FALSE.
      go to 40
   30 continue
      collid = .TRUE.
   40 continue
      return
      end function collid

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine scfmat (v, shft)

!     ************************************************************************
!     **** generates the Fock matrices F for each shell plus determins the ***
!     **** variational energy using trace formula, V.			   ***
!     **** then it constracts the total fock operator in A, 		   ***
!     **** using SHFT as a shift of the virtual energy levels in AII.	   ***
!     **** D = each shells density matrix (d, ff in symmetric storage mode)  ***
!     ****   D is destroyed if open shell or damped closed shell	   ***
!     **** P = atomic charges from each shell; BETA, U = 1 e matr; GAMMA = 2e ***
!     **** C = previous set of MO coefficients if first element  >  - 1.     ***
!     ************************************************************************
!     **** References:							   ***
!     ****   ROHF: Edwards and Zerner Theor Chim Acta 72 (1987) 347	   ***
!     ****	   eqn 27 for v, eqn 33 for shell Fock matrices		   ***
!     ****	   eqn 24 is solved in previous MO basis for the total	    **
!     ****	   Fock operator by putting				   ***
!     ****	     alam = n(nu)/n(mu)*LAMBDA(mu, nu) - LAMBDA(nu, mu)	   ***
!     ****	     so that cross term is alam*(F(nu) - F(mu))*n(mu)/n(nu)  ***
!     ****	     alam is arbitrary non - zero, is set to 1 herein	   ***
!     ****	   eqn 24 is extended by a VIRTUAL - VIRTUAL term designed   ***
!     ****	     to produce better virtual eigenvalues		   ***
!     ****	   Errors: eqn 24, no 1/n(mu); eqn 33 F(hat) = not F = 	   ***
!     ****   INDO (Rotationally invariant for Transition Metals):	   ***
!     ****	   Bacon and Zerner Theor Chim Acta 53 (1979) 21	   ***
!     ****	   with additional R integrals included			   ***
!     ************************************************************************

      use molkst_C, only : mpack, norbs
      use reimers_C, only : n, na, nb2, matind, occfr, nel, nshell, norbl, &
          norbh, nbf, ibf, iat, ig1, ig2, ig3, ig4, g, nirreg, natt, &
          avec1, bvec1, avec2, bvec2, ppg, pg, dia, dd, ff, aa, cc0, &
          beta, gamma

      implicit none
      double precision ::   q, v, avec10, &
                         ga, gk, hg, off, shft, wt
      integer ::            i, j, k, irreg, &
                         ib, is, ishell, jb, jshell, &
                         k1, k2, k3, k4, mu, nm, nu

      double precision :: eltot
      double precision :: dd1(mpack, 2)

      avec10 = 0.d0
      hg = 0.d0
      v = 0.d0

!     **** diagonal term, sum Coulomb integrals from all other atoms ****
      if (allocated(pg)) deallocate(pg)
      if (allocated(ppg)) deallocate(ppg)
      allocate(pg(na, 0:2))
      allocate(ppg(norbs, 0:2))

      do ishell = 0, nshell
        do ib = 1, n
          ppg(ib, ishell) = 0.d0
        end do
        do i = 1, na
          pg(i, ishell) = 0.d0
        end do
      end do

      do ib = 1, n
        i = iat(ib)

        do jb = 1, n
          j = iat(jb)
          ga = gamma(ib, jb)
          if (ib < jb) ga = gamma(jb, ib)
          nm = matind(jb) + jb
          call veccou (nm, avec1, bvec1)
          do ishell = 0, nshell
            if (ib == jb) then
!	      **** weighted charges ****
              pg(i, ishell) = pg(i, ishell) + avec1(ishell)
            else if (i /= j) then
!	      **** weighted sums over all other atoms ****
              ppg(ib, ishell) = ppg(ib, ishell) + avec1(ishell) * ga
            end if
          end do
        end do

      end do

!     ************ Shell Fock matrices for different Hamiltonians *************

!	**** INDO Hamiltonian ****
      do i = 1, na
        do mu = ibf(i), ibf(i) + nbf(i) - 1
!	  **** terms in diagonal atom - atom block ****

!	  **** zero counters for the diagonal energy ****
          do is = 0, nshell
            dia(is) = 0.d0
          end do

!	  **** loop over all other densities on this atom ****
        do nu = ibf(i), ibf(i) + nbf(i) - 1

!	    **** load the (nu, nu) elements of density matrix ****
            nm = matind(nu) + nu
            call veccou (nm, avec1, bvec1)
            if (mu > nu) then
!	      **** load the (mu, nu) elements of density matrix ****
              nm = matind(mu) + nu
              call veccou (nm, avec2, bvec2)
            end if

            do is = 0, nshell
              if (mu == nu) then
                dia(is) = dia(is) + gamma(mu, mu) * (avec1(is) - bvec1(is))
                avec10 = avec1(0)
              else if (mu > nu) then
!	        **** gamma(mu, nu) = (mu, mu|nu, nu); gamma(nu, mu) = (mu, nu|mu, nu) ***
                dia(is) = dia(is) + gamma(mu, nu)*avec1(is)&
     &                          - gamma(nu, mu)*bvec1(is)
!		**** same atom but different basis functions ****
                off = gamma(nu, mu) * (2.d0*avec2(is) - bvec2(is))&
     &            - gamma(mu, nu) * bvec2(is)
                if (is == 0) then
                  hg = off
                  v = v + off * avec2(0)
                else
                  ff(nm, is) = hg - off
                  v = v - off * dd(nm, is)
                end if
              else
                dia(is) = dia(is) + gamma(nu, mu)*avec1(is)&
     &                          - gamma(mu, nu)*bvec1(is)
              end if
            end do
          end do

!	  **** store fully diagonal terms ****
          nm = matind(mu) + mu
          hg = beta(nm) + ppg(mu, 0) + dia(0)
          v = v + (beta(nm) + hg) * avec10 * 0.5d0
          do is = 1, nshell
            q = ppg(mu, is) + dia(is)
            ff(nm, is) = hg - q
            v = v - q * dd(nm, is) * 0.5d0
          end do

!	  **** off - diagonal atom - atom blocks and energy contribution ****
          do j = 1, i - 1
            do nu = ibf(j), ibf(j) + nbf(j) - 1
              nm = matind(mu) + nu
              call veccou (nm, avec1, bvec1)
              hg = beta(nm) - bvec1(0) * gamma(mu, nu)
              v = v + (beta(nm) + hg) * avec1(0)
              do is = 1, nshell
                q = -bvec1(is) * gamma(mu, nu)
                ff(nm, is) = hg - q
                v = v - q * dd(nm, is)
              end do
            end do
          end do
        end do

!	**** Zerners irregular integrals ****
        k = natt(i)
        if (k > 0) then
          mu = ibf(i)
          do irreg = 1, nirreg
            k1 = ig1(irreg, k)
            k2 = ig2(irreg, k)
            k3 = ig3(irreg, k)
            k4 = ig4(irreg, k)
            gk = g(irreg, k)
            call scfirr (v, mu, gk, k1, k2, k3, k4)
            call scfirr (v, mu, gk, k1, k2, k4, k3)
            call scfirr (v, mu, gk, k3, k4, k1, k2)
            call scfirr (v, mu, gk, k4, k3, k1, k2)
            if (k1 /= k2) then
              call scfirr (v, mu, gk, k2, k1, k3, k4)
              call scfirr (v, mu, gk, k2, k1, k4, k3)
              call scfirr (v, mu, gk, k3, k4, k2, k1)
              call scfirr (v, mu, gk, k4, k3, k2, k1)
            end if
          end do
        end if

      end do

!     ********************* construct total fock matrix **********************

      if (nshell == 1 .and. shft == 0.d0) then
!	**** Closed shell, no damping so just copy single Fock matrix  ****
        do nm = 1, nb2
          aa(nm) = ff(nm, 1)
        end do

      else
       dd1 = dd

!	***** first, zero all matrix elements of total fock matrix ****
        do nm = 1, nb2
          aa(nm) = 0.d0
        end do
!	**** transform Fock matrices into previous MO basis set ****
!	**** doing projections of E and Z eqn 24		****
!	**** uses first two density matrices as work space	****

!	**** these coupling coeffs are almost arbitrary, choose irrational ****
        eltot = 0.d0
        do ishell = 1, nshell
          eltot = eltot + nel(ishell)
        end do

        do ishell = 1, nshell
          wt = 1.d0
!	  **** diagonal terms ISHELL - ISHELL ****
          call ao2mo1 (aa, ff(:, ishell), cc0, dd1, norbl(ishell), norbh(ishell), &
     &          norbl(ishell), norbh(ishell), wt)
!	  **** terms ISHELL - VIRTUAL ****
          call ao2mo1 (aa, ff(:, ishell), cc0, dd1, norbl(ishell), norbh(ishell), &
     &          norbh(nshell) + 1, n, wt)
!	  **** JRRs xtra VIRTUAL - VIRTUAL term (improves order of virtuals) ****
          wt = nel(ishell) / eltot
          call ao2mo1 (aa, ff(:, ishell), cc0, dd1, norbh(nshell) + 1, n, &
     &          norbh(nshell) + 1, n, wt)

!	  **** off - diagonal occupied terms ISHELL - JSHELL ****
          do jshell = ishell + 1, nshell
            wt = 1.d0
            call ao2mo1 (aa, ff(1, ishell), cc0, dd1, norbl(ishell), norbh(ishell), &
     &            norbl(jshell), norbh(jshell), wt)
            wt = -occfr(jshell) / occfr(ishell)
            call ao2mo1 (aa, ff(1, jshell), cc0, dd1, norbl(ishell), norbh(ishell), &
     &            norbl(jshell), norbh(jshell), wt)

          end do
        end do

!	**** shift virtual energies to dampen SCF convergence problems ****

        do is = 1, max(1, nshell - 1)
          do i = norbh(is) + 1, n
            nm = matind(i) + i
            aa(nm) = aa(nm) + shft
          end do
        end do

!	**** back - transform Fock matrix into AO basis ****

        call mo2ao (aa, cc0, dd1, n)

        if (cc0(1, 1) == 0.d0) then
          do nm = 1, nb2
            aa(nm) = ff(nm, 1)
          end do
        end if
      end if
      return
      end subroutine scfmat

!     *************************************************************************

      subroutine scfirr (v, mu, g, k1, k2, k3, k4)

      use reimers_C, only : nshell, avec1, bvec1, avec2, bvec2, matind, ff, dd

      implicit none
      double precision ::   g, q, v, hg, v1
      integer ::            is, k1, k2, k3, k4, mu, nm

!     **** inserts Zerners irregular ints into atomic Fock matrix block ****
!     **** add and contribution to total energy v			 ****
!     **** mu = nber of first basis function of this atom		 ****

      if (k2 >= k1) then
!	**** Coulomb integral, use A vec ****

!	**** mixing of dens(3, 4) ****
        nm = matind(mu + max(k3, k4)) + mu + min(k3, k4)
        call veccou (nm, avec1, bvec1)

!	**** mixing of dens(1, 2) ****
        nm = matind(mu + k2) + mu + k1
        call veccou (nm, avec2, bvec2)

        hg = avec1(0) * g
        v1 = avec2(0) * hg
        do is = 1, nshell
          q = avec1(is) * g
          ff(nm, is) = ff(nm, is) + hg - q
          v1 = v1 - q * dd(nm, is)
        end do
        if (k2 == k1) v1 = 0.5d0 * v1
        v = v + v1
      end if

      if (k3 >= k1) then
!	**** Exchange integral, use - B vec ****

!	**** mixing of dens(2, 4) ****
        nm = matind(mu + max(k2, k4)) + mu + min(k2, k4)
        call veccou (nm, avec1, bvec1)

!	**** mixing of dens(3, 1) ****
        nm = matind(mu + k3) + mu + k1
        call veccou (nm, avec2, bvec2)

        hg = -bvec1(0) * g
        v1 = avec2(0) * hg
        nm = matind(mu + k3) + mu + k1
        do is = 1, nshell
          q = -bvec1(is) * g
          ff(nm, is) = ff(nm, is) + hg - q
          v1 = v1 - q * dd(nm, is)
        end do
        if (k3 == k1) v1 = 0.5d0 * v1
        v = v + v1
      end if

      return
      end subroutine scfirr

!     *************************************************************************

      subroutine veccou (nm, avec1, bvec1)

!     **** determins A and B coeffs for shells of Fock matrix using	****
!     **** E&Z eqn 30c; closed shell terms are set to zero.		****
!     **** nm = matrix element index, shell 0 is the total density	****
!     **** the B vec has the half factor of eqn 30b included		****
      use reimers_C, only : vca, vcb, nshell, dd

      implicit none
      double precision ::   avec1(0:4), bvec1(0:4)
      integer ::            ishell, jshell, nm

      avec1(0) = dd(nm, 1)
      avec1(1) = 0.d0
      bvec1(1) = 0.d0
      do ishell = 2, nshell
        avec1(0) = avec1(0) + dd(nm, ishell)
        avec1(ishell) = 0.d0
        bvec1(ishell) = 0.d0
        do jshell = 2, nshell
          avec1(ishell) = avec1(ishell) + (1.d0 - vca(ishell, jshell)) *&
     &                                dd(nm, jshell)
          bvec1(ishell) = bvec1(ishell) + (1.d0 - vcb(ishell, jshell)) *&
     &                                dd(nm, jshell)
        end do
        bvec1(ishell) = bvec1(ishell) / 2.d0
      end do
      bvec1(0) = avec1(0) / 2.d0

      return
      end subroutine veccou

!     *************************************************************************

! ____________________________________________________________________________
! ________________________ SCF OUTPUT ROUTINES _______________________________
! ____________________________________________________________________________

      subroutine output (c, aii)

      USE chanel_C, only : iw
      use reimers_C, only : n, nshell, norbl, norbh, &
          nmrep, nptg, nr, nsym

      implicit none
      double precision ::  aii(n), c(n, n)
      character*1       ll(5)
      integer ::           notype(8, 5), notot(8)
      integer ::           i, ir, is, nmoou1, nmoou2

!     **** write number of each orb of each symmetry in each shell ****
!     **** get shell operator name ****

      nmoou1 = 1
      nmoou2 = n
      nr = 1
      nptg = 1

      if (nshell == 1) then
        ll(1) = '1'
        ll(2) = 'v'
      else
        ll(1) = '1'
        ll(2) = '2'
        ll(3) = 'v'
      end if

      if (allocated(nsym)) deallocate(nsym)
      allocate(nsym(n))
      do i = 1, n
        nsym(i) = 1
      end do

      do is = 1, nshell + 1
        do ir = 1, nr
          notype(ir, is) = 0
        end do
      end do

      do is = 1, nshell
        do i = norbl(is), norbh(is)
          notype(1, is) = notype(1, is) + 1
        end do
      end do
      is = nshell + 1
      do i = norbh(nshell) + 1, n
          notype(1, is) = notype(1, is) + 1
      end do
      do ir = 1, nr
        notot(ir) = 0
        do is = 1, nshell + 1
          notot(ir) = notot(ir) + notype(ir, is)
        end do
      end do

      write (iw, "(/' Summary of symmetry occupancy in each shell:'//' SHELL  ', 9(a3, 1x))") &
        (nmrep(ir, nptg), ir = 1, nr)
      do is = 1, nshell + 1
        write (iw, '(4x, a1, 1x, 8i4)') ll(is), (notype(ir, is), ir = 1, nr)
      end do
      write (iw, '(1x, a5, 8i4)') 'TOTAL', (notot(ir), ir = 1, nr)

!     ***** page eject for MO dump ****


      if (nmoou1 > nmoou2) return

!     **** first eigenvalues before main dump ****

!     **** dump of molecular orbitals ****
      write (iw, "(/,/,20x,' MOLECULAR ORBITALS ',/,/)")
      call matout(c, aii, n, n, n)
      return
      end subroutine output

!     *************************************************************************

      subroutine gsdip (xz, d, zcore, dm)

!     **** calculates ground-state dipole moment and Mulliken charges ****
      use reimers_C, only : na, nb2, matind, debye, nbf, ibf, nbt, &
          qgs, dipgs, ndtype
      implicit none
      double precision ::  d(nb2), dm(nb2, 3), xz(na, 3), zcore(na), cm(3), &
                        pt(4), pm(3)
      integer ::           ind(0:8), i, j, k, ib, mu, nm, nu

!     ****		identify AO as s, p, d(eg) or d(t2g) ****
      data ind          /1, 2, 2, 2, 3, 3, 4, 4, 4/


      ndtype = 1

      if (allocated(qgs))  deallocate(qgs)
      if (allocated(dipgs))  deallocate(dipgs)
      allocate(qgs(na))
      allocate(dipgs(na, 3))

!     **** zero counters for atomic and hybridization contributions ****
      do i = 1, 3
        cm(i) = 0.d0
        pm(i) = 0.d0
      end do

      do i = 1, na
        qgs(i) = zcore(i)
        dipgs(i, 1) = 0.d0
        dipgs(i, 2) = 0.d0
        dipgs(i, 3) = 0.d0

!	**** break charge up into s, p, d(eg) and d(t2g) contributions ****
        do j = 1, 4
          pt(j) = 0.d0
        end do
        do ib = ibf(i), ibf(i) + nbf(i) - 1
          nm = matind(ib) + ib
          j = ind(nbt(ib))
          pt(j) = pt(j) + d(nm)
        end do

!	**** atomic charge and its contribution to dipole moment ****
        qgs(i) = qgs(i) - pt(1) - pt(2) - pt(3) - pt(4)
        do j = 1, 3
          cm(j) = cm(j) + qgs(i) * xz(i, j)
        end do

        if (ndtype /= 1 .or. nbf(i) <= 1) then
!	  **** no hybridization contribution from this atom ****
        else
!	  **** determine hybridization contribution ****
          do mu = ibf(i), ibf(i) + nbf(i) - 1
            do nu = ibf(i), mu - 1
              nm = matind(mu) + nu
              do k = 1, 3
                dipgs(i, k) = dipgs(i, k) + d(nm) * dm(nm, k)
              end do
            end do
          end do
          do j = 1, 3
            dipgs(i, j) = dipgs(i, j) * debye * 2.d0
            pm(j) = pm(j) + dipgs(i, j)
          end do
        end if

      end do

      do j = 1, 3
        cm(j) = cm(j) * debye
      end do
      return
      end subroutine gsdip

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine matout(a, b, nc, nr, ndim)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : numat, method_indo
      use common_arrays_C, only : nfirst, nlast, nat
      use chanel_C, only : iw
      use elemts_C, only : elemnt
!***********************************************************************
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: nc
      integer , intent(inout) :: nr
      integer , intent(in) :: ndim
      double precision , intent(in) :: a(ndim,ndim)
      double precision , intent(in) :: b(ndim)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(:), allocatable :: natom
      integer :: i, jlo, jhi, l, j, ka, kc, kb, la, lc, lb
      character :: ref_atorbs(9,2)*2, atorbs(9)*2
      character, dimension(:), allocatable :: itext*2, jtext*2

      save atorbs
!-----------------------------------------------
!**********************************************************************
!
!      MATOUT PRINTS A SQUARE MATRIX OF EIGENVECTORS AND EIGENVALUES
!
!    ON INPUT A CONTAINS THE MATRIX TO BE PRINTED.
!             B CONTAINS THE EIGENVALUES.
!             NC NUMBER OF MOLECULAR ORBITALS TO BE PRINTED.
!             NR IS THE SIZE OF THE SQUARE ARRAY TO BE PRINTED.
!             NDIM IS THE ACTUAL SIZE OF THE SQUARE ARRAY "A".
!             NFIRST AND NLAST CONTAIN ATOM ORBITAL COUNTERS.
!             NAT = ARRAY OF ATOMIC NUMBERS OF ATOMS.
!
!
!***********************************************************************
      data ref_atorbs/ ' S', 'PX', 'PY', 'PZ', 'X2', 'XZ', 'Z2', 'YZ', 'XY', &
                       ' S', 'PX', 'PY', 'PZ', 'Z2', 'X2', 'XY', 'XZ', 'YZ'/
      if (method_indo) then
        atorbs(:) = ref_atorbs(:,2)
      else
        atorbs(:) = ref_atorbs(:,1)
      end if
      i = max(ndim, 1)
      allocate (itext(i), jtext(i), natom(i))
      if (nlast(numat) /= nr) go to 30
      do i = 1, numat
        jlo = nfirst(i)
        jhi = nlast(i)
        l = nat(i)
        itext(jlo:jhi) = atorbs(:jhi-jlo+1)
        jtext(jlo:jhi) = elemnt(l)
        natom(jlo:jhi) = i
      end do
      go to 50
   30 continue
      nr = abs(nr)
      do i = 1, nr
        itext(i) = '  '
        jtext(i) = '  '
        natom(i) = i
      end do
   50 continue
      ka = 1
      kc = 6
   60 continue
      kb = min0(kc,nc)
      write (iw, 100) (i,i=ka,kb)
      if (b(1) /= 0.D0) write (iw, 110) (b(i),i=ka,kb)
      write (iw, 120)
      la = 1
      lc = 40
   70 continue
      lb = min0(lc,nr)
      do i = la, lb
        if (itext(i) == ' S') write (iw, 120)
        write (iw, 130) itext(i), jtext(i), natom(i), (a(i,j),j=ka,kb)
      end do
      if (lb == nr) go to 90
      la = lc + 1
      lc = lc + 40
      go to 70
   90 continue
      if (kb == nc) return
      ka = kc + 1
      kc = kc + 6
      go to 60
!
  100 format(/,/,/,/,3x,' ROOT NO.',i5,9i12)
  110 format(/,8x,10f12.5)
  120 format('  ')
  130 format(2(1x,a2),i4,f10.5,10f12.5)
!
      end subroutine matout

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine modgra ()
   !***********************************************************************
   !
   !   MODGRA prints the gradients due to (a) backbone residue atoms, and
   !   (b) all side-chain atoms in each residue.
   !
   !***********************************************************************
    use molkst_C, only: numat, nvar, maxtxt, natoms
    use chanel_C, only: iw
    use common_arrays_C, only : grad, loc, txtatm
    use MOZYME_C, only : nres, at_res, res_start
    implicit none
    double precision, allocatable :: rgrad(:), res_grad_b(:), res_grad_s(:)
    double precision :: sum
    integer :: i, j
    logical :: L_protein
    allocate(rgrad(natoms), res_grad_b(natoms), res_grad_s(natoms))
    call build_res_start_etc()
!
!  Put atomic gradients into an atom-based array
!
    rgrad      = 0.d0
    res_grad_b = 0.d0
    res_grad_s = 0.d0
    do i = 1, nvar
      j = loc(1, i)
      rgrad(j) = rgrad(j) + grad(i) ** 2
    end do
    l_protein = .false.
    do i = 1, numat
      j = at_res(i)
      if (txtatm(i)(:6) == "ATOM  " .and. &
      (txtatm(i)(13:15) == " CA" .or. txtatm(i)(13:15) == " N " .or. txtatm(i)(13:15) == " C ")) then
        res_grad_b(j) = res_grad_b(j) + rgrad(i)
        l_protein = .true.
      else
        res_grad_s(j) = res_grad_s(j) + rgrad(i)
      end if
    end do
    sum = 0.d0
    do i = 1, nres
      res_grad_b(i) = sqrt(res_grad_b(i))
      res_grad_s(i) = sqrt(res_grad_s(i))
      sum = sum + res_grad_b(i) + res_grad_s(i)
    end do
    if (l_protein) then
      if (sum < 0.5d0) then
        write (iw,"(/12x,a,/)") " ALL GRADIENTS FOR ALL BACKBONES PLUS SIDE CHAINS ARE VERY SMALL"
      else
        write (iw,"(/12x,a,/)") " GRADIENTS FOR ALL BACKBONES"
        write (iw,"(a)")"     Residue        Backbone    Side-Chain        Total"
        write(iw,*)
        do i = 1, nres
          if (txtatm(res_start(i))(18:20) /= "HOH" .or. abs(res_grad_s(i)) > 1.d0) &
            write(iw,'(4x, a, f15.3, f12.3, f15.3)')txtatm(res_start(i))(18:maxtxt), &
            res_grad_b(i), res_grad_s(i), res_grad_b(i) + res_grad_s(i)
          end do
      end if
    else
      if (sum < 0.5d0) then
        write (iw,"(/12x,a,/)") " ALL GRADIENTS FOR ALL GROUPS ARE VERY SMALL"
      else
        write (iw,"(/13x,a,/)") " GRADIENTS FOR ALL GROUPS"
        write (iw,"(11x,a)")"     Group       Gradient"
        write(iw,*)
        write(iw,'(14x, a, f13.3)')(txtatm(res_start(i))(18:20)//" "//txtatm(res_start(i))(23:26),  &
          res_grad_s(i),i = 1, nres)
      end if
    end if
    return
end subroutine modgra

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  subroutine site(neutral, chain, res, alt, charge, nres, max_sites, allkey)
  use common_arrays_C, only : geo, coord, labels, nat, nbonds, ibonds, &
    atmass, txtatm, tvec, lopt
  use parameters_C, only : ams
  use chanel_C, only : iw, job_fn
  use elemts_C, only : elemnt
  use molkst_C, only : numat, natoms, line, keywrd, id, moperr,maxtxt
  use funcon_C,  only : pi
  implicit none
  logical, intent(in) :: neutral(100)
  integer, intent (in) :: nres, res(nres), max_sites
  character, intent (in) :: chain(nres)*1, alt(nres)*1
  character, intent (inout) :: charge(max_sites,3)*1, allkey*3000
  integer :: i_atom, i_charge
  integer :: i, j, k, l, m, n, o(2), jres, metals(1), nmetals = 0, nadd, ndel, p, ncarbon, &
    nb_icc, nc_icc, nd_icc
  logical :: l_res, bug = .false., first, let, l_type, first_2
  character :: res_txt*16, txt*26, num*1, line_1*1200
  character, allocatable :: changes(:)*30
  double precision :: bond_length, angle, dihedral, internal_dihedral, tetrahedral, sum
  logical, allocatable :: l_used(:)
  integer, allocatable :: hybrid(:)
  double precision, external :: reada, distance
  i = max(20,numat)
  allocate (changes(i), l_used(natoms), hybrid(natoms))
  l_used = .false.
  labels(numat + 1:) = 0
  tetrahedral = 109.4712206d0
  let = (index(keywrd," LET ") /= 0)
  first = (.not. let)
  first_2 = .true.
  i = index(keywrd," SITE=")
  j = index(keywrd(i:), ") ") + i
  k = index(allkey, "SALT")
  if (k /= 0) then
    k = index(allkey, " SITE")
    l = index(allkey(k:), ") ") + k - 1
    allkey = " """//allkey(k + 1:l)//""" => "//keywrd(i:j)
  end if
  changes = " "
  nadd = 0
  ndel = 0
  ncarbon = 0
  lopt(:,natoms + 1:) = 1
  geo(:,:natoms) = coord(:,:natoms)
  i_charge = 100
  do i_atom = 1, numat
    if (txtatm(i_atom)(22:22) /= " " .and. txtatm(i_atom)(22:22) /= "A") exit
  end do
  if (i_atom > numat) then
!
! No chain letters, so insert letter "A" into all atom labels
!
    do i_atom = 1, numat
      txtatm(i_atom)(22:22) = "A"
    end do
  end if
  call check_cvs(.true.)
  jres = 0
  do i_atom = 1, numat
    l_res = .false.
    if (nres > 0) then
      do jres = 1, nres
        if (txtatm(i_atom)(22:22) /= chain(jres)) cycle
        if (txtatm(i_atom)(27:27) /= alt(jres)) then
          i = i + 1
          cycle
        end if
        i = nint(reada(txtatm(i_atom), 23))
        if (i == res(jres) .and. charge(jres,1) /= "*") exit
      end do
      l_res = (jres <= nres)
      if (l_res) then
        if (charge(jres,1) == "+") then
          i_charge = 1
        else if (charge(jres,1) == "-") then
          i_charge = -1
        else
          i_charge = 0
        end if
      else
        i_charge = 100 ! this means "not l_res"
      end if
    end if
!
!  Deliberately add or remove hydrogen atoms as required by keyword "SITE"
!  This request uses sites defined in the "C" style in the manual, e.g., "[HIS]239:A.NE2"(+)
!
    if (neutral(5) .or. neutral(6) .or. l_res) then !  Must be -Arg(+)- or -Arg(0)-
!
!  Check for Arg(0) or Arg(+)
!
      l_type = (txtatm(i_atom)(18:20) == "ARG")
      if (l_type .and. nat(i_atom) == 6 .and. nbonds(i_atom) == 3) then
        if (nat(ibonds(1, i_atom)) == 7 .and. &
            nat(ibonds(2, i_atom)) == 7 .and. &
            nat(ibonds(3, i_atom)) == 7 ) then! System is C bonded to three N, check for number of H on N
          i = 0
          do j = 1, 3
            i = i + nbonds(ibonds(j,i_atom))
          end do
          if (i_charge /= 100 .and. (i == 8 .or. i == 9)) charge(jres,1:2) = charge(jres,2:3)
          if (i /= 9 .and. (neutral(6) .or. i_charge == 0) .or. i /= 8 .and. (neutral(5) .or. i_charge == 1)) cycle
          if (neutral(6) .or. i_charge == 0) then
!
! Found the system -NH-C(NH2)2, now delete a hydrogen atom
!
            do j = 1, 3
              if (nbonds(ibonds(j, i_atom)) == 3) then
                l = ibonds(j, i_atom)
                k = 0
                if (nat(ibonds(1,l)) == 1) k = k + 1
                if (nat(ibonds(2,l)) == 1) k = k + 1
                if (nat(ibonds(3,l)) == 1) k = k + 1
                if (k == 2) then
                  if (nat(ibonds(1,l)) == 1) then
                    k = ibonds(1,l)
                  else
                    k = ibonds(2,l)
                  end if
                  nat(k) = 99
                  ibonds(nbonds(i_atom), i_atom) = 0
                  nbonds(i_atom) = nbonds(i_atom) - 1
                  exit
                end if
              end if
            end do
          else if (neutral(5) .or. i_charge == 1) then
!
! Found the system -NH-C(NH2)(NH), now add a hydrogen atom
!
            do j = 1, 3
              if (nbonds(ibonds(j, i_atom)) == 2) then ! Found a N with two bonds
                l = ibonds(j, i_atom)
                call add_sp2_H(ibonds(1,l), l, ibonds(2,l))
                numat = numat + 1
                if (i_charge /= 100) charge(jres,1:2) = charge(jres,2:3)
                nbonds(i_atom) = nbonds(i_atom) + 1
                ibonds(nbonds(i_atom), i_atom) = numat
                nadd = nadd + 1
                changes(nadd)(:15) = trim(txtatm(l)(12:))
                write(txtatm(natoms),'(a,i5," 3H",a)')txtatm(l)(:6), natoms, txtatm(l)(15:)
                exit
              end if
            end do
          end if
        end if
      end if
    end if
    if (neutral(11) .or. neutral(12) .or. l_res) then !  Must be -Lys(+)- or -Lys(0)-
!
!  Check for Lys(0) or Lys(+)
!
      l_type = (txtatm(i_atom)(18:20) == "LYS")
      if (l_type .and. txtatm(i_atom)(14:15) == "NZ" ) then
        if (neutral(12) .or. i_charge == 0) then
!
! Found the system -NH3(+), now delete a hydrogen atom
!
          do j = 1, 3
            if (nbonds(ibonds(j, i_atom)) == 3) then
              l = ibonds(j, i_atom)
              k = 0
              if (nat(ibonds(1,l)) == 1) k = k + 1
              if (nat(ibonds(2,l)) == 1) k = k + 1
              if (nat(ibonds(3,l)) == 1) k = k + 1
              if (k == 2) then
                if (nat(ibonds(1,l)) == 1) then
                  k = ibonds(1,l)
                else
                  k = ibonds(2,l)
                end if
                nat(k) = 99
                ibonds(nbonds(i_atom), i_atom) = 0
                nbonds(i_atom) = nbonds(i_atom) - 1
                exit
              end if
            end if
          end do
        else if ((neutral(11) .or. i_charge == 1) .and. nbonds(i_atom) == 3) then
!
!  Nitrogen bonded to three atoms, add a hydrogen atom.
!
          if (nbonds(i_atom) == 3 .and. i_charge /= 100) charge(jres,1:2) = charge(jres,2:3)
          call add_sp3_H(ibonds(1,i_atom), i_atom, ibonds(2,i_atom), ibonds(3,i_atom))
          nbonds(i_atom) = nbonds(i_atom) + 1
          ibonds(nbonds(i_atom), i_atom) = numat
          numat = numat + 1
          nadd = nadd + 1
          changes(nadd)(:15) = trim(txtatm(i_atom)(12:))
          write(txtatm(natoms),'(a,i5," 3H",a)')txtatm(i_atom)(:6), natoms, txtatm(i_atom)(15:)
        end if
      end if
    end if
    if (neutral(1)  .or. neutral(2) .or. l_res) then
      if (nat(i_atom) == 6 .and. (nbonds(i_atom) == 3 .or. (nbonds(i_atom) > 2 .and. l_res))) then
!
! check for -COOH or -COO(-) or -CH2OH or -CH2O(-)
!
        k = 0
        l = 0
        m = 0
        do i = 1,3
          j = ibonds(i,i_atom)
          if (nat(j) == 8) then
            if (nbonds(j) == 1) then
              k = k + 1
              m = m + 1
            else if (nbonds(j) == 2 .and. (nat(ibonds(1,j)) == 1 .or. nat(ibonds(2,j)) == 1)) then
              k = k + 1
            end if
            l = j
          end if
        end do
!
!  k is the number of oxygen atoms that are ionizable or are ionized
!
        if (k > 0) then
          if (k == 2 .or. k == 1 .and. (nbonds(i_atom) == 4 .or. &! A bit ugly, but it checks for ">C=O" of a peptide bond
            (l_res .and. nbonds(i_atom) == 3 .and. distance(i_atom, l) > 1.3d0))) then
            if (i_charge == 1) then
!
!  Panic: -COO found, but charge is impossible.  Check for another charge on the same residue
!
              do i = jres + 1, nres
                if (chain(i) == chain(jres) .and. res(i) == res(jres)) then
!
!  Found one.  Swap charges and hope for the best
!
                    do k = 1, 3
                      num = charge(i,k)
                      charge(i,k) = charge(jres,k)
                      charge(jres,k) = num
                    end do
                    if (charge(jres,1) == "+") then
                      i_charge = 1
                    else if (charge(jres,1) == "-") then
                      i_charge = -1
                    else
                      i_charge = 0
                    end if
                    exit
                  end if
              end do
            end if
            if (m == 2 .and. i_charge == -1) then
              if (.not. bug) write(iw,*)
              write(iw,'(10x,a)')"A charge of -1 requested for -COO in """//txtatm(i_atom)(18:)// &
              & """, but current charge is already -1"
              bug = .true.
            end if
            if(neutral(2) .or. i_charge == -1) then ! Make it -COO(-) or -CH2O(-)
              do i = 1, nbonds(i_atom)
                j = ibonds(i,i_atom)
                o = 0
                o(1) = nat(ibonds(1,j))
                if (nbonds(j) == 2) o(2) = nat(ibonds(2,j))
                if (nat(j) == 8 .and. nbonds(j) == 2 .and. (o(1) == 1 .or. o(2) == 1)) then
                  if(nat(ibonds(1,j)) == 1) nat(ibonds(1,j)) = 99
                  if(nat(ibonds(2,j)) == 1) nat(ibonds(2,j)) = 99
                  ibonds(nbonds(j), j) = 0
                  nbonds(j) = nbonds(j) - 1
                  if (jres > 0) charge(jres,1:2) = charge(jres,2:3)
                  exit
                end if
              end do
            else if(neutral(1) .or. i_charge == 0) then
              k = 0
              l = 0
              do i = 1, nbonds(i_atom)
                j = ibonds(i,i_atom)
                if (nat(j) == 8 .and. nbonds(j) == 2) then
                  if (nat(ibonds(1,j)) == 1 .or. nat(ibonds(2,j)) == 1) k = k + 1
                end if
                if (nat(j) == 8 .and. nbonds(j) == 1) then
                  l = l + 1
                  o(l) = j
                end if
              end do
              if (k == 0 .and. (l == 2 .and. nbonds(i_atom) == 3 .or. l == 1 .and. nbonds(i_atom) == 4)) then
!
!  -COO(-) or -CH2O(-) group identified.  Now add a hydrogen
!
                call add_sp_H(j, o(1), o(2))
                m = 1
                call h_type(22, j, .false., m, nb_icc, nc_icc, nd_icc, bond_length, angle, dihedral, internal_dihedral, &
        hybrid, metals, nmetals)
                if (abs(bond_length - 1.d0) < 1.d-3) then
                  angle = angle*pi/180.d0
                  call add_a_generic_hydrogen_atom(j, nb_icc, nc_icc, bond_length, angle, dihedral, metals, nmetals)
                  geo(:,numat) = coord(:,numat)
                  nbonds(j) = nbonds(j) + 1
                  ibonds(nbonds(j), j) = numat
                  nadd = nadd + 1
                  changes(nadd)(:15) = trim(txtatm(j)(12:))
                  charge(jres,1:2) = charge(jres,2:3)
                  write(txtatm(natoms),'(a,i5," 3H",a)')txtatm(j)(:6), natoms, txtatm(j)(15:)
                end if
              end if
            end if
          end if
        end if
      end if
    end if
    if (neutral(3) .or. neutral(4) .or. l_res) then !  Must be -NH3(+) or -NH2
      if (nat(i_atom) == 7) then
!
!  Exclude -NH-C-(NH2) type
!
        do j = 1, nbonds(i_atom)
          if (nat(ibonds(j,i_atom)) == 6) then
            i = ibonds(j,i_atom)
            l = 0
            do k = 1, nbonds(i)
              if (nat(ibonds(k,i)) == 7) l = l + 1
            end do
            if (l == 3) exit
          end if
        end do
        if (l == 3) cycle
        i = 0
        l = 0
        do j = 1, nbonds(i_atom)
          if (nat(ibonds(j,i_atom)) == 1) i = i + 1
          do k = 1, nbonds(ibonds(j,i_atom))
            m = ibonds(k, ibonds(j,i_atom))
            if (nat(m) == 7 .and. m /= i_atom) l = 1
          end do
        end do
        if (l == 1) cycle
        if (i == 2 .and. (neutral(3) .or. i_charge == 1) .and. nbonds(i_atom) == 3) then
!
!  Selectively exclude -CO-NH2 if all -NH2 are flagged for ionization
!
          if (neutral(3)) then
            do i = 1, nbonds(i_atom)
              j = ibonds(i,i_atom)
              if (nat(j) == 6) exit
            end do
            if (i <= nbonds(i_atom)) then
              do i = 1, nbonds(j)
                if (nat(ibonds(i,j)) == 8) exit
              end do
              if (i <= nbonds(j)) cycle
            end if
          end if
!
!  Nitrogen bonded to two hydrogen atoms, add a hydrogen atom.
!
          if ((i == 2 .and. nbonds(i_atom) == 3 .or. i == 3 .and. nbonds(i_atom) == 4) &
          .and. i_charge /= 100) charge(jres,1:2) = charge(jres,2:3)
          call add_sp3_H(ibonds(1,i_atom), i_atom, ibonds(2,i_atom), ibonds(3,i_atom))
          nbonds(i_atom) = nbonds(i_atom) + 1
          ibonds(nbonds(i_atom), i_atom) = numat
          numat = numat + 1
          nadd = nadd + 1
          changes(nadd)(:15) = trim(txtatm(i_atom)(12:))
          write(txtatm(natoms),'(a,i5," 3H",a)')txtatm(i_atom)(:6), natoms, txtatm(i_atom)(15:)
          continue
        else if (i == 3 .and. (neutral(4) .or. i_charge == 0) .and. nbonds(i_atom) == 4) then
!
!  Nitrogen bonded to three hydrogen atoms, delete a hydrogen atom.
!
          do i = 1, 4
            if (nat(ibonds(i, i_atom)) == 1) then
              j = ibonds(i, i_atom)
              nat(j) = 99
              ibonds(nbonds(i_atom), i_atom) = 0
              nbonds(i_atom) = nbonds(i_atom) - 1
              charge(jres,1:2) = charge(jres,2:3)
              exit
            end if
          end do
        end if
      end if
    end if
    if (neutral(7) .or. neutral(8) .or. l_res) then!  Must be -His(+) or -His(0)-
!
!  Check for His(0) or His(+)
!
      if (nat(i_atom) == 6 .and. nbonds(i_atom) == 3) then
        j = 0
        k = 0
        do i = 1, 3
          if (nat(ibonds(i, i_atom)) == 7 ) j = j + 1
          if (nat(ibonds(i, i_atom)) == 1 ) k = k + 1
        end do
        if (j == 2 .and. k == 1) then! System is C bonded to two N and one H, therefore His
          i = 0
          do j = 1,3
            k = ibonds(j,i_atom)
            do l = 1, nbonds(k)
              m = ibonds(l,k)
              if (nat(m) == 1) i = i + 1
            end do
          end do
          if (i /= 2 .and. (neutral(8) .or. i_charge == 0) .or. i /= 1 .and. (neutral(7) .or. i_charge == 1)) cycle
          if (i_charge /= 100) charge(jres,1:2) = charge(jres,2:3)
          if (neutral(8) .or. i_charge == 0) then
!
! Found a His(+), now delete a hydrogen atom
!
            outer_loop: do j = 1,3
              k = ibonds(j,i_atom)
              do l = 1, nbonds(k)
                m = ibonds(l,k)
                if (nat(m) == 1) then
                  nat(m) = 99
                  ibonds(nbonds(i_atom), i_atom) = 0
                  nbonds(i_atom) = nbonds(i_atom) - 1
                  exit outer_loop
                end if
              end do
            end do outer_loop
          else if (neutral(7) .or. i_charge == 1) then
!
! Found the system -C-N-C-, now add a hydrogen atom
!
            do j = 1, 3
              if (nbonds(ibonds(j, i_atom)) == 2) then ! Found a N with two bonds
                l = ibonds(j, i_atom)
                call add_sp2_H(ibonds(1,l), l, ibonds(2,l))
                numat = numat + 1
                nbonds(l) = nbonds(l) + 1
                ibonds(nbonds(l), l) = numat
                nadd = nadd + 1
                changes(nadd)(:15) = trim(txtatm(l)(12:))
                write(txtatm(natoms),'(a,i5," 3H",a)')txtatm(l)(:6), natoms, txtatm(l)(15:)
                exit
              end if
            end do
          end if
        end if
      end if
    end if
    if (neutral(9)) then  !  Check for sulfate.  If the structure S-O-H exists, delete the "H"
      if (nat(i_atom) == 8 .and. nbonds(i_atom) == 2) then
        do j = 1, 2
          if (nat(ibonds(j,i_atom)) == 16) exit  !  Look for a sulfur atom attached to the oxygen
        end do
        if (j < 3) then
          do k = 1, 2
            if (nat(ibonds(k,i_atom)) == 1) exit  !  Look for a hydrogen atom attached to the oxygen
          end do
          if (k < 3) then
            l = ibonds(j,i_atom)
            m = 0
            do n = 1, nbonds(l)
              if (nat(ibonds(n,l)) == 8) m = m + 1
            end do
            if (m == 4) then
              m = ibonds(k,i_atom)
              nat(m) = 99
              ibonds(k, i_atom) = 0
              nbonds(i_atom) = nbonds(i_atom) - 1
            end if
          end if
        end if
      end if
    end if
    if (neutral(10)) then
!  Check for phosphate.
!
!  Aim for [PO4](-), e.g., CH3-PO4-H
!
      if (nat(i_atom) == 8 .and. nbonds(i_atom) == 2) then
        do j = 1, 2
          if (nat(ibonds(j,i_atom)) == 15) exit  !  Look for a phosphorus atom attached to the oxygen
        end do
        if (j < 3) then
          if(nbonds(ibonds(j,i_atom)) == 4) then
!
!   oxygen atoms on phosphorus should be attached to only two ligands
!
            m = ibonds(j,i_atom)
            l = 0
            do k = 1, 4
              if (nat(ibonds(k,m)) == 8 .and. nbonds(ibonds(k,m)) == 2) then
                if (nat(ibonds(1, ibonds(k,m))) /= 99 .and. nat(ibonds(2, ibonds(k,m))) /= 99) l = l + 1
              end if
            end do
            if (l > 2) then
              do k = 1, 2
                if (nat(ibonds(k,i_atom)) == 1) exit  !  Look for a hydrogen atom attached to the oxygen
              end do
              if (k < 3) then
                l = ibonds(j,i_atom)
                m = 0
                do n = 1, nbonds(l)
                  if (nat(ibonds(n,l)) == 8) m = m + 1
                end do
                if (m == 4) then
                  nat(ibonds(k,i_atom)) = 99
                  ibonds(nbonds(i_atom), i_atom) = 0
                  nbonds(i_atom) = nbonds(i_atom) - 1
                end if
              end if
            end if
          end if
        end if
      end if
    end if
    if (l_res) then
      if (charge(jres,1) /= "*") then
!
!  Check for sulfate
!
        if (nat(i_atom) == 16 .and. nbonds(i_atom) == 4) then
          k = 2
          do i = 1, 4
            j = ibonds(i, i_atom)
            if (nat(j) /= 8) exit
            if (nbonds(j) == 1) k = k - 1
          end do
          if (i == 5) then

!
!  Found a sulfate.
!
            i_charge = min(0, i_charge)
            if (charge(jres,2) == "-") i_charge = -2
!
!  Work out the change in the number of ionized atoms
!  If i_charge becomes negative, delete hydrogen atoms
!
            i_charge = i_charge - k
            if (i_charge < 0) then
!
!   Now delete hydrogens, as necessary.
!
              do i = 1, -i_charge
                do l = 1, 4
                  j = ibonds(l, i_atom)
                  if (nbonds(j) == 2) then
                    if(nat(ibonds(2,j)) == 1) exit
                  end if
                end do
                if (l < 5) then
                  nat(ibonds(2,j)) = 99
                  ibonds(nbonds(i_atom), i_atom) = 0
                  nbonds(i_atom) = nbonds(i_atom) - 1
                end if
              end do
            else if (i_charge > 0) then
!
!   Now add hydrogens, as necessary.
!
              l = 1
              do i = 1, 4
                j = ibonds(i, i_atom)
                if (nbonds(j) == 1) then
                  do k = 1, 4
                    if (k /= i) exit
                  end do
                  call add_sp_H(j, i_atom, ibonds(k,i_atom))
                  numat = numat + 1
                  nbonds(i_atom) = nbonds(i_atom) + 1
                  ibonds(nbonds(i_atom), i_atom) = numat
                  nadd = nadd + 1
                  changes(nadd)(:15) = trim(txtatm(j)(12:))
                  l = l + 1
                  if (l > i_charge) exit
                end if
              end do
            end if
            charge(jres,1) = "*"
          end if
        end if
      end if
!
!  Check for phosphate
!
      if (nat(i_atom) == 15 .and. nbonds(i_atom) == 4) then
        k = 1
        do i = 1, 4
          j = ibonds(i, i_atom)
          if (nat(j) /= 8) exit
          if (nbonds(j) == 1) k = k - 1
        end do
        if (i == 5) then

!
!  Found a phosphate.
!
          i_charge = min(0, i_charge)
          if (charge(jres,2) == "-") i_charge = -2
!
!  Work out the change in the number of ionized atoms
!  If i_charge becomes negative, delete hydrogen atoms
!
          i_charge = i_charge - k
          if (i_charge < 0) then
!
!   Now delete hydrogens, as necessary.
!
            do i = 1, -i_charge
              do l = 1, 4
                j = ibonds(l, i_atom)
                if (nbonds(j) == 2) then
                  if(nat(ibonds(2,j)) == 1) exit
                end if
              end do
              if (l < 5) then
                nat(ibonds(2,j)) = 99
                charge(jres,1:2) = charge(jres,2:3)
                ibonds(nbonds(i_atom), i_atom) = 0
                nbonds(i_atom) = nbonds(i_atom) - 1
              end if
            end do
          else if (i_charge > 0) then
!
!   Now add hydrogens, as necessary.
!
            l = 1
            do i = 1, 4
              j = ibonds(i, i_atom)
              if (nbonds(j) == 1) then
                do k = 1, 4
                  if (k /= i) exit
                end do
                call add_sp_H(j, i_atom, ibonds(k,i_atom))
                numat = numat + 1
                nbonds(i_atom) = nbonds(i_atom) + 1
                ibonds(nbonds(i_atom), i_atom) = numat
                nadd = nadd + 1
                changes(nadd)(:15) = trim(txtatm(j)(12:))
                write(txtatm(natoms),'(a,i5," 3H",a)')txtatm(j)(:6), natoms, txtatm(j)(15:)
                charge(jres,1:2) = charge(jres,2:3)
                l = l + 1
                if (l > i_charge) exit
              end if
            end do
          else
            charge(jres,1:2) = charge(jres,2:3)
          end if
        end if
      end if
    end if
  end do
!
!  Now check for explicit atoms
!
  i = index(keywrd," SITE=")
  j = index(keywrd(i:), ") ") + i
  if (j == i) then
    line = "ERROR IN KEYWORD ""SITE"" - no closing "")"""
    call mopend(trim(line))
    return
  end if
!
!  In the next block "txt_to_atom_no" cannot be used, because the PDB text is
!  needed for recognizing the atom.
!
  do
    k = Index (keywrd(i:), ") ") + i
    j = index(keywrd(i:k),"""") + i
    if (j == i) exit
    l = index(keywrd(j:),"""") + j
    line = keywrd(j:l - 2)
    if (line(1:1) == "[") then
!
! Atom defined using Jmol format
!
      n = index(keywrd(j:l - 2),".") + j
      k = index(keywrd(j:l - 2),":") + j
      m = index(keywrd(j:l - 2),"]") + j
      if (n == j .or. m == j) then
        if (n == j) write(iw,'(/10x,a)')"""."" Missing in JSmol atom label: """//keywrd(j:l - 2)//'"'
        if (m == j) write(iw,'(/10x,a)')"""]"" Missing in JSmol atom label: """//keywrd(j:l - 2)//'"'
        call mopend("ERROR IN JSMOL ATOM LABEL IN KEYWORD ""SITE""")
        return
      end if
      if (k == j) then
        line = keywrd(n:l - 2)//keywrd(j + 1:m - 2)//keywrd(j + 5:n - 2)
      else
        line = keywrd(n:l - 2)//keywrd(j + 1:m - 2)//keywrd(k:k)//keywrd(m:k - 2)
      end if
    end if
    keywrd(j:) = trim(line)//trim(keywrd(l - 1:))
    i = j + len_trim(line) + 2
  end do
  i = index(keywrd," SITE=")
  j = index(keywrd(i:), ") ") + i
  line = keywrd(i + 6:j)
  do
    i = index(line, """")
    if (i == 0) exit
    do j = i + 1, len_trim(line)
      if (line(j:j) == """") exit
    end do
!
! Convert one PDB label into an atom-number
! First, run a check to confirm that the PDB label exists in the data-set
! and that it is only used for one atom.
!
    line_1 = trim(line)
    call txt_to_atom_no(line_1, i, .false.)
    if (moperr) return
    res_txt = line(i + 1: j - 1)
    if (line(j + 2:j + 2) == "+") i_charge = 1
    if (line(j + 2:j + 2) == "0") i_charge = 0
    if (line(j + 2:j + 2) == "-") i_charge = -1
    if (line(j + 3:j + 3) == "2") i_charge = i_charge*2
    if (line(j + 3:j + 3) == "3") i_charge = i_charge*3
    line = line(j + 1:)
    m = 0
    do k = 1, len_trim(res_txt)
      if (res_txt(k:k) /= " ") then
        m = m + 1
        res_txt(m:m) = res_txt(k:k)
      end if
    end do
    res_txt(m + 1:) = " "
    do i = 1, numat
      txt = trim(txtatm(i))
      n = 0
      do k = 13, maxtxt
        if (txt(k:k) /= " ") then
          n = n + 1
          txt(n:n) = txt(k:k)
        end if
      end do
      txt(n + 1:) = " "
      n = max(n, m)
      do k = 1, n
        if (res_txt(k:k) /= txt(k:k) .and. res_txt(k:k) /= "*") exit
      end do
      if (k > n) exit
    end do
    if (i > numat) then
      if (first) then
        write(iw,'(/10x,a)')"An atom defined by keyword SITE does not match an atom in the system."
        write(iw,'(/10x,a)')"To ignore messages of this type, add keyword ""LET"""
        first = .false.
      end if
      k = index(allkey, " SITE")
      l = index(allkey(k:), ") ") + k - 1
      do
        k = k + 1
        if (k >= l) exit
        if (allkey(k:k) == '"') then
!
!  Start of an atom-label
!
          i = k
          do
            k = k + 1
            if (allkey(k:k) == '"') exit
          end do
!
!  End of atom-label
!
          if (allkey(i + 1:i + 1) == "[") then
            n = index(allkey(i:k),".") + i
            p = index(allkey(i:k),":") + i
            m = index(allkey(i:k),"]") + i
            if (n == i  .or. m == i) then
              if (n == i) write(iw,'(/10x,a)')"""."" Missing in JSmol atom label: "//allkey(i:k)
              if (m == i) write(iw,'(/10x,a)')"""]"" Missing in JSmol atom label: "//allkey(i:k)
              call mopend("ERROR IN JSMOL ATOM LABEL IN KEYWORD ""SITE""")
              return
            end if
            if (p == i) then
!
!  Chain-letter missing, so:
!
              txt = allkey(n:k - 1)//allkey(i + 2:i + 4)//allkey(i + 6:n - 2)
            else
              txt = allkey(n:k - 1)//allkey(i + 2:m - 2)//allkey(p:p)//allkey(m:p - 2)
            end if
          else
            txt = allkey(i + 1:k - 1)
          end if
          m = 0
          do n = 1, len_trim(txt)
            if (txt(n:n) /= " ") then
              m = m + 1
              txt(m:m) = txt(n:n)
            end if
          end do
          txt(m + 1:) = " "
          if (trim(txt) == trim(res_txt)) exit
        end if
      end do
      if (.not. let .and. first_2) call mopend("FAULT DETECTED IN KEYWORD ""SITE"" AT: "//allkey(i:k))
      first_2 = .false.
      cycle
    end if
    if (abs(i_charge) > 1 .and. nat(i) /= 6) then
      call mopend("IN ""SITE"" THE USE OF MULTIPLE CHARGES IS ONLY ALLOWED FOR CARBON ATOMS")
      return
    end if
    if (l_used(i)) then
      num = char(ichar("2") + int(log10(i*1.0001)))
      if (nat(i) == 6) then
        num = char(ichar("2") + int(log10(i*1.0001))) 
        write(iw,'(/5x, a, i'//num//', a)')"Two requests were made to modify the number of hydrogen atoms on atom", i, &
          ", a carbon atom, PDB label: """//txtatm(i)(:26)//"""."
        write(iw,'(5x, a)')"When more than one hydrogen atom is to be added or deleted use "// &
          """+3"" or ""+2"" or ""-2"" or ""-3"" instead of ""+"" or ""-""."
        call mopend("MULTIPLE REQUESTS WERE MADE USING ""SITE"" TO CHANGE THE NUMBER "// &
        "OF HYDROGEN ATOMS ON A CARBON ATOM.")
      else
        call mopend("MULTIPLE REQUESTS WERE MADE USING ""SITE"" TO CHANGE THE NUMBER "// &
        "OF HYDROGEN ATOMS ON A NON-CARBON ATOM.") 
        call mopend("THIS IS NOT ALLOWED.  USE SEPARATE JOBS.") 
      end if
      return
    else
      l_used(i) = .true.
    end if
    j = nat(i)
    select case (j)
    case (6) ! Add and delete hydrogen atoms on Carbon
      if (i_charge == 1) then
        nadd = nadd + 1
        changes(nadd)(:15) = trim(txtatm(i)(12:))
      end if
      ncarbon = ncarbon + 1
!
!  Delete existing hydrogen atoms
!
        m = 0
        do j = 1, nbonds(i)
          if (nat(ibonds(j,i)) == 1 .or. nat(ibonds(j,i)) == 99) then
             nat(ibonds(j,i)) = 99
             ibonds(j,i) = 0
             nbonds(i) = nbonds(i) - 1
             m = m + 1
          end if
        end do
!
! There were "m" hydrogen atoms, so new number of hydrogen atoms should be
!
        i_charge =  i_charge + m
        if (4 - nbonds(i) < i_charge) then
          num = char(ichar("2") + int(log10(i*1.0001)))
          write(iw,'(/5x, a, i'//num//', a)')"An attempt to add a hydrogen atom to atom", i, &
            ", a carbon atom, PDB label: """//txtatm(i)(:26)//""","
          write(iw,'(5x, a, i'//num//', a,/)')"failed because the atom was already saturated. "// &
            "Atoms currently bonded to atom", i, " are:"
          write(iw,'(10x, a, i'//num//')')" Atom No.    <------ PDB Label ------->      Distance to atom", i
          sum = 0.d0
          do j = 1, nbonds(i)
            bond_length = distance(i, ibonds(j,i))
            if (bond_length > sum) then
              sum = bond_length
              k = ibonds(j,i)
            end if
            write(iw,'(i5, i11, a, f12.4, a)')j, ibonds(j,i), "      """//txtatm(ibonds(j,i))(:26)//"""", bond_length, " Angstroms"
          end do
          write(iw,'(/2x,a)')"[ The simplest way to correct this fault would be to use the"// &
            & " CVB keyword, e.g., CVB=("""//txtatm(i)(13:26)//""":-"""//txtatm(k)(13:26)//""") ]"
          if (index(keywrd, " HTML") + index(keywrd, "PDBOUT") /= 0) then
            line = job_fn(:len_trim(job_fn) - 3)//"pdb"
            call add_path(line)
            open(unit = 99, file = trim(line), iostat = i)
            call pdbout(99)
          end if
          call mopend("ATTEMPT WAS MADE TO ADD A HYDROGEN ATOM TO A CARBON ATOM THAT WAS ALREADY SATURATED")
          return
        end if
        j = ibonds(1,i)
!
! Need to jump over any atoms that were hydrogen atoms.
! At this point, hydrogen atoms have ibonds(a,b) = 0, so they are easily identified.
!
        m = 0
        do l = 1, nbonds(i)
          m = m + 1
          do n = 1, 6
            k = ibonds(m,i)
            if (k /= 0) exit
            m = m + 1
          end do
          if (k /= i .and. k /= j) exit
        end do
        bond_length = 1.09d0
        select case (i_charge)
          case (1)
!
! Carbon with one hydrogen atom
!
            select case (nbonds(i))
              case (1)
!
! Carbon bonded to one other non-hydrogen atom
!
                angle = pi
                dihedral = pi
              case (2)
!
! Carbon bonded to two other non-hydrogen atoms
!
                angle = 120.d0*pi/180.d0
                dihedral = pi
              case (3)
!
! Carbon bonded to three other non-hydrogen atoms
!
                angle = 0.d0
            end select
            if (angle < 1.d0) then
              call add_a_sp3_hydrogen_atom(i, ibonds(1,i), ibonds(2,i), ibonds(3,i), bond_length, metals, nmetals)
            else
              call add_a_generic_hydrogen_atom(i, j, k, bond_length, angle, dihedral, metals, nmetals)
            end if
            geo(:,numat) = coord(:,numat)
            natoms = numat
          case (2)
!
! Carbon with two hydrogen atoms
!
            select case (nbonds(i))
              case (1)
!
! Carbon bonded to one other non-hydrogen atom
!
                angle = 120.d0*pi/180.d0
                internal_dihedral = pi
                dihedral = pi
              case (2)
!
! Carbon bonded to two other non-hydrogen atoms
!
                angle = tetrahedral*pi/180.d0
                internal_dihedral = 120.d0*pi/180.d0
                dihedral = 120.d0*pi/180.d0
            end select
            call add_a_generic_hydrogen_atom(i, j, k, bond_length, angle, dihedral, metals, nmetals)
            natoms = natoms + 1
            nbonds(i) = nbonds(i) + 1
            ibonds(nbonds(i),i) = numat
            geo(:,numat) = coord(:,numat)
            internal_dihedral = internal_dihedral + dihedral
            call add_a_generic_hydrogen_atom(i, j, k, bond_length, angle, internal_dihedral, metals, nmetals)
            natoms = natoms + 1
            nbonds(i) = nbonds(i) + 1
            ibonds(nbonds(i),i) = numat
            geo(:,numat) = coord(:,numat)
          case (3)
!
! Carbon with three hydrogen atoms,
! this can only bond to one other atom.
!
            j = ibonds(1,i)
            do l = 1, nbonds(j)
              k = ibonds(l,j)
              if (k > 0 .and. k /= i) exit
            end do
            angle = tetrahedral*pi/180.d0
            internal_dihedral = 120.d0*pi/180.d0
            dihedral = pi
            call add_a_generic_hydrogen_atom(i, j, k, bond_length, angle, pi, metals, nmetals)
            natoms = natoms + 1
            nbonds(i) = nbonds(i) + 1
            ibonds(nbonds(i),i) = numat
            geo(:,numat) = coord(:,numat)
            call add_a_generic_hydrogen_atom(i, j, numat, bond_length, angle, internal_dihedral, metals, nmetals)
            natoms = natoms + 1
            nbonds(i) = nbonds(i) + 1
            ibonds(nbonds(i),i) = numat
            geo(:,numat) = coord(:,numat)
            call add_a_generic_hydrogen_atom(i, j, numat, bond_length, angle, internal_dihedral, metals, nmetals)
            natoms = natoms + 1
            nbonds(i) = nbonds(i) + 1
            ibonds(nbonds(i),i) = numat
            geo(:,numat) = coord(:,numat)
        end select
      case (7)! Select for Nitrogen in different coordination numbers
        select case (nbonds(i))
          case (1)
            j = ibonds(1,i)
!
!  Search for an atom attached to the atom that's attached to the nitrogen that's not that nitrogen
!
            do k = 1, nbonds(j)
              if (ibonds(k,j) /= i) exit
            end do
            k = ibonds(k,j)
            if (k == 0) then
              bond_length = 1.09d0
              angle = 2.6d0
              dihedral = pi
              call add_a_generic_hydrogen_atom(i, j, j, bond_length, angle, dihedral, metals, nmetals)
              geo(:,numat) = coord(:,numat)
            else
              call add_sp_H(i, j, k)
              numat = numat + 1
              nbonds(i) = nbonds(i) + 1
              ibonds(nbonds(i),i) = numat
            end if
            natoms = numat
            nadd = nadd + 1
            changes(nadd)(:15) = trim(txtatm(i)(12:))
            write(txtatm(natoms),'(a,i5," 3H",a)')txtatm(i)(:6), natoms, txtatm(i)(15:)
          case (2)
          if(i_charge == 1) then
            call add_sp2_H(ibonds(1,i), i, ibonds(2,i))
            numat = numat + 1
            coord(:,numat) = geo(:,numat)
            nbonds(i) = nbonds(i) + 1
            ibonds(nbonds(i),i) = numat
            nadd = nadd + 1
            changes(nadd)(:15) = trim(txtatm(i)(12:))
            write(txtatm(natoms),'(a,i5," 3H",a)')txtatm(i)(:6), natoms, txtatm(i)(15:)
          else
!
!  Delete a hydrogen atom, and hope the user knows what's going on.
!
            do j = 1, nbonds(i)
              if (nat(ibonds(j,i)) == 1) exit
            end do
            if (j <= nbonds(i)) then
              nat(ibonds(j,i)) = 99
              ibonds(nbonds(i),i) = 0
              nbonds(i) = nbonds(i) - 1
            end if
          end if
        case (3)
          if (i_charge == 1) then
!
!  Three-coordinate nitrogen, therefore make into a quaternary nitrogen
!
            call add_a_sp3_hydrogen_atom(i, ibonds(1,i), ibonds(2,i), ibonds(3,i), 1.1d0, metals, nmetals)
            natoms = natoms + 1
            nbonds(i) = nbonds(i) + 1
            ibonds(nbonds(i),i) = numat
            geo(:,numat) = coord(:,numat)
            nadd = nadd + 1
            changes(nadd)(:15) = trim(txtatm(i)(12:))
            write(txtatm(numat),'(a,i5," 3H",a)')txtatm(i)(:6), natoms, txtatm(i)(15:)
          else if (i_charge == 0) then
!
!  Three-coordinate nitrogen, therefore neutralize (assume pyridinium)
!
            k = 0
            do j = 1, nbonds(i)
              if (nat(ibonds(j,i)) == 1) then
                k = k + 1
                l = j
              end if
            end do
            if (k == 0) then
              write(iw,'(/1x,a,/)')" A nitrogen atom defined by keyword SITE is not bonded to any hydrogen atoms."
              write(line_1,'(a,4x,3f8.3,a)')'Faulty atom = "'//txtatm(i), coord(:,i), &
              "  1.00  0.00      PROT"//elemnt(nat(i))//'"'
              call mopend(trim(line_1))
              bug = .true.
            else if (k == 2 .and. txtatm(i)(18:20) /= "ARG") then
              write(iw,'(3(/,a),/)')"  A nitrogen atom defined by keyword SITE is bonded to two hydrogen atoms, ", &
              "  but a charge of zero has been specified.  If a hydrogen atom were to be deleted", &
              "  the resulting geometry would not be chemically sensible."
              write(line_1,'(a,4x,3f8.3,a)')'Faulty atom = "'//txtatm(i), coord(:,i), &
              "  1.00  0.00      PROT"//elemnt(nat(i))//'"'
              call mopend(trim(line_1))
              bug = .true.
            else
              nat(ibonds(l,i)) = 99
              ibonds(nbonds(i),i) = 0
              nbonds(i) = nbonds(i) - 1
            end if
          else
            write(iw,'(/1x,a)')"  A nitrogen atom defined by keyword SITE cannot have a negative charge."
            write(iw,'(a,/)')"  (If a hydrogen atom is to be deleted from a nitrogen, use ""(0)"" instead of ""(-)"")"
            write(line_1,'(a,4x,3f8.3,a)')'Faulty atom = "'//txtatm(i), coord(:,i), &
            "  1.00  0.00      PROT"//elemnt(nat(i))//'"'
            call mopend(trim(line_1))
            bug = .true.
          end if
        case (4)
          if (i_charge == 0) then
!
!  Quaternary nitrogen, therefore neutralize
!
            do j = 1, 4
              if (nat(ibonds(j,i)) == 1) exit
            end do
            if (j > 4) then
              write(iw,'(/1x,a,/)')" A nitrogen atom defined by keyword SITE is not bonded to any hydrogen atoms."
              write(line_1,'(a,4x,3f8.3,a)')'Faulty atom = "'//txtatm(i), coord(:,i), "  1.00  0.00      PROT"//elemnt(nat(i))//'"'
              call mopend(trim(line_1))
              bug = .true.
            end if
            nat(ibonds(j,i)) = 99
            ibonds(nbonds(i),i) = 0
            nbonds(i) = nbonds(i) - 1
          else if (i_charge == 1) then
            write(iw,'(/1x,a,/)')" A nitrogen atom defined by keyword SITE is already bonded to four atoms."
            write(line_1,'(a,4x,3f8.3,a)')'Faulty atom = "'//txtatm(i), coord(:,i), "  1.00  0.00      PROT"//elemnt(nat(i))//'"'
            call mopend(trim(line_1))
          end if
        end select
      case (8, 16)! Select for Oxygen in different coordination numbers
  99    continue
        select case (nbonds(i))
        case (0)
          if (i_charge == 0 .or. i_charge == 1) then
            line = "An attempt has been made to change the number of hydrogen atoms attached to an isolated oxygen atom"
            call mopend(trim(line))
            write(iw, '(10x,a)')"(Either use CVB to make a bond to the oxygen, or make this change outside MOPAC)"
            return
          end if
        case (1)
          if (i_charge == 0 .or. i_charge == 1) then
            j = ibonds(1,i)
            do k = 1, nbonds(j)  !  First search for -COO structure
              if (ibonds(k,j) /= i .and. nat(ibonds(k,j)) == 8) exit
            end do
            if (k > nbonds(j)) then
              do k = 1, nbonds(j)   ! If no -COO, search for anything other that atom i
                if (ibonds(k,j) /= i) exit
              end do
            end if
            if (k > nbonds(j)) then
              do k = numat, 1, -1
                if (k /= j .and. k /= i) exit
              end do
              if (k == 0) then
                line = "A hydrogen atom cannot be added to a diatomic.  Do this outside MOPAC"
                call mopend(trim(line))
                return
              end if
            else
              k = ibonds(k,j)
            end if
            call add_sp_H(i, j, k)
            numat = numat + 1
            nadd = nadd + 1
            changes(nadd)(:15) = trim(txtatm(i)(12:))
            if (i_charge == 0) then
              nbonds(i) = 2
              ibonds(2,i) = natoms
            end if
          else if (i_charge == -1) then
            num = char(ichar("1") + int(log10(i*1.001)))
            write(iw,'(/,a,i'//num//',a,/,a,/)')"  Oxygen atom ",i, &
              " defined by keyword SITE is already bonded to only one atom,", &
              "  so a hydrogen atom cannot be deleted, as requested by the option ""(-)"""
            write(line_1,'(a,4x,3f8.3,a)')'Faulty atom = "'//txtatm(i), coord(:,i), &
              "  1.00  0.00      PROT"//elemnt(nat(i))//'"'
            call mopend(trim(line_1))
            bug = .true.
          end if
        case (2)
          if (i_charge == -1) then
            do j = 1, nbonds(i)
              if (nat(ibonds(j,i)) == 1) exit
            end do
            if (j > nbonds(i)) then
              num = char(ichar("1") + int(log10(i*1.001)))
              write(iw,'(/1x,a,i'//num//',a,/)')"  Oxygen atom ",i, " defined by keyword SITE is not bonded to any hydrogen atoms."
              write(line_1,'(a,4x,3f8.3,a)')'Faulty atom = "'//txtatm(i), coord(:,i), "  1.00  0.00      PROT"//elemnt(nat(i))//'"'
              call mopend(trim(line_1))
              bug = .true.
            else
              nat(ibonds(j,i)) = 99
              ibonds(nbonds(i),i) = 0
              nbonds(i) = nbonds(i) - 1
            end if
          else if (i_charge == 0) then
            num = char(ichar("1") + int(log10(i*1.001)))
            write(iw,'(/1x,a,i'//num//',a,/)')"  Oxygen atom ",i, " defined by keyword SITE is already bonded to two atoms."
            write(line_1,'(a,4x,3f8.3,a)')'Faulty atom = "'//txtatm(i), coord(:,i), "  1.00  0.00      PROT"//elemnt(nat(i))//'"'
            call mopend(trim(line_1))
            bug = .true.
          else
            call add_sp2_H(ibonds(1,i), i, ibonds(2,i))
            numat = numat + 1
            nbonds(i) = nbonds(i) + 1
            ibonds(nbonds(i), i) = numat
            nadd = nadd + 1
            changes(nadd)(:15) = trim(txtatm(i)(12:))
          end if
        case (3)
          if (i_charge == -1 .or. i_charge == 0) then
            do j = 1, nbonds(i)
              if (nat(ibonds(j,i)) == 1) exit
            end do
            if (j > nbonds(i)) then
              write(iw,'(/1x,a,/)')" An oxygen atom defined by keyword SITE is not bonded to any hydrogen atoms."
              write(line_1,'(a,4x,3f8.3,a)')'Faulty atom = "'//txtatm(i), coord(:,i), "  1.00  0.00      PROT"//elemnt(nat(i))//'"'
              call mopend(trim(line_1))
              bug = .true.
            else
              nat(ibonds(j,i)) = 99
              nbonds(i) = 2
              if (j == 2) ibonds(2,i) = ibonds(3,i)
              if (i_charge == -1) goto 99
            end if
          else
            write(iw,'(/1x,a,/)')" An oxygen atom defined by keyword SITE is already bonded to three atoms."
            write(line_1,'(a,4x,3f8.3,a)')'Faulty atom = "'//txtatm(i), coord(:,i), "  1.00  0.00      PROT"//elemnt(nat(i))//'"'
            call mopend(trim(line_1))
            bug = .true.
          end if
        end select
      case default
        write(iw,'(/1x,a,/)')" An atom defined by keyword SITE is not a nitrogen, oxygen, or sulfur."
        write(line_1,'(a,4x,3f8.3,a)')'Faulty atom = "'//txtatm(i), coord(:,i), "  1.00  0.00      PROT"//elemnt(nat(i))//'"'
        call mopend(trim(line_1))
        bug = .true.
   end select
  end do
!
!  Check that all sites have been recognized, whether they are modified or not
!
  k = 0
  do j = 1 , nres
    if (charge(j,1) /= "*") then
      if (k == 0) then
        k = index(keywrd," SITE=")
        l = index(keywrd(k:), ") ") + k
        if (allkey /= " ") write(iw,'(/10x,a)')"Faulty SITE Keyword: '"//trim(allkey)//"'"
      end if
      k = index(keywrd," SITE=")
      if (j == 1) then
       do k = k, len_trim(keywrd)
         if (keywrd(k:k) == "(") exit
       end do
       k = k + 1
      else
        do i = 1, j - 1
          k = index(keywrd(k + 1:l), ",") + k + 1
        end do
      end if
      i = index(keywrd(k + 1:l), ",")
      if (i == 0) i = index(keywrd(k + 1:l + 1), ") ")
      i = i + k - 1
      write(line_1,'(a,i3,a)')"Site:", j, ", '"//keywrd(k:i)//"', was not properly recognized."
      call mopend(trim(line_1))
      write(iw,'(/10x,a)')"(Check that the residue is not duplicated and can be ionized or de-ionized)"
      if (index(keywrd, " 0SCF") /= 0) moperr = .false.
    end if
  end do
  if (bug) then
    if (allkey /= " ") then
      write(line_1,'(a)')"FAULTY SITE KEYWORD: '"//trim(allkey)//"'"
    else
      write(line_1,'(a)')"FAULTY SITE KEYWORD"
    end if
    call mopend(trim(line_1))
    write(iw,'(/10x,a,/10x,a)')"(Check that the atom is N or O and can be ionized or de-ionized)"
    if (index(keywrd, " 0SCF") /= 0) return
  end if
  do i = 1, natoms - id
    if (nat(i) == 99 .and. nbonds(i) > 0) then
      do j = 1, nadd
        if (changes(j)(:15) == trim(txtatm(ibonds(1,i))(12:))) exit
      end do
      if (j > nadd) then
        ndel = ndel + 1
        changes(ndel)(16:) = trim(txtatm(ibonds(1,i))(12:))
      end if
    end if
  end do
  j = 0
  do i = 1, ndel
    do k = 1, i - 1
      if (changes(k)(16:) == changes(i)(16:)) exit
    end do
    if ( k == i) then
      j = j + 1
      changes(j)(16:) = changes(i)(16:)
    end if
  end do
  ndel = j
  j = 0
  do i = 1, numat
    if (nat(i) /= 99) then
      j = j + 1
      geo(:,j) = geo(:,i)
      coord(:,j) = geo(:,i)
      nat(j) = nat(i)
      atmass(j) = ams(nat(i))
      txtatm(j) = txtatm(i)
      lopt(:,j) = lopt(:,i)
    end if
  end do
  numat = j
  natoms = numat
  labels(:numat) = nat(:numat)
  call set_up_dentate()
  call update_txtatm(.true., .false.)
  j = max(nadd, ndel)
  if (j > 0) then
    write(iw,'(/7x,a,/)')"Changes in Ionization caused by keyword SITE"
    n = 85
    k = len_trim(allkey)
    i = min(k,n - 8)
    l = index(allkey(i:), ",")
    if (l == 0) l = index(allkey(i:), "))")
    i = min(k, l + i) - 1
    if (i == k - 1) then
      write(iw,'(7x,a)')"Keyword:"//allkey(1:k)
    else
      write(iw,'(7x,a)')"Keyword:"//allkey(1:i)
      do
        l = i + 1
        i = min(l + n, k)
        i = min(k, index(allkey(i:), ",") + i)
        if (i == k) then
          if (allkey(i - 1:i - 1) == ",") allkey(i - 1:i) = ") "
          write(iw,'(7x, a)')allkey(l:i)
          exit
        else
          i = i - 1
          write(iw,'(7x, a)')allkey(l:i)
        end if
      end do
    end if
    write(iw,'(/5x,a,/)')" Hydrogen atoms added to     Hydrogen atoms deleted from"
    k = 0
    do i = 1, j
      if (index(changes(i)(17:18), "O") /= 0 .or. index(changes(i)(17:18), "N") /= 0) k = k - 1
      if (index(changes(i)( 2: 3), "O") /= 0 .or. index(changes(i)( 2: 3), "N") /= 0) k = k + 1
      if (changes(i)(:15) == " ") changes(i)(:15) = "       -"
      if (changes(i)(16:) == " ") changes(i)(16:) = "       -"
      write(iw,'(i3,5x,a)')i, changes(i)(:15)//"               "//trim(changes(i)(16:))
    end do
    if (mod(ncarbon,2) == 0) write(iw,'(/10x,a,SP,i4)')"Change in net ionization:", k
  end if
  do i = numat + 1, numat + id
    labels(i) = 107
    nat(i) = 107
    geo(:,i)  = tvec(:, i - numat)
  end do
  natoms = natoms + id
  return
  end subroutine site

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

     subroutine drc(startv, startk)
      USE molkst_C, only : nvar, tleft, escf, gnorm, ndep, numat, keywrd, &
      line, nopen, nclose, moperr, jloop => itemp_1, prt_velocity
      USE chanel_C, only : iw0, iw, ires, iscr, restart_fn
      use common_arrays_C, only : geo, loc, grad, xparam, atmass, nat, &
      & errfn, coord, na, p, q, labels, geoa, txtatm
      USE parameters_C, only : tore
      USE elemts_C, only : elemnt
      use drc_C, only : georef
      implicit none
      double precision :: startv(9*numat*numat)
      double precision , intent(in) :: startk(3*numat)
!
      integer :: i, j, iskin,   iloop, k, kl, ncoprt, bigcycles, jloop_lim, i_constant = 1, &
        ii, i1, maxcyc, iupper, ilp, io_stat, ilim, iw00, percent, n_escf, n_min, iwd = 9
      integer, dimension(2,3*numat) :: mcoprt
      double precision, dimension(3*numat) :: velo0, velo1, velo2, velo3, gerror, grold2
      double precision, dimension(10) :: past10
      double precision, dimension(3*numat) :: grold
      double precision :: ekin, elost1, etold, dlold2, tnow, oldtim, delold, gtot, &
        accu, gnlim, half, addonk, deltat, quadr, etot, const, one, summ, &
        summas, ams, error, velvec, delta1, elost, sum, dummy, tcycle, &
        old_hof, new_hof, start_hof=1.d20, minstep, escf_old, &
        escf_diff, stepx, escf_min, stepxx, dipvec(3), dip = 0.d0, cnvg
      logical :: addk, letot, let, velred, opend, parmax, debug, l_debug = .false., l_irc, &
        l_dipole, l_pdb
      double precision, external :: ddot, dipole, reada, seconds
!***********************************************************************
!                                                                      *
!    DRC IS DESIGNED TO FOLLOW A REACTION PATH FROM THE TRANSITION     *
!    STATE.  TWO MODES ARE SUPPORTED, FIRST: GAS PHASE:- AS THE SYSTEM *
!    MOVES FROM THE T/S THE MOMENTUM OF THE ATOMS IS STORED AND THE    *
!    POSITION OF THE ATOMS IS RELATED TO THE OLD POSITION BY (A) THE   *
!    CURRENT VELOCITY OF THE ATOM, AND (B) THE FORCES ACTING ON THAT   *
!    ATOM.  THE SECOND MODE IS CONDENSED PHASE, IN WHICH THE ATOMS MOVE*
!    IN RESPONSE TO THE FORCES ACTING ON THEM. I.E. INFINITELY DAMPED  *
!                                                                      *
!***********************************************************************
      addk = .TRUE.
      ekin = 0.d0
      escf_old = 10.d0
      escf_diff = 20.d0
      elost1 = 0.d0
      etold = 0.d0
      dlold2 = 0.d0
      past10 = 0.d0
      old_hof = 0.d0
      new_hof = 0.d0
      tnow = seconds(1)
      oldtim = seconds(1)
      delold = 10.d0
      percent = 0
      gtot = 0.d0
      gnorm = 0.d0
      iw00 = iw0
      iw0 = -1
      iloop = 1
      n_escf = 0
      escf_min = 1.d20
      parmax = .FALSE.
      l_pdb = (txtatm(1)(:7) /= "")
      call l_control("LDRC_FIRST", len("LDRC_FIRST"), 1)
      if (nopen /= nclose .and. Index (keywrd, " IRC") /= 0) then
        minstep = 5.d-16 ! Gradients are not very accurate, so use larger minimum step.
      else
        minstep = 1.d-16
      end if
      if (allocated(grad))  deallocate(grad)
      if (allocated(errfn)) deallocate(errfn)
      if (allocated(georef)) deallocate(georef)
      allocate(grad(3*numat), errfn(3*numat), georef(3,numat))
      errfn = 0.d0
      inquire(unit=iscr, opened=opend)
      if (opend) close(unit=iscr)
      open(unit=iscr, status='SCRATCH', position='asis')
      if (index(keywrd,' PREC') /= 0) then
        accu = 0.25d0
        cnvg = 0.000001d0
      else
        accu = 1.d0
        cnvg = 0.00001d0
      end if
      l_dipole = (index(keywrd,' DIPOLE') /= 0)
      l_irc = (index(keywrd,' DRC') == 0)
      if (l_irc) then
        if (index(keywrd,' X-PRIORITY=') /= 0) then
          stepx = reada(keywrd,index(keywrd,'X-PRIO') + 5)
        else
          stepx = 0.05D0
        end if
        stepx = stepx*0.2d0  !  Use five steps per point
        stepxx = 0.01d0
      else
        stepx = 0.d0
        stepxx = 0.d0
      end if
!
!   COSMO surfaces are relatively rough, so increase number of steps to
!   ensure on the descent side
!
      if (Index (keywrd, " EPS") /= 0) then
        ilim = 300
        accu = accu*10
      else
        ilim = 30
      end if
      gnlim = 1.d0
      past10(5) = 100.d0
      debug = (index(keywrd,' DEBUG') /= 0)
      i = index(keywrd,'GNORM')
      if (i /= 0) gnlim = reada(keywrd,i)
      if (gnlim < 0.9d0) then
        n_min = 80
      else
        n_min = 40
      end if
!
! DETERMINE EXCESS KINETIC ENERGY
!
      iskin = 0
      if (index(keywrd,'KINE') /= 0) then
        iskin = 1
        addonk = reada(keywrd,index(keywrd,'KINE'))
        if (addonk < 0.d0) startv = -startv
        write (iw,'(2/10X,'' EXCESS KINETIC ENERGY ENTERED INTO SYSTEM ='',F12.6)') Abs(addonk)
        if (addonk < 0.d0) then
          addonk = -addonk
          write (iw,'(10X,'' KINETIC ENERGY SUPPLIED WAS NEGATIVE, SO INITIAL VELOCITY IS REVERSED'')')
        end if
      else
        addonk = 0.d0
        if (l_irc) addonk=2.d0  ! Just a guess to get the IRC started
      end if
      velred = index(keywrd,'VELO') /= 0
      if (ddot(3*numat,startv,1,startv,1) > 0.001d0) then
!
!     PRINT OUT INITIAL VELOCITIES
!
        if (prt_velocity) then
          write (iw, '(10x, A)') ' INITIAL VELOCITY IN DRC (Angstroms/Femtosecond)'
          write (iw, '(3F16.5)') (startv(i), i = 1, numat*3)
        end if
        startv(:numat*3) = -startv(:numat*3)
      end if
      let = (velred .and. Index (keywrd, " IRC") == 0)
      if (index(keywrd,' SYMM') /= 0) ndep = 0
   !
   !      CONVERT TO CARTESIAN COORDINATES, IF NOT ALREADY DONE.
   !
      call gmetry (geo, coord)
      geo(:,:numat) = coord(:,:numat)
      na = 0
      do i = 1, numat
        if (atmass(i) >= 1.d-1) cycle
        write (iw, '(A,I3,A)') ' ATOMIC MASS OF ATOM', i, ' TOO SMALL'
        return
      end do
!
!  TRANSFER COORDINATES TO XPARAM AND LOC
!
      if (.not. l_irc) then
        parmax = (loc(1,1) /= 0)
        ncoprt = 0
        if (parmax) then
          mcoprt(:,:nvar) = loc(:,:nvar)
          ncoprt = nvar
        end if
      else
        ncoprt = 0
      end if
      ncoprt = 0  !  Do NOT print turning points. These just mess up the output.
      if (allocated(geoa)) deallocate(geoa)
      allocate( geoa(3,numat))
      geoa(:,:numat) = geo(:,:numat)
      georef = geo
      if (index(keywrd, " NOOPT") == 0) then
        k = 0
        do i = 1, numat
          do j = 1, 3
            k = k + 1
            loc(1,k) = i
            loc(2,k) = j
          end do
        end do
        nvar = k
      end if


      do i = 1, nvar
        xparam(i) = geo(loc(2,i), loc(1,i))
      end do
!
! DETERMINE DAMPING FACTOR
!
      if (index(keywrd,'DRC=') /= 0) then
        half = reada(keywrd,index(keywrd,'DRC='))
        write (iw, &
      '(2/10X,'' DAMPING FACTOR FOR KINETIC ENERGY ='',F12.6)') half
      else if (index(keywrd,' DRC') == 0) then
!
!  IRC
!
        half = 0.d0
!   startv = startv*0.02d0
        if (addonk > 1.d-4) startv(:3*numat) = startv(:3*numat)*addonk
      else
!
! undamped DRC
!
        half = 1.d6
      end if
!
!  LETOT IS TRUE IF CORRECTIONS ARE NOT TO BE MADE PART WAY INTO
!        THE CALCULATION
!
!  USAGE OF LETOT:
! (1) WHILE LETOT IS FALSE, NO DAMPING WILL BE DONE
! (2) WHEN LETOT IS TURNED TRUE,
!     IF AN IRC, THEN ETOT IS RESET SO THE ERROR IS ZERO.
!     IF A  DRC, EXCESS KINETIC ENERGY USED TO START THE RUN IS REMOVED.
!
      letot = index(keywrd,'IRC=') == 0 .and. .not.let
      half = sign(max(0.000001d0,abs(half)),half)

!
!   LOOP OVER TIME-INTERVALS OF DELTAT SECOND
!
      deltat = 1.d-16
      if (index(keywrd,'IRC=') /= 0) deltat = min(1.d-13, deltat*(numat*0.25d0)**4)  !  Big step if starting from a transition state
      quadr = 1.d0
      etot = 0.d0
      escf = 0.d0
      const = 1.d0
      if (index(keywrd,'RESTART') /= 0 .and. index(keywrd,'IRC=') == 0) then
!
!  RESTART FROM A PREVIOUS RUN
!
        inquire(unit=ires, opened=opend)
        if (opend) close(unit=ires, status='KEEP')
        open(unit=ires, file=restart_fn, status='UNKNOWN', &
          form='UNFORMATTED', position='asis', iostat = io_stat)
        if (io_stat /= 0) then
          write(iw,*)" Restart file either does not exist or is not available for reading"
          call mopend ("Restart file either does not exist or is not available for reading")
          return
        end if
        rewind ires
        read (ires, iostat = io_stat) (xparam(i),i=1,nvar)
        read (ires, iostat = io_stat) (velo0(i),i=1,nvar)
        read (ires, iostat = io_stat) (grad(i),i=1,nvar)
        read (ires, iostat = io_stat) (grold(i),i=1,nvar)
        read (ires, iostat = io_stat) (grold2(i),i=1,nvar)
        read (ires, iostat = io_stat) etot, escf, ekin, delold, deltat, dlold2, iloop, gnorm, &
            letot, elost1, gtot
        close (ires)
        if (io_stat /= 0) then
          call mopend ("Restart file is corrupt")
          return
        end if
        if ((abs(etot) > 1.d5 .or. abs(etot) < 1.d-5) .and. (abs(escf) > 1.d5 .or. abs(escf) < 1.d-5)) then
          call mopend ("RESTART FILE DOES NOT APPEARS TO BE AN IRC OR DRC RESTART. ")
          write(iw,'(10x,a)')"COULD IT BE A FORCE RESTART, IF SO USE IRC=n"
          return
        end if
        write (iw, &
      '(2/10X,''CALCULATION RESTARTED, CURRENT KINETIC ENERGY='',F10.5,2/)') ekin
        go to 100
      else
!                         NOT A RESTART

        velo0(:nvar) = 0.d0
        grold2(:nvar) = 0.d0
        grold(:nvar) = 0.d0
        grad(:nvar) = 0.d0
        if (index(keywrd,'IRC=') /= 0 .or. velred) then
!
!  GET HOLD OF VELOCITY VECTOR
!
          if (index(keywrd,'IRC=') /= 0) then
            k = nint(reada(keywrd,index(keywrd,'IRC=')))
          else
            k = 1
          end if
          if (k < 0) then
            k = -k
            one = -1.d0
          else
            one = 1.d0
          end if
!
!   Modify all velocities to set net momentum to zero
!
          kl = (k - 1)*nvar
          summ = 0.d0
          velo1(1) = 0.d0
          velo1(2) = 0.d0
          velo1(3) = 0.d0
          summas = 0.d0
          i = 0
          do ii = 1, numat
            ams = atmass(ii)
            summas = summas + ams
            velo0(i+1) = startv(kl+i+1)*one
            velo1(1) = velo1(1) + velo0(i+1)*ams
            velo0(i+2) = startv(kl+i+2)*one
            velo1(2) = velo1(2) + velo0(i+2)*ams
            velo0(i+3) = startv(kl+i+3)*one
            velo1(3) = velo1(3) + velo0(i+3)*ams
            i = i + 3
          end do
          velo1(:3) = -velo1(:3)/summas
          i = 0
          if (addonk > 1.d-5 .or. .not.velred) then
            do ii = 1, numat
              ams = atmass(ii)
              do i1 = 1, 3
                i = i + 1
                velo0(i) = velo0(i) + velo1(i1)
                summ = summ + velo0(i)**2*ams
              end do
            end do
          else
            do ii = 1, numat
              ams = atmass(ii)
              do i1 = 1, 3
                i = i + 1
                summ = summ + velo0(i)**2*ams
              end do
            end do
          end if

          if (addonk < 1.d-5 .and. velred) addonk = 0.5d0*summ/4.184D10
          if (addonk < 1.d-5 .and. .not. velred) then
            if (abs(half) > 1.d-3 .and. startk(k) > 105.d0) then
              write (iw, '(A,F10.3,A,/,A)') &
                ' BY DEFAULT, ONE QUANTUM OF ENERGY, EQUIVALENT TO', &
                startk(k), ' CM(-1)', ' WILL BE USED TO START THE DRC'
!
!    2.8585086D-3 CONVERTS CM(-1) INTO KCAL/MOLE
!
              addonk = startk(k)*2.8585086D-3
              write (iw, '(A,F7.2,A)') ' THIS REPRESENTS AN ENERGY OF', &
              addonk, ' KCALS/MOLE'
            else if (abs(half) > 1.d-3) then
              write (iw, '(A,F9.2,A)') ' THE VIBRATIONAL FREQUENCY (', &
              startk(k), 'CM(-1)) IS TOO SMALL', ' FOR ONE QUANTUM TO BE USED'
              write (iw, '(A)') &
                ' INSTEAD 0.3KCAL/MOLE WILL BE USED TO START THE IRC'
              addonk = 0.3d0
            else
              addonk = 0.3d0
            end if
          end if
!
!   AT THIS POINT ADDONK IS IN KCAL/MOLE
!   NORMALIZE SO THAT TOTAL K.E. = ONE QUANTUM (DEFAULT) (DRC ONLY)
!                              OR 0.3KCAL/MOLE (IRC ONLY)
!                              OR ADDONK IF KINETIC=NN SUPPLIED
!
          if (summ < 1.d-4) then
            write (iw, '(A)') ' SYSTEM IS APPARENTLY NOT MOVING!'
            return
          end if
!
!  ADDONK IS EXCESS KINETIC ENERGY.  IF THE CALCULATION IS AN IRC,
!  THIS ENERGY MUST BE REMOVED AFTER A SHORT 'TIME'.
!
!  MAKE AN AD-HOC CORRECTION: IF ADDONK IS NON-ZERO AND HALF IS LARGER
!  THAN 0.1, MODIFY ADDONK TO REFLECT ERRORS DUE TO START-UP.
!
          if (half > 0.1d0 .and. half < 10000.d0) &
            addonk = addonk*(1.d0 + 0.06972d0/half)
!
!  MAKE AN AD-HOC CORRECTION: IF ADDONK IS NON-ZERO AND HALF IS LESS
!  THAN -0.1, MODIFY ADDONK TO REFLECT ERRORS DUE TO START-UP.
!
          if (half<(-0.1d0) .and. half>(-10000.d0)) addonk = addonk*(1.d0 + &
            0.06886d0/half)
          summ = sqrt(addonk/(0.5d0*summ/4.184D10))
          addk = .FALSE.
          if (summ > 1.d-10) then
            velo0(:nvar) = velo0(:nvar)*summ
!
!  IF IT IS A DRC, DESTROY ADDONK.  THE KINETIC ENERGY USED WILL COME
!  FROM THE VELOCITY ONLY.
!
            if (half > 1.d-3) addonk = 0.d0
          end if
        end if
      end if
  100 continue
      if (Index (keywrd, " BIGCYCLES") /= 0) then
        bigcycles = Nint (reada (keywrd, Index (keywrd, " BIGCYCLES")))*4
      else
        bigcycles = -1
      end if


      if (index(keywrd,' CYCLES') /= 0) then
        maxcyc = 1000000
        jloop_lim = nint(reada(keywrd,index(keywrd,' CYCLES')))
      else
        maxcyc = 4999
        jloop_lim = 100000
      end if
      iupper = iloop + maxcyc
      ilp = iloop
      one = 0.d0
      if (index(keywrd,'RESTART') /= 0 .and. index(keywrd,'IRC=') == 0) one = 1.d0
      gerror(:nvar) = 0.d0
      if (l_debug) then
!
! Use this block to print diagnostic details of the reaction coordinate
!
        line = "debug.txt"
        call add_path(line)
        open(iwd, file = trim(line))
        write(iwd,'(a)')" Point  Velocity      Coordinate      Delta-x    Gradient     ESCF   Deltat*(10^16)"
      end if
      do iloop = ilp, iupper
!
!  MOVEMENT OF ATOMS WILL BE PROPORTIONAL TO THE AVERAGE VELOCITIES
!  OF THE ATOMS BEFORE AND AFTER TIME INTERVAL
!
!
!  RAPID CHANGE IN GRADIENT IMPLIES SMALL STEP SIZE FOR DELTAT
!
!   KINETIC ENERGY = 1/2 * M * V * V
!                  = 0.5 / (4.184D10) * M * V * V
!   NEW VELOCITY = OLD VELOCITY + GRADIENT * TIME / MASS
!                = KCAL/ANGSTROM*SECOND/(ATOMIC WEIGHT)
!                =4.184*10**10(ERGS)*10**8(PER CM)*DELTAT(SECONDS)
!   NEW POSITION = OLD POSITION - AVERAGE VELOCITY * TIME INTERVAL
!
!
!   ESTABLISH REFERENCE TOTAL ENERGY
!
        error = etot - (ekin + escf)
        if (iloop > 2) then
          quadr = 1.d0 + error/(ekin*const + 0.001d0)*0.5d0
          quadr = min(1.3d0,max(0.8d0,quadr))
        else
          quadr = 1.d0
        end if
        if ((let .or. ekin > 0.2d0) .and. addk) then
!
!   DUMP IN EXCESS KINETIC ENERGY
!
          etot = etot + addonk
          addk = .FALSE.
          addonk = 0.d0
        end if
!
!  CALCULATE THE DURATION OF THE NEXT STEP.
!  STEP SIZE IS THAT REQUIRED TO PRODUCE A CONSTANT CHANGE IN GEOMETRY
!
!
!  IF DAMPING IS USED, CALCULATE THE NEW TOTAL ENERGY AND
!  THE RATIO FOR REDUCING THE KINETIC ENERGY
!
        const = max(1.d-36,0.5d0**(deltat*1.d15/half))
        const = sqrt(const)
        ekin = 0.d0
        delta1 = delold + dlold2
        elost = 0.d0
        startv(:nvar) = xparam(:nvar)
        if (iloop > 3) then
          do i = 1, nvar
!
!   CALCULATE COMPONENTS OF VELOCITY AS
!   V = V(0) + V'*T + V"*T*T
!   WE NEED ALL THREE TERMS, V(0), V' AND V"
!
            velo1(i) = 1.d0/atmass(loc(1,i))*grad(i)   ! Velocity
            velo3(i) = 2.d0/atmass(loc(1,i))* &
                (delta1*(grold(i)-grad(i)) - &
                delold*(grold2(i)-grad(i)))/(delta1*(delold**2*1.d30) - &
                delold*(delta1**2*1.d30))
            velo2(i) = 1.d0/atmass(loc(1,i))* &
            (grad(i)-grold(i)-0.5d0*velo3(i)*(1.d30*delold**2))/(delold*1.d15)
          end do
          if (l_irc) then
            velo2 = 0.d0
            velo3 = 0.d0
          end if
          do
            do i = 1, nvar
!
!  MOVE ATOMS THROUGH DISTANCE EQUAL TO VELOCITY * DELTA-TIME, NOTE
!  VELOCITY CHANGES FROM START TO FINISH, THEREFORE AVERAGE.
!
              startv(i) = xparam(i) - 1.d8*( &
              deltat*velo0(i)*one + &
              0.5d0*deltat**2*velo1(i) + &
              0.16666d0*(deltat**2*1.d15)*deltat*velo2(i) + &
              0.0416666d0*deltat**2*(1.d30*deltat**2)*velo3(i))
            end do
            if (stepxx < 1.d-5 .or. (l_irc .and. iloop > 4)) exit
            sum = 1.d-5
            do i = 1, nvar
              sum = sum + (xparam(i) - startv(i))**2
            end do
            sum = stepxx/sqrt(sum)
            if (sum > 0.8d0 .and. sum < 1.25d0) exit
            deltat = deltat*max(0.99d0, min(1.01d0, sum))
          end do
          sum = 0.d0
          do i = 1, numat
            do j = 1,3
              sum = sum + (geo(j,i) - georef(j,i))**2
            end do
          end do
          if (sum > 0.01d0) gnorm = 4.d0
          if (l_irc) velo0 = 0.d0
          do i = 1, nvar
!
!   CORRECT ERRORS DUE TO CUBIC COMPONENTS IN ENERGY GRADIENT,
!   ALSO TO ADD ON EXCESS ENERGY, IF NECESSARY.
!
!
!   MODIFY VELOCITY IN LIGHT OF CURRENT ENERGY GRADIENTS.
!
!   VELOCITY = OLD VELOCITY + (DELTA-T / ATOMIC MASS) * CURRENT GRADIENT
!                           + 1/2 *(DELTA-T * DELTA-T /ATOMIC MASS) *
!                             (SLOPE OF GRADIENT)
!              SLOPE OF GRADIENT = (GRAD(I)-GROLD(I))/DELOLD
!
!
!   THIS EXPRESSION IS ACCURATE TO SECOND ORDER IN TIME.
!
            velo0(i) =                              velo0(i) + &          ! Velocity
                                             deltat*velo1(i) + &          ! Acceleration
                                    0.5d0*deltat**2*velo2(i)*1.d15 + &    ! Rate of acceleration
                0.166666d0*deltat*(1.d30*deltat**2)*velo3(i)              ! Rate of rate of acceleration
            if (let .or. gnorm > 3.d0) then
              let = .TRUE.
              elost = elost + velo0(i)**2*atmass(loc(1,i))*(1 - const**2)
              velo0(i) = velo0(i)*const*quadr
            end if
!
!  CALCULATE KINETIC ENERGY (IN 2*ERGS AT THIS POINT)
!
            ekin = ekin + velo0(i)**2*atmass(loc(1,i))
          end do
          if (l_debug) then
!
! Use this block to print diagnostic details of the reaction coordinate
!
            if (iloop > 25) then
              write(iwd,'(i6, f10.2, f15.6, f15.6, f10.4, 2f12.6)')iloop, velo0(42)/(const*quadr), &
              startv(42), startv(42) - xparam(42), grad(42)/4.184D18, escf, deltat*1.d16
            end if
          end if
          xparam(:nvar) = startv(:nvar)
        else
!
!   First few steps do not have velo3
!
!
          if (l_irc) then
            velo1 = 0.d0
            velo2 = 0.d0
            velo3 = 0.d0
          end if
          do i = 1, nvar
!
!   CALCULATE COMPONENTS OF VELOCITY AS
!   V = V(0) + V'*T + V"*T*T
!   WE NEED ALL THREE TERMS, V(0), V' AND V"
!
            velo1(i) = 1.d0/atmass(loc(1,i))*grad(i)
            velo2(i) = 1.d0/atmass(loc(1,i))*(grad(i)-grold(i))/(1.d15*delold)
            velo3(i) = 0.d0
!
!  MOVE ATOMS THROUGH DISTANCE EQUAL TO VELOCITY * DELTA-TIME, NOTE
!  VELOCITY CHANGES FROM START TO FINISH, THEREFORE AVERAGE.
!
            xparam(i) = xparam(i) - 1.d8*(deltat*velo0(i)*one + &
            0.5d0*deltat**2*velo1(i) + &
            0.16666d0*(deltat**2*1.d15)*deltat*velo2(i) + &
            0.0416666d0*deltat**2*(1.d30*deltat**2)*velo3(i))
!
!   CORRECT ERRORS DUE TO CUBIC COMPONENTS IN ENERGY GRADIENT,
!   ALSO TO ADD ON EXCESS ENERGY, IF NECESSARY.
!
!
!   MODIFY VELOCITY IN LIGHT OF CURRENT ENERGY GRADIENTS.
!
!   VELOCITY = OLD VELOCITY + (DELTA-T / ATOMIC MASS) * CURRENT GRADIENT
!                           + 1/2 *(DELTA-T * DELTA-T /ATOMIC MASS) *
!                             (SLOPE OF GRADIENT)
!              SLOPE OF GRADIENT = (GRAD(I)-GROLD(I))/DELOLD
!
!
!   THIS EXPRESSION IS ACCURATE TO SECOND ORDER IN TIME.
!
            velo0(i) = velo0(i) + deltat*velo1(i) + 0.5d0*deltat**2*velo2(i)*&
              1.d15 + 0.166666d0*deltat*(1.d30*deltat**2)*velo3(i)
            if (let .or. gnorm>3.d0) then
              let = .TRUE.
              elost = elost + velo0(i)**2*atmass(loc(1,i))*(1 - const**2)
              velo0(i) = velo0(i)*const*quadr
            end if
!
!  CALCULATE KINETIC ENERGY (IN 2*ERGS AT THIS POINT)
!
            ekin = ekin + velo0(i)**2*atmass(loc(1,i))
          end do
        end if
        one = 1.d0
        if (let .or. gnorm > 3.d0) then
          if (.not.letot) then
            if (abs(half) < 1.d-3) then
!
!  IT IS AN IRC, SO RESET THE TOTAL ENERGY
!
              etot = escf + elost1
              addonk = 0.d0
              elost1 = 0.d0
              elost = 0.d0
              deltat = 5.d-16
            else if (iskin == 0) then
!
!  IT IS A DRC AND KINETIC NOT USED, SO REMOVE EXTRA KINETIC ENERGY
!
              etot = etot - addonk
            end if
          end if
          letot = .TRUE.
        end if
!
!  CONVERT ENERGY INTO KCAL/MOLE
!
        ekin = 0.5d0*ekin/4.184D10
!
!  IF IT IS A DAMPED DRC, MODIFY ETOT TO REFLECT LOSS OF KINETIC ENERGY
!
        if (letot .and. abs(half) > 0.00001d0) etot = etot - ekin/const**2 + ekin
        elost1 = elost1 + 0.5d0*elost/4.184D10
!
! STORE OLD GRADIENTS FOR DELTA - VELOCITY CALCULATION
!
        grold2(:nvar) = grold(:nvar)
        grold(:nvar) = grad(:nvar)
        grad(:nvar) = 0.d0
!
!   CALCULATE ENERGY AND GRADIENTS
!
        if (Abs(new_hof) > 1.d-20) old_hof = escf
        call compfg (xparam, .TRUE., escf, .TRUE., grad, .TRUE.)
        if (Abs(new_hof) < 1.d-20) then
        old_hof = escf + 5.d0
        new_hof = escf
        end if
        if (moperr) return
        if (debug) then
          write(iw,"(//,a, i8)")" Point calculated:    ",iloop
          write(iw,"(a, f13.5)")" Heat of formation:    ", escf
          if (start_hof > 1.d19) start_hof = escf
          write(iw,"(a, f10.5)")" Calculated energy change:", elost1
          write(iw,"(a, f11.5)")" Predicted energy change:", etot - escf
          if (Abs(elost1) > 1.d-4) write(iw,"(a, f11.5)")" Cumulative error:       ", escf + elost1 - etot

          write(iw,"(a,  f13.4)")" 'Time' interval (fs):",deltat*1.d15

          write(iw,"(a)")" Geometry supplied to COMPFG in DRC"
          do i = 1, numat
            if (l_pdb) then
              write(iw,'(i6, 2x, a,3F15.6)') i, elemnt(nat(i))//"("//txtatm(i)(:26)//")", (xparam((i - 1)*3 + j), j = 1,3)
            else
              write(iw,"(1x,a2,f15.4,2f17.4)")elemnt(nat(i)), (xparam((i - 1)*3 + j), j = 1,3)
            end if
          end do
          write(iw,"(/,a)")" Forces (gradients) acting on atoms"
          do i = 1, numat
            if (l_pdb) then
              write(iw,'(i6, 2x, a,3F15.6)') i, elemnt(nat(i))//"("//txtatm(i)(:26)//")", (grad((i - 1)*3 + j), j = 1,3)
            else
              write(iw,"(i6, 1x,a2,f15.4,2f17.4)")i, elemnt(nat(i)), (grad((i - 1)*3 + j), j = 1,3)
            end if
          end do
          velvec = 0.d0
          do i = 1, nvar
            velvec = velvec + velo0(i)**2
          end do
          if (velvec > 1.d0) then
            write(iw,"(/,a)")" Velocity of atoms, in cm/sec"
            do i = 1, numat
              if (l_pdb) then
                write(iw,'(i6, 2x, a,3F15.6)') i, elemnt(nat(i))//"("//txtatm(i)(:26)//")", (-velo0((i - 1)*3 + j), j = 1,3)
              else
                write(iw,"(i6, 1x,a2,f15.4,2f17.4)")i, elemnt(nat(i)), (-velo0((i - 1)*3 + j), j = 1,3)
              end if
            end do
          else
            write(iw,"(/,a)")" Acceleration of atoms, in 10^(-14)cm/(sec*sec) = 10^10 Angstroms/(fs**2)"
            do i = 1, numat
              write(iw,"(i6, 1x,a2,f15.4,2f17.4)")i, elemnt(nat(i)),&
              (-1.d-14*velo1((i - 1)*3 + j), j = 1,3)
            end do
          end if
        end if
        new_hof = escf
        if (iloop > 2) then
          gnorm = 0.d0
          do i = 1, nvar, 3
            sum = dsqrt(ddot(3,grad(i),1,grad(i),1)/(ddot(3,velo0(i),1,velo0(i),1)+1.d-20))
            gerror(i:2+i) = gerror(i:2+i) + grad(i:2+i) + velo0(i:2+i)*sum
          end do
          gnorm = dsqrt(ddot(nvar,gerror,1,gerror,1))
          gtot = gnorm
        end if
        gnorm = dsqrt(ddot(nvar,grad,1,grad,1))
!
!   CONVERT GRADIENTS INTO ERGS/CM
!
        grad(:nvar) = grad(:nvar)*4.184D18
!
!   SPECIAL TREATMENT FOR FIRST POINT - SET "OLD" GRADIENTS EQUAL TO
!   CURRENT GRADIENTS.
!
        if (iloop == 1) then
          grold(:nvar) = grad(:nvar)
        end if
        dlold2 = delold
        delold = deltat
        sum = 0.d0
        do i = 1, nvar
          sum = sum + ((grad(i)-grold(i))/4.184D18)**2
        end do
        if (abs(half) < 0.001d0) then
          deltat = deltat*min(2.d0,2.d-4*accu/(abs(escf + elost1 - etold) + 1.d-20))**0.25d0
          etold = escf + elost1
          if (iloop > ilim .and. addonk < 1.d-5 .and. &
          & abs(old_hof - new_hof) < cnvg .or. iloop > 10000) then
!
!  Deciding when to terminate the IRC is tricky.
            i_constant = i_constant + 1
            if (i_constant > 3 .or. iloop > 10000) then
              iw0 = iw00
              write (iw, '(2/,'' IRC CALCULATION COMPLETE '')')
              return
            end if
          else
            i_constant = 1
          end if
          if (escf < escf_min .or. iloop < 10) then
            escf_min = escf
            n_escf = 0
          else
            n_escf = n_escf + 1
            if (n_escf > n_min) then
              write (iw, '(2/10x,A,/)') &
            ' POTENTIAL ENERGY HAS STOPPED DROPPING'
              iw0 = iw00
              return
            end if
          end if
        else
          deltat = deltat*min(1.05d0,10.d0*accu/(sum + 1.d-4))
          deltat = min(deltat,3.d-15*accu)
          past10(10) = gnorm
          sum = 0.d0
          do i = 1, 9
            sum = sum + abs(past10(i)-past10(i+1))
            past10(i) = past10(i+1)
          end do
          if (sum < gnlim) then
            write (iw, '(2/,A)') &
              ' GRADIENT CONSTANT AND SMALL -- ASSUME ALL MOTION STOPPED'
            write (iw, '(A)') ' TO CONTINUE, USE KEYWORD ''GNORM=0'''
            iw0 = iw00
            return
          end if
          deltat = min(deltat,2.d-15)
!***********************************************************************
!
!         TESTING CODE - REMOVE BEFORE FINAL VERSION ASSEMBLED
!#          (ILOOP/400)*400.EQ.ILOOP)DELTAT=-DELTAT
!
!***********************************************************************
        end if
        deltat = max(minstep,deltat)
        if (l_dipole) then
          call chrge (p, q)
          q(:numat) = tore(labels(:numat)) - q(:numat)
          dip = dipole(p, xparam, dipvec,0)
        end if
        iw0 = iw00
        if (abs(half) < 0.00001d0) then
!
!   FOR THE IRC:
!
! ESCF   = POTENTIAL ENERGY
! ELOST1 = ENERGY LOST (IN DRC, THIS WOULD HAVE BEEN THE KINETIC ENERGY)
! ETOT   = COMPUTED TOTAL ENERGY = STARTING POTENTIAL ENERGY
!
!   IN DRCOUT  'TOTAL' = ESCF + ELOST1
!              'ERROR' = ESCF + ELOST1 - ETOT
!
      call prtdrc (deltat, xparam, georef, escf, elost1, gtot, etot, velo0, mcoprt, ncoprt, parmax, &
          l_dipole, dip)
        else
!
!   FOR THE DRC:
!
! ESCF   = POTENTIAL ENERGY
! EKIN   = CURRENT KINETIC ENERGY
! ETOT   = COMPUTED TOTAL ENERGY = STARTING POTENTIAL ENERGY -
!          KINETIC ENERGY LOST THROUGH DAMPING, IF PRESENT.
!
!   IN DRCOUT  'TOTAL' = ESCF + EKIN
!              'ERROR' = ESCF + EKIN - ETOT
!
          call prtdrc (deltat, xparam, georef, escf, ekin, dummy, etot, velo0, mcoprt, ncoprt, parmax, &
          l_dipole, dip)
          if (iloop > 10 .and. (escf - escf_old)/ escf_diff < 0.d0) then
            bigcycles = bigcycles - 1
            if (bigcycles == 0) iupper = iloop
          end if
          escf_diff = escf - escf_old
          escf_old = escf
        end if
        iw0 = -1
        tnow = seconds(2)
        tcycle = tnow - oldtim
        oldtim = tnow
        tleft = tleft - tcycle
        if (iw00 > -1) then
          i = nint((100.0*iloop)/(iupper))
          if (i /= percent) then
            percent = i
            write(line,"(i4,a)")percent, "% of DRC/IRC done"
            call to_screen(line)
          end if
        end if
        if (jloop < jloop_lim .and. iloop /= iupper .and. tleft >= 3*tcycle) cycle
        if (tleft < 3*tcycle) then
          inquire(unit=ires, opened=opend)
          if (opend) close(unit=ires, status='DELETE')
          open(unit=ires, file=restart_fn, status='UNKNOWN', form='UNFORMATTED', position='asis')
          rewind ires
          write (ires) 1,1, (xparam(i),i=1,nvar)
          write (ires) (velo0(i),i=1,nvar)
          write (ires) (grad(i),i=1,nvar)
          write (ires) (grold(i),i=1,nvar)
          write (ires) (grold2(i),i=1,nvar)
          i = iloop + 1
          write (ires) etot, escf, ekin, delold, deltat, dlold2, i, gnorm, letot, elost1, gtot
          close (ires)
          escf = -1.d9
          call prtdrc (deltat, xparam, georef, escf, ekin, elost, etot, velo0, mcoprt, ncoprt, parmax, &
          l_dipole, dip)
          call den_in_out(1)
        end if
        do j = 1, 3
          do i = 1, numat
            geo(j, i) = coord(j, i)
            coord(j, i) = 0.0d0
          end do
        end do
        na = 0
        if ((jloop < jloop_lim .or. iloop == iupper) .and. bigcycles < 0) then
          write (iw, '(/10X,'' NUMBER OF CYCLES EXCEEDED, RESTART FILE WRITTEN'')')
          write (iw, '(10x," Number of cycles allowed in this run =",i7)') maxcyc + 1
          write (iw, '(10x," To increase the number of cycles, use keyword ""CYCLES=n"",")')
          write (iw, '(10x," where ""n"" is the number of cycles you want to run")')
        else
          write (iw, '(/10a,'' RUNNING OUT OF TIME, RESTART FILE WRITTEN'')')
        end if
        iw0 = iw00
        return
      end do
      iw0 = iw00
      return
      end subroutine drc

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine thermo(a, b, c, linear, sym, vibs, nvibs, escf)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use funcon_C, only : fpc_5, fpc_6, fpc_7, fpc_8, fpc_10, pi
      use molkst_C, only : keywrd, title, koment, mol_weight, &
      cp298 => temp_1, s298 => temp_2, ilim
      use common_arrays_C, only : T_range, HOF_tot, H_tot, Cp_tot, S_tot
      use chanel_C, only : iw
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n T s
!-----------------------------------------------
      integer , intent(in) :: nvibs
      double precision , intent(in) :: a
      double precision , intent(in) :: b
      double precision , intent(in) :: c
      double precision , intent(in) :: sym
      double precision , intent(in) :: escf
      logical , intent(in) :: linear
      double precision , intent(inout) :: vibs(*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: it1, it2, istep, i, itemp, ir
      double precision :: R, h, ak, ac, qtr2, T, c1, qv, hv, cpv, sv1, wi, ewj, &
        ewjr, e0, sv, qr, cpr, hr, sr, qint, hint, cpint, sint, qtr, cptr, htr&
        , str, cptot, stot, htot, h298
      character :: tmpkey*241
      double precision, external :: reada
!-----------------------------------------------
      if (allocated(T_range)) deallocate(T_range, HOF_tot, H_tot, Cp_tot, S_tot)
      allocate(T_range(300), HOF_tot(300), H_tot(300), Cp_tot(300), S_tot(300))
      R = fpc_5
      h = fpc_6
      ak = fpc_7
      ac = fpc_8
      it1 = 200
      it2 = 400
      istep = 10
      tmpkey = trim(keywrd)
      i = index(tmpkey,'THERMO(') + index(tmpkey,'THERMO=(')
      if (i /= 0) then
!
!   ERASE ALL TEXT FROM TMPKEY EXCEPT THERMO DATA
!
        tmpkey = tmpkey(i + index(tmpkey(i:), "("):)
        tmpkey(index(tmpkey,')'):) = ' '
        it1 = nint(reada(tmpkey,1))
        if (it1 < 100) then
          write (iw, &
      '(2/10X,''TEMPERATURE RANGE STARTS TOO LOW, LOWER BOUND IS RESET TO 100K'')')
          it1 = 100
        end if
        istep = 0
        do i = 1, len_trim(tmpkey)
          if (tmpkey(i:i) == ",") istep = istep + 1
        end do
        select case (istep)
          case (0)
!
!  Only starting temperatures provided
!
            it2 = it1 + 200
            istep = 10
          case (1)
!
!  Starting and ending temperatures provided
!
            i = index(tmpkey,',')
            it2 = nint(reada(tmpkey,i))
            istep = (it2 - it1)/20
            if (istep == 0) then
              istep = 1
            else if (istep <   5) then
              istep = 2
            else if (istep <  10) then
              istep = 5
            else if (istep <  20) then
              istep = 10
            else if (istep <  50) then
              istep = 20
            else if (istep < 100) then
              istep = 50
            else
              istep = 100
            end if
          case (2)
!
!  Starting, step-size, and ending temperatures provided
!
          i = index(tmpkey,',')
          tmpkey(i:i) = ' '
          it2 = nint(reada(tmpkey,i))
          istep = max0(1,istep)
          i = index(tmpkey,',')
          istep = nint(reada(tmpkey,i))
        end select
      end if
      if (nvibs > 0) then
        write (iw, '(2/,A)') trim(title)
        write (iw, '(A)') trim(koment)
        if (linear) then
          write (iw, '(2/10X,''MOLECULE IS LINEAR'')')
        else
          write (iw, '(2/10X,''MOLECULE IS NOT LINEAR'')')
        end if
        if (nvibs > 99) then
          write (iw, &
          '(/10X,''THERE ARE'',I5,'' GENUINE VIBRATIONS IN THIS '',''SYSTEM'')') &
          nvibs
        else
          write (iw, &
          '(/10X,''THERE ARE'',I3,'' GENUINE VIBRATIONS IN THIS '',''SYSTEM'')') &
          nvibs
        end if
        write (iw, 20)
  20    format(10x,'THIS THERMODYNAMICS CALCULATION IS LIMITED TO',/,10x,&
          'MOLECULES WHICH HAVE NO INTERNAL ROTATIONS'/,/)
      end if
      write (iw, '(2/20X,''CALCULATED THERMODYNAMIC PROPERTIES'')')
      write (iw, '(42X,''*'')')
      write (iw, &
      '(''   TEMP. (K)   PARTITION FUNCTION   H.O.F.    ENTHALPY  HEAT CAPACITY ENTROPY'')')
      write (iw, &
      '(''                                   KCAL/MOL   CAL/MOLE    CAL/K/MOL  CAL/K/MOL'',/)')
      do i = 1, nvibs
        vibs(i) = abs(vibs(i))
      end do
      ilim = 1
      if (istep > it2) then
        i = istep
        istep = it2
        it2 = i
      end if
      do itemp = it1, it2, istep
        ilim = ilim + 1
        T_range(ilim) = itemp
      end do
      T_range(1) = 298.D0
      qtr2 = 2.D0*pi*ac*mol_weight/fpc_10
      if (ilim == 2 .and. Abs(T_range(1) - T_range(2)) < 1.d-4) ilim = 1
      do ir = 1, ilim
        itemp = int(T_range(ir))
        T = itemp
!   ***   INITIALISE SOME VARIABLES   ***
        c1 = h*ac/ak/T
        qv = 1.0D0
        hv = 0.0D0
        cpv = 0.0D0
        sv1 = 0.0D0
!   ***   CONSTRUCT THE FREQUENCY DEPENDENT PARTS OF PARTITION FUNCTION
        do i = 1, nvibs
          wi = vibs(i)
!     INSERTED BY PROF. HIRANO
!        To exclude imaginary Wi (here expressed in negative value) and
!        small Wi arising from the imperfect geometry optimization,
!        Wi less than 100 cm-1 (an arbitrary threshold) are neglected
!        in the calculations of vibrational contributions.
          if (wi < 1.d-4) cycle
!
          ewj = dexp((-wi*c1))
          ewjr = 1.D0 - ewj
          qv = qv/ewjr
          e0 = wi*ewj/ewjr
          hv = hv + e0
          cpv = cpv + e0*e0/ewj
          sv1 = sv1 + dlog(ewjr)
        end do
!   ***   FINISH CALCULATION OF VIBRATIONAL PARTS   ***
        e0 = R*c1
        sv = hv*e0 - R*sv1
        hv = hv*e0*T
        cpv = cpv*e0*c1
        if (nvibs == 0) then
          qr = 0.d0 !  This is an atom, therefore no vibrations
          cpr = 0.d0
          hr = cpr*T
          sr = 0.d0
!   ***   NOW CALCULATE THE ROTATIONAL PARTS  (FIRST NON-LINEAR MOLECULES)
        else if (.not.linear) then
          e0 = pi/(a*b*c)
          qr = dsqrt(e0/c1)/c1/sym
          cpr = 1.5D0*R
          hr = cpr*T
          sr = R*(1.5D0*dlog(1.D0/c1) - dlog(sym) + dlog(e0)/2.D0 + 1.5D0)
        else
          qr = 1.D0/(c1*a*sym)
          cpr = R
          hr = cpr*T
          sr = R*dlog(qr) + R
        end if
!   ***   CALCULATE INTERNAL CONTRIBUTIONS   ***
        qint = qv*qr
        hint = hv + hr
        cpint = cpv + cpr
        sint = sv + sr
!   ***   CONSTRUCT TRANSLATION CONTRIBUTIONS   ***
        qtr = dsqrt(qtr2/c1/h)**3
        cptr = 2.5D0*R
        htr = cptr*T
!     UPDATED BY PROF.HIRANO AND MODIFIED BY YI
        str = 4.96804D0*(log(T) + 0.6D0*log(mol_weight)) - 2.31482D0
!
!  Which is best?
!
!   STR=2.2868D0*(5.D0*LOG10(T)+3.D0*LOG10(mol_weight))-2.3135D0
!   STR=0.993608D0*(5.D0*LOG(T)+3.D0*LOG(mol_weight))-2.31482D0
!   STR=4.96804D0*(LOG(T)+0.6D0*LOG(mol_weight))-2.31482D0
!
!   ***   CONSTRUCT TOTALS   ***
        cptot = cptr + cpint
        stot = str + sint
        htot = htr + hint
!   ***   OUTPUT SECTION   ***
!     UPDATED BY PROF. HIRANO
        if (ir == 1) h298 = htot
        write (iw, '(/,F7.2,''  VIB.'',D15.4,10X,f17.4,2F11.4)') T, qv, hv, cpv, sv
        write (iw, '(9X,''ROT.'',D15.4,10X,f17.4,2F11.4)') qr, hr, cpr, sr
        write (iw, '(9X,''INT.'',D15.4,10X,f17.4,2F11.4)') qint, hint, cpint, sint
        write (iw, '(9X,''TRA.'',D15.4,10X,f17.4,2F11.4)') qtr, htr, cptr, str
        write (iw, '(9X,''TOT.'',12X,F17.3,F13.4,2F11.4)') escf + (htot - h298)/1000.D0, htot, cptot, stot
        HOF_tot(ir) = escf + (htot - h298)/1000.D0
        H_tot(ir)   = htot
        Cp_tot(ir)  = cptot
        S_tot(ir)   = stot
      end do
      if (ilim == 1 .and. Abs(T_range(1) - 298) < 1.d1) then
        cp298 = cptot
        s298  = stot
      end if
      write (iw, &
      '(/3X,''*: NOTE: HEATS OF FORMATION ARE RELATIVE TO THE'',/12X,&
        &''ELEMENTS IN THEIR STANDARD STATE AT 298K'')')
!     INSERTED BY PROF.HIRANO
      write (iw, '(12X,''  (=  Standard Enthalpy of Formation).'')')  !,        /12X,&
   !     &''Heat of Formation at T is calculated as [Escf + (HT - H298.15)-.'')')
      write (iw, &
      & '(/12X,''Hvib:  Zero-point energy is not included.'',    /12X,&
      &''       frequencies of less than zero cm-1 are not included.'', &
      & /12X,''Hrot = (3/2)RT''/12X,''Htra = (3/2)RT + pV = (5/2)RT'')')
      write (iw, '(/12X,''Heat capacity is Cp, not Cv'')')
      call web_message(iw,"thermochemistry.html")
!  END OF INSERT
      return
      end subroutine thermo

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine minv(a, n, d)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!***********************************************************************
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n
      double precision , intent(out) :: d
      double precision , intent(inout) :: a(*)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(n) :: m, l
      integer :: nk, k, kk, j, iz, i, ij, ki, ji, jp, jk, ik, kj, jq, jr
      double precision :: biga, hold
!-----------------------------------------------
!*********************************************************************
!
!     INVERT A MATRIX USING GAUSS-JORDAN METHOD.  PART OF DIIS
!     A - INPUT MATRIX (MUST BE A GENERAL MATRIX), DESTROYED IN
!        COMPUTATION AND REPLACED BY RESULTANT INVERSE.
!     N - ORDER OF MATRIX A
!     D - RESULTANT DETERMINANT
!
!*********************************************************************
!
!     SEARCH FOR LARGEST ELEMENT
!
      d = 1.0D0
      nk = -n
      do k = 1, n
        nk = nk + n
        l(k) = k
        m(k) = k
        kk = nk + k
        biga = a(kk)
        do j = k, n
          iz = n*(j - 1)
          do i = k, n
            ij = iz + i
            if (abs(biga) >= abs(a(ij))) cycle
            biga = a(ij)
            l(k) = i
            m(k) = j
          end do
        end do
!
!     INTERCHANGE ROWS
!
        j = l(k)
        if (j - k > 0) then
          ki = k - n
          do i = 1, n
            ki = ki + n
            hold = -a(ki)
            ji = ki - k + j
            a(ki) = a(ji)
            a(ji) = hold
          end do
        end if
!
!     INTERCHANGE COLUMNS
!
        i = m(k)
        if (i - k > 0) then
          jp = n*(i - 1)
          do j = 1, n
            jk = nk + j
            ji = jp + j
            hold = -a(jk)
            a(jk) = a(ji)
            a(ji) = hold
          end do
        end if
!
!     DIVIDE COLUMN BY MINUS PIVOT (VALUE OF PIVOT ELEMENT IS
!     CONTAINED IN BIGA)
!
        if (biga == 0.D0) then
          d = 0.D0
          return
        end if
        do i = 1, n
          if (i - k == 0) cycle
          ik = nk + i
          a(ik) = a(ik)/(-biga)
        end do
!  REDUCE MATRIX
        do i = 1, n
          ik = nk + i
          hold = a(ik)
          ij = i - n
          if (i - k == 0) then
          else
            do j = 1, n
              ij = ij + n
              if (j - k == 0) cycle
              kj = ij - i + k
              a(ij) = hold*a(kj) + a(ij)
            end do
          end if
        end do
!
!     DIVIDE ROW BY PIVOT
!
        kj = k - n
        do j = 1, n
          kj = kj + n
          if (j - k == 0) cycle
          a(kj) = a(kj)/biga
        end do
!
!     PRODUCT OF PIVOTS
!
        d = max(-1.D25,min(1.D25,d))
        d = d*biga
!
!     REPLACE PIVOT BY RECIPROCAL
!
        a(kk) = 1.D0/biga
      end do
!
!     FINAL ROW AND COLUMN INTERCHANGE
!
      k = n
  190 continue
      k = k - 1
      if (k <= 0) go to 260
      i = l(k)
      if (i - k > 0) then
        jq = n*(k - 1)
        jr = n*(i - 1)
        do j = 1, n
          jk = jq + j
          hold = a(jk)
          ji = jr + j
          a(jk) = -a(ji)
          a(ji) = hold
        end do
      end if
      j = m(k)
      if (j - k <= 0) go to 190
      ki = k - n
      do i = 1, n
        ki = ki + n
        hold = a(ki)
        ji = ki - k + j
        a(ki) = -a(ji)
        a(ji) = hold
      end do
      go to 190
  260 continue
      return
      end subroutine minv

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

module orient_water_C
  double precision :: near(3,30), O_coord(3)
  integer :: near_nat(30), n_atoms, O_copy, H1_copy, atom_nos(30)
end module orient_water_C
subroutine orient_water(O_of_H2O, H1, H2, fun)
use common_arrays_C,  only : coord, nat
use molkst_C,  only : numat
use orient_water_C, only: near,  O_coord, n_atoms, near_nat, O_copy, H1_copy, atom_nos
implicit none
integer, intent (in) :: O_of_H2O, H1, H2
double precision, intent (out) :: fun
double precision :: x(6)
integer   :: i, n
double precision, external :: distance
  n = 6
  x(1:3) = coord(:,H1)
  x(4:6) = coord(:,H2)
  O_coord = coord(:,O_of_H2O)
  O_copy = O_of_H2O
  H1_copy = H1
!
! Find nearby atoms
!
  n_atoms = 0
  do i = 1, numat
    if (distance(O_of_H2O, i) < 3.5d0) then
      if (i /= O_of_H2O .and. i /= H1 .and. i /= H2) then
        n_atoms = n_atoms + 1
        near(:, n_atoms) = coord(:, i)
        near_nat(n_atoms) = nat(i)
        atom_nos(n_atoms) = i
      end if
    end if
  end do
  if (n_atoms > 0) then
    call cobyla (n, x, fun)
    coord(:,H1) = x(1:3)
    coord(:,H2) = x(4:6)
  end if
  return
end subroutine orient_water

subroutine calcfc (x, fun)
!
! Evaluate the energy penalty due to steric interactions between water hydrogen atoms
! and nearby heavy atoms.
!
! Input:
! x:                Coordinates of the two hydrogen atoms
! O_coord:          Coordinates of the oxygen atom
! near(3, n_atoms): Coordinates of the n_atoms atoms near to oxygen atom
!
! On exit:
! fun:                Value of the energy-penalty, i.e., function to be minimized
!
use common_arrays_C,  only : coord
use orient_water_C, only : near, O_coord, n_atoms, near_nat, O_copy, H1_copy, atom_nos
implicit none
double precision, intent(in)   :: x(6)
double precision, intent(out)  :: fun
!
! Local
!
integer :: i, j
double precision :: h2(3,2), Rab, Rab2, min_O, c_O, angle
!
logical :: first = .true.
save
!
! This method of positioning the hydrogen atoms in a water molecule is "quick and dirty" -
! it works, but could do with being improved.
!
  if (first) then
!
!  Set the optimum H-X distances
!
    min_O = 2.d0
!
!  For a 12-6 potential, the precursor to the "6" term is 2/min_X**6
!
    c_O = 2.d0/min_O**6
    first = .false.
  end if
  h2(1:3,1) = x(1:3)
  h2(1:3,2) = x(4:6)
  fun = 0.d0
!
!  H - other atoms repulsion
!
  do j = 1, 2
    do i = 1, n_atoms
      Rab2 = (h2(1,j) - near(1,i))**2 + (h2(2,j) - near(2,i))**2 + (h2(3,j) - near(3,i))**2
      rab =  sqrt(rab2)
      select case (near_nat(i))
      case (1)  ! H-H repulsion
        fun = fun + 1.d0*Rab2**(-6)
      case (6, 7)  ! H-(C, and N) repulsion
        fun = fun + 100.d0*Rab2**(-6)
      case (8)  ! H-O interaction
        fun = fun + 100.d0*(Rab2**(-6) - c_O/Rab2**3)
        if (j == 1) then
          coord(:,H1_copy) = H2(:,1)
          call bangle (coord, O_copy, H1_copy, atom_nos(i), angle)
          fun = fun + 0.15d0*(3.14159d0 - angle)
        end if
      case (12)  ! H-Mg
        fun = fun + 200.d0*Rab2**(-6)
      case default  ! H-(everything else) repulsion
        fun = fun + 100.d0/Rab2**6
      end select
    end do
  end do
!
!  H - H distance
!
  Rab = sqrt((h2(1,1) - h2(1,2))**2 +(h2(2,1) - h2(2,2))**2 + (h2(3,1) - h2(3,2))**2)
  fun = fun + (Rab - 1.52d0)**2
!
!  O - H distance
!
  do i = 1, 2
    Rab = sqrt((h2(1,i) - O_coord(1))**2 +(h2(2,i) - O_coord(2))**2 + (h2(3,i) - O_coord(3))**2)
    fun = fun +    (Rab - 0.98d0)**2
  end do
return
end subroutine calcfc
subroutine cobyla (n,  x,  fun)
!
! Generic function minimized,  modified to work only for optimizing the positions of
! hydrogen atoms in water,  when ADD-H is used.
!
! n   = 6 = number of coordinates
! x   = Coordinates of the two hydrogen atoms,  updated on output
! fun = value of penalty (used in debugging only)
!
! This code is "black-box"
!
integer,  intent(in) :: n
double precision,  intent(in out)  :: x(6)
double precision :: con(2),  sim(n, n + 1),  simi(n, n),  datmat(2, n + 1),  a(n, 1),       &
             vsig(n),  veta(n),  sigbar(n),  dx(n),  w(n)
double precision :: alpha,  barmu,  beta,  cmin,  cmax,  cvmaxm,  cvmaxp,  delta,  denom,     &
             dxsign,  edgmax,  error,  fun,  gamma,  pareta,  parmu,  parsig,  phi,      &
             phimin,  prerec,  prerem,  ratio,  resmax,  resnew,  rho,  temp,  tempa,  &
             total,  trured,  vmnew,  vmold,  weta,  wsig,   rhobeg,  rhoend
integer   :: i,  ibrnch,  iflag,  ifull,  iptem,  iptemp,  j,  jdrop,  k,  l,  mp,   &
             nbest,  nfvals,  np,  iw = 6,  mpp,  m,  iprint,  maxfun
  rhobeg = 0.5d0
  rhoend = 1.d-3
  iprint = 0
  iflag = 0
  maxfun = 3500
  iptem = min(n, 5)
  iptemp = iptem + 1
  m = 0
  np = n + 1
  mp = m + 1
  mpp = m + 2
  alpha = 0.25d0
  beta = 2.1d0
  gamma = 0.5d0
  delta = 1.1d0
  rho = rhobeg
  parmu = 0.0d0
  parsig = 0.d0
  if (iprint >= 2) write(iw,  10) rho
  10 format (/'   The initial value of RHO is',  G13.6,    &
             '  and PARMU is set to zero.')
  nfvals = 0
  temp = 1.0d0/rho
  do i=1, n
    sim(i, np) = x(i)
    do j=1, n
      sim(i, j) = 0.0d0
      simi(i, j) = 0.0d0
    end do
    sim(i, i) = rho
    simi(i, i) = temp
  end do
  jdrop = np
  ibrnch = 0

  !  Make the next call of the user-supplied subroutine CALCFC. These
  !  instructions are also used for calling CALCFC during the iterations of
  !  the algorithm.

  40 if (nfvals >= maxfun .and. nfvals > 0) then
    if (iprint >= 1) write(iw,  50)
    50 format (/'   return from subroutine COBYLA because the ',   &
               'MAXFUN limit has been reached.')
    go to 600
  end if
  nfvals = nfvals + 1
  call calcfc (x,  fun)
  resmax = 0.0d0
  if (nfvals == iprint-1 .or. iprint == 3) then
    write(iw,  70) nfvals,  fun,  resmax,  x(1:iptem)
    70 format (/'   NFVALS = ',  i5,  '   fun = ',  G13.6,  '    MAXCV = ',   &
               G13.6/ ('   X = ',  5G14.6))
    if (iptem < n) write(iw,  80) x(iptemp:n)
    80 format (G19.6,  G15.6)
  end if
  con(mp) = fun
  con(mpp) = resmax
  if (ibrnch == 1) go to 440

  !  Set the recently calculated function values in a column of DATMAT. This
  !  array has a column for each vertex of the current simplex,  the entries of
  !  each column being the values of the constraint functions (if any)
  !  followed by the objective function and the greatest constraint violation
  !  at the vertex.

  do k=1, mpp
    datmat(k, jdrop) = con(k)
  end do
  if (nfvals > np) go to 130

  !  Exchange the new vertex of the initial simplex with the optimal vertex if
  !  necessary. then,  if the initial simplex is not complete,  pick its next
  !  vertex and calculate the function values there.

  if (jdrop <= n) then
    if (datmat(mp, np) <= fun) then
      x(jdrop) = sim(jdrop, np)
    else
      sim(jdrop, np) = x(jdrop)
      do k=1, mpp
        datmat(k, jdrop) = datmat(k, np)
        datmat(k, np) = con(k)
      end do
      do k=1, jdrop
        sim(jdrop, k) = -rho
        temp = -sum( simi(k:jdrop,  k) )
        simi(jdrop, k) = temp
      end do
    end if
  end if
  if (nfvals <= n) then
    jdrop = nfvals
    x(jdrop) = x(jdrop) + rho
    go to 40
  end if
  130 ibrnch = 1

  !  Identify the optimal vertex of the current simplex.

  140 phimin = datmat(mp, np) + parmu*datmat(mpp, np)
  nbest = np
  do j=1, n
    temp = datmat(mp, j) + parmu*datmat(mpp, j)
    if (temp < phimin) then
      nbest = j
      phimin = temp
    else if (abs(temp - phimin) < 1.d-6 .and. parmu == 0.0d0) then
      if (datmat(mpp, j) < datmat(mpp, nbest)) nbest = j
    end if
  end do

  !  Switch the best vertex into pole position if it is not there already,
  !  and also update SIM,  SIMI and DATMAT.

  if (nbest <= n) then
    do i=1, mpp
      temp = datmat(i, np)
      datmat(i, np) = datmat(i, nbest)
      datmat(i, nbest) = temp
    end do
    do i=1, n
      temp = sim(i, nbest)
      sim(i, nbest) = 0.0d0
      sim(i, np) = sim(i, np) + temp
      tempa = 0.0d0
      do k=1, n
        sim(i, k) = sim(i, k) - temp
        tempa = tempa - simi(k, i)
      end do
      simi(nbest, i) = tempa
    end do
  end if

  !  Make an error return if SIGI is a poor approximation to the inverse of
  !  the leading N by N submatrix of SIG.

  error = 0.0d0
  do i=1, n
    do j=1, n
      temp = 0.0d0
      if (i == j) temp = temp - 1.0d0
      temp = temp + dot_product( simi(i, 1:n),  sim(1:n, j) )
      error = max(error,  abs(temp))
    end do
  end do
  if (error > 0.1d0) then
    if (iprint >= 1) write(iw,  210)
    210 format (/'   return from subroutine COBYLA because ',   &
                'rounding errors are becoming damaging.')
    go to 600
  end if

  !  Calculate the coefficients of the linear approximations to the objective
  !  and constraint functions,  placing minus the objective function gradient
  !  after the constraint gradients in the array A. The vector W is used for
  !  working space.

  do k=1, mp
    con(k) = -datmat(k, np)
    do j=1, n
      w(j) = datmat(k, j) + con(k)
    end do
    do i=1, n
      temp = dot_product( w(1:n),  simi(1:n, i) )
      if (k == mp) temp = -temp
      a(i, k) = temp
    end do
  end do

  !  Calculate the values of sigma and eta,  and set IFLAG = 0 if the current
  !  simplex is not acceptable.

  iflag = 1
  parsig = alpha*rho
  pareta = beta*rho
  do j=1, n
    wsig = sum( simi(j, 1:n)**2 )
    weta = sum( sim(1:n, j)**2 )
    vsig(j) = 1.0d0/sqrt(wsig)
    veta(j) = sqrt(weta)
    if (vsig(j) < parsig .or. veta(j) > pareta) iflag = 0
  end do

  !  if a new vertex is needed to improve acceptability,  then decide which
  !  vertex to drop from the simplex.

  if (ibrnch == 1 .or. iflag == 1) go to 370
  jdrop = 0
  temp = pareta
  do j=1, n
    if (veta(j) > temp) then
      jdrop = j
      temp = veta(j)
    end if
  end do
  if (jdrop == 0) then
    do j=1, n
      if (vsig(j) < temp) then
        jdrop = j
        temp = vsig(j)
      end if
    end do
  end if

  !  Calculate the step to the new vertex and its sign.

  temp = gamma*rho*vsig(jdrop)
  dx(1:n) = temp*simi(jdrop, 1:n)
  cvmaxp = 0.0d0
  cvmaxm = 0.0d0
  do k=1, mp
    total = dot_product( a(1:n, k),  dx(1:n) )
    if (k < mp) then
      temp = datmat(k, np)
      cvmaxp = max(cvmaxp,  -total - temp)
      cvmaxm = max(cvmaxm,  total - temp)
    end if
  end do
  dxsign = 1.0d0
  if (parmu*(cvmaxp - cvmaxm) > total + total) dxsign = -1.0d0

  !  Update the elements of SIM and SIMI,  and set the next X.

  temp = 0.0d0
  do i=1, n
    dx(i) = dxsign*dx(i)
    sim(i, jdrop) = dx(i)
    temp = temp + simi(jdrop, i)*dx(i)
  end do
  simi(jdrop, 1:n) = simi(jdrop, 1:n) / temp
  do j=1, n
    if (j /= jdrop) then
      temp = dot_product( simi(j, 1:n),  dx(1:n) )
      simi(j, 1:n) = simi(j, 1:n) - temp*simi(jdrop, 1:n)
    end if
    x(j) = sim(j, np) + dx(j)
  end do
  go to 40

  !  Calculate DX = x(*)-x(0).
  !  Branch if the length of DX is less than 0.5*RHO.

  370 call trstlp (n,  m,  a,  con,  rho,  dx,  ifull)
  if (ifull == 0) then
    temp = sum( dx(1:n)**2 )
    if (temp < 0.25d0*rho*rho) then
      ibrnch = 1
      go to 550
    end if
  end if

  !  Predict the change to fun and the new maximum constraint violation if the
  !  variables are altered from x(0) to x(0) + DX.

  resnew = 0.0d0
  con(mp) = 0.0d0
  do k=1, mp
    total = con(k) - dot_product( a(1:n, k),  dx(1:n) )
    if (k < mp) resnew = max(resnew,  total)
  end do

  !  Increase PARMU if necessary and branch back if this change alters the
  !  optimal vertex. Otherwise PREREM and PREREC will be set to the predicted
  !  reductions in the merit function and the maximum constraint violation
  !  respectively.

  barmu = 0.0d0
  prerec = datmat(mpp, np) - resnew
  if (prerec > 0.0d0) barmu = total/prerec
  if (parmu < 1.5d0*barmu) then
    parmu = 2.0d0*barmu
    if (iprint >= 2) write(iw,  410) parmu
    410 format (/'   Increase in PARMU to',  G13.6)
    phi = datmat(mp, np) + parmu*datmat(mpp, np)
    do j=1, n
      temp = datmat(mp, j) + parmu*datmat(mpp, j)
      if (temp < phi) go to 140
      if (temp - phi < 1.d-6 .and. parmu == 0.0) then
        if (datmat(mpp, j) < datmat(mpp, np)) go to 140
      end if
    end do
  end if
  prerem = parmu*prerec - total

  !  Calculate the constraint and objective functions at x(*).
  !  then find the actual reduction in the merit function.

  x(1:n) = sim(1:n, np) + dx(1:n)
  ibrnch = 1
  go to 40

  440 vmold = datmat(mp, np) + parmu*datmat(mpp, np)
  vmnew = fun + parmu*resmax
  trured = vmold - vmnew
  if (abs(parmu) < 1.d-6 .and. abs(fun - datmat(mp, np)) < 1.d-6) then
    prerem = prerec
    trured = datmat(mpp, np) - resmax
  end if

  !  Begin the operations that decide whether x(*) should replace one of the
  !  vertices of the current simplex,  the change being mandatory if TRURED is
  !  positive. Firstly,  JDROP is set to the index of the vertex that is to be
  !  replaced.

  ratio = 0.0d0
  if (trured <= 0.0d0) ratio = 1.0d0
  jdrop = 0
  do j=1, n
    temp = dot_product( simi(j, 1:n),  dx(1:n) )
    temp = abs(temp)
    if (temp > ratio) then
      jdrop = j
      ratio = temp
    end if
    sigbar(j) = temp*vsig(j)
  end do

  !  Calculate the value of ell.

  edgmax = delta*rho
  l = 0
  do j=1, n
    if (sigbar(j) >= parsig .or. sigbar(j) >= vsig(j)) then
      temp = veta(j)
      if (trured > 0.0d0) then
        temp = sum( (dx(1:n) - sim(1:n, j))**2 )
        temp = sqrt(temp)
      end if
      if (temp > edgmax) then
        l = j
        edgmax = temp
      end if
    end if
  end do
  if (l > 0) jdrop = l
  if (jdrop == 0) go to 550

  !  Revise the simplex by updating the elements of SIM,  SIMI and DATMAT.

  temp = 0.0d0
  do i=1, n
    sim(i, jdrop) = dx(i)
    temp = temp + simi(jdrop, i)*dx(i)
  end do
  simi(jdrop, 1:n) = simi(jdrop, 1:n) / temp
  do j=1, n
    if (j /= jdrop) then
      temp = dot_product( simi(j, 1:n),  dx(1:n) )
      simi(j, 1:n) = simi(j, 1:n) - temp*simi(jdrop, 1:n)
    end if
  end do
  datmat(1:mpp, jdrop) = con(1:mpp)

  !  Branch back for further iterations with the current RHO.

  if (trured > 0.0d0 .and. trured >= 0.1d0*prerem) go to 140
  550 if (iflag == 0) then
    ibrnch = 0
    go to 140
  end if

  !  Otherwise reduce RHO if it is not at its least value and reset PARMU.

  if (rho > rhoend) then
    rho = 0.5d0*rho
    if (rho <= 1.5d0*rhoend) rho = rhoend
    if (parmu > 0.0d0) then
      denom = 0.0d0
      do k=1, mp
        cmin = datmat(k, np)
        cmax = cmin
        do i=1, n
          cmin = min(cmin,  datmat(k, i))
          cmax = max(cmax,  datmat(k, i))
        end do
        if (k <= m .and. cmin < 0.5d0*cmax) then
          temp = max(cmax, 0.0d0) - cmin
          if (denom <= 0.0d0) then
            denom = temp
          else
            denom = min(denom, temp)
          end if
        end if
      end do
      if (denom == 0.0d0) then
        parmu = 0.0d0
      else if (cmax - cmin < parmu*denom) then
        parmu = (cmax - cmin)/denom
      end if
    end if
    if (iprint >= 2) write(iw,  580) rho, parmu
    580 format ('   Reduction in RHO to ',  G13.6,  '  and PARMU = ',  G13.6)
    if (iprint == 2) then
      write(iw,  70) nfvals,  datmat(mp, np),  datmat(mpp, np),  sim(1:iptem, np)
      if (iptem < n) write(iw,  80) x(iptemp:n)
    end if
    go to 140
  end if

  !  return the best calculated values of the variables.

  if (iprint >= 1) write(iw,  590)
  590 format (/'   Normal return from subroutine COBYLA')
  if (ifull == 1) go to 620

  600 x(1:n) = sim(1:n, np)
  fun = datmat(mp, np)
  resmax = datmat(mpp, np)
  620 if (iprint >= 1) then
    write(iw,  70) nfvals,  fun,  resmax,  x(1:iptem)
    if (iptem < n) write(iw,  80) x(iptemp:n)
  end if
  maxfun = nfvals
  return
end subroutine cobyla
!------------------------------------------------------------------------------

subroutine trstlp (n,  m,  a,  b,  rho,  dx,  ifull)

! N.B. Arguments Z,  ZDOTA,  VMULTC,  SDIRN,  DXNEW,  VMULTD & IACT have been removed.

integer,  intent(in)     :: n
integer,  intent(in)     :: m
double precision,  intent(in)   :: a(n, 10)
double precision,  intent(in)   :: b(m)
double precision,  intent(in)   :: rho
double precision,  intent(out)  :: dx(10)
integer,  intent(out)    :: ifull

!

double precision :: z(n, n),  zdota(m + 1),  vmultc(m + 1),  sdirn(n),  dxnew(n),  vmultd(m + 1)
double precision :: acca,  accb,  alpha,  beta,  dd,  optnew,  optold,  ratio,  resmax,    &
             resold,  sd,  sp,  spabs,  ss,  step,  stpful,  sumabs,  temp,  tempa,  &
             tot,  total,  vsave,  zdotv,  zdotw,  zdvabs,  zdwabs
integer   :: i,  iact(m + 1),  icon,  icount,  isave,  k,  kk,  kl,  kp,  kw,  mcon,    &
             nact,  nactx

ifull = 1
icon = 0
mcon = m
nact = 0
nactx = 0
resold = 0.d0
resmax = 0.0d0
do i=1, n
  z(i, 1:n) = 0.0d0
  z(i, i) = 1.0d0
  dx(i) = 0.0d0
end do
if (m >= 1) then
  do k=1, m
    if (b(k) > resmax) then
      resmax = b(k)
      icon = k
    end if
  end do
  do k=1, m
    iact(k) = k
    vmultc(k) = resmax - b(k)
  end do
end if
if (resmax == 0.0d0) go to 480
sdirn(1:n) = 0.0d0

!  end the current stage of the calculation if 3 consecutive iterations
!  have either failed to reduce the best calculated value of the objective
!  function or to increase the number of active constraints since the best
!  value was calculated. This strategy prevents cycling,  but there is a
!  remote possibility that it will cause premature termination.

60 optold = 0.0d0
icount = 0
70 if (mcon == m) then
  optnew = resmax
else
  optnew = -dot_product( dx(1:n),  a(1:n, mcon) )
end if
if (icount == 0 .or. optnew < optold) then
  optold = optnew
  nactx = nact
  icount = 3
else if (nact > nactx) then
  nactx = nact
  icount = 3
else
  icount = icount - 1
  if (icount == 0) go to 490
end if

!  if ICON exceeds NACT,  then we add the constraint with index IACT(ICON) to
!  the active set. Apply Givens rotations so that the last N-NACT-1 columns
!  of Z are orthogonal to the gradient of the new constraint,  a scalar
!  product being set to zero if its nonzero value could be due to computer
!  rounding errors. The array DXNEW is used for working space.

if (icon <= nact) go to 260
kk = iact(icon)
dxnew(1:n) = a(1:n, kk)
tot = 0.0d0
k = n
100 if (k > nact) then
  sp = 0.0d0
  spabs = 0.0d0
  do i=1, n
    temp = z(i, k)*dxnew(i)
    sp = sp + temp
    spabs = spabs + abs(temp)
  end do
  acca = spabs + 0.1d0*abs(sp)
  accb = spabs + 0.2d0*abs(sp)
  if (spabs >= acca .or. acca >= accb) sp = 0.0d0
  if (tot == 0.0d0) then
    tot = sp
  else
    kp = k + 1
    temp = sqrt(sp*sp + tot*tot)
    alpha = sp/temp
    beta = tot/temp
    tot = temp
    do i=1, n
      temp = alpha*z(i, k) + beta*z(i, kp)
      z(i, kp) = alpha*z(i, kp) - beta*z(i, k)
      z(i, k) = temp
    end do
  end if
  k = k - 1
  go to 100
end if

!  Add the new constraint if this can be done without a deletion from the
!  active set.

if (tot /= 0.0d0) then
  nact = nact + 1
  zdota(nact) = tot
  vmultc(icon) = vmultc(nact)
  vmultc(nact) = 0.0d0
  go to 210
end if

!  The next instruction is reached if a deletion has to be made from the
!  active set in order to make room for the new active constraint,  because
!  the new constraint gradient is a linear combination of the gradients of
!  the old active constraints.  Set the elements of VMULTD to the multipliers
!  of the linear combination.  Further,  set IOUT to the index of the
!  constraint to be deleted,  but branch if no suitable index can be found.

ratio = -1.0d0
k = nact
130 zdotv = 0.0d0
zdvabs = 0.0d0
do i=1, n
  temp = z(i, k)*dxnew(i)
  zdotv = zdotv + temp
  zdvabs = zdvabs + abs(temp)
end do
acca = zdvabs + 0.1d0*abs(zdotv)
accb = zdvabs + 0.2d0*abs(zdotv)
if (zdvabs < acca .and. acca < accb) then
  temp = zdotv/zdota(k)
  if (temp > 0.0d0 .and. iact(k) <= m) then
    tempa = vmultc(k)/temp
    if (ratio < 0.0d0 .or. tempa < ratio) then
      ratio = tempa
    end if
  end if
  if (k >= 2) then
    kw = iact(k)
    dxnew(1:n) = dxnew(1:n) - temp*a(1:n, kw)
  end if
  vmultd(k) = temp
else
  vmultd(k) = 0.0d0
end if
k = k - 1
if (k > 0) go to 130
if (ratio < 0.0d0) go to 490

!  Revise the Lagrange multipliers and reorder the active constraints so
!  that the one to be replaced is at the end of the list. Also calculate the
!  new value of ZDOTA(NACT) and branch if it is not acceptable.

do k=1, nact
  vmultc(k) = max(0.0d0, vmultc(k) - ratio*vmultd(k))
end do
if (icon < nact) then
  isave = iact(icon)
  vsave = vmultc(icon)
  k = icon
  170 kp = k + 1
  kw = iact(kp)
  sp = dot_product( z(1:n, k),  a(1:n, kw) )
  temp = sqrt(sp*sp + zdota(kp)**2)
  alpha = zdota(kp)/temp
  beta = sp/temp
  zdota(kp) = alpha*zdota(k)
  zdota(k) = temp
  do i=1, n
    temp = alpha*z(i, kp) + beta*z(i, k)
    z(i, kp) = alpha*z(i, k) - beta*z(i, kp)
    z(i, k) = temp
  end do
  iact(k) = kw
  vmultc(k) = vmultc(kp)
  k = kp
  if (k < nact) go to 170
  iact(k) = isave
  vmultc(k) = vsave
end if
temp = dot_product( z(1:n, nact),  a(1:n, kk) )
if (temp == 0.0d0) go to 490
zdota(nact) = temp
vmultc(icon) = 0.0d0
vmultc(nact) = ratio

!  Update IACT and ensure that the objective function continues to be
!  treated as the last active constraint when MCON>M.

210 iact(icon) = iact(nact)
iact(nact) = kk
if (mcon > m .and. kk /= mcon) then
  k = nact - 1
  sp = dot_product( z(1:n, k),  a(1:n, kk) )
  temp = sqrt(sp*sp + zdota(nact)**2)
  alpha = zdota(nact)/temp
  beta = sp/temp
  zdota(nact) = alpha*zdota(k)
  zdota(k) = temp
  do i=1, n
    temp = alpha*z(i, nact) + beta*z(i, k)
    z(i, nact) = alpha*z(i, k) - beta*z(i, nact)
    z(i, k) = temp
  end do
  iact(nact) = iact(k)
  iact(k) = kk
  temp = vmultc(k)
  vmultc(k) = vmultc(nact)
  vmultc(nact) = temp
end if

!  if stage one is in progress,  then set SDIRN to the direction of the next
!  change to the current vector of variables.

if (mcon > m) go to 320
kk = iact(nact)
temp = dot_product( sdirn(1:n),  a(1:n, kk) )
temp = temp - 1.0d0
temp = temp/zdota(nact)
sdirn(1:n) = sdirn(1:n) - temp*z(1:n, nact)
go to 340

!  Delete the constraint that has the index IACT(ICON) from the active set.

260 if (icon < nact) then
  isave = iact(icon)
  vsave = vmultc(icon)
  k = icon
  do
    kp = k + 1
    kk = iact(kp)
    sp = dot_product( z(1:n, k),  a(1:n, kk) )
    temp = sqrt(sp*sp + zdota(kp)**2)
    alpha = zdota(kp)/temp
    beta = sp/temp
    zdota(kp) = alpha*zdota(k)
    zdota(k) = temp
    do i=1, n
      temp = alpha*z(i, kp) + beta*z(i, k)
      z(i, kp) = alpha*z(i, k) - beta*z(i, kp)
      z(i, k) = temp
    end do
    iact(k) = kk
    vmultc(k) = vmultc(kp)
    k = kp
    if (k >= nact) EXIT
  end do
  iact(k) = isave
  vmultc(k) = vsave
end if
nact = nact - 1

!  if stage one is in progress,  then set SDIRN to the direction of the next
!  change to the current vector of variables.

if (mcon > m) go to 320
temp = dot_product( sdirn(1:n),  z(1:n, nact + 1) )
sdirn(1:n) = sdirn(1:n) - temp*z(1:n, nact + 1)
go to 340

!  Pick the next search direction of stage two.

320 temp = 1.0d0/zdota(nact)
sdirn(1:n) = temp*z(1:n, nact)

!  Calculate the step to the boundary of the trust region or take the step
!  that reduces RESMAX to zero. The two statements below that include the
!  factor 1.0E-6 prevent some harmless underflows that occurred in a test
!  calculation. Further,  we skip the step if it could be zero within a
!  reasonable tolerance for computer rounding errors.

340 dd = rho*rho
sd = 0.0d0
ss = 0.0d0
do i=1, n
  if (abs(dx(i)) >= 1.0E-6*rho) dd = dd - dx(i)**2
  sd = sd + dx(i)*sdirn(i)
  ss = ss + sdirn(i)**2
end do
if (dd <= 0.0d0) go to 490
temp = sqrt(ss*dd)
if (abs(sd) >= 1.0E-6*temp) temp = sqrt(ss*dd + sd*sd)
stpful = dd/(temp + sd)
step = stpful
if (mcon == m) then
  acca = step + 0.1d0*resmax
  accb = step + 0.2d0*resmax
  if (step >= acca .or. acca >= accb) go to 480
  step = min(step, resmax)
end if

!  Set DXNEW to the new variables if STEP is the steplength,  and reduce
!  RESMAX to the corresponding maximum residual if stage one is being done.
!  Because DXNEW will be changed during the calculation of some Lagrange
!  multipliers,  it will be restored to the following value later.

dxnew(1:n) = dx(1:n) + step*sdirn(1:n)
if (mcon == m) then
  resold = resmax
  resmax = 0.0d0
  do k=1, nact
    kk = iact(k)
    temp = b(kk) - dot_product( a(1:n, kk),  dxnew(1:n) )
    resmax = max(resmax, temp)
  end do
end if

!  Set VMULTD to the VMULTC vector that would occur if DX became DXNEW. A
!  device is included to force VMULTD(K) = 0.0 if deviations from this value
!  can be attributed to computer rounding errors. First calculate the new
!  Lagrange multipliers.

k = nact
390 zdotw = 0.0d0
zdwabs = 0.0d0
do i=1, n
  temp = z(i, k)*dxnew(i)
  zdotw = zdotw + temp
  zdwabs = zdwabs + abs(temp)
end do
acca = zdwabs + 0.1d0*abs(zdotw)
accb = zdwabs + 0.2d0*abs(zdotw)
if (zdwabs >= acca .or. acca >= accb) zdotw = 0.0d0
vmultd(k) = zdotw / zdota(k)
if (k >= 2) then
  kk = iact(k)
  dxnew(1:n) = dxnew(1:n) - vmultd(k)*a(1:n, kk)
  k = k - 1
  go to 390
end if
if (mcon > m) vmultd(nact) = max(0.0d0, vmultd(nact))

!  Complete VMULTC by finding the new constraint residuals.

dxnew(1:n) = dx(1:n) + step*sdirn(1:n)
if (mcon > nact) then
  kl = nact + 1
  do k=kl, mcon
    kk = iact(k)
    total = resmax - b(kk)
    sumabs = resmax + abs(b(kk))
    do i=1, n
      temp = a(i, kk)*dxnew(i)
      total = total + temp
      sumabs = sumabs + abs(temp)
    end do
    acca = sumabs + 0.1*abs(total)
    accb = sumabs + 0.2*abs(total)
    if (sumabs >= acca .or. acca >= accb) total = 0.0
    vmultd(k) = total
  end do
end if

!  Calculate the fraction of the step from DX to DXNEW that will be taken.

ratio = 1.0d0
icon = 0
do k=1, mcon
  if (vmultd(k) < 0.0d0) then
    temp = vmultc(k)/(vmultc(k) - vmultd(k))
    if (temp < ratio) then
      ratio = temp
      icon = k
    end if
  end if
end do

!  Update DX,  VMULTC and RESMAX.

temp = 1.0d0 - ratio
dx(1:n) = temp*dx(1:n) + ratio*dxnew(1:n)
do k=1, mcon
  vmultc(k) = max(0.0d0, temp*vmultc(k) + ratio*vmultd(k))
end do
if (mcon == m) resmax = resold + ratio*(resmax - resold)

!  if the full step is not acceptable then begin another iteration.
!  Otherwise switch to stage two or end the calculation.

if (icon > 0) go to 70
if (abs(step - stpful) < 1.d-6) go to 500
480 mcon = m + 1
icon = mcon
iact(mcon) = mcon
vmultc(mcon) = 0.0d0
go to 60

!  We employ any freedom that may be available to reduce the objective
!  function before returning a DX whose length is less than RHO.

490 if (mcon == m) go to 480
ifull = 0

500 return
end subroutine trstlp

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

    subroutine getsym (locpar, idepfn, locdep, depmul)
    use molkst_C, only: natoms, ndep, moperr, id
    use chanel_C, only : iw, ir
    use common_arrays_C, only : na
    use molkst_C, only : line
   !
   !.. Implicit Declarations ..
    implicit none
   !
   !.. Formal Arguments ..
    integer, dimension (3*natoms), intent (inout) :: idepfn, locpar
    integer, dimension (3*natoms), intent (inout) :: locdep
    double precision, dimension (natoms), intent (out) :: depmul
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------


!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(100) :: ivalue
      integer :: n, nvalue, i, ll, j, l, nerror, n_used, i_sym(4)
      double precision :: sum
      double precision, dimension(100) :: value
      character , dimension(19) :: texti*60, textx*60
      character, dimension(19,2) :: text*60
      character, dimension(38) :: used*60
      logical :: ok, sym_pdb

      save text, i_sym
!-----------------------------------------------

      equivalence (text(1,1), texti), (text(1,2), textx)
      data i_sym/3, 6, 8, 12/
      data texti/ &
        ' BOND LENGTH    IS SET EQUAL TO THE REFERENCE BOND LENGTH   ', &
        ' BOND ANGLE     IS SET EQUAL TO THE REFERENCE BOND ANGLE    ', &
        ' DIHEDRAL ANGLE IS SET EQUAL TO THE REFERENCE DIHEDRAL ANGLE', &
        ' DIHEDRAL ANGLE VARIES AS  90 DEGREES - REFERENCE DIHEDRAL  ', &
        ' DIHEDRAL ANGLE VARIES AS  90 DEGREES + REFERENCE DIHEDRAL  ', &
        ' DIHEDRAL ANGLE VARIES AS 120 DEGREES - REFERENCE DIHEDRAL  ', &
        ' DIHEDRAL ANGLE VARIES AS 120 DEGREES + REFERENCE DIHEDRAL  ', &
        ' DIHEDRAL ANGLE VARIES AS 180 DEGREES - REFERENCE DIHEDRAL  ', &
        ' DIHEDRAL ANGLE VARIES AS 180 DEGREES + REFERENCE DIHEDRAL  ', &
        ' DIHEDRAL ANGLE VARIES AS 240 DEGREES - REFERENCE DIHEDRAL  ', &
        ' DIHEDRAL ANGLE VARIES AS 240 DEGREES + REFERENCE DIHEDRAL  ', &
        ' DIHEDRAL ANGLE VARIES AS 270 DEGREES - REFERENCE DIHEDRAL  ', &
        ' DIHEDRAL ANGLE VARIES AS 270 DEGREES + REFERENCE DIHEDRAL  ', &
        ' DIHEDRAL ANGLE VARIES AS - REFERENCE DIHEDRAL              ', &
        ' BOND LENGTH VARIES AS HALF THE REFERENCE BOND LENGTH       ', &
        ' BOND ANGLE VARIES AS HALF THE REFERENCE BOND ANGLE         ', &
        ' BOND ANGLE VARIES AS 180 DEGREES - REFERENCE BOND ANGLE    ', &
        ' DO NOT USE - USE SYMMETY FUNCTION 19 INSTEAD               ', &
        ' BOND LENGTH IS A MULTIPLE OF THE REFERENCE BOND LENGTH     '/
      data textx/ &
        ' X COORDINATE IS SET EQUAL TO   THE REFERENCE X COORDINATE  ', &
        ' Y COORDINATE IS SET EQUAL TO   THE REFERENCE Y COORDINATE  ', &
        ' Z COORDINATE IS SET EQUAL TO   THE REFERENCE Z COORDINATE  ', &
        ' X COORDINATE IS SET EQUAL TO - THE REFERENCE X COORDINATE  ', &
        ' Y COORDINATE IS SET EQUAL TO - THE REFERENCE Y COORDINATE  ', &
        ' Z COORDINATE IS SET EQUAL TO - THE REFERENCE Z COORDINATE  ', &
        ' X COORDINATE IS SET EQUAL TO   THE REFERENCE Y COORDINATE  ', &
        ' Y COORDINATE IS SET EQUAL TO   THE REFERENCE Z COORDINATE  ', &
        ' Z COORDINATE IS SET EQUAL TO   THE REFERENCE X COORDINATE  ', &
        ' X COORDINATE IS SET EQUAL TO - THE REFERENCE Y COORDINATE  ', &
        ' Y COORDINATE IS SET EQUAL TO - THE REFERENCE Z COORDINATE  ', &
        ' Z COORDINATE IS SET EQUAL TO - THE REFERENCE X COORDINATE  ', &
        ' X COORDINATE IS SET EQUAL TO   THE REFERENCE Z COORDINATE  ', &
        ' Y COORDINATE IS SET EQUAL TO   THE REFERENCE X COORDINATE  ', &
        ' Z COORDINATE IS SET EQUAL TO   THE REFERENCE Y COORDINATE  ', &
        ' X COORDINATE IS SET EQUAL TO - THE REFERENCE Z COORDINATE  ', &
        ' Y COORDINATE IS SET EQUAL TO - THE REFERENCE X COORDINATE  ', &
        ' Z COORDINATE IS SET EQUAL TO - THE REFERENCE Y COORDINATE  ', &
        ' NOT USED                                                   '/
      n_used = 0
      nerror = 0
      sym_pdb = .false.
!
! TITLE OUTPUT
!
      write (iw, 10)
   10 format(/,/,/,20x,'PARAMETER DEPENDENCE DATA'/,/,&
        '        REFERENCE ATOM      FUNCTION NO.    DEPENDENT ATOM(S)')
!
! INPUT SYMMETRY : FUNCTION, REFERANCE PARAMETER, AND DEPENDENT ATOMS
!
      n = 0
      if (ndep > 0) then
        j = 2
        do i = 1, ndep
          j = j + 1
          ivalue(j) = locdep(i)
          ok = (i == ndep)
          if (.not. ok) ok = (locpar(i) /= locpar(i + 1) .or. idepfn(i) /= idepfn(i + 1))
          if (ok) then
            write (iw, "(i13, i19, i16, 6 i5, 10(/, 43 x, 7 i5))") &
            locpar(i), idepfn(i), (ivalue(l), l=3, j)
            j = 2
          end if
        end do
        goto 90
      end if
      depmul(1) = 0.D0
   20 continue
      read (ir, '(A)', iostat=i, end=90) line
      if (i/=0) then
        return
      endif
      call upcase(line, len_trim(line))
      do
        i =index(line, '"')
        if (i == 0) exit
        call txt_to_atom_no(line, i, .false.)
        call  l_control("CONTROL_SYM_in_PDB", len_trim("CONTROL_SYM_in_PDB"), 1)
        sym_pdb = .true.
        if (moperr) return
      end do
      call nuchar (line, len_trim(line), value, nvalue)
!   INTEGER VALUES
      do i = 1, nvalue
        ivalue(i) = nint(value(i))
      end do
!   FILL THE LOCDEP ARRAY
      if (nvalue==0 .or. Abs(value(3)) < 1.d-20) go to 90
      if (ivalue(2) == 19) then
        if (na(ivalue(1)) == 0) then
            !
            !  Not allowed: a Cartesian coordinate cannot use function 19
            !
          write (iw,*) "Atom ", ivalue (1), " is Cartesian.  " // &
                     & "Function 19 cannot be used here."
          call mopend ("Error in Symmetry Data")
          return
        end if
        do i = 4, nvalue
          if (ivalue(i) == 0) exit
          ndep = ndep + 1
          locdep(ndep) = ivalue(i)
          locpar(ndep) = ivalue(1)
          idepfn(ndep) = 19
          n = n + 1
!
!  Check:  Is multiplier a square root of a rational ratio?
!
          sum = value(3) ** 2
          do ll = 1, 4
            l = i_sym(ll)
            j = Nint (sum*l)
            if (Abs (j-sum*l) < l*1.d-4) then
              value(3) = Sqrt ((1.d0*j)/l)
              exit
            end if
          end do
          depmul(n) = value(3)
        end do
      else
        if (na(ivalue(1)) /= 0 .and. ivalue(2) == 18) then
            !
            !  Not allowed: an internal coordinate cannot use function 18
            !
          write (iw,*) "Atom ", ivalue (1), " is internal.  " // &
                     & "Function 18 cannot be used here."
          call mopend ("Error in Symmetry Data")
          return
        end if
        do i = 3, nvalue
          if (ivalue(i) == 0) exit
          ndep = ndep + 1
          locdep(ndep) = ivalue(i)
          locpar(ndep) = ivalue(1)
          idepfn(ndep) = ivalue(2)
          if (ivalue(i) > natoms + id) then
            nerror = 1
          end if
        end do
      end if
      ll = i - 1
      if (ivalue(2) == 19) then
          write (iw,'(i13, i13, f13.8, i9, 6 i5, 10(/, 43 x, 7 i5))') &
          ivalue(1), ivalue(2), value(3), (ivalue(j), j=4, ll)
      else
        if (sym_pdb) then
          line = " "
          call atom_no_to_txt(ivalue(1), line(9:))
          write(line(len_trim(line) + 1:),'(i13)')ivalue(2)
          call atom_no_to_txt(ivalue(3), line(len_trim(line) + 11:))
          do j = 4, ll
            call atom_no_to_txt(ivalue(j), line(len_trim(line) + 2:))
          end do
          write(iw, '(a)')trim(line)
        else
          write (iw, "(i13, i19, i16, 6 i5, 10(/, 43 x, 7 i5))") ivalue(1), ivalue(2), (ivalue(j), j=3, ll)
        end if
      end if
      if (na(ivalue(1)) == 0) then
        i = 2
      else
        i = 1
      end if
      line = text(ivalue(2), i)
      do i = 1, n_used
        if (used(i) == line) exit
      end do
      if (i > n_used) then
        n_used = n_used + 1
        used(n_used) = line(:len_trim(line))
      end if
      if (nerror == 1) then
        call mopend("A SYMMETRY FUNCTION IS USED TO DEFINE A NON-EXISTENT ATOM")
        return
      end if
    goto 20
!
! CLEAN UP
   90 continue
      write (iw, 100)
  100 format(/,10x,'   DESCRIPTIONS OF THE FUNCTIONS USED')
      do j = 1, 18
        do i = 1, n_used
          if (used(i) == texti(j)) go to 120
        end do
        cycle
  120   continue
         write (iw, 130) j, used(i)
  130   format(i4,5x,a)
      end do
      do j = 1, 18
        do i = 1, n_used
          if (used(i) == textx(j)) go to 121
        end do
        cycle
  121   continue
         write (iw, 130) j, used(i)
      end do
      write(iw,*)
      return
      end subroutine getsym

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  subroutine nxtmer (iatom, nbackb)
    use common_arrays_C, only : nat, ibonds, nbonds
    implicit none
    integer, intent (in) :: iatom
    integer, dimension (4), intent (inout) :: nbackb
!
    integer :: i, ii, iii, j, jatom, jj, jjofco = 0, jofco = 0, k, kk, l, ihcr, ico, ico1
    ico = 0
    ico1 = 0
    ihcr = 0
!
    jatom = nbackb(4)
    do i = 1, nbonds(iatom)
       if (nat(ibonds(i, iatom)) == 6) ihcr = ibonds(i, iatom)
    end do
   !
   !   START WITH NITROGEN
   !
    outer_loop: do i = 1, nbonds(iatom)
      !
      !    IS THERE A CARBON ATTACHED TO THE NITROGEN?
      !
      if (nat(ibonds(i, iatom)) == 6) then
        l = ibonds(i, iatom)
        jj = 0
        jjofco = 0
        do k = 1, nbonds(l)
            !
            !    IS THERE A CARBON ATTACHED TO THE CARBON ATTACHED TO THE NITROGEN?
            !
          if (nat(ibonds(k, l)) == 6) then
            j = ibonds(k, l)
            do ii = 1, nbonds(j)
!
!   IS THERE AN OXYGEN ATOM THAT IS BONDED ONLY TO THE CARBON ATTACHED TO THE
!   CARBON ATTACHED TO THE NITROGEN?
!
              if (nat(ibonds(ii, j)) == 8 .and. nbonds(ibonds(ii, j)) == 1) go to 1000
            end do
            cycle
1000        jofco = ibonds(ii, j)
            ico1 = ico
            ico = j
            iii = ii
            ihcr = l
            do ii = 1, nbonds(j)
                  !
                  !   IS THERE A NITROGEN ATTACHED TO THE
                  !   CARBON ATTACHED TO THE CARBON ATTACHED TO THE NITROGEN?
                  !
              if (nat(ibonds(ii, j)) == 7) go to 1010
            end do
            kk = 0
            do ii = 1, nbonds(j)
                  !
                  !   ARE THERE TWO OXYGEN ATOMS ATTACHED TO THE
                  !   CARBON ATTACHED TO THE CARBON ATTACHED TO THE NITROGEN?
                  !
              if (nat(ibonds(ii, j)) == 8) kk = kk + 1
            end do
            if (kk == 2) then
!
! A -COO group detected
!
              jatom = 0
              exit outer_loop
            end if
               !
               !   NO BOND TO NITROGEN, THEREFORE NOT BACKBONE
               !
            kk = 0
            do ii = 1, nbonds(j)
              if (nat(ibonds(ii, j)) == 6) then
                kk = kk + 1
              end if
            end do
               !
               !  IF THERE IS MORE THAN ONE CARBON ATOM ATTACHED TO THE
               !  SECOND CARBON ATOM THEN IT CANNOT BE A BACKBONE ATOM
               !
            if (kk == 1) then
              jj = j
              jjofco = ibonds(iii, j)
            end if
            cycle
1010        jatom = ibonds(ii, j)
            do ii = 1, nbonds(jatom)
              if (nat(ibonds(ii, jatom)) == 6) exit outer_loop
            end do
          end if
        end do
         !
         !  IN ORDER TO GET HERE, THE BACKBONE HAS NOT BEEN RECOGNIZED,
         !  THEREFORE SET CARBON OF C=O TO JJ
         !
        if (jj /= 0) then
          j = jj
        end if
        if (jjofco /= 0) then
          jofco = jjofco
        end if
      end if
    end do outer_loop
   !
   !    IATOM = STARTING NITROGEN
   !    L     = CARBON OF -(HCR)-
   !    J     = CARBON OF -(C=O)-
   !    JATOM = NITROGEN OF -(C=O)-NH-
   !    JOFCO = OXYGEN OF -(C=O)-
    if (ico1 /= 0) then
!
! Distinguish a terminal threonine with "CO" instead of "COOH"
!
      do i = 1, nbonds(ico1)
        if (ibonds(i,ico1) == jofco) ico = ico1
      end do
    end if
    nbackb(1) = ihcr
    nbackb(2) = ico
    nbackb(3) = jofco
    nbackb(4) = jatom
    return
  end subroutine nxtmer

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      module overlaps_C
      double precision :: &
      cutof1,   &  !  For distances beyond cutof1 overlaps are set to zero
      cutof2       !  For distances beyond cutof2, NDDO is replaced by point-charges
      double precision, dimension(60,6) :: ccc, zzz
      double precision, dimension(6,6,2) :: allc, allz
      integer :: isp, ips
      double precision, dimension(7) :: a, b
      double precision :: sa, sb
      double precision, dimension(0:17) :: fact    ! Factorials:  fact(n) = n!
      data fact/ 1.d0, 1.D0, 2.D0, 6.D0, 24.D0, 120.D0, 720.D0, 5040.D0, 40320.D0, &
        362880.D0, 3628800.D0, 39916800.D0, 479001600.D0, 6227020800.D0, &
        8.71782912D10, 1.307674368D12, 2.092278989D13, 3.556874281D14/
      end module overlaps_C

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine rsp(a, n, nvect, root, vect) 
      USE vast_kind_param, ONLY:  double 
      implicit none
      integer  :: n 
      integer  :: nvect 
      real(double)  :: a(*) 
      real(double), intent (out)  :: root(n) 
      real(double)  :: vect(n,n) 
!
      integer :: i 
!
! Trivial case: n = 1
!
      if (n == 1) then
        root(1) = a(1)
        vect(1,1) = 1.d0
        return
      end if
!
! Perturb secular determinant matrix to split exact degeneracies
! (This is to get around a bug in the diagonalizer that causes eigenvectors to not be orthonormal)
!
      do i = 1, n                                   ! Do NOT go much higher than 1.d-10, otherwise the geometry 
        a((i*(i+1))/2) = a((i*(i+1))/2) + i*1.d-10  ! optimization might go into an endless loop.
      end do
      call evvrsp ((-1), n, nvect, n*n, n, a, root, vect, 0, i)
      return  
      end subroutine rsp 


      subroutine evvrsp(msgfl, n, nvect, lena, nv, a, root, vect, &
        iorder, ierr) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: msgfl 
      integer  :: n 
      integer  :: nvect 
      integer  :: lena 
      integer  :: nv 
      integer , intent(in) :: iorder 
      integer  :: ierr 
      integer  :: ind(n) 
      real(double)  :: a(lena) 
      real(double)  :: b(n,8) 
      real(double)  :: root(n) 
      real(double)  :: vect(nv,*) 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: lmsgfl, i, j, l, jsv, klim, k 
      real(double) :: t 
!-----------------------------------------------
!***********************************************************************
!*       ROUTINE EVVRSP (MSGFL,N,NVECT,LENA,NV,A,B,IND,ROOT,VECT,IORDER
!*   *                 ,IERR)
!*
!*    AUTHOR:  S. T. ELBERT, AMES LABORATORY-USDOE, JUNE 1985
!*
!*    PURPOSE -
!*       FINDS   (ALL) EIGENVALUES    AND    (SOME OR ALL) EIGENVECTORS
!*                     *    *                                   *
!*       OF A REAL SYMMETRIC PACKED MATRIX.
!*            *    *         *
!*
!*    METHOD -
!*       THE METHOD AS PRESENTED IN THIS ROUTINE CONSISTS OF FOUR STEPS:
!*       FIRST, THE INPUT MATRIX IS REDUCED TO TRIDIAGONAL FORM BY THE
!*       HOUSEHOLDER TECHNIQUE (ORTHOGONAL SIMILARITY TRANSFORMATIONS).
!*       SECOND, THE ROOTS ARE LOCATED USING THE RATIONAL QL METHOD.
!*       THIRD, THE VECTORS OF THE TRIDIAGONAL FORM ARE EVALUATED BY THE
!*       INVERSE ITERATION TECHNIQUE.  VECTORS FOR DEGENERATE OR NEAR-
!*       DEGENERATE ROOTS ARE FORCED TO BE ORTHOGONAL.
!*       FOURTH, THE TRIDIAGONAL VECTORS ARE ROTATED TO VECTORS OF THE
!*       ORIGINAL ARRAY.
!*
!*       THESE ROUTINES ARE MODIFICATIONS OF THE EISPACK 3
!*       ROUTINES TRED3, TQLRAT, TINVIT AND TRBAK3
!*
!*       FOR FURTHER DETAILS, SEE EISPACK USERS GUIDE, B. T. SMITH
!*       ET AL, SPRINGER-VERLAG, LECTURE NOTES IN COMPUTER SCIENCE,
!*       VOL. 6, 2-ND EDITION, 1976.  ANOTHER GOOD REFERENCE IS
!*       THE SYMMETRIC EIGENVALUE PROBLEM BY B. N. PARLETT
!*       PUBLISHED BY PRENTICE-HALL, INC., ENGLEWOOD CLIFFS, N.J. (1980)
!*
!*    ON ENTRY -
!*       MSGFL  - INTEGER (LOGICAL UNIT NO.)
!*                FILE WHERE ERROR MESSAGES WILL BE PRINTED.
!*                IF MSGFL IS 0, ERROR MESSAGES WILL BE PRINTED ON LU 6.
!*                IF MSGFL IS NEGATIVE, NO ERROR MESSAGES PRINTED.
!*       N      - INTEGER
!*                ORDER OF MATRIX A.
!*       NVECT  - INTEGER
!*                NUMBER OF VECTORS DESIRED.  0 .LE. NVECT .LE. N.
!*       LENA   - INTEGER
!*                DIMENSION OF  A  IN CALLING ROUTINE.  MUST NOT BE LESS
!*                THAN (N*N+N)/2.
!*       NV     - INTEGER
!*                ROW DIMENSION OF VECT IN CALLING ROUTINE.   N .LE. NV.
!*       A      - WORKING PRECISION REAL (LENA)
!*                INPUT MATRIX, ROWS OF THE LOWER TRIANGLE PACKED INTO
!*                LINEAR ARRAY OF DIMENSION N*(N+1)/2.  THE PACKED ORDER
!*                IS A(1,1), A(2,1), A(2,2), A(3,1), A(3,2), ...
!*       B      - WORKING PRECISION REAL (N,8)
!*                SCRATCH ARRAY, 8*N ELEMENTS
!*       IND    - INTEGER (N)
!*                SCRATCH ARRAY OF LENGTH N.
!*       IORDER - INTEGER
!*                ROOT ORDERING FLAG.
!*                = 0, ROOTS WILL BE PUT IN ASCENDING ORDER.
!*                = 2, ROOTS WILL BE PUT IN DESCENDING ORDER.
!*
!*    ON EXIT -
!*       A      - DESTORYED.  NOW HOLDS REFLECTION OPERATORS.
!*       ROOT   - WORKING PRECISION REAL (N)
!*                ALL EIGENVALUES IN ASCENDING OR DESCENDING ORDER.
!*                  IF IORDER = 0, ROOT(1) .LE. ... .LE. ROOT(N)
!*                  IF IORDER = 2, ROOT(1) .GE. ... .GE. ROOT(N)
!*       VECT   - WORKING PRECISION REAL (NV,NVECT)
!*                EIGENVECTORS FOR ROOT(1), ..., ROOT(NVECT).
!*       IERR   - INTEGER
!*                = 0 IF NO ERROR DETECTED,
!*                = K IF ITERATION FOR K-TH EIGENVALUE FAILED,
!*                = -K IF ITERATION FOR K-TH EIGENVECTOR FAILED.
!*                (FAILURES SHOULD BE VERY RARE.  CONTACT C. MOLER.)
!*
!*    EXTERNAL ROUTINES -
!*       ETRED3(ELAU, FREDA, DASUM, DNRM2, DSCAL)
!*       EQLRAT(EPSLON)
!*       EINVIT(EPSLON, ESTPI1, DASUM, DAXPY, DDOT, DNRM2, DSCAL)
!*       ETRBK3(DDOT, DAXPY)
!*
!***********************************************************************
!
!                              DECLARATIONS
!
!
!
!
!
      lmsgfl = msgfl 
      if (msgfl == 0) lmsgfl = 6 
      ierr = n - 1 
      if (n <= 0) go to 150 
      ierr = n + 1 
      if ((n*n + n)/2 > lena) go to 160 
!
!        REDUCE REAL SYMMETRIC MATRIX A TO TRIDIAGONAL FORM
!
      call etred3 (n, a, b(1,1), b(1,2), b(1,3)) 
!
!        FIND ALL EIGENVALUES OF TRIDIAGONAL MATRIX
!
      call eqlrat (n, b(1,1), b(1,2), b(1,3), root, ind, ierr, b(1,4)) 
      if (ierr /= 0) go to 170 
!
!         CHECK THE DESIRED ORDER OF THE EIGENVALUES
!
      b(1,3) = dble(iorder) 
      if (iorder /= 0) then 
        if (iorder /= 2) go to 200 
!
!         ORDER ROOTS IN DESCENDING ORDER (LARGEST FIRST)...
!        TURN ROOT AND IND ARRAYS END FOR END
!
        do i = 1, n/2 
          j = n + 1 - i 
          t = root(i) 
          root(i) = root(j) 
          root(j) = t 
          l = ind(i) 
          ind(i) = ind(j) 
          ind(j) = l 
        end do 
!
!           FIND I AND J MARKING THE START AND END OF A SEQUENCE
!           OF DEGENERATE ROOTS
!
        i = 0 
   90   continue 
        i = i + 1 
        if (i > n) go to 130 
        do j = i, n 
          if (Abs(root(j) - root(i)) > 1.d-20) go to 110 
        end do 
        j = n + 1 
  110   continue 
        j = j - 1 
        if (j == i) go to 90 
!
!                    TURN AROUND IND BETWEEN I AND J
!
        jsv = j 
        klim = (j - i + 1)/2 
        do k = 1, klim 
          l = ind(j) 
          ind(j) = ind(i) 
          ind(i) = l 
          i = i + 1 
          j = j - 1 
        end do 
        i = jsv 
        go to 90 
!
      endif 
  130 continue 
      if (nvect <= 0) return  
      if (nv < n) go to 180 
!
!        FIND EIGENVECTORS OF TRI-DIAGONAL MATRIX VIA INVERSE ITERATION
!
      ierr = lmsgfl 
      call einvit (nv, n, b(1,1), b(1,2), b(1,3), nvect, root, ind, vect, ierr&
        , b(1,4), b(1,5), b(1,6), b(1,7), b(1,8)) 
      if (ierr /= 0) go to 190 
!
!        FIND EIGENVECTORS OF SYMMETRIC MATRIX VIA BACK TRANSFORMATION
!
  140 continue 
      call etrbk3 (nv, n, lena, a, nvect, vect) 
      return  
!
!        ERROR MESSAGE SECTION
!
  150 continue 
      if (lmsgfl < 0) return  
      go to 210 
!
  160 continue 
      if (lmsgfl < 0) return  
      go to 210 
!
  170 continue 
      if (lmsgfl < 0) return  
      go to 210 
!
  180 continue 
      if (lmsgfl < 0) return  
      go to 210 
!
  190 continue 
      go to 140 
!
  200 continue 
      ierr = -1 
      if (lmsgfl < 0) return  
!
  210 continue 
      return  
      end subroutine evvrsp 


      subroutine freda(l, d, a, e) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  11:05:01  03/09/06  
!...Switches: -rl INDDO=2 INDIF=2 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: l 
      real(double) , intent(in) :: d(l) 
      real(double) , intent(inout) :: a(*) 
      real(double) , intent(in) :: e(l) 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: jk, j
      real(double) :: f, g 
!-----------------------------------------------
!
!
      jk = 1 
!
!     .......... FORM REDUCED A ..........
!
      do j = 1, l 
        f = d(j) 
        g = e(j) 
!
        if (j > 0) then 
          a(jk:j-1+jk) = a(jk:j-1+jk) - f*e(:j) - g*d(:j) 
          jk = j + jk 
        endif 
!
      end do 
      return  
      end subroutine freda 


!***********************************************************************
!*       ROUTINE EINVIT(NM,N,D,E,E2,M,W,IND,Z,IERR,RV1,RV2,RV3,RV4,RV6)
!*
!*    AUTHORS-
!*       THIS IS A MODIFICATION OF ROUTINE TINVIT FROM EISPACK EDITION 3
!*       DATED AUGUST 1983.
!*       TINVIT IS A TRANSLATION OF THE INVERSE ITERATION TECHNIQUE
!*       IN THE ALGOL PROCEDURE TRISTURM BY PETERS AND WILKINSON.
!*       HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 418-439(1971).
!*       THIS VERSION IS BY S. T. ELBERT (AMES LABORATORY-USDOE)
!*
!*    PURPOSE -
!*       THIS ROUTINE FINDS THOSE EIGENVECTORS OF A TRIDIAGONAL
!*       SYMMETRIC MATRIX CORRESPONDING TO SPECIFIED EIGENVALUES.
!*
!*    METHOD -
!*       INVERSE ITERATION.
!*
!*    ON ENTRY -
!*       NM     - INTEGER
!*                MUST BE SET TO THE ROW DIMENSION OF TWO-DIMENSIONAL
!*                ARRAY PARAMETERS AS DECLARED IN THE CALLING ROUTINE
!*                DIMENSION STATEMENT.
!*       N      - INTEGER
!*       D      - W.P. REAL (N)
!*                CONTAINS THE DIAGONAL ELEMENTS OF THE INPUT MATRIX.
!*       E      - W.P. REAL (N)
!*                CONTAINS THE SUBDIAGONAL ELEMENTS OF THE INPUT MATRIX
!*                IN ITS LAST N-1 POSITIONS.  E(1) IS ARBITRARY.
!*       E2     - W.P. REAL (N)
!*                CONTAINS THE SQUARES OF CORRESPONDING ELEMENTS OF E,
!*                WITH ZEROS CORRESPONDING TO NEGLIGIBLE ELEMENTS OF E.
!*                E(I) IS CONSIDERED NEGLIGIBLE IF IT IS NOT LARGER THAN
!*                THE PRODUCT OF THE RELATIVE MACHINE PRECISION AND THE
!*                SUM OF THE MAGNITUDES OF D(I) AND D(I-1).  E2(1) MUST
!*                CONTAIN 0.0 IF THE EIGENVALUES ARE IN ASCENDING ORDER,
!*                OR 2.0 IF THE EIGENVALUES ARE IN DESCENDING ORDER.
!*                IF TQLRAT, BISECT, TRIDIB, OR IMTQLV
!*                HAS BEEN USED TO FIND THE EIGENVALUES, THEIR
!*                OUTPUT E2 ARRAY IS EXACTLY WHAT IS EXPECTED HERE.
!*       M      - INTEGER
!*                THE NUMBER OF SPECIFIED EIGENVECTORS.
!*       W      - W.P. REAL (M)
!*                CONTAINS THE M EIGENVALUES IN ASCENDING
!*                OR DESCENDING ORDER.
!*       IND    - INTEGER (M)
!*                CONTAINS IN FIRST M POSITIONS THE SUBMATRIX INDICES
!*                ASSOCIATED WITH THE CORRESPONDING EIGENVALUES IN W --
!*                1 FOR EIGENVALUES BELONGING TO THE FIRST SUBMATRIX
!*                FROM THE TOP, 2 FOR THOSE BELONGING TO THE SECOND
!*                SUBMATRIX, ETC.
!*       IERR   - INTEGER (LOGICAL UNIT NUMBER)
!*                LOGICAL UNIT FOR ERROR MESSAGES
!*
!*    ON EXIT -
!*       ALL INPUT ARRAYS ARE UNALTERED.
!*       Z      - W.P. REAL (NM,M)
!*                CONTAINS THE ASSOCIATED SET OF ORTHONORMAL
!*                EIGENVECTORS. ANY VECTOR WHICH WHICH FAILS TO CONVERGE
!*                IS LEFT AS IS (BUT NORMALIZED) WHEN ITERATING STOPPED.
!*       IERR   - INTEGER
!*                SET TO
!*                ZERO    FOR NORMAL RETURN,
!*                -R      IF THE EIGENVECTOR CORRESPONDING TO THE R-TH
!*                        EIGENVALUE FAILS TO CONVERGE IN 5 ITERATIONS.
!*                        (ONLY LAST FAILURE TO CONVERGE IS REPORTED)
!*
!*       RV1, RV2, RV3, RV4, AND RV6 ARE TEMPORARY STORAGE ARRAYS.
!*
!*       RV1    - W.P. REAL (N)
!*                DIAGONAL ELEMENTS OF U FROM LU DECOMPOSITION
!*       RV2    - W.P. REAL (N)
!*                SUPER(1)-DIAGONAL ELEMENTS OF U FROM LU DECOMPOSITION
!*       RV3    - W.P. REAL (N)
!*                SUPER(2)-DIAGONAL ELEMENTS OF U FROM LU DECOMPOSITION
!*       RV4    - W.P. REAL (N)
!*                ELEMENTS DEFINING L IN LU DECOMPOSITION
!*       RV6    - W.P. REAL (N)
!*                APPROXIMATE EIGENVECTOR
!*
!*    DIFFERENCES FROM EISPACK 3 -
!*       EPS3 IS SCALED BY  EPSCAL  (ENHANCES CONVERGENCE, BUT
!*          LOWERS ACCURACY)!
!*       ONE MORE ITERATION (MINIMUM 2) IS PERFORMED AFTER CONVERGENCE
!*          (ENHANCES ACCURACY)!
!*       REPLACE LOOP WITH PYTHAG WITH SINGLE CALL TO DNRM2!
!*       IF NOT CONVERGED, USE PERFORMANCE INDEX TO DECIDE ON ERROR
!*          VALUE SETTING, BUT DO NOT STOP!
!*       L.U. FOR ERROR MESSAGES PASSED THROUGH IERR
!*       USE PARAMETER STATEMENTS AND GENERIC INTRINSIC FUNCTIONS
!*       USE LEVEL 1 BLAS
!*       USE IF-THEN-ELSE TO CLARIFY LOGIC
!*       LOOP OVER SUBSPACES MADE INTO DO LOOP.
!*       LOOP OVER INVERSE ITERATIONS MADE INTO DO LOOP
!*       ZERO ONLY REQUIRED PORTIONS OF OUTPUT VECTOR
!*
!*    EXTERNAL ROUTINES -
!*       EPSLON
!*       BLAS(1)--DASUM, DAXPY, DDOT, DNRM2, DSCAL
!*       INTRINSIC FUNCTIONS - ABS, MAX, SQRT
!*
!*    NOTE -
!*       QUESTIONS AND COMMENTS CONCERNING EISPACK SHOULD BE DIRECTED TO
!*       B. S. GARBOW, APPLIED MATH. DIVISION, ARGONNE NATIONAL LAB.
!*
!***********************************************************************
      subroutine einvit(nm, n, d, e, e2, m, w, ind, z, ierr, rv1, rv2, rv3, rv4&
        , rv6) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: nm 
      integer , intent(in) :: n 
      integer , intent(in) :: m 
      integer , intent(out) :: ierr 
      integer , intent(in) :: ind(m) 
      real(double)  :: d(n) 
      real(double)  :: e(n + 1) 
      real(double) , intent(in) :: e2(n) 
      real(double) , intent(in) :: w(m) 
      real(double)  :: z(nm,m) 
      real(double) , intent(inout) :: rv1(n) 
      real(double) , intent(inout) :: rv2(n) 
      real(double) , intent(inout) :: rv3(n) 
      real(double) , intent(inout) :: rv4(n) 
      real(double)  :: rv6(n) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      real(double), parameter :: epscal = 0.5D+00 
      real(double), parameter :: grptol = 0.001D+00 
      real(double), parameter :: hundrd = 100.0D+00 
      real(double), parameter :: one = 1.0D+00 
      real(double), parameter :: zero = 0.0D+00 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: group, i, its, j, jj, p, q, r, s, submat, tag 
      real(double) :: anorm, eps2, eps3, eps4, norm, order, rho, u, uk, v, x0, &
        x1, xu 
      double precision, external :: ddot, epslon, dasum, dnrm2, estpi1
      logical :: convgd 
!-----------------------------------------------
!
!                        DECLARATIONS
!
!-----------------------------------------------------------------------
!
      ierr = 0 
      x0 = zero 
      uk = zero 
      norm = zero 
      eps2 = zero 
      eps3 = zero 
      eps4 = zero 
      group = 0 
      tag = 0 
      order = one - e2(1) 
      q = 0 
      do submat = 1, n 
        p = q + 1 
!
!        .......... ESTABLISH AND PROCESS NEXT SUBMATRIX ..........
!
        do q = p, n - 1 
          if (e2(q+1) == zero) go to 30 
        end do 
        q = n 
!
!        .......... FIND VECTORS BY INVERSE ITERATION ..........
!
   30   continue 
        tag = tag + 1 
        anorm = zero 
        s = 0 
!
        do r = 1, m 
          if (ind(r) /= tag) cycle  
          its = 1 
          x1 = w(r) 
          if (s == 0) then 
!
!        .......... CHECK FOR ISOLATED ROOT ..........
!
            xu = one 
            if (p == q) then 
              rv6(p) = one 
              convgd = .TRUE. 
              go to 160 
!
            endif 
            norm = abs(d(p)) 
            do i = p + 1, q 
              norm = max(norm,abs(d(i))+abs(e(i))) 
            end do 
!
!        .......... EPS2 IS THE CRITERION FOR GROUPING,
!                   EPS3 REPLACES ZERO PIVOTS AND EQUAL
!                   ROOTS ARE MODIFIED BY EPS3,
!                   EPS4 IS TAKEN VERY SMALL TO AVOID OVERFLOW .........
!
            eps2 = grptol*norm 
            eps3 = epscal*epslon(norm) 
            uk = q - p + 1 
            eps4 = uk*eps3 
            uk = eps4/sqrt(uk) 
            s = p 
            group = 0 
          else 
!
!        .......... LOOK FOR CLOSE OR COINCIDENT ROOTS ..........
!
            if (abs(x1 - x0) >= eps2) then 
!
!                 ROOTS ARE SEPERATE
!
              group = 0 
            else 
!
!                 ROOTS ARE CLOSE
!
              group = group + 1 
              if (order*(x1 - x0) <= eps3) x1 = x0 + order*eps3 
            endif 
!
!        .......... ELIMINATION WITH INTERCHANGES AND
!                   INITIALIZATION OF VECTOR ..........
!
          endif 
!
          u = d(p) - x1 
          v = e(p+1) 
          rv6(p) = uk 
          do i = p + 1, q 
            rv6(i) = uk 
            if (abs(e(i)) > abs(u)) then 
!
!                 EXCHANGE ROWS BEFORE ELIMINATION
!
!                  *** WARNING -- A DIVIDE CHECK MAY OCCUR HERE IF
!                      E2 ARRAY HAS NOT BEEN SPECIFIED CORRECTLY .......
!
              xu = u/e(i) 
              rv4(i) = xu 
              rv1(i-1) = e(i) 
              rv2(i-1) = d(i) - x1 
              rv3(i-1) = e(i+1) 
              u = v - xu*rv2(i-1) 
              v = -xu*rv3(i-1) 
!
            else 
!
!                    STRAIGHT ELIMINATION
!
              xu = e(i)/u 
              rv4(i) = xu 
              rv1(i-1) = u 
              rv2(i-1) = v 
              rv3(i-1) = zero 
              u = d(i) - x1 - xu*v 
              v = e(i+1) 
            endif 
          end do 
!
          if (abs(u) <= eps3) u = eps3 
          rv1(q) = u 
          rv2(q) = zero 
          rv3(q) = zero 
!
!              DO INVERSE ITERATIONS
!
          convgd = .FALSE. 
          do its = 1, 5 
            if (its /= 1) then 
!
!                    .......... FORWARD SUBSTITUTION ..........
!
              if (norm == zero) then 
                rv6(s) = eps4 
                s = s + 1 
                if (s > q) s = p 
              else 
                xu = eps4/norm 
                call dscal (q - p + 1, xu, rv6(p), 1) 
              endif 
!
!                     ... ELIMINATION OPERATIONS ON NEXT VECTOR
!
              do i = p + 1, q 
                u = rv6(i) 
!
!                         IF RV1(I-1) .EQ. E(I), A ROW INTERCHANGE
!                         WAS PERFORMED EARLIER IN THE
!                         TRIANGULARIZATION PROCESS ..........
!
                if (Abs(rv1(i-1) - e(i)) < 1.d-20) then 
                  u = rv6(i-1) 
                  rv6(i-1) = rv6(i) 
                else 
                  u = rv6(i) 
                endif 
                rv6(i) = u - rv4(i)*rv6(i-1) 
              end do 
            endif 
!
!           .......... BACK SUBSTITUTION
!
            rv6(q) = rv6(q)/rv1(q) 
            v = u 
            u = rv6(q) 
            norm = abs(u) 
            do i = q - 1, p, -1 
              rv6(i) = (rv6(i)-u*rv2(i)-v*rv3(i))/rv1(i) 
              v = u 
              u = rv6(i) 
              norm = norm + abs(u) 
            end do 
            if (group /= 0) then 
!
!                 ....... ORTHOGONALIZE WITH RESPECT TO PREVIOUS
!                         MEMBERS OF GROUP ..........
!
              j = r 
              do jj = 1, group 
                j = j - 1 
                do while(ind(j) /= tag) 
                  j = j - 1 
                end do 
                call daxpy (q - p + 1, (-ddot(q - p + 1,rv6(p),1,z(p,j),1)),z(p&
                  ,j), 1, rv6(p), 1) 
              end do 
              norm = dasum(q - p + 1,rv6(p),1) 
            endif 
!
            if (convgd) exit  
            if (norm < one) cycle  
            convgd = .TRUE. 
          end do 
!
          xu = one/dnrm2(q - p + 1,rv6(p)) 
!
  160     continue 
          z(:p-1,r) = zero 
          z(p:q,r) = rv6(p:q)*xu 
          z(q+1:n,r) = zero 
!
          if (.not.convgd) then 
            rho = estpi1(q - p + 1,x1,d(p),e(p),z(p,r),anorm) 
!
!               *** SET ERROR -- NON-CONVERGED EIGENVECTOR ..........
!
            if (rho > hundrd) ierr = -r 
          endif 
!
          x0 = x1 
        end do 
!
        if (q /= n) cycle  
        exit  
      end do 
      return  
      end subroutine einvit 


      subroutine elau(hinv, l, d, a, e) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  11:05:01  03/09/06  
!...Switches: -rl INDDO=2 INDIF=2 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: l 
      real(double) , intent(in) :: hinv 
      real(double) , intent(in) :: d(l) 
      real(double) , intent(in) :: a(*) 
      real(double) , intent(inout) :: e(l) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      real(double), parameter :: half = 0.5D+00 
      real(double), parameter :: zero = 0.0D+00 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: jl, jk, j, jm1
      real(double) :: f, g, hh 
!-----------------------------------------------
!
!
!
      jl = l 
      e(1) = a(1)*d(1) 
      jk = 2 
      do j = 2, jl 
        f = d(j) 
        g = zero 
        jm1 = j - 1 
!
        if (jm1 > 0) then 
          g = g + sum(a(jk:jm1-1+jk)*d(:jm1)) 
          e(:jm1) = e(:jm1) + a(jk:jm1-1+jk)*f 
          jk = jm1 + jk 
        endif 
!
        e(j) = g + a(jk)*f 
        jk = jk + 1 
      end do 
!
!        .......... FORM P ..........
!
      f = zero 
      e = e*hinv 
      f = f + dot_product(e,d) 
!
!     .......... FORM Q ..........
!
      hh = f*half*hinv 
      e = e - hh*d 
!
      return  
      end subroutine elau 


!*MODULE EIGEN   *DECK EPSLON
!***********************************************************************
!*    FUNCT. ROUTINE EPSLON (X)
!*
!*    AUTHORS -
!*       THIS ROUTINE WAS TAKEN FROM EISPACK EDITION 3 DATED 4/6/83
!*       THIS VERSION IS BY S. T. ELBERT, AMES LABORATORY-USDOE NOV 1986
!*
!*    PURPOSE -
!*       ESTIMATE UNIT ROUNDOFF IN QUANTITIES OF SIZE X.
!*
!*    ON ENTRY -
!*       X      - WORKING PRECISION REAL
!*                VALUES TO FIND EPSLON FOR
!*
!*    ON EXIT -
!*       EPSLON - WORKING PRECISION REAL
!*                SMALLEST POSITIVE VALUE SUCH THAT X+EPSLON .NE. ZERO
!*
!*    QUALIFICATIONS -
!*       THIS ROUTINE SHOULD PERFORM PROPERLY ON ALL SYSTEMS
!*       SATISFYING THE FOLLOWING TWO ASSUMPTIONS,
!*          1.  THE BASE USED IN REPRESENTING FLOATING POINT
!*              NUMBERS IS NOT A POWER OF THREE.
!*          2.  THE QUANTITY  A  IN STATEMENT 10 IS REPRESENTED TO
!*              THE ACCURACY USED IN FLOATING POINT VARIABLES
!*              THAT ARE STORED IN MEMORY.
!*       THE STATEMENT NUMBER 10 AND THE GO TO 10 ARE INTENDED TO
!*       FORCE OPTIMIZING COMPILERS TO GENERATE CODE SATISFYING
!*       ASSUMPTION 2.
!*       UNDER THESE ASSUMPTIONS, IT SHOULD BE TRUE THAT,
!*              A  IS NOT EXACTLY EQUAL TO FOUR-THIRDS,
!*              B  HAS A ZERO FOR ITS LAST BIT OR DIGIT,
!*              C  IS NOT EXACTLY EQUAL TO ONE,
!*              EPS  MEASURES THE SEPARATION OF 1.0 FROM
!*                   THE NEXT LARGER FLOATING POINT NUMBER.
!*       THE DEVELOPERS OF EISPACK WOULD APPRECIATE BEING INFORMED
!*       ABOUT ANY SYSTEMS WHERE THESE ASSUMPTIONS DO NOT HOLD.
!*
!*    DIFFERENCES FROM EISPACK 3 -
!*       USE IS MADE OF PARAMETER STATEMENTS AND INTRINSIC FUNCTIONS
!*       --NO EXECUTEABLE CODE CHANGES--
!*
!*    EXTERNAL ROUTINES - NONE
!*    INTRINSIC FUNCTIONS - ABS
!*
!*    NOTE -
!*       QUESTIONS AND COMMENTS CONCERNING EISPACK SHOULD BE DIRECTED TO
!*       B. S. GARBOW, APPLIED MATH. DIVISION, ARGONNE NATIONAL LAB.
!*
!***********************************************************************
      real(kind(0.0d0)) function epslon (x) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  11:05:01  03/09/06  
!...Switches: -rl INDDO=2 INDIF=2 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      real(double) , intent(in) :: x 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      real(double), parameter :: zero = 0.0D+00 
      real(double), parameter :: one = 1.0D+00 
      real(double), parameter :: three = 3.0D+00 
      real(double), parameter :: four = 4.0D+00 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      real(double) :: a, b, c, eps 
!-----------------------------------------------
!
!                    DECLARATIONS
!
!
!
!-----------------------------------------------------------------------
!
      a = four/three 
      b = a - one 
      c = b + b + b 
      eps = abs(c - one) 
      do while(eps == zero) 
        b = a - one 
        c = b + b + b 
        eps = abs(c - one) 
      end do 
      epslon = eps*abs(x) 
      return  
      end function epslon 


!***********************************************************************
!*       ROUTINE EQLRAT(N,DIAG,E,E2IN,D,IND,IERR,E2)
!*
!*    AUTHORS -
!*       THIS IS A MODIFICATION OF ROUTINE EQLRAT FROM EISPACK EDITION 3
!*       DATED AUGUST 1983.
!*       TQLRAT IS A TRANSLATION OF THE ALGOL PROCEDURE TQLRAT,
!*       ALGORITHM 464, COMM. ACM 16, 689(1973) BY REINSCH.
!*       THIS VERSION IS BY S. T. ELBERT (AMES LABORATORY-USDOE)
!*
!*    PURPOSE -
!*       THIS ROUTINE FINDS THE EIGENVALUES OF A SYMMETRIC
!*       TRIDIAGONAL MATRIX
!*
!*    METHOD -
!*       RATIONAL QL
!*
!*    ON ENTRY -
!*       N      - INTEGER
!*                THE ORDER OF THE MATRIX.
!*       D      - W.P. REAL (N)
!*                CONTAINS THE DIAGONAL ELEMENTS OF THE INPUT MATRIX.
!*       E2     - W.P. REAL (N)
!*                CONTAINS THE SQUARES OF THE SUBDIAGONAL ELEMENTS OF
!*                THE INPUT MATRIX IN ITS LAST N-1 POSITIONS.
!*                E2(1) IS ARBITRARY.
!*
!*     ON EXIT -
!*       D      - W.P. REAL (N)
!*                CONTAINS THE EIGENVALUES IN ASCENDING ORDER.  IF AN
!*                ERROR EXIT IS MADE, THE EIGENVALUES ARE CORRECT AND
!*                ORDERED FOR INDICES 1,2,...IERR-1, BUT MAY NOT BE
!*                THE SMALLEST EIGENVALUES.
!*       E2     - W.P. REAL (N)
!*                DESTROYED.
!*       IERR   - INTEGER
!*                SET TO
!*                ZERO       FOR NORMAL RETURN,
!*                J          IF THE J-TH EIGENVALUE HAS NOT BEEN
!*                           DETERMINED AFTER 30 ITERATIONS.
!*
!*    DIFFERENCES FROM EISPACK 3 -
!*       G=G+B INSTEAD OF IF(G.EQ.0) G=B ; B=B/4
!*       F77 BACKWARD LOOPS INSTEAD OF F66 CONSTRUCT
!*       GENERIC INTRINSIC FUNCTIONS
!*       ARRARY  IND  ADDED FOR USE BY EINVIT
!*
!*    EXTERNAL ROUTINES -
!*       EPSLON
!*       INTRINSIC--ABS, SIGN, SQRT
!*
!*    NOTE -
!*       QUESTIONS AND COMMENTS CONCERNING EISPACK SHOULD BE DIRECTED TO
!*       B. S. GARBOW, APPLIED MATH. DIVISION, ARGONNE NATIONAL LAB.
!*
!***********************************************************************
      subroutine eqlrat(n, diag, e, e2in, d, ind, ierr, e2) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n 
      integer , intent(out) :: ierr 
      integer , intent(out) :: ind(n) 
      real(double) , intent(in) :: diag(n) 
      real(double) , intent(in) :: e(n) 
      real(double) , intent(inout) :: e2in(n) 
      real(double) , intent(inout) :: d(n) 
      real(double) , intent(inout) :: e2(n) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      real(double), parameter :: scale = 1.0D+00/64.0D+00 
      real(double), parameter :: zero = 0.0D+00 
      real(double), parameter :: one = 1.0D+00 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j, l, m, l1, k, itag 
      real(double) :: b, c, f, g, h, p, r, s, t 
      double precision, external :: epslon
!-----------------------------------------------
!
!
!
!
!-----------------------------------------------------------------------
      ierr = 0 
      d(1) = diag(1) 
      ind(1) = 1 
      k = 0 
      itag = 0 
      if (n /= 1) then 
!
        d(2:n) = diag(2:n) 
        e2(:n-1) = e2in(2:n) 
!
        f = zero 
        t = zero 
        b = epslon(one) 
        c = b*b 
        b = b*scale 
        e2(n) = zero 
!
        do l = 1, n 
          h = abs(d(l)) + abs(e(l)) 
          if (t < h) then 
            t = h 
            b = epslon(t) 
            c = b*b 
            b = b*scale 
          endif 
!     .......... LOOK FOR SMALL SQUARED SUB-DIAGONAL ELEMENT ..........
          m = l - 1 
          m = m + 1 
          do while(e2(m) > c) 
            m = m + 1 
          end do 
!     .......... E2(N) IS ALWAYS ZERO, SO THERE IS AN EXIT
!                FROM THE LOOP ..........
!
          if (m > k) then 
            if (m /= n) e2in(m+1) = zero 
            k = m 
            itag = itag + 1 
          endif 
          if (m == l) go to 80 
!
!           ITERATE
!
          do j = 1, 30 
!              .......... FORM SHIFT ..........
            l1 = l + 1 
            s = sqrt(e2(l)) 
            g = d(l) 
            p = (d(l1)-g)/(2.0D+00*s) 
            r = sqrt(p*p + 1.0D+00) 
            d(l) = s/(p + sign(r,p)) 
            h = g - d(l) 
!
            d(l1:n) = d(l1:n) - h 
!
            f = f + h 
!              .......... RATIONAL QL TRANSFORMATION ..........
            g = d(m) + b 
            h = g 
            s = zero 
            do i = m - 1, l, -1 
              p = g*h 
              r = p + e2(i) 
              e2(i+1) = s*r 
              s = e2(i)/r 
              d(i+1) = h + s*(h + d(i)) 
              g = d(i) - e2(i)/g + b 
              h = g*p/r 
              if (h == zero) then
              e2(l) = s * g
              d(l) = zero
              go to 80
            end if
            end do 
!
            e2(l) = s*g 
            d(l) = h 
!              .......... GUARD AGAINST UNDERFLOW IN CONVERGENCE TEST
            if (h == zero) go to 80 
            if (abs(e2(l)) <= abs(c/h)) go to 80 
            e2(l) = h*e2(l) 
            if (e2(l) == zero) go to 80 
          end do 
!     .......... SET ERROR -- NO CONVERGENCE TO AN
!                EIGENVALUE AFTER 30 ITERATIONS ..........
          ierr = l 
          exit  
!
!           CONVERGED
!
   80     continue 
          p = d(l) + f 
!           .......... ORDER EIGENVALUES ..........
          i = 1 
          if (l /= 1) then 
            if (p < d(1)) go to 100 
            i = l 
!           .......... LOOP TO FIND ORDERED POSITION
            i = i - 1 
            do while(p < d(i)) 
              i = i - 1 
            end do 
!
            i = i + 1 
            if (i == l) go to 120 
  100       continue 
            d(l:1+i:(-1)) = d(l-1:i:(-1)) 
            ind(l:1+i:(-1)) = ind(l-1:i:(-1)) 
!
          endif 
  120     continue 
          d(i) = p 
          ind(i) = itag 
        end do 
!
      endif 
      return  
      end subroutine eqlrat 


!*MODULE EIGEN   *DECK ETRBK3
!***********************************************************************
!*       ROUTINE ETRBK3(NM,N,NV,A,M,Z)
!*
!*    AUTHORS-
!*       THIS IS A MODIFICATION OF ROUTINE TRBAK3 FROM EISPACK EDITION 3
!*       DATED AUGUST 1983.
!*       EISPACK TRBAK3 IS A TRANSLATION OF THE ALGOL PROCEDURE TRBAK3,
!*       NUM. MATH. 11, 181-195(1968) BY MARTIN, REINSCH, AND WILKINSON.
!*       HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 212-226(1971).
!*       THIS VERSION IS BY S. T. ELBERT (AMES LABORATORY-USDOE)
!*
!*    PURPOSE -
!*       THIS ROUTINE FORMS THE EIGENVECTORS OF A REAL SYMMETRIC
!*       MATRIX BY BACK TRANSFORMING THOSE OF THE CORRESPONDING
!*       SYMMETRIC TRIDIAGONAL MATRIX DETERMINED BY  ETRED3.
!*
!*    METHOD -
!*       THE CALCULATION IS CARRIED OUT BY FORMING THE MATRIX PRODUCT
!*          Q*Z
!*       WHERE  Q  IS A PRODUCT OF THE ORTHOGONAL SYMMETRIC MATRICES
!*                Q = PROD(I)[1 - U(I)*.TRANSPOSE.U(I)*H(I)]
!*       U  IS THE AUGMENTED SUB-DIAGONAL ROWS OF  A  AND
!*       Z  IS THE SET OF EIGENVECTORS OF THE TRIDIAGONAL
!*       MATRIX  F  WHICH WAS FORMED FROM THE ORIGINAL SYMMETRIC
!*       MATRIX  C  BY THE SIMILARITY TRANSFORMATION
!*                F = Q(TRANSPOSE) C Q
!*       NOTE THAT ETRBK3 PRESERVES VECTOR EUCLIDEAN NORMS.
!*
!*
!*    COMPLEXITY -
!*       M*N**2
!*
!*    ON ENTRY-
!*       NM     - INTEGER
!*                MUST BE SET TO THE ROW DIMENSION OF TWO-DIMENSIONAL
!*                ARRAY PARAMETERS AS DECLARED IN THE CALLING ROUTINE
!*                DIMENSION STATEMENT.
!*       N      - INTEGER
!*                THE ORDER OF THE MATRIX  A.
!*       NV     - INTEGER
!*                MUST BE SET TO THE DIMENSION OF THE ARRAY  A  AS
!*                DECLARED IN THE CALLING ROUTINE DIMENSION STATEMENT.
!*       A      - W.P. REAL (NV)
!*                CONTAINS INFORMATION ABOUT THE ORTHOGONAL
!*                TRANSFORMATIONS USED IN THE REDUCTION BY  ETRED3  IN
!*                ITS FIRST  NV = N*(N+1)/2 POSITIONS.
!*       M      - INTEGER
!*                THE NUMBER OF EIGENVECTORS TO BE BACK TRANSFORMED.
!*       Z      - W.P REAL (NM,M)
!*                CONTAINS THE EIGENVECTORS TO BE BACK TRANSFORMED
!*                IN ITS FIRST M COLUMNS.
!*
!*    ON EXIT-
!*       Z      - W.P. REAL (NM,M)
!*                CONTAINS THE TRANSFORMED EIGENVECTORS
!*                IN ITS FIRST M COLUMNS.
!*
!*    DIFFERENCES WITH EISPACK 3 -
!*       THE TWO INNER LOOPS ARE REPLACED BY DDOT AND DAXPY.
!*       MULTIPLICATION USED INSTEAD OF DIVISION TO FIND S.
!*       OUTER LOOP RANGE CHANGED FROM 2,N TO 3,N.
!*       ADDRESS POINTERS FOR  A  SIMPLIFIED.
!*
!*    EXTERNAL ROUTINES -
!*       BLAS(1)--DDOT, DAXPY
!*       INTRINSIC FUNCTIONS - NONE
!*
!*    NOTE -
!*       QUESTIONS AND COMMENTS CONCERNING EISPACK SHOULD BE DIRECTED TO
!*       B. S. GARBOW, APPLIED MATH. DIVISION, ARGONNE NATIONAL LAB.
!*
!***********************************************************************
      subroutine etrbk3(nm, n, nv, a, m, z) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
!...Translated by Pacific-Sierra Research 77to90  4.4G  11:05:01  03/09/06  
!...Switches: -rl INDDO=2 INDIF=2 
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: nm 
      integer , intent(in) :: n 
      integer , intent(in) :: nv 
      integer , intent(in) :: m 
      real(double)  :: a(nv) 
      real(double)  :: z(nm,m) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      real(double), parameter :: zero = 0.0D+00 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, ii, im1, iz, j 
      real(double) :: h, s 
      double precision, external :: ddot
!-----------------------------------------------
!
!                        DECLARATIONS
!
!
!
!
!-----------------------------------------------------------------------
!
      if (m == 0) return  
      if (n <= 2) return  
!
      ii = 3 
      do i = 3, n 
        iz = ii + 1 
        ii = ii + i 
        h = a(ii) 
        if (h == zero) cycle  
        im1 = i - 1 
        do j = 1, m 
          s = -(ddot(im1,a(iz),1,z(1,j),1)*h)*h 
          call daxpy (im1, s, a(iz), 1, z(1,j), 1) 
        end do 
      end do 
      return  
      end subroutine etrbk3 


!*MODULE EIGEN   *DECK ETRED3
!***********************************************************************
!*       ROUTINE ETRED3(N,A,D,E,E2)
!*
!*    AUTHORS -
!*       THIS IS A MODIFICATION OF ROUTINE TRED3 FROM EISPACK EDITION 3
!*       DATED AUGUST 1983.
!*       EISPACK TRED3 IS A TRANSLATION OF THE ALGOL PROCEDURE TRED3,
!*       NUM. MATH. 11, 181-195(1968) BY MARTIN, REINSCH, AND WILKINSON.
!*       HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 212-226(1971).
!*       THIS VERSION IS BY S. T. ELBERT, AMES LABORATORY-USDOE JUN 1986
!*
!*    PURPOSE -
!*       THIS ROUTINE REDUCES A REAL SYMMETRIC (PACKED) MATRIX, STORED
!*       AS A ONE-DIMENSIONAL ARRAY, TO A SYMMETRIC TRIDIAGONAL MATRIX
!*       USING ORTHOGONAL SIMILARITY TRANSFORMATIONS, PRESERVING THE
!*       INFORMATION ABOUT THE TRANSFORMATIONS IN  A.
!*
!*    METHOD -
!*       THE TRIDIAGONAL REDUCTION IS PERFORMED IN THE FOLLOWING WAY.
!*       STARTING WITH J=N, THE ELEMENTS IN THE J-TH ROW TO THE
!*       LEFT OF THE DIAGONAL ARE FIRST SCALED, TO AVOID POSSIBLE
!*       UNDERFLOW IN THE TRANSFORMATION THAT MIGHT RESULT IN SEVERE
!*       DEPARTURE FROM ORTHOGONALITY.  THE SUM OF SQUARES  SIGMA  OF
!*       THESE SCALED ELEMENTS IS NEXT FORMED.  THEN, A VECTOR  U  AND
!*       A SCALAR
!*                      H = U(TRANSPOSE) * U / 2
!*       DEFINE A REFLECTION OPERATOR
!*                      P = I - U * U(TRANSPOSE) / H
!*       WHICH IS ORTHOGONAL AND SYMMETRIC AND FOR WHICH THE
!*       SIMILIARITY TRANSFORMATION  PAP  ELIMINATES THE ELEMENTS IN
!*       THE J-TH ROW OF  A  TO THE LEFT OF THE SUBDIAGONAL AND THE
!*       SYMMETRICAL ELEMENTS IN THE J-TH COLUMN.
!*
!*       THE NON-ZERO COMPONENTS OF  U  ARE THE ELEMENTS OF THE J-TH
!*       ROW TO THE LEFT OF THE DIAGONAL WITH THE LAST OF THEM
!*       AUGMENTED BY THE SQUARE ROOT OF  SIGMA  PREFIXED BY THE SIGN
!*       OF THE SUBDIAGONAL ELEMENT.  BY STORING THE TRANSFORMED SUB-
!*       DIAGONAL ELEMENT IN  E(J)  AND NOT OVERWRITING THE ROW
!*       ELEMENTS ELIMINATED IN THE TRANSFORMATION, FULL INFORMATION
!*       ABOUT  P  IS SAVE FOR LATER USE IN  ETRBK3.
!*
!*       THE TRANSFORMATION SETS  E2(J)  EQUAL TO  SIGMA  AND  E(J)
!*       EQUAL TO THE SQUARE ROOT OF  SIGMA  PREFIXED BY THE SIGN
!*       OF THE REPLACED SUBDIAGONAL ELEMENT.
!*
!*       THE ABOVE STEPS ARE REPEATED ON FURTHER ROWS OF THE
!*       TRANSFORMED  A  IN REVERSE ORDER UNTIL  A  IS REDUCED TO TRI-
!*       DIAGONAL FORM, THAT IS, REPEATED FOR  J = N-1,N-2,...,3.
!*
!*    COMPLEXITY -
!*       2/3 N**3
!*
!*    ON ENTRY-
!*       N      - INTEGER
!*                THE ORDER OF THE MATRIX.
!*       A      - W.P. REAL (NV)
!*                CONTAINS THE LOWER TRIANGLE OF THE REAL SYMMETRIC
!*                INPUT MATRIX, STORED ROW-WISE AS A ONE-DIMENSIONAL
!*                ARRAY, IN ITS FIRST N*(N+1)/2 POSITIONS.
!*
!*    ON EXIT-
!*       A      - W.P. REAL (NV)
!*                CONTAINS INFORMATION ABOUT THE ORTHOGONAL
!*                TRANSFORMATIONS USED IN THE REDUCTION.
!*       D      - W.P. REAL (N)
!*                CONTAINS THE DIAGONAL ELEMENTS OF THE TRIDIAGONAL
!*                MATRIX.
!*       E      - W.P. REAL (N)
!*                CONTAINS THE SUBDIAGONAL ELEMENTS OF THE TRIDIAGONAL
!*                MATRIX IN ITS LAST N-1 POSITIONS.  E(1) IS SET TO ZERO
!*       E2     - W.P. REAL (N)
!*                CONTAINS THE SQUARES OF THE CORRESPONDING ELEMENTS OF
!*                E. MAY COINCIDE WITH E IF THE SQUARES ARE NOT NEEDED.
!*
!*    DIFFERENCES FROM EISPACK 3 -
!*       OUTER LOOP CHANGED FROM II=1,N TO I=N,3,-1
!*       PARAMETER STATEMENT AND GENERIC INTRINSIC FUNCTIONS USED
!*       SCALE.NE.0 TEST NOW SPOTS TRI-DIAGONAL FORM
!*       VALUES LESS THAN EPSLON CLEARED TO ZERO
!*       USE BLAS(1)
!*       U NOT COPIED TO D, LEFT IN A
!*       E2 COMPUTED FROM E
!*       INNER LOOPS SPLIT INTO ROUTINES ELAU AND FREDA
!*       INVERSE OF H STORED INSTEAD OF H
!*
!*    EXTERNAL ROUTINES -
!*       ELAU, FREDA
!*       BLAS(1)--DASUM, DNRM2, DSCAL
!*       INTRINSIC--ABS, MAX, SIGN, SQRT
!*
!*    NOTE -
!*       QUESTIONS AND COMMENTS CONCERNING EISPACK SHOULD BE DIRECTED TO
!*       B. S. GARBOW, APPLIED MATH. DIVISION, ARGONNE NATIONAL LAB.
!*
!***********************************************************************
      subroutine etred3(n, a, d, e, e2) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n 
      real(double)  :: a(*) 
      real(double) , intent(out) :: d(*) 
      real(double)  :: e(*) 
      real(double) , intent(out) :: e2(*) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      real(double), parameter :: one = 1.0D+00 
      real(double), parameter :: zero = 0.0D+00 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, iia, iz0, l 
      real(double) :: aiimax, f, g, h, hroot, scale, scalei 
      double precision, external :: dasum, dnrm2
!-----------------------------------------------
!
!                        DECLARATIONS
!
!
!
!
!-----------------------------------------------------------------------
!
      if (n > 2) then 
        iz0 = (n*n + n)/2 
        aiimax = abs(a(iz0)) 
        do i = n, 3, -1 
          l = i - 1 
          iia = iz0 
          iz0 = iz0 - i 
          aiimax = max(aiimax,abs(a(iia))) 
          scale = dasum(l,a(iz0+1),1) 
          if (Abs(scale - abs(a(iia-1))) < 1.d-20 .or. Abs(aiimax+scale - aiimax) < 1.d-20) then 
!
!           THIS ROW IS ALREADY IN TRI-DIAGONAL FORM
!
            d(i) = a(iia) 
            if (Abs(aiimax + d(i) - aiimax) < 1.d-20) d(i) = zero 
            e(i) = a(iia-1) 
            if (Abs(aiimax + e(i) - aiimax) < 1.d-20) e(i) = zero 
            e2(i) = e(i)*e(i) 
            a(iia) = zero 
            cycle  
!
          endif 
!
          scalei = one/scale 
          call dscal (l, scalei, a(iz0+1), 1) 
          hroot = dnrm2(l,a(iz0+1)) 
!
          f = a(iz0+l) 
          g = -sign(hroot,f) 
          e(i) = scale*g 
          e2(i) = e(i)*e(i) 
          h = hroot*hroot - f*g 
          if (Abs(h) < 1.d-20) exit
          a(iz0+l) = f - g 
          d(i) = a(iia) 
          a(iia) = one/sqrt(h) 
!           .......... FORM P THEN Q IN E(1:L) ..........
          call elau (one/h, l, a(iz0+1), a, e) 
!           .......... FORM REDUCED A ..........
          call freda (l, a(iz0+1), a, e) 
!
        end do 
      endif 
      e(1) = zero 
      e2(1) = zero 
      d(1) = a(1) 
      e(2) = a(2) 
      e2(2) = a(2)*a(2) 
      d(2) = a(3) 
!
      return  
      end subroutine etred3 


!*MODULE EIGEN   *DECK ESTPI1
!***********************************************************************
!*    FUNCT. ROUTINE ESTPI1 (N,EVAL,D,E,X,ANORM)
!*
!*    AUTHOR -
!*       STEPHEN T. ELBERT (AMES LABORATORY-USDOE) DATE: 5 DEC 1986
!*
!*    PURPOSE -
!*       EVALUATE SYMMETRIC TRIDIAGONAL MATRIX PERFORMANCE INDEX
!*       *        *         *                  *           *
!*       FOR 1 EIGENVECTOR
!*           *
!*
!*    METHOD -
!*       THIS ROUTINE FORMS THE 1-NORM OF THE RESIDUAL MATRIX A*X-X*EVAL
!*       WHERE  A  IS A SYMMETRIC TRIDIAGONAL MATRIX STORED
!*       IN THE DIAGONAL (D) AND SUB-DIAGONAL (E) VECTORS, EVAL IS THE
!*       EIGENVALUE OF AN EIGENVECTOR OF  A,  NAMELY  X.
!*       THIS NORM IS SCALED BY MACHINE ACCURACY FOR THE PROBLEM SIZE.
!*       ALL NORMS APPEARING IN THE COMMENTS BELOW ARE 1-NORMS.
!*
!*    ON ENTRY -
!*       N      - INTEGER
!*                THE ORDER OF THE MATRIX  A.
!*       EVAL   - W.P. REAL
!*                THE EIGENVALUE CORRESPONDING TO VECTOR  X.
!*       D      - W.P. REAL (N)
!*                THE DIAGONAL VECTOR OF  A.
!*       E      - W.P. REAL (N)
!*                THE SUB-DIAGONAL VECTOR OF  A.
!*       X      - W.P. REAL (N)
!*                AN EIGENVECTOR OF  A.
!*       ANORM  - W.P. REAL
!*                THE NORM OF  A  IF IT HAS BEEN PREVIOUSLY COMPUTED.
!*
!*    ON EXIT -
!*       ANORM  - W.P. REAL
!*                THE NORM OF  A, COMPUTED IF INITIALLY ZERO.
!*       ESTPI1 - W.P. REAL
!*          !!A*X-X*EVAL!! / (EPSLON(10*N)*!!A!!*!!X!!);
!*          WHERE EPSLON(X) IS THE SMALLEST NUMBER SUCH THAT
!*             X + EPSLON(X) .NE. X
!*
!*          ESTPI1 .LT. 1 == SATISFACTORY PERFORMANCE
!*                 .GE. 1 AND .LE. 100 == MARGINAL PERFORMANCE
!*                 .GT. 100 == POOR PERFORMANCE
!*          (SEE LECT. NOTES IN COMP. SCI. VOL.6 PP 124-125)
!*
!***********************************************************************
      real(kind(0.0d0)) function estpi1 (n, eval, d, e, x, anorm) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param, ONLY:  double 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n 
      real(double) , intent(in) :: eval 
      real(double) , intent(inout) :: anorm 
      real(double) , intent(in) :: d(n) 
      real(double) , intent(in) :: e(n) 
      real(double) , intent(in) :: x(n) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      real(double), parameter :: one = 1.0D+00 
      real(double), parameter :: zero = 0.0D+00 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i 
      real(double) :: rnorm, size, xnorm 
      double precision, external :: epslon
!-----------------------------------------------
!
!                    DECLARATIONS
!
!
!
!-----------------------------------------------------------------------
!
      estpi1 = zero 
      if (n <= 1) return  
      size = 10*n 
      if (anorm == zero) then 
!
!              COMPUTE NORM OF  A
!
        anorm = max(abs(d(1))+abs(e(2)),abs(d(n))+abs(e(n))) 
        do i = 2, n - 1 
          anorm = max(anorm,abs(e(i))+abs(d(i))+abs(e(i+1))) 
        end do 
        if (anorm == zero) anorm = one 
      endif 
!
!           COMPUTE NORMS OF RESIDUAL AND EIGENVECTOR
!
      xnorm = abs(x(1)) + abs(x(n)) 
      rnorm = abs((d(1)-eval)*x(1)+e(2)*x(2)) + abs((d(n)-eval)*x(n)+e(n)*x(n-1&
        )) 
      do i = 2, n - 1 
        xnorm = xnorm + abs(x(i)) 
        rnorm = rnorm + abs(e(i)*x(i-1)+(d(i)-eval)*x(i)+e(i+1)*x(i+1)) 
      end do 
!
      estpi1 = rnorm/(epslon(size)*anorm*xnorm) 
      return  
      end function estpi1 

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine outer1 (ni_loc, nj, c1, c2, w, kr, e1b, e2a, enuc, mode, direct)
    use molkst_C, only: l1u, l2u, l3u, l_feather
    use parameters_C, only: natorb, tore, am
    use funcon_C, only: a0, ev
    use common_arrays_C, only: tvec
    implicit none
    logical, intent (in) :: direct
    integer, intent (in) :: mode, ni_loc, nj
    integer, intent (inout) :: kr
    double precision, intent (out) :: enuc
    double precision, dimension (*), intent (inout) :: w
    double precision, dimension (3), intent (in) :: c1, c2
    double precision, dimension (45), intent (out) :: e1b, e2a
!
    integer :: i, j, k, l
    double precision :: aee, r, rij, ww, point, const
    double precision, dimension (3) :: c2s
    double precision, external :: trunk
    if (mode == 0) then
      !
      !                                            MOLECULAR TERM
      !
     e1b = 0
     e2a = 0
      !
      rij = Sqrt ((c1(1)-c2(1))**2+ (c1(2)-c2(2))**2+ (c1(3)-c2(3))**2)
      r = rij / a0
      !
      aee = 0.5d0 / am(ni_loc) + 0.5d0 / am(nj)
      aee = aee * aee
      ww = ev / Sqrt (r*r+aee)
      if (l_feather) then
        call to_point(rij, point, const)
        ww = ww*const + (1.d0 - const)*point
      end if
      e1b(1) = -ww * tore(nj)
      e1b(3) = -ww * tore(nj)
      e1b(6) = -ww * tore(nj)
      e1b(10) = -ww * tore(nj)
      e1b(15) = -ww * tore(nj)
      e1b(21) = -ww * tore(nj)
      e1b(28) = -ww * tore(nj)
      e1b(36) = -ww * tore(nj)
      e1b(45) = -ww * tore(nj)
      e2a(1) = -ww * tore(ni_loc)
      e2a(3) = -ww * tore(ni_loc)
      e2a(6) = -ww * tore(ni_loc)
      e2a(10) = -ww * tore(ni_loc)
      e2a(15) = -ww * tore(ni_loc)
      e2a(21) = -ww * tore(ni_loc)
      e2a(28) = -ww * tore(ni_loc)
      e2a(36) = -ww * tore(ni_loc)
      e2a(45) = -ww * tore(ni_loc)
      enuc = tore(ni_loc) * tore(nj) * ww
      !
      if ( .not. direct) then
        w(1) = ww
        if (natorb(ni_loc)*natorb(nj) /= 0) then
          kr = kr + 1
        end if
      end if
    else
      !
      !                                            SOLID-STATE TERM
      !
      w(1) = 0.d0
      do i = 1, 10
        e1b(i) = 0.d0
        e2a(i) = 0.d0
      end do
      do i = -l1u, l1u
        do j = -l2u, l2u
          do k = -l3u, l3u
            do l = 1, 3
              c2s(l) = c2(l) + tvec(l, 1) * i + tvec(l, 2) * j + tvec(l, &
             & 3) * k - c1(l)
            end do
            r = Sqrt (c2s(1)**2+c2s(2)**2+c2s(3)**2)
            r = trunk (r)
               !
            w(1) = w(1) + a0 * ev / r
          end do
        end do
      end do
      e1b(1) = -w(1) * tore(nj)
      e1b(3) = -w(1) * tore(nj)
      e1b(6) = -w(1) * tore(nj)
      e1b(10) = -w(1) * tore(nj)
      e1b(15) = -w(1) * tore(nj)
      e1b(21) = -w(1) * tore(nj)
      e1b(26) = -w(1) * tore(nj)
      e1b(36) = -w(1) * tore(nj)
      e1b(45) = -w(1) * tore(nj)
      e2a(1) = -w(1) * tore(ni_loc)
      e2a(3) = -w(1) * tore(ni_loc)
      e2a(6) = -w(1) * tore(ni_loc)
      e2a(10) = -w(1) * tore(ni_loc)
      e2a(15) = -w(1) * tore(ni_loc)
      e2a(21) = -w(1) * tore(ni_loc)
      e2a(26) = -w(1) * tore(ni_loc)
      e2a(36) = -w(1) * tore(ni_loc)
      e2a(45) = -w(1) * tore(ni_loc)
      enuc = tore(ni_loc) * tore(nj) * w(1)
      if (natorb(ni_loc)*natorb(nj) /= 0) then
        kr = kr + 1
      end if
    end if
!
end subroutine outer1

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine gmetry(geo, coord)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : natoms, numcal, step, id, nvar, keywrd
      use common_arrays_C, only : labels, geoa, na, nb, nc, tvec, loc, &
      xparam, txtatm
      use elemts_C, only : elemnt
      use chanel_C, only : iw
      use funcon_C, only : pi
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision :: geo(3,natoms)
      double precision , intent(out) :: coord(3,natoms)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: icalcn, j, i, mb, mc, ma, k, l, counter
      double precision :: sum, error, ccos, cosa, xb, yb, zb, rbc, xa, ya, za, xyb&
        , xpa, xpb, costh, sinth, ypa, sinph, cosph, zqa, yza, coskh, sinkh, &
        sina, sind, cosd, xd, yd, zd, ypd, zpd, xpd, zqd, xqd, yqd, xrd
      character, dimension(4) :: ndimen*16
      double precision, dimension(3, natoms) :: geovec
      save ndimen, icalcn, counter
!-----------------------------------------------
      data icalcn/ 0/, counter/0/
      data ndimen/ ' MOLECULE     ', ' POLYMER       ', ' LAYER STRUCTURE', &
        ' SOLID         '/
!***********************************************************************
!
!    GMETRY  COMPUTES COORDINATES FROM BOND-ANGLES AND LENGTHS.
! *** IT IS ADAPTED FROM THE PROGRAM WRITTEN BY M.J.S. DEWAR.
!
!    (A) IF STEP IS NON-ZERO (THIS IS THE CASE WHEN "SADDLE" IS USED)
!        THEN GEO IS FIRST MODIFIED BY SHIFTING THE INTERNAL COORDINATES
!        ALONG A RADIUS FROM GEOA TO PLACE GEO AT A DISTANCE STEP FROM GEOA.
!    (B) NORMAL CONVERSION FROM INTERNAL TO CARTESIAN COORDINATES IS DONE.
!
!  ON INPUT:
!         GEO    = ARRAY OF INTERNAL COORDINATES.
!         NATOMS = NUMBER OF ATOMS, INCLUDING DUMMIES.
!         NA     = ARRAY OF ATOM LABELS FOR BOND LENGTHS.
!
!  ON OUTPUT:
!         COORD  = ARRAY OF CARTESIAN COORDINATES
!
!***********************************************************************
!                                     OPTION (A)
      if (abs(step) > 1.D-4) then
        sum = 0.D0
        do j = 1, 3
          do i = 1, natoms
            geovec(j,i) = geo(j,i) - geoa(j,i)
            sum = sum + geovec(j,i)**2
          end do
        end do
        sum = sqrt(sum)
        error = (sum - step)/sum
      else
        error = 0.D0
        geovec = 0.d0
      end if
      geo = geo - error*geovec(:,:natoms)
!                                     OPTION (B)
      coord(:,1) = geo(:,1)
      if (natoms == 1) return
      if (na(2) == 1) then
        coord(1,2)   = coord(1,1) + geo(1,2)
        coord(2:3,2) = coord(2:3,1)
      else
        coord(:,2) = geo(:,2)
      end if
      if (natoms /= 2) then
        if (na(3) == 0) then
          coord(:,3) = geo(:,3)
        else
          ccos = cos(geo(2,3))
          if (na(3) == 1) then
            coord(1,3) = coord(1,1) + geo(1,3)*ccos
          else
            coord(1,3) = coord(1,2) - geo(1,3)*ccos
          end if
          coord(2,3) = coord(2,2) + geo(1,3)*sin(geo(2,3))
          coord(3,3) = coord(3,2)
        end if

        if(size(na) == 4) call exit(1)
        do i = 4, natoms
          if (na(i) == 0) then
            coord(:,i) = geo(:,i)  ! Coordinate is already Cartesian
          end if
        end do
        do i = 4, natoms
          if (na(i) /= 0) then
            cosa = cos(geo(2,i))
            mb = nb(i)
            mc = na(i)
            xb = coord(1,mb) - coord(1,mc)
            yb = coord(2,mb) - coord(2,mc)
            zb = coord(3,mb) - coord(3,mc)
            rbc = xb*xb + yb*yb + zb*zb
            if (rbc < 1.D-16) then
  !
  !     TWO ATOMS ARE COINCIDENT.  A FATAL ERROR.
  !
              write (iw, '(/10x, A,I4,A,I4,A, 18x, a)') 'ATOMS', mb, ' AND', mc, ' ARE COINCIDENT', 'CARTESIAN COORDINATES'
              write(iw,'(58x, a, 2(11x,a))')"X", "Y", "Z"
              write(iw, '(10x, a, i5, a, a, 3f12.5)')"Atom", mb, ": ", elemnt(labels(mb))//"("//trim(txtatm(mb))//")",coord(:,mb)
              write(iw, '(10x, a, i5, a, a, 3f12.5,/)')"Atom", mc, ": ", elemnt(labels(mc))//"("//trim(txtatm(mc))//")",coord(:,mc)
              write (iw,'(a)')" Geometry at point of failure:"
              call geout(1)
              call mopend ('TWO ATOMS ARE COINCIDENT.  A FATAL ERROR.')
              return
            else
              rbc = 1.0D00/sqrt(rbc)
            end if
            ma = nc(i)
            xa = coord(1,ma) - coord(1,mc)
            ya = coord(2,ma) - coord(2,mc)
            za = coord(3,ma) - coord(3,mc)
  !
  !     ROTATE ABOUT THE Z-AXIS TO MAKE YB=0, AND XB POSITIVE.  IF XYB IS
  !     TOO SMALL, FIRST ROTATE THE Y-AXIS BY 90 DEGREES.
  !
            xyb = sqrt(xb*xb + yb*yb)
            k = -1
            if (xyb <= 0.009d0) then
              xpa = za
              za = -xa
              xa = xpa
              xpb = zb
              zb = -xb
              xb = xpb
              xyb = sqrt(xb*xb + yb*yb)
              if (xyb < 0.009d0) then
                write (iw, '(/10x, A,I4,A,I4,A, 18x, a)') 'ATOMS', ma, ' AND', mc, ' ARE COINCIDENT', 'CARTESIAN COORDINATES'
                write(iw,'(58x, a, 2(11x,a))')"X", "Y", "Z"
                write(iw, '(10x, a, i5, a, a, 3f12.5)')"Atom", ma, ": ", elemnt(labels(ma))//"("//trim(txtatm(ma))//")",coord(:,ma)
                write(iw, '(10x, a, i5, a, a, 3f12.5,/)')"Atom", mc, ": ", &
                  elemnt(labels(mc))//"("//trim(txtatm(mc))//")",coord(:,mc)
                write (iw,'(a)')" Geometry at point of failure:"
                call geout(1)
                call mopend ('TWO ATOMS ARE COINCIDENT.  A FATAL ERROR.')
                return
              end if
              k = 1
            end if
  !
  !     ROTATE ABOUT THE Y-AXIS TO MAKE ZB VANISH
  !
            costh = xb/xyb
            sinth = yb/xyb
            xpa = xa*costh + ya*sinth
            ypa = ya*costh - xa*sinth
            sinph = zb*rbc
            cosph = sqrt(abs(1.D00 - sinph*sinph))
            zqa = za*cosph - xpa*sinph
  !
  !     ROTATE ABOUT THE X-AXIS TO MAKE ZA=0, AND YA POSITIVE.
  !
            yza = sqrt(ypa**2 + zqa**2)
            if (yza >= 1.D-4) then
              coskh = ypa/yza
              sinkh = zqa/yza
            else
  !
  !   ANGLE TOO SMALL TO BE IMPORTANT
  !
              coskh = 1.D0
              sinkh = 0.D0
            end if
  !
  !     COORDINATES :-   A=(???,YZA,0),   B=(RBC,0,0),  C=(0,0,0)
  !     NONE ARE NEGATIVE.
  !     THE COORDINATES OF I ARE EVALUATED IN THE NEW FRAME.
  !
            sina = sin(geo(2,i))
            sind = -sin(geo(3,i))
            cosd = cos(geo(3,i))
            xd = geo(1,i)*cosa
            yd = geo(1,i)*sina*cosd
            zd = geo(1,i)*sina*sind
  !
  !     TRANSFORM THE COORDINATES BACK TO THE ORIGINAL SYSTEM.
  !
            ypd = yd*coskh - zd*sinkh
            zpd = zd*coskh + yd*sinkh
            xpd = xd*cosph - zpd*sinph
            zqd = zpd*cosph + xd*sinph
            xqd = xpd*costh - ypd*sinth
            yqd = ypd*costh + xpd*sinth
            if (k >= 1) then
              xrd = -zqd
              zqd = xqd
              xqd = xrd
            end if
            coord(1,i) = xqd + coord(1,mc)
            coord(2,i) = yqd + coord(2,mc)
            coord(3,i) = zqd + coord(3,mc)
!
!  If the bond-angle cosine is near zero or 180 degrees, then re-define the torsion or dihedral connectivity
!  unless it is a solid.  In solids, the re-definition would need to be restricted to the same unit cell.
!
            if (Abs (cosa) > 0.9998d0 .and. i > 4 .and. id == 0) then
              call bangle (coord, na(i), nb(i), nc(i), sum)
                if (sum > 3.05d0 .or. sum < 0.09d0) then
                  j = nc(i)
                  call renum (coord, na, nb, nc, i, natoms)

                  if (nc(i) == 0) nc(i) = j
                  !
                  !  Correct GEO to show the new dihedral
                  !
                  if (nc(i) /= j) then
                    call dihed (coord, i, na(i), nb(i), nc(i), geo(3, i))
                    if (sum >= pi/2) sum = pi - sum
!
!  If angle is not in the domain 0 - 180 degrees, increase dihedral by 180 degrees,
!  because the dihedral is for the wrong angle.
!
                    if (Mod (Int(geo(2,i)/pi + 100.d0), 2) == 1) &
                 &  geo(3,i) = geo(3,i) + pi
!
! Update xparam, if necessary
!
                  do j = 1, nvar
                    if(loc(2,j) == 3 .and. loc(1,j) == i) then
                      xparam(j) = geo(3,i)
                      exit
                    end if
                  end do
                end if
              end if
            end if
          end if
        end do
!
! *** NOW REMOVE THE TRANSLATION VECTORS, IF ANY, FROM THE ARRAY COORD
!
      end if
      if (natoms == 0) then
        call mopend("SYSTEMS HAVE NO ATOMS IN COMMON!")
        return
      end if
      k = natoms
      do while(labels(k) == 107)
        k = k - 1
        if (k == 0) then
           call mopend ('SOLIDS WITHOUT ATOMS ARE NOT ALLOWED.')
           return
        end if
      end do
      k = k + 1
      if (icalcn /= numcal) id = 0
      if (k <= natoms) then
!
!   SYSTEM IS A SOLID, OF DIMENSION NATOMS+1-K
!
        l = 0
        do i = k, natoms
          l = l + 1
          mc = na(i)
          tvec(1,l) = coord(1,i)
          tvec(2,l) = coord(2,i)
          tvec(3,l) = coord(3,i)
        end do
        id = l
        if (icalcn /= numcal) then
          if (counter < 1) then
          counter = counter + 1
          go to 170
          else
          icalcn = numcal
          counter = 0
          end if
          if (index(keywrd, " SILENT") == 0) then
            write (iw, 140) trim(ndimen(id+1))
  140       format(/,19x,'THE SYSTEM IS A',a,/)
            if (id == 0) go to 170
            write (iw, 150)
            write (iw, 160) (i,(tvec(j,i),j=1,3),i=1,id)
  150       format(/,'                UNIT CELL TRANSLATION VECTORS',/,/,&
            '              X                Y              Z')
160         format('    T',i1,' =',f14.7,' ',f14.7,' ',f14.7)
          end if
        end if
      end if
  170 continue
      j = 0
      do i = 1, natoms
        if (labels(i)==99) cycle
        j = j + 1
        coord(:,j) = coord(:,i)
      end do
      return
      end subroutine gmetry
      subroutine renum (coord, na, nb, nc, ii, natoms)
      implicit none
      integer, intent (in) :: ii, natoms
      integer, dimension (natoms), intent (in) :: na, nb
      integer, dimension (natoms), intent (inout) :: nc
      double precision, dimension (3, natoms), intent (in) :: coord
      integer :: i, jj, nai, nbi
      double precision :: angle, rab, rmin, theta
      intrinsic Asin
 !***********************************************************************
 !
 !  Renumber the NC of atom II.  On input, the angle NA(II)-NB(II)-NC(II)
 !  is too near to 0 or 180 degrees.  Find a new atom for NC(II), so that
 !  the angle will be acceptable (as large as possible)
 !***********************************************************************
      nai = na(ii)
      nbi = nb(ii)
 !
 !   Theta = 45 degrees
 !
      theta = 0.7853d0
      jj = 0
      rmin = 1.d10
      do
        do i = 1, ii - 1
          if (i /= nai .and. i /= nbi) then
            call bangle (coord, nai, nbi, i, angle)
            if (angle > 1.5707963d0) then
              angle = 2.d0 * Asin (1.d0) - angle
            end if
            if (angle >= theta) then
             !
             !   Angle is OK.  Now find atom of lowest distance
             !
              rab = (coord(1, nbi)-coord(1, i)) ** 2 + (coord(2, &
             & nbi)-coord(2, i)) ** 2 + (coord(3, nbi)-coord(3, i)) ** 2
              if (rab < rmin) then
                jj = i
                rmin = rab
              end if
            end if
          end if
        end do
        if (jj /= 0) then
       !
       !  Best NC is JJ; best angle is THMIN
       !
          nc(ii) = jj
          exit
        end if
    !
    !   No atom inside the allowed angle - reduce the angle
    !
        theta = theta * 0.5d0
        if (theta < 0.0174533d0) theta = 0.d0
      end do
   end subroutine renum

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      module maps_C

      double precision, dimension(:), allocatable  :: &
   &  surf,    &
   &  react

      integer :: &
  &  ijlp    , & !
  &  ilp,      & !
  &  jlp,      & !
  &  jlp1,     & !
  &  ione,     & !
  &  latom,    & !
  &  lparam,   & !
  &  kloop,    &
  &  latom1,   &
  &  lpara1,   &
  &  latom2,   &
  &  lpara2
      double precision :: &
  &  rxn_coord1 = 0.d0,   &
  &  rxn_coord2 = 0.d0,   &
  &  rxn_coord,           &
  &  rc_escf,             &  !  Reaction coordinate Heat of Formation
  &  rc_dipo,             &  !  Reaction coordinate dipole
  &  ekin,                &  !  Kinetic energy
  &  dummy
      end module maps_C

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

! ____________________________________________________________________________
! __________________________ INTEGRAL ROUTINES _______________________________
! ____________________________________________________________________________

      subroutine replsn ()
      use molkst_C, ONLY: numat

      use reimers_C, only : ind, f0, x, y, z, zcore, gamma, beta, &
          fg, vnn, nrep, ifroti, mic2, mic1, mf0ss, mf0sd, mf0dd, mg1sp, &
          mf2pp, mg2sd, mg1pd, mf2pd, mg3pd, mf2dd, mf4dd, mr1sppd, &
          mr2sddd, mr2sdpp, ntrmet, itrmet, nirreg, natt, nte, natm, &
          ibf, nbf, matind, na
      USE chanel_C, only : iw

      implicit none
      double precision ::  enr, enucrep, fracsi, fracsj, gav, gamma1, &
                        rij, sqrt3, vnn1, vnnz, xx, zero
      integer ::       i, j, k, &
                        i1, i2, ia, ib, ibk, &
                        j1, j2, ja, jb, jbk, &
                        kb, mte, ndump = 0, nham, nm

      data zero /0.d0/
      data mte  /8/

      k = 0
      na = numat

!     **** this evaluates the electron repulsion integrals and also ****
!     **** the nuclear repulsion energy ****
      nrep = 1
      vnn = zero
      vnnz = zero
      nham = 2

      do i = 1, na
        ia = natm(i)
        ib = ibf(i)

        do j = i, 1, - 1
          ja = natm(j)
          jb = ibf(j)
          rij = sqrt ((x(j) - x(i))**2 + (y(j) - y(i))**2 + (z(j) - z(i))**2 )
!          write (6, *) 'dist', i, j, x(i), x(j), y(i), y(j), z(i), z(j), rij

!	  **** s - s, s - p, or p - p interactions ******
          f0(1, 1) = gamma1 (fg(mf0ss, ia), fg(mf0ss, ja), rij)
          gav = f0(1, 1)
          fracsi = 1.d0
          fracsj = 1.d0
          if (nbf(i) == 9) then
!	    **** i - j is d-sp interaction ****
            if (i == j) then
!	      *** gamma(sd) is only used if one - centre integral ****
              f0(2, 1) = gamma1 (fg(mf0sd, ia), fg(mf0sd, ja), rij)
            else
!	      *** Zindo does this, but seems crazy to me ****
              f0(2, 1) = gamma1 (fg(mf0dd, ia), fg(mf0ss, ja), rij)
            end if
            fracsi = (fg(mic1, ia) + fg(mic2, ia)*2) / zcore(i)

            if (nbf(j) == 9) then
!	      **** d-d interactions ****
              f0(2, 2) = gamma1 (fg(mf0dd, ia), fg(mf0dd, ja), rij)
              fracsj = (fg(mic1, ja) + fg(mic2, ja)*2) / zcore(j)
              gav = fracsi*fracsj*f0(1, 1) + fracsi*(1 - fracsj)*f0(1, 2) + &
     &          (1 - fracsi)*fracsj*f0(2, 1) + (1 - fracsi)*(1 - fracsj)*f0(2, 2)
            else
              gav = fracsi*f0(1, 1) + (1 - fracsi)*f0(2, 1)
            end if
          end if
          if (nbf(j) == 9) then
!	    **** i - j is sp - d interaction ****
            if (i == j) then
!	      *** gamma(sd) is only used if one - centre integral ****
              f0(1, 2) = gamma1 (fg(mf0sd, ia), fg(mf0sd, ja), rij)
            else
!	      *** Zindo does this, but seems crazy to me ****
              f0(1, 2) = gamma1 (fg(mf0ss, ia), fg(mf0dd, ja), rij)
            end if
            if (nbf(i) < 9) then
              fracsj = (fg(mic1, ja) + fg(mic2, ja)*2) / zcore(j)
              gav = fracsj*f0(1, 1) + (1 - fracsj)*f0(1, 2)
            end if
          end if
!	  **** fill in atom - atom block, f0(ss), f0(sp), .... f0(dd) ****

          do i1 = 0, nbf(i) - 1
            i2 = ib + i1
            do j1 = 0, nbf(j) - 1
              j2 = jb + j1
              if (i2 >= j2) then
                gamma(i2, j2) = f0(ind(i1), ind(j1))
              end if
            end do
          end do
!	  **** nuclear repulsion energy, gav = weighted s, p, d gammas ****

          if (i == j) then
!	    **** calculation of core matrix elements for this atom ****
            call uform (i, fg(1, ia), f0, zcore(i))
          else

!	    **** nuclear repulsion energy ****
!            if (ia <= 9 .and. ja <= 9) alp = alpha(ia, ja)
            enr = enucrep (gav)
!            vnn1 = zcore(i) * zcore(j) * enr
            vnn1 = zcore(i) * zcore(j) * gav
            vnn = vnn + vnn1
!            write (6, *) 'enr', enr, rij, gav
!            write (6, *) 'vnn', vnn1, vnn
!            write (6, *) 'zcr', zcore(i), zcore(j)
            vnnz = vnnz + zcore(i) * zcore(j) * f0(1, 1)
            if (ndump >= 2 .and. (nbf(i) == 0 .or. nbf(j) == 0) .and. vnn1 /= 0.d0) &
              write (iw, "(' POINT CHARGE: atoms', 2i4, ' at r = ', f8.4, ' gamma = ', f8.4)") i, j, rij, enr
!	    **** add nuclear - electronic attraction to U for Fock matrix ***
            do kb = 0, nbf(i) - 1
              ibk = ib + kb
              nm = matind(ibk) + ibk
              beta(nm) = beta(nm) - zcore(j) * (fracsj*f0(ind(kb), 1) + &
     &                (1.d0 - fracsj)*f0(ind(kb), 2) )
            end do
            do kb = 0, nbf(j) - 1
              jbk = jb + kb
              nm = matind(jbk) + jbk
              beta(nm) = beta(nm) - zcore(i) * (fracsi*f0(1, ind(kb)) + &
     &                (1.d0 - fracsi)*f0(2, ind(kb)) )
            end do
          end if

        end do

!	**** INDO atom - atom diagonal block modifications ****
        if (nham == 2) then

          if (nbf(i) > 1) then
            do j = 1, 3
!	      **** s - p exchange integrals ****
              gamma(ib + 0, ib + j) = fg(mg1sp, ia)
!	      **** p - p coulomb diagonal integrals ****
              gamma(ib + j, ib + j) = gamma(ib + j, ib + j) + 4*fg(mf2pp, ia)
            end do
!	    **** p - p coulomb off - diagonal integrals ****
            gamma(ib + 2, ib + 1) = gamma(ib + 2, ib + 1) - 2*fg(mf2pp, ia)
            gamma(ib + 3, ib + 2) = gamma(ib + 2, ib + 1)
            gamma(ib + 3, ib + 1) = gamma(ib + 2, ib + 1)
!	    **** p - p exchange integrals ****
            gamma(ib + 1, ib + 2) = 3*fg(mf2pp, ia)
            gamma(ib + 2, ib + 3) = gamma(ib + 1, ib + 2)
            gamma(ib + 1, ib + 3) = gamma(ib + 1, ib + 2)
          end if

          if (nbf(i) == 9) then
            do j = 4, 8
!	      **** s - d exchange integrals ****
              gamma(ib + 0, ib + j) = fg(mg2sd, ia)
!	      **** d-d diagonal coulomb integrals ****
              gamma(ib + j, ib + j) = gamma(ib + j, ib + j) + 4*fg(mf2dd, ia) + &
     &                          36*fg(mf4dd, ia)
            end do
!	    **** p - d coulomb integrals ****
            gamma(ib + 4, ib + 1) = gamma(ib + 4, ib + 1) - 2*fg(mf2pd, ia)
            gamma(ib + 4, ib + 2) = gamma(ib + 4, ib + 1)
            gamma(ib + 4, ib + 3) = gamma(ib + 4, ib + 3) + 4*fg(mf2pd, ia)
            gamma(ib + 5, ib + 1) = gamma(ib + 5, ib + 1) + 2*fg(mf2pd, ia)
            gamma(ib + 5, ib + 2) = gamma(ib + 5, ib + 1)
            gamma(ib + 6, ib + 1) = gamma(ib + 5, ib + 1)
            gamma(ib + 6, ib + 2) = gamma(ib + 5, ib + 1)
            gamma(ib + 7, ib + 1) = gamma(ib + 5, ib + 1)
            gamma(ib + 7, ib + 3) = gamma(ib + 5, ib + 1)
            gamma(ib + 8, ib + 2) = gamma(ib + 5, ib + 1)
            gamma(ib + 8, ib + 3) = gamma(ib + 5, ib + 1)
            gamma(ib + 5, ib + 3) = gamma(ib + 5, ib + 3) - 4*fg(mf2pd, ia)
            gamma(ib + 6, ib + 3) = gamma(ib + 5, ib + 3)
            gamma(ib + 7, ib + 2) = gamma(ib + 5, ib + 3)
            gamma(ib + 8, ib + 1) = gamma(ib + 5, ib + 3)
!	    **** p - d exchange terms ****
            gamma(ib + 1, ib + 4) =  fg(mg1pd, ia) + 18*fg(mg3pd, ia)
            gamma(ib + 2, ib + 4) = gamma(ib + 1, ib + 4)
            gamma(ib + 3, ib + 4) = 4*fg(mg1pd, ia) + 27*fg(mg3pd, ia)
            gamma(ib + 1, ib + 5) = 3*fg(mg1pd, ia) + 24*fg(mg3pd, ia)
            gamma(ib + 2, ib + 5) = gamma(ib + 1, ib + 5)
            gamma(ib + 1, ib + 6) = gamma(ib + 1, ib + 5)
            gamma(ib + 2, ib + 6) = gamma(ib + 1, ib + 5)
            gamma(ib + 1, ib + 7) = gamma(ib + 1, ib + 5)
            gamma(ib + 3, ib + 7) = gamma(ib + 1, ib + 5)
            gamma(ib + 2, ib + 8) = gamma(ib + 1, ib + 5)
            gamma(ib + 3, ib + 8) = gamma(ib + 1, ib + 5)
            gamma(ib + 3, ib + 5) = 15*fg(mg3pd, ia)
            gamma(ib + 3, ib + 6) = gamma(ib + 3, ib + 5)
            gamma(ib + 2, ib + 7) = gamma(ib + 3, ib + 5)
            gamma(ib + 1, ib + 8) = gamma(ib + 3, ib + 5)
!	    **** d-d off - diagonal coulomb terms ****
            gamma(ib + 5, ib + 4) = gamma(ib + 5, ib + 4) - 4*fg(mf2dd, ia) + &
     &                                 6*fg(mf4dd, ia)
            gamma(ib + 6, ib + 4) = gamma(ib + 5, ib + 4)
            gamma(ib + 6, ib + 5) = gamma(ib + 6, ib + 5) + 4*fg(mf2dd, ia) - &
     &                                34*fg(mf4dd, ia)
            gamma(ib + 7, ib + 4) = gamma(ib + 7, ib + 4) + 2*fg(mf2dd, ia) - &
     &                                24*fg(mf4dd, ia)
            gamma(ib + 8, ib + 4) = gamma(ib + 7, ib + 4)
            gamma(ib + 7, ib + 5) = gamma(ib + 7, ib + 5) - 2*fg(mf2dd, ia) - &
     &                                 4*fg(mf4dd, ia)
            gamma(ib + 7, ib + 6) = gamma(ib + 7, ib + 5)
            gamma(ib + 8, ib + 5) = gamma(ib + 7, ib + 5)
            gamma(ib + 8, ib + 6) = gamma(ib + 7, ib + 5)
            gamma(ib + 8, ib + 7) = gamma(ib + 7, ib + 5)
!	    **** d-d exchange terms ****
            gamma(ib + 4, ib + 5) = 4*fg(mf2dd, ia) + 15*fg(mf4dd, ia)
            gamma(ib + 4, ib + 6) = gamma(ib + 4, ib + 5)
            gamma(ib + 5, ib + 6) = 35*fg(mf4dd, ia)
            gamma(ib + 4, ib + 7) =   fg(mf2dd, ia) + 30*fg(mf4dd, ia)
            gamma(ib + 4, ib + 8) = gamma(ib + 4, ib + 7)
            gamma(ib + 5, ib + 7) = 3*fg(mf2dd, ia) + 20*fg(mf4dd, ia)
            gamma(ib + 6, ib + 7) = gamma(ib + 5, ib + 7)
            gamma(ib + 5, ib + 8) = gamma(ib + 5, ib + 7)
            gamma(ib + 6, ib + 8) = gamma(ib + 5, ib + 7)
            gamma(ib + 7, ib + 8) = gamma(ib + 5, ib + 7)
          end if
        end if

      end do

!     **** calculation of irregular integrals for transition metals INDO/1S ****

      ntrmet = 0
      sqrt3 = sqrt (3.d0)

      if (ifroti == 0) then
!	**** igrore Zerners terms, loosing rotational invariance of d orbs ****
        nirreg = 0

      else

      k = 0
      do i = 1, na
        ia = natm(i)
        natt(i) = 0
        if (nbf(i) > 4) then
          ntrmet = ntrmet + 1
          itrmet(ntrmet) = i
!	  **** check to see if this type of atom already found ****
          j = 1
          do while (j < i .and. natm(j) /= natm(i))
            j = j + 1
          end do
          if (j < i) then
!	    **** atom already done ****
            natt(i) = natt(j)
          else
            k = k + 1
            if (k > mte) then
              write (iw, "(/' ERROR: Max number of different transition metals = ', i4)") mte
              write (6, "(/' ERROR: Max number of different transition metals = ', i4)") mte
              stop 'MTE'
            end if
            natt(i) = k
            nirreg = 0

!	    ********* G1(pd) and G3(pd) contributions *******
            xx = ( - fg(mg1pd, ia) - 3*fg(mg3pd, ia)) * sqrt3
            call irreg (k, xx, 1, 4, 1, 5)
            call irreg (k, xx, 1, 6, 2, 4)
            call irreg (k, xx, 2, 6, 1, 4)
            xx = -3*fg(mg1pd, ia) + 21*fg(mg3pd, ia)
            call irreg (k, xx, 1, 6, 2, 5)
            xx = (2*fg(mg1pd, ia) - 9*fg(mg3pd, ia)) * sqrt3
            call irreg (k, xx, 1, 7, 3, 4)
            call irreg (k, xx, 2, 8, 3, 4)
            xx =                   15*fg(mg3pd, ia)
            call irreg (k, xx, 1, 7, 3, 5)
            call irreg (k, xx, 1, 8, 2, 7)
            call irreg (k, xx, 1, 8, 3, 6)
            call irreg (k, xx, 2, 7, 3, 6)
            xx = (  fg(mg1pd, ia) + 3*fg(mg3pd, ia)) * sqrt3
            call irreg (k, xx, 2, 5, 2, 4)
            xx =  3*fg(mg1pd, ia) - 21*fg(mg3pd, ia)
            call irreg (k, xx, 2, 6, 1, 5)
            xx =  3*fg(mg1pd, ia) - 6*fg(mg3pd, ia)
            call irreg (k, xx, 2, 8, 1, 7)
            call irreg (k, xx, 3, 7, 1, 5)
            call irreg (k, xx, 3, 7, 2, 6)
            call irreg (k, xx, 3, 8, 1, 6)
            xx =                - 15*fg(mg3pd, ia)
            call irreg (k, xx, 2, 8, 3, 5)
            xx = ( - fg(mg1pd, ia) + 12*fg(mg3pd, ia)) * sqrt3
            call irreg (k, xx, 3, 7, 1, 4)
            call irreg (k, xx, 3, 8, 2, 4)
            xx = -3*fg(mg1pd, ia) + 6*fg(mg3pd, ia)
            call irreg (k, xx, 3, 8, 2, 5)

!	    ********* F2(pd) contrinutions *************
            xx = -2*fg(mf2pd, ia)  * sqrt3
            call irreg (k, xx, 1, 1, 4, 5)
            call irreg (k, xx, 4, 6, 1, 2)
            xx =  2*fg(mf2pd, ia)  * sqrt3
            call irreg (k, xx, 2, 2, 4, 5)
            xx =    fg(mf2pd, ia)  * sqrt3
            call irreg (k, xx, 4, 7, 1, 3)
            call irreg (k, xx, 4, 8, 2, 3)
            xx =  3*fg(mf2pd, ia)
            call irreg (k, xx, 5, 7, 1, 3)
            call irreg (k, xx, 6, 7, 2, 3)
            call irreg (k, xx, 6, 8, 1, 3)
            call irreg (k, xx, 7, 8, 1, 2)
            xx = -3*fg(mf2pd, ia)
            call irreg (k, xx, 5, 8, 2, 3)

!	    ********* F2(dd) and F4(dd) contrinutions *************
            xx = (  fg(mf2dd, ia) - 5*fg(mf4dd, ia)) * sqrt3
            call irreg (k, xx, 5, 7, 4, 7)
            call irreg (k, xx, 6, 7, 4, 8)
            call irreg (k, xx, 6, 8, 4, 7)
            xx = (- fg(mf2dd, ia) + 5*fg(mf4dd, ia)) * sqrt3
            call irreg (k, xx, 5, 8, 4, 8)
            xx = -3*fg(mf2dd, ia) + 15*fg(mf4dd, ia)
            call irreg (k, xx, 5, 8, 6, 7)
            xx =  3*fg(mf2dd, ia) - 15*fg(mf4dd, ia)
            call irreg (k, xx, 6, 8, 5, 7)
            xx = (- 2*fg(mf2dd, ia) + 10*fg(mf4dd, ia)) * sqrt3
            call irreg (k, xx, 7, 7, 4, 5)
            call irreg (k, xx, 7, 8, 4, 6)
            xx = (2*fg(mf2dd, ia) - 10*fg(mf4dd, ia)) * sqrt3
            call irreg (k, xx, 8, 8, 4, 5)

            if (ifroti == 1) then
!	      ********* R1(sppd) contrinutions *************
              xx = 0.1490712d0 * fg(mr1sppd, ia)
              call irreg (k, - xx, 0, 1, 1, 4)
              call irreg (k, - xx, 0, 2, 2, 4)
              call irreg (k, 2*xx, 0, 3, 3, 4)
              xx = 0.2581989d0 * fg(mr1sppd, ia)
              call irreg (k, xx, 0, 1, 1, 5)
              call irreg (k, xx, 0, 1, 2, 6)
              call irreg (k, xx, 0, 1, 3, 7)
              call irreg (k, xx, 0, 2, 1, 6)
              call irreg (k, - xx, 0, 2, 2, 5)
              call irreg (k, xx, 0, 2, 3, 8)
              call irreg (k, xx, 0, 3, 1, 7)
              call irreg (k, xx, 0, 3, 2, 8)

!	      ********* R2(sdpp) contrinutions *************
              xx = 0.0894427d0 * fg(mr2sdpp, ia)
              call irreg (k, - xx, 1, 1, 0, 4)
              call irreg (k, - xx, 2, 2, 0, 4)
              call irreg (k, 2*xx, 3, 3, 0, 4)
              xx = 0.1549193d0 * fg(mr2sdpp, ia)
              call irreg (k, xx, 1, 1, 0, 5)
              call irreg (k, - xx, 2, 2, 0, 5)
              call irreg (k, xx, 1, 2, 0, 6)
              call irreg (k, xx, 1, 3, 0, 7)
              call irreg (k, xx, 2, 3, 0, 8)

!	      ********* R2(sddd) contrinutions *************
              xx = 0.0638877 * fg(mr2sddd, ia)
              call irreg (k, 2*xx, 4, 4, 0, 4)
              call irreg (k, - 2*xx, 5, 5, 0, 4)
              call irreg (k, - 2*xx, 6, 6, 0, 4)
              call irreg (k,  xx, 7, 7, 0, 4)
              call irreg (k,  xx, 8, 8, 0, 4)
              call irreg (k, - 2*xx, 4, 5, 0, 5)
              call irreg (k, - 2*xx, 4, 6, 0, 6)
              call irreg (k,  xx, 4, 7, 0, 7)
              call irreg (k,  xx, 4, 8, 0, 8)
              xx = 0.1106567d0 * fg(mr2sddd, ia)
              call irreg (k,  xx, 7, 7, 0, 5)
              call irreg (k, - xx, 8, 8, 0, 5)
              call irreg (k,  xx, 7, 8, 0, 6)
              call irreg (k,  xx, 5, 7, 0, 7)
              call irreg (k,  xx, 6, 8, 0, 7)
              call irreg (k, - xx, 5, 8, 0, 8)
              call irreg (k,  xx, 6, 7, 0, 8)
            end if

          end if
        end if
      end do
      end if
      nte = k

      return
      end subroutine replsn

!     *************************************************************************

      subroutine irreg (k, xx, i1, i2, i3, i4)

      use reimers_C, only : ig1, ig2, ig3, ig4, g, nirreg
      implicit none
      double precision ::   xx
      integer ::            i1, i2, i3, i4, k

!     **** stores one of Zerners rotational - invariance maintaining ****
!     **** irregular two - electron integrals into integral list      ****

      if (nirreg >= 75) stop 'IRREGULAR INTEGRALS'
      nirreg = nirreg + 1
      g(nirreg, k) = xx
      ig1(nirreg, k) = i1
      ig2(nirreg, k) = i2
      ig3(nirreg, k) = i3
      ig4(nirreg, k) = i4

      return
      end subroutine irreg

!     *************************************************************************

      subroutine uform (i, fg, f0, zcore)

      use reimers_C, only : matind, natm, nbf, ibf, nbt, nbeta, &
          mis2, mip2, mid2, mic2, mic1, mg1sp, mf2pp, &
          mg2sd, mg1pd, mg3pd, mf2dd, mf4dd, beta

      implicit none
      double precision ::  fg(24), f0(2, 2), &
                        sp, uu, zcore
      integer ::           i, k, &
                        i0, i1, ib, ic, id, icindx, icore, ip, is, nm

!     *** This constructs the U matrix from either (I + A)/2 or I		****
!     *** using mixed electronic configurations for the uncharged atoms	****

!     *** mis2 = s ioniz pot from d(n - 2)s2 or from sp, mic2 = its probability ****
!     *** mis1 = s ioniz pot from d(n - 1)s1,           mic1 = its probability ****
!     *** sim for p and d ioniz pots, mid0 is d ioniz pot from d(n)s0       ****
!     *** sp is the sum of the d(n - 2)s2 and d(n - 1)s1 probabilities	    ****

      icore = nint (zcore)
      i0 = ibf(i)
      k = natm(i)
      sp = fg(mic2) + fg(mic1)
      nbeta = 5
!     **** loop over basis functions on this atom ****

      do ib = 0, nbf(i) - 1
        i1 = i0 + ib
        nm = matind(i1) + i1
        beta(nm) = 0.d0

!       **** loop over the 3 configurations d(n - ic)s(ic) ****

        do ic = 2, 0, - 1
          icindx = 2 - ic
          uu = 0.d0
          if (nbt(i1) == 0) then
!           ***** s function, note there is no entry for d(n)s0 ****
            if (ic > 0) then
              uu = fg(mis2 + icindx)
              if (nbeta == 5) then

!               **** INDO/1S I only, all atoms ****
                if (nbf(i) == 9) then
                  is = ic
                  ip = 0
                  id = icore - is
                else
!                 **** sp configuration only ****
                  is = min (2, icore)
                  id = 0
                  ip = icore - is
                end if
                uu = uu - (is - 1) * f0(1, 1)&
     &                 - ip     * (f0(1, 1) - fg(mg1sp)/2.d0)&
     &                 - id     * (f0(1, 2) - fg(mg2sd)/2.d0)
              else if (nbeta < 4) then

!               **** (I + A)/2, 2nd row code only ****
                uu = uu - (zcore - 0.5d0) * f0(1, 1)

                if (k == 4) then
                  uu = uu + fg(mg1sp)/4
                else if (k > 4) then
                  uu = uu + fg(mg1sp)/2*(zcore - 1.5d0)
                end if

              end if
            else
!             **** renormalization as no d(n)s(0) ****
              beta(nm) = beta(nm) / sp
            end if

          else if (nbt(i1) <= 3) then
!           ***** p function, note there is no entry for d(n)s0 ****
            if (ic > 0) then
              uu = fg(mip2 + icindx)
               if (nbeta == 5) then
!               **** INDO/1S I only, all atoms ****
                if (nbf(i) == 9) then
                  ip = 1
                  if (k /= 20) then
                    is = ic - ip
                    id = icore - ic
                  else
!                   **** ZINDO has d->p for Ca and s - >p for all else ****
                    is = ic
                    id = icore - ic - 1
                  end if
                else
!                 **** sp configuration only ****
                  id = 0
                  ip = max (1, icore - 2)
                  is = icore - ip
                end if
                uu = uu - (ip - 1.d0) * (f0(1, 1) - fg(mf2pp)*2.0d0)&
     &                - is        * (f0(1, 1) - fg(mg1sp)*0.5d0)&
     &                - id        * (f0(1, 2) - fg(mg1pd)&
     &                                       - fg(mg3pd)*10.5d0)

              else if (nbeta < 4) then
!               **** (I + A)/2, 2nd row code only ****
                uu = uu - (zcore - 0.5d0) * f0(1, 1)
                 if (k == 3) then
                  uu = uu + fg(mg1sp)/4
                else if (k == 4) then
                  uu = uu + fg(mg1sp)*0.75d0
                else if (k > 4) then
                  uu = uu + fg(mg1sp)&
     &                  + fg(mf2pp)*2*(zcore - 2.5d0)
                end if

              end if

            else
!             **** renormalization as no d(n)s(0) ****
              beta(nm) = beta(nm) / sp
            end if

          else
!           **** d function, INDO/1S code only, all atoms ****
            ip = 0
            is = ic
            id = icore - is
            uu = fg(mid2 + icindx)
            uu = uu - (id-1.d0)  * (f0(2, 2) - fg(mf2dd)*14.d0/9.d0&
     &                                    - fg(mf4dd)*14.d0)&
     &            - is         * (f0(1, 2) - fg(mg2sd)*0.5d0)&
     &            - ip         * (f0(1, 2) - fg(mg1pd)&
     &                                    - fg(mg3pd)*10.5d0)
          end if
!         **** multiply contribution to core integral by its weight ****
          beta(nm) = beta(nm) + uu * fg(mic2 + icindx)
        end do
      end do

      return
      end subroutine uform

!     *************************************************************************

      function gamma1 (gammk, gammk1, r)

      use reimers_C, only : nham, au2ev, au2ang, tomk
      implicit none
      double precision ::   r, gamma1, gamma2, gammk, gammk1

!     **** two - electron repulsion integrals ****

      nham = 2
!     **** mataga integrals (with Tomono/Weiss modifications) ****
      gamma2 = au2ev / (r/au2ang + tomk*2.d0*au2ev/(gammk + gammk1) )

      if (nham /= 3) gamma2 = gamma2 * tomk
      gamma1 = gamma2
      return
      end function gamma1
!     *************************************************************************

      function enucrep (gamma)
         implicit none
      double precision :: gamma, enucrep

!     **** nuclear repulsion energy ****

      enucrep = gamma

      return
      end function enucrep

!     *************************************************************************

      subroutine beta1 (s, betao, beta)

      use reimers_C, only : n
      USE molkst_C, ONLY: mpack, norbs
      implicit none

      double precision ::  betao(norbs), beta(mpack), s(mpack)
      integer ::           i, j, nm

!     **** construction of the one - electron matrix ****

      nm = 0
      do i = 1, n
        do j = 1, i
          nm = nm + 1
          if (i /= j) beta(nm) = (betao(i) + betao(j)) * s(nm) * 0.5d0
        end do
      end do
      return

      end subroutine beta1

!     *************************************************************************

      subroutine dipol (x, y, z, dm)

!     **** calculates dipole moment matrix elements in AO basis   ****
!     **** units of dipole are eA				  ****
      use reimers_C, only : n, na, nb2, matind, au2ang, &
          natm, nbf, ibf, iat, nbt, nprn, zeta, zetad, zetawt, &
          dipsym, ndtype, fact
!      USE chanel_C, only : iw

      implicit none
      double precision ::  x(na), y(na), z(na), dm(nb2, 3), &
                        two, three, bohrmg, &
                        sqrt3, &
                        al, aaa, am, amu, bmu, delx, dely, delz, &
                        pd, r, sp, t, zj, zk
      integer ::           i, j, &
                        i1, ia, ib, iss, &
                        j2, j3, ja, jb, jnat, &
                        k3, ka, kb, knat, mmmm, mu, nm, nu


      data two, three    /2.d0, 3.d0/
!     **** the Borh magneton ehbar/(2.mass_e.c) in units of e Ang ****
      data bohrmg       /0.0019308d0/

      sqrt3 = sqrt (three)
      pd = 0.d0

!     **** start by zeroing all elements ****
      ndtype = 1
      do i = 1, nb2
        do j = 1, 3
          dm(i, j) = 0.d0
        end do
      end do
      if (ndtype <= 1) then

!	**** usual length formalism of dipole integrals, REAL ****

        dipsym = 1.d0
        do i = 1, na
          ia = natm(i)
          ib = ibf(i)
          do i1 = ib, ib + nbf(i) - 1
!	    **** contribution from atomic charges ****
            nm = matind(i1) + i1
            dm(nm, 1) = -x(i)
            dm(nm, 2) = -y(i)
            dm(nm, 3) = -z(i)
           end do

          if (nbf(i) > 1 .and. ndtype == 1) then
!	    **** include one - centre hybridization terms ****

!	    **** sp polarization term ****
            j2 = 2*nprn(ib) + 1
            amu = zeta(ia)
            sp = -au2ang * j2 / amu / two / sqrt3
            if (nbf(i) > 4) then
!	      **** pd polarization term ****
              j3 = j2 - 2
              k3 = j2
              pd = 0.d0
              do iss = 1, 2
                bmu = zetad(iss, ia)
                t = dsqrt ((two*amu)**j2 * (two*bmu)**j3 /&
     &             (fact(j2)*fact(j3)*5.d0) ) * fact(k3) / (amu + bmu)**k3
                pd = pd + t * zetawt(iss, ia)
              end do
            end if

            do mu = ib + 1, ib + nbf(i) - 1
              do nu = ib, mu - 1
                nm = matind(mu) + nu
                if (nbt(nu) == 0) then
!		  **** store any sp terms ****
                  if (nbt(mu) == 1) then
                    dm(nm, 1) = sp
                  else if (nbt(mu) == 2) then
                    dm(nm, 2) = sp
                  else if (nbt(mu) == 3) then
                    dm(nm, 3) = sp
                  end if
                else if (nbt(nu) <= 3 .and. nbt(mu) > 3) then
!		  **** pd polarization terms ****
                  mmmm = nbt(nu) + 3*(nbt(mu) - 4)
      go to (1302, 1304, 1306, 1308, 1310, 1800, 1312, 1308, 1800, 1314, &
     & 1800, 1308, 1800, 1314, 1312), mmmm
 1302 dm(nm, 1) = au2ang*pd/sqrt3
      go to 1800
 1304 dm(nm, 2) = au2ang*pd/sqrt3
      go to 1800
 1306 dm(nm, 3) = -au2ang*pd*two/sqrt3
      go to 1800
 1308 dm(nm, 1) = -au2ang*pd
      go to 1800
 1310 dm(nm, 2) = au2ang*pd
      go to 1800
 1312 dm(nm, 2) = -au2ang*pd
      go to 1800
 1314 dm(nm, 3) = -au2ang*pd
      go to 1800

 1800       continue
                end if
              end do
            end do

          end if
        end do
      else if (ndtype == 2) then
!	**** dipole velocity eqns of Hush and Williams CPL 8 (1971) 179 ****
!	**** but note their last two eqns for Iz must be mult by two ****
!	**** only p - p integrals hence only programmed for PPP calc ****
!	**** mx, my, mz are imaginary and have units of Angstrom** - 1 ****
!	**** works only for 2nd row elements			   ****
!	**** Integrals are actually IMAGINARY			   ****

        dipsym = -1.d0
        nm = 0
        do jb = 1, n
          ja = iat(jb)
          jnat = natm(ja)
!	  **** zeta is in bohr, convert to Ang** - 1 ****
          zj = zeta(jnat) / au2ang

          do kb = 1, jb
            nm = nm + 1
            if (jb /= kb) then
              ka = iat(kb)
              knat = natm(ka)
              zk = zeta(knat) / au2ang

              delx = x(ka) - x(ja)
              dely = y(ka) - y(ja)
              delz = z(ka) - z(ja)
              r = sqrt (delx**2 + dely**2 + delz**2)
              al = 0.5d0 * r * (zk + zj)
              if (abs(zk - zj) > 1.d-10) then
!	        **** different atom types ****
                am = 0.5d0 * r * (zk - zj)
                aaa = -32.d0 / (r/2.d0)**4 * &
     &            (zk*zj)**3 * sqrt (zk*zj) / (zk**2 - zj**2)**5 *&
     &            (3.d0 + 3.d0*al + al**2) *&
     &            (exp(- zk*r)*(3.d0 + 3.d0*am + am**2) - &
     &             exp(- zj*r)*(3.d0 - 3.d0*am + am**2) )
              else
!	        **** same type of atom (Chong formula) ****
                aaa = -zk * al/15.d0 * exp(- al) * (3.d0 + 3.d0*al + al**2)
              end if
              aaa = aaa / r
              dm(nm, 1) = aaa * delx
              dm(nm, 2) = aaa * dely
              dm(nm, 3) = aaa * delz
            end if
          end do
        end do

      else if (ndtype == 3) then

!	**** Magnetic transition moments, IMAGINARY ****

        dipsym = -1.d0
        do i = 1, na
          if (nbf(i) /= 1) then
!	    **** include p - p one - centre hybridization terms ****
            ib = ibf(i)
            dm(matind(ib + 3) + ib + 2, 1) =  bohrmg
            dm(matind(ib + 3) + ib + 1, 2) = -bohrmg
            dm(matind(ib + 2) + ib + 1, 3) =  bohrmg
          end if
        end do

      end if

      return
      end subroutine dipol

!     *************************************************************************

      subroutine efmods (beta, zcore, dm)
      use reimers_c, only : n, na, nb2, matind, ibf, vnn, ef

      implicit none
      double precision ::   dm(nb2, 3), zcore(na), beta(nb2), ecoref
      integer ::            i, mu, nm, nu


!     **** Electric field effect on core energies and 1 el operators ****
!     **** using the definition: Energy = -F * sum RiQi ****
!     **** U(i) = -beta(i, i) = -electron_charge * (- F.r) = -F.r ****
!     **** beta(i, j) = electron_charge * (- F<s|x|px>) ****

!     **** mods to one - electron integrals ****
      nm = 0
      do mu = 1, n
        do nu = 1, mu
          nm = nm + 1
          beta(nm) = beta(nm) - (ef(1)*dm(nm, 1) + ef(2)*dm(nm, 2) + &
     &                          ef(3)*dm(nm, 3) )
        end do
      end do

!     **** nuclear interaction ****
      ecoref = 0.d0
      do i = 1, na
        mu = ibf(i)
        nm = matind(mu) + mu
        ecoref = ecoref + zcore(i) * (ef(1)*dm(nm, 1) + ef(2)*dm(nm, 2) + &
     &                               ef(3)*dm(nm, 3))
      end do
      vnn = vnn + ecoref
      return
      end subroutine efmods

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine getval(line, x, t)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision , intent(out) :: x
      character  :: line*80
      character , intent(out) :: t*12
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i
      character :: ch1, ch2
      double precision, external :: reada
!-----------------------------------------------
      ch1 = line(1:1)
      ch2 = line(2:2)
      if ((ichar(ch1)<ichar('A') .or. ichar(ch1)>ichar('Z')) .and. (ichar(ch2)<&
        ichar('A') .or. ichar(ch2)>ichar('Z'))) then
!
!   IS A NUMBER
!
        x = reada(line,1)
        t = ' '
      else
        i = index(line,' ')
        t = line(:i)
        x = -999.D0
      end if
      return
      end subroutine getval

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine newflg ()
    use molkst_C, only: natoms, numat, nvar
    use common_arrays_C, only : coord, geo, txtatm, na, nb, nc, loc, xparam
    use chanel_C, only: iw
    implicit none
    integer :: i, j, k
!
    if (numat /= natoms) then
      write (iw,*) " NEWGEO CAN ONLY BE USED IF THERE ARE NO DUMMY ATOMS,", &
     & " OR IF 'RESEQ' IS USED"
      call mopend ("NEWGEO cannot be used here")
    end if
!
!    Force all coordinates to be internal
!
    call xyzint (coord, numat, na, nb, nc, 1.D0, geo)
!
!  Convert coordinates to Cartesian
!
    call gmetry(geo, coord)
    k = 0
    do i = 1, numat
      if (txtatm(i)(:6) /= "ATOM  ") cycle
      if (txtatm(i)(13:15) /= " N " .and. txtatm(i)(13:15) /= " C ") cycle
!
!  CONVERT ATOM COORDINATES FROM INTERNAL TO CARTESIAN
!
      na(i) = 0
      nb(i) = 0
      nc(i) = 0
      do j = 1, 3
        geo(j, i) = coord(j, i)
      end do
      k = 1
    end do
    do i = 1, nvar
      xparam(i) = geo(loc(2, i), loc(1, i))
    end do
    if (k == 0) call mopend("KEYWORD ""NEWGEO"" USED, BUT NO BACKBONE ATOMS IDENTIFIED")
    return
end subroutine newflg

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

subroutine rotcel (t2, isize, jsize, t1)
  implicit none
  integer, intent(in) :: isize, jsize
  double precision, dimension(9,9), intent(inout) :: t2
  double precision, dimension(9,9), intent(in) :: t1
  integer :: i, j, k, k2, l, l2
  double precision :: sum
  double precision, dimension(isize,jsize) :: work 
  do i = 1, jsize
    do j = 1, isize
      sum = 0.d0
      k2 = 0
      do k = 1, isize
        k2 = k2 + 1
        l2 = 0
        do l = 1, jsize
          l2 = l2 + 1
          sum = sum + t1(l2, i)*t2(k, l)*t1(k2, j)
        end do
      end do
      work(j, i) = sum
    end do
  end do
  do i = 1, isize
    do j = 1, jsize
      t2(i, j) = work(i, j)
    end do
  end do
end subroutine rotcel

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

module common_elemts
    implicit none
    character (len=2), dimension (107) :: elemnt
        data elemnt / " H", "He", "Li", "Be", " B", " C", " N", " O", " F", "Ne", &
         &"Na", "Mg", "Al", "Si", " P", " S", "Cl", "Ar", " K", "Ca", "Sc", &
         &"Ti", " V", "Cr", "Mn", "Fe", "Co", "Ni", "Cu", "Zn", "Ga", "Ge", &
         &"As", "Se", "Br", "Kr", "Rb", "Sr", " Y", "Zr", "Nb", "Mo", "Tc", &
         &"Ru", "Rh", "Pd", "Ag", "Cd", "In", "Sn", "Sb", "Te", " I", "Xe", &
         &"Cs", "Ba", "La", "Ce", "Pr", "Nd", "Pm", "Sm", "Eu", "Gd", "Tb", &
         &"Dy", "Ho", "Er", "Tm", "Yb", "Lu", "Hf", "Ta", " W", "Re", "Os", &
         &"Ir", "Pt", "Au", "Hg", "Tl", "Pb", "Bi", "Po", "At", "Rn", "Fr", &
         &"Ra", "Ac", "Th", "Pa", " U", "Np", "Pu", "Am", "Cm", "Bk", "Cf", &
         &"XX", "Fm", "Md", "Cb", "++", " +", "--", " -", "Tv" /
end module common_elemts

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine wrtkey
  use molkst_C, only : moperr, allkey, keywrd
  implicit none
  integer :: i, j, k, l
  integer, parameter :: n_protected_keywords = 14
  character :: protected_keywords(n_protected_keywords)*10
  data protected_keywords /"SITE=", "C.I.=", "I.D.=", "METAL=", "POLAR=", &
       "POLAR(", "PDB(", "OPEN(", "OPT(", "LARGE=", "EXTERNAL=", &
       "C.A.S.=", "C.I.D.=", "C.I.="/
!**********************************************************************
!
!  WRTKEY CHECKS ALL KEY-WORDS AND PRINTS THOSE IT RECOGNIZES.  IF IT
!  FINDS A WORD IT DOES NOT RECOGNIZE THE PROGRAM WILL BE STOPPED.
!
!**********************************************************************
!
!   Write out the control keywords. First, tidy up: delete equals signs and quotation marks,
!   and make sure there is a space at the start of the line.
!
!  Do not tidy up allkey earlier in the job, instead fill allkey here from keywrd,
!  and do all the tidying up at this one point.  The old style of tidying up allkey
!  as the job progressed was very error-prone and hard to debug.
!
  allkey = trim(keywrd)
  j = 1
  do
!
! Delete equals sign and everything after it that belongs to it
!
    i = index(allkey(j:), "=") + j
    if (i /= j) then
      if (allkey(i:i) == "(") then
        j = index(allkey(i + 1:), ') ') + i
      else if (allkey(i:i) == '"') then
        j = index(allkey(i + 1:), '"') + i
      else
        j = j + 1
        cycle
      end if
      allkey(i - 1:j) = " "
      j = i
    else
      do
        i = index(allkey, "(")
        if (i == 0) exit
        if (i > 6) then
          if (allkey(i-6:i) == "OUTPUT(") exit
        end if
        j = index(allkey(i + 1:), ')') + i
        allkey(i:j) = " "
      end do
      exit
    end if
  end do
  j=1
  do
    i = index(allkey(j:), '"') + j
    if (i /= j) then
      j = index(allkey(i + 1:), '"') + i
      allkey(i - 1:j) = " "
      j = j + 1
    else
      exit
    end if
  end do
!
!  Special treatment for keywords that must not be modified because they contain data that is
!  printed in the output.
!
  do k = 1, n_protected_keywords
    j = 1
    do
      i = index(keywrd(j:), " "//trim(protected_keywords(k))) + j
      if (i == j) exit
      j = index(keywrd(i:), ") ")
      l = index(keywrd(i:), '" ')
      if (j > 0 .and. l > 0) then
        j = min(j,l)
      else if (l > 0) then
        j = l
      end if
      j = j + i
      allkey(i - 1:j) = keywrd(i - 1:j)
    end do
  end do
!
! Now print out everything to do with keywords, starting with control keywords
!
  call wrtcon (allkey)
  if (moperr) return
!
!   Write out the keywords controlling the working
!
  call wrtwor (allkey)
!
!   Write out the keywords controlling the output
!
  call wrtout (allkey)
!
!   Check the keywords to see if two or more conflict
!
  call wrtchk (allkey)
end subroutine wrtkey



subroutine wrtchk (allkey)
  use molkst_C, only: keywrd, is_PARAM, uhf, method_mndo, method_am1, &
  method_pm3, method_mndod, method_pm6, method_rm1, rhf, mozyme, line, &
  method_pm7, method_pm6_org, method_pm8, method_indo, koment, title, refkey
  use chanel_C, only: iw, input_fn
  implicit none
  logical :: birad, exci, ci, trip
  integer :: i, j, k, l, nmos
  character :: ch
  character (len=3000), intent (inout) :: allkey
  logical, external :: myword
  double precision, external :: reada
  birad = (Index (keywrd, " BIRAD") /= 0)
  exci  = (Index (keywrd, " EXCI") /= 0)
  ci    = (Index (keywrd, " C.I.") /= 0)
  trip  = (Index (keywrd, " TRIP") /= 0)
  uhf   = (Index (keywrd, " UHF") /= 0)
  rhf   = (Index (keywrd, " RHF") + index(keywrd, " MECI") /= 0  &
    .or. ci .or. (.not. uhf .and. Index(keywrd, " OPEN") /= 0))
  if (.not. (birad .or. exci .or. ci .or. (Index (keywrd, " INDO") /= 0) .or. (index(keywrd, " OPEN") /= 0))) then
    if ((index(keywrd, " MECI") /= 0) .or. (index(keywrd, " CIS") /= 0)) then
      if (index(keywrd, " CIS ") /= 0) call mopend("Keyword ""CIS"" used, but no C.I. defined")
      if (index(keywrd, " CISD ") /= 0) call mopend("Keyword ""CISD"" used, but no C.I. defined")
      if (index(keywrd, " CISDT ") /= 0) call mopend("Keyword ""CISDT"" used, but no C.I. defined")
      if ((index(keywrd, " MECI") /= 0)) call mopend("Keyword ""MECI"" used, but no C.I. defined")
      write(iw,'(/10x,a)')"Keyword ""C.I."" or ""OPEN"" must be present for the other C.I. keywords to be used"
      return
    end if
  end if
  if (.not. (mozyme .or. (index(keywrd," PDBOUT") + index(keywrd," RESID") + index(keywrd," ADD-H")/= 0)) &
    .and. index(keywrd, " 0SCF") == 0) then
!
! Check for keywords that require MOZYME to be present
!
    if (index(keywrd," PDBOUT") /= 0) then
      call mopend("Keyword PDBOUT only works when MOZYME or 0SCF is also present")
      return
    end if
    if (index(keywrd," RESID") /= 0) then
      call mopend("Keyword RESIDUES only works when MOZYME or 0SCF is also present")
      return
    end if
    if (index(keywrd," CVB") /= 0) then
      call mopend("Keyword CVB only works with MOZYME")
      return
    end if
    if (index(keywrd," SETPI") /= 0) then
      call mopend("Keyword SETPI only works with MOZYME ")
      return
    end if
  end if
  if (mozyme) then
    if (index(keywrd, " UHF") /= 0) then
      call mopend("Keyword UHF cannot be used with MOZYME")
    end if
    if (index(keywrd, " ENPART") /= 0)  then
      call mopend("Keyword ENPART is not available with MOZYME")
    end if
    if (index(keywrd, " LOCAL") /= 0)  then
      call mopend("Keyword LOCAL is not available with MOZYME")
    end if
    if (index(keywrd," RE-LOC") /= 0) then
      i = index(keywrd," RE-LOC")
      j = index(keywrd(i + 7:), " ") + i + 7
      if (index(keywrd(i:j), "=")  + index(keywrd," DENOUT") + &
        index(keywrd," VEC") + index(keywrd," ALLVE") == 0) then
        call mopend("Keyword RE-LOC only has meaning if DENOUT or VECTORS or ALLVEC is present")
      end if
      if (index(keywrd, "BANANA") /= 0) &
        call mopend("Keyword BANANA only works with keyword LOCAL, i.e. NOT with MOZYME")
      if (index(keywrd, "RABBIT") /= 0) &
        call mopend("Keyword RABBIT only works with keyword LOCAL, i.e. NOT with MOZYME")
    end if
    if (index(keywrd," 1SCF") /= 0 .and. index(keywrd," RAPID") /= 0) then
      call mopend("RAPID cannot be used with 1SCF")
      return
    end if
  end if
!
!   MULLIK does not work with UHF
!
  if (Index (keywrd, " MULLIK") /= 0 ) then
    if (uhf) then
      call mopend ("MULLIKEN POPULATION NOT AVAILABLE WITH UHF")
      return
    end if
  end if
!
!   Check UHF with nonallowed keywords
!
  if (uhf) then
    if (rhf) then
      call mopend("UHF and RHF cannot both be used")
    end if
    if (birad .or. exci .or. ci) then
      write (iw, "(//10X, ' UHF USED WITH EITHER BIRAD, EXCITED OR C.I. ')")
      write (iw, '(/ / 10 x, " IMPOSSIBLE OPTION REQUESTED,")')
      go to 1020
!
!  POLAR and UHF do not work
!
    else if (Index (keywrd, " POLAR") /= 0) then
      call mopend("POLAR does not work with UHF")
      go to 1020
    end if
  else if (exci .and. trip) then
    write (iw, "(//10X,' EXCITED USED WITH TRIPLET')")
    write (iw, 10000)
    go to 1020
  end if
!
!   PMEP only works with AM1
!
  if (Index (keywrd, " PMEP") /= 0 ) then
    if (.not. method_am1) then
      write (iw, "(A)") " PMEP only works with AM1"
      call mopend ("PMEP only works with AM1")
      return
    end if
  end if
!
!  XYZ and INT cannot simultaneously be present
!
  if (Index (keywrd, " INT ") /= 0 .and. Index (keywrd, " XYZ") /= 0) then
    call mopend ("INT cannot be used with XYZ")
  end if
!
!   Check T-PRIO MUST have DRC
!
  if (Index (keywrd, " T-PRIO") /= 0 .and. Index (keywrd, " DRC") == 0) then
    write (iw, "(//10X,'T-PRIO AND NO DRC')")
    write (iw, 10000)
    go to 1020
  end if
!
!   Check that only one method is used
!
    i = 0
    if (method_am1)     i = i + 1
    if (method_pm3)     i = i + 1
    if (method_pm6)     i = i + 1
    if (method_pm7)     i = i + 1
    if (method_PM8)     i = i + 1
    if (method_mndo)    i = i + 1
    if (method_mndod)   i = i + 1
    if (method_rm1)     i = i + 1
    if (method_indo)    i = i + 1
    if (i > 1) then
      write (iw, '(//10 x, " ONLY ONE OF MNDO, MNDOD, AM1, PM3, RM1, PM6, PM7, PM8, AND INDO ALLOWED")')
10000 format(/ / 10 x, "IMPOSSIBLE OPTION REQUESTED")
      call mopend("IMPOSSIBLE OPTION REQUESTED")
      return
    end if
      !
      !   Check that only one geometry option is used
      !
    i = 0
    line = trim(keywrd)
    j = 0
    l = len_trim(line)
    do
      j = j + 1
      if (j > l) exit
      if (line(j:j) == '"') then
        k = j
        do
          j = j + 1
          if (j > l) exit
          if (line(j:j) == '"') exit
        end do
        line(k:j) = " "
      end if
      if (j >= l) exit
    end do
    if (Index (line, " BFGS") /= 0)    i = i + 1
    if (Index (line, " LBFGS") /= 0)   i = i + 1
    if (Index (line, " EF") /= 0)      i = i + 1
    if (Index (line, " TS") /= 0)      i = i + 1
    if (Index (line, " SIGMA") /= 0)   i = i + 1
    if (Index (line, " NLLSQ") /= 0)   i = i + 1
    if (Index (line, " FORCE") + Index (line, " IRC") + Index (line, " DRC") /= 0)   i = i + 1
    if (i > 1) then
      call mopend ("MORE THAN ONE GEOMETRY OPTION HAS BEEN" // &
      & " SPECIFIED. CONFLICT MUST BE RESOLVED BEFORE JOB WILL RUN.")
      return
    end if
    if (Index (keywrd, " HESSIAN") /= 0) then
      if (Index (keywrd, " EF") == 0) then
        call mopend(" Keyword EF must be present if HESSIAN is used")
        return
      end if
    end if
    if (Index (keywrd, " PKA") /= 0 .and. .not. method_pm6) then
      write(iw,"(a)")" *"," *  The pKa option only works with PM6."
      write(iw,"(a)")" *  Either remove keyword pKa or change method to PM6."," *"
      call mopend("The pKa option only works with PM6. Calculation abandoned.")
        return
    end if
    if (Index(keywrd, " C.I.=") /= 0) then
      j = Index (keywrd, " C.I.=(")
      if (j /= 0) then
        nmos = Nint (reada (keywrd, Index (keywrd, "C.I.=(")+5))
      else
        nmos = Int (reada (keywrd, Index (keywrd, "C.I.")+4))
      end if
      if (nmos > 29 .and. .not. method_indo) then
        write (iw, "(' *',/,a)") " *      Maximum size of open space = 29 M.O.s"
        write (iw, "(a, i3,/,' *')") " *      Size requested:", nmos
        call mopend("Maximum size of open space = 29 M.O.s")
        return
      else if (nmos < 1) then
        write (iw, "(' *',/,a)") " *      Minimum size of open space = 1 M.O.s"
        write (iw, "(a, i3,/,' *')") " *      Size requested:", nmos
        call mopend("Minimum size of open space = 1 M.O.s")
        return
      end if
    end if
! INDO keywords incompatible with non-INDO methods
    if (.not. method_indo) then
      if (Index (keywrd, " C.I.D.") /= 0) then
        write (6,*) "C.I.D. is only compatible with INDO"
        call mopend("C.I.D. is only compatible with INDO")
        return
      end if
      if (Index (keywrd, " C.A.S.") /= 0) then
        write (6,*) "C.A.S. is only compatible with INDO"
        call mopend("C.A.S. is only compatible with INDO")
        return
      end if
      if (Index (keywrd, " MRCI") /= 0) then
        write (6,*) "MRCI is only compatible with INDO"
        call mopend("MRCI is only compatible with INDO")
        return
      end if
      if (Index (keywrd, " MAXCI") /= 0) then
        write (6,*) "MAXCI is only compatible with INDO"
        call mopend("MAXCI is only compatible with INDO")
        return
      end if
      if (Index (keywrd, " WRTCI") /= 0) then
        write (6,*) "WRTCI is only compatible with INDO"
        call mopend("WRTCI is only compatible with INDO")
        return
      end if
      if (Index (keywrd, " TDIP") /= 0) then
        write (6,*) "TDIP is only compatible with INDO"
        call mopend("TDIP is only compatible with INDO")
        return
      end if
      if (Index (keywrd, " WRTCONF") /= 0) then
        write (6,*) "WRTCONF is only compatible with INDO"
        call mopend("WRTCONF is only compatible with INDO")
        return
      end if
! INDO incompatible with many standard MOPAC keywords
    else
! Incompatible CI options
      if (Index (keywrd, " CIS ") /= 0 .and. Index (keywrd, " CISD ") /= 0) then
        write (6,*) "CIS and CISD are incompatible keywords"
        call mopend("CIS and CISD are incompatible keywords")
        return
      end if
      if (Index (keywrd, " CIS ") /= 0 .and. Index (keywrd, " C.I.D.") /= 0) then
        write (6,*) "CIS and C.I.D. are incompatible keywords"
        call mopend("CIS and C.I.D. are incompatible keywords")
        return
      end if
! Too high spin
      if (Index (keywrd, " QUIN") /= 0 .or. Index (keywrd, " SEXT") /= 0 .or. &
          Index (keywrd, " SEPT") /= 0 .or. Index (keywrd, " OCTE") /= 0 .or. &
          Index (keywrd, " NONE") /= 0) then
        write (6,*) "Spin is incompatible with INDO"
        call mopend("Spin is incompatible with INDO")
        return
      end if

! Keywords in wrtcon - exit if a bad combination specified
      if (Index (keywrd, " FORCE") /= 0) then
        write (6,*) "FORCE is incompatible with INDO"
        call mopend("FORCE is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " LOCATE_TS") /= 0) then
        write (6,*) "LOCATE_TS is incompatible with INDO"
        call mopend("LOCATE_TS is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " MOZ") /= 0) then
        write (6,*) "MOZYME is incompatible with INDO"
        call mopend("MOZYME is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " LEWIS") /= 0) then
        write (6,*) "LEWIS is incompatible with INDO"
        call mopend("LEWIS is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " RESEQ") /= 0) then
        write (6,*) "RESEQ is incompatible with INDO"
        call mopend("RESEQ is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " CHARGES") /= 0) then
        write (6,*) "CHARGES is incompatible with INDO"
        call mopend("CHARGES is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " RAPID") /= 0) then
        write (6,*) "RAPID is incompatible with INDO"
        call mopend("RAPID is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " SITE") /= 0) then
        write (6,*) "SITE is incompatible with INDO"
        call mopend("SITE is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " PDBOUT") /= 0) then
        write (6,*) "PDBOUT is incompatible with INDO"
        call mopend("PDBOUT is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " QMMM") /= 0) then
        write (6,*) "QMMM is incompatible with INDO"
        call mopend("QMMM is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " COMPAR") /= 0) then
        write (6,*) "COMPAR is incompatible with INDO"
        call mopend("COMPAR is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " BZ") /= 0) then
        write (6,*) "BZ is incompatible with INDO"
        call mopend("BZ is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " EXCI") /= 0) then
        write (6,*) "EXCI is incompatible with INDO"
        call mopend("EXCI is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " VELO") /= 0) then
        write (6,*) "VELO is incompatible with INDO"
        call mopend("VELO is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " ESR") /= 0) then
        write (6,*) "ESR is incompatible with INDO"
        call mopend("ESR is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " NOMM") /= 0) then
        write (6,*) "NOMM is incompatible with INDO"
        call mopend("NOMM is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " MMOK") /= 0) then
        write (6,*) "MMOK is incompatible with INDO"
        call mopend("MMOK is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " CISDT") /= 0) then
        write (6,*) "CISDT is incompatible with INDO"
        call mopend("CISDT is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " COSCCH") /= 0) then
        write (6,*) "COSCCH is incompatible with INDO"
        call mopend("COSCCH is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " INVERT") /= 0) then
        write (6,*) "INVERT is incompatible with INDO"
        call mopend("INVERT is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " ESP") /= 0) then
        write (6,*) "ESP is incompatible with INDO"
        call mopend("ESP is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " NSURF") /= 0) then
        write (6,*) "NSURF is incompatible with INDO"
        call mopend("NSURF is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " SCINCR") /= 0) then
        write (6,*) "SCINCR is incompatible with INDO"
        call mopend("SCINCR is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " SLOPE") /= 0) then
        write (6,*) "SLOPE is incompatible with INDO"
        call mopend("SLOPE is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " PDBOUT") /= 0) then
        write (6,*) "PDBOUT is incompatible with INDO"
        call mopend("PDBOUT is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " NOTER") /= 0) then
        write (6,*) "NOTER is incompatible with INDO"
        call mopend("NOTER is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " XENO") /= 0) then
        write (6,*) "XENO is incompatible with INDO"
        call mopend("XENO is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " CHAINS") /= 0) then
        write (6,*) "CHAINS is incompatible with INDO"
        call mopend("CHAINS is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " SETPI") /= 0) then
        write (6,*) "SETPI is incompatible with INDO"
        call mopend("SETPI is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " PINOUT") /= 0) then
        write (6,*) "PINOUT is incompatible with INDO"
        call mopend("PINOUT is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " REORTH") /= 0) then
        write (6,*) "REORTH is incompatible with INDO"
        call mopend("REORTH is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " RE-LOCAL") /= 0) then
        write (6,*) "RE-LOCAL is incompatible with INDO"
        call mopend("RE-LOCAL is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " ADD_H") /= 0) then
        write (6,*) "ADD_H is incompatible with INDO"
        call mopend("ADD_H is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " CONNOL") /= 0) then
        write (6,*) "CONNOL is incompatible with INDO"
        call mopend("CONNOL is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " ESPRST") /= 0) then
        write (6,*) "ESPRST is incompatible with INDO"
        call mopend("ESPRST is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " UHF") /= 0) then
        write (6,*) "UHF is incompatible with INDO"
        call mopend("UHF is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " STATIC") /= 0) then
        write (6,*) "STATIC is incompatible with INDO"
        call mopend("STATIC is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " POLAR") /= 0) then
        write (6,*) "POLAR is incompatible with INDO"
        call mopend("POLAR is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " RESI") /= 0) then
        write (6,*) "RESI is incompatible with INDO"
        call mopend("RESI is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " NOOPT") /= 0) then
        write (6,*) "NOOPT is incompatible with INDO"
        call mopend("NOOPT is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " OPT") /= 0) then
        write (6,*) "OPT is incompatible with INDO"
        call mopend("OPT is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " P=") /= 0) then
        write (6,*) "P= is incompatible with INDO"
        call mopend("P= is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " CUBE") /= 0) then
        write (6,*) "CUBE is incompatible with INDO"
        call mopend("CUBE is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " ESPGRID") /= 0) then
        write (6,*) "ESPGRID is incompatible with INDO"
        call mopend("ESPGRID is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " MICROS") /= 0) then
        write (6,*) "MICROS is incompatible with INDO"
        call mopend("MICROS is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " OPEN") /= 0) then
        write (6,*) "OPEN is incompatible with INDO"
        call mopend("OPEN is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " MS=") /= 0) then
        write (6,*) "MS= is incompatible with INDO"
        call mopend("MS= is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " ROOT") /= 0) then
        write (6,*) "ROOT is incompatible with INDO"
        call mopend("ROOT is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " STEP") /= 0) then
        write (6,*) "STEP is incompatible with INDO"
        call mopend("STEP is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " MERS") /= 0) then
        write (6,*) "MERS is incompatible with INDO"
        call mopend("MERS is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " POINT") /= 0) then
        write (6,*) "POINT is incompatible with INDO"
        call mopend("POINT is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " IRC") /= 0) then
        write (6,*) "IRC is incompatible with INDO"
        call mopend("IRC is incompatible with INDO")
        return
      end if
      if (Index (keywrd, " DRC") /= 0) then
        write (6,*) "DRC is incompatible with INDO"
        call mopend("DRC is incompatible with INDO")
        return
      end if

! Keywords in wrtout - print a warning but let the calculation proceed
      i = 0
      if (Index (keywrd, " AUX")      /= 0) i = i + 1
      if (Index (keywrd, " OUTPUT")   /= 0) i = i + 1
      if (Index (keywrd, " NOCOM")    /= 0) i = i + 1
      if (Index (keywrd, " ISOTOPE")  /= 0) i = i + 1
      if (Index (keywrd, " DENOUT")   /= 0) i = i + 1
      if (Index (keywrd, " OLDENS")   /= 0) i = i + 1
      if (Index (keywrd, " CIOSCI")   /= 0) i = i + 1
      if (Index (keywrd, " ENPART")   /= 0) i = i + 1
      if (Index (keywrd, " GRAD")     /= 0) i = i + 1
      if (Index (keywrd, " MINI")     /= 0) i = i + 1
      if (Index (keywrd, " VEC")      /= 0) i = i + 1
      if (Index (keywrd, " EIGEN")    /= 0) i = i + 1
      if (Index (keywrd, " CARTAB")   /= 0) i = i + 1
      if (Index (keywrd, " CHARST")   /= 0) i = i + 1
      if (Index (keywrd, " DCART")    /= 0) i = i + 1
      if (Index (keywrd, " DERI1")    /= 0) i = i + 1
      if (Index (keywrd, " DERI2")    /= 0) i = i + 1
      if (Index (keywrd, " DERITR")   /= 0) i = i + 1
      if (Index (keywrd, " DERIV")    /= 0) i = i + 1
      if (Index (keywrd, " DERIVO")   /= 0) i = i + 1
      if (Index (keywrd, " MAKVEC")   /= 0) i = i + 1
      if (Index (keywrd, " DIIS")     /= 0) i = i + 1
      if (Index (keywrd, " FLEPO")    /= 0) i = i + 1
      if (Index (keywrd, " FMAT")     /= 0) i = i + 1
      if (Index (keywrd, " DFORCE")   /= 0) i = i + 1
      if (Index (keywrd, " HCORE")    /= 0) i = i + 1
      if (Index (keywrd, " FREQCY")   /= 0) i = i + 1
      if (Index (keywrd, " LINMIN")   /= 0) i = i + 1
      if (Index (keywrd, " RAMA")     /= 0) i = i + 1
      if (Index (keywrd, " SYMOIR")   /= 0) i = i + 1
      if (Index (keywrd, " GROUP")    /= 0) i = i + 1
      if (Index (keywrd, " SYMTRZ")   /= 0) i = i + 1
      if (Index (keywrd, " DENS")     /= 0) i = i + 1
      if (Index (keywrd, " SPIN")     /= 0) i = i + 1
      if (Index (keywrd, " PRNT")     /= 0) i = i + 1
      if (Index (keywrd, " DISP")     /= 0) i = i + 1
      if (Index (keywrd, " DEP")      /= 0) i = i + 1
      if (Index (keywrd, " BONDS")    /= 0) i = i + 1
      if (Index (keywrd, " ALLBO")    /= 0) i = i + 1
      if (Index (keywrd, " SYBYL")    /= 0) i = i + 1
      if (Index (keywrd, " FOCK")     /= 0) i = i + 1
      if (Index (keywrd, " LARGE")    /= 0) i = i + 1
      if (Index (keywrd, " HTML")     /= 0) i = i + 1
      if (Index (keywrd, " PDBOUT")   /= 0) i = i + 1
      if (Index (keywrd, " AIGOUT")   /= 0) i = i + 1
      if (Index (keywrd, " GRAP")     /= 0) i = i + 1
      if (Index (keywrd, " 1ELEC")    /= 0) i = i + 1
      if (Index (keywrd, " SUPER")    /= 0) i = i + 1
      if (Index (keywrd, " ALLVEC")   /= 0) i = i + 1
      if (Index (keywrd, " H-PRIO")   /= 0) i = i + 1
      if (Index (keywrd, " X-PRIO")   /= 0) i = i + 1
      if (Index (keywrd, " T-PRIO")   /= 0) i = i + 1
      if (Index (keywrd, " MECI")     /= 0) i = i + 1
      if (Index (keywrd, " HESSIAN")  /= 0) i = i + 1
      if (Index (keywrd, " LOCAL")    /= 0) i = i + 1
      if (Index (keywrd, " MULLIK")   /= 0) i = i + 1
      if (Index (keywrd, " PI")       /= 0) i = i + 1
      if (Index (keywrd, " POTWRT")   /= 0) i = i + 1
      if (Index (keywrd, " PMEP")     /= 0) i = i + 1
      if (Index (keywrd, " PRTMEP")   /= 0) i = i + 1
      if (Index (keywrd, " MINMEP")   /= 0) i = i + 1
      if (Index (keywrd, " PL")       /= 0) i = i + 1
      if (Index (keywrd, " PKA")      /= 0) i = i + 1
      if (Index (keywrd, " POPS")     /= 0) i = i + 1
      if (Index (keywrd, " BCC")      /= 0) i = i + 1
      if (Index (keywrd, " Z=")       /= 0) i = i + 1
      if (Index (keywrd, " HYPERF")   /= 0) i = i + 1
      if (Index (keywrd, " THERMO")   /= 0) i = i + 1
      if (Index (keywrd, " K=")       /= 0) i = i + 1
      if (i > 0) then
        write (6,*) "WARNING: Specified print options may not behave as expected with INDO"
        write (iw,*) "**********"
        write (iw,*) "*  WARNING: Specified print options may not behave as expected with INDO"
        write (iw,*) "**********"
      end if
    end if
       !******************************************************************
       !
       !  Check to see that all keywords have been recognized
       !
       !*******************************************************************
       !
       !    DUMMY IF STATEMENT TO REMOVE AMPERSAND, PLUS SIGNS AND OBSOLETE KEYWORDS, IF PRESENT
       !
      if (myword(allkey, " SETUP"))       i = 1
      if (myword(allkey, "&"))            i = 2
      if (myword(allkey, " +"))           i = 3
      if (myword(allkey, " CONTROL"))     i = 3
      if (myword(allkey, " DIIS"))    write (iw,'(" *  DIIS       - THIS IS AN OBSOLETE KEYWORD, IT WILL BE IGNORED")')
      if (myword(allkey, " NODIIS"))  write (iw,'(" *  NODIIS     - THIS IS AN OBSOLETE KEYWORD, IT WILL BE IGNORED")')
      if (myword(allkey, " ROT"))     write (iw,'(" *  ROT        - THIS IS AN OBSOLETE KEYWORD, IT WILL BE IGNORED")')
      if (myword(allkey, " HEADER") .or. myword(allkey, " USER"))  then
        write (iw,'(" *  HEADER     - DATA SET IS IN PROTEIN DATA BANK FORMAT")')
        i = index(keywrd, " HEADER")
        keywrd = " ADD-H PDBOUT "//keywrd(:i)
        refkey(1) = trim(keywrd)
        refkey(2) = " NULL "
        koment = " From PDB file: '"//input_fn(1:len_trim(input_fn)   - 5)//"'"
        title = "   "
        return
      end if

      if (allkey == " ") return
!
!  Compress unrecognized key-words
!
   if (allkey /= ' ' .and. .not. is_PARAM) then
        j = 0
        do i = 1, 3000 - 1
          if (allkey(i:i+1) == '  ') cycle
          j = j + 1
          ch = allkey(i:i)
          allkey(j:j) = ch
        end do
        j = max(1,j)
        l = index(keywrd,' DEBUG')
        if (l /= 0) then
          write (iw, '('' *  DEBUG KEYWORDS USED:  '',A)') allkey(2:j)
        else
          write (line, "('UNRECOGNIZED KEY-WORDS: (',A,')')") allkey (2:j)
          call to_screen(trim(line))
          call mopend (trim(line))
          call mopend ("IF THESE ARE DEBUG KEYWORDS, ADD THE KEYWORD ""DEBUG"".")
        end if
      return
    end if
1020 if (is_PARAM) return
  call mopend ("CALCULATION ABANDONED, SORRY!")
end subroutine wrtchk


subroutine wrtcon (allkey)
  use molkst_C, only: keywrd, keywrd_quoted, numat, pressure, id, mozyme, mers, natoms, maxtxt, txtmax, &
    line, old_chrge
  use cosmo_C, only : fepsi, nspa
  use chanel_C, only: iw, job_fn
  use meci_C, only : nmos
  use conref_C, only : fpcref
  use common_arrays_C, only :  lopt, na, txtatm
  implicit none
  character (len=3000), intent (out) :: allkey
  double precision :: epsi, sum
  integer :: i, ielec, ilevel, j, k, l
  logical :: l_add_H = .false., l_temp
  character :: num*1, num1*1
  character(len=300), external :: get_a_name
  integer, external :: quoted
  logical, external :: myword
  double precision, external :: reada
  save :: l_add_H
!
!  COSMO does not work with polymers or other infinite systems
!
  if (id > 0 .and. Index(keywrd, "EPS=") /= 0) call l_control("EPS=", len_trim("EPS="), -1)
!
  i = index(keywrd, " LOCATE_TS")
  if (i /= 0) keywrd(i:i + 9) = " LOCATE-TS"
  l_temp = (index(keywrd," MOZ") + index(keywrd," LEWIS") + index(keywrd," LOCATE-TS") + &
    index(keywrd, " RESEQ") + index(keywrd, " CHARGES") + &
    index(keywrd, " RAPID") + index(keywrd, " SITE=(") /= 0)
  mozyme = (l_temp .or. index(keywrd, " PDBOUT") /= 0)
  if (index(keywrd, "CHARGE=") == 0 .and. old_chrge /= 0 .and. index(keywrd, " OLDGEO") /= 0) then
!
!  Use the charge from the previous calculation
!
    i = index(keywrd,"           ")
    if (old_chrge > 99) then
      write(keywrd(i:i+11),'(" CHARGE=",i3)')old_chrge
    else if (old_chrge > 9) then
      write(keywrd(i:i+11),'(" CHARGE=",i2)')old_chrge
    else if (old_chrge > 0) then
      write(keywrd(i:i+11),'(" CHARGE=",i1)')old_chrge
    else if (old_chrge > -10) then
      write(keywrd(i:i+11),'(" CHARGE=",i2)')old_chrge
    else
      write(keywrd(i:i+11),'(" CHARGE=",i3)')old_chrge
    end if
   allkey(i:i+11) = keywrd(i:i+11)
  else
    old_chrge=0
  end if
  if (index(keywrd, " COMPAR") /= 0) &
    call l_control("0SCF HTML GEO-OK LET NOCOM", len_trim("0SCF HTML GEO-OK LET NOCOM"), -1)
  if (myword(allkey, " NEXT"))   write (iw, '(" *  NEXT       - DO NOT USE A BLANK LINE AFTER THE PREVIOUS JOB")')
  if (myword(allkey, " CCDC "))  i = 0 ! Dummy assignment   - to clear CCDC
  if (myword(allkey, " MNDO "))  write (iw, '(" *  MNDO       - The MNDO Hamiltonian to be used")')
  if (myword(allkey, " AM1 "))   write (iw, '(" *  AM1        - The AM1 Hamiltonian to be used")')
  if (myword(allkey, " PM3 "))   write (iw, '(" *  PM3        - The PM3 Hamiltonian to be used")')
  if (myword(allkey, " MNDOD"))  write (iw, '(" *  MNDOD      - The MNDOD Hamiltonian to be used")')
  if (myword(allkey, " PM6 "))   write (iw, '(" *  PM6        - The PM6 Hamiltonian to be used")')
  if (myword(allkey, " PM7-TS")) write (iw, '(" *  PM7-TS     - Calculate barrier height using PM7-TS")')
  if (myword(allkey, " PM7"))    write (iw, '(" *  PM7        - The PM7 Hamiltonian to be used")')
  if (myword(allkey, " PM6-ORG"))write (iw, '(" *  PM6-ORG    - The PM6-ORG Hamiltonian to be used (IN DEVELOPMENT)")')
  if (myword(allkey, " PM8"))    write (iw, '(" *  PM8        - The PM8 Hamiltonian to be used (IN DEVELOPMENT)")')
  if (myword(allkey, " SPARKL")) write (iw, '(" *  SPARKLE    - Use SPARKLES when they exist.")')
  if (myword(allkey, " RM1 "))   write (iw, '(" *  RM1        - The RM1 Hamiltonian to be used")')
  if (myword(allkey, " PM5 "))   write (iw, '(" *  PM5        - METHOD NOT SUPPORTED. DEFAULT METHOD USED INSTEAD (See above)")')
  if (myword(allkey, " INDO "))  write (iw, '(" *  INDO       - The INDO Hamiltonian to be used")')
  if (myword(allkey,' MRCI'))    write (iw, '(" *  MRCI       -  Use multi-reference CI (specify ref dets using C.A.S.)")')
  if (myword(allkey,' MAXCI='))  write (iw, '(" *  MAXCI =",i5," maximum CI states computed")') &
    nint(reada(keywrd,index(keywrd, ' MAXCI')))
  if (myword(allkey,' WRTCI='))  write (iw, '(" *  WRTCI =",i5," maximum CI states printed")') &
    nint(reada(keywrd,index(keywrd, ' WRTCI')))
  if (myword(allkey,' TDIP'))    write (iw, '(" *  TDIP       -  Print transition dipoles between excited states")')
  if (myword(allkey,'WRTCONF=')) &
    write (iw, '(" *  WRTCONF =",f8.4," - Print configurations with coefficients greater than cutoff")') &
    reada(keywrd,index(keywrd, ' WRTCONF'))
!
!  The lack of space before QMMM on the next line is deliberate   - at allows MOL_QMMM as an option
!
  if (myword(allkey, "QMMM "))   write (iw, '(" *  QMMM       - Generate energies and gradients for use in MM codes")')
  if (myword(allkey, " COMPAR")) write (iw, '(" *  COMPARE    - Compare two geometries")')
  if (myword(allkey, " BRZ"))    write (iw, '(" *  BRZ         - Write file <name>.brz for use by program BZ")')
  if (myword(allkey, " BIRAD"))  write (iw, '(" *  BIRADICAL  - SYSTEM HAS TWO UNPAIRED ELECTRONS")')
  if (myword(allkey, " EXCI"))   write (iw, '(" *  EXCITED    - FIRST EXCITED STATE IS TO BE OPTIMIZED")')
  if (myword(allkey, " VELO"))   write (iw, '(" *  VELOCITY   - INPUT STARTING VELOCITIES FOR DRC")')
  if (myword(allkey, " DIPO"))   write (iw, '(" *  DIPOLE     - PRINT DIPOLE INSTEAD OF ENERGY IN TRAJECTORIES")')
  if (myword(allkey, " GEO-OK")) write (iw, '(" *  GEO-OK     - OVERRIDE INTERATOMIC DISTANCE AND OTHER SAFETY CHECKS")')
  if (myword(allkey, " CHECK"))  write (iw, '(" *  CHECK      - RUN EXTRA INTERATOMIC DISTANCE CHECKS")')
  if (myword(allkey, " PM6-D")) then
    if (index(keywrd, "PM6-DH+") /= 0) then
      write (iw, '(" *  PM6-DH+    - CORRECT DISPERSION AND HYDROGEN BOND TERMS USING PM6-DH+")')
    elseif (index(keywrd, "PM6-DH2X") /= 0) then
      write (iw, '(" *  PM6-DH2X   - CORRECT DISPERSION, HALOGEN AND HYDROGEN BOND TERMS USING PM6-DH2X")')
    elseif (index(keywrd, "PM6-D2X") /= 0) then
      write (iw, '(" *  PM6-D2X    - CORRECT DISPERSION AND HALOGEN BOND TERMS USING PM6-D2X")')
    elseif (index(keywrd, "PM6-D3 ") /= 0) then
      write (iw, '(" *  PM6-D3     - CORRECT DISPERSION USING GRIMME''s D3 METHOD")')
    elseif (index(keywrd, "PM6-D3H4") /= 0) then
      write (iw, '(" *  PM6-D3H4   - CORRECT DISPERSION AND HYDROGEN BOND TERMS USING THE D3H4 METHOD")')
    elseif (index(keywrd, "PM6-D3(H4)") /= 0) then
      write (iw, '(" *  PM6-D3(H4) - CORRECT DISPERSION USING THE D3H4 METHOD")')
    elseif (index(keywrd, "PM6-DH2") /= 0) then
      write (iw, '(" *  PM6-DH2    - CORRECT DISPERSION AND HYDROGEN BOND TERMS USING PM6-DH2")')
    else
      write (iw, '(" *  PM6-D      - CORRECT DISPERSION TERMS USING PM6-D")')
    end if
  else if (myword(allkey, " PM6-H"))  then
    write (iw, '(" *  PM6-H      - CORRECT HYDROGEN BOND TERMS USING PM6-H")')
  end if
  if (myword(allkey, " JCTC")) i = 6
  if (myword(allkey, " AIGIN"))  write (iw, '(" *  AIGIN      - GEOMETRY MUST BE IN GAUSSIAN FORMAT")')
  if (myword(allkey, " ESR"))    write (iw, '(" *  ESR        - RHF SPIN DENSITY CALCULATION REQUESTED")')
  if (myword(allkey, " NOMM"))   write (iw, '(" *  NOMM       - DO NOT MAKE MM CORRECTION TO CONH BARRIER")')
  if (myword(allkey, " MMOK"))   write (iw, '(" *  MMOK       - APPLY MM CORRECTION TO CONH BARRIER")')
  if (myword(allkey, " CIS "))   write (iw, '(" *  CIS        - C.I. USES 1 ELECTRON EXCITATIONS ONLY")')
  if (myword(allkey, " CISD "))  write (iw, '(" *  CISD       - C.I. USES 1 AND 2 ELECTRON EXCITATIONS")')
  if (myword(allkey, " CISDT ")) write (iw, '(" *  CISDT      - C.I. USES 1, 2 AND 3 ELECTRON EXCITATIONS")')
  if (myword(allkey, " SING"))   write (iw, '(" *  SINGLET    - SPIN STATE DEFINED AS A SINGLET")')
  if (myword(allkey, " DOUB"))   write (iw, '(" *  DOUBLET    - SPIN STATE DEFINED AS A DOUBLET")')
  if (myword(allkey, " TRIP"))   write (iw, '(" *  TRIPLET    - SPIN STATE DEFINED AS A TRIPLET")')
  if (myword(allkey, " QUAR"))   write (iw, '(" *  QUARTET    - SPIN STATE DEFINED AS A QUARTET")')
  if (myword(allkey, " QUIN"))   write (iw, '(" *  QUINTET    - SPIN STATE DEFINED AS A QUINTET")')
  if (myword(allkey, " SEXT"))   write (iw, '(" *  SEXTET     - SPIN STATE DEFINED AS A SEXTET")')
  if (myword(allkey, " SEPT"))   write (iw, '(" *  SEPTET     - SPIN STATE DEFINED AS A SEPTET")')
  if (myword(allkey, " OCTE"))   write (iw, '(" *  OCTET      - SPIN STATE DEFINED AS A OCTET")')
  if (myword(allkey, " NONE"))   write (iw, '(" *  NONET      - SPIN STATE DEFINED AS A NONET")')
  if (myword(allkey, " COSCCH")) write (iw, '(" *  COSCCH     - ADD IN COSMO CHARGE CORRECTIONS")')
  if (myword(allkey, " FIELD"))  write (iw, '(" *  FIELD      - AN EXTERNAL ELECTRIC FIELD IS TO BE USED")')
  if (myword(allkey, " NOREOR")) write (iw, '(" *  NOREOR     - DO NOT ALLOW THE SYSTEM TO BE REORIENTATED")')
  if (myword(allkey, " INVERT")) write (iw, '(" *  INVERT     - REVERSE ALL OPTIMIZATION FLAGS")')
  if (myword(allkey, " ESP "))   write (iw, '(" *  ESP        - ELECTROSTATIC POTENTIAL CALCULATION")')
  if (myword(allkey, " NSURF"))  write (iw, '(" *  NSURF      - NUMBER OF LAYERS")')
  if (myword(allkey, " NOGPU"))  write (iw, '(" *  NOGPU      - DO NOT USE GPU ACCELERATION")')
  if (myword(allkey, " SCALE"))  write (iw, '(" *  SCALE      - SCALING FACTOR FOR VAN DER WAALS DISTANCE")')
  if (myword(allkey, " SCINCR")) write (iw, '(" *  SCINCR     - INCREMENT BETWEEN LAYERS")')
  if (myword(allkey, " SLOPE"))  write (iw, '(" *  SLOPE      - SLOPE   - USED TO SCALE MNDO ESP CHARGES")')
  if (myword(allkey, " PDBOUT")) write (iw, '(" *  PDBOUT     - PRINT GEOMETRY IN PDB FORMAT")')
  if (myword(allkey, " NOTER"))  write (iw, '(" *  NOTER      - DO NOT PUT ""TER""S IN PDB FILE")')
  if (myword(allkey, " CHARGES"))write (iw, '(" *  CHARGES    - IDENTIFY AND PRINT CHARGED ATOMS")')
  if ( .not. l_add_H) l_add_H = (index(keywrd, " ADD-H") /= 0)
  if (myword(allkey, " NORES"))  write (iw, '(" *  NORESEQ    - DO NOT RESEQUENCE Z-MATRIX INTO NORMAL PDB FORMAT")')
  if (myword(allkey, " MACRO"))  write (iw, '(" *  MACRO      - MODIFY METHODS TO SMOOTH NDDO - POINT-CHARGE TRANSITION")')
  if (myword(allkey, " XENO"))   then
                                 write (iw, '(" *  XENO       - RENAME PROTEIN FRAGMENTS AND SMALL MOLECULES")')
    if ( .not. (Index (keywrd, " RESI") /= 0 )) then
      call mopend("XENO requires keyword RESIDUES to also be used")
      return
    end if
  end if
  if (myword(allkey, " RESEQ"))  then
                                 write (iw, '(" *  RESEQ      - RESEQUENCE Z-MATRIX INTO NORMAL PDB FORMAT")')
    if (index(keywrd, "RESID") == 0 .and. maxtxt /= txtmax) then
      call mopend("RESEQ only works when the atom labels are in PDB format")
      write(iw,'(a,/)')"(Before using RESEQ, run a job using keyword RESIDUES to add PDB atom labels.)"
      return
    end if
  end if
  i = index(keywrd," START_RES") + 1
  if (i > 1) then
    j = index(keywrd(i:),")")
    if (j == 0) then
      write (iw, '(" ***START_RES must be followed by open and close parentheses, e.g., START_RES=(1 10)")')
      call web_message(iw,"start_res.html")
      call mopend("Keyword START_RES not properly defined")
      return
    end if
    j = j + i
    allkey(i:j) = " "
    write (iw, '(" *  START_RES  - STARTING RESIDUE NUMBERS DEFINED")')
    write (iw, '(" *  Keyword:     ",a)')keywrd(i:j)
    if(myword(allkey, "START_RES")) then
      call mopend("Only one keyword START_RES allowed")
      return
    end if
  end if

  if (quoted('GEO_DAT=')  > 0) then
    i = index(keywrd_quoted," GEO_DAT")
    j = index(keywrd_quoted(i + 10:),'"') + i + 9 
    write (iw, '(" *  GEO_DAT    - DATA SET GEOMETRY IS IN FILE """,a,"""")') &
      keywrd_quoted(i + 10:j - 1)
  end if
  if (quoted('GEO_REF=')  > 0) then
    i = index(keywrd_quoted," GEO_REF")
    j = index(keywrd_quoted(i + 10:),'"') + i + 9 
    k = index(keywrd_quoted(i:j), "SELF")
    if (index(keywrd_quoted(i:j), "SELF") /= 0) then
      line = " *  GEO_REF=""SELF""    - USE MOPAC DATA SET """//keywrd_quoted(i + 10:j - 5) &
        //trim(job_fn)//""" AS REFERENCE GEOMETRY"
       write (iw, '(a)')trim(line)
    else
      write (iw, '(" *  GEO_REF    - REFERENCE GEOMETRY IS IN FILE """,a,"""")')keywrd_quoted(i + 10:j - 1)
    end if
    if (keywrd_quoted(j + 1:j + 1) == " ") then
      write(iw,'(a)') " *               (NO BIAS TOWARDS THE REFERENCE GEOMETRY WILL BE APPLIED)"
    else
      sum = reada(keywrd_quoted(j:), 1)
      if (sum < 0.001d0) then
        write(iw,'(a)') " *               (NO BIAS TOWARDS THE REFERENCE GEOMETRY WILL BE APPLIED)"
      else
        i = nint(log10(sum))
        num = char(ichar("4") + abs(i))
        if (i < 0) then
          num1 = char(ichar("1") - i)
        else
          num1 = "1"
        end if
        write(iw,'(a, f'//num//'.'//num1//', a)') " *               (A BIAS OF",sum, &
        " KCAL/MOL/ANGSTROM^2 TOWARDS THE REFERENCE GEOMETRY WILL BE APPLIED)"
      end if
    end if
  end if
  i = index(allkey," CHAIN") + 1
  if (i > 1) then
    j = index(keywrd(i:),")") + i
    if (j == i) then
      write (iw, '(" ***CHAINS must be followed by open and close parentheses, e.g., CHAINS=(ABCD)")')
      call web_message(iw,"chains.html")
      call mopend("Keyword CHAINS not properly defined")
      return
    end if
    if (.not. myword(allkey, " CHAIN")) return
                                 write (iw, '(" *  CHAINS     - PDB CHAIN LETTERS EXPLICITLY DEFINED")')
                                 write (iw, '(" *  Keyword:     ",a)')keywrd(i:j)
  end if
  if (myword(allkey, " NEWPDB")) write (iw, '(" *  NEWPDB     - CONVERT PDB ATOM FORMAT INTO THE MODERN PDB VERSION, VERSION-3")')
  if (myword(allkey, " GEOCHK")) write (iw, '(" *  GEOCHK     - PRINT WORKING IN SUBROUTINE GEOCHK")')
  if (myword(allkey, " LEWIS"))  write (iw, '(" *  LEWIS      - PRINT OUT LEWIS STRUCTURE, THEN STOP")')
  if (myword(allkey, " SETPI"))  write (iw, '(" *  SETPI      - SOME OR ALL PI BONDS EXPLICITLY SET BY USER")')
  if (myword(allkey, " PDB "))   write (iw, '(" *  PDB        - INPUT GEOMETRY IS IN PDB FORMAT")')
  if (myword(allkey, " PDB("))   write (iw, '(" *  PDB(txt)   - SYMBOLS IN PDB FILE ARE DEFINED BY USER")')
  if (myword(allkey, " MOZ"))    write (iw, '(" *  MOZYME     - USE LOCALIZED M.O.s IN SOLVING THE SCF EQUATIONS")')
  if (myword(allkey, " RAPID"))  write (iw, '(" *  RAPID      - IN MOZYME SCF, USE ATOMS BEING OPTIMIZED ONLY")')
  if (myword(allkey, " PINOUT")) write (iw, '(" *  PINOUT     - WRITE OUT THE LMOs WHEN READING OR WRITING A ''.DEN'' FILE")')
  if (myword(allkey, " REORTH")) write (iw, '(" *  REORTH     - RE-ORTHOGONALIZE LMOs EACH 10 SCF CALCULATIONS")')
  if (myword(allkey, " RE-LOCAL")) write(iw,'(" *  RE-LOCAL   - RE-LOCALIZE LMOs AT END OF CALCULATION")')
  if (myword(allkey, " SWAP"))   write(iw,  '(" *  SWAP       - THIS KEYWORD IS NOW REDUNDANT. SEE KEYWORD NOSWAP")')
  if (myword(allkey, " NOSWAP")) write(iw,  '(" *  NOSWAP     - DO NOT SWAP ATOMS EVEN IF IT WILL IMPROVE OVERLAP IN GEO_REF")')
  if (myword(allkey, " A0 "))    write (iw, '(" *  A0         - INPUT GEOMETRY IS IN ATOMIC UNITS (A0)")')
  if (myword(allkey, " ANG"))    write (iw, '(" *  ANGSTROMS- INPUT GEOMETRY IS IN ANGSTROMS")')
  if (myword(allkey, " ADD-H"))  write (iw, '(" *  ADD-H      - ADD HYDROGEN ATOMS TO SATISFY VALENCE")')
  if (myword(allkey, " CONNOL")) write (iw, '(" *  CONNOLLY   - USE CONNOLLY SURFACE")')
  if (myword(allkey, " ESPRST")) write (iw, '(" *  ESPRST     - RESTART OF ELECTRIC POTENTIAL CALCULATION")')
  if (myword(allkey, " UHF"))    write (iw, '(" *  UHF        - UNRESTRICTED HARTREE-FOCK CALCULATION")')
  if (myword(allkey, " RHF"))    write (iw, '(" *  RHF        - RESTRICTED HARTREE-FOCK CALCULATION")')
  if (myword(allkey, " STATIC")) write (iw, '(" *  STATIC     - CALCULATE STATIC FIELD POLARIZABILITIES")')
  i = quoted(' SETUP=')
  if (i /= 0) then
    if (len_trim(line) == 0) then
      allkey(i:i + 7) = " " 
      line = "SETUP or SETUP.TXT"
    end if
    i = len_trim(line)
    if (i < 26) then
      write (iw, '(" *  SETUP      - EXTRA KEYWORDS TO BE READ FROM FILE """, a, """")') trim(line)
    else
      write (iw, '(" *  SETUP      - EXTRA KEYWORDS TO BE READ FROM FILE:")')
      write (iw, '("                 """, a, """")') trim(line)
    end if
  else
    i = index(allkey," SETUP")
    if (i /= 0) then
      j = index(allkey(i + 6:), " ") + i + 4
      write (iw, '(" *  SETUP      - EXTRA KEYWORDS TO BE READ FROM FILE """,a,"""")')allkey(i + 1:j)
      allkey(i + 1:j) = " "
    end if
  end if
  if (myword(allkey, " MAX"))    write (iw, '(" *  MAX        - GRID SIZE 23*23 ")')
  if (myword(allkey, " COSWRT")) write (iw, '(" *  COSWRT")')
  if (myword(allkey, " OLDCAV")) write (iw, '(" *  OLDCAV")')
  if (myword(allkey, " SYM ") .or. myword(allkey, " SYMM")) &
    write (iw, '(" *  SYMMETRY   - SYMMETRY CONDITIONS TO BE IMPOSED")')
  if (myword(allkey, " POLAR")) then
    write (iw, '(" *  POLAR      - CALCULATE FIRST, SECOND AND THIRD-ORDER POLARIZABILITIES")')
    if (id /= 0) then
      call mopend("KEYWORD ""POLAR"" CANNOT BE USED WITH PERIODIC BOUNDARY CONDITIONS")
      write(iw,'(2x,a)')"(TV in the geometry implies PBC, but PBC cannot allow an electric field gradient.) "
    end if
  end if
  if (myword(allkey, " RESI")) then
    write (iw, '(" *  RESIDUES   - DETERMINE THE SEQUENCE OF RESIDUES")')
    if (index(keywrd," RESIDUES0") /= 0) then
      if (index(keywrd," ADD-H") + index(keywrd," RESEQ") + index(keywrd, " SITE=") + index(keywrd, " SITE(") /= 0) then
        call mopend("Keyword RESIDUES0 cannot be used when a keyword that changes the geometry is present")
        if (index(keywrd," ADD-H") /= 0) write(iw,'(10x,a)')"Keyword ADD-H changes the geometry."
        if (index(keywrd," RESEQ") /= 0) write(iw,'(10x,a)')"Keyword RESEQ changes the geometry."
        if (index(keywrd," SITE=(") /= 0) write(iw,'(10x,a)')"Keyword SITE changes the geometry."
        call web_message(iw,"Residues.html")
      end if
    end if
    if(myword(allkey, " NOZERO")) &
      write (iw, '(" *  NOZERO     - THE NUMBER ZERO IN THE RESIDUE SEQUENCE IS DELETED")')
    if(myword(allkey, " ZERO")) &
      write (iw, '(" *  ZERO       - A RESIDUE IS ALLOWED TO HAVE THE NUMBER ZERO")')
  end if
  if (myword(allkey, " NORES"))  &
    write (iw, '(" *  NORES      - THIS IS THE DEFAULT.  USE ""RESIDUES"" IF RESIDUES ARE TO BE CALCULATED")')
  if (myword(allkey, " SITE"))   then
    write (iw, '(" *  SITE       - SET IONIZATION LEVELS OF IONIZABLE RESIDUES ")')
    k = 0
    do i = 1, natoms
      if (na(i) /= 0) then
        k = k + 1
        if (k == 1) then
          call mopend("KEYWORD ""SITE"" REQUIRES ALL ATOMS TO BE IN CARTESIAN COORDINATES")
          write(iw,'(/10x,a)') "Atoms in internal coordinates:"
        end if
        write(iw,'(12x, a)') txtatm(i)
      end if
    end do
    if (k > 0) write(iw,'(/10x,a)') "(Keyword ""XYZ"" converts internal coordinates to Cartesian coordinates.)"
    if (k > 5) write(iw,'(/10x,a)') "Remaining errors suppressed"
    if (index(keywrd, " RESIDU") /= 0) then
      call mopend("THE PRESENCE OF KEYWORD ""RESIDUES"" PREVENTS KEYWORD ""SITE"" FROM WORKING CORRECTLY")
      write(iw,*)
      return
    end if
    i = index(keywrd, " SITE=(")
    do j = i, len_trim(keywrd)
      if (keywrd(j:j + 1) == ") ") exit
    end do
    allkey(i:j) = " "
  end if
  if (myword(allkey, " NOOPT"))   then
    line = trim(keywrd)
    do
      i = index(line, " NOOPT")
      if (i == 0) exit
      j = index(line(i + 5:)," ") + i + 3
      if (j   - i == 8) then
        line(j:j) = char( ichar(line(j:j)) + ichar("a")   - ichar("A"))
        write (iw, '(" *  NOOPT-",a2,"   - DO NOT OPTIMIZE COORDINATES OF ATOMS OF TYPE ",a2)')line(j - 1:j), line(j   - 1:j)
      else if (j   - i == 7) then
        write (iw, '(" *  NOOPT-",a1,"    - DO NOT OPTIMIZE COORDINATES OF ATOMS OF TYPE ",a1)')line(j:j), line(j:j)
      else if (j   - i == 5) then
        write (iw, '(" *  NOOPT      - DO NOT OPTIMIZE ANY COORDINATES")')
        if (index(keywrd, " OPT ") /= 0) then
          write (iw, '(" *  OPT        - OPTIMIZE COORDINATES OF ALL ATOMS")')
          write (iw, '(" *             - USE ""NOOPT"" OR ""OPT"" BUT NOT BOTH")')
          call mopend("OPT AND NOOPT CANNOT BOTH BE PRESENT")
          return
        end if
      else
        write (iw, '(" ***NOOPT      - IMPROPER USE OF NOOPT KEYWORD, KEYWORD USED = ''", a,"''")')line(i + 1:j)
        call mopend("IMPROPER USE OF OPT KEYWORD")
        return
      end if
      line(i:j) = " "
    end do
  end if
  line = trim(allkey)
  if (myword(allkey, " OPT-") .or. myword(allkey, " OPT ") .or. myword(allkey, " OPT(") &
    .or. myword(allkey, " OPT="))   then
    i = index(line, " OPT=")
    if (i /= 0) line(i + 4:) = line(i + 5:)
    l = 0
    do
      i = index(line, " OPT-") + index(line, " OPT ") + index(line, " OPT(") + index(line, " OPT=(")
      if (i == 0) exit
      j = index(line(i + 4:)," ") + i + 2
      if (index(line, " OPT-") /= 0) then
        if (j - i == 6) then
          line(j:j) = char( ichar(line(j:j)) + ichar("a")   - ichar("A"))
          write (iw, '(" *  OPT-",a2,"     - OPTIMIZE COORDINATES OF ATOMS OF TYPE ",a2)')line(j - 1:j), line(j - 1:j)
        else if (j - i == 5) then
          write (iw, '(" *  OPT-",a1,"      - OPTIMIZE COORDINATES OF ATOMS OF TYPE ",a1)')line(j:j), line(j:j)
        else
          l = 1
        end if
      else if (index(line(i:), " OPT(") /= 0) then
        j = index(line(i + 1:), ") ")
        if (j /= 0) then
          i = i + 5
          k = index(line(i:j + i - 5), "=")
          if (k /= 0) then
            write(iw,'(" *  OPT        - OPTIMIZE COORDINATES OF ALL ATOMS WITHIN ")')
            j = i + j
            do
              sum = reada(line, k + i)
              write(iw,'(" *",14x,f5.2, " ANGSTROMS OF ATOMS WITH PDB LABEL ",a)') sum, line(i: k + i -2)
              l = index(line(i:j), ",")
              if (l /= 0) then
                i = i + l
                k = index(line(i:j), "=")
              else
                exit
              end if
            end do
          else
            write(iw,'(" *  OPT        - OPTIMIZE COORDINATES OF ALL ATOMS IN RESIDUES:",/," *",15x,a, &
            & a)') line(k + i:j + i - 6), line(i: k + i -2)
          end if
        else
          l = 1
        end if
        exit
      else if (index(line(i:), " OPT ") /= 0) then
        write (iw, '(" *  OPT        - OPTIMIZE COORDINATES OF ALL ATOMS")')
      else
        l = 1
      end if
      line(i:j) = " "
    end do
    if (l == 1) then
      i = index(line, " OPT")
      j = index(line(i + 1:), " ")
      write (iw, '(" ***OPT        - IMPROPER USE OF OPT KEYWORD, KEYWORD USED = ''", a,"''")')line(i + 1:j)
      call mopend("IMPROPER USE OF OPT KEYWORD")
      return
    end if
  end if
!
!  Keywords involving equals sign
!
!**********************************************************************
!
    !  Tension or pressure in a solid-state calculation
    !
    pressure = 0.d0
    if (myword(allkey, " P=")) then
      pressure = reada (keywrd, Index (keywrd, " P="))
      if (id == 1) then
        write (iw, '(" *  P=         - TENSION IN POLYMER=", g13.6, " NEWTONS PER MOLE")') pressure
        pressure = -pressure * 10.d0 ** (-13) / 4.184d0
      else if (id == 2) then
      else if (id == 3) then
        i = Index (keywrd, " P=")
        j = Index (keywrd(i + 3:), " ") + i + 3
        if (index(keywrd(i + 3: j),"GP") /= 0) then
         write (iw, '(" *  P=         - PRESSURE ON SOLID=", f7.3, &
             & " GIGAPASCALS")') pressure
          pressure = pressure*1.d9
        else
          write (iw, '(" *  P=         - PRESSURE ON SOLID=", g13.6, &
             & " NEWTONS PER SQUARE METER")') pressure
        end if
!
!  Multiply by N, Avogadro's Number, to convert from J/M**3 per molecule
!  to J/M**3/mol.
!  Divide by 4184 to convert from J/M**3/mol to Kcal/M**3/mol
!  Divide by 10**30 to convert from Kcal/M**3/mol to Kcal/Angstrom**3/mol
!
        pressure = -(fpcref(1,10)*pressure) / (4184.d0*10.d0**30)
      else
        write (iw, *) " Keyword 'P=n.nn' is not allowed here"
        call mopend("Keyword 'P=n.nn' is not allowed here")
        return
      end if
    end if
!
!                       ESP grid
!
    i = -100
    if (myword(allkey, " CUBE")) then
      write (iw,'(" *  CUBE       - USE GAUSSIAN CUBE FILE FOR ELECTROSTATICS")')
    else if (myword(allkey, " ESPGRID")) then
      i = Nint (reada (keywrd, Index (keywrd, " ESPGRID")))
      write (iw,'(" *  ESPGRID    - GENERATE ELECTROSTATICS CUBE FILE  =", i5," POINTS ON SIDE")') i
    end if
    if (i /= -100 .and. i < 2 .or. i > 100) then
      if (i < 2) write (iw,'(//," *   Value of number of points is too small",//)')
      if (i > 100) write (iw,'(//," *   Value of number of points is too large",//)')
      call mopend("Number of points in electrostatics is outside limits")
      return
    end if

!
!
!               Electronic quantities (mainly C.I.)
!
!                       CHARGE
!
  if (myword(allkey, " CHARGE=")) then
    i = Nint (reada (keywrd, Index (keywrd, " CHARGE=")))
    if (i == 0) then
      write (iw,'(3(" *", /), " *", 15 x, "  CHARGE ON SYSTEM = 0", 3 (/, " *"))')
    else
      num = char(ichar("3") + max(int(log10(abs(i) + 0.05)),0))
      write (iw,'(3(" *", /), " *", 15 x, "  CHARGE ON SYSTEM =", SP,i'//num//', 3 (/, " *"))') i
    end if
    if (id /= 0 .and. i /= 0) then
      write(iw,"(/10x,a)")"INFINITE SYSTEMS MUST HAVE A ZERO CHARGE ON THE UNIT CELL"
      call mopend("Unit cell has a charge. Correct fault and re-submit ")
    end if
  end if
  if (Index(allkey, " C.I.D.") /= 0) then
    j = Index (keywrd, " C.I.D.=(")
    if (j /= 0) then
      j = Index (keywrd(j:j+10), ",") + j   - 1
      nmos = Nint (reada (keywrd, Index (keywrd, "C.I.D.=(")+7))
      num = char(ichar("2") + int(log10(nmos*1.0)))
      l = Int (reada (keywrd, j))
      num1 = char(ichar("2") + int(log10(l*1.0)))
      write (iw,'(" * C.I.D.=(N,M)-", i'//num1// &
        ', " DOUBLY FILLED LEVELS USED IN A CI DOUBLES INVOLVING", i'//num//', " M.O.''S")') l, nmos
     if (.not. myword(allkey, " C.I.D.=(")) return ! Impossible option used to delete keyword
    else if (myword(allkey, " C.I.D.=")) then
      nmos = Int (reada (keywrd, Index (keywrd, "C.I.D.")+7))
      write (iw,' (" *  C.I.D.=N   -", i2, " M.O.S TO BE USED IN CI DOUBLES")') nmos
    else
      write (iw, "(' *',/,a)") " *      C.I.D. keyword must be of form 'C.I.D.=n' or 'C.I.D.=(n1,n2)' (See manual)"
      call mopend("C.I.D. keyword must be of form 'C.I.D.=n' or 'C.I.D.=(n1,n2)'")
      return
    end if
  end if
!
!                       C.I.=(n1,n2)
!
  if (Index(allkey, " C.I.") /= 0) then
    j = Index (keywrd, " C.I.=(")
    if (j /= 0) then
      j = Index (keywrd(j:j+10), ",") + j   - 1
      nmos = Nint (reada (keywrd, Index (keywrd, "C.I.=(")+5))
      num = char(ichar("2") + int(log10(nmos*1.0)))
      l = Int (reada (keywrd, j))
      num1 = char(ichar("2") + int(log10(l*1.0)))
      write (iw,'(" *  C.I.=(N,M) -", i'//num1//', " DOUBLY FILLED LEVELS USED IN A C.I. INVOLVING", i' &
        //num//', " M.O.''S")') l, nmos
     if (.not. myword(allkey, " C.I.=(")) return ! Impossible option used to delete keyword
    else if (myword(allkey, " C.I.=")) then
      nmos = Int (reada (keywrd, Index (keywrd, "C.I.")+5))
      i = Index (keywrd, "C.I.=")
      j = Index(keywrd(i + 1:), " ") + i
      line = " *  "//keywrd(i:j)
      num = char(ichar("2") + int(log10(nmos*1.0)))
      write (iw, "(a, i"//num//", a)")line(1:15)//"-", nmos, " M.O.S TO BE USED IN C.I."
    else
      write (iw, "(' *',/,a)") " *      C.I. keyword must be of form 'C.I.=n' or 'C.I.=(n1,n2)' (See manual)"
      call mopend("C.I. keyword must be of form 'C.I.=n' or 'C.I.=(n1,n2)'")
      call web_message(iw,"CI=nm.html")
      call web_message(iw,"CI=n.html")
      return
    end if
  end if
  if (Index(allkey, " C.A.S.") /= 0) then
    j = Index (keywrd, " C.A.S.=(")
    if (j /= 0) then
      j = Index (keywrd(j:j+10), ",") + j   - 1
      nmos = Nint (reada (keywrd, Index (keywrd, "C.A.S.=(")+7))
      write (iw,'(" * C.A.S.=(N,M)-", i3, " DOUBLY FILLED LEVELS USED IN A",/, &
     & " *             CAS REF DET GENERATION INVOLVING ", i2, " M.O.''S")')  &
     Int (reada (keywrd, j)), nmos
     if (.not. myword(allkey, " C.A.S.=(")) return ! Impossible option used to delete keyword
    else if (myword(allkey, " C.A.S.=")) then
      nmos = Int (reada (keywrd, Index (keywrd, "C.A.S.")+7))
      write (iw,' (" *  C.A.S.=N   -", i2, " M.O.S TO BE USED IN CAS REF DET GENERATION")') nmos
    else
      write (iw, "(' *',/,a)") " *      C.A.S. keyword must be of form 'C.A.S.=n' or 'C.A.S.=(n1,n2)' (See manual)"
      call mopend("C.A.S. keyword must be of form 'C.A.S.=n' or 'C.A.S.=(n1,n2)'")
      return
    end if
  end if
!
!                       MECI Microstates read in
!
  if (myword(allkey, " MICROS")) &
    write (iw,'(" *  MICROS=N -", i4, " MICROSTATES TO BE SUPPLIED FOR C.I.")') &
    Int (reada (keywrd, Index (keywrd, " MICROS")))
!
!                       Fractionally occupied degenerate Open shell
!
  if (myword(allkey, " OPEN")) then
    i = Index (keywrd, " OPEN")
    j = Index (keywrd(i:i+10), ",") + i   - 1
    ilevel = Nint (reada (keywrd, j))
    ielec = Nint (reada (keywrd, Index (keywrd, " OPEN")+6))
    write (iw,'(" *  OPEN(M,N)  - THERE ARE", i2, " ELECTRONS IN", i2, " LEVELS")') &
     ielec, ilevel
  end if
!
!                       Magnetic component of spin
!
  if (myword(allkey, " MS=")) &
    write (iw,'(" *  MS=        - IN MECI, MAGNETIC COMPONENT OF SPIN =", f5.1)') &
    reada (keywrd, Index (keywrd, " MS="))
!
!   Select root of C.I. matrix
!
  if (myword(allkey, " ROOT")) then
    i = Index (keywrd, " ROOT") + 6
    j = index(keywrd(i:), " ") + i - 2
    line = keywrd(i:j)
    do k = 3,5
      if (line(k:k) >="A" .and. line(k:k) <= "Z") &
      & line(k:k) = Char(Ichar(line(k:k)) + Ichar('a') - Ichar('A'))
    end do
    write (iw,'(" *  ROOT       - IN A C.I. CALCULATION, ROOT """, a, """ TO BE OPTIMIZED.")') trim(line)
    if (keywrd(i:i) > "9" .or. keywrd(i:i) < "0") then
      call mopend("THE VALUE OF ""ROOT"" MUST START WITH AN INTEGER")
    end if
  end if
!**********************************************************************
!
!   SOLVATION KEYWORDS
!

  if (myword(allkey, " EPS=") .or. (index(keywrd," PKA") .ne. 0)) then
    if (Index(keywrd," EPS=CRSDEF") /= 0) then
      fepsi = 1.d0
    else
      if (index(keywrd," PKA") .ne. 0) then
        epsi = 78.4d0
        line = "EPS=78.4 "
      else
        i = Index (keywrd, "EPS=")
        j = Index(keywrd(i + 1:), " ") + i
        line = " *  "//keywrd(i:j)
        epsi = reada (keywrd, i)
      end if
      write (iw, "(a, a)")line(1:15),"- USE ANDREAS KLAMT'S COSMO IMPLICIT SOLVATION MODEL"
      fepsi = (epsi-1.d0) / (epsi+0.5d0)
    end if
    if (epsi < -100.d0) then
      write(iw,"(a)") " *  "
      write(iw,"(a)") " *  The lower bound of a dielectric is 1.00 = vacuum"
      write(iw,"(2a)")" *  Keywords: ",keywrd(:len_trim(keywrd))
      write(iw,"(a)") " *  "
      call mopend("Nonsense value of dielectric constant supplied")
      return
    end if
  else if (myword(allkey, " COSMO")) then
    epsi = 999.d0
    write (iw, "(a, f6.2, a)")" *  EPS=", epsi," - USE ANDREAS KLAMT'S COSMO IMPLICIT SOLVATION MODEL"
    fepsi = (epsi-1.d0) / (epsi+0.5d0)
  else if (numat < 100) then  !  Limit surface area calculation to 100 atoms   - saves time
    epsi = 78.4d0   !  For surface area and volume only
    fepsi = (epsi-1.d0) / (epsi+0.5d0)
  end if
  if (myword(allkey, " DIPL"))  write (iw,'(" *  DIPL=", f7.3)') reada (keywrd, Index (keywrd, " DIPL"))
  if (myword(allkey, " RSOLV")) write (iw,'(" *  RSOLV=", f7.3)') reada (keywrd, Index (keywrd, " RSOLV"))
  if (myword(allkey, " DELSC")) write (iw,'(" *  DELSC=", f7.3)') reada (keywrd, Index (keywrd, " DELSC"))
  if (myword(allkey, " DISEX")) write (iw,'(" *  DISEX=", f7.3)') reada (keywrd, Index (keywrd, " DISEX"))
  i = Index(keywrd, "N**2")
  if (i /= 0) then
    j = Index(keywrd(i + 1:), " ") + i
    line = " *  "//keywrd(i:j)
    write (iw, "(a, a)")line(1:14), " - USED IN COSMO-CI"
    if (.not. myword(allkey, "N**2")) return
  end if
  if (myword(allkey, " NSPA")) then
    i = Nint (reada (keywrd, Index (keywrd, " NSPA")))
    write (iw,'(" *  NSPA=", i5)') i
    nspa = i
  else
    nspa = 42
  end if
  if (myword(allkey, " ROTX"))  write (iw,'(" *  ROTX=", i5)') Nint (reada (keywrd, Index (keywrd, " ROTX")))
!**********************************************************************
!
!                       Geometric quantities
!
!                       Grids, Reaction paths, etc.
!
 i = 0
 if (myword(allkey, " STEP1"))  then
   write (iw,'(" *  STEP1      - FIRST STEP-SIZE IN GRID =", f7.2)') &
   reada (keywrd, Index (keywrd, "STEP1")+6)
   if (index(keywrd, " POINT1") == 0) then
    call l_control("POINT1=11", len_trim("POINT1=11"), 1)
   end if
   i = 2
 end if
 if (myword(allkey, " STEP2"))  then
   write (iw,'(" *  STEP2      - SECOND STEP-SIZE IN GRID =", f7.2)') &
   reada (keywrd, Index (keywrd, "STEP2")+6)
   if (index(keywrd, " POINT2") == 0) then
    call l_control("POINT2=11", len_trim("POINT2=11"), 1)
   end if
 end if
 if (myword(allkey, " STEP="))  then
   write (iw,'(" *  STEP       - STEP-SIZE IN PATH =", f8.3)') &
   reada (keywrd, Index (keywrd, " STEP") + 4)
   if (index(keywrd, " POINT") == 0) call mopend ("KEYWORD POINT MISSING")
   if (index(keywrd, " 1SCF") /= 0) call mopend ("KEYWORD ""1SCF"" CANNOT BE USED WITH KEYWORD ""STEP""")
   i = 1
 end if
 if (i > 0) then
!
! Check that the appropriate flags are set
!
   k = 0
   do j = 1, natoms
     do l = 1, 3
       if (lopt(l,j) < 0) k = k + 1
     end do
   end do
   if (i /= k) then
     if (index(keywrd," 0SCF") == 0) then
       write(iw,'(10x, a,i1)')"Number of optimization flags requested by keywords: ", i
       write(iw,'(10x, a,i1)')"Number of optimization flags found in data-set:     ", k
       call mopend("The number of optimization flags set to '-1' does not match the keywords used")
     end if
   end if
 end if
 if (myword(allkey, " MERS"))then
   j = index(keywrd," MERS")
   mers = 0
   k = 0
   i = Index (keywrd(j + 1:), " ") + j
   do l = 1, 3
     j = j + k
     if (l > 1 .and. k == 0) exit
     mers(l) = Nint (reada (keywrd(j:), 1))
     k = Index (keywrd(j:i), ",")
   end do
   i = mers(1)
   do l = 2, 3
     if (mers(l) == 0) exit
     i = i*mers(l)
   end do
   write (iw,'(" *  MERS=N     - NUMBER OF FUNDAMENTAL UNIT CELLS USED:", i3)') i
 else
   mers = 0
 end if
 if (myword(allkey, " POINT1")) then
   write (iw,'(" *  POINT1     - NUMBER OF ROWS IN GRID =", i3)') &
   Nint (reada (keywrd, Index (keywrd, "POINT1")+7))
   if (index(keywrd, " STEP1") == 0) then
     write (iw,'("*",/," *             - **** KEYWORD STEP1 MISSING ****",/,"*")')
     call mopend("KEYWORD STEP1 MISSING")
   end if
 end if
 if (myword(allkey, " POINT2")) then
   write (iw,'(" *  POINT2     - NUMBER OF COLUMNS IN GRID =", i3)') &
   Nint (reada (keywrd, Index (keywrd, "POINT2")+7))
   if (index(keywrd, " STEP2") == 0) then
     write (iw,'("*",/," *             - **** KEYWORD STEP2 MISSING ****",/,"*")')
     call mopend("KEYWORD STEP2 MISSING")
   end if
 end if
 if (myword(allkey, " POINT")) then
   write (iw,'(" *  POINT      - NUMBER OF POINTS IN PATH =", i3)') &
   Nint (reada (keywrd, Index (keywrd, "POINT")+6))
   if (index(keywrd, " STEP") == 0) then
     write (iw,'("*",/," *             - **** KEYWORD STEP MISSING ****",/,"*")')
     call mopend("KEYWORD STEP MISSING")
   end if
 end if
 if (myword(allkey, " KINE"))   write (iw,'(" *  KINETIC=   - ", f9.3, " KCAL KINETIC ENERGY ADDED TO DRC")') &
    reada (keywrd, Index (keywrd, " KINE"))
!
!                       Specific intrinsic reaction coordinate
!
 if (myword(allkey, " IRC="))  then
    write (iw,'(" *  IRC=N      - INTRINSIC REACTION COORDINATE", i3, " DEFINED")') &
    Nint (reada (keywrd, Index (keywrd, " IRC=")))
  else if (myword(allkey, " IRC")) then
    write (iw,'(" *  IRC        - INTRINSIC REACTION COORDINATE CALCULATION")')
  end if
!
!                       DRC (may have half-life)
!
  if (myword(allkey, " DRC=")) then
    write (iw,'(" *  DRC=       - HALF-LIFE FOR KINETIC ENERGY LOSS =", f9.2, " *10**(-15) SECONDS")') &
     reada (keywrd, Index (keywrd, " DRC="))
  else if (myword(allkey, " DRC")) then
    write (iw,'(" *  DRC        - DYNAMIC REACTION COORDINATE CALCULATION")')
  end if
   mozyme = l_temp
!
!                       External parameters read from file
!
  if (myword(allkey, " EXTERNAL")) write (iw, '(" *  EXTERNAL   - DEFAULT PARAMETERS RESET USING DATA IN INPUT FILE")')
  if (quoted('EXTERNAL=')  > 0) then
    i = index(keywrd_quoted," EXTERNAL=")
    i = i + 10
    line = get_a_name(keywrd_quoted(i:), len_trim(keywrd_quoted(i:)))
    write (iw, '(" *",/," *  EXTERNAL=n -  DEFAULT PARAMETERS RESET USING DATA IN FILES: ",/," *",17x, a)') '"'//trim(line)//'"'
    do
      j = index(keywrd_quoted(i:), ";")
      if (j /= 0) then
        i = i + j
        line = get_a_name(keywrd_quoted(i:), len_trim(keywrd_quoted(i:)))
        write (iw, '(" *", 10x, a)')'   and "'//trim(line)//'"'
      else
        exit
      end if
    end do
  end if
  return
end subroutine wrtcon
subroutine wrtout (allkey)
  use molkst_C, only : keywrd, mozyme, maxtxt, line, prt_coords, prt_gradients, prt_cart, prt_charges, prt_pops, &
    prt_topo, prt_force, prt_normal_coords, prt_orientation, prt_velocity, backslash, is_PARAM
  use chanel_C, only: iw0, iw, log, input_fn
  implicit none
  character (len=1000), intent (inout) :: allkey
  integer :: i, j
  logical, external :: myword
  double precision, external :: reada
  intrinsic Index, Nint
  if (myword(allkey, " PRTINT"))  write (iw,'(" *  PRTINT     - INTERATOMIC DISTANCES TO BE PRINTED")')
  if (myword(allkey, " PRTCHAR")) write (iw,'(" *  PRTCHARGE  - PRINT CHARGES IN ARC FILE")')
  if (index(allkey, " AUX") > 0) then
    i = index(allkey, " AUX(") + 1
    if (i > 1) then
      j = index(allkey(i + 4:), ") ") + i + 3
      allkey(i:j) = " "
    else
      i = index(allkey, " AUX")
      allkey(i:i + 3) = " "
    end if
    write (iw,'(" *  AUX        - OUTPUT AUXILIARY INFORMATION")')
    if (myword(allkey, " AUX")) i = i + 1
  end if
  if (index(allkey, " OUTPUT") > 0) then
    i = index(allkey, " OUTPUT(") + 1
    if (i > 1) then
      j = index(allkey(i + 4:), ") ") + i + 3
      line = allkey(i + 6:j - 1)
    else
      line = " "
    end if
    prt_coords        = (index(line, "C") /= 0)
    prt_gradients     = (index(line, "G") /= 0)
    prt_cart          = (index(line, "X") /= 0)
    prt_charges       = (index(line, "Q") /= 0)
    prt_pops          = (index(line, "P") /= 0)
    prt_topo          = (index(line, "T") /= 0)
    prt_force         = (index(line, "F") /= 0)
    prt_normal_coords = (index(line, "N") /= 0)
    prt_orientation   = (index(line, "O") /= 0)
    prt_velocity      = (index(line, "V") /= 0)
    if (prt_gradients .or. i > 1) then
      write (iw,'(" *  OUTPUT     - REDUCE OUTPUT, BUT PRINT:")')
    else
      write (iw,'(" *  OUTPUT     - MINIMIZE OUTPUT")')
    end if
    if (prt_coords)        write (iw,'(" *           C - COORDINATES")')
    if (prt_gradients)     write (iw,'(" *           G - GRADIENTS")')
    if (prt_cart)          write (iw,'(" *           X - CARTESIAN COORDINATES")')
    if (prt_charges)       write (iw,'(" *           Q - FRACTIONAL ATOMIC CHARGES")')
    if (prt_pops)          write (iw,'(" *           P - ATOMIC ORBITAL POPULATIONS")')
    if (prt_topo)          write (iw,'(" *           T - TOPOGRAPHY (ATOM CONNECTIVITY)")')
    if (prt_force)         write (iw,'(" *           F - FORCE MATRIX")')
    if (prt_normal_coords) write (iw,'(" *           N - NORMAL COORDINATES")')
    if (prt_orientation)   write (iw,'(" *           O - ORIENTATION)")')
    if (prt_velocity)      write (iw,'(" *           V - VELOCITY)")')
    if (.not. myword(allkey, " OUTPUT")) return ! An impossible option
    if (index(keywrd, " FORCE ") /= 0 .and. .not. prt_force ) then
      if (index(keywrd, " GEO-OK") + index(keywrd, " ISOTOPE") == 0) then
        call mopend("KEYWORD ""FORCE"" PRESENT BUT KEYWORD ""OUTPUT"" SUPPRESSES RESULTS OF ""FORCE"" CALCULATION")
        write (iw,'(10x, "(Either add ""GEO-OK"" or ""ISOTOPE"", remove ""OUTPUT"", or use ""OUTPUT(F)"")")')
      end if
    end if
  else
    prt_coords        = .TRUE.
    prt_gradients     = .TRUE.
    prt_cart          = .TRUE.
    prt_charges       = .TRUE.
    prt_pops          = .TRUE.
    prt_topo          = .TRUE.
    prt_force         = .TRUE.
    prt_normal_coords = .TRUE.
    prt_orientation   = .TRUE.
    prt_velocity      = .TRUE.
  end if
  if (myword(allkey, " MOPAC"))   write (iw,'(" *  MOPAC      - USE OLD MOPAC CONVENTION FOR FIRST THREE ATOMS")')
  if (myword(allkey, " NOINT"))   write (iw,'(" *  NOINTER    - THIS KEYWORD HAS BEEN REPLACED BY PRTINT")')
  if (myword(allkey, " NOCOM"))   write (iw,'(" *  NOCOMMENTS - SUPPRESS PDB COMMENTS")')
  if (myword(allkey, " ISOTOPE")) write (iw,'(" *  ISOTOPE    - SAVE THE FORCE MATRIX FOR USE LATER")')
  if (myword(allkey, " DENOUT"))  write (iw,'(" *  DENOUT     - SAVE DENSITY MATRIX FOR USE LATER")')
  if (myword(allkey, " OLDENS"))  write (iw,'(" *  OLDENS     - INITIAL DENSITY MATRIX READ OFF DISK")')
  if (myword(allkey, " CIOSCI"))  write (iw,'(" *  CIOSCI     - PRINT WORKING IN SUBROUTINE CIOSCI")')
  if (myword(allkey, " ENPART"))  write (iw,'(" *  ENPART     - ENERGY TO BE PARTITIONED INTO COMPONENTS")')
  if (myword(allkey, " NOXYZ"))   write (iw,'(" *  NOXYZ      - CARTESIAN COORDINATES NOT TO BE PRINTED")')
  if (myword(allkey, " PRTXYZ"))  write (iw,'(" *  PRTXYZ     - PRINT CARTESIAN COORDINATES")')
  if (myword(allkey, " NOTXT"))   write (iw,'(" *  NOTXT      - DO NOT PRINT TEXT ASSOCIATED WITH AN ATOM")')
  if (myword(allkey, " GRAD"))    write (iw,'(" *  GRADIENTS  - ALL GRADIENTS TO BE PRINTED")')
  if (myword(allkey, " MINI"))    write (iw,'(" *  MINI       - REDUCE OUTPUT BY ONLY PRINTING FLAGGED ATOMS")')
  if (mozyme) then
    if (myword(allkey, " VEC"))     write (iw,'(" *  VECTORS    - FINAL MOLECULAR ORBITALS TO BE PRINTED")')
  else
    if (myword(allkey, " VEC"))     write (iw,'(" *  VECTORS    - FINAL EIGENVECTORS TO BE PRINTED")')
  end if
  if (myword(allkey, " EIGEN"))   write (iw,'(" *  EIGEN      - CONVERT LMO''s INTO EIGENVECTORS")')
  if (myword(allkey, " CARTAB"))  write (iw,'(" *  CARTAB     - PRINT ALL THE CHARACTER TABLES")')
  if (myword(allkey, " CHARST"))  write (iw,'(" *  CHARST     - PRINT DETAILS OF SUBROUTINE CHARST")')
  if (myword(allkey, " DCART"))   write (iw,'(" *  DCART      - PRINT DETAILS OF SUBROUTINE DCART")')
  if (myword(allkey, " DERI1"))   write (iw,'(" *  DERI1      - PRINT DETAILS OF SUBROUTINE DERI1")')
  if (myword(allkey, " DERI2"))   write (iw,'(" *  DERI2      - PRINT DETAILS OF SUBROUTINE DERI2 ")')
  if (myword(allkey, " DERITR"))  write (iw,'(" *  DERITR     - PRINT DETAILS OF SUBROUTINE DERITR")')
  if (myword(allkey, " DERIV"))   write (iw,'(" *  DERIV      - PRINT DETAILS OF SUBROUTINE DERIV")')
  if (myword(allkey, " DERNVO"))  write (iw,'(" *  DERNVO     - PRINT DETAILS OF SUBROUTINE DERNVO")')
  if (myword(allkey, " MAKVEC"))  write (iw,'(" *  MAKVEC     - PRINT DETAILS OF SUBROUTINE MAKVEC")')
  if (myword(allkey, " DIIS"))    write (iw,'(" *  DIIS       - PRINT DETAILS OF SUBROUTINE DIIS  ")')
  if (myword(allkey, " FLEPO"))   write (iw,'(" *  FLEPO      - PRINT DETAILS OF SUBROUTINE FLEPO ")')
  if (myword(allkey, " FMAT"))    write (iw,'(" *  FMAT       - PRINT DETAILS OF SUBROUTINE FMAT  ")')
  if (myword(allkey, " DFORCE"))  write (iw,'(" *  DFORCE     - PRINT FORCE MATRIX OVER CARTESIAN COORDINATES")')
  if (myword(allkey, " HCORE"))   write (iw,'(" *  HCORE      - PRINT DETAILS OF SUBROUTINE HCORE ")')
  if (myword(allkey, " MOLDAT"))  write (iw,'(" *  MOLDAT     - PRINT DETAILS OF SUBROUTINE MOLDAT")')
  if (myword(allkey, " FREQCY"))  write (iw,'(" *  FREQCY     - PRINT DETAILS OF SUBROUTINE FREQCY")')
  if (myword(allkey, " ITER"))    write (iw,'(" *  ITER       - PRINT DETAILS OF SUBROUTINE ITER  ")')
  if (myword(allkey, " LINMIN"))  write (iw,'(" *  LINMIN     - PRINT DETAILS OF SUBROUTINE LINMIN")')
  if (myword(allkey, " MOLSYM"))  write (iw,'(" *  MOLSYM     - PRINT DETAILS OF SUBROUTINE MOLSYM")')
  if (myword(allkey, " RAMA"))    write (iw,'(" *  RAMA       - PRINT RAMACHANDRA ANGLES FOR PROTEIN RESIDUES")')
  if (myword(allkey, " SYMOIR"))  write (iw,'(" *  SYMOIR     - PRINT DETAILS OF SUBROUTINE SYMOIR")')
  if (myword(allkey, " GROUP"))   write (iw,'(" *  GROUP      - PRINT DETAILS OF SUBROUTINE GROUP ")')
  if (myword(allkey, " SYMTRZ"))  write (iw,'(" *  SYMTRZ     - PRINT DETAILS OF SUBROUTINE SYMTRZ")')
  if (myword(allkey, " DENS"))    write (iw,'(" *  DENSITY    - FINAL DENSITY MATRIX TO BE PRINTED")')
  if (myword(allkey, " SPIN"))    write (iw,'(" *  SPIN       - FINAL UHF SPIN MATRIX TO BE PRINTED")')
  if (myword(allkey, " PRNT"))    write (iw,'(" *  PRNT       - EXTRA PRINTING IN EF ROUTINE")')
  if (myword(allkey, " DISP"))    write (iw,'(" *  DISP       - PRINT DISPERSION AND HYDROGEN BOND ENERGIES")')
  if (myword(allkey, " DEP ")) then
10410 format (" *  DEP        - OUTPUT FORTRAN CODE FOR BLOCK-DATA")
10411 format (" *             THIS KEYWORD CANNOT BE USED IN THIS VERSION OF MOPAC.")
    write (iw, 10410)
    write (iw, 10411)
  end if
  if (myword(allkey, " TIMES"))  write (iw,'(" *  TIMES      - TIMES OF VARIOUS STAGES TO BE PRINTED")')
  if (mozyme)then
    if (myword(allkey, " BONDS"))  write (iw,'(" *  BONDS      - NON-HYDROGEN BOND-ORDERS TO BE PRINTED")')
    if (myword(allkey, " ALLBO"))  write (iw,'(" *  ALLBONDS   - ALL SIGNIFICANT BOND-ORDERS TO BE PRINTED")')
  else
    if (myword(allkey, " BONDS"))  write (iw,'(" *  BONDS      - FINAL BOND-ORDER MATRIX TO BE PRINTED")')
  end if
  if (myword(allkey, " SYBYL"))  write (iw,'(" *  SYBYL      - OUTPUT SYBYL FILE")')
  if (myword(allkey, " FOCK"))   write (iw,'(" *  FOCK       - LAST FOCK MATRIX TO BE PRINTED")')
  if (myword(allkey, " LARGE"))  write (iw,'(" *  LARGE      - EXPANDED OUTPUT TO BE PRINTED")')
  log = .false.
  if (myword(allkey, " LOG") .or. &
    (index(keywrd," 0SCF") /= 0 .and. index(keywrd," OLDGEO") /= 0 .and. index(keywrd," PDBOUT") /= 0) .or. &
    index(keywrd, " ADD-H") /= 0 .or. index(keywrd, " HEADER") /= 0) then
    iw0 = 0
    log = .true.
    if (index(keywrd, " LOG") /= 0) write (iw,'(" *  LOG        - GENERATE A LOG FILE")')
  end if
  if (myword(allkey, " NOLOG")) then
    write (iw,'(" *  NOLOG      - SUPPRESS LOG FILE")')
    iw0 = -1
  end if
  if (myword(allkey, " HTML"))   then
    if ((index(keywrd, " STEP=") == 0 .or. index(keywrd, " POINT") == 0) .and. &
    index(keywrd, " IRC") + index(keywrd, " DRC") == 0 .or. index(keywrd, " 0SCF") /= 0) then
      write (iw,'(" *  HTML       - WRITE HTML SCRIPT TO READ PDB FILE USING JSMOL")')
      if (index(keywrd, " PDBOUT") == 0) call l_control("PDBOUT", len_trim("PDBOUT"), 1)
    else
      write (iw,'(" *  HTML       - WRITE HTML SCRIPT TO GENERATE ANIMATION USING JSMOL")')
      if (index(keywrd, " PDBOUT") /= 0) then
        write (iw,'(" *             - TO DISPLAY ENERGIES, DELETE KEYWORD ""PDBOUT""")')
      else
        write (iw,'(" *             - TO DISPLAY IN PDB FORMAT, ADD ""PDBOUT""")')
      end if
    end if
    if (index(keywrd, " PDBOUT") /= 0) then
      if (maxtxt < 26) then
        if (index(keywrd," RESIDUES") == 0) then
          if (index(keywrd, " 0SCF") /= 0) then
             call l_control("RESIDUES", len_trim("RESIDUES"), 1)
          end if
        end if
      end if
    end if
    if ( .not. is_PARAM) then
!
!  Check that file-name is okay
!
      do j = len_trim(input_fn) - 5, 2, -1
        if (input_fn(j:j) == "/" .or. input_fn(j:j) == backslash) exit
      end do
      do i = j, len_trim(input_fn) - 5
        if (input_fn(i:i) == "'") exit
      end do
      if (i < len_trim(input_fn) - 6) then
         call mopend("When HTML is present, the file-name must not contain an apostrophe.")
         write(iw,'(/10x,a)')"(File name = """//input_fn(:len_trim(input_fn) - 5)//""")"
      end if
    end if
  end if
  if (myword(allkey, " NORJSMOL")) write (iw,'(" *  HTML(NORES)- SUPPRESS LIST OF RESIDUES IN HTML FILE")')
  if (myword(allkey, " AIGOUT")) write (iw,'(" *  AIGOUT     - IN ARC FILE, INCLUDE AB-INITIO GEOMETRY")')
  if (myword(allkey, " GRAP"))   write (iw,'(" *  GRAPH      - GENERATE FILE FOR GRAPHICS")')
  if (myword(allkey, " 1ELEC"))  write (iw,'(" *  1ELECTRON  - FINAL ONE-ELECTRON MATRIX TO BE PRINTED")')
  if (myword(allkey, " INTERP")) write (iw,'(" *  INTERP     - PRINT DETAILS OF CAMP-KING CONVERGER")')
  if (myword(allkey, " HTML"))   write (iw,'(" *  HTML       - WRITE HTML SCRIPT TO READ PDB FILE USING JSMOL")')
  if (myword(allkey, " SUPER"))  write (iw,'(" *  SUPER      - PRINT SUPERDELOCALIZABILITIES")')
  if (myword(allkey, " ALLVEC")) write (iw,'(" *  ALLVEC     - PRINT ALL EIGENVECTORS")')
  if (myword(allkey, " H-PRIO")) write (iw,'(" *  H-PRIOR    - HEAT OF FORMATION TAKES PRIORITY IN DRC")')
  if (myword(allkey, " X-PRIO")) write (iw,'(" *  X-PRIOR    - GEOMETRY CHANGES TAKE PRIORITY IN DRC")')
  if (myword(allkey, " T-PRIO")) write (iw,'(" *  T-PRIOR    - TIME TAKES PRIORITY IN DRC")')
  if (myword(allkey, " COMPFG")) write (iw,'(" *  COMPFG     - PRINT HEAT OF FORMATION CALC''D IN COMPFG")')
  if (myword(allkey, " MECI"))   write (iw,'(" *  MECI       - M.E.C.I. WORKING TO BE PRINTED")')
  if (myword(allkey, " HESSIAN"))write (iw,'(" *  HESSIAN    - WRITE OUT HESSIAN FROM GEOMERY OPTIMIZATION")')
  if (myword(allkey, " LOCAL"))  write (iw,'(" *  LOCALIZE   - LOCALIZED ORBITALS TO BE PRINTED")')
  if (myword(allkey, " BANANA")) write (iw,'(" *  BANANA     - MAKE LOCALIZED ORBITALS WITH BANANA BONDS")')
  if (myword(allkey, " RABBIT")) write (iw,'(" *  RABBIT     - MAKE LOCALIZED ORBITALS WITH RABBIT EARS")')
  if (myword(allkey, " MULLIK")) write (iw,'(" *  MULLIK     - THE MULLIKEN ANALYSIS TO BE PERFORMED")')
  if (myword(allkey, " PI "))    write (iw,'(" *  PI         - BONDS MATRIX, SPLIT INTO SIGMA-PI-DELL", &
   & " COMPONENTS, TO BE PRINTED")')
  if (myword(allkey, " ECHO"))   write (iw,'(" *  ECHO       - ALL INPUT DATA TO BE ECHOED BEFORE RUN")')
  if (myword(allkey, " DEBUG ")) write (iw,'(" *  DEBUG      - DEBUG OPTION TURNED ON")')
  if (myword(allkey, " POTWRT")) write (iw,'(" *  POTWRT     - WRITE OUT ELECTRIC POT. DATA TO FILE 21")')
  if (myword(allkey, " PMEP"))   write (iw,'(" *  PMEP       - GENERATE THE WANG-FORD ELECTROSTATIC POTENTIAL")')
  if (myword(allkey, " PRTMEP")) write (iw,'(" *  PRTMEP     - MEP CONTOUR DATA OUTPUT TO <FILENAME>.mep")')
  if (myword(allkey, " MINMEP")) write (iw,'(" *  MINMEP     - PRINT MEP MINIMA IN THE PLANE DEFINED")')
  if (myword(allkey, " PL"))     write (iw,'(" *  PL         - MONITOR CONVERGENCE IN DENSITY MATRIX")')
  if (myword(allkey, " PKA"))    write (iw,'(" *  PKA        - PRINT pKa FOR MOST ACIDIC HYDROGEN")')
  if (myword(allkey, " POPS"))   write (iw,'(" *  POPS       - PRINT SCF ATOMIC ORBITAL POPULATIONS")')
  if (myword(allkey, " BCC"))    write (iw,'(" *  BCC        - THE SYSTEM IS BODY-CENTERED CUBIC")')
  if (myword(allkey, " EIGS"))   write (iw,'(" *  EIGS       - PRINT ALL EIGENVALUES IN ITER")')
  if (myword(allkey, " HYPERF")) write (iw,'(" *  HYPERFINE  - HYPERFINE COUPLING CONSTANTS TO BE PRINTED")')
  if (myword(allkey, " THERMO")) write (iw,'(" *  THERMO     - THERMODYNAMIC QUANTITIES TO BE CALCULATED")')
  if (myword(allkey, " Z=")) then
    write (iw,'(" *  Z=",I2,"     - NUMBER OF FORMULA UNITS IN UNIT CELL")')Nint(Reada(keywrd,Index(keywrd," Z=") + 2))
    if (index(keywrd, " MERS") == 0) call mopend(" *  KEYWORD Z REQUIRES KEYWORD MERS TO BE USED")
  end if
  if (myword(allkey, " K=")) then
    i = Index (keywrd, " K=")
    write (iw,' (" *   K=        - BRILLOUIN ZONE STRUCTURE TO BE CALCULATED")')
    write (iw,'(" *             STEP SIZE IN SAMPLING ZONE:", f8.4)') reada (keywrd, i)
    i = Index (keywrd(i:), ",") + i
    write (iw,'(" *             NO. OF ATOMS IN FUNDAMENTAL UNIT CELL:", i6)') Nint (reada (keywrd, i))
  end if
  return
end subroutine wrtout
subroutine wrtwor (allkey)
  use molkst_C, only: tleft, tdump, keywrd, natoms, numat, mozyme, pdb_label, line
  use chanel_C, only: iw
  implicit none
  character (len=1000), intent (inout) :: allkey
  character :: ch, ch4*4
  character (len=7) :: chrono
  integer :: i, ii, j, k
  double precision :: time, sum_1, sum_2
  logical, external :: myword
  double precision, external :: reada
  intrinsic Index, Min, Nint, Max
  if (myword(allkey, " EIGINV"))     write (iw,'(" *  EIGINV     - USE HESSIAN EIGENVALUE REVERSION IN EF")')
  if (myword(allkey, " NONR"))       write (iw,'(" *  NONR       - DO NOT USE NEWTON-RAPHSON STEP IN EF")')
  if (myword(allkey, " SNAP"))       write (iw,'(" *  SNAP       - INCREASE PRECISION OF SYMMETRY ANGLES")')
  if (myword(allkey, " PULAY"))      write (iw,'(" *  PULAY      - PULAY''S METHOD TO BE USED IN SCF")')
  if (myword(allkey, " CAMP"))       write (iw,'(" *  CAMP,KING- THE CAMP-KING CONVERGER TO BE USED")')
  if (myword(allkey, " KING"))       write (iw,'(" *  CAMP,KING- THE CAMP-KING CONVERGER TO BE USED")')
  if (myword(allkey, " LET"))        write (iw,'(" *  LET        - OVERRIDE SOME SAFETY CHECKS")')
  if (myword(allkey, " OLDGEO"))     write (iw,'(" *  OLDGEO     - PREVIOUS GEOMETRY TO BE USED")')
  if (myword(allkey, " OLDFPC"))     write (iw,'(" *  OLDFPC     - OLD FUNDAMENTAL PHYSICAL CONSTANTS TO BE USED")')
  if (myword(allkey, " OLD_HESS"))   write (iw,'(" *  OLD_HESS   - USE THE OLD HESSIAN MATRIX")')
  if (myword(allkey, " PREC"))       write (iw,'(" *  PRECISE    - TIGHTER CRITERIA TO BE USED")')
  if (myword(allkey, " NOANCI"))     write (iw,'(" *  NOANCI     - DO NOT USE ANALYTICAL C.I. DERIVATIVES")')
  if (myword(allkey, " DFP"))        write (iw,'(" *  DFP        - USE DAVIDON FLETCHER POWELL OPTIMIZER")')
  if (myword(allkey, " XYZ"))        write (iw,'(" *  XYZ        - CARTESIAN COORDINATE SYSTEM TO BE USED")')
  if (myword(allkey, " RESTART"))    write (iw,'(" *  RESTART    - CALCULATION RESTARTED")')
  if (myword(allkey, " RSCAL"))      write (iw,'(" *  RSCAL      - SCALE P-RFO STEP IN EF TO TRUST RADIUS")')
  if (myword(allkey, " SYMAVG"))     write (iw,'(" *  SYMAVG     - AVERAGE SYMMETRY EQUIVALENT ESP CHARGES")')
  if (myword(allkey, " STO3G"))      write (iw,'(" *  STO3G      - DEORTHOGONALIZE ORBITALS IN STO-3G BASIS")')
  if (myword(allkey, " FORCE "))     write (iw,'(" *  FORCE      - FORCE CALCULATION SPECIFIED")')
  if (myword(allkey, " FORCETS"))    write (iw,'(" *  FORCETS    - VERIFY THAT TRANSITION STATE IS GENUINE")')
  if (myword(allkey, " BFGS"))       write (iw,'(" *  BFGS       - USE THE BFGS GEOMETRY OPTIMIZER")')
  if (myword(allkey, " LBFGS"))      write (iw,'(" *  LBFGS      - USE THE LBFGS GEOMETRY OPTIMIZER")')
  if (myword(allkey, " EF"))         write (iw,'(" *  EF         - USE EF ROUTINE FOR MINIMUM SEARCH")')
  if (myword(allkey, " TS"))         write (iw,'(" *  TS         - USE EF ROUTINE FOR TS SEARCH")')
  if (myword(allkey, " LOCATE-TS"))  write (iw,'(" *  LOCATE-TS  - LOCATE A TRANSITION STATE USING REACTANTS AND PRODUCTS")')
  if (myword(allkey, " NOSYM"))      write (iw,'(" *  NOSYM      - POINT-GROUP SYMMETRY SET TO C1")')
  if (myword(allkey, " SMOOTH"))     write (iw,'(" *  SMOOTH     - IN A GRID CALCULATION, REMOVE COMPUTATIONAL ARTIFACTS")')
  if (myword(allkey, " AUTOSYM"))    write (iw,'(" *  AUTOSYM    - SYMMETRY TO BE IMPOSED AUTOMATICALLY")')
  if (myword(allkey, " 1SCF "))      write (iw,'(" *  1SCF       - DO 1 SCF AND THEN STOP ")')
  if (myword(allkey, " SIGMA"))      write (iw,'(" *  SIGMA      - GEOMETRY TO BE OPTIMIZED USING SIGMA.")')
  if (myword(allkey, " NLLSQ"))      write (iw,'(" *  NLLSQ      - GRADIENTS TO BE MINIMIZED USING NLLSQ.")')
  if (myword(allkey, " SADDLE"))     write (iw,'(" *  SADDLE     - TRANSITION STATE TO BE OPTIMIZED")')
  if (myword(allkey, " 0SCF"))       write (iw,'(" *  0SCF       - AFTER READING AND PRINTING DATA, STOP")')
  if (myword(allkey, " QPMEP "))     write (iw,'(" *  QPMEP      - CHARGES DERIVED FROM WANG-FORD TYPE AM1", " MEP")')
  if (myword(allkey, " BIGSCF"))     write (iw,'(" *  BIGSCF     - DO INITIAL FULL SCF WHEN RESTARTING JOB")')
  if (myword(allkey, " WILLIA"))     write (iw,'(" *  WILLIAMS   - USE WILLIAMS SURFACE")')
  if (myword(allkey, " INT "))       write (iw,'(" *  INT        - INTERNAL COORDINATE SYSTEM TO BE USED")')
  if (myword(allkey, " PECI"))       write (iw,'(" *  PECI       - SINGLE AND PAIRED ELECTRON", " EXCITATIONS ONLY")')
!
! Number of threads
!
  if (myword(allkey, " THREADS")) then
    i = Index (keywrd, " THREADS")
    i = nint(reada(keywrd, i))
    i = max(i,1)
#ifdef _OPENMP
    if (i == 1) then
      write (iw,'(" *  THREADS=1  - MULTI-THREADING NOT USED")')
    else if (i < 10) then
      write (iw,'(" *  THREADS    - USE A MAXIMUM OF", i2, " THREADS")') i
    else
      write (iw,'(" *  THREADS    - USE A MAXIMUM OF", i3, " THREADS")') i
    end if
#else
    write (iw,'(" *  THREADS    - INACTIVE (THREAD CONTROLS DISABLED)")')
#endif
  end if
  !                   Times
  chrono = "SECONDS"
  time = 1.0d0
  tleft = 172800.d0 ! two days
  if (myword(allkey, " T=")) then
    i = Index (keywrd, " T=")
    tleft = reada (keywrd, i)
    do j = i + 3, 1000
      if (j == 1000 .or. keywrd(j+1:j+1) == " ") go to 1000
    end do
1010 if (tleft < 99999.9d0) then
       ch = char(ichar("4") + int(log10(tleft)))
       write (iw,'(" *  T=         - A TIME OF", f'//ch//'.1, " ", a, " REQUESTED")') tleft, trim(chrono)
     else
       i = int(log10(tleft)) + 4
       ch4(1:1) = char(ichar("0") + 1)
       ch4(2:2) = char(ichar("0") + i - 10)
       write (iw,'(" *  T=         - A TIME OF", f'//ch4(1:2)//'.1, " ", a, " REQUESTED")') tleft, trim(chrono)
    end if
!
!  Limit time to 999 weeks
!
    tleft = Min (6.0479d8, tleft*time)
    go to 1020
1000  ch = keywrd(j:j)
    if (ch == "M") then
      chrono = "MINUTES"
      time = 60.0d0
    end if
    if (ch == "H") then
      chrono = "HOURS"
      time = 3600.0d0
    end if
    if (ch == "D") then
      chrono = "DAYS"
      time = 86400.0d0
    end if
    if (ch == "W") then
      chrono = "WEEKS"
      time = 7*86400.0d0
    end if
    go to 1010
  else
    ch = char(ichar("4") + int(log10(tleft)))
    write (iw,'(" *  T=         - A TIME OF", f'//ch//'.1, " ", a7, " REQUESTED")') tleft, "SECONDS"
  end if
1020 time = 1.0d0
  chrono = "SECONDS"
  tdump = 7200.d0
  if (myword(allkey, " DUMP")) then
    i = Index (keywrd, " DUMP")
    tdump = reada (keywrd, i)
    do j = i + 6, 1000
      if (j == 1000 .or. keywrd(j+1:j+1) == " ") go to 1030
    end do
1040 if (tdump < 99999.9d0) then
      ch = char(ichar("4") + int(log10(tdump)))
      write (iw,'(" *  DUMP=N     - RESTART FILE WRITTEN EVERY", f'//ch//'.1, " ", a, " REQUESTED")') tdump, trim(chrono)
    else
      i = int(log10(tdump)) + 4
      ch4(1:1) = char(ichar("0") + 1)
      ch4(2:2) = char(ichar("0") + i - 10)
      write (iw,'(" *  DUMP=N     - RESTART FILE WRITTEN EVERY", f'//ch4(1:2)//'.1, " ", a, " REQUESTED")') tdump, trim(chrono)
    end if
    tdump = tdump * time
    go to 1050
1030  ch = keywrd(j:j)
    if (ch == "M") then
      chrono = "MINUTES"
      time = 60.d0
    end if
    if (ch == "H") then
      chrono = "HOURS"
      time = 3600.d0
    end if
    if (ch == "D") then
      chrono = "DAYS"
      time = 86400.d0
    end if
    if (ch == "W") then
      chrono = "WEEKS"
      time = 7*86400.d0
    end if
    go to 1040
  else
    ch = char(ichar("4") + int(log10(tdump)))
    write (iw,'(" *  DUMP=N     - RESTART FILE WRITTEN EVERY", f'//ch//'.1, " ", a7, " REQUESTED")') tdump, "SECONDS"
  end if
1050 if (index(keywrd, " LOCATE-TS") /= 0) then
       if (abs(tleft - 7200) < 0.1d0) tleft = 3.d6
       tdump = 3.d6
     end if
  if (myword(allkey, " CYCLES")) then
    sum_1 = reada (keywrd, Index (keywrd, " CYCLES"))
    ch = char(ichar("2") + int(log10(sum_1)))
    write (iw,'(" *  CYCLES=    - DO A MAXIMUM OF", i'//ch//', " STEPS")') Nint(sum_1)
  end if
  if (myword(allkey, " BIGCYCLES")) then
    sum_1 = reada (keywrd, Index (keywrd, " BIGCYCLES"))
    ch = char(ichar("2") + int(log10(sum_1)))
    write (iw,'(" *  BIGCYCLES  - DO", i'//ch//', " BIG STEPS")') Nint(sum_1)
  end if
!
!**********************************************************************
!
!                   Geometric Quantities
!
  if (myword(allkey, " ALT_A")) then
    write (iw, '(" *  ALT_A=", a1, "    - USE ALTERNATIVE ATOMS WHERE APPROPRIATE")') keywrd (Index (keywrd, " ALT_A")+7: &
     & Index (keywrd, " ALT_A")+7)
    end if
  if (myword(allkey, " ALT_R")) then
    write (iw, '(" *  ALT_R=", a1, "    - USE ALTERNATIVE RESIDUES WHERE APPROPRIATE")') keywrd (Index (keywrd, " ALT_R")+7: &
     & Index (keywrd, " ALT_R")+7)
    end if
  if (myword(allkey, " VDW")) then
    i = Index (keywrd, " VDW")
    j = Index (keywrd(i:), ")") + i
    write (iw, '(" *  ", a, "  USER-DEFINED ATOMIC OR VAN DER WAALS RADII")') keywrd(i + 1:j)
  end if
  if (index(allkey, " METAL") /= 0) then
    j = Index (keywrd, " METAL")
!
!  Force an equals sign in, if one is not present
!
    if (keywrd(j + 6:j + 6) == "(") then
      line = keywrd(:j + 5)//"="//trim(keywrd(j + 6:))
      keywrd = trim(line)
    end if
    i = Index (keywrd, " METAL=")
    if (i == 0) then
!
! The word "METAL" on its own.
!
      write (iw,'(" *  METAL      - METALS ARE DEFINED AS BEING FULLY IONIC")')
    else
!
! The word "METAL" in the construction "METAL=(text)"
!
      j = Index (keywrd(i:), ") ") + i
!
! Write out the labels of all atoms that are explicitely defined in PDB or Jmol format
!

      if (index(keywrd(i:j), '"') /= 0) then
        write (iw, '(" *  METAL        INDIVIDUAL ATOMS DEFINED AS BEING FULLY IONIC")')
        line = keywrd(i + 8:j - 2)
!
! Convert PDB and Jmol format into atom-numbers
!
        do
          k = index(keywrd(i:j), '"')
          if (k == 0) exit
          call txt_to_atom_no(keywrd(i:j), k, .false.)
        end do
!
! Now write out atoms and atom numbers
!
        j = Index (keywrd(i:), ") ") + i
        write (iw, '(" *",15x,a)')"("//trim(line)//") = "//keywrd(i + 8:j - 2)
      else
        j = Index (keywrd(i:), ") ") + i
        write (iw,'(" *  METAL      - THE FOLLOWING ELEMENTS ARE DEFINED AS BEING FULLY IONIC: ", a)') &
          keywrd(i + 8:j - 2)
      end if
    end if
    if (.not. myword(allkey, " METAL")) return ! dummy call to use "myword"
  end if
  if (numat < natoms .and. pdb_label) then
    if (index(keywrd, " RESEQ") + index(keywrd, " ADD-H") + index(keywrd, " SITE") /= 0) then
      call mopend("DUMMY ATOMS CANNOT BE PRESENT WHEN GEOMETRY IS BEING CHANGED")
      if (index(keywrd, " RESEQ") /= 0) write(iw,'(10x,a)')"Geometry is changed by keywrd: RESEQ"
      if (index(keywrd, " ADD-H") /= 0) write(iw,'(10x,a)')"Geometry is changed by keywrd: ADD-H"
      if (index(keywrd, " SITE=(")  /= 0) write(iw,'(10x,a)')"Geometry is changed by keywrd: SITE"
      write(iw,'(10x,a)')"(A simple way to remove dummy atoms is to add keyword ""XYZ"")"
    end if
  end if
  i = index(allkey, " CVB")
  if (i > 0) then
!
! Replace spaces by "_"
!
    j = index(allkey(i + 2:), ") ") + i + 1
    do k = i + 2, j
      if (allkey(k:k) == " ") allkey(k:k) ="_"
    end do
    if (index(keywrd, "ADD-H") /= 0) then
      do
        if (index(keywrd(i:k), "[") /= 0) then
          i = i + index(keywrd(i:k), "[")
          j = index(keywrd(i:k), ".") + i
          if (index(keywrd(i:j), ":") == 0) then
            call mopend("CVB keyword must use chain letters when ADD-H is used")
            write(iw,'(a)')"(Either run ""RESIDUES"" first "// &
            "to assign chain letters, or use CVB after ADD-H has been run.)"
            exit
          else
            i = j
          end if
        else
          exit
        end if
      end do
    end if
  end if
  if (myword(allkey, " CVB")) then
    i = Index (keywrd, " CVB")
    j = Index (keywrd(i:), ")") + i
    if (j - i < 24) then
      write (iw, '(" *  ", a, "  USER-DEFINED EXPLICIT COVALENT BONDS")') keywrd(i + 1:j)
    else
        write (iw, '(" *  USER-DEFINED EXPLICIT COVALENT BONDS:")')
        write (iw, '(" *    ",a)') keywrd(i + 1:j)
    end if
    if (index(keywrd, " RESEQ") /= 0) then
      call mopend("CVB must not be present when RESEQ is used")
      write(iw,*)
    end if
  end if
  if (myword(allkey, " TRANS=")) then
    write (iw, '(" *  TRANS=     - ", i4, " VIBRATIONS ARE TO BE DELETED FROM THE THERMO CALCULATION")') &
     Nint (reada (keywrd, Index (keywrd, " TRANS=")))
  else if (myword(allkey, " TRANS")) then
    write (iw, '(" *  TRANS      - THE REACTION VIBRATION TO BE DELETED FROM THE THERMO CALCULATION")')
  end if
  if (myword(allkey, "MEP=")) then
    i = Nint (reada (keywrd, Index (keywrd, "MEP=")))
    if (i == 1) then
      write (iw, '(" *  MEP=1      - MEP IN A CUBIC GRID")')
    else
      write (iw, '(" *  MEP=2      - MEP IN CONNOLLY SURFACE")')
    end if
  end if
!
!   How hessian matrix is updated.
!
  if (myword(allkey, " IUPD")) then
    ii = Nint (reada (keywrd, Index (keywrd, " IUPD=")))
    if (ii == 0) then
10730   format (" *  IUPD=0     - HESSIAN WILL NOT BE UPDATED")
      write (iw, 10730)
    end if
    if (ii == 1) then
10740   format (" *  IUPD=1     - HESSIAN WILL BE UPDATED USING POWELL")
      write (iw, 10740)
    end if
    if (ii == 2) then
10750   format (" *  IUPD=2     - HESSIAN WILL BE UPDATED USING BFGS")
      write (iw, 10750)
    end if
  end if
!
!   How starting hessian matrix is obtained.
!
  if (myword(allkey, " HESS=")) then
    ii = Nint (reada (keywrd, Index (keywrd, " HESS=")))
    if (ii == 0) then
10760   format (" *  HESS=0     - DIAGONAL HESSIAN USED AS INITIAL GUESS")
      write (iw, 10760)
    end if
    if (ii == 1) then
10770   format (" *  HESS=1     - INITIAL HESSIAN WILL BE CALCULATED")
      write (iw, 10770)
    end if
    if (ii == 2) then
10780   format (" *  HESS=2     - INITIAL HESSIAN READ FROM DISK")
      write (iw, 10780)
    end if
    if (ii == 3) then
10790   format (" *  HESS=3     - INITIAL HESSIAN READ FROM INPUT")
      write (iw, 10790)
    end if
  end if
!
!   Which "normal" mode to follow in geometry
!
  if (myword(allkey, " MODE=")) then
10800 format (" *  MODE=      - FOLLOW HESSIAN MODE", i3, " TOWARD TS")
    write (iw, 10800) Nint (reada (keywrd, Index (keywrd, "MODE=")))
  end if
  if (myword(allkey, " RECALC")) then
10810 format (" *  RECALC=    - DO", i4, " CYCLES BETWEEN HESSIAN RECALC")
    write (iw, 10810) Nint (reada (keywrd, Index (keywrd, "RECALC")))
  end if
  if (myword(allkey, " RMAX")) then
10820 format (" *  RMAX=      - MAX. CALC./PRED. ENERGY STEP IN TS", f7.3)
    write (iw, 10820) reada (keywrd, Index (keywrd, " RMAX="))
  end if
  if (myword(allkey, " RMIN")) then
10830 format (" *  RMIN=      - MIN. CALC./PRED. ENERGY STEP IN TS", f7.3)
    write (iw, 10830) reada (keywrd, Index (keywrd, " RMIN="))
  end if
  if (myword(allkey, " DDMAX")) then
10840 format (" *  DDMAX=     - MAXIMUM TRUST RADIUS", f7.3, " ANG/RAD")
    write (iw, 10840) reada (keywrd, Index (keywrd, " DDMAX="))
  end if
  if (myword(allkey, " DDMIN")) then
10850 format (" *  DDMIN=     - MINIMUM TRUST RADIUS", f7.3, " ANG/RAD")
    write (iw, 10850) reada (keywrd, Index (keywrd, " DDMIN="))
  end if
  if (myword(allkey, " DMAX")) then
10860 format (" *  DMAX=      - STARTING TRUST RADIUS", f7.3, " ANG/RAD")
    write (iw, 10860) reada (keywrd, Index (keywrd, "DMAX="))
  end if
  if (myword(allkey, " OMIN")) then
10870 format (" *  OMIN=      - MINIMUM EIGENVECTOR OVERLAP IN TS", f7.3)
    write (iw, 10870) reada (keywrd, Index (keywrd, "OMIN="))
  end if
  if (myword(allkey, " GNORM")) then
    sum_2 = reada (keywrd, Index (keywrd, " GNORM"))
    ch4 = char(ichar("6") + max(0, min(2,int(log10(sum_2 + 1.d-10)))))//".3"
    write (iw, '(" *  GNORM      - EXIT WHEN GRADIENT NORM DROPS BELOW", f'//ch4//')') sum_2
  end if
  if (myword(allkey, " DELTA")) then
10881 format (" *  DELTA=     - EXIT WHEN ENERGY DIFFERENCE DROPS BELOW ", g10.3)
    write (iw, 10881) reada (keywrd, Index (keywrd, " DELTA"))
  end if
  if (myword(allkey, " BAR")) then
10890 format (" *  BAR=       - REDUCE BAR LENGTH BY A MAX. OF", f7.2)
    write (iw, 10890) reada (keywrd, Index (keywrd, " BAR"))
  end if
  if (myword(allkey, " SLOG=")) then
    i = Index (keywrd, " SLOG=")
10900 format (" *  SLOG=n     - DEFAULT STEP SIZE IN BFGS:", f5.2)
    write (iw, 10900) reada (keywrd, i)
  else if (myword(allkey, " SLOG")) then
10910 format (" *  SLOG       - DEFAULT STEP SIZE IN BFGS: 0.25")
    write (iw, 10910)
  end if
!**********************************************************************
!
!                      SCF quantities
!
!   SCF Criterion
!
  if (myword(allkey, " RELSCF")) then
    if (mozyme) then
      sum_1 = 0.001d0
    else
      sum_1 = 0.0001d0
    end if
    sum_2 = reada (keywrd, Index (keywrd, " RELSCF"))
    ch4 = char(ichar("7") + max(0, min(2,int(log10(sum_2)))))//".4"
    write (iw, '(" *  RELSCF     - DEFAULT SCF CRITERION MULTIPLIED BY", f'//ch4//',/, &
       & " *              (DEFAULT SCF CRITERION =", f8.5, ")")') sum_2, sum_1
  end if
  if (myword(allkey, " SCFCRT")) then
10930 format (" *  SCFCRT     - DEFAULT SCF CRITERION REPLACED BY", g12.3)
    write (iw, 10930) reada (keywrd, Index (keywrd, " SCFCRT"))
  end if
  if (myword(allkey, " SHIFT")) then
10940 format (" *  SHIFT      - A DAMPING FACTOR OF", f8.2, " DEFINED")
    write (iw, 10940) reada (keywrd, Index (keywrd, " SHIFT"))
  end if
  if (myword(allkey, " FILL")) then
10950 format (" *  FILL=      - IN RHF CLOSED SHELL, FORCE M.O.", i3, &
   & " TO BE FILLED")
    write (iw, 10950) Nint (reada (keywrd, Index (keywrd, " FILL")))
  end if
  if (myword(allkey, " ITRY")) then
10960 format (" *  ITRY=      - DO A MAXIMUM OF", i6, " ITERATIONS FOR SCF")
    write (iw, 10960) Nint (reada (keywrd, Index (keywrd, " ITRY")))
  end if
  if (myword(allkey, " DAMP=")) then
10970 format (" *  DAMP=      - DAMP SCF OSCILLATIONS USING DAMP=", f6.2)
    write (iw, 10970) reada (keywrd, Index (keywrd, " DAMP=")+6)
  end if
  if (myword(allkey, " CUTOFF=")) then
10981 format (" *  CUTOFF=    - CUTOFF FOR NDDO AND DIPOLE INTERACTIONS =", f6.2, "A")
    write (iw, 10981) reada (keywrd, Index (keywrd, " CUTOFF=")+8)
  end if
  if (myword(allkey, " CUTOF2=")) then
10980 format (" *  CUTOF2=    - CUTOFF FOR NDDO INTERACTIONS =", f6.2, "A")
    write (iw, 10980) reada (keywrd, Index (keywrd, " CUTOF2=")+8)
  end if
  if (myword(allkey, " CUTOF1=")) then
10990 format (" *  CUTOF1=    - CUTOFF FOR DIPOLE INTERACTIONS =", f6.2, "A")
    write (iw, 10990) reada (keywrd, Index (keywrd, " CUTOF1=")+8)
  end if
  if (myword(allkey, " CUTOFP=")) then
11010 format (" *  CUTOFP=    - CUTOFF FOR POLYMER ELECTROSTATICS =", f6.2, "A")
    write (iw, 11010) reada (keywrd, Index (keywrd, " CUTOFP=")+8)
  end if
  if (myword(allkey, " CUTOFS=")) then
    write (iw, '(" *  CUTOFS=    - CUTOFF FOR OVERLAP INTEGRALS IN " &
    & //"SOLIDS =", f6.2, " A")') reada (keywrd, Index (keywrd, " CUTOFS=")+8)
  end if
  if (myword(allkey, " NLMO=")) then
11020 format (" *  NLMO=N     - AVERAGE NUMBER OF ATOMS PER LMO =", i4)
    write (iw, 11020) Nint (reada (keywrd, Index (keywrd, " NLMO=")))
  end if
  if (myword(allkey, " RELTHR")) then
11030 format (" *  RELTHR     - DEFAULT THRESHOLD FOR LMO's MULTIPLIED BY", &
   & f9.4,/, " *             (DEFAULT WAS 1.D-13)")
    write (iw, 11030) Max (reada (keywrd, Index (keywrd, " RELTHR")), 1.d-12)
  end if
  if (myword(allkey, " THRESH")) then
11040 format (" *  THRESH     - DEFAULT THRESHOLD FOR LMO's:", g12.3)
    write (iw, 11040) Max (reada (keywrd, Index (keywrd, " THRESH")), 1.d-25)
  end if
if (myword(allkey,' SETGPU=')) then
        i = index(keywrd,' SETGPU=')
        j = nint(reada(keywrd,i))
        write (iw,'(" *  SETGPU=   - YOUR CALCULATION WILL RUN IN THE GPU NUM. = ",i2)') j
  end if
  if (myword(allkey,' CPUTHREADS=')) then
     i = index(keywrd,' CPUTHREADS=')
     j = nint(reada(keywrd,i))
     write (iw,'(" *  CPUTHREADS=   - NUM. OF THREADS FOR CPU = ",i2)') j
  end if

  if (myword(allkey, ' FULLDIAG ')) write (iw,'(" *  FULLDIAG   - USE ONLY FULL DIAGONALIZATIONS IN SCF ")')
  return
  end subroutine wrtwor

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine locmin(m, xparam, nvar, p, ssq, alf, efs, ncount)
      use molkst_C, only : numcal, keywrd, escf
      use chanel_C, only : iw
      implicit none
      integer , intent(in) :: m, nvar
      integer  :: ncount
      double precision , intent(inout) :: ssq
      double precision , intent(inout) :: alf
      double precision  :: xparam(nvar)
      double precision , intent(inout) :: p(nvar)
      double precision  :: efs(nvar)
      integer ::  left, right, center, mxcnt2, iprint, icalcn, i, mxct, ictr
      double precision, dimension(nvar) ::  xstor, gstor
      double precision, dimension(3) :: phi, vt
      double precision :: xmaxm, scale, eps, tee, ymaxst, xcrit, xminm, fin, t, &
        tscale, sqstor, energy = 0.d0, estor, alfs, tlast, flast, f, alpha, beta, &
        gamma, abg, s, amdis, sscale, sum, sum2
      logical :: debug, lower
      double precision, external :: ddot
      save  xmaxm, scale, eps, debug, tee, ymaxst, xcrit, mxcnt2, iprint, icalcn
      data icalcn/ 0/
!***********************************************************************
!
!    LOCMIN IS CALLED BY NLLSQ ONLY. IT IS A LINE-SEARCH PROCEDURE FOR
!    LOCATING A MINIMUM IN THE FUNCTION SPACE OF COMPFG.  SEE NLLSQ
!    FOR MORE DETAILS
!
!***********************************************************************
      if (icalcn /= numcal) then
        icalcn = numcal
        xmaxm = 1.D9
        scale = 1.D0
!
! THE ABOVE LINE IS TO TRY TO PREVENT OVERFLOW IN NLLSQ
!
        eps = 1.D-5
        debug = index(keywrd,'LINMIN') /= 0
        tee = 1.D-2
        ymaxst = 0.005D0
        xcrit = 0.0002D0
        mxcnt2 = 30
        iprint = 0
        if (debug) iprint = -1
      end if
      xmaxm = 1.D-11
      do i = 1, nvar
        xmaxm = max(xmaxm,abs(p(i)))
      end do
      xminm = xmaxm*scale
      xmaxm = ymaxst/xmaxm/scale
      fin = ssq
      lower = .FALSE.
      t = alf
      phi(1) = ssq
      vt(1) = 0.0D0
      vt(2) = t/4.0D0
      vt(2) = min(xmaxm,vt(2))
      t = vt(2)
      tscale = t*scale
      xparam(:nvar) = xparam(:nvar) + p(:nvar)*tscale
      call compfg (xparam, .TRUE., escf, .TRUE., efs, .TRUE.)
      phi(2) = ddot(nvar,efs,1,efs,1)
      call exchng (phi(2), sqstor, energy, estor, xparam, xstor, t, alfs, nvar)
      gstor(:m) = efs(:m)
      if (phi(1) <= phi(2)) then
        vt(3) = -vt(2)
        left = 3
        center = 1
        right = 2
      else
        vt(3) = 2.0D0*vt(2)
        left = 1
        center = 2
        right = 3
      end if
      tlast = vt(3)
      t = tlast - t
      tscale = t*scale
      xparam(:nvar) = xparam(:nvar) + p(:nvar)*tscale
      flast = phi(2)
      call compfg (xparam, .TRUE., escf, .TRUE., efs, .TRUE.)
      f = ddot(nvar,efs,1,efs,1)
      if (f < sqstor) call exchng (f, sqstor, energy, estor, xparam, xstor, t, alfs&
        , nvar)
      gstor(:m) = efs(:m)
      if (f < fin) lower = .TRUE.
      ncount = ncount + 2
      phi(3) = f
      if (iprint < 0) then
        write (iw, 310) vt(1), sqrt(phi(1)), vt(2), sqrt(phi(2)), vt(3), sqrt(&
          phi(3))
      end if
      mxct = mxcnt2
      do ictr = 3, mxct
        xmaxm = xmaxm*3.D0
        alpha = vt(2) - vt(3)
        beta = vt(3) - vt(1)
        gamma = vt(1) - vt(2)
        if (alpha == 0.D0) alpha = 1.D-20
        if (beta == 0.D0) beta = 1.D-20
        if (gamma == 0.D0) gamma = 1.D-20
        abg = -(phi(1)*alpha+phi(2)*beta+phi(3)*gamma)/alpha
        abg = abg/beta
        abg = abg/gamma
        alpha = abg
        beta = (phi(1)-phi(2))/gamma - alpha*(vt(1)+vt(2))
        if (alpha <= 0.D0) then
          if (phi(right) <= phi(left)) then
            t = 3.0D0*vt(right) - 2.0D0*vt(center)
          else
            t = 3.0D0*vt(left) - 2.0D0*vt(center)
          end if
          s = t - tlast
          t = s + tlast
        else
          t = -beta/(2.0D0*alpha)
          s = t - tlast
          if (s <= 0.D0) then
            if (s == 0.D0) exit
            amdis = vt(left) - tlast - xmaxm
          else
            amdis = vt(right) - tlast + xmaxm
          end if
          if (abs(s) > abs(amdis)) s = amdis
          t = s + tlast
        end if
        if (ictr>3 .and. abs(s*xminm)<xcrit) then
          if (debug) write (iw, '('' EXIT DUE TO SMALL PROJECTED STEP'')')
          exit
        end if
        t = s + tlast
        sscale = s*scale
        xparam(:nvar) = xparam(:nvar) + p(:nvar)*sscale
        flast = f
        call compfg (xparam, .TRUE., escf, .TRUE., efs, .TRUE.)
        f = ddot(nvar,efs,1,efs,1)
        if (f < sqstor) call exchng (f, sqstor, energy, estor, xparam, xstor, t, &
          alfs, nvar)
        gstor(:m) = efs(:m)
        if (f < fin) lower = .TRUE.
        ncount = ncount + 1
        if (iprint < 0) then
          write (iw, 320) vt(left), sqrt(phi(left)), vt(center), sqrt(phi(&
            center)), vt(right), sqrt(phi(right)), t, sqrt(f)
        end if
!
!    TEST FOR EXCITED STATES AND POTHOLES
!
        if (abs(vt(center)) > 1.D-10) go to 200
        if (abs(t)/(abs(vt(left))+1.D-15) > 0.3333D0) go to 200
        if (2.5D0*f - phi(right) - phi(left) < 0.5D0*phi(center)) go to 200
!
!   WE ARE STUCK ON A FALSE MINIMUM
!
        exit
  200   continue
!
! NOW FOR THE MAIN STOPPING TESTS.  LOCMIN WILL STOP IF:-
!     THE ERROR FUNCTION HAS BEEN REDUCED, AND
!     THE RATE OF DROP OF THE ERROR FUNCTION IS LESS THAN 0.5% PER STEP
!     AND
!     (A) THE RATIO OF THE PROPOSED STEP TO THE TOTAL STEP IS LESS THAN
!         EPS,   OR
!     (B) THE LAST DROP IN ERROR FUNCTION WAS LESS THAN 5%OFTHETOTALDROP
!         DURING THIS CALL TO LOCMIN.
!
        if (debug) write (iw, '('' F/FLAST'',F13.6)') f/flast
        if (lower .and. f/flast>0.995D0) then
          if (abs(t - tlast) <= eps*abs(t + tlast) + tee) then
            if (debug) write (iw, '('' EXIT AS STEP IS ABSOLUTELY SMALL '')')
            exit
          end if
          sum = min(min(abs(f - phi(1)),abs(f-phi(2))),abs(f-phi(3)))
          sum2 = (fin - sqstor)*0.05D0
          if (sum < sum2) then
            if (debug) write (iw, '('' EXIT DUE TO HAVING REACHED BOTTOM'')')
            exit
          end if
        end if
        tlast = t
        if (.not.(t>vt(right) .or. t>vt(center) .and. f<phi(center) .or. t>vt(&
          left) .and. t<vt(center) .and. f>phi(center))) then
          vt(right) = t
          phi(right) = f
        else
          vt(left) = t
          phi(left) = f
        end if
        if (vt(center) >= vt(right)) then
          i = center
          center = right
          right = i
        end if
        if (vt(left) >= vt(center)) then
          i = left
          left = center
          center = i
        end if
        if (vt(center) < vt(right)) cycle
        i = center
        center = right
        right = i
      end do
      call exchng (sqstor, f, estor, energy, xstor, xparam, alfs, t, nvar)
      efs(:m) = gstor(:m)
      ssq = f
      alf = t
      if (t < 0.D0) then
        t = -t
        p(:nvar) = -p(:nvar)
      end if
      alf = t
      return
  310 format(' ---LOCMIN'/,5x,'LEFT   ...',2f19.6,/,5x,'CENTER ...',2f19.6,/,5x&
        ,'RIGHT  ...',2f19.6,/,' ')
  320 format(5x,'LEFT   ...',2f19.6,/,5x,'CENTER ...',2f19.6,/,5x,'RIGHT  ...',&
        2f19.6,/,5x,'NEW    ...',2f19.6,/,' ')
      end subroutine locmin

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine direct(cycle_no)
!
    use param_global_C, only : valvar, numvar, power, ifiles_8, fnsnew, &
    error, factor, tfns, fns, diffns, nfns, ihrefs, refgeo, is_a_ref, &
    refcer, reftot, refger, refher, refder, wthof, wtdip, wtips, wtgeo, wtpKa, &
    contrl, nmols, locvar, molele, maxmol, maxfns, molnum, molnam, nref, refdir, &
    heats, refhof
!
    use molkst_C, only : koment, title,   tleft, gnorm, last, nvar,  &
    moperr,  atheat, norbs, is_PARAM, id, rjkab1, keywrd, line, time0
    use cosmo_C, only : iseps, useps
!
    use chanel_C, only : iw, ir
    use common_arrays_C, only : nat, nfirst, nlast, uspd, xparam, c, cb, loc, &
    geometry => geo, na, nb, nc, coord
!-----------------------------------------------------------------------
    implicit none
    integer :: cycle_no
    logical :: geopt, full, lderivs, lfact, lfast, used, exists
    integer :: i, itime, j, loop, loopar, ndmols, nel, nerr, nhmols, nimols, &
    & ngmols, big_loop, k
    double precision :: aveder, aveher, aveier, delta, erdmod, erhmod, erimod, &
   & rmsder, rmsher, rmsier, sumder, sumerr, sumger, sumher, sumier, lim_gnorm, &
   & ergmod, rmsger, sum, sumpKa, phase = 1.d0, scale_lim, store
    character (len=20), dimension (300) :: ttype
    integer, dimension (maxmol) :: loch
    double precision, dimension (numvar) :: dstep
    double precision, dimension (300) :: differ, errors, yparam
    logical, dimension (maxfns) :: lfact_here
    double precision, external :: seconds, reada
  !
  !.. Intrinsic Functions ..
    intrinsic Abs, Index, Int
  !
  ! ... Executable Statements ...
  !
  !***********************************************************************
  !
  !   PARAMETRIZATION OPTIMISATION PROCEDURE.
  !
  !   DIRECT IS AN ITERATIVE METHOD.  ON EACH CYCLE THE FUNCTION
  !   SSQ (SUM OF SQUARES OF ERRORS) IS CALCULATED, ALONG WITH THE
  !   PRECISE PARTIAL DIFFERENTIALS OF THE ERRORS WITH RESPECT TO ALL
  !   PARAMETERS.
  !
  !   IN A SECOND STEP THE PARAMETERS ARE CHANGED IN "RAPID" SO AS TO
  !   REDUCE THE SSQ.  THE ASSUMPTION IS MADE THAT ONLY ONE MINIMUM
  !   EXISTS, AND THAT THE LOCAL SPACE IS STRICTLY PARABOLIC.
  !
  !***********************************************************************
    geopt = (Index (contrl, "1SCF") == 0)
    lfact = (Index (contrl, " NOSCALE") == 0)
    full = (Index (contrl, "FULL") /= 0)
    lderivs = (Index (contrl, "DERI") /= 0)
    lfast = (Index (contrl, " NOFINE") /= 0)
    useps = (Index (contrl, " EPS") + Index (contrl, " PKA")/= 0)
    iseps = useps
    lim_gnorm = 3.d0
    i = Index (contrl, "GNORM")
    if( i /= 0) lim_gnorm = Reada(contrl, i)
    used = .false.
    j = 0
    k = 0
    sumher = 0.d0
    sumder = 0.d0
    sumier = 0.d0
    sumger = 0.d0
    sumpKa = 0.d0
    nhmols = 0
    ndmols = 0
    nimols = 0
    ngmols = 0
    aveher = 0.d0
    aveder = 0.d0
    aveier = 0.d0
    rmsher = 0.d0
    rmsder = 0.d0
    rmsier = 0.d0
    rmsger = 0.d0
    erhmod = 0.d0
    erdmod = 0.d0
    erimod = 0.d0
    ergmod = 0.d0
    nfns = 0
    phase = - phase
    itime = Int (seconds (1))
    if (cycle_no == 14) then
     i = 1
    end if
    write (ifiles_8, "(2A)") &
    &"   Molecule                                       Time  Heat     "&
    &, "Dipole     I.P.     Geometry     Total"
    if(numvar == -10) open (unit=55, file="CALCD.TXT", status="UNKNOWN",iostat = loop)
    do loop = 1, nmols
      molnum = molnum + 1
      tleft = 10000.d0
      time0 = seconds(1)
    !
    !  Restore all information for molecule number LOOP
    !
      call calpar
      call getmol (loop)
      write(iw,*)trim(koment)
      endfile (iw)
      backspace (iw)
      deallocate(c)
      if (allocated(cb)) deallocate(cb)
      allocate(c(norbs, norbs), cb(norbs, norbs))
      line = molnam
      call upcase (line, len_trim(line))
      if (line(:4) == "CORE") then
!
!  Update core-core heat
!
        do i = 1, nref
          line = trim(refdir(i))//trim(molnam)//".mop"
          inquire (file=trim(line), exist= exists)
          if (exists) goto 99
        end do
        goto 98
    99  open(ir,file=trim(line), iostat=i)
        if (i /= 0) goto 98
        j = 0
        do
          read(ir,'(a)', iostat=i)line
          if (i /= 0) goto  98
          if (line(1:1) /= "*") j = j + 1
          if (j == 3) goto 97
        end do
    97  call upcase (line, len_trim(line))
        i = index(line," H=")
        store = refhof
        refhof = reada(line,i+3)
        close (ir)
        if (Abs(store - refhof) > 0.001d0) then
           write (ifiles_8, "(a,f9.3,a,f9.3,a,a)") " HoF changed from", &
             store, " to", refhof, " kcal/mol for system '"// trim(molnam)//"'"
           heats(loop) = refhof
        end if
      end if
   98 moperr = .false.
      gnorm = 0
      last = 0
    !
    !  If needed, optimize the geometry
    !
  !  Write(ifiles_8,"(A,F12.4)")" Tleft:",tleft
 !     if (cycle_no == 1) is_PARAM = .false.
      if (iseps) then
         call gmetry (geometry, coord)
      ! The following routine constructs the dielectric screening surface
        call cosini(.false.)
      !  if (moperr) goto 100
        call coscav
        call mkbmat
      !  if (moperr) go to 100
      end if
      if (geopt) then
        call optgeo (xparam, yparam, nvar, refgeo(1), lim_gnorm)
      else
         call savgeo (loop, geometry, na, nb, nc, xparam, loc)
      end if
      moperr = .false.
    !
    !  Compute the value of all errors
    !
      rjkab1 = 0.d0
      call parfg (errors, ttype, nerr, loop, .true.)
      if (geopt) then
!
!  Write out the geometry so it can be used by a later run
!
        call savgeo (loop, geometry, na, nb, nc, xparam, loc)
!
!  If unable to write geometry, reset MOPERR and continue
!
        moperr = .false.
      end if
      is_PARAM = .true.
      endfile (ifiles_8)
      backspace (ifiles_8)
      if( .not. is_a_ref(loop)) then
        if (index(keywrd," XFAC") == 0) then
          if (refher /= 0.d0) then
            aveher = aveher + refher
            rmsher = rmsher + Abs(refher) ** power
            erhmod = erhmod + Abs (refher)
            nhmols = nhmols + 1
          end if
        end if
        if (refcer /= 0.d0) then
          aveier = aveier + refcer
          rmsier = rmsier + Abs(refcer) ** power
          erimod = erimod + Abs (refcer)
          nimols = nimols + 1
        end if
        if (refder /= 0.d0) then
          aveder = aveder + refder
          rmsder = rmsder + Abs(refder) ** power
          erdmod = erdmod + Abs (refder)
          ndmols = ndmols + 1
        end if
        if (refger > 1.d-5) then
          if (wtgeo > 1.d-4) then
            do i = 1, nerr
              ergmod = ergmod + Abs(errors(i)/wtgeo)
              rmsger = rmsger + Abs(errors(i)/wtgeo) ** power
            end do
          else
            do i = 1, nerr
              ergmod = ergmod + Abs(errors(i))
              rmsger = rmsger + Abs(errors(i)) ** power
            end do
          end if
          ngmols = ngmols + nerr
          end if
        sumher = sumher + Abs(refher*wthof) ** power
        sumpKa = sumpKa + Abs(refher*wtpKa) ** power
        sumder = sumder + Abs(refder*wtdip) ** power
        sumier = sumier + Abs(refcer*wtips) ** power
        sumger = sumger + refger
        reftot = Abs(refher*(wthof + wtpKa)) ** power + Abs(refder*wtdip) ** power + &
        & Abs(refcer*wtips) ** power + refger
      else
!
!  Set errors for some functions to zero. (these functions are data
!  that are not used by the optimizer, but whose derivatives are used by other
!
        do i = 1, nerr
          errors(i) = 0.d0
        end do
      end if
    !
    !  Store all the errors for use by the parameter optimizer
    !
      do i = 1, nerr
        fns(i+nfns) = errors(i)
        tfns (i+nfns) = koment (1:41) // " " // ttype (i)
      end do
!
!  Set lfact_here: .true. if scaling is allowed for this system
!
      lfact_here(nfns+1) = ((Index( title, " NOSCALE") == 0) .and. lfact)
      do i = 2,nerr
        lfact_here(nfns+i) = lfact_here(nfns+1)
      end do
      if(numvar /= 0) then
        do big_loop = 1,5
        !
        !   Move all parameters delta in the negative direction.
        !
          do loopar = 1, numvar
            if(lfast) then
    !
    !  Trying different step sizes to find the best for the derivatives.
    !
    !   2.d-3 results in a lot of numerical instability
    !   4.d-3 previous value - used from 1999 - 2005
    !   I've not tried higher values than 8.d-3
    !
              dstep(loopar) = 2.d-3
            else
    !
    !   1.d-2 looks good
    !
              dstep(loopar) = 10.d-3*phase !min(max(2.d-2, abs(valvar(loopar)*0.02d0)), 3.d-2 ) * phase
            end if

            delta = -dstep(loopar)
    !
    ! Single-sided derivatives are only good for quick rough work.  For accurate
    ! work, double-sided derivatives are needed.

            if (lfast .and. (id /= 3 .or. locvar(2,loopar) < 200)) &
               call update (locvar(1, loopar), locvar(2, loopar), delta, 1.d0)
          end do
        !
        !  Update derived parameters, USPD, and ATHEAT
        !
          call calpar
          call getusp (nat, nfirst, nlast, uspd, atheat)
        !
        !  Compute the value of all errors at the point -0.5*delta
        !
          call parfg (errors, ttype, nerr, 0, .true.)
        !
        !  For each parameter in turn, step two delta in the positive direction
        !

          do loopar = 1, numvar
            nel = molele(1, loop)
            used = .true.
            do i = 2, nel
              if (mod(locvar(2, loopar),200) == molele(i, loop))  then
                k = 0
                if (locvar(2,loopar) > 200) then
                  k = 1
                  if (molele(i, loop) /= 99) then
                    do j = 2, nel
                      if (locvar(2, loopar)/200 == molele(j, loop) .and. molele(j, loop) /= 99)  k = 0
                    end do
                  end if
                end if
              end if
            end do
            if (id == 3 .and. locvar(2,loopar) < 200) k = 1
            if (k /= 0) then
          !
          !  Set all derivatives to zero IF:
          !  (A) The element whose parameter is being optimized is not present, OR
          !  (B) The system is a solid, and the parameter is not a diatomic.
          !
              do i = 1, nerr
                differ(i) = 0.d0
              end do
              used = .false.
              go to 1100
            end if
           ! if (id == 3) write(ifiles_8,"(2a,2i4,a)")" Derivative for Parameter: ", &
          !    partyp(locvar(1, loopar)), &
            !  mod(locvar(2, loopar),200), locvar(2, loopar)/200, " calculated"
            endfile (ifiles_8)
            backspace (ifiles_8)
            if (.not. lfast) then
        !
        !  Compute the value of all errors at the point -0.5*delta
        !
              delta = -1.d0*dstep(loopar)
              call update (locvar(1, loopar), locvar(2, loopar), delta, 1.d0)
              call calpar
              call getusp (nat, nfirst, nlast, uspd, atheat)
              if (loopar == 8)then
                i = 0
              end if
              call parfg (errors, ttype, nerr, 0, .true.)
            end if
           !
           !  Compute the value of all errors at the point +0.5*delta
           !
            delta = 2.d0*dstep(loopar)
            call update (locvar(1, loopar), locvar(2, loopar), delta, 1.d0)
            call calpar
            call getusp (nat, nfirst, nlast, uspd, atheat) ! Update derived parameters, USPD, and ATHEAT
            call parfg (differ, ttype, nerr, 0, .true.)
           !
           !  Evaluate all derivatives
           !
            do i = 1, nerr
              differ(i) = (differ(i)-errors(i)) / delta
            end do
           !
           !  Store all the derivatives for use by the parameter optimizer
           !
     1100   do i = 1, nerr
              diffns(loopar, i+nfns) = differ(i)
            end do
           !
           ! Step -delta.  This resets the value of the parameter.
           !
            delta=-delta
              call update (locvar(1, loopar), locvar(2, loopar),delta, 1.d0)
            end do
            if (.not. lfast) then
     !
     !  Check that derivatives are being correctly evaluated.
     !
            if (used) then
              call calpar
              call getusp (nat, nfirst, nlast, uspd, atheat)
              call parfg (differ, ttype, nerr, 0, .true.)
              do i = 1, nerr
                 differ(i) = (differ(i)-errors(i)) / delta
              end do
            end if
            j = 0
            do i = 1, nerr  !  do i
              if (abs(differ(i)) > 20 .and. used) then
                j = 1
                if (big_loop == 5) then
       !
       !  Zero out the derivatives - they are not accurate, and can't be made accurate.
       !
                  do loopar = 1, numvar
                    diffns(loopar, i+nfns) = 0.d0
                  end do
                  write(ifiles_8,*)" Derivatives inaccurate - not used"
                end if
              end if
            end do ! do i
            if (j == 0) exit
          else
            exit
          end if
        end do ! big_loop
      end if  ! numvar
    !
    !  Reset the value of all parameters.  These were stored in VALVAR.
    !  VALVAR is updated in rapid0
    !
      do loopar = 1, numvar
        call update (locvar(1, loopar), locvar(2, loopar), valvar(loopar), 0.d0)
      end do

    !
    !  Store location of heat of formation error and derivatives.
    !
      loch(loop) = nfns + 1
      nfns = nfns + nerr
    !
    !  Save the density matrix for use in the next optimization cycle.
    !
      call resetp (1, loop)
    !
    !  Write out information on this system
    !

      if (Mod(loop,5) == 0) then
        do i = 80,2,-2
          if(koment(i:i+1) /= "  ") exit
          koment(i:i+1) = ". "
        end do
      end if
       i = Int (seconds (1))
      if(is_a_ref(loop)) then
      write (ifiles_8, "(A49,I4)") koment, i - itime
      else
      write (ifiles_8, "(A49,I4,F9.3,F9.3,F9.2,F12.3,F12.3)") koment, i - &
     & itime, refher, refder, refcer, refger, reftot
!
!   Print the contribution from pKa and the scalar of the derivative vector
!   of the first reference function.
!
  !    if (wtpKa > 1.d-5) &
  !    & write(ifiles_8,"(a,f12.3,a,f12.3)")"Total pKa:", sumpKa," Gnorm:", &
  !    & sqrt(dot(diffns(1,nfns - nerr + 1), diffns(1,nfns - nerr + 1), numvar - 2))
        if(numvar == -10) then
!
! Write out heats of formation, only, without spaces
!
            if (refher < -999.9950d0) then
             write(55,"(f9.2)",err=95) refher
            else if (refher < -99.9950d0) then
             write(55,"(f8.2)",err=95) refher
             else if (refher < -9.9950d0) then
             write(55,"(f7.2)",err=95) refher
             else if (refher < -0.9950d0) then
             write(55,"(f6.2)",err=95) refher
             else if (refher < 0.0001d0) then
             write(55,"(f5.2)",err=95) refher
             else if (refher < 9.9950d0) then
             write(55,"(f5.2)",err=95) refher
             else if (refher < 99.9950d0) then
             write(55,"(f6.2)",err=95) refher
             else if (refher < 999.9950d0) then
             write(55,"(f7.2)",err=95) refher
            end if
  95  continue
        end if
      end if
      itime = i
      write(iw,*)trim(koment)//" end"
      endfile (iw)
      backspace (iw)
    end do
    write(iw,*)" End of cycle"
    do loop = 1, nmols
      if (ihrefs(1, loop) > 0) then
        call depfn (fns, diffns, loop, loch, ihrefs(1, loop), ihrefs(2, loop), &
       & nfns, numvar)
      end if
    end do
    if (numvar == -10) close (55)
  !
  !  Summarize the errors
  !
    sumerr = sumher + sumder + sumier + sumger + sumpKa
    write (ifiles_8, "(25x,A23,F14.3,F9.3,F9.2,F12.3,F12.3)") " TOTALS", sumher, &
   & sumder, sumier, sumger, sumerr
    if (sumpKa > 1.d0) &
    & write (ifiles_8, "(88x,a,f10.3,a)") " (pKa:",sumpKa,")"
    aveher = aveher / (nhmols+0.000001d0)
    erhmod = erhmod / (nhmols+0.000001d0)
    rmsher = (rmsher/(nhmols+0.000001d0))**(1.d0/power)
    aveder = aveder / (ndmols+0.000001d0)
    erdmod = erdmod / (ndmols+0.000001d0)
    rmsder = (rmsder/(ndmols+0.000001d0))**(1.d0/power)
    aveier = aveier / (nimols+1.d-4)
    rmsier = (rmsier/(nimols+1.d-4))**(1.d0/power)
    erimod = erimod / (nimols+1.d-4)
    rmsger = (rmsger/(ngmols+1.d-5))**(1.d0/power)
    ergmod = ergmod / (ngmols + 1.d-4)
    write (ifiles_8, "(21x,i4,'    AVERAGE ERROR       ',i4,f8.2,i3,f6.2,i5,f5.2,i8,/21x,i4,'&
   &    ROOT MEAN SQUARE ERROR =',f8.2,f9.2,f10.2,f11.2,/,21x,i4,'  UNSIGNED AVE. ERROR     &
   & =',f9.3,f9.3,f10.3,f11.3)") cycle_no, nhmols, aveher, ndmols, aveder, nimols, aveier, &
   & ngmols, cycle_no, rmsher, rmsder, rmsier, rmsger, cycle_no, erhmod, erdmod, erimod, ergmod
    if (fnsnew(1) > -1.d6 .and. numvar > 0) then
      j = 0
      do i = 1, nfns
        error(i) = fns(i) - fnsnew(i)
!
!   If the predicted and calculated quantities are very different, then alter
!   the weighting for that reference datum.
!
!   The weighting factor is just a "best guess".  Currently:
!
        scale_lim = 10.d0
!
!   If the error is less than scale_lim then
!   if the weighting factor is 1.0 ignore it, otherwise increase it
!   If the error is greater than scale_lim, decrease the weighting factor
!
!
        sum = Abs(error(i))
        if (lfact_here(i)) then
      !  if (lfact) then
          if (sum < scale_lim) then
            factor(i) = 1.d0 ! Min(1.d0, (factor(i) + 0.01d0)*2.d0) !  Double scaling factor
          else
            factor(i) =  1.d0/sum**2
          end if
        end if
        if (Abs (fns(i)-fnsnew(i)) > 5.d0) then
          if (j == 0) then
            write (ifiles_8, "(A,43X,2A)") "    Function ", "   Calculated ", " &
           & Predicted     Error      Factor"
            j = 1
          end if
          write (ifiles_8, "(1X,A52,3F12.3,f16.7)") tfns (i), fns (i), fnsnew (i), &
          & error(i), factor(i)
        end if
      end do
    else
      factor = 1.d0
    end if

!    if (full .or. nr) then
!
!  Write out the errors and their weighted derivatives
!
    fnsnew(1:numvar) = 0.d0
    sumerr = 0.d0
    if (full) write(ifiles_8,"(/,'    System                Datum      Error',&
    &'     Derivatives, weighted for errors')")
    do i = 1,nfns
    if (full) write(ifiles_8,"(/2x,A52,F12.4,10(/7x,7f12.4))") &
   & tfns(i),fns(i), &
   & (Sign(1.d0,fns(i))*Abs(fns(i))**(power - 1.d0) * diffns(j, i) * power,j = 1,numvar)
   sumerr = sumerr + Abs(fns(i)) ** power
   do j = 1,numvar
   fnsnew(j) = fnsnew(j)+Sign(1.d0,fns(i))*Abs(fns(i))**(power - 1.d0) * diffns(j, i) * power * factor(i)
   end do
    end do
  ! end if
   if (full) write(ifiles_8,"(/2x,A33,F14.4,3F14.2,10(/7x,7f14.2))") &
   & "Total Error:",sumerr,fnsnew(1:numvar)
   write(ifiles_8,*)
   if (lderivs) then
!
!  Write out the errors and their derivatives
!
    fnsnew(1:numvar) = 0.d0
    sumerr = 0.d0
    write(ifiles_8,"(/,'    System                Datum      Error',&
    &'     Derivatives, NOT weighted for errors')")
    do i = 1,nfns
    write(ifiles_8,"(/2x,A52,F12.4,10(/7x,7f12.4))") &
   & tfns(i),fns(i), (diffns(j,i),j = 1,numvar)
   sumerr = sumerr + Abs(fns(i)) ** power
   do j = 1,numvar
   fnsnew(j) = fnsnew(j)+Sign(1.d0,fns(i))*Abs(fns(i))**(power-1.d0)*diffns(j,i) &
   & * power
   end do
    end do
       write(ifiles_8,"(/2x,A33,F14.4,3F14.4,10(/7x,7f14.4))") &
   & "Total Error:",sumerr,fnsnew(1:numvar)
   end if
   return
   end subroutine direct

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine iter_for_MOZYME (ee)
    use molkst_C, only: norbs, step_num, numcal, nscf, escf, &
       & numat,  enuclr, atheat, emin, keywrd, moperr, line
!
    use chanel_C, only: iw, iend, end_fn
!
    use MOZYME_C, only : icocc, icvir, iorbs, ncocc, &
         ncvir, nncf, nnce, cocc, cvir, nvirtual, noccupied, &
         cocc_dim, icocc_dim, icvir_dim, cvir_dim, nelred, &
         norred, numred, ncf, nce, scfref, thresh, ovmax, tiny, shift, &
         energy_diff, sumt, sumb, ijc, use_three_point_extrap, &
         ws, p1, p2, p3, partf, partp, idiag, mode
!
    use funcon_C, only: fpc_9
    use common_arrays_C, only : f, p
    use iter_C, only : pold
    use cosmo_C, only: useps, lpka, solv_energy
    use linear_cosmo, only : c_proc
    implicit none
!
    double precision, intent (out) :: ee
   !
   !***********************************************************************
   !
   !                   The Occupied Set
   !
   !  COCC:     Starting localized filled M.O.s        Atomic Orbitals
   !  NCOCC:    Starting address of the filled LMOs    Atomic Orbitals
   !  ICOCC:    Atom indices for the filled LMOs       Atoms
   !  NCF:      Number of atoms in each filled LMO     Atoms
   !  NNCF:     Starting address of each M.O. in NCF   Atoms
   !
   !                   The Virtual Set
   !
   !  CVIR:     Starting localized empty M.O.s         Atomic Orbitals
   !  NCVIR:    Starting address of the empty LMOs     Atomic Orbitals
   !  ICVIR:    Atom indices for the empty LMOs        Atoms
   !  NCE:      Number of atoms in each empty LMO      Atoms
   !  NNCE:     Starting address of each M.O. in NCE   Atoms
   !
   !***********************************************************************
    character :: xchar = " "
    logical, save :: prtpls, orthog, times, scf1, bigscf, debug, prtden, &
         & prtfok, okscf, opend, panic = .true., store_useps
    integer, save :: i, idnout, nocc1, nvir1, istabl, idiagg, nhb, itrmax, &
      niter, lno, iemax, iemin, lnv, mn, indi, j, k, l, nij = 0, re_local, &
      icalcn = 0, imol = 0, nmol = 0, lstart = 0, add_niter
    double precision, save :: selcon, eold,  sum
    integer, external :: ijbo
    logical, external :: PLS_faulty
    double precision, external :: helecz, reada
    add_niter = 0
!
        80  continue
    if (nmol /= numcal) then
      !
      !  INITIALIZE
      !
      !     THRESH          ERROR IN H.O.F., RELATIVE TO THRESH=1.D-13
      !
      !     1.D-8             0.21??     SCF unstable
      !     1.D-9             0.0294     SCF stable
      !     1.D-10            0.0112     SCF stable
      !     1.D-11            0.0040     SCF stable
      !     1.D-12            0.0011     SCF stable
      !
      !   IF THRESH IS CHANGED, THEN ALSO CHANGE DEFAULT IN WRTKEY
      !
      thresh = 1.d-13
      scfref = 0.d0
      i = Index (keywrd, " RELTHR")
      if (i /= 0) then
        thresh = reada (keywrd, i) * thresh
      end if
      i = Index (keywrd, " THRESH")
      if (i /= 0) then
        thresh = reada (keywrd, i)
      end if!

      thresh = Max (thresh, 1.d-25)
      prtpls = (Index (keywrd, " PL ") /= 0)
      orthog = (Index (keywrd, " REORTH") /= 0)
      times = (Index (keywrd, " TIMES") /= 0)
      i = Index (keywrd, " DENOUT=")
      if (i /= 0) then
        idnout = Nint (reada (keywrd, i+8))
      else
        idnout = 10000000
      end if
      itrmax = 2000
      if (Index (keywrd, " ITRY") /= 0) then
        itrmax = Nint (reada (keywrd, Index (keywrd, " ITRY")))
      end if
      re_local = 100000000
      i = index(keywrd," RE-LOC")
      if (i /= 0) then
        j = index(keywrd(i + 7:), " ") + i + 7
        if (index(keywrd(i:j), "=") /= 0) then ! Allow for RE-LOC=, RE-LOCAL=, etc.
          i = index(keywrd(i:j), "=") + i
          re_local = nint(reada(keywrd,i))
        end if
      end if
      nocc1 = 0
      nvir1 = 0
      scf1 = (Index (keywrd, " 1SCF") /= 0)
      bigscf = (Index (keywrd, " BIGSCF") /= 0)
      if (Index (keywrd, " OLDEN") == 0) then
        bigscf = .true.
      end if
      debug = (Index (keywrd, " DEBUG") /= 0)
      prtden = (Index (keywrd, " DENS") /= 0 .and. debug)
      prtfok = (Index (keywrd, " FOCK") /= 0 .and. debug)
      debug = (Index (keywrd, " ITER") /= 0)
      idiagg = 0
      nocc1 = noccupied
      store_useps = useps
      if (Index (keywrd, " LEWIS") /= 0) then
        call makvec()
        return
      end if
      if (Index (keywrd, " OLDEN") /= 0) then
          call pinout(0, (index(keywrd, "SILENT") == 0))
          if (add_niter /= 0)  call l_control("OLDEN", len_trim("OLDEN"), -1)
          if (add_niter /= 0)  call l_control("SILENT", len_trim("SILENT"), -1)
          if (moperr) return
          call density_for_MOZYME (p, 0, noccupied, partp)
          partp = p
      else
        useps = .false.
        if (index(keywrd, "OLD_SCF") == 0) call makvec()
      end if
      if (moperr) return
      !
      !  A NEW MOLECULE, THEREFORE SEARCH FOR ALL WEAK INTERACTIONS.
      !
      nhb = 0
    else
      !
      !  A MODIFIED GEOMETRY, THEREFORE SEARCH ONLY FOR NEW
      !  OR VERY WEAK INTERACTIONS.
      !
      nhb = 3
    end if
    if (mod(nscf + 1, re_local) == 0) then
      write(iw,"(/10x,a,/)")"  LMOs being Re-Localized"
      call local_for_MOZYME("OCCUPIED")
      call local_for_MOZYME("VIRTUAL")
    end if
    useps = store_useps
    if (lpka) useps = .true.
    if (icalcn /= step_num) then
      istabl = 0
      eold = 0.d0
      ovmax = 0.d0
      call scfcri (selcon)
      idiagg = 0
      tiny = 0.d0
    end if
    if (index(keywrd," tighten")  /= 0) then
      call l_control("tighten", len_trim("tighten"), -1)
      selcon = max( selcon*0.1d0, 1.d-3)
    end if
   !
   ! Fill the array IDIAG pointing to the diagonal elements of P
   !
    l = 0
    do i = 1, numat
      j = ijbo (i, i)
      do k = 1, iorbs(i)
        l = l + 1
        j = j + k
        idiag(l) = j
      end do
    end do
   !
   !  Zero out POLD and P1 so that the new calculation is not affected
   !  by a previous one.
   !
    pold = 0.d0
    p1 = 0.d0
    nscf = nscf + 1
   !
   !  Force IDIAGG to be even - this is to ensure that DIAGG1
   !  re-builds the interaction list, in case the temporary space
   !  has been used between the calls to ITER.
   !
    if (Mod(idiagg, 2) == 1) idiagg = idiagg + 1
    iemin = 0
    iemax = 0
    niter = 0
    shift = 0.0d0
    use_three_point_extrap = .true.
    if (times) then
      call timer (" At start of ITER")
    end if
!***********************************************************
!
!   Everything is now set up to allow the SCF to be run
!
!***********************************************************
    do  !  Big loop to run the SCF
!----------------
      do
        call tidy (noccupied, ncf, icocc, icocc_dim, cocc, cocc_dim, nncf, ncocc, lno, mn, 1)
        if (moperr) then
!
!  During a run of "tidy", the amount of expansion space for the LMO's to use had
!  become small.  The LMOs were stored to disc.  The old arrays will now be deleted
!  and re-created 60% larger than before.  Then the LMOs are read off disc
!
          deallocate (icocc, cocc, icvir, cvir)

!
!  Re-allocate more memory
!
          icocc_dim = Nint(icocc_dim*1.6)
          cocc_dim = Nint(cocc_dim*1.6)
          icvir_dim = Nint(icvir_dim*1.6)
          cvir_dim = Nint(cvir_dim*1.6)
          allocate (icocc(icocc_dim), cocc(cocc_dim), &
                & icvir(icvir_dim), cvir(cvir_dim), stat = i)
          if (i /= 0) then
            call memory_error(" iter_for MOZYME")
            return
          end if
!
!  Read in old density
!
          call pinout (0, .false.)
          moperr = .false.
        else
          exit
        end if
      end do
      do
        call tidy (nvirtual, nce, icvir, icvir_dim, cvir, cvir_dim, nnce, ncvir, lnv, mn, 2)
        if (moperr) then
!  Delete old memory
!
          deallocate (icocc, cocc, icvir, cvir)

!
!  Re-allocate more memory
!
          icocc_dim = Nint(icocc_dim*1.6)
          cocc_dim = Nint(cocc_dim*1.6)
          icvir_dim = Nint(icvir_dim*1.6)
          cvir_dim = Nint(cvir_dim*1.6)
          allocate (icocc(icocc_dim), cocc(cocc_dim), &
                & icvir(icvir_dim), cvir(cvir_dim), stat = i)
          if (i /= 0) then
            call memory_error(" iter_for MOZYME")
            return
          end if
!
!  Read in old density
!
          call pinout (0, .false.)
          moperr = .false.
        else
          exit
        end if
      end do
!----------------
      nocc1 = nelred / 2
      nvir1 = norred - nocc1
      !
      !   REMOVE ELECTRON DENSITY DUE TO LMO'S INVOLVED IN SCF FROM
      !   THE DENSITY MATRIX
      !
      if (imol /= numcal .or. icalcn /= step_num .and. numat > numred+1) then
        !---------------------------------------------------------
        !
        !   THIS PART IS ONLY RUN WHEN ICALCN IS INCREMENTED
        !
        call density_for_MOZYME (p, 0, noccupied, partp) ! Build the whole density matrix
!
        if (times) call timer (" After DENSIT")
        if (prtden) then
          write (iw, "(' DENSITY MATRIX TO GO INTO PARTP')")
          call vecprt_for_MOZYME (p, norbs)
        end if
        call setupk (nocc1) ! Work out the atom list to be used in the SCF
        if (times) call timer (" After SETUPK")
        if (imol == numcal .and. numat > numred+1) then
          call density_for_MOZYME (partp, -1, nocc1, p) ! Remove density due to atoms to be
                                                        ! used in the SCF
          if (prtden) then
            write (iw, "(' DENSITY MATRIX IN PARTP')")
            call vecprt_for_MOZYME (partp, norbs)
          end if
        end if
        call buildf (f, partf, 0)
        if (prtfok) then
          write (iw, "(' FOCK MATRIX AT START OF ITER')")
          call vecprt_for_MOZYME (f, norbs)
        end if
        if (icalcn /= step_num) then
          if (times) call timer (" After BUILDF")
          ee = helecz()
          if (times) call timer (" After HELEC")
          escf = (ee+enuclr) * fpc_9 + atheat
          if (useps) then
                escf = escf + solv_energy * fpc_9
          end if
          if (prtpls)  write (iw, "(/,A,F16.6,A,/)") " PLS ESCF USING THE OLD LMOs:", escf, " KCAL/MOL"
          endfile (iw)
          backspace (iw)
        end if
        if (imol == numcal .and. numat > numred+1) call buildf (partf, f, -1)
        icalcn = step_num
        imol = numcal
      end if
!
!  Correct any small errors in normalization
!
      call check (nocc1, nncf, ncf, icocc, icocc_dim, iorbs, ncocc, cocc, cocc_dim)
      if (moperr) return
      call check (nvir1, nnce, nce, icvir, icvir_dim, iorbs, ncvir, cvir, cvir_dim)
      if (moperr) return
      if (Mod(niter+1, idnout) == 0) then
        write (iw, "(A)") " .den FILE TO BE WRITTEN OUT"
        endfile (iw)
        backspace (iw)
        call pinout (1, .true.)
        write (iw, "(A)") " .den FILE WRITTEN OUT"
        endfile (iw)
        backspace (iw)
      end if
      call eimp ()
      if (nmol == numcal .and. numat > numred+1) then
        indi = 1
      else
        indi = 0
      end if
      if (niter > 10 .and. add_niter == 0) then
        if (PLS_faulty()) then
!
!  When some systems are run using MOZYME, the DIAGG1 - DIAGG2 combination fails to converge,
!  and the ovmax converges to a non-zero minimum.  If the job is stopped and a <file>.den
!  is generated, then on restarting the same job, the fault is automatically corrected.
!
!  PLS_faulty detects the conditions of the failure, at run time, and silently writes out
!  the <file>.den, then after reading in the same file, it re-runs the SCF calculation.
!  This corrects the fault.
!
          numcal = numcal + 1
          add_niter = niter
          call pinout(1, .false.)
          call l_control("OLDEN", len_trim("OLDEN"), 1)
          call l_control("SILENT", len_trim("SILENT"), 1)
          nscf = nscf - 1
          goto 80
        end if
      end if
      if (bigscf .or. numcal /= 1) then
          call diagg (f, nocc1, nvir1,  idiagg,  partp, indi)
        idiagg = idiagg + 1
      else
        call density_for_MOZYME (p, mode, nocc1,  partp)
        bigscf = .true.
      end if
      niter = niter + 1
      if (Mod(niter, 3) == 0 .and. nhb < 4) then
        nhb = nhb + 1
         !
         !   Check for missed hydrogen bonds and other unusual bonds
         !
          call addhb (nocc1, nvir1, idiagg, nij, nhb)
         !
         !   If hydrogen bonds have been made, set IDIAGG even for DIAGG
         !   to make new interactions.
        if (nij /= 0 .and. Mod (idiagg, 2) == 1) then
          idiagg = idiagg + 1
        end if
      end if
      if (times) then
        if (i == 1) then
          call timer (" After DENS+1")
        else
          call timer (" After DENSIT")
        end if
      end if
      if (use_three_point_extrap) call cnvgz (p, pold, p1, p2, p3, niter, idiag)
      if (times) call timer (" After CNVG")
      if (prtden) then
        write (iw, "(' DENSITY MATRIX ON ITERATION',I4)") niter
        call vecprt_for_MOZYME (p, norbs)
      end if
      if (nmol == numcal .and. numat > numred+1) then
        call buildf (f, partf, 1)  !
      else
        call buildf (f, partf, 0)
      end if
      if (itrmax < 3) return
      if (times) call timer (" After BUILDF")
      if (prtfok) then
        write (iw, "(' FOCK    MATRIX ON ITERATION',I4)") niter
        call vecprt_for_MOZYME (f, norbs)
      end if
      ee = helecz()
      escf = (ee+enuclr) * fpc_9 + atheat
      if (times) call timer (" After HELEC")
      if (useps) then
            escf = escf + solv_energy * fpc_9
      end if
      energy_diff = escf - eold
      eold = escf
      if (Abs(ovmax) < 5.d0*selcon) then
        c_proc = 1.d0
      else
        c_proc = 5.d0*selcon/abs(ovmax)
      end if
      escf = max(-999999.d0, min(999999.d0, escf))
      if (abs(energy_diff) > 9999.D0) energy_diff = 0.D0
      if (prtpls .or. debug .and. niter > itrmax - 20) then
        write (line, "(' ITER.',i7,' PLS=', e10.3,10x,' ENERGY ',f13.5,' DELTAE',f13.7)")  &
        niter + add_niter, ovmax,   escf, energy_diff
        write(iw,"(a)")trim(line)
        call to_screen(line)
        endfile (iw)
        backspace (iw)
        if (debug) then
          write (iw, "(A,F9.6,A,F7.1,A,F9.6,A,F8.2,A,F11.3,A,I7)") "TINY:", &
               & tiny, " SUMT:", sumt, " OVMAX:", ovmax, " SUMB:", sumb, &
               & " DIFF:", energy_diff, " IJ:", ijc
        end if
      end if
      if (debug) then
        call chrge_for_MOZYME (p, ws)
        sum = 0.d0
        do i = 1, numat
          sum = sum + Abs (ws(i))
        end do
        write (iw, "(A,I4)") " Atomic Electron Population on Iteration:", &
               & niter
        write (iw, "(10F8.4)") (ws(i), i=1, numat)
        write (iw, "(A,F12.6)") " Variance:", sum
      end if
      endfile (iw)
      backspace (iw)
      call isitsc (escf, selcon, emin, iemin, iemax, okscf, niter, itrmax)
      if ( .not. bigscf .and. numcal == 1) then
        exit
      else if (okscf .and. niter > 1 .and. (emin /= 0.d0 .or. niter > 3)) then
        exit
      end if
      if (use_three_point_extrap) then
        if (mod(niter,3) == 2 .and. Abs (energy_diff) < 0.1d0) then
          use_three_point_extrap = .false.
          lstart = niter
          shift = 0.0d0
        end if
      else
        if (energy_diff > 0.0d0 .and. shift < 11.0d0 .and. &
             & niter > lstart+2) then
          shift = shift + 2.0d0
          lstart = niter
        end if
      end if
    end do
!************************************************************
!
!   The SCF equations are now solved
!
!************************************************************
    if (istabl > 100000 .and. escf-emin > 200.d0 .and. panic) then
      write (iw, "(A)") " Something disastrous has happened.  " // &
                        & "The LMOs are probably corrupt."
      write (iw, "(A)") " The job should be restarted using RESTART but" // &
             & " OLDENS should NOT be used."
      write (iw, "(/10X,A,F16.6,/10X,A,F16.6)") &
             & " Value of previous Heat of Formation:", emin, &
             & " Value of current Heat of Formation: ", escf
        !
        !          Start the SHUT command.
        !
      inquire (file=end_fn, opened=opend)
      if (opend) then
        rewind (iend)
      else
        open (unit=iend, file=end_fn, status="UNKNOWN")
      end if
      write (iend, "(A)", err=1000) xchar
      go to 1010
        !
        !  The SHUT command is faulty.  Stop everything.
        !
1000  call geout (iw)
      call mopend ("Severe fault in RESTART")
1010  panic = .false.
    end if
    if (Abs (escf-emin) < 1.d0) then
      istabl = istabl + 1
    else
      istabl = 0
    end if
    if (escf < emin .or. emin == 0.d0) then
      emin = escf
    end if
    if (.not. scf1) then
      if (numat > numred+1) then
        call density_for_MOZYME (p, 1, nocc1, partp)
      else
        call density_for_MOZYME (p, 0, nocc1, partp)
      end if
    end if
    icalcn = step_num
    imol = numcal
    if (orthog .and. Mod (nscf + 1, 10) == 1) then
      call reorth (ws)               !   Re-orthogonalize the LMO's
      call density_for_MOZYME (p, 0, noccupied, partp)
      call buildf (f, partf, 0)
      ee = helecz ()
      escf = (ee+enuclr) * fpc_9 + atheat
      if (useps) then
            escf = escf + solv_energy * fpc_9
      end if
    end if
    nmol = numcal
    return
    end subroutine iter_for_MOZYME

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine optgeo (xparam, yparam, nvar, refgeo, glim)
  !**********************************************************************
  !
  !   OPTGEO 1:  Optimizes the current geometry
  !              If the geometry is a geometry reference, the reference
  !              data are restored before exit.
  !  On exit, xparam holds the optimized geometry; geometric references are
  !           NOT changed.
  !           yparam holds to optimized geometric references
  !
  !**********************************************************************
    use param_global_C, only : ifiles_8, molnam, contrl
    use molkst_C, only : moperr, errtxt, escf, keywrd
    use common_arrays_C, only : gradients => grad, loc
    implicit none
    integer, intent (inout) :: nvar
    double precision, intent (in) :: glim
    character (len=12), dimension (300), intent (in) :: refgeo
    double precision, dimension (nvar), intent (inout) :: xparam
    double precision, dimension (nvar), intent (out) ::  yparam
    logical :: lsav
    integer :: i, lim, j
    double precision :: sum
    double precision, dimension (nvar) :: x_store
    integer, dimension (2,nvar) :: loc_store
    external compfg, ef
    double precision, external :: dot
    intrinsic Min, Sqrt
!-------------------------------------------------------------------------
  !
  !  Compute the gradient.
  !
       lim = Min (300, nvar)
       j = 0
       do i = 1, lim
        if (refgeo(i) /= " ") j = j + 1
      end do
      if(nvar - j > 0 .or. nvar == 0)then
        escf = 0.d0
        call compfg (xparam, .true., escf, .true., gradients, .true.)
          if (moperr) then
            write (ifiles_8, "(2A)") " Deadly error detected in COMPFG in OPTGEO, in system ", &
           & molnam
            write (ifiles_8, "(2A)") " Error message:", errtxt (1:50)
          end if
  !
  !  Compute the GNORM.  First, set gradients due to geometric references to zero.
  !
          do i = 1, lim
            if (refgeo(i) /= " ") then
            gradients(i) = 0.d0
          end if
        end do
      if (nvar > 0) then
        sum = Sqrt (dot(gradients, gradients, nvar))
      else
        sum = 0.d0
      end if
    else
      sum=0.d0
    end if
  !
  !  Store the geometric variables - they might be used if PARTAB is
  !  called.
  !
    do i = 1, nvar
      x_store(i) = xparam(i)
      loc_store(1,i) = loc(1,i)
      loc_store(2,i) = loc(2,i)
    end do
  !
  !  If the GNORM is large, re-optimize the geometry
  !
    lsav = (sum > glim)
    if (lsav) then
      if( glim > 0.d0) then
    !
    !  Arrange to optimize only the variables that are NOT geometric references
    !  This is for parameter optimization.  If PARTAB is called, then glim < 0
    !  and the whole geometry is optimized.
    !
        j = 0
        do i = 1,nvar
          if (i > lim .or. refgeo(i) == " ") then
            j = j + 1
            loc(1,j) = loc(1,i)
            loc(2,j) = loc(2,i)
            xparam(j) = xparam(i)
          end if
        end do
        i = nvar
        nvar = j
      end if
      if(nvar == 1) then
       call flepo (xparam, nvar, escf)
      else if(nvar > 1) then
        if (index(keywrd,' LBFGS') + index(contrl,' LBFGS')  /= 0) then
          call lbfgs(xparam, escf)
        else
          call ef (xparam, escf)
        end if
      end if
      if (glim < 0) then
!
!  This is used for PARTAB: restore reference data to xparam,
!  put optimized geometry into yparam
!
        do i = 1, lim
          if (refgeo(i) /= " ") then
            yparam(i) = xparam(i)
            xparam(i) = x_store(i)
            if (abs(gradients(i)) < 1.d-4) gradients(i) = 1.d-4
          end if
        end do
      else
!
!  Restore geometry.  x_store contains the reference geometric data plus the
!  un-optimized geometry.  xparam contains the optimized geometry
!
        nvar = i
        j = 0
        do i = 1, nvar
          if (i > lim .or. refgeo(i) == " ") then
            j = j + 1
            x_store(i) = xparam(j)
          end if
        end do
        do i = 1, nvar
          loc(1,i) = loc_store(1,i)
          loc(2,i) = loc_store(2,i)
          xparam(i) = x_store(i)
        end do
        if (moperr) then
          write (ifiles_8, "(2A)") " Deadly error detected in EF, in system ", molnam
          write (ifiles_8, "(2A)") " Error message:", errtxt (1:50)
        end if
      end if
    end if
    return
end subroutine optgeo

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      double precision function diagi (ialpha, ibeta, eiga, xy, nmos)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!***********************************************************************
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: nmos
      integer , intent(in) :: ialpha(nmos)
      integer , intent(in) :: ibeta(nmos)
      double precision , intent(in) :: eiga(*)
      double precision , intent(in) :: xy(nmos,nmos,nmos,nmos)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j
      double precision :: x
!-----------------------------------------------
!***********************************************************************
!
!  CALCULATES THE ENERGY OF A MICROSTATE DEFINED BY IALPHA AND IBETA
!
!***********************************************************************
      x = 0.0D0
      do i = 1, nmos
        if (ialpha(i) == 0) cycle
        x = x + eiga(i)
        do j = 1, nmos
          x = x + ((xy(i,i,j,j)-xy(i,j,i,j))*ialpha(j)*0.5D0+xy(i,i,j,j)*ibeta(&
            j))
        end do
      end do
      do i = 1, nmos
        if (ibeta(i) == 0) cycle
        x = x + eiga(i)
        do j = 1, i - 1
          x = x + (xy(i,i,j,j)-xy(i,j,i,j))*ibeta(j)
        end do
      end do
      diagi = x
      return
      end function diagi

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      double precision function seconds (mode)
!
!  If mode = 1:   Get current CPU time - CPU_0, and return without checking for <file>.end
!     mode = 2:   Get current CPU time - CPU_0, and return after checking for <file>.end,
!                 if <file>.end exists, and contains anything, increase time by 10^8 seconds.
!
      USE chanel_C, only : iw, iend, end_fn, output_fn
      use molkst_C, only : is_PARAM, wall_clock_0, wall_clock_1, CPU_1, CPU_0, prt_coords
      implicit none
      integer , intent(in) :: mode
      double precision :: shut
      logical :: setok, exists, first = .true., opend
      character :: x
      integer :: i99, l
      integer :: itim1(8), ihour, imin, isec, imsec, jhour = 100, idays = -1
      save
!******************************************************
!
!   SECONDS, ON EXIT, CONTAINS THE NUMBER OF CPU SECONDS
!   SINCE THE START OF THE CALCULATION.
!
!   NOTE: THIS FUNCTION WAS NAMED 'SECOND' IN OLDER
!         MOPAC VERSIONS, WHICH IS THE NAME OF A GNU
!         FORTRAN INTRINSIC FUNCTION
!
!******************************************************
      data setok/ .TRUE./
      data shut/ 0.D0/
      seconds = 0.D0 ! dummy time upon failure
      if (first) then
        first = .false.
!
!   CHECK TO SEE IF AN OLD '.end' FILE EXISTS.  IF IT DOES, DELETE IT.
!
        rewind iend
        open(unit=iend, file=end_fn, status='UNKNOWN', position='asis', iostat = i99)
        if (i99 /= 0) then
          write(iw,"(a)")" File '"//trim(end_fn)//"' is unavailable for use"
          write(iw,"(a)")" Correct the error and re-submit"
          call to_screen(" File '"//trim(end_fn)//"' is unavailable for use")
          call to_screen(" Correct the error and re-submit")
          call mopend("File '"//trim(end_fn)//"' is unavailable for use")
          return
        end if
        read (iend, '(A)', end=20, err=20, iostat = i99) x
!
!   FILE EXISTS.  DELETE IT.
!
        if (ichar(x) /= (-1)) close(iend, status='DELETE')
!
!  Set the zero of time
!
20      call cpu_time(CPU_0)
        call date_and_time(values = itim1)
        ihour = itim1(5)
        imin  = itim1(6)
        isec  = itim1(7)
        imsec = itim1(8)
        wall_clock_0 = float(3600*ihour + 60*imin + isec) + (float(imsec)/1.e3 )
      end if

!**********************************************************************
!
!   NOW TO SEE IF A FILE CALLED <FILENAME>.end EXISTS, IF IT DOES
!   THEN INCREMENT CPU TIME BY 10,000,000 SECONDS.
!
!***********************************************************************
      if (mode == 2) then
        shut = 0.D0
        inquire (file=end_fn, exist = exists)
        if (exists) then
          open(unit=iend, file=end_fn, status='UNKNOWN', position='asis', iostat=i99)
          if (i99 /= 0) then
            close(iend, err=99)   ! Do not stop job if shutdown is faulty
    99      return
          end if
          read (iend, '(A)', end=10, err=10) x
  !
  !          FILE EXISTS, THEREFORE INCREMENT TIME
  !
          shut = 1.D7
          if (setok) then
            write (iw, '(3/10X,''****   JOB STOPPED BY OPERATOR   ****'')')
            if (prt_coords) then
              write (iw, '(3/10X,''****   GEOMETRY AT THIS POINT    ****'')')
              call geout (1)
            end if
            setok = .FALSE.
          end if
     10   continue
          close(iend, iostat = i99)
        end if
      end if
!
!  Every call to second executes the following code
!
      call cpu_time(CPU_1)
      call date_and_time(values = itim1)
      ihour = itim1(5)
      if (ihour < jhour) idays = idays + 1
      jhour = ihour
      ihour = ihour + 24*idays
      imin  = itim1(6)
      isec  = itim1(7)
      imsec = itim1(8)
      wall_clock_1 = float(3600*ihour + 60*imin + isec) + (float(imsec)/1.e3 )
      seconds = dble(wall_clock_1 - wall_clock_0) + shut

      if (is_PARAM) return
 11   endfile (iw, iostat = i99)
      l = 0
      if (i99 /= 0) then
        l = l + 1
        write(0,"(i3,3a)")21 - l," File """,trim(output_fn),""" is unavailable for use"
        write(0,"(a)")"    Correct fault (probably the output file is in use elsewhere)"
        call sleep(5)
        inquire(unit=iw, opened=opend)
        if (opend) close (iw)
        open(unit=iw, file=output_fn, status='UNKNOWN', position='asis')
        if (l < 20) goto 11
        write(0,"(a)") "Job abandoned due to output file being unavailable"
        call mopend("Job abandoned due to output file being unavailable")
        call sleep(5)
        return
      end if
      if (l > 0) then
       write(0,"(a)")" Fault successfully corrected.  Job continuing"
      end if
      backspace (iw)
      return
      end function seconds

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine setcuc (coord, natoms, tvec, id, xtoc)
    use common_keywrd, only : keywrd
    implicit none
    integer, intent (in) :: natoms
    double precision, dimension (3, natoms), intent (inout) :: coord
    double precision, dimension (3, 3), intent (in) :: tvec
    double precision, dimension (3, 3) :: xtoc
    integer, intent (in) :: id
    integer :: i, j, j1, j2, j3, k, l, store_l(3)
    double precision :: sum, summax, summin, storen(3), xyz(3)
    logical :: l_bcc
    l_bcc = (index(keywrd, " BCC") /= 0)
!
!  Make normalized translation vectors
!
    do i = 1, id
      sum = 0.d0
      do j = 1, 3
        sum = sum + tvec(j, i)**2
      end do
      storen(i) = Sqrt (sum)
      sum = 1.d0 / storen(i)
      do j = 1, 3
        xtoc(j, i) = tvec(j, i) * sum
      end do
    end do
!
!   Construct vectors perpendicular to known vectors,
!   if system is of dimension 1 or 2
!
    if (id == 1) then
!
!    Make a vector orthogonal to the first vector
!
      summax = 0.d0
      summin = 1.d0
      do j = 1, 3
        if (Abs (summax) < Abs (xtoc(j, 1))) then
          j1 = j
          summax = xtoc(j, 1)
        end if
        if (Abs (summin) >= Abs (xtoc(j, 1))) then
          j2 = j
          summin = xtoc(j, 1)
        end if
      end do
      j3 = 6 - j1 - j2
      xtoc(j3, 2) = 0.d0
      xtoc(j2, 2) = summax
      xtoc(j1, 2) = -summin
    end if
    if (id /= 3) then
!
!  Make a vector orthogonal to the first and second vectors.
!
      summin = 1.d0
      do j = 1, 3
        sum = xtoc(j, 1)**2 + xtoc(j, 2)**2
        if (summin > sum) then
          j2 = j
          summin = sum
        end if
      end do
      xtoc(j2, 3) = 1.d0
      do j = 1, 3
        if (j /= j2) then
          sum = 0.d0
          do i = 1, 2
            sum = sum + xtoc(j, i) * xtoc(j2, i)
          end do
          xtoc(j, 3) = -sum
        end if
      end do
      sum = 1.d0 / Sqrt (xtoc(1, 3)**2+xtoc(2, 3)**2+xtoc(3, 3)**2)
      do j = 1, 3
        xtoc(j, 3) = xtoc(j, 3) * sum
      end do
    end if
!
!   Expand normalized vectors to their full size
!
    do i = 1, id
      do j = 1, 3
        xtoc(j, i) = xtoc(j, i) * storen(i)
      end do
    end do
!
!   Make unused vectors of length 10
!
    do i = id + 1, 3
      do j = 1, 3
        xtoc(j, i) = xtoc(j, i) * 10.d0
      end do
    end do
!
!  Invert translation vector matrix
!
    call minv (xtoc, 3, sum)
!
!  FORCE ALL ATOMS IN THE CENTRAL UNIT CELL INTO THE DOMAIN 0-1
!
    store_l = 0
    do i = 1, natoms
    xyz = 0.d0
      do k = 1, 3        
        do j = 1, id
          xyz(j) = xyz(j) + coord(k, i) * xtoc(j, k)
        end do
      end do
!
!   XYZ holds the crystal fractional coordinates
!
      k = 0
      do j = 1, id
        l = Int (xyz(j)+20.001d0) - 20
        k = k + l
        store_l(j) = l
      end do
      if (.not. l_bcc .or. mod(k,2) == 0) then
        continue
        do j = 1, id
          l = store_l(j)
          do k = 1, 3
            coord(k, i) = coord(k, i) - l * tvec(k, j)
          end do
        end do
      end if
      continue
    end do
    return
end subroutine setcuc

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

module refkey_C
    implicit none
    character (len=360) :: refkey
    save
end module refkey_C

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine bfn(x, bf)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use overlaps_C, only : fact
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision , intent(in) :: x
      double precision , intent(out) :: bf(13)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: k, io, last, i, m
      double precision :: absx, expx, expmx, y, xf
!-----------------------------------------------
!**********************************************************************
!
!     BINTGS FORMS THE "B" INTEGRALS FOR THE OVERLAP CALCULATION.
!
!**********************************************************************
      k = 12
      io = 0
      absx = abs(x)
      if (absx <= 3.D00) then
        if (absx > 2.D00) then
          last = 15
          go to 60
        end if
        if (absx > 1.D00) then
          last = 12
          go to 60
        end if
        if (absx > 0.5D00) then
          last = 7
          go to 60
        end if
        if (absx <= 1.D-6) go to 90
        last = 6
        go to 60
      end if
      expx = exp(x)
      expmx = 1.D00/expx
      bf(1) = (expx - expmx)/x
      do i = 1, k
        bf(i+1) = (i*bf(i)+(-1.D00)**i*expx-expmx)/x
      end do
      go to 110
   60 continue
      do i = io, k
        y = 0.0D00
        do m = io, last
          xf = 1.0D00
          if (m /= 0) xf = fact(m)
          y = y + (-x)**m*(2*mod(m + i + 1,2))/(xf*(m + i + 1))
        end do
        bf(i+1) = y
      end do
      go to 110
   90 continue
      do i = io, k
        bf(i+1) = (2*mod(i + 1,2))/(i + 1.D0)
      end do
  110 continue
      return
!
      end subroutine bfn

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

module MOZYME_C
!
!  This module holds all the data that is specific to the MOZYME Localized
!  Molecular Orbital (LMO) procedure.
!
    implicit none
    integer :: i
!
!                               Data for the system
!
  integer :: &
    noccupied,   & ! Number of occupied molecular orbitals
    nvirtual,    & ! Number of virtual molecular orbitals
    nres,        & ! Number of amino-acid residues in a polypeptide or protein
    morb,        & ! Maximum number of orbitals on any atom, usually 4 or 9
    ipad2,       & ! Estimate of the average number of atoms in a LMO
    ipad4,       & ! Estimate of the average number of atomic orbital coefficients in a LMO
    uni_res,     & ! Number of unique residues in a protein
    Lewis_tot,   & ! Total number of Lewis elements (occupied plus virtual)
    Lewis_max      ! Maximum number of Lewis elements (size of Lewis_elem buffer)
!
!                              Data on atoms
!
  integer, allocatable, dimension (:) :: &
    iorbs,       &
    jopt
!
!                              Data on diatomic interactions
!
  integer ::     &
    ij_dim         ! Number of interactions treated by NDDO approximations
                   ! = size of arrays iijj and ijall
  logical :: &
    lijbo          ! TRUE if array ijbo is to be used,
                   ! FALSE if the ijbo function is to be used
  integer, dimension (:), allocatable :: &
    iijj,        & !
    iii,         &
    iij,         &
    numij,       &
    ijall          !
  integer, allocatable, dimension (:,:) :: &
    nijbo          ! If it exists, nijbo holds the statring address of array elements
                   ! for atoms i and j in otomic orbital arrays such as P, H, F, etc.
!
!  Protein-specific data
!
  integer, parameter :: &
    maxres = 9999    !  Maximum number of residues allowed in a protein

  integer, dimension(:), allocatable :: &
                  !
                  ! The unique residue number of atom i is at_res(i)
    at_res,     & ! This number is independent of the residue number printed
                  ! and is only used inside MOPAC - it is never printed out
    iz,         & ! Number of valence electrons available for Lewis structure, on each atom
    ib,         & ! Number of valence orbitals available for Lewis structure, on each atom
    ions          ! Charge on ionized atoms, cations = 1 neutral = 0

                  !
  integer, dimension(:,:), allocatable :: &
    Lewis_elem       ! Atoms and atom pairs involved in making the Lewis structure
  integer ::     &
    iatom,       & ! Used in working out residue names
    jatom,       & ! Used in working out residue names
    mxeno,       & ! Used in working out residue names
    k,           &
    loop,        &
    icharges       ! Number of charged sites
   integer :: &
    nxeno(4,11), & ! Up to 10 xeno groups allowed. nxeno(1,*) = number of C,
                   ! 2 = No. on N, 3 = #O, 4 = #S
    nbackb(4),   & ! for each peptide line, nbackb(1) = atom number of C of CHR,
                   ! 2 = # of C of C=O, 3 = # of O of C=O, 4 = # of N
                        !
                        ! For each entry in in_res, res_start contains the atom
    res_start(-20:maxres),& ! number of the first atom in the residue. It is
                        ! only used inside MOPAC - it is never printed out
                        !
    start_res(-20:maxres), &   !
                        !
    bbone(3,-20:maxres) = 0! Atom numbers of the backbone atoms in a polypeptide

   double precision :: &
    angles(3, -20:maxres) !  Phi, Psi, and Omega for backbone angles (Ramachandran)


   character (len=4), dimension (-999:maxres) :: &
     allres        ! Names of all the residues
   data (allres(i), i = -999,0) /1000*"    "/
   data (allres(i), i = 1,maxres) /maxres*"    "/

   integer, parameter :: size_mres = 23
   character :: &
     tyres(size_mres)*3, tyr(size_mres), start_letter(500), allr(-999:maxres), ch*2

   character (len=40), dimension (11) :: &
     txeno         ! Names of xeno groups

!
!   Arrays that hold the localized molecular orbitals
!
!                               Occupied set
!
  integer ::     &
    cocc_dim,    & ! Size of the array cocc
    icocc_dim      ! Size of the array icocc
  integer, dimension (:), allocatable :: &
    ncf,         & ! Number of atoms involved in the LMO
    nncf,        & !  Starting address of the atom numbers of the atoms in the LMO
                   !  nncf(1) = 0
    icocc,       & ! Atom numbers of the atoms in the LMO's
    ncocc          ! Starting address of te atomic orbital coefficients in each LMO
  double precision, dimension (:), allocatable :: &
    cocc           ! Atomic orbital coefficients of the LMO's
!
!                                Virtual set
!
  integer ::     &
    cvir_dim,    & ! Size of the array cvir
    icvir_dim      ! Size of the array icvir
  integer, dimension (:), allocatable :: &
    nce,         & ! Number of atoms involved in the LMO
    nnce,        & ! Starting address of the atom numbers of the atoms in the LMO
                   ! nncf(1) = 0
    icvir,       & ! Atom numbers of the atoms in the LMO's
    ncvir          ! Starting address of te atomic orbital coefficients in each LMO
  double precision, dimension (:), allocatable :: &
    cvir           ! Atomic orbital coefficients of the LMO's
!
!                            Data for SCF and diagonalization
!
  integer, dimension (:,:), allocatable :: &
    ifmo           !
  integer, dimension (:), allocatable :: &
    idiag,       & !

    nfmo           ! Number of filled LMO's that interact with a virtual LMO
  double precision, dimension (:), allocatable :: &
    partf,       & !
    p1,          & !
    p2,          & !
    p3,          & !
    fmo,         & !
    partp,       & !
    parth,       & !
    ws             !

!
  integer ::     &
    nelred,      & ! Number of electrons to be used in the SCF during a geometry optimization.
                   ! In the first SCF, numred = nelecs
    norred,      & ! Number of atomic orbitals to be used in the SCF during a geometry optimization
                   ! In the first SCF, norred = norbs
    numred,      & ! Number of atoms to be used in the SCF during a geometry optimization
                   ! In the first SCF, numred = numat
    fmo_dim,     & ! Size of arrays holding the occupied M.O. - virtual M.O. interactions
    mode,        & !  0 for a simple MOZYME,
                   ! -1 if depleted arrays are to be constructed (RAPID only)
                   ! +1 if arrays are to be built using depleted arrays (RAPID only)
    ijc
  double precision, allocatable, dimension (:,:) ::  &
     part_dxyz
  double precision :: &
    cutofs,      & ! Overlap cut-off distance (normally 7 A)
    thresh,      & ! Criterion for deciding to do Euler rotation to annihilate
                   ! LMO occupied - virtual interaction
    energy_diff, &
    tiny,        &
    sumt,        &
    sumb,        &
    shift,       &
    pmax,        &
    ovmax,       &
    scfref,      &
    refnuc,      &
    refout,      &
    unused
  logical :: &
    rapid,       &      !  True if RAPID technique to be used
    odd_h,       &      !  Control print of banner for quentionable number of hydrogen atoms
    lstart_res(-20:maxres), &  !
    use_three_point_extrap
!
!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
!                    Delete or move everything below here
!
!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    logical ::     &
      direct,      &
      lredop,      &
      semidr

    integer, allocatable, dimension (:) :: &
      isort,       &
      kopt,        &
      iopt
    data tyres / "GLY", "ALA", "VAL", "LEU", "ILE", "SER", "THR", "ASP", &
         & "ASN", "LYS", "GLU", "GLN", "ARG", "HIS", "PHE", "CYS", "TRP", &
         & "TYR", "MET", "PRO", "PRO", "PRO", "UNK" /
    data tyr / "G", "A", "V", "L", "I", "S", "T", "D", "N", "K", "E", "Q", &
         & "R", "H", "F", "C", "W", "Y", "M", "P", "P", "P", "?" /
    character*4 :: atomname(20,14), afn(20)
    integer :: n_add(20)
!
!  Names of all non-hydrogen atoms in each residue
!
  data (atomname(1,i),i=1,4)/" N  "," CA "," C  "," O  "/                                                                          !   GLY
  data (atomname(2,i),i=1,5)/" N  "," CA "," C  "," O  "," CB "/                                                                   !   ALA
  data (atomname(3,i),i=1,6)/" N  "," CA "," C  "," O  "," CB "," OG "/                                                            !   SER
  data (atomname(4,i),i=1,6)/" N  "," CA "," C  "," O  "," CB "," SG "/                                                            !   CYS
  data (atomname(5,i),i=1,7)/" N  "," CA "," C  "," O  "," CB "," CG1"," CG2"/                                                     !   VAL
  data (atomname(6,i),i=1,7)/" N  "," CA "," C  "," O  "," CB "," OG1"," CG2"/                                                     !   THR
  data (atomname(7,i),i=1,8)/" N  "," CA "," C  "," O  "," CB "," CG1"," CG2"," CD1"/                                              !   ILE
  data (atomname(8,i),i=1,7)/" N  "," CA "," C  "," O  "," CB "," CG "," CD "/                                                     !   PRO
  data (atomname(9,i),i=1,8)/" N  "," CA "," C  "," O  "," CB "," CG "," SD "," CE "/                                              !   MET
  data (atomname(10,i),i=1,8)/" N  "," CA "," C  "," O  "," CB "," CG "," OD1"," OD2"/                                             !   ASP
  data (atomname(11,i),i=1,8)/" N  "," CA "," C  "," O  "," CB "," CG "," OD1"," ND2"/                                             !   ASN
  data (atomname(12,i),i=1,8)/" N  "," CA "," C  "," O  "," CB "," CG "," CD1"," CD2"/                                             !   LEU
  data (atomname(13,i),i=1,9)/" N  "," CA "," C  "," O  "," CB "," CG "," CD "," CE "," NZ "/                                      !   LYS
  data (atomname(14,i),i=1,9)/" N  "," CA "," C  "," O  "," CB "," CG "," CD "," OE1"," OE2"/                                      !   GLU
  data (atomname(15,i),i=1,9)/" N  "," CA "," C  "," O  "," CB "," CG "," CD "," OE1"," NE2"/                                      !   GLN
  data (atomname(16,i),i=1,11)/" N  "," CA "," C  "," O  "," CB "," CG "," CD "," NE "," CZ "," NH1"," NH2"/                       !   ARG
  data (atomname(17,i),i=1,10)/" N  "," CA "," C  "," O  "," CB "," CG "," ND1"," CD2"," CE1"," NE2"/                              !   HIS
  data (atomname(18,i),i=1,11)/" N  "," CA "," C  "," O  "," CB "," CG "," CD1"," CD2"," CE1"," CE2"," CZ "/                       !   PHE
  data (atomname(19,i),i=1,12)/" N  "," CA "," C  "," O  "," CB "," CG "," CD1"," CD2"," CE1"," CE2"," CZ "," OH "/                !   TYR
  data (atomname(20,i),i=1,14)/" N  "," CA "," C  "," O  "," CB "," CG "," CD1"," CD2"," NE1"," CE2"," CE3"," CZ2"," CZ3"," CH2"/  !   TRP
!
! "long" names of each residue
!
  data afn/'GLY','ALA','SER','CYS','VAL','THR','ILE','PRO','MET','ASP','ASN','LEU','LYS','GLU','GLN','ARG','HIS','PHE','TYR','TRP'/
!
!  number of non-hydrogen atoms in each residue
!
  data n_add /4,    5,    6,    6,    7,    7,    8,    7,    8,    8,    8,    8,    9,    9,    9,   11,   10,   11,   12,   14/
    save
!
!  All arrays used in "big_swap" - these are the arrays that define the LMOs, the geometry, and some details of the SCF.
!
  integer, allocatable :: &
    nbonds_1(:), ibonds_1(:,:), icocc_1(:), icvir_1(:), ncocc_1(:), ncvir_1(:), &
    nncf_1(:), nncv_1(:), nnce_1(:), nce_1(:), ncf_1(:),  &
    nijbo_1(:,:), iijj_1(:), iij_1(:), ij_dim_1(:), ijall_1(:), numij_1(:), iorbs_1(:), &
    nbonds_2(:), ibonds_2(:,:), icocc_2(:), icvir_2(:), ncocc_2(:), ncvir_2(:), &
    nncf_2(:), nncv_2(:), nnce_2(:), nce_2(:), ncf_2(:),  &
    nijbo_2(:,:), iijj_2(:), iij_2(:), ij_dim_2(:), ijall_2(:), numij_2(:), iorbs_2(:)
    double precision, allocatable :: geo_1(:,:), geo_2(:,:), &
    cocc_1(:), cvir_1(:), cocc_2(:), cvir_2(:), xparam_1(:), xparam_2(:), &
    partf_1(:), partp_1(:), f_1(:), p_1(:), pold_1(:), dxyz_1(:), dxyz_2(:), &
    partf_2(:), partp_2(:), f_2(:), p_2(:), pold_2(:), parth_1(:), parth_2(:)
end module MOZYME_C

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine ptgrp (mt)

!     **** optionally determins molecular point grp			***
!     **** and then determins the symmetry AO transformation		***
!     **** if mt=1, then transformation is of AOs but			***
!     **** if mt=0, then uses only s functions and forms trans of gamma ***

      use reimers_C, only: n, na, natm, nbf, ibf, iat, nbt, &
          iatsym, kind, ncisym, icisym, cisym, nmptg, &
          nmrep, stwt, nptg, nr, ns, nslwr, nsupr, nstr, istr, weight, &
          wk0, cc0, x, y, z, xz, zcore, ion
      USE molkst_C, only: norbs
      USE chanel_C, only: iw

      implicit none
      logical  op(7), isinc(na), isrep
      character*20  lam(2)
      character*15  mtype(0:1)
      character*3       rep
      integer           ictbl(8, 7), nrep(8), jsymt(0:8, 7), ioploc(7, 8), &
                        irs(8), isign(8), jrels(na, 7)
      integer           i, j, k, l, &
                        iao, ier, iop, ir, ja, jsign, jr, jrs, &
                        k1, kc, krs, mt, mu, nop, nrs, nu
      double precision  sum, summ, sumx, sumy, sumz, xo, yo, zo, &
                        pmom(3), ef(3)

      data lam /'     principal      ', ' centroid of charge '/
      data mtype  /' GAMMA TRANSF  ', ' SYMM ORBITALS '/

!     **** effect on s, p, d_eg, and d_t2g orbitals of the 7 symm operators ****
!     **** 1 = symmetric, 2 = asymmetric ****
!     **** line for 7 sym ops: C2z, C2y, C2x, i, SIGxy, SIGxz, SIGyz ****
      data jsymt   / 1, -1, -1, 1,  1, 1,  1, -1, -1, &
     &         1, -1, 1, -1,  1, 1, -1, 1, -1, &
     &         1,  1, -1, -1, 1, 1, -1, -1, 1, &
     &         1, -1, -1, -1, 1, 1,  1, 1, 1, &
     &         1,  1, 1, -1,  1, 1,  1, -1, -1, &
     &         1,  1, -1, 1,  1, 1, -1, 1, -1, &
     &         1, -1, 1, 1,   1, 1, -1, -1, 1  /

!     **** ictbl is the character table: the E op is not included ****
!     **** it is actually D2h, others are eq spaced rows with first cols ****
      data ictbl / 1, 1, 1, 1, -1, -1, -1, -1, 1, 1, -1, -1, 1, 1, -1, -1, &
     &       1, 1, -1, -1, -1, -1, 1, 1, 1, -1, 1, -1, 1, -1, 1, -1, &
     &       1, -1, 1, -1, -1, 1, -1, 1, 1, -1, -1, 1, 1, -1, -1, 1, &
     &       1, -1, -1, 1, -1, 1, 1, -1 /

!     **** ioploc is allowed operators for the point groups ****
      data ioploc / 7*0, 5, 6*0, 1, 6*0, 1, 6, 7, 4*0, 1, 2, 3, 4, 5, 6, 7, &
     &        4, 6*0, 1, 4, 5, 4*0, 1, 2, 3, 4*0 /

!     **** number of irreducible reps in each point group ****
      data nrep /1, 2, 2, 4, 8, 2, 4, 4/

      if (nptg > 0) goto 7

!  correct coordinates to center of gravity

      ef = 0.d0
      summ = 0.D0
      sumx = 0.D0
      sumy = 0.D0
      sumz = 0.D0
      do i = 1, na
        j = natm(i)
        sumx = sumx + x(i) * weight(j)
        sumy = sumy + y(i) * weight(j)
        sumz = sumz + z(i) * weight(j)
        summ = summ +        weight(j)
      end do
      xo = sumx / summ
      yo = sumy / summ
      zo = sumz / summ
      do i = 1, na
        x(i) = x(i) - xo
        y(i) = y(i) - yo
        z(i) = z(i) - zo
      end do

!  determine principal moments of inertia, check for degenerate group
      do k = 1, 3
        do l = k, 3
          sum = 0.D0
          do i = 1, na
            j = natm(i)
            sum = sum + weight(j)*xz(i, k)*xz(i, l)
          end do
          cc0(k, l) = sum
          cc0(l, k) = sum
        end do
      end do

      call tred2e (3, 3, cc0, pmom, wk0, cc0)
      call tql2e  (3, 3,    pmom, wk0, cc0, ier)

      if (abs(pmom(1)-pmom(2)) <  1.d-1 .or. abs(pmom(2)-pmom(3)) <  1.d-1) then
!       **** degenerate, don't rotate coords ****
        write (iw, "(/' This molecule belongs to one of the degenerate point', &
     & 'groups.' / ' The point group given is the highest', &
     & ' non-degenerate subgroup in the orientation used')")
        goto 10
      end if

!     determine prin axes in an equal mass system

      do k = 1, 3
        do l = k, 3
          sum = 0.D0
          do i = 1, na
            j = natm(i)
            sum = sum + xz(i, k)*xz(i, l)
          end do
          cc0(k, l) = sum
          cc0(l, k) = sum
        end do
      end do

      call tred2e (3, 3, cc0, pmom, wk0, cc0)
      call tql2e  (3, 3,    pmom, wk0, cc0, ier)

!     rotation of coordinates

      do i = 1, na
        do k = 1, 3
          sum = 0.D0
          do l = 1, 3
            sum = sum + cc0(l, k)*xz(i, l)
          end do
          pmom(k) = sum
        end do
        do k = 1, 3
          xz(i, k) = pmom(k)
        end do
      end do
      do k = 1, 3
        pmom(k) = cc0(1, k)*ef(1) + cc0(2, k)*ef(2) + cc0(3, k)*ef(3)
      end do
      do k = 1, 3
        ef(k) = pmom(k)
      end do

!     if charged ion, translate to center of charge

   10 if (ion == 1) go to 7
      summ = 0.D0
      sumx = 0.D0
      sumy = 0.D0
      sumz = 0.D0
      do 8 i = 1, na
      summ = summ + zcore(i)
      sumx = sumx + zcore(i)*x(i)
      sumy = sumy + zcore(i)*y(i)
      sumz = sumz + zcore(i)*z(i)
    8 continue
      xo = sumx / summ
      yo = sumy / summ
      zo = sumz / summ
      do 9 i = 1, na
      x(i) = x(i) - xo
      y(i) = y(i) - yo
      z(i) = z(i) - zo
    9 continue

7     continue

!     ********************* search for symm operators *******************
!     **** 1 = yz plane, 2 = xz plane, 3=xy plane, 4=x axis, 5=y axis, ****
!     **** 6 = z axis, 7 = centre ****

      nop = 0
      do i = 1, 7
        call serch (op(i), jrels(1, i), jsymt(0, i), xz, natm, na)
        if (op(i)) nop = nop + 1
      end do

      if (nptg > 0) then
!       **** verify that all required operators are present ****
        do i = 1, nrep(nptg)-1
          iop = ioploc(i, nptg)
          if (.not.op(iop)) then
            write (iw, "(/' ERROR: SYMMETRY OPERATOR #', i2, ' NOT PRESENT')") iop
            write ( 6, "(/' ERROR: SYMMETRY OPERATOR #', i2, ' NOT PRESENT')") iop
            stop 'RESTART SYMMETRY'
          end if
        end do

      else

!     ************************ determine point group ********************

      if (nop == 0) then
!       **** no symmetry ****
        nptg = 1

      else if (nop == 7) then
!       **** D2H ****
        nptg = 5

      else if (nop == 1) then
        if (op(7)) then
!         *** Cs symmetry, is yz plane, ensure that its the xy plane ****
          nptg = 2
          call swaap (xz, ef, op, jrels, 1, 3, na)
        else if (op(6)) then
!         *** Cs symmetry, is xz plane, ensure that its the xy plane ****
          nptg = 2
          call swaap (xz, ef, op, jrels, 2, 3, na)
        else if (op(5)) then
!         *** Cs symmetry ****
          nptg = 2
        else if (op(4)) then
!         *** Ci symmetry ****
          nptg = 6
        else if (op(3)) then
!         **** C2 symmetry, is x axis, ensure that its about z axix ****
          nptg = 3
          call swaap (xz, ef, op, jrels, 1, 3, na)
        else if (op(2)) then
!         **** C2 symmetry, is y axis, ensure that its about z axix ****
          nptg = 3
          call swaap (xz, ef, op, jrels, 2, 3, na)
        else if (op(1)) then
!         **** C2 symmetry ****
          nptg = 3
        end if

      else
        if (op(4)) then
!         **** C2h symmetry, ensure C2 axis is z axis ****
          nptg = 7
          if (op(2)) then
            call swaap (xz, ef, op, jrels, 2, 3, na)
          else if (op(3)) then
            call swaap (xz, ef, op, jrels, 1, 3, na)
          end if

        else if (op(6).or.op(7)) then
!         **** C2V symmetry, ensure that C2 axis is Z axis ****
          nptg = 4
          if (op(2)) then
            call swaap (xz, ef, op, jrels, 2, 3, na)
          else if (op(3)) then
            call swaap (xz, ef, op, jrels, 1, 3, na)
          end if

        else
!         **** D2 symmetry ****
          nptg = 8
        end if
      end if

!     ********** output of modified coordinates **************

      write (iw, "(/' The point group of the molecule is ', a3, a13)") nmptg(nptg)
      write (iw, "(/' coordinates in', a20, 'axis system'/&
     & ' atom     x', 9x, 'y', 9x, 'z     at.#'/)") lam(ion)
      do i = 1, na
          write (iw, '(i4, 3f10.5, 2x, a2)') i, x(i), y(i), z(i), iatsym(natm(i))
      end do

      end if

!     ********************************************************************

!     ******** construct symmetry transform of atomic orbitals ******

!     **** nber of irreducible reps and step siie thru character table rows ****
      nr = nrep(nptg)
      kc = 8 / nr

!     **** loop over all irreducible reps looking for symm orbs ****
      if (allocated(nstr))  deallocate(nstr)
      if (allocated(istr))  deallocate(istr)
      allocate(nstr(norbs))
      allocate(istr(8, norbs))

      nu = 0
      do ir = 1, nr
        ns(ir) = 0
        nslwr(ir) = nu+1

!       **** flags to indicate if an atom has been included or not ****
        do i = 1, na
          isinc(i) = .false.
        end do

!       **** scan over unique atoms ****
        mu = 0
        do i = 1, na
          if (isinc(i)) then
!           **** atom found to be related to an earlier one ****
            mu = mu + nbf(i)

          else
!           **** proceed for first atom in symmetry-related set ****

            do j = 1, nbf(i)
!              write (6, *) 'processing atom', i, ' basis fn', j
              mu = mu + 1
              nrs = 1
              irs(nrs) = i
              isrep = .true.
              do jr = 2, nr
                isign(jr) = 0
              end do
              isign(1) = 1

!             **** loop over allowed symmetry ops for this point grp ****
              do k = 1, nr-1
                k1 = ioploc(k, nptg)

                if (jrels(i, k1).ne.0) then
!                 **** atom is related to another by this symm op ****
                  krs = 0
                  do jrs = 1, nrs
                    if (irs(jrs) == jrels(i, k1)) krs = jrs
                  end do
                  if (krs == 0) then
!                   **** add this atom to list of symmetry-related atoms ****
                    nrs = nrs + 1
                    irs(nrs) = jrels(i, k1)
                    isinc(jrels(i, k1)) = .true.
                    krs = nrs
                  end if

!                 **** calc sign of atom for this irr rep ****
                  jsign = jsymt(mt*nbt(mu), k1) * ictbl(ir*kc, k)
                  if (isign(krs) == 0) then
!                   **** sign for this basis function not yet assigned ****
                    isign(krs) = jsign
                  else if (isign(krs).ne.jsign) then
!                   **** confused sign info means this irr rep not present ***
                    isrep = .false.
                  end if

                else
!                 **** atom maps onto itself by this symm op ****
                  if (jsymt(mt*nbt(mu), k1).ne.ictbl(ir*kc, k)) then
!                   **** this rep does not transform as this ao does ****
                    isrep = .false.
                  end if
                end if

              end do

!             **** if irr rep is found, map out ao signs ****
              if (isrep) then
                nu = nu + 1
                ns(ir) = ns(ir) + 1
                nstr(nu) = nrs
                do jrs = 1, nrs
                  if (isign(jrs) == 0) isign(jrs) = 1
                  iao = mu - ibf(irs(1)) + ibf(irs(jrs))
                  istr(jrs, nu) = isign(jrs) * iao
                end do
              end if

            end do
          end if
        end do
        nsupr(ir) = nu
      end do

!     **** weights for transform vectors ****
      if (allocated(stwt))  deallocate(stwt)
      allocate(stwt(n))

      do i = 1, n
        stwt(i) = sqrt (1.D0/nstr(i))
      end do
!
!     **** output of symmetry transform ****
!
      if (nptg > 1) then
        write (iw, *)
        write (iw, "(a15, 8(1x, a3, '=', i3))") mtype(mt), (nmrep(ir, nptg), ns(ir), ir=1, nr)
        write ( 6, "(a15, 8(1x, a3, '=', i3))") mtype(mt), (nmrep(ir, nptg), ns(ir), ir=1, nr)
      end if

!     **** electron assignment based on symmetry info ****


!     ********* max nber of states of each symmetry to use in CI calc ********

      if (mt == 1) then
      do i = 1, nr
        irs(i) = 0
      end do
      do ir = 1, nr
        rep = nmrep(ir, nptg)
        call upcas(rep)
        do i = 1, ncisym
          if (cisym(i) == rep) irs(ir) = icisym(i)
        end do
      end do
      do i = 1, nr
        icisym(i) = irs(i)
      end do
      end if

      if (nptg == 1) return

!     ************** detailed dump of symmetry transform coefficients *********

      write (iw, "(/' TRANSFORMATION:'/)")
      mu = 0
      do ir = 1, nr
        write (iw, *) 'irred rep ', nmrep(ir, nptg), 'count=', ns(ir)
        do i = 1, ns(ir)
          mu = mu + 1
          j = abs(istr(1, mu))
          ja = iat(j)
          write (iw, '(i4, 1x, a2, 1x, a3, 1x, 8i5)') mu, iatsym(natm(ja)), &
     &        kind(nbt(j)), (istr(k, mu), k=1, nstr(mu))
        end do
      end do

      return
      end subroutine ptgrp

!     *************************************************************************

      subroutine serch (op, jrels, jsymt, xz, natm, na)

      use reimers_C, only: ef

      implicit none
      integer           i, j, k, na, jrels(na), jsymt(0:8), natm(na)
      double precision  tol, xz(na, 3)

      logical           op, nm
      data tol /1.D-5/

!     **** determins if symm op is present, hence atoms related by symm ****

      do i = 1, na
        jrels(i) = 0
      end do
      op = .false.
      do k = 1, 3
        if (jsymt(k) == -1 .and. ef(k).ne.0.0) return
      end do

      do 300 i = 1, na
        if (jrels(i) > 0) goto 300

!	**** check for not moved by symm op ****
        nm = .true.
        do k = 1, 3
          if (jsymt(k) == -1 .and. abs(xz(i, k)) > tol) nm = .false.
        end do

        if (.not.nm) then

!	  **** check for pairs of atoms related by symm ****
          do 200 j = 1, na
!	    **** check if symmetry pair ****
            if (j == i) goto 200
            if (natm(i) .ne. natm(j)) goto 200
            do k = 1, 3
              if (abs(xz(i, k)-xz(j, k)*jsymt(k)) > tol) goto 200
            end do
!	    **** matching atom found ****
            jrels(i) = j
            jrels(j) = i
            goto 300
200       continue

!	  **** only can get here if its moved and no matching atom ****
          op = .false.
          return
        end if

300   continue

      op = .true.
      return
      end subroutine serch

!     *************************************************************************

      subroutine swaap (xz, ef, op, jrels, i, j, na)

      implicit none
      integer           i, j, k, na, &
                        itmp, jrels(na, 7)
      double precision  xz(na, 3), ef(3), tmp
      logical           op(7), op1

!     **** interchanges coordinate axes i and j ****

      op1 = op(4-i)
      op(4-i) = op(4-j)
      op(4-j) = op1
      op1 = op(8-i)
      op(8-i) = op(8-j)
      op(8-j) = op1

      tmp = ef(i)
      ef(i) = ef(j)
      ef(j) = tmp

      do k = 1, na
        tmp = xz(k, i)
        xz(k, i) = xz(k, j)
        xz(k, j) = tmp

        itmp = jrels(k, 4-i)
        jrels(k, 4-i) = jrels(k, 4-j)
        jrels(k, 4-j) = itmp
        itmp = jrels(k, 8-i)
        jrels(k, 8-i) = jrels(k, 8-j)
        jrels(k, 8-j) = itmp
      end do

      return
      end subroutine swaap

!     *************************************************************************

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

subroutine maksym (loc, xparam)
    use common_systm
    use common_geosym, only : locpar, idepfn, locdep
    implicit none
    integer, dimension (2, nvar), intent (inout) :: loc
    double precision, dimension (nvar), intent (inout) :: xparam
    integer :: i, j, locl, loop
    double precision :: twopi, xref, xstore(maxsym)
    twopi = 4.d0 * Asin (1.d0)
    ndep = 0
    do i = 1, nvar
      if (loc(2, i) == 3) then
!
!  FORCE DIHEDRALS INTO SAME HALF-CIRCLE
!
        j = Int (sign(0.5d0, xparam(i))+xparam(i)/twopi)
        xparam(i) = xparam(i) - j * twopi
      end if
      xstore(i) = xparam(i)
    end do
    do loop = 1, nvar
      if (xstore(loop) >=-1.d4) then
        xref = xstore(loop)
        locl = loc(2, loop)
        do i = loop + 1, nvar
          if (Abs (xref-xstore(i)) < 1.d-3 .and. loc(2, i) == locl) then
            ndep = ndep + 1
            locpar(ndep) = loc(1, loop)
            idepfn(ndep) = locl
            locdep(ndep) = loc(1, i)
            xstore(i) = -1.d5
          end if
        end do
      end if
    end do
    j = 0
    do i = 1, nvar
      if (xstore(i) >-1.d4) then
        j = j + 1
        loc(1, j) = loc(1, i)
        loc(2, j) = loc(2, i)
        xparam(j) = xparam(i)
      end if
      nvar = j
    end do
    return
end subroutine maksym

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine resolv(c, cold, mdim, eig, nocc, size_of_LMO)
      use common_arrays_C, only : nfirst, nlast
      use molkst_C, only : norbs, numat, keywrd
      implicit none
      integer , intent(in) :: mdim
      integer , intent(in) :: nocc
      double precision , intent(inout) :: c(mdim,mdim)
      double precision , intent(in) :: cold(mdim,mdim)
      double precision , intent(in) :: eig(nocc), size_of_LMO(nocc)
!
      integer , dimension(4) :: idegen
      integer :: loop, j, k, nsec, i, ij, ii, jj, l, mo1, mo2, mo3, atom_a, atom_b
      double precision, dimension(10) :: sec
      double precision, dimension(16) :: vec
      double precision, dimension(4) :: eigs
      double precision :: thresh, sum1, sum, coi, coj, sum2, sum3, &
        sqrt_2, sqrt_3, sqrt_23, sqrt_6
      logical :: l_banana, l_rabbit, lone_pair, multiple
      logical, allocatable :: used_MO(:)
!***********************************************************************
!
!   RESOLVE removes any ill-definition in the LMOs.
!
!   If two or more LMOs have the same atomic contributions, then
!   any linear combination of these LMOs is an acceptable solution.
!   This is undesirable, in that the energies of these LMOs is therefore
!   not defined.  RESOLVE will identify such sets of LMOs, and resolve
!   them so that they have a zero energy interaction, that is, the
!   integral <psi(1)|F|psi(2)> is zero.
!
!***********************************************************************
      atom_a = 0
      atom_b = 0
      thresh = 0.05d0
      lone_pair = .false.
      l_banana = (index(keywrd, "BANANA") /= 0)
      l_rabbit = (index(keywrd, "RABBIT") /= 0)
      allocate(used_MO(norbs))
      used_MO = .false.
      sqrt_2 = sqrt(0.5d0)
      sqrt_3 = sqrt(1/3.d0)
      sqrt_23 = sqrt(2/3.d0)
      sqrt_6 = sqrt(1/6.d0)

      l160: do loop = 1, nocc
!
!  Test the LMO to see if it is a potential candidate for degeneracy.
!
!  If the LMO is entirely on one atom (a lone pair) or
!  if the LMO is over 30% on one atom and entirely on two atoms (a double or triple bond)
!
        if (used_MO(loop)) cycle
        do j = 1, numat
          if (nlast(j) == nfirst(j)) cycle
          sum1 = 0.D0
          do k = nfirst(j), nlast(j)
            sum1 = sum1 + c(k,loop)**2
          end do
!
!  Only LMOs that are near 100% on an atom (a lone pair) or at least 30% on one atom and entirely
!  on two atoms (a bond) are potential candidates.
!
          if (sum1 > 1.d0 - thresh) then
            lone_pair = .true.
            atom_a = j
            exit
          else if (sum1 > 0.3d0) then
            do l = j + 1, numat
              sum2 = 0.D0
              do k = nfirst(l), nlast(l)
                sum2 = sum2 + c(k,loop)**2
              end do
              if (sum1 + sum2 > 1.d0 - thresh) exit
            end do
            if (l <= numat) then
              atom_a = j
              atom_b = l
              exit
            end if
          end if
        end do
        if (j > numat) then
!
! No atoms qualify as belonging to either a lone pair or to an atom in a diatomic bond
! so go on to the next LMO
!
          continue
          cycle  l160
        end if
!
! If a lone pair, then "atom_a" is the atom involved
! If a bond, then "atom_a" is the first atom, and "atom_b" is the second atom in the bond
!
        nsec = 1
        idegen(nsec) = loop
!
!   LMO 'LOOP' is a candidate.  Now identify any related LMOs
!
        do i = loop + 1, nocc
!
! Check that LMO "i" has not already been used.
!
          if (used_MO(i)) cycle
!
! Check that LMO "i" has roughly the same number of centers as LMO "loop".
! If it does not, then it is not a candidate for rabbit ears or banana bonds
!
          if (abs(size_of_LMO(i) - size_of_LMO(loop)) > 0.3d0) cycle
          multiple = .false.
          sum1 = 0.d0
          do k = nfirst(atom_a), nlast(atom_a)
              sum1 = sum1 + c(k,i)**2
          end do
          if (lone_pair) then
            multiple = (sum1 > 1.d0 - thresh)
          else
            sum2 = 0.d0
            do k = nfirst(atom_b), nlast(atom_b)
                sum2 = sum2 + c(k,i)**2
            end do
            multiple = (sum1 + sum2 > 1.d0 - thresh)
          end if
          if (multiple) then
            nsec = nsec + 1
            idegen(nsec) = i
            used_MO(i) = .true.
          end if
        end do
        if (nsec /= 1 .and. nsec < 4) then
!
!   Build small secular determinant.
!
          ij = 0
          do ii = 1, nsec
            i = idegen(ii)
            do jj = 1, ii
              j = idegen(jj)
              sum = 0.D0
              do l = 1, nocc
                coi = 0.D0
                coj = 0.D0
                do k = 1, norbs
                  coi = coi + cold(k,l)*c(k,i)
                  coj = coj + cold(k,l)*c(k,j)
                end do
                sum = sum + coi*eig(l)*coj
              end do
              ij = ij + 1
              sec(ij) = sum
            end do
          end do
!
!   Diagonalize, to identify LCMO
!
          call rsp (sec, nsec, eigs, vec)
          sum = eigs(1) ! dummy use of eigs
!
!    Crude, but fast, way of rotating LMOs
!
          select case (nsec)
          case default
            mo1 = idegen(1)
            mo2 = idegen(2)
            do i = 1, norbs
              sum1 = vec(1)*c(i,mo1) + vec(2)*c(i,mo2)
              sum2 = vec(3)*c(i,mo1) + vec(4)*c(i,mo2)
              c(i,mo1) = sum1
              c(i,mo2) = sum2
            end do
            if (lone_pair .and. l_rabbit .or. .not. lone_pair .and. l_banana) then
              sum3 = sqrt(0.5d0)
              do i = 1, norbs
                sum1 = sum3*c(i,mo1) + sum3*c(i,mo2)
                sum2 = sum3*c(i,mo1) - sum3*c(i,mo2)
                c(i,mo1) = sum1
                c(i,mo2) = sum2
              end do
            end if
          case (3)
            mo1 = idegen(1)
            mo2 = idegen(2)
            mo3 = idegen(3)
            do i = 1, norbs
              sum1 = vec(1)*c(i,mo1) + vec(2)*c(i,mo2) + vec(3)*c(i,mo3)
              sum2 = vec(4)*c(i,mo1) + vec(5)*c(i,mo2) + vec(6)*c(i,mo3)
              sum3 = vec(7)*c(i,mo1) + vec(8)*c(i,mo2) + vec(9)*c(i,mo3)
              c(i,mo1) = sum1
              c(i,mo2) = sum2
              c(i,mo3) = sum3
            end do
            if (lone_pair .and. l_rabbit .or. .not. lone_pair .and. l_banana) then
              do i = 1, norbs
                sum1 = sqrt_3*c(i,mo1) - sqrt_2*c(i,mo2) +  sqrt_6*c(i,mo3)
                sum2 = sqrt_3*c(i,mo1) + sqrt_2*c(i,mo2) +  sqrt_6*c(i,mo3)
                sum3 = sqrt_3*c(i,mo1)                   - sqrt_23*c(i,mo3)
                c(i,mo1) = sum1
                c(i,mo2) = sum2
                c(i,mo3) = sum3
              end do
              continue
            end if
          end select
        end if
      end do l160
      return
      end subroutine resolv

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

module molkst_C
!
!  This module contains all the scalars relating to the system being calculated.
!  Every entry is unique, and has the same meaning in every subroutine.
!
!
!  This module can also be regarded as a dictionary of the scalars relating to the system.
!  Quantities which have only a one-line description are of no interest outside MOPAC.
!  The data-type for each quantity is given at the start of the statement
!
  integer :: &
  &  maxatoms, & !  Maximum number of atoms allowed = number of lines in the data set
&  txtmax = 26, &!  Number of characters in a PDB label, 27 if insertion residue is present
                 !
  &  natoms,   & !  Term        Number of atoms, real plus dummy, etc., in the system
                 !  Units       Atoms
                 !  Min. value  0
                 !  Max. value  very large
                 !
  &  numat = 0,& !  Term        Number of real atoms in the system
                 !  Units       Atoms
                 !  Min. value  0
                 !  Max. value  very large
                 !
  &  numat_old,& !  Number of real atoms in the system supplied by the data set
  &  norbs,    & !  Term        Number of atomic orbitals in the system
                 !  Units       atomic orbitals
                 !  Min. value  0
                 !  Max. value  very large
                 !
  &  nelecs,   & !  Term        Number of electrons
                 !  Units       Electrons
                 !  Min. value  0
                 !  Max. value  2*norbs
                 !
  &  ispd,     & !  0 if a s-p basis set, 1 or more if any atoms have d-orbitals
  &  ndep = 0, & !  Number of dependent coordinates, related by symmetry
  &  nvar = 0, & !  Number of coordinate that are to be optimized
                 !
  &  nclose,    &!  Term        Number of doubly-occupied M.O.s
                 !  Units       Molecular orbitals
                 !  Min. value  0
                 !  Max. value  nelecs/2
                 !
  &  nopen,    & !  Term        Upper bound of active space in ROHF - C.I.
                 !  Units       Molecular orbitals
                 !  Definition  nclose + number of M.O.s in the active space.
                 !  Min. value  0
                 !  Max. value  norbs
                 !  Default     nclose
                 !
  &  nalpha,   & !  Term        Number of alpha singly-occupied M.O.s
                 !  Units       Molecular orbitals
                 !  Min. value  0
                 !  Max. value  min(norbs, nelecs)
                 !  Default     0 (RHF) (nelecs + 1)/2 (UHF)
                 !
  &  nbeta,    & !  Term        Number of beta singly-occupied M.O.s
                 !  Units       Molecular orbitals
                 !  Min. value  0
                 !  Max. value  min(norbs, nalpha - nelecs)
                 !  Default     0 (RHF) nelecs/2 (UHF)
                 !
  &nalpha_open,& !  Term        Number of alpha fractionally-occupied M.O.s
                 !  Units       Molecular orbitals
                 !  Min. value  0
                 !  Max. value  norbs
                 !  Default     nalpha
                 !
  & nbeta_open,& !  Term        Number of beta fractionally-occupied M.O.s
                 !  Units       Molecular orbitals
                 !  Min. value  0
                 !  Max. value  norbs
                 !  Default     nbeta
                 !
  &  job_no=0, & !  Number of the job.  The first job, which might involve several steps, will have
                 !  job_no = 1.  The second job will have job_no = 2, and so on.
                 !  Most jobs consist of a single operation, see numcal next.
                 !
  &  numcal=0, & !  Number of the calculation.  The first calculation in job 1 will have numcal = 1.
                 !  If there are several calculations in one job, numcal will be incremented with
                 !  each new calculation.  A "calculation" is any operation that assumes that it is
                 !  the first operation.  So, for example, if hydrogen atoms are added, that counts
                 !  as one operation.  The atoms must then be re-sequenced, that counts as a second
                 !  operation. So adding hydrogen atoms is one job with two operations.
                 !
   step_num=0, & !  The unique number of the stage or step within a calculation of a molecule.
                 !  The first stage of the first calculation will have step_num = 1.
                 !  If that calculation involves a second stage, then step_num will be incremented.
                 !  When a new calculation starts, step_num will be incremented.
                 !  Each stage is limited to the same electronic structure.  Most calculations
                 !  will only have one stage, e.g. geometry optimization or force constants.
                 !
  &  mpack,    & !  Number of elements in a lower-half-triangle = (norbs*(norbs+1))/2
  &  n2elec,   & !  Number of two-electron integrals
  &  nscf,     & !  Number of SCF calculations done
  &  iscf,     & !  Index of message of how the SCF ended
  &  npulay    & !  Total number of previous SCF solutions in Pulay converger
  &  = 10,     & !  Default set to standard value in quantum chemistry codes
  &  iflepo,   & !  Index of message of how the geometry operation ended
  &  maxtxt,   & !  Maximum number of characters in labeled atoms (e.g. C(on Si))
  &  last,     & !
  &  na1,      & !  99 if coordinates must be Cartesian, 0 otherwise
  &  lm61,     & !
  &  nbreaks,  & !  Number of breaks in a PDB structure
                 !
  &  no_pKa,   & !  Number of ionizable hydrogen atoms used in pKa calculation
  &  id,       & !  Term        Dimensionality of system
                 !  Definition  Number of infinite dimensions of the system
                 !  Units       none
                 !  Min. value  0  (A discrete molecule or ion)
                 !  Max. value  3  (A regular solid)
                 !
  &  l1u,      & !  Number of unit cells in the first dimension used in solid-state work (0 for a molecule)
  &  l2u,      & !  Number of unit cells in the second dimension (0 for a molecule or polymer)
  &  l3u,      & !  Number of unit cells in the third dimension (0 for a molecule, polymer, or layer system)
  &  l123,     & !  Total number of unit cells (=1 for a molecule = (2*l1u + 1)*(2*l2u + 1)*(2*l3u + 1))
  &  l11,      & !  1 if l1u > 0, 0 otherwise
  &  l21,      & !  1 if l2u > 0, 0 otherwise
  &  l31,      & !  1 if l3u > 0, 0 otherwise
  &  msdel,    & !  Magnetic component of spin
  &  Run = 1,  & !  Run-number (=1 if a single job)
  &  ilim,     & !  Number of temperatures in a thermodynamics calculation
  &  ncomments,& !  Number of lines of comment
  &  mers(3),  & !  Number of mers in each direction, in solids
  &  itemp_1,  & !  Used for very temporary transfer of information
  &  itemp_2,  & !  Used for very temporary transfer of information
  &  lpars,    & !  Number of parameters read from parameter files
  &  n_screen, & !  Used to pass information about type of output to "to_screen"
  &  nl_atoms, & !  number of atoms to be printed.
  &  old_chrge,& !  Net charge from the previous calculation, if it exists.
  &  N_Hbonds, & !  Number of hydrogen bonds, with energy < -1 kcal/mol, found in system
  &  P_Hbonds, & !  Number of hydrogen bonds found in system
  &  dummy
  real ::          &
    CPU_0,         & !  Start of CPU time (in seconds)
    CPU_1,         & !  Curresnt CPU time (in seconds)
    wall_clock_0,  & !  Start of wall-clock time (in seconds)
    wall_clock_1     !  Current wall-clock time (in seconds)
  double precision ::  &
  & arc_hof_1,     & !  Heat of formation from an old ARC file
  & arc_hof_2,     & !  Heat of formation from another old ARC file
  &  escf,         & !  Term        Heat of formation at 298 K
                     !  Units       kcal/mole
                     !  Unit type   Heat of Formation in kcal/mol
                     !  Min. value  ~-20000
                     !  Max. value  ~+20000
                     !
  &  emin,         & !  Lowest heat of formation calculated.
                     !
  &  elect,        & !  Term        Electronic energy
                     !  Units       eV
                     !  Definition  Total electronic energy of the system in electron volts
                     !  Min. value  Very negative
                     !  Max. value  0.0
                     !
  &  enuclr,       & !  Term        Nuclear energy
                     !  Units       eV
                     !  Definition  Total core-core repulsion energy in eV
                     !  Min. value  0.0
                     !  Max. value  Very large
                     !
  &  fract,        & !  Term        Fractional occupancy of M.O.s in active space
                     !  Units       Electrons
                     !  Definition  Number of electrons in active space divided by number of M.O.s in active space
                     !  Min. value  0.0
                     !  Max. value  2.0
                     !  Default     0.0
                     !
  &  gnorm = 0.d0, & !  Term        Scalar of gradient vector
                     !  Units       kcal/mol/(Angstrom - Radians)
                     !  Definition  The square root of the sum of the squares of the gradient components
                     !
  &  mol_weight,   & !  Term        Molecular weight
                     !  Units       Atomic mass units (Hydrogen = 1.00794 on this scale)
                     !  Min. value  0.0
                     !  Max. value  Very large
                     !
  &  time0 = 0.d0, & !  The start of time, or when the job began (seconds)
  &  tleft,        & !  Number of seconds the job has left before running out of time
  &  tdump = 0.d0, & !  Time between checkpoint dumps (seconds)
  &  cosine,       & !  Angle between previous and current gradient vectors
  &  ux, uy, uz,   & !  Dipole components (?)
  &  step,         & !  "step" in SADDLE calculation
  &  rjkab1,       & !  "J" and "K" integrals for correction of doublet I.P.
  &  atheat,       & !  Sum of atomic heats of formation
  &  hpress,       & !  Energy due to pressure (solids only)
  &  nsp2_corr,    & !  PM6 >N- correction
  &  Si_O_H_corr,  & !  PM7 Si-O-H correction
  &  sum_dihed,    & !  Peptide twist correction (sets barrier in Me-CO-NH-ME to the correct value)
                     !
  &  efield(3),    & !  Term        Electric field
                     !  Definition  Applied external electric field components in X, Y, and Z.
                     !  Units       Atomic units per Bohr
                     !  Min. value  Very negative
                     !  Max. value  Very positive
                     !  Default     0.0, 0.0, 0.0
                     !
  &  cutofp,       & !  Cutoff distance for NDDO approximation in solid state
                     !  Default     10**(10) for molecules, 30 for polymers, layers, solids
  &  clower = 0.d0,& !  Lower bound for transition to point charges in solid-state
                     !  Default     13 Angstroms
  &  cupper,       & !  Upper bound for transition to point charges in solid-state
                     !  Default     cutofp
                     !
  &  pressure,     & !  Term        Pressure or stress for solid-state and polymer work
                     !  Definition  Applied isotropic pressure (for solids) or pull (for polymers)
                     !  Units       Pascals (Newtons per square meter) (solids) or Newtons per Mole (polymers)
                     !  Default     0.0
  &  zpe,          & !  Term        Zero point energy
                     !  Definition  Half the addition of the vibrational energies
                     !  Units       kcal/mol
  &  density,      & !  Term        Density of solid
                     !  Definition  Weight of cluster divided by its volume
                     !  Units       grams per cubic centimeter
  &  stress,       & !  Term        Energy due to distortion from reference geometry, used with GEO-REF=
                     !  Units       Kcal/mol
                     !
  &  press(3),     & ! Type         Pressure on crystal faces
                     ! Definition   Pressure required to stop crystal expanding
                     ! Units        Gigapascals
  &  E_disp,       & ! Dispersion term
  &  E_hb,         & ! Hydrogen-bond term
  &  E_hh,         & ! Hydrogen-hydrogen repulsion term (to correct for short H - H interactions)
  &  Rab,          & ! Distance between two atom, calculated in "connected"
  &  temp_1,       & !  Used for very temporary transfer of information
  &  temp_2,       & !  Used for very temporary transfer of information
  &  temp_3,       & !  Used for very temporary transfer of information
  &  sz,           & ! Spin component
  &  ss2,          & ! Total spin
   trunc_1,        &
   trunc_2,        &
  &  rdummy
!
   character ::     &
  & ltxt,          & !
  & caltyp*27,     & !  Calculation name
  & formula*100,   & !  Type          Empirical formula
                     !  Definition    Type and number count of each element in the system
                     !  Units         Text
  & git_hash*40 = 'unknown', & !  Git commit hash string
  & os*12 = 'unknown', &       !  Operating system name
  & verson*20 = 'unknown'      !  Version number for this copy of MOPAC
                     !  Pattern      "xx.yy.zz(-pre)"
                     !  Description  major version, minor version, patch version, & pre-release tag
  character ::     &
  & jobnam*240 = ' ', &!
  & line*3000         !
  character :: backslash = achar(92) ! portable way of representing the backslash character
  character :: keywrd*3000, koment*200, title*200, refkey(6)*3000, geo_ref_name*241, geo_dat_name*241, &
    allkey*3000, keywrd_txt*3000, refkey_ref(6)*3000, keywrd_quoted*3000
  character :: errtxt*200, dh*20
!
  logical ::            &
     moperr,            & !
     uhf,               & !  Term        Should the Unrestricted Hartree Fock method be used?
                          !  Definition  True if the calculation is Unrestricted Hartree-Fock
                          !  Default    = .false.
     rhf,               & !  Term        Should the Restricted Hartree Fock method be used?
                          !  Definition  True if the calculation is Restricted Hartree-Fock
                          !  Default    = .false.
     isok,              & !
     mozyme,            & !  TRUE if any of the MOZYME functions are to be used
     limscf,            & !  Convergence criterion for SCF: if TRUE, then exit the SCF
                          !  if the energy changes a lot (useful in geometry optimization)
                          !  if FALSE, then converge the SCF to the default criterion
     gui = .true.,      & !  By default, output information for a Graphical User Interface
     lxfac,             & !  TRUE if a diatomic is being used to define the values of XFAC and ALPB
     units,             & !  TRUE if units for input geometry are defined (Angstroms or A0), FALSE otherwise
     Angstroms,         & !  TRUE if units for input geometry must be in Angstroms, if FALSE then A0, see also units
     Sparkle,           & !  TRUE if basis set is missing and sparkles are present (any of elements 58:70)
     keep_res,          & !  TRUE if the original residue names are to be used
     use_ref_geo,       & !  TRUE if keyword GEO_REF is used
     pdb_label,         & !  TRUE if label text is in PDB format
     MM_corrections(20),& !
     N_3_present,       & !
     Si_O_H_present,    & !
     prt_coords,        & ! TRUE if coordinates are to be printed
     prt_gradients,     & ! TRUE if gradients are to be printed
     prt_cart,          & ! TRUE if Cartesian coordinates to be printed
     prt_charges,       & ! TRUE if atomic partial charges to be printed
     prt_pops,          & ! TRUE if atomic orbital populations to be printed
     prt_topo,          & ! TRUE if topography to be printed
     prt_force,         & ! TRUE if FORCE matrix to be printed
     prt_normal_coords, & ! TRUE if normal coordinates in a FORCE matrix calculation to be printed
     prt_orientation,   & ! TRUE if orientation in a FORCE matrix calculation to be printed
     prt_velocity,      & ! TRUE if velocity vector in IRC/DRC to be printed
     dummy_present,     & !
     l_normal_html,     & ! TRUE if a normal HTML file is to be generated. After it's generated, set FALSE
     is_PARAM=.false.     !  This will be set "TRUE" in a PARAM run
  equivalence  &
    (MM_corrections(1), N_3_present),    & ! TRUE if the system contains at least one N bonded to three ligands
                                           ! and at least two are not hydrogen atoms
    (MM_corrections(2), Si_O_H_present), & ! TRUE if the system contains at least one Si-O-H group
    (MM_corrections(20), dummy_present)    ! If needed, then increase the size of the MM_corrections array.
!
!  Define names for all methods.  Adjust n_methods here and in the equivalence statement lower down.
!
  integer, parameter :: n_methods = 20
  logical ::      &
       & methods(n_methods),   &
       & method_MNDO,          &   !  1
       & method_AM1,           &
       & method_PM3,           &
       & method_RM1,           &
       & method_MNDOD,         &   !  5
       & method_PM6,           &
       & method_PM6_DH_plus,   &
       & method_PM6_DH2,       &
       & method_PM6_D3H4,      &
       & method_PM6_DH2X,      &   ! 10
       & method_PM6_D3H4X,     &
       & method_PM6_D3,        &
       & method_PM6_D3_not_H4, &
       & method_PM7,           &
       & method_pm7_ts,        &   ! 15
       & method_PM7_HH,        &
       & method_PM7_minus,     &
       & method_pm6_org,       &
       & method_PM8,           &
       & method_indo,          &
       & method_x,             &  ! 20 To be used some day
       & l_feather,            &  ! Smooth transition from NDDO to point-charge
       & l_feather_1,          &  ! Type of smoothing used in l_feather
       & method             !  Default method = PM7
  character :: methods_keys(n_methods)*11
  data methods_keys/ " MNDO ", " AM1 ", " PM3 ", " RM1 ", " MNDOD ", " PM6 ", " PM6-DH+ ", &
    & " PM6-DH2 ", " PM6-D3H4 ", " PM6-DH2X ", " PM6-D3H4X ", " PM6-D3 ", " PM6-D3(H4)",  &
    & " PM7 ", " PM7-TS ", " PM7-HH ", " PM7- ", " PM6-ORG ", " PM8", " INDO"/
  equivalence (methods(1),  method_MNDO), (methods(2),  method_AM1), (methods(3),  method_PM3), &
    & (methods(4),  method_RM1), (methods(5),  method_MNDOD), (methods(6),  method_PM6), &
    & (methods(7),  method_PM6_DH_plus), (methods(8),  method_PM6_DH2), (methods(9),  method_PM6_D3H4), &
    & (methods(10),  method_PM6_DH2X), (methods(11),  method_PM6_D3H4X), (methods(12),method_PM6_D3), &
    & (methods(13),  method_PM6_D3_not_H4), (methods(14), method_PM7), (methods(15),  method_pm7_ts), &
    & (methods(16),  method_PM7_HH), (methods(17),  method_PM7_minus), (methods(18),  method_pm6_org), &
    & (methods(19),  method_PM8), (methods(20), method_indo)
end module molkst_C

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine addhb (nocc1, nvir1,  idiagg, nij, nhb)
   !***********************************************************************
   !
   !   CHECK FOCK MATRIX AND DENSITY MATRIX TO ENSURE THAT ALL
   !   FOCK MATRIX ELEMENTS ARE BEING CORRECTLY HANDLED BY THE
   !   DIAGONALISER.
   !
   !**********************************************************************
   !
   !  nocc1    Number of occupied M.O.s (might be a subset of noccupied)
   !  nvir1    Number of virtual M.O.s (might be a suset of nvirtual)
   !
   !**********************************************************************
    use molkst_C, only : numat, norbs
    use common_arrays_C, only: eigs, f
    implicit none
    integer, intent (in) :: idiagg, nhb, nocc1, nvir1
    integer, intent (out) :: nij
    integer :: alloc_stat
    logical, dimension (:), allocatable :: latom_loc
    double precision, dimension(:), allocatable :: storei, storej
    integer, allocatable, dimension(:) :: iused
    double precision, dimension (4) :: hblims
    data hblims / 1.d0, 0.1d0, 0.01d0, 0.001d0 /
    allocate (latom_loc(numat), iused(Max (norbs, numat)), &
         & storei(norbs), storej(norbs), &
         & stat=alloc_stat)
    if (alloc_stat /= 0) then
      call memory_error ("addhb")
      return
    end if
    call hbonds (f, nocc1, nvir1, iused, nij, hblims(nhb))
    if (nij /= 0) then
      call diagg2 (nocc1, nvir1, eigs(nocc1+1:), iused, latom_loc, &
      nij, idiagg, storei, storej)
    end if
    deallocate (latom_loc, iused, storei, storej)
    if (alloc_stat /= 0) then
      call memory_error ("addhb")
    end if
end subroutine addhb

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine deritr()
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE molkst_C, ONLY: norbs, nelecs, numcal, ndep, nvar, &
      & enuclr, keywrd, natoms, escf, elect, method_pm7, mozyme, moperr
      use common_arrays_C, only : loc, geo, p, pa, coord, errfn
      USE funcon_C, only : fpc_9
      USE chanel_C, only : iw
      USE molmec_C, only : nnhco, nhco, htype
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: icalcn, i, k, l, j
      double precision :: xderiv
      double precision, dimension(3*natoms) :: xparam
      double precision :: delta, const, aa, xstore, ee, escf_store, enuclr_store, &
      elect_store, sum, sum_dihed_ref, sum_dihed_delta, angle
      double precision, external :: reada
      logical :: debug, PM6_H, precise

      save
!-----------------------------------------------
!***********************************************************************
!
!    DERITR CALCULATES THE DERIVATIVES OF THE ENERGY WITH RESPECT TO THE
!          INTERNAL COORDINATES. THIS IS DONE BY FINITE DIFFERENCES
!          USING FULL SCF CALCULATIONS.
!
!          THIS IS VERY TIME-CONSUMING, AND SHOULD ONLY BE USED WHEN
!          NO OTHER DERIVATIVE CALCULATION WILL DO.
!
!    THE MAIN ARRAYS IN DERIV ARE:
!        LOC    INTEGER ARRAY, LOC(1,I) CONTAINS THE ADDRESS OF THE ATOM
!               INTERNAL COORDINATE LOC(2,I) IS TO BE USED IN THE
!               DERIVATIVE CALCULATION.
!        GEO    ARRAY \GEO\ HOLDS THE INTERNAL COORDINATES.
!
!***********************************************************************
      data icalcn/ 0/
  !    precise = .false.
  !    PM6_H = .false.
      if (icalcn /= numcal) then
        debug = (index(keywrd,'DERITR') /= 0)
        precise = (index(keywrd,'PRECISE') /= 0)
        PM6_H = (method_pm7 .or. index(keywrd,'PM6-D') + index(keywrd,'PM6-H') /= 0)
!
!   DELTA IS A MACHINE-PRECISION DEPENDANT CONSTANT
!

        icalcn = numcal
!
!   CONST = 23.06... eV to KCAL
!
        const = fpc_9
!
        delta = 0.d0
        i = index(keywrd,' DELTA')
        if (i /= 0) delta = reada(keywrd,i)
        if (precise) then
          if (delta < 1.d-10) delta = 0.001D0
          xderiv = 0.5D0/delta
        else
          if (delta < 1.d-10) delta = 0.0002D0
          xderiv = 1.d0/delta
        end if
      end if
      do i = 1, nvar
        xparam(i) = geo(loc(2,i),loc(1,i))
      end do
      escf_store = escf
      enuclr_store = enuclr
      elect_store = elect
      if ( .not. precise) then
!
!  ESTABLISH THE ENERGY AT THE CURRENT POINT
!
        if (ndep /= 0) call symtry
        call gmetry (geo, coord)
        if (norbs*nelecs > 0) then
          if (mozyme) then
            call hcore_for_MOZYME ()
            if (moperr) return
            aa = 0.d0
            call iter_for_MOZYME (aa)
          else
            call hcore ()
            call iter (aa, .TRUE., .TRUE.)
          end if
        else
          aa = 0.d0
        end if
        sum_dihed_ref = 0.d0
        do i = 1, nnhco
          call dihed (coord, nhco(1,i), nhco(2,i), nhco(3,i), nhco(4,i), angle)
          sum_dihed_ref = sum_dihed_ref + htype*sin(angle)**2
        end do
        if (PM6_H) then
          call post_scf_corrections(sum, .false.)
          aa = aa + sum/const
        end if
        aa = aa + enuclr
      end if
!
!  RESTORE THE DENSITY MATRIX (WHY?)
!
      if (allocated (pa)) p = pa*2.D0
      if (abs(escf+56.12779d0) < 1.d-4) then
        continue
      end if
      do i = 1, nvar
        k = loc(1,i)
        l = loc(2,i)
        xstore = xparam(i)
        do j = 1, nvar
          geo(loc(2,j),loc(1,j)) = xparam(j)
        end do
        if (precise) then
          geo(l,k) = xstore + delta
          if (ndep /= 0) call symtry
          call gmetry (geo, coord)
!
!   IF NEEDED, CALCULATE "EXACT" DERIVATIVES.
!
          if (norbs*nelecs > 0) then
            if (mozyme) then
              call hcore_for_MOZYME ()
              if (moperr) return
              call iter_for_MOZYME (aa)
            else
              call hcore ()
              call iter (aa, .TRUE., .TRUE.)
            end if
            sum_dihed_ref = 0.d0
            do j = 1, nnhco
              call dihed (coord, nhco(1,j), nhco(2,j), nhco(3,j), nhco(4,j), angle)
              sum_dihed_ref = sum_dihed_ref + htype*sin(angle)**2
            end do
            if (PM6_H) then
              call post_scf_corrections(sum, .false.)
              aa = aa + sum/const
            end if
          else
            aa = 0.d0
          end if
          aa = aa + enuclr
        end if
        geo(l,k) = xstore - delta
        if (ndep /= 0) call symtry
        call gmetry (geo, coord)
!
!   IF NEEDED, CALCULATE "EXACT" DERIVATIVES.
!
        if (norbs*nelecs > 0) then
          if (mozyme) then
            call hcore_for_MOZYME ()
            if (moperr) return
            call iter_for_MOZYME (ee)
          else
            call hcore ()
            call iter (ee, .TRUE., .TRUE.)
          end if
          sum_dihed_delta = 0.d0
          do j = 1, nnhco
            call dihed (coord, nhco(1,j), nhco(2,j), nhco(3,j), nhco(4,j), angle)
            sum_dihed_delta = sum_dihed_delta + htype*sin(angle)**2
          end do
          if (PM6_H) then
            call post_scf_corrections(sum, .false.)
            ee = ee + sum/const
          end if
        else
          ee = 0.d0
        end if
        ee = ee + enuclr
        if (i == 13) then
          continue
        end if
         errfn(i) = (aa - ee)*const*xderiv + (sum_dihed_ref - sum_dihed_delta)*xderiv

      end do
      if (debug) then
        write (iw, '('' ERROR FUNCTION'')')
        write (iw, '(10F8.3)') (errfn(i),i=1,nvar)
      end if
      geo(loc(2,nvar),loc(1,nvar)) = xparam(nvar)
      escf = escf_store
      enuclr = enuclr_store
      elect = elect_store
      return
      end subroutine deritr

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine orient (nvecs, sec_det, natot, coord)
!
!   Rotate system (atoms and interaction matrices) so that the first
!   translation vector is along the "x" axis, and the second vector,
!   if present, is in the "x-y" plane.
!
  use common_common, only : numat, id, tvec, xop, iop, phonon, jobnam, &
    nfirst, nlast, per_atom, ncell, nijk, title, mr1, mr2, mr3, bcc, trans, &
      keywrd, iw_new
  implicit none
  integer, intent(in) :: nvecs
  integer, intent(inout) :: natot
  double precision, dimension(3, natot+3), intent(inout) :: coord
  double precision, dimension(nvecs, *), intent(inout) :: sec_det
!
  logical :: prtok, prtops
  integer :: i, i1, i2, i3, i4, i99, ii, il, iofset, iu, j, j1, j2, j3, &
       & jj, jl, ju, k, k1, k2, l1, l2, mprt, nprt
  double precision :: sum, sum1, summax, summin, x, y, z, &
  a, b, c, d, e, f, g, h, o, two, six, ca, sa
  character :: line*120
  double precision, dimension(3) :: storen
  double precision, dimension(3, 3) :: xtoc, p_rot
  double precision, dimension(9, 9) :: t1, t2, e1, e2
  double precision, external :: reada
  equivalence (p_rot(1, 1), a)
  equivalence (p_rot(2, 1), b)
  equivalence (p_rot(3, 1), c)
  equivalence (p_rot(1, 2), d)
  equivalence (p_rot(2, 2), e)
  equivalence (p_rot(3, 2), f)
  equivalence (p_rot(1, 3), g)
  equivalence (p_rot(2, 3), h)
  equivalence (p_rot(3, 3), o)
! 
! ... Executable Statements ...
! 
  trans = 0.d0
  do i = 1, 3
    trans(i, i) = 1.d0
  end do
!
!  Make normalized translation vectors
!
  do i = 1, id
    sum = 0.d0
    do j = 1, 3
      sum = sum + tvec(j, i)**2
    end do
    storen(i) = Sqrt (sum)
    sum = 1.d0 / storen(i)
    do j = 1, 3
      xtoc(j, i) = tvec(j, i) * sum
    end do
  end do
!
!   Construct vectors perpendicular to known vectors,
!   if system is of dimension 1 or 2
!
  if (id == 1) then
!
!    Make a vector orthogonal to the first vector
!
    summax = 0.d0
    summin = 1.d0
    do j = 1, 3
      if (Abs (summax) < Abs (xtoc(j, 1))) then
        j1 = j
        summax = xtoc(j, 1)
      end if
      if (Abs (summin) >= Abs (xtoc(j, 1))) then
        j2 = j
        summin = xtoc(j, 1)
      end if
    end do
!
!  If possible, make XTOC(2,2) large.
!
    if (Abs (summax) > 0.80d0 .and. j2 /= 2) then
      j2 = 2
      j1 = 1
      j3 = 3
    else
      j3 = 6 - j1 - j2
    end if
    xtoc(j3, 2) = 0.d0
    xtoc(j2, 2) = summax
    xtoc(j1, 2) = -summin
  end if
  if (id /= 3) then
!
!  Make a vector orthogonal to the first and second vectors.
!
    summin = 1.d0
    do j = 1, 3
      sum = xtoc(j, 1)**2 + xtoc(j, 2)**2
      if (summin > sum) then
        j2 = j
        summin = sum
      end if
    end do
    xtoc(j2, 3) = 1.d0
    do j = 1, 3
      if (j /= j2) then
        sum = 0.d0
        do i = 1, 2
          sum = sum + xtoc(j, i)*xtoc(j2, i)
        end do
        xtoc(j, 3) = -sum
      end if
    end do
    sum = 1.d0 / Sqrt (xtoc(1, 3)**2+xtoc(2, 3)**2+xtoc(3, 3)**2)
    xtoc(:, 3) = xtoc(:, 3) * sum
  end if
!
!   Expand normalized vectors to their full size
!
  do i = 1, id
    do j = 1, 3
      xtoc(j, i) = xtoc(j, i) * storen(i)
    end do
  end do
  do i = id + 1, 3
    do j = 1, 3
      tvec(j, i) = xtoc(j, i)
    end do
  end do
!
!   Convert Cartesian coordinates into fractional unit cell coordinates.
!
!   Add in unit vectors at the end of coord, to be used in making trans or p_rot
  natot = natot + 3
  k = 0
  do i = natot-2, natot
    k = k + 1
    do j = 1, 3
      coord(j, i) = 0.d0
    end do
    coord(k, i) = 1.d0
  end do
  sum = Sqrt (tvec(2, 1)**2 + tvec(3, 1)**2)
  if (sum > 1.d-6) then
!
!    Rotate to eliminate TVEC(3,1)
!
    ca = tvec(2, 1) / sum
    sa = tvec(3, 1) / sum
    do i = 1, 3
      sum1 = tvec(2, i)*ca + tvec(3, i)*sa
      tvec(3, i) = -tvec(2, i)*sa + tvec(3, i)*ca
      tvec(2, i) = sum1
    end do
    do i = 1, natot
      sum1 = coord(2, i)*ca + coord(3, i)*sa
      coord(3, i) = -coord(2, i)*sa + coord(3, i)*ca
      coord(2, i) = sum1
    end do
!
!    Rotate to eliminate TVEC(2,1)
!
    sum = Sqrt (tvec(1, 1)**2 + tvec(2, 1)**2)
    ca = tvec(1, 1) / sum
    sa = tvec(2, 1) / sum
    do i = 1, 3
      sum1 = tvec(1, i)*ca + tvec(2, i)*sa
      tvec(2, i) = -tvec(1, i)*sa + tvec(2, i)*ca
      tvec(1, i) = sum1
    end do
    do i = 1, natot
      sum1 = coord(1, i)*ca + coord(2, i)*sa
      coord(2, i) = -coord(1, i)*sa + coord(2, i)*ca
      coord(1, i) = sum1
    end do
  end if
!
!    Rotate to eliminate TVEC(3,2)
!
  sum = Sqrt (tvec(2, 2)**2 + tvec(3, 2)**2)
  if (sum > 1.d-6) then
    ca = tvec(2, 2) / sum
    sa = tvec(3, 2) / sum
    do i = 2, 3
      sum1 = tvec(2, i)*ca + tvec(3, i)*sa
      tvec(3, i) = -tvec(2, i)*sa + tvec(3, i)*ca
      tvec(2, i) = sum1
    end do
    do i = 1, natot
      sum1 = coord(2, i)*ca + coord(3, i)*sa
      coord(3, i) = -coord(2, i)*sa + coord(3, i)*ca
      coord(2, i) = sum1
    end do
  end if
  natot = natot - 3
  do i = 1, 3
    do j = 1, 3
      trans(i, j) = coord(i, j+natot)
    end do
  end do
  natot = natot + 3
  do i = 1, natot
    coord(3, i) = coord(3, i) / tvec(3, 3)
    coord(2, i) = coord(2, i) - coord(3, i)*tvec(2, 3)
    coord(1, i) = coord(1, i) - coord(3, i)*tvec(1, 3)
    coord(2, i) = coord(2, i) / tvec(2, 2)
    coord(1, i) = coord(1, i) - coord(2, i)*tvec(1, 2)
    coord(1, i) = coord(1, i) / tvec(1, 1)
  end do
  natot = natot - 3
  if (Index (keywrd, " FRACT") /= 0) then
    write(iw_new, "(a)") " Fractional Unit Cell Coordinates"
    write(iw_new, "(i4,3f12.5)") (i, coord(:, i), i = 1, natot)
  end if
  do i = 1, 3
    if (tvec(i, i) < 0) then
      do j = 1, 3
        trans(i, j) = -trans(i, j)
      end do
    end if
  end do
!
!   TRANS is the unitary transform to rotate from the Cartesian frame
!   into the crystallographic frame.
!
  if (Index (keywrd, " TRANS") /= 0) then
    write(iw_new, "(a)") " Unitary Transform: Cartesian to Crystal"
    write(iw_new, "(3f12.5)") (trans(:, i), i = 1, 3)
  end if
!***********************************************************************
!
!   Rotate Secular Determinant into crystal coordinate frame.
!
!***********************************************************************
  do i = 1, 4
    do j = 1, 4
      t1(i, j) = 0.d0
    end do
  end do
  if(phonon)then
    t1(1:3,1:3) = trans(1:3,1:3)
  else
    do i = 1, 3
      do j = 1, 3
        t1(i + 1, j + 1) = trans(i, j)
      end do
    end do
    t1(1, 1) = 1.d0
    do i = 1,3
      do j = 1,3
        p_rot(i,j) = trans(j,i)
      end do
    end do
    p_rot = trans
!
!  "d"-orbital transform
!
    two = Sqrt (0.5d0)  
    six = Sqrt (1/6.d0)  
!
!   d(x^2 - y^2)
!
    t1(5, 5) = (a*a - b*b - d*d + e*e)/2.d0
    t1(5, 6) = a*c - d*f  
    t1(5, 7) = (2.d0*c*c - b*b - a*a - 2.d0*f*f + e*e + d*d) * two * six  
    t1(5, 8) = b*c - e*f  
    t1(5, 9) = a*b - d*e 
!
!  d(xz)
! 
    t1(6, 5) = a*g - b*h  
    t1(6, 6) = a*o + c*g  
    t1(6, 7) = (2.d0*c*o - b*h - a*g) * six/two  
    t1(6, 8) = b*o + c*h  
    t1(6, 9) = a*h + b*g  
!
!  d(2z^2 - x^2 - y^2)
!
    t1(7, 5) = (2.d0*g*g - d*d - a*a - 2.d0*h*h + e*e + b*b) * two * six  
    t1(7, 6) = (2.d0*g*o - d*f - a*c) * six/two
    t1(7, 7) = (4.d0*o*o - 2.d0*(h*h + g*g + f*f + c*c) + e*e + d*d + b*b + a*a)/6.d0 
    t1(7, 8) = (2.d0*h*o - e*f - c*b) * six/two  
    t1(7, 9) = (2.d0*g*h - e*d - a*b) * six/two 
!
!  d(yz)
!
    t1(8, 5) = d*g - e*h  
    t1(8, 6) = d*o + f*g  
    t1(8, 7) = (2.d0*o*f - e*h - d*g) * six/two  
    t1(8, 8) = e*o + f*h  
    t1(8, 9) = d*h + e*g  
!
!  d(xy)
!
    t1(9, 5) = a*d - b*e  
    t1(9, 6) = a*f + c*d  
    t1(9, 7) = (2.d0*c*f - e*b - a*d) * six/two  
    t1(9, 8) = b*f + c*e  
    t1(9, 9) = a*e + d*b
!
    do i = 5,9
      do j = 5,i
        sum = t1(i,j)
        t1(i,j) = t1(j,i)
        t1(j,i) = sum
      end do
    end do
    if (.false.) then
      write(*,*)"  p_rot"
      write(*,'(3f16.10)')((p_rot(i,j), i = 1,3),j = 1,3)
      write(*,*)
      do i = 1, 3
        do j = 1, 3
          sum = 0.d0
          sum1 = 0.d0
          do k = 1, 3
            sum = sum + p_rot(i,k)*p_rot(j,k)
            sum1 = sum1 + p_rot(k,i)*p_rot(k,j)
          end do
          e1(i,j) = sum
          e2(i,j) = sum1
        end do
      end do
      write(*,*) " p_rot squared"
      write(*,'(3f16.10)')((e1(i,j), i = 1,3),j = 1,3)
      write(*,*)
      write(*,'(3f16.10)')((e2(i,j), i = 1,3),j = 1,3)
      write(*,*)
      do i = 5, 9
        do j = 5, 9
          sum = 0.d0
          sum1 = 0.d0
          do k = 5,9
            sum = sum + t1(i,k)*t1(j,k)
            sum1 = sum1 + t1(k,i)*t1(k,j)
          end do
          e1(i,j) = sum
          e2(i,j) = sum1
        end do
      end do
      write(*,*) " d_rot "
      write(*,'(5f16.10)')((t1(i,j), i = 5,9),j = 5,9)
      write(*,*)
      write(*,*) " d_rot squared"
      write(*,'(5f16.10)')((e1(i,j), i = 5,9),j = 5,9)
      write(*,*)
      write(*,'(5f16.10)')((e2(i,j), i = 5,9),j = 5,9)
    end if
  end if
  nprt = Min (8, nvecs)
  prtok = (Index (keywrd, " ROTSEC")/=0)
  if (prtok) then
    write(iw_new, "(/2X,'SECULAR DETERMINANT IN CRYSTAL ORIENTATION',/)")
    i = Index (keywrd, " ROTSEC=")
    mprt = 2000
    if (i /= 0) then
      mprt = Nint (reada (keywrd, i+3))
    end if
  end if
!
!  Rotate entire secular determinant into crystal orientation
!
  ncell = 0
  do i = 1, mr1
    do j = 1, mr2
      do k = 1, mr3
        if (.not.bcc .or. Mod(i + j + k, 2) == 1) then
          iofset = nvecs * ncell
          ncell = ncell + 1
          do ii = 1, numat
            il = nfirst(ii)
            iu = nlast(ii)
            do jj = 1, numat
              jl = nfirst(jj)
              ju = nlast(jj)
              do i1 = 1, per_atom(ii)
                do j1 = 1, per_atom(jj)
                  sum = 0.d0
                  k2 = 0
                  do k1 = il, iu
                    k2 = k2 + 1
                    l2 = 0
                    do l1 = jl, ju
                      l2 = l2 + 1 
                      sum = sum + t1(i1, k2)*sec_det(k1, l1 + iofset)*t1(j1, l2)
                    end do
                  end do
                  t2(i1, j1) = sum
                end do
              end do
              i2 = 0
              do i1 = il, iu
                i2 = i2 + 1
                j2 = 0
                do j1 = jl, ju
                  j2 = j2 + 1
                  sec_det(i1, j1 + iofset) = t2(i2, j2)
                end do
              end do
            end do
          end do
          if (prtok .and. ncell <= mprt) then
            write(iw_new, "(A,3I3)") " Unit Cell:", i-1, j-1, k-1
            do jj = iofset + 1, iofset + nvecs
              write(iw_new, "(10f8.4)") (sec_det(ii, jj), ii = 1, nprt)
            end do
          end if
        end if
      end do
    end do
  end do
  prtops = (Index (keywrd, " OPS")/=0)
!  i = Index (jobnam, " ") - 1
!
!
!                                   Read in symmetry operations
!
!
  open (unit = 4, file = trim(jobnam)//".ops", status = "OLD", iostat = i99)
  i = 1
  if (i99 == 0) then
    if (prtops) then
      write(iw_new, "(//11X,'SYMMETRY OPERATIONS OF SPACE GROUP',//)")
      write(iw_new, '( "    INV.  NON-PRIMITIVE ROTATION   AXIS OF               CENTER          NAME", &
        & / "    1=YES TRANSLATIONS   ANGLE    ROTATION           OF OPERATION", &
        & /, "             X   Y   Z", 12x, "X     Y     Z       X     Y     Z "/)')
    end if
    do i = 1, 149
      do
        read(4,'(a)') line
        if (line(1:1) /= "*") exit
      end do
      read (line, *, end = 1000, err = 1000) i1, i2, i3, i4, &
           & (xop(j, i), j = 5, 8), xop(9, i), xop(10, i), xop(11, i), title(i)
      xop(1, i) = i1
      if (Abs (xop(6, i)) + Abs (xop(7, i)) < 1.d-5) then
        xop(8, i) = 1.d0
      end if
      if (i1 == 2) exit
      x = 0.d0
      if (i2 /= 0) x = 1.d0 / i2
      y = 0.d0
      if (i3 /= 0) y = 1.d0 / i3
      z = 0.d0
      if (i4 /= 0) z = 1.d0 / i4
      xop(2, i) = x
      xop(3, i) = y
      xop(4, i) = z
      j = Nint (xop(5, i)*360.d0)
      xop(5, i) = j
      if (prtops) write(iw_new, '(i2, i4, f9.1, 2f4.1, i6, f8.2, 2f6.2, f8.2, 2f6.2, 3x, a12)') &
          i, i1, (xop(j, i), j = 2, 4), Int (xop(5, i)+0.5d0), (xop(j, i), j = 6, 11), title(i)
      xop(5, i) = xop(5, i) / 360.d0
    end do
  end if
  1000 iop = i - 1
  if (iop == 0) then
!
!  No symmetry operations were supplied, so force in the Identity
!
         iop = 1
         do i = 1, 11
           xop(i, 1) = 0.d0
         end do
         xop(8, 1) = 1.d0
         title(1) = "Identity"
       end if
!***********************************************************************
!
!     Symmetrize Secular Determinant
!
!***********************************************************************
  prtok = (Index (keywrd, " SYMSEC") /= 0)
  if (iop /= 1 .and. prtok) then
    write(iw_new, *) " Symmetrizing Secular Determinant."
  end if
  call symtrz (sec_det, nvecs, coord)
  if (.not. bcc) call add_missing_cells()
  prtok = (Index (keywrd, " SYMSEC") /= 0)
  if (.not. prtok) return
  write(iw_new, "(/2X,'SYMMETRIZED SECULAR DETERMINANT',/)")
  i = Index (keywrd, " SYMSEC=")
  mprt = 2000
  if (i /= 0) mprt = Nint (reada (keywrd, i+3))
  mprt = Min (ncell, mprt)
  nprt = Min (8, nvecs)
  do ii = 1, mprt
    write(iw_new, "(/3X,'Unit Cell:',3I3)") (nijk(j, ii), j = 1, 3)
    do i = (ii-1)*nvecs + 1, ii*nvecs
      write(iw_new, "(10F8.4)") (sec_det(jj, i), jj = 1, nprt)
    end do
  end do
end subroutine orient
!

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

subroutine rapid0 (loop)
!
!
    use param_global_C, only : valvar, numvar, xparamp, locvar
!
!
    implicit none
    integer, intent (in) :: loop
!----------------------------------------------------------------
    integer :: i
    double precision :: funct1
!----------------------------------------------------------------
  !
  !   DELTAS will hold the CHANGE IN VALUE of the parameters
  !
    do i = 1, numvar
      xparamp(i) = 0.d0
    end do
  !
  !  Optimize the parameters
  !
    call rapid1 (loop, xparamp, numvar, funct1)
  !
  !  Update the values of the parameters
  !
    do i = 1, numvar
      valvar(i) = valvar(i) - xparamp(i)
      if(locvar(1,i) > 3 .and. locvar(1,i) < 7) valvar(i) = max(0.05d0, valvar(i))
      call update (locvar(1, i), locvar(2, i), valvar(i), 0.d0)
    end do
end subroutine rapid0

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine modchg ()
   !***********************************************************************
   !
   !   MODGRA prints the charge due to (a) backbone residue atoms, and
   !   (b) all side-chain atoms in each residue.
   !
   !***********************************************************************
    use molkst_C, only: numat, id, maxtxt
    use MOZYME_C, only : nres, at_res, res_start
    use common_arrays_C, only : q, txtatm
    use chanel_C, only: iw
    implicit none
    double precision, allocatable :: work(:)
    logical, allocatable :: l_used(:)
    logical :: first = .true.
    character :: nam_het(600)*3, het_num(600)*4
    double precision :: total_charge = 0.d0, res_charge = 0.d0
    integer :: i, j, n_cat, n_ani, cations(50), anions(50), n_het = 0
   !
   ! ... Executable Statements ...
   !
    allocate (work(0:numat + id))
    call build_res_start_etc()
    work = 0.d0
    if (.not. allocated(q)) then
      write(iw,"(a)") "Density matrix is not available.  Run a 1SCF."
      return
    end if
    allocate(l_used(numat + id))
   !
   !    WORK collects charge contributions from atoms.  The negative
   !    addresses refer to the residue backbone, the positive addresses
   !    refer to the side-chain.
   !
   !    (Backbone atoms are -NH-CH-CO-)
   !
    work = 0.d0
    do i = 1, numat
      j = at_res(i)
      work(j) = work(j) + q(i)
      total_charge = total_charge + q(i)
      l_used(i) = (j > 0)
    end do
    write (iw,"(/9x,a,/)") " NET CHARGE ON RESIDUES"
    write (iw,"(a)")"      Residue         Charge  Anion or"
    write (iw,"(a)")"                              Cation?"
    n_cat = 0
    n_ani = 0
    do i = 1, nres
      if (res_start(i) < 1) cycle
      if (work(i) > 0.5d0) then
         write (iw, "(6x,a,SP,F13.3, a)") txtatm(res_start(i))(18:maxtxt), work(i), "  CATION"
         n_cat = min(50, n_cat + 1)
         cations(n_cat) = res_start(i)
      else if (work(i) < -0.5d0) then
         write (iw, "(6x,a,F13.3, a)") txtatm(res_start(i))(18:maxtxt), work(i), "  ANION"
         n_ani = min(50, n_ani + 1)
         anions(n_ani) = res_start(i)
      else
        if (work(i) < 0.d0 .and. work(i) > -0.0005d0) work(i) = 0.d0
        if (txtatm(res_start(i))(18:20) /= "HOH" .or. abs(work(i)) > 0.1d0) &
         write (iw, "(6x,a,SP,F13.3)") txtatm(res_start(i))(18:maxtxt), work(i)
      end if
      res_charge = res_charge + work(i)
    end do
    work = 0.d0
    do i = 1, numat
      if (.not. l_used(i)) then
        do j = 1, n_het
          if (txtatm(i)(18:20) == nam_het(j) .and. txtatm(i)(23:26) == het_num(j)) exit
        end do
        if (j > n_het) then
          n_het = n_het + 1
          if (n_het > 600) exit
          nam_het(j) = txtatm(i)(18:20)
          het_num(j) = txtatm(i)(23:26)
        end if
        work(j) = work(j) + q(i)
      end if
    end do
    if (n_het > 0) then
      do i = 1, n_het
        if (abs(work(i)) < 0.1d0) cycle
        if (first) then
          first = .false.
          write (iw,"(/6x,a,/2x,a,/)") "NET CHARGES ON HETERO-GROUPS  (|Charges| less than 0.1 not printed)"
          write (iw,"(a)")"    HETERO-GROUP      Charge "
          write (iw,"(a)")" "
        end if
        write (iw, "(6x,a,F14.3)") txtatm(res_start(i))(18:maxtxt), work(i)
      end do
    end if
    write(iw,*)
!
!  Print out salt bridges
!
    if (n_cat > 0 .and. n_ani > 0) then
      call set_up_dentate()
      call find_salt_bridges(cations, anions, n_cat, n_ani)
    end if
    write(iw,'(/)')
    return
  end subroutine modchg
  subroutine build_res_start_etc()
    use MOZYME_C, only : nres, at_res, res_start
    use molkst_C, only: numat, id
    use common_arrays_C, only : txtatm, nat, nbonds, ibonds
    implicit none
    integer :: i, j
    character :: ren_name(numat)*9, residue*9
!
! Work out which residue each atom belongs to, and the location of the first atom
! in each residue.
!
    nres = 0
    ren_name = " "
    if (.not. allocated(at_res)) allocate(at_res(numat + id))
!
!  Do all non-hydrogen atoms
!
     do i = 1, numat
      if (nat(i) == 1 .and. nbonds(i) == 1) cycle
      residue = txtatm(i)(18:26)
      do j = 1, nres
        if (ren_name(j) == residue) exit
      end do
      if (j > nres) then
        nres = nres + 1
        ren_name(j) = residue
        res_start(j) = i
      end if
      at_res(i) = j
     end do
!
! Do all hydrogen atoms
!
    do i = 1, numat
      if (nat(i) /= 1 .or. nbonds(i) /= 1) cycle
        j = ibonds(1,i)
        residue = txtatm(j)(18:26)
      do j = 1, nres
        if (ren_name(j) == residue) exit
      end do
      at_res(i) = j
    end do
    return
  end subroutine build_res_start_etc

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine MOZYME_eigs (nocc)
   !**********************************************************************
   !
   !  f:      FOCK MATRIX OVER ATOMIC ORBITALS
   !  VECTOR:   EIGENVECTORS OF M.O.S
   !  FILLED:   OCCUPIED M.O.S
   !  eigs:     EIGENVALUES OF OCCUPIED M.O.S
   !  NOCC:     NUMBER OF OCCUPIED M.O.S
   !  EIG:      ALL THE EIGENVALUES
   !  N:        NUMBER OF M.O.S = NUMBER OF A.O.S*
   !
   !**********************************************************************
   !
   !  ALL OCCUPIED LMO ENERGY LEVELS ARE CALCULATED.
   !
   !**********************************************************************
   !
    use molkst_C, only: norbs
    use MOZYME_C, only : icocc_dim, &
       lijbo, nijbo, &
       ijc, ncf, nncf, ncocc, &
     & iorbs, icocc, cocc
    use common_arrays_C, only : eigs, nfirst, nlast, p, f
    implicit none
    integer, intent (in) :: nocc
    integer :: i, i4, ii, j, j1, j4, &
         & jl, jx, k, k1, kk, kl, l, loopi, loopj, k1j1
    double precision, allocatable :: avir(:), aocc(:)
    double precision :: cutoff, sum, sum1
    integer, external :: ijbo
    allocate (avir(norbs), aocc(icocc_dim))
    !
    !
    aocc(:) = 0.d0

    do j = 1, nocc
        loopj = ncocc(j)
        kl = 0
        do kk = nncf(j) + 1, nncf(j) + ncf(j)
          k1 = icocc(kk)
          sum = 0.d0
          do k = nfirst(k1), nlast(k1)
            kl = kl + 1
            sum = sum + cocc(kl+loopj) ** 2
          end do
          !
          !   AOCC(KK) HOLDS THE SQUARE OF THE CONTRIBUTION OF THE KK'TH ATOM
          !   IN THE OCCUPIED SET.  NOTE:  THIS IS NOT ATOM KK.
          !
          aocc(kk) = sum
          !
        end do
      !
    end do
    cutoff = 1.d-8
    ijc = 0
!
!  EVALUATE THE OCCUPIED ENERGY LEVELS
!
!
      do i = 1, nocc
        loopi = ncocc(i)
          l = 0
          do j = nncf(i) + 1, nncf(i) + ncf(i)
            j1 = icocc(j)
            sum = 0.d0
            do k = l + 1, l + iorbs(j1)
              sum = sum + cocc(k+loopi) ** 2
            end do
            l = l + iorbs(j1)
            !
            !   AOCC(KK) HOLDS THE SQUARE OF THE CONTRIBUTION OF THE KK'TH ATOM
            !   IN THE OCCUPIED SET.  NOTE:  THIS IS NOT ATOM KK.
            !
            !   AVIR(J1) HOLDS THE SQUARE OF THE CONTRIBUTION OF ATOM J1
            !   IN THE OCCUPIED SET.  NOTE:  THIS IS NOT THE J1'th ATOM.
            !
            avir(j1) = sum
            !
            !   AOCC(KK) HOLDS THE SQUARE OF THE CONTRIBUTION OF THE KK'TH ATOM
            !   IN THE OCCUPIED SET.  NOTE:  THIS IS NOT ATOM KK.
            !
            !   AVIR(J1) HOLDS THE SQUARE OF THE CONTRIBUTION OF ATOM J1
            !   IN THE OCCUPIED SET.  NOTE:  THIS IS NOT THE J1'th ATOM.
            !
          end do
          sum = 0.d0
          jl = loopi
          !
          if (lijbo) then
            do j = nncf(i) + 1, nncf(i) + ncf(i)
              j1 = icocc(j)
              kl = loopi
              do k = nncf(i) + 1, nncf(i) + ncf(i)
                k1 = icocc(k)
                k1j1 = nijbo(k1, j1)
                if (k1j1 >= 0) then
                  if (avir(k1)*p(k1j1+1)*aocc(k) >= cutoff) then
                    !
                    !  EXTRACT THE ATOM-ATOM INTERSECTION OF f
                    !
                    if (k1 > j1) then
                      !
                      !   LOWER TRIANGLE
                      !
                      do jx = 1, iorbs(j1)
                        sum1 = 0.d0
                        do i4 = 1, iorbs(k1)
                          ii = k1j1 + (i4-1) * iorbs(j1) + jx
                          sum1 = sum1 + f(ii) * cocc(kl+i4)
                        end do
                        sum = sum + cocc(jl+jx) * sum1
                      end do
                    else if (k1 < j1) then
                      !
                      !   UPPER TRIANGLE
                      !
                      do jx = 1, iorbs(j1)
                        sum1 = 0.d0
                        do i4 = 1, iorbs(k1)
                          ii = k1j1 + (jx-1) * iorbs(k1) + i4
                          sum1 = sum1 + f(ii) * cocc(kl+i4)
                        end do
                        sum = sum + cocc(jl+jx) * sum1
                      end do
                    else
                      !
                      !   DIAGONAL TERM
                      !
                      do jx = 1, iorbs(j1)
                        sum1 = 0.d0
                        do j4 = 1, jx
                          ii = k1j1 + (jx*(jx-1)) / 2 + j4
                          sum1 = sum1 + f(ii) * cocc(kl+j4)
                        end do
                        ii = k1j1 + (jx*(jx+1)) / 2
                        do i4 = jx + 1, iorbs(k1)
                          ii = k1j1 + (i4*(i4-1)) / 2 + jx
                          sum1 = sum1 + f(ii) * cocc(kl+i4)
                        end do
                        sum = sum + cocc(jl+jx) * sum1
                      end do
                    end if
                  end if
                end if
                kl = kl + iorbs(k1)
              end do
              !
              jl = jl + iorbs(j1)
            end do
          else
            do j = nncf(i) + 1, nncf(i) + ncf(i)
              j1 = icocc(j)
              kl = loopi
              do k = nncf(i) + 1, nncf(i) + ncf(i)
                k1 = icocc(k)
                k1j1 = ijbo (k1, j1)
                if (k1j1 >= 0) then
                  if (avir(k1)*p(k1j1+1)*aocc(k) >= cutoff) then
                    !
                    !  EXTRACT THE ATOM-ATOM INTERSECTION OF f
                    !
                    if (k1 > j1) then
                      !
                      !   LOWER TRIANGLE
                      !
                      do jx = 1, iorbs(j1)
                        sum1 = 0.d0
                        do i4 = 1, iorbs(k1)
                          ii = k1j1 + (i4-1) * iorbs(j1) + jx
                          sum1 = sum1 + f(ii) * cocc(kl+i4)
                        end do
                        sum = sum + cocc(jl+jx) * sum1
                      end do
                    else if (k1 < j1) then
                      !
                      !   UPPER TRIANGLE
                      !
                      do jx = 1, iorbs(j1)
                        sum1 = 0.d0
                        do i4 = 1, iorbs(k1)
                          ii = k1j1 + (jx-1) * iorbs(k1) + i4
                          sum1 = sum1 + f(ii) * cocc(kl+i4)
                        end do
                        sum = sum + cocc(jl+jx) * sum1
                      end do
                    else
                      !
                      !   DIAGONAL TERM
                      !
                      do jx = 1, iorbs(j1)
                        sum1 = 0.d0
                        do j4 = 1, jx
                          ii = k1j1 + (jx*(jx-1)) / 2 + j4
                          sum1 = sum1 + f(ii) * cocc(kl+j4)
                        end do
                        ii = k1j1 + (jx*(jx+1)) / 2
                        do i4 = jx + 1, iorbs(k1)
                          ii = k1j1 + (i4*(i4-1)) / 2 + jx
                          sum1 = sum1 + f(ii) * cocc(kl+i4)
                        end do
                        sum = sum + cocc(jl+jx) * sum1
                      end do
                    end if
                  end if
                end if
                kl = kl + iorbs(k1)
              end do
              !
              jl = jl + iorbs(j1)
            end do
          end if
          !
          eigs(i) = sum
          !
      end do

end subroutine MOZYME_eigs

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine parsav(mode, n, m, q, r, efslst, xlast, iiium)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE molkst_C, ONLY:  keywrd, numat, norbs
      USE chanel_C, only : ires, iw, restart_fn
      use common_arrays_C, only : aicorr, errfn
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: mode
      integer  :: n, m, iiium(6)
      double precision  :: q(n,n)
      double precision, dimension(n) :: efslst, xlast
      double precision  :: r(n + 2,n + 2)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer ::  i, j, io_stat, old_numat, old_norbs
      logical :: opend
!-----------------------------------------------
!*********************************************************************
!
!   PARSAV SAVES AND RESTORES DATA USED IN NLLSQ GRADIENT MINIMIZATION.
!
!    IF MODE IS 0 DATA ARE RESTORED, IF 1 THEN SAVED.
!
!*********************************************************************
      inquire(unit=ires, opened=opend)
      if (opend) close(unit=ires, status='KEEP')
      open(unit=ires, file=restart_fn, form='UNFORMATTED', iostat = io_stat)
      if (io_stat /= 0) then
          write(iw,*)" Restart file either does not exist or is not available for reading"
          call mopend ("Restart file either does not exist or is not available for reading")
          return
        end if
      rewind ires
      if (mode == 0) then
!
!  MODE=0: RETRIEVE DATA FROM DISK.
!
        write (iw, '(2/10X,''RESTORING DATA FROM DISK''/)')
        read (ires, iostat = io_stat) old_numat, old_norbs, (xlast(i),i=1,n), m, iiium, efslst, n
        if (norbs /= old_norbs .or. numat /= old_numat) then
              call mopend("Restart file read in does not match current data set")
              return
        end if
        read (ires, iostat = io_stat) ((q(j,i),j=1,m),i=1,m)
        read (ires, iostat = io_stat) ((r(j,i),j=1,n),i=1,n)
        if (index(keywrd,'AIDER') /= 0) then
          read (ires, iostat = io_stat) (aicorr(i),i=1,n)
          read (ires, iostat = io_stat) (errfn(i),i=1,n)
        end if
        if (io_stat /= 0) then
          write(iw,*)" Restart file is currupt"
          call mopend ("Restart file is currupt")
        end if
        close(ires)
        return
      end if
      if (mode == 1) then
        write (iw, &
      '(2/10X,                                              ''- - - - - - - TIM&
      &E UP - - - - - - -'',2/)')
        write (iw, '(10X,A)') ' - THE CALCULATION IS BEING DUMPED TO DISK', &
          '   RESTART IT USING THE KEY-WORD "RESTART"'
        write (iw, '(/10X,''CURRENT VALUE OF GEOMETRY'',/)')
        call geout (iw)
      end if
      write (ires) numat, norbs, (xlast(i),i=1,n), m, iiium, efslst, n
      write (ires) ((q(j,i),j=1,m),i=1,m)
      write (ires) ((r(j,i),j=1,n),i=1,n)
      if (index(keywrd,'AIDER') /= 0) write (ires) (aicorr(i),i=1,n)
      if (index(keywrd,'AIDER') /= 0) write (ires) (errfn(i),i=1,n)
!*****
!     The density matrix is required by ITER upon restart .
!
      call den_in_out(1)
!
!*****
      close(ires)
      return
      end subroutine parsav

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine point (nvecs, fcells)
  use common_common, only : id, ir, iw, line, Sym_Oper, jobnam, data_set_name, l_read_dat
  implicit none
  integer, intent(in) :: nvecs
  complex, dimension(nvecs, nvecs) :: v
  double precision, dimension(nvecs, *), intent(in) :: fcells
!
  character(len=80) :: input_line
  logical :: leadsp
  integer :: i, j, itype, nvalue
  integer, dimension(20) :: istart
  double precision, dimension(3) :: xyzk, xyzxyz
  double precision, dimension(2*nvecs) :: eigs
  double precision, external :: reada
  do
    Sym_Oper = " "
    if (l_read_dat) write(iw, '(a)') " Please type point in k-space or a blank line to quit"
    if (l_read_dat) write(iw, "(A,I2,A)") " Format is", id, " numbers, free format"
    read(ir, "(A)", end = 1000, err = 1000) line
    if (line == " ") goto 1000
    i = index(line, '{')
    if (i /= 0) then
      j = index(line, "}")
      Sym_Oper = line(i + 1:j - 1)
    end if
    line(30:) = ": Please type point in k-space or a blank line to quit"
    call write_keystrokes(line, len_trim(line))
    read(line, '(a)') input_line
    leadsp = .true.
    nvalue = 0
    do i = 1, 80
      if (leadsp .and. input_line(i:i)/=" ") then
        nvalue = nvalue + 1
        istart(nvalue) = i
      end if
      leadsp = (input_line(i:i)==" ")
    end do
    if( nvalue < id .and. nvalue > 0) then
      i = ichar(input_line(istart(1):istart(1)))
      if (i >= ichar("0") .and. i <= ichar("9")) &
        write(iw,'(a,i2,a)')" Exactly",id," points are needed" 
      cycle    
    end if
    if (nvalue > 3) then
      line = input_line(istart(4):)
    else
      line = " "
    end if
    if (input_line == " ") stop
    do i = 1, id
      xyzk(i) = reada (input_line, istart(i))
    end do
    do i = 1, 3
      xyzxyz(i) = xyzk(i)
    end do
    if (id /= 1) then
      call rot (xyzk)
    end if
    call upcase (input_line)
    !
    !   Option to decide how to represent operations which involve non-
    !   primitive translations
    !
    itype = 1
    if (Index (input_line, " RAW") /= 0) then
      itype = 1
    end if
    if (Index (input_line, " ONE") /= 0) then
      itype = 2
    end if
    if (Index (input_line, " BYK") /= 0) then
      itype = 3
    end if
    if (input_line == " ") then
      stop
    end if
    call kpoint (fcells, nvecs, xyzk(1), xyzk(2), xyzk(3), v, eigs)
    line = Sym_Oper
    call solir (eigs, v, nvecs, xyzk, itype, xyzxyz)
  end do
1000 continue
  call graphics(0.0, 0.0, 100)
  if (l_read_dat) then
    write(iw,'(/5x,a)')"A copy of this output can be found in the file: '"//trim(jobnam)//".txt'"
    write(iw,'(/5x,a)')"Press ""RETURN"" to quit"
    read(iw,'(a)', iostat = i) input_line
  else
    write(iw,'(/5x,a)')"A copy of this output can be found in the file: '"//trim(data_set_name)//".txt'"
    write(iw,'(/5x,a)')"Press ""RETURN"" to quit"
    read(iw,'(a)', iostat = i) input_line
  end if
  stop
end subroutine point

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine forsav(time, deldip, ipt, fmatrx, coord, nvar, refh, evecs, &
        jstart, fconst)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE chanel_C, only : iw, ires, restart_fn
      use molkst_C, only : numat, norbs
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: ipt
      integer , intent(in) :: nvar
      integer  :: jstart
      double precision  :: time
      double precision  :: refh
      double precision  :: deldip(3,*)
      double precision  :: fmatrx((nvar*(nvar+1))/2)
      double precision  :: coord(nvar)
      double precision  :: evecs(nvar**2)
      double precision  :: fconst(nvar)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, i99, j, linear, n33, old_numat, old_norbs
      logical :: opend, exists
!-----------------------------------------------
!***********************************************************************
!
!  FORSAV SAVES AND RESTORES DATA USED IN THE FORCE CALCULATION.
!
! ON INPUT TIME = TOTAL TIME ELAPSED SINCE THE START OF THE CALCULATION.
!          IPT  = LINE OF FORCE MATRIX REACHED, IF IN WRITE MODE,
!               = 0 IF IN READ MODE.
!        FMATRX = FORCE MATRIX
!***********************************************************************
      i99 = 0
   10 continue
      j = i99
      inquire(unit=ires, opened=opend)
      if (opend) close(unit=ires, status='KEEP')
      if (ipt == 0) then
        inquire (file=restart_fn, exist = exists)
        if ( .not. exists) then
          call mopend ('RESTART file does not exist')
          return
        end if
      end if
      open(unit=ires, file=restart_fn, status='UNKNOWN', &
      form='UNFORMATTED', iostat=i99, position='asis')
      if (i99 /= 0) then
        if (j /= 0) then
          call mopend ('Fatal error in trying to open RESTART file')
          return
        end if
!
!   A restart file exists, but cannot be mounted.  Delete it.
!   If it can't be deleted, carry on regardless.
!
        open(unit=ires, file=restart_fn, status='OLD', iostat=i99, &
          position='asis')
        close(ires, status='DELETE', iostat=i99)
        go to 10
      end if
      rewind ires
      if (ipt == 0) then
!
!   READ IN FORCE DATA
!
        read (ires, iostat=i99) time, ipt, refh, old_numat, old_norbs
        if (norbs /= old_norbs .or. numat /= old_numat) then
              call mopend("Restart file read in does not match current data set")
              return
        end if
        linear = (nvar*(nvar + 1))/2
        read (ires, iostat=i99) (coord(i),i=1,nvar)
        read (ires, iostat=i99) (fmatrx(i),i=1,linear)
        read (ires, iostat=i99) ((deldip(j,i),j=1,3),i=1,ipt)
        n33 = nvar*nvar
        read (ires, iostat=i99) (evecs(i),i=1,n33)
        read (ires, iostat=i99) jstart, (fconst(i),i=1,nvar)
        close (ires)
        if (i99 /= 0) then
          call mopend ('INSUFFICIENT DATA ON DISK FILES FOR A FORCE CALCULATION RESTART.')
          write (iw, '(/10X,"PERHAPS THIS STARTED OFF AS A FORCE CALCULATION")')
          write (iw, '(10X,"BUT THE GEOMETRY HAD TO BE OPTIMIZED FIRST, IN WHICH CASE" &
      &,/10X,"REMOVE THE KEY-WORD ""FORCE"".")')
        end if
        return
      else
!
!    WRITE FORCE DATA
!
        rewind ires
        if (time > 1.D7) time = time - 1.D7
        write (ires) time, ipt, refh, numat, norbs
        linear = (nvar*(nvar + 1))/2
        write (ires) (coord(i),i=1,nvar)
        write (ires) (fmatrx(i),i=1,linear)
        write (ires) ((deldip(j,i),j=1,3),i=1,ipt)
        n33 = nvar*nvar
        write (ires) (evecs(i),i=1,n33)
        write (ires) jstart, (fconst(i),i=1,nvar)
        call den_in_out(1)
        close(ires)
      end if
      return
      end subroutine forsav

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine symh(h, dip, i, n, ipo)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use symmetry_C, only : r
      USE molkst_C, ONLY: numat
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: i
      integer , intent(in) :: n
      integer, dimension (numat, 120), intent (in) :: ipo
      double precision , intent(inout) :: h(*)
      double precision , intent(inout) :: dip(3,*)

!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: k, i3, i6, k3, k6, j, l, l3, l6, j3, j6, iel33, im1t3, istart
      double precision, dimension(9) :: temp, temp2
      double precision :: fact
!-----------------------------------------------
!****************************************************************
!
!  INPUT:   H()   A packed lower triangular hessian
!           DIP(,) A MATRIX OF DIPOLE TENSORS TO BE SYMM
!           R(,)  A matrix of symmetry operations
!           IPO(,) A matrix of atomic mapping according to R
!           I     The atom (row and column) to add to H()
!           N     The symmetry operation to use to generate I
!
!  OUTPUT:  H()   A packed lower triangular Hessian with information
!                   about atom I added
!           DIP(,) A MATRIX OF DIPOLE TENSORS THAT HAVE BEEN SYMM
!
!****************************************************************
!
!
!  This subroutine will add all necessary information to the Hessian
!    concerning atom I.  Since the Hessian is a packed lower half
!    triangle, the existing information for atom pair (K,L) where K,L
!    < I is fully known, (K > I and L < I) or (vice versa) is half
!    known, K,L > I is completely unknown.
!    Therefore, start in unknown region and make it half known.  Double
!    known values, and move in the diagonal element at full strength.
!
!
!
!
!
!  Variables used:  (n represents the number of atomic centers)
!     H(3n,3n):  Input/output matrix.  It is a packed lower half triangu
!        matrix.  Commonly, the Hessian.
!     TEMP(9), TEMP2(9):   Temporary matricies used to hold small parts
!          larger matricies for specific matrix operations.
!
!    For the next two items, the last indicy represents the symmetry
!        operation number.
!     R(14,*):   The first 9 elements of each record are a packed 3 by 3
!          array of a given symmetry operations.  Elements 10 - 14 are t
!          users input describing the symmetry operation.
!     IPO(n,*):  A vector that contains the symmetry mapping of atomic c
!
!
      k = ipo(i,n)
      i3 = 3*i
      i6 = 6*i
      k3 = 3*k
      k6 = 6*k
!
!  Now, to climb up the matrix
      do j = numat, i + 1, -1
        l = ipo(j,n)
        l3 = 3*l
        l6 = 6*l
        j3 = 3*j
        j6 = 6*j
!
!  Now, to actually perform R H R
!
!  Do this multiplication in a 3 by 3 block at a time.  Store H(i,j) in
!    H( IPO(I,N), IPO(J,N))
!
        if (k > l) then
          iel33 = (k3*(k3 - 1))/2 + l3
          temp(9) = 0.5D0*h(iel33)
          temp(8) = 0.5D0*h(iel33-1)
          temp(7) = 0.5D0*h(iel33-2)
          temp(6) = 0.5D0*h(iel33-k3+1)
          temp(5) = 0.5D0*h(iel33-k3)
          temp(4) = 0.5D0*h(iel33-k3-1)
          temp(3) = 0.5D0*h(iel33-k6+3)
          temp(2) = 0.5D0*h(iel33-k6+2)
          temp(1) = 0.5D0*h(iel33-k6+1)
        else
          iel33 = (l3*(l3 - 1))/2 + k3
          fact = 1.0D0
          if (l < i) fact = 0.5D0
          temp(9) = fact*h(iel33)
          temp(6) = fact*h(iel33-1)
          temp(3) = fact*h(iel33-2)
          temp(8) = fact*h(iel33-l3+1)
          temp(5) = fact*h(iel33-l3)
          temp(2) = fact*h(iel33-l3-1)
          temp(7) = fact*h(iel33-l6+3)
          temp(4) = fact*h(iel33-l6+2)
          temp(1) = fact*h(iel33-l6+1)
        end if
!
        call mat33 (r(1,n), temp, temp2)
!
        iel33 = (j3*(j3 - 1))/2 + i3
        h(iel33) = temp2(9)
        h(iel33-j3+1) = temp2(8)
        h(iel33-j6+3) = temp2(7)
        h(iel33-1) = temp2(6)
        h(iel33-j3) = temp2(5)
        h(iel33-j6+2) = temp2(4)
        h(iel33-2) = temp2(3)
        h(iel33-j3-1) = temp2(2)
        h(iel33-j6+1) = temp2(1)
      end do
!
!  Now, to do the diagonal term
!
      iel33 = (k3*(k3 + 1))/2
      temp(9) = 0.5D0*h(iel33)
      temp(8) = 0.5D0*h(iel33-1)
      temp(7) = 0.5D0*h(iel33-2)
      temp(6) = temp(8)
      temp(5) = 0.5D0*h(iel33-k3)
      temp(4) = 0.5D0*h(iel33-k3-1)
      temp(3) = temp(7)
      temp(2) = temp(4)
      temp(1) = 0.5D0*h(iel33-k6+1)
!
      call mat33 (r(1,n), temp, temp2)
!
      iel33 = (i3*(i3 + 1))/2
      h(iel33) = temp2(9)
      h(iel33-1) = temp2(8)
      h(iel33-2) = temp2(7)
      h(iel33-i3) = temp2(5)
      h(iel33-i3-1) = temp2(4)
      h(iel33-i6+1) = temp2(1)
!
!   NOW, TO ROTATE THE DIPOLE TENSOR TERM
!
      temp(9) = dip(3,k*3)
      temp(8) = dip(2,k*3)
      temp(7) = dip(1,k*3)
      temp(6) = dip(3,k*3-1)
      temp(5) = dip(2,k*3-1)
      temp(4) = dip(1,k*3-1)
      temp(3) = dip(3,k*3-2)
      temp(2) = dip(2,k*3-2)
      temp(1) = dip(1,k*3-2)
!
      call mat33 (r(1,n), temp, temp2)
!
      dip(3,i*3) = temp2(9)
      dip(2,i*3) = temp2(8)
      dip(1,i*3) = temp2(7)
      dip(3,i*3-1) = temp2(6)
      dip(2,i*3-1) = temp2(5)
      dip(1,i*3-1) = temp2(4)
      dip(3,i*3-2) = temp2(3)
      dip(2,i*3-2) = temp2(2)
      dip(1,i*3-2) = temp2(1)
!
!   Now, to double all existing values going across
!
      im1t3 = (i - 1)*3
      istart = (im1t3*(im1t3 + 1))/2 + 1
      h(istart:iel33) = h(istart:iel33) + h(istart:iel33)
!  Everything is now done for this symmetry element.
!
      return
      end subroutine symh

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine extvdw_for_MOZYME (radius, refvdw)
    use molkst_C, only: numat, keywrd, line
    use chanel_C, only: iw
    use common_arrays_C, only: nat
    use atomradii_C, only: is_metal
    use elemts_C, only : cap_elemnt
    implicit none
    double precision, dimension (numat), intent (out) :: radius
    double precision, dimension (107), intent (in) :: refvdw
    integer :: i, j, k
    double precision, dimension (107) :: vdw
    character (len=80) :: txt_rad
    logical :: paren
    double precision, external :: reada
!
!  Modify Van der Waals' radii of various atoms.  The format of
! the keyword is: VDW(:chemical symbol=n.nn:chemical symbol=n.nn ...)
! e.g. VDWM(:H=1.0:Cl=1.7)
!
    txt_rad = " "
    j = -1
    i = index(keywrd," METAL")
    if (i /= 0) j = index(keywrd(i:),") ") + i
    if (i /= 0 .and. keywrd(i + 6:i + 6) == " " .or. index(keywrd, " ADD-H") /= 0) then
      is_metal = .false.
      do i = 1, 102
        select case (i)
        case (3, 4, 11, 12, 19:30, 37:48, 55:80)
          is_metal(i) = .true.
        end select
      end do
    else if (i > 0) then
      i = index(keywrd(i:j), "(") + i
      txt_rad = keywrd(i:j - 1)
      do k = 1, 83
        if (.not. is_metal(k)) is_metal(k) = (index(txt_rad,cap_elemnt(k)) /= 0)
      end do
    end if
    i = index(keywrd," VDWM(")
    if (i == 0) then
      line = " "
    else
      if (keywrd(i + 6:i + 6) /= ";" .and. keywrd(i + 6:i + 6) /= ":") keywrd(i + 6:) = ";"//keywrd(i + 6:)
      j = index(keywrd(i + 6:),")") + i + 6
      do k = i + 5, j
         if (keywrd(k:k) == ":") keywrd(k:k) = ";"
         if (keywrd(k:k) == ",") keywrd(k:k) = ";"
      end do
      line = keywrd(i + 5:j - 1)
    end if
    vdw(:107) = refvdw(:107)
    if (line /= " ") then
      do i = 1, 107
        j = 2
        if (cap_elemnt(i)(2:2) == " ") j = 1
        k = index(line, ";"//cap_elemnt(i)(:j)//"=")
        if (k > 0) then
          vdw(i) = reada(line, k)
          is_metal(i) = .false.
        end if
      end do
    end if
!
!  Verify that all radii that will be used are, in fact, set correctly
!
    do i = 1, numat
      if (nat(i) > 98) cycle
      if (vdw(nat(i)) > 900.d0) then
        write (line,*) "MISSING VAN DER WAALS RADIUS FOR " // cap_elemnt (nat(i))
        call mopend(trim(line))
        j = 2
        if (cap_elemnt(nat(i)) (2:2) == " ") j = 1
        write (iw, "(2x,3a)") "To correct this, add keyword 'VDWM(", &
       & cap_elemnt (nat(i)) (1:j), "=n.nn)'"
        return
      end if
    end do
!
! Flag which elements are to be treated as metals by giving them negative
! atomic radii
    do i = 1, 102
      if (is_metal(i)) vdw(i) = -1.0d0
    end do
    do i = 1, numat
      radius(i) = vdw(nat(i))
    end do
!
!  Set VDW radius for individual atoms to -1
!
    if (txt_rad /= " ") then
      paren = .false.
      i = 0
      do k = 1, len_trim(txt_rad)
        i = i + 1
        if (paren) then
          paren = (txt_rad(i:i) /= ")")
        else
           paren = (txt_rad(i:i) == "(")
          if (ichar(txt_rad(i:i)) - ichar("0") <= 9 .and. ichar(txt_rad(i:i)) - ichar("0") > 0) then
            j = nint(reada(txt_rad(i:), 1))
            i = i + int(log10(j*1.0001))
            radius(j) = -1.d0
            do j = i, len_trim(txt_rad)
              if (ichar(txt_rad(i:i)) - ichar("0") > 9 .or. &
              ichar(txt_rad(i:i)) - ichar("0") < 0) exit
              txt_rad(i:i) = " "
            end do
          end if
        end if
      end do
    end if
    return
  end subroutine extvdw_for_MOZYME
    subroutine rectify_sequence()
    use common_arrays_C, only : geo, coord, txtatm, txtatm1, nat, labels, coorda
    use molkst_C, only: numat, pdb_label
    implicit none
!
!  Search atom sequence for the following structure:
!  A break in a chain: same chain letter, but the residue sequence increases suddenly.
!  After the increase, atoms of a residue in the same chain that are out-of-sequence are found.
!
! If this situation occurs, move the out-of-sequence atoms to their correct place.
!
! This should only be done if RESEQ or similar keyword is present.
!
    integer :: i_lower, res2, res1, res3, res, ii, jj, num_min, num_max
    character :: chain1*1, chain2*1, chain*1, used(numat)*1
    double precision, external :: reada
    if (pdb_label) return
    txtatm1(:numat) = txtatm(:numat)
    coorda(:,:numat) = coord(:,:numat)
    used(:numat) = txtatm1(:numat)(22:22)
    used(1) = "a"
    labels(:numat) = nat(:numat)
    geo(:,:numat) = coord(:,:numat)
    res1 = nint(reada(txtatm(1), 23))
    chain1 = "a"
!
!  ii keeps track of the new numbering sequence
!
    ii = 1
    do i_lower = 2, numat
      chain2 = used(i_lower)
      if (chain2 == "a") cycle           ! Atom already used
!
!   res1: Residue number of previous residue
!   res2: Residue number of current residue
!
      res2 = nint(reada(txtatm1(i_lower), 23))
!
! Look for a fault at the end of the first bit of chain
! This will occur in atoms in the domain res1 to res1 + 1
!
      do res3 = res1, res1 + 1
        num_min = max(i_lower - 50, 1)
        num_max = min(i_lower + 50, numat)
        do
          do jj = num_min, num_max
            res = nint(reada(txtatm1(jj), 23))
            chain = used(jj)
            if (res == res3 .and. chain == chain1 .and. used(jj) /= "a") exit
          end do
          if (jj > num_max) exit
          ii = ii + 1
          coord(:,ii) = geo(:,jj)
          txtatm(ii) = txtatm1(jj)
          nat(ii) = labels(jj)
          used(jj) = "a"
        end do
      end do
!
! Look for a fault at the start of the next bit of chain
! This will occur in atoms in the domain res2 - 1 to res2
!
      do res3 = res2 - 1, res2
        num_min = max(i_lower - 50, 1)
        num_max = min(i_lower + 50, numat)
        do
          do jj = num_min, num_max
            res = nint(reada(txtatm1(jj), 23))
            chain = used(jj)
            if (res == res3 .and. chain == chain1 .and. used(jj) /= "a") exit
          end do
          if (jj > num_max) exit
          ii = ii + 1
          coord(:,ii) = geo(:,jj)
          txtatm(ii) = txtatm1(jj)
          nat(ii) = labels(jj)
          used(jj) = "a"
        end do
      end do
      chain1 = chain2
      res1 = res2
    end do
    if (ii < numat) then
      do jj = 1, numat
        if (used(jj) /= "a") then
          ii = ii + 1
          coord(:,ii) = geo(:,jj)
          txtatm(ii) = txtatm1(jj)
          nat(ii) = labels(jj)
          used(jj) = "a"
        end if
      end do
    end if
    return
  end subroutine rectify_sequence
  subroutine write_sequence
    use common_arrays_C, only : txtatm, nat
!
    use MOZYME_C, only : ions, allres, tyr, allr, tyres, maxres
!
    use chanel_C, only: iw
!
    use molkst_C, only: numat, line, job_no, maxtxt
    implicit none
    integer :: i, nfrag, jj, ii, ires, kl, ku, irold, l, j, k, charge, i_job_no = -50, &
      ifrag, i_alt
    integer, allocatable :: res_no(:)
    character, allocatable :: res_charge(:)*1
    logical, save :: prt, use_alt, use_alt_2
    character :: chain, ch*2, ilet*1, jj_let*1
    double precision, external :: reada
    save :: i_job_no
    prt = (i_job_no /= job_no)
    if (prt) then
      i_job_no = job_no
    else
     return
    end if
!
!  Write out all residue names, use information in txtatm to define sequence
!
      ii = 1
      ifrag = 0
      if (maxtxt == 27) allocate(res_no(numat), res_charge(numat))
      use_alt_2 = .false.
      do nfrag = 1, 100
        if (ii > numat) exit
        if (txtatm(ii) == " ") exit
        chain = txtatm(ii)(22:22)
        ires = nint(reada(txtatm(ii), 23))
        allres = " "
        allres(ires) = txtatm(ii)(18:20)
        ilet = txtatm(ii)(27:27)
        charge = ions(ii)
        irold = ires
        j = 0
        i_alt = 0
        use_alt = .false.
        do ii = ii + 1, numat
          if (nat(ii) /= 1 .and. txtatm(ii)(22:22) /= chain) exit !  chain letter has changed.
          jj = nint(reada(txtatm(ii),23))
          jj_let = txtatm(ii)(27:27)
          if (nat(ii - 1) /= 1) j = ii - 1
          charge = charge + ions(ii)
          if (ires == jj .and. ilet == jj_let) cycle              !  Residue is same
!
! At this point, atom "ii" marks the start of the next residue
! and the charge on the current residue is "charge"
!
          charge = charge - ions(ii)
          if (txtatm(ii)(14:14) == "H") cycle!  Ignore hydrogen atoms
          if (ires + 1 /= jj .and. (ires /= jj .and. ilet == jj_let)) exit           !  Residue is not contiguous
!
!  Take residue name from the previous atom (the atom label has just changed)
!
!  Charge is the net charge on the previous residue, so:
!
          if (charge == 1) then
            allres(ires)(4:4) = "+"
          else if (charge == -1) then
            allres(ires)(4:4) = "-"
          end if
          ires = ires + 1
          allres(ires)(1:3) = txtatm(ii)(18:20)
          if (maxtxt == 27) then
            i_alt = i_alt + 1
            res_no(i_alt) = ii - 1
            res_charge(i_alt) = allres(ires)(4:4)
            if (.not. use_alt) use_alt = (ilet /= jj_let)
          end if
          charge = 0
          if (ires /= jj) ires = ires + 1
          ilet = jj_let
          if (ires > maxres) then
            write(line,'(a,i5)')" Maximum residue number allowed:", maxres
            call mopend(trim(line))
            return
          end if
        end do
        if (ii > numat) j = numat
        if (j /= 0) then
          if (txtatm(j)(18:20) /= "   " .and. allres(ires) == " ") allres(ires) = txtatm(j)(18:20)
        end if
        if (charge == 1) then
          allres(ires)(4:4) = "+"
        else if (charge == -1) then
          allres(ires)(4:4) = "-"
        end if
        do j = irold, ires
          do k = 1, 20
            if (allres(j) == tyres(k)) exit
          end do
          if (k < 21) exit
        end do
        if (j > ires .or. (j == ires .and. j == 0)) cycle
        do i = ires, 1, -1
          if (allres(i) /= "HOH" .and. allres(i) /= "SO4") exit
        end do
        ires = i
        ifrag = ifrag + 1
        if (ifrag == 1) then
          write (iw, "(/,16X,A,/)") "RESIDUE SEQUENCE IN PROTEIN Chain: "//chain
        else
          write (iw, "(/,16X,A,I2, a/)") "RESIDUE SEQUENCE IN PROTEIN FRAGMENT:", ifrag, " Chain: "//chain
        end if
        if (use_alt) then
          do i = 1, i_alt, 10
            write(iw,'(3x,10a)')(txtatm(res_no(j))(23:27)//": "//txtatm(res_no(j))(18:20)//res_charge(j)//" ", &
            j = i, min(i + 9, i_alt))
          end do
          use_alt_2 = .true.
          cycle
        end if
        if (irold < 1) then
          jj = 100
          i = mod(irold + jj, 10)
          if (i == 0) i = 10
          kl = irold
          ku = min(ires, kl - i + 10)
          line = " "
          l = 6*(i - 1) + 1
          j = ((kl + jj)/10)*10 - jj
          if (i == 10) j = j - 10
          write(iw,"(8x,10i6)")((k - 10), k = 1, 10)
          write(iw,"(5x,i4,2x,a,10(a4,'  '))")j, line(:l), allres(kl:ku)
          do
            kl = ku + 1
            if (kl > min(0, ires)) exit
            j = j + 10
            ku = min(ires, ku + 10)
            write(iw,"(5x,i4,3x,10(a4,'  '))")j, allres(kl:ku)
         end do
         write(iw,'(a)')" "
        end if
        kl = max(irold, 1)
        i = mod(kl, 10)
        if (i == 0) i = 10
        ku = min(ires, kl - i + 10)
        line = " "
        l = 6*(i - 1) + 1
        j = (kl/10)*10
        if (i == 10) j = j - 10
        write(iw,"(8x,10i6)")(k, k = 1, 10)
        write(iw,"(5x,i4,2x,a,10(a4,'  '))")j, line(:l), allres(kl:ku)
        do
          kl = ku + 1
          if (kl > ires) exit
          j = j + 10
          ku = min(ires, ku + 10)
          write(iw,"(5x,i4,3x,10(a4,'  '))")j, allres(kl:ku)
        end do
      end do
      if (use_alt_2) return
      ii = 1
      ifrag = 0
      do nfrag = 1, 100
        j = 0
        if (ii > numat) exit
        if (txtatm(ii) == " ") exit
        chain = txtatm(ii)(22:22)
        ires = nint(reada(txtatm(ii), 23))
        irold = ires
        do ii = ii + 1, numat
          if (nat(ii) /= 1 .and. txtatm(ii)(22:22) /= chain) exit !  chain letter has changed.
          jj = nint(reada(txtatm(ii),23))
          if (nat(ii - 1) /= 1) j = ii - 1
          if (ires == jj) cycle              !  Residue is same
          if (txtatm(ii)(14:14) == "H") cycle!  Ignore hydrogen atoms
          if (ires + 1 /= jj) exit           !  Residue is not contiguous
          allres(ires) = txtatm(ii - 1)(18:20)
          ires = ires + 1
        end do
        if (j /= 0) then
          if (txtatm(j)(18:20) /= "   ") allres(ires) = txtatm(j)(18:20)
        end if
        do j = irold, ires
          do k = 1, 20
            if (allres(j) == tyres(k)) exit
          end do
          if (k < 21) exit
        end do
        if (j > ires .or. (j == ires .and. j == 0)) cycle
        do i = ires, 1, -1
          if (allres(i) /= "HOH" .and. allres(i) /= "SO4") exit
        end do
        ires = i
        do i = irold, ires
          do k = 1, 20
            if (tyres(k) == allres(i)) exit
          end do
          if (k > 0 .and. k < 21) then
            allr(i) = tyr(k)
          else if (allres(i) /= " ") then
            allr(i) = "X"
          else
            allr(i) = " "
          end if
        end do
        ifrag = ifrag + 1
        if (ifrag == 1) then
          write (iw, "(/,16X,A,/)") "RESIDUE SEQUENCE IN PROTEIN Chain: "//chain
        else
          write (iw, "(/,16X,A,I2, a/)") "RESIDUE SEQUENCE IN PROTEIN FRAGMENT:", ifrag, " Chain: "//chain
        end if
        jj = 100
        i = mod(irold + jj, 10)
        if (irold < 0) i = i - 10
        if (i == 0) i = 10
        kl = irold
        if (i < 0) then
          ku = min(ires, kl - i + 40)
        else
          ku = min(ires, kl - i + 50)
        end if
        line = " "
        j = ((kl + jj)/10)*10 - jj
        if (i == 10) j = j - 10
        if (i == 1) then
          ch = "10"
        else
          ch(1:1) = " "
          if (i < 0) then
             ch(2:2) = char(9 + i + ichar("0"))
             if (ch(2:2) == "0") then
               ch(1:1) = "1"
               i = 12
             else
               i = 2 - i
             end if
          else
             ch(2:2) = char(11 - i + ichar("0"))
          end if
        end if
        if (i /= 0) write (iw, "(5x,i4,a,"//ch//"a,x,10(10a1,x))")j, line(:i + 1), (allr(i), i=kl, ku)
        do
          kl = ku + 1
          if (kl > ires) exit
          j = j + 50
          ku = min(ires, kl + 49)
          write (iw, "(5X,I4,2X,5(10A1,1X))") j, (allr(i), i=kl, ku)
        end do
      end do
      return
  end subroutine write_sequence
  subroutine fix_charges(ichrge)
  use molkst_C, only: refkey, keywrd, line
  implicit none
  integer, intent (in) :: ichrge
  integer :: i, j
!
!  Modify charges in keyword line so that the system will run using MOZYME.
!  Steps:
!     If "old" CHARGE=n keyword exists in the reference keyword line, delete it.
!     Write new CHARGE keyword, if charge is non-zero
!     Rewind the data set file.
!     Write out the new data set.
!     Rewind it again, so it is ready for reading.
!     Rewind the output file, so the user does not see the faulty output.
!
      line = trim(refkey(1))
      call upcase(line,len_trim(line))
      i = Index(line," CHARGE=")
      if (i /= 0) then
        j = Index(refkey(1)(i+2:)," ")
        refkey(1)(i + 1:) = refkey(1)(i + j + 2:)
      end if
!                 12345678901
      i = Index(refkey(1),"            ")
      if (ichrge /= 0) then
        if (ichrge > 99) then
          write(refkey(1)(i:i+11),'(" CHARGE=",i3)')ichrge
        else if (ichrge > 9) then
          write(refkey(1)(i:i+11),'(" CHARGE=",i2)')ichrge
        else if (ichrge > 0) then
          write(refkey(1)(i:i+11),'(" CHARGE=",i1)')ichrge
        else if (ichrge > -10) then
          write(refkey(1)(i:i+11),'(" CHARGE=",i2)')ichrge
        else
          write(refkey(1)(i:i+11),'(" CHARGE=",i3)')ichrge
        end if
      end if
       i = Index(keywrd," CHARGE=")
      if (i /= 0) then
        j = Index(keywrd(i+2:)," ")
        keywrd(i + 1:) = keywrd(i + j + 2:)
      end if
      i = Index(keywrd,"            ")
      if (ichrge /= 0) then
        if (ichrge > 99) then
          write(keywrd(i:i+11),'(" CHARGE=",i3)')ichrge
        else if (ichrge > 9) then
          write(keywrd(i:i+11),'(" CHARGE=",i2)')ichrge
        else if (ichrge > 0) then
          write(keywrd(i:i+11),'(" CHARGE=",i1)')ichrge
        else if (ichrge > -10) then
          write(keywrd(i:i+11),'(" CHARGE=",i2)')ichrge
        else
          write(keywrd(i:i+11),'(" CHARGE=",i3)')ichrge
        end if
      end if
end subroutine fix_charges
subroutine add_sp_H(i1, i, i2)
!
! Given three atoms, i1, i, and i2, put a hydrogen atom at the point
! of a triangle
!
  use molkst_C, only: natoms, maxatoms
  use common_arrays_C, only : geo, nat, txtatm
  use chanel_C, only: iw
  implicit none
  integer :: i1, i, i2
  logical :: first = .true.
  double precision :: scale
  natoms = natoms + 1
  if (natoms > maxatoms) then
    if (first) then
      write(iw,*)" Too many changes. Re-run using the data set generated by this job"
      first = .false.
    end if
    natoms = natoms - 1
    return
  end if
  geo(:,natoms) = 2.d0*geo(:,i1) - 2.d0*geo(:,i) + geo(:,i2)
  scale = 1.1d0/sqrt( (geo(1,i1) - geo(1,natoms))**2 + &
                      (geo(2,i1) - geo(2,natoms))**2 + &
                      (geo(3,i1) - geo(3,natoms))**2 )
  geo(:,natoms) = geo(:,i1) + scale*(geo(:,natoms) - geo(:,i1))
  nat(natoms) = 1
  txtatm(natoms) = " "
  return
end subroutine add_sp_H
subroutine add_sp2_H(i1, i, i2)
!
! Given three atoms, i1, i, and i2, put a hydrogen atom at the point
! of a triangle
!
  use molkst_C, only: natoms, maxatoms
  use common_arrays_C, only : geo, nat, txtatm
  use chanel_C, only: iw
  implicit none
  integer :: i1, i, i2
  logical :: first = .true.
  double precision :: scale
  natoms = natoms + 1
  if (natoms > maxatoms) then
    if (first) then
      write(iw,*)" Too many changes. Re-run using the data set generated by this job"
      first = .false.
    end if
    natoms = natoms - 1
    return
  end if
  geo(:,natoms) = 3.d0*geo(:,i) - geo(:,i1) - geo(:,i2)
  scale = 1.1d0/sqrt( (geo(1,i) - geo(1,natoms))**2 + &
                      (geo(2,i) - geo(2,natoms))**2 + &
                      (geo(3,i) - geo(3,natoms))**2 )
  geo(:,natoms) = geo(:,i) + scale*(geo(:,natoms) - geo(:,i))
  nat(natoms) = 1
  txtatm(natoms) = " "
end subroutine add_sp2_H
subroutine add_sp3_H(i1, i, i2, i3)
!
! Given four atoms, i1, i, and i2, put a hydrogen atom at the point
! of a tetrahedron
!
  use molkst_C, only: natoms, maxatoms
  use common_arrays_C, only : geo, nat, txtatm
  use chanel_C, only: iw
  implicit none
  integer :: i1, i, i2, i3
  logical :: first = .true.
  double precision :: scale
  natoms = natoms + 1
  if (natoms > maxatoms) then
    if (first) then
      write(iw,*)" Too many changes. Re-run using the data set generated by this job"
      first = .false.
    end if
    natoms = natoms - 1
    return
  end if
  geo(:,natoms) = 4.d0*geo(:,i) - geo(:,i1) - geo(:,i2) - geo(:,i3)
  scale = 1.1d0/sqrt( (geo(1,i) - geo(1,natoms))**2 + &
                      (geo(2,i) - geo(2,natoms))**2 + &
                      (geo(3,i) - geo(3,natoms))**2 )
  geo(:,natoms) = geo(:,i) + scale*(geo(:,natoms) - geo(:,i))
  nat(natoms) = 1
  txtatm(natoms) = " "
end subroutine add_sp3_H

subroutine compare_sequence(n_new)
!
!  Compare calculated residue with residue name from data-set
!  and print any differences
!
  use common_arrays_C, only : txtatm, txtatm1, nat, chains, breaks
  use molkst_C, only: numat, line, maxtxt, keywrd
  use MOZYME_C, only : tyr, tyres
  use chanel_C, only: iw, log, ilog
  implicit none
  integer :: n_new
!
! Local
!
  integer :: i_atom, i, j, i_delta = 0, new_res, old_res, previous = -200, &
    mbreaks, loop
  character :: old*3, new*3
  double precision, external :: reada
  logical :: first = .true.
  character :: num
  first = .true.
  mbreaks = 1
  i_atom = 0
  do loop = 1, numat
!
!  Find first non-hydrogen atom
!
    do
      i_atom = i_atom + 1
      if (i_atom > numat) exit
       if (i_atom == breaks(mbreaks)) mbreaks = mbreaks + 1
      if (nat(i_atom) /= 1) exit
    end do
    if (i_atom > numat) exit
    new_res = nint(reada(txtatm(i_atom),23))
    new = txtatm (i_atom)(18:20)
    if (maxtxt == 14) then
      old_res = nint(reada(txtatm1(i_atom),12))
      old = txtatm1(i_atom)(8:10)
    else
      old_res = nint(reada(txtatm1(i_atom),23))
      old = txtatm1(i_atom)(18:20)
    end if
    if (new_res - i_delta /= old_res) then
      i_delta = new_res - old_res
    end if
    if (new_res /= previous) then
      if (old /= new .and. index(keywrd, "CHANGED ALREADY PRINTED") == 0) then
        if (old /= "HET" .or. new /= "HOH") then
          if (first) then
            write(iw,'(/16x,a)')"Residue names that have changed"
            write(iw,'(7x,a,/)')"Original residue name   Calculated residue name"
            if (log) then
              write(ilog,'(/16x,a)')"Residue names that have changed"
              write(ilog,'(7x,a,/)')"Original residue name   Calculated residue name"
            end if
            first = .false.
            line="XENO=("
          end if
          do i = 1, 20
            if (old == tyres(i)) exit
          end do
          num = tyr(i)
          if (i == 21) num = " "
          write(iw,'(i14,a, 2x,a3,3x, 11x,i5,a,2x,a3)')old_res, " "//chains(mbreaks), old, &
            new_res, " "//chains(mbreaks), new
          if (log) write(ilog,'(i14,a, 2x,a3,3x, a1, 11x,i5,a,2x,a3)')old_res, " "//chains(mbreaks), &
            old, num, new_res, " "//chains(mbreaks), new
          if (i < 21) then
            j = len_trim(line) + 1
            if (j > 200) exit
            if (old_res > -1) then
              num = char(ichar("1") + int(log10(old_res + 0.05)))
              write(line(j:),'(a1,i'//num//',a1,a1,a1)')chains(mbreaks), old_res, "=", tyr(i),","
            else
              num = char(ichar("1") + int(log10(-old_res + 0.05)) + 1)
              write(line(j:),'(a1,i'//num//',a1,a1,a1)')chains(mbreaks), old_res, "=", tyr(i),","
            end if
          end if
        end if
      end if
      previous = new_res
    end if
  end do
  call l_control("CHANGED ALREADY PRINTED", len("CHANGED ALREADY PRINTED"), 1)
  if (first .and. n_new == 0) then
  else
    j = len_trim(line)
    if (j > 6 .and. n_new == 0) then
      line(j:j) = ")"
      write(line,'(a)')"(Use the XENO keyword to re-define unrecognized residues.)"
      write(iw,'(/2x,a)')trim(line)
      if (log) write(ilog,'(/a)')trim(line)
    end if
  end if
  return
end subroutine compare_sequence
  subroutine find_salt_bridges(in_cat, in_ani, n_cat, n_ani)
!
!  Find Salt Bridges:  Identify all ionizable sites that can be used for making salt bridges
!
    use common_arrays_C, only : nat, txtatm, nbonds, ibonds
    use molkst_C, only : numat, line, keywrd, moperr, maxtxt
    use chanel_C, only: iw
    use MOZYME_C, only : tyres
    use atomradii_C, only: is_metal
    implicit none
    integer, intent(in) :: n_cat, n_ani, in_cat(n_cat), in_ani(n_ani)
    integer :: i, j, k, kk, l, m, n, n_cations, n_anions, n_C, n_H, n_O, C, pairs(2,200), n_pairs, &
      salt_bridges(2,200), n_salt, i_length, ii, jj, nh_cat, nh_ani, nmetals
    double precision :: r, cutoff, Rab(200), R_min, R_sorted(200)
    character :: bits*10, num
    logical :: het
    double precision, external :: distance, reada
    logical, external :: near_a_metal
    integer, allocatable :: cations(:), anions(:), metals(:)
    allocate (cations(numat), anions(numat), metals(numat))
    het = .false.
    C = 0
    ii = 0
    jj = 0
    nmetals = 0
     do i = 1, numat
      do j = 1, 102
        if (is_metal(nat(i))) exit
      end do
      if (j < 103) then
        nmetals = nmetals + 1
        metals(nmetals) = i
      end if
    end do
    if (n_cat == 0) then
      i = index(keywrd,"SALT=")
      if (i /= 0) then
        cutoff = reada(keywrd, i + 4)
      else
        cutoff = 4.d0
      end if
      nh_cat = 0
      nh_ani = 0
    else
      cutoff = 8.d0
      nh_cat = 1
      nh_ani = -1
    end if
!
!  Locate all Arg guanidine "C" atoms and all -C(R)H-NH2 "N" atoms
!
    n_cations = 0
    do i = 1, numat
      if (nat(i) == 6) then
        if (nbonds(i) == 3) then
          if (nat(ibonds(1,i)) == 7 .and. nat(ibonds(2,i)) == 7 .and. nat(ibonds(3,i)) == 7) then
!
!  Make sure it has the correct charge
!
            m = 0
            do j = 1, 3
              m = m + nbonds(ibonds(j,i))
            end do
            if (m == 8 + nh_cat) then
              if (n_cat > 0) then
                do n = 1, n_cat
                  if (txtatm(in_cat(n))(18:maxtxt) == txtatm(i)(18:maxtxt)) then
                    exit
                  end if
                end do
              else
                n = 0
              end if
              if (n <= n_cat .and. txtatm(i)(18:20) /= "UNK" &
                .and. txtatm(i)(22:22) >= "A" .and. txtatm(i)(22:22) <= "Z") then
                n_cations = n_cations + 1
                cations(n_cations) = i
              end if
            end if
          end if
        end if
      end if
    end do
    do i = 1, numat
      if (nat(i) == 7) then
        if (nbonds(i) == 3 + nh_cat) then
!
!  Test for -NH2, e.g. N-terminus and lysine
!
          n_C = 0
          n_H = 0
          do j = 1, 3 + nh_cat
            if (nat(ibonds(j,i)) == 6  .and. txtatm(ibonds(j,i))(18:20) /= "UNK" &
                .and. txtatm(ibonds(j,i))(22:22) >= "A" .and. txtatm(ibonds(j,i))(22:22) <= "Z") then
              n_C = n_C + 1
              C = ibonds(j,i)
            end if
            if (nat(ibonds(j,i)) == 1) n_H = n_H + 1
          end do
!
!  Make sure it has the correct charge
!
          if (n_C == 1 .and. n_H == 2 + nh_cat) then
            do j = 1, nbonds(C)
              if (nat(ibonds(j,C)) == 8) exit
              if (nat(ibonds(j,C)) == 7 .and. ibonds(j,C) /= i) exit
            end do
            if (j <= nbonds(C) .and. nbonds(C) == 3) then
!
!  See if it's a -CO-NH3
!
               j = 1
               do k = 1, nbonds(i)
                 if (nat(ibonds(k,i)) == 1) j = j + 1
               end do
            end if
            if (j > nbonds(C)) then
              if (n_cat > 0) then
                do n = 1, n_cat
                  if (txtatm(in_cat(n))(18:maxtxt) == txtatm(i)(18:maxtxt)) then
                    exit
                  end if
                end do
              else
                n = 0
              end if
              if (n <= n_cat .and. txtatm(C)(18:20) /= "UNK" &
                .and. txtatm(C)(22:22) >= "A" .and. txtatm(C)(22:22) <= "Z") then
                n_cations = n_cations + 1
                cations(n_cations) = C
              end if
            end if
          end if
        else if (nbonds(i) == 2 + nh_cat .and. txtatm(i)(18:20) == "HIS") then
!
!  Check for Histidine
!
          do j = 1, nbonds(i)
            k = ibonds(j,i)
            if (nbonds(k) < 3) cycle
            do l = 1, nbonds(k)
              if (nat(ibonds(l,k)) == 7 .and. ibonds(l,k) /= i) exit
            end do
            if (l <= nbonds(k)) exit
          end do
          if (j > nbonds(i)) cycle
          if (n_cat > 0) then
            do n = 1, n_cat
              if (txtatm(in_cat(n))(18:maxtxt) == txtatm(i)(18:maxtxt)) then
                exit
              end if
            end do
          else
            n = 0
          end if
!
!  Avoid a "double count"
!
          do k = 1, n_cations
            if (txtatm(cations(k))(18:maxtxt) == txtatm(ibonds(j,i))(18:maxtxt)) exit
          end do
          if (n <= n_cat .and. k > n_cations) then
            if ( .not. near_a_metal(i, i, metals, nmetals)) then
              n_cations = n_cations + 1
              cations(n_cations) = ibonds(j,i)
            end if
          end if
        end if
      end if
    end do
!
!  Locate all -COOH "C" atoms
!
    n_anions = 0
    do i = 1, numat
      if (nat(i) == 6) then
      if (nbonds(i) == 3) then
        n_C = 0
        n_O = 0
        do j = 1,3
          if (nat(ibonds(j,i)) == 6) n_C = n_C + 1
          if (nat(ibonds(j,i)) == 8) n_O = n_O + 1
        end do
        if (n_C == 1 .and. n_O == 2) then
          m = 0
          ii = 0
          do j = 1, 3
            if (nat(ibonds(j,i)) == 8) then
              l = ibonds(j,i)
              ii = ii + nbonds(l)
              do k = 1, nbonds(l)
                if (nat(ibonds(k,l)) == 1) m = m + 1
              end do
            end if
          end do
          if (m == 1 + nh_ani .and. ii < 4) then
            if (n_ani > 0) then
              do n = 1, n_ani
                if (txtatm(in_ani(n))(18:maxtxt) == txtatm(i)(18:maxtxt)) then
                  exit
                end if
              end do
            else
              n = 0
            end if
            if (n <= n_ani .and. txtatm(i)(18:20) /= "UNK" &
                .and. txtatm(i)(22:22) >= "A" .and. txtatm(i)(22:22) <= "Z") then
                n_anions = n_anions + 1
                anions(n_anions) = i
              end if
            end if
          end if
        end if
      end if
    end do
!
!  Find interatomic distances and weight them by type
!
    n_pairs = 0
    do i = 1, n_cations
      do j = 1, n_anions
        r = distance(cations(i), anions(j))
        if (r < cutoff + 2.d0) then
          m = cations(i)
          n = anions(j)
          R_min = 100.d0
          do k = 1, nbonds(m)
            if (nat(ibonds(k,m)) /= 7) cycle
            do l = 1, nbonds(n)
              if (nat(ibonds(l,n)) /= 8) cycle
              r = distance(ibonds(k,m), ibonds(l,n))
              if (r < R_min) then
                R_min = r
                ii = ibonds(k,m)
                jj = ibonds(l,n)
!
!  Check that hetero-groups are excluded, i.e., by default, do not form salt-bridges between the protein and any substrate molecules.
!  This is because substrates might have multiple -COO groups.
!
                do kk = 1, 20
                  if (txtatm(ii)(18:20) == tyres(kk)) exit
                end do
                het = (kk > 20)
                if (.not. het) then
                  do kk = 1, 20
                    if (txtatm(jj)(18:20) == tyres(kk)) exit
                  end do
                  het = (kk > 20)
                end if
              end if
            end do
          end do
          if (R_min < cutoff .and. .not. het) then
            n_pairs = n_pairs + 1
            pairs(1,n_pairs) = ii
            pairs(2,n_pairs) = jj
            Rab(n_pairs) = R_min
          end if
        end if
      end do
    end do
!
!  Sort interatomic distances
!
    n_salt = 0
    do
      if (n_pairs == 0) exit
      r = 1.d10
      do i = 1, n_pairs
        if (r > Rab(i)) then
          r = Rab(i)
          j = i
        end if
      end do
      if (r > 40.d0) exit
      n_salt = n_salt + 1
      salt_bridges(:, n_salt) = pairs(:, j)
      R_sorted(n_salt) = r
      n_pairs = n_pairs - 1
      do k = j, n_pairs
        Rab(k) = Rab(k + 1)
        pairs(:, k) = pairs(:, k + 1)
      end do
    end do
    if (n_cat == 0) then
!
!  Eliminate duplicates
!
      do i = 1, n_salt
        if (salt_bridges(1,i) == 0) cycle
        do j = n_salt, i + 1, -1
          if (salt_bridges(1,j) == 0) cycle
          m = salt_bridges(1,i)
          n = salt_bridges(2,i)
          ii = salt_bridges(1,j)
          jj = salt_bridges(2,j)
          if (salt_bridges(1,j) == salt_bridges(1,i) .or. salt_bridges(2,j) == salt_bridges(2,i)) then
            salt_bridges(:,j) = 0
          else if (txtatm(m)(18:) == txtatm(jj)(18:)) then
            salt_bridges(:,j) = 0
          else
            do ii = 1,2
              m = salt_bridges(ii,i)
              n = salt_bridges(ii,j)
              do k = 1, nbonds(m)
                if (nat(ibonds(k,m)) /= 6) cycle
                do l = 1, nbonds(n)
                  if (nat(ibonds(l,n)) /= 6) cycle
                  if (ibonds(k,m) == ibonds(l,n))  salt_bridges(:,j) = 0
                end do
              end do
              if (salt_bridges(1,j) == 0) exit
            end do
          end if
        end do
      end do
    end if
!
!  Build new SITE keyword
!
    if (n_salt > 0) then
      num = char(ichar("4") + int(log10(cutoff + 0.04999d0)))
      write(iw,'(//19x, a, f'//num//'.1, a)')"Salt Bridges Found (Up to", cutoff," Angstroms)"
      write(iw,'(/4x,a,10x,a,28x,a,16x,a,/)')" No.","Cationic site","Anionic site","Dist. (Angstroms)"
     if (n_cat == 0) call update_txtatm(.true., .true.)
    else
       if (n_cat == 0) then
         call mopend("SALT option used in SITE command, but no Salt Bridges found")
         moperr = .false.
         return
       else
         write(iw,'(//19x,a)')"No Salt Bridges Found"
       end if
    end if
    line = " "
    j = 0
    do i = 1, n_salt
      if (salt_bridges(1,i) == 0) cycle
      k = salt_bridges(1,i)
      do m = 26, 23, -1
        if (txtatm(k)(m:m) == " ") exit
      end do
      m = max(23,m + 1)
      l = salt_bridges(2,i)
      do n = 26, 23, -1
        if (txtatm(l)(n:n) == " ") exit
      end do
      n = max(23,n + 1)
      i_length = len_trim(line)
      if (i_length > 1900 - len_trim(keywrd)) then
        call mopend("TOO MANY SALT BRIDGES FOUND")
        call mopend("(TO ADD MORE SALT BRIDGES, USE THE ""ARC"" OR ""PDB"" FILE FROM THIS JOB)")
        moperr = .false.
        exit
      end if
      write(line(i_length + 1:),'(2a)')","//txtatm(k)(22:22)//txtatm(k)(m:maxtxt)//"(+),", &
                                        txtatm(l)(22:22)//txtatm(l)(n:maxtxt)//"(-)"
      j = j + 1
      write(iw,'(i7,2x,a,a9,4x,a,a9, f10.2)') &
      j, "("//txtatm(k)(:maxtxt)//")", txtatm(k)(22:22)//txtatm(k)(m:maxtxt)//"(+)", &
      "("//txtatm(l)(:maxtxt)//")", txtatm(l)(22:22)//txtatm(l)(n:maxtxt)//"(-)", R_sorted(i)
      if (txtatm(k)(22:22) < "A" .or. txtatm(k)(22:22) > "Z") then
        write(line,'(a)')"Chain letter for the cation is not in the range 'A' to 'Z'"
        call mopend(trim(line))
        write(iw,'(10x,a)')"Chain letter = """//txtatm(k)(22:22)//""""
        return
      end if
      if (txtatm(l)(22:22) < "A" .or. txtatm(l)(22:22) > "Z") then
        write(line,'(a)')"Chain letter for the anion is not in the range 'A' to 'Z'"
        call mopend(trim(line))
        write(iw,'(10x,a)')"Chain letter = """//txtatm(l)(22:22)//""""
        return
      end if
    end do
    if (n_cat > 0) return
    line = line(2:)
!
!  Delete the word "SALT"
!
    k = index(keywrd, "(SALT") + index(keywrd, ",SALT") + 1
    i = index(keywrd,"(SALT=") + index(keywrd, ",SALT=")
    if (i > 0) then
      do j = i, len_trim(keywrd)
        if (keywrd(j:j) == "," .or. keywrd(j:j) == ")") exit
      end do
      if (keywrd(j:j) == ",") j = j + 1
      keywrd(i + 1:) = keywrd(j:)
      if (keywrd(i:i) == ",") keywrd(i:) = trim(keywrd(i + 1:))
    else
      i = index(keywrd, "(SALT") + index(keywrd, ",SALT") + 1
      keywrd(i:) = keywrd(i + 4:)
      if (keywrd(i:i) == ",") keywrd(i:) = trim(keywrd(i + 1:))
    end if
!
!   Check for duplicate sites in keywrd
!
    m = index(keywrd," SITE")
    m = index(keywrd(m:), "(") + m
    j = index(keywrd(m:),") ") + m
    if (keywrd(m:m) == ",") m = m + 1
    do
      k = index(keywrd(m:j), ",")
      if (k == 0) k = index(keywrd(m:j + 1), ") ")
      if (k == 0) exit
      k = k + m - 2
      bits = keywrd(m:k)
      if (k - m < 3) exit
      l = index(line, trim(bits))
      if (l > 0) then
!
!  Remove the comma
!
        if (line(l - 1:l - 1) == ",") then
          line = line(:l - 2)//line(l + k - m + 1:)
        else
          line = line(:l - 1)//line(l + k - m:)
        end if
      end if
      m = k + 2
      if (keywrd(m:m) == ",") m = m + 1
    end do
!
!  Insert the new keyword
!
    i = index(keywrd," SITE")
    if (keywrd(i + 7:i + 7) /= ")") then
!
! Keyword is NOT SITE=(SALT)
! it is either SITE=(text,SALT,text), SITE=(SALT,text), or SITE=(text,SALT),
! whichever it is, add a comma
!
      keywrd(i + 7:) = trim(line)//","//trim(keywrd(i + 7:))
    else
      keywrd(i + 7:) = trim(line)//trim(keywrd(i + 7:))
    end if
    return
  end subroutine find_salt_bridges
subroutine update_txtatm(output, sort)
!
!  If "output" is true. and keyword RESIDUES is not present, then use input text in TXTATM1
!
!  if "sort" is true, then use the geometry in coorda to work out which atom is which.
!
  use common_arrays_C, only : nat, txtatm, txtatm1, coorda, nbonds, ibonds, coord, &
    breaks
  USE molkst_C, ONLY: numat, numat_old, keywrd, pdb_label, line
  use MOZYME_C, only: tyres
  implicit none
  logical :: output, sort, pdb, update_chain
!
! Local
!
  logical :: L_all
  integer :: i, j, k, l, H_Z
  integer, allocatable :: n_H(:), nn_H(:)
  if (.not. pdb_label) return
!
!   Do the hydrogen atom labels need to be re-done?
!  "Yes," if atoms are added or removed or shuffled.
!
  if (index(keywrd," RESID") + index(keywrd," ADD-H") + &
    index(keywrd," SITE=") + index(keywrd," RESEQ") /= 0 .or. output) then
    H_Z = 1
  else
    H_Z = 0
  end if
  pdb = (index(keywrd, " PDBOUT") /= 0)
  L_all = (output .and. index(keywrd," RESID") == 0)
  if (L_all .and. .not. sort .and. numat == numat_old) then
!
!  Do nothing!
!
    do i = 1, numat
      if (txtatm1(i) == " ") then
        txtatm1(i) = txtatm(i)
      else
        txtatm(i) = txtatm1(i)
      end if
    end do
    goto 99
  end if
!
!  Add text to TXTATM to label hydrogen atoms and to add chain letter
!
  if (index(keywrd," ADD-H") + index(keywrd," SITE=") + index(keywrd," RESEQ") /= 0) &
    call set_up_dentate()
  if (index(keywrd, "0SCF") == 0 .and. index(keywrd, "SITE") == 0) call check_cvs(.true.)
  call check_H(i)
  update_chain = (index(keywrd, " CHAINS=(") == 0)
  do i = 1, numat
    if (sort) then
      if (nat(i) > H_Z) then
        if (L_all .or. update_chain) then
          do j = 1, numat_old
            if (abs(coord(1,i) - coorda(1,j)) > 0.01d0) cycle
            if (abs(coord(2,i) - coorda(2,j)) > 0.01d0) cycle
            if (abs(coord(3,i) - coorda(3,j)) > 0.01d0) cycle
            if (L_all) then
              if (txtatm1(j) /= " ") txtatm(i) = txtatm1(j)
            else
              if (txtatm1(j)(22:22) /= " ") txtatm(i)(22:22) = txtatm1(j)(22:22)
            end if
            exit
          end do
        end if
      else
        if (nbonds(i) > 0) txtatm(i) = txtatm(ibonds(1,i))
      end if
    else
      if (L_all) then
        if (nat(i) > 1) then
          if (txtatm1(i) /= " ") txtatm(i) = txtatm1(i)
        else if (nbonds(i) > 0) then
          txtatm(i) = txtatm(ibonds(1,i))
        end if
      else
        if (update_chain .and. txtatm1(i)(22:22) /= " ") txtatm(i)(22:22) = txtatm1(i)(22:22)
      end if
    end if
  end do
  99 continue
!
!  Number hydrogen atoms, if more than one on a heavy atom
!
  allocate(n_H(numat), nn_H(numat))
  n_H = 0
  nn_H = 0
  do i = 1, numat
    if (nat(i) > H_Z) then
      j = 0
      do k = 1, nbonds(i)
        if (nat(ibonds(k,i)) == 1) j = j + 1
      end do
      n_H(i) = j
    end if
  end do
  do i = 1, numat
    if (nat(i) <= H_Z .and. nbonds(i) > 0) then
      k = ibonds(1,i)
      txtatm(i) = txtatm(k)(:12)//" H"//txtatm(k)(15:)
!
!  If a hydrogen atom is attached to an unlabeled carbon atom, make the hydrogen atom a terminal hydrogen
!
      if (nat(k) == 6 .and. txtatm(i)(15:16) == " ") then
        do j = 1, 20
          if (txtatm(i)(18:20) == tyres(j)) exit
        end do
        if (j < 21) txtatm(i)(15:16) = "XT"
      end if
      if (n_H(k) == 1) then
        txtatm(i)(13:14) = " H"
      else
        nn_H(k) = nn_H(k) + 1
        txtatm(i)(13:14) = char(nn_H(k) + ichar("0"))//"H"
      end if
    end if
    if (numat == numat_old) then
      if (txtatm1(i) == " ") txtatm1(i) = txtatm(i)
    end if
  end do
!
!  Check for duplicate hydrogen atom labels
!
  do i = 1, numat
    if (nat(i) == 1) then
      l = 1
      do j = i + 1, numat
        if (nat(j) == 1) then
          if (txtatm(i)(13:) == txtatm(j)(13:)) then
            do k = 13, 16
              if (txtatm(j)(k:k) == " ") then
                l = l + 1
                txtatm(j)(k:k) = char(l + ichar("0"))
                if (numat == numat_old) then
                  if (txtatm1(j) == " ") txtatm1(j) = txtatm(j)
                end if
                exit
              end if
            end do
          end if
        end if
        if (l == 9) exit
      end do
      if (l > 1) then
        do k = 13, 16
            if (txtatm(i)(k:k) == " ") then
              txtatm(i)(k:k) = "1"
              if (numat == numat_old) then
                if (txtatm1(i) == " ") txtatm1(i) = txtatm(i)
              end if
              exit
            end if
        end do
      end if
    end if
  end do

!
!  Add atom numbering, using PDB format, i.e., a TER group has its own number
!  (TER groups are represented by BREAKS)
!
  j = 1
  do i = 1, numat
    write(line,'(a6,i5,a)')txtatm(i)(:6),i + j - 1,txtatm(i)(12:)
    txtatm(i) = trim(line)
    if (PDB .and. i == breaks(j)) j = j + 1
  end do
  return
  end subroutine update_txtatm

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine getocc(aoc, boc, ao1, bo1, io, iv, nio)
      use reimers_C, only : nov, ncore
      implicit none
      logical*1 ::     aoc(nov), boc(nov), &
                      ao1(nov), bo1(nov)
      integer ::       io(4), iv(4), nio
      integer ::      i, j, niv

!***********************************************************************
!   RMG - get the occupied/virtual orbitals involved in a configuration
!   aoc, boc = occupations of excited configuration
!   ao1, bo1 = occupations of ground configuration
!   io, iv = lists of occupied/virtural orbitals
!   nio     = number of excitations in the configuration
!***********************************************************************
      do i = 1, 4
        io(i) = 0
        iv(i) = 0
      end do

      nio = 0
      niv = 0

!      write (6, *) aoc, boc
!      write (6, *) ao1, bo1

!     **** loop over orbitals, check diffs from first ref det ****
      do j = 1, nov
        if (ao1(j) .neqv. aoc(j)) then
!         **** alpha differs from first ref det ****
          if (ao1(j)) then
            nio = nio + 1
            io(nio) = j + ncore
          else
            niv = niv + 1
            iv(niv) = j + ncore
          end if
        end if

        if (bo1(j) .neqv. boc(j)) then
!         **** beta differs from first ref det ****
          if (bo1(j)) then
            nio = nio + 1
            io(nio) = j + ncore
          else
            niv = niv + 1
            iv(niv) = j + ncore
          end if
        end if
      end do
      if (nio /= niv) write (6, *) 'Error: Different number of occ ', &
         'and vir orbitals found', nio, niv, io, iv
      return
      end subroutine getocc

      subroutine diagci(cimat, aocc, bocc, diagsl)
      use molkst_C, only : mpack
      use reimers_C, only : nconf, nov, nex, matind, mspn, &
                           aor1, bor1

      implicit none
      double precision :: cimat(*), deltap(mpack), &
                      diagsl(nconf)
      logical*1 :: aocc(nov, mspn, nex), bocc(nov, mspn, nex)
      integer :: iconf, io(4), iv(4), nm, nio
      double precision :: ener
!***********************************************************************
!   RMG - compute the correction to the diagonal terms of the CI matrix
!   due to solvation, as in Klamt, J. Phys. Chem. 1996, 100, 3349.
!
!   For each excitation, compute the density change, then compute the
!   correction to the diagonal energy term. Correct the CI matrix, but
!   save all corrections in dcie for later use in unsolv.
!***********************************************************************
      diagsl(1) = 0.d0
      do iconf = 2, nconf
        call getocc(aocc(1:nov, 1, iconf), bocc(1:nov, 1, iconf), &
                    aor1(1:nov), bor1(1:nov), io, iv, nio)
! Compute the density change
        call exdeltap(io, iv, nio, deltap)

! Compute the energy change
        call solenr(deltap, ener)
        diagsl(iconf) = ener
        nm = matind(iconf) + iconf
        cimat(nm) = cimat(nm) + ener
      end do

      return
      end subroutine diagci

      subroutine corrci(cimat, cist, aocc, bocc, diagsl, eval)
      use molkst_C, only : mpack, keywrd
      use reimers_C, only : nconf, nov, nex, mspn
      USE chanel_C, only : iw
      implicit none
      double precision :: cimat(nconf*(nconf + 1)/2), deltap(mpack), &
                      diagsl(nconf), eval(nconf), cist(nconf, nconf), &
!                      dpall(mpack, nconf), ucener(nconf), eorig(nconf)
                      ucener(nconf), eorig(nconf)
      logical*1 :: aocc(nov, mspn, nex), bocc(nov, mspn, nex)

      integer :: ist
      double precision :: ener
!***********************************************************************
!   RMG - compute the correction to the final CI states. First compute
!   the energies without the diagonal corrections. Then compute the
!   state densities and updated energy corrections for the proper
!   densities.
!***********************************************************************

      do ist = 1, nconf
        eorig(ist) = eval(ist)
      end do

! Compute uncorrected state energies if necessary
      if (index(keywrd, ' KL2') == 0) then
        call unsolv(cimat, cist, diagsl, ucener)
      else
        ucener = eorig
      end if

! For each state, compute the proper energetic correction
      do ist = 1, nconf
        call stdeltap(cist, aocc, bocc, deltap, ist)
        call solenr(deltap, ener)
        eval(ist) = ucener(ist) + ener
      end do

!      write (6, *) 'Energy corrections'
      write (iw, *) ''
      write (iw, *) 'COSMO corrections to state energies'
      write (iw, *) 'State    Diag E (eV)   Uncorr E (eV)   Final E (eV)'
      do ist = 1, nconf
        !write (6, '(i6, 3f15.5)') ist, eorig(ist), ucener(ist), eval(ist)
        write (iw, '(i6, 3f15.5)') ist, eorig(ist), ucener(ist), eval(ist)
      end do

      return
      end subroutine corrci


      subroutine unsolv(cimat, cist, diagsl, ucener)
      use reimers_C, only : nconf, matind
      implicit none
      double precision :: cimat(nconf*(nconf + 1)/2), cist(nconf, nconf), &
                      diagsl(nconf), ucener(nconf)
      integer :: iconf, ist, nm, jconf
      double precision :: ener, etmp
!***********************************************************************
!   RMG - Compute the energies of the CI states without the diagonal
!   energy corrections. Un - correct the CI matrix, then multiply with the
!   earlier eigenvectors to get the new 'eigenvalues'.
!***********************************************************************
! Uncorrect the CI matrix
      do iconf = 1, nconf
        nm = matind(iconf) + iconf
        cimat(nm) = cimat(nm) - diagsl(iconf)
      end do
!
! Compute expectation values for the energies of the old eigenvectors
! with the new CI matrix to get uncorrected energies
      do ist = 1, nconf
        ener = 0.d0
        do iconf = 1, nconf
          etmp = 0.d0
          do jconf = 1, nconf
            nm = matind(max(iconf, jconf)) + min(iconf, jconf)
            etmp = etmp + cimat(nm)*cist(jconf, ist)
          end do
          ener = ener + cist(iconf, ist)*etmp
        end do
        ucener(ist) = ener
      end do

      return
      end subroutine unsolv


      subroutine stdeltap(cist, aocc, bocc, dpstat, ist)
      use molkst_c, only : mpack
      use reimers_C, only : nconf, nov, nex, &
          mspn, aor1, bor1
      implicit none
      double precision :: dpstat(mpack), cist(nconf, nconf), &
                      deltap(mpack)
      logical*1 :: aocc(nov, mspn, nex), bocc(nov, mspn, nex)
      integer :: iorb, ist, iconf
      integer :: io(4), iv(4), nio
      double precision :: prob(nconf)
!***********************************************************************
!   RMG - Compute the AO density for the full CI states. Loop over all
!   involved excitations to get the overall change in density.
!***********************************************************************

! Set up an empty matrix to hold all changes in density
      do iorb = 1, mpack
        dpstat(iorb) = 0.d0
      end do

! For each excitation, compute the change in density
      do iconf = 1, nconf
! Determine occupied & unoccupied orbitals in this configuration
        call getocc(aocc(1:nov, 1, iconf), bocc(1:nov, 1, iconf), &
                    aor1(1:nov), bor1(1:nov), io, iv, nio)
! Compute the density change
        call exdeltap(io, iv, nio, deltap)

! For each CI state, add the change in density with the appropriate
! coefficient
        prob(ist) = cist(iconf, ist)**2
        if (prob(ist) > 0.0001d0) then
          do iorb = 1, mpack
            dpstat(iorb) = dpstat(iorb) + prob(ist)*deltap(iorb)
          end do
        end if
      end do

      return
      end subroutine stdeltap


      subroutine exdeltap(io, iv, nio, deltap)
      use molkst_c, only : mpack
      use reimers_C, only : n, matind, cc0
      implicit none
      double precision  :: deltap(mpack)
      integer :: i, j, ia, occ, vir, &
                 io(4), iv(4), nio
!***********************************************************************
!   RMG - compute the change in density for a particular excitation.
!***********************************************************************
      do i = 1, mpack
        deltap(i) = 0.d0
      end do

      do j = 1, nio
        occ = io(j)
        vir = iv(j)
        do i = 1, n
          ia = matind(i) + i
          deltap(ia) = deltap(ia) + cc0(vir, i)**2 - cc0(occ, i)**2
        end do
      end do

      return
      end subroutine exdeltap


      subroutine solenr(deltap, dcie)
      use cosmo_C, only : amat, bmat, nden, gden, ipiden, nps, &
           nsetf, fnsq
      use molkst_c, only : mpack
      use funcon_C, only : a0, ev
      implicit none
      double precision  :: deltap(mpack), qsc(nps), phi(nps), qden(nden)
      integer :: i, j
      double precision :: dcie, fcon
!***********************************************************************
!   RMG - adapted from dmecip subroutine in MOPAC
!
!   Given the density deltap (change in AO occupation upon excitation),
!   computes the energetic stabilization due to electronic screening of
!   the density difference (dcie).
!
!   See Klamt, J. Phys. Chem. 1996, 100, 3349. Correction computed here
!   corresponds to the final term in Equation 10.
!***********************************************************************

      dcie = 0.d0
      fcon = a0 * ev

      do i = 1, nden
        qden(i) = gden(i) * deltap(ipiden(i))
      end do
      do i = 1, nps
        phi(i) = 0.d0
        do j = 1, nden
          phi(i) = phi(i) + bmat(j, i) * qden(j)
        end do
      end do

      call coscl2 (amat, nsetf, qsc, phi, nps)
      do i = 1, nps
        dcie = dcie + qsc(i) * phi(i)
      end do

      dcie = -dcie * fnsq * fcon / 2

      return
      end subroutine solenr

      subroutine staticsolv(ao, bo, ener)
      use cosmo_C, only : bmat, nden, gden, ipiden, nps, qscnet
      use molkst_c, only : mpack
      use funcon_C, only : a0, ev
      use reimers_C, only : n, nov, cc0, ncore

      implicit none
      double precision  :: p(mpack), phi(nps), qden(nden)
      logical*1 :: ao(nov), bo(nov)
      integer :: a, i, j, k, k0, kocc
      double precision :: ener, fcon
!***********************************************************************
!   RMG - Compute the interaction energy of an excited-state electron
!   density (p) with the ground-state surface charges (qdenet(2)).
!***********************************************************************
      ener = 0.d0
      fcon = a0 * ev

      do i = 1, mpack
        p(i) = 0.d0
      end do

      a = 0
      do i = 1, n
        do j = 1, i
           a = a + 1
           p(a) = p(a) + sum(cc0(1:ncore, i)*cc0(1:ncore, j)) * 2.d0
           do k = 1, nov
              k0 = k + ncore
              kocc = 0
              if (ao(k)) kocc = kocc + 1
              if (bo(k)) kocc = kocc + 1
              p(a) = p(a) + cc0(k0, i) * cc0(k0, j) * kocc

           end do
        end do
      end do

! Set up charge density for solvation
      do i = 1, nden
        qden(i) = gden(i) * p(ipiden(i))
      end do

! Compute electrostatic potential at each surface point
      do i = 1, nps
        phi(i) = 0.d0
        do j = 1, nden
          phi(i) = phi(i) + bmat(j, i) * qden(j)
        end do
      end do

! Calculate interaction energy of charge density with surface points
      do i = 1, nps
        ener = ener + qscnet(i, 2) * phi(i)
      end do
      ener = ener * fcon
      return
      end subroutine staticsolv

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine xyzcry(tvec, numat, dxyz, iw)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: numat
      integer , intent(in) :: iw
      double precision , intent(inout) :: tvec(3,3)
      double precision , intent(inout) :: dxyz(3,*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j
      double precision :: sum, ca, sa, sum1
!-----------------------------------------------
!
!   Convert Cartesian derivatives into fractional unit cell derivatives.
!
!      WRITE(IW,*)' Atoms 1 and 2'
!      WRITE(IW,'(3F12.6)')((DXYZ(I,J),I=1,3),J=1,2)
      sum = sqrt(tvec(2,1)**2+tvec(3,1)**2)
!      WRITE(IW,*)' TVEC'
!      WRITE(IW,'(3f12.4)')TVEC
      if (sum > 1.D-6) then
!
!    Rotate to eliminate TVEC(3,1)
!
        ca = tvec(2,1)/sum
        sa = tvec(3,1)/sum
        do i = 1, 3
          sum1 = tvec(2,i)*ca + tvec(3,i)*sa
          tvec(3,i) = (-tvec(2,i)*sa) + tvec(3,i)*ca
          tvec(2,i) = sum1
        end do
!      WRITE(IW,*)' TVEC'
!      WRITE(IW,'(3f12.4)')TVEC
        do i = 1, numat
          sum1 = dxyz(2,i)*ca + dxyz(3,i)*sa
          dxyz(3,i) = (-dxyz(2,i)*sa) + dxyz(3,i)*ca
          dxyz(2,i) = sum1
        end do
!
!    Rotate to eliminate TVEC(2,1)
!
        sum = sqrt(tvec(1,1)**2+tvec(2,1)**2)
        ca = tvec(1,1)/sum
        sa = tvec(2,1)/sum
        do i = 1, 3
          sum1 = tvec(1,i)*ca + tvec(2,i)*sa
          tvec(2,i) = (-tvec(1,i)*sa) + tvec(2,i)*ca
          tvec(1,i) = sum1
        end do
        do i = 1, numat
          sum1 = dxyz(1,i)*ca + dxyz(2,i)*sa
          dxyz(2,i) = (-dxyz(1,i)*sa) + dxyz(2,i)*ca
          dxyz(1,i) = sum1
        end do
!      WRITE(IW,*)' TVEC'
!      WRITE(IW,'(3f12.4)')TVEC
      end if
!
!    Rotate to eliminate TVEC(3,2)
!
      sum = sqrt(tvec(2,2)**2+tvec(3,2)**2)
      if (sum > 1.D-6) then
        ca = tvec(2,2)/sum
        sa = tvec(3,2)/sum
        do i = 2, 3
          sum1 = tvec(2,i)*ca + tvec(3,i)*sa
          tvec(3,i) = (-tvec(2,i)*sa) + tvec(3,i)*ca
          tvec(2,i) = sum1
        end do
!      WRITE(IW,*)' TVEC'
!      WRITE(IW,'(3f12.4)')TVEC
        do i = 1, numat
          sum1 = dxyz(2,i)*ca + dxyz(3,i)*sa
          dxyz(3,i) = (-dxyz(2,i)*sa) + dxyz(3,i)*ca
          dxyz(2,i) = sum1
        end do
      end if
!
!  Convert unit cell into it's reciprocal
!
      do i = 1, 3
        sum = 0.D0
        do j = 1, i
          sum = sum + tvec(j,i)**2
        end do
        tvec(:i,i) = tvec(:i,i)/sum
      end do
!      WRITE(IW,*)' TVEC'
!      WRITE(IW,'(3f12.4)')TVEC
!         WRITE(IW,'(A)')' Fractional Unit Cell Derivatives'
!         WRITE(IW,'(I4,3F12.5)')(I,(DXYZ(J,I),J=1,3),I=1,NUMAT)
      dxyz(3,:numat) = dxyz(3,:numat)/tvec(3,3)
      dxyz(2,:numat) = dxyz(2,:numat) - dxyz(3,:numat)*tvec(2,3)
      dxyz(1,:numat) = dxyz(1,:numat) - dxyz(3,:numat)*tvec(1,3)
      dxyz(2,:numat) = dxyz(2,:numat)/tvec(2,2)
      dxyz(1,:numat) = dxyz(1,:numat) - dxyz(2,:numat)*tvec(1,2)
      dxyz(1,:numat) = dxyz(1,:numat)/tvec(1,1)
      write (iw, '(A)') ' Fractional Unit Cell Derivatives'
      write (iw, '(I4,3F12.5)') (i,(dxyz(j,i),j=1,3),i=1,numat)
      return
      end subroutine xyzcry

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine refer
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE journal_references_C, only : allref
      use chanel_C, only : iw
      use common_arrays_C, only : nat
      use molkst_C, only : numat, keywrd, keywrd_quoted, is_PARAM, method_rm1, &
      method_mndo, method_am1, method_pm3, method_pm6, method_mndod, &
      method_pm7, sparkle, method_pm6_org, method_pm8, method_indo
      use parameters_C, only : gss
      use parameters_for_PM6_Sparkles_C, only : gss6sp
      use parameters_for_AM1_Sparkles_C, only : gssam1sp
      use parameters_for_PM3_Sparkles_C, only : gssPM3sp
      use reimers_C, only : isok
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, mode
      logical :: allok
      logical , dimension(107) :: elemns
      logical :: mixok, mix, exter

      save mix
!-----------------------------------------------
      data mix/ .FALSE./
      elemns(:102) = .FALSE.
      elemns(nat(:numat)) = .TRUE.
      if (method_indo) then
        allok = .true.
        do i = 1,numat
          if (isok(nat(i)) == 0) allok = .false.
        end do
        if (.not. allok) then
          write (iw, 40) 'SOME ELEMENTS HAVE BEEN SPECIFIED FOR WHICH', &
            'NO PARAMETERS ARE AVAILABLE.  CALCULATION STOPPED.'
          call mopend("Parameters for some elements are missing")
        end if
        return
      end if
      if (method_pm6) then
        allok = .true.
        if (sparkle) then !  Check for Lanthanides
          write(iw,*)
          write (iw, '(/,a)') " References for PM6:"
          do i = 57, 71
            if (elemns(i)) then
              write (iw, '(A)') allref(i,2)(:len_trim(allref(58,2)))
            end if
          end do
        else
          do i = 58, 70
            if (elemns(i)) then
              write (iw, '(A,I3)') ' DATA ARE NOT AVAILABLE FOR ELEMENT NO.', i
              if (Abs(gss6sp(i))   > 0.1d0) write(iw,*)" (Parameters are available if PM6 SPARKLE is used)"
              allok = .FALSE.
            end if
          end do
        end if
        write (iw, '(/,a)') " General Reference for PM6:"
        write (iw, '(1x,a)') &
          &  """Optimization of Parameters for Semiempirical Methods V: Modification of NDDO Approximations", &
          &  "and Application to 70 Elements"", J. J. P. Stewart, J. Mol. Mod., 13, 1173-1213 (2007)", &
          &  "URL: https://link.springer.com/article/10.1007/s00894-007-0233-4"
        if (index(keywrd," PM6-DH+") /= 0) then
          write (iw, '(/,a)') " Reference for PM6-DH+:"
          write(iw,'(1x,a)') &
            & """Third-Generation Hydrogen-Bonding Corrections for Semiempirical QM Methods and Force Fields""", &
            & "Martin Korth, J. Chem. Theory Comput., 6 (12), pp 3808-3816 (2010)", &
            & "URL: http://pubs.acs.org/doi/abs/10.1021/ct100408b"
        end if
        if (allok .or. is_PARAM) return
        write (iw, 40) 'SOME ELEMENTS HAVE BEEN SPECIFIED FOR WHICH', &
          'NO PARAMETERS ARE AVAILABLE.  CALCULATION STOPPED.'
        call mopend("Parameters for some elements are missing")
        return
      end if
      if (method_pm7) then
        allok = .true.
        if (sparkle) then !  Check for Lanthanides
          write(iw,*)
          write (iw, '(/,a)') " References for PM7 Sparkles:"
          do i = 57, 71
            if (elemns(i)) then
              write (iw, '(A)') " ""Sparkle/PM7 Lanthanide Parameters for the Modeling of Complexes and Materials""", &
                & " J. D. L. Dutra, M. A. M. Filho1, R. O. Freire, G. B. Rocha, A. M. Simas, and J. J. P. Stewart", &
                & " Chemistry of Materials (submitted)"
              exit
            end if
          end do
        else
          do i = 58, 70
            if (elemns(i)) then
              write (iw, '(A,I3)') ' DATA ARE NOT AVAILABLE FOR ELEMENT NO.', i
              if (Abs(gss6sp(i))   > 0.1d0) write(iw,*)" (Parameters are available if SPARKLE is used)"
              allok = .FALSE.
            end if
          end do
        end if
        write (iw, '(/,a)') " General Reference for PM7:"
        write (iw, '(1x,a)') &
          &  """Optimization of Parameters for Semiempirical Methods VI: More Modifications to the ", &
          & "NDDO Approximations and Re-optimization of Parameters"", J. J. P. Stewart, J. Mol. Mod., 1:32, 19 (2013)", &
          & "https://link.springer.com/article/10.1007/s00894-012-1667-x"
        if (allok .or. is_PARAM) return
        write (iw, 40) 'SOME ELEMENTS HAVE BEEN SPECIFIED FOR WHICH', &
          'NO PARAMETERS ARE AVAILABLE.  CALCULATION STOPPED.'
        call mopend("Parameters for some elements are missing")
        return
      end if
      if (method_pm6_org) then
        allok = .true.
        do i = 1, 102 
          if (.not.elemns(i)) cycle
          select case(i)
            case (1, 6, 7, 8, 9, 11, 12, 15, 16, 17, 19, 20, 26, 27, 29, 30, 34, 35, 53)
              continue
            case default
              if (allok) write (iw, *)
              write (iw, '(10x, A,I3)') 'DATA ARE NOT AVAILABLE FOR ELEMENT NO.', i
              allok = .FALSE.
          end select
        end do
        if (.not. allok) then
          call mopend("Parameters for some elements are missing")
          return
        end if
        write (iw, '(/,a)') " General Reference for PM6-ORG will be added when available."
        return
      end if
      mixok = index(keywrd,'PARASOK') /= 0
      exter = index(keywrd_quoted,"EXTERNAL") /= 0

      if (method_pm7)   mode = 7
      if (method_rm1)   then
        if (index(keywrd, "SPARKLES") /= 0) then
          do i = 58, 71
            allref(i,6) = allref(i,8)
          end do
        end if
        mode = 6
      end if
      if (method_mndod)   mode = 5
      if (method_pm3)     mode = 4
      if (method_am1)     mode = 3
      if (method_pm6)     mode = 2
      if (method_mndo)    mode = 1
      if (method_pm6_org) mode = 9
      if (method_pm8)     mode = 10
      allref(99,mode) = &
        ' DUMMY ATOMS ARE USED; THESE DO NOT AFFECT THE CALCULATION'
      allref(100,mode) = ' '
      allok = .TRUE.
       write (iw, '(A)')
      do i = 1, 102
        if (.not.elemns(i)) cycle
        if (i < 99 .and. .not.mix .and. mode==3) mix = index(allref(i,3),'MNDO') /= 0
        if (allref(i,5)(1:1) /= ' ' .or. allref(i,5)(1:4) == "    " ) allref(i,5) = allref(i,1)
        if (allref(i,mode)(1:1) /= ' ' .or. &
          allref(i,mode)(1:4) == "    " .or. Abs(gss(i)) < 0.1d0 ) then
          if (.not. exter) then
          write (iw, '(A,I3)') ' DATA ARE NOT AVAILABLE FOR ELEMENT NO.', i
          if (Abs(gssam1sp(i)) > 0.1d0) write(iw,*)" (Parameters are available if AM1 SPARKLE is used)"
          if (Abs(gssPM3sp(i)) > 0.1d0) write(iw,*)" (Parameters are available if PM3 SPARKLE is used)"
          if (Abs(gss6sp(i))   > 0.1d0) write(iw,*)" (Parameters are available if PM6 SPARKLE is used)"
          allok = .FALSE.
          end if
        else
          write (iw, '(A)') trim(allref(i,mode))
          if (mode == 7) exit
        end if
      end do
      if (mix .and. .not.mixok) then
        write (iw, 40) 'SOME ELEMENTS HAVE BEEN SPECIFIED FOR WHICH ONLY MNDO'&
          , 'PARAMETERS ARE AVAILABLE.  SUCH MIXTURES OF METHODS ARE', &
          'VERY RISKY AND HAVE NOT BEEN FULLY TESTED.  IF YOU FEEL', &
          'THE RISK IS WORTH WHILE - CHECK THE MANUAL FIRST - THEN', &
          'SPECIFY "PARASOK" IN THE KEYWORDS'
          call mopend ('MIXED PARAMETER SETS.  USE "PARASOK" TO CONTINUE')
        return
      end if
      if (allok .or. is_PARAM .or. index(keywrd, "0SCF") /= 0) return
      write (iw, 40) 'SOME ELEMENTS HAVE BEEN SPECIFIED FOR WHICH', &
        'NO PARAMETERS ARE AVAILABLE.  CALCULATION STOPPED.'
        call mopend("Parameters for some elements are missing")
      return
   40 format(/,/,/,/,/,10x,a,4(/,10x,a))
      end subroutine refer

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine sp_two_electron
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use parameters_C, only : zsn, zpn, gss, gsp, gpp, gp2, hsp, &
      main_group
      use mndod_C, only : iii
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: ni, ns
      double precision :: es, ep, r033, r233
      double precision, external :: rsc
!
      do ni = 1, 80
        ns = iii(ni)
        es = zsn(ni)
        ep = zpn(ni)
        if (es < 1.d-4 .or. ep < 1.d-4 .or. main_group(ni)) cycle
        gss(ni) = rsc(0,ns,es,ns,es,ns,es,ns,es)
        gsp(ni) = rsc(0,ns,es,ns,es,ns,ep,ns,ep)
        hsp(ni) = rsc(1,ns,es,ns,ep,ns,es,ns,ep)/3.D0
        r033 = rsc(0,ns,ep,ns,ep,ns,ep,ns,ep)
        r233 = rsc(2,ns,ep,ns,ep,ns,ep,ns,ep)
        gpp(ni) = r033 + 0.16D0*r233
        gp2(ni) = r033 - 0.08D0*r233
      end do
      return
      end subroutine sp_two_electron

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.


! For GPU MOPAC 

!
!==============================================================================
!   
! Interface for (t)asum CUBLAS
!
  module call_asum_cublas
    interface asum_cublas_gpu
        subroutine asum_cublas(n,vecx,incx,res) bind(c, &
            & name='call_asum_cublas')
            use iso_c_binding
            implicit none
            integer(c_int), value :: n, incx            
            real(c_double), dimension(n) :: vecx
            real(c_double):: res           
        end subroutine asum_cublas
    end interface
end module

!
!==============================================================================
!   
! Interface for (t)axpy CUBLAS
!
  module call_axpy_cublas
    interface axpy_cublas_gpu
        subroutine axpy_cublas(n,alpha,vecx,incx,vecy,incy) bind(c, &
            & name='call_axpy_cublas')
            use iso_c_binding
            implicit none
            integer(c_int), value :: n, incx,incy          
            real(c_double), dimension(n) :: vecx,vecy
            real(c_double), value :: alpha      
        end subroutine axpy_cublas
    end interface
end module

!
!==============================================================================
!   
! Interface for (t)copy CUBLAS
!
  module call_copy_cublas
    interface copy_cublas_gpu
        subroutine copy_cublas(n,vecx,incx,vecy,incy) bind(c, &
            & name='call_copy_cublas')
            use iso_c_binding
            implicit none
            integer(c_int), value :: n, incx,incy          
            real(c_double), dimension(n) :: vecx,vecy       
        end subroutine copy_cublas
    end interface
end module

!
!==============================================================================
!   
! Interface for (t)dot CUBLAS
!
  module call_dot_cublas
    interface dot_cublas_gpu
        subroutine dot_cublas(n,vecx,incx,vecy,incy,res) bind(c, &
            & name='call_dot_cublas')
            use iso_c_binding
            implicit none
            integer(c_int), value :: n, incx,incy        
            real(c_double), dimension(n) :: vecx,vecy
            real(c_double) :: res       
        end subroutine dot_cublas
    end interface
end module

!
!==============================================================================
!   
! Interface for (t)gemm CUBLAS
!
  module call_gemm_cublas
    interface gemm_cublas_gpu
        subroutine gemm_cublas(tra, trb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc) bind(c, &
            & name='call_gemm_cublas')
            use iso_c_binding
            implicit none
            character(c_char), value :: tra,trb
	        integer(c_int),value     :: m,n,k,lda,ldb,ldc        
            real(c_double), dimension(m,k) :: a
            real(c_double), dimension(k,n) :: b
            real(c_double), dimension(m,n) :: c
            real(c_double), value :: alpha,beta                     
        end subroutine gemm_cublas
    end interface

    interface gemm_cublas_multigpu
        subroutine gemm_cublas_mgpu(tra, trb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc) bind(c, &
            & name='call_gemm_cublas_mgpu')
            use iso_c_binding
            implicit none
            character(c_char), value :: tra,trb
            integer(c_int),value     :: m,n,k,lda,ldb,ldc
#if CC12
            real(c_float), dimension(m,k) :: a
            real(c_float), dimension(k,n) :: b
            real(c_float), dimension(m,n) :: c
            real(c_float), value :: alpha,beta
#else
            real(c_double), dimension(m,k) :: a
            real(c_double), dimension(k,n) :: b
            real(c_double), dimension(m,n) :: c
            real(c_double), value :: alpha,beta
#endif
        end subroutine gemm_cublas_mgpu
    end interface

  end module


  module call_gemm_phigemm
    interface gemm_phigemm_gpu
        subroutine gemm_phigemm(tra, trb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc) bind(c, &
            & name='phigemm')
            use iso_c_binding
            implicit none
            character(c_char), value :: tra,trb
	          integer(c_int),value     :: m,n,k,lda,ldb,ldc       
            real(c_double), dimension(m,k) :: a
            real(c_double), dimension(k,n) :: b
            real(c_double), dimension(m,n) :: c
            real(c_double), value :: alpha,beta                  
        end subroutine gemm_phigemm
    end interface
  end module

! Interface for (t)gemm CUBLAS THRUST
!
  module call_gemm_cublas_thrust
    interface gemm_cublas_gpu_thrust
        subroutine gemm_cublas_thrust(tra, trb,m,n,k,alpha,a,lda,b,ldb,beta,c,ldc) bind(c, &
            & name='call_gemm_cublas_thrust')
            use iso_c_binding
            implicit none
            character(c_char), value :: tra,trb
	          integer(c_int),value     :: m,n,k,lda,ldb,ldc        
            real(c_double), dimension(m,k) :: a
            real(c_double), dimension(k,n) :: b
            real(c_double), dimension(m,n) :: c
            real(c_double), value :: alpha,beta                  
        end subroutine gemm_cublas_thrust
    end interface
  end module

!
!==============================================================================
!   
! Interface for (t)rot CUBLAS
!
  module call_rot_cublas
    interface rot_cublas_gpu
        subroutine rot_cublas(n,vecj,k,veci,l,alpha,beta) bind(c, &
            & name='call_rot_cublas')
            use iso_c_binding
            implicit none
            integer(c_int), value :: n, k,l           
            real(c_double), dimension(n) :: vecj,veci
            real(c_double), value :: alpha,beta           
        end subroutine
    end interface
end module

!
!==============================================================================
!   
! Interface for (t)gemv CUBLAS
!
  module call_gemv_cublas
    interface gemv_cublas_gpu
        subroutine gemv_cublas(tra,m,n,alpha,a,lda,vecx,incx,beta,vecy,incy) bind(c, &
            & name='call_gemv_cublas')
            use iso_c_binding
            implicit none
            character(c_char), value :: tra
	        integer(c_int),value     :: m,n,lda,incx,incy	        
            real(c_double), dimension(lda,*) :: a
            real(c_double), dimension(*) :: vecx,vecy
            real(c_double), value :: alpha,beta
        end subroutine gemv_cublas
    end interface
  end module
             
!
!==============================================================================
!   
! Interface for (t)ger CUBLAS
!
  module call_ger_cublas
    interface ger_cublas_gpu
        subroutine ger_cublas(m,n,k,alpha,vecx,incx,vecy,incy,a,lda) bind(c, &
            & name='call_ger_cublas')
            use iso_c_binding
            implicit none
	          integer(c_int),value     :: m,n,k,lda,incx,incy        
            real(c_double), dimension(lda,n) :: a
            real(c_double), dimension(m) :: vecx
            real(c_double), dimension(n) :: vecy
            real(c_double), value :: alpha
        end subroutine ger_cublas
    end interface
  end module

!
!==============================================================================
!   
! Interface for (t)nrm2 CUBLAS
!
  module call_nrm2_cublas
    interface nrm2_cublas_gpu
        subroutine nrm2_cublas(n,vecx,incx,res) bind(c, &
            & name='call_nrm2_cublas')
            use iso_c_binding
            implicit none
            integer(c_int), value :: n, incx           
            real(c_double), dimension(n) :: vecx
            real(c_double) :: res          
        end subroutine nrm2_cublas
    end interface
end module

!
!==============================================================================
!   
! Interface for (t)scal CUBLAS
!
  module call_scal_cublas
    interface scal_cublas_gpu
        subroutine scal_cublas(n,alpha,vecx,incx) bind(c, &
            & name='call_scal_cublas')
            use iso_c_binding
            implicit none
            integer(c_int), value :: n, incx           
            real(c_double), dimension(n) :: vecx
            real(c_double), value :: alpha           
        end subroutine scal_cublas
    end interface
end module

!
!==============================================================================
!   
! Interface for (t)swap CUBLAS
!
  module call_swap_cublas
    interface swap_cublas_gpu
        subroutine swap_cublas(n,vecx,incx,vecy,incy) bind(c, &
            & name='call_swap_cublas')
            use iso_c_binding
            implicit none
            integer(c_int), value :: n, incx,incy          
            real(c_double), dimension(n) :: vecx,vecy          
        end subroutine swap_cublas
    end interface
end module

!
!==============================================================================
!   
! Interface for (t)trmm CUBLAS
!
  module call_trmm_cublas
    interface trmm_cublas_gpu
        subroutine trmm_cublas(side,uplo,tra,diag,m,n,alpha,a,lda,b,ldb,c,ldc) bind(c, &
            & name='call_trmm_cublas')
            use iso_c_binding
            implicit none
            character(c_char), value :: side,uplo,tra,diag
	          integer(c_int),value     :: m,n,lda,ldb,ldc       
            real(c_double), dimension(lda,*) :: a
            real(c_double), dimension(ldb,n) :: b
            real(c_double), dimension(ldc,n) :: c
            real(c_double), value :: alpha
        end subroutine trmm_cublas
    end interface
  end module

!
!==============================================================================
!   
! Interface for (t)trmv CUBLAS
!
  module call_trmv_cublas
    interface trmv_cublas_gpu
        subroutine trmv_cublas(uplo,tra,diag,n,a,lda,vecx,incx) bind(c, &
            & name='call_trmv_cublas')
            use iso_c_binding
            implicit none
            character(c_char), value :: uplo,tra,diag
	          integer(c_int),value     :: n,lda,incx      
            real(c_double), dimension(lda,n) :: a
            real(c_double), dimension(n) :: vecx
        end subroutine trmv_cublas
    end interface
  end module

!
!==============================================================================
!   
! Interface for (t)trsm CUBLAS
!
  module call_trsm_cublas
    interface trsm_cublas_gpu
        subroutine trsm_cublas(side,uplo,tra,diag,m,n,alpha,a,lda,b,ldb) bind(c, &
            & name='call_trsm_cublas')
            use iso_c_binding
            implicit none
            character(c_char), value :: side, uplo,tra,diag
	          integer(c_int),value     :: m,n,lda,ldb        
            real(c_double), dimension(lda,*) :: a
            real(c_double), dimension(ldb,n) :: b
            real(c_double), value :: alpha
        end subroutine trsm_cublas
    end interface
  end module

!
!==============================================================================
!   
! Interface for i(t)amax CUBLAS
!
  module call_iamax_cublas
    interface iamax_cublas_gpu
        subroutine iamax_cublas(n,vecx,incx,res) bind(c, &
            & name='call_iamax_cublas')
            use iso_c_binding
            implicit none
            integer(c_int), value :: n, incx            
            real(c_double), dimension(n) :: vecx
            real(c_double):: res           
        end subroutine iamax_cublas
    end interface
end module

!
!==============================================================================
!   
! Interface for i(t)amin CUBLAS
!
  module call_iamin_cublas
    interface iamin_cublas_gpu
        subroutine iamin_cublas(n,vecx,incx,res) bind(c, &
            & name='call_iamin_cublas')
            use iso_c_binding
            implicit none
            integer(c_int), value :: n, incx           
            real(c_double), dimension(n) :: vecx
            real(c_double):: res          
        end subroutine iamin_cublas
    end interface
end module

!
!==============================================================================
!   
! Interface for (t)syrk CUBLAS
!
  module call_syrk_cublas
    interface syrk_cublas_gpu
        subroutine syrk_cublas(uplo,tra,n,k,alpha,a,lda,beta,c,ldc) bind(c, &
            & name='call_syrk_cublas')
            use iso_c_binding
            implicit none
            character(c_char), value :: uplo,tra
	          integer(c_int),value     :: n,k,lda,ldc       
            real(c_double), dimension(lda,*) :: a
            real(c_double), dimension(ldc,n) :: c
            real(c_double), value :: alpha,beta
        end subroutine syrk_cublas
    end interface
  end module

module call_syrk_cublas_thrust
    interface syrk_cublas_gpu_thrust
        subroutine syrk_cublas_thrust(uplo,tra,n,k,alpha,a,lda,beta,c,ldc) bind(c, &
            & name='call_syrk_cublas_thrust')
            use iso_c_binding
            implicit none
            character(c_char), value :: uplo,tra
	          integer(c_int),value     :: n,k,lda,ldc        
            real(c_double), dimension(lda,*) :: a
            real(c_double), dimension(ldc,n) :: c
            real(c_double), value :: alpha,beta
        end subroutine syrk_cublas_thrust
    end interface
  end module

!
!==============================================================================
!   

  module handle_cublas
    interface handle_init
        subroutine init_handle() bind(c, &
            & name='create_handle')
            implicit none                  
        end subroutine init_handle
    end interface

    interface handle_destroy
        subroutine destroy_handle() bind(c, name='destroy_handle')
            implicit none
        end subroutine destroy_handle
    end interface
  end module

  module cuda_alloc
    interface cudaMallocHost
      integer (C_INT) function cudaMallocHost(buffer, size)  bind(C,name="cudaMallocHost")
        use iso_c_binding
        implicit none
        type (C_PTR)  :: buffer
        integer (C_LONG), value :: size
      end function cudaMallocHost
    end interface

    interface cudaFreeHost
      integer (C_INT) function cudaFreeHost(buffer)  bind(C,name="cudaFreeHost")
        use iso_c_binding
        implicit none
        type (C_PTR), value :: buffer
      end function cudaFreeHost
    end interface
  end module cuda_alloc

!
!==============================================================================
!   
! Interface for MAGMA
!
  
#if (MAGMA .and. LINUX)

  module initMagma
	interface magmaDsyevd
		
		subroutine magma_dsyevd_Driver1(ngpus,opt1, opt2,n,eigenvecs,m,eigvals, &
			& work_tmp, lwork, iwork_tmp, liwork, info) bind(c,name="MagmaDsyevd_Driver1")
			use iso_c_binding
			implicit none
		
			character(C_CHAR),value :: opt1,opt2
			integer(c_int),value :: n,m,lwork,liwork,ngpus
			integer(c_int) :: iwork_tmp(10),info
			real(c_double) :: eigenvecs(n*n), eigvals(n),work_tmp(10)
		end subroutine
		
		subroutine magma_dsyevd_Driver2(ngpus,opt1, opt2,n,eigenvecs,m,eigvals, &
            & work, lwork, iwork, liwork, info) bind(c,name="MagmaDsyevd_Driver2")
			use iso_c_binding
			implicit none
		
			character(C_CHAR),value :: opt1,opt2
            integer(c_int),value :: n,m,lwork,liwork,ngpus
            integer(c_int) :: iwork(liwork),info
            real(c_double) :: eigenvecs(n*n), eigvals(n),work(lwork)
		end subroutine
		
	end interface
  end module
      
#endif

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine symoir(itype, vects, eigs, nvecs, r, imat)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE symmetry_C, ONLY: jndex, namo, nirred, nclass, name, jx, group
      USE meci_C, only : lab, eig
      use molkst_C, only : keywrd, numat
      use chanel_C, only : iw
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: itype
      integer  :: nvecs
      integer , intent(in) :: imat
      double precision  :: vects(nvecs,*)
      double precision , intent(in) :: eigs(*)
      double precision  :: r(3,3)
      double precision  :: carmat(imat,20)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(20) :: icount
      integer , dimension(nvecs) :: ntype
      integer :: korb, i, jj, j, nfind, ifound, l, ik, k
      double precision, dimension(20) :: tchar
      double precision :: toler, check
      logical :: first, r3, debug
      character :: names*4
      double precision, external :: charmo, charst, charvi

      save toler
!-----------------------------------------------
!***********************************************************************
!
!    Calculates the Irreducible Representation of an eigenvector.
!
!    GROUP(i,j) is the Character of Irreducible Representation i in
!    Class j.
!
!     On input  NVECS  = No. of vectors to be assigned.
!               VECTS  = Eigenvectors, packed
!
!     On output ICOUNT = No. of I.R.s of each type.
!               NAMO   = Irreducible Representation as a 4 character
!                        string.
!
!
!***********************************************************************
      data toler/ 0.1D0/
!
!
!  ICOUNT will hold the number of occurances of each Irreducible
!         Representation
!
      r3 = name == 'R3'
      korb = 0
      do i = 1, numat
        jj = jndex(i)
        do j = 1, jj
          korb = korb + 1
          ntype(korb) = 100*i + 9 + j
        end do
      end do
      if (itype /= 3) then
        nfind = nvecs
      else
        nfind = lab
      end if
      icount(:nirred) = 0
      names = '????'
      if (nclass == 1) names = jx(1)
      do i = 1, nfind
        jndex(i) = i
        namo(i) = names
      end do
      if (nclass == 1) return
      ifound = 0
!
!   Calculate all the characters in one pass.  This is done
!   for the convenience of CHARST.  In CHARST, the M.O. transform
!   only need be evaluated once per class.
!
      first = .TRUE.
      do j = 1, nclass
        l = (j - 1)*imat
        do i = 1, nfind
          l = l + 1
          if (itype == 1) then
            carmat(i,j) = charmo(vects, ntype, i, j, r, nvecs, first)
          else if (itype == 2) then
            carmat(i,j) = charvi(vects, i, j, r, nvecs)
          else
            carmat(i,j) = charst(vects, ntype, i, j, r, nvecs, first)
          end if
        end do
      end do
!
!     Reset counters in CHARST
!
      if (itype == 3) i = int(charst(vects ,ntype, -1, 0, r, nvecs, first))
      debug = index(keywrd,'SYMOIR') /= 0
      if (debug) then
        write (iw, '(/10x,a)') 'Characters of Transform'
        if (itype == 3) then
          write (iw, '(a)') ' State    Energy           Characters for Operations'
          do i = 1, nfind
            write (iw, '(I5,6F12.6)') i, eig(i), (carmat(i,j),j=1,nclass)
          end do
        else
          write (iw, '(A)') ' Characters of Transform'
          do i = 1, nfind
            write (iw, '(I5,6F12.6)') i, (carmat(i,j),j=1,nclass)
          end do
        end if
      end if
      i = 0
   70 continue
      ik = i + 1
      tchar(:nclass) = 0.D0
   90 continue
      i = i + 1
      if (i > nfind) then
!
!  Convert to lower case if one-electron eigenvector
!
        if (itype == 1) then
          do i = 1, nfind
            j = ichar(namo(i)(1:1))
            if (j>=ichar('A') .and. j<=ichar('Z')) j = j + ichar('a') - ichar(&
              'A')
            namo(i)(1:1) = char(j)
          end do
        end if
        if (debug) then
          write (iw, '(/,A,/)') &
            ' Number of Irreducible Representations of each Class'
          write (iw, '(7(I5,1X,A4))') (icount(i),jx(i),i=1,nirred)
        end if
        return
      end if
      tchar(:nclass) = tchar(:nclass) + carmat(i,:nclass)
      if (tchar(1)>5.1D0 .and. .not.r3) go to 70
      l140: do k = 1, nirred
        do j = 1, nclass
          check = abs(tchar(j)-group(k,j))
          if (check <= toler) cycle
          cycle  l140
        end do
!
!   Degeneracy of Eigenvector manifold is I-IK+1
!
        icount(k) = icount(k) + 1
!
!  The only information passed to MATOU1 is JNDEX and NAMO
!
        if (i - ik + 1 > 0) then
          jndex(ik:i) = icount(k)
          namo(ik:i) = jx(k)
          ifound = i - ik + 1 + ifound
        end if
        go to 70
      end do l140
!
!   If manifold registration lost, use eigenvalues to decide
!   if start of new Irreducible Representation.
!
      if (i < nfind) then
        if (eigs(i+1) - eigs(i) > 0.1D0) go to 70
      end if
      go to 90
      end subroutine symoir

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

double precision function invfn (x, qn, mode)
    implicit none
    integer, intent (in) :: qn, mode
    double precision, intent (in) :: x
    double precision :: x0, x1, ans0, ans1, new
    intrinsic Abs
    ans0 = 2.0d0
    x0 = fn(ans0, qn, mode) - x
    ans1 = ans0 * 1.1d0
    new = 0.d0
    do
      x1 = fn(ans1, qn, mode) - x
      if (Abs (x0-x1) < 1.d-10) exit
      new = ans0 + x0 * (ans1-ans0) / (x0-x1)
      if (Abs(x1) < 1.d-10) exit
      x0 = x1
      ans0 = ans1
      ans1 = new
    end do
    invfn = new
contains
    double precision function fn (x, qn, mode)
   !
   !.. Implicit Declarations ..
      implicit none
   !
   !.. Formal Arguments ..
      integer, intent (in) :: qn, mode
      double precision, intent (in) :: x
   !
   !.. External Calls ..
      double precision, external :: rsc
      fn = 0.d0
      select case (mode)
      case (0)
    !
    !  Calculate Gss given the principal quantum number
    !  and Slater exponent for the "s" orbital.
    !
        fn = rsc (0, qn, x, qn, x, qn, x, qn, x)
      case (1)
    !
    !  Calculate Gpp given the principal quantum number
    !  and Slater exponent for the "p" orbital.
    !
        fn = rsc (0, qn, x, qn, x, qn, x, qn, x) + 0.16d0 * rsc (2, qn, x, qn, &
       & x, qn, x, qn, x)
      case (2)
    !
    !  Calculate Gdd given the principal quantum number
    !  and Slater exponent for the "d" orbital.
    !
        fn = rsc (0, qn, x, qn, x, qn, x, qn, x) + 4.d0 / 49.d0 * (rsc (2, qn, &
       & x, qn, x, qn, x, qn, x)+rsc (4, qn, x, qn, x, qn, x, qn, x))
      end select
      return
    end function fn
end function invfn

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine exchng(a, b, c, d, x, y, t, q, n)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n
      double precision , intent(in) :: a
      double precision , intent(out) :: b
      double precision , intent(in) :: c
      double precision , intent(out) :: d
      double precision , intent(in) :: t
      double precision , intent(out) :: q
      double precision , intent(in) :: x(*)
      double precision , intent(out) :: y(*)
!-----------------------------------------------
!********************************************************************
!
! THE CONTENTS OF A, C, T, AND X ARE STORED IN B, D, Q, AND Y!
!
!   THIS IS A DEDICATED ROUTINE, IT IS CALLED BY LINMIN AND LOCMIN ONLY.
!
!********************************************************************
      b = a
      d = c
      q = t
      y(:n) = x(:n)
      return
!
      end subroutine exchng

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine esp()
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : keywrd, moperr
      use chanel_C, only : iw
      use esp_C, only : scale, den, nesp
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: n, i
      double precision :: scincr, time1
      double precision, external :: reada, seconds
!-----------------------------------------------
      time1 = seconds (1)
      if (index(keywrd, " CUBE") /= 0 .or. index(keywrd, " ESPGRID") /= 0) then
        call new_esp()
        return
      end if
!
!     SET STANDARD PARAMETERS FOR THE SURFACE GENERATION
!
      if (index(keywrd,'SCALE=') /= 0) then
        scale = reada(keywrd,index(keywrd,'SCALE='))
      else
        scale = 1.4D0
      end if
!
      if (index(keywrd,'DEN=') /= 0) then
        den = reada(keywrd,index(keywrd,'DEN='))
      else
        den = 1.0D0
      end if
!
      if (index(keywrd,'SCINCR=') /= 0) then
        scincr = reada(keywrd,index(keywrd,'SCINCR='))
      else
        scincr = 0.20D0
      end if
!
      if (index(keywrd,'NSURF=') /= 0) then
        n = nint(reada(keywrd,index(keywrd,'NSURF=')))
      else
        n = 4
      end if
!
      time1 = seconds(1)
!
!     NOW CALCULATE THE SURFACE POINTS
!
      call setup_esp(1)
      nesp = 0
      if (index(keywrd,'WILLIAMS') /= 0) then
        call pdgrid ()
        if (moperr) return
      else
        do i = 1, n
          call surfac ()
          if (moperr) return
          scale = scale + scincr
        end do
      end if
!
!     NEXT CALCULATE THE ESP AT THE POINTS CALCULATED BY SURFAC
!
      call potcal ()
!
!     END OF CALCULATION
!
      time1 = seconds(1) - time1
      write (iw, 20) 'TIME TO CALCULATE ESP:', time1, ' SECONDS'
   20 format(/,9x,a,f8.2,a)
      return
      end subroutine esp
       subroutine pdgrid()
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : numat, natoms
      use common_arrays_C, only : geo, coord, labels, nat
      use esp_C, only : nesp, potpt, co
      use chanel_C, only : iw
!
!     ROUTINE TO CALCULATE WILLIAMS SURFACE
!
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: icntr, i, j, ia, npnt, l, jz
      double precision, dimension(53) :: vderw
      double precision, dimension(100) :: dist
      double precision, dimension(3) :: xmin, xmax
      double precision :: shell, grid, closer, vdmax, xstart, ystart, zstart, zgrid&
        , ygrid, xgrid
!-----------------------------------------------
!
      data vderw/ 53*0.0D0/
      vderw(1) = 2.4D0
      vderw(5) = 3.0D0
      vderw(6) = 2.9D0
      vderw(7) = 2.7D0
      vderw(8) = 2.6D0
      vderw(9) = 2.55D0
      vderw(15) = 3.1D0
      vderw(16) = 3.05D0
      vderw(17) = 3.0D0
      vderw(35) = 3.15D0
      vderw(53) = 3.35D0
      shell = 1.2D0
      nesp = 0
      grid = 0.8D0
      closer = 0.D0
!     CHECK IF VDERW IS DEFINED FOR ALL ATOMS
!
!     CONVERT INTERNAL TO CARTESIAN COORDINATES
!
      call gmetry (geo, coord)
!
!     STRIP COORDINATES AND ATOM LABEL FOR DUMMIES (I.E. 99)
!
      icntr = 0
      do i = 1, natoms
        co(:,i) = coord(:,i)
        if (labels(i) == 99) cycle
        icntr = icntr + 1
        nat(icntr) = labels(i)
      end do
      numat = icntr
!
      do i = 1, numat
        j = nat(i)
        if (vderw(j) == 0.0D0) go to 40
      end do
      go to 50
   40 continue
      write (iw, *) 'VAN DER WAALS'' RADIUS NOT DEFINED FOR ATOM', i
      write (iw, *) 'IN WILLIAMS SURFACE ROUTINE PDGRID!'
      call mopend (&
      'VAN DER WAALS'' RADIUS NOT DEFINED FOR ATOM IN WILLIAMS SURFACE ROUTINE &
      &PDGRID!')
      return
!     NOW CREATE LIMITS FOR A BOX
   50 continue
      xmin = 100000.0D0
      xmax = -100000.0D0
      do ia = 1, numat
        where (co(:,ia) - xmin < 0.D0)
          xmin = co(:,ia)
        end where
        where (co(:,ia) - xmax > 0.D0)
          xmax = co(:,ia)
        end where
      end do
!     ADD (OR SUBTRACT) THE MAXIMUM VDERW PLUS SHELL
      vdmax = 0.0D0
      vdmax = dmax1(maxval(vderw),vdmax)
      xmin = xmin - vdmax - shell
      xmax = xmax + vdmax + shell
! STEP GRID BACK FROM ZERO TO FIND STARTING POINTS
      xstart = 0.0D0
      xstart = xstart - grid
      do while(xstart > xmin(1))
        xstart = xstart - grid
      end do
      ystart = 0.0D0
      ystart = ystart - grid
      do while(ystart > xmin(2))
        ystart = ystart - grid
      end do
      zstart = 0.0D0
      zstart = zstart - grid
      do while(zstart > xmin(3))
        zstart = zstart - grid
      end do
      npnt = 0
      zgrid = zstart
  160 continue
      ygrid = ystart
  170 continue
      xgrid = xstart
  180 continue
      do l = 1, numat
        jz = nat(l)
        dist(l) = sqrt((co(1,l)-xgrid)**2+(co(2,l)-ygrid)**2+(co(3,l)-zgrid)**2)
!     REJECT GRID POINT IF ANY ATOM IS TOO CLOSE
        if (dist(l) < vderw(jz) - closer) go to 220
      end do
! BUT AT LEAST ONE ATOM MUST BE CLOSE ENOUGH
      do l = 1, numat
        jz = nat(l)
        if (dist(l) > vderw(jz) + shell) cycle
        go to 210
      end do
      go to 220
  210 continue
      npnt = npnt + 1
      nesp = nesp + 1
      potpt(1,nesp) = xgrid
      potpt(2,nesp) = ygrid
      potpt(3,nesp) = zgrid
  220 continue
      xgrid = xgrid + grid
      if (xgrid <= xmax(1)) go to 180
      ygrid = ygrid + grid
      if (ygrid <= xmax(2)) go to 170
      zgrid = zgrid + grid
      if (zgrid <= xmax(3)) go to 160
      return
      end subroutine pdgrid
      subroutine surfac()
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use common_arrays_C, only :geo, coord, labels, nat
      use molkst_C, only : numat, natoms
      use esp_C, only : nesp, rad, dens, scale, potpt, co, den
      use chanel_C, only : iw
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(numat) :: ias
      integer :: icntr, i, ipoint, iatom, nnbr, jatom, ncon
      double precision, dimension(100) :: vander
      double precision, dimension(3,1000) :: con
      double precision, dimension(3,200) :: cnbr
      double precision, dimension(200) :: rnbr
      double precision, dimension(3) :: ci, temp0
      double precision, dimension(3,2) :: cw
      double precision :: pi, rw, ri, d2
      logical :: si
      double precision, external :: distance
      logical, external :: collid
!-----------------------------------------------
!***********************************************************************
!
!      THIS SUBROUTINE CALCULATES THE MOLECULAR SURFACE OF A MOLECULE
!      GIVEN THE COORDINATES OF ITS ATOMS.  VAN DER WAALS' RADII FOR
!      THE ATOMS AND THE PROBE RADIUS MUST ALSO BE SPECIFIED.
!
!      ON INPUT    SCALE = INITIAL VAN DER WAALS' SCALE FACTOR
!                  DENS  = DENSITY OF POINTS PER UNIT AREA
!
!      THIS SUBROUTINE WAS LIFTED FROM MICHAEL CONNOLLY'S SURFACE
!      PROGRAM FOR UCSF GRAPHICS SYSTEM BY U.CHANDRA SINGH AND
!      P.A.KOLLMAN AND MODIFIED FOR USE IN QUEST. K.M.MERZ
!      ADAPTED AND CLEANED UP THIS PROGRAM FOR USE IN AMPAC/MOPAC
!      IN FEB. 1989 AT UCSF.
!
!***********************************************************************
!
!
!     NEIGHBOR ARRAYS
!
!     THIS SAME DIMENSION FOR THE MAXIMUM NUMBER OF NEIGHBORS
!     IS USED TO DIMENSION ARRAYS IN THE LOGICAL FUNCTION COLLID
!
!#      DIMENSION INBR(200)
!
!     ARRAYS FOR ALL ATOMS
!
!     IATOM, JATOM AND KATOM COORDINATES
!
!
!     GEOMETRIC CONSTRUCTION VECTORS
!
!
!     LOGICAL VARIABLES
!
!
!     LOGICAL FUNCTIONS
!
!
!     DATA FOR VANDER VALL RADII
!
      data vander/ 1.20D0, 1.20D0, 1.37D0, 1.45D0, 1.45D0, 1.50D0, 1.50D0, &
        1.40D0, 1.35D0, 1.30D0, 1.57D0, 1.36D0, 1.24D0, 1.17D0, 1.80D0, 1.75D0&
        , 1.70D0, 17*0.0D0, 2.3D0, 65*0.0D0/
!
      pi = 4.D0*atan(1.D0)
!     INSERT VAN DER WAAL RADII FOR ZINC
      vander(30) = 1.00D0
!
!     CONVERT INTERNAL TO CARTESIAN COORDINATES
!
      call gmetry (geo, coord)
!
!     STRIP COORDINATES AND ATOM LABEL FOR DUMMIES (I.E. 99)
!
      icntr = 0
      co(:,:numat) = coord(:,:numat)
      do i = 1, natoms
        if (labels(i) == 99) cycle
        icntr = icntr + 1
        nat(icntr) = labels(i)
      end do
!
!     ONLY VAN DER WAALS' TYPE SURFACE IS GENERATED
!
!#      NESP=0
      rw = 0.0D0
      numat = icntr
      dens = den
      do i = 1, numat
        ipoint = nat(i)
        rad(i) = vander(ipoint)*scale
        if (rad(i) < 0.01D0) write (iw, &
      '(T2,''VAN DER WAALS'''' RADIUS FOR ATOM '',I3,'' IS ZERO, SUPPLY A VALUE IN SUBROUTINE SURFAC)''                )')
        ias(i) = 2
      end do
!
!     BIG LOOP FOR EACH ATOM
!
      do iatom = 1, numat
        if (ias(iatom) == 0) cycle
!
!     TRANSFER VALUES FROM LARGE ARRAYS TO IATOM VARIABLES
!
        ri = rad(iatom)
        si = ias(iatom) == 2
        ci = co(:,iatom)
!
!     GATHER THE NEIGHBORING ATOMS OF IATOM
!
        nnbr = 0
        do jatom = 1, numat
          if (iatom==jatom .or. ias(jatom)==0) cycle
          d2 = distance(iatom,jatom)
          if (d2 >= (2*rw + ri + rad(jatom))**2) cycle
!
!     WE HAVE A NEW NEIGHBOR
!     TRANSFER ATOM COORDINATES, RADIUS AND SURFACE REQUEST NUMBER
!
          nnbr = nnbr + 1
          if (nnbr > 200) then
            write (iw, '(''ERROR'',2X,''TOO MANY NEIGHBORS:'',I5)') nnbr
            call mopend ('ERROR.  TOO MANY NEIGHBORS')
            return
          end if
!#            INBR(NNBR) = JATOM
          cnbr(:,nnbr) = co(:,jatom)
          rnbr(nnbr) = rad(jatom)
        end do
!
!     CONTACT SURFACE
!
        if (.not.si) cycle
        ncon = int((4*pi*ri**2)*den)
        ncon = min0(1000,ncon)
!
!     THIS CALL MAY DECREASE NCON SOMEWHAT
!
        if (ncon == 0) then
          write (iw, '(T2,''VECTOR LENGTH OF ZERO IN SURFAC'')')
          call mopend ('VECTOR LENGTH OF ZERO IN SURFAC')
          return
        end if
        call genun (con, ncon)
!#         AREA = (4 * PI * RI ** 2) / NCON
!
!     CONTACT PROBE PLACEMENT LOOP
!
        do i = 1, ncon
          cw(:,1) = ci + (ri + rw)*con(:,i)
!
!     CHECK FOR COLLISION WITH NEIGHBORING ATOMS
!
          if (collid(cw(1,1),rw,cnbr,rnbr,nnbr,1)) cycle
          temp0 = ci + ri*con(:,i)
!
!     STORE POINT IN POTPT AND INCREMENT NESP
!
          nesp = nesp + 1
          potpt(1,nesp) = temp0(1)
          potpt(2,nesp) = temp0(2)
          potpt(3,nesp) = temp0(3)
        end do
      end do
      return
      end subroutine surfac

     subroutine potcal()
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : keywrd, numat, ux, uy, uz, method_mndo
      USE common_arrays_C, only : q, nat
      use funcon_C, only : a0
      use elemts_C, only : elemnt
      use esp_C, only : cf, cequiv, co, qsc, nesp, &
      & rms, rrms, dx, dy, dz, iz, idip
      use chanel_C, only : iw
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j, ieq
      double precision :: dipx, dipy, dipz, slope, dip
      double precision, external :: reada
!-----------------------------------------------
!***********************************************************************
!
!     THIS SUBROUTINE CALCULATES THE TOTAL ELECTROSTATIC POTENTIAL
!     THE NUCLEAR CONTRIBUTION IS EVALUATED BY NUCPOT
!     THE ELECTRONIC CONTRIBUTION IS EVALUATED BY ELESP
!     ESPFIT FITS THE QUANTUM POTENTIAL TO A CLASSICAL POINT CHARGE
!     MODEL.
!     THIS SUBROUTINE WAS WRITTEN BY B.H.BESLER AND K.M.MERZ IN FEB.
!     1989 AT UCSF
!
!***********************************************************************
      data dipx, dipy, dipz/ 3*0.D0/
!
!
      call elesn ()
      rms = 0.D0
      rrms = 0.D0
      slope = 0.d0
!
!     NOW FIT THE ELECTROSTATIC POTENTIAL
!
      write (iw, '(2/12X,''ELECTROSTATIC POTENTIAL CHARGES'',/)')
      iz = 0
      if (index(keywrd,'CHARGE=') /= 0) iz = nint(reada(keywrd,index(keywrd,&
        'CHARGE=')))
!
!     DIPOLAR CONSTRAINTS IF DESIRED
!
      if (index(keywrd,'DIPOLE') /= 0) then
        idip = 1
        if (iz /= 0) then
          idip = 0
          write (iw, '(/12X,''  DIPOLE CONSTRAINTS NOT USED'')')
          write (iw, '(12X,''        CHARGED MOLECULE'',/)')
        end if
      else
        idip = 0
      end if
      if (idip == 1) write (iw, '(/12X,''DIPOLE CONSTRAINTS WILL BE USED'',/)')
!
!     GET X,Y,Z DIPOLE COMPONENTS IF DESIRED
!
      if (index(keywrd,'DIPX=') /= 0) then
        dx = reada(keywrd,index(keywrd,'DIPX='))
      else
        dx = ux
      end if
      if (index(keywrd,'DIPY=') /= 0) then
        dy = reada(keywrd,index(keywrd,'DIPY='))
      else
        dy = uy
      end if
      if (index(keywrd,'DIPZ=') /= 0) then
        dz = reada(keywrd,index(keywrd,'DIPZ='))
      else
        dz = uz
      end if
      call espfit ()
!
!     WRITE OUT OUR RESULTS TO CHANNEL 6
!     THE CHARGES ARE SCALED TO REPRODUCE 6-31G* CHARGES FOR MNDO ONLY
!     AM1 CHARGES ARE NOT SCALED DUE TO THE LOW COORELATION
!     COEFFICIENT. SEE BESLER,MERZ,KOLLMAN IN J. COMPUT. CHEM.
!     (IN PRESS)
!
      if (.not. method_mndo) then
        write (iw, '(15X,''ATOM NO.    TYPE    CHARGE'')')
        do i = 1, numat
          write (iw, '(17X,I4,9X,A2,1X,F10.4)') i, elemnt(nat(i)), q(i)
        end do
        call to_screen("To_file: Esp")
      else
!
!     MNDO CALCULATION-SCALE THE CHARGES. TEST FOR SLOPE KEYWORD
!
        if (index(keywrd,'SLOPE=') /= 0) then
          slope = reada(keywrd,index(keywrd,'SLOPE='))
        else
          slope = 1.422D0
        end if
        qsc(:numat) = slope*q(:numat)
        write (iw, '(7X,''ATOM NO.    TYPE    CHARGE   SCALED CHARGE'')')
        do i = 1, numat
          write (iw, '(9X,I4,9X,A2,1X,F10.4,2X,F10.4)') i, elemnt(nat(i)), q(i), qsc(i)
        end do
!     Temporarily scale charges in q for AUX printing
        q(:numat) = qsc(:numat)
        call to_screen("To_file: Esp")
        q(:numat) = qsc(:numat)/slope
      end if
      write (iw, '(/12X,A,4X,I6)') 'THE NUMBER OF POINTS IS:', nesp
      write (iw, '(12X,A,4X,F9.4)') 'THE RMS DEVIATION IS:', rms
      write (iw, '(12X,A,3X,F9.4)') 'THE RRMS DEVIATION IS:', rrms
!
!     CALCULATE DIPOLE MOMENT IF NEUTRAL MOLECULE
!
      if (iz /= 0) then
        go to 60
      else
        write (iw, 40)
   40   format(/,/,5x,'DIPOLE MOMENT EVALUATED FROM THE POINT CHARGES',/)
        dipx = 0.d0
        dipy = 0.d0
        dipz = 0.d0
        dipx = dipx + sum(co(1,:numat)*q(:numat)/a0)
        dipy = dipy + sum(co(2,:numat)*q(:numat)/a0)
        dipz = dipz + sum(co(3,:numat)*q(:numat)/a0)
        dip = sqrt(dipx**2 + dipy**2 + dipz**2)
        write (iw, '(12X,'' X        Y        Z       TOTAL'')')
        write (iw, '(8X,4F9.4)') dipx*cf, dipy*cf, dipz*cf, dip*cf
      end if
   60 continue
      if (index(keywrd,'SYMAVG') /= 0) then
        allocate (cequiv(numat,numat))
        do i = 1, numat
          do j = 1, numat
            cequiv(i,j) = .FALSE.
            if (abs(abs(q(i))-abs(q(j))) >= 1.D-5) cycle
            cequiv(i,j) = .TRUE.
          end do
        end do
        do i = 1, numat
          ieq = 0
          qsc(i) = 0.D0
          do j = 1, numat
            if (.not.cequiv(i,j)) cycle
            qsc(i) = qsc(i) + abs(q(j))
            ieq = ieq + 1
          end do
          q(i) = q(i)/abs(q(i))*qsc(i)/ieq
        end do
        write (iw, *) ' '
        write (iw, *) '   ELECTROSTATIC POTENTIAL CHARGES AVERAGED FOR'
        write (iw, *) '   SYMMETRY EQUIVALENT ATOMS'
        write (iw, *) ' '
        if (index(keywrd,'AM1')/=0 .or. index(keywrd,'PM3')/=0) then
          write (iw, '(7X,''ATOM NO.    TYPE    CHARGE'')')
          do i = 1, numat
            write (iw, '(9X,I4,9X,A2,1X,F10.4)') i, elemnt(nat(i)), q(i)
          end do
        else
          write (iw, &
      '(7X,''ATOM NO.    TYPE     CHARGE   SCALED CHARGE'')')
          do i = 1, numat
            write (iw, '(9X,I4,9X,A2,1X,F10.4,2X,F10.4)') i, elemnt(nat(i)), q(i), q(i)*slope
          end do
        end if
      end if
      return
      end subroutine potcal


      subroutine elesn()
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : numat, keywrd, nopen, fract, nclose
      use overlaps_C, only : allc, allz
      use parameters_C, only : tore, zs, zp
      use chanel_C, only : iesp, esp_fn
      use common_arrays_C, only : c, nat
      use esp_C, only : b_esp, ovl, fac, &
      & cespm2, esp_array, cesp, cespm, es, cespml, potpt, &
      & cc, dex, fv, ex, cen, iam, ind, temp, itemp, nesp, co, fc, indc, icd, &
      & npr, ncc, is_esp, ip, ipe, ipx, isc
      use funcon_C, only : a0
!
      implicit none
!
      integer :: j1, i, m, k, j, nqn, ipc,  in, l
      double precision :: norm
      double precision :: pi,  t, fval, sum, ra, rij
      logical :: potwrt, sto3g
      double precision, external :: dex2
      pi = 4.D0*atan(1.D0)
!
!     PUT STO-6G BASIS SET ON ATOM CENTERS
!
      do i = -1, 10
        dex(i) = dex2(i)
      end do
      if (fac(4) > 1.D0) then
        fac(:7) = 1.D0/fac(:7)
      end if
      do m = 0, 8
        k = 1
        fv(m,1) = 1.D0/(2.D0*m + 1.D0)
        t = 0.D0
        do j1 = 1, int(41.D0/0.05D0)
          t = t + 0.05D0
          k = k + 1
          call fsub (m, t, fval)
          fv(m,k) = fval
        end do
        t = t + 0.05D0
      end do
!
!     LOAD BASIS FUNCTIONS INTO ARRAYS
!
      sto3g = index(keywrd,'STO3G') /= 0
      if (sto3g) then
        icd = 3
        call setup3
      else
        icd = 6
        call setupg
      end if
      ncc = 0
      npr = 0
      do i = 1, numat
        if (nat(i) <= 2) then
          cc(npr+1:icd+npr) = allc(:icd,1,1)
          ex(npr+1:icd+npr) = allz(:icd,1,1)*zs(1)**2
          cen(npr+1:icd+npr,1) = co(1,i)/a0
          cen(npr+1:icd+npr,2) = co(2,i)/a0
          cen(npr+1:icd+npr,3) = co(3,i)/a0
          iam(npr+1:icd+npr,1) = 0
          iam(npr+1:icd+npr,2) = 0
          fc(npr+1:icd+npr) = i
          ncc = ncc + 1
          npr = npr + icd
        else
!        DETERMINE PRINCIPAL QUANTUM NUMBER(NQN)
!        OF ORBITALS TO BE USED
!
          nqn = 2
          if (nat(i)>10 .and. nat(i)<=18) nqn = 3
          if (nat(i)>18 .and. nat(i)<=36) nqn = 4
          if (nat(i)>36 .and. nat(i)<=54) nqn = 5
!
          cc(npr+1:icd+npr) = allc(:icd,nqn,1)
          ex(npr+1:icd+npr) = allz(:icd,nqn,1)*zs(nat(i))**2
          cen(npr+1:icd+npr,1) = co(1,i)/a0
          cen(npr+1:icd+npr,2) = co(2,i)/a0
          cen(npr+1:icd+npr,3) = co(3,i)/a0
          iam(npr+1:icd+npr,1) = 0
          iam(npr+1:icd+npr,2) = 0
          ncc = ncc + 1
          npr = npr + icd
          do k = 1, 3
            cc(npr+1:icd+npr) = allc(:icd,nqn,2)
            ex(npr+1:icd+npr) = allz(:icd,nqn,2)*zp(nat(i))**2
            cen(npr+1:icd+npr,1) = co(1,i)/a0
            cen(npr+1:icd+npr,2) = co(2,i)/a0
            cen(npr+1:icd+npr,3) = co(3,i)/a0
            iam(npr+1:icd+npr,1) = 1
            iam(npr+1:icd+npr,2) = k
            ncc = ncc + 1
            npr = npr + icd
          end do
        end if
      end do
!
!     CALCULATE NORMALIZATION CONSTANTS AND INCLUDE
!     THEM IN THE CONTRACTION COEFFICIENTS
!
      do i = 1, npr
        norm = (2.D0*ex(i)/pi)**0.75D0*(4.D0*ex(i))**(iam(i,1)/2.D0)/sqrt(dex(2&
          *iam(i,1)-1))
        cc(i) = cc(i)*norm
      end do
!
!     PERFORM SORT OF PRIMITIVES BY ANGULAR MOMENTUM
!
      is_esp = 0
      isc = 0
      j = 0
      do i = 1, npr
        if (iam(i,1) /= 0) cycle
        is_esp = is_esp + 1
        ind(is_esp) = i
      end do
      ip = is_esp
      do i = 1, npr
        if (iam(i,1)/=1 .or. iam(i,2)/=1) cycle
        ip = ip + 1
        ind(ip) = i
      end do
      do i = 1, npr
        if (iam(i,1)/=1 .or. iam(i,2)/=2) cycle
        ip = ip + 1
        ind(ip) = i
      end do
      do i = 1, npr
        if (iam(i,1)/=1 .or. iam(i,2)/=3) cycle
        ip = ip + 1
        ind(ip) = i
      end do
      do i = 1, ncc
        in = i*icd - icd + 1
        if (iam(in,1) /= 0) cycle
        isc = isc + 1
        indc(isc) = i
      end do
      ipc = isc
      do i = 1, ncc
        in = i*icd - icd + 1
        if (iam(in,1)/=1 .or. iam(in,2)/=1) cycle
        ipc = ipc + 1
        indc(ipc) = i
      end do
      do i = 1, ncc
        in = i*icd - icd + 1
        if (iam(in,1)/=1 .or. iam(in,2)/=2) cycle
        ipc = ipc + 1
        indc(ipc) = i
      end do
      do i = 1, ncc
        in = i*icd - icd + 1
        if (iam(in,1)/=1 .or. iam(in,2)/=3) cycle
        ipc = ipc + 1
        indc(ipc) = i
      end do
      temp(:npr) = cc(ind(:npr))
      cc(:npr) = temp(:npr)
      temp(:npr) = ex(ind(:npr))
      ex(:npr) = temp(:npr)
      temp(:npr) = cen(ind(:npr),1)
      cen(:npr,1) = temp(:npr)
      temp(:npr) = cen(ind(:npr),2)
      cen(:npr,2) = temp(:npr)
      temp(:npr) = cen(ind(:npr),3)
      cen(:npr,3) = temp(:npr)
      itemp(:npr) = iam(ind(:npr),1)
      iam(:npr,1) = itemp(:npr)
      itemp(:npr) = iam(ind(:npr),2)
      iam(:npr,2) = itemp(:npr)
!     CALCULATE OVERLAP MATRIX OF STO-6G FUNCTIONS
!
      do j = 1, ncc
        call ovlp (j)
      end do
!
      do j = 1, ncc
        do k = 1, ncc
          cespm2(indc(j),indc(k)) = ovl(j,k)
        end do
      end do
      ovl(:ncc,:ncc) = cespm2(:ncc,:ncc)
      l = 0
      do i = 1, ncc
        if (i > 0) then
          cesp(l+1:i+l) = ovl(i,:i)
          l = i + l
        end if
      end do
!
!     DEORTHOGONALIZE THE COEFFICIENTS AND REFORM THE DENSITY MATRIX
!
      call rsp (cesp, ncc, temp, cespml)
      do i = 1, ncc ! TODO: to be parallelized
        do j = 1, i
          sum = 0.D0
          do k = 1, ncc
            sum = sum + cespml(i+(k-1)*ncc)/dsqrt(temp(k))*cespml(j+(k-1)*ncc)
            cesp(i+(j-1)*ncc) = sum
            cesp(j+(i-1)*ncc) = sum
          end do
        end do
      end do
      call mult (c, cesp, cespml, ncc)
      call densit (cespml, ncc, ncc, nclose, 2.d0, nopen, fract, cesp, 2)


!
!     NOW CALCULATE THE ELECTRONIC CONTRIBUTION TO THE ELECTROSTATIC POT
!
      l = 0
      do i = 1, ncc ! TODO: to be parallelized
        do j = 1, i
          l = l + 1
          cespm(i,j) = cesp(l)
          cespm(j,i) = cesp(l)
        end do
      end do
      ipx = (npr - is_esp)/3
      ipe = is_esp + ipx
      es(:nesp) = 0.D0
      call naicas () !TODO: to be parallelized
      call naicap () !TODO: to be parallelized
!     CALCULATE TOTAL ESP AND FORM ARRAYS FOR ESPFIT
      b_esp = 0.d0
      do i = 1, nesp
        esp_array(i) = 0.D0
        do j = 1, numat
          ra = sqrt((co(1,j)-potpt(1,i))**2+(co(2,j)-potpt(2,i))**2+(co(3,j) - potpt(3,i))**2)
          esp_array(i) = esp_array(i) + tore(nat(j))/(ra/a0)
        end do
        esp_array(i) = esp_array(i) - es(i)
        do j = 1, numat
          rij = sqrt((co(1,j)-potpt(1,i))**2+(co(2,j)-potpt(2,i))**2+(co(3,j) - potpt(3,i))**2)/a0
          b_esp(j) = b_esp(j) + esp_array(i)*1.D0/rij
        end do
      end do
!
!     IF REQUESTED WRITE OUT ELECTRIC POTENTIAL DATA TO
!     UNIT 21
!
      potwrt = index(keywrd,'POTWRT') /= 0
      if (potwrt) then
        open(iesp, file=esp_fn, status='UNKNOWN', position='asis')
        write (iesp, '(I5)') nesp
        do i = 1, nesp
          write (iesp, 420) esp_array(i), potpt(1,i)/a0, potpt(2,i)/a0, potpt(3,i)/a0
        end do
        close(unit=iesp, status='KEEP')
      end if
  420 format(1x,4e16.7)
      return
      end subroutine elesn
      subroutine espfit()
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE esp_C, only : nesp, cf, co, potpt, idip, iz, dx, dy, dz, &
      & b_esp, esp_array, rms, rrms
      use common_arrays_C, only : q
      use molkst_C, only : numat
      use funcon_C, only : a0, fpc_1, fpc_8
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: k, j, i, info
      double precision ::rik, rij, espc, atmp
      integer, allocatable :: ipiv(:)
      double precision, allocatable :: a(:,:)
    !
    !.. Local Scalars ..
    integer ::  istart, iend
    cf = fpc_1 * a0 * fpc_8 * 1.d-10
     allocate (a(numat+4,numat+4))
    !
    !     THE FOLLOWING SETS UP THE LINEAR EQUATION A*Q=B
    !     SET UP THE A(J,K) ARRAY
    !


    istart = 1
    iend = nesp
    do k = 1, numat
      do j = 1, numat
        atmp = 0
        do i = istart, iend
          rik = (co(1, k) - potpt(1, i)) ** 2 &
               & + (co(2, k) - potpt(2, i)) ** 2 &
               & + (co(3, k) - potpt(3, i)) ** 2
          rij = (co(1, j) - potpt(1, i)) ** 2 &
               & + (co(2, j) - potpt(2, i)) ** 2 &
               & + (co(3, j) - potpt(3, i)) ** 2
          atmp = atmp + 1 / Sqrt (rij * rik)
        end do
        a(j, k) = atmp * a0**2
      end do
    end do
      a(numat+1, 1:numat) = 1.d0 !row
      a(numat+1:, numat+1:) = 0.d0 !corner
      a(1:numat, numat+1) = 1.d0 !column
      if (idip == 1) then
        a(numat+2:numat+4, 1:numat) = co(1:3, 1:numat) / a0
        a(1:numat, numat+2:numat+4) = Transpose (co(1:3, 1:numat) / a0)
        a(numat+2:numat+4, numat+2:numat+4) = 0.d0
      else
        a(:, numat+2:) = 0.d0
        a(numat+2:, 1:numat+1) = 0.d0
      end if
    !
    !     INSERT CHARGE AND DIPOLAR (IF DESIRED) CONSTRAINTS
    !
    b_esp(numat+1) = iz
    b_esp(numat+2) = dx / cf
    b_esp(numat+3) = dy / cf
    b_esp(numat+4) = dz / cf
    !
    if (allocated(q)) deallocate(q)
    allocate(q(numat + 4))
    q(1:numat+4) = b_esp(1:numat+4)
    !
    allocate (ipiv(numat+4))
    !
    if (idip == 1) then
      call dgesv (numat+4, 1, a, numat+4, ipiv, q, numat+4, info)
    else
      call dgesv (numat+1, 1, a, numat+4, ipiv, q, numat+4, info)
    end if
    !
    deallocate (ipiv)
    !
    !     CALCULATE ROOT MEAN SQUARE FITS AND RELATIVE ROOT MEAN SQUARE FITS
    !
    do i = 1, nesp
      espc = 0.d0
      do j = 1, numat
        rij = Sqrt ((co(1, j) - potpt(1, i)) ** 2 &
             & + (co(2, j) - potpt(2, i)) ** 2 &
             & + (co(3, j) - potpt(3, i)) ** 2) / a0
        espc = espc + q(j) / rij
      end do
      rms = rms + (espc-esp_array(i)) ** 2
      rrms = rrms + esp_array(i) ** 2
    end do
    rms = Sqrt (rms/nesp)
    rrms = rms / Sqrt (rrms/nesp)
    rms = rms * 627.51d0
  end subroutine espfit


      subroutine naicas()
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use chanel_C, only : iw, iesr, restart_fn
      use funcon_C, only : a0
      use molkst_C, only : keywrd
      use esp_C, only : cen, exsr, ex, tf, fv, iam, cc, ip, npr, fac, &
      & ncc, ipe, cespm, espi, potpt, es, dx_array, dy_array, dz_array, f1, td, &
      & u_esp, expn, rnai, ewcx, ewcy, ewcz, f0, rnai1, ipx, is_esp, isc, &
      & icd, exs, ce, indc, nesp
!***********************************************************************
      implicit none
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: ipx2, i, jstart, iesps, np, ic, ipr, istart, j, iesp, iref, k, ips, jps
      double precision :: pi, potp1, potp2, potp3, ref, res, term, f, ts, term1, fi, ts1
!-----------------------------------------------
      a0 = a0
!
!     CALCULATE DISTANCE ARRAYS
!
      write (iw, *)
      pi = 4.D0*atan(1.D0)
      ipx2 = 2*ipx
!     IF THIS IS A RESTART RUN, READ IN RESTART INFO
      if (index(keywrd,'ESPRST') /= 0) then
        open(unit=iesr, file=restart_fn, status='OLD', form=&
          'UNFORMATTED', position='asis')
        read (iesr) jstart, iesps
        if (jstart == isc*2) then
          close(iesr)
          return
        end if
        do i = 1, nesp
          read (iesr) es(i)
        end do
        close(iesr)
!
        jstart = jstart + 1
      else
        jstart = 1
      end if
      np = is_esp + 1
      do ic = jstart, isc
        ipr = ic*icd - icd + 1
        istart = ipr
        dx_array(istart:ipe) = cen(ipr,1) - cen(istart:ipe,1)
        dy_array(istart:ipe) = cen(ipr,2) - cen(istart:ipe,2)
        dz_array(istart:ipe) = cen(ipr,3) - cen(istart:ipe,3)
        td(istart:ipe) = dx_array(istart:ipe)**2 + dy_array(istart:ipe)**2 + dz_array(istart:ipe)**2
!
!     CALCULATE EXPONENT SUM
!
        do i = istart, ipe
          do j = 1, icd
            exsr(i,j) = ex(ipr+j-1) + ex(i)
            exs(i,j) = 1.D0/exsr(i,j)
            ce(i,j) = ex(ipr+j-1)*ex(i)*exs(i,j)
            expn(i,j) = exp((-ce(i,j)*td(i)))
          end do
        end do
!
!     CALCULATE EXPONENT WEIGHTED CENTERS
!
        do i = istart, ipe
          ewcx(i,:icd) = (ex(i)*cen(i,1)+ex(ipr:icd-1+ipr)*cen(ipr:icd-1+ipr,1)&
            )*exs(i,:icd)
          ewcy(i,:icd) = (ex(i)*cen(i,2)+ex(ipr:icd-1+ipr)*cen(ipr:icd-1+ipr,2)&
            )*exs(i,:icd)
          ewcz(i,:icd) = (ex(i)*cen(i,3)+ex(ipr:icd-1+ipr)*cen(ipr:icd-1+ipr,3)&
            )*exs(i,:icd)
        end do
!
!     BEGIN LOOP OVER ESP POINTS
!
        do iesp = 1, nesp
          potp1 = potpt(1,iesp)/a0
          potp2 = potpt(2,iesp)/a0
          potp3 = potpt(3,iesp)/a0
!
!     BEGIN LOOP OVER COMPONENTS OF CONTRACTED FUNCTION IC
!
          do j = 1, icd
!
!     CALCULATE DISTANCE BETWEEN EXPONENT WEIGHTED AND PROBE POINT
!
            do i = istart, ipe
              u_esp(i,j) = ((ewcx(i,j)-potp1)**2+(ewcy(i,j)-potp2)**2+(ewcz(i,j)-&
                potp3)**2)*exsr(i,j)
              rnai(i,j) = sqrt(pi/u_esp(i,j))
            end do
!
!     CALCULATE ESP INTEGRALS
!
            do i = istart, ipe
              if (u_esp(i,j) <= tf(0)) then
                iref = nint(u_esp(i,j)*20.D0)
                ref = 0.05D0*iref
                res = u_esp(i,j) - ref
                term = 1.D0
                f0(i,j) = 0.D0
                do k = 0, 6
                  f = fv(k,iref+1)
                  ts = f*term*fac(k)
                  term = -term*res
                  f0(i,j) = f0(i,j) + ts
                end do
              else
                f0(i,j) = rnai(i,j)*0.5D0
              end if
            end do
            do i = np, ipe
              if (u_esp(i,j) <= tf(1)) then
                iref = nint(u_esp(i,j)*20.D0)
                ref = 0.05D0*iref
                res = u_esp(i,j) - ref
                term1 = 1.D0
                f1(i,j) = 0.D0
                do k = 0, 6
                  fi = fv(k+1,iref+1)
                  ts1 = fi*term1*fac(k)
                  term1 = -term1*res
                  f1(i,j) = f1(i,j) + ts1
                end do
              else
                f1(i,j) = rnai(i,j)*0.25D0/u_esp(i,j)
              end if
            end do
            u_esp(istart:is_esp,j) = 2.D0*pi*exs(istart:is_esp,j)*expn(istart:is_esp,j)* &
            f0(istart:is_esp,j)
            np = is_esp + 1
            rnai(np:ipe,j) = 2.D0*pi*exs(np:ipe,j)*expn(np:ipe,j)*f0(np:ipe,j)
            rnai1(np:ipe,j) = 2.D0*pi*exs(np:ipe,j)*expn(np:ipe,j)*f1(np:ipe,j)
!
!     CALCULATE (S||P) ESP INTEGRALS
!
            if (iam(ipr,1)/=0 .or. is_esp==ip) cycle
            u_esp(np:ipe,j) = (ewcx(np:ipe,j)-cen(np:ipe,1))*rnai(np:ipe,j) - &
            (ewcx(np:ipe,j)-potp1)*rnai1(np:ipe,j)
            u_esp(ipe+1:1+ipx+ipe,j) = (ewcy(ipe+1-ipx:1+ipe,j)-cen(ipe+1-ipx:1+ipe,2))* &
            rnai(ipe+1-ipx:1+ipe,j) - (ewcy(ipe+1-ipx:1+ipe,j)-potp2)*&
              rnai1(ipe+1-ipx:1+ipe,j)
            u_esp(ipe+1+ipx:npr,j) = (ewcz(ipe+1+ipx-ipx2:npr-ipx2,j) - &
            cen(ipe+1+ipx-ipx2:npr-ipx2,3))*rnai(ipe+1+ipx-ipx2:npr-ipx2,j) - &
            (ewcz(ipe+1+ipx-ipx2:npr-ipx2,j)-potp3)*rnai1(ipe+1+ipx-ipx2:npr-ipx2,j)
          end do
          ips = ic*icd - icd + 1
          do i = ic, ncc
            jps = i*icd - icd + 1
            espi(i,ic) = 0.D0
            do j = jps, jps + icd - 1
              espi(i,ic) = espi(i,ic) + sum(cc(j)*cc(ips:icd-1+ips)*u_esp(j,:icd))
            end do
            es(iesp) = es(iesp) + 2.D0*cespm(indc(i),indc(ic))*espi(i,ic)
          end do
          es(iesp) = es(iesp) - cespm(indc(ic),indc(ic))*espi(ic,ic)
        end do
!     WRITE OUT RESTART INFORMATION
        open(unit=iesr, file=restart_fn, status='UNKNOWN', form='UNFORMATTED', position='asis')
        iesps = 0
        write (iesr) ic, iesps
        do i = 1, nesp
          write (iesr) es(i)
        end do
        close(iesr)
!
        write (iw, '(A,F6.2,A)') 'NAICAS DUMPED: ', 100.D0/isc*ic, &
          ' PERCENT COMPLETE'
      end do
      return
      end subroutine naicas


      subroutine ovlp(ic)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use esp_C, only : cen, ex, iam, cc, is_esp, ip, npr, ncc, icd, ovl, &
      &  dx_array, dy_array, dz_array, td, ce, exs, expn, rnai, ewcx, ewcy, ewcz
!***********************************************************************
      implicit none
      integer :: ic
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: ipr, istart, i, j, np, ips, jps
      double precision :: pi
!-----------------------------------------------
!
!     CALCULATE DISTANCE ARRAYS
!
      pi = 4.D0*atan(1.D0)
      ipr = ic*icd - icd + 1
      istart = ipr
      dx_array(istart:npr) = cen(ipr,1) - cen(istart:npr,1)
      dy_array(istart:npr) = cen(ipr,2) - cen(istart:npr,2)
      dz_array(istart:npr) = cen(ipr,3) - cen(istart:npr,3)
      td(istart:npr) = dx_array(istart:npr)**2 + dy_array(istart:npr)**2 + dz_array(istart:npr)**2
!
!     CALCULATE EXPONENT SUM
!
      do i = istart, npr
        exs(i,:icd) = 1.D0/(ex(ipr:icd-1+ipr)+ex(i))
        ce(i,:icd) = ex(ipr:icd-1+ipr)*ex(i)*exs(i,:icd)
!
!     CALCULATE EXPONENT WEIGHTED CENTERS
!
        ewcx(i,:icd) = (ex(i)*cen(i,1)+ex(ipr:icd-1+ipr)*cen(ipr:icd-1+ipr,1))*&
          exs(i,:icd)
        ewcy(i,:icd) = (ex(i)*cen(i,2)+ex(ipr:icd-1+ipr)*cen(ipr:icd-1+ipr,2))*&
          exs(i,:icd)
        ewcz(i,:icd) = (ex(i)*cen(i,3)+ex(ipr:icd-1+ipr)*cen(ipr:icd-1+ipr,3))*&
          exs(i,:icd)
      end do
      do i = 1, npr
        do j = 1, icd
          expn(i,j) = exp((-ce(i,j)*td(i)))
          rnai(i,j) = (pi*exs(i,j))**1.5D0*expn(i,j)
          expn(i,j) = rnai(i,j)
        end do
      end do
!
!     CALCULATE (S||P) ESP INTEGRALS
!
      if (iam(ipr,1)==0 .and. is_esp/=ip) then
        np = is_esp + 1
        do i = np, npr
          do j = 1, icd
            select case (iam(i,2))
            case default
              rnai(i,j) = (ewcx(i,j)-cen(i,1))*expn(i,j)
            case (2)
              rnai(i,j) = (ewcy(i,j)-cen(i,2))*expn(i,j)
            case (3)
              rnai(i,j) = (ewcz(i,j)-cen(i,3))*expn(i,j)
            end select
          end do
        end do
      end if
!
!     CALCULATE (P||S) ESP INTEGRALS
!
      if (iam(ipr,1)==1 .and. is_esp/=ip) then
        np = is_esp + 1
        do i = istart, npr
          do j = 1, icd
            select case (iam(ipr+j-1,2))
            case default
              rnai(i,j) = (ewcx(i,j)-cen(ipr+j-1,1))*expn(i,j)
            case (2)
              rnai(i,j) = (ewcy(i,j)-cen(ipr+j-1,2))*expn(i,j)
            case (3)
              rnai(i,j) = (ewcz(i,j)-cen(ipr+j-1,3))*expn(i,j)
            end select
          end do
        end do
        do i = istart, npr
          do j = 1, icd
            select case (iam(i,2))
            case default
              rnai(i,j) = (ewcx(i,j)-cen(i,1))*rnai(i,j)
              if (iam(ipr+j-1,2) == iam(i,2)) rnai(i,j) = rnai(i,j) + exs(i,j)*&
                0.5D0*expn(i,j)
            case (2)
              rnai(i,j) = (ewcy(i,j)-cen(i,2))*rnai(i,j)
              if (iam(ipr+j-1,2) == iam(i,2)) rnai(i,j) = rnai(i,j) + exs(i,j)*&
                0.5D0*expn(i,j)
            case (3)
              rnai(i,j) = (ewcz(i,j)-cen(i,3))*rnai(i,j)
              if (iam(ipr+j-1,2) == iam(i,2)) rnai(i,j) = rnai(i,j) + exs(i,j)*&
                0.5D0*expn(i,j)
            end select
          end do
        end do
      end if
      ips = ic*icd - icd + 1
      do i = ic, ncc
        jps = i*icd - icd + 1
        ovl(ic,i) = 0.D0
        do j = jps, jps + icd - 1
          ovl(ic,i) = ovl(ic,i) + sum(cc(j)*cc(ips:icd-1+ips)*rnai(j,:icd))
        end do
        ovl(i,ic) = ovl(ic,i)
      end do
      return
      end subroutine ovlp
      subroutine setup3
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE overlaps_C, only : allc, allz
!***********************************************************************
      implicit none
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
!-----------------------------------------------
!     SET-UP THE STEWART'S STO-3G EXPANSIONS
!     FROM J. CHEM. PHYS. 52 431.
!                                            1S
      allz(1,1,1) = 2.227660584D00
      allz(2,1,1) = 4.057711562D-01
      allz(3,1,1) = 1.098175104D-01
!
      allc(1,1,1) = 1.543289673D-01
      allc(2,1,1) = 5.353281423D-01
      allc(3,1,1) = 4.446345422D-01
!                                      2S
      allz(1,2,1) = 2.581578398D00
      allz(2,2,1) = 1.567622104D-01
      allz(3,2,1) = 6.018332272D-02
!
      allc(1,2,1) = -5.994474934D-02
      allc(2,2,1) = 5.960385398D-01
      allc(3,2,1) = 4.581786291D-01
!                                     2P
      allz(1,2,2) = 9.192379002D-01
      allz(2,2,2) = 2.359194503D-01
      allz(3,2,2) = 8.009805746D-02
!
      allc(1,2,2) = 1.623948553D-01
      allc(2,2,2) = 5.661708862D-01
      allc(3,2,2) = 4.223071752D-01
!                                      3S
      allz(1,3,1) = 5.641487709D-01
      allz(2,3,1) = 6.924421391D-02
      allz(3,3,1) = 3.269529097D-02
!
      allc(1,3,1) = -1.782577972D-01
      allc(2,3,1) = 8.612761663D-01
      allc(3,3,1) = 2.261841969D-01
!                                     3P
      allz(1,3,2) = 2.692880368D00
      allz(2,3,2) = 1.489359592D-01
      allz(3,3,2) = 5.739585040D-02
!
      allc(1,3,2) = -1.061945788D-02
      allc(2,3,2) = 5.218564264D-01
      allc(3,3,2) = 5.450015143D-01
!                                      4S
      allz(1,4,1) = 2.267938753D-01
      allz(2,4,1) = 4.448178019D-02
      allz(3,4,1) = 2.195294664D-02
!
      allc(1,4,1) = -3.349048323D-01
      allc(2,4,1) = 1.056744667D00
      allc(3,4,1) = 1.256661680D-01
!                                     4P
      allz(1,4,2) = 4.859692220D-01
      allz(2,4,2) = 7.430216918D-02
      allz(3,4,2) = 3.653340923D-02
!
      allc(1,4,2) = -6.147823411D-02
      allc(2,4,2) = 6.604172234D-01
      allc(3,4,2) = 3.932639495D-01
!                                      5S
      allz(1,5,1) = 1.080198458D-01
      allz(2,5,1) = 4.408119382D-02
      allz(3,5,1) = 2.610811810D-02
!
      allc(1,5,1) = -6.617401158D-01
      allc(2,5,1) = 7.467595004D-01
      allc(3,5,1) = 7.146490945D-01
!                                     5P
      allz(1,5,2) = 2.127482317D-01
      allz(2,5,2) = 4.729648620D-02
      allz(3,5,2) = 2.604865324D-02
!
      allc(1,5,2) = -1.389529695D-01
      allc(2,5,2) = 8.076691064D-01
      allc(3,5,2) = 2.726029342D-01
!
      return
      end subroutine setup3

!****************************************************************
      double precision function dex2 (m)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: m
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i
!-----------------------------------------------
      if (m < 2) then
        dex2 = 1
      else
        dex2 = 1
        do i = 1, m, 2
          dex2 = dex2*i
        end do
      end if
      return
      end function dex2

!***********************************************************************
      subroutine fsub(n, x, fval)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n
      double precision , intent(in) :: x
      double precision , intent(out) :: fval
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: ku, k, i
      double precision, dimension(21) :: ff
      double precision, dimension(200) :: term
      double precision :: a0, a1s2, pie4, a1, xsw, e, fac0, fact, term0, sum, suma, &
        sum1
!-----------------------------------------------
!***********************************************************************
!
!     CALCULATE THE FM(T). KINDLY SUPPLIED BY RUS PITZER AND CLEANED UP
!     BY K.M.MERZ IN FEB. 1989 AT UCSF.
!
!     ON INPUT:  N = INDEX
!                X = EXPONENT
!     ON OUTPUT: FVAL = VALUE OF THE FUNCTION
!
!     FOR MORE DETAILS SEE: OBARA AND SAIKA J. CHEM. PHYS. 1986,84,3963
!***********************************************************************
      data a0, a1s2, pie4, a1/ 0.0D0, 0.5D0, 0.7853981633974483096156608D0, &
        1.0D0/
      data xsw/ 24.0D0/
      e = a1s2*exp((-x))
      fac0 = n
      fac0 = fac0 + a1s2
      if (x > xsw) go to 50
!
!     USE POWER SERIES
!
   10 continue
      fact = fac0
      term0 = e/fact
      sum = term0
      ku = int(x - fac0)
      if (ku >= 1) then
!
!     SUM INCREASING TERMS FORWARDS
!
        do k = 1, ku
          fact = fact + a1
          term0 = term0*x/fact
          sum = sum + term0
        end do
      end if
      i = 1
      fact = fact + a1
      term(1) = term0*x/fact
      suma = sum + term(1)
      if (Abs(sum - suma) < 1.d-20) go to 90
      i = i + 1
      fact = fact + a1
      term(i) = term(i-1)*x/fact
      sum1 = suma
      suma = suma + term(i)
      do while(sum1 - suma /= 0.D0)
        i = i + 1
        fact = fact + a1
        term(i) = term(i-1)*x/fact
        sum1 = suma
        suma = suma + term(i)
      end do
      go to 90
!
!     USE ASYMPTOTIC SERIES
!
   50 continue
      sum = sqrt(pie4/x)
      if (n /= 0) then
        fact = -a1s2
        do k = 1, n
          fact = fact + a1
          sum = sum*fact/x
        end do
      end if
      i = 1
      term(1) = -e/x
      suma = sum + term(1)
      if (Abs(sum - suma) < 1.d-20) go to 90
      fact = fac0
      ku = int(x + fac0 - a1)
      do i = 2, ku
        fact = fact - a1
        term(i) = term(i-1)*fact/x
        sum1 = suma
        suma = suma + term(i)
        if (Abs(sum - suma) < 1.d-20) go to 90
      end do
!
!     XSW SET TOO LOW. USE POWER SERIES.
!
      go to 10
!
!     SUM DECREASING TERMS BACKWARDS
!
   90 continue
      sum1 = a0
      do k = 1, i
        sum1 = sum1 + term(i+1-k)
      end do
      ff(n+1) = sum + sum1
!
!     USE RECURRENCE RELATION
!
      if (n /= 0) then
        do k = 1, n
          fac0 = fac0 - a1
          ff(n+1-k) = (e + x*ff(n+2-k))/fac0
        end do
      end if
      fval = ff(n+1)
      return
      end subroutine fsub

!****************************************************************
      subroutine naicap()
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use funcon_C, only : a0
      use chanel_C, only : iw, iesr, esr_fn
      use esp_C, only : cen, ex, tf, fv, iam, cc, isc, is_esp, ip, npr, ncc, ipe, &
      & ipx, icd, cespm, espi, potpt, es, rnai, rnai2, pf0, pf1, pf2, fac, &
      & pexs, pce, pexpn, ptd, pewcx, pewcy, pewcz, ird, indc, nesp
      use molkst_C, only : keywrd
!***********************************************************************
      implicit none

!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer,  allocatable, dimension (:) :: id
      integer :: idn, idc, ipx2, np, i, l, j, jstart, iesps, iesp, il&
        , iref, k, ic, ipr, istart, in, ir, ir2, ips, jps, mptd
      double precision :: pi, potp1, potp2, potp3, ref, res, term, f, ts, &
        term1, fi, ts1, term2, fii, ts2
!-----------------------------------------------
      idn = 10
      mptd = ((ipe - is_esp)*(ipe - is_esp + 1))/2
      allocate(id(ipe - is_esp))
      allocate (pf0(mptd), pf1(mptd), pf2(mptd), pexs(mptd), pce(mptd), &
         & pexpn(mptd), ptd(mptd), pewcx(mptd), pewcy(mptd), pewcz(mptd))
!
      idc = 0
      write (iw, *)
      ipx2 = 2*ipx
      pi = 4.D0*atan(1.D0)
      np = is_esp + 1
!     SETUP INDEX ARRAY
      do i = np, ipe
        ird(i) = i - is_esp
        ird(i+ipx) = i - is_esp
        ird(i+ipx2) = i - is_esp
      end do
!
!     CALCULATE QUANTITIES INVARIANT WITH ESP POINT FOR
!     (P|P) ESP INTEGRALS
!
!      IL=L
      l = 0
      do i = np, ipe
        do j = i, ipe
          l = l + 1
          ptd(l) = (cen(i,1)-cen(j,1))**2 + (cen(i,2)-cen(j,2))**2 + (cen(i,3)-&
            cen(j,3))**2
          pexs(l) = 1.D0/(ex(i)+ex(j))
          pce(l) = ex(i)*ex(j)*pexs(l)
          pexpn(l) = exp((-pce(l)*ptd(l)))
          pewcx(l) = (ex(i)*cen(i,1)+ex(j)*cen(j,1))*pexs(l)
          pewcy(l) = (ex(i)*cen(i,2)+ex(j)*cen(j,2))*pexs(l)
          pewcz(l) = (ex(i)*cen(i,3)+ex(j)*cen(j,3))*pexs(l)
        end do
!
!     SET UP OTHER INDEX ARRAY FOR PACKED SYMMETRIC ARRAY
!     STORAGE
!
        id(i-is_esp) = l - ipx
      end do
!
!     READ IN RESTART INFORMATION IF THIS IS A RESTART
!
      if (index(keywrd,'ESPRST') /= 0) then
        open(unit=iesr, file=esr_fn, status='UNKNOWN', form=&
          'UNFORMATTED', position='asis')
        read (iesr) jstart, iesps
        if (jstart /= isc*2) then
          iesps = 0
          close(iesr)
          go to 50
        end if
        do i = 1, nesp
          read (iesr) es(i)
        end do
        close(iesr)
        idc = int((iesps/float(nesp))*10)
      else
        iesps = 0
      end if
   50 continue
      do iesp = iesps + 1, nesp
        potp1 = potpt(1,iesp)/a0
        potp2 = potpt(2,iesp)/a0
        potp3 = potpt(3,iesp)/a0
!     CALCULATE QUANTITY U
!
        l = 0
        do i = np, ipe
          do j = i, ipe
            l = l + 1
            ptd(l) = ((pewcx(l)-potp1)**2+(pewcy(l)-potp2)**2+(pewcz(l)-potp3)**2)/pexs(l)
            pce(l) = sqrt(pi/ptd(l))
          end do
        end do
!
!     CALCULATE F0, F1, AND F2(U) USING TAYLOR SERIES
!     OR ASYMPTOTIC EXPANSION
!
        il = l
        l = 0
        do i = 1, il
          if (ptd(i) <= tf(0)) then
            iref = nint(ptd(i)*20.D0)
            ref = 0.05D0*iref
            res = ptd(i) - ref
            term = 1.D0
            pf0(i) = 0.D0
            do k = 0, 6
              f = fv(k,iref+1)
              ts = f*term*fac(k)
              term = -term*res
              pf0(i) = pf0(i) + ts
            end do
          else
            pf0(i) = pce(i)*0.5D0
          end if
          if (ptd(i) <= tf(1)) then
            iref = nint(ptd(i)*20.D0)
            ref = 0.05D0*iref
            res = ptd(i) - ref
            term1 = 1.D0
            pf1(i) = 0.D0
            do k = 0, 6
              fi = fv(k+1,iref+1)
              ts1 = fi*term1*fac(k)
              term1 = -term1*res
              pf1(i) = pf1(i) + ts1
            end do
          else
            pf1(i) = pce(i)*0.25D0/ptd(i)
          end if
          if (ptd(i) <= tf(2)) then
            iref = nint(ptd(i)*20.D0)
            ref = 0.05D0*iref
            res = ptd(i) - ref
            term2 = 1.D0
            pf2(i) = 0.D0
            do k = 0, 6
              fii = fv(k+2,iref+1)
              ts2 = fii*term2*fac(k)
              term2 = -term2*res
              pf2(i) = pf2(i) + ts2
            end do
          else
            pf2(i) = pce(i)*0.375D0/(ptd(i)*ptd(i))
          end if
        end do
!
!     CALCULATE (S||S) TYPE INTEGRALS
!
        pf0(:il) = 2.D0*pi*pexs(:il)*pexpn(:il)*pf0(:il)
        ptd(:il) = pf0(:il)
        pf1(:il) = 2.D0*pi*pexs(:il)*pexpn(:il)*pf1(:il)
        pf2(:il) = 2.D0*pi*pexs(:il)*pexpn(:il)*pf2(:il)
!
        do ic = isc + 1, ncc
          ipr = ic*icd - icd + 1
          istart = ipr
          do j = 1, icd
!
!     CALCULATE (P||S) ESP INTEGRALS
!
            if (iam(ipr,1)==1 .and. is_esp/=ip) then
              do i = istart, npr
                in = ipr + j - 1
                ir = ird(i) + id(ird(in))
                ir2 = id(ird(i)) + ird(in)
                ir = min0(ir2,ir)
                select case (iam(in,2))
                case default
                  rnai2(i,j) = (pewcx(ir)-cen(in,1))*pf1(ir) - pf2(ir)*(pewcx(ir)-potp1)
                  rnai(i,j) = (pewcx(ir)-cen(in,1))*pf0(ir) - pf1(ir)*(pewcx(ir)-potp1)
                case (2)
                  rnai2(i,j) = (pewcy(ir)-cen(in,2))*pf1(ir) - pf2(ir)*(pewcy(ir)-potp2)
                  rnai(i,j) = (pewcy(ir)-cen(in,2))*pf0(ir) - pf1(ir)*(pewcy(ir)-potp2)
                case (3)
                  rnai2(i,j) = (pewcz(ir)-cen(in,3))*pf1(ir) - pf2(ir)*(pewcz(ir)-potp3)
                  rnai(i,j) = (pewcz(ir)-cen(in,3))*pf0(ir) - pf1(ir)*(pewcz(ir)-potp3)
                end select
              end do
            end if
!
!     CALCULATE (P||P) ESP INTEGRALS
!
            if (iam(ipr,1)/=1 .or. is_esp==ip) cycle
            do i = istart, npr
              in = ipr + j - 1
              ir = ird(i) + id(ird(in))
              ir2 = id(ird(i)) + ird(in)
              ir = min0(ir2,ir)
              select case (iam(i,2))
              case default
                rnai(i,j) = (pewcx(ir)-cen(i,1))*rnai(i,j) - (pewcx(ir)-potp1)*rnai2(i,j)
                if (iam(in,2) == iam(i,2)) rnai(i,j) = rnai(i,j) + pexs(ir)*0.5D0*(ptd(ir)-pf1(ir))
              case (2)
                rnai(i,j) = (pewcy(ir)-cen(i,2))*rnai(i,j) - (pewcy(ir)-potp2)*rnai2(i,j)
                if (iam(in,2) == iam(i,2)) rnai(i,j) = rnai(i,j) + pexs(ir)*0.5D0*(ptd(ir)-pf1(ir))
              case (3)
                rnai(i,j) = (pewcz(ir)-cen(i,3))*rnai(i,j) - (pewcz(ir)-potp3)*rnai2(i,j)
                if (iam(in,2) == iam(i,2)) rnai(i,j) = rnai(i,j) + pexs(ir)*0.5D0*(ptd(ir)-pf1(ir))
              end select
            end do
          end do
!
!     FORM INTEGRALS OVER CONTRACTED FUNCTIONS
!
          ips = ic*icd - icd + 1
          do i = ic, ncc
            jps = i*icd - icd + 1
            espi(i,ic) = 0.D0
            do j = jps, jps + icd - 1
              espi(i,ic) = espi(i,ic) + sum(cc(j)*cc(ips:icd-1+ips)*rnai(j,:icd))
            end do
            es(iesp) = es(iesp) + 2.D0*cespm(indc(i),indc(ic))*espi(i,ic)
          end do
          es(iesp) = es(iesp) - cespm(indc(ic),indc(ic))*espi(ic,ic)
        end do
!
!     WRITE OUT RESTART INFORMATION EVERY NESP/10 POINTS
!
        if (mod(iesp,nesp/idn) /= 0) cycle
        open(unit=iesr, file=esr_fn, status='UNKNOWN', form=&
          'UNFORMATTED', position='asis')
        jstart = isc*2
        write (iesr) jstart, iesp
        do i = 1, nesp
          write (iesr) es(i)
        end do
        close(iesr)
        idc = idc + 1
        write (iw, '(A,F6.2,A)') 'NAICAP DUMPED: ', 100.D0/idn*idc, &
          ' PERCENT COMPLETE'
      end do
      deallocate(id, pf0, pf1, pf2, pexs, pce, pexpn, ptd, pewcx, pewcy, pewcz)
      return
      end subroutine naicap
  subroutine setup_esp(mode)
    use esp_C, only : ind, itemp, ird, iam, cc, ex, temp, rad, es, &
      & b_esp, esp_array, cesp, cespml, al, qesp, td, dx_array, dy_array, dz_array, &
      & cespm, cen, fc, co, indc, &
      & potpt, ovl, cespm2, a2, exs, ce, expn, ewcx, ewcy, ewcz, f0, f1, u_esp, &
      & rnai, rnai1, rnai2, espi,  exsr, qsc
    use molkst_C, only : norbs, numat
    implicit none
    integer :: i, mode
    integer, parameter :: mesp=5000
    if (mode == 1) then
      i = 6*norbs
      if (allocated(a2))        deallocate(a2)
      if (allocated(ovl))       deallocate(ovl)
      if (allocated(cespm2))    deallocate(cespm2)
      if (allocated(cespml))    deallocate(cespml)
      if (allocated(cesp))      deallocate(cesp)
      if (allocated(potpt))     deallocate(potpt)
      if (allocated(es))        deallocate(es)
      if (allocated(co))        deallocate(co)
      if (allocated(al))        deallocate(al)
      if (allocated(rad))       deallocate(rad)
      if (allocated(b_esp))     deallocate(b_esp)
      if (allocated(qesp))      deallocate(qesp)
      if (allocated(cespm))     deallocate(cespm)
      if (allocated(cc))        deallocate(cc)
      if (allocated(cen))       deallocate(cen)
      if (allocated(iam))       deallocate(iam)
      if (allocated(ind))       deallocate(ind)
      if (allocated(ex))        deallocate(ex)
      if (allocated(temp))      deallocate(temp)
      if (allocated(f0))        deallocate(f0)
      if (allocated(f1))        deallocate(f1)
      if (allocated(ce))        deallocate(ce)
      if (allocated(u_esp))     deallocate(u_esp)
      if (allocated(exs))       deallocate(exs)
      if (allocated(expn))      deallocate(expn)
      if (allocated(cesp))      deallocate(cesp)
      if (allocated(rnai))      deallocate(rnai)
      if (allocated(ewcx))      deallocate(ewcx)
      if (allocated(ewcy))      deallocate(ewcy)
      if (allocated(ewcz))      deallocate(ewcz)
      if (allocated(rnai1))     deallocate(rnai1)
      if (allocated(rnai2))     deallocate(rnai2)
      if (allocated(fc))        deallocate(fc)
      if (allocated(exsr))      deallocate(exsr)
      if (allocated(indc))      deallocate(indc)
      if (allocated(itemp))     deallocate(itemp)
      if (allocated(dx_array))  deallocate(dx_array)
      if (allocated(dy_array))  deallocate(dy_array)
      if (allocated(dz_array))  deallocate(dz_array)
      if (allocated(td))        deallocate(td)
      if (allocated(esp_array)) deallocate(esp_array)
      if (allocated(qsc))       deallocate(qsc)
      if (allocated(espi))      deallocate(espi)
      if (allocated(ird))       deallocate(ird)
      allocate(a2((numat+4), (numat+4)), ovl(norbs, norbs), cespm2(norbs, norbs), cespml(norbs**2), &
      & cesp(norbs**2), potpt(3, mesp), es(mesp), co(3,numat), al((numat+4)**2),  &
      & rad(numat), b_esp(numat+4), qesp(numat+4), cespm(norbs, norbs))
      allocate( cc(i), cen(i,3), iam(i,2), ind(i), ex(i), temp(i), f0(i,6), &
      & f1(i,6), ce(i,6), u_esp(i,6), exs(i,6), expn(i,6), rnai(i,6), ewcx(i,6), ewcy(i,6), &
      & ewcz(i,6), rnai1(i,6), rnai2(i,6), fc(36*norbs), exsr(i,6), indc(norbs))
      allocate( itemp(i), dx_array(i), dy_array(i), dz_array(i), td(i), esp_array(mesp), &
      & qsc(numat), espi(norbs, norbs), &
      & ird(i))
       es = 1.d9
       a2 = 1.d9
       ovl = 1.d9
       cespm2 = 1.d9
       cesp = 1.d9
       potpt = 0.d0
       co = 1.d9
       al = 1.d9
       rad = 1.d9
       b_esp = 1.d9
       qesp = 1.d9
       cespm = 1.d9
       cc = 1.d9
       rnai1 = 0.d0


    end if
    end subroutine setup_esp
     subroutine getattrib(xmin, xmax)
    !-----------------------------------------------
    !   M o d u l e s
    !-----------------------------------------------
          use molkst_C, only : numat, natoms
          use common_arrays_C, only : geo, coord, labels, nat
          use esp_C, only : nesp, co
          use chanel_C, only : iw
    !
    !     ROUTINE TO CALCULATE WILLIAMS SURFACE
    !
    !***********************************************************************
    !-----------------------------------------------
    !   I n t e r f a c e   B l o c k s
    !-----------------------------------------------
          implicit none
        !.. Formal Arguments ..
          double precision, dimension (3), intent (out) :: xmin
          double precision, dimension (3), intent (out) :: xmax
    !-----------------------------------------------
    !   L o c a l   V a r i a b l e s
    !-----------------------------------------------
          integer :: icntr, i, j, ia
          double precision, dimension(53) :: vderw
          double precision :: shell, vdmax
    !-----------------------------------------------
    !
          data vderw/ 53*0.0D0/
          vderw(1) = 2.4D0
          vderw(5) = 3.0D0
          vderw(6) = 2.9D0
          vderw(7) = 2.7D0
          vderw(8) = 2.6D0
          vderw(9) = 2.55D0
          vderw(15) = 3.1D0
          vderw(16) = 3.05D0
          vderw(17) = 3.0D0
          vderw(35) = 3.15D0
          vderw(53) = 3.35D0
          shell = 1.2D0
          nesp = 0
    !     CHECK IF VDERW IS DEFINED FOR ALL ATOMS
    !
    !     CONVERT INTERNAL TO CARTESIAN COORDINATES
    !
          call gmetry (geo, coord)
    !
    !     STRIP COORDINATES AND ATOM LABEL FOR DUMMIES (I.E. 99)
    !
          icntr = 0
          do i = 1, natoms
            co(:,i) = coord(:,i)
            if (labels(i) == 99) cycle
            icntr = icntr + 1
            nat(icntr) = labels(i)
          end do
          numat = icntr
    !
          do i = 1, numat
            j = nat(i)
            if (vderw(j) == 0.0D0) go to 40
          end do
          go to 50
       40 continue
          write (iw, *) 'VAN DER WAALS'' RADIUS NOT DEFINED FOR ATOM', i
          write (iw, *) 'IN WILLIAMS SURFACE ROUTINE PDGRID!'
          call mopend (&
          'VAN DER WAALS'' RADIUS NOT DEFINED FOR ATOM IN WILLIAMS SURFACE ROUTINE PDGRID!')
          return
    !     NOW CREATE LIMITS FOR A BOX
       50 continue
          xmin = 100000.0D0
          xmax = -100000.0D0
          do ia = 1, numat
            where (co(:,ia) - xmin < 0.D0)
              xmin = co(:,ia)
            end where
            where (co(:,ia) - xmax > 0.D0)
              xmax = co(:,ia)
            end where
          end do
    !     ADD (OR SUBTRACT) THE MAXIMUM VDERW PLUS SHELL
          vdmax = 0.0D0
          vdmax = dmax1(maxval(vderw),vdmax)
          xmin = xmin - vdmax - shell
          xmax = xmax + vdmax + shell
    end subroutine getattrib

    subroutine espplane(iplane, xmin, step, ngridpts2, ngridpts3)
      use esp_C, only : nesp, potpt
      !
      !.. Implicit Declarations ..
      implicit none
      !
      !.. Formal Arguments ..
      integer :: iplane, ngridpts2, ngridpts3
      double precision, dimension (3), intent (in) :: xmin, step
      !
      !.. Local Scalars ..
      integer :: ix, iy
      double precision :: ygrid, zgrid

      if (nesp == 0) then
          do iy = 1, ngridpts2
              ygrid = xmin(2) + step(2) * (iy - 1)
              do ix = 1, ngridpts3
                  nesp = nesp + 1
                  potpt(1, nesp) = xmin(1) + step(1) * (ix - 1)
                  potpt(2, nesp) = ygrid
              end do
          end do
      end if

      zgrid = xmin(3) + step(3) * (iplane - 1)
      do ix = 1, nesp
          potpt(3, ix) = zgrid
      end do
    end subroutine espplane

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine ef (xparam, funct)
    use Common_arrays_C, only: geo, loc, hesinv, grad, atmass, nc
    use molkst_C, only: nvar, numcal, last, gnorm, iflepo, line, &
       & tleft, numat, ndep, time0, tdump, natoms, id, keywrd, moperr
    use chanel_C, only: iw0, iw, ilog, log, input_fn
    use ef_C, only: nstep, negreq, iprnt, ef_mode, ddx, xlamd, &
       & xlamd0, skal, rmin, rmax
    use maps_C, only : latom
    implicit none
    double precision, dimension (nvar), intent (inout) :: xparam
    double precision, intent (inout) :: funct
   !
   !*********************************************************************
   !
   !  EF IS A QUASI NEWTON RAPHSON OPTIMIZATION ROUTINE BASED ON
   !     JACK SIMONS P-RFO ALGORITHM AS IMPLEMENTED BY JON BAKER
   !     (J.COMP.CHEM. 7, 385). STEP SCALING TO KEEP LENGTH WITHIN
   !     TRUST RADIUS IS TAKEN FROM CULOT ET AL. (THEO. CHIM. ACTA 82, 189)
   !     THE TRUST RADIUS CAN BE UPDATED DYNAMICALLY ACCORDING TO FLETCHER
   !     SAFEGUARDS ON VALID STEP FOR TS SEARCHES BASED ON ACTUAL/PREDICTED
   !     FUNCTION CHANGE AND CHANGE IN TS MODE ARE OWN MODIFICATIONS
   !
   !  ON ENTRY XPARAM = VALUES OF PARAMETERS TO BE OPTIMISED.
   !           NVAR   = NUMBER OF PARAMETERS TO BE OPTIMISED.
   !
   !  ON EXIT  XPARAM = OPTIMISED PARAMETERS.
   !           FUNCT  = HEAT OF FORMATION IN KCAL/MOL.
   !
   !  CURRENT VERSION IMPLEMENTING COMBINED NR, P-RFO AND QA ALGORITHM
   !      TOGETHER WITH THRUST RADIUS UPDATE AND STEP REJECTION WAS
   !      MADE OCTOBER 1992 BY F.JENSEN, ODENSE, DK
   !
   !*********************************************************************
    character :: txt
    logical :: lorjk, lrjk, lts, old, l_geo_ok
    logical, save :: let, lupd, scf1, newhes, saddle, rrscal, first_time, donr
    integer, save :: icalcn = 0, igthes = 0, ihess, iloop, ireclc, &
         & iupd = 0, ldump, mxstep, ntime
!
    integer :: i, ij, imode, instep, itry1, ittest, j, k, l, neg, &
         & nflush, ih
    integer, dimension (9) :: ipow
    integer, dimension (:), allocatable :: best_nc
!
    double precision, parameter :: demin = 1.0d-2, gmin = 5.0d0, &
         & one = 1.d0, two = 2.d0,  three = 3.0d0, four = 4.d0, &
         & zero = 0.d0, pt5 = 0.5d0, pt75 = 0.75d0, tmone = 1.0d-1, &
         & tmtwo = 1.0d-2, tmsix = 1.0d-06
    double precision :: ss, absmin, deact, depre, dtmp, &
         & olde, ratio, tprt, tstep, tt0, xtmp, rmx, best_funct, &
         & best_gnorm, cosine, cos_const
    double precision, save :: time1, time2, tol2, dmax, ddmin, ddmax, &
           t_hess1, t_hess2
    double precision, save :: odmax = 0.d0, oolde = 0.d0,  odd = 0.d0
    double precision, dimension(:), allocatable :: pmat, u, hessc, eigval, &
         & tvec, svec, fx, oldfx, oldeig, ooldf, oldf, d, vmode
    double precision, dimension(:), allocatable :: x, rm, dx, best_xparam, &
           best_grad
    double precision, dimension(:,:), allocatable :: p, coord
    double precision, dimension(:,:), allocatable, save :: bmat
    double precision, external :: ddot, seconds
!

    intrinsic Abs, Index, Int, Max, Min, Mod, Sqrt
    i = 0
   !
   !   Create temporary arrays
   !
    ih = (nvar*(nvar+1)) / 2
    if (nvar < 7996) then
      allocate (pmat(nvar**2), bmat(nvar, nvar), u(nvar**2), hessc(ih), &
         & eigval(nvar), tvec(nvar), svec(nvar), fx(nvar), oldfx(nvar), &
         & oldeig(nvar), ooldf(nvar), oldf(nvar), d(nvar), vmode(nvar), &
         & best_xparam(nvar), best_grad(nvar), best_nc(natoms), stat=i)
    end if
    if (nvar > 7995 .or. i /= 0) then
      if (index(keywrd, " TS") /= 0) then
        call mopend("Insufficient memory to run TS")
      else
        call mopend("Insufficient memory to run EF")
        write(iw,'(6x,a)') " ", &
        "The L-BFGS geometry optimizer uses less memory", &
        "To use the L-BFGS geometry optimizer, add LBFGS to the keyword line", " "
      end if
      return
    end if
    tstep = 0.d0
    pmat(:) = 0.d0
    bmat(:,:) = 0.d0
    u(:) = 0.d0
    hessc(:) = 0.d0
    eigval(:) = 0.d0
    tvec(:) = 0.d0
    svec(:) = 0.d0
    fx(:) = 0.d0
    oldfx(:) = 0.d0
    oldeig(:) = 0.d0
    ooldf(:) = 0.d0
    oldf(:) = 0.d0
    d(:) = 0.d0
    vmode(:) = 0.d0
    best_xparam(:) = 0.d0
    best_grad(:) = 0.d0
    best_nc(:) = 0
    best_funct = 1.d10
    best_gnorm = 1.d10
   !
   !     GET ALL INITIALIZATION DATA
   !
    cos_const = 1.d0
    ihess = 0
    nstep = 0
    ipow(:) = 0
    if (allocated(hesinv)) then
      i = size(hesinv)
    else
      i = 0
    end if
    l_geo_ok = (index(keywrd, " GEO-OK") /= 0)
    if (icalcn /= numcal .or. nvar*nvar /= i) then
      newhes = .true.
      old = (index(keywrd, " OLD_HESS") /= 0)
      if (old) then
        old = allocated(hesinv)
        if ( .not. old) then
          write(line,"(a)") " OLD_HESS requested, but old Hessian is missing"
          write(iw,'(//10x,a,//)')trim(line)
          call mopend(trim(line))
        end if
        if (old) then
          old = (nvar*nvar == size(hesinv))
          if ( .not. old) then
            write(line,"(a)") " OLD_HESS requested, but old Hessian is of a different size"
            write(iw,'(//10x,a,//)')trim(line)
            call mopend(trim(line))
          end if
        end if
        if ( .not. old) then
          if (allocated(bmat)) deallocate(bmat)
          return
        end if
      end if
      if (.not. old) then
        if (allocated(hesinv)) deallocate(hesinv)
        allocate (hesinv(nvar*nvar))
        hesinv = 0.0D00
      end if
      call efstr (xparam, funct, ihess, ntime, iloop, igthes, mxstep, &
           & ireclc, iupd, dmax, ddmax, ddmin, tol2, time1, time2, nvar, &
           & scf1, lupd, ldump, rrscal, donr, hesinv, pmat, bmat, grad, &
           & oldf, d, vmode)
      if (moperr) go to 1100
      if (old) iloop = -1
      let = (Index (keywrd, " LET") /= 0)
      saddle = (Index (keywrd, " SADDLE") /= 0)
      first_time = .true.
    else
      first_time = (latom /= 0)
    end if
   !
   !  Assume that this is the last SCF, so that if geometry is optimized
   !  then the results will be OK.
   !
    last = 1
    do i = 1, nvar
      grad(i) = 0.d0
    end do
    time1 = seconds(1)
    call compfg (xparam, .true., funct, .true., grad, .true.)
    if (moperr) then
      go to 1100
    end if
    olde = funct
    nflush = 1
    absmin = 1.d9
    itry1 = 0
    lts = .false.
    if (negreq == 1) then
      lts = .true.
    end if
    lorjk = .false.
    if (scf1) then
      gnorm = dSqrt (ddot(nvar, grad, 1,grad, 1))
      iflepo = 1
      go to 1100
    end if
!     CHECK THAT GEOMETRY IS NOT ALREADY OPTIMIZED
    rmx = dSqrt (ddot(nvar, grad, 1, grad, 1))
!
    if (rmx < tol2) then
      iflepo = 2
      last = 1
      icalcn = numcal
      write (iw, '(/, 5 x, "GRADIENT =", f9.5, " IS LESS THAN CUTOFF =", f9.5,//)') rmx, tol2
      go to 1030
    end if
   !
   !  geometry is not optimized, so set LAST non-zero
   !
    last = 0
   !     GET INITIAL HESSIAN. IF ILOOP IS .LE.0 THIS IS AN OPTIMIZATION
   !     RESTART AND HESSIAN SHOULD ALREADY BE AVAILABLE
    t_hess1 = seconds(1)
    if (newhes .and. iloop > 0) then
      call gethes (xparam, igthes, iloop, hesinv, pmat, bmat, grad, &
           & geo, loc, oldf, d, vmode, funct)
      if (moperr) then
        go to 1100
      end if
      newhes = .false.
    end if
    t_hess2 = seconds(1)
    icalcn = numcal
   !     START OF MAIN LOOP
   !     WE NOW HAVE THE GRADIENT AND A HESSIAN. IF THIS IS THE FIRST
   !     TIME THROUGH DON'T UPDATE THE HESSIAN. FOR LATER LOOPS ALSO
   !     CHECK IF WE NEED TO RECALCULATE THE HESSIAN
    iflepo = 0
    funct = olde
    do
      !     STORE VARIOUS THINGS FOR POSSIBLY OMIN REJECTION
      do i = 1, nvar
        oldfx(i) = fx(i)
        ooldf(i) = oldf(i)
        oldeig(i) = eigval(i)
        do j = 1, nvar
          bmat(i, j) = hesinv(i + (j-1)*nvar)
          pmat(i + (j-1)*nvar) = u(i + (j-1)*nvar)
        end do
      end do
      if (ihess >= ireclc .and. iflepo /= 15) then
        iloop = 1
        ihess = 0
        if (igthes /= 3) then
          igthes = 1
        end if
        call gethes (xparam, igthes, iloop, hesinv, pmat, bmat, grad, &
             & geo, loc, oldf, d, vmode, funct)
        if (moperr) then
          go to 1100
        end if
      end if
      if (ihess > 0) then
        call updhes (svec, tvec, grad, nvar, iupd, hesinv, oldf, d)
      end if
      if (iprnt >= 2) then
        call geout (iw)
      end if
      if (iprnt >= 2) then
        write (iw, "(' XPARAM ')")
        write (iw, "(5(2I3,F10.4))") (loc(1, i), loc(2, i), xparam(i), i=1, &
       & nvar)
        write (iw, "(' grad')")
        write (iw, "(3X,8F11.5)") (grad(i), i=1, nvar)
      end if
      !
      !        PRINT RESULTS IN CYCLE
      gnorm = dSqrt (ddot(nvar, grad, 1, grad, 1))
!
      time2 = seconds (2)
      tstep = time2 - time1
      if (tstep < zero) then
        tstep = zero
      end if
      tleft = tleft - tstep
      if (tleft < 0.0d0) then
        tleft = -0.1d0
      end if
      time1 = time2
!
!  The following construction is designed to delete the time required for building the Hessian
!  from the time of the cycle.  This prevents the time for building the Hessian from distorting
!  the cycle time.
!
      if (tleft < (tstep - (t_hess2 - t_hess1))*two) go to 1030
      call prttim (tleft, tprt, txt)
      if ( .not. saddle .and. tstep > 0.5d0 .or. first_time) then
        if (ldump == 0) then
          if (id == 3) then
            call write_cell(iw)
            call write_cell(iw0)
          end if
          write (line, '(" CYCLE:", i6, " TIME:", f8.3, " TIME LEFT:", &
                & f6.2, a1, "  GRAD.:", f10.3, " HEAT:", g14.7)') &
                nstep + 1, Min (tstep, 9999.99d0), tprt, txt, &
                & Min (gnorm, 999999.999d0), funct
          write(iw,"(a)")line(:len_trim(line))
          if (mod(nstep + 1,30) == 0) then
            line = trim(input_fn)
            call add_path(line)
            i = len_trim(line) - 5
          call to_screen(line(:i))
        end if
          endfile (iw)
          backspace (iw)
          if (log) write (ilog, "(a)")line(:len_trim(line))
          call to_screen(line)
        end if
        if (nflush /= 0) then
          if (Mod(nstep+1, nflush) == 0) then
              endfile (iw)
              backspace (iw)
            if (log) then
              endfile (ilog)
              backspace (ilog)
            end if
          end if
        end if
      else
        if (id == 3) then
          call write_cell(iw)
          call write_cell(iw0)
        end if
        write (line, '(" RESTART FILE WRITTEN,      TIME LEFT:", f6.2, &
        & a1, "  GRAD.:", f10.3, " HEAT:", g14.7)') &
        tprt, txt, Min (gnorm, 999999.999d0), funct
        write(iw,"(a)")line(:len_trim(line))
        call to_screen(line)
        endfile (iw)
        backspace (iw)
        if (log) then
          write (ilog, '(" RESTART FILE WRITTEN,      TIME LEFT:", f6.2, &
        & a1, "  GRAD.:", f10.3, " HEAT:", g14.7)', err=1000) &
        tprt, txt, Min (gnorm,999999.999d0), funct
        end if
        if (nflush /= 0) then
          if (Mod(nstep+1, nflush) == 0) then
              endfile (iw)
              backspace (iw)
            if (log) then
                endfile (ilog)
                backspace (ilog)
            end if
          end if
        end if
        if (mod(nstep + 1,30) == 0) then
          line = trim(input_fn)
          call add_path(line)
          i = len_trim(line) - 5
          call to_screen(line(:i))
        end if
      end if
      call to_screen("To_file: Geometry optimizing")
!
!  Store best result up to the present
!
      if (ef_mode /= 0 .and. best_gnorm > gnorm .or. &
        & ef_mode == 0 .and. best_funct > funct) then
        best_gnorm = gnorm
        best_funct = funct
        best_xparam = xparam
        best_grad = grad
        best_nc(:natoms) = nc(:natoms)
      end if
      !
1000  ihess = ihess + 1
      nstep = nstep + 1
      !
      !        TEST FOR CONVERGENCE
      !
      rmx = dSqrt (ddot(nvar, grad, 1, grad, 1))
!
      if (rmx < tol2) then
         !
         !     ****** OPTIMIZATION TERMINATION ******
         !
        write (iw, '(/, 5 x, "GRADIENT =", f9.5, " IS LESS THAN CUTOFF =", f9.5,//)') rmx, tol2
        go to 1020
      else
        if (ef_mode == 0 .and. nstep > 5 .and. .not. l_geo_ok) then
          if (absmin-funct < 1.d-5) then
            if (itry1 > 15 .or. (rmx < 0.1d0 .and. itry1 > 9)) then
              write (iw, &
                 &"(//,' HEAT OF FORMATION IS ESSENTIALLY STATIONARY')")
              go to 1020
            end if
            itry1 = itry1 + 1
          else
            itry1 = 0
            absmin = funct
          end if
        end if
        olde = funct
        if (nstep > 5) then
          cosine = ddot(nvar, grad, 1, oldf, 1)/ &
                 & dsqrt(ddot(nvar, grad, 1, grad, 1)*ddot(nvar, oldf, 1, oldf, 1))
          if (cosine > 0.9d0) then
            cos_const = cos_const*1.5d0
          else
            cos_const = 1.d0
          end if
  !        write(iw,*)"COSINE:", cosine, cos_const
        end if
        do i = 1, nvar
          oldf(i) = grad(i)
        end do
         !
         ! IF THE OPTIMIZATION IS IN CARTESIAN COORDINATES, WE SHOULD REMOVE
         ! TRANSLATION AND ROTATION MODES. POSSIBLE PROBLEM IF RUN IS IN
         ! INTERNAL BUT WITH EXACTLY 3*NATOMS VARIABLE (I.E. DUMMY ATOMS
         ! ARE ALSO OPTIMIZED).
        if (nvar == 3*numat .and. numat > 2) then ! Sometime, add check that system is not linear.
                                                  ! Here NUMAT = 2 is a primitive check
          allocate (p(nvar,nvar), x(nvar), rm(nvar), dx(nvar), coord(3,nvar))

          p(:,:) = 0.d0
          x(:) = 0.d0
          rm(:) = 0.d0
          dx(:) = 0.d0
          coord(:,:) = 0.d0
          call prjfc (hesinv, xparam, nvar, u, p, atmass, x, rm, dx, coord)
          deallocate (p, x, rm, dx, coord)

          if (moperr) then
            go to 1100
          end if
        end if
        ij = 0
        do i = 1, nvar
          do j = 1, i
            ij = ij + 1
            hessc(ij) = hesinv(j + (i-1)*nvar)
          end do
        end do
        call rsp (hessc, nvar, eigval, u)
!
        do i = 1, nvar
          if (Abs (eigval(i)) < tmsix) then
            eigval(i) = zero
          end if
        end do
        ij = nvar ** 2
        do i = nvar, 1, -1
          do j = nvar, 1, -1
            u(j + (i-1)*nvar) = u(ij)
            ij = ij - 1
          end do
        end do
        if (iprnt >= 3) then
          call prthes (eigval, nvar, hesinv, u)
        end if
        if (mxstep == 0) then
          nstep = 0
          go to 1030
        end if
        neg = 0
        do i = 1, nvar
          if (eigval(i) < zero) then
            neg = neg + 1
          end if
        end do
        if (iprnt >= 1) then
10030     format (/, 10 x, "HESSIAN HAS", i3, " NEGATIVE EIGENVALUE(S)", &
               & 6 f7.1, /)
          write (iw, 10030) neg, (eigval(i), i=1, neg)
        end if
         ! IF AN EIGENVALUE HAS BEEN ZERO OUT IT IS PROBABLY ONE OF THE T,R
         ! MODES IN A CARTESIAN OPTIMIZATION. ZERO CORRESPONDING FX TO
         ! ALLOW FORMATION OF STEP WITHOUT THESE CONTRIBUTIONS. A SAFER
         ! CRITERION FOR DECIDING WHETHER THIS ACTUALLY IS A CARTESIAN
         ! OPTIMIZATION SHOULD BE PUT IN SOME DAY...
        do i = 1, nvar
          fx(i) = ddot (nvar, u(1 + (i-1)*nvar), 1, grad, 1)
          if (Abs (eigval(i)) == zero) then
            fx(i) = zero
          end if
        end do
        do
            !     FORM GEOMETRY STEP D
          call formd (eigval, fx, nvar, dmax, ddmin, lts, lorjk, rrscal, &
               & donr, u, d, vmode)
          if (moperr) then
            go to 1099
          end if
            ! IF LORJK IS TRUE, THEN TS MODE OVERLAP IS LESS THAN OMIN,
            ! REJECT PREVIOUS STEP
          if (lorjk) then
            if (iprnt >= 1) then
              write (iw,*) "      NOW UNDOING PREVIOUS STEP"
            end if
            dmax = odmax
            ddx = odd
            olde = oolde
            do i = 1, nvar
              fx(i) = oldfx(i)
              oldf(i) = ooldf(i)
              eigval(i) = oldeig(i)
              do j = 1, nvar
                hesinv(i + (j-1)*nvar) = bmat(i, j)
                u(i + (j-1)*nvar) = pmat(i + (j-1)*nvar)
              end do
            end do
            do i = 1, nvar
              xparam(i) = xparam(i) - d(i)
              k = loc(1, i)
              l = loc(2, i)
              geo(l, k) = xparam(i)
            end do
            if (ndep /= 0) then
              call symtry ()
            end if
            dmax = Min (dmax, ddx) / two
            odmax = dmax
            odd = ddx
            nstep = nstep - 1
            if (dmax < ddmin) then
              go to 1010
            else if (iprnt >= 1) then
              write (iw,*) "      FINISH UNDOING, NOW GOING FOR NEW STEP"
            end if
          else
               !
               !  FORM NEW TRIAL XPARAM AND GEO
               !
            d(:nvar) = d(:nvar)*cos_const
            do i = 1, nvar
              xparam(i) = xparam(i) + d(i)
              k = loc(1, i)
              l = loc(2, i)
              geo(l, k) = xparam(i)
            end do
            if (ndep /= 0) then
              call symtry ()
            end if
               !
               !     COMPARE PREDICTED E-CHANGE WITH ACTUAL
               !
            depre = zero
            imode = 1
            if (ef_mode /= 0) then
              imode = ef_mode
            end if
            do i = 1, nvar
              if (lts .and. i == imode) then
                xtmp = xlamd0
              else
                xtmp = xlamd
              end if
              if (Abs (xtmp-eigval(i)) >= tmtwo) then
                ss = skal * fx(i) / (xtmp-eigval(i))
                depre = depre + ss * (fx(i) + pt5 * ss * eigval(i))
              end if
            end do
               !
               !     GET GRADIENT FOR NEW GEOMETRY
               !
            grad(:nvar) = 0.d0
            call compfg (xparam, .true., funct, .true., grad, .true.)
            if (moperr) then
              go to 1100
            end if
            deact = funct - olde
            if (depre == zero) then
              write (iw, "(' CALCULATION IS TERMINATED TO AVOID ZERO DIVIDE')")
              call mopend ("in EF")
              go to 1100
            end if
            ratio = deact / depre
         !   if (nstep > 1 .and. Abs(depre) < 1.d0) ratio = 1.d0 ! ignore ratio when step is small
            if (iprnt >= 1) then
		!                   12345678901234567890123456789012345678901234567890
               write (iw, '("       HoF         ACTUAL,  PREDICTED ENERGY CHANGE, RATIO",/ &
                   & 2 f14.7, f20.7, f13.7)') funct, deact, depre, ratio
            end if
               !
               ! POSSIBLY REJECT THE STEP IF THE RATIO BETWEEN ACTUAL AND
               ! PREDICTED CHANGE IN ENERGY IS OUTSIDE RMIN AND RMAX LIMITS
               ! THE DEFAULT VALUES OF RMIN=0.0 FOR MINIMIZATIONS IS
               ! EQUIVALENT
               ! TO NOT ALLOWING THE ENERGY THE RAISE.
               ! DON'T WORRY IS THE ABSOLUTE CHANGES ARE SMALL ( < DEMIN)
               !
            lrjk = .false.
            if ((ratio < rmin .or. ratio > rmax) .and. &
                 & (Abs (depre) > demin .or. Abs (deact) > demin)) then
              dtmp = Min (dmax, ddx) / two
              if (dtmp <= ddmin) then
                dtmp = ddmin
              end if
              if (iprnt >= 1) then
10050           format (1 x, "UNACCEPTABLE RATIO,", &
                     & " REJECTING STEP, REDUCING DMAX TO", f7.4)
                write (iw, 10050) dtmp
              end if
              lrjk = .true.
            end if
               !     IF THE TRUST RADIUS IS EQUAL TO DDMIN, CONTINUE ANYWAY
            if (lrjk .and. Abs(dmax - ddmin) < 1.d-20) then
              if (iprnt >= 1) then
10060           format (1 x, "NEW TRUST RADIUS WOULD BE BELOW DDMIN", &
                     & " ACCEPTING STEP ANYWAY")
                write (iw, 10060)
              end if
              lrjk = .false.
            end if
               !
               !   BYPASS ALL TESTS
               !
            if (let) then
              lrjk = .false.
            end if
               !
            if ( .not. lrjk) exit
            do i = 1, nvar
              xparam(i) = xparam(i) - d(i)
              k = loc(1, i)
              l = loc(2, i)
              geo(l, k) = xparam(i)
            end do
            if (ndep /= 0) then
              call symtry ()
            end if
            dmax = Min (dmax, ddx) / two
            if (dmax < ddmin) then
              go to 1010
            end if
          end if
        end do
        if (iprnt >= 1) then
10070     format (5 x, "STEPSIZE USED IS", f9.5)
          write (iw, 10070) ddx
        end if
        if (iprnt >= 2) then
          write (iw, "(' CALCULATED STEP')")
          write (iw, "(3X,8F10.6)") (d(i), i=1, nvar)
        end if
         !
         !     POSSIBLE USE DYNAMICAL TRUST RADIUS
        odmax = dmax
        odd = ddx
        oolde = olde
        if (lupd .and. ((rmx > gmin) .or. (Abs (depre) > demin .or. &
             & Abs (deact) > demin))) then
            ! FLETCHER RECOMMEND DMAX=DMAX/4 AND DMAX=DMAX*2
            ! THESE ARE A LITTLE MORE CONSERVATIVE SINCE HESSIAN IS BEING
            ! UPDATED
            ! DON'T REDUCE TRUST RADIUS DUE TO RATIO FOR MIN SEARCHES
          if (lts .and. ratio <= tmone .or. ratio >= three) then
            dmax = Min (dmax, ddx) / two
          end if
          if (lts .and. ratio >= pt75 .and. ratio <= (four/three) .and. ddx > &
         & (dmax-tmsix)) then
            dmax = dmax * Sqrt (two)
          end if
            ! ALLOW WIDER LIMITS FOR INCREASING TRUST RADIUS FOR MIN SEARCHES
          if ( .not. lts .and. ratio >= pt5 .and. ddx >(dmax-tmsix)) then
            dmax = dmax * Sqrt (two)
          end if
            ! BE BRAVE IF  0.90 < RATIO < 1.10 ...
          if (Abs (ratio-one) < tmone) then
            dmax = dmax * Sqrt (two)
          end if
          dmax = Max (dmax, ddmin)
          dmax = Min (dmax, ddmax)
        end if
         ! ALLOW STEPSIZE UP TO 0.1 IN THE END-GAME WHERE CHANGES ARE LESS
         ! THAN DEMIN AND GRADIENT IS LESS THAN GMIN
        if (lupd .and. rmx < gmin .and. (Abs (depre) < demin .and. &
             & Abs (deact) < demin)) then
          dmax = Max (dmax, tmone)
        end if
        if (iprnt >= 1) then
10080     format (5 x, "NEW TRUST RADIUS = ", f8.5)
          write (iw, 10080) dmax
        end if
         !frj  this test should never be encountered with the current update...
1010    if (dmax < ddmin) exit
         !     CHECK STEPS AND ENOUGH TIME FOR ANOTHER PASS
        if (nstep >= mxstep) go to 1030
         !     IN USER UNFRIENDLY ENVIROMENT, SAVE RESULTS EVERY 1 CPU HRS
        ittest = Int ((time2-time0)/tdump)
         !     RETURN FOR ANOTHER CYCLE
        if (ittest > ntime) then
          ldump = 1
          ntime = Max (ittest, (ntime+1))
          ipow(1) = ihess
          ipow(2) = nstep
          ipow(9) = 2
          tt0 = seconds (1) - time0
          instep = -nstep
          call efsav (tt0, hesinv, funct, grad, xparam, pmat, instep, &
               bmat, ipow, oldf, d, vmode)

          if (moperr) then
            go to 1100
          end if
        else
          ldump = 0
        end if
      end if
    end do
10090 format (/, 5 x, "TRUST RADIUS NOW LESS THAN ", f8.5, &
           & " OPTIMIZATION TERMINATING",/, 5 x, &
           & " THE GEOMETRY MAY NOT BE COMPLETELY OPTIMIZED",/, 5 x, &
           & " (TO CONTINUE, ADD 'LET DDMIN=0.0' TO THE KEYWORD LINE)")
    write (iw, 10090) ddmin
1099 continue
!
!  If current point is not the best, then load in the best point
!
    if (ef_mode /= 0 .and. best_gnorm < gnorm .or. ef_mode == 0 .and. best_funct < funct) then
          funct = best_funct
          gnorm = best_gnorm
          xparam(:nvar) = best_xparam(:nvar)
          grad(:nvar) = best_grad(:nvar)
          nc(:natoms) = best_nc(:natoms)
      end if
1020 iflepo = 15
    last = 1
    tt0 = seconds (1) - time0
    if ( .not. moperr) then
   !     CALL COMPFG TO CALCULATE ENERGY FOR FIXING MO-VECTOR BUG
      call compfg (xparam, .true., funct, .true., grad, .false.)
    end if
    go to 1100
   !     WE RAN OUT OF TIME OR TOO MANY ITERATIONS. DUMP RESULTS
1030 if (tleft < tstep*two) call mopend("NOT ENOUGH TIME FOR ANOTHER CYCLE")
    if (nstep >= mxstep) call mopend("EXCESS NUMBER OF OPTIMIZATION CYCLES")
    if (tleft < tstep*two .or. nstep >= mxstep) then
      ipow(1) = ihess
      ipow(9) = 1
      ipow(2) = nstep
      tt0 = seconds (1) - time0
      instep = -nstep
      call efsav (tt0, hesinv, funct, grad, xparam, pmat, instep, &
                & bmat, ipow, oldf, d, vmode)
      iflepo = -1
    end if
   !
1100 continue

   !   Delete temporary arrays
   !
    deallocate (pmat, bmat, u, hessc, eigval, tvec, svec, fx, oldfx, &
         & oldeig, ooldf, oldf, d, vmode, best_xparam, best_grad, best_nc)
    return
end subroutine ef

subroutine efsav (tt0, hess, funct, grad, xparam, pmat, il, bmat, ipow, &
     & oldf, d, vmode)
  USE maps_C, only : rxn_coord, latom, kloop
  use molkst_C, only : nvar, keywrd, nscf, is_PARAM, norbs, numat, mozyme, prt_gradients
  use common_arrays_C, only : profil
  USE ef_C, ONLY: ddx, ef_mode, &
   nstep, negreq, alparm, x0, x1, x2, iloop
  USE chanel_C, only : iw, ires, restart_fn
  implicit none
  integer :: il
  double precision  :: tt0
  double precision  :: funct
  integer  :: ipow(9)
  double precision  :: hess(nvar,nvar)
  double precision  :: grad(nvar), oldf(*), d(nvar), vmode(nvar)
  double precision  :: xparam(nvar)
  double precision  :: pmat(*)
  double precision  :: bmat(nvar,nvar)
!
  integer ::  i, j, linear, io_stat, old_numat, old_norbs
  double precision :: funct1
  logical :: opend
  double precision, external :: ddot
!*********************************************************************
!
! EFSAV STORES AND RETRIEVE DATA USED IN THE EF GEOMETRY
!        OPTIMISATION. VERY SIMILAR TO POWSAV.
!
!  ON INPUT HESS   = HESSIAN MATRIX, PARTIAL OR WHOLE.
!           GRAD   = GRADIENTS.
!           XPARAM = CURRENT STATE OF PARAMETERS.
!           IL     = INDEX OF HESSIAN,
!           JL     = CYCLE NUMBER REACHED SO-FAR.
!           BMAT   = "B" MATRIX!
!           IPOW   = INDICES AND FLAGS.
!           IPOW(9)= 0 FOR RESTORE, 1 FOR DUMP, 2 FOR SILENT DUMP
!
!*********************************************************************
  if (is_PARAM) return
  inquire(unit=ires, opened=opend)
  if (opend) close(unit=ires, status='KEEP')
  open(unit=ires, file=restart_fn, status='UNKNOWN', form=&
  'UNFORMATTED', position='asis', iostat = io_stat)
  if (io_stat /= 0) then
    write(iw,*)" Restart file either does not exist or is not available for reading"
    call mopend ("Restart file either does not exist or is not available for reading")
    return
  end if
  rewind ires
  if (ipow(9)==1 .or. ipow(9)==2) then
    funct1 = dsqrt(ddot(nvar, grad, 1, grad, 1))
    if (ipow(9) == 1 .and. index(keywrd,'STEP1') == 0) then
      write (iw, '(2/10X,''CURRENT VALUE OF GRADIENT NORM ='',F12.6)') funct1
      if (prt_gradients .and. index(keywrd," GRADI") /= 0 .and. mozyme) then
        write (iw, '(3/7X,''CURRENT  POINT  AND  DERIVATIVES'',/)')
        call prtgra ()
      end if
      write (iw, '(/10X,''CURRENT VALUE OF GEOMETRY'',/)')
      call geout (iw)
    end if
!
!  IPOW(1) AND IPOW(9) ARE USED ALREADY, THE REST ARE FREE FOR USE
!
    ipow(8) = nscf
    write (ires) numat, norbs, (xparam(i),i=1,nvar)
    if (latom /= 0) then
      if (index(keywrd,' STEP=') /= 0) then
        write (ires) kloop
        write (ires) rxn_coord
        write (ires) (profil(i),i=1,kloop)
      else
        write (ires) ((alparm(j,i),j=1,3),i=1,nvar)
       write (ires) iloop, x0, x1, x2
      end if
    end if
    write (ires) ipow, il, nstep, funct, tt0
    write (ires) (grad(i),i=1,nvar)
    write (ires) ((hess(j,i),j=1,nvar),i=1,nvar)
    write (ires) ((bmat(j,i),j=1,nvar),i=1,nvar)
    write (ires) (oldf(i),i=1,nvar), (d(i),i=1,nvar), (vmode(i),i=1,nvar)
    write (ires) ddx, ef_mode, nstep, negreq
    linear = (nvar*(nvar + 1))/2
    write (ires) (pmat(i),i=1,linear)
    call den_in_out(1)
    if (index(keywrd,'STEP1') /= 0) return
    close(ires)
    return
  else
    read (ires, iostat = io_stat)old_numat, old_norbs
    if (norbs /= old_norbs .or. numat /= old_numat) then
        call mopend("Restart file read in does not match current data set")
        return
    end if
    if (latom /= 0) then
      if (index(keywrd,' STEP=') /= 0) then
        read (ires, iostat = io_stat) kloop
        read (ires, iostat = io_stat) rxn_coord
        read (ires, iostat = io_stat) (profil(i),i=1,kloop)
      else
        read (ires, iostat = io_stat) ((alparm(j,i),j=1,3),i=1,nvar)
        read (ires, iostat = io_stat) iloop, x0, x1, x2
      end if
    end if
    read (ires, iostat = io_stat) ipow, il, nstep, funct, tt0
    nscf = ipow(8)
    i = int(tt0/1000000)
    tt0 = tt0 - i*1000000
    write (iw, '(2/10X,''TOTAL TIME USED SO FAR:'',F13.2,'' SECONDS'')') tt0
    if(abs(funct) > 1.d-20) write (iw, '(  10X,''              FUNCTION:'',F17.6)') funct
    read (ires, iostat = io_stat) (grad(i),i=1,nvar)
    read (ires, iostat = io_stat) ((hess(j,i),j=1,nvar),i=1,nvar)
    read (ires, iostat = io_stat) ((bmat(j,i),j=1,nvar),i=1,nvar)
    read (ires, iostat = io_stat) (oldf(i),i=1,nvar), (d(i),i=1,nvar), (vmode(i),i=1,nvar)
    read (ires, iostat = io_stat) ddx, ef_mode, nstep, negreq
    linear = (nvar*(nvar + 1))/2
    read (ires, iostat = io_stat) (pmat(i),i=1,linear)
    if (index(keywrd,' STEP1') /= 0) return
    close(ires)
    if (io_stat /= 0) then
      call mopend ("Restart file is currupt")
    end if
    return
  end if
  return
  end subroutine efsav
subroutine efstr (xparam, funct, ihess, ntime, iloop, igthes, mxstep, ireclc, &
     & iupd, dmax, ddmax, ddmin, tol2, time1, time2, nvar, scf1, lupd, &
     & ldump, rrscal, donr, hess, bmat, pmat, grad, oldf, d, vmode)
    use molkst_C, only: limscf, time0, numcal, keywrd, moperr, id
    use chanel_C, only: iw
    use ef_C, only: nstep, ef_mode, negreq, rmin, rmax, omin, iprnt
   !
   !.. Implicit Declarations ..
    implicit none
   !
   !.. Formal Arguments ..
    logical, intent (out) :: donr, lupd, rrscal, scf1
    integer, intent (inout) :: nvar
    integer, intent (out) :: igthes, ihess, iloop, ireclc, iupd, ldump, &
         & mxstep, ntime
    double precision, intent (inout) :: funct
    double precision, intent (out) :: ddmax, ddmin, dmax, time1, time2, tol2
    double precision, dimension (nvar), intent (inout) :: d, grad, &
         & oldf, vmode, xparam
    double precision, dimension (nvar, nvar), intent (inout) :: &
         & bmat, hess, pmat
   !
   !.. Local Scalars ..
    logical :: restrt
    integer :: i, ip, its, j, k, mtmp, icalcn=0
    double precision :: tt0
   !
   !.. Local Arrays ..
    integer, dimension (9) :: ipow
   !
   !.. External Calls ..
    double precision, external :: reada
    intrinsic Abs, Index, Int, Nint
   !
   ! ... Executable Statements ...
   !
   !     GET ALL INITIALIZATION DATA
    nvar = Abs (nvar)
    ldump = 0
    lupd = (Index (keywrd, " NOUPD") == 0)
    restrt = (Index (keywrd, " RESTART") /= 0)
    scf1 = (Index (keywrd, " 1SCF") /= 0)
    nstep = 0
    ihess = 0
    ntime = 0
    iloop = 1
    ef_mode = 0
    igthes = 0
    iupd = 2
    negreq = 0
    rmin = 0.0d0
    rmax = 1.d3
    dmax = 0.2d0
    ddmax = 0.5d0
    if (icalcn == numcal) then
!
!  This is a reaction path or a grid, etc. therefore set maximum step small,
!  and re-set the Hessian every 10 cycles of geo optimization.
!
      ddmax = 0.1d0
      ireclc = 10
    else
      icalcn = numcal
      ireclc = 999999
    end if
   !
   !   In geometry optimization, let SCF exit if conditions are right,
   !   that is, if the heat has increased or decreased a lot.
   !
    limscf = .true.
    its = Index (keywrd, " TS ")
    if (its /= 0) then
      limscf = .false.
      ef_mode = 1
      igthes = 1
      iupd = 1
      negreq = 1
      rmin = 0.0d0
      rmax = 4.0d0
      omin = 0.8d0
      dmax = 0.1d0
      ddmax = 0.3d0
    end if
    rrscal = .false.
   !
    i = Index (keywrd, " RSCAL")
    if (i /= 0) then
      rrscal = .true.
    end if
    donr = .true.
    i = Index (keywrd, " NONR")
    if (i /= 0) then
      donr = .false.
    end if
    iprnt = 0
    ip = Index (keywrd, " PRNT=")
    if (ip /= 0) then
      iprnt = Nint (reada (keywrd, ip))
    end if
    if (iprnt > 5) then
      iprnt = 5
    end if
    if (iprnt < 0) then
      iprnt = 0
    end if
    mxstep = 2000
    i = Index (keywrd, " CYCLES=")
    if (i /= 0) then
      mxstep = Nint (reada (keywrd, i))
    end if
    if (i /= 0 .and. mxstep == 0 .and. ip == 0) then
      iprnt = 3
    end if
    i = Index (keywrd, " RECALC=")
    if (i /= 0) then
      ireclc = Nint (reada (keywrd, i))
    end if
    i = Index (keywrd, " IUPD=")
    if (i /= 0) then
      iupd = Nint (reada (keywrd, i))
    end if
    i = Index (keywrd, " MODE=")
    if (i /= 0) then
      ef_mode = Nint (reada (keywrd, i))
    end if
    ddmin = 1.d-4
    i = Index (keywrd, " DDMIN=")
    if (i /= 0) then
      ddmin = reada (keywrd, i)
    end if
    i = Index (keywrd, " DMAX=")
    if (i /= 0) then
      dmax = reada (keywrd, i)
    end if
    i = Index (keywrd, " DDMAX=")
    if (i /= 0) then
      ddmax = reada (keywrd, i)
    end if
    tol2 = 1.d+0
    if (id /= 0) tol2 = id*2.d0 - 1.d0
    if (Index (keywrd, " PREC") /= 0) tol2 = tol2*5.d-2
    i = Index (keywrd, " GNORM=")
    if (i /= 0) then
      tol2 = reada (keywrd, i)
    end if
    if (Index (keywrd, " LET") == 0 .and. tol2 < 0.01d0) then
      write (iw, "(/,A)") "  GNORM HAS BEEN SET TOO LOW, RESET TO 0.01", &
     & "  SPECIFY LET AS KEYWORD TO ALLOW GNORM LESS THAN 0.01"
      tol2 = 0.01d0
    end if
    i = Index (keywrd, " HESS=")
    if (i /= 0) then
      igthes = Nint (reada (keywrd, i))
    end if
    i = Index (keywrd, " RMIN=")
    if (i /= 0) then
      rmin = reada (keywrd, i)
    end if
    i = Index (keywrd, " RMAX=")
    if (i /= 0) then
      rmax = reada (keywrd, i)
    end if
    i = Index (keywrd, " OMIN=")
    if (i /= 0) then
      omin = reada (keywrd, i)
    end if
    time1 = time0
    time2 = time1
   !   DONE WITH ALL INITIALIZING STUFF.
   !   CHECK THAT OPTIONS REQUESTED ARE RESONABLE
    if ((its /= 0) .and. (iupd == 2)) then
      write (iw,*) " TS SEARCH AND BFGS UPDATE WILL NOT WORK"
      call mopend ("TS SEARCH AND BFGS UPDATE WILL NOT WORK")
      return
    end if
    if ((its /= 0) .and. (igthes == 0)) then
      write (iw,*) " TS SEARCH REQUIRE BETTER THAN DIAGONAL HESSIAN"
      call mopend ("TS SEARCH REQUIRE BETTER THAN DIAGONAL HESSIAN")
      return
    end if
    if ((igthes < 0) .or. (igthes > 3)) then
      write (iw,*) " UNRECOGNIZED HESS OPTION", igthes
      call mopend ("UNRECOGNIZED HESS OPTION")
      return
    end if
    if ((omin < 0.d0) .or. (omin > 1.d0)) then
      write (iw,*) " OMIN MUST BE BETWEEN 0 AND 1", omin
      call mopend ("OMIN MUST BE BETWEEN 0 AND 1")
      return
    end if
    nstep = 0
    if (restrt) then
      !
      !   RESTORE DATA. I INDICATES (HESSIAN RESTART OR OPTIMIZATION
      !   RESTART). IF I .GT. 0 THEN HESSIAN RESTART AND I IS LAST
      !   STEP CALCULATED IN THE HESSIAN. IF I .LE. 0 THEN J (NSTEP)
      !   IN AN OPTIMIZATION HAS BEEN DONE.
      !
      ipow(9) = 0
      mtmp = ef_mode
      tt0 = 0.d0
      j = 0
      call efsav (tt0, hess, funct, grad, xparam, pmat, i, bmat, ipow, &
           & oldf, d, vmode)
      if (moperr) return
      ef_mode = mtmp
      j = ipow(2)
      k = Int (tt0/1000000.d0)
      time0 = time0 - tt0 + k * 1000000.d0
      iloop = i
      if (i > 0) then
        igthes = 4
        nstep = j
        write (iw, "(10X,'RESTARTING HESSIAN AT POINT',I4)") iloop
        if (nstep /= 0) then
          write (iw, "(10X,'IN OPTIMIZATION STEP',I4)") nstep
        end if
      else
        nstep = j
        write (iw, "(//10X,'RESTARTING OPTIMIZATION AT STEP',I6)") nstep
      end if
    end if
    mxstep = mxstep + nstep
end subroutine efstr
subroutine formd (eigval, fx, nvar, dmax, ddmin, ts, lorjk, rrscal, &
     & donr, u, d, vmode)
   !     THIS VERSION FORMS GEOMETRY STEP BY EITHER PURE NR, P-RFO OR QA
   !     ALGORITHM, UNDER THE CONDITION THAT THE STEPLENGTH IS LESS THAN
   !     DMAX
    use chanel_C, only: iw
    use ef_C, only: skal, ef_mode, iprnt, ddx, xlamd, xlamd0
    use molkst_C, only: numcal, numat
    implicit none
    logical, intent (in) :: donr, rrscal, ts
    logical, intent (inout) :: lorjk
    integer, intent (in) :: nvar
    double precision, intent (in) :: ddmin, dmax
    double precision, dimension (nvar), intent (in) :: eigval, fx
    double precision, dimension (nvar), intent (inout) :: d, vmode
    double precision, dimension (nvar, nvar), intent (in) :: u
    logical :: frodo1, frodo2, rscal
    integer :: i, it, j, jt, ncnt, newmod
    integer, save :: icalcn = 0
    double precision, parameter :: big = 1.0d+3, half = 0.5d0
    double precision, save :: eone, eigit
    double precision, parameter :: tmtwo = 1.0d-2
    double precision :: bl, bu, d2max, fl, fm, fu, ssmax, ssmin, &
         & sstoll, temp, xlambda, lambda, lambda0, sstep, store_ddx
    double precision, parameter :: eps = 1.0d-12, four = 4.0d+00, &
         & one = 1.0d+0, sfix = 1.0d+01, step_loc = 5.0d-02, ten = 1.0d+1, &
         & tmsix = 1.0d-06, toll = 1.0d-8, zero = 0.0d0
    save :: store_ddx

!For MOPAC BLAS
    double precision, external :: ddot
!

   !
   !
   !.. Intrinsic Functions ..
    intrinsic Abs, Max, Sqrt
   !
   ! ... Executable Statements ...
   !
    if (icalcn /= numcal) then
      icalcn = numcal
      store_ddx = 0.d0
      d = 0.d0
    end if
    skal = one
    rscal = rrscal
    it = 0
    jt = 1
    if (ts) then
      if (ef_mode /= 0) then
        call overlp (dmax, ddmin, newmod, nvar, lorjk, u, vmode)
        if (lorjk) return
         !
         !  ON RETURN FROM OVERLP, NEWMOD IS THE TS MODE
         !
        if (newmod /= ef_mode .and. iprnt >= 1) then
10000     format (5 x, "WARNING! MODE SWITCHING. WAS FOLLOWING MODE ", &
         & i3, " NOW FOLLOWING MODE ", i3)
          write (iw, 10000) ef_mode, newmod
        end if
        ef_mode = newmod
        it = ef_mode
      else
        it = 1
      end if
      eigit = eigval(it)
      if (eigit == zero) then
        if (nvar > 3*numat - 5) then
          call mopend ("Too many variables. By definition, at least one force constant is exactly zero" )
          write(iw,"(10x,a)")"and the lowest force constant is not negative."
          write(iw,"(10x,a,i5)")"Number of variables = ", nvar
          write(iw,"(10x,a,i5)")"Number of atoms     = ", numat
          if (nvar == 3*numat) &
            write(iw,"(10x,a,i5)")"(If coordinates are Cartesian, convert to internal coordinates and re-run.)"
        else
          write(iw,"(a)")" At least one force constant is exactly zero"
          call mopend("At least one force constant is exactly zero")
        end if
        return
      else if (iprnt >= 1) then
10010   format (/, 5 x, "TS MODE IS NUMBER", i3, " WITH EIGENVALUE", &
       & f9.1,/, 5 x, "AND COMPONENTS", /)
        write (iw, 10010) it, eigit
10020   format (5 x, 8 f9.4)
        write (iw, 10020) (u(i, it), i=1, nvar)
      end if
    end if
   !     JT SHOULD BE LOWEST MODE WHICH IS NOT THE TS-MODE AND NOT T, R MOD
   !     IN CARTESIAN COORDINATES. JT SHOULD BE ONE OF THE FIRST 8 MODES,
   !     SEARCH ALL TO ALLOW FOR ACCIDENTAL EIGENVALUES = 0.
    do i = 1, nvar
      if (i /= it .and. eigval(i) /= zero) then
        jt = i
        exit
      end if
    end do
    eone = eigval(jt)
    ssmin = Max (Abs (eone)*eps, (ten*eps))
    ssmax = Max (big, Abs (eone))
    ssmax = ssmax * big
    sstoll = toll
    d2max = dmax * dmax
   !  SOLVE ITERATIVELY FOR LAMBDA
   !  INITIAL GUESS FOR LAMBDA IS ZERO EXCEPT NOTE THAT
   !  LAMBDA SHOULD BE LESS THAN EIGVAL(1)
   !  START BY BRACKETING ROOT, THEN HUNT IT DOWN WITH BRUTE FORCE BISECT.
   !
    frodo1 = .false.
    frodo2 = .false.
    lambda = zero
    lambda0 = zero
    if (ts) then
      if (eigit < zero .and. eone >= zero .and. donr) then
        if (iprnt >= 1) then
          write (iw,*) " TS SEARCH, CORRECT HESSIAN, TRYING PURE NR STEP"
        end if
        go to 1010
      end if
    else if (donr) then
      if (eone >= zero) then
        if (iprnt >= 1) then
          write (iw,*) " MIN SEARCH, CORRECT HESSIAN, TRYING PURE NR STEP"
        end if
        go to 1010
      end if
    end if
   !     .. Head of OUTER_LOOP ..
1000 continue
    if (ts) then
      lambda0 = eigval(it) + Sqrt (eigval(it)**2+four*fx(it)**2)
      lambda0 = lambda0 * half
      if (iprnt >= 1) then
         !
10030   format (1 x, "LAMBDA THAT MAXIMIZES ALONG TS MODES =   ", f15.5)
        write (iw, 10030) lambda0
      end if
    end if
    sstep = step_loc
    if (eone <= zero) then
      lambda = eone - sstep
    end if
    if (eone > zero) then
      sstep = eone
    end if
    bl = lambda - sstep
    bu = lambda + sstep * half
    ncnt = 0
    do
      fl = zero
      fu = zero
      do i = 1, nvar
        if (i /= it) then
          if ((bl-eigval(i) == zero) .or. &
            & (bu-eigval(i) == zero)) then
            write (iw, "(' CALCULATION IS TERMINATED TO AVOID ZERO DIVIDE')")
            call mopend ("in FORMD")
            return
          end if
          fl = fl + (fx(i)*fx(i)) / (bl-eigval(i))
          fu = fu + (fx(i)*fx(i)) / (bu-eigval(i))
        end if
      end do
      fl = fl - bl
      fu = fu - bu
      if (fl*fu < zero) exit
      bl = bl - (eone-bl)
      bu = bu + half * (eone-bu)
      if (bl <=-ssmax) then
        bl = -ssmax
        frodo1 = .true.
      end if
      if (Abs (eone-bu) <= ssmin) then
        bu = eone - ssmin
        frodo2 = .true.
      end if
      endfile (iw)
      backspace (iw)
      if (frodo1 .and. frodo2) then
        write (iw,*) "NUMERICAL PROBLEMS IN BRACKETING LAMBDA", eone, bl, &
             & bu, fl, fu
        write (iw,*) " GOING FOR FIXED STEP SIZE...."
        go to 1020
      end if
      ncnt = ncnt + 1
      if (ncnt > 1000) then
        write (iw,*) "TOO MANY ITERATIONS IN LAMBDA BISECT", bl, bu, &
             & fl, fu
        call mopend ("TOO MANY ITERATIONS IN LAMBDA BISECT IN EF")
        return
      end if
    end do
    ncnt = 0
    xlambda = zero
    do
      fl = zero
      fu = zero
      fm = zero
      lambda = half * (bl+bu)
      do i = 1, nvar
        if (i /= it) then
          if ((bl-eigval(i) == zero) .or. &
            & (bu-eigval(i) == zero) .or. &
            & (lambda-eigval(i) == zero)) then
            write (iw, "(' CALCULATION IS TERMINATED TO AVOID ZERO DIVIDE')")
            call mopend ("in FORMD")
            return
          end if
          fl = fl + (fx(i)*fx(i)) / (bl-eigval(i))
          fu = fu + (fx(i)*fx(i)) / (bu-eigval(i))
          fm = fm + (fx(i)*fx(i)) / (lambda-eigval(i))
        end if
      end do
      fl = fl - bl
      fu = fu - bu
      fm = fm - lambda
      if (Abs (xlambda-lambda) < sstoll) exit
      ncnt = ncnt + 1
      if (ncnt > 1000) then
        write (iw,*) "TOO MANY ITERATIONS IN LAMBDA BISECT", bl, bu, &
             & lambda, fl, fu
        call mopend ("TOO MANY ITERATIONS IN LAMBDA BISECT IN EF")
        return
      else
        xlambda = lambda
        if (fm*fu < zero) then
          bl = lambda
        end if
        if (fm*fl < zero) then
          bu = lambda
        end if
      end if
    end do
   !     .. Head of LOOP ..
1010 continue
   !
    if (iprnt >= 1) then
10040 format (1 x, "LAMBDA THAT MINIMIZES ALONG ALL MODES =  ", f17.9)
      write (iw, 10040) lambda
    end if
   !
   !  CALCULATE THE STEP
   !
    do i = 1, nvar
      d(i) = zero
    end do
    do i = 1, nvar
      if (lambda == zero .and. Abs (eigval(i)) < tmtwo) then
        temp = zero
      else
        temp = fx(i) / (lambda-eigval(i))
      end if
      if (i == it) then
        if (Abs (lambda0-eigval(it)) < 1.d-9) then
          write (iw,*) " TS FAILED TO LOCATE TRANSITION STATE"
          write (iw, "(/10X,'CURRENT VALUE OF GEOMETRY',/)")
          call geout (iw)
          call mopend ("TS FAILED TO LOCATE TRANSITION STATE")
          return
        else
          temp = fx(it) / (lambda0-eigval(it))
        end if
      end if
      if (iprnt >= 5) then
        write (iw, "(A,I4,F16.11)") "FORMD, DELTA STEP", i, temp
      end if
      do j = 1, nvar
        d(j) = d(j) + temp * u(j, i)
      end do
    end do
    ddx = dSqrt (ddot(nvar, d, 1, d, 1))
    if ( ((lambda /= zero .and. abs(lambda0 + lambda) <= 1.d-20)) .or. &
        & (lambda /= zero .and. abs(lambda0 + lambda) > 1.d-20) .and. store_ddx > 1.d-9) then
      if (ddx > 2*store_ddx) then
        d = d*store_ddx/ddx
        ddx = 2*store_ddx
      end if
    end if
    if (lambda == zero .and. lambda0 == zero .and. iprnt >= 1) then
10050 format (1 x, "PURE NR-STEP HAS LENGTH", f10.5)
      write (iw, 10050) ddx
    end if
    if (lambda /= zero .and. abs(lambda0 + lambda) > 1.d-20 .and. iprnt >= 1) then
10060 format (1 x, "P-RFO-STEP   HAS LENGTH", f10.5)
      write (iw, 10060) ddx
    end if
    if (lambda /= zero .and. abs(lambda0 + lambda) <= 1.d-20 .and. iprnt >= 1) then
10070 format (1 x, "QA/TRIM-STEP HAS LENGTH", f10.5)
      write (iw, 10070) ddx
    end if
    store_ddx = ddx
    if (ddx < (dmax+tmsix)) then
      xlamd = lambda
      xlamd0 = lambda0
      return
    end if
    if (lambda == zero .and. lambda0 == zero) go to 1000
    if (rscal) go to 1040
1020 lambda = zero
    frodo1 = .false.
    frodo2 = .false.
    sstep = step_loc
    if (eone <= zero) then
      lambda = eone - sstep
    end if
    if (ts .and.-eigit < eone) then
      lambda = -eigit - sstep
    end if
    if (eone > zero) then
      sstep = eone
    end if
    bl = lambda - sstep
    bu = lambda + sstep * half
    do
      fl = zero
      fu = zero
      do i = 1, nvar
        if (i /= it) then
          if ((bl-eigval(i) == zero) .or. &
            & (bu-eigval(i) == zero)) then
            write (iw, "(' CALCULATION IS TERMINATED TO AVOID ZERO DIVIDE')")
            call mopend ("in FORMD")
            return
          end if
          fl = fl + (fx(i)/(bl-eigval(i))) ** 2
          fu = fu + (fx(i)/(bu-eigval(i))) ** 2
        end if
      end do
      if (ts) then
        if ((bl+eigval(it) == zero) .or. &
          & (bu+eigval(it) == zero)) then
          write (iw, "(' CALCULATION IS TERMINATED TO AVOID ZERO DIVIDE')")
          call mopend ("in FORMD")
          return
        end if
        fl = fl + (fx(it)/(bl+eigval(it))) ** 2
        fu = fu + (fx(it)/(bu+eigval(it))) ** 2
      end if
      fl = fl - d2max
      fu = fu - d2max
      if (fl*fu < zero) go to 1030
      bl = bl - (eone-bl)
      bu = bu + half * (eone-bu)
      if (bl <=-ssmax) then
        bl = -ssmax
        frodo1 = .true.
      end if
      if (Abs (eone-bu) <= ssmin) then
        bu = eone - ssmin
        frodo2 = .true.
      end if
      if (frodo1 .and. frodo2) exit
    end do
    write (iw,*) "NUMERICAL PROBLEMS IN BRACKETING LAMBDA", eone, bl, bu, &
         & fl, fu
    write (iw,*) " GOING FOR FIXED LEVEL SHIFTED NR STEP..."
   !           BOTH LAMBDA SEARCHES FAILED, GO FOR FIXED LEVEL SHIFTED NR
   !           THIS IS UNLIKELY TO PRODUCE ANYTHING USEFUL, BUT MAYBE WE'RE
    lambda = eone - sfix
    lambda0 = eigit + sfix
    rscal = .true.
    go to 1010
1030 continue
    ncnt = 0
    xlambda = zero
    do
      fl = zero
      fu = zero
      fm = zero
      lambda = half * (bl+bu)
      do i = 1, nvar
        if (i /= it) then
          if ((bl-eigval(i) == zero) .or. &
            & (bu-eigval(i) == zero) .or. &
            & (lambda-eigval(i) == zero)) then
            write (iw, "(' CALCULATION IS TERMINATED TO AVOID ZERO DIVIDE')")
            call mopend ("in FORMD")
            return
          end if
          fl = fl + (fx(i)/(bl-eigval(i))) ** 2
          fu = fu + (fx(i)/(bu-eigval(i))) ** 2
          fm = fm + (fx(i)/(lambda-eigval(i))) ** 2
        end if
      end do
      if (ts) then
        if ((bl+eigval(it) == zero) .or. &
          & (bu+eigval(it) == zero) .or. &
          & (lambda+eigval(it) == zero)) then
          write (iw, "(' CALCULATION IS TERMINATED TO AVOID ZERO DIVIDE')")
          call mopend ("in FORMD")
          return
        end if
        fl = fl + (fx(it)/(bl+eigval(it))) ** 2
        fu = fu + (fx(it)/(bu+eigval(it))) ** 2
        fm = fm + (fx(it)/(lambda+eigval(it))) ** 2
      end if
      fl = fl - d2max
      fu = fu - d2max
      fm = fm - d2max
      if (Abs (xlambda-lambda) < sstoll) exit
      ncnt = ncnt + 1
      if (ncnt > 1000) then
        write (iw,*) "TOO MANY ITERATIONS IN LAMBDA BISECT", bl, bu, lambda, &
             & fl, fu
        call mopend ("TOO MANY ITERATIONS IN LAMBDA BISECT IN EF")
        return
      else
        xlambda = lambda
        if (fm*fu < zero) then
          bl = lambda
        end if
        if (fm*fl < zero) then
          bu = lambda
        end if
      end if
    end do
   !
    lambda0 = -lambda
    rscal = .true.
   !     .. End of LOOP ..
    go to 1010
1040 if (ddx == zero) then
      write (iw, "(' CALCULATION IS TERMINATED TO AVOID ZERO DIVIDE')")
      call mopend ("in FORMD")
      return
    end if
    skal = dmax / ddx
    do i = 1, nvar
      d(i) = d(i) * skal
    end do
    ddx = dSqrt (ddot(nvar, d, 1, d, 1))
    if (iprnt >= 1) then
10080 format (5 x, "CALCULATED STEP SIZE TOO LARGE, SCALED WITH", f9.5)
      write (iw, 10080) skal
    end if
    xlamd = lambda
    xlamd0 = lambda0
end subroutine formd
subroutine gethes (xparam, igthes, iloop, hess, pmat, bmat, grad, geo, loc, &
     & oldf, d, vmode, funct0)
    use molkst_C, only: nvar, natoms, id, nalpha, tleft, time0, ndep, gnorm, &
    keywrd, moperr, line
    use chanel_C, only: iw0, iw
    use ef_C, only: ef_mode, nstep, iprnt
   !
   !.. Implicit Declarations ..
    implicit none
   !
   !.. Formal Arguments ..
    integer, intent (in) :: igthes, iloop
    double precision, intent (inout) :: funct0
    integer, dimension (2, nvar), intent (in) :: loc
    double precision, dimension (nvar*nvar), intent (inout) :: pmat
    double precision, dimension (nvar), intent (inout) :: d, grad, oldf, &
         & vmode, xparam
    double precision, dimension (3, natoms), intent (inout) :: geo
    double precision, dimension (nvar, nvar), intent (inout) :: bmat, hess
   !
   !.. Local Scalars ..
    integer :: i, if, iidum, ij, j, k, l, mtmp, nxxx, percent
    double precision :: dg1, dg2, dg3, dummy, fdmy, funct, funct1, sum, &
         & tdm, time1, time2, tstep, tstore, tt0, test = 0.d0, xinc
    double precision, parameter :: dghsa = 500.d0, dghsd = 200.d0, &
         & dghss = 1000.d0, two = 2.d0,  zzero = 0.d0
    logical :: lpacifier
   !
   !.. Local Arrays ..
    integer, dimension (9) :: ipow = (/ 0, 0, 0, 0, 0, 0, 0, 0, 0 /)
    double precision, dimension(:), allocatable :: gnext1, gmin1
    double precision, external :: seconds

    intrinsic Index, Max, Sign
   !
   ! ... Executable Statements ...
   !
    allocate (gnext1(nvar), gmin1(nvar))
    if (index(keywrd, " MOZ") + index(keywrd, " LOCATE-TS")/= 0) then
!
!  MOZYME is not as precise as conventional, so use a bigger step
!
      xinc = 1.d-2
    else
      xinc = 1.d-3
    end if
    do i = 1, nvar
      gnext1(i) = 0.0d0
      gmin1(i) = 0.0d0
    end do
   !
   !     DGHSX IS HESSIAN DIAGONAL FOR IGTHES=0 (STRETCHING, ANGLE,
   !     DIHEDRAL).  THE VALUES SHOULD BE 'OPTIMUM' FOR CYCLOHEXANONE
   !     XINC IS STEPSIZE FOR HESSIAN CALCULATION. TESTS SHOWS THAT IT SHOU
   !     BE IN THE RANGE 10(-2) TO 10(-4). 10(-3) APPEARS TO BE
   !     A REASONABLE COMPROMISE BETWEEN ACCURACY AND NUMERICAL PROBLEMS
    if (igthes == 0) then
10000 format (/, 10 x, "DIAGONAL MATRIX USED AS START HESSIAN", /)
      write (iw, 10000)
      do i = 1, nvar
        do j = 1, nvar
          hess(i, j) = zzero
        end do
      end do
      !
      !   If a polymer, then calculate the diagonal of the Hessian explicitly
      !
      if (id /= 0) then
        do i = 1, nvar
            !
            !  MAKE THE FIRST STEP A WEAK FUNCTION OF THE GRADIENT
            !
          oldf(i) = xparam(i) - Sign (0.001d0, grad(i))
         !
         !  MAKE THE FIRST STEP A WEAK FUNCTION OF THE GRADIENT
         !
        end do
        call compfg (oldf, .true., funct1, .true., gnext1, .true.)
        do i = 1, nvar
          hess(i, i) = Max (100.d0, (grad(i)-gnext1(i))/(xparam(i)-oldf(i)))
        end do
        if (funct1 < funct0) then
            !
            !   The new point is better than the old point
            !
          funct0 = funct1
          do i = 1, nvar
            xparam(i) = oldf(i)
            grad(i) = gnext1(i)
          end do
        end if
      else
        sum = 200.d0
        if (Index (keywrd, " XYZ") /= 0) then
          dg1 = sum
          dg2 = sum
          dg3 = sum
        else
          dg1 = dghss
          dg2 = dghsa
          dg3 = dghsd
        end if
        ij = 1
        outer_loop: do j = 1, natoms
          do i = 1, 3
            if (loc(2, ij) == i .and. loc(1, ij) == j) then
              if (i == 1) then
                hess(ij, ij) = dg1
              end if
              if (i == 2) then
                hess(ij, ij) = dg2
              end if
              if (i == 3) then
                hess(ij, ij) = dg3
              end if
              ij = ij + 1
              if (ij > nvar) exit outer_loop
            end if
          end do
        end do outer_loop
        ij = ij - 1
        if (ij /= nvar) then
          write (iw,*) "ERROR IN IGTHES=0,IJ,NVAR", ij, nvar
        end if
      end if
    end if
   !
    if (igthes == 2) then
10010 format (/, 10 x, "HESSIAN READ FROM DISK", /)
      write (iw, 10010)
      ipow(9) = 0
      ! USE DUMMY ARRAY FOR CALL EXCEPT FOR HESSIAN
      ! TEMPORARY SET NALPHA = 0, THEN WE CAN READ HESSIAN FROM RHF
      ! RUN FOR USE IN SAY UHF RUNS
      ! ALSO SAVE MODE, TO ALLOW FOLLOWING A DIFFERENT MODE THAN THE ON
      ! CURRENTLY ON RESTART FILE
      nxxx = nalpha
      nalpha = 0
      mtmp = ef_mode
      tdm = 0.d0
      fdmy = 0.d0
      iidum = 0
      call efsav (tdm, hess, fdmy, gnext1, gmin1, pmat, iidum, bmat, &
           & ipow, oldf, d, vmode)
      if (moperr) return
      nalpha = nxxx
      ef_mode = mtmp
      nstep = 0
    end if
    if ((igthes == 1) .or. (igthes == 3) .or. (igthes == 4)) then
      ! IF IGTHES IS .EQ. 4, THEN THIS IS A HESSIAN RESTART.
      ! USE GNEXT1 AND DUMMY FOR CALLS TO COMPFG DURING HESSIAN
      ! CALCULATION
      if (igthes == 1) then
10020   format (/, 10 x, "HESSIAN CALCULATED NUMERICALLY", /)
        write (iw, 10020)
      end if
      if (igthes == 3) then
10030   format (/, 10 x, "HESSIAN CALCULATED DOUBLE NUMERICALLY", /)
        write (iw, 10030)
      end if
      if (iprnt >= 5) then
        write (iw, "(I3,12(8F9.4,/3X))") 0, (grad(if), if=1, nvar)
      end if
      time1 = seconds (1)
      tstore = time1
      percent = (100*(iloop-1))/nvar
      lpacifier = .false.
      do i = iloop, nvar
        xparam(i) = xparam(i) + xinc
        call compfg (xparam, .true., dummy, .true., gnext1, .true.)
        if (iprnt >= 5) then
          write (iw, "(I3,12(8F9.4,/3X))") i, (gnext1(if), if=1, nvar)
        end if
        xparam(i) = xparam(i) - xinc
        if (igthes == 3) then
          xparam(i) = xparam(i) - xinc
          gnorm = 0.d0
          call compfg (xparam, .true., dummy, .true., gmin1, .true.)
          if (iprnt >= 5) then
            write (iw, "(I3,12(8F9.4,/3X))") - i, (gmin1(if), if=1, nvar)
          end if
          xparam(i) = xparam(i) + xinc
          do j = 1, nvar
            hess(i, j) = (gnext1(j)-gmin1(j)) / (xinc+xinc)
          end do
        else
          do j = 1, nvar
            hess(i, j) = (gnext1(j)-grad(j)) / xinc
          end do
        end if
        time2 = seconds (1)
        tstep = time2 - time1
        tleft = tleft - tstep
        time1 = time2
        j = (100*i)/nvar
        test = test + tstep
        if (j/5 > percent/5 .or. (j == 1 .and. percent /= 1) .or. i == 1) then
!
!   User pacifier
!
          percent = j
          j = i - iloop + 1
          if (nvar*test/(j*3600) > 0.1d0 .or. lpacifier) then
            lpacifier = .true.
            sum = (nvar - i)*(test/(j*3600))
            write(line,"(a,i3,a,f7.2,a)") &
              "    Hessian",percent,"% complete.  Estimated remaining time required:", sum, " hours"
            write(iw,"(a)")trim(line)
            call to_screen(line)
          end if
        end if
        if (nvar*test/(j*3600) > 0.1d0 .or. lpacifier) then
          write(line,"(i5,a,i4,a)")i," of",nvar," steps completed"
          write(iw,"(a)")trim(line)
          if (iw0 >= 0) call to_screen(line)
        end if

        if (tleft < tstep*two) then
            !
            !  STORE PARTIAL HESSIAN PATRIX
            !  STORE GRADIENT FOR GEOMETRY AND ILOOP AS POSITIVE
          write (iw, "(A)") " NOT ENOUGH TIME TO COMPLETE HESSIAN"
          write (iw, "(A,I4)") " STOPPING IN HESSIAN AT COORDINATE:", i
          ipow(9) = 1
          ipow(2) = nstep
          tt0 = seconds (1) - time0
          j = i
          call efsav (tt0, hess, funct, grad, xparam, pmat, j, bmat, &
               & ipow, oldf, d, vmode)
          tleft = -0.1d0
          call mopend("NOT ENOUGH TIME TO COMPLETE HESSIAN")
          return
        end if
      end do
      !     FIX LAST ENTRY IN GEO ARRAY, THIS IS CURRENTLY AT VALUE-XINC
      k = loc(1, nvar)
      l = loc(2, nvar)
      geo(l, k) = xparam(nvar)
      if (ndep /= 0) then
        call symtry ()
      end if
      !        ADD ALL TIME USED BACK TO TLEFT, THIS WILL THEN BE SUBTRACTED
      !        AGAIN IN MAIN EF ROUTINE
      time2 = seconds (1)
      tstep = time2 - tstore
      tleft = tleft + tstep
    end if
   !
   !     SYMMETRIZE HESSIAN
   !
    do i = 1, nvar
      do j = 1, i - 1
        hess(i, j) = (hess(i, j)+hess(j, i)) / two
        hess(j, i) = hess(i, j)
      end do
    end do
    deallocate (gnext1, gmin1)

end subroutine gethes
subroutine overlp (dmax, ddmin, newmod, nvar, lorjk, u, vmode)
    use molkst_C, only: numcal
    use chanel_C, only: iw
    use ef_C, only: ef_mode, iprnt, omin
    implicit none
    logical, intent (inout) :: lorjk
    integer, intent (in) :: nvar
    integer, intent (out) :: newmod
    double precision, intent (in) :: ddmin, dmax
    double precision, dimension (nvar), intent (inout) :: vmode
    double precision, dimension (nvar, nvar), intent (in) :: u
    integer :: i
    integer, save :: icalcn = 0, it
    double precision :: ovlp, tovlp
    intrinsic Abs
    double precision, external :: dot
   !
   ! ... Executable Statements ...
   !
   !  ON THE FIRST STEP SIMPLY DETERMINE WHICH MODE TO FOLLOW
   !
   !     IF(NSTEP.EQ.1) THEN
    if (icalcn /= numcal) then
      icalcn = numcal !
      if (ef_mode > nvar) then
        write (iw,*) "ERROR!! MODE IS LARGER THAN NVAR", ef_mode
        call mopend ("ERROR!! MODE IS LARGER THAN NVAR")
        return
      else
        it = ef_mode
        if (iprnt >= 1) then
10000     format (5 x, "HESSIAN MODE FOLLOWING SWITCHED ON"/ &
               & "     FOLLOWING MODE ", i3)
          write (iw, 10000) ef_mode
        end if
      end if
    else
      !
      !  ON SUBSEQUENT STEPS DETERMINE WHICH HESSIAN EIGENVECTOR HAS
      !  THE GREATEST OVERLAP WITH THE MODE WE ARE FOLLOWING
      !
      it = 1
      lorjk = .false.
      tovlp = dot (u(1, 1), vmode, nvar)
      tovlp = Abs (tovlp)
      do i = 2, nvar
        ovlp = dot (u(1, i), vmode, nvar)
        ovlp = Abs (ovlp)
        if (ovlp > tovlp) then
          tovlp = ovlp
          it = i
        end if
      end do
      !
      if (iprnt >= 1) then
10010   format (5 x, "OVERLAP OF CURRENT MODE", i3, &
             & " WITH PREVIOUS MODE IS ", f6.3)
        write (iw, 10010) it, tovlp
      end if
      if (tovlp < omin) then
        if (dmax > ddmin) then
          lorjk = .true.
          if (iprnt >= 1) then
10020       format (5 x, "OVERLAP LESS THAN OMIN", f6.3, &
                 & " REJECTING PREVIOUS STEP")
            write (iw, 10020) omin
          end if
          return
        else if (iprnt >= 1) then
10030     format (5 x, "OVERLAP LESS THAN OMIN", f6.3, " BUT TRUST RADIUS", &
               & f6.3, " IS LESS THAN DDMIN", f6.3,/, 5 x, " ACCEPTING STEP")
          write (iw, 10030) omin, dmax, ddmin
        end if
      end if
    end if
   !
   !  SAVE THE EIGENVECTOR IN VMODE
   !
    do i = 1, nvar
      vmode(i) = u(i, it)
    end do
   !
    newmod = it
!
end subroutine overlp
subroutine prjfc (f, xparam, nvar, cof, p, atmass, x, rm, dx, coord)
    use molkst_C, only: numat
    use chanel_C, only: iw
    implicit none
    integer, intent (in) :: nvar
    double precision, dimension (nvar), intent (in) :: xparam
    double precision, dimension (nvar), intent (inout) :: dx, rm, x
    double precision, dimension (numat), intent (in) :: atmass
    double precision, dimension (3, numat), intent (inout) :: coord
    double precision, dimension (nvar, nvar), intent (inout) :: cof, f, p
    double precision, parameter :: zero = 0.0d+00
    double precision, parameter :: one = 1.0d+00
    double precision, parameter :: cut8 = 1.0d-08
    integer :: i, ia, ib, ic, ii, ij, indx, info, ip, j, ja, jb, jc, &
         & jend, jj, jndx, jp, l, natm_loc, nc1
    double precision :: chk, det, sum, tmp, totm, trp
    integer, dimension (6) :: iscr_loc
    double precision, dimension (2) :: det2
    double precision, dimension (3) :: cmass
    double precision, dimension (3, 3) :: rot, scr
    double precision, dimension (3, 3, 3), save :: tens
    intrinsic Abs, Sqrt
    data tens / 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, -1.0d0, &
   & 0.0d0, 1.0d0, 0.0d0, 0.0d0, 0.0d0, 1.0d0, 0.0d0, 0.0d+0, &
   & 0.0d0, -1.0d0, 0.0d0, 0.0d0, 0.0d0, -1.0d0, 0.0d0, &
   & 1.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0 /
    natm_loc = nvar / 3
    nc1 = nvar
    ij = 1
    do i = 1, natm_loc
      coord(1, i) = xparam(ij)
      coord(2, i) = xparam(ij+1)
      coord(3, i) = xparam(ij+2)
      ij = ij + 3
    end do
   !     CALCULATE 1/SQRT(MASS)
    l = 0
    do i = 1, natm_loc
      tmp = one / Sqrt (atmass(i))
      do j = 1, 3
        l = l + 1
        rm(l) = tmp
      end do
    end do
   !     PREPARE GRADIENT
    do i = 1, nc1
      dx(i) = zero
    end do
   !     FIND CMS AND CALCULATED MASS WEIGHTED COORDINATES
    totm = zero
    cmass(1) = zero
    cmass(2) = zero
    cmass(3) = zero
    do i = 1, natm_loc
      totm = totm + atmass(i)
      do j = 1, 3
        cmass(j) = cmass(j) + atmass(i) * coord(j, i)
      end do
    end do
    do j = 1, 3
      cmass(j) = cmass(j) / totm
    end do
    l = 0
    do i = 1, natm_loc
      do j = 1, 3
        tmp = Sqrt (atmass(i))
        l = l + 1
        x(l) = tmp * (coord(j, i)-cmass(j))
      end do
    end do
   ! 2. COMPUTE INERTIA TENSOR.
    do i = 1, 3
      do j = 1, 3
        rot(i, j) = zero
      end do
    end do
    do i = 1, natm_loc
      l = 3 * (i-1) + 1
      rot(1, 1) = rot(1, 1) + x(l+1) ** 2 + x(l+2) ** 2
      rot(1, 2) = rot(1, 2) - x(l) * x(l+1)
      rot(1, 3) = rot(1, 3) - x(l) * x(l+2)
      rot(2, 2) = rot(2, 2) + x(l) ** 2 + x(l+2) ** 2
      rot(2, 3) = rot(2, 3) - x(l+1) * x(l+2)
      rot(3, 3) = rot(3, 3) + x(l) ** 2 + x(l+1) ** 2
    end do
    rot(2, 1) = rot(1, 2)
    rot(3, 1) = rot(1, 3)
    rot(3, 2) = rot(2, 3)
   !
   !CHECK THE INERTIA TENSOR.
    chk = rot(1, 1) * rot(2, 2) * rot(3, 3)
    if (Abs (chk) > cut8) then
      !
      ! 4. COMPUTE INVERSION MATRIX OF ROT.
      !     CALL MXLNEQ(ROT,3,3,DET,JRNK,EPS,SCR,+0)
      !     IF(JRNK.LT.3) CALL MOPEND
      !      IF(JRNK.LT.3) RETURN
      info = 0
      call dgefa (rot, 3, 3, iscr_loc, info)
      if (info /= 0) then
        if (numat == 3 .and. natm_loc == 3) then
          call mopend ("ERROR DETECTED IN EF: SYSTEM IS TRIATOMIC AND ALMOST LINEAR")
          write(iw,'(/10x,a)')"Nine geometric parameters marked for optimization."
          write(iw,'(10x,a)')"Reduce this to three or four."
        else
          call mopend ("ERROR DETECTED IN EF: SYSTEM IS ALMOST BUT NOT EXACTLY LINEAR")
          write(iw,'(/10x,a)')"Either define it as being linear or define it as being non-linear."
        end if
      end if
      if (info /= 0) return
      det = zero
      call dgedi (rot, 3, 3, iscr_loc, det2, scr, 1)
    else if (Abs (rot(1, 1)) > cut8) then
      ! X.NE.0
      if (Abs (rot(2, 2)) > cut8) then
         !* 4. X,Y.NE.0 BUT Z=0
        det = rot(1, 1) * rot(2, 2) - rot(1, 2) * rot(2, 1)
        trp = rot(1, 1)
        rot(1, 1) = rot(2, 2) / det
        rot(2, 2) = trp / det
        rot(1, 2) = -rot(1, 2) / det
        rot(2, 1) = -rot(2, 1) / det
      else if (Abs (rot(3, 3)) > cut8) then
         !* 5. X,Z.NE.0 BUT Y=0
        det = rot(1, 1) * rot(3, 3) - rot(1, 3) * rot(3, 1)
        trp = rot(1, 1)
        rot(1, 1) = rot(3, 3) / det
        rot(3, 3) = trp / det
        rot(1, 3) = -rot(1, 3) / det
        rot(3, 1) = -rot(3, 1) / det
      else
         !* 3. Y,Z=0 BUT X.NE.0
        rot(1, 1) = one / rot(1, 1)
      end if
   ! X=0
    else if (Abs (rot(2, 2)) > cut8) then
      ! Y.NE.0
      if (Abs (rot(3, 3)) > cut8) then
         !* 6. Y,Z.NE.0 BUT X=0
        det = rot(3, 3) * rot(2, 2) - rot(3, 2) * rot(2, 3)
        trp = rot(3, 3)
        rot(3, 3) = rot(2, 2) / det
        rot(2, 2) = trp / det
        rot(3, 2) = -rot(3, 2) / det
        rot(2, 3) = -rot(2, 3) / det
      else
         !* 2. X,Z=0 BUT Y.NE.0
        rot(2, 2) = one / rot(2, 2)
      end if
   ! X,Y=0
    else if (Abs (rot(3, 3)) > cut8) then
      !
      !* 1. X,Y=0 BUT Z.NE.0
      rot(3, 3) = one / rot(3, 3)
    else
10000 format (1 x, "EVERY DIAGONAL ELEMENTS ARE ZERO ?", 3 f20.10)
      write (iw, 10000) rot(1, 1), rot(2, 2), rot(3, 3)
      return
    end if
   !
   ! 5. TOTAL MASS ---> TOTM.
   !
   ! 6. COMPUTE P MATRIX
   !    ----------------
    do ip = 1, natm_loc
      indx = 3 * (ip-1)
      do jp = 1, ip
        jndx = 3 * (jp-1)
        do ic = 1, 3
          jend = 3
          if (jp == ip) then
            jend = ic
          end if
          do jc = 1, jend
            sum = zero
            do ia = 1, 3
              do ib = 1, 3
                if (tens(ia, ib, ic) /= 0.d0) then
                  do ja = 1, 3
                    do jb = 1, 3
                      if (tens(ja, jb, jc) /= 0.d0) then
                        sum = sum + tens(ia, ib, ic) * tens(ja, jb, jc) * &
                       & rot(ia, ja) * x(indx+ib) * x(jndx+jb)
                      end if
                    end do
                  end do
                end if
              end do
            end do
            ii = indx + ic
            jj = jndx + jc
            p(ii, jj) = sum + dx(ii) * dx(jj)
            if (ic == jc) then
              p(ii, jj) = p(ii, jj) + one / (rm(ii)*rm(jj)*totm)
            end if
          end do
        end do
      end do
    end do
   !
   ! 7. COMPUTE DELTA(I,J)-P(I,J)
    do i = 1, nc1
      do j = 1, i
        p(i, j) = -p(i, j)
        if (i == j) then
          p(i, j) = one + p(i, j)
        end if
      end do
    end do
   !
   ! 8. NEGLECT SMALLER VALUES THAN 10**-8.
    do i = 1, nc1
      do j = 1, i
        if (Abs (p(i, j)) < cut8) then
          p(i, j) = zero
        end if
        p(j, i) = p(i, j)
      end do
    end do

! For GPU MOPAC
! GBR_new_addition
   !     USE COF FOR SCRATCH.
    call dgemm ("N", "N", nc1, nc1, nc1, 1.0d0, f, nvar, p, nvar, &
         & 0.0d0, cof, nvar)
   !
   ! 11. COMPUTE P*F*P.
   !
    call dgemm ("N", "N", nc1, nc1, nc1, 1.0d0, p, nvar, cof, nvar, &
         & 0.0d0, f, nvar)
    continue
    return
!
end subroutine prjfc
subroutine prthes (eigval, nvar, hess, u)
    use chanel_C, only: iw
    use ef_C, only: iprnt
   !
   !.. Implicit Declarations ..
    implicit none
   !
   !.. Formal Arguments ..
    integer, intent (in) :: nvar
    double precision, dimension (nvar), intent (in) :: eigval
    double precision, dimension (nvar, nvar), intent (in) :: hess, u
   !
   !.. Local Scalars ..
    integer :: i, j, low, nup
   !
   !.. Intrinsic Functions ..
    intrinsic Min
   !
   ! ... Executable Statements ...
   !
    if (iprnt >= 4) then
      write (iw,*) " "
      write (iw,*) "              HESSIAN MATRIX"
      low = 1
      nup = 8
      do
        nup = Min (nup, nvar)
10000   format (/, 3 x, 8 i9)
        write (iw, 10000) (i, i=low, nup)
        do i = 1, nvar
10010     format (1 x, i3, 8 f9.1)
          write (iw, 10010) i, (hess(i, j), j=low, nup)
        end do
        nup = nup + 8
        low = low + 8
        if (low > nvar) exit
      end do
    end if
    write (iw,*) " "
    write (iw,*) "              HESSIAN EIGENVALUES AND -VECTORS"
    low = 1
    nup = 8
    do
      nup = Min (nup, nvar)
      write (iw, 10000) (i, i=low, nup)
10020 format (/, 4 x, 8 f9.1, /)
      write (iw, 10020) (eigval(i), i=low, nup)
      do i = 1, nvar
10030   format (1 x, i3, 8 f9.4)
        write (iw, 10030) i, (u(i, j), j=low, nup)
      end do
      nup = nup + 8
      low = low + 8
      if (low > nvar) exit
    end do
end subroutine prthes
subroutine updhes (svec, tvec, grad, nvar, iupd, hess, oldf, d)
    use molkst_C, only: numcal
    use chanel_C, only: iw
    use ef_C, only: iprnt, ddx
    implicit none
    integer, intent (in) :: iupd, nvar
    double precision, dimension (nvar), intent (in) :: d, grad, oldf
    double precision, dimension (nvar), intent (inout) :: svec, tvec
    double precision, dimension (nvar, nvar), intent (inout) :: hess
    integer :: i
    integer, save :: icalcn = 0
    integer :: j
    double precision :: dds, ddtd, temp
    double precision, save :: zero = 0.0d0
    double precision, external :: dot, ddot
!


   !
   ! ... Executable Statements ...
   !
   !  UPDATING OF THE HESSIAN
   !  DEPENDS ON CURRENT grad, OLD grad AND THE
   !  CORRECTION VECTOR USED ON THE LAST CYCLE
   !  SVEC & TVEC ARE FOR TEMPORARY STORAGE
   !
   !  2 UPDATING PROCEDURES ARE POSSIBLE
   !  (I)   THE POWELL UPDATE
   !        THIS PRESERVES THE SYMMETRIC CHARACTER OF THE HESSIAN
   !        WHILST ALLOWING ITS EIGENVALUE STRUCTURE TO CHANGE.
   !        IT IS THE DEFAULT UPDATE FOR A TRANSITION STATE SEARCH
   !  (II)  THE BFGS UPDATE
   !        THIS UPDATE HAS THE IMPORTANT CHARACTERISTIC OF RETAINING
   !        POSITIVE DEFINITENESS (NOTE: THIS IS NOT RIGOROUSLY
   !        GUARANTEED, BUT CAN BE CHECKED FOR BY THE PROGRAM).
   !        IT IS THE DEFAULT UPDATE FOR A MINIMUM SEARCH
   !
   !     SWITCH : IUPD
   !       IUPD = 0  :  SKIP UPDATE
   !       IUPD = 1  :  POWELL
   !       IUPD = 2  :  BFGS
   !
    if (icalcn /= numcal) then
      icalcn = numcal
      if (iprnt >= 2) then
        if (iupd == 0) then
10000     format (/, 5x, "HESSIAN IS NOT BEING UPDATED", /)
          write (iw, 10000)
        end if
        if (iupd == 1) then
            !
10010     format (/, 5x, &
               & "HESSIAN IS BEING UPDATED USING THE POWELL UPDATE", /)
          write (iw, 10010)
        end if
        if (iupd == 2) then
10020     format (/, 5x, "HESSIAN IS BEING UPDATED USING THE BFGS UPDATE", /)
          write (iw, 10020)
        end if
      end if
    end if
    if (iupd == 0) return
    do i = 1, nvar
      tvec(i) = zero
    end do
    do j = 1, nvar
      do i = 1, nvar
        tvec(i) = tvec(i) + hess(i, j) * d(j)
      end do
    end do
   !
    if (iupd == 1) then
      !
      !   (I) POWELL UPDATE
      !
      do i = 1, nvar
        tvec(i) = grad(i) - oldf(i) - tvec(i)
        svec(i) = grad(i) - oldf(i)
      end do
      dds = ddx * ddx

      ddtd = dot (tvec, d, nvar)
      if (Abs(dds - zero) < 1.d-20) then
        write (iw, "(' CALCULATION IS TERMINATED TO AVOID ZERO DIVIDE')")
        call mopend ("in UPDHES")
        return
      end if
      ddtd = ddtd / dds
      !
      do i = 2, nvar
        do j = 1, i - 1
          temp = tvec(i) * d(j) + d(i) * tvec(j) - d(i) * ddtd * d(j)
          hess(i, j) = hess(i, j) + temp / dds
          hess(j, i) = hess(i, j)
        end do
      end do
      do i = 1, nvar
        temp = d(i) * (2.0d0*tvec(i)-d(i)*ddtd)
        hess(i, i) = hess(i, i) + temp / dds
      end do
    end if
    if (iupd /= 2) return
   !
   !  (II) BFGS UPDATE
   !
    do i = 1, nvar
      svec(i) = grad(i) - oldf(i)
    end do
    dds = ddot (nvar, svec, 1, d, 1)
    ddtd = ddot (nvar, d, 1, tvec, 1)
!
   !
    if (Abs(dds - zero) < 1.d-20 .or. Abs(ddtd) < 1.d-20) then
      write (iw, "(' CALCULATION IS TERMINATED TO AVOID ZERO DIVIDE')")
      call mopend ("in UPDHES")
      return
    end if
    do i = 2, nvar
      do j = 1, i - 1
        temp = (svec(i)*svec(j)) / dds - (tvec(i)*tvec(j)) / ddtd
        hess(i, j) = hess(i, j) + temp
        hess(j, i) = hess(i, j)
      end do
    end do
    do i = 1, nvar
      temp = (svec(i)*svec(i)) / dds - (tvec(i)*tvec(i)) / ddtd
      hess(i, i) = hess(i, i) + temp
    end do
end subroutine updhes

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  subroutine txtype (jj, jtype, letter)
!
!  Construct the Greek letter for each atom using
!  the PDB convention.  The letter will go in character 15
!  of the entries in array "txtatm"  If there is also a number,
!  it will go in character 16.
!
    use common_arrays_C, only : txtatm, nat, nbonds, ibonds
    implicit none
    character, intent (in) :: letter
    integer, intent (inout) :: jj
    integer, dimension (jj), intent (inout) :: jtype
!
    integer :: i, j, k, loop, m
   !
   !   Remove any duplicates from JTYPE
   !
    j = 1
    k = 1
    outer_loop: do i = 2, jj
      do k = 1, j
        if (jtype(k) == jtype(i)) cycle outer_loop
      end do
      j = j + 1
      jtype(j) = jtype(i)
    end do outer_loop
    jj = j
    do loop = 1, 4
      m = 0
      do i = 1, jj
        if (nat(jtype(i)) /= 1) then
          m = m + 1
          k = i
        end if
      end do
      !
      !   Make symbol for atom.  Greek letter goes in 15:15
      !                            and number goes in 16:16
      !
      if (m == 1) then
        txtatm (jtype(k)) (15:15) = letter
        j = jtype(k)
        m = 0
        do i = 1, nbonds(j)
          if (txtatm(ibonds(i, j)) (16:16) /= " ") then
            txtatm(j) (16:16) = txtatm(ibonds(i, j)) (16:16)
            m = m + 1
          end if
        end do
        if (m /= 1) then
          txtatm (j) (16:16) = " "
        end if
        if (txtatm(j)(18:20) == "TRP" .and. letter == "H") then
          txtatm (j) (16:16) = "2"
        end if
      else
        m = 0
!
!  Special case: Tryptophan zeta starts with 2, not 1
!
        if (txtatm(j)(18:20) == "TRP" .and. letter == "Z") m = 1
        do i = 1, jj
          j = jtype(i)
          if (nat(jtype(i)) /= 1) then
            m = m + 1
            txtatm(j) (15:15) = letter
            if (txtatm(j)(18:20) /= "UNK" .or. txtatm (j) (16:16) == " " &
              .or. txtatm (j) (16:16) > Char (min(9,m)+Ichar ("0"))) then
              txtatm (j) (16:16) = Char (min(9,m)+Ichar ("0"))
            end if
          end if
        end do
      end if
    end do
end subroutine txtype

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine compfg(xparam, int, escf, fulscf, grad, lgrad)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!
      USE funcon_C, only : fpc_9
!
      USE chanel_C, only : iw
!
      use elemts_C, only : elemnt
!
      USE molmec_C, only : nnhco, nhco, htype
!
      use MOZYME_C, only : partf
!
      use common_arrays_C, only : nat, loc, geo, na, nb, nc, geoa, &
      & coord, xparef, aicorr, tvec, labels, pa, p, pdiag, f, nlast, h, nfirst, c, eigs
!
      USE molkst_C, ONLY: numat, norbs, nelecs, nclose, nopen, fract, natoms, numcal, &
      & ndep, nvar, elect, enuclr, keywrd, moperr, emin, mozyme, method_PM7, lxfac, &
      atheat, id, pressure, method_pm6, density, stress, N_3_present, Si_O_H_present, &
      use_ref_geo, hpress, nsp2_corr, Si_O_H_corr, sum_dihed, method_PM6_D3H4X, method_PM6_D3H4, &
      method_PM6_D3, method_pm7_minus, method_pm6_dh_plus, method_pm7_hh, method_pm8, &
      method_pm6_org, method_indo, mpack, e_disp
!
      use cosmo_C, only : iseps, useps, noeps, solv_energy
!
      use linear_cosmo, only : ini_linear_cosmo, coscavz
      use reimers_C, only: x, y, z, xz, zcore, beta, gamma, s, betao, ibf, &
      & natm, r, nbf, nbt, nprn, iat, natt, zcorea, betaa, matind, n, &
      & nprin, vnn, dm, ef, dd, ff, cc0, aa, dtmp, nb2, ppg, pg, nsym
!
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision , intent(out) :: escf
      logical , intent(in) :: int
      logical, intent(in)  :: fulscf
      logical , intent(in) :: lgrad
      double precision , intent(in) :: xparam(nvar)
      double precision  :: grad(nvar)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: icalcn, i, j, k, l
      double precision, dimension(3) :: degree
      double precision :: angle, atheat_store, sum, store_e_disp
      double precision, external ::  nsp2_correction, Si_O_H_correction
      double precision, external :: helecz
      logical :: debug, print, large, usedci, force, times, aider, &
        dh, l_locate_ts
      double precision, external :: xfac_value, reada
      double precision, external :: ddot, dot, volume
      character :: tmpkey*241

      save debug, print, large, usedci, force, times, aider, degree, &
        icalcn, dh, l_locate_ts
!***********************************************************************
!
!   COMPFG CALCULATES (A) THE HEAT OF FORMATION OF THE SYSTEM, AND
!                     (B) THE GRADIENTS, IF LGRAD IS .TRUE.
!
!   ON INPUT  XPARAM = ARRAY OF PARAMETERS TO BE USED IN INTERNAL COORDS
!             LGRAD  = .TRUE. IF GRADIENTS ARE NEEDED, .FALSE. OTHERWISE
!             INT    = .TRUE. IF HEAT OF FORMATION IS TO BE CALCULATED
!             FULSCF = .TRUE. IF FULL SCF TO BE DONE, .FALSE. OTHERWISE.
!
!   ON OUTPUT ESCF  = HEAT OF FORMATION.
!             GRAD   = ARRAY OF GRADIENTS, IF LGRAD = .TRUE.
!
!***********************************************************************
      data icalcn/ 0/
      if (lxfac) then
        if (index(keywrd," POP") /= 0) then
          pa = 0.d0
          i = index(keywrd," POP") + 4
          pa(1)  = reada(keywrd,i+1)    !  "s"-population
          pa(3)  = reada(keywrd,i+3)/3  !  "p"-population
          pa(6)  = pa(3)
          pa(10) = pa(3)
          pa(15) = reada(keywrd,i+5)/5  !  "d"-population
          pa(21) = pa(15)
          pa(28) = pa(15)
          pa(36) = pa(15)
          pa(45) = pa(15)
          p = pa
          pa = pa*0.5d0
          pdiag(1)   = p(1)
          pdiag(2:4) = p(3)
          pdiag(5:9) = p(15)
        else
          escf = xfac_value()
          return
        end if
      end if
      if (icalcn /= numcal) then
        icalcn = numcal
        hpress = 0.d0
        nsp2_corr = 0.d0
        Si_O_H_corr = 0.d0
        sum_dihed = 0.d0
        if (iseps) then
          iseps = .true.
          noeps = .true.
          call cosini(.true.)
          if (moperr) return
          mozyme = (index(keywrd," MOZ") + index(keywrd," LOCATE-TS") + index(keywrd," RAPID") /= 0)
          if (mozyme .and. numat == 1) then
            call mopend("MOZYME cannot be used for systems composed of only one atom!")
            return
          end if
          if (mozyme) call ini_linear_cosmo
        else
          iseps = .false.
          noeps = .false.
        end if
        aider = index(keywrd,'AIDER') /= 0
        times = index(keywrd,'TIMES') /= 0
        usedci = nclose/=nopen .and. Abs(fract - 2.d0) > 1.d-20 .and. &
          fract > 1.d-20 .or. index(keywrd,'C.I.')/=0
        force = index(keywrd,'FORCE') /= 0
        large = index(keywrd,'LARGE') /= 0
        print = index(keywrd,'COMPFG') /= 0
        l_locate_ts = index(keywrd,'LOCATE-TS') /= 0
        debug = index(keywrd,'DEBUG')/=0 .and. print
        dh = (method_pm6_d3h4x .or. method_pm6_d3h4    .or. &
              method_pm6_d3    .or. method_pm6_dh_plus .or. &
              method_pm7_hh    .or. method_pm7_minus   .or. &
              method_PM7 .or. method_pm6_org .or. method_pm8)
        emin = 0.D0
        xparef(:nvar) = xparam(:nvar)
      end if
!
! SET UP COORDINATES FOR CURRENT CALCULATION
!
!       PLACE THE NEW VALUES OF THE VARIABLES IN THE ARRAY GEO.
!       MAKE CHANGES IN THE GEOMETRY.
      do i = 1, nvar
        k = loc(1,i)
        l = loc(2,i)
        geo(l,k) = xparam(i)
      end do
!      IMPOSE THE SYMMETRY CONDITIONS + COMPUTE THE DEPENDENT-PARAMETERS
      if (ndep /= 0) call symtry
!      NOW COMPUTE THE ATOMIC COORDINATES.
      if (debug) then
        if (large) then
          k = natoms
        else
          k = min(5,natoms)
        end if
        write(iw,"(a)")" COORDINATES IN ARRAY 'GEO'"
        degree(1) = 1.d0
        do i = 1, k
          if (na(i) > 0) then
            degree(2:3) = 57.29577951308232D0
          else
            degree(2:3) = 1.d0
          end if
          write (iw, "(i4,3x,a2,3x,3F14.5,3i5)") i,elemnt(labels(i)), &
          (geo(j, i)*degree(j), j=1, 3), na(i), nb(i), nc(i)
        end do
      end if
      call gmetry (geo, coord)
      if (moperr) return
      if (debug) then
        if (large) then
          k = numat
        else
          k = min(5,numat)
        end if
        write (iw, '('' CARTESIAN COORDINATES'',/10000(/,i4,3x,a2,3x,3F16.9))') &
          (i,elemnt(nat(i)),(coord(j,i),j=1,3),i=1,k)
      end if
      if (iseps) then
      ! The following routine constructs the dielectric screening surface
      if (mozyme) then
          call coscavz(coord, nat)
        else
          call coscav
          call mkbmat
        end if
        if (moperr) return
        if (noeps) useps = .false.
      end if
      if (index(keywrd,' HCORE') /= 0) call prtpar
      if (times) call timer ('BEFORE HCORE')
      if (mozyme) then
        if (iseps) useps = .true.
        if (l_locate_ts .or. int) call hcore_for_MOZYME ()
        if (moperr) return
      else if (method_indo) then
! Set up Reimers data
        if (allocated(x))     deallocate(x)
        if (allocated(y))     deallocate(y)
        if (allocated(z))     deallocate(z)
        if (allocated(xz))    deallocate(xz)
        if (allocated(zcore)) deallocate(zcore)
        if (allocated(beta))  deallocate(beta)
        if (allocated(gamma)) deallocate(gamma)
        if (allocated(s))     deallocate(s)
        if (allocated(betao)) deallocate(betao)
        if (allocated(ibf))   deallocate(ibf)
        if (allocated(natm))  deallocate(natm)
        if (allocated(r))     deallocate(r)
        if (allocated(nbf))   deallocate(nbf)
        if (allocated(nbt))   deallocate(nbt)
        if (allocated(nprn))  deallocate(nprn)
        if (allocated(iat))   deallocate(iat)
        if (allocated(natt))  deallocate(natt)
        if (allocated(dd))    deallocate(dd)
        if (allocated(cc0))   deallocate(cc0)
        if (allocated(aa))    deallocate(aa)
        if (allocated(ff))    deallocate(ff)
        if (allocated(dtmp))  deallocate(dtmp)
        if (allocated(dd))    deallocate(dd)
        if (allocated(ppg))   deallocate(ppg)
        if (allocated(pg))    deallocate(pg)
        if (allocated(nsym))  deallocate(nsym)
        allocate(x(numat))
        allocate(y(numat))
        allocate(z(numat))
        allocate(xz(numat,3))
        allocate(zcore(numat))
        allocate(beta(mpack))
        allocate(gamma(norbs,norbs))
        gamma = 0.d0
        allocate(s(mpack))
        allocate(betao(norbs))
        allocate(ibf(numat))
        allocate(natm(numat))
        allocate(r(numat,numat))
        allocate(nbf(numat))
        allocate(nbt(norbs))
        allocate(nprn(norbs))
        allocate(iat(norbs))
        allocate(natt(norbs))


        matind(1) = 0
        do i=2,50000
          matind(i) = matind(i-1) + i-1
        end do
        n = norbs
     !   na = numat

        do i=1,numat
          x(i) = coord(1,i)
          y(i) = coord(2,i)
          z(i) = coord(3,i)
          xz(i,1) = coord(1,i)
          xz(i,2) = coord(2,i)
          xz(i,3) = coord(3,i)
          zcore(i) = zcorea(labels(i))
          ibf(i) = nfirst(i)
          natm(i) = labels(i)
          natt(i) = labels(i)
          nbf(i) = nlast(i) - nfirst(i) + 1
          do j=nfirst(i),nlast(i)
            nbt(j) = j - nfirst(i)
            iat(j) = i
            if (j-nfirst(i).eq.0) then
              betao(j) = betaa(1,labels(i))
              nprn(j) = nprin(labels(i))
            else if (j-nfirst(i).le.3) then
              betao(j) = betaa(2,labels(i))
              nprn(j) = nprin(labels(i))
            else
              betao(j) = betaa(3,labels(i))
              nprn(j) = nprin(labels(i))-1
            end if
          end do
        end do
! Call Reimers INDO routine
        call replsn ()

        enuclr = vnn
        call ovlap  (s,x,y,z)
        call beta1  (s,betao,beta)
! Add electric field correction - borrow code from hcore
        tmpkey = trim(keywrd)
        i = index(tmpkey,' FIELD(') + index(tmpkey,' FIELD=(')
        if (i /= 0) then
!   ERASE ALL TEXT FROM TMPKEY EXCEPT FIELD DATA
          tmpkey(:i) = ' '
          tmpkey(index(tmpkey,')'):) = ' '
!   READ IN THE EFFECTIVE FIELD IN X,Y,Z COORDINATES
          ef(1) = reada(tmpkey,i)
          i = index(tmpkey,',')
          if (i /= 0) then
            tmpkey(i:i) = ' '
            ef(2) = reada(tmpkey,i)
            i = index(tmpkey,',')
            if (i /= 0) then
              tmpkey(i:i) = ' '
              ef(3) = reada(tmpkey,i)
            end if
          end if
          write (iw,'(/10X,''THE ELECTRIC FIELD IS'',3F10.5,&
             &''VOLTS/ANGSTROM'',/)') ef
! Reimers code uses E field in V/A
          do i = 1,3
            ef(i) = -ef(i)
          end do
! Back to Reimers-specific stuff
          nb2 = mpack
          if(.not. allocated(dm))     allocate(dm(nb2,3))
          call dipol (x,y,z,dm)
          call efmods (beta,zcore,dm)
        end if
! Put Reimers data back into h
        do i= 1,mpack
          h(i) = beta(i)
        end do
! Solvent correction
        if (useps) then
          call addnuc ()
          call addhcr ()
!     Put h back into beta
          do i= 1,mpack
            beta(i) = h(i)
          end do
        end if
      else
        if (int) call hcore ()
        if (moperr) return
      end if
       atheat_store = atheat
      if (times) call timer ('AFTER  HCORE')
!
! COMPUTE THE HEAT OF FORMATION.
!
      if (norbs > 0 .and. nelecs > 0) then
!
!  Put any ad-hoc corrections to the HoF here, so they will show up if PL
!  is used
!
        hpress = 0.d0
        if (Abs (pressure) > 1.d-4) then
          if (id == 1) then
            hpress = -pressure * Sqrt (dot(tvec(1, 1), tvec(1, 1), 3))
          else if (id == 3) then
            hpress = -pressure * volume (tvec, 3)
          end if
          atheat = atheat + hpress
        end if
        if (useps .and. .not. mozyme) atheat = atheat + solv_energy * fpc_9
!
!  Add in any molecular-mechanics type corrections here
!
        if (method_pm6 .and. N_3_present) then
          nsp2_corr = nsp2_correction()
          atheat = atheat + nsp2_corr
        end if
        if (method_pm7 .and. Si_O_H_present) then
          Si_o_H_corr = Si_O_H_correction()
          atheat = atheat + Si_O_H_corr
        end if
        call setup_nhco(i)
        sum_dihed = 0.d0
        do i = 1, nnhco
          call dihed (coord, nhco(1,i), nhco(2,i), nhco(3,i), nhco(4,i), angle)
          sum_dihed = sum_dihed + htype*sin(angle)**2
        end do
        atheat = atheat + sum_dihed
        stress = 0.d0
        if(use_ref_geo) then
          do i = 1, numat
            do j = 1,3
              stress = stress + (geo(j,i) - geoa(j,i))**2
            end do
          end do
        end if
        if (dh) then
          call post_scf_corrections(sum, .false.)
          if (moperr) return
          atheat =  sum + atheat
        end if
        if (times) call timer ('BEFORE ITER')
        if (int) then
          if (mozyme) then
            call iter_for_MOZYME (elect)
          else
            call iter (elect, fulscf, .TRUE.)
          end if
          if (moperr) return
          if (noeps) then
            noeps = .false.
            useps = .true.
            if ( .not. mozyme) then
              if (.not. method_indo) call hcore ()
              if (method_indo) then
                call addnuc ()
                call addhcr ()
                do i= 1,mpack
                  beta(i) = h(i)
                end do
              end if
              call iter (elect, fulscf, .TRUE.)
            end if
          end if
        else
          if (mozyme) then
             call buildf (f, partf, 0)
             elect = helecz()
           end if
        end if
        stress = stress*density
        atheat = atheat + stress
        if (moperr) return
        if (times) call timer ('AFTER  ITER')
      else
        elect = 0.D0
      end if
      escf = (elect + enuclr)*fpc_9 + atheat
      if (useps .and. mozyme) then
            escf = escf + solv_energy * fpc_9
      end if
      if (.not. dh) then
        call post_scf_corrections(sum, .false.)
        if (moperr) return
        escf =  sum + escf
      end if
      atheat = atheat_store
      if (escf < emin .or. emin == 0.D0) emin = escf
      if (method_indo) then
        call output (c,eigs)
      end if
!
! FIND DERIVATIVES IF DESIRED
!
      if (lgrad) then
        store_e_disp = e_disp
        if (times) call timer ('Before DERIV')
        if (nelecs > 0) call deriv (geo, grad)
        if (moperr) return
        if (times) call timer ('AFTER  DERIV')
        e_disp = store_e_disp
      end if
      if (aider) then
!
!  ADD IN AB INITIO CORRECTION
!
        escf = escf + ddot(nvar,xparam(:nvar)-xparef(:nvar),1,aicorr(:nvar),1)
      end if
      if (int .and. print) write (iw, '(/1X,'' HEAT OF FORMATION'',G30.17)') &
        escf
      if (print .and. lgrad) then
        write (iw, '('' PARAMETERS     '',8F8.3,(/10F8.3))') (xparam(i),i=1,nvar)
        write (iw, '('' GRADIENT       '',8F8.3,(/10F8.3))') (grad(i),i=1,nvar)
      end if
!
! REFORM DENSITY MATRIX, IF A C.I. DONE AND EITHER THE LAST SCF OR A
! FORCE CALCULATION
!
      if (usedci .and. force .and. .not. method_indo) call mecip ()
      return
      end subroutine compfg
!
!
!
      double precision function xfac_value()
      use parameters_C, only :  tore, guess1, guess2, guess3, alpb, xfac, po, pocord, &
        uss, upp, udd
      use common_arrays_C, only : nat, coord, pa, p, h, f, w
      use funcon_C, only : a0, ev, fpc_9
      USE molkst_C, ONLY: keywrd
      implicit none
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: ni, nj, i
      double precision :: enuc, abond, fff, scale, ax, r, &
        gab, enuclr, point, const
      double precision, external :: reada
        if (index(keywrd," POP") /= 0) then
          p = 0.d0
          i = index(keywrd," POP") + 4
          p(1)  = reada(keywrd,i+1)  !  "s"-population
          p(3)  = reada(keywrd,i+3)/3  !  "p"-population
          p(6)  = p(3)
          p(10) = p(3)
          p(15) = reada(keywrd,i+5)/5  !  "d"-population
          p(21) = p(15)
          p(28) = p(15)
          p(36) = p(15)
          p(45) = p(15)
          pa = p*0.5d0
          h = 0.d0
          h(1) = uss(nat(1))
          h(3) = upp(nat(1))
          h(6) = h(3)
          h(10) = h(3)
          h(15) = udd(nat(1))
          h(21) = h(15)
          h(28) = h(15)
          h(36) = h(15)
          h(45) = h(15)
          f = h
          call fock1(f, p, pa, 45, w, i, 1, 9, 45)
          xfac_value = 0.0d0 ! dummy return value for unaccessed branch
          return
        end if
        r = coord(1,2)
        ni = nat(1)
        nj = nat(2)
        if (pocord(ni) > 1.D-5) po(9,ni) = pocord(ni)
        if (pocord(nj) > 1.D-5) po(9,nj) = pocord(nj)
        gab = eV/sqrt((r/a0)**2 + (po(9,ni) + po(9,nj))**2)
        call to_point(r, point, const)
        gab = gab*const + (1.d0 - const)*point
        enuc = tore(ni)*tore(nj)*gab
        abond = alpb(ni,nj)
        if (abond  > 1.d-3) then
          fff = xfac(ni,nj)
          scale = 2.d0 * fff * Exp (-abond*(r + 0.0003*r**6))
          enuclr = enuc * scale
          scale = 0.d0
          ax = guess2(ni,1)*(r - guess3(ni,1))**2
          if (ax < 25.D0) scale = scale + tore(ni)*tore(nj)/r*guess1(ni,1)*exp((-ax))
          ax = guess2(nj,1)*(r - guess3(nj,1))**2
          if (ax < 25.D0) scale = scale + tore(ni)*tore(nj)/r*guess1(nj,1)*exp((-ax))
          enuclr = enuclr + scale
          ax = r/(ni**0.3333d0 + nj**0.3333d0)
          if (ax < 3.d0) then
            scale = 1.d-8/ax**12
            enuclr = enuclr + min(scale, 1.d5)
          end if
        else
          scale = 10.d0*exp((-2.18d0*r)) ! This is a generic core-core term.
          enuclr = abs(scale*enuc)
      end if
        xfac_value = enuclr*fpc_9
      end function xfac_value

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine diag_for_GPU (fao, vector, nocc, eig, norbs, mpack)
#ifdef MKL
    use molkst_C, only: num_threads
#endif
#ifdef GPU
    Use mod_vars_cuda, only: lgpu, prec, ngpus
    Use iso_c_binding
    use call_rot_cuda
    Use call_gemm_cublas
#endif
    implicit none
    integer, intent (in) :: nocc, mpack, norbs
    double precision, dimension (mpack), intent (in) :: fao
    double precision, dimension (norbs, norbs), intent (inout) :: vector
    double precision, dimension (norbs), intent (in) :: eig
    double precision, allocatable, dimension (:) :: fmo
    integer :: lumo, mdim, n, nvirt, i, ij, in, j,  norbs2
    double precision :: bigeps = 1.5d-007
    double precision :: a, alpha, b, beta, d, e, tiny, x
    double precision, allocatable, dimension(:,:)  :: fck
#ifdef GPU
    double precision, allocatable, dimension(:,:)  :: ci0,ca0 ! alp,bet
#endif
    integer :: kk
!
    integer,external :: idamax

!-----------------------------------------------
!***********************************************************************
!
!   "FAST" DIAGONALISATION PROCEDURE.
!
!    ON INPUT FAO CONTAINS THE LOWER HALF TRIANGLE OF THE MATRIX TO BE
!                         DIAGONALISED, PACKED.
!             VECTOR  CONTAINS THE OLD EIGENVECTORS ON INPUT, THE NEW
!             VECTORS ON EXITING.
!             NOCC = NUMBER OF OCCUPIED MOLECULAR ORBITALS.
!             EIG  = EIGENVALUES FROM AN EXACT DIAGONALISATION
!             MDIM = DECLARED SIZE OF MATRIX "C".
!             N = NUMBER OF ATOMIC ORBITALS IN BASIS SET
!
!  DIAG IS A PSEUDO-DIAGONALISATION PROCEDURE, IN THAT THE VECTORS THAT
!       ARE GENERATED BY IT ARE MORE NEARLY ABLE TO BLOCK-DIAGONALISE
!       THE FOCK MATRIX OVER MOLECULAR ORBITALS THAN THE STARTING
!       VECTORS. IT MUST BE CONSIDERED PSEUDO FOR SEVERAL REASONS:
!       (A) IT DOES NOT GENERATE EIGENVECTORS - THE SECULAR DETERMINANT
!           IS NOT DIAGONALISED, ONLY THE OCCUPIED-VIRTUAL INTERSECTION.
!       (B) MANY SMALL ELEMENTS IN THE SEC.DET. ARE IGNORED AS BEING TOO
!           SMALL COMPARED WITH THE LARGEST ELEMENT.
!       (C) WHEN ELEMENTS ARE ELIMINATED BY ROTATION, THE REST OF THE
!           SEC. DET. IS ASSUMED NOT TO CHANGE, I.E. ELEMENTS CREATED
!           ARE IGNORED.
!       (D) THE ROTATION REQUIRED TO ELIMINATE THOSE ELEMENTS CONSIDERED
!           SIGNIFICANT IS APPROXIMATED TO USING THE EIGENVALUES OF THE
!           EXACT DIAGONALISATION THROUGHOUT THE REST OF THE ITERATIVE
!           PROCEDURE.
!
!  (NOTE:- IN AN ITERATIVE PROCEDURE ALL THE APPROXIMATIONS PRESENT IN
!          DIAG BECOME VALID AT SELF-CONSISTENCY, SELF-CONSISTENCY IS
!          NOT SLOWED DOWN BY USE OF THESE APPROXIMATIONS)
!
!    REFERENCE:
!             "FAST SEMIEMPIRICAL CALCULATIONS",
!             STEWART. J.J.P., CSASZAR, P., PULAY, P., J. COMP. CHEM.,
!             3, 227, (1982)
!
!***********************************************************************
!
!  FIRST, CONSTRUCT THAT PART OF A SECULAR DETERMINANT OVER MOLECULAR
!  ORBITALS WHICH CONNECTS THE OCCUPIED AND VIRTUAL SETS.
!
!***********************************************************************
!
!  Quick check:  does an occupied-virtual intersection exist
!
   if (nocc == norbs .or. nocc == 0) return
    n = norbs
    mdim = norbs
    lumo = nocc + 1
    nvirt = n - nocc
    norbs2 = norbs*norbs

    allocate(fmo(norbs2), fck(norbs,norbs))
    !fck = 0.d0
    forall (i=1:norbs,j=1:norbs) fck(i,j) = 0.d0
    do i = 1,n
      do j = 1,n

        if (j > i) then  ! here is for columns > rows
          in = ((j*(j-1))/2) + i  ! location in upper triangle
        else
          in = ((i*(i-1))/2) + j  ! location in lower triangle
        end if

        ij = j + n*(i-1)
        fmo(ij) = fao(in)
      end do
    end do
! here, performs matrix multiplications to form FMO
#ifdef GPU
    if (lgpu) then
  !  PERFORMS BOTH MULTIPLICATIONS USING CUBLAS	
      if (nocc < nvirt) then
        call gemm_cublas('N', 'N', n, nocc, n, 1.0d0, fmo, n,vector , mdim, 0.0d0, fck, &
        & norbs)
        call gemm_cublas('T', 'N', nvirt, nocc, n, 1.0d0, vector(1:n, lumo:n), mdim, fck, &
        & norbs, 0.0d0, fmo, nvirt)
      else
        call gemm_cublas ('N', 'N', n, nvirt, n, 1.0d0, fmo, n, vector(1:n, lumo:n), mdim, &
        & 0.0d0, fck, norbs)
        call gemm_cublas ('T', 'N', nvirt, nocc, n, 1.0d0, fck, norbs, vector, mdim, &
        & 0.0d0, fmo, nvirt)
      end if
    else
#endif
!
!  PERFORMS BOTH MULTIPLICATIONS USING LAPACK
!
      if (nocc < nvirt) then
        call dgemm ("N", "N", n, nocc, n, 1.d0, fmo, n, vector, mdim, 0.d0, fck, &
        & norbs)
        call dgemm ("T", "N", nvirt, nocc, n, 1.d0, vector(1:n, lumo:n), mdim, fck, &
        & norbs, 0.d0, fmo, nvirt)
      else
        call dgemm ("N", "N", n, nvirt, n, 1.d0, fmo, n, vector(1:n, lumo:n), mdim, &
        & 0.d0, fck, norbs)
        call dgemm ("T", "N", nvirt, nocc, n, 1.d0, fck, norbs, vector, mdim, &
        & 0.d0, fmo, nvirt)
      end if
#ifdef GPU
    end if
#endif
    i = idamax (nocc*nvirt, fmo, 1)
    tiny = dabs (fmo(i)) * 0.05d0
!***********************************************************************
!
!   NOW DO A CRUDE 2 BY 2 ROTATION TO "ELIMINATE" SIGNIFICANT ELEMENTS
!
!***********************************************************************
    kk = 1
#ifdef GPU
    if (lgpu) then
      kk = 2
    end if
#endif

    Select case (kk)

       case (1)

          ! The correct one
          ij = 1
#ifdef MKL
          call mkl_set_num_threads(ij)
#endif
          ij = 0 ; in = 0

          do i = 1, nocc
            do j = lumo, n
               ij = ij + 1

               !ij = i + n*(j-1)
               !ij = nvirt*(i-1) - (lumo - j) + 1

               x = fmo(ij)
               if (dabs(x) < tiny) cycle
!
!      BEGIN 2 X 2 ROTATIONS
!
               a = eig(i)
               b = eig(j)
               d = a - b !eig(i) - eig(j)
!
!    USE BIGEPS TO DETERMINE WHETHER TO DO A 2 BY 2 ROTATION
!
               if (dabs (x/d) < bigeps) cycle
!
!  AT THIS POINT WE KNOW THAT
!
               !in = in + 1
               e = sign (dsqrt(4.0d0*x*x + d*d), d)
               alpha = dsqrt (0.5d0*(1.0d0 + d/e))
               beta = -sign(dsqrt(1.0d0 - alpha*alpha), x)
               call drot(n,vector(1:n,i),1,vector(1:n,j),1,alpha,beta)

!              continue
            end do
          end do

          !write(6,*) 'IN e IJ = ',in,ij

          continue

       case (2)

#ifdef GPU
         allocate (ci0(n,nocc),ca0(n,nvirt),stat=i)

         ci0 = vector(1:n,1:nocc)
         ca0 = vector(1:n,lumo:n)

         if (ngpus > 1) then
            call rot_cuda_2gpu(fmo,eig,vector,ci0,ca0,nocc,lumo,n,bigeps,tiny)
         else
            call rot_cuda(fmo,eig,vector,ci0,ca0,nocc,lumo,n,bigeps,tiny)
         end if
         deallocate (ci0,ca0,stat=i)
#endif
    End select
    deallocate (fmo,fck,stat=i)
    continue
#ifdef MKL
    call mkl_set_num_threads(num_threads)
#endif
    return
end subroutine diag_for_GPU

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine symtry ()
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : ndep
      USE symmetry_C, ONLY: locpar, idepfn, locdep, depmul
      use common_arrays_C, only : geo
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: n, i, locn, j
      double precision :: value
!-----------------------------------------------
!**********************************************************************
!
!  SYMTRY COMPUTES THE BOND LENGTHS AND ANGLES THAT ARE FUNCTIONS OF
!         OTHER BOND LENGTHS AND ANGLES.
!
! ON INPUT GEO     = KNOWN INTERNAL COORDINATES
!          NDEP    = NUMBER OF DEPENDENCY FUNCTIONS.
!          IDEPFN  = ARRAY OF DEPENDENCY FUNCTIONS.
!          LOCDEP  = ARRAY OF LABELS OF DEPENDENT ATOMS.
!          LOCPAR  = ARRAY OF LABELS OF REFERENCE ATOMS.
!
!  ON OUTPUT THE ARRAY "GEO" IS FILLED
!***********************************************************************
!
!     NOW COMPUTE THE DEPENDENT PARAMETERS.
!
      n = 0
      do i = 1, ndep
        if (idepfn(i) == 19 .and. depmul(n + 1) > 1.d-20) then
          n = n + 1
          call haddon (value, locn, idepfn(i), locpar(i), geo, depmul(n))
        else
          call haddon (value, locn, idepfn(i), locpar(i), geo, depmul(i))
        end if
        j = locdep(i)
        geo(locn,j) = value
      end do
      return
      end subroutine symtry
      subroutine haddon(w, l, m, loc, a,  fact)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use chanel_C, only : iw
      use molkst_C, only : numcal
      use common_arrays_C, only : na
      use funcon_C, only : pi
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(out) :: l
      integer , intent(in) :: m
      integer , intent(in) :: loc
      double precision , intent(out) :: w
      double precision , intent(in) :: fact
      double precision , intent(in) :: a(3,*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: icalcn, i
      save icalcn
!-----------------------------------------------
      data icalcn/ 0/
      if (numcal /= icalcn) then
        icalcn = numcal
      end if
     !**********************************************************************
    if (m > 19 .or. m < 1) then
      write (iw, "(///10X,'UNDEFINED SYMMETRY FUNCTION',I3, ' USED')") m
      call mopend ("UNDEFINED SYMMETRY FUNCTION USED")
    end if
    i = loc
    if (na(i) == 0) then
      select case (m)
      case (1)
         !
         !   Start of Cartesian relationships.
         !
         !                          X = X
        l = 1
        w = a(1, i)
        return
      case (2)
         !                          Y = Y
        l = 2
        w = a(2, i)
        return
      case (3)
         !                          Z = Z
        l = 3
        w = a(3, i)
        return
      case (4)
         !                          X = -X
        l = 1
        w = -a(1, i)
        return
      case (5)
         !                          Y = -Y
        l = 2
        w = -a(2, i)
        return
      case (6)
         !                          Z = -Z
        l = 3
        w = -a(3, i)
        return
      case (7)
         !                          X = Y
        l = 1
        w = a(2, i)
        return
      case (8)
         !                          Y = Z
        l = 2
        w = a(3, i)
        return
      case (9)
         !                          Z = X
        l = 3
        w = a(1, i)
        return
      case (10)
         !                          X = -Y
        l = 1
        w = -a(2, i)
        return
      case (11)
         !                          Y = -Z
        l = 2
        w = -a(3, i)
        return
      case (12)
         !                          Z = -X
        l = 3
        w = -a(1, i)
        return
      case (13)
         !                          X = Z
        l = 1
        w = a(3, i)
        return
      case (14)
         !                          Y = X
        l = 2
        w = a(1, i)
        return
      case (15)
         !                          Z = Y
        l = 3
        w = a(2, i)
        return
      case (16)
         !                          X = -Z
        l = 1
        w = -a(3, i)
        return
      case (17)
         !                          Y = -X
        l = 2
        w = -a(1, i)
        return
      case (18, 19)
         !                          Z = -Y
        l = 3
        w = -a(2, i)
        return
      case default
      end select
    else
      select case (m)
      case (2)
         !
         !  Set bond-angles equal
         !
        l = 2
        w = a(2, i)
        return
      case (3)
         !
         !  Set dihedrals equal
         !
        w = a(3, i)
      case (4)
        w = (pi/2.0d00) - a(3, i)
      case (5)
        w = (pi/2.0d00) + a(3, i)
      case (6)
        w = (2.0d00*pi/3.0d00) - a(3, i)
      case (7)
        w = (2.0d00*pi/3.0d00) + a(3, i)
      case (8)
        w = pi - a(3, i)
      case (9)
        w = pi + a(3, i)
      case (10)
        w = (4.0d00*pi/3.0d00) - a(3, i)
      case (11)
        w = (4.0d00*pi/3.0d00) + a(3, i)
      case (12)
        w = (3.0d00*pi/2.0d00) - a(3, i)
      case (13)
        w = (3.0d00*pi/2.0d00) + a(3, i)
      case (14)
        w = -a(3, i)
      case (15)
        l = 1
        w = a(1, i) / 2.0d00
        return
      case (16)
        l = 2
        w = a(2, i) / 2.0d00
        return
      case (17)
        l = 2
        w = pi - a(2, i)
        return
      case (18, 19)
        l = 1
        w = a(1, i) * fact
        return
      case default
        go to 1000
      end select
      l = 3
      return
    end if
   !
   !  Set bond-lengths equal
   !
1000 l = 1
    w = a(1, i)
      end subroutine haddon

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine dhcore(coord, h, ww, enuclr, nati, natx, step)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : norbs, numat, n2elec
      use common_arrays_C, only : nat, nfirst, nlast
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: nati
      integer , intent(in) :: natx
      double precision , intent(out) :: enuclr
      double precision , intent(in) :: step
      double precision  :: coord(3,numat)
      double precision , intent(inout) :: h(*)
      double precision , intent(out) :: ww(n2elec)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, kr, ia, ib, ni, j, ja, jb, nj, i2, i1, ij, &
        kro, ii, k
      double precision, dimension(45) :: e1b, de1b, e2a, de2a
      double precision, dimension(9,9) :: di, ddi
      double precision, dimension(2026) :: wjd = 0.d0, dwjd = 0.d0
      double precision :: csave, enuc, denuc
!-----------------------------------------------
!
!  DHCORE GENERATES THE 1-ELECTRON  AND 2-ELECTRON INTEGRALS DERIVATIVES
!         WITH RESPECT TO THE CARTESIAN COORDINATE COORD (NATX,NATI).
!
!  INPUT
!      COORD     : CARTESIAN  COORDINATES OF THE MOLECULE.
!      NATI,NATX : INDICES OF THE MOVING COORDINATE.
!      STEP      : STEP SIZE OF THE 2-POINTS FINITE DIFFERENCE.
!  OUTPUT
!      H         : 1-ELECTRON INTEGRALS DERIVATIVES (PACKED CANONICAL).
!      W         : 2-ELECTRON INTEGRALS DERIVATIVES (ORDERED AS REQUIRED
!                             IN DFOCK2 AND DIJKL1).
!      ENUCLR    : NUCLEAR ENERGY DERIVATIVE.
!
!-----------------------------------------------
      h(:norbs*(norbs+1)/2) = 0
      enuclr = 0.D0
      kr = 1
      i = nati
      csave = coord(natx,nati)
      ia = nfirst(nati)
      ib = nlast(nati)
      ni = nat(nati)
      do j = 1, numat
        if (j == nati) cycle
        ja = nfirst(j)
        jb = nlast(j)
        nj = nat(j)
        coord(natx,nati) = csave + step
        call h1elec (ni, nj, coord(1,nati), coord(1,j), di)
        coord(natx,nati) = csave - step
        call h1elec (ni, nj, coord(1,nati), coord(1,j), ddi)
!
!     FILL THE ATOM-OTHER ATOM ONE-ELECTRON MATRIX.
!
        i2 = 0
        if (ia > ja) then
          do i1 = ia, ib
            ij = (i1*(i1 - 1))/2 + ja - 1
            i2 = i2 + 1
            h(ij+1:jb-ja+1+ij) = h(ij+1:jb-ja+1+ij) + (di(i2,:jb-ja+1)-ddi(i2,:&
              jb-ja+1))
          end do
        else
          do i1 = ja, jb
            ij = (i1*(i1 - 1))/2 + ia - 1
            i2 = i2 + 1
            h(ij+1:ib-ia+1+ij) = h(ij+1:ib-ia+1+ij) + (di(:ib-ia+1,i2)-ddi(:ib-&
              ia+1,i2))
          end do
        end if
!
!     CALCULATE THE TWO-ELECTRON INTEGRALS, W; THE ELECTRON NUCLEAR TERM
!     E1B AND E2A; AND THE NUCLEAR-NUCLEAR TERM ENUC.
!
        kro = kr
        coord(natx,nati) = csave + step
!
!     Two-electron one and two center terms.
!
        call rotate (ni, nj, coord(1,nati), coord(1,j), wjd, kr, e1b, e2a, enuc)
        kr = kro
        coord(natx,nati) = csave - step
        call rotate (ni, nj, coord(1,nati), coord(1,j), dwjd, kr, de1b, de2a, denuc)
        k = kr - kro
        if ( kr > 0) then
          wjd(:k + 1) = wjd(:k + 1) - dwjd(:k + 1)
          do i = 0, k - 1
            ww(i + kro) = wjd(i + 1)
          end do
        end if
        coord(natx,nati) = csave
        enuclr = enuclr + enuc - denuc
!
!   ADD ON THE ELECTRON-NUCLEAR ATTRACTION TERM FOR ATOM I.
!
        i2 = 0
        do i1 = ia, ib
          ii = (i1*(i1 - 1))/2 + ia - 1
          if (i1 - ia + 1 > 0) then
            h(ii+1:i1-ia+1+ii) = h(ii+1:i1-ia+1+ii) + e1b(i2+1:i1-ia+1+i2) - &
              de1b(i2+1:i1-ia+1+i2)
            i2 = i1 - ia + 1 + i2
          end if
        end do
!
!   ADD ON THE ELECTRON-NUCLEAR ATTRACTION TERM FOR ATOM J.
!
        i2 = 0
        do i1 = ja, jb
          ii = (i1*(i1 - 1))/2 + ja - 1
          if (i1 - ja + 1 > 0) then
            h(ii+1:i1-ja+1+ii) = h(ii+1:i1-ja+1+ii) + e2a(i2+1:i1-ja+1+i2) - &
              de2a(i2+1:i1-ja+1+i2)
            i2 = i1 - ja + 1 + i2
          end if
        end do
      end do
      return
      end subroutine dhcore

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine partab
!
    use param_global_C, only : power, ifiles_8, refers, names, is_a_ref, &
    contrl, refgeo, refher, refder, refcer, reftot, refger, maxmol, &
    maxrfs, nmols, refhof, refips, molnum, wtgeo, wthof, refdip, &
    wtdip, wtips
!
    use molkst_C, only :  natoms, nvar, tleft, jobnam, escf, &
    & gnorm, last, koment, moperr, norbs, cp298 => temp_1, s298 => temp_2
!
    use chanel_C, only : ir, iw, ilog
    use common_arrays_C, only : labels, loc, xparam, nat, &
    na, nb, nc, c, cb, geometry => geo
!
!------------------------------------------------------------------------
!
    implicit none
    character (len=5) :: wrk2
    character (len=8) :: els
    character (len=40) :: formla
    character (len=96) :: wrk
    logical :: ldips = .false., lgeos = .false., lheat = .false., lips = &
   & .false., large, opend, cp, one_scf
    integer :: i, itime, itxt, j, k, loop,  nerr, ndmols, nimols, nbmols, &
    & nhmols, namols
    double precision :: sum, aveher, aveder, aveier, aveber, aveaer, &
    & rmsher, rmsder, rmsier, rmsger, sumher, sumder, sumier, sumger, &
    & sumerr
    character (len=20), dimension (300) :: ttype
    character (len=5), dimension (maxmol, 4) :: reftxt
    character (len=13), dimension (maxrfs, 4) :: allref
    integer, dimension (4) :: ipfile
    integer, dimension (4) :: nzs
    integer, dimension (4) :: sortl
    double precision :: errors(300), yparam(300), dummy(2)
    double precision, external :: seconds
    intrinsic Abs, Index, Int, Min
    data ipfile / 16, 17, 18, 19 /
!------------------------------------------------------------------------
   large = (Index (contrl, "LARGE") /= 0)
   cp = (Index (contrl, " CP ") /= 0)
   i = len_trim(jobnam)
    open (unit=ipfile(1), form="FORMATTED", status="UNKNOWN", &
   & file=jobnam(:i)//".heats")
    open (unit=ipfile(2), form="FORMATTED", status="UNKNOWN", &
   & file=jobnam(:i)//".ips")
    open (unit=ipfile(3), form="FORMATTED", status="UNKNOWN", &
   & file=jobnam(:i)//".dips")
    open (unit=ipfile(4), form="FORMATTED", status="UNKNOWN", &
   & file=jobnam(:i)//".geos")
   allref(1,1) = " "
   reftxt(1,1) = " "
    do i = 1, 4
      call psort (refers(1, i), 0, nmols, reftxt(1, i), allref(1, i), &
     & ipfile(i), sortl(i), .false. )
    end do
    write (ipfile(1), "(' Formula        Molecule              ',26x,'  &
   &Heat of Formation   Diff. Ref.')")
    write (ipfile(1), "(67X,'Exp.     Calc.')")
    write (ipfile(2), "(' Formula        Molecule              ',20x,'Io&
   &nization Potential  Diff. Ref.')")
    write (ipfile(2), "(67X,'Exp.     Calc.')")
    write (ipfile(4), "(' Formula        Molecule              ',6x,' Geome&
   &tric        Exp.    Calc.   Ref.')")
    write (ipfile(4), "(45X,'Parameter')")
    write (ipfile(3), "(' Formula        Molecule              ','            &
   &     Dipole         Diff. Ref.')")
    write (ipfile(3), "(67X,'Exp.     Calc.')")
    write (ifiles_8, "(a,26x,2A)") "   Molecule     ","         Time  Heat      ", "Dipole   I.P.     Geometry     Total"
    itime = Int (seconds (1))
     if (large) then
        inquire (unit=iw, opened=opend)
        if (.not. opend) then
        i = Index (jobnam, " ") - 1
        open (unit=iw, file=jobnam(:i)//".arc", status="UNKNOWN")
        rewind (iw)
        end if
        else
        open (unit=iw, status="SCRATCH", form="FORMATTED")
      !
      !  Standard MOPAC output is NOT wanted, therefore send it to scratch.
      !
        inquire (unit=iw, opened=opend)
        if (opend) then
          close (unit=iw, status="DELETE")
        end if
        open (unit=iw, status="SCRATCH", form="FORMATTED")
      !
      !  Standard MOPAC LOG files are NOT wanted, therefore send
      !  them to scratch.
      !
        inquire (unit=ilog, opened=opend)
        if (opend) then
          close (unit=ilog, status="DELETE")
        end if
        open (unit=ilog, status="SCRATCH", form="FORMATTED")
      end if
    nhmols = 0
    ndmols = 0
    nimols = 0
    nbmols = 0
    namols = 0
    aveher = 0.d0
    aveder = 0.d0
    aveier = 0.d0
    aveaer = 0.d0
    aveber = 0.d0
    rmsher = 0.d0
    rmsder = 0.d0
    rmsier = 0.d0
    rmsger = 0.d0
    sumher = 0.d0
    sumder = 0.d0
    sumier = 0.d0
    sumger = 0.d0
    one_scf = (index(contrl, "PKA") + index(contrl, "1SCF")/= 0)
    do loop = 1, nmols
      molnum = molnum + 1
    !
    !  Restore all information for molecule number LOOP
    !
      call calpar
      call getmol (loop)
      deallocate(c, cb)
      allocate(c(norbs, norbs), cb(norbs, norbs))
      write(iw,*)trim(koment)
      gnorm = 0
      last = 0
      call empire (formla, nat, els)
      moperr = .false.
      tleft = 1.d7
    !
    !  Compute the value of all errors.  Gradient limit is set
    !  to -0.10 to ensure that geometries are OK.
    !

      if (one_scf) then
        call compfg (xparam, .true., escf, .true., dummy, .false.)
      else
        call optgeo (xparam, yparam, nvar, refgeo, -0.1d0)
      end if
      call savgeo (loop, geometry, na, nb, nc, xparam, loc)
      call parfg (errors, ttype, nerr, loop, .false.)
      if (cp) then
        cp298 = 0.d0
        s298 = 0.d0
        call force()
        refher = cp298 - refhof
        refder = s298 - refdip
      end if
      endfile (ifiles_8)
      backspace (ifiles_8)
    !
    !  Write out information on this system
    !
      i = Int (seconds (1))
      if (is_a_ref(loop)) then
      write (ifiles_8, "(A48,I5)") koment, i - itime
        cycle
      end if
      write (ifiles_8, "(A48,I5,F9.3,F10.3,F7.2,F12.3,F12.3)") koment, i - itime, refher, &
        refder, refcer, refger, refher + refder + refcer + refger
      itime = i
    !
    !  Write out the results in a suitable format.
    !
    !                       Heat of Formation
    !
      if ((Abs (refher) > 1.d-20 .or. natoms == 1 .and. refhof > 0.d0) .and. (index(koment, " TS") /= 0 .or. .not. one_SCF)) then
        write (ipfile(1), "(A15,A47,F9.2,F10.2,F9.2,1X,A5,3X,A,5X,A)") formla, &
       & koment, refhof, refher + refhof, refher, reftxt(loop, 1), els, trim(names(loop))
   !     if (method_pm6) write(51,"(a)")koment(:len_trim(koment))
        lheat = .true.
        nhmols = nhmols + 1
        aveher = aveher + Abs(refher)
          rmsher = rmsher + Abs(refher) ** power
      end if
    !
    !                       Ionization Potential
    !
      if (Abs (refcer) > 1.d-20) then
        write (ipfile(2), "(A15,A47,F9.2,F10.2,F9.2,1X,A5,3X,A,5X,A)") formla, &
       & koment, refips, refcer + refips, refcer, reftxt(loop, 2), els, trim(names(loop))
  !      if (method_pm6) write(52,"(a)")koment(:len_trim(koment))
        lips = .true.
        nimols = nimols + 1
        aveier = aveier + Abs(refcer)
        rmsier = rmsier + Abs(refcer) ** power
      end if
    !
    !                       Dipole Moment
    !
      if (Abs (refder) > 1.d-20) then
        write (ipfile(3), "(A15,A47,F9.2,F10.2,F9.2,1X,A5,3X,A,5X,A)") formla, &
       & koment, refdip, refdip + refder, refder, reftxt(loop, 3), els, trim(names(loop))
   !     if (method_pm6) write(53,"(a)")koment(:len_trim(koment))
        ldips = .true.
        ndmols = ndmols + 1
        aveder = aveder + Abs(refder)
        rmsder = rmsder + Abs(refder) ** power
      end if
    !
    !                       Geometric Variable
    !
      if (refger > 1.d-20) then
        j = Min (300, nvar)
        itxt = 0
        do i = 1, j
         if (refgeo(i) /= " ") then
!
!  Put into nzs the atomic numbers of the atoms used in the geometric variable
!
!   k = atom number of atom of geometric variable
!   j = 1 - bond length, 2 - angle, 3 - dihedral
!
          k = loc(1, i)
          j = loc(2, i) + 1
          select case (j)
          case (2)  !  Bond length
            if (labels(na(k)) > labels(k)) then
              nzs(2) = labels(na(k))
              nzs(1) = labels(k)
            else
              nzs(2) = labels(k)
              nzs(1) = labels(na(k))
            end if
          case (3)
            if (labels(nb(k)) > labels(k)) then
              nzs(3) = labels(nb(k))
              nzs(2) = labels(na(k))
              nzs(1) = labels(k)
            else
              nzs(3) = labels(k)
              nzs(2) = labels(na(k))
              nzs(1) = labels(nb(k))
            end if
          case (4)
          if (labels(nc(k)) > labels(k)) then
              nzs(4) = labels(nc(k))
              nzs(3) = labels(nb(k))
              nzs(2) = labels(na(k))
              nzs(1) = labels(k)
            else
              nzs(4) = labels(k)
              nzs(3) = labels(na(k))
              nzs(2) = labels(nb(k))
              nzs(1) = labels(nc(k))
            end if
          end select
          sum = 1.d0
          if (loc(2, i) > 1) then
            sum = 180 / 3.141592653598d0
          end if
          if (itxt == 0 .and. refgeo(i) /= " ") then
            wrk = formla(:15) // koment(1:81)
            wrk2 = reftxt(loop, 4)
            itxt = 1
          else
            wrk = " "
            wrk2 = " "
          end if
!
!  xparam:  experimental reference
!  yparam:  calculated geometric parameter
!
              if (sum > 5.d0) then
              write (ipfile(4), "(A47,A12,F8.3,F8.3,1X,A5,7X,F8.3,4I3)") wrk, &
             & refgeo(i), xparam(i) * sum, yparam(i) * sum, wrk2, &
             & (yparam(i)-xparam(i)) * sum, (nzs(k), k=1, j)
  !           if (method_pm6)    write(50,"(a)")wrk(16:len_trim(wrk))
             namols = namols + 1
             aveaer = aveaer + Abs((yparam(i)-xparam(i)) * sum)
            else
              write (ipfile(4), "(A47,A12,2F8.3,1X,A5,F7.3,8X,4I3)") wrk, &
             & refgeo(i), xparam(i) * sum, yparam(i) * sum, wrk2, &
             & (yparam(i)-xparam(i)) * sum, (nzs(k), k=1, j)
  !           if (method_pm6) write(50,"(a)")wrk(16:len_trim(wrk))
             nbmols = nbmols + 1
             aveber = aveber + Abs((yparam(i)-xparam(i)) * sum)
            end if
            rmsger = rmsger + Abs(errors(i)/wtgeo) ** power
            lgeos = .true.
          end if
        end do
      end if
        sumher = sumher + Abs(refher*wthof) ** power
        sumder = sumder + Abs(refder*wtdip) ** power
        sumier = sumier + Abs(refcer*wtips) ** power
        sumger = sumger + refger
        reftot = Abs(refher*wthof) ** power + Abs(refder*wtdip) ** power + &
        & Abs(refcer*wtips) ** power + refger
        write(iw,*)trim(koment)//" end"
    end do
!
!  Use iostat, but ignore the result - causes "graceful" exit
!
    if ( .not. lheat) then
      close (unit=ipfile(1), status="DELETE", iostat=i)
    end if
    if ( .not. lips) then
      close (unit=ipfile(2), status="DELETE", iostat=i)
    end if
    if ( .not. ldips) then
      close (unit=ipfile(3), status="DELETE", iostat=i)
    end if
    if ( .not. lgeos) then
      close (unit=ipfile(4), status="DELETE", iostat=i)
    end if
    close (unit=ir, status="DELETE", iostat=i)
    if( .not. large) close (unit=iw, status="DELETE")
  !
  !  Summarize the errors
  !
    sumerr = sumher + sumder + sumier + sumger
    write (ifiles_8, "(25x,A23,F14.3,F9.2,F8.2,F12.3,F12.3)") " TOTALS", sumher, &
   & sumder, sumier, sumger, sumerr
    aveher = aveher / (nhmols+0.000001d0)
    aveder = aveder / (ndmols+0.000001d0)
    aveier = aveier / (nimols+1.d-4)

    write (ifiles_8, "(25x,'  UNSIGNED AVE. ERROR   ',i4,f8.2,i4,f6.2,i3,f5.2,i6,f6.3)")&
    & nhmols,  aveher, ndmols, aveder, nimols, aveier, namols + nbmols, &
    & (aveaer*3.141592653598d0/180 + aveber)/(namols + nbmols + 1.d-4)
    aveber = aveber / (nbmols + 1.d-4)
    aveaer = aveaer / (namols + 1.d-4)
    write(ifiles_8,'(/,a,/30x,a)')"     Average Errors for Various Quantities", &
    &"No. in set"
    if (nhmols > 0) write(ifiles_8,"(a,f7.2,a,i6)")' Delta Hf:   ',&
    & aveher,"  kcal/mol",nhmols
    if (ndmols > 0) write(ifiles_8,"(a,f7.2,a,i6)")' Dipole:     ',&
    & aveder,"  Debye   ",ndmols
    if (nimols > 0) write(ifiles_8,"(a,f7.2,a,i6)")' I.P.:       ',&
    & aveier,"  eV      ",nimols
    if (nbmols > 0) write(ifiles_8,"(a,f8.3,a,i5)")' Bond length:',&
    & aveber," Angstroms",nbmols
    if (namols > 0) write(ifiles_8,"(a,f7.2,a,i6)")' Angle:      ',&
    & aveaer,"  Degrees ",namols
    write (ifiles_8, "(/,2A)") " All systems calculated; " // "now generating re&
   &ferences"
    do i = 1, 4
      inquire(unit=ipfile(i), opened=opend)
      if ( .not. opend) cycle
      write(ipfile(i),"(20a)")("****",j=1,20)
      call psort (refers(1, i), 1, nmols, reftxt(1, i), allref(1, i), &
     & ipfile(i), sortl(i), .false.)
    end do
    write (ifiles_8, "(2A)") " References generated"
end subroutine partab

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine molval(c, p, rhfuhf)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE molkst_C, only : numat, norbs, mpack
      USE chanel_C, only : iw
      use common_arrays_C, only : nfirst, nlast
!***********************************************************************
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision, dimension (norbs) :: val
      double precision , intent(in) :: rhfuhf
      double precision , intent(in) :: c(norbs,norbs)
      double precision , intent(in) :: p(mpack)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer ::  i, jj, jl, ju, j, kk, kl, ku, k, l1, l2, l
      double precision :: sum
!-----------------------------------------------
      do i = 1, norbs
        sum = 0.D0
        do jj = 1, numat
          jl = nfirst(jj)
          ju = nlast(jj)
          do j = jl, ju
            do kk = 1, numat
              if (kk == jj) cycle
              kl = nfirst(kk)
              ku = nlast(kk)
              do k = kl, ku
                l1 = max(j,k)
                l2 = j + k - l1
                l = (l1*(l1 - 1))/2 + l2
                sum = sum + c(j,i)*c(k,i)*p(l)
              end do
            end do
          end do
        end do
        val(i) = sum*rhfuhf
      end do
      write (iw, '(10F8.4)') (val(i),i=1,norbs)
      return
      end subroutine molval

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine setup (MOPAC_sec_det, nvecs, sec_det)
  !
  !
  !   Convert the secular determinant MOPAC_sec_det (which is a lower-half
  !   triangle over the Large Unit Cell) into a set of small 
  !   interaction matrices, sec_det.  sec_det has the structure:
  !
  ! sec_det(1:nvecs,(i*nr2*nr3 + j*nr3 + k )*nvecs+1:(i*nr2*nr3 + j*nr3 + k +1)*nvecs) 
  ! =  unit cell (0,0,0) interacting with cell (i,j,k)
  !
  use common_common, only : mr1, mr2, mr3, bcc, keywrd, iw_new
  implicit none
  integer, intent(in) :: nvecs
  double precision, dimension(*), intent(in) :: MOPAC_sec_det
  double precision, dimension(nvecs, nvecs*mr1*mr2*mr3), intent(out) :: sec_det
!
  logical :: prt
  integer :: i, ii, j, jj, k, l, lvecs, m, mprt, n, ncell, nprt
  double precision, external :: reada
  ! 
  !
  !   Set up individual Fock matrices.
  !
  prt = (Index (keywrd, " SEC ") /= 0)
  if (prt) then
    write(iw_new, "(a)") " Secular Determinant, as supplied by MOPAC"
    i = Index (keywrd, " SEC=")
    mprt = 2000
    if (i /= 0) then
      mprt = Nint (reada (keywrd, i+3))
    end if
  end if
  nprt = Min (8, nvecs)
  l = 0
  do i = 1, nvecs
    do j = 1, i
      l = l + 1
      sec_det(i, j) = MOPAC_sec_det(l)
      sec_det(j, i) = MOPAC_sec_det(l)
    end do
  end do
  if (prt) then
    write(iw_new, "(A,3I3)") " Unit Cell:", 0, 0, 0
    do jj = 1, nvecs
      write(iw_new, "(10f8.4)") (sec_det(ii, jj), ii = 1, nprt)
    end do
  end if
  ncell = 1
  do i = 1, mr1
    do j = 1, mr2
      do k = 1, mr3
        if (i + j + k /= 3) then
          if (.not.bcc .or. Mod(i + j + k, 2) == 1) then
            lvecs = nvecs * ncell
            ncell = ncell + 1
            do m = 1, nvecs
              lvecs = lvecs + 1
              do n = 1, nvecs
                l = (lvecs*(lvecs-1))/2 + n
                sec_det(n, lvecs) = MOPAC_sec_det(l)
              end do
            end do
            if (prt .and. ncell<=mprt) then
              write(iw_new, "(A,3I3)") " Unit Cell:", i-1, j-1, k-1
              do jj = lvecs-nvecs+1, lvecs
                write(iw_new, "(10F8.4)") (sec_det(ii, jj), ii = 1, nprt)
              end do
            end if
          end if
        end if
      end do
    end do
  end do
end subroutine setup
!

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine isitsc (escf, selcon, emin, iemin, iemax, okscf, niter, itrmax)
    use molkst_C, only: iscf
    use MOZYME_C, only : ovmax, energy_diff
    implicit none
    logical, intent (out) :: okscf
    integer, intent (in) :: itrmax, niter
    integer, intent (inout) :: iemax, iemin
    double precision, intent (in) :: emin, escf, selcon
    logical :: scf1 = .false.
    integer :: i, iemax1, iemin1
    double precision :: energy_test, fmo_test
    double precision, dimension (10) :: escf0
    data escf0 / 10 * 0.d0 /
    save
   !
   ! Test the change in energy on successive iterations and the maximum
   ! element of the occ-vir block of the Fock matrix in the LMO basis
   !
    energy_test = selcon
    fmo_test = selcon * 5.0d0

    if (ovmax < fmo_test .and. Abs (energy_diff) < energy_test &
         & .and. scf1 .or. niter > itrmax) then
      okscf = .true.
      iscf = 2
      if (scf1) iscf = 1
    else
      scf1 = (ovmax < fmo_test .and. Abs (energy_diff) < energy_test)
      if (emin /= 0.d0) then
        !*****************************************************************
        !
        !  THE FOLLOWING TESTS ARE INTENDED TO ALLOW A FAST EXIT FROM
        !  ITER IF THE RESULT IS 'GOOD ENOUGH' FOR THE CURRENT STEP IN
        !  THE GEOMETRY OPTIMIZATION
        !
        if (escf < emin) then
          !
          !  THE ENERGY IS LOWER THAN THE PREVIOUS MINIMUM.
          !  NOW CHECK THAT IT IS CONSISTENTLY LOWER.
          !
          iemax = 0
          iemin1 = iemin
          iemin = Min (5, iemin+1)
          if (iemin1 == 5) then
            do i = 2, 5
              escf0(i-1) = escf0(i)
            end do
          end if
          escf0(iemin) = escf
          !
          !  IS THE DIFFERENCE IN ENERGY BETWEEN TWO ITERATIONS LESS THAN 10%
          !  OF THE ENERGY GAIN FOR THIS GEOMETRY RELATIVE TO THE PREVIOUS
          !  MINIMUM.
          !
          if (iemin > 3) then
            do i = 2, iemin
              if (Abs (escf0(i)-escf0(i-1)) > 0.1d0*(emin-escf)) go to 1000
            end do
               !
               ! IS GOOD ENOUGH -- RAPID EXIT
               !
            okscf = .true.
            iscf = 1
            return
          end if
        else
            !
            !  THE ENERGY HAS RISEN ABOVE THAT OF THE PREVIOUS MINIMUM.
            !  WE NEED TO CHECK WHETHER THIS IS A FLUKE OR IS THIS REALLY
            !  A BAD GEOMETRY.
            !
          iemin = 0
          iemax1 = iemax
          iemax = Min (5, iemax+1)
          if (iemax1 == 5) then
            do i = 2, 5
              escf0(i-1) = escf0(i)
            end do
          end if
          escf0(iemax) = escf
          !
          !  IS THE DIFFERENCE IN ENERGY BETWEEN TWO ITERATIONS LESS THAN 10%
          !  OF THE ENERGY LOST FOR THIS GEOMETRY RELATIVE TO THE PREVIOUS
          !  MINIMUM.
          !
          if (iemax > 3) then
            do i = 2, iemax
              if (Abs (escf0(i)-escf0(i-1)) > 0.1d0*(escf-emin)) go to 1000
            end do
               !
               ! IS GOOD ENOUGH -- RAPID EXIT
               !
            okscf = .true.
            iscf = 1
            return
          end if
        end if
      end if
1000  okscf = .false.
    end if
  end subroutine isitsc
  logical function PLS_faulty()
!
!  When some systems are run using MOZYME, the DIAGG1 - DIAGG2 combination fails to converge,
!  and the ovmax converges to a non-zero minimum.  If the job is stopped and a <file>.den
!  is generated, then on restarting the same job, the fault is automatically corrected.
!
!  PLS_faulty detects the conditions of the failure, at run time, and silently writes out
!  the <file>.den, then after reading in the same file, it re-runs the SCF calculation.
!  This corrects the fault.
!
    use MOZYME_C, only : ovmax
    use molkst_C, only : escf
    implicit none
    integer :: loop = -1, j = 0
    integer, parameter :: loop_lim = 6
    double precision :: ovmax_old = 0.d0, array_ovmax(loop_lim), escf_old = 0.d0, array_escf(loop_lim)
    save
    if (loop == -1) then
      array_ovmax = 10.d0
      array_escf = 10.d0
      loop = 0
    else
      loop = loop + 1
      if (loop == loop_lim + 1) then
        do loop = 2, loop_lim
          array_ovmax(loop - 1) = array_ovmax(loop)
          array_escf(loop - 1) = array_escf(loop)
        end do
        loop = loop_lim
      end if
      array_ovmax(loop) = abs(ovmax - ovmax_old)
      ovmax_old = ovmax
      array_escf(loop) = abs(escf - escf_old)
      escf_old = escf
      do j = 1, loop
        if (array_ovmax(j) > 0.01d0) exit
      end do
      if (j <= loop) then
        do j = 1, loop
          if (array_escf(j) > 0.1d0) exit
        end do
      end if
    end if
!
!  Check to see if (a) ovmax (PLS) has converged, and (b) that ovmax is not near zero.
!
    PLS_faulty = (j > loop .and. ovmax > 0.1d0)
    if (j > loop  .and. ovmax > 0.1d0) then
!
!  Deliberately overwrite array_ovmax with different numbers.
!  This prevents the appearance of convergance, for loop_lim iterations.
!
      do j = 1, loop_lim
        array_ovmax(j) = j
        array_escf(j) = j
      end do
    end if
    return
  end function PLS_faulty

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

 subroutine datinp
    use param_global_C, only : maxmol, Atom_pKas, ifiles_8, contrl, &
    maxatm, numvar, locvar, names, nmols, heats, dipls, hions, weight, &
    is_a_ref, refers, qn, spin_state, i_r, ihrefs, msdels, nref, &
    & pkas, lions, geotxt, norbss, nlecss, ncloss, molele, nopens, &
    nvars, comnts, titls, nlm61, fracts, natmss, numats, ndeps, &
    nnmos, geos, nfirss, nlasts, lablss, keys, nats, pas, pbs, &
    locs, locpas, idepfs, locdes, depmuls, nas, nbs, ncs, maxpat, maxsym, &
    maxpab, nfns, diffns, n2elecs, botlim, toplim, valvar, valold, &
    l123s, refdir, nnalpha_open, nnbeta_open
!
    use common_arrays_C, only : nat, labels, &
    & nfirst, nlast, na, nb, nc, geo, loc, &
    pdiag

    use elemts_C, only : elemnt

    use parameters_C, only : n_partyp_alpb
!
    use molkst_C, only : keywrd, moperr, title, natoms, method_mndo, &
    method_am1, method_pm6, method_mndod, nvar, koment, nclose, norbs, &
    nalpha, nelecs, nopen, ndep, fract, nbeta, numat, lm61, n2elec, &
    jobnam, errtxt, msdel, id, l1u, l2u, l3u, method_pm3, line, method_pm6_dh2, &
    method_pm7, method_PM6_DH_plus, nalpha_open, nbeta_open, method_pm6_d3h4, &
    method_pm6_d3_not_h4, method_pm6_d3h4x, backslash
!
    use meci_C, only : nmos
!
    USE molmec_C, only : nnhco
!
    USE symmetry_C, ONLY: idepfn, locdep, depmul, locpar
!
    use chanel_C, only : iw, ir, igpt, ilog, job_fn
!----------------------------------------------------------------------------
    implicit none
    character :: dr, gr, hr, jr
    character (len=200) :: name, refnam
    character (len=80), dimension (maxmol) :: safety
    logical :: case, exists, let, opend, refok, precise, large, all, survey, &
    & clean, hof_type, deadly = .false., l_only, method_pm5 = .false., &
    &  cp, solid, nocore
    integer :: i, iatm, icapa, igeo, ilin, iline, iloc, ilowa, ilowz, isym, &
   & itime, j, k, l, loop, misd, misg, mish, misi, &
   & mmmols, mol, ndips, nel, nions, nmolmx, nnmols, notok, icapz, &
   & m, n, lnmols, is, iref, faulty, max_atom, ni, nj, ne_excluded = 0, &
   itype, mers(3), nele(107)
    double precision :: sum, tnow, told, wtd, wtgeo, wth, wti
    logical, dimension (2, 107) :: elemok
    integer, dimension (4) :: jfiles
    integer, dimension (107,107) :: ccp = 0, bonds_ij = 0
    intrinsic Abs, Char, Ichar, Index, Int
    logical, external :: core_core_OK
!
!  The weights given to each reference datum depend on the elements present.
!  Weights are assigned according to the type of element
   double precision, dimension (107) :: element_weights
   character(len=300), external :: get_a_name
   integer, external :: end_of_keyword
   double precision, external :: seconds, reada
   double precision, parameter :: &
   & org = 1.d0,      &! Organic elements
   & mg1 = 0.9d0,     &! Main-group elements (important in biochemistry)
   & mg2 = 0.8d0,     &! Main-group elements (less important)
   & tms = 0.7d0,     &! Transition metals
   & oth = 1.d0! Other entities
!
!
!
!              H           Relative elements weights                                           He
!              Li  Be                                                      B   C   N   O   F   Ne
!              Na  Mg                                                      Al  Si  P   S   Cl  Ar
!              K   Ca  Sc             Ti  V   Cr  Mn  Fe  Co  Ni  Cu  Zn   Ga  Ge  As  Se  Br  Kr
!              Rb  Sr  Y              Zr  Nb  Mo  Tc  Ru  Rh  Pd  Ag  Cd   In  Sn  Sb  Te  I   Xe
!              Cs  Ba  La Ce-Lu       Hf  Ta  W   Re  Os  Ir  Pt  Au  Hg   Tl  Pb  Bi  Po  At  Rn
!              Fr  Ra  Ac Th Pa U     Np  Pu  Am  Cm  Bk  Cf  XX  +++ ---  Cb  ++  +   --  -   Tv
!
!
    data element_weights  &
           &/ org,                                                                            mg1, &!    2
           &  mg2,mg2,                                                    mg2,org,org,org,mg1,mg1, &!   10
           &  mg1,mg2,                                                    mg2,mg2,mg1,mg1,mg1,mg1, &!   18
           &  mg1,mg2,tms,           tms,tms,tms,tms,tms,tms,tms,tms,tms, mg2,mg2,mg2,mg2,mg1,mg1, &!   36
           &  mg2,mg2,tms,           tms,tms,tms,tms,tms,tms,tms,tms,tms, mg2,mg2,mg2,mg2,mg1,mg1, &!   54
           &  mg2,mg2,tms, 14*tms,   tms,tms,tms,tms,tms,tms,tms,tms,tms, mg2,mg2,mg2,mg2,mg1,mg1, &!   86
           &  mg2,mg2,tms, 3*tms,    tms,tms,tms,tms,tms,tms,oth,oth,oth, oth,oth,oth,oth,oth,oth /
!                                  /
!
! ... Executable Statements ...
!
!  Assign the maximum possible size to pas and pbs
!
    maxpab = 10000000
    do
      maxpab = (maxpab*6)/5
      allocate (pas(maxpab), pbs(maxpab), stat = i)
      if (i /= 0) then
        maxpab = (maxpab*5)/6
        if (allocated(pas)) deallocate(pas)
        allocate (pas(maxpab), pbs(maxpab), stat = i)
        exit
      end if
      if (maxpab > 40000000) exit
      deallocate (pas, pbs, stat = i)
    end do
    refnam = " "
    refok = .false.
!
!  JFILES(1) = Normal MOPAC output - this will be deleted.
!  JFILES(2) = Faulty MOPAC output - to be saved.
!  JFILES(3) = Normal PARAM output - to be saved.
!  JFILES(4) = Duplicate PARAM output - to be deleted.
!
    Atom_pKas = 0
    jfiles(1) = iw
    jfiles(2) = iw
    jfiles(3) = ifiles_8
    jfiles(4) = iw
    iloc = 0
    igeo = 0
    isym = 0
    iatm = 0
    ilin = 0
    is   = 0
    itype = 0
    ilowa = Ichar ("a")
    ilowz = Ichar ("z")
    icapa = Ichar ("A")
    icapz = Ichar ("Z")
    told = seconds (1)
    max_atom = 1000
    if (Index (contrl, " MAXAT") /= 0) max_atom = Nint(reada(contrl, Index(contrl," MAXAT")))

    let = (Index (contrl, " LET") /= 0)
    large = (Index(contrl, "LARGE") /= 0)
    precise = (Index(contrl, "PRECISE") /= 0)
    clean = (Index(contrl, "CLEAN") /= 0)
    all = (Index(contrl, " ALL") /= 0)
    survey = (Index (contrl, " SURVEY") /= 0)
    nocore = (Index (contrl, " NOCORE") /= 0)
!   nocore = .true.
    l_only = (Index (contrl, "ONLY") /= 0)
    solid = (index(contrl, " SOLID") /= 0 .and. max_atom == 1000)
    cp = (Index (contrl, " CP ") /= 0)
!   rewind (14)
!
! NOW FOLLOW THE WEIGHTING FACTORS FOR THE OPTIMISATION,
      wth = 1.d0!     WTH = WEIGHTING FACTOR FOR HEATS OF FORMATION, IN MOLES/KCAL
!    wtd = 20.d0!     WTD = WEIGHTING FACTOR FOR DIPOLE MOMENTS, IN DIPOLES(**-1)
!    wti = 10.d0!     WTI = WEIGHTING FACTOR FOR IONISATION POTENTIALS, IN EV(**-1)
      wtgeo = 0.4d0!   WTGEO = WEIGHTING FACTOR FOR GRADIENTS, IN KCAL/MOLE
!
!   For the SBIR work, reduce weights for dipoles and I.P.s
!
      wtd = 10.d0!     WTD = WEIGHTING FACTOR FOR DIPOLE MOMENTS, IN DIPOLES(**-1)
      wti = 5.d0!     WTI = WEIGHTING FACTOR FOR IONISATION POTENTIALS, IN EV(**-1)
!
!  If the user wants to alter these weights, then
!
    i = Index (keywrd, " RELH=")
    if (i /= 0) wth = max(wth * Reada(keywrd,i), 1.d-7)
    i = Index (keywrd, " RELD=")
    if (i /= 0) wtd = max(wtd * Reada(keywrd,i), 1.d-7)
    i = Index (keywrd, " RELI=")
    if (i /= 0) wti = max(wti * Reada(keywrd,i), 1.d-7)
    i = Index (keywrd, " RELG=")
    if (i /= 0) wtgeo = max(wtgeo * Reada(keywrd,i), 1.d-7)
    rewind (14)
!
!  Set ELEMOK(1,N) to TRUE if the element is to be parameterized
!
    i = maxatm
    do i = 1, 107
      elemok(1, i) = .false.
    end do
    do i = 1, numvar
      if (locvar(1,i) /= 41) elemok(1, mod(locvar(2, i),200)) = .true.
    end do

!
!  Establish which elements have parameters. If GSS(I) is non-zero
!  parameters are assumed to exist.
!
    j=1
    sum = 0.d0
    do i = 1, 98
      call extract_parameter (j, i, sum)
      elemok(2, i) = (Abs (sum) > 0.0001d0)
    end do
    elemok(2,57:71) = .true.
    elemok(2,87) = .true.
    elemok(2,85) = .true.
    do i = 99, 107
      elemok(1, i) = (numvar == 0)
      elemok(2, i) = .true.
    end do
    if (solid) elemok(1,107) = .true.! Allow Tv
    elemok(1,99)  = .true.
    elemok(1,98)  = .true.
!
!  Store KEYWRD in CONTRL.  At this point KEYWRD = keywords
!  of parameterization data set
!
    contrl = trim(keywrd)
    i = 0
    m = 0
    n = 0
    loop = Index(contrl, " SET=")
    if (loop /= 0) then
      n = loop
      contrl(loop:loop + 4) = ' '
      loop = loop + 5
    end if
    do
      if (loop /= 0) then
        moperr = .false.
        inquire(unit=ir, opened=opend)
        if (opend) close(ir)
        line = get_a_name(contrl(loop:), len_trim(contrl(loop:)))
        loop = loop + len_trim(line)
        if (contrl(loop + 1:loop + 1) == '"') loop = loop + 2
        if (contrl(loop:loop) == ";") then
          loop = loop + 1
        else
          contrl(n:loop) = " "
          loop = 0
        end if
        call add_path(line)
        open (unit=ir, file=trim(line), status="OLD", err=99)
        goto 89
  99    write(*,"(///,3a,///)")" Reference data file set: '",trim(line),"' missing."
        write(ifiles_8,"(///,3a,///)")" Reference data file set: '",trim(line),"' missing."
        call finish
89      continue
      else
        if (i /= 0) exit!  At least one set of data has been read in.
      end if

!
!   Read in all the names of the molecules to be used in the optimization
!

      do m = 1, maxmol
        read (ir, "(A)", end=1200) keywrd
        if (keywrd(1:1) == "*") cycle
!
!  Force molecule name into lower case
!
        do j = 1, 80
          if (keywrd(j:j) /= " ") go to 1100
        end do
        exit
1100    do k = 80, j, -1
          if (keywrd(k:k) /= " ") exit
        end do
        line = keywrd
        do l = j, k
          iline = Ichar (keywrd(l:l))
          if (iline >= Ichar ("A") .and. iline <= Ichar ("Z")) then
            line (l:l) = Char (iline+Ichar ("a")-Ichar ("A"))
          end if
        end do
        if (line(:3) == "end") cycle
        if (nocore .and. index(line,"core") /= 0) cycle
        i = i + 1
        names(i) = keywrd(j:k)
        j = Index(line(j:k), ".mop")!  Remove ".mop" if it exists
        if (j /= 0) names(i)(j:j+3) = " "
        do j = 1, i - 1
          if (names(i) == names(j)) then
            write(ifiles_8,"(5x,3a)")" File: """,trim(names(i)),""" already specified."
            i = i - 1
            exit
          end if
        end do
      end do
      cycle
 1200 continue
      if (m == 1) then
        call finish !  no data on file-names
      end if
    end do
!
!  Close input data set to prevent it being damaged by next set
!  of READS
!
    inquire(unit=ir, opened=opend)
    if (opend) then
      close (ir)
    end if
    if (Ichar(names(i)(1:1)) == 0) i = i - 1
    nmolmx = i
    write (ifiles_8, "(//10X,' FILE NAMES OF MOLECULES USED',/)")
    write (ifiles_8, "(2x,a)") (names(i), i=1, nmolmx)
    write (ifiles_8, "('1',//,'     MOLECULE         ',25x,'           H-EXP','   WT'&
   &,'   D-EXP   WT   I-EXP   WT  GEO-WT')")
    ndips = 0
    nions = 0
    mmmols = 0
    mish = 0
    misi = 0
    misd = 0
    misg = 0
    notok = 0
    faulty = 0
!
!  Define directory where the reference data are.
!
    nref = 0
    k = Index (contrl, " REF=")
    if (k /= 0) then
      k = k + 5
      j = end_of_keyword(contrl, len_trim(contrl), k)
!
! k = start of reference data directory list
! j = end of list.
! in between are the names of the reference directories, separated by ";"
!
      do l = 1, 20
        i = Index(contrl(k:j),";")
        if (i /= 0) then
          nref = nref + 1
          refdir(nref) = trim(get_a_name(contrl(k:j), len_trim(contrl(k:j))))//"/"
          n = len_trim(refdir(nref))
          if (refdir(nref)(n:n) /= "/") refdir(nref)(n + 1:n + 1) = "/"
          k = k + i
        end if
        if (i == 0) exit
      end do
      nref = nref + 1
      refdir(nref) = trim(get_a_name(contrl(k:j), j - k + 1))
      n = len_trim(refdir(nref))
      if (refdir(nref)(n:n) /= "/") refdir(nref)(n + 1:n + 1) = "/"
    else
      nref = nref + 1
      refdir(nref) = "."//"/"
    end if
    m = 0
    do i = 1, nref
      n = len_trim(refdir(i))
      if (n /= 2) then
        if (refdir(i)(n:n) /= "/") refdir(i)(n + 1:n + 1) = "/"
        call add_path(refdir(i))
      else
        if (index(job_fn, "/") > 0) then
          refdir(i) = " "
          call add_path(refdir(i))
        end if
      end if
! the directory checking feature of inquire is specific to the Intel compiler, remove for now
!      inquire (directory = refdir(i), exist = exists)
!      if (.not. exists) then
!        write(ifiles_8,'(//10x,a)')"Reference folder """//trim(refdir(i))//""" does not exist"
!        do n =  len_trim(refdir(i)) - 1, 1, -1
!          if (refdir(i)(n:n) == "\") then
!            inquire (directory = refdir(i)(:n), exist = exists)
!            if (.not. exists) then
!              write(ifiles_8,'(10x,a)')"Reference folder """//refdir(i)(:n)//""" also does not exist"
!            else
!              write(ifiles_8,'(10x,a)')"But reference folder """//refdir(i)(:n)//""" does exist"
!              exit
!            end if
!          end if
!        end do
!        m = 1
!      end if
    end do
 !   call finish
    if (m == 1) call finish
    i = Index (jobnam, " ") - 1
    inquire (file=jobnam(:i)//".err", exist=exists)
    if (exists) then
      open (unit=iw, file=jobnam(:i)//".err", iostat = j)
      if (j == 0) close(iw, status='DELETE')
    end if
    inquire (file="fort.26", exist= exists)
    if (exists) then
      open (unit=iw,  file="fort.26", iostat = i)
      if (i == 0) close(iw, status='DELETE')
    end if
    open (unit=iw, status="SCRATCH")
    lnmols = 0
    moperr = .false.
    do nmols = 1, nmolmx
      loop1: do
!
! This is a bit clumsy: loop is called twice, the first time ALL systems
! are read in, the second time, only valid systems are used.
!
        do loop = 1, 2
          nnmols = 0
          ifiles_8 = jfiles(loop+2)
!
!  Open channel to reference data file
!
          if (names(nmols) (1:1) == " ") exit
          do iref = 1, nref
            refnam = trim(refdir(iref)) // trim(names (nmols))
            if (Index(refnam,".mop") == 0) refnam = trim(refnam)//".mop"
            inquire (unit=igpt, opened=opend)
            if (opend) then
              close (unit=igpt, status="KEEP")
            end if
            i = 0
98          i = i + 1
            open (igpt, status="OLD", file=trim(refnam), blank="ZERO", iostat=l)
            if (l /= 0) then
              continue
            end if
            if ( l == 30 .and. i < 10) then
!
!  The file exists, but is not currently accessible
!
              write(ifiles_8,*) "Problem with", refnam
              call sleep(3)
              goto 98
            end if
            if (l == 0) exit
          end do
          inquire (unit=ir, opened=opend)
          if ( .not. opend)  open(ir,status='scratch',blank='zero')
          rewind (ir)
          do
            read (igpt, "(A360)", end=1300, err=1300) line
            if (line(1:1) /= "*") then
              do j = max(3,len_trim(line)), 2, -1
                if (line(j:j) /= " ") exit
              end do
              if (Ichar (line(j:j)) == 13) then
                j = j - 1
              end if
              if (j == 0) then
                write (ir,*) " File ", names (nmols) (:i), " is_loc empty!"
                l = 0
                exit
              else
                write (ir, "(A)") line (:j)
              end if
            end if
          end do
1300      line = " "
          write (ir, "(A)") " "
          rewind (ir)
          if (l /= 0) then
            write (ifiles_8,'(a)') "  ++++ NOT FOUND ++++ %: """//trim(names(nmols))//'"'
            nnmols = nnmols + 1
          else
            rewind (2)
!
!   Reset NASIZE(8) so that MOPAC will think that the geometry
!   has not been read in.  This allows faulty data sets to be handled
!   correctly.
!
             natoms = 0
!
!   Read in all the data in the reference data file
!
            i = itype
            id = 0
            call readmo ()
              if (nmols == 223) then
               itype = i
              end if
            itype = i
!***********************************************************************
!
!  Put reference data into upper case EXCEPT between "<" and ">"
!
            case = .true.
            do i = 1, len_trim(title)
              iline = Ichar (title (i:i))
              if (title (i:i) == "<") case = .false.
              if (title (i:i) == ">") case = .true.
              if (case .and. iline >= ilowa .and. iline <= ilowz) title (i:i) = Char(iline + icapa - ilowa)
            end do
!***********************************************************************
!
!  Delete any keywords that PARAM might set
!
            call l_control("PM3", len("PM3"), -1)
            call l_control("PM7", len("PM7"), -1)
            call l_control("PM6-DH", len("PM6-DH"), -1)
            call l_control("PM6-D3H4", len("PM6-D3H4"), -1)
            call l_control("PM6-D3H4X", len("PM6-D3H4X"), -1)
            call l_control("PM6-D3(H4)", len("PM6-D3(H4)"), -1)
            call l_control("PM6", len("PM6"), -1)
            call l_control("PM7A", len("PM7A"), -1)
            call l_control("NEW", len("NEW"), -1)
            call l_control("AM1", len("AM1"), -1)
            call l_control("1SCF", len("1SCF"), -1)
            call l_control("1SCF", len("1SCF"), -1)
            call l_control("1SCF", len("1SCF"), -1)
            call l_control("EXTERNAL", len("EXTERNAL"), -1)
            if (index(contrl," LET") /= 0) then
              i = index(keywrd,"        ")
              keywrd(i:i+7) = " GEO-OK"
            end if
            i = index(keywrd," GNORM")
            if ( i == 0) then
              i = Index (contrl, "GNORM")
              if (i /= 0) then
                k = index(contrl(i:)," ")
                j = index(keywrd,"            ")
                keywrd(j + 1:j+7) = contrl(i:i + k)
              end if
            end if
!
! Write in method name
!
            i = Index (keywrd, "        ") + 1
            if (method_mndo)        keywrd(i:i+3) = "MNDO"
            if (method_am1 )        keywrd(i:i+3) = "AM1 "
            if (method_pm3 )        keywrd(i:i+3) = "PM3 "
            if (method_pm5 )        keywrd(i:i+3) = "PM5 "
            if (method_mndod)       keywrd(i:i+4) = "MNDOD"
            if (method_PM6_DH_plus) keywrd(i:i+6) = "PM6-DH+"
            if (method_PM6_D3H4)    keywrd(i:i+7) = "PM6-D3H4"
            if (method_PM6_D3H4X)   keywrd(i:i+8) = "PM6-D3H4X"
            if (method_PM6_D3_not_H4) keywrd(i:i+9) = "PM6-D3(H4)"
            if (method_PM6_DH2)     then
              if (index(contrl, " PM6-DH2X") /= 0) then
               call l_control("PM6-DH2X", len("PM6-DH2X"),  1)
              else
                call l_control("PM6-DH2", len("PM6-DH2"),  1)
              end if
            end if

            if (method_pm7)    then
              if (index(keywrd,"PM7") == 0) then
                  keywrd(i:i+4) = "PM7 "
                end if
            end if
            call l_control("PRECISE", len("PRECISE"), -1)
            if(.not. large) then
              call l_control("HCORE", len("HCORE"), -1)
              call l_control("FOCK", len("FOCK"), -1)
              call l_control("PL", len("PL"), -1)
              call l_control("VECTORS", len("VECTORS"), -1)
              call l_control("COMPFG", len("COMPFG"), -1)
              call l_control("OLDENS", len("OLDENS"), -1)
              call l_control("NOLOG", len("NOLOG"), -1)
              i = Index (title, " TYPE")!  Start of title scrub
              if (i /= 0) then
                j = index(title(i + 1:)," ") + i + 1
                title (i:j) = " "
              end if
              if (cp) call l_control("THERMO(298,298,1)", len("THERMO(298,298,1)"), 1)
            end if
!***********************************************************************
            if (clean) call l_control("MECI", len("MECI"), -1)
!***********************************************************************
            do
              i = index(keywrd(:len_trim(keywrd)),"  ")
              if (i /= 0) then
                keywrd(i:) = keywrd(i + 1:)
              else
                exit
              end if
            end do
            do
              i = index(title(:len_trim(title)),"  ")
              if (i /= 0) then
                title(i:) = title(i + 1:)
              else
                exit
              end if
            end do
!
!  Set PARAM keywords to be used by the MOPAC side
!
            if( precise) call l_control("PRECISE", len("PRECISE"), 1)
            if (natoms == 0 .or. moperr) then
              write (ifiles_8,'(a,a)') " ++++ FILE FAULTY ++++ % ",  trim(refnam)
              write (ifiles_8, "(3A)") " (DATINP) There is an error in data-set ", names (nmols)
              if (moperr) then
                write (ifiles_8, "(2A)") " Error message:", errtxt (1:50)
              end if
              moperr = .false.
              faulty = faulty + 1
              nnmols = nnmols + 1
            else
              if (numvar /= 0 .and. .not. all) then
                if (natoms > max_atom) go to 1400
!
!   CHECK IF COMPOUND CONTAINS AN ELEMENT TO BE PARAMETERIZED.
!
                do i = 1, natoms
                  if (elemok(1, labels(i)) .and. labels(i) /= 99 .and. labels(i) /= 107) exit
                end do
                if(i > natoms) then
                  ne_excluded = ne_excluded + 1
                  go to 1400
                end if
!
!   CHECK IF ONLY THE ELEMENTS BEING OPTIMIZED ARE PRESENT
!
                if (l_only) then
                  do i = 1, natoms
                    if (.not. elemok(1, labels(i))) exit
                  end do
                  if(i <= natoms) go to 1400
                end if
              end if
!
!   CHECK IF ALL ELEMENTS ARE ALLOWED
!
              do i = 1, natoms
                if ( .not. elemok(2, labels(i))) go to 1400
              end do
              do i = len_trim(refnam), 2, -1
                if (refnam(i:i) == backslash) exit
              end do
              j = 0
              do i = 1, natoms
                if (labels(i) /= 99 .and. labels(i) /= 107) then
                  j = j + 1
                  nat(j) = labels(i)
                end if
              end do
              if (.not.(let .or. core_core_OK(geo, nat, numat, k, l, ccp) .or. .not. method_pm6)) then
                do i = len_trim(refnam), 1, -1
                  if (refnam(i:i) == backslash .or. refnam(i:i) == "/") exit
                end do
                write(ifiles_8,"(//,a, /, a,//)")"++++ FAULT DETECTED IN ++++ "//trim(koment)//", in file: """ &
                & //refnam(i + 1:len_trim(refnam)-4)//"""","     File is missing the "//trim(elemnt(k))//" - "//trim(elemnt(l))// &
                & " core-core term. System deleted."
                go to 1400
              end if
              if (.not. all .and. Index(title,"GUESS") /= 0 .and. survey ) goto 1400
              if (Index(title,"RCJ02") /= 0 .and. survey ) goto 1400
!
!  Store reference data
!
!
!
              hr = " "
              dr = " "
              jr = " "
              gr = " "
              if (title (1:1) /= " ") then
                name = title (1:80)
                title (1:1) = " "
                title (2:) = name(1:79)
              end if
              heats(nmols) = 0.d0
              dipls(nmols) = 0.d0
              hions(nmols) = 0.d0
              weight(1:3, nmols) = 0.d0
              weight(4, nmols) = wtgeo
              weight(5,nmols) = 1.d0
              mol = 1
              hof_type = .false.
!
!  If the system is NOT to be used in constructing tables, set is_a_ref .true.
!
              is_a_ref(nmols) = (Index(title," HR=REF") /= 0 &
              & .or. (Index(title," HB ") /= 0 .and. survey) )
              refers (nmols, 1) = " "
              if (cp) then
                i = Index (title, " CP=")
              else
                i = Index (title, " H=")
              end if
              if (i /= 0) then
                hof_type = .true.
                j = Index (title, " HR=")
                if (j /= 0) then
                  refers(nmols, 1) = title (j+4:j+12)
                  j = Index (refers(nmols, 1), " ")
                  if (j /= 0) then
                    refers (nmols, 1) (j:) = " "
                  end if
                  if (is_a_ref(nmols) .and. survey) refers(nmols,1) = " "
                else
                  mish = mish + 1
                  hr = "*"
                end if
                heats(nmols) = reada (title, i)
!
!  Read in the excited state quantum numbers, if they exist
!
                i = Index(title, " ROOT=")+5
                qn(nmols) = 0
                Excited_state: if( i /= 5 ) then
!
! Format:  "ROOT=n,m,rep", n   = quantum number,
!                          m   = spin multiplicity,
!                          rep = representation.
                  j = Index(title(i:), " ")+i
!
!  All the text is in title(i:j)
!
                  k = Index(title(i:j), ",")
                  l = Index(title(i+k:j), ",")
                  if(k /= 0 .and. l /= 0) then
                  k = k + i
                  l = l + k
                  qn(nmols) = Nint(Reada(title(i:k),1))
                  spin_state(nmols) = Nint(Reada(title(k:l),1))
                  i_r(nmols) = title(l:j-1)
                  do i = 2, 4
                      iline = Ichar (i_r(nmols)(i:i))
                      if (iline >= icapa .and. iline <= icapz) then
                        i_r(nmols)(i:i) = Char(iline+ilowa-icapa)
                      end if
                  end do
                end if
!
!  If keyword MECI is not present, put it in - to force MECI to calculate all states
!
                if(Index(keywrd," MECI") == 0) then
                  i = Index(keywrd,"      ")
                  keywrd(i+1:i+4) = "MECI"
                end if
              end if Excited_state
              do
!
!  LOAD IN THE STANDARD DEVIATION, IF KNOWN
!
!#            J=INDEX(TITLE(I:),' ')
!#            K=INDEX(TITLE(I:J+I),',')
!#            HSDS(NMOLS)=0.D0
!#            HSDS(NMOLS)=1.D0
!#            IF(K.NE.0)HSDS(NMOLS)=READA(TITLE,I+K)
                i = Index (title, "+")
                if (i == 0) exit
                if (wth < 1.d-3) exit
!
!   HEAT OF FORMATION (EXPT) IS A FUNCTION OF ANOTHER MOLECULE.
!
                if (nmols == 1) then
                  write(ifiles_8,*)" The first molecule cannot depend on other molecules"
                  faulty = faulty + 2
                  deadly = .true.
                end if
                title (i:i) = "^"
!
!  If name has quotation marks, use these as delimiter
!
                if (title(i+1:i+1) == """") then
!
!  j = end of name
!
                 j = Index (title (i + 2:), """") + i
                 if (j == i-1) then
                    j = 80
                  end if
                  l = j - i
                  name = title (i+2:j)
!
! Remove any "+" signed from the name in title
!
                  do
                    k = Index(title (i+2:j),"+")
                    if (k == 0) exit
                    title (i+k+1:i+k+1)="^"
                  end do
                else
                  j = Index (title (i:80), " ") + i - 1
                  if (j == i-1) then
                    j = 80
                  end if
                  k = Index (title (i+1:80), "+")
                  if (k /= 0) then
                    k = Index (title (i+1:80), "+") + i - 1
                  else
                    k = Index (title (i+1:80), " ") + i - 1
                  end if
                  if (k == i-1) then
                    k = 80
                  end if
                  if (k < j) then
                    j = k
                  end if
                  l = j - i
                  name = title (i+1:j)
                end if
                do k = 1, len_trim(name)
                  iline = Ichar (name(k:k))
                  if (iline >= icapa .and. iline <= Ichar ("Z")) then
                    name(k:k) = Char(iline+ilowa-icapa)
                  end if
                end do
                refok = .true.
                k = len_trim(name)
                if (name(k - 3:) == ".mop") name(k - 3:) = " "
                do k = 1, nmols - 1
                  line = names(k)
                  do j = 1, len_trim(line)
                    iline = Ichar (line(j:j))
                    if (iline >= icapa .and. iline <= Ichar ("Z")) line(j:j) = Char(iline+ilowa-icapa)
                  end do
                  if (name == line .and. len_trim(name) == len_trim(line)) go to 1500
                end do
                write (ifiles_8,"(/,2a)") " ++++ FAULT DETECTED IN FILE ++++ %: ", trim(refnam)
                write (ifiles_8, "(' NAME OF REFERENCE MOLECULE <',A, '> NOT KNOWN')") &
                trim(name)//".mop"
                do k = 1,is
                if(safety(k)(1:l+1) == name(1:l+1)) exit
                end do
                if (k > is) then
                  is = is + 1
                  safety(is) = name(:80)
                end if
                write (ifiles_8, "(//,A,//)") " (DATINP) There is an error in data-set ", &
                names (nmols)
                refok = .false.
                mmmols = mmmols + 1
                cycle
1500            mol = mol + 1
                ihrefs(mol, nmols) = k
!
!  Check that the dependent species do not depend on anything
!
                if (ihrefs(1,k) > 0) then
                  faulty = faulty + 2
                  deadly = .true.
                  write (ifiles_8,"(/,2a)") " ++++ FAULT DETECTED IN FILE ++++ %: ", trim(refnam)
                  write (ifiles_8, "(' Dependent molecule ""', &
                & a, &
                &'"" depends on other molecules.',/,' This is not allowed.',/)") &
                & names(ihrefs(mol, nmols))(1:len_trim(names(ihrefs(mol, nmols))))
                end if
              end do
              ihrefs(1, nmols) = mol - 1
              if (refok .and. mol /= 1) then
                write (ifiles_8, "(' TO THE REF. H.O.F MUST BE ADDED',' THE CALC. HEAT OF ',10a)") &
               &(""""//names(ihrefs(j, nmols))(1:len_trim(names(ihrefs(j, nmols))))//""" ", j=2, mol)
              end if
              weight(1, nmols) = wth
              i = Index (title, " HWT=")
              if (i /= 0) weight(1, nmols) = reada (title, i) * wth
!
! Set weights for states (defined by the presence of "ROOT=") to be less than other heats of formation, because the
! emphasis is on normal heats of formation, and state energies are used just to help tame the PES.
!
              if (qn(nmols) /= 0) weight(1, nmols) = 0.5d0*weight(1, nmols)
              if (is_a_ref(nmols)) weight(1, nmols) = 1.d-6
            else
              if (is_a_ref(nmols)) then
                write (ifiles_8,"(/,2a)") " ++++ FAULT DETECTED IN FILE ++++ %: ", trim(refnam)
                write(ifiles_8,"(a)")" If ""HR=REF"" is present, a heat of formation MUST be specified"
                faulty = faulty + 2
              end if
            end if
            do i = 1, len_trim(title)
              if (title (i:i) == "^") then
                title (i:i) = "+"
              end if
            end do
!
!  pKa
!
            i = Index (title, " PKA")
            if (i /= 0) then
              j = Index (title, " PKR=")
              if (j /= 0) then
                refers(nmols, 6) = title (j+4:j+12)
                j = Index (refers(nmols, 6), " ")
                if (j /= 0) then
                  refers (nmols, 6) (j:) = " "
                end if
              else
                mish = mish + 1
                hr = "*"
              end if
!
!  pKa value is stored
!
              Atom_pKas(nmols,1) = Nint(Reada(title,i))!  i
              i = i + Index(title(i:),"=")
              pKas(nmols) = reada (title, i)
              heats(nmols) = pKas(nmols)
              sum = 10.d0!   pKa default weight relative to H.o.F. weight
              weight(1, nmols) = wth * sum
              i = Index (title, " PKA_WT=")
              if (i /= 0) then
                weight(1, nmols) = reada (title, i) * wth * sum
              end if
            else
                pkas(nmols) = 0.d0
            end if
            refers (nmols, 3) = " "
            if (cp) then
              i = Index (title, " S=")
            else
              i = Index (title, " D=")
            end if
            if (i /= 0) then
              hof_type = .true.
              j = Index (title, " DR=")
              if (j /= 0) then
                refers(nmols, 3) = title (j+4:j+12)
                j = Index (refers(nmols, 3), " ")
                if (j /= 0) then
                  refers (nmols, 3) (j:) = " "
                end if
              else
                misd = misd + 1
                dr = "*"
              end if
              dipls(nmols) = reada (title, i)
!
!  LOAD IN THE STANDARD DEVIATION, IF KNOWN
!
!#            J=INDEX(TITLE(I:),' ')
!#            K=INDEX(TITLE(I:J+I),',')
!#            DSDS(NMOLS)=0.D0
!#            DSDS(NMOLS)=0.2D0
!#            IF(K.NE.0)DSDS(NMOLS)=READA(TITLE,I+K)
              weight(2, nmols) = wtd
              i = Index (title, " DWT=")
              if (i /= 0) then
                weight(2, nmols) = reada (title, i) * wtd
              end if
            end if
            refers (nmols, 2) = " "
            i = Index (title, " I=") + Index (title, " IA") + Index (title, " IE") + &
            & Index (title, " IP")+ Index (title, " I1=")+ Index (title, " I2=") + &
            & Index (title, " I3=")+ Index (title, " I4=")
            if (i /= 0 .and. Index(title,"IR=PW91D") == 0) then
              hof_type = .true.
              if (title (i+2:i+2) == "=") then
                lions(nmols) = 0
              else
                j = Ichar (title (i+2:i+2)) - Ichar ("0") - 1
                if (j > 9 .or. j < 0) then
                  write (ifiles_8, "(A,I4,A)") " FOR MOL.", nmols, " I.P. BAD"
                  lions(nmols) = 0
                else
                  lions(nmols) = j
                end if
              end if
              i = i + 3
              hions(nmols) = reada (title, i)
              weight(3, nmols) = wti
              j = Index (title, " IR=")
              if (j /= 0) then
                refers(nmols, 2) = title (j+4:j+12)
                j = Index (refers(nmols, 2), " ")
                if (j /= 0) then
                  refers (nmols, 2) (j:) = " "
                end if
              else
                jr = "*"
                misi = misi + 1
              end if
              i = Index (title, " IWT=")
              if (i /= 0) then
                weight(3, nmols) = reada (title, i) * wti
              end if
            end if
            i = Index (title, " GWT=")
            if (i /= 0) then
              weight(4, nmols) = reada (title, i) * weight(4, nmols)
            end if
            refers (nmols, 4) = " "
            if (Index (title, "GEOREF")+Index (title, "GR=") == 0) then
              weight(4, nmols) = 0.d0
              do i = 1, 300
                geotxt (i, nmols) = " "
              end do
            else
              j = Index (title, "GR=")
              if (j /= 0) then
                if (hof_type ) then
!
!  PANIC
!
                write(ifiles_8,"(3a)")' Error: Molecule "',names(nmols)(1:j), &
                    &'" is both a geometric and a non-geometric reference.', &
                    ' Modify reference data-set and re-run'
                    faulty = faulty + 1
                end if
                refers(nmols, 4) = title (j+3:j+12)
                j = Index (refers(nmols, 4), " ")
                if (j /= 0) then
                  refers (nmols, 4) (j:) = " "
                end if
              else
                gr = "*"
                misg = misg + 1
              end if
!
!   READ IN NAMES OF GEOMETRIC PARAMETERS
!
              l = 0
              k = 1
              do i = 1, 300
                j = Index (title (k:), "<")
                if (j /= 0) then
                  l = Index (title (k:), ">")
                  if (l == 0) then
                    write(ifiles_8,"(3a,i3)")' Error: Molecule "',trim(names(nmols)), &
                      '" has unterminated geometric reference.'
                    faulty = faulty + 1
                    deadly = .true.
                  else if (l == j+1) then
                    geotxt (i, nmols) = " "
                  else
                    geotxt(i, nmols) = title (k+j:k+l-2)
                    if (i > nvar) then
                      write(ifiles_8,"(3a,i3)")' Error: Molecule "',trim(names(nmols)), &
                      ' has more geometric reference data than variables:',nvar
                      faulty = faulty + 1
                      deadly = .true.
                    end if
                  end if
                else
                  l = 0
                  geotxt (i, nmols) = " "
                end if
                k = k + l
              end do
!
!  Check: are the geometric references in internal coordinates?
!
              j = min(40,nvar)
              do i = 1, j
                if (geotxt(i,nmols) /= " ") then
                  if(na(loc(1,i)) == 0) then
                    write(ifiles_8,"(3a)")' Error: Molecule "',trim(names(nmols)), &
                    &'" is a geometric reference, but geometry is not ',&
                    &' entirely in internal coordinates. Modify reference data-set and re-run'
                    faulty = faulty + 1
                  else
                    if (loc(2,i) == 1) then
!
!  Make a note of bond-lengths for advice to users
!
                      bonds_ij(labels(loc(1,i)), labels(na(loc(1,i)))) = &
                      & bonds_ij(labels(loc(1,i)), labels(na(loc(1,i)))) + 1
                    end if
                  end if
                end if
              end do
            end if
!
!  Add in factor for number of formula units in the cluster, if present
!
            if (id > 0) then! Special handling for solids - divide HoF by number of mers.
              j = Index (keywrd, " MERS")
              if (j /= 0) then
                mers = 0
                k = 0
                i = Index (keywrd(j + 1:), " ") + j
                do l = 1, 3
                  j = j + k
                  if (l > 1 .and. k == 0) exit
                  mers(l) = Nint (reada (keywrd(j:), 1))
                  k = Index (keywrd(j:i), ",")
                end do
              end if
              i = Index(keywrd, " Z=")
              if (i /= 0) then
                i = Nint(reada(keywrd,i))
                i = mers(1)*mers(2)*mers(3)*i
                if (Index (keywrd, " BCC") /= 0) i = i/2
                weight(5,nmols) =1.d0/i
              else
                nele = 0
                do i = 1, natoms - 3
                  nele(labels(i)) = nele(labels(i)) + 1
                end do
                j = 0
                do i = 1, 98
                  if (nele(i) > 0) then
                    j = j + 1
                    nele(j) = nele(i)
                  end if
                end do
                k = 1000
                do i = 1, j
                  if(nele(i) < k) k = nele(i)
                end do
!
!  k is the smallest number of atoms of any element in the formula
!
                do i = 1, 10
                  m = 0
                  do l = 1, j
                    if (Abs((i*nele(l))/k - (i*1.d0*nele(l))/k) > 1.d-5) m = 1
                  end do
                  if (m == 0) exit
                end do
!
!  Number of empirical units  = k/i
!
                weight(5,nmols) =(i*1.d0)/k
              end if
            end if
!
! IF GRADIENT OR FULL OPTIMISATION CALCULATION DONE THEN
!    WEIGHT(4,NMOLS) DEFAULTS TO 1.D0, UNLESS "NOGEO" IS SPECIFIED,
!    WHEN IT DEFAULTS TO 0.D0.
! IF GWT=N.NNN IS SPECIFIED, THIS CAN BE OVER-RIDDEN BY "NOGEO".
!
            tnow = seconds (1)
            itime = Int (tnow-told)
            told = tnow
            if(koment == " ")then
            i=Index(names(nmols)," ")
            write(ifiles_8,"(3a)")"Comment for ",names (nmols)(1:i)," is empty."
            call finish
            end if
            do
              if(koment(1:1) /= " ") exit
              koment = koment(2:)
            end do
! Write out heats of formation, only, without spaces
!
!         if (heats (nmols) < -999.9950d0) then
!          write(55,"(f9.2)",err=95) heats (nmols)
!        end if
            endfile (ifiles_8)
            backspace (ifiles_8)
            if (moperr) then
              write (ifiles_8, "(//, A)") " (READMO) There is an error in data-set", &
              names (nmols)
              write (ifiles_8, "(2A,//)") " Error message:", errtxt (1:50)
              moperr = .false.
              faulty = faulty + 1
              go to 1600
            else
!
!  ATMASS, REACT, AND TXTATM ARE NOT USED, THEREFORE USE DUMMYS
!
!
!   COPY1 DEFINES NB AND NC IN TERMS OF NA AND NATOMS.  THEREFORE,
!   NATOMS MUST BE RESET TO THE MAXIMUM (DEFINED IN MAKECM).
!
              if (moperr) then
                write (ifiles_8, "(//,3A)") " (STATE)  There is an error in data-set ", names (nmols)
                write (ifiles_8, "(2A,//)") " Error message:", trim(errtxt)
                moperr = .false.
                faulty = faulty + 1
                go to 1600
              else
                call moldat(2)
                if (moperr) then
                  if(errtxt(1:10) == "PARAMETERS")then
                    moperr=.false.
                    exit loop1
                  end if
                  write (ifiles_8, "(//,3A)") " ++++ FAULT DETECTED IN FILE ++++ (MOLDAT)&
                                               & There is an error in data-set ", names (nmols)
                  write(ifiles_8, "(a,//)")" Error message: """//trim(errtxt)//""". System deleted."
                  moperr = .false.
                  go to 1600
                else
!
!  Now that "molele" is filled, work out the RELATIVE weights of the reference data.
!
                  if (is_a_ref(nmols)) exit loop1
                  if (weight(1,nmols) + weight(2,nmols) + weight(3,nmols) + weight(4,nmols) < 1.d-4) then
                    if (weight(1,nmols) + weight(2,nmols) + weight(3,nmols) + weight(4,nmols) < 1.d-10) then
                      faulty = faulty + 2
                      deadly = .true.
                      write (ifiles_8,"(/,3a,/)") " ++++ FILE FAULTY ++++ %: ", trim(refnam), &
                        & ': No reference data '
                      end if
                      goto 1400
                    end if
                  exit loop1
                end if
              end if
            end if
!
!  No elements to be parameterized.
!
!  THIS COMPOUND CANNOT BE RUN - ELIMINATE IT!
!
1400        natoms = 0
          end if
        end if
1600    if (loop == 2) then
          notok = notok + 1
          do i = nmols, nmolmx - notok
            names(i) = names(i+1)
          end do
          names (nmolmx-notok+1) = " "
          if (nmols <= nmolmx-notok) cycle loop1
        end if
      end do
      go to 1700
    end do loop1
!
!  CALCULATE THE M.O. INDEX FOR I.P.
!
    lions(nmols) = nelecs / 2 - lions(nmols)
    if (nelecs == 0) then
      weight(3, nmols) = 0.d0
    end if
!
!  Identify all elements in the system
!
    nel = 1
    molele(1,nmols) = 0
    loop2: do i = 1, natoms
      if (labels(i) == 99) cycle loop2
      do j = nel, 2, -1
        if (molele(j, nmols) == labels(i)) cycle loop2
      end do
      nel = nel + 1
      molele(nel, nmols) = labels(i)
    end do loop2

    sum = 1.d0
    do j = 2, nel
      sum = min(sum, element_weights(molele(j,nmols)))
    end do
    weight(1:4,nmols) = weight(1:4,nmols)*sum
    if (natoms > 0) then
      write (ifiles_8, "(1X,A50,I4, F8.2,A,F6.2,F6.3,A,F5.1,F7.2,A,F5.1,&
           &F7.2,A)") koment, itime, heats (nmols), hr, weight (1, nmols), &
           & dipls(nmols), dr, weight(2, nmols), hions(nmols), jr, &
           & (weight(i, nmols), i=3, 4), gr
!
      lnmols = lnmols + 1
      is = is + 1
      safety(is) = names(nmols)
      if (Index (keywrd, " XFAC") /= 0 .and. index(keywrd, " POP") == 0 .and. numat /= 2) then
        write(ifiles_8,"(a)")" Number of atoms in reference function must be 2"
        call finish
      end if
!
!  element 99 is used for all parameters that are constant for all elements
!
      nel = nel + 1
      molele(nel,nmols) = 99
      molele(1, nmols) = nel
!
! FIRST, STORE ALL DATA DEFINING THE SIZE OF THE MOLECULE.
!
      natmss(lnmols) = natoms
      numats(lnmols) = numat
      ndeps(lnmols) = ndep
      norbss(lnmols) = norbs
      n2elecs(lnmols) = n2elec
      nlecss(lnmols) = nelecs
      ncloss(lnmols) = nclose+nalpha
      nopens(lnmols) = nopen+nbeta
      nnalpha_open(lnmols) = nalpha_open
      nnbeta_open(lnmols) = nbeta_open
      keys(lnmols) = trim(keywrd)
      msdels(lnmols) = msdel
      titls(lnmols) = title
      nvars(lnmols) = nvar
      comnts(lnmols) = koment(1:80)
      nnmos(lnmols) = nmos
      nlm61(lnmols) = lm61
      fracts(lnmols) = fract
!
! NOW TO STORE GEOMETRIC DATA
!
      do i = 1, nvar
        iloc = iloc + 1
        locs(1, iloc) = loc(1, i)
        locs(2, iloc) = loc(2, i)
      end do
      l123s(1,lnmols) = l1u
      l123s(2,lnmols) = l2u
      l123s(3,lnmols) = l3u
      do i = 1, natoms
        igeo = igeo + 1
        do j = 1, 3
          geos(j, igeo) = geo(j, i)
        end do
      end do
      do i = 1, ndep
        isym = isym + 1
        locpas(isym) = locpar(i)
        idepfs(isym) = idepfn(i)
        locdes(isym) = locdep(i)
        depmuls(isym) = depmul(i)
      end do
!
!  NOW TO STORE ATOMIC DATA.
!
      do i = 1, natoms
        iatm = iatm + 1
        nas(iatm) = na(i)
        nbs(iatm) = nb(i)
        ncs(iatm) = nc(i)
        nats(iatm) = nat(i)
        nfirss(iatm) = nfirst(i)
        nlasts(iatm) = nlast(i)
        lablss(iatm) = labels(i)
      end do
!
!  FINALLY, STORE ORBITAL DATA.
!
      if (nalpha /= nbeta) then
        sum = dfloat(nalpha)/nelecs
      else
       sum = 0.5d0
      end if
      do i = 1, norbs
        pas(ilin+ (i*(i+1))/2) = pdiag(i)*sum
        pbs(ilin+ (i*(i+1))/2) = pdiag(i)*(1.d0-sum)
      end do
      ilin = ilin + (norbs*(norbs+1)) / 2
      if (Abs (weight(2, nmols)) > 1.d-4) then
        ndips = ndips + 1
      end if
      if (Abs (weight(3, nmols)) > 1.d-4) then
        nions = nions + 1
      end if
    end if
1700 continue
  end do
  close (unit=jfiles(1), status="DELETE")
  close (unit=igpt)
  close (unit=55)
  close (unit = 56)
  ifiles_8 = jfiles(3)
!
! IF THERE ARE NO MOLECULES LEFT AT ALL, THEN STOP
!
  if (nmolmx-notok == 0) then
    write (ifiles_8,*) " NO ACCEPTABLE MOLECULES IN SET SUPPLIED"
    if (ne_excluded /= 0) write (ifiles_8,*) " (No molecules contained elements marked for optimization)"
    write (ifiles_8,*) " (To by-pass this check, add keyword ""ALL"")"
    call finish
  end if
! iw = jfiles(1)
  ifiles_8 = jfiles(3)
  nmolmx = nmolmx - notok
  if (nnmols /= 0) then
    write (ifiles_8,*) nnmols, " MOLECULES WERE NOT FOUND"
    if ( .not. let) call finish
  end if
  write(ifiles_8,'(/)')
  if (mish+misd+misi+misg /= 0) then
    if (mish /= 0) then
      write (ifiles_8, "(10x,I4,A)") mish, " REFERENCES FOR HEATS OF FORMATION MIS&
     &SING"
    else
      write (ifiles_8, "(10x,A)") " ALL HEATS OF FORMATION REFERENCED."
    end if
    if (misd /= 0) then
      write (ifiles_8, "(10x,I4,A)") misd, " REFERENCES FOR DIPOLES MISSING"
    else
      write (ifiles_8, "(10x,A)") " ALL DIPOLES REFERENCED."
    end if
    if (misg /= 0) then
      write (ifiles_8, "(10x,I4,A)") misg, " REFERENCES FOR " // "GEOMETRIES MISSI&
     &NG"
    else
      write (ifiles_8, "(10x,A)") " ALL GEOMETRIES REFERENCED."
    end if
    if (misi /= 0) then
      write (ifiles_8, "(10x,I4,A)") misi, " REFERENCES FOR IONIZATION POTENTIALS &
     &MISSING"
    else
      write (ifiles_8, "(10x,A)") " ALL IONIZATION POTENTIALS REFERENCED."
    end if
  else
    write (ifiles_8, "(10x,A)") " REFERENCES PRESENT FOR ALL DATA."
  end if
  write(ifiles_8,*)
  if (mmmols /= 0) then
    write (ifiles_8,*) mmmols, " REFERENCE HEATS OF FORMATION NOT KNOWN"
    write (ifiles_8,"(a)")" Use the following files with ALL to allow the run to continue"
    write (ifiles_8,*)" (This file will also be written to 'bits.txt')"
    k = 15
    line = "bits.txt"
    call add_path(line)
    open (unit=k, file=trim(line))
    do i = 1, is
      do j = 80,2,-1
      if(safety(i)(j:j) /= " ") exit
      end do
      write (ifiles_8,"(a)")safety(i)(1:j)
      write (k,"(a)")safety(i)(1:j)
    end do
    if ( .not. let) call finish
  end if
  close (ir)
  nmols = lnmols
  write (ifiles_8, "(//10X,' ADVICE ON STORAGE SPACE REQUIREMENTS')")
  write (ifiles_8, "(//10X,' STORE   SPACE USED  ', ' TOTAL SPACE AVAILABLE')")
  write (ifiles_8,*)
! write (ifiles_8, "(11X,'ILOC',I10,I14)") iloc, maxpat
  write (ifiles_8, "(11X,'IGEO',I10,I14)") igeo, maxatm
  write (ifiles_8, "(11X,'ISYM',I10,I14)") isym, maxsym
  write (ifiles_8, "(11X,'ILIN',I10,I14)") ilin, maxpab
  write (ifiles_8, "(11X,'NMOL',I10,I14)") nmols, maxmol

!
!   Write out the matrix of core-core terms
!
  ccp(99,99) = 1! Deliberately allow dummy atom parameters to be optimized.
  do i = 1, 83
    do j = 1,i-1
      ccp(i,j) = ccp(i,j) + ccp(j,i)
      ccp(j,i) = ccp(i,j)
    end do
  end do
  if (i == -999) then! Dummy suppress printing of matrices
  write(ifiles_8,"(/10x,a,/)") " Matrix of core-core terms * = present, - = absent"
  do i = 1, 83
    do j = 1,i
!  call setalp_read (i,j, sum, wth)
      if (sum > 1.d-3) then
        if (ccp(i,j) > 1) then!  2 data are sufficient to define the core-core term
          line(j:j) = "*"
        else
          line(j:j) = Char(Ichar("0") + ccp(i,j))
        end if
      else
        line(j:j) = "-"
      end if
    end do
     select case (i)
    case (2,10,18,36,54)
      write(ifiles_8,*)
    end select
    write(ifiles_8,"(1x,a2,1x,2a1,1x,8a1,1x,8a1,1x,18a1,1x,18a1,1x,32a1)")elemnt(i),(line(j:j),j=1,i)
  end do

!
!   Write out the matrix of number of bond-lengths used
!
  write(ifiles_8,"(/10x,a,/)") " Matrix of number of bond-lengths used."
  do i = 1, 83
    do j = 1,i-1
      bonds_ij(i,j) = bonds_ij(i,j) + bonds_ij(j,i)
      bonds_ij(j,i) = bonds_ij(i,j)
    end do
  end do
  do i = 1, 83
    do j = 1,i
      if (bonds_ij(i,j) == 0) then
        line(j:j) = "-"
      else if (bonds_ij(i,j) < 10) then
        line(j:j) = Char(Ichar("0") + bonds_ij(i,j))
      else
        line(j:j) = "+"
      end if
    end do
    select case (i)
    case (2,10,18,36,54)
      write(ifiles_8,*)
    end select
    write(ifiles_8,"(1x,a2,1x,2a1,1x,8a1,1x,8a1,1x,18a1,1x,18a1,1x,32a1)")elemnt(i),(line(j:j),j=1,i)
  end do
end if
!
!  Work out how many reference data are present
!
  j= 0
  do i = 1,nmols
    if(weight(1,i) > 1.d-9) j = j + 1
    if(weight(2,i) > 1.d-9) j = j + 1
    if(weight(3,i) > 1.d-9) j = j + 1
    if(weight(4,i) > 1.d-9) then
      do k = 1,300
        if (geotxt(k,i) /= " ") j = j + 1
      end do
    end if
  end do
  nfns = j
!
! Remove atomic parameters that are not accessible from the set of reference data supplied
!
  elemok(1,:) = .false.
  do i = 1, 107
    do j = 1,i
      if (ccp(i,j) > 0) elemok(1,i) = .true.
    end do
  end do
  elemok(:,97:99)  = .true.
!
! At this point, no parameters have been excluded yet
!
  j = 0
  do i = 1, numvar
    k = 1
!
! 39 = ALPB_, 40 = XFAC_, 41 = PAR
!
    if(locvar(1,i) /= 39 .and. locvar(1,i) /= 40 .and. locvar(1,i) /= 41) then
      if ( .not. elemok(1,locvar(2,i))) k = 0
    end if
    if (k > 0) then
!
!  Parameter is valid
!
    j = j + 1
    locvar(1,j) = locvar(1,i)
    locvar(2,j) = locvar(2,i)
    botlim(j) = botlim(i)
    toplim(j) = toplim(i)
    valvar(j) = valvar(i)
    valold(j) = valold(i)
    end if
  end do
  numvar = j
!
!  Remove core-core terms that are not accessible from the set of reference data supplied
!
  j = 0
  do i = 1, numvar
    k = 1
    if(locvar(1,i) == n_partyp_alpb .or. locvar(1,i) == n_partyp_alpb + 1) then
      nj = locvar(2,i)/200
      ni = locvar(2,i) - nj*200
      if (ccp(ni,nj) ==  0) then
        k = 0
      end if
    end if
    if (k > 0) then
!
!  Parameter is valid
!
      j = j + 1
      locvar(1,j) = locvar(1,i)
      locvar(2,j) = locvar(2,i)
      botlim(j) = botlim(i)
      toplim(j) = toplim(i)
      valvar(j) = valvar(i)
      valold(j) = valold(i)
    end if
  end do
  numvar = j
  write(ifiles_8,"(a,i5)")" Number of reference data:",nfns
  if (index(contrl, " CYCLES=0") /= 0) numvar = 0
  write(ifiles_8,"(a,i5)")" Number of parameters:    ",numvar
!
!   nfns should be correct, but add 10 "for safety" - the calculation of nfns is buggy
!
  allocate (diffns(numvar,nfns+10))
  if (iloc > maxpat .or. igeo > maxatm .or. isym > maxpat .or. ilin > maxpab &
 & .or. nmols > maxmol) then
    write (ifiles_8, "('  ARRAY BOUND ERROR - ', 'MODIFY SIZES AND RECOMPILE')&
   &")
    write (ifiles_8, "('  CURRENT VALUES')")
    write (ifiles_8, "(' MAXATM:',I8)") maxatm
    write (ifiles_8, "(' MAXSYM:',I8)") maxsym
    write (ifiles_8, "(' MAXPAB:',I8)") maxpab
    write (ifiles_8, "(' MAXMOL:',I8)") maxmol
    call finish
  end if
  inquire (unit=ir, opened=opend)
  if (opend) then
    close (unit=ir, status="DELETE")
  end if
  inquire (unit=ilog, opened=opend)
  if (opend) then
    close (unit=ilog, status="DELETE",err = 97)
  end if
97 if (faulty /= 0) then
    write (ifiles_8,'(a,i3,a)') " Faults were detected in", (faulty+1)/2, " data sets."
    if (deadly) then
      write (ifiles_8,'(a,i3,a)') " Faults MUST be corrected before job can be run."
      call finish
    end if
    if ( .not. let) then
      write(ifiles_8,*)" To continue, add ""LET"" to the keyword line."
      call finish
    end if
  end if
  nnhco = 0
  return
end subroutine datinp
logical function core_core_OK(geo, nat, numat, ni, nj, ccp)
  use parameters_C, only : alpb
  integer :: numat, ni, nj
  integer, dimension (numat) :: nat
  integer, dimension (107,107) :: ccp
  double precision, dimension (3,*) :: geo
  logical :: first = .true.
  logical, save, dimension (107,107) :: cc_OK
  integer :: i, j
  double precision, dimension (3,600) :: coord
  if (first) then
    first = .false.
!
!   Determine which core-core terms are valid
!
    cc_OK = .true.
    do i = 1, 100
      do j = 1, i
        cc_OK(i,j) = (alpb(i,j) > 1.d-4)
        cc_OK(j,i) = cc_OK(i,j)
      end do
    end do
    cc_OK(:,98:) = .true.
    cc_OK(98:,:) = .true.
    cc_OK(:,57:71) = .true.
    cc_OK(57:71,:) = .true.
  end if
!
!  Find all pairs of atoms that are near to each other (less than 5 Angstroms)
!
  call gmetry (geo, coord)
  do i = 2, numat
    ni = nat(i)
    do j = 1, i - 1
      if((coord(1,i)-coord(1,j))**2 + &
    &    (coord(2,i)-coord(2,j))**2 + &
    &    (coord(3,i)-coord(3,j))**2 < 25.5d0) then
        ccp(ni,nat(j)) =  ccp(ni,nat(j)) + 1
        if(.not. cc_OK(ni, nat(j))) then
          core_core_OK = .false.
          nj = nat(j)
          return
        end if
      end if
    end do
  end do
  do i = 1, numat
    ccp(nat(i), nat(i)) = ccp(nat(i), nat(i)) + 1
  end do
  ccp(:,98:) = 1
  ccp(98:,:) = 1
  core_core_OK = .true.
end  function core_core_OK

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

! ____________________________________________________________________________
! _________________________ OVERLAP ROUTINES _________________________________
! ____________________________________________________________________________

      subroutine ovlap (s, x, y, z)

      use reimers_C, only : n, na, natm, iat, nbt, nprn, nbeta, &
          zeta, zetad, zetawt, fssig, fpsig, fppi, fdsig, fdpi, &
          fddel, pp, bincoe, fact, d, e, fspdf, kflag, jflag
      USE molkst_C, ONLY: mpack, keywrd

      implicit none
      double precision ::  x(na), y(na), z(na), s(mpack), &
                        one, two, zero, &
                        g, abc, acu, amu, bcu, bmu, bin, &
                        edel, ephi, epi, esig, ggg, &
                        pig, delg, phig, &
                        reada, rij, sigg, ss, sp, sd, sf, &
                        sss, ssp, ssd, ssf, &
                        u1, u2, u3
      integer ::        langl(16), i, j, k, &
                        i1, ind, iss, issmax, &
                        ja, jb, jj, jl, jlp1, jm, jnat, jnp, jss, jssmax, &
                        ka, kb, kl, klp1, knat, knp, la, lh, minkm, nm
      character*9       atomk, atomkx, atomj, atomjx
      logical           agovlp
      double precision  agfact

      data one/1.d0/, two/2.d0/, zero/0.0d0/
      data langl/0, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3/

      edel = 0.d0
      epi = 0.d0
      pig = 0.d0
      phig = 0.d0
      delg = 0.d0
      ss = 0.d0
      sp = 0.d0
      sd = 0.d0
      sf = 0.d0
      sigg = 0.d0
      jm = 0

! RMG - add scaling factor
      agovlp = .False.
      agfact = 0.d0
      if (index(keywrd, ' AGOVLP = ') /= 0) then
          agovlp = .True.
          agfact = reada(keywrd, index(keywrd, ' AGOVLP = '))
      end if

      if (nbeta == 4) then
!	**** Tomono betas, set overlap to nearest neighbour indicator ****
        nm = 0
        do i = 1, n
          do j = 1, i
            nm = nm + 1
            s(nm) = zero
            if (r(i, j) < 1.7d0) s(nm) = one
          end do
        end do
        return
      end if

!     *********************************************************
!     ******* general overlap code ****************************
!     *********************************************************

!     **** n - factorial ****
      fact(1) = 1
      do i = 2, 30
        fact(i) = fact(i - 1) * (i - 1)
      end do

!
!     ********* form binomial coeffecient *******
!
!      (n )
!      (m )  index = n*(n + 1)/2 + m + 1
!
      bincoe(1) = 1.d0
      ind = 2
      do 601 i = 1, 29
      i1 = i + 1
      do 602 j = 1, i1
      jj = i1 - j + 1
      if (j < 26)go to 66
      bin = 1.d0
      if (j >= jj)then
      do 62 k = j, i
      bin = bin*dfloat(k)
62    continue
      bincoe(ind) = bin/fact(jj)
      else
      do 64 k = jj, i
      bin = bin*dfloat(k)
64    continue
      bincoe(ind) = bin/fact(j)
      end if
      go to 60
66    bincoe(ind) = fact(i1)/fact(j)/fact(jj)
60    ind = ind + 1
602   continue
601   continue

!  introduce atomk and atomj to test if treating the same shell
!
!    kflag(1) - - > k atom no
!    kflag(2) - - > k pqn
!    kflag(3) - - > k lqn
!    jflag(1) - - > j atom no
!    jflag(2) - - > j pqn
!    jflag(3) - - > j lqn
!
!  initialise atomkx and atomjx to zero
      atomkx = '  0  0  0'
      atomjx = ' 0 0 0'
!
!     fspdf(i, j) is weighting factor.
!     i = angular quantum number + 1,
!     j = 1, 2, 3, 4 for sigma, pi, delta, phi.
      do 1 i = 1, 4
      do 11 j = 1, 4
      fspdf(i, j) = one
   11 continue
    1 continue
      fspdf(1, 1) = fssig
      fspdf(2, 1) = fpsig
      fspdf(2, 2) = fppi
      fspdf(3, 1) = fdsig
      fspdf(3, 2) = fdpi
      fspdf(3, 3) = fddel
!
!  set pp (in common pptt) to - 10.d0 so as to initialise ovlap
!
      pp = -10.d0
!
      nm = 0
      do 100 i = 1, n
        ka = iat(i)
        kb = nbt(i)
        knat = natm(ka)
        knp = nprn(i)
        kl = langl(kb + 1)
        klp1 = kl + 1
        kflag(1) = ka
        kflag(2) = knp
        kflag(3) = kl
!
!      do an internal write to convert the saved flag values to
!      character strings.
!
        write(atomk, '(3i3)') kflag
        do 90 j = 1, i
          nm = nm + 1
          if (j == i) then
            s(nm) = 1.d0
            goto 90
          end if
          ja = iat(j)
          jb = nbt(j)
          jnat = natm(ja)
          jnp = nprn(j)
          jl = langl(jb + 1)
          jlp1 = jl + 1
          jflag(1) = ja
          jflag(2) = jnp
          jflag(3) = jl
          write (atomj, '(3i3)') jflag
          rij = r(ja, ka)
!
!    one center overlaps
!
         if (ja == ka) then
            s(nm) = zero
            go to 90
         end if

         if (kb <= jb) then
            la = jb
            lh = kb
         else
           la = kb
           lh = jb
           rij = -rij
         end if

!	  **** geometrical matrices ****

          if (abs(rij) < 1.0D-4) then
            u1 = one
            u2 = one
            u3 = zero
          else
            u1 = (z(ja) - z(ka))/rij
            g = one - u1**2
            if (g  <=  1.D-7) then
              u2 = one
              if (u1 < zero) u2 = -one
              u3 = zero
            else
              g = one/dsqrt(g)
              u2 = (x(ja) - x(ka))*g/rij
              u3 = (y(ja) - y(ka))*g/rij
            end if
          end if

      call geome (u1, u2, u3, lh, d)
      call geome (u1, u2, u3, la, e)

!.......................................................
!
!     get phase for e transform
!     phase (- 1)**(l - m) on la >= the other l value
!
      if (la == jb) jm = jlp1
      if (la == kb) jm = klp1
      go to (27, 28, 29, 30), jm
!
!  f - orbs
!
   30 ephi = one
      edel = -one
!
!  p - orbs
!
   28 epi = one
      esig = -one
      go to 31
!
!  d-orbs
!
   29 edel = one
      epi = -one
!
!  s - orbs
!
   27 esig = one
   31 continue
!.......................................................
      rij = abs (rij)
      if (atomk == atomkx.and.atomj == atomjx) go to 46
      atomkx = atomk
      atomjx = atomj
      ss = zero
      sp = zero
      sd = zero
      sf = zero
!
!     do double zeta for each atom.  when exponent is zero, quit.
!
      issmax = 1
      if (nbt(i) > 3) issmax = 2
      jssmax = 1
      if (nbt(j) > 3) jssmax = 2

      do 38 iss = 1, issmax
         if (nbt(i) > 3)  then
           acu = zetawt(iss, knat)
           amu = zetad(iss, knat)
         else
           acu = 1.d0
           amu = zeta(knat)
         end if
         if (amu < 1.0d-4) go to 38

         do 32 jss = 1, jssmax
            if (nbt(j) > 3)  then
              bcu = zetawt(jss, jnat)
              bmu = zetad(jss, jnat)
            else
              bcu = 1.d0
              bmu = zeta(jnat)
            end if
            if (bmu < 1.0d-4) go to 32

            abc = acu*bcu
            call ovlaap(knp, kl, amu, jnp, jl, bmu, rij, sss, ssp, ssd, ssf)
            ss = ss + sss*abc
            sp = sp + ssp*abc
            sd = sd + ssd*abc
            sf = sf + ssf*abc
   32       continue
   38    continue

!     **** this is some type of damping for low r, uses ZINDOs alt single STO set
      ggg = 0.d0
      if (kl /= jl) then
!	**** set interaction factors to one for cross sp, sd, pd interactions ****
        sigg = one
        pig = one
        delg = one
        phig = one
      else
!	**** ss, pp, or dd interaction, damped ****
        sigg = (fspdf(klp1, 1) + fspdf(jlp1, 1))/two
        pig = (fspdf(klp1, 2) + fspdf(jlp1, 2))/two
        delg = (fspdf(klp1, 3) + fspdf(jlp1, 3))/two
        phig = (fspdf(klp1, 4) + fspdf(jlp1, 4))/two
        sigg = sigg + (one - sigg)*ggg
        pig = pig + (one - pig )*ggg
        delg = delg + (one - delg)*ggg
        phig = phig + (one - phig)*ggg
      end if

!.......................................................
!
!  form sigma overlap
!
 46   s(nm) = e(1)*d(1)*ss*esig*sigg
!
!  check how many terms in overlap
!
      minkm = min0(kl, jl) + 1
      go to (50, 47, 48, 49), minkm
!
!  phi overlap
!
   49 s(nm) = s(nm) + (e(6)*d(6) + e(7)*d(7))*sf*ephi*phig
!
!  delta overlap
!
   48 s(nm) = s(nm) + (e(4)*d(4) + e(5)*d(5))*sd*edel*delg
!
!  pi overlap
!
   47 s(nm) = s(nm) + (e(2)*d(2) + e(3)*d(3))*sp*epi*pig
!
!.......................................................
   50 continue

! RMG - Ag overlap scaling
      if (agovlp) then
        if ((knat == 47.or.jnat == 47).and.knat /= jnat) then
          s(nm) = s(nm)*agfact
        end if
      end if

   90 continue
  100 continue

      return

      contains
            double precision function r(i, j)
                  implicit none
                  integer :: i, j
                  r = sqrt((x(j) - x(i))**2 + (y(j) - y(i))**2 + (z(j) - z(i))**2 )
            end function r

      end subroutine ovlap

!     *************************************************************************

      subroutine ovlaap (n1, l1, amu, n2, l2, bmu, r, s, sp, sd, sf)
!
!     evaluates overlap between two slater type orbitals.
!     n1, n2, are princ. q.no. - s, l1, l2, are secondary q.n. - s, , amu and
!     bmu are the exponential constants. r is the separation in angstrom
!     s is the sigma, sp the pi, sd the delta and sf the f compoents of
!     the overlap, to be put together using lh and sub. geom.
!     fact(i + 1) = factorial i.
!
      use reimers_C, only : au2ang, pp, fact, ss

      implicit none
      double precision ::  zero, one, two, &
                        f, p, r, s, t, &
                        amu, bmu, rr, sp, sd, sf, ssss, tt
      integer ::           i, ii, l1, l2, lmin, mm, n1, n2, nn
      save :: tt

      data              zero/0.d0/, one/1.d0/, two/2.d0/

      if (abs(pp + 10.d0) < 1.d-10)then
      tt = zero
      end if
      rr = r/au2ang
      p = (amu + bmu)*rr/two
      t = (amu - bmu)/(amu + bmu)
      if (r <= 1.d-3) go to 300
      if(dabs (t) <= 1.d-4) t = zero
      if(abs(p - pp) < 1.d-10 .and. abs(t - tt) < 1.d-10) go to 5
      pp = p
      tt = t
      call aux (p, t)
    5 continue
      ss(2) = zero
      ss(3) = zero
      ss(4) = zero
      lmin = l1
      if (l2 < l1) lmin = l2
      lmin = lmin + 1
      do 10 ii = 1, lmin
      i = ii - 1
      call molpab (n1, n2, l1, l2, i, i, amu, bmu, rr, ssss)
      ss(ii) = ssss
   10 continue
      s = ss(1)
      sp = ss(2)
      sd = ss(3)
      sf = ss(4)
      go to 500
!     one center overlap.
  300 s = zero
      sp = zero
      sd = zero
      sf = zero
      if (l1 /= l2) go to 500
      nn = 2*n1 + 1
      mm = 2*n2 + 1
      f = (one - t)**mm*(one + t)**nn
      s = fact(n1 + n2 + 1)*dsqrt(f/(fact(nn)*fact(mm)))
      if (l1 > 0) sp = (- one)**(l1 + 1)*s
      if (l1 > 1) sd = (- one)**(l1 + 2)*s
      if (l1 > 2) sf = (- one)**(l1 + 3)*s
      s = (- one)**l1*s
  500 continue
      return
      end subroutine ovlaap

!     *************************************************************************

      subroutine aux (pp, tt)

!     this subroutine calculates a and b fns. for molecular integrals.
!     b - fns. of argument pp*tt and with indices of 0 to ix, a fns. of
!     argument pp and indices from 0 to ix.
! **  references:
! **  (a) mullikan/rieke/orloff/orloff (1949) jcp 17, 1248;
! **      pp (= p or = rho) = 1/2*[mu(a) + mu(b)]*r/a(h)
! **      tt (= t or = tau) = [mu(a) - mu(b)]/[mu(a) + mu(b)]
! **  (b) kotani/amemiya/simose (1940) proc. phys. mat. soc. japan 22, 1

      use reimers_C, only : a, b
      implicit none
!      implicit          double precision :: (a - h, o - z)
      double precision ::  pp, tt, upplim, zero, one, two, &
                        c, d, h, r, t, ra, rho2, tr
      integer ::           i, j, k, il, in, ir, is, ix, ixm, ixs, jy

      data upplim       /1.0D36/
      data zero, one, two /0.0d0, 1.0d0, 2.d0/

        ix = 32
        rho2 = pp*tt
        ir = int(abs(rho2 + rho2))
        if (ir > 170) go to 100
        is = min0(ir + 1, 15)
!
!     first the more difficult b - fn.
!
        if (dabs(rho2) <  1.d-3) go to 35
           if (pp > 40.0d0) go to 100
              d = dexp(rho2)
              h = dexp(- rho2)
              r = d-h
!
!     if the value of rho is too small the sinh must be obtained by
!     summing the infinite series rather than by addition of two
!     exponentials
!
        if (dabs(r) - 1.d-1 >= 0.d0) go to 28
           ra = zero
           t = rho2
              do 27 i = 2, 25
              if (dabs(t) < 1.d-18) go to 127
              t = t*rho2*rho2/dfloat((i + i - 1)*(i + i - 2))
              ra = ra + t
27            continue
127     continue
        r = (ra + rho2)*two
28      b(1) = r/rho2
!
!     as many successive b functions are generated from b(0) by the
!     recursion formula as accuracy will permit.
!
        ixs = ix
            do 51 i = 2, ixs, is
            if (ir == 0) go to 40

            il = is - 1
            if ((i + il) > ix) il = ix - i + 1
              do 31 j = 1, il
              k = i + j - 1
                 if (mod(k, 2) <= 0) go to 30
                 b(k) = (r + dfloat(k - 1)*b(k - 1))/rho2
                 go to 31
30               b(k) = -(d + h - dfloat(k - 1)*b(k - 1))/rho2
31               continue
40               in = i + is - 1
                 if (in - ix <= 0) go to 39
                 if (in - ix > 0) go to 38
!
!     after the recurrence formula has been applied an appropriate no.
!     of times the next b function is obtained by summing the infinite
!     series.
!
39      if (mod(in, 2) > 0) go to 44
        tr = rho2
        b(in) = -(tr + tr)/dfloat(in + 1)
          do 43 j = 1, 500
          tr = tr*rho2*rho2/dfloat((j + j)*(j + j + 1))
!      note accuracy criterion
!      if (dabs(tr/b(in)) - 0.000011 ) 51, 51, 43
          if (dabs(tr) - 1.d-7*dabs(b(in)) <= 0.d0) go to 51
          b(in) = b(in) - (tr + tr)/dfloat(in + 1 + j + j)
43        continue
44        tr = one
          b(in) = (tr + tr)/dfloat(in)
          do 46 j = 1, 500
          tr = tr*rho2*rho2/dfloat((j + j)*(j + j - 1))
!      note accuracy criterion
!      if (dabs(tr/b(in)) - 0.00001  ) 51, 51, 46
          if (dabs(tr) - 1.d-7*dabs(b(in)) <= 0.d0) go to 51
            b(in) = b(in) + (tr + tr)/dfloat(in + j + j)
46        continue
51        continue
        go to 38
!
!     if the argument of the b - fn is zero a separate formula is used.
!
35      continue
        jy = ix/2
           do 36 i = 1, jy
              b(i + i) = zero
           b(i + i - 1) = two/dfloat(i + i - 1)
36      continue
38      continue
!
!     now the a - functions
!
        c = dexp(- pp)
        a(1) = c/pp
        ixm = ix - 3
            do 15 i = 2, ixm
              if (a(i - 1) >= upplim) then
                  a(i) = a(i - 1)
                     go to 15
              end if
              a(i) = (dfloat(i - 1)*a(i - 1) + c)/pp
15          continue
            go to 500
100     continue
          do 120 i = 1, ix
             a(i) = 0.0d0
             b(i) = 0.0d0
120       continue
500       return
          end subroutine aux

!     *************************************************************************

       subroutine molpab (n1, n2, l1, l2, m1, m2, sk1, sk2, r, vest)
!
!     this subroutine calculates two centered overlap integrals
!
      use reimers_C, only : fact

!      implicit          double precision :: (a - h, o - z)
      implicit none
      double precision ::   sk1, sk2, r, vest, &
                         f1, f2, f3, f4, f5, f6, &
                         f11, f12, f13, f14, f15, f16, f17, f18, &
                         q1, q2, rhoa, rhob, strad, strad1, term, value
      integer ::            j, k, iff, jend, ju, kend, ku, &
                         l1, l2, m1, m2, n1, n2

      vest = 0.0d0
      if (m1 /= m2)  go to 500
      strad = 0.0d0
      rhoa = r*sk1
      rhob = r*sk2
      f1 = fact(2*n1 + 1)
      f2 = fact(2*n2 + 1)
      iff = l1 - m1 + 1
      f3 = fact(iff)
      iff = l2 - m2 + 1
      f4 = fact(iff)
      iff = l1 + m1 + 1
      f5 = fact(iff)
      iff = l2 + m2 + 1
      f6 = fact(iff)
      q1 = (sk1**n1/dsqrt(f1))*r**n1
      q2 = (sk2**n2/dsqrt(f2))*r**n2
      term = dsqrt(dfloat((2*l1 + 1)*(2*l2 + 1))*&
     &  (f3/f5)*(f4/f6)*rhoa*rhob)/2.d0**(l1 + l2 + 1)
      term = q1*term*q2
      jend = 1 + ((l1 - m1)/2)
      kend = 1 + ((l2 - m2)/2)
      do 501 j = 1, jend
      ju = j - 1
      iff = 2*l1 - 2*ju + 1
      f11 = fact(iff)
      iff = l1 - m1 - 2*ju + 1
      f13 = fact(iff)
      f15 = fact(ju + 1)
      iff = l1 - ju + 1
      f17 = fact(iff)
      do 502 k = 1, kend
      ku = k - 1
      iff = 2*l2 - 2*ku + 1
      f12 = fact(iff)
      iff = l2 - m2 - 2*ku + 1
      f14 = fact(iff)
      f16 = fact(ku + 1)
      iff = l2 - ku + 1
      f18 = fact(iff)
      call cfunct (n1 - l1 + 2*ju, n2 - l2 + 2*ku, l1 - m1 - 2*ju, l2 - m2 - 2*ku, m1, value)
      strad1 = value * (f11/f13/f15/f17) * (f12/f14/f16/f18)
      if (mod(ju + ku, 2) == 1) strad1 = -strad1
      strad = strad + strad1
  502 continue
  501 continue
      vest = term*strad
  500 return
      end subroutine molpab

!     *************************************************************************

      subroutine cfunct (ia, ib, ic, id, ie, snag)

      use reimers_C, only : bincoe, a, b
!      implicit          double precision :: (a - h, o - z)
      implicit none
      double precision ::   count, b1, b2, b3, b4, b5, b6, snag, term
      integer ::            i, i1, i2, i3, i4, i5, i6, &
                         ia, ib, ic, id, ie, ip, ir, &
                         iab, ibb, icb, idb, ieb, &
                         inda, indb, indc, indd, inde, nin

      nin(i) = i * (i - 1) / 2

      count = 0.0d0
      iab = ia + 1
      ibb = ib + 1
      icb = ic + 1
      idb = id + 1
      ieb = ie + 1
      inde = nin(ieb)
      indd = nin(idb)
      indc = nin(icb)
      indb = nin(ibb)
      inda = nin(iab)
      do 901 i6 = 1, ieb
      b6 = bincoe(inde + i6)
      do 902 i5 = 1, ieb
      b5 = bincoe(inde + i5)
      do 903 i4 = 1, idb
      b4 = bincoe(indd + i4)
      do 904 i3 = 1, icb
      b3 = bincoe(indc + i3)
      do 905 i2 = 1, ibb
      b2 = bincoe(indb + i2)
      do 906 i1 = 1, iab
      b1 = bincoe(inda + i1)
      term = b1*b2*b3*b4*b5*b6
      if (mod(i2 + i5 + i6 + i4 + ie + id, 2) == 1) term = -term
      ir = i1 + i2 - i3 - i4 + ie + ie - i6 - i6 + ic + id + 3
      ip = ia - i1 + ib - i2 + ie + ie - i5 - i5 + ic - i3 + id-i4 + 7
      count = count + a(ip)*b(ir)*term
  906 continue
  905 continue
  904 continue
  903 continue
  902 continue
  901 continue
      snag = count
      end subroutine cfunct

!     *************************************************************************

      subroutine geome (ct, cp, sp, m, h)
!
!     this subroutine gives the transformation matrix necessary for the
!     expression of p, d, and f tensors in the simplest canonical terms.
!
!     m = 0, 1, 2, 3, 4, 5, 6, 7, 8 for s, x, y, z, 3z2 - r2, x2 - y2, xy, xz, yz respectively
!     ____________ deleted to save space ______________
!     m = 9, 10, 11, 12, 13, 14, 15 for z3, xz2, yz2, z(x2 - y2), xyz, x(x2 - 3y2), and
!        y(3x2 - y2)
!     m = 51, 52, 53 for x2, y2, z2
!
!     h(i) returns as sigma, pi - x, pi - y, delta - (x**2 - y**2), delta - xy, phi -
!          x(x2 - 3y2), phi - y(3x2 - y2), and s component if any.
!
!     the phases of the real fns. are those of frank harris in the upps
!     ala monograph.
!     spherical coordinates. ct = cos(theta), cp = cos(phi), sp = sin(phi).
!     h returns as trans elements of 3 - dim. space for p orb. and of 5 - di
!     m space for the d orb., etc.

!      implicit          double precision :: (a - h, o - z)
      implicit none
      double precision ::   h(8), ct, cp, sp, dsqrt3, one, two, three, zero, &
                         r, st, z
      integer ::            m

      data dsqrt3/1.732050807d0/one/1.d0/zero/0.d0/two/2.d0/three/3.d0/

      h(1) = one
      h(2) = zero
      h(3) = zero
      h(4) = zero
      h(5) = zero
      h(6) = zero
      h(7) = zero
      h(8) = zero
      if (m == 0) go to 50
      continue
      r = two*sp*cp
      st = dabs (one - ct**2)
      if (1.D-7 - st <= 0.d0) go to 22
      st = zero
      go to 24
   22 continue
      st = dsqrt(st)
   24 continue
      z = cp**2 - sp**2
      go to (1, 2, 3, 4, 5, 6, 7, 8), m
!     p type fn.
    1 h(1) = cp*st
      h(2) = cp*ct
      h(3) = -sp
      go to 50
    2 h(1) = sp*st
      h(2) = sp*ct
      h(3) = cp
      go to 50
    3 h(1) = ct
      h(2) = -st
      h(3) = zero
      go to 50
!     d type fn .
    4 h(1) = (three*ct*ct - one)/two
      h(2) = -dsqrt3*ct*st
      h(3) = zero
      h(4) = dsqrt3*(one - ct**2)/two
      h(5) = zero
      go to 50
    5 h(1) = dsqrt3*z*(one - ct*ct)/two
      h(2) = ct*z*st
      h(3) = -st*r
      h(4) = z*(one + ct*ct)/two
      h(5) = -r*ct
      go to 50
    6 h(1) = dsqrt3*cp*sp*(one - ct*ct)
      h(2) = ct*st*r
      h(3) = z*st
      h(4) = cp*sp*(one + ct*ct)
      h(5) = ct*z
      go to 50
    7 h(1) = dsqrt3*cp*ct*st
      h(2) = cp*(two*ct*ct - one)
      h(3) = -sp*ct
      h(4) = -h(1)/dsqrt3
      h(5) = sp*st
      go to 50
    8 h(1) = dsqrt3*sp*ct*st
      h(2) = sp*(two*ct*ct - one)
      h(3) = cp*ct
      h(4) = -h(1)/dsqrt3
      h(5) = -cp*st
   50 continue
      return
      end subroutine geome

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

subroutine gettxt
    use common_titles, only : koment, title
    use common_systm, only : ir, iw
    use common_keywrd, only : keywrd
    implicit none
      keywrd = " "
      koment = "    NULL  "
      title = "    NULL  "
      read (ir, "(A)", end=1700, err=1600) keywrd (:120)
      call upcase (keywrd(1:len_trim(keywrd)), len_trim(keywrd))
      if (Index (keywrd, "SETUP") /= 0) then
      else if (Index (keywrd(1:80), " +") /= 0) then
!
!  READ SECOND KEYWORD LINE
!
        read (ir, "(A)", end=1700, err=1600) keywrd (81:160)
        call upcase (keywrd(81:160), 80)
        if (Index (keywrd(81:160), "SETUP") /= 0) then
        else if (Index (keywrd(81:160), " +") /= 0) then
!
!  READ THIRD KEYWORD LINE
!
          read (ir, "(A)", end=1700, err=1600) keywrd (161:240)
          call upcase (keywrd(161:240), 80)
        end if
!
!  READ TITLE LINE
!
      else if (Index (keywrd(:80), "&") /= 0) then
        read (ir, "(A)", end=1700, err=1600) keywrd (81:160)
        call upcase (keywrd(81:160), 80)
        if (Index (keywrd(81:160), "SETUP") /= 0) then
        else if (Index (keywrd(81:160), "&") /= 0) then
          read (ir, "(A)", end=1700, err=1600) keywrd (161:240)
          call upcase (keywrd(161:240), 80)
        else
          read (ir, "(A)", end=1700, err=1600) title
        end if
      else
        read (ir, "(A)", end=1700, err=1600) koment, title
      end if
      
      call upcase (keywrd, 241)
      go to 1800
1600  write (iw, "(A)") " ERROR IN READ OF FIRST THREE LINES"
1700  continue
1800  continue
      return
end subroutine gettxt

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine make_line (nvecs, fcells)
!
! 
!
  use common_common, only : id, ir, iw, data_set_name, mr1, mr2, mr3, phonon, iw_new, jobnam, line, &
    l_read_dat
  implicit none
  integer, intent(in) :: nvecs
  double precision, dimension(nvecs, nvecs*(mr1*mr2*mr3 + 1)), intent(in) :: fcells
!
  complex, allocatable, dimension(:) :: v
  double precision, dimension(:,:), allocatable :: alleig, all_points
  integer :: i, j, k, l, m, mm, npts, point
  real :: x, y, scale=0.5, old_dist, ratio, bottom
  double precision :: dist, stepy, xkold = 0.d0, del_point(4)
  double precision :: emax, emin, erange, step, stepx, stepz, xk, xk1, &
       & xk2, xofset, yk, yk1, yk2, zk, zk1, maximum, minimum, reset_zero = -0.2d0, last_x
  double precision :: ykold = 0.d0, zk2, zkold = 0.d0, distance = 0.d0
  double precision :: eigs(2*nvecs), xyzk(3,2)
  integer, parameter :: npoints = 4
  character :: num*1, char_points(3)*3, symbols*100, line_1*100, &
    points(npoints)*6 =  (/"GAMMA", "DELTA", "LAMBDA", "SIGMA" /), &
    pts(npoints)*3 = (/"G G", "D G", "L G", "S G"/)
  logical :: opend
  save
! 
! ... Executable Statements ...
! 
  allocate(alleig(nvecs, 0:10000))
  allocate(v(nvecs**2)) 
  allocate(all_points(4, 0:10000))
  call graphics (0.0, 0.0, 6)
  xofset = 0.d0
  last_x = 0.d0
  emin = 100.d0
  emax = -100.d0
  point = 0
  data_set_name = trim(data_set_name)//".dat"
  do
    if (l_read_dat) then
      write (iw, '(a)') " Please type starting and ending points in k-space"
      write (iw, "(A,I2,A)") " Format is", 2*id, " numbers, free format, all on one line"
      write (iw, *) " To quit, type 'quit'."
    end if
    read (ir, '(a80)', end = 1000, err = 1000) line
    i = len_trim(line)
!
!  Work out the starting, middle, and terminal point symbols for the current line.
!
    line_1 = trim(line)
    call upcase(line)
    symbols = trim(line)
    char_points = " "
    l = 0
    m = 2
    do k = 1, 3
      symbols = " "
      do j = m - 1, len_trim(line)
        if (line(j:j) >= "A" .and. line(j:j) <= "Z") then
          do m = j, len_trim(line) + 1
            if (line(m:m) == " ") then
              symbols = " "//line(j:m)
              line(j:m) = " "
              exit
            end if
          end do
        end if        
        if (symbols /= " ") exit
      end do   
      if (len_trim(symbols) == 3 .and. (symbols(3:3) >= "0" .and. symbols(3:3) <= "9" .or. &
        symbols(3:3) == """" .or. symbols(3:3) == "'") .or. len_trim(symbols) == 2) then
        l = l + 1
        char_points(l) = symbols(2:3)//"R"
      else       
        do j = 1, npoints
          mm = index(symbols, " "//trim(points(j)))
          if (mm /= 0) exit
        end do    
        if (j <= npoints) then
          l = l + 1
          char_points(l) = pts(j)
          mm = mm + 1 + len_trim(points(j))
          if (symbols(mm:mm) == "'") char_points(l)(2:2) = char(162) ! Greek symbol for "'"
        end if
      end if
    end do
    if (l == 2) then
      char_points(3) = char_points(2)
      char_points(2) = " "
    end if
!
! Manipulate the starting and ending points of the line in k-space.
!
    line = trim(line_1)
    if (i < 30) write(line(30:),'(a, i2, a)')": Starting and ending points in k-space, ", 2*id, " numbers, ""quit"" to quit"
    call write_keystrokes(line, len_trim(line))    
    read(line,*, end = 1000, err = 1000) ((xyzk(i, j), i = 1, id), j = 1, 2)
    zk2 = xyzk(3,2)
    yk2 = xyzk(2,2)
    xk2 = xyzk(1,2)
    zk1 = xyzk(3,1)
    yk1 = xyzk(2,1)
    xk1 = xyzk(1,1)
    old_dist = real(Sqrt ((xk1 - xk2)**2 + (yk1 - yk2)**2 + (zk1 - zk2)**2))
    if (id /= 1) then
      do i = 1, 2
        call rot (xyzk(1, i))
      end do
    end if
    zk2 = xyzk(3,2)
    yk2 = xyzk(2,2)
    xk2 = xyzk(1,2)
    zk1 = xyzk(3,1)
    yk1 = xyzk(2,1)
    xk1 = xyzk(1,1)
    dist = Sqrt ((xk1 - xk2)**2 + (yk1 - yk2)**2 + (zk1 - zk2)**2)
    if (dist < 1.d-5) exit
    ratio = real(old_dist/dist)
    if (xofset /= 0.d0) then
      if (Abs (xk1 - xkold) > 1.d-2 .or. Abs (yk1 - ykold) > 1.d-2 .or. Abs (zk1 - zkold) > 1.d-2) then
!
!  Discontinuity in Band Structure - put in a small gap
!
        xofset = xofset + 0.1d0
        distance = distance + 0.1d0
      end if
    end if
    npts = Nint (300*dist)
    stepx = (xk2 - xk1) / npts
    stepy = (yk2 - yk1) / npts
    stepz = (zk2 - zk1) / npts
    xk = xk1 - stepx
    yk = yk1 - stepy
    zk = zk1 - stepz
    do i = 0, npts
      xk = xk + stepx
      yk = yk + stepy
      zk = zk + stepz
      call kpoint (fcells, nvecs, xk, yk, zk, v, eigs)
      point = point + 1
      do j = 1, nvecs
        alleig(j, point) = eigs(j)
      end do
      if (i > 0)  distance = distance + old_dist/npts
      all_points(1,point) = distance
      all_points(2,point) = xk
      all_points(3,point) = yk
      all_points(4,point) = zk
      if (xofset == 0.d0) then
        do j = 1, nvecs
          emin = Min (emin, eigs(j))
          emax = Max (emax, eigs(j))
        end do
      end if
    end do
    erange = 0.505d0*(emax - emin)
    step = dist / npts
    if (id == 1) scale = scale*4.0
!
!  Write scale on left-side of the walk
!
    if (x < 0.01) call write_scale(emin, emax, erange, reset_zero, bottom)
    x = Real (xofset)
!
!  Left-hand side vertical bar.
!
    call graphics (x*scale, -0.05, 2)
    call graphics (x*scale, bottom, 3)
!
!  Write the Brillouin zone symbol
!
    write(line,'(a)')char_points(1)
    call graphics (x*scale - 0.01, bottom, 96) ! Symbol of Brillouin-zone point
    last_x = x
!
!   Draw the plot.
!
    do i = 1, nvecs
      y = 1.95 - Real ((alleig(i, point - npts) - emin + reset_zero)/erange)
      x = Real (0.d0 + xofset)
      call graphics (x*scale,  y, 2)
      do j = 1,npts
      k = point - npts + j 
      y = 1.95 - Real ((alleig(i, k) - emin + reset_zero)/erange)
      x = Real (j*step*ratio + xofset)
      call graphics (x*scale,  y, 3)
      end do
    end do
!
!  Normal right-hand side vertical bar.
!
    call graphics (x*scale, -0.05, 2)
    call graphics (x*scale, bottom, 3)
    write(line,'(a)')char_points(2)
    call graphics (real(x + last_x)*0.5*scale - 0.01, bottom, 96) ! Symbol of Brillouin-zone point
    write(line,'(a)')char_points(3)
    call graphics (x*scale - 0.01, bottom, 96) ! Symbol of Brillouin-zone point
!
!   Draw the bottom line
!
    x = Real (xofset)
    call graphics (x*scale, bottom, 2)
    x = x + Real (dist)*ratio
    call graphics (x*scale, bottom, 3)
    last_x = xofset
    xofset = xofset + dist*ratio
    xkold = xk2
    ykold = yk2
    zkold = zk2
  end do
1000 x = Real (xofset)
  maximum = -1.d9
  minimum = 1.d9
  do j = 1,point
    maximum = max(maximum, alleig(nvecs,j))
    minimum = min(minimum, alleig(1,j))
  end do
  i = int(maximum - minimum)
  if (i > 100) then !  Work out step-size
    j = 20
  else if (i > 50) then
    j = 10
  else if (i > 20) then
    j = 5
  else 
    j = 2
  end if
  maximum = int(maximum/j)*j + j 
  minimum = minimum + 10000
  minimum = int(minimum/j)*j 
  minimum = minimum - 10000
  if (phonon) then
    num = "1"
  else
    num = "3"
  end if
  del_point(:) = all_points(:,2) - all_points(:,1)
!
! Write everything to a file, then stop
!
  inquire(unit=iw_new, opened=opend) 
  if (opend) close (iw_new)
98 open (unit = iw_new, file = trim(jobnam)//".txt", form = "FORMATTED", status = "UNKNOWN", iostat = i)
  if (i /= 0) then
    write(iw,*)" File: '"//trim(jobnam)//".txt' cannot be opened."
    call sleep(1)
    goto 98
  end if
  write(iw_new,'(f8.3,f8.'//num//')',iostat = i)0.0, maximum
  if (i /= 0) then
    write(iw,*)" Cannot write to file: '"//trim(jobnam)//".txt'."
    call sleep(1)
    goto 98
  end if
  do j = 1, point
    if (j > 1) then
      step = abs(del_point(2) - all_points(2,j) + all_points(2,j - 1)) + &
             abs(del_point(3) - all_points(3,j) + all_points(3,j - 1)) + &
             abs(del_point(4) - all_points(4,j) + all_points(4,j - 1)) 
      if (step > 0.0001d0) then
        if (step > 0.01d0) then
          write(iw_new,'(f8.3,100f8.'//num//')')all_points(1,j - 1),minimum
          write(iw_new,'(f8.3,100f8.'//num//')')all_points(1,j - 1),maximum
          write(iw_new,'(f8.3,100f8.'//num//')')all_points(1,j - 1),minimum
          write(iw_new,'(f8.3,100f8.'//num//')')all_points(1,j - 1),minimum
          write(iw_new,'(f8.3,100f8.'//num//')')all_points(1,j),minimum
        end if
        write(iw_new,'(f8.3,100f8.'//num//')')all_points(1,j),minimum
        write(iw_new,'(f8.3,100f8.'//num//')')all_points(1,j),maximum
        write(iw_new,'(f8.3,100f8.'//num//')')all_points(1,j),minimum
        del_point(:) = all_points(:,j + 1) - all_points(:,j)
      end if
    end if
    write(iw_new,'(f8.3,100f8.'//num//')')all_points(1,j),minimum, (alleig(i,j), i = 1, nvecs)
  end do
  write(iw_new,'(f8.3,100f8.'//num//')')all_points(1,j - 1),maximum
  write(iw,'(/5x,a)')"A copy of this output can be found in the file: '"//trim(jobnam)//".txt'"
  write(iw,'(/5x,a)')"Press ""RETURN"" to quit"
  read(iw,'(a)', iostat = i) num
  call graphics(0.0, 0.0, 100)
  stop
  end subroutine make_line
  
  
  subroutine write_scale(emin, emax, erange, reset_zero, bottom)
  use common_common, only : line
  implicit none
  double precision, intent (in) :: emin, emax, reset_zero, erange
  real, intent (out) :: bottom
  integer, parameter :: nsteps = 12
  real :: lower_bound, upper_bound, zero, y, marker, step, range, &
  steps(nsteps) = (/5000.0, 2000.0, 1000.0, 500.0, 200.0, 100.0, 50.0, 20.0, 10.0, 5.0, 2.0, 1.0/)     
  character :: num*1
  integer :: i, npts, num_steps, mini
    lower_bound = real(emin)
    upper_bound = real(emax)
    zero = real(reset_zero)
    range = upper_bound - lower_bound
    num_steps = 10
    do i = 1, nsteps
      if (range*2.5 > steps(i)) then
        step = steps(i)/num_steps
        marker = nint(lower_bound/step)*step - step
        exit
      end if
    end do
    range = real(erange)
    marker = nint(lower_bound/step)*step 
    bottom = 1.95 - (marker - lower_bound + zero)/range
    marker = marker - step
    do i = 0, 20
      marker = marker + step
      if (marker > upper_bound) exit
      num = char(ichar("2") + int(log10(max(abs(marker), 1.0))))
      write(line,'(i'//num//')') nint(marker)
      mini = int(max(log10(abs(marker) + 0.1), 0.0))
      y = 1.95 - (marker - lower_bound + zero)/range
      call graphics (-0.06 - mini*0.03, y - 0.04, 96) ! Write scale
      call graphics (-0.01, y, 2) ! Write tic
      call graphics (-0.00, y, 3) ! Write tic
    end do
  return
  end subroutine write_scale

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine local_for_MOZYME (type)
    use molkst_C, only: norbs, numat, nelecs
    use MOZYME_C, only : cocc_dim, icocc_dim, &
       & cvir_dim, icvir_dim, cocc, icocc, ncf, ncocc, iorbs, nncf, &
       & cvir, icvir, nce, ncvir, nnce
    use chanel_C, only: iw
    implicit none
    character (len=*), intent (in) :: type
    integer :: i, nocc, nvir, alloc_stat
    double precision :: totij, sum
    double precision, dimension(:), allocatable :: psi1, psi2, axiiii
    integer, dimension(:), allocatable :: nf, nl
    integer, dimension(:,:), allocatable :: ioc
    allocate (psi1(norbs), psi2(norbs), axiiii(norbs), nf(numat), &
         & nl(numat), ioc(2,numat), stat=alloc_stat)
    if (alloc_stat /= 0) then
      call memory_error ("localz")
      goto 1100
    end if
    if (type == "OCCUPIED") then
      nocc = nelecs / 2
      !
      do i = 1, 100
        call localize_for_MOZYME (cocc, cocc_dim, icocc, icocc_dim, ncf, ncocc, &
             & nocc, iorbs, psi1, psi2, axiiii, nf, nl, ioc, nncf, totij, sum)
   !     write (iw, "(10x,'NUMBER OF ITERATIONS =',i4,/,10x,'LOCALIZATION VALUE =',f14.9)") i, sum
        if (totij < 1.d-5) exit
      end do
      write (iw, "(10x,'NUMBER OF ITERATIONS =',i4,/,10x,'LOCALIZATION VALUE =',f14.9,/)") i, sum
!
      call MOZYME_eigs(nocc)
!
    else if (type == "VIRTUAL") then
      nvir = norbs - nelecs / 2
      !
      do i = 1, 100
        call localize_for_MOZYME (cvir, cvir_dim, icvir, icvir_dim, nce, ncvir, &
             & nvir, iorbs, psi1, psi2, axiiii, nf, nl, ioc, &
             & nnce, totij, sum)
        if (totij < 1.d-5) exit
      end do
    else
      write (iw,*) " Error"
      call mopend ("Error in LOCAL")
    end if
    deallocate (psi1, psi2, axiiii, nf, nl, ioc)
1100 continue
end subroutine local_for_MOZYME
subroutine localize_for_MOZYME (c, n289, ic, n267, nc, ncstrt, nmos_loc, iorbs, psi1, &
     & psi2, axiiii, nf, nl, ioc, nnc_loc, totij, total)
    use molkst_C, only: numat, norbs, natoms
    implicit none
    integer, intent (in) :: n267, n289, nmos_loc
    double precision, intent (out) :: totij, total
    integer, dimension (n267), intent (in) :: ic
    integer, dimension (nmos_loc), intent (in) :: nc, ncstrt, nnc_loc
    integer, dimension (numat), intent (inout) :: nf, nl
    integer, dimension (numat), intent (in) :: iorbs
    integer, dimension (2, numat), intent (inout) :: ioc
    double precision, dimension (n289), intent (inout) :: c
    double precision, dimension (nmos_loc), intent (inout) :: axiiii
    double precision, dimension (norbs), intent (inout) :: psi1, psi2
    integer :: i, i1, i5, i8, ii, ij, ijorb, il, il1, iloop, j, j1, j5, j8, &
   & jl, jl1, jloop, k, k1, l, m
    double precision :: aij, bij, ca, dii, dij, djj, sa, xiiii, xiijj, &
   & xijij, xijjj, xjiii, xjjjj
   !
   !**********************************************************************
   !
   !   LOCALISATION SUBROUTINE
   ! ON INPUT
   !        C      = EIGENVECTORS IN AN MDIM*MDIM MATRIX
   !        NCSTRT = STARTING ADDRESS FOR ATOMIC ORBITALS IN LMO'S
   !        NMOS = NUMBER OF LMO'S TO BE USED
   !        NNC    = STARTING ADDRESS OF ATOMS IN LMO'S
   !        NLAST   = INTEGER ARRAY OF ATOM ORBITAL COUNTERS
   !        NFIRST   = INTEGER ARRAY OF ATOM ORBITAL COUNTERS
   !
   !       SUBROUTINE MAXIMIZES (PSI)**4
   !
   !**********************************************************************
   !  DUMMY STATEMENT TO USE COMMON BLOCK
    i = natoms
   !
   !   Build all the DII
   !
    l = 0
    xiiii = 0.d0
    do k = 1, nmos_loc
      l = nnc_loc(k)
      m = ncstrt(k)
      axiiii(k) = 0.d0
      do i = 1, nc(k)
        l = l + 1
        i1 = ic(l)
        dii = 0.d0
        do j = 1, iorbs(i1)
          m = m + 1
          dii = dii + c(m) ** 2
        end do
        axiiii(k) = axiiii(k) + dii * dii
      end do
    end do
    total = 0.d0
    totij = 0.d0
    do iloop = 1, nmos_loc
      i5 = ncstrt(iloop)
      i8 = nnc_loc(iloop)
      do jloop = 1, nmos_loc
        j8 = nnc_loc(jloop)
        j5 = ncstrt(jloop)
        if (jloop /= iloop) then
          do i = 1, 2
            do j = 1, 2
              if (ic(i+i8) == ic(j+j8)) go to 1000
            end do
          end do
          cycle
1000      ij = 0
          ijorb = 0
          il = 0
          do i = 1, nc(iloop)
            i1 = ic(i+i8)
            jl = 0
            do j = 1, nc(jloop)
              j1 = ic(j+j8)
              if (i1 == j1) then
                ij = ij + 1
                nf(ij) = ijorb + 1
                nl(ij) = ijorb + iorbs(i1)
                ioc(1, ij) = il
                ioc(2, ij) = jl
                jl1 = jl
                il1 = il
                do k = 1, iorbs(i1)
                  ijorb = ijorb + 1
                  il1 = il1 + 1
                  jl1 = jl1 + 1
                  psi1(ijorb) = c(il1+i5)
                  psi2(ijorb) = c(jl1+j5)
                end do
              end if
              jl = jl + iorbs(j1)
            end do
            il = il + iorbs(i1)
          end do
          xijjj = 0.d0
          xjiii = 0.d0
          xijij = 0.d0
          xiijj = 0.d0
          do k1 = 1, ij
            dij = 0.d0
            dii = 0.d0
            djj = 0.d0
            do k = nf(k1), nl(k1)
              dij = dij + psi1(k) * psi2(k)
              dii = dii + psi1(k) * psi1(k)
              djj = djj + psi2(k) * psi2(k)
            end do
            xijjj = xijjj + dij * djj
            xjiii = xjiii + dij * dii
            xijij = xijij + dij * dij
            xiijj = xiijj + dii * djj
          end do
          if (xiijj >= 0.001d0) then
            xiiii = axiiii(iloop)
            xjjjj = axiiii(jloop)
            aij = xijij - (xiiii+xjjjj-2.0d0*xiijj) / 4.0d0
            bij = xjiii - xijjj
            ca = Sqrt (aij*aij+bij*bij)
            sa = aij + ca
            if (sa > 1.d-14) then
              ca = (1.0d0+Sqrt((1.0d0-aij/ca)/2.0d0)) / 2.0d0
              sa = Sqrt (1.0d0-ca)
              ca = Sqrt (ca)
              totij = totij + sa
              ii = 0
              do k = 1, ij
                il = 0
                do i = nf(k), nl(k)
                  il = il + 1
                  ii = ii + 1
                  c(ioc(1, k)+il+i5) = ca * psi1(ii) + sa * psi2(ii)
                  c(ioc(2, k)+il+j5) = -sa * psi1(ii) + ca * psi2(ii)
                end do
              end do
            end if
          end if
        end if
      end do
      total = total + xiiii
    end do
    return
end subroutine localize_for_MOZYME

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine deri21(a, nvar_nvo, minear, ifirst, vnert, pnert, b, ncut)
      implicit none
      integer  :: nvar_nvo
      integer  :: minear
      integer , intent(in) :: ifirst
      integer  :: ncut
      double precision  :: a(minear,nvar_nvo)
      double precision  :: vnert(nvar_nvo)
      double precision  :: pnert(nvar_nvo)
      double precision  :: b(minear,nvar_nvo)
!
      integer :: i, l
      double precision, dimension(4) :: work
      double precision :: cutoff, sum2, sum
!***********************************************************************
!
!     LEAST-SQUARE ANALYSIS OF A SET OF ANALYTICAL POINTS {A} :
!
!     PRODUCE A SUBSET OF NCUT ORTHONORMALIZED VECTORS B, OPTIMUM IN A
!     LEAST-SQUARE SENSE WITH RESPECT TO THE INITIAL SPACE {A}.
!     EACH NEW HIERARCHIZED VECTOR B EXTRACTS A MAXIMUM PERCENTAGE FROM
!     THE REMAINING DISPERSION OF THE SET {A} OUT OF THE PREVIOUS
!     {B} SUBSPACE.
!   INPUT
!     A(MINEAR,nvar_nvo): ORIGINAL SET {A}.
!     ifirst        : MAXIMUM ALLOWED SIZE OF THE BASIS B.
!   OUTPUT
!     VNERT(nvar_nvo)   : LOWEST EIGENVECTOR OF A'* A.
!     PNERT(nvar_nvo)     : SQUARE ROOT OF THE ASSOCIATED EIGENVALUES
!                     IN DECREASING ORDER.
!     B(MINEAR,NCUT): OPTIMUM ORTHONORMALIZED SUBSET {B}.
!
!***********************************************************************
!
!     VNERT = A' * A
      cutoff = 0.85D0
      sum2 = 0.D0
      call mtxmc (a, nvar_nvo, a, minear, work)
      work(:(nvar_nvo*(nvar_nvo + 1))/2) = -work(:(nvar_nvo*(nvar_nvo + 1))/2)
!     DIAGONALIZE IN DECREASING ORDER OF EIGENVALUES
      if (abs(work(1))<1.D-28 .and. nvar_nvo==1) then
        pnert(1) = sqrt((-work(1)))
        work(1) = 1.D15
        vnert(1) = 1.D0
        ncut = 1
        go to 50
      else
        call rsp (work, nvar_nvo, pnert, vnert)
!     FIND NCUT ACCORDING TO CUTOFF, BUILD WORK = VNERT * (PNERT)**-0.5
        sum = 0.D0
        do i = 1, nvar_nvo
          sum = sum - pnert(i)
        end do
        l = 1
        do i = 1, ifirst
          sum2 = sum2 - pnert(i)/sum
          pnert(i) = sqrt(Abs(pnert(i)))
          if (nvar_nvo > 0) then
            work(l:nvar_nvo-1+l) = vnert(l:nvar_nvo-1+l)/pnert(i)
            l = nvar_nvo + l
          end if
          if (sum2 < cutoff) cycle
          ncut = i
          go to 50
        end do
        ncut = ifirst
!     ORTHONORMALIZED BASIS
!     B(MINEAR,NCUT) = A(MINEAR,nvar_nvo)*WORK(nvar_nvo,NCUT)
      end if
   50 continue
      call mxm (a, minear, work, nvar_nvo, b, ncut)
      return
      end subroutine deri21

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine empire (formla, nat, els)
    use molkst_C, only : numat, keywrd, natoms
    use common_arrays_C, only : labels
    implicit none
    character (len=40), intent (out) :: formla
    integer, dimension (numat), intent (in) :: nat
    character (len=8), intent (out) :: els
    logical :: first = .true.
    integer :: i, j
    integer :: maxele
    integer :: l, nc, ne, mers(3), k, nele(109), m, nelements
    character (len=2), dimension (107) :: elemnt, lowel
    character (len=3), dimension (14) :: presnt
    character :: num
    integer, dimension (10) :: ntype
    integer, dimension (107) :: nmap, nos, nosort, numz
    double precision, external :: reada
    save :: first, nmap,nos, nosort, numz, elemnt, lowel, presnt, maxele
!
!.. Data Declarations ..
!
!  Sequence taken from the CRC Handbook page B-30
!
    data lowel /       &
 & "Cs","Rb","K ","Na","Li", & !  Group I
 & "Ba","Sr","Ca","Mg","Be", & !  Group IIA
 & "La","Ce","Pr","Nd","Pm","Sm","Eu","Gd","Tb","Dy","Ho","Tm","Yb","Lu", &
 &      "Y ","Sc",           & !  Group IIIB
 & "Hf","Zr","Ti",           & !  Group IVB
 & "Ta","Nb","V ",           & !  Group VB
 & "W ","Mo","Cr",           & !  Group VIB
 & "Re","Tc","Mn",           & !  Group VIIB
 & "Pt","Ir","Os",           & !  This is the sequence in CRC B-30
 & "Pd","Rh","Ru","Ni","Co","Fe","Au",      &
 & "Ag","Cu","Hg","Cd","Zn","Tl","In","Ga","Al","Pb","Sn","Ge","Bi", &
 & "B ","Si","C ","Sb","As","P ","N ","H ","Te","Se","S ","I ","Br", &
 & "Cl","O ","F ","He","Ne","Ar","Kr","Xe",25*"XX"/

    data elemnt / "H ", "He", "Li", "Be", "B ", "C ", "N ", "O ", "F ", "Ne", &
   & "Na", "Mg", "Al", "Si", "P ", "S ", "Cl", "Ar", "K ", "Ca", "Sc", "Ti", "&
   &V ", "Cr", "Mn", "Fe", "Co", "Ni", "Cu", "Zn", "Ga", "Ge", "As", "Se", "Br&
   &", "Kr", "Rb", "Sr", "Y ", "Zr", "Nb", "Mo", "Tc", "Ru", "Rh", "Pd", "Ag", &
   & "Cd", "In", "Sn", "Sb", "Te", "I ", "Xe", "Cs", "Ba", "La", "Ce", "Pr", "&
   &Nd", "Pm", "Sm", "Eu", "Gd", "Tb", "Dy", "Ho", "Er", "Tm", "Yb", "Lu", "Hf&
   &", "Ta", "W ", "Re", "Os", "Ir", "Pt", "Au", "Hg", "Tl", "Pb", "Bi", "Po", &
   & "At", "Rn", "Fr", "Ra", "Ac", "Th", "Pa", "U ", "Np", "Pu", "Am", "Cm", "&
   &Bk", "Cf", "XX", "Fm", "Md", "Cb", "++", " +", "--", " -", "Tv" /
  !
  ! ... Executable Statements ...
  !
    if (first) then
      first = .false.
    !
    !  CONSTRUCT THE MAP TO DETERMINE THE ORDER IN WHICH THE ELEMENTS WILL
    !  BE PRINTED IN THE EMPIRIC FORMULA
    !
      do i = 1, 107
        if (lowel(i) =="XX") exit
        do j = 1, 107
          if (elemnt(j) == lowel(i)) go to 1000
        end do
        go to 1100
1000    nmap(i) = j
      end do
      maxele = i - 1
      go to 1200
1100  write (6,*) "   FAULT:", lowel (i), i
      stop
    end if
1200 els = " "
    do i = 1, maxele
      if (lowel(i) (2:2) == " ") then
        numz(i) = 1
      else
        numz(i) = 2
      end if
    end do
  !
  !  INITIALIZE ELEMENT ARRAYS
  !
    do i = 1, 107
      nos(i) = 0
    end do
  !
  !  READ FORMULA AND WORK OUT ELEMENTAL COMPOSITION
  !
    do i = 1, numat
      j = nat(i)
      nos(j) = nos(j) + 1
    end do
  !
  !   SEQUENCE ELEMENTS TO LOOK NICE
  !
    do i = 1, maxele
      nosort(i) = nos(nmap(i))
    end do
  !
  !  REDUCE IT TO AN EMPIRICAL FORMULA
  !
    nelements = 0
    do i = 1, maxele
      if (nosort(i) /= 0) then
        nelements = nelements + 1
        ntype(nelements) = i
        presnt(nelements) = lowel(i)
      end if
    end do
    j = Index (keywrd, " MERS")
    if (j /= 0) then
      mers = 0
      k = 0
      i = Index (keywrd(j + 1:), " ") + j
      do l = 1, 3
        j = j + k
        if (l > 1 .and. k == 0) exit
        mers(l) = Nint (reada (keywrd(j:), 1))
        k = Index (keywrd(j:i), ",")
      end do
      i = Index(keywrd, " Z=")
      if (i /= 0) then
        k = Nint(reada(keywrd,i))
        k = mers(1)*mers(2)*mers(3)*k
        if (Index (keywrd, " BCC") /= 0) k = k/2
      else
        nele = 0
        do i = 1, natoms - 3
          nele(labels(i)) = nele(labels(i)) + 1
        end do
        j = 0
        do i = 1, 98
          if (nele(i) > 0) then
            j = j + 1
            nele(j) = nele(i)
          end if
        end do
        k = 1000
        do i = 1, j
          if(nele(i) < k) k = nele(i)
        end do
  !
  !  k is the smallest number of atoms of any element in the formula
  !
        do i = 1, 100
          m = 0
          do l = 1, j
            if (Abs((i*nele(l))/k - (i*1.d0*nele(l))/k) > 1.d-5) m = 1
          end do
          if (m == 0) exit
        end do
        k = k/i
      end if
      nosort = nosort/max(k,1)
    end if
!
!   CONVERT IT TO A CHARACTER FORMULA
!
    formla = " "
    ne = 2
    nc = 2
    do i = 1, nelements
      formla(nc:) = presnt(i) (:numz(ntype(i)))
      nc = nc + numz(ntype(i))
      els(ne:) = presnt(i) (:numz(ntype(i)))
      ne = ne + numz(ntype(i))
      if (nosort(ntype(i)) /= 1) then
        if (nosort(ntype(i)) == 0) then
   !       write(*,'(a)')" Z definitely wrong in "//trim(title)
    !      write(31,'(a)')" Z definitely wrong in "//trim(title)
        else
          j = int(log10(nosort(ntype(i))*1.0)) + 1
          num = char(ichar("0") + j)
          write(formla(nc:),"(i"//num//")")nosort(ntype(i))
          nc = len_trim(formla) + 1
        end if
      end if
    end do
end subroutine empire

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine wrttxt(iprt)
      use molkst_C, only : koment, title, refkey, keywrd, line
      implicit none
      integer , intent(in) :: iprt
      integer :: i, j, k
      logical :: l_chains = .false., l_start = .false.
!-----------------------------------------------
!
! Is CHAINS or START_RES present in the data set?
!
      do i = 1, 6
        if (index(refkey(i), " NULL") /= 0) exit
        line = " "//trim(refkey(i))
        call upcase(line, len_trim(line))
        if (.not. l_chains) l_chains = (index(line, " CHAINS") /= 0)
        if (.not. l_start)  l_start  = (index(line, " START_RES") /= 0)
      end do
!
!  Is CHAINS present in the keyword?
!
      i = index(keywrd," CHAINS")
      if(i /= 0 .and. .not. l_chains) then
!
!  CHAINS is present in keyword, but was not present in the data-set,
!  so add CHAINS keyword to refkey(1)
!
        j = index(keywrd(i + 7:), ")") + i + 7
        refkey(1) = keywrd(i:j)//trim(refkey(1))
      end if
!
!  Is START_RES present in the keyword?
!
      i = index(keywrd," START_RES")
      if(i /= 0 .and. .not.l_start) then
!
!  START_RES is present in keyword, but was not present in the data-set,
!  so add START_RES keyword to refkey(1)
!
        j = index(keywrd(i + 10:), ")") + i + 10
        refkey(1) = keywrd(i:j)//trim(refkey(1))
      end if
      if (refkey(2) == " ") then
        i = index(refkey(1), " +")
        if (i /= 0) then
          refkey(1)(i:i + 1) = " "
          refkey(2) = " NULL"
        end if
      end if
      k = 0
      do i = 1, 6
        if (index(refkey(i), " NULL") /= 0) exit
        if (index(refkey(i), " +") == 0) k = k + 1
        write(iprt,'(a)', iostat = j)trim(refkey(i))
        if (j /= 0) then
          call mopend("ERROR DETECTED WHILE TRYING TO WRITE KEYWORDS TO A FILE")
          return
        end if
      end do
      if (index(koment, " NULL") == 0 .and. k < 3) write (iprt, '(A)') trim(koment)
      if (index(koment, " NULL") == 0 .and. k < 4) write (iprt, '(A)') trim(title)
      return
      end subroutine wrttxt

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  double precision function EH_plus(i, hblist, max_h_bonds, nrbondsa, nrbondsb)
!
!  Third-Generation Hydrogen-Bonding Corrections for Semiempirical QM Methods and Force Fields
!  Martin Korth, J. Chem. Theory Comput., 2010, 6 (12), pp 3808-3816
!
    use common_arrays_C, only : nat
    use molkst_C, only : method_PM7
    use funcon_C, only : eV, fpc_9, a0, pi
  !  use parameters_C, only : par8, par9
    implicit none
    integer, intent (in) :: max_h_bonds, i, hblist(max_h_bonds,10), nrbondsa(max_h_bonds), nrbondsb(max_h_bonds)
    double precision :: angle_cos, angle, torsion_check, & ! weight_956, &
      angle2_shift, angle2_shift_2, torsion_shift, angle2, torsion_check_bac, &
      angle2_cos, angle2_cos_2, torsion_correct, torsion_value, torsion_cos, torsion_value_2, &
      torsion_cos_2, angle2_cos_new, angle2_cos_2_new, torsion_cos_new, torsion_cos_2_new, &
      scale_a, scale_nsp3, scale_nsp2, scale_osp3, scale_osp2, scale_b, scale_c, &
      hb_dist, xc_dist, ha_dist, damping, hartree2kcal, XY_dist, short
    double precision :: shortcut = 2.4d0    !  2.4 Angstrom
    double precision :: longcut  = 7.0d0    !  7.0 Angstrom
    double precision :: covcut   = 1.2d0    !  1.2 Angstrom (hb mid point)
    logical :: torsion_check_set, torsion_check_set2
    double precision, external :: torsion, distance
    torsion_value = 0.d0
    torsion_shift = 0.d0
    angle2_shift = 0.d0
    angle2_shift_2 = 0.d0
    if (method_PM7) then
       scale_nsp3 = -0.171271D0*a0**2
       scale_osp3 = -0.098822D0*a0**2
       scale_nsp2 = -0.171271D0*a0**2
    else
       scale_nsp3 = -0.16d0*a0**2
       scale_osp3 = -0.12d0*a0**2
       scale_nsp2 = scale_nsp3
    end if
    scale_osp2 = scale_osp3
    hartree2kcal = eV*fpc_9
    EH_plus = 0.d0
    if (hblist(i, 10) /= -666) then
! first angle
      angle_cos = -cos(angle(hblist(i, 1), hblist(i, 9), hblist(i, 5)))   !  cos(pi-angle)
      if (angle_cos <= 0) return
! get target angles for hblist(i, 1)
! - no explicit lone pair representation to keep gradient simpler
! - no coordinate dependent target shifts for the same reason (except NR3)
      torsion_check = 0.d0
      torsion_check_set = .false.
      torsion_check_set2 = .false.
      if (nat(hblist(i, 1)) == 8) then ! sulphur?
        if (nrbondsa(i) == 1) then
!
!  >C=O - - H-X
!
          angle2_shift = pi
          angle2_shift_2 = pi/(180.d0/120.d0)
          torsion_shift = 0.d0
          torsion_check_set2 = .true.! H...O = C -R1
        else
!
! >O - - H-X
!
          angle2_shift = pi/(180.d0/109.48)
          angle2_shift_2 = angle2_shift
          torsion_shift = pi/(180.d0/54.74)
        end if
      else if (nat(hblist(i, 1)) == 7) then
        if (nrbondsa(i) == 2) then
!
! >N - - H-X
!
          angle2_shift = pi/(180.d0/120.d0)
          angle2_shift_2 = angle2_shift
          torsion_shift = 0.d0
        else
!
! >N- - - H-X   WHAT ABOUT Cyanide?
!
          angle2_shift = pi/(180.d0/109.48)
          angle2_shift_2 = angle2_shift
          torsion_shift = pi/(180.d0/54.74)
          torsion_check_set = .true.! NR3 group
        end if
      end if
!
! extrapolation between tetragonal and planar NR3 group
!
      if (torsion_check_set) then
        torsion_check = torsion(hblist(i, 3), hblist(i, 2), hblist(i, 1), hblist(i, 4))   !  torsion2
        if (torsion_check <= -pi) torsion_check = torsion_check  +  2.d0 * pi
        if (torsion_check > pi) torsion_check = torsion_check - 2.d0 * pi
        if (torsion_check < 0) then
          torsion_check = -pi -torsion_check
        else
          torsion_check = pi -torsion_check
        end if
        torsion_check_bac = torsion_check ! save sign
        if (torsion_check < 0) torsion_check = -1.d0 * torsion_check
        torsion_check = torsion_check*180.d0/pi
        torsion_shift = torsion_shift + pi/(180.d0/((54.74d0 - torsion_check)/54.74d0*35.26d0))
        angle2_shift = angle2_shift - pi/(180.d0/((54.74d0 - torsion_check)/54.74d0*19.48d0))
        angle2_shift_2 = angle2_shift
        torsion_check = torsion_check_bac ! restore sign
      end if
! second angle
      angle2 = angle(hblist(i, 2), hblist(i, 1), hblist(i, 9))  !angle2
      angle2_cos = cos(angle2_shift - angle2)
      angle2_cos_2 = cos(angle2_shift_2 - angle2)
      if (angle2_cos_2 > angle2_cos) angle2_cos = angle2_cos_2
      if (angle2_cos <= 0.d0) return
! torsion angle
      torsion_correct = torsion(hblist(i, 3), hblist(i, 2), hblist(i, 1), hblist(i, 9))   !  torsion1
      if (torsion_correct <= -pi) torsion_correct = torsion_correct + 2.d0 * pi
      if (torsion_correct  >  pi) torsion_correct = torsion_correct - 2.d0 * pi
      if ((.not.torsion_check_set2) .or. (abs(torsion_correct*180.d0/pi) > 90.d0)) then
        if (torsion_correct < 0.d0) then
          torsion_correct = -pi - torsion_correct
        else
          torsion_correct =  pi - torsion_correct
        end if
      end if
!
! correction of NR3 torsion angle for through-bond case
!
      if (torsion_check < 0) then ! negative torsion angle occupied by -NR3 r3
        torsion_value = torsion_shift - torsion_correct
        if (torsion_value <= -pi) torsion_value = torsion_value + 2.d0 * pi
        if (torsion_value  >  pi) torsion_value = torsion_value - 2.d0 * pi
        torsion_cos = cos(torsion_value)
      else if (torsion_check > 0) then ! positive torsion angle occupied by -NR3 r3
        torsion_value = -torsion_shift - torsion_correct
        if (torsion_value <= -pi) torsion_value = torsion_value + 2.d0 * pi
        if (torsion_value  >  pi) torsion_value = torsion_value - 2.d0 * pi
        torsion_cos = cos(torsion_value)
      else ! planar -NR3 or general case
        torsion_value = torsion_shift - torsion_correct
        torsion_value_2 = -torsion_shift - torsion_correct
        if (torsion_value   <= -pi) torsion_value   = torsion_value   + 2.d0 * pi
        if (torsion_value   >   pi) torsion_value   = torsion_value   - 2.d0 * pi
        if (torsion_value_2 <= -pi) torsion_value_2 = torsion_value_2 + 2.d0 * pi
        if (torsion_value_2 >   pi) torsion_value_2 = torsion_value_2 - 2.d0 * pi
        torsion_cos = cos(torsion_value)
        torsion_cos_2 = cos(torsion_value_2)
        if (torsion_cos_2 > torsion_cos) torsion_cos = torsion_cos_2
      end if
      if (distance(hblist(i, 9), hblist(i, 1)) > distance(hblist(i, 9), hblist(i, 2)) .and. torsion_check_set2) &
        torsion_cos = 0.d0
      if (hblist(i, 3) == hblist(i, 4) .or. hblist(i, 9) == hblist(i, 4)) torsion_cos = 1.d0
      if (torsion_cos < 0) return
!
! get target angles for hblist(i, 5) - see comment above
!
      torsion_check      = 0.d0
      torsion_check_set  = .false.
      torsion_check_set2 = .false.
      if (nat(hblist(i, 5)) == 8) then ! sulphur?
        if (nrbondsb(i) == 1) then
          angle2_shift = pi
          angle2_shift_2 = pi/(180.d0/120.d0)
          torsion_shift = 0.d0
          torsion_check_set2 = .true.! H...O = C -R1
        else
          angle2_shift = pi/(180.d0/109.48d0)
          angle2_shift_2 = angle2_shift
          torsion_shift = pi/(180.d0/54.74d0)
        end if
      else if (nat(hblist(i, 5)) == 7) then
        if (nrbondsb(i) == 2) then
          angle2_shift = pi/(180.d0/120.d0)
          angle2_shift_2 = angle2_shift
          torsion_shift = 0.d0
        else
          angle2_shift = pi/(180.d0/109.48d0)
          angle2_shift_2 = angle2_shift
          torsion_shift = pi/(180.d0/54.74d0)
          torsion_check_set = .true.! NR3 group
        end if
      end if
! extrapolation between tetragonal and planar NR3 group
      if (torsion_check_set) then
        torsion_check = torsion(hblist(i, 7), hblist(i, 6), hblist(i, 5), hblist(i, 8))  !torsion2_new
        if (torsion_check <= -pi) torsion_check = torsion_check + 2.d0 * pi
        if (torsion_check  >  pi) torsion_check = torsion_check - 2.d0 * pi
        if (torsion_check < 0) then
          torsion_check = -pi -torsion_check
        else
          torsion_check = pi -torsion_check
        end if
        torsion_check_bac = torsion_check ! save sign
        if (torsion_check < 0) torsion_check = -1.d0 * torsion_check
        torsion_check = torsion_check*180.d0/pi
        torsion_shift = torsion_shift + pi/(180.d0/((54.74d0 -torsion_check)/54.74d0*35.26d0))
        angle2_shift = angle2_shift -pi/(180.d0/((54.74d0 -torsion_check)/54.74d0*19.48d0))
        angle2_shift_2 = angle2_shift
        torsion_check = torsion_check_bac ! restore sign
      end if
! second angle
      angle2 = angle(hblist(i, 6), hblist(i, 5), hblist(i, 9))   ! angle2_new
!
!  Patch - as angle approaches 180 degrees, reduce the weight of this term.
!
!     weight_956 = 1.d0 - exp(-10.d0*(angle2 - pi)**2)
      angle2_cos_new = cos(angle2_shift -angle2)
      angle2_cos_2_new = cos(angle2_shift_2 -angle2)
      if (angle2_cos_2_new > angle2_cos_new) angle2_cos_new = angle2_cos_2_new
      if (angle2_cos_new <= 0.d0) return
! torsion angle
      torsion_correct = torsion(hblist(i, 7), hblist(i, 6), hblist(i, 5), hblist(i, 9))   ! torsion1_new
      if (torsion_correct <= -pi) torsion_correct = torsion_correct  +  2.d0 * pi
      if (torsion_correct > pi) torsion_correct = torsion_correct - 2.d0 * pi
      if ((.not.torsion_check_set2) .or. (abs(torsion_correct*180.d0/pi) > 90.d0)) then
        if (torsion_correct < 0.d0) then
          torsion_correct = -pi -torsion_correct
        else
          torsion_correct = pi - torsion_correct
        end if
      end if
! correction of NR3 torsion angle for through-bond case
      if (torsion_check < 0.d0) then ! negative torsion angle occupied by -NR3 r3
        torsion_value = torsion_shift - torsion_correct
        if (torsion_value <= -pi) torsion_value = torsion_value + 2.d0 * pi
        if (torsion_value  >  pi) torsion_value = torsion_value - 2.d0 * pi
        torsion_cos_new = cos(torsion_value)
      else if (torsion_check > 0) then ! positive torsion angle occupied by -NR3 r3
        torsion_value = -torsion_shift - torsion_correct
        if (torsion_value <= -pi) torsion_value = torsion_value + 2.d0 * pi
        if (torsion_value  >  pi) torsion_value = torsion_value - 2.d0 * pi
        torsion_cos_new = cos(torsion_value)
      else ! planar -NR3 or general case
        torsion_value   =  torsion_shift - torsion_correct
        torsion_value_2 = -torsion_shift - torsion_correct
        if (torsion_value   <= -pi) torsion_value   = torsion_value   + 2.d0 * pi
        if (torsion_value    >  pi) torsion_value   = torsion_value   - 2.d0 * pi
        if (torsion_value_2 <= -pi) torsion_value_2 = torsion_value_2 + 2.d0 * pi
        if (torsion_value_2  >  pi) torsion_value_2 = torsion_value_2 - 2.d0 * pi
        torsion_cos_new   = cos(torsion_value)
        torsion_cos_2_new = cos(torsion_value_2)
        if (torsion_cos_2_new > torsion_cos_new)torsion_cos_new = torsion_cos_2_new
      end if
      if (distance(hblist(i, 9), hblist(i, 5)) > distance(hblist(i, 9), hblist(i, 6)) .and. torsion_check_set2) &
        torsion_cos_new = 0.d0
      if (hblist(i, 7) == hblist(i, 8) .or. hblist(i, 9) == hblist(i, 8)) torsion_cos_new = 1.d0
   !   if (torsion_cos_new < 0.d0) return
      torsion_cos_new=abs(torsion_cos_new)
! parameters
      if (nat(hblist(i, 1)) == 7) then ! nitrogen
        if (nrbondsa(i) >= 3) then
          scale_a = scale_nsp3
        else
          scale_a = scale_nsp2
        end if
      else ! oxygen
        if (nrbondsa(i) >= 2) then
          scale_a = scale_osp3
        else
          scale_a = scale_osp2
        end if
      end if ! sulphur?
      if (nat(hblist(i, 5)) == 7) then ! nitrogen
        if (nrbondsb(i) >= 3) then
          scale_b = scale_nsp3
        else
          scale_b = scale_nsp2
        end if
      else ! oxygen
        if (nrbondsb(i) >= 2) then
          scale_b = scale_osp3
        else
          scale_b = scale_osp2
        end if
      end if ! sulphur?
      scale_c = (scale_a + scale_b)/2.d0
!
! damping 1.d0/(1.d0 + exp( -60.d0*(x/2.65d0 - 1.d0)))
!
      ha_dist = distance(hblist(i, 9), hblist(i, 1))
      hb_dist = distance(hblist(i, 9), hblist(i, 5))
      xc_dist = min(ha_dist, hb_dist)

! energies
      if (method_PM7) then
        XY_dist = max(ha_dist, hb_dist) - xc_dist
        if (XY_dist > 0.5d0) then
!
! Make damping a function of the shorter X - H distance.
! Distances greater than covcut = 1.2 Angstroms reduce damping
! distances less than covcut are not affected
!
          damping = 1.d0 - 1.d0/(1.d0 + exp( -60.d0*(xc_dist/covcut - 1.0d0)))
        else
!
! In very strong X - H - Y systems the X - Y distance is small, so an increased
! X - H minimum distance is expected, therefore do not dampen the function.
!
          damping = 1.d0
        end if
! y-x damping
        xc_dist = distance(hblist(i, 1), hblist(i, 5))

!
! Make damping a function of the O - O distance
! Damping is decreased as the O - O distances approaches shortcut Angstroms
!
        damping = damping/(1.d0 + exp( -100.d0*(xc_dist/shortcut - 1.d0)))
!
! At very large O - O distances, make damping go to zero
!
        damping = damping*(1.d0 - 1.d0/(1.d0 + exp( -10.d0*(xc_dist/longcut - 1.d0))))
        XY_dist = distance(hblist(i, 1), hblist(i, 5))
!
!   angle_cos       = cos(angle between donor-hydrogen-acceptor)
!   angle2_cos      = cos(difference between optimum DA-D-H and actual DA-D-H angle)
!   torsion_cos     =
!   angle2_cos_new  = cos(difference between optimum AA-A-H and actual AA-A-H angle)
!   torsion_cos_new = cos(difference between optimum AA'-AA-A-H and actual AA'-AA-A-H torsion angle)
!
        EH_plus = scale_c/XY_dist**2.d0*angle_cos**2* &
          (1.d0 - (1.d0 - angle2_cos*torsion_cos*angle2_cos_new*torsion_cos_new)**2)*hartree2kcal*damping
  !      (1.d0 - (1.d0 - weight_956*angle2_cos*torsion_cos*angle2_cos_new*torsion_cos_new)**2)*hartree2kcal*damping
        if (nat(hblist(i, 1)) == 8 .and. nat(hblist(i, 5)) == 8) then
!
!  Add in extra stabilization as the O - O distance approaches 2.41 Angstroms.
!  As a guide, formic acid dimer has O - O: 2.67 Angstroms, stabilization should total 18.61 kcal/mol
!              the H5O2(+) ion has O - O: 2.38 - 2.43 Angstroms
!
          short = -2.5d0*exp(-80.d0*(max(XY_dist - 2.67d0, 0.d0))**2)*angle_cos**4
          EH_plus = EH_plus + short
        end if
      else
! y-h damping
      damping = 1.d0 - 1.d0/(1.d0 + exp( -60.d0*(xc_dist/covcut - 1.d0)))
! y-x damping
      xc_dist = distance(hblist(i, 1), hblist(i, 5))

! short range
      damping = damping/(1.d0 + exp( -100.d0*(xc_dist/shortcut - 1.d0)))
! long range
      damping = damping*(1.d0 - 1.d0/(1.d0 + exp( -10.d0*(xc_dist/longcut - 1.d0))))
        EH_plus = scale_c/distance(hblist(i, 1), hblist(i, 5))**2.d0* &
        angle_cos**2*angle2_cos**2*torsion_cos**2*angle2_cos_new**2*torsion_cos_new**2*hartree2kcal*damping
      end if
    end if
    return
  end function EH_plus

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

double precision function PM6_DH_Dispersion(l_grad)
  use molkst_C, only : numat, E_disp
  use common_arrays_C, only: coord, dxyz
  implicit none
  logical, intent (in) :: l_grad
  double precision, external :: PM6_DH_Disp
!
!  Local
!
  double precision :: sum, sum1, sum2, delta = 1.d-5
  integer :: i, k
  E_disp = PM6_DH_Disp(0, numat)
  PM6_DH_Dispersion = E_disp
  if (l_grad) then
!
!   Dispersion contribution is small, so only calculate the CUC.
!
    do k = 1, numat
      sum2 = PM6_DH_Disp(k, 1)
      do i = 1, 3
        coord(i,k) = coord(i,k) + delta
        sum = PM6_DH_Disp(k, 1)
        sum1 = (sum2 - sum)/delta
        if (Abs(sum1) < 50.d0) then
          dxyz((k - 1)*3 + i) = dxyz((k - 1)*3 + i) - sum1
        end if
        coord(i,k) = coord(i,k) - delta
      end do
    end do
  end if
  return
end function PM6_DH_Dispersion

double precision function PM6_DH_Disp(set_a, nsa)
!
!  Based on materials provided by Jan Rezak, as described in:
!
!  "A Transferable H-bonding Correction For Semiempirical Quantum-Chemical Methods"
!  Martin Korth, Michal Pitonak, Jan Rezac and Pavel Hobza,
!
!  J Chem Theory and Computation 6:344-352 (2010)
!
  use common_arrays_C, only: nat, nbonds, tvec, coord
  use molkst_C, only : Rij => Rab, method_PM7, numcal, line, id, l11, l21, l31, numat
  use chanel_C, only : iw
  use elemts_C, only : atom_names
  implicit none
  integer :: nsa
  integer :: set_a
  logical :: first_1 = .true., l_eles(110), first_2 = .true.
  double precision :: alpha = 20.d0, s = 1.04d0, cscale = 0.89d0, C6i, C6j, V_ab(3)
  integer :: ii, i, j, ni, nj, j_start, icalcn = 0, i1, j1, k1
  double precision :: C(86),R(86),N(86)
  double precision :: C6, R0, E_disp_tmp, damp, disp_limit = 6.5d0, sum, E_disp
  logical, external :: connected
  save :: icalcn, first_1, first_2

! C6 parameters (J.nm^6/mol)
  data C/ &
    0.16D0, 0.084D0,0.00D0, 0.00D0, 5.79D0, 1.65D0, 1.11D0, 0.70D0,   &  !  H He Li Be  B  C  N  O
    0.57D0, 0.45D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 3.25D0, 5.79D0,   &  !  F Ne Na Mg Al Si  P  S
    5.97D0, 3.71D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0,   &  ! Cl Ar  K Ca Sc Ti  V Cr
    0.00D0, 0.00D0, 0.04D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0,   &  ! Mn Fe Co Ni Cu Zn Ga Ge
    0.00D0, 0.00D0,11.60D0, 4.47D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0,   &  ! As Se Br Kr Rb Sr  Y Zr
    0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0,   &  ! Nb Mo Tc Ru Rh Pd Ag Cd
    0.00D0, 0.00D0, 0.00D0, 0.00D0,25.80D0,16.50D0, 0.00D0, 0.00D0,   &  ! In Sn Sb Te  I Xe Cs Ba
    0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0,   &  ! La Ce Pr Nd Pm Sm Eu Gd
    0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0,   &  ! Tb Dy Ho Er Tm Yb Lu Hf
    0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0,   &  ! Ta  W Re Os Ir Pt Au Hg
    0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0/                      ! Tl Pb Bi Po At Rn

! R0 parameters (pm)
  data R/ &
    156.d0,  140.d0,  000.d0,  000.d0,  180.d0,  170.d0,  155.d0,  152.d0,   &  !  H He Li Be  B  C  N  O
    147.d0,  154.d0,  000.d0,  000.d0,  000.d0,  000.d0,  180.d0,  180.d0,   &  !  F Ne Na Mg Al Si  P  S
    175.d0,  188.d0,  000.d0,  000.d0,  000.d0,  000.d0,  000.d0,  000.d0,   &  ! Cl Ar  K Ca Sc Ti  V Cr
    000.d0,  000.d0,  140.d0,  000.d0,  000.d0,  000.d0,  000.d0,  000.d0,   &  ! Mn Fe Co Ni Cu Zn Ga Ge
    000.d0,  000.d0,  185.d0,  202.d0,  000.d0,  000.d0,  000.d0,  000.d0,   &  ! As Se Br Kr Rb Sr  Y Zr
    000.d0,  000.d0,  000.d0,  000.d0,  000.d0,  000.d0,  000.d0,  000.d0,   &  ! Nb Mo Tc Ru Rh Pd Ag Cd
    000.d0,  000.d0,  000.d0,  000.d0,  198.d0,  216.d0,  000.d0,  000.d0,   &  ! In Sn Sb Te  I Xe Cs Ba
    000.d0,  000.d0,  000.d0,  000.d0,  000.d0,  000.d0,  000.d0,  000.d0,   &  ! La Ce Pr Nd Pm Sm Eu Gd
    000.d0,  000.d0,  000.d0,  000.d0,  000.d0,  000.d0,  000.d0,  000.d0,   &  ! Tb Dy Ho Er Tm Yb Lu Hf
    000.d0,  000.d0,  000.d0,  000.d0,  000.d0,  000.d0,  000.d0,  000.d0,   &  ! Ta  W Re Os Ir Pt Au Hg
    000.d0,  000.d0,  000.d0,  000.d0,  000.d0,  000.d0/                        ! Tl Pb Bi Po At Rn

! Neff (electrons) - Slater-Kirkwood effective number of electrons
  data N/ &
    0.80D0, 1.42D0, 0.00D0, 0.00D0, 2.16D0, 2.50D0, 2.82D0, 3.15D0,   &  !  H He Li Be  B  C  N  O
    3.48D0, 3.81D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 4.50D0, 4.80D0,   &  !  F Ne Na Mg Al Si  P  S
    5.10D0, 5.40D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0,   &  ! Cl Ar  K Ca Sc Ti  V Cr
    0.00D0, 0.00D0, 2.90D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0,   &  ! Mn Fe Co Ni Cu Zn Ga Ge
    0.00D0, 0.00D0, 6.00D0, 6.30D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0,   &  ! As Se Br Kr Rb Sr  Y Zr
    0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0,   &  ! Nb Mo Tc Ru Rh Pd Ag Cd
    0.00D0, 0.00D0, 0.00D0, 0.00D0, 6.95D0, 7.25D0, 0.00D0, 0.00D0,   &  ! In Sn Sb Te  I Xe Cs Ba
    0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0,   &  ! La Ce Pr Nd Pm Sm Eu Gd
    0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0,   &  ! Tb Dy Ho Er Tm Yb Lu Hf
    0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0,   &  ! Ta  W Re Os Ir Pt Au Hg
    0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0, 0.00D0/                      ! Tl Pb Bi Po At Rn
!
! dispersion energy
!
  E_disp = 0.d0
  if (method_PM7) then
    alpha  = 15.450118D0
    s      = 1.226593D0
    cscale = 2.286419D0
  else
    alpha  = 20.d0
    s      = 1.04d0
    cscale = 0.89d0
  end if
  l_eles = .true.
  do ii = 1, nsa
    if (nsa == numat) then
      i = ii
    else
      i = set_a
    end if
    ni = nat(i)
    if (ni > 86) cycle
    if (R(ni) == 0.d0 .or. C(ni) == 0.d0 .or. N(ni) == 0.d0) then
      if (method_PM7) cycle
      if (icalcn /= numcal .and. l_eles(ni)) then
        l_eles(ni) = .false.
        line = atom_names(ni)
        do
          if (line(1:1) /= " ") exit
          line(1:) = line(2:)
        end do
        if (first_1) write(iw,'(///,6(a,/))') "          *********************************************", &
                                            "          *                                           *", &
                                            "          *                 WARNING                   *", &
                                            "          *                                           *", &
                                            "          *********************************************"
        if (first_2) write(iw,'(10x,a)') "Dispersion parameters missing for "//trim(line)
      end if
      first_1 = .false.
      cycle
    end if
    if (nsa == numat) then
      j_start = ii + 1
    else
      j_start = 1
    end if
    do j  = j_start, numat
      if (i == j) cycle
      nj = nat(j)
      if (nj > 86) cycle
      if (ni == 6) then
        if (nbonds(i) == 4) then
          C6i = 0.95d0
        else
          C6i = 1.65d0
        end if
      else
        C6i = C(ni)
      end if
      if (nj == 6) then
        if (nbonds(j) == 4) then
          C6j = 0.95d0
        else
          C6j = 1.65d0
        end if
      else
        C6j = C(nj)
      end if
      if (R(nj).eq.0.0.or.C(nj).eq.0.0 .or. N(nj).eq.0.0) cycle
      C6 = 2.d0*(C6i**2*C6j**2*N(ni)*N(nj))**(1.d0/3.d0)/((C6i*N(nj)**2)**(1.d0/3.d0) + &
        (C6j*N(ni)**2)**(1.d0/3.d0))
      R0 = (R(ni)**3+R(nj)**3)/(R(ni)**2+R(nj)**2) /1000.d0*2.d0    ! pm to nm
      if (connected(i, j, 100.d0**2)) then
        if (id == 0) then
! atomic distance Rij, in nm
! i-j dispersion energy
          Rij = Rij*0.1d0
          damp = 1.d0 / (1.d0 + exp(-alpha * (Rij/(s*R0) - 1.d0)))
          E_disp_tmp = C6/Rij**6*damp/(1000.d0*4.184d0)
          E_disp = E_disp - E_disp_tmp
        else
          sum = 0.d0
          do i1 = -l11, l11
            do j1 = -l21, l21
              do k1 = -l31, l31
                V_ab = coord(:,i) - coord(:,j) + tvec(:,1)*i1 + tvec(:,2)*j1 + tvec(:,3)*k1
                Rij = sqrt(V_ab(1)**2 + V_ab(2)**2 + V_ab(3)**2)*0.1d0
                if (Rij*10.d0 < disp_limit) then
                  damp = 1.d0 / (1.d0 + exp(-alpha * (Rij/(s*R0) - 1.d0)))
!
!  The damping function *(1.d0 - exp(-(Rij*10.d0 - disp_limit)**2)) is used in solids because the number
!  of atoms increases as Rij**2.  This makes long-range interactions (6 Angstroms to infinity) more important.
!  In molecules, there is no equivalent increase.
!

                  E_disp_tmp = C6/Rij**6*damp/(1000.d0*4.184d0)*(1.d0 - exp(-(Rij*10.d0 - disp_limit)**2))
                    sum = sum + E_disp_tmp
                end if
              end do
            end do
          end do
          E_disp = E_disp - sum
        end if
      end if
    end do
  end do
  if (first_2 .and. .not. first_1) &
  write(iw,'(/,6(a,/))')   "          *********************************************", &
                            "          *                                           *", &
                            "          *              END OF WARNING               *", &
                            "          *                                           *", &
                            "          *********************************************"
  first_2 = .false.
  icalcn = numcal
  PM6_DH_Disp = E_disp*cscale
  return
end function PM6_DH_Disp

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine iter(ee, fulscf, rand)
      use common_arrays_C, only : eigs, p, pa, pb, cb, h, &
       &  c, nat, nfirst, nlast, eigb, pdiag, f, w, wk, fb
      use iter_C, only : pold, pold2, pbold, pbold2, &
      & pold3, pbold3, vec_ai, vec_bi, fock_ai, fock_bi, p_ai, &
      p_bi, h_ai, h_bi, vecl_ai, vecl_bi
      USE parameters_C, only :
      USE funcon_C, only : fpc_9
      USE maps_C, ONLY: latom
      USE chanel_C, only : iw, ifiles_1
      USE molkst_C, ONLY: numat, norbs, nalpha, nbeta, uhf, &
    &    nclose, nopen, fract, numcal, mpack, iflepo, iscf, &
    &    enuclr, keywrd, gnorm, moperr, last, nscf, emin, &
         limscf, atheat, is_PARAM, id, line, lxfac, nalpha_open, &
         nbeta_open, npulay, method_indo
      USE reimers_C, only: dd, ff, tot, cc0, aa, dtmp, nb2
      use cosmo_C, only : useps
#ifdef GPU
      Use mod_vars_cuda, only: lgpu, real_cuda, prec
      use density_cuda_i
#endif
      implicit none
      double precision , intent(out) :: ee
      logical , intent(in) :: fulscf
      logical , intent(in) :: rand
      double precision :: selcon
      integer :: l, icalcn, itrmax, na2el, na1el, nb1el, ifill, &
        irrr, jalp, ialp, jbet, ibet, ihomo, ihomob, i, j, iemin, &
        iemax, iredy, niter, modea, modeb, nl1, nl2, nu1, nu2
      double precision, dimension(numat) :: q
      double precision, dimension(10) :: escf0
      double precision :: plb, scfcrt, pl, bshift, pltest, trans, w1, w2, random, &
        shift, shiftb = 0.d0, shfmax, ten, tenold, plchek, scorr, shfto, &
        shftbo, titer0, eold, diff, enrgy, titer, escf, &
        sellim, sum, summ, eold_alpha, eold_beta, theta(norbs), ofract, sum1, sum2
      logical :: debug, prtfok, prteig, prtden, prt1el, minprt, newdg, prtpl, &
        prtvec, camkin, ci, okpuly, oknewd, times, force, allcon, &
        halfe, gs, capps, incitr, timitr, frst, bfrst, ready, glow,  &
        makea, makeb, getout, l_param, opendd
      integer :: iopc_calcp
      character, dimension(3) :: abprt*5
      double precision, external :: capcor, helect, meci, reada, seconds

      save icalcn, debug, prtfok, prteig, prtden, prt1el, abprt, plb, &
        minprt, newdg, scfcrt, prtpl, prtvec, pl, bshift, pltest, itrmax, na2el, &
        na1el, nb1el, ifill, camkin, ci, okpuly, oknewd, &
        times, force, allcon, trans, halfe, w1, w2, random, gs, shift, shiftb, &
        shfmax, capps, ten, tenold, incitr, irrr, plchek, timitr, &
        scorr, shfto, shftbo, titer0, jalp, ialp, jbet, ibet, enrgy, &
        iopc_calcp
      data icalcn/ 0/
      data debug/ .FALSE./
      data prtfok/ .FALSE./
      data titer0/ 0.D0/
      data prteig/ .FALSE./
      data prtden/ .FALSE./
      data prt1el/ .FALSE./
      data ten/ 10.D0/
      data tenold/ 10.D0/
      data plb/ 0.D0/
      data scorr/ 0.D0/
      data abprt/ '     ', 'ALPHA', ' BETA'/
!
!  INITIALIZE
!
      ifill = 0
      ihomo = max(1,nclose + nalpha)
      ihomob = max(1,nclose + nbeta)
      eold = 1.D2
      ready = .FALSE.
      diff = 0.D0
      escf0 = 0.D0
      sellim = 0.d0
      opendd = .false.
      glow = .FALSE.
      if (icalcn /= numcal) then
        call delete_iter_arrays
        l_param = .true.
        enrgy = fpc_9
        irrr = 5
        shift = 0.D0
        icalcn = numcal
        shfmax = 20.D0
!
!    DEBUG KEY-WORDS WORKED OUT
!
        debug = index(keywrd,' DEBUG') /= 0
        minprt = index(keywrd,' SADDLE') + latom==0 .or. debug
        prteig = index(keywrd,' EIGS') /= 0
        prtpl = index(keywrd,' PL ') + index(keywrd,' PLS') /= 0
        prt1el = index(keywrd,' 1ELE') /=0 .and. debug
        prtden = index(keywrd,' DENS') /=0 .and. debug
        prtfok = index(keywrd,' FOCK') /=0 .and. debug
        prtvec = index(keywrd,' VEC') + index(keywrd,' ALLVEC') /=0 .and. debug
        debug = index(keywrd,' ITER') /= 0
!
! INITIALIZE SOME LOGICALS AND CONSTANTS
!
        newdg = .FALSE.
        camkin = .false.
        plchek = 0.005D0
        pl = 1.D0
        plb = 0.d0
        bshift = -80.D0
        shift = 1.D0
        shfto = 0.D0
        shftbo = 0.D0
        itrmax = 2000
        na2el = nclose
        na1el = nalpha + nopen
        nb1el = nbeta + nopen
!
!  USE KEY-WORDS TO ASSIGN VARIOUS CONSTANTS
!
        if (index(keywrd,' FILL') /= 0) ifill = -nint(reada(keywrd,index(keywrd,' FILL')))
        if (index(keywrd,' SHIFT') /= 0) bshift = -reada(keywrd,index(keywrd,' SHIFT'))
        if (Abs(bshift) > 1.d-20) ten = bshift
        if (index(keywrd,' ITRY') /= 0) itrmax = nint(reada(keywrd,index(keywrd,' ITRY')))
        ci = index(keywrd,' MICROS') + index(keywrd,' C.I.') /= 0 .and. .not. method_indo
        okpuly = index(keywrd,' PULAY') /= 0
        oknewd = abs(bshift) < 0.001D0
        if (camkin .and. abs(bshift)>1.D-5) bshift = 4.44D0
        times = index(keywrd,' TIMES') /= 0
        timitr = times
        force = index(keywrd,' FORCE') /= 0
        gs = index(keywrd,' TS') + index(keywrd,' NLLSQ') + index(keywrd,' SIGMA') == 0 .and. .not.force
        allcon = okpuly .or. camkin
!
!   DO WE NEED A CAPPED ATOM CORRECTION?
!
        j = 0
        j = j + count(nat(:numat) == 102)
        capps = j > 0
        iscf = 1
        trans = 0.200D0
        if (index(keywrd,' OLDENS') /= 0) then
           call den_in_out(0)
           if (moperr) return
           if (uhf) then
            pold(1:mpack) = pa(1:mpack)
            pbold(1:mpack) = pb(1:mpack)
          else
            pold(1:mpack) = pa(1:mpack)*2.d0
          end if
        else
!
! If a reaction path of some kind and it's a UHF, don't reset the density matrix after the first SCF
!
          if (.not. is_PARAM .and. (latom == 0 .or. nscf == 0) .or. .not. UHF) then
            p(:mpack) = 0.D0
            pa(:mpack) = 0.D0
            pb(:mpack) = 0.D0
            w1 = na1el/(na1el + 1.D-6 + nb1el)
            w2 = 1.D0 - w1
            if (w1 < 1.D-6) w1 = 0.5D0
            if (w2 < 1.D-6) w2 = 0.5D0
!
!  SLIGHTLY PERTURB THE DENSITY MATRIX IN CASE THE SYSTEM IS
!  TRAPPED IN A S**2 = 0 STATE.
!
            random = 1.0D0
            glow = method_indo .or. glow .or. (gnorm<2.D0 .and. gnorm > 1.D-9)
            if (.not. glow .and. uhf .and. na1el == nb1el) random = 1.1D0
            do i = 1, norbs
              j = (i*(i + 1))/2
              p(j) = pdiag(i)
              pa(j) = p(j)*w1*random
              random = 1.D0/random
              pb(j) = p(j)*w2*random
            end do
            if (uhf) then
              do i = 1, norbs
                random = 1.D0/random
                pb((i*(i+1))/2) = p((i*(i+1))/2)*w2*random
              end do
            end if
          end if
          pold(1:mpack) = pa(1:mpack)
          if (uhf) then
            pbold(1:mpack) = pb(1:mpack)
          end if
          do i = 1, norbs
            pold2(i) = pold((i*(i+1))/2)
          end do
        end if
        halfe = (nopen /= nclose .and. Abs(fract - 2.D0) > 1.d-20 .and. Abs(fract) > 1.d-20)
        if (halfe) then
          iopc_calcp = 3            ! DGEMM on CPU
#ifdef GPU
          if (lgpu) iopc_calcp = 2  ! DGEMM on GPU
#endif
        else
          iopc_calcp = 5            ! DSYRK on CPU
#ifdef GPU
          if (lgpu) iopc_calcp = 4  ! DSYRK on GPU
#endif
        end if
!
        if (gs) gs = .not. halfe .and. .not.ci
!
!   DETERMINE THE SELF-CONSISTENCY CRITERION
!
!
! SCFCRT IS MACHINE-PRECISION DEPENDENT
!
        scfcrt = 1.D-4
!
!  INCREASE PRECISION FOR EVERYTHING EXCEPT NORMAL GROUND-STATE
!  CALCULATIONS
!
        if (index(keywrd,' NLLSQ') + index(keywrd,' SIGMA') + index(keywrd,&
          ' TS')/=0 .or. force) then
          scfcrt = scfcrt*0.001D0
        else if (index(keywrd,' PRECISE')/=0 .or. nopen/=nclose) then
          scfcrt = scfcrt*0.01D0
        end if
        if (index(keywrd,' POLAR') /= 0) scfcrt = min(1.d-6, scfcrt)
        scfcrt = max(scfcrt,1.D-12)
!
!  THE USER CAN STATE THE SCF CRITERION, IF DESIRED.
!
        i = index(keywrd,' SCFCRT')
        j = index(keywrd,' RELSCF')
        if (i /= 0) then
          scfcrt = reada(keywrd,i)
        else if (j /= 0) then
          scfcrt = reada(keywrd,j)*scfcrt
        end if
!
!  For solids, reduce the SCF criterion to match a system with ~20 atoms
!
        if (id == 3) scfcrt = scfcrt*numat/20
        if (debug .or. i + j /= 0) write (iw, '(''  SCF CRITERION ='',G14.4)') scfcrt
        if (scfcrt < 1.D-12) write (iw, &
      '(2/2X,'' THERE IS A RISK OF INFINITE LOOPING WITH THE SCFCRT LESS THAN 1.D-12'')')
!
!   END OF INITIALIZATION SECTION.
!
      else if (nscf>0 .and. .not.uhf) then
!
!   RESET THE DENSITY MATRIX IF MECI HAS FORMED AN EXCITED STATE.  THIS
!   PREVENTS THE SCF GETTING TRAPPED ON AN EXCITED STATE, PARTICULARLY
!   IF THE PULAY CONVERGER IS USED.
!
! GBR_new_addition

        call dcopy(mpack, pa, 1, pb, 1)
        forall (i=1:mpack) p(i) = 2.d0*pa(i)

!          pb(:mpack) = pa(:mpack)
!          p(:mpack) = 2.D0*pa(:mpack)
!**
      end if
!
!   INITIALIZATION OPERATIONS DONE EVERY TIME ITER IS CALLED
!
      makea = .TRUE.
      makeb = .TRUE.
      iemin = 0
      iemax = 0
      if (irrr /= 5) then
        if (uhf) then
          call dcopy(mpack, pa, 1, pold, 1)
          call dcopy(mpack, pb, 1, pbold, 1)
          forall (i=1:norbs)
            pold2(i) = pa((i*(i+1))/2)
            pbold2(i) = pb((i*(i+1))/2)
          endforall
        else
          call dcopy(mpack, p, 1, pold, 1)
          forall (i=1:norbs)
            pold2(i) = p((i*(i+1))/2)
          endforall
        end if
      end if
      camkin = index(keywrd,' KING') + index(keywrd,' CAMP') /= 0
!
!  TURN OFF SHIFT IF NOT A FULL SCF.
!
      if (.not.fulscf) shift = 0.D0
      if (newdg) newdg = abs(bshift) < 0.001D0
      if (last == 1) newdg = .FALSE.
!
!   SELF-CONSISTENCY CRITERIA: SELCON IS IN KCAL/MOL, PLTEST IS
!   A LESS IMPORTANT TEST TO MAKE SURE THAT THE SELCON TEST IS NOT
!   PASSED 'BY ACCIDENT'
!                              IF GNORM IS LARGE, MAKE SELCON BIGGER
!
      selcon = scfcrt
!
!  LET SELCON BE DETERMINED BY SCFCRT AND GNORM, BUT IN NO CASE
!  CAN IT BE MORE THAN 100*SELCON OR 0.1
!
      if (gs) selcon = min(min(scfcrt*100.D0,0.1D0),max(scfcrt*gnorm**3*10**(-id*3),scfcrt))
      pltest = 0.05D0*sqrt(abs(selcon))
!
!  SOMETIMES HEAT GOES SCF BUT DENSITY IS STILL FLUCTUATING IN UHF
!  IN WHICH CASE PAY LESS ATTENTION TO DENSITY MATRIX
!
      if (nalpha/=nbeta .and. uhf) pltest = 0.001D0
      if (debug) write (iw, '(''  SELCON, PLTEST'',3G16.7)') selcon, pltest
      if (prt1el) then
        write (iw, '(2/10X,''ONE-ELECTRON MATRIX AT ENTRANCE TO ITER'')')
        call vecprt (h, norbs)
      end if
      iredy = 1
  180 continue
      niter = 0
      frst = .TRUE.
      if (camkin) then
        modea = 1
        modeb = 1
      else
        modea = 0
        modeb = 0
      end if
      bfrst = .TRUE.
!*********************************************************************
!                                                                    *
!                                                                    *
!                START THE SCF LOOP HERE                             *
!                                                                    *
!                                                                    *
!*********************************************************************
  250 continue

      incitr = modea/=3 .and. modeb/=3
      if (incitr) niter = niter + 1
      if (timitr) then
        titer = seconds(1)
        write (iw, *)
        if (niter > 1) write (iw, '(a,f9.2,a,/)') &
          '     TIME FOR ITERATION:', titer - titer0, ' WALL CLOCK SECONDS'
        titer0 = titer
      end if
      if (niter > itrmax - 10 .and. .not.allcon) then
!***********************************************************************
!                                                                      *
!                   SWITCH ON ALL CONVERGERS                           *
!                                                                      *
!***********************************************************************
        okpuly = .true.
        camkin = .not. halfe
          if (itrmax > 2) write (iw, &
      '(2/,'' ALL CONVERGERS ARE NOW FORCED ON'',/,'' SHIFT=10,&
      & PULAY ON, CAMP-KING ON'',/,'' AND ITERATION COUNTER RESET'',2/)')
        allcon = .TRUE.
        bshift = 4.44D0
        iredy = -4
        eold = 100.D0
        newdg = .FALSE.
        if (is_PARAM .and. l_param) then
          write (ifiles_1,'(a)') "ALL CONVERGERS ARE NOW FORCED ON"
          l_param = .false.
        end if
        go to 180
      end if
!***********************************************************************
!                                                                      *
!                        MAKE THE ALPHA FOCK MATRIX                    *
!                                                                      *
!***********************************************************************
      if (abs(shift)>1.D-10 .and. bshift/=0.D0) then
        l = 0
        if (niter > 1) then
          if (newdg .and. .not.(halfe .or. camkin)) then
!
!  SHIFT WILL APPLY TO THE VIRTUAL ENERGY LEVELS USED IN THE
!  PSEUDODIAGONALIIZATION. IF DIFF IS -VE, GOOD, THEN LOWER THE
!  HOMO-LUMO GAP BY 0.1EV, OTHERWISE INCREASE IT.
            if (diff > 0.D0) then
              shift = 1.D0
!
! IF THE PSEUDODIAGONALIZATION APPROXIMATION -- THAT THE WAVEFUNCTION
! IS ALMOST STABLE -- IS INVALID, TURN OFF NEWDG
              if (diff > 1) newdg = .FALSE.
            else
              shift = -0.1D0
            end if
          else
            if (ihomo < norbs) then
              shift = ten + eigs(ihomo+1) - eigs(ihomo) + shift
            else
              shift = 0.D0
            end if
          end if
          if (diff > 0.D0) then
            if (shift > 4.D0) shfmax = 4.5D0
            if (shift > shfmax) shfmax = max(shfmax - 0.5D0,0.D0)
          end if
!
!   IF SYSTEM GOES UNSTABLE, LIMIT SHIFT TO THE RANGE -INFINITY - SHFMAX
!   BUT IF SYSTEM IS STABLE, LIMIT SHIFT TO THE RANGE -INFINITY - +20
!
          shift = max(-20.D0,min(shfmax,shift))
          if (abs(shift - shfmax) < 1.D-5) shfmax = shfmax + 0.01D0
!
!  THE CAMP-KING AND PULAY CONVERGES NEED A CONSTANT SHIFT.
!  IF THE SHIFT IS ALLOWED TO VARY, THESE CONVERGERS WILL NOT
!  WORK PROPERLY.
!
          if (okpuly .or. abs(bshift-4.44D0)<1.D-5) then
            shift = -8.D0
            if (newdg) shift = 0.D0
          end if
          if (uhf) then
            if (newdg .and. .not.(halfe .or. camkin)) then
              shiftb = ten - tenold
            else
              shiftb = ten + eigb(ihomob+1) - eigb(ihomob) + shiftb
            end if
            if (diff > 0.D0) shiftb = min(4.D0,shiftb)
            shiftb = max(-20.D0,min(shfmax,shiftb))
            if (okpuly .or. abs(bshift-4.44D0)<1.D-5) then
              shiftb = -8.D0
              if (newdg) shiftb = 0.D0
            end if
            eigb(ihomob+1:norbs) = eigb(ihomob+1:norbs) + shiftb
          end if
        end if
        tenold = ten
        if (pl > plchek) then
          shftbo = shiftb
          shfto = shift
        else
          shiftb = shftbo
          shift = shfto
        end if
        if (id == 0) eigs(ihomo+1:norbs) = eigs(ihomo+1:norbs) + shift
        if (id /= 0) shift = -80.D0
        if (lxfac) shift=0.d0
        forall (i=1:mpack)
          f(i) = h(i) + shift*pa(i) + 1.D-16*i
        endforall

        do i=1,norbs
           f(i*(i+1)/2) = f(i*(i+1)/2) - shift
        end do
      else if (last==0 .and. niter<2 .and. fulscf) then
!
!  SLIGHTLY PERTURB THE FOCK MATRIX IN CASE THE SYSTEM IS
!  TRAPPED IN A METASTABLE EXCITED ELECTRONIC STATE
!
        random = 0.001D0
        glow = method_indo .or. glow .or. (gnorm < 2.D0 .and. gnorm > 1.D-9)
        if (glow) random = 0.D0
        do i = 1, mpack
          random = -random   ! GBR: This sounds strange. Could Random variable be placed out of the loop?
          f(i) = h(i) + random
        end do
      else
        call dcopy(mpack,h,1,f,1)
      end if
  320 continue
      if (timitr) call timer ('BEFORE FOCKS')
      if (id /= 0) then
        call fock2 (f, p, pa, w, w, wk, numat, nfirst, nlast, 2)
      else if (method_indo) then
        if (.not. allocated(dd)) then
          allocate(dd(mpack,2))
          allocate(cc0(norbs,norbs))
          allocate(aa(mpack))
          allocate(ff(mpack,2))
          allocate(dtmp(mpack,2))
          nb2 = mpack
! First round - fill dd based on occupied fractions
          ofract = dble(nclose)*2/(dble(nclose) + dble(nopen))
          do i=1,mpack
            dd(i,1) = p(i) * ofract
            dd(i,2) = p(i) * (1.D0 - ofract)
          end do
!          write (6,*) 'ofract',ofract,nclose,nopen
          opendd = .False.
        else
! Following rounds - fill dd based on orbitals if open shell
!          write (0,*) 'dd sum', c
          if (nopen > nclose .and. pl < pltest*10 .and. abs(diff) < sellim*10) then
            opendd = .True.
          end if
          if (opendd) then
            l = 0
            nl2 = 1
            nu2 = nclose
            nl1 = nclose + 1
            nu1 = nopen
!            write (0,*) 'nl',nl2,nu2,nl1,nu1,nclose,nopen
            do i = 1, norbs
              do j = 1, i
                l = l + 1
                sum2 = sum(c(i,nl2:nu2)*c(j,nl2:nu2))
                sum1 = sum(c(i,nl1:nu1)*c(j,nl1:nu1))
                dd(l,1) = sum2*2.D0
                dd(l,2) = sum1
              end do
            end do
          else
            do i=1,mpack
              dd(i,1) = p(i) - dd(i,2)
            end do
            do i=1,mpack
              dd(i,1) = p(i)
              dd(i,2) = 0.D0
            end do
          end if
        end if
!        do i = 1,6
!          write (0,*) dd(i,1) + dd(i,2), p(i), dd(i,1) + dd(i,2) - p(i)
!        end do
!        write (6,*) 'p',p, pa, pb
        do i=1,norbs
          do j = 1,norbs
            cc0(j,i) = c(i,j)
          end do
        end do

        call scfmat(tot,shiftb)

        do i=1,mpack
! Use full Fock matrix (same for closed-shell, diff for open-shell)
          f(i)  = aa(i)
          dtmp(i,1) = dd(i,1)
          dtmp(i,2) = dd(i,2)
!          p(i) = dd(i,1) + dd(i,2)
!          pa(i) = p(i)/2.D0
!          pb(i) = p(i)/2.D0
        end do

        do i=1,norbs
          do j = 1,norbs
            c(j,i) = cc0(i,j)
          end do
        end do
! dd and p contain the full density matrix (sum of alpha and beta electrons)
        if (useps) then
          call addfck (f,p)
        end if
      else
        call fock2 (f, p, pa, w, w, w, numat, nfirst, nlast, 2)
      end if
      if (lxfac) then
        ee = helect(norbs,pa,h,f)*2.d0
        if (ci .or. halfe) then
          call eigenvectors_LAPACK(c, f, eigs, norbs)
          summ = meci()
          ee = ee + summ
        end if
        return
      end if
      if (timitr) call timer ('AFTER  FOCKS ')
      if (prtfok) then
        if (uhf) write (iw, "('   ALPHA FOCK MATRIX ON ITERATION',i3)") niter
        if ( .not. uhf) write (iw, "('   FOCK MATRIX ON ITERATION',i3)") niter
        call vecprt (f, norbs)
      end if
!***********************************************************************
!                                                                      *
!                        MAKE THE BETA FOCK MATRIX                     *
!                                                                      *
!***********************************************************************
      if (uhf) then
        if (shiftb /= 0.D0) then
          l = 0
          do i = 1, norbs
            if (i > 0) then
              fb(l+1:i+l) = h(l+1:i+l) + shiftb*pb(l+1:i+l)
              l = i + l
            end if
            fb(l) = fb(l) - shiftb
          end do
        else if (rand .and. last==0 .and. niter<2 .and. fulscf) then
          random = 0.001D0
          if (glow) random = 0.D0
          do i = 1, mpack
            random = -random
            fb(i) = h(i) + random
          end do
        else
           call dcopy(mpack,h,1,fb,1)
        end if
        if (id /= 0) then
          call fock2 (fb, p, pb, w, w, wk, numat, nfirst, nlast, 2)
        else
          call fock2 (fb, p, pb, w, w, w, numat, nfirst, nlast, 2)
        end if
        if (prtfok) then
          write (iw, "('   BETA FOCK MATRIX ON ITERATION',i3)") niter
          call vecprt (fb, norbs)
        end if
      end if
      if (.not.fulscf) go to 600
!
!   CODE THE FOLLOWING LINE IN PROPERLY SOMETIME
!   THIS OPERATION IS BELIEVED TO GIVE RISE TO A BETTER FOCK MATRIX
!   THAN THE CONVENTIONAL GUESS.
!
      if (irrr == 0) then
        do i = 1, norbs
          f((i*(i+1))/2) = f((i*(i+1))/2)*0.5D0
        end do
      end if
      irrr = 2
!***********************************************************************
!                                                                      *
!                        CALCULATE THE ENERGY IN KCAL/MOLE             *
!                                                                      *
!***********************************************************************
      if (niter >= itrmax) then
        if (diff < 1.D-3 .and. pl < 1.D-4 .and. .not. force) then
          if (abs(shift) < 1.D-10) write (iw, &
      '('' """""""""""""""UNABLE TO ACHIEVE'',           '' SELF-CONSISTENCE, J&
      &OB CONTINUING'')')
          incitr = .TRUE.
          getout = .TRUE.
          go to 410
        end if
        if (minprt) write (iw, 390)
  390   format(/,/,10x,'"""""""""""""UNABLE TO ','ACHIEVE SELF-CONSISTENCE',/)
        write (iw, 400) diff, pl
  400   format(/,/,10x,'DELTAE= ',e12.4,5x,'DELTAP= ',e12.4,/,/,/)
        iflepo = 9
        iscf = 2
        call writmo
        call mopend ('UNABLE TO ACHIEVE SELF-CONSISTENCE')
        return
      end if
      ee = helect(norbs,pa,h,f)
      if (uhf) then
        ee = ee + helect(norbs,pb,h,fb)
      else
        ee = ee*2.D0
      end if
      if (capps) ee = ee + capcor(nat,nfirst,nlast,p,h)
      if (uhf) then
        if (bshift /= 0.D0) then
          if (nalpha_open > nalpha) then
            scorr = shift*(nalpha_open - nalpha)*enrgy*0.5d0*(fract*(1.D0 - fract))
          else
            scorr = shift*(nbeta_open - nbeta)*enrgy*0.5d0*(fract*(1.D0 - fract))
          end if
        end if
      else
        if (bshift /= 0.D0) scorr = shift*(nopen - nclose)*enrgy*0.25D0*(fract*(2.D0 - fract))
      end if
      escf = (ee + enuclr)*enrgy + atheat + scorr
      getout = .FALSE.
  410 continue
      if (incitr) then
        if (getout) go to 470
        diff = escf - eold
        if (diff > 0) then
          ten = ten - 1.D0
        else
          ten = ten*0.975D0 + 0.05D0
        end if
        sellim = max(selcon,1.d-15*max(abs(ee),1.D0))
!
! SCF TEST:  CHANGE IN HEAT OF FORMATION IN KCAL/MOL SHOULD BE
!            LESS THAN SELLIM.  THE OTHER TESTS ARE SAFETY MEASURES
!
        if (.not.(niter > 4 .and. (pl == 0.D0 .or. &
        pl < pltest .and. abs(diff) < sellim) .and. ready)) go to 490
!***********************************************************************
!                                                                      *
!          SELF-CONSISTENCY TEST, EXIT MODE FROM ITERATIONS            *
!                                                                      *
!***********************************************************************
  470   continue
        if (abs(shift) < 1.D-10) go to 600
        shift = 0.D0
        shiftb = 0.D0
        f(:mpack) = h(:mpack)
        makea = .TRUE.
        makeb = .TRUE.
        go to 320
  490   continue
        if (limscf .and. emin/=0.D0 .and. .not.(ci .or. halfe)) then
!
!  THE FOLLOWING TESTS ARE INTENDED TO ALLOW A FAST EXIT FROM ITER
!  IF THE RESULT IS 'GOOD ENOUGH' FOR THE CURRENT STEP IN THE GEOMETRY
!  OPTIMIZATION
!
          if (escf < emin) then
!
!  THE ENERGY IS LOWER THAN THE PREVIOUS MINIMUM.  NOW CHECK THAT
!  IT IS CONSISTENTLY LOWER.
!
            iemax = 0
            iemin = min(5,iemin + 1)
            escf0(:iemin-1) = escf0(2:iemin)
            escf0(iemin) = escf
!
!  IS THE DIFFERENCE IN ENERGY BETWEEN TWO ITERATIONS LESS THAN 5%
!  OF THE ENERGY GAIN FOR THIS GEOMETRY RELATIVE TO THE PREVIOUS
!  MINIMUM.
!
            if (iemin > 3) then
              do i = 2, iemin
                if (abs(escf0(i)-escf0(i-1)) > 0.05D0*(emin - escf)) go to 540
              end do
!
! IS GOOD ENOUGH -- RAPID EXIT
!
              if (debug) write (iw, *) &
                ' RAPID EXIT BECAUSE ENERGY IS CONSISTENTLY LOWER'
              incitr = .TRUE.
              getout = .TRUE.
              go to 410
            end if
          else
!
!  THE ENERGY HAS RISEN ABOVE THAT OF THE PREVIOUS MINIMUM.
!  WE NEED TO CHECK WHETHER THIS IS A FLUKE OR IS THIS REALLY
!  A BAD GEOMETRY.
!
            iemin = 0
            iemax = min(5,iemax + 1)
            escf0(:iemax-1) = escf0(2:iemax)
            escf0(iemax) = escf
!
!  IS THE DIFFERENCE IN ENERGY BETWEEN TWO ITERATIONS LESS THAN 5%
!  OF THE ENERGY LOST FOR THIS GEOMETRY RELATIVE TO THE PREVIOUS
!  MINIMUM.
!
            if (iemax > 3) then
              do i = 2, iemax
                if (abs(escf0(i)-escf0(i-1)) > 0.05D0*(escf - emin)) go to 540
              end do
!
! IS GOOD ENOUGH -- RAPID EXIT
!
              if (debug) write (iw, *) &
                ' RAPID EXIT BECAUSE ENERGY IS CONSISTENTLY HIGHER'
              incitr = .TRUE.
              getout = .TRUE.
              go to 410
            end if
          end if
        end if
  540   continue
        ready = iredy>0 .and. (abs(diff)<sellim*10.D0 .or. pl==0.D0)
        iredy = iredy + 1
      end if
      if (prtpl .or. debug .and. niter > itrmax - 20) then
        if (escf > 999999.D0) then
          escf = 999999.D0
        end if
        if (escf < -999999.D0) escf = -999999.D0
        if (abs(diff) > 9999.D0) diff = 0.D0
        if (incitr) then
          write (line,'('' ITERATION'',I4,'' PLS='',2E10.3,'' ENERGY  '',F14.6,'' DELTAE'',F13.7,f14.3)') &
            niter, pl, plb, escf, diff
          write(iw,'(a)')trim(line)
          call to_screen(line)
          endfile (iw)
          backspace (iw)
        end if
      end if
      if (incitr) eold = escf
!***********************************************************************
!                                                                      *
!                        INVOKE THE CAMP-KING CONVERGER                *
!                                                                      *
!***********************************************************************
      if (niter>2 .and. camkin .and. makea) then
        if (.not. Allocated (vec_ai)) then
        allocate (vec_ai(norbs, norbs), fock_ai(norbs, norbs), &
        & p_ai(norbs, norbs), h_ai(norbs**2), vecl_ai(norbs**2), stat=i)
        if (i /= 0) then
          call memory_error("Camp-King converger in Iter")
          return
        end if
! TODo: make it parallel
        vec_ai(:,:)= 0.0d0
        fock_ai(:,:) = 0.0d0
        p_ai(:,:) = 0.0d0
        h_ai(:) = 0.0d0
        vecl_ai(:) = 0.0d0
      end if
        call interp (na1el, norbs - na1el, modea, escf/enrgy, f, c, &
        theta, vec_ai, fock_ai, p_ai, h_ai, vecl_ai, eold_alpha)
      end if
      makeb = .FALSE.
      if (modea /= 3) then
        makeb = .TRUE.
        if (debug) then
          write (iw, *) ' Diagonal of FOCK Matrix'
          write (iw, '(8F10.6)') (f((i*(i + 1))/2),i = 1,norbs)
        end if
        if (nscf == 2) then
          continue
          end if
        if (newdg) then
!***********************************************************************
!                                                                      *
!                        INVOKE PULAY'S CONVERGER                      *
!                                                                      *
!***********************************************************************
           if (okpuly .and. makea .and. iredy>1) then
#ifdef GPU
              if (lgpu) then
                 call pulay_for_gpu (f, pa, norbs, pold, pold2, pold3, &
                 & jalp, ialp, npulay*mpack, frst, pl)
              else
#endif
                 call pulay (f, pa, norbs, pold, pold2, pold3, &
                 & jalp, ialp, npulay*mpack, frst, pl)
#ifdef GPU
              end if
#endif
          end if

!***********************************************************************
!                                                                      *
!           DIAGONALIZE THE ALPHA OR RHF SECULAR DETERMINANT           *
! WHERE POSSIBLE, USE THE PULAY-STEWART METHOD, OTHERWISE USE BEPPU'S  *
!                                                                      *
!***********************************************************************
! JEM NOTE: pseudo-diagonalization does less work, but it is less stable
!           and slower because a large fraction of its work is stuck
!           using BLAS level-1 operations right now. This could be
!           accelerated using a QR diagonalization analog at some point ...
!          if (halfe .or. camkin) then
            if (timitr) call timer ('BEFORE FULL DIAG')
            call eigenvectors_LAPACK(c, f, eigs, norbs)
            if (timitr) call timer ('AFTER  FULL DIAG')
!          else
!            if (lgpu) then
!               if (timitr) call timer ('BEFORE GPU DIAG')
!               call diag_for_GPU (f, c, na1el, eigs, norbs, mpack)
!               if (timitr) call timer ('AFTER  GPU DIAG')
!            else
!              if (timitr) call timer ('BEFORE CPU DIAG')
!               call diag_for_GPU (f, c, na1el, eigs, norbs, mpack)
!               if (timitr) call timer ('AFTER  CPU DIAG')
!            end if
!          end if
        else
          if (timitr) call timer ('BEFORE FULL DIAG')
          call eigenvectors_LAPACK(c, f, eigs, norbs)
          if (timitr) call timer ('AFTER  FULL DIAG')
        end if
        j = 1
        if (prtvec) then
            j = 1
            if (uhf) j = 2
            write (iw, &
         & '(2/10X,A,'' EIGENVECTORS AND EIGENVALUES ON ITERATION'',I3)') abprt(j), niter
            call matout (c, eigs, norbs, norbs, norbs)
        else
          if (prteig) write (iw, 550) abprt(j), niter, (eigs(i),i=1,norbs)
        end if
  550   format(10x,a,'  EIGENVALUES ON ITERATION',i3,/,10(6g13.6,/))
      end if
      if (ifill /= 0) call swap (c, norbs, norbs, na2el, ifill)
!***********************************************************************
!                                                                      *
!            CALCULATE THE ALPHA OR RHF DENSITY MATRIX                 *
!                                                                      *
!***********************************************************************
        if (timitr) call timer ('BEFORE DENSIT')
        if (uhf) then
          call density_for_GPU (c, fract, nalpha, nalpha_open, 1.d0, mpack,norbs, 1, pa, iopc_calcp)
          if (modea /= 3 .and. .not. (newdg .and. okpuly)) then
            i = niter
            if (camkin) i = 7
            call cnvg (pa, pold, pold2,  i, pl)
          end if
        else
          if (halfe) then
            call densit (c, norbs, norbs, na2el, 2.d0, na1el, fract, p, 1)
          else
            call density_for_GPU (c, fract, na2el, na1el, 2.d0, mpack, norbs, 1, p, iopc_calcp)
          end if
          if (modea/=3 .and. .not.(newdg .and. okpuly)) then
            call cnvg (p, pold, pold2,  niter, pl)
        end if
      end if
      if (timitr) call timer ('AFTER  DENSIT')
!***********************************************************************
!                                                                      *
!                       UHF-SPECIFIC CODE                              *
!                                                                      *
!***********************************************************************
      if (uhf) then
!***********************************************************************
!                                                                      *
!                        INVOKE THE CAMP-KING CONVERGER                *
!                                                                      *
!***********************************************************************
        if (niter > 2 .and. camkin .and. makeb) then
          if (.not. Allocated (vec_bi)) then
          allocate (vec_bi(norbs, norbs), fock_bi(norbs, norbs), &
               & p_bi(norbs, norbs), h_bi(norbs**2), vecl_bi(norbs**2), stat=i)
          if (i /= 0) then
            call memory_error("Camp-King converger in Iter")
            return
          end if
        end if
          call interp (nb1el, norbs - nb1el, modeb, escf/enrgy, fb, cb, &
          theta, vec_bi, fock_bi, p_bi, h_bi, vecl_bi, eold_beta)
        end if
        makea = .FALSE.
        if (modeb /= 3) then
          makea = .TRUE.
          if (newdg) then
!***********************************************************************
!                                                                      *
!                        INVOKE PULAY'S CONVERGER                      *
!                                                                      *
!***********************************************************************
            if (okpuly .and. makeb .and. iredy>1) then
#ifdef GPU
              if (lgpu) then
                 call pulay_for_gpu (fb, pb, norbs, pbold, pbold2, pbold3, &
                 & jbet, ibet, npulay*mpack, bfrst, plb)
              else
#endif
                call pulay (fb, pb, norbs, pbold, pbold2, pbold3, &
                 & jbet, ibet, npulay*mpack, bfrst, plb)
#ifdef GPU
              end if
#endif
          end if

!***********************************************************************
!                                                                      *
!           DIAGONALIZE THE ALPHA OR RHF SECULAR DETERMINANT           *
! WHERE POSSIBLE, USE THE PULAY-STEWART METHOD, OTHERWISE USE BEPPU'S  *
!                                                                      *
!***********************************************************************
! JEM NOTE: pseudo-diagonalization does less work, but it is less stable
!           and slower because a large fraction of its work is stuck
!           using BLAS level-1 operations right now. This could be
!           accelerated using a QR diagonalization analog at some point ...
!            if (halfe .or. camkin) then
              if (timitr) call timer ('BEFORE FULL DIAG')
              call eigenvectors_LAPACK(cb, fb, eigb, norbs)
              if (timitr) call timer ('AFTER  FULL DIAG')
!            else
!              if (lgpu) then
!                 if (timitr) call timer ('BEFORE GPU DIAG')
!                 call diag_for_GPU (fb, cb, nb1el, eigb, norbs, mpack)
!                 if (timitr) call timer ('AFTER  GPU DIAG')
!              else
!                if (timitr) call timer ('BEFORE CPU DIAG')
!                call diag_for_GPU (fb, cb, nb1el, eigb, norbs, mpack)
!                if (timitr) call timer ('AFTER  CPU DIAG')
!              end if
!            end if
          else
            if (timitr) call timer ('BEFORE FULL DIAG')
            call eigenvectors_LAPACK(cb, fb, eigb, norbs)
            if (timitr) call timer ('AFTER  FULL DIAG')
          end if

          if (prtvec) then
            write (iw, &
      '(2/10X,A,'' EIGENVECTORS AND EIGENVALUES ON '',   ''ITERATION'',I3)') &
            &  abprt(3), niter
            call matout (cb, eigb, norbs, norbs, norbs)
          else
            if (prteig) write (iw, 550) abprt(3), niter, (eigb(i),i=1,norbs)
          end if

        end if
!***********************************************************************
!                                                                      *
!                CALCULATE THE BETA DENSITY MATRIX                     *
!                                                                      *
!***********************************************************************
        if (timitr) call timer ('BEFORE B-DENS')
        call density_for_GPU (cb, fract, nbeta, nbeta_open, 1.d0, mpack, norbs, 1, pb, iopc_calcp)
        if (.not.(newdg .and. okpuly)) then
          i = niter
          if (camkin) i = 7
          call cnvg (pb, pbold, pbold2, i, plb)
        end if
        if (timitr) call timer ('AFTER  B-DENS')
      end if
!***********************************************************************
!                                                                      *
!                   CALCULATE THE TOTAL DENSITY MATRIX                 *
!                                                                      *
!***********************************************************************
      if (uhf) then
        forall (i=1:mpack)
           p(i) = pa(i) + pb(i)
        endforall
      else
        forall (i=1:mpack)
           pa(i) = p(i)*0.5d0
           pb(i) = pa(i)
        endforall
      end if
      if (debug) then
        call chrge (p, q)
        write (iw, *) ' CHARGES'
        write (iw, '(8F10.7)') (q(i),i=1,numat)
      end if
      if (prtden) then
        write (iw, '('' DENSITY MATRIX ON ITERATION'',I4)') niter
        call vecprt (p, norbs)
      end if
      if (itrmax < 3) return
      oknewd = pl<sellim .or. oknewd
      newdg = pl<trans .and. oknewd .or. newdg
      if (pl < trans*0.3333D0) oknewd = .TRUE.
      go to 250
!*********************************************************************
!                                                                    *
!                                                                    *
!                      END THE SCF LOOP HERE                         *
!                NOW CALCULATE THE ELECTRONIC ENERGY                 *
!                                                                    *
!                                                                    *
!*********************************************************************
!          SELF-CONSISTENCE ACHIEVED.
!
  600 continue
      ee = helect(norbs,pa,h,f)
      if (uhf) then
        ee = ee + helect(norbs,pb,h,fb)
      else
        ee = ee*2.D0
      end if
      if (capps) ee = ee + capcor(nat,nfirst,nlast,p,h)
      if (timitr) call timer ('BEFORE FINAL DIAG')
      if (nscf==0 .or. last==1 .or. ci .or. halfe) then
!
!  PUT F AND FB INTO POLD IN ORDER TO NOT DESTROY F AND FB
!  AND DO EXACT DIAGONALISATIONS
!
        call dcopy(mpack,f,1,pold,1)
        call eigenvectors_LAPACK(c, pold, eigs, norbs)
        if (last == 1) call phase_lock(c, norbs)
        if (uhf) then
           call dcopy(mpack,fb,1,pold,1)
           call eigenvectors_LAPACK(cb, pold, eigb, norbs)
           if (last == 1) call phase_lock(cb, norbs)
           call dcopy(mpack,pa,1,pold,1)
        else
           call dcopy(mpack,p,1,pold,1)
        end if
        if (ci .or. halfe) then
          if (timitr) call timer ('BEFORE MECI')
          summ = meci()
          if (timitr) call timer ('AFTER  MECI')
          if (moperr) return
          ee = ee + summ
          if (prtpl) then
            escf = (ee + enuclr)*enrgy + atheat
            write (iw, '(27X,''AFTER MECI, ENERGY  '',F14.7)') escf
          end if
        end if
      end if
      if (timitr) call timer ('AFTER  FINAL DIAG')
      nscf = nscf + 1
      if (debug) write (iw, '('' NO. OF ITERATIONS ='',I6)') niter
      if (allcon .and. abs(bshift - 4.44D0) < 1.D-7) then
        camkin = .FALSE.
        allcon = .FALSE.
        newdg = .FALSE.
        bshift = -10.D0
        okpuly = .FALSE.
      end if
      shift = 1.D0
      escf = (ee + enuclr)*enrgy + atheat
      if (emin == 0.D0) then
        emin = escf
      else
        emin = min(emin,escf)
      end if
      return
      end subroutine iter
      subroutine delete_iter_arrays
!
!  If these arrays exist, they must be deleted before starting ITER.
!  If they're not deleted, and they're too small, the stack will
!  become corrupt if INTERP is called.
!
      use iter_C, only : vec_ai, vec_bi, fock_ai, fock_bi, p_ai, &
      p_bi, h_ai, h_bi, vecl_ai, vecl_bi
      implicit none
        if (allocated(vec_ai)) deallocate(vec_ai)
        if (allocated(vec_bi)) deallocate(vec_bi)
        if (allocated(fock_ai)) deallocate(fock_ai)
        if (allocated(fock_bi)) deallocate(fock_bi)
        if (allocated(p_ai)) deallocate(p_ai)
        if (allocated(p_bi)) deallocate(p_bi)
        if (allocated(h_ai)) deallocate(h_ai)
        if (allocated(h_bi)) deallocate(h_bi)
        if (allocated(vecl_ai)) deallocate(vecl_ai)
        if (allocated(vecl_bi)) deallocate(vecl_bi)
      end subroutine delete_iter_arrays


      subroutine den_in_out(mode)
      use chanel_C, only : iw, iden, density_fn
      use common_arrays_C, only : p, pa, pb
      use molkst_C, only: uhf, keywrd, norbs, numat, mozyme
!
! Read and write the density matrix
!
!   If mode == 0 read the density matrix in (fill p, pa, and, if uhf, pb)
!   if mode == 1 write out the density matrix
!
      implicit none
      integer, intent (in) :: mode
      integer :: io_stat, icount, old_norbs, old_numat
      logical :: formatted, opend
      if (Index (keywrd, " DENOUT") == 0 .and. mode == 1) return
      if (Index (keywrd, " OLDENS") == 0 .and. mode == 0) return
      call l_control("NEWDEN", len("NEWDEN"), 1)
      if (mozyme) then
        call pinout(mode, .true.)
        return
      end if
      formatted = (Index(keywrd," DENOUTF") /= 0)
      inquire(unit=iden, opened=opend)
      if (opend) close(unit=iden, status='KEEP')
      do icount = 1,2
        if (formatted)then
          open(unit=iden, file=density_fn)
        else
          open(unit=iden, file=density_fn, status='UNKNOWN', &
          form='UNFORMATTED', position='asis')
        end if
        rewind iden
        if (mode == 0) then
!
!  Try reading the file using formatted input if DENOUTF exists.
!  If the read does not work, try the other way
!
          if (formatted)then
             read (iden, *, iostat=io_stat)old_norbs, old_numat, pa
          else
             read (iden, iostat=io_stat)old_norbs, old_numat, pa
          end if
          if (old_norbs > 0 .and. old_norbs < 100000) then   ! Delete this conditional in 2008
          if (norbs /= old_norbs .or. numat /= old_numat) then
            call mopend("Density file read in does not match current data set")
            return
          end if
          end if
          if (icount < 2.and. io_stat /= 0) then
            formatted = (.not. formatted)
            close(iden)
            cycle
          end if
          if (io_stat /= 0) then
            call to_screen(" Density Restart File missing or corrupt")
            call mopend ('Density Restart File missing or corrupt')
            return
          end if
            if (uhf) then
              if (formatted)then
                read (iden, *, iostat=io_stat) pb
              else
                read (iden, iostat=io_stat) pb
              end if
            if (io_stat /= 0) then
              if (index(keywrd, " GEO-OK") == 0) then
                call mopend("Beta Density Restart File missing or corrupt")
                write(iw,'(10x,a)')'(Most likely the previous job did not use UHF)'
                write(iw,'(10x,a)')"To continue, using the RHF density matrix as the starting point, add keyword ""GEO-OK"""
                return
              end if
              pb = pa
            end if
            p = pa + pb
          else
            p = pa*2.d0
          end if
        else
          if (formatted)then
            write (iden, *, iostat=io_stat)norbs, numat, pa
          else
            write (iden, iostat=io_stat)norbs, numat, pa
          end if
          if (uhf) then
            if (formatted)then
              write (iden, *, iostat=io_stat) pb
            else
              write (iden, iostat=io_stat) pb
            end if
          end if
          close (iden)
          exit
        end if
        close (iden)
      end do
      end subroutine den_in_out

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine kab_for_MOZYME (ia, ja, pk, w, f)
    implicit none
    integer, intent (in) :: ia, ja
    double precision, dimension (16), intent (in) :: pk
    double precision, dimension (100), intent (in) :: w
    double precision, dimension (*), intent (inout) :: f
    integer :: i, j, j1, j2, j3, m
    integer, dimension (16, 16) :: kkind
    double precision, dimension (16) :: sum
    data kkind / 1, 2, 4, 7, 11, 12, 14, 17, 31, 32, 34, 37, 61, 62, 64, 67, &
   & 2, 3, 5, 8, 12, 13, 15, 18, 32, 33, 35, 38, 62, 63, 65, 68, 4, 5, 6, 9, &
   & 14, 15, 16, 19, 34, 35, 36, 39, 64, 65, 66, 69, 7, 8, 9, 10, 17, 18, 19, &
   & 20, 37, 38, 39, 40, 67, 68, 69, 70, 11, 12, 14, 17, 21, 22, 24, 27, 41, &
   & 42, 44, 47, 71, 72, 74, 77, 12, 13, 15, 18, 22, 23, 25, 28, 42, 43, 45, &
   & 48, 72, 73, 75, 78, 14, 15, 16, 19, 24, 25, 26, 29, 44, 45, 46, 49, 74, &
   & 75, 76, 79, 17, 18, 19, 20, 27, 28, 29, 30, 47, 48, 49, 50, 77, 78, 79, &
   & 80, 31, 32, 34, 37, 41, 42, 44, 47, 51, 52, 54, 57, 81, 82, 84, 87, 32, &
   & 33, 35, 38, 42, 43, 45, 48, 52, 53, 55, 58, 82, 83, 85, 88, 34, 35, 36, &
   & 39, 44, 45, 46, 49, 54, 55, 56, 59, 84, 85, 86, 89, 37, 38, 39, 40, 47, &
   & 48, 49, 50, 57, 58, 59, 60, 87, 88, 89, 90, 61, 62, 64, 67, 71, 72, 74, &
   & 77, 81, 82, 84, 87, 91, 92, 94, 97, 62, 63, 65, 68, 72, 73, 75, 78, 82, &
   & 83, 85, 88, 92, 93, 95, 98, 64, 65, 66, 69, 74, 75, 76, 79, 84, 85, 86, &
   & 89, 94, 95, 96, 99, 67, 68, 69, 70, 77, 78, 79, 80, 87, 88, 89, 90, 97, &
   & 98, 99, 100 /
    do j = 1, 16
      sum(j) = 0.0d0
      do i = 1, 16
        sum(j) = sum(j) + pk(i) * w(kkind(i, j))
      end do
    end do
   !
    if (ia > ja) then
      !
      !   IA IS GREATER THAN JA, THEREFORE USE HALF OF TRIANGLE
      !
      m = 0
      do j1 = ia, ia + 3
        j = (j1*(j1-1)) / 2
        do j2 = ja, ja + 3
          m = m + 1
          j3 = j + j2
          f(j3) = f(j3) - sum(m)
        end do
      end do
    else if (ia < ja) then
      !
      !   IA IS LESS THAN JA, THEREFORE USE OTHER HALF OF TRIANGLE
      !
      m = 0
      do j1 = ia, ia + 3
        do j2 = ja, ja + 3
          m = m + 1
          j3 = (j2*(j2-1)) / 2 + j1
          f(j3) = f(j3) - sum(m)
        end do
      end do
    else
      !
      !   MOZYME - type - array elements are stored simply.
      !   (The factor of 0.5 is because MOZYME uses only the
      !    TOTAL density matrix.)
      !
      do i = 1, 16
        f(i) = f(i) - sum(i) * 0.5d0
      end do
    end if
end subroutine kab_for_MOZYME

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine dtran2(r, t, ioper)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use funcon_C, only : pi
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: ioper
      double precision , intent(inout) :: r(3,3)
      double precision , intent(inout) :: t(5,5,12)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i
      double precision, dimension(2,4) :: f
      double precision :: tol, s12, s3, one, r1, r2, r3, check, arg, b, sina, g&
        , a, e1, x1, e2, e3, e4, x2, x3, x4, ta, tg
      logical :: right

      save tol, s12, s3, one
!-----------------------------------------------
!
!  3.464... =SQRT(12)
!
      data tol, s12/ 0.001D0, 3.46410161513D0/
      data s3, one/ 1.73205080756D0, 1.D0/
      r1 = r(2,1)*r(3,2) - r(3,1)*r(2,2)
      r2 = r(3,1)*r(1,2) - r(1,1)*r(3,2)
      r3 = r(1,1)*r(2,2) - r(2,1)*r(1,2)
      check = r1*r(1,3) + r2*r(2,3) + r3*r(3,3)
      right = check > 0.D0
      r(1,3) = r1
      r(2,3) = r2
      r(3,3) = r3
      arg = r3
      if (abs(arg) > one) arg = sign(one,arg)
      b = acos(arg)
      sina = sqrt(1.D0 - arg*arg)
      if (sina >= tol) then
        arg = r(3,2)/sina
        if (abs(arg) > one) arg = sign(one,arg)
        g = asin(arg)
        arg = r(2,3)/sina
        if (abs(arg) > one) arg = sign(one,arg)
        a = asin(arg)
      else
        arg = r(1,2)
        if (abs(arg) > one) arg = sign(one,arg)
        g = asin(arg)
        a = 0.D0
      end if
      f(1,1) = a
      f(1,2) = a
      f(1,3) = pi - a
      f(1,4) = pi - a
      f(2,1) = g
      f(2,3) = g
      f(2,2) = pi - g
      f(2,4) = pi - g
      do i = 1, 4
        a = f(1,i)
        g = f(2,i)
        check = abs(sin(b)*cos(a) + r(1,3))
        if (check > tol) cycle
        check = (-sin(g)*cos(b)*sin(a)) + cos(g)*cos(a)
        if (abs(check - r(2,2)) > tol) cycle
        check = sin(a)*cos(g) + cos(a)*cos(b)*sin(g)
        if (abs(check - r(1,2)) > tol) cycle
        exit
      end do
      g = -g
      a = -a
      b = -b
      e1 = cos(b*0.5D0)
      x1 = -sin(b*0.5D0)
      e2 = e1*e1
      e3 = e1*e2
      e4 = e2*e2
      x2 = x1*x1
      x3 = x1*x2
      x4 = x2*x2
      ta = 2.D0*a
      tg = 2.D0*g
      t(1,1,ioper) = e4*cos(ta + tg) + x4*cos(ta - tg)
      t(1,2,ioper) = 2.D0*e3*x1*cos(a + tg) - 2.D0*e1*x3*cos(a - tg)
      t(1,3,ioper) = 2.D0*s3*e2*x2*cos(tg)
      t(1,4,ioper) = 2.D0*e3*x1*sin(a + tg) - 2.D0*e1*x3*sin(a - tg)
      t(1,5,ioper) = e4*sin(ta + tg) + x4*sin(ta - tg)
      t(2,1,ioper) = 2.D0*e1*x3*cos(ta - g) - 2.D0*e3*x1*cos(ta + g)
      t(2,2,ioper) = (e4 - 3.D0*e2*x2)*cos(a + g) - (3.D0*e2*x2 - x4)*cos(a - g)
      t(2,3,ioper) = 2.D0*s3*(e3*x1 - e1*x3)*cos(g)
      t(2,4,ioper) = (e4 - 3.D0*e2*x2)*sin(a + g) - (3.D0*e2*x2 - x4)*sin(a - g)
      t(2,5,ioper) = (-2.D0*e3*x1*sin(ta + g)) + 2.D0*e1*x3*sin(ta - g)
      t(3,1,ioper) = s12*e2*x2*cos(ta)
      t(3,2,ioper) = -s12*(e3*x1 - e1*x3)*cos(a)
      t(3,3,ioper) = e4 - 4.D0*e2*x2 + x4
      t(3,4,ioper) = -s12*(e3*x1 - e1*x3)*sin(a)
      t(3,5,ioper) = s12*e2*x2*sin(ta)
      t(4,1,ioper) = 2.D0*e1*x3*sin(ta - g) + 2.D0*e3*x1*sin(ta + g)
      t(4,2,ioper) = (-(e4 - 3.D0*e2*x2)*sin(a + g)) - (3.D0*e2*x2 - x4)*sin(a - g)
      t(4,3,ioper) = -2.D0*s3*(e3*x1 - e1*x3)*sin(g)
      t(4,4,ioper) = (e4 - 3.D0*e2*x2)*cos(a + g) + (3.D0*e2*x2 - x4)*cos(a - g)
      t(4,5,ioper) = (-2.D0*e3*x1*cos(ta + g)) - 2.D0*e1*x3*cos(ta - g)
      t(5,1,ioper) = (-e4*sin(ta + tg)) + x4*sin(ta - tg)
      t(5,2,ioper) = (-2.D0*e3*x1*sin(a + tg)) - 2.D0*e1*x3*sin(a - tg)
      t(5,3,ioper) = -2.D0*s3*e2*x2*sin(tg)
      t(5,4,ioper) = 2.D0*e3*x1*cos(a + tg) + 2.D0*e1*x3*cos(a - tg)
      t(5,5,ioper) = e4*cos(ta + tg) - x4*cos(ta - tg)
      if (right) return
      t(2,:,ioper) = -t(2,:,ioper)
      t(4,:,ioper) = -t(4,:,ioper)
      return
      end subroutine dtran2

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      double precision function dist2 (a, b)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!
!     DETERMINE DISTANCES BETWEEN NEIGHBORING ATOMS
!
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision , intent(in) :: a(3)
      double precision , intent(in) :: b(3)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
!-----------------------------------------------
      dist2 = (a(1)-b(1))**2 + (a(2)-b(2))**2 + (a(3)-b(3))**2
      return
      end function dist2


      double precision function dot1 (a, b)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision , intent(in) :: a(3)
      double precision , intent(in) :: b(3)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
!-----------------------------------------------
      dot1 = a(1)*b(1) + a(2)*b(2) + a(3)*b(3)
      return
      end function dot1

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine timer(a)
!
!  Write out CPU and wall-clock times for the current step, and total times
!
      Use molkst_C, only : wall_clock_0, wall_clock_1, CPU_1, CPU_0
      USE chanel_C, only : iw
      implicit none
      character , intent(in) :: a*(*)
      character :: b*20
      double precision :: CPU_start, CPU_last, CPU_now
      real :: wall_clock_last, dummy
      logical :: first
      double precision, external :: seconds
      save first, CPU_start, CPU_last, wall_clock_last
      data first/ .TRUE./
      if (first) then
!
!  DEFINE THE ZERO OF TIME
!
        CPU_start = seconds(1)
        CPU_start = CPU_0
        CPU_last = CPU_start
        wall_clock_last = wall_clock_1
        wall_clock_0 = wall_clock_last
        first = .FALSE.
      end if
!
! "dummy" call: wall_clock_1 is set in seconds(1), but call needed to set CPU_1
!
      dummy = real(seconds(1))
      if (dummy < -300.0) return
      CPU_now = CPU_1
      b = a
      write (iw, '(2x, a20, a, f7.2,  a, f11.2, a, f7.2, a, f9.2)') b, 'CPU INTERVAL:', &
      CPU_now - CPU_last, ', INTEGRAL:', CPU_now - CPU_start, &
      '    WALL-CLOCK INTERVAL:', wall_clock_1 - wall_clock_last, ', INTEGRAL:', &
      wall_clock_1 - wall_clock_0
      CPU_last = CPU_now
      wall_clock_last = wall_clock_1
      return
      end subroutine timer

! Example of MOPAC Fortran API usage
program mopac_api_example
  use mopac_api_f
  implicit none
  type(mopac_system_f) :: water
  type(mopac_state_f) :: state
  type(mopac_properties_f) :: output
  integer :: i

  ! define a water molecule (derived type has default values)  
  water%natom = 3
  allocate(water%atom(water%natom))
  allocate(water%coord(water%natom*3))
  water%atom(1) = 1
  water%coord(1) = -0.02110d0
  water%coord(2) = -0.00200d0
  water%coord(3) = 0.00000d0
  water%atom(2) = 8
  water%coord(4) = 0.83450d0
  water%coord(5) = 0.45190d0
  water%coord(6) = 0.00000d0
  water%atom(3) = 1
  water%coord(7) = 1.47690d0
  water%coord(8) = -0.27300d0
  water%coord(9) = 0.00000d0

  ! self-consistent field (SCF) calculation
  call mopac_scf_f(water, state, output)
  write(*,*) "PM7 heat of water =", output%heat, "kcal/mol"
  if(output%nerror > 0)then
    do i=1,output%nerror
       write(*,*) "SCF ERROR #", i, ":", output%error_msg(i)
    end do
    stop 1
  end if

  ! SCF calculation in COSMO solvent
  water%epsilon = 78.4d0
  call mopac_scf_f(water, state, output)
  if(output%nerror > 0)then
    do i=1,output%nerror
       write(*,*) "COSMO ERROR #", i, ":", output%error_msg(i)
    end do
    stop 1 
  end if
  write(*,*) "PM7 heat of water in COSMO solvent =", output%heat, "kcal/mol"

  ! geometry relaxation
  water%epsilon = 1.0d0 ! reset dielectric constant back to vacuum
  water%natom_move = 3
  call mopac_relax_f(water, state, output)
  if(output%nerror > 0)then
    do i=1,output%nerror
       write(*,*) "RELAX ERROR #", i, ":", output%error_msg(i)
    end do
    stop 1
  end if
  write(*,*) "geometry relaxation:"
  do i=1,water%natom*3
    write(*,*) i, ":", water%coord(i), "->", output%coord_update(i)
    water%coord(i) = output%coord_update(i)
  end do

  ! vibrational calculation of relaxed geometry
  call mopac_vibe_f(water, state, output)
  if(output%nerror > 0)then
    do i=1,output%nerror
       write(*,*) "VIBE ERROR #", i, ":", output%error_msg(i)
    end do
    stop 1
  end if
  write(*,*) "vibrational modes:"
  do i=1,water%natom_move*3
    write(*,*) i, ":", output%freq(i), "1/cm"
  end do
end program mopac_api_example

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

   subroutine bonds_for_MOZYME ()
    use molkst_C, only: numat, keywrd, nl_atoms, maxtxt
    use chanel_C, only: iw
    use common_arrays_C, only : p, nat, l_atom
    use MOZYME_C, only : iorbs
    implicit none
    logical :: lall, mozyme_style
    integer :: i, io, j, jo, k, kk, kl, ku, l, newl, j_lim
    double precision :: sum, sumlim, valenc
    integer, allocatable, dimension (:) :: ibab
    logical, allocatable, dimension (:) :: l_atom_store
    double precision, allocatable, dimension (:) :: bab
    intrinsic Index
    integer, external :: ijbo
  !
    lall = (Index (keywrd, " ALLBOND") /= 0)
    sumlim = 0.01d0                  !  Report all bonds greater than 0.01 not involving hydrogen
    if (lall) sumlim = sumlim*0.1d0  !  Report all bonds greater than 0.001
    mozyme_style = .true.
    if (index(keywrd, " IRC") + index(keywrd, " DRC") + index(keywrd, " MINI") /= 0) mozyme_style = .false.
    if (mozyme_style) then
      if (maxtxt > 25) then
        write (iw, '(1X,2/37X,"(VALENCIES)",1x,"BOND ORDER       TO",/)')
      else
        write (iw, '(1X,2/12X,"(VALENCIES)   BOND ORDERS",/)')
      end if
      allocate (bab(100), ibab(100))
    else
      write (iw, '(1X,2/20X,''BOND ORDERS AND VALENCIES'')')
      sumlim = -1.d0
      i = (nl_atoms*(nl_atoms + 1))/2
      allocate (bab(i), l_atom_store(nl_atoms))
    end if
    newl = 0
    l = 0
    do i = 1, numat
    if ( .not. mozyme_style .and.  .not. l_atom(i)) cycle
      newl = newl + 1
      valenc = 0.d0
      io = iorbs(i)
      if (mozyme_style) then
          j_lim = numat
          l = 0
        else
          j_lim = i - 1
        end if
      if (nat(i) /= 1 .or. lall) then
        if (io == 1) then
          kk = ijbo (i, i) + 1
          valenc = 2.d0 * p(kk) - p(kk) ** 2
        else
          kk = ijbo (i, i)
          do j = 1, iorbs(i)
            do k = 1, j
              kk = kk + 1
              valenc = valenc - 2.d0*p(kk) * p(kk)
            end do
            valenc = valenc + p(kk) * p(kk)
            valenc = valenc + 2.d0 * p(kk)
          end do
        end if
        do j = 1, j_lim
          if ( .not. mozyme_style .and.  .not. l_atom(j)) cycle
          if (nat(j) /= 1 .or. lall) then
            jo = iorbs(j)
            if (i /= j .and. ijbo (i, j) >= 0) then
              kl = ijbo (i, j) + 1
              ku = kl + io * jo - 1
              sum = 0.d0
              do k = kl, ku
                sum = sum + p(k) ** 2
              end do
              if (sum > sumlim) then
                l = l + 1
                bab(l) = sum
                if (mozyme_style) ibab(l) = j
              end if
            else
              if ( .not. mozyme_style) then
                l = l + 1
                bab(l) = 0.d0
              end if
            end if
          end if
        end do
        if (mozyme_style) then
          call print_bonds_compact(i,l, valenc, bab, ibab)
        else
          l = l + 1
          bab(l) = valenc
        end if
      end if
    end do
    if ( .not. mozyme_style) then
      l_atom_store = l_atom(:nl_atoms)
      l_atom(:nl_atoms) = .true.
      call vecprt (bab, newl)
      l_atom(:nl_atoms) = l_atom_store
      deallocate (l_atom_store, bab)
    end if
  end subroutine bonds_for_MOZYME
  subroutine print_bonds_compact(i_atom,n_non_zero, valenc, bab, ibab)
!
! Print bonds in a compact form.
! On input: i_atom = atom number
!           n_non_zero = number of non-zero bonds
!
  use molkst_C, only: maxtxt
  use common_arrays_C, only : txtatm,nat
  use elemts_C, only: elemnt
  use chanel_C, only: iw
  implicit none
  double precision, intent (inout) :: bab(100)
  double precision, intent (in) :: valenc
  integer, intent (inout) :: ibab(100)
  integer, intent (in) :: i_atom, n_non_zero
!
  integer :: j, k, m, mtx, nper, ju
  double precision :: sum
  character :: nc*2, blank*60,  f5p3*4 = "f5.3"
  save :: f5p3
    if (n_non_zero == 0) return
    if (maxtxt /= 0) then
      write(nc,'(i2)')maxtxt + 20
      mtx = maxtxt + 23
      nper = 33
    else
      mtx = 21
      nper = 6
    end if
    blank = " "
    do j = 1, n_non_zero
      m = 0
      sum = 0.d0
      do k = j, n_non_zero
        if (bab(k) > sum) then
          m = k
          sum = bab(k) * (1.d0+1.d-4)
        end if
      end do
      k = ibab(j)
      ibab(j) = ibab(m)
      ibab(m) = k
      sum = bab(j)
      bab(j) = bab(m)
      bab(m) = sum
    end do
    ju = Min (nper, n_non_zero)

    if (maxtxt /= 0) then
      write (iw, "(I6, 1X, A, A, "//f5p3//", A1, F8.3, 2x, a)") i_atom, elemnt (nat(i_atom)) &
      & //"("// txtatm (i_atom)(:maxtxt)//")", "  (", valenc, ")      ", &
      & bab(1), elemnt(nat(ibab(1)))//"("//txtatm(ibab(1))(:maxtxt)//")"
      do j = 2, ju
        write(iw,'('//nc//'x, f8.3, 2x, a)') bab(j), elemnt(nat(ibab(j)))//"("//txtatm(ibab(j))(:maxtxt)//")"
      end do
    else
      write (iw, "(I6,1X,A,A,"//f5p3//",')',6(I6,1x,A2,F6.3))") i_atom, elemnt(nat(i_atom)), &
      "     (", valenc, (ibab(j), elemnt(nat(ibab(j))), &
      & bab(j), j=1, ju)
      do m = nper + 1, n_non_zero, nper
        ju = Min (m+nper-1, n_non_zero)
        write (iw, "(A,6(I6,1x,A2,F6.3))") blank (1:mtx), (ibab(j), &
        & elemnt(nat(ibab(j))), bab(j), j=m, ju)
      end do
    end if
    write (iw,*)
  end subroutine print_bonds_compact

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

submodule (mopac_api) mopac_api_operations
  use Common_arrays_C, only: xparam, grad, lopt
  use molkst_C, only: keywrd, escf, moperr, nvar, jobnam, run, verson
  implicit none

  interface

    ! initialize MOPAC modules before calculations
    module subroutine mopac_initialize(system)
      type(mopac_system), intent(in) :: system
    end subroutine mopac_initialize

    ! extract data from MOPAC modules after calculations
    module subroutine mopac_finalize(properties)
      type(mopac_properties), intent(out) :: properties
    end subroutine mopac_finalize

    ! save MOPAC density matrices
    module subroutine mopac_save(state)
      type(mopac_state), intent(inout) :: state
    end subroutine mopac_save

    ! load MOPAC density matrices, or construct initial guesses
    module subroutine mopac_load(state)
      type(mopac_state), intent(in) :: state
    end subroutine mopac_load

    ! save MOZYME density matrix
    module subroutine mozyme_save(state)
      type(mozyme_state), intent(inout) :: state
    end subroutine mozyme_save

    ! load MOZYME density matrix, or construct initial guess
    module subroutine mozyme_load(state)
      type(mozyme_state), intent(in) :: state
    end subroutine mozyme_load

  end interface

contains

  ! MOPAC electronic ground state calculation
  module subroutine mopac_scf(system, state, properties) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: mopac_scf
#endif
    type(mopac_system), intent(in) :: system
    type(mopac_state), intent(inout) :: state
    type(mopac_properties), intent(out) :: properties

    keywrd = " 1SCF PULAY BONDS"
    if (system%natom_move + system%nlattice_move > 0) keywrd = trim(keywrd) // " GRADIENTS"
    if (state%mpack > 0 .and. state%uhf == 1) keywrd = trim(keywrd) // " UHF"
    call mopac_initialize(system)
    if (.not. moperr) call mopac_load(state)
    ! call computational routine for SCF calculations
    if (.not. moperr) call compfg (xparam, .true., escf, .true., grad, .true.)
    if (.not. moperr) call mopac_save(state)
    call mopac_finalize(properties)
  end subroutine mopac_scf

  ! MOPAC geometry relaxation
  module subroutine mopac_relax(system, state, properties) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: mopac_relax
#endif
    type(mopac_system), intent(in) :: system
    type(mopac_state), intent(inout) :: state
    type(mopac_properties), intent(out) :: properties

    keywrd = " LBFGS PULAY BONDS"
    if (state%mpack > 0 .and. state%uhf == 1) keywrd = trim(keywrd) // " UHF"
    call mopac_initialize(system)
    if (.not. moperr) call mopac_load(state)
    ! call computational routine for LBFGS geometry optimization
    if (.not. moperr) call lbfgs (xparam, escf)
    if (.not. moperr) call mopac_save(state)
    call mopac_finalize(properties)
  end subroutine mopac_relax

  ! MOPAC vibrational calculation
  module subroutine mopac_vibe(system, state, properties) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: mopac_vibe
#endif
    type(mopac_system), intent(in) :: system
    type(mopac_state), intent(inout) :: state
    type(mopac_properties), intent(out) :: properties
    integer :: i

    keywrd = " FORCETS PULAY BONDS"
    if (state%mpack > 0 .and. state%uhf == 1) keywrd = trim(keywrd) // " UHF"
    call mopac_initialize(system)
    if (.not. moperr) call mopac_load(state)
    ! call computational routine to evaluate vibrational matrix
    if (.not. moperr) call force()
    ! recompute nvar because it is zero'd after vibrational calculations
    if (.not. moperr) then
      nvar = 0
      do i=1, system%natom+system%nlattice
        if (lopt(1,i) == 1) nvar = nvar + 3
      end do
    end if
    ! call computational routine for standard properties calculations
    if (.not. moperr) call compfg (xparam, .true., escf, .true., grad, .true.)
    if (.not. moperr) call mopac_save(state)
    call mopac_finalize(properties)
  end subroutine mopac_vibe

  ! MOZYME electronic ground state calculation
  module subroutine mozyme_scf(system, state, properties) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: mozyme_scf
#endif
    type(mopac_system), intent(in) :: system
    type(mozyme_state), intent(inout) :: state
    type(mopac_properties), intent(out) :: properties

    keywrd = " MOZYME 1SCF ALLBONDS"
    if (system%natom_move + system%nlattice_move > 0) keywrd = trim(keywrd) // " GRADIENTS"
    call mopac_initialize(system)
    if (.not. moperr) call mozyme_load(state)
    ! call computational routine for SCF calculations
    if (.not. moperr) call compfg (xparam, .true., escf, .true., grad, .true.)
    if (.not. moperr) call mozyme_save(state)
    call mopac_finalize(properties)
  end subroutine mozyme_scf

  ! MOZYME geometry relaxation
  module subroutine mozyme_relax(system, state, properties) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: mozyme_relax
#endif
    type(mopac_system), intent(in) :: system
    type(mozyme_state), intent(inout) :: state
    type(mopac_properties), intent(out) :: properties

    keywrd = " MOZYME LBFGS ALLBONDS"
    call mopac_initialize(system)
    if (.not. moperr) call mozyme_load(state)
    ! call computational routine for LBFGS geometry optimization
    if (.not. moperr) call lbfgs (xparam, escf)
    if (.not. moperr) call mozyme_save(state)
    call mopac_finalize(properties)
  end subroutine mozyme_relax

  ! MOZYME vibrational calculation
  module subroutine mozyme_vibe(system, state, properties) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: mozyme_vibe
#endif
    type(mopac_system), intent(in) :: system
    type(mozyme_state), intent(inout) :: state
    type(mopac_properties), intent(out) :: properties
    integer :: i

    keywrd = " MOZYME FORCETS PULAY BONDS"
    call mopac_initialize(system)
    if (.not. moperr) call mozyme_load(state)
    ! call computational routine to evaluate vibrational matrix
    if (.not. moperr) call force()
    ! recompute nvar because it is zero'd after vibrational calculations
    if (.not. moperr) then
      nvar = 0
      do i=1, system%natom+system%nlattice
        if (lopt(1,i) == 1) nvar = nvar + 3
      end do
    end if
    ! call computational routine for standard properties calculations
    if (.not. moperr) call compfg (xparam, .true., escf, .true., grad, .true.)
    if (.not. moperr) call mozyme_save(state)
    call mopac_finalize(properties)
  end subroutine mozyme_vibe

  ! Run MOPAC conventionally from an input file
  module function run_mopac_from_input(path_to_file) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: run_mopac_from_input
#endif
    interface
      subroutine run_mopac() bind(c)
      end subroutine run_mopac
    end interface
    integer(c_int) :: run_mopac_from_input
    character(kind=c_char), dimension(*), intent(in) :: path_to_file
    integer :: i
    i = 1
    do
      if(path_to_file(i) == ' ' .or. path_to_file(i) == c_null_char) exit
      jobnam(i:i) = path_to_file(i)
      i = i + 1
    end do
    run = 2
    call run_mopac
    if (moperr) then
      run_mopac_from_input = 1
    else
      run_mopac_from_input = 0
    end if
    run = 1
    jobnam = ' '
  end function run_mopac_from_input

  ! Get MOPAC version string
  module subroutine get_mopac_version(version) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: get_mopac_version
#endif
    character(kind=c_char), dimension(*), intent(out) :: version
    integer :: i
    i = 1
    do
      if(verson(i:i) == ' ') exit
      version(i) = verson(i:i)
      i = i + 1
    end do
    version(i) = c_null_char
  end subroutine get_mopac_version

end submodule mopac_api_operations

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine drcout(xyz3, geo3, vel3, nvar, time, escf3, ekin3, etot3, dip3, &
        xtot3, iloop, charge, fract, text1, text2, ii, jloop, l_dipole)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use common_arrays_C, only : na, nb, nc, labels, loc, nat, c, eigs
      use molkst_C, only : natoms, numcal, keywrd, numat, title, koment, line
      use maps_C, only : rxn_coord, rc_escf, ekin, rc_dipo
      use elemts_C, only : elemnt
      use chanel_C, only : iw
      implicit none
      integer, intent(in) :: nvar, iloop, ii
      integer, intent(inout) :: jloop
      double precision, intent(in) :: time, fract
      character, intent(in) :: text1*3, text2*2
      double precision, intent(in) :: xyz3(3,3*numat), geo3(3,3*numat), vel3(3,3*numat), &
        escf3(3), ekin3(3), etot3(3), dip3(3), xtot3(3), charge(natoms)
      logical, intent (in) :: l_dipole
!
      integer, dimension(3) :: iel1
      integer :: i, icalcn, iprint, l, j, ivar, k
      double precision, dimension(3,numat) :: xyz, vel
      double precision, dimension(3) :: gg
      double precision :: etot, errr, last_point, last_rxn_coord = 10.d0
      logical :: drc, large, graph, run_local
      character :: alpha*2, frmat*1
      double precision, external :: reada
      save i, drc, icalcn, iprint, large, graph, &
        run_local, last_point
!************************************************************
!                                                           *
!    DRCOUT PRINTS THE GEOMETRY, ETC. FOR A DRC AT A        *
!    POSITION DETERMINED BY FRACT.                          *
!    ON INPUT XYZ3  = QUADRATIC EXPRESSION FOR THE GEOMETRY *
!             VEL3  = QUADRATIC EXPRESSION FOR THE VELOCITY *
!             ESCF3 = QUADRATIC EXPRESSION FOR THE P.E.     *
!             EKIN3 = QUADRATIC EXPRESSION FOR THE K.E.     *
!                                                           *
!************************************************************
      data icalcn/ 0/
      if (icalcn /= numcal) then
        icalcn = numcal
        last_point = -1.d8
        graph = (index(keywrd,' GRAPH') /= 0)
        run_local = (index(keywrd,' LOCAL') + index(keywrd,' RABBIT') + index(keywrd,' BANANA') /= 0)
        if (index(keywrd,'RESTART') == 0 .or. index(keywrd,'IRC=') /= 0) jloop = 0
        drc = index(keywrd,' DRC') /= 0
        i = index(keywrd,'LARGE')
        iprint = 10000
        large = .FALSE.
        if (i /= 0) then
          iprint = 1
          i = i + 5
          large = keywrd(i:i) == ' ' .or. keywrd(i+1:i+1) == '-'
          if (keywrd(i:i) == '=') iprint = nint(abs(reada(keywrd,i)))
        end if
      end if
      if (drc) then
!
! Sanity check - don't print two points that are the same.
!
        if (Abs(last_point - time) < 5.d-4) then
          return
        else
          last_point = time
        end if
      end if
      jloop = jloop + 1
      rc_escf = escf3(1) + escf3(2)*fract + escf3(3)*fract**2
      rc_dipo = dip3(1) + dip3(2)*fract + dip3(3)*fract**2
      ekin = ekin3(1) + ekin3(2)*fract + ekin3(3)*fract**2
      etot = etot3(1) + etot3(2)*fract + etot3(3)*fract**2
      rxn_coord = xtot3(1) + xtot3(2)*fract + xtot3(3)*fract**2
      if (.not. drc) then
!
! Sanity check - don't print two points that are the same.
!
        if (Abs(rxn_coord - last_rxn_coord) < 1.d-7) then
          jloop = jloop - 1
          return
        else
          last_rxn_coord = rxn_coord
        end if
      end if
      if (jloop==0 .or. (jloop/iprint)*iprint==jloop) then
        if (drc) then
          write (line, '('' FEMTOSECONDS  POINT  POTENTIAL + KINETIC  =   TOTAL     ERROR    REF%   MOVEMENT'')')
        else
          write (line, '(''     POINT   POTENTIAL  +  ENERGY LOST   =   TOTAL      ERROR    REF%   MOVEMENT'')')
        end if
        write(iw,'(2/,a)')trim(line)
      end if
      errr = min(9999.99999D0,max(-999.99999D0,rc_escf + ekin - etot))
      if (rc_escf > 99999.d0 .or. rc_escf < -9999.d0) then
        frmat = "3"
      else if (rc_escf > 9999.d0 .or. rc_escf < -999.d0) then
        frmat = "4"
      else
        frmat = "5"
      end if
      if (ii /= 0) then
        if (drc) then
          write (line, &
      '(F10.3,I8,F12.'//frmat//',F11.5,F12.'//frmat//', F10.5,'' '',I5,3X,''%'&
      &',A,A,I3)') time, iloop - 2, rc_escf, ekin, rc_escf + ekin, errr, jloop, text1, text2, ii
        else
          write (line, &
      '(I8,F14.'//frmat//',F13.5,F17.5,F10.5,I6,''   %'',A,A,I3)') &
      iloop - 2, rc_escf, ekin, rc_escf + ekin, errr, jloop, text1, text2, ii
        end if
      else
        if (drc) then
          if (text1 == ' ' .and. text2 == ' ') then
            write (line, &
      '(F10.3,I8,F12.'//frmat//',F11.5,F12.'//frmat//',F10.5,'' '',I5,3X,''%'',F8.4)') &
      time, iloop - 2, rc_escf, ekin, rc_escf + ekin, errr, jloop, rxn_coord
          else
            write (line, &
      '(F10.3,I8,F12.'//frmat//',F11.5,F12.'//frmat//',F10.5,'' '',I5,3X,''%'',A,A,I3)') &
      time, iloop - 2, rc_escf, ekin, rc_escf + ekin, errr, jloop, text1, text2
          end if
        else
          if (text1 == ' ' .and. text2 == ' ') then
            write (line, &
      '(I8,F14.'//frmat//',F13.5,F17.5,F10.5,'' '',I5,3X,''%'',F8.4)') &
      iloop - 2, rc_escf, ekin, rc_escf + ekin, errr, jloop, rxn_coord
          else
            write (line, &
      '(I8,F14.'//frmat//',F13.5,F17.5,F10.5,'' '',I5,3X,''%'',A,A,I3)') &
      iloop - 2, rc_escf, ekin, rc_escf + ekin, errr, jloop, text1, text2
          end if
        end if
      end if
      if (index(keywrd," LDRC_FIRST") /= 0) then
!
!   This is very poor code, and will become buggy if the formats are changed.
!
        if (drc) then
          line = line(:16)//" "//line(18:53)//"   0.00000     1   %  0.0000"
        else
          line = line(:6)//" "//line(8:52)//"   0.00000     1   %  0.0000"
        end if
        jloop = 0
      end if
      write(iw,'(a)')trim(line)
      call to_screen(line)
      l = 0
      do i = 1, nvar/3
        vel(:,i) = vel3(1,l+1:3+l) + vel3(2,l+1:3+l)*fract + vel3(3,l+1:3+l)*fract**2
        xyz(:,i) = xyz3(1,l+1:3+l) + xyz3(2,l+1:3+l)*fract + xyz3(3,l+1:3+l)*fract**2
        l = 3 + l
      end do
      if (graph) then
        if (run_local)  call local (c, i, eigs, 0, "c ")
        call mullik ()
      end if
      call to_screen("To_file: IRC-DRC")
      if (index(keywrd," LDRC_FIRST") /= 0) then
        call l_control("LDRC_FIRST", len("LDRC_FIRST"), -1)
        jloop = 1
      end if
      if (large .and. (jloop/iprint)*iprint==jloop) then
        write (iw, '(A)') &
          '                CARTESIAN GEOMETRY           VELOCITY (IN CM/SEC)'
        write (iw, '(A)') &
      '  ATOM        X          Y          Z                X          Y          Z'
        do i = 1, numat
          write (iw, '(I4,3X,A2,3F11.5,2X,3F11.1)') i, elemnt(nat(i)), &
          (xyz(j,i),j=1,3), (-vel(j,i),j=1,3)
        end do
      end if
!
!   Write out trajectory for graphics
!
      if (drc) then
        call write_trajectory(xyz, rc_escf, ekin, rc_dipo, time, rxn_coord, l_dipole)
      else
        call write_trajectory(xyz, rc_escf, errr, rc_dipo, 0.d0, rxn_coord, l_dipole)
      end if
      if ((jloop/iprint)*iprint == jloop) then
        ivar = 1
        l = 0
        write (iw, '(2/10X,''FINAL GEOMETRY OBTAINED'',33X,''CHARGE'')')
        write (iw, '(A)') trim(keywrd), trim(koment), trim(title)
        l = 0
        do i = 1, numat
          j = i/26
          alpha(1:1) = char(ichar('A') + j)
          j = i - j*26
          alpha(2:2) = char(ichar('A') + j - 1)
          iel1 = 0
  110     continue
          if (loc(1,ivar) == i) then
            iel1(loc(2,ivar)) = 1
            ivar = ivar + 1
            go to 110
          end if
          if (i < 4) then
            iel1(3) = 0
            if (i < 3) then
              iel1(2) = 0
              if (i < 2) iel1(1) = 0
            end if
          end if
          if (labels(i) < 99 .or. labels(i) > 102 .and. labels(i) < 107) then
            l = l + 1
            gg(1) = geo3(1,i*3-2) + geo3(2,i*3-2)*fract + geo3(3,i*3-2)*fract**2
            gg(2) = geo3(1,i*3-1) + geo3(2,i*3-1)*fract + geo3(3,i*3-1)*fract**2
            gg(3) = geo3(1,i*3) + geo3(2,i*3)*fract + geo3(3,i*3)*fract**2
            write (iw, '(2X,A2,3(F12.6,I3),I4,2I3,F10.4,I8,A)') elemnt(labels(i)), &
             (gg(k),iel1(k),k=1,3), na(i), nb(i), nc(i), charge(l), jloop, alpha//'*'
          else
            write (iw, '(2X,A2,3(F12.6,I3),I4,2I3,10X,I8,A)') elemnt(labels(i)), &
            (gg(k),iel1(k),k=1,3), na(i), nb(i), nc(i), jloop, alpha//'%'
          end if
        end do
      end if
      return
      end subroutine drcout

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      double precision function capcor (nat, nfirst, nlast, p, h)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : numat
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: nat(numat)
      integer , intent(in) :: nfirst(numat)
      integer , intent(in) :: nlast(numat)
      double precision , intent(in) :: p(*)
      double precision , intent(in) :: h(*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, ni, il, iu, j, ii, k, jl, kk
      double precision :: sum
!-----------------------------------------------
!*****************************************************************
!
!    CORRECTION TO ELECTRONIC ENERGY DUE TO CAPPED BONDS
!
!*****************************************************************
      sum = 0.D0
      do i = 1, numat
        ni = nat(i)
        il = nfirst(i)
        iu = nlast(i)
        if (ni == 102) then
!
!   DO ENTIRE ROW - NO NEED TO CHECK FURTHER.
!
          j = (nlast(i)*(nlast(i)+1))/2
          ii = iu - 1
          do k = 1, ii
            j = j - 1
            sum = sum + p(j)*h(j)
          end do
        else
          do j = 1, i
            jl = nfirst(j)
            if (nat(j) /= 102) cycle
            do k = il, iu
              kk = (k*(k - 1))/2 + jl
              sum = sum + p(kk)*h(kk)
            end do
          end do
        end if
      end do
!
!   DOUBLE SUM SINCE WE ONLY CALCULATED LOWER HALF, AND CAPCOR
!   WILL APPEAR IN 1/2*P(H+F).  ONLY H PART OF F WILL BE USED.
      capcor = -sum*2.D0
      return
      end function capcor

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine surfac (nvecs, fcells)
!
  use common_common, only : id, phonon, ir, iw, jobnam, data_set_name, iw_new, line, &
    l_read_dat, top_l, top_r, bottom_l, bottom_r, grid, isurf
  implicit none
!
!  npts should be odd, so that the system has a center.
!
  integer, parameter :: npts = 81
  integer, intent(in) :: nvecs
  double precision, dimension(nvecs, *), intent(in) :: fcells
!
  complex, allocatable, dimension(:) :: v
  integer :: i, i99, iok, irow, j, k, mpts, npts2, nmax, nmin, l
  double precision :: ca, cb, cntval, cx, cy, cz, px, py, pz, r1, range, &
       & sa, sb, size, step, x, x2, xmax, xmin, xy, y2, eigs(2*nvecs), &
       xyzc(3), xyzp(3), top(3), bottom(3), stepx, stepy, xyz(3), &
       temp_ima(6),  maxima(6,1000), minima(6,1000), store_xyzc(3)
  logical :: first = .true., opend, exists
  character :: q*1, graph_name*200
  double precision, allocatable :: onebnd(:)
  external sleep
! 
!.. Equivalences .. 
  equivalence (xyzp(3), pz), (xyzp(2), py), (xyzp(1), px)
  equivalence (xyzc(3), cz), (xyzc(2), cy), (xyzc(1), cx)
  allocate(grid(npts,npts,nvecs), v(nvecs**2))
  allocate(onebnd((npts*2)**2))
! 
! ... Executable Statements ...
! 
  step = 1.0d0 / (npts-1)
  iok = 1
  inquire (file=jobnam(:len_trim(jobnam))//".bnd", exist = exists)
  if (exists) then
    write (iw, *) "Start a new surface [1], or use an old one [2]?"
    read(6, '(a)',  iostat=i) line
    if (.not. l_read_dat .and. index(line, ": Enter k-space") /= 0) then
      rewind (ir)
      read(ir, '(a)',  iostat=i) line
    else       
      line(20:) = ": Start a new surface [1], or use an old one [2]?"
      call write_keystrokes(line, len_trim(line)) 
      read(line, *) iok
      if (iok == 1 .and. .not. l_read_dat) then
        rewind (ir)
        read(ir,*,  iostat=i) line
      end if 
    end if        
  end if
  call graphics (0.0, 0.0, 6)
  if (iok == 2) then
    i = len_trim(jobnam) 
    open (unit = 17, file = jobnam(:i)//".bnd", status = "OLD", &
         & form = "FORMATTED", iostat = i99)
    if (i99 /= 0) then
      write (iw, *) " Failed to read data. "
      write(iw,*)" Press return to exit"
      read(5,'(a)') q
      call graphics(0.0, 0.0, 100)
      stop
    end if
    do i = 1, 5
      read(17,*)q
    end do
    read(17,"(3f12.5)")px, py, pz
    read(17,"(3f12.5)")store_xyzc
    read(17,"(f12.5)")size
    write(iw,"(3f12.5,a)")px, py, pz, " = center of plot"
    write(iw,"(3f12.5,a)")store_xyzc, " = vector perpendicular to plot"
    write(iw,"(/,f12.5,a)")size, " = length from center to the middle of one edge, in reciprocal space units"
    read(17,*)q
    read(17,*)top_l
    read(17,*)top_r
    read(17,*)bottom_l
    read(17,*)bottom_r
    read(17,*)i,j
    read (17,"(8f10.4)")  (((grid(i, j, k), i = 1, npts), j = 1, npts), k = 1,nvecs)
  else
    do k = 1, 10
      write (iw, '(a,i2,a)') "Enter k-space coordinates for the center of the plot,", id, " numbers"
      read (6, "(Q,A)", iostat = j)i, line 
      read(line,*, iostat = j) px, py, pz
      if (j == 0) exit
      i = len_trim(line)
      line(20:) = ": Enter k-space coordinates for the center of the plot"
      call write_keystrokes(line, len_trim(line)) 
      read(line,*, iostat = j)(xyzp(i), i = 1, id)
      if (j == 0) exit
    end do
    do k = 1, 10
      if (id == 3) then
        write (iw, '(a,i2,a)') "Enter vector perpendicular to plot,", id, " numbers"
        read(6, '(a80)', iostat = j) line
        i = len_trim(line)
        line(20:) = ": Enter vector perpendicular to plot"
        call write_keystrokes(line, len_trim(line)) 
        read(line, *, iostat = j) (xyzc(i), i = 1, id)
        if (j == 0) exit
      else
        xyzc(1) = 0.d0
        xyzc(2) = 0.d0
        xyzc(3) = 1.d0
        exit
      end if
    end do
    store_xyzc = xyzc
    if (abs(xyzc(1)) + abs(xyzc(2)) + abs(xyzc(3)) < 1.d-4) &
      write(iw,'(a,/)')" By default, the vector (0.0,0.0,1.0) will be used"
    do k = 1, 10
      write(iw, '(a)') "Enter length from center to the middle of one edge in "
      write(iw,'(a)') "reciprocal space units (typically 1.0)"
      read(6, '(a80)', iostat = j) line
       i = len_trim(line)
       line(20:) = ": Enter length from center to the middle of one edge in reciprocal space units"
      call write_keystrokes(line, len_trim(line)) 
      read(line, *, iostat = j) size
      if (size < 1.d-4) cycle
      if (j == 0) exit
    end do
!
! CALCULATE DIRECTION COSINES AND SINES.
!
    if (Abs (cx) + Abs (cy) < 1.d-5) cz = 1.d0
    xy = cx*cx + cy*cy
    if (xy > 1.d-15) then
      r1 = Sqrt (xy + cz*cz)
      xy = Sqrt (xy)
      ca = cx/xy
      cb = cz/r1
      sa = cy/xy
      sb = xy/r1
    else
      ca = 1.d0
      cb = 1.d0
      sa = 0.d0
      sb = 0.d0
    end if
    step = 2.d0*size/(npts - 1.d0)
    do i = 1, npts
      x2 = -size + (i - 1)*step
      if (mod(i,10) == 0) write (iw, *) "Raster line", i, " done,", npts-i, " left"
      do j = 1, npts
        y2 = -size + (j-1)*step
        cx = ca*cb*x2 - sa*y2 + px
        cy = sa*cb*x2 + ca*y2 + py
        cz = -sb*x2 + pz
        call rot (xyzc)
        call kpoint (fcells, nvecs, cx, cy, cz, v, eigs)
        do k = 1, nvecs
          grid(npts - i + 1,  j, k) = eigs(k)
        end do
      end do
    end do
    i = len_trim(jobnam)
    if (abs(px) > 1.d4 .or. abs(px) > 1.d4 .or. abs(px) > 1.d4) then
      write(iw,'(//10x,a)')"Data for writing the file "//jobnam(1:i)//".bnd are faulty"
      write(iw,'(10x,a)')"The current job will be halted as no useful results can be made"
      write(iw,'(/5x,a)')"Press ""RETURN"" to quit"
      read(6,'(a)', iostat = i99) q
      call graphics(0.0, 0.0, 100)
      stop
    end if
    bottom_r(1) = ca*cb*( size) - sa*(-size) + px
    bottom_r(2) = sa*cb*( size) + ca*(-size) + py
    bottom_r(3) =   -sb*( size)              + pz
    bottom_l(1) = ca*cb*(-size) - sa*(-size) + px
    bottom_l(2) = sa*cb*(-size) + ca*(-size) + py
    bottom_l(3) =   -sb*(-size)              + pz
    top_r(1) = ca*cb*( size) - sa*( size) + px
    top_r(2) = sa*cb*( size) + ca*( size) + py
    top_r(3) =   -sb*( size)              + pz
    top_l(1) = ca*cb*(-size) - sa*( size) + px
    top_l(2) = sa*cb*(-size) + ca*( size) + py
    top_l(3) =   -sb*(-size)              + pz
    open (unit = 17, file = jobnam(:i)//".bnd", status = "UNKNOWN", &
         & form = "FORMATTED", iostat = i99)
    write(17,"(2a)", iostat = i99)" Brillouin Zone Cross Sections for system: ",jobnam(1:i)
    if (i99 == 0) then
      if( phonon ) then
        write(17,'(A)')" Values of Energy Level, in cm**(-1) for the ", &
        & " Different Vibrational Bands (generated by BZ)"
      else
        write(17,'(a)')" Values of Energy Level, in eV for the ", &
        & " Different Electronic Bands (generated by BZ)"
      end if
      write(17,"(a,i4,a)")" There are",npts," points on each edge of the square"
      write(17,"(a,i4,a)")" There are",nvecs," squares (surfaces)"
      write(17,"(3f12.5,a)")px, py, pz, " = center of plot"
      write(17,"(3f12.5,a)")store_xyzc, " = vector perpendicular to plot"
      write(17,"(f12.5,a)")2*size, " = length of one edge in reciprocal space units"
      write(17,*)" (Gamma to nearest other Gamma is one unit)"
      write(17,"(3f12.5,a)")top_l, " = top left"
      write(17,"(3f12.5,a)")top_r, " = top right"
      write(17,"(3f12.5,a)")bottom_l, " = bottom left"
      write(17,"(3f12.5,a)")bottom_r, " = bottom right"
      write(17,*)npts, nvecs
      write (17,"(8f10.4)")  (((grid(i, j, k), i = 1, npts), j = 1, npts), k = 1, nvecs)
      write(17,"(3f12.5,a)")top_l, " = top left"
      write(17,"(3f12.5,a)")top_r, " = top right"
      write(17,"(3f12.5,a)")bottom_l, " = bottom left"
      write(17,"(3f12.5,a)")bottom_r, " = bottom right"
      write(17,*)npts, nvecs
      write (17,"(8f10.4)")  (((grid(i, j, k), i = 1, npts), j = 1, npts), k = 1, nvecs)
    end if
  end if
  q = char(ichar("1") + int(log10(nvecs*1.0)))
  outer_loop: do 
    do
      if(l_read_dat) write (iw, "(A,I"//q//",a)") "Pick an energy surface in the range 1 - ", nvecs, &
        ", 0 to stop"
      read(ir, '(a80)', iostat = j) line
      if (j /= 0) goto 50
      if (.not. l_read_dat .and. index(line, ": Pick an") == 0) cycle
      i = len_trim(line)
      write(line(20:),'(a,i'//q//',a)')": Pick an energy surface in the range 1 - ", nvecs, ", 0 to stop"
      call write_keystrokes(line, len_trim(line)) 
      read(line, *, end = 50, err = 50) isurf
      if (isurf > nvecs .or. isurf < 1) then
        if (isurf /= 0) then
          write(iw,'(a)') "To stop, enter ""0"", otherwise enter the surface to be drawn"
          cycle
        else
          exit outer_loop
        end if
      end if
      if(l_read_dat) write (iw, "(//,A,I"//q//",/)") " Drawing energy surface No.",isurf
!
!   Extract band from grid array
!
      npts2 = 2*npts - 1
      onebnd = 0.d0
      do i = npts, 1, -1
        do j = npts, 1, -1
          onebnd((2*i - 2)*npts2 + 2*j - 1) = grid(i, j, isurf)
        end do
      end do
!
!  Find turning points
!
      nmax = 0
      nmin = 0
      do i = 2, npts - 1
        do j = 2, npts - 1
          x = grid(i,j,isurf)
!
!  Work hard to avoid spurious maxima and minima
!
          if ( x > grid(i-1,j,isurf)   .and. x > grid(i+1,j,isurf) .and. &
          &    x > grid(i,j-1,isurf)   .and. x > grid(i,j+1,isurf)) then
          if ( x > grid(i-1,j+1,isurf) .and. x > grid(i+1,j-1,isurf) .and. &
             & x > grid(i-1,j-1,isurf) .and. x > grid(i+1,j+1,isurf)) then
!
!  Point x is near to a maximum
!
              x2 = 0.5d0*(grid(i-1,j,isurf) - grid(i+1,j,isurf)) / &
              & (grid(i-1,j,isurf) + grid(i+1,j,isurf) - 2.d0*grid(i,j,isurf))
              stepx = 1.d0 - (i-1+x2)/(npts-1)
              y2 = 0.5d0*(grid(i,j-1,isurf) - grid(i,j+1,isurf)) / &
              & (grid(i,j-1,isurf) + grid(i,j+1,isurf) - 2.d0*grid(i,j,isurf))
              stepy = 1.d0 - (j-1+x2)/(npts-1)
              nmax = Min(nmax + 1, 1000)
              maxima(1:3,nmax) = top_l(:) - stepx*(top_l(:) - top_r(:)) - stepy*(top_l(:) - bottom_l(:))
              maxima(4,nmax) = x + 0.5d0*(grid(i,j-1,isurf) - grid(i,j+1,isurf))*x2 &
              & + 0.5d0*(grid(i,j-1,isurf) + grid(i,j+1,isurf) - 2.d0*grid(i,j,isurf))*x2**2
            end if
          end if
   
          if ( x < grid(i-1,j,isurf)   .and. x < grid(i+1,j,isurf) .and. &
          &    x < grid(i,j-1,isurf)   .and. x < grid(i,j+1,isurf)) then
            if ( x < grid(i-1,j+1,isurf) .and. x < grid(i+1,j-1,isurf) .and. &
             &   x < grid(i-1,j-1,isurf) .and. x < grid(i+1,j+1,isurf)) then
!
!  Point x is near to a minimum
!
              x2 = 0.5d0*(grid(i-1,j,isurf) - grid(i+1,j,isurf)) / &
              & (grid(i-1,j,isurf) + grid(i+1,j,isurf) - 2.d0*grid(i,j,isurf))
              stepx = 1.d0 - (i-1+x2)/(npts-1)
              y2 = 0.5d0*(grid(i,j-1,isurf) - grid(i,j+1,isurf)) / &
              & (grid(i,j-1,isurf) + grid(i,j+1,isurf) - 2.d0*grid(i,j,isurf))
              stepy = 1.d0 - (j-1+x2)/(npts-1)
              nmin = Min(nmin + 1, 1000)
              minima(1:3,nmin) = top_l(:) - stepx*(top_l(:) - top_r(:)) - stepy*(top_l(:) - bottom_l(:)) 
              minima(4,nmin) = x + 0.5d0*(grid(i,j-1,isurf) - grid(i,j+1,isurf))*x2 &
              & + 0.5d0*(grid(i,j-1,isurf) + grid(i,j+1,isurf) - 2.d0*grid(i,j,isurf))*x2**2
              minima(5,nmin) = stepx
              minima(6,nmin) = stepy
              continue
            end if
          endif
        end do
      end do
!
!  Eliminate maxima that are near to each other.
!
      do
        l = 0
        do i = 2, nmax
          if(maxima(4,i) < -999.d0) cycle
          do j = 1, i - 1
            if(maxima(4,j) < -999.d0) cycle
            step = (maxima(1,i) -  maxima(1,j))**2 + &
                 & (maxima(2,i) -  maxima(2,j))**2 + &
                 & (maxima(3,i) -  maxima(3,j))**2
            if (step < 0.025d0) then
              l = k
              if (maxima(4,i) > maxima(4,j)) then
                maxima(4,j) = -1000.d0
              else
                maxima(4,i) = -1000.d0
              end if                   
            end if
          end do
        end do
        if (l == 0) exit
      end do
      j = 0
      do i = 1, nmax
        if (maxima(4,i) > -999.d0) then
          j = j + 1
          maxima(1:4,j) = maxima(1:4,i)
        end if
      end do
      nmax = j
!
!  Eliminate minima that are near to each other.
!
      do
        l = 0
        do i = 2, nmin
          if(minima(4,i) < -999.d0) cycle
          do j = 1, i - 1
            if(minima(4,j) < -999.d0) cycle
            step = (minima(1,i) -  minima(1,j))**2 + &
                 & (minima(2,i) -  minima(2,j))**2 + &
                 & (minima(3,i) -  minima(3,j))**2
            if (step < 0.025d0) then
              l = k
              if (minima(4,i) < minima(4,j)) then
                minima(4,j) = -1000.d0
              else
                minima(4,i) = -1000.d0
              end if                   
            end if
          end do
        end do
        if (l == 0) exit
      end do
      j = 0
      do i = 1, nmin
        if (minima(4,i) > -999.d0) then
          j = j + 1
          minima(:,j) = minima(:,i)
        end if
      end do
!
!  Sort into decreasing order
!
      nmin = j
      do i = 1, nmax
        do j = i + 1, nmax
          if(maxima(4,j) > maxima(4,i)) then
            temp_ima(:) = maxima(:,j)
            maxima(:,j) = maxima(:,i)
            maxima(:,i) = temp_ima(:)
          end if
        end do
      end do
!
! Sort into increasing order
!
      do i = 1, nmin
        do j = i + 1, nmin
          if(minima(4,j) < minima(4,i)) then
            temp_ima(:) = minima(:,j)
            minima(:,j) = minima(:,i)
            minima(:,i) = temp_ima(:)
          end if
        end do
      end do
      write(line,'(a,a,i2.2,a)')trim(data_set_name)," surface number ",isurf," notes.txt"
      inquire(unit=iw_new, opened=opend) 
      if (opend) close (iw_new)
      open(unit = iw_new, file = trim(line))
      if( nmax > 0 )then
        if(nmax == 1) then
          write(iw,'(/19x,a)')"Maximum in plot"
          write(iw_new,'(/19x,a)', iostat = i99)"Maximum in plot"
        else
          write(iw,'(/19x,a)')"Maxima in plot"
          write(iw_new,'(/19x,a)', iostat = i99)"Maxima in plot"
        end if
        write(iw,"(a)")"       kx          ky          kz           Value"
        write(iw_new,"(a)", iostat = i99)"       kx          ky          kz           Value"
        do i = 1,nmax
          write(iw,    "(3f12.4,f14.4)")maxima(1:4,i)
          write(iw_new,"(3f12.4,f14.4)", iostat = i99)maxima(1:4,i)
        end do
      end if
      if( nmin > 0 ) then
        if(nmin == 1) then
          write(iw,'(/19x,a)')"Minimum in plot"
          write(iw_new,'(/19x,a)', iostat = i99)"Minimum in plot"
        else
          write(iw,'(/19x,a)')"Minima in plot"
          write(iw_new,'(/19x,a)', iostat = i99)"Minima in plot"
        end if
        write(iw,"(a)")"       kx          ky          kz          Value"
        write(iw_new,"(a)", iostat = i99)"       kx          ky          kz          Value"
        do i = 1,nmin
          write(iw,"(3f12.4,f14.4,f18.4,f14.4)")minima(:4,i)
          write(iw_new,"(3f12.4,f14.4)", iostat = i99)minima(1:4,i)
        end do
      end if
!
!   Double up mesh.  Array was NPTS, increase it to 2*NPTS-1
!
      mpts = npts*2 - 1
      do i = 1, mpts, 2
        irow = (i-1) * mpts
        onebnd(irow+2) = 0.5d0 * (onebnd(irow+1)+onebnd(irow+3))
        onebnd(i*mpts-1) = 0.5d0 * (onebnd(i*mpts)+onebnd(i*mpts-2))
        do j = 3, mpts-4, 2
          onebnd(irow+j+1) = 0.0625d0 * &
               & (-onebnd(irow+j-2)-onebnd(irow+j+4) + &
               & 9.d0 * (onebnd(irow+j)+onebnd(irow+j+2)))
        end do
      end do
      npts2 = mpts * mpts
      do i = 1, mpts
        onebnd(i+mpts) = 0.5d0 * (onebnd(i)+onebnd(i+mpts*2))
        onebnd(i+npts2-2*mpts) = 0.5d0 * &
             & (onebnd(i+npts2-mpts)+onebnd(i+npts2-3*mpts))
        do j = 3, mpts-4, 2
          onebnd(i+j*mpts) = 0.0625d0 * &
               & (-onebnd(i+(j-1)*mpts)-onebnd(i+(j+3)*mpts) + &
               & 9.d0*(onebnd(i+ (j-1)*mpts)+onebnd(i+ (j+1)*mpts)))
        end do
      end do
!
!   Determine maximum and minimum contours, and step size.
!
      xmin = 1.d10
      xmax = -1.d10
      do i = 1, npts2
        xmin = Min (xmin, onebnd(i))
        xmax = Max (xmax, onebnd(i))
      end do
      range = xmax - xmin
!
!   Determine a suitable step-size
!
      i = Int(Log10(range) + 10.d0) - 10
      step = range*10.d0**(-i)
      i = i-1
      if (step > 5) then
        step = 2.d0*10.d0**i
      else if (step > 2.d0) then
        step = 1.d0*10.d0**i
      else
        step = 0.5d0*10.d0**i
      end if
      cntval = step * Int (xmin/step) - step
      if (first) then
! 
!  One-time setup
!
       first = .false.
      end if
!
!  INITIALIZE & SET-UP FOR NEXT PICTURE
!

      call graphics (0.0, 0.0, 6)
      call graphics (0.0, 0.0, 99)
      write(iw,"(/,3f12.5,a)")top_l, " = top left"
      write(iw,"(3f12.5,a)")top_r, " = top right"
      write(iw,"(3f12.5,a)")bottom_l, " = bottom left"
      write(iw,"(3f12.5,a)")bottom_r, " = bottom right"
      write(iw,"(3f12.5,a)")px, py, pz, " = center"
      write(iw_new,"(/,3f12.5,a)", iostat = i99)top_l, " = top left"
      write(iw_new,"(3f12.5,a)", iostat = i99)top_r, " = top right"
      write(iw_new,"(3f12.5,a)", iostat = i99)bottom_l, " = bottom left"
      write(iw_new,"(3f12.5,a)", iostat = i99)bottom_r, " = bottom right"
      write(iw_new,"(3f12.5,a)", iostat = i99)px, py, pz, " = center"

      if(phonon) then
        write(iw,"(/5x,a,f9.5,a)")"Contour interval = ",step," cm**(-1)"
        write(iw_new,"(/5x,a,f9.5,a)", iostat = i99)"Contour interval = ",step," cm**(-1)"
      else
        write(iw,"(/5x,a,f8.5,a)")"Contour interval = ",step," eV"
        write(iw_new,"(/5x,a,f8.5,a)", iostat = i99)"Contour interval = ",step," eV"
      end if
      write(iw,'(/5x,a,/5x,a,/)')"To exit, click on a point in the window ""Program BZ""", &
      "that is outside the contour map"
      call graphics (0.0, 0.0, 98)  ! Select black
      call graphics (0.0, 0.0, 2)
      call graphics (0.0, 2.0, 3)
      call graphics (2.0, 2.0, 3)
      call graphics (2.0, 0.0, 3)
      call graphics (0.0, 0.0, 3)
      write(line,'(a,i3)')"Band:",isurf
      call graphics (0.90, -0.05, 96) ! Write band number
      write(line,'(a,3f8.3,a)')"(",top_l,")"
      call graphics (0.0, -0.05, 96)  ! Write coordinate of top left
      write(line,'(a,3f8.3,a)')"(",top_r,")"
      call graphics (1.50, -0.05, 96) ! Write coordinate of top right
      write(line,'(a,3f8.3,a)')"(",bottom_l,")"
      call graphics (0.0, 2.02, 96)   ! Write coordinate of bottom left
      write(line,'(a,3f8.3,a)')"(",bottom_r,")"
      call graphics (1.50, 2.02, 96)  ! Write coordinate of bottom right
!
      do i = 1, 1000
        cntval = cntval + step
         if ( cntval > xmax) exit
!
!  Select new color
!
        call graphics(i*1.0, 0.0, 99)
        call cntour (onebnd, mpts, mpts, mpts, 0.d0, cntval, 1, 2, 3, x)
      end do
!
! Draw a box in black
!
      
      call graphics (0.0, 0.0, 98)  ! Select black
      call graphics (0.0, 0.0, 2)
      call graphics (0.0, 2.0, 3)
      call graphics (2.0, 2.0, 3)
      call graphics (2.0, 0.0, 3)
      call graphics (0.0, 0.0, 3)
      do 
        if (line(1:4) == "EXIT") exit
        call sleep(1)
      end do
!
!  Write raw data in a form suitable for use in Microsoft Excel
!
      write(graph_name,'(a,a,i2.2,a)')trim(data_set_name)," surface number ",isurf,".txt"
      write(iw,'(/5x,a)')"Writing suface to file """//trim(graph_name)//""""      
      inquire(unit=18, opened=opend) 
      if (opend) close (18)
      open(unit = 18, file = graph_name)
      write(18,'(8x,200f8.3)')(i*1.d0, i = 1,mpts)
      do i = 1, mpts
        write(18,'(201f8.3)')i*1.d0,(onebnd((i-1)*mpts + j), j = 1, mpts)
      end do
      call sleep(2)
    end do    
  end do outer_loop
50 continue
  if (ir == 99) then
    write(iw,'(/5x,a)')"Press ""RETURN"" to quit"
    read(iw,'(a)', iostat = i99) q
  end if
  call graphics(0.0, 0.0, 100)
  stop
end subroutine surfac

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine dimens(coord, iw)
!
!  Work out the three dimensions of a molecule.
!
!  Dimension 1: The largest distance between any two atoms.
!  Dimension 2: The largest distance in the plane perpendicular to Dimension 1, between any two atoms.
!  Dimension 3: The largest distance in the direction orthogonal to dimensions 1 and 2, between any two atoms.
!
      use molkst_C, only : numat
      use common_arrays_C, only : nat
      use elemts_C, only : elemnt
!***********************************************************************
      implicit none
      integer , intent(in) :: iw
      double precision  :: coord(3,numat)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(3,2) :: ij
      integer :: l, loop, j, k, kmax, lmax, i, kk, ll
      double precision, dimension(3,3) :: c
      double precision, dimension(3) :: dim
      double precision :: x1, y1, z1, rabmax, rmax, r, xy, ca, cb, sa, sb, ymin, &
        ymax, store_coords(3,numat), sum
!-----------------------------------------------
    if (numat == 1) return
    store_coords(:,:numat) = coord(:,:numat)
    rmax = 0.d0
    kmax = 0
    lmax = 0
    do k = 1, numat
      x1 = coord(1, k)
      y1 = coord(2, k)
      z1 = coord(3, k)
      do l = 1, k - 1
        r = (x1-coord(1, l)) ** 2 + (y1-coord(2, l)) ** 2 + (z1-coord(3, l)) ** 2
        if (r > rmax) then
          rmax = r
          kmax = k
          lmax = l
        end if
      end do
    end do
    k = kmax
    l = lmax
   !
   !   Determine vector joining most distant atoms.
   !
    x1 = coord(1, k) - coord(1, l)
    y1 = coord(2, k) - coord(2, l)
    z1 = coord(3, k) - coord(3, l)
   !
   !  Rotate the system so that the most distant atoms have the same
   !  "Z" coordinates.
   !
    xy = x1 ** 2 + y1 ** 2
    r = Sqrt (xy+z1**2)
    xy = Sqrt (xy)
    if (xy < 1.d-10) then
      if (z1 < 0.0d0) then
        ca = -1.d0
        cb = -1.d0
        sa = 0.d0
        sb = 0.d0
      else if (z1 > 0.0d0) then
        ca = 1.d0
        cb = 1.d0
        sa = 0.d0
        sb = 0.d0
      else
        ca = 0.d0
        cb = 0.d0
        sa = 0.d0
        sb = 0.d0
      end if
    else
      ca = x1 / xy
      cb = z1 / r
      sa = y1 / xy
      sb = xy / r
    end if
    c(1, 3) = ca * cb
    c(1, 2) = -sa
    c(1, 1) = ca * sb
    c(2, 3) = sa * cb
    c(2, 2) = ca
    c(2, 1) = sa * sb
    c(3, 3) = -sb
    c(3, 2) = 0.d0
    c(3, 1) = cb
    call symopr (numat, coord, 1, c)

    dim(1) = r
    ij(1, 1) = k
    ij(1, 2) = l
    dim_loop: do
     !
     !   The longest dimension is now "X"
     !   Find the most distant atom in "Y-Z" plane'
     !
      y1 = coord(2, l)
      z1 = coord(3, l)
      rabmax = 0.d0
      kk = 0
      ll = 0
      loop = 0
      do
        loop = loop + 1
        if (loop > 10) then
          k = kk
          l = ll
          exit
        else
         !
         !    Find the atom most distant from atom "L"
         !
          rmax = 0.d0
          do j = 1, numat
            r = (y1-coord(2, j)) ** 2 + (z1-coord(3, j)) ** 2
            if (r > rmax) then
              rmax = r
              k = j
            end if
          end do
         !
         !   Atom K is most distant from L in the Y-Z plane.
         !
          if (Abs (rmax-rabmax) < 1.d-5) exit
          if (rmax > rabmax) then
            rabmax = rmax
            kk = k
            ll = l
          end if
         !
         !   We don't know if RMAX is the maximum, therefore go to the
         !   mid-point, and repeat the test.
         !
         !   Now find the mid-point between the two atoms
         !
          y1 = 0.5d0 * (y1+coord(2, k))
          z1 = 0.5d0 * (z1+coord(3, k))
         !
         !    Find the atom most distant
         !
          rmax = 0.d0
          do j = 1, numat
            r = (y1-coord(2, j)) ** 2 + (z1-coord(3, j)) ** 2
            if (r > rmax) then
              rmax = r
              l = j
            end if
          end do
          y1 = coord(2, l)
          z1 = coord(3, l)
        end if
      end do
     !
     !   Determine vector joining most distant atoms (K and L).
     !
      y1 = coord(2, k) - coord(2, l)
      z1 = coord(3, k) - coord(3, l)
      r = Sqrt (y1**2 + z1**2 + 1.d-20)
      ca = y1 / r
      sa = z1 / r
     !
     !  Rotate system so that atoms K and L have the same Y coordinate.
     !
      do i = 1, numat
        sum         =  ca * coord(2, i) + sa * coord(3, i)
        coord(3, i) = -sa * coord(2, i) + ca * coord(3, i)
        coord(2, i) =  sum
      end do
      if (r > dim(1) + 1.d-10) then
        dim(1) = r
        ij(1, 1) = k
        ij(1, 2) = l
        cycle dim_loop
      else
        dim(2) = r
        ij(2, 1) = k
        ij(2, 2) = l
        exit dim_loop
      end if
    end do dim_loop
   !
   !   The longest dimension is now "X", the second longest dimension
   !   is "Y".
   !   Find the largest dimension in the "Z" direction
   !
    ymin = 1.d16
    ymax = -1.d16
    do i = 1, numat
      if (coord(3, i) > ymax) then
        k = i
        ymax = coord(3, i)
      end if
      if (coord(3, i) < ymin) then
        l = i
        ymin = coord(3, i)
      end if
    end do
    dim(3) = ymax - ymin
    ij(3, 1) = k
    if (k == l) then
      if (l == 1) then
        l = 2
      else
        l = 1
      end if
    end if
    ij(3, 2) = l
    write (iw, "(/,9X,A,/)") " MOLECULAR DIMENSIONS (Angstroms)"
    write (iw, "(9X,A)") "   Atom       Atom       Distance"
    write (iw, "(11X,A2,I6,3X,A2,I6,F12.5)") ((elemnt(nat(ij(j, i))), &
             & ij(j, i), i=1, 2), dim(j), j=1, 3)
    coord(:,:numat) =  store_coords(:,:numat)
end subroutine dimens

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine cnvgz (pnew, p, p1, p2, p3, niter, idiag)
    use molkst_C, only: norbs, mpack
    use MOZYME_C, only : use_three_point_extrap, pmax
    implicit none
    integer, intent (in) :: niter
    integer, dimension (norbs), intent (in) :: idiag ! Pointers to diagonal elements
    double precision, dimension (norbs), intent (inout) :: p1, p2, p3
    double precision, dimension (mpack), intent (inout) :: p, pnew
    integer :: i, j
    double precision :: damp, fac, faca, facb, sa
    intrinsic Abs, Max, Min, Mod, Sign, Sqrt
   !
   ! Save the diagonal of the current and previous density for later use
   !
    do i = 1, norbs
      j = idiag(i)
      p3(i) = pnew(j)
      p2(i) = p(j)
    end do
!
!   Calculate the maximum and RMS change in the density matrix
!
    pmax = 0.0d0
    do i = 1, mpack
      sa = Abs (pnew(i) - p(i))
      pmax = Max (pmax, sa)
    end do
    if (use_three_point_extrap) then
!
!   Three-point extrapolation in use. Extrapolation is used on
!   every third SCF cycle
!
      if (Mod (niter, 3) == 0) then
        faca = 0.0d0
        facb = 0.0d0
        do i = 1, norbs
          sa = Abs (p3(i) - p2(i))
          faca = faca + sa ** 2
          facb = facb + (p3(i)-2.0d0*p2(i)+p1(i)) ** 2
        end do
!
        if (facb > 0.d0 .and. faca < (100.d0*facb)) then
          fac = Sqrt (faca/facb)
          pnew = pnew + fac * (pnew-p)
        end if
!
      end if
!
!   From iteration 4 on, the change in the diagonal elements is
!   limited to 'damp'
!
      if (niter > 3) then
        damp = 0.05d0
        if (pmax > damp) then
          do i = 1, norbs
            j = idiag(i)
            if (Abs (p3(i)-p2(i)) > damp) then
              pnew(j) = p2(i) + Sign (damp, p3(i)-p2(i))
              pnew(j) = Min (2.0d0, Max (pnew(j), 0.0d0))
            end if
          end do
        end if
      end if
    end if ! three-point extrapolation
!
!  Save the density for use in the next iteration
!
    p1 = p2
    p = pnew
end subroutine cnvgz

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

! ____________________________________________________________________________
! _________________________GENERALLY USED ROUTINES ___________________________
! ____________________________________________________________________________

      subroutine upcas (s)

      implicit none
      integer ::          i
      character*(*)    s

!     **** converts string to upper case ****

      do i = 1, len(s)
        if (s(i:i) <= 'z' .and. s(i:i) >= 'a')&
     &          s(i:i) = char(ichar(s(i:i)) - 32)
      end do

      return
      end subroutine upcas

!     ***********************************************************************

      subroutine st (a, b, ihalf)
      use reimers_C, only : n, stwt, nr, nslwr, nsupr, nstr, istr

      implicit none
      double precision ::   a(n, n), b(n, n), bb, bbb
      integer ::            i, j, ihalf, i1, ib, ir, j1, jb

!     **** this does the symmetry - orbital transform on a matrix in ao basis ***
!     ****			b = T(transp) . a . T			    ***
!     **** ihalf = 1 lower, = 2 upper, triangle of matrices only		    ***

      do i = 1, n
        do j = i, n
          if (ihalf == 2) then
            b(i, j) = 0.d0
          else
            b(j, i) = 0.d0
          end if
        end do
      end do

      do ir = 1, nr
        do i = nslwr(ir), nsupr(ir)
          do j = i, nsupr(ir)
            bbb = 0.d0
            do i1 = 1, nstr(i)
              bb = 0.d0
              ib = abs(istr(i1, i))
              do j1 = 1, nstr(j)
                jb = abs(istr(j1, j))
                if (jb > ib .and. ihalf == 2 .or.&
     &              jb <= ib .and. ihalf /= 2) then
                  bb = bb + isign(1, istr(j1, j)) * a(ib, jb) * stwt(j)
                else
                  bb = bb + isign(1, istr(j1, j)) * a(jb, ib) * stwt(j)
                end if
              end do
              bbb = bbb + bb * isign(1, istr(i1, i)) * stwt(i)
            end do
            if (ihalf == 2) then
              b(i, j) = bbb
            else
              b(j, i) = bbb
            end if
          end do
        end do
      end do

      return
      end subroutine st

!     *************************************************************************
      subroutine stgamm (gamma, g1)
      use reimers_C, only : n, nham

      implicit none
      double precision ::  g1(n, n), gamma(n, n)
      integer ::           i, j

!     **** symmetry - trandforms the gamma (i, i|j, j) and (i, j|i, j) matrices ****

!     **** first copy gamma into g1 ****
      do i = 1, n
        do j = 1, n
          g1(i, j) = gamma(i, j)
        end do
      end do

!     **** transform integrals (i, j|i, j) in upper half ****
      if (nham == 2) call st (g1, gamma, 2)

!     **** transform integrals (i, i|j, j) in lower half ****
      call st (g1, gamma, 1)

      return
      end subroutine stgamm

!     *************************************************************************

      subroutine ao2mo1 (a, f, c, d, i1, i2, j1, j2, weight)

!     **** this adds C(transp) . F . C onto A over MO range with weighting ****
!     **** as specified by Edwards and Zerner, eqn 24			   ****
!     **** in MO basis, the proj operators simply limit the range of i, j   ****
      use reimers_C, only : n, nb2, matind

      implicit none
      double precision ::  a(nb2), f(nb2), c(n, n), d(nb2, 2), wk(n, n), weight, &
                        xx
      integer ::           i, j, k, i1, i2, j1, j2, nm

! RMG edit
      do i = 1, n
        wk(i, 1) = d(i, 1)
        do j = 2, n
          wk(i, j) = 0.d0
        end do
      end do
! End RMG

      do i = 1, n
        do j = j1, j2
          xx = 0.d0
          do k = 1, n
            nm = matind (max(i, k)) + min(i, k)
            xx = xx + f(nm) * c(j, k)
          end do
          wk(i, j) = xx
        end do
      end do

      do j = j1, j2
        do i = i1, min(j, i2)
          xx = 0.d0
          do k = 1, n
            xx = xx + c(i, k) * wk(k, j)
          end do
          nm = matind(max(i, j)) + min(i, j)
          a(nm) = a(nm) + xx * weight
        end do
      end do

! RMG edit
      do i = 1, n
         d(i, 1) = wk(i, 1)
      end do
! End RMG

      return
      end subroutine ao2mo1

!     *************************************************************************

      subroutine ao2mo (a, c, wk, mm, nn, n1, n2)

!     **** this transforms a matrix from AO to MO basis ****
!     **** or from configuration state basis to CI states ****
!     **** calculating output for states n1 to n2 only ****
      use reimers_C, only : matind

      implicit none
      integer ::           i, j, k, mm, nn, n1, n2, nm
      double precision ::  a(*), c(mm, nn), wk(mm, nn), xx

      do i = 1, nn
        do j = n1, n2
          xx = 0.d0
          do k = 1, nn
            nm = matind (max(i, k)) + min(i, k)
            xx = xx + a(nm) * c(j, k)
          end do
          wk(i, j) = xx
        end do
      end do

      do j = n1, n2
        nm = matind(j)
        do i = n1, j
          nm = nm + 1
          xx = 0.d0
          do k = 1, nn
            xx = xx + c(i, k) * wk(k, j)
          end do
          a(nm) = xx
        end do
      end do

      return
      end subroutine ao2mo

!     *************************************************************************

      subroutine mo2ao (a, c, d, nn)
      use reimers_C, only : nb2, matind

!     **** this transforms a matrix A from MO to AO basis set ****
!     **** or from CI state basis to spin - adapted configuration basis
      implicit none
      integer ::           i, j, k, nm, nn
      double precision ::  a(*), c(nn, nn), wk(nn, nn), d(nb2, 2), xx

! RMG edit
      do i = 1, nn
        wk(i, 1) = d(i, 1)
        do j = 2, nn
          wk(i, j) = 0.d0
        end do
      end do
! End RMG
      do i = 1, nn
        do j = 1, nn
          xx = 0.d0
          do k = 1, nn
            nm = matind(max(i, k)) + min(i, k)
            xx = xx + a(nm) * c(k, j)

          end do
          wk(i, j) = xx
        end do
      end do

      nm = 0
      do j = 1, nn
        do i = 1, j
          nm = nm + 1
          xx = 0.d0
          do k = 1, nn
            xx = xx + c(k, i) * wk(k, j)
          end do
          a(nm) = xx
        end do
      end do
! RMG edit
      do i = 1, nn
         d(i, 1) = wk(i, 1)
      end do
! End RMG
      return
      end subroutine mo2ao

!     *************************************************************************

      subroutine dump (a, nn, ibtype, name)
      use reimers_C, only : matind, nham, natm, iat, nbt, nci, iatsym, kind, &
          nptg, nr, nmrep
      USE chanel_C, only : iw

      implicit none
      double precision ::  a(*), amax
      integer ::           i, j, k, i0, i1, i2, ibtype, ip, ir, k1, k2, nm, nn, nnb2
      character*(*) ::     name
      character*21 ::      f1150
      data f1150        /'(1x,2i3,a2,a3,15f8.?)'/

!     **** dumps a symmetric matrix					    ****
!     **** ibtype = 1 atom by atom; = 2 orbital by orbital; = 3 state by state;   ****
!     **** = 4 state by state max 15, 	 = 0 is basic			    ****

      write (iw, *)
      write (iw, *) name

!     **** find largest elements ****
      nnb2 = nn*(nn + 1)/2
      amax = 1.D-10
      do i = 1, nnb2
        amax = max (amax, abs(a(i)))
      end do
      ip = int(log10(amax) + 0.99d0)
      ip = max (0, min (4, 6 - ip))

      k2 = 0
      do while (k2 < nn)
        k1 = k2 + 1
        k2 = min (k1 + 14, nn)
        write (iw, *)
        write (iw, '(10x, 15i8)') (i, i = k1, k2)
        if (ibtype < 3) then
          do j = k1, nn
            nm = matind(j)
            if (ibtype == 0) then
!	      **** generic matrix ****
              write (iw, '(1x, i6, 1x, a2, 2x, 15f8.4)') j, '  ', (a(nm + k), k = k1, min(j, k2))
            else if (ibtype == 1) then
!	      **** atom by atom matrix ****
              write (iw, '(1x, i6, 1x, a2, 2x, 15f8.4)') j, iatsym(natm(j)), (a(nm + k), k = k1, min(j, k2))
            else
!	      **** orbital by orbital matrix ****
              f1150(20:20) = char (ip + ichar('0'))
              i = iat(j)
              write (iw, f1150) j, i, iatsym(natm(i)), kind(nbt(j)), &
     &                                (a(nm + k), k = k1, min(j, k2))
              if (nham /= 1 .and. nham /= 3 .and. (j == nn .or.&
     &           i /= iat(j + 1)) ) write (iw, *)
            end if
          end do

        else
!	  **** configuration by configuration matrix, symmetry - block wize ****

          i0 = 1
          do ir = 1, nr
            if (nci(ir) > 0) then
              if (nptg > 1) write (iw, "(' Block of symmetry ', a4)") nmrep(ir, nptg)
              i1 = i0 - 1
              i2 = i1 + nci(ir)
              if (ibtype == 4) i2 = min (i2, i1 + 14)
              do i = i1 + 1, i1 + nci(ir)
                nm = matind(i) + i1
                write (iw, '(1x, i6, 5x, 15f8.4)') i, (a(nm + k), k = 1, min(15, i - i1))
              end do
              i0 = i0 + nci(ir)
            end if
          end do
          k2 = nn

        end if
      end do

      return
      end subroutine dump

!     *************************************************************************

      subroutine polzro

      use reimers_C, only : pol
      implicit none
      integer ::           j

      do 100 j = 1, 6
        pol(j) = 0.d0
100   continue

      return
      end subroutine polzro

!     *************************************************************************

      subroutine polizn (tmx, tmy, tmz, dele)
      use reimers_C, only : pol

      implicit none
      double precision ::  tmx, tmy, tmz, dele

      if (abs(dele) < 1.d1) then
        return
      end if
      pol(1) = pol(1) + tmx**2 / dele
      pol(2) = pol(2) + tmx*tmy/ dele
      pol(3) = pol(3) + tmy**2 / dele
      pol(4) = pol(4) + tmx*tmz/ dele
      pol(5) = pol(5) + tmy*tmz/ dele
      pol(6) = pol(6) + tmz**2 / dele

      return
      end subroutine polizn

!     *************************************************************************

      subroutine polout
      use reimers_C, only : au2ang, au2cm, pol
      USE chanel_C, only : iw

      implicit none
      double precision ::  conv, toang
      integer ::           j

      conv = 2.d0 * au2cm / au2ang**2
      toang = au2ang**3
      write (iw, *)
      write (iw, 800) 'au  ', (pol(j)*conv, j = 1, 6)
      write (iw, 800) 'A**3', (pol(j)*conv*toang, j = 1, 6)

      return
800   format (' Polarizability (', a4, ') xx=', f8.2, &
     & ' xy=', f8.2, ' yy=', f8.2, ' xz=', f8.2, ' yz=', f8.2, ' zz=', f8.2)
      end subroutine polout

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine dfpsav(totime, xparam, gd, xlast, funct1, mdfp, xdfp)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE ef_C, ONLY: alparm, x0, x1, x2, iloop
      USE maps_C, only : rxn_coord, latom, kloop
      use common_arrays_C, only : na, geo, geoa, grad, hesinv, profil
      USE molkst_C, ONLY: natoms, numcal, nvar, keywrd, mozyme, koment, title, norbs, numat, &
        prt_gradients
      USE chanel_C, only : iw, ires, restart_fn
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision  :: totime
      double precision  :: funct1
      integer  :: mdfp(9)
      double precision  :: xparam(nvar)
      double precision  :: gd(nvar)
      double precision  :: xlast(nvar)
      double precision  :: xdfp(9)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: icalcn, i, j, linear, old_numat, old_norbs
      logical :: first, opend

      save first, icalcn
!-----------------------------------------------
!*********************************************************************
!
! DFPSAV STORES AND RESTORES DATA USED IN THE D-F-P GEOMETRY
!        OPTIMISATION.
!
!  ON INPUT TOTIME = TOTAL JOB TIME ELAPSED DURING THE CALCULATION.
!           XPARAM = CURRENT VALUE OF PARAMETERS.
!           GD     = OLD GRADIENT.
!           XLAST  = OLD VALUE OF PARAMETERS.
!           FUNCT1 = CURRENT VALUE OF HEAT OF FORMATION.
!           MDFP   = INTEGER CONSTANTS USED IN D-F-P.
!           XDFP   = REAL CONSTANTS USED IN D-F-P.
!           MDFP(9)= 1 FOR DUMP, 0 FOR RESTORE.
!*********************************************************************
      data icalcn/ 0/
      first = icalcn /= numcal
      if (first) icalcn = numcal
      inquire(unit=ires, opened=opend)
      if (opend) close(unit=ires, status='KEEP')
      open(unit=ires, file=restart_fn, status='UNKNOWN', form=&
        'UNFORMATTED', position='asis')
      rewind ires
      if (mdfp(9) /= 0) then
        if (mdfp(9) == 1) then
          write (iw, &
      '(2/10X,''- - - - - - - TIME UP - - - - - - -'',2/)')
          if (index(keywrd,'SADDLE') /= 0) then
            write (iw, &
      '(2/10X,'' NO RESTART EXISTS FOR SADDLE'',2/      10X, &
      & '' HERE IS A DATA-FILE FILES THAT MIGHT BE SUITABLE'',/ &
      & 10X,'' FOR RESTARTING THE CALCULATION'',3/)')
            write (iw, '(A)') keywrd, koment, title
            do iloop = 1, 2
              call geout ((-iw))
              geo(:,:natoms) = geoa(:,:natoms)
              na = 0
            end do
            write (iw, '(3/10X,''CALCULATION TERMINATED HERE'')')
            call mopend ('NO RESTART EXISTS FOR SADDLE. ')
            return
          end if
          write (iw, &
      '(2/10X,'' - THE CALCULATION IS BEING DUMPED TO DISK'',/10X, &
      & ''   RESTART IT USING THE KEYWORD "RESTART"'')')
          if (index(keywrd,'STEP1') == 0) then
            write (iw, &
              '(2/10X,''CURRENT VALUE OF HEAT OF FORMATION ='',F12.6)') funct1
            if (prt_gradients .and. index(keywrd," GRADI") /= 0 .and. mozyme) then
              write (iw, '(3/7X,''CURRENT  POINT  AND  DERIVATIVES'',/)')
              call prtgra ()
            end if
            if (mdfp(9) == 1) call geout (iw)
          end if
        end if
        write (ires) norbs, numat, (xparam(i),i=1,nvar), (gd(i),i=1,nvar)
        write (ires) mdfp, xdfp, totime, funct1
        write (ires) (xlast(i),i=1,nvar), (grad(i),i=1,nvar)
        linear = (nvar*(nvar + 1))/2
        write (ires) (hesinv(i),i=1,linear)
        call den_in_out(1)
        if (latom /= 0) then
          if (index(keywrd,' STEP=') /= 0) then
            write (ires) kloop
            write (ires) rxn_coord
            write (ires) (profil(i),i=1,kloop)
          else
            write (ires) ((alparm(j,i),j=1,3),i=1,nvar)
            write (ires) iloop, x0, x1, x2
          end if
        end if
        if (index(keywrd,'STEP1') /= 0) then
          return
        end if
        close(ires)
      else
        if (first) write (iw, '(2/10X,''RESTORING DATA FROM DISK''/)')
        read (ires, end=50, err=50)old_norbs, old_numat, (xparam(i),i=1,nvar), (gd(i),i=1,nvar)
        if (norbs /= old_norbs .or. numat /= old_numat) then
              call mopend("Restart file read in does not match current data set")
              return
        end if
        read (ires, end=40, err=40) mdfp, xdfp, totime, funct1
        if (first) write (iw, '(10X,''FUNCTION ='',F13.6,2/)') funct1
        read (ires, end=50, err=50) (xlast(i),i=1,nvar), (grad(i),i=1,nvar)
        linear = (nvar*(nvar + 1))/2
        if (.not. allocated(hesinv)) allocate (hesinv(linear))
        read (ires, end=50, err=50) (hesinv(i),i=1,linear)
        call den_in_out(0)
        if (latom /= 0) then
          if (index(keywrd,' STEP=') /= 0) then
            read (ires, end=50, err=50) kloop
            read (ires, end=50, err=50) rxn_coord
            read (ires, end=50, err=50) (profil(i),i=1,kloop)
          else
            read (ires, end=50, err=50) ((alparm(j,i),j=1,3),i=1,nvar)
            read (ires, end=50, err=50) iloop, x0, x1, x2
          end if
        end if
        first = .FALSE.
        return
   40   continue
        call mopend ('NO RESTART FILE EXISTS!')
        return
   50   continue
        call mopend ('RESTART FILE EXISTS, BUT IS CORRUPT')
        return
      end if
      return
      end subroutine dfpsav

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine symtrz (sec_det, nvecs, coord)
!
!  symtrz uses symmetry operations supplied by the user to symmetrize the
!  secular determinant.  This is a complicated operation, because the effect
!  of a symmetry operation usually involves moving an atom out of its
!  primitive unti cell and into a different unit cell.
!
  use common_common, only : numat, id, iop, nfirst, nlast, per_atom, ncell, nijk, &
    title, allt1, mop, mr1, mr2, mr3, bcc, keywrd, iw_new, ixyz, nijk_CUC, line, &
    data_set_name, jobnam
  implicit none
  integer, intent(in) :: nvecs
  double precision, dimension(3, numat), intent(in) :: coord
  double precision, dimension(nvecs, nvecs*(mr1*mr2*mr3 + 1)), intent(inout) :: sec_det
! 
  logical :: debugs, debugf, opend
  integer :: i, i1, ii, il, iu, j, j1, jj, ix, &
       & jl, jop, ju, jx, k, k1, kk, sym_op, m1, m2, m3, mm, newcel, &
       & nx, ny, nz, alloc_stat
  integer :: new(numat), newcuc(numat), incell(3,numat), itrans(3,numat), &
    nxyz(-11:11, -11:11, -11:11)
  double precision :: sum, new_coord(3,numat), t1(9,9), t2(9,9), new_cuc(3,numat)
  double precision, dimension(:,:), allocatable :: new_sec_det
!
!    Put the unit cell indices into the 3 dimensional integer array NXYZ
!    and also store the indices in a linear integer array NIJK. 
!
!    Initially, unit cells are in the range (1:mr1), (1:mr2), and (1:mr3), but
!    for this operation, they must be as near to the CUC as possible, so
!    they are re-numbered as (0:mr1/2, -mr1/2:-1), etc. I.e., if mr1=9, 
!    then the order of unit cells would be (0,1,2,3,4,-4,-3,-2,-1).
!
! 
  incell = 0
  itrans = 0
  sum = 0.d0
!
! Make a list, nijk, of unit cell indices, nx, ny, nz, and a map
! to that list, nxyz
!
  ncell = 0
  do m3 = 1, mr3
    if (m3 <= (mr3+1)/2) then
      nz = m3 - 1
    else
      nz = m3 - mr3 - 1
    end if
    do m2 = 1, mr2
      if (m2 <= (mr2+1)/2) then
        ny = m2 - 1
      else
        ny = m2 - mr2 - 1
      end if
      do m1 = 1, mr1
        if (m1 <= (mr1+1)/2) then
          nx = m1 - 1
        else
          nx = m1 - mr1 - 1
        end if
        if (.not.bcc .or. Mod(nx + ny + nz, 2) == 0) then
          ncell = ncell + 1        
          if (nx <= -mr1/2) nx = nx + mr1
          if (ny <= -mr2/2) ny = ny + mr2
          if (nz <= -mr3/2) nz = nz + mr3
          if (nx >  mr1/2) nx = nx - mr1
          if (ny >  mr2/2) ny = ny - mr2 
          if (nz >  mr3/2) nz = nz - mr3
          nxyz(nx, ny, nz) = ncell
          nijk(1, ncell) = nx
          nijk(2, ncell) = ny
          nijk(3, ncell) = nz
        end if
      end do
    end do
  end do
  if (index(keywrd," NOSYM") /= 0) then
    do i = 1, numat
      mop(1, i, 1) = i
      mop(2:4, i, 1) = 0 
    end do
    iop = 1
    return
  end if 
!
!  Make a list of the unit cell that each atom in the Central Unit Cell is in
!  (Some atoms in the CUC can be in the adjacent unit cell.)
!
!  Coordinates are in crystallographic units.
!
  do i = 1, numat
    do j = 1, id
      k = Int (coord(j, i) + 40.1d0) - 40
      nijk_CUC(j,i) = k
    end do
  end do
  debugs = (Index (keywrd, " SYMTRZ") /= 0)
  debugf = (Index (keywrd, " ROTFOK") /= 0)
  if (debugs .or. debugf) write(*, "(/,2a)") "  (For debug information, please look in the output file created by this run)"   
  allocate(new_sec_det(nvecs, ncell*nvecs), stat = alloc_stat)
  if (alloc_stat /= 0) then
    write(iw_new,'(a)')"Failed to allocate array new_sec_det in symtrz"
    stop
  end if
  new_sec_det = 0.d0
!
!   Outer-most sym_op:  Over all operations
!
  jop = iop
  big_sym_op: do sym_op = 1, iop
    if (debugf) write(iw_new, "(/,2A)") " Operation: ", title(sym_op)
!
!   Work out where the atoms of the CUC go
!
    new_coord = coord
    call rotsec (t1, .true., new_coord, sym_op)
!
!  On exit from rotsec, t1 holds the unitary rotation matrix.
!
    do i = 1, 9
      do j = 1, 9
        allt1(i, j, sym_op) = t1(i, j)
      end do
    end do
!
!   Work out the behavior of the atoms in the CUC.
!
!   Atoms in the CUC might, in fact, not be in the CUC, i.e., they might not have indices = (0,0,0)
!   so keep track of the unit cell they are in.  For atom "i" this is nijk_CUC(:,i)

!   Clear newcuc so that if a mistake occurs, it will be obvious.
!
    do j = 1, numat
      newcuc(j) = 0
    end do
    do i = 1, numat
      do j = 1, id
        k = Int (new_coord(j, i) + 40.1d0) - 40 - nijk_CUC(j,i)
        new_coord(j, i) = new_coord(j, i) - k 
!
!  itrans holds the indices of the atoms of the CUC after they have been moved by operation sym_op
!  These indices are "relative" in the sense that the fractional coordinates are relative to those
!  of the atoms they came from in the CUC.  I.e., if an atom in the CUC has coordinates (0.1 -0.1 0.1)
!  then after the operation the indices of that atom will have (0,1,0) added to it.
!
        itrans(j, i) = k
      end do
      new_cuc = new_coord
      if (Mod (itrans(1, i) + itrans(2, i) + itrans(3, i), 2) /= 0 .and. bcc) then
        inquire(unit=iw_new, opened=opend) 
        if (.not. opend) open (unit = iw_new, file = trim(data_set_name)//".txt", &
        form = "FORMATTED", status = "UNKNOWN")
        write(iw_new, '(a,i3,a)') " Operation,", sym_op, " is not an allowed operation."
        write(iw_new, "(A,I3,3F12.6,3I3)") &
          & " New coordinates of CUC atom", i, (new_coord(j, i), j = 1, 3), &
          & (itrans(j, i), j = 1, 3)
        jop = jop - 15
        cycle big_sym_op
      end if
      sym_op1: do j = 1, numat
        do k = 1, 3
          if (Abs (new_coord(k, i)  - nijk_CUC(k,i) - coord(k, j) + nijk_CUC(k,j)) > 0.2d0) cycle sym_op1
        end do
        new_coord(:, i) = new_coord(:, i) + nijk_CUC(:,j) - nijk_CUC(:,i)
        itrans(:, i) = itrans(:, i) - nijk_CUC(:,j) + nijk_CUC(:,i)
        newcuc(i) = j
        exit 
      end do sym_op1
    end do 
!
!  Next sym_op:  Over all (supplied) unit cells
!
   if (debugf) then
      write(iw_new, "(/,2a)") " Unit Cell Indices    Atom               Crystal coordinates             ", &
        "Cartesian coordinates            New Cartesian coordinates         New Crystal coordinates"
      write(iw_new, "(2a,/)") "           i  j  k                    a         b         c             ", &
        "x         y         z             x         y         z             a         b         c"                             
    end if
    do ixyz = 1, ncell
!
!  Put into new_coord the positions of all atoms in unit cell ixyz
!  after they have been moved by operation sym_op
!
!  The steps involved are:
!  1.  Move the atom into unit cell nijk(1:3,ixyz)
!  2.  Operate on the atom's position using operation "sym_op".
!
      do i = 1, numat
        new_coord(:, i) = coord(:, i) + nijk(:,ixyz)
      end do
      call rotsec (t1, .false., new_coord, sym_op)
!
!   Find out which unit cell each atom has been moved into.
!
      do ii = 1, numat
        do jj = 1, id
          k1 = Int (new_coord(jj, ii) + 40.1d0) - 40 - nijk_CUC(jj,ii)
          new_coord(jj, ii) = new_coord(jj, ii) - k1
!
!  incell holds the indices of the atoms of the  unit cell ixyz after they have been moved by operation sym_op
!  These indices are "relative" in the sense that the fractional coordinates are relative to those
!  of the atoms they came from in the CUC.  I.e., if an atom in the CUC has coordinates (0.1 -0.1 0.1)
!  then after the operation the indices of that atom will have (0,1,0) added to it.
!
          incell(jj, ii) = k1
        end do
        if (Mod (incell(1, ii) + incell(2, ii) + incell(3, ii), 2) /= 0 .and. bcc) then
          inquire(unit=iw_new, opened=opend) 
          if (.not. opend) open (unit = iw_new, file = trim(data_set_name)//".txt", &
          form = "FORMATTED", status = "UNKNOWN")  
          write(iw_new, '(/,a, i3, a,i3,a)') " For atom",ii, " Operation,", sym_op, &
          ", "//trim(title(sym_op))//", is not an allowed operation."
          write(iw_new, '(a)') &
          " Original position of atom     Transformed position of atom (in fractional unit cell coordinates)"
          write(iw_new,'(f12.4,2f8.4, f12.4, 2f8.4)') coord(:,ii) + nijk(:,ixyz), &
          (new_coord(jj,ii) + incell(jj,ii), jj = 1,id)
          jop = jop - 1
          cycle
        end if
        sym_op2: do jj = 1, numat
          do kk = 1, 3
            sum = new_coord(kk, ii) - nijk_CUC(kk,ii) - coord(kk, jj) + nijk_CUC(kk,jj)
            if (Abs (sum) > 0.2d0) cycle sym_op2
          end do
!
!  Atom II has been moved to become atom new(ii) in unit cell incell(1-3,ii)
!
          mop(1, ii, sym_op) = jj
          mop(2, ii, sym_op) = itrans(1, ii)
          mop(3, ii, sym_op) = itrans(2, ii)
          mop(4, ii, sym_op) = itrans(3, ii) 
          new(ii) = jj
          new_coord(:,ii) = new_coord(:,ii) + nijk_CUC(:,jj) - nijk_CUC(:,ii)
          incell(:,ii) = incell(:,ii) - nijk_CUC(:,jj) + nijk_CUC(:,ii)
          exit
        end do sym_op2
        if (jj > numat) then
!
!  Error!
!
          inquire(unit=iw_new, opened=opend) 
          if (.not. opend) open (unit = iw_new, file = trim(data_set_name)//".txt", &
          form = "FORMATTED", status = "UNKNOWN")      
          write(line,'(a)')"Symmetry data were supplied from file """//trim(jobnam)//".ops"""
          write(*,'(/10x,a)')trim(line)
          write(iw_new,'(/10x,a)')trim(line)
          write(line,'(a,i3,a)') &
          "Operation", sym_op, " ("//trim(title(sym_op))//") is not an allowed operation."
          write(*,'(/10x,a)')trim(line)
          write(iw_new,'(/10x,a)')trim(line)
          write(line,'(a,i3,a)')"(It moved atom", ii, " into a position that is not part of the lattice)" 
          write(*,'(10x,a,/)')trim(line)
          write(iw_new,'(10x,a,/)')trim(line)
          write(line,'(a)')"(Edit """//trim(jobnam)//".mop"" or  """//trim(jobnam)//".ops"" or "
          write(*,'(10x,a)')trim(line)
          write(iw_new,'(10x,a)')trim(line)
          write(line,'(a)')"delete or rename file """//trim(jobnam)//".ops"" to avoid this error)"
          write(*,'(10x,a,/)')trim(line)
          write(iw_new,'(10x,a,/)')trim(line)
          stop 
        end if
      end do
      do ii = 1, numat
        if (new(ii) == 0) then
          write(*,*)ii
          stop "Error in SYMTRZ"
        end if
      end do
!
!   Now comes the difficult part:  Take each pair of atoms in unit
!   cell IXYZ interacting with the central unit cell, and work
!   out the new unit cell indices.
      do i = 1, numat
        do j = 1, numat
          il = nfirst(i)
          iu = nlast(i)
          jl = nfirst(j) + (ixyz - 1)*nvecs
          ju = nlast(j)  + (ixyz - 1)*nvecs
!
!  Extract that part of the secular determinant which represents atom I in 
!  the central unit cell interacting with atom J in unit cell IXYZ.
!
          i1 = 0
          do ii = il, iu
            i1 = i1 + 1
            j1 = 0
            do jj = jl, ju
              j1 = j1 + 1
              t2(i1, j1) = sec_det(ii, jj)
            end do
          end do
          nx = incell(1, j) - itrans(1, i)
          ny = incell(2, j) - itrans(2, i)
          nz = incell(3, j) - itrans(3, i)
!
!  Make sure that ix, iy, and iz are in the correct range
!
          if (nx <= -mr1/2) nx = nx + mr1
          if (ny <= -mr2/2) ny = ny + mr2
          if (nz <= -mr3/2) nz = nz + mr3
          if (nx >  mr1/2) nx = nx - mr1
          if (ny >  mr2/2) ny = ny - mr2
          if (nz >  mr3/2) nz = nz - mr3
          if (nxyz(nx, ny, nz) == 0) then
            if (bcc) then
              inquire(unit=iw_new, opened=opend) 
              if (.not. opend) open (unit = iw_new, file = trim(data_set_name)//".txt", &
                form = "FORMATTED", status = "UNKNOWN")
              write(iw_new,'(a)') "There is a known bug in some BCC systems.  Symmetry will not be used"
              do ii = 1, numat
                mop(1, ii, 1) = ii
                mop(2:4, ii, 1) = 0 
              end do
              iop = 1
              return             
            end if
            write(*,'(//10x,a,3i2,a)')" Unit cell (",nx,ny,nz,") does not exist!" 
            write(*,'(a,//)')"     (For more details, see '"//trim(data_set_name)//".txt')"
            write(iw_new,'(//10x,a,3i2,a,//)')" Unit cell (",nx,ny,nz,") does not exist!" 
            write(iw_new,'(a,i3,a,a,i3,a,i3,a,i3,a,3i3,a)') &
            " Faulty operation: Symmetry operation", sym_op, ", ("//trim(title(sym_op)), &
              "), Atom:",i," in CUC with atom:",j, " in unit cell",ixyz, " indices: (",nijk(:,ixyz),")"
            write(iw_new,'(a,i3,a,3i3,a)')" Indices of atom", i," in CUC:          (", itrans(:,i),")"
            write(iw_new,'(a,i3,a,i3,a,3i3,a)') &
            " Indices of atom", j," in unit cell", ixyz,": (", incell(:, j),")"
            stop
          end if
          newcel = nxyz(nx, ny, nz)
          call rotcel (t2,per_atom(i), per_atom(j), t1)
!
! Now put the rotated interaction matrix into the correct unit cell in new_sec_det.
!
          il = nfirst(newcuc(i))
          iu = nlast(newcuc(i))
          jl = nfirst(new(j)) + (newcel - 1)*nvecs 
          ju = nlast(new(j))  + (newcel - 1)*nvecs 
          i1 = 0
          do ii = il, iu
            i1 = i1 + 1
            j1 = 0
            do jj = jl, ju
              j1 = j1 + 1
              sum = t2(i1, j1)-sec_det(ii, jj)
              if (Abs (sum) > 0.5d0) then
                write(*,*)" Error detected. see file '"//trim(data_set_name)//".txt' for more information"
                call sleep(2)
                inquire(unit=iw_new, opened=opend) 
                if (.not. opend) open (unit = iw_new, file = trim(data_set_name)//".txt", &
                form = "FORMATTED", status = "UNKNOWN")
                write(iw_new, '(/,a)') " Secular determinant generated by symmetry operations may be faulty."
                write(iw_new, '(/,a,i3, a,i3,a,i3,a,i3,a,i3)') &
                  " Operation", sym_op," ("//trim(title(sym_op))//"), atom",i, &
                " in the CUC, and atom",j," in unit cell",ixyz
                write(iw_new,'(/,a,i3,a,3i3,a,3f8.3)')" New indices of atom",i," in the CUC:", itrans(:,i), &
                "   Coordinates:",new_cuc(:,i)
                write(iw_new,'(a,i3,a,3i3,a,3f8.3)')" New indices of atom",j,"            ", incell(:,j), &
                "   Coordinates:", new_coord(:,j)
                write(iw_new,'(a,i3,a,i3,a,i3,a,3i3)')" Atom",j," maps to atom",new(j), " in cell", newcel, &
                " at indices", incell(:,j)
                write(iw_new,'(/,a,i3,a,i3,a, 3i3)') " F(s,s) terms for unit cells involving atom", i, &
                " in the CUC and", new(j), " in all unit cells"
                write(iw_new,'(a,i3,a,i3,a)')" Unit cell  Indices   Atom ",new(j), "   F(ss)     Atom", &
                new(j), "  fractional coords"
                do mm = 1, ncell
                  write(iw_new, '(i6,i7,2i3,i6,f14.4,f12.4,2f8.4)')mm, nijk(:,mm),(mm - 1)*numat + new(j), & 
                    sec_det(nfirst(newcuc(i)), (mm - 1)*nvecs + nfirst(new(j))), &
                    coord(1,new(j)) + nijk(1,mm), coord(2,new(j)) + nijk(2,mm), coord(3,new(j)) + nijk(3,mm)
                end do
                if (.not. debugs .or. .not. debugf) write(iw_new,'(a)') &
                " Use keywords SYMTRZ and ROTFOK for more information."
                stop
              else
                new_sec_det(ii, jj) = new_sec_det(ii, jj) + t2(i1, j1)
              end if 
            end do
          end do
        end do
      end do
    end do
  end do big_sym_op
  iop = jop
  if (jop == 0) then
    write(iw_new, '(a)') "System has NO symmetry operations"
    stop  
  end if
!
!  Re-normalize new_sec_det, then copy it back into sec_det
!  Identify the largest error
!
  sum = 0.d0
  do i = 1, nvecs
    do j = 1, ncell*nvecs
      new_sec_det(i, j) = new_sec_det(i, j)/iop
      if (Abs (new_sec_det(i, j) - sec_det(i, j)) > sum) then 
        sum = Abs (new_sec_det(i, j) - sec_det(i, j))
        ix = i
        jx = j
      end if
      sec_det(i, j) = new_sec_det(i, j)
    end do
  end do
  if (sum > 1.d-1) then
    inquire(unit=iw_new, opened=opend) 
    if (.not. opend) open (unit = iw_new, file = trim(data_set_name)//".txt", form = "FORMATTED", status = "UNKNOWN")
    write(iw_new, '(a,f10.2,a,2i4)') " Largest Difference in symmetrized secular determinant:", sum, " at location", ix, jx
  end if
  return
end subroutine symtrz

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine swap(c, n, mdim, nocc, ifill)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE chanel_C, only : iw
      use iter_C, only : psi => pbold, stdpsi => pbold2
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n
      integer , intent(in) :: mdim
      integer , intent(in) :: nocc
      integer , intent(inout) :: ifill
      double precision , intent(inout) :: c(mdim,mdim)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer ::  i, jfill
      double precision :: sum, summax, x
      double precision, external :: ddot

!-----------------------------------------------
!******************************************************************
!
!        SWAP ENSURES THAT A NAMED MOLECULAR ORBITAL IFILL IS FILLED
! ON INPUT
!          C = EIGENVECTORS IN A MDIM*MDIM MATRIX
!          N = NUMBER OF ORBITALS
!          NOCC = NUMBER OF OCCUPIED ORBITALS
!          IFILL = FILLED ORBITAL
!******************************************************************
      if (ifill <= 0) then
!
!     WE NOW DEFINE THE FILLED ORBITAL
!
        if (allocated(psi)) deallocate(psi)
        if (allocated(stdpsi)) deallocate(stdpsi)
        allocate (psi(n), stdpsi(n))
        ifill = -ifill
        stdpsi(:n) = c(:n,ifill)
        psi(:n) = c(:n,ifill)
        return
      end if
      sum = 0.D0
      sum = ddot(n,psi(:n),1,c(:n,ifill),1)
!
      if (abs(sum) <= 0.707106781187D0) then
!
!     IFILL HAS MOVED!
!
        summax = 0.D0
        do ifill = 1, n
          sum = 0.D0
          do i = 1, n
            sum = sum + stdpsi(i)*c(i,ifill)
          end do
          sum = abs(sum)
          if (sum > summax) jfill = ifill
          summax = dmax1(sum,summax)
          if (sum > 0.707106781187D0) go to 90
        end do
        do ifill = 1, n
          sum = 0.D0
          do i = 1, n
            sum = sum + psi(i)*c(i,ifill)
          end do
          sum = abs(sum)
          if (sum > summax) jfill = ifill
          summax = dmax1(sum,summax)
          if (sum > 0.7071D0) go to 90
        end do
        write (iw, 80) summax, jfill
   80   format(/,' CAUTION !!! SUM IN SWAP VERY SMALL, SUMMAX =',f10.5,&
          ' JFILL=',i3)
        ifill = jfill
      end if
   90 continue
      if (ifill <= nocc) return
!
!    ITS EMPTY, SO SWAP IT WITH THE HIGHEST FILLED
!
      do i = 1, n
        x = c(i,nocc)
        c(i,nocc) = c(i,ifill)
        c(i,ifill) = x
      end do
      return
      end subroutine swap

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine force()
!
      use molkst_C, only : natoms, ndep,  nvar, gnorm, iflepo, keywrd, &
      & last, numat, escf, id, jloop => itemp_1, numcal, n_trivial => itemp_2, &
      moperr, this_point => itemp_2, zpe, mozyme, uhf, prt_force, prt_normal_coords, &
      prt_orientation, maxtxt, l_normal_html
!
      use common_arrays_C, only : xparam, na, nb, nc, geo, geoa, ca => c, cb, eigs, eigb, &
      & labels, coord, loc, grad, errfn, na_store, nat, lopt, fmatrx, p, q, txtatm
!
      use symmetry_C, only : name, igroup
!
      use parameters_C, only : tore
      USE elemts_C, only : elemnt
      USE funcon_C, only : fpc_10, fpc_6, fpc_8, a0, ev, fpc_9
      use to_screen_C, only : dipt, travel, freq, redmas, cnorml, force_const
      USE chanel_C, only : iw, ixyz
      implicit none
!
      integer , dimension(60) :: irot
      integer , dimension(2,3*natoms) :: locold
      integer , dimension(natoms) :: nar, nbr, ncr
      integer :: j, i, l, nvaold, ndeold, iu, il, nvib, ij, &
        im1, ju, jl, ii, jj, ni, k, nto6, nrem6, iinc1, iinc2, store_natoms, store_numat
      double precision, dimension(3,3*numat) :: deldip, trdip
      double precision, dimension(3,3) :: rot
      double precision :: time2, tscf, tder, time1, time3, a, b, c, &
        sum, const, summ, sum1, sym
      double precision, dimension(:), allocatable :: store, ff, oldf, &
        velocity
      double precision, dimension (:,:), allocatable :: store_coord
      logical :: restrt, linear, debug, prnt, large, ts
      double precision, external :: ddot, dipole, reada, seconds
!**********************************************************************
!
!   FORCE CALCULATES THE FORCE CONSTANTS FOR THE MOLECULE, AND THE
!         VIBRATIONAL FREQUENCIES.  ISOTOPIC SUBSTITUTION IS ALLOWED.
!
!**********************************************************************
!  Point-Groups are stored in order of increasing symmetry.  Groups
!   supported are, in order
!
! C1, Cs, Ci, C2, D2, C2v, C2h, D2h, C3, C4, S4, D3, C3v, C3h, C5, C6,
! S6, C7, C8, S8, C4v, D4, D2d, C5v, C6v, D6, C4h, D3h, D3d, C7v, C7h,
! C8v, D8, D4d, D4h, C5h, D5, D5h, D5d, C6h, D6h, D6d, D7, D7h, D7d,
! C8h, D8h, T, Td, O, Th, Oh, I, Ih, Cv, Dh, R3
!
      data irot/ 1, 1, 1, 2, 4, 2, 2, 4, 3, 4, 2, 6, 3, 3, 5, 6, 3, 7, 8, 4, 4&
        , 8, 4, 5, 6, 12, 4, 6, 6, 7, 7, 8, 16, 8, 8, 5, 10, 10, 10, 6, 12, 12&
        , 14, 14, 14, 8, 16, 12, 12, 24, 12, 24, 24, 24, 1, 2, 4*1/
!
      k = 0
      nvaold = 0
      rot = 0.d0
      a = 0.d0
      b = 0.d0
      c = 0.d0
!
!
! TEST GEOMETRY TO SEE IF IT IS OPTIMIZED
!
      time2 = -1.D9
! Save the connectivity and geometry for restarts
      nar(:natoms) = na(:natoms)
      nbr(:natoms) = nb(:natoms)
      ncr(:natoms) = nc(:natoms)
      if (allocated(geoa)) deallocate(geoa)
      allocate(geoa(3,natoms))
      geoa = geo
      ts = (index(keywrd, " FORCETS") + index(keywrd, " MINI") /= 0)
      store_natoms = natoms
      if (id == 0 .and. index(keywrd,' NOREOR') == 0 .and. .not. ts) then
!
!   NEED TO ENSURE THAT XYZINT WILL WORK CORRECTLY BEFORE CALL
!   TO DRC.
!
        l = 0
        do i = 1, natoms
          if (labels(i) == 99) cycle
          l = l + 1
          labels(l) = labels(i)
          txtatm(l) = txtatm(i)
        end do
        numat = l
        natoms = numat
        nvib = 0
        call xyzint (coord, numat, na, nb, nc, 1.D0, geo)
        na_store = na
        call gmetry (geo, coord)
        nvaold = nvar
        locold(1,:nvar) = loc(1,:nvar)
        locold(2,:nvar) = loc(2,:nvar)
      end if
!
!   Unconditionally convert structure into Cartesian coordinates
!   because FORCE works in Cartesian coordinates.
!   Pay careful attention to the translation vectors - they must
!   be at the end of the coordinates, and should not be marked for
!   optimization.
!
      if ( .not. ts) nvar = 0
      ndeold = ndep
      ndep = 0
      do i = 1, numat + id
        do j = 1, 3
          geo(j,i) = coord(j,i)
          if ( .not. ts) then
            nvar = nvar + 1
            loc(1,nvar) = i
            loc(2,nvar) = j
            xparam(nvar) = geo(j,i)
          end if
          labels(i) = nat(i)
        end do
      end do
      if (ts) then
        do i = 1, nvar
          xparam(i) = geo(loc(2,i), loc(1,i))
        end do
      end if
      if (id > 0) then
        natoms = numat + id
        nvar = nvar - 3*id ! No need to check for TS - solids can't have transition states.
        labels(numat + 1:numat + id) = 107
      end if
      na = 0
      if (ts) then
        i = nvar
      else
        i = 3*(numat + id)
      end if

!
! Deallocate grad and errfn in case the number of variables set in the input file was smaller
! than the number needed in FORCE
!
      if (allocated(grad))            deallocate (grad)
      if (allocated(errfn))           deallocate (errfn)
      if (allocated(dipt))            deallocate (dipt)
      if (allocated(travel))          deallocate (travel)
      if (allocated(force_const))     deallocate (force_const)
      if (allocated(freq))            deallocate (freq)
      if (allocated(redmas))          deallocate (redmas)
      if (allocated(cnorml))          deallocate (cnorml)
      if (allocated(fmatrx))          deallocate (fmatrx)
      allocate(cnorml(i**2), fmatrx((i*(i+1))/2),grad(i), ff(i**2), errfn(i), &
       & store((i*(i+1))/2), oldf((i*(i + 1))/2), dipt(3*numat), &
       travel(3*numat), force_const(3*numat), freq(3*numat), redmas(3*numat,2), stat = j)
       if (j /= 0) then
         write(iw,*)" Failed to allocate memory in FORCE"
         call mopend("Failed to allocate memory in FORCE")
         return
       end if
      errfn = 0.d0
      grad = 0.d0
!
!   IF A RESTART, THEN TSCF AND TDER WILL BE FAULTY, THEREFORE SET TO -1
!
      tscf = -1.D0
      tder = -1.D0
      prnt = index(keywrd,'RC=') == 0
      debug = index(keywrd,'DFORCE') /= 0
      large = index(keywrd,'LARGE') /= 0
      restrt = index(keywrd,'RESTART') /= 0
      time1 = seconds(1)
      if (.not. restrt) then
        call compfg (xparam, .TRUE., escf, .TRUE., grad, .FALSE.)
        if (numat == 1) goto 98
        if (moperr) goto 99
        write (iw,'(2/10X,''HEAT OF FORMATION ='',F15.6,'' KCALS/MOLE'')') escf
        time2 = seconds(1)
        tscf = time2 - time1
        call compfg (xparam, .TRUE., escf, .FALSE., grad, .TRUE.)
        time3 = seconds(1)
        tder = time3 - time2
        if (prnt) then
          if (ts) then
          else
            write (iw, '(2/10X,''CARTESIAN COORDINATE DERIVATIVES'',2/3X,&
        &     ''NUMBER  ATOM'',9X,''X'',12X,''Y'',12x,''Z'',/)')
            l = 0
            iu = 0
            do i = 1, natoms
              if (labels(i) == 99) cycle
              l = l + 1
              il = iu + 1
              iu = il + 2
              if (labels(i) == 107) iu = il
              write (iw, '(I6,6X,A2,F14.6,2F13.6)') l, elemnt(labels(i)), (grad(j),j=il,iu)
            end do
            write(iw,*)
          end if
        end if
        gnorm = dsqrt(ddot(nvar,grad,1,grad,1))
        if (.not. mozyme .and. index(keywrd, " AUX") /= 0) then
          call chrge (p, q)
          do i = 1, numat
            l = nat(i)
            q(i) = tore(l) - q(i)
          end do
          sum = dipole(p,coord,fmatrx,1)
          call symtrz (ca, eigs, 1, .true.)
          if (uhf) call symtrz (cb, eigb, 1, .TRUE.)
          call to_screen("To_file: Normal output")
        end if
        write (iw, '(2/10X,''GRADIENT NORM ='',F10.5)') gnorm
        sum = max(10.d0, sqrt(float(numat))*2.d0)
        if (gnorm > sum .and. .not. ts) then
          if (index(keywrd,' LET ') /= 0) then
             write (iw, &
        '(3/1X,''** GRADIENT IS VERY LARGE, BUT SINCE "LET" IS USED, CALCULATION WILL CONTINUE'')')
          else
            write (iw, &
        '(3/1X,"** GRADIENT IS TOO LARGE TO ALLOW THE FORCE MATRIX TO BE CALCULATED, (LIMIT =",f5.1,") **",2/)') sum
            write (iw, "(/,A)") " THE GEOMETRY IS NOT AT A STATIONARY POINT ON THE POTENTIAL ENERGY SURFACE"
            write (iw, "(/,A)") " EITHER ADD 'LET' OR OPTIMIZE THE GEOMETRY SO THAT THE GEOMETRY IS AT A STATIONARY POINT."
            write (iw, "(A)") " (FOR A TRANSITION STATE, USE 'TS', FOR A GROUND STATE DO A NORMAL GEOMETRY OPTIMIZATION)"
            call to_screen("To_file: ERROR: GRADIENT IS TOO LARGE TO ALLOW FORCE MATRIX TO BE CALCULATED")
            call mopend ("Gradient in FORCE is too large, geometry is not at a stationary point on the P.E.S.")
            goto 99
          end if
        end if
      end if
      sum = max(1.d0, sqrt(float(numat))*0.2d0)
      if (index(keywrd,'THERMO') /= 0 .and. gnorm > sum) then
        write (iw, &
      '(2/30X,''**** WARNING ****'',2/10X,'' GRADIENT IS VERY LARGE FOR A THERMO CALCULATION'', &
      & /10X,'' RESULTS ARE LIKELY TO BE INACCURATE IF THERE ARE'')')
        write (iw, &
          '(10X,'' ANY LOW-LYING VIBRATIONS (LESS THAN ABOUT 400CM-1)'')')
        write (iw, &
      '(10X," GRADIENT NORM SHOULD BE LESS THAN ABOUT",f4.1," FOR THERMO",&
      &/10X,'' TO GIVE ACCURATE RESULTS'')') sum
      end if
      if ( .not. mozyme .and. .not. restrt) call mullik()
      if (tscf > 0.01D0) then
        write (iw, '(2/10X,''TIME FOR SCF CALCULATION ='',F8.2)') tscf
        write (iw, '( /10X,''TIME FOR DERIVATIVES     ='',F8.2)') tder
      end if
      if (ndeold > 0) write (iw, &
      '(2/10X,''SYMMETRY WAS SPECIFIED, BUT CANNOT BE USED HERE'')')
      c = 1.d0
      if ( .not. ts) call axis (a, b, c, rot)
      allocate (store_coord(3,numat))
      store_coord(:,:numat) = coord(:,:numat)
      geo(:,:numat) = coord(:,:numat)
      if (rot(1,1) > 2.d0) goto 99 ! dummy use of rot
      nvib = 3*numat - 6
      if (ts) then
        nvib = nvar
      else
        if (abs(c) < 1.D-20) nvib = nvib + 1
        if (id /= 0) nvib = 3*numat - 3
      end if
      if (prnt .and. prt_orientation) then
        write (iw, &
      '(/10X,''ORIENTATION OF MOLECULE IN FORCE CALCULATION'')')
        write (iw, &
      '(/,4X,''NO.'',7X,''ATOM'',9X,''X'',9X,''Y'',9X,''Z'',/)')
      end if
      l = 0
      if (.not. (prnt .and. prt_orientation)) then
        l = l + count(labels(:natoms)/=99)
      else
        do i = 1, natoms
          if (labels(i) == 99) cycle
          l = l + 1
          write (iw, '(I6,9X,A2,3X,3F10.4)') l, elemnt(labels(i)), (coord(j,l),&
            j=1,3)
        end do
      end if
      call symtrz (cnorml, cnorml, 2, .FALSE.)
      call fmat (fmatrx, nvib, tscf, tder, deldip, escf, ff, ts)
      if (moperr) goto 99
      na(1) = 0
      na(:natoms) = nar(:natoms)
      nb(:natoms) = nbr(:natoms)
      nc(:natoms) = ncr(:natoms)
      geo(:,:natoms) = geoa(:,:natoms)
      if (nvib < 0) then
        ndep = ndeold
        nvar = 0
        iflepo = -1
        goto 99
      end if
!
!   THE FORCE MATRIX IS PRINTED AS AN ATOM-ATOM MATRIX RATHER THAN
!   AS A 3N*3N MATRIX, AS THE 3N MATRIX IS VERY CONFUSING!
!
      ij = 0
      iu = 0
      do i = 1, nvar/3
        il = iu + 1
        iu = il + 2
        im1 = i - 1
        ju = 0
        do j = 1, im1
          jl = ju + 1
          ju = jl + 2
          sum = 0.D0
          do ii = il, iu
            do jj = jl, ju
              sum = sum + fmatrx((ii*(ii-1))/2+jj)**2
            end do
          end do
          ij = ij + 1
          store(ij) = sqrt(sum)
        end do
        ij = ij + 1
        store(ij) = sqrt(fmatrx(((il+0)*(il+1))/2)**2+fmatrx(((il+1)*(il+2))/2)&
          **2+fmatrx(((il+2)*(il+3))/2)**2+2.D0*(fmatrx(((il+1)*(il+2))/2-1)**2&
          +fmatrx(((il+2)*(il+3))/2-2)**2+fmatrx(((il+2)*(il+3))/2-1)**2))
      end do
      if (debug) then
        write (iw, '(2/10X,'' FULL FORCE MATRIX, INVOKED BY "DFORCE"'')')
        if (index(keywrd, " NOREOR") == 0) then
          write(iw,'(/10x,a)')" Caution: NOREOR is NOT present, therefore system will be oriented"
          write(iw,'(10x,a)')" so that the moments of inertia are along the Cartesian axes."
        end if
        i = -nvar
        call vecprt (fmatrx, i)
      end if
      if (prnt .and. prt_force) then
        sum = 1.d-21*fpc_10*a0**2/(4.184*ev*fpc_9)
        write(iw,'(/,a,f7.4,a)')"(To convert to Hartree/Bohr^2, multiply by (10^(-21) x N x a0^2)/(4.184 x 627.51) = ", &
          sum,")"
        write (iw, '(2/10X,'' FORCE MATRIX IN MILLIDYNES/ANGSTROM'')')
        if (ts) then
          i = nvar/3
        else
          i = numat
        end if
        call vecprt (store, i)
      end if
      l = (nvar*(nvar + 1))/2
      store(:l) = fmatrx(:l)
      if (prnt) call axis (a, b, c, rot)
!
!  A molecule is linear IF one or two of a, b, and c are much smaller than the largest of a, b, and c.
!
      linear = abs((a/(a + b + c))*(b/(a + b + c))*(c/(a + b + c))) < 1.D-10
      if (prnt) write (iw, &
        '(2/10X,''HEAT OF FORMATION ='',F15.6,'' KCALS/MOLE'')') escf
      coord(:,:numat) = store_coord(:,:numat)
      if (large) then
        store_numat = numat
        numat = nvar/3
        call frame (store, numat, 0)
        numat = store_numat
        call rsp (store, nvar, freq, cnorml)
        call phase_lock(cnorml, nvar)
        do i = nvib + 1, nvar
          j = int((freq(i)+50.D0)*0.01D0)
          freq(i) = freq(i) - j*100
        end do
        if (prnt) then
          write (iw, '(2/10X,''TRIVIAL VIBRATIONS, SHOULD BE ZERO'')')
          write (iw, &
      '(/, F9.4,''=TX'',F9.4,''=TY'',F9.4,''=TZ'',F9.4,''=RX'',F9.4,''=RY'',F9.4,''=RZ'')') &
      & (freq(i),i=nvib + 1,nvar)
          call symtrz (cnorml, freq, 2, .TRUE.)
          write (iw, '(2/''      MOLECULAR POINT GROUP   :   '',A4)') name
          write (iw, '(2/10X,'' EIGENVECTORS  '')')
          call matou1 (cnorml, freq, nvib, nvar, nvib, 5)
          write (iw, &
      '(2/10X,''FORCE CONSTANTS IN MILLIDYNES/ANGSTROM'' ,'' (= 10**5 DYNES/CM)'',/)')
          write (iw, '(8F10.5)') (freq(i),i=1,nvib)
! CONVERT TO WEIGHTED FMAT
          write (iw, '(2/10X,'' ASSOCIATED EIGENVECTORS'')')
          i = -nvar
          call matout (cnorml, freq, nvib, i, nvar)
        end if
      end if
      n_trivial = nvar - nvib
      call freqcy (fmatrx, freq, travel, force_const, .TRUE., deldip, ff, oldf, ts)
!
!  CALCULATE ZERO POINT ENERGY
!
!.
!   N AVOGADRO'S NUMBER
!   H PLANCK'S CONSTANT
!   C SPEED OF LIGHT
!   CONST=0.5*N*H*C/(1.D10*4.184)
      const = 0.5D0*fpc_10*fpc_6*fpc_8/(1.D10*4.184D0)
      sum = 0.D0
      ni = 0
      do i = 1, nvib
        if (freq(i) > 0) then
          sum = sum + freq(i)
        else
          ni = ni + 1
        end if
      end do
      zpe = sum*const
      if (prnt) then
        write (iw, '(/9X,'' ZERO POINT ENERGY'', F12.3,'' KCAL/MOL'')') zpe
        if (ni /= 0) then
          write (iw, '(2(/9X,A))') &
            'NOTE: SYSTEM IS NOT A GROUND STATE, THEREFORE ZERO POINT', &
            'ENERGY IS NOT MEANINGFULL. ZERO POINT ENERGY PRINTED'
          write (iw, '(9X,A,I3,A)') 'DOES NOT INCLUDE THE', ni, &
            ' IMAGINARY FREQUENCIES'
        end if
      end if
      summ = 0.D0
      do i = 1, nvar
        sum1 = 1.D-20
        do j = 1, nvar
          sum1 = sum1 + cnorml(j+(i-1)*nvar)**2
        end do
        sum1 = 1.D0/sqrt(sum1)
        grad = 0.D0
        do k = 1, 3
          sum = 0.D0
          do j = 1, nvar
            sum = sum + cnorml(j+(i-1)*nvar)*deldip(k,j)
          end do
          summ = summ + abs(sum)
          trdip(k,i) = sum*sum1
        end do
        dipt(i) = sqrt(trdip(1,i)**2+trdip(2,i)**2+trdip(3,i)**2)
      end do
      if (prnt .and. large) then
        write (iw, &
      '(2/10X,'' FREQUENCIES, REDUCED MASSES AND VIBRATIONAL DIPOLES''/)')
        nto6 = nvar/6
        nrem6 = nvar - nto6*6
        iinc1 = -5
        if (nto6 >= 1) then
          do i = 1, nto6
            write (iw, '(/)')
            iinc1 = iinc1 + 6
            iinc2 = iinc1 + 5
            write (iw, '(3X,''I'',10I10)') (j,j=iinc1,iinc2)
            write (iw, '('' FREQ(I)'',6F10.4,/)') (freq(j),j=iinc1,iinc2)
            write (iw, '('' MASS(I)'',6F10.5,/)') (redmas(j, 1),j=iinc1,iinc2)
            write (iw, '('' DIPX(I)'',6F10.5)') (trdip(1,j),j=iinc1,iinc2)
            write (iw, '('' DIPY(I)'',6F10.5)') (trdip(2,j),j=iinc1,iinc2)
            write (iw, '('' DIPZ(I)'',6F10.5,/)') (trdip(3,j),j=iinc1,iinc2)
            write (iw, '('' DIPT(I)'',6F10.5)') (dipt(j),j=iinc1,iinc2)
          end do
        end if
        if (nrem6 >= 1) then
          write (iw, '(/)')
          iinc1 = iinc1 + 6
          iinc2 = iinc1 + (nrem6 - 1)
          write (iw, '(3X,''I'',10I10)') (j,j=iinc1,iinc2)
          write (iw, '('' FREQ(I)'',6F10.4)') (freq(j),j=iinc1,iinc2)
          write (iw, '(/,'' MASS(I)'',6F10.5)') (redmas(j, 1),j=iinc1,iinc2)
          write (iw, '(/,'' DIPX(I)'',6F10.5)') (trdip(1,j),j=iinc1,iinc2)
          write (iw, '('' DIPY(I)'',6F10.5)') (trdip(2,j),j=iinc1,iinc2)
          write (iw, '('' DIPZ(I)'',6F10.5)') (trdip(3,j),j=iinc1,iinc2)
          write (iw, '(/,'' DIPT(I)'',6F10.5)') (dipt(j),j=iinc1,iinc2)
        end if
      end if
      if (ts) then
        write(iw,'(//25x,a,/)')"Atoms used in the FORCETS calculation"
        do i = 1, nvar, 3
          j = loc(1,i)
          if (maxtxt == 26) then
            write(iw,'(i4,4x,a2,"(",a26,")",3(F13.8," +1"))')(i + 2)/3, elemnt(nat(j)),txtatm(j), geo(:,j)
          else
            write(iw,'(10x,i4,4x,a2,3(F13.8," +1"))')(i + 2)/3, elemnt(nat(j)), geo(:,j)
          end if
        end do
      end if
      if (prnt .and. prt_normal_coords) then
        write (iw, '(2/10X,'' NORMAL COORDINATE ANALYSIS (Total motion = 1 Angstrom)'')')
        j = nvar
        i = -nvar
        call matou1 (cnorml, freq, nvib, j, nvib, 5)
      end if
!
!   CARRY OUT IRC IF REQUESTED.
!
      if (index(keywrd,'IRC') + index(keywrd,'DRC') /= 0) then
        if (index(keywrd, " HTML") /= 0) then
           if (index(keywrd,' DIPOLE') /= 0) call write_path_html(2)
           call write_path_html(1)
        end if
        loc(1,:nvar) = 0
        loc(2,:nvar) = 0
        nvar = nvaold
        loc(1,:nvar) = locold(1,:nvar)
        loc(2,:nvar) = locold(2,:nvar)
        call xyzint (coord, numat, na, nb, nc, 1.D0, geo)
        last = 1
        store_coord = coord
        geo(:,:numat) = store_coord(:,:numat)
        na = 0
        jloop = 0
        this_point = 0
        if (ts) then
          allocate(velocity(3*numat))
          if (index(keywrd, " FORCETS") /= 0) then
            k = 1
          else
            k = 0
          end if
!
!  Generate a complete normal mode
!
          velocity = 0.d0
          j = 3
          do i = 1, numat
            if (lopt(1,i) == k) then
              velocity(i*3 - 2) = cnorml(j - 2)
              velocity(i*3 - 1) = cnorml(j - 1)
              velocity(i*3 - 0) = cnorml(j - 0)
              j = j + 3
            end if
          end do
          na_store = 0
          l_normal_html = .false.
          call drc (velocity, freq)
        else
          if (.not. allocated(velocity)) &
            allocate(velocity(3*numat))
          velocity(:3*numat) = cnorml(:3*numat)
          l_normal_html = .false.
          call drc (cnorml, freq)
          cnorml(:3*numat) = velocity(:3*numat)
        end if
        if (moperr) return
        i = Index (keywrd, " IRC")
        if (i /= 0) then
          if  (Index (keywrd(i+1 + Index(keywrd(i+1:), " ") - 2:), "*") /= 0) then
!
! a double sided IRC
!
!   First, reverse the reaction path already written.
!
            If (index(keywrd,' DIPOLE') /= 0) call reverse_trajectory(2)
            call reverse_trajectory(1)
            call reverse_aux
            call l_control("REVERSE", len("REVERSE"), 1)
            last = 1
            geo(:,:numat) = store_coord(:,:numat)
            na = 0
            jloop = 0
            numcal = numcal + 1
            loc(1,:nvar) = 0
            loc(2,:nvar) = 0
            nvar = nvaold
            loc(1,:nvar) = locold(1,:nvar)
            loc(2,:nvar) = locold(2,:nvar)
            if (ts) then
              velocity = 0.d0
              j = 3
              do i = 1, numat
                if (lopt(1,i) == k) then
                  velocity(i*3 - 2) = -cnorml(j - 2)
                  velocity(i*3 - 1) = -cnorml(j - 1)
                  velocity(i*3 - 0) = -cnorml(j - 0)
                  j = j + 3
                end if
              end do
               call drc (velocity, freq)
            else
              cnorml = -cnorml
              call drc (cnorml, freq)
            end if
          end if
          ndep = 0
          lopt(:,:numat) = 1
        else
          ndep = ndeold
          nvar = 0
          geo(:,:natoms) = geoa(:,:natoms)
        end if
        if (index(keywrd, " PDBOUT") /= 0) close(ixyz, status = 'delete', iostat=i)
        goto 99
      end if
      call freqcy (fmatrx, freq, deldip, force_const, .FALSE., deldip, ff, oldf, ts)
      if (prt_normal_coords) then
      write (iw, '(2/10X,'' MASS-WEIGHTED COORDINATE ANALYSIS (NORMAL COORDINATES)'')')
        i = -nvar
        j = nvar
        call matou1 (cnorml, freq, nvib, j, nvib, 5)
      end if
      if (.not. ts) call anavib (freq, dipt, nvar, cnorml, store, nvib, fmatrx, ff)
  98 continue
      if (index(keywrd,'THERMO') /= 0) then
        call gmetry (geo, coord)
        sym = irot(igroup)
        write (iw, '(/5x,A,A,A,I3)') ' SYMMETRY NUMBER FOR POINT-GROUP ', &
        & name, '=', irot(igroup)
        i = index(keywrd,' TRANS')
!
!   "I" IS GOING TO MARK THE BEGINNING OF THE GENUINE VIBRATIONS.
!
        if (i /= 0) then
          i = index(keywrd,' TRANS=')
          if (i /= 0) then
            i = nint(1 + reada(keywrd,i))
            j = nvib - i + 1
            if (i - 1 > 0) &
              write (iw, '(2/1X,''THE LOWEST'',I3,'' VIBRATIONS ARE NOT'',/, &
      & '' TO BE USED IN THE THERMO CALCULATION'')') i - 1
          else
            write (iw, '(2/10X,''SYSTEM IS A TRANSITION STATE'')')
            i = 2
            j = nvib - 1
          end if
        else
          if (numat > 1) write (iw, '(2/10X,''SYSTEM IS A GROUND STATE'')')
          i = 1
          j = nvib
        end if
        if (.not. allocated(freq)) then
          allocate (freq(1))
          freq = 0.d0
        end if
        if (.not. allocated(store)) allocate(store(1))
        store(:nvib) = freq(:nvib)
        call thermo (a, b, c, linear, sym, store(i), j, escf)
      end if
      if (allocated(store_coord)) coord(:,:numat) = store_coord(:,:numat)
      call to_screen("To_file: Force output")
      if (numat > 1) then
        fmatrx = oldf*1.d-5
        if ( .not. ts .and. numat > 1) call intfc (oldf, xparam, geoa, nar, nbr, ncr)
      end if
      na(1) = 0
      nvar = 0
      ndep = ndeold

  99  if (allocated(dipt))    deallocate (dipt)
      if (allocated(travel))  deallocate (travel)
      if (allocated(freq))    deallocate (freq)
      if (allocated(redmas))  deallocate (redmas)
      if (store_natoms /= natoms + id) then
        natoms = -30; numat = -30
      end if
      return
      end subroutine force
      subroutine phase_lock(vecs,n)
      implicit none
   !
      integer :: n
      double precision, dimension (n,n) :: vecs
!  Local
      integer :: i, j
      double precision :: asum, ssum
!
!  The convention used in MOPAC is that the phase of an eigenvector is
!  defined such that the largest coefficient is positive.
!
      do i = 1, n
        asum = 0.d0
        ssum = 0.d0
        do j = 1, n
          if (Abs(vecs(j,i)) > asum) then
            asum = Abs(vecs(j,i))
            ssum = vecs(j,i)
          end if
        end do
        if (ssum < 0.d0) then
!
!  The largest coefficient was negative - therefore reverse the phase of the eigenvector
!
          vecs(1:n,i) = -vecs(1:n,i)
        end if
      end do
      return
      end subroutine phase_lock

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

module meci_C
  integer, parameter :: mmci = 70
  integer ::         &
  &  nmos,           & !  Type        Number of M.O.s in active space in C.I.
                       !  Definition  Number of M.O.s involved in a MECI calculation
                       !  Min. value  0
                       !  Max. value  norbs
  &  lab,            & !  Number of microstates used in the C.I.
  &  labsiz,         & !  Number of states to be calculated (a subset of lab)
  &  root_requested, & !  Number of the root that was requested
  &  nstate,         & !  Type        Number of States used in defining the system
                       !  Definition  The complete manifold of staet vectors defining the state.
                       !  Min. value  1 (for a non-degenerate state)
                       !  Max. value  Lesser of norbs and 22
  &  nelec =-20,     & !  Minus the maximum number of electrons in the active space
  &  nmeci = 22,     & !  Maximum number of M.O.s in active space
  &  maxci,          & !  Largest number of configurations allowed
  &  is,             &
  &  iiloop,         &
  &  jloop,          &
  &  k,              &
  &  dummy

  double precision ::    &
  &  cif1,           & !
  &  cif2,           & !
  &  cdiagi


  integer :: nbo(3)

  integer, dimension(:), allocatable :: &
  &  nalmat, & !
  &  ispin     ! Type        Spins of each State (Singlet = 1)
               ! Definition  "S" quantum number for each State
               ! Min. value   0,  0,  0, etc.
               ! Max. value  10, 10, 10, etc  (9 = Nonet, 10 = "???????")

  integer, dimension(:,:), allocatable :: ispqr

  double precision, dimension(:), allocatable :: &
  &  cdiag,  & !
  &  occa,   & ! Type        Initial M.O. occupancy
               ! Definition  Number of electrons in each M.O. of the SCF in the active space
               ! Units       Electrons
               ! Min. value  0.0, 0.0, etc.
               ! Max. value  2.0, 2.0, etc
  &  conf,   & !  State vectors
  &  eig,    & !  State eigenvalues
  &  vectci    ! Type        State vector of interest
               ! Definition  nstate State vectors, each of length lab, if not degenerate, nstate = 1

  double precision, dimension(:,:), allocatable :: &
  &  rjkaa,  & ! Type
  &  rjkab,  & !
  &  deltap, & ! Type        Change in molecular orbital occupancy as a result of C.I.
               ! Definition  deltap(i,i) = Number of electrons gained or lost in forming the State
               ! Units       Electrons
  &  cxy       !

  double precision, dimension(:,:,:), allocatable :: &
  &  dijkl
  double precision, dimension(:,:,:,:), allocatable :: &
  &  xy

  integer, dimension(:,:), allocatable :: &
  &  microa, & ! Type       microstates
               ! Definition occupancy of alpha M.O.s in microstates
               ! Units      Electrons
  &  microb    ! Type       Beta microstates
               ! Definition occupancy of beta M.O.s in microstates
               ! Units      Electrons
end module meci_C

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine dhc (p, pa, pb, xi, nat, if, il, jf, jl, dener, mode)
    use molkst_C, only : numcal, cutofp, id, uhf, clower
    implicit none
    integer, intent (in) :: if, il, jf, jl, mode
    double precision, intent (out) :: dener
    integer, dimension (2), intent (in) :: nat
    double precision, dimension (*), intent (in) :: p, pa, pb
    double precision, dimension (3, 2), intent (in) :: xi
    logical, save :: ignor1, ignor2, lpoint, cutoff
    integer, save :: icalcn = 0
    double precision, save :: cutof
    double precision, save :: wlim
    integer :: ic
    integer :: i, i1, i2, ia, ii, j, j1, ja, jc, jj, k, kr, linear, ni, nj
    double precision :: ee, enuclr_loc, rij
    integer, dimension (2) :: nfirst_loc, nlast_loc
    double precision, dimension (45) :: e1b = 0.d0, e2a = 0.d0
    double precision, dimension (171) :: f, h
    double precision, dimension (9, 9) :: shmat
    double precision, dimension (2026), save :: w = 0.d0, wk = 0.d0
    double precision, external :: helect
    if (icalcn /= numcal) then
      !
      !  Switch to point charges for separations of more than 14 Angstroms
      !  (This is related to FACT in subroutine REPPD)
      !
      cutof = clower**2
      lpoint = .false.
      icalcn = numcal
      ignor1 = .false.
      ignor2 = .false.
      wlim = 4.d0
      if (id == 0) then
        wlim = 0.d0
      end if
    end if
    rij = (xi(1, 1)-xi(1, 2)) ** 2 + (xi(2, 1)-xi(2, 2)) ** 2 &
         & + (xi(3, 1)-xi(3, 2)) ** 2
    if (mode == 1 .and. id /= 0) then
      ignor1 = (rij > 225.d0)  ! Ignore overlaps involving atoms separated by more than 15 A.
      ignor2 = (rij >(4.d0/3.d0*cutofp)**2)
      if (ignor1 .and. ignor2) then
        dener = 0.d0
        return
      end if
    end if
    if (mode == 2 .and. id /= 0 .and. ignor2 .and. ignor1) then
      dener = 0.d0
      return
    end if
    nfirst_loc(1) = 1
    nlast_loc(1) = il - if + 1
    nfirst_loc(2) = nlast_loc(1) + 1
    nlast_loc(2) = nfirst_loc(2) + jl - jf
    linear = (nlast_loc(2)*(nlast_loc(2)+1)) / 2
    do i = 1, linear
      f(i) = 0.d0
      h(i) = 0.0d00
    end do
    kr = 0
    ia = nfirst_loc(2)
    ic = nlast_loc(2)
    ja = nfirst_loc(1)
    jc = nlast_loc(1)
    j = 1
    i = 2
    nj = nat(1)
    ni = nat(2)
    if ( .not. ignor1) then
      !
      !   Evaluate the one-electron term
      !
      call h1elec (nj, ni, xi(1, 1), xi(1, 2), shmat)
      if (nat(1) == 102 .or. nat(2) == 102) then
        k = (ic*(ic+1)) / 2
        h(1:k) = 0.d0
      else
        j1 = 0
        do j = ia, ic
          jj = j * (j-1) / 2
          j1 = j1 + 1
          i1 = 0
          do i = ja, jc
            jj = jj + 1
            i1 = i1 + 1
            h(jj) = shmat(i1, j1)
            f(jj) = shmat(i1, j1)
          end do
        end do
      end if
    end if
    if ( .not. ignor2) then
      !
      !   Evaluate the two-electron term
      !
      if (id > 0) then
        if (mode == 1) then
          lpoint = (rij > cutof)
        end if
      end if
      if (lpoint) then
        rij = sqrt(rij)
        call point (rij, ni, nj, w, kr, e2a, e1b, enuclr_loc)
      else
        kr = 1
        call rotate (ni, nj, xi(1, 2), xi(1, 1), w, kr, e2a, e1b, &
       & enuclr_loc)
      end if
      if (id /= 0) then
        do i = 1, kr - 1
          wk(i) = w(i)
        end do
        if (mode == 1) then
          cutoff = (w(1) < wlim)
        end if
        if (cutoff) then
          do i = 1, kr - 1
            wk(i) = 0.d0
          end do
        end if
      end if
      !
      !    * ENUCLR IS SUMMED OVER CORE-CORE REPULSION INTEGRALS.
      !
      i2 = 0
      do i1 = ja, jc
        ii = i1 * (i1-1) / 2 + ja - 1
        do j1 = ja, i1
          ii = ii + 1
          i2 = i2 + 1
          h(ii) = h(ii) + e1b(i2)
          f(ii) = f(ii) + e1b(i2)
        end do
      end do
      i2 = 0
      do i1 = ia, ic
        ii = i1 * (i1-1) / 2 + ia - 1
        do j1 = ia, i1
          ii = ii + 1
          i2 = i2 + 1
          h(ii) = h(ii) + e2a(i2)
          f(ii) = f(ii) + e2a(i2)
        end do
      end do
      i = -2
      call fock2 (f, p, pa, w, w, wk, i, nfirst_loc, nlast_loc, 1)
    else
      enuclr_loc = 0.d0
    end if
    ee = helect (nlast_loc(2), pa, h, f)
    if (uhf) then
      do i = 1, linear
        f(i) = h(i)
      end do
      i = -2
      call fock2 (f, p, pb, w, w, wk, i, nfirst_loc, nlast_loc, 1)
      ee = ee + helect (nlast_loc(2), pb, h, f)
    else
      ee = ee * 2.d0
    end if
    dener = ee + enuclr_loc
end subroutine dhc

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

 subroutine extract_parameter (iparam, ielmnt, param)
!
    use parameters_C, only : guess1, guess2, guess3, zs, zp, zd, &
    betas, betap, betad, alp, zsn, zpn, zdn, uss, upp, udd, gss, gpp, &
    gsp, gp2, hsp, pocord, xfac, alpb, f0sd_store, g2sd_store, v_par, &
    n_partyp_fn, n_partyp_alpb
    implicit none
    integer, intent (in) :: iparam
    integer, intent (in) :: ielmnt
    double precision, intent (inout) :: param
!------------------------------------------------------------
    integer :: kfn, ni, nj, jparam
!------------------------------------------------------------
    jparam = iparam
    kfn = 0
    if (jparam > n_partyp_fn - 1 .and. jparam < n_partyp_alpb) then
      kfn = (jparam - n_partyp_fn) / 3
      jparam = jparam - kfn * 3
      kfn = kfn + 1
    end if
    select case (jparam)
    case (2)
      param = upp(ielmnt)
    case (3)
      param = udd(ielmnt)
    case (4)
      param = zs(ielmnt)
    case (5)
      param = zp(ielmnt)
    case (6)
      param = zd(ielmnt)
    case (7)
      param = betas(ielmnt)
    case (8)
      param = betap(ielmnt)
    case (9)
      param = betad(ielmnt)
    case (10)
      param = gss(ielmnt)
    case (11)
      param = gsp(ielmnt)
    case (12)
      param = gpp(ielmnt)
    case (13)
      param = gp2(ielmnt)
    case (14)
      param = hsp(ielmnt)
    case (15)
      param = f0sd_store(ielmnt)
    case (16)
      param = g2sd_store(ielmnt)
    case (17)
      param = pocord(ielmnt)
    case (18)
      param = alp(ielmnt)
    case (19)
      param = zsn(ielmnt)
    case (20)
      param = zpn(ielmnt)
    case (21)
      param = zdn(ielmnt)
!
!  Add in C_ZET to C_XHI here
!
    case (27)
      param = guess1(ielmnt, kfn)
    case (28)
      param = guess2(ielmnt, kfn)
    case (29)
      param = guess3(ielmnt, kfn)
    case (25)
      write (6, "(' YOU ARE NOT ALLOWED TO OPTIMIZE THIS PARAMETER!')")
      stop
    case (39)
      nj = ielmnt/200
      ni = ielmnt - nj*200
      param = alpb(ni, nj)
    case (40)
      nj = ielmnt/200
      ni = ielmnt - nj*200
      param = xfac(ni, nj)
    case (41)
      param = v_par(ielmnt)
    case default
      param = uss(ielmnt)
    end select
    return
end subroutine extract_parameter

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

   subroutine dihed(xyz, i, j, k, l, angle)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
   use funcon_C, only : pi
   use common_arrays_C, only: tvec
   use molkst_C, only : id, l11, l21, l31
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
   implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
   integer , intent(in) :: i
   integer , intent(in) :: j
   integer , intent(in) :: k
   integer , intent(in) :: l
   double precision, intent (out)  :: angle
   double precision , intent(in) :: xyz(3,*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
   double precision :: xi1, xj1, xl1, yi1, yj1, yl1, zi1, zj1, zl1, dist, cosa, &
     ddd, yxdist, xi2, xl2, yi2, yl2, costh, sinth, cosph, sinph, yj2, yi3, &
     yl3, rmin_ik, rmin_jk, rmin_lk, Vab_ik(3), Vab_jk(3), Vab_lk(3), Vab(3), &
     Rab
   integer :: ii, jj, kk
!-----------------------------------------------
!********************************************************************
!
!      DIHED CALCULATES THE DIHEDRAL ANGLE BETWEEN ATOMS I, J, K,
!            AND L.  THE CARTESIAN COORDINATES OF THESE ATOMS
!            ARE IN ARRAY XYZ.
!
!     DIHED IS A MODIFIED VERSION OF A SUBROUTINE OF THE SAME NAME
!           WHICH WAS WRITTEN BY DR. W. THIEL IN 1973.
!
!********************************************************************
  if (id == 0) then
     xi1 = xyz(1,i) - xyz(1,k)
     xj1 = xyz(1,j) - xyz(1,k)
     xl1 = xyz(1,l) - xyz(1,k)
     yi1 = xyz(2,i) - xyz(2,k)
     yj1 = xyz(2,j) - xyz(2,k)
     yl1 = xyz(2,l) - xyz(2,k)
     zi1 = xyz(3,i) - xyz(3,k)
     zj1 = xyz(3,j) - xyz(3,k)
     zl1 = xyz(3,l) - xyz(3,k)
   else
     rmin_ik = 1.d8
     rmin_jk = 1.d8
     rmin_lk = 1.d8
     Vab_ik = 0.d0
     Vab_jk = 0.d0
     Vab_lk = 0.d0
     do ii = -l11, l11
       do jj = -l21, l21
         do kk = -l31, l31
           Vab = xyz(:,i) - xyz(:,k) + tvec(:,1)*ii + tvec(:,2)*jj + tvec(:,3)*kk
           Rab = Vab(1)**2 + Vab(2)**2 + Vab(3)**2
           if (Rab < rmin_ik) then
             rmin_ik = Rab
             Vab_ik = Vab
           end if
           Vab = xyz(:,j) - xyz(:,k) + tvec(:,1)*ii + tvec(:,2)*jj + tvec(:,3)*kk
           Rab = Vab(1)**2 + Vab(2)**2 + Vab(3)**2
           if (Rab < rmin_jk) then
             rmin_jk = Rab
             Vab_jk = Vab
           end if
           Vab = xyz(:,l) - xyz(:,k) + tvec(:,1)*ii + tvec(:,2)*jj + tvec(:,3)*kk
           Rab = Vab(1)**2 + Vab(2)**2 + Vab(3)**2
           if (Rab < rmin_lk) then
             rmin_lk = Rab
             Vab_lk = Vab
           end if
         end do
       end do
     end do
     xi1 = Vab_ik(1)
     xj1 = Vab_jk(1)
     xl1 = Vab_lk(1)
     yi1 = Vab_ik(2)
     yj1 = Vab_jk(2)
     yl1 = Vab_lk(2)
     zi1 = Vab_ik(3)
     zj1 = Vab_jk(3)
     zl1 = Vab_lk(3)
   end if
!      ROTATE AROUND Z AXIS TO PUT KJ ALONG Y AXIS
   dist = sqrt(xj1*xj1 + yj1*yj1 + zj1*zj1)
   cosa = zj1/dist
   cosa = min(1.0D0,cosa)
   cosa = dmax1(-1.0D0,cosa)
   ddd = 1.0D0 - cosa**2
   if (ddd <= 0.0D0) go to 10
   yxdist = dist*sqrt(ddd)
   if (yxdist > 1.0D-6) go to 20
    10 continue
   xi2 = xi1
   xl2 = xl1
   yi2 = yi1
   yl2 = yl1
   costh = cosa
   sinth = 0.D0
   go to 30
    20 continue
   cosph = yj1/yxdist
   sinph = xj1/yxdist
   xi2 = xi1*cosph - yi1*sinph
   xl2 = xl1*cosph - yl1*sinph
   yi2 = xi1*sinph + yi1*cosph
   yj2 = xj1*sinph + yj1*cosph
   yl2 = xl1*sinph + yl1*cosph
!      ROTATE KJ AROUND THE X AXIS SO KJ LIES ALONG THE Z AXIS
   costh = cosa
   sinth = yj2/dist
    30 continue
   yi3 = yi2*costh - zi1*sinth
   yl3 = yl2*costh - zl1*sinth
   call dang (xl2, yl3, xi2, yi3, angle)
!     6.2831853  IS 2 * 3.1415926535 = 180 DEGREE
   if (angle < 0.) angle = pi*2.d0 + angle
   if (angle >= 6.28318530717959D0) angle = 0.D0
   return
   end subroutine dihed

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

 subroutine run_param
 !dec$ attributes dllexport :: run_param
    use param_global_C, only : numvar, large, power, ifiles_8, &
    & contrl, fnsnew, nfns, xparamp, diffns, fns, penalty, &
    save_parameters
!
    use molkst_C, only : tdump, maxatoms, is_PARAM, numat, jobnam, &
     moperr, &
     norbs, mpack, nvar, n2elec, keywrd, keywrd_quoted, uhf, l123, run, method_pm6_d3, &
     method_pm6, lm61, tleft, &
     method_pm6_dh_plus, method_pm6_dh2, method_pm7, trunc_1, method_pm8, &
     trunc_2, method_pm6_d3h4, method_pm6_d3_not_h4, n_methods, methods, &
     methods_keys, method_pm7_hh, method_pm7_minus, method_pm7_ts, method_pm6_dh2x, &
     method_pm6_d3h4x, backslash, os, git_hash, verson
    use cosmo_C, only : iseps, nspa
!
    use common_arrays_C, only:  atmass, na, nb, nc, geoa, p, nw
!
    use chanel_C, only : ir, iw, ilog, job_fn, input, iarc, ifiles_1
    use funcon_C, only : fpc_1, fpc_2, a0, ev, fpc_6, fpc_7, fpc_8, &
    & fpc_9, fpc_10, fpc_5
    use conref_C, only : fpcref
    use meci_C, only : nmos
    use parameters_C, only: f0sd, g2sd, tore, ios, iop, iod, f0sd_store, g2sd_store, &
      zs, t_par
    USE journal_references_C, only : allref
    implicit none
    logical :: opend, exists, quotation_mark
    integer :: i, j, l, k, loop, maxcyc, n9, n4, n1
    double precision :: sum
    character :: text*2000, idate*24
  !
  !
  !.. External Calls ..
    external finish, getdat
  !
  !.. External Functions ..
    double precision, external :: Reada
  !
  !.. Intrinsic Functions ..
    intrinsic Index
  !
  ! ... Executable Statements ...
  !
  !
! set versioning information
#ifdef MOPAC_VERSION_FULL
    verson = MOPAC_VERSION_FULL
#endif
#ifdef MOPAC_OS
    os = MOPAC_OS
#endif
#ifdef MOPAC_GIT_HASH
    git_hash = MOPAC_GIT_HASH
#endif
  ! parse command-line flags
#ifdef MOPAC_F2003
    do i = 1, command_argument_count()
      call get_command_argument (i, jobnam)
#else
    do i = 1, iargc()
      call getarg (i, jobnam)
#endif
      if (jobnam == '-V' .OR. jobnam == '--version') then
        write(*,"(a)") "PARAM version "//trim(verson)//" commit "//trim(git_hash)
        stop
      endif
    end do
!------------------------------------------------------------------------
    t_par(1)  = "Used in ccrep for scalar correction of C-C triple bonds."
    t_par(2)  = "Used in ccrep for exponent correction of C-C triple bonds."
    t_par(3)  = "Used in ccrep for scalar correction of O-H term."
    t_par(4)  = "Used in ccrep for exponent correction of C-C triple bonds."
    t_par(7)  = "Used in dftd3 to set ""s6""  in D3H4"
    t_par(8)  = "Used in dftd3 to set ""alp"" in D3H4"
    t_par(9)  = "Used in dftd3 to set ""rs6"" in D3H4"
    ifiles_8 = 8
    ifiles_1 = ifiles_8
    power = 2.0d0
    tore = ios + iop + iod
    is_PARAM = .true.
    run = 1
    call mopac_version(verson)
#ifdef MOPAC_OS
    os = MOPAC_OS
#endif

      call fbx   ! Factorials and Pascal's triangle (pure constants)
      call fordd ! More constats, for use by MNDO-d
  !
  !  one-time construction of arrays in setalp
  !
  !  call setalp_init
  !  time0 = second (1)
  !
  !  Disable MOPAC test for the presence of parameters
  !
    do i = 1, 107
      do j = 1, 5
        allref (i, j) (1:1) = " "
      end do
    end do
  !
  ! Read in all the data in the file "<filename>.dat", and put it
  ! in an internal file.
  !
    call getdat(input, ifiles_8)
    if (moperr) then
      call finish
    end if
    job_fn = Trim (jobnam) // ".dat"
    inquire (file=job_fn, exist=exists)
    if (.not. exists) then
      open(unit=ifiles_8, file=trim(jobnam)//'.out')
      write(ifiles_8,'(//10x,a,/10x,a)')"File: """//trim(job_fn)//"""", &
      "does not exist in this folder, therefore this job cannot be run."
      call finish
    end if
    job_fn = Trim (jobnam) // ".mop"
    inquire (file=job_fn, exist=exists)
    if (exists) then
      write(ifiles_8,*)"File ",job_fn," exists, therefore job cannot be run."
      call finish
    end if
  !
  !  Open output results
  !
    i = len_trim(jobnam)
    k = Index (contrl, "OUT=")
    if (k /= 0) then
      j = Index (contrl(k+4:), " ")
      text = contrl (k+4:k+j+2) // jobnam (:i) // ".out"
    else
      text = jobnam (:i) // ".out"
    end if
  97  open (unit=ifiles_8, file=text, status="UNKNOWN", iostat=i)
    if (i /= 0) then
      write(0,*)" Output file '"//trim(text)//"' is busy.  Correct the fault or kill this job"
      call sleep (10)
      go to 97
    end if
    goto 100
  !
  !  Open input data set
  !
100 rewind (input)
    i = 0
    do
      read (input, "(A120)") text
      i = i + 1
      if (text(1:1) /= "*") exit
      write (ifiles_8,"(a)") Trim(text)
    end do
    close (ir)
    ir = input
    rewind (ir)
  !
  !  Read in keywords for PARAM control
  !
    read (ir, "(a)",end = 99, err = 98) contrl
    do
      i = Index(contrl," +") + Index(contrl," &")
      if ( i /= 0) then
        contrl(i + 1:i + 1) = " "
        text = " "
        read (ir, "(a)",end = 99, err = 98) text
        if (text == " ") cycle
        do
          if (text(1:1) /= " ") exit
          text = text(2:)
        end do
        if (text(1:1) == '"') then
          contrl(len_trim(contrl) + 1:) = trim(text)
        else
          contrl(len_trim(contrl) + 1:) = " "//trim(text)
        end if
      else
        exit
      end if
    end do

  !
  !  Force character 1 to be a space
  !
    if (contrl(1:1) /= " ") then
     text = " " // trim(contrl)
      contrl = text
    else
      text = trim(contrl)
    end if
    call upcase (contrl, len_trim(contrl))
    j = 1
    do
      l = Index (contrl(j:), '"') + j
      if (l /= j) then
!
!  Find a quotation mark - if found, preserve the case of the text between quotation marks
!
        k = Index (contrl(l:), '"') + l
        if (k /= l) then
          contrl(l:k) = text(l:k)
        else
          if (len_trim(text(l - 1:)) < 20) then
            write (ifiles_8,"(a)") "Unmatched quotation marks in keyword line near: '"//trim(text(max(1,l - 20):))//"'"
          else
            write (ifiles_8,"(a)") "Unmatched quotation marks in keyword line near: '"//trim(text(l - 1:))//"'"
          end if
          call finish
        end if
        j = k + 1
      else
        exit
      end if
    end do
!
! Find an equals sign. Then find the first space that is not in a quoted string.
!
    j = 1
    quotation_mark = .false.
    k = len_trim(contrl)
    do i = 1, k
      j = j + 1
      if (j > k) exit
      if (contrl(j:j) == '=') then
        do l = j + 1, k
          if (contrl(l:l) == " " .and. .not. quotation_mark) exit
          if (contrl(l:l) == '"') quotation_mark = (.not. quotation_mark)
        end do
!
!  Preserve the case of the text after the equals sign in this keyword.
!
        contrl(j:l - 1) = text(j:l - 1)
        j  = l
      end if
    end do
!
! Convert all bad slashes into good slashes
!
    do
      i = index(contrl, backslash)
      if (i == 0) exit
      contrl(i:i) = "/"
    end do
    trunc_1 = 7.0d0
    trunc_2 = 0.22d0
!
!   HERE IS WHERE THE MAXIMUM NUMBER OF ATOMS IN ANY SYSTEM IS SET
!
    if (Index(contrl," EPS") /= 0) then
      n1 = 20             !  Number of atoms with 1 basis function
      n4 = 20             !  Number of atoms with 4 basis functions
      n9 = 10             !  Number of atoms with 9 basis functions
      iseps = .true.
      nspa = 42
      lm61 = 45*n9 + 10*n4 + n1
    else
      n1 = 200            !  Number of atoms with 1 basis function
      n4 = 304            !  Number of atoms with 4 basis functions
      n9 = 100            !  Number of atoms with 9 basis functions
      lm61 = 0
      iseps = .false.
    end if

!
!
    maxatoms = n1 + n4 + n9
    call setup_mopac_arrays(maxatoms, 1)
    allocate(nw(maxatoms))
    norbs = 9*n9 + 4*n4 + n1
    mpack = (norbs*(norbs + 1))/2
    numat = maxatoms
    nvar = 3*maxatoms
    n2elec = 2025*n9+100*n4+n1+2025*(n9*(n9-1))/2+450*n9*n4+45*n9*n1+&
     & 100*(n4*(n4-1))/2+10*n4*n1+ (n1*(n1-1))/2+10

    nmos = 12
    l123 = 1000
    uhf = .true.
    call setup_mopac_arrays(1,2)
    allocate(geoa(3,maxatoms))
    na(:) = 0
    nb(:) = 0
    nc(:) = 0
    atmass = 1.d0
    if (Index(contrl, "OLDFPC") == 0)then
  !
  ! Load in the modern (CODATA) fundamental constants
    !
      fpc_1 = fpcref(1, 1)
      fpc_2 = fpcref(1, 2)
      a0 = fpcref(1, 3)
      ev = fpcref(1, 4)
      fpc_5 = fpcref(1, 5)
      fpc_6 = fpcref(1, 6)
      fpc_7 = fpcref(1, 7)
      fpc_8 = fpcref(1, 8)
      fpc_9 = fpcref(1, 9)
      fpc_10 = fpcref(1, 10)
    else
  !
  ! Load in the old (CODATA) fundamental constants
  !
      fpc_1 = fpcref(2, 1)
      fpc_2 = fpcref(2, 2)
      a0 = fpcref(2, 3)
      ev = fpcref(2, 4)
      fpc_5 = fpcref(2, 5)
      fpc_6 = fpcref(2, 6)
      fpc_7 = fpcref(2, 7)
      fpc_8 = fpcref(2, 8)
      fpc_9 = fpcref(2, 9)
      fpc_10 = fpcref(2, 10)
    end if
    i = Index(contrl," POWER")
    if (i /= 0) power = Reada(contrl, i)
    do i = 1, n_methods
      methods(i) = (index(contrl, trim(methods_keys(i))//" ") /= 0)
    end do
    do i = 1, n_methods
      if (methods(i)) exit
    end do
!
!  Define parent methods "method_PM6" and "method_PM7" for variants of these methods
!
    method_pm7 = (method_PM7 .or. method_PM7_ts .or. method_pm7_hh .or. method_pm7_minus)
    method_pm6 = (method_PM6 .or. method_pm6_dh2 .or. method_pm6_d3h4 .or. method_pm6_dh_plus .or. &
    & method_pm6_dh2x .or. method_pm6_d3h4x .or. method_pm6_d3 .or. method_pm6_d3_not_h4)
!
! Default method is PM8
!
    if (.not. method_pm8) then
        do i = 1, n_methods
          if (methods(i)) exit
        end do
        if (i > n_methods) then
          i = 14
          method_pm8 = .true.
        end if
    end if
    tdump = 1.d8 ! (a long time)
    tleft=1.d6
!
!  Write out output banner
!
96 write (ifiles_8, "(1x,15('*****')//18x,'PARAMETRIZATION CALCULATION RESULTS',//1x,15('*****'))", iostat = i)
    if (i /= 0) then
      write(0,*)" Output file '"//trim(jobnam)//".out' is busy.  Correct the fault or kill this job"
      call sleep (10)
      go to 96
    end if
    idate = " "
    call fdate (idate)
    write (ifiles_8, "(' *',50x,A24)") idate
    keywrd = contrl
    call parkey (contrl)
    contrl = trim(keywrd)
    write (ifiles_8, "(' *',/1X,15('*****'))")
    call switch
!
!
    penalty = 10000.d0  ! Contribution to SSQ = penalty*error**2
!
!
!
! Read in all data relating to parameters
!
    j = iw
    iw = ifiles_8
    if (index(keywrd, " PARAMS=") + index(keywrd, " EXTERNAL") + index(keywrd_quoted, " EXTERNAL=") /= 0) call datin(ir, ifiles_8)
    iw = j
    if (moperr) stop
    call getpar
    if ((Index (contrl, " CHKPAR") /= 0) .and. numvar == 0) then
      write(ifiles_8,*)" No parameters therefore parameter ", &
      &" independence cannot be determined"
      call finish
    end if
    do i = 1,90
    if (f0sd_store(i) < 1.d-5) f0sd_store(i) = f0sd(i)
    if (g2sd_store(i) < 1.d-5) g2sd_store(i) = g2sd(i)
    end do
    do i = 57, 71
      if (zs(i) < 0.1d0) tore(i) = 3.d0
    end do
    call fractional_metal_ion
    call l_control(trim("ifiles_8=8"), len_trim("ifiles_8=8"), 1)
    call calpar
    if (Index (contrl, " CC") /= 0) then
    end if
    save_parameters = (Index (contrl, " NOSAVEP") == 0)
!
! Read in all data relating to reference data
!
    i = size(p)
    deallocate(p)
    call datinp()
    text = trim(jobnam)//".F90"
    j = iw
    iw = ifiles_8
    ! call create_parameters_for_PMx_C(text, "7")
    iw = j
    allocate(p(i))
    call fractional_metal_ion
    large = (Index (contrl, " LARGE") /= 0)
!
!  Unconditionally, do not generate MOPAC log files
!
    inquire (unit=ilog, opened=opend)
    if (opend) then
      close (unit=ilog, status="DELETE")
    end if
    open (unit=ilog, status="SCRATCH", form="FORMATTED")
!
!  Do NOT generate normal MOPAC output, unless "LARGE" is present.
!
    if (large) then
      inquire (unit=iw, opened=opend)
      if (opend) then
        close (unit=iw, status="DELETE")
      end if
      i = Index (jobnam, " ") - 1
      inquire (unit=iarc, opened=opend)
      if (opend) close(iarc)
      open (unit=iw, file=jobnam(:len_trim(jobnam))//".arc", status="UNKNOWN")
      rewind (iw)
    else
      open (unit=iw, status="SCRATCH", form="FORMATTED")
    end if
  !***********************************************************************
  !
  !   Different functions within PARAM
  !
  !***********************************************************************
    if (Index (contrl, " CHKPAR") /= 0) then
    !
    ! Check the parameter set to see if it is well-defined
    !
      call direct(1)
      call chkpar
      write (ifiles_8, "(//20X,A)") " PARAM FINISHED"
      call finish
      stop
    end if
    if (Index (contrl, " SURVEY") /= 0) then
    !
    !   Generate publication-quality tables
    !
      call partab
      call finish
    end if
    if (numvar < 1) then
    !
    ! Compute the error function, but do not optimize any parameters.
    !
      call direct (1)
      call finish
    end if
    if (Index (contrl, " CYCLES") /= 0) then
      maxcyc = Nint(Reada(contrl,Index (contrl, " CYCLES")))
    else
      maxcyc = 600
    end if
  !
  ! Optimize the parameters
  !
    fnsnew(1) = -1.d7
    do loop = 1, maxcyc
      call direct(loop)
      if (.not. large) then
!
!   Delete scatch files to save storage space
!
        close (iw, iostat=i)
        open (unit=iw, status="SCRATCH", form="FORMATTED", iostat=i)
      end if
      call rapid0 (loop)
      call pparsav(save_parameters)
    !
    !  Calculate the predicted value of the new error function
    !
      do i = 1, nfns
        sum = 0.d0
        do j = 1, numvar
          sum = sum + xparamp(j) * diffns(j, i)
        end do
        fnsnew(i) = fns(i) - sum
      end do
    end do
    call finish
 99 write(*,*)" Data file '",jobnam(:i),".dat' does not exist!"
    call finish
 98 write(*,*)" Data file '",jobnam(:i),".dat' is locked!"
    call finish
 end subroutine run_param

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine deri23(f, fd, e, fci, cmo, emo, ninear, minear)
      use molkst_C, only : norbs, nopen, fract
      use meci_C, only : nelec, nmos, nbo
      implicit none
      integer :: minear, ninear
      double precision , intent(in) :: f(minear)
      double precision , intent(in) :: fd(ninear)
      double precision , intent(in) :: e(norbs)
      double precision  :: fci(minear)
      double precision , intent(out) :: cmo(norbs,norbs)
      double precision  :: emo(*)
      integer :: l, nend, loop, ninit, n1, n2, i, j, ncol
      double precision :: const, diffe, com, scal
!-----------------------------------------------
!**********************************************************************
!  1) UNPACK THE C.I-ACTIVE M.O. DERIVATIVES IN M.O. BASIS,
!     DIAGONAL BLOCKS INCLUDED.
!  2) EXTRACT THE FOCK EIGENVALUES RELAXATION OVER C.I-ACTIVE M.O.
!   INPUT
!     F           : UNSCALED SOLUTIONS VECTOR IN M.O. BASIS,
!                   OFF-DIAGONAL BLOCKS PACKED AS DEFINED IN 'DERI21'.
!     FD          : DIAGONAL BLOCKS OF NON-RELAXED FOCK MATRIX
!                   AS DEFINED IN 'DERI1'.
!     E(NORBS)    : FOCK EIGENVALUES.
!     FCI         : DIAGONAL BLOCKS OF RELAXATION OF THE FOCK MATRIX.
!     NORBS       : NUMBER OF M.O
!     NELEC,NMOS  : # OF LAST FROZEN CORE M.O , C.I-ACTIVE BAND LENGTH.
!   OUTPUT
!     CMO(N,NELEC+1,...,NELEC+NMOS): C.I-ACTIVE M.O DERIVATIVES
!                                  IN M.O BASIS.
!     EMO(  NELEC+1,...,NELEC+NMOS): C.I-ACTIVE FOCK EIGENVALUE RELAXATI
!
!**********************************************************************
!
      nopen = nbo(1) + nbo(2)
      const = 1.D-3
!
!     PART 1.
!     -------
!     COMPUTE AND UNPACK DIAGONAL BLOCKS, DIAGONAL TERMS INCLUDED,
!     ACCORDING TO CMO(I,J) = (FD(I,J)-FCI(I,J))/(E(I)-E(J))
!     AND TAKING   CMO(I,J)=0 IF E(I)=E(J) (THRESHOLD 1D-4 EV),
!                             I.E WHEN M.O. DEGENERACY OCCURS.
      l = 1
      nend = 0
      do loop = 1, 3
        ninit = nend + 1
        nend = nend + nbo(loop)
        n1 = max(ninit,nelec + 1)
        n2 = min(nend,nelec + nmos)
        if (n2 < n1) cycle
        do i = n1, n2
          if (i > ninit) then
            do j = ninit, i - 1
              diffe = e(i) - e(j)
              if (abs(diffe) > 1.D-4) then
                com = (fd(l)-fci(l))/diffe
              else
                com = 0.D0
              end if
              cmo(i,j) = -com
              cmo(j,i) = com
              l = l + 1
            end do
          end if
          cmo(i,i) = 0.D0
        end do
      end do
      ncol = n2 - ninit + 1
      if (ncol > 0 .and. n2 < norbs) then
        do j = ninit, n2
          do i = n2 + 1, norbs
            diffe = e(i) - e(j)
            if (Abs (diffe) > 1.d-4) then
              com = (fd(l)-fci(l)) / diffe
            else
              com = 0.d0
            end if
            cmo(i, j) = -com
            cmo(j, i) = com
            l = l + 1
          end do
        end do
      end if
!
!     C.I-ACTIVE EIGENVALUES RELAXATION.
      call dcopy (nmos, fci(l), 1, emo(nelec+1), 1)
!
!     PART 2.
!     -------
!     UNPACK THE ANTISYMMETRIC MATRIX F IN CMO, (OFF-DIAGONAL BLOCKS).
!
      l = 1
      if (nbo(2)>0 .and. nbo(1)>0) then
!        OPEN-CLOSED
        scal = 1.D0/(2.D0 - fract + const)
        do j = 1, nbo(1)
          do i = nbo(1) + 1, nopen
            com = f(l)*scal
            cmo(i,j) = -com
            cmo(j,i) = com
            l = l + 1
          end do
        end do
      end if
      if (nbo(3)>0 .and. nbo(1)>0) then
!       VIRTUAL-CLOSED
        scal = 0.5D0
        do j = 1, nbo(1)
          do i = nopen + 1, norbs
            com = f(l)*scal
            cmo(i,j) = -com
            cmo(j,i) = com
            l = l + 1
          end do
        end do
      end if
      if (nbo(3)/=0 .and. nbo(2)/=0) then
!        VIRTUAL-OPEN
        scal = 1.D0/(fract + const)
        do j = nbo(1) + 1, nopen
          do i = nopen + 1, norbs
            com = f(l)*scal
            cmo(i,j) = -com
            cmo(j,i) = com
            l = l + 1
          end do
        end do
      end if
      return
      end subroutine deri23

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine flepo(xparam, nvar, funct1)
      use molkst_C, only : numcal, gnorm, iflepo, keywrd, emin, tleft, &
      & time0, moperr, nscf, limscf, tdump, last, cosine, line
      use common_arrays_C, only : hesinv, grad
      USE chanel_C, only : iw, ilog, log, input_fn
      implicit none
      integer  :: nvar
      double precision  :: funct1
      double precision  :: xparam(nvar)
!
      integer , dimension(9) :: mdfp
      integer :: icalcn, igg1, nrst, ihdim, itry1, jcyc, lnstop, irepet, jnrst&
        , ncount, maxcyc, i, ireset, icyc, i80, ii, j, k, nto6, &
        iinc1, iinc2, ic
      double precision, dimension(nvar) :: xvar, gvar, xd, gd, glast, xlast, gg, &
        pvect
      double precision, dimension(9) :: xdfp
      double precision :: rst, sfact, dell, einc, del, const, rootv, delhof, tolerf&
        , tolerg, tolrg, tolerx, drop, frepf, cncadd, absmin, alpha, pnorm, &
        cycmx, cos, tx1, tx2, tlast, totime, therb, gnormr, step, funct2, &
        gdnorm, sum, deltag, deltax, ggd, yhy, sy, xvari, ggi, pnlast, dott, &
        beta, smval, dropn, totim, xn, tx, tf, bsmvf, tcycle, tprt
      logical :: restrt, geook, dfp, saddle, minprt, print, thiel, okf, &
        resfil, lgrad
      character :: txt
      double precision, external :: ddot, reada, seconds
      save mdfp, icalcn, rst, sfact, dell, einc, igg1, del, restrt, geook, dfp&
        , const, saddle, minprt, rootv, print, delhof, tolerf, tolerg, nrst, &
        thiel, tolrg, tolerx, drop, frepf, ihdim, cncadd, absmin, itry1, &
        okf, jcyc, lnstop, irepet, alpha, pnorm, jnrst, cycmx, cos, ncount, &
        resfil, tx1, tx2, tlast, totime, maxcyc
!-----------------------------------------------
!
!     *
!     THIS SUBROUTINE ATTEMPTS TO MINIMIZE A REAL-VALUED FUNCTION OF
!     THE N-COMPONENT REAL VECTOR XPARAM ACCORDING TO THE
!     BFGS FORMULA. RELEVANT REFERENCES ARE
!
!     BROYDEN, C.G., JOURNAL OF THE INSTITUTE FOR MATHEMATICS AND
!                     APPLICATIONS, VOL. 6 PP 222-231, 1970.
!     FLETCHER, R., COMPUTER JOURNAL, VOL. 13, PP 317-322, 1970.
!
!
!     SHANNO, D.F. MATHEMATICS OF COMPUTATION, VOL. 24, PP 647-656
!                    1970.
!
!   SEE ALSO SUMMARY IN
!
!    HEAD, J.D.; AND ZERNER, M.C., CHEMICAL PHYSICS LETTERS, VOL. 122,
!          264 (1985).
!    SHANNO, D.F., J. OF OPTIMIZATION THEORY AND APPLICATIONS
!          VOL.46, NO 1 PP 87-94 1985.
!     *
!     THE FUNCTION CAN ALSO BE MINIMIZED USING THE
!     DAVIDON-FLETCHER-POWELL ALGORITHM (COMPUTER JOURNAL, VOL. 6,
!     P. 163).
!
!     THE USER MUST SUPPLY THE SUBROUTINE
!     COMPFG(XPARAM,.TRUE.,FUNCT,.TRUE.,GRAD,LGRAD)
!     WHICH COMPUTES FUNCTION VALUES  FUNCT AT GIVEN VALUES FOR THE
!     VARIABLES XPARAM, AND THE GRADIENT GRAD IF LGRAD=.TRUE.
!     THE MINIMIZATION PROCEEDS BY A SEQUENCE OF ONE-DIMENSIONAL
!     MINIMIZATIONS.  THESE ARE CARRIED OUT WITHOUT GRADIENT COMPUTATION
!     BY THE SUBROUTINE LINMIN, WHICH SOLVES THE SUBPROBLEM OF
!     MINIMIZING THE FUNCTION FUNCT ALONG THE LINE XPARAM+ALPHA*PVECT,
!     WHERE XPARAM
!     IS THE VECTOR OF CURRENT VARIABLE VALUES,  ALPHA IS A SCALAR
!     VARIABLE, AND  PVECT  IS A SEARCH-DIRECTION VECTOR PROVIDED BY THE
!     BFGS OR DAVIDON-FLETCHER-POWELL ALGORITHM.  EACH ITERATION STEP CA
!     OUT BY FLEPO PROCEEDS BY LETTING LINMIN FIND A VALUE FOR ALPHA
!     WHICH MINIMIZES  FUNCT  ALONG  XPARAM+ALPHA*PVECT, BY
!     UPDATING THE VECTOR  XPARAM  BY THE AMOUNT ALPHA*PVECT, AND
!     FINALLY BY GENERATING A NEW VECTOR  PVECT.  UNDER
!     CERTAIN RESTRICTIONS (POWELL, J.INST.MATHS.APPLICS.(1971),
!     V.7,21-36)  A SEQUENCE OF FUNCT VALUES CONVERGING TO SOME
!     LOCAL MINIMUM VALUE AND A SEQUENCE OF
!     XPARAM VECTORS CONVERGING TO THE CORRESPONDING MINIMUM POINT
!     ARE PRODUCED.
!                          CONVERGENCE TESTS.
!
!     HERBERTS TEST: THE ESTIMATED DISTANCE FROM THE CURRENT POINT
!                    POINT TO THE MINIMUM IS LESS THAN TOLERA.
!
!                    "HERBERTS TEST SATISFIED - GEOMETRY OPTIMIZED"
!
!     GRADIENT TEST: THE GRADIENT NORM HAS BECOME LESS THAN TOLERG
!                    TIMES THE SQUARE ROOT OF THE NUMBER OF VARIABLES.
!
!                    "TEST ON GRADIENT SATISFIED".
!
!     XPARAM TEST:  THE RELATIVE CHANGE IN XPARAM, MEASURED BY ITS NORM,
!                   OVER ANY TWO SUCCESSIVE ITERATION STEPS DROPS BELOW
!                   TOLERX.
!
!                    "TEST ON XPARAM SATISFIED".
!
!     FUNCTION TEST: THE CALCULATED VALUE OF THE HEAT OF FORMATION
!                    BETWEEN ANY TWO CYCLES IS WITHIN TOLERF OF
!                    EACH OTHER.
!
!                    "HEAT OF FORMATION TEST SATISFIED"
!
!     FOR THE GRADIENT, FUNCTION, AND XPARAM TESTS A FURTHER CONDITION,
!     THAT NO INDIVIDUAL COMPONENT OF THE GRADIENT IS GREATER
!     THAN TOLERG, MUST BE SATISFIED, IN WHICH CASE THE
!     CALCULATION EXITS WITH THE MESSAGE
!
!                     "PETERS TEST SATISFIED"
!
!     WILL BE PRINTED, AND FUNCT AND XPARAM WILL CONTAIN THE LAST
!     FUNCTION VALUE CUM VARIABLE VALUES REACHED.
!
!
!     ALGORITHMS CHOOSE SEARCH DIRECTIONS
!     ON THE BASIS OF LOCAL PROPERTIES OF THE FUNCTION.  A MATRIX  H,
!     WHICH IN FLEPO IS PRESET WITH THE IDENTITY, IS MAINTAINED AND
!     UPDATED AT EACH ITERATION STEP.  THE MATRIX DESCRIBES A LOCAL
!     METRIC ON THE SURFACE OF FUNCTION VALUES ABOVE THE POINT XPARAM.
!     THE SEARCH-DIRECTION VECTOR  PVECT  IS SIMPLY A TRANSFORMATION
!     OF THE GRADIENT  GRAD  BY THE MATRIX H.
!
      equivalence (mdfp(1), jcyc), (mdfp(2), jnrst), (mdfp(3), ncount), (mdfp(4&
        ), lnstop), (xdfp(1), alpha), (xdfp(2), cos), (xdfp(3), pnorm), (xdfp(4&
        ), drop), (xdfp(5), del), (xdfp(6), frepf), (xdfp(7), cycmx), (xdfp(8)&
        , totime)
      data icalcn/ 0/
!
!   START OF ONCE-ONLY SECTION
!
      emin = 0.D0
      smval = 0.d0
      gnormr = 0.d0
      beta = 0.d0
      therb = 0.d0
      icyc = 0
      if (icalcn /= numcal) then
        if (allocated(hesinv)) deallocate(hesinv)
        allocate (hesinv((nvar*(nvar+1))/2))
        hesinv = 0.0d0
!
!   THE FOLLOWING CONSTANTS SHOULD BE SET BY THE USER.
!
        rst = -1.D0
        nrst = 30
        sfact = 1.5D0
        dell = 0.01D0
        einc = 0.3D0
        igg1 = 3
        del = dell
!
!    THESE CONSTANTS SHOULD BE SET BY THE PROGRAM.
!
        maxcyc = 100000
        if (index(keywrd,' CYCLES') /= 0) maxcyc = nint(reada(keywrd,index(&
          keywrd,' CYCLES')))
        restrt = index(keywrd,'RESTAR') /= 0
        thiel = index(keywrd,'NOTHIE') == 0
        geook = index(keywrd,'GEO-OK') /= 0
        saddle = index(keywrd,'SADDLE') /= 0
        minprt = .not.saddle
        const = 1.D0
!
!      THE DAVIDON-FLETCHER-POWELL METHOD IS NOT RECOMMENDED
!      BUT CAN BE INVOKED BY USING THE KEYWORD 'DFP'
!
        dfp = index(keywrd,'DFP') /= 0
!
!  ORDER OF PRECISION:   'GNORM' TAKES PRECEDENCE OVER 'FORCE', WHICH
!                        TAKES PRECEDENCE OVER 'PRECISE'.
        tolerg = 1.0D0
        if (index(keywrd,'PREC') /= 0) tolerg = 0.2D0
        if (index(keywrd,'FORCE') /= 0) tolerg = 0.1D0
!
!      READ IN THE GRADIENT-NORM LIMIT, IF SPECIFIED
!
        if (index(keywrd,'GNORM=') /= 0) then
          rootv = 1.D0
          const = 1.D-20
          tolerg = reada(keywrd,index(keywrd,'GNORM='))
          if (index(keywrd,' LET')==0 .and. tolerg<1.D-2) then
            write (iw, '(/,A)') '  GNORM HAS BEEN SET TOO LOW, RESET TO 0.01'
            tolerg = 1.D-2
          end if
        else
          rootv = sqrt(nvar + 1.D-5)
        end if
        tolerx = 0.0001D0*const
        delhof = 0.0010D0*const
        tolerf = 0.002D0*const
        tolrg = tolerg
        if (index(keywrd,'PREC') /= 0) then
          tolerx = tolerx*0.01D0
          delhof = delhof*0.01D0
          tolerf = tolerf*0.01D0
          einc = einc*0.01D0
        end if
        therb = 5.D0*tolerg*rootv
!
!  MINOR BOOK-KEEPING
!
        tlast = tleft
        tx2 = seconds(2)
        tleft = tleft - tx2 + time0
        print = index(keywrd,'FLEPO') /= 0
!
!   THE FOLLOWING CONSTANTS SHOULD BE SET TO SOME ARBITARY LARGE VALUE.
!
        drop = 1.D15
        frepf = 1.D15
!
!     AND FINALLY, THE FOLLOWING CONSTANTS ARE CALCULATED.
!
        ihdim = (nvar*(nvar + 1))/2
        cncadd = 1.0D00/rootv
        cncadd = min(0.15D00,cncadd)
        icalcn = numcal
        if (restrt .and. nvar > 0) then
          jnrst = 1
          mdfp(9) = 0
          gd = 0.d0
          xlast = 0.d0
          call dfpsav (totime, xparam, gd, xlast, funct1, mdfp, xdfp)
          if (moperr) return
          jcyc = jcyc - 1
          i = int(totime/1000000.D0)
          totime = totime - i*1000000.D0
          time0 = time0 - totime
          nscf = mdfp(5)
          write (iw, &
      '(2/10X,''TOTAL TIME USED SO FAR:'',                   F13.2,'' SECONDS''&
      &)') totime
          if (index(keywrd,' 1SCF') /= 0) then
            last = 1
            lgrad = index(keywrd,' GRAD') /= 0
            call compfg (xparam, .TRUE., funct1, .TRUE., grad, lgrad)
            if (moperr) return
            iflepo = 13
            emin = 0.D0
            return
          end if
        end if
!
!   END OF ONCE-ONLY SETUP
!
      end if
!
!     FIRST, WE INITIALIZE THE VARIABLES.
!
      ireset = 0
      absmin = 1.D6
      itry1 = 0
      jcyc = 0
      lnstop = 1
      irepet = 1
      limscf = .TRUE.
      alpha = 1.0D00
      pnorm = 1.0D00
      jnrst = 0
      cycmx = 0.D0
      cos = 0.0D00
      totime = 0.D0
      ncount = 1
      resfil = .FALSE.
      if (const>1.D-5 .and. saddle) then
!
!   WE DON'T NEED HIGH PRECISION DURING A SADDLE-POINT CALCULATION.
!
! For Mopac BLAS
!        if (nvar > 0) gnorm = sqrt(dot(grad,grad,nvar)) - 3.D0
        if (nvar > 0) gnorm = dsqrt(ddot(nvar,grad,1,grad,1)) - 3.D0

!
        gnorm = min(10.D0,gnorm)
        if (gnorm > 1.D0) tolerg = tolrg*gnorm
        write (iw, '('' GRADIENT CRITERION IN FLEPO ='',F10.3)') tolerg
      end if
      if (nvar == 1) then
        pvect(1) = 0.01D0
        alpha = 1.D0
        go to 270
      end if
      totime = 0.D0
!
! CALCULATE THE VALUE OF THE FUNCTION -> FUNCT1, AND GRADIENTS -> GRAD.
! NORMAL SET-UP OF FUNCT1 AND GRAD, DONE ONCE ONLY.
!
      call compfg (xparam, .TRUE., funct1, .TRUE., grad, .TRUE.)
      iflepo = 16
      if (nvar == 0) return
      if (moperr) return
      call dcopy (nvar, grad, 1, gd, 1)
      if (nvar /= 0) then
! For Mopac BLAS
!        gnorm = sqrt(dot(grad,grad,nvar))
         gnorm = dsqrt(ddot(nvar,grad,1,grad,1))
!
        gnormr = gnorm
        if (lnstop/=1 .and. cos>rst .and. (jnrst<nrst .or. .not.dfp) .and. &
          restrt) then
          call dcopy (nvar, gd, 1, glast, 1)
        else
          call dcopy (nvar, grad, 1, glast, 1)
        end if
      end if
      if (gnorm<tolerg .or. nvar==0) then
        iflepo = 2
        if (restrt) then
          call compfg (xparam, .TRUE., funct1, .TRUE., grad, .TRUE.)
          if (moperr) return
        else
          call compfg (xparam, .TRUE., funct1, .TRUE., grad, .FALSE.)
          if (moperr) return
        end if
        tx2 = seconds(1)
        emin = 0.D0
        return
      end if
      tx1 = seconds(2)
      tleft = tleft - tx1 + tx2
!     *
!     START OF EACH ITERATION CYCLE ...
!     *
!
! For Mopac BLAS
!        gnorm = sqrt(dot(grad,grad,nvar))
         gnorm = dsqrt(ddot(nvar,grad,1,grad,1))
!

      if (gnormr < 1.D-10) gnormr = gnorm
      icyc = jcyc
      go to 30
   10 continue
      if (cos < rst) then
        gd(:nvar) = 0.5D0
      end if
   30 continue
      jcyc = jcyc + 1
      jnrst = jnrst + 1
      i80 = 0
      if (i80==1 .or. lnstop==1 .or. cos<=rst .or. jnrst>=nrst .and. dfp) then
!
!     *
!     RESTART SECTION
!     *
!
   50   continue
        do i = 1, nvar
!
!  MAKE THE FIRST STEP A WEAK FUNCTION OF THE GRADIENT
!
          step = abs(grad(i))*0.0002D0
          step = max(0.01D0,min(0.04D0,step))
          xd(i) = xparam(i) - sign(del,grad(i))
        end do
!
! THIS CALL OF COMPFG IS USED TO CALCULATE THE SECOND-ORDER MATRIX IN H
! IF THE NEW POINT HAPPENS TO IMPROVE THE RESULT, THEN IT IS KEPT.
! OTHERWISE IT IS SCRAPPED, BUT STILL THE SECOND-ORDER MATRIX IS O.K.
!
        call compfg (xd, .TRUE., funct2, .TRUE., gd, .TRUE.)
        if (moperr) return
        if (.not.geook .and. dsqrt(ddot(nvar,gd,1,gd,1))/gnorm>10.D0 .and. gnorm>20&
           .and. jcyc>2) then
          del = del/10.0D0
          if (del >= 0.00005D0) then
            go to 50
          else
!
!  THE GEOMETRY IS BADLY SPECIFIED IN THAT MINOR CHANGES IN INTERNAL
!  COORDINATES LEAD TO LARGE CHANGES IN CARTESIAN COORDINATES, AND THESE
!  LARGE CHANGES ARE BETWEEN PAIRS OF ATOMS THAT ARE CHEMICALLY BONDED
!  TOGETHER.
            write (iw, '('' GRADIENTS OF OLD GEOMETRY, GNORM='',       F13.6)')&
               gnorm
            write (iw, '(6F12.6)') (grad(i),i=1,nvar)
            gdnorm = dsqrt(ddot(nvar,gd,1,gd,1))
            write (iw, '('' GRADIENTS OF NEW GEOMETRY, GNORM='',       F13.6)')&
               gdnorm
            write (iw, '(6F12.6)') (gd(i),i=1,nvar)
            write (iw, &
      '(3/20X,                                       ''CALCULATION ABANDONED AT&
      & THIS POINT!'')')
            write (iw, &
      '(2/10X,'' SMALL CHANGES IN INTERNAL '',2/       ''COORDINATES ARE   '',/&
      &10X,                                      '' CAUSING A LARGE CHANGE IN TH&
      &E DISTANCE BETWEEN'',              /   10X,'' CHEMICALLY-BOUND ATOMS. THE&
      & GEOMETRY OPTIMIZATION'',/     10X,'' PROCEDURE WOULD LIKELY PRODUCE INCO&
      &RRECT RESULTS'')')
            call geout (1)
            call mopend ('CALCULATION ABANDONED IN FLEPO')
            return
          end if
        end if
        ncount = ncount + 1
        hesinv(:ihdim) = 0.0D00
        sum = 0.D0
        ii = 0
        j = 0
        if (funct2 < funct1) then
          do i = 1, nvar
            ii = ii + i
            deltag = grad(i) - gd(i)
            deltax = xparam(i) - xd(i)
            if (abs(deltag) < 0.001D0) deltag = 0.001D0
            ggd = max(1.D0,abs(gd(i)))
            hesinv(ii) = min(0.1D0/ggd,deltax/deltag)
            if (hesinv(ii) <= 0.0D00) cycle
            j = j + 1
            sum = sum + hesinv(ii)
          end do
        else
          do i = 1, nvar
            ii = ii + i
            deltag = grad(i) - gd(i)
            deltax = xparam(i) - xd(i)
            if (abs(deltag) < 0.001D0) deltag = 0.001D0
            ggd = max(1.D0,abs(grad(i)))
            hesinv(ii) = min(0.1D0/ggd,deltax/deltag)
            if (hesinv(ii) <= 0.0D00) cycle
            j = j + 1
            sum = sum + hesinv(ii)
          end do
        end if
        if (j /= 0) then
          sum = sum/j
          ii = 0
          do i = 1, nvar
            ii = ii + i
            if (hesinv(ii) >= 0) cycle
            hesinv(ii) = sum
          end do
        end if
        jnrst = 0
        if (jcyc < 2) cosine = 1.D0
        if (funct2 >= funct1) then
          if (print) write (iw, 100) funct1, funct2
  100     format(' FUNCTION VALUE=',f13.7,'  WILL NOT BE REPLACED BY VALUE=',&
            f13.7,/,10x,'CALCULATED BY RESTART PROCEDURE',/)
          cosine = 1.D0
        else
          if (print) write (iw, 110) funct1, funct2
  110     format(' FUNCTION VALUE=',f13.7,' IS BEING REPLACED BY VALUE=',f13.7,&
            /,10x,' FOUND IN RESTART PROCEDURE',/,6x,'THE CORRESPONDING',&
            ' X VALUES AND GRADIENTS ARE ALSO BEING REPLACED',/)
          funct1 = funct2
          call dcopy (nvar, xd, 1, xparam, 1)
          call dcopy (nvar, gd, 1, grad, 1)
! For Mopac BLAS
!        gnorm = sqrt(dot(grad,grad,nvar))
         gnorm = dsqrt(ddot(nvar,grad,1,grad,1))
!
          if (gnormr < 1.D-10) gnormr = gnorm
        end if
      else
!
!     *
!     UPDATE VARIABLE-METRIC MATRIX
!     *
!
        xvar(:nvar) = xparam(:nvar) - xlast(:nvar)
        gvar(:nvar) = grad(:nvar) - glast(:nvar)
        call supdot (gg, hesinv, gvar, nvar)

! For Mopac BLAS
!        yhy = dot(gg,gvar,nvar)
!        sy = dot(xvar,gvar,nvar)
        yhy = ddot(nvar,gg,1,gvar,1)
        sy = ddot(nvar,xvar,1,gvar,1)
!

        k = 0
!
!    UPDATE ACCORDING TO DAVIDON-FLETCHER-POWELL
!
        if (dfp) then
          do i = 1, nvar
            xvari = xvar(i)/sy
            ggi = gg(i)/yhy
            if (i > 0) then
              hesinv(k+1:i+k) = hesinv(k+1:i+k) + xvar(:i)*xvari - gg(:i)*ggi
              k = i + k
            end if
          end do
!
!     UPDATE USING THE BFGS FORMALISM
!
        else
          yhy = 1.0D0 + yhy/sy
          do i = 1, nvar
            xvari = xvar(i)/sy
            ggi = gg(i)/sy
            if (i > 0) then
              hesinv(k+1:i+k) = hesinv(k+1:i+k) - gg(:i)*xvari - xvar(:i)*ggi&
                 + yhy*xvar(:i)*xvari
              k = i + k
            end if
          end do
        end if
      end if
!
!     *
!     ESTABLISH NEW SEARCH DIRECTION
!     *
      pnlast = pnorm
      call supdot (pvect, hesinv, grad, nvar)
      pnorm = dsqrt(ddot(nvar,pvect,1,pvect,1))
      if (pnorm > 1.5D0*pnlast) then
!
!  TRIM PVECT BACK
!
        pvect(:nvar) = pvect(:nvar)*1.5D0*pnlast/pnorm
        pnorm = 1.5D0*pnlast
      end if
! For Mopac BLAS
!     dott = -dot(pvect,grad,nvar)
      dott = -ddot(nvar,pvect,1,grad,1)
!
      pvect(:nvar) = -pvect(:nvar)
      cos = -dott/(pnorm*gnorm)
      if (print) write (iw, 170) jcyc, funct1
  170 format(' ','AT THE BEGINNING OF CYCLE',i5,'  THE FUNCTION',' VALUE IS ',&
        f13.6,/,'  THE CURRENT POINT IS ...')
      if (print) write (iw, 180) gnorm, cos
  180 format('  GRADIENT NORM = ',f10.4,/,'  ANGLE COSINE =',f10.4)
      if (print) then
        write (iw, 190)
  190   format('  THE CURRENT POINT IS ...')
        nto6 = (nvar - 1)/6 + 1
        iinc1 = -5
        do i = 1, nto6
          write (iw, '(/)')
          iinc1 = iinc1 + 6
          iinc2 = min(iinc1 + 5,nvar)
          write (iw, 200) (j,j=iinc1,iinc2)
          write (iw, 210) (xparam(j),j=iinc1,iinc2)
          write (iw, 220) (grad(j),j=iinc1,iinc2)
          write (iw, 230) (pvect(j),j=iinc1,iinc2)
  200     format(' ',3x,'I',9x,i3,9(8x,i3))
  210     format(' ',1x,'XPARAM(I)',1x,f9.4,2x,9(f9.4,2x))
  220     format(' ',1x,'GRAD  (I)',f10.4,1x,9(f10.4,1x))
  230     format(' ',1x,'PVECT (I)',2x,f10.6,1x,9(f10.6,1x))
        end do
      end if
      lnstop = 0
      alpha = alpha*pnlast/pnorm
      call dcopy (nvar, grad, 1, glast, 1)
      call dcopy (nvar, xparam, 1, xlast, 1)
      if (jnrst == 0) alpha = 1.0D00
      drop = abs(alpha*dott)
      if (print) write (iw, 250) drop
  250 format(' ',' -ALPHA.P.G =',f18.6,/)
      if (gnorm<=therb .and. jnrst/=0 .and. drop<delhof) then
!
!   HERBERT'S TEST: THE PREDICTED DROP IN ENERGY IS LESS THAN DELHOF
!   IF PASSED, CALL COMPFG TO GET A GOOD SET OF EIGENVECTORS, THEN EXIT
!
        if (minprt) write (iw, 260)
  260   format(/,/,10x,'HERBERTS TEST SATISFIED - GEOMETRY OPTIMIZED')
!
!   FLEPO IS ENDING PROPERLY. THIS IS IMMEDIATELY BEFORE THE RETURN.
!
        last = 1
        call compfg (xparam, .TRUE., funct1, .TRUE., grad, .FALSE.)
        if (moperr) return
        iflepo = 3
        time0 = time0 - totime
        emin = 0.D0
        tx2 = seconds(1)
        return
      end if
      beta = alpha
      smval = funct1
      dropn = -abs(drop/alpha)
!
!    UPDATE GEOMETRY USING THE G-DIIS PROCEDURE
!
      okf = .FALSE.
      ic = 2
  270 continue
      call linmin (xparam, alpha, pvect, nvar, funct1, okf, ic, dropn)
      if (moperr) return
      if (nvar == 1) then
        write (iw, &
      '('' ONLY ONE VARIABLE, THEREFORE ENERGY A MINIMUM'')')
        last = 1
        lgrad = index(keywrd,'GRAD') /= 0
        grad(1) = 0.D0
!
!  This call is essential.  If this call is not made, then
!  the eigenvalues will be incorrect.
!
        call compfg (xparam, .TRUE., funct1, .TRUE., grad, lgrad)
        if (moperr) return
        iflepo = 14
        emin = 0.D0
        tx2 = seconds(1)
        if (tx2 - time0 > tleft) then
!
!  This step is necessary so that a GRID calculation can
!  be re-started, even if there is only one variable.
!
          iflepo = -1
          totim = totime + seconds(1) - time0
          mdfp(9) = 1
          mdfp(5) = nscf
          call dfpsav (totim, xparam, gd, xlast, funct1, mdfp, xdfp)
          if (moperr) return
        end if
        return
      end if
!   WE WANT ACCURATE DERIVATIVES AT THIS POINT
!
!   LINMIN DOES NOT GENERATE ANY DERIVATIVES, THEREFORE COMPFG MUST BE
!   CALLED TO END THE LINE SEARCH
!
!  IF THE DERIVATIVES ARE TO BE CALCULATED USING FULL SCF'S, THEN CHECK
!  WHETHER TO DO FULL SCF'S (CRITERION FROM FLEPO: GRAD IS NULL).
!
      if (ireset>10 .or. gnorm<40.D0 .and. gnorm/gnormr<0.33D0) then
        ireset = 0
        gnormr = 0.D0
        grad(:nvar) = 0.D0
      end if
      ireset = ireset + 1
!
!
!     RESTORE TO STANDARD VALUE BEFORE COMPUTING THE GRADIENT
      if (thiel) then
        call compfg (xparam, ic/=1, sum, .TRUE., grad, .TRUE.) ! sum is not used
        if (moperr) return
      else
        call compfg (xparam, .TRUE., funct1, .TRUE., grad, .TRUE.)
        if (moperr) return
      end if
! For Mopac BLAS
      !gnorm = sqrt(dot(grad,grad,nvar))
      gnorm = dsqrt(ddot(nvar,grad,1,grad,1))
!
      if (gnormr < 1.D-10) gnormr = gnorm
      ncount = ncount + 1
      if (.not.okf) then
        lnstop = 1
        if (minprt) write (iw, &
      '(/,20X, ''NO POINT LOWER IN ENERGY THAN THE STARTING POINT&
      & '',/,20X,''COULD BE FOUND IN THE LINE MINIMIZATION'')')
        funct1 = smval
        alpha = beta
        call dcopy (nvar, glast, 1, grad, 1)
        call dcopy (nvar, xlast, 1, xparam, 1)
        if (jnrst == 0) then
          write (iw, 290)
  290     format(' ',/,/,20x,'SINCE COS WAS JUST RESET,THE SEARCH',&
            ' IS BEING ENDED')
!
!           FLEPO IS ENDING BADLY. THIS IS IMMEDIATELY BEFORE THE RETURN
!
          last = 1
          call compfg (xparam, .TRUE., funct1, .TRUE., grad, .TRUE.)
          if (moperr) return
          iflepo = 4
          time0 = time0 - totime
          tx2 = seconds(1)
          emin = 0.D0
          return
        end if
        if (print) write (iw, 300)
  300   format(' ',20x,'COS WILL BE RESET AND ANOTHER ','ATTEMPT MADE')
        cos = 0.0D00
        go to 430
      end if
! For Mopac BLAS
!      xn = sqrt(dot(xparam,xparam,nvar))
      xn = dsqrt(ddot(nvar,xparam,1,xparam,1))
!
      tx = dabs(alpha*pnorm)
      if (xn /= 0.0D00) tx = tx/xn
      tf = dabs(smval - funct1)
      if (absmin - smval < 1.D-7) then
        itry1 = itry1 + 1
        if (itry1 > 10) then
          write (iw, &
      '(2/,'' HEAT OF FORMATION IS ESSENTIALLY STATIONARY'')')
          go to 420
        end if
      else
        itry1 = 0
        absmin = smval
      end if
      if (print) write (iw, 310) ncount, cos, tx*xn, alpha, (-drop), (-tf), &
        & gnorm
  310 format(/,'           NUMBER OF COUNTS =',i6,'         COS    =',f11.4,/,&
        '  ABSOLUTE  CHANGE IN X     =',f13.6,'  ALPHA  =',f11.4,/,&
        '  PREDICTED CHANGE IN F     =  ',g11.4,'  ACTUAL =  ',g11.4,/,&
        '  GRADIENT NORM             =  ',g11.4,/,/)
      if (tx <= tolerx) then
        if (minprt) write (iw, 320)
  320   format(' TEST ON X SATISFIED')
        go to 350
      end if
      if (tf <= tolerf) then
        if (minprt) write (iw, 330)
  330   format(' HEAT OF FORMATION TEST SATISFIED')
        go to 350
      end if
      if (gnorm <= tolerg*rootv) then
        if (minprt) write (iw, 340)
  340   format(' TEST ON GRADIENT SATISFIED')
        go to 350
      end if
      go to 430
  350 continue
      do i = 1, nvar
        if (abs(grad(i)) <= tolerg) cycle
        irepet = irepet + 1
        if (irepet <= 1) then
          frepf = funct1
          cos = 0.0D00
        end if
        if (minprt) write (iw, 370) tolerg
  370   format(20x,'HOWEVER, A COMPONENT OF GRADIENT IS ','LARGER THAN',f6.2,/)
        if (abs(funct1 - frepf) > einc) irepet = 0
        if (irepet > igg1) then
          write (iw, 380) igg1, einc
  380     format(10x,' THERE HAVE BEEN',i2,' ATTEMPTS TO ',&
            'REDUCE THE GRADIENT.',/,10x,&
            ' DURING THESE ATTEMPTS THE ENERGY DROPPED',' BY LESS THAN',f4.1,&
            ' KCAL/MOLE',/,10x,&
            ' FURTHER CALCULATION IS NOT JUSTIFIED AT THIS TIME.')
          if (index(keywrd,'PREC') == 0) write (iw, 390)
  390     format(10x,' TO CONTINUE, START AGAIN WITH THE WORD "PRECISE"')
          last = 1
          call compfg (xparam, .TRUE., funct1, .TRUE., grad, .FALSE.)
          if (moperr) return
          iflepo = 8
          time0 = time0 - totime
          tx2 = seconds(1)
          emin = 0.D0
          return
        else
          go to 430
        end if
      end do
      if (minprt) write (iw, 410)
  410 format('PETERS TEST SATISFIED')
  420 continue
      last = 1
      call compfg (xparam, .TRUE., funct1, .TRUE., grad, .FALSE.)
      if (moperr) return
      iflepo = 6
      time0 = time0 - totime
      tx2 = seconds(1)
      emin = 0.D0
      return
!
!   ALL TESTS HAVE FAILED, WE NEED TO DO ANOTHER CYCLE.
!
  430 continue
      bsmvf = abs(smval - funct1)
      if (bsmvf > 10.D00) cos = 0.0D00
      del = 0.002D00
      if (bsmvf > 1.0D00) del = dell/2.0D00
      if (bsmvf > 5.0D00) del = dell
      tx2 = seconds(2)
      tcycle = tx2 - tx1
      tx1 = tx2
!
! END OF ITERATION LOOP, EVERYTHING IS STILL O.K. SO GO TO
! NEXT ITERATION, IF THERE IS ENOUGH TIME LEFT.
!
      if (tcycle < 100000.D0) cycmx = max(cycmx,tcycle)
      tleft = tleft - tcycle
      if (tleft < 0) tleft = -0.1D0
      if (tcycle > 1.D5) tcycle = 0.D0
      if (tlast - tleft > tdump) then
        totim = totime + seconds(1) - time0
        tlast = tleft
        mdfp(9) = 2
        resfil = .TRUE.
        mdfp(5) = nscf
        call dfpsav (totim, xparam, gd, xlast, funct1, mdfp, xdfp)
        if (moperr) return
      end if
      call prttim (tleft, tprt, txt)
      if (resfil) then
        write (line, '(" RESTART FILE WRITTEN,      TIME LEFT:", f6.2, &
           & a1, "  GRAD.:", f10.3, " HEAT:", g14.7)') &
           tprt, txt, Min (gnorm, 999999.999d0), funct1
        write(iw,"(a)")trim(line)
        call to_screen(trim(line))
        endfile (iw)
        backspace (iw)
        if (log) then
          write (ilog, "(a)")trim(line)
          endfile (ilog)
          backspace (ilog)
        end if
        resfil = .false.
      else
        write (line, '(" CYCLE:", i6, " TIME:", f8.3, " TIME LEFT:", &
          & f6.2, a1, "  GRAD.:", f10.3, " HEAT:", g14.7)') &
          jcyc, Min (tcycle, 9999.99d0), tprt, txt, &
          & Min (gnorm, 999999.999d0), funct1
          if (minprt) then
            write(iw,"(a)")trim(line)
            endfile (iw)
            backspace (iw)
          end if
          if (log) then
            write (ilog, "(a)")trim(line)
            endfile (ilog)
            backspace (ilog)
          end if
          call to_screen(trim(line))
      end if
      if (mod(jcyc,30) == 0) then
        line = trim(input_fn)
        call add_path(line)
        i = len_trim(line) - 5
        call to_screen(line(:i))
      end if
      call to_screen("To_file: Geometry optimizing")
      if (tleft>sfact*cycmx .and. jcyc-icyc<maxcyc) go to 10
      write (iw, 460)
  460 format(20x,'THERE IS NOT ENOUGH TIME FOR ANOTHER CYCLE',/,30x,&
        'NOW GOING TO FINAL')
      totim = totime + seconds(1) - time0
      mdfp(9) = 1
      mdfp(5) = nscf
      call dfpsav (totim, xparam, gd, xlast, funct1, mdfp, xdfp)
      if (moperr) return
      iflepo = -1
      return
      end subroutine flepo

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

submodule (mopac_api:mopac_api_operations) mopac_api_initialize
  use chanel_C, only : output_fn, & ! name of output file
    iw ! file handle for main output file
  use conref_C, only : fpcref ! values of fundamental constants (data)
  use Common_arrays_C, only : time_start, & ! starting time of the MOPAC calculation
    nat, & ! atomic numbers of real atoms
    labels, & ! atomic numbers of real atoms, labels for dummy atoms (Tv = 107)
    atmass, & ! atomic masses of atoms
    xparam, & ! values of coordinates undergoing optimization
    geo, & ! raw coordinates of atoms
    loc, & ! indices of atoms and coordinates marked for optimization
    lopt, & ! optimization flags for Cartesian coordinates of atoms
    na, nb, nc, & ! internal coordinate connectivity information
    breaks, chains, cell_ijk, nw, nfirst, nlast
  use cosmo_C, only : iseps, & ! flag for use of COSMO model
    noeps, useps, lpka, solv_energy, area, fepsi, ediel, nspa
  use funcon_C, only : fpc, fpc_9 ! fundamental constants used in the MOPAC calculation
  use maps_C, only : latom, lparam, lpara1, latom1, lpara2, latom2, rxn_coord
  use meci_C, only : nmos, lab
  use molkst_C, only : use_disk, & ! variable to turn off disk usage for MOPAC API
    keywrd, & ! keyword string to adjust MOPAC behavior
    trunc_1, & ! cutoff radius for switch to point-charge electrostatics
    trunc_2, & ! exponent in smooth cutoff for point-charge electrostatics
    time0, & ! starting time of the MOPAC calculation
    tleft, & ! amount of time left for the calculation to finish
    natoms, maxatoms, & ! number of atoms
    numat, & ! number of real atoms
    mozyme, & ! logical flag for MOZYME calculations
    methods, methods_keys, & ! logical flags and names of semiempirical models
    l_feather, & ! smooth transition from NDDO to point-charge
    method_am1, method_pm3, method_rm1, & ! logical flag aliases for specific models
    id, & ! number of translation/lattice vectors
    nvar, & ! number of coordinates to be optimized
    numcal, job_no, step_num, & ! MOPAC's persistent state variables
    moperr, & ! error status
    isok, MM_corrections, pdb_label, l_normal_html, lxfac, &
    nscf, na1, norbs, no_pKa, id, iflepo, nelecs, ndep, &
    escf, gnorm, E_disp, E_hb, E_hh, sz, ss2, step, density, press, stress, voigt, &
    sparkle, &  ! logical flag for the presence of sparkles
    rhf, uhf, & ! logical flags for spin restrictions
    atheat, & ! total atomic heat of formation
    keywrd_txt, keywrd_quoted, koment, title, refkey, allkey ! other text extracted from input files
  use MOZYME_C, only : nres, uni_res, refnuc
  use parameters_C, only : tore, & ! number of valence electrons per element
    ios, iop, iod, & ! number of s, p, and d valence electrons per element (data)
    ams, & ! standard atomic masses (data)
    zs, & ! s-type STO exponents of elements
    eheat, eheat_sparkles, eisol ! heat of formation reference values (data)
  use symmetry_C, only : state_Irred_Rep, name
  implicit none

contains

  ! This subroutine is replicating the setup steps of run_mopac
  ! for running the limited functionality supported by the MOPAC API.
  ! It is likely that not every step here is strictly necessary, but it is
  ! difficult to assess what is and isn't necessary without a very substantial
  ! investment of development time. Similarly, the keyword line is set to represent
  ! the calculation that the API is trying to perform, but some of the keyword-dependent
  ! logic has been stripped out of this restricted initialization.
  module subroutine mopac_initialize(system)
    type(mopac_system), intent(in) :: system
    double precision, external :: seconds
    character(100) :: num2str
    integer :: i, j, nelectron, status
    double precision :: eat
    integer(c_int), pointer :: atom(:)
    real(c_double), pointer :: coord(:)
    real(c_double), pointer :: lattice(:)

    ! reset the error handler before using it
    call summary("",-21)
    moperr = .false.

    ! validity checks of data in system
    if (system%natom <= 0) call mopend("Invalid number of atoms")
    if (system%natom_move < 0 .or. system%natom_move > system%natom) &
      call mopend("Invalid number of moveable atoms")
    if (system%epsilon /= 1.d0 .and. system%nlattice > 0) &
      call mopend("COSMO solvent not available for periodic systems")
    if (system%natom > 0 .and. .not. c_associated(system%atom)) &
      call mopend("Array of atomic numbers not found")
    if (system%natom > 0 .and. .not. c_associated(system%coord)) &
      call mopend("Array of atomic coordinates is too small")
    if (system%nlattice < 0 .or. system%nlattice > 3) call mopend("Invalid number of lattice vectors")
    if (system%nlattice_move < 0 .or. system%nlattice_move > system%nlattice) &
      call mopend("Invalid number of moveable lattice vectors")
    if (system%nlattice > 0 .and. .not. c_associated(system%lattice)) &
      call mopend("List of lattice vectors is too small")
    if (system%tolerance <= 0.d0) call mopend("Relative numerical tolerance must be a positive number")
    if (system%max_time <= 0) call mopend("Time limit must be a positive number")
    if (system%nlattice_move > 0 .and. index(keywrd," FORCETS") /= 0) &
      call mopend("Lattice vectors cannot move during vibrational calculations")
    if (moperr) return

    ! convert C pointers
    call c_f_pointer(system%atom, atom, [system%natom])
    call c_f_pointer(system%coord, coord, [3*system%natom])
    if (system%nlattice > 0) call c_f_pointer(system%lattice, lattice, [3*system%nlattice])

    use_disk = .false.
    ! load ios, iop, and iod data into tore
    tore = ios + iop + iod
    ! factorials and Pascal's triangle (mndod_C)
    call fbx
    ! more constants, for use by MNDO-d (mndod_C)
    call fordd
    ! point-charge switching radius (Angstroms) assumed by all MOPAC models
    trunc_1 = 7.0d0
    ! exponent in point-charge switching weight: exp(-trunc_2*(trunc_1 - Rab)^2)
    trunc_2 = 0.22d0
    ! initialize CODATA fundamental constants
    fpc(:) = fpcref(1,:)
    ! assemble virtual keyword line
    keywrd = trim(keywrd) // " LET NOSYM GEO-OK"
    write(num2str,'(i6)') system%charge
    keywrd = trim(keywrd) // " CHARGE=" // adjustl(num2str)
    if (system%pressure /= 0.d0) then
      write(num2str,'(f12.6)') system%pressure
      keywrd = trim(keywrd) // " P=" // trim(adjustl(num2str)) // "GPa"
    end if
    write(num2str,'(f12.6)') system%tolerance
    keywrd = trim(keywrd) // " GNORM=" // adjustl(num2str)
    keywrd = trim(keywrd) // " RELSCF=" // adjustl(num2str)
    write(num2str,'(i10)') system%max_time
    keywrd = trim(keywrd) // " T=" // adjustl(num2str)
    ! open dummy output file
#ifdef WIN32
    output_fn = 'NUL'
#else
  output_fn = '/dev/null'
#endif
    close(iw)
    open(unit=iw, file=output_fn, iostat=status)
    if (status /= 0) then
      call mopend("Failed to open NULL file in MOPAC_INITIALIZE")
      return
    end if
    ! initialize job timers
    time0 = seconds(1)
    call date_and_time(VALUES=time_start)
    tleft = system%max_time
    ! set number of atoms
    natoms = system%natom + system%nlattice
    maxatoms = natoms
    numat = system%natom
    ! set MOZYME flag
    mozyme = (index(keywrd," MOZ") /= 0)
    ! initialize common workspaces (Common_arrays_C)
    call setup_mopac_arrays(natoms, 1)
    if (.not. allocated(lopt)) then
      allocate(lopt(3,maxatoms), stat=status)
      if (status /= 0) then
        call mopend("Failed to allocate memory in MOPAC_INITIALIZE")
        return
      end if
    end if
    ! set semiempirical model
    methods = .false.
    select case (system%model)
      case (0) ! PM7
        i = 14
      case (1) ! PM6-D3H4
        i = 9
        ! PM6-D3H4 also needs the PM6 flag for PM6-x model family checks
        methods(6) = .true.
      case (2) ! PM6-ORG
        i = 18
      case (3) ! PM6
        i = 6
      case (4) ! AM1
        i = 2
      case (5) ! RM1
        i = 4
      case default
        call mopend("Unknown semiempirical model requested")
    end select
    methods(i) = .true.
    keywrd = trim(keywrd) // methods_keys(i)
    ! feathered interactions for PM6-ORG and PM7, or for MOZYME calculations of PM6-based models
    l_feather = (methods(14) .or. methods(18) .or. index(keywrd, " MOZ") /= 0 .and. (index(keywrd, " PM6") /= 0))
    ! check for use of COSMO model
    if (system%epsilon /= 1.d0) then
      iseps = .true.
      useps = .true.
      noeps = .false.
      write(num2str,'(f6.2)') system%epsilon
      keywrd = trim(keywrd) // " EPS=" // adjustl(num2str)
      fepsi = (system%epsilon-1.d0) / (system%epsilon+0.5d0)
    else
      iseps = .false.
      useps = .false.
      noeps = .true.
      fepsi = 0.d0
    end if
    ! insert geometry information into MOPAC data structures
    id = system%nlattice
    nat(:system%natom) = atom(:system%natom)
    labels(:system%natom) = atom(:system%natom)
    geo(:,:system%natom) = reshape(coord,[3, system%natom])
    if (id > 0) then
      nat(system%natom+1:system%natom+id) = 107
      labels(system%natom+1:system%natom+id) = 107
      geo(:,system%natom+1:system%natom+id) = reshape(lattice,[3, id])
    end if
    atmass(:natoms) = ams(labels(:))
    ! set optimization flags & xparam
    nvar = 3*system%natom_move + 3*system%nlattice_move
    lopt(:,:system%natom_move) = 1
    lopt(:,system%natom_move+1:) = 0
    xparam(:3*system%natom_move) = coord(:3*system%natom_move)
    do i=1, system%natom_move
      do j=1, 3
        loc(1,3*(i-1)+j) = i
        loc(2,3*(i-1)+j) = j
      end do
    end do
    if (system%nlattice_move > 0) then
      lopt(:,numat+1:numat+system%nlattice_move) = 1
      xparam(3*system%natom_move+1:) = lattice(:3*system%nlattice_move)
      do i=1, system%nlattice_move
        do j=1, 3
          loc(1,3*system%natom_move+3*(i-1)+j) = numat+i
          loc(2,3*system%natom_move+3*(i-1)+j) = j
        end do
      end do  
    end if
    ! update MOPAC state variables that do not reset
    numcal = numcal + 1
    job_no = job_no + 1
    step_num = step_num + 1
    ! initialize variables that need default values (molkst_C)
    isok = .true.
    MM_corrections = .false.
    pdb_label = .false.
    l_normal_html = .true.
    lxfac = .false.
    nscf = 0
    na1 = 0
    norbs = 0
    no_pKa = 0
    iflepo = 0
    nelecs = 0
    ndep = 0
    escf = 0.d0
    gnorm = 0.D0
    E_disp = 0.d0
    E_hb = 0.d0
    E_hh = 0.d0
    sz = 0.d0
    ss2 = 0.d0
    step = 0.d0
    density = 0.d0
    press = 0.d0
    stress = 0.d0
    voigt = 0.d0
    keywrd_txt = ' '
    keywrd_quoted = ' '
    koment = ' '
    title = ' '
    refkey = ' '
    allkey = ' '
    ! initialize variables that need default values (Common_arrays_C)
    na = 0
    nb = 0
    nc = 0
    cell_ijk = 0
    chains = " "
    breaks(1) = -300
    ! initialize variables that need default values (cosmo_C)
    lpka = .false.
    solv_energy = 0.d0
    area = 0.d0
    ediel = 0.d0
    nspa = 42
    ! initialize variables that need default values (maps_C)
    latom = 0
    lparam = 0
    lpara1 = 0
    latom1 = 0
    lpara2 = 0
    latom2 = 0
    rxn_coord = 1.d9
    ! initialize variables that need default values (meci_C)
    nmos = 0
    lab = 0
    ! initialize variables that need default values (MOZYME_C)
    nres = 0
    uni_res = 0
    refnuc = 0.d0
    ! initialize variables that need default values (symmetry_C)
    name = " "
    state_Irred_Rep = " "
    ! load model parameters
    call switch
    ! adjust number of valence electrons for sparkles
    sparkle = .false.
    do i = 1, numat
      if  (nat(i) > 56 .and. nat(i) < 72 .and. zs(nat(i)) < 0.1d0) sparkle = .true.
    end do
    do i = 57,71
      if (zs(i) < 0.1d0) tore(i) = 3.d0
    end do
    ! set the spin multiplicity
    nelectron = sum(tore(nat(:numat))) - system%charge
    write(num2str,'(f6.1)') system%spin + mod(nelectron,2)*0.5d0
    keywrd = trim(keywrd) // " MS=" // adjustl(num2str)
    ! set the spin restriction flags (moldat sets defaults if rhf & uhf are both .false.)
    if(mod(nelectron,2) == 0 .and. system%spin == 0 .and. index(keywrd," UHF") == 0) then
      rhf = .true.
      uhf = .false.
    else
      uhf = .true.
      rhf = .false.
    end if
    ! initialization steps performed by moldat
    call moldat (0)
    ! evaluate derived parameters of the model
    call calpar
    ! initialize system-specific MOPAC workspaces (Common_arrays_C)
    call setup_mopac_arrays(1,2)
    if (allocated(nw)) deallocate(nw)
    allocate(nw(numat), stat=status)
    if (status /= 0) then
      call mopend("Failed to allocate memory in MOPAC_INITIALIZE")
      return
    end if
    j = 1
    do i = 1, numat
      nw(i) = j
      j = j + ((nlast(i)-nfirst(i)+1)*(nlast(i)-nfirst(i)+2))/2
    end do
    ! calculate the atomic energy, including sparkles for Ce-Yb
    atheat = 0.d0
    do i = 1, numat
      if  (nat(i) > 56 .and. nat(i) < 72 .and. zs(nat(i)) < 0.1d0) then
        atheat = atheat + eheat_sparkles(nat(i))
      else
        atheat = atheat + eheat(nat(i))
      end if
    end do
    eat = sum(eisol(nat(:numat)))
    atheat = atheat - eat*fpc_9
    ! setup MOZYME calculations
    if (mozyme) call set_up_MOZYME_arrays()
  end subroutine mopac_initialize

end submodule mopac_api_initialize

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine mlmo (locc, lvir, ii, jj, nf_loc, ne, nocc, nvir, iz, ib, nce, &
     & ncf, ncocc, ncvir, iorbs, icocc, icvir, cocc, cvir)
    use molkst_C, only: numat, norbs
    use MOZYME_C, only : icocc_dim, icvir_dim, cocc_dim, &
         & cvir_dim, ipad2, ipad4
    implicit none
    integer, intent (in) :: ii, jj
    integer, intent (inout) :: locc, lvir, ne, nf_loc, nocc, nvir
    integer, dimension (*), intent (inout) :: ncf, ncocc
    integer, dimension (*), intent (inout) :: nce, ncvir
    integer, dimension (numat), intent (in) :: iorbs
    integer, dimension (numat), intent (inout) :: ib, iz
    integer, dimension (icocc_dim), intent (inout) :: icocc
    integer, dimension (icvir_dim), intent (inout) :: icvir
    double precision, dimension (cocc_dim), intent (inout) :: cocc
    double precision, dimension (cvir_dim), intent (inout) :: cvir
!
    integer :: i, iocc, ivir, j, k, nes, nfs
    nes = ne
    nfs = nf_loc
    iocc = locc
    ivir = lvir
    if (ii /= 0) then
      !
      !   OCCUPIED M.O.
      !
      iz(ii) = iz(ii) - 1
      if (jj == 0) then
        iz(ii) = iz(ii) - 1
      end if
      ib(ii) = ib(ii) - 1
      nocc = nocc + 1
      ncocc(nocc) = locc
      locc = locc + iorbs(ii)
      nf_loc = nf_loc + 1
      icocc(nf_loc) = ii
      ncf(nocc) = 1
    end if
    if (jj /= 0) then
      !
      !   VIRTUAL M.O.
      !
      iz(jj) = iz(jj) - 1
      if (ii == 0) then
        iz(jj) = iz(jj) + 1
      end if
      ib(jj) = ib(jj) - 1
      nvir = nvir + 1
      ncvir(nvir) = lvir
      lvir = lvir + iorbs(jj)
      ne = ne + 1
      nce(nvir) = 1
      if (ii /= 0) then
        icvir(ne) = ii
        ncf(nocc) = 2
        nce(nvir) = 2
      else
        icvir(ne) = jj
      end if
    end if
    if (ii /= 0 .and. jj /= 0) then
      !
      !   OCCUPIED AND VIRTUAL M.O.
      !
      nf_loc = nf_loc + 1
      icocc(nf_loc) = jj
      ne = ne + 1
      icvir(ne) = jj
      locc = locc + iorbs(jj)
      lvir = lvir + iorbs(ii)
    end if
   !
   !  Assign space for LMO's to expand into.
   !  J = SPACE RESERVED FOR ATOM INDICES IN ICOCC AND/OR ICVIR
   !  K = SPACE RESERVED FOR ATOMIC ORBITALS IN COCC AND/OR CVIR
   !
    j = Min (numat*2, ipad2)
    k = Min (norbs*2, ipad4)
    if (ii /= 0) then
      nf_loc = nfs + j
      do i = locc + 1, iocc + k
        cocc(i) = 0.d0
      end do
      locc = iocc + k
    end if
    if (jj /= 0) then
      ne = nes + j
      do i = lvir + 1, ivir + k
        cvir(i) = 0.d0
      end do
      lvir = ivir + k
    end if
end subroutine mlmo

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine rotlmo (rotvec)
   !***********************************************************************
   !                                                                      *
   !   ROTLMO rotates the atomic orbitals in all LMOs.  The rotation
   !   matrix used is ROTVEC.
   !                                                                      *
   !***********************************************************************
    use MOZYME_C, only: iorbs, ncf, nce, ncocc, ncvir, nncf, nnce, icocc, &
     icvir, cocc, cvir
    use molkst_C, only: nelecs, norbs
    implicit none
    double precision, dimension (3, 3), intent (in) :: rotvec
    integer :: i, j, jj, k, ka, loop, nj, nocc, nvir
    double precision :: sum
    double precision, dimension (3) :: vec
   !
   !   Rotate the occupied LMOs
   !
    nocc = nelecs / 2
    do i = 1, nocc
      loop = ncocc(i) + 1
      do jj = nncf(i) + 1, nncf(i) + ncf(i)
        nj = iorbs(icocc(jj))
        if (nj == 4) then
          ka = loop
          do j = 1, 3
            sum = 0.0d00
            do k = 1, 3
              sum = sum + cocc(ka+k) * rotvec(k, j)
            end do
            vec(j) = sum
          end do
          do j = 1, 3
            cocc(ka+j) = vec(j)
          end do
        end if
        loop = loop + nj
      end do
    end do
   !
   !   Rotate the virtual LMOs
   !
    nvir = norbs - nocc
    do i = 1, nvir
      loop = ncvir(i) + 1
      do jj = nnce(i) + 1, nnce(i) + nce(i)
        nj = iorbs(icvir(jj))
        if (nj == 4) then
          ka = loop
          do j = 1, 3
            sum = 0.0d00
            do k = 1, 3
              sum = sum + cvir(ka+k) * rotvec(k, j)
            end do
            vec(j) = sum
          end do
          do j = 1, 3
            cvir(ka+j) = vec(j)
          end do
        end if
        loop = loop + nj
      end do
    end do
end subroutine rotlmo

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

     subroutine interp(np, nq, mode, e, fp, cp, theta, vec_interp, fock_interp, &
     p_interp, h_interp, vecl, eold_ref)
      use molkst_C, only : keywrd, numcal, norbs
      use common_arrays_C, only :
      use chanel_C, only : iw
      use funcon_C, only : fpc_9, pi
      implicit none
      integer  :: np
      integer  :: nq
      integer , intent(inout) :: mode
      double precision , intent(in) :: e
      double precision , intent(in) :: fp((norbs*(norbs + 1))/2)
      double precision , intent(inout) :: cp(norbs,norbs)
      double precision , dimension (norbs, norbs), intent (inout) :: vec_interp, &
    & fock_interp, p_interp
      double precision , dimension (norbs*norbs), intent (inout) :: h_interp
      double precision, dimension(norbs), intent (inout) :: theta
      double precision, intent (inout)  :: vecl(norbs*norbs)
      double precision, intent(inout) :: eold_ref
!
      integer ::  icalcn, minpq, np1, np2, ii, i, i1, j, k, ik, ipoint, j1, &
        ij, il, k1, k2
      double precision :: xold, zero, ff, dum, dedx, deold, xnow, denow, enow, ck, sk
      integer :: npnts
      double precision, dimension(12) :: x, f, df
      double precision :: xlow, xhigh, xmin, emin
      logical :: debug
      save
!-----------------------------------------------
!*********************************************************************
!
! INTERP: AN INTERPOLATION PROCEDURE FOR FORCING SCF CONVERGANCE
!         ORIGINAL THEORY AND FORTRAN WRITTEN BY R.N. CAMP AND
!         H.F. KING, J. CHEM. PHYS. 75, 268 (1981)
!*********************************************************************
!
! ON INPUT norbs     = NUMBER OF ORBITALS
!          NP    = NUMBER OF FILLED LEVELS
!          NQ    = NUMBER OF EMPTY LEVELS
!          MODE  = 1, DO NOT RESET.
!          E     = ENERGY
!          FP    = FOCK MATRIX, AS LOWER HALF TRIANGLE, PACKED
!          CP    = EIGENVECTORS OF FOCK MATRIX OF ITERATION -1
!                  AS PACKED ARRAY OF NORBS**2 COEFFICIENTS
!
! ON OUTPUT CP   = BEST GUESSED SET OF EIGENVECTORS
!           MODE = 2 OR 3 - USED BY CALLING PROGRAM
!*********************************************************************
      data icalcn/ 0/
      data zero, ff/ 0.0D0, 0.9D0/
      data xold/ 0.D0/
      if (icalcn /= numcal) then
        debug = index(keywrd,'INTERP') /= 0
        icalcn = numcal
        emin = 0.d0
        npnts = 0
      end if
!
!         FF=FACTOR FOR CONVERGENCE TEST FOR 1D SEARCH.
!
      minpq = min0(np,nq)
      np1 = np + 1
      np2 = max0(1,np/2)
      if (mode /= 2) then
!
!     (MODE=1 OR 3 ENTRY)
!     TRANSFORM FOCK MATRIX TO CURRENT MO BASIS.
!     ONLY THE OFF DIAGONAL OCC-VIRT BLOCK IS COMPUTED.
!     STORE IN FOCK ARRAY
!
        ii = 0
        do i = 1, norbs
          i1 = i + 1
          do j = 1, nq
            dum = zero
            dum = dum + sum(fp(ii+1:i+ii)*cp(:i,j+np))
            if (i /= norbs) then
              ik = ii + i + i
              do k = i1, norbs
                dum = dum + fp(ik)*cp(k,j+np)
                ik = ik + k
              end do
            end if
            p_interp(i,j) = dum
          end do
          ii = ii + i
        end do
        do i = 1, np
          do j = 1, nq
            dum = zero
            dum = dum + sum(cp(:norbs,i)*p_interp(:norbs,j))
            fock_interp(i,j) = dum
          end do
        end do
        if (mode /= 3) then
!
!     CURRENT POINT BECOMES OLD POINT (MODE=1 ENTRY)
!
          vec_interp(:norbs,:norbs) = cp(:norbs,:norbs)
          eold_ref = e
          xold = 1.0D0
          mode = 2
          return
        end if
!
!     (MODE=3 ENTRY)
!     F CORRESPONDS TO CURRENT POINT IN CORRESPONDING REPRESENTATION.
!     VEC DOES NOT HOLD CURRENT VECTORS. VEC SET IN LAST MODE=2 ENTRY.
!
        npnts = npnts + 1
        if (debug) write (iw, '(''   INTERPOLATED ENERGY:'',F13.6)') e*fpc_9
        ipoint = npnts
      else
!
!    (MODE=2 ENTRY) CALCULATE THETA, AND U, V, W MATRICES.
!                   U ROTATES CURRENT INTO OLD MO.
!                   V ROTATES CURRENT INTO CORRESPONDING CURRENT MO.
!                   W ROTATES OLD INTO CORRESPONDING OLD MO.
!
        j1 = 1
        do i = 1, norbs
          if (i == np1) j1 = np1
          do j = j1, norbs
            p_interp(i,j) = zero
            p_interp(i,j) = p_interp(i,j) + sum(cp(:norbs,i)*vec_interp(:norbs,j))
          end do
        end do
!
!     U = CP(DAGGER)*VEC IS NOW IN P ARRAY.
!     VEC IS NOW AVAILABLE FOR TEMPORARY STORAGE.
!
        ij = 0
        do i = 1, np
          do j = 1, i
            ij = ij + 1
            h_interp(ij) = 0.D0
            h_interp(ij) = h_interp(ij) + sum(p_interp(i,np1:norbs)*p_interp(j,np1:norbs))
          end do
        end do
        call rsp (h_interp, np, theta, vecl)
        do i = np, 1, -1
          il = i*np - np
          vec_interp(np:1:(-1),i) = vecl(np+il:il+1:(-1))
        end do
        do i = 1, np2
          dum = theta(np1-i)
          theta(np1-i) = theta(i)
          theta(i) = dum
          do j = 1, np
            dum = vec_interp(j,np1-i)
            vec_interp(j,np1-i) = vec_interp(j,i)
            vec_interp(j,i) = dum
          end do
        end do
        do i = 1, minpq
          theta(i) = max(theta(i),zero)
          theta(i) = min(theta(i),1.D0)
          theta(i) = asin(sqrt(theta(i)))
        end do
!
!     THETA MATRIX HAS NOW BEEN CALCULATED, ALSO UNITARY VP MATRIX
!     HAS BEEN CALCULATED AND STORED IN FIRST NP COLUMNS OF VEC MATRIX.
!     NOW COMPUTE WQ
!
        do i = 1, nq
          do j = 1, minpq
            vec_interp(i,np+j) = zero
            vec_interp(i,np+j) = vec_interp(i,np+j) + sum(p_interp(:np,np+i)*vec_interp(:np,j))
          end do
        end do
        call schmit (vec_interp(1,np1), nq, norbs)
!
!     UNITARY WQ MATRIX NOW IN LAST NQ COLUMNS OF VEC MATRIX.
!     TRANSPOSE NP BY NP BLOCK OF U STORED IN P
!
        do i = 1, np
          do j = 1, i
            dum = p_interp(i,j)
            p_interp(i,j) = p_interp(j,i)
            p_interp(j,i) = dum
          end do
        end do
!
!     CALCULATE WP MATRIX AND HOLD IN FIRST NP COLUMNS OF P
!
        do i = 1, np
          h_interp(:np) = p_interp(i,:np)
          do j = 1, np
            p_interp(i,j) = zero
            p_interp(i,j) = p_interp(i,j) + sum(h_interp(:np)*vec_interp(:np,j))
          end do
        end do
        call schmib (p_interp, np, norbs)
!
!     CALCULATE VQ MATRIX AND HOLD IN LAST NQ COLUMNS OF P MATRIX.
!
        do i = 1, nq
          h_interp(:nq) = p_interp(np+i,np+1:nq+np)
          do j = np1, norbs
            p_interp(i,j) = zero
            p_interp(i,j) = p_interp(i,j) + sum(h_interp(:nq)*vec_interp(:nq,j))
          end do
        end do
        call schmib (p_interp(1,np1), nq, norbs)
!
!     CALCULATE (DE/DX) AT OLD POINT
!
        dedx = zero
        do i = 1, np
          do j = 1, nq
            dum = zero
            dum = dum + sum(theta(:minpq)*p_interp(i,:minpq)*vec_interp(j,np+1:minpq+np))
            dedx = dedx + dum*fock_interp(i,j)
          end do
        end do
!
!     STORE OLD POINT INFORMATION FOR SPLINE FIT
!
        deold = -4.0D0*dedx
        x(2) = xold
        f(2) = eold_ref
        df(2) = deold
!
!     MOVE VP OUT OF vec_interp ARRAY INTO FIRST NP COLUMNS OF p_interp MATRIX.
!
        p_interp(:np,:np) = vec_interp(:np,:np)
        k1 = 0
        k2 = np
        do j = 1, norbs
          if (j == np1) then
            k1 = np
            k2 = nq
          end if
          do i = 1, norbs
            dum = zero
            dum = dum + sum(cp(i,k1+1:k2+k1)*p_interp(:k2,j))
            vec_interp(i,j) = dum
          end do
        end do
!
!     CORRESPONDING CURRENT MO VECTORS NOW HELD IN vec_interp.
!     COMPUTE vec_interp(DAGGER)*FP*vec_interp
!     STORE OFF-DIAGONAL BLOCK IN fock_interp ARRAY.
!
        ii = 0
        do i = 1, norbs
          i1 = i + 1
          do j = 1, nq
            dum = zero
            dum = dum + sum(fp(ii+1:i+ii)*vec_interp(:i,j+np))
            if (i /= norbs) then
              ik = ii + i + i
              do k = i1, norbs
                dum = dum + fp(ik)*vec_interp(k,j+np)
                ik = ik + k
              end do
            end if
            p_interp(i,j) = dum
          end do
          ii = ii + i
        end do
        do i = 1, np
          do j = 1, nq
            dum = zero
            dum = dum + sum(vec_interp(:norbs,i)*p_interp(:norbs,j))
            fock_interp(i,j) = dum
          end do
        end do
!
!     SET LIMITS ON RANGE OF 1-D SEARCH
!
        npnts = 2
        ipoint = 1
        xnow = zero
        xhigh = pi/(2.d0*theta(1))
!
!     1.5708 IS MAXIMUM ROTATION ANGLE (90 DEGREE = 3.14159/2 RADIAN).
!
        xlow = -0.5D0*xhigh
      end if
!
!     CALCULATE (DE/DX) AT CURRENT POINT AND
!     STORE INFORMATION FOR SPLINE FIT
!     ***** JUMP POINT FOR MODE=3 ENTRY *****
!
      dedx = zero
      do k = 1, minpq
        dedx = dedx + theta(k)*fock_interp(k,k)
      end do
      denow = -4.0D0*dedx
      enow = e
!     PERFORM 1-D SEARCH AND DETERMINE EXIT MODE.
!
      x(ipoint) = xnow
      f(ipoint) = enow
      df(ipoint) = denow
      call spline(x, f, df, xhigh, xlow,  xmin, npnts)
      if (eold_ref - enow<=ff*(eold_ref - emin) .and. ipoint<=10) then
!
!     (MODE=3 EXIT) RECOMPUTE CP VECTORS AT PREDICTED MINIMUM.
!
        xnow = xmin
        cp = vec_interp
        do k = 1, minpq
          ck = cos(xnow*theta(k))
          sk = sin(xnow*theta(k))
          if (debug) write (iw, '('' ROTATION ANGLE:'',F12.4)') sk*57.29578D0
          cp(:norbs,k) = ck*vec_interp(:norbs,k) - sk*vec_interp(:norbs,np+k)
          cp(:norbs,np+k) = sk*vec_interp(:norbs,k) + ck*vec_interp(:norbs,np+k)
        end do
        mode = 3
        return
      end if
!
!     (MODE=2 EXIT) CURRENT VECTORS GIVE SATISFACTORY ENERGY IMPROVEMENT
!     CURRENT POINT BECOMES OLD POINT FOR THE NEXT 1-D SEARCH.
!
      if (mode /= 2) then
        vec_interp(:norbs,:norbs) = cp(:norbs,:norbs)
        mode = 2
      end if
      eold_ref = enow
      if (npnts <= 200) return
      write (iw, 600)
      do k = 1, npnts
        write (iw, 610) k, x(k), f(k), df(k)
      end do
      write (iw, 620)
      return
  600 format('  K','     X(K) ','       F(K)    ','     DF(K)')
  610 format(i3,f10.5,2f15.10)
  620 format(10x)
      end subroutine interp
      subroutine spline(x, f, df, xhigh, xlow,  xmin, npnts)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!***********************************************************************
      implicit none
      integer :: npnts
      double precision, dimension(12) :: x, f, df
      double precision :: xlow, xhigh, xmin, fmin, dfmin
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: k1, j2, n1, k
      double precision :: close, big, huge, ustep, dstep, step, xstart, xstop, dx, &
        x1, x2, dum, a, b, c, bb, ac3, xk, r, fm
      logical :: skip1, skip2

      save close, big, huge, ustep, dstep
!-----------------------------------------------
!
!     FIT F(X) BY A CUBIC SPLINE GIVEN VALUES OF THE FUNCTION
!     AND ITS FIRST DERIVATIVE AT npnts PNTS.
!     SUBROUTINE RETURNS VALUES OF XMIN,FMIN, AND DFMIN
!     AND MAY REORDER THE DATA.
!     XLOW AND XHIGH SET LIMITS ON THE INTERVAL WITHIN WHICH
!     TO SEARCH.  SUBROUTINE MAY FURTHER REDUCE THIS INTERVAL.
!
      data close, big, huge, ustep, dstep/ 1.0D-8, 500.0D0, 1.0D+10, 1.0D0, &
        2.0D0/
!
!     SUBROUTINE ASSUMES THAT THE FIRST npnts-1 DATA PNTS HAVE BEEN
!     PREVIOUSLY ORDERED,  X(I).LT.X(I+1) FOR I=1,2,...,npnts-2
!     NOW MOVE NTH POINT TO ITS PROPER PLACE.
!
      xmin = x(npnts)
      fmin = f(npnts)
      dfmin = df(npnts)
      n1 = npnts - 1
      k = n1
      k1 = k
      j2 = min0(1,k1)
      do k = k1, j2, -1
        if (x(k) < xmin) go to 20
        x(k+1) = x(k)
        f(k+1) = f(k)
        df(k+1) = df(k)
      end do
   20 continue
      x(k+1) = xmin
      f(k+1) = fmin
      df(k+1) = dfmin
      if (df(1) > 0.0D0) then
!
!     DEFINE THE INTERVAL WITHIN WHICH WE TRUST THE SPLINE FIT.
!     USTEP =  UP HILL STEP SIZE FACTOR
!     DSTEP = DOWN HILL STEP SIZE FACTOR
!
        step = dstep
      else
        step = ustep
      end if
      xstart = x(1) - step*(x(2)-x(1))
      xstart = max(xstart,xlow)
      if (df(npnts) > 0.0D0) then
        step = ustep
      else
        step = dstep
      end if
      xstop = x(npnts) + step*(x(npnts)-x(n1))
      xstop = min(xstop,xhigh)
!
!     SEARCH FOR MINIMUM
!
      do k = 1, n1
        skip1 = k /= 1
        skip2 = k /= n1
        if (f(k) < fmin) then
          xmin = x(k)
          fmin = f(k)
          dfmin = df(k)
        end if
        dx = x(k+1) - x(k)
!
!     SKIP INTERVAL IF PNTS ARE TOO CLOSE TOGETHER
!
        if (dx <= close) cycle
        x1 = 0.0D0
        if (k == 1) x1 = xstart - x(1)
        x2 = dx
        if (k == n1) x2 = xstop - x(n1)
!
!     (A,B,C)=COEF OF (CUBIC,QUADRATIC,LINEAR) TERMS
!
        dum = (f(k+1)-f(k))/dx
        a = (df(k)+df(k+1)-dum-dum)/(dx*dx)
        b = (dum + dum + dum - df(k)-df(k)-df(k+1))/dx
        c = df(k)
!
!     XK = X-X(K) AT THE MINIMUM WITHIN THE KTH SUBINTERVAL
!     TEST FOR PATHOLOGICAL CASES.
!
        bb = b*b
        ac3 = (a + a + a)*c
        if (bb < ac3) go to 90
        if (b <= 0.0D0) then
          if (abs(b) > huge*abs(a)) go to 90
        else
          if (bb > big*abs(ac3)) go to 60
        end if
!
!     WELL BEHAVED CUBIC
!
        xk = ((-b) + sqrt(bb - ac3))/(a + a + a)
        go to 70
!
!     CUBIC IS DOMINATED BY QUADRATIC TERM
!
   60   continue
        r = ac3/bb
        xk = -(((0.039063D0*r + 0.0625D0)*r + 0.125D0)*r + 0.5D0)*c/b
   70   continue
        if (xk<x1 .or. xk>x2) go to 90
   80   continue
        fm = ((a*xk + b)*xk + c)*xk + f(k)
        if (fm <= fmin) then
          xmin = xk + x(k)
          fmin = fm
          dfmin = ((a + a + a)*xk + b + b)*xk + c
!
!     EXTRAPOLATE TO END OF INTERVAL IF K=1 AND/OR K=N1
!
        end if
   90   continue
        if (skip1) go to 100
        skip1 = .TRUE.
        xk = x1
        go to 80
  100   continue
        if (skip2) cycle
        skip2 = .TRUE.
        xk = x2
        go to 80
      end do
      return
      end subroutine spline

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

double precision function disp_DnX(l_grad)
   use common_arrays_C, only: nat, dxyz, cell_ijk, vab
   use molkst_C, only : numat, l123, l1u, l2u, l3u, method_PM6_DH2X, e_disp
   implicit none
   logical, intent (in) :: l_grad
!
!  Local variables
!
   integer :: i, j, k, l, iii, jjj, kkkk, i_cell, j_cell, iX(100), jOorN(100)
   double precision :: Rab, sum, sum2, sum3,  a_X(3,3), b_X(3,3)
   logical :: first = .true.
   logical, external :: connected
   double precision, external :: distance
   save
      if (first) then
          first = .false.
          if (method_PM6_DH2X) then
!
! Add in Rezac and Hobza's correction: "A halogen-bonding correction for the semiempirical PM6 method"
! Chem. Phys. Lett. 506 286-289 (2011)
!
            a_X(1,1) = 1.0489d12  ! Cl - N
            a_X(2,1) = 1.0226d5   ! Br - N
            a_X(3,1) = 1.2751d12  !  I - N
            a_X(1,2) = 4.6783d8   ! Cl - O
            a_X(2,2) = 9.6021d3   ! Br - O
            a_X(3,2) = 6.0912d5   !  I - O
            b_X(1,1) = -9.946d0   ! Cl - N
            b_X(2,1) = -3.236d0   ! Br - N
            b_X(3,1) = -9.534d0   !  I - N
            b_X(1,2) = -6.867d0   ! Cl - O
            b_X(2,2) = -2.900d0   ! Br - O
            b_X(3,2) = -4.154d0   !  I - O
          else
!
! Parameters for the "X" part in the "D3H4X" method
!
! Use Brahmkshatriya, et al.: "Quantum Mechanical Scoring: Structural and Energetic Insights into
! Cyclin-Dependent Kinase 2 Inhibition by Pyrazolo[1,5-a]pyrimidines" Current Computer-Aided Drug Design, 2013, 9, 118-129
! Table 2
            a_X(1,1) = 1.049d12   ! Cl - N
            a_X(2,1) = 5.560d4    ! Br - N
            a_X(3,1) = 5.237d8    !  I - N
            a_X(1,2) = 1.871d9    ! Cl - O
            a_X(2,2) = 2.160d4    ! Br - O
            a_X(3,2) = 2.436d6    !  I - O
            a_X(3,3) = 1.051d6    !  I - S
            b_X(1,1) = -9.95d0    ! Cl - N
            b_X(2,1) = -3.04d0    ! Br - N
            b_X(3,1) = -6.77d0    !  I - N
            b_X(1,2) = -7.44d0    ! Cl - O
            b_X(2,2) = -3.30d0    ! Br - O
            b_X(3,2) = -4.71d0    !  I - O
            b_X(3,3) = -3.82d0    !  I - S
          end if
          iX(17) = 1
          iX(35) = 2
          iX(53) = 3
          jOorN(7)  = 1
          jOorN(8)  = 2
          jOorN(16) = 3
      end if
      sum = 0.d0
      do i = 1, numat
        if (nat(i) /= 17 .and. nat(i) /= 35 .and. nat(i) /= 53) cycle ! crude, but fast
        k = nat(i)
        do j = 1, numat
          select case (nat(j))
          case (7, 8, 16)
            if (k /= 53 .and. nat(j) == 16) cycle  ! If sulfur, only select iodine
            l = nat(j)
            Rab = distance(i, j)
            sum2 = a_X(iX(k),jOorN(l))
            sum3 = b_X(iX(k),jOorN(l))
            sum = sum + sum2*exp(sum3*Rab)
            if (l_grad) then
              if (connected(i,j, 8.d0**2)) then
  !
  !   kkkk is the cell that atom j is in, relative to atom i
  !
                iii = l123*(i - 1)
                jjj = l123*(j - 1)
                kkkk = (l3u - cell_ijk(3)) + (2*l3u + 1)*(l2u - cell_ijk(2) + (2*l2u + 1)*(l1u - cell_ijk(1)))
                i_cell = iii + kkkk
                j_cell = jjj - kkkk
                do l = 1,3
                  dxyz(i_cell*3 + l) = dxyz(i_cell*3 + l) + Vab(l)*sum2*sum3*exp(sum3*Rab)/Rab
                  dxyz(j_cell*3 + l) = dxyz(j_cell*3 + l) - Vab(l)*sum2*sum3*exp(sum3*Rab)/Rab
                end do
              end if
            end if
          end select
        end do
      end do
      disp_DnX = sum
      e_disp = e_disp + sum
      return
  end function disp_DnX
  subroutine print_post_scf_corrections
  use molkst_C, only : keywrd, E_disp, E_hb, P_Hbonds
  use common_arrays_C, only: H_energy, H_txt
  use chanel_C, only : iw
  implicit none
  double precision :: sum, sum1
  double precision, external :: reada
  integer :: i, j, k
    if (index(keywrd," DISP(") > 0) then
      write(iw,'(/47x,a)')" List of hydrogen bonds found"
      write(iw,'(3x,a,12x,a,16x,a,11x,a,23x,a,17x,a)')"No.", "Donor", &
      "R(D-H)", "Hydrogen",  "Acceptor", "H-bond energy"
      sum1 = -abs(reada(keywrd, index(keywrd," DISP(") + 5))
      k = 0
      do
        sum = 0.d0
        j = 0
        do i = 1, P_hbonds
          if (sum > H_energy(i)) then
            sum = H_energy(i)
            j = i
          end if
        end do
        if (sum > sum1) exit
        k = k + 1
        write(iw,'(i5,3x,a)')k, trim(H_txt(j))
        H_energy(j) = 10.d0
      end do
    end if
    if (index(keywrd, "0SCF") /= 0) then
      write(iw,'(/10x,"DISPERSION ENERGY       =", f17.5, a)') e_disp, " KCAL/MOL"
      write(iw,'(10x,"H-BOND ENERGY           =", f17.5, a,/)') e_hb, " KCAL/MOL"
    end if
  end subroutine print_post_scf_corrections

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine dernvo()
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE molkst_C, only : numcal, numat, nopen, nclose, norbs, gnorm, &
      & fract, keywrd, mpack, moperr, lm61, n2elec
      use meci_C, only : nbo, nmos, nelec, lab
      use common_arrays_C, only : eigs, dxyz
      use chanel_C, only : iw
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
      double precision, dimension(:), allocatable  :: scalar, diag, fmooff, &
      work
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer ::  minear, ninear, nvax, icalcn, i, ilast, ifirst, j, k, l, ll, &
      n1, n2
      double precision, dimension(nmos*norbs + 1) :: fmoon
      double precision, dimension(3*numat) :: dxyzr
      double precision, dimension(nmos*norbs*20) :: eigbb
      double precision :: sum, throld, sumx, sumy, sumz
      logical :: debug, dcar, large, relaxd
      character :: blank*60

      save  debug, dcar, large,  minear, ninear, nvax, icalcn, &
      & diag, scalar, fmooff
!-----------------------------------------------
!**********************************************************************
!
!    IMPLEMENTATION OF ANALYTICAL FORMULATION FOR OPEN SHELL OR CI,
!                      VARIABLES FINITE DIFFERENCE METHODS,
!                      STATISTICAL ESTIMATE OF THE ERRORS,
!                   BY D. LIOTARD
!                      LABORATOIRE DE CHIMIE STRUCTURALE
!                      UNIVERSITE DE PAU ET DES PAYS DE L'ADOUR
!                      AVENUE DE L'UNIVERSITE, 64000, PAU (FRANCE)
!
!
!   MODIFIED BY JJPS TO CONFORM TO MOPAC CONVENTIONS
!   (NOTE BY JJPS:  PROF. LIOTARD'S TECHNIQUE WORKS.  IF THIS
!   IMPLEMENTATION DOES NOT WORK, THE REASON IS A FAULT INTRODUCED
!   BY JJPS, AND DOES NOT REFLECT ON PROF. LIOTARD'S ABILITY)
!
!
!    AS THE WAVE FUNCTION IS NOT VARIATIONALLY OPTIMIZED, I.E.
!    HALF-ELECTRON OR CI, THE DERIVATIVES OF THE 1 AND 2-ELECTRON
!    INTEGRALS IN A.O. BASIS ARE EVALUATED IN CARTESIAN COORDINATES
!    BY A 1 OR 2 POINTS FINITE DIFFERENCE FORMULA AND STORED.
!    THUS ONE GETS THE NON-RELAXED (I.E. FROZEN ELECTRONIC CLOUD)
!    CONTRIBUTION TO THE FOCK EIGENVALUES AND 2-ELECTRON INTEGRALS IN
!    AN M.O. BASIS.  THE NON-RELAXED GRADIENT COMES FROM THE
!    NON-RELAXED C.I. MATRIX DERIVATIVE (SUBROUTINE DERI1).
!    THE DERIVATIVES OF THE M.O. COEFFICIENTS ARE THEN WORKED OUT
!    ITERATIVELY (OK FOR BOTH CLOSED SHELLS AND HALF-ELECTRON CASES)
!    AND STORED. THUS ONE GETS THE ELECTRONIC RELAXATION CONTRIBUTION TO
!    THE FOCK EIGENVALUES AND 2-ELECTRON INTEGRALS IN M.O. BASIS.
!    FINALLY THE RELAXATION CONTRIBUTION TO THE C.I. MATRIX DERIVATIVE
!    GIVES THE RELAXATION CONTRIBUTION TO THE GRADIENT (ROUTINE DERI2).
!
!
!        COORD  HOLDS THE CARTESIAN COORDINATES.
!    INPUT
!        DXYZ   NOT DEFINED.
!    EXIT
!        DXYZ   DERIVATIVES OF ENERGY W.R.T CARTESIAN COORDINATES,
!               IN KCAL/MOL/ANGSTROM (3 * NUMAT OF THESE)
!
!**********************************************************************
      data icalcn/ 0/
!        ACTUAL SIZES FOR C.I. GRADIENT CALCULATION.
        nbo(1) = nclose
        nbo(2) = nopen - nclose
        nbo(3) = norbs - nopen
        minear = nbo(2)*nbo(1) + nbo(3)*nopen
        ninear = nmos
        k = 0
        l = 0
        n2 = 0
        do i = 1, 3
          l = k + 1
          k = k + nbo(i)
          n1 = Max (0, nelec - l)
          n2 = Min (k, nelec + nmos) - l
          if (n2 > n1) then
            ninear = ninear + (n2*(n2 + 1) - n1*(n1 + 1))/2
          end if
        end do
        j = n2 + 1
        n2 = n2 + l
        if (j > 0 .and. n2 < norbs) then
          ninear = ninear + j * (norbs-n2)
        else if (ninear <= 0) then
          ninear = 1
        end if
        i = max(norbs**2 + 45*lm61, (lab*(lab+1))/2, n2elec + mpack)
        allocate(work(i))
        if(allocated(scalar)) deallocate(scalar)
        allocate(scalar(minear))
        if(allocated(diag)) deallocate(diag)
        allocate(diag(minear))
        if(allocated(fmooff)) deallocate(fmooff)
        allocate(fmooff(2*minear))
!
!     SELECT THE REQUIRED OPTION AND READ KEYWORDS
!     --------------------------------------------
!
      if (icalcn /= numcal) then
        icalcn = numcal
        debug = index(keywrd,'DERNVO') /= 0
        large = index(keywrd,'LARGE') /= 0
        dcar = index(keywrd,'FORC') + index(keywrd,'PREC') /= 0
        nvax = 3*numat
      end if
      dxyzr(:nvax) = 0.D0
!        SCALING ROW FACTORS TO SPEED CV OF RELAXATION PROCEDURE.
      call deri0 (eigs, norbs, scalar, diag, fract, nbo)
!
!   BECAUSE DERI2 IS CPU INTENSIVE, AND THE CONTRIBUTION TO THE
!   DERIVATIVE DUE TO RELAXATION OF THE ELECTRON CLOUD IS RELATIVELY
!   INSENSITIVE TO CHANGES IN GEOMETRY, WHERE POSSIBLE ONLY CALCULATE
!   THE DERIVATIVE EVERY 2 CALLS TO DERNVO
!
      eigbb = 0.D0
      sum = 0.D0
      if (gnorm<1.D0 .or. dcar) then
        dxyzr(:nvax) = 0.D0
        relaxd = .FALSE.
      end if
      do i = 1, nvax
        sum = sum + abs(dxyzr(i))
      end do
      relaxd = sum > 1.D-7
!
!  IF DXYZR CONTAINS DATA, USE IT AND FLUSH AFTER USE.
!
      ilast = 0
   50 continue
      ifirst = ilast + 1
      ilast = min(nvax,ilast + 1)
      j = 1 - minear
      k = 1 - ninear
      do i = ifirst, ilast
        k = k + ninear
        j = j + minear
!
!        NON-RELAXED CONTRIBUTION (FROZEN ELECTRONIC CLOUD) IN DXYZ
!        AND NON-RELAXED FOCK MATRICES IN FMOOFF AND FMOON.
!   CONTENTS OF F-MO-OFF: OPEN-CLOSED, VIRTUAL-CLOSED, AND VIRTUAL-OPEN
!   CONTENTS OF F-MO-ON:  CLOSED-CLOSED, OPEN-OPEN AND VIRTUAL-VIRTUAL
!   OVER M.O. INDICES
!
        call deri1 (i, dxyz(i), fmooff(j), minear, fmoon(k), scalar, work)
      end do
      if (debug) then
        if (ifirst==1 .and. large) then
          write (iw, *) ' CONTENTS OF FMOOFF '
          write (iw, *) ' OPEN-CLOSED'
          write (iw, '(7X,I3,5I12)') (j,j=nclose + 1,nopen)
          do i = 1, nclose
            write (iw, '(I3,6F12.6)') i, (fmooff(j),j=(i - 1)*nbo(2) + 1,i*nbo(2))
          end do
!
!
          write (iw, *) ' VIRTUAL-CLOSED'
          k = nclose*nbo(2)
          write (iw, '(7X,I3,5I12)') (j,j=nopen + 1,min(nopen + 6,norbs))
          do i = 1, nclose
            write (iw, '(I3,6F12.6)') i, &
            (fmooff(j+k),j=(i - 1)*nbo(3) + 1,min(6 + (i - 1)*nbo(3),i*nbo(3)))
          end do
          k = nclose*nbo(2) + nbo(3)*nclose
!
!
          write (iw, *) ' VIRTUAL-OPEN'
          write (iw, '(7X,I3,4I12)') (j,j=nclose + 1,nopen)
          do i = 1, min(6,nbo(3))
            write (iw, '(I3,6F12.6)') i + nopen, &
            (fmooff(j+k),j=(i - 1)*nbo(2) + 1,min((i - 1)*nbo(2)+6,i*nbo(2)))
          end do
          write (iw, *) ' CONTENTS OF FMOON (ACTIVE-SPACE -- ACTIVE SPACE)'
          k = (nmos*(nmos - 1))/2
          ll = 1
          blank = ' '
          do i = 1, nmos
            l = ll + nmos - i - 1
            write (iw, '(A,5F12.6)') blank(:12*i), (fmoon(j),j=ll,l), fmoon(k+i)
            ll = l + 1
          end do
        end if
      end if
!        COMPUTE THE ELECTRONIC RELAXATION CONTRIBUTION.
!
!   DERNVO PROVIDES THE FOLLOWING SCRATCH AREAS TO DERI2: EIGB, WORK2,
!          WORK3, CBETA.  THESE ARE DIMENSIONED ON ENTRY TO DERI2
!          WHICH IS WHY THEY ARE NOT DECLARED THERE.  THEY ARE NOT USED
!          AT ALL IN DERNVO.
!
!
!  The following function was chosen as a guide to THROLD.  It is NOT
!  intended to be hard-and-fast.
!
!     throld = max(0.001D0,min(thref,gnorm**3*0.00002D0))
      throld = 0.00001D0
      if (.not.relaxd) call deri2 (minear, fmooff, fmoon, eigbb &
        , ninear, ilast - ifirst + 1, dxyzr(ifirst) &
        , throld,  diag, scalar, work)
      if (moperr) goto 99
      if (ilast < nvax) go to 50
      if (debug) then
        sumx = 0.D0
        sumy = 0.D0
        sumz = 0.D0
        do i = 1, numat
          sumx = sumx + dxyz(i*3-2)
          sumy = sumy + dxyz(i*3-1)
          sumz = sumz + dxyz(i*3)
        end do
        write (iw, *) ' CARTESIAN DERIVATIVES DUE TO FROZEN CORE'
        write (iw, '('' ATOM    X           Y           Z'')')
        do i = 1, numat
          write (iw, '(I4,3F12.7)') i, dxyz(i*3-2), dxyz(i*3-1), dxyz(i*3)
        end do
        write (iw, '(/10X,''RESIDUAL ERROR'')')
        write (iw, '(4X,3F12.7)') sumx, sumy, sumz
        write (iw, *)
        sumx = 0.D0
        sumy = 0.D0
        sumz = 0.D0
        do i = 1, numat
          sumx = sumx + dxyzr(i*3-2)
          sumy = sumy + dxyzr(i*3-1)
          sumz = sumz + dxyzr(i*3)
        end do
        write (iw, *) ' CARTESIAN DERIVATIVES DUE TO RELAXING CORE'
        write (iw, '('' ATOM    X           Y           Z'')')
        do i = 1, numat
          write (iw, '(I4,3F12.7)') i, dxyzr(i*3-2), dxyzr(i*3-1), dxyzr(i*3)
        end do
        write (iw, '(/10X,''RESIDUAL ERROR'')')
        write (iw, '(4X,3F12.7)') sumx, sumy, sumz
        write (iw, *)
      end if
      dxyz(:nvax) = dxyz(:nvax) + dxyzr(:nvax)
      if (relaxd) then
        dxyzr(:nvax) = 0.D0
      end if
      sumx = 0.D0
      sumy = 0.D0
      sumz = 0.D0
      do i = 1, numat
        sumx = sumx + dxyz(i*3-2)
        sumy = sumy + dxyz(i*3-1)
        sumz = sumz + dxyz(i*3)
      end do
      sum = max(1.D-10,abs(sumx) + abs(sumy) + abs(sumz))
      if (debug) then
        write (iw, *) 'CARTESIAN DERIVATIVES FROM ANALYTICAL C.I. CALCULATION'
        write (iw, '('' ATOM    X           Y           Z'')')
        do i = 1, numat
          write (iw, '(I4,3F12.7)') i, dxyz(i*3-2), dxyz(i*3-1), dxyz(i*3)
        end do
        write (iw, '(/10X,''RESIDUAL ERROR'')')
        write (iw, '(4X,3F12.7)') sumx, sumy, sumz
        write (iw, *)
      end if
  99  continue
      if(allocated(scalar)) deallocate(scalar)
      if(allocated(diag))   deallocate(diag)
      if(allocated(fmooff)) deallocate(fmooff)
      return
      end subroutine dernvo

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine euler (px, py, pz, i1, i2, i3, ipen)
  implicit none
  integer, intent(in) :: i1, i2, i3, ipen
  double precision, intent(in) :: px, py, pz
  ! 
  double precision :: ca = 1.d0, cb = 1.d0, sa = 0.d0, sb = 0.d0
  double precision :: r1, x, xy, y, z
  real :: cx, cy
  double precision, dimension(3) :: c
!
  if (i1 == 0) then
    !
    ! SET UP COS AND SIN ANGLES FOR EULARIAN TRANSFORM.
    !
    x = px
    y = py
    z = pz
    xy = x*x + y*y
    if (xy > 1.d-15) then
      r1 = Sqrt (xy + z*z)
      xy = Sqrt (xy)
      ca = x / xy
      cb = z / r1
      sa = y / xy
      sb = xy / r1
    end if
  else
    !
    !  SWAP AROUND THE POINTS TO BE PLOTTED.
    !
    c(i1) = px
    c(i2) = py
    c(i3) = pz
    x = c(1)
    y = c(2)
    z = c(3)
    !
    !  NOW DO THE EULARIAN TRANSFORM ITSELF.
    !
    cx = real(ca*cb*x + sa*cb*y - sb*z)
    cy = real(-sa*x + ca*y)
    call graphics (cx, cy, ipen)
  end if
end subroutine euler

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine findn1 (n1, ioptl, io, delta_res)
!**********************************************************************
!
!  Locate the nitrogen atom of a peptide linkage.
!
!  On input, ioptl is a logical array of atoms which might contain a
!  peptide linkage.
!
!  On output:
!
!  n1 is the atom-number of the nitrogen atom of the peptide
!  or zero, if a nitrogen could not be found.
!
!  io is the oxygen of the "C=O" of the peptide linkage.
!
!  delta_res is the change in residue number caused by moving along
!  the chain to the N end.  This is normally zero.
!
!**********************************************************************

    use molkst_C, only: numat, isok
    use common_arrays_C, only : nat, nbonds, ibonds
    implicit none
    integer, intent (out) :: n1, io, delta_res
    logical, dimension (numat), intent (in) :: ioptl
    logical :: peptide, is_ring, ok = .true.
!
    integer :: i, iatom, ii, ires_loc, j, k, l, jj, kk, ll, mm, last_n1
    logical, external :: ring_6
    integer, external :: nheavy
    save :: ok
!
    n1 = 0
    delta_res = 0
    last_n1 = 0
!
!   FIND A N-C-C=O SYSTEM
!
    outer_loop: do iatom = 1, numat
      if ( .not. ioptl(iatom)) then
!
!   START WITH OXYGEN OF C=O
!
        if (nat(iatom) == 8 .and. nbonds(iatom) == 1) then
          do i = 1, nbonds(iatom)
            if (nat(ibonds(i, iatom)) == 6) then
!
!    THERE IS A CARBON ATTACHED TO THE OXYGEN
!
              l = ibonds(i, iatom)
      loop_k: do k = 1, nbonds(l)
                if (nat(ibonds(k, l)) == 6) then
!
!  THERE IS A CARBON ATTACHED TO THE CARBON ATTACHED
!  TO THE OXYGEN
!
                  j = ibonds(k, l)
                  if (nheavy(j) == 4) cycle loop_k
                  if (j == 4159) then
                   j = j
                   end if
!
! Make sure that C(alpha) is not part of a six-membered ring
!
                  do jj = 1, nbonds(j)
                    kk = ibonds(jj,j)
                    if (kk /= l) then
                      if (ring_6(j, l, kk)) cycle loop_k
                    end if
                    if (nat(kk) /= 6 .and. nat(kk) /= 1 .and. nat(kk) /=7) cycle loop_k
                  end do
                  do ii = 1, nbonds(j)
                    if (nheavy(ibonds(ii, j)) < 4 .and. nat(ibonds(ii, j)) == 7 .and. .not. ioptl(ibonds(ii, j))) then

!
!  THERE IS A NITROGEN ATTACHED TO THE CARBON ATTACHED TO THE
!  CARBON ATTACHED TO THE OXYGEN
!
!
!   YES, A PEPTIDE LINKAGE HAS BEEN FOUND.
!   THE NITROGEN IS N1
!
                      n1 = ibonds(ii, j)
!
!  Make sure it's not part of a ring
!
                      is_ring = .false.
                      do jj = 1, nbonds(n1)
                        kk = ibonds(jj,n1)
                        do ll = 1, nbonds(n1)
                          mm = ibonds(ll,n1)
                          if (nat(kk) > 1 .and. nat(mm) > 1 .and. kk > mm) then
                            if (ring_6(n1, mm, kk)) is_ring = .true.
                          end if
                        end do
                      end do
                      if ( is_ring) then
                        n1 = 0
                      else
                        n1 = n1
                        exit outer_loop
                      end if
                    end if
                  end do
                end if
              end do loop_k
            end if
          end do
        end if
      end if
    end do outer_loop
    io = iatom
    if (n1 == 0) return
!
!  N1 IS A NITROGEN IN AN O=C-C-N SYSTEMS.
!
    if (nat(n1) == 7) last_n1 = n1
    j = 0
    do i = 1, nbonds(n1)
      if (nat(ibonds(i, n1)) /= 1) then
        j = j + 1
      end if
    end do
    if (j == 1) return
!
!  AT THIS POINT, THE SEQUENCE O-C-C-N HAS BEEN IDENTIFIED.
!  NOW TO MOVE ALONG BACKBONE TO THE START OF THE PROTEIN
!
    peptide = .false.
    do ires_loc = 1, 1000000
      do i = 1, nbonds(n1)
        j = ibonds(i, n1)
        if (nat(j) == 6) then
          do k = 1, nbonds(j)
            if (nat(ibonds(k, j)) == 8) go to 1000
          end do
          cycle
!
!   J IS THE CARBON OF C=O
!
1000      do k = 1, nbonds(j)
            if (nat(ibonds(k, j)) == 6) then
              peptide = .true.
              go to 1010
            end if
          end do
        end if
      end do
      cycle
1010  j = ibonds(k, j)
      do k = 1, nbonds(j)
        if (nat(ibonds(k, j)) == 7) go to 1020
      end do
      if (peptide) then
!
!  The residue at the start does not contain a nitrogen atom.
!  So, temporarily, artificially convert a hydrogen into a nitrogen.
!  This will allow the second residue to be correctly identified.
!  (The first residue might be almost correctly identified)
!
        do k = 1, nbonds(j)
          if (nat(ibonds(k, j)) == 1) n1 = ibonds(k, j)
        end do
        ok = (ok .and. n1 == ibonds(k, j))
        isok = ok
      end if
      exit
1020  if (n1 == ibonds(k, j)) exit
      if (.not. ioptl(ibonds(k, j))) then
        n1 = ibonds(k, j)
        delta_res = delta_res + 1
      end if
      j = 0
      do ii = 1, nbonds(n1)
        if (nat(ibonds(ii, n1)) /= 1) then
          j = j + 1
        end if
      end do
      if (j == 1) exit
    end do
    if (nat(n1) /= 7) then
      n1 = last_n1
    end if
    return
end subroutine findn1
logical function ring_6(atom_1, atom_2, atom_6)
!
!  Given three adjacent atoms, atom_2 - atom_1 - atom_6, determine if they belong
!  to an aromatic ring.  If so, "aromatic" return .true.
!
    use common_arrays_C,  only : nbonds,  ibonds
    implicit none
    integer, intent (in) :: atom_1, atom_2, atom_6
    integer :: atom_3, atom_5, i, j, k, l, nii, njj, kka, atom_4
      ring_6 = .false.
      nii = nbonds(atom_2)
      njj = nbonds(atom_6)
      do i = 1, nii
        atom_3 = ibonds(i,atom_2)
        if (atom_3 == atom_1) cycle
        do j = 1, njj
          atom_5 = ibonds(j,atom_6)
          if (atom_5 == atom_1) cycle
          do k = 1, nbonds(atom_5)
            kka = ibonds(k,atom_5)
            if (kka == atom_6) cycle
            do l = 1, nbonds(atom_3)
              atom_4 = ibonds(l,atom_3)
              if (atom_4 == atom_2) cycle
              if (kka == atom_4) then
                if (atom_1 == atom_3 .or. atom_1 == atom_4 .or. atom_1 == atom_5) exit
                if (atom_2 == atom_3 .or. atom_2 == atom_4 .or. atom_2 == atom_5) exit
                if (atom_3 == atom_4 .or. atom_3 == atom_5 .or. atom_3 == atom_6) exit
                if (atom_4 == atom_5 .or. atom_4 == atom_6 .or. atom_5 == atom_6) exit
!
!  Six-membered ring, with atoms numbered atom_1, atom_2, atom_3, atom_4 = kka, atom_5, atom_6
!

                ring_6 = .true.
                return
              end if
            end do
          end do
        end do
      end do
      return
  end function ring_6

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

        module gpu_info
            interface
                subroutine gpuInfo(hasGpu, hasDouble, nDevices, name,name_size, totalMem, clockRate, major, minor) bind(c, name="getGPUInfo")
                    use iso_c_binding
                    implicit none
                    
                    logical(c_bool)		   :: hasGpu
                    integer(c_int)         :: nDevices
                    logical(c_bool),dimension(6)   :: hasDouble
                    integer(c_int),dimension(6)	   :: clockRate, major, minor, name_size
                    character(c_char),dimension(6) :: name
	                integer(c_size_t),dimension(6) :: totalMem
                    
                end subroutine
            end interface
        end module
        
! ******************************

        module settingGPUcard
            interface setDevice_C
                subroutine setGPU(idevice, stat) bind(c, name='setDevice')
                    use iso_c_binding
                    implicit none
                    
                    logical(c_bool)		   :: stat
                    integer(c_int), value 	:: idevice
                    
                end subroutine
            end interface
        end module
        

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine dgedi (a, lda, n, ipvt, det, work, job)
   !
   !.. Implicit Declarations ..
    implicit none
   !
   !.. Formal Arguments ..
    integer, intent (in) :: job, lda, n
    integer, dimension (n), intent (in) :: ipvt
    double precision, dimension (2), intent (out) :: det
    double precision, dimension (n), intent (out) :: work
    double precision, dimension (lda, n), intent (inout) :: a
   !
   !.. Local Scalars ..
    integer :: i, j, k, kb, kp1, l, nm1
    double precision :: t, ten
   !
   !.. External Calls ..
   !
   !.. Intrinsic Functions ..
    intrinsic Abs, Mod
   !
   ! ... Executable Statements ...
   !
   !     DGEDI COMPUTES THE DETERMINANT AND INVERSE OF A MATRIX
   !     USING THE FACTORS COMPUTED BY DGECO OR DGEFA.
   !
   !     ON ENTRY
   !
   !        A       DOUBLE PRECISION(LDA, N)
   !                THE OUTPUT FROM DGECO OR DGEFA.
   !
   !        LDA     INTEGER
   !                THE LEADING DIMENSION OF THE ARRAY  A .
   !
   !        N       INTEGER
   !                THE ORDER OF THE MATRIX  A .
   !
   !        IPVT    INTEGER(N)
   !                THE PIVOT VECTOR FROM DGECO OR DGEFA.
   !
   !        WORK    DOUBLE PRECISION(N)
   !                WORK VECTOR.  CONTENTS DESTROYED.
   !
   !        JOB     INTEGER
   !                = 11   BOTH DETERMINANT AND INVERSE.
   !                = 01   INVERSE ONLY.
   !                = 10   DETERMINANT ONLY.
   !
   !     ON RETURN
   !
   !        A       INVERSE OF ORIGINAL MATRIX IF REQUESTED.
   !                OTHERWISE UNCHANGED.
   !
   !        DET     DOUBLE PRECISION(2)
   !                DETERMINANT OF ORIGINAL MATRIX IF REQUESTED.
   !                OTHERWISE NOT REFERENCED.
   !                DETERMINANT = DET(1) * 10.0**DET(2)
   !                WITH  1.0 .LE. ABS(DET(1)) .LT. 10.0
   !                OR  DET(1) .EQ. 0.0 .
   !
   !     ERROR CONDITION
   !
   !        A DIVISION BY ZERO WILL OCCUR IF THE INPUT FACTOR CONTAINS
   !        A ZERO ON THE DIAGONAL AND THE INVERSE IS REQUESTED.
   !        IT WILL NOT OCCUR IF THE SUBROUTINES ARE CALLED CORRECTLY
   !        AND IF DGECO HAS SET RCOND .GT. 0.0 OR DGEFA HAS SET
   !        INFO .EQ. 0 .
   !
   !     LINPACK. THIS VERSION DATED 08/14/78 .
   !     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.
   !
   !     SUBROUTINES AND FUNCTIONS
   !
   !     BLAS DAXPY,DSCAL,DSWAP
   !     FORTRAN ABS,MOD
   !
   !     COMPUTE DETERMINANT
   !
    if (job/10 /= 0) then
      det(1) = 1.0d0
      det(2) = 0.0d0
      ten = 10.0d0
      do i = 1, n
        if (ipvt(i) /= i) then
          det(1) = -det(1)
        end if
        det(1) = a(i, i) * det(1)
         !        ...EXIT
        if (det(1) == 0.0d0) exit
        do while (Abs (det( 1)) < 1.0d0)
          det(1) = ten * det(1)
          det(2) = det(2) - 1.0d0
        end do
        do while (Abs (det( 1)) >= ten)
          det(1) = det(1) / ten
          det(2) = det(2) + 1.0d0
        end do
      end do
    end if
   !
   !     COMPUTE INVERSE(U)
   !
    if (Mod(job, 10) == 0) return
    do k = 1, n
      a(k, k) = 1.0d0 / a(k, k)
      t = -a(k, k)
      call dscal (k-1, t, a(1, k), 1)
      kp1 = k + 1
      if (n >= kp1) then
        do j = kp1, n
          t = a(k, j)
          a(k, j) = 0.0d0
          call daxpy (k, t, a(1, k), 1, a(1, j), 1)
        end do
      end if
    end do
   !
   !        FORM INVERSE(U)*INVERSE(L)
   !
    nm1 = n - 1
    if (nm1 < 1) return
    do kb = 1, nm1
      k = n - kb
      kp1 = k + 1
      do i = kp1, n
        work(i) = a(i, k)
        a(i, k) = 0.0d0
      end do
      do j = kp1, n
        t = work(j)
        call daxpy (n, t, a(1, j), 1, a(1, k), 1)
      end do
      l = ipvt(k)
      if (l /= k) then
        call dswap (n, a(1, k), 1, a(1, l), 1)
      end if
    end do
end subroutine dgedi

subroutine dgefa (a, lda, n, ipvt, info)
    implicit none
    integer, intent (in) :: lda, n
    integer, intent (out) :: info
    integer, dimension (n), intent (out) :: ipvt
    double precision, dimension (lda, n), intent (inout) :: a
    integer :: j, k, kp1, l, nm1
    double precision :: t
      integer, external :: idamax
!

   !
   ! ... Executable Statements ...
   !
   !     DGEFA FACTORS A DOUBLE PRECISION MATRIX BY GAUSSIAN ELIMINATION.
   !
   !     DGEFA IS USUALLY CALLED BY DGECO, BUT IT CAN BE CALLED
   !     DIRECTLY WITH A SAVING IN TIME IF  RCOND  IS NOT NEEDED.
   !     (TIME FOR DGECO) = (1 + 9/N)*(TIME FOR DGEFA) .
   !
   !     ON ENTRY
   !
   !        A       DOUBLE PRECISION(LDA, N)
   !                THE MATRIX TO BE FACTORED.
   !
   !        LDA     INTEGER
   !                THE LEADING DIMENSION OF THE ARRAY  A .
   !
   !        N       INTEGER
   !                THE ORDER OF THE MATRIX  A .
   !
   !     ON RETURN
   !
   !        A       AN UPPER TRIANGULAR MATRIX AND THE MULTIPLIERS
   !                WHICH WERE USED TO OBTAIN IT.
   !                THE FACTORIZATION CAN BE WRITTEN  A = L*U  WHERE
   !                L  IS A PRODUCT OF PERMUTATION AND UNIT LOWER
   !                TRIANGULAR MATRICES AND  U  IS UPPER TRIANGULAR.
   !
   !        IPVT    INTEGER(N)
   !                AN INTEGER VECTOR OF PIVOT INDICES.
   !
   !        INFO    INTEGER
   !                = 0  NORMAL VALUE.
   !                = K  IF  U(K,K) .EQ. 0.0 .  THIS IS NOT AN ERROR
   !                     CONDITION FOR THIS SUBROUTINE, BUT IT DOES
   !                     INDICATE THAT DGESL OR DGEDI WILL DIVIDE BY ZERO
   !                     IF CALLED.  USE  RCOND  IN DGECO FOR A RELIABLE
   !                     INDICATION OF SINGULARITY.
   !
   !     LINPACK. THIS VERSION DATED 08/14/78 .
   !     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.
   !
   !     SUBROUTINES AND FUNCTIONS
   !
   !     BLAS DAXPY,DSCAL,IDAMAX
   !
   !     GAUSSIAN ELIMINATION WITH PARTIAL PIVOTING
   !
    info = 0
    nm1 = n - 1
    if (nm1 >= 1) then
      do k = 1, nm1
        kp1 = k + 1
         !
         !        FIND L = PIVOT INDEX
         !
        l = idamax (n-k+1, a(k, k), 1) + k - 1
        ipvt(k) = l
         !
         !        ZERO PIVOT IMPLIES THIS COLUMN ALREADY TRIANGULARIZED
         !
        if (a(l, k) == 0.0d0) then
          info = k
        else
            !
            !           INTERCHANGE IF NECESSARY
            !
          if (l /= k) then
            t = a(l, k)
            a(l, k) = a(k, k)
            a(k, k) = t
          end if
            !
            !           COMPUTE MULTIPLIERS
            !
          t = -1.0d0 / a(k, k)
          call dscal (n-k, t, a(k+1, k), 1)
            !
            !           ROW ELIMINATION WITH COLUMN INDEXING
            !
          do j = kp1, n
            t = a(l, j)
            if (l /= k) then
              a(l, j) = a(k, j)
              a(k, j) = t
            end if
            call daxpy (n-k, t, a(k+1, k), 1, a(k+1, j), 1)
          end do
        end if
      end do
    end if
    ipvt(n) = n
    if (a(n, n) == 0.0d0) then
      info = n
    end if
end subroutine dgefa

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

subroutine rot (xyz)
  use common_common, only : tvec, id
  implicit none 
  double precision, dimension(3), intent(inout) :: xyz
  integer :: i, j, k
  double precision :: sum, x, y, z
  double precision, dimension(3, 3) :: unit
  do i = 1, 3
    sum = 0.d0
    do j = 1, 3
      sum = sum + tvec(j, i)**2
    end do
    sum = 1.d0 / Sqrt (sum)
    do k = 1, 3
      unit(k, i) = tvec(k, i) * sum
    end do
  end do
  sum = 1.d7
  do i = 1, id
    sum = Min (sum, unit(i, i))
  end do
  sum = 1.d0 / sum
  do i = 1, 3
    do j = 1, 3
      unit(i, j) = sum * unit(i, j)
    end do
  end do
  !
  !  UNIT is now the unitary transform for TVEC
  !
  x = xyz(1)*unit(1, 1) + xyz(2)*unit(2, 1) + xyz(3)*unit(3, 1)
  y = xyz(1)*unit(1, 2) + xyz(2)*unit(2, 2) + xyz(3)*unit(3, 2)
  z = xyz(1)*unit(1, 3) + xyz(2)*unit(2, 3) + xyz(3)*unit(3, 3)
  xyz(1) = x
  xyz(2) = y
  xyz(3) = z
end subroutine rot

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine deri0(e, n, scalar, diag, fract, nbo)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n
      double precision , intent(in) :: fract
      integer , intent(in) :: nbo(3)
      double precision , intent(in) :: e(n)
      double precision , intent(out) :: scalar(*)
      double precision , intent(inout) :: diag(*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: nopen, l, j, i
      double precision :: shift, const
!-----------------------------------------------
!
!     COMPUTE THE DIAGONAL DOMINANT PART OF THE SUPER-MATRIX AND
!     DEFINE THE SCALAR COEFFICIENTS APPLIED ON EACH ROW OF THE
!     SUPER LINEAR SYSTEM IN ORDER TO REDUCE THE EIGENVALUE SPECTRUM OF
!     THE ELECTRONIC HESSIAN,
!     THUS SPEEDING CONVERGENCE OF RELAXATION PROCESS IN 'DERI2'.
!  INPUT
!     E(N)             : EIGENVALUES OF FOCK MATRIX.
!     N                : NUMBER OF M.O.
!     NBO(3)           : OCCUPANCY BOUNDARIES.
!     FRACT            : PARTIAL OCCUPANCY OF 'OPEN' SHELLS.
!     SCALAR(MINEAR)   : SCALE APPLIED ON EACH COLUMN AND ROW OF THE
!                        SYMMETRIC SUPER SYSTEM.
!
      shift = 2.36D0
!
!     DOMINANT DIAGONAL PART OF THE SUPER-MATRIX.
!     -------------------------------------------
      nopen = nbo(1) + nbo(2)
      const = 1.D-3
      l = 1
      if (nbo(2)>0 .and. nbo(1)>0) then
!        OPEN-CLOSED
        do j = 1, nbo(1)
          if (nopen - nbo(1) > 0) then
            diag(l:nopen-nbo(1)-1+l) = (e(nbo(1)+1:nopen)-e(j))/(2.D0 - fract&
               + const)
            l = nopen - nbo(1) + l
          end if
        end do
      end if
      if (nbo(3)>0 .and. nbo(1)>0) then
!        VIRTUAL-CLOSED
        do j = 1, nbo(1)
          if (n - nopen > 0) then
            diag(l:n-nopen-1+l) = (e(nopen+1:n)-e(j))/2.D0
            l = n - nopen + l
          end if
        end do
      end if
      if (nbo(3)/=0 .and. nbo(2)/=0) then
!        VIRTUAL-OPEN
        do j = nbo(1) + 1, nopen
          if (n - nopen > 0) then
            diag(l:n-nopen-1+l) = (e(nopen+1:n)-e(j))/(fract + const)
            l = n - nopen + l
          end if
        end do
      end if
!
!     TAKE SCALE FACTORS AS (SHIFT-DIAG)**(-0.5) .
!     ------------------------------------------
      do i = 1, l - 1
        scalar(i) = sqrt(1.D0/max(0.3D0*diag(i),diag(i)-shift))
      end do
      return
      end subroutine deri0

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine xxx(type, i, j, k, l, r)
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: i
      integer , intent(in) :: j
      integer , intent(in) :: k
      integer , intent(in) :: l
      character , intent(in) :: type
      character , intent(out) :: r*(*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(4) :: ijk
      integer :: m, loop, ii, i2
!-----------------------------------------------
!***********************************************************************
!
!    XXX WILL FORM A UNIQUE STRING LABEL 'R' FOR GAUSSIAN-TYPE INPUT
!    THE LABEL WILL BE LETTER (EITHER R, P, OR F, NORMALLY), FOLLOWED
!    BY THE CONNECTIVITY, IN THE ORDER I, J, K, L.
!    'R' IS 13 CHARACTERS LONG IN ORDER TO ACCOMMODATE 3 DIGITS PER
!    LABEL, WHEN NECESSARY
!
!***********************************************************************
      r = type
      ijk(1) = i
      ijk(2) = j
      ijk(3) = k
      ijk(4) = l
      m = 1
      do loop = 1, 4
        ii = ijk(loop)
        if (ii == 0) cycle
!
!   IF LABELS GREATER THAN 99 ARE USED, UNCOMMENT THE FOLLOWING CODE
!
!#         I2=II/100
!#         IF(I2.NE.0) THEN
!#            M=M+1
!#            R(M:M)=CHAR(ICHAR('0')+I2)
!#            II=II-I2*100
!#         ENDIF
        i2 = ii/10
        if (i2 /= 0) then
          m = m + 1
          r(m:m) = char(ichar('0') + i2)
          ii = ii - i2*10
        end if
        m = m + 1
        r(m:m) = char(ichar('0') + ii)
      end do
      return
      end subroutine xxx

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine greek (n1)
    use MOZYME_C, only: nbackb
    use common_arrays_C, only : txtatm, nat, nbonds, ibonds
    implicit none
    integer, intent (in) :: n1
!
    integer :: i, ico, ihcr, ii, j, jatom1, jjj, k1, l, ll, m, ncurr, nnext
    integer :: nold4 = 0, nprev = 0
    character, dimension (22) :: types
    integer, dimension (150) :: icurr, inext, iprev
    logical :: Trp, Ile
    data types / "G", "D", "E", "Z", "H", "T", "I", "K", "L", "M", &
   & "N", "X", "O", "P", "R", "S", "T", "U", "F", "C", "Y", "W" /
   !
   !             NBACKB(1) =  Carbon CHR  of N-CHR-CO-N'
   !             NBACKB(2) =  Carbon CO   of N-CHR-CO-N'
   !             NBACKB(4) =  Nitrogen N' of N-CHR-CO-N'
    ihcr = nbackb(1)
    ico  = nbackb(2)
    jatom1 = nold4
    nold4 = nbackb(4)
   !
   !  Backbone atom 'IHCR' is ALPHA.
   !
   !   Special case:  avoid last residue being re-labeled.
   !
    do i = 1, nbonds(ihcr)
      if (nat(ibonds(i, ihcr)) == 8) go to 1000
    end do
    txtatm (ihcr) (15:15) = "A"
   !
   !  Find the BETA carbon, if present
   !
1000 do i = 1, nbonds(ihcr)
      j = ibonds(i, ihcr)
      if (nat(j) == 6) then
        if (j /= ico) go to 1010
      end if
    end do
    return
1010 txtatm (j) (15:15) = "B"
   !
   !  Now slowly go through the rest of the residue, assigning
   !  letters and numbers.
   !
    Trp = txtatm(j)(18:20) == "TRP"
    Ile = txtatm(j)(18:20) == "ILE"
    nnext = 1
    icurr(1) = j
    ncurr = 1
    iprev(1) = ihcr
    do jjj = 1, 22
      !
      !   NNEXT  =           Number of atoms of next type
      !   INEXT =     Atom numbers of atoms of next type
      !
      !   NCURR  =        Number of atoms of current type
      !   ICURR =  Atom numbers of atoms of current type
      !
      !   NPREV  =       Number of atoms of previous type
      !   IPREV = Atom numbers of atoms of previous type
      !
      nprev = ncurr
      ncurr = nnext
      nnext = 0
      do ii = 1, ncurr
        j = icurr(ii)
        if (j == n1) cycle  !  Unconditionally, do not label the N of the peptide.
        k1 = nbonds(j)
        loop1: do l = 1, k1
          m = ibonds(l, j)
            !
            !  Check that atom 'M' is not (a) a previous atom,
            !  (b) a current atom, or (c) the backbone nitrogen of a proline.
            !
          do ll = 1, nprev
            if (m == iprev(ll)) cycle loop1
          end do
          do ll = 1, ncurr
            if (m == icurr(ll)) cycle loop1
          end do
          if (m /= jatom1) then
            nnext = nnext + 1
            inext(nnext) = m
          end if
          if (nat(m) == 7 .and. txtatm(ihcr)(18:20) == "PRO") then
            nnext = max(0, nnext - 1)
          end if
        end do loop1
      end do
      if (nnext == 0) exit
      if (Trp) then
        if (jjj == 2) then
!
!  Make sure that the carbon attached to a nitrogen is first
!
          j = inext(1)
          do l = 1, nbonds(j)
            if (nat(ibonds(l,j)) == 7) exit
          end do
          if (l > nbonds(j)) then
            l = inext(1)
            inext(1) = inext(2)
            inext(2) = j
          end if
        end if
      else if (Ile) then
        if (jjj == 1) then
!
!  Make sure that CG1 is the carbon of the ethyl group in isoleucine
!
         j = inext(1)
          m = 0
          do l = 1, nbonds(j)
            if (nat(ibonds(l,j)) == 6) m = m + 1
          end do
          if (m == 1) then
            l = inext(1)
            inext(1) = inext(2)
            inext(2) = j
          end if

        end if
      end if
      call txtype (nnext, inext, types(jjj))
      !
      !  Copy current atoms into previous atoms
      !
       iprev(:ncurr) = icurr(:ncurr)
      !
      !  Copy next atoms into current atoms
      !
      icurr(:nnext) = inext(:nnext)
    end do
    return  ! go to 1020
end subroutine greek

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  subroutine set_up_dentate()
!
!   Work out which atoms are connected to which other atoms.
!   Atoms are assumed to be connected if they are within a certain distance of each other.
!
!  On exit:  nbonds(i) = number of atoms attached to atom "i"
!            ibonds(j,i) = atom numbers of atoms attached to atom i (there are nbonds(i) of these)
    use molkst_C, only : numat, l11, l21, l31, id, pdb_label
    use mozyme_C, only : nijbo, tyres
    use common_arrays_C, only : nat, coord, tvec, nbonds, ibonds, txtatm
    use atomradii_C, only: atom_radius_covalent, radius
    implicit none
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
    integer :: i, ik, j, k, jk, kl, il, iu, l
    double precision :: rmin, safety
   !
   !.. Local Arrays ..
    double precision, dimension (3) :: coord1
    nbonds = 0
    ibonds = 0
    if (allocated(radius)) deallocate (radius)
    allocate (radius(numat))
    call extvdw_for_MOZYME (radius, atom_radius_covalent)
   !
   !  ATOMS ARE ASSUMED ATTACHED IF THEY ARE WITHIN
   !  1.1  TIMES THE SUM OF THEIR COVALENT RADII.
   !
    do i = 1, numat
      do j = 1, i - 1
        rmin = 1.d6
        if (id == 0) then
          rmin = (coord(1, i)-coord(1, j)) ** 2 + &
                 (coord(2, i)-coord(2, j)) ** 2 + &
                 (coord(3, i)-coord(3, j)) ** 2
        else
          do ik = -l11, l11
            do jk = -l21, l21
              do kl = -l31, l31
                coord1(:) = coord(:, j) + tvec(:, 1)*ik + tvec(:, 2)*jk + tvec(:, 3)*kl
                rmin = Min (rmin, (coord1(1)-coord(1, i))**2 &
                                + (coord1(2)-coord(2, i))**2 &
                                + (coord1(3)-coord(3, i))**2)
              end do
            end do
          end do
        end if
!
!  Apply safety criteria to specific diatomic pairs
!
        il = min(nat(i), nat(j))
        iu = max(nat(i), nat(j))
        safety = 1.1d0
        select case (il)
          case (1)
            if (iu == 6) safety = 1.25d0  ! C-H
          case (5)
            if (iu ==7) safety = 1.0d0   ! B-N bonds are unusually short
          case (6)
            if (iu < 8) safety = 1.2d0   ! C-C, C-N, C-O
          case (16)
            if (iu == 16) safety = 1.2d0 ! S-S
          end select
        if (pdb_label) then
          if (il /= 1 .and. iu /= 1 .and. txtatm(i)(18:27) == txtatm(j)(18:27)) then
            do k = 1, 20
              if (txtatm(i)(18:20) == tyres(k)) exit
            end do
            if (k < 21) then
!
!  Both atoms are heavy atoms in the same standard amino acid residue, so be more tolerant.
!
              safety = safety*1.05d0
            end if
          end if
        end if
        if (rmin < (safety*(radius(i) + radius(j)))**2) then
          if (nbonds(i) < 15 .and. nbonds(j) < 15) then
            nbonds(i) = nbonds(i) + 1
            nbonds(j) = nbonds(j) + 1
            ibonds(nbonds(i), i) = j
            ibonds(nbonds(j), j) = i
          end if
        end if
      end do
    end do
!
!  Check for H attached to H
!
    do i = 1, numat
      if (nat(i) /= 1) cycle
      if (nbonds(i) < 2) cycle
      k = 0
      do j = 1, nbonds (i)
        if (nat(ibonds(j,i)) /= 1) then
          k = k +1
          ibonds(k,i) = ibonds(j,i)
        end if
      end do
      nbonds(i) = k
    end do
    if (allocated(nijbo)) then
!
!  Sanity check - don't allow a bond if the atoms are too far apart for nijbo to be positive
!
      do i = 1, numat
        k = 0
        do j = 1, nbonds(i)
          l = ibonds(j,i)
          if (nijbo(l,i) > -1) then
            k = k + 1
            ibonds(k,i) = l
          end if
          nbonds(i) = k
        end do
      end do
    end if
    return
  end subroutine set_up_dentate
!
!
!
  double precision function nsp2_correction()
!
!   Add a molecular mechanics correction to all nitrogen atoms that have exactly
!   three ligands.
!
    use common_arrays_C, only : nat, coord, nbonds, ibonds
    use molkst_C, only : numat, method_pm6, method_pm7, method_pm6_org, method_pm8
    implicit none
    integer :: i, j
    double precision :: correction, sum
    double precision, external :: nsp2_atom_correction
    if ( .not. (method_pm6 .or. method_pm7 .or. method_pm6_org .or. method_pm8)) then
      nsp2_correction = 0.d0
      return
    end if
    correction = 0.d0
    do i = 1, numat
      if (nat(i) == 7 .and. nbonds(i) == 3) then
        j = 0
        if (nat(ibonds(1,i)) == 1) j = 1
        if (nat(ibonds(2,i)) == 1) j = j + 1
        if (nat(ibonds(3,i)) == 1) j = j + 1
        if ( j < 2) then
          sum = nsp2_atom_correction(coord, i, ibonds(1,i), ibonds(2,i), ibonds(3,i))
          correction = correction + sum
         end if
      end if
    end do
    nsp2_correction = correction
  end function nsp2_correction
!
!
!
  double precision function nsp2_atom_correction(vectors,n,i,j,k)
  implicit none
  double precision :: vectors(3,*)
  integer :: n,i,j,k

  double precision :: a, b, c, ab, ac, bc, tot, cosa, cosb, cosc
!
!  Evaluate the penalty for non-planarity
!  - done by working out the three angles about the central atom
!  (here "n") subtended by the lines to atoms "i", "j", and "k".
!
  a = sqrt((vectors(1,n) - vectors(1,i))**2 + &
           (vectors(2,n) - vectors(2,i))**2 + &
           (vectors(3,n) - vectors(3,i))**2)
  b = sqrt((vectors(1,n) - vectors(1,j))**2 + &
           (vectors(2,n) - vectors(2,j))**2 + &
           (vectors(3,n) - vectors(3,j))**2)
  c = sqrt((vectors(1,n) - vectors(1,k))**2 + &
           (vectors(2,n) - vectors(2,k))**2 + &
           (vectors(3,n) - vectors(3,k))**2)
  ab = sqrt((vectors(1,j) - vectors(1,i))**2 + &
            (vectors(2,j) - vectors(2,i))**2 + &
            (vectors(3,j) - vectors(3,i))**2)
  ac = sqrt((vectors(1,k) - vectors(1,i))**2 + &
            (vectors(2,k) - vectors(2,i))**2 + &
            (vectors(3,k) - vectors(3,i))**2)
  bc = sqrt((vectors(1,j) - vectors(1,k))**2 + &
            (vectors(2,j) - vectors(2,k))**2 + &
            (vectors(3,j) - vectors(3,k))**2)
!
  cosa = dacos((b**2 +c**2 -bc**2)/(2.d0*b*c))
  cosb = dacos((a**2 +c**2 -ac**2)/(2.d0*a*c))
  cosc = dacos((b**2 +a**2 -ab**2)/(2.d0*b*a))
!
!  tot = difference between the sum of the three angles and
!        360 degrees, expressed as radians.
  tot = 4.d0*asin(1.d0) - (cosa + cosb + cosc)
  nsp2_atom_correction = -0.5d0*exp(-10.d0*tot)
  end function nsp2_atom_correction
!
!
!
  double precision function C_triple_bond_C()
!
! Evaluate energy contribution from acetylenic bonds - this is
! a correction to account for the extra stabilization of yne bonds
!
  use common_arrays_C, only : nat, coord, nbonds, ibonds
  use molkst_C, only : numat, method_pm6, method_pm7, method_pm6_org, method_pm8
  implicit none
  integer :: i, j, k, isum
  double precision :: rab
    if ( .not. (method_pm6 .or. method_pm7 .or. method_pm6_org .or. method_pm8)) then
      C_triple_bond_C = 0.d0
      return
    end if
    isum = 0
    do i = 1, numat
      rab = 10.d0
      if (nat(i) == 6 .and. nbonds(i) == 2) then
!
!  Possible triple bond
!
        do k = 1, nbonds(i)
          j = ibonds(k,i)
          if (j > i) cycle
          if(nat(j) == 6 .and. nbonds(j) == 2) then
            rab = (coord(1,i) - coord(1,j))**2 + (coord(2,i) - coord(2,j))**2 + (coord(3,i) - coord(3,j))**2
!
! C-C double bond length = 1.34 Angstroms
! C-C triple bond length = 1.20 Angstroms
!
            if (rab < 1.27d0**2) goto 99
          end if
        end do
        if (i < j) cycle
!
!   Carbon atom "i" is attached to two other atoms, and is attached to carbon atom "j"
!   and the i-j distance indicates that the bond is acetylenic.
!
      end if
      cycle
99    isum = isum + 1
    end do
    C_triple_bond_C = isum*12.d0  !  (The value "12" was determined empirically
  end function C_triple_bond_C
!
!
!
   double precision function Si_O_H_Correction()
!
!   If an Si-O-H structure, add in a bending perturbation
!
      use common_arrays_C, only : nat, nbonds, ibonds, coord
!
      use molkst_C, only : numat
!
      implicit none
      integer :: i, j, k, Si, O, H
      double precision :: sum
      double precision, external :: Si_O_H_bond_correction
!
      sum = 0.d0
      do i = 1, numat
        if (nat(i) == 8) then
          O = i
          Si = 0
          H = 0
          do j = 1, nbonds(i)
            k = ibonds(j,i)
            if (nat(k) == 14) Si = k
            if (nat(k) == 1) H = k
          end do
          if (Si /= 0 .and. H /= 0) then
          sum = sum + Si_O_H_bond_correction(coord, Si, O, H)
          end if
        end if
      end do
      Si_O_H_Correction = sum
      return
    end function Si_O_H_Correction
!
!
!
    double precision function Si_O_H_bond_correction(coord, Si, O, H)
      use funcon_C, only : pi
      implicit none
      integer :: Si, O, H
      double precision :: coord(3,*)
      double precision :: r_Si_O, r_O_H, ref_angle, angle
!
!  Assuming that a Si - O - H structure has been identified, now apply a correction.
!  The angle should be 115 degrees
!  Apply a Gaussian when Si - O > 1.7 Angstroms and when O - H > 1.0 Angstroms
!  Gaussian drops to 0.05 when atoms are no longer considered connected
!  = 2.02 A for Si -O, and 1.21 A for O - H
!
        r_Si_O = (coord(1,O) - coord(1,Si))**2 + (coord(2,O) - coord(2,Si))**2 + (coord(3,O) - coord(3,Si))**2 - &
              1.7d0**2
        r_O_H  = (coord(1,O) - coord(1,H ))**2 + (coord(2,O) - coord(2,H ))**2 + (coord(3,O) - coord(3,H ))**2 - &
              1.d0
        ref_angle = 125.d0*pi/180.d0
        call bangle (coord, Si, O, H, angle)
        Si_O_H_bond_correction = 15.d0*(angle - ref_angle)**2*exp(-33.d0*max(0.d0, r_Si_O))*exp(-68.d0*max(0.d0, r_O_H ))
        return
      end function Si_O_H_bond_correction

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine freqcy(fmatrx, freq, travel, force_const, eorc, deldip, ff, oldf, ts)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE molkst_C, only : numat, keywrd, nvar, mers, id
      USE common_arrays_C, only : atmass, coord, tvec
      USE funcon_C, only : fpc_10, fpc_8, fpc_6, pi
      USE chanel_C, only : iw, brillouin_fn, ibrz
      use to_screen_C, only : redmas, cnorml
      implicit none
      double precision  :: ff(*)
      logical , intent(in) :: eorc, ts
      double precision  :: fmatrx((3*numat*(3*numat+1))/2)
      double precision  :: freq(3*numat)
      double precision , intent(out) :: travel(3*numat), force_const(3*numat)
      double precision  :: deldip(3,3*numat)
      double precision , intent(out) :: oldf((3*numat*(3*numat+1))/2)
!
      integer :: loop, i, j, ij, iu, il, im1, ju, jl, ii, jj, l, linear, jii, k
      double precision, dimension(numat*3) :: wtmass
      double precision :: fact, c2pi, sumerr, sum, err, weight, summ, sum1
      logical :: bcc
!********************************************************************
!
!  FREQCY CALCULATES THE FORCE CONSTANTS AND VIBRATIONAL FREQUENCIES
!       FOR A MOLECULE.  IT USES THE ISOTOPIC MASSES TO WEIGHT THE
!       FORCE MATRIX
!
! ON INPUT   FMATRX   =  FORCE MATRIX, OF SIZE NUMAT*3*(NUMAT*3+1)/2.
!
!********************************************************************
      fact = fpc_10
!
!    CONVERSION FACTOR FOR SPEED OF LIGHT AND 2 PI.
!
      c2pi = 1.D0/(fpc_8*pi*2.D0)
! NOW TO CALCULATE THE VIBRATIONAL FREQUENCIES
!
!   FIND CONVERSION CONSTANTS FOR MASS WEIGHTED SYSTEM
      if (eorc .and. .not. ts .and. index(keywrd,' NOSYM') == 0) then
!
!     The diagonal terms of the Force Matrix should
!     be equal to minus the sum of the off-diagonal terms.
!
        do loop = 1, 20
          sumerr = 0.D0
          do i = 1, nvar
            sum = 0.D0
            err = 0.D0
            do j = 1, i - 1
              sum = sum + fmatrx((i*(i-1))/2+j)
            end do
            do j = i + 1, nvar
              sum = sum + fmatrx((j*(j-1))/2+i)
            end do
            err = err + fmatrx((i*(i+1))/2) + sum
            sumerr = sumerr + abs(err)
            fmatrx((i*(i+1))/2) = (-sum) - err*0.5D0
          end do
          call symt (fmatrx, deldip, ff)
          if (sumerr >= 1.D-6) cycle
          exit
        end do
      end if
      if (index(keywrd,' FREQCY') /= 0) then
        write (iw, '(A)') ' SYMMETRIZED HESSIAN MATRIX'
!
!   THE FORCE MATRIX IS PRINTED AS AN ATOM-ATOM MATRIX RATHER THAN
!   AS A 3N*3N MATRIX, AS THE 3N MATRIX IS VERY CONFUSING!
!
        ij = 0
        iu = 0
        do i = 1, numat
          il = iu + 1
          iu = il + 2
          im1 = i - 1
          ju = 0
          do j = 1, im1
            jl = ju + 1
            ju = jl + 2
            sum = 0.D0
            do ii = il, iu
              do jj = jl, ju
                sum = sum + fmatrx((ii*(ii-1))/2+jj)**2
              end do
            end do
            ij = ij + 1
            cnorml(ij) = sqrt(sum)
          end do
          ij = ij + 1
          cnorml(ij) = sqrt(fmatrx(((il+0)*(il+1))/2)**2 + &
                            fmatrx(((il+1)*(il+2))/2)**2 + &
                            fmatrx(((il+2)*(il+3))/2)**2 + &
                            2.D0*(fmatrx(((il+1)*(il+2))/2-1)**2 + &
                                  fmatrx(((il+2)*(il+3))/2-2)**2 + &
                                  fmatrx(((il+2)*(il+3))/2-1)**2))
        end do
        i = -numat
        call vecprt (cnorml, i)
      end if
      l = 0
      do i = 1, numat
        weight = 1.D0/sqrt(atmass(i))
        wtmass(l+1) = weight
        wtmass(l+2) = weight
        wtmass(l+3) = weight
        l = l + 3
        wtmass(l) = weight
      end do
!    CONVERT TO MASS WEIGHTED FMATRX
      linear = 0
      do i = 1, nvar
        if (i > 0) then
          oldf(linear+1:i+linear) = fmatrx(linear+1:i+linear)*1.D5
          fmatrx(linear+1:i+linear) = fmatrx(linear+1:i+linear)* &
            wtmass(i)*wtmass(:i)
          linear = i + linear
        end if
      end do
!
!    1.D5 IS TO CONVERT FROM MILLIDYNES/ANGSTROM TO DYNES/CM.

      if (Index (keywrd, " MERS") /= 0) then
!
!  Write out information for BZ.  Do NOT stop the run - the user might want
!  vibrational frequencies and thermodynamics of the cluster.
!
        bcc = (Index (keywrd, " BCC") /= 0)
        open (unit=ibrz, file=brillouin_fn, status="UNKNOWN", form="FORMATTED")
        rewind(ibrz)
        write (ibrz,*) numat*3, mers, bcc
        write (ibrz,*) (fmatrx(i), i=1, linear)
        write (ibrz,*) tvec, id, numat, ((coord(j, i)-coord(j,1), j=1, 3), i=1,numat)
        write (ibrz,*) ((i-1)*3+1,i*3, i=1, numat)
      end if
!
!    DIAGONALIZE
!
      if (.not. ts) call frame (fmatrx, numat, 1)
      call rsp (fmatrx, nvar, freq, cnorml)
      call phase_lock(cnorml, nvar)
      if (eorc .and. nvar == 3*numat) call symtrz (cnorml, freq, 2, .TRUE.)
      do i = 1, nvar
        j = int((freq(i)+50.D0)*0.01D0)
        freq(i) = freq(i) - dble(j*100)
      end do
      freq(:nvar) = freq(:nvar)*1.D5
!
!    CALCULATE REDUCED MASSES, STORE IN REDMAS
!
      do i = 1, nvar
        ii = (i - 1)*nvar
        summ = 0.D0
        do j = 1, nvar/3
          summ = summ + (cnorml(ii+j*3-2)**2 + &
                         cnorml(ii+j*3-1)**2 + &
                         cnorml(ii+j*3  )**2)**2*atmass(j)
        end do
        sum = 0.D0
        do j = 1, nvar
          jii = j + ii
          jj = (j*(j - 1))/2
          do k = 1, j
            sum = sum + cnorml(jii)*oldf(jj+k)*cnorml(k+ii)
          end do
          do k = j + 1, nvar
            sum = sum + cnorml(jii)*oldf((k*(k-1))/2+j)*cnorml(k+ii)
          end do
        end do
        sum = sum*0.5d0
        sum1 = sum*2.D0
        if (abs(freq(i)) > abs(sum)*1.D-20) then
          sum = 1.D0*sum/freq(i)
        else
          sum = 0.D0
        end if
      !
      !  Given   E = (h/2pi)freqency, then
      !          Energy = SQRT(FREQ(I)) = sqrt(force constant/reduced mass) and
      !          Reduced mass = (force constant)/(FREQ(I))
      !
      !   At this point, FREQ(I) is the square root of the energy.
      !
        redmas(i,1) = summ
        if (Abs (freq(i)) > Abs (sum)*1.d-20) then
          redmas(i, 2) = Abs (sum1/freq(i))
          sum = sum / freq(i)
        else
          redmas(i, 2) = 0.d0
          sum = 0.d0
        end if
        force_const(i) = freq(i)*redmas(i,1)*1.d-5
        freq(i) = sign(sqrt(fact*abs(freq(i)))*c2pi,freq(i))
!
! Convert frequency into SI units (ergs)
!
        sum = freq(i)*fpc_6*fpc_8
!
! Travel, in Angstroms
!
        if (force_const(i) == 0.D0) then
          travel(i) = 0.D0
        else
          travel(i) = sqrt(2.d0*sum/(force_const(i)*1.d5))*1.d8
        end if
        if (travel(i) > 1.D0) travel(i) = 0.D0
        if (abs(freq(i)) < abs(sum1)*1.D+20) then
          sum1 = sqrt(abs(freq(i)/(sum1*1.D-5)))
        else
          sum1 = 0.D0
        end if
      end do
      if (eorc) then
!
!    CONVERT NORMAL VECTORS TO CARTESIAN COORDINATES
!    (DELETED) AND NORMALIZE SO THAT THE TOTAL MOVEMENT IS 1.0 ANGSTROM.
!
        ij = 0
        do i = 1, nvar
          sum = 0.D0
          j = 0
          do jj = 1, nvar/3
            sum1 = 0.D0
            cnorml(ij+1) = cnorml(ij+1)*wtmass(j+1)
            sum1 = sum1 + cnorml(ij+1)**2
!
            cnorml(ij+2) = cnorml(ij+2)*wtmass(j+2)
            sum1 = sum1 + cnorml(ij+2)**2
!
            cnorml(ij+3) = cnorml(ij+3)*wtmass(j+3)
            sum1 = sum1 + cnorml(ij+3)**2
!
            j = j + 3
            ij = ij + 3
            sum = sum + sqrt(sum1)
          end do
          sum = 1.D0/sum
          ij = ij - nvar
          cnorml(ij+1:nvar+ij) = cnorml(ij+1:nvar+ij)*sum
          ij = nvar + ij
        end do
!
!          RETURN HESSIAN IN MILLIDYNES/ANGSTROM IN FMATRX
!
        fmatrx(:linear) = oldf(:linear)*1.D-5
      else
!
!  RETURN HESSIAN AS MASS-WEIGHTED FMATRIX
        linear = 0
!
        do i = 1, nvar
          if (i > 0) then
            fmatrx(linear+1:i+linear) = oldf(linear+1:i+linear)*1.D-5* &
              wtmass(i)*wtmass(:i)
            linear = i + linear
          end if
        end do
      end if
      return
      end subroutine freqcy

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

 
  subroutine pulay_for_gpu(f, p, n, fppf, fock, emat, &
                        & lfock, nfock, msize, start, pl) 
      USE vast_kind_param, ONLY:  double 
      integer  :: n,iopc 
      integer , intent(inout) :: lfock 
      integer , intent(inout) :: nfock 
      integer , intent(in) :: msize 
      real(double) :: pl 
      end
  
subroutine gemma_cublas(txt, txt_2, n, nocc, n_1, one, fmo, n_2, vector , mdim, zero, fck, norbs)
  end

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      module esp_C
      integer  :: nesp, idip, iz, ipx, isc, is_esp, icd, ipe, npr, ic, ip, ncc
      double precision :: dens, scale, cf, &
      & rms, rrms, dx, dy, dz, den
      double precision, dimension(0:8,821) :: fv
      double precision, dimension(-1:96) :: dex
      double precision, dimension(0:2) :: tf
      integer, dimension (10) :: ixn, iyn, izn, jxn, jyn, jzn
      double precision, dimension (0:7) :: fac

      integer, dimension(:), allocatable :: ind, itemp, ird, indc

      integer, dimension(:,:), allocatable :: iam

      double precision, dimension(:), allocatable :: cc, ex, temp, rad, es, &
      & b_esp, esp_array, cesp, cespml, al, qesp, td, dx_array, dy_array, dz_array, &
      & ptd, pexs, pce, pexpn, pewcx, pewcy, pewcz, pf0, pf1, pf2, pmtd, fc, &
      & qsc, espx, espp

      double precision, dimension(:,:), allocatable :: cespm, cen, potpc, co, &
      & potpt, ovl, cespm2, a2, exs, ce, expn, ewcx, ewcy, ewcz, f0, f1, u_esp, &
      & rnai, rnai1, rnai2, espi, exsr
      logical, dimension(:,:), allocatable :: cequiv
      data tf/33.d0, 37.d0, 41.d0/
      data fac / 1.d0, 1.d0, 2.d0, 6.d0, 24.d0, 120.d0, 720.d0, 5040.d0 /
!                S    P             D
!                s  x y z   xx yy zz xy xz yz
      data ixn /  0, 4,0,0,  8, 0, 0, 4, 4, 0 /
      data iyn /  0, 0,4,0,  0, 8, 0, 4, 0, 4 /
      data izn /  0, 0,0,4,  0, 0, 8, 0, 4, 4 /
      data jxn /  0, 1,0,0,  2, 0, 0, 1, 1, 0 /
      data jyn /  0, 0,1,0,  0, 2, 0, 1, 0, 1 /
      data jzn /  0, 0,0,1,  0, 0, 2, 0, 1, 1 /
      end module esp_C

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine mbonds (locc, lvir, f, catom, nfirst, ii, jj, ui, uj, lok, iorbs, &
     & cocc, cvir, cocc_dim, cvir_dim, numat, norbs, morb, mpack1)
    use chanel_C, only: iw
    use molkst_C, only: nelecs
    implicit none
    logical, intent (out) :: lok
    integer, intent (in) :: ii, jj, locc, lvir, morb, mpack1, cocc_dim, &
         & cvir_dim, norbs, numat
    logical, dimension (*), intent (inout) :: ui, uj
    integer, dimension (numat), intent (in) :: iorbs, nfirst
    double precision, dimension (mpack1), intent (in) :: f
    double precision, dimension (cocc_dim), intent (inout) :: cocc
    double precision, dimension (cvir_dim), intent (inout) :: cvir
    double precision, dimension (morb, norbs), intent (in) :: catom
!
    logical :: ok
    integer :: nocc, nvir
    integer :: i, i1 = 0, i2 = 0, iorbsi, iorbsj, j, j1 = 0, j2 = 0, k, l, m, ni, nj
    double precision :: alpha, beta, d, e, e11, e111, e12, e22, e221, one, &
   & sum, summax, summin
    integer, external :: ijbo
    lok = .false.
   !
   !   Four cases: Both light, one light and one heavy,
   !               one heavy and one light, and both heavy
   !
    iorbsi = iorbs(ii)
    iorbsj = iorbs(jj)
   !
    ni = nfirst(ii) - 1
    nj = nfirst(jj) - 1
    summin = 0.d0
    summax = -1.d5
    ok = .false.
    do i = 1, iorbsi
      if ( .not. ui(i)) then
        do j = 1, iorbsj
          if ( .not. uj(j)) then
            ok = .true.
            sum = 0.d0
            l = ijbo (ii, jj)
            do m = 1, iorbsj
              do k = 1, iorbsi
                l = l + 1
                sum = sum + catom(k, i+ni) * f(l) * catom(m, j+nj)
              end do
            end do
            if (sum < summin) then
              i1 = i
              j1 = j
              summin = sum
            end if
            if (sum > summax) then
              i2 = i
              j2 = j
              summax = sum
            end if
          end if
        end do
      end if
    end do
    if ( .not. ok) return
    lok = .true.
    k = 0
    do i = 1, iorbsi
      if (ui(i)) k = k + 1
    end do
    do i = 1, iorbsj
      if (uj(i)) k = k + 1
    end do
   !
    if ((locc + iorbsi + iorbsj - k) > cocc_dim .or. &
      & (lvir + iorbsi + iorbsj - k) > cvir_dim) then
      nocc = Max (1, nelecs/2)
      nvir = Max (1, norbs - nocc)
      write (iw, "(A,I3,A)") " THIS FAULT CAN PROBABLY BE " // &
     & "CORRECTED BY USE OF KEYWORD 'NLMO=", &
     & Max (Nint (Real (locc + iorbsi + iorbsj - k) / Real (nocc) &
          &     * Real (numat) / Real (norbs)), &
          & Nint (Real (lvir + iorbsi + iorbsj - k) / Real (nvir) &
          &     * Real (numat) / Real (norbs))), "'"
      write (iw,*)
      call mopend ("VALUE OF NLMO IS TOO SMALL")
      return
    end if
   !
   !   'best' hybrid pair is I1 and J1
   !
   !  Now form LCAO for the two hybrid orbitals
   !
    if (summax >-summin) then
      i1 = i2
      j1 = j2
      one = -1.d0
      e12 = -summax
    else
      one = 1.d0
      e12 = summin
    end if
    e11 = 0.d0
    e111 = 0.d0
    l = ijbo (ii, ii)
    do i = 1, iorbsi
      do j = 1, i - 1
        l = l + 1
        e111 = e111 + catom(i, ni+i1) * f(l) * catom(j, ni+i1)
      end do
      l = l + 1
      e11 = e11 + catom(i, ni+i1) * f(l) * catom(i, ni+i1)
    end do
    e11 = e11 + e111 * 2.d0
    l = ijbo (jj, jj)
    e22 = 0.d0
    e221 = 0.d0
    do i = 1, iorbsj
      do j = 1, i - 1
        l = l + 1
        e221 = e221 + catom(i, nj+j1) * f(l) * catom(j, nj+j1)
      end do
      l = l + 1
      e22 = e22 + catom(i, nj+j1) * f(l) * catom(i, nj+j1)
    end do
    e22 = e22 + e221 * 2.d0
    d = e11 - e22
    e = Sign (Sqrt(4.d0*e12*e12+d*d), d)
    alpha = Min (0.866d0, Max (Sqrt(0.5d0*(1.d0+d/e)), 0.5d0))
    beta = -Sign (Sqrt(1.d0-alpha*alpha), e12)
    do i = 1, iorbsi
    if (locc + i == 1225)then
      alpha = alpha
    end if
      cocc(locc+i) = catom(i, ni+i1) * alpha
      cvir(lvir+i) = catom(i, ni+i1) * beta
    end do
    do i = 1, Min(iorbsj, Min(cocc_dim -locc -iorbsi, cvir_dim -lvir -iorbsi))
      cocc(locc+iorbsi+i) = catom(i, nj+j1) * beta * one
      cvir(lvir+iorbsi+i) = -catom(i, nj+j1) * alpha * one
    end do
    ui(i1) = .true.
    uj(j1) = .true.
end subroutine mbonds

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  subroutine gdisp(r0ab, rs6, alp6, c6ab, s6, s8, mxc, r2r4, rcov, rs8, alp8, dxyz_temp)
!
! Calculates the derivative (gradient) of the D3 dispersion term,
! based on material provided by Stefan Grimme, University of Muenster, Germany
! v3.1 of the DFTD3 library
!
  use common_arrays_C, only: nat, cell_ijk, Vab
  use molkst_C, only : numat, l123, l1u, l2u, l3u
  implicit none
  double precision, parameter :: k1 = 16.d0
  integer, parameter :: max_elem = 94, maxc = 5 ! maximum coordination number references per element
  double precision :: &
  c6ab(max_elem, max_elem, maxc, maxc, 3), & ! C6 for all element pairs
  dxyz_temp(3,numat),                      & ! Contribution to gradient
  rcov(max_elem),                          & ! covalent radii
  cn(numat),                               & ! coordination numbers of the atoms
  r0ab(max_elem, max_elem),                & ! cut  -  off radii for all element pairs
  rs6, alp6, s6, s8, r2r4(max_elem), rs8, alp8
  integer :: mxc(max_elem)
!
!  Local variables
!
  integer :: i, j, linij, iii, jjj, i_cell, j_cell, kkkk
  double precision :: R0, r2, damp6, damp8, c6, tmp1, tmp2, r, dc6_rest, rij(3), dc6iji, dc6ijj, r6, r7, t6, t8, &
  rcovij, expterm, dcn,x1, r42, r8, r9
  double precision, allocatable :: drij(:), dc6i(:)
  double precision, external :: distance
  integer, external :: lin
!
! In this subroutine, array "coord" is in atomic units, not Angstroms.
!
  i = (numat*(numat + 1))/2
  allocate(drij(i), dc6i(numat))
  call ncoord(numat, rcov, nat, cn)
  drij = 0.d0
  dc6i = 0.d0
  dc6_rest = 0.0d0
  do i = 2, numat
    do j = 1, i - 1
      r = distance(j,i)
      if (r < 0.1d0) cycle
      r2 = r**2
      if (r2 > 10000.d0) cycle
      linij = lin(i,j)
      r0 = r0ab(nat(j),nat(i))
      r42=r2r4(nat(i))*r2r4(nat(j))
      call get_dC6_dCNij(maxc, max_elem, c6ab, mxc(nat(i)), &
            mxc(nat(j)), cn(i), cn(j), nat(i), nat(j), &
            c6, dc6iji, dc6ijj)
      r6 = r2*r2*r2
      r7 = r6*r
      r8=r6*r2
      r9=r8*r
!
!  Calculate damping functions
!
      t6  =  (r/(rs6*R0))**( - alp6)
      damp6  = 1.d0/( 1.d0 + 6.d0*t6 )
      t8 = (r/(rs8*R0))**(-alp8)
          damp8 =1.d0/( 1.d0+6.d0*t8 )
      tmp1 = s6*6.d0*damp6*C6/r7
      tmp2=s8*6.d0*C6*r42*damp8/r9
      drij(linij) = drij(linij) - tmp1 - 4.d0*tmp2
      drij(linij) = drij(linij)  + tmp1*alp6*t6*damp6 +3.d0*tmp2*alp8*t8*damp8
      dc6_rest = s6/r6*damp6 +3.d0*s8*r42/r8*damp8
!
!     saving all f_dmp/r6*dC6(ij)/dCN(i) for each atom for later
!
      dc6i(i) = dc6i(i) + dc6_rest*dc6iji
      dc6i(j) = dc6i(j) + dc6_rest*dc6ijj
    end do
  end do
!
! After calculating all derivatives dE/dr_ij w.r.t. distances,
! the grad w.r.t. the coordinates is calculated dE/dr_ij * dr_ij/dxyz_i
!
  do i = 2, numat
    do j = 1, i - 1
      linij = lin(i,j)
      r = distance(j,i)
      if (r < 0.1d0) cycle
      r2 = r**2
      rij = Vab
      r2 = sum(rij*rij)
      r = dsqrt(r2)
      if (r2 < 100.d0) then
        rcovij = rcov(nat(i)) + rcov(nat(j))
        expterm = exp( - k1*(rcovij/r - 1.d0))
        dcn =  - k1*rcovij*expterm/(r*r*(expterm + 1.d0)*(expterm + 1.d0))
      else
        dcn = 0.d0
      end if
      x1 = drij(linij) + dcn*(dc6i(i) + dc6i(j))
      iii = l123*(i - 1)
      jjj = l123*(j - 1)
      kkkk = (l3u - cell_ijk(3)) + (2*l3u + 1)*(l2u - cell_ijk(2) + (2*l2u + 1)*(l1u - cell_ijk(1))) + 1
      i_cell = iii + kkkk 
      j_cell = jjj + kkkk       
      dxyz_temp(:,i_cell) = dxyz_temp(:,i_cell) + x1*rij/r
      dxyz_temp(:,j_cell) = dxyz_temp(:,j_cell) - x1*rij/r
    end do
  end do
  return
  end subroutine gdisp


  subroutine ncoord(natoms, rcov, nat, cn)
  implicit none
  integer nat(*),natoms, i, j
  double precision cn(*), rcov(94)
  double precision r, damp, xn, rr, rco
  double precision, external :: distance
  do i = 1, natoms
    xn = 0.0d0
    do j = 1, natoms
        if (j /= i) then
          r = distance(i, j)
! covalent distance in Bohr
          rco = rcov(nat(i)) + rcov(nat(j))
          rr = rco/r
! counting function exponential has a better long - range behavior than MHGs inverse damping
          damp = 1.d0/(1.d0 + exp( -16.d0*(rr - 1.0d0)))
          xn = xn + damp
        end if
    end do
    cn(i) = xn
  end do
  return
  end subroutine ncoord

  subroutine get_dC6_dCNij(maxc ,max_elem, c6ab, mxci, mxcj,  &
    cni, cnj, izi, izj, c6check, dc6i, dc6j)
    implicit none
    integer, intent (in) :: maxc ,max_elem, mxci, mxcj
    double precision, intent (in) :: c6ab(max_elem,max_elem,maxc,maxc,3), cni, cnj
    integer :: izi, izj, a, b
    double precision :: dc6i, dc6j, c6check, term
    double precision :: zaehler, nenner, dzaehler_i, dnenner_i, dzaehler_j, dnenner_j
    double precision :: expterm, cn_refi, cn_refj, c6ref, r
    double precision :: c6mem, r_save
    c6mem =  -1.d99
    r_save = 9999.d0
    zaehler = 0.0d0
    nenner = 0.0d0
    dzaehler_i = 0.d0
    dnenner_i = 0.d0
    dzaehler_j = 0.d0
    dnenner_j = 0.d0
    do a = 1,mxci
      do b = 1,mxcj
        c6ref = c6ab(izi, izj, a, b, 1)
        if (c6ref > 0.d0) then
          cn_refi = c6ab(izi, izj, a, b, 2)
          cn_refj = c6ab(izi, izj, a, b, 3)
          r = (cn_refi - cni)*(cn_refi - cni) + (cn_refj - cnj)*(cn_refj - cnj)
          if (r < r_save) then
            r_save = r
            c6mem = c6ref
          end if
          expterm = exp(-4.d0*r)
          zaehler = zaehler + c6ref*expterm
          nenner = nenner + expterm
          expterm = -4.d0*expterm*2.d0
          term = expterm*(cni - cn_refi)
          dzaehler_i = dzaehler_i + c6ref*term
          dnenner_i  = dnenner_i + term
          term = expterm*(cnj - cn_refj)
          dzaehler_j = dzaehler_j + c6ref*term
          dnenner_j  = dnenner_j +      term
        end if
      end do
    end do

    if (nenner > 1.0d-99) then
      c6check = zaehler/nenner
      dc6i = ((dzaehler_i*nenner) - (dnenner_i*zaehler))/(nenner*nenner)
      dc6j = ((dzaehler_j*nenner) - (dnenner_j*zaehler))/(nenner*nenner)
    else
      c6check = c6mem
      dc6i = 0.0d0
      dc6j = 0.0d0
    end if
end subroutine get_dC6_dCNij

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      double precision function aabacd (iocca1, ioccb1, iocca2, ioccb2, nmos, xy)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!***********************************************************************
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: nmos
      integer , intent(in) :: iocca1(nmos)
      integer , intent(in) :: ioccb1(nmos)
      integer , intent(in) :: iocca2(nmos)
      integer , intent(in) :: ioccb2(nmos)
      double precision , intent(in) :: xy(nmos,nmos,nmos,nmos)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: ij, i, j, k, l
      double precision :: sum
!-----------------------------------------------
!**********************************************************************
!
! AABACD EVALUATES THE C.I. MATRIX ELEMENT FOR TWO MICROSTATES DIFFERING
!       BY TWO ALPHA MOS. ONE MICROSTATE HAS ALPHA ELECTRONS IN
!       M.O.S PSI(I) AND PSI(J) FOR WHICH THE OTHER MICROSTATE HAS
!       ELECTRONS IN PSI(K) AND PSI(L)
!
!**********************************************************************
      ij = 0
      do i = 1, nmos
        if (iocca1(i) >= iocca2(i)) cycle
        exit
      end do
      do j = i + 1, nmos
        if (iocca1(j) < iocca2(j)) exit
        ij = ij + iocca2(j) + ioccb2(j)
      end do
      do k = 1, nmos
        if (iocca1(k) <= iocca2(k)) cycle
        exit
      end do
      do l = k + 1, nmos
        if (iocca1(l) > iocca2(l)) exit
        ij = ij + iocca1(l) + ioccb1(l)
      end do
      ij = ij + ioccb2(i) + ioccb1(k)
      sum = xy(i,k,j,l) - xy(i,l,k,j)
      if (mod(ij,2) == 1) sum = -sum
      aabacd = sum
      return
      end function aabacd

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine denrot_for_MOZYME ()
    use molkst_C, only: numat, maxtxt, id, l1u, l2u, &
       & l3u
!
    use MOZYME_C, only : iorbs
    use chanel_C, only: iw
    use elemts_C, only: elemnt
    use common_arrays_C, only: tvec, coord, p, txtatm, nat
    implicit none
    character (len=40) :: blank
    logical :: first
    integer :: i, i1, ii, ij, imax, io, ipq, is_loc, j, j1, jj, jo, jpq, js, &
   & ks, l, l1, l2, lsp
    double precision :: delx, dely, delz, r, rmin, sum
    integer, dimension (4), save :: isp
    integer, dimension (5, 10), save :: irot
    double precision, dimension (3) :: xjuc
    double precision, dimension (4) :: sigpi
    double precision, dimension (4, 4) :: arot, pab, vect
    double precision, dimension (3, 5, 5) :: c
    integer, external :: ijbo
    data irot / 1, 1, 1, 3, 3, 2, 2, 2, 4, 3, 3, 2, 2, 2, 3, 4, 2, 2, 3, 3, 2, &
   & 3, 2, 4, 2, 3, 3, 2, 2, 2, 4, 3, 2, 3, 2, 2, 4, 2, 4, 4, 3, 4, 2, 2, 4, &
   & 4, 4, 2, 3, 4 /
    data isp / 1, 2, 3, 3 /
    blank = " "
    if (maxtxt /= 0) then
      write (iw, "(2A)") blank(:maxtxt/2 + 3)//"ATOM"//blank(:maxtxt + 4)//"ATOM" //&
      & blank(:maxtxt/2 + 7)//"s-s Sig  s-p Sig  p-p Sig  p-p Pi"
    else
      write (iw, "(2A)") "   ATOM    ATOM    S-S (Sig) " // &
                       & "  S-P (Sig)   P-P (Sig)    P-P (PI)"
    end if
    write (iw,*)
    imax = maxtxt + 10
    pab(:,:) = 0.d0
    do i = 1, numat
      io = min(iorbs(i),4)  !  Sometime this subroutine should be expanded to include "d" orbitals
      first = .true.
      ipq = Max (1, io-2)
      do j = 1, numat
        if (i /= j .and. ijbo (i, j) >= 0) then
          ij = ijbo (i, j)
          jo = min(iorbs(j),9)
          jpq = Max (1, jo-2)
          if (id == 0) then
            delx = coord(1, j) - coord(1, i)
            dely = coord(2, j) - coord(2, i)
            delz = coord(3, j) - coord(3, i)
          else
            rmin = 1.d6
            do is_loc = -l1u, l1u
              do js = -l2u, l2u
                do ks = -l3u, l3u
                  do l = 1, 3
                    xjuc(l) = coord(l, j) + tvec(l, 1) * is_loc + tvec(l, &
                   & 2) * js + tvec(l, 3) * ks - coord(l, i)
                  end do
                  r = xjuc(1) ** 2 + xjuc(2) ** 2 + xjuc(3) ** 2
                  if (r < rmin) then
                    rmin = r
                    delx = xjuc(1)
                    dely = xjuc(2)
                    delz = xjuc(3)
                  end if
                end do
              end do
            end do
          end if
          sum = 0.d0
          do ii = 1, io
            do jj = 1, jo
              ij = ij + 1
              sum = sum + p(ij) ** 2
              pab(ii, jj) = p(ij)
            end do
          end do
          if (sum >= 0.1d0) then
            call coe (delx, dely, delz, ipq, jpq, c, r)
            do i1 = 1, 4
              do j1 = 1, 4
                arot(i1, j1) = 0.d0
              end do
            end do
            do i1 = 1, 10
              arot(irot(1, i1), irot(2, i1)) = c(irot(3, i1), irot(4, i1), &
             & irot(5, i1))
            end do
            do i1 = 1, io
              do j1 = 1, jo
                vect(i1, j1) = 0.d0
              end do
            end do
            if (i /= j) then
              ij = Max (io, jo)
              do i1 = 1, io
                do j1 = 1, jo
                  sum = 0.d0
                  do l1 = 1, ij
                    do l2 = 1, ij
                      sum = sum + arot(l1, i1) * pab(l1, l2) * arot(l2, j1)
                    end do
                  end do
                  vect(isp(i1), isp(j1)) = vect(isp(i1), isp(j1)) + sum ** 2
                end do
              end do
            end if
            sigpi(2) = 0.d0
            lsp = 1
               !
               !    S-S SIGMA
               !
            sigpi(1) = vect(1, 1)
            if (jo > 1) then
              lsp = 2
                  !
                  !    S-P SIGMA
                  !
              sigpi(2) = vect(1, 2)
              if (io > 1) then
                lsp = 4
                     !
                     !    P-S SIGMA (CONT)
                     !
                sigpi(2) = sigpi(2) + vect(2, 1)
                     !
                     !    P-P SIGMA
                     !
                sigpi(3) = vect(2, 2)
                     !
                     !    P-P PI
                     !
                sigpi(4) = vect(3, 3)
              end if
            else if (io > 1) then
              lsp = 2
                  !
                  !    P-S SIGMA
                  !
              sigpi(2) = vect(2, 1)
            end if
            if (first) then
              if (maxtxt > 0) then
                write (iw, "(I6,A,I6,A,4F9.5)") i, elemnt (nat(i)) // "(" // &
               & txtatm (i) (:maxtxt) // ")", j, elemnt (nat(j)) // "(" // &
               & txtatm (j) (:maxtxt) // ")", (sigpi(ii), ii=1, lsp)
              else
                write (iw, "(I6,A,I6,A,4F12.5)") i, elemnt (nat(i)), j, elemnt &
               & (nat(j)), (sigpi(ii), ii=1, lsp)
              end if
              first = .false.
            else if (maxtxt > 0) then
              write (iw, "(A,I6,A,4F9.5)") blank (:imax), j, elemnt (nat(j)) &
             & // "(" // txtatm (j) (:maxtxt) // ")", (sigpi(ii), ii=1, lsp)
            else
              write (iw, "(8X,I6,A,4F12.5)") j, elemnt (nat(j)), (sigpi(ii), &
             & ii=1, lsp)
            end if
          end if
        end if
      end do
    end do
end subroutine denrot_for_MOZYME

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine mamult(a, b, c, n, one)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n
      double precision , intent(in) :: one
      double precision , intent(in) :: a(*)
      double precision , intent(in) :: b(*)
      double precision , intent(inout) :: c(*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: l, i, ii, j, jj, k, kk
      double precision :: sum
!-----------------------------------------------
!***********************************************************************
!
!   MAMULT MULTIPLIES A BY B AND PUTS THE RESULT IN C
!
!***********************************************************************
      l = 0
      do i = 1, n
        ii = ((i - 1)*i)/2
        do j = 1, i
          jj = ((j - 1)*j)/2
          l = l + 1
          sum = 0.D0
          do k = 1, j
            sum = sum + a(ii+k)*b(jj+k)
          end do
          do k = j + 1, i
            sum = sum + a(ii+k)*b(((k-1)*k)/2+j)
          end do
          do k = i + 1, n
            kk = (k*(k - 1))/2
            sum = sum + a(kk+i)*b(kk+j)
          end do
          c(l) = sum + one*c(l)
        end do
      end do
      return
      end subroutine mamult

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

   module radii_C
   double precision :: covalent_radii(118)
   data covalent_radii /0.37d0, 0.32d0, 1.34d0, 0.9d0, 0.82d0, 0.77d0, &
     0.75d0, 0.73d0, 0.71d0, 0.69d0, 1.54d0, 1.3d0, 1.18d0, 1.11d0, 1.06d0, 1.02d0, 0.99d0, 0.97d0, &
     1.96d0, 1.74d0, 1.44d0, 1.36d0, 1.25d0, 1.27d0, 1.39d0, 1.25d0, 1.26d0, 1.21d0, 1.38d0, 1.31d0, &
     1.26d0, 1.22d0, 1.19d0, 1.16d0, 1.14d0, 1.1d0, 2.11d0, 1.92d0, 1.62d0, 1.48d0, 1.37d0, 1.45d0, &
     1.56d0, 1.26d0, 1.35d0, 1.31d0, 1.53d0, 1.48d0, 1.44d0, 1.41d0, 1.38d0, 1.35d0, 1.33d0, 1.3d0, &
     2.25d0, 1.98d0, 1.69d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, &
     0.0d0, 0.0d0, 1.6d0, 1.5d0, 1.38d0, 1.46d0, 1.59d0, 1.28d0, 1.37d0, 1.28d0, 1.44d0, 1.49d0, 0.0d0, &
     0.0d0, 1.46d0, 0.0d0, 0.0d0, 1.45d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, &
     0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, &
     0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0d0, 0.0/
  end module radii_C

  double precision function H_bonds4(H_i, i, j, d_list, nd_list)
!
! Rezac J., Hobza P., "Advanced Corrections of Hydrogen Bonding and
! Dispersion for Semiempirical Quantum Mechanical Methods", J. Chem.
! Theory and Comp 8, 141-151 (2012).
!
  use common_arrays_C, only: coord, nat
  use molkst_C, only : numat, N_Hbonds, numcal, method_PM6_D3H4, method_PM7, method_PM8, &
    method_pm6_d3h4x, method_pm6_org
  implicit none
  integer, intent (in) :: H_i, i, j
  integer, intent (out) :: d_list(20), nd_list
!
!  Local variables
!
  integer :: d_i, a_i, k, o1, o2, cc, icalcn = -1
  double precision :: rda, rih, rjh, angle, rdh, rah, e_radial, a, x, e_angular, &
    e_para, e_bond_switch, e_scale_w, e_scale_chd, e_scale_cha, rdhs, ravgs, &
    hydrogens, others, slope, v, fv, fv2, f_o1, f_o2, f_cc, cdist, &
    cv_o1, odist, cv_cc, cv_o2, e_corr_sum, e_corr, sum
  double precision :: M_PI = 3.141592653589793d0, &
    para_oh_o = 2.32d0, para_oh_n = 3.10d0, para_nh_o = 1.07d0, para_nh_n = 2.01d0, &
    multiplier_wh_o = 0.42d0, multiplier_nh4 = 3.61d0, multiplier_coo = 1.41d0
  double precision, external :: distance, cvalence_contribution
  save :: icalcn
    cv_cc = 0.d0
    if (icalcn /= numcal) then
!
!   Variables that change depending on the method
!
      if (method_PM6_D3H4 .or. method_pm6_d3h4x .or. method_pm6_org) then
        icalcn = numcal
        para_oh_o = 2.32d0
        para_oh_n = 3.10d0
        para_nh_o = 1.07d0
        para_nh_n = 2.01d0
        multiplier_wh_o = 0.42d0
        multiplier_nh4 = 3.61d0
        multiplier_coo = 1.41d0
      else if (method_PM7 .or. method_PM8) then
        para_oh_o = 2.32d0
        para_oh_n = 3.10d0
        para_nh_o = 1.07d0
        para_nh_n = 2.01d0
        multiplier_wh_o = 0.42d0
        multiplier_nh4 = 3.61d0
        multiplier_coo = 1.41d0
      else
        para_oh_o = 2.32d0
        para_oh_n = 3.10d0
        para_nh_o = 1.07d0
        para_nh_n = 2.01d0
        multiplier_wh_o = 0.42d0
        multiplier_nh4 = 3.61d0
        multiplier_coo = 1.41d0
      end if
    end if
    d_list(1) = i
    d_list(2) = j
    d_list(3) = H_i
    nd_list = 3
!
! Iterate over donor/acceptor pairs
!
    e_corr_sum = 0.d0
    N_Hbonds = 0
! Calculate donor-acceptor distance
!
    rda = distance(i, j)
!
! Iterate over hydrogens
!

!
! Distances to hydrogen
!
    rih = distance(i, h_i)
    rjh = distance(j, h_i)
    call bangle(coord, i, h_i, j, angle)
    angle = M_PI - angle
    if (angle >= M_PI/2.d0) then
      continue
    end if
!
! Here, we have filtered out everything but correct H-bonds
! Determine donor and acceptor - donor is the closer one
!
    if (rih < rjh) then
      d_i = i
      a_i = j
      rdh = rih
      rah = rjh
    else
      d_i = j
      a_i = i
      rdh = rjh
      rah = rih
    end if
!
! Radial term
!
    e_radial = -0.00303407407407313510d0*rda**7 &
                +0.07357629629627092382d0*rda**6 &
                -0.70087111111082800452d0*rda**5 &
                +3.25309629629461749545d0*rda**4 &
                -7.20687407406838786983d0*rda**3 &
                +5.31754666665572184314d0*rda**2 &
                +3.40736000001102778967d0*rda  &
                -4.68512000000450434811d0
!
!  The e_radial function has a minimum at rda = 5.5 Angstroms:
!  rda  e_radial   rda    e_radial
!  4.50 -0.143     6.75   -1.531
!  4.75 -0.056     7.00   -3.601
!  5.00 -0.013     7.25   -7.527
!  5.25 -0.001     7.50  -14.418
!  5.50  0.000     7.75  -25.819
!  5.75 -0.001     8.00  -43.815
!  6.00 -0.026     8.25  -71.155
!  6.25 -0.152     8.50 -111.391
!  6.50 -0.550     8.75 -169.028
!
! This is set in "cutoff" in find_H__Y_bonds
!
! Angular term
!
    a = angle/(M_PI/2.d0)
    x = -20.d0*a**7 + 70.d0*a**6 - 84.d0*a**5 + 35.d0*a**4
    e_angular = 1.d0 - x*x
!
! Energy coefficient
!
    e_para = 0.d0
    if (nat(d_i) == 8 .and. nat(a_i) == 8) e_para = para_oh_o
    if (nat(d_i) == 8 .and. nat(a_i) == 7) e_para = para_oh_n
    if (nat(d_i) == 7 .and. nat(a_i) == 8) e_para = para_nh_o
    if (nat(d_i) == 7 .and. nat(a_i) == 7) e_para = para_nh_n
!
! Bond switching
!
    if (rdh > 1.15d0) then
      rdhs = rdh - 1.15d0
      ravgs = 0.5d0*rdh + 0.5d0*rah - 1.15d0
      x = rdhs/ravgs
      e_bond_switch = 1.d0 - (-20.d0*x**7 + 70.d0*x**6 -84.d0*x**5 + 35.d0*x**4)
    else
!
! No switching, no gradient
!
      e_bond_switch = 1.d0
    end if
!
! Water scaling
!
    e_scale_w = 1.d0
    if (nat(d_i) == 8 .and. nat(a_i) == 8) then
      hydrogens = 0.d0
      others = 0.d0
      do k = 1, numat
        if (nat(k) == 1) then
          hydrogens = hydrogens + cvalence_contribution(d_i, k, d_list, nd_list)
        else
          others = others + cvalence_contribution(d_i, k, d_list, nd_list)
        end if
      end do
!
! If it is water
!
      if (hydrogens >= 1.d0) then
        slope = multiplier_wh_o -1.d0
        v = hydrogens
        fv = 0.d0
        if (v > 1.d0 .and. v <= 2.d0) then
          fv = v - 1.d0
        end if
        if (v > 2.d0 .and. v < 3.d0) then
          fv = 3.d0 -v
        end if
        fv2 = max(1.d0 - others, 0.d0)
        e_scale_w = 1.d0 + slope*fv*fv2
      end if
    end if
!
! Charged groups
!
    e_scale_chd = 1.d0
    e_scale_cha = 1.d0
!
! Scaled groups: NR4+
!
    if (nat(d_i) == 7) then
      slope = multiplier_nh4 - 1.d0
      v = 0.d0
      do k = 1, numat
        v = v + cvalence_contribution(d_i, k, d_list, nd_list)
      end do
      if (v > 3.d0) then
        v = v - 3.d0
      else
        v = 0.d0
      end if
      e_scale_chd = 1.d0 + slope*v
    end if
!
! Scaled groups: COO-
!
    f_o1 = 0.d0
    f_o2 = 0.d0
    f_cc = 0.d0
    o1 = a_i
    o2 = -1
    cc = -1
    if (nat(a_i) == 8) then
      slope = multiplier_coo - 1.d0
!
! Search for closest C atom
!
      cdist = 9.9d9
      cv_o1 = 0.d0
      do k = 1, numat
        v = cvalence_contribution(o1, k, d_list, nd_list)
        cv_o1 = cv_o1 + v! Sum O1 valence
        sum = distance(o1, k)
        if (v > 0.d0 .and. nat(k) == 6 .and. sum < cdist) then
          cdist =  sum
          cc = k
        end if
      end do
!
! If C found, look for the second O
!
      if (cc /= -1) then
        odist = 9.9d9
        cv_cc = 0.d0
        do k = 1, numat
          v = cvalence_contribution(cc, k, d_list, nd_list)
          cv_cc = cv_cc + v
          sum = distance(cc, k)
          if ((v > 0.d0) .and. (k /= o1) .and. (nat(k) == 8) .and. (sum < odist)) then
            odist =  sum
            o2 = k
          end if
        end do
      end if
!
! O1-C-O2 triad:
!
      if (o2 /= -1) then
!
! Get O2 valence
!
        cv_o2 = 0.d0
        do k = 1, numat
          cv_o2 = cv_o2 +cvalence_contribution(o2, k, d_list, nd_list)
        end do
        f_o1 = max(1.d0 - abs(1.d0 - cv_o1), 0.d0)
        f_o2 = max(1.d0 - abs(1.d0 - cv_o2), 0.d0)
        f_cc = max(1.d0 - abs(3.d0 - cv_cc), 0.d0)
        e_scale_cha = 1.d0 + slope*f_o1*f_o2*f_cc
      end if
    end if
!
! Final energy
!
    e_corr = e_para*e_radial*e_angular*e_bond_switch*e_scale_w*e_scale_chd*e_scale_cha
    if (e_corr < -1.d0) then
      N_Hbonds = N_Hbonds + 1
    end if
    e_corr_sum = e_corr_sum  + e_corr
    H_bonds4 = e_corr_sum
  end function H_bonds4




  function energy_corr_hh_rep(l_grad, dxyz)
    use common_arrays_C, only: nat, cell_ijk, Vab
    use molkst_C, only : numat, keywrd, e_hh, l123, l1u, l2u, l3u
    use chanel_C, only : iw
    use elemts_C, only: elemnt
    implicit none
    logical, intent (in) :: l_grad
    double precision, intent (inout) :: dxyz(3, numat*l123)
    double precision :: grad_hh(3, numat*l123)
    double precision :: e_corr, r, d_rad, g(3), energy_corr_hh_rep
    integer :: i, j, iii, jjj, i_cell, j_cell, kkkk
    double precision, external :: distance, poly
    e_hh = 0.d0
    grad_hh = 0.d0
!
! Iterate over H atoms twice
!
    do i = 1, numat
      if (nat(i) /= 1) cycle
      do j = 1, i - 1
        if (nat(j) /= 1) cycle
!
! Calculate distance
!
        r = distance(j, i)
        if (cell_ijk(1) /= 0) then
          continue
        end if

        e_corr = poly(r, l_grad, d_rad)
        e_hh = e_hh + e_corr
        if (l_grad) then
!
! Cartesian components of the gradient
!
          g(:) = Vab(:)/r*d_rad
!
! Add pair contribution to the global gradient
!
          iii = l123*(i - 1)
          jjj = l123*(j - 1)
          kkkk = (l3u - cell_ijk(3)) + (2*l3u + 1)*(l2u - cell_ijk(2) + (2*l2u + 1)*(l1u - cell_ijk(1))) + 1
          i_cell = iii + kkkk
          j_cell = jjj + kkkk
          grad_hh(:,i_cell) = grad_hh(:,i_cell) - g(:)
          grad_hh(:,j_cell) = grad_hh(:,j_cell) + g(:)
        end if
      end do
    end do
    energy_corr_hh_rep = e_hh
    if (l_grad) then
      dxyz = dxyz + grad_hh
      if (index(keywrd, " DERIV") > 0) then
        write (iw, '(/25X,a)')"HH REPULSION"
        write (iw, '(" NUMBER  ATOM  ",5X,"X",12X,"Y",12X,"Z",/)')
        write (iw, '(I6,4x,a2,F13.6,2F13.6)') (i, elemnt(nat(i)), grad_hh(:,i), i = 1,numat)
      end if
    end if
    return
  end function energy_corr_hh_rep
  double precision function poly(r, l_grad, dpoly)
    implicit none
    double precision :: r, dpoly
    logical :: l_grad
!
!  poly is the hydrogen-hydrogen correction for two atoms separated by "r" Angstroms
!  dpoly is the gradient of the internal coordinate
!
    if (r <= 1.d0) then
      poly = 25.46293603147693d0
      dpoly = 0.d0
    else if ( r > 1.d0 .and. r < 1.5d0) then
      poly =  -2714.952351603469651d0 * r**5 &
             +17103.650110591705015d0 * r**4 &
             -42511.857982217959943d0 * r**3 &
             +52063.196799138342612d0 * r**2 &
             -31430.658335972289933d0 * r    &
              +7516.084696095140316d0
      if (l_grad) &
        dpoly = -2714.952351603469651d0*5.d0 * r**4 &
               +17103.650110591705015d0*4.d0 * r**3 &
               -42511.857982217959943d0*3.d0 * r**2 &
               +52063.196799138342612d0*2.d0 * r    &
               -31430.658335972289933d0
    else
      poly = 118.7326d0*exp(-1.53965d0*(r**1.72905d0))
      if (l_grad) &
      dpoly = -1.53965d0*1.72905d0*r**0.72905d0*118.7326d0*exp(-1.53965d0*(r**1.72905d0))
    end if
    return
  end function poly


   function cvalence_contribution(atom_a, atom_b, d_list, nd_list)
    use common_arrays_C, only: nat
    use radii_C, only : covalent_radii
    implicit none
    integer, intent (in) :: atom_a, atom_b
    integer, intent (inout) :: d_list(20), nd_list
    integer :: i
    double precision :: r, ri, rj, r0, r1, x, cvalence_contribution
    double precision, external :: distance
    ri = covalent_radii(nat(atom_a))
    rj = covalent_radii(nat(atom_b))
    r0 = ri + rj
    r1 = r0*1.6d0
    r = distance(atom_a, atom_b)
    if (r == 0.d0 .or. r >= r1) then
      cvalence_contribution = 0.d0
    else if (r <= r0) then
      cvalence_contribution = 1.d0
    else
      x = (r - r0)/(r1 - r0)
      cvalence_contribution = 1.d0 - (-20.d0*x**7 + 70.d0*x**6 -84.d0*x**5 + 35.d0*x**4)
      do i = 1, nd_list
        if (d_list(i) == atom_b) exit
      end do
      if (i > nd_list) then
        nd_list = nd_list + 1
        d_list(nd_list) = atom_b
      end if
    end if
    return
  end function cvalence_contribution

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine density_for_GPU (c, fract, ndubl, nsingl, occ, mpack, norbs, mode, pp, iopc)
#ifdef GPU
      Use mod_vars_cuda, only: real_cuda, prec, nthreads_gpu, nblocks_gpu
      Use iso_c_binding
      Use density_cuda_i
      Use call_gemm_cublas
      Use call_syrk_cublas
#endif
      implicit none
      Integer :: ndubl, nsingl, mode, mpack, norbs, nl1, nl2, nu1, nu2, i, j, l, &
	           & nl21, nl11, iopc
      double precision,allocatable :: xmat(:,:)
      double precision :: c(norbs,norbs), pp(mpack)
      double precision :: cst, sign, fract, frac, occ, sum1, sum2
#ifdef GPU
      double precision, allocatable :: pdens(:)
#endif
      if (ndubl /= 0 .and. nsingl > (norbs/2) .and. mode /= 2) then
        !
        !    TAKE POSITRON EQUIVALENT
        !
        sign = -1.d0
        frac = occ - fract
        cst = occ
        nl2 = nsingl + 1
        nu2 = norbs
        nl1 = ndubl + 1
        nu1 = nsingl
      else
        !
        !    TAKE ELECTRON EQUIVALENT
        !
        sign = 1.d0
        frac = fract
        cst = 0.d0
        nl2 = 1
        nu2 = ndubl
        nl1 = ndubl + 1
        nu1 = nsingl
      end if
      Select case (iopc)
        case(2)   ! Option to use dgemm from CUBLAS
#ifdef GPU

          nl21 = Min (norbs, nl2)
          nl11 = Min (norbs, nl1)
          allocate(xmat(norbs,norbs),stat = i)
          call gemm_cublas ('N', 'T', norbs, norbs, nu2-nl2+1, 2.0_prec*sign, c(1:norbs,nl21:norbs),&
                        &   norbs, c(1:norbs,nl21:norbs), norbs, 0.0_prec, xmat, norbs)
          call gemm_cublas ('N', 'T', norbs, norbs, nu1-nl1+1, frac*sign, c(1:norbs,nl11:norbs), &
                        &   norbs, c(1:norbs,nl11:norbs), norbs, 1.0_prec, xmat, norbs)
          forall (i=1:norbs)
             xmat(i,i) = xmat(i,i) + cst
          endforall
          call dtrttp('u', norbs, xmat, norbs, pp, i )
          deallocate (xmat,stat=i)
#endif
        case(3)   ! Option to use dgemm from BLAS

          nl21 = Min (norbs, nl2)
          nl11 = Min (norbs, nl1)

          allocate(xmat(norbs,norbs),stat = i)
          if (norbs < 0) forall (j=1:norbs,i=1:norbs) xmat(i,j) = 0.d0  ! Dummy statement to 'fool' FORTRAN checks

          call dgemm ('N', 'T', norbs, norbs, nu2-nl2+1, 2.0d0*sign, c(1:norbs,nl21:norbs),&
                        &   norbs, c(1:norbs,nl21:norbs), norbs, 0.0d0, xmat, norbs)
          call dgemm ('N', 'T', norbs, norbs, nu1-nl1+1, frac*sign, c(1:norbs,nl11:norbs), &
                        &   norbs, c(1:norbs,nl11:norbs), norbs, 1.0d0, xmat, norbs)

          forall (i=1:norbs)
             xmat(i,i) = xmat(i,i) + cst
          endforall

          call dtrttp('u', norbs, xmat, norbs, pp, i )

          deallocate (xmat,stat=i)
        case(4)   ! Option to use dsyrk from CUBLAS
#ifdef GPU
          allocate(xmat(norbs,norbs),stat = i)
          forall (j = 1:norbs, i=1:norbs) xmat(i, j) = 0.d0
          call syrk_cublas ('U','N',norbs,ndubl, &
                 & occ,c(1:norbs,1:ndubl),norbs, &
                 & 0.d0,xmat,norbs)
          call dtrttp('u', norbs, xmat, norbs, pp, i )
          deallocate(xmat,stat=i)
#endif
        case(5)   ! Option to use dsyrk from BLAS
          if (fract < 1.d-2) then
            allocate(xmat(norbs,norbs),stat = i)
            forall (j = 1:norbs, i=1:norbs) xmat(i, j) = 0.d0
            call dsyrk ('u', 'n', norbs, ndubl, occ, c(1:norbs,1:ndubl), norbs, 0.d0, xmat, norbs) ! For RHF	      	      	
            call dtrttp('u', norbs, xmat, norbs, pp, i )
            deallocate (xmat,stat=i)
          else
!
! The following block should be re-cast in a modern style "someday"
! It's used only infrequently, so updating it is not urgent.
!
            l = 0
            do i = 1, norbs
              do j = 1, i
                l = l + 1
                sum1 = 0.D0
                sum2 = sum(c(i,nl2:nu2)*c(j,nl2:nu2))
                sum2 = sum2*occ
                sum1 = sum(c(i,nl1:nu1)*c(j,nl1:nu1))
                pp(l) = (sum2 + sum1*frac)*sign
              end do
              pp(l) = cst + pp(l)
            end do
          end if
    End select
    continue
    return
End subroutine density_for_GPU

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine delsta (nat, iorbs, p, cdi, dstat, ii, jj)
   !***********************************************************************
   !                                                                      *
   !   DELSTA calculates the derivative of the energy WRT Cartesian       *
   !   coordinates.  Called by DCART only.                                *
   ! On input: CDI:    The coordinates of the two atoms                   *
   !           P:      The density matrix (only the diagonal will be used *
   !           II,JJ:  The atom numbers                                   *
   ! On exit:  DSTAT:  Derivatives (3 numbers)                            *
   !                                                                      *
   !***********************************************************************
    use molkst_C, only: numat, mpack, cutofp
    use funcon_C, only: fpc_9, ev
    use parameters_C, only: tore
   !
   !.. Implicit Declarations ..
    implicit none
   !
   !.. Formal Arguments ..
    integer, intent (in) :: ii, jj
    integer, dimension (numat), intent (in) :: iorbs, nat
    double precision, dimension (3), intent (out) :: dstat
    double precision, dimension (mpack), intent (in) :: p
    double precision, dimension (3, 2), intent (in) :: cdi
   !
   !.. Local Scalars ..
    integer :: k, l
    double precision :: qii, qjj, rij, sum
   !
   !.. Local Arrays ..
    double precision, dimension (3) :: vect
    integer, external :: ijbo
   !
   !.. Intrinsic Functions ..
    intrinsic Sqrt
   !
   ! ... Executable Statements ...
   !
    qii = tore(nat(ii))
    l = ijbo (ii, ii)
    do k = 1, iorbs(ii)
      l = l + k
      qii = qii - p(l)
    end do
    qjj = tore(nat(jj))
    l = ijbo (jj, jj)
    do k = 1, iorbs(jj)
      l = l + k
      qjj = qjj - p(l)
    end do
    rij = Sqrt ((cdi(1, 1)-cdi(1, 2))**2+ (cdi(2, 1)-cdi(2, 2))**2+ (cdi(3, &
   & 1)-cdi(3, 2))**2)
    if (rij > cutofp) then
      do k = 1, 3
        dstat(k) = 0.d0
      end do
    else
      do k = 1, 3
        vect(k) = (cdi(k, 1)-cdi(k, 2)) / rij
      end do
      !
      !   This component of the derivative has an electrostatic term only
      !
      sum = fpc_9 * ev / rij ** 2
      do k = 1, 3
        dstat(k) = -0.5d0 * qjj * qii * sum * vect(k)
      end do
    end if
end subroutine delsta

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine rsp(a, n, root, vect)
      implicit none
      integer  :: n
      double precision  :: a(*)
      double precision, intent (out)  :: root(n)
      double precision  :: vect(n,n)
!
! Trivial case: n = 1
!
      if (n == 1) then
        root(1) = a(1)
        vect(1,1) = 1.d0
        return
      end if
      call eigenvectors_LAPACK(vect, a, root, n)
      return
      end subroutine rsp

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

    integer function ijbo (ii, jj)
    !**********************************************************************
    !
    !  Given atom numbers II and JJ,
    !  IJBO = -1 if the atoms are separated by more than SQRT(CUTOF1), else
    !  IJBO = -2 if the atoms are separated by more than SQRT(CUTOF2), else
    !  IJBO = N, where "N+1" in the address of the starting location in the
    !            H, P, and F arrays.
    !
    !**********************************************************************
      use overlaps_C, only: cutof1, cutof2
      use common_arrays_C, only: coord
      use MOZYME_C, only : lijbo, nijbo, iij, numij, ijall, iijj
      implicit none
      integer, intent (in) :: ii, jj
      integer :: ik, il, iu, j, ind_i, ind_j, jm1, jm2
      double precision :: r
      if (lijbo) then
        ijbo = nijbo(ii, jj)
        return
      end if
!
      r =      (coord(1, ii)-coord(1, jj)) ** 2 &
           & + (coord(2, ii)-coord(2, jj)) ** 2 &
           & + (coord(3, ii)-coord(3, jj)) ** 2
      if (r > cutof1) then
        ijbo = -1
        return
      end if
      if (r > cutof2) then
        ijbo = -2
        return
      end if
    !
    !   use lookup array to find ijbo
    !
      if (ii > jj) then
        ind_i = ii
        ind_j = jj
      else
        ind_i = jj
        ind_j = ii
      end if
      il = iij(ind_i)
      iu = numij(ind_i)
      j = (il+iu+1) / 2
      jm1 = 0
      jm2 = 0
      do
        ik = ijall(j)
        if (ik < ind_j) then
          il = j
          j = (j+iu+1) / 2
        else
          if (ik == ind_j) exit
          iu = j
          j = (j+il) / 2
          if (j == jm2) then
            ijbo = -2
            return
          end if
          jm1 = j
          jm2 = jm1
        end if
      end do
      ijbo = iijj(j)
      return
    end function ijbo

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.
 
  subroutine pparsav(save_parameters)
    use param_global_C, only : valvar, valold, toplim, &
    botlim, numvar, ifiles_8, locvar, contrl, fnsnew, penalty
!
    use chanel_C, only : iext
    use molkst_C, only : jobnam, line
    use parameters_C, only : partyp, t_par
    use elemts_C, only : elemnt
    implicit none
    logical :: save_parameters
!-----------------------------------------------------------------------
    integer :: i, j, k
    double precision :: penalty_fn, sum
    character :: elemnt2*2, num*1
    intrinsic Index
!-----------------------------------------------------------------------
    if(save_parameters) then
      if (numvar == 0) return
      k = len_trim(jobnam)
      i = Index(contrl, "NEW_RP=")
      if (i /= 0) then
      j = Index(contrl(i:)," ") + i - 2
      if(contrl(j:j) /= "/") then
        j = j + 1
        contrl(j:j) = "/"
      end if
      line = contrl(i+13:j)//jobnam (:k) // "." // "rp"
      else
      line = jobnam (:k) // "." // "rp"
      end if
      open (unit=iext, form="FORMATTED", file=line)
      rewind (iext)
      write(iext,"('*',/,2a,/,'*')")'* Parameter    Element     New value   ',&
      & '    Change   '
      write(ifiles_8,"(2a)")'  Parameter    Element     New value   ',&
      & '    Change   Limits: Low    High      Penalty     Gradient'
      do i = 1, numvar
        j = locvar(2, i)/200
        if(j /= 0) then
          elemnt2 = elemnt(j)
           if(elemnt2(1:1) == " ")elemnt2 = elemnt2(2:2)
          j = locvar(2,i) - j*200
        else
          elemnt2 = " "
          j = locvar(2,i)
        endif
        penalty_fn = penalty*((Max(0.d0, valvar(i)-toplim(i))+Min(0.d0, valvar(i)-botlim(i))))**2
        if (locvar(1, i) == 41) then
          num = "1"
          if (j > 9) num = "2"
          write(elemnt2,'(i'//num//')')j
          write (line, "(4X,'PAR',a2,11X,2F15.8, 2x, a)") elemnt2, &
          &             valvar(i), valvar(i) - valold(i), t_par(j)
        else
          write (line, "(4X,A7,5X,A2,2X,2F15.8)") partyp(locvar(1, i))//elemnt2, &
          & elemnt(j), valvar(i), valvar(i) - valold(i)
        endif
 !       if (valvar(i)-toplim(i) < 0.d0 .and. valvar(i)-botlim(i) > 0.d0) line(52:82) = " "
        write (iext, "(a)") " "//trim(line)
      end do
    end if
!
!  For parameters that should always be a maximum or a minimum, modify
!  the limits to impose a mild force on the parameter
!
    do i = 1, numvar
      if (botlim(i) < -1.d3) then
!
! This parameter should be as negative as possible.  Set the upper bound
! slightly lower than the actual parameter. (difference is such that the force = botlim*0.0001)
!
        toplim(i) = valvar(i) - 0.000158114*sqrt(-botlim(i))
      end if
      if (toplim(i) > 1.d3) then
!
! This parameter should be as positive as possible.  Set the lower bound
! slightly higher than the actual parameter.
!
        botlim(i) = valvar(i) + 0.000158114*sqrt(toplim(i))
      end if
    end do
    sum = 0.d0
    do i = 1, numvar
      j = locvar(2, i)/200
      if (j /= 0) then
        elemnt2 = elemnt(j)
        if(elemnt2(1:1) == " ")elemnt2 = elemnt2(2:2)
        j = locvar(2,i) - j*200
      else
         elemnt2 = " "
         j = locvar(2,i)
      endif
      penalty_fn = penalty*((Max(0.d0, valvar(i)-toplim(i))+Min(0.d0, valvar(i)-botlim(i))))**2
      if (locvar(1, i) == 41) then
        num = "1"
        if (j > 9) num = "2"
        write(elemnt2,'(i'//num//')')j
        write (line, "(4X,'PAR',a2,11X,2F15.8,F12.2,F8.2,f12.2,f14.2, 2x, a)") elemnt2, &
        &             valvar(i), valvar(i) - valold(i), botlim(i), toplim(i), &
        & penalty_fn,fnsnew(i), t_par(j)
      else
        write (line, "(4X,A7,5X,A2,2X,2F15.8,F12.2,F8.2,f12.2,f14.2)") partyp(locvar(1, i))//elemnt2, &
        & elemnt(j), valvar(i), valvar(i) - valold(i), botlim(i), toplim(i), &
        & penalty_fn,fnsnew(i)
      endif
      if (valvar(i)-toplim(i) < 0.d0 .and. valvar(i)-botlim(i) > 0.d0) line(52:82) = " "
      write (ifiles_8, "(a)") " "//trim(line)
    end do
    do i = 1, numvar
      valold(i) = valvar(i)
    end do
    close (iext)
    if (sum > 1.d-6) write(ifiles_8,"(a,f12.2)")' Total penalty function:', sum
    if(save_parameters) write (ifiles_8,*) " PARAMETERS DUMPED O.K."
  end subroutine pparsav
  subroutine trim_parameter_set
    use param_global_C, only : valvar, valold, toplim,  diffns, contrl, &
    botlim, numvar, locvar, fnsnew, nfns
!
! Trim the parameter set so that only the parameters with the largest gradients are used in the parameter optimization
!
    implicit none
    double precision :: store_fnsnew(numvar), store_valvar(numvar), store_botlim(numvar), store_toplim(numvar), &
      store_valold(numvar), store_diffns(numvar,nfns), weighted_fnsnew(numvar), sum
    integer :: store_locvar(2,numvar)
    integer :: i, j, loop, new_numvar
    double precision, external :: reada
    store_fnsnew(:numvar) = fnsnew(:numvar)
    store_locvar(:,:numvar) = locvar(:,:numvar)
    store_valvar(:numvar) = valvar(:numvar)
    store_valold(:numvar) = valold(:numvar)
    store_botlim(:numvar) = botlim(:numvar)
    store_toplim(:numvar) = toplim(:numvar)
    store_diffns(:numvar,:nfns) = diffns(:numvar,:nfns)
    i = index(contrl, " NUMOPT")
    if (i == 0) then
      return
    else
      new_numvar = nint(reada(contrl, i))
      if (new_numvar >= numvar) return
    end if
!
!  Identify the new_numvar parameters with the largest gradients
!
    do loop = 1, numvar
      sum = 0.1d0
      do i = 1, nfns
        sum = sum + diffns(loop,i)**2
      end do
      weighted_fnsnew(loop) = fnsnew(loop)/sqrt(sum)
    end do   
    deallocate(diffns)
    allocate(diffns(new_numvar,nfns))
    do loop = 1, new_numvar
      sum = 0.d0
      do i = 1, numvar
        if (abs(weighted_fnsnew(i)) > sum) then
          sum = abs(weighted_fnsnew(i))
          j = i
        end if
      end do
      fnsnew(loop) =  store_fnsnew(j)
      weighted_fnsnew(j) = 0.d0
      locvar(:,loop) = store_locvar(:,j)
      valvar(loop) = store_valvar(j)
      valold(loop) = store_valold(j)
      botlim(loop) = store_botlim(j)
      toplim(loop) = store_toplim(j)
      diffns(loop,:nfns) = store_diffns(j,:nfns)      
    end do
    numvar = new_numvar   
    return
  end subroutine trim_parameter_set

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine convert_mat_packed_to_triangle (matrix_packed, matrix_triangle)
   !***********************************************************************
   !                                                                      *
   !        Converts matrix from the storage format used                  *
   !        in MOZYME into lower triangular form.
   !                                                                      *
   !***********************************************************************
    use molkst_C, only: numat, norbs, mpack
    use common_arrays_C, only: nfirst, nlast
    implicit none
    double precision, dimension (norbs*(norbs+1)/2), intent (out) :: &
         & matrix_triangle
    double precision, dimension (mpack), intent (in) :: matrix_packed
    integer :: i, ii, ij, il, iu, j, jj, jl, ju, linear
    integer, external :: ijbo
   !
    linear = (norbs*(norbs+1)) / 2
    do i = 1, linear
      matrix_triangle(i) = 0.d0
    end do
    do i = 1, numat
      do j = 1, i
        if (ijbo(i, j) >= 0) then
          ij = ijbo (i, j)
          il = nfirst(i)
          iu = nlast(i)
          jl = nfirst(j)
          ju = nlast(j)
          do ii = il, iu
            do jj = jl, min(ju, ii)
              ij = ij + 1
              matrix_triangle((ii*(ii-1))/2+jj) = matrix_packed(ij)
            end do
          end do
        end if
      end do
    end do
end subroutine convert_mat_packed_to_triangle

subroutine convert_lmo_packed_to_square (c_square)
   !***********************************************************************
   !                                                                      *
   !        Converts LMOs from the storage format used in MOZYME to that  *
   !        used in MOPAC.
   !                                                                      *
   !***********************************************************************
    use molkst_C, only: norbs, nelecs
    use MOZYME_C, only: isort, nce, ncf, ncocc, ncvir, nnce, nncf, &
          icocc, icvir, cocc, cvir
    use common_arrays_C, only : nfirst, nlast
    implicit none
    double precision, dimension (norbs, norbs), intent (out) :: c_square
    integer :: i, ii, iunsrt, j, jj, k, ka, nocc, nvir, alloc_stat
    nocc = nelecs / 2
    nvir = norbs - nocc
    if (.not. Allocated (isort)) then
!
!  isort has not been assigned, therefore assume that eigenvectors are not wanted.
!  in which case, use the LMOs in the order in which they occur
!
      allocate (isort(norbs), stat=alloc_stat)
      if (alloc_stat /= 0) then
        call memory_error ("convert_lmo_packed_to_square")
        call mopend ("Error in converting storage format of orbitals")
      end if
      do i = 1, nocc
        isort(i) = i
      end do
      do i = 1,nvir
        isort(nocc+i) = i
      end do
    end if
      !
      !   Put occupied LMOs into conventional form
      !
      do iunsrt = 1, nocc
        i = isort(iunsrt)
        do j = 1, norbs
          c_square(j, iunsrt) = 0.d0
        end do
        ka = ncocc(i)
        do jj = nncf(i) + 1, nncf(i) + ncf(i)
          j = icocc(jj)
          do k = nfirst(j), nlast(j)
            ka = ka + 1
            c_square(k, iunsrt) = cocc(ka)
          end do
        end do
      end do
      !
      !   Put virtual LMOs into conventional form
      !
      do iunsrt = 1, nvir
        i = isort(iunsrt+nocc)
        ii = iunsrt + nocc
        do j = 1, norbs
          c_square(j, ii) = 0.d0
        end do
        ka = ncvir(i)
        do jj = nnce(i) + 1, nnce(i) + nce(i)
          j = icvir(jj)
          do k = nfirst(j), nlast(j)
            ka = ka + 1
            c_square(k, ii) = cvir(ka)
          end do
        end do
      end do
end subroutine convert_lmo_packed_to_square

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

subroutine fock1(f, ptot, pa, mpack, w, kr, ia, ib, ilim)
        implicit none
        integer, intent (in) :: ia, ib, ilim, mpack
        integer, intent (inout) :: kr
        double precision, dimension (mpack), intent (in) :: pa, ptot
        double precision, dimension (mpack), intent (inout) :: f
        double precision, dimension (ilim, ilim), intent (in) :: w
        integer :: i, ij, ijp, ijw, ikw, im, ip, iw, j, jlw, jm, jp, jw, k, klw, &
       & kw, l, lw
        double precision :: sum
        intrinsic Max, Min
  ! *********************************************************************
  !
  ! *** COMPUTE THE REMAINING CONTRIBUTIONS TO THE ONE-CENTER ELEMENTS.
  !
  ! *********************************************************************
  !
  !   One-center coulomb and exchange terms for atom II.
  !
  !  F(i,j)=F(i,j)+sum(k,l)((PA(k,l)+PB(k,l))*<i,j|k,l>
  !                        -(PA(k,l)        )*<i,k|j,l>), k,l on atom II.
  !
        do i = ia, ib
          iw = i - ia + 1
          do j = ia, i
            jw = j - ia + 1
             !
             !    Address in 'F'
             !
            ij = (i*(i - 1))/2 + j
             !
             !    'J' Address IJ in W
             !
            ijw = (iw*(iw - 1))/2 + jw
            sum = 0.d0
            do k = ia, ib
              kw = k - ia + 1
              do l = ia, ib
                lw = l - ia + 1
                ip = Max (k, l)
                jp = Min (k, l)
                   !
                   !    Address in 'P'
                   !
                ijp = (ip*(ip - 1))/2 + jp
                   !
                   !    'J' Address KL in W
                   !
                im = Max (kw, lw)
                jm = Min (kw, lw)
                klw = (im*(im - 1))/2 + jm
                   !
                   !    'K' Address IK in W
                   !
                im = Max (kw, jw)
                jm = Min (kw, jw)
                ikw = (im*(im - 1))/2 + jm
                   !
                   !    'K' Address JL in W
                   !
                im = Max (lw, iw)
                jm = Min (lw, iw)
                jlw = (im*(im - 1))/2 + jm
                   !
                   !   The term itself
                   !
                sum = sum + ptot(ijp) * w(ijw, klw) - pa(ijp) * w(ikw, jlw)
              end do
            end do
            f(ij) = f(ij) + sum
          end do
        end do
        kr = kr + ilim**2
end subroutine fock1

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine dijkl2(dc)
      use meci_C, only : dijkl, xy, nmos
      use molkst_C, only : norbs
      implicit none
      double precision  :: dc(norbs,nmos)
!
      integer :: ij, i, j, kl, k, ll, l
      double precision :: val, val2
      logical :: lij, lkl
      double precision, external :: ddot
!***********************************************************************
!     RELAXATION OF 2-ELECTRONS INTEGRALS IN M.O BASIS.
!
!   INPUT
!   DC(NORBS,NMOS) : C.I-ACTIVE M.O DERIVATIVES IN M.O BASIS, IN COLUMN.
!   NORBS          : TOTAL NUMBER OF M.O.
!   NMOS           : NUMBER OF C.I-ACTIVE M.O.
!   DIJKL(I,J,KL)  : <I(1),J(1)|K(2),L(2)> WITH
!                     I              OVER     ALL    M.O.
!                     J,KL CANONICAL OVER C.I-ACTIVE M.O.
!   OUTPUT
!     xy(I,J,K,L)= d< I(1),J(1) | K(2),L(2) >
!                   = <dI,J|K,L> + <I,dJ|K,L> + <I,J|dK,L> + <I,J|K,dL>
!                     WITH I,J,K,L OVER ALL C.I-ACTIVE M.O.
!     WRITTEN BY DANIEL LIOTARD
! (NOTE BY JJPS: AS THIS CODE IS HIGHLY EFFICIENT, NO CHANGES WERE MADE)
!***********************************************************************
!
      ij = 0
      do i = 1, nmos
        do j = 1, i
          ij = ij + 1
          lij = i == j
          kl = 0
          do k = 1, i
            if (k == i) then
              ll = j
            else
              ll = k
            end if
            do l = 1, ll
              kl = kl + 1
              lkl = k == l
              val = ddot(norbs,dc(1,i),1,dijkl(1,j,kl),1)
              if (lij .and. lkl .and. j==k) then
                val = val*4.D0
              else
                if (lij) then
                  val = val*2.D0
                else
                  val = val + ddot(norbs,dc(1,j),1,dijkl(1,i,kl),1)
                end if
                val2 = ddot(norbs,dc(1,k),1,dijkl(1,l,ij),1)
                if (lkl) then
                  val = val + val2*2.D0
                else
                  val = val + val2 + ddot(norbs,dc(1,l),1,dijkl(1,k,ij),1)
                end if
              end if
              xy(i,j,k,l) = val
              xy(i,j,l,k) = val
              xy(j,i,k,l) = val
              xy(j,i,l,k) = val
              xy(k,l,i,j) = val
              xy(k,l,j,i) = val
              xy(l,k,i,j) = val
              xy(l,k,j,i) = val
            end do
          end do
        end do
      end do
      return
      end subroutine dijkl2

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

    subroutine calpar
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE parameters_C, only : ios, iop, iod, qq, am, ad, aq, dd, &
      gpp, gp2, hsp, gss, gsp, &
      zs, zp, uss, upp, udd, eisol, &
      f0sd, g2sd, f0sd_store, g2sd_store, &
         dsd, dpd, ddd, zd
      USE funcon_C, only : ev
      USE molkst_C, only : keywrd, method_indo
      USE reimers_C, only: zetad, zetawt, nbfa
#if MOPAC_F2003
      USE, INTRINSIC :: IEEE_ARITHMETIC
#endif
      implicit none
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------

      integer , dimension(107) :: nspqn
      integer :: i, k, l, jmax, j
      double precision, dimension(107) :: gssc, gspc, hspc, gp2c, gppc
      double precision :: p, p4,  hpp, qn, gdd1, d1, d2, df, hsp1, hsp2, d3, &
        gqq, q1, q2, qf, hpp1, hpp2, q3
      double precision :: zda, zdb, zwa, zwb, dsda, dsdb, dpda, dpdb, ddda, dddb
      save nspqn
!-----------------------------------------------
      data nspqn/ 2*1, 8*2, 8*3, 18*4, 18*5, 32*6, 21*0/
!
      if (method_indo) then
        do i = 1, 107
#ifdef MOPAC_F2003
          if (ieee_is_nan(zs(i))) zs(i) = 0.d0
          if (ieee_is_nan(zp(i))) zp(i) = 0.d0
          if (ieee_is_nan(zd(i))) zd(i) = 1.d-6
#else
          if (isnan(zs(i))) zs(i) = 0.d0
          if (isnan(zp(i))) zp(i) = 0.d0
          if (isnan(zd(i))) zd(i) = 1.d-6
#endif
          if(zd(i) == 0.d0) zd(i) = 1.d-6
        end do
      end if
!
!
!     SET SCALING PARAMETER.
      p = 2.D0
      p4 = p**4
      call sp_two_electron
      am = 0.d0
      ad = 0.d0
      aq = 0.d0
      dd = 0.d0
      qq = 0.d0
      do i = 2, 97
!
!  GSSC is the number of two-electron terms of type <SS|SS>
!
        gssc(i) = max(ios(i)-1,0)
        k = iop(i)
!
!  GSPC is the number of two-electron terms of type <SS|PP>
!
        gspc(i) = ios(i)*k
        l = min(k,6 - k)
!
!  GP2C is the number of two-electron terms of type <PP|PP>
!       plus 0.5 of the number of HPP integrals.
!  (HPP is not used; instead it is replaced by 0.5(GPP-GP2))
!
        gp2c(i) = (k*(k - 1))/2 + 0.5D0*(l*(l - 1))/2
!
!  GPPC is minus 0.5 times the number of HPP integrals.
!
        gppc(i) = -0.5D0*(l*(l - 1))/2
!
!  HSPC is the number of two-electron terms of type <SP|SP>.
!       (S and P must have the same spin.  In all cases, if
!  P is non-zero, there are two S electrons)
!
        hspc(i) = -k*ios(i)*0.5d0
!
!
        if (zp(i)<1.D-4 .and. zs(i)<1.D-4) cycle
!*********************************************************************
!
!   CONSTRAINTS ON THE POSSIBLE VALUES OF PARAMETERS
!
!*********************************************************************
        zp(i) = dmax1(0.3D0,zp(i))
!  PUT IN ANY CONSTRAINTS AT THIS POINT
!*********************************************************************
        hpp = 0.5D0*(gpp(i)-gp2(i))
        hpp = max(0.1D0,hpp)
        hsp(i) = max(1.D-7,hsp(i))
        eisol(i) = uss(i)*ios(i) + upp(i)*iop(i) + udd(i)*iod(i) + gss(i)*gssc(i) + &
          gpp(i)*gppc(i) + gsp(i)*gspc(i) + gp2(i)*gp2c(i) + hsp(i)*hspc(i)
        qn = nspqn(i)
        dd(i) = (2.D0*qn + 1)*(4.D0*zs(i)*zp(i))**(qn + 0.5D0)/(zs(i)+zp(i))**(2.D0*qn + 2)/sqrt(3.D0)
        qq(i) = sqrt((4.D0*qn*qn + 6.D0*qn + 2.D0)/20.D0)/zp(i)
        if (method_indo .and. i<=80) then
          if (nbfa(i) > 4) then
!           INDO d orbitals - since two Slater basis functions, calculate two
!           terms and weights based on the coefficients
            zda = zetad(1,i)
            zdb = max(zetad(2,i), 1.d-8)
            zwa = zetawt(1,i)
            zwb = zetawt(2,i)

            dsda = (2.D0*zs(i))**(qn + 0.5D0) * (2.D0*zda)**(qn - 0.5D0) / (zs(i) + zda)**(2.D0*qn + 2)
            dsda = dsda * (2.D0*qn + 1) * sqrt(2.D0*qn*(2.D0*qn - 1))

            dsdb = (2.D0*zs(i))**(qn + 0.5D0) * (2.D0*zdb)**(qn - 0.5D0) / (zs(i) + zdb)**(2.D0*qn + 2)
            dsdb = dsdb * (2.D0*qn + 1) * sqrt(2.D0*qn*(2.D0*qn - 1))

            dsd(i) = sqrt((dsda*zwa + dsdb*zwb) / sqrt(15.D0))


            dpda = (2.D0*zp(i))**(qn + 0.5D0) * (2.D0*zda)**(qn - 0.5D0) / (zp(i) + zda)**(2.D0*qn + 1)
            dpda = dpda * sqrt(2.D0*qn*(2.D0*qn-1))

            dpdb = (2.D0*zp(i))**(qn + 0.5D0) * (2.D0*zdb)**(qn - 0.5D0) / (zp(i) + zdb)**(2.D0*qn + 1)
            dpdb = dpdb * sqrt(2.D0*qn*(2.D0*qn-1))

            dpd(i)= (dpda*zwa + dpdb*zwb) / sqrt(5.D0)


            ddda = (4.D0*qn*qn - 2.D0*qn) / (2*zda)**2
            dddb = (4.D0*qn*qn - 2.D0*qn) / (2*zdb)**2

            ddd(i)= sqrt((ddda*zwa + dddb*zwb) / 7.D0)
          else
! Single-Slater d orbitals
            dsd(i) = sqrt( (2.D0*zs(i))**(qn + 0.5D0) * (2.D0*zd(i))**(qn - 0.5D0) &
                     / (zs(i) + zd(i))**(2.D0*qn + 2) &
                     * (2.D0*qn + 1) * sqrt(2.D0*qn*(2.D0*qn - 1)) / sqrt(15.0))
            dpd(i) = (2.D0*zp(i))**(qn + 0.5D0) * (2.D0*zd(i))**(qn - 0.5D0) &
                     / (zp(i) + zd(i))**(2.D0*qn + 1) * sqrt(2.D0*qn*(2.D0*qn-1)) / sqrt(5.D0)
            ddd(i) = sqrt( (4.D0*qn*qn - 2.D0*qn) / (2*zd(i))**2 / 7.D0)
          end if
        end if
!     CALCULATE ADDITIVE TERMS, IN ATOMIC UNITS.
        jmax = 5
        gdd1 = (hsp(i)/(ev*dd(i)**2))**(1.D0/3.D0)
        d1 = gdd1
        d2 = gdd1 + 0.04D0
        do j = 1, jmax
          df = d2 - d1
          hsp1 = 0.5D0*d1 - 0.5D0/sqrt(4.D0*dd(i)**2+1.D0/d1**2)
          hsp2 = 0.5D0*d2 - 0.5D0/sqrt(4.D0*dd(i)**2+1.D0/d2**2)
          if (abs(hsp2 - hsp1) < 1.D-25) exit
          d3 = d1 + df*(hsp(i)/ev-hsp1)/(hsp2 - hsp1)
          d1 = d2
          d2 = d3
        end do
        gqq = (p4*hpp/(ev*48.D0*qq(i)**4))**0.2D0
        q1 = gqq
        q2 = gqq + 0.04D0
        do j = 1, jmax
          qf = q2 - q1
          hpp1 = 0.25D0*q1 - 0.5D0/sqrt(4.D0*qq(i)**2+1.D0/q1**2) + 0.25D0/&
            sqrt(8.D0*qq(i)**2+1.D0/q1**2)
          hpp2 = 0.25D0*q2 - 0.5D0/sqrt(4.D0*qq(i)**2+1.D0/q2**2) + 0.25D0/&
            sqrt(8.D0*qq(i)**2+1.D0/q2**2)
          if (abs(hpp2 - hpp1) < 1.D-25) exit
          q3 = q1 + qf*(hpp/ev - hpp1)/(hpp2 - hpp1)
          q1 = q2
          q2 = q3
        end do
        am(i) = gss(i)/ev
        ad(i) = d2
        aq(i) = q2
      end do
      do i = 1, 107
        if (am(i) < 1.d-20) then
          if (gss(i) > 1.d-20) then
            am(i) = gss(i)/ev
          else
            am(i) = 1.d0
          end if
        end if
      end do
      eisol(1) = uss(1)
      am(1) = gss(1)/ev
      ad(1) = am(1)
      aq(1) = am(1)
      do i = 1, 100
        if (f0sd_store(i) < 1.d-20) f0sd(i) = 0.d0 ! Force f0sd and g2sd to zero if not already defined
        if (g2sd_store(i) < 1.d-20) g2sd(i) = 0.d0
      end do

      call inid        ! Calculate derived parameters for "d" orbital work
!
!   Atomic number 102 is the capped bond.  It should have a very
!   small AM to prevent division by zero in REPPD, and to avoid
!   spurious effects due to normal AM values.
!
      am(102) = 1.D-10
!
!     DEBUG PRINTING.
!     THIS IS FORMATTED FOR DIRECT INSERTION INTO 'PARAM'
!
      if (index(keywrd,' DEP ') == 0) return
      call create_parameters_for_PMx_C
      return
    end subroutine calpar
!
!
!
!
  subroutine create_parameters_for_PMx_C
!
    USE molkst_C, only : line, keywrd
    USE parameters_C, only : guess1, guess2, guess3, gpp, gp2, hsp, gss, gsp, betas, betap, betad, &
    zs, zp, zd, uss, upp, udd, zsn, zpn, zdn, pocord, alpb, xfac, &
    f0sd, g2sd, main_group, alp, polvol, CPE_Zeta, CPE_Z0, CPE_B, CPE_Xlo, CPE_Xhi, v_par, t_par
    USE chanel_C, only : iw, param_out
    USE elemts_C, only : atom_names
!
    implicit none
!
!  Local
!
    integer :: i, j, l1, l2, l3
    logical :: lnew
    character :: num1*2, num2*2, name_1*10, name_2*10, name_3*10, file_name*120
    double precision :: abond, fff
    double precision, external :: reada
!
!   Define all text variables here
!
! Module names
!
    name_1 = "6_ORG"  ! PM6_ORG
    l1 = len_trim(name_1)
!
! Name of parameter set
!
    name_2 = "_org"
    l2 = len_trim(name_2)
!
! Name of parameter set for global parameters
!
    name_3 = "_org("
    l3 = len_trim(name_3)
!
!  End if definitions
!
    file_name = "parameters_for_PM"//name_1(:l1)//"_C.F90"
    i = index(keywrd, "ifiles_8")
    if (i > 0) then
      i = nint(reada(keywrd, i))
    else
      i = iw
    end if
    write (i, '(//10x, a, /)')" A new file called '"//trim(file_name)//"' will be written"
    call add_path(file_name)
    j = 0
97  open (unit=param_out, file=trim(file_name), status="UNKNOWN", iostat=i)
    if ( i /= 0 .and. j < 10)then
!
!  The file can exist, but is not currently accessible
!
      write(iw,*) "Problem writing '"//trim(file_name)//"'"
      call sleep(3)
      j = j + 1
      goto 97
    end if
    if (j > 9) return
    rewind (param_out)
    write (param_out,"(a)") "  module Parameters_for_PM"//name_1(:l1)//"_C"
    write (param_out,"(a)") "    double precision, dimension(107) :: uss"//name_2(:l2)//", upp"//name_2(:l2)//", udd" &
      //name_2(:l2)//", zs"//name_2(:l2)//", zp"//name_2(:l2)//", zd"//name_2(:l2)//", betas"//name_2(:l2)//", &"
    write (param_out,"(a)") "    betap"//name_2(:l2)//", betad"//name_2(:l2)//", gss"//name_2(:l2)//", gsp" &
      //name_2(:l2)//", gpp"//name_2(:l2)//", gp2"//name_2(:l2)//", hsp"//name_2(:l2)//", polvo" &
      //name_2(:l2)//", poc_"//name_2(:l2)//", &"
    write (param_out,"(a)") "    zsn"//name_2(:l2)//", zpn"//name_2(:l2)//", zdn"//name_2(:l2)//", f0sd" &
      //name_2(:l2)//", g2sd"//name_2(:l2)//", alp"//name_2(:l2)//", &"
    write (param_out,"(a)") "    CPE_Zet"//name_2(:l2)//", CPE_Z0"//name_2(:l2)//", CPE_B"//name_2(:l2)//", CPE_Xlo" &
      //name_2(:l2)//", CPE_Xhi"//name_2(:l2)//""
    write (param_out,"(a)") "    double precision :: v_par"//name_2(:l2)//"(60) "
    write (param_out,"(a)") "    double precision, dimension(107,4) :: gues"//name_2(:l2)//"1, gues" &
      //name_2(:l2)//"2, gues"//name_2(:l2)//"3"
    do i = 1, 107
      if (zs(i) < 1.d-20 .and. gss(i) < 1.d-20 .and. Abs(guess1(i,1)) &
      + Abs(alp(i)) < 1.d-20) cycle
      write (param_out,"('!')")
      write (param_out, '("!",20X,"Data for Element ",I3,5x,a)') i, atom_names(i)
      write (param_out,"('!')")
      if (uss(i) /= 0.D0) write (param_out, &
        '(6X,"data     uss'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, uss(i)
      if (upp(i) /= 0.D0) write (param_out, &
        '(6X,"data     upp'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, upp(i)
      if (udd(i) /= 0.D0) write (param_out, &
        '(6X,"data     udd'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, udd(i)
      if (betas(i) /= 0.D0) write (param_out, &
        '(6X,"data   betas'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, betas(i)
      if (betap(i) /= 0.D0) write (param_out, &
        '(6X,"data   betap'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, betap(i)
      if (betad(i) /= 0.D0) write (param_out, &
        '(6X,"data   betad'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, betad(i)
      if (zs(i) /= 0.D0) write (param_out, &
        '(6X,"data      zs'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, zs(i)
      if (zp(i) /= 0.D0) write (param_out, &
        '(6X,"data      zp'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, zp(i)
      if (zd(i) /= 0.D0) write (param_out, &
        '(6X,"data      zd'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, zd(i)
      if (zsn(i) /= 0.D0) write (param_out, &
        '(6X,"data     zsn'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, zsn(i)
      if (zpn(i) /= 0.D0) write (param_out, &
        '(6X,"data     zpn'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, zpn(i)
      if (zdn(i) /= 0.D0) write (param_out, &
        '(6X,"data     zdn'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, zdn(i)
      if (alp(i) /= 0.D0) write (param_out, &
        '(6X,"data     alp'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, alp(i)
      if (gss(i) /= 0.D0) write (param_out, &
        '(6X,"data     gss'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, gss(i)
      if (gsp(i) /= 0.D0) write (param_out, &
        '(6X,"data     gsp'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, gsp(i)
      if (gpp(i) /= 0.D0) write (param_out, &
        '(6X,"data     gpp'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, gpp(i)
      if (gp2(i) /= 0.D0) write (param_out, &
        '(6X,"data     gp2'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, gp2(i)
      if (hsp(i) /= 0.D0) write (param_out, &
        '(6X,"data     hsp'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, hsp(i)
      if (pocord(i) /= 0.D0) write (param_out, &
        '(6X,"data    poc_'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, pocord(i)
      if (polvol(i) /= 0.D0) write (param_out, &
        '(6X,"data   polvo'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, polvol(i)
      if (CPE_Zeta(i) /= 0.D0) write (param_out, &
        '(6X,"data CPE_Zet'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, CPE_Zeta(i)
      if (CPE_Z0(i) /= 0.D0) write (param_out, &
        '(6X,"data  CPE_Z0'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, CPE_Z0(i)
      if (CPE_B(i) /= 0.D0) write (param_out, &
        '(6X,"data   CPE_B'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, CPE_B(i)
      if (CPE_Xlo(i) /= 0.D0) write (param_out, &
        '(6X,"data CPE_Xlo'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, CPE_Xlo(i)
      if (CPE_Xhi(i) /= 0.D0) write (param_out, &
        '(6X,"data CPE_Xhi'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, CPE_Xhi(i)
      if (.not. main_group(i) .and. f0sd(i) /= 0.D0) write (param_out, &
        '(6X,"data    f0sd'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, f0sd(i)
      if (.not. main_group(i) .and. g2sd(i) /= 0.D0) write (param_out, &
        '(6X,"data    g2sd'//name_2(:l2)//'(",I3,")/",f17.8,"D0/")') i, g2sd(i)
      do j = 1, 4
        if (guess1(i,j) /= 0.D0) &
        write (param_out, &
        '(6X,"data gues'//name_2(:l2)//'1(",I3,",",I1,")/",          f17.8,"D0/")')&
          i, j, guess1(i,j)
        if (guess2(i,j) /= 0.D0) &
        write (param_out, &
        '(6X,"data gues'//name_2(:l2)//'2(",I3,",",I1,")/",          f17.8,"D0/")')&
          i, j, guess2(i,j)
        if (guess3(i,j) /= 0.D0) &
        write (param_out, &
        '(6X,"data gues'//name_2(:l2)//'3(",I3,",",I1,")/",          f17.8,"D0/")')&
          i, j, guess3(i,j)
      end do
    end do
!
! Write out the global parameters
!
    write (param_out,'(2("!",/),"!",21x,a,2(/,"!"))')"Global parameters"
    do i = 1, 60
      if (abs(v_par(i)) > 1.d-10) then
          num1 = "2"
          num2 = "1"
        line = " "
        if (t_par(i) /= " ") line = "  ! "//trim(t_par(i))
        if (i > 9) then
          num1 = "1"
          num2 = "2"
        end if
        write(param_out,'(6x, "data  ", a, i'//num2//', a2, f1'//num1//'.8,"d0/", a)') &
          "v_par"//name_3(:l3), i, ")/", v_par(i), trim(line)
      end if
    end do
    write (param_out,"(a)") '  contains'

    write (param_out,"(a)") &
    & '  subroutine alpb_and_xfac_pm'//name_1(:l1)//'', &
    & '    use parameters_C, only : xfac, alpb'
!
!  Write out all the diatomic parameters
!
    do i = 1, 100
      lnew = .true.
      do j = 1, i
        abond = alpb(i,j)
        if (abond > 1.d-4) then
          fff = xfac(i,j)
          if ( lnew ) then
          lnew = .false.
          write (param_out,*)"!"
          end if
            write(param_out,"(6x,a,i2,a,i2,a,f14.8,a)") &
            "alpb(",i,",",j,") = ", abond,"d0 !"//atom_names(i)//" - "//atom_names(j)
            write(param_out,"(6x,a,i2,a,i2,a,f14.8,a)") &
            "xfac(",i,",",j,") = ", fff,"d0 !"//atom_names(i)//" - "//atom_names(j)
        end if
      end do
    end do
    write (param_out,"(a)") '    end subroutine alpb_and_xfac_pm'//name_1(:l1)
    write (param_out,"(a)") "  end module Parameters_for_PM"//name_1(:l1)//"_C"
    return
  end subroutine create_parameters_for_PMx_C

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

double precision function dipole_for_MOZYME (dipvec, mode)
    use molkst_C, only: numcal, numat, keywrd
    use chanel_C, only: iw
    use MOZYME_C, only : iorbs
    use common_arrays_C, only : nat, q, p, coord
    use parameters_C, only: dd, ams, ddp
    use funcon_C, only: fpc_8, fpc_1, a0
    implicit none
    double precision, intent(out) :: dipvec(3)
    integer, intent (in) :: mode
!.
    logical, save :: chargd, first, force
    integer, save :: icalcn = 0
    integer :: i, j, k, l, ni
    double precision :: const, sum, dx, dy, dz, hyfpd, xt
    double precision, save :: wtmol_loc
    double precision, dimension (3) :: center
    double precision, dimension (107), save :: hyf
    double precision, dimension (4, 3), save :: dip
    integer, external :: ijbo
    data hyf(1) / 0.0d00 /
    first = (icalcn /= numcal)
    icalcn = numcal
   !
   !   CONST = c.C.a0.2
   !
    const = fpc_8 * fpc_1 * a0 * 2.d0 * 1.d-10
    if (first) then
      hyf(2:107) = const * dd(2:107)
      wtmol_loc = 0.d0
      sum = 0.d0
      do i = 1, numat
        wtmol_loc = wtmol_loc + ams(nat(i))
        sum = sum + q(i)
      end do
      chargd = (Abs (sum) > 0.5d0)
      force = index(keywrd,'FORCE') + index(keywrd," THERMO") + index(keywrd,'IRC') /= 0
    end if
    if (chargd) then
      !
      !   NEED TO RESET ION'S POSITION SO THAT THE CENTER OF MASS IS AT THE
      !   ORIGIN.
      !
      center = 0.d0
      do i = 1, 3
        do j = 1, numat
          center(i) = center(i) + ams(nat(j)) * coord(i, j)
        end do
      end do
      center = center / wtmol_loc
      do i = 1, 3
        do j = 1, numat
          coord(i, j) = coord(i, j) - center(i)
        end do
      end do
    end if
    dip = 0.0d00
    do i = 1, numat
      ni = nat(i)
      l = iorbs(i) - 1
      if (l >= 3) then
        do j = 1, 3
          k = ijbo (i, i) + 1 + (j*(j+1)) / 2
          dip(j, 2) = dip(j, 2) - hyf(ni) * p(k)
        end do
        if (l == 8) then
          xt = 1.d0 / Sqrt (3.d00)
          hyfpd = 2.0d0 * ddp(5, ni) * a0 * fpc_8 * fpc_1 * 1.d-10
          k = ijbo (i, i)
          !
          ! x:   <x|x|x2-y2> + <z|x|xz> - 1/root(3)<x|x|z2> + <y|x|xy>
          ! y: - <y|y|x2-y2> - 1/root(3)<y|y|z2> + <z|y|yz> + <x|y|xy>
          ! z:   <x|z|xz> + 2/root(3)<z|z|z2> + <y|z|yz>
          !
          dx = p(k+12) + p(k+19) - p(k+23) * xt + p(k+39)
          dy = -p(k+13) - p(k+24) * xt + p(k+32) + p(k+38)
          dz = p(k+17) + 2.d0 * p(k+25) * xt + p(k+31)
          dip(1, 2) = dip(1, 2) - dx * hyfpd
          dip(2, 2) = dip(2, 2) - dy * hyfpd
          dip(3, 2) = dip(3, 2) - dz * hyfpd
        end if
      end if
      do j = 1, 3
         !
         !  FPC(8)=SPEED OF LIGHT,  FPC(1)=CHARGE ON ELECTRON.
         !
        dip(j, 1) = dip(j, 1) + fpc_8 * fpc_1 * 1.d-10 * q(i) * coord(j, i)
      !
      !  FPC(8)=SPEED OF LIGHT,  FPC(1)=CHARGE ON ELECTRON.
      !
      end do
    end do
    do j = 1, 3
      dip(j, 3) = dip(j, 2) + dip(j, 1)
    end do
    dip(4, :) = Sqrt (dip(1, :)**2+dip(2, :)**2+dip(3, :)**2)
    if (force) then
      dipvec(1) = dip(1,3)
      dipvec(2) = dip(2,3)
      dipvec(3) = dip(3,3)
    end if
    dipole_for_MOZYME = dip(4, 3)
    if ( chargd) then
      do i = 1, 3
        coord(i, :numat) = coord(i, :numat) + center(i)
      end do
    end if
    if (mode == 0) return
   !
10000 format (" DIPOLE", 11x, "X         Y         Z       TOTAL", / &
   & , " POINT-CHG.", 4f10.3/, " HYBRID", 4x, 4f10.3/, " SUM", 7 x, 4 f10.3)
    write (iw, 10000) ((dip(i, j), i=1, 4), j=1, 3)
!
end function dipole_for_MOZYME

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine mpcsyb(chr, kchrge, eionis, dip)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : numat, norbs, nclose, nalpha, nbeta, escf, &
      keywrd
      use common_arrays_C, only : coord, eigs
      use chanel_C, only : isyb, syb_fn
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: kchrge
      double precision , intent(in) :: eionis, chr(numat)
      double precision , intent(inout) :: dip
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j, i1, i2, nfilled
!-----------------------------------------------
   open(unit = isyb, file = syb_fn)
!  Write out the charge flag and number of atoms
      write (16, '(2I4)', err=30) 1, numat
!  Write out the coordinates and charges
      do i = 1, numat
        write (16, '(4F12.6)', err=30) (coord(j,i),j=1,3), chr(i)
      end do
      nfilled = max(nclose, nalpha, nbeta)
      i1 = max(1,nfilled - 1)
      i2 = min(norbs,nfilled + 2)
!
!  Write out the 2 highest and 2 lowest orbital energies
!
      write (16, 20, err=30) (eigs(j),j=i1,i2), nfilled
   20 format(4f12.6,2x,i4,2x,'HOMOs,LUMOs,# of occupied MOs')
!
!  Write out the Heat of Formation and Ionisation Potential
!
      write (16, '(2F12.6,4X,''HF and IP'')', err=30) escf, eionis
!
!  Write out the Dipole Moment
!
      if (kchrge /= 0) dip = 0.0
      write (16, '(I4,F10.3,''  Charge,Dipole Moment'')', err=30) kchrge, dip
      if (index(keywrd," MULL") /= 0) then
        call mpcpop(1)
      else
        call mpcpop(0)
      end if
      close(unit = isyb, status = "keep")
      return
   30 continue
      write (6, '(A)') 'Error writing SYBYL MOPAC output'
      return
      end subroutine mpcsyb
!
! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
      subroutine mpcpop(icok)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE molkst_C, only : numat, keywrd
      use common_arrays_C, only : nfirst, nlast, nat, pb, chrg
      use parameters_C, only : tore
      use chanel_C, only : iw, isyb
      use elemts_C, only : elemnt
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: icok
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, if, il, j, k
      double precision, dimension(numat) :: pop
      double precision :: sum
      double precision, allocatable :: Pot(:), Dipole_correction(:)
      double precision :: Ene
!-----------------------------------------------
!
! This subroutine calculates the total Mulliken populations on the
!   atoms by summing the diagonal elements from the  Mulliken
!   population analysis.
!
      if (icok > -1) write (isyb, '(I4,5X,'' MULLIKEN POPULATION AND CHARGE'')', err=40) icok
!
! ICOK = 1  ==> SYBYL present - do analysis, and write MOPAC and SYBYL output
! ICOK = 0  ==> KEYWORD SYBYL present, but MULLIK absent - don't do analysis
! ICOK = -1 ==> MULLIK present but SYBYL absent - do analysis, but don't write SYBYL output
!
      if (allocated(chrg)) deallocate(chrg)
      allocate(chrg(numat))
      if (icok /= 0) then
        do i = 1, numat
          if = nfirst(i)
          il = nlast(i)
          sum = 0.0
          pop(i) = 0.0
          chrg(i) = 0.0
          do j = if, il
!
!    Diagonal element of mulliken matrix
!
            sum = sum + pb((j*(j+1))/2)
          end do
          k = nat(i)
!
!    Mulliken population for i'th atom
!
          pop(i) = sum
          chrg(i) = tore(k) - pop(i)
        end do
        write (iw, '(3/8X,''MULLIKEN POPULATIONS AND CHARGES'',/)')
        write (iw, '(6X,''NO.  ATOM   POPULATION      CHARGE'')')
        write (iw, '(5X,I4,3X,A2,F13.6,F14.6)') &
         (j, elemnt(nat(j)), pop(j), chrg(j), j = 1, numat)

         if (index(keywrd, " EF") /= 0) then
!
!  Keyword EF is used here to activate the CPE correction.  When CPE is fully integrated, the activation can be removed
!
          allocate(Pot(numat), Dipole_correction(3*numat))
 !         do i = 1, numat !  Use 4 digits after decimal point, to mimic stand-alone code
 !           chrg(i) = nint(chrg(i)*1.d4)/1.d4
 !         end do
          call CPE_energy(Ene, Pot, Dipole_correction)
          write(iw, '(//10x,a,/)') "Chemical-Potential Equalization"
          write(iw, '(10x,a, F20.16, a)')  'Energy                    = ', Ene ,                     "   kcal/mol"
          write(iw, '(10x,a, F20.16, a)')  "Pot(1)                    = ", Pot(1),                   "   eV"
          write(iw, '(10x,a, F20.16, a)')  "Dipole correction(1)      = ", Dipole_correction(1),     "   au"
        end if

        if (icok > -1) write (isyb, "(2f12.6)", err=40) pop(:numat), chrg(:numat)
        call to_screen("To_file: Mulliken")
      end if
      return
   40 continue
      write (iw, '(A)') 'Error writing SYBYL Mulliken population output'
      return
      end subroutine mpcpop
!

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine partxy(c34, pq34, w)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : numcal, numat, lm61
      use common_arrays_C, only : nfirst, nlast
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision  :: c34(*)
      double precision  :: pq34(lm61)
      double precision  :: w(*)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(-1:8) :: nb
      integer :: icalcn, iband, kr, ls, ii, ia, ib, lsp, i, &
        j, lsw, k, l, jband, js, jj
      double precision :: aa, sum, bb
      save nb, icalcn
!-----------------------------------------------
!------------------------------------------------------------------
!
!    PARTXY WORKS OUT  IN MNDO FORMALISM THE FIRST 2-INDICES TRANSFO.
!          REQUIRED IN THE COMPUTATION OF 2-ELECTRONS REPULSION OVER M.O
!  INPUT
!     C34   : VECTOR OF THE CURRENT CHARGE DISTRIBUTION BETWEEN TWO M.O.
!  OUTPUT
!     PQ34(PQ) : <P(1),Q(1)|C3(2),C4(2)> WHERE P ,Q  ARE A.O.
!                                          AND C3,C4 ARE M.O.
!                P AND Q RUN IN CANONICAL ORDER OVER THE A.O BELONGING
!                TO AN ATOM 'A' ONLY (BASIC ASSUMPTION OF MNDO SCHEME)
!                AND 'A' RUNS OVER THE ATOMS OF THE SYSTEM.
!     D.L. (DEWAR GROUP) 1986
!----------------------------------------------------------------------
      data nb/ 0, 1, 0, 0, 10, 0, 0, 0, 0, 45/
      data icalcn/ 0/
      if (numcal /= icalcn) then
        icalcn = numcal
      end if
!     KK    : POINTER OF SUPPORTING ATOM, SPARKLES SKIPPED OUT.
 !     KK    : POINTER OF SUPPORTING ATOM, SPARKLES SKIPPED OUT.
   !
   !     LOOP OVER OUTER ATOM A, SPARKLES EXCLUDED.
   !     ------------------------------------------
    iband = 1
    kr = 1
    ls = 0
    pq34 = 0.d0
    do ii = 1, numat
      ia = nfirst(ii)
      ib = nlast(ii)
      if (ib >= ia) then
        ls = ls + iband
        iband = nb(ib-ia)
         !
         !     PQ34(IJ) = <IJ|KL> * C34(KL)  , 1-CENTRE CONTRIBUTIONS.
        lsp = ls - 1
         !
         !        LOOP OVER CHARGE DISTRIBUTION OF INNER ATOMS  B < A .
         !        -----------------------------------------------------
         !        PQ34(IJ)=<IJ|KL>*C34(KL) 2-CENTRES CONTRIBUTIONS.
         !
        jband = 1
        js = 0
        do jj = 1, ii - 1
          js = js + jband
          jband = nb(nlast(jj)-nfirst(jj))
          if (jband /= 0) &
          call formxy (w(kr), kr, pq34(ls), pq34(js), c34(ls), iband,  c34(js), jband)
        end do
        lsp = ls - 1
        do i = ia, ib
          aa = 1.d0
          do j = ia, i
            if (i == j) then
              aa = 0.5d0
            end if
            lsp = lsp + 1
               !
               !    'J' Address IJ in W
               !
            sum = 0.d0
            lsw = ls - 1
            do k = ia, ib
              bb = 1.d0
              do l = ia, k
                if (l == k) then
                  bb = 0.5d0
                end if
                lsw = lsw + 1
                     !
                     !   The term itself
                     !
                sum = sum + c34(lsw) * w(kr) * bb
                kr = kr + 1
              end do
            end do
            pq34(lsp) = pq34(lsp) + sum * aa
          end do
        end do
      end if
    end do
end subroutine partxy

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine set_up_rapid (txt)
!
!  set_up_rapid creates the environment where SCF and gradient calculations can be run
!  using a small number of atoms instead of the whole set.  When first called (option ON)
!  a full SCF is done, then the atoms of interest are selected and moved to the start.
!
!  Until OFF is specified, the SCF and gradient calculations use the results of the sub-set plus
!  "depleted" arrays - arrays representing the atoms not used in the SCF.
!
!  txt has three setting:
!      ON    - turn on the RAPID option
!      OFF   - turn off the RAPID option
!      RESET - reverse the OFF option, i.e., turn RAPID on but don't do work such as SCF calculations
!
  use common_arrays_C, only : xparam, grad, coord, dxyz
  use molkst_C, only : escf, step_num, iflepo, moperr, nelecs, numat, use_ref_geo, keywrd
  use MOZYME_C, only : mode, nelred, numred
  implicit none
  character :: txt*2
  logical :: store_use_ref_geo
  integer, save :: store_numred, store_nelred, store_mode
  if (txt == "OF") then
!
!  Turn off the RAPID method
!
      store_numred = numred
      store_mode = mode
      store_nelred = nelred
      numred = numat
      mode = 0
      nelred = nelecs
      return
  else if (txt == "RE") then
!
!  Turn off the RAPID method
!
      numred = store_numred
      mode = store_mode
      nelred = store_nelred
      return
  end if
  if (txt /= "ON") then
    continue ! panic
  end if
  store_use_ref_geo = use_ref_geo
  use_ref_geo = .false.
  numred = numat
  mode = 0
  nelred = nelecs
!
!  When RAPID is used, do a full SCF + derivatives.  Then
!  identify those atoms that move.  Subsequent SCFs and derivatives
!  only involve those atoms that move.
!
!  First, run a normal, single-point SCF calculation.  This fills all
!  the arrays that will be used in future SCF calculations.
!  In particular, the arrays P, H, F, and dxyz are filled.
!
  call picopt(-1)
  mode = 0
  grad = 0.d0
  call compfg (xparam, .true., escf, .true., grad, (index(keywrd," RAPID") /= 0))
!  From here on, any call to COMPFG will use the subset of atoms.
!
  call pinout (1, .true.)
!
!  Identify all the atoms that move.  The number of moving atoms is
!  NUMRED
!
  call picopt (1)
!
  iflepo = 1
!
!  Increment step_num: this indicates that startup in the SCF should
!  be re-done.
!
  step_num = step_num + 1
!
!  The RAPID technique uses "depleted arrays"  - normal arrays that
!  would be used in a full SCF, but with all terms that refer to the
!  moving atoms deleted.  This is done in the following steps:
! 1.  The array is multipled by -1.
! 2.  The terms arising from the moving atoms are added to the array.
! 3.  The resulting array is again multiplied by -1.
!
!  That is, each array = the normal array - terms due to the moving atoms.
!  Each "depleted array" has the same "part<x>" where <x> refers to the
!  name of the normal array.
!
!  Second, recalculate the one-electron matrix, but this time build the array parth
!
  mode = -1
  call hcore_for_MOZYME ()
  if (moperr) return
!  Build the depleted array part_dxyz if RAPID is used
  if (index(keywrd," RAPID") /= 0)  call dcart(coord, dxyz)
!  Finally, set mode to +1.  The first time COMPFG is run, the following arrays will be built:
!    partp
!    partf
!
  mode = 1
  use_ref_geo = store_use_ref_geo
  return
end subroutine set_up_rapid

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine symtrz(vects, eigs, itype, geteig)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE molkst_C, only : numat, norbs, keywrd, moperr
      use meci_C, only : lab, maxci
      use common_arrays_C, only : nfirst, nlast, coord, nat, atmass
      USE symmetry_C, only :  jndex, nclass, elem, namo, jelem
      USE chanel_C, only : iw
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer, intent (in)  :: itype
      logical, intent(in) :: geteig
      double precision  :: vects(*)
      double precision  :: eigs(*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: k, ierror, i, j, nvecs, nat_store(numat)
      double precision, dimension(3,numat) :: cotim
      double precision, dimension(3,3) :: r
!-----------------------------------------------
!**************************************************************
!                                                             *
!     DETERMINE POINT GROUP & SYMMETRIZE ORBITALS             *
!                                                             *
!**************************************************************
!
!    On input:   COORD  = Cartesian coordinates of atoms in system
!                VECTS  = Eigenvectors
!                ITYPE  = 1 for Molecular Orbitals
!                         2 for vibrational normal coordinates
!                         3 for State Functions.
!                GETEIG = .TRUE. if eigenvector analysis wanted.
!    On output   NAME   = Point Group Symbol as 4-character string
!                NAMO   = Irreducible Representations of Eigenvectors
!                         as 4-character strings
!                JNDEX  = Principal Quantum Number of each I.R.
!
!
!**************************************************************
!
!   Store cartesian geometry
!

      cotim(:,1:numat) = coord(:,1:numat)
!
!    Identify Molecular Point Group
!
      nat_store(1:numat) = nat(1:numat)
!
!  Change the atomic number to a function of the isotope.
!  The multiplier "20" was chosen so that an isotope that was different by
!  0.05 amu would be considered a different type of atom.
!  Do not make the multiplier much larger because a large value would upset
!  the detection of symmetry operations.
!
      if (size(jelem) < numat*20) return
      do i = 1, numat
        nat(i) = nat(i)*20 + Nint(atmass(i)*20.d0)
      end do
      call molsym (cotim, ierror, r)
      nat(:numat) = nat_store
      if (moperr) return
      if (allocated(namo)) deallocate (namo)
      if (allocated(jndex)) deallocate (jndex)
      i = max(norbs, maxci + 20,3*numat, lab)
      allocate(namo(i), jndex(i))
      j = size(jndex)
      namo = ' '
      do i = 1, j
        jndex(i) = i
      end do
!
!   A Point-Group has been positively identified.  Now to
!   make the symmetry-operations (as vectors in ELEM).
!
      if ((geteig .or. itype == 2) .and. ierror == 0) call makopr (numat, cotim, ierror, r)
!
!    Return to the user, if wanted, the symmetry operations for
!    the system.  The operations are relative to the cartesian
!    coordinate system supplied in COORD.
!
      if (itype == 2 .and. .not.geteig) then
        if (index(keywrd,'SYMTRZ') /= 0) then
          write (iw, *) ' Symmetry Operations in SYMTRZ'
          do i = 1, nclass
            write (iw, *) ' Operation:', i
            write (iw, '(3F12.6)') ((elem(j,k,i),j=1,3),k=1,3)
          end do
          write (iw, *) ' Orientation Matrix'
          write (iw, '(3F12.6)') r
        end if
        do i = 2, nclass
          call mult33 (r, i)
        end do
        if (index(keywrd,'SYMTRZ') /= 0) then
          write (iw, *) ' Symmetry Operations for FORCE calculation'
          write (iw, *) ' Operation:', i
          do i = 1, nclass
            write (iw, '(3F12.6)') ((elem(j,k,i),j = 1,3),k = 1,3)
          end do
        end if
      end if
!
!    Characterize Eigenvectors
!
      if (ierror == 0 .and. geteig) then
        if (itype == 2) then
!
!   In vibrational analyses, each atom has three modes, x, y, and z.
!
      jndex(:numat) = 3
          nvecs = 3*numat
        else
!
!    In Molecular Orbital analyses, atoms have bases sets of
!    atomic orbitals.
!
          jndex(:numat) = nlast(:numat) - nfirst(:numat) + 1
          nvecs = norbs
        end if
        if (nvecs >= 1) then
          i = nvecs
          if (itype == 3) i = lab
          call symoir (itype, vects, eigs, nvecs, r, i)
        end if
      end if
      return
      end subroutine symtrz

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine getpdb (geo)
    use molkst_C, only: maxtxt, natoms, numat, na1, keywrd, line, &
      ncomments, nbreaks, title, txtmax, pdb_label
    use common_arrays_C, only : txtatm, atmass, na, nb, nc, break_coords, &
      labels, lopt, coord, all_comments, breaks, txtatm1
    use chanel_C, only: iw, ir
    use parameters_C, only: ams
    use elemts_C, only : elemnt
    implicit none
 !
 !***********************************************************************
 !
 !  GETPDB READS IN THE GEOMETRY, IN BROOKHAVEN PROTEIN DATA BASE FORMAT.
 !
 !  ON INPUT   IR  = CHANNEL NUMBER FOR READ, NORMALLY 5
 !
 ! ON OUTPUT LABELS = ATOMIC NUMBERS OF ALL ATOMS, INCLUDING DUMMIES.
 !           GEO    = CARTESIAN COORDINATES, IN ANGSTROMS
 !           LOPT   = INTEGER ARRAY FILLED WITH '1'S.
 !                    (PDB FILES DO NOT SUPPORT OPTIMIZATION FLAGS)
 !           NA     = INTEGER ARRAY FILLED WITH '0'S.
 !           NB     = INTEGER ARRAY FILLED WITH '0'S.
 !           NC     = INTEGER ARRAY FILLED WITH '0'S.
 !************************************************************************
    double precision :: geo(3,*)
!
    integer, parameter :: maxel = 115
    character, save :: comma, space
    character :: typea, typer, ch
    character :: ele*3, letter*26
    logical :: leadsp, lxyz, lchain, last_atom = .true., l_pdb, first = .true., &
      l_letter(26)
    integer :: i, icomma, ii, j, k, khar, label, nline, npdb, nvalue, n_water = 0, &
      old_natoms = 0, numerr
    integer :: new_elements, defined_elements, previous_res, current_res
    double precision :: degree
    character :: commas(20), new_key_1*3000, new_key_2*3000 = " ", line1*3000
    character (len=2), dimension (maxel), save :: element
    character (len=4), dimension (20) :: txtpdb
    integer, dimension (20) :: ntxt_loc
    integer, dimension (maxel) :: ielem
    character, allocatable :: tmp_comments(:)*81
    double precision, external :: reada
    intrinsic Abs, Ichar, Index, Nint
    data commas / 20 * "," /
    data ntxt_loc / 20 * 2 /
    data comma, space, txtpdb / ",", 21 * " " /
 !
 ! ... Executable Statements ...
 !
    do i = 1, 93
      if (elemnt(i)(1:1) == " ") then
        element(i) = elemnt(i)(2:2)//elemnt(i)(1:1)
      else
        element(i) = elemnt(i)(1:1)//char(ichar(elemnt(i)(2:2)) + ichar("A") - ichar("a"))
      end if
      ielem(i) = i
    end do
    element(i) = "X "
    ielem(i)   = 99
    i = i + 1
    element(i) = "L "
    ielem(i)   = 0
    i = i + 1
    element(i) = "D "
    ielem(i)   = 1
    defined_elements = i
    numerr = 0
    new_elements = 0
    line = trim(keywrd)
    j = 0
    do i = 1, len_trim(keywrd)
      if (keywrd(i:i) == '"') j = 1 - j
      if (j == 1) keywrd(i:i) = " "
    end do
    i = Index (keywrd, " CHAINS")
    if (i > 0) then
      i = index(keywrd(i:), "(") + i
      j = index(keywrd(i:), ") ") + i - 2
      letter = keywrd(i:j)
    else
      letter = " "
    end if
    i = Index (keywrd, " PDB(")
    l_pdb = (Index (keywrd, " PDB ") /= 0 .or. i /= 0)
    keywrd = trim(line)
    if (i /= 0) then
!
!  THE USER IS GOING TO DEFINE VARIOUS SYMBOLS AND ATOMIC NUMBERS
!
      i = i + 5
      j = Index (keywrd(i:241), ")") + i
      if (j /= i) then
        k = defined_elements + 1
        new_elements = 1
        do
          element(k) = keywrd(i:j)
          ii = Index (element(k), ":")
          if (ii /= 0) then
            element (k) (ii:2) = " "
          end if
          ii = Index (keywrd(i:j), ":") + i
          if (ii == i) exit
          ielem(k) = Nint (reada (keywrd, ii))
          i = Index (keywrd(ii:j), ",") + ii
          if (i /= ii) then
            k = k + 1
            new_elements = new_elements +1
          else
            go to 1000
          end if
        end do
      end if
      call mopend ("KEYWORD PDB IS INCORRECT")
    end if
1000 i = Index (keywrd, " ALT_A=")
    if (i /= 0) then
      typea = keywrd(i+7:i+7)
      if (typea == "*") typea = " "
    else
      typea = "A"
    end if
    i = Index (keywrd, " ALT_R=")
    if (i /= 0) then
      typer = keywrd(i+7:i+7)
      if (typer == "*") typer = " "
    else
      typer = "A"
    end if
    maxtxt = 0
    natoms = 0
    numat = 0
    npdb = 0
    maxtxt = 26
    nline = 0
    previous_res = 2000
    ncomments = 0
    nbreaks = 0
    new_key_1 = " "
    lchain = .true.
    if (.not. allocated(tmp_comments)) allocate(tmp_comments(10000))
!
    outer_loop: do
!
      read (ir, "(A)", end=1020, err=1020) line
!
      nline = nline + 1
      if (natoms > 0 .and. line == " ") exit
      if( .not. ( line(1:4) == "ATOM" .or. line(1:6) == "HETATM" ) ) then
        if (index(line,"ATOM  ") + index(line,"HETATM") + index(line,"TITLE ") + index(line,"HEADER") + &
                                   index(line,"COMPND") + index(line,"SOURCE") + index(line,"KEYWDS") + &
            index(line,"HELIX ") + index(line,"SHEET ") + index(line,"REMARK") + index(line,"USER  ") + &
            index(line,"EXPDTA") + index(line,"AUTHOR") + index(line,"REVDAT") + index(line,"JRNL  ") + &
            index(line,"DBREF ") + index(line,"SEQRES") + index(line,"HET   ") + index(line,"HETNAM") + &
            index(line,"LINK  ") + index(line,"CRYST1") + index(line,"SCALE" ) + index(line,"ORIGX" ) + &
            index(line,"FORMUL") + index(line,"SEQRES") + index(line,"CONECT") /= 0 ) then
          if (line(1:6) /= "CONECT") then
            ncomments = ncomments + 1
            tmp_comments(ncomments) = "*"//line(:80)
          end if
          cycle
        end if
        if (line(1:3) == "TER" .and. natoms > 0) then
          nbreaks = nbreaks + 1
          if (nbreaks > 400) then
            call mopend("Maximum number (400) of breaks (lines starting with TER) exceeded")
            return
          end if
          line1 = txtatm(natoms)(22:)
          do i = natoms, 1, -1
            j = i
            if (labels(i) /= 1) exit
            if (txtatm(i)(22:) /= line1(:5)) then
              j = j + 1
              exit
            end if
          end do
          break_coords(:,nbreaks) = geo(:,i)
          breaks(nbreaks) = i
          lchain = .true.
        end if
        if (line(1:3) == "END") exit
        if (line(1:3) == "TER") cycle
        if (line(1:6) == "MASTER") cycle
        if (l_pdb) then
          if (first) then
            first = .false.
            write(iw,'(//10x,a,/)')" Keyword PDB present, but the following lines are not in PDB format"
          end if
          write(iw,'(a)')trim(line)
        end if
        cycle
      end if
      if (letter /= " " .and. index(letter, line(22:22)) == 0) cycle
      if (line(17:17) /= " ") then
        if (typea == " ") then
          write (iw,*) nline, " lines have been read in"
          write (iw,*) " Faulty line:", line
          call mopend ("The data set contains alternative location" // &
         & " indicators.  Keyword ALT_A must be used")
           call web_message(iw,"ALT_A.html")
         return
        end if
        if (line(17:17) /= typea) cycle
      end if
      natoms = natoms + 1
!   CLEAN THE INPUT DATA
      call upcase (line, 80)
      icomma = Ichar (comma)
      do i = 1, 80
        khar = Ichar (line(i:i))
        if (khar == icomma) then
          line(i:i) = space
        end if
      end do
      if (line(14:14) == "O" .or. line(14:14) == "H") n_water = n_water + 1
      if (line(14:14) /= "H") then
!
! If HETATM and chain is zero, then use the current chain letter
!
        if (line(:6) == "HETATM" .and. line(22:22) == "0") line(22:22) = "A"
        current_res = nint(reada(line,23))
        if (line(27:27) /= " ") txtmax = 27
        if (lchain .and. (line(:6) /= "HETATM" .or. line(22:22) /= " " .or. ch /= " " .or. last_atom)) then
          lchain = .false.
          if (new_key_1 /= " ") then
            do i = 23, 25
              if (line(i:i) /= " ") exit
            end do
            line1 = trim(new_key_1)//" "//line(i:26)//line(22:22)
            new_key_1 = trim(line1)
            line1 = trim(new_key_2)//line(22:22)
            new_key_2 = trim(line1)
            previous_res = 2000
          else
             do i = 23, 25
                if (line(i:i) /= " ") exit
              end do
            new_key_1 = " START_RES=("//line(i:26)//line(22:22)
            new_key_2 = " CHAINS=("//line(22:22)
          end if
        else
          if (abs(current_res - previous_res) > 1 .or. (natoms > 2 .and. line(22:22) /= ch)) then
            if (line(:6) /= "HETATM" .or. line(22:22) /= " ") then
              do i = 23, 25
                if (line(i:i) /= " ") exit
              end do
              if (line(22:22) /= ch .or. (current_res - previous_res) < 0) then
!
!  Letter changed, so make a break.  There was a fault(?) in the original PDB file
!
                if (n_water /= natoms - old_natoms) then
                  line1 = trim(new_key_1)//" "//line(i:26)//line(22:22)
                  new_key_1 = trim(line1)
                end if
                n_water = 0
                old_natoms = natoms
                line1 = trim(new_key_2)//line(22:22)
                new_key_2 = trim(line1)
              else
                if (n_water /= natoms - old_natoms)then
                  line1 = trim(new_key_1)//"-"//line(i:26)
                  new_key_1 = trim(line1)
                end if
                n_water = 0
                old_natoms = natoms
              end if
            end if
          end if
        end if
        previous_res = current_res
        ch = line(22:22)
      end if
      last_atom = (line(:4) == "ATOM")
!
!  Format of txtatm: "( nnnnn rrr mmmm)abc"
!  where: nnnnn = atom number (integer)
!         rrr   = residue three-letter abbreviation (text)
!         mmmm  = residue number (integer)
!         a     = A space or an integer, e.g., 1, 2 or 3, etc.
!         b     = A space or an integer, e.g., 1, 2 or 3, etc.
!         c     = A space or a Greek letter, e.g. a: alpha, g: gamma, etc.
!
!  Check that the residue number is a legal quantity
!
       if (line(18:20) == "***") line(18:20) = "UNK"
       do i = 23, 26
         if (line(i:i) /= " ") then
           if (line(i:i) > "9" .or. line(i:i) < "0") then
             if (line(i:i) /= "-") then
               if (numerr < 10) then
                 if (numerr == 0) write(iw,'(10x,a,/)')"THE RESIDUE SEQUENCE NUMBER IN PDB LINE(S): "
                 write(iw,'(10x,a)')""""//trim(line)//""""
                 numerr = numerr + 1
                 exit
               else if (numerr < 30) then
                 write(iw,'(/10x,a,/)')"Remaining errors suppressed"
               else
                 numerr = 100
               end if
                write(iw,'(10x,a)')"CONTAINS ONE OR MORE NON-NUMERIC CHARACTERS"
                call mopend("ERROR DETECTED IN RESIDUE SEQUENCE NUMBER IN A PDB LINE")
               return
             end if
           end if
         end if
       end do
       txtatm(natoms) = line(1:27)
!
!  If the user wants to keep the original text, use txtatm1
!
      txtatm1(natoms) = line(1:27)
!
      leadsp = .true.
      nvalue = 0
      do i = 1, 80
        if (leadsp .and. line(i:i) /= space) then
          nvalue = nvalue + 1
        end if
        leadsp = (line(i:i) == space)
      end do

!
! ESTABLISH THE ELEMENT'S NAME AND ISOTOPE, CHECK FOR ERRORS OR E.O.DATA
!

      if( line(1:4) == "ATOM" .or. line(1:6) == "HETATM" ) then
!
! Is there an element field present?
!
        ele = line(77:78)
        if (ele(1:1) /= " " .and. ele(2:2) == " ") ele = " "
        if( scan( " 0123456789.", ele(1:1) ) /= 0 ) then
          ele(1:1) = ele(2:2)
          ele(2:2) = " "
          if( scan( " 0123456789.", ele(1:1) ) /= 0 ) then ! no
!
! Use 13-14 field
!
            ele = line(13:14)
!
! Special case - old insight format
!
            if ( line(1:4) == "ATOM" .and. ele(1:1) == "H" ) then
            ele(2:2) = " "
            else if( scan( " 0123456789", ele(1:1) ) /= 0 ) then
            ele(1:1) = ele(2:2)
            ele(2:2) = " "
            end if

            if( scan( " 0123456789", ele(2:2) ) /= 0 ) then
              ele(2:2) = " "
            end if
          end if
        end if
      else
        natoms = natoms -1
        cycle
      end if

      do i = defined_elements+1, defined_elements + new_elements
        if (ele == element(i)) go to 1010
      end do

      do i = 1, defined_elements
        if (ele == element(i)) go to 1010
      end do

      natoms = natoms - 1

      do i = 1, npdb
        if (ele == txtpdb(i)) cycle outer_loop
      end do
      npdb = npdb + 1
      txtpdb(npdb) = ele
      if (ele(2:2) == " ") then
        ntxt_loc(npdb) = 1
      end if
      write (iw, "('  UNRECOGNIZED SPECIES: (',A,')' ,A,' ON LINE',I6)") ele &
     & (1:ntxt_loc(npdb)), ele(ntxt_loc(npdb)+1:3), nline
      cycle
1010  label = ielem(i)
      if (label == 0 .or. label == 99) then
        natoms = natoms - 1
      else
 !
 ! ALL O.K.
 !
        labels(natoms) = label
        if (label /= 99) then
          numat = numat + 1
          atmass(numat) = ams(label)
        end if
        geo(1, natoms) = reada (line(31:38), 1)
        geo(2, natoms) = reada (line(39:46), 1)
        geo(3, natoms) = reada (line(47:54), 1)
        lopt(1, natoms) = 1
        lopt(2, natoms) = 1
        lopt(3, natoms) = 1
        na(natoms) = 0
        nb(natoms) = 0
        nc(natoms) = 0
      end if
    end do outer_loop
!
!  Ensure that all atoms have a chain-letter
!
    l_letter = .false.
    do i = 1, natoms
      if (txtatm(i)(22:22) /= " ") l_letter(ichar(txtatm(i)(22:22)) - ichar("A") + 1) = .true.
    end do
    do i = 1, 26
      if (.not. l_letter(i)) exit
    end do
    if (i <= 26) then
      j = i - 1
      do i = 1, natoms
        if (txtatm(i)(22:22) == " ") txtatm(i)(22:22) = char(ichar("A") + j)
      end do
    end if
1020 if (npdb /= 0) then
      write (iw,*) " THE SPECIES THAT WERE NOT RECOGNIZED CAN BE"
      write (iw,*) " RECOGNIZED BY USING THE FOLLOWING KEYWORD"
      write (iw,*)
      commas (npdb) = ")"
      write (iw,*) " PDB(", (txtpdb(i) (1:ntxt_loc(i)), ":Z", commas(i), i=1, &
     & npdb)
      write (iw,*)
      write (iw,*) " WHERE 'Z' IS/ARE ATOMIC NUMBERS"

      call mopend( "UNRECOGNIZED ELEMENT ")
    end if
    txtatm(:numat)(17:17)  = " " !  Delete structural disorder
    txtatm1(:numat)(17:17) = " " !  Delete structural disorder
    if (title == '    NULL  ')  title = " "
    if (allocated(all_comments)) deallocate(all_comments)
    allocate(all_comments(ncomments + 100))
    all_comments(:ncomments) = tmp_comments(:ncomments)
    deallocate(tmp_comments)
    if (index(keywrd,"START_RES") == 0 .and. new_key_1(12:) /= "(" ) then
      j = 0
      line1 = new_key_1
      new_key_1 = " "
      ii = min(999, len_trim(line1))
      do i = 2, ii
        if (line1(i:i + 1) == "  ") cycle
        if (line1(i - 1:i) == "- ") cycle
        j = j + 1
        new_key_1(j:j) = line1(i:i)
      end do
      if (new_key_1(12:12) == " ") then
        line1 = new_key_1(:11)//new_key_1(13:j)
        new_key_1 = trim(line1)
      end if
      line1  = " "//trim(new_key_1)//") "//trim(keywrd)
      keywrd = trim(line1)
    end if
    if (index(keywrd,"CHAINS") == 0 .and. new_key_2(9:) /= "(") then
      line1 = " "//trim(new_key_2)//") "//trim(keywrd)
      keywrd = trim(line1)
    end if
    if (line /= " ") then
!
! Dummy read to end of PDB file
!
      do
        read(ir,'(a)',iostat = i) line
        if (i /= 0) exit
        if (line == " ") exit
      end do
    end if
    maxtxt = txtmax
    pdb_label = .true.
 !
 !  SWITCH:   Coordinates are in Cartesian.  Should they be internal?
 !
    lxyz = (Index (keywrd, " INT") == 0)
    do i = 1, natoms
      do j = 1, 3
        coord(j, i) = geo(j, i)
      end do
    end do
    if (lxyz) then
      na1 = 99
      return
    end if
    degree = 57.29577951308232d0
    call xyzint (coord, natoms, na, nb, nc, degree, geo)
 !
 !  UNCONDITIONALLY SET FLAGS FOR INTERNAL COORDINATES
 !
    do i = 1, 3
      do j = i, 3
        lopt(j, i) = 0
      end do
    end do
    if (natoms > 2) then
      if (Abs (geo(2, 3)-180.d0) < 1.d-4 .or. Abs (geo(2, 3)) < 1.d-4) then
        write (iw, "(A)") " DUE TO PROGRAM BUG, THE FIRST THREE " // &
                        & "ATOMS MUST NOT LIE IN A STRAIGHT LINE."
        call mopend ("FIRST 3 ATOMS MUST NOT LIE IN A LINE.")
        return
      end if
    end if
 !
 !  COORDINATES ARE INTERNAL, BUT IN DEGREES.  CONVERT TO RADIANS
 !
    degree = 1.7453292519943d-02
    do j = 2, 3
      do i = 1, natoms
        geo(j, i) = geo(j, i) * degree
      end do
    end do
    na1 = 0
    if (index(keywrd,"START_RES") == 0) then
      j = 0
      do i = 1, len_trim(new_key_1)
        if (new_key_1(i:i + 1) == " ") cycle
      end do
      keywrd = " "//trim(new_key_1)//") "//trim(keywrd)
    end if
    if (index(keywrd,"CHAINS") == 0) then
    end if
    return
end subroutine getpdb

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine geout(mode1)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use common_arrays_C, only : labels, na, nb, nc, geo, nat, loc, txtatm, &
      & p, atmass, all_comments, pibonds_txt, l_atom
      USE parameters_C, only : tore, ams
      USE molkst_C, ONLY: numat, natoms, ndep, keywrd, maxtxt, line, &
      & ncomments, moperr, nl_atoms, gui
      USE symmetry_C, ONLY: depmul, locpar, idepfn, locdep
      USE elemts_C, only : elemnt
      USE chanel_C, only : iw
      use maps_C, only : lpara1, latom1, lpara2, latom2, latom, lparam
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: mode1
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: mode, iprt, i, j, n, ia, ii, k, igui, store_maxtxt
      double precision, dimension(natoms) :: q2
      double precision :: degree, w, x, y, z
      logical :: cart, lxyz, isotopes, charge, store_moperr, nabc_pdb, sym_pdb
      character , dimension(3) :: q*2
      character :: flag1*2, flag0*2, flagn*2, blank*80, fmt1*4, fmt2*4, fmt3*4, num*1
!*********************************************************************
!
!   GEOUT PRINTS THE CURRENT GEOMETRY.  IT CAN BE CALLED ANY TIME,
!         FROM ANY POINT IN THE PROGRAM AND DOES NOT AFFECT ANYTHING.
!
!   mode1:   1 write geometry in normal MOPAC *.out format
!           -n write geometry in normal MOPAC *.arc format, but do not print keywords, title
!              symmetry data, etc.
!            n write geometry in normal MOPAC *.arc format
!
!*********************************************************************
      if (nl_atoms == 0 .and. (index(keywrd,' 0SCF') /= 0)) l_atom(:natoms) = .true.
      nabc_pdb = (index(keywrd, "CONTROL_NABC_in_PDB") /= 0)
      sym_pdb = (index(keywrd, "CONTROL_SYM_in_PDB") /= 0)
      mode = mode1
      igui = -10 ! Set to impossible value
      store_maxtxt = maxtxt
      if (index(keywrd, " NOTXT") /= 0) maxtxt = 0
      store_moperr = moperr
      moperr = .false.
      charge = (index(keywrd, " PRTCHAR") /= 0)
      lxyz = index(keywrd,' COORD') + index(keywrd,'VELO') /= 0
      if (index(keywrd,' 0SCF') /= 0 .and. lxyz) then
!
!  If 0SCF and coord and a polymer, then get rid of TV.
!
        natoms = numat
        lxyz = .FALSE.
      end if
      if (mode == 1) then
        flag1 = ' *'
        flag0 = '  '
        flagn = ' +'
        iprt = iw
      else
        if (gui) then
          flag1 = ' 1'
          flag0 = ' 0'
        else
          flag1 = '+1'
          flag0 = '+0'
        end if
        flagn = '-1'
        iprt = abs(mode)
      end if
      degree = 57.29577951308232D0
      if (lxyz) degree = 1.D0
      blank = ' '
      if (mode /= 1 .and. index(keywrd, " RESEQ") /= 0) then
!
! Atoms may have moved, so re-set atmass
!
         do i = 1, numat
           atmass(i) = ams(nat(i))
         end do
      end if
      if (mode /= 1 .and. nat(1) /= 0) then
        do i = 1, numat
          if (Abs(ams(nat(i)) - atmass(i)) > 1.d-6) exit
        end do
        isotopes = (i <= numat)
      else
        isotopes = .false.
      end if
      cart = .true.
      do i = 1, natoms
        if (na(i) > 0) cart = .false.
      end do
      if (mode > 1 .and. ncomments > 0) &
          write(iprt,"(a)")(all_comments(i)(:len_trim(all_comments(i))), i = 1, ncomments)
      fmt1  = "13.8"
      fmt2  = "13.7"
      fmt3  = "13.7"
      if (maxtxt /= 0)  maxtxt = maxtxt + 2
      if (cart) then
        x = 1.d-8
        y = 1.d-8
        z = 1.d-8
        do i = 1, natoms
          x = max(x, abs(geo(1,i)))
          y = max(y, abs(geo(2,i)))
          z = max(z, abs(geo(3,i)))
        end do
        fmt1 = "1"//char(ichar("2") + max(1,int(log10(x))))//".8"
        fmt2 = "1"//char(ichar("2") + max(1,int(log10(y))))//".8"
        fmt3 = "1"//char(ichar("2") + max(1,int(log10(z))))//".8"
        if (mode == 1) then
          if (maxtxt == 0) then
            i = 6
          else
            i = maxtxt/2 + 1
          end if
          write (iprt,'(4a)') &
             & "   ATOM "//blank(:maxtxt/2 + 1)//" CHEMICAL  "//blank(:i)//"  X               Y               Z"
          write (iprt,'(4a)') "  NUMBER "//blank(:maxtxt/2 + 1)//" SYMBOL" &
          &//blank(:i)//"(ANGSTROMS)     (ANGSTROMS)     (ANGSTROMS)"
          write (iprt,*)
        else if (mode > 0) then
          call wrttxt (iprt)
          if (moperr) return
        end if
      else if (mode == 1) then
        j = max(9,maxtxt + 2)
        if (maxtxt == 0) j = 8
        write (iprt,'(4a)') &
           & "  ATOM"//blank(:j/2)//"CHEMICAL "//blank(:(j + 1)/2)//" BOND LENGTH      BOND ANGLE     TWIST ANGLE "
        write (iprt,'(4a)') &
           & " NUMBER"//blank(:j/2)//"SYMBOL   "//blank(:(j + 1)/2)//"(ANGSTROMS)      (DEGREES)       (DEGREES) "
        write (iprt, "(A)") &
           & "   (I)       "//blank(:j)//"      NA:I           NB:NA:I    " // &
           & "   NC:NB:NA:I " // "      NA    NB    NC "
      else if (mode > 0) then
        call wrttxt (iprt)
      end if
      if (mode /= 1 .and. allocated(p) .and. index(keywrd, " 0SCF") == 0) then
        call chrge (p, q2)
        q2(:numat) = tore(nat(:numat)) - q2(:numat)
      else
        q2(:numat) = 0.D0
      end if
      n = 1
      ia = loc(1,1)
      ii = 0
      blank = " "
      num = char(ichar("2") + int(log10(natoms*1.01)))
      do i = 1, natoms
        do j = 1, 3
          q(j) = flag0
          if (ia /= i) cycle
          if (j /= loc(2,n)) cycle
          q(j) = flag1
          n = n + 1
          ia = loc(1,n)
        end do
        if (na(i) > 0) then
          w = geo(2,i)*degree
          x = geo(3,i)*degree
          if (i > 3) then
!
!  CONSTRAIN ANGLE TO DOMAIN 0 - 180 DEGREES
!
            w = w - aint(w/360.D0)*360.D0
            if (w < -1.d-6) w = w + 360.D0
            if (w > 180.000001D0) then
              x = x + 180.D0
              w = 360.D0 - w
            end if
!
!  CONSTRAIN DIHEDRAL TO DOMAIN -180 - 180 DEGREES
!
            x = x - aint(x/360.D0 + sign(0.5D0 - 1.D-9,x) - 1.D-9)*360.D0
          end if
        else
          w = geo(2,i)
          x = geo(3,i)
        end if
        if (latom == i) q(lparam) = flagn
        if ( .not. gui .and. latom1 == i) q(lpara1) = flagn
        if (latom2 == i) q(lpara2) = flagn
        blank = elemnt(labels(i))
        if (labels(i) /= 99 .and. labels(i) /= 107) ii = ii + 1
        if (labels(i) == 1) then  ! Check for Deuterium and tritium
          if (Abs(atmass(ii) - 2.014d0) < 1.d-3) blank(1:2) = " D"
          if (Abs(atmass(ii) - 3.016d0) < 1.d-3) blank(1:2) = " T"
        end if
        k = 4
        if (maxtxt > 0) then
          if (txtatm(i)(15:16) == "**") txtatm(i)(15:16) = "99"
          if (txtatm(i)(23:26) == "****") txtatm(i)(23:26) = "9999"
          line = txtatm(i)
          if (gui .and. txtatm(i)(3:) /= " ") then
            blank = trim(blank)//"("//txtatm(i)(3:)//'  '
            igui = -10
          else
            if (line /= " ") blank = trim(blank)//"("//line(:store_maxtxt)//')  '
            igui = 0
          end if
        end if
        k = 0
        if (mode /= 1 .and. ii > 0 .and. nat(1) /= 0) then
          if (Abs(ams(nat(ii)) - atmass(ii)) > 1.d-6) then
            j = int(log10(atmass(ii)))
            line(40:) = "(f8."//char(6 - j + ichar("0"))//")"
            if (blank(1:2) /= " D" .and. blank(1:2) /= " T") then
              write(line,line(40:))atmass(ii)
              do j = len_trim(line), 1, -1
                if (line(j:j) /= "0") exit
                line(j:j) = " "
              end do
              j = len_trim(line) + 1
              line(j:j) = "0"
              j = index(blank,"(")
              if (j > 0) then
                blank = blank(:j - 1)//trim(line)//blank(j:)
              else
                blank = blank(:2)//trim(line)
              end if
            end if
          end if
          j = max(4,maxtxt + 2)
          if (isotopes) j = j + 8
          k = max(0,8 - j)
        else
          if (mode /= 1) then
            j = max(4,maxtxt + 2)
          else
            j = max(9,maxtxt + 3)
          end if
        end if
        if (index(blank(:j),"(") /= 0) then
          if (index(blank(:j),")") == 0) then
            if (index(blank(j + 1:j + 1), ")") /= 0) j = j + 1
          end if
        end if
        if (labels(i) == 0) cycle
        if ( .not. l_atom(i)) cycle
        if (na(i) == igui .or. cart) then
          if (mode /= 1) then !  Print suitable for reading as a data-set
            if (labels(i)/=99 .and. labels(i)/=107) then

              if (maxtxt == 0 .and. .not. isotopes) j = 4
              if (charge) then
                write(line,'(a,f8.4)')blank(41:59 + k), q2(ii)
              else
                write(line,'(a,f8.4)')blank(41:59 + k)
              end if
              write (iprt, '(1X,A,F'//fmt1//',1X,A2,F'//fmt2//',1X,A2,F'//fmt3//',1X, A2, A)') &
                 blank(:j), geo(1,i), q(1), w, q(2), x, q(3),trim(line)
            else
              write (iprt, '(1X,A,F'//fmt1//',1X,A2,F'//fmt2//',1X,A2,F'//fmt3//',1X,A2,a)') &
              blank(:j), geo(1,i), q(1), w, q(2), x, q(3), " "
            end if
          else !  Print in output style
            if (maxtxt == 0) j = 9
            write (iprt, '(i6,6x,A,F'//fmt1//',1X,A2,F'//fmt2//',1X,A2,F'//fmt3//',1X,A2,a)')i  &
              , blank(:j), geo(1,i), q(1), w, q(2), x, q(3)
          end if
        else
          if (mode /= 1) then  !  Print suitable for reading as a data-set
            if (maxtxt == 0 .and. .not. isotopes) j = 4
            if (labels(i) /= 107) then
              if (nabc_pdb) then
                line = " "
                call atom_no_to_txt(na(i), line(2:))
                call atom_no_to_txt(nb(i), line(20:))
                call atom_no_to_txt(nc(i), line(38:))
                write(line(56:),'(a,3i'//num//')')"=", na(i), nb(i), nc(i)
              else
                write(line,'(3i6)')na(i), nb(i), nc(i)
              end if
              write(line(len_trim(line) + 1:),'(a,f8.4)') blank(41:41 + k)
              if (charge) write(line(len_trim(line) + 1:),'(f8.4)')q2(ii)
              write (iprt, &
                '(1X,A,F'//fmt1//',1X,A2,F'//fmt2//',1X,A2,F'//fmt3//',1X,A2,A)') &
                & blank(:j), geo(1,i), q(1), w, q(2), x, q(3), trim(line)
            else
              write (iprt, '(1X,A,F'//fmt1//',1X,A2,F'//fmt2//',1X,A2,F'//fmt3//',1X,A2,3I6)') &
                blank(:j), geo(1,i), q(1), w, q(2), x, q(3), na(i), nb(i), nc(i)
            end if
          else !  Print in output style
            if (maxtxt == 0) j = 9
            write (iprt, &
              '(I6,6X,A,F'//fmt1//',1X,A2,F'//fmt2//',1X,A2,F'//fmt3//',1X,A2,I6,2I6)') i, &
              blank(:j), geo(1,i), q(1), w, q(2), x, q(3), na(i), nb(i), nc(i)
          end if
        end if
      end do
      moperr = (moperr .or. store_moperr)
      maxtxt = store_maxtxt
      if (mode == 1) return
      write (iprt, *)
      if (ndep /= 0) then
!
!   OUTPUT SYMMETRY DATA.
!
        n = 1
        i = 1
        outer_loop: do
          j = i
          do
            if (j == ndep) exit outer_loop
             !
             !  Group together symmetry functions of the same type
             !  (same reference atom, same reference function, same multiplier,
             !   if function 18 or 19)
             !  (Maximum number of dependent atoms on a line: 9)
             !
            if (locpar(j) /= locpar(j+1) .or. idepfn(j) /= idepfn(j+1) .or. &
                 & j-i >= 9) exit
            if (idepfn(i) == 18 .or. idepfn(i) == 19) then
              if (Abs(depmul(n) - depmul(n+1)) > 1.d-10) exit
              n = n + 1
            end if
            j = j + 1
          end do
          if (idepfn(i) == 18 .or. idepfn(i) == 19) then
            write (iprt, "(I4,I3,F13.9,10I5)") locpar (i), idepfn (i), &
                 & depmul(n), (locdep(k), k=i, j)
            n = n + 1
          else
            if (sym_pdb) then
              line = " "
              call atom_no_to_txt(locpar(i), line(2:))
              write(line(len_trim(line) + 1:),'(i3)')idepfn(i)
              call atom_no_to_txt(locdep(i), line(len_trim(line) + 3:))
              do k = i + 1, j
                call atom_no_to_txt(locdep(k), line(len_trim(line) + 2:))
              end do
              write(iprt, '(a)')trim(line)
            else
              write (iprt, "(I4,I3,10I5)") locpar (i), idepfn (i), (locdep(k), k=i, j)
            end if
          end if
          i = j + 1
        end do outer_loop
        if (na(i) > 0 .and. (idepfn(i) == 19 .or. idepfn(i) == 18)) then
          write (iprt, "(I4,I3,F13.9,10I5)") locpar (i), idepfn (i), &
               & depmul(n), (locdep(k), k=i, j)
        else
          if (sym_pdb) then
            line = " "
            call atom_no_to_txt(locpar(i), line(2:))
            write(line(len_trim(line) + 1:),'(i3)')idepfn(i)
            call atom_no_to_txt(locdep(i), line(len_trim(line) + 3:))
            do k = i + 1, j
              call atom_no_to_txt(locdep(k), line(len_trim(line) + 2:))
            end do
            write(iprt, '(a)')trim(line)
          else
            write (iprt, "(I4,I3,10I5)") locpar (i), idepfn (i), (locdep(k), k=i, j)
          end if
        end if
        write (iprt,*)
      end if
      if (index(keywrd, " SETPI") /= 0 .and. allocated(pibonds_txt)) then
!
!  The user has supplied some pi bonds.  Write them out.
!
        do n = 1, 10
          if (pibonds_txt(n) == " ") exit
          if (n == 1) then
            write(iprt,"(a)")trim(pibonds_txt(n))//"  User-supplied pi bonds"
          else
            write(iprt,"(a)")trim(pibonds_txt(n))
          end if
        end do
      end if
      moperr = (moperr .or. store_moperr)
      end subroutine geout

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

subroutine compct (nncnew, ncnew, ncmnew, itop, nc, ic, iws, n01, c, n02, &
& nmos, idone, lb, mb, icref, inref)
    implicit none
    integer, intent (in) :: icref, idone, inref, itop, n01, n02, nmos
    integer, intent (out) :: lb, mb
    integer, dimension (n01), intent (inout) :: ic
    integer, dimension (nmos), intent (inout) :: iws, nc, ncmnew, nncnew
    integer, dimension (nmos), intent (out) :: ncnew
    double precision, dimension (n02), intent (inout) :: c
    integer :: i, ii, inco, inew, inic, ioco, ioic, n, natom, ncoef
   !
   !   Start the compression at the LMO below the current LMO.  Gaps can
   !   only exist in the domain IDONE-1 to 1.
   !
    inic = icref
    inco = inref
   !   The last array element of  C used is INCO
   !   The last array element of IC used is INIC
    inew = itop - 1
    ii = idone
    do i = idone - 1, 1, -1
      if (nc(i) /= 0) then
        ii = ii - 1
        inew = inew + 1
        natom = nc(i)
        ncoef = iws(i)
         !
         !  Decrement counters by number of atoms in LMO and by number of
         !  coefficients in LMO.
         !
        inic = inic - natom
        inco = inco - ncoef
         !
         !  Get starting address of atoms and coefficients.
         !
        ioic = nncnew(inew)
        ioco = ncmnew(inew)
         !
         !  Move atom index addresses.  Count backwards to prevent overwriting.
         !
        do n = natom, 1, -1
          ic(inic+n) = ic(ioic+n)
        end do
         !
         !  Move orbital coefficients. Count backwards to prevent overwriting.
         !
        do n = ncoef, 1, -1
          c(inco+n) = c(ioco+n)
        end do
         !
         !  RESET starting addresses
         !
        ncnew(inew) = natom
        nncnew(inew) = inic
        ncmnew(inew) = inco
        nc(ii) = natom
        iws(ii) = ncoef
        if (inew == nmos) exit
      end if
    end do
   !
   !   ZERO OUT ALL LOWER LMOs
   !
    do i = ii - 1, 1, -1
      nc(i) = 0
    end do
   !
   !   RESET LOWER BOUNDARY OF LMOs. (THIS IS USED BY SELMOS)
   !
    lb = inic
    mb = inco
end subroutine compct

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

double precision function digit (string, istart)
  !     FORTRAN FUNCTION TO CONVERT NUMERIC FIELD TO DOUBLE PRECISION
  !     NUMBER.  THE STRING IS ASSUMED TO BE CLEAN (NO INVALID DIGIT
  !     OR CHARACTER COMBINATIONS FROM ISTART TO THE FIRST NONSPACE,
  !     NONDIGIT, NONSIGN, AND NONDECIMAL POINT CHARACTER).
  !
  ! 
  !.. Implicit Declarations .. 
  implicit none
  ! 
  !.. Formal Arguments .. 
  character(len=*), intent(in) :: string
  integer, intent(in) :: istart
  ! 
  !.. Local Scalars .. 
  logical :: sign
  integer :: i, i0, i9, idig, idot, ineg, ipos, ispc, j, l, n
  double precision :: c1, c2, deciml
  ! 
  !.. Intrinsic Functions .. 
  intrinsic Ichar, Len
  ! 
  ! ... Executable Statements ...
  ! 
  !
  !     DEFINE ASCII VALUES OF NUMERIC FIELD CHARACTERS
  i0 = Ichar ("0")
  i9 = Ichar ("9")
  ineg = Ichar ("-")
  ipos = Ichar ("+")
  idot = Ichar (".")
  ispc = Ichar (" ")
  !
  c1 = 0.d0
  c2 = 0.d0
  sign = .true.
  l = Len (string)
  !
  !     DETERMINE THE CONTRIBUTION TO THE NUMBER GREATER THAN ONE
  idig = 0
  do i = istart, l
    n = Ichar (string(i:i))
    if (n>=i0 .and. n<=i9) then
      idig = idig + 1
      c1 = c1*1.d1 + n - i0
    elseif (n==ineg .or. n==ipos .or. n==ispc) then
      if (n == ineg) then
        sign = .false.
      end if
    else
      goto 1000
    end if
  end do
  !
  !     DETERMINE THE CONTRIBUTION TO THE NUMBER LESS THAN THAN ONE
  1100 deciml = 1.d0
  do j = i+1, l
    n = Ichar (string(j:j))
    if (n>=i0 .and. n<=i9) then
      deciml = deciml / 1.d1
      c2 = c2 + (n-i0)*deciml
    elseif (n /= ispc) then
      exit
    end if
  end do
  goto 1200
  1000 if (n == idot) goto 1100
  !
  !     PUT THE PIECES TOGETHER
  1200 digit = c1 + c2
  if (.not. sign) then
    digit = -digit
  end if
end function digit

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine local(c, nocc, eig, iprint, txt)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : norbs, numat, keywrd, nbeta
      use common_arrays_C, only : nat, nfirst, nlast, p, pa, pb
      use chanel_C, only : iw
      use symmetry_C, only : namo, jndex
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: nocc, iprint
      double precision  :: c(norbs,norbs)
      double precision  :: eig(norbs)
      character*2 :: txt
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(20) :: iel
      integer :: niter, i, j, iter, k, k1, kl, ku, il, iu, i1, ii
      double precision, dimension(norbs) :: eig1, psi1, psi2, cii, refeig
      double precision :: eps, sum, xijjj, xjiii, xiiii, xjjjj, xijij, xiijj, dij, &
        dii, djj, aij, bij, ca, sa, sum1, x, co
      character :: elemnt(99)*2, num_1*1, num_2*1
      double precision, allocatable  :: cold(:,:)

      save elemnt
!-----------------------------------------------
!**********************************************************************
!
!   LOCALISATION SUBROUTINE
! ON INPUT
!        C = EIGENVECTORS IN AN norbs*norbs MATRIX
!        NOCC = NUMBER OF FILLED LEVELS
!        NORBS = NUMBER OF ORBITALS
!        NUMAT = NUMBER OF ATOMS
!        NLAST   = INTEGER ARRAY OF ATOM ORBITAL COUNTERS
!        NFIRST   = INTEGER ARRAY OF ATOM ORBITAL COUNTERS
!
!       SUBROUTINE MAXIMIZES (PSI)**4
!       REFERENCE_
!       A NEW RAPID METHOD FOR ORBITAL LOCALISATION, P.G. PERKINS AND
!       J.J.P. STEWART, J.C.S. FARADAY (II) 78, 285-296, (1982).
!
!       MODIFIED AND CORRECTED TO AVOID SIGMA-PI ORBITAL MIXING BY
!       JUAN CARLOS PANIAGUA, UNIVERSITY OF BARCELONA, MAY 1983.
!
!**********************************************************************
      data elemnt/ 'H', 'HE', 'LI', 'BE', 'B', 'C', 'N', 'O', 'F', 'NE', 'NA', &
        'MG', 'AL', 'SI', 'P', 'S', 'CL', 'AR', 'K', 'CA', 'SC', 'TI', 'V', &
        'CR', 'MN', 'FE', 'CO', 'NI', 'CU', 'ZN', 'GA', 'GE', 'AS', 'SE', 'BR'&
        , 'KR', 'RB', 'SR', 'Y', 'ZR', 'NB', 'MO', 'TC', 'RU', 'RH', 'PD', 'AG'&
        , 'CD', 'IN', 'SN', 'SB', 'TE', 'I', 'XE', 'CS', 'BA', 'LA', 'CE', 'PR'&
        , 'ND', 'PM', 'SM', 'EU', 'GD', 'TB', 'DY', 'HO', 'ER', 'TM', 'YB', &
        'LU', 'HF', 'TA', 'W', 'RE', 'OS', 'IR', 'PT', 'AU', 'HG', 'TL', 'PB', &
        'BI', 'PO', 'AT', 'RN', 'FR', 'RA', 'AC', 'TH', 'PA', 'U', 'NP', 'PU', &
        'AM', 'CM', 'BK', 'CF', 'XX'/
!
! Set all symmetry names to "a", the lowest symmetry, because LMOs do not normally have any symmetry.
!
      namo(:norbs) = "a   "
      do i = 1, norbs
        jndex(i) = i
      end do
      niter = 100
      eps = 1.0D-10
      refeig(:norbs) = eig(:norbs)
      allocate (cold(norbs,norbs), stat = i)
       if (i /= 0) then
        call memory_error ("Unable to allocate memory in LOCAL")
        return
      end if
      cold(:norbs,:norbs) = c(:norbs,:norbs)
      iter = 0
   20 continue
      sum = 0.D0
      iter = iter + 1
      do i = 1, nocc
        do j = 1, nocc
          if (j == i) cycle
          xijjj = 0.0D0
          xjiii = 0.0D0
          xiiii = 0.0D0
          xjjjj = 0.0D0
          xijij = 0.0D0
          xiijj = 0.0D0
          k = 1
          if (norbs > 0) then
            psi1(:norbs) = c(:norbs,i)
            psi2(:norbs) = c(:norbs,j)
            k = norbs + 1
          end if
! NOW FOLLOWS THE RATE-DETERMINING STEP FOR THE CALCULATION
          do k1 = 1, numat
            kl = nfirst(k1)
            ku = nlast(k1)
            dij = 0.D0
            dii = 0.D0
            djj = 0.D0
            k = kl
            if (ku - kl + 1 > 0) then
              do k = 1, ku - kl + 1
                dij = dij + psi1(k-1+kl)*psi2(k-1+kl)
                dii = dii + psi1(k-1+kl)*psi1(k-1+kl)
                djj = djj + psi2(k-1+kl)*psi2(k-1+kl)
              end do
              k = ku + 1
            end if
            xijjj = xijjj + dij*djj
            xjiii = xjiii + dij*dii
            xiiii = xiiii + dii*dii
            xjjjj = xjjjj + djj*djj
            xijij = xijij + dij*dij
            xiijj = xiijj + dii*djj
          end do
          aij = xijij - (xiiii + xjjjj - 2.0D0*xiijj)/4.0D0
          bij = xjiii - xijjj
          ca = sqrt(aij*aij + bij*bij)
          sa = aij + ca
          if (sa < 1.0D-14) cycle
          sum = sum + sa
          ca = -aij/ca
          ca = (1.0D0 + sqrt((1.0D0 + ca)/2.0D0))/2.0D0
          if ((2.0D0*ca - 1.0D0)*bij < 0.0D0) ca = 1.0D0 - ca
          sa = sqrt(1.0D0 - ca)
          ca = sqrt(ca)
          k = 1
          if (norbs > 0) then
            c(:norbs,i) = ca*psi1(:norbs) + sa*psi2(:norbs)
            c(:norbs,j) = (-sa*psi1(:norbs)) + ca*psi2(:norbs)
            k = norbs + 1
          end if
        end do
      end do
      sum1 = 0.D0
      psi1(:nocc) = 0.d0
      do i = 1, nocc
        do j = 1, numat
          il = nfirst(j)
          iu = nlast(j)
          x = 0.D0
          do k = il, iu
            x = x + c(k,i)**2
          end do
          sum1 = sum1 + x*x
          psi1(i) = psi1(i) + x*x
        end do
      end do
      if (sum > eps .and. iter < niter) go to 20
!
!   Check for LMOs that involve the same atom(s).  Resolve any
!   ill-definition.
!
      do i = 1, nocc
        psi1(i) = 1.d0/psi1(i)
      end do
      call resolv (c, cold, norbs, eig, nocc, psi1)
!
!   Work out LMO energy levels
!
      do i = 1, nocc
        sum = 0.D0
        do j = 1, nocc
          co = 0.D0
          do k = 1, norbs
            co = co + cold(k,j)*c(k,i)
          end do
          sum = sum + co*co*eig(j)
        end do
        eig1(i) = sum
      end do
!
!  Sort into increasing energy order
!
     do i = 1, nocc
        x = 100.D0
        i1 = 0
        do j = i, nocc
          if (x < eig1(j)) cycle
          x = eig1(j)
          i1 = j
        end do
        eig(i) = eig1(i1)
        x = eig1(i1)
        eig1(i1) = eig1(i)
        eig1(i) = x
        do j = 1, norbs
          x = c(j,i1)
          c(j,i1) = c(j,i)
          c(j,i) = x
        end do
      end do
      if (iprint == 1) then
        num_1 = char(ichar("1") +int(log10(numat + 0.05)))
        write (iw, "(/,10x,'NUMBER OF ITERATIONS =',i4,/,10x,'LOCALIZATION VALUE =',f14.9,/)") iter, sum1
        write (iw, "("//num_1//"x,'NUMBER OF CENTERS  LMO ENERGY     COMPOSITION OF ORBITALS ')")
        write (iw, "("//num_1//"x,34x,'(AS PERCENT OF THE LMO)',/)")
        num_1 = char(ichar("3") +int(log10(numat + 0.05)))
        num_2 = char(ichar("1") +int(log10(norbs + 0.05)))
        do i = 1, nocc
          x = 0.D0
          do k1 = 1, numat
            kl = nfirst(k1)
            ku = nlast(k1)
            dii = 0.D0
            do k = kl, ku
              dii = dii + c(k,i)**2
            end do
            x = x + dii*dii
            psi1(k1) = dii*100.D0
          end do
          x = 1.D0/x
          do ii = 1, numat
            sum = 0.D0
            k = 0
            do j = 1, numat
              if (psi1(j) < sum) cycle
              sum = psi1(j)
              k = j
            end do
            psi1(k) = 0.D0
            cii(ii) = sum
            iel(ii) = k
            if (sum >= 1.D0) cycle
            exit
          end do
          ii = ii - 1
          if (ii == 1) then
            if (cii(1) > 99.949d0) then
              write (iw, '(i'//num_1//',f10.4,f17.5, 3x,a2,i'//num_2//',f6.1)') i, x,eig(i), elemnt(nat(iel(1))),iel(1),cii(1)
            else
              write (iw, '(i'//num_1//',f10.4,f17.5, 3x,a2,i'//num_2//',f6.2)') i, x,eig(i), elemnt(nat(iel(1))),iel(1),cii(1)
            end if
          else
            if (ii < 6) then
              write (iw, '(i'//num_1//',f10.4,f17.5, 5(3x,a2,i'//num_2//',f6.2))') &
              i, x,eig(i), (elemnt(nat(iel(k))),iel(k),cii(k),k=1,ii)
            else if (ii < 11) then
              write (iw, '(i'//num_1//',f10.4,f17.5, 5(3x,a2,i'//num_2//',f6.2),/31x,5(3x,a2,i'//num_2//',f6.2))') &
              i, x,eig(i), (elemnt(nat(iel(k))),iel(k),cii(k),k=1,ii)
            else
              write (iw, '(i'//num_1//',f10.4,f17.5, 5(3x,a2,i'//num_2//',f6.2),2(/31x,5(3x,a2,i'//num_2//',f6.2)))') &
              i, x,eig(i), (elemnt(nat(iel(k))),iel(k),cii(k),k=1,ii)
            end if
          end if
        end do
        call phase_lock(c, norbs)
        if (numat > 25 .and. index(keywrd, "LARGE") == 0) then
          write(iw,'(/10x,a)')"Localized orbitals for systems of over 25 atoms are not printed by default"
          write(iw,'(10x,a)')"(To print localized orbitals, add keyword ""LARGE"")"
        else
          write (iw, "(/,/,20x,' LOCALIZED ORBITALS ',/,/)")
          call matout (c, eig, nocc, norbs, norbs)
        end if
        call to_screen("To_file: LMOs")
      end if
      if (txt == "c ") then
        if (nbeta == 0) then
          write (iw, '(/10X,''BONDING CONTRIBUTION OF EACH M.O.'',/)')
          call molval (c, p, 2.D0)
          call to_screen("To_file: Localized RHF M.O.s")
        else
          write (iw, '(/10X,''BONDING CONTRIBUTION OF EACH ALPHA M.O.'',/)')
          call molval (c, pa, 2.D0)
          call to_screen("To_file: Localized alpha M.O.s")
        end if
      else
        write (iw, '(/10X,''BONDING CONTRIBUTION OF EACH BETA  M.O.'',/)')
        call molval (c, pb, 2.D0)
        call to_screen("To_file: Localized beta M.O.s")
      end if
      if (index(keywrd,' GRAPH') == 0) then
        eig(:nocc) = refeig(:nocc)
        c(:norbs,:nocc) = cold(:norbs,:nocc)
      end if
      return
      end subroutine local

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine jcarin(xparam, step, preci, b, ncol, il, iu)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : numat, nvar, ndep, id, l1u, l2u, l3u, l123, &
      natoms
      use common_arrays_C, only : geo, coord, loc, tvec
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------

!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(out) :: ncol
      integer , intent(in) :: il
      integer , intent(in) :: iu
      double precision , intent(in) :: step
      logical , intent(in) :: preci
      double precision , intent(in) :: xparam(3*natoms)
      double precision , intent(inout) :: b(iu - il + 1,3*numat*l123)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: ivar, jvar, j, ij, ii, im, jl, kl, j1, j2
      double precision, dimension(:), allocatable :: coold
!-----------------------------------------------
!     JACOBIAN dCARTESIAN/dINTERNAL, WORKED OUT BY FINITE DIFFERENCE.
!  INPUT
!     XPARAM(*) : INTERNAL COORDINATES
!     STEP      : STEP SIZE FOR FINITE DIFFERENCE METHOD
!     PRECI     : .TRUE. IF 2-POINTS FINITE DIFFERENCES TO BE USED,
!                 .FALSE. OTHERWISE.
!  OUTPUT
!     B(NVAR,NCOL) : JACOBIAN, STEP TIME TOO LARGE.
!
!
       ncol = 3*numat*l123
       allocate(coold(3*numat*l123))
!
!     INTERNAL OF CENTRAL POINT
      do ivar = 1, nvar
        geo(loc(2,ivar),loc(1,ivar)) = xparam(ivar)
      end do
!
      if (id == 0) then
!
!        MOLECULAR SYSTEM
!        ----------------
        jvar = 0
        do ivar = il, iu
          jvar = jvar + 1
!        STEP FORWARD
          geo(loc(2,ivar),loc(1,ivar)) = xparam(ivar) + step
          if (ndep /= 0) call symtry
          call gmetry (geo, coord)
          j = 0
          do j1 = 1, numat
            do j2 = 1, 3
              j = j + 1
              b(jvar, j) = coord(j2, j1)
            end do
          end do
          geo(loc(2,ivar),loc(1,ivar)) = xparam(ivar)
        end do
        if (preci) then
          jvar = 0
          do ivar = il, iu
            jvar = jvar + 1
!           STEP BACKWARD
            geo(loc(2,ivar),loc(1,ivar)) = xparam(ivar) - step
            if (ndep /= 0) call symtry
            call gmetry (geo, coord)
            j = 0
            do j1 = 1, numat
              do j2 = 1, 3
                j = j + 1
                b(jvar, j) = b(jvar, j) - coord(j2, j1)
              end do
            end do
            geo(loc(2, ivar), loc(1, ivar)) = xparam(ivar)
          end do
        else
!           CENTRAL POINT
          if (ndep /= 0) call symtry
          call gmetry (geo, coord)
          jvar = 0
          do ivar = il, iu
            jvar = jvar + 1
            j = 0
            do j1 = 1, numat
              do j2 = 1, 3
                j = j + 1
                b(jvar, j) = b(jvar, j) - coord(j2, j1)
              end do
            end do
          end do
        end if
      else
!
!        SOLID STATE
!        -----------
        jvar = 0
        do ivar = il, iu
          jvar = jvar + 1
!        STEP FORWARD
          geo(loc(2,ivar),loc(1,ivar)) = xparam(ivar) + step
          if (ndep /= 0) call symtry
          call gmetry (geo, coord)
          ij = 0
          do ii = 1, numat
            do im = -l1u, l1u
              do jl = -l2u, l2u
                do kl = -l3u, l3u
                  b(jvar,ij+1:3+ij) = coord(:,ii) + tvec(:,1)*im + tvec(:,2)*jl + tvec(:,3)*kl
                  ij = 3 + ij
                end do
              end do
            end do
          end do
          geo(loc(2,ivar),loc(1,ivar)) = xparam(ivar)
        end do
        if (preci) then
          jvar = 0
          do ivar = il, iu
            jvar = jvar + 1
!           STEP BACKWARD
            geo(loc(2,ivar),loc(1,ivar)) = xparam(ivar) - step
            if (ndep /= 0) call symtry
            call gmetry (geo, coord)
            ij = 0
            do ii = 1, numat
              do im = -l1u, l1u
                do jl = -l2u, l2u
                  do kl = -l3u, l3u
                    b(jvar,ij+1:3+ij) = b(jvar,ij+1:3+ij) - &
                    coord(:,ii) - tvec(:,1)*im - tvec(:,2)*jl - tvec(:,3)*kl
                    ij = 3 + ij
                  end do
                end do
              end do
            end do
            geo(loc(2,ivar),loc(1,ivar)) = xparam(ivar)
          end do
        else
!           CENTRAL POINT
          if (ndep /= 0) call symtry
          call gmetry (geo, coord)
          ij = 0
          do ii = 1, numat
            do im = -l1u, l1u
              do jl = -l2u, l2u
                do kl = -l3u, l3u
                  ij = ij + 1
                  coold(3*ij - 2) = coord(1,ii) + tvec(1,1)*im + tvec(1,2)*jl + tvec(1,3)*kl
                  coold(3*ij - 1) = coord(2,ii) + tvec(2,1)*im + tvec(2,2)*jl + tvec(2,3)*kl
                  coold(3*ij - 0) = coord(3,ii) + tvec(3,1)*im + tvec(3,2)*jl + tvec(3,3)*kl
                end do
              end do
            end do
          end do
          jvar = 0
          do ivar = il, iu
            jvar = jvar + 1
            b(jvar,:ncol) = b(jvar,:ncol) - coold(:ncol)
          end do
        end if
      end if
      return
      end subroutine jcarin

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine chrge(p, q)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use common_arrays_C, only:  nfirst, nlast
      use molkst_C, only: numat, norbs, mozyme
!***********************************************************************
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------

      double precision , intent(out) :: q(numat)
      double precision , intent(in) :: p((norbs*(norbs+1))/2)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: k, i, ia, ib, j
!-----------------------------------------------
!***********************************************************************
!
!      CHRGE STORES IN Q THE TOTAL ELECTRON DENSITIES ON THE ATOMS
!
!      ON INPUT P      = DENSITY MATRIX
!
!      ON OUTPUT Q     = ATOM ELECTRON DENSITIES
!
!***********************************************************************
      if (mozyme) then
        call chrge_for_MOZYME(p, q)
        return
      end if
      k = 0
      do i = 1, numat
        ia = nfirst(i)
        ib = nlast(i)
        q(i) = 0.D0
        do j = ia, ib
          k = k + j
          q(i) = q(i) + p(k)
        end do
      end do
      return
      end subroutine chrge

! TODO: to be parallelized

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine hybrid (catom)
!
!   Construct hybrid atomic orbitals for each atom.
!
!   The hybrid orbitals point to the nearest atoms.
!
    use molkst_C, only: numat, norbs, keywrd
    use chanel_C, only: iw
    use common_arrays_C, only : nbonds, ibonds, f, nat
    use MOZYME_C, only : morb, iorbs
    use elemts_C, only: atom_names
    implicit none
    double precision, dimension (morb, norbs), intent (out) :: catom
    logical :: debug
    integer :: i, ii, j, jj, jl, k, l, loop, m, nb
    double precision :: root2, rt2
    integer, dimension (16) :: nf_loc, nl_loc
    double precision, dimension (10) :: eig
    double precision, dimension (190) :: a
    double precision, dimension (145) :: c
    character :: element*13
    integer, external :: ijbo
    data nf_loc / 1, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19 /
    data nl_loc / 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19 /
   !
   ! ... Executable Statements ...
   !
    debug = (Index (keywrd, " HYBRID") /= 0)
    root2 = Sqrt (2.d0)
    loop = 0
    do ii = 1, numat
      nb = nbonds(ii)
      if (nb > 15) then
        go to 1000
      else if (iorbs(ii) /= 0) then
        if (iorbs(ii) == 1) then
            !
            !  Hydrogen: single orbital = hybrid orbital
            !
          loop = loop + 1
          catom(1, loop) = 1.d0
        else
            !
            !  Heavy atom, therefore make hydrids.
            !
          k = ((nb+4)*(nb+5)) / 2
          do j = 1, k
            a(j) = 0.d0
          end do
          k = 10
          do j = 1, nb
            jj = ibonds(j, ii)
            jl = ijbo (jj, ii)
            m = iorbs(jj)
            if (ibonds(j, ii) < ii) then
              do l = 1, 4
                a(k+l) = f(jl-m+1+m*l)
              end do
            else
              do l = 1, 4
                a(k+l) = f(jl+l)
              end do
            end if
            k = k + 4 + j
          end do
          k = 4 + nb
            !
            !   Perturb A so that any symmetry that exists is destroyed.
            !
          do i = 1, 4
            do l = 1, 4
              j = (i*(i-1)) / 2 + l
              a(j) = a(j) + j * 1.d-8
            end do
          end do
          do i = 5, k
            do l = 1, 4
              j = (i*(i-1)) / 2 + l
              a(j) = a(j) + j * 2.d-4
            end do
          end do
          if (debug) then
            write (iw, "(A,I4)") " ATOM NUMBER", ii
            do i = 1, k
              write (iw, "(8F10.4)") (a(j), j=(i*(i-1))/2+1, (i*(i+1))/2)
            end do
            write (iw,*)
          end if
          if (k == 1) then
            eig(1) = a(1)
            c(1) = 1.d0
          else
            call rsp (a, k, eig, c)
               !
               !  Set phase of coefficient 1 in each M.O. to +1
               !
            do i = 1, k
              if (c((i-1)*k+1) < 1.d-14) then
                do j = 1, k
                  c((i-1)*k+j) = -c((i-1)*k+j)
                end do
              end if
            end do
          end if
          if (debug) then
            write (iw, "(8F10.4)") (eig(j), j=1, k)
            write (iw,*)
            do i = 1, 4
              write (iw, "(8F10.4)") (c(j), j=(i-1)*k+1, i*k)
            end do
          end if
          j = 8 - k
          if (j > 1) then
            call minloc (c, k, j)
          end if
          call local2 (c, k, 4, nf_loc, nl_loc, nb+1)
          if (debug) then
            write (iw,*) "Hybrid orbitals"
            write (iw,*)
            do i = 1, 4
              write (iw, "(8F10.4)") (c(j), j=(i-1)*k+1, i*k)
            end do
          end if
          rt2 = root2
          do i = 1, 4
            rt2 = 0.d0
            do j = 1, 4
              rt2 = rt2 + c((i-1)*k+j) ** 2
            end do
            rt2 = 1.d0 / Sqrt (rt2)
            do j = 1, 4
              catom(j, i+loop) = c((i-1)*k+j) * rt2
            end do
          end do
            !
            !  Make "d" orbitals the simple orthogonal set
            !
          k = Min (4, iorbs(ii))
          do i = 1, k
            do j = 5, iorbs(ii)
              catom(j, i+loop) = 0.d0
            end do
          end do
          do i = 5, iorbs(ii)
            do j = 1, iorbs(ii)
              catom(j, i+loop) = 0.d0
            end do
            catom(i, i+loop) = 1.d0
          end do
          if (debug) then
            write (iw,*)
            do i = 1, 4
              write (iw, "(20X,4F12.5)") (catom(j, i+loop), j=1, 4)
            end do
          end if
          loop = loop + iorbs(ii)
        end if
      end if
    end do
    return
1000 element = atom_names(nat(ii))
    do
      if(element(1:1) /= " ") exit
      element(:12) = element(2:)
    end do
    write (iw, "(A,I4,A,I8)") " For atom", ii, ", a "//trim(element)//", number of bonds:", nb
    stop
end subroutine hybrid
subroutine minloc (vecs, nvec, n)
   !***********************************************************************
   !                                                                      *
   ! MINLOC puts the hybrid orbitals that are ill-defined into a          *
   ! definite form.  If a heavy atom bonds to one other atom, then only   *
   ! the orientation of the sigma bond is defined, the orientations of    *
   ! the two or three other hybrids is not well defined (is ill-defined). *
   !                                                                      *
   ! By using a simple unitary transform, the orientations of the two or  *
   ! ill-defined hybrids becomes well-defined.  Note:  Although they are  *
   ! now well-defined, they do not need to make chemical sense.  This     *
   ! operation is performed to allow MOZYME to be more easily ported.     *
   ! As with the original hybrids, the new hybrids, although              *
   ! well-defined, are not rotationally invariant.  Rotational            *
   ! invariance is only achieved at self-consistency.                     *
   !***********************************************************************
   !
   !.. Implicit Declarations ..
    implicit none
   !
   !.. Formal Arguments ..
    integer, intent (in) :: nvec
    double precision, dimension (nvec, 4), intent (inout) :: vecs
    integer, intent (in) :: n
   !
   !.. Local Scalars ..
    integer :: i, j, l1, l2
    double precision :: beta
    double precision :: rot = 0.999d0
    double precision :: alpha, sum
   !
   !.. Intrinsic Functions ..
    intrinsic Sqrt
   !
   ! ... Executable Statements ...
   !
    if (n /= 2) then
      !
      !                             x   x   x   x  x
      !   Pattern of Coefficients:  x   x   x   x  x
      !                             x   x   x   x  x
      !                             x   x   x   x  x
      !
      !   Re-hybridize three orbitals.  First, annihilate element VECS(2,3)
      !
      do i = 2, 4
        sum = vecs(i, 2) ** 2 + vecs(i, 3) ** 2
        if (sum > 0.1d0) go to 1000
      end do
1010  sum = vecs(i, 4) ** 2 + vecs(i, 2) ** 2
      !
      !                             x   x   x   x  x
      !   Pattern of Coefficients:  x   x   x   x  x
      !                             x   0   x   x  x
      !                             x   x   x   x  x
      !
      !                                  Next, annihilate element VECS(2,4)
      !
      sum = 1.d0 / Sqrt (sum)
      alpha = vecs(i, 4) * sum
      beta = vecs(i, 2) * sum
      do j = 1, nvec
        sum = alpha * vecs(j, 4) + beta * vecs(j, 2)
        vecs(j, 4) = -beta * vecs(j, 4) + alpha * vecs(j, 2)
        vecs(j, 2) = sum
      end do
      go to 1020
1000  sum = 1.d0 / Sqrt (sum)
      alpha = vecs(i, 2) * sum
      beta = vecs(i, 3) * sum
      do j = 1, nvec
        sum = alpha * vecs(j, 2) + beta * vecs(j, 3)
        vecs(j, 3) = -beta * vecs(j, 2) + alpha * vecs(j, 3)
        vecs(j, 2) = sum
      end do
      go to 1010
    end if
   !
   !                             x   x   x   x  x
   !   Pattern of Coefficients:  x   x   x   x  x
   !                             x   0   x   x  x
   !                             x   0   x   x  x
   !
1020 do i = 2, 4
           !
           !                                  Annihilate element VECS(i,4)
           !
      sum = vecs(i, 4) ** 2 + vecs(i, 3) ** 2
      if (sum > 0.1d0) go to 1030
    end do
    return
1030 sum = 1.d0 / Sqrt (sum)
    alpha = vecs(i, 4) * sum
    beta = vecs(i, 3) * sum
    do j = 1, nvec
      sum = alpha * vecs(j, 4) + beta * vecs(j, 3)
      vecs(j, 4) = -beta * vecs(j, 4) + alpha * vecs(j, 3)
      vecs(j, 3) = sum
    end do
   !
   !   Finally, make a small perturbation to destroy any accidental
   !   symmetry that might exist.  This symmetry can prevent an SCF
   !   from forming.
   !
    do l1 = 1, 4
      do l2 = l1 + 1, 4
        alpha = rot
        beta = Sqrt (1.d0-alpha**2)
        do j = 1, nvec
          sum = alpha * vecs(j, l1) + beta * vecs(j, l2)
          vecs(j, l1) = -beta * vecs(j, l1) + alpha * vecs(j, l2)
          vecs(j, l2) = sum
        end do
      end do
    end do
!
!                             x   x   x   x  x
!   Pattern of Coefficients:  x   x   x   x  x
!                             x   0   x   x  x
!                             x   0   0   x  x
!
end subroutine minloc

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine analyt(psum, palpha, pbeta, coord, nat, jja, jjd, iia, iid, &
        eng) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE funcon_C, only : a0, fpc_9
      USE molkst_C, only : keywrd, numcal, mpack
      USE analyt_C, only : ds, dg, dr, g, nztype
      USE parameters_C, only : alp, natorb, tore, guess1, guess2, guess3, &
      betas, betap 
      use chanel_C, only : irot
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: jja 
      integer , intent(in) :: jjd 
      integer , intent(in) :: iia 
      integer , intent(in) :: iid 
      integer , intent(in) :: nat(2) 
      double precision , intent(in) :: psum(mpack) 
      double precision , intent(in) :: palpha(mpack) 
      double precision , intent(in) :: pbeta(mpack) 
      double precision  :: coord(3,2) 
      double precision , intent(inout) :: eng(3) 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: icalcn, jd, ja, id, ia, j, i, ni, istart, nj, jstart&
        , ix, isp, iol, k, ka, kg, l, la, lg, is, ig, m, mn&
        , n, kk, ll, kl, mk, nk, ml, nl, i22
      double precision, dimension(3) :: eaa, eab, enuc 
      double precision, dimension(4) :: bi, bj 
      double precision ::  r2, rij, r0, rr, del1, termaa, termab&
        , del2, del3, c1, termnc, &
        part1, part2, part3, f3, dd, anam1, termk, bb, aa 
      logical :: am1

      save icalcn, am1
!-----------------------------------------------
!***********************************************************************
!                                                                      *
!         CALCULATION OF ANALYTICAL DERIVATIVES                        *
!                                                                      *
!***********************************************************************
      data icalcn/ 0/   
      if (icalcn /= numcal) then 
        icalcn = numcal 
        am1 = index(keywrd,'AM1') + index(keywrd,'PM3') /= 0 
      end if 
      jd = jjd - jja + 1 
      ja = 1 
      id = iid - iia + 1 + jd 
      ia = jd + 1 
      eaa = 0.0D0 
      eab = 0.0D0 
      enuc = 0.0D0 
      eng = 0.0D0 
      i = 2 
      ni = nat(i) 
      istart = nztype(ni)*4 - 3 
      j = 1 
      nj = nat(j) 
      jstart = nztype(nj)*4 - 3 
      r2 = (coord(1,i)-coord(1,j))**2 + (coord(2,i)-coord(2,j))**2 + (coord(3,i&
        )-coord(3,j))**2 
      rij = sqrt(r2) 
      r0 = rij/a0 
      rr = r2/(a0*a0) 
      do ix = 1, 3 
        del1 = coord(ix,i) - coord(ix,j) 
        termaa = 0.0D0 
        termab = 0.0D0 
        isp = 0 
        iol = 0 
!   THE FIRST DERIVATIVES OF OVERLAP INTEGRALS
        do k = ia, id 
          ka = k - ia 
          kg = istart + ka 
          do l = ja, jd 
            la = l - ja 
            lg = jstart + la 
            iol = iol + 1 
            ds(iol) = 0.0D0 
            if (ka==0 .and. la==0) then 
!   (S/S) TERM
              if (abs(del1) <= 1.0D-6) cycle  
              is = 1 
            else if (ka==0 .and. la>0) then 
!   (S/P) TERM
              is = 3 
              if (ix == la) go to 20 
              if (abs(del1) <= 1.0D-6) cycle  
              is = 2 
              del2 = coord(la,i) - coord(la,j) 
            else if (ka>0 .and. la==0) then 
!   (P/S) TERM
              is = 5 
              if (ix == ka) go to 20 
              if (abs(del1) <= 1.0D-6) cycle  
              is = 4 
              del2 = coord(ka,i) - coord(ka,j) 
            else 
!   (P/P) TERM
              if (ka == la) then 
!    P/P
                is = 9 
                if (ix == ka) go to 20 
                if (abs(del1) <= 1.0D-6) cycle  
!    P'/P'
                is = 8 
                del2 = coord(ka,i) - coord(ka,j) 
              else if (ix/=ka .and. ix/=la) then 
!    P'/P"
                if (abs(del1) <= 1.0D-6) cycle  
                is = 7 
                del2 = coord(ka,i) - coord(ka,j) 
                del3 = coord(la,i) - coord(la,j) 
              else 
!    P/P' OR P'/P
                del2 = coord(ka+la-ix,i) - coord(ka+la-ix,j) 
                is = 6 
              end if 
            end if 
!
!        CALCULATE OVERLAP DERIVATIVES, STORE RESULTS IN DS
!
   20       continue 
            call ders (kg, lg, rr, del1, del2, del3, is, iol) 
          end do 
        end do 
        if (ix==1) read (irot) (g(i22),i22=1,22) 
        call delri (dg, ni, nj, r0, del1) 
        call delmol (coord, i, j, ni, nj, ia, id, ja, jd, ix, rij, del1, isp)   
!
!   THE FIRST DERIVATIVE OF NUCLEAR REPULSION TERM
!
!      CORE-CORE TERMS, MNDO AND AM1
!
!
!  SPECIAL TREATMENT FOR N-H AND O-H TERMS
!
          if (rij<1.D0 .and. natorb(ni)*natorb(nj)==0) then 
            termnc = 0.D0 
            go to 50 
          end if 
          c1 = tore(ni)*tore(nj) 
          if (ni==1 .and. (nj==7 .or. nj==8)) then 
            f3 = 1.0D0 + exp((-alp(1)*rij)) + rij*exp((-alp(nj)*rij)) 
            dd = (dg(1)*f3-g(1)*(del1/rij)*(alp(1)*exp((-alp(1)*rij))+(alp(&
              nj)*rij-1.0D0)*exp((-alp(nj)*rij))))*c1 
          else if ((ni==7 .or. ni==8) .and. nj==1) then 
            f3 = 1.0D0 + exp((-alp(1)*rij)) + rij*exp((-alp(ni)*rij)) 
            dd = (dg(1)*f3-g(1)*(del1/rij)*(alp(1)*exp((-alp(1)*rij))+(alp(&
              ni)*rij-1.0D0)*exp((-alp(ni)*rij))))*c1 
          else 
!
!  SPECIAL CASE OF TWO SPARKLES
!
            part1 = dg(1)*c1 
            part2 = -(g(1)*(del1/rij)*(alp(ni)*exp((-alp(ni)*rij))+alp(nj)*&
              exp((-alp(nj)*rij))))*abs(c1) 
            part3 = dg(1)*(exp((-alp(ni)*rij))+exp((-alp(nj)*rij)))*abs(c1) 
            dd = part1 + part2 + part3 
!
!   THE GENERAL CASE
!
          end if 
          termnc = dd 
!
!   ****   START OF THE AM1 SPECIFIC DERIVATIVE CODE   ***
!
!      ANALYT=-A*(1/(R*R)+2.D0*B*(R-C)/R)*EXP(-B*(R-C)**2)
!
!    ANALYTICAL DERIVATIVES
!
        if (am1) then 
          anam1 = 0.D0 
          do ig = 1, 4 
            if (abs(guess1(ni,ig)) > 0.D0) anam1 = anam1 + guess1(ni,ig)*(1.D0/(rij*&
              rij) + 2.D0*guess2(ni,ig)*(rij-guess3(ni,ig))/rij)*exp(max(-30.D0,(-guess2&
              (ni,ig)*(rij-guess3(ni,ig))**2))) 
            if (abs(guess1(nj,ig)) <= 0.D0) cycle  
            anam1 = anam1 + guess1(nj,ig)*(1.D0/(rij*rij) + 2.D0*guess2(nj,ig)*(rij-&
              guess3(nj,ig))/rij)*exp(max(-30.D0,(-guess2(nj,ig)*(rij-guess3(nj,ig))**2)&
              )) 
          end do 
          anam1 = anam1*tore(ni)*tore(nj) 
          termnc = termnc - anam1*del1/rij 
        end if 
!
!   ****   END OF THE AM1 SPECIFIC DERIVATIVE CODE   ***
!
   50   continue 
!
!   COMBINE TOGETHER THE OVERLAP DERIVATIVE PARTS
!
          bi(1) = betas(ni) 
          bi(2) = betap(ni) 
          bi(3) = bi(2) 
          bi(4) = bi(2) 
          bj(1) = betas(nj) 
          bj(2) = betap(nj) 
          bj(3) = bj(2) 
          bj(4) = bj(2) 
        iol = 0 
        do k = ia, id 
          if (jd - ja + 1 > 0) then 
            termk = bi(k-ia+1) 
            termab = termab + sum((termk + bj(:jd-ja+1))*psum(ja+k*(k-1)/2:jd+k&
              *(k-1)/2)*ds(iol+1:jd-ja+1+iol)) 
            iol = jd - ja + 1 + iol 
          end if 
        end do 
!
!        FIRST, CORE-ELECTRON ATTRACTION DERIVATIVES (MNDO AND AM1)
!
!          ATOM CORE I AFFECTING A.O.S ON J
          isp = 0 
          do m = ja, jd 
            bb = 1.D0 
            do n = m, jd 
              mn = m + (n*(n - 1))/2 
              isp = isp + 1 
              termab = termab - bb*tore(ni)*psum(mn)*dr(isp) 
              bb = 2.D0 
            end do 
          end do 
!          ATOM CORE J AFFECTING A.O.S ON I
          k = max(jd - ja + 1,1) 
          k = (k*(k + 1))/2 
          isp = (-k) + 1 
          do m = ia, id 
            bb = 1.D0 
            do n = m, id 
              mn = m + (n*(n - 1))/2 
              isp = isp + k 
              termab = termab - bb*tore(nj)*psum(mn)*dr(isp) 
              bb = 2.D0 
            end do 
          end do 
          isp = 0 
!
!   NOW FOR COULOMB AND EXCHANGE TERMS (MNDO AND AM1)
!
          do k = ia, id 
            aa = 1.D0 
            kk = (k*(k - 1))/2 
            do l = k, id 
              ll = (l*(l - 1))/2 
              do m = ja, jd 
                bb = 1.D0 
                do n = m, jd 
                  isp = isp + 1 
                  kl = k + ll 
                  mn = m + (n*(n - 1))/2 
!
!    COULOMB TERM
!
                  termaa = termaa + aa*bb*psum(kl)*psum(mn)*dr(isp) 
                  mk = m + kk 
                  nk = n + kk 
                  ml = m + ll 
                  nl = n + ll 
!
!    EXCHANGE TERM
!
                  termaa = termaa - 0.5D0*aa*bb*(palpha(mk)*palpha(nl)+palpha(&
                    nk)*palpha(ml)+pbeta(mk)*pbeta(nl)+pbeta(nk)*pbeta(ml))*dr(&
                    isp) 
                  bb = 2.D0 
                end do 
              end do 
              aa = 2.D0 
            end do 
          end do 
        eaa(ix) = eaa(ix) + termaa 
        eab(ix) = eab(ix) + termab 
        enuc(ix) = enuc(ix) + termnc 
      end do 
      eng = eaa + eab + enuc 
      eng = -eng*fpc_9 
      return  
      end subroutine analyt 


      subroutine delmol(coord, i, j, ni, nj, ia, id, ja, jd, ix, rij, tomb, isp&
        ) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE analyt_C, only : dr, dg, tdx, tdy, tdz, g, tx, ty, tz
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: i 
      integer  :: j 
      integer , intent(in) :: ni 
      integer , intent(in) :: nj 
      integer , intent(in) :: ia 
      integer , intent(in) :: id 
      integer , intent(in) :: ja 
      integer , intent(in) :: jd 
      integer  :: ix 
      integer , intent(inout) :: isp 
      double precision  :: rij 
      double precision  :: tomb 
      double precision  :: coord(3,*) 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: ib, jb, k, kk, l, ll, m, mm, n, nn 
      double precision :: temp1, temp2 
!-----------------------------------------------
      if (ni>1 .or. nj>1) call rotat (coord, i, j, ix, rij, tomb, 2) 
      ib = max0(ia,id) 
      jb = max0(ja,jd) 
   do k = ia, ib
      kk = k - ia
      do l = k, ib
        ll = l - ia
        do m = ja, jb
          mm = m - ja
          do n = m, jb
            nn = n - ja
            isp = isp + 1
            if (nn == 0) then
              if (ll == 0) then
                     !   (SS/SS)
                dr(isp) = dg(1)
              else if (kk == 0) then
                     !   (SP/SS)
                dr(isp) = dg(2) * tx(ll) + g(2) * tdx(ll)
              else
                     !   (PP/SS)
                dr(isp) = dg(3) * tx(kk) * tx(ll) + g(3) * &
               & (tdx(kk)*tx(ll)+tx(kk)*tdx(ll)) + dg(4) * &
               & (ty(kk)*ty(ll)+tz(kk)*tz(ll)) + g(4) * &
               & (tdy(kk)*ty(ll)+ty(kk)*tdy(ll)+tdz(kk)*tz(ll)+tz(kk)*tdz(ll))
              end if
            else if (mm == 0) then
              if (ll == 0) then
                     !   (SS/SP)
                dr(isp) = dg(5) * tx(nn) + g(5) * tdx(nn)
              else if (kk == 0) then
                     !   (SP/SP)
                dr(isp) = dg(6) * tx(ll) * tx(nn) + g(6) * &
               & (tdx(ll)*tx(nn)+tx(ll)*tdx(nn)) + dg(7) * &
               & (ty(ll)*ty(nn)+tz(ll)*tz(nn)) + g(7) * &
               & (tdy(ll)*ty(nn)+ty(ll)*tdy(nn)+tdz(ll)*tz(nn)+tz(ll)*tdz(nn))
              else
                     !   (PP/SP)
                dr(isp) = dg(8) * tx(kk) * tx(ll) * tx(nn) + g(8) * &
               & (tdx(kk)*tx(ll)*tx(nn)+tx(kk)*tdx(ll)*tx(nn)+&
               & tx(kk)*tx(ll)*tdx(nn)) + dg(9) * (ty(kk)*ty(ll)+&
               & tz(kk)*tz(ll)) * tx(nn) + g(9) * ((tdy(kk)*ty(ll)+&
               & ty(kk)*tdy(ll)+tdz(kk)*tz(ll)+tz(kk)*tdz(ll))*tx(nn)+&
               & (ty(kk)*ty(ll)+tz(kk)*tz(ll))*tdx(nn)) + dg(10) * &
               & (tx(kk)*(ty(ll)*ty(nn)+tz(ll)*tz(nn))+tx(ll)*(ty(kk)*ty(nn)+&
               & tz(kk)*tz(nn))) + g(10) * (tdx(kk)*(ty(ll)*ty(nn)+&
               & tz(ll)*tz(nn))+tdx(ll)*(ty(kk)*ty(nn)+tz(kk)*tz(nn))+&
               & tx(kk)*(tdy(ll)*ty(nn)+ty(ll)*tdy(nn)+tdz(ll)*tz(nn)+&
               & tz(ll)*tdz(nn))+tx(ll)*(tdy(kk)*ty(nn)+ty(kk)*tdy(nn)+&
               & tdz(kk)*tz(nn)+tz(kk)*tdz(nn)))
              end if
            else if (ll == 0) then
                  !   (SS/PP)
              dr(isp) = dg(11) * tx(mm) * tx(nn) + g(11) * &
             & (tdx(mm)*tx(nn)+tx(mm)*tdx(nn)) + dg(12) * &
             & (ty(mm)*ty(nn)+tz(mm)*tz(nn)) + g(12) * &
             & (tdy(mm)*ty(nn)+ty(mm)*tdy(nn)+tdz(mm)*tz(nn)+tz(mm)*tdz(nn))
            else if (kk == 0) then
                  !   (SP/PP)
              dr(isp) = dg(13) * tx(ll) * tx(mm) * tx(nn) + g(13) * &
             & (tdx(ll)*tx(mm)*tx(nn)+tx(ll)*tdx(mm)*tx(nn)+&
             & tx(ll)*tx(mm)*tdx(nn)) + dg(14) * tx(ll) * (ty(mm)*ty(nn)+&
             & tz(mm)*tz(nn)) + g(14) * (tdx(ll)*(ty(mm)*ty(nn)+&
             & tz(mm)*tz(nn))+tx(ll)*(tdy(mm)*ty(nn)+ty(mm)*tdy(nn)+&
             & tdz(mm)*tz(nn)+tz(mm)*tdz(nn))) + dg(15) * &
             & (ty(ll)*(ty(mm)*tx(nn)+ty(nn)*tx(mm))+tz(ll)*(tz(mm)*tx(nn)+&
             & tz(nn)*tx(mm))) + g(15) * (tdy(ll)*(ty(mm)*tx(nn)+&
             & ty(nn)*tx(mm))+tdz(ll)*(tz(mm)*tx(nn)+tz(nn)*tx(mm))+&
             & ty(ll)*(tdy(mm)*tx(nn)+ty(mm)*tdx(nn)+tdy(nn)*tx(mm)+&
             & ty(nn)*tdx(mm))+tz(ll)*(tdz(mm)*tx(nn)+tz(mm)*tdx(nn)+&
             & tdz(nn)*tx(mm)+tz(nn)*tdx(mm)))
            else
                  !   (PP/PP)
              dr(isp) = dg(16) * tx(kk) * tx(ll) * tx(mm) * tx(nn) + g &
             & (16) * (tdx(kk)*tx(ll)*tx(mm)*tx(nn)+&
             & tx(kk)*tdx(ll)*tx(mm)*tx(nn)+tx(kk)*tx(ll)*tdx(mm)*tx(nn)+&
             & tx(kk)*tx(ll)*tx(mm)*tdx(nn)) + dg(17) * (ty(kk)*ty(ll)+&
             & tz(kk)*tz(ll)) * tx(mm) * tx(nn) + g(17) * ((tdy(kk)*ty(ll)+&
             & ty(kk)*tdy(ll)+tdz(kk)*tz(ll)+tz(kk)*tdz(ll))*tx(mm)*tx(nn)+&
             & (ty(kk)*ty(ll)+tz(kk)*tz(ll))*(tdx(mm)*tx(nn)+tx(mm)*tdx(nn))) +&
             &  dg(18) * tx(kk) * tx(ll) * (ty(mm)*ty(nn)+tz(mm)*tz(nn)) + &
             & g(18) * ((tdx(kk)*tx(ll)+tx(kk)*tdx(ll))*(ty(mm)*ty(nn)+&
             & tz(mm)*tz(nn))+tx(kk)*tx(ll)*(tdy(mm)*ty(nn)+ty(mm)*tdy(nn)+&
             & tdz(mm)*tz(nn)+tz(mm)*tdz(nn)))
              dr(isp) = dr(isp) + dg(19) * (ty(kk)*ty(ll)*ty(mm)*ty(nn)+&
             & tz(kk)*tz(ll)*tz(mm)*tz(nn)) + g(19) * &
             & (tdy(kk)*ty(ll)*ty(mm)*ty(nn)+ty(kk)*tdy(ll)*ty(mm)*ty(nn)+&
             & ty(kk)*ty(ll)*tdy(mm)*ty(nn)+ty(kk)*ty(ll)*ty(mm)*tdy(nn)+&
             & tdz(kk)*tz(ll)*tz(mm)*tz(nn)+tz(kk)*tdz(ll)*tz(mm)*tz(nn)+&
             & tz(kk)*tz(ll)*tdz(mm)*tz(nn)+tz(kk)*tz(ll)*tz(mm)*tdz(nn)) + dg &
             & (20) * (tx(kk)*(tx(mm)*(ty(ll)*ty(nn)+tz(ll)*tz(nn))+&
             & tx(nn)*(ty(ll)*ty(mm)+tz(ll)*tz(mm)))+&
             & tx(ll)*(tx(mm)*(ty(kk)*ty(nn)+tz(kk)*tz(nn))+&
             & tx(nn)*(ty(kk)*ty(mm)+tz(kk)*tz(mm))))
                  !      TO AVOID COMPILER DIFFICULTIES THIS IS DIVIDED
              temp1 = tdx(kk) * (tx(mm)*(ty(ll)*ty(nn)+tz(ll)*tz(nn))+&
             & tx(nn)*(ty(ll)*ty(mm)+tz(ll)*tz(mm))) + tdx(ll) * &
             & (tx(mm)*(ty(kk)*ty(nn)+tz(kk)*tz(nn))+tx(nn)*(ty(kk)*ty(mm)+&
             & tz(kk)*tz(mm))) + tx(kk) * (tdx(mm)*(ty(ll)*ty(nn)+&
             & tz(ll)*tz(nn))+tdx(nn)*(ty(ll)*ty(mm)+tz(ll)*tz(mm))) + tx(ll) &
             & * (tdx(mm)*(ty(kk)*ty(nn)+tz(kk)*tz(nn))+tdx(nn)*(ty(kk)*ty(mm)+&
             & tz(kk)*tz(mm)))
              temp2 = tx(kk) * (tx(mm)*(tdy(ll)*ty(nn)+ty(ll)*tdy(nn)+&
             & tdz(ll)*tz(nn)+tz(ll)*tdz(nn))+tx(nn)*(tdy(ll)*ty(mm)+&
             & ty(ll)*tdy(mm)+tdz(ll)*tz(mm)+tz(ll)*tdz(mm))) + tx(ll) * &
             & (tx(mm)*(tdy(kk)*ty(nn)+ty(kk)*tdy(nn)+tdz(kk)*tz(nn)+&
             & tz(kk)*tdz(nn))+tx(nn)*(tdy(kk)*ty(mm)+ty(kk)*tdy(mm)+&
             & tdz(kk)*tz(mm)+tz(kk)*tdz(mm)))
              dr(isp) = dr(isp) + g(20) * (temp1+temp2)
              dr(isp) = dr(isp) + dg(21) * (ty(kk)*ty(ll)*tz(mm)*tz(nn)+&
             & tz(kk)*tz(ll)*ty(mm)*ty(nn)) + g(21) * &
             & (tdy(kk)*ty(ll)*tz(mm)*tz(nn)+ty(kk)*tdy(ll)*tz(mm)*tz(nn)+&
             & ty(kk)*ty(ll)*tdz(mm)*tz(nn)+ty(kk)*ty(ll)*tz(mm)*tdz(nn)+&
             & tdz(kk)*tz(ll)*ty(mm)*ty(nn)+tz(kk)*tdz(ll)*ty(mm)*ty(nn)+&
             & tz(kk)*tz(ll)*tdy(mm)*ty(nn)+tz(kk)*tz(ll)*ty(mm)*tdy(nn))
              dr(isp) = dr(isp) + dg(22) * (ty(kk)*tz(ll)+tz(kk)*ty(ll)) * &
             & (ty(mm)*tz(nn)+tz(mm)*ty(nn)) + g(22) * ((tdy(kk)*tz(ll)+&
             & ty(kk)*tdz(ll)+tdz(kk)*ty(ll)+tz(kk)*tdy(ll))*(ty(mm)*tz(nn)+&
             & tz(mm)*ty(nn))+ (ty(kk)*tz(ll)+tz(kk)*ty(ll))*(tdy(mm)*tz(nn)+&
             & ty(mm)*tdz(nn)+tdz(mm)*ty(nn)+tz(mm)*tdy(nn)))
            end if
          end do
        end do
      end do
    end do
      return  
      end subroutine delmol 


      subroutine delri(dg, ni, nj, rr, del1) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      use funcon_C, only : a0, ev
      use molkst_C, only : numcal
      use parameters_C, only : natorb, am, ad, aq, dd, qq
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: ni 
      integer , intent(in) :: nj 
      double precision , intent(in) :: rr 
      double precision , intent(in) :: del1 
      double precision , intent(out) :: dg(22) 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: icalcn 
      double precision :: term, da, db, qa, qb, aee, ee, ade, aqe, dze, &
        qzze, qxxe, aed, aeq, edz, eqzz, eqxx, add, adq, aqd, aqq, dxdx, dzdz, &
        dzqxx, qxxdz, dzqzz, qzzdz, qxxqxx, qxxqyy, qxxqzz, qzzqxx, qzzqzz, &
        dxqxz, qxzdx, qxzqxz 

      save icalcn 
!-----------------------------------------------
!***********************************************************************
!                                                                      *
!    ON INPUT NI = ATOMIC NUMBER OF FIRST ATOM                         *
!             NJ = ATOMIC NUMBER OF SECOND ATOM                        *
!             RR = INTERATOMIC DISTANCE IN BOHRS                       *
!                                                                      *
!***********************************************************************
      data icalcn/ 0/  
      dze = 0.d0
      qxxe = 0.d0
      qzze = 0.d0
      if (icalcn /= numcal) then 
        icalcn = numcal  
      end if 
      term = (ev*del1)/(rr*a0*a0) 
      da = dd(ni) 
      db = dd(nj) 
      qa = qq(ni) 
      qb = qq(nj) 
!   HYDROGEN-HYDROGEN
      aee = 0.25D0*(1.0D0/am(ni)+1.0D0/am(nj))**2 
      ee = -rr/sqrt(rr**2 + aee)**3 
      dg(1) = term*ee 
      if (natorb(ni)<=2 .and. natorb(nj)<=2) return  
      if (natorb(ni) > 2) then 
!   HEAVY ATOM-HYDROGEN
        ade = 0.25D0*(1.0D0/ad(ni)+1.0D0/am(nj))**2 
        aqe = 0.25D0*(1.0D0/aq(ni)+1.0D0/am(nj))**2 
        dze = (rr + da)/sqrt((rr + da)**2 + ade)**3 - (rr - da)/sqrt((rr - da)&
          **2 + ade)**3 
        qzze = (-(rr + 2.0D0*qa)/sqrt((rr + 2.0D0*qa)**2 + aqe)**3) - (rr - &
          2.0D0*qa)/sqrt((rr - 2.0D0*qa)**2 + aqe)**3 + (2.0D0*rr)/sqrt(rr**2&
           + aqe)**3 
        qxxe = (-(2.0D0*rr)/sqrt(rr**2 + 4.0D0*qa**2 + aqe)**3) + (2.0D0*rr)/&
          sqrt(rr**2 + aqe)**3 
        dg(2) = -(term*dze)/2.0D0 
        dg(3) = term*(ee + qzze/4.0D0) 
        dg(4) = term*(ee + qxxe/4.0D0) 
        if (natorb(nj) <= 2) return  
      end if 
!   HYDROGEN-HEAVY ATOM
      aed = 0.25D0*(1.0D0/am(ni)+1.0D0/ad(nj))**2 
      aeq = 0.25D0*(1.0D0/am(ni)+1.0D0/aq(nj))**2 
      edz = (rr - db)/sqrt((rr - db)**2 + aed)**3 - (rr + db)/sqrt((rr + db)**2&
         + aed)**3 
      eqzz = (-(rr - 2.0D0*qb)/sqrt((rr - 2.0D0*qb)**2 + aeq)**3) - (rr + 2.0D0&
        *qb)/sqrt((rr + 2.0D0*qb)**2 + aeq)**3 + (2.0D0*rr)/sqrt(rr**2 + aeq)**&
        3 
      eqxx = (-(2.0D0*rr)/sqrt(rr**2 + 4.0D0*qb**2 + aeq)**3) + (2.0D0*rr)/&
        sqrt(rr**2 + aeq)**3 
      dg(5) = -(term*edz)/2.0D0 
      dg(11) = term*(ee + eqzz/4.0D0) 
      dg(12) = term*(ee + eqxx/4.0D0) 
      if (natorb(ni) <= 2) return  
!   HEAVY ATOM-HEAVY ATOM
      add = 0.25D0*(1.D0/ad(ni)+1.D0/ad(nj))**2 
      adq = 0.25D0*(1.D0/ad(ni)+1.D0/aq(nj))**2 
      aqd = 0.25D0*(1.D0/aq(ni)+1.D0/ad(nj))**2 
      aqq = 0.25D0*(1.D0/aq(ni)+1.D0/aq(nj))**2 
      dxdx = (-(2.D0*rr)/sqrt(rr**2 + (da - db)**2 + add)**3) + (2.D0*rr)/sqrt(&
        rr**2 + (da + db)**2 + add)**3 
      dzdz = (-(rr + da - db)/sqrt((rr + da - db)**2 + add)**3) - (rr - da + db&
        )/sqrt((rr - da + db)**2 + add)**3 + (rr - da - db)/sqrt((rr - da - db)&
        **2 + add)**3 + (rr + da + db)/sqrt((rr + da + db)**2 + add)**3 
      dzqxx = 2.D0*(rr + da)/sqrt((rr + da)**2 + 4.D0*qb**2 + adq)**3 - 2.D0*(&
        rr - da)/sqrt((rr - da)**2 + 4.D0*qb**2 + adq)**3 - 2.D0*(rr + da)/&
        sqrt((rr + da)**2 + adq)**3 + 2.D0*(rr - da)/sqrt((rr - da)**2 + adq)**&
        3 
      qxxdz = 2.D0*(rr - db)/sqrt((rr - db)**2 + 4.D0*qa**2 + aqd)**3 - 2.D0*(&
        rr + db)/sqrt((rr + db)**2 + 4.D0*qa**2 + aqd)**3 - 2.D0*(rr - db)/&
        sqrt((rr - db)**2 + aqd)**3 + 2.D0*(rr + db)/sqrt((rr + db)**2 + aqd)**&
        3 
      dzqzz = (rr + da - 2.D0*qb)/sqrt((rr + da - 2.D0*qb)**2 + adq)**3 - (rr&
         - da - 2.D0*qb)/sqrt((rr - da - 2.D0*qb)**2 + adq)**3 + (rr + da + &
        2.D0*qb)/sqrt((rr + da + 2.D0*qb)**2 + adq)**3 - (rr - da + 2.D0*qb)/&
        sqrt((rr - da + 2.D0*qb)**2 + adq)**3 + 2.D0*(rr - da)/sqrt((rr - da)**&
        2 + adq)**3 - 2.D0*(rr + da)/sqrt((rr + da)**2 + adq)**3 
      qzzdz = (rr + 2.D0*qa - db)/sqrt((rr + 2.D0*qa - db)**2 + aqd)**3 - (rr&
         + 2.D0*qa + db)/sqrt((rr + 2.D0*qa + db)**2 + aqd)**3 + (rr - 2.D0*qa&
         - db)/sqrt((rr - 2.D0*qa - db)**2 + aqd)**3 - (rr - 2.D0*qa + db)/&
        sqrt((rr - 2.D0*qa + db)**2 + aqd)**3 - 2.D0*(rr - db)/sqrt((rr - db)**&
        2 + aqd)**3 + 2.D0*(rr + db)/sqrt((rr + db)**2 + aqd)**3 
      qxxqxx = (-(2.D0*rr)/sqrt(rr**2 + 4.D0*(qa - qb)**2 + aqq)**3) - (2.D0*rr&
        )/sqrt(rr**2 + 4.D0*(qa + qb)**2 + aqq)**3 + (4.D0*rr)/sqrt(rr**2 + &
        4.D0*qa**2 + aqq)**3 + (4.D0*rr)/sqrt(rr**2 + 4.D0*qb**2 + aqq)**3 - (&
        4.D0*rr)/sqrt(rr**2 + aqq)**3 
      qxxqyy = (-(4.D0*rr)/sqrt(rr**2 + 4.D0*qa**2 + 4.D0*qb**2 + aqq)**3) + (&
        4.D0*rr)/sqrt(rr**2 + 4.D0*qa**2 + aqq)**3 + (4.D0*rr)/sqrt(rr**2 + &
        4.D0*qb**2 + aqq)**3 - (4.D0*rr)/sqrt(rr**2 + aqq)**3 
      qxxqzz = (-2.D0*(rr - 2.D0*qb)/sqrt((rr - 2.D0*qb)**2 + 4.D0*qa**2 + aqq)&
        **3) - 2.D0*(rr + 2.D0*qb)/sqrt((rr + 2.D0*qb)**2 + 4.D0*qa**2 + aqq)**&
        3 + 2.D0*(rr - 2.D0*qb)/sqrt((rr - 2.D0*qb)**2 + aqq)**3 + 2.D0*(rr + &
        2.D0*qb)/sqrt((rr + 2.D0*qb)**2 + aqq)**3 + (4.D0*rr)/sqrt(rr**2 + 4.D0&
        *qa**2 + aqq)**3 - (4.D0*rr)/sqrt(rr**2 + aqq)**3 
      qzzqxx = (-2.D0*(rr + 2.D0*qa)/sqrt((rr + 2.D0*qa)**2 + 4.D0*qb**2 + aqq)&
        **3) - 2.D0*(rr - 2.D0*qa)/sqrt((rr - 2.D0*qa)**2 + 4.D0*qb**2 + aqq)**&
        3 + 2.D0*(rr + 2.D0*qa)/sqrt((rr + 2.D0*qa)**2 + aqq)**3 + 2.D0*(rr - &
        2.D0*qa)/sqrt((rr - 2.D0*qa)**2 + aqq)**3 + (4.D0*rr)/sqrt(rr**2 + 4.D0&
        *qb**2 + aqq)**3 - (4.D0*rr)/sqrt(rr**2 + aqq)**3 
      qzzqzz = (-(rr + 2.D0*qa - 2.D0*qb)/sqrt((rr + 2.D0*qa - 2.D0*qb)**2 + &
        aqq)**3) - (rr + 2.D0*qa + 2.D0*qb)/sqrt((rr + 2.D0*qa + 2.D0*qb)**2 + &
        aqq)**3 - (rr - 2.D0*qa - 2.D0*qb)/sqrt((rr - 2.D0*qa - 2.D0*qb)**2 + &
        aqq)**3 - (rr - 2.D0*qa + 2.D0*qb)/sqrt((rr - 2.D0*qa + 2.D0*qb)**2 + &
        aqq)**3 + 2.D0*(rr - 2.D0*qa)/sqrt((rr - 2.D0*qa)**2 + aqq)**3 + 2.D0*(&
        rr + 2.D0*qa)/sqrt((rr + 2.D0*qa)**2 + aqq)**3 + 2.D0*(rr - 2.D0*qb)/&
        sqrt((rr - 2.D0*qb)**2 + aqq)**3 + 2.D0*(rr + 2.D0*qb)/sqrt((rr + 2.D0*&
        qb)**2 + aqq)**3 - (4.D0*rr)/sqrt(rr**2 + aqq)**3 
      dxqxz = 2.D0*(rr - qb)/sqrt((rr - qb)**2 + (da - qb)**2 + adq)**3 - 2.D0*&
        (rr + qb)/sqrt((rr + qb)**2 + (da - qb)**2 + adq)**3 - 2.D0*(rr - qb)/&
        sqrt((rr - qb)**2 + (da + qb)**2 + adq)**3 + 2.D0*(rr + qb)/sqrt((rr + &
        qb)**2 + (da + qb)**2 + adq)**3 
      qxzdx = 2.D0*(rr + qa)/sqrt((rr + qa)**2 + (qa - db)**2 + aqd)**3 - 2.D0*&
        (rr - qa)/sqrt((rr - qa)**2 + (qa - db)**2 + aqd)**3 - 2.D0*(rr + qa)/&
        sqrt((rr + qa)**2 + (qa + db)**2 + aqd)**3 + 2.D0*(rr - qa)/sqrt((rr - &
        qa)**2 + (qa + db)**2 + aqd)**3 
      qxzqxz = (-2.D0*(rr + qa - qb)/sqrt((rr + qa - qb)**2 + (qa - qb)**2 + &
        aqq)**3) + 2.D0*(rr + qa + qb)/sqrt((rr + qa + qb)**2 + (qa - qb)**2 + &
        aqq)**3 + 2.D0*(rr - qa - qb)/sqrt((rr - qa - qb)**2 + (qa - qb)**2 + &
        aqq)**3 - 2.D0*(rr - qa + qb)/sqrt((rr - qa + qb)**2 + (qa - qb)**2 + &
        aqq)**3 + 2.D0*(rr + qa - qb)/sqrt((rr + qa - qb)**2 + (qa + qb)**2 + &
        aqq)**3 - 2.D0*(rr + qa + qb)/sqrt((rr + qa + qb)**2 + (qa + qb)**2 + &
        aqq)**3 - 2.D0*(rr - qa - qb)/sqrt((rr - qa - qb)**2 + (qa + qb)**2 + &
        aqq)**3 + 2.D0*(rr - qa + qb)/sqrt((rr - qa + qb)**2 + (qa + qb)**2 + &
        aqq)**3 
      dg(6) = (term*dzdz)/4.0D0 
      dg(7) = (term*dxdx)/4.0D0 
      dg(8) = -term*(edz/2.0D0 + qzzdz/8.0D0) 
      dg(9) = -term*(edz/2.0D0 + qxxdz/8.0D0) 
      dg(10) = -(term*qxzdx)/8.0D0 
      dg(13) = -term*(dze/2.0D0 + dzqzz/8.0D0) 
      dg(14) = -term*(dze/2.0D0 + dzqxx/8.0D0) 
      dg(15) = -(term*dxqxz)/8.0D0 
      dg(16) = term*(ee + eqzz/4.0D0 + qzze/4.0D0 + qzzqzz/16.0D0) 
      dg(17) = term*(ee + eqzz/4.0D0 + qxxe/4.0D0 + qxxqzz/16.0D0) 
      dg(18) = term*(ee + eqxx/4.0D0 + qzze/4.0D0 + qzzqxx/16.0D0) 
      dg(19) = term*(ee + eqxx/4.0D0 + qxxe/4.0D0 + qxxqxx/16.0D0) 
      dg(20) = (term*qxzqxz)/16.0D0 
      dg(21) = term*(ee + eqxx/4.0D0 + qxxe/4.0D0 + qxxqyy/16.0D0) 
      dg(22) = term*(qxxqxx - qxxqyy)/32.0D0 
      return  
      end subroutine delri 


      subroutine rotat(coord, i, j, ix, rij, del1, idx) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE analyt_C, only : tx, ty, tz,  tdx, tdy, tdz 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: i 
      integer , intent(in) :: j 
      integer , intent(in) :: ix 
      integer , intent(in) :: idx 
      double precision , intent(in) :: rij 
      double precision , intent(in) :: del1 
      double precision , intent(in) :: coord(3,25) 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      double precision :: xd, yd, zd, rxy, ryz, rzx, term, tmp 
!-----------------------------------------------
      xd = coord(1,i) - coord(1,j) 
      yd = coord(2,i) - coord(2,j) 
      zd = coord(3,i) - coord(3,j) 
      rxy = sqrt(xd*xd + yd*yd) 
      ryz = sqrt(yd*yd + zd*zd) 
      rzx = sqrt(zd*zd + xd*xd) 
      tx = 0.0D0 
      ty = 0.0D0 
      tz = 0.0D0 
      tdx = 0.0D0 
      tdy = 0.0D0 
      tdz = 0.0D0 
      if (rxy < 1.0D-4) then 
!   MOLECULAR Z AXIS IS PARALLEL TO DIATOMIC Z AXIS
        tx(3) = 1.0D0 
        if (zd < 0.0D0) tx(3) = -1.0D0 
        ty(2) = 1.0D0 
        tz(1) = tx(3) 
        if (idx == 1) return  
        if (ix == 1) tdx(1) = 1.0D0/rij 
        if (ix == 2) tdx(2) = 1.0D0/rij 
        if (ix == 1) tdz(3) = -1.0D0/rij 
        if (ix == 2) tdy(3) = -tx(3)/rij 
      else if (ryz < 1.0D-4) then 
!   MOLECULAR X AXIS IS PARALLEL TO DIATOMIC Z AXIS
        tx(1) = 1.0D0 
        if (xd < 0.0D0) tx(1) = -1.0D0 
        ty(2) = tx(1) 
        tz(3) = 1.0D0 
        if (idx == 1) return  
        if (ix == 2) tdx(2) = 1.0D0/rij 
        if (ix == 3) tdx(3) = 1.0D0/rij 
        if (ix == 2) tdy(1) = -1.0D0/rij 
        if (ix == 3) tdz(1) = -tx(1)/rij 
      else if (rzx < 1.0D-4) then 
!   MOLECULAR Y AXIS IS PARALLEL TO DIATOMIC Z AXIS
        tx(2) = 1.0D0 
        if (yd < 0.0D0) tx(2) = -1.0D0 
        ty(1) = -tx(2) 
        tz(3) = 1.0D0 
        if (idx == 1) return  
        if (ix == 1) tdx(1) = 1.0D0/rij 
        if (ix == 3) tdx(3) = 1.0D0/rij 
        if (ix == 1) tdy(2) = 1.0D0/rij 
        if (ix == 3) tdz(2) = -tx(2)/rij 
      else 
        tx(1) = xd/rij 
        tx(2) = yd/rij 
        tx(3) = zd/rij 
        tz(3) = rxy/rij 
        ty(1) = -tx(2)*sign(1.0D0,tx(1))/tz(3) 
        ty(2) = abs(tx(1)/tz(3)) 
        ty(3) = 0.0D0 
        tz(1) = -tx(1)*tx(3)/tz(3) 
        tz(2) = -tx(2)*tx(3)/tz(3) 
        if (idx == 1) return  
        term = del1/(rij*rij) 
        select case (ix)  
        case (1)  
          tdx(1) = 1.0D0/rij - tx(1)*term 
          tdx(2) = -tx(2)*term 
          tdx(3) = -tx(3)*term 
          tdz(3) = tx(1)/rxy - tz(3)*term 
        case (2)  
          tdx(1) = -tx(1)*term 
          tdx(2) = 1.0D0/rij - tx(2)*term 
          tdx(3) = -tx(3)*term 
          tdz(3) = tx(2)/rxy - tz(3)*term 
        case (3)  
          tdx(1) = -tx(1)*term 
          tdx(2) = -tx(2)*term 
          tdx(3) = 1.0D0/rij - tx(3)*term 
          tdz(3) = -tz(3)*term 
        end select 
        tmp = tdz(3)/tz(3)**2 
        tdy(1) = (-tdx(2)/tz(3)) + tx(2)*tmp 
        if (tx(1) < 0.0D0) tdy(1) = -tdy(1) 
        tdy(2) = tdx(1)/tz(3) - tx(1)*tmp 
        if (tx(1) < 0.0D0) tdy(2) = -tdy(2) 
        tdy(3) = 0.0D0 
        tdz(1) = tx(1)*tx(3)*tmp - (tx(3)*tdx(1)+tx(1)*tdx(3))/tz(3) 
        tdz(2) = tx(2)*tx(3)*tmp - (tx(3)*tdx(2)+tx(2)*tdx(3))/tz(3) 
      end if 
      return  
      end subroutine rotat 


      subroutine ders(m, n, rr, del1, del2, del3, is, iol) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE overlaps_C, only :  ccc,  zzz
      use funcon_C, only : a0
      USE analyt_C, only : ds 
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: m 
      integer , intent(in) :: n 
      integer , intent(in) :: is 
      integer , intent(in) :: iol 
      double precision , intent(in) :: rr 
      double precision , intent(in) :: del1 
      double precision , intent(in) :: del2 
      double precision , intent(in) :: del3 
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j 
      double precision, dimension(6,6) :: ss 
      double precision :: apb, amb, adb, adr, abn 
!-----------------------------------------------
!***********************************************************************
!                                                                      *
!    ON INPUT M    = INDEX OF FIRST ATOMIC ORBITAL                     *
!             N    = INDEX OF SECOND ATOMIC ORBITAL                    *
!             RR   = SQUARE IF INTERATOMIC DIATANCE (IN BOHR)          *
!             DEL1 = CATERSIAN DISTANCE IN DERIVATIVE DIRECTION        *
!             DEL2 = CARTESIAN DISTANCE IN M A.O.'S DIRECTION          *
!             DEL3 = CARTESIAN DISTANCE IN N A.O.'S DIRECTION          *
!             IS   = INDICATES TYPE OF A.O.-A.O. INTERACTION           *
!                  = 1 S/S, 2 S/P', 3 S/P, 4 P'/S, 5 P/S, 6 P/P',      *
!                    7 P'/P", 8 P'P', 9 P/P                            *
!             IOL  = INDEX FOR STORING DERIVATIVES IN DS               *
!                                                                      *
!***********************************************************************
      do i = 1, 6 
        do j = 1, 6 
          ss(i,j) = 0.0D0 
          apb = zzz(m,i)*zzz(n,j) 
          amb = zzz(m,i) + zzz(n,j) 
          adb = apb/amb 
          adr = min(adb*rr,35.D0) 
          select case (is)  
          case default 
            abn = -2.0D0*adb*del1/a0**2 
          case (2)  
            abn = -4.0D0*adb**2*del1*del2/(sqrt(zzz(n,j))*a0**3) 
          case (3)  
            abn = (2.0D0*adb/(sqrt(zzz(n,j))*a0))*(1.0D0 - 2.0D0*adb*del1**2/a0&
              **2) 
          case (4)  
            abn = 4.0D0*adb**2*del1*del2/(sqrt(zzz(m,i))*a0**3) 
          case (5)  
            abn = -(2.0D0*adb/(sqrt(zzz(m,i))*a0))*(1.0D0 - 2.0D0*adb*del1**2/a0&
              **2) 
          case (6)  
            abn = -(4.0D0*adb**2*del2/(sqrt(apb)*a0**2))*(1.0D0 - 2.0D0*adb*&
              del1**2/a0**2) 
          case (7)  
            abn = 8.0D0*adb**3*del1*del2*del3/(sqrt(apb)*a0**4) 
          case (8)  
            abn = -(8.0D0*adb**2*del1/(sqrt(apb)*a0**2))*(0.5D0 - adb*del2**2/&
              a0**2) 
          case (9)  
            abn = -(8.0D0*adb**2*del1/(sqrt(apb)*a0**2))*(1.5D0 - adb*del1**2/&
              a0**2) 
          end select  
          ss(i,j) = sqrt((2.0D0*sqrt(apb)/amb)**3)*exp((-adr))*abn 
        end do 
      end do 
      do i = 1, 6 
        ds(iol) = ds(iol) + sum(ss(i,:)*ccc(m,i)*ccc(n,:)) 
      end do 
      return  
      end subroutine ders 

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine mxv(a, nar, vecx, nbr, vecy)
      implicit none
      integer, parameter :: incy = 1, incx = 1
      integer  :: nar
      integer  :: nbr
      double precision  :: a(nar,nbr)
      double precision  :: vecx(nbr)
      double precision  :: vecy(nar)
!
!     RECTANGULAR MATRIX-VECTOR PRODUCT C=A*B.
!     EACH MATRIX IS ENTIRELY FULLFILLED AND PACKED.

      call dgemv ('N', nar, nbr, 1.0d0, a, nar, vecx, incx, 0.0d0, vecy, incy)
      return
      end subroutine mxv

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

    Subroutine eigenvectors_LAPACK(eigenvecs, xmat, eigvals, ndim)
      USE chanel_C, only : iw
#ifdef GPU
      Use mod_vars_cuda, only: lgpu, ngpus, prec
#endif
#if (MAGMA)
      Use magma
      use initMagma
#endif

      implicit none
      Integer :: ndim
      double precision :: eigenvecs(ndim,ndim), &
                    & eigvals(ndim),xmat((ndim*(ndim+1))/2)
      integer :: i, j
      Integer :: lwork, liwork, info
      double precision,dimension(1:10) :: work_tmp
      Integer, dimension(1:10) :: iwork_tmp
      double precision, allocatable :: work(:)
      Integer, allocatable :: iwork(:)
!==============================================================================
! Code to find all eigenvectors and all eigenvalues for a symmetric General matrix
! using LAPACK and MAGMA
! Gerd Bruno Rocha and Julio Carvalho Maia 11/17/2013.
!==============================================================================
      continue
      eigvals = 0.d0
      eigenvecs = 0.d0

!
! Perturb secular determinant matrix to split exact degeneracies
! (This is to get around a bug in the diagonalizer that causes eigenvectors to not be orthonormal)
!
!  The following unusual construction works.  Do NOT change it unless degeneracy tests have been done,
!  and the results are reproducible.
!
      forall (i=1:ndim)
          xmat((i*(i + 1))/2) = xmat((i*(i + 1))/2) + i*1.d-10   ! Do NOT go much higher than 1.d-10, otherwise the geometry
      endforall                                              ! optimization might go into an endless loop.
      call dtpttr( 'u', ndim, xmat, eigenvecs, ndim, i )

#ifdef MKL
#ifdef GPU
if (lgpu .and. (ngpus > 1 .and. ndim > 100)) then
      call mkl_dimatcopy('C', 'T' , ndim, ndim, 1.0d0, eigenvecs, ndim, ndim)
end if
#endif
#endif
      if (i /= 0) stop 'error in dtpttr'

      j = i ! Dummy - to make FORCHECK not complain about "j"
      i = j ! Dummy
      if (i == -999) return
      lwork = -1
      liwork = -1

! GBR_new_addition

#if (MAGMA)
      if (lgpu .and. ndim > 100) then
         if (ngpus > 1) then
             call magma_dsyevd_Driver1(ngpus,'v','l',ndim,eigenvecs,ndim,eigvals,&
                    & work_tmp,lwork,iwork_tmp,liwork,info)
          else
             call magma_dsyevd_Driver1(ngpus,'v','u',ndim,eigenvecs,ndim,eigvals,&
                    & work_tmp,lwork,iwork_tmp,liwork,info)
          end if
      else
         call dsyevd('v','u',ndim,eigenvecs,ndim,eigvals,work_tmp,&
                    & lwork,iwork_tmp,liwork,info)
      end if
#else
      call dsyevd('v','u',ndim,eigenvecs,ndim,eigvals,work_tmp, &
                    & lwork,iwork_tmp,liwork,info)
#endif
      lwork = int(work_tmp(1))
      liwork = iwork_tmp(1)
      allocate (work(lwork), iwork(liwork), stat = i)
!      forall (j=1:lwork) work(j) = 0.d0
!      forall (j=1:liwork) iwork(j) = 0
#if (MAGMA)
      if (lgpu .and. ndim > 100) then
         if (ngpus > 1) then
             call magma_dsyevd_Driver2(ngpus,'v','l',ndim,eigenvecs,ndim,eigvals,&
                    & work,lwork,iwork,liwork,info)
          else
             call magma_dsyevd_Driver2(ngpus,'v','u',ndim,eigenvecs,ndim,eigvals,&
                    & work,lwork,iwork,liwork,info)
          end if
      else
         call dsyevd('v','u',ndim,eigenvecs,ndim,eigvals,work,&
                                & lwork,iwork,liwork,info)
      end if
#else

      call dsyevd('v','u',ndim,eigenvecs,ndim,eigvals,work, &
                                & lwork,iwork,liwork,info)
#endif

      deallocate (iwork,work,stat = j)
      if (info /= 0)  write(iw,*) ' dsyevd Diagonalization error., CODE =',info
      continue
      return
    End subroutine eigenvectors_LAPACK

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine dijkl1(c, n, nati, w, cij, wcij, ckl, xy)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : numat, norbs
      use common_arrays_C, only : nfirst, nlast
      use meci_C, only : nmos
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n
      integer , intent(in) :: nati
      double precision , intent(in) :: c(n,*)
      double precision  :: w(*)
      double precision  :: cij(10*norbs)
      double precision  :: wcij(10*norbs)
      double precision , intent(inout) :: ckl(10*norbs)
      double precision , intent(out) :: xy(nmos,nmos,nmos,nmos)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(0:8) :: nb
      integer :: na, i, j, ipq, ii, ip, i77, kr, js, nbj, nbi, k, ll, l
      double precision :: sum

      save nb
!-----------------------------------------------
!***********************************************************************
!
!   DIJKL1 IS SIMILAR TO IJKL.  THE MAIN DIFFERENCES ARE THAT
!   THE ARRAY W CONTAINS THE TWO ELECTRON INTEGRALS BETWEEN
!   ONE ATOM (NATI) AND ALL THE OTHER ATOMS IN THE SYSTEM.
!
!           ON EXIT
!
!   THE ARRAY XY IS FILLED WITH THE DIFFERENTIALS OF THE
!   TWO-ELECTRON INTEGRALS OVER ACTIVE-SPACE M.O.S W.R.T. MOTION
!   OF THE ATOM NATI.
!***********************************************************************
      data nb/ 1, 0, 0, 10, 0, 0, 0, 0, 45/
      na = nmos
      do i = 1, na
        do j = 1, i
          ipq = 0
          do ii = 1, numat
            if (ii == nati) cycle
            do ip = nfirst(ii), nlast(ii)
              if (ip - nfirst(ii) + 1 > 0) then
                cij(ipq+1:ip-nfirst(ii)+1+ipq) = c(ip,i)*c(nfirst(ii):ip,j) + c&
                  (ip,j)*c(nfirst(ii):ip,i)
                ipq = ip - nfirst(ii) + 1 + ipq
              end if
            end do
          end do
          i77 = ipq + 1
          do ip = nfirst(nati), nlast(nati)
            if (ip - nfirst(nati) + 1 > 0) then
              cij(ipq+1:ip-nfirst(nati)+1+ipq) = c(ip,i)*c(nfirst(nati):ip,j)&
                 + c(ip,j)*c(nfirst(nati):ip,i)
              ipq = ip - nfirst(nati) + 1 + ipq
            end if
          end do
          wcij(:ipq) = 0.D0
          kr = 1
          js = 1
          nbj = nlast(nati) - nfirst(nati)
          if (nbj >= 0) then
            do ii = 1, numat
              if (ii == nati) cycle
              nbi = nlast(ii) - nfirst(ii)
              if (nbi < 0) cycle
              call formxy (w(kr), kr, wcij(i77), wcij(js), cij(i77),nb(nbj), cij(&
                js), nb(nbi))
              js = js + nb(nbi)
            end do
          end if
          do k = 1, i
            if (k == i) then
              ll = j
            else
              ll = k
            end if
            do l = 1, ll
              ipq = 0
              do ii = 1, numat
                if (ii == nati) cycle
                do ip = nfirst(ii), nlast(ii)
                  if (ip - nfirst(ii) + 1 > 0) then
                    ckl(ipq+1:ip-nfirst(ii)+1+ipq) = c(ip,k)*c(nfirst(ii):ip,l)&
                       + c(ip,l)*c(nfirst(ii):ip,k)
                    ipq = ip - nfirst(ii) + 1 + ipq
                  end if
                end do
              end do
              do ip = nfirst(nati), nlast(nati)
                if (ip - nfirst(nati) + 1 > 0) then
                  ckl(ipq+1:ip-nfirst(nati)+1+ipq) = c(ip,k)*c(nfirst(nati):ip,&
                    l) + c(ip,l)*c(nfirst(nati):ip,k)
                  ipq = ip - nfirst(nati) + 1 + ipq
                end if
              end do
              sum = 0.D0
              do ii = 1, ipq
                sum = sum + ckl(ii)*wcij(ii)
              end do
              xy(i,j,k,l) = sum
              xy(i,j,l,k) = sum
              xy(j,i,k,l) = sum
              xy(j,i,l,k) = sum
              xy(k,l,i,j) = sum
              xy(k,l,j,i) = sum
              xy(l,k,i,j) = sum
              xy(l,k,j,i) = sum
            end do
          end do
        end do
      end do
      return
      end subroutine dijkl1

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine ijkl(cp, cf, nelec, nmos, dijkl, cij, ckl, wcij, xy)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE molkst_C, only : norbs, numat, lm61
      USE cosmo_C, only : iseps
      use common_arrays_C, only : nfirst, nlast, w
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: nelec
      integer , intent(in) :: nmos
      double precision , intent(in) :: cp(norbs,nmos)
      double precision , intent(in) :: cf(norbs,norbs)
      double precision , intent(inout) :: dijkl(norbs,nmos,(nmos*(nmos + 1))/2)
      double precision  :: cij(lm61)
      double precision  :: ckl(lm61)
      double precision  :: wcij(lm61)
      double precision , intent(out) :: xy(nmos,nmos,nmos,nmos)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: ij, i, j, ipq, ii, ip, k, l, kk
      double precision :: sum
!-----------------------------------------------
!***********************************************************************
!
!   IJKL FILLS THE XY ARRAY.  XY HOLDS THE TWO-ELECTRON INTEGRALS OVER
!        MOLECULAR ORBITALS IN THE ACTIVE SPACE.
!        XY(I,J,K,L) = <IJ|1/R(1,2)|KL>
!
!           ON INPUT
!
! CP     = M.O.'S OVER C.I. ACTIVE SPACE (NORMALLY 1 TO 5 M.O.S)
! CF     = ALL M.O.'S, INCLUDING THOSE IN CP
! NORBS  = NUMBER OF ATOMIC ORBITALS
! NELEC  = NUMBER OF OCCUPIED M.O.S NOT INVOLVED IN THE C.I.
! NMOS   = NUMBER OF M.O.S INVOLVED IN THE C.I. (NORMALLY 1 TO 5 M.O.S)
!          ALSO CALLED THE ACTIVE SPACE OF THE C.I.
!
!  NOTE: THIS SUBROUTINE IS UNUSUAL IN THAT ONE FUNCTION IS TO
!        FILL THE ARRAY XY WHICH IS NOT PASSED AS AN ARGUMENT,
!        INSTEAD IT IS PASSED VIA COMMON BLOCK XYIJKL.
!
!***********************************************************************
!
!  CALCULATE TWO-ELECTRON INTEGRALS FOR THE SET DIJKL(K,L,IJ)
!  THE INDEX K RUNS OVER ALL M.O.'S, L OVER ACTIVE-SPACE M.O.'S,
!  AND IJ OVER LOWER-HALF TRIANGLE OF ACTIVE-SPACE M.O.'S, J FASTER THAN
!  I.
!  ALL ACTIVE-SPACE INTERACTIONS ARE COPIED INTO THE ARRAY XY
!
      ij = 0
      do i = 1, nmos
        do j = 1, i
          ij = ij + 1
          ipq = 0
          do ii = 1, numat
            do ip = nfirst(ii), nlast(ii)
              if (ip - nfirst(ii) + 1 > 0) then
                cij(ipq+1:ip-nfirst(ii)+1+ipq) = cp(ip,i)*cp(nfirst(ii):ip,j)&
                   + cp(ip,j)*cp(nfirst(ii):ip,i)
                ipq = ip - nfirst(ii) + 1 + ipq
              end if
            end do
          end do
!
!  CIJ HOLDS THE DENSITY DISTRIBUTION PSI(I)*PSI(J) OVER ATOMIC BASES
!  I AND J ARE M.O. INDICES WITHIN THE ACTIVE SPACE.  CIJ(M,N) IS FOR
!  THE ATOMIC BASES M AND N FOR M.O.'S I AND J.
!
          call partxy (cij, wcij, w)
!
! WCIJ HOLDS THE KET PART OF THE INTEGRAL <K,L|1/R(1,2)|I,J>
! THAT IS, |1/R(1,2)|I,J>.  WCIJ(M,N) IS FOR THE ATOMIC BASES M AND N
! FOR M.O.'S K AND L.
!
          do k = 1, norbs
            do l = 1, nmos
!
!  ABOUT TO CALCULATE <I,J|1/R(1,2)|K,L>
!
              ipq = 0
              do ii = 1, numat
                do ip = nfirst(ii), nlast(ii)
                  if (ip - nfirst(ii) + 1 > 0) then
                    ckl(ipq+1:ip-nfirst(ii)+1+ipq) = cf(ip,k)*cp(nfirst(ii):ip,&
                      l) + cp(ip,l)*cf(nfirst(ii):ip,k)
                    ipq = ip - nfirst(ii) + 1 + ipq
                  end if
                end do
              end do
!
! CKL HOLDS THE DENSITY DISTRIBUTION PSI(K)*PSI(L) OVER ATOMIC BASES.
! K IS THE INDEX OF A M.O.; L IS AN INDEX OF A M.O. IN THE ACTIVE SPACE.
!
              sum = 0.D0
              do ii = 1, ipq
                sum = sum + ckl(ii)*wcij(ii)
              end do
!
!  SUM IS THE INTEGRAL <I,J|1/R(1,2)|K,L>
!
              dijkl(k,l,ij) = sum
            end do
          end do
        end do
      end do
!
!  NOW SPREAD THE INTEGRALS OVER THE XY ARRAY.  XY IS ENTIRELY
!  IN ACTIVE SPACE
!
      do k = 1, nmos
        kk = nelec + k
!
!  K IS A M.O. INDEX IN ACTIVE SPACE
! KK IS A M.O. INDEX
!
        do l = 1, nmos
          ij = 0
          do i = 1, nmos
            do j = 1, i
              ij = ij + 1
              sum = dijkl(kk,l,ij)
              xy(i,j,k,l) = sum
              xy(i,j,l,k) = sum
              xy(j,i,k,l) = sum
              xy(j,i,l,k) = sum
              xy(k,l,i,j) = sum
              xy(k,l,j,i) = sum
              xy(l,k,i,j) = sum
            end do
          end do
        end do
      end do
      if (.not.iseps) return
      do i = 1, nmos
        ipq = 0
        do ii = 1, numat
          do ip = nfirst(ii), nlast(ii)
            if (ip - nfirst(ii) + 1 > 0) then
              cij(ipq+1:ip-nfirst(ii)+1+ipq) = cp(ip,i)*cp(nfirst(ii):ip,i)
              ipq = ip - nfirst(ii) + 1 + ipq
            end if
          end do
        end do
        call ciint (cij, wcij)
        do l = 1, i
          ipq = 0
          do ii = 1, numat
            do ip = nfirst(ii), nlast(ii)
              if (ip - nfirst(ii) + 1 > 0) then
                ckl(ipq+1:ip-nfirst(ii)+1+ipq) = cp(ip,l)*cp(nfirst(ii):ip,l)
                ipq = ip - nfirst(ii) + 1 + ipq
              end if
            end do
          end do
        end do
      end do
      return
      end subroutine ijkl

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine write_trajectory(xyz, escf, ekin, rc_dipo, time, xtot, l_dipole)
!
! Write a single point in a trajectory to a file of type <file>.xyz or <file>.pdb
!
!  If the type is <file>.xyz then the single point consists of:
!
!  A line containing the number of atoms in the system.
!  A line containing the text "Profile." followed by the model number,  some more text ending in the character "="
!    and a real datum, either the heat of formation or the dipole moment.
!    The geometry in Cartesian coordinates
!
!  Example of a single point in such a file (6 lines):
!     4
!Profile.   2 HEAT OF FORMATION =    -0.467 KCAL =    -1.955 KJ
!    N        0.00000        0.00000       -0.00092
!    H        0.97231        0.00000        0.00427
!    H       -0.48616        0.84205        0.00427
!    H       -0.48616       -0.84205        0.00427
!
!  If the type if <file>.pdb then the single point consists of:
!
!  A line containing the text "MODEL" followed by the model number.
!  A PDB file giving a header line, the geometry, and an "END" line
!  A A line containing the text "ENDMDL"
!
!  Example of a single point in such a file (8 lines)
!MODEL      2
!HEADER Heat of Formation =       2.677 Kcal/mol
!HETATM    1  N   NH3 A   1       0.000   0.000   0.000  1.00 -0.83      PROT N
!HETATM    2 1H   NH3 A   1       0.920   0.000   0.000  1.00  0.28      PROT H
!HETATM    3 2H   NH3 A   1      -0.460   0.797   0.000  1.00  0.28      PROT H
!HETATM    4 3H   NH3 A   1      -0.460  -0.797  -0.000  1.00  0.28      PROT H
!END
!ENDMDL
!
  use molkst_C, only : step_num, numat, jloop => itemp_1, line, keywrd, backslash, nvar, &
  ncomments
  use chanel_C, only : ixyz, xyz_fn
  use drc_C, only : georef
  USE elemts_C, only : elemnt
  use common_arrays_C, only : nat, l_atom
  implicit none
  double precision, intent (in) :: escf, ekin, time, xtot, rc_dipo
  double precision, intent (in) :: xyz(3,numat)
  logical, intent (in) :: l_dipole
  integer :: icalcn = 0, i, k, j, ipdb = 14, imodel = 0, npt = 0, ixyz1
  character :: num1*1, num2*1, num3*1
  double precision :: factor
  save :: icalcn, ipdb, imodel, npt, ixyz1
  if (icalcn /= step_num) then
    ncomments = -1
    if (nvar >= numat*3 .and. index(keywrd, " MINI ") == 0 ) l_atom(:numat) = .true.
    do i = len_trim(xyz_fn), 1, -1
      if (xyz_fn(i:i) == "/" .or. xyz_fn(i:i) == backslash) exit
    end do
    open(unit=ixyz, file=xyz_fn)
    if (l_dipole) then
      ixyz1 = ixyz + 1
      open(unit=ixyz1, file=xyz_fn(:len_trim(xyz_fn) - 4)//" for dipole.xyz")
    end if
    if (index(keywrd, " PDBOUT") /= 0) &
      open(unit = ipdb, file = xyz_fn(:len_trim(xyz_fn) - 3)//"pdb")
    icalcn = step_num
  end if
!
!  Write out "xyz" file
!
  write(ixyz,"(i6,a)") numat," "
  if (index(keywrd, " REVERSE") /= 0) then
    npt = npt - 1
    imodel = imodel -1
    call l_control("REVERSE", len("REVERSE"), -1)
  end if
  num1 = char(ichar("1") + int(log10(jloop*1.01)))
  factor = abs(escf)
  num2 = char(max(ichar("0"), ichar("0") + min(9, int(log10(factor)) - 1)))
  num3 = char(max(ichar("0"), ichar("0") + min(9, int(log10(4.184d0*factor)) - 1)))
  npt = npt + 1
  if (l_dipole) then
    write(ixyz1,"(i6,a)") numat," "
    write(line,'(a, i'//num1//', a, f1'//num2//'.4, a)')"Profile.", jloop, &
    " DIPOLE =", rc_dipo, " DEBYE"
     k = index(line, "DIPO")
     write(ixyz1,'(a,i4,a)')line(:8), npt," "//trim(line(k:))
  end if
  write(line,'(a, i'//num1//', a, f1'//num2//'.3, a, f1'//num3//'.3, a)')"Profile.", jloop, &
    " HEAT OF FORMATION =", escf, " KCAL "
  k = index(line, "HEAT")
  write(ixyz,'(a,i4,a)')line(:8), npt," "//trim(line(k:))
  k = 0
  do i = 1, numat
    if (l_atom(i)) then
      k = k + 1
      if (l_dipole) write(ixyz1,"(3x,a2,3f15.5)")elemnt(nat(i)), (xyz(j,k), j = 1, 3)
      write(ixyz,"(3x,a2,3f15.5)")elemnt(nat(i)), (xyz(j,k), j = 1,3)
    else
      if (l_dipole) write(ixyz1,"(3x,a2,3f15.5)")elemnt(nat(i)), (georef(j,i), j = 1, 3)
      write(ixyz,"(3x,a2,3f15.5)")elemnt(nat(i)), (georef(j,i), j = 1, 3)
    end if
  end do
  if (mod(jloop,10) == 0) then! write out every 10'th iteration.
    if (time > 1.d-6) then
      write (line, "(a7,i6,a8,f17.5,a8,f9.4,a7,f9.4,a7,f9.3)") " CYCLE:", jloop, &
        & "  Pot.E:", escf, "  Kin.E:", ekin, "  Move:", xtot,"  Time:", Min(time,99999.999d0)
      else
        write (line, "(a7,i6,a19,f17.5,a8,f9.4,a7,f9.4,a7,f9.3)") " CYCLE:", jloop, &
    & "  Potential energy:", escf, " Diff.:", ekin, "  Move:", xtot
    end if
    call to_screen(line)
  end if
  if (index(keywrd, " PDBOUT") /= 0) then
    imodel = imodel + 1
    write(line,'(F13.5)') escf
    do i = 1, 12
      if (line(i:i) /= " ") exit
    end do
    write(ipdb,'(a, i9, 2x, a)')"MODEL",imodel, trim(line(i:))
    call pdbout(ipdb)
    write(ipdb,'(a)')"ENDMDL"
  end if
end subroutine write_trajectory
subroutine reverse_trajectory(mode)
!
! Read in a trajectory that was created earlier in this run, and
! write it back out, in reverse order of points.
!
  use molkst_C, only : step_num, jloop => itemp_1, line, nl_atoms, keywrd, backslash
  use chanel_C, only : ixyz, xyz_fn
  implicit none
  integer, intent (in) :: mode
  integer :: icalcn = 0, i, k, io_stat, ipdb = 14, imodel = 0, npdb, npt, ixyzn
  character :: dummy_char*1, xyz_fnn*200
  character, allocatable :: store_path(:,:)*200, store_hofs(:)*200
  save :: icalcn, ipdb, imodel, npt
  ixyzn = 0
  if (icalcn /= step_num) then
    do i = len_trim(xyz_fn), 1, -1
      if (xyz_fn(i:i) == "/" .or. xyz_fn(i:i) == backslash) exit
    end do
    if (mode == 1) then
      ixyzn = ixyz
      xyz_fnn = trim(xyz_fn)
    else
      ixyzn = ixyz + 1
      xyz_fnn = xyz_fn(:len_trim(xyz_fn) - 4)//" for dipole.xyz"
    end if
    open(unit=ixyzn, file=xyz_fnn)
    if (index(keywrd, " PDBOUT") /= 0) &
      open(unit = ipdb, file = xyz_fnn(:len_trim(xyz_fnn) - 3)//"pdb")
    if (mode == 1) icalcn = step_num
  end if

  close (ixyzn)
  open(ixyzn, file = xyz_fnn)
  rewind(ixyzn)
  allocate (store_path(nl_atoms, jloop), store_hofs(jloop))
!
!  Read in the path already generated
!
  do i = 1, 100000
    read(ixyzn,*, iostat=io_stat)dummy_char
    if (dummy_char =="0" .and. i < 0) return  ! dummy use of dummy_char
    read(ixyzn,'(a)', iostat=io_stat)line
    if (io_stat /= 0) exit
    store_hofs(i) = trim(line)
    read(ixyzn,"(a)", iostat=io_stat) &
      (store_path(k,i), k = 1, nl_atoms)
  end do
  close (ixyzn)
  open(ixyzn, file = xyz_fnn)
  rewind(ixyzn)
!
! Write out the path already generated, in reverse
!
  jloop = i - 1
  npt = 0
  do i = jloop, 2, -1  ! Exclude the first point - it's common to both paths
    write(ixyzn,"(i6,a)") nl_atoms," "
    k = index(store_hofs(i), "HEAT") + index(line, "DIPO")
    npt = npt + 1
    write(ixyzn,'(a,i4,1x,a)')store_hofs(i)(:8), npt,trim(store_hofs(i)(k:))
    do k = 1, nl_atoms
      write(ixyzn,"(a)") trim(store_path(k,i))
    end do
  end do
!
!  Do the same with the PDB file
!
  if (index(keywrd, " PDBOUT") /= 0) then
    deallocate (store_path)
    open(unit = ipdb, file = xyz_fnn(:len_trim(xyz_fnn) - 3)//"pdb")
    rewind (ipdb)
!
! How many lines are there in each PDB file?
!
    do npdb = 0, 10000
      read(ipdb,'(a)') line
      if (line(:6) == "ENDMDL") exit
    end do
    allocate (store_path(npdb, jloop))
    rewind (ipdb)
    do i = 1, 100000
      read(ipdb,*, iostat=io_stat)dummy_char
      if (dummy_char =="0" .and. i < 0) return  ! dummy use of dummy_char
      read(ipdb,"(a)", iostat=io_stat) &
        (store_path(k,i), k = 1, npdb)
      if (io_stat /= 0) exit
    end do
    close (ipdb)
    open(unit = ipdb, file = xyz_fnn(:len_trim(xyz_fnn) - 3)//"pdb")
    rewind(ipdb)
!
! Write out the path already generated, in reverse
!
    imodel = 0
    jloop = i - 1
    do i = jloop, 2, -1! Exclude the first point - it's common to both paths
      imodel = imodel + 1
      line = store_hofs(i)(33:43)
      do k = 1, 12
        if (line(k:k) /= " ") exit
      end do
      write(ipdb,'(a, i9, 2x, a)')"MODEL",imodel, trim(line(k:))
      do k = 1, npdb
        write(ipdb,"(a)") trim(store_path(k,i))
      end do
    end do
  end if
  deallocate (store_path)
end subroutine reverse_trajectory
subroutine reverse_aux
!
!  Read in the current AUX file, then write out everything down to the start of the IRC,
!  then write out the IRC in reverse.
!
  use molkst_C, only : npoints => itemp_1, line, keywrd
  use chanel_C, only : output_fn
  implicit none
  integer :: hook = 50, i, j, n_head, n_lines
  character, allocatable :: start(:)*100, irc(:,:)*100
  if (index(keywrd, " AUX") == 0) return
  close (hook)
  open(unit=hook,file=output_fn(:len_trim(output_fn) - 4)//".aux")
  do i = 1, 10000
    read(hook,'(a)') line
    if (index(line, "#               IRC                #") /= 0) exit
  end do
  n_head = i + 2
  read(hook,'(a)') line
  if (line /= "dummy") read(hook,'(a)') line! a clumsy way to "fool" forcheck
  if (line /= "dummy") read(hook,'(a)') line
  if (line == "dummy") return
  do i = n_head + 1, n_head + 10000
    read(hook,'(a)') line
    if (index(line, "REF_POINT") /= 0) exit
  end do
  n_lines = i - n_head
!
!  The sizes of the data blocks are now known,
!  so rewind, and store everything.
!
  rewind (hook)
  allocate (start(n_head), irc(n_lines, npoints))
  read(hook,'(a)')start
  read(hook,'(a)')irc
!
! Now write out the AUX file again, in reverse
!
  rewind (hook)
  do i = 1, n_head
    write(hook,'(a)')trim(start(i))
  end do
  do i = npoints, 2, -1
    write(hook,'(a,i5.5)')" REF_POINT=",npoints - i + 1
    irc(2,i)(21:21) = "-"
    do j = 2, n_lines
      write(hook,'(a)')trim(irc(j,i))
    end do
  end do
  write(hook,'(a)')" ######################################"
  write(hook,'(a)')" #                                    #"
  write(hook,'(a)')" # Next point is the transition state #"
  write(hook,'(a)')" #                                    #"
  write(hook,'(a)')" ######################################"
  deallocate(start, irc)
end subroutine reverse_aux

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine linmin(xparam, alpha, pvect, nvar, funct, okf, ic, dott)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : moperr, numcal, keywrd, cosine, line
      use common_arrays_C, only : loc
      use chanel_C, only : iw
      use funcon_C, only : pi
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: nvar
      integer , intent(inout) :: ic
      double precision  :: alpha
      double precision, intent (out)  :: funct
      double precision , intent(in) :: dott
      logical , intent(inout) :: okf
      double precision  :: xparam(nvar)
      double precision , intent(inout) :: pvect(nvar)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: left, right, center, icalcn, i, maxlin, nsame, ictr
      double precision, dimension(3) :: phi
      double precision, dimension(4) :: vt, grad ! grad is not used in linmin
      double precision, dimension(nvar) :: xstor, xparef
      double precision :: alpold, xmaxm, delta1, delta2, xnear, ymaxst, pabs, &
        fin, ssqlst, fmax, fmin, sqstor, energy = 0.d0, estor, alfs, beta, gamma, s&
        , xxm, funold, hlast, drop, sum
      logical :: print, diis

      save print, alpold, icalcn, xmaxm, i, delta1, delta2, xnear, maxlin, &
        ymaxst
!-----------------------------------------------
!*********************************************************************
!
!  LINMIN DOES A LINE MINIMISATION.
!
!  ON INPUT:  XPARAM = STARTING COORDINATE OF SEARCH.
!             ALPHA  = STEP SIZE FOR INITIATING SEARCH.
!             PVECT  = DIRECTION OF SEARCH.
!             NVAR   = NUMBER OF VARIABLES IN XPARAM.
!             FUNCT  = INITIAL VALUE OF THE FUNCTION TO BE MINIMIZED.
!             ISOK   = NOT IMPORTANT.
!             COSINE = COSINE OF ANGLE OF CURRENT AND PREVIOUS GRADIENT.
!
!  ON OUTPUT: XPARAM = COORDINATE OF MINIMUM OF FUNCTI0N.
!             ALPHA  = NEW STEP SIZE, USED IN NEXT CALL OF LINMIN.
!             FUNCT  = FINAL, MINIMUM VALUE OF THE FUNCTION.
!             OKF    = TRUE IF LINMIN IMPROVED FUNCT, FALSE OTHERWISE.
!
!**********************************************************************
!
!  THE FOLLOWING COMMON IS USED TO FIND OUT IF A NON-VARIATIONALLY
!  OPTIMIZED WAVE-FUNCTION IS BEING USED.
      data icalcn/ 0/
      data alpold/ 0.D0/
      if (icalcn /= numcal) then
        xmaxm = 0.4D0
        delta2 = 0.001D0
        if (index(keywrd,'NOTH') == 0) then
          delta1 = 0.5D0
        else
          delta1 = 0.1D0
        end if
        alpha = 1.D0
        maxlin = 15
        xnear = 1.D-4
        if (nvar == 1) then
          pvect(1) = 0.01D0
          alpha = 1.D0
          xnear = 1.D-5
          delta1 = 0.0005D0
          delta2 = 0.0001D0
          if (index(keywrd,'PREC') /= 0) then
            delta1 = 0.D0
            delta2 = delta2*0.01D0
          end if
          maxlin = 50
        end if
        cosine = 99.99D0
!
        ymaxst = 0.4D0
        print = index(keywrd,'LINMIN') /= 0
        icalcn = numcal
      end if
      nsame = 0
      xparef(:nvar) = xparam(:nvar)
      xmaxm = 0.D0
      do i = 1, nvar
        pabs = abs(pvect(i))
        xmaxm = max(xmaxm,pabs)
      end do
      xmaxm = ymaxst/xmaxm
      if (nvar == 1) call compfg (xparam, .TRUE., funct, .TRUE., grad, .FALSE.)
      if (moperr) return
      fin = funct
      ssqlst = funct
      diis = ic==1 .and. nvar>1
      phi(1) = funct
      alpha = 1.D0
      vt(1) = 0.0D00
      vt(2) = alpha
      vt(2) = min(xmaxm,vt(2))
      fmax = funct
      fmin = funct
      alpha = vt(2)
      i = 1
      if (nvar > 0) then
        xparam(:nvar) = xparef(:nvar) + alpha*pvect(:nvar)
        i = nvar + 1
      end if
      call compfg (xparam, .TRUE., funct, .TRUE., grad, .FALSE.)
      phi(2) = funct
      if (moperr) return
      fmax = dmax1(phi(2),fmax)
      fmin = min(phi(2),fmin)
      call exchng (phi(2), sqstor, energy, estor, xparam, xstor, alpha, alfs, &
        nvar)
      if (.not.diis) then
        if (nvar > 1) then
!
!   CALCULATE A NEW ALPHA BASED ON THIEL'S FORMULA
!
          alpha = -alpha**2*dott/(2.D0*(phi(2)-ssqlst-alpha*dott))
          alpha = min(2.D0,alpha)
        else
          if (phi(2) < phi(1)) then
            alpha = 2*alpha
          else
            alpha = -alpha
          end if
        end if
!#      IF(PRINT)WRITE(IW,'(3(A,F12.6))')' ESTIMATED DROP:',DOTT*0.5D0,
!#     1'  ACTUAL: ',PHI(2)-SSQLST, '  PREDICTED ALPHA',ALPHA
        okf = okf .or. phi(2)<ssqlst
        if (delta1 > 0.3D0) then
!
!  THIEL'S TESTS # 18 AND 19
!
          if (okf .and. alpha<2.D0) go to 190
        end if
        vt(3) = alpha
        if (vt(3) <= 1.D0) then
          left = 3
          center = 1
          right = 2
        else
          left = 1
          center = 2
          right = 3
        end if
        i = 1
        if (nvar > 0) then
          xparam(:nvar) = xparef(:nvar) + alpha*pvect(:nvar)
          i = nvar + 1
        end if
        call compfg (xparam, .TRUE., funct, .TRUE., grad, .FALSE.)
        if (moperr) return
        fmax = dmax1(funct,fmax)
        fmin = min(funct,fmin)
        if (funct < sqstor) call exchng (funct, sqstor, energy, estor, xparam, &
          xstor, alpha, alfs, nvar)
        okf = okf .or. funct<fin
        phi(3) = funct
        if (print) write (iw, 50) vt(1), phi(1), phi(1) - fin, vt(2), phi(2), &
          phi(2) - fin, vt(3), phi(3), phi(3) - fin
          if (print) then
          call to_screen(' ---QLINMN ')
          write(line,"(5x,'LEFT    ...',f17.8,2f17.7)")vt(1), phi(1), phi(1) - fin
          call to_screen(line)
          write(line,"(5x,'CENTER  ...',f17.8,2f17.7)") phi(2), phi(2) - fin, vt(3)
          call to_screen(line)
          write(line,"(5x,'RIGHT   ...',f17.8,2f17.7)")vt(3), phi(3), phi(3) - fin
          call to_screen(line)
          end if
   50   format(' ---QLINMN ',/,5x,'LEFT    ...',f17.8,2f17.7,/,5x,'CENTER  ...',&
          f17.8,2f17.7,/,5x,'RIGHT   ...',f17.8,2f17.7,/)
        alpold = 0.D0
        l180: do ictr = 3, maxlin
          alpha = vt(2) - vt(3)
          beta = vt(3) - vt(1)
          gamma = vt(1) - vt(2)
          if (abs(alpha*beta*gamma) > xnear) then
            alpha = -(phi(1)*alpha+phi(2)*beta+phi(3)*gamma)/(alpha*beta*gamma)
          else
!
!   FINISH BECAUSE TWO POINTS CALCULATED ARE VERY CLOSE TOGETHER
!
            exit  l180
          end if
          beta = (phi(1)-phi(2))/gamma - alpha*(vt(1)+vt(2))
          if (alpha <= 0.D0) then
            if (phi(right) <= phi(left)) then
              alpha = 3.0D00*vt(right) - 2.0D00*vt(center)
            else
              alpha = 3.0D00*vt(left) - 2.0D00*vt(center)
            end if
            s = alpha - alpold
            if (abs(s) > xmaxm) s = sign(xmaxm,s)*(1 + 0.01D0*(xmaxm/s))
            alpha = s + alpold
          else
            alpha = -beta/(2.0D00*alpha)
            s = alpha - alpold
            xxm = 2.0D00*xmaxm
            if (abs(s) > xxm) s = sign(xxm,s)*(1 + 0.01D0*(xxm/s))
            alpha = s + alpold
          end if
!
!   FINISH IF CALCULATED POINT IS NEAR TO POINT ALREADY CALCULATED
!
          do i = 1, 3
            if (.not.(abs(alpha - vt(i))<delta1*(1.D0+vt(i)) .and. okf)) cycle
            exit  l180
          end do
          i = 1
          if (nvar > 0) then
            xparam(:nvar) = xparef(:nvar) + alpha*pvect(:nvar)
            i = nvar + 1
          end if
          funold = funct
          call compfg (xparam, .TRUE., funct, .TRUE., grad, .FALSE.)
          if (moperr) return
          fmax = dmax1(funct,fmax)
          fmin = min(funct,fmin)
          if (funct < sqstor) call exchng (funct, sqstor, energy, estor, xparam&
            , xstor, alpha, alfs, nvar)
          okf = okf .or. funct<fin
          if (print) then
            write(line,"(5x,'LEFT   ...',f17.8,2f17.7)")vt(left), phi(left), phi(left) - fin
            call to_screen(line)
            write(line,"(5x,'CENTER ...',f17.8,2f17.7)") vt(center), phi(center), phi(center) - fin
            call to_screen(line)
            write(line,"(5x,'RIGHT  ...',f17.8,2f17.7)")vt(right), phi(right), phi(right) - fin
            call to_screen(line)
            if (nvar == 1) then
              if (loc(2,1) == 1) then
                sum = 1.d0
              else
                sum = 180/pi
              end if
              write(line,"(5x,'NEW    ...',f17.8,4f17.7)")alpha, funct, funct - fin, xparam(1)*sum
              write (iw, 130) vt(left), phi(left), phi(left) - fin, &
                              vt(center), phi(center), phi(center) - fin, &
                              vt(right), phi(right), phi(right) - fin, &
                              alpha, funct, funct - fin, xparam(1)*sum
            else
              write(line,"(5x,'NEW    ...',f17.8,2f17.7)")alpha, funct, funct - fin
              write (iw, 130) vt(left), phi(left), phi(left) - fin, &
                              vt(center), phi(center), phi(center) - fin, &
                              vt(right), phi(right), phi(right) - fin, &
                              alpha, funct, funct - fin
            end if
            call to_screen(line)
          end if
  130     format(5x,'LEFT    ...',f17.8,2f17.7,/,5x,'CENTER  ...',f17.8,2f17.7, &
            & /,5x,'RIGHT   ...',f17.8,2f17.7,/,5x,'NEW     ...',f17.8,3f17.7,/)
!
! TEST TO EXIT FROM LINMIN IF NOT DROPPING IN VALUE OF FUNCTION FAST.
!
          if (abs(funold - funct)<delta2 .and. okf) exit  l180
          alpold = alpha
          if (alpha>vt(right) .or. alpha>vt(center) .and. funct<phi(center)&
             .or. alpha>vt(left) .and. alpha<vt(center) .and. funct>phi(center)&
            ) go to 140
!
!   IF SYSTEM IS CREEPING UP ON A DISTANT HIGH VALUE, DISCARD
!   DISTANT HIGH VALUE.
!
          if (nsame > 4) go to 140
          nsame = nsame + 1
          vt(right) = alpha
          phi(right) = funct
          go to 150
  140     continue
          vt(left) = alpha
          nsame = 0
          phi(left) = funct
  150     continue
          if (vt(center) >= vt(right)) then
            i = center
            center = right
            right = i
          end if
          if (vt(left) >= vt(center)) then
            i = left
            left = center
            center = i
          end if
          if (vt(center) < vt(right)) cycle  l180
          i = center
          center = right
          right = i
        end do l180
      end if
  190 continue
      ic = 2
      if (abs(estor - energy) < 1.D-12) ic = 1
      hlast = funct - fin
      drop = sqstor - fin
      call exchng (sqstor, funct, estor, energy, xstor, xparam, alfs, alpha, &
        nvar)
!
!  Check that the density matrix is O.K., or almost O.K.
!
      if (hlast /= 0.D0 .and. hlast > 0.5D0*drop) then
        call compfg (xparam, .TRUE., funct, .TRUE., grad, .FALSE.)
        if (moperr) return
      end if
      okf = funct < ssqlst .or. diis
      if (funct >= ssqlst) return
      if (alpha < 0.D0) then
        alpha = -alpha
        i = 1
        if (nvar > 0) then
          pvect(:nvar) = -pvect(:nvar)
          i = nvar + 1
        end if
      end if
      return
!
!
      end subroutine linmin

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine maklay (labels, coord, geo, na, nb, nc, mers, loc, nmax)
    use common_systm, only : maxtxt, nalpha, numat, id, iw, l_int, natoms, nvar, &
      line, ndep, l_use_tv
    use common_keywrd, only : keywrd
    use common_ctvec, only : tvec
    use common_jobnam, only : jobnam
    use common_sizes, only : numatm
    
    implicit none
    integer, intent (in) :: nmax
    integer, dimension (3), intent (in) :: mers
    integer, dimension (nmax), intent (inout) :: labels, na, nb, nc
    integer, dimension (2, 3*nmax), intent (inout) :: loc
    double precision, dimension (3, nmax), intent (inout) :: coord, geo
    logical :: debug, lbcc, sym, exists
    integer :: i, ioff = 0, j, k, l, loop1, loop2, loop3, ncell1
    double precision :: degree,  r, xparam(3*numatm)
    double precision, external :: snapth
    debug = (Index (keywrd, " DEBUG") /= 0)
    lbcc = (Index (keywrd, " BCC") /= 0)
    sym = (Index (keywrd, " SYMM") /= 0) 
    if (debug) then
      write(iw,"(/5x,A)")"At entry to MAKLAY"
      write(iw,'(/5x,a, i4)')"Number of atoms:",numat
      write(iw,'(5x,a, i4)')"Number of Tv:   ",id
      write(iw,'(5x,a,3i4)')"MERS:           ",mers(:id)
      write(iw,'(/15x,a,9F9.4)')"TVEC           "
      write(iw,'(2x,3f9.4)')tvec(:,:id)
      write(iw,'(/10x,a,/)')"Geometry (atom number, label, coordinates"      
      do i = 1, numat
        write (iw, "(2I6,3F18.12,3I4)") i, labels (i), (coord(k, i), k = 1, 3)
      end do
    end if
    nalpha = numat
    do loop1 = 0, mers(3) - 1
      do loop2 = 0, mers(2) - 1
        do loop3 = 0, mers(1) - 1
!
!   Find unit cell for relating current unit cell to
!
          if (loop3 /= 0 .or. loop2 /= 0 .or. loop1 /= 0) then
            if ( .not. lbcc .or. Mod (loop1+loop2+loop3, 2) /= 1) then
!
!  All the atoms in the unit cell LOOP1, LOOP2, LOOP3
!
              ioff = ioff + numat
              do j = 1, numat
                labels(ioff+j) = labels(j)
                do k = 1, 3
                  coord(k, ioff+j) = coord(k, j) + tvec(k, 3) * loop1 + &
                 & tvec(k, 2) * loop2 + tvec(k, 1) * loop3
                end do
                k = j + ioff - numat
                if (na(k) /= 0 .and. nb(k) /= 0 .and. nc(k) /= 0) then
                  na(ioff+j) = na(k) + numat
                  nb(ioff+j) = nb(k) + numat
                  nc(ioff+j) = nc(k) + numat
                end if
              end do
            end if
          end if
        end do
      end do
    end do
!
!  Convert from
!
!  All atoms in Unit cell 1
!  All atoms in Unit cell 2
!  All atoms in Unit cell
!
!  to
!
!  Atom 1 (all unit cells)
!  Atom 2 (all unit cells)
!  Atom 3 (all unit cells)
!
    i = Index (keywrd, " SORT")
    if (i /= 0) then
!
!  Delete keywords SORT and MERS
!
      keywrd (i:i+4) = " "
      i = Index (keywrd, " MERS")
      j = Index (keywrd(i+1:), " ") + i
      keywrd (i:j) = " "
      ncell1 = ioff / numat + 1
      do i = 1, numat * ncell1
        na(i) = labels(i)
        do j = 1, 3
          geo(j, i) = coord(j, i)
        end do
      end do
      ncell1 = ncell1 - 1
      l = 0
      do i = 1, numat
        do j = 0, ncell1
          l = l + 1
          labels(l) = na(i)
          do k = 1, 3
            coord(k, l) = geo(k, j*numat+i)
          end do
        end do
      end do
      do i = 1, l
        na(i) = 0
        nb(i) = 0
        nc(i) = 0
      end do
    end if
    numat = ioff + numat     
!
!  Increase size of Tv by factor MERS
!
    do i = 1, id
      do j = 1, 3
        tvec(j, i) = tvec(j, i) * mers(i) 
      end do
    end do
    do i = 2, numat
      do j = 1, i - 1
        r = (coord(1, i)-coord(1, j))**2 + (coord(2, i)-coord(2, j))**2 + &
      & (coord(3, i)-coord(3, j))**2
        if (r < 0.2d0 .and. labels(i) < 99 .and. labels(j) < 99) labels(i) = 200
      end do
    end do
    j = 1
    do i = 2, numat
      if (labels(i) /= 200) then
        j = j + 1
        coord(1,j) = coord(1,i)
        coord(2,j) = coord(2,i)
        coord(3,j) = coord(3,i)
        labels(j) = labels(i)
      end if
    end do
    numat = j
    if (l_int) then
!
!  Add in dummy atoms for translation vectors to use
!
      do i = 1, id
        numat = numat + 1
        labels(numat) = 99
        do j = 1, 3
          coord(j, numat) = tvec(j, i)
        end do
      end do  
      do i = 1, numat
        if (labels(i) == 98) then
          labels(i) = 99
        end if
      end do

      do i = 1, numat
        if (labels(i) == 99) then
          labels(i) = 98
        end if
      end do
!
!  Convert back to internal coordinates
!
      degree = 1.d0
      na = 0; nb = 0; nc = 0;
      call xyzint (coord, na, nb, nc, degree, geo)
!
!   If any angles are near to important angles (such as 109.47...)
!   snap the angle to the exact angle
!
      do i = 1, numat
        if (na(i) /= 0) then
          geo(2, i) = snapth (geo(2, i))
          geo(3, i) = snapth (geo(3, i))
        end if
      end do
!
!   All real atoms plus "ID" dummy atoms are now in GEO, in
!   internal coordinates.
!
!
!  Now to add the translation vectors
!
      do i = 1, id
        numat = numat + 1
        labels(numat) = 107
        geo(1, numat) = Sqrt (tvec(1, i)**2+tvec(2, i)**2+tvec(3, i)**2)
        geo(2, numat) = 0.d0
        geo(3, numat) = 0.d0
        na(numat) = 1
        nb(numat) = numat - id
        nc(numat) = 2
      end do
      go to 1100
    else
      do i = 1, numat
        do j = 1, 3
          geo(j, i) = coord(j, i)
        end do
      end do
!
!  Add in Cartesian translation vectors
!
      do i = 1, id
        numat = numat + 1
        labels(numat) = 107
        do j = 1, 3
          geo(j, numat) = tvec(j, i)
        end do
      end do
    end if
1100 natoms = numat
!
!   Make parameters from all possible geometric variables.
!
    nvar = 0
    do i = 1, numat
      if (l_int) then
        k = Min (3, i-1)
!
!  For Tv, only use "bond length" - do NOT optimize angles or dihedrals
!
        if (labels(i) == 107) then
          k = 1
        end if
      else
        k = 3
      end if
      do j = 1, k
        nvar = nvar + 1
        xparam(nvar) = geo(j, i)
        loc(1, nvar) = i
        loc(2, nvar) = j
      end do
    end do
    if (sym) then
      call maksym (loc, xparam)
    end if
    if (l_int) then
      i = index(keywrd, "     ")
      keywrd (i:i + 3) = " INT"
    end if
!
!   Unprotect any dummy atoms
!
    do i = 1, numat
      if (labels(i) == 98) then
        labels(i) = 99
      end if
    end do
    j = 0
    do i = 1, numat
      if (na(i) /= 0) j = 1
    end do
    if (.false. .and. j == 0) then
!
!  Put atom 1 at the origin
!
      do i = 2, numat - 3
        geo(:,i) = geo(:,i) - geo(:,1)
      end do
      geo(:,1) = 0.d0
    end if
    maxtxt = 0
    if (debug) then
      write(iw,'(///10x,a,///)')"MOPAC data-set"
    end if
    i = index(keywrd, " INT")
    if (i > 0) keywrd(i:i + 3) = " "
    call geout (iw, geo, na, nb, nc, labels, loc)
    line = jobnam
 !   do i = 1, len_trim(line)
 !     if (line(i:i) == "_") line(i:i) = " "
 !   end do
    line = "Make_"//trim(line)//".dat"
    call add_path(line)
    inquire (file = trim(line), exist = exists)
    if ( .not. exists .and. l_use_tv) then
      open (unit=15, file=trim(line), status="NEW")
      ndep = 0
      k = index(keywrd, "BCC")
      if (k /= 0) then
        keywrd(k:k + 2) = " "
        i = index(keywrd, "MERS")
        if (i /= 0) then
          j = index(keywrd(i:), " ") + i
          write(keywrd(i:j),'(a,i1,a,i1,a,i1,a)')"MERS=(", mers(1)/2, ",", mers(2)/2, ",", mers(3)/2, ")"
        end if           
      end if
      call geout (15, geo, na, nb, nc, labels, loc)
    end if
    stop
end subroutine maklay

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine outer2 (ni, nj, xi, xj, w, kr, e1b, e2a, enuc, mode, direct)
    use molkst_C, only: numcal, l1u, l2u, l3u, clower
    use parameters_C, only: natorb, tore
    use common_arrays_C, only: tvec
    implicit none
    logical, intent (in) :: direct
    integer, intent (in) :: mode, ni, nj
    integer, intent (inout) :: kr
    double precision, intent (out) :: enuc
    double precision, dimension (3), intent (in) :: xi, xj
    double precision, dimension (7), intent (inout) :: w
    double precision, dimension (45), intent (out) :: e1b, e2a
!
    logical :: si, sj
    integer :: icalcn = 0, i, j, k, ki, l
    double precision :: a, rij, rijx, w1, w2, w3, w4, w5, w6, w7, cutof2, enubit
    double precision, save :: gab
    double precision, dimension (3) :: x
    double precision, dimension (7) :: wb
    double precision, dimension (22) :: ri
    double precision, dimension(45) :: e1bits, e2bits
    save icalcn, cutof2
    if (mode == 0) then
!
!   Simple di-atomic
!
      x(1) = xi(1) - xj(1)
      x(2) = xi(2) - xj(2)
      x(3) = xi(3) - xj(3)
      rij = x(1) * x(1) + x(2) * x(2) + x(3) * x(3)
      rijx = Sqrt (rij)
      rij = rijx
!
! *** COMPUTE INTEGRALS IN DIATOMIC FRAME
!
!   The last argument should be QS if the Tomasi model is
!   supported
!
      call reppd (ni, nj, rij, ri, gab)
      a = 1.d0 / rijx
      x(1) = x(1) * a
      x(2) = x(2) * a
      x(3) = x(3) * a
      if (Abs (x(3)) > 0.99999999d0) then
        x(3) = Sign (1.d0, x(3))
      end if
      si = (natorb(ni) > 1)
      sj = (natorb(nj) > 1)
      w1 = ri(1)
      ki = 1
        e1b = 0.d0
        e2a = 0.d0
      e1b(1) = -w1 * tore(nj)
      e2a(1) = -w1 * tore(ni)
!
      if ( .not. direct) then
        w(1) = w1
      end if
      if (sj) then
        w2 = -ri(5) * x(1)
        w3 = -ri(5) * x(2)
        w4 = -ri(5) * x(3)
        e2a(2) = -w2 * tore(ni)
        e2a(3) = -w1 * tore(ni)
        e2a(4) = -w3 * tore(ni)
        e2a(6) = -w1 * tore(ni)
        e2a(7) = -w4 * tore(ni)
        e2a(10) = -w1 * tore(ni)
        if (natorb(nj) > 4) then
          e2a(15) = e2a(1)
          e2a(21) = e2a(1)
          e2a(28) = e2a(1)
          e2a(36) = e2a(1)
          e2a(45) = e2a(1)
        end if
        ki = 4
        if ( .not. direct) then
          w(2) = w2
          w(3) = w3
          w(4) = w4
        end if
      end if
!
      if (si) then
        if (sj) then
          w5 = -ri(2) * x(1)
          w6 = -ri(2) * x(2)
          w7 = -ri(2) * x(3)
          ki = 7
          e1b(2) = -w5 * tore(nj)
          e1b(3) = -w1 * tore(nj)
          e1b(4) = -w6 * tore(nj)
          e1b(6) = -w1 * tore(nj)
          e1b(7) = -w7 * tore(nj)
          e1b(10) = -w1 * tore(nj)
          if (natorb(ni) > 4) then
            e1b(15) = e1b(1)
            e1b(21) = e1b(1)
            e1b(28) = e1b(1)
            e1b(36) = e1b(1)
            e1b(45) = e1b(1)
          end if
!
          if ( .not. direct) then
            w(5) = w5
            w(6) = w6
            w(7) = w7
          end if
        else
          w2 = -ri(2) * x(1)
          w3 = -ri(2) * x(2)
          w4 = -ri(2) * x(3)
          ki = 4
          e1b(2) = -w2 * tore(nj)
          e1b(3) = -w1 * tore(nj)
          e1b(4) = -w3 * tore(nj)
          e1b(6) = -w1 * tore(nj)
          e1b(7) = -w4 * tore(nj)
          e1b(10) = -w1 * tore(nj)
          if (natorb(ni) > 4) then
            e1b(15) = e1b(1)
            e1b(21) = e1b(1)
            e1b(28) = e1b(1)
            e1b(36) = e1b(1)
            e1b(45) = e1b(1)
          end if
!
          if ( .not. direct) then
            w(2) = w2
            w(3) = w3
            w(4) = w4
          end if
        end if
      end if
      enuc = tore(ni) * tore(nj) * w1
    else
!
!   SOLID SYSTEM
!
      if (icalcn /= numcal) then
        icalcn = numcal
        cutof2 = clower**2
      end if
      do i = 1, 10
        e1b(i) = 0.d0
        e2a(i) = 0.d0
      end do
      si = (natorb(ni) > 1)
      sj = (natorb(nj) > 1)
      ki = 1
      if (si .or. sj) then
        ki = 4
      end if
      if (si .and. sj) then
        ki = 7
      end if
      do i = 1, ki
        w(i) = 0.d0
      end do
      do i = -l1u, l1u
        do j = -l2u, l2u
          do k = -l3u, l3u
            do l = 1, 3
              x(l) = xi(l) + tvec(l, 1) * i + tvec(l, 2) * j + tvec(l, 3) &
             & * k - xj(l)
            end do
            rij = x(1) * x(1) + x(2) * x(2) + x(3) * x(3)
            if (rij >  cutof2) then
!
!  Interaction distance is greater than cutoff, so use point-charge
!
              rij = sqrt(rij)
              call point(rij, ni, nj, ri, l, e1bits, e2bits, enubit)
              ri(4) = ri(1)
              ri(6) = 0.d0
            else
              rij = Sqrt (rij)
!
! *** COMPUTE INTEGRALS IN DIATOMIC FRAME
!
              call reppd (ni, nj, rij, ri, gab)
            end if
!
              a = 1.d0 / rij
              x(1) = x(1) * a
              x(2) = x(2) * a
              x(3) = x(3) * a
              if (Abs (x(3)) > 0.99999999d0) x(3) = Sign (1.d0, x(3))
              wb(1) = ri(1)
              e1b(1) = e1b(1) - wb(1) * tore(nj)
              e2a(1) = e2a(1) - wb(1) * tore(ni)
              if (sj) then
                wb(2) = -ri(5) * x(1)
                wb(3) = -ri(5) * x(2)
                wb(4) = -ri(5) * x(3)
                e2a(2) = e2a(2) - wb(2) * tore(ni)
                e2a(3) = e2a(3) - wb(1) * tore(ni)
                e2a(4) = e2a(4) - wb(3) * tore(ni)
                e2a(6) = e2a(6) - wb(1) * tore(ni)
                e2a(7) = e2a(7) - wb(4) * tore(ni)
                e2a(10) = e2a(10) - wb(1) * tore(ni)
              end if
!
              if (si) then
                if (sj) then
                  wb(5) = -ri(2) * x(1)
                  wb(6) = -ri(2) * x(2)
                  wb(7) = -ri(2) * x(3)
                  e1b(2) = e1b(2) - wb(5) * tore(nj)
                  e1b(3) = e1b(3) - wb(1) * tore(nj)
                  e1b(4) = e1b(4) - wb(6) * tore(nj)
                  e1b(6) = e1b(6) - wb(1) * tore(nj)
                  e1b(7) = e1b(7) - wb(7) * tore(nj)
                  e1b(10) = e1b(10) - wb(1) * tore(nj)
                else
                  wb(2) = -ri(2) * x(1)
                  wb(3) = -ri(2) * x(2)
                  wb(4) = -ri(2) * x(3)
                  e1b(2) = e1b(2) - wb(2) * tore(nj)
                  e1b(3) = e1b(3) - wb(1) * tore(nj)
                  e1b(4) = e1b(4) - wb(3) * tore(nj)
                  e1b(6) = e1b(6) - wb(1) * tore(nj)
                  e1b(7) = e1b(7) - wb(4) * tore(nj)
                  e1b(10) = e1b(10) - wb(1) * tore(nj)
              end if
            end if
            do l = 1, ki
              w(l) = w(l) + wb(l)
            end do
          end do
        end do
      end do
      enuc = tore(ni) * tore(nj) * w(1)
    end if
!
    if ( .not. direct) then
      if (natorb(ni)*natorb(nj) == 0) then
        ki = 0
      end if
      kr = kr + ki
    end if
end subroutine outer2

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine dfock2(f, ptot, p, w, numat, nfirst, nlast, nati)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use common_arrays_C, only : ifact, i1fact, ptot2
      use molkst_C, only : numcal, norbs, mpack
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: numat
      integer , intent(in) :: nati
      integer , intent(in) :: nfirst(numat)
      integer , intent(in) :: nlast(numat)
      double precision  :: f(mpack)
      double precision , intent(in) :: ptot(mpack)
      double precision , intent(in) :: p(mpack)
      double precision  :: w(*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: itype
      integer , dimension(256) :: jindex
      integer :: icalcn, i, m, j, ij, ji, k, ik, l, kl, lk, kk, ia, ib, jk, kj&
        , ii, jj, ja, jb, i1, j1, ll, kr, ka
      double precision, dimension(81) :: pk
      double precision, dimension(16) :: pja, pjb
      double precision :: sumdia, sumoff, sum, elrep

      save itype, icalcn, jindex
!-----------------------------------------------
!***********************************************************************
!
!     DFOCK2 ADDS THE 2-ELECTRON 2-CENTER REPULSION CONTRIBUTION TO
!     THE FOCK MATRIX DERIVATIVE WITHIN THE NDDO FORMALISMS.
!  INPUT
!     F    : 1-ELECTRON CONTRIBUTIONS DERIVATIVES.
!     PTOT : TOTAL DENSITY MATRIX.
!     P    : ALPHA OR BETA DENSITY MATRIX. = 0.5 * PTOT
!     W    : NON VANISHING TWO-ELECTRON INTEGRAL DERIVATIVES
!            (ORDERED AS DEFINED IN DHCORE).
!     NATI : # OF THE ATOM SUPPORTING THE VARYING CARTESIAN COORDINATE.
!  OUTPUT
!     F    : FOCK MATRIX DERIVATIVE WITH RESPECT TO THE CART. COORD.
!
!***********************************************************************
      data itype/ 1/
      data icalcn/ 0/
      if (icalcn /= numcal) then
        if (allocated(ifact))  deallocate(ifact)
        if (allocated(i1fact)) deallocate(i1fact)
        if (allocated(ptot2))  deallocate(ptot2)
        allocate(ifact(norbs), i1fact(norbs), ptot2(numat,81))
        icalcn = numcal
        itype = 1
      end if
   10 continue
      select case (itype)
      case default
        do i = 1, norbs
          ifact(i) = (i*(i - 1))/2
          i1fact(i) = ifact(i) + i
        end do
!
!   SET UP GATHER-SCATTER TYPE ARRAYS FOR USE WITH TWO-ELECTRON
!   INTEGRALS.  JINDEX ARE THE INDICES OF THE J-INTEGRALS FOR ATOM I
!   INTEGRALS.  JJNDEX ARE THE INDICES OF THE J-INTEGRALS FOR ATOM J
!               KINDEX ARE THE INDICES OF THE K-INTEGRALS
!
        m = 0
        do i = 1, 4
          do j = 1, 4
            ij = min(i,j)
            ji = i + j - ij
            do k = 1, 4
              ik = min(i,k)
              do l = 1, 4
                m = m + 1
                kl = min(k,l)
                lk = k + l - kl
                jindex(m) = (ifact(ji)+ij)*10 + ifact(lk) + kl - 10
              end do
            end do
          end do
        end do
          itype = 3
        go to 10
      case (3)
        kk = 0
        l = 0
        do i = 1, numat
          ia = nfirst(i)
          ib = nlast(i)
          m = 0
          do j = ia, ib
            do k = ia, ib
              m = m + 1
              jk = min(j,k)
              kj = k + j - jk
              jk = jk + (kj*(kj - 1))/2
              ptot2(i,m) = ptot(jk)
            end do
          end do
        end do
        ii = nati
        ia = nfirst(ii)
        ib = nlast(ii)
        do jj = 1, numat
          if (ii == jj) cycle
          ja = nfirst(jj)
          jb = nlast(jj)
          if (ib - ia < 0 .or. jb - ja < 0) cycle ! One atom is a sparkle
          if (ib - ia>=6 .or. jb-ja>=6) then
            call fockdorbs(ia, ib, ja, jb, f, p, ptot, w, kk, ifact)
          else if (ib - ia>=3 .and. jb-ja>=3) then
!
!                         HEAVY-ATOM  - HEAVY-ATOM
!
!   EXTRACT COULOMB TERMS
!
            pja = ptot2(ii,:16)
            pjb = ptot2(jj,:16)
!
!  COULOMB TERMS
!
            call jab (ia, ja, pja, pjb, w(kk+1), f)
!
!  EXCHANGE TERMS
!
!
!  EXTRACT INTERSECTION OF ATOMS II AND JJ IN THE SPIN DENSITY MATRIX
!
            if (ia > ja) then
              l = 0
              do i = ia, ib
                if (jb - ja + 1 > 0) then
                  pk(l+1:jb-ja+1+l) = p(ifact(i)+ja:jb+ifact(i))
                  l = jb - ja + 1 + l
                end if
              end do
            else
              l = 0
              do i = ia, ib
                if (jb - ja + 1 > 0) then
                  pk(l+1:jb-ja+1+l) = p(ifact(ja:jb)+i)
                  l = jb - ja + 1 + l
                end if
              end do
            end if
            i1 = ia
            j1 = ja
            call kab (ia, ja, pk, w(kk+1), f)
            ia = i1
            ja = j1
            kk = kk + 100
          else if (ib - ia >= 3) then
!
!                         LIGHT-ATOM  - HEAVY-ATOM
!
!
!   COULOMB TERMS
!
            sumdia = 0.D0
            sumoff = 0.D0
            ll = i1fact(ja)
            k = 0
            do i = 0, 3
              j1 = ifact(ia+i) + ia - 1
              do j = 0, i - 1
                k = k + 1
                j1 = j1 + 1
                f(j1) = f(j1) + ptot(ll)*w(kk+k)
                sumoff = sumoff + ptot(j1)*w(kk+k)
              end do
              j1 = j1 + 1
              k = k + 1
              f(j1) = f(j1) + ptot(ll)*w(kk+k)
              sumdia = sumdia + ptot(j1)*w(kk+k)
            end do
            f(ll) = f(ll) + sumoff*2.D0 + sumdia
!
!  EXCHANGE TERMS
!
!
!  EXTRACT INTERSECTION OF ATOMS II AND JJ IN THE SPIN DENSITY MATRIX
!
            if (ia > ja) then
              k = 0
              do i = ia, ib
                i1 = ifact(i) + ja
                sum = 0.D0
                do j = ia, ib
                  k = k + 1
                  j1 = ifact(j) + ja
                  sum = sum + p(j1)*w(kk+jindex(k))
                end do
                f(i1) = f(i1) - sum
              end do
            else
              k = 0
              do i = ia, ib
                i1 = ifact(ja) + i
                sum = 0.D0
                do j = ia, ib
                  k = k + 1
                  j1 = ifact(ja) + j
                  sum = sum + p(j1)*w(kk+jindex(k))
                end do
                f(i1) = f(i1) - sum
              end do
            end if
            kk = kk + 10
          else if (jb - ja >= 3) then
!
!                         HEAVY-ATOM - LIGHT-ATOM
!
!
!   COULOMB TERMS
!
            sumdia = 0.D0
            sumoff = 0.D0
            ll = i1fact(ia)
            k = 0
            do i = 0, 3
              j1 = ifact(ja+i) + ja - 1
              do j = 0, i - 1
                k = k + 1
                j1 = j1 + 1
                f(j1) = f(j1) + ptot(ll)*w(kk+k)
                sumoff = sumoff + ptot(j1)*w(kk+k)
              end do
              j1 = j1 + 1
              k = k + 1
              f(j1) = f(j1) + ptot(ll)*w(kk+k)
              sumdia = sumdia + ptot(j1)*w(kk+k)
            end do
            f(ll) = f(ll) + sumoff*2.D0 + sumdia
!
!  EXCHANGE TERMS
!
!
!  EXTRACT INTERSECTION OF ATOMS II AND JJ IN THE SPIN DENSITY MATRIX
!
            if (ia > ja) then
              k = ifact(ia) + ja
              j = 0
              do i = k, k + 3
                sum = 0.D0
                do l = k, k + 3
                  j = j + 1
                  sum = sum + p(l)*w(kk+jindex(j))
                end do
                f(i) = f(i) - sum
              end do
            else
              j = 0
              do k = ja, ja + 3
                i = ifact(k) + ia
                sum = 0.D0
                do ll = ja, ja + 3
                  l = ifact(ll) + ia
                  j = j + 1
                  sum = sum + p(l)*w(kk+jindex(j))
                end do
                f(i) = f(i) - sum
              end do
            end if
            kk = kk + 10
          else
!
!                         LIGHT-ATOM - LIGHT-ATOM
!
            i1 = i1fact(ia)
            j1 = i1fact(ja)
            f(i1) = f(i1) + ptot(j1)*w(kk+1)
            f(j1) = f(j1) + ptot(i1)*w(kk+1)
            if (ia > ja) then
              ij = i1 + ja - ia
              f(ij) = f(ij) - p(ij)*w(kk+1)
            else
              ij = j1 + ia - ja
              f(ij) = f(ij) - p(ij)*w(kk+1)
            end if
            kk = kk + 1
          end if
        end do
        return
      case (2)
        kr = 0
        ii = nati
        ia = nfirst(ii)
        ib = nlast(ii)
        do jj = 1, numat
          if (jj == ii) cycle
          kr = kr + 1
          elrep = w(kr)
          ja = nfirst(jj)
          jb = nlast(jj)
          if (ja < ia) then
            do i = ia, ib
              ka = ifact(i)
              kk = ka + i
              do k = ja, jb
                ll = i1fact(k)
                ik = ka + k
                f(kk) = f(kk) + ptot(ll)*elrep
                f(ll) = f(ll) + ptot(kk)*elrep
                f(ik) = f(ik) - p(ik)*elrep
              end do
            end do
          else
            do i = ia, ib
              ka = ifact(i)
              kk = ka + i
              do k = ja, jb
                ll = i1fact(k)
                ik = ll + i - k
                f(kk) = f(kk) + ptot(ll)*elrep
                f(ll) = f(ll) + ptot(kk)*elrep
                f(ik) = f(ik) - p(ik)*elrep
              end do
            end do
          end if
        end do
        return
      end select
      end subroutine dfock2

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine chklew (mb, numbon, l, large, debug)
!***********************************************************************
!
!   CHKLEW  identifies all the obvious Lewis structural elements such
!           as bonds, lone pairs, and ions.
!
!   On exit, NUMBON(1):  Number of sigma bonds.
!            NUMBON(2):  Number of lone pairs.
!            NUMBON(3):  Number of pi-bonds.
!
!***********************************************************************
    use molkst_C, only: natoms, numat, keywrd, norbs, line, maxtxt
    use chanel_C, only: iw
    use elemts_C, only: elemnt
    use parameters_C, only: tore, ndelec, natorb
    use common_arrays_C, only : txtatm, labels, nat, nbonds, ibonds, &
      nfirst, nlast, pibonds
    use MOZYME_C, only: icharges, ions, Lewis_elem, Lewis_tot, Lewis_max, ib, iz
    implicit none
    logical, intent (in) :: debug
    integer, intent (in) :: large
    integer, intent (out) :: l
    integer, dimension (3), intent (inout) :: numbon
    integer, dimension (numat), intent (inout) :: mb
!
    logical, external :: arom, arom2
    logical :: big, graphi, lnext, first_pi
    integer :: i, i1, i2, ii, iset, j, jj, k, loop, m, nbii, ni_loc, &
         & npi, alloc_stat, not_aromatic_pi
    character :: plus_seven*1, num1*1, num2*1
    integer, dimension(:), allocatable :: ipi, ir5, mpii
    intrinsic Index, Min, Nint
    double precision, external :: distance

!
!   Set LET to .TRUE.  At some later date, have LET defined by a keyword
!   If LET is true, then the job will not stop if there is a very large
!   number of ions.
!
    if (allocated(Lewis_elem)) deallocate(Lewis_elem)
    Lewis_max = max(norbs,1)
    allocate(Lewis_elem(2,Lewis_max))
    Lewis_tot = 0
    big = (Index (keywrd, " LARGE") /= 0)
    graphi = .false.
    first_pi = .true.
    allocate (ipi(6*numat), ir5(numat), mpii(numat), stat=alloc_stat)
    if (alloc_stat /= 0) then
      call memory_error ("chklew")
      goto 1100
    end if
    do i = 1, numat
!
!  Do not allow more than 4 bonds per atom.  Later on,
!  more can be added, if necessary.
!
      ib(i) = nlast(i) - nfirst(i) + 1
      iz(i) = Nint (tore(nat(i)))
    end do
!   Construction of the Lewis structure is based on a set of "rules",
!   These are, in order of usage:
!
! *  Every atom that is bonded to another atom forms a sigma bond to
!    that atom.
! *  The number of lone pairs on an atom is equal to the difference
!    between the number of unused valence electrons and unused orbitals.
! *  For unsaturated systems:
!    Open-ended pi-bonds are created when an atom pi-bonds to exactly
!    one other atom.
!    Pi bonds attached to open-ended pi-bonds are created next.
!    If no open-ended pi-bonds can be created, a delocalized pi-bond is
!    assigned.  Only atoms that pi-bond to exactly two other atoms are
!    involved here. Pi-bonds in five membered rings are NOT allowed, if
!    the ring is attached to one or more six-membered rings.
!
!   If any atoms have explicit charges, assign them first.
!
    j = 0
    do i = 1, natoms
      if (labels(i) /= 99) then
        j = j + 1
      end if
      plus_seven = txtatm(i)(7:7)
      txtatm(i)(7:7) = " "
      if (Index (txtatm(i)(:6), "+") /= 0) then
        icharges = icharges + 1
        iz(j) = iz(j) - 1
        ions(j) =  1
      else if (Index (txtatm(i)(:12), "-") /= 0) then
        icharges = icharges + 1
        iz(j) = iz(j) + 1
        ions(j) = -1
      end if
      txtatm(i)(7:7) = plus_seven
    end do
!
!   Fill "d" shell if necessary
!
    do i = 1, numat
      if (ib(i) /= nlast(i) - nfirst(i) + 1) then
        j = nat(i)
        if (ndelec(j) /= 0) then
!
!   NDELEC(I) is the number of "d" electrons NOT involved in the
!   Lewis structure.
!
          do k = 1, ndelec(j) / 2
            call add_Lewis_element(i,0,0, numbon(2))
          end do
        end if
      end if
    end do
!
    if (debug) then
      write (iw,*) &
           & " Arrays before making Sigma Framework (ATOM CORE ORBS BONDS)"
      j = Min (numat, large)
      do k = 1, j, 20
        l = Min (k+19, j)
        write (iw, "(20I4)") (i, i=k, l)
        write (iw, "(20I4)") (iz(i), i=k, l)
        write (iw, "(20I4)") (ib(i), i=k, l)
        write (iw, "(20I4)") (nbonds(i), i=k, l)
      end do
    end if
    numbon = 0
!
!   First set: The SIGMA bond framework
!
    do ii = 1, numat
      mb(ii) = 0
      nbii = nbonds(ii)
      do i = 1, nbii
        jj = ibonds(i, ii)
        if (jj >= ii .and. ib(ii) > 0 .and. ib(jj) > 0) then
!
! A sigma bond exists if:
!  (a) The atoms are bonded together.
!  (b) The second atom has a higher atom number than the first atom
!      (This prevents "double counting")
!  (c) Both atoms have unused atomic orbitals available
!
          call add_Lewis_element(ii,jj,0, numbon(1))
        end if
      end do
    end do
    do i = 1, numat
      if (ib(i) /= 0) go to 1000
    end do
    l = 0
    goto 1070
1000 continue
    if (debug) then
      write (iw,*) &
           & " Core charges after making Sigma Framework (ATOM CORE ORBS)"
      j = Min (numat, large)
      do k = 1, j, 20
        l = Min (k+19, j)
        write (iw, "(20I4)") (i, i=k, l)
        write (iw, "(20I4)") (iz(i), i=k, l)
        write (iw, "(20I4)") (ib(i), i=k, l)
      end do
    end if
    if (index(keywrd, " SETPI") /= 0) then
!
!  The user has supplied some pi bonds.
!
      j = 0
      do loop = 1, numat
        ii = pibonds(loop,1)
        if (ii == 0) exit
        jj = pibonds(loop,2)
        do i = 1, nbonds(ii)
          if (ibonds(i, ii) == jj) exit
        end do
        if (i > nbonds(ii)) then
          if (j == 0) write(iw, '(/10x, a)') &
            "Using ""SETPI"" a pi-bond has been defined between two atoms that are not bonded together"
          if (maxtxt == 26) then
            if (j == 0) write(iw,'(/27x, a, 27x, a)')"Atom-1", "Atom-2"
            write(iw,'(17x, a, 5x, a)')'"'//txtatm(ii)(:26)//'"', '"'//txtatm(jj)(:26)//'"'
          else
            if (j == 0) write(iw,'(/15x, a, 15x, a)')"Atom-1", "Atom-2"
            write(iw,'(14x,a2,i5, 14x,a2,i5)')elemnt(nat(ii)), ii, elemnt(nat(jj)), jj
          end if
          j = 1
        end if
        call add_Lewis_element(ii,jj,0, numbon(3))
        if (ib(ii) < 0 .or. ib(jj) < 0) then
         if (Index (keywrd, " RESEQ")+Index (keywrd, " SITE=")+Index (keywrd, " 0SCF") == 0) then
           num1 = char(ichar("2") + int(log10(ii*1.01)))
           num2 = char(ichar("2") + int(log10(jj*1.01)))
            write(line,'(a,i'//num1//',a,i'//num2//')') &
            " Impossible user-supplied pi bond between "//elemnt(nat(ii)), ii, &
            " and "//elemnt(nat(jj)), jj
            call mopend(trim(line))
            return
          end if
        end if
      end do
    end if
    if (j == 1) then
      call mopend("AN ERROR IN ASSIGNING PI-BONDS USING ""SETPI"" HAS BEEN DETECTED")
      return
    end if
!
!   Second set: Assign all lone-pairs
!
!
    l = 1
    do i = 1, numat
      if (iz(i) > ib(i)) then
        if (ib(i) > 0) then
          j = Min (ib(i), iz(i)-ib(i))
          do k = 1, j
           call add_Lewis_element(i,0,0, numbon(2))
          end do
        end if
      end if
      if (iz(i) < ib(i)) then
  !
  ! This is a "virtual" lone pair - empty orbital on an atom
  !
        if (ib(i) > 0) then
          j = ib(i) - iz(i)
          do k = 1, j
            call add_Lewis_element(0,i,0, ii) ! ii is not used here.
          end do
        end if
      end if
    end do
!
    do i = 1, numat
      if (ib(i) /= 0) go to 1010
    end do
    l = 0
    goto 1070
1010 continue
    if (debug) then
      write (iw,*) " Core charges after adding Lone Pairs (ATOM CORE ORBS)"
      j = Min (numat, large)
      do k = 1, j, 20
        l = Min (k+19, j)
        write (iw, "(20I4)") (i, i=k, l)
        write (iw, "(20I4)") (iz(i), i=k, l)
        write (iw, "(20I4)") (ib(i), i=k, l)
      end do
    end if
!
!  Third set: pi-bonds attached to five-membered rings.
!
    npi = 0
    not_aromatic_pi = 0
    do ii = 1, numat
      mpii(ii) = 0
      ir5(ii) = 0
      l = 0
      if (ib(ii) /= 0) then
        nbii = nbonds(ii)
        do i = 1, nbii
          jj = ibonds(i, ii)
          if (ib(jj) /= 0) then
            l = l + 1
          end if
        end do
      end if
      mb(ii) = l
    end do
    do i = 1, numat
      if (mb(i) > 2 .and. ir5(i) == 0) then
        call ring5 (i, mb, ir5)
      end if
    end do
    do ii = 1, numat
!
!  If NOT an atom on a five-membered ring, skip loop
!
      if (ir5(ii) /= 0) then
        nbii = nbonds(ii)
        do i = 1, nbii
          jj = ibonds(i, ii)
!
!  If the other end of the pi bond is IN the same five membered
!  ring, skip loop
!
          if (ir5(jj) /= ir5(ii)) then
            if (mb(jj) /= 0 .and. ib(jj) /= 0 .and. ib(ii) > 0) then
              iset = 1
              mb(ii) = mb(ii) - 1
              mb(jj) = mb(jj) - 1
              mpii(ii) = jj
              mpii(jj) = ii
              call add_Lewis_element(ii,jj,0, numbon(3))
              if (debug .and. big) then
                write (iw, "(A,I5,A,I5)") " PI BOND BETWEEN ATOMS", &
               & ii, " AND", jj
              end if
!
!  Store atom numbers of attached atoms that might
!  pi-bond - these have priority.
!
              npi = npi + 1
              ipi(npi) = ii
              npi = npi + 1
              ipi(npi) = jj
            end if
          end if
        end do
      end if
    end do
    do
!
!  Fourth set: pi-bonds (non-ring systems)
!
      iset = 0
      do ii = 1, numat
        l = 0
        if (ib(ii) /= 0) then
          nbii = nbonds(ii)
          do i = 1, nbii
            jj = ibonds(i, ii)
            if (ib(jj) /= 0) then
!
!  Special case: C-S-X treat S as di-valent
!
              if (nat(ii) == 6 .and. nat(jj) == 16 .and. nbonds(jj) > 1 .or. &
                nat(ii) == 16 .and. nbonds(ii) > 1.and. nat(jj) == 6) cycle
              l = l + 1
            end if
          end do
        end if
        mb(ii) = l
      end do
      if (debug) then
        write (iw,*) " Number of atoms pi bonding to each atom (MB)"
        l = Min (numat, large)
        do j = 1, l, 20
          k = Min (j+19, numat)
          write (iw, "(20I4)") (i, i=j, k)
          write (iw, "(20I4)") (mb(i), i=j, k)
        end do
      end if
!
!  If in a graphitic lattice, use rules for poly-conjugated system only.
!
      if ( .not. graphi) then
        do loop = 1, 2
!
!  Do this twice - first time start from carbon end, second time
!  start from any end.  This distinguishes C-C-C-N from N-C-C-C
!
          do i1 = 1, numat
!
!   Identify the end of a ene or polyene system
!
            if (mb(i1) == 1) then
!
!  If heteroatom at end of polyene, start from carbon end.
!
              if (loop /= 1 .or. Nint (tore(nat(i1))-4.d0) == 0) then
                ii = i1
                nbii = nbonds(ii)
                do i = 1, nbii
                  jj = ibonds(i, ii)
                  if (natorb(nat(ii)) == 9 .or. natorb(nat(jj)) == 9  ) cycle
                  if (nat(ii) == 8 .or. nat(jj) == 8) then
                    if (nat(ii) == 6 .or. nat(jj) == 6) then
                      if (distance(ii,jj) > 1.315d0) cycle  !  Exclude C-O, but keep C=O
                    end if
                  end if
                  do while (mb(jj) /=  0 .and. ib(jj) /= 0 .and. ib(ii) > 0)
                    iset = 1
                    not_aromatic_pi = not_aromatic_pi + 1
                    mb(ii) = mb(ii) - 1
                    mb(jj) = mb(jj) - 1
                    mpii(ii) = jj
                    mpii(jj) = ii
                    call add_Lewis_element(ii,jj,0, numbon(3))
                    if (debug .and. big) then
                      write (iw, "(A,I5,A,I5)") " PI BOND BETWEEN ATOMS", ii, " AND", jj
                    end if
                    npi = npi + 1
                    ipi(npi) = ii
                    npi = npi + 1
                    ipi(npi) = jj
!
!  YNE groups take precedence over ENE groups, therefore:
!
                    if (ib(ii) <= 0 .or. ib(jj) <= 0) exit
                  end do
                end do
              end if
            end if
          end do
        end do
      end if
!
!   If any pi bonds are formed, go back and see if any open-ended
!   pi systems have been uncovered.  This detects conjugated ene-yne
!   systems.
!
      if (iset /= 1) then
        do i = 1, numat
          if (ib(i) /= 0) go to 1020
        end do
        go to 1060
1020    if (debug) then
          write (iw,*) " After removing open-ended pi systems"
          write (iw,*) " Number of bonds to each atom (MB, IB)"
          l = Min (numat, large)
          do j = 1, l, 20
            k = Min (j+19, numat)
            write (iw, "(20I4)") (i, i=j, k)
            write (iw, "(20I4)") (mb(i), i=j, k)
            write (iw, "(20I4)") (ib(i), i=j, k)
          end do
          write (iw,*) " Core charges (ATOM CORE ORBS)"
          j = Min (numat, large)
          do k = 1, j, 20
            l = Min (k+19, j)
            write (iw, "(20I4)") (i, i=k, l)
            write (iw, "(20I4)") (iz(i), i=k, l)
            write (iw, "(20I4)") (ib(i), i=k, l)
          end do
        end if
!
!   Remaining Pi system: pi-systems that were attached to open-ended
!   pi-bonds.
!
        do ii = 1, numat
          l = 0
          if (ib(ii) /= 0) then
            nbii = nbonds(ii)
            do i = 1, nbii
              jj = ibonds(i, ii)
              if (ib(jj) /= 0) then
                l = l + 1
              end if
            end do
          end if
          mb(ii) = l
        end do
!
!  If there are no open-ended pi-systems left, then a ring system
!  must be opened.  The first ring to open is a ring that was attached
!  to an open-ended pi-system, and which is bonded to the least number
!  of other pi-atoms.  This should allow graphitic lattices to be
!  calculated
!
        if (first_pi) then
          not_aromatic_pi = 0
          first_pi = .false.
        end if
        l = npi
        do i = 1, npi
          ni_loc = nbonds(ipi(i))
          loop1: do j = 1, ni_loc
            k = ibonds(j, ipi(i))
            if (ib(k) /= 0) then
              do m = 1, l
                if (ipi(m) == k) cycle loop1
              end do
              l = l + 1
              ipi(l) = k
            end if
          end do loop1
        end do
        npi = l
        l = 0
        loop2: do i = 1, npi
          do j = 1, l
            if (ipi(j) == ipi(i)) cycle loop2
          end do
          if (ib(ipi(i)) /= 0) then
            l = l + 1
            ipi(l) = ipi(i)
          end if
        end do loop2
        npi = l
!
!   Now to start building graphite lattice.
!
        loop = 1
        do
          iset = 0
          do i1 = npi, 1, -1
            ii = ipi(i1)
            if (mb(ii) /= 0) then
              nbii = nbonds(ii)
              do i = 1, nbii
                jj = ibonds(i, ii)
                if (natorb(nat(ii)) == 9 .or. natorb(nat(jj)) == 9  ) cycle
                if (mb(jj) /= 0) then
                  if (ib(ii) > 0 .and. ib(jj) > 0) then

!
!   Rules of priority:  LOOP determines the order of
!   priority. LOOP=1 is Rule 1, LOOP=2 is Rule 2, etc.
!   For all bonds, the order of application of the rules
!   is 1, then 2 then 3, etc.
!
!   Rule 1.  If a six membered ring has two Pi bonds
!            already, then add a third Pi bond to make
!            it an aromatic ring.
!   Rule 2.  If a six membered ring has one Pi bond,
!            then add another Pi bond to the same ring,
!            so that Rule 1 can be used.
!   Rule 3.  Any Pi bond that can be made, is made.
!
                    if (loop == 1 .and. &
                         & arom (ii, jj, mpii) &
                         & .or. loop == 2 .and. &
                         & arom2 (ii, jj, mpii) &
                         & .or. loop == 3) then
                      iset = 1
                      mpii(ii) = jj
                      mpii(jj) = ii
                      call add_Lewis_element(ii, jj, 0, numbon(3))
!
!  Check for acetylenic bond
!
                      if (ib(ii) == 1 .and. ib(jj) == 1) then
                        call add_Lewis_element(ii, jj, 0, numbon(3))
                      end if
!
!   Atom JJ was pi-bonding.  Add JJ to list of
!   potential pi bonding atoms, and add on all
!   atoms that might pi bond to II or JJ.
!
                      npi = npi + 1
                      ipi(npi) = jj
                      graphi = .true.
                      l = npi
                      ni_loc = nbonds(ii)
                      do j = 1, ni_loc
                        k = ibonds(j, ii)
                        if (ib(k) /= 0) then
                          l = l + 1
                          ipi(l) = k
                        end if
                      end do
                      ni_loc = nbonds(jj)
                      do j = 1, ni_loc
                        k = ibonds(j, jj)
                        if (ib(k) /= 0) then
                          l = l + 1
                          ipi(l) = k
                        end if
                      end do
                      npi = l
!
! Eliminate duplicates and atoms that have already
! pi bonded
!
                      l = 0
                      loop3: do i2 = 1, npi
                        do j = 1, l
                          if (ipi(j) == ipi(i2)) cycle loop3
                        end do
                        if (ib(ipi(i2)) /= 0) then
                          l = l + 1
                          ipi(l) = ipi(i2)
                        end if
                      end do loop3
                      npi = l
                    end if
                  end if
                end if
              end do
              if (iset == 1 .and. loop /= 1) go to 1030
            end if
          end do
          loop = loop + 1
          if (loop /= 4) then
            cycle
          else
            exit
          end if
1030      loop = 1
        end do
        graphi = .false.
        npi = 0
!
!   Remaining Pi system: rings
!
!   Order of creation of pi bonds:
!   1:  Pi bonds involving atoms bonded to 2 pi bonds and which are
!       adjacent to atoms that form 3 pi bonds (pi bonds in
!       aromatic rings or pi bonds attached to aromatic rings)
!   2:  Pi bonds involving atoms bonded to 2 pi atoms and which are
!       not necessarily adjacent to 3 pi bonds.
!   3:  Any other remaining pi system.
!
        do loop = 1, 3
          do ii = 1, numat
            l = 0
            if (ib(ii) /= 0) then
              nbii = nbonds(ii)
              do i = 1, nbii
                jj = ibonds(i, ii)
                if (ib(jj) /= 0) then
                  l = l + 1
                end if
              end do
            end if
            mb(ii) = l
          end do
          do ii = 1, numat
            if (mb(ii) /= 0 .and. (mb(ii) /= 3 .or. loop >= 3)) then
              nbii = nbonds(ii)
              lnext = .false.
              do i = 1, nbii
                if (mb(ibonds(i, ii)) == 3) then
                  lnext = .true.
                end if
              end do
              lnext = (lnext .or. loop > 2)
!
!  LNEXT is TRUE if atom II is next to an atom bonded to
!  3 other atoms (bonded to a PI system?)
!
              do i = 1, nbii
                jj = ibonds(i, ii)
                if (lnext .and. mb(jj) /= 0 .and. (mb(jj) /= 3 .or. loop > 2)) then
                  if (natorb(nat(ii)) == 9 .or. natorb(nat(jj)) == 9  ) cycle
                  if (ib(ii) > 0 .and. ib(jj) > 0) go to 1040
                end if
              end do
            end if
          end do
        end do
        exit
1040    mpii(ii) = jj
        mpii(jj) = ii
        call add_Lewis_element(ii,jj,0, numbon(3))
        if (debug .and. big) then
          write (iw, "(A,I5,A,I5)") " PI BOND BETWEEN ATOMS", ii, &
               & " AND", jj
        end if
        npi = 1
        ipi(npi) = ii
        npi = npi + 1
        ipi(npi) = jj
      end if
    end do
!
!  Work out the number of aromatic carbon atoms
!
    do i = 1, numat
      if (ib(i) > 0) go to 1050
    end do
    l = 0
    goto 1070
1050 if (debug) then
      write (iw,*) " After removing closed pi systems"
      write (iw,*) " Number of bonds to each atom"
      k = Min (20, numat)
      write (iw, "(20I4)") (i, i=1, k)
      write (iw, "(20I4)") (mb(i), i=1, k)
      write (iw,*) " Core charges (ATOM CORE ORBS)"
      j = Min (numat, large)
      do k = 1, j, 20
        l = Min (k+19, j)
        write (iw, "(20I4)") (i, i=k, l)
        write (iw, "(20I4)") (iz(i), i=k, l)
        write (iw, "(20I4)") (ib(i), i=k, l)
      end do
    end if
    l = 1
    goto 1070
1060 continue
!
!  Work out the number of aromatic carbon atoms
!
    i = 0
    do j = 1, numat
      if (mpii(j) /= 0) i = i + 1
    end do
    l = 0
1070 continue
    deallocate (ipi, ir5, mpii)
1100 continue
    return
end subroutine chklew

subroutine ring5 (i, mb, ir5)
    use common_arrays_C, only : nbonds, ibonds
    use molkst_C, only : numat
    implicit none
    integer, intent (in) :: i
    integer, dimension (numat), intent (in) :: mb
    integer, dimension (numat), intent (inout) :: ir5
!
    integer :: j, j1, k, k1, l, l1, m, m1, n1, ni, nj, nk, nm
    integer :: nrings = 1
    ni = nbonds(i)
    do j1 = 1, ni
      j = ibonds(j1, i)
      if (mb(j) >= 3) then
        nj = nbonds(j)
        do k1 = j1 + 1, ni
          k = ibonds(k1, i)
          if (mb(j) >= 3) then
            nk = nbonds(k)
!
!   Atoms J and K are attached to atom I.
!   Find atoms, other than I, that are attached to J and K.
!
            do l1 = 1, nj
              l = ibonds(l1, j)
              if (l /= i) then
                if (mb(l) >= 3) then
                  do m1 = 1, nk
                    m = ibonds(m1, k)
                    if (m /= i) then
                      if (mb(m) >= 3) then
!
!  Atoms L and M are attached to J and K respectively.
!  The connectivity is thus: M-K-I-J-L.  Now, check:
! is M attached to L?
!
                        nm = nbonds(m)
                        do n1 = 1, nm
                          if (ibonds(n1, m) == l) go to 1000
                        end do
                      end if
                    end if
                  end do
                end if
              end if
            end do
          end if
        end do
      end if
    end do
    return
!
! Flag atoms I, J, K, L, and M as being members of a five-membered ring.
!
1000 nrings = nrings + 1
    ir5(i) = nrings
    ir5(j) = nrings
    ir5(k) = nrings
    ir5(l) = nrings
    ir5(m) = nrings
end subroutine ring5
logical function arom (ii, jj, mpii)
    use common_arrays_C, only : nbonds, ibonds
    use molkst_C, only : numat
    implicit none
    integer, intent (in) :: ii, jj
    integer, dimension (numat), intent (in) :: mpii
!
    integer :: i, iia, iib, j, j2, jja, jjb, jjc, ni, nj, njb
!***********************************************************************
!
!  AROM determines if the PI bond between II and JJ is part of an
!       aromatic ring.  It does this by checking to see if two other pi
!       bonds already exist in the ring.  If they do, then II and JJ
!       form the third and final pi bond.
!
!***********************************************************************
    ni = nbonds(ii)
    nj = nbonds(jj)
    do i = 1, ni
      iia = ibonds(i, ii)
      if (iia /= jj) then
        if (mpii(iia) /= 0) then
!
!  IIA is attached to II and forms a pi bond
!  IIB is a pi-bonded atom attached to IIA
!
          iib = mpii(iia)
          do j = 1, nj
            jja = ibonds(j, jj)
            if (jja /= ii) then
              if (mpii(jja) /= 0) then
!
!  JJA is attached to JJ and forms a pi bond
!  JJB is a pi-bonded atom attached to JJA
!
                jjb = mpii(jja)
                njb = nbonds(jjb)
                do j2 = 1, njb
                  jjc = ibonds(j2, jjb)
!
! Is any atom attached to JJB the same as IIB?
!
                  if (jjc == iib) then
                    arom = .true.
                    return
                  end if
                end do
              end if
            end if
          end do
        end if
      end if
    end do
    arom = .false.
end function arom
logical function arom2 (ii, jj, mpii)
    use common_arrays_C, only : nbonds, ibonds
    use molkst_C, only : numat
    implicit none
    integer, intent (in) :: ii, jj
    integer, dimension (numat), intent (in) :: mpii
    integer :: i, i1, iia, iib, iic, j, j1, jja, jjb, jjc, ni, nia, nib, nj, &
   & nja, njb
!***********************************************************************
!
!  AROM2 determines if the PI bond between II and JJ is part of an
!        aromatic ring.  It does this by detecting a second PI bond
!        in the ring, and then identifying the final PI bond.
!        The atom numbers of the final PI bond are put into II and JJ
!
!***********************************************************************
    ni = nbonds(ii)
    nj = nbonds(jj)
!
!  Was II attached to a PI bonded system?
!
    do i = 1, ni
      iia = ibonds(i, ii)
      if (iia /= jj) then
        nia = nbonds(iia)
        if (mpii(iia) /= 0) then
          iib = mpii(iia)
!
!   IIA is attached to to II
!   IIB is pi bonded to IIA
!
          nib = nbonds(iib)
          do j = 1, nj
            jja = ibonds(j, jj)
            if (jja /= ii) then
              nja = nbonds(jja)
!
!   JJA is attached to JJ
!
              do i1 = 1, nib
                iic = ibonds(i1, iib)
                do j1 = 1, nja
!
!   Is any atom attached to IIB also attached to JJA?
!
                  if (iic == ibonds(j1, jja)) then
                    arom2 = .true.
                    return
                  end if
                end do
              end do
            end if
          end do
        end if
      end if
    end do
!
!  Was JJ attached to a PI bonded system?
!
    do j = 1, nj
      jja = ibonds(j, jj)
      if (jja /= ii) then
        nja = nbonds(jja)
        if (mpii(jja) /= 0) then
          jjb = mpii(jja)
!
!   JJA is attached to to JJ
!   JJB is pi bonded to JJA
!
          njb = nbonds(jjb)
          do i = 1, ni
            iia = ibonds(i, ii)
            if (iia /= jj) then
              nia = nbonds(iia)
!
!  IIA is attached to II
!
              do j1 = 1, njb
                jjc = ibonds(j1, jjb)
                do i1 = 1, nia
!
!   Is any atom attached to JJB also attached to IIA?
!
                  if (jjc == ibonds(i1, iia)) then
                    arom2 = .true.
                    return
                  end if
                end do
              end do
            end if
          end do
        end if
      end if
    end do
    arom2 = .false.
end function arom2
subroutine add_Lewis_element(atom_i, atom_j, charge, element_type)
!
!  All the elements of the Lewis structure are stored in Lewis_elem
!  These are used in constructing the starting LMOs
!
!  atom_i : If atom_j is non-zero, atom_i is the atom number of one of the two atoms in a bond.
!  atom_i : If atom_j is zero, atom_i is the atom number of an occupied (normal) lone-pair
!           If atom_i is negative, -atom_i is the atom number of either an anion or a cation,
!           the choice is made later.
!  atom_j : If atom_i is non-zero, atom_j is the atom number of the other of the two atoms in a bond.
!  atom_j : If atom_i is zero, atom_j is the atom number of a virtual lone-pair
!  charge : The charge implied by this Lewis element (If Na virtual lone pair, then +1)
!  Element_type : Type of Lewis structural element (sigma, lone pair, pi bond, etc.)
!
  use MOZYME_C, only: ions, Lewis_elem, Lewis_tot, Lewis_max, iz, ib
  integer, intent (in) :: atom_i, atom_j, charge
  integer, intent (inout) :: element_type
  integer, dimension(:,:), allocatable :: Lewis_save
    Lewis_tot = Lewis_tot + 1
! Expand Lewis_elem buffer if maximum size is exceeded
    if (Lewis_tot > Lewis_max) then
      Lewis_max = 2*Lewis_max
      allocate(Lewis_save(2,Lewis_max))
      Lewis_save(:,:Lewis_max) = Lewis_elem(:,:Lewis_max)
      deallocate(Lewis_elem)
      allocate(Lewis_elem(2,2*Lewis_max))
      Lewis_elem(:,:Lewis_max) = Lewis_save(:,:Lewis_max)
      deallocate(Lewis_save)
      Lewis_max = 2*Lewis_max
    endif
    Lewis_elem(1,Lewis_tot) = atom_i
    Lewis_elem(2,Lewis_tot) = atom_j
    if (atom_i > 0 .and. atom_j > 0) then
!
! Diatomic bond (a line in the Lewis structure)
! Decrement both atoms by one electron and one atomic orbital
!
      iz(atom_i) = iz(atom_i) - 1
      iz(atom_j) = iz(atom_j) - 1
      ib(atom_i) = ib(atom_i) - 1
      ib(atom_j) = ib(atom_j) - 1
      element_type = element_type + 1
    else if (atom_i /= 0) then
      if (atom_i > 0) then
        if (charge == -1) then
!
! A lone pair (two dots in the Lewis structure) arising from a unit negative charge
! Decrement the atom by one electron and one atomic orbital.  The other electron
! comes from the negative charge
!
          iz(atom_i) = iz(atom_i) - 1
        else if (charge == 0) then
!
! A normal lone pair (two dots in the Lewis structure)
! Decrement the atom by two electrons and one atomic orbital.
!
          iz(atom_i) = iz(atom_i) - 2
        end if
        ib(atom_i) = ib(atom_i) - 1
        element_type = element_type + 1  ! Lone pair
      else
!
! At this point, the type is unknown, so simply decrement ib,
! and don't change iz.
!
        ib(-atom_i) = ib(-atom_i) - 1
      end if
    else
      if (charge == 2) then
!
! A virtual lone pair arising from a di-cation
! Decrement the atom by two electrons and one atomic orbital.
! (Think of Ca(++) - this is calcium after removal of two electrons
!
        iz(atom_j) = iz(atom_j) - 2
      else if (charge == 1) then
!
! A virtual lone pair arising from a cation
! Decrement the atom by one electrons and one atomic orbital.
! (Think of Na(+) - this is sodium after removal of one electron
!
        iz(atom_j) = iz(atom_j) - 1
      end if
      ib(atom_j) = ib(atom_j) - 1
    end if
    if (charge == 0) return
    ions(atom_i + atom_j) = ions(atom_i + atom_j) + charge
end subroutine add_Lewis_element

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine vecprt(a, numm)
      use molkst_C, only : numat, mozyme
      use common_arrays_C, only : nfirst, nlast, nat
      use chanel_C, only : iw
      use elemts_C, only : elemnt
      implicit none
      integer , intent(in) :: numm
      double precision , intent(inout) :: a(*)
!
! Local
!
      integer , dimension(:), allocatable :: natom
      integer :: i, jlo, jhi, l, k, numb, limit, kk, na, ll, m, ma, n
      double precision :: sumax, fact
      character :: line(21)*6, atorbs(9)*2, fmt*31
      character, dimension(:), allocatable :: itext*2, jtext*2
      save atorbs
!**********************************************************************
!
!  VECPRT PRINTS A LOWER-HALF TRIANGLE OF A SQUARE MATRIX, THE
!         LOWER-HALF TRIANGLE BEING STORED IN PACKED FORM IN THE
!         ARRAY "A"
!
! ON INPUT:
!      A      = ARRAY TO BE PRINTED
!      NUMM   = SIZE OF ARRAY TO BE PRINTED
!(REF) NUMAT  = NUMBER OF ATOMS IN THE MOLECULE (THIS IS NEEDED TO
!               DECIDE IF AN ATOMIC ARRAY OR ATOMIC ORBITAL ARRAY IS
!               TO BE PRINTED
!(REF) NAT    = LIST OF ATOMIC NUMBERS
!(REF) NFIRST = LIST OF ORBITAL COUNTERS
!(REF) NLAST  = LIST OF ORBITAL COUNTERS
!
!  NONE OF THE ARGUMENTS ARE ALTERED BY THE CALL OF VECPRT
!
!*********************************************************************
      data atorbs/ ' S', 'PX', 'PY', 'PZ', 'X2', 'XZ', 'Z2', 'YZ', 'XY'/
      l = 0
      if (mozyme) then
        call vecprt_for_MOZYME(a,numm)
        return
      end if
      numb = abs(numm)
      allocate (natom(numb), itext(numb), jtext(numb))
      sumax = 1.D0
      do i = 1, numm
        sumax = max(abs(a((i*(i+1))/2)), sumax)
      end do
      i = int(log10(sumax))
      if (i == 1 .or. i == 2) i = 0
      fact = 10.D0**(-i)
      if (abs(fact - 1.D0) > 0.001D0) then
        write (iw, '(A,F12.1)') 'Diagonal Terms should be Multiplied by', 1.D0/fact
        do i = 1, numm
          a((i*(i+1))/2) = a((i*(i+1))/2)*fact
        end do
      end if
      if (numat /= 0 .and. numat == numm) then
!
!    PRINT OVER ATOM COUNT
!
        do i = 1, numat
          itext(i) = '  '
          jtext(i) = elemnt(nat(i))
          natom(i) = i
        end do
      else
        if (numat /= 0 .and. nlast(numat) == numm) then
          do i = 1, numat
            jlo = nfirst(i)
            jhi = nlast(i)
            l = nat(i)
            k = 0
            itext(jlo:jhi) = atorbs(:jhi-jlo+1)
            jtext(jlo:jhi) = elemnt(l)
            natom(jlo:jhi) = i
          end do
        else
          do i = 1, numb
            itext(i) = '  '
            jtext(i) = '  '
            natom(i) = i
          end do
        end if
      end if
      line = '------'
      limit = (numb*(numb + 1))/2
      kk = 8
      na = 1
      if (numb > 999) then
        fmt = "(/,/,12x,10(1x,a2,1x,a2,i4,1x))"
      else
        fmt = "(/,/,13x,10(1x,a2,1x,a2,i3,2x))"
      end if
   80 continue
      ll = 0
      m = min0(numb + 1 - na, 6)
      ma = 2*m + 1
      m = na + m - 1
      write (iw, fmt) (itext(i), jtext(i), natom(i), i = na, m)
      write (iw, "(' ',21a6)") (line(k),k=1,ma)
      do i = na, numb
        ll = ll + 1
        k = (i*(i - 1))/2
        l = min0(k + m,k + i)
        k = k + na
        if (kk + ll > 50) then
          write (iw, fmt) (itext(n), jtext(n), natom(n) ,n = na, m)
          write (iw, "(' ',21a6)") (line(n),n=1,ma)
          kk = 4
          ll = 0
        end if
        write (iw, "(' ', a2, 1x, a2, i5, 10f11.6)") itext(i), jtext(i), natom(i), (a(n), n = k, l)
      end do
      if (l >= limit) go to 110
      kk = kk + ll + 4
      na = m + 1
      if (kk + numb + 1 - na <= 50) go to 80
      kk = 4
      go to 80
  110 continue
      if (abs(fact - 1.D0) > 0.001D0) then
        do i = 1, numm
          a((i*(i+1))/2) = a((i*(i+1))/2)/fact
        end do
      end if
      return
      end subroutine vecprt

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine reorth (ws)
    use molkst_C, only: numat, norbs
    use MOZYME_C, only : nvirtual, noccupied, icocc_dim, &
       & icvir_dim, cocc_dim, cvir_dim, ncf, nce, nncf, nnce, ncocc, ncvir, iorbs, &
       & icocc, icvir, cocc, cvir
    use common_arrays_C, only : nfirst
    implicit none
    double precision, dimension (norbs) :: ws
!
    integer :: i, ii, j, j1, jj, jx, loopi, loopii, alloc_stat
    double precision :: sum, sumtot
    logical, dimension (:), allocatable :: latom_loc
    integer, dimension (:), allocatable :: iused
!
    allocate (latom_loc(numat), iused(numat), stat=alloc_stat)
    if (alloc_stat /= 0) then
      call memory_error ("reorth")
      go to 1100
    end if
    sumtot = 0.d0
    do i = 1, nvirtual
      loopi = ncvir(i)
      do j = 1, numat
        latom_loc(j) = .false.
      end do
      do jj = nnce(i) + 1, nnce(i) + nce(i)
        j1 = icvir(jj)
        latom_loc(j1) = .true.
        j = nfirst(j1) - 1
        do jx = 1, iorbs(j1)
          loopi = loopi + 1
          j = j + 1
          ws(j) = cvir(loopi)
        end do
      end do
      !
      !    WS holds the LMO coefficients, in atom number order.
      !
      do ii = i + 1, nvirtual
        j1 = icvir(nnce(ii)+1)
        sum = 0.d0
        loopii = ncvir(ii)
        do jj = nnce(ii) + 1, nnce(ii) + nce(ii)
          j1 = icvir(jj)
          if (latom_loc(j1)) then
            j = nfirst(j1) - 1
            do jx = 1, iorbs(j1)
              loopii = loopii + 1
              j = j + 1
              sum = sum + ws(j) * cvir(loopii)
            end do
          else
            loopii = loopii + iorbs(j1)
          end if
        end do
        call adjvec (cvir, cvir_dim, icvir, icvir_dim, nnce, nce, nvirtual, &
             & ncvir, i, iorbs, cvir, cvir_dim, icvir, icvir_dim, nnce, &
             & nce, nvirtual, ncvir, ii, sum, iused, sumtot)
      end do
      !
      !   EVALUATE THE VIRTUAL-OCCUPIED LMO OVERLAPS
      !
      do ii = 1, noccupied
        j1 = icocc(nncf(ii)+1)
        sum = 0.d0
        loopii = ncocc(ii)
        do jj = nncf(ii) + 1, nncf(ii) + ncf(ii)
          j1 = icocc(jj)
          if (latom_loc(j1)) then
            j = nfirst(j1) - 1
            do jx = 1, iorbs(j1)
              loopii = loopii + 1
              j = j + 1
              sum = sum + ws(j) * cocc(loopii)
            end do
          else
            loopii = loopii + iorbs(j1)
          end if
        end do
        call adjvec (cvir, cvir_dim, icvir, icvir_dim, nnce, nce, nvirtual, &
             & ncvir, i, iorbs, cocc, cocc_dim, icocc, icocc_dim, nncf, &
             & ncf, noccupied, ncocc, ii, sum, iused, sumtot)
      end do
    end do
    do i = 1, noccupied
      loopi = ncocc(i)
      do j = 1, numat
        latom_loc(j) = .false.
      end do
      do jj = nncf(i) + 1, nncf(i) + ncf(i)
        j1 = icocc(jj)
        latom_loc(j1) = .true.
        j = nfirst(j1) - 1
        do jx = 1, iorbs(j1)
          loopi = loopi + 1
          j = j + 1
          ws(j) = cocc(loopi)
        end do
      end do
      !
      !    WS holds the LMO coefficients, in atom number order.
      !
      !  EVALUATE THE OCCUPIED-OCCUPIED LMO OVERLAPS
      !
      do ii = i + 1, noccupied
        j1 = icocc(nncf(ii)+1)
        sum = 0.d0
        loopii = ncocc(ii)
        do jj = nncf(ii) + 1, nncf(ii) + ncf(ii)
          j1 = icocc(jj)
          if (latom_loc(j1)) then
            j = nfirst(j1) - 1
            do jx = 1, iorbs(j1)
              loopii = loopii + 1
              j = j + 1
              sum = sum + ws(j) * cocc(loopii)
            end do
          else
            loopii = loopii + iorbs(j1)
          end if
        end do
        call adjvec (cocc, cocc_dim, icocc, icocc_dim, nncf, ncf, &
             & noccupied, ncocc, i, iorbs, cocc, cocc_dim, icocc, &
             & icocc_dim, nncf, ncf, noccupied, ncocc, ii, sum, &
			 & iused, sumtot)
      end do
    end do
    deallocate (latom_loc, iused)
1100 continue
end subroutine reorth

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine enpart()
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use common_arrays_C, only : h, p, pa, pb, nfirst, nlast, nat, &
      & coord, w, set_a, set_b
      use molkst_C, only : numat, uhf, keywrd, E_disp, E_hb, numcal, itemp_1
      use elemts_C, only : elemnt
      use chanel_C, only : iw
      USE funcon_C, only : fpc
      USE parameters_C, only : uss, upp, udd
!----------------------------------------------------------*
!
!     SUBROUTINE ENPART,  MODIFIED BY TSUNEO HIRANO 1986/6/3/
!
!----------------------------------------------------------*
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, k,ii, ia, ib, ni, j, kl, n, iminus, jj, ja, &
      jb, ka, ik, iss, nj, kinc, jap1, kc, kk, jss, l, iap1, ij, jij, jkl, &
      im,km,kik,lm, kil, kjk, i3, jm, kjl, kb, k3, jk, l3, il, jl, j3, numat1, j1, j4, &
      parts(10), nparts, iu, ju
      double precision, dimension(45) :: e1b, e2a
      double precision, dimension(:), allocatable :: w2
      double precision, allocatable, dimension(:,:) :: ea, e, ex
      double precision :: t, sum1, aa, sum, eau, eae, tone, oneii, onejj, g, &
        bb, pij, eabr, eabx, eabee, eaben, eabnn, eabrx, &
        eabe, ttwo, et
      logical :: si, sj, large
      double precision, external :: reada
!-----------------------------------------------
!--- DEFINED HERE, AND TO BE USED FOR ENPART-PRINT ONLY ---*
!--- END OF DIMENSION DEFINITION ----------------- BY TH --*
!***********************************************************************
!
! *** ENERGY PARTITIONING WITHIN THE UMNDO SCHEME
!     ROUTINE WRITTEN BY S.OLIVELLA, BARCELONA NOV. 1979.
!     EXTENDED TO AM1 AND PM3 BY JJPS.
!
!   ON INPUT UHF     = .TRUE. IF A U.H.F. CALCULATION.
!            H       = ONE-ELECTRON MATRIX.
!            pa      = ALPHA ELECTRON DENSITY.
!            pb      = BETA ELECTRON DENSITY.
!            P       = TOTAL ELECTRON DENSITY.
!            Q       = ATOM ELECTRON DENSITIES.
!
!    NOTHING IS CHANGED ON EXIT.
!
!***********************************************************************
! *** RECALCULATE THE DENSITY MATRICES IN THE UHF SCHEME
!
      allocate (ea((numat*(numat + 1))/2,2), e((numat*(numat + 1))/2,4), &
      ex((numat*(numat + 1))/2,3), w2(8100), stat = i)
      if (i /= 0) then
        write(iw,*)" A problem occurred during memory assignment in ENPART. "
        call mopend("A problem occurred during memory assignment in ENPART.")
        return
      end if
      ea = 0.d0
      if (.not.uhf) pb = pa
      large = (index(keywrd, " LARGE") /= 0)
!
! *** ONE-CENTER ENERGIES
!
      k = 0
      do ii = 1, numat
        ia = nfirst(ii)
        ib = nlast(ii)
        ni = nat(ii)
        ea(ii,1) = 0.0D0
        go to (60,40,40,40,20,20,20,20,20) ib - ia + 1
   20   continue
        t = udd(ni)
        do j = ia + 4, ib
          ea(ii,1) = ea(ii,1) + p((j*(j+1))/2)*t
        end do
   40   continue
        t = upp(ni)
        do j = ia + 1, ia + 3
          ea(ii,1) = ea(ii,1) + p((j*(j+1))/2)*t
        end do
   60   continue
        ea(ii,1) = ea(ii,1) + p((ia*(ia+1))/2)*uss(ni)
      end do
      if (large) write (iw, '(3/,10X,''TOTAL ENERGY PARTITIONING'')')
      if (large) write (iw, '(/10X,''ALL ENERGIES ARE IN ELECTRON VOLTS'')')
      kl = 0
      k = kl + 1
      kl = kl + 10
      kl = min0(kl,numat)
      do while(numat > kl)
        k = kl + 1
        kl = kl + 10
        kl = min0(kl,numat)
      end do
      eau = 0.0D0
      eae = 0.0D0
      do i = 1, numat
        eau = eau + ea(i,1)
        eae = eae + ea(i,2)
      end do
      tone = eau + eae
! *** TWO-CENTER ENERGIES
!     RESONANCE (E(N,1)) TERMS
      n = 1
      do ii = 2, numat
        e(n,1) = 0.0D0
        ia = nfirst(ii)
        ib = nlast(ii)
        iminus = ii - 1
        oneii = 1.D0
        if (nat(ii) == 102) oneii = 0.D0
        do jj = 1, iminus
          n = n + 1
          ja = nfirst(jj)
          jb = nlast(jj)
          onejj = 1.D0
          if (nat(jj) == 102) onejj = 0.D0
          e(n,1) = 0.0D0
          do i = ia, ib
            ka = (i*(i - 1))/2
            do k = ja, jb
              ik = ka + k
              e(n,1) = e(n,1) + 2.0D0*p(ik)*h(ik)*oneii*onejj
            end do
          end do
        end do
        n = n + 1
      end do
!
!
!     CORE-CORE REPULSION (E(N,2)) AND CORE-ELEC. ATTRACTION (E(N,3)).
      n = 0
      kk = 0
      outer_ii_loop: do ii = 1, numat
        ia = nfirst(ii)
        ib = nlast(ii)
        si = (ib < ia)
        ni = nat(ii)
        iss = (ia*(ia+1)) / 2
        iminus = ii - 1
        outer_jj_loop: do jj = 1, iminus
          n = n + 1
          e(n, 2) = 0.0d0
          e(n, 3) = 0.0d0
          ja = nfirst(jj)
          jb = nlast(jj)
          sj = (jb < ja)
          nj = nat(jj)
          jss = (ja*(ja+1)) / 2
!
!  Use rotate here because g, e1b, and e2a need to be re-calculated.
!
          call rotate (ni, nj, coord(1,ii), coord(1,jj), w2, i, e1b, e2a, g)
          if(w2(1) < -1.d20) return ! Dummy use of w2
          if (ib >= ia .and. jb >= ja) then
            kk = kk + 1
!
!  Calculate the nuclear-nuclear term (e(n,2).
!
            e(n, 2) = g
!
!  Calculate the electron-nuclear stabilization. (e(n,3))
!
            if (ib >= ia ) e(n, 3) =  e(n, 3) + (pa(iss) + pb(iss)) * e1b(1)
            if (jb >= ja ) e(n, 3) =  e(n, 3) + (pa(jss) + pb(jss)) * e2a(1)
          else  ! add in sparkle contribution
            e(n, 2) = g
            if (ib >= ia ) e(n, 3) =  (pa(iss) + pb(iss)) * e1b(1)
            if (jb >= ja ) e(n, 3) =  (pa(jss) + pb(jss)) * e2a(1)
          end if
!
!  Calculate the electron-nuclear stabilization. (e(n,3))
!
!
!  The s-s term has already been calculated.  Now do the
!  <ZZ|other terms>  Go along the side of the square matrix of
!  W integrals (in steps of 1).
!  Note:  The first term is the <ZZ|sz> integral.
!
          kinc = ((jb-ja+1)*(jb-ja+2)) / 2 - 1
          jap1 = ja + 1
          i = 1
          do k = jap1, jb
            kc = (k*(k-1)) / 2
            do l = ja, k
              kl = kc + l
              bb = 2.0d0
              if (k == l) then
                bb = 1.0d0
              end if
              if ( si ) then
                i = i + 1  ! Sparkle contribution to A.O. of atom j
                e(n, 3) = e(n, 3) + (pa(kl) + pb(kl)) * bb * e2a(i)
              else
                i = i + 1
                kk = kk + 1
                e(n, 3) = e(n, 3) + (pa(kl) + pb(kl)) * bb * e2a(i)
              end if
            end do
          end do
         !
         !  Calculate the electron-nuclear stabilization.
         !  The s-s term has already been calculated.  Now do the
         !  <ZZ|other terms>  Go down the side of the square matrix of
         !  W integrals (in steps of kinc+1).
         !  Note: The first term is the <sz|ZZ> integral.
         !
          iap1 = ia + 1
          l = 1
          do i = iap1, ib
            ka = (i*(i-1)) / 2
            do j = ia, i
              ij = ka + j
              aa = 2.0d0
              if (i == j) then
                aa = 1.0d0
              end if
              if ( sj ) then
                l = l + 1
                e(n, 3) = e(n, 3) +  (pa(ij) + pb(ij)) * aa * e1b(l)
              else
                l = l + 1
                kk = kk + 1
                e(n, 3) = e(n, 3) + (pa(ij) + pb(ij)) * aa * e1b(l)
               !
               !  KINC is the number of terms on a side, less 1
               !
                kk = kk + kinc
              end if
            end do
          end do
        end do outer_jj_loop
        sum1 = 0.d0
       !
       !   One-center coulomb and exchange terms for atom II.
       !
       !  F(i,j)=F(i,j)+sum(k,l)((PA(k,l)+PB(k,l))*<i,j|k,l>
       !                        -(PA(k,l)        )*<i,k|j,l>), k,l on atom II.
       !
        do i = ia, ib
          aa = 2.d0
          do j = ia, i
            if (i == j) then
              aa = 1.d0
            end if
               !
               !   'J' address in P
               !
            jij = (i*(i-1)) / 2 + j
            sum = 0.d0
            do k = ia, ib
              bb = 2.d0
              do l = ia, k
                if (k == l) then
                  bb = 1.d0
                end if
                     !
                     !   'J' address in P
                     !
                jkl = (k*(k-1)) / 2 + l
                     !
                     !   'K' addresses in P
                     !
                im = Max (i, k)
                km = Min (i, k)
                kik = (im*(im-1)) / 2 + km
                im = Max (i, l)
                lm = Min (i, l)
                kil = (im*(im-1)) / 2 + lm
                jm = Max (j, k)
                km = Min (j, k)
                kjk = (jm*(jm-1)) / 2 + km
                jm = Max (j, l)
                lm = Min (j, l)
                kjl = (jm*(jm-1)) / 2 + lm
                     !
                     !   The term itself
                     !
                kk = kk + 1
                sum = sum + aa * bb * w(kk) * ((pa(jij)+&
               & pb(jij))*(pa(jkl)+pb(jkl))-(pa(kik)*pa(kjl)+&
               & pa(kil)*pa(kjk)+pb(kik)*pb(kjl)+&
               & pb(kil)*pb(kjk))*0.5d0)
              end do
            end do
            sum1 = sum1 + sum
          end do
        end do
        ea(ii, 2) = sum1 * 0.5d0
        n = n + 1
        e(n, 2) = 0.0d0
        e(n, 3) = 0.0d0
      end do outer_ii_loop
      eau = 0.0d0
      eae = 0.0d0
      do i = 1, numat
        eau = eau + ea(i, 1)
        eae = eae + ea(i, 2)
      end do
      tone = eau + eae
!
!  Two center Coulomb and exchange terms
!
! (All indices start over)
!
      !     COULOMB (E(N,4)) AND EXCHANGE (EX(N)) TERMS
      n = 1
      ia = nfirst(1)
      ib = nlast(1)
      kk = (((ib-ia+1)*(ib-ia+2))/2) ** 2
      do ii = 2, numat
        e(n, 4) = 0.0d0
        ex(n, 1) = 0.0d0
        ia = nfirst(ii)
        ib = nlast(ii)
        iminus = ii - 1
        do jj = 1, iminus
          ja = nfirst(jj)
          jb = nlast(jj)
          n = n + 1
          e(n, 4) = 0.0d0
          ex(n, 1) = 0.0d0
          i3 = 0
          do i = ia, ib
            i3 = i3 + 1
            ka = (i*(i-1)) / 2
            j3 = 0
            do j = ia, i
              j3 = j3 + 1
              kb = (j*(j-1)) / 2
              ij = ka + j
              aa = 2.0d0
              if (i == j) then
                aa = 1.0d0
              end if
              pij = (pa(ij)+pb(ij))
              k3 = 0
              do k = ja, jb
                k3 = k3 + 1
                kc = (k*(k-1)) / 2
                ik = ka + k
                jk = kb + k
                l3 = 0
                do l = ja, k
                  l3 = l3 + 1
                  il = ka + l
                  jl = kb + l
                  kl = kc + l
                  bb = 2.0d0
                  if (k == l) then
                    bb = 1.0d0
                  end if
                  kk = kk + 1
                  g = w(kk)
                  e(n, 4) = e(n, 4) + aa * bb * g * pij * &
                 & (pa(kl)+pb(kl))
                  ex(n, 1) = ex(n, 1) - 0.5d0 * aa * bb * g * &
                 & (pa(ik)*pa(jl)+pa(il)*pa(jk)+pb(ik)*pb(jl)+&
                 & pb(il)*pb(jk))
                end do
              end do
            end do
          end do
        end do
        kk = kk + (((ib-ia+1)*(ib-ia+2))/2) ** 2
        n = n + 1
      end do
      numat1 = (numat*(numat + 1))/2
      e(numat1,:) = 0.0D0
      ex(numat1,:) = 0.0D0
!@ --------------------------*
!-----PRINT OUT ONE AND TWO CENTER ENERGIES
!
!     E(I,1):     RESONANCE ENERGY
!     E(I,2):     NUCLEAR-NUCLEAR REPULSION ENERGY
!     E(I,3):     ELECTRON-NUCLEAR ATTRACTION ENERGY
!     E(I,4):     ELECTRON-ELECTRON REPULSION ENERGY
!     EX(I,1):    EXCHANGE  ENERGY
!     EX(I,2):    EXCHANGE + RESONANCE ENERGY
      ex(:numat1,2) = e(:numat1,1) + ex(:numat1,1)
!
!   ADD IN MONOCENTRIC EXCHANGE AND COULOMBIC TERM
!
      do i = 1, numat
        ex((i*(i+1))/2,2) = ea(i,2)
      end do
!
!
      do i = 1, numat
        e((i*(i+1))/2,3) = ea(i,1)
      end do
!
!
      ex(:numat1,3) = e(:numat1,4) + e(:numat1,3) + e(:numat1,2)
!     PRINT OUT OF TOTAL COULOMB TERM
!     PRINT OUT OF TWO-CENTER SUM(OFF-DIAGONAL) +
!                  ONE-CENTER SUM(DIAGONAL).
      if (large) then
        write (iw, '(/,8(10X,A,/))') '  ONE-CENTER TERMS ', &
          'E-E:  ELECTRON-ELECTRON REPULSION', &
          'E-N:  ELECTRON-NUCLEAR ATTRACTION'
        write (iw, '(/,''   ATOM      E-E       E-N    (E-E + E-N)'')')
        do i = 1, numat
          j = (i*(i + 1))/2
          write (iw, '(2X,A2,I4,1X,2F10.4,F10.4)') &
          elemnt(nat(i)), i, ex(j,2), e(j,3), ex(j,2) + e(j,3)
        end do
        write (iw, '(/,8(10X,A,/))') '    TWO-CENTER TERMS', ' ', &
          'J:   RESONANCE ENERGY          E-E: ELECTRON-ELECTRON REPULSION', &
          'K:   EXCHANGE ENERGY           E-N: ELECTRON-NUCLEAR ATTRACTION', &
          '                               N-N: NUCLEAR-NUCLEAR REPULSION', &
          'C:   COULOMBIC INTERACTION = E-E + E-N + N-N', &
          'EE:  TOTAL OF ELECTRONIC AND NUCLEAR ENERGIES'
        write (iw, &
        '(/,''     ATOM          J        K       E-E       E-N      N-N      C        EE'')')
        write (iw, '(''     PAIR'')')
        ij = 0
        do i = 1, numat
          if (i<6 .or. i==numat) then
            do j = 1, i
              ij = ij + 1
              if (i /= j) then
                write (iw, &
        '(1X,A2,I5,1X,A2,I5,1X,2F9.4,F9.4,F10.4,F9.4,F8.4,F9.4)') elemnt(nat(i)), i, &
         elemnt(nat(j)), j, e(ij,1), ex(ij,1), e(ij,4), e(ij,3), &
         e(ij,2), ex(ij,3), ex(ij,2) + ex(ij,3)
              else
                write (iw, *)
              end if
            end do
          else
            do j = 1, i
              ij = ij + 1
              if (i /= j) then
                write (iw, &
        '(1X,A2,I5,1X,A2,I5,1X,2F9.4,F9.4,F10.4,F9.4,F8.4,F9.4)') elemnt(nat(i)), i, &
        elemnt(nat(j)), j, e(ij,1), ex(ij,1), e(ij,4), e(ij,3), e(ij,2), ex(ij,3), ex(ij,2) + ex(ij,3)
              else
                write (iw, &
        '(/,''   ATOM          J        K       E-E       E-N      N-N      C        EE'')')
                write (iw, '(''   PAIR'')')
              end if
            end do
          end if
        end do
      else
        write(iw,'(/12x,a)')"For more detail of energy partitioning, add keyword 'LARGE'"
      end if
!
!  If the system is to be split into parts, do so now.
!
      if (index(keywrd,"ENPART(") /= 0) then
        i = index(keywrd,"ENPART(")
        j = index(keywrd(i:),")") + i - 1
        keywrd(j:j) = ","
        k = 0
        do nparts = 1,10
           parts(nparts) = nint(reada(keywrd,i)) + k
           k = parts(nparts)
           i = index(keywrd(i + 1:),",") + i
           if (i >= j) exit
        end do
        if (k > numat) then
          write(iw,"(a)")"  Number of atoms in parts exceeds total number of atoms"
          write(iw,"(a,i5)")"  Number of atoms in parts:", k
          write(iw,"(a,i5)")"  Number of atoms:         ", numat
        end if
        keywrd(j:j) = ")"
        if (k <= numat) then
          write(iw,"(/,11x,a,i1,a)")" In the energy partitioning, the system is to be split into ",nparts, " parts"
          write(iw,"(15x,a)")" Part     No. of atoms     Atoms"
          k = 0
          do i = 1, nparts
            write(iw,"(16x,i3,i12,i10,' to',i4)")i, parts(i) - k, k + 1, parts(i)
            k = parts(i)
          end do
          if (allocated(set_a))  deallocate(set_a)
          if (allocated(set_b))  deallocate(set_b)
          allocate (set_a(numat), set_b(numat))   ! two fragments
          write(iw,'(40x,a,10x,a)')"     Contribution from:    H-bonds    +  Dispersion   =   Total"
          il = 1
          do nparts  = 1, nparts
            iu = parts(nparts)
!
!  Evaluate hydrogen bonding and dispersion contributions
!  First set: atoms il - iu, second part: jl - ju
!
              itemp_1 =  -99
              set_a = 0
              set_b = 0
              j = 0
              do i = il, iu
                j = j + 1
                set_a(j) = i
                set_b(j) = i
              end do
              numcal = numcal + 1
              call post_scf_corrections(sum, .false.)
!
!   Calculate energy term due to the part
!
            sum = 0.d0
            do i = il, iu
              k = (i*(i-1))/2 + il - 1
              do j = il, i - 1
                k = k + 1
                sum = sum + ex(k,2) + ex(k,3)
              end do
              k = k + 1
              sum = sum + ex(k,2) + e(k,3)
            end do
            write(iw,"(a,i1,a,f14.4,' eV =',f13.3,' Kcal/mol', f10.3, f16.3,f15.3,a)") &
            " Part ", nparts," self - energy:",sum, sum*fpc(9), E_hb, E_disp, E_disp + E_hb, " Kcal/mol"
!
!  Calculate energy term due to interaction of parts
!
            jl = 1
            do l = 1, nparts - 1
              ju = parts(l)
              sum = 0.d0
              do i = il, iu
                k = (i*(i - 1))/2 + jl - 1
                do j = jl, ju
                  k = k + 1
                  sum = sum + ex(k,2) + ex(k,3)
                end do
              end do
!
!  Evaluate hydrogen bonding and dispersion contributions
!  First set: atoms il - iu, second part: jl - ju
!
              itemp_1 =  -99
              set_a = 0
              set_b = 0
              j = 0
              do i = il, iu
                j = j + 1
                set_a(j) = i
              end do
              j = 0
              do i = jl, ju
                j = j + 1
                set_b(j) = i
              end do
              numcal = numcal + 1
              call post_scf_corrections(aa, .false.)
              write(iw,"(a,i1,a,i1,a,f11.4,' eV =',f13.3,' Kcal/mol', f10.3, f16.3,f15.3,a )") &
              " Parts ", nparts, " - ",l," interaction:",sum, sum*fpc(9), E_hb, E_disp, E_disp + E_hb, " Kcal/mol"
              jl = ju + 1
            end do
            il = iu + 1
          end do
        end if
      end if
      itemp_1 =  0
      numcal = numcal + 1
      call post_scf_corrections(sum, .false.)
      write(iw,'(/,a, f10.3, a,f9.3,a,f10.3,a,/)') &
        "                    Total contribution from hydrogen bonds:    ", &
        E_hb," disp.:",E_disp," Tot:",E_disp + E_hb," kcal/mol"

!
!     ++++   TOTALS   ++++
!
      eabr = 0.0D0
      eabx = 0.0D0
      eabee = 0.0D0
      eaben = 0.0D0
      eabnn = 0.0D0
      e((/(j1,j1=1,numat)/)*(/(j4,j4=2,numat+1)/)/2,3) = 0.D0
      do i = 1, numat1
        eabr = eabr + e(i,1)
        eabx = eabx + ex(i,1)
        eabee = eabee + e(i,4)
        eaben = eaben + e(i,3)
        eabnn = eabnn + e(i,2)
      end do
      eabrx = eabr + eabx
      eabe = eabee + eaben + eabnn
      ttwo = eabrx + eabe
      et = tone + ttwo
!@ ***************************************************************
      write (iw, 450)
  450 format(/,/,/,'***  SUMMARY OF ENERGY PARTITION  ***')
      write (iw, 460)
  460 format(' ','---------------------------------------')
      write (iw, '(''     ONE-CENTER TERMS'')')
      write (iw, 470) eau
  470 format(/,' ELECTRON-NUCLEAR  (ONE-ELECTRON) ',f17.4,' EV')
      write (iw, 480) eae
  480 format(' ELECTRON-ELECTRON (TWO-ELECTRON) ',f17.4,' EV')
      write (iw, 490) tone
  490 format(/,' TOTAL OF ONE-CENTER TERMS ',9x,f15.4,' EV')
      write (iw, 460)
      write (iw, '(''     TWO-CENTER TERMS'')')
      write (iw, 500) eabr
  500 format(/,' RESONANCE ENERGY',19x,f15.4,' EV')
      write (iw, 510) eabx
  510 format(' EXCHANGE ENERGY ',19x,f15.4,' EV')
      write (iw, 520) eabrx
  520 format(/,' EXCHANGE + RESONANCE ENERGY:       ',f15.4,' EV')
      write (iw, 530) eabee
  530 format(/,' ELECTRON-ELECTRON REPULSION',f23.4,' EV')
      write (iw, 540) eaben
  540 format(' ELECTRON-NUCLEAR ATTRACTION',f23.4,' EV')
      write (iw, 550) eabnn
  550 format(' NUCLEAR-NUCLEAR REPULSION  ',f23.4,' EV')
      write (iw, 560) eabe
  560 format(/,' TOTAL ELECTROSTATIC INTERACTION ',f18.4,' EV',/)
      write (iw, 570) ttwo
  570 format(' GRAND TOTAL OF TWO-CENTER TERMS',f19.4,' EV')
      write (iw, 460)
      write (iw, 580) et
  580 format(' ETOT (EONE + ETWO) ',14x,f17.4,' EV'/,/)
      deallocate (ea, e, ex, w2)
      return
      end subroutine enpart

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

! ---------------------------------------------------------------------------------------
      subroutine mult_symm_AB(a, b, alpha, ndim, mdim, c, beta, iopc)

!        Use mod_vars_cuda, only: ngpus
        Use iso_c_binding
#ifdef GPU
        Use call_gemm_cublas
        Use mamult_cuda_i
        use common_arrays_C, only : ifact
#endif
        implicit none
        Integer :: iopc,ndim,mdim
        Integer :: i
#ifdef GPU
        integer :: igrid, iblock
        real :: tt
#endif
#if CC12
        real(c_float), dimension(mdim) :: a, b, c
#else
        real(c_double), dimension(mdim) :: a, b, c
#endif
        double precision, allocatable, dimension(:,:) :: xa, xb, xc

        double precision :: alpha,beta

        continue

! here, performs matrix multiplications

        Select case (iopc)

          case (1) ! mamult
            call mamult (a, b, c, ndim, beta)
#ifdef GPU
          case (2) ! mamult_gpu
            igrid = 512 ; iblock = 512
            tt = 0.0
            call mamult_gpu(a, b, c, ndim, mdim, ifact, beta, igrid, iblock, tt, 0)
#endif
          case (3) ! dgemm
            allocate (xa(ndim,ndim), xb(ndim,ndim), xc(ndim,ndim),stat=i)

!            forall (i=1:ndim,j=1:ndim)
!              xa(i,j) = 0.d0
!              xb(i,j) = 0.d0
!            endforall

            call dtpttr( 'u', ndim, a, xa, ndim, i )
            if (i /= 0) stop 'error in dtpttr'

            call dtpttr( 'u', ndim, b, xb, ndim, i )
            if (i /= 0) stop 'error in dtpttr'

            do i = 1,ndim-1
               call dcopy(ndim-i,xa(i,i+1),ndim,xa(i+1,i),1)
               call dcopy(ndim-i,xb(i,i+1),ndim,xb(i+1,i),1)
            end do

            if (.not.(beta == 0.d0)) then
!              forall (i=1:ndim,j=1:ndim)
!                xc(i,j) = 0.d0
!              endforall

              call dtpttr( 'u', ndim, c, xc, ndim, i )
              if (i /= 0) stop 'error in dtpttr'
              do i = 1,ndim-1
                 call dcopy(ndim-i,xc(i,i+1),ndim,xc(i+1,i),1)
              end do
            end if

            call dgemm ("N", "N", ndim, ndim, ndim, alpha, xa, ndim, xb, ndim, beta, xc, &
                       & ndim)

            call dtrttp('u', ndim, xc, ndim, c, i )

            deallocate (xa,xb,xc,stat=i)

#ifdef GPU
          case (4) ! dgemm_gpu

            allocate (xa(ndim,ndim), xb(ndim,ndim), xc(ndim,ndim),stat=i)

!            forall (i=1:ndim,j=1:ndim)
!              xa(i,j) = 0.d0
!              xb(i,j) = 0.d0
!            endforall

            call dtpttr( 'u', ndim, a, xa, ndim, i )
            if (i /= 0) stop 'error in dtpttr'

            call dtpttr( 'u', ndim, b, xb, ndim, i )
            if (i /= 0) stop 'error in dtpttr'

            do i = 1,ndim-1
               call dcopy(ndim-i,xa(i,i+1),ndim,xa(i+1,i),1)
               call dcopy(ndim-i,xb(i,i+1),ndim,xb(i+1,i),1)
            end do

            if (beta /= 0.d0) then
!              forall (i=1:ndim,j=1:ndim)
!                xc(i,j) = 0.d0
!              endforall

              call dtpttr( 'u', ndim, c, xc, ndim, i )
              if (i /= 0) stop 'error in dtpttr'
              do i = 1,ndim-1
                 call dcopy(ndim-i,xc(i,i+1),ndim,xc(i+1,i),1)
              end do
            end if

!            if (ngpus > 1 .and. ndim > 100) then
!
!               call gemm_cublas_mgpu ("N", "N", ndim, ndim, ndim, alpha, xa, ndim, xb, ndim, beta, xc, &
!                           & ndim)
!
!            else
               call gemm_cublas ("N", "N", ndim, ndim, ndim, alpha, xa, ndim, xb, ndim, beta, xc, &
                           & ndim)

!            end if

            call dtrttp('u', ndim, xc, ndim, c, i )

            deallocate (xa,xb,xc,stat=i)
#endif
        end select

        continue

      return
      end subroutine mult_symm_AB

! ---------------------------------------------------------------------------------------

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

! Diskless/stateless Application Programming Interface (API) to core MOPAC operations
submodule (mopac_api) mopac_api_createdestroy
  implicit none

#ifdef MOPAC_API_CC
  interface
    function malloc(num) bind(c)
      use iso_c_binding
      integer(c_size_t), value :: num
      type(c_ptr) :: malloc
    end function malloc
    subroutine free(ptr) bind(c)
      use iso_c_binding
      type(c_ptr), value :: ptr
    end subroutine free
  end interface
#endif

contains

  ! allocate memory for mopac_state
  module subroutine create_mopac_state(state) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: create_mopac_state
#endif
    type(mopac_state), intent(inout) :: state
    if (state%mpack /= 0) then
      state%pa = create_real(state%mpack)
      if (state%uhf == 1) state%pb = create_real(state%mpack)
    end if
  end subroutine create_mopac_state

  ! allocate memory for mozyme_state
  module subroutine create_mozyme_state(state) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: create_mozyme_state
#endif
    type(mozyme_state), intent(inout) :: state
    if (state%numat /= 0) then
      state%nbonds = create_int(state%numat)
      state%ibonds = create_int2(9,state%numat)
      state%iorbs = create_int(state%numat)
      state%ncf = create_int(state%noccupied)
      state%nce = create_int(state%nvirtual)
      state%icocc = create_int(state%icocc_dim)
      state%icvir = create_int(state%icvir_dim)
      state%cocc = create_real(state%cocc_dim)
      state%cvir = create_real(state%cvir_dim)
    end if
  end subroutine create_mozyme_state

  ! deallocate memory in mopac_properties
  module subroutine destroy_mopac_properties(properties) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: destroy_mopac_properties
#endif
    type(mopac_properties), intent(in) :: properties
    integer :: i
    type(c_ptr), pointer :: pptr(:)
    call destroy_real(properties%charge)
    call destroy_int(properties%bond_index)
    call destroy_int(properties%bond_atom)
    call destroy_real(properties%bond_order)
    call destroy_real(properties%coord_update)
    call destroy_real(properties%coord_deriv)
    call destroy_real(properties%freq)
    call destroy_real(properties%disp)
    call destroy_real(properties%lattice_update)
    call destroy_real(properties%lattice_deriv)
    if (properties%nerror > 0) then
      call c_f_pointer(properties%error_msg, pptr, [properties%nerror])
      do i=1, properties%nerror
        call destroy_char(pptr(i))
      end do
      call destroy_ptr(properties%error_msg)
    end if
  end subroutine destroy_mopac_properties

  ! deallocate memory in mopac_state
  module subroutine destroy_mopac_state(state) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: destroy_mopac_state
#endif
    type(mopac_state), intent(in) :: state
    if (state%mpack /= 0) then
      call destroy_real(state%pa)
      if (state%uhf == 1) call destroy_real(state%pb)
    end if
  end subroutine destroy_mopac_state

  ! deallocate memory in mozyme_state
  module subroutine destroy_mozyme_state(state) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: destroy_mozyme_state
#endif
    type(mozyme_state), intent(in) :: state
    if (state%numat /= 0) then
      call destroy_int(state%nbonds)
      call destroy_int(state%ibonds)
      call destroy_int(state%iorbs)
      call destroy_int(state%ncf)
      call destroy_int(state%nce)
      call destroy_int(state%icocc)
      call destroy_int(state%icvir)
      call destroy_real(state%cocc)
      call destroy_real(state%cvir)
    end if
  end subroutine destroy_mozyme_state

  ! Unfortunately, the Intel Fortran compiler does not adhere to the Fortran standard for pointers.
  ! Memory allocated to a Fortran pointer erroneously cannot be deallocated if its memory is passed
  ! through a C pointer in a C-bound interface and then reassigned to a Fortran pointer because hidden
  ! information about memory allocation is contained within the original Fortran pointer and is not
  ! retained by the C pointer. To get around this, MOPAC's API will support both C and Fortran memory
  ! managers through the presence/absence of the MOPAC_API_CC and MOPAC_API_IFORT preprocessor variables.
  ! The MOPAC_API_IFORT variable uses ifort's custom malloc/free intrinsics, whereas MOPAC_API_CC uses
  ! malloc/free from the C standard library.

  ! allocate memory (C or Fortran memory manager, depending on compiler)
  module function create_int(size)
    integer, intent(in) :: size
    type(c_ptr) :: create_int
#ifdef MOPAC_API_CC
    integer(c_int) :: mold
    create_int = malloc(c_sizeof(mold)*size)
#elif defined(MOPAC_API_IFORT)
    integer(c_intptr_t) :: dummy
    integer(c_int) :: mold
    dummy = malloc(c_sizeof(mold)*size)
    create_int = transfer(dummy, create_int)
#else
    integer(c_int), pointer :: ptr(:)
    integer :: status
    allocate(ptr(size), stat=status)
    if (status /= 0) then
      write(*,*) "ERROR: Failed to allocate memory in MOPAC API I/O"
      stop 1
    end if
    create_int = c_loc(ptr)
#endif
  end function create_int
  module function create_int2(size, size2)
    integer, intent(in) :: size
    integer, intent(in) :: size2
    type(c_ptr) :: create_int2
#ifdef MOPAC_API_CC
    integer(c_int) :: mold
    create_int2 = malloc(c_sizeof(mold)*size*size2)
#elif defined(MOPAC_API_IFORT)
    integer(c_intptr_t) :: dummy
    integer(c_int) :: mold
    dummy = malloc(c_sizeof(mold)*size*size2)
    create_int2 = transfer(dummy, create_int2)
#else
    integer(c_int), pointer :: ptr(:,:)
    integer :: status
    allocate(ptr(size,size2), stat=status)
    if (status /= 0) then
      write(*,*) "ERROR: Failed to allocate memory in MOPAC API I/O"
      stop 1
    end if
    create_int2 = c_loc(ptr)
#endif
  end function create_int2
  module function create_real(size)
    integer, intent(in) :: size
    type(c_ptr) :: create_real
#ifdef MOPAC_API_CC
    real(c_double) :: mold
    create_real = malloc(c_sizeof(mold)*size)
#elif defined(MOPAC_API_IFORT)
    integer(c_intptr_t) :: dummy
    real(c_double) :: mold
    dummy = malloc(c_sizeof(mold)*size)
    create_real = transfer(dummy, create_real)
#else
    real(c_double), pointer :: ptr(:)
    integer :: status
    allocate(ptr(size), stat=status)
    if (status /= 0) then
      write(*,*) "ERROR: Failed to allocate memory in MOPAC API I/O"
      stop 1
    end if
    create_real = c_loc(ptr)
#endif
  end function create_real

  ! allocate memory & copy data (C or Fortran memory manager, depending on compiler)
  module function create_copy_int(array, size)
    integer, intent(in) :: array(:)
    integer, intent(in) :: size(1)
    type(c_ptr) :: create_copy_int
    integer(c_int), pointer :: ptr(:)
#ifdef MOPAC_API_CC
    integer(c_int) :: mold
    create_copy_int = malloc(c_sizeof(mold)*size(1))
    call c_f_pointer(create_copy_int, ptr, size)
#elif defined(MOPAC_API_IFORT)
    integer(c_intptr_t) :: dummy
    integer(c_int) :: mold
    dummy = malloc(c_sizeof(mold)*size(1))
    create_copy_int = transfer(dummy, create_copy_int)
    call c_f_pointer(create_copy_int, ptr, size)
#else
    integer :: status
    allocate(ptr(size(1)), stat=status)
    if (status /= 0) then
      write(*,*) "ERROR: Failed to allocate memory in MOPAC API I/O"
      stop 1
    end if
    create_copy_int = c_loc(ptr)
#endif
    ptr = array(:size(1))
  end function create_copy_int
  module function create_copy_int2(array, size)
    integer, intent(in) :: array(:,:)
    integer, intent(in) :: size(2)
    type(c_ptr) :: create_copy_int2
    integer(c_int), pointer :: ptr(:,:)
#ifdef MOPAC_API_CC
    integer(c_int) :: mold
    create_copy_int2 = malloc(c_sizeof(mold)*size(1)*size(2))
    call c_f_pointer(create_copy_int2, ptr, size)
#elif defined(MOPAC_API_IFORT)
    integer(c_intptr_t) :: dummy
    integer(c_int) :: mold
    dummy = malloc(c_sizeof(mold)*size(1)*size(2))
    create_copy_int2 = transfer(dummy, create_copy_int2)
    call c_f_pointer(create_copy_int2, ptr, size)
#else
    integer :: status
    allocate(ptr(size(1),size(2)), stat=status)
    if (status /= 0) then
      write(*,*) "ERROR: Failed to allocate memory in MOPAC API I/O"
      stop 1
    end if
    create_copy_int2 = c_loc(ptr)
#endif
    ptr = array(:size(1),:size(2))
  end function create_copy_int2
  module function create_copy_real(array, size)
    double precision, intent(in) :: array(:)
    integer, intent(in) :: size(1)
    type(c_ptr) :: create_copy_real
    real(c_double), pointer :: ptr(:)
#ifdef MOPAC_API_CC
    real(c_double) :: mold
    create_copy_real = malloc(c_sizeof(mold)*size(1))
    call c_f_pointer(create_copy_real, ptr, size)
#elif defined(MOPAC_API_IFORT)
    integer(c_intptr_t) :: dummy
    real(c_double) :: mold
    dummy = malloc(c_sizeof(mold)*size(1))
    create_copy_real = transfer(dummy, create_copy_real)
    call c_f_pointer(create_copy_real, ptr, size)
#else
    integer :: status
    allocate(ptr(size(1)), stat=status)
    if (status /= 0) then
      write(*,*) "ERROR: Failed to allocate memory in MOPAC API I/O"
      stop 1
    end if
    create_copy_real = c_loc(ptr)
#endif
    ptr = array(:size(1))
  end function create_copy_real
  module function create_copy_char(array, size)
    character(len=*), intent(in) :: array
    integer, intent(in) :: size(1)
    type(c_ptr) :: create_copy_char
    character(kind=c_char), pointer :: ptr(:)
    integer :: i
#ifdef MOPAC_API_CC
    character(kind=c_char) :: mold
    create_copy_char = malloc(c_sizeof(mold)*size(1))
    call c_f_pointer(create_copy_char, ptr, size)
#elif defined(MOPAC_API_IFORT)
    integer(c_intptr_t) :: dummy
    character(kind=c_char) :: mold
    dummy = malloc(c_sizeof(mold)*size(1))
    create_copy_char = transfer(dummy, create_copy_char)
    call c_f_pointer(create_copy_char, ptr, size)
#else
    integer :: status
    allocate(ptr(size(1)), stat=status)
    if (status /= 0) then
      write(*,*) "ERROR: Failed to allocate memory in MOPAC API I/O"
      stop 1
    end if
    create_copy_char = c_loc(ptr)
#endif
    do i=1, size(1)-1
      ptr(i) = array(i:i)
    end do
    ptr(size(1)) = c_null_char
  end function create_copy_char
  module function create_copy_ptr(array, size)
    type(c_ptr), intent(in) :: array(:)
    integer, intent(in) :: size(1)
    type(c_ptr) :: create_copy_ptr
    type(c_ptr), pointer :: ptr(:)
#ifdef MOPAC_API_CC
    type(c_ptr) :: mold
    create_copy_ptr = malloc(c_sizeof(mold)*size(1))
    call c_f_pointer(create_copy_ptr, ptr, size)
#elif defined(MOPAC_API_IFORT)
    integer(c_intptr_t) :: dummy
    type(c_ptr) :: mold
    dummy = malloc(c_sizeof(mold)*size(1))
    create_copy_ptr = transfer(dummy, create_copy_ptr)
    call c_f_pointer(create_copy_ptr, ptr, size)
#else
    integer :: status
    allocate(ptr(size(1)), stat=status)
    if (status /= 0) then
      write(*,*) "ERROR: Failed to allocate memory in MOPAC API I/O"
      stop 1
    end if
    create_copy_ptr = c_loc(ptr)
#endif
    ptr = array(:size(1))
  end function create_copy_ptr

  ! deallocate memory (C or Fortran memory manager, depending on compiler)
  module subroutine destroy_int(copy)
    type(c_ptr), intent(in) :: copy
#ifdef MOPAC_API_CC
    call free(copy)
#elif defined(MOPAC_API_IFORT)
    integer(c_intptr_t) :: copy2
    copy2 = transfer(copy, copy2)
    call free(copy2)
#else
    integer(c_int), pointer :: ptr
    integer :: status
    if (c_associated(copy)) then
      call c_f_pointer(copy, ptr)
      deallocate(ptr, stat=status)
      if (status /= 0) then
        write(*,*) "ERROR: Failed to deallocate memory in MOPAC API I/O"
        stop 1
      end if
    end if
#endif
  end subroutine destroy_int
  module subroutine destroy_real(copy)
    type(c_ptr), intent(in) :: copy
#ifdef MOPAC_API_CC
    call free(copy)
#elif defined(MOPAC_API_IFORT)
    integer(c_intptr_t) :: copy2
    copy2 = transfer(copy, copy2)
    call free(copy2)
#else
    real(c_double), pointer :: ptr
    integer :: status
    if (c_associated(copy)) then
      call c_f_pointer(copy, ptr)
      deallocate(ptr, stat=status)
      if (status /= 0) then
        write(*,*) "ERROR: Failed to deallocate memory in MOPAC API I/O"
        stop 1
      end if
    end if
#endif
  end subroutine destroy_real
  module subroutine destroy_char(copy)
    type(c_ptr), intent(in) :: copy
#ifdef MOPAC_API_CC
    call free(copy)
#elif defined(MOPAC_API_IFORT)
    integer(c_intptr_t) :: copy2
    copy2 = transfer(copy, copy2)
    call free(copy2)
#else
    character(kind=c_char), pointer :: ptr
    integer :: status
    if (c_associated(copy)) then
      call c_f_pointer(copy, ptr)
      deallocate(ptr, stat=status)
      if (status /= 0) then
        write(*,*) "ERROR: Failed to deallocate memory in MOPAC API I/O"
        stop 1
      end if
    end if
#endif
  end subroutine destroy_char
  module subroutine destroy_ptr(copy)
    type(c_ptr), intent(in) :: copy
#ifdef MOPAC_API_CC
    call free(copy)
#elif defined(MOPAC_API_IFORT)
    integer(c_intptr_t) :: copy2
    copy2 = transfer(copy, copy2)
    call free(copy2)
#else
    type(c_ptr), pointer :: ptr
    integer :: status
    if (c_associated(copy)) then
      call c_f_pointer(copy, ptr)
      deallocate(ptr, stat=status)
      if (status /= 0) then
        write(*,*) "ERROR: Failed to deallocate memory in MOPAC API I/O"
        stop 1
      end if
    end if
#endif
  end subroutine destroy_ptr

end submodule mopac_api_createdestroy

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine mat33(a, b, c)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!  A subroutine that will multiply two 3 by 3 matricies in the following
!     fashion:    C = A(transpose) B A
!
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision , intent(in) :: a(9)
      double precision , intent(in) :: b(9)
      double precision , intent(out) :: c(9)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      double precision, dimension(9) :: t
!-----------------------------------------------
!
!
      t(1) = b(1)*a(1) + b(2)*a(4) + b(3)*a(7)
      t(2) = b(1)*a(2) + b(2)*a(5) + b(3)*a(8)
      t(3) = b(1)*a(3) + b(2)*a(6) + b(3)*a(9)
      t(4) = b(4)*a(1) + b(5)*a(4) + b(6)*a(7)
      t(5) = b(4)*a(2) + b(5)*a(5) + b(6)*a(8)
      t(6) = b(4)*a(3) + b(5)*a(6) + b(6)*a(9)
      t(7) = b(7)*a(1) + b(8)*a(4) + b(9)*a(7)
      t(8) = b(7)*a(2) + b(8)*a(5) + b(9)*a(8)
      t(9) = b(7)*a(3) + b(8)*a(6) + b(9)*a(9)
!
      c(1) = a(1)*t(1) + a(4)*t(4) + a(7)*t(7)
      c(2) = a(1)*t(2) + a(4)*t(5) + a(7)*t(8)
      c(3) = a(1)*t(3) + a(4)*t(6) + a(7)*t(9)
      c(4) = a(2)*t(1) + a(5)*t(4) + a(8)*t(7)
      c(5) = a(2)*t(2) + a(5)*t(5) + a(8)*t(8)
      c(6) = a(2)*t(3) + a(5)*t(6) + a(8)*t(9)
      c(7) = a(3)*t(1) + a(6)*t(4) + a(9)*t(7)
      c(8) = a(3)*t(2) + a(6)*t(5) + a(9)*t(8)
      c(9) = a(3)*t(3) + a(6)*t(6) + a(9)*t(9)
!
      return
      end subroutine mat33

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      double precision function volume (vecs, ndim)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: ndim
      double precision , intent(in) :: vecs(3,ndim)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      double precision :: a, b, gamma, sing
!-----------------------------------------------
!**********************************************************************
!
! VOLUME RETURNS (A) THE VOLUME OF A UNIT CELL IF NDIM=3
!                (B) THE AREA   OF A UNIT CELL IF NDIM=2
!                (C) THE LENGTH OF A UNIT CELL IF NDIM=1
!
!  ON INPUT VECS = ARRAY OF POINTS MARKING THE ENDS OF UNIT CELL VECTORS
!                  THE ORIGIN BEING (0.0, 0.0, 0.0)
!
!**********************************************************************
      a = sqrt(vecs(1,1)**2+vecs(2,1)**2+vecs(3,1)**2)
!
!    CASE 1: SYSTEM IS A POLYMER
!
      if (ndim == 1) then
        volume = a
        return
      end if
      b = sqrt(vecs(1,2)**2+vecs(2,2)**2+vecs(3,2)**2)
      gamma = sqrt((vecs(1,1)-vecs(1,2))**2+(vecs(2,1)-vecs(2,2))**2+(vecs(3,1)&
        -vecs(3,2))**2)
!
!     SING = SIN OF ANGLE BETWEEN FIRST AND SECOND VECTORS
!            OBTAINED FROM COSINE RULE C**2=A**2+B**2-2*A*B*COS(C)
!
      sing = sqrt(1.D0 - ((a*a + b*b - gamma*gamma)/(2.D0*a*b))**2)
!
!    CASE 2: SYSTEM IS A LAYER STRUCTURE
!
      if (ndim == 2) then
!
!   AREA OF A PARALLELOGRAM = BASE * HEIGHT
!
        volume = a*b*sing
        return
      end if
!
!    CASE 3: SYSTEM IS A SOLID
!
         !
         !      VOLUME = A.(B x C) IN VECTOR NOTATION
         !
        volume = Abs (((vecs(2, 1)*vecs(3, 2)-vecs(3, 1)*vecs(2, 2))*vecs(1, 3) + &
                       (vecs(3, 1)*vecs(1, 2)-vecs(1, 1)*vecs(3, 2))*vecs(2, 3) + &
                       (vecs(1, 1)*vecs(2, 2)-vecs(2, 1)*vecs(1, 2))*vecs(3, 3)))
      return
      end function volume

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

  module conref_C
    double precision, dimension(2,10) :: fpcref
!
!   Fundamental physical constants
!
!   fpcref(1,*) = 2018 CODATA  fpcref(2,8) = old constants
!
!   In the 2019 revision of SI units, 7 fundamental constants were switched from
!   uncertain measured values to exact defined values. Similarly, the non-SI calorie
!   has an exact defined value (4.184 J) that is used instead of old measured values.
!
    data fpcref(1, 1) / 1.602176634d0 /         ! Elementary charge, in Coulombs*10**(-19) (exact)
    data fpcref(2, 1) / 1.60217733d0 /
    data fpcref(1, 2) / 14.399645478456d0 /     ! a0*(one au in eV) = ref(3)*ref(4)
    data fpcref(2, 2) / 14.399d0 /
    data fpcref(1, 3) / 0.529177210903d0 /      ! a0 (+/- 1.5e-10 RSD)
    data fpcref(2, 3) / 0.529167d0 /
    data fpcref(1, 4) / 27.211386245988d0 /     ! one au in eV (+/- 1.9e-12 RSD)
    data fpcref(2, 4) / 27.21d0 /
    data fpcref(1, 5) / 1.987204258640832d0 /   ! "R", the gas constant, in calories (exact)
    data fpcref(2, 5) / 1.98726d0 /
    data fpcref(1, 6) / 6.62607015d-27 /        ! Planck's constant in erg-seconds (exact)
    data fpcref(2, 6) / 6.626d-27 /
    data fpcref(1, 7) / 1.380649d-16 /          ! Boltzmann's constant, in J/K (exact)
    data fpcref(2, 7) / 1.3807d-16 /
    data fpcref(1, 8) / 2.99792458d+10 /        ! Speed of light, in cm/sec (exact)
    data fpcref(2, 8) / 2.99776d+10 /
    data fpcref(1, 9) / 23.060547830619029d0 /  ! 1eV in kcal/mol = (ref(1)*ref(10)*10**(-3))/4.184
    data fpcref(2, 9) / 23.061d0 /
    data fpcref(1, 10) / 6.02214076d+23 /       ! Avogadro's number, in 1/mol (exact)
    data fpcref(2, 10) / 6.02205d+23 /
  end module conref_C

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

module Param_global_C
!
!  All the data that are global to PARAM, and are not used at all in MOPAC
!
    implicit none
                                            !       Maximum number of
!
    integer, parameter :: maxmol = 10000    !          molecules
    integer, parameter :: maxpms = 4000     !          parameter
    integer, parameter :: maxfns = 15000    !          reference data
    integer, parameter :: maxrfs = 4000     !          journal references
    integer, parameter :: maxatm = 190000   !          atoms in all systems
    integer, parameter :: maxsym = 20000    !          symmetry functions
!
!  Dependent parameters
!
    integer, parameter :: maxpat = 3*maxatm !          geometric parameters
!
!  Integer scalars
!
    logical ::  large
!
!
!
    integer ::    &
    nmols,        & ! Number of molecules in PARAM
    atom_pKa,     & ! Atom number of hydrogen atom used in pKa work
    atom_pKa_O,   & ! Atom number of oxygen atom that the hydrogen atom in pKa work is attached to
    nfns,         & ! Number of reference data in current run
    numvar,       & ! Number of parameters in PARAM
    ifiles_8,     & ! output channel for PARAM
    molnum,       & ! Molecule number of the current molecule
    nref,         & ! Number of reference directories to be used
    maxpab,       & ! Number of density matrix elements
    aaaint
!
!  Real scalars
!
    double precision :: &    ! Reference value of
      refdip,     & ! Reference value of Dipole
      refhof,     & ! Reference value of Heat of formation
      refips,     & ! Reference value of Ionization potential
      wtdip,      & ! Weighting factor for dipole
      wtgeo,      & ! Weighting factor for geometry
      wthof,      & ! Weighting factor for heat of formation
      wtips,      & ! Weighting factor for ionization potential
      wtz,        & ! Number of mers in a cluster in a solid
      refpKa,     & ! Reference value of pKa
      wtpKa,      & ! Weighting factor for pKa
      refcer,     & ! Error in calculated ionization potential
      refder,     & ! Error in calculated dipole moment
      refger,     & ! Error in calculated geometry
      refher,     & ! Error in calculated heat of formation
      reftot,     & ! Total error for current system
      parab,      & ! Restraining force constant (on values of parameters)
      power,      & ! Power for error function (normally 2)
      penalty,    & ! Penalty for exceeding parameter boundaries = penalty*error**2
    phase = 1.d0, & ! Alternate step directions when building derivatives to minimize bias
      xxxxxx
!
!  Character scalars
!
      character (len=2000) :: contrl = " "  ! Keywords for PARAM
!

      character (len=40) :: molnam         ! Names of file of current system
!
!   Arrays
!
    logical :: &
    is_a_ref(maxmol), &   ! "true" if the H.o.F. reference datum is used only as a reference to
                          ! another reference H.O.F.
    save_parameters,  &   ! "true" if parameters are to be saved
    locked(maxpms),   &   ! "false" if parameter is selected for optimization using "(all)"
    dorbs(107)
!
!
!
    integer :: &
    ihrefs(6, maxmol),      & ! Number of, and indices for, all I.P. levels for all molecules
    molele(10, maxmol),     & ! Number of elements in, and atomic numbers of elements, in each molecule
    locvar(2, maxpms),      & ! (1,*) : Element number for parameter, (2,*) : parameter number
    qn(maxmol),             & ! Quantum number of electronic state use in "root=" option
    spin_state(maxmol),     & ! Spin-state of electronic state use in "root=" option
    lions(maxmol),          & ! Eigenvalue number for ionization potential
    Atom_pKas(maxmol,2),    & ! Atom numbers for O and H in oKa calculation, for all molecules
    natmss(maxmol),         & ! Number of atoms (real plus others) in each molecule
    numats(maxmol),         & ! Number of real atoms in each molecule
    lablss(maxatm),         & ! Labels for every atom in all molecules
    nas(maxatm),            & ! Bond-length connectivity for all atoms in all molecules
    nbs(maxatm),            & ! Bond-angle connectivity for all atoms in all molecules
    ncs(maxatm),            & ! Dihedral connectivity for all atoms in all molecules
    nats(maxatm),           & ! Atomic numbers of all atoms in all molecules
    nfirss(maxatm),         & ! NFIRST for all atoms in all molecules (see MOPAC)
    nlasts(maxatm),         & ! NLAST for all atoms in all molecules (see MOPAC)
    ncloss(maxmol),         & ! NCLOSE for all molecules (see MOPAC)
    nlecss(maxmol),         & ! NELECS for all molecules (see MOPAC)
    nlm61(maxmol),          & ! LM61 for all molecules (see MOPAC)
    nnmos(maxmol),          & ! NMOS for all molecules (see MOPAC)
    nopens(maxmol),         & ! NOPEN for all molecules (see MOPAC)
    norbss(maxmol),         & ! NORBS for all molecules (see MOPAC)
    nnalpha_open(maxmol),   &
    nnbeta_open(maxmol),    &
    n2elecs(maxmol),        & ! N2ELEC for all molecules (see MOPAC)
    ndeps(maxmol),          & ! Number of symmetry-dependent functions for all molecules
    idepfs(maxsym),         & ! IDEP symmetry functions for all molecules
    locdes(maxsym),         & ! LOCDEP symmetry functions for all molecules
    locpas(maxsym),         & ! LOCDER symmetry functions for all molecules
    nvars(maxmol),          & ! Number of geometric variables in all molecules
    locs(2, maxpat),        & ! Indices of all geometric variables in all molecules
    msdels(maxmol),         & ! Magnetic component of spin for all molecules
    l123s(3,maxmol),        & ! Number of unit cells (for solids)
    asasasa
!
!
!
    double precision :: &
    geos(3, maxatm),    & ! All geometries for all systems
    dipls(maxmol),      & ! Reference dipoles for all systems
    heats(maxmol),      & ! Reference H.o.F. for all systems
    hions(maxmol),      & ! Reference ionization potentials for all systems
    pKas(maxmol),       & ! Reference pKa for all systems
    weight(6, maxmol),  & ! The weights for all reference data for all molecules
    xparamp(maxpms),    & ! Values of all parameters used in PARAM
    hofcal(maxmol),     & ! Calculated H.o.F. for all molecules
    fns(maxfns),        & ! Calculated values of reference data
    fnsnew(maxfns),     & ! Predicted values of reference data (using RAPID)
    error(maxfns),      & ! Errors in calculated and predicted values of reference data
    factor(maxfns),     & ! Weighting factors, used in reducing significance of inaccurate data
    fracts(maxmol),     & ! FRACT for all molecules (see MOPAC)
    depmuls(maxsym),    & ! DEPMUL symmetry functions for all molecules
    botlim(maxpms),     & ! Bottom limit for all parameters
    toplim(maxpms),     & ! Top limit for all parameters
    valold(maxpms),     & ! Values of all parameters in previous cycle
    valvar(maxpms),     & ! Values of all parameters
    asaaaa
!
!
!
    character (len=12) :: &
    geotxt(300, maxmol),  & ! Descriptions of all geometric reference data in all molecules
    refgeo(300)             ! Descriptions of each geometric reference datum in a molecule
    character (len=600) :: &
    refdir(20)              ! Names of reference directories to be used
    character (len=80) :: &
    names(maxmol)           ! File-names of reference data, one per system
    character (len=63) :: &
    tfns(maxfns)            ! Text describing each reference datum (mol. name + parameter type)
    character (len=8)  :: &
    refers(maxmol,7)        ! Reference mnemonics for all reference data in all molecules
    character (len=4)  :: &
    i_r(maxmol)             ! Irreducible representation of electronic state use in "root=" option
    character (len=241):: &
    keys(maxmol),         & ! Keywords for all molecules
    titls(maxmol)           ! Titles for all molecules
    character (len=80) :: &
    comnts(maxmol)          ! Comments for all molecules
    character (len=120) :: &
    source(3, 400)          ! Original references for all reference data


!
!
!
    double precision, dimension (:,:), allocatable :: &
    diffns     !  Differentials of all reference data by all parameters
    double precision, dimension (:), allocatable :: &
    pas,          & ! Alpha density matrix for all molecules
    pbs,          & ! Beta density matrix for all molecules
    asasa
!
    save
end module Param_global_C

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine PDB3
!
! Work out the atom label of a hydrogen atom, as defined by the PDB format definition 3.0 and higher
!
USE molkst_C, ONLY: numat, line
use MOZYME_C, only : tyres
use common_arrays_C, only : nat, txtatm, coord, nbonds, ibonds
use funcon_C, only : pi
implicit none
double precision :: torsion
integer :: i, ii, j, k, l, m, n
logical :: swap
logical, allocatable :: used(:)
!
! see: http://publications.iupac.org/pac/pdf/1998/pdf/7001x0117.pdf
!
! Greek letters are used as atom identifiers. The CA or the substituent closer to CA (in
! the order CA,CB,CG,. . . ) takes precedence over atoms in branches in defining stereochemical relationships. For example, if
! tetrahedral carbon C has four substituents X, Y, Z, and Z' (with priority X > Y > Z = Z'; i.e., Z and Z are diastereotopic sub-
! stituents designated provisionally as unprimed and primed), their numbering is derived as follows: if one sights down the
! X-C axis (with the X atom toward the viewer), the equivalent atoms, Z and Z', are designated Z2 and Z3, such that Y, Z2,and
! Z3 follow a clockwise orientation. The side-chain -NH2 nitrogens of Arg are designated as NHl and NH2 by their relationship
! (cis or trans, respectively) to CD. The hydrogen atoms of the side-chain -NH2 groups of Asn, Gln, and Arg are distinguished
! by numbers (1 or 2) on the basis of their relationship (cis or trans, respectively) to the heavy atom three bonds closer to the
! main chain (CB for Asn, CG for Gln, NE for Arg). Thus, each -NH2 hydrogen of Arg is distinguished by two numbers, the first
! indicating the nitrogen to which it is attached and the second indicating the stereochemistry of the hydrogen itself. Numbering
! of Phe and Tyr rings gives higher priority to the atom with the smaller absolute value of the Xi^2 torsion angle (ref. 20). For
! example, the ring carbons of Phe and Tyr lying in the plane with the smaller Xi^2 torsion angle are designated as CD1 and CE1
!
! Special action in the case of ARG
!
do i = 1, numat
  if (txtatm(i)(18:20) == "ARG") then
    if (txtatm(i)(14:16) == "NH1") then
      swap = .false.
!
! Check that the side-chain -NH1 is cis to CD
!
      do j = 1, nbonds(i)
        k = ibonds(j,i)
        if (txtatm(k)(14:15) == "CZ") then
          do l = 1, nbonds(k)
            m = ibonds(l,k)
            if (txtatm(m)(14:15) == "NE") then
              do n = 1, nbonds(m)
                ii = ibonds(n,m)
                if (txtatm(ii)(14:15) == "CD") then
                  call dihed (coord, i, k, m, ii, torsion)
                  if (torsion > pi) torsion = torsion - 2*pi
                  swap = (torsion > pi*0.5d0)
!
!  NH1 is trans, it should be cis, so swap labels
!
                  go to 10
                end if
              end do
            end if
          end do
        end if
10      if (swap) then
          do l = 1, nbonds(k)
            m = ibonds(l,k)
            if (txtatm(m)(14:16) == "NH2") exit
          end do
          txtatm(i)(16:16) = "2"
          do l = 1, nbonds(i)
            n = ibonds(l,i)
            if (txtatm(n)(14:15) == "HH") txtatm(n)(16:16) = "2"
          end do
          txtatm(m)(16:16) = "1"
          do l = 1, nbonds(m)
            n = ibonds(l,m)
            if (txtatm(n)(14:15) == "HH") txtatm(n)(16:16) = "1"
          end do
          exit
        end if
      end do
    end if
  end if
end do
allocate (used(numat))
used = .false.
do i = 1, numat
  if (used(i)) cycle
  if (nat(i) == 1) then
    do j = 1, 20
      if (txtatm(i)(18:20) == tyres(j)) exit
    end do
    if (j == 21) cycle
!
!  Convert hydrogen atom from old-style to Greek letter only
!
    do j = 12, 15
      if (txtatm(i)(j:j) == "H") exit
    end do
    do k = j, 17
      if (txtatm(i)(k:k) == " ") exit
    end do
    line = " H"//txtatm(i)(j + 1:k - 1)
    txtatm(i)(13:16) = trim(line)
  end if
end do
do i = 1, numat
  if (nat(i) == 1) then
    do j = 1, 20
      if (txtatm(i)(18:20) == tyres(j)) exit
    end do
    if (j == 21) then
!
! Not one of the 20 amino-acids, so treat it as a generic atom.
! If a number is present at the start of the atom symbol, move the number to the end of the atom symbol.
!
      do j = 13, 15
        if (txtatm(i)(j:j) /= " ") exit
      end do
      if (txtatm(i)(j:j) > "0" .and. txtatm(i)(j:j) < "9") then
        line = txtatm(i)(j:16)
        if (len_trim(line) == 4) then
          txtatm(i)(j:16) = trim(line(2:))
          j = j + 3
          txtatm(i)(j:j) = line(1:1)
        else
          txtatm(i)(j:15) = " "//trim(line(2:))
          j = j + len_trim(line) 
          txtatm(i)(j:j) = line(1:1)
        end if
      end if
      cycle
    end if
!
! Identify the atom that the hydrogen atom is attached to
!
    j = ibonds(1,i)
    l = 0
    do k = 1, nbonds(j)
      if (nat(ibonds(k, j)) == 1) l = l + 1
    end do
    if (i == 21) then
      continue
    end if
    if (nbonds(j) == 4) then
!
! "j" is an atom that is bonded to four atoms, one of which is hydrogen atom "i"
!
      if (l == 3) then
!
! Three hydrogen atoms attached to atom "j"
!
        l = 0
        do m = 1, 4
          n = ibonds(m,j)
          if (nat(n) == 1 .and. .not. used(n)) then
            l = l + 1
            do k = 15, 17
              if (txtatm(n)(k:k) == " ") exit
            end do
            if (k == 17) then
              line = txtatm(n)(14:16)
              txtatm(n)(13:16) = line(1:4)
              k = 16
            end if
            used(n) = .true.
            write(txtatm(n)(k:k), '(i1)')l
          end if
        end do
      else if (l == 2) then
        call two_atoms(i,j)
      end if
    else if (nbonds(j) == 3 .and. l == 2) then
!
! "j" is an atom that is bonded to three atoms, two of these are hydrogen, and one is hydrogen atom "i"
!
      call two_atoms(i,j)
    end if
  end if
end do
return
end subroutine PDB3
subroutine two_atoms(i, j)
!
! two_atoms assignes the PDB-3.n labels to two hydrogen atoms attached to atom "j"
!
! On input:
!          "i" = atom-number of a hydrogen atom
!          "j" = atom-number of the atom that "i" is attached to
! On output:
!   txtatm(i) is updated with the PDB-3.n label
!
use common_arrays_C, only : txtatm, coord, nbonds, ibonds
use funcon_C, only : pi
USE molkst_C, ONLY : line
implicit none
integer, intent (in) :: i, j
integer :: jj, k, l, m, n, ii, priority(4), order(3)
double precision :: torsion
logical :: swap
character :: types(24)*1, nos(3)*1, no1*1
data types / "A", "B", "G", "D", "E", "Z", "H", "T", "I", "K", "L", "M", &
   & "N", "X", "O", "P", "R", "S", "T", "U", "F", "C", "Y", "W" /
data nos / "1", "2", "3" /
! The hydrogen atoms of the side-chain -NH2 groups of Asn, Gln, and Arg are distinguished
! by numbers (1 or 2) on the basis of their relationship (cis or trans, respectively) to the heavy atom three bonds closer to the
! main chain (CB for Asn, CG for Gln, NE for Arg). Thus, each -NH2 hydrogen of Arg is distinguished by two numbers, the first
! indicating the nitrogen to which it is attached and the second indicating the stereochemistry of the hydrogen itself.
!
! Two hydrogen atoms attached to atom "j"
  if (txtatm(j)(18:20) == "ARG" .and. txtatm(j)(14:15) == "NH") then
    do jj = 1, nbonds(j)
      k = ibonds(jj,j)
      if (txtatm(k)(14:15) == "CZ") then
        do l = 1, nbonds(k)
          m = ibonds(l,k)
          if (txtatm(m)(14:15) == "NE") then
            call dihed (coord, i, j, k, m, torsion)
            if (torsion > pi) torsion = torsion - 2*pi
            swap = (abs(torsion) > pi*0.5d0)
            go to 10
          end if
        end do
      end if
    end do
10  continue
    if (swap) then
      no1 = "2"
    else
      no1 = "1"
    end if
    line = txtatm(i)(14:16)
    txtatm(i)(13:16) = line(1:3)//no1
    return
  end if
!
  if (txtatm(j)(18:20) == "ASN" .and. txtatm(j)(14:15) == "ND") then
    do jj = 1, nbonds(j)
      k = ibonds(jj,j)
!
! If a hydrogen atom on atom j, i.e., ND, has already been defined, then
! automatically assign the current hydrogen atom, atom i.
!
      if (txtatm(k)(13:14) == "HD") then
        if (k < i) then
          line = txtatm(i)(14:16)
          if (txtatm(k)(16:16) == "1") then
            txtatm(i)(13:16) = line(1:3)//"2"
          else
            txtatm(i)(13:16) = line(1:3)//"1"
          end if
          return
        end if
      end if
    end do
    do jj = 1, nbonds(j)
      k = ibonds(jj,j)
      if (txtatm(k)(14:15) == "CG") then
        do l = 1, nbonds(k)
          m = ibonds(l,k)
          if (txtatm(m)(14:15) == "CB") then
            call dihed (coord, i, j, k, m, torsion)
            if (torsion > pi) torsion = torsion - 2*pi
            swap = (abs(torsion) > pi*0.5d0)
            go to 20
          end if
        end do
      end if
    end do
20  continue
    if (swap) then
      no1 = "2"
    else
      no1 = "1"
    end if
    line = txtatm(i)(14:16)
    txtatm(i)(13:16) = line(1:3)//no1
    return
  end if
  !
  if (txtatm(j)(18:20) == "GLN" .and. txtatm(j)(14:15) == "NE") then
    do jj = 1, nbonds(j)
      k = ibonds(jj,j)
      if (txtatm(k)(14:15) == "CD") then
        do l = 1, nbonds(k)
          m = ibonds(l,k)
          if (txtatm(m)(14:15) == "CG") then
            call dihed (coord, i, j, k, m, torsion)
            if (torsion > pi) torsion = torsion - 2*pi
            swap = (abs(torsion) > pi*0.5d0)
            go to 30
          end if
        end do
      end if
    end do
30  continue
    if (swap) then
      no1 = "2"
    else
      no1 = "1"
    end if
    line = txtatm(i)(14:16)
    txtatm(i)(13:16) = line(1:3)//no1
    return
  end if
!
  if (txtatm(j)(18:20) == "GLY" .and. txtatm(j)(14:15) == "CA") then
!
! Assumed convention: The first hydrogen on CA is HA2, the second is HA3
!
    if (txtatm(i + 1)(12:20) == txtatm(i)(12:20)) then
      txtatm(i)(14:16) = "HA2"
    else
      txtatm(i)(14:16) = "HA3"
    end if
    return
  end if

!
  priority = 100
  do k = 1, nbonds(j)
    l = ibonds(k, j)
    if (l == i) then
      m = 25
    else
      jj = 15
      if (txtatm(l)(13:13) /= " ") jj = 14
      if (txtatm(l)(jj:jj) /= " ") then
        do m = 1, 24
          if (txtatm(l)(jj:jj) == types(m)) exit
        end do
      else
        m = 24
      end if
    end if
    priority(k) = m
  end do
!
!  Put the atoms in order.
!
  do k = 1, 2
    l = 110
    do m = 1, 4
      if (priority(m) < l .and. ibonds(m,j) /= i) then
        l = priority(m)
        n = ibonds(m,j)
        ii = m
      end if
    end do
    priority(ii) = 100
    order(k) = n
  end do
!
! Evaluate dihedral i - j - order(1) - order(2)
!
  call dihed (coord, i, j, order(1), order(2), torsion)
  if (torsion > pi) torsion = torsion - 2*pi
  do k = 15, 17
    if (txtatm(i)(k:k) == " ") exit
  end do
  if (k == 17) then
    line = txtatm(i)(14:16)
    txtatm(i)(13:16) = line(1:4)
    k = 16
  end if
  if (torsion < 0.d0) then
    txtatm(i)(k:k) = nos(nbonds(j) - 2)
  else
    txtatm(i)(k:k) = nos(nbonds(j) - 1)
  end if
  return
end subroutine two_atoms

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      module molmec_C
      integer, dimension(4,6000) :: nhco = 0
      integer :: nnhco = 0
      double precision :: htype = 0.d0
      end module molmec_C

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine mecip()
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use meci_C, only : nmos, lab, occa, nalmat, microa, microb, nelec, &
      & nstate, vectci, deltap
      use common_arrays_C, only : c, p
      use molkst_C, only : norbs

!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j, id, jd, ix, iy, ij, k
      double precision :: sum,  delta(norbs, nmos)
!-----------------------------------------------
!***********************************************************************
!
!   MECIP WILL CORRECT THE TOTAL DENSITY MATRIX FOR THE EFFECT OF THE
!   C.I.
!              ON INPUT
!
!  COEFFS       : ALL M.O.'S (NORBS M.O.S)
!  NORBS        : NUMBER OF MOLECULAR ORBITALS = NUMBER OF A.O.'S
!  P            : TOTAL DENSITY MATRIX
!  NMOS         : NUMBER OF M.O.'S IN ACTIVE SPACE
!  VECTCI       : STATE VECTOR OF LENGTH LAB
!  MICROA(I,J)  : ALPHA OCCUPANCY OF M.O. 'I' IN MICROSTATE 'J'
!  MICROB(I,J)  : BETA  OCCUPANCY OF M.O. 'I' IN MICROSTATE 'J'
!
!  NOTE: THIS IS A MODIFICATION OF CODE ORIGINALLY WRITTEN BY
!        PROF. DANIEL LIOTARD
!***********************************************************************
!     INITIALIZE WITH THE OPPOSITE OF THE 'SCF' DENSITY.
      do i = 1, nmos
        deltap(i,i) = -occa(i)*2.D0
        deltap(i,:i-1) = 0.D0
      end do
!
!     ADD THE C.I. CORRECTION
      do id = 1, lab
        do jd = 1, id
!     CHECK SPIN AGREEMENT
          if (nalmat(id) /= nalmat(jd)) cycle
          ix = 0
          iy = 0
          do j = 1, nmos
            ix = ix + abs(microa(j,id)-microa(j,jd))
            iy = iy + abs(microb(j,id)-microb(j,jd))
          end do
!     CHECK NUMBER OF DIFFERING M.O.
          if (ix + iy > 2) cycle
          if (ix == 2) then
!        DETERMINANTS ID AND JD DIFFER BY M.O I IN ID AND M.O J IN JD:
            do i = 1, nmos
              if (microa(i,id) == microa(i,jd)) cycle
              exit
            end do
            ij = microb(i,id)
            do j = i + 1, nmos
              if (microa(j,id) /= microa(j,jd)) exit
              ij = ij + microa(j,id) + microb(j,id)
            end do
!        IJ GIVES THE SIGN OF THE PERMUTATION
            sum = 0.D0
            do k = 1, nstate
              sum = sum + vectci(id+(k-1)*lab)*vectci(jd+(k-1)*lab)
            end do
            deltap(j,i) = deltap(j,i) + sum*dble(1 - 2*mod(ij,2))/nstate
          else if (iy == 2) then
!        DETERMINANTS ID AND JD DIFFER BY M.O J IN ID AND M.O I IN JD:
            do i = 1, nmos
              if (microb(i,id) == microb(i,jd)) cycle
              exit
            end do
            ij = 0
            do j = i + 1, nmos
              if (microb(j,id) /= microb(j,jd)) exit
              ij = ij + microa(j,id) + microb(j,id)
            end do
            ij = ij + microa(j,id)
            sum = 0.D0
            do k = 1, nstate
              sum = sum + vectci(id+(k-1)*lab)*vectci(jd+(k-1)*lab)
            end do
            deltap(j,i) = deltap(j,i) + sum*dble(1 - 2*mod(ij,2))/nstate
          else
!        DETERMINANTS ID AND JD ARE IDENTICAL:
            sum = 0.D0
            do k = 1, nstate
              sum = sum + vectci(id+(k-1)*lab)**2
            end do
            do i = 1, nmos
              deltap(i,i) = deltap(i,i) + (microa(i,id)+microb(i,id))*sum/nstate
            end do
          end if
        end do
      end do
!
!     BACK TRANSFORM INTO A.O. BASIS.
!     -------------------------------
!     P(C.I.) = P(SCF) + C * DELTAP * C'
      do i = 1, nmos
        deltap(:i-1,i) = deltap(i,:i-1)
      end do
!     STEP 1: DELTAP = C * DELTAP
      call mxm (c(1,nelec+1), norbs, deltap, nmos, delta, nmos)
!     STEP 2: P = P + DELTAP * C'
      ij = 0
      do i = 1, norbs
        do j = 1, i
          ij = ij + 1
          sum = 0.D0
          do k = 1, nmos
            sum = sum + delta(i,k)*c(j,nelec+k)
          end do
          p(ij) = p(ij) + sum
        end do
      end do
!     NOTE FROM D.L.: AT THIS POINT THE 'NATURAL ORBITALS' OF THIS STATE
!     CAN BE OBTAINED STRAIGHTWAY AS EIGENVECTORS OF THE DENSITY MATRIX.
      return
      end subroutine mecip

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine sympop(h, i, iskip, deldip)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use symmetry_C, only : nsym, ipo
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: i
      integer , intent(out) :: iskip
      double precision  :: h(*)
      double precision  :: deldip(3,*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: j
!-----------------------------------------------
      do j = 1, nsym
        if (ipo(i,j) >= i) cycle
        call symh (h, deldip, i, j, ipo)
        iskip = 3
!  atom ipo(i,j) is suitable for transition dipole calc'n
!
!            K=I*3-2
!            WRITE(IW,*)' Transition dipole after symmetry operation'
!            WRITE(IW,'(3f12.5)')(deldip(l,k),l=1,3)
!            WRITE(IW,'(3f12.5)')(deldip(l,k+1),l=1,3)
!            WRITE(IW,'(3f12.5)')(deldip(l,k+2),l=1,3)
!
!   INSERT DELDIP ROTATION HERE
!
        go to 20
      end do
      iskip = 0
   20 continue
      return
      end subroutine sympop

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  subroutine setup_mopac_arrays(n, mode)
!
!   Create and destroy allocatable arrays used by MOPAC
!
!  n == 0  destroy all arrays that have been created.
!  n >  0
!  mode == 1 Create the arrays essential for reading in data
!  mode /= 1 Create MOPAC arrays (holds electronic info.)
!
  use common_arrays_C, only : geo, coord, na, nb, nc, simbol, atmass, &
     & labels, loc, xparam, nat, nfirst, nlast, uspd, pdiag, xparef, &
     & h, w, p, pa, pb, f, c, eigs, dxyz, grad, eigb, txtatm, fb, cb, &
     & wk, errfn, aicorr, nbonds, ibonds, na_store, q, nw, lopt, &
     & hesinv, gnext1, gmin1, ifact, i1fact, ptot2, geoa, l_atom, coorda, &
       txtatm1, workmat1, workmat2, workmat3
!
  USE maps_C, only : react
!
  use iter_C, only : pold, pbold, pold2, pbold2, pold3, pbold3
!
  use symmetry_C, only : depmul, jelem, locpar, idepfn, locdep, jndex, &
  namo, ipo
!
  use molkst_C, only : mpack, n2elec, norbs, numat, nvar, uhf, &
  l123, natoms, mozyme, npulay
!
  USE chanel_C, only : iw
!
  use derivs_C, only : b, ab, fb_ci => fb, fmat, hmat, wmat, aidref, work2
!
  USE ef_C, ONLY: hess, ef_bmat => bmat, u, oldhss, oldu, pmat, uc, hessc, oldf, &
      & d, vmode
!
  use meci_C, only : microa, microb, &
      & cdiag, occa, nalmat, conf, &
      & vectci, ispin, eig, ispqr, deltap
!
  use drc_C, only: vref, vref0, allxyz, allvel, xyz3, vel3, allgeo, geo3, parref
!
  use cosmo_C, only : ipiden, idenat, gden, qdenet, &
  phinet, qscnet, qscat, bmat, abcmat, srad, iatsp, &
  nn, cosurf, xsp, nset, bh, qden, nsetf, isude, sude, &
  arat, amat, cmat
!
  use esp_C, only : cen, ex, iam, cc, &
      & cespm, espi, potpt, es, rnai, rnai2, pf0, pf1, pf2, &
      & pexs, pce, pexpn, ptd, pewcx, pewcy, pewcz, ird, indc,  &
      cequiv, exsr, itemp, dx_array, dy_array, dz_array, td, esp_array, qsc, &
      a2, ovl, cespm2, cespml, cesp, co, al, rad, b_esp, qesp, ind, temp, f0, &
      f1, ce, u_esp, exs, expn, ewcx, ewcy, ewcz, rnai1, fc
!
  use to_screen_C, only : cnorml
!
   use reimers_C, only : natm,nbf,ibf,iat,nbt,&
                 nprn,itrmet,&
                 natt,nstr,&
                 istr,nsym,ivv,npsn,mofrag,&
                 nfocc,nfvir,icifrag,imp2d,imp2s,&
                 isc,krefd,vv,iwk,&
                 istate,nseig,icif,jcif,ncif,&
                 nbtmo,iconf,nspn, &
                 vca,vcb,occfr,&
                 x,y,z,zcore,gamma, beta,betao,&
                 s,r,ppg,pg,dd,ff,aa,&
                 dm,xz,ci,evalmo,evalci,&
                 spintr,cimatr,dmci,&
                 stwt,e0,wk1,wk2,tr1,&
                 wk3,occ,qgs,dipgs,&
                 qbfcore,qbf,qcore,&
                 dip,dtmp, &
                 eec,ee2, &
                 aocc,bocc,aor1,bor1,&
                 aor,bor,aos,bos,aod,bod,&
                 ao1,bo1,cc0,wk0,q0
!
  implicit none
    integer :: n, mode, i, j
    double precision, external :: meci
    if (n > 0) then
      if (mode == 1) then
!
! Create essential arrays only at this point
!
        allocate(geo(3,n), coord(3,n), coorda(3,n), na(n), nb(n), nc(n))
        allocate(simbol(n*3), atmass(n), labels(n), loc(2, 3*n))
        allocate(xparam(3*n), nat(n), nfirst(n), nlast(n), uspd(9*n))
        allocate(pdiag(9*n), xparef(3*n), depmul(3*n), jelem(20, n))
        allocate(txtatm1(n), txtatm(n), locpar(3*n), idepfn(3*n), locdep(3*n))
        allocate(nbonds(n), ibonds(15,n), na_store(n), l_atom(n))
        na = 0
        na_store = 0
        nfirst = -9999
        nlast = -9999
        nbonds = 0
!
      else
!
!  Create main arrays - at this point, the array sizes are all known
!
        j = 0
        if (allocated(grad))     deallocate(grad)
        allocate(grad(nvar), stat=i)
          j = j + i
        if ( .not. mozyme) then
!
!  A conventional MOPAC job
!
          if (allocated(h))        deallocate(h)
          if (allocated(p))        deallocate(p)
          if (allocated(pa))       deallocate(pa)
          if (allocated(pb))       deallocate(pb)
          if (allocated(pold))     deallocate(pold)
          if (allocated(pold2))    deallocate(pold2)
          if (allocated(pold3))    deallocate(pold3)
          if (allocated(pbold))    deallocate(pbold)
          if (allocated(pbold2))   deallocate(pbold2)
          if (allocated(pbold3))   deallocate(pbold3)
          if (allocated(errfn))    deallocate(errfn)
          if (allocated(aicorr))   deallocate(aicorr)
          if (allocated(f))        deallocate(f)
          if (allocated(fb))       deallocate(fb)
          if (allocated(w))        deallocate(w)
          if (allocated(wk))       deallocate(wk)
          if (allocated(dxyz))     deallocate(dxyz)
          if (allocated(c))        deallocate(c)
          if (allocated(cb))       deallocate(cb)
          if (allocated(eigs))     deallocate(eigs)
          if (allocated(q))        deallocate(q)
          if (allocated(eigb))     deallocate(eigb)
          if (allocated(workmat1)) deallocate(workmat1)
          if (allocated(workmat2)) deallocate(workmat2)
          if (allocated(workmat3)) deallocate(workmat3)
          allocate(h(mpack), p(mpack), pa(mpack), pb(mpack), stat=i)
          j = j + i
          allocate(pold(npulay*mpack),  pold2(npulay*mpack), f(mpack), stat=i)
          j = j + i
          allocate(c(norbs, norbs), eigs(norbs + 1), q(numat), stat=i)
          j = j + i
          allocate(workmat1(norbs, norbs), workmat2(norbs, norbs), workmat3(norbs, norbs), stat=i)
          j = j + i
          allocate(eigb(norbs + 1), pold3(max(mpack, 400)), stat=i)
          j = j + i
          allocate(errfn(3*natoms*l123), aicorr(nvar), stat=i)
          j = j + i
          allocate(w(n2elec + 2025), stat=i)
          j = j + i
          allocate(dxyz(3*numat*l123), stat=i)
          j = j + i
          if (uhf) allocate(fb(mpack), cb(norbs, norbs), pbold(npulay*mpack), &
          pbold2(npulay*mpack), pbold3(max(mpack, npulay*npulay)), stat=i)
          j = j + i
          if (j /= 0) then
            call mopend("A problem occurred during memory assignment, most likely the system is too big to run. ")
            return
          end if
          p = 0.d0
          pold = 0.d0
          eigs = 0.d0
          eigb = 0.d0
          eigs = 0.d0
          if (uhf) pbold = 0.d0
          if (l123 > 1) then
            allocate(wk(n2elec + 2025), stat = i)
            if (i /= 0) then
              call mopend("Failed to allocate the two-electron integral array 'wk'")
              write(iw,"(10x,a,f9.2,a)") "  Size requested:",(n2elec*8.d0)/1.d6, "Mb"
              return
            end if
          end if
          dxyz = 0.d0
          errfn = 0.d0
          aicorr = 0.d0
          grad = 0.d0
        end if
      end if
    else
!
!  Delete all arrays
!
    mpack = 0
    numat = 0
    n2elec =0
    if ( meci() < - 1.d0) n2elec = 0
    if (allocated(f)) call fock2(f, f, f, w, w, w, numat, nfirst, nlast, mode)
    if (allocated(a2))         deallocate(a2, stat = i)
    if (allocated(ab))         deallocate(ab, stat = i)
    if (allocated(abcmat))     deallocate (abcmat, stat = i)
    if (allocated(aicorr))     deallocate (aicorr, stat = i)
    if (allocated(aidref))     deallocate(aidref, stat = i)
    if (allocated(al))         deallocate(al, stat = i)
    if (allocated(allgeo))     deallocate (allgeo, stat = i)
    if (allocated(allvel))     deallocate (allvel, stat = i)
    if (allocated(allxyz))     deallocate (allxyz, stat = i)
    if (allocated(amat))       deallocate (amat, stat = i)
    if (allocated(arat))       deallocate (arat, stat = i)
    if (allocated(atmass))     deallocate (atmass, stat = i)
    if (allocated(b))          deallocate(b, stat = i)
    if (allocated(b_esp))      deallocate(b_esp, stat = i)
    if (allocated(bh))         deallocate (bh, stat = i)
    if (allocated(bmat))       deallocate (bmat, stat = i)
    if (allocated(c))          deallocate (c, stat = i)
    if (allocated(cb))         deallocate (cb, stat = i)
    if (allocated(cc))         deallocate(cc, stat = i)
    if (allocated(ce))         deallocate(ce, stat = i)
    if (allocated(cen))        deallocate(cen, stat = i)
    if (allocated(cequiv))     deallocate(cequiv, stat = i)
    if (allocated(cesp))       deallocate(cesp, stat = i)
    if (allocated(cespm))      deallocate(cespm, stat = i)
    if (allocated(cespm2))     deallocate(cespm2, stat = i)
    if (allocated(cespml))     deallocate(cespml, stat = i)
    if (allocated(cmat))       deallocate (cmat, stat = i)
    if (allocated(cnorml))     deallocate(cnorml, stat = i)
    if (allocated(co))         deallocate(co, stat = i)
    if (allocated(coord))      deallocate (coord, stat = i)
    if (allocated(coorda))     deallocate (coorda, stat = i)
    if (allocated(cosurf))     deallocate (cosurf, stat = i)
    if (allocated(d))          deallocate (d, stat = i)
    if (allocated(deltap))     deallocate (deltap, stat = i)
    if (allocated(depmul))     deallocate (depmul, stat = i)
    if (allocated(dx_array))   deallocate(dx_array, stat = i)
    if (allocated(dxyz))       deallocate (dxyz, stat = i)
    if (allocated(dy_array))   deallocate(dy_array, stat = i)
    if (allocated(dz_array))   deallocate(dz_array, stat = i)
    if (allocated(ef_bmat))    deallocate (ef_bmat, stat = i)
    if (allocated(eigb))       deallocate (eigb, stat = i)
    if (allocated(eigs))       deallocate (eigs, stat = i)
    if (allocated(errfn))      deallocate (errfn, stat = i)
    if (allocated(es))         deallocate(es, stat = i)
    if (allocated(esp_array))  deallocate(esp_array, stat = i)
    if (allocated(espi))       deallocate(espi, stat = i)
    if (allocated(ewcx))       deallocate(ewcx, stat = i)
    if (allocated(ewcy))       deallocate(ewcy, stat = i)
    if (allocated(ewcz))       deallocate(ewcz, stat = i)
    if (allocated(ex))         deallocate(ex, stat = i)
    if (allocated(expn))       deallocate(expn, stat = i)
    if (allocated(exs))        deallocate(exs, stat = i)
    if (allocated(exsr))       deallocate(exsr, stat = i)
    if (allocated(f))          deallocate (f, stat = i)
    if (allocated(f0))         deallocate(f0, stat = i)
    if (allocated(f1))         deallocate(f1, stat = i)
    if (allocated(fb))         deallocate (fb, stat = i)
    if (allocated(fb_ci))      deallocate(fb_ci, stat = i)
    if (allocated(fc))         deallocate(fc, stat = i)
    if (allocated(fmat))       deallocate(fmat, stat = i)
    if (allocated(gden))       deallocate (gden, stat = i)
    if (allocated(geo))        deallocate (geo, stat = i)
    if (allocated(geo3))       deallocate (geo3, stat = i)
    if (allocated(geoa))       deallocate(geoa, stat = i)
    if (allocated(gmin1))      deallocate(gmin1, stat = i)
    if (allocated(gnext1))     deallocate(gnext1, stat = i)
    if (allocated(grad))       deallocate (grad, stat = i)
    if (allocated(h))          deallocate (h, stat = i)
    if (allocated(hesinv))     deallocate(hesinv, stat = i)
    if (allocated(hess))       deallocate (hess, stat = i)
    if (allocated(hessc))      deallocate (hessc, stat = i)
    if (allocated(hmat))       deallocate(hmat, stat = i)
    if (allocated(i1fact))     deallocate(i1fact, stat = i)
    if (allocated(iam))        deallocate(iam, stat = i)
    if (allocated(iatsp))      deallocate (iatsp, stat = i)
    if (allocated(ibonds))     deallocate (ibonds, stat = i)
    if (allocated(idenat))     deallocate (idenat, stat = i)
    if (allocated(idepfn))     deallocate (idepfn, stat = i)
    if (allocated(ifact))      deallocate(ifact, stat = i)
    if (allocated(ind))        deallocate(ind, stat = i)
    if (allocated(indc))       deallocate(indc, stat = i)
    if (allocated(ipiden))     deallocate (ipiden, stat = i)
    if (allocated(ipo))        deallocate(ipo, stat = i)
    if (allocated(ird))        deallocate(ird, stat = i)
    if (allocated(isude))      deallocate (isude, stat = i)
    if (allocated(itemp))      deallocate(itemp, stat = i)
    if (allocated(jelem))      deallocate (jelem, stat = i)
    if (allocated(jndex))      deallocate (jndex, stat = i)
    if (allocated(labels))     deallocate (labels, stat = i)
    if (allocated(loc))        deallocate (loc, stat = i)
    if (allocated(locdep))     deallocate (locdep, stat = i)
    if (allocated(locpar))     deallocate (locpar, stat = i)
    if (allocated(lopt))       deallocate (lopt, stat = i)
    if (allocated(na))         deallocate (na, stat = i)
    if (allocated(na_store))   deallocate (na_store, stat = i)
    if (allocated(l_atom))     deallocate (l_atom, stat = i)
    if (allocated(namo))       deallocate (namo, stat = i)
    if (allocated(nat))        deallocate (nat, stat = i)
    if (allocated(nb))         deallocate (nb, stat = i)
    if (allocated(nbonds))     deallocate (nbonds, stat = i)
    if (allocated(nc))         deallocate (nc, stat = i)
    if (allocated(nfirst))     deallocate (nfirst, stat = i)
    if (allocated(nlast))      deallocate (nlast, stat = i)
    if (allocated(nn))         deallocate (nn, stat = i)
    if (allocated(nset))       deallocate (nset, stat = i)
    if (allocated(nsetf))      deallocate (nsetf, stat = i)
    if (allocated(nw))         deallocate (nw, stat = i)
    if (allocated(oldf))       deallocate (oldf, stat = i)
    if (allocated(oldhss))     deallocate (oldhss, stat = i)
    if (allocated(oldu))       deallocate (oldu, stat = i)
    if (allocated(ovl))        deallocate(ovl, stat = i)
    if (allocated(p))          deallocate (p, stat = i)
    if (allocated(pa))         deallocate (pa, stat = i)
    if (allocated(parref))     deallocate (parref, stat = i)
    if (allocated(pb))         deallocate (pb, stat = i)
    if (allocated(pbold))      deallocate (pbold, stat = i)
    if (allocated(pbold2))     deallocate (pbold2, stat = i)
    if (allocated(pbold3))     deallocate (pbold3, stat = i)
    if (allocated(pbold3))     deallocate (pbold3, stat = i)
    if (allocated(pbold3))     deallocate (pbold3, stat = i)
    if (allocated(pce))        deallocate(pce, stat = i)
    if (allocated(pdiag))      deallocate (pdiag, stat = i)
    if (allocated(pewcx))      deallocate(pewcx, stat = i)
    if (allocated(pewcy))      deallocate(pewcy, stat = i)
    if (allocated(pewcz))      deallocate(pewcz, stat = i)
    if (allocated(pexpn))      deallocate(pexpn, stat = i)
    if (allocated(pexs))       deallocate(pexs, stat = i)
    if (allocated(pf0))        deallocate(pf0, stat = i)
    if (allocated(pf1))        deallocate(pf1, stat = i)
    if (allocated(pf2))        deallocate(pf2, stat = i)
    if (allocated(phinet))     deallocate (phinet, stat = i)
    if (allocated(pmat))       deallocate (pmat, stat = i)
    if (allocated(pold))       deallocate (pold, stat = i)
    if (allocated(pold2))      deallocate (pold2, stat = i)
    if (allocated(pold3))      deallocate (pold3,  stat = i)
    if (allocated(potpt))      deallocate(potpt, stat = i)
    if (allocated(ptd))        deallocate(ptd, stat = i)
    if (allocated(ptot2))      deallocate(ptot2, stat = i)
    if (allocated(q))          deallocate (q, stat = i)
    if (allocated(qden))       deallocate (qden, stat = i)
    if (allocated(qdenet))     deallocate (qdenet, stat = i)
    if (allocated(qesp))       deallocate(qesp, stat = i)
    if (allocated(qsc))        deallocate(qsc, stat = i)
    if (allocated(qscat))      deallocate (qscat, stat = i)
    if (allocated(qscnet))     deallocate (qscnet, stat = i)
    if (allocated(rad))        deallocate(rad, stat = i)
    if (allocated(react))      deallocate (react, stat = i)
    if (allocated(rnai))       deallocate(rnai, stat = i)
    if (allocated(rnai1))      deallocate(rnai1, stat = i)
    if (allocated(rnai2))      deallocate(rnai2, stat = i)
    if (allocated(simbol))     deallocate (simbol, stat = i)
    if (allocated(srad))       deallocate (srad, stat = i)
    if (allocated(sude))       deallocate (sude, stat = i)
    if (allocated(td))         deallocate(td, stat = i)
    if (allocated(temp))       deallocate(temp, stat = i)
    if (allocated(txtatm))     deallocate (txtatm, stat = i)
    if (allocated(txtatm1))    deallocate (txtatm1, stat = i)
    if (allocated(u))          deallocate (u, stat = i)
    if (allocated(u_esp))      deallocate(u_esp, stat = i)
    if (allocated(uc))         deallocate (uc, stat = i)
    if (allocated(uspd))       deallocate (uspd, stat = i)
    if (allocated(vel3))       deallocate (vel3, stat = i)
    if (allocated(vmode))      deallocate (vmode, stat = i)
    if (allocated(vref))       deallocate (vref, stat = i)
    if (allocated(vref0))      deallocate (vref0, stat = i)
    if (allocated(w))          deallocate (w, stat = i)
    if (allocated(wk))         deallocate (wk, stat = i) ! stat needed because the array can be faulty
    if (allocated(wmat))       deallocate(wmat, stat = i)
    if (allocated(work2))      deallocate(work2, stat = i)
    if (allocated(xparam))     deallocate (xparam, stat = i)
    if (allocated(xparef))     deallocate (xparef, stat = i)
    if (allocated(xsp))        deallocate (xsp, stat = i)
    if (allocated(xyz3))       deallocate (xyz3, stat = i)
    if (allocated(occa))       deallocate(occa, stat = i)
    if (allocated(microa))     deallocate(microa, stat = i)
    if (allocated(microb))     deallocate(microb, stat = i)
    if (allocated(cdiag))      deallocate(cdiag, stat = i)
    if (allocated(nalmat))     deallocate(nalmat, stat = i)
    if (allocated(eig))        deallocate(eig, stat = i)
    if (allocated(conf))       deallocate(conf, stat = i)
    if (allocated(vectci))     deallocate(vectci, stat = i)
    if (allocated(ispin))      deallocate(ispin, stat = i)
    if (allocated(ispqr))      deallocate(ispqr, stat = i)
    if (allocated(natm))       deallocate(natm, stat = i)
    if (allocated(nbf))        deallocate(nbf, stat = i)
    if (allocated(ibf))        deallocate(ibf, stat = i)
    if (allocated(iat))        deallocate(iat, stat = i)
    if (allocated(nbt))        deallocate(nbt, stat = i)
    if (allocated(nprn))       deallocate(nprn, stat = i)
    if (allocated(itrmet))     deallocate(itrmet, stat = i)
    if (allocated(natt))       deallocate(natt, stat = i)
    if (allocated(nstr))       deallocate(nstr, stat = i)
    if (allocated(istr))       deallocate(istr, stat = i)
    if (allocated(nsym))       deallocate(nsym, stat = i)
    if (allocated(ivv))        deallocate(ivv, stat = i)
    if (allocated(npsn))       deallocate(nspn, stat = i)
    if (allocated(mofrag))     deallocate(mofrag, stat = i)
    if (allocated(nfocc))      deallocate(nfocc, stat = i)
    if (allocated(nfvir))      deallocate(nfvir, stat = i)
    if (allocated(icifrag))    deallocate(icifrag, stat = i)
    if (allocated(imp2d))      deallocate(imp2d, stat = i)
    if (allocated(imp2s))      deallocate(imp2s, stat = i)
    if (allocated(isc))        deallocate(isc, stat = i)
    if (allocated(krefd))      deallocate(krefd, stat = i)
    if (allocated(vv))         deallocate(vv, stat = i)
    if (allocated(iwk))        deallocate(iwk, stat = i)
    if (allocated(istate))     deallocate(istate, stat = i)
    if (allocated(nseig))      deallocate(nseig, stat = i)
    if (allocated(icif))       deallocate(icif, stat = i)
    if (allocated(jcif))       deallocate(jcif, stat = i)
    if (allocated(ncif))       deallocate(ncif, stat = i)
    if (allocated(nbtmo))      deallocate(nbtmo, stat = i)
    if (allocated(iconf))      deallocate(iconf, stat = i)
    if (allocated(nspn))       deallocate(nspn, stat = i)
    if (allocated(vca))        deallocate(vca, stat = i)
    if (allocated(vcb))        deallocate(vcb, stat = i)
    if (allocated(occfr))      deallocate(occfr, stat = i)
    if (allocated(x))          deallocate(x, stat = i)
    if (allocated(y))          deallocate(y, stat = i)
    if (allocated(z))          deallocate(z, stat = i)
    if (allocated(zcore))      deallocate(zcore, stat = i)
    if (allocated(gamma))      deallocate(gamma, stat = i)
    if (allocated(beta))       deallocate(beta, stat = i)
    if (allocated(betao))      deallocate(betao, stat = i)
    if (allocated(s))          deallocate(s, stat = i)
    if (allocated(r))          deallocate(r, stat = i)
    if (allocated(ppg))        deallocate(ppg, stat = i)
    if (allocated(pg))         deallocate(pg, stat = i)
    if (allocated(dd))         deallocate(dd, stat = i)
    if (allocated(ff))         deallocate(ff, stat = i)
    if (allocated(aa))         deallocate(aa, stat = i)
    if (allocated(dm))         deallocate(dm, stat = i)
    if (allocated(xz))         deallocate(xz, stat = i)
    if (allocated(ci))         deallocate(ci, stat = i)
    if (allocated(evalmo))     deallocate(evalmo, stat = i)
    if (allocated(evalci))     deallocate(evalci, stat = i)
    if (allocated(spintr))     deallocate(spintr, stat = i)
    if (allocated(cimatr))     deallocate(cimatr, stat = i)
    if (allocated(dmci))       deallocate(dmci, stat = i)
    if (allocated(stwt))       deallocate(stwt, stat = i)
    if (allocated(e0))         deallocate(e0, stat = i)
    if (allocated(wk1))        deallocate(wk1, stat = i)
    if (allocated(wk2))        deallocate(wk2, stat = i)
    if (allocated(tr1))        deallocate(tr1, stat = i)
    if (allocated(wk3))        deallocate(wk3, stat = i)
    if (allocated(occ))        deallocate(occ, stat = i)
    if (allocated(qgs))        deallocate(qgs, stat = i)
    if (allocated(dipgs))      deallocate(dipgs, stat = i)
    if (allocated(qbfcore))    deallocate(qbfcore, stat = i)
    if (allocated(qbf))        deallocate(qbf, stat = i)
    if (allocated(qcore))      deallocate(qcore, stat = i)
    if (allocated(dip))        deallocate(dip, stat = i)
    if (allocated(dtmp))       deallocate(dtmp, stat = i)
    if (allocated(eec))        deallocate(eec, stat = i)
    if (allocated(ee2))        deallocate(ee2, stat = i)
    if (allocated(aocc))       deallocate(aocc, stat = i)
    if (allocated(bocc))       deallocate(bocc, stat = i)
    if (allocated(aor1))       deallocate(aor1, stat = i)
    if (allocated(bor1))       deallocate(bor1, stat = i)
    if (allocated(aor))        deallocate(aor, stat = i)
    if (allocated(bor))        deallocate(bor, stat = i)
    if (allocated(aos))        deallocate(aos, stat = i)
    if (allocated(bos))        deallocate(bos, stat = i)
    if (allocated(aod))        deallocate(aod, stat = i)
    if (allocated(bod))        deallocate(bod, stat = i)
    if (allocated(ao1))        deallocate(ao1, stat = i)
    if (allocated(bo1))        deallocate(bo1, stat = i)
    if (allocated(cc0))        deallocate(cc0, stat = i)
    if (allocated(wk0))        deallocate(wk0, stat = i)
    if (allocated(q0))         deallocate(q0, stat = i)
    if (allocated(workmat1))   deallocate(workmat1, stat = i)
    if (allocated(workmat2))   deallocate(workmat2, stat = i)
    if (allocated(workmat3))   deallocate(workmat3, stat = i)
    end if
  end subroutine setup_mopac_arrays
  subroutine memory_error(txt)
    USE chanel_C, only : iw
    character (len=*) :: txt
    write(iw,'(/10x,a,/)')"Unable to allocate memory in subroutine "//txt(:len_trim(txt))
    call mopend(txt(:len_trim(txt)))
    return
  end subroutine memory_error

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine xyzint(xyz, numat, na, nb, nc, degree, geo)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use funcon_C, only : pi
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision  :: degree
      integer :: numat
      integer  :: na(numat)
      integer  :: nb(numat)
      integer  :: nc(numat)
      double precision  :: xyz(3,numat)
      double precision  :: geo(3,numat)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j, im1, k, l
      double precision :: sum, r
!-----------------------------------------------
!**********************************************************************
!
! XYZINT WORKS OUT THE INTERNAL COORDINATES OF A MOLECULE.
!        THE "RULES" FOR THE CONNECTIVITY ARE AS FOLLOWS:
!        ATOM I IS DEFINED AS BEING AT A DISTANCE FROM THE NEAREST
!        ATOM J, ATOM J ALREADY HAVING BEEN DEFINED.
!        ATOM I MAKES AN ANGLE WITH ATOM J AND THE ATOM K, WHICH HAS
!        ALREADY BEEN DEFINED, AND IS THE NEAREST ATOM TO J
!        ATOM I MAKES A DIHEDRAL ANGLE WITH ATOMS J, K, AND L. L HAVING
!        BEEN DEFINED AND IS THE NEAREST ATOM TO K, AND J, K AND L
!        HAVE A CONTAINED ANGLE IN THE RANGE 15 TO 165 DEGREES,
!        IF POSSIBLE.
!
!        IF(NA(2).EQ.1 THEN THE ORIGINAL CONNECTIVITY IS USED.
!
!        NOTE THAT GEO AND XYZ MUST NOT BE THE SAME IN THE CALL.
!
!   ON INPUT XYZ    = CARTESIAN ARRAY OF NUMAT ATOMS
!            DEGREE = 1 IF ANGLES ARE TO BE IN RADIANS
!            DEGREE = 57.29578 IF ANGLES ARE TO BE IN DEGREES
!
!**********************************************************************
!
!  Use original connectivity, if present
!
        geo = 0.d0
        do i = 1, numat
          im1 = i - 1
          j = na(i)
          if (j == 0) then
            na(i) = 2
            nb(i) = 3
            nc(i) = 4
            if (i == 1) cycle
            sum = 1.d30
            do j = 1, im1
              r = (xyz(1,i) - xyz(1,j))**2 + (xyz(2,i) - xyz(2,j))**2 + (xyz(3,i) - xyz(3,j))**2
              if (.not.(r < sum .and. na(j) /= j .and. nb(j) /=j )) cycle
              sum = r
              k = j
            end do
  !
  !   ATOM I IS NEAREST TO ATOM K
  !
            na(i) = k
            j = k
            if (i > 2) nb(i) = na(k)
            nc(i) = nb(k)
!
!   FIND ANY ATOM TO RELATE TO NA(I)
!
          end if
          if (i > 3) then
!
!  Check that the angle na(i) - nb(i) - nc(i) is meaningful
!
            call bangle (xyz, na(i), nb(i), nc(i), sum)
            if (sum < 1.d-2 .or. Abs(pi - sum) < 1.d-2) then
!
!  Angle is zero or 180 degrees.  Search for an atom nearest to 90 degrees
!
              r = 2.d0
              l = 0
              do k = 1, im1
                if (k == na(i) .or. k == nb(i)) cycle
                call bangle (xyz, na(i), nb(i), k, sum)
                if (Abs(pi*0.5d0 - sum)  < r) then
                  r =  Abs(pi*0.5d0 - sum)
                  l = k
                  end if
                  if (r < 0.5d0) exit ! angle is acceptable
              end do
              nc(i) = l
            end if
            call dihed (xyz, i, j, nb(i), nc(i), geo(3,i))
          end if
          geo(3,i) = geo(3,i)*degree
          if (i > 2) call bangle (xyz, i, j, nb(i), geo(2,i))
          geo(2,i) = geo(2,i)*degree
          geo(1,i) = sqrt((xyz(1,i)-xyz(1,j))**2 + &
                          (xyz(2,i)-xyz(2,j))**2 + &
                          (xyz(3,i)-xyz(3,j))**2)
        end do
        na(1) = 0
        nb(1) = 0
        nc(1) = 0
        if (numat > 1) then
          nb(2) = 0
          nc(2) = 0
          if (numat > 2) nc(3) = 0
          na(2) = 1
        end if
        return
      end subroutine xyzint

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine pmep()
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use common_arrays_C, only : nat, geo, &
      & coord
      USE molkst_C, only : numat, keywrd, moperr, mxmep => itemp_1
      USE chanel_C, only : iw, mep_fn, imep
!***********************************************************************
!  THIS IS A DRIVING ROUTINE FOR COMPUTATIONS OF PMEP - PARAMETRIC
!  MOLECULAR ELECTROSTATIC POTENTIAL AS WELL AS  MEP CHARGES.
!
!  REF.  B. WANG AND G.P.FORD J.COMPT.CHEM. IN PRESS.
!        G.P.FORD AND B. WANG J.COMPT.CHEM. 14(1993)1101.
!
!                               WRITTEN BY BINGZE WANG, AUGUST 1993
!***********************************************************************
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer ::  nmep, i
      double precision, dimension(3,numat*50 + 1000) :: potpt
      double precision, dimension(107) :: alpw
      double precision :: t1
      double precision, external :: seconds
!-----------------------------------------------
      data alpw/ 2.92D0, 4*0.0D0, 4.36D0, 6.95D0, 9.22D0, 5.53D0, 0.0D0, 4*&
        0.0D0, 2.3D0, 2.6D0, 3.32D0, 17*0.0D0, 3.32D0, 72*0.0D0/
      data nmep/ 0/
!                                                 CHECK FOR SAVING TIME
      if (index(keywrd,' AM1') /= 0) then
        do i = 1, numat
          if (alpw(nat(i)) < 0.1D0) go to 30
        end do
!
        t1 = seconds(1)
!
        call gmetry (geo, coord)
        if (moperr) return
!                                              ***** CALCULATE MEP ONLY
        if (index(keywrd,' PMEP') /= 0) then
          open(unit=imep, file=mep_fn, status='UNKNOWN', position=&
            'asis')
          call mepmap (coord)
          if (moperr) return
          go to 20
        end if
         mxmep = 50*numat + 1000
!                         ***** CHOOSE SURFACE WHERE POINTS ARE SAMPLED
!
        if (index(keywrd,'WILLIAMS') /= 0) then
!                                                  THE WILLIAMS SURFACE
          call grids (coord, potpt, nmep)
          if (moperr) return
        else
!                                                  THE CONNOLLY SURFACE
          call surfa (coord, potpt, nmep)
          if (moperr) return
        end if
!                                           ***** CALCULATE MEP CHARGES
        call mepchg (coord, potpt, nmep)
!
   20   continue
        t1 = seconds(1) - t1
        write (iw, '(/1X,A,F9.2,A)') 'TIME TO CALCULATE MEP', t1, ' SECONDS'
        return
      end if
   30 continue
      write (iw, *) ' AM1 PARAMETERS FOR H,C,N,F AND CL ARE AVAILABLE.', &
        '  PMEP WAS NOT EXECUTED'
      return
      end subroutine pmep



      subroutine pmepco(pp, ria, w, ui, co, nonzo, id)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use common_arrays_C, only : nat, nfirst, nlast
      use molkst_C, only : numat
      use funcon_C, only : ev
!**********************************************************************
! PMEPCO IS THE CORE SUBROUTINE OF THIS PROGRAM <PMEP>. IT CALCULATES
! THE MEP AT AN ARBITRALRY POSITION W(3).
! REF.  B. WANG AND G.P.FORD J.COMPT.CHEM. IN PRESS
!       G.P.FORD AND B. WANG J.COMPT.CHEM. 14(1993)1101
!                                      WRITTEN BY BINGZE WANG FEB 1993
!**********************************************************************
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: nonzo
      integer , intent(in) :: id
      double precision , intent(out) :: ui
      double precision , intent(in) :: pp(*)
      double precision , intent(in) :: ria(*)
      double precision  :: w(3)
      double precision  :: co(3,*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: j, mn, i, ia, ib, ni, i2, i1, k
      double precision, dimension(10) :: e1b
      double precision, dimension(nonzo) :: vp
      double precision, dimension(107) :: alpw, aw
      double precision :: enuclr, rr, xx, yy, zz, fnear, enuc
!-----------------------------------------------
!                                    AM1 PARAMETERS (FOR H,C,N,O,F,CL)
      data alpw/ 2.92D0, 4*0.0D0, 4.36D0, 6.95D0, 9.22D0, 5.53D0, 0.0D0, 4*&
        0.0D0, 2.3D0, 2.6D0, 3.32D0, 17*0.0D0, 3.32D0, 72*0.0D0/
      data aw/ 0.05D0, 4*0.0D0, 0.63D0, 0.64D0, 0.67D0, 0.29D0, 0.0D0, 4*0.0D0&
        , 0.45D0, 0.37D0, 0.31D0, 17*0.0D0, 0.31D0, 72*0.0D0/
!
      vp(:nonzo) = 0.0D0
      mn = 0
      enuclr = 0.D0
      do i = 1, numat
        ia = nfirst(i)
        ib = nlast(i)
        ni = nat(i)
        if (id == 1) then
          rr = ria(i)
        else
          xx = w(1) - co(1,i)
          yy = w(2) - co(2,i)
          zz = w(3) - co(3,i)
          rr = sqrt(xx*xx + yy*yy + zz*zz)
        end if
        fnear = 1.0D0 + exp((-alpw(ni)*(rr-aw(ni))))
!
        call drotat (ni, co(1,i), w, e1b, enuc, rr)
        enuclr = enuclr + enuc*fnear
        i2 = 0
        do i1 = ia, ib
          if (i1 - ia + 1 > 0) then
            vp(mn+1:i1-ia+1+mn) = e1b(i2+1:i1-ia+1+i2)
            i2 = i1 - ia + 1 + i2
            mn = i1 - ia + 1 + mn
          end if
        end do
      end do
      mn = 0
      ui = 0.0D0
      do i = 1, numat
        ia = nfirst(i)
        ib = nlast(i)
        do j = ia, ib
          do k = ia, j
            mn = mn + 1
            if (k == j) then
              ui = ui + pp(mn)*vp(mn)
            else
              ui = ui + 2.0D0*pp(mn)*vp(mn)
            end if
          end do
        end do
      end do
      ui = (enuclr + ui)*ev
!                                                       UI  IN KCAL/MOL
      return
      end subroutine pmepco


      subroutine surfa(co, potpt, nmep)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use chanel_C, only : iw
      use molkst_C, only : keywrd, numat, mxmep => itemp_1
      use common_arrays_C, only : nat
!***********************************************************************
!   THIS SUBROUTINE CALCULATED THE MOLECULAR SURFACE AND WAS LIFTED
!   FROM M. CONNOLLY'S PROGRAM BY U.C.SINGH AND P.A.KOLLMAN.
!   IN THIS MODIFIED VERSION IT GENERATES THE SAMPLE POINTS ON FOUR
!   LAYERS OF VAN DER WAAL'S SURFACES.
!                                     BY BINGZE WANG ON 19 AUGUST 1993
!***********************************************************************
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(inout) :: nmep
      double precision , intent(in) :: co(3,*)
      double precision , intent(out) :: potpt(3,*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(:), allocatable :: ias
      integer ::  layer, ishel, i, ipoint, iatom, nnbr, jatom, ncon
      double precision, dimension(100) :: vander
      double precision, dimension(3,1000) :: con
      double precision, dimension(:), allocatable :: rad
      double precision, dimension(3,200) :: cnbr
      double precision, dimension(200) :: rnbr
      double precision, dimension(3) :: ci, temp0
      double precision, dimension(3,2) :: cw
      double precision :: scale, dens, scincr, pi, rw, den, ri, d2
      logical :: si
      double precision, external :: reada
      logical, external :: collis
!-----------------------------------------------
!
!     NEIGHBOR ARRAYS
!
!     THIS SAME DIMENSION FOR THE MAXIMUM NUMBER OF NEIGHBORS
!     IS USED TO DIMENSION ARRAYS IN THE LOGICAL FUNCTION COLLID
!
!
!              ARRAYS FOR ALL ATOMS, IATOM, JATOM AND KATOM COORDINATES
!                                        GEOMETRIC CONSTRUCTION VECTORS
!                                                     LOGICAL VARIABLES
!                                                     LOGICAL FUNCTIONS
!                                            DATA FOR VANDER VALL RADII
      data scale/ 1.4D0/
      data dens/ 1.0D0/
      data scincr/ 0.20D0/
      data layer/ 4/
      data vander/ 1.20D0, 1.20D0, 1.37D0, 1.45D0, 1.45D0, 1.50D0, 1.50D0, &
        1.40D0, 1.35D0, 1.30D0, 1.57D0, 1.36D0, 1.24D0, 1.17D0, 1.80D0, 1.75D0&
        , 1.70D0, 17*0.0D0, 2.3D0, 65*0.0D0/
!
      mxmep = 50*numat + 1000
      allocate (ias(mxmep), rad(mxmep))
      pi = 4.D0*atan(1.D0)
!                                    INSERT VAN DER WAAL RADII FOR ZINC
      vander(30) = 1.00D0
!
      if (index(keywrd,'SCALE=') /= 0) scale = reada(keywrd,index(keywrd,&
        'SCALE='))
      if (index(keywrd,'DEN=') /= 0) dens = reada(keywrd,index(keywrd,'DEN='))
      if (index(keywrd,'SCINCR=') /= 0) &
        scincr = reada(keywrd,index(keywrd,'SCINCR='))
      if (index(keywrd,'NSURF=') /= 0) &
        layer = nint(reada(keywrd,index(keywrd,'NSURF=')))
!
      do ishel = 1, layer
!                         ONLY VAN DER WAALS' TYPE SURFACE IS GENERATED
        rw = 0.0D0
        den = dens
        do i = 1, numat
          ipoint = nat(i)
          rad(i) = vander(ipoint)*scale
          if (rad(i) < 0.01D0) write (iw, &
      '(T2,''VAN DER WAALS'''' RADIUS FOR ATOM '',I3,          '' IS ZERO, SUPP&
      &LY A VALUE IN SUBROUTINE SURFAC)'' )')
          ias(i) = 2
        end do
!
!     BIG LOOP FOR EACH ATOM
!
        do iatom = 1, numat
          if (ias(iatom) == 0) cycle
!
!     TRANSFER VALUES FROM LARGE ARRAYS TO IATOM VARIABLES
!
          ri = rad(iatom)
          si = ias(iatom) == 2
          ci = co(:,iatom)
!                                GATHER THE NEIGHBORING ATOMS OF IATOM
          nnbr = 0
          do jatom = 1, numat
            if (iatom==jatom .or. ias(jatom)==0) cycle
            d2 = (ci(1)-co(1,jatom))**2 + (ci(2)-co(2,jatom))**2 + (ci(3)-co(3,&
              jatom))**2
            if (d2 >= (2*rw + ri + rad(jatom))**2) cycle
!
!     WE HAVE A NEW NEIGHBOR
!     TRANSFER ATOM COORDINATES, RADIUS AND SURFACE REQUEST NUMBER
!
            nnbr = nnbr + 1
            if (nnbr > 200) then
              write (iw, '(''ERROR'',2X,''TOO MANY NEIGHBORS:'',I5)') nnbr
              call mopend ('TOO MANY NEIGHBORS')
              return
            end if
            cnbr(:,nnbr) = co(:,jatom)
            rnbr(nnbr) = rad(jatom)
          end do
!
!     CONTACT SURFACE
!
          if (.not.si) cycle
          ncon = int((4*pi*ri**2)*den)
          ncon = min0(1000,ncon)
!
!     THIS CALL MAY DECREASE NCON SOMEWHAT
!
          if (ncon == 0) then
            write (iw, '(T2,''VECTOR LENGTH OF ZERO IN SURFAC'')')
            call mopend ('VECTOR LENGTH OF ZERO IN SURFAC')
            return
          end if
          call genvec (con, ncon)
!
!     CONTACT PROBE PLACEMENT LOOP
!
          do i = 1, ncon
            cw(:,1) = ci + (ri + rw)*con(:,i)
!
!     CHECK FOR COLLISION WITH NEIGHBORING ATOMS
!
            if (collis(cw(1,1),rw,cnbr,rnbr,nnbr,1)) cycle
            temp0 = ci + ri*con(:,i)
!
!     STORE POINT IN POTPT AND INCREMENT NMEP
!
            nmep = nmep + 1
            if (nmep > mxmep) go to 100
            potpt(1,nmep) = temp0(1)
            potpt(2,nmep) = temp0(2)
            potpt(3,nmep) = temp0(3)
          end do
        end do
        scale = scale + scincr
      end do
      return
  100 continue
      write (iw, 110)
      call mopend ('ERROR - TOO MANY POINTS GENERATED IN SURFAC.')
      return
  110 format(/,'ERROR - TO MANY POINTS GENERATED IN SURFAC'/,&
        '    REDUCE NSURF, SCALE, DEN, OR SCINCR')
      end subroutine surfa


      logical function collis (cw, rw, cnbr, rnbr, nnbr, ishape)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!****************************************************************
!     COLLISION CHECK OF PROBE WITH NEIGHBORING ATOMS
!     FOR CONNOLLY SURFACE ONLY.
!****************************************************************
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: nnbr
      integer , intent(in) :: ishape
      double precision , intent(in) :: rw
      double precision , intent(in) :: cw(3)
      double precision , intent(in) :: cnbr(3,200)
      double precision , intent(in) :: rnbr(200)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i
      double precision :: sumrad, vect1, vect2, vect3, sr2, dd2
!-----------------------------------------------
!
      collis = .FALSE.
      if (nnbr <= 0) return
!                 CHECK WHETHER PROBE IS TOO CLOSE TO ANY NEIGHBOR
      if (ishape == 3) then
      else
        do i = 1, nnbr
          sumrad = rw + rnbr(i)
          vect1 = dabs(cw(1)-cnbr(1,i))
          if (vect1 >= sumrad) cycle
          vect2 = dabs(cw(2)-cnbr(2,i))
          if (vect2 >= sumrad) cycle
          vect3 = dabs(cw(3)-cnbr(3,i))
          if (vect3 >= sumrad) cycle
          sr2 = sumrad**2
          dd2 = vect1**2 + vect2**2 + vect3**2
          if (dd2 < sr2) go to 20
        end do
      end if
      return
   20 continue
      collis = .TRUE.
      return
      end function collis


!
      subroutine drepp2(ni, rij, ri, core)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE parameters_C, only : natorb, tore, am, ad, aq, dd, qq
      USE funcon_C, only : a0, ev
!*********************************************************************
! DREPP2 CALCULATES THE INTEGRAL FOR PMEP.
! REFERENCE G.P.FORD AND B.WANG, J.COMPUT.CHEM. 14 (1993)1101.
!                            WRITTEN BY BINGZE WANG, 10 OCTOBER 1991.
!*********************************************************************
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: ni
      double precision , intent(in) :: rij
      double precision , intent(out) :: ri(22)
      double precision , intent(out) :: core(4,2)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i
      double precision, dimension(72) :: arg, sqr
      double precision ::  ev1, ev2, pp, r, aee, da, qa, ade, aqe, rsq, xxx&
        , ee
!-----------------------------------------------
      ev1 = ev*0.5D0
      ev2 = ev1*0.5D0
      data pp/ 0.5D00/
      r = rij/a0
      if (natorb(ni) < 3) then
!                                           HYDROGEN - HYDROGEN (SS/SS)
        aee = pp/am(ni)
        aee = aee*aee
        ri(1) = ev/dsqrt(r*r + aee)
        core(1,1) = ri(1)
        core(1,2) = tore(ni)*ri(1)
      else
!                                                 HEAVY ATOM - HYDROGEN
        aee = pp/am(ni)
        aee = aee*aee
        da = dd(ni)
        qa = qq(ni)*2.0D0
        ade = pp/ad(ni)
        ade = ade*ade
        aqe = pp/aq(ni)
        aqe = aqe*aqe
        rsq = r*r
        arg(1) = rsq + aee
        xxx = r + da
        arg(2) = xxx*xxx + ade
        xxx = r - da
        arg(3) = xxx*xxx + ade
        xxx = r + qa
        arg(4) = xxx*xxx + aqe
        xxx = r - qa
        arg(5) = xxx*xxx + aqe
        arg(6) = rsq + aqe
        arg(7) = arg(6) + qa*qa
        do i = 1, 7
          sqr(i) = dsqrt(arg(i))
        end do
        ee = ev/sqr(1)
        ri(1) = ee
        ri(2) = ev1/sqr(2) - ev1/sqr(3)
        ri(3) = ee + ev2/sqr(4) + ev2/sqr(5) - ev1/sqr(6)
        ri(4) = ee + ev1/sqr(7) - ev1/sqr(6)
        core(1,1) = ri(1)
        core(2,1) = ri(2)
        core(3,1) = ri(3)
        core(4,1) = ri(4)
        core(1,2) = tore(ni)*ri(1)
      end if
      return
      end subroutine drepp2


!
      subroutine drotat(ni, xi, xj, e1b, enuc, rij)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE rotate_C, only : ccore, css1, csp1, cpps1, cppp1
      use parameters_C, only : natorb, tore
!**********************************************************************
!  SUBROUTINE DROTAT TRANSFORMS THE INTEGRALS FROM LOCAL COORDINATES
!  INTO MOLECULAR COORDINATES FOR PMEP COMPUTATIONS.
!                                  WRITTEN BY BINGZE WANG, NOV. 1991
!**********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: ni
      double precision , intent(out) :: enuc
      double precision  :: rij
      double precision , intent(in) :: xi(3)
      double precision , intent(in) :: xj(3)
      double precision , intent(out) :: e1b(10)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      double precision, dimension(3) :: x, y, z
      double precision, dimension(22) :: ri
      double precision :: rijx, gam, a, xx11, xx21, xx22, xx31, xx32, xx33, yy11, &
        yy21, yy22, zz11, zz21, zz22, zz31, zz32, zz33, yyzz11, yyzz21, yyzz22
!-----------------------------------------------
      xx11 = 0.d0
      xx21 = 0.d0
      xx22 = 0.d0
      xx31 = 0.d0
      xx32 = 0.d0
      xx33 = 0.d0
      yyzz11 = 0.d0
      yyzz21 = 0.d0
      yyzz22 = 0.d0
      zz31 = 0.d0
      zz32 = 0.d0
      zz33 = 0.d0

      x(1) = xi(1) - xj(1)
      x(2) = xi(2) - xj(2)
      x(3) = xi(3) - xj(3)
      rijx = rij
!                                   COMPUTE INTEGRALS IN DIATOMIC FRAME
      call drepp2 (ni, rij, ri, ccore)
!
      gam = ri(1)
      a = 1.D0/rijx
      x(1) = x(1)*a
      x(2) = x(2)*a
      x(3) = x(3)*a
      if (dabs(x(3)) > 0.99999D0) then
        x(3) = dsign(1.D0,x(3))
        y(1) = 0.D0
        y(2) = 1.D0
        y(3) = 0.D0
        z(1) = 1.D0
        z(2) = 0.D0
        z(3) = 0.D0
      else
        z(3) = dsqrt(1.D0 - x(3)*x(3))
        a = 1.D0/z(3)
        y(1) = -a*x(2)*dsign(1.D0,x(1))
        y(2) = dabs(a*x(1))
        y(3) = 0.D0
        z(1) = -a*x(1)*x(3)
        z(2) = -a*x(2)*x(3)
      end if
      if (natorb(ni) > 1) then
        xx11 = x(1)*x(1)
        xx21 = x(2)*x(1)
        xx22 = x(2)*x(2)
        xx31 = x(3)*x(1)
        xx32 = x(3)*x(2)
        xx33 = x(3)*x(3)
        yy11 = y(1)*y(1)
        yy21 = y(2)*y(1)
        yy22 = y(2)*y(2)
        zz11 = z(1)*z(1)
        zz21 = z(2)*z(1)
        zz22 = z(2)*z(2)
        zz31 = z(3)*z(1)
        zz32 = z(3)*z(2)
        zz33 = z(3)*z(3)
        yyzz11 = yy11 + zz11
        yyzz21 = yy21 + zz21
        yyzz22 = yy22 + zz22
      end if
!                               ROTATE THE NUCLEAR ATTRACTION INTEGRALS
      e1b(1) = -css1
      if (natorb(ni) == 4) then
        e1b(2) = -csp1*x(1)
        e1b(3) = (-cpps1*xx11) - cppp1*yyzz11
        e1b(4) = -csp1*x(2)
        e1b(5) = (-cpps1*xx21) - cppp1*yyzz21
        e1b(6) = (-cpps1*xx22) - cppp1*yyzz22
        e1b(7) = -csp1*x(3)
        e1b(8) = (-cpps1*xx31) - cppp1*zz31
        e1b(9) = (-cpps1*xx32) - cppp1*zz32
        e1b(10) = (-cpps1*xx33) - cppp1*zz33
      end if
      enuc = tore(ni)*gam
      return
      end subroutine drotat


!
      subroutine genvec(u, n)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!*******************************************************************
!  GENERATE UNIT VECTORS OVER SPHERE. FOR CONNOLLY SURFACE ONLY
!*******************************************************************
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(inout) :: n
      double precision , intent(out) :: u(3,n)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: nequat, nvert, nu, i, nhor, j
      double precision :: pi, fi, z, xy, fj, x, y
!-----------------------------------------------
      pi = 4.D0*atan(1.D0)
      nequat = int(sqrt(n*pi))
      nvert = nequat/2
      nu = 0
      l20: do i = 1, nvert + 1
        fi = (pi*(i - 1))/nvert
        z = cos(fi)
        xy = sin(fi)
        nhor = int(nequat*xy)
        nhor = max0(1,nhor)
        do j = 1, nhor
          fj = (2.D0*pi*(j - 1))/nhor
          x = dcos(fj)*xy
          y = dsin(fj)*xy
          if (nu >= n) exit  l20
          nu = nu + 1
          u(1,nu) = x
          u(2,nu) = y
          u(3,nu) = z
        end do
      end do l20
      n = nu
      return
      end subroutine genvec


!
      subroutine grids(co, potpt, nmep)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use chanel_C, only : iw
      use molkst_C, only : numat
      use common_arrays_C, only : nat
!********************************************************************
!   THIS SUBROUTINE CALCULATES THE WILLIAMS SURFACE OR GRIDS. IT IS
!   LIFTED FROM <ESP> BY B.H.BESLER AND K.M.MERZ.
!********************************************************************
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(inout) :: nmep
      double precision , intent(in) :: co(3,*)
      double precision , intent(out) :: potpt(3,*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, ia, npnt, l, jz
      double precision, dimension(53) :: vderw
      double precision, dimension(100) :: dist
      double precision, dimension(3) :: xmin, xmax
      double precision :: shell, grid, closer, vdmax, xstart, ystart, zstart, zgrid&
        , ygrid, xgrid
!-----------------------------------------------
!
      data vderw/ 53*0.0D0/
      vderw(1) = 2.4D0
      vderw(5) = 3.0D0
      vderw(6) = 2.9D0
      vderw(7) = 2.7D0
      vderw(8) = 2.6D0
      vderw(9) = 2.55D0
      vderw(15) = 3.1D0
      vderw(16) = 3.05D0
      vderw(17) = 3.0D0
      vderw(35) = 3.15D0
      vderw(53) = 3.35D0
      shell = 1.2D0
      grid = 0.8D0
      closer = 0.D0
!     CHECK IF VDERW IS DEFINED FOR ALL ATOMS
!
      do i = 1, numat
        if (vderw(nat(i)) == 0.0D0) go to 20
      end do
      go to 30
   20 continue
      write (iw, *) 'VAN DER WAALS'' RADIUS NOT DEFINED FOR ATOM', i
      write (iw, *) 'IN WILLIAMS SURFACE ROUTINE PDGRID!'
      call mopend (&
      'VAN DER WAALS'' RADIUS NOT DEFINED IN WILLIAMS SURFACE ROUTINE PDGRID!.'&
        )
      return
!     NOW CREATE LIMITS FOR A BOX
   30 continue
      xmin = 100000.0D0
      xmax = -100000.0D0
      do ia = 1, numat
        where (co(:,ia) - xmin < 0.D0)
          xmin = co(:,ia)
        end where
        where (co(:,ia) - xmax > 0.D0)
          xmax = co(:,ia)
        end where
      end do
!     ADD (OR SUBTRACT) THE MAXIMUM VDERW PLUS SHELL
      vdmax = 0.0D0
      vdmax = dmax1(maxval(vderw),vdmax)
      xmin = xmin - vdmax - shell
      xmax = xmax + vdmax + shell
! STEP GRID BACK FROM ZERO TO FIND STARTING POINTS
      xstart = 0.0D0
      xstart = xstart - grid
      do while(xstart > xmin(1))
        xstart = xstart - grid
      end do
      ystart = 0.0D0
      ystart = ystart - grid
      do while(ystart > xmin(2))
        ystart = ystart - grid
      end do
      zstart = 0.0D0
      zstart = zstart - grid
      do while(zstart > xmin(3))
        zstart = zstart - grid
      end do
      npnt = 0
      zgrid = zstart
  140 continue
      ygrid = ystart
  150 continue
      xgrid = xstart
  160 continue
      do l = 1, numat
        jz = nat(l)
        dist(l) = sqrt((co(1,l)-xgrid)**2+(co(2,l)-ygrid)**2+(co(3,l)-zgrid)**2&
          )
!     REJECT GRID POINT IF ANY ATOM IS TOO CLOSE
        if (dist(l) < vderw(jz) - closer) go to 200
      end do
! BUT AT LEAST ONE ATOM MUST BE CLOSE ENOUGH
      do l = 1, numat
        jz = nat(l)
        if (dist(l) > vderw(jz) + shell) cycle
        go to 190
      end do
      go to 200
  190 continue
      npnt = npnt + 1
      nmep = nmep + 1
      potpt(1,nmep) = xgrid
      potpt(2,nmep) = ygrid
      potpt(3,nmep) = zgrid
  200 continue
      xgrid = xgrid + grid
      if (xgrid <= xmax(1)) go to 160
      ygrid = ygrid + grid
      if (ygrid <= xmax(2)) go to 150
      zgrid = zgrid + grid
      if (zgrid <= xmax(3)) go to 140
      return
      end subroutine grids


      subroutine mepchg(co, potpt, nmep)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      USE common_arrays_C, only : ch, p, nat => nat
      USE elemts_C, only : elemnt
      use chanel_C, only : iw
      use molkst_C, only : keywrd, ux, uy, uz, numat, mpack, &
      mxmep => itemp_1
      use funcon_C, only : fpc_9, a0, fpc_1, fpc_8, ev
!**********************************************************************
!  MEPCHG CALCULATES THE MEP CHARGES BY FITTING THE QUANTUM POTENTIAL
!  TO THE COULOMB POTENTIAL.
!  REF.  B. WANG AND G.P.FORD J.COMPT.CHEM. IN PRESS.
!        G.P.FORD AND B. WANG J.COMPT.CHEM. 14(1993)1101.
!                                       BINGZE WANG ON 19 AUGUST 1993
!**********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: nmep
      double precision  :: co(3,*)
      double precision  :: potpt(3,*)
      double precision  :: al(1000)
      double precision  :: a(numat + 4,numat + 4)
      double precision  :: d(numat,nmep)
      double precision  :: d1(numat,nmep)
      logical       :: cequiv(numat,numat)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: iz, numat0, k, i, nonzo, ip, j, l, ieq
      double precision, dimension(numat) :: q
      double precision, dimension(mxmep) :: ep
      double precision, dimension(numat + 4) :: b
      double precision, dimension(mpack) :: pp
      double precision, dimension(numat) :: qsc, qq
      double precision :: rms, rrms, dipx, dipy, dipz, au, cf, bohr1, au1, dx&
        , dy, dz, xk, yk, zk, xp, yp, zp, dki, ui, ajk, det,qi, epc, epi, dip
      logical :: idip
! For Mopac BLAS
      double precision, external :: ddot, reada
!

!-----------------------------------------------
      iz = 0
      rms = 0.0D0
      rrms = 0.0D0
      dipx = 0.0D0
      dipy = 0.0D0
      dipz = 0.0D0
      dx = 0.d0
      dy = 0.d0
      dz = 0.d0
      idip = .FALSE.
      au = ev*fpc_9
!     cf = 5.2917715D0*1.601917D0/3.33564D0
      cf = fpc_1*a0*fpc_8*1.D-10
      bohr1 = 1.0D0/a0
      au1 = 1.0D0/au
      numat0 = numat + 1
!
      write (iw, 10)
   10 format(/,/,1x,'ATOMIC CHARGES DERIVED FROM MOLECULAR',&
        ' ELECTROSTATIC POTENTIAL')
      if (index(keywrd,' WILLIAMS') /= 0) then
        write (iw, '(8X,''(WILLIAMS SURFACES)''/)')
      else
        write (iw, '(8X,''(CONNOLLY SURFACES)''/)')
      end if
!
      if (index(keywrd,' CHARGE=') /= 0) iz = nint(reada(keywrd,index(keywrd,&
        ' CHARGE=')))
!                                                  DIPOLAR CONSTRAINTS
      if (index(keywrd,'DIPOLE') /= 0) then
        if (iz == 0) then
          idip = .TRUE.
          numat0 = numat + 4
          write (iw, '(/12X,''DIPOLE CONSTRAINTS WILL BE USED'',/)')
          dx = ux
          dy = uy
          dz = uz
          if (index(keywrd,'DIPX=') /= 0) dx = reada(keywrd,index(keywrd,&
            'DIPX='))
          if (index(keywrd,'DIPY=') /= 0) dy = reada(keywrd,index(keywrd,&
            'DIPY='))
          if (index(keywrd,'DIPZ=') /= 0) dz = reada(keywrd,index(keywrd,&
            'DIPZ='))
        else
          write (iw, *) ' DIPOLE CONSTRAINTS NOT USED FOR CHARGED MOLECULE'
        end if
      end if
      do k = 1, numat
        xk = co(1,k)
        yk = co(2,k)
        zk = co(3,k)
        do i = 1, nmep
          xp = potpt(1,i) - xk
          yp = potpt(2,i) - yk
          zp = potpt(3,i) - zk
          dki = sqrt(xp*xp + yp*yp + zp*zp)
          d(k,i) = dki
          d1(k,i) = a0/dki
        end do
      end do
!
!******  SET UP THE LINEAR EQUATION A*Q=B  *******
!                                       MEP AT SAMPLE POINTS & B MATRIX
      call packp (p, pp, nonzo)
      b(:numat) = 0.0D0
      do ip = 1, nmep
        call pmepco (pp, d(1,ip), potpt(1,ip), ui, co, nonzo, 1)
        ep(ip) = ui*au1
        b(:numat) = b(:numat) + ep(ip)*d1(:numat,ip)
      end do
      b(numat+1) = dble(iz)
      if (idip) then
        b(numat+2) = dx/cf
        b(numat+3) = dy/cf
        b(numat+4) = dz/cf
      end if
!                                                      THE A(J,K) ARRAY
      do k = 1, numat
        do j = 1, k
          ajk = 0.0D0
          ajk = sum(d1(k,:nmep)*d1(j,:nmep))
          a(k,j) = ajk
          a(j,k) = ajk
        end do
        a(numat+1,k) = 1.D0
        a(k,numat+1) = 1.D0
        if (.not.idip) cycle
        a(numat+2,k) = co(1,k)*bohr1
        a(numat+3,k) = co(2,k)*bohr1
        a(numat+4,k) = co(3,k)*bohr1
        a(k,numat+2) = a(numat+2,k)
        a(k,numat+3) = a(numat+3,k)
        a(k,numat+4) = a(numat+4,k)
      end do
      a(numat+1,numat+1) = 0.D0
      if (idip) then
        a(numat+2,numat+2) = 0.D0
        a(numat+3,numat+3) = 0.D0
        a(numat+4,numat+4) = 0.D0
      end if
!                                                            SOLVE AQ=B
      l = 0
      do i = 1, numat0
        al(l+1:numat0+l) = a(i,:numat0)
        l = numat0 + l
      end do
      call osinv (al, numat0, det)
      l = 0
      do i = 1, numat
        qi = 0.0D0
        if (numat0 > 0) then
          qi = sum(al(l+1:numat0+l)*b(:numat0))
          l = numat0 + l
        end if
        q(i) = qi
      end do
      qi = det ! dummy use of det
!                               AVERAGE CHARGES EQUIVALENT BY SYMMETRY
      if (index(keywrd,'SYMAVG') /= 0) then
        do i = 1, numat
          do j = 1, numat
            cequiv(i,j) = .FALSE.
            if (abs(abs(ch(i))-abs(ch(j))) >= 1.D-5) cycle
            cequiv(i,j) = .TRUE.
          end do
        end do
        do i = 1, numat
          ieq = 0
          qsc(i) = 0.D0
          do j = 1, numat
            if (.not.cequiv(i,j)) cycle
            qsc(i) = qsc(i) + abs(q(j))
            ieq = ieq + 1
          end do
          qq(i) = q(i)/abs(q(i))*qsc(i)/ieq
        end do
        q(:numat) = qq(:numat)
      end if
!                              ROOT MEAN SQUARE (RMS) AND RELATIVE RMS
      do i = 1, nmep
        epi = ep(i)
        epc = sum(q(:numat)*d1(:numat,i))
        epc = epc - epi
        rms = rms + epc*epc
        rrms = rrms + epi*epi
      end do
      rms = sqrt(rms/nmep)
      rrms = rms/sqrt(rrms/nmep)
      rms = rms*au
!
      write (iw, '(3X,''ATOM NO.    TYPE    CHARGE'')')
      do i = 1, numat
        write (iw, '(5X,I2,9X,A2,1X,F10.4)') i, elemnt(nat(i)), q(i)
      end do
!
      write (iw, '(/2X,A,4X,I6)') 'NUMBER OF POINTS ', nmep
      write (iw, '(2X,A,4X,F9.4)') 'RMS DEVIATION ', rms
      write (iw, '(2X,A,3X,F9.4)') 'RRMS DEVIATION ', rrms
!
      if (iz /= 0) return
!                                    DIPOLE MOMENT FOR NEUTRAL MOLECULE
      dipx = dipx + ddot(numat,co(1,:numat),1,q(:numat),1)
      dipy = dipy + ddot(numat,co(2,:numat),1,q(:numat),1)
      dipz = dipz + ddot(numat,co(3,:numat),1,q(:numat),1)
      dipx = dipx*bohr1
      dipy = dipy*bohr1
      dipz = dipz*bohr1
      dip = sqrt(dipx*dipx + dipy*dipy + dipz*dipz)
      write (iw, '(2/1X,''DIPOLE MOMENT EVALUATED FROM THE MEP CHARGES'')')
      write (iw, '(7X,''D(X)     D(Y)     D(Z)     TOTAL'')')
      write (iw, '(3X,4F9.4)') dipx*cf, dipy*cf, dipz*cf, dip*cf
!
      return
      end subroutine mepchg


!
      subroutine mepmap(c1)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : keywrd, moperr, numat, lm61
      use common_arrays_C, only : nat, p
      use chanel_C, only : iw, imep
      use elemts_C, only : elemnt
!*********************************************************************
!  SUBROUTINE MEPMAP CALCULATES THE MEP MINIMA AND GENERATES THE
!  CONROUR DATA IN A DEFINED PLANE.
!  REF.  G.P.FORD AND B. WANG J.COMPT.CHEM. 14(1993)1101.
!                                    WRITTEN BY BINGZE WANG, DEC 1992
!*********************************************************************
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision  :: c1(3,numat)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(numat) :: mx, my
      integer :: need1, natm, icase, iback, i, nonzo, npx, npy, k, ip, &
        m, n, imin, ny, minima, j
      double precision, dimension(lm61) :: pp
      double precision, dimension(3) :: w, r0
      double precision, dimension(3,3) :: t
      double precision, dimension(numat) :: ria, vmin
      double precision, dimension(3,numat) :: cw
      double precision, dimension(200) :: uu
      double precision, dimension(3,numat) :: cmep
      double precision :: step, cut, z0, xm, ym, t11, t12, t13, t21, t22, t23, t31&
        , t32, t33, xx0, yy0, zz0, xxw, yyw, zzw, step1, xx1, yy1, zz1, stepm, &
        xx2, yy2, zz2, stepn, rmin, rr, ui
      logical :: prtmep, minmep
!-----------------------------------------------
      data t/ 1.0D0, 3*0.0D0, 1.0D0, 3*0.0D0, 1.0D0/
      data step/ 0.1D0/
      data need1/ 0/
      data natm/ 0/
      data r0/ 3*0.0D0/
      data cut/ 999.0D0/
      data icase/ 0/
      data z0/ 0.0D0/
      data iback/ 0/
      write (iw, 10)
   10 format(/,/,/,13x,'MOLECULAR ELECTROSTATIC POTENTIAL',/,/,1x,&
        'REFERENCES  B.WANG AND G.P.FORD J.COMP.CHEM. 15, 200:207 (1994)',/,13x,&
        'G.P.FORD AND B.WANG J.COMPT.CHEM. 14(1993)1101')
      call meprot (c1, r0, t, xm, ym, icase, step, cmep, z0, iback)
      if (moperr) return
      if (iback > 0) return
      prtmep = index(keywrd,' PRTMEP') /= 0
      minmep = index(keywrd,' MINMEP') /= 0
      cw(1,:numat) = cut
      cw(2,:numat) = cut
      cw(3,:numat) = cut
      vmin(:numat) = cut
!
      call packp (p, pp, nonzo)
!
      npx = int(xm/step)*2 + 1
      if (icase==2 .or. icase==3) then
        ym = ym + 3.0D0
        npy = int(ym/step) + 1
      else
        npy = int(ym/step)*2 + 1
      end if
      if (prtmep) then
        write (imep, 30) numat, npx, npy, (-xm), (-ym), step
   30   format(1x,3i5,3f8.2,/)
        write (imep, 130) npx, npy, npx*npy, z0, (-xm), step, (-ym), step
        write (imep, 140)
        write (imep, 150) (i,nat(i),(cmep(k,i),k=1,2),i=1,numat)
        write (imep, *)
      end if
!                                   CREATE THE POINTS AND CALCULATE MEP
      ip = 0
      t11 = t(1,1)
      t12 = t(1,2)
      t13 = t(1,3)
      t21 = t(2,1)
      t22 = t(2,2)
      t23 = t(2,3)
      t31 = t(3,1)
      t32 = t(3,2)
      t33 = t(3,3)
      xx0 = z0*t31
      yy0 = z0*t32
      zz0 = z0*t33
      xxw = xx0 + r0(1)
      yyw = yy0 + r0(2)
      zzw = zz0 + r0(3)
      step1 = step
   40 continue
      xx1 = xx0 + r0(1)
      yy1 = yy0 + r0(2)
      zz1 = zz0 + r0(3)
!
      do m = 1, npx
        stepm = (m - 1)*step1
        xx2 = xx1 + stepm*t11
        yy2 = yy1 + stepm*t12
        zz2 = zz1 + stepm*t13
        l60: do n = 1, npy
          uu(n) = cut
          stepn = (n - 1)*step1
          w(1) = xx2 + stepn*t21
          w(2) = yy2 + stepn*t22
          w(3) = zz2 + stepn*t23
          if (need1 == 0) then
!                                          CHECK IF TOO CLOSE TO NUCLEI
            rmin = 81.0D0
            imin = 0
            do i = 1, numat
              rr = (w(1)-c1(1,i))**2 + (w(2)-c1(2,i))**2 + (w(3)-c1(3,i))**2
              if (rr < 0.25D0) cycle  l60
              if (nat(i)>1 .and. rr<0.36D0) cycle  l60
              ria(i) = sqrt(rr)
              if (rmin <= rr) cycle
              rmin = rr
              imin = i
            end do
            call pmepco (pp, ria, w, ui, c1, nonzo, 1)
            uu(n) = ui
            if (ui < vmin(imin)) then
              vmin(imin) = ui
              cw(1,imin) = w(1)
              cw(2,imin) = w(2)
              cw(3,imin) = w(3)
              mx(imin) = m
              my(imin) = n
            end if
          else
            call pmepco (pp, ria, w, ui, c1, nonzo, 0)
            if (ui < vmin(natm)) then
              vmin(natm) = ui
              cw(1,natm) = w(1)
              cw(2,natm) = w(2)
              cw(3,natm) = w(3)
            end if
          end if
          ip = ip + 1
        end do l60
        if (.not.(need1==0 .and. prtmep)) cycle
        write (imep, 160) (uu(ny),ny=1,npy)
      end do
!
      if (need1 == 0) write (iw, 170) npx, npy
      if (prtmep .and. need1==0) write (iw, *) &
        '=> CONTOUR FILE IS PRINTED ON CHANNEL 7'
      if (need1 <= 0) then
!                                               REMOVE THE FALSE MINIMA
        minima = 0
        l90: do i = 1, numat
          if (vmin(i) > 0.0D0) cycle  l90
          do m = mx(i) - 1, mx(i) + 1
            stepm = (m - 1)*step
            xx2 = xxw + stepm*t11
            yy2 = yyw + stepm*t12
            zz2 = zzw + stepm*t13
            do n = my(i) - 1, my(i) + 1
              stepn = (n - 1)*step
              w(1) = xx2 + stepn*t21
              w(2) = yy2 + stepn*t22
              w(3) = zz2 + stepn*t23
              ip = ip + 1
              call pmepco (pp, ria, w, ui, c1, nonzo, 0)
              if (ui >= vmin(i) - 0.001D0) cycle
              vmin(i) = 99.0D0
              cycle  l90
            end do
          end do
          minima = minima + 1
        end do l90
        if (minima == 0) then
          write (iw, *) ' NO MEP MINIMUM FOUND IN THIS PLANE'
          return
        end if
        if (.not.minmep) go to 110
        need1 = 1
        step1 = step*0.2D0
        npx = 11
        npy = 11
      end if
      natm = natm + 1
      if (natm > numat) go to 110
      do while(vmin(natm) > 0.0D0)
        natm = natm + 1
        if (natm > numat) go to 110
      end do
      r0(1) = cw(1,natm) - step*(t11 + t21)
      r0(2) = cw(2,natm) - step*(t12 + t22)
      r0(3) = cw(3,natm) - step*(t13 + t23)
      go to 40
  110 continue
      if (need1 > 0) write (iw, 180) ip
      write (iw, 190)
      do i = 1, numat
        if (vmin(i) >= 0.0D0) cycle
        write (iw, 200) i, elemnt(nat(i)), vmin(i), dsqrt((c1(1,i)-cw(1,i))**2+&
          (c1(2,i)-cw(2,i))**2+(c1(3,i)-cw(3,i))**2), (cw(j,i),j=1,3)
      end do
      return
  130 format(22x,'INSTRUCTION',/,1x,'1) NX*NY = ',i3,'*',i3,' =',i6,' GRIDS;',/&
        ,1x,'2) NY VALUES IN EACH OF THE NX BLOCKS;',/,1x,&
        '3) X,Y COORDINATES (Z=',f6.2,' ) OF THE GRIDS:',/,9x,'X(I)=',f8.2,'+',&
        f6.2,'*(I-1)    I=1,2,...,NX',/,9x,'Y(J)=',f8.2,'+',f6.2,&
        '*(J-1)    I=1,2,...,NY')
  140 format(1x,'4) THE MOLECULAR COORDINATES (X,Y)',&
        ' ON THE 2D-MEP CONTOUR MAP')
  150 format(9x,2i4,2f12.5)
  160 format(6f11.5)
  170 format(/,1x,'GRIDS NX*NY=',i3,' *',i3)
  180 format(1x,'TOTAL NUMBER OF THE POINTS CALCULATED ',i8)
  190 format(/,1x,'MINIMA IN THE SPECIFIED PLANE',/,5x,&
        'ATOM       UMIN      DISTANCE',10x,'XYZ COORDINATE',/,15x,&
        'KCAL/MOL     ANG',14x,'IN MOL COORD')
  200 format(3x,i3,2x,a2,2x,f9.1,4x,f6.2,4x,3f9.3)
      end subroutine mepmap


!
      subroutine meprot(c, r0, t, xm, ym, icase, step, c1, z0, iback)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : keywrd, numat, line
      use common_arrays_C, only : nat
      use chanel_C, only : iw, ir
!*********************************************************************
! MEPROT ROTATES THE MOLECULE TO CHOOSE THE PLANE IN WHICH MEP IS
! TO BE COMPUTED.
!                                     BY BINGZE WANG  28 OCT 1992
!*********************************************************************
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: icase
      integer , intent(out) :: iback
      double precision , intent(out) :: xm
      double precision , intent(out) :: ym
      double precision , intent(in) :: step
      double precision  :: z0
      double precision , intent(in) :: c(3,*)
      double precision , intent(inout) :: r0(3)
      double precision , intent(inout) :: t(3,3)
      double precision , intent(out) :: c1(3,*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer ::  n1, n2, n3, i, k, j, is, il
      double precision, dimension(3) :: c0
      double precision :: x2, y2, z2, rr2, r2, r21, x3, y3, z3, rr3, r3, r31, cos1&
        , p41, x34, y34, z34, r341, x6, y6, z6, x62, y62, z62, r621, x4, y4, z4&
        , x63, y63, z63, r631, r41, z5, y5, x5, r51, xi, yi, cs, cl
      double precision, external :: reada
!-----------------------------------------------
      data c0/ 3*0.0D0/
!
   10 format(/,1x,'INPUT CARD FOR PMEPR: ICASE,I,J,K,Z0 =',4i4,f8.2)
   20 format(1x,'ICASE SHOULD BE 1,2, OR 3 AS PMEPR IS SPECIFIED',/,1x,&
        'PMEPR WAS NOT EXECUTED')
   30 format(1x,'THE THREE REFERENTIAL ATOMS ARE UNREASONABLE, ',/,1x,&
        'PMEPR WAS NOT EXECUTED')
      if (index(keywrd,' PMEPR') /= 0) then

        read (ir, "(a80)") line
        i = len_trim(line)
        call upcase (line, i)
        i = index(line, "ICASE")
        if(i /= 0) then
          icase = nint(reada(line, i))
          i = index(line, " N1")
          n1 = nint(reada(line, i + 4))
          i = index(line, " N2")
          n2 = nint(reada(line, i + 4))
          i = index(line, " N3")
          n3 = nint(reada(line, i + 4))
          i = index(line, " Z0")
          z0 = reada(line, i + 4)
        else
          read(line,*) icase, n1, n2, n3, z0
        end if
        write (iw, 10) icase, n1, n2, n3, z0
        if (icase<1 .or. icase>3) then
          write (iw, 20)
          iback = 1
          return
        end if
        if (n1==n2 .or. n1==n3 .or. n2==n3 .or. n1>numat .or. n2>numat .or. n3>&
          numat) then
          write (iw, 30)
          iback = 1
          return
        end if
        if (icase == 1) then
          if (abs(z0) < 0.0001D0) then
            write (iw, 40) n1, n2, n3
          else
            write (iw, 50) z0, n1, n2, n3
          end if
        end if
   40   format(1x,'MEPS ARE IN THE PLANE DEFINED BY ATOMS',3i4)
   50   format(1x,'MEPS ARE IN THE PLANE',f6.2,' ABOVE THAT DEFINED BY ATOMS',&
          3i4)
        if (icase == 2) then
          if (abs(z0) < 0.0001D0) then
            write (iw, 60) n1, n2, n3, n1, n2
          else
            write (iw, 70) n1, n2, n3, n1, n2, z0
          end if
        end if
   60   format('line buggy')
   70   format(1x,'Line buggy')
        if (icase == 3) then
          if (abs(z0) < 0.0001D0) then
            write (iw, 80) n2, n1, n3
          else
            write (iw, 90) n2, n1, n3, z0
          end if
        end if
   80   format(1x,'MEPS ARE IN THE PLANE BISECTING THE ANGLE (',3i3,')')
   90   format(1x,'MEPS ARE IN THE PLANE BISECTING THE ANGLE (',3i3,')',/,5x,&
          'BUT NON-ZERO VALUE Z0=',f6.2,' MAKES NO SENSE',' AND IS IGNORED')
      end if
      if (icase <= 1) then
        c1(1,:numat) = c(1,:numat)
        c1(2,:numat) = c(2,:numat)
        c1(3,:numat) = c(3,:numat)
        go to 150
      end if
!                                            MOVE THE ORIGIN TO ATOM N1
      c1(1,:numat) = c(1,:numat) - c(1,n1)
      c1(2,:numat) = c(2,:numat) - c(2,n1)
      c1(3,:numat) = c(3,:numat) - c(3,n1)
!
      x2 = c1(1,n2)
      y2 = c1(2,n2)
      z2 = c1(3,n2)
      rr2 = x2*x2 + y2*y2 + z2*z2
      r2 = dsqrt(rr2)
      r21 = 1.0D0/r2
      x3 = c1(1,n3)
      y3 = c1(2,n3)
      z3 = c1(3,n3)
      rr3 = x3*x3 + y3*y3 + z3*z3
      r3 = dsqrt(rr3)
      r31 = 1.0D0/r3
      cos1 = (rr3 + rr2 - (x3 - x2)**2 - (y3 - y2)**2 - (z3 - z2)**2)*(0.5D0*&
        r31*r21)
      if (1.0D0 - dabs(cos1) < 0.01D0) then
        write (6, 190) dacos(cos1)
        call mopend ('Error in PMEP')
        return
      end if
!
      if (icase==1 .or. icase==2) then
!                                            CHOOSE X-AXIS FOR CASE 1,2
        t(1,1) = x2*r21
        t(1,2) = y2*r21
        t(1,3) = z2*r21
!                                           Y-AXIS FOR CASE 1, Z CASE 2
        p41 = r3*cos1*r21
        x34 = x3 - p41*x2
        y34 = y3 - p41*y2
        z34 = z3 - p41*z2
        r341 = 1.0D0/dsqrt(x34*x34 + y34*y34 + z34*z34)
        if (icase == 1) then
          t(2,1) = x34*r341
          t(2,2) = y34*r341
          t(2,3) = z34*r341
        else
          t(3,1) = -x34*r341
          t(3,2) = -y34*r341
          t(3,3) = -z34*r341
        end if
      end if
!                                           CHOOSE X, Z-AXES FOR CASE 3
      if (icase == 3) then
        if (r3 > r2) then
          x6 = r2*r31
          y6 = x6*y3
          z6 = x6*z3
          x6 = x6*x3
          x62 = x6 - x2
          y62 = y6 - y2
          z62 = z6 - z2
          r621 = 1.0D0/dsqrt(x62*x62 + y62*y62 + z62*z62)
          t(3,1) = -x62*r621
          t(3,2) = -y62*r621
          t(3,3) = -z62*r621
          x4 = (x2 + x6)*0.5D0
          y4 = (y2 + y6)*0.5D0
          z4 = (z2 + z6)*0.5D0
        else
          x6 = r3*r21
          y6 = x6*y2
          z6 = x6*z3
          x6 = x6*x2
          x63 = x6 - x3
          y63 = y6 - y3
          z63 = z6 - z3
          r631 = 1.0D0/dsqrt(x63*x63 + y63*y63 + z63*z63)
          t(3,1) = x63*r631
          t(3,2) = y63*r631
          t(3,3) = z63*r631
          x4 = (x3 + x6)*0.5D0
          y4 = (y3 + y6)*0.5D0
          z4 = (z3 + z6)*0.5D0
        end if
        r41 = 1.0D0/dsqrt(x4*x4 + y4*y4 + z4*z4)
        t(1,1) = x4*r41
        t(1,2) = y4*r41
        t(1,3) = z4*r41
      end if
!                                      Z FOR ICASE=1, Y FOR ICASE=2 & 3
      z5 = 1.0D0
      if (dabs(x2) > 0.1D0) then
        y5 = -(x2*z3 - x3*z2)/(x2*y3 - x3*y2)
        x5 = -(y5*y2 + z2)/x2
        go to 130
      end if
      if (dabs(x3) > 0.1D0) then
        y5 = -(x3*z2 - x2*z3)/(x3*y2 - x2*y3)
        x5 = -(y3*y5 + z3)/x3
        go to 130
      end if
      if (dabs(y3) > 0.1D0) then
        x5 = -(y3*z2 - y2*z3)/(x2*y3 - x3*y2)
        y5 = -(x5*x3 + z3)/y3
        go to 130
      end if
      if (dabs(y2) > 0.1D0) then
        x5 = -(y2*z3 - y3*z2)/(x3*y2 - x2*y3)
        y5 = -(x5*x2 + z2)/y2
        go to 130
      else
        write (iw, 200) x2, y2, x3, y3
        call mopend ('Error in PMEP')
        return
      end if
  130 continue
      r51 = 1.0D0/dsqrt(x5*x5 + y5*y5 + 1.0D0)
      k = 3
      if (icase /= 1) k = 2
      t(k,1) = x5*r51
      t(k,2) = y5*r51
      t(k,3) = z5*r51
!                            ROTATE THE MOLECULE TO NEW XYZ COORDINATES
      do k = 1, numat
        xi = t(1,1)*c1(1,k) + t(1,2)*c1(2,k) + t(1,3)*c1(3,k)
        yi = t(2,1)*c1(1,k) + t(2,2)*c1(2,k) + t(2,3)*c1(3,k)
        c1(3,k) = t(3,1)*c1(1,k) + t(3,2)*c1(2,k) + t(3,3)*c1(3,k)
        c1(1,k) = xi
        c1(2,k) = yi
      end do
!                                                   NON-WEIGHTED CENTER
  150 continue
      do j = 1, 2
        cs = 1.D6
        cl = -1.D6
        is = 0
        il = 0
        do i = 1, numat
          if (c1(j,i) < cs) then
            cs = c1(j,i)
            is = i
          end if
          if (c1(j,i) <= cl) cycle
          cl = c1(j,i)
          il = i
        end do
        c0(j) = (cs + cl)/2.0D0
        r0(j) = cl - c0(j) + 2.0D0
        if (nat(is)<=1 .and. nat(il)<=1) cycle
        r0(j) = r0(j) + 0.4D0
      end do
!                                                MOVE TO THE NEW CENTER
      c1(1,:numat) = c1(1,:numat) - c0(1)
      c1(2,:numat) = c1(2,:numat) - c0(2)
      xm = int(r0(1)/step)*step
      ym = int(r0(2)/step)*step
      if (icase<1 .or. icase>3) then
        r0(1) = ((-xm) + c0(1))*t(1,1) + ((-ym) + c0(2))*t(2,1)
        r0(2) = ((-xm) + c0(1))*t(1,2) + ((-ym) + c0(2))*t(2,2)
        r0(3) = ((-xm) + c0(1))*t(1,3) + ((-ym) + c0(2))*t(2,3)
      else
        if (icase == 1) then
          r0(1) = ((-xm) + c0(1))*t(1,1) + ((-ym) + c0(2))*t(2,1) + c(1,n1)
          r0(2) = ((-xm) + c0(1))*t(1,2) + ((-ym) + c0(2))*t(2,2) + c(2,n1)
          r0(3) = ((-xm) + c0(1))*t(1,3) + ((-ym) + c0(2))*t(2,3) + c(3,n1)
        else
          r0(1) = ((-xm) + c0(1))*t(1,1) + c0(2)*t(2,1) + c(1,n1)
          r0(2) = ((-xm) + c0(1))*t(1,2) + c0(2)*t(2,2) + c(2,n1)
          r0(3) = ((-xm) + c0(1))*t(1,3) + c0(2)*t(2,3) + c(3,n1)
        end if
      end if
      return
  190 format(1x,'N2-N1-N3=',f9.3,' DEGREES, ALMOST LINEAR!')
  200 format('X21,Y21,X31,Y31=',4f8.4,' WHY THEY ARE SO SMALL?')
      end subroutine meprot


!
      subroutine packp(p, pp, mn)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : numat
      use common_arrays_C, only : nfirst, nlast
!*********************************************************************
!  SUBROUTINE PACKP RE-WRITES THE DENSITY MATRIX.
!  WRITTEN BY BINGZE WANG, 20 OCTOBER 1991.
!*********************************************************************
!***********************************************************************
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(out) :: mn
      double precision , intent(in) :: p(*)
      double precision , intent(out) :: pp(*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, ia, ib, j, j1st
!-----------------------------------------------
      mn = 0
      do i = 1, numat
        ia = nfirst(i)
        ib = nlast(i)
        do j = ia, ib
          j1st = j*(j - 1)/2
          if (j - ia + 1 > 0) then
            pp(mn+1:j-ia+1+mn) = p(j1st+ia:j+j1st)
            mn = j - ia + 1 + mn
          end if
        end do
      end do
      return
      end subroutine packp

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

submodule (mopac_api:mopac_api_operations) mopac_api_finalize
  use chanel_C, only : iw ! file handle for main output file
  use Common_arrays_C, only : xparam, & ! values of coordinates undergoing optimization
    geo, & ! raw coordinates of atoms
    coord, & ! Cartesian coordinates of atoms
    grad, & ! gradients of heat
    p, & ! total density matrix
    q, & ! partial charges
    nat, & ! atomic number of each atom
    loc, & ! indices of atoms and coordinates marked for optimization
    bondab ! bond order matrix in packed triangular format
  use molkst_C, only : escf, & ! heat of formation
    moperr, & ! error status
    numat, & ! number of real atoms
    nvar, & ! number of coordinates to be optimized
    id, & ! number of lattice vectors
    keywrd, & ! keyword string to adjust MOPAC behavior
    voigt, & ! Voigt stress tensor
    mozyme, & ! logical flag for MOZYME calculations
    dummy, & ! dummy integer
    errtxt, & ! most recent error message
    use_disk ! logical flag to enable disk access
  use MOZYME_C, only : iorbs ! number of atomic orbitals for each atom
  use parameters_C, only : tore ! number of valence electrons per element
  use to_screen_C, only : dip, & ! dipole moments
    freq, cnorml ! vibrational properties

  implicit none

contains

  ! save properties and clean up after a MOPAC/MOZYME calculation
  module subroutine mopac_finalize(properties)
    type(mopac_properties), intent(out) :: properties
    integer :: status, i, j, size
    type(c_ptr), allocatable :: pptr(:)

    ! record properties
    if (.not. moperr) call mopac_record(properties)

    ! collect error messages & assign NULL pointers for memory safety
    if (moperr) then
      properties%charge = c_null_ptr
      properties%coord_update = c_null_ptr
      properties%coord_deriv = c_null_ptr
      properties%lattice_update = c_null_ptr
      properties%lattice_deriv = c_null_ptr
      properties%freq = c_null_ptr
      properties%disp = c_null_ptr
      properties%bond_index = c_null_ptr
      properties%bond_atom = c_null_ptr
      properties%bond_order = c_null_ptr
      call summary("",0)
      properties%nerror = dummy
      allocate(pptr(properties%nerror), stat=status)
      if (status /= 0) then
        properties%nerror = -properties%nerror
        properties%error_msg = c_null_ptr
        return
      else
        do i=1, properties%nerror
          call summary("",-i)
          size = len_trim(errtxt) + 1
          pptr(i) = create_copy(errtxt, [size])
        end do
      end if
      properties%error_msg = create_copy(pptr, [properties%nerror])
      call summary("",-abs(properties%nerror)-1)
    else
      properties%nerror = 0
    end if

    ! deallocate memory
    call setup_mopac_arrays(0,0)
    if (mozyme) call delete_MOZYME_arrays()

    ! turn use_disk back on
    use_disk = .true.

    ! close dummy output file to free up /dev/null
    close(iw)
  end subroutine mopac_finalize

  subroutine mopac_record(properties)
    type(mopac_properties), intent(out) :: properties
    integer, external :: ijbo
    double precision, external :: dipole, dipole_for_MOZYME
    integer :: status, i, j, k, kk, kl, ku, io, jo, natom_move, nlattice_move
    double precision :: valenc, sum, dumy(3)
    integer(c_int), pointer :: bond_index(:), bond_atom(:)
    real(c_double), pointer :: bond_order(:)

    ! trigger charge & dipole calculation
    call chrge (p, q)
    q(:numat) = tore(nat(:numat)) - q(:numat)
    call gmetry (geo, coord)
    if (id == 0) then
      if (mozyme) then
        sum = dipole_for_MOZYME(dumy, 2)
        properties%dipole = dumy
      else
        sum = dipole(p, coord, dumy, 1)
        properties%dipole = dip(:3,3)
      end if
    else
      properties%dipole = 0.d0
    end if
    ! save basic properties
    properties%heat = escf
    properties%charge = create_copy(q, [numat])
    properties%stress = voigt
    natom_move = nvar/3
    nlattice_move = 0
    do i=nvar/3-id+1, nvar/3
      if (nat(loc(1,3*i)) == 107) then
        natom_move = natom_move - 1
        nlattice_move = nlattice_move + 1
      end if
    end do
    ! save properties of moveable coordinates
    properties%coord_update = create_copy(xparam, [3*natom_move])
    properties%coord_deriv = create_copy(grad, [3*natom_move])
    if (nlattice_move > 0) then
      properties%lattice_update = create_copy(xparam(3*natom_move+1:), [3*nlattice_move])
      properties%lattice_deriv = create_copy(grad(3*natom_move+1:), [3*nlattice_move])
    else
      properties%lattice_update = c_null_ptr
      properties%lattice_deriv = c_null_ptr
    end if
    ! save vibrational properties if available
    if (index(keywrd, " FORCETS") /= 0) then
      properties%freq = create_copy(freq, [nvar])
      properties%disp = create_copy(cnorml, [nvar*nvar])
    else
      properties%freq = c_null_ptr
      properties%disp = c_null_ptr
    end if
    ! prune bond order matrix
    properties%bond_index = create_int(numat+1)
    call c_f_pointer(properties%bond_index, bond_index, [numat+1])
    if (mozyme) then
      ! 1st pass to populate bond_index
      bond_index(1) = 0
      do i = 1, numat
        io = iorbs(i)
        bond_index(i+1) = bond_index(i)
        valenc = 0.d0
        if (io == 1) then
          kk = ijbo (i, i) + 1
          valenc = 2.d0 * p(kk) - p(kk) ** 2
        else
          kk = ijbo (i, i)
          do j = 1, io
            do k = 1, j
              kk = kk + 1
              valenc = valenc - 2.d0*p(kk) * p(kk)
            end do
            valenc = valenc + p(kk) * p(kk)
            valenc = valenc + 2.d0 * p(kk)
          end do
        end if
        if (valenc > 0.01d0) then
          bond_index(i+1) = bond_index(i+1) + 1
        end if
        do j = 1, numat
          jo = iorbs(j)
          if (i /= j .and. ijbo (i, j) >= 0) then
            kl = ijbo (i, j) + 1
            ku = kl + io * jo - 1
            sum = 0.d0
            do k = kl, ku
              sum = sum + p(k) ** 2
            end do
            if (sum > 0.01d0) then
              bond_index(i+1) = bond_index(i+1) + 1
            end if
          end if
        end do
      end do
      ! 2nd pass to populate bond_atom and bond_order
      properties%bond_atom = create_int(bond_index(numat+1))
      call c_f_pointer(properties%bond_atom, bond_atom, [bond_index(numat+1)])
      properties%bond_order = create_real(bond_index(numat+1))
      call c_f_pointer(properties%bond_order, bond_order, [bond_index(numat+1)])
      do i = 1, numat
        io = iorbs(i)
        valenc = 0.d0
        if (io == 1) then
          kk = ijbo (i, i) + 1
          valenc = 2.d0 * p(kk) - p(kk) ** 2
        else
          kk = ijbo (i, i)
          do j = 1, io
            do k = 1, j
              kk = kk + 1
              valenc = valenc - 2.d0*p(kk) * p(kk)
            end do
            valenc = valenc + p(kk) * p(kk)
            valenc = valenc + 2.d0 * p(kk)
          end do
        end if
        kk = bond_index(i) + 1
        do j = 1, numat
          jo = iorbs(j)
          if (i /= j .and. ijbo (i, j) >= 0) then
            kl = ijbo (i, j) + 1
            ku = kl + io * jo - 1
            sum = 0.d0
            do k = kl, ku
              sum = sum + p(k) ** 2
            end do
            if (sum > 0.01d0) then
              bond_atom(kk) = j - 1
              bond_order(kk) = sum
              kk = kk + 1
            end if
          else if (valenc > 0.01d0) then
            bond_atom(kk) = j - 1
            bond_order(kk) = valenc
            kk = kk + 1
          end if
        end do
      end do
    else
      call bonds()
      ! 1st pass to populate bond_index
      bond_index(1) = 0
      do i = 1, numat
        bond_index(i+1) = bond_index(i)
        ku = i*(i-1)/2 + 1
        kl = (i+1)*(i+2)/2 - 1
        do j = 1, i
          if (bondab(ku) > 0.01d0) then
            bond_index(i+1) = bond_index(i+1) + 1
          end if
          ku = ku + 1
        end do
        do j = i+1, numat
          if (bondab(kl) > 0.01d0) then
            bond_index(i+1) = bond_index(i+1) + 1
          end if
          kl = kl + j
        end do
      end do
      ! 2nd pass to populate bond_atom and bond_order
      properties%bond_atom = create_int(bond_index(numat+1))
      call c_f_pointer(properties%bond_atom, bond_atom, [bond_index(numat+1)])
      properties%bond_order = create_real(bond_index(numat+1))
      call c_f_pointer(properties%bond_order, bond_order, [bond_index(numat+1)])
      do i = 1, numat
        ku = i*(i-1)/2 + 1
        kl = (i+1)*(i+2)/2 - 1
        kk = bond_index(i) + 1
        do j = 1, i
          if (bondab(ku) > 0.01d0) then
            bond_atom(kk) = j - 1
            bond_order(kk) = bondab(ku)
            kk = kk + 1
          end if
          ku = ku + 1
        end do
        do j = i+1, numat
          if (bondab(kl) > 0.01d0) then
            bond_atom(kk) = j - 1
            bond_order(kk) = bondab(kl)
            kk = kk + 1
          end if
          kl = kl + j
        end do
      end do
    end if
  end subroutine mopac_record

end submodule mopac_api_finalize

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine symtnn (geo, na)
!**********************************************************************
!
!  SYMTRY COMPUTES THE BOND LENGTHS AND ANGLES THAT ARE FUNCTIONS OF
!         OTHER BOND LENGTHS AND ANGLES.
!
! ON INPUT GEO     = KNOWN INTERNAL COORDINATES
!          NDEP    = NUMBER OF DEPENDENCY FUNCTIONS.
!          IDEPFN  = ARRAY OF DEPENDENCY FUNCTIONS.
!          LOCDEP  = ARRAY OF LABELS OF DEPENDENT ATOMS.
!          LOCPAR  = ARRAY OF LABELS OF REFERENCE ATOMS.
!
!  ON OUTPUT THE ARRAY "GEO" IS FILLED
!***********************************************************************
    use common_systm
    use common_symult
    use common_geosym
    implicit none
    double precision, dimension (3, natoms), intent (inout) :: geo
    integer, dimension (natoms), intent (in) :: na
    integer :: i, j, locn, n
    double precision :: value
!
!     NOW COMPUTE THE DEPENDENT PARAMETERS.
!
    n = 0
    do i = 1, ndep
      if (idepfn(i) == 19 .and. depmul(n+1) > 1.d-3) then
        n = n + 1
        call haddon (value, locn, idepfn(i), locpar(i), geo, na, depmul(n))
      else
        call haddon (value, locn, idepfn(i), locpar(i), geo, na, depmul(1))
      end if
      j = locdep(i)
      if(j <= natoms) geo(locn, j) = value
    end do
end subroutine symtnn

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

  subroutine alpb_and_xfac_mndod
    use parameters_C, only : xfac, alpb
    xfac = 0.d0
    alpb = 0.d0
    alpb(11, 1) =  1.05225212D0  !     Sodium - Hydrogen
    xfac(11, 1) =  1.00000000d0  !     Sodium - Hydrogen
    alpb(11, 6) =  1.05225212D0  !     Sodium - Carbon
    xfac(11, 6) =  1.00000000d0  !     Sodium - Carbon
    alpb(12, 1) =  1.35052992D0  !     Magnesium - Hydrogen
    xfac(12, 1) =  1.00000000d0  !     Magnesium - Hydrogen
    alpb(12, 6) =  1.48172071D0  !     Magnesium - Hydrogen
    xfac(12, 6) =  1.00000000d0  !     Magnesium - Hydrogen
    alpb(16,12) =  1.48172071D0  !     Sulfur - Magnesium
    xfac(16,12) =  1.00000000d0  !     Sulfur - Magnesium
    alpb(13, 1) =  1.38788000D0  !     Aluminum - Hydrogen
    xfac(13, 1) =  1.00000000d0  !     Aluminum - Hydrogen
    alpb(13, 6) =  1.38788000D0  !     Aluminum - Carbon
    xfac(13, 6) =  1.00000000d0  !     Aluminum - Carbon
    alpb(13,13) =  1.38788000D0  !     Aluminum - Aluminum
    xfac(13,13) =  1.00000000d0  !     Aluminum - Aluminum
  end subroutine alpb_and_xfac_mndod

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine geout (mode1, geo, na, nb, nc, labels, loc)
!*********************************************************************
!
!   GEOUT PRINTS THE CURRENT GEOMETRY.  IT CAN BE CALLED ANY TIME,
!         FROM ANY POINT IN THE PROGRAM AND DOES NOT AFFECT ANYTHING.
!         IF MODE1 .EQ.1 THEN GEOMETRY IS PRINTED IN USUAL .OUT FORMAT
!                  .GT.1 THEN GEOMETRY IS PRINTED IN .DAT FORMAT to
!                  CHANNEL MODE1
!
!*********************************************************************
    use common_systm, only : natoms, iw, maxtxt, ndep, numat, line
    use common_symult, only : depmul
    use common_keywrd, only : keywrd
    use common_geosym, only : locpar, idepfn, locdep
    use common_elemts, only : elemnt
    implicit none
    integer, intent (in) :: mode1, labels(natoms)
    integer, intent (in) :: na(natoms), nb(natoms), nc(natoms)
    integer, intent (inout) :: loc(2,3*natoms + 6)
    double precision, dimension (3, natoms), intent (in) :: geo
    integer :: mode, iprt, i, j, n, ia, ii, k, igui, store_maxtxt
    double precision :: degree, w, x 
    logical :: cart, lxyz, charge, gui = .false.
    character , dimension(3) :: q*2 
    character :: flag1*2, flag0*2,  blank*80, fmt1*4, fmt23*4
!*********************************************************************
!
!   GEOUT PRINTS THE CURRENT GEOMETRY.  IT CAN BE CALLED ANY TIME,
!         FROM ANY POINT IN THE PROGRAM AND DOES NOT AFFECT ANYTHING.
!
!   mode1:   1 write geometry in normal MOPAC *.out format
!           -n write geometry in normal MOPAC *.arc format, but do not print keywords, title
!              symmetry data, etc.
!            n write geometry in normal MOPAC *.arc format
!
!*********************************************************************
      mode = mode1 
      igui = -10 ! Set to impossible value
      store_maxtxt = maxtxt
      charge = (index(keywrd, " PRTCHAR") /= 0)
      lxyz = index(keywrd,' COORD') + index(keywrd,'VELO') /= 0 
      if (index(keywrd,' 0SCF')/=0 .and. lxyz) then 
!
!  If 0SCF and coord and a polymer, then get rid of TV.
!
        natoms = numat 
        lxyz = .FALSE. 
      endif 
      if (mode == 1) then 
        flag1 = ' *' 
        flag0 = '  ' 
        iprt = iw 
      else 
        if (gui) then
          flag1 = ' 1' 
          flag0 = ' 0' 
        else
          flag1 = '+1' 
          flag0 = '+0' 
        end if
        iprt = abs(mode) 
      endif 
      degree = 57.29577951308232D0 
      if (lxyz) degree = 1.D0 
      blank = ' '  
      cart = .true.
      do i = 1, natoms
        if (na(i) > 0) cart = .false.
      end do     
      fmt1  = "13.8"
      fmt23 = "13.7"
      if (maxtxt /= 0)  maxtxt = maxtxt + 2
      if (cart) then 
        x = 0.d0
        do i = 1, natoms
          x = min(x, geo(1,i), geo(2,i), geo(3,i))
        end do
        if (x < -99.99d0) then
          fmt1  = "14.8"
          fmt23 = "14.8"
        else
          fmt23 = "13.8"
        end if
        if (mode == 1) then
          if (maxtxt == 0) then
            i = 6
          else
            i = maxtxt/2 + 1
          end if
          write (iprt,'(4a)') &
             & "   ATOM "//blank(:maxtxt/2 + 1)//" CHEMICAL  "//blank(:i)//"  X               Y               Z"
          write (iprt,'(4a)') "  NUMBER "//blank(:maxtxt/2 + 1)//" SYMBOL" & 
          &//blank(:i)//"(ANGSTROMS)     (ANGSTROMS)     (ANGSTROMS)"
          write (iprt,*)
        else if (mode > 0) then         
          call wrttxt (iprt)
        end if
      else if (mode == 1) then
        j = max(9,maxtxt + 2) 
        if (maxtxt == 0) j = 8
        write (iprt,'(4a)') &
           & "  ATOM"//blank(:j/2)//"CHEMICAL "//blank(:(j + 1)/2)//" BOND LENGTH      BOND ANGLE     TWIST ANGLE "
        write (iprt,'(4a)') &
           & " NUMBER"//blank(:j/2)//"SYMBOL   "//blank(:(j + 1)/2)//"(ANGSTROMS)      (DEGREES)       (DEGREES) "
        write (iprt, "(A)") &
           & "   (I)       "//blank(:j)//"      NA:I           NB:NA:I    " // &
           & "   NC:NB:NA:I " // "      NA    NB    NC "
      else if (mode > 0) then
        call wrttxt (iprt)
      end if 
      if (.false. .and. cart) then
        n = 0
        do i = 1, natoms
          do j = 1, 3
            n = n + 1
            loc(1,n) = i
            loc(2,n) = j
          end do
        end do
      end if
      n = 1 
      ia = loc(1,1) 
      ii = 0 
      blank = " "
      do i = 1, natoms 
        do j = 1, 3 
          q(j) = flag0 
          if (ia /= i) cycle  
          if (j/=loc(2,n)) cycle  
          q(j) = flag1 
          n = n + 1 
          ia = loc(1,n) 
        end do         
        if (na(i) > 0) then
          w = geo(2,i)*degree 
          x = geo(3,i)*degree  
!
!  CONSTRAIN ANGLE TO DOMAIN 0 - 180 DEGREES
!
          w = w - aint(w/360.D0)*360.D0 
          if (w < -1.d-6) w = w + 360.D0 
          if (w > 180.000001D0) then 
            x = x + 180.D0 
            w = 360.D0 - w 
          endif 
!
!  CONSTRAIN DIHEDRAL TO DOMAIN -180 - 180 DEGREES
!
          x = x - aint(x/360.D0 + sign(0.5D0 - 1.D-9,x) - 1.D-9)*360.D0 
        else
          w = geo(2,i) 
          x = geo(3,i)  
        endif 
       
        blank = elemnt(labels(i))
        if (labels(i) /= 99 .and. labels(i) /= 107) ii = ii + 1 
      
        k = 4
        
        k = 0
      
        if (index(blank(:j),"(") /= 0) then
          if (index(blank(:j),")") == 0) then
            if (index(blank(j + 1:j + 1), ")") /= 0) j = j + 1
          end if
        end if
        if (labels(i) == 0) cycle  
    
        if (na(i) == igui .or. cart) then 
          if (mode /= 1) then !  Print suitable for reading as a data-set
            if (labels(i)/=99 .and. labels(i)/=107) then 
              if (maxtxt == 0 ) j = 4    
              if (charge) then
                write(line,'(a,f8.4)')blank(41:59 + k)
              else
                write(line,'(a,f8.4)')blank(41:59 + k)
              end if
              write (iprt, '(1X,A,F'//fmt1//',1X,A2,F'//fmt23//',1X,A2,F'//fmt23//',1X, A2, A)') &
                 blank(:j), geo(1,i), q(1), w, q(2), x, q(3),trim(line)
            else 
              write (iprt, '(1X,A,F'//fmt1//',1X,A2,F'//fmt23//',1X,A2,F'//fmt23//',1X,A2,a)') &
              blank(:j), geo(1,i), q(1), w, q(2), x, q(3), " "
            endif 
          else !  Print in output style
            if (maxtxt == 0) j = 9
            write (iprt, '(I6,6X,A,F'//fmt1//',1X,A2,F'//fmt23//',1X,A2,F'//fmt23//',1X,A2)') i&
              , blank(:j), geo(1,i), q(1), w, q(2), x, q(3) 
          endif 
        else 
          if (mode /= 1) then  !  Print suitable for reading as a data-set
            if (maxtxt == 0 ) j = 4
            if (labels(i) /= 99 .and. labels(i) /= 107) then 
              if (charge) then
                write(line,'(a,f8.4)')blank(41:41 + k)
              else
                write(line,'(a,f8.4)')blank(41:41 + k)
              end if
              write (iprt, &
                '(1X,A,F'//fmt1//',1X,A2,F'//fmt23//',1X,A2,F'//fmt23//',1X,A2,3I6,A)') &
                & blank(:j), geo(1,i), q(1), w, q(2), x, q(3), na(i), nb(i), nc(i), &
                trim(line) 
            else 
              write (iprt, '(1X,A,F'//fmt1//',1X,A2,F'//fmt23//',1X,A2,F'//fmt23//',1X,A2,3I6)') &
                blank(:j), geo(1,i), q(1), w, q(2), x, q(3), na(i), nb(i), nc(i) 
            endif 
          else !  Print in output style
            if (maxtxt == 0) j = 9
            write (iprt, &
              '(I6,6X,A,F'//fmt1//',1X,A2,F'//fmt23//',1X,A2,F'//fmt23//',1X,A2,I6,2I6)') i, &
              blank(:j), geo(1,i), q(1), w, q(2), x, q(3), na(i), nb(i), nc(i) 
          endif 
        endif 
      end do 
      maxtxt = store_maxtxt
      if (mode == 1) return  
      write (iprt, *) 
      if (ndep /= 0) then  
!
!   OUTPUT SYMMETRY DATA.
!
        n = 1
        i = 1
        outer_loop: do
          j = i
          do
            if (j == ndep) exit outer_loop
             !
             !  Group together symmetry functions of the same type
             !  (same reference atom, same reference function, same multiplier,
             !   if function 18 or 19)
             !  (Maximum number of dependent atoms on a line: 9)
             !
            if (locpar(j) /= locpar(j+1) .or. idepfn(j) /= idepfn(j+1) .or. &
                 & j-i >= 9) exit
            if (idepfn(i) == 18 .or. idepfn(i) == 19) then
              if (Abs(depmul(n) - depmul(n+1)) > 1.d-10) exit
              n = n + 1
            end if
            j = j + 1
          end do
          if (idepfn(i) == 18 .or. idepfn(i) == 19) then
            write (iprt, "(I4,I3,F13.9,10I5)") locpar (i), idepfn (i), &
                 & depmul(n), (locdep(k), k=i, j)
            n = n + 1
          else
            write (iprt, "(I4,I3,10I5)") locpar (i), idepfn (i), &
                 & (locdep(k), k=i, j)
          end if
          i = j + 1
        end do outer_loop
        if (idepfn(i) == 19 .or. idepfn(i) == 18) then
          write (iprt, "(I4,I3,F13.9,10I5)") locpar (i), idepfn (i), &
               & depmul(n), (locdep(k), k=i, j)
        else
          write (iprt, "(I4,I3,10I5)") locpar (i), idepfn (i), &
               & (locdep(k), k=i, j)
        end if
        write (iprt,*)
      end if
     
      end subroutine geout 

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine diagg (fao, nocc, nvir, idiagg, partp, indi)
!**********************************************************************
!
!  This is the most important operation of MOZYME - the matrix elements
!  involving occupied and virtual LMO's are annihilated by a single pass
!  Euler rotation.
!
!**********************************************************************
    use MOZYME_C, only: icocc_dim, fmo, ifmo, fmo_dim
    use common_arrays_C, only: eigs, p
    use molkst_C, only : mpack, norbs, numat
!
    implicit none
    integer, intent (in) :: idiagg, nocc, nvir, indi
    double precision, dimension (mpack), intent (inout) :: partp
    double precision, dimension (mpack), intent (in) :: fao
!
    integer :: nij, alloc_stat
    logical, dimension (:), allocatable :: latoms
    integer, dimension (:), allocatable :: iused
    double precision, dimension(:), allocatable :: storei, storej, ws, aov, aocc, avir
    allocate (storei(norbs), storej(norbs), ws(norbs), aov(numat), &
         & avir(norbs), aocc(Max(1, icocc_dim)), iused(numat), latoms(numat), &
         & stat=alloc_stat)
    if (alloc_stat /= 0) then
      call mopend("Insufficient memory to run DIAGG")
      return
    end if
    nij = fmo_dim
!**********************************************************************
!
!  In diagg1, all significant matrix elements are constructed.  These
!  nij elements are stored in fmo, and their indices are stored in ifmo.
!
!**********************************************************************

!
    call diagg1 (fao, nocc, nvir,  eigs(nocc+1:), ws, latoms,  ifmo, fmo, &
     & fmo_dim, nij, idiagg, avir, aocc, aov)
!
!**********************************************************************
!
!  In diagg2, the significant matrix elements are annihilated by a two by
!  two rotation.
!
!**********************************************************************

    call diagg2 (nocc, nvir, eigs(nocc+1:), iused, latoms, nij, idiagg, storei, storej)
!
    call density_for_MOZYME (p, indi, nocc, partp)
!
    deallocate (storei, storej, ws, aov, avir, aocc, iused, latoms)
    return
end subroutine diagg

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      double precision function reada (string, istart)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: istart
      character  :: string*(*)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i0, i9, idot, ineg, ipos, icapd, icape, ismld, ismle, l, i, &
        iadd, n, j
      logical :: expnnt
      double precision, external :: digit
!-----------------------------------------------
!     FORTRAN FUNCTION TO EXTRACT NUMBER FROM STRING
!
!
!     DEFINE ASCII VALUES OF NUMERIC FIELD CHARACTERS
      i0 = ichar('0')
      i9 = ichar('9')
      idot = ichar('.')
      ineg = ichar('-')
      ipos = ichar('+')
      icapd = ichar('D')
      icape = ichar('E')
      ismld = ichar('d')
      ismle = ichar('e')
!
      l = len(string)
!
!     FIND THE START OF THE NUMERIC FIELD
      do i = istart, l
        iadd = 0
        n = ichar(string(i:i))
!
!       SIGNAL START OF NUMERIC FIELD IF DIGIT FOUND
        if (n>=i0 .and. n<=i9) go to 20
!
!       ACCOUNT FOR CONSECUTIVE SIGNS [- AND(OR) +]
        if (n==ineg .or. n==ipos) then
          iadd = iadd + 1
          if (i + iadd > l) go to 50
          n = ichar(string(i+iadd:i+iadd))
          if (n>=i0 .and. n<=i9) go to 20
        end if
!
!       ACCOUNT FOR CONSECUTIVE DECIMAL POINTS (.)
        if (n /= idot) cycle
        iadd = iadd + 1
        if (i + iadd > l) go to 50
        n = ichar(string(i+iadd:i+iadd))
        if (n>=i0 .and. n<=i9) go to 20
      end do
      go to 50
!
!     FIND THE END OF THE NUMERIC FIELD
   20 continue
      expnnt = .FALSE.
      do j = i + 1, l
        iadd = 0
        n = ichar(string(j:j))
!
!       CONTINUE SEARCH FOR END IF DIGIT FOUND
        if (n>=i0 .and. n<=i9) cycle
!
!       CONTINUE SEARCH FOR END IF SIGN FOUND AND EXPNNT TRUE
        if (n==ineg .or. n==ipos) then
          if (.not.expnnt) go to 40
          iadd = iadd + 1
          if (j + iadd > l) go to 40
          n = ichar(string(j+iadd:j+iadd))
          if (n>=i0 .and. n<=i9) cycle
        end if
        if (n == idot) then
          iadd = iadd + 1
          if (j + iadd > l) go to 40
          n = ichar(string(j+iadd:j+iadd))
          if (n>=i0 .and. n<=i9) cycle
          if (n==icape .or. n==ismle .or. n==icapd .or. n==ismld) cycle
        end if
        if (n==icape .or. n==ismle .or. n==icapd .or. n==ismld) then
          if (expnnt) go to 40
          expnnt = .TRUE.
          cycle
        end if
        go to 40
      end do
      j = l + 1
   40 continue
      n = ichar(string(j-1:j-1))
      if (n==icape .or. n==ismle .or. n==icapd .or. n==ismld) j = j - 1
!
!     FOUND THE END OF THE NUMERIC FIELD (IT RUNS 'I' THRU 'J-1')
      n = 0
      n = n + index(string(i:j-1),'e')
      n = n + index(string(i:j-1),'E')
      n = n + index(string(i:j-1),'d')
      n = n + index(string(i:j-1),'D')
      if (n == 0) then
        reada = digit(string(i:j-1),1)
      else
        reada = digit(string(:i+n-2),i)*1.D1**digit(string(:j-1),i+n)
      end if
      return
!
!     DEFAULT VALUE RETURNED BECAUSE NO NUMERIC FIELD FOUND
   50 continue
      reada = 0.D0
      return
      end function reada

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine pinout (mode, l_use_disk)
   !**********************************************************************
   !
   !   PINOUT WRITES ALL INFORMATION REGARDING THE LMO'S TO DISK
   !
   !  mode = 1             - Write LMO's to disk
   !  mode = 0             - Read LMO's from disk
   !  l_use_disk = .true.  - Use a disk
   !  l_use_disk = .false. - Use a scratch disk
   !
   !**********************************************************************
    use molkst_C, only: numat, keywrd, nelecs, norbs, line
    use MOZYME_C, only : icocc_dim, iorbs, &
    nce, ncf, ncvir, nncf, nnce, ncocc, &
       & icvir_dim, cocc_dim, cvir_dim, icocc, icvir, cocc, cvir
    use chanel_C, only: iw, iden, density_fn
    use common_arrays_C, only : nbonds, ibonds
    implicit none
    integer, intent (in) :: mode
    logical, intent (in) :: l_use_disk
!
    logical :: opend, exists
    integer :: i, j, k, l, nocc, nvir
!
    nocc = nelecs / 2
    nvir = norbs - nocc
    inquire (unit=iden, opened=opend)
    if (opend) then
      if (l_use_disk) then
!
! Unconditionally close the file so it can be opened later on.
!
        close (unit = iden, status="KEEP", iostat = i)
        if (i /= 0) then
          inquire (unit=iden, opened=opend)
          if (opend) then
            close (unit=iden,  iostat = i)
            if (i /= 0) return
          end if
        end if
      else
!
!  The scratch file exists, so close it because it is going to be written to later on.
!
        if (mode == 1) close (unit = iden, iostat = i)
      end if
    end if
    if (l_use_disk) then
      if (mode == 0) then
        inquire (file=density_fn, exist = exists)
        if ( .not. exists) then
          write (line,"(10x,a)") " FILE " // trim(density_fn) // " IS MISSING"
          write(iw,'(//,a)')trim(line)
          call to_screen(line)
          call mopend ("DENSITY file is missing")
          return
        end if
      end if
    end if
    if (l_use_disk) then
      open (unit=iden, file=density_fn, status="UNKNOWN", form="UNFORMATTED")
    else
      open (unit=iden, status="SCRATCH", form="UNFORMATTED")
    end if
    rewind (iden)
    if (mode == 1) then
      !
      !   OUTPUT ALL DATA FOR LMO'S
      !
      write (iden, err=1030) (ncf(i), i=1, nocc)
      write (iden) (nce(i), i=1, nvir)
      do i = 1, nocc
        write (iden) (icocc(j), j=nncf(i)+1, nncf(i)+ncf(i))
      end do
      do i = 1, nvir
        write (iden) (icvir(j), j=nnce(i)+1, nnce(i)+nce(i))
      end do
      write (iden) (iorbs(i), i=1, numat)
      write (iden) (nbonds(i), i=1, numat)
      write (iden) ((ibonds(j, i), j=1, 9), i=1, numat)
      !
      !  NOW TO WRITE THE LMOS
      !
      do i = 1, nocc
        l = 0
          do j = nncf(i) + 1, nncf(i) + ncf(i)
            l = l + iorbs(icocc(j))
        end do
        write (iden) (cocc(j), j=ncocc(i)+1, ncocc(i)+l)
      end do
      do i = 1, nvir
        l = 0
        do j = nnce(i) + 1, nnce(i) + nce(i)
          l = l + iorbs(icvir(j))
        end do
        write (iden) (cvir(j), j=ncvir(i)+1, ncvir(i)+l)
      end do
      if (l_use_disk) close (iden)
      go to 1000
    else
    !
    !   READ IN ALL DATA FOR LMO'S
    !
      read (iden, end=1010, err=1010) (ncf(i), i=1, nocc)
      read (iden, end=1020, err=1020) (nce(i), i=1, nvir)
      l = 0
      do i = 1,nocc
        l = l + ncf(i)
      end do
!
!  Check to see if there is enough storage for incoming LMOs.
!  If not, then delete old storage, and create new, larger, storage.
!
!  Use a safety marging of 60%
!
        if ((l*8)/5 > icocc_dim) then
!
!  Delete old memory
!
          deallocate (icocc, cocc)
!
!  Re-allocate more memory
!
          cocc_dim = Nint(cocc_dim*(l*1.6/icocc_dim))
          icocc_dim = (l*8)/5
          allocate (icocc(icocc_dim), cocc(cocc_dim))
        end if
        l = 0
        do i = 1,nvir
          l = l + nce(i)
        end do
        if ((l*8)/5 > icvir_dim) then
!
!  Delete old memory
!
          deallocate (icvir, cvir)
!
!  Re-allocate more memory
!
          cvir_dim = Nint(cvir_dim*(l*1.6/icvir_dim))
          icvir_dim = (l*8)/5
          allocate (icvir(icvir_dim), cvir(cvir_dim))
        end if
      !
      !   COMPRESS INCOMING DATA.
      !
        j = 0
        do i = 1, nocc
          nncf(i) = j
          j = j + ncf(i)
        end do
        j = 0
        do i = 1, nvir
          nnce(i) = j
          j = j + nce(i)
        end do
        do i = 1, nocc
          read (iden, end=1020, err=1020) (icocc(j), j=nncf(i)+1, &
         & nncf(i)+ncf(i))
        end do
        do i = 1, nvir
          read (iden, end=1020, err=1020) (icvir(j), j=nnce(i)+1, &
         & nnce(i)+nce(i))
        end do
        read (iden, end=1020, err=1020) (iorbs(i), i=1, numat)
        read (iden, end=1020, err=1020) (nbonds(i), i=1, numat)
        read (iden, end=1020, err=1020) ((ibonds(j, i), j=1, 9), i=1, numat)
      !
      !  NOW TO READ THE LMOS
      !
        k = 0
        cocc = 0.d0
        do i = 1, nocc
          ncocc(i) = k
          l = 0
          do j = nncf(i) + 1, nncf(i) + ncf(i)
            l = l + iorbs(icocc(j))
          end do
          k = k + l
          read (iden, end=1020, err=1020) (cocc(j), j=ncocc(i)+1, ncocc(i)+l)
        end do
        k = 0
        cvir = 0.d0
        do i = 1, nvir
          ncvir(i) = k
          l = 0
          do j = nnce(i) + 1, nnce(i) + nce(i)
            l = l + iorbs(icvir(j))
          end do
          k = k + l
          read (iden, end=1020, err=1020) (cvir(j), j=ncvir(i)+1, ncvir(i)+l)
        end do
        if (l_use_disk) close (iden)
        go to 1000
      !
1010    continue
      !
      !
        call mopend (" FILE " // trim(density_fn) // " EXISTS, BUT IS FAULTY")
        return
      !
      !
1020    continue
      !
          call mopend (" OLDENS FILE FOR " // trim(density_fn) // " IS CORRUPT")
          return
      end if
     !
1030  call mopend(" Cannot write density matrix to """ // density_fn//"""")
      return
   !
1000 if (Index (keywrd, " PINOUT") /= 0) then
      call prtlmo ()
    end if
  return
   !
end subroutine pinout

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine readmo
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!
      use chanel_C, only : iw, ir, iarc, ilog, log_fn, archive_fn, &
      ires, restart_fn, output_fn, job_fn
!
      USE maps_C, ONLY: latom, lparam, lpara1, latom1, lpara2, latom2, &
      react
!
      USE symmetry_C, ONLY: idepfn, locdep, depmul, locpar
!
      use molkst_C, only : ndep, numat, numcal, natoms, nvar, keywrd, dh, &
      & verson, is_PARAM, line, nl_atoms, l_feather, backslash, &
      & moperr, maxatoms, koment, title, method_pm6, refkey, l_feather_1, &
      isok, method_pm6_dh2, caltyp, keywrd_quoted, &
      method_pm7, jobnam, method_PM7_ts, arc_hof_1, keywrd_txt, txtmax, refkey_ref, &
      ncomments, itemp_1, nbreaks, numat_old, maxtxt, use_ref_geo, &
      n_methods, methods, methods_keys,  method_pm6_d3h4, method_pm6_dh2x, id,  &
      method_pm6_d3h4x, method_pm6_d3, method_pm6_d3_not_h4, method_pm7_hh, method_pm6_org, &
      method_pm7_minus, method_pm6_dh_plus, prt_coords, prt_cart, mozyme, pdb_label, gui
!
      use meci_C, only : maxci
!
      use elemts_C, only : elemnt
!
      use parameters_C, only : ams
!
      use common_arrays_C, only : xparam, loc, labels, nat, na, nb, nc, &
        geo, coord, atmass, lopt, pibonds, l_atom, chains, pibonds_txt, &
        coorda, txtatm, txtatm1, break_coords, breaks, nbonds, tvec, lopt_store
!
      use MOZYME_C, only : start_res, lstart_res, start_letter
!
      USE funcon_C, only : fpc
      use conref_C, only : fpcref
!
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: ireact
      integer , dimension(19,2) :: idepco
      integer :: naigin, i, j, k, iflag, nreact, ij, iend, l, ii, jj, &
        i4, j4, ir_temp, l_iw, from_data_set = 14, i_loop, setpi_limit = 50
      integer, external :: quoted
      double precision, dimension(40) :: value
      double precision, dimension(400) :: xyzt
      double precision :: degree, convrt, dum1, dum2, sum, Rab
      double precision, external :: distance, reada, snapth
      logical :: intern = .true., aigeo, xyz, opend, exists, l_rewind = .true., l_int, l_dummy
      logical, allocatable :: l_use(:)
      character :: space, ch, idate*24, line_1*3000, line_2*3000, txt*15
      save  space, intern, ireact
!-----------------------------------------------
!
! MODULE TO READ IN GEOMETRY FILE, OUTPUT IT TO THE USER,
! AND CHECK THE DATA TO SEE IF IT IS REASONABLE.
! EXIT IF NECESSARY.
!
!
!
!  ON EXIT NATOMS    = NUMBER OF ATOMS PLUS DUMMY ATOMS (IF ANY).
!          KEYWRD    = KEYWORDS TO CONTROL CALCULATION
!          KOMENT    = COMMENT CARD
!          TITLE     = TITLE CARD
!          LABELS    = ARRAY OF ATOMIC LABELS INCLUDING DUMMY ATOMS.
!          GEO       = ARRAY OF INTERNAL COORDINATES.
!          LOPT      = FLAGS FOR OPTIMIZATION OF MOLECULE
!          NA        = ARRAY OF LABELS OF ATOMS, BOND LENGTHS.
!          NB        = ARRAY OF LABELS OF ATOMS, BOND ANGLES.
!          NC        = ARRAY OF LABELS OF ATOMS, DIHEDRAL ANGLES.
!          LATOM     = LABEL OF ATOM OF REACTION COORDINATE.
!          LPARAM    = RC: 1 FOR LENGTH, 2 FOR ANGLE, AND 3 FOR DIHEDRAL
!          REACT     = REACTION COORDINATE PARAMETERS
!          LOC(1,I)  = LABEL OF ATOM TO BE OPTIMIZED.
!          LOC(2,I)  = 1 FOR LENGTH, 2 FOR ANGLE, AND 3 FOR DIHEDRAL.
!          NVAR      = NUMBER OF PARAMETERS TO BE OPTIMIZED.
!          XPARAM    = STARTING VALUE OF PARAMETERS TO BE OPTIMIZED.
!
!***********************************************************************
! *** IR THE TRIAL GEOMETRY  (IE.  KGEOM=0)
!   LABEL(I) = THE ATOMIC NUMBER OF ATOM(I).
!            = 99, THEN THE I-TH ATOM IS A DUMMY ATOM USED ONLY TO
!              SIMPLIFY THE DEFINITION OF THE MOLECULAR GEOMETRY.
!   GEO(1,I) = THE INTERNUCLEAR SEPARATION (IN ANGSTROMS) BETWEEN ATOMS
!              NA(I) AND (I).
!   GEO(2,I) = THE ANGLE NB(I):NA(I):(I) IR IN DEGREES; STORED IN
!              RADIANS.
!   GEO(3,I) = THE ANGLE BETWEEN THE VECTORS NC(I):NB(I) AND NA(I):(I)
!              IR IN DEGREES - STORED IN RADIANS.
!  LOPT(J,I) = -1 IF GEO(J,I) IS THE REACTION COORDINATE.
!            = +1 IF GEO(J,I) IS A PARAMETER TO BE OPTIMIZED
!            =  0 OTHERWISE.
! *** NOTE:    MUCH OF THIS DATA IS NOT INCLUDED FOR THE FIRST 3 ATOMS.
!     ATOM1  IR LABELS(1) ONLY.
!     ATOM2  IR LABELS(2) AND GEO(1,2) SEPARATION BETWEEN ATOMS 1+2
!     ATOM3  IR LABELS(3), GEO(1,3)    SEPARATION BETWEEN ATOMS 2+3
!              AND GEO(2,3)              ANGLE ATOM1 : ATOM2 : ATOM3
!
!***********************************************************************
!
      data space/ ' '/
      data naigin/ 0/
      data idepco/ 1, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 1, 2, 2, 0, 1, 1, 2, &
        3, 1, 2, 3, 1, 2, 3, 1, 2, 3, 1, 2, 3, 1, 2, 3, 0/
      aigeo = .FALSE.
      k = 0
      nvar = 0
      ndep = 0
      latom = 0
      lparam = 0
      lpara1 = 0
      latom1 = 0
      lpara2 = 0
      latom2 = 0
      breaks(1) = -300
      convrt = 0.d0
      if (index(keywrd, " ADD-H PDBOUT") /= 0 .and. index(koment, " From PDB file") /= 0) then
        i = index(keywrd, " ADD-H")
        keywrd(i:i + 5) = " 0SCF "
        call update_txtatm(.true., .true.)
        if (allocated(txtatm1)) deallocate(txtatm1)
        allocate(txtatm1(numat))
        txtatm1(:numat) = txtatm(:numat)
        keywrd = "  LOG "//trim(keywrd)
        open(unit=ilog, form='FORMATTED', status='UNKNOWN', file=log_fn, position='asis')
        return
      end if
      if (.not. allocated(lopt)) allocate(lopt(3,maxatoms))
   10 continue
      line = trim(keywrd)
      keywrd = " "
      refkey_ref(1) = koment
      refkey_ref(2) = title
      call gettxt
      if (moperr) return
      if (quoted('GEO_DAT=')  > 0) then
        if (moperr) then
          title = " "
          koment = " "
          moperr = .false.
        end if
!
!     Use geometry in file defined by GEO_DAT
!
        line_2 = trim(line)
        line_1 = trim(line)
        call upcase(line_1, len_trim(line_1))
        line_2 = job_fn
        if (index(keywrd, "GEO-OK") == 0) then
          do i = len_trim(line_1), 1, -1
            if (line_1(i:i) == backslash) exit
          end do
          if (i > 0) line_1 = line_1(i + 1:)
          do i = len_trim(line_2), 1, -1
            if (line_2(i:i) == backslash) exit
          end do
          if (i > 0) line_2 = line_2(i + 1:)
          if (line_1(:len_trim(line_1) - 3) == line_2(:len_trim(line_2) - 3)) then
            if (line_1(len_trim(line_1) - 2:) == "ARC" .or. line_1(len_trim(line_1) - 2:) == "PDB") then
              if (len_trim(line) == len_trim(line_1) .and. index(keywrd, " HTML") + index(keywrd, " PDBOUT") /= 0) then
                call mopend("The name of the geometry file defined by GEO_DAT is "// &
                & "similar to the name of the job data set")
                write(iw,"(/10x,a)")"Job name:    """//trim(job_fn)//""""
                write(iw,"(10X,a)") "GEO_DAT name:"""//trim(line)//""""
                write(iw,"(/10x,a)")"This might cause the GEO_DAT geometry data set to be over-written by the job."
                write(iw,"(10x,a)")"Either change one of the names or add ""GEO-OK"" to the keyword line, then re-run."
                return
              end if
            end if
          end if
        end if
        call add_path(line)
        inquire (file=trim(line), exist = exists)
        if (.not. exists) then
          inquire (file=trim(line)//".mop", exist = exists)
          if (exists) line = trim(line)//".mop"
          if (.not. exists) then
            call mopend ("GEO_DAT file: '"//trim(line)//"' does not exist.")
            return
          end if
        end if
        open(unit = from_data_set, file = trim(line), iostat = i)
        call upcase(line, len_trim(line))
        rewind (ir)
        if (index(line_1, ".PDB") == 0) then
          i = index(line, ".ARC")
          if (i /= 0) then
            read (from_data_set, '(A)', iostat=j) line
            if (j == 0 .and. line(1:1) /= "*") then
              do i = 1, 10000
                read (from_data_set, '(A)', iostat=j) line
                if (j /= 0) exit
                if (index(line, "HEAT OF FORMATION") > 0) arc_hof_1 = reada(line,20)
                if (index(line, "FINAL GEOMETRY OBTAINED") > 0) exit
              end do
            end if
            if (j /= 0 .or. i == 10001) rewind(from_data_set)
          end if
          i = 0
          line_2 = trim(keywrd)
          do
            read (from_data_set, '(A241)',  iostat=j) keywrd
            if (keywrd(4:4) == "(" .and. keywrd(31:31) == ")" .and. keywrd(36:36) == ".") then
              rewind(from_data_set)
              exit
            end if
            if (j == -1) then
              call mopend(" END OF FILE FOUND WHILE TRYING TO READ IN GEOMETRY DATA FROM """//trim(line_1)//"""")
              write(iw,'(10x,a)')"(Error occurred while trying to read over the keyword line in the data-set.)"
              return
            end if
            if (keywrd(1:1) /= "*") then
              if (index(keywrd,"ATOM") + index(keywrd,"HETATM") /= 0) then
                write (ir, '(A)', iostat=i) trim(keywrd)
              end if
!
!  Delete all text between '"' and '"', to eliminate the unwanted text " +"
!
              call upcase(keywrd, len_trim(keywrd))
              call l_control("GEO_DAT", len_trim("GEO_DAT"), -1)
              call l_control("GEO_REF", len_trim("GEO_REF"), -1)
              call l_control("EXTERNAL", len_trim("EXTERNAL"), -1)
              line = trim(keywrd)
              if (i == 0 .and. index(line, " +") /= 0) i = i - 1
              if (i == 0 .and. index(line, "++") /= 0) i = i - 1
              line = line(:6)
              if (index(line,"ATOM") + index(line,"HETATM") + index(line,"TITLE") + &
                index(line,"HEADER") + index(line,"ANISOU") + index(line,"COMPND") + &
                index(line,"SOURCE") + index(line,"KEYWDS") + index(line,"USER ")  + &
                index(line,"HELIX") + index(line,"SHEET") + index(line,"REMARK") /= 0)  exit
              i = i + 1
            end if
            if (i == 3) exit
          end do
          keywrd = trim(line_2)
        end if
        natoms = 0
        j = 0
        do
          read (from_data_set, '(A241)',  iostat=i) line
          if (i /= 0) exit
          do i = 1, 100
            if (line(i:i) /= " ") exit
          end do
          if (i < 101) j = j + 1
          if (line(1:1) /= "*") then
            write (ir, '(A)', iostat=k) trim(line(i:))
            natoms = natoms + 1
          end if
        end do
        close (from_data_set)
        rewind (ir)
        maxatoms = natoms + 200
        call setup_mopac_arrays(0, 0)
        call setup_mopac_arrays(natoms + 200, 1)
        allocate(lopt(3,maxatoms))
        if (j == 0) then
!
! PANIC!
!
          call mopend("THE FILE DEFINED BY ""GEO_DAT"": """//trim(line_1)//""" IS FAULTY")
          write(iw,'(10x, a)')"It either does not exist or it does not contain a geometry"
          return
        end if
      end if
      chains = " "
      if (index(keywrd,"OLDGEO") .ne. 0) then
        if (natoms == -30 .and. numat == -30) then
          write(iw,'(/10x,a)')"OLDGEO cannot be used here."
          call mopend("A FORCE CALCULATION ON A SYSTEM THAT HAS DUMMY ATOMS CANNOT BE CONTINUED")
          return
        end if
        do i = 1, id
          coord(:, natoms + i) = tvec(:,i)
        end do
        natoms = natoms + id
        if (koment == " " .and. refkey_ref(1) /= " ") koment = trim(refkey_ref(1))
        if (title == " " .and. refkey_ref(2) /= " ") title = trim(refkey_ref(2))
!
!  Because OLDGEO is used, keywords that depend on the geometry are
!  not set, so copy them from "line"
!
        if (na(1) < -1) then
          natoms = 0
          return
        end if
        ncomments = itemp_1
        if (index(keywrd, "START_RES") == 0 .and. index(line, "START_RES") .ne. 0) then
          i = index(line, "START_RES")
          j = i + 9
          do
            if(line(j:j) == ")") exit
            j = j + 1
          end do
          keywrd = line(i:j + 1)//trim(keywrd)
        end if
        if (index(keywrd, "CHAINS") == 0 .and. index(line, "CHAINS") .ne. 0) then
          i = index(line, "CHAINS")
          j = i + 9
          do
            if(line(j:j) == ")") exit
            j = j + 1
          end do
          keywrd = line(i:j + 1)//trim(keywrd)
        end if
        call update_txtatm(.true., .true.)
        if (allocated(txtatm1)) deallocate(txtatm1)
        allocate(txtatm1(numat))
        numat_old = numat
        txtatm1(:numat) = txtatm(:numat)
        if (index(keywrd, " INT") /= 0) then
          call xyzint (coord, numat, na, nb, nc, 1.d0, geo)
          lopt(:,1) = 0
          lopt(2:,2) = 0
          lopt(3,3) = 0
        end if
        if (index(keywrd, " XYZ") /= 0) then
          numat = 0
          do i = 1, natoms
            if (labels(i) /= 99) then
              numat = numat + 1
              labels(numat) = labels(i)
              txtatm(numat) = txtatm(i)
              lopt(:,numat) = lopt(:,i)
              na(numat) = 0
            end if
            geo(:,i) = coord(:,i)
          end do
!
!   If everything is marked for optimization then unconditionally mark the first
!   three atoms for optimization
!
          if (k >= 3*numat - 6) lopt(:,:min(3, numat)) = 1
          natoms = numat
        end if

      end if
      if (moperr) then
        natoms = 0
        return
      end if
      if (index(keywrd,'ECHO') /= 0) then
        rewind ir
        if (.not.isok) then
          write (iw, '(A)', iostat=l_iw) ' ECHO is not allowed at this point'
          call mopend ('ECHO is not allowed at this point')
          return
        end if
        isok = .FALSE.
        do i = 1, 1000
          read (ir, '(A)', end=60) keywrd
          do j = 80, 2, -1
            if (keywrd(j:j) /= ' ') go to 30
          end do
          j = 1
   30     continue
          do k = 1, j
            if (ichar(keywrd(k:k)) >= 32) cycle
            keywrd(k:k) = '*'
          end do
          write (iw, '(1X,A)', iostat=l_iw) keywrd(1:j)
          if (l_iw /= 0) exit
        end do
   60   continue
        rewind ir
        call gettxt
        if (moperr) return
      end if
      if (keywrd(1:7) == " HEADER") keywrd(8:) = " "
      if (keywrd(1:1) /= space) keywrd = " "//trim(keywrd)
      if (koment(1:1) /= space) koment = " "//trim(koment)
      if (title(1:1) /= space)  title  = " "//trim(title)
      i = index(keywrd, ' MNDO/D')
      if (i > 0) keywrd(i:i + 6) = " MNDOD"
!
! Decide which set of fundamental constants to use
!
      if (index(keywrd,' OLDFPC') + index(keywrd, ' MNDOD') > 0) then
!
! Use old fundamental physical constants
!
        fpc(:) = fpcref(2,:)
      else
!
! Use CODATA fundamental physical constants
!
        fpc(:) = fpcref(1,:)
      end if
      latom  = 0
      lparam = 0
      xyz    = index(keywrd,' XYZ') + index(keywrd,' IRC') + index(keywrd,' DRC') /= 0
!
!   Top level
!
      if (index(keywrd,' OLDGEO') == 0) then
!
!  Read in a new geometry
!
        nvar = 0
        ndep = 0
        if (allocated(nbonds)) nbonds(1) = -200
        if (allocated(txtatm1)) deallocate(txtatm1)
        allocate(txtatm1(maxatoms))
        break_coords(1,:400) = -123.d0
        if (aigeo .or. index(keywrd,' AIGIN') /= 0) then
          intern = .false.
          call getgeg (ir, labels, geo, lopt, na, nb, nc)
          if (moperr) return
          if (xyz) then
            write (iw, '(A)') &
              ' CARTESIAN CALCULATION NOT ALLOWED WITH GAUSSIAN INPUT'
              call mopend (&
               'CARTESIAN CALCULATION NOT ALLOWED WITH GAUSSIAN INPUT')
            return
          end if
          if (nvar == 0) then
            lopt(:,:natoms) = 0
          end if
        else
          line = trim(keywrd)
          j = 0
          do i = 1, len_trim(line)
            if (line(i:i) == '"') j = 1 - j
            if (j == 1) line(i:i) = " "
          end do
          i = index(keywrd, " CHAIN=")
          if (i /= 0) keywrd = keywrd(:i + 5)//"S"//trim(keywrd(i + 6:))
          natoms = maxatoms

          if (index(line, " PDB ") + index(line, " PDB(")/= 0) then
            call getpdb(geo)
            coorda(:,:numat) = geo(:,:numat)
            numat_old = numat
          else
            call getgeo (ir, labels, geo, coord, lopt, na, nb, nc, intern)
            if (numcal == 1 .and. natoms == 0) then
              i = index(keywrd, "GEO_DAT")
              if (i /= 0) then
                write(line,'(2a)')" GEO_DAT file """//trim(line_1)//""" exists, but does not contain any atoms."
                write(0,'(//10x,a,//)')trim(line)
                call mopend(trim(line))
              else if (.not. gui .and. numcal < 2) then
                write(line,'(2a)')" Data set '"//trim(job_fn)//" exists, but does not contain any atoms."
                write(0,'(//10x,a,//)')trim(line)
                call mopend(trim(line))
              end if
              write(line,'(a)')"(Check the first few lines of the data-set to see if there is an extra blank line."
              write(0,'(10x,a)')trim(line)
              write(iw,'(10x,a)')trim(line)
              write(line,'(a)')"If there is an extra line, delete it and re-run the job.)"
              write(0,'(10x,a)')trim(line)
              write(iw,'(10x,a)')trim(line)
              inquire(unit=ir, opened=opend)
              if (opend) close(ir, status = 'delete', err=99)
99            stop
            else if (natoms == -2) then
              if (l_rewind) then
                l_rewind = .false.
              else
                line ="Problem detected in data set."
                write(0,'(/10x,a,/)')trim(line)
                call mopend(trim(line))
                return
              end if
              rewind(ir)
              call getpdb(geo)
              coorda(:,:numat) = geo(:,:numat)
              numat_old = numat
            else if (natoms /= -3) then
              if (moperr .and. numcal == 1) return
              if (maxtxt > txtmax) txtmax = maxtxt
              txtatm1(:natoms) = txtatm(:natoms)
              if (index(keywrd, " RESID") /= 0) txtatm1(:numat)(22:22) = " "
              i = size(coorda)/3
              if (i < numat) then
                deallocate(coorda)
                allocate(coorda(3,numat))
              end if
              coorda(:,:numat) = coord(:,:numat)
              numat_old = numat
            end if
            if (keywrd(1:1) /= space) keywrd = " "//trim(keywrd)
            if (koment(1:1) /= space) koment = " "//trim(koment)
            if (title(1:1) /= space)  title  = " "//trim(title)
          end if
!
!  Convert any "SELF" into file-names
!
      do
        line = trim(keywrd_quoted)
        call upcase(line, len_trim(line))
        i = index(line, "SELF")
        if (i == 0) exit
!
! Isolate the path
!
        do l = i, 1, -1
          if (keywrd_quoted(l:l) == '"') exit
        end do
        if (l == 0) then
          call mopend(" KEYWORD OPTION ""SELF"" FOUND, BUT IT WAS NOT IN DOUBLE QUOTATION MARKS")
          return
        end if
        line_2 = keywrd_quoted(l + 1:i - 1)
!
! If "SELF" without a suffix, use the name of the job.
!
        do k = len_trim(job_fn), 1, -1
            if (job_fn(k:k) == "/" .or. job_fn(k:k) == "\") exit
        end do
        if (keywrd_quoted(i + 4:i + 4) == '"') then
!
!  "SELF" without a suffix, so use the name of the job.
!
          line_1 = trim(line_2)//trim(job_fn(k + 1:))
          i = i + 4
        else
!
!  "SELF" with a suffix, so use the name of the job but using the suffix from "SELF".
!
          do j = len_trim(job_fn), k + 1, -1
            if (job_fn(j:j) == ".") exit
          end do
          line_1 = keywrd_quoted(l + 1:i - 1)//job_fn(k + 1: j - 1)//keywrd_quoted(i + 4:i + 7)
          i = i + index(keywrd_quoted(i:), '"') - 1
        end if
        call add_path(line_1)
!
! Replace "SELF"
!
        line = keywrd_quoted(1:l)//trim(line_1)//trim(keywrd_quoted(i:))
        keywrd_quoted = trim(line)
      end do
          if (index(keywrd, " HTML") + index(keywrd, " PDBOUT") /= 0 .and. maxtxt == 0) then
            if (index(keywrd," ADD-H") + index(keywrd," SITE=") /= 0) then
              if (index(keywrd," ADD-H") /= 0) then
                call mopend("KEYWORD ""ADD-H"" CANNOT BE USED WHEN PDB DATA ARE NOT"// &
                  " PRESENT AND KEYWORDS THAT USE PDB DATA ARE PRESENT")
              else
                call mopend("KEYWORD ""SITE"" CANNOT BE USED WHEN PDB DATA ARE NOT "// &
                  "PRESENT AND KEYWORDS THAT USE PDB DATA ARE PRESENT")
              end if
              write(iw,'(10x, a)')"If the geometry is correct, this fault might be corrected by using two jobs:"
              write(iw,'(10x, a)')"Job-1 uses keywords ""0SCF RESIDUES"" - that adds PDB data to the ARC file."
              write(iw,'(10x, a)')"Job-2 uses that data when adding or deleting hydrogen atoms"
              return
            end if
              call l_control("RESIDUES", len_trim("RESIDUES"), 1)
              if (index(keywrd," MOZ") + index(keywrd," LOCATE-TS") + index(keywrd," RAPID") &
              + index(keywrd," ADD-H") == 0) &
                call l_control("CONTROL_no_MOZYME", len_trim("CONTROL_no_MOZYME"), 1)
          end if
          if (maxtxt == 27 .and. index(keywrd, " HTML") /= 0) then
!
!  Delete residue code letter.  If it was present, then Jmol could give problems
!
            maxtxt = 26
            txtatm1(:numat)(27:27) = " "
            txtatm(:numat) = txtatm1(:numat)
          end if
!
!  If the file contains PDB data, but no chain label, then force chain label "A" in.
!
          if (maxtxt == 26) then
            do i = 1, numat
              if (txtatm1(i)(22:22) /= " ") exit
            end do
            if (i > numat) txtatm1(:numat)(22:22) = "A"
          end if
          if (index(keywrd, " RESIDUES ") /= 0) then
            txtatm(:numat) = " "
            maxtxt = 0
          end if
          if (natoms == -3) then
            if (index(keywrd, " COMPARE") /= 0) then
              call mopend("SEVERE ERROR DETECTED IN ""GEO_DAT"" FILE")
              return
            end if
            goto 10
          end if
          if (moperr) return
          if (Index (keywrd, " SNAP") /= 0) then
            !
            !   If any angles are near to important angles (such as 109.47...)
            !   snap the angle to the exact angle
            !
            do i = 1, natoms
              if (na(i) /= 0) then
                geo(2, i) = snapth (geo(2, i))
                geo(3, i) = snapth (geo(3, i))
              end if
            end do
          end if
          if (natoms < 0 ) then
            if (numcal == 1) rewind ir
            if (.not.isok) then
              write (iw, '(A)') &
                ' Use AIGIN to allow more geometries to be used'
                call mopend ('Use AIGIN to allow more geometries to be used')
!
!   This is a deadly error - to prevent an infinite loop, kill the job.
!
              stop
            end if
            isok = .FALSE.
            if (numcal > 2) then
              naigin = naigin + 1
              write (iw, '(2/,2A)') '   GAUSSIAN INPUT REQUIRES', &
                ' STAND-ALONE JOB'
              write (iw, '(/,A)') '   OR KEYWORD "AIGIN"'
              call mopend (&
                 'GAUSSIAN INPUT REQUIRES STAND-ALONE JOB OR KEYWORD "AIGIN"')
              return
            end if
            aigeo = .TRUE.
            go to 10
          end if
        end if
        if (natoms == 0 .and. numcal == 1) then
          call mopend ('NO ATOMS IN SYSTEM')
          return
        end if
      else
!
!   Use the old geometry, if one exists
!
        if (numcal == 1) then
          write(line,'(a)')" Keyword OLDGEO cannot be used in the first calculation - there is no old geometry"
          write(iw,'(//10x,a)')trim(line)
          call to_screen(trim(line))
          call mopend(trim(line))
          return
        end if
      end if
      if (natoms == 0) return
      if (index(keywrd,' FORCE')/=0 .and. labels(natoms)==107) then
        do i = 1, na(natoms)
          if (labels(i) /= 99) cycle
          write (iw, '(A)') ' NO DUMMY ATOMS ALLOWED BEFORE TRANSLATION'
          write (iw, '(A)') ' ATOM IN A FORCE CALCULATION'
          call mopend (&
       'NO DUMMY ATOMS ALLOWED BEFORE TRANSLATION ATOM IN A FORCE CALCULATION')
          return
        end do
      end if
!
!
! OUTPUT FILE TO UNIT 6
!
!    WRITE HEADER
      idate = ' '
      call fdate (idate)
      write (iw, '(1X,15(''*****''),''****'')',iostat=i)
      if ( .not. gui) then
        if (i /= 0) then
          write(line,'(2a)')" Unable to write to file '", trim(output_fn)//"'"
          write(0,'(//10x,a,//)')trim(line)
          call mopend(trim(line))
          return
        else
          if (numcal == 1 .and. numat > 50) write(0,'(10x,a)')idate//"  Job: '"//trim(jobnam)//"' started successfully"
        end if
      end if
      maxci = 16000
      write (iw, '(1X,a)')"**                                                                           **"
      write (iw,"(1x,a)") "**                              MOPAC v"//verson//"                  **"
      write (iw, '(1X,a)')"**                                                                           **"
      write (iw, '(1X,a)')"*******************************************************************************"
      write (iw, '(1X,a)')"**          Digital Object Identifier (DOI): 10.5281/zenodo.6511958          **"
      write (iw, '(1X,a)')"**    Visit the DOI location for information on how to cite this program.    **"
      write (iw, '(1X,a)')"*******************************************************************************"
      j = len_trim(keywrd)
      do i = j, 1, -1
        ch = keywrd(i:i)
        if (ichar(ch) > 126) keywrd(i:i) = " "
        if (ichar(ch) < 32) exit
      end do
      if (i /= 0) then
        write(line,'(a)')" Non-standard characters detected in keyword line"
        call mopend(trim(line))
        l = 0
        write(iw,*)
        do
          l = l + 20
          k = min(l,i)
          if (k < l - 19) exit
          write(iw,'(a,i4,30i4)')"Position: ", (j, j = l - 19, k)
          write(iw,'(a,i4,30i4)')"   ASCII: ", (ichar(keywrd(j:j)), j = l - 19, k)
          write(iw,'(a,a4,29a4)')"    Char: ", (keywrd(j:j), j = l - 19, k)
          write(iw,*)
          if (k == i) exit
        end do
        write(iw,'(//,a,//)')" (Edit keyword line to remove non-standard characters using a primitive editor such as vi)"
      end if
      if (.not. is_PARAM) then
        keywrd_txt = trim(keywrd)
!
!  Delete all text that might contain keywords
!
        call l_control("GEO_DAT", len_trim("GEO_DAT"), -1)
        call l_control("GEO_REF", len_trim("GEO_REF"), -1)
!
!  Decide which method to use
!
        do i = 1, n_methods
          methods(i) = (index(keywrd, trim(methods_keys(i))//" ") /= 0)
        end do
        do i = 1, n_methods
          if (methods(i)) exit
        end do
        if (i > n_methods) then
!
!  Is it a known variant of PM6 or PM7?
!
          j = index(keywrd, " PM6") + index(keywrd, " PM7")
          if (j /= 0) then
            k = index(keywrd(j + 1:), " ") + j - 1
            call mopend('The method requested: "'//keywrd(j + 1:k)//'" does not exist.')
            return
          end if
        end if
!
! Default method is PM7
!
        if (.not. method_pm7) then
           do i = 1, n_methods
             if (methods(i)) exit
           end do
           if (i > n_methods) then
             i = 14
             method_pm7 = .true.
           end if
        end if
        caltyp = methods_keys(i)
!
!  Define parent methods "method_PM6" and "method_PM7" for variants of these methods
!
        method_pm7 = (method_PM7 .or. method_PM7_ts .or. method_pm7_hh .or. method_pm7_minus)
        method_pm6 = (method_PM6 .or. method_pm6_dh2 .or. method_pm6_d3h4 .or. method_pm6_dh_plus .or. &
       & method_pm6_dh2x .or. method_pm6_d3h4x .or. method_pm6_d3 .or. method_pm6_d3_not_h4)
        l_feather = (method_PM7 .or. method_pm6_org .or. index(keywrd, " MOZ") /= 0 .and. (index(keywrd, " PM6") /= 0))
        l_feather_1 = (index(keywrd, " MACRO") /= 0)
        dh = " "
        i = index(keywrd, " PM6-D")
        if (i /= 0) then
          j = index(keywrd(i + 6:)," ") + i + 4
          dh = keywrd(i + 5:j)
        else if (index(keywrd, " PM6-H") /= 0)  then
          dh = "H   "
        end if
        keywrd = trim(keywrd_txt)
      end if
      write (iw, &
      '(/24X,A,'' CALCULATION RESULTS'',2/1X,15(''*****''),''****'' )') "     "//trim(caltyp)
      write (iw,'(" *  CALCULATION DONE: ",31x,2a)') idate,"  *"
!
! Copy all keywords to keywrd_txt
!
      keywrd_txt = trim(keywrd)
      line_1 = trim(keywrd)
!
!  Delete all text that might contain keywords
!
      call l_control("GEO_DAT", len_trim("GEO_DAT"), -1)
      call l_control("GEO_REF", len_trim("GEO_REF"), -1)
      keywrd = trim(line_1)
      if (index(keywrd, " HTML(NORES)") /= 0) call l_control("HTML NORJSMOL", len_trim("HTML NORJSMOL"), 1)
!
! WRITE KEYWORDS BACK TO USER AS FEEDBACK
!
      call wrtkey
      if (moperr) &
        write(iw,'(a)')" *", &
      & " *  Errors detected in keywords.  Job stopped here to avoid wasting time."," *"
      write (iw, &
        '(1X,14(''*****''),''*********'')')
      if (moperr) return
      if (index(keywrd, " LOCATE-TS") /= 0 .and. index(keywrd, " LOCATE-TS(SET") == 0) lopt(:,:natoms) = 1
      if (index(keywrd, "INVERT") /= 0) then
        nvar = 0
        do i = 1, natoms
          do j = 1,3
            if (lopt(j,i) == 1) then
              lopt(j,i) = 0
            else if (lopt(j,i) == 0) then
              lopt(j,i) = 1
            end if
          end do
        end do
      end if
      start_res = -200
      lstart_res = .false.
      lstart_res(1) = .true.
      i = index(keywrd," START_RES")
      if (i /= 0) then       !                  Parse the "START_RES" keyword for residues, chains, and breaks
        i = i + 10
        if (keywrd(i:i) == "=") i = i + 1
        k = 1000
        do j = 1, 500
          start_res(j) = nint(reada(keywrd, i)) - 1
            k = i
          do
            k = k + 1
            if (keywrd(k:k) < "0" .or. keywrd(k:k) > "9") exit
          end do
          ch = " "
          if (keywrd(k:k) >= "A" .and. keywrd(k:k) <= "Z") ch = keywrd(k:k)
          start_letter(j) = ch
          do
            if (keywrd(k:k) == "-" .and. ((keywrd(k-1:k-1) >= "0" .and. keywrd(k-1:k-1) <= "9") &
                                    .or. (keywrd(k-1:k-1) >= "A" .and. keywrd(k-1:k-1) <= "Z"))) exit
            if (keywrd(k:k) == " ") exit
            if (keywrd(k:k) == ")") exit
            k = k + 1
          end do
          if (keywrd(k:k) == ")") exit
          if (keywrd(k:k) == "-" .and. ((keywrd(k-1:k-1) >= "0" .and. keywrd(k-1:k-1) <= "9") &
                                  .or. (keywrd(k-1:k-1) >= "A" .and. keywrd(k-1:k-1) <= "Z")))  then
            i = k + 1
          else
            if (keywrd(k:k) == ")") exit
            l = index(keywrd(i:k), " ") !  Start of a new protein
            if (l /= 0) then
              i = i + l
              lstart_res(j + 1) = .true.
            end if
          end if
        end do
!
!  Identify atoms where chain breaks occur
!
        j = 1
        ij = 0
        jj = nint(reada(txtatm(1), 22)) - 1
        nbreaks = 0
        do i = 1, natoms
          if (labels(i) == 6) exit
        end do
        if (index(keywrd, " NOTER") /= 0 .or. i > natoms) then
          start_res(2) = -200
          break_coords = 0.d0
          breaks = -100
        end if
        do ii = 2, 10
          if (start_res(ii) == -200) exit
          inner_loop: do k = j, numat
            l = nint(reada(txtatm(k), 22)) - 1
            if (l == start_res(ii) .and. txtatm(k)(22:22) == start_letter(ii)) then
              if (lstart_res(ii)) then
                nbreaks = nbreaks + 1
                do i4 = k - 1, 1, -1
                  if (labels(i4) /= 1) exit
                end do
                if (i4 > 0) then
                  break_coords(:,nbreaks) = geo(:,i4)
                else
                  nbreaks = nbreaks - 1
                end if
              end if
              ij = ij + 1
              breaks(ij) = k - 1
              j = k
              exit inner_loop
            end if
          end do inner_loop
        end do
        j = 1
        do i = 2, nbreaks
          if (breaks(i) - breaks(i - 1) > 1) then
            j = j + 1
            breaks(j) = breaks(i)
          end if
        end do
        nbreaks = j
        breaks(nbreaks + 1) = 0
      end if
      i = index(keywrd," CHAINS")
      if (i /= 0) then
        i = i + index(keywrd(i:),"(")
        do j = i, i + 26
          k = ichar(keywrd(j:j))
          if (k < ichar("A") .or. k > ichar("Z")) then
            do k = j - i + 1, 26
              chains(k) = chains(j - i)
            end do
            exit
          end if
          chains(j - i + 1) = keywrd(j:j)
        end do
      else
    !
    ! Allow for up to 26 chains
    !
        do i = 1, 26
          chains(i) = char(ichar("A") + i - 1)
        end do
      end if
!
! FILL IN GEO MATRIX IF NEEDED
!
      if (index(keywrd,' SYMM') + index(keywrd," SYM ") /= 0 .or. ndep > 0) then
        call getsym(locpar, idepfn, locdep, depmul)
        if ((xyz .or. intern)) then
          ndep = 0
          if (index(keywrd," IRC") + index(keywrd," DRC") == 0) then
            if (index(keywrd,' XYZ') /= 0) write(iw,"(13x,a)")"(Remove either SYMMETRY or XYZ)"
            if (intern) write(iw,"(13x,a)")"(Remove either SYMMETRY or INT)"
            if (index(keywrd, " 0SCF") == 0) then
              call mopend('SYMMETRY CANNOT BE USED WHEN COORDINATE SYSTEMS ARE CHANGED')
              return
            else
              moperr = .false.
            end if
          end if
        end if
      end if

      if (index(keywrd, " NOOPT") /= 0 .and. index(keywrd, " IRC") + index(keywrd, " DRC") == 0)   then
        k = 0
        do_noopt: do i = 1, natoms
          do j = 1,3
            if (lopt(j,i) < 0) exit do_noopt
          end do
        end do do_noopt
        if (j < 4 .or. i <= natoms) then
          write(iw,*)" ""NOOPT"" cannot be used when an optimization flag of -1 is present"
          call mopend("""NOOPT"" cannot be used when an optimization flag of -1 is present")
          return
        end if
        line = trim(keywrd)
        do
          i = index(line, " NOOPT")
          if (i == 0) exit
          j = index(line(i + 4:)," ") + i + 2
          line(i:i + 6) = " "
          if (j - i == 8) then
            line(1:1) = line(j - 1:j - 1)
            line(2:2) = char( ichar(line(j:j)) + ichar("a") - ichar("A"))
          else if (j - i == 7) then
            line(1:1) = " "
            line(2:2) = line(j:j)
          else
            do i = 1, natoms
              lopt(1, i) = 0
              lopt(2, i) = 0
              lopt(3, i) = 0
            end do
            cycle
          end if
          do l = 1, 99
            if (line(1:2) == elemnt(l)) exit
          end do
          do i = 1, natoms
            j = labels(i)
            if (j == l) then
              lopt(1, i) = 0
              lopt(2, i) = 0
              lopt(3, i) = 0
            end if
          end do
        end do
      end if
      if (index(keywrd, " OPT") /= 0)   then
        i = index(keywrd, " OPT=")
        if (i /= 0) keywrd(i + 4:) = keywrd(i + 5:)
        k = 0
        do_opt: do i = 1, natoms
          do j = 1,3
            if (lopt(j,i) < 0) exit do_opt
          end do
        end do do_opt
        if (j < 4 .or. i <= natoms) then
          call mopend("""OPT"" cannot be used when an optimization flag of -1 is present")
          return
        end if
        line = trim(keywrd)
        i = index(line, " OPT")
!
! "j" marks the end of the keyword
!
        j = 0
        if (index(line, " OPT(") /= 0) j = index(line(i + 1:), ") ")
        if (j /= 0) then
!
! Test to ensure that there are no other "OPT" keywords are present
!
          if (index(keywrd, " OPT ") + index(keywrd, " OPT-") /= 0) then
            exists = moperr
            call mopend('When keyword "OPT(text)" is present, other keywords containing "OPT" must not be present.')
            if (index(keywrd, " 0SCF") /= 0) then
              moperr = exists
            else
              return
            end if
          end if
          allocate(l_use(natoms))
          l_use = .false.
          lopt(:,:natoms) = 0
          i = i + 5
          k = index(line(i:j + i - 5), "=")
          if (k /= 0) then
            i_loop = i
            line_2 = trim(line)
            lopt(:,:natoms) = 0
!
! If dummy atoms are present, they must not be deleted when working out which atoms are to be selected
! for optimization.  This is because both the atom's coordinate and the atom's PDB label are used.
! After the selection is done, the dummy atoms can be deleted again from the coordinate list
!
            l_dummy = .false.
            do i = 1, natoms
              if (labels(i) == 99) then
                l_dummy = .true.
                labels(i) = 86
              end if
            end do
            if (l_dummy) call gmetry (geo, coord)
            do
              i = i_loop
              j = index(line(i + 1:), ") ")
!
! Keyword OPT("text"=n.nn) used, so use only atoms in the region of selected atoms.
!
!
!  Text for selected atoms
!
              txt = line(i + 1: k + i - 3)
              ch = txt(1:1)
              if (ch >= "a" .and. ch <= "z") txt(1:1) = char(ichar(ch) + ichar("A") - ichar("a"))
              Rab = reada(line, k + i)
              jj = 0
              do i = 1, len_trim(txt)
                if (txt(i:i) /= " ") then
                  jj = jj + 1
                  txt(jj:jj) = txt(i:i)
                end if
              end do
              txt(jj + 1:) = " "
              do i = len_trim(txt), 1, -1
                if (txt(i:i) > "9" .or. txt(i:i) < "0") exit
              end do
              txt = trim(txt(max(i,1):))
              if (txt(1:1) >= "0" .and. txt(1:1) <= "9") then
!
! Ignore chain letter in test
!
                txt = "*"//trim(txt)
                jj = jj + 1
              end if
              do i = 1, natoms
!
!  l_use(i) = F:  not assigned
!  l_use(i) = T:  Assigned because it matches the SITE word or it's within Rab of an atom defined by SITE
!
                line = txtatm(i)(22:)
                j = 0
                if (txt(1:1) == "*") then
                  j = 1
                  line(1:1) = " "
                end if
                do ii = 1, len_trim(line)
                  if (line(ii:ii) /= " ") then
                    j = j + 1
                    line(j:j) = line(ii:ii)
                  end if
                end do
!
!   "j" is the number of characters in the PDB chain letter plus residue number
!
!   "jj" is the number of characters in the keyword for the test
!
                if (len_trim(txt) == j) then
                  do k = 1, jj
                    if (txt(k:k) /= line(k:k) .and. txt(k:k) /= "*") exit
                  end do
                  if (k > jj) then
                    l_use(i) = .true.
                    do j = 1, natoms
                      if (l_use(j)) cycle
                      l_use(j) = (distance(i,j) < Rab)
                    end do
                  end if
                end if
              end do
              if (index(keywrd, " NOOPT") /= 0) then
                do i = 1, natoms
                  if ( .not. l_use(i)) cycle
                  line = txtatm(i)(22:)
                  j = 1
                  do ii = 1, len_trim(line)
                    if (line(ii:ii) /= " ") then
                      line(j:j) = line(ii:ii)
                      j = j + 1
                    end if
                  end do
                  do k = 1, jj
                    if (txt(k:k) /= line(k:k) .and. txt(k:k) /= "*") exit
                  end do
                  l_use(i) = (k < jj + 1)
                end do
              end if
              line = trim(line_2)
              j = index(line(i_loop + 1:), ") ") + i_loop
              i = index(line(i_loop:j + i_loop), ",")
              if (i == 0) exit
!
!  Move on to next residue
!
              i_loop = i_loop + i
              k = index(line(i_loop:), "=")
            end do
            if (l_dummy) then
              do i = 1, natoms
                if (labels(i) == 86) labels(i) = 99
              end do
              call gmetry (geo, coord)
            end if
          else
!
!   Keyword OPT("text1"[,"text2"[,"text3"]]...) used, so use only atoms in the defined residues.
!
            i4 = i
            j4 = index(line(i4 + 1:), '"') + i4
!
!  Text for selected atoms
!
            do
              txt = line(i4 + 1:j4 - 1)
              jj = 0
              do i = 1, len_trim(txt)
                if (txt(i:i) /= " ") then
                  jj = jj + 1
                  txt(jj:jj) = txt(i:i)
                end if
              end do
              txt(jj + 1:) = " "
!
! If no chain letter in the residue name, don't check for the chain letter in the protein
!
              ij = 22
              if (txt(1:1) >= "0" .and. txt(1:1) <= "9") then
                ij = 23
              end if
              do i = 1, natoms
!
!  l_use(i) = F:  not assigned
!  l_use(i) = T:  Assigned because it matches the SITE word
!
                line_1 = txtatm(i)(ij:)
                j = 1
                do ii = 1, len_trim(line_1)
                  if (line_1(ii:ii) /= " ") then
                    line_1(j:j) = line_1(ii:ii)
                    j = j + 1
                  end if
                end do
                if (len_trim(txt) == j - 1) then
                  do k = 1, jj
                    if (txt(k:k) /= line_1(k:k)) exit
                  end do
                  if (k > jj) l_use(i) = .true.
                end if
              end do
!
! Move on to the next residue
!
              i4 = j4 + 2
              if (line(i4:i4) /= '"') exit
              j4 = index(line(i4 + 1:), '"') + i4
            end do
          end if
          do i = 1, natoms
            if (l_use(i)) lopt(:,i) = 1
          end do
        else
          do
            i = index(line, " OPT")
            if (i == 0) exit
            j = index(line(i + 2:)," ") + i
            line(i:i + 4) = " "
            if (j - i == 6) then
              line(1:1) = line(j - 1:j - 1)
              line(2:2) = char( ichar(line(j:j)) + ichar("a") - ichar("A"))
            else  if (j - i == 5) then
              line(1:1) = " "
              line(2:2) = line(j:j)
            else if (j - i == 3) then
              if (natoms > 1) then
                l_int = na(2) /= 0
              else
                l_int = .false.
              end if
              do i = 1, natoms
                if (i == 1 .and. l_int) cycle
                lopt(1, i) = 1
                if (i == 2 .and. l_int) cycle
                lopt(2, i) = 1
                if (i == 3 .and. l_int) cycle
                lopt(3, i) = 1
              end do
              cycle
            else
              cycle
            end if
            do l = 1, 99
              if (line(1:2) == elemnt(l)) exit
            end do
            do i = 1, natoms
              j = labels(i)
              if (j == l) then
                lopt(1, i) = 1
                lopt(2, i) = 1
                lopt(3, i) = 1
              end if
            end do
          end do
        end if
      end if
!
!   FORCE OPTIMIZATION FLAGS OFF FOR DEPENDENT COORDINATES
!
      j = 1
      if (xyz) j = 2
      do i = 1, natoms
        if (na(i) > 0) exit
      end do
      if (xyz .or. i > natoms) j = 2
      do i = 1, ndep
        lopt(idepco(idepfn(i),j),locdep(i)) = 0
      end do
      if (ndep /= 0) call symtry
!
! INITIALIZE FLAGS FOR OPTIMIZE AND PATH
!
      iflag = 0
      latom = 0
      numat = 0
      if (nvar /= 0) then
        numat = natoms
      else
        if (index(keywrd, " FORCETS") /= 0) then
          do i = 1, natoms
            if (lopt(1,i) /= lopt(2,i) .or. lopt(1,i) /= lopt(3,i)) then
              write(iw,'(/10x,a,i5)')" Fault on line:",i
              call mopend("All optimization flags for an atom must be the same.")
              return
            end if
          end do
        end if
        loc = 0
        if (index(keywrd, " FORCETS") /= 0 .and. index(keywrd," RESTART") /= 0) then
          k = 1
        else
          k = 2
        end if
        do i = 1, natoms
          if (labels(i) /= 99 .and. labels(i) /= 107) numat = numat + 1
          if (k == 1) then
            if (lopt(1,i) /= lopt(2,i) .or. lopt(1,i) /= lopt(3,i)) then
              write(iw,'(/10x,a,i5)')" Fault on line:",i
              call mopend("All optimization flags for an atom must be the same")
              return
            end if
          end if
          do j = 1, 3
            if (lopt(j,i) == 1 .or. lopt(j,i) == k) go to 200
            if (lopt(j,i) > -1) cycle
            if (iflag /= 0) then
              if (index(keywrd,' STEP1') /= 0) then
                lpara1 = lparam
                latom1 = latom
                lpara2 = j
                latom2 = i
                latom = 0
                iflag = 0
                cycle
              else
               call mopend ('ONLY ONE REACTION COORDINATE PERMITTED')
                return
              end if
            end if
            latom = i
            lparam = j
            convrt = 1.d0
            if (j > 1 .and. na(latom) > 0) convrt = 0.01745329252D00
            if (allocated(react)) deallocate(react)
            allocate(react(4000))
            react(1) = geo(lparam, latom)
            ireact = 1
            iflag = 1
            cycle
!    FLAG FOR OPTIMIZE
  200       continue
            nvar = nvar + 1
            loc(1,nvar) = i
            loc(2,nvar) = j
            xparam(nvar) = geo(j,i)
          end do
        end do
        if (numat == 0) then
          call mopend ('NO REAL ATOMS, ONLY DUMMY ATOMS AND/OR TRANSLATION VECTORS PRESENT')
          return
        end if
      end if
      if (index(keywrd, " MINI ") /= 0) then
        j = 0
        nl_atoms = 0
        if (index(keywrd, " FORCETS") /= 0) then
          k = 0
        else
          k = 1
        end if
        do i = 1, natoms
          l_atom(i) = (abs(lopt(1,i)) > k)
          if (l_atom(i)) nl_atoms = nl_atoms + 1
          if (lopt(1,i) == 1) j = j + 1
        end do
        if (nl_atoms == 0) then
          if (index(keywrd, " 0SCF") == 0) then
            call mopend("Keyword 'MINI' used, but no atoms flagged for printing (optimization flag '2')")
            return
          end if
        end if
        if (j == 0 .and. k == 0) then
          call mopend("Keyword 'FORCETS' used, but no atoms flagged for FORCE calculation (optimization flag '1')")
          return
        end if
      else
        nl_atoms = numat
        l_atom = .true.
      end if
      line_1 = trim(keywrd)
      call l_control("GEO_DAT", len_trim("GEO_DAT"), -1)
      call l_control("GEO_REF", len_trim("GEO_REF"), -1)
      i = index(keywrd," RESTART")
      keywrd = line_1
      if (i /= 0 .and. index(keywrd,' IRC') + index(keywrd,'FORCE') + index(keywrd," THERMO") == 0) then
        inquire (file=restart_fn, exist = exists)
        if (.not. exists) goto 1900
        open (unit=ires, file=restart_fn, status="UNKNOWN", &
                   & form="UNFORMATTED")
        rewind (ires)
               !
               !  Read in the geometric variables
               !
         read (ires, end=1900, err=1900) i,i, (xparam(i), i=1, nvar)
         close (ires)
         do i = 1, nvar
           k = loc(1, i)
           l = loc(2, i)
           geo(l, k) = xparam(i)
         end do
         if (ndep /= 0) call symtry
         call gmetry (geo, coorda)
         if (index(keywrd, " XYZ") /= 0) na(:numat) = 0
        end if
! READ IN PATH VALUES
      if (iflag /= 0) then
        if (Index (line, " TS") /= 0) then
          call mopend("""TS"" cannot be used when an optimization flag of -1 is present")
          return
        end if
        if (Index (line, " SIGMA") /= 0) then
          call mopend("""SIGMA"" cannot be used when an optimization flag of -1 is present")
          return
        end if
        if (Index (line, " NLLSQ") /= 0) then
          call mopend("""NLLSQ"" cannot be used when an optimization flag of -1 is present")
          return
        end if
        if (index(keywrd,' SIGMA') /= 0) then
          write (iw, '(A)') &
            ' SIGMA USED WITH REACTION PATH; THIS OPTION IS NOT ALLOWED'
          call mopend (&
             'SIGMA USED WITH REACTION PATH; THIS OPTION IS NOT ALLOWED')
          return
        end if
        if (index(keywrd,' STEP=') + index(keywrd,' POINT=') + index(keywrd,' 0SCF') /= 0) then
          go to 250
        end if
  220   continue
        read (ir, '(A)', end=240) line
        call nuchar (line, len_trim(line), value, nreact)
        if (nreact == 0) go to 240
        do i = 1, nreact
          ij = ireact + i
          react(ij) = value(i)*convrt
          if (abs(react(ij)-react(ij-1)) >= 1.D-12) cycle
          dum1 = react(ij)/convrt
          dum2 = react(ij-1)/convrt
          write (iw, &
      '(3/,'' TWO ADJACENT POINTS ARE IDENTICAL:  '',    F7.3,2X,F7.3,/,'' THIS&
      & IS NOT ALLOWED IN A PATH CALCULATION'')') dum1, dum2
          call mopend (&
       'TWO ADJACENT POINTS ARE IDENTICAL: THIS IS NOT ALLOWED IN A PATH CALCULATION')
          return
        end do
        ireact = ireact + nreact
        go to 220
  240   continue
        degree = 1.D0
        if (lparam > 1 .and. na(latom) > 0) degree = 57.29577951308232D0
         if (index(keywrd,' 0SCF') + index(keywrd,' RESEQ') == 0) then
          if (ireact <= 1) then
            call mopend ('NO POINTS SUPPLIED FOR REACTION PATH')
            write (iw, '(2/10X,'' GEOMETRY AS READ IN IS AS FOLLOWS'')')
            xparam(1) = -1.D0
            call geout (1)
            return
          else
            write (iw, '(2/10X,'' POINTS ON REACTION COORDINATE'')')
            write (iw, '(10X,8F8.2)') (react(i)*degree,i=1,ireact)
          end if
          iend = ireact + 1
          react(iend) = -1.D12
          if (na(latom) > 0 .and. lparam == 1 .and. labels(1) < 99 .and. labels(latom) < 99 ) then
            do i = 1, ireact
              if (abs(react(i)) < 1.d-3) exit
            end do
            if (i <= ireact) then
              write(line,'(a, i4, a)')"INTERATOMIC SEPARATION IS ZERO FOR POINT", i, " ON REACTION PATH"
              call mopend (trim(line))
              return
            end if
          end if
        end if
      end if
  250 continue
      if (nvar > 0 .and. index(keywrd,' PM7-TS') /= 0) nvar = 0
      call wrttxt (iw)
      if (index(keywrd,' 0SCF') == 0) then
!
! CHECK DATA
!
        if (xyz) then
          if (index(keywrd,' IRC') + index(keywrd,' DRC') + &
          index(keywrd,' 1SCF') + index(keywrd,' FORCE') + index(keywrd,' DFORCE') == 0) then
            if (nvar /= 0 .and. intern .and. nvar < 3*numat-6) then
              write (iw, &
      '(2/10X,''INTERNAL COORDINATES READ IN, AND CALCULATION '',/10X, &
      & ''TO BE RUN IN CARTESIAN COORDINATES, '',/10X, &
      & ''BUT NOT ALL COORDINATES MARKED FOR OPTIMISATION'')')
              write (iw, &
      '(2/10X,''THIS INVOLVES A LOGICALLY ABSURD CHOICE'',/10X, &
      & '' SO THE CALCULATION IS TERMINATED AT THIS POINT'')')
              call mopend ('INCONSISTENT USE OF OPTIMIZATION FLAGS')
              return
            end if
          end if
        else
          if (index(keywrd,' FORCE') + index(keywrd,' DFORCE') + index(keywrd,' 1SCF') == 0 .or. &
            index(keywrd,' GRAD') /= 0) then
            if (intern .and. nvar/=0 .and. nvar<3*numat-6) then
              write (iw, &
         '(2/10X,''CARTESIAN COORDINATES READ IN, AND CALCULATION '',/10X, &
      & ''TO BE RUN IN INTERNAL COORDINATES, '',/10X, &
      & ''BUT NOT ALL COORDINATES MARKED FOR OPTIMIZATION'')')
              write (iw, '(10x,a)')'EITHER ADD "OPT", EDIT THE GEOMETRY, OR REMOVE "INT"'
              call mopend ('INCONSISTENT USE OF OPTIMIZATION FLAGS')
              return
            end if
          end if
        end if
      end if
      if (index(keywrd,' LOG') + index(keywrd," ADD-H") /= 0 .or. &
      (index(keywrd," 0SCF") /= 0 .and. index(keywrd," OLDGEO") /= 0 .and. &
       index(keywrd," PDBOUT") /= 0)) then
        inquire(unit=ilog, opened=opend)
        if (.not. opend) open(unit=ilog, form='FORMATTED', status='UNKNOWN', file=log_fn, position='asis')
        call wrttxt (ilog)
       end if
      if (index(keywrd," OLDGEO") /= 0) call delete_ref_key("OLDGEO", len_trim("OLDGEO"), ' ', 1)
      if (index(keywrd, " NOTXT") /= 0) then
        maxtxt = 0
        txtatm = " "
      end if
      if (prt_coords) call geout(1)
      write(iw,*)
      if (moperr) return
!
!  Check for isotopes.  If found, print them out
!
      j = 0
      k = 0
      do i = 1, natoms
        if (labels(i) == 99 .or. labels(i) == 107) cycle
        k = k + 1
        if (Abs(atmass(k) - ams(labels(i))) > 1.d-3) then
          if (j == 0) then
            write(iw,"(/30x, a,/)")"  Isotopes Used"
            j = 1
          end if
        write(iw,"(a,i5,1x,2a,f8.4,a,f8.4,a)")"              Atom:", i, elemnt(labels(i)), &
   "  Default mass", ams(labels(i)), ",  mass used:", atmass(k), " amu"
        end if
      end do
      call gmetry (geo, coord)
      if(index(keywrd," PKA") /= 0) then
!
!  Do any ionizable hydrogen atoms exist (hydrogens attached to an oxygen)
!
        k = 0
        i = 0
        do ii = 1, natoms
          if (labels(ii) < 99) i = i + 1
          if (labels(ii) /= 1) cycle
          j = 0
          do jj = 1, natoms
            if (labels(ii) < 99) j = j + 1
            if (labels(jj) /= 8) cycle
            sum = (coord(1,i) - coord(1,j))**2 + &
                & (coord(2,i) - coord(2,j))**2 + &
                & (coord(3,i) - coord(3,j))**2
            if (sum < 1.69d0) then
              k = 1
              exit
            end if
          end do
        end do
        if (k == 0) then
          write(iw,"(/,3(10x,a,/))")"A request was made to print the pKa values for this system,", &
      "but there are no hydrogen atoms attached to an oxygen atom,", &
      "so the pKa calculation cannot be completed."
          call mopend("No '-O-H' groups found.  pKa cannot be calculated")
          return
        end if
      end if
      if (moperr) return
      pdb_label = (maxtxt > 25)
      use_ref_geo = (quoted('GEO_REF="')  > 0)
      if (use_ref_geo) then
!
!  "GEO-OK+" is used only by COMPARE.  It can be read as "If one or more hydrogen atoms in the two systems have different labels,
!  ignore the difference in labels and continue with the comparison."
!
        if (index(keywrd, " COMPAR") /= 0) then
          if (index(keywrd_txt, " LET") /= 0) then
            call l_control("0SCF HTML GEO-OK+ LET NOCOM", len_trim("0SCF HTML GEO-OK+ LET NOCOM"), 1)
          else
            call l_control("0SCF HTML GEO-OK LET NOCOM", len_trim("0SCF HTML GEO-OK LET NOCOM"), 1)
          end if
        end if
        if (index(keywrd,' RESIDUES0') /= 0 .and. index(keywrd,' 0SCF') /= 0 .and. index(keywrd, " HTML") /= 0) then
          nat(:numat) = labels(:numat)
          call geochk
        end if
        if (index(keywrd,' SYMM') + index(keywrd," SYM ") /= 0) then
          call mopend("""SYMMETRY"" cannot be used with ""GEO_REF"" (""GEO_REF"" requires all coordinates to be optimized)")
          return
        end if
        call geo_ref
        if (.not. allocated(lopt_store)) then
!
! Store lopt for input data-set or GEO_DAT in case it will be needed in LOCATE_TS
!
          allocate(lopt_store(3,numat))
          lopt_store = lopt(:3,:numat)
        end if
        if (moperr) return
        lopt = 1
      end if
      if (index(keywrd," NOCOM") /= 0) then
        ncomments = 0
        do j = 1, 3
          line = refkey(j)
          call upcase(line, len_trim(line))
          i = index(line, " NOCOM")
          if (i > 0) then
            do i = i + 1, i + 10
              if (refkey(j)(i:i) == " ") exit
              refkey(j)(i:i) = " "
            end do
          end if
        end do
      end if
      if (index(keywrd, " SETPI") /= 0) then
        i = min(setpi_limit, numat)
        if (allocated(pibonds)) deallocate(pibonds)
        if (allocated(pibonds_txt)) deallocate(pibonds_txt)
        allocate (pibonds(i,2), pibonds_txt(i))
        pibonds_txt = " "
        pibonds = 0
!
!  The user supplies some pi bonds.
!
        i = index(keywrd, " SETPI")
        j = index(keywrd(i + 6:), " ") + i + 4
        l = index(keywrd(i:j), "=")
        if (l /= 0) then
!
!  Read pi bonds from a file in this folder
!
          l = l + i
          if (keywrd(l:l) == '"') then
            do j = l + 1, len_trim(keywrd)
              if (keywrd(j:j) == '"') exit
            end do
            l = l + 1
            j = j - 1
          end if
          line = keywrd(l:j)
          call add_path(line)
          inquire (file=line, exist = exists)
          if (exists) then
            ir_temp = 27
            open (unit=ir_temp, file=line)
            rewind (ir_temp)
          else
            if (index(keywrd,' 0SCF') == 0 ) then
              write(line_1,'(a)')" Pi-bond file """//trim(line)//""" does not exist."
              call mopend(trim(line_1))
              write(line_1,'(a)')"(required by SETPI="""//trim(line)//""")"
              call mopend(trim(line_1))
              return
            end if
          end if
          k = index(keywrd," SETPI=") + 7
          if (k > 7) then
            do ii = 1, 6
              line = " "//trim(refkey(ii))
              call upcase(line, len_trim(line))
              i = index(line," SETPI=")
              if (i /= 0) exit
            end do
            if (keywrd(k:k) == '"') then
              j = index(refkey(ii)(i + 9:),'" ') + i + 7
            else
              j = index(refkey(ii)(i + 9:),' ') + i + 6
            end if
            refkey(ii) = refkey(ii)(:i + 4)//refkey(ii)(j + 2:)
          end if
        else
          ir_temp = ir
        end if
        l = 0
        do
          read (ir_temp,'(a)',end=98, err=98) line
          if (line(1:1) == "*") cycle
          if (line == " ") exit
          i = index(line, " User")
          if (i /= 0) line(i:) = " "
          pibonds_txt(l + 1) = trim(line)
          call upcase(line, len_trim(line))
          i = index(line, '"')
          if (i > 0) then
            do i4 = 1,2
              i = index(line, '"')
              if (i /= 0) then
                j = index(line(i:),"""") + i
                if (j == i) exit
                ij = index(line(j:),"""") + j
                line_1 = line(j:ij - 2)
!
! Do NOT use "txt_to_atom_no" in the next block - the format must be in PDB
!
                if (line_1(1:1) == "[") then
!
! Atom defined using Jmol format
!
                  ii = index(line(j:ij - 2),".") + j
                  k = index(line(j:ij - 2),":") + j
                  jj = index(line(j:ij - 2),"]") + j
                  if (k == j) then
                    line_1 = line(ii:ij - 2)//line(j + 1:jj - 2)//line(jj:ii - 2)
                  else
                    line_1 = line(ii:ij - 2)//line(j + 1:jj - 2)//line(k:k)//line(jj:k - 2)
                  end if
                else
                  j = 0
                  do i = 1, len_trim(line_1)
                    if (line_1(i:i) /= " ") then
                      j = j + 1
                      line_1(j:j) = line_1(i:i)
                    end if
                  end do
                  line_1(j + 1:) = " "
                end if
                do i = 1, numat
                  line_2 = txtatm(i)
                  ij = 0
                  do k = 13, txtmax
                    if (line_2(k:k) /= " ") then
                      ij = ij + 1
                      line_2(ij:ij) = line_2(k:k)
                    end if
                  end do
                  line_2(ij + 1:) = " "
                  ij = max(ij, len_trim(line_1))
                  do j = 1, ij
                    if (line_1(j:j) /= line_2(j:j) .and. line_1(j:j) /= "*") exit
                  end do
                  if (j > ij) exit
                end do
                if (i > numat) then
                  i = index(line,'"')
                  if (i > 0) then
                    j = index(line(i + 1:), '"') + i
                    write(line_1,'(a)')"Pi-bond atom defined by "//line(i:j)//" does not exist."
                    call mopend(trim(line_1))
                    return
                  end if
                end if
                ii = index(line, '"')
                jj = index(line(ii + 1:),"""") + ii
                write(line(ii:jj),'(i5)')i
              end if
            end do
          end if
!
!  Read in the first of the two atom numbers
!
          do i = 1, len_trim(line)
            if (line(i:i) /= " ") then
              ii = nint(reada(line,i))
              exit
            end if
          end do
          do i = i + 1, len_trim(line)
            if (line(i:i) == " ") then
              jj = nint(reada(line,i))
              exit
            end if
          end do
          l = l + 1
          if (ii > numat .or. jj > numat) then
            write(line,'(a,i5,a,i5,a)') " pi bond between atoms",ii," and", jj," is impossible - atom number too large"
            call mopend(trim(line))
            return
          end if
!
! Check that the number of pi-bonds is within the limit
!
          if (l >= setpi_limit) then
            write(line,'(a,i0,a,i0,a)') "The number of bonds provided to SETPI exceeds the limit of min(",setpi_limit,", ",numat,")"
            call mopend(trim(line))
            return
          end if
          pibonds(l,1) = ii
          pibonds(l,2) = jj
        end do
98      if (l == 0) then
          if (index(keywrd,' 0SCF') + index(keywrd, " RESEQ") == 0 .and. mozyme) then
            call mopend("Keyword SETPI used, but no pi bonds specified")
            call web_message(iw,"SETPI.html")
            return
          end if
        else
         write(iw,'(/15x,a)')"Keyword SETPI used, pi-bonds specified are:"
         write(iw,'(/12x,a)')"   Bond No.                   Atom               to              Atom"
         do i = 1, l
           if (maxtxt == 26) then
           write(iw,'(12x,i7,12x,a,a,a)')i, &
           '"'//txtatm(pibonds(i,1))(:maxtxt)//'"', "   -   ", '"'//txtatm(pibonds(i,2))(:maxtxt)//'"'
           else
             write(iw,'(1x,i18,22x,i5,13x, a,i15)')i,pibonds(i,1), "   -   ", pibonds(i,2)
           end if
         end do
        end if
        if (ir_temp == 27) close(ir_temp)
      end if
      k = index(keywrd," GEO_DAT") + 10
      call delete_ref_key("GEO_DAT=", len_trim("GEO_DAT="), '" ', 2)
      if (moperr) return
      if (index(keywrd,' AUTOSYM') /= 0) call maksym(loc, xparam, xyzt)
      if (index(keywrd,' 0SCF') + index(keywrd, " RESEQ") /= 0) then
        inquire(unit=iarc, opened=opend)
        if (opend) close (iarc)
        if (index(keywrd, "PDBOUT") /= 0) archive_fn = archive_fn(:len_trim(archive_fn) - 3)//"pdb"
      end if
      if (prt_cart .and. (maxtxt < 26 .and. (index(keywrd,' NOXYZ') == 0 .or. gui))) then
         write (iw, '(2/10X,''CARTESIAN COORDINATES '',/)')
        write (iw, &
      '(4X,''NO.'',7X,''ATOM'',11X,''X'',11X,''Y'',11X,''Z'',/)')
        l = 0
        do i = 1, natoms
          if (labels(i)==99 .or. labels(i)==107) cycle
          l = l + 1
          if (l_atom(i)) write (iw, '(I6,8X,A2,4X,3F12.4)') l, elemnt(labels(i)), (coord(j,l),j=1,3)
          end do
      end if
      return
1900  if (exists) then
        call mopend("RESTART file is corrupt")
      else
        call mopend("RESTART file '"//trim(restart_fn)//"' does not exist.")
      end if
      return
      end subroutine readmo
      double precision function snapth (theta)
      implicit none
      double precision, intent (in) :: theta
      integer :: i, j, k
      double precision :: angle, const, phase, sum
      intrinsic Abs, Acos, Asin, Cos, Int, Mod, Nint, Sign, Sqrt, Dble
        angle = Cos (theta)
        phase = Sign (1.d0, theta)
        if (Abs (angle) < 1.d-4) then
          !
          !   Cos(Theta) is zero - this is 90 or 270 degrees
          !
          const = 2 * Asin (1.d0)
          if (Abs (theta) < const) then
            snapth = phase * Acos (0.d0)
          else
            snapth = phase * Acos (0.d0) + const
          end if
        else
          sum = Abs (1.d0/angle) ** 2
          do i = 1, 7
            j = Nint (sum*i)
            if (Abs (j-sum*i) < 5.d-3) go to 1000
          end do
          snapth = theta
          return
    1000  sum = Sqrt (Dble(i)/Dble(j))
          const = 2 * Asin (1.d0)
          k = Int (Abs (theta)/const)
          if (Mod(k, 2) == 0) then
             !
             !   Theta is in domain -180 - 0 - +180 degrees
             !
            snapth = phase * Acos (sign(sum, angle))
          else
             !
             !   Theta is in domain -180 - 360 - +180 degrees
             !
            snapth = phase * (2*const-Acos (sign(sum, angle)))
          end if
        end if
  end function snapth
  subroutine geo_diff(sum, rms, prt)
!
!  geo_diff calculates the total distance between geometries "geo" and "geoa"
!
!  Two measures are used:
!
!   sum = addition of all differences in position, i.e., sum of motions of atoms.
!   rms = sum of squares of differences in positions,
!   i.e., the square of the vector sum of differences
!
    use common_arrays_C, only : geo, geoa, txtatm, nat
    use molkst_C, only : numat, keywrd, txtmax, line
    use chanel_C, only : iw
    use elemts_C, only : elemnt
    use MOZYME_C, only : tyres
    implicit none
    double precision, intent (out) :: sum, rms
    logical, intent (in) :: prt
    logical :: precise
    integer :: i, j, k, lim, ires_l, ires_u
    logical :: first, l_first
    double precision :: dum1, sum1
    character :: num*7
    integer, allocatable :: No_atoms_in_residue(:)
    double precision, allocatable :: move(:), residue_motion(:)
    character, allocatable :: residue_name(:)*10
    double precision, external :: reada
    save :: first, l_first
    sum1 = 0.d0
    do i = 1, numat
      sum1 = max(sum1, reada(txtatm(i), 24))
    end do
    i = max(numat, nint(sum1))
    allocate (move(i), residue_motion(-100:i), residue_name(-100:i), No_atoms_in_residue(-100:i))
!
!  Calculate the average and RMS differences of two geometries
!
    precise = (index(keywrd, " PREC") /= 0)
    residue_motion = 0.d0
    No_atoms_in_residue = 0
    ires_l = 10000
    ires_u = -1000
    sum = 0.d0
    rms = 0.d0
    do i = 1, numat
      dum1 =  (geo(1,i) - geoa(1,i))**2 + &
              (geo(2,i) - geoa(2,i))**2 + &
              (geo(3,i) - geoa(3,i))**2
      rms = rms + dum1
      dum1 = sqrt(dum1)
      move(i) = dum1
      sum = sum + dum1
      if (txtmax >= 26) then
        j = max(-100, nint(reada(txtatm(i), 24)))
        ires_l = min(j, ires_l)
        ires_u = max(j, ires_u)
        residue_motion(j) = residue_motion(j) + move(i)
        No_atoms_in_residue(j) = No_atoms_in_residue(j) + 1
        residue_name(j) = txtatm(i)(17:26)
      end if
    end do
    first = .true.
    l_first = .true.
    sum1 = 0.d0
    lim = min(60, numat)
    if (.not. precise) lim = min(30, lim)
    do i = 1, lim
      dum1 = -1.d0
      do j = 1, numat
        if (dum1 < move(j)) then
          dum1 = move(j)
          k = j
        end if
      end do
      if (dum1 > 0.1d0 .or. (dum1 > 0.003d0 .and. i < 11) .or. (precise .and. dum1 > 0.001d0)) then
        if (prt .and. first) then
          first = .false.
          write(iw,'(/21x,a,//2x,a,/)')"Atoms that move a lot", &
          "                   Atom Label             GEO_REF Coordinates       Movement    Integral"
        end if
        if (prt) then
          sum1 = sum1 + dum1
          if (dum1 > 0.1d0) then
            num = "12.2,2x"
          else
            num = "14.4   "
          end if
          if (txtatm(k) /= " ") then
            if (prt) write(iw,'(8x,  4x, a, 3f8.3, f'//num//', f11.2)')"("//txtatm(k)(:txtmax)//")", geoa(:,k), dum1, sum1
          else
            if (prt) write(iw,'(1x, i5, 18x, a2, 14x, 3f8.3, f'//num//', f11.2)')k, elemnt(nat(k)),  geoa(:,k), dum1, sum1
          end if
          move(k) = -2.d0
        end if
      else
        exit
      end if
    end do
    if (prt) then
      do i = ires_l, ires_u
        if (residue_motion(i) > 1.d-10) residue_motion(i) = residue_motion(i)/No_atoms_in_residue(i)
      end do
      line = " "
      k = 0
      do
        k = k + 1
        sum1 = 0.d0
        j = 0
        do i = ires_l, ires_u
          if (residue_motion(i) > sum1) then
            sum1 = residue_motion(i)
            j = i
          end if
        end do
        if (sum1 < 0.1d0) exit
        residue_motion(j) = 0.d0
        if (l_first) then
          write(iw,'(/5x, a, /)')"Residues that move a lot and their (Movement in Angstroms, per atom)"
          l_first = .false.
        end if
        do i = 1, 22
          if (residue_name(j)(2:4) == tyres(i)) exit
        end do
        num = residue_name(j)(2:4)
        if (i < 23) then
          do i = 2, 3
            num(i:i) = char(ichar(num(i:i)) + ichar("a") - ichar("A"))
          end do
        end if
        i = len_trim(line)
        write(line(i + 1:),'(4x, a, f5.2, a)') num(1:3)//residue_name(j)(7:)//"(", min(sum1,99.99d0),")"
        if (mod(k,5) == 0) then
          write(iw,'(a)') trim(line)
          line = " "
        end if
      end do
    end if
    deallocate (move, residue_motion, residue_name)
    return
  end subroutine geo_diff
  subroutine add_path(file)
    use chanel_C, only : job_fn
    implicit none
    character, intent (inout) :: file*(*)
    integer :: i, j, n
    character :: path*241
    logical :: need_path
    i = 0
    if (file(1:1) == '"') then
      i = len_trim(file)
      path = file(2:i-1)
      file = trim(path)
    end if
!
!  Test to see if the file "file" already has an absolute path.
!
    need_path = (file(2:2) /= ":" .and. file(1:1) /= "/" .and. file(1:1) /= "~")
    if (.not. need_path) return
!
!  Test to see if the job has an absolute path.
!
    need_path = (job_fn(2:2) == ":" .or. job_fn(1:1) == "/")
    if (.not. need_path) return
!
!  file "file" does not include the path and the path is present in job_fn
!  therefore add path to the file "file"
!
!  First check if a relative path is used
!
    n = 1
    do
      if (file(1:3) /= ".."//"/" .and. file(1:3) /= ".."//"/") exit
      n = n + 1
      file = trim(file(4:))
    end do
!
!  Is the file defined relative to the current folder?
!  If so, delete the definition.
!
    if (file(1:2) == "."//"/" .or. file(1:2) == "."//"/") file = trim(file(3:))
!
!  Delete the data-set-name from the path, and delete the folders up to the relative folder.
!
    path = trim(job_fn)
    do j = 1, n
      do i = len_trim(path) - 1, 1, -1
        if (path(i:i) == "/") exit
      end do
      path = path(:i)
    end do
!
!  Finally, join the path to the start of the file
!
    file = path(:i)//trim(file)
    return
  end subroutine add_path
  subroutine delete_ref_key(beginning, length_beginning, ending, length_ending)
!
! Delete keyword from refkey so that it will not appear in an ARC file
!
!   beginning :        Start of keyword to be deleted (MUST be uppercase)
!   length_beginning : Length of string in "beginning"
!   ending :           End of keyword (MUST be uppercase)
!   length_ending :    Length of string "ending"
!
  use molkst_C, only : refkey, line
  implicit none
  integer, intent (in) :: length_beginning, length_ending
  character, intent (in) :: beginning*(length_beginning), ending*(length_ending)
  integer :: i, j, k
  logical :: in_text
  do
    k = 0
    do i = 1, 6
      line = " "//trim(refkey(i))
      call upcase(line, len_trim(line))
      k = index(line," "//beginning)
      if (k /= 0) exit
    end do
    if (k == 0) exit
!
!  Search from the start of the keyword (k) to find the end of the keyword (j)
!
    j = index(refkey(i)(k + length_beginning:), ending) + k + length_beginning
!
!  Search for the first non-blank character (j) after the keyword, if it exists.
!
    do j = j, len_trim(refkey(i))
      if (refkey(i)(j:j) /= " ") exit
    end do
!
!  Search for the first non-blank character (k) before the keyword, if it exists.
!
    do k = k - 1, 1, -1
      if (refkey(i)(k:k) /= " ") exit
    end do
!
! Eliminate the keyword
!
    refkey(i) = refkey(i)(:k)//" "//refkey(i)(j:)
!
! Cycle, in case there is more than one instance of the keyword.
!
  end do
!
!  Compress keywords, if possible.
!  This involves deleting " + " and " & ", if present and the resulting line is not too long,
!  and removing excess spaces between keywords
!
  if (index(refkey(1), " + ") + index(refkey(1), " & ") > 0) then
    if (index(refkey(2), " + ") + index(refkey(2), " & ") > 0) then
      i = len_trim(refkey(3))
      j = len_trim(refkey(2))
      if (j < 120) then
        k = index(refkey(2), " + ") + index(refkey(2), " & ") + 1
        refkey(2)(k:k) = " "
        refkey(2) = refkey(2)(:j)//refkey(3)(:i)
        refkey(3) = "    NULL"
      end if
    end if
    i = len_trim(refkey(2))
    j = len_trim(refkey(1))
    if (j < 60) then
      k = index(refkey(1), " + ") + index(refkey(1), " & ") + 1
      refkey(1)(k:k) = " "
      refkey(1) = refkey(1)(:j)//refkey(2)(:i)
      if (index(refkey(2), " + ") + index(refkey(2), " & ") > 0) then
        refkey(2) = trim(refkey(3))
        refkey(3) = "    NULL"
      else
        refkey(2) = "    NULL"
      end if
    end if
!
! First line of keywords MUST be printed
!
    i = index(refkey(1), " NULL")
    if (i /= 0) refkey(1) = refkey(1)(:i)//refkey(1)(i + 5:)
    do i = 1, 3
      in_text = .false.
      k = 1
      do j = 2, len_trim(refkey(i))
        if (refkey(i)(j:j) == '"') in_text = (.not. in_text)
        if (in_text .or. refkey(i)(j-1:j) /= "  ") then
          k = k + 1
          refkey(i)(k:k) = refkey(i)(j:j)
        end if
      end do
      refkey(i)(k + 1:) = " "
    end do
  end if
  do i = 1, 3
    if (len_trim(refkey(i)) > 0) then
      do
        if (refkey(i)(1:1) /= " ") refkey(i) = " "//trim(refkey(i))
        if (refkey(i)(1:2) == "  ") refkey(i) = trim(refkey(i)(2:))
        if (refkey(i)(2:2) /= " ") exit
      end do
    end if
  end do
  return
  end subroutine delete_ref_key

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine moldat(mode)
!-----------------------------------------------
!
!   If mode == 1 run silently
!   If mode /= 1 generate normal MOPAC output
!
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!
      use common_arrays_C, only : nfirst, nlast, nat, uspd, txtatm, &
      & pdiag, labels, coord, geo, atmass, na, nbonds, ibonds
!
      USE molmec_C, only : nnhco
!
      USE molkst_C, only : natoms, norbs, nalpha, nbeta, nclose, nopen, &
      & nelecs, fract, numat, mpack, keywrd, n2elec, lm61, moperr, line, &
      & uhf, id, msdel, mol_weight, method_PM6, method_PM7, &
      is_PARAM, formula, ispd, mozyme, nvar, rhf, old_chrge, jobnam, &
      N_3_present, Si_O_H_present, nalpha_open, nbeta_open, pdb_label, &
      method_rm1, use_ref_geo, method_indo, backslash
!
      USE parameters_C, only : natorb, uss, upp, udd, tore, &
      dorbs, zd, zs, zp
!
      USE symmetry_C, only : name
!
      use meci_C, only: nmos
!
      USE chanel_C, only : iw, log, ilog, iarc, archive_fn
!
      use elemts_C, only : elemnt
!
!***********************************************************************
!
!       MOLDAT works out essential molecular data, such as orbital
!              counters (NFIRST, NLAST), number of electrons,
!              starting populations, etc.
!
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: mode
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: kharge, i, ndorbs, ia, ib, nheavy, nnull, ii, &
        k, k1, j, ielec, ndoubl, ne, nupp, &
        ndown, l, iminr, jminr, icount, &
        ireal, jreal, ni, n1, n4, n9
      integer(8) :: n2elec8
      double precision :: elecs,  c(1), yy, w, sum, rmin   ! c(1) is for a dummy call
      logical :: debug, exci, sing, doub, trip, quar, quin, sext, sept, &
        octe, none, birad, halfe, odd, opend
      character :: num1*1
      double precision, dimension (:), allocatable :: rxyz
      double precision, external :: reada
!-----------------------------------------------
      debug = index(keywrd,'MOLDAT') /= 0
!
!   SPECIAL MODIFIERS FOR LIMITATIONS IN AVAILABLE PARAMETERS
!
      i = index(keywrd,' CHARGE=')
      if (i /= 0) then
        kharge = nint(reada(keywrd,i))
        old_chrge = kharge
      else
        kharge = 0
      end if
      elecs = -kharge
      ndorbs = 0
      if (.not. method_indo .and. uss(1) > (-1.D0)) then
      call mopend (&
           'THE HAMILTONIAN REQUESTED IS NOT AVAILABLE IN THIS PROGRAM')
        return
      end if
!
!  Determine the number of atomic orbitals on each element
!
      if (.not. method_indo) then
        do i = 1,107
          dorbs(i) = (zd(i) > 1.d-8)
          if (dorbs(i)) then
            natorb(i) = 9                   ! Element has "d"-orbitals
          else if (zp(i) > 1.d-20) then
            natorb(i) = 4                   ! Element has "p"-orbitals
          else if (zs(i) > 1.d-20) then
            natorb(i) = 1                   ! Element has one "s"-orbital
          else
            natorb(i) = 0                   ! Element has no orbitals
          end if
        end do
      end if
      numat = 0
      ia = 1
      ib = 0
      nheavy = 0
      nnull = 0
      do ii = 1, natoms
        if (labels(ii)/=99 .and. labels(ii)/=107) then
          numat = numat + 1
          nat(numat) = labels(ii)
          nfirst(numat) = ia
          ni = nat(numat)
          elecs = elecs + tore(ni)
          ib = ia + natorb(ni) - 1
          if (natorb(ni) == 9) ndorbs = ndorbs + 5
          nlast(numat) = ib
          uspd(ia) = uss(ni)
          if (ia /= ib) then
            k = ia + 1
            k1 = ia + 3
            do j = k, k1
              uspd(j) = upp(ni)
            end do
            if (ib > ia) then
              nheavy = nheavy + 1
            else
              nnull = nnull + 1
            end if
            if (k1 /= ib) then
              k = k1 + 1
              uspd(k:ib) = udd(ni)
            end if
          end if
        end if
        ia = ib + 1
      end do
      if (numat == 1) then
        if (index(keywrd,'FORCE') /= 0 .and. index(keywrd,' THERMO') == 0) then
          call mopend ('A SINGLE ATOM HAS NO VIBRATIONAL MODES')
          return
        end if
      end if
      if (mode /= 1) call refer
      call gmetry (geo, coord)
      if (mode /= 1)then
        call empiri()
        write(iw,"(/,a,/)") trim(formula)
        if (moperr) return
      end if
      allocate(rxyz((numat*(numat + 1))/2), stat = i)
      if (i /= 0) then
        if (mode /= 1) write(iw,*)" The interatomic distance array could not be assigned"
        if (mode /= 1) call mopend("The interatomic distance array could not be assigned")
!
!  Do not attempt to check interatomic distances, or anything related to the geometry
!
        return
      end if
      if (pdb_label .and. index(keywrd, " GEO-OK") + index(keywrd, " 0SCF") == 0) then
!
!  Sanity check - does the atom name match its label?
!
        l = 0
        if (index(keywrd, "RESIDUES") == 0) then
          do i = 1, numat
            j = labels(i)
            if (j /= 1 .and. (j < 6 .or. j > 8)) cycle
!
!  Check H, C, N, and O, only
!
            if (txtatm(i)(14:14) >= 'a' .and. txtatm(i)(14:14) <= 'z') &
              txtatm(i)(14:14) = char(ichar(txtatm(i)(14:14)) + ichar("A") - ichar("a"))
            if(elemnt(j)(2:2) /= txtatm(i)(14:14) .and. elemnt(j)(2:2) /= txtatm(i)(13:13)) then
              if (j == 1 .and. txtatm(i)(13:13) == "D") then
                txtatm(i)(13:13) = "H"
              else if (j == 1 .and. txtatm(i)(14:14) == "D") then
                txtatm(i)(14:14) = "H"
              else
                num1 = char(Int(log10(i + 0.5)) + ichar("2"))
                write(line,'(a,i'//num1//',a,a)')"Atom name for atom", i, &
                " ("//elemnt(j)(2:2)//") does not match its label """//txtatm(i)//""""
                write(iw,'(10x,a)')trim(line)
                l = l + 1
                if (l == 20) then
                  write(iw,'(/10x,a)') "Remaining errors not printed"
                  exit
                end if
              end if
            end if
          end do
        end if
        if (l > 0) then
          call mopend("Atom name does not match atom label. To suppress this error, add GEO-OK")
          return
        end if
      end if
!
!   WRITE OUT THE INTERATOMIC DISTANCES
!
      l = 0
      iminr = 0
      jminr = 0
      rmin = 100.D0
      do i = 1, numat
        do j = 1, i
          l = l + 1
          rxyz(l) = sqrt((coord(1,i) - coord(1,j))**2 + &
                         (coord(2,i) - coord(2,j))**2 + &
                         (coord(3,i) - coord(3,j))**2)
          if (.not.(rmin > rxyz(l) .and. i /= j .and. (nat(i) < 103 .or. nat(j) < 103))) cycle
          iminr = i
          jminr = j
          rmin = rxyz(l)
        end do
      end do
      call setcup
      if (moperr) return
!
!  The "or" here is needed because symmetry theory uses connectivity
!  (If "or" is replaced by "and" a really weird bug is introduced. DON'T DO IT!
!
      if (index(keywrd, " ADD-H") == 0 .or. index(keywrd, " PDBOUT") /= 0 ) then
        call set_up_dentate
        call check_cvs(index(keywrd, " GEO-OK") .ne. 0)
        if (moperr) return
        call check_H(i)
        if (i /= 0) then
          if (Index (keywrd, " 0SCF") + Index (keywrd, " RESEQ") + Index (keywrd, " SITE=") +  &
            Index (keywrd, " GEO-OK") + Index (keywrd, " ADD-H") + Index (keywrd, " LET") == 0) then
            write(iw,'(10x,a)') "Add keyword ""LET"" to allow job to continue"
            call mopend ("A hydrogen atom is badly positioned")
            if ( index(keywrd," PDBOUT") /= 0) then
              inquire(unit=iarc, opened=opend)
              if (opend) close(iarc)
                line = archive_fn(:len_trim(archive_fn) - 3)//"pdb"
                if (index(keywrd, " HTML") /= 0) then
                  do i = len_trim(line), 1, -1
                    if (line(i:i) == "/" .or. line(i:i) == backslash) exit
                  end do
                end if
              open(unit=iarc, file=trim(line), status='UNKNOWN', position='asis')
              rewind iarc
              call pdbout(iarc)
            end if
          end if
        end if
      end if
      if (use_ref_geo) call big_swap(0,1)
      if (id == 0) then
        if ((index(keywrd, " ADD-H") == 0 .and. .not. mozyme) .or. numat < 200) then
          call symtrz (c, pdiag, 1, .FALSE.)
          if (moperr) return
          if (mode /= 1) write (iw, '(2/''      MOLECULAR POINT GROUP   :   '',A4)') name
        end if
      end if
      mol_weight = 0.D0
      do i = 1, numat
        mol_weight = mol_weight + atmass(i)
      end do
      mpack = 1
      if (Index (keywrd, " RESEQ") + index(keywrd,' 0SCF') + index(keywrd,' ADD-H') &
        + index(keywrd,' SITE')/= 0) return
      n9 = 0
      n4 = 0
      n1 = 0
      do i = 1, natoms
        j = labels(i)
        if (j > 0 .and. j /= 99 .and. j /= 107) then
          k = natorb(j)
          if (k == 1) then
            n1 = n1 + 1
          else if (k == 4) then
            n4 = n4 + 1
          else if (k == 9) then
            n9 = n9 + 1
          end if
        end if
      end do
      ispd = n9
      if (id == 0) then
        n2elec8 = (n4*(n4 - 1))/2
        n2elec8 = 100*n2elec8 + 2025*n9 + 100*n4 + n1 + 2025*(n9*(n9 - 1))/2 + 450*n9*n4 + 45*n9*n1 + &
     &  10*n4*n1 + (n1*(n1 - 1))/2 + 10
      else
        n2elec8 = (n4*(n4 + 1))/2
        n2elec8 = 100*n2elec8 + 2025*n9 + 100*n4 + n1 + 2025*(n9*(n9 + 1))/2 + 450*n9*n4 + 45*n9*n1 + &
     &  10*n4*n1 + (n1*(n1 + 1))/2 + 10
      end if
      if (.not. mozyme .and. n2elec8 > 2147483647) then
        if (Index (keywrd, " RESEQ") + Index (keywrd, " SITE=") + index(keywrd, " ADD-H") == 0) then
          call mopend(" Data set '"//trim(jobnam)//"' exists, but is too large to run.")
          write(iw,'(10x,a)')"(Maximum number of two-electron integrals allowed: 2,147,483,647)"
          write(iw,'(10x,a, i12,a)')"(Number of two-electron integrals exceeded this by:", &
            n2elec8 - 2147483647,")"
          write(iw,'(/10x,a)')"(Try using MOZYME on this system)"
          return
        end if
      end if
      n2elec = int(n2elec8, kind(n2elec))
      if (ispd > 0 .and. index(keywrd, " ESP") /= 0) then
        line = " The ESP method does not work with 'd' orbitals"
        write(iw,'(//,10x,a)')trim(line)
        call mopend(trim(line))
        if (method_pm6) then
          write(iw,'(10x,a)')" (If possible, use MNDO, AM1, or PM3, with a 1SCF to prevent geometry changes)"
        end if
        return
      end if
!
!  Set all solid-state variables at this point
!
      lm61 = 45*n9 + 10*n4 + n1
      norbs = nlast(numat)
      if (index(keywrd, " GRAPH") /= 0) then
        if (norbs > 9500) then
          write(line,'(a)')" The system is too large for 'GRAPH' to be used."
          write(iw,'(//10x,a,/)')trim(line)
          call mopend(trim(line))
          return
        end if
      end if
      if (id /= 0) then
        i = max(18, norbs)
      else
        i = norbs
      end if
      mpack = (i*(i+1))/2
!
!   NOW TO CALCULATE THE NUMBER OF LEVELS OCCUPIED
!
      sing = index(keywrd,' SING') /= 0
      doub = index(keywrd,' DOUB') /= 0
      trip = index(keywrd,' TRIP') /= 0
      quar = index(keywrd,' QUAR') /= 0
      quin = index(keywrd,' QUIN') /= 0
      sext = index(keywrd,' SEXT') /= 0
      sept = index(keywrd,' SEPT') /= 0
      octe = index(keywrd,' OCTE') /= 0
      none = index(keywrd,' NONE') /= 0
      exci = index(keywrd,' EXCI') /= 0
      birad = exci .or. index(keywrd,'BIRAD')/=0
      if (index(keywrd,'C.I.')/=0 .and. uhf) then
        write (iw, '(2/10X,''C.I. NOT ALLOWED WITH UHF '')')
        call mopend ('C.I. NOT ALLOWED WITH UHF')
        return
      end if
!
! NOW TO WORK OUT HOW MANY ELECTRONS ARE IN EACH TYPE OF SHELL
!
      nalpha = 0
      nbeta = 0
!
!      PROTECT DUMB USERS FROM DUMB ERRORS!
!
      nelecs = nint(max(elecs,0.D0))
      nelecs = min(2*norbs,nelecs)
      if (.not. rhf .and. .not. uhf) then
        if (mod(nelecs,2) == 0) then
          rhf = .true.
        else
          uhf = .true.
        end if
      end if
      if (method_indo .and. uhf) then
        write(iw,'(10x,a)')" INDO does not support UHF - defaulting to ROHF"
        rhf = .true.
        uhf = .false.
      end if
      if (uhf) then
        if (index(keywrd," POLAR") /= 0) then
            write(iw,'(//10x,a)')" Keyword POLAR used with an odd-electron system."
            write(iw,'(10x,a)')" By default, UHF is used for odd-electron systems."
            write(iw,'(10x,a)')" POLAR does not work with UHF."
            write(iw,'(10x,a)')" To correct this fault, add RHF to the keyword line, and re-run."
            call mopend("POLAR used with a UHF system.  Add keyword RHF and re-run")
            return
          end if
          if (index(keywrd," ESP") /= 0) then
            write(iw,'(//10x,a)')" Keyword ESP used with a UHF calculation."
            write(iw,'(10x,a)')" By default, UHF is used for odd-electron systems."
            write(iw,'(10x,a)')" ESP does not work with UHF."
            write(iw,'(10x,a)')" To correct this fault, add RHF to the keyword line, and re-run."
            call mopend("ESP used with a UHF system.  Add keyword RHF and re-run")
            return
          end if
      end if
      odd = (mod(nelecs,2) /= 0)
!
! Explicit (named) declaration of spin state
!
      msdel = 100000 ! Set to a very high value, so if it is explicitly set, that will be obvious
      if (sing) then
        if (odd) then
         call mopend (&
             'SINGLET SPECIFIED WITH ODD NUMBER OF ELECTRONS, CORRECT FAULT')
          return
        else
          if (mode /= 1) write (iw, '(2/'' SINGLET STATE CALCULATION'')')
          msdel = 0
        end if
      else if (doub) then
        if (.not. odd) then
         call mopend (&
             'DOUBLET SPECIFIED WITH EVEN NUMBER OF ELECTRONS, CORRECT FAULT')
          return
        else
          if (mode /= 1) write (iw, '(2/'' DOUBLET STATE CALCULATION'')')
          msdel = 1
        end if
      else if (trip) then
        if (odd) then
         call mopend (&
             'TRIPLET SPECIFIED WITH ODD NUMBER OF ELECTRONS, CORRECT FAULT')
          return
        else
          if (mode /= 1) write (iw, '(2/'' TRIPLET STATE CALCULATION'')')
          msdel = 2
        end if
      else if (quar) then
        if (.not. odd) then
          call mopend (&
             'QUARTET SPECIFIED WITH EVEN NUMBER OF ELECTRONS, CORRECT FAULT')
          return
        else
          if (mode /= 1) write (iw, '(2/'' QUARTET STATE CALCULATION'')')
          msdel = 3
        end if
      else if (quin) then
        if (odd) then
          call mopend (&
             'QUINTET SPECIFIED WITH ODD NUMBER OF ELECTRONS, CORRECT FAULT')
          return
        else
          if (mode /= 1) write (iw, '(2/'' QUINTET STATE CALCULATION'')')
          msdel = 4
        end if
      else if (sext) then
        if (.not. odd) then
          call mopend (&
             'SEXTET SPECIFIED WITH EVEN NUMBER OF ELECTRONS, CORRECT FAULT')
          return
        else
          if (mode /= 1) write (iw, '(2/'' SEXTET STATE CALCULATION'')')
          msdel = 5
        end if
      else if (sept) then
        if (odd) then
          call mopend (&
             'SEPTET SPECIFIED WITH ODD NUMBER OF ELECTRONS, CORRECT FAULT')
          return
        else
          if (mode /= 1) write (iw, '(2/'' SEPTET STATE CALCULATION'')')
          msdel = 6
        end if
      else if (octe) then
        if (.not. odd) then
          call mopend (&
             'OCTET SPECIFIED WITH EVEN NUMBER OF ELECTRONS, CORRECT FAULT')
          return
        else
          if (mode /= 1) write (iw, '(2/'' OCTET STATE CALCULATION'')')
          msdel = 7
        end if
      else if (NONE) then
        if (odd) then
          call mopend (&
             'NONET SPECIFIED WITH ODD NUMBER OF ELECTRONS, CORRECT FAULT')
          return
        else
          if (mode /= 1) write (iw, '(2/'' NONET STATE CALCULATION'')')
          msdel = 8
        end if
      end if
!
!  Generic declaration of spin state
!
      i = Index (keywrd, " MS")
      if (i /= 0) then
        if (msdel < 100000) then
          write(iw,'(a)')" MS cannot be used with other keywords that define spin"
          write(iw,'(a)')" Specify either MS or other keyword, but not both."
          call mopend("MS cannot be used with other keywords that define spin")
          call to_screen(" MS cannot be used with other keywords that define spin")
          call to_screen(" Specify either MS or other keyword, but not both.")
          return
        end if
        i = Nint (2*reada (keywrd, Index (keywrd, " MS")))
        if((odd .eqv. mod(i,2) == 0)) then
          write(iw,"(/10x,a,i5)")"Number of electrons in system =", nelecs
          write(iw,"(10x,a,f5.1)")"Value of MS supplied          =  ", i*0.5d0
          if (odd) then
            write(iw,'(10x, a)')"Number of electrons is odd, but MS is integer "//&
              "implying number of electrons is even."
          else
            write(iw,'(10x, a)')"Number of electrons is even, but MS is not integer "//&
              "implying number of electrons is odd."
          end if
          write(iw,"(10x,a)")"Correct the error and re-submit"
          call mopend ("Value of MS not consistent with number of electrons")
          return
        end if
        i = index(keywrd,' MS')
        if (i /= 0) then
          msdel = nint(2.d0*reada(keywrd,index(keywrd,' MS')))
          if (Mod(nelecs+msdel,2) == 1) then
            write (iw, '(//10 x, "Impossible value of MS ")')
            call mopend ("Impossible value of MS")
            return
          end if
        end if
      end if
      if (msdel > 99999) msdel = 0 ! Set default value of msdel

!
! At this point, msdel is known. Now work out UHF and RHF quantities
!
      if (uhf) then
        nbeta = (nelecs - msdel)/2
        nalpha = nelecs - nbeta
        nopen = 0
        nclose = 0
        fract = 0.d0
        nalpha_open = nalpha
        nbeta_open = nbeta
        if (mode /= 1 .and. .not. mozyme) write (iw, &
    '(2/10X,''UHF CALCULATION, NO. OF ALPHA ELECTRONS ='',I5,/27X, &
    & ''NO. OF BETA  ELECTRONS ='',I5)') nalpha, nbeta
        i = index(keywrd,'OPEN(')
        if (i /= 0) then
          j = index(keywrd(i:i+10),',') + i - 1
          nmos = nint(reada(keywrd,j))
          ielec = nint(reada(keywrd,index(keywrd,'OPEN(') + 5))
          fract = (ielec*1.d0)/nmos
          if (nclose < 0) then
            call mopend ('IMPOSSIBLE NUMBER OF FILLED SHELLS')
            return
          end if
        else
          ielec = 0
          nmos = 0
        end if
          nalpha = nalpha - ielec
          if (nalpha < 0) then
            call mopend ('NUMBER OF ALPHA ELECTRONS IS LESS THAN ZERO')
            return
          end if
         nalpha_open = nalpha + nmos
         nbeta_open = nbeta
      else  !  The RHF option
!
!   NOW TO DETERMINE OPEN AND CLOSED SHELLS
!
        ielec = 0
        nmos = 0
        fract = 0
        if (exci .or. birad) then
          if (mode /= 1) then
            if (birad) write (iw, '(2/'' SYSTEM IS A BIRADICAL'')')
            if (exci) write (iw, '(2/'' EXCITED STATE CALCULATION'')')
          end if
          if (odd) then
            write (iw, &
      '(2/10X,''SYSTEM SPECIFIED WITH ODD NUMBER OF ELECTRONS, CORRECT FAULT '')')
            call mopend (&
               'SYSTEM SPECIFIED WITH ODD NUMBER OF ELECTRONS, CORRECT FAULT')
            return
          end if
          ielec = 2
          nmos = 2
        else if ((nelecs/2)*2 /= nelecs) then
          ielec = 1
          nmos = 1
        end if

        i = index(keywrd,'OPEN(')
        if (i /= 0) then
          j = index(keywrd(i:i+10),',') + i - 1
          nmos = nint(reada(keywrd,j))
          ielec = nint(reada(keywrd,index(keywrd,'OPEN(') + 5))
        end if
        nclose = nelecs/2
        nopen = nelecs - nclose*2
        if (ielec /= 0 .and. norbs > 0) then
          if (((nelecs/2)*2 == nelecs .neqv. (ielec/2)*2 == ielec)) then
            write (iw, '(/10x, A,I5)') ' NUMBER OF ELECTRONS IN SYSTEM:    ', nelecs
            write (iw, '(10x, A,I5)') ' NUMBER OF ELECTRONS IN OPEN SHELL:', ielec
            call mopend ('IMPOSSIBLE NUMBER OF OPEN SHELL ELECTRONS')
            return
          end if
          nclose = nclose - ielec/2
          nopen = nmos
          if (nclose + nopen > norbs) then
            write (iw, '(/10x, A,I5)') 'TOTAL NUMBER OF ELECTRONS:                      ', nelecs
            write (iw, '(10x, A,I5)') 'NUMBER OF ELECTRONS IN PARTIALLY-FILLED LEVELS: ', ielec
            write (iw, '(10x, A,I5)') 'NUMBER OF DOUBLY FILLED LEVELS:                 ', nclose
            write (iw, '(10x, A,I5)') 'NUMBER OF PARTLY FILLED LEVELS:                 ', nopen
            write (iw, '(10x, A,I3)') 'NUMBER OF DOUBLY FILLED PLUS PARTLY FILLED LEVELS:', &
              nclose + nopen
            write (iw, '(10x, A,I5)') 'TOTAL NUMBER OF ORBITALS:                       ', nopen
            call mopend (&
       'NUMBER OF DOUBLY FILLED PLUS PARTLY FILLED LEVELS IS GREATER THAN THE TOTAL NUMBER OF ORBITALS')
            return
          end if
          if (nmos == 0) then
            write (iw, *) ' NUMBER OF M.O.s IN OPEN(M,N) IS ZERO!'
            call mopend (' NUMBER OF ELECTRONS IN OPEN(M,N) IS ZERO!')
            return
          end if
          fract = ielec*1.D0/nmos
          if (nclose < 0) then
            write (iw, '(A)') ' IMPOSSIBLE NUMBER OF CLOSED SHELLS'
            call mopend ('IMPOSSIBLE NUMBER OF CLOSED SHELLS')
            return
          end if
          if (mode /= 1) write (iw, '(/6X,''THERE ARE'',I5,'' DOUBLY FILLED LEVELS'')') nclose
        end if
        if (mode /= 1 .and. .not. mozyme) then
          num1 = char(Int(log10(nclose + 0.5)) + ichar("2"))
          write (iw, '(2/6X,''RHF CALCULATION, NO. OF DOUBLY OCCUPIED LEVELS ='',I'//num1//',/)') nclose
          if (nopen/=0 .and. abs(fract-1.D0)<1.D-4) &
            write (iw, '(/23X,''NO. OF SINGLY OCCUPIED LEVELS ='',I5)') nopen
          if (nopen/=0 .and. abs(fract-1.D0)>1.D-4) &
            write (iw, '(/23X,''NO. OF LEVELS WITH OCCUPANCY'',F6.3,''  ='',I3)') fract, nopen
        end if
        i = index(keywrd,'C.I.=(')
        if (i /= 0) then
          j = index(keywrd(i:i+10),',') + i - 1
          ndoubl = nint(reada(keywrd,j))
          if (ndoubl > nclose) then
            write (iw, '(7x,A,I3)') 'NUMBER OF DOUBLY FILLED LEVELS IN C.I. RESET TO', nclose
            ndoubl = nclose
          end if
          i = nint(reada(keywrd,index(keywrd,'C.I.=(') + 5))
          i = i - ndoubl
          if (nopen > i) then
            call mopend ('NUMBER OF OPEN-SHELLS ALLOWED IN C.I. IS LESS THAN THAT SPECIFIED BY OTHER KEYWORDS')
            return
          end if
          if (i + nclose > norbs) then
            write(iw,'(10x,a,i2)')"Number of doubly-occupied levels requested in C.I.:", ndoubl
            write(iw,'(10x,a,i13)')"Total number of M.O.s requested in C.I.:", i + ndoubl
            write(iw,'(10x,a,i2)')"Calculated number of empty M.O.s requested in C.I.:", i
            write(iw,'(10x,a,i13)')"Index of highest M.O. requested in C.I.:", nclose + i
            write(iw,'(10x,a,i13)')"Number of M.O.s in system:              ", norbs
            call mopend ('NUMBER OF M.O.s REQUESTED IN C.I. IS GREATER THAN THE NUMBER OF ORBITALS')
            return
          end if
        end if
        nopen = nopen + nclose
      end if
      if (index(keywrd, " CIS") /= 0) then
        msdel = 0
        else
!
!  WORK OUT IF DEFINED SPIN-STATE ALLOWED
!

      end if
      if (msdel/=0 .and. .not. uhf) then
!
!   MSDEL = NUMBER OF ALPHA ELECTRONS - NUMBER OF BETA ELECTRONS
!
        ndoubl = 99
        i = index(keywrd,'C.I.=(')
        if (i /= 0) then
          j = index(keywrd(i:i+10),',') + i - 1
          ndoubl = nint(reada(keywrd,j))
          nmos = nint(reada(keywrd,index(keywrd,'C.I.=(') + 5))
        else if (index(keywrd,'C.I.=') /= 0) then
          nmos = nint(reada(keywrd,index(keywrd,'C.I.=') + 5))
        else
          nmos = nopen - nclose
          nmos = min0(norbs,nmos)
        end if
        if (ndoubl == 99) then
          j = max(min((nclose + nopen + 1)/2 - (nmos - 1)/2, norbs - nmos + 1),1)
        else
          j = nclose - ndoubl + 1
        end if
        ne = int(max(0.D0,nclose - j + 1.D0)*2.D0 + &
          max(0.D0,(nopen - nclose)*fract) + 0.5D0)
        nupp = (ne + msdel)/2
        ndown = ne - nupp
        if (nmos == 0) then
          nupp = 0
          ndown = 0
        end if
        if (.not. method_indo) then
!
!  NUPP  = NUMBER OF ALPHA ELECTRONS IN ACTIVE SPACE
!  NDOWN = NUMBER OF BETA  ELECTRONS IN ACTIVE SPACE
!
          if (nupp*ndown < 0 .or. nupp > nmos .or. ndown > nmos .or. nmos == 0) then
            write (iw, '(A)')' SPECIFIED SPIN COMPONENT NOT SPANNED BY ACTIVE SPACE'
            write (iw, '(a,i3)')' Number of alpha electrons in active space:', nupp
            write (iw, '(a,i3)')'  Number of beta electrons in active space:', ndown
            write (iw, '(a,i3)')'                      Size of active space:', nmos
            if (Index (keywrd, " MS") /= 0) then
              call web_message(iw,"ms.html")
            else
              call web_message(iw,"active_space.html")
            end if
            call mopend ('SPECIFIED SPIN COMPONENT NOT SPANNED BY ACTIVE SPACE')
            return
          end if
        end if
      end if
      halfe = (nopen > nclose .and. Abs(fract -2.D0) > 1.d-20 .and. Abs(fract) > 1.d-20 &
      & .or. index(keywrd,'C.I.')/=0)
      if (halfe) halfe = (.not. (index(keywrd,'EXCI') /= 0 .or. &
                                 index(keywrd,'ROOT') /= 0 .and. index(keywrd,'ROOT=1') == 0))
      if (halfe .and. id /= 0 .and. index(keywrd,' NOANCI') == 0) then
        write (iw, *)
        write (iw, *) ' ''NOANCI'' MUST BE USED FOR RHF OPEN-SHELL SYSTEMS'
        write (iw, *) ' THAT INVOLVE TRANSLATION VECTORS'
        call mopend (&
       '"NOANCI" MUST BE USED FOR RHF OPEN-SHELL SYSTEMS THAT INVOLVE TRANSLATION VECTORS')
        return
      end if
      yy = dble(kharge)/(norbs + 1.D-10)
      pdiag(:norbs) = 0.D0
      do i = 1, numat
        ni = nat(i)
        if (nlast(i) - nfirst(i) == (-1)) cycle
        l = nfirst(i) - 1
        if (nlast(i) - nfirst(i) == 0) then
!
!    Hydrogen
!
          l = l + 1
          pdiag(l) = tore(ni) - yy
        else if (nlast(i) - nfirst(i) == 3) then
!
!    Normal heavy atom
!
          w = tore(ni)*0.25D0 - yy
          pdiag(l+1:4+l) = w
        else
!
!   This atom has a 'd' shell
!
          if (ni<21 .or. ni>30 .and. ni<39 .or. ni>48 .and. ni<57) then
!
!   Main Group Element:  The "d" shell is formally empty.
!
            w = tore(ni)*0.25D0 - yy
            pdiag(l+1:4+l) = w
            l = 4 + l
            pdiag(l+1:5+l) = -yy
          else if (ni < 99) then
!
!   Transition metal
!
            sum = tore(ni) - 9*yy
!   First, put 2 electrons in the 's' shell
            l = l + 1
            pdiag(l) = max(0.D0,min(sum,2.D0))
            sum = sum - 2.D0
            if (sum > 0.D0) then
!
!   Now put as many electrons as possible into the 'd' shell
!
              l = l + 3
              do j = 1, 5
                l = l + 1
                pdiag(l) = max(0.D0,min(sum*0.2D0,2.D0))
              end do
              sum = sum - 10.D0
              if (sum > 0) then
!
!   Put the remaining electrons in the 'p' shell
!
                l = l - 8
                pdiag(l+1:3+l) = sum/3.D0
              end if
            end if
          end if
        end if
      end do
      call setup_nhco(ii)
!
!  Does the system contain a N bonded to three atoms, at least
!  two of which are not hydrogen atoms?
!
      do i = 1, numat
        if (nat(i) == 7 .and. nbonds(i) == 3) then
        j = 0
        if (nat(ibonds(1,i)) == 1) j = 1
        if (nat(ibonds(2,i)) == 1) j = j + 1
        if (nat(ibonds(3,i)) == 1) j = j + 1
        if ( j < 2)  N_3_present = .true.
        end if
        if (N_3_present) exit
      end do
!
!  Does the system contain a Si-O-H group?
!
      do i = 1, numat
        if (nat(i) == 14) then
          do j = 1, nbonds(i)
            if (nat(ibonds(j,i)) == 8) then
              l = ibonds(j,i)
              do k = 1, nbonds(l)
                if (nat(ibonds(k,l)) == 1) Si_O_H_present = .true.
              end do
            end if
          end do
        end if
        if (Si_O_H_present) exit
      end do
  !    Si_O_H_present = .false.
      if (nvar == 0) then
        if (index(keywrd," GRAD") /= 0) then
          if (index(keywrd, " RESEQ") + index(keywrd, " ADD-H") + index(keywrd, " SITE") == 0) then
            line = " Keyword GRADIENTS used, but geometry has no variables."
            call mopend(trim(line))
            return
          end if
        end if
      end if
      if (mod(nelecs, 2) == 1 .and. .not. uhf .and. nnhco > 0 .and. mode /= 1 &
      .and. (index(keywrd," 1SCF") == 0 .or. index(keywrd," GRAD") /= 0) .and. &
      nvar > 10 .and. index(keywrd," GEO-OK") == 0 .and. abs(kharge) < 400) then
      write(iw,"(/)")
       write(iw,"(10x,a)") &
       " This system has an odd number of electrons and also", &
       " contains peptide linkages.  The CPU time required for", &
       " calculating the gradients is likely to be large. If ""UHF"" is ", &
       " added, then the gradient calculation will run much faster. ", &
       " Either add ""GEO-OK"" or ""UHF"" to the keyword list.", &
       " Also, check that the system should be a radical. A quick " , &
       " way to do this is to add keyword ""LEWIS"" and run it again.", &
       " This will print out the Lewis structure."
       call mopend("radical run with RHF.  Either add 'GEO-OK' or 'UHF'.")
       return
      end if
      if (nnhco > 3 .and. &
        index(keywrd," GEO-OK") == 0 .and. &
        index(keywrd," RESEQ") == 0 .and. &
        index(keywrd," CHARGES") == 0 .and. &
        index(keywrd," 1SCF") == 0) then
        j = 1
        do i = 1, natoms
          if (na(i) > 0) j = j + 1
        end do
        if (nvar > 0 .and. j == natoms .and. .not. is_PARAM) then
          if (index(keywrd," ADD-H") + index(keywrd," SITE=") == 0) then
            write(iw,"(5x,a)")"The system contains peptide linkages, but all atoms are in internal coordinates.", &
            "This is likely to result in problems in geometry optimization.", &
            "To correct this, add ""XYZ"" to the keyword line.", &
            "(If internal coordinates should be used, add ""GEO-OK"" to the keyword line.)"
            call mopend("Peptides should be run using Cartesian coordinates")
            return
          end if
        end if
      end if
      if (mode /= 1 .and. ii > 1) then
        write (iw, '(A,I4,2A)') ' THERE ARE', ii/2, ' PEPTIDE LINKAGES IDENTIFIED IN THIS SYSTEM'
        write (iw, '(A)') ' Keyword "NOMM" has been used, therefore a Molecular Mechanics correction will not be used'
      else if (mode /= 1 .and. nnhco /= 0 .and. (method_RM1 .or. method_pm6 .or. method_PM7) &
      & .and. (index(keywrd, "MMOK") == 0)) then
        if (index(keywrd, " LEWIS") + index(keywrd, " RESEQ") + index(keywrd, " CHARGES")== 0) then
          if (method_RM1) line = "RM1"
          if (method_PM6) line = "PM6"
          if (method_PM7) line = "PM7"
      !      write (iw, '(A)') ' When peptide bonds are present, and '//line(:3)//&
      !      &' is used, then keyword "MMOK" or "NOMM" must be used'
      !      call mopend("Keyword MMOK or NOMM must be used with "//line(:3)//" for this system")
      !      return
          end if
      end if
      if (mode /= 1 .and. index(keywrd,'PRTINT') /= 0) then
        write (iw, '(2/10X,''  INTERATOMIC DISTANCES'')')
        call vecprt (rxyz, numat)
      end if
      if (rmin < 0.9D0 .and. index(keywrd,'CHECK') /= 0 .or. &
          rmin < 0.2D0 .and. index(keywrd,'GEO-OK') == 0 .or. &
          rmin < 1.d-4) then
        icount = 0
        ireal = iminr
        jreal = jminr
        do i = 1, natoms
          if (labels(i)==99 .or. labels(i)==107) cycle
          icount = icount + 1
          if (icount == iminr) ireal = i
          if (icount /= jminr) cycle
          jreal = i
        end do
        write(line,"('ATOMS',i6,' AND',i6,' ARE SEPARATED BY',f7.4,' ANGSTROMS.')")ireal, jreal, rmin
        if (index(keywrd,'CHECK') /= 0) then
          call mopend(trim(line))
          write(iw,'(/10x,a)')'FAULT DETECTED BY KEYWORD "CHECK'
          if (log) write (ilog, '(//10x,a,//10x,a)')trim(line), 'FAULT DETECTED BY KEYWORD "CHECK'
        else
          call mopend(trim(line))
          write(iw,'(/10x,a)')'TO CONTINUE CALCULATION SPECIFY "GEO-OK"'
          num1 = char(Int(log10(max(ireal,jreal)     + 1.0)) + ichar("1"))
          if (pdb_label) then
            write(iw,"(/10x,a,i"//num1//",a)")"(Label for atom ", ireal, ": """//txtatm(ireal)//""")"
            write(iw,"( 10x,a,i"//num1//",a)")"(Label for atom ", jreal, ": """//txtatm(jreal)//""")"
          end if
          if (log) write (ilog, '(//10x,a,//10x,a)')trim(line), 'TO CONTINUE CALCULATION SPECIFY "GEO-OK"'
        end if
        write (iw, '(/,a)')'   NOTE THAT THE ATOM NUMBERS CORRESPOND TO THE'//&
          ' ''CARTESIAN COORDINATES'' ATOM LIST.'
        if (index(keywrd,' ADD-H') /= 0) then
          write(line,'(a,i6,a,i6)')'SEVERE ERROR IN GEOMETRY, FIX FAULT BEFORE CONTINUING. Atoms:',ireal, ' and', jreal
          call mopend (trim(line))
          numat = 0
          natoms = 0
          return
        end if
        if (rmin < 1.d-4) then
          write(line,'(a,i6,a,i6)')'GEOMETRY IN ERROR, FIX FAULT BEFORE CONTINUING. Atoms:',ireal, ' and', jreal
          call mopend (trim(line))
        else
          call mopend ("GEOMETRY IN ERROR.  TO CONTINUE CALCULATION SPECIFY 'GEO-OK'.")
        end if
        return
      end if
      if (.not.debug) return
      write (iw, 290) numat, norbs, ndorbs, natoms
  290 format('   NUMBER OF REAL ATOMS:',i4,/,'   NUMBER OF ORBITALS:  ',i4,/,&
        '   NUMBER OF D ORBITALS:',i4,/,'   TOTAL NO. OF ATOMS:  ',i4)
      write (iw, 300) (uspd(i),i=1,norbs)
  300 format('   ONE-ELECTRON DIAGONAL TERMS',/,10(/,10f8.3))
      write (iw, 310) (pdiag(i),i=1,norbs)
  310 format('   INITIAL P FOR ALL ATOMIC ORBITALS',/,10(/,10f8.3))
      return
end subroutine moldat

subroutine setcup
   !***********************************************************************
   !
   !   SETCUP determines CUTOFP and the number of unit cells in each
   !          direction that will be needed in order to allow CUTOFP
   !   to be correctly used.
   !
   !***********************************************************************
    use molkst_C, only: cutofp, id, keywrd, l1u, l2u, l3u, l123, l11, l21, l31, line, &
      clower
    use common_arrays_C, only : tvec
    use chanel_C, only: iw
    implicit none
    integer :: i
    double precision :: area12, area13, area23, r1, r12, r13, r2, &
         & r23, r3, tv1, tv2, tv3, vol, sum
    double precision, external :: reada, volume
    cutofp = 1.d10
    l1u = 0
    l2u = 0
    l3u = 0
    l123 = 1
    if (id == 0) return
    i = Index (keywrd, " CUTOFP")
    if (i /= 0) then
      cutofp = reada (keywrd, i+7)
    else
      cutofp = 30.d0
    end if
!
!   Set constants for truncation function.
!
!   CLOWER = lower bound of truncation function, as a function of CUTOFP
!
! Setting "clower" to 17 Angstroms seems to be okay for the gradients and for smoothness of the PES.
! It had been 14 Angstroms, but that caused significant problems with the gradients.
!
!  If in doubt, test the gradients using DERITR
!
    clower = Min( cutofp*2.d0/3.d0, 17.0d0)
   !
   !   CALCULATE L1U, L2U, and L3U
   !
    if (id == 1) then  !   Polymer case
      !
      !   TV1 =  length of polymer.
      !
      tv1 = Sqrt (tvec(1, 1)**2+tvec(2, 1)**2+tvec(3, 1)**2)
      if (tv1 < 1.d0) then
        line = "  Length of translation vector is too small."
        write(iw,'(a)')trim(line)
        call mopend (trim(line))
        return
      end if
      l1u = Int (cutofp*4.d0/3.d0/tv1) + 1
    else if (id == 2) then !  Layer system
      !
      !   TV1, TV2 = Distances across unit cell.
      !
      r1 = Sqrt (tvec(1, 1)**2 + tvec(2, 1)**2 + tvec(3, 1)**2)
      r2 = Sqrt (tvec(1, 2)**2 + tvec(2, 2)**2 + tvec(3, 2)**2)
      if (r1 < 1.d0) then
        call mopend ("Length of first translation vector is too small.")
        return
      end if
      if (r1 < 1.d0) then
        call mopend ("Length of second translation vector is too small.")
        return
      end if
      r12 = Sqrt ((tvec(1, 2)-tvec(1, 1))**2 + (tvec(2, 2)-tvec(2, 1))**2 &
           & + (tvec(3, 2)-tvec(3, 1))**2)
      sum = (r1**2 + r2**2 - r12**2)/(2*r1*r2)
      if (sum > 0.9d0) then
        call mopend ("The angle between the two translation vectors is too small")
        return
      end if
      tv1 = r1 * Sin (Acos((r1**2 + r2**2 - r12**2)/(2*r1*r2)))
      tv2 = r2 * Sin (Acos((r1**2 + r2**2 - r12**2)/(2*r1*r2)))
      l1u = Int (cutofp*4.d0/3.d0/tv1) + 1
      l2u = Int (cutofp*4.d0/3.d0/tv2) + 1
    else !  Solid-state (three-dimensional crystal)
      !
      !   TV1,TV2,TV3 = Distances between faces of unit cell
      !
      r1 = Sqrt (tvec(1, 1)**2 + tvec(2, 1)**2 + tvec(3, 1)**2)
      r2 = Sqrt (tvec(1, 2)**2 + tvec(2, 2)**2 + tvec(3, 2)**2)
      r3 = Sqrt (tvec(1, 3)**2 + tvec(2, 3)**2 + tvec(3, 3)**2)
      if (r1 < 1.d0 .or. r2 < 1.d0 .or. r3 < 1.d0) then
        if (r1 < 1.d0) then
          line = "  Length of first translation vector is too small."
          write(iw,'(a)')trim(line)
          call mopend (trim(line))
          return
        else if (r2 < 1.d0) then
          line = "  Length of second translation vector is too small."
          write(iw,'(a)')trim(line)
          call mopend (trim(line))
          return
        else
          line = "  Length of third translation vector is too small."
          write(iw,'(a)')trim(line)
          call mopend (trim(line))
          return
        end if
      end if
      r12 = Sqrt ((tvec(1, 2)-tvec(1, 1))**2 + (tvec(2, 2)-tvec(2, 1))**2 &
           & + (tvec(3, 2)-tvec(3, 1))**2)
      r13 = Sqrt ((tvec(1, 3)-tvec(1, 1))**2 + (tvec(2, 3)-tvec(2, 1))**2 &
           & + (tvec(3, 3)-tvec(3, 1))**2)
      r23 = Sqrt ((tvec(1, 3)-tvec(1, 2))**2 + (tvec(2, 3)-tvec(2, 2))**2 &
           & + (tvec(3, 3)-tvec(3, 2))**2)
      area12 = r1 * r2 * Sin (Acos((r1**2 + r2**2 - r12**2)/(2*r1*r2)))
      area13 = r1 * r3 * Sin (Acos((r1**2 + r3**2 - r13**2)/(2*r1*r3)))
      area23 = r2 * r3 * Sin (Acos((r2**2 + r3**2 - r23**2)/(2*r2*r3)))
      vol = volume (tvec, id)
      if (vol < 1.d0) then
        write (iw,'(//10X,A,F9.6,A)') &
             & "Volume of unit cell unreasonably small:", vol, &
             & " Cubic Angstroms"
        call mopend("Volume of unit cell unreasonably small")
        return
      end if
      tv1 = vol / area23
      tv2 = vol / area13
      tv3 = vol / area12
      sum = 4.0d0
      if ((tv1 < sum .or. tv2 < sum .or. tv3 < sum) .and. Index (keywrd, " GEO-OK") == 0) then
        write(iw,"(//10x,a,f9.3,a   )") "Translation vector length 1:", r1," Angstroms"
        write(iw,"(  10x,a,f9.3,a   )") "Translation vector length 2:", r2," Angstroms"
        write(iw,"(  10x,a,f9.3,a,/ )") "Translation vector length 3:", r3," Angstroms"
        if (tv1 < sum) write (iw,'(10X,A,F6.3,A,f6.3)') &
             & "Distance between faces 2 and 3 is unreasonably small:", tv1," Angstroms, min:", sum
        if (tv2 < sum) write (iw,'(10X,A,F6.3,A,f6.3)') &
             & "Distance between faces 1 and 3 is unreasonably small:", tv2," Angstroms, min:", sum
        if (tv3 < sum) write (iw,'(10X,A,F6.3,A,f6.3)') &
             & "Distance between faces 1 and 2 is unreasonably small:", tv3," Angstroms, min:", sum
        if (tv1 < sum .or. tv2 < sum .or. tv3 < sum) then
          call mopend("One or more translation vectors are unreasonably small")
        write(iw,'(10x,a)')"To over-ride this safety check, add keyword 'GEO-OK'"
        return
        end if
      end if
      l1u = Int ((cutofp*4.d0/3.d0)/tv1) + 1
      l2u = Int ((cutofp*4.d0/3.d0)/tv2) + 1
      l3u = Int ((cutofp*4.d0/3.d0)/tv3) + 1
    end if
    l123 = (2*l1u + 1)*(2*l2u + 1)*(2*l3u + 1)
    l11 = min(l1u,1)
    l21 = min(l2u,1)
    l31 = min(l3u,1)
end subroutine setcup
subroutine write_cell(iprt)
  use molkst_C, only: mol_weight, escf, numat, keywrd, gnorm, &
   line, mers, density, gui
  use funcon_C, only: fpc_10
  use common_arrays_C, only: nat, tvec
  use ef_C, only : nstep
  implicit none
  integer, intent(in) :: iprt
  integer :: i, j, k, l, z, m, old_nstep = -1
  double precision :: ta, tb, tc, tab, tbc, tac, talpha, tbeta, tgamma, vol
  integer, dimension (100) :: nel
  double precision, external :: reada, volume
  save :: old_nstep
  if (iprt < 0 .or. gui) return
  if (iprt == 0) then
    if(old_nstep == nstep) return
    old_nstep = nstep
  end if

!
!  Write out unit cell lengths and angles
!
  ta = Sqrt(tvec(1,1)**2 + tvec(2,1)**2 + tvec(3,1)**2)
  tb = Sqrt(tvec(1,2)**2 + tvec(2,2)**2 + tvec(3,2)**2)
  tc = Sqrt(tvec(1,3)**2 + tvec(2,3)**2 + tvec(3,3)**2)
  tab = Sqrt((tvec(1,1)-tvec(1,2))**2 + (tvec(2,1)-tvec(2,2))**2 + (tvec(3,1)-tvec(3,2))**2)
  tac = Sqrt((tvec(1,1)-tvec(1,3))**2 + (tvec(2,1)-tvec(2,3))**2 + (tvec(3,1)-tvec(3,3))**2)
  tbc = Sqrt((tvec(1,3)-tvec(1,2))**2 + (tvec(2,3)-tvec(2,2))**2 + (tvec(3,3)-tvec(3,2))**2)
  talpha = 57.295779513d0*Acos((tb**2 + tc**2 - tbc**2)/(2*tc*tb))
  tbeta  = 57.295779513d0*Acos((ta**2 + tc**2 - tac**2)/(2*ta*tc))
  tgamma = 57.295779513d0*Acos((ta**2 + tb**2 - tab**2)/(2*ta*tb))
  tab = 1.d0
  if (index(keywrd," BCC") /= 0) tab = 2.d0
!
!  Work out the empirical formula
!
  i = Index(keywrd, " Z=")
  if (i /= 0) then
    i = Nint(reada(keywrd,i))
    z = mers(1)*mers(2)*mers(3)*i
    if (Index (keywrd, " BCC") /= 0) z = z/2
  else
    nel = 0
    do i = 1, numat
      nel(nat(i)) = nel(nat(i)) + 1
    end do
    j = 0
    do i = 1, 100
      if (nel(i) > 0) then
        j = j + 1
        nel(j) = nel(i)
       end if
    end do
    k = 10000
    do i = 1, j
      if(nel(i) < k) k = nel(i)
    end do
!
!  k is the smallest number of atoms of any element in the formula
!
    do i = 1, 20
      m = 0
      do l = 1, j
        if (Abs((i*nel(l))/k - (i*1.d0*nel(l))/k) > 1.d-5) m = 1
      end do
      if (m == 0) exit
    end do
!
!  Number of empirical units  = k/i
!
    z = k/i
  end if
  vol = volume (tvec, 3)
  if (mers(1) > 0 .and. mers(2) > 0 .and. mers(3) > 0 .and. index(keywrd, " PRT ") == 0) then
    if (gnorm > 1.d-20) then
      write (line,'(i4,a,3f7.3,3f7.2,a,f8.2,a,f6.3,a,f10.3, a, f7.2)')nstep + 1," a, b, c, alpha, beta, gamma:", &
      & tab*ta/mers(1), tab*tb/mers(2), tab*tc/mers(3), talpha, tbeta, tgamma, &
      " Vol:",vol/(mers(1)*mers(2)*mers(3))," Density:",mol_weight * 1.d24 / fpc_10 / vol, &
      " HoF:",escf/z," Grad:",gnorm/sqrt(z*1.d0)
      write(iprt,"(a)")line(:len_trim(line))
    end if
  end if
  if (index(keywrd, " PRT ") /= 0) then
    write (iprt, '(/10X,A,F15.3,A)') 'VOLUME OF UNIT CELL     =', &
        vol/(max(1,mers(1))*max(1,mers(2))*max(1,mers(3))), ' CUBIC ANGSTROMS'
    write (iprt, '(/10X,A,F15.3,A)') 'DENSITY                 =', density, ' GRAMS/CC'

    write (iprt,'(28x, a, 8x, f7.3, a)')"  A   =", tab*ta/max(1,mers(1)), " ANGSTROMS"
    write (iprt,'(28x, a, 8x, f7.3, a)')"  B   =", tab*tb/max(1,mers(2)), " ANGSTROMS"
    write (iprt,'(28x, a, 8x, f7.3, a)')"  C   =", tab*tc/max(1,mers(3)), " ANGSTROMS"
    write (iprt,'(28x, a, 8x, f7.3, a)')"ALPHA =",talpha, " DEGREES"
    write (iprt,'(28x, a, 8x, f7.3, a)')"BETA  =",tbeta , " DEGREES"
    write (iprt,'(28x, a, 8x, f7.3, a)')"GAMMA =",tgamma, " DEGREES"
    call l_control("PRT", 3, -1)
  end if
  return
end subroutine write_cell
subroutine write_unit_cell_HOF(iprt)
  use molkst_C, only : keywrd, escf, numat, line, mers, formula
  use common_arrays_C, only : nat
  implicit none
  integer, intent(in) :: iprt
  integer :: i, j, k, l, z, nel(107), m
  character :: num*1
  logical :: one_letter
  double precision, external :: reada

    if (iprt < 0) return
!
!  Work out the empirical formula
!
        i = Index(keywrd, " Z=")
        if (i /= 0) then
          i = Nint(reada(keywrd,i))
          z = max(1, mers(1))*max(1, mers(2))*max(1, mers(3))*i
          if (Index (keywrd, " BCC") /= 0) z = z/2
        else
          nel = 0
          do i = 1, numat
            nel(nat(i)) = nel(nat(i)) + 1
          end do
          j = 0
          do i = 1, 100
            if (nel(i) > 0) then
              j = j + 1
              nel(j) = nel(i)
            end if
          end do
          k = 1000
          do i = 1, j
            if(nel(i) < k) k = nel(i)
          end do
!
!  k is the smallest number of atoms of any element in the formula
!
          do i = 1, 10
            m = 0
            do l = 1, j
              if (Abs((i*nel(l))/k - (i*1.d0*nel(l))/k) > 1.d-5) m = 1
            end do
            if (m == 0) exit
          end do
!
!  Number of empirical units  = k/i
!
         z = k/i
       end if
       num = char(ichar("2") + int(log10(z + 0.05)))
       write (line, "(10x,'H.o.F. per unit cell    =',f17.5,' KCAL, for',i"//num//",' unit cells')") &
         & escf/z, z
       i = index(formula, ":") + 1
       write(line(len_trim(line) + 1:), '(a)')", unit cell ="
       one_letter = .true.
       do
         if (formula(i:i) == "=") exit
         if (formula(i:i) == " ") then
           i = i + 1
           cycle
         end if
         if (formula(i:i) < "0" .or. formula(i:i) > "9") then
           j = j + 1
           if (one_letter) then
             line(len_trim(line) + 2:) = formula(i:i)
           else
             line(len_trim(line) + 1:) = formula(i:i)
           end if
           i = i + 1
           one_letter = .false.
         else
           l = index(formula(i:), " ") + i
           k = nint(reada(formula, i))/z
           num = char(ichar("1") + int(log10(k + 0.05)))
           write(line(len_trim(line) + 1:),'(i'//num//')') k
           i = l
           one_letter = .true.
         end if
       end do
       if (iprt == 0) then
         call to_screen(line)
       else
         write(iprt,"(a)")line(:len_trim(line))
       end if
       return
      end subroutine write_unit_cell_HOF
      subroutine write_pressure(iprt)
      use common_arrays_C, only: loc, tvec, na
      use molkst_C, only: nvar, pressure, line, press
      use funcon_C, only: fpc_10
      use common_arrays_C, only : grad, xparam, labels
      implicit none
      integer, intent(in) :: iprt
      integer :: m, i1,i2, k, l, i, ndim
      double precision :: xi
      double precision, dimension (nvar) :: dsum, dsum1
      double precision, external :: ddot, volume
      if (iprt < 0) return
        m = 0
        i1 = 0
        i2 = 0
        ndim = 0
        do i = 1, nvar
          k = loc(1, i)
          l = labels(k)
          xi = xparam(i)
          if (l == 107 .and. (m == 0 .or. k == i1)) then
!
!  Atom is a Tv
!
            i1 = k
            m = m + 1
            dsum(m) = grad(i)
            dsum1(m) = xparam(i)
            if (m == 3) then
              if (na(k) /= 0) then
                if (iprt == 0) then
                  call to_screen("The pressure required to constrain translation vectors")
                  call to_screen("can only be calculated if Cartesian coordinates are used.")
                else
                  if (Abs(pressure) > 0.01d0) then
                    write(iprt,'(/10x,a)')"The pressure required to constrain translation vectors"
                    write(iprt,'(10x,a)')"can only be calculated if Cartesian coordinates are used."
                  end if
                end if
                return
              end if
!
!  Determine the scalar of the component of the gradient vector in the
!  direction of the translation vector
!
              xi = ddot(3,dsum, 1,dsum1,1)
!
!  Convert this into a pressure = force per unit area
!
              xi = -(4184.d0*10.d0**30)/fpc_10 * xi/volume (tvec, 3)
              if (Abs(xi) < 1.d-20) cycle ! suppress printing if gradients are zero
              if (i2 == 0) then
                write(line,'(a)') "          Pressure required to constrain translation vectors"
                if (iprt == 0) then
                  call to_screen(trim(line))
                else
                  write(iprt,*)trim(line)
                end if
                i2 = 1
              end if
              xi = (xi - pressure * (4184.d0*10.d0**30)/ fpc_10)*1.d-9
              ndim = ndim + 1
              press(ndim) = xi
              write(line,'(10x,a,i4,a,f7.2,a)')"Tv(", k,")  Pressure:",xi," GPa"
               if (iprt == 0) then
                  call to_screen(trim(line))
                else
                  write(iprt,*)trim(line)
                end if
              m = 0
            end if
          end if
        end do
  end subroutine write_pressure
  subroutine setup_nhco(ii)
  USE molmec_C, only : nnhco, nhco, htype
  USE molkst_C, only : numat,  method_am1, method_pm3, method_mndo, method_pm6, method_PM7, method_rm1, &
   keywrd
  use common_arrays_C, only : nat
  implicit none
  integer, intent (out) :: ii
!
!  Local
!
  integer :: j, i, k, l, m, jj
  double precision, external :: distance

  nnhco = 0
  !
  !   SET UP MOLECULAR-MECHANICS CORRECTION TO -(C=O)-(NH)- LINKAGE
  !   THIS WILL BE USED IF NOMM HAS NOT BEEN SPECIFIED.
  !
                      htype = 0.d0
    if (method_mndo) htype = 6.1737D0
    if (method_am1)  htype = 3.3191D0
    if (method_pm3)  htype = 7.1853D0
    if (method_rm1)  htype = 2.4127D0
    if (method_pm7)  htype = 3.1595D0
    if (method_pm6)  htype = 2.5000D0
    ii = 0
    if (index(keywrd,'NOMM') /= 0) ii = 1
  !
  !   IDENTIFY O=C-N-H SYSTEMS VIA THE INTERATOMIC DISTANCES MATRIX
  !
  l230: do j = 1, numat
      if (nat(j) /= 6) cycle  l230
      do i = 1, numat
        if (nat(i) /= 8) cycle
        if (distance(i, j) > 1.3D0) cycle
        do k = 1, numat
          if (nat(k) /= 7) cycle
          if (distance(k, j) > 1.6D0) cycle
          do l = 1, numat
            if (nat(l) /= 1) cycle
            if (distance(k, l) > 1.3D0) cycle
  !
  !   WE HAVE A H-N-C=O SYSTEM.  THE ATOM NUMBERS ARE L-K-J-I
  !   NOW SEARCH OUT ATOM ATTACHED TO NITROGEN, THIS SPECIFIES
  !   THE SYSTEM X-N-C=O
  !
            l190: do m = 1, numat
              if (m==k .or. m==l .or. m==j) cycle  l190
              if (distance(m, k) > 1.7D0) cycle  l190
              do jj = 1, nnhco, 2
                if (nhco(3,jj) /= k) cycle
                cycle  l190
              end do
              nnhco = nnhco + 1
              nhco(1,nnhco) = i
              nhco(2,nnhco) = j
              nhco(3,nnhco) = k
              nhco(4,nnhco) = m
              nnhco = nnhco + 1
              nhco(1,nnhco) = i
              nhco(2,nnhco) = j
              nhco(3,nnhco) = k
              nhco(4,nnhco) = l
              if (ii /= 0) then
                ii = ii + 2
                nnhco = nnhco - 2
              end if
              cycle  l230
            end do l190
          end do
        end do
      end do
  end do l230
    end subroutine setup_nhco

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

module afmm_C
  !
  !
  !       Adaptive multipole algorithm
  !       Based on the paper
  !       H. Cheng, L. Greengard, and V. Rokhlin
  !       "A fast adaptive multipole algorithm in three dimensions",
  !       J. Comp. Phys., 155, 468-498 (1999)
  !
  !       But use spherical harmonic addition theorem for
  !       Multipole -> Local transformation, no rotations
  !
  !       L1 list - modified
  !
  use chanel_C, only: iw
  implicit none

  public :: afmm_ini, prepare_tesselations, set_tesselation, &
       & divide_box, afmm, simple_mm, get_legendre, &
       & count_short_ints

  private

  logical, parameter :: DEBUG = .false.
  logical, parameter :: PRINT = .false.

  double precision, parameter ::  small = 1.d-3   ! Tolerance for
                                                  ! for box ident.

  integer, parameter ::   p = 3         ! Multipole expansion level >= 2
  integer, parameter :: dcmplx_kind = Kind ((1.d0, 1.d0))

  type Box
     integer :: parent, level
     integer :: n_p, p_start
     integer :: n_childs, n_l1, n_l2
     integer :: n_up, n_down, n_north, n_south, n_east, n_west
     integer, dimension(8) :: childs
     integer, dimension(28) :: l1
     integer, dimension(189) :: l2

     double precision :: x0, y0, z0

     complex(kind=dcmplx_kind), dimension(-p:p, 0:p) :: phi, psi
  end type Box

  type(Box), dimension(:), pointer :: b
  double precision, dimension(:), pointer :: d
  integer, dimension(:), pointer :: level, ind, ind1

  integer :: nbox, nlev
  integer, dimension(:), allocatable :: points_index

  double precision, dimension(-p:p, 0:p) :: pmn, y_norm, amn
  double precision, dimension(0:2*p) :: fact

  type Tesselation
     type(Box), dimension(:), pointer :: b
     double precision, dimension(:), pointer :: d
     integer, dimension(:), pointer :: level, ind, ind1
     integer :: nbox, nlev, n
  end type Tesselation

  integer :: max_tess, current_tess

  Type(Tesselation), dimension(:), allocatable :: tess

contains

  subroutine prepare_tesselations (n1, n2, ind, n, ierr)

    !
    !.. Implicit Declarations ..
    implicit none
    !
    !.. Formal Arguments ..
    integer, intent(in) :: n1, n2, n
    integer, intent(out) :: ierr
    integer, dimension(n), intent(out) :: ind
    !
    !.. Local Scalars ..
    integer :: i, j
    !
    !.. Intrinsic Functions ..
    intrinsic Allocated, Associated, Max
    !
    ! ... Executable Statements ...

    if (Allocated (tess)) then
      do j = 1, max_tess
        if (Associated (tess(j)%b) ) then
          deallocate (tess(j)%b, tess(j)%d, tess(j)%level, tess(j)%ind, &
               & tess(j)%ind1, stat = i)

          if (i /= 0) then
            ierr = -3
            return
          end if
        end if
      end do

      deallocate (tess, points_index, stat = i)
      if (i /= 0) then
        ierr = -2
        return
      end if
    end if

    allocate (tess(n), points_index(Max (n1, n2)), stat = i)

    if (i /= 0) then
      ierr = -1
      return
    end if

    do j = 1, n
      nullify(tess(j)%b, tess(j)%d, tess(j)%level, tess(j)%ind, &
           & tess(j)%ind1)
    end do

    do i = 1, n
      ind(i) = i
    end do

    max_tess = n
    current_tess = 0
    ierr = 0

  end subroutine prepare_tesselations

  subroutine set_tesselation (handle, ierr)
    !
    !.. Implicit Declarations ..
    implicit none
    !
    !.. Formal Arguments ..
    integer, intent(in) :: handle
    integer, intent(out) :: ierr
    !
    ! ... Executable Statements ...

    if (handle > 0 .and. handle <= max_tess) then
      ierr = 0

      if (current_tess /= handle) then
        current_tess = handle
        b => tess(handle)%b
        d => tess(handle)%d
        level => tess(handle)%level
        ind => tess(handle)%ind
        ind1 => tess(handle)%ind1
        nbox = tess(handle)%nbox
        nlev = tess(handle)%nlev
      end if

      points_index(1:tess(handle)%n) = ind(1:tess(handle)%n)

    else
      ierr = -1
    end if


  end subroutine set_tesselation

  subroutine store_tesselation (handle, n)
    !
    !.. Implicit Declarations ..
    implicit none
    !
    !.. Formal Arguments ..
    integer, intent(in) :: handle, n
    !
    ! ... Executable Statements ...

    current_tess = handle
    tess(handle)%b => b
    tess(handle)%d => d
    tess(handle)%level => level
    tess(handle)%ind => ind
    tess(handle)%ind1 => ind1
    tess(handle)%nbox = nbox
    tess(handle)%nlev = nlev
    tess(handle)%n = n

  end subroutine store_tesselation

  subroutine divide_box (coord, n1, n, min_d, min_p, max_tes, handle, ierr)
    implicit none
    integer, intent (in) :: n1, n, handle
    double precision, intent (in), dimension(n1, n) :: coord
    double precision, intent (in) :: min_d   ! Minimum box size
    integer, intent (in) :: min_p   ! Minimum points in cell
    integer, intent (in) :: max_tes ! Max tesselation size
                                    ! (if < 3, then compute)

    integer, intent(out) :: ierr  ! error, 0 if everything OK
    double precision :: xmax, xmin, ymax, ymin, zmax, zmin, &
         &  dx, dy, dz, x0, y0, z0, t, r
    integer :: max_boxs, max_lev
    integer :: i, i0, i1, j, j0, k, m, status
    logical :: division
    intrinsic Sqrt, Abs, Dble, Int, Log, Max, Min
    !
    !       Step -1. Find initial box
    !       ======
    !
    if (n1 < 3) then
      ierr = -10
      return
    end if

    xmax = coord(1, 1)
    xmin = coord(1, 1)
    ymax = coord(2, 1)
    ymin = coord(2, 1)
    zmax = coord(3, 1)
    zmin = coord(3, 1)

    do i = 2, n
      if (xmax < coord(1, i)) then
        xmax = coord(1, i)
      elseif (xmin > coord(1, i)) then
        xmin = coord(1, i)
      end if

      if (ymax < coord(2, i)) then
        ymax = coord(2, i)
      elseif (ymin > coord(2, i)) then
        ymin = coord(2, i)
      end if

      if (zmax < coord(3, i)) then
        zmax = coord(3, i)
      elseif (zmin > coord(3, i)) then
        zmin = coord(3, i)
      end if
    end do

    dx = xmax - xmin
    dy = ymax - ymin
    dz = zmax - zmin

    t = dx
    if (t < dy) then
      t = dy
    end if
    if (t < dz) then
      t = dz
    end if

    ! --- adjust the initial box

    x0 = (xmax + xmin) /2
    y0 = (ymax + ymin) /2
    z0 = (zmax + zmin) /2
    t = t /2

    xmin = x0 - t
    xmax = x0 + t
    ymin = y0 - t
    ymax = y0 + t
    zmin = z0 - t
    zmax = z0 + t

    if (DEBUG) then
      write (iw, *) " Adjusted, t = ", t
      write (iw, *) "xmax, xmin", xmax, xmin
      write (iw, *) "ymax, ymin", ymax, ymin
      write (iw, *) "zmax, zmin", zmax, zmin
    end if

    if (max_tes < 3) then
      max_lev = Int (Min (Log(t / min_d) / Log(2.d0) + 1.d0, &
           & Log(n / Dble (min_p)) / Log(8.d0) + 2.d0))
    else
      max_lev = max_tes
    end if

    if (max_lev < 3) max_lev = 3

    max_boxs = 0
    j = 1
    do i = 1, max_lev
      max_boxs = max_boxs + j*8
      j = j * 8
    end do

    if (PRINT) then
      write (iw, *) " Estimated number of splits =", max_lev
      write (iw, *) " Estimated number of boxes =", max_boxs
    end if

    allocate (b(max_boxs), d(max_lev), level(max_lev+1), &
         & ind(n+1), ind1(Max(n+1, 189*6)), stat = status)

    if (status /= 0) then
      ierr = -2
      return
    end if

    !
    !       Step 0. Split the initial box
    !       ======
    !
    do i = 1, n
      ind(i) = i
    end do

    call split_box (0, 1, x0, y0, z0, t*0.5, coord, n1, n, 0, 0, m)

    d(1) = t
    level(1) = 1
    level(2) = m + 1
    nbox = m

    do i = 1, max_lev - 1
      division = .false.
      t = t / 2
      do j = level(i), level(i+1) - 1
        if (b(j)%n_p > min_p) then
          call split_box (j, i+1, b(j)%x0, b(j)%y0, b(j)%z0, &
               &    t*0.5, coord, n1, b(j)%n_p, nbox, b(j)%p_start - 1, m)
          division = .true.
          b(j)%n_childs = m
          do k = 1, m
            b(j)%childs(k) = nbox + k
          end do
          nbox = nbox + m
        end if
      end do

      if (division) then
        nlev = i+1
        d(i+1) = t
        level(i+2) = nbox + 1

        do j = level(i+1), level(i+2) - 1
          b(j)%p_start = b(j)%p_start + b(b(j)%parent)%p_start - 1
        end do
      else
        nlev = i
        exit
      end if
    end do

    if (PRINT) then
      write (iw, *) " Actual number of splits =", nlev
      write (iw, *) " Actual number of boxes =", nbox
      do i=1, nlev
        write (iw, *) " Level ", i, "Size = ", d(i)
      end do
    end if

    !
    !       Create lists for each box
    !
    !       l1(b) - set consisting of all boxes adjustent to b.
    !       Let c be in l1(b). Then
    !               if c has children it will be in l1(b)
    !               if c is childless, then only c with numbers < b
    !                       will be in the l1 list of b.
    !       This is done to avoid double counting on step 7.
    !       List l1 is computed for parent boxes, and contains all the boxes
    !       (Note 1. So the list 1 has boxes on the same split level,
    !               as box b, similar to list 2).
    !       (Note 2. in this version the definition of list 1 includes
    !               lists 1 and 3 of the original paper)
    !

    do i = 1, nlev
      t = d(i) + small
      do j = level(i), level(i+1) - 1
        do k = level(i), level(i+1) - 1

          if (j == k) cycle

          dx = Abs (b(j)%x0 - b(k)%x0)
          dy = Abs (b(j)%y0 - b(k)%y0)
          dz = Abs (b(j)%z0 - b(k)%z0)

          if (dx < t .and. dy < t .and. dz < t) then
            if (b(j)%n_childs /= 0) then
              b(j)%n_l1 = b(j)%n_l1 + 1
              b(j)%l1(b(j)%n_l1) = k
            elseif (j > k .or. b(k)%n_childs /= 0) then
              b(j)%n_l1 = b(j)%n_l1 + 1
              b(j)%l1(b(j)%n_l1) = k
            end if
          end if
        end do
      end do
    end do
    !
    !       l2(b) - set consisting of all children of boxes
    !       adjustent to parent of b, but separated from b.
    !       (Note. The list 2 is empty for boxes on level 1)
    !
    do i = level(2), nbox
      t = d(b(i)%level) + small

      i0 = b(i)%parent
      do j = 1, b(i0)%n_l1
        j0 = b(i0)%l1(j)
        do k = 1, b(j0)%n_childs
          i1 = b(j0)%childs(k)

          dx = Abs (b(i)%x0 - b(i1)%x0)
          dy = Abs (b(i)%y0 - b(i1)%y0)
          dz = Abs (b(i)%z0 - b(i1)%z0)

          if (.not. (dx < t .and. dy < t .and. dz < t)) then
            b(i)%n_l2 = b(i)%n_l2 + 1
            b(i)%l2(b(i)%n_l2) = i1
          end if
        end do
      end do
    end do

    if (DEBUG) then
      write (iw, *) " Boxes:"
      ind1 = 0
      do i = 1, nbox
        write (iw, *) "Box, level, x0, y0, z0", i, &
             & b(i)%level, b(i)%x0, b(i)%y0, b(i)%z0
        write (iw, *) "n_childs, n_l1, n_l2, n_p", &
             & b(i)%n_childs, b(i)%n_l1, b(i)%n_l2, b(i)%n_p

        write (iw, *) "parent: ", b(i)%parent

        write (iw, *) " Childs list:"
        write (iw, *) (b(i)%childs(k), k = 1, b(i)%n_childs)

        write (iw, *) " L1 list:"
        write (iw, *) (b(i)%l1(k), k = 1, b(i)%n_l1)

        write (iw, *) " L2 list:"
        write (iw, *) (b(i)%l2(k), k = 1, b(i)%n_l2)

        if (b(i)%n_childs == 0) then
          write (iw, *) " Points:"
          write (iw, *) (ind(b(i)%p_start + k), k = 0, b(i)%n_p - 1)

          do k = 0, b(i)%n_p - 1
            j = b(i)%p_start + k
            if (ind1(j) /= 0) then
              write (iw, *) "--- ERROR in points ---"
            else
              ind1(j) = ind(j)
            end if
          end do
        end if
      end do

      do i = 1, n
        if (ind1(i) == 0) then
          write (iw, *) " +++ Error in points "
        end if
      end do

      do i = 1, nlev
        write (iw, *) " Boxes on level ", i, " : ", &
             & level(i), level(i+1) - 1
      end do
    end if

    if (DEBUG) then

    !
    ! --- Test for points assignment
    !

      do i = 1, nbox
        dx = d(b(i)%level) * 0.5
        r = Sqrt(3.d0) * dx           ! max distance

        do j = 0, b(i)%n_p - 1
          k = ind(b(i)%p_start + j)
          dx = coord(1, k) - b(i)%x0
          dy = coord(2, k) - b(i)%y0
          dz = coord(3, k) - b(i)%z0
          t = Sqrt (dx**2 + dy**2 + dz**2)

          if (t >= r) then
            write (iw, *) " *2* Error", i, j
          end if
        end do
      end do
    end if

    ierr = 0

    call store_tesselation (handle, n)

  end subroutine divide_box

  function count_short_ints ( coord, nc, simulate_dir_int, compute ) result(n)
    !
    !.. Implicit Declarations ..
    implicit none

    !
    !.. Formal Arguments ..
    integer, intent(in) :: nc
    double precision, intent (in), dimension(nc, *) :: coord
    logical, intent( in ) :: compute

    interface
       subroutine simulate_dir_int (ind1, n1, ind2, n2, c, nc, same, &
                & compute, n )
         integer, intent(in) :: n1, n2, nc
         integer, intent(in), dimension(*) :: ind1, ind2
         double precision, intent(in), dimension(nc, *) :: c
         logical, intent(in) :: same, compute
         integer, intent(inout) :: n
       end subroutine simulate_dir_int
    end interface
    !
    !.. Local Scalars ..
    integer :: n, i, j, j1
    !
    ! ... Executable Statements ...

    n = 0

    do i = 1, nbox
      if (i == 34) then
        j1 = 0
      end if
      if (b(i)%n_childs == 0) then
        call simulate_dir_int (points_index(b(i)%p_start), b(i)%n_p, &
             & points_index(b(i)%p_start), b(i)%n_p, &
             & coord, nc, .true., compute, n)

        do j1 = 1, b(i)%n_l1
          j = b(i)%l1(j1)
          call simulate_dir_int (&
               & points_index(b(i)%p_start), b(i)%n_p, &
               & points_index(b(j)%p_start), b(j)%n_p, &
               & coord, nc, .false., compute, n)

        end do
      end if
    end do

  end function count_short_ints

  subroutine afmm (coord, nc, n, q, res, res_size, dir_int, mult_int, &
       & tricky_multipoles )

    !
    !.. Implicit Declarations ..
    implicit none
    !
    !.. Formal Arguments ..
    integer, intent(in) :: nc, n, res_size
    double precision, intent (in), dimension(n) :: q
    double precision, intent (in), dimension(nc, n) :: coord
    double precision, intent (out), dimension(res_size) :: res

    optional :: tricky_multipoles

    interface
       subroutine dir_int (ind1, n1, ind2, n2, c, nc, q, r, same)
         integer, intent(in) :: n1, n2, nc
         integer, intent(in), dimension(*) :: ind1, ind2
         double precision, intent(in), dimension(nc, *) :: c
         double precision, intent(in), dimension(*) :: q
         double precision, intent(inout), dimension(*) :: r
         logical, intent(in) :: same
       end subroutine dir_int

       subroutine mult_int (ind, n, psi, p, x0, y0, z0, y_norm, pmn, &
            & c, n3, q, r)

         integer, intent(in) :: n, p, n3
         integer, intent(in), dimension(*) :: ind
         complex (kind=Kind ((1.d0, 1.d0))), dimension(-p:p, 0:p), &
            & intent(in) :: psi
         double precision, dimension(-p:p, 0:p), intent(in) :: y_norm
         double precision, dimension(-p:p, 0:p), intent(out) :: pmn
         double precision, intent(in), dimension(n3, *) :: c
         double precision, intent(in), dimension(*) :: q
         double precision, intent(inout), dimension(*) :: r
         double precision, intent(in) :: x0, y0, z0
       end subroutine mult_int

       subroutine tricky_multipoles (&
            & x0, y0, z0, ind, n, pmn, y_norm, c, nc, q, psi, p)

         implicit none

         double precision, intent(in) :: x0, y0, z0
         integer, intent(in) :: n, nc, p
         integer, dimension(*), intent(in) :: ind
         double precision, dimension(nc, *), intent(in) :: c
         double precision, dimension(*), intent(in) :: q
         double precision, dimension(-p:p, 0:p), intent(in) :: y_norm
         double precision, dimension(-p:p, 0:p), intent(inout) :: pmn

         complex (kind=Kind ((1.d0, 1.d0))), dimension(-p:p, 0:p), &
            & intent(inout) :: psi

       end subroutine tricky_multipoles

    end interface
    double precision :: t, tt
    integer :: i, j, j1
    intrinsic Present
    if (Present (tricky_multipoles)) then
      call afmm_step1 (coord, nc, n, q, tricky_multipoles)
    else
      call afmm_step1 (coord, nc, n, q)
    end if

    call afmm_step2
    call afmm_step35
    res = 0

    !
    !       Step 7. Calculate the potential at each charge in a box from
    !       ======  direct interactions
    !
    t = 0
    tt = n
    tt = tt*(tt-1.d0) * 0.5d0
    do i = 1, nbox
      if (b(i)%n_childs == 0) then

        call dir_int (points_index(b(i)%p_start), b(i)%n_p, &
             & points_index(b(i)%p_start), b(i)%n_p, &
             & coord, nc, q, res, .true.)

        t = t + (b(i)%n_p * (b(i)%n_p - 1)) /2

        do j1 = 1, b(i)%n_l1
          j = b(i)%l1(j1)
          call dir_int (&
               & points_index(b(i)%p_start), b(i)%n_p, &
               & points_index(b(j)%p_start), b(j)%n_p, &
               & coord, nc, q, res, .false.)

          t = t + b(i)%n_p * b(j)%n_p
        end do
      end if

    end do
    !
    !       Step 6. Calculate the potential at each charge in a box from
    !       ======  it's local expansion
    !
    do i = 1, nbox
      if (b(i)%n_childs == 0) then
        call mult_int (points_index(b(i)%p_start), b(i)%n_p, &
             & b(i)%psi, p, b(i)%x0, b(i)%y0, b(i)%z0, &
             & y_norm, pmn, coord, nc, q, res)
      end if
    end do
  end subroutine afmm

  subroutine afmm_step1 (coord, nc, n, q, tricky_multipoles)
    !
    !.. Implicit Declarations ..
    implicit none
    !
    !.. Formal Arguments ..
    integer, intent(in) :: nc, n
    double precision, intent (in), dimension(n) :: q
    double precision, intent (in), dimension(nc, n) :: coord

    optional :: tricky_multipoles

    interface

       subroutine tricky_multipoles (x0, y0, z0, ind, n, pmn, y_norm, &
            & c, nc, q, psi, p)

         implicit none

         double precision, intent(in) :: x0, y0, z0
         integer, intent(in) :: n, nc, p
         integer, dimension(*), intent(in) :: ind
         double precision, dimension(nc, *), intent(in) :: c
         double precision, dimension(*), intent(in) :: q
         double precision, dimension(-p:p, 0:p), intent(in) :: y_norm
         double precision, dimension(-p:p, 0:p), intent(inout) :: pmn

         complex (kind=Kind ((1.d0, 1.d0))), dimension(-p:p, 0:p), &
              & intent(inout) :: psi

       end subroutine tricky_multipoles

    end interface
    integer :: i
    intrinsic Present
    !
    ! ... Executable Statements ...

    do i = 1, nbox
      b(i)%phi = (0.d0, 0.d0)
      b(i)%psi = (0.d0, 0.d0)
    end do
    !
    !  Step 1. For each childless box form a multipole expansion about it's
    !  ======  centre from all it's charges
    !
    do i = 1, nbox
      if (b(i)%n_childs == 0) then
        if (Present (tricky_multipoles)) then
          call tricky_multipoles (&
               & b(i)%x0, b(i)%y0, b(i)%z0, points_index(b(i)%p_start), &
               & b(i)%n_p, pmn, y_norm, coord, nc, q, b(i)%phi, p)
        else
          call normal_multipoles (&
               & b(i)%x0, b(i)%y0, b(i)%z0, points_index(b(i)%p_start), &
               & b(i)%n_p, pmn, y_norm, coord, nc, q, b(i)%phi, p)
        end if
      end if
    end do
  end subroutine afmm_step1

  subroutine normal_multipoles (x0, y0, z0, ind, n, pmn, y_norm, &
       & c, nc, q, psi, p)
    !
    !.. Implicit Declarations ..
    implicit none
    !
    !.. Formal Arguments ..
    double precision, intent(in) :: x0, y0, z0
    integer, intent(in) :: n, nc, p
    integer, dimension(*), intent(in) :: ind
    double precision, dimension(nc, *), intent(in) :: c
    double precision, dimension(*), intent(in) :: q
    double precision, dimension(-p:p, 0:p), intent(in) :: y_norm
    double precision, dimension(-p:p, 0:p), intent(inout) :: pmn
    complex (kind=dcmplx_kind), dimension(-p:p, 0:p), intent(inout) :: psi
    !
    !.. Local Scalars ..
    double precision :: dx, dy, dz, t, tt, r, cos_t, phi
    complex (kind=dcmplx_kind) :: tc, tc1
    integer :: j, k, n1, m1
    !
    !.. Intrinsic Functions ..
    intrinsic Sqrt, Atan2, Exp, Cmplx, Conjg
    !
    ! ... Executable Statements ...

    do j = 1, n
      k = ind(j)
      dx = c(1, k) - x0
      dy = c(2, k) - y0
      dz = c(3, k) - z0
      r = Sqrt (dx**2 + dy**2 + dz**2)
      cos_t = dz / r
      phi = Atan2 (dy, dx)

      call get_legendre (p, cos_t, pmn)

      psi(0, 0) = psi(0, 0) + Cmplx (q(k), 0.d0, dcmplx_kind)

      t = 1.d0
      do n1 = 1, p
        t = t * r
        do m1 = 0, n1
          tc = Exp (Cmplx (0.d0, -m1*phi, dcmplx_kind))
          tt = y_norm(-m1, n1) * pmn(-m1, n1) * t * q(k)
          tc1 = tc * tt
          psi(m1, n1) = psi(m1, n1) + tc1
        end do
      end do

      do n1 = 1, p
        do m1 = 1, n1
          psi(-m1, n1) = Conjg (psi(m1, n1))
        end do
      end do
    end do

  end subroutine normal_multipoles

  subroutine afmm_step2
    implicit none
    double precision :: dx, dy, dz, tt, r, cos_t, phi
    complex (kind=dcmplx_kind) :: tc, tc1
    integer :: i, j, j1, k, m, n1, m1, n2, m2
    intrinsic Sqrt, Exp, Cmplx, Atan2, Abs, Conjg

    !
    !       Step 2. For each parent box form a multipole expansion
    !       ======  around it's centre by merging multipole expansion
    !               from it's children
    !
    do i = nlev-1, 2, -1
      do j = level(i), level(i+1) - 1
        do k = 1, b(j)%n_childs
          j1 = b(j)%childs(k)

          dx = b(j1)%x0 - b(j)%x0
          dy = b(j1)%y0 - b(j)%y0
          dz = b(j1)%z0 - b(j)%z0

          r = Sqrt (dx**2 + dy**2 + dz**2)
          cos_t = dz / r
          phi = Atan2 (dy, dx)

          call get_legendre (p, cos_t, pmn)

          do n1 = 0, p
           do m1 = 0, n1
              tc = Cmplx (0.d0, 0.d0, dcmplx_kind)
              do n2 = 0, n1
                do m2 = -n2, n2

                  if (Abs (m1-m2) > n1-n2) then
                    cycle
                  end if

                  m = Abs (m1) - Abs (m2) - Abs (m1-m2)

                  tt = amn(m2, n2) * amn(m1-m2, n1-n2) &
                       & / amn(m1, n1) * r**n2 &
                       & * y_norm(-m2, n2) * pmn(-m2, n2)

                  tc1 = Exp (Cmplx (0, -m2*phi, dcmplx_kind)) &
                       & * b(j1)%phi(m1-m2, n1-n2) &
                       & * (Cmplx (0, 1, dcmplx_kind)) **m

                  tc = tc + tt * tc1

                end do
              end do

              b(j)%phi(m1, n1) = b(j)%phi(m1, n1) + tc
            end do
          end do

        end do

        do n1 = 1, p
          do m1 = 1, n1
            b(j)%phi(-m1, n1) = Conjg (b(j)%phi(m1, n1))
          end do
        end do
      end do
    end do
  end subroutine afmm_step2

  subroutine afmm_step35
    implicit none
    double precision :: dx, dy, dz, tt, r, cos_t, phi
    complex (kind=dcmplx_kind) :: tc, tc1
    integer :: i, j, j1, m, n1, m1, n2, m2
    intrinsic Sqrt, Cmplx, Conjg, Exp, Atan2, Abs
    !
    ! ... Executable Statements ...

    !
    !       Steps 3 and 8. Interaction of not very well separated points
    !       =============
    !
    !       These step is now combined into step 7 due to different
    !       definition of the list 1.
    !

    !
    !       Step 4. Move multipole expansion to boxes in l2 list.
    !       ======
    !

    do i = level(2), nbox
      do j1 = 1, b(i)%n_l2
        j = b(i)%l2(j1)

        dx = b(i)%x0 - b(j)%x0
        dy = b(i)%y0 - b(j)%y0
        dz = b(i)%z0 - b(j)%z0

        r = Sqrt (dx**2 + dy**2 + dz**2)
        cos_t = dz / r
        if( Abs( dx ) < 1.d-6 .and. Abs( dy ) < 1.d-6 ) then
           phi = 0.d0
        else
           phi = Atan2 (dy, dx)
        end if


        call get_legendre (p, cos_t, pmn)

        do n1 = 0, p
          do m1 = 0, n1

            tc = (0.d0, 0.d0)

            do n2 = 0, p

              if (n1+n2 > p) then
                cycle
              end if

              do m2 = -n2, n2

                if (Abs (m2-m1) > n1+n2) then
                  cycle
                end if

                m = Abs (m1-m2) - Abs (m1) - Abs (m2)

                tt = amn(m2, n2) * amn(m1, n1) &
                     & / (amn(m2-m1, n1+n2) * r**(n1+n2+1)) &
                     & * y_norm(m2-m1, n1+n2) * pmn(m2-m1, n1+n2) / (-1)**n2

                tc1 = Exp (Cmplx (0, (m2-m1)*phi, dcmplx_kind)) &
                     & * b(i)%phi(m2, n2) &
                     & * (Cmplx (0, 1, dcmplx_kind)) **m

                tc = tc + tt * tc1
              end do
            end do

            b(j)%psi(m1, n1) = b(j)%psi(m1, n1) + tc
          end do
        end do

        do n1 = 1, p
          do m1 = 1, n1
            b(j)%psi(-m1, n1) = Conjg (b(j)%psi(m1, n1))
          end do
        end do

      end do
    end do
    !
    !       Step 5. For each parent shift the centre of it's local expansion
    !       ======  to it's children.
    !

    do i = level(2), nbox
      do j1 = 1, b(i)%n_childs
        j = b(i)%childs(j1)

        dx = b(i)%x0 - b(j)%x0
        dy = b(i)%y0 - b(j)%y0
        dz = b(i)%z0 - b(j)%z0

        r = Sqrt (dx**2 + dy**2 + dz**2)
        cos_t = dz / r
        phi = Atan2 (dy, dx)

        call get_legendre (p, cos_t, pmn)

        do n1 = 0, p
          do m1 = -n1, n1
            tc = (0.d0, 0.d0)
            do n2 = n1, p
              do m2 = -n2, n2

                if (Abs (m2-m1) > n2-n1) then
                  cycle
                end if

                m = Abs (m2) - Abs (m2-m1) - Abs (m1)

                tt = amn(m2-m1, n2-n1) * amn(m1, n1) &
                     & / amn(m2, n2) * r**(n2-n1) &
                     & * y_norm(m2-m1, n2-n1) * pmn(m2-m1, n2-n1) &
                     & / (-1)**(n2+n1)

                tc1 = Exp (Cmplx (0, (m2-m1)*phi, dcmplx_kind)) &
                     & * b(i)%psi(m2, n2) * (Cmplx (0, 1, dcmplx_kind))**m

                tc = tc + tt * tc1
              end do
            end do

            b(j)%psi(m1, n1) = b(j)%psi(m1, n1) + tc
          end do
        end do
      end do
    end do
  end subroutine afmm_step35

  subroutine simple_mm (coord, nc, n, q, res, dir_int, far_int, &
       & tricky_multipoles)

    !
    !.. Implicit Declarations ..
    implicit none
    !
    !.. Formal Arguments ..
    integer, intent(in) :: nc, n
    double precision, intent (in), dimension(n) :: q
    double precision, intent (in), dimension(nc, n) :: coord
    double precision, intent (out), dimension(n) :: res

    optional :: tricky_multipoles

    interface
       subroutine dir_int (ind1, n1, ind2, n2, c, nc, q, r, same)
         integer, intent(in) :: n1, n2, nc
         integer, intent(in), dimension(*) :: ind1, ind2
         double precision, intent(in), dimension(nc, *) :: c
         double precision, intent(in), dimension(*) :: q
         double precision, intent(inout), dimension(*) :: r
         logical, intent(in) :: same
       end subroutine dir_int

       subroutine far_int (ind, n, phi, p, x0, y0, z0, &
            & y_norm, pmn, c, nc, q, r)

         integer, intent(in) :: n, p, nc
         integer, intent(in), dimension(*) :: ind
         complex (kind=Kind ((1.d0, 1.d0))), dimension(-p:p, 0:p), &
              &intent(in) :: phi
         double precision, dimension(-p:p, 0:p), intent(in) :: y_norm
         double precision, dimension(-p:p, 0:p), intent(out) :: pmn
         double precision, intent(in), dimension(nc, *) :: c
         double precision, intent(in), dimension(*) :: q
         double precision, intent(inout), dimension(*) :: r
         double precision, intent(in) :: x0, y0, z0
       end subroutine far_int

       subroutine tricky_multipoles (&
            & x0, y0, z0, ind, n, pmn, y_norm, c, nc, q, psi, p)

         implicit none

         double precision, intent(in) :: x0, y0, z0
         integer, intent(in) :: n, nc, p
         integer, dimension(*), intent(in) :: ind
         double precision, dimension(nc, *), intent(in) :: c
         double precision, dimension(*), intent(in) :: q
         double precision, dimension(-p:p, 0:p), intent(in) :: y_norm
         double precision, dimension(-p:p, 0:p), intent(inout) :: pmn

         complex (kind=Kind ((1.d0, 1.d0))), dimension(-p:p, 0:p), &
              & intent(inout) :: psi

       end subroutine tricky_multipoles

    end interface
    double precision :: t, tt
    integer :: i, j, j1
    intrinsic Present
    !
    ! ... Executable Statements ...

    res = 0

    if (Present (tricky_multipoles)) then
      call afmm_step1 (coord, nc, n, q, tricky_multipoles)
    else
      call afmm_step1 (coord, nc, n, q)
    end if

    call afmm_step2

    !
    !       Step 3. Compute far interactions
    !
    do i = level(2), nbox
      do j1 = 1, b(i)%n_l2
        j = b(i)%l2(j1)
        call far_int (points_index(b(i)%p_start), b(i)%n_p, &
             & b(j)%phi, p, b(j)%x0, b(j)%y0, b(j)%z0, &
             & y_norm, pmn, coord, nc, q, res)
      end do
    end do


    !
    !       Step 4. Calculate the potential at each charge in a box from
    !       ======  direct interactions
    !


    t = 0
    tt = n
    tt = tt*(tt-1.d0) * 0.5d0
    do i = 1, nbox
      if (b(i)%n_childs == 0) then
        call dir_int (points_index(b(i)%p_start), b(i)%n_p, &
             & points_index(b(i)%p_start), b(i)%n_p, &
             & coord, nc, q, res, .true.)

        t = t + (b(i)%n_p * (b(i)%n_p - 1)) /2

        do j1 = 1, b(i)%n_l1
          j = b(i)%l1(j1)
          call dir_int (&
               & points_index(b(i)%p_start), b(i)%n_p, &
               & points_index(b(j)%p_start), b(j)%n_p, &
               & coord, nc, q, res, .false.)

          t = t + b(i)%n_p * b(j)%n_p
        end do
      end if
    end do
  end subroutine simple_mm

  subroutine split_box (parent, level, x0, y0, z0, d, coord, nc, n, &
       & b_pos, ind_pos, m)
    !
    !       Splits box to 8 smaller boxes & ignore empty boxes
    !

    !
    !.. Implicit Declarations ..
    implicit none
    !
    !.. Formal Arguments ..
    integer, intent(in) :: n, nc, parent, level, b_pos, ind_pos
    double precision, intent(in) :: x0, y0, z0, d
    double precision, intent(in), dimension(nc, *) :: coord
    integer, intent(out) :: m
    !
    !.. Local Scalars ..
    integer :: i, n1, n2, n3, n4, n5, n6
    !
    ! ... Executable Statements ...

    m = 0

    call split_index (1, coord, nc, x0, ind_pos, n, n1, n2)

    if (n1 > 0) then
      call split_index (2, coord, nc, y0, ind_pos, n1, n3, n4)

      if (n3 > 0) then
        call split_index (3, coord, nc, z0, ind_pos, n3, n5, n6)

        if (n5 > 0) then
          m = m + 1
          b(b_pos + m)%x0 = x0 - d
          b(b_pos + m)%y0 = y0 - d
          b(b_pos + m)%z0 = z0 - d
          b(b_pos + m)%p_start = 1
          b(b_pos + m)%n_p = n5
        end if

        if (n6 > 0) then
          m = m + 1
          b(b_pos + m)%x0 = x0 - d
          b(b_pos + m)%y0 = y0 - d
          b(b_pos + m)%z0 = z0 + d
          b(b_pos + m)%p_start = 1 + n5
          b(b_pos + m)%n_p = n6
        end if
      end if

      if (n4 > 0) then
        call split_index (3, coord, nc, z0, ind_pos+n3, n4, n5, n6)

        if (n5 > 0) then
          m = m + 1
          b(b_pos + m)%x0 = x0 - d
          b(b_pos + m)%y0 = y0 + d
          b(b_pos + m)%z0 = z0 - d
          b(b_pos + m)%p_start = n3 + 1
          b(b_pos + m)%n_p = n5
        end if

        if (n6 > 0) then
          m = m + 1
          b(b_pos + m)%x0 = x0 - d
          b(b_pos + m)%y0 = y0 + d
          b(b_pos + m)%z0 = z0 + d
          b(b_pos + m)%p_start = n3 + 1 + n5
          b(b_pos + m)%n_p = n6
        end if
      end if
    end if

    if (n2 > 0) then
      call split_index (2, coord, nc, y0, ind_pos+n1, n2, n3, n4)

      if (n3 > 0) then
        call split_index (3, coord, nc, z0, ind_pos+n1, n3, n5, n6)

        if (n5 > 0) then
          m = m + 1
          b(b_pos + m)%x0 = x0 + d
          b(b_pos + m)%y0 = y0 - d
          b(b_pos + m)%z0 = z0 - d
          b(b_pos + m)%p_start = n1 + 1
          b(b_pos + m)%n_p = n5
        end if

        if (n6 > 0) then
          m = m + 1
          b(b_pos + m)%x0 = x0 + d
          b(b_pos + m)%y0 = y0 - d
          b(b_pos + m)%z0 = z0 + d
          b(b_pos + m)%p_start = n1 + 1 + n5
          b(b_pos + m)%n_p = n6
        end if
      end if

      if (n4 > 0) then
        call split_index (3, coord, nc, z0, ind_pos+n1+n3, n4, n5, n6)

        if (n5 > 0) then
          m = m + 1
          b(b_pos + m)%x0 = x0 + d
          b(b_pos + m)%y0 = y0 + d
          b(b_pos + m)%z0 = z0 - d
          b(b_pos + m)%p_start = n1 + n3 + 1
          b(b_pos + m)%n_p = n5
        end if

        if (n6 > 0) then
          m = m + 1
          b(b_pos + m)%x0 = x0 + d
          b(b_pos + m)%y0 = y0 + d
          b(b_pos + m)%z0 = z0 + d
          b(b_pos + m)%p_start = n1 + n3 + 1 + n5
          b(b_pos + m)%n_p = n6
        end if
      end if
    end if

    do i = b_pos + 1, b_pos + m
      b(i)%parent = parent
      b(i)%level = level
      b(i)%n_childs = 0
      b(i)%n_l1 = 0
      b(i)%n_l2 = 0
      b(i)%phi = (0.d0, 0.d0)
      b(i)%psi = (0.d0, 0.d0)
    end do

  end subroutine split_box

  subroutine split_index (k, coord, nc, g, ind_pos, n, n1, n2)
    !
    !.. Implicit Declarations ..
    implicit none
    !
    !.. Formal Arguments ..
    integer, intent(in) :: k, n, nc, ind_pos
    double precision, intent(in), dimension(nc, *) :: coord
    double precision, intent(in) :: g
    integer, intent (out) :: n1, n2

    !
    !.. Local Scalars ..
    integer :: i
    !
    ! ... Executable Statements ...

    n1 = 0
    n2 = n + 1

    do i = 1, n
      if (coord(k, ind(ind_pos+i)) < g) then
        n1 = n1 + 1
        ind1(n1) = ind(ind_pos+i)
      else
        n2 = n2 - 1
        ind1(n2) = ind(ind_pos+i)
      end if
    end do

    n2 = n - n1

    do i = 1, n
      ind(ind_pos+i) = ind1(i)
    end do

  end subroutine split_index

  subroutine get_legendre (n_max, x, pmn)
    !
    !       Computes array of Legendre functions
    !

    !
    !.. Implicit Declarations ..
    implicit none
    !
    !.. Formal Arguments ..
    integer, intent (in) :: n_max
    double precision, intent (inout) :: x
    double precision, intent (out), dimension(-n_max:n_max, 0:n_max) :: pmn

    !
    !.. Local Scalars ..
    double precision :: x2, t, s, s1
    integer :: n, m
    !
    !.. Intrinsic Functions ..
    intrinsic Sqrt, Dble
    !
    ! ... Executable Statements ...

    x2 = x**2
    if (x2 >= 1.d0) then
      if (x > 0) then
        x = 1.d0
      else
        x = -1.d0
      end if
      x2 = 1.d0
      t = 0.d0
    else
      t = Sqrt (1.d0 - x2)
    end if

    pmn(0, 0) = 1.d0
    pmn(0, 1) = x
    pmn(1, 1) = -t
    pmn(0, 2) = 0.5d0 * (3.d0*x2 - 1.d0)
    pmn(1, 2) = -3.d0*x*t
    pmn(2, 2) = 3.d0*t*t

    s = pmn(2, 2)
    do n = 3, n_max
      s = s * (2*n - 1) * t
      pmn(n, n) = s * (-1)**n
    end do

    do n = 3, n_max
      do m = n-1, 0, -1
        s = 1.d0 / (Dble(n-m))
        s1 = x*(2*n-1)*pmn(m, n-1)
        if (m <= n-2) then
          s1 = s1 - (n+m-1)*pmn(m, n-2)
        end if
        pmn(m, n) = s1 * s
      end do
    end do

    do n = 1, n_max
      do m = 1, n
        pmn(-m, n) = pmn(m, n)
      end do
    end do

  end subroutine get_legendre

  subroutine afmm_ini
    !
    !.. Implicit Declarations ..
    implicit none

    !
    !.. Local Scalars ..
    integer :: i, j
    double precision :: t
    !
    !.. Intrinsic Functions ..
    intrinsic Sqrt
    !
    ! ... Executable Statements ...

    ! --- factorials

    t = 1.d0
    fact(0) = t
    fact(1) = t

    do i = 2, 2*p
      t = t * i
      fact(i) = t
    end do

    ! --- Spherical harmonics norm

    y_norm(0, 0) = 1.d0
    do i = 1, p
      do j = 0, i
        t = Sqrt (fact(i-j) / fact(i+j))
        y_norm(j, i) = t
        y_norm(-j, i) = t
      end do
    end do

    ! --- amn

    t = 1.d0
    amn(0, 0) = 1.d0
    do i = 1, p
      t = -t
      do j = -i, i
        amn(j, i) = t / Sqrt (fact(i-j) * fact(i+j))
      end do
    end do

  end subroutine afmm_ini

end module afmm_C

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine deri2(minear, f, fd, fci, ninear, nvar_nvo, dxyzr,  throld, &
      diag, scalar, work)
      USE funcon_C, only : fpc_9
      USE meci_C, only : nelec, nstate, lab, nmeci, nmos, xy, &
      & vectci, maxci
      USE molkst_C, only : keywrd, mpack, numcal, norbs
      USE chanel_C, only : iw
      use derivs_C, only : b, ab, fb
      use common_arrays_C, only : c, w, eigs
      implicit none
      integer  :: minear
      integer  :: ninear
      integer  :: nvar_nvo
      double precision , intent(in) :: throld
      double precision  :: f(minear,nvar_nvo)
      double precision  :: fd(ninear,nvar_nvo)
      double precision  :: fci(ninear,nmeci*(nmeci + 1)*10/ninear)
      double precision  :: work(*)
      double precision , intent(inout) :: dxyzr(nvar_nvo)
      double precision  :: diag(mpack)
      double precision  :: scalar(mpack)
      double precision, allocatable  :: bab(:,:), babinv(:)
      double precision  :: bcoef(1000)
      integer :: icalcn, maxite, ifirst, i, nbsize, ilast, j, l, &
        nres, ivar, nadd, nbsze = 0, k, ll, iindex, jindex, limci, ib
      double precision :: const, time1, deter, test2 = 0.d0, test, time2, sum, gse
      logical , dimension(nvar_nvo) :: lconv
      logical :: fail, debug, lbab
      double precision, external :: ddot, seconds
      save debug, icalcn, maxite, ifirst, limci, ib, const
!********************************************************************
!
!     DERI2 COMPUTE THE RELAXATION PART OF THE DERIVATIVES OF THE
!     NON-VARIATIONALLY OPTIMIZED ENERGY WITH RESPECT TO TWO
!     COORDINATES AT A TIME. THIS IS DONE IN THREE STEPS.
!
!     THE M.O DERIVATIVES ARE SOLUTION [X] OF A LINEAR SYSTEM
!                        (D-A) * X = F
!     WHERE D IS A DIAGONAL SUPER-MATRIX OF FOCK EIGENVALUE DIFFERENCES
!     AND A IS A SUPER-MATRIX OF 2-ELECTRONS INTEGRALS IN M.O BASIS.
!     SUCH A SYSTEM IS TOO LARGE TO BE INVERTED DIRECTLY THUS ONE MUST
!     USES A RELAXATION METHOD TO GET A REASONABLE ESTIMATE OF [X].
!     THIS REQUIRES A BASIS SET [B] TO BE GENERATED ITERATIVELY, AFTER
!     WHICH WE SOLVE BY DIRECT INVERSION THE LINEAR SYSTEM PROJECTED
!     IN THIS BASIS [B]. IT WORKS QUICKLY BUT DOES REQUIRE A LARGE
!     CORE MEMORY.
!
!     USE A FORMALISM WITH FOCK OPERATOR THUS AVOIDING THE EXPLICIT
!     COMPUTATION (AND STORAGE) OF THE SUPER-MATRIX A.
!     THE SEMIEMPIRICAL METHODS DO NOT INVOLVE LARGE C.I CALCULATIONS.
!     THEREFORE FOR EACH GRADIENT COMPONENT WE BUILD THE C.I MATRIX
!     DERIVATIVE FROM THE M.O. INTEGRALS <IJ|KL> AND FOCK EIGENVALUES
!     DERIVATIVES, THUS PROVIDING THE RELAXATION CONTRIBUTION TO THE
!     GRADIENT WITHOUT COMPUTATION AND STORAGE OF THE 2ND ORDER DENSITY
!     MATRIX.
!
!   STEP 1)
!     USE THE PREVIOUS B AND THE NEW F VECTORS TO BUILD AN INITIAL
!     BASIS SET B.
!   STEP 2)
!     BECAUSE THE ELECTRONIC HESSIAN (D-A) IS THE SAME FOR EACH
!     DERIVATIVE, WE ONLY NEED TO ENLARGE ITERATIVELY THE ORTHONORMAL
!     BASIS SET [B] USED TO INVERT THE PROJECTED HESSIAN.
!     (DERIVED FROM THE LARGEST RESIDUAL VECTOR ).
!     THIS SECTION IS CARRIED OUT IN THE DIAGONAL METRIC 'SCALAR'.
!   STEP 3) ... LOOP ON THE GEOMETRIC VARIABLE :
! 3.1 FOR EACH GEOMETRIC VARIABLE, GET THE M.O DERIVATIVES IN A.O.
! 3.2 COMPUTE THE FOCK EIGENVALUES AND 2-ELECTRON INTEGRAL RELAXATION.
! 3.3 BUILD THE ELECTRONIC RELAXATION CONTRIBUTION TO THE C.I MATRIX
!     AND GET THE ASSOCIATED EIGENSTATE DERIVATIVE WITH RESPECT TO
!     THE GEOMETRIC VARIABLE.
!
!   INPUT
!     C(NORBS,NORBS) : M.O. COEFFICIENTS, IN COLUMN.
!     eigs(NORBS)       : EIGENVALUES OF THE FOCK MATRIX.
!     MINEAR         : NUMBER OF NON REDUNDANT ROTATION OF THE M.O.
!     F(MINEAR,nvar_nvo) : NON-RELAXED FOCK MATRICES DERIVATIVES
!                    IN M.O BASIS, OFF-DIAGONAL BLOCKS.
!     FD(NINEAR,nvar_nvo): IDEM, DIAGONAL BLOCKS, C.I-ACTIVE ONLY.
!     WORK           : WORK ARRAY OF SIZE N*N.
!     B(MINEAR,NBSIZE) : INITIAL ORTHONORMALIZED BASIS SET [B].
!     dxyzr(nvar_nvo)     : GRADIENT VECTOR BEFORE RELAXATION CORRECTION.
!     AB(MINEAR,*): STORAGE FOR THE (D-A) * B VECTORS.
!     FB(nvar_nvo,*)  : STORAGE FOR THE MATRIX PRODUCT F' * B.
!   OUTPUT
!     dxyzr   : DERIVATIVE OF THE HEAT OF FORMATION WITH RESPECT TO
!              THE nvar_nvo OPTIMIZED VARIABLES.
!
!***********************************************************************
      data icalcn/ 0/
      time1 = 0.d0
      time2 = 0.d0
      allocate (bab(70,70), babinv(4900))
      bab = 0.d0
!
!     * * * STEP 1 * * *
!     BUILD UP THE INITIAL ORTHONORMALIZED BASIS.
!
      if (icalcn /= numcal) then
        limci = nmos*norbs*20/ninear
        ib = max(lab,20)
        debug = index(keywrd,' DERI2') /= 0
        const = fpc_9
        icalcn = numcal
        i = max(20*minear, (lab*(lab + 1))/2, mpack)
        if (allocated(ab)) deallocate(ab)
        allocate(ab(minear, i*2/minear))
        ab = 0.d0
        maxite = min(min(60,int(sqrt(dble(nmeci**3)))),10000*2/nvar_nvo, i/minear)
        ifirst = min(nvar_nvo,1 + maxite/4)
        k = max((lab*(lab + 1))/2, 20*mpack)
        if (allocated(b))  deallocate(b)
        if (allocated(fb)) deallocate(fb)
        i = max(k, (maxci*(maxci + 1))/2)
        allocate(b(minear,i/minear))
        i = max(ninear, i/minear)
        allocate(fb(1,i))
      end if
      fail = .FALSE.
      nbsize = 0
      if (debug) time1 = seconds(1)
!
!        NORMAL CASE. USE F ONLY.
!
      call deri21 (f, nvar_nvo, minear, ifirst, work, work(nvar_nvo*nvar_nvo+1), b, ilast)
      lbab = .FALSE.
      ifirst = nbsize + 1
      ilast = nbsize + ilast
      lconv(:nvar_nvo) = .FALSE.
!
!     * * * STEP 2 * * *
!     RELAXATION METHOD WITH OPTIMUM INCREASE OF THE BASIS SET.
!     ---------------------------------------------------------
!
!     UPDATE AB ,FCI AND BAB. (BAB IS SYMMETRIC)
   30 continue
      if (ilast > limci .or. ilast > ib) then
        write (iw, &
             & "(' Derivatives cannot be evaluated using analytical methods')")
        call mopend &
             & (" Derivatives cannot be evaluated using analytical methods")
        write (iw, &
         &"(' Use ""NOANCI"", however, this will slow down the calculation.')")
        write (iw, "(/10X,'FINAL GEOMETRY')")
        call geout (iw)
        goto 99
      end if
      do j = ifirst, ilast
        call deri22 (c, b(1,j), work, work, ab(1,j), minear, fci(1,j), w, diag, scalar, ninear)
        call mxm (ab(1,j), 1, b, minear, bab(1,j), ilast)
        bab(j,:ifirst-1) = bab(:ifirst-1,j)
      end do
!     INVERT BAB, STORE IN BABINV.
   50 continue
      l = 0
      do j = 1, ilast
        babinv(l+1:ilast+l) = bab(:ilast,j)
        l = ilast + l
      end do
      call osinv (babinv, ilast, deter)
      if (Abs(deter) < 1.d-20) then
        if (ilast /= 1) write (iw, &
      '('' THE BAB MATRIX OF ORDER'',I3,'' IS SINGULAR IN DERI2''/ &
      & '' THE RELAXATION IS STOPPED AT THIS POINT.'')') ilast
        lbab = .TRUE.
        ilast = ilast - 1
        go to 50
      end if
!        UPDATE F * B'
      ! TODO: GBR future modifications
      if (.not.lbab) call mtxm (f, nvar_nvo, b(1,ifirst), minear, fb(1,ifirst), &
        ilast - ifirst + 1)
!     NEW SOLUTIONS IN BASIS B , STORED IN BCOEF(nvar_nvo,*).
!     BCOEF = BABINV * FB'
      if (ilast /= 0) call mxmt (babinv, ilast, fb, ilast, bcoef, nvar_nvo)
      if (lbab) go to 100
!
!     SELECT THE NEXT BASIS VECTOR AS THE LARGEST RESIDUAL VECTOR.
!     AND TEST FOR CONVERGENCE ON THE LARGEST RESIDUE.
      nres = 0
      test2 = 0.D0
      do ivar = 1, nvar_nvo
        if (lconv(ivar)) cycle
!     GET ONE NOT-CONVERGED RESIDUAL VECTOR (# IVAR),
!     STORED IN WORK.
        call mxm (ab, minear, bcoef(ilast*(ivar-1)+1), ilast, work, 1)
        test = 0.D0
        do i = 1, minear
          work(i) = f(i,ivar) - work(i)
          test = max(abs(work(i)),test)
        end do
        if (debug) write (iw, *) ' TEST:', test
        test2 = max(test2,test)
        if (test <= throld) then
          lconv(ivar) = .TRUE.
          if (nvar_nvo == 1) go to 100
          cycle
        else if (ilast + nres == maxite) then
!
!   COMPLETELY OUT OF STORAGE
!
          fail = nres == 0
          exit
        else if (ilast + nres >= maxite - 1) then
!        RUNNING OUT OF STORAGE
          if (test <= max(0.01D0,throld*2)) then
            lconv(ivar) = .TRUE.
            cycle
          end if
        else
!        STORE THE FOLLOWING RESIDUE IN AB(CONTINUED).
          nres = nres + 1
          call dcopy (minear, work, 1, ab(1,ilast+nres), 1)
        end if
      end do
      if (nres == 0) go to 100
!     FIND OPTIMUM FOLLOWING SUBSET, ADD TO B AND LOOP.
      ifirst = ilast + 1
      call deri21 (ab(1,ifirst), nres, minear, nres, work, work(nres*nres+1)&
        , b(1,ifirst), nadd)
      ilast = ilast + nadd
      go to 30
!
!     CONVERGENCE ACHIEVED OR HALTED.
!     -------------------------------
!
  100 continue
      nbsze = nbsize
      if (debug .or. lbab) then
        write (iw, &
      '('' RELAXATION ENDED IN DERI2 AFTER'',I3,'' CYCLES''/'' REQUIRED CONVERGENCE&
      & THRESHOLD ON RESIDUALS =''    ,F12.9/'' HIGHEST RESIDUAL ON'',I3,&
      & '' GRADIENT COMPONENTS = ''    ,F12.9)') ilast - nbsze, &
          throld, nvar_nvo, test2
        if (ilast - nbsze == 0) then
          write (iw, '(A)') &
            ' ANALYTIC C.I. DERIVATIVES DO NOT WORK FOR THIS SYSTEM'
          write (iw, '(A)') ' ADD KEYWORD ''NOANCI'' AND RESUBMIT'
          call mopend (&
       'ANALYTIC C.I. DERIVATIVES DO NOT WORK FOR THIS SYSTEM.  ADD &
       & KEYWORD "NOANCI" AND RESUBMIT')
          goto 99
        end if
        if (debug) then
          time2 = seconds(1)
          write (iw, &
            '('' ELAPSED TIME IN RELAXATION'',F15.3,'' SECOND'')') time2 - time1
        end if
      end if
      if (fail) then
        write (iw, '(A)') ' ANALYTICAL DERIVATIVES TOO INACCURATE FOR THIS'
        write (iw, '(A)') ' WORK.  JOB STOPPED HERE.  SEE MANUAL FOR IDEAS'
        call mopend (&
       'ANALYTICAL DERIVATIVES TOO INACCURATE FOR THIS WORK.  JOB STOPPED HERE. &
       & SEE MANUAL FOR IDEAS')
        goto 99
      else
        nbsize = 0
!        UNSCALED SOLUTION SUPERVECTORS, STORED IN F.
        if (ilast /= 0) call mxm (b, minear, bcoef, ilast, f, nvar_nvo)
        do j = 1, nvar_nvo
          f(:minear,j) = f(:minear,j)*scalar(:minear)
        end do
!        FOCK MATRIX DIAGONAL BLOCKS OVER C.I-ACTIVE M.O.
!        STORED IN FB.
        if (ilast /= 0) call mxm (fci, ninear, bcoef, ilast, fb, nvar_nvo)
      end if
!
!     * * * STEP 3 * * *
!     FINAL LOOP (390) ON THE GEOMETRIC VARIABLES.
!     --------------------------------------------
!
      do ivar = 1, nvar_nvo
!
!     C.I-ACTIVE M.O DERIVATIVES INTO THE M.O BASIS,
!         RETURNED IN AB (N,NELEC+1,...,NELEC+NMOS).
!     C.I-ACTIVE EIGENVALUES DERIVATIVES,
!         RETURNED IN BCOEF(NELEC+1,...,NELEC+NMOS).
        call deri23 (f(1,ivar), fd(1,ivar), eigs, fb(ninear*(ivar-1)+1,1), ab, &
          bcoef, ninear, minear)
!
!     DERIVATIVES OF THE 2-ELECTRONS INTEGRALS OVER C.I-ACTIVE M.O.
!     STORED IN /XYIJKL/.
      iindex = Mod (norbs*nelec+1, minear)
      jindex = (norbs*nelec+1) / minear + 1
      if (iindex == 0) then
        iindex = minear
        jindex = jindex - 1
      end if
        call dijkl2 (ab(iindex, jindex))
        if (debug) then
          write (iw, '('' * * * GRADIENT COMPONENT NUMBER'',I4)') ivar
          if (index(keywrd,'DEBU') /= 0) then
            write (iw, &
      '('' C.I-ACTIVE M.O. DERIVATIVES IN M.O BASIS'','', IN ROW.'')')
            l = norbs*nelec + 1
            do i = nelec + 1, nelec + nmos
              write (iw, '(8F10.4)') (ab(mod(k-1, minear) + 1, (k-1)/minear + 1),k=l,l + norbs - 1)
              l = l + norbs
            end do
          end if
          write (iw, &
      '('' C.I-ACTIVE FOCK EIGENVALUES RELAXATION (eigs.V.)'')')
          write (iw, '(8F10.4)') (bcoef(i),i=nelec + 1,nelec + nmos)
          write (iw, '('' 2-ELECTRON INTEGRALS RELAXATION (eigs.V.)'',2/ &
          &''    I    J    K    L       d<I(1)J(1)|K(2)L(2)> RELAXATION ONLY'')')
          do i = 1, nmos
            do j = 1, i
              do k = 1, i
                ll = k
                if (k == i) ll = j
                do l = 1, ll
                  write (iw, '(4I5,F20.10)') nelec + i, nelec + j, nelec + k, &
                    nelec + l, xy(i,j,k,l)
                end do
              end do
            end do
          end do
        end if
!
!     BUILD THE C.I MATRIX DERIVATIVE, STORED IN AB.
        call mecid (bcoef(1+nelec), gse, work(lab+1), work, xy)
        call mecih (work, ab, nmos, lab, xy)
!     RELAXATION CORRECTION TO THE C.I ENERGY DERIVATIVE.
        sum = 0.D0
        if (gse > 1.d10) sum = -sum ! dummy use of gse
        do i = 1, nstate
          j = (i - 1)*lab + 1
          call supdot (work, ab, vectci(j), lab)
          sum = sum + ddot(lab,vectci(j),1,work,1)
        end do
        dxyzr(ivar) = dxyzr(ivar) + sum*const/nstate
        if (.not.debug) cycle
        write (iw, &
          '('' RELAXATION OF THE GRADIENT COMPONENT'',F10.4, '' KCAL/MOLE'')') &
          ddot(lab,vectci,1,work,1)*const
!
!     THE END .
      end do
      if (debug) write (iw, &
      '('' ELAPSED TIME IN C.I-ENERGY RELAXATION'',F15.3,'' SECOND'')') seconds(1) - time2
  99  deallocate(bab, babinv)
      return
      end subroutine deri2

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

subroutine lower (a, n)
  implicit none
  character(len=*), intent(inout) :: a
  integer, intent(in) :: n
  integer :: i, j, lowa, lupa, lupz
  intrinsic Char, Ichar
  lowa = Ichar ("a")
  lupa = Ichar ("A")
  lupz = Ichar ("Z")
  do i = 1, n
    if (Ichar (a(i:i))>=lupa .and. Ichar (a(i:i))<=lupz) then
      j = Ichar (a(i:i)) + lowa - lupa
      a(i:i) = Char(j)
    end if
  end do
end subroutine lower

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine molsym(coord, ierror, r)
      use common_arrays_C, only : nat, nbonds, ibonds
      use symmetry_C, only : ielem, cub, name
      use chanel_C, only : iw
      use molkst_C, only : numat, keywrd, moperr
      implicit none
      integer , intent(out) :: ierror
      double precision  :: coord(3,numat)
      double precision  :: r(3,3)
      integer , dimension(6) :: icyc
      integer :: i, j, k, l, ij, iturn, iqual, kndex, icheck, naxes, iz, ix, iy
      double precision, dimension(6) :: f
      double precision, dimension(3) :: ew, help
      double precision, dimension(3,3) :: rhelp
      double precision, dimension(3) :: shift
      double precision :: toler, wmol, sum, rxy, tole, distxy, rmin, sina, &
        cosa, theta, total
      logical :: linear, cubic, axis, sphere, debug, reorie, iscube, used(10)
!***************************************************************
!                                                              *
!     Credits not yet written                                  *
!                                                              *
!***************************************************************
!
!    MOLSYM CALCULATES THE MOLECULAR SYMMETRY AS A POINT-GROUP SYMBOL
!
      debug = index(keywrd,' MOLSYM') /= 0
!
!   REORIE IS NORMALLY .TRUE.   IF SET .FALSE., THEN THE ORIENTATION
!   SUPPLIED WILL BE USED IN DETERMINING SYMMETRY
!
      ew = 0.d0
      reorie = index(keywrd,' NOREOR') == 0
      toler = 0.1D0
      ierror = 0
      kndex = 0
      name = '????'
      do i = 1, 3
        cub(i,:) = 0.D0
        cub(i,i) = 1.D0
      end do
!
!  Now to put all the symmetry operations into the array ELEM
!   In order, the operations in ELEM are
!
!   1 C2(X)       6 Sigma(YZ)   11 C6    16 S8
!   2 C2(Y)       7 inversion   12 C7    17 S10
!   3 C2(Z)       8 C3          13 C8    18 S12
!   4 Sigma(XY)   9 C4          14 S4    19 1 if cubic, 0 otherwise.
!   5 Sigma(XZ)  10 C5          15 S6    20 1 if infinite, 0 otherwise.
!
!
      do i = 1, 18
        call bldsym (i, i)
        ielem(i) = 0
      end do
      ielem(19) = 0
      ielem(20) = 0
!
!   Calculate Moments of Inertia and Axes of Inertia.
!   First, center the molecule.
!
      shift = 0.D0
      wmol = 0.D0
      do i = 1, numat
        wmol = wmol + nat(i)
        shift = shift + nat(i)*coord(:,i)
      end do
      ij = 0
      do i = 1, 3
        shift(i) = shift(i)/wmol
        coord(i,:numat) = coord(i,:numat) - shift(i)
        do j = 1, i
          ij = ij + 1
          f(ij) = ij*1.D-8
          do k = 1, numat
            f(ij) = f(ij) + nat(k)*coord(i,k)*coord(j,k)
          end do
        end do
      end do
      iscube = .true.
      do
      if (.not.reorie) then
!
!     USE ORIENTATION AS SUPPLIED
!
!     FOR SYMMETRY, ORIENTATION IS: Z=PRINCIPAL AXIS, X,Y=SECONDARY
!
!      WRITE(IW,*)'H IN MOLSYM'
        sum = 0.D0
        do i = 1, 5
          sum = sum + abs(f(i))
        end do
        linear = sum < 0.01D0
        sphere = linear .and. abs(f(6))<0.01D0
        cubic = abs(f(1)-f(3))<0.01D0 .and. &
                abs(f(1)-f(6))<0.01D0 .and. &
                abs(f(2))+abs(f(4))+abs(f(5))<0.01D0
        do i = 1, 3
          r(i,:) = 0.D0
          r(i,i) = 1.D0
        end do
      else
        call rsp (f, 3, ew, r)
        sum = r(1,1)*(r(2,2)*r(3,3)-r(3,2)*r(2,3)) + &
              r(1,2)*(r(2,3)*r(3,1)-r(2,1)*r(3,3)) + &
              r(1,3)*(r(2,1)*r(3,2)-r(2,2)*r(3,1))
        if (sum > 1.d0) then
          sum = 1.01D0
          do j = 1, 3
            if (r(j,j) >= sum) cycle
            sum = r(j,j)
            i = j
          end do
          r(:,i) = -r(:,i)
        end if
        r(1,3) = r(2,1)*r(3,2) - r(3,1)*r(2,2)
        r(2,3) = r(3,1)*r(1,2) - r(1,1)*r(3,2)
        r(3,3) = r(1,1)*r(2,2) - r(2,1)*r(1,2)
!
!   Determine if molecule belongs to a special group
!
        linear = ew(2) < 1.D-2
        sphere = ew(3) < 1.D-2
        cubic = ew(3) - ew(1) < 5.D-3*max(ew(3),40.D0)
      end if
      if (sphere) then
!
!   Set flags 8 and 12 simultaneously to 1 - impossible for
!   non-spherical systems.
!
        ielem(7) = 1
        ielem(8) = 1
        ielem(10) = 1
        ielem(20) = 1
!
!  Make sure that C5 axis is different from C3 - this eliminates
!  accidental degeneracy.
!
        cub = 0.D0
        cub(1,2) = 1.D0
        cub(2,3) = 1.D0
        cub(3,1) = 1.D0
        go to 270
      else if (linear) then
!
!   Molecule is C-infinity-v or D-infinity-h
!
        call symopr (numat, coord, 1, r)
        ielem(20) = 1
        go to 250
      end if
      if (reorie) then
        if (.not.cubic .and. ew(3) - ew(2) < 1.D-2*ew(3)) then
!
!   Molecule has two-fold degeneracy ( Cn, Cnv, Dn, Dnh, Sn, n>2)
!
          do i = 1, 3
            rxy = -r(i,1)
            r(i,1) = r(i,3)
            r(i,3) = rxy
          end do
          rxy = ew(1)
          ew(1) = ew(3)
          ew(3) = rxy
        end if
        axis = abs(ew(1) - ew(2)) < 0.01D0*ew(2)
      else
        axis = abs(f(1) - f(3)) < 0.01D0*f(6)
      end if
!
!   Is there a plane of symmetry perpendicular to the Z axis?
!
      call symopr (numat, coord, 1, r)
      if ( .not. cubic) go to 1100
        ielem(19) = 1
        call plato (coord, r, cubic)
        if (moperr) return
      if ( .not. iscube .or. cubic) go to 1000
         !
         !  Three moments of inertia were equal, but the system does
         !  not have cubic symmetry.  Use an additional test to check
         !  for cubic nature.
         !
        do i = 1, 6
          f(i) = 0.d0
        end do
        ij = 0
        do i = 1, 3
          do j = 1, i
            ij = ij + 1
            f(ij) = ij * 1.d-8
            do k = 1, numat
              sum = 0.d0
              do l = 1, numat
                sum = sum + Sqrt ((coord(1, k)-coord(1, l))**2 + &
                                  (coord(2, k)-coord(2, l))**2 + &
                                  (coord(3, k)-coord(3, l))**2)
              end do
              f(ij) = f(ij) + sum * coord(i, k) * coord(j, k)
            end do
          end do
        end do
         !
         !  All species of this type (pseudo-cubic) have similar
         !  moments of inertia.  Increase the relative difference of
         !  the moments.
        f(1) = f(1) - 0.8d0 * f(1)
        f(3) = f(3) - 0.8d0 * f(1)
        f(6) = f(6) - 0.8d0 * f(1)
         !
         !  Reset IELEM(19) - system is NOT cubic!
         !
        ielem(19) = 0
        iscube = .false.
    end do
   !
   !   Set flags 8 and 12 simultaneously to 1 - impossible for
   !   non-spherical systems.
   !
    ielem(7) = 1
    ielem(8) = 1
    ielem(10) = 1
    ielem(20) = 1
   !
   !  Make sure that C5 axis is different from C3 - this eliminates
   !  accidental degeneracy.
   !
    do i = 1, 3
      do j = 1, 3
        cub(i, j) = 0.d0
      end do
    end do
    cub(1, 2) = 1.d0
    cub(2, 3) = 1.d0
    cub(3, 1) = 1.d0
    go to 270
1000 if (moperr) return
1100 if (axis) then
!
!  Molecule has degeneracy.  At this point, the Z-axis is
!  defined.  The molecule is Cn Cnv Cnh Dn, etc, or a special group,
!  e.g. Td, Oh, Ih.
!
  130   continue
        iturn = 7
        j = 0
!
!   Check for the existance of a Cn(2<n<9) or Sn(1<0.5*n<7)
!
        do i = 8, 18
!
!   Make certain that TOLE gets tighter as the n in Cn increases.
!
          if (i < 14) then
            tole = toler*9.D0/(i - 5)**2
          else
            tole = toler*16.D0/(2*i - 24)**2
          end if
          call chi (tole, coord, i, iqual)
!
!   If Cn, then set ITURN = n  (Remember ELEM(8) is C3, therefore offset
!                               by 5)
!
          if (ielem(i)/=1 .or. i>=14) cycle
          if (iturn > 9) then
            toler = toler*0.5D0
            go to 130
          end if
          iturn = i
        end do
        if (ielem(14) + ielem(15) + ielem(17) > 1 .or. &
            ielem(15) + ielem(16) + ielem(17) > 1 .or. &
            ielem(16) + ielem(17) + ielem(18) > 1) then
          toler = toler*0.5D0
          go to 130
        end if
        iturn = iturn - 5
        if (debug) then
          write (iw, '(A)') ' after checking 8-18'
          write (iw, '(20I3)') ielem
        end if
!
!  Now use two adjacent equivalent atoms, not on the
!  Z axis, to define the X-axis.
!
        do i = 1, numat
          distxy = coord(1,i)**2 + coord(2,i)**2
          if (distxy < toler) cycle
!
!   Atom I is the first atom.
!
          rmin = 1000.D0
          kndex = 0
          do j = i + 1, numat
            if (abs(abs(coord(3,i)) - abs(coord(3,j))) > 0.2D0) cycle
            rxy = coord(1,j)**2 + coord(2,j)**2
            if (abs(rxy - distxy) > toler .or. nat(i) /= nat(j)) cycle
!
!   Atoms i and j are equidistant from the Z axis, and are of the same type.
!   Now check that the atoms connected to them are also identical.
!
            if (nbonds(i) /= nbonds(j)) cycle
            used(:nbonds(i)) = .false.
            do k = 1, nbonds(i)
              do l = 1, nbonds(j)
                if (nat(ibonds(k,i)) == nat(ibonds(l,j)) .and. .not. used(l)) exit
              end do
              if (l <= nbonds(i)) used(l) = .true.
            end do
            l = 0
            do k = 1, nbonds(i)
              if (used(k)) l = l + 1
            end do
            if (l < nbonds(i)) cycle
            rxy = (coord(1,i) - coord(1,j))**2 + (coord(2,i) - coord(2,j))**2
            if (rxy > rmin) cycle
            kndex = j
            rmin = rxy
          end do
!
!   Atom KNDEX is the second, adjacent, atom, equivalent to I.
!
          exit
        end do
        if (kndex < 1) then
!
!  System does not have a Cn axis!  Go back and treat it as an Abelian
!  system.
!
          axis = .FALSE.
          go to 190
        end if
        help(1) = coord(1,i) + coord(1,kndex)
        help(2) = coord(2,i) + coord(2,kndex)
        distxy = sqrt(help(1)**2+help(2)**2)
        sina = help(2)/distxy
        cosa = help(1)/distxy
        call rotmol (numat, coord, sina, cosa, 1, 2, r)
!
!   Is there a Sigma(XZ) plane of symmetry?
!
        call chi (toler, coord, 5, iqual)
        if (ielem(5) /= 1) then
!
!    Is there a C2(X) axis of rotation?
!
          call chi (toler, coord, 1, iqual)
          if (ielem(1) /= 0) then
!
!    Check for an improper axis of rotation.
!
            theta = 1.5707963268D0/dble(iturn)
            sina = sin(theta)
            cosa = cos(theta)
            icheck = 0
  180       continue
            call rotmol (numat, coord, sina, cosa, 1, 2, r)
            if (icheck > 0) then
              axis = (iturn /= 2)
              go to 190
            end if
            call chi (toler, coord, 5, iqual)
            if (ielem(5) > 0) go to 190
            icheck = 1
            sina = -sina
            go to 180
          end if
        end if
      end if
  190 continue
      if (cubic) call orient (numat, coord, r)
      if (debug) then
        write (iw, '(A)') ' C2 and sigma-v     '
        write (iw, '(20I3)') ielem
      end if
      if (.not.axis) then
        toler = 0.2D0
!
!   Molecule belongs to one of the 8 Abelian groups
!   (C1, C2, Ci, Cs, C2v, D2, C2h, or D2h)
!
        do i = 1, 6
          call chi (toler, coord, i, iqual)
          icyc(i) = (1 + iqual)*ielem(i)
        end do
        if (reorie) then
          naxes = ielem(1) + ielem(2) + ielem(3)
!
!    Special handling for the Abelian Groups:  Determine
!    the principal axis by atom counts.
!
          if (naxes <= 1) then
            iz = 1
            if (ielem(1) == 1) go to 220
            iz = 2
            if (ielem(2) == 1) go to 220
            iz = 3
            if (ielem(3) == 1) go to 220
            if (icyc(5) > icyc(4)) iz = 2
            if (icyc(6) > icyc(7-iz)) iz = 1
            go to 220
          end if
          iz = 1
          if (icyc(2) > icyc(1)) iz = 2
          if (icyc(3) > icyc(iz)) iz = 3
  220     continue
          icyc(7-iz) = -1
          ix = 1
          if (icyc(5) > icyc(6)) ix = 2
          if (icyc(4) > icyc(7-ix)) ix = 3
          iy = 6 - ix - iz
!
!  Whew!   Now to re-orient the molecule so the the principal
!  axis is 'Z'
!
          rhelp(:,1) = r(:,ix)
          rhelp(:,2) = r(:,iy)
          rhelp(1,3) = r(2,ix)*r(3,iy) - r(3,ix)*r(2,iy)
          rhelp(2,3) = r(3,ix)*r(1,iy) - r(1,ix)*r(3,iy)
          rhelp(3,3) = r(1,ix)*r(2,iy) - r(2,ix)*r(1,iy)
          call symopr (numat, coord, -1, r)
          r = rhelp
          call symopr (numat, coord, 1, r)
        end if
!
!   And re-calculate the first 7 Characters.
!   (C2(X), C2(Y), C2(Z), Sigma(XY), Sigma(XZ), Sigma(YZ), i)
!
      end if
  250 continue
      do i = 1, 7
        call chi (toler, coord, i, iqual)
      end do
      if (debug) then
        write (iw, '(A)') ' After re-doing 1-7'
        write (iw, '(20I3)') ielem
      end if
  270 continue
      call symopr (numat, coord, -1, r)
      total = ew(1) + ew(2) + ew(3)
      ew = total - ew
      call cartab
      return
      end subroutine molsym
      subroutine chi(toler, coord, ioper, iqual)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use symmetry_C, only : ielem, elem, jelem
      use molkst_C, only : numat
      use common_arrays_C, only : nat
!***********************************************************************
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: ioper
      integer , intent(out) :: iqual
      double precision , intent(in) :: toler
      double precision , intent(in) :: coord(3,numat)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: iresul, i, j
      double precision, dimension(3) :: help
!-----------------------------------------------
!***********************************************************************
!
!   CHI RETURNS A '1' IN IELEM(IOPER) IF THE SYMMETRY OPERATION ELEM(IOP
!       LEAVES THE SYSTEM UNCHANGED.  OTHERWISE CHI RETURNS '0' IN IELEM
!
!   ON INPUT: COORD        = CARTESIAN COORDINATES
!             IOPER        = SYMMETRY OPERATION TO BE PERFORMED
!             ELEM         = SYMMETRY OPERATORS AS 3*3 MATRICES
!   ON OUTPUT IELEM(IOPER) = 1 OR 0.
!
!***********************************************************************
      iresul = 1
      iqual = 0
      l20: do i = 1, numat
        help(1) = coord(1,i)*elem(1,1,ioper) + &
                  coord(2,i)*elem(1,2,ioper) + &
                  coord(3,i)*elem(1,3,ioper)
        help(2) = coord(1,i)*elem(2,1,ioper) + &
                  coord(2,i)*elem(2,2,ioper) + &
                  coord(3,i)*elem(2,3,ioper)
        help(3) = coord(1,i)*elem(3,1,ioper) + &
                  coord(2,i)*elem(3,2,ioper) + &
                  coord(3,i)*elem(3,3,ioper)
        do j = 1, numat
          if (nat(i) /= nat(j)) cycle
          if (abs(coord(1,j)-help(1)) > toler) cycle
          if (abs(coord(2,j)-help(2)) > toler) cycle
          if (abs(coord(3,j)-help(3)) > toler) cycle
          jelem(ioper,i) = j
          if (i == j) iqual = iqual + 1
          cycle  l20
        end do
        iresul = 0
      end do l20
      ielem(ioper) = iresul
      return
      end subroutine chi
      subroutine makopr(numat, coord, ierror, r)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use symmetry_C, only : ielem, jy, nclass
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: numat
      integer , intent(out) :: ierror
      double precision  :: coord(3,numat)
      double precision  :: r(3,3)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, iqual
      double precision :: toler
!-----------------------------------------------
!*********************************************************************
!
!   MAKOPR builds the operations based on the point group
!          of the system.  A check is made to verify that the
!          operations are valid.
!
!*********************************************************************
      call symopr (numat, coord, 1, r)
      if (nclass < 2) return
!
!   NCLASS is the number of Classes in the Group.
!   Construct the Operations corresponding to the Classes
!   These are stored in ELEM.
!
      do i = 2, nclass
        call bldsym (jy(i), i)
      end do
!
!   Use a more tolerant criterion for recognizing operations because
!   the point-group has already been identified.
!
      toler = 0.2D0
      do i = 2, nclass
        call chi (toler, coord, i, iqual)
        if (ielem(i) >= 1) cycle
        ierror = 5
      end do
      call symopr (numat, coord, -1, r)
      if (iqual < 0) return ! dummy use of iqual
      return
      end subroutine makopr
      subroutine orient(numat, coord, r)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use symmetry_C, only : cub, ielem
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: numat
      double precision  :: coord(3,numat)
      double precision  :: r(3,3)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, jota, iqual, j
      double precision, dimension(2) :: wink
      double precision :: toler, wink2, sina, cosa, sinb, cosb

      save wink, toler
!-----------------------------------------------
!***********************************************************************
!
!    ORIENT is part of the SYMMETRY package
!           In cubic systems the three moments of inertia are identical.
!           Therefore, use the nearest atom to the center to determine
!           the principal axis (Z)
!
!**********************************************************************
      data toler/ 0.1D0/
      data wink(1), wink(2)/ 0.955316618125D0, 0.65235813978437D0/
!
!   WINK(1) rotates a cubic molecule through half the tetrahedral angle.
!   WINK(2) does something similar for an icosahedral system.
!
!   WINK(1)=ACOS(SQRT(1/3))
!   WINK(2)=ACOS((47+21*SQRT(5))/(75+33*SQRT(5)))
!           = angle from a vertex of an icosahedron to the center and th
!             to the middle of the triangular face
!           = 37.377366 degrees
!
!
      wink2 = 0.D0
      if (ielem(8) >= 1) then
!
!   Check for a S4 or C5 axis
!
        do i = 1, 2
          jota = 18 - 4*i
          wink2 = wink(i)
          sina = sin(wink2)
          cosa = cos(wink2)
          call rotmol (numat, coord, sina, cosa, 1, 3, r)
          call chi (toler, coord, jota, iqual)
          if (ielem(jota) > 0) exit
          if (i == 1) then
            call chi (toler, coord, 3, iqual)
            if (ielem(3) == 1) exit
          end if
          wink2 = -wink2
          sinb = sin(2.D0*wink2)
          cosb = cos(2.D0*wink2)
          call rotmol (numat, coord, sinb, cosb, 1, 3, r)
          call chi (toler, coord, jota, iqual)
          if (ielem(jota) > 0) exit
          if (i == 1) then
            call chi (toler, coord, 3, iqual)
            if (ielem(3) == 1) exit
          end if
          call rotmol (numat, coord, sina, cosa, 1, 3, r)
        end do
        call chi (toler, coord, 9, iqual)
!
!   Check on all IELEM registers
        if (ielem(10) > 0) call chi (toler, coord, 17, iqual)
      else
!
!   No C3 axis, therefore not T, Td, Th, O, or Oh.
!
        wink2 = -wink(1)
        if (ielem(10) > 0) wink2 = -wink(2)
        sina = -sin(wink2)
        cosa = cos(wink2)
        call rotmol (numat, coord, sina, cosa, 1, 3, r)
        call chi (toler, coord, 8, iqual)
        call rotmol (numat, coord, (-sina), cosa, 1, 3, r)
        if (ielem(8) <= 0) then
          if (ielem(9) <= 0) then
            wink2 = -wink2
          else
            call rotmol (numat, coord, 0.707106781186D0, 0.707106781186D0, 1, 2, r)
          end if
        end if
      end if
      j = sum(ielem(:17))
      if (j==2 .and. ielem(1)+ielem(8)==2) return
      cub(1,1) = cos(wink2)
      cub(3,3) = cub(1,1)
      cub(1,3) = sin(wink2)
      cub(3,1) = -cub(1,3)
      call mult33 (cub, 8)
      call mult33 (cub, 15)
      call chi (toler, coord, 8, iqual)
      j = iqual ! dummy use of iqual
      call chi (toler, coord, 15, iqual)
      if (j + iqual == 0) return ! dummy use of iqual
      return
      end subroutine orient
      subroutine plato(coord, r, cubic)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use chanel_C, only : iw
      use molkst_C, only : numat
      use common_arrays_C, only : nat
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      logical, intent(out) :: cubic
      double precision  :: coord(3,numat)
      double precision  :: r(3,3)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(numat) :: near
      integer , dimension(3) :: ipoly
      integer ::  i, l, j, ii, k, i1, j1, m, i3, i2, ligand_type, &
      store_ligand, j2, k1, k2
      double precision, dimension(3) :: allr
      double precision, dimension(3,3) :: xyz
      double precision :: toler = 0.1d0, xmin, dist, r2j, angle, sum, buff, buff1, &
      rmin, ymin, dist1, dist2

      save toler
!-----------------------------------------------
!***********************************************************************
!
!    PLATO  is part of the SYMMETRY package.  It generates the
!           unitary transform which will orientate the system
!           so that the 'Z' axis is an axis of rotation.
!
!    PLATO is called when the system belongs to a cubic point group.
!          Atoms nearest to the center of symmetry are identified.
!          If there are 4, 6, 8, 12, or 20, then they outline one
!          of the Platonic solids (tetrahedron, octahedron, cube,
!          icosahedron, or pentagonal dodecahedron).  In that case,
!          each atom lies on a 3, 4, or 5 fold symmetry axis.
!
!          In other cases the axis of symmetry lies goes through a
!          regular polygon, either an equilateral triangle, a square,
!          or a regular pentagon.
!
!          The unitary transform is returned through R.
!
!**********************************************************************
      call symopr (numat, coord,-1, r)
      rmin = 0.1d0
      xmin = 0.d0
      ymin = 0.d0
      store_ligand = 0
      ligand_type = 0
      k = 100
      do
  !
  !   Find the smallest number of atoms that are at the same distance
  !   from the center.  This is done by steadily moving out, rmin, from the center,
  !   and counting the number of atoms in the shell.  The minimum number of atoms, k,
  !   is at a distance of ymin.
  !
      do i = 1, numat
        xmin = coord(1, i) ** 2 + coord(2, i) ** 2 + coord(3, i) ** 2
        if (xmin >= rmin) then
          ligand_type = nat(i)
          exit
        end if
      end do
      if (xmin < rmin) then
        xmin = ymin
        exit
      end if
  !
  !  How many atoms are at the same distance from the center?
  !
      l = 0
      do i = 1, numat
        dist = coord(1, i) ** 2 + coord(2, i) ** 2 + coord(3, i) ** 2
        if (Abs(dist - xmin) < toler .and. nat(i) == ligand_type) l = l + 1
      end do
  !
  !  The current "shell" has less than an earlier shell, therefore use it.
  !
      if (l < k) then
        k = l
        ymin = xmin
        store_ligand = ligand_type
      end if
  !
  !  l cannot be less than 4 (a tetrahedron)
  !
      if (l < 5) exit
  !
  ! Increase the value of rmin to start the check of the next shell
  !
      rmin = xmin + 2.d0*toler
      end do
  !
  !  How many atoms are at the same distance from the center?
  !
      ligand_type = store_ligand
      l = 0
      do i = 1, numat
        dist = coord(1, i) ** 2 + coord(2, i) ** 2 + coord(3, i) ** 2
        if (dist >= toler .and. dist <= xmin+toler) then
          if (Abs (dist-xmin) < toler .and. nat(i) == ligand_type) then
            l = l + 1
            near(l) = i
          end if
        end if
      end do
      if (l /= 0) then
        if (l == 1) then
  !
  !  System was identified as cubic because of moments of inertia only.
  !  This was a coincidence.  Correct error and continue
  !
          cubic = .false.
          return
        end if
        if (l == 4 .or. l == 6 .or. l == 8 .or. l == 12 .or. l == 20) then
           !
           !   How many near neighbors has atom NEAR(1) got?
           !
          xmin = 10000.d0
          j = near(1)
          do ii = 2, l
            i = near(ii)
            dist = (coord(1, j)-coord(1, i)) ** 2 + &
                   (coord(2, j)-coord(2, i)) ** 2 + &
                   (coord(3, j)-coord(3, i)) ** 2
            if (dist < xmin) then
              xmin = dist
            end if
          end do
          j1 = near(1)
          j2 = near(2)
          k1 = 0
          k2 = 0
          do ii = 1, l
            i = near(ii)
            dist1 = (coord(1, j1)-coord(1, i)) ** 2 + &
                    (coord(2, j1)-coord(2, i)) ** 2 + &
                    (coord(3, j1)-coord(3, i)) ** 2
            dist2 = (coord(1, j2)-coord(1, i)) ** 2 + &
                    (coord(2, j2)-coord(2, i)) ** 2 + &
                    (coord(3, j2)-coord(3, i)) ** 2
            if (Abs (dist2-xmin) < toler) then
              k2 = k2 + 1
            end if
            if (Abs (dist1-xmin) < toler) then
              k1 = k1 + 1
            end if
          end do
          if (k1 == k2) then
            k = k1
          else if (k1 > 2 .or. k2 > 2) then
              !
              !  There are no cubic solids that (a) have three or more equidistant
              !  vertices and (b) are not platonic
              !
            cubic = .false.
            return
          else
            k = 0
          end if   !   # points    #neighbors   Polyhedron
  !
          if (          l == 4  .and. k == 3 &  !   Tetrahedron
          .or.          l == 6  .and. k == 4 &  !   Cube
          .or.          l == 8  .and. k == 3 &  !   Octahedron
          .or.          l == 12 .and. k == 5 &  !   Icosahedron
          .or.          l == 20 .and. k == 3 &  !   Pentagonal dodecahedron
          ) then
              !
              !     The system is a Platonic solid.  This is the simplest case.
              !     An atom lies on a high-symmetry axis.
              !
            i = near(l)
            r(1, 3) = coord(1, i) / dist
            r(2, 3) = coord(2, i) / dist
            r(3, 3) = coord(3, i) / dist
            go to 1100
          end if
        end if
        !
        !  Pick one atom (here NEAR(1)), and find the three nearest
        !  neighbors in the same set.  Put these in IPOLY(1:3).
        !
        i1 = near(1)
        do i = 1, 3
          xmin = 10000.d0
          ipoly(i) = 0
          loop: do j1 = 2, l
            j = near(j1)
            do m = 1, i - 1
              if (ipoly(m) == j) cycle loop
            end do
            r2j = (coord(1, i1)-coord(1, j)) ** 2 + (coord(2, i1)-coord(2, j)) &
           & ** 2 + (coord(3, i1)-coord(3, j)) ** 2
            if (xmin > r2j) then
              xmin = r2j
              ipoly(i) = j
              allr(i) = r2j
              if (xmin < 0.01d0) then
                write (iw,*) " Geometry is apparently cubic, but the distance"
                write (iw, "(A,I5,A,I5,A,F12.8,A)") " between atoms", i1, " and",&
               &  j, " is", Sqrt (xmin), " Angstroms"
                write (iw, "(/,A,/)") " Here is the current geometry"
                call geout (iw)
                call mopend("Geometry is severely faulty")
                return
              end if
            end if
          end do loop
        end do
        do i = 1, 3
          allr(i) = Sqrt (allr(i))
        end do
        if (ipoly(1)*ipoly(2)*ipoly(3) == 0) then
  !
  !  System is obviously not cubic.
  !
          cubic = .false.
          return
        end if
        !
        !   Identify the two atoms in the regular polygon.
        !
        do i = 1, 2
          do j = i + 1, 3
            if (Abs (allr(i)-allr(j)) < 0.01d0) go to 1000
          end do
        end do
        !
        !  There are not many cubic solids in which a vertex nearest to
        !  the center has three neighbors all at different distances.
        !  Since this is very rare, relative to the number of truly non-
        !  cubic systems, ignore all such cases.
        !
        cubic = .false.
        return
1000  do k = 1, 3
          xyz(k, 3) = coord(k, ipoly(i))
          xyz(k, 2) = coord(k, ipoly(j))
          xyz(k, 1) = coord(k, i1)
        end do
        i3 = ipoly(i)
        i2 = ipoly(j)
        ipoly(1) = i3
        ipoly(2) = i2
        call bangle (xyz, 3, 1, 2, angle)
        if (Abs (angle-1.0472d0) < 0.1d0) then
           !
           !   It's a triangle!
           !
          do i = 1, 3
            r(i, 3) = coord(i, i1) + coord(i, i2) + coord(i, i3)
          end do
        else if (Abs (angle-1.5707963d0) < 0.1d0) then
           !
           !   It's a square!
           !
          do i = 1, 3
            r(i, 3) = coord(i, i2) + coord(i, i3)
          end do
        else if (Abs (angle-1.885d0) < 0.1d0) then
           !
           !  It's a pentagon!
           !
          do i = 1, 3
            r(i, 3) = 1.6180341d0 * (coord(i, i2)+coord(i, i3)) - coord(i, i1)
          end do
        else
           !
           !  There are no cubic solids that (a) have two or more equidistant
           !  vertices and (b) these vertices are not part of a regular
           !  polygon.
           !
          cubic = .false.
          return
        end if
1100    sum = Sqrt (r(1, 3)**2+r(2, 3)**2+r(3, 3)**2)
        do i = 1, 3
          r(i, 3) = r(i, 3) / sum
        end do
        buff = Sqrt (r(1, 3)**2+r(2, 3)**2)
        buff1 = Sqrt (r(1, 3)**2+r(3, 3)**2)
        if (buff <= buff1) then
          r(1, 1) = r(3, 3) / buff1
          r(2, 1) = 0.d0
          r(3, 1) = -r(1, 3) / buff1
        else
          r(1, 1) = r(2, 3) / buff
          r(2, 1) = -r(1, 3) / buff
          r(3, 1) = 0.d0
        end if
        r(1, 2) = r(2, 3) * r(3, 1) - r(2, 1) * r(3, 3)
        r(2, 2) = r(3, 3) * r(1, 1) - r(3, 1) * r(1, 3)
        r(3, 2) = r(1, 3) * r(2, 1) - r(1, 1) * r(2, 3)
        !
        !   The molecule is now orientated along one of the high-symmetry axes
        !
        call symopr (numat, coord, 1, r)
        return
      end if
      return
      end subroutine plato
      subroutine cartab
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use symmetry_C, only : nclass, igroup, group, allrep, &
      & nallop,ntbs, ntab, nallg, name, nirred, ielem, jx, jy
      use molkst_C, only : numcal, keywrd
      use chanel_C, only : iw
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      integer, parameter :: ngps = 57
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(ngps) :: nope, nrep
      integer :: icalcn, i, j, k, l, nopers, nreprs, nstabl, kl, ku, istart, &
        igp, nzz, nz, prnt
      double precision :: buff, fz, fn
      logical :: debug, first, large
      character, dimension(20) :: class*9
      logical, external :: symdec

      save nrep, class, debug, first, icalcn, large, nope
!-----------------------------------------------
!***********************************************************************
!
! CARTAB constructs Character Tables for Point Groups.  Each Group is
!        defined by an array having the same name as the Group, e.g. C2v
!        The format of each group is explained in BLOCK TABLES
!
!
!   The Magic Number is the decimal representation of a 20-digit binary
!   number, each digit of which is '1' if the associated operation is
!   present in the system, '0' otherwise.  The 20 operations are, in
!   order
!
!  1 C2(X)         6 Sigma(YZ)    11 C6     16 S8
!  2 C2(Y)         7 inversion    12 C7     17 S10
!  3 C2(Z)         8 C3           13 C8     18 S12
!  4 Sigma(XY)     9 C4           14 S4     19 Cubic group
!  5 Sigma(XZ)    10 C5           15 S6     20 Infinite group.
!
!***********************************************************************
      data first/ .TRUE./
      data prnt/ 1/
      data class/ 'C2(x)', 'C2(y)', 'C2(z)', 'Sigma(XY)', 'Sigma(v)', &
        'Sigma(d)', 'Inversion', ' C3', ' C4', ' C5', ' C6', ' C7', ' C8', &
        ' S4', ' S6', ' S8', ' S10', ' S12', ' ?? ', 'C(Inf)'/
      data icalcn/ 0/
!
      if (numcal /= icalcn) then
        icalcn = numcal
        debug = index(keywrd,'CARTAB') /= 0
        large = index(keywrd,'LARGE')/=0 .and. debug
      end if
      large = large .and. prnt==1
      if (large) prnt = 0
      if (first) then
        first = .FALSE.
!
!   Generate array to hold addresses of groups
!
!  NOPE will apply to operations
!  NREP will apply to group name and irreducible representations
!
        nope(1) = 1
        nrep(1) = 1
        do i = 2, ngps
          nope(i) = nope(i-1) + nallop(nope(i-1)) + 4
          nrep(i) = nrep(i-1) + nallop(nope(i-1)+1) + 1
        end do
!
!   Generate array to hold addresses of character tables
!
        j = 1
        do i = 1, ntbs
          k = ntab(i)
          ntab(i) = j
          j = j + k
        end do
!
!  Use the following lines to check that the common blocks
!  have the correct sizes.
!
!#      WRITE(*,*)' Size of Groups:',NOPE(NGPS)+NALLOP(NOPE(NGPS))+3
!#      WRITE(*,*)' Size of Reps  :',NREP(NGPS)+NALLOP(NOPE(NGPS)+1)
!#      WRITE(*,*)' Size of TABLES:',J-1
      end if
!
!  Debug code:  Print all the point groups, in order
!
      if (large) then
        do i = 1, ngps
          k = nope(i)
          l = nrep(i)
          nopers = nallop(k)
          nreprs = nallop(k+1)
          nstabl = ntab(nallop(k+2))
          write (iw, *) '         Point Group: ', allrep(l)
          write (iw, "(a,i4,a,i4,a,i4,a,i9)") ' No. Ops:', nopers + 1, ' No. Reps:', &
          nreprs, ' Table:', nallop(k+2), ' "Magic" No.:', nallop(k+3)
          write (iw, '(/10X,8(A,1X))') '   Identity   ', &
          (class(nallop(j)),j=k + 4,k + 3 + nallop(k))
          write (iw, '(A,10I10)') '    '//allrep(l+1), (1,j=1,nallop(k) + 1)
          do j = 2, nreprs
            kl = nstabl + (j - 2)*(nopers + 1)
            ku = kl + nopers
            write (iw, '(A,10I10)') '    '//allrep(l+j), (nallg(k),k=kl,ku)
          end do
        end do
      end if
!
!    Identify the Point Group of the molecule.
!
      do igroup = ngps, 1, -1
        if (.not.symdec(nallop(nope(igroup)+3),ielem)) cycle
        exit
      end do
      if (index(keywrd,' NOSYM') /= 0) igroup = 1
      istart = nope(igroup)
      igp = nrep(igroup)
      name = allrep(igp)
      nclass = nallop(istart) + 1
      nirred = nallop(istart+1)
!
!  IGROUP:  The number of the point-group of the system.
!  ISTART:  Starting address of the group.
!  IGP   :  Starting address of the names used in the group.
!  NAME  :  The name of the group.
!  NCLASS:  Number of operations used to represent the group, plus 1.
!  NIRRED:  Number of Irreducible Representations.
!  GROUP :  The full point-group character table for group IGROUP.
!
      group(1,:nclass) = 1.D0
      jy(2:nclass) = nallop(istart+4:nclass+2+istart)
      jx(:nirred) = allrep(igp+1:nirred+igp)
      istart = ntab(nallop(istart+2)) - 1
      do i = 2, nirred
        do k = 1, nclass
          istart = istart + 1
          buff = nallg(istart)
          if (buff>=10.D0 .and. &
          (name/='R3' .or. name=='R3' .and. k/=1 .and. k /= nclass)) then
            nzz = nallg(istart)
            nz = nzz/10
            fz = nz
            fn = nzz - 10*nz
            buff = 2.D0*cos(6.283185307179D0*fn/fz)
          end if
          group(i,k) = buff
        end do
      end do
      jy(1) = 0
      if (debug) then
        write (iw, '(2A)') ' Character Table for Group  ', name
        write (iw, '(7X,10A10)') '   E    ', (class(jy(k)),k=2,nclass)
        do i = 1, nirred
          write (iw, '(A4,10F10.4)') jx(i), (group(i,k),k=1,nclass)
        end do
      end if
      return
      end subroutine cartab
      logical function symdec (n1, ielem)
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n1
      integer , intent(in) :: ielem(20)
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: in1, i, ibin
!-----------------------------------------------
!
!*********************************************************************
!
!   SYMDEC matches up a set of symmetry operations for the system
!          with a point-group.  The set of symmetry operations are
!          stored in IELEM.  Point-groups are represented by a
!          number, N1, which is expanded into binary.
!
!          A system has the symmetry of a specific point-group if
!          every operation of the point-group is present in the
!          system.  Extra operations may also be present, but are
!          ignored.  This allows a controlled descent in symmetry.
!          The symmetry groups in the calling routine, CARTAB, are
!          stored in order of symmetry - C1 to R3.
!  SYMDEC  returns a .TRUE. if the system matches point-group N1.
!
!*********************************************************************
      in1 = n1
      do i = 1, 20
        ibin = mod(in1,2)
        if (ielem(i)/=1 .and. ibin==1) go to 20
        in1 = in1/2
      end do
      symdec = .TRUE.
      return
   20 continue
      symdec = .FALSE.
      return
      end function symdec

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      module elemts_C
      character, dimension(107) :: elemnt*2, cap_elemnt*2
      character (len=12), dimension(107) :: atom_names
      data elemnt/ ' H', 'He', 'Li', 'Be', ' B', ' C', ' N', ' O', ' F', 'Ne', &
        'Na', 'Mg', 'Al', 'Si', ' P', ' S', 'Cl', 'Ar', ' K', 'Ca', 'Sc', 'Ti'&
        , ' V', 'Cr', 'Mn', 'Fe', 'Co', 'Ni', 'Cu', 'Zn', 'Ga', 'Ge', 'As', &
        'Se', 'Br', 'Kr', 'Rb', 'Sr', ' Y', 'Zr', 'Nb', 'Mo', 'Tc', 'Ru', 'Rh'&
        , 'Pd', 'Ag', 'Cd', 'In', 'Sn', 'Sb', 'Te', ' I', 'Xe', 'Cs', 'Ba', &
        'La', 'Ce', 'Pr', 'Nd', 'Pm', 'Sm', 'Eu', 'Gd', 'Tb', 'Dy', 'Ho', 'Er'&
        , 'Tm', 'Yb', 'Lu', 'Hf', 'Ta', ' W', 'Re', 'Os', 'Ir', 'Pt', 'Au', &
        'Hg', 'Tl', 'Pb', 'Bi', 'Po', 'At', 'Rn', 'Fr', 'Ra', 'Ac', 'Th', 'Pa'&
        , ' U', 'Np', 'Pu', 'Am', 'Cm', 'Bk', 'Mi', 'XX', '+3', '-3', 'Cb', &
        '++', ' +', '--', ' -', 'Tv'/
      data cap_elemnt / "H ", "HE", "LI", "BE", "B ", "C ", "N ", "O ", "F ", "NE", &
        & "NA", "MG", "AL", "SI", "P ", "S ", "CL", "AR", "K ", "CA", "SC", "TI", &
        & "V ", "CR", "MN", "FE", "CO", "NI", "CU", "ZN", "GA", "GE", "AS", "SE", "BR", &
        & "KR", "RB", "SR", "Y ", "ZR", "NB", "MO", "TC", "RU", "RH", "PD", "AG", &
        & "CD", "IN", "SN", "SB", "TE", "I ", "XE", "CS", "BA", "LA", "CE", "PR", &
        & "ND", "PM", "SM", "EU", "GD", "TB", "DY", "HO", "ER", "TM", "YB", "LU", "HF", &
        & "TA", " W", "RE", "OS", "IR", "PT", "AU", "HG", "TL", "PB", "BI", "PO", &
        & "AT", "RN", "FR", "RA", "AC", "TH", "PA", " U", "NP", "PU", "AM", "CM", &
        & "BK", "CF", "XX", "+3", "-3", "CB", '++', ' +', '--', ' -', 'TV'/
               data atom_names / &
   & "    Hydrogen", "      Helium", "     Lithium", "   Beryllium", &
   & "       Boron", "      Carbon", "    Nitrogen", "      Oxygen", &
   & "    Fluorine", "        Neon", "      Sodium", "   Magnesium", &
   & "    Aluminum", "     Silicon", "  Phosphorus", "      Sulfur", &
   & "    Chlorine", "       Argon", "   Potassium", "     Calcium", &
   & "    Scandium", "    Titanium", "    Vanadium", "    Chromium", &
   & "   Manganese", "        Iron", "      Cobalt", "      Nickel", &
   & "      Copper", "        Zinc", "     Gallium", "   Germanium", &
   & "     Arsenic", "    Selenium", "     Bromine", "     Krypton", &
   & "    Rubidium", "   Strontium", "     Yttrium", "   Zirconium", &
   & "     Niobium", "  Molybdenum", "  Technetium", "   Ruthenium", &
   & "     Rhodium", "   Palladium", "      Silver", "     Cadmium", &
   & "      Indium", "         Tin", "    Antimony", "   Tellurium", &
   & "      Iodine", "       Xenon", "      Cesium", "      Barium", &
   & "   Lanthanum", "      Cerium", "Praseodymium", "   Neodymium", &
   & "  Promethium", "    Samarium", "    Europium", "  Gadolinium", &
   & "     Terbium", "  Dysprosium", "     Holmium", "      Erbium", &
   & "     Thulium", "   Ytterbium", "    Lutetium", &
   & "     Hafnium", "    Tantalum", "    Tungsten", &
   & "     Rhenium", "      Osmium", "     Iridium", "    Platinum", &
   & "        Gold", "     Mercury", "    Thallium", "        Lead", &
   & "     Bismuth", "    Polonium", "    Astatine", "       Radon", &
   & "    Francium", "      Radium", "    Actinium", "     Thorium", &
   & "Protactinium", "     Uranium", "   Neptunium", "   Plutonium", &
   & "   Americium", "      Curium", "   Berkelium", "     Mithril", &
   & "  Dummy atom", &
   & "  3+ Sparkle", "  3- Sparkle", " Capped bond", "  ++ Sparkle", &
   & "   + Sparkle", "  -- Sparkle", "   - Sparkle", "     Tv     "/
      end module elemts_C

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine react1
      USE molkst_C, only : keywrd, natoms, moperr, numat, nvar, keywrd_txt, &
      tleft,  gnorm, escf, cosine, mpack, step, time0, iflepo, line, density
      use chanel_C, only : iw, ir
      use elemts_C, only : elemnt
      use common_arrays_C, only : p, pa, pb, geo, geoa, coord, &
      & labels, na, nb, nc, xparam, grad, nat, loc
      implicit none
      integer :: linear, iflag, i, maxstp, maxcyc, j, k, iloop, lopt(3,natoms)
      double precision, dimension(3*numat) :: xold, grold
      double precision :: stepmx,  x, sumx, sumy, sumz, sum, &
        step0, one, dell, eold, time1, swap, funct1, time2, gold, c1, c2, &
        dist
      double precision, dimension(:,:), allocatable :: xyz
      double precision, dimension(:), allocatable ::  pastor, pbstor
      logical :: gradnt, finish, intl
      logical , dimension(2) :: gok
      logical :: lef
      double precision, external :: ddot, reada, seconds
!-----------------------------------------------
!***********************************************************************
!
!  REACT1 DETERMINES THE TRANSITION STATE OF A CHEMICAL REACTION.
!
!   REACT WORKS BY USING TWO SYSTEMS SIMULTANEOUSLY, THE HEATS OF
!   FORMATION OF BOTH ARE CALCULATED, THEN THE MORE STABLE ONE
!   IS MOVED IN THE DIRECTION OF THE OTHER. AFTER A STEP THE
!   ENERGIES ARE COMPARED, AND THE NOW LOWER-ENERGY FORM IS MOVED
!   IN THE DIRECTION OF THE HIGHER-ENERGY FORM. THIS IS REPEATED
!   UNTIL THE SADDLE POINT IS REACHED.
!
!   IF ONE FORM IS MOVED 3 TIMES IN SUCCESSION, THEN THE HIGHER ENERGY
!   FORM IS RE-OPTIMIZED WITHOUT SHORTENING THE DISTANCE BETWEEN THE TWO
!   FORMS. THIS REDUCES THE CHANCE OF BEING CAUGHT ON THE SIDE OF A
!   TRANSITION STATE.
!
!***********************************************************************
      linear = 0
      density = 0.d0
      iflag = 1
      gok(1) = .FALSE.
      gok(2) = .FALSE.
      lef = index(keywrd,' EF') /= 0
      gradnt = index(keywrd,'GRAD') /= 0
      i = index(keywrd,' BAR')
      stepmx = 0.01D0
      if (i /= 0) stepmx = reada(keywrd,i)
      maxstp = 10000
      allocate(pastor(mpack), pbstor(mpack))
      if (index(keywrd_txt, "GEO_REF") == 0) then
!
!    READ IN THE SECOND GEOMETRY.
!
        if (allocated (geoa)) deallocate(geoa)
        allocate(geoa(3,natoms))
        i = numat
        call getgeo (ir, labels, geoa, coord, lopt, na, nb, nc, intl)
        if (numat /= i) then
          rewind (ir)
          write(iw,"(a,i4)")" Number of atoms in the first geometry: ",i, &
                            " Number of atoms in the second geometry:", numat
          write (iw,"(a)") " Second geometry has different number of atoms from first geometry", &
        " Data set suppled:"
          do i = 1, 100000
            read(ir,"(a)", iostat = j) line
            if (j < 0) exit
            write(iw,"(a)") Trim (line)
          end do
          call mopend("Geometry supplied is faulty - see output file")
  ! Dummy use of intl
          if (intl .or. lopt(1,1) /= 0) return
          return
        end if
      else
        call gmetry (geoa, coord)
      end if
      call delete_ref_key("GEO_REF=", len_trim("GEO_REF="), '" ', 2)
      call delete_ref_key("SADDLE", len_trim("SADDLE"), ' ', 1)
      call delete_ref_key("BAR", len_trim("BAR"), ' ', 1)
      intl = (index(keywrd, " XYZ") == 0)
      maxcyc = 100000
      if (Index (keywrd, " BIGCYCLES") /= 0) &
        maxcyc = Nint (reada (keywrd, Index (keywrd, " BIGCYCLES")))
   !
   !  SWAP FIRST AND SECOND GEOMETRIES AROUND
   !  SO THAT GEOUT CAN OUTPUT DATA ON SECOND GEOMETRY.
   !
      allocate(xyz(3,numat))
      xyz = geo(:,:numat)
      geo(:,:numat) = geoa(:,:numat)
      geoa(:,:numat) = xyz
      sumx = 0.d0
      sumy = 0.d0
      sumz = 0.d0
      do j = 1, numat
        sumx = sumx + xyz(1, j)
        sumy = sumy + xyz(2, j)
        sumz = sumz + xyz(3, j)
      end do
      sumx = sumx / numat
      sumy = sumy / numat
      sumz = sumz / numat
      do j = 1, numat
        geoa(1, j) = xyz(1, j) - sumx
        geoa(2, j) = xyz(2, j) - sumy
        geoa(3, j) = xyz(3, j) - sumz
      end do
      write (iw, "(//,'  CARTESIAN GEOMETRY OF FIRST SYSTEM',//)")
      write (iw, "(i4,3x,a2,3x,3F14.5)") (i,elemnt(nat(i)),(geo(j, i), j=1, 3), i=1, numat)
      call dock (geoa, geo, dist)
      write (iw, "(//,'  CARTESIAN GEOMETRY OF SECOND SYSTEM',//)")
        write (iw, "(i4,3x,a2,3x,3F14.5)") (i,elemnt(nat(i)),(geoa(j, i), j=1, 3), i=1, numat)
      write (iw, "(//,'   ""DISTANCE"":',F13.6)") dist
      write (iw, "(//,'  REACTION COORDINATE VECTOR',//)")
      write (iw, "(i4,3x,a2,3x,3F14.5)") (i,elemnt(nat(i)), &
      (geo(j, i) - geoa(j, i), j=1, 3), i=1, numat)
      !
      !   XPARAM HOLDS THE VARIABLE PARAMETERS FOR GEOMETRY IN GEO
      !   XOLD   HOLDS THE VARIABLE PARAMETERS FOR GEOMETRY IN GEOA
      !
      sum = 0.d0
      i = 0
      do j = 1, numat
        do k = 1,3
          i = i + 1
          grold(i) = 1.d0
          xparam(i) = geo(k,j)
          xold(i) = geoa(k,j)
          sum = sum + (xparam(i)-xold(i)) ** 2
        end do
      end do
      step0 = Sqrt (sum)
      if (step0 < 1.d-2) then
        write (iw, "(//,3(5X,A,/))") " THE TWO GEOMETRIES ARE IDENTICAL OR ALMOST IDENTICAL", &
       & " A SADDLE CALCULATION INVOLVES A REACTANT AND A PRODUCT", &
       & " THESE MUST BE DIFFERENT GEOMETRIES"
        call mopend ("THE TWO GEOMETRIES IN SADDLE ARE IDENTICAL.")
        return
      end if
      time0 = seconds(2)
      maxcyc = 100000
      if (index(keywrd,' BIGCYCLES') /= 0) maxcyc = nint(reada(keywrd,index(&
        keywrd,' BIGCYCLES')))

      one = 1.D0
      dell = 0.1D0
      eold = -2000.D0
      time1 = seconds(2)
      swap = 0.D0
      do iloop = 1, maxstp
        if (iloop >= maxcyc) tleft = -100.D0
        write (iw, '('' '',40(''*+''))')
!
!   THIS METHOD OF CALCULATING 'STEP' IS QUITE ARBITARY, AND NEEDS
!   TO BE IMPROVED BY INTELLIGENT GUESSWORK!
!
        gnorm = dmax1(1.D-3,gnorm)
        step = Min (0.2d0, Min (swap, 0.5d0, 6.d0/gnorm, dell, stepmx*step0)/step0) * step0
        swap = swap + 1.D0
        dell = dell + 0.1D0
        write (iw, '(''            BAR SHORTENED BY'',F12.3,'' PERCENT'')') step/step0*100.D0
        step0 = step0 - step
        if (step0 < 0.1D0) exit
        step = step0
        if (lef) then
          call ef (xparam, escf)
          if (moperr) return
        else
          call flepo (xparam, nvar, escf)
          if (moperr) return
        end if
        if (linear == 0 .and. allocated(pa)) then
          linear = mpack
          pastor = pa
          pbstor = pb
        end if
        i = 0
        do j = 1, numat
          do k = 1,3
            i = i + 1
            xparam(i) = geo(k,j)
          end do
        end do
        if (iflag == 1) then
          write (iw, '(2/10X,''FOR POINT'',I5,'' SECOND STRUCTURE'')') iloop
        else
          write (iw, '(2/10X,''FOR POINT'',I5,'' FIRST  STRUCTURE'')') iloop
        end if
        write (iw, '('' DISTANCE A - B  '',F12.6)') step
        sum = step
!
!   NOW TO CALCULATE THE "CORRECT" GRADIENTS, SWITCH OFF 'STEP'.
!
        step = 0.D0
        grad(:nvar) = grold(:nvar)
        call compfg (xparam, .TRUE., funct1, .TRUE., grad, .TRUE.)
        if (moperr) return
        grold(:nvar) = grad(:nvar)
        if (gradnt) then
          write (iw, '(''  ACTUAL GRADIENTS OF THIS POINT'')')
          write (iw, '(8F10.4)') (grad(i),i=1,nvar)
        end if
        write (iw, '('' HEAT            '',F12.6)') funct1
        gnorm = dsqrt(ddot(nvar,grad,1,grad,1))
        write (iw, '('' GRADIENT NORM   '',F12.6)') gnorm
        cosine = cosine*one
        write (iw, '('' DIRECTION COSINE'',F12.6)') cosine
        if (mod(iloop - 1, 50) == 0) &
        call to_screen(" Structure  No.  Distance from A - B  Heat of Formation Gradient Norm  Cosine of angle")
        if (iflag == 1) then
          write (line, '( "  SECOND ",i5,2f18.6,3f16.6)') iloop, sum,  funct1, gnorm, cosine
        else
          write (line, '( "  FIRST  ",i5,2f18.6,3f16.6)') iloop, sum, funct1, gnorm, cosine
        end if
        call to_screen(trim(line))
        if (intl) then
          xyz = geo(:,:numat)
          call xyzint (xyz, numat, na, nb, nc, 1.d0, geo)
          k = 0
          do i = 1, numat
            do j = 1, min(i - 1,3)
              k = k + 1
              loc(1,k) = i
              loc(2,k) = j
            end do
          end do
        end if
        call geout (iw)
        if (intl) then
          na = 0
          geo(:,:numat) = xyz
          k = 0
          do i = 1, numat
            do j = 1, 3
              k = k + 1
              loc(1,k) = i
              loc(2,k) = j
            end do
          end do
        end if
        if (cosine < 0.d0) then
         i = 0
        end if
        if (swap > 2.9D0 .or. iloop > 3 .and. cosine < 0.D0 .or. escf > eold) then
          if (swap > 2.9D0) then
            swap = 0.D0
          else
            swap = 0.5D0
          end if
!
!   SWAP REACTANT AND PRODUCT AROUND
!
          finish = (gok(1) .and. gok(2) .and. cosine < -0.8D0)
          if (finish) then
            call mopend("BOTH SYSTEMS ARE ON THE SAME SIDE OF THE TRANSITION STATE.")
            return
          end if
          time2 = seconds(2)
          write (iw, '('' TIME='',F9.2)') time2 - time1
          time1 = time2
          write (iw, '(''  REACTANTS AND PRODUCTS SWAPPED AROUND'')')
          iflag = 1 - iflag
          one = -1.D0
          eold = escf
          if (gnorm > 10.D0) gok(iflag + 1) = .TRUE.
          gnorm = sum
          do i = 1, natoms
            do j = 1, 3
              x = geo(j,i)
              geo(j,i) = geoa(j,i)
              geoa(j,i) = x
            end do
          end do
          do i = 1, nvar
            x = xold(i)
            xold(i) = xparam(i)
            xparam(i) = x
          end do
!
!
!    SWAP AROUND THE DENSITY MATRICES.
!
          do i = 1, linear
            x = pastor(i)
            pastor(i) = pa(i)
            pa(i) = x
            x = pbstor(i)
            pbstor(i) = pb(i)
            pb(i) = x
            p(i) = pa(i) + pb(i)
          end do
          if (finish) exit
        else
          one = 1.D0
        end if
      end do
      iflepo = 18
      write (iw, '('' AT END OF STEPWISE ASCENT OF REACTION BARRIER'')')
      gold = dsqrt(ddot(nvar,grad,1,grad,1))
      call compfg (xparam, .TRUE., funct1, .TRUE., grad, .TRUE.)
      if (moperr) return
      gnorm = dsqrt(ddot(nvar,grad,1,grad,1))
      grold(:nvar) = xparam(:nvar)
      call writmo ()
      if (moperr) return
!
! THE GEOMETRIES HAVE (A) BEEN OPTIMIZED CORRECTLY, OR
!                     (B) BOTH ENDED UP ON THE SAME SIDE OF THE T.S.
!
!  TRANSITION STATE LIES BETWEEN THE TWO GEOMETRIES
!
      c1 = gold/(gold + gnorm)
      c2 = 1.D0 - c1

      xparam(:nvar) = c1*grold(:nvar) + c2*xold(:nvar)
      step = 0.D0
      sum = gnorm
      grold(:nvar) = grad(:nvar)
      call compfg (xparam, .TRUE., funct1, .TRUE., grad, .TRUE.)
      if (moperr) return
      gnorm = dsqrt(ddot(nvar,grad,1,grad,1))
      if (gnorm < sum) then
!
!  Gradient has been minimized - write out "better" ts
!
        write (iw, '('' BEST ESTIMATE GEOMETRY OF THE TRANSITION STATE'')')
        write (iw, '(2/10X,'' C1='',F8.3,5X,''C2='',F8.3)') c1, c2
        escf = funct1
        call writmo ()
      else
!
!  Gradient is worse - restore last point
!
        grad = gold
        xparam(:nvar) = grold
      end if
      iflepo = -1 ! Prevent any more calls to writmo
      if (moperr) return
      end subroutine react1
      subroutine dock (geoa, geo, dist)
   !***********************************************************************
   !
   !  DOCK rotates and translates the geometry in GEOA so that the root
   !       mean square difference between GEOA and GEO is a minimum.
   !
   !  On input  GEOA = Cartesian coordinate geometry of first system.
   !            GEO  = Cartesian coordinate geometry of second system.
   !            NUMAT= Number of atoms.
   !
   ! On output  GEOA = "best fit" Cartesian geometry of first system.
   !            GEO  = Unchanged
   !            DIST = Scalar of distance between the two systems.
   !
   !***********************************************************************
    use molkst_C, only : numat, id
    implicit none
    double precision, dimension (3, numat), intent (inout) :: geoa
    double precision, dimension (3, numat), intent (inout) :: geo
    double precision, intent (out) :: dist
    integer :: i, ir, j, jr, k, l
    double precision :: ca, sa, sum, summ, sum_b(3), x
    double precision, save :: sum_a(3) = 0.d0
    integer, dimension (2, 3), save :: irot
    logical, save :: first = .true.
    intrinsic Abs, Cos, Sqrt
    data irot / 1, 2, 1, 3, 2, 3 /
    if (first) then
      first = .false.
      do j = 1, numat - id
        sum_a(:) = sum_a(:) + geo(:,j)
      end do
      sum_a = sum_a/numat
    end if
    do j = 1, numat - id
        geo(:,j) = geo(:,j) - sum_a(:)
    end do
    sum_b = 0.d0
    do j = 1, numat - id
      sum_b(:) = sum_b(:) + geoa(:, j)
    end do
    sum = 0.d0
    sum_b = sum_b / numat
    do j = 1, numat - id
      geoa(:, j) = geoa(:, j) - sum_b(:)
      sum = sum + (geo(1, j)-geoa(1, j)) ** 2 + (geo(2, j)-geoa(2, j)) ** 2 + &
     & (geo(3, j)-geoa(3, j)) ** 2
    end do
    do l = 3, -3, -1
      !
      !     DOCKING IS DONE IN STEPS OF 16, 4, AND 1 DEGREES AT A TIME.
      !
      ca = Cos (4.d0**(l-1)*0.0174532925199432957d0)
      sa = Sqrt (Abs (1.d0-ca**2))
      do j = 1, 3
        ir = irot(1, j)
        jr = irot(2, j)
        do i = 1, 40
          summ = 0.d0
          do k = 1, numat
            x = ca * geoa(ir, k) + sa * geoa(jr, k)
            geoa(jr, k) = -sa * geoa(ir, k) + ca * geoa(jr, k)
            geoa(ir, k) = x
            summ = summ + (geo(1, k)-geoa(1, k)) ** 2 + &
                          (geo(2, k)-geoa(2, k)) ** 2 + &
                          (geo(3, k)-geoa(3, k)) ** 2
          end do
          if (summ > sum) then
            if (i > 1) go to 1000
            sa = -sa
          else
            sum = summ
          end if
          if (i == 1) sum = summ
        end do
        cycle
1000    continue
        sa = -sa
        do k = 1, numat
          x = ca * geoa(ir, k) + sa * geoa(jr, k)
          geoa(jr, k) = -sa * geoa(ir, k) + ca * geoa(jr, k)
          geoa(ir, k) = x
        end do
      end do
    end do
    do j = 1, numat - id
      geo(:,j) = geo(:,j) + sum_a(:)
      geoa(:,j) = geoa(:,j) + sum_a(:)
    end do
    dist = sqrt(sum)
    return
end subroutine dock

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine getgeo(iread, labels, geo, xyz, lopt, na, nb, nc, int)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!
      use parameters_C, only : ams
!
      use molkst_C, only : natoms, keywrd, numat, maxtxt, line, moperr, &
        numcal, id, units, Angstroms, arc_hof_1, arc_hof_2, keywrd_txt, pdb_label
!
      use chanel_C, only : iw, ir, input_fn, end_fn, iend
!
      use common_arrays_C, only :atmass, simbol, txtatm, na_store, nat, l_atom, p
!
      USE maps_C, ONLY: react
!
      use funcon_C, only : a0
!
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: iread
      integer , intent(out) :: labels(*)
      integer , intent(out) :: lopt(3,*)
      integer, intent(out)  :: na(*)
      integer, intent(out)  :: nb(*)
      integer, intent(out)  :: nc(*)
      double precision, intent(out)  :: geo(3,*), xyz(3,*)
      logical :: int, lmop, solid, exists, get_q

!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(40) :: istart
      integer :: i, icapa, icapz, iserr, k, icomma, khar, nvalue, label, j, ndmy, &
      jj, ltl, max_atoms, ii, ios
      double precision :: weight, real, sum
      logical :: lxyz, velo, leadsp, ircdrc, saddle, mini, l_gaussian
      character , dimension(107) :: elemnt*2
      character :: space, nine, zero, comma, string*120, ele*2, no
      double precision, external :: reada
      save elemnt, space, nine, zero, comma
!-----------------------------------------------
!***********************************************************************
!
!   GETGEO READS IN THE GEOMETRY. THE ELEMENT IS SPECIFIED BY IT'S
!          CHEMICAL SYMBOL, OR, OPTIONALLY, BY IT'S ATOMIC NUMBER.
!
!  ON INPUT   IREAD  = CHANNEL NUMBER FOR READ, NORMALLY 5
!             AMS    = DEFAULT ATOMIC MASSES.
!
! ON OUTPUT LABELS = ATOMIC NUMBERS OF ALL ATOMS, INCLUDING DUMMIES.
!           GEO    = INTERNAL COORDINATES, IN ANGSTROMS, AND DEGREES.
!                    OR CARTESIAN COORDINATES, DEPENDING ON WHETHER
!                    KEYWORD ' XYZ' IS PRESENT
!           LOPT   = INTEGER ARRAY, A '1' MEANS OPTIMIZE THIS PARAMETER,
!                    '0' MEANS DO NOT OPTIMIZE, AND A '-1' LABELS THE
!                    REACTION COORDINATE.
!           NA     = INTEGER ARRAY OF ATOMS (SEE DATA INPUT)
!           NB     = INTEGER ARRAY OF ATOMS (SEE DATA INPUT)
!           NC     = INTEGER ARRAY OF ATOMS (SEE DATA INPUT)
!           ATMASS = ATOMIC MASSES OF ATOMS.
!***********************************************************************
      data (elemnt(i),i=1,107)/ 'H', 'HE', 'LI', 'BE', 'B', 'C', 'N', 'O', 'F'&
        , 'NE', 'NA', 'MG', 'AL', 'SI', 'P', 'S', 'CL', 'AR', 'K', 'CA', 'SC', &
        'TI', 'V', 'CR', 'MN', 'FE', 'CO', 'NI', 'CU', 'ZN', 'GA', 'GE', 'AS', &
        'SE', 'BR', 'KR', 'RB', 'SR', 'Y', 'ZR', 'NB', 'MO', 'TC', 'RU', 'RH', &
        'PD', 'AG', 'CD', 'IN', 'SN', 'SB', 'TE', 'I', 'XE', 'CS', 'BA', 'LA', &
        'CE', 'PR', 'ND', 'PM', 'SM', 'EU', 'GD', 'TB', 'DY', 'HO', 'ER', 'TM'&
        , 'YB', 'LU', 'HF', 'TA', 'W', 'RE', 'OS', 'IR', 'PT', 'AU', 'HG', 'TL'&
        , 'PB', 'BI', 'PO', 'AT', 'RN', 'FR', 'RA', 'AC', 'TH', 'PA', 'U', 'NP'&
        , 'PU', 'AM', 'CM', 'BK', 'MI', 'XX', '+T', '-T', 'CB', '++', '+', '--'&
        , '-', 'TV'/
      data comma, space, nine, zero/ ',', ' ', '9', '0'/
      ircdrc = index(keywrd,' IRC') + index(keywrd,' DRC') /= 0
      if (index(keywrd," FORCETS") /= 0) ircdrc = .false.
      icapa = ichar('A')
      icapz = ichar('Z')
      get_q = (index(keywrd, " 0SCF") > 0 .and. index(keywrd, " HTML") > 0 .and. index(keywrd_txt, " GEO_REF") == 0)
      if (get_q) then
        if (allocated(p)) deallocate(p)
        i = size(atmass)
        allocate(p(i))
        p = -1.d3
      end if
      saddle = (index(keywrd, "SADDLE") > 0)
      lxyz = (index(keywrd, " XYZ") > 0 .or. saddle .or. (index(keywrd, " LOCATE-TS") /= 0))
      int = (index(keywrd, " INT ") > 0)
      velo = (index(keywrd,' VELO') > 0)
      lmop = (Index (keywrd, " MOPAC") /= 0)
      if (lmop) then
!
! Don't set lmop if " MOPAC" is inside a quoted string
! 
        i = 0
        j = Index (keywrd, " MOPAC") 
        do k = j, len_trim(keywrd)
          if (keywrd(k:k) == '"') i = i + 1
        end do
        lmop = (mod(i, 2) == 0)
      end if
      max_atoms = size(txtatm)
      maxtxt = 0
      istart(1:1) = shape(simbol)
      if (istart(1) < natoms*3) then
        natoms = 0
        numat = 0
        return
      end if
      simbol(:natoms*3) = '---------'
      natoms = 0
      numat = 0
      nvalue = 0
      label = 0
      l_gaussian = .false.
      weight = 0.d0
     ! call dbreak()
      iserr = 0
      mini = (index(keywrd, " MINI") /= 0)
!
!  Set distance units undefined, but with a default of Angstroms
!
      units = .false.
      Angstroms = .true.
      if (index(keywrd, " A0 ") /= 0) then
        units = .true.
        Angstroms = .false.
      else  if (index(keywrd, " Ang") /= 0) then
        units = .true.
      end if
      ii = 0
   20 continue
      read (iread, '(A241)', iostat=ios, end=120, err=210) line
      if (line == '$coord') go to 20
      if (line == '$end') go to 20
      if (line(1:1) == '*') go to 20
      if (line == ' ') then
        if(natoms == 0 .and. numcal == 1) then
!
!  Check:  Is this an ARC file?
!
          numcal = 2
          rewind (iread)
          sum = 0.d0
          do i = 1, 10000
            read (iread, '(A)', iostat=ios, end=120, err=210) line
            if (index(line, "HEAT OF FORMATION") > 0) sum = reada(line,20)
            if (index(line, "FINAL GEOMETRY OBTAINED") > 0) exit
            if (index(line, "GEOMETRY IN CARTESIAN COORDINATE") > 0) exit
            if (index(line, "GEOMETRY IN MOPAC Z-MATRIX") > 0) exit
          end do
!
!  Yes, it's an arc file
!
          if (abs(sum) > 1.d-4) then
            if (abs(arc_hof_1) < 1.d-4) then
              arc_hof_1 = sum
            else
              arc_hof_2 = sum
            end if
          end if
          ii = 0
          if (index(line, "FINAL GEOMETRY OBTAINED") > 0) then
!
! Read in keywords, title and comment
!
            call gettxt
            saddle = (index(keywrd, "SADDLE") > 0)
            lxyz = (index(keywrd, " XYZ") > 0 .or. saddle .or. (index(keywrd, " LOCATE-TS") /= 0))
            int = (index(keywrd, " INT ") > 0)
            velo = (index(keywrd,' VELO') > 0)
            lmop = (Index (keywrd, " MOPAC") /= 0)
            read (iread, '(A)', iostat=ios, end=120, err=210) line
            ii = 3
          else
            natoms = -3
            return
          end if
        end if
        if (ii == 0) goto 120
        ii = 0
      end if
      ltl = len_trim(line)
      icomma = ichar(comma)
      do i = 1, ltl
        khar = ichar(line(i:i))
        if (khar == icomma .or. khar == 9) line(i:i) = space
      end do
      if (natoms == max_atoms) then
        write(iw,"(//10x,a)")" Maximum number of atoms exceeded"
        write(iw,"(10x,a,i6)")" Maximum allowed:", max_atoms
        call mopend("Maximum number of atoms exceeded")
        return
      end if
      if (natoms < 10) then
!
!  Check for anything that might suggest that the data-set is a PDB
!
        if (index(line(:4),"ATOM") + index(line(:6),"HETATM") + index(line,"TITLE ") + index(line,"HEADER") + &
                                         index(line,"COMPND") + index(line,"SOURCE") + index(line,"KEYWDS") + &
                  index(line,"HELIX ") + index(line,"SHEET ") + index(line,"REMARK") + index(line,"USER  ") + &
                  index(line,"EXPDTA") + index(line,"AUTHOR") + index(line,"REVDAT") + index(line,"JRNL  ") + &
                  index(line,"DBREF ") + index(line,"SEQRES") + index(line,"HET   ") + index(line,"HETNAM") + &
                  index(line,"LINK  ") + index(line,"CRYST1") + index(line,"SCALE" ) + index(line,"ORIGX" ) + &
                  index(line,"FORMUL") + index(line,"SEQRES") + index(line,"CONECT") /= 0 .and. &
                  index(line(:6), "(") == 0) then
            natoms = -2
            return
        end if
      end if
!
!   SEE IF TEXT IS ASSOCIATED WITH THIS ELEMENT
!
      i = index(line,'(')
      if (i /= 0) then
!
!  YES, ELEMENT IS LABELLED.
!
        k = index(line,')')
        if (k == 0) then
          write(iw,"(a,i5,a)")" Atom",natoms," has an opening parenthesis but no closing parenthesis"
          write(iw,"(a)")" Line :'"//line(:len_trim(line))//"'"
          write (iw, '(/,A)') ' GEOMETRY IS FAULTY.  GEOMETRY READ IN IS'
          atmass(1) = -1.D0
          nat(1) = 0
          l_atom = .true.
          call geout (iw)
          call mopend ('GEOMETRY IS FAULTY')
          return
        end if
        if (line(k:k) == ")") then
          jj = k - 1
        else
          jj = k
        end if
        txtatm(natoms + 1) = line(i + 1:jj)
        if (maxtxt == 27 .and. k - i - 1 /= 27) then
          if (index(keywrd, " GEO-OK") == 0) then
            no = char(Nint(log10(natoms + 1.1)) + ichar("1"))
            write(iw,'(//10x,a,i'//no//',a,i3,a)') "Atom label length of 27 detected, but atom ", natoms + 1, " has a label of", &
            k - i - 1, " characters."
            write(iw,'(/,a)')"Faulty line = '"//trim(line)//"'"
            write (iw,'(/10x,a)') "If this is intended, add keyword ""GEO-OK"""
            write(line,'(a,i'//no//')')"Fault detected in atom number ", natoms + 1
            call mopend (trim(line))
            stop
          end if
        end if
        maxtxt = max(maxtxt,k - i - 1)
        if (maxtxt > 38) then
          if (index(line,"ATOM") + index(line,"HETATM") + index(line,"TITLE") + &
            index(line,"HEADER") + index(line,"ANISOU") + index(line,"COMPND") + &
            index(line,"SOURCE") + index(line,"KEYWDS") + index(line,"USER ")  + &
            index(line,"HELIX") + index(line,"SHEET") /= 0)  goto 70
          write(iw,"(a)")" Atom labels must not exceed 38 characters"
          string = " "
          write(iw,"(a)")string(:i)//"                1         2         3         4"
          write(iw,"(a)")string(:i)//"       1234567890123456789012345678901234567890"
          write(iw,"(a)")"Line :"""//line(:len_trim(line))//""""
          write (iw, '(/,A)') ' GEOMETRY IS FAULTY.  GEOMETRY READ IN IS'
          atmass(1) = -1.D0
          nat(1) = 0
          call geout (iw)
          call mopend ('GEOMETRY IS FAULTY')
          return
        end if
        string = line(1:i-1)//line(k+1:)
        line = string
      else
        txtatm(natoms + 1) = ' '
      end if
!   CLEAN THE INPUT DATA
      call upcase (line, ltl)
      if (index(line, " NEXT") /= 0) goto 120
!
!   INITIALIZE ISTART TO INTERPRET BLANKS AS ZERO'S
      istart(:10) = len_trim(line) + 1
!
! FIND INITIAL DIGIT OF ALL NUMBERS, CHECK FOR LEADING SPACES FOLLOWED
!     BY A CHARACTER AND STORE IN ISTART
      leadsp = .TRUE.
      nvalue = 0
      i = 0
      do jj = 1, ltl
        i = i + 1
        if (leadsp .and. line(i:i) /= space) then
          nvalue = nvalue + 1
          istart(nvalue) = i
          if (i > 2) then
            if (line(i - 1:i - 1) ==  "-" .and. line(i - 2:i - 2) /=  " ") istart(nvalue) = i - 1
          end if
          if (line(i:i) == '"') then
!
!  Run to other end of quoted text
!
            do j = 1, 40
              i = i + 1
              if (line(i:i) == '"') exit
            end do
          end if
        end if
!
!  set leadsp true if a space is detected, or if a "-" sign is found and it's part of a new number
!
        leadsp = (line(i:i) == space .or. (i /= istart(max(nvalue,1)) .and. line(i:i) ==  "-"))
        if (i > 1) then
          if ((line(i-1:i) == "D-" .or. line(i-1:i) == "E-")) leadsp = .false.
        end if
      end do
      l_gaussian = (nvalue == 7)
      if (nvalue == 4) then !  Cartesian coordinates without optimization flags
!
! Check: is the fourth datum only 1 or 2 characters long?
!
        i = index(line(istart(4):), " ") + istart(4) - 2
        k = 0
        if (i > istart(4) + 1) k = 1
!
! Is is alphabetic?
!
        do j = istart(4), i
          if (line(j:j) < "A" .or. line(j:j) > "Z") k = 1
        end do
!
! Is the first datum definitely not pure alphabetic?
!
        i = index(line(istart(1):), " ") + istart(1) - 2
        do j = istart(1), i
          if (line(j:j) >= "A" .and. line(j:j) <= "Z") exit
        end do
        if (j > i .and. k == 0) then
          natoms = natoms + 1
          geo(1,natoms) = reada(line,istart(1))
          geo(2,natoms) = reada(line,istart(2))
          geo(3,natoms) = reada(line,istart(3))
          lopt(1,natoms) = 1
          lopt(2,natoms) = 1
          lopt(3,natoms) = 1
          na(natoms) = 0
          nb(natoms) = 0
          nc(natoms) = 0
          do i = 1, 107
            if (line(istart(4): istart(4) + 1) /= elemnt(i)) cycle
            labels(natoms) = i
            atmass(natoms) = ams(i)
            exit
          end do
          if (.not. units) then
!
!  distance units were not defined, so define them
!
            Angstroms = .false.
            units = .true.
          end if
          goto 20
        end if
      end if
!
! ESTABLISH THE ELEMENT'S NAME AND ISOTOPE, CHECK FOR ERRORS OR E.O.DATA
!
      weight = 0.D0
      string = line(istart(1):istart(2)-1)
      if (string == "+3") string = "+T"
      if (string == "-3") string = "-T"
      if (string(1:1) >= zero .and. string(1:1) <= nine) then
!  ATOMIC NUMBER USED: NO ISOTOPE ALLOWED
        label = nint(reada(string,1))
        if (label == 0) go to 120
        if (label < 0 .or. label > 107) then
          write (iw, '(''  ILLEGAL ATOMIC NUMBER'')')
          go to 210
        end if
        go to 70
      end if
!  ATOMIC SYMBOL USED
      real = abs(reada(string,1))
      if (real < 1.D-15) then
!   NO ISOTOPE
        ele = string(1:2)
      else
        weight = real
        if (string(2:2) >= zero .and. string(2:2) <= nine) then
          ele = string(1:1)
        else
          ele = string(1:2)
        end if
      end if
!   CHECK FOR ERROR IN ATOMIC SYMBOL
      if (ele(1:1)=='-' .and. ele(2:2)/='-') ele(2:2) = ' '
      do i = 1, 107
        if (ele /= elemnt(i)) cycle
        label = i
        go to 70
      end do
      if (ele(1:1) == 'X') then
        label = 99
        go to 70
      end if
      if (ele == "D ") then
        label = 1
        weight = 2.014d0
        go to 70
      else if (ele == "T ") then
        label = 1
        weight = 3.016d0
        go to 70
      else
         if (index(line,"ATOM") + index(line,"HETATM") + index(line,"TITLE") + index(line,"HEADER") + &
        index(line,"ANISOU") + index(line,"COMPND") + index(line,"SOURCE") + index(line,"KEYWDS") + &
        index(line,"HELIX") + index(line,"SHEET") + index(line,"REMARK") + index(line,"USER ")  + &
        index(line, "SEQRES") /= 0) goto 70
        if (trim(line) == " *                    *") return
        write (iw, '(''  UNRECOGNIZED ELEMENT NAME: ('',A,'')'')') ele
        write(iw,'(/,"  Faulty line: """,a,"""",/)')trim(line)
        go to 210
      end if
!
! ALL O.K.
!
 70   continue
      natoms = natoms + 1
      nb(natoms) = 0
      nc(natoms) = 0
      if (label /= 99) numat = numat + 1
      if (weight /= 0.D0) then
        atmass(numat) = weight
      else
        if (label /= 99) atmass(numat) = ams(label)
      end if
      labels(natoms) = label
      if (nvalue == 4) then !  Cartesian coordinates without optimization flags
        geo(1,natoms) = reada(line,istart(2))
        geo(2,natoms) = reada(line,istart(3))
        geo(3,natoms) = reada(line,istart(4))
        lopt(1,natoms) = 1
        lopt(2,natoms) = 1
        lopt(3,natoms) = 1
      else
        geo(1,natoms) = reada(line,istart(2))
        geo(2,natoms) = reada(line,istart(4))
        geo(3,natoms) = reada(line,istart(6))
        lopt(1,natoms) = nint(reada(line,istart(3)))
        lopt(2,natoms) = nint(reada(line,istart(5)))
        lopt(3,natoms) = nint(reada(line,istart(7)))
        if (nvalue == 8 .and. get_q) p(natoms) = reada(line,istart(8))
        if (nvalue == 11 .and. get_q) p(natoms) = reada(line,istart(11))
        do i = 3, 7, 2
          if (.not.(ichar(line(istart(i):istart(i)))>=icapa .and. ichar(line(&
            istart(i):istart(i)))<=icapz .and. natoms>1)) cycle
          iserr = 1
        end do
      end if
      pdb_label = (maxtxt > 25)
      if (line(istart(10):istart(10)) == '"' .or. line(istart(9):istart(9)) == '"' .or. &
        line(istart(8):istart(8)) == '"') then
        call  l_control("CONTROL_NABC_in_PDB", len_trim("CONTROL_NABC_in_PDB"), 1)
        end if
      string = trim(line)
      if (line(istart(10):istart(10)) == '"') then
        call txt_to_atom_no(line, istart(10), .false.)
      end if
      if (line(istart(9):istart(9)) == '"')   call txt_to_atom_no(line, istart(9), .false.)
      if (line(istart(8):istart(8)) == '"')   call txt_to_atom_no(line, istart(8), .false.)
      if (moperr) then
        write(iw,'(/10x,a, i5)')" Error detected in definition of atom no.:", natoms
        write(iw,'(/,a)')" Text of faulty atom: '"//trim(elemnt(labels(natoms)))//&
        & "("//txtatm(natoms)//") "//trim(string(istart(2):))//"'"
        return
      end if
      j = len_trim(line)
      if (ltl /= j) then
        i = index(line(istart(8):), " ") + istart(8)
        nvalue = 8
        leadsp = .true.
        do i = i, j
          if (leadsp .and. line(i:i) /= space) then
            nvalue = nvalue + 1
            istart(nvalue) = i
          end if
          leadsp = (line(i:i) == " ")
        end do
      end if
      sum = reada(line,istart(8))
      i = index(line(istart(8):), " ") + istart(8) ! Find end of 8'th datum
      if (index(line(istart(8):i), ".") /= 0) sum = 0.D0 ! if 8'th datum contains a decimal, then it's not a connectivity
      na(natoms) = nint(sum)
      if (natoms == 1) na(1) = 0
      if (lmop .and. natoms == 2) then
        na(2) = 1
      else if (lmop .and. natoms == 3 .and. na(3) == 0) then
        na(3) = 2
        nb(3) = 1
        geo(2,3) = geo(2,3)*1.7453292519943D-02
        geo(3,3) = 0.D0
        lopt(3,3) = 0
      else if (na(natoms) > 0) then
        nb(natoms) = nint(reada(line,istart(9)))
        nc(natoms) = nint(reada(line,istart(10)))
        geo(2:3,natoms) = geo(2:3,natoms)*1.7453292519943D-02
      end if

!
!  SPECIAL CASE OF USERS FORGETTING TO ADD DIHEDRAL DATA FOR ATOM 3
!
      if (natoms == 3) then
        if (lopt(1,3) /= 2 .and. lopt(2,3) /= 2 .and. lopt(3,3) == 2) then
          na(3) = 1
          nb(3) = 2
          geo(3,3) = 0.D0
          lopt(3,3) = 0
        else if (lopt(3,3)==1 .and. line(istart(6):istart(6) + 1) == "2 ") then
          na(3) = 2
          nb(3) = 1
          geo(3,3) = 0.D0
          geo(2,3) = geo(2,3)*1.7453292519943D-02
          lopt(3,3) = 0
        end if
      end if
      if ( .not. mini .and. .not. l_gaussian) then
        if ((lopt(1,natoms) > 1 .or. lopt(2,natoms) > 1 .or. lopt(3,natoms) > 1) .and. natoms > 1) then
          if (nvalue == 5 .and. lopt(2,natoms) > 1) &
            l_gaussian = (line(istart(5):istart(5)) >= "A" .and. line(istart(5):istart(5)) <= "Z")
          if (nvalue == 3 .and. lopt(1,natoms) > 1) &
            l_gaussian = (line(istart(3):istart(3)) >= "A" .and. line(istart(3):istart(3)) <= "Z")
          if (l_gaussian) then
!
!  Geometry contins indications that it is in Gaussian format, so return and try reading it again.
!
            natoms  = -1
            return
          end if
          iserr = 1
          write(iw,'(/10x,a,i5)')"Faulty atom:", natoms
          write(iw,'(/10x,a)')"Faulty line: """//trim(line)//""""
          call mopend("Unless MINI is used, optimization flags must be 1, 0, or -1")
          numcal = 2
          if ((lopt(1,natoms) > 10 .or. lopt(2,natoms) > 10 .or. lopt(3,natoms) > 10) .and. natoms > 1) &
            write(iw,'(/10x,a)')" If the geometry is in Gaussian format, add keyword ""AIGIN"" and re-run"
          return
        end if
      else
         i = max(lopt(1,natoms),lopt(2,natoms),lopt(3,natoms))
         j = min(lopt(1,natoms),lopt(2,natoms),lopt(3,natoms))
        if (max(i, -j) > 1) then
          if (i /= -j) then
            do k = 1, 3
              if (lopt(k,natoms) /= 0) lopt(k,natoms) = sign(2,lopt(k,natoms))
            end do
          end if
        end if
      end if
      if (iserr == 1) then
      if (index(line,"ATOM") + index(line,"HETATM") + index(line,"TITLE") + index(line,"HEADER") + &
        index(line,"ANISOU") + index(line,"COMPND") + index(line,"SOURCE") + index(line,"KEYWDS") + &
        index(line,"HELIX") + index(line,"SHEET") + index(line,"REMARK") + index(line,"USER ")  + &
        index(line, "SEQRES") /= 0) then
!
!  Geometry is definitely PDB
!
        natoms = -2
        return
      end if
!
!  MUST BE GAUSSIAN GEOMETRY INPUT
!
        do i = 2, natoms
          do k = 1, 3
            j = nint(geo(k,i))
            if (abs(geo(k,i)-j) <= 1.D-5) cycle
!
!   GEOMETRY CANNOT BE GAUSSIAN
!
           write (iw, '(A)') ' GEOMETRY IS FAULTY.  GEOMETRY READ IN IS'
            atmass(1) = -1.D0
            nat(1) = 0
            call geout (iw)
            call mopend ('GEOMETRY IS FAULTY')
            return
          end do
        end do
        natoms = -1
        return
      end if
      go to 20
!***********************************************************************
! ALL DATA READ IN, CLEAN UP AND RETURN
!***********************************************************************
  120 continue
      if (natoms == 0) then
        if (numcal == 1) call mopend (' Error detected while reading geometry')
        return
      end if
      if ( .not. Angstroms) then
!
!  Convert from A0 to Angstroms
!
        do i = 1, natoms
          geo(1,i) = geo(1,i)*a0
          if (na(i) == 0) then
            geo(2,i) = geo(2,i)*a0
            geo(3,i) = geo(3,i)*a0
          end if
        end do
      end if
      if (maxtxt > 0) then
        do i = 1, natoms
          j = max(1, len_trim(txtatm(i)))
          if (j /= maxtxt) then           !  Pad out text with blanks
            txtatm(i)(j + 1:) = " "       !  (Removes rubbish like "null" characters)
          end if
        end do
      end if
      na(1) = 0
      nb(1) = 0
      nc(1) = 0
      nb(2) = 0
      nc(2) = 0
      nc(3) = 0
!
!     READ IN VELOCITY VECTOR, IF PRESENT
!
      if (velo) then
        j = 0
        do i = 1, natoms
          if (na(i) /= 0) j = 1
        end do
        if ((j /= 0 .or. int .and. index(keywrd,' LET') == 0) .and. index(keywrd,' 0SCF') == 0) then
          call mopend ('COORDINATES MUST BE CARTESIAN WHEN VELOCITY VECTOR IS USED.')
          return
        end if
        if (allocated(react)) deallocate(react)
        allocate(react(3*natoms))
        do i = 1, natoms
          read (iread, '(A)') line
          call nuchar (line, len_trim(line), react((i-1)*3+1), ndmy)
          if (ndmy == 3) cycle
          call mopend ('THERE MUST BE EXACTLY THREE VELOCITY DATA PER LINE.')
          return
        end do
      end if
      if (ircdrc .and. index(keywrd,' 0SCF') == 0) then
        if (numat /= natoms) then
          call mopend ('Only real atoms are allowed in IRC and DRC calculations.')
          return
        end if
        call gmetry(geo, xyz)
        call xyzint (xyz, numat, na, nb, nc, 1.D0, geo)
        geo(:,1:numat) = xyz(:,1:numat)
        na_store = na(:numat) ! Store na - it will be used in printing the DRC
        na(:numat) = 0
      end if
      solid = .false.
      do i = 1, natoms
        if (labels(i) <= 0) then
          write (iw, '('' ATOMIC NUMBER OF '',I3,'' ?'')') labels(i)
          if (i == 1) then
            write (iw, '(A)') ' THIS WAS THE FIRST ATOM'
          else
            write (iw, '(A)') &
              '    GEOMETRY UP TO, BUT NOT INCLUDING, THE FAULTY ATOM'
            natoms = i - 1
            call geout (iw)
          end if
          call mopend ('Error in READMO')
          return
        end if
        if (labels(i) == 107) solid = .true.
        if (solid .and. labels(i) < 99) then
          call mopend ('TRANSLATION VECTORS MUST BE AT THE END OF THE DATA SET')
          return
        end if
        if (i == 1 .or. na(i) == 0) cycle
        j = 0
        if (na(i) == nb(i).and. i > 1 .or. &
          (na(i) == nc(i) .or. nb(i) == nc(i)) .and. i > 2 .or. &
          nb(i)*nc(i) == 0 .and. i > 3) j = 1  !  Error condition
        if (na(i) >= i .or. nb(i) >= i .or. nc(i) >= i) then
!
! An atom is being defined using a connectivity involving one or more atoms
! whose positions have not yet been defined.  This is likely to be an error.
!
          j = j + 1
!
!  Test: The atom is defined in internal coordinates, so check that
!  the dependent atoms are defined in Cartesian coordinates
!
          if ((na(i) < i .or. na(max(1,na(i))) == 0) .and. &
              (nb(i) < i .or. na(max(1,nb(i))) == 0) .and. &
              (nc(i) < i .or. na(max(1,nc(i))) == 0) ) j = j - 1
        end if
        if (j == 0) cycle
        j = max(i, na(i), nb(i), nc(i))
        no = char(Nint(log10(j + 1.1)) + ichar("1"))
        write (line, '(" ATOM NUMBER ",I'//no//'," IS ILL-DEFINED")') i
        write (iw, '(//10x, a)') trim(line)
        write(iw,'(/10x," Connectivity of atom ",i'//no//',": NA=",i'//no//',", NB=",i'//no//',", NC=",i'//no//')') &
        i, na(i), nb(i), nc(i)
        if (na(i) > i) then
          if (na(na(i)) /= 0) write(iw,'(/10x,a)')" NA is defined using internal coordinates"
        end if
        if (nb(i) > i) then
          if (na(nb(i)) /= 0) write(iw,'(/10x,a)')" NB is defined using internal coordinates"
        end if
        if (nc(i) > i) then
          if(na(nc(i)) /= 0) write(iw,'(/10x,a)')" NC is defined using internal coordinates"
        end if
          call web_message(iw,"geometry_specification.html")
        if (i == 1) then
          return
        end if
        write (0, '(//10x, a)') trim(line)
        write (iw, '(/,''  GEOMETRY READ IN'',/)')
        nat = 0
        call geout (iw)
        call mopend (trim(line) )
        inquire (file = input_fn, exist = exists)
        if (exists) close(ir, status = 'delete', err = 99)
        inquire (file = end_fn, exist = exists)
        if (exists) then
          open(unit=iend, file=end_fn, status='UNKNOWN', position='asis', iostat=j)
          close(iend, status = 'delete', iostat=j)
        end if
99      stop
      end do
      if (natoms > 0) then
        call gmetry (geo, xyz)
        if (get_q) then
          j = 0
          k = 1
          do i = 1, natoms
            if (labels(i) /= 99) then
              j = j + 1
              p(j) = p(i)
              if (p(j) < -10.d0) k = 0
            end if
          end do
          if (k == 0) deallocate(p)
        end if
      else
        call mopend ("No atoms!")
      end if
      if (moperr) return
!
!  Switch for converting between coordinate systems.
!
      if (lxyz .or. int) then
!
!    Coordinates should all be Cartesian or all be internal.
!    First, unconditionally convert to Cartesian.
!
        k = 0
        do i = 1, natoms
          do j = 1, 3
            k = k + lopt(j,i)
          end do
        end do
!
!  Get rid of dummy atoms
!
        numat = 0
        do i = 1, natoms
          if (labels(i) /= 99) then
            numat = numat + 1
            labels(numat) = labels(i)
            txtatm(numat) = txtatm(i)
            lopt(:,numat) = lopt(:,i)
          end if
          geo(:,i) = xyz(:,i)
        end do
        na(:natoms) = 0
!
!   If everything is marked for optimization then unconditionally mark the first
!   three atoms for optimization
!
        if (k >= 3*numat - 6) lopt(:,:min(3, numat)) = 1
        natoms = numat
        if (saddle .or. (index(keywrd, " LOCATE-TS") /= 0)) then
          if (index(keywrd, " LOCATE-TS") == 0) lopt(:,:numat) = 1  ! In a saddle calculation, all parameters must be optimizable.
          na(:natoms) = 0
        end if
      end if
      if (int) then
!
!  Coordinates should be internal. Unconditionally convert to internal
!
        if (id > 0) then
!
!  System is a solid, so move translation vectors to suit atom 1
!
          do i = numat - id + 1, numat
            xyz(:,i) = xyz(:,i) + xyz(:,1)
          end do
        end if
        call xyzint (xyz, numat, na, nb, nc, 1.d0, geo)
!
!  UNCONDITIONALLY SET FLAGS FOR INTERNAL COORDINATES
!
        do i = 1, 3
          lopt(i:3,i) = 0
        end do
      end if
      return
! ERROR CONDITIONS
  210 continue
! gfortran flags all EOF reads past the first one as a 5001 error, and MOPAC doesn't avoid this behavior at the moment
      if (ios == 5001) goto 120
      j = natoms - 1
      write (iw, '('' DATA CURRENTLY READ IN ARE: '',/)')
      do k = 1, j
        if (na(k) > 0) geo(2:3,k) = geo(2:3,k)/1.7453292519943D-02
        write (iw, '(3x,a,2x,3(f10.5,2x,i2,2x),3(i2,1x))') &
        elemnt(labels(k)), (geo(jj,k),lopt(jj,k),jj=1,3), &
        na(k), nb(k), nc(k)
      end do
      natoms = 0
      return
      end subroutine getgeo
      subroutine web_message(channel, txt)
        implicit none
        character (*) ::txt
        integer :: channel
        write(channel,'(/10x,a,/)')"For more information, see: HTTP://OpenMOPAC.net/Manual/"//trim(txt)
        return
      end subroutine web_message

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine osinv(a, n, d)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!***********************************************************************
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: n
      double precision , intent(out) :: d
      double precision , intent(inout) :: a(*)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer , dimension(n) :: l, m
      integer :: nk, k, kk, j, iz, i, ij, ki, ji, jp, jk, ik, kj, jq, jr
      double precision :: tol, biga, holo
!-----------------------------------------------
!***********************************************************************
!
!    OSINV INVERTS A GENERAL SQUARE MATRIX OF ORDER UP TO MAXORB. SEE
!          DIMENSION STATEMENTS BELOW.
!
!   ON INPUT       A = GENERAL SQUARE MATRIX STORED LINEARLY.
!                  N = DIMENSION OF MATRIX A.
!                  D = VARIABLE, NOT DEFINED ON INPUT.
!
!   ON OUTPUT      A = INVERSE OF ORIGINAL A.
!                  D = DETERMINANT OF ORIGINAL A, UNLESS A WAS SINGULAR,
!                      IN WHICH CASE D = 0.0
!
!***********************************************************************
!***********************************************************************
!
!    IF THE VALUE OF TOL GIVEN HERE IS UNSUITABLE, IT CAN BE CHANGED.
      tol = 1.D-8
!
!
!***********************************************************************
      d = 1.D0
      nk = -n
      do k = 1, n
        nk = nk + n
        l(k) = k
        m(k) = k
        kk = nk + k
        biga = a(kk)
        do j = k, n
          iz = n*(j - 1)
          do i = k, n
            ij = iz + i
!
!     10 FOLLOWS
!
            if (abs(biga) - abs(a(ij)) >= 0.D0) cycle
            biga = a(ij)
            l(k) = i
            m(k) = j
          end do
        end do
        j = l(k)
        if (j - k > 0) then
          ki = k - n
          do i = 1, n
            ki = ki + n
            holo = -a(ki)
            ji = ki - k + j
            a(ki) = a(ji)
            a(ji) = holo
          end do
        end if
        i = m(k)
        if (i - k > 0) then
          jp = n*(i - 1)
          do j = 1, n
            jk = nk + j
            ji = jp + j
            holo = -a(jk)
            a(jk) = a(ji)
            a(ji) = holo
          end do
        end if
        if (abs(biga) - tol < 0.D0) then
          d = 0.D0
          return
        end if
        do i = 1, n
          if (i - k == 0) cycle
          ik = nk + i
          a(ik) = a(ik)/(-biga)
        end do
        do i = 1, n
          ik = nk + i
          ij = i - n
          if (i - k == 0) then
          else
            do j = 1, n
              ij = ij + n
              if (j - k == 0) cycle
              kj = ij - i + k
              a(ij) = a(ik)*a(kj) + a(ij)
            end do
          end if
        end do
        kj = k - n
        do j = 1, n
          kj = kj + n
          if (j - k == 0) cycle
          a(kj) = a(kj)/biga
        end do
        d = min(d*biga,1.D10)
        a(kk) = 1.D0/biga
      end do
      k = n
  190 continue
      k = k - 1
      if (k <= 0) go to 260
      i = l(k)
      if (i - k > 0) then
        jq = n*(k - 1)
        jr = n*(i - 1)
        do j = 1, n
          jk = jq + j
          holo = a(jk)
          ji = jr + j
          a(jk) = -a(ji)
          a(ji) = holo
        end do
      end if
      j = m(k)
      if (j - k <= 0) go to 190
      ki = k - n
      do i = 1, n
        ki = ki + n
        holo = a(ki)
        ji = ki + j - k
        a(ki) = -a(ji)
        a(ji) = holo
      end do
      go to 190
  260 continue
      return
!
      end subroutine osinv

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine intfc(fmatrx, xparam, georef, nar, nbr, ncr)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : natoms, nvar, numat, l123, l1u, l2u, l3u
      use common_arrays_C, only : na, nb, nc, geo, loc, labels, nat
      use chanel_C, only : iw
      use elemts_C, only : elemnt
      use to_screen_C, only : fcint
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: nar(natoms)
      integer , intent(in) :: nbr(natoms)
      integer , intent(in) :: ncr(natoms)
      double precision , intent(in) :: fmatrx((3*numat*(3*numat + 1))/2)
      double precision  :: xparam(nvar)
      double precision , intent(in) :: georef(3,natoms)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: j, i, ilim, n3, k, ncol
      double precision :: step, stepi, sum, dumy(3*numat*l123)
      logical :: precis, lxyz
!-----------------------------------------------
      nvar = 0
      numat = 0
      l1u = 0
      l2u = 0
      l3u = 0
      j = 0
      do i = 1, natoms
      if (nar(i) /= 0) j = j + 1
      end do
      lxyz = (j == 0) ! All coordinates are Cartesian
      na(:natoms) = nar
      nb(:natoms) = nbr
      nc(:natoms) = ncr
      if (allocated(fcint)) deallocate (fcint)
      allocate(fcint(3,natoms))
      fcint(:,:natoms) = 0.D0
      geo(:,:natoms) = georef
      do i = 1, natoms
        if (labels(i) == 99) cycle
        numat = numat + 1
        if (lxyz) then
          ilim = 3
        else
          ilim = min(3,i - 1)
        end if
        do j = 1, ilim
          nvar = nvar + 1
          loc(1,nvar) = i
          loc(2,nvar) = j
          xparam(nvar) = geo(j,i)
        end do
      end do
      n3 = 3*numat
!
!   Calculate force constants over internal coordinates
!
      step = 1.D-7
      stepi = 0.5D0/step
      precis = .TRUE.
      if (lxyz) then
        write (iw, '(/,10X,A,/)') &
          ' FORCE CONSTANT IN CARTESIAN COORDINATES (Millidynes/A)'
        write (iw, '(A)') &
          '    ATOM   CHEMICAL       X               Y               Z'
        write (iw, '(A)') &
          '   NUMBER   SYMBOL  FORCE CONSTANT  FORCE CONSTANT  FORCE CONSTANT'
      else
        write (iw, '(/,10X,A,/)') &
          ' FORCE CONSTANT IN INTERNAL COORDINATES (Millidynes/A)'
        write (iw, '(A)') &
          '    ATOM   CHEMICAL  BOND LENGTH      BOND ANGLE     TWIST ANGLE'
        write (iw, '(A)') &
          '   NUMBER   SYMBOL  FORCE CONSTANT  FORCE CONSTANT  FORCE CONSTANT'
      end if
      write (iw, '(A)')
      l123 = 1
      do i = 1, nvar
        j = i
        call jcarin (xparam, step, precis, dumy, ncol, i, j)
        dumy(:n3) = dumy(:n3)*stepi
!
!   Calculate internal force constant
!
        sum = 0.D0
        do j = 1, n3
          do k = 1, n3
            if (j >= k) then
              sum = sum + dumy(j)*fmatrx((j*(j-1))/2+k)*dumy(k)
            else
              sum = sum + dumy(j)*fmatrx((k*(k-1))/2+j)*dumy(k)
            end if
          end do
        end do
!
!   1.D-5 is to correct the multiplier in FREQCY of the force constants
!
        fcint(loc(2,i),loc(1,i)) = sum*1.d-5
      end do
      if (ncol < 0) return ! dummy statement, just to use ncol
      write (iw, '(I7,6X,A2,3F16.6)') (i,elemnt(nat(i)),(fcint(j,i),j=1,3),i=1,&
        numat)
      call to_screen("To_file: Internal Force Constants")
      deallocate(fcint)
      return
      end subroutine intfc

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine draw (iz, jz, jdir, a, b, c, pz, i1, i2, i3, mdim)
  use common_common, only : im, jm, r1
  implicit none
  integer, intent(in) :: i1, i2, i3, iz, jdir, jz, mdim
  double precision, intent(in) :: pz
  logical, dimension(40000), intent(inout) :: b
  logical, dimension(20000, 2), intent(out) :: c
  double precision, dimension(mdim, mdim), intent(in) :: a
!
  logical :: ai, aj, ak
  integer :: i, icount, iddx, iddy, idir, idx, idy, ipen, j, k, m, number
  double precision :: aa, ab, ad, cx = 0.d0, cy = 0.d0, ac, fa, factor, px, py
  integer, dimension(6) :: idirx, idiry
  data idiry/0, 1, 0, -1, 0, 1/
  data idirx/1, 0, -1, 0, 1, 0/
  ! 
  ! ... Executable Statements ...
  ! 
  icount = -5
  idir = jdir
  ipen = 2
  i = iz
  j = jz
  do
    aa = a(i, j)
    ai = (aa<0.)
    idx = idirx(idir)
    idy = idiry(idir)
    ab = a(i+idx, j+idy)
    factor = aa / (aa-ab)
    py = (im-i-factor*idx) / (im-1)
    px = (jm-j-factor*idy) / (jm-1)
    call euler (px*2.0, py*2.0, pz*2.0, i1, i2, i3, ipen)
    if (ipen==3 .or. r1>0.d0) then
      r1 = r1 + Sqrt ((cx-px)**2 + (cy-py)**2)
    end if
    cy = py
    cx = px
    icount = icount + 1
    if (idir/2*2 /= idir) then
      if (j==1 .or. j==jm) then
        number = idir * j
        if (number==3 .or. number==jm) exit
      end if
    else
      if (idir /= 2) then
        number = j - 1
        m = im
      else
        number = j
        m = 1
      end if
      k = (number-1)*im + i
      if (.not. b(k)) return
      b(k) = .false.
      if (i == m) return
    end if
    ipen = 3
    iddx = i + idirx(idir+1)
    iddy = j + idiry(idir+1)
    ac = a(iddx+idx, iddy+idy)
    aj = (ac<0.)
    ad = a(iddx, iddy)
    ak = (ad<0.)
    fa = 1
    if (aj .and. ak) then
      if (ai) goto 1000
    elseif (.not. (aj.or.ak)) then
      if (.not. ai) goto 1000
    else
      fa = 0.d0
      if ((ai.or..not.ak) .and. (.not.ai.or.ak)) goto 1000
      fa = aa*ac - ab*ad
      if (fa >= 0.) goto 1000
    end if
    idir = idir + 1
    if (idir == 5) then
      idir = 1
    end if
    cycle
    1000 i = iddx
    j = iddy
    if (fa /= 0.) then
      i = i + idx
      j = j + idy
      idir = idir - 1
      if (idir == 0) then
        idir = 4
      end if
    end if
  end do
  if (number == 3) then
    c(i-1, 1) = .false.
  else
    c(i, 2) = .false.
  end if
end subroutine draw

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine  writmo
      use cosmo_C, only : iseps, area, fepsi, cosvol, ediel, solv_energy
!
      use molkst_C, only : numat, nclose, nopen, fract, nalpha, nelecs, nbeta, &
      & norbs, nvar, gnorm, iflepo, enuclr,elect, ndep, nscf, numcal, escf, &
      & keywrd, os, verson, time0, moperr, last, iscf, id, pressure, mol_weight, &
      jobnam, line, mers, uhf, method_indo, &
      density, formula, mozyme, mpack, stress, &
      sz, ss2, maxtxt, E_disp, E_hb, E_hh, l_normal_html, &
      no_pKa, nalpha_open, nbeta_open, use_ref_geo, N_Hbonds, caltyp, &
      hpress, nsp2_corr, Si_O_H_corr, sum_dihed, atheat, &
      prt_gradients, prt_coords, prt_cart, prt_pops, prt_charges, pdb_label, backslash, gui
!
      use MOZYME_C, only : icocc, icvir, ncocc, ncvir, nvirtual, noccupied, &
      & nnce, nncf, cocc, cvir, ncf, nce,  cocc_dim, &
      & cvir_dim, icocc_dim, icvir_dim, iorbs
!
      use common_arrays_C, only: loc, geo, pa, pb, na, eigs, eigb, coord, &
      & dxyz, p, grad, labels, xparam, nat, nfirst, nlast, cb, q, geoa, &
      & h, c, f, tvec, pdiag, txtatm, hesinv, l_atom, ipKa_sorted, ipKa_unsorted, &
      & pKa_sorted, time_end
!
      use elemts_C, only : elemnt
!
      use maps_C, only : latom, lparam
!
      use meci_C, only : rjkab
!
      use parameters_C, only : tore, natorb
!
      use symmetry_C, only : name, state_spin, state_Irred_Rep, state_QN
!
      use funcon_C, only : fpc_10, fpc_9
!
      use chanel_C, only : iw0, iw, iarc, ibrz, brillouin_fn, archive_fn, log
!
#if MOPAC_F2003
      USE, INTRINSIC :: IEEE_ARITHMETIC
#endif
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------

      double precision ::  gcoord(3,numat)
      double precision, dimension (:), allocatable :: rxyz
      integer :: icalcn, i, loc11, loc21, nopn, j, k, l, m, kchrge, iwrite, mvar
      double precision :: q2(numat), degree, xreact, eionis, vol, tim, xi, sum, &
      dip, dumy(3), pKa_unsorted(numat), distortion, rms, gnorm_norm, escf_min
      logical :: ci, lprtgra, still, bcc, opend, bigcycles
      character  :: type(3)*11, idate*24, gtype*13, grtype*14, &
      flepo(19)*58, iter(2)*58, namfil*241, num*2
      character, allocatable :: old_arc_file(:)*1000
      double precision, external :: dipole, dipole_for_MOZYME, dot, meci, seconds, volume
      integer, external :: ijbo
      save type, flepo, iter, namfil, icalcn, i, bigcycles, escf_min
!***********************************************************************
!
!   WRITMO PRINTS OUT MOST OF THE RESULTS.
!         IT SHOULD NOT ALTER ANY PARAMETERS, SO THAT IT CAN BE CALLED
!         AT ANY CONVENIENT TIME.
!
!***********************************************************************
      data icalcn/ 0/
      data flepo(1), flepo(2), flepo(3)/ &
        ' 1SCF WAS SPECIFIED, SO BFGS WAS NOT USED                 ', &
        ' GRADIENTS WERE INITIALLY ACCEPTABLY SMALL                ', &
        ' HERBERTS TEST WAS SATISFIED IN BFGS                      '/
      data flepo(4), flepo(5), flepo(6)/ &
        ' THE LINE MINIMIZATION FAILED TWICE IN A ROW.   TAKE CARE!', &
        ' BFGS FAILED DUE TO COUNTS EXCEEDED. TAKE CARE!           ', &
        ' PETERS TEST WAS SATISFIED IN BFGS OPTIMIZATION           '/
      data flepo(7), flepo(8), flepo(9)/ &
        ' THIS MESSAGE SHOULD NEVER APPEAR, THERE IS A BUG IN MOPAC', &
        ' GRADIENT TEST NOT PASSED, BUT FURTHER WORK NOT JUSTIFIED ', &
        ' A FAILURE HAS OCCURRED, TREAT RESULTS WITH CAUTION!!     '/
      data flepo(10), flepo(11), flepo(12)/ &
        ' GEOMETRY OPTIMIZED USING NLLSQ. GRADIENT NORM MINIMIZED  ', &
        ' GEOMETRY OPTIMIZED USING POWSQ. GRADIENT NORM MINIMIZED  ', &
        ' CYCLES EXCEEDED, GRADIENT NOT FULLY MINIMIZED IN NLLSQ   '/
      data flepo(13), flepo(14), flepo(15)/ &
        ' 1SCF RUN AFTER RESTART.  GEOMETRY MIGHT NOT BE OPTIMIZED ', &
        ' HEAT OF FORMATION MINIMIZED IN ONE LINE SEARCH           ', &
        ' GEOMETRY OPTIMISED USING EIGENVECTOR FOLLOWING (EF).     '/
      data flepo(16), flepo(17), flepo(18)/ &
        ' NO PARAMETERS MARKED FOR OPTIMIZATION, SO 1SCF WAS USED  ', &
        ' GEOMETRY OPTIMISED USING EIGENVECTOR FOLLOWING (TS).     ', &
        ' TRANSITION STATE LOCATED USING THE "SADDLE" TECHNIQUE    '/
      data flepo(19)/ &
        ' TRANSITION GEOMETRY LOCATED USING LOCATE-TS              '/
      data iter/ ' SCF FIELD WAS ACHIEVED                                   ', &
        '  ++++----**** FAILED TO ACHIEVE SCF. ****----++++        '/
!
! SUMMARY OF RESULTS (NOTE: THIS IS IN A SUBROUTINE SO IT
!          CAN BE USED BY THE PATH OPTION)
      if (icalcn == 0) then
        namfil = '**NULL**'
        escf_min = escf
        bigcycles = (index(keywrd, " BIGCYC") /= 0)
      end if
      if (bigcycles) then
        if (escf > escf_min) return
        escf_min = escf
        rewind (iarc)
      end if
      idate = ' '
      lprtgra = (index(keywrd,' GRAD') /= 0 .and. nvar > 0)
      ci = index(keywrd,' C.I.') /= 0
      call fdate (idate)
      degree = 57.29577951308232D0
      gnorm = 0.D0
      if (nvar /= 0) gnorm = dsqrt(dot(grad,grad,nvar))
      write (iw, '(/,'' ----'',15(''-----''))')
      call wrttxt (iw)
      if (iflepo == 15 .and. index(keywrd,' TS') /=0 ) iflepo = 17
      if (iflepo == 0)                             iflepo =  7
      if (iflepo == 1 .and. nvar == 0 .and. index(keywrd,"1SCF") == 0) iflepo = 16
      write (iw, '(2/4X,A58)') flepo(iflepo)
      iscf = max(1,iscf)
      write (iw, '(4X,A58)') iter(iscf)
      write (iw, "(2/29X,A,' CALCULATION')") trim(caltyp)
      write (iw, '(55X,''MOPAC v'',a,'' '',a)') trim(verson), trim(os)
      write (iw, '(55X,A24)') idate
      if (iscf == 2) then
!
!   RESULTS ARE MEANINGLESS. DON'T PRINT ANYTHING!
!
        write (iw, '(A)') ' '
        write (iw, '(A)') ' '
        write (iw, '(A)') ' FOR SOME REASON THE SCF CALCULATION FAILED.'
        write (iw, '(A)') ' '
        write (iw, '(A)') &
          ' THE RESULTS WOULD BE MEANINGLESS, SO WILL NOT BE PRINTED.'
        write (iw, '(A)') &
          ' TRY TO FIND THE REASON FOR THE FAILURE BY USING ''PL''.'
        write (iw, '(A)') ' '
        write (iw, '(A)') &
          ' CHECK YOUR GEOMETRY AND ALSO TRY USING SHIFT OR PULAY. '
        call geout (1)
        call mopend ('THE SCF CALCULATION FAILED.')
        return
      end if
      if ( Abs (pressure) > 1.d-4) then
      !
      ! Remove energy term arising from the external pressure,
      !
        if( id == 1) then
          escf = escf + pressure * dsqrt(dot(tvec(1,1), tvec(1,1),3))
        else if (id == 3) then
          escf = escf + pressure * volume(tvec,3)
        end if
      end if
      if (use_ref_geo) then
        write (iw, &
      '(4/10X,''FINAL H.O.F PLUS STRESS ='',F17.5,'' KCAL/MOL''  ,'' ='',F14.5,'' KJ/MOL'')') escf, escf*4.184D0
        write (iw, &
      '(10X,''FINAL STRESS            ='',F17.5,'' KCAL/MOL''  ,'' ='',F14.5,'' KJ/MOL'')') stress, stress*4.184D0
        write (iw, &
      '(10X,''FINAL HEAT OF FORMATION ='',F17.5,'' KCAL/MOL''  ,'' ='',F14.5,'' KJ/MOL'')') escf - stress, (escf - stress)*4.184D0
        call  geo_diff(sum, rms, .false.)
        sum = 0.d0
        rms = 0.d0
        do i = 1, numat
          sum = sum + sqrt((geo(1,i) - geoa(1,i))**2 + &
                           (geo(2,i) - geoa(2,i))**2 + &
                           (geo(3,i) - geoa(3,i))**2)
          rms = rms +      (geo(1,i) - geoa(1,i))**2 + &
                           (geo(2,i) - geoa(2,i))**2 + &
                           (geo(3,i) - geoa(3,i))**2
        end do
        distortion = sum/numat
        write (iw, &
    '(10X,''TOTAL DISTORTION        ='',F17.5,'' Angstroms'' )') sum
        write (iw, &
    '(10X,''AVERAGE DISTORTION      ='',F17.5,'' Angstroms per atom (all atoms)'' )') distortion
        write (iw, &
    '(10X,''RMS DISTORTION          ='',F17.5,'' Angstroms per atom (all atoms)'' )') sqrt(rms/numat)
      else
        distortion = 0.d0
        rms = 0.d0
        if (index(keywrd," PM7-TS") /= 0) then
          call PM7_TS
          return
        end if
        stress = -1.1d-6
        write (iw, &
      '(4/10X,''FINAL HEAT OF FORMATION ='',F17.5,'' KCAL/MOL''  ,'' ='',F14.5,'' KJ/MOL'')') escf, escf*4.184D0
      end if
      elect = elect + solv_energy
      solv_energy = 0.d0
      if (index(keywrd," DISP") /= 0) then
        if (index(keywrd,' EPS') /= 0) then
          write(iw,'(/10x,"TOTAL ENERGY            =",f17.5,a)') &
          (elect + enuclr)*fpc_9, " KCAL/MOL = ELECTRONIC ENERGY + CORE-CORE REPULSION + SOLVATION ENERGY"
        else
          write(iw,'(/10x,"TOTAL ENERGY            =",f17.5,a)') &
          (elect + enuclr)*fpc_9, " KCAL/MOL = ELECTRONIC ENERGY + CORE-CORE REPULSION"
        end if
        write(iw,'(10x,"ENERGY OF ATOMS         =",f17.5,a)') atheat, " KCAL/MOL"
        write(iw,'(10x,"                    SUM =",f17.5,a)') &
        (elect + enuclr)*fpc_9 + atheat + solv_energy*fpc_9, " KCAL/MOL"
        if (abs(hpress) > 1.d-5)      write(iw,'(10x,"ENERGY DUE TO PRESSURE  =",f17.5,a)') hpress, " KCAL/MOL"

        write(iw,'(10x,"DISPERSION ENERGY       =", f17.5, a)') e_disp, " KCAL/MOL"
        if (E_hb < -1.d-5) write(iw,'(10x,"H-BOND ENERGY           =", f17.5, a)') e_hb, " KCAL/MOL"
        if (E_hh > 1.d-5)  write(iw,'(10x,"H - H CORRECTION ENERGY =", f17.5, a)') e_hh, " KCAL/MOL"
        if (abs(nsp2_corr) > 1.d-5)   write(iw,'(10x,"MM CORRECTION FOR >N-   =",f17.5,a)') nsp2_corr, " KCAL/MOL"
        if (abs(Si_O_H_corr) > 1.d-5) write(iw,'(10x,"MM CORR. FOR Si-O-H     =",f17.5,a)') Si_O_H_corr, " KCAL/MOL"
        if (abs(sum_dihed) > 1.d-5)   write(iw,'(10x,"MM CORR. FOR -CO-NH-    =",f17.5,a)') sum_dihed, " KCAL/MOL"
        sum = (elect + enuclr + solv_energy)*fpc_9 + atheat + hpress + nsp2_corr + Si_O_H_corr + sum_dihed + &
          e_disp + e_hb + e_hh
        write(iw,'(30x,"SUM =",f17.5,a,/)') sum, " KCAL/MOL = FINAL HEAT OF FORMATION"
        if (abs(sum - escf + stress) > 1.d-3*numat) then
          write(iw,'(5x,"*",4x,a,/)')"WARNING - An energy term is incorrect or missing!"
          write(iw, '(5x,"*",4x,''FINAL HEAT OF FORMATION     ='',F13.5,'' KCAL/MOL'')') escf - stress
          write(iw,'(5x,"*",4x,"SUM OF CONTRIBUTIONS TO HoF =",f13.5,a)') sum, " KCAL/MOL"
          write(iw,'(5x,"*",21x,"DIFFERENCE =",f13.5,a,/)') escf - stress - sum, " KCAL/MOL"
        end if
        if (N_Hbonds > 0)  write(iw,'(10x,"No. OF HYDROGEN BONDS   =", i11,7x,a)') N_Hbonds, "(H-bond Energy < -1.0 Kcal/mol)"
        if (index(keywrd, " DISP(") /= 0) then
          call l_control("PRT", len_trim("PRT"), 1)
          call post_scf_corrections(sum, .false.)
        end if
      end if
      if (numat > 1 .and. iscf == 1 .and. escf > 1.d4 .and. index(keywrd, " CHECK") == 0) &
        write(iw,'(//10x,a,//)') "Calculated Heat of Formation is very large, re-run using keyword 'CHECK'"
      if (id == 3 .or. id == 1) call write_unit_cell_HOF(iw)
      call to_screen(" Job: "//jobnam(1:len_trim(jobnam)))
      write (line,'(10x,a,f16.5,a)') "Final heat of formation = ",escf," kcal/mol"
      call to_screen(line)
      gnorm_norm =  gnorm/sqrt(1.0*numat) + 1.d-8
      write(num, '(i2)')  max(0, Int(Log10( gnorm_norm))) + 7
      write (line, '(10X,''GRADIENT NORM           ='',F17.5, '' = '',f'//num//'.5, '' PER ATOM'')') gnorm, gnorm_norm
      call to_screen(line)
      if ((id == 3 .or. id == 1) .and. iw0 > -1) call write_unit_cell_HOF(iw0)
      if (index(keywrd,' EPS') /= 0) write (iw, '(10X,A,F14.2,A)') &
        'VAN DER WAALS AREA      =', area, ' SQUARE ANGSTROMS'
      if (latom == 0) write (iw, '(/)')
      if (index(keywrd," DISP") /= 0) &
        write (iw, '(    10X,''TOTAL ENERGY            ='',F17.5,'' EV'' )') elect + enuclr + solv_energy
!
!  There is a bug in the call to symtrz.  This appears to be a compiler bug!
!
      if (norbs > 0 .and. .not. mozyme .and. numat < 200) call symtrz (c, eigs, 1, .true.)
      if (moperr) return
      if (index(keywrd," DISP") /= 0) then
        write (iw, '(10X,"ELECTRONIC ENERGY       =",F17.5," EV ")') elect
        write (iw, '(    10X,''CORE-CORE REPULSION     ='',F17.5,'' EV''    )') enuclr
        if (iseps) then
          if (abs(solv_energy) > 1.d-1) &
          write (iw, '(    10X,''SOLVATION ENERGY        ='',F17.5,'' EV''   )') solv_energy
          write (iw, '(/   10X,''DIELECTRIC ENERGY       ='',F17.5,'' EV''   )') ediel
        end if
      else
        if (iseps) then
          if (abs(solv_energy) > 1.d-1) &
          write (iw, '(    10X,''SOLVATION ENERGY        ='',F17.5,'' EV''   )') solv_energy
          write (iw, '(/   10X,''DIELECTRIC ENERGY       ='',F17.5,'' EV''   )') ediel
        end if
      end if
      if (iseps .and. Index (keywrd, "COSWRT") /= 0) call coswrt()
      hpress = 0.d0
      if (Abs (pressure) > 1.d-4) then
        if (id == 1) then
          hpress = -pressure * dsqrt (dot(tvec(1, 1), tvec(1, 1), 3))
        else if (id == 3) then
          sum =  volume (tvec, 3)
          hpress = -pressure * sum
          write (iw, '(    10X,''ENERGY DUE TO PRESSURE  ='',F17.5,'' KCAL/MOL''    )') &
          hpress
          sum = -(4184.d0*10.d0**30)*pressure/fpc_10
          if (abs(sum) > 1.d9) then
            write (iw, '(10X,''PRESSURE                ='',F17.5,'' Gp''    )') sum*1.d-9
          else
            write (iw, '(10X,''PRESSURE                ='',F17.5,'' Pascals''    )') sum
          end if
        end if
      end if
      if (Index(keywrd, " EPS") == 0 .and. id == 0 .and. (.not. mozyme .and. numat < 700)) then
        sum = 78.4d0
        fepsi = (sum-1.d0) / (sum+0.5d0)
        call cosini(.false.)
        if (moperr) then
          moperr = .false.
          area = 0.d0
          cosvol = 0.d0
        else
          call coscav
        end if
      end if
      if (moperr) then
        moperr = .false.
      else
        if (fepsi > 1.d-10 .and. area > 1.d-3) then
          write (iw, "(10X,A,F14.2,A)") "COSMO AREA              =", area, &
             & " SQUARE ANGSTROMS"
          write (iw, "(10X,A,F14.2,A)") "COSMO VOLUME            =", cosvol, &
             & " CUBIC ANGSTROMS"
        end if
      end if
      if (index(keywrd," PKA") /= 0) then
      if (allocated(ipKa_sorted))  deallocate (ipKa_sorted)
      if (allocated(ipKa_unsorted))  deallocate (ipKa_unsorted)
      if (allocated(pKa_sorted))  deallocate (pKa_sorted)
      allocate(ipKa_sorted(numat), ipKa_unsorted(numat), pKa_sorted(numat))
        call prtpka(ipKa_sorted, pKa_sorted, ipKa_unsorted, pKa_unsorted, no_pKa)
        if (moperr) return
        if (no_pKa > 0) then
          write(iw,'(/10x,a,/)')"                pKa for hydroxyl hydrogens"
          j = index(txtatm(ipKa_sorted(1)), "(")
          if (j /= 0) then
             write(iw, '(10x,a)') &
          &"        Sorted by pKa                    Sorted by atom", &
          &"Atom        Label         pKa      Atom        Label         pKa"
            do i = 1, no_pKa
              j = index(txtatm(ipKa_sorted(i)), "(")
              k = index(txtatm(ipKa_sorted(i)), ")")
              l = index(txtatm(ipKa_unsorted(i)), "(")
              m = index(txtatm(ipKa_unsorted(i)), ")")
              write(iw,"(9x,i5, a, f8.3,i9,a,f8.3)")ipKa_sorted(i), "  "//txtatm(ipKa_sorted(i))(j:k), &
                 pKa_sorted(i), ipKa_unsorted(i), "  "//txtatm(ipKa_unsorted(i))(l:m), pKa_unsorted(i)
            end do
          else
            write(iw, '(22x,a)') &
            &"Sorted by pKa       Sorted by atom", &
            &"Atom      pKa       Atom      pKa"
            do i = 1, no_pKa
              write(iw,"(21x,i5, f11.3,i9,f11.3)")ipKa_sorted(i), &
                 pKa_sorted(i), ipKa_unsorted(i), pKa_unsorted(i)
            end do
          end if
          write(iw,*)
        end if
      end if
      if (latom == 0) write (iw, '(1X)')
      if (lprtgra .or. gnorm /= 0.D0) &
        write (iw, '(10X,"GRADIENT NORM           =",F17.5, 10x, "=", 7x, f'//num//'.5, '' PER ATOM'')') &
        gnorm, gnorm/sqrt(1.0*numat)
      if (gnorm > 2.D0 .and. fract > 0.05D0 .and. fract < 1.95D0 .and. &
        index(keywrd,' 1SCF') == 0 .and. index(keywrd,' UHF') == 0 .and. &
        index(keywrd,' NOANCI') == 0) write (iw, *) &
      ' TO REDUCE GNORM FURTHER, TRY ADDING KEYWORD ''NOANCI'' AND RE-RUN THE JOB'
      still = .TRUE.
      if (latom == 0) then
        if (index(keywrd,' AIDER') == 0 .and. nvar > 0) then
#ifdef MOPAC_F2003
          if (.not. ieee_is_nan(dxyz(1)) .and. (index(keywrd,' 1SCF') == 0 .or. index(keywrd,' GRAD') /= 0)) then
#else
          if (.not. isnan(dxyz(1)) .and. (index(keywrd,' 1SCF') == 0 .or. index(keywrd,' GRAD') /= 0)) then
#endif
!
!   CHECK THAT THE CARTESIAN COORDINATE GRADIENT IS ALSO SMALL
!
            sum = dsqrt(dot(dxyz, dxyz, 3*numat))
!
! Not at a stationary point if:
! (A) "sum" is more than 2 times "gnorm" scaled from (nvar/3) to numat and
! (B) "sum" is less than 0.1 times the square-root of numat
!
! where "sum" is the gradient norm of the entire system.
!
            if (nvar > 0 .and. nvar < numat*3 - 5 .and. sum > max(2.d0, 2.D0*gnorm*sqrt((numat*3.d0)/nvar)) .and. &
              sum < sqrt(0.1d0*numat) .and. nclose == nopen .and. id == 0 .and. index(keywrd, "NOANCI") == 0) then
              if (nvar /= 1 .or. index(keywrd," GRAD") + index(keywrd, "DERIV") > 0) then
                write (iw, '(9x,A)') &
                ' WARNING -- GEOMETRY IS NOT AT A STATIONARY POINT'
                call web_message(iw,"Warning_geometry.html")
                still = .FALSE.
              end if
            end if
          end if
        end if
      else
!
!   WE NEED TO CALCULATE THE REACTION COORDINATE GRADIENT.
!
        mvar = nvar
        loc11 = loc(1,1)
        loc21 = loc(2,1)
        nvar = 1
        loc(1,1) = latom
        loc(2,1) = lparam
        xreact = geo(lparam,latom)
        gcoord = 0.d0
        call deriv (geo, gcoord)
        nvar = mvar
        loc(1,1) = loc11
        loc(2,1) = loc21
        grtype = ' KCAL/ANGSTROM'
        if (lparam == 1 .or. na(latom) == 0) then
          write (iw, &
      '(10X,''FOR REACTION COORDINATE ='',F17.5,'' ANGSTROMS'')') xreact
        else
          if (na(latom) /= 0) grtype = ' KCAL/RADIAN  '
          write (iw, &
      '(10X,''FOR REACTION COORDINATE ='',F17.5,'' DEGREES'')') xreact*degree
        end if
        write (iw, '(10X,''REACTION GRADIENT       ='',F17.5,A14)') &
        gcoord(1,1), grtype
      end if
      eionis = 0.D0
      if (nalpha > 0 .and. nbeta > 0) then
        eionis = -max(eigs(nalpha),eigb(nbeta))
      else if (nelecs == 1) then
        eionis = -eigs(1)
      else if (nelecs > 1) then
        if (nopen > 0) eionis = -eigs(nopen)
        if (nclose > 0) eionis = min(eionis,-eigs(nclose))
      end if
      i = nclose
      if (fract > 1.99D0) i = nopen
      nopn = nopen - i
      if ( .not. mozyme ) then
!   CORRECTION TO I.P. OF DOUBLETS
        if (nopn == 1) eionis = eionis + 0.5D0*rjkab(1,1)
        if (abs(eionis) > 1.D-5 .and. nopn < 2) then
          if (state_Irred_Rep /= " ") then
            write(line, '(10x, "STATE:  ",i2,1x,3A)') state_QN, state_spin, state_Irred_Rep
          else
            line = " "
          end if
          write (iw, '(  10X,"IONIZATION POTENTIAL    =  ",F16.6," EV", a)') eionis, trim(line)
        end if
        if (uhf) then
          if (nalpha >= 1) write (iw, &
          '(  10X,''ALPHA SOMO LUMO (EV)    =  '',F13.3,F7.3)') eigs(nalpha), &
          (eigs(i),i=nalpha + 1,norbs,10000)
          if (nbeta >= 1) write (iw, &
          '(  10X,''BETA  SOMO LUMO (EV)    =  '',F13.3,F7.3)') eigb(nbeta), &
          (eigb(i),i=nbeta + 1,norbs,10000)
        else if (nopen == nclose) then
          if (nopen >= 1) write (iw, &
          '(  10X,''HOMO LUMO ENERGIES (EV) =  '',F13.3,F7.3)') eigs(nopen), &
          (eigs(i),i=nopen + 1,norbs,10000)
        else if (nopn == 1) then
            if (nclose >= 1) then
            write (iw, &
      '(  10X,''HOMO (SOMO) LUMO (EV)   ='',F13.3,   '' ('',F7.3,'')'',F7.3)') &
            eigs(nclose), (eigs(i),i=nclose + 1,norbs,10000), &
            (eigs(i),i=nclose + 2,norbs,10000)
          else
            write (iw, &
      '(  10X,''     (SOMO) LUMO (EV)   ='',         ''      ('',F6.3,'')'',F7.3)') &
      eigs(nclose+1), (eigs(i),i=nclose + 2,norbs,10000)
          end if
        end if
      end if
      if (uhf) then
        write (iw, '(      10X,''NO. OF ALPHA ELECTRONS  ='',I11)') nalpha + nint((nalpha_open - nalpha)*fract)
        write (iw, '(      10X,''NO. OF BETA  ELECTRONS  ='',I11)') nbeta + nint((nbeta_open - nbeta)*fract)
      else
        write (iw, '(      10X,''NO. OF FILLED LEVELS    ='',I11)') nopen - nopn
        if (nopn /= 0) write (iw, '(   10X,''AND NO. OF OPEN LEVELS  ='',I11)') nopn
      end if
      if (mol_weight > 0.1D0) then
        if (name /= " ") then
          write (iw, '(    10X,"MOLECULAR WEIGHT        =",F16.4, 9x, "POINT GROUP:", 2x, a)') mol_weight, name
        else
          write (iw, '(    10X,"MOLECULAR WEIGHT        =",F16.4 )') mol_weight
        end if
      end if
      call gmetry (geo, coord)
      if (id == 0) call dimens (coord, iw)
      if (id == 3) then
        vol = volume(tvec,3)
        call l_control("PRT", 3, 1)
        density = mol_weight*1.D24/fpc_10/vol
        call write_cell(iw)
        if (mers(1) > 1 .or. mers(2) > 1 .or. mers(3) > 1) &
          write (iw, '(/10X,''VOLUME OF CLUSTER       ='',&
          & F17.5,'' ANGSTROMS**3 ='',f9.3, '' CM**3/MOLE'')') &
        vol,  vol*fpc_10*1.d-24
        write(iw,*)
        call write_pressure(iw)
        call write_pressure(iw0)
      end if
      if (latom == 0) write (iw, '(/)')
      write (iw, '(10X,''SCF CALCULATIONS        =   '',I8 )') nscf
      tim = seconds(1) - time0
      i = int(tim*0.000001D0)
      tim = tim - i*1000000
      call date_and_time(VALUES=time_end)
      write(iw,*)
      call timout (iw)
      if (ndep /= 0) call symtry
      do i = 1, nvar
        xparam(i) = geo(loc(2,i),loc(1,i))
      end do
      call gmetry (geo, coord)
      if (lprtgra .and. gnorm > 0.2d0) call prt_sorted_gradients
      if (prt_gradients .and. (lprtgra .or. (prt_gradients .and. gnorm > 2.d0))) then
        write (iw, '(3/7X,''FINAL  POINT  AND  DERIVATIVES'',/)')
        if (mozyme) then
          call prtgra ()
          if (pdb_label) call modgra ()
        else
          write (iw, &
      '(''   PARAMETER     ATOM    TYPE            VALUE        GRADIENT'')')
          do i = 1, nvar
            j = loc(2,i)
            k = loc(1,i)
            l = labels(k)
            xi = xparam(i)
            if (j /= 1 .and. na(k) > 0) xi = xi*degree
            if (j==1 .or. na(k) == 0) then
              gtype = 'KCAL/ANGSTROM'
            else
              gtype = 'KCAL/RADIAN  '
            end if
          if (na(k) == 0) then
            type(1) = 'CARTESIAN X'
            type(2) = 'CARTESIAN Y'
            type(3) = 'CARTESIAN Z'
          else
            type(1) = 'BOND       '
            type(2) = 'ANGLE      '
            type(3) = 'DIHEDRAL   '
          end if
            write (iw, '(I7,I11,1X,A2,4X,A11,F13.6,F14.6,2X,A13)') &
            i, k, elemnt(l), type(j), xi, grad(i), gtype
          end do
        end if
      end if
      if (prt_coords) then
!
!     WRITE OUT THE GEOMETRY
!
        write (iw, '(3/)')
        call geout (1)
      end if
      if (prt_cart) then
        if (numat > 9999) then
          write (iw, '(/28x,'' CARTESIAN COORDINATES'',/10000(/,i6,3x,a2,3x,3F16.9))') &
            (i,elemnt(nat(i)),(coord(j,i),j=1,3),i=1,numat)
        else
          write (iw, '(/28x,'' CARTESIAN COORDINATES'',/10000(/,i4,3x,a2,3x,3F16.9))') &
            (i,elemnt(nat(i)),(coord(j,i),j=1,3),i=1,numat)
        end if
      end if
      if (mozyme) then
        i = 3*numat
        if (.not. log) call bridge_H()
      else
        i = max((numat*(numat + 1))/2, 3*numat)
      end if
      allocate(rxyz(i))
      if (.not. mozyme .and. index(keywrd,'PRTINT') /= 0) then
!
!   WRITE OUT THE INTERATOMIC DISTANCES
!
        l = 0
        do i = 1, numat
          do j = 1, i
            l = l + 1
            rxyz(l) = sqrt((coord(1,i)-coord(1,j))**2+(coord(2,i)-coord(2,j))**&
              2+(coord(3,i)-coord(3,j))**2)
          end do
        end do
        write (iw, '(2/10X,''  INTERATOMIC DISTANCES'')')
        call vecprt (rxyz, numat)
      end if
      if (.not. mozyme) then
        where (.not.eigs(:norbs)>=(-999.D0) .or. .not.eigs(:norbs)<=1000.D0)
          eigs(:norbs) = 1.D-12
        end where
        where (eigb(:norbs)<(-999.D0) .or. eigb(:norbs)>1000.D0)
          eigb(:norbs) = 1.D-12
        end where
      end if
      write(iw,"(/,a,/)")formula(:len_trim(formula))
      if (index(keywrd," HESSIAN") /= 0) then
        write(iw,"(a)") "    Hessian matrix from geometry optimization"
        do i = 1, nvar
          write(iw,"(10f10.4)")(hesinv((i - 1)*nvar + j), j = 1, i)
        end do
      end if
      if (norbs*nelecs > 0 ) then
        if (id == 0 .and. .not. mozyme) &
        write (iw, '(2/,''      MOLECULAR POINT GROUP   :   '',A4)') name
        if (index(keywrd, " RAMA") /= 0) then
          call output_rama()
        end if
        if (mozyme) then
          if (index(keywrd," RE-LOC") /= 0) then
            write(iw,"(10x,a,/)")"  LMOs being Re-Localized"
            call local_for_MOZYME("OCCUPIED")
!
!  Suppress re-localization of the virtual set.  Not of interest to users.
!
!            call local_for_MOZYME("VIRTUAL")
          end if
          if ((index(keywrd,' VEC') + index(keywrd,' ALLVEC'))*nelecs /= 0) then
            if (index(keywrd, " EIGEN") /= 0) then
              call eigen(.false., .true.)
            else
              call prtlmo()
            end if
          end if
        else
          if ((index(keywrd,' VEC') + index(keywrd,' ALLVEC'))*nelecs /= 0) then
            if (uhf) then
              write (iw, '(2/10X,''ALPHA EIGENVECTORS  '')')
            else
              write (iw, '(2/16X,''EIGENVECTORS  '')')
            end if

            call matou1 (c, eigs, norbs, norbs, norbs, 2)
            if (uhf) then
              write (iw, '(2/10X,'' BETA EIGENVECTORS  '')')
              call symtrz (cb, eigb, 1, .TRUE.)
              call matou1 (cb, eigb, norbs, norbs, norbs, 2)
            end if
          else
            if (uhf) then
              write (iw, '(2/10X,''ALPHA EIGENVALUES  '')')
            else
              write (iw, '(2/18X,''EIGENVALUES  '')')
            end if
            write (iw, '(8F10.5)') (eigs(i),i=1,norbs)
            if (uhf) then
              write (iw, '(2/10X,'' BETA EIGENVALUES '')')
             write (iw, '(8F10.5)') (eigb(i),i=1,norbs)
            end if
          end if
          if (index(keywrd,' SUPER') /= 0) then
            write (iw, '(/,10X,A,/)') ' SUPERDELOCALIZABILITIES'
            call superd (c, eigs, norbs, nelecs, numat, nat)
          end if
        end if
      end if
      if (nelecs /= 0) then
!
!   Correct density matrix, if necessary
!
        if (nclose/=nopen .and. abs(fract - 2.d0) > 1.d-20 .and. &
         fract > 1.d-20 .or. index(keywrd,' C.I.') /= 0 .and. .not. method_indo) call mecip ()
        if (prt_charges) then
          write (iw, '(2/13X,'' NET ATOMIC CHARGES AND DIPOLE CONTRIBUTIONS'',/)')
          i = 0
          do j = 1, numat
            i = Max(i, natorb(nat(j)))
          end do
          i = Nint(Sqrt(Real(i)))*12
          line = "s-Pop       p-Pop       d-Pop"
          if  (pdb_label) then
            write (iw, "(1x,' ATOM NO.                 TYPE                        CHARGE   ',&
               &'   No. of ELECS.   ',A)") line(1:i)
          else
            write (iw, "(1x,' ATOM NO.   TYPE          CHARGE   ',&
               &'   No. of ELECS.   ',A)") line(1:i)
          end if
        end if
        call chrge (p, q2)
        sum = 0.D0
        m = 0
        do i = 1, numat
          l = nat(i)
          q(i) = tore(l) - q2(i)
          sum = sum + q(i)
          if (.not. l_atom(i)) cycle
          j = Nint(Sqrt(Real(natorb(nat(i)) + 1.d-4)))
          k = nfirst(i)
          if (j > 0) then
            if (mozyme) then
              k = ijbo(i,i)
              if(j > 0) then
                rxyz(1) = p(k+1)
                if(j > 1) then
                  rxyz(2) = p(k+3) + p(k+6) + p(k+10)
                  if(j > 2) then
                    rxyz(3) = p(k+15) + p(k+21) + p(k+28) + p(k+36) + p(k+45)
                  end if
                end if
              end if
            else
              rxyz(1) = p((k*(k+1))/2)
              if(j > 1) then
                rxyz(2) = p(((k+1)*(k+2))/2) + p(((k+2)*(k+3))/2) &
                     & + p(((k+3)*(k+4))/2)
                if(j > 2) then
                  rxyz(3) = p(((k+4)*(k+5))/2) + p(((k+5)*(k+6))/2) &
                     & + p(((k+6)*(k+7))/2) + p(((k+7)*(k+8))/2) &
                     & + p(((k+8)*(k+9))/2)
                end if
              end if
            end if
          end if
          if (prt_charges) then
            if (pdb_label) then
              m = m + 1
              if (txtatm(m)(14:14) == "X") m = m + 1
              write (iw, "(I5,9X,A,4X,F15.6,F14.4,3F12.5)") i, elemnt (l)//"("//txtatm(m)(:maxtxt)//")", &
                 & q(i), q2(i), rxyz(1:j)
            else
              write (iw, "(I5,9X,A2,4X,F15.6,F14.4,3F12.5)") i, elemnt (l), &
                 & q(i), q2(i), rxyz(1:j)
            end if
          end if
        end do
        if (pdb_label .and. index(keywrd, "CONTROL_no_MOZYME") == 0) call modchg ()
        kchrge = nint(sum)
        if (id == 0) then
          if ( mozyme ) then
            dip = dipole_for_mozyme(dumy, 1)
          else
            dip = dipole(p,coord,dumy,1)
          end if
          sum = dumy(1) ! Dummy operation - to use dumy
        end if
      end if
      if (norbs > 0) then
        if (index(keywrd,' FOCK') /= 0) then
          write (iw, '('' FOCK MATRIX '')')
          call vecprt (f, norbs)
        end if
        if (mers(1) /= 0 .and. .not. mozyme .and. index(keywrd, " BRZ") /= 0) then
          bcc = index(keywrd,' BCC') /= 0
          open(unit=ibrz, file=brillouin_fn, status='UNKNOWN')
          write (ibrz,*) norbs, (max(mers(i),1), i = 1,3), bcc
          write (ibrz,*) (f(i),i=1,(norbs*(norbs + 1))/2)
          write (ibrz,*) tvec, id, numat, ((coord(j,i),j=1,3),i=1,numat)
          write (ibrz,*) (nfirst(i),nlast(i),i=1,numat)
        end if
        if (nelecs /= 0) then
          if (index(keywrd,' DENS') /= 0) then
            write (iw, '(2/,20X,'' DENSITY MATRIX IS '')')
            call vecprt (p, norbs)
          end if
          if (prt_pops) then
            write (iw, '(2/10X,''ATOMIC ORBITAL ELECTRON POPULATIONS'' ,/)')
            j = 0
            do i = 1, numat
              j = max(nlast(i) - nfirst(i), j)
            end do
            line = " "
            if (maxtxt == 0) then
              i = 2
            else if (pdb_label) then
              i = 16
            else
              i = maxtxt/2 + 2
            end if
            if (j == 8) then
                                            !12345678901234567890123456789012345678901234567890123456789012345678901234567890
              write(iw,'(a)')line(:i)//"   Atom"//line(:i)//"  s        px        py        pz      x^2-y^2"// &
              &"     xz        z^2       yz        xy"
            else if (j == 3) then
              write(iw,'(a)')line(:i)//"   Atom"//line(:i)//"  s        px        py        pz   "
            else
              write(iw,'(a)')line(:i)//"   Atom"//line(:i)//"  s   "
            end if
          end if
          if (prt_pops) then
            if (mozyme) then
              l = 0
              do i = 1, numat
                j = ijbo (i, i)
                do k = 1, iorbs(i)
                  l = l + 1
                  j = j + k
                  pdiag(l) = p(j)
                end do
              end do
              if (maxtxt > 1) then
                m = 0
                do i = 1, numat
                  m = m + 1
                  if (txtatm(m)(14:14) == "X") m = m + 1
                  write (iw, '(i5,1x,a, 9f10.5)') i, elemnt(nat(i))//"("//txtatm(m)(:maxtxt)//")", &
                  (pdiag(j), j = nfirst(i), nlast(i))
                end do
              else
                do i = 1, numat
                  write (iw, '(i5," ",a2, 9f10.5)') i, elemnt(nat(i)), (pdiag(j), j = nfirst(i), nlast(i))
                end do
              end if
            else
              if (maxtxt > 1) then
                m = 0
                do i = 1, numat
                  m = m + 1
                  if (txtatm(m)(14:14) == "X") m = m + 1
                  write (iw, '(2x, a, 9f10.5)') elemnt(nat(i))//"("//txtatm(m)(:maxtxt)//")", &
                  (p((j*(j+1))/2), j = nfirst(i), nlast(i))
                end do
              else
                do i = 1, numat
                  write (iw, '(i5," ",a2, 9f10.5)') i, elemnt(nat(i)), (p((j*(j+1))/2), j = nfirst(i), nlast(i))
                end do
              end if
            end if
          end if
          if (index(keywrd,' PI') /= 0) then
            write (iw, '(2/10X,''SIGMA-PI BOND-ORDER MATRIX'')')
            call denrot ()
          end if
        end if
        if (uhf) then
          sz = (nalpha + (nalpha_open - nalpha)*fract - (nbeta + (nbeta_open - nbeta)*fract))*0.5D0
          ss2 = sz*sz
          l = 0
          do i = 1, norbs
            do j = 1, i
              l = l + 1
              pa(l) = pa(l) - pb(l)
              ss2 = ss2 + pa(l)**2
            end do
            ss2 = ss2 - 0.5D0*pa(l)**2
          end do
          write (iw, '(2/20X,''(SZ)    ='',F12.6)') sz
          if (fract  < 1.d-5 .or. fract > 0.9999d0) then
            write (iw, '(  20X,''(S**2)  ='',F12.6)') ss2
          else
            write(iw,'(10x,a)')" Average over configurations used, so (S**2) is not meaningful"
          end if
          if (index(keywrd,' SPIN') /= 0) then
            write (iw, '(2/10X,''SPIN DENSITY MATRIX'')')
            call vecprt (pa, norbs)
          end if
          write (iw, '(2/10X,''ATOMIC ORBITAL SPIN POPULATIONS'',/)')
          j = 0
          do i = 1, numat
            j = max(nlast(i) - nfirst(i), j)
          end do
          if (j == 8) then
                                           !123456712345671234567123456712345671234567123456712345671234567
            write(iw,'(a)')"    Atom   Total    s     px     py     pz   x^2-y^2  xz     z^2    yz     xy"
          else if (j == 3) then
            write(iw,'(a)')"    Atom   Total    s     px     py     pz   "
          else
            write(iw,'(a)')"    Atom   Total    s   "
          end if
          write(iw,'(8x,a)')" Atomic"
          do i = 1, numat
            sum = 0.d0
            do j = nfirst(i), nlast(i)
              sum = sum + pa((j*(j+1))/2)
            end do
            write (iw, '(i5," ",a2, f8.4, 9f7.3)') i, elemnt(nat(i)), sum, (pa((j*(j+1))/2), j = nfirst(i), nlast(i))
          end do
          if (index(keywrd,' HYPERFINE') /= 0) then
!
!  WORK OUT THE HYPERFINE COUPLING CONSTANTS.
!
            write (iw, '(2/10X,''    HYPERFINE COUPLING COEFFICIENTS'' ,/)')
            j = (nalpha - 1)
            q(:numat) = pa(nfirst(:numat)*(nfirst(:numat)+1)/2)*0.3333333D0 + &
             c(nfirst(:numat), j)**2*0.66666666D0
            write (iw, '(5(2X,A2,I2,F9.5,1X))') (elemnt(nat(i)),i,q(i),i=1,&
              numat)
          end if
          pa = p - pb
        end if
        if (gui .or. index(keywrd,' BONDS') + index(keywrd,' ALLBO') /= 0) then
          if ( .not. mozyme) then
            if (nbeta == 0) then
              write (iw, '(/10X,''BONDING CONTRIBUTION OF EACH M.O.'',/)')
              call molval (c, p, 2.D0)
            else
              write (iw, '(/10X,''BONDING CONTRIBUTION OF EACH ALPHA M.O.'',/)')
              call molval (c, pa, 2.D0)
              write (iw, '(/10X,''BONDING CONTRIBUTION OF EACH BETA  M.O.'',/)')
              call molval (cb, pb, 2.D0)
            end if
          end if
          call bonds ()
        end if
        call to_screen("To_file: Normal output")
        i = nclose + nalpha
        if (index(keywrd,' LOCAL') + index(keywrd,' RABBIT') + index(keywrd,' BANANA') /= 0) then
          call local (c, i, eigs, 1, "c ")
          if (nbeta /= 0) then
            write (iw, '(2/10X,'' LOCALIZED BETA MOLECULAR ORBITALS'')')
            call local (cb, nbeta, eigb, 1, "cb")
          end if
        end if
        if (index(keywrd,' 1ELE') /= 0) then
          write (iw, '('' FINAL ONE-ELECTRON MATRIX '')')
          call vecprt (h, norbs)
        end if
        if (index(keywrd,' ENPART') /= 0) call enpart ()
      end if
      if (seconds(2) - time0 > 1.d7 .or. index(keywrd,' DENOUT') /= 0) call den_in_out(1)
      if ((ci .or. nopen /= nclose .and. Abs(fract - 2.d0) > 1.d-20 .and. fract > 1.d-20 .or. &
        index(keywrd,' SIZE') /= 0) .and. index(keywrd,' MECI') + index(keywrd,' ESR')/=0) then
        write (iw, &
      '(2/10X,''MULTI-ELECTRON CONFIGURATION INTERACTION CALCULATION'',2/)')
        last = 3
        sum = meci()
        if (moperr) return
      end if
      if (index(keywrd,' MULLIK') + index(keywrd,' GRAPH') /= 0 .and. .not. gui) then
        if (index(keywrd,' MULLIK') /= 0) write (iw, &
          '(/10X,'' MULLIKEN POPULATION ANALYSIS'')')
        if (mozyme) then
          if (allocated(c)) deallocate(c)
          allocate (c(norbs, norbs), stat=i)
          if (i /= 0) then
            call memory_error ("eigen")
            return
          end if
  !
  ! Convert LMOs to Eigenvectors
  !
          call lmo_to_eigenvectors(noccupied, ncf, nncf, ncocc, noccupied, &
           & icocc, icocc_dim, cocc, cocc_dim, eigs, c)
          call lmo_to_eigenvectors(nvirtual, nce, nnce, ncvir, nvirtual, icvir, &
           & icvir_dim, cvir, cvir_dim, eigs(noccupied + 1), c(1, noccupied + 1))
!
!              Convert "h" from MOZYME form to lower-half-triangle
!
          mpack = (norbs*(norbs + 1))/2
          allocate(pb(mpack))
          call convert_mat_packed_to_triangle(h, pb)
          deallocate(h)        !   "h" must be deallocated because it might be smaller than mpack
          allocate(h(mpack))   !   Re-allocate "h"
          h(:mpack) = pb(:mpack)
        end if
        call mullik ()
        if (index(keywrd,' GRAPH') /= 0) &
          write (iw,'(/10X,'' DATA FOR GRAPH WRITTEN TO DISK'')')
      end if
!
!  NOTE: ON EXIT FROM MULLIK, PB HOLDS THE MULLIKEN ANALYSIS.
!
      if (index(keywrd," SYB") /= 0) then
        call mpcsyb(q, kchrge, eionis, dip)
      else
        if (index(keywrd,' MULLIK') /= 0)  call mpcpop(-1)
      end if
      if (icalcn /= numcal) then
        inquire(unit=iarc, opened=opend)
        if ( .not. opend) then
          if (namfil == '**NULL**') namfil = archive_fn
          open(unit=iarc, file=archive_fn, status='UNKNOWN', position='asis', iostat = i)
          if (i /= 0) then
            write(iw,*) "Could not open archive file, run continuing."
            return
          end if
          rewind iarc
        end if
        if ( index(keywrd," HTML") + index(keywrd," PDBOUT") /= 0 .and. latom == 0 ) then
          line = archive_fn(:len_trim(archive_fn) - 3)
          line = archive_fn(:len_trim(archive_fn) - 3)
          do i = len_trim(line), 1, -1
            if (line(i:i) == "/" .or. line(i:i) == backslash) exit
          end do
          line = trim(line)//"pdb"
          open(unit=31, file=trim(line), status='UNKNOWN', position='asis')
          l_normal_html = .true.
          call l_control("Write_Escf", len("Write_Escf"), 1)
          call pdbout(31)
          close (31)
        end if
        if (numcal == 2) then
          if (index(keywrd, "OLDGEO") /= 0) then
!
! Write a warning that OLDGEO has been used, so user is aware that multiple ARC files are present
!
            rewind (iarc)
            do i = 1, 100000
              read(iarc,*,iostat = j)
              if (j /= 0) exit
            end do
            i = i - 1
            allocate( old_arc_file(i))
            rewind (iarc)
            do j = 1, i
              read(iarc,'(a)') old_arc_file(j)
            end do
            rewind (iarc)
            write(iarc,'(/10x,a)')"WARNING - This file contains multiple individual ARC files."
            write(iarc,'(18x,a)')"- Be careful to select the correct ARC file."
            write(iarc,'(a)')(trim(old_arc_file(j)), j = 1, i)
          end if
        end if
        icalcn = numcal
      end if
      if (moperr) return
      iwrite = iarc
      write (iwrite, "(2/20X,' SUMMARY OF ',A,' CALCULATION',/)", iostat = j) trim(caltyp)
      if (j /= 0) then
            write(iw,'(/10x,a)') "Could not write to archive file, run continuing."
            return
          end if
      write (iwrite, '(55X,''MOPAC v'',a,'' '',a)') trim(verson), trim(os)
      write (iwrite, '(55X,A24)') idate
      write(iwrite,"(/,a,/)")formula(:len_trim(formula))
      call wrttxt (iwrite)
      write (iwrite, '(2/4X,A58)') flepo(iflepo)
      write (iwrite, '(4X,A58)') iter(iscf)
      if (stress > -1.0d-6) then
        write (iwrite, &
      '(3/10X,''FINAL H.O.F PLUS STRESS ='',F17.5,'' KCAL/MOL''  ,'' ='',F14.5,'' KJ/MOL'')') escf, escf*4.184D0
        write (iwrite, &
      '(10X,''FINAL STRESS            ='',F17.5,'' KCAL/MOL''  ,'' ='',F14.5,'' KJ/MOL'')') stress, stress*4.184D0
        write (iwrite, &
      '(10X,''HEAT OF FORMATION       ='',F17.5,'' KCAL/MOL''  ,'' ='',F14.5,'' KJ/MOL'')') escf - stress, (escf - stress)*4.184D0
        write (iwrite, &
    '(10X,''TOTAL DISTORTION        ='',F17.5,'' Angstroms'' )') distortion*numat
        write (iwrite, &
    '(10X,''AVERAGE DISTORTION      ='',F17.5,'' Angstroms per atom (all atoms)'' )') distortion
        write (iwrite, &
    '(10X,''RMS DISTORTION          ='',F17.5,'' Angstroms per atom (all atoms)'' )') sqrt(rms/numat)
      else
        write (iwrite, &
      '(/10X,''HEAT OF FORMATION       ='',F17.5,'' KCAL/MOL''  ,'' ='',F14.5,'' KJ/MOL'')') escf, escf*4.184D0
      end if
      if (index(keywrd," DISP") /= 0) then
        if (index(keywrd,' EPS') /= 0) then
          write(iwrite,'(/10x,"TOTAL ENERGY            =",f17.5,a)') &
          (elect + enuclr)*fpc_9, " KCAL/MOL = ELECTRONIC ENERGY + CORE-CORE REPULSION + SOLVATION ENERGY"
        else
          write(iwrite,'(/10x,"TOTAL ENERGY            =",f17.5,a)') &
          (elect + enuclr)*fpc_9, " KCAL/MOL = ELECTRONIC ENERGY + CORE-CORE REPULSION"
        end if
        write(iwrite,'(10x,"ENERGY OF ATOMS         =",f17.5,a)') atheat, " KCAL/MOL"
        if (index(keywrd,' EPS') /= 0) then
          if (abs(solv_energy) > 1.d-1) then
            write (iwrite, '(    10X,''SOLVATION ENERGY        ='',F17.5,'' KCAL/MOL''   )') solv_energy*fpc_9
          else if (.not. mozyme) then
            write (iwrite, '(/10X,"SOLVATION ENERGY CAN ONLY BE PRINTED WHEN MOZYME IS USED",/)')
          end if
        end if
        write(iwrite,'(10x,"                    SUM =",f17.5,a)') &
        (elect + enuclr)*fpc_9 + atheat + solv_energy*fpc_9, " KCAL/MOL"
        if (abs(hpress) > 1.d-5)      write(iwrite,'(10x,"ENERGY DUE TO PRESSURE  =",f17.5,a)') hpress, " KCAL/MOL"
        write(iwrite,'(10x,"DISPERSION ENERGY       =", f17.5, a)') e_disp, " KCAL/MOL"
        if (E_hb < -1.d-5) write(iwrite,'(10x,"H-BOND ENERGY           =", f17.5, a)') e_hb, " KCAL/MOL"
        if (E_hh > 1.d-5)  write(iwrite,'(10x,"H - H CORRECTION ENERGY =", f17.5, a)') e_hh, " KCAL/MOL"
        if (abs(nsp2_corr) > 1.d-5)   write(iwrite,'(10x,"MM CORRECTION FOR >N-   =",f17.5,a)') nsp2_corr, " KCAL/MOL"
        if (abs(Si_O_H_corr) > 1.d-5) write(iwrite,'(10x,"MM CORR. FOR Si-O-H     =",f17.5,a)') Si_O_H_corr, " KCAL/MOL"
        if (abs(sum_dihed) > 1.d-5)   write(iwrite,'(10x,"MM CORR. FOR -CO-NH-    =",f17.5,a)') sum_dihed, " KCAL/MOL"
        sum = (elect + enuclr)*fpc_9 + atheat + hpress + solv_energy*fpc_9 + nsp2_corr + Si_O_H_corr + sum_dihed + &
          e_disp + e_hb + e_hh
        write(iwrite,'(30x,"SUM =",f17.5,a,/)') sum, " KCAL/MOL = FINAL HEAT OF FORMATION"
        if (abs(sum - escf + stress) > 1.d-3*numat) then
          write(iwrite,'(5x,"*",4x,a,/)')"WARNING - An energy term is incorrect or missing!"
          write(iwrite,'(5x,"*",4x,''FINAL HEAT OF FORMATION     ='',F13.5,'' KCAL/MOL'')') escf - stress
          write(iwrite,'(5x,"*",4x,"SUM OF CONTRIBUTIONS TO HoF =",f13.5,a)') sum, " KCAL/MOL"
          write(iwrite,'(5x,"*",21x,"DIFFERENCE =",f13.5,a,/)') escf - stress - sum, " KCAL/MOL"
        end if
        if (N_Hbonds > 0)  write(iwrite,'(10x,"No. OF HYDROGEN BONDS   =", i11,7x,a, /)') &
          N_Hbonds, "(H-bond Energy < -1.0 Kcal/mol)"
      end if
      if (numat > 1 .and. iscf == 1 .and. escf > 1.d4 .and. index(keywrd, " CHECK") == 0) &
        write(iwrite,'(//10x,a,//)') "Calculated Heat of Formation is very large, re-run using keyword 'CHECK'"
      if (id == 3 .or. id == 1) call write_unit_cell_HOF(iwrite)
      if (index(keywrd," DISP") /= 0) then
        write (iwrite, '(    10X,''TOTAL ENERGY            ='',F17.5,'' EV'' )') elect + enuclr + solv_energy
        write (iwrite, '(  10X,''ELECTRONIC ENERGY       ='',F17.5,'' EV'')')  elect
        write (iwrite, '(  10X,''CORE-CORE REPULSION     ='',F17.5,'' EV'')')  enuclr
        if (abs(solv_energy) > 1.d-1) &
          write (iwrite, '(    10X,''SOLVATION ENERGY        ='',F17.5,'' EV''   )') solv_energy
      end if
      if (abs(ediel) > 1.d-5) then
        write (iwrite, '(    10X,''DIELECTRIC ENERGY       ='',F17.5,'' EV''   )') ediel
      end if
      if (Abs (pressure) > 1.d-4) then
        if (id == 1) then
          else if (id == 3) then
          sum =  volume (tvec, 3)
          write (iwrite, '(    10X,''ENERGY DUE TO PRESSURE  ='',F17.5,'' KCAL/MOL''    )') &
          hpress
          sum = -(4184.d0*10.d0**30)*pressure/fpc_10
          if (abs(sum) > 1.d9) then
            write (iwrite, '(10X,''PRESSURE                ='',F17.5,'' Gp''    )') sum*1.d-9
          else
            write (iwrite, '(10X,''PRESSURE                ='',F17.5,'' Pascals''    )') sum
          end if
        end if
      end if
      if (id == 3) then
        call l_control("PRT", 3, 1)
        call write_cell(iwrite)
        write(iwrite,'(" ")')
        if (mers(1) > 1 .or. mers(2) > 1 .or. mers(3) > 1) &
          write (iwrite, '(/10X,''VOLUME OF CLUSTER       ='',&
          & F17.5,'' ANGSTROMS**3 ='',f9.3, '' CM**3/MOLE'')') &
          vol,  vol*fpc_10*1.d-24
        write(iwrite,*)
      end if
      if (lprtgra .or. gnorm /= 0.D0) write (iwrite, &
        '(  10X, "GRADIENT NORM           =",F17.5, 10x, "=", 7x, f'//num//'.5, " PER ATOM")') gnorm, gnorm/sqrt(1.0*numat)
      if (latom == 0) then
        if (.not.still) then
          write (iwrite, '(9x,A)') &
          ' WARNING -- GEOMETRY IS NOT AT A STATIONARY POINT'
          call web_message(iwrite,"Warning_geometry.html")
        end if
      else
        grtype = ' KCAL/ANGSTROM'
        if (lparam == 1) then
          write (iwrite, &
      '(    10X,''FOR REACTION COORDINATE =  '',F16.4,'' ANGSTROMS'')')&
             xreact
        else
          if (na(latom) /= 0) grtype = ' KCAL/RADIAN  '
          write (iwrite, '(    10X,''FOR REACTION COORDINATE ='',F16.4,'' DEGREES'')') &
            xreact*degree
        end if
        write (iwrite, '(    10X,''REACTION GRADIENT       ='',F18.6,A14     )'&
          ) gcoord(1,1), grtype
      end if
      if(id == 0) then
        if(name /= " ") then
          write (iwrite, '(  10X,''DIPOLE                  ='',F17.5, " DEBYE   POINT GROUP:", 2x,A)') dip, name
        else
          write (iwrite, '(  10X,''DIPOLE                  ='',F17.5,  '' DEBYE   '')') dip
        end if
      end  if
      if (uhf) then
        write (iwrite, '(  10X,''(SZ)                    =  '',F16.6)') sz
        if (fract  < 1.d-5 .or. fract > 0.9999d0) then
            write (iwrite, '(  10X,''(S**2)                  =  '',F16.6)') ss2
          else
            write(iwrite,'(10x,a)')" Average over configurations used, so (S**2) is not meaningful"
          end if
        write (iwrite, '(  10X,''NO. OF ALPHA ELECTRONS  =  '',I9)') nalpha + nint((nalpha_open - nalpha)*fract)
        write (iwrite, '(  10X,''NO. OF BETA  ELECTRONS  =  '',I9)') nbeta + nint((nbeta_open - nbeta)*fract)
      else
        write (iwrite, '(      10X,''NO. OF FILLED LEVELS    =  '',I9, 3a)') nopen - nopn
        if (nopn /= 0) write (iwrite, &
          '(  10X,''AND NO. OF OPEN LEVELS  =  '',I9)') nopn
      end if
      if (ci .or. nopen /= nclose .and. Abs(fract - 2.d0) > 1.d-20 .and. fract > 1.d-20) &
         write (iwrite, '(  10X,''CONFIGURATION INTERACTION WAS USED'')')
      if (kchrge /= 0) write (iwrite, &
        '(  SP, 10X,''CHARGE ON SYSTEM        =  '',I9)') kchrge
      if ( .not. mozyme ) then
        if (state_Irred_Rep /= " ") then
          write(line, '(11x, "STATE:  ",i2,1x,3A)') state_QN, state_spin, state_Irred_Rep
        else
          line = " "
        end if
        write (iwrite, &
        '(  10X,"IONIZATION POTENTIAL    =  ",F16.6," EV", a)') eionis, trim(line)
        if (uhf) then
          if (nalpha >= 1) write (iwrite, &
          '(  10X,''ALPHA SOMO LUMO (EV)    =  '',F13.3,F7.3)') eigs(nalpha), &
          (eigs(i),i=nalpha + 1,norbs,10000)
          if (nbeta >= 1) write (iwrite, &
          '(  10X,''BETA  SOMO LUMO (EV)    =  '',F13.3,F7.3)') eigb(nbeta), &
          (eigb(i),i=nbeta + 1,norbs,10000)
        else if (nopen == nclose) then
          if (nopen >= 1) write (iwrite, &
          '(  10X,''HOMO LUMO ENERGIES (EV) =  '',F13.3,F7.3)') eigs(nopen), &
          (eigs(i),i=nopen + 1,norbs,10000)
          else if (nopn == 1) then
            if (nclose >= 1) then
            write (iwrite, &
      '(  10X,''HOMO (SOMO) LUMO (EV)   ='',F13.3,   '' ('',F7.3,'')'',F7.3)') &
            eigs(nclose), (eigs(i),i=nclose + 1,norbs,10000), &
            (eigs(i),i=nclose + 2,norbs,10000)
          else
            write (iwrite, &
      '(  10X,''     (SOMO) LUMO (EV)   ='',         ''      ('',F6.3,'')'',F7.3)') &
      eigs(nclose+1), (eigs(i),i=nclose + 2,norbs,10000)
          end if
        end if
      end if
      if (index(keywrd," PKA") /= 0 .and. no_pKa > 0 ) then
        write(iwrite,'(/24x,a,/)')"    pKa for hydroxyl hydrogens"
        j = index(txtatm(ipKa_sorted(1)), "(")
        if (j /= 0) then
          write(iwrite, '(10x,a)') &
          &"        Sorted by pKa                    Sorted by atom", &
          &"Atom        Label         pKa      Atom        Label         pKa"
          do i = 1, no_pKa
            j = index(txtatm(ipKa_sorted(i)), "(")
            k = index(txtatm(ipKa_sorted(i)), ")")
            l = index(txtatm(ipKa_unsorted(i)), "(")
            m = index(txtatm(ipKa_unsorted(i)), ")")
            write(iwrite,"(9x,i5, a, f8.3,i9,a,f8.3)")ipKa_sorted(i), "  "//txtatm(ipKa_sorted(i))(j:k), &
               pKa_sorted(i), ipKa_unsorted(i), "  "//txtatm(ipKa_unsorted(i))(l:m), pKa_unsorted(i)
          end do
        else
         write(iwrite, '(22x,a)') &
            &"Sorted by pKa       Sorted by atom", &
            &"Atom      pKa       Atom      pKa"
            do i = 1, no_pKa
              write(iwrite,"(21x,i5, f11.3,i9,f11.3)")ipKa_sorted(i), &
                 pKa_sorted(i), ipKa_unsorted(i), pKa_unsorted(i)
            end do
        end if
        write(iwrite,*)
      end if
      write (iwrite, '(  10X,''MOLECULAR WEIGHT        =  '',F14.4)') mol_weight
      if (id == 3) then
    !    call write_cell(iwrite)
        call write_pressure(iwrite)
      end if
      if (fepsi > 1.d-10 .and. area > 1.d-3) then
        write (iwrite, "(10X,A,F14.2,A)") "COSMO AREA              =", area, &
             & " SQUARE ANGSTROMS"
        write (iwrite, "(10X,A,F14.2,A)") "COSMO VOLUME            =", cosvol, &
             & " CUBIC ANGSTROMS"
      end if
      if (id == 0) call dimens (coord, iwrite)
      write (iwrite, '(  10X,''SCF CALCULATIONS        =  '',I9)') nscf
      call timout (iwrite)
      if (index(keywrd," PRTCHAR") /= 0) then
        write (iwrite, '(2/10X,''FINAL GEOMETRY OBTAINED'',36X,''CHARGE'')')
      else
        write (iwrite, '(2/10X,''FINAL GEOMETRY OBTAINED'')')
      end if
      call geout (iwrite)
      if (index(keywrd,' AIGOUT') /= 0) then
        write (iwrite, '(2/,A)') '  GEOMETRY IN GAUSSIAN Z-MATRIX STYLE'
        call wrttxt (iwrite)
        call geoutg (iwrite)
      end if
   !   if (in_house_only) call write_paras_used(iwrite)
      nscf = 0
      return
      end subroutine writmo
!
      subroutine empiri ()
      use molkst_C, only : numat, formula
      use Common_arrays_C, only : nat
      use chanel_C, only : log, ilog
      implicit  none
      integer :: i, j, k, nlab
      character  :: elemnt(107)*2, line*120
      integer, dimension (50) :: llab, mlab
      intrinsic Char, Ichar, Int, Log10
      data elemnt / "H ", "He", "Li", "Be", "B ", "C ", "N ", "O ", "F ", "Ne", &
     & "Na", "Mg", "Al", "Si", "P ", "S ", "Cl", "Ar", "K ", "Ca", "Sc", "Ti", &
     & "V ", "Cr", "Mn", "Fe", "Co", "Ni", "Cu", "Zn", "Ga", "Ge", "As", "Se", "Br", &
     & "Kr", "Rb", "Sr", "Y ", "Zr", "Nb", "Mo", "Tc", "Ru", "Rh", "Pd", "Ag", &
     & "Cd", "In", "Sn", "Sb", "Te", "I ", "Xe", "Cs", "Ba", "La", "Ce", "Pr", &
     & "Nd", "Pm", "Sm", "Eu", "Gd", "Tb", "Dy", "Ho", "Er", "Tm", "Yb", "Lu", &
     & "Hf", "Ta", "W ", "Re", "Os", "Ir", "Pt", "Au", "Hg", "Tl", "Pb", "Bi", "Po", &
     & "At", "Rn", "Fr", "Ra", "Ac", "Th", "Pa", "U ", "Np", "Pu", "Am", "Cm", &
     & "Bk", "Mi", "XX", "+3", "-3", "Cb", "++", "+ ", "--", "- ", "Tv" /
     !
     !    The order of elements in the empirical formula is C H N O, then
     !    whatever else there is, in no particular order.  (The order of the
     !    remaining elements is the order in which they occur in the
     !    molecule.
     !
      nlab = 4
      llab = 0
      llab(1) = 6
      llab(2) = 1
      llab(3) = 7
      llab(4) = 8
      do i = 1, 4
        mlab(i) = 0
      end do
      do i = 1, numat
        j = nat(i)
        do k = 1, nlab
          if (j == llab(k)) go to 1000
        end do
        nlab = nlab + 1
        llab(nlab) = j
        mlab(nlab) = 1
        cycle
  1000  mlab(k) = mlab(k) + 1
      end do
      if (llab(nlab) == 0) nlab = nlab - 1
      j = 0
      do i = 1, nlab
        if (mlab(i) /= 0) then
          j = j + 1
          mlab(j) = mlab(i)
          llab(j) = llab(i)
        end if
      end do
      nlab = j
     !
     !   BUILD THE FORMAT STATEMENT
      line = "(10X,A,1X,"
      j = 11
      do i = 1, nlab
        if (i /= 1) then
          j = j + 1
          line (j:j) = ","
        end if
        j = j + 1
        !                       CHARACTER FORMAT
        line (j:j) = "A"
        k = 2
        if (elemnt(llab(i)) (2:2) == " ") then
          k = 1
        end if
        j = j + 1
        line (j:j) = Char (k+Ichar ("0"))
        j = j + 1
        !                       NUMBER FORMAT
        if (mlab(i) > 1) then
           !***********************************************************************
          line (j:j+5) = ",I" // Char (Int(Log10(1.0*mlab(i)))+Ichar ("1")) // ",1X"
          j = j + 5
        else
          mlab(i) = 0
  !
  !  If formula goes over nline characters, exit.  The system is obviously artificial
  !
        if ( j + 4 > 400 ) return
          line (j:j+4) = ",I1.0"
          j = j + 4
        end if
      end do
      j = j + 1
      line (j:j+2) = ")"
      write (formula, line) " Empirical Formula:", (elemnt(llab(i)), mlab(i), i=1, nlab)
      write(formula(len_trim(formula) + 1:),"(a,i6,a)")"  =",numat," atoms"
      if (log) write(ilog, line(1:len_trim(line) - 1)//",a,i6,a)") " Empirical Formula:", &
        (elemnt(llab(i)), mlab(i), i=1, nlab),"  =",numat," atoms"
  end subroutine empiri
!
  subroutine coswrt()
!
  use cosmo_C, only : area, ediel, cosvol, fepsi, amat, nsetf, &
    nps, qscnet, srad, qscat, arat, cosurf, phinet, iatsp, solv_energy
!
  use chanel_C, only : iwc, cosmo_fn, ir
!
  use molkst_C, only : keywrd, numat, escf, elect, enuclr, line, mozyme
!
  use common_arrays_C, only : nat, coord
!
  use funcon_C, only : a0, ev
!
  use linear_cosmo, only : am1dft_solve
!
  implicit none
  double precision :: sum
  integer :: i, j, k, i1, i2, ips, ix
  double precision :: fcon, dqam1dft, dd, enew
    open (unit=iwc, file=cosmo_fn, status='unknown')
    if (index(keywrd,'COSCCH') > 0) then
      fcon=a0*ev
10    read(ir,'(a)',err=30,end=30) line
        if(index(line,'dq:') == 0) goto 20
        read(line(5:),*) i1,i2,dqam1dft
        do ips=1,nps
          dd=0.d0
          do ix=1,3
           dd=dd+(cosurf(ix,ips)-(coord(ix,i1)+coord(ix,i2))/2)**2
          end do
          phinet(ips,3)=phinet(ips,3)-dqam1dft/sqrt(dd)
        end do
        goto 10
20      do i=1,numat
          read(line,*,err=30) dqam1dft
          do ips=1,nps
            dd=0.d0
            do ix=1,3
             dd=dd+(cosurf(ix,ips)-coord(ix,i))**2
            end do
            phinet(ips,3)=phinet(ips,3)-dqam1dft/sqrt(dd)
          end do
          read(ir,'(a)',err=30,end=30) line
        end do
30    continue
      if (mozyme) then
        qscnet(1:nps, 3) = qscnet(1:nps, 3) / (-fepsi)
        call am1dft_solve (qscnet(:, 3), phinet(:, 3), nps)
      else
        call coscl2(amat, nsetf, qscnet(1,3), phinet(1,3), nps)
      end if
!
! SCALE QSCNUC AND CALCULATE INTERACTION ENERGY
!
      enew = 0.d0
      do i = 1, nps
        qscnet(i,3) =  -fepsi*qscnet(i,3)
        enew = enew + qscnet(i,3)*phinet(i,3)
      end do
      ediel = fcon*enew*0.5d0
    end if
    write (iwc, "(a)") keywrd (1:80)
    write (iwc, "(a)") keywrd (81:160)
    write (iwc, "(a)") keywrd (161:240)
    sum = 0.d0
    do i = 1, nps
      sum = sum + qscnet(i, 3)
    end do
    write (iwc, "(/10x,'FINAL HEAT OF FORMATION =',f17.5,' KCAL/MOL',' = ', f12.5,' KJ/MOL')") &
       escf, escf * 4.184d0
    write (iwc, "(    10X,'TOTAL ENERGY            =',F17.5,      ' EV')") &
       & elect + enuclr + solv_energy
    write (iwc, "(    10X,'DIELECTRIC ENERGY       =',F17.5,      ' EV')") &
       & ediel
    write (iwc, "(10X,A,F14.2,A)") "COSMO AREA              =", area, " SQUARE ANGSTROMS"
    write (iwc, "(10X,A,F14.2,A)") "COSMO VOLUME            =", cosvol, " CUBIC ANGSTROMS"
    write (iwc, "(    10X,'TOTAL COSMO CHARGE      =',F17.5,a,/)") &
       & sum
    call web_message(iwc,"COSWRT.html")
    write (iwc, "(10X,A)") "ATOMIC DATA "
    write (iwc, "(2x,a10,4x,a24,10x,a13,2x,a12,A7,5x,a8)") " NR. ELEM.", "COORDINATES", &
       & "RADIUS  ", "COSMO-CHARGE", "AREA", "SIGMA"
    do i = 1, numat
     write (iwc, "(2i5,4x,7F12.6)") i, nat (i), &
       (coord(j, i), j=1, 3), srad(i), qscat(i), arat(i), qscat(i) / Max (arat(i), 1.d-10)
    end do
    write (iwc, "(/10X,A,i8)") " SEGMENT DATA: NPS=", nps
    write (iwc, "(a15,a36,5A12)") " NR. ATOM ELEM.", &
      & "COORDINATES (X, Y, Z)     ", "COSMO-CHARGE", " AREA ", &
      & "SIGMA", "POTENTIAL"
    do i = 1, nps
      k=0
      do j=1,3
        sum=cosurf(j,i)
        if(log10(abs(sum)).gt.4) k=max(k,int(log10(abs(sum))-3))
        if(sum.lt.0.0.and. log10(abs(sum)).gt.3) &
&                   k=max(k,int(log10(abs(sum))-2))
      end do
      if(k.eq.0) write (iwc, "(3i5,7F12.6)") i, iatsp (i), nat (iatsp(i)), &
&       (cosurf(j, i), j=1, 3), qscnet(i, 3), cosurf(4, i), &
&        qscnet(i, 3) / cosurf(4, i), phinet(i, 3)
      if(k.eq.1) write (iwc, "(3i5,7F12.5)") i, iatsp (i), nat (iatsp(i)), &
&       (cosurf(j, i), j=1, 3), qscnet(i, 3), cosurf(4, i), &
&        qscnet(i, 3) / cosurf(4, i), phinet(i, 3)
      if(k.eq.2) write (iwc, "(3i5,7F12.4)") i, iatsp (i), nat (iatsp(i)), &
&       (cosurf(j, i), j=1, 3), qscnet(i, 3), cosurf(4, i), &
&        qscnet(i, 3) / cosurf(4, i), phinet(i, 3)
    end do
  end subroutine coswrt
  subroutine write_paras_used(iwrt)
    use Common_arrays_C, only : nat
    USE parameters_C, only : guess1, guess2, guess3, gpp, gp2, hsp, gss, gsp, betas, betap, betad, &
      zs, zp, zd, uss, upp, udd, zsn, zpn, zdn, pocord, alpb, xfac, &
      f0sd, g2sd, main_group, alp
    use molkst_C, only : numat
    implicit none
    integer, intent(in) :: iwrt
!
!  Local
!
    integer :: i, j, k
    logical :: els(107) = .false.
    character :: elemnt(107)*2, num1*1
!-----------------------------------------------
      data (elemnt(i),i=1,107)/ 'H ', 'HE', 'LI', 'BE', 'B ', 'C ', 'N ', 'O '&
        , 'F ', 'NE', 'NA', 'MG', 'AL', 'SI', 'P ', 'S ', 'CL', 'AR', 'K ', &
        'CA', 'SC', 'TI', 'V ', 'CR', 'MN', 'FE', 'CO', 'NI', 'CU', 'ZN', 'GA'&
        , 'GE', 'AS', 'SE', 'BR', 'KR', 'RB', 'SR', 'Y ', 'ZR', 'NB', 'MO', &
        'TC', 'RU', 'RH', 'PD', 'AG', 'CD', 'IN', 'SN', 'SB', 'TE', 'I ', 'XE'&
        , 'CS', 'BA', 'LA', 'CE', 'PR', 'ND', 'PM', 'SM', 'EU', 'GD', 'TB', &
        'DY', 'HO', 'ER', 'TM', 'YB', 'LU', 'HF', 'TA', 'W ', 'RE', 'OS', 'IR'&
        , 'PT', 'AU', 'HG', 'TL', 'PB', 'BI', 'PO', 'AT', 'RN', 'FR', 'RA', &
        'AC', 'TH', 'PA', 'U ', 'NP', 'PU', 'AM', 'CM', 'BK', 'MI', 'XX', 'FM'&
        , 'MD', 'CB', '++', '+', '--', '-', 'TV'/
      do i = 1, numat
        els(min(99,max(1,nat(i)))) = .true.
      end do
      write (iwrt, "(//,16X,A)") " Parameters used"
      write (iwrt, "(/5X, ' Parameter Type  Element    Parameter')")
      do i = 1, 98
        if (.not. els(i)) cycle
        if (uss(i) /= 0.D0)   write (iwrt, "(10x,A7,9x,A2,F16.6)") "USS  ", elemnt(i), uss(i)
        if (upp(i) /= 0.D0)   write (iwrt, "(10x,A7,9x,A2,F16.6)") "UPP  ", elemnt(i), upp(i)
        if (udd(i) /= 0.D0)   write (iwrt, "(10x,A7,9x,A2,F16.6)") "UDD  ", elemnt(i), udd(i)
        if (betas(i) /= 0.D0) write (iwrt, "(10x,A7,9x,A2,F16.6)") "BETAS", elemnt(i), betas(i)
        if (betap(i) /= 0.D0) write (iwrt, "(10x,A7,9x,A2,F16.6)") "BETAP", elemnt(i), betap(i)
        if (betad(i) /= 0.D0) write (iwrt, "(10x,A7,9x,A2,F16.6)") "BETAD", elemnt(i), betad(i)
        if (zs(i) /= 0.D0)    write (iwrt, "(10x,A7,9x,A2,F16.6)") "ZS   ", elemnt(i), zs(i)
        if (zp(i) /= 0.D0)    write (iwrt, "(10x,A7,9x,A2,F16.6)") "ZP   ", elemnt(i), zp(i)
        if (zd(i) /= 0.D0)    write (iwrt, "(10x,A7,9x,A2,F16.6)") "ZD   ", elemnt(i), zd(i)
        if (zsn(i) /= 0.D0)   write (iwrt, "(10x,A7,9x,A2,F16.6)") "ZSN  ", elemnt(i), zsn(i)
        if (zpn(i) /= 0.D0)   write (iwrt, "(10x,A7,9x,A2,F16.6)") "ZPN  ", elemnt(i), zpn(i)
        if (zdn(i) /= 0.D0)   write (iwrt, "(10x,A7,9x,A2,F16.6)") "ZDN  ", elemnt(i), zdn(i)
        if (alp(i) /= 0.D0)   write (iwrt, "(10x,A7,9x,A2,F16.6)") "ALP  ", elemnt(i), alp(i)
        if (gss(i) /= 0.D0)   write (iwrt, "(10x,A7,9x,A2,F16.6)") "GSS  ", elemnt(i), gss(i)
        if (gsp(i) /= 0.D0)   write (iwrt, "(10x,A7,9x,A2,F16.6)") "GSP  ", elemnt(i), gsp(i)
        if (gpp(i) /= 0.D0)   write (iwrt, "(10x,A7,9x,A2,F16.6)") "GPP  ", elemnt(i), gpp(i)
        if (gp2(i) /= 0.D0)   write (iwrt, "(10x,A7,9x,A2,F16.6)") "GP2  ", elemnt(i), gp2(i)
        if (hsp(i) /= 0.D0)   write (iwrt, "(10x,A7,9x,A2,F16.6)") "HSP  ", elemnt(i), hsp(i)
        if (pocord(i) /= 0.D0)write (iwrt, "(10x,A7,9x,A2,F16.6)") "POC  ", elemnt(i), pocord(i)
        if (.not. main_group(i) .and. f0sd(i) /= 0.D0) write (iwrt, "(10x,A7,9x,A2,F16.6)") "F0SD ", elemnt(i), f0sd(i)
        if (.not. main_group(i) .and. g2sd(i) /= 0.D0) write (iwrt, "(10x,A7,9x,A2,F16.6)") "G2SD ", elemnt(i), g2sd(i)
        if (i /= 99) then
          do j = 1, 4
            if (guess1(i,j) /= 0.D0) write (iwrt, '(12X,a3,I1,10x,a2,f16.6)')"FN1", j, elemnt(i), guess1(i,j)
            if (guess2(i,j) /= 0.D0) write (iwrt, '(12X,a3,I1,10x,a2,f16.6)')"FN2", j, elemnt(i), guess2(i,j)
            if (guess3(i,j) /= 0.D0) write (iwrt, '(12X,a3,I1,10x,a2,f16.6)')"FN3", j, elemnt(i), guess3(i,j)
          end do
        else
          do j = 1, 4
            if (guess1(i,j) /= 0.D0) then
              k = 1 + 3*(j - 1)
              if (k < 10) then
                num1 = "1"
              else
                num1 = "2"
              end if
              write (iwrt, &
                '(6X,"data gues1(",I3,",",I1,")/",          F17.6,"D0/ ! = PAR",i'//num1//')')&
                 i, j, guess1(i,j),k
            end if
            if (guess2(i,j) /= 0.D0) then
              k = 2 + 3*(j - 1)
              if (k < 10) then
                num1 = "1"
              else
                num1 = "2"
              end if
              write (iwrt, &
                '(6X,"data gues2(",I3,",",I1,")/",          F17.6,"D0/ ! = PAR",i'//num1//')')&
                 i, j, guess2(i,j),k
            end if
            if (guess3(i,j) /= 0.D0) then
              k = 3 + 3*(j - 1)
              if (k < 10) then
                num1 = "1"
              else
                num1 = "2"
              end if
              write (iwrt, &
                '(6X,"data gues3(",I3,",",I1,")/",          F17.6,"D0/ ! = PAR",i'//num1//')')&
                 i, j, guess3(i,j),k
            end if
          end do
        end if
        do j = 1, i
          if (.not.els(j)) cycle
          if (Abs(alpb(i,j)) > 0.01d0) write(iwrt,"(12x,a,a2,7x,a,f16.6)") "ALPB_",elemnt(j), elemnt(i), alpb(i,j)
          if (Abs(xfac(i,j)) > 0.01d0) write(iwrt,"(12x,a,a2,7x,a,f16.6)") "XFAC_",elemnt(j), elemnt(i), xfac(i,j)
        end do
      end do
    end subroutine write_paras_used


    subroutine PM7_TS()
    use common_arrays_C, only : grad, xparam
    use molkst_C, only : escf, moperr, mpack
    use chanel_C, only : iw
    implicit none
    integer :: i
    i = mpack
    call moldat(1)
    moperr = .false. ! An error in moldat is not important here.
    mpack = i
    call calpar
    call compfg (xparam, .TRUE., escf, .TRUE., grad, .FALSE.)
     write (iw, '(4/10X,''FINAL HEAT OF FORMATION ='',F17.5,'' KCAL/MOL''  ,'' ='',F14.5,'' KJ/MOL'')') escf, escf*4.184D0
    return
  end subroutine PM7_TS

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine symt(h, deldip, ha)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use symmetry_C, only : nsym, ipo, r
      use molkst_C, only : numat
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision , intent(inout) :: h(*)
      double precision , intent(inout) :: deldip(3,*)
      double precision , intent(inout) :: ha(*)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, n, i3, i6, j, k, l, j3, k3, k6, l3, l6, iel33
      double precision, dimension(9) :: temp, temp2
      double precision, dimension(3,3*numat) :: deltmp
!-----------------------------------------------
!****************************************************************
!
!   ON INPUT   H    = HESSIAN MATRIX, PACKED LOWER HALF TRIANGLE
!              R    = SYMMETRY OPERATIONS
!              IPO  = MAP OF ATOMS MOVED
!              NSYM = NUMBER OF SYMMETRY OPERATIONS
!
!   ON OUTPUT  H    = SYMMETRIZED HESSIAN MATRIX
!
!****************************************************************
!  A subroutine that will symmetrize the Hamiltonian, or other matrix
!     by successive application of group operations.  The method used
!     is R H R  added to HA then divided by the total number of symmetry
!     operations used.  This in effects averages all the values in a
!     symmetry correct fashion.
!
!
!
!  Variables used:  (n represents the number of atomic centers)
!     H(3n,3n):  Input/output matrix.  It is a packed lower half triangu
!        matrix.  Commonly, the Hessian.
!     HA(3n,3n): An internal matrix used to sum the symatrized Hessian
!     NSYM:      Input, the value of this symmetry operation.
!     TEMP(9), TEMP2(9):   Temporary matricies used to hold small parts
!          larger matricies for specific matrix operations.
!
!    For the next two items, the last indicy represents the symmetry
!        operation number.
!     IPO(n,*):  A vector that contains the symmetry mapping of atomic c
!
!   Skip this subroutine if NSYMM <= 0.  This implies that only E is pre
      if (nsym < 2) return
!
      ha(:numat*(9*numat+3)/2) = 0.D0
!
      deltmp(1,:numat*3) = 0.D0
      deltmp(2,:numat*3) = 0.D0
      deltmp(3,:numat*3) = 0.D0
!
      do n = 1, nsym
!
!  Now, to actually perform R H R
        do i = 1, numat
          i3 = 3*i
          i6 = 6*i
          do j = 1, i - 1
!
!  Do this multiplication in a 3 by 3 block at a time.  Store H(i,j) in
!    HA( IPO(I,N), IPO(J,N)) or HS( IPO(I,N), IPO(J,N))
!
            k = ipo(i,n)
            l = ipo(j,n)
            j3 = 3*j
            k3 = 3*k
            k6 = 6*k
            l3 = 3*l
            l6 = 6*l
            if (k > l) then
              iel33 = (k3*(k3 - 1))/2 + l3
              temp(9) = h(iel33)
              temp(8) = h(iel33-1)
              temp(7) = h(iel33-2)
              temp(6) = h(iel33-k3+1)
              temp(5) = h(iel33-k3)
              temp(4) = h(iel33-k3-1)
              temp(3) = h(iel33-k6+3)
              temp(2) = h(iel33-k6+2)
              temp(1) = h(iel33-k6+1)
            else
              iel33 = (l3*(l3 - 1))/2 + k3
              temp(9) = h(iel33)
              temp(6) = h(iel33-1)
              temp(3) = h(iel33-2)
              temp(8) = h(iel33-l3+1)
              temp(5) = h(iel33-l3)
              temp(2) = h(iel33-l3-1)
              temp(7) = h(iel33-l6+3)
              temp(4) = h(iel33-l6+2)
              temp(1) = h(iel33-l6+1)
            end if
!
            call mat33 (r(1,n), temp, temp2)
!
            iel33 = (i3*(i3 - 1))/2 + j3
            ha(iel33) = temp2(9) + ha(iel33)
            ha(iel33-1) = temp2(8) + ha(iel33-1)
            ha(iel33-2) = temp2(7) + ha(iel33-2)
            ha(iel33-i*3+1) = temp2(6) + ha(iel33-i3+1)
            ha(iel33-i*3) = temp2(5) + ha(iel33-i3)
            ha(iel33-i*3-1) = temp2(4) + ha(iel33-i3-1)
            ha(iel33-6*i+3) = temp2(3) + ha(iel33-i6+3)
            ha(iel33-6*i+2) = temp2(2) + ha(iel33-i6+2)
            ha(iel33-6*i+1) = temp2(1) + ha(iel33-i6+1)
          end do
          k = ipo(i,n)
          k3 = 3*k
          k6 = 6*k
          iel33 = (k3*(k3 + 1))/2
          temp(9) = h(iel33)
          temp(8) = h(iel33-1)
          temp(7) = h(iel33-2)
          temp(6) = temp(8)
          temp(5) = h(iel33-k3)
          temp(4) = h(iel33-k3-1)
          temp(3) = temp(7)
          temp(2) = temp(4)
          temp(1) = h(iel33-k6+1)
!
          call mat33 (r(1,n), temp, temp2)
!
          iel33 = (i3*(i3 + 1))/2
          ha(iel33) = temp2(9) + ha(iel33)
          ha(iel33-1) = temp2(8) + ha(iel33-1)
          ha(iel33-2) = temp2(7) + ha(iel33-2)
          ha(iel33-i*3) = temp2(5) + ha(iel33-i3)
          ha(iel33-i*3-1) = temp2(4) + ha(iel33-i3-1)
          ha(iel33-6*i+1) = temp2(1) + ha(iel33-i6+1)
!
!  APPLY SYMMETRY TO DIPOLE TERM AS WELL
!
          temp(9) = deldip(3,k*3)
          temp(8) = deldip(2,k*3)
          temp(7) = deldip(1,k*3)
          temp(6) = deldip(3,k*3-1)
          temp(5) = deldip(2,k*3-1)
          temp(4) = deldip(1,k*3-1)
          temp(3) = deldip(3,k*3-2)
          temp(2) = deldip(2,k*3-2)
          temp(1) = deldip(1,k*3-2)
!
          call mat33 (r(1,n), temp, temp2)
!
          deltmp(3,i*3) = temp2(9) + deltmp(3,i*3)
          deltmp(2,i*3) = temp2(8) + deltmp(2,i*3)
          deltmp(1,i*3) = temp2(7) + deltmp(1,i*3)
          deltmp(3,i*3-1) = temp2(6) + deltmp(3,i*3-1)
          deltmp(2,i*3-1) = temp2(5) + deltmp(2,i*3-1)
          deltmp(1,i*3-1) = temp2(4) + deltmp(1,i*3-1)
          deltmp(3,i*3-2) = temp2(3) + deltmp(3,i*3-2)
          deltmp(2,i*3-2) = temp2(2) + deltmp(2,i*3-2)
          deltmp(1,i*3-2) = temp2(1) + deltmp(1,i*3-2)
!
        end do
      end do
!
      h(:numat*(9*numat+3)/2) = ha(:numat*(9*numat+3)/2)/nsym
!
      deldip(1,:3*numat) = deltmp(1,:3*numat)/nsym
      deldip(2,:3*numat) = deltmp(2,:3*numat)/nsym
      deldip(3,:3*numat) = deltmp(3,:3*numat)/nsym
!
      return
      end subroutine symt

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

! Diskless/stateless Application Programming Interface (API) to core MOPAC operations
module mopac_api
  use, intrinsic :: iso_c_binding
  implicit none

  private
  ! public derived types of the MOPAC API
  public :: mopac_system, mopac_properties, mopac_state, mozyme_state
  ! public subroutines of the MOPAC API
  public :: mopac_scf, mopac_relax, mopac_vibe, mozyme_scf, mozyme_relax, mozyme_vibe
  ! public subroutines to create derived types of the API that it can destroy
  public :: create_mopac_state, create_mozyme_state
  ! public subroutines to destroy derived types created by the API
  public :: destroy_mopac_properties, destroy_mopac_state, destroy_mozyme_state
  ! public subroutine of the simple, disk-based MOPAC API
  public :: run_mopac_from_input, get_mopac_version

  ! data that defines the atomistic system and MOPAC job options
  type, bind(c) :: mopac_system
    ! number of atoms
    integer(c_int) :: natom
    ! number of atoms that are allowed to move (first natom_move atoms in array)
    integer(c_int) :: natom_move
    ! net charge
    integer(c_int) :: charge
    ! number of spin excitations, floor[(number of alpha electrons)/2 - (number of beta electrons)/2]
    integer(c_int) :: spin
    ! semiempirical model: PM7 = 0, PM6-D3H4 = 1, PM6-ORG = 2, PM6 = 3, AM1 = 4, RM1 = 5
    integer(c_int) :: model
    ! dielectric constant for COSMO implicit solvent, must be 1 (no solvent) for nlattice > 0
    real(c_double) :: epsilon
    ! atomic number of each atom
    type(c_ptr) :: atom ! integer(c_int)[natom]
    ! (x,y,z) coordinates of each atom (Angstroms)
    type(c_ptr) :: coord ! real(c_double)[3*natom]
    ! number of lattice vectors / translation vectors / periodic dimensions
    integer(c_int) :: nlattice
    ! number of lattice vectors that are allowed to move (first nlattice_move vectors in array)
    integer(c_int) :: nlattice_move
    ! external hydrostatic pressure (Gigapascals)
    real(c_double) :: pressure
    ! (x,y,z) coordinates of each lattice vectors (Angstroms)
    type(c_ptr) :: lattice ! real(c_double)[3*nlattice]
    ! relative numerical tolerances (equivalent to GNORM and RELSCF keyword values)
    real(c_double) :: tolerance
    ! time limit for a MOPAC calculation (seconds)
    integer(c_int) :: max_time
  end type

  ! calculated ground-state properties of an atomistic system and MOPAC job info
  type, bind(c) :: mopac_properties
    ! heat of formation (kcal/mol)
    real(c_double) :: heat
    ! dipole moment vector (Debye)
    real(c_double), dimension (3) :: dipole
    ! atomic partial charges
    type(c_ptr) :: charge ! real(c_double)[natom]
    ! (x,y,z) coordinates of each moveable atom (Angstroms)
    type(c_ptr) :: coord_update ! real(c_double)[3*natom_move]
    ! (x,y,z) heat gradients for each moveable atom (kcal/mol/Angstrom)
    type(c_ptr) :: coord_deriv ! real(c_double)[3*natom_move]
    ! vibrational frequencies of normal modes (1/cm)
    type(c_ptr) :: freq ! real(c_double)[3*natom_move], NULL if unavailable
    ! (x,y,z) displacement vectors of normal modes
    type(c_ptr) :: disp ! real(c_double)[3*natom_move,3*natom_move], NULL if unavailable
    ! bond-order matrix in compressed sparse column (CSC) matrix format (0-based indexing)
    ! with insignificant bond orders (<0.01) truncated
    ! diagonal matrix entries are atomic valencies
    ! > first index of each atom in CSC bond-order matrix
    type(c_ptr) :: bond_index ! integer(c_int)[natom+1]
    ! > list of atoms bonded to each atom in CSC format
    type(c_ptr) :: bond_atom ! integer(c_int)[bond_index(natom+1)]
    ! > bond order of atoms bonded to each atom in CSC format
    type(c_ptr) :: bond_order ! real(c_double)[bond_index(natom+1)]
    ! (x,y,z) coordinates of each moveable lattice vectors (Angstroms)
    type(c_ptr) :: lattice_update ! real(c_double)[3*nlattice_move]
    ! (x,y,z) heat gradients for each moveable lattice vector (kcal/mol/Angstrom)
    type(c_ptr) :: lattice_deriv ! real(c_double)[3*nlattice_move]
    ! stress tensor (Gigapascals) in Voigt form (xx, yy, zz, yz, xz, xy)
    real(c_double), dimension (6) :: stress ! 0 if unavailable
    ! number of MOPAC error messages (negative value indicates that allocation of error_msg failed)
    integer(c_int) :: nerror
    ! text of MOPAC error messages
    type(c_ptr) :: error_msg ! type(c_ptr)[nerror] -> character(kind=c_char)[*]
  end type

  ! data that describes the electronic state using standard molecular orbitals
  type, bind(c) :: mopac_state
    ! MOPAC data format is adapted from molkst_C and Common_arrays_C modules
    ! > number of matrix elements in packed lower triangle matrix format
    integer(c_int) :: mpack ! 0 if state is unavailable
    ! > flag for unrestricted Hartree-Fock ground state (0 == restricted, 1 == unrestricted)
    integer(c_int) :: uhf
    ! > alpha density matrix
    type(c_ptr) :: pa ! real(c_double)[mpack]
    ! > beta density matrix
    type(c_ptr) :: pb ! real(c_double)[mpack], NULL if uhf == 0
  end type

  ! data that describes the electronic state using localized molecular orbitals
  type, bind(c) :: mozyme_state
    ! MOZYME data format is adapted from molkst_C, Common_arrays_C, and MOZYME_C modules
    ! > number of real atoms
    integer(c_int) :: numat ! 0 if state is unavailable
    ! > number of Lewis bonds per real atom
    type(c_ptr) :: nbonds ! integer(c_int)[numat]
    ! > list of Lewis-bonded real atoms for each real atom
    type(c_ptr) :: ibonds ! integer(c_int)[9,numat]
    ! > number of orbitals per real atom
    type(c_ptr) :: iorbs ! integer(c_int)[numat]
    ! > number of occupied molecular orbitals
    integer(c_int) :: noccupied
    ! > number of atoms in each occupied LMO
    type(c_ptr) :: ncf ! integer(c_int)[noccupied]
    ! > number of virtual molecular orbitals
    integer(c_int) :: nvirtual
    ! > number of atoms in each virtual LMO
    type(c_ptr) :: nce ! integer(c_int)[nvirtual]
    ! > size of array icocc
    integer(c_int) :: icocc_dim
    ! > index of each real atom in the occupied LMOs
    type(c_ptr) :: icocc ! integer(c_int)[iccoc_dim]
    ! > size of array icvir
    integer(c_int) :: icvir_dim
    ! > index of each real atom in the virtual LMOs
    type(c_ptr) :: icvir ! integer(c_int)[icvir_dim]
    ! > size of array cocc
    integer(c_int) :: cocc_dim
    ! > atomic orbital coefficients of the occupied LMOs
    type(c_ptr) :: cocc ! real(c_double)[cocc_dim]
    ! > size of array cvir
    integer(c_int) :: cvir_dim
    ! > atomic orbital coefficients of the virtual LMOs
    type(c_ptr) :: cvir ! real(c_double)[cvir_dim]
  end type

  interface

    ! MOPAC electronic ground state calculation
    module subroutine mopac_scf(system, state, properties) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: mopac_scf
#endif
      type(mopac_system), intent(in) :: system
      type(mopac_state), intent(inout) :: state
      type(mopac_properties), intent(out) :: properties
    end subroutine mopac_scf

    ! MOPAC geometry relaxation
    module subroutine mopac_relax(system, state, properties) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: mopac_relax
#endif
      type(mopac_system), intent(in) :: system
      type(mopac_state), intent(inout) :: state
      type(mopac_properties), intent(out) :: properties
    end subroutine mopac_relax

    ! MOPAC vibrational calculation
    module subroutine mopac_vibe(system, state, properties) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: mopac_vibe
#endif
      type(mopac_system), intent(in) :: system
      type(mopac_state), intent(inout) :: state
      type(mopac_properties), intent(out) :: properties
    end subroutine mopac_vibe

    ! MOZYME electronic ground state calculation
    module subroutine mozyme_scf(system, state, properties) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: mozyme_scf
#endif
      type(mopac_system), intent(in) :: system
      type(mozyme_state), intent(inout) :: state
      type(mopac_properties), intent(out) :: properties
    end subroutine mozyme_scf

    ! MOZYME geometry relaxation
    module subroutine mozyme_relax(system, state, properties) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: mozyme_relax
#endif
      type(mopac_system), intent(in) :: system
      type(mozyme_state), intent(inout) :: state
      type(mopac_properties), intent(out) :: properties
    end subroutine mozyme_relax

    ! MOZYME vibrational calculation
    module subroutine mozyme_vibe(system, state, properties) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: mozyme_vibe
#endif
      type(mopac_system), intent(in) :: system
      type(mozyme_state), intent(inout) :: state
      type(mopac_properties), intent(out) :: properties
    end subroutine mozyme_vibe

    ! allocate memory for mopac_state
    module subroutine create_mopac_state(state) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: create_mopac_state
#endif
      type(mopac_state), intent(inout) :: state
    end subroutine create_mopac_state

    ! allocate memory for mozyme_state
    module subroutine create_mozyme_state(state) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: create_mozyme_state
#endif
      type(mozyme_state), intent(inout) :: state
    end subroutine create_mozyme_state
  
    ! deallocate memory in mopac_properties
    module subroutine destroy_mopac_properties(properties) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: destroy_mopac_properties
#endif
      type(mopac_properties), intent(in) :: properties
    end subroutine destroy_mopac_properties

    ! deallocate memory in mopac_state
    module subroutine destroy_mopac_state(state) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: destroy_mopac_state
#endif
      type(mopac_state), intent(in) :: state
    end subroutine destroy_mopac_state

    ! deallocate memory in mozyme_state
    module subroutine destroy_mozyme_state(state) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: destroy_mozyme_state
#endif
      type(mozyme_state), intent(in) :: state
    end subroutine destroy_mozyme_state

    ! run MOPAC conventionally from an input file
    module function run_mopac_from_input(path_to_file) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: run_mopac_from_input
#endif
      integer(c_int) :: run_mopac_from_input
      character(kind=c_char), dimension(*), intent(in) :: path_to_file
    end function run_mopac_from_input

    ! get MOPAC version string
    module subroutine get_mopac_version(version) bind(c)
#ifdef WIN32
!dec$ attributes dllexport :: get_mopac_version
#endif
      character(kind=c_char), dimension(*), intent(out) :: version
    end subroutine get_mopac_version

  end interface

  ! allocate memory (C or Fortran memory manager, depending on compiler)
  interface
    module function create_int(size)
      type(c_ptr) :: create_int
      integer, intent(in) :: size
    end function create_int
    module function create_int2(size, size2)
      type(c_ptr) :: create_int2
      integer, intent(in) :: size
      integer, intent(in) :: size2
    end function create_int2
    module function create_real(size)
      type(c_ptr) :: create_real
      integer, intent(in) :: size
    end function create_real
  end interface

  ! allocate memory & copy data (C or Fortran memory manager, depending on compiler)
  interface create_copy
    module function create_copy_int(array, size)
      type(c_ptr) :: create_copy_int
      integer, intent(in) :: array(:)
      integer, intent(in) :: size(1)
    end function create_copy_int
    module function create_copy_int2(array, size)
      type(c_ptr) :: create_copy_int2
      integer, intent(in) :: array(:,:)
      integer, intent(in) :: size(2)
    end function create_copy_int2
    module function create_copy_real(array, size)
      type(c_ptr) :: create_copy_real
      double precision, intent(in) :: array(:)
      integer, intent(in) :: size(1)
    end function create_copy_real
    module function create_copy_char(array, size)
      type(c_ptr) :: create_copy_char
      character(len=*), intent(in) :: array
      integer, intent(in) :: size(1)
    end function create_copy_char
    module function create_copy_ptr(array, size)
      type(c_ptr) :: create_copy_ptr
      type(c_ptr), intent(in) :: array(:)
      integer, intent(in) :: size(1)
    end function create_copy_ptr
  end interface

  ! deallocate memory (C or Fortran memory manager, depending on compiler)
  interface
    module subroutine destroy_int(copy)
      type(c_ptr), intent(in) :: copy
    end subroutine destroy_int
    module subroutine destroy_real(copy)
      type(c_ptr), intent(in) :: copy
    end subroutine destroy_real
    module subroutine destroy_char(copy)
      type(c_ptr), intent(in) :: copy
    end subroutine destroy_char
    module subroutine destroy_ptr(copy)
      type(c_ptr), intent(in) :: copy
    end subroutine destroy_ptr
  end interface

end module mopac_api

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine powsq()
      use molkst_C, only : tleft, time0, numcal, keywrd, last, &
      &  nscf, tdump, nvar, iflepo, escf, line
      use funcon_C, only : a0
      use common_arrays_C, only : loc, grad, xparam, gnext1, gmin1
      use chanel_C, only : iw0, iw, ilog, log
      implicit none
      double precision  :: hess(nvar,nvar)
      double precision  :: bmat(nvar,nvar)
      double precision  :: pmat(nvar*nvar)
      double precision  :: pvec(nvar*nvar)
!
      integer , dimension(9) :: ipow
      integer :: icyc, iloop, icalcn, maxcyc, i, ilpr, if, j, jcyc, ij, k, l, &
        il, ik, ip1, id, percent
      double precision, dimension(nvar) :: sig, e1, e2, p, work, eig, q
      double precision :: time1, time2, tlast, xinc, rho2, tol2, gmin, tstep, &
        sum, alpha, rmu, sk, pmax, tprt, amin, anext, test
      logical :: debug, restrt, times, scf1, resfil, lpacifier
      character :: txt
      double precision, external :: ddot, reada, seconds
      save debug, restrt, times, scf1, resfil, time1, time2, icyc, tlast, &
        iloop, xinc, rho2, tol2, icalcn
!*********************************************************************
!
!   POWSQ OPTIMIZES THE GEOMETRY BY MINIMISING THE GRADIENT NORM.
!         THUS BOTH GROUND AND TRANSITION STATE GEOMETRIES CAN BE
!         CALCULATED. IT IS ROUGHLY EQUIVALENT TO FLEPO, FLEPO MINIMIZES
!         THE ENERGY, POWSQ MINIMIZES THE GRADIENT NORM.
!
!  ON ENTRY XPARAM = VALUES OF PARAMETERS TO BE OPTIMIZED.
!           NVAR   = NUMBER OF PARAMETERS TO BE OPTIMIZED.
!
!  ON EXIT  XPARAM = OPTIMIZED PARAMETERS.
!           escf  = HEAT OF FORMATION IN KCALS.
!
!*********************************************************************
!        *****  ROUTINE PERFORMS  A LEAST SQUARES MINIMIZATION  *****
!        *****  OF A FUNCTION WHICH IS A SUM OF SQUARES.        *****
!        *****  INITIALLY WRITTEN BY J.W. MCIVER JR. AT SUNY/   *****
!        *****  BUFFALO, SUMMER 1971.  REWRITTEN AND MODIFIED   *****
!        *****  BY A.K. AT SUNY BUFFALO AND THE UNIVERSITY OF   *****
!        *****  TEXAS.  DECEMBER 1973                           *****
!
      data icalcn/ 0/
      maxcyc = 0
      tleft = tleft - seconds(1) + time0
      tstep = 0.d0
      if (icalcn /= numcal) then
        icalcn = numcal
        if (allocated(gnext1)) deallocate(gnext1)
        if (allocated(gmin1)) deallocate(gmin1)
        allocate (gnext1(nvar), gmin1(nvar))
        restrt = (index(keywrd,' OLD_HESS') + index(keywrd,' RESTART') /= 0)
        maxcyc = 100000
        if (index(keywrd,' CYCLES') /= 0) maxcyc = nint(reada(keywrd,index(keywrd,' CYCLES')))
        scf1 = index(keywrd,' 1SCF') /= 0
        time1 = seconds(2)
        time2 = time1
        icyc = 0
        jcyc = 0
        times = index(keywrd,' TIME') /= 0
        tlast = tleft
        resfil = .FALSE.
        last = 0
        iloop = 1
        xinc = a0*0.01D0
        rho2 = 1.D-4
        tol2 = 4.D-1
        if (index(keywrd,' PREC') /= 0) tol2 = 1.D-2
        if (index(keywrd,' GNORM') /= 0) then
          tol2 = reada(keywrd,index(keywrd,' GNORM'))
          if (tol2<0.01D0 .and. index(keywrd,' LET')==0) then
            write (iw, '(/,A)') '  GNORM HAS BEEN SET TOO LOW, RESET TO 0.01'
            tol2 = 0.01D0
          end if
        end if
        debug = index(keywrd,' POWSQ') /= 0
        if (restrt) then
!
!   RESTORE STORED DATA
!
          ipow(9) = 0
          hess = 0.d0
          pmat = 0.d0
          bmat = 0.d0
          call powsav (hess, gmin1, xparam, pmat, iloop, bmat, ipow)
          icyc = ipow(3)
          if (index(keywrd, " LOCATE-TS") /= 0) icyc = 0
          if (scf1) go to 390
          nscf = ipow(8)
          grad(:nvar) = gmin1(:nvar)
          gnext1(:nvar) = gmin1(:nvar)
          if (iloop > 0) &
            write (iw, '(2/10X,'' RESTARTING AT POINT'',I3)') iloop
        end if
!
!   DEFINITIONS:   NVAR   = NUMBER OF GEOMETRIC VARIABLES = 3*NUMAT-6
!
      end if
      nvar = abs(nvar)
      if (debug) then
        write (iw, '('' XPARAM'')')
        write (iw, '(5(i8,i2,F10.4))') (loc(1,i),loc(2,i),xparam(i),i=1,nvar)
      end if
      if (.not.restrt) then
        grad(:nvar) = 0.D0
        call compfg (xparam, .TRUE., escf, .TRUE., grad, .TRUE.)
      end if
      if (debug) then
        write (iw, '('' STARTING GRADIENTS'')')
        write (iw, '(3X,8F9.4)') (grad(i),i=1,nvar)
      end if
      gmin = dsqrt(ddot(nvar,grad,1,grad,1))
      gnext1 = grad
      gmin1 = gnext1
!
!    NOW TO CALCULATE THE HESSIAN MATRIX.
!
      if (iloop < 0) go to 140
!
!   CHECK THAT HESSIAN HAS NOT ALREADY BEEN CALCULATED.
!
      ilpr = iloop
      lpacifier = .false.
      percent = (100*(ilpr-1))/nvar
      write (iw, '(/, 10 x, "HESSIAN CALCULATED NUMERICALLY", /)')
      test = 0.d0
      do iloop = ilpr, nvar
        time1 = seconds(1)
        xparam(iloop) = xparam(iloop) + xinc
        call compfg (xparam, .TRUE., escf, .TRUE., grad, .TRUE.)
        if (scf1) go to 390
        if (debug) write (iw, '(I3,12(8F9.4,/3X))') iloop, (grad(if),if=1,nvar)
        grad(iloop) = grad(iloop) + 1.D-5
        xparam(iloop) = xparam(iloop) - xinc
        hess(iloop,:nvar) = -(grad(:nvar)-gnext1(:nvar))/xinc
        if (iw0 >= 0) then
          write(line,"(i5,a,i4,a)")iloop," of",nvar," steps completed"
          call to_screen(line)
        end if
        time2 = seconds(2)
        tstep = time2 - time1
        tleft = tleft - tstep
        time1 = time2
        j = (100*iloop)/nvar
        test = test + tstep
        if (j/5 > percent/5 .or. (j == 1 .and. percent /= 1) .or. iloop == 1) then
!
!   User pacifier
!
          percent = j
          j = iloop - ilpr + 1
          if (nvar*test/(j*3600) > 0.1d0 .or. lpacifier) then
            lpacifier = .true.
            sum = (nvar - iloop)*(test/(j*3600))
            write(line,"(a,i3,a,f7.2,a)") &
              "    Hessian",percent,"% complete.  Estimated remaining time required:", sum, " hours"
            write(iw,"(a)")trim(line)
            call to_screen(line)
            write(line,"(i5,a,i4,a)")iloop," of",nvar," steps completed"
            write(iw,"(a)")trim(line)
            if (iw0 >= 0) call to_screen(line)
          end if
        end if
        if (tlast - tleft > tdump) then
          tlast = tleft
          resfil = .TRUE.
          ipow(9) = 2
          i = iloop
          ipow(3) = icyc
          ipow(8) = nscf
          call powsav (hess, gmin1, xparam, pmat, i, bmat, ipow)
        end if
        if (tleft >= tstep*2.D0 .and. iloop-ilpr<=maxcyc) cycle
!
!  STORE RESULTS TO DATE.
!
        ipow(9) = 1
        i = iloop
        ipow(8) = nscf
        ipow(3) = icyc
        call powsav (hess, gmin1, xparam, pmat, i, bmat, ipow)
        iflepo = -1
        return
      end do
      write(iw,*)
!        *****  SCALE -HESSIAN- MATRIX                           *****
      if (debug) then
        write (iw, '(2/10X,''UN-NORMALIZED HESSIAN MATRIX'')')
        do i = 1, nvar
          write (iw, '(8F10.4)') (hess(j,i),j=1,nvar)
        end do
      end if
      do i = 1, nvar
        sum = 0.0D0
        do j = 1, nvar
          sum = sum + hess(i,j)**2
        end do
        work(i) = 1.0D0/sqrt(sum)
      end do
      do i = 1, nvar
        hess(i,:nvar) = hess(i,:nvar)*work(i)
      end do
      if (debug) then
        write (iw, '(2/10X,''HESSIAN MATRIX'')')
        do i = 1, nvar
          write (iw, '(8F10.4)') (hess(j,i),j=1,nvar)
        end do
      end if
!        *****  INITIALIZE B MATIRX                        *****
      do i = 1, nvar
        bmat(i,:nvar) = 0.0D0
        bmat(i,i) = work(i)*2.D0
      end do
!***********************************************************************
!
!  THIS IS THE START OF THE BIG LOOP TO OPTIMIZE THE GEOMETRY
!
!***********************************************************************
      iloop = -99
      tstep = tstep*4.D0
      jcyc = icyc
  130 continue
      if (tlast - tleft > tdump) then
        tlast = tleft
        resfil = .TRUE.
        ipow(9) = 2
        i = iloop
        ipow(8) = nscf
        ipow(3) = icyc
        call powsav (hess, gmin1, xparam, pmat, i, bmat, ipow)
      end if
      if (tleft<tstep*2.D0 .or. icyc-jcyc>maxcyc) then
!
!  STORE RESULTS TO DATE.
!
        ipow(9) = 1
        i = iloop
        ipow(8) = nscf
        ipow(3) = icyc
        call powsav (hess, gmin1, xparam, pmat, i, bmat, ipow)
        iflepo = -1
        return
      end if
  140 continue
      ij = 0
      do j = 1, nvar
        do i = 1, j
          ij = ij + 1
          sum = 0.0D0
          do k = 1, nvar
            sum = sum + hess(i,k)*hess(j,k)
          end do
          pmat(ij) = sum
        end do
      end do
      do i = 1, nvar
        sum = 0.0D0
        do k = 1, nvar
          sum = sum - hess(i,k)*gmin1(k)
        end do
        p(i) = -sum
      end do
      l = 0
      if (debug) then
        write (iw, '(/10X,''P MATRIX IN POWSQ'')')
        call vecprt (pmat, nvar)
      end if
      call rsp (pmat, nvar, eig, pvec)
!        *****  CHECK FOR ZERO EIGENVALUE                  *****
!#      WRITE(IW,'(''  EIGS IN POWSQ:'')')
!#      WRITE(IW,'(6F13.8)')(EIG(I),I=1,NVAR)
      if (eig(1) >= rho2) then
!        *****  IF MATRIX IS NOT SINGULAR FORM INVERSE     *****
!        *****  BY BACK TRANSFORMING THE EIGENVECTORS      *****
        ij = 0
        do i = 1, nvar
          do j = 1, i
            ij = ij + 1
            sum = 0.0D0
            do k = 1, nvar
              sum = sum + pvec((k-1)*nvar+j)*pvec((k-1)*nvar+i)/eig(k)
            end do
            pmat(ij) = sum
          end do
        end do
!        *****  FIND -Q- VECTOR                            *****
        l = 0
        il = l + 1
        l = il + i - 1
        do i = 1, nvar
          sum = 0.0D0
          do k = 1, i
            ik = (i*(i - 1))/2 + k
            sum = sum + pmat(ik)*p(k)
          end do
          ip1 = i + 1
          do k = ip1, nvar
            ik = (k*(k - 1))/2 + i
            sum = sum + pmat(ik)*p(k)
          end do
          q(i) = sum
        end do
      else
        q(:nvar) = pvec(:nvar)
      end if
      do i = 1, nvar
        sig(i) = 0.0D0
        do j = 1, nvar
          sig(i) = sig(i) + q(j)*bmat(i,j)
        end do
      end do
!        *****  DO A ONE DIMENSIONAL SEARCH                *****
      if (debug) then
        write (iw, '('' SEARCH VECTOR'')')
        write (iw, '(8F10.5)') (sig(i),i=1,nvar)
      end if
      call search (xparam, alpha, sig, nvar, gmin, escf, amin, anext)
      if (nvar == 1) go to 390
!
!  FIRST WE ATTEMPT TO OPTIMIZE GEOMETRY USING SEARCH.
!  IF THIS DOES NOT WORK, THEN SWITCH TO LINMIN, WHICH ALWAYS WORKS,
!  BUT IS TWICE AS SLOW AS SEARCH.
!
      if (gmin < tol2) then
        write (iw, '(/, 5 x, "GRADIENT =", f9.5, "  IS LESS THAN CUTOFF =", f9.5,//)') gmin, tol2
        go to 390
      end if
!        *****  TWO STEP ESTIMATION OF DERIVATIVES         *****
      e1(:nvar) = (gmin1(:nvar)-gnext1(:nvar))/(amin - anext)
      rmu = ddot(nvar,e1,1,gmin1,1)/ddot(nvar,gmin1,1,gmin1,1)
      e2(:nvar) = e1(:nvar) - rmu*gmin1(:nvar)
!        *****  SCALE -E2- AND -SIG-                       *****
      sk = 1.0D0/dsqrt(ddot(nvar,e2,1,e2,1))
      sig(:nvar) = sk*sig(:nvar)
      e2(:nvar) = sk*e2(:nvar)
!        *****  FIND INDEX OF REPLACEMENT DIRECTION        *****
      pmax = -1.0D+20
      id = 0
      do i = 1, nvar
        if (abs(p(i)*q(i)) <= pmax) cycle
        pmax = abs(p(i)*q(i))
        id = i
      end do
!        *****  REPLACE APPROPRIATE DIRECTION AND DERIVATIVE ***
      hess(id,:nvar) = -e2(:nvar)
!        *****  REPLACE STARTING POINT                     *****
      bmat(:nvar,id) = sig(:nvar)/a0
      gnext1(:nvar) = gmin1(:nvar)
      time1 = time2
      time2 = seconds(2)
      tstep = time2 - time1
      tleft = tleft - tstep
      if (tleft < 0.0D0) tleft = -0.1D0
      icyc = icyc + 1
      call prttim (tleft, tprt, txt)
      if (resfil) then
        write (line, 370) tprt, txt, min(gmin,999999.999D0), escf
        write(iw,"(a)")trim(line)
        if (log) write (ilog, "(a)")trim(line)
  370   format('  RESTART FILE WRITTEN,     TIME LEFT:',f6.2,a1,'  GRAD.:',f10.3, &
        ' HEAT:',g14.7)
        resfil = .FALSE.
      else
        write (line, 380) icyc, min(tstep,9999.99D0), tprt, txt, min(gmin,&
          999999.999D0), escf
        write(iw,"(a)")trim(line)
        if (log) write (ilog, "(a)")trim(line)
  380   format(' CYCLE:',i6,' TIME:',f8.3,' TIME LEFT:',f6.2,a1,'  GRAD.:',f10.3,' HEAT:',g14.7)
      end if
      call to_screen(line)
      endfile (iw)
      backspace (iw)
      if (log) then
        endfile (ilog)
        backspace (ilog)
      end if
      if (times) write (iw, '('' TIME FOR STEP:'',F8.3,'' LEFT'',F8.3)') tstep, tleft
      go to 130
  390 continue
      grad(:nvar) = 0.D0
      last = 1
      call compfg (xparam, .TRUE., escf, .TRUE., grad, .TRUE.)
      grad(:nvar) = gmin1(:nvar)
      iflepo = 11
      if (scf1) iflepo = 13
      if (index(keywrd, " LOCATE-TS") /= 0) then
        ipow(9) = 2
        i = iloop
        ipow(8) = nscf
        ipow(3) = icyc
        call powsav (hess, gmin1, xparam, pmat, i, bmat, ipow)
      end if
      return
      end subroutine powsq
      subroutine search(xparam, alpha, sig, nvar, gmin, funct, amin, anext )
      USE common_arrays_C, only : gmin1, gnext1
      use chanel_C, only : iw
      use molkst_C, only : numcal, keywrd
      implicit none
      integer  :: nvar
      double precision , intent(inout) :: alpha
      double precision , intent(inout) :: gmin
      double precision  :: funct, amin, anext
      double precision  :: xparam(*)
      double precision , intent(in) :: sig(*)
      integer :: looks, icalcn, i, itrys
      double precision, dimension(nvar) :: grad, xref, gref, xmin1
      double precision :: g, tiny, tolerg, gb, gstore, gminn, ta, tb, ga, sum, gtot
      logical :: debug
      double precision, external :: ddot
      save debug, g, tiny, looks, tolerg, icalcn
!***********************************************************************
!
! SEARCH PERFORMS A LINE SEARCH FOR POWSQ. IT MINIMIZES THE NORM OF
!        THE GRADIENT VECTOR IN THE DIRECTION SIG.
!
! ON INPUT  XPARAM = CURRENT POINT IN NVAR DIMENSIONAL SPACE.
!           ALPHA  = STEP SIZE (IN FACT ALPHA IS CALCULATED IN SEARCH).
!           SIG    = SEARCH DIRECTION VECTOR.
!           NVAR   = NUMBER OF PARAMETERS IN SIG (& XPARAM)
!
! ON OUTPUT XPARAM = PARAMETERS OF MINIMUM.
!           ALPHA  = DISTANCE TO MINIMUM.
!           GMIN   = GRADIENT NORM AT MINIMUM.
!***********************************************************************
      data icalcn/ 0/
      if (icalcn /= numcal) then
        icalcn = numcal
!
!    TOLG   = CRITERION FOR EXIT BY RELATIVE CHANGE IN GRADIENT.
!
        debug = index(keywrd,'LINMIN') /= 0
        looks = 0
        tiny = 0.1D0
        tolerg = 0.02D0
        g = 100.D0
        alpha = 0.1D0
      end if
      gref(:nvar) = gmin1(:nvar)
      gnext1(:nvar) = gmin1(:nvar)
      xmin1(:nvar) = xparam(:nvar)
      xref(:nvar) = xparam(:nvar)
      if (abs(alpha) > 0.2D0) alpha = sign(0.2D0,alpha)
      if (debug) then
        write (iw, '('' SEARCH DIRECTION VECTOR'')')
        write (iw, '(6F12.6)') (sig(i),i=1,nvar)
        write (iw, '('' INITIAL GRADIENT VECTOR'')')
        write (iw, '(6F12.6)') (gmin1(i),i=1,nvar)
      end if
      gb = ddot(nvar,gmin1,1,gref,1)
      if (debug) write (iw, '('' GRADIENT AT START OF SEARCH:'',F16.6)') sqrt(gb)
      gstore = gb
      amin = 0.D0
      gminn = 1.D9
      ta = 0.D0
      tb = 0.D0
      ga = gb
      gb = 1.D9
      itrys = 0
      go to 30
   20 continue
      sum = ga/(ga - gb)
      itrys = itrys + 1
      if (abs(sum) > 3.D0) sum = sign(3.D0,sum)
      alpha = (tb - ta)*sum + ta
!
!         XPARAM IS THE GEOMETRY OF THE PREDICTED MINIMUM ALONG THE LINE
!
   30 continue
      xparam(:nvar) = xref(:nvar) + alpha*sig(:nvar)
!
!         CALCULATE GRADIENT NORM AND GRADIENTS AT THE PREDICTED MINIMUM
!
   !   if (itrys == 1) then
        grad(:nvar) = 0.D0
   !   end if
      call compfg (xparam, .TRUE., funct, .TRUE., grad, .TRUE.)
      looks = looks + 1
!
!          G IS THE PROJECTION OF THE GRADIENT ALONG SIG.
!
      g = ddot(nvar,gref,1,grad,1)
      gtot = dsqrt(ddot(nvar,grad,1,grad,1))
      if (debug) write (iw, &
      '('' LOOKS'',I3,'' ALPHA ='',F12.6,'' GRADIENT'',F12.3,  '' G  ='',F16.6)') &
      looks, alpha, dsqrt(ddot(nvar,grad,1,grad,1)), g
      if (gtot < gminn) then
        gminn = gtot
        if (abs(amin - alpha) > 1.D-2) then
!
! WE CAN MOVE ANEXT TO A POINT NEAR, BUT NOT TOO NEAR, AMIN, SO THAT THE
! SECOND DERIVATIVESWILLBEREALISTIC(D2E/DX2=(GNEXT1-GMIN1)/(ANEXT-AMIN))
!
          anext = amin
          gnext1(:nvar) = gmin1(:nvar)
        end if
        amin = alpha
        if (gminn < gmin) then
          xmin1(:nvar) = xparam(:nvar)
          gmin1(:nvar) = grad(:nvar)
        else
          gmin1(:nvar) = grad(:nvar)
        end if
        gmin = min(gminn,gmin)
      end if
      if (itrys > 8) go to 80
      if (abs(g/gstore)<tiny .or. abs(g)<tolerg) go to 80
      if (abs(g)<max(abs(ga),abs(gb)) .or. ga*gb>0.D0 .and. g*ga<0.D0) then
!
!   G IS AN IMPROVEMENT ON GA OR GB.
!
        if (abs(gb) < abs(ga)) then
          ta = alpha
          ga = g
          go to 20
        else
          tb = alpha
          gb = g
          go to 20
        end if
      else
!#         WRITE(IW,'(//10X,'' FAILED IN SEARCH, SEARCH CONTINUING'')')
        go to 80
      end if
   80 continue
      gminn = dsqrt(ddot(nvar,gmin1,1,gmin1,1))
      xparam(:nvar) = xmin1(:nvar)
      if (debug) then
        write (iw, '('' AT EXIT FROM SEARCH'')')
        write (iw, '('' XPARAM'',6F12.6)') (xparam(i),i=1,nvar)
        write (iw, '('' GNEXT1'',6F12.6)') (gnext1(i),i=1,nvar)
        write (iw, '('' GMIN1 '',6F12.6)') (gmin1(i),i=1,nvar)
        write (iw, '('' AMIN, ANEXT,GMIN'',4F12.6)') amin, anext, gmin
      end if
      if (gminn > gmin) then
        xparam(:nvar) = xref(:nvar)
      end if
      return
!
      end subroutine search
      subroutine powsav(hess, grad, xparam, pmat, iloop, bmat, ipow)
      use molkst_C, only : nvar, keywrd, numat, norbs
      use maps_C, only : latom
      use chanel_C, only : iw, ires, restart_fn
      use common_arrays_C, only : loc, geo, aicorr
      use ef_C, only : alparm, x0, x1, x2
      use meci_C, only : jloop
      implicit none
      integer  :: iloop
      integer  :: ipow(9)
      double precision  :: hess(nvar,*)
      double precision  :: grad(*)
      double precision  :: xparam(*)
      double precision  :: pmat(*)
      double precision  :: bmat(nvar,*)
!
      integer :: i, k, l, j, linear, old_numat, old_norbs
      double precision :: funct1
      double precision, external :: ddot
!-----------------------------------------------
!*********************************************************************
!
! POWSAV STORES AND RESTORES DATA USED IN THE SIGMA GEOMETRY
!        OPTIMISATION.
!
!  ON INPUT HESS   = HESSIAN MATRIX, PARTIAL OR WHOLE.
!           GRAD   = GRADIENTS.
!           XPARAM = CURRENT STATE OF PARAMETERS.
!           ILOOP  = INDEX OF HESSIAN, OR FLAG OF POINT REACHED SO-FAR.
!           BMAT   = "B" MATRIX!
!           IPOW   = INDICES AND FLAGS.
!           IPOW(9)= 0 FOR RESTORE, 1 or 2 FOR DUMP (2: silent)
!
!*********************************************************************
      open(unit=ires, file=restart_fn, status='UNKNOWN', form='UNFORMATTED', position='asis')
      rewind ires
      if (ipow(9) /= 0) then
        if (ipow(9) == 1) then
          write (iw, &
      '(2/10X,''- - - - - - - TIME UP - - - - - - -'',2/)')
          write (iw, '(10X,A)') ' - THE CALCULATION IS BEING DUMPED TO DISK', &
            '   RESTART IT USING THE KEY-WORD "RESTART"'
          funct1 = dsqrt(ddot(nvar,grad,1,grad,1))
          write (iw, &
            '(2/10X,''CURRENT VALUE OF GRADIENT NORM ='',F12.6)') funct1
          do i = 1, nvar
            k = loc(1,i)
            l = loc(2,i)
            geo(l,k) = xparam(i)
          end do
          write (iw, '(/10X,''CURRENT VALUE OF GEOMETRY'',/)')
          call geout (iw)
        end if
        write (ires) numat, norbs, (xparam(i),i=1,nvar)
        write (ires) ipow, iloop
        write (ires) (grad(i),i=1,nvar)
        write (ires) ((hess(j,i),j=1,nvar),i=1,nvar)
        write (ires) ((bmat(j,i),j=1,nvar),i=1,nvar)
        linear = (nvar*(nvar + 1))/2
        write (ires) (pmat(i),i=1,linear)
        if (index(keywrd,'AIDER') /= 0) write (ires) (aicorr(i),i=1,nvar)
        call den_in_out(1)
        if (latom /= 0) then
          write (ires) ((alparm(j,i),j=1,3),i=1,nvar)
          write (ires) jloop, x0, x1, x2
        end if
        close(ires)
        return
      else
        if (index(keywrd, " LOCATE-TS") == 0) write (iw, '(2/10X,''RESTORING DATA FROM DISK''/)')
        read (ires, end=40, err=40) old_numat, old_norbs, (xparam(i),i=1,nvar)
        if (norbs /= old_norbs .or. numat /= old_numat) then
              call mopend("Restart file read in does not match current data set")
              return
        end if
        read (ires, end=20, err=20) ipow, iloop
        read (ires, end=40, err=40) (grad(i),i=1,nvar)
        read (ires, end=40, err=40) ((hess(j,i),j=1,nvar),i=1,nvar)
        read (ires, end=40, err=40) ((bmat(j,i),j=1,nvar),i=1,nvar)
        funct1 = dsqrt(ddot(nvar,grad,1,grad,1))
        linear = (nvar*(nvar + 1))/2
        read (ires, end=40, err=40) (pmat(i),i=1,linear)
        if (index(keywrd,'AIDER') /= 0) read (ires, end=40, err=40) (aicorr(i),i=1,nvar)
        if (latom /= 0) then
          read (ires, end=40, err=40) ((alparm(j,i),j=1,3),i=1,nvar)
          read (ires, end=40, err=40) jloop, x0, x1, x2
          iloop = iloop + 1
        end if
        iloop = iloop + 1
        return
      end if
   20 continue
      write (iw, '(2/10X,''NO RESTART FILE EXISTS!'')')
      return
   40 continue
      write (iw, '(2/10X,''PROBLEMS READING RESTART FILE'')')
      return
      end subroutine powsav

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine output_cc_rep_fn
!
!  Output the core-core repulsion function in a form suitable for EXCEL plotting.
!
  use Param_global_C, only : ifiles_8
  use funcon_C, only: a0, ev
  use parameters_C, only: tore, po
  implicit none
  integer :: i, j, ni, nj, pair
  double precision :: r, gab
  double precision, dimension (100,10) :: vab
  double precision, dimension (100) :: rab
  integer, parameter  :: np = 7
  integer, dimension (2,np) :: nij 
  data nij /1,8,6,8,8,8,7,7,1,1,6,1,6,6/
  do pair = 1, np
    do i = 5,60
      r = 0.1d0 * i / a0
      ni = nij(1,pair)
      nj = nij(2,pair)
        gab = ev / Sqrt (r*r/(a0*a0)+ (po(9, ni)+po(9, nj))**2)
      call ccrep (ni, nj, r, vab(i,pair), gab)
    
   !
   ! Multiply by core charges
      vab(i,pair) = 23.06*(vab(i,pair) - tore(ni) * tore(nj) * gab)
       rab(i) = r
    end do
  end do
  write(ifiles_8,"(a)")" Distance    O-H         C-O         O-O         N-N         H-H         C-H         C-C"
  do i = 5, 60
    write(ifiles_8,"(f6.2,9f12.3)")rab(i),(vab(i,j), j=1,np)
  end do
end subroutine output_cc_rep_fn

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine fmat(fmatrx, nreal, tscf, tder, deldip, heat, evecs, ts)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use common_arrays_C, only : coord, na, labels, atmass, p, q, xparam
      use molkst_C, only : numat, nvar, keywrd, tleft, moperr, natoms, tdump, &
      emin, mozyme
      use parameters_C, only : tore
      use funcon_C, only : fpc_10
      use chanel_C, only : iw, ilog, log
      USE elemts_C, only : elemnt
      implicit none
      integer , intent(out) :: nreal
      logical, intent (in) :: ts
      double precision , intent(in) :: tscf
      double precision , intent(in) :: tder
      double precision  :: heat
      double precision  :: fmatrx(((3*numat + 1)*(3*numat))/2)
      double precision  :: deldip(3,3*numat)
      double precision  :: evecs(9*numat*numat)
!
      integer ::  i, lin, maxcyc, istart, jstart, kountf, lu, iskip, j, &
        ii, ll, l, k, kk, iloop, store_numat
      double precision, dimension(3*natoms) :: grad, grold
      double precision, dimension(3) :: del2
      double precision, dimension(3*natoms) :: g2old, eigs, g2rad, fconst, dumy
      double precision :: fact, tlast, totime, time2, estime, delta, &
        time3, tstep, estim, escf
      logical :: debug, restrt, prnt, resfil, precis, big
      character :: line*120
      double precision, external :: dipole_for_MOZYME
      double precision, external :: ddot, dipole, dot, reada, seconds
      character :: XYZ(3)*1, num
      save fact
!**********************************************************************
!
!  VALUE CALCULATES THE SECOND-ORDER OF THE ENERGY WITH
!        RESPECT TO THE CARTESIAN COORDINATES I AND J AND PLACES IT
!        IN FMATRX
!
!  ON INPUT NATOMS  = NUMBER OF ATOMS IN THE SYSTEM.
!           XPARAM  = INTERNAL COORDINATES OF MOLECULE STORED LINEARLY
!
!
!  ON OUTPUT FMATRX = SECOND DERIVATIVE OF THE ENERGY WITH RESPECT TO
!                    CARTESIAN COORDINATES I AND J.
!**********************************************************************
      data del2/ 3*0.D0/
      data xyz /"X", "Y", "Z"/
      num = char(Int(log10(numat*1.0)) + ichar("1") + 1)
!
!    FACT IS THE CONVERSION FACTOR FROM KCAL/MOLE TO ERGS
!
      fact = 4.184D0/fpc_10*1.D21
!          = 4.184/6.0221367d23*10^21
!
! SET UP CONSTANTS AND FLAGS
      na = 0
!
!  SET UP THE VARIABLES IN XPARAM AND LOC,THESE ARE IN
!  CARTESIAN COORDINATES
!
      numat = 0
      do i = 1, natoms
        if (labels(i)==99 .or. labels(i)==107) cycle
        numat = numat + 1
        labels(numat) = labels(i)
      end do
      natoms = numat
      grad = 0.d0
      lin = (nvar*(nvar + 1))/2
      fmatrx(:lin) = 0.D0
      maxcyc = 100000
      if (index(keywrd,' CYCLES') /= 0 .and. index(keywrd, " IRC") == 0) &
        maxcyc = nint(reada(keywrd,index(keywrd,' CYCLES')))
      prnt = index(keywrd,'IRC=') == 0
      precis = index(keywrd,' PREC') /= 0
      restrt = index(keywrd,'RESTART') /= 0
      if (index(keywrd,'NLLSQ') /= 0) restrt = .FALSE.
      debug = index(keywrd,'FMAT') /= 0
      big = (index(keywrd,'LARGE') /= 0 .and. debug)
      if (prnt) write (iw, &
      '(2/4X,''FIRST DERIVATIVES WILL BE USED IN THE CALCULATION OF SECOND DERIVATIVES'')')
      tlast = tleft
      resfil = .FALSE.
      if (restrt) then
        istart = 0
        i = 0
        totime = 0.d0
        jstart = 0
        fconst = 0.d0
        call forsav (totime, deldip, istart, fmatrx, coord, nvar, heat, evecs, jstart, fconst)
        if (moperr) return
        kountf = (istart*(istart + 1))/2
        istart = istart + 1
        jstart = jstart + 1
        time2 = seconds(1)
      else
        kountf = 0
        totime = 0.D0
        if (tscf > 0.D0) tleft = tleft - tscf - tder
        istart = 1
      end if
! CALCULATE FMATRX
      if (istart > 1) then
        estime = (nvar - istart + 1)*totime/(istart - 1.D0)
      else
        estime = nvar*(tscf + tder)*2.D0
        if (precis) estime = estime*2.D0
      end if
! 20190807 removed conditional output to stabilize output file
!      if (tscf > 0)
      write (iw, &
      '(/10X,''ESTIMATED TIME TO COMPLETE CALCULATION ='',F12.2,'' SECONDS'')') estime
      if (restrt) then
        if (istart <= nvar) write (iw, &
          '(/10X,''STARTING AGAIN AT LINE'',18X,I4)') istart
        write (iw, '(/10X,''TIME USED UP TO RESTART ='',F22.2)') totime
      end if
      lu = kountf
      eigs(:nvar) = 0.D0
      if (.not. ts) call symr
      iskip = 0
      do i = istart, nvar
        if (((i - 1)/3)*3 == i - 1) then
!
!  START OF A NEW ATOM.  DOES A SYMMETRY OPERATION RELATE AN ALREADY
!  CALCULATED ATOM TO THIS ONE
!
          j = (i + 2)/3
          call sympop (fmatrx, j, iskip, deldip)
        end if
        if (iskip > 0) then
          write (line, '(" STEP:",I4,23X,"INTEGRAL =",F10.2," TIME LEFT:",F10.2)') i, totime, tleft
          write(iw,"(a)")line(:len_trim(line))
          call to_screen(line)
          endfile (iw)
          backspace (iw)
          iskip = iskip - 1
          lu = lu + i
          cycle
        end if
        time2 = seconds(1)
        delta = 1.D0/120.D0
        g2old = 0.D0
        if (precis) then
!
!   DETERMINE A GOOD STEP SIZE
!
          g2old = 100.D0
          xparam(i) = xparam(i) + delta
          call compfg (xparam, .TRUE., escf, .TRUE., g2old, .TRUE.)
          if (moperr) return
          xparam(i) = xparam(i) - delta
          delta = delta*10.D0/sqrt(ddot(nvar,g2old,1,g2old,1))
!
!   CONSTRAIN DELTA TO A 'REASONABLE' VALUE
!
          delta = min(0.05D0,max(0.005D0,delta))
          if (debug) write (iw, '(A,I3,A,F15.8)') ' STEP:', i, ' DELTA :', delta
          g2old(1) = 100.D0
          xparam(i) = xparam(i) + delta
          emin = 0.d0
          call compfg (xparam, .TRUE., escf, .TRUE., g2old, .TRUE.)
          if (moperr) return
!
          if (debug) write (iw, '(A,F12.5)') ' GNORM +1.0*DELTA',  &
            & dsqrt(ddot(nvar,g2old,1,g2old,1))
          xparam(i) = xparam(i) - delta*2.D0
          g2rad = 100.D0
          emin = 0.d0
          call compfg (xparam, .TRUE., escf, .TRUE., g2rad, .TRUE.)
          if (moperr) return
          xparam(i) = xparam(i) + delta
          if (debug) write (iw, '(A,F12.5)') ' GNORM -1.0*DELTA', &
            dsqrt(ddot(nvar,g2rad,1,g2rad,1))
        else
          if (debug) write (iw, '(A,I3,A,F15.8)') ' STEP:', i, ' DELTA :', delta
        end if
        xparam(i) = xparam(i) + 0.5D0*delta
        grold = 100.D0
        emin = 0.d0
        call compfg (xparam, .TRUE., escf, .TRUE., grold, .TRUE.)
        if (moperr) return
        if (debug) then
          if (precis) then
            write (iw, '(A,F12.5)') ' GNORM +0.5*DELTA', dsqrt(ddot(nvar,grold,1,grold,1))
          else
            write (iw, '(A,F12.5)') ' GNORM +DELTA:', dsqrt(ddot(nvar,grold,1,grold,1))
          end if
        end if
!
        call chrge (p, q)

        q(:numat) = tore(labels(:numat)) - q(:numat)
!
!   ESTIME IS USED HERE AS DIPOLE IS A FUNCTION
!
        store_numat = numat
        numat = nvar/3
        if (mozyme) then
          estime = dipole_for_MOZYME (deldip(1,i),0)
        else
          estime = dipole(p,xparam,deldip(1,i),0)
        end if
        numat = store_numat
        xparam(i) = xparam(i) - delta
        grad(1) = escf ! dummy use of escf and grad
        emin = 0.d0
        call compfg (xparam, .TRUE., escf, .TRUE., grad, .TRUE.)
        if (moperr) return
        if (debug) then
          if (precis) then
            write (iw, '(A,F12.5)') ' GNORM -0.5*DELTA', sqrt(dot(grad,grad,nvar))
          else
            write (iw, '(A,F12.5)') ' GNORM -DELTA:', sqrt(dot(grad,grad,nvar))
          end if
        end if
        call chrge (p, q)
        q(:numat) = tore(labels(:numat)) - q(:numat)
!
!   ESTIME IS USED HERE AS DIPOLE IS A FUNCTION
!
        store_numat = numat
        numat = nvar/3
        if (mozyme) then
          estime = dipole_for_MOZYME (del2, 0)
        else
          estime = dipole(p,xparam,del2, 0)
        end if
        numat = store_numat
        xparam(i) = xparam(i) + delta*0.5D0
        deldip(1,i) = (deldip(1,i)-del2(1))*0.5D0/delta
        deldip(2,i) = (deldip(2,i)-del2(2))*0.5D0/delta
        deldip(3,i) = (deldip(3,i)-del2(3))*0.5D0/delta
        ll = lu + 1
        lu = ll + i - 1
        l = 0
        if (precis) then
          if (lu - ll + 1 > 0) then
!
!       G2OLD = X + 1.0*DELTA
!       GROLD = X + 0.5*DELTA
!       GRAD  = X - 0.5*DELTA
!       G2RAD = X - 1.0*DELTA
!
            dumy(:lu-ll+1) = (8.D0*(grold(:lu-ll+1)-grad(:lu-ll+1)) - &
              (g2old(:lu-ll+1)-g2rad(:lu-ll+1)))/delta*fact/12.D0
            eigs(:lu-ll+1) = (2.D0*(grold(:lu-ll+1)-grad(:lu-ll+1)) - &
              (g2old(:lu-ll+1)-g2rad(:lu-ll+1)))/delta**3*fact/28.D0
!
!  CORRECT FOR 4'TH ORDER CONTAMINATION
!
            fmatrx(ll:lu) = fmatrx(ll:lu) + dumy(:lu-ll+1)
            l = lu - ll + 1
          end if
          l = l - 1
          do k = i, nvar
            l = l + 1
            kk = (k*(k - 1))/2 + i
            dumy(l) = (8.D0*(grold(l)-grad(l))-(g2old(l)-g2rad(l)))/delta*fact/12.D0
            eigs(l) = (2.D0*(grold(l)-grad(l))-(g2old(l)-g2rad(l)))/delta**3*fact/28.D0
!
!  CORRECT FOR 4'TH ORDER CONTAMINATION
!
            fmatrx(kk) = fmatrx(kk) + dumy(l)
          end do
        else
          if (lu - ll + 1 > 0) then
            dumy(l+1:lu-ll+1+l) = (grold(l+1:lu-ll+1+l)-grad(l+1:lu-ll+1+l))*0.5D0/delta*fact
            fmatrx(ll:lu) = fmatrx(ll:lu) + dumy(l+1:lu-ll+1+l)
            l = lu - ll + 1 + l
          end if
          l = l - 1
          do k = i, nvar
            l = l + 1
            kk = (k*(k - 1))/2 + i
            dumy(l) = (grold(l)-grad(l))*0.5D0/delta*fact
            fmatrx(kk) = fmatrx(kk) + dumy(l)
          end do
        end if
        if (big) then
          j = (i - 1)/3 + 1
          l = i - j*3 + 3
          write (iw, '(a, i'//num//', a)') ' CONTRIBUTIONS TO F-MATRIX FOR '//xyz(l)//" COMPONENT OF ATOM", &
            j, " ("//elemnt(labels(j))//")"
          if (precis) then
            write (iw, '(A)') &
      ' ELEMENT  +1.0*DELTA  +0.5*DELTA  -0.5*DELTA  -1.0*DELTA   2''ND ORDER 4TH ORDER'
            write (iw, '(I7,6F12.6)') (l,g2old(l),grold(l),grad(l),g2rad(l),dumy(l),eigs(l),l=1,nvar)
          else
            write (iw, '(A)') '  MATRIX ELEMENT  +Delta      -Delta      Hessian'
            do l = 1, nvar
              j = (l - 1)/3 + 1
              k = l - j*3 + 3
              write (iw, '(I7, a2, a3, i'//num//', 3F12.6)') l, xyz(k), elemnt(labels(j)), j, grold(l) ,grad(l), dumy(l)
            end do
            write (iw, '(a, 2f12.6)')"   SUM:", sum(grold(1:nvar)), sum(grad(1:nvar))
          end if
        end if
        time3 = seconds(2)
        tstep = time3 - time2
        tleft = max(0.1D0,tleft - tstep)
        if (tstep > 1.D7) tstep = tstep - 1.D7
        totime = totime + tstep
        if (resfil) then
          write (line, &
      '('' STEP:'',I4,'' RESTART FILE WRITTEN, INTEGRAL ='',F10.2,'' TIME LEFT:'',F10.2)') &
      i, min(totime,9999999.9D0), tleft
          write(iw,'(a)')trim(line)
          endfile (iw)
          backspace (iw)
          if (log) write (ilog, '(a)')trim(line)
          resfil = .FALSE.
        else
          write (line, &
      '('' STEP:'',I4,'' TIME ='',F9.2,'' SECS, INTEGRAL ='',F10.2,'' TIME LEFT:'',F10.2)') &
      i, tstep, totime, tleft
          write(iw,'(a)')trim(line)
          endfile (iw)
          backspace (iw)
          if (log) write (ilog, '(a)')trim(line)
        end if
        call to_screen(line)
        estim = totime/i
        if (tlast - tleft > tdump) then
          tlast = tleft
          resfil = .TRUE.
          jstart = 1
          ii = i
          call forsav (totime, deldip, ii, fmatrx, coord, nvar, heat, evecs, &
            jstart, fconst)
          if (moperr) return
        end if
        if (.not.(i /= nvar .and. tleft - 10.D0 < estim .or. i - istart >= maxcyc - 1)) &
          cycle
        write (iw, &
      '(2/10X,''- - - - - - - TIME UP - - - - - - -'',2/)')
        write (iw, '(/10X,'' POINT REACHED ='',I4)') i
        write (iw, '(/10X,'' RESTART USING KEY-WORD "RESTART"'')')
        write (iw, &
          '(10X,''ESTIMATED TIME FOR THE NEXT STEP ='',F9.2, '' SECONDS'')') estim
        jstart = 1
        ii = i
        call forsav (totime, deldip, ii, fmatrx, coord, nvar, heat, evecs, &
          jstart, fconst)
        if (moperr) return
        write (iw, '(2/10X,''FORCE MATRIX WRITTEN TO DISK'')')
        nreal = -1
        return
      end do
      do i = 1, natoms
        if (atmass(i)>=1.D-20 .or. labels(i)>=99) cycle
        call forsav (totime, deldip, nvar, fmatrx, coord, nvar, heat, evecs, &
          iloop, fconst)
        if (moperr) return
        write (iw, '(A)') ' AT LEAST ONE ATOM HAS A ZERO MASS. A RESTART'
        write (iw, '(A)') ' FILE HAS BEEN WRITTEN AND THE JOB STOPPED'
        call mopend (&
       'AT LEAST ONE ATOM HAS A ZERO MASS.  A RESTART FILE HAS BEEN WRITTEN AND &
       &THE JOB STOPPED')
        return
      end do
      if (istart<=nvar .and. index(keywrd,'ISOT')/=0) &
        call forsav (totime, deldip, nvar, fmatrx, coord, nvar, heat, evecs, iloop, fconst)
      if (moperr) return
      return
      end subroutine fmat

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

module cosmo_C
  implicit none
  logical :: iseps, noeps, useps, lpka
  integer :: nspa, nps, nps2, nden, lenabc, nppa = 1082, &
  amat_dim, isude_dim, nipc, ioldcv
  integer, dimension (2) :: n0
  integer, dimension(:), allocatable :: &
  & iatsp,   & !
  & nar_csm, & !
  & nsetf,i, & !  Watch out for the "i"
  & ipiden,  & !
  & idenat,  & !
  & nset       !
  integer, dimension(:,:), allocatable :: &
  & isude,   & !
  & nn
  double precision ::&
    fepsi,       & ! Dielectric factor =  (e-1)/(e+0.5), e = dielectric constant
                   !
    rds, disex2, &
                   !
    ediel,       & ! Dielectric energy, in eV
                   !
    solv_energy, & ! Solvation energy, in eV
                   !
    area,        & ! Surface area, in square Angstroms
                   !
    cosvol,      & ! Molecular volume, in cubic Angstroms
                   !
    cif1, cif2,  & !
   fnsq, rsolv
  double precision :: ffact = 0.d0
  double precision, dimension(:), allocatable :: diagsl
  double precision, dimension(3,3,1082) :: tm
  double precision, dimension(4,1082) :: dirsm, dirvec
  double precision, dimension(:), allocatable :: &
  & amat,    & !
  & gden,    & !
  & qscat,   & !
  & arat,    & !
  & srad,    & !
  & qden
  double precision, dimension(:,:), allocatable :: &
  & bmat,    & !
  & phinet,  & !
  & qscnet,  & !
  & qdenet,  & !
  & cosurf,  & !
  & sude
end module cosmo_C

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

  double precision function dftd3(l_grad, dxyz)
!
! dftd3 is the "D3" method of Grimme, et.al, as described in "A consistent and accurate ab initio
! parametrization of density functional dispersion correction (DFT-D) for the 94 elements H-Pu"
! S. Grimme, J. Antony, S. Ehrlich, H. Krieg, THE JOURNAL OF CHEMICAL PHYSICS 132, 154104 .2010.
!
!  This subroutine is based on materials provided by S. Grimme.
!
!
  use funcon_C, only : a0, fpc_9, fpc_2
  use molkst_C, only : numat, keywrd, E_hb, E_disp, numcal, method_pm8, method_pm6_org, l123
  use common_arrays_C, only: coord, nat, tvec
  use chanel_C, only : iw
  use elemts_C, only: elemnt
  use parameters_C, only: par7, par8, par9, par10
  implicit none
  double precision, intent (inout) ::  dxyz(3, numat)
  logical, intent (in):: l_grad
!
! local and dummy variables
!
  integer, parameter :: max_elem = 94, maxc = 5 ! maximum coordination number references per element
  integer :: i, mxc(max_elem), icalcn = -1
  logical :: D3H4, first = .true.
  double precision :: au_to_kcal, e6, e8, rs6, rs8, s6, s18, store_tvec(3,3), &
    alp6, alp8, rs18, alp, ehb, hbscale
  double precision :: &
    c6ab(max_elem, max_elem, maxc, maxc, 3), & ! C6 for all element pairs
    rcov(max_elem),                          & ! covalent radii
    r2r4(max_elem),                          & ! atomic <r^2>/<r^4> values
    r0ab(max_elem, max_elem)                   ! cut - off radii for all element pairs
    double precision, allocatable :: &
    dxyz_temp(:,:),                          &  ! Contribution to gradient
    store_coord(:,:)                                    ! Coordinates in au

  save
!
! PBE0/def2 - QZVP atomic values
!
      data r2r4 / &
       8.0589d0,  3.4698d0, 29.0974d0, 14.8517d0, 11.8799d0,  7.8715d0,  5.5588d0, &
       4.7566d0,  3.8025d0,  3.1036d0, 26.1552d0, 17.2304d0, 17.7210d0, 12.7442d0, &
       9.5361d0,  8.1652d0,  6.7463d0,  5.6004d0, 29.2012d0, 22.3934d0, 19.0598d0, &
      16.8590d0, 15.4023d0, 12.5589d0, 13.4788d0, 12.2309d0, 11.2809d0, 10.5569d0, &
      10.1428d0,  9.4907d0, 13.4606d0, 10.8544d0,  8.9386d0,  8.1350d0,  7.1251d0, &
       6.1971d0, 30.0162d0, 24.4103d0, 20.3537d0, 17.4780d0, 13.5528d0, 11.8451d0, &
      11.0355d0, 10.1997d0,  9.5414d0,  9.0061d0,  8.6417d0,  8.9975d0, 14.0834d0, &
      11.8333d0, 10.0179d0,  9.3844d0,  8.4110d0,  7.5152d0, 32.7622d0, 27.5708d0, &
      23.1671d0, 21.6003d0, 20.9615d0, 20.4562d0, 20.1010d0, 19.7475d0, 19.4828d0, &
      15.6013d0, 19.2362d0, 17.4717d0, 17.8321d0, 17.4237d0, 17.1954d0, 17.1631d0, &
      14.5716d0, 15.8758d0, 13.8989d0, 12.4834d0, 11.4421d0, 10.2671d0,  8.3549d0, &
       7.8496d0,  7.3278d0,  7.4820d0, 13.5124d0, 11.6554d0, 10.0959d0,  9.7340d0, &
       8.8584d0,  8.0125d0, 29.8135d0, 26.3157d0, 19.1885d0, 15.8542d0, 16.1305d0, &
      15.6161d0, 15.1226d0, 16.1576d0/
!
! covalent radii (taken from Pyykko and Atsumid0, Chem. Eur. J. 15d0, 2009d0, 188 - 197)
! values for metals decreased by 10 %
!
      data rcov/ &
      0.32d0, 0.46d0, 1.20d0, 0.94d0, 0.77d0, 0.75d0, 0.71d0, 0.63d0, 0.64d0, 0.67d0, &
      1.40d0, 1.25d0, 1.13d0, 1.04d0, 1.10d0, 1.02d0, 0.99d0, 0.96d0, 1.76d0, 1.54d0, &
      1.33d0, 1.22d0, 1.21d0, 1.10d0, 1.07d0, 1.04d0, 1.00d0, 0.99d0, 1.01d0, 1.09d0, &
      1.12d0, 1.09d0, 1.15d0, 1.10d0, 1.14d0, 1.17d0, 1.89d0, 1.67d0, 1.47d0, 1.39d0, &
      1.32d0, 1.24d0, 1.15d0, 1.13d0, 1.13d0, 1.08d0, 1.15d0, 1.23d0, 1.28d0, 1.26d0, &
      1.26d0, 1.23d0, 1.32d0, 1.31d0, 2.09d0, 1.76d0, 1.62d0, 1.47d0, 1.58d0, 1.57d0, &
      1.56d0, 1.55d0, 1.51d0, 1.52d0, 1.51d0, 1.50d0, 1.49d0, 1.49d0, 1.48d0, 1.53d0, &
      1.46d0, 1.37d0, 1.31d0, 1.23d0, 1.18d0, 1.16d0, 1.11d0, 1.12d0, 1.13d0, 1.32d0, &
      1.30d0, 1.30d0, 1.36d0, 1.31d0, 1.38d0, 1.42d0, 2.01d0, 1.81d0, 1.67d0, 1.58d0, &
      1.52d0, 1.53d0, 1.54d0, 1.55d0/
     if (icalcn /= numcal) then
        icalcn = numcal
        if (first) then
          first = .false.
          rcov = 4.d0/3.d0*rcov/a0
          au_to_kcal = fpc_9*fpc_2/a0
          do i = 1, max_elem
            r2r4(i) = sqrt(0.5d0*r2r4(i)*sqrt(float(i)))
          end do
          call setr0ab(max_elem, a0, r0ab)
          call copyc6(maxc, max_elem, c6ab, mxc)
        end if
      end if
      D3H4 = (method_pm6_org .or. method_PM8 .or. index(keywrd, "D3H4") + index(keywrd, "D3(H4)") /= 0)
      if (D3H4) then
! The D3H4 version of the dispersion
! Used in PM6-D3H4 and its variants PM6-D3H4X, PM6-D3(H4)
! I'VE CHECKED THAT THIS SETUP & THE PARAMETER VALUES READ FROM
! parameters_for_PM6 YIELD CORRECT PM6-D3H4 energies
        s6   = par7
        alp  = par8
        rs6 = par9
        s18 = par10
        rs18 = 1.d-10
      else ! hard-wired
!
! Grimme, S. (2012). "Supramolecular Binding Thermodynamics
! by Dispersion-Corrected Density Functional Theory." Chem. Eur. J.: 9955:9964.
!
        s6   = 1.0d0
        rs18 = 1.0d0
        alp = 14.0d0
        rs6 = 1.560d0   ! rs6 = s_(r,6) in Grimme's paper
        s18 = 1.009d0   ! s18 = s_8 in Grimme's paper
      end if
      hbscale = 1.301d0
      rs8   = rs18
      alp6  = alp
      alp8  = alp + 2.d0
!
!   Switch from MOPAC (convert coordinates from Angstroms to au)
!
      store_tvec = tvec
      allocate(dxyz_temp(3,numat*l123), store_coord(3,numat))
      store_coord = coord(:,:numat)
      coord(:,:numat) = coord(:,:numat)/a0
      tvec = tvec/a0
      call edisp(max_elem, maxc, numat, nat, c6ab, mxc, r2r4, r0ab, rcov, rs6, rs8, alp6, alp8, e6, e8)
      e6 = e6*s6
      e8 = e8*s18
      E_disp = (- e6 - e8)*au_to_kcal
      dxyz_temp = 0.0d0
!
! HBOND
!
      if (.not. D3H4) then
        call hbsimple(numat, nat, coord, hbscale, ehb, l_grad, dxyz_temp)
      else
        ehb = 0.d0
      end if
      E_hb   = ehb*au_to_kcal
      dftd3  = E_disp + E_hb
      if(l_grad)then
        call gdisp(r0ab, rs6, alp6, c6ab, s6, s18,mxc, r2r4, rcov, rs8, alp8, dxyz_temp)
        dxyz = dxyz + 2.d0*dxyz_temp*au_to_kcal
        if (index(keywrd, " DERIV") > 0) then
          write (iw, '(/16X,a)')"GRIMME'S D3 CORRECTIONS"
          write (iw, '(" NUMBER  ATOM  ",5X,"X",12X,"Y",12X,"Z",/)')
          write (iw, '(I6,4x,a2,F13.6,2F13.6)') (i, elemnt(nat(i)), dxyz_temp(:,i)*2.d0*au_to_kcal, i = 1,numat)
        end if
      end if
      coord(:,:numat) = store_coord
      tvec = store_tvec
      deallocate(dxyz_temp, store_coord)
  end function dftd3

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      module Parameters_for_AM1_Sparkles_C
      double precision, dimension(107) :: alpam1sp, gssam1sp
      double precision, dimension(107,4) :: guesam1sp1, guesam1sp2, guesam1sp3
!
!       Data for Element  57:    Lanthanum
!
      data      alpam1sp( 57)/       2.1879021d0/
      data    guesam1sp1( 57,1)/       1.3207809d0/
      data    guesam1sp2( 57,1)/       7.1394307d0/
      data    guesam1sp3( 57,1)/       1.8503282d0/
      data    guesam1sp1( 57,2)/       0.3425778d0/
      data    guesam1sp2( 57,2)/       8.7780632d0/
      data    guesam1sp3( 57,2)/       3.1678964d0/
      data    gssam1sp(57) /          55.7344864002d0/
!
!       Data for Element  58:       Cerium
!
      data      alpam1sp( 58)/       2.6637770d0/
      data    guesam1sp1( 58,1)/       1.7507655d0/
      data    guesam1sp2( 58,1)/       7.6163181d0/
      data    guesam1sp3( 58,1)/       1.8064853d0/
      data    guesam1sp1( 58,2)/       0.0093401d0/
      data    guesam1sp2( 58,2)/       8.7664931d0/
      data    guesam1sp3( 58,2)/       3.2008171d0/
      data    gssam1sp(58)  /         58.7223887052d0/
!
!       Data for Element  59: Praseodymium
!
      data      alpam1sp( 59)/       2.6104230d0/
      data    guesam1sp1( 59,1)/       1.7515391d0/
      data    guesam1sp2( 59,1)/       7.6039743d0/
      data    guesam1sp3( 59,1)/       1.8084677d0/
      data    guesam1sp1( 59,2)/       0.0097057d0/
      data    guesam1sp2( 59,2)/       8.7264195d0/
      data    guesam1sp3( 59,2)/       2.9111890d0/
      data    gssam1sp(59)  /         58.9017644267d0/
!
!       Data for Element  60:    Neodymium
!
      data      alpam1sp( 60)/       4.5002951d0/
      data    guesam1sp1( 60,1)/       1.1206946d0/
      data    guesam1sp2( 60,1)/       6.8295606d0/
      data    guesam1sp3( 60,1)/       1.7859050d0/
      data    guesam1sp1( 60,2)/       0.1070369d0/
      data    guesam1sp2( 60,2)/      10.7894805d0/
      data    guesam1sp3( 60,2)/       3.1628661d0/
      data    gssam1sp(60)  /         57.6242766015d0/
!
!       Data for Element  61:   Promethium
!
      data      alpam1sp( 61)/       3.1059834d0/
      data    guesam1sp1( 61,1)/       1.7347671d0/
      data    guesam1sp2( 61,1)/       9.2464226d0/
      data    guesam1sp3( 61,1)/       1.7533419d0/
      data    guesam1sp1( 61,2)/       0.2571017d0/
      data    guesam1sp2( 61,2)/       7.8793445d0/
      data    guesam1sp3( 61,2)/       3.0498163d0/
      data    gssam1sp(61)  /         59.4249705519d0/
!
!       Data for Element  62:     Samarium
!
      data      alpam1sp( 62)/       4.1758509d0/
      data    guesam1sp1( 62,1)/       0.9592885d0/
      data    guesam1sp2( 62,1)/       6.4799924d0/
      data    guesam1sp3( 62,1)/       1.7381402d0/
      data    guesam1sp1( 62,2)/       0.0261004d0/
      data    guesam1sp2( 62,2)/       9.7391952d0/
      data    guesam1sp3( 62,2)/       2.8881177d0/
      data    gssam1sp(62)  /         56.9935144820d0/
!
!       Data for Element  63:     Europium
!
      data      alpam1sp( 63)/       2.1247189d0/
      data    guesam1sp1( 63,1)/       0.5695122d0/
      data    guesam1sp2( 63,1)/       7.4680208d0/
      data    guesam1sp3( 63,1)/       1.7319730d0/
      data    guesam1sp1( 63,2)/       0.3286619d0/
      data    guesam1sp2( 63,2)/       7.8009780d0/
      data    guesam1sp3( 63,2)/       2.9641285d0/
      data    gssam1sp(63) /          55.6059122033D0/
!
!       Data for Element  64:   Gadolinium
!
      data      alpam1sp( 64)/       3.6525485d0/
      data    guesam1sp1( 64,1)/       0.7013512d0/
      data    guesam1sp2( 64,1)/       7.5454483d0/
      data    guesam1sp3( 64,1)/       1.7761953d0/
      data    guesam1sp1( 64,2)/       0.1293094d0/
      data    guesam1sp2( 64,2)/       8.3437991d0/
      data    guesam1sp3( 64,2)/       3.0110320d0/
      data    gssam1sp(64) /          55.7083247618D0/
!
!       Data for Element  65:      Terbium
!
      data      alpam1sp( 65)/       2.3418889d0/
      data    guesam1sp1( 65,1)/       0.7734458d0/
      data    guesam1sp2( 65,1)/       7.6510526d0/
      data    guesam1sp3( 65,1)/       1.7033464d0/
      data    guesam1sp1( 65,2)/       0.3936233d0/
      data    guesam1sp2( 65,2)/       7.9261457d0/
      data    guesam1sp3( 65,2)/       3.0132951d0/
      data    gssam1sp(65) /          55.7245956904D0/
!
!       Data for Element  66:   Dysprosium
!
      data      alpam1sp( 66)/       2.4164925d0/
      data    guesam1sp1( 66,1)/       1.0385214d0/
      data    guesam1sp2( 66,1)/       8.0016177d0/
      data    guesam1sp3( 66,1)/       1.7161372d0/
      data    guesam1sp1( 66,2)/       0.3018082d0/
      data    guesam1sp2( 66,2)/       8.7917319d0/
      data    guesam1sp3( 66,2)/       2.9953821d0/
      data    gssam1sp(66)  /         55.7676495431d0/
!
!       Data for Element  67:      Holmium
!
      data      alpam1sp( 67)/       3.5558256d0/
      data    guesam1sp1( 67,1)/       0.9819488d0/
      data    guesam1sp2( 67,1)/       8.9158637d0/
      data    guesam1sp3( 67,1)/       1.7513929d0/
      data    guesam1sp1( 67,2)/       0.5454297d0/
      data    guesam1sp2( 67,2)/       8.6358144d0/
      data    guesam1sp3( 67,2)/       3.0176829d0/
      data    gssam1sp(67)  /         58.0375569983d0/
!
!       Data for Element  68:       Erbium
!
      data      alpam1sp( 68)/       3.6568233d0/
      data    guesam1sp1( 68,1)/       0.7029402d0/
      data    guesam1sp2( 68,1)/       8.7235010d0/
      data    guesam1sp3( 68,1)/       1.7746085d0/
      data    guesam1sp1( 68,2)/       0.1321262d0/
      data    guesam1sp2( 68,2)/       8.3498076d0/
      data    guesam1sp3( 68,2)/       3.0114807d0/
      data    gssam1sp(68)  /         58.0489423317d0/
!
!       Data for Element  69:      Thulium
!
      data      alpam1sp( 69)/       2.6969697d0/
      data    guesam1sp1( 69,1)/       0.9252929d0/
      data    guesam1sp2( 69,1)/       7.8636142d0/
      data    guesam1sp3( 69,1)/       1.7113099d0/
      data    guesam1sp1( 69,2)/       0.4125806d0/
      data    guesam1sp2( 69,2)/       8.5211941d0/
      data    guesam1sp3( 69,2)/       2.9817875d0/
      data    gssam1sp(69)  /         55.8847434446d0/
!
!       Data for Element  70:    Ytterbium
!
      data      alpam1sp( 70)/       4.0022391d0/
      data    guesam1sp1( 70,1)/       1.0231211d0/
      data    guesam1sp2( 70,1)/       8.3969198d0/
      data    guesam1sp3( 70,1)/       1.7046767d0/
      data    guesam1sp1( 70,2)/       0.3351965d0/
      data    guesam1sp2( 70,2)/       7.2817207d0/
      data    guesam1sp3( 70,2)/       2.9140122d0/
      data    gssam1sp(70)  /         56.1788359906d0/
!
!       Data for Element  71:     Lutetium
!
      data      alpam1sp( 71)/       4.0203424d0/
      data    guesam1sp1( 71,1)/       1.0381639d0/
      data    guesam1sp2( 71,1)/       8.4911797d0/
      data    guesam1sp3( 71,1)/       1.7034421d0/
      data    guesam1sp1( 71,2)/       0.3342233d0/
      data    guesam1sp2( 71,2)/       7.2729947d0/
      data    guesam1sp3( 71,2)/       2.9153096d0/
      data    gssam1sp(71)  /         56.1751741742d0/

   end module Parameters_for_AM1_Sparkles_C

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

 subroutine init_filenames
    use molkst_C, only: jobnam, line, gui
    use chanel_C, only : output_fn, restart_fn, brillouin_fn, &
     & density_fn, log_fn, end_fn, archive_fn, esp_fn, ump_fn, &
     mep_fn, pol_fn, gpt_fn, esr_fn, input_fn, xyz_fn, syb_fn, &
     cosmo_fn
    implicit none
    integer :: text_length
    text_length = len_trim (jobnam)
    line = trim(jobnam)
    call upcase(line, len_trim(jobnam))
    if (text_length > 3) then
      if (jobnam(text_length - 3:text_length - 3) == ".") then
        if ((line(text_length - 3:text_length) == ".MOP") .or. &
            (line(text_length - 3:text_length) == ".DAT") .or. &
            (line(text_length - 3:text_length) == ".ARC") .or. &
            (line(text_length - 3:text_length) == ".PDB") .or. &
            (line(text_length - 3:text_length) == ".ENT") .or. &
            (line(text_length - 3:text_length) == ".NEW"))      &
        text_length = text_length - 4
      end if
    end if
!
!  Set up the name of the files that are related to the input file name
!
    input_fn      = jobnam(1:text_length) // ".temp"
    output_fn     = jobnam(1:text_length) // ".out"
    restart_fn    = jobnam(1:text_length) // ".res"
    density_fn    = jobnam(1:text_length) // ".den"
    log_fn        = jobnam(1:text_length) // ".log"
    end_fn        = jobnam(1:text_length) // ".end"
    archive_fn    = jobnam(1:text_length) // ".arc"
    brillouin_fn  = jobnam(1:text_length) // ".brz"
    esp_fn        = jobnam(1:text_length) // ".esp"
    ump_fn        = jobnam(1:text_length) // ".ump"
    mep_fn        = jobnam(1:text_length) // ".mep"
    pol_fn        = jobnam(1:text_length) // ".pol"
    gpt_fn        = jobnam(1:text_length) // ".gpt"
    esr_fn        = jobnam(1:text_length) // ".esr"
    xyz_fn        = jobnam(1:text_length) // ".xyz"
    syb_fn        = jobnam(1:text_length) // ".syb"
    cosmo_fn      = jobnam(1:text_length) // ".cos"
    if (gui) output_fn     = "OUTPUT file"
  end subroutine init_filenames

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

double precision function pardip (coord, nat)
  !**********************************************************************
  !
  !   PARDIP  1:  Computes the dipole moment.
  !
  !**********************************************************************
    use molkst_C, only : numat
    use parameters_c, only : tore
    use common_arrays_C, only : p, q
  !
  !.. Implicit Declarations ..
    implicit none
  !
  !.. Formal Arguments ..
    double precision, dimension (3, numat), intent (inout) :: coord
    integer, dimension (numat), intent (in) :: nat
  !
  !.. Local Scalars ..
    integer :: i, l
  !
  !.. Local Arrays ..
    double precision, dimension (3) :: dumy
  !
  !.. External Calls ..
    external chrge
  !
  !.. External Functions ..
    double precision, external :: dipole
  !
  ! ... Executable Statements ...
  !
  !
  !  Calculate the total number of electrons on each atom
  !
    call chrge (p, q)
  !
  !  Calculate the charge on each atom
  !
    do i = 1, numat
      l = nat(i)
      q(i) = tore(l) - q(i)
    end do
  !
  !  Calculate the dipole
  !
    pardip = dipole (p, coord, dumy, 1)
end function pardip

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine mecih(diag, cimat, nmos, lab, xy)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use meci_C, only : microa, microb, nalmat, ispqr, is, iiloop, jloop
!***********************************************************************
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer  :: nmos
      integer , intent(in) :: lab
      double precision, dimension(*), intent(in)  :: xy
      double precision , intent(in) :: diag(*)
      double precision , intent(out) :: cimat(*)
!-----------------------------------------------
!   L o c a l   V a r iiloop a b l e s
!-----------------------------------------------
      integer :: ik, ix, iy, j
      double precision, external :: aababc, aabacd, aabbcd, babbbc, babbcd
!-----------------------------------------------
!
!     BUILD THE C.I. MATRIX 'CIMAT' IN PACKED CANONICAL FORM.
!
!
      ik = 0
!
!     OUTER LOOP TO FILL C.I. MATRIX.
      do iiloop = 1, lab
        is = 2
!
!     INNER LOOP.
        do jloop = 1, iiloop
          ik = ik + 1
          cimat(ik) = 0.D0
          ix = 0
          iy = 0
          do j = 1, nmos
            ix = ix + abs(microa(j,iiloop)-microa(j,jloop))
            iy = iy + abs(microb(j,iiloop)-microb(j,jloop))
          end do
!
!                              CHECK IF MATRIX ELEMENT HAS TO BE ZERO
!
          if (ix + iy>4 .or. nalmat(iiloop)/=nalmat(jloop)) cycle
          if (ix + iy == 4) then
            if (ix == 0) then
              cimat(ik) = babbcd(microa(1,iiloop),microb(1,iiloop),microa(1,jloop),microb(1,jloop&
                ),nmos,xy)
            else if (ix == 2) then
              cimat(ik) = aabbcd(microa(1,iiloop),microb(1,iiloop),microa(1,jloop),microb(1,jloop&
                ),nmos,xy)
            else
              cimat(ik) = aabacd(microa(1,iiloop),microb(1,iiloop),microa(1,jloop),microb(1,jloop&
                ),nmos,xy)
            end if
          else if (ix == 2) then
            cimat(ik) = aababc(microa(1,iiloop),microb(1,iiloop),microa(1,jloop),nmos,xy)
          else if (iy == 2) then
            cimat(ik) = babbbc(microa(1,iiloop),microb(1,iiloop),microb(1,jloop),nmos,xy)
          else
            cimat(ik) = diag(iiloop)
          end if
        end do
        ispqr(iiloop,1) = is - 1
      end do
      return
      end subroutine mecih

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

! RMG - subroutine added to control Reimers CI in MOPAC
      subroutine rci ()

      USE chanel_C, only: iw
      USE reimers_C, only: beta, cc0, dd, n, nb2, nvh, nol, &
          ndtype, dm, x, y, z, xz, zcore, ion, ndump, gamma, &
          ci, tot, nbtmo, iconf, aocc, bocc, &
          spintr, cimatr, nstop, nconf, ic, id, dmci, &
          evalci, nptg, nspn, dtmp, nciout, nex, &
          nold, nvhd, nolc, nvhc, ncore, mrci, dbls
      USE molkst_C, only: norbs, keywrd, nopen, nclose
      USE overlaps_C, only: fact

      implicit none

      integer :: i, j, occ, vir, occd, vird, occc, virc, noh, nvl, &
                 ndoubl, nmos, nc2
      double precision, allocatable :: e(:)
      double precision, external :: reada
      logical :: sing

      n = norbs
      nb2 = n*(n+1)/2
!     ****        transform one-electron matrix in active CI space ****
      call ao2mo  (beta, cc0, dd, norbs, n, 1, n)
!     ****        transform dipole matrices in active CI space ****
      j = nol

!     ****	  get symmetry properties of gamma ****
      nptg = 1
      ion = 1
      call ptgrp(0)
      if(allocated(ci))  deallocate(ci)
      allocate(ci(n, n))

      call stgamm (gamma, ci)

      if(allocated(dm))  deallocate(dm)
      allocate(dm(nb2, 3))

! Need to compute ground-state dipole to get proper dm matrix for CI
! dipoles
      do i = 1, nb2
        dd(i, 1) = dtmp(i, 1)
        dd(i, 2) = dtmp(i, 2)
      end do
      call dipol (x, y, z, dm)

      call gsdip  (xz, dd, zcore, dm)

      do i = 1, 3
        if (ndtype < 4) call ao2mo (dm(1, i), cc0, dd, n, n, 1, n)
      end do


! Read active space information
      noh = nopen
      nvl = nclose + 1


      if (index(keywrd, ' MAXCI=') == 0) then
        nconf = 2000
      else
        nconf = nint(reada(keywrd, index(keywrd, ' MAXCI=')))
      end if
      if (index(keywrd, ' WRTCI=') == 0) then
        nciout = 500
      else
        nciout = nint(reada(keywrd, index(keywrd, ' WRTCI=')))
      end if

! Single excitation active space
      occ = noh
      vir = norbs - nvl + 1

      ndoubl = 99
      if (index(keywrd, 'C.I.=') /= 0) then
        i = index(keywrd, 'C.I.=(')
        if (i /= 0) then
          j = index(keywrd(i:i+10), ',') + i - 1
          ndoubl = nint(reada(keywrd, j))
          nmos = nint(reada(keywrd, index(keywrd, 'C.I.=(') + 5))
          ndoubl = min(ndoubl, nclose)
        else if (index(keywrd, 'C.I.=') /= 0) then
          nmos = nint(reada(keywrd, index(keywrd, 'C.I.=') + 5))
        else
          nmos = nopen - nclose
        end if
        nmos = min(nmos, norbs)
        if (ndoubl == 99) then
          ndoubl = nmos/2
        end if
        occ = min(occ, ndoubl)
        vir = min(vir, nmos - ndoubl)
      end if
! Double excitation active space
      occd = 0
      vird = 0
      ndoubl = 99
      if (index(keywrd, 'CISD') /= 0 .and. index(keywrd, 'C.I.D.') == 0) then
        ! Set default double excitation active space
        occd = min(5, occ)
        vird = min(5, vir)
      else if (index(keywrd, 'C.I.D.') /= 0) then
        i = index(keywrd, 'C.I.D.=(')
        if (i /= 0) then
          j = index(keywrd(i:i+10), ',') + i - 1
          ndoubl = nint(reada(keywrd, j))
          nmos = nint(reada(keywrd, index(keywrd, 'C.I.D.=(') + 7))
          ndoubl = min(ndoubl, nclose)
        else
          nmos = nint(reada(keywrd, index(keywrd, 'C.I.D.=') + 7))
        end if
        nmos = min(nmos, norbs)
        if (ndoubl == 99) then
          ndoubl = nmos/2
        end if
        occd = min(max(occd, ndoubl), noh)
        vird = min(max(vird, nmos - ndoubl), norbs - nvl + 1)
        occd = min(occd, occ)
        vird = min(vird, vir)
      end if
! CAS active space
      occc = 0
      virc = 0
      ndoubl = 99
      if (index(keywrd, 'MRCI') /= 0 .and. index(keywrd, 'C.A.S.') == 0) then
        ! Set default CAS excitation active space
        occc = min(1, occ)
        virc = min(1, vir)
      else if (index(keywrd, 'C.A.S.') /= 0) then
        i = index(keywrd, 'C.A.S.=(')
        if (i /= 0) then
          j = index(keywrd(i:i+10), ',') + i - 1
          ndoubl = nint(reada(keywrd, j))
          nmos = nint(reada(keywrd, index(keywrd, 'C.A.S.=(') + 7))
          ndoubl = min(ndoubl, nclose)
        else
          nmos = nint(reada(keywrd, index(keywrd, 'C.A.S.=') + 7))
        end if
        nmos = min(nmos, norbs)
        if (ndoubl == 99) then
          ndoubl = nmos/2
        end if
        occc = min(max(occc, ndoubl), noh)
        virc = min(max(virc, nmos - ndoubl), norbs - nvl + 1)
        occ = max(occ, occc)
        vir = max(vir, virc)
        occd = max(occd, occc)
        vird = max(vird, virc)
      end if

      nol = max(1, nvl-occ)
      nvh = min(norbs, nvl+vir-1)
      nold = max(1, nvl-occd)
      nvhd = min(norbs, nvl+vird-1)
      nolc = max(1, nvl-occc)
      nvhc = min(norbs, nvl+virc-1)

      sing = .false.
      dbls = .false.
      mrci = .false.
      nex = 1

      if (index(keywrd, ' CIS') /= 0 .or. index(keywrd, ' C.I.') /= 0 &
          .or. index(keywrd, ' MRCI') /= 0) then
        sing = .true.
        nex = (noh-nol+1)*(nvh-nvl+1)+1
      end if
! Doubles count
      if (index(keywrd, ' CISD') /= 0 .or. index(keywrd, ' C.I.D.') /= 0) then
        dbls = .true.
        nex = (noh-nol+1)*(nvh-nvl+1)*((noh-nold+1)*(nvhd-nvl+1)+2)+1
      end if
! MRCI count
      if (index(keywrd, ' MRCI') /= 0 .or. index(keywrd, ' C.A.S.') /= 0) then
        mrci = .true.
        nex = nint(nex * fact((occc+virc)*2) /(fact(occc*2) * fact(virc*2)))
        if (.not. sing) then
          nol = nolc
          nvh = nvhc
        end if
      end if
      ncore = nol-1
      if (nex > 1.D7) then
        write (iw, '("Warning: Generating", i10, " excitations")') nex
      end if

! Make sure nconf and nciout are not too large
      nconf = min(nex, nconf)
      nciout = min(nconf, nciout)
      if (allocated(cimatr))  deallocate(cimatr, stat = i)
      allocate(cimatr(nconf*(nconf+1)/2))
      allocate(e(nconf))
      do i = 1, nconf*(nconf+1)/2
        cimatr(i) = 0.d0
      end do
      if(allocated(iconf))  deallocate(iconf)
      allocate(iconf(nconf))
      do i = 1, nconf
        iconf(i) = 0
      end do
      call excite (iconf, e, cimatr)

      if (nstop == 1 .or. nconf == 0) goto 3

!     ****	  construct dipole moment matrix in config-state basis ****
      deallocate(ci)
      if(allocated(dmci))  deallocate(dmci)
      allocate(dmci(nconf*(nconf+1)/2, 3))
      allocate(ci(nconf, nconf))
      if(allocated(evalci))  deallocate(evalci)
      allocate(evalci(nconf))
      open        (ic, status ='scratch', form ='unformatted')
      write (ic)  ((cc0(i, j), j = 1, n), i = 1, n), (beta(i), i = 1, nb2)
      rewind ic
      call foscil (dmci, dm, iconf, e, aocc, bocc, spintr, nspn, xz, zcore)
      nc2 = nconf*(nconf+1)/2

      open        (id, status ='scratch', form ='unformatted')

      write (id)  ((dmci(i, j), i = 1, nc2), j = 1, 3)
      rewind id
      read (ic)   ((cc0(i, j), j = 1, n), i = 1, n), (beta(i), i = 1, nb2)
      rewind ic
      call cimat (cc0, gamma, beta, nbtmo, iconf, e, aocc, bocc, &
               spintr, nspn, cimatr, ndump)
      call cidiag (cimatr, ci, evalci, aocc, bocc)
!     ****	  trasfer dipole integrals to CI eigenvector basis ****
      read (id)   ((dmci(i, j), i = 1, nc2), j = 1, 3)
      j = nciout

      if(allocated(gamma))       deallocate(gamma)
      allocate(gamma(nconf, nconf))

      do i = 1, 3
        call ao2mo (dmci(1, i), ci, gamma, nconf, nconf, 1, j)
      end do
      call ciout  (ci, evalci, iconf, dmci, aocc, bocc, tot)

3     continue
            if (allocated(cimatr))  deallocate(cimatr, stat = i)
      close (id)
      close (ic)
      return
      end subroutine rci

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine reseq (iopt, lused, n1, new, io)
!
!  on exit, lused: New sequence of atoms.  Atom n is original lused(n)
!
    use molkst_C, only: numat, natoms, keywrd
    use chanel_C, only: iw
    use elemts_C, only: elemnt, atom_names
    use common_arrays_C, only : nat, ibonds, nbonds, txtatm, coord
    implicit none
    integer, intent (inout) :: n1
    integer, intent (inout) :: new
    integer, intent (out) :: io
    logical, dimension (numat), intent (inout) :: iopt
    integer, dimension (natoms), intent (inout) :: lused
!
    integer, parameter :: natomr = 10000, max_n_live = 200
    integer :: i, i2, i3, iatom, ico, ihcr, ires_loc, j, j2, jatom, k, l, &
   & ninres, nlive
    character :: num*1
    integer, dimension (4) :: nbackb
    integer, dimension (max_n_live) :: live
    integer, allocatable :: inres(:)
    logical :: iopt_ico
    logical, external :: peptide_n
!
    allocate (inres(natomr))
    if (index(keywrd, " Move") /= 0) then
!
! "Move" is only present if hydrogen atoms have been added or deleted.  If this is done, then the
! hydrogen atoms need to be put in their correct place in the list of atoms.  It is also important that
! the order of the non-hydrogen atoms is not changed.  For this reason a special subroutine "move_hydrogen_atoms"
! is used.
!
      call move_hydrogen_atoms
      call lewis(.false.)
      n1 = -100
      return
    end if
!
! If "Move" is not present, do a complete resequence of the atoms.  This is complicated...
!
    nbackb = 0
    inres = 0
    call lewis(.false.)
    i = Index (keywrd, " CVB")
    if (i /= 0) then
      call check_cvs(.true.)
    end if
!
!  Break all intra-chain bonds, so that the residues can easily be
!  identified.
!
    call lyse! Break all S-S bonds
!
!   WORK OUT THE BACKBONE
!
    iatom = n1
    do ires_loc = 1, 100000
      call nxtmer (iatom, nbackb)
      ihcr = nbackb(1)
      ico = nbackb(2)
      io = nbackb(3)
      jatom = nbackb(4)
!
!    STORE INDICES FOR  C (OF -HCR-) AND C (OF -CO-) in 'N-C(H,R)-C(=O)'
!
      if (ico > 0) then
        iopt_ico = iopt(ico)
      else
        iopt_ico = .false.
      end if
      if (iopt(iatom) .or. iopt(ihcr) .or. iopt_ico) then
        l = 0
        j = 0
        io = 0
        if (iatom /= 0 .and. iatom == jatom) then
!
!   An amine or ammine group
!
          jatom = 0
          io = -1
        end if
      else if (io == 0) then
        lused(new+1) = iatom
        lused(new+2) = ihcr
        lused(new+3) = ico
        iopt(iatom) = .true.
        iopt(ihcr) = .true.
        iopt(ico) = .true.
        new = new + 3
        l = ihcr
        j = ico
      else if (iopt(io)) then
        l = 0
        j = 0
        io = 0
        if (iatom /= 0 .and. iatom == jatom) then
!
!  Not a residue, but there is something attached to the N at the END
!  of the protein (at the COO end), so turn off everything to do with
!  the backbone, and treat it as a xeno-group.
!
          jatom = 0
          ico = 0
          io = 0
          ihcr = 0
          if ( .not. iopt(iatom)) then
            iopt(iatom) = .true.
            new = new + 1
            lused(new) = iatom
          end if
        end if
      else
        lused(new+1) = iatom
        lused(new+2) = ihcr
        lused(new+3) = ico
        lused(new+4) = io
        iopt(iatom) = .true.
        iopt(ihcr) = .true.
        iopt(ico) = .true.
        iopt(io) = .true.
        new = new + 4
        l = ihcr
        j = ico
      end if
!
!  The residue is attached to IATOM and does not involve JATOM
!
!  NOW TO WORK OUT THE ATOMS IN THE RESIDUE
!
      ninres = 0
      if (io < 1) then
        nlive = 1
        live(1) = iatom
      else
        nlive = 0
        ninres = 0
        do i2 = 1, nbonds(iatom)
          if (nat(ibonds(i2, iatom)) == 1 .or. ibonds(i2, iatom) == ihcr) then
            nlive = nlive + 1
            live(nlive) = ibonds(i2, iatom)
          end if
        end do
      end if
      if (l /= 0) then
        do i2 = 1, nbonds(l)
          live(nlive+i2) = ibonds(i2, l)
        end do
        nlive = nlive + nbonds(l)
        do i2 = 1, nbonds(j)
          live(nlive+i2) = ibonds(i2, j)
        end do
        nlive = nlive + nbonds(j)
      end if
      do
        l = live(1)
        if (l == jatom .or. iopt(l) .or. (l == iatom .or. peptide_n(l)) .and. io > -1) then
          if (nlive == 0) exit
!
!  Pick the lowest numbered atom
!
          i3 = 0
          i2 = 1000000
          do i = 1, nlive
            if (i2 > live(i)) then
              i3 = i
              i2 = live(i)
            end if
          end do
          live(1) = live(i3)
          nlive = nlive - 1
          do i = i3, nlive
            live(i) = live(i + 1)
          end do
        else
          iopt(l) = .true.
!
! Complicated way of saying "If there is a nitrogen atom on its own, add it to the set"
!
          if (io < 0 .and. (l == iatom .or. l == ihcr)) then
            new = new + 1
            lused(new) = l
          end if
          ninres = ninres + 1
          if (ninres > natomr) then
            write (iw, "(A,I4,A,I4)") " There are more than", natomr, &
           & " atoms in residue", ires_loc
            write (iw,*) " Atoms in residue", ires_loc
            write (iw, "(10(1X,A2,I5))") (elemnt(nat(inres(l))), inres(l), &
           & l=1, natomr)
            go to 1000
          else
            inres(ninres) = l
            if (nbonds(l) /= 0) then
!
!  THERE IS AT LEAST ONE ATOM ATTACHED TO THE 'LIVE' ATOM
!
              loop: do i2 = 1, nbonds(l)
                j = ibonds(i2, l)
                do i3 = 1, nlive
                  if (live(i3) == j) cycle loop
                end do
                nlive = nlive + 1
                if (nlive > max_n_live) then
                  go to 1000
                else
                  live(nlive) = j
                end if
              end do loop
              live(1) = ibonds(1, l)
            else
              if (nlive == 0) exit
              live(1) = live(nlive)
              nlive = nlive - 1
            end if
          end if
        end if
      end do
!
!   Check that atoms are not counted twice
!
      do j = 1, ninres
        do k = j + 1, ninres
          if (inres(j) == inres(k)) then
            inres(j) = 0
          end if
        end do
      end do
!
!  Put hydrogen atoms at the end of the list
!
      k = ninres
      do j = 1, ninres
        l = inres(j)
        if (l /= 0) then
          if (nat(l) == 1) then
            k = k + 1
            if (k > natomr) then
              goto 1000
            end if
            inres(k) = l
            inres(j) = 0
          end if
        end if
      end do
      ninres = k
      if (io == 0 .and. iatom /= 0 .and. .not. iopt(iatom)) then
        new = new + 1
        lused(new) = iatom
        iopt(iatom) = .true.
      end if
      do i2 = 1, ninres
        j2 = inres(i2)
        if (j2 /= 0 .and. j2 /= iatom .and. j2 /= ihcr .and. j2 /= ico) then
          new = new + 1
          lused(new) = j2
        end if
      end do
      if (ico > 0) then
!
!  Check to see if a OXT atom exists.  If it does, then move it to the end of the heavy atoms
!
        j = 0
        do i = 1, nbonds(ico)
          if (nat(ibonds(i,ico)) == 8) then
            j = j + 1
            if (ibonds(i,ico) /= io) k = ibonds(i,ico)
          end if
        end do
        if (j == 2) then
  !
  !   Found a terminal -COO structure.  Now move the OXT to the end of the heavy atoms
  !
          do i = new, 1, -1
            if (lused(i) == k) exit
          end do
          do i = i + 1, numat
            if (lused(i) == -1000) exit
            if (nat(lused(i)) == 1) exit
            lused(i - 1) = lused(i)
          end do
          lused(i - 1) = k
        end if
      end if
      j = new
      if (iatom == jatom .or. jatom == 0) go to 1100
      iatom = jatom
    end do
    return
1000 i = 0
    if (ihcr > 0 .and. ihcr <= numat) then
      i = ihcr
    else if (iatom > 0 .and. iatom <= numat) then
      i = iatom
    else if (ico > 0 .and. ico <= numat) then
      i = ico
    end if
    if (index(keywrd, " ADD-H") > 0) then
      write(iw,'(/10x,a)') "Attempt to resequence the atoms after adding hydrogen atoms (ADD-H) failed"
    else if (index(keywrd, " SITE=") > 0) then
      write(iw,'(/10x,a)') "Attempt to resequence the atoms after adding or deleting hydrogen atoms (SITE) failed"
    else
      write(iw,'(/10x,a)') "Attempt to resequence the atoms by using keyword RESEQ failed"
    end if
    if (i > 0) then
      do j = 1, 10
        if (atom_names(nat(i))(j:j) /= " ") exit
      end do
      num = char(ichar("1") + int(log10(i*1.0001)))
      write (iw, "(/10X,A,I"//num//",a,/10x,a, /10x,a, 3F8.3)") &
      "The fault is likely to be near to "//atom_names(nat(i))(j:)//" atom, atom number: ", i, ",", &
      "PDB line label: """//txtatm(i)//""",", &
      "at coordinates:", coord(:,i)
    else
      write(iw,'(/10x,a)')" RESEQ procedure is completely confused!"
    end if
    if (index(keywrd, " ADD-H") + index(keywrd, " SITE=") > 0)  &
      write(iw,'(/10x,a)')"(To avoid this error, add keyword ""NORESEQ"")"
    call mopend("ATTEMPT TO RESEQUENCE ATOMS FAILED")
    call web_message(iw,"residue_too_big.html")
1100 continue
     if (nbackb(4) > 0) then
!
!  SPECIAL CASE - IS THERE A HYDROGEN ATTACHED TO THE FINAL NITROGEN?
       jatom = nbackb(4)
       do i = 1, nbonds(jatom)
         j = ibonds(i, jatom)
         if (.not. iopt(j) .and. nat(j) == 1) then
           iopt(j) = .true.
           new = new + 1
           lused(new) = j
         end if
       end do
     end if
     if (io < 1) return
!
!  SPECIAL CASE - IS THERE A HYDROGEN ATTACHED TO THE FINAL OXYGEN?
!
    do i = 1, nbonds(io)
      j = ibonds(i, io)
      if ( .not. iopt(j) .and. nat(j) == 1) then
        iopt(j) = .true.
        new = new + 1
        lused(new) = j
      end if
    end do
    return
  end subroutine reseq
subroutine move_hydrogen_atoms
!
! At this point, some hydrogen atoms might not be in their correct location in the list of atoms
! so move the hydrogen atoms to their correct place.
!
!  This operation assumes that the geometry had PDB labels in "txtatm"
!
 use common_arrays_C, only : coord, txtatm, nat, atmass, labels, geo, loc, lopt
 USE molkst_C, only : natoms, numat, id
 USE chanel_C, only : iw
 use elemts_C, only : elemnt
 implicit none
 integer :: i, j, k, l, n_res, n_heavy, n_hydrogens
 integer, allocatable :: res_end(:), new_nat(:), new_lopt(:,:), H_lopt(:,:), not_H_lopt(:,:)
 double precision, allocatable :: not_H_coord(:,:), H_coord(:,:), new_coord(:,:), new_atmass(:), &
   H_atmass(:), not_H_atmass(:)
 character*27, allocatable :: not_H_txtatm(:), H_txtatm(:), new_txtatm(:)
 logical :: l_debug
 l_debug = .false.
!
! Separate all the atoms into two sets, one set consisting of the hydrogen atoms, the other set
! consisting of the non-hydrogen atoms.
!
! "res_end" = Atom number of the last atom in residue in the set "not_H_txtatm"
!
 allocate(not_H_txtatm(natoms), H_txtatm(natoms), not_H_coord(3,natoms), H_coord(3,natoms), not_H_atmass(natoms), &
   H_atmass(natoms), H_lopt(3,natoms), not_H_lopt(3,natoms))
 allocate(res_end(natoms), new_txtatm(natoms), new_coord(3,natoms + id), new_nat(natoms + id), new_atmass(natoms), &
   new_lopt(3,natoms))
 n_heavy = 0
 n_hydrogens = 0
 n_res = 0
 do i = 1, numat
   if (txtatm(i)(14:14) == "H") then
     n_hydrogens = n_hydrogens + 1
     H_coord(:,n_hydrogens) = coord(:,i)
     H_txtatm(n_hydrogens) = txtatm(i)
     H_atmass(n_hydrogens) = atmass(i)
     H_lopt(:,n_hydrogens) = lopt(:,i)
   else
     n_heavy = n_heavy + 1
     not_H_coord(:,n_heavy) = coord(:,i)
     not_H_txtatm(n_heavy) = txtatm(i)
     nat(n_heavy) = nat(i)
     not_H_atmass(n_heavy) = atmass(i)
     not_H_lopt(:,n_heavy) = lopt(:,i)
    if (n_heavy > 1) then
       if (not_H_txtatm(n_heavy)(17:26) /= not_H_txtatm(n_heavy - 1)(17:26)) then
         n_res = n_res + 1
         res_end(n_res) = n_heavy - 1
       end if
     end if
   end if
 end do
 n_res = n_res + 1
 res_end(n_res) = n_heavy
 if (l_debug) then
   write(iw,'(10x,a)')"Heavy atoms"
   write(iw,'(i5,3x,a)')(i, not_H_txtatm(i), i = 1, n_heavy)
   write(iw,'(10x,a)')"Hydrogen atoms"
   write(iw,'(i5,3x,a)')(i, H_txtatm(i), i = 1, n_hydrogens)
   write(iw,'(10x,a)')"Number of the last atom in residues"
   write(iw,'(20i5)')res_end(1:n_res)
 end if
!
! Start the merge of hydrogen atoms into their correct locations
!
! l = atom number in merged set
! j = atom number in non-hydrogen atom set
!
 l = 0
 j = 0
 do i = 1, n_res
   do
     l = l + 1
     j = j + 1
     new_coord(:,l) = not_H_coord(:,j)
     new_txtatm(l) = not_H_txtatm(j)
     write(new_txtatm(l)(7:12),'(i5)') l
     new_nat(l) = nat(j)
     new_atmass(l)= not_H_atmass(j)
     new_lopt(:,l) = not_H_lopt(:,j)
     if (j == res_end(i)) then
       do k = 1, n_hydrogens
         if (H_txtatm(k)(17:26) == not_H_txtatm(j)(17:26)) then
           l = l + 1
           new_coord(:,l) = H_coord(:,k)
           new_txtatm(l) = H_txtatm(k)
           H_txtatm(k)(17:26) = "Used"
           new_nat(l) = 1
           new_atmass(l)= H_atmass(k)
           write(new_txtatm(l)(7:12),'(i5)') l
           new_lopt(:,l) = H_lopt(:,k)
         end if
       end do
       continue
       exit
     end if
   end do
 end do
!
! Fill "loc" with the new values
!
 k = 0
 do i = 1, l
   do j = 1,3
     if (new_lopt(j,i) == 1) then
       k = k + 1
       loc(1,k) = i
       loc(2,k) = j
     end if
   end do
 end do

 do i = 1, id
   l = l + 1
   new_coord(:,l) = coord(:, numat + i)
   new_nat(l) = 107
 end do
 if (l_debug) then
   write(iw,*)" New sequence of atoms"
   do i = 1,l
     write(iw, '(1x, a,a, 3(f13.8, a3))')elemnt(new_nat(i)), "("//new_txtatm(i)//")", (new_coord(j,i), " +1", j=1,3)
   end do
 end if
 nat(:natoms) = new_nat(:natoms)
 labels(:natoms) = nat(:natoms)
 atmass(:natoms) = new_atmass(:natoms)
 coord(:,:natoms) = new_coord(:,:natoms)
 geo(:,:natoms) = coord(:,:natoms)
 txtatm(:natoms) = new_txtatm(:natoms)
 return
 end subroutine move_hydrogen_atoms
 subroutine store_and_restore_Tv(mode)
!
! "Protect" information on the translation vectors during operations where the number or sequence of atoms
! is changed.
!
 use molkst_C, only : numat, natoms, id
 use common_arrays_C, only : coord, geo, nat, txtatm, tvec, labels, loc, lopt, l_atom
 implicit none
 character, intent(in) :: mode*(5)
!
! Local storage, all arrays here have to be save'd
!
 integer :: i, j, tv_id = 0, tv_loc(2,9), tv_lopt(3,3), tv_old_natoms
 logical :: first = .true.
 save
 if (mode == "STORE") then
   if (id == 0) return
   natoms = natoms - id
   if (.not. first) return
   first = .false.
!
!  Store data on Tv here
!
   tv_id = id
   tv_old_natoms = natoms
   do i = 1, 3*natoms
     if (loc(1,i) > natoms) exit
   end do
   j = 0
   do i = i, i + 3*id - 1
     j = j + 1
     tv_loc(:,j) = loc(:,i)
   end do
   j = 0
   do i = natoms + 1, natoms + id
     j = j + 1
     tv_lopt(:,j) = lopt(:,i)
   end do
   id = 0
 else
!
!  Restore data on Tv here
!
   id = tv_id
   do i = 1, id
     coord(:,numat + i) = tvec(:,i)
     geo(:,numat + i) = tvec(:,i)
   end do
   nat(numat + 1:numat + id) = 107
   labels(numat + 1:numat + id) = 107

   do i = 1, 3*natoms
     if (loc(1,i) > natoms .or. loc(1,i) == 0) exit
   end do
   j = 0
   do i = i, i + 3*id - 1
     j = j + 1
     loc(1,i) = tv_loc(1,j) + natoms - tv_old_natoms
     loc(2,i) = tv_loc(2,j)
   end do
   j = 0
   do i = natoms + 1, natoms + id
     j = j + 1
     lopt(:,i) = tv_lopt(:,j)
   end do
   do i = numat + 1, numat + id
     write(txtatm(i), '(i11, 1x, a)') i,"Tv"
   end do
   natoms = natoms + id
   l_atom(:natoms) = .true.
   continue
 end if
 return
 end subroutine store_and_restore_Tv

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

module iso_c_binding
!
! Do NOT use this module with the compiler - it is intended for use by FORCHECK only!
!
  implicit none
  integer, parameter :: pointer_len           = int_ptr_kind()
  integer (kind = 4), parameter :: c_intptr_t = pointer_len
  integer (kind = 4), parameter :: c_char     = 1
  integer (kind = 4), parameter :: c_bool     = 1
  integer (kind = 4), parameter :: c_int      = 4
  integer (kind = 4), parameter :: c_float    = 4
  integer (kind = 4), parameter :: c_long     = 4
  integer (kind = 4), parameter :: c_double   = 8
  integer (kind = 4), parameter :: c_size_t   = pointer_len
  type, bind(c) :: c_ptr
    private
    integer(c_intptr_t) :: ptr
  end type c_ptr
end module iso_c_binding

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

subroutine savgeo (loop, geo, na, nb, nc, xparam, loc)
!
    use param_global_C, only : contrl, nas, nbs, ncs, geos, &
    names, refher !, ifiles_8
!
    use molkst_C, only : natoms, nvar, keywrd, title, refkey, escf, &
      line, ncomments
!
    use common_arrays_C, only : all_comments

    implicit none
    integer, intent (in) :: loop
    integer, dimension (natoms), intent (in) :: na, nb, nc
    integer, dimension (2, nvar), intent (in) :: loc
    double precision, dimension (nvar), intent (in) :: xparam
    double precision, dimension (3, natoms), intent (inout) :: geo
!--------------------------------------------------------------------
    character (len=100) :: dirnew
    character (len=100) :: name
    logical :: opend, lsav !, exists
    integer :: i, iatm, igeo, j, k, iw
    character :: num*1
    intrinsic Index
    double precision, external :: reada
    character(len=300), external :: get_a_name
    save :: iatm, igeo
!--------------------------------------------------------------------
  !
  !   Check - should the geometry be saved.  Criterion: NEW_REF exists.
  !   "lsav" is TRUE if the geometry is to be saved.
      lsav = .false.
      iw = 14
      k = Index (contrl, " NEW_REF=")
      if (k /= 0) then
        dirnew = get_a_name(contrl(k + 9:), len_trim(contrl(k + 9:)))
        k = len_trim(dirnew)
        if (dirnew(k:k) /= "/")then
!
! The directory name for the new reference data needs a "/"
!
          k = k + 1
          dirnew(k:k) = "/"
        end if
        do i = 80, 2, -1
          if (names(loop)(i:i) /= " ") exit
        end do
        name = trim(dirnew) // names (loop) (:i) // ".mop"
        inquire (unit=iw, opened=opend)
        if (opend) then
          close (unit=iw, status="KEEP")
        end if
        call add_path(dirnew)
! the directory feature of inquire is specific to the Intel compiler and not standard Fortran, ignoring this for now
!        inquire (directory=trim(dirnew) , exist = exists)
!        if (.not. exists) then
!          write(ifiles_8,'(//10x,a)')"Folder """//trim(dirnew)//""" specified by NEW_REF does not exist"
!          write(ifiles_8,'(/10x,a)')"(Either edit or delete ""NEW_REF"" or create the folder.)"
!          stop
!        end if
        call add_path(name)
        open (iw, status="UNKNOWN", file=name, blank="ZERO", err=1000)
        write (iw, "(A)", err=1000) " Test"
        rewind (iw)
        lsav = .true.
      end if
!
!  keywrd is 248 characters long, refkey is 360 characters long
!
 1000 refkey(1) = trim(keywrd)
     do i = 1, nvar
      geo(loc(2, i), loc(1, i)) = xparam(i)
     end do
     line = title
     if (Index (contrl, " UPDATE ") /= 0) then
!
! Replace the old reference heat of formation with the calculated HoF.
!
       i = index(title, "H=")
       if (i /= 0) then
         do j = i + 2, i + 20
           if ((ichar(title(j:j)) < ichar("0") .or. ichar(title(j:j)) > ichar("9")) .and. &
              ichar(title(j:j)) /= ichar("-") .and. ichar(title(j:j)) /= ichar(".")) exit
         end do
         line(100:) = title(j:) ! j = end of number
         if (line(i + 3:i + 3) == "-") then
           line(i + 3:99) = " "
         else
            line(i + 2:99) = " "
         end if
         if (title(j:j) == "+") then
!
! Re-set escf to difference between calculated error (refher) and that supplied
!
           escf = reada(title, i + 2) + refher
         end if
         if (escf > 0.d0) then
           i = max(int(log10(escf)),0)
           num = char(ichar("5") + i)
         else
           i = max(int(log10(-escf)),0)
           num = char(ichar("6") + i)
         end if
         write(title,"(a,f"//num//".3,a)")trim(line(:99)), escf, trim(line(100:199))
       end if
     end if
  !
  !  Only write out the geometry if the geometry has been optimized.
  !
    if (lsav) then
      if (Index (contrl, " EXPORT ") /= 0) title = " "
      if (index(contrl," LET") /= 0) then
          i = index(refkey(1)," GEO-OK")
          if (i /= 0) refkey(1)(i:i+7) = " "
        end if
      ncomments = 3
      all_comments(1) = "*"
      write(all_comments(2),"('*', f10.3)") escf
      all_comments(3) = "*"
      call geout (iw)
      ncomments = 0
      close (iw)
    end if
    if (loop == 1) then
      igeo = 0
      iatm = 0
    end if
    do i = 1, natoms
      igeo = igeo + 1
      do j = 1, 3
        geos(j, igeo) = geo(j, i)
      end do
    end do
    do i = 1, natoms
      iatm = iatm + 1
      nas(iatm) = na(i)
      nbs(iatm) = nb(i)
      ncs(iatm) = nc(i)
    end do
end subroutine savgeo

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine symopr(numat, coord, jump, r)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
!***********************************************************************
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      integer , intent(in) :: numat
      integer , intent(in) :: jump
      double precision , intent(inout) :: coord(3,numat)
      double precision , intent(in) :: r(3,3)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j
      double precision, dimension(3) :: help
!-----------------------------------------------
!***********************************************************************
!
!   SYMOPR performs the symmetry operation stored in the 3 by 3 array
!          R on the coordinates.   If JUMP is +1, the operation is
!          X.R, if JUMP is -1, the operation is R.X
!
!   On output, COORD = COORD.R or R.COORD
!
!***********************************************************************
      if (jump >= 0) then
        do i = 1, numat
          help = coord(:,i)
          do j = 1, 3
            coord(j,i) = 0.D0
            coord(j,i) = coord(j,i) + sum(r(:,j)*help)
          end do
        end do
        return
      end if
      do i = 1, numat
        help = coord(:,i)
        do j = 1, 3
          coord(j,i) = 0.D0
          coord(j,i) = coord(j,i) + sum(r(j,:)*help)
        end do
      end do
      return
      end subroutine symopr

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.
 
      SUBROUTINE FINISH
!
!   MOPEND SHUTS ALL FILES WHICH MAY HAVE BEEN OPENED
!        AND THEN STARTS A RAPID RETURN TO THE MAIN SEGMENT
!            
      use chanel_C, only: iend, end_fn
      use param_global_C, only : ifiles_8, large
      implicit none
      logical :: exists
      integer :: i
      inquire (file = end_fn, exist = exists)
      if (exists) then
        open(unit=iend, file=end_fn, iostat=i)
        if (i == -100) return
        close(iend, status = 'delete', iostat=i)
        if (i == -100) return
      end if
      end_fn = end_fn(:len_trim(end_fn) - 3)//"res"
      inquire (file = end_fn, exist = exists)
      if (exists) then
        open(unit=iend, file=end_fn, iostat=i)
        if (i == -100) return
        close(iend, status = 'delete', iostat=i)
        if (i == -100) return
      end if
      if (large) write (ifiles_8, '(/,'' == PARAM DONE =='')')
      stop
      END

! Molecular Orbital PACkage (MOPAC)
! Copyright (C) 2021, Virginia Polytechnic Institute and State University
!
! MOPAC is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! MOPAC is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with this program.  If not, see <https://www.gnu.org/licenses/>.

      subroutine symr
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use molkst_C, only : numat
      use common_arrays_C, only : coord
      use chanel_C, only : iw
      use symmetry_C, only : nclass, r, ipo, elem, nsym, nent
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      integer, parameter :: maxent = 6
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: nvalue, i, ndflt, k, j, n
      double precision :: x, y, z, xa, ya, za, dist
      logical :: prob
!-----------------------------------------------
!
!     R(9,*):   The 9 elements of each record are a packed 3 by 3
!          array of a given symmetry operations.
!    IPO(n,*):  A vector that contains the symmetry mapping of atomic ce
!
      if (allocated(ipo)) deallocate(ipo)
      allocate(ipo(numat,120))
      prob = .FALSE.
      nvalue = 0
!  Get the symmetry functions: (NOTE: THE FIRST IS ALWAYS E)
      r(1,1) = 1.D0
      r(2,1) = 0.D0
      r(3,1) = 0.D0
      r(4,1) = 0.D0
      r(5,1) = 1.D0
      r(6,1) = 0.D0
      r(7,1) = 0.D0
      r(8,1) = 0.D0
      r(9,1) = 1.D0
!
!  CENTER THE MOLECULE
!
      x = 0.D0
      y = 0.D0
      z = 0.D0
      do i = 1, numat
        x = x + coord(1,i)
        y = y + coord(2,i)
        z = z + coord(3,i)
        ipo(i,1) = i
      end do
      xa = x/dble(numat)
      ya = y/dble(numat)
      za = z/dble(numat)
      coord(1,:numat) = (-xa) + coord(1,:numat)
      coord(2,:numat) = (-ya) + coord(2,:numat)
      coord(3,:numat) = (-za) + coord(3,:numat)
!
      nent = 1
      nsym = 0
      ndflt = 1
   30 continue
      nsym = nsym + 1
      ndflt = ndflt + 1
      if (ndflt <= nclass) then
!
!   Copy Symmetry Operation from ELEM
!
        k = 0
        nvalue = 1
        do i = 1, 3
          r(k+1:3+k,1+nent) = elem(i,:,ndflt)
          k = 3 + k
        end do
!  NOW, TO CALCULATE THE IPO OF THIS FUNCTION
        nent = 1 + nent
        n = nent
!  Now, to initialize IPO(n) and
!  Perform R on each atomic center and determine where it maps to.
        l80: do i = 1, numat
          x = coord(1,i)*r(1,n) + coord(2,i)*r(2,n) + coord(3,i)*r(3,n)
          y = coord(1,i)*r(4,n) + coord(2,i)*r(5,n) + coord(3,i)*r(6,n)
          z = coord(1,i)*r(7,n) + coord(2,i)*r(8,n) + coord(3,i)*r(9,n)
          ipo(i,n) = 0
          do j = 1, numat
            dist = abs(x - coord(1,j)) + abs(y - coord(2,j)) + abs(z - coord(3,&
              j))
            if (dist >= 0.6D0) cycle
            if (ipo(i,n) == 0) then
              ipo(i,n) = j
            else
              write (iw, 50)
              prob = .TRUE.
              exit  l80
   50         format('  ONE ATOM MAPS ONTO TWO DIFFERENT ATOMIC C','ENTERS',/,&
                '  ADD KEYWORD '' NOSYM'' AND RE-RUN')
            end if
          end do
          if (ipo(i,n) /= 0) cycle  l80
          write (iw, 70)
   70     format('  ONE ATOM MAPS ONTO NO OTHER ATOM ',/,&
            '  ADD KEYWORD '' NOSYM'' AND RE-RUN')
          prob = .TRUE.
          exit  l80
        end do l80
!
!
      end if
      if (nvalue/=0 .and. nsym<maxent) go to 30
!
!  If a problem exists.  Stop the program.
!
      if (prob) then
        write (iw, *) ' PROBLEM IN SYMR'
        call mopend ('PROBLEM IN SYMR')
        return
      end if
      nsym = nent
!
!  NEXT, EXPAND THE EXISTING OPERATORS TO THE FULL SET
!
      call symp
!
      return
      end subroutine symr
      subroutine symp
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use symmetry_C, only : nsym, r, ipo, name
      USE molkst_C, ONLY: numat
      USE chanel_C, only : iw
!***********************************************************************
      implicit none
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      integer, parameter :: maxfun = 120
      double precision, parameter :: tol = 1D-2
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j, n, m
      double precision :: res
!-----------------------------------------------
!****************************************************************
!
!   ON INPUT   R    = SYMMETRY OPERATIONS (7 MAX)
!              IPO  = PERM OPR FOR ABOVE OPERATIONS
!              NSYM = CURRENT NUMBER OF SYMMETRY OPERATIONS
!              NENT = NUMBER OF USER SUPPLIED OPERATIONS
!
!   ON OUTPUT  R    = SYMMETRY OPERATIONS (120 MAX)
!              IPO  = PERMUTATION OPERATOR FOR SYMMETRY OPERATIONS
!              NSYM = NUMBER OF SYMMETRY OPERATIONS
!
!****************************************************************
!
!  A SUBROUTINE THAT WILL EXPAND THE SYMMETRY OPERATIONS READ IN INTO
!     THE COMPLETE SET.  NOTE: VERY FEW OPERATIONS ARE REQUIRED TO
!     GENERATE EVEN VERY LARGE GROUPS OF OPERATIONS.
!
!
!
!
!  Variables used:  (n represents the number of atomic centers)
!
!    For the next two items, the last index represents the symmetry
!        operation number.
!     R(9,*):   The 9 elements of each record are a packed 3 by 3
!          array of a given symmetry operation.
!    IPO(n,*):  A vector that contains the symmetry mapping of atomic ce
!
!  NSYM IS ALWAYS THE UPPER BOUND OF THE VALID FUNCTIONS.  QUIT IF IT
!     REACHES 120.
!  I IS THE SLOW INDEX OF FUNCTIONS TO MULTIPLY
!  J IS THE FAST INDEX OF FUNCTIONS TO MULTIPLY
!  ALWAYS DO R(I)*R(J) AND TAKE I,J FROM 2 TO NSYM
!
      i = 2
      j = 1
!
!  DETERMINE IF IT IS TIME TO STOP
!
   10 continue
      j = j + 1
      if (j > nsym) then
        j = 2
        i = i + 1
        if (i > nsym) go to 50
      end if
      if (nsym == maxfun) go to 50
!
!  NOW TO START THE MULTIPLICATION
!
      r(1,nsym+1) = r(1,i)*r(1,j) + r(2,i)*r(4,j) + r(3,i)*r(7,j)
      r(2,nsym+1) = r(1,i)*r(2,j) + r(2,i)*r(5,j) + r(3,i)*r(8,j)
      r(3,nsym+1) = r(1,i)*r(3,j) + r(2,i)*r(6,j) + r(3,i)*r(9,j)
      r(4,nsym+1) = r(4,i)*r(1,j) + r(5,i)*r(4,j) + r(6,i)*r(7,j)
      r(5,nsym+1) = r(4,i)*r(2,j) + r(5,i)*r(5,j) + r(6,i)*r(8,j)
      r(6,nsym+1) = r(4,i)*r(3,j) + r(5,i)*r(6,j) + r(6,i)*r(9,j)
      r(7,nsym+1) = r(7,i)*r(1,j) + r(8,i)*r(4,j) + r(9,i)*r(7,j)
      r(8,nsym+1) = r(7,i)*r(2,j) + r(8,i)*r(5,j) + r(9,i)*r(8,j)
      r(9,nsym+1) = r(7,i)*r(3,j) + r(8,i)*r(6,j) + r(9,i)*r(9,j)
!
!  IS IT UNIQUE?
!
      do n = 1, nsym
        res = 0.D0
        do m = 1, 9
          res = res + abs(r(m,n)-r(m,nsym+1))
        end do
        if (res < tol) go to 10
      end do
!
!  YES, IT IS UNIQUE.  NOW, GENERATE THE NEW IPO(,NSYM)
!
      nsym = nsym + 1
      do n = 1, numat
        ipo(n,nsym) = ipo(ipo(n,j),i)
      end do
!
!     ALL DONE ADDING THE NEW FUNCTION.  GO TRY TO FIND A NEW ONE.
!
      go to 10
!
!
   50 continue
      write (iw, 60) name, nsym
   60 format(/,'    FOR POINT-GROUP ',a4,' THERE ARE ',i3,&
        ' UNIQUE SYMMETRY FUNCTIONS.',/)
!#       WRITE(IW,*)' Symmetry Operations'
!#       DO 14 I=1,NSYM
!#       WRITE(IW,*)
!#       WRITE(IW,'(3f12.6)')(R(J,I),J=1,9)
!#  14   continue
!
      return
      end subroutine symp

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      module rotate_C
!
!   Set up an equivalence between the core-core array ccore and the individual
!   terms, for use in ROTATE
!
      double precision :: css1, csp1, cpps1, cppp1, css2, csp2, cpps2, cppp2
      double precision, dimension(4,2) :: ccore = 0.d0
      equivalence (ccore(1,1), css1), (ccore(2,1), csp1), (ccore(3,1), cpps1), &
      & (ccore(4,1), cppp1), (ccore(1,2), css2), (ccore(2,2), csp2), &
      & (ccore(3,2), cpps2), (ccore(4,2), cppp2)
      end module rotate_C

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

subroutine chrge_for_MOZYME (p, q)
!
! Evaluate the atomic partial charge.
!
    use molkst_C, only: mpack, numat
    use MOZYME_C, only : iorbs
    implicit none
    double precision, dimension (mpack), intent (in) :: p
    double precision, dimension (numat), intent (out) :: q
!
    integer :: i, ii, j
    double precision :: sum
    integer, external :: ijbo
!
    do i = 1, numat
      ii = ijbo (i, i)
      sum = 0.d0
      do j = 1, iorbs(i)
        ii = ii + j
        sum = sum + p(ii)
      end do
      q(i) = sum
    end do
end subroutine chrge_for_MOZYME

! Molecular Orbital PACkage (MOPAC)
! Copyright 2021 Virginia Polytechnic Institute and State University
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!    http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

      subroutine mecid(eigs, gse, eiga, diag, xy)
!-----------------------------------------------
!   M o d u l e s
!-----------------------------------------------
      use meci_C, only : occa, microa, microb, nmos, lab
!***********************************************************************
!-----------------------------------------------
!   I n t e r f a c e   B l o c k s
!-----------------------------------------------
      implicit none
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      double precision , intent(out) :: gse
      double precision , intent(in) :: eigs(*)
      double precision  :: eiga(*)
      double precision , intent(out) :: diag(*)
      double precision  :: xy(nmos,nmos,nmos,nmos)
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      integer :: i, j
      double precision :: x
      double precision, external :: diagi
!-----------------------------------------------
!***********************************************************************
!
!   MECID CALCULATES THE EFFECT OF REMOVING THE ELECTRONS INVOLVED IN
!   THE C.I. FROM THE GROUND-STATE CONFIGURATION, AND CALCULATES THE
!   MICROSTATE ENERGIES OF THE MICROSTATES INVOLVED IN THE C.I.
!
!  THE QUANTITIES NMOS, NELEC, AND LAB, AND THE ARRAYS EIGS, OCCA,
!  MICROA, AND MICROB ARE USED, BUT UNCHANGED ON EXIT
!
!   ON EXIT, GSE IS THE ELECTRONIC ENERGY OF STABILIZATION DUE TO
!            REMOVAL OF THE ELECTRONS INVOLVED IN THE C.I.
!
!            EIGA HOLDS THE ONE-ELECTRON ENERGY LEVELS RESULTING FROM
!            REMOVAL OF THE ELECTRONS INVOLVED IN THE C.I.
!
!            DIAG HOLDS THE MICROSTATE ENERGIES OF ALL STATES INVOLVED
!            IN THE C.I.  THIS CAN BE USED AS THE DIAGONAL OF A C.I.
!            MATRIX
!
!***********************************************************************
      gse = 0.D0
      do i = 1, nmos
        x = 0.D0
        do j = 1, nmos
          x = x + (2.D0*xy(i,i,j,j)-xy(i,j,i,j))*occa(j)
        end do
        eiga(i) = eigs(i) - x
        gse = gse + eiga(i)*occa(i)*2.D0
        gse = gse + xy(i,i,i,i)*occa(i)*occa(i)
        do j = i + 1, nmos
          gse = gse + 2.D0*(2.D0*xy(i,i,j,j)-xy(i,j,i,j))*occa(i)*occa(j)
        end do
      end do
      do i = 1, lab
        diag(i) = diagi(microa(1,i),microb(1,i),eiga,xy,nmos) - gse
      end do
      return
      end subroutine mecid

mopac port.mop
rm port.arc
rm port.aux
rm port.den
rm port.esp
rm port.esr
rm port.gpt
rm port.html
rm port.pdb
rm port.pol
rm port.res
rm port.txt
rm port.ump
rm port.xyz
rm parameters_for_PM8_C.F90

mopac Crambin_1SCF.mop
rm Crambin_1SCF.arc
rm Crambin_1SCF.log
rm Crambin_1SCF.pdb
rm Crambin_1SCF.den

mopac test_Lewis_for_Proteins.mop
rm test_Lewis_for_Proteins.html
rm test_Lewis_for_Proteins.pdb
rm test_Lewis_for_Proteins.txt

mopac Test_XENO.mop
rm Test_XENO.arc
rm Test_XENO.html
rm Test_XENO.pdb
rm Test_XENO.txt

mopac Test_Hetero_group.mop
rm Test_Hetero_group.arc
rm Test_Hetero_group.log
rm Test_Hetero_group.pdb

mopac convert_an_edited_PDB_file.mop
rm convert_an_edited_PDB_file.arc
rm convert_an_edited_PDB_file.html
rm convert_an_edited_PDB_file.log
rm convert_an_edited_PDB_file.pdb
rm convert_an_edited_PDB_file.txt

mopac convert_an_un-edited_PDB_file.mop
rm convert_an_un-edited_PDB_file.arc
rm convert_an_un-edited_PDB_file.log
rm convert_an_un-edited_PDB_file.pdb

mopac Check_that_TERs_are_preserved.mop
rm Check_that_TERs_are_preserved.arc
rm Check_that_TERs_are_preserved.html
rm Check_that_TERs_are_preserved.pdb
rm Check_that_TERs_are_preserved.txt

mopac Compare_two_protein_structures.mop
rm Compare_two_protein_structures.html
rm Compare_two_protein_structures.txt
rm Compare_two_protein_structures_Structure-1.pdb
rm Compare_two_protein_structures_Structure-2.pdb

mopac PDB1CBN.ent
rm PDB1CBN.log
rm PDB1CBN.pdb
rm PDB1CBN.arc

mopac PDB1EJG.ent
rm PDB1EJG.log
rm PDB1EJG.pdb
rm PDB1EJG.arc

mopac Compare_PDB_1EJG_and_1CBN.mop
rm Compare_PDB_1EJG_and_1CBN.html
rm Compare_PDB_1EJG_and_1CBN.txt
rm Compare_PDB_1EJG_and_1CBN_PDB1CBN.pdb
rm Compare_PDB_1EJG_and_1CBN_PDB1EJG.pdb

mopac Compare_PDB_Bacteriorhodopsin_1AP9_and_2AT9.mop
rm Compare_PDB_Bacteriorhodopsin_1AP9_and_2AT9.html
rm Compare_PDB_Bacteriorhodopsin_1AP9_and_2AT9.txt
rm Compare_PDB_Bacteriorhodopsin_1AP9_and_2AT9_Bacteriorhodopsin_1AP9.pdb
rm Compare_PDB_Bacteriorhodopsin_1AP9_and_2AT9_Bacteriorhodopsin_2AT9.pdb

mopac Compare_PDB_Bacteriorhodopsin_1AP9_and_1C3W.mop
rm Compare_PDB_Bacteriorhodopsin_1AP9_and_1C3W.html
rm Compare_PDB_Bacteriorhodopsin_1AP9_and_1C3W.txt
rm Compare_PDB_Bacteriorhodopsin_1AP9_and_1C3W_Bacteriorhodopsin_1AP9.pdb
rm Compare_PDB_Bacteriorhodopsin_1AP9_and_1C3W_Bacteriorhodopsin_1C3W.pdb

mopac Compare_PDB_Bacteriorhodopsin_1AP9_and_1BRX.mop
rm Compare_PDB_Bacteriorhodopsin_1AP9_and_1BRX.html
rm Compare_PDB_Bacteriorhodopsin_1AP9_and_1BRX.txt
rm Compare_PDB_Bacteriorhodopsin_1AP9_and_1BRX_Bacteriorhodopsin_1AP9.pdb
rm Compare_PDB_Bacteriorhodopsin_1AP9_and_1BRX_Bacteriorhodopsin_1BRX.pdb

mopac Compare_PDB_Bacteriorhodopsin_1AP9_and_1BRR.mop
rm Compare_PDB_Bacteriorhodopsin_1AP9_and_1BRR.html
rm Compare_PDB_Bacteriorhodopsin_1AP9_and_1BRR.txt
rm Compare_PDB_Bacteriorhodopsin_1AP9_and_1BRR_Bacteriorhodopsin_1AP9.pdb
rm Compare_PDB_Bacteriorhodopsin_1AP9_and_1BRR_Bacteriorhodopsin_1BRR.pdb

mopac Compare_PDB_Bacteriorhodopsin_1AP9_and_1AT9.mop
rm Compare_PDB_Bacteriorhodopsin_1AP9_and_1AT9.html
rm Compare_PDB_Bacteriorhodopsin_1AP9_and_1AT9.txt
rm Compare_PDB_Bacteriorhodopsin_1AP9_and_1AT9_ADD-H_Bacteriorhodopsin_1AP9.pdb
rm Compare_PDB_Bacteriorhodopsin_1AP9_and_1AT9_ADD-H_Bacteriorhodopsin_1AT9.pdb

mopac ADD-H_Bacteriorhodopsin_1AP9.mop
rm ADD-H_Bacteriorhodopsin_1AP9.html
rm ADD-H_Bacteriorhodopsin_1AP9.log
rm ADD-H_Bacteriorhodopsin_1AP9.arc
rm ADD-H_Bacteriorhodopsin_1AP9.pdb
rm ADD-H_Bacteriorhodopsin_1AP9.txt

mopac ADD-H_Bacteriorhodopsin_1AT9.mop
rm ADD-H_Bacteriorhodopsin_1AT9.log
rm ADD-H_Bacteriorhodopsin_1AT9.arc

mopac Au_Add-H.mop
rm Au_Add-H.arc
rm Au_Add-H.log

mopac Compare_ADD-H_1EJG_and_1CBN.mop
rm Compare_ADD-H_1EJG_and_1CBN.html
rm Compare_ADD-H_1EJG_and_1CBN.txt
rm Compare_ADD-H_1EJG_and_1CBN_PDB1CBN.pdb
rm Compare_ADD-H_1EJG_and_1CBN_PDB1EJG.pdb

mopac Locate_TS.mop
rm Locate_TS.html
rm Locate_TS.log
rm Locate_TS.pdb
rm Locate_TS.arc
rm Locate_TS.txt
rm "Locate_TS 30p0 first.mop"
rm "Locate_TS 60p0 first.mop"
rm "Locate_TS 120p0 first.mop"
rm "Locate_TS 30p0 second.mop"
rm "Locate_TS 60p0 second.mop"
rm "Locate_TS 120p0 second.mop"
rm "Locate_TS 30p0 average.mop"
rm "Locate_TS 60p0 average.mop"
rm "Locate_TS 120p0 average.mop"
rm "Locate_TS Loop1.mop"
rm "Locate_TS Loop2.mop"
rm "Locate_TS Loop3.mop"
rm "Locate_TS Loop4.mop"
rm "Locate_TS Loop5.mop"

mopac IONIZE.mop
rm IONIZE.arc
rm IONIZE.html
rm IONIZE.pdb
rm IONIZE.txt

mopac SALT.mop
rm SALT.arc

mopac SALT_2.mop
rm SALT_2.arc

mopac SITE_Individual_residues.mop
rm SITE_Individual_residues.arc

mopac erratic1.mop
rm erratic1.arc

mopac erratic2.mop
rm erratic2.arc

mopac ag20.mop
rm ag20.arc

mopac ag20_cis_active.mop

mopac benzene.mop

mopac co_cas.mop

mopac co_cis.mop

mopac co_cis_2.mop

mopac co_cis_PM7.mop
rm co_cis_PM7.arc

mopac co_cis_active.mop

mopac co_cis_solv.mop

mopac co_cis_tdip.mop
rm co_cis_tdip.tdip

mopac co_cis_trip.mop

mopac co_extern.mop

mopac co_fail.mop

mopac co_field.mop

mopac co_mrci.mop

mopac co_mrci_maxci.mop

mopac co_mrci_solv.mop

mopac co_pm7.mop
rm co_pm7.arc

mopac co_pm7_solv.mop
rm co_pm7_solv.arc

mopac co_print.mop

mopac no_cis_quar.mop

mopac no_mrci.mop

mopac noparam.mop

mopac poly_c8.mop

mopac poly_c8_mr.mop

## Test environments
* Mac OS X (github actions), R 4.0.5
* ubuntu 20.04 (github actions), R 4.0.5
* win-builder (github actions), R 4.0.5

## R CMD check results

0 errors | 0 warnings | 0 notes

* This is a new release.

---
name: Bug report
about: Create a report to help us improve
title: ''
labels: ''
assignees: ''

---

**Describe the bug**
A clear and concise description of what the bug is.

**To Reproduce**
A clear and concise description of how to reproduce the bug.

Please provide a MOPAC input file that causes the bug to occur, if possible. This does not have to be the input file that originally produced the bug. It is preferable to isolate a minimal representative example that is as short and simple as possible.

Also, please clarify if the bug is intermittent or requires a particular set of circumstances to reproduce it.

**Expected behavior**
A clear and concise description of what you expected to happen.

**Operating system**
The operating system that this problem occurred on.

**Additional context**
Add other useful context about the problem here, if any.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{rates}
\alias{rates}
\title{Mopac Express Lane Rates}
\format{
A tibble with 25 rows and 3 variables:
\describe{
  \item{direction}{\strong{north}: Far West entry point heading to Parmer, \strong{south}: RM 2222 heading to Cesar Chavez}
  \item{time}{time of day}
  \item{rate}{TxTag rate in USD}
}
}
\source{
{Rates obtained from Central Texas Regional Mobility Authority.} \url{https://www.mobilityauthority.com/pay-your-toll/rates}
}
\usage{
rates
}
\description{
Express Lane Rates for Loop 1 "Mopac" in Austin, Texas. Rates correspond to RM 2222 / Far West entry points with pre-COVID weekday traffic. Recommend loading \href{https://readr.tidyverse.org/}{readr} package so that \code{time} displays correctly as \strong{hms}.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{rush_hour}
\alias{rush_hour}
\title{Sample of vehicles collected from Loop 1 "Mopac" in Austin, Texas.}
\format{
A tibble with 962 rows and 7 variables:
\describe{
  \item{day}{day of the week when observations were recorded}
  \item{time}{observation timestamp}
  \item{commercial}{indicates whether vehicle is used for commercial purposes}
  \item{color}{vehicle color}
  \item{type}{vehicle type}
  \item{make}{vehicle make}
  \item{model}{vehicle model}
}
}
\source{
Real observations collected from northbound Mopac at Far West Blvd.
}
\usage{
rush_hour
}
\description{
Observations sampled in 2.5 minute intervals throughout week of 17 May 2020. Note that although intervals fall within normal "rush hour" timeframe, traffic density is lighter than normal due to COVID.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{exits}
\alias{exits}
\title{Exit information for Mopac.}
\format{
A tibble with 32 rows and 4 variables:
\describe{
  \item{mi}{distance from Loop 1 southern terminus, in miles}
  \item{km}{distance from Loop 1 southern terminus, in kilometers}
  \item{exit}{main road accessed by exit}
  \item{notes}{additional information}
}
}
\source{
Scraped from \url{https://en.wikipedia.org/wiki/Texas_State_Highway_Loop_1}
}
\usage{
exits
}
\description{
Accurate as of 2021-03-26. Provides basic details for all exits along Loop 1 "Mopac" in Austin, Texas. Exits are unnumbered.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{express}
\alias{express}
\title{Mopac Express Lane Records}
\format{
A tibble with 13032 rows and 6 variables:
\describe{
  \item{direction}{\strong{north}: Far West entry point heading to Parmer, \strong{south}: RM 2222 heading to Cesar Chavez}
  \item{time}{time of day}
  \item{plate}{vehicle license plate}
  \item{make}{vehicle make}
  \item{model}{vehicle model}
  \item{color}{vehicle color}
}
}
\source{
To see how this dataset was generated, visit \url{https://sccm.io/post/mopac-dataset/}

For City of Austin Traffic Counts, visit \url{https://data.austintexas.gov/Transportation-and-Mobility/Camera-Traffic-Counts/sh59-i6y9}
}
\usage{
express
}
\description{
Simulated observations of vehicles entering Mopac express lane at RM 2222 / Far West Blvd. Vehicle make/model/color frequencies are based on actual data from rush_hour. Traffic density inferred from ad hoc sampling and City of Austin Traffic Counts.
}
\keyword{datasets}
